#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "cd3e574fdd2e41661ad9235356bfb71684d9b9bc";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "import \"util\" as util",
  "import \"identifierKinds\" as k",
  "",
  "// This module contains classes and pseudo-classes for all the AST nodes used",
  "// in the parser. Because of the limitations of the class syntax, classes that",
  "// need more than one method are written as object literals containing methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is given by type ASTNode ",
  "//",
  "// Most nodes also contain a \"value\" field, with varied type, holding the `main value`",
  "// in the node.  This field is confusing and should be appropriately re-named in",
  "// each case. Some nodes contain other fields for their specific use: while has",
  "// both a value (the condition) and a body, for example.",
  "",
  "def lineLength is public = 80",
  "",
  "method listMap(l, b) ancestors(as) is confidential {",
  "    def newList = list.empty",
  "    l.do { nd -> newList.addLast(nd.map(b) ancestors(as)) }",
  "    newList",
  "}",
  "method maybeMap(n, b) ancestors(as) is confidential {",
  "    if (n != false) then {",
  "        n.map(b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "method maybeListMap(n, b) ancestors(as) is confidential {",
  "    if (n != false) then {",
  "        listMap(n, b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def ancestorChain = object {",
  "    class empty {",
  "        method isEmpty { true }",
  "        method asString { \"ancestorChain ▫\" }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "    method with(n) { empty.extend(n) }",
  "    class cons(p) onto(as) is confidential {",
  "        method forebears { as }",
  "        method isEmpty { false }",
  "        method parent { p }",
  "        method grandparent { forebears.parent }",
  "        ",
  "        method asString {",
  "            var a := self",
  "            var s := \"ancestorChain \"",
  "            while { a.isEmpty.not } do {",
  "                s := s ++ a.parent ++ \"➤\"",
  "                a := a.forebears",
  "            }",
  "            s ++ \"▫\"",
  "        }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "}",
  "",
  "def emptySeq = sequence.empty",
  "",
  "type AstNode = type {",
  "    kind -> String ",
  "        // Used for pseudo-instanceof tests.",
  "    register -> String",
  "        // Used in the code generator on to name the resulting object",
  "    line -> Number",
  "        // The source line the node came from",
  "    line:=(ln:Number)",
  "    linePos -> Number",
  "    linePos:=(lp:Number)",
  "    scope -> SymbolTable",
  "        // The symbolTable for names defined in this node and its sub-nodes",
  "    pretty(n:Number) -> String ",
  "        // Pretty-print-string of node at depth n",
  "    comments -> AstNode",
  "        // Comments associated with this node",
  "}",
  "",
  "type SymbolTable = Unknown",
  "",
  "class baseNode {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var symbolTable := fakeSymbolTable",
  "    var comments is public := false",
  "",
  "    method kind { abstract }",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isLegalInTrait { false }",
  "    method isMember { false }",
  "    method isMethod { false }",
  "    method isExecutable { true }",
  "    method isCall { false }",
  "    method isComment { false }",
  "    method isClass { false }    // is a method that returns a fresh object",
  "    method inClass { false }    // object in a syntactic class definiton",
  "    method isTrait { false }    // is a method that returns a trait object",
  "    method inTrait { false }    // object in a syntactic trait definition",
  "    method isBind { false }",
  "    method isBlock { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method isDialect { false }",
  "    method isImport { false }",
  "    method isTypeDec { false }",
  "    method isExternal { false }",
  "    method canInherit { false }",
  "    method returnsObject { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"{kind} {nameString}\" }",
  "    method nameString { \"?\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (self.dtype == false) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method isSimple { true }  // needs no parens when used as reciever",
  "    method description { kind }",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (ancestorChain.empty)",
  "    }",
  "    method scope { symbolTable }",
  "",
  "    method scope:=(st) {",
  "        // override this method in subobjects that open a new scope. In such",
  "        // subobjects, and only in such subobjects, there should be a 2-way",
  "        // conection between the node and the symbol table that defines its scope.",
  "        symbolTable := st",
  "    }",
  "",
  "    method shallowCopyFieldsFrom(other) {",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        scope := other.scope",
  "        self",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        if ((scope.node == self).andAlso{util.target == \"symbols\"}) then {",
  "            \"{line}:{linePos} {description}\\n{spc}Symbols({scope.variety}): {scope}{scope.elementScopesAsString}\"",
  "        } elseif {scope.variety == \"fake\"} then {",
  "            \"{line}:{linePos} {description}\"",
  "        } else {",
  "            \"{line}:{linePos} {description} {scope.asDebugString}\"",
  "        }",
  "    }",
  "    method deepCopy {",
  "        self.map { each -> each } ancestors(ancestorChain.empty)",
  "    }",
  "    method enclosingObject {",
  "        def obj = scope.enclosingObjectScope.node",
  "        obj",
  "    }",
  "    method addComment(cmtNode) {",
  "        if (comments == false) then {",
  "            comments := cmtNode",
  "        } else {",
  "            comments.extendCommentUsing(cmtNode)",
  "        }",
  "    }",
  "    method addComments(cmtNodeList) {",
  "        cmtNodeList.do { each -> addComment(each) }",
  "    }",
  "    method statementName { kind }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherits baseNode",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "}",
  "",
  "def fakeSymbolTable = object {",
  "    var node is public := nullNode",
  "    method asString { \"fake Symbol Table\" }",
  "    method addNode (n) as (kind) {",
  "        ProgrammingError.raise \"fakeSymbolTable(on node {node}).addNode({n}) as \\\"{kind}\\\" requested\"",
  "    }",
  "    method thatDefines (name) ifNone (action) {",
  "        ProgrammingError.raise \"fakeSymbolTable.thatDefines({name}).\"",
  "    }",
  "    method enclosingObjectScope {",
  "        ProgrammingError.raise \"fakeSymbolTable.enclosingObjectScope on node {node}\"",
  "    }",
  "    method variety { \"fake\" }",
  "}",
  "",
  "def ifNode is public = object {",
  "  class new(cond, thenblock', elseblock') {",
  "    inherits baseNode",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIf(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            value.accept(visitor) from(newChain)",
  "            thenblock.accept(visitor) from(newChain)",
  "            elseblock.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.thenblock := thenblock.map(blk) ancestors(newChain)",
  "        n.elseblock := elseblock.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.isntEmpty) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "  }",
  "}",
  "def blockNode is public = object {",
  "  class new(params', body') {",
  "    inherits baseNode",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(ancestorChain.with(self))",
  "    }",
  "    method isBlock { true }",
  "    method isEmpty { body.size == 0 }",
  "    method isntEmpty { body.size > 0 }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.parameter }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method returnsObject {",
  "        (body.size > 0).andAlso { body.last.returnsObject }",
  "    }",
  "    method returnedObjectScope {",
  "        // precondition: returnsObject",
  "        body.last.returnedObjectScope",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBlock(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (self.matchingPattern != false) then {",
  "                self.matchingPattern.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        n.body := listMap(body, blk) ancestors(newChain)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        if (self.matchingPattern != false) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params[i]",
  "                if (self.matchingPattern != false) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" ->\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "  }",
  "}",
  "def tryCatchNode is public = object {",
  "  class new(block, cases', finally') {",
  "    inherits baseNode",
  "    def kind is public = \"trycatch\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTryCatch(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (self.finally != false) then {",
  "                self.finally.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.finally := maybeMap(finally, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"try \" ++ self.value.toGrace(depth + 1) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"catch \" ++ case.toGrace(depth + 1)",
  "        }",
  "        if (self.finally != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        tryCatchNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def matchCaseNode is public = object {",
  "  class new(matchee', cases', elsecase') {",
  "    inherits baseNode",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    var elsecase is public := elsecase'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method matchee { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (self.elsecase != false) then {",
  "                self.elsecase.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.elsecase := maybeMap(elsecase, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.elsecase != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        matchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def methodTypeNode is public = object {",
  "  class new(name', signature', rtype') {",
  "    // Represents the signature of a method in a type literal",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode",
  "    def kind is public = \"methodtype\"",
  "    var value is public := name'",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var typeParams is public := false",
  "    def nameString:String is public = value",
  "",
  "    method isExecutable { false }",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the symbol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMethodType(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            if (rtype != false) then {",
  "                rtype.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.rtype := maybeMap(rtype, blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (rtype != false) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (false != typeParams) then {",
  "            s := \"{s}\\n{spc}TypeParams:\\n\" ",
  "            s := s ++ typeParams.pretty(depth + 2)",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        var firstPart := true",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if (firstPart) then {",
  "                firstPart := false",
  "                if (false != typeParams) then {",
  "                    typeParams.toGrace(depth + 1)",
  "                }",
  "            }",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.rtype != false) then {",
  "            s := s ++ \" -> \" ++ self.rtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        methodTypeNode.new(value, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def typeLiteralNode is public = object {",
  "  class new(methods', types') {",
  "    inherits baseNode",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "    ",
  "    method name { value }",
  "    method name:=(n) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"typeliteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method isExecutable { false }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeLiteral(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.methods := listMap(methods, blk) ancestors (as)",
  "        n.types := listMap(types, blk) ancestors (as)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"type\"",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "  }",
  "}",
  "",
  "def typeDecNode is public = object {",
  "  class new(name', typeValue) {",
  "    inherits baseNode",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "    var typeParams is public := false",
  "",
  "    method isLegalInTrait { true }",
  "    method isTypeDec { true }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    ",
  "    method isExecutable { true }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            name.accept(visitor) from(newChain)",
  "            if (typeParams != false) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            annotations.do { each -> each.accept(visitor) from(newChain) }",
  "            value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (false != typeParams) then {",
  "            s := \"{s}{spc}Type parameters:\\n{typeParams.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (false != typeParams) then {",
  "            typeParams.toGrace(0)",
  "        }",
  "        s ++ \" = \" ++ value.toGrace(depth + 2)",
  "    }",
  "    method shallowCopy {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def methodNode = object {",
  "    method new(name, signature, body, dtype) scope(s) {",
  "        def result = new(name, signature, body, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "    ",
  "    class new(name', signature', body', dtype') {",
  "        // Represents a method declaration",
  "        // name' is the name of the method (an identifierNode),",
  "        // signature is a sequence of signatureParts,",
  "        // body is a sequence of statements and declarations,",
  "        // dtype is the declared return type of the method, or false.",
  "",
  "        inherits baseNode",
  "        def kind is public = \"method\"",
  "        var value is public := name'",
  "        var signature is public := signature'",
  "        var body is public := body'",
  "        var dtype is public := dtype'",
  "        var varargs is public := false",
  "        var typeParams is public := false",
  "        var selfclosure is public := false",
  "        def nameString:String is public = value.value",
  "        var annotations is public := list.empty",
  "        var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "        var usesClassSyntax is public := false",
  "",
  "        method isMethod { true }",
  "        method isExecutable { false }",
  "        method isLegalInTrait { true }",
  "        method isClass { isFresh || usesClassSyntax }",
  "        method isTrait {",
  "            if (isFresh) then {",
  "                body.last.isTrait",
  "            } else {",
  "                false",
  "            }",
  "        }",
  "        method needsArgChecks {",
  "            signature.do { part -> ",
  "                part.params.do { p ->",
  "                    if ((p.dtype != false).andAlso { ",
  "                            p.dtype.nameString != \"Unknown\" }) then {",
  "                        return true",
  "                    }",
  "                }",
  "            }",
  "            return false",
  "        }",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the synmol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method isConfidential {",
  "            if (annotations.size == 0) then { return false }",
  "            findAnnotation(self, \"confidential\")",
  "        }",
  "        method isPublic { isConfidential.not }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method returnsObject {",
  "            body.isEmpty.not.andAlso {body.last.returnsObject}",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            body.last.returnedObjectScope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMethod(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "                for (self.signature) do { part ->",
  "                    for (part.params) do { p ->",
  "                        p.accept(visitor) from(newChain)",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        part.vararg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (dtype != false) then {",
  "                    dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                for (self.body) do { mx ->",
  "                    mx.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as){",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.body := listMap(body, blk) ancestors(newChain)",
  "            n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            n.signature := listMap(signature, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Name: \" ++ self.value.pretty(depth+1)",
  "            s := s ++ \"\\n\"",
  "            if (false != self.dtype) then {",
  "                s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "                s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "            if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "            s := \"{s}{spc}Signature:\"",
  "            for (signature) do { part ->",
  "                s := \"{s}\\n  {spc}Part: {part.name}\"",
  "                s := \"{s}\\n    {spc}Parameters:\"",
  "                for (part.params) do { p ->",
  "                    s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "                }",
  "            }",
  "            s := s ++ \"\\n\"",
  "            if (false != typeParams) then {",
  "                s := \"{s}{spc}Generics:\"",
  "                typeParams.do {g->",
  "                    s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            if (annotations.size > 0) then {",
  "                s := \"{s}{spc}Annotations:\"",
  "                for (annotations) do {an->",
  "                    s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            s := s ++ spc ++ \"Body:\"",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"method \"",
  "            var firstPart := true",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart.andAlso{false != typeParams}) then {",
  "                    s := s ++ typeParams.toGrace(depth + 1)",
  "                }",
  "                firstPart := false",
  "                if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params[pnr]",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        s := s ++ \"*\" ++ part.vararg.value",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            if (self.dtype != false) then {",
  "                s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            s := s ++ \" \\{\"",
  "            if (comments != false) then {",
  "                s := s ++ comments.toGrace(depth + 1)",
  "            }",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            methodNode.new(value, signature, body, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isFresh := other.isFresh",
  "            selfclosure := other.selfclosure",
  "            self",
  "        }",
  "    }",
  "}",
  "def callNode = object {",
  "    method new(what, with) scope(s) {",
  "        def result = new(what, with)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(what, with') {",
  "        // requested as callNode.new(target:AstNode, parts:List)",
  "        // Represents a method request with arguments.",
  "        // The ‹target›.‹methodName› part is in `value`",
  "        // The argument list is in `with`, as a sequence of `callWithPart`s.",
  "        // [with]",
  "        //     object {",
  "        //         name := \"\"",
  "        //         args := sequence.empty",
  "        //     }",
  "        //     object {",
  "        //         name := \"\"",
  "        //         args := sequence.empty",
  "        //     }",
  "        //     ...",
  "        //     object {",
  "        //         ...",
  "        //     }",
  "        inherits baseNode",
  "        def kind is public = \"call\"",
  "        var value is public := what        // method being requested",
  "        var with is public := with'        // arguments",
  "        var generics is public := false",
  "        var isPattern is public := false",
  "        def nameString:String is public = value.nameString",
  "        ",
  "        method target { value }",
  "        method isCall { true }",
  "        method returnsObject {",
  "            if (value.isMember.not) then { return false }",
  "            if (value.nameString == \"clone\") then { return true }",
  "            if (value.nameString == \"copy\") then { return true }",
  "            return false",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            self.scope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitCall(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                for (self.with) do { part ->",
  "                    for (part.args) do { arg ->",
  "                        arg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != generics) then {",
  "                    generics.do { each ->",
  "                        each.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.with := listMap(with, blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Method Name: {self.value.pretty(depth + 1)}\"",
  "            s := s ++ \"\\n\"",
  "            if (false != generics) then {",
  "                s := s ++ spc ++ \"  Generics:\\n\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "                }",
  "            }",
  "            s := s ++ spc ++ \"Arguments:\"",
  "            for (self.with) do { part ->",
  "                s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "                for (part.args) do { arg ->",
  "                    s := s ++ \"\\n      \" ++ spc ++ arg.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            repeat (depth) times {",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"\"",
  "            // only the last member is the method call we need to handle",
  "            if (self.value.kind == \"member\") then {",
  "                var member := self.value",
  "                if (member.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                    s := member.value.substringFrom(7)to(member.value.size)",
  "                    return s ++ member.in.toGrace(0)",
  "                }",
  "                if (member.in.isSimple) then {",
  "                    s := \"{member.in.toGrace 0}.\"",
  "                } else {",
  "                    s := \"({member.in.toGrace 0}).\"",
  "                }",
  "            }",
  "            var firstPart := true",
  "            for (self.with) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart.andAlso{generics != false}) then {",
  "                    s := s ++ \"<\"",
  "                    for (1..(generics.size - 1)) do {ix ->",
  "                        s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                    }",
  "                    s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "                }",
  "                firstPart := false",
  "                if (part.args.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.args.indices) do { anr ->",
  "                        var arg := part.args[anr]",
  "                        s := s ++ arg.toGrace(depth + 1)",
  "                        if (anr < part.args.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method asString { \"call {what.pretty(0)}\" }",
  "        method shallowCopy {",
  "            callNode.new(value, with).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isPattern := other.isPattern",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "def moduleNode = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result",
  "    }",
  "    class body(b) {",
  "        inherits objectNode.new(b, false)",
  "        def kind is public = \"module\"",
  "        line := 0       // because the module is always implicit",
  "        linePos := 0",
  "        var imports is public := list.empty",
  "",
  "        method isModule { true }",
  "        method returnsObject { false }",
  "        method externalsDo(action) {",
  "            value.do { o -> ",
  "                if (o.isExternal) then { action.apply(o) }",
  "            }",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitModule(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (self.superclass != false) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            moduleNode.body(emptySeq).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            imports := other.imports",
  "            self",
  "        }",
  "    }",
  "}",
  "def objectNode is public = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b, false)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        body(b) named(n) scope(fakeSymbolTable)",
  "    }",
  "    class new(b, superclass') {",
  "        inherits baseNode",
  "        def kind is public = \"object\"",
  "        var value is public := b",
  "        var superclass is public := superclass'",
  "        var usedTraits is public := list.empty",
  "        var name:String is public := \"object\"",
  "        var inClass is public := false",
  "        var inTrait is public := false",
  "        var myLocalNames := false",
  "        var annotations is public := list.empty",
  "        ",
  "        method description -> String { ",
  "            if (isTrait) then { ",
  "                \"{kind} (trait)\" ",
  "            } elseif { inClass } then {",
  "                \"{kind} (class)\"",
  "            } else {",
  "                kind",
  "            }",
  "        }",
  "        method isTrait {",
  "            // answers true if this object qualifies to be a trait, whether",
  "            // or not it was declared with the trait syntax",
  "            if (inTrait) then { return true }",
  "            if (false != superclass) then { return false }",
  "            value.do { each -> ",
  "                if (each.isLegalInTrait.not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "                ",
  "        method localNames -> Set<String> { ",
  "            // answers the names of all of the methods defined directly in",
  "            // this object.  Inherited names are _not_ included.",
  "            if (false == myLocalNames) then {",
  "                myLocalNames := set.empty",
  "                value.do { node ->",
  "                    if (node.isFieldDec || node.isMethod) then {",
  "                        myLocalNames.add(node.nameString)",
  "                    }",
  "                }",
  "            }",
  "            myLocalNames",
  "        }",
  "        ",
  "        method parentsDo(action) {",
  "            // iterate over my superclass and my used traits",
  "",
  "            if (false != superclass) then { action.apply(superclass) }",
  "            usedTraits.do { t -> action.apply(t) }",
  "        }",
  "        ",
  "        method methodsDo(action) {",
  "            // iterate over my method declarations",
  "            ",
  "            value.do { o ->",
  "                if (o.isMethod) then { action.apply(o) }",
  "            }",
  "        }",
  "        ",
  "        method executableComponentsDo(action) {",
  "            // iterate over my executable code, including",
  "            // field declarations (since they may have initializers)",
  "            value.do { o ->",
  "                if (o.isExecutable) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the symbol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method body { value }",
  "        method returnsObject { true }",
  "        method returnedObjectScope { scope }",
  "        method canInherit { inTrait.not }   // an object can inherit if not in a trait",
  "        method canUse { true }",
  "        method isObject { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitObject(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (superclass != false) then {",
  "                    superclass.accept(visitor) from(newChain)",
  "                }",
  "                usedTraits.do { t -> t.accept(visitor) from(newChain) }",
  "                value.do { x -> x.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method nameString { ",
  "            if (name == \"object\") then {",
  "                \"object_on_line_{line}\"",
  "            } else {",
  "                name",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            n.usedTraits := listMap(usedTraits, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth') {",
  "            var depth := depth'",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := \"{s}\\n{spc}Name: {self.name}\"",
  "            if (self.superclass != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Superclass: \" ++ ",
  "                        self.superclass.pretty(depth + 1)",
  "            }",
  "            if (usedTraits.isEmpty.not) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Traits:\"",
  "                usedTraits.do { t -> ",
  "                    s := \"{s}\\n{spc}  {t.pretty(depth + 1)}\"",
  "                }",
  "            }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\"++ spc ++ x.pretty(depth + 1)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"object \\{\"",
  "            if (inTrait) then { s := s ++ \"   // trait\" }",
  "            if (inClass) then { s := s ++ \"   // class\" }",
  "            if (false != superclass) then { ",
  "                s := s ++ \"\\n\" ++ superclass.toGrace(depth + 1)",
  "            }",
  "            usedTraits.do { t -> s := s ++ \"\\n\" ++ t.toGrace(depth + 1) }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            name := other.name",
  "            value := other.value",
  "            superclass := other.superclass",
  "            usedTraits := other.usedTraits",
  "            inClass := other.inClass",
  "            inTrait := other.inTrait",
  "            annotations := other.annotations",
  "            self",
  "        }",
  "        method asString {",
  "            \"object {nameString}\"",
  "        }",
  "    }",
  "}",
  "def arrayNode is public = object {",
  "  class new(values) {",
  "    inherits baseNode",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitArray(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value[i].toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def memberNode = object {",
  "    method new(request, receiver) scope(s) {",
  "        def result = new(request, receiver)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(request, receiver) {",
  "        // Represents a dotted request ‹receiver›.‹request›",
  "        inherits baseNode",
  "        def kind is public = \"member\"",
  "        var value is public := request  // NB: value is a String, not an Identifier",
  "        var in is public := receiver",
  "        var generics is public := false",
  "",
  "        method target { in }",
  "        method nameString { value }",
  "        method isMember { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMember(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (generics != false) then {",
  "                    generics.do { each -> each.accept(visitor) from(newChain) }",
  "                }",
  "                in.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.in := in.map(blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\\n\"",
  "            s := s ++ spc ++ in.pretty(depth)",
  "            if (generics != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := self.value.substringFrom(7)to(value.size)",
  "                s := s ++ \" \" ++ self.in.toGrace(0)",
  "            } else {",
  "                s := self.in.toGrace(depth) ++ \".\" ++ self.value",
  "            }",
  "            if (generics != false) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "        method asString { \"{in}.{value}\" }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (scope == fakeSymbolTable) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (value, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method shallowCopy {",
  "            memberNode.new(value, nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "def genericNode is public = object {",
  "  class new(base, arguments) {",
  "    // represents an application of a parameterized type to some arguments.",
  "    inherits baseNode",
  "    def kind is public = \"generic\"",
  "    var value is public := base        ",
  "        // in a generic application, `value` is the applied type",
  "        // e.g. in List<Number>, value is Identifier‹List›",
  "    var args is public := arguments",
  "    method nameString { value.nameString }",
  "    method asString { toGrace 0 }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitGeneric(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.args) do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.args := listMap(args, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{super.pretty(depth)}({value.pretty(depth)})<\"",
  "        args.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := nameString ++ \"<\"",
  "        args.do { each -> s := s ++ each.toGrace(0) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        genericNode.new(value, args).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def typeParametersNode is public = object {",
  "  class new(params') {",
  "    inherits baseNode",
  "    def kind is public = \"typeparams\"",
  "    var params is public := params'",
  "    method asString { toGrace 0 }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeParameters(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            params.do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method do(blk) {",
  "        params.do(blk)",
  "    }",
  "    method size { params.size }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := spc ++ super.pretty(depth) ++ \"<\"",
  "        params.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth:Number) -> String {",
  "        var s := \"<\"",
  "        params.do { each -> s := \"{s}{each.toGrace(depth)}\" }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        typeParametersNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def identifierNode = object {",
  "",
  "    method new(name, dtype) scope(s) {",
  "        def result = new(name, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"identifier\"",
  "        var value is public := name",
  "        var wildcard is public := false",
  "        var dtype is public := dtype'",
  "        var isBindingOccurrence is public := false",
  "        var isAssigned is public := false",
  "        var inRequest is public := false",
  "        var generics is public := false",
  "        var isDeclaredByParent is public := false",
  "",
  "        method nameString { value }     //  value changes when parsing \"[]\"",
  "        method quoted { value.quoted }",
  "        method isIdentifier { true }",
  "",
  "        method isAppliedOccurenceOfIdentifier {",
  "            if (wildcard) then { ",
  "                false ",
  "            } else {",
  "                isBindingOccurrence.not",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            as.parent.declarationKindWithAncestors(as)",
  "        }",
  "        method inTypePositionWithAncestors(as) {",
  "            // am I used by my parent node as a type?",
  "            // This is a hack, used as a subsitute for having information in the .gct",
  "            // telling us which identifiers represent types",
  "            if (as.isEmpty) then { return false }",
  "            as.parent.usesAsType(self)",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitIdentifier(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (self.dtype != false) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if ( wildcard ) then {",
  "                s := s ++ \" Wildcard\"",
  "            } elseif { isBindingOccurrence } then {",
  "                s := s ++ \"Binding‹{value}›\"",
  "            } else {",
  "                s := s ++ \"‹{value}›\"",
  "            }",
  "            if (self.dtype != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "                s := s ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s",
  "            if(self.wildcard) then {",
  "                s := \"_\"",
  "            } else {",
  "                s := self.value",
  "            }",
  "            if (self.dtype != false) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "",
  "        method asString { ",
  "            if (isBindingOccurrence) then {",
  "                \"identifierBinding‹{value}›\"",
  "            } else { ",
  "                \"identifier‹{value}›\"",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            identifierNode.new(value, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            wildcard := other.wildcard",
  "            isBindingOccurrence := other.isBindingOccurrence",
  "            isDeclaredByParent := other.isDeclaredByParent",
  "            isAssigned := other.isAssigned",
  "            inRequest := other.inRequest",
  "            self",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "def stringNode = object {",
  "    method new(v) scope(s) {",
  "        def result = new(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(v) {",
  "        inherits baseNode",
  "        def kind is public = \"string\"",
  "        var value is public := v",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitString(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def q = \"\\\"\"",
  "            q ++ value.quoted ++ q",
  "        }",
  "        method shallowCopy {",
  "            stringNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "def numNode is public = object {",
  "    class new(val) {",
  "        inherits baseNode",
  "        def kind is public = \"num\"",
  "        var value is public := val",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitNum(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            self.value.asString",
  "        }",
  "        method asString { \"num {value}\" }",
  "        method shallowCopy {",
  "            numNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "def opNode is public = object {",
  "  class new(op, l, r) {",
  "    inherits baseNode",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    method isSimple { false }    // needs parens when used as reciever",
  "    method nameString { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitOp(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.left.accept(visitor) from(newChain)",
  "            self.right.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.left := left.map(blk) ancestors(newChain)",
  "        n.right := right.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && (self.left.value != self.value)) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && (self.right.value != self.value)) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new (value, false) scope (scope)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        return resultNode",
  "    }",
  "    method shallowCopy {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def indexNode is public = object {",
  "  class new(expr, index') {",
  "    // an expression in square brackets",
  "    inherits baseNode",
  "    def kind is public = \"index\"",
  "    var value is public := expr",
  "    var index is public := index'",
  "    ",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIndex(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            self.index.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.index := index.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.index.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.value.toGrace(depth + 1)",
  "        s := s ++ \"[\" ++ self.index.toGrace(depth + 1) ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        indexNode.new(nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def bindNode is public = object {",
  "  class new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherits baseNode",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "    ",
  "    method isBind { true }",
  "    method asString { \"bind {value}\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBind(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.dest.accept(visitor) from(newChain)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.dest := dest.map(blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"assignment or assigment request\" }",
  "  }",
  "}",
  "def defDecNode = object {",
  "    method new(name', val, dtype') scope(s) {",
  "        def result = new(name', val, dtype')",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name', val, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"defdec\"",
  "        var name is public := name'",
  "        var value is public := val",
  "        var dtype is public := dtype'",
  "        def nameString:String is public = name.value",
  "        var annotations is public := list.empty",
  "        var startToken is public := false",
  "",
  "        method isPublic {",
  "            // defs are confidential by default",
  "            if (annotations.size == 0) then { return false }",
  "            if (findAnnotation(self, \"public\")) then { return true }",
  "            findAnnotation(self, \"readable\")",
  "        }",
  "        method isFieldDec { true }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "",
  "        method returnsObject {",
  "            value.returnsObject",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            value.returnedObjectScope",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method declarationKindWithAncestors(as) { k.defdec }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitDefDec(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.name.accept(visitor) from(newChain)",
  "                if (self.dtype != false) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.name := name.map(blk) ancestors(newChain)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.name.pretty(depth)",
  "            if (dtype != false) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != value) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "            }",
  "            if (annotations.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Annotations:\"",
  "                annotations.do { ann ->",
  "                    s := \"{s} {ann.pretty(depth + 2)}\"",
  "                }",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"def {self.name.toGrace(0)}\"",
  "            if ( (self.dtype != false).andAlso{",
  "                    self.dtype.value != \"Unknown\" }) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            if (self.value != false) then {",
  "                s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            startToken := other.startToken",
  "            self",
  "        }",
  "        method statementName { \"definition\" }",
  "    }",
  "}",
  "def varDecNode is public = object {",
  "  class new(name', val', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "    method isFieldDec { true }",
  "",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "",
  "    method declarationKindWithAncestors(as) { k.vardec }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitVarDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.value := maybeMap(value, blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if ( (self.dtype != false).andAlso{",
  "                self.dtype.value != \"Unknown\" }) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.fold{ a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                    startingWith \"\"",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"variable declaration\" }",
  "",
  "  }",
  "}",
  "def importNode is public = object {",
  "  class new(path', name', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := list.empty",
  "    var dtype is public := dtype'",
  "    method isImport { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (path) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKindWithAncestors(as) { k.defdec }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitImport(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            self.value.accept(visitor) from(newChain)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopy {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def dialectNode is public = object {",
  "  class new(path') {",
  "    inherits baseNode",
  "    def kind is public = \"dialect\"",
  "    var value is public := path'",
  "    ",
  "    method isDialect { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (value) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method path {",
  "        value",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitDialect(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopy {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def returnNode is public = object {",
  "  class new(expr) {",
  "    inherits baseNode",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitReturn(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopy {",
  "        returnNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def inheritsNode = object {",
  "    method new(expr) scope(s) {",
  "        def result = new(expr)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(expr) {",
  "        inherits baseNode",
  "        def kind is public = \"inherits\"",
  "        var value is public := expr",
  "        var providedNames is public := set.empty",
  "        var aliases is public := list.empty",
  "        var exclusions is public := list.empty",
  "        var isUse is public := false  // this is a `use trait` clause, not an inherits",
  "        ",
  "        method isLegalInTrait { isUse }",
  "        method isInherits { true }",
  "        method inheritsFromMember { value.isMember }",
  "        method inheritsFromCall { value.isCall }",
  "        method isExecutable { false }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitInherits(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                value.accept(visitor) from(newChain)",
  "                aliases.do { a ->",
  "                    a.newName.accept(visitor) from(newChain)",
  "                    a.oldName.accept(visitor) from(newChain)",
  "                }",
  "                exclusions.do { e -> e.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { ",
  "            // identifiers declared in an inherits statement are aliases for ",
  "            // methods.  We treat them as methods, because (unlike inherited names)",
  "            // they can't be overridden by local methods.",
  "            k.methdec",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if (isUse) then { s := \"{s} (use)\" }",
  "            s := s ++ \"\\n\" ++ spc ++ self.value.pretty(depth + 1)",
  "            aliases.do { a ->",
  "                s := \"{s}\\n{a.pretty(depth)}\"",
  "            }",
  "            if (exclusions.isEmpty.not) then { s := \"{s}\\n{spc}\" }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e} \"",
  "            }",
  "            if (providedNames.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Provided names: {providedNames.asList.sort}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := if (isUse) then { \"use \" } else { \"inherit \" }",
  "            s := s ++ self.value.toGrace(0)",
  "            aliases.do { a ->",
  "                s := \"{s} {a} \"",
  "            }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e.nameString} \"",
  "            }",
  "            s",
  "        }",
  "        method nameString { value.toGrace(0) }",
  "        method addAlias (newName) for (oldName) {",
  "            aliases.push(aliasNew(newName) old(oldName))",
  "        }",
  "        method addExclusion(methName) {",
  "            exclusions.push(methName)",
  "        }",
  "        method shallowCopy {",
  "            inheritsNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            providedNames := other.providedNames",
  "            aliases := other.aliases",
  "            exclusions := other.exclusions",
  "            isUse := other.isUse",
  "            self",
  "        }",
  "        method statementName { ",
  "            if (isUse) then { \"use\" } else { \"inherit\" }",
  "        }",
  "    }",
  "}",
  "type AliasPair = {",
  "    newName",
  "    oldName",
  "}",
  "",
  "class aliasNew(n) old(o) {",
  "    method newName {n}",
  "    method oldName {o}",
  "    method asString { \"alias {n.nameString} = {o.nameString}\" }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        \"{spc}  alias {n.pretty(depth)} = {o.pretty(depth)}\"",
  "    }",
  "    method hash { (n.hash * 1171) + o.hash }",
  "    method isExecutable { false }",
  "    method == (other) {",
  "        match (other)",
  "            case { that:AliasPair -> (n == that.newName) && (o == that.oldName) }",
  "            case { _ -> false }",
  "    }",
  "}",
  "def blankNode is public = object {",
  "    class new {",
  "        inherits baseNode",
  "        def kind is public = \"blank\"",
  "        def value is public = \"blank\"",
  "        method isExecutable { false }",
  "",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitBlank(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method nameString { \"\" }",
  "        method asString { \"blank\" }",
  "        method toGrace(depth : Number) -> String { \"\" }",
  "        method shallowCopy {",
  "            blankNode.new.shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "def signaturePart = object {",
  "    method new {",
  "        partName \"\" params( [] ) variableParam(false)",
  "    }",
  "    method partName(n) scope(s) {",
  "        def result = partName(n) params([]) variableParam(false)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) params(ps) scope(s) {",
  "        def result = partName(n) params(ps) variableParam(false)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) params(ps) variableParam(v) scope(s) {",
  "        def result = partName(n) params(ps) variableParam(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) {",
  "        partName(n) params([]) variableParam(false)",
  "    }",
  "    method partName(n) params(ps) {",
  "        partName(n) params(ps) variableParam(false)",
  "    }",
  "    class partName(n) params(ps) variableParam(v) {",
  "        inherits baseNode",
  "        def kind is public = \"signaturepart\"",
  "        var name is public := n",
  "        var params is public := ps",
  "        var vararg is public := v",
  "        var typeParams is public := false",
  "        var lineLength is public := 0",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitSignaturePart(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                params.do { p -> p.accept(visitor) from(newChain) }",
  "                if (false != vararg) then { ",
  "                    vararg.accept(visitor) from(newChain) ",
  "                }",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method map(blk) ancestors(as) {",
  "            var nd := shallowCopy",
  "            def newChain = as.extend(nd)",
  "            nd.params := listMap(params, blk) ancestors(newChain)",
  "            nd.vararg := maybeMap(vararg, blk) ancestors(newChain)",
  "            nd.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            blk.apply(nd, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            if (params.isEmpty.not) then { s := \"{s}\\n{spc}Parameters:\" }",
  "            for (params) do { p ->",
  "                s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "            }",
  "            if (vararg != false) then {",
  "                s := \"{s}\\n  {spc}Vararg: {vararg.pretty(depth + 1)}\"",
  "            }",
  "            if (false != typeParams) then {",
  "                s := \"{s}\\n  {spc}TypeParams: {typeParams.pretty(depth + 1)}\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            signaturePart.partName(name) params(params) variableParam(vararg)",
  "                .shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method asString {",
  "            \"part: {name}\"",
  "        }",
  "    }",
  "}",
  "",
  "def callWithPart = object {",
  "    method new {",
  "        request \"\" withArgs( [] )",
  "    }",
  "    method request(name) withArgs(argList) scope (s) {",
  "        def result = request(name) withArgs(argList)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class request(rPart:String) withArgs(xs) {",
  "        inherits baseNode",
  "        def kind is public = \"callwithpart\"",
  "        var name is public := rPart",
  "        var args is public := xs",
  "        var lineLength is public := 0",
  "",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.args := listMap(args, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            repeat (depth+1) times {",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            s := \"{s}\\n    {spc}Args:\"",
  "            for (args) do { a ->",
  "                s := \"{s}\\n    {spc}{a.pretty(depth + 4)}\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            callWithPart.request(name) withArgs(args).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "",
  "def commentNode = object {",
  "    class new(val') {",
  "        inherits baseNode",
  "        def kind is public = \"comment\"",
  "        var value:String is public := val'",
  "        var isPartialLine:Boolean is public := false",
  "        var isPreceededByBlankLine is public := false",
  "        var endLine is public := util.linenum",
  "        method isComment { true }",
  "        method isLegalInTrait { true }",
  "        method isExecutable { false }",
  "        method asString { \"comment ({line}–{endLine}): {value}\" }",
  "        method extendCommentUsing(cmtNode) {",
  "            value := value ++ \" \" ++ cmtNode.value",
  "            endLine := cmtNode.endLine",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitComment(self) up(as)",
  "        }",
  "        method pretty(depth) {",
  "            var s := \"\\n\"",
  "            repeat (depth-1) times {",
  "                s := s ++ \"  \"",
  "            }",
  "            def pb = if (isPreceededByBlankLine) then { \" > blank\" } else { \"\" }",
  "            \"{s}Comment{pb}({line}–{endLine}): ‹{value}›\"",
  "        }",
  "        method toGrace(depth) {",
  "            // Partial line comments don't start with a newline, whereas",
  "            // full-line comments do.  No newline at end in either case.",
  "            if (isPartialLine) then {",
  "                \"// (partial) {value}\"",
  "            } else {",
  "                var spc := \"\"",
  "                repeat (depth) times { spc := spc ++ \"    \" }",
  "                wrap(value) to (lineLength) prefix (spc ++ \"// \")",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            commentNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            value := other.value",
  "            isPartialLine := other.isPartialLine",
  "            endLine := other.endLine",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "method wrap(str:String) to (l:Number) prefix (margin:String) {",
  "    def ind = margin.size",
  "    def len = max(ind + 4, l)",
  "    if ((ind + str.size) <= len) then {",
  "        return \"\\n\" ++ margin ++ str",
  "    }",
  "    var currBreak ",
  "    var trimmedLine",
  "",
  "    try {",
  "        currBreak := str.lastIndexOf \" \" startingAt (len - ind)",
  "            ifAbsent {len - ind}",
  "        trimmedLine := str.substringFrom (1) to (currBreak).trim",
  "    } catch { ex:NoSuchMethod ->  // C string libraries lack methods",
  "        currBreak := min(len - ind, str.size)",
  "        (1..currBreak).do { ix ->",
  "            if (str.at(ix) == \" \") then { currBreak := ix }",
  "        }",
  "        var end := currBreak",
  "        while {(end >= 1).andAlso{str.at(end) == \" \"}} do {",
  "            end := end - 1",
  "        }",
  "        var start := 1",
  "        while {(start <= str.size).andAlso{str.at(start) == \" \"}} do {",
  "            start := start + 1",
  "        }",
  "        trimmedLine := str.substringFrom (start) to (end)",
  "    }",
  "    \"\\n\" ++ margin ++ trimmedLine ++",
  "        wrap(str.substringFrom (currBreak+1) to (str.size))",
  "            to (l) prefix (margin)",
  "}",
  "",
  "",
  "type ASTVisitor = {",
  "     visitIf(o) up(as) -> Boolean",
  "     visitBlock(o) up(as) -> Boolean",
  "     visitMatchCase(o) up(as) -> Boolean",
  "     visitTryCatch(o) up(as) -> Boolean",
  "     visitMethodType(o) up(as) -> Boolean",
  "     visitSignaturePart(o) up(as) -> Boolean",
  "     visitTypeLiteral(o) up(as) -> Boolean",
  "     visitTypeParameters(o) up(as) -> Boolean",
  "     visitTypeDec(o) up(as) -> Boolean",
  "     visitMethod(o) up(as) -> Boolean",
  "     visitCall(o) up(as) -> Boolean",
  "     visitObject(o) up(as) -> Boolean",
  "     visitModule(o) up(as) -> Boolean",
  "     visitArray(o) up(as) -> Boolean",
  "     visitMember(o) up(as) -> Boolean",
  "     visitGeneric(o) up(as) -> Boolean",
  "     visitIdentifier(o) up(as) -> Boolean",
  "     visitString(o) up(as) -> Boolean",
  "     visitNum(o) up(as) -> Boolean",
  "     visitOp(o) up(as) -> Boolean",
  "     visitIndex(o) up(as) -> Boolean ",
  "     visitBind(o) up(as) -> Boolean",
  "     visitDefDec(o) up(as) -> Boolean",
  "     visitVarDec(o) up(as) -> Boolean",
  "     visitImport(o) up(as) -> Boolean",
  "     visitReturn(o) up(as) -> Boolean",
  "     visitInherits(o) up(as) -> Boolean",
  "     visitDialect(o) up(as) -> Boolean",
  "     visitBlank(o) up(as) -> Boolean",
  "     visitComment(o) up(as) -> Boolean",
  "}",
  "",
  "class baseVisitor -> ASTVisitor {",
  "    method visitIf(o) up(as) { visitIf(o) }",
  "    method visitBlock(o) up(as) { visitBlock(o) }",
  "    method visitMatchCase(o) up(as) { visitMatchCase(o) }",
  "    method visitTryCatch(o) up(as) { visitTryCatch(o) }",
  "    method visitMethodType(o) up(as) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(as) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(as) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(as) { visitTypeLiteral(o) }",
  "    method visitTypeParameters(o) up(as) { visitTypeParameters(o) }",
  "    method visitMethod(o) up(as) { visitMethod(o) }",
  "    method visitCall(o) up(as) { visitCall(o) }",
  "    method visitObject(o) up(as) { visitObject(o) }",
  "    method visitModule(o) up(as) { visitObject(o) }",
  "    method visitArray(o) up(as) { visitArray(o) }",
  "    method visitMember(o) up(as) { visitMember(o) }",
  "    method visitGeneric(o) up(as) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(as) { visitIdentifier(o) }",
  "    method visitString(o) up(as) { visitString(o) }",
  "    method visitNum(o) up(as) { visitNum(o) }",
  "    method visitOp(o) up(as) { visitOp(o) }",
  "    method visitIndex(o) up(as) { visitIndex(o) }",
  "    method visitBind(o) up(as) { visitBind(o) }",
  "    method visitDefDec(o) up(as) { visitDefDec(o) }",
  "    method visitVarDec(o) up(as) { visitVarDec(o) }",
  "    method visitImport(o) up(as) { visitImport(o) }",
  "    method visitReturn(o) up(as) { visitReturn(o) }",
  "    method visitInherits(o) up(as) { visitInherits(o) }",
  "    method visitDialect(o) up(as) { visitDialect(o) }",
  "    method visitBlank(o) up(as) { visitBlank(o) }",
  "    method visitComment(o) up(as) { visitComment(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitTryCatch(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitTypeParameters(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitModule(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitIndex(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "    method visitBlank(o) -> Boolean { true }",
  "    method visitComment(o) -> Boolean { true }",
  "    ",
  "    method asString { \"an AST visitor\" }",
  "}",
  "",
  "class pluggableVisitor(visitation:Block2) -> ASTVisitor {",
  "    // Manufactures a default visitor, given a 2-parameter block.",
  "    // Typically, some of the methods will be overridden.",
  "    // The block will be applied with the AST node as the first argument",
  "    // and the ancestor chain as the second, and should answer true if",
  "    // the visitation is to continue and false if it is to go no deeper.",
  "",
  "    method visitIf(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlock(o) up(as) { visitation.apply (o, as) }",
  "    method visitMatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitTryCatch(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethodType(o) up(as) { visitation.apply (o, as) }",
  "    method visitSignaturePart(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeLiteral(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethod(o) up(as) { visitation.apply (o, as) }",
  "    method visitCall(o) up(as) { visitation.apply (o, as) }",
  "    method visitObject(o) up(as) { visitation.apply (o, as) }",
  "    method visitModule(o) up(as) { visitation.apply (o, as) }",
  "    method visitArray(o) up(as) { visitation.apply (o, as) }",
  "    method visitMember(o) up(as) { visitation.apply (o, as) }",
  "    method visitGeneric(o) up(as) { visitation.apply (o, as) }",
  "    method visitIdentifier(o) up(as) { visitation.apply (o, as) }",
  "    method visitString(o) up(as) { visitation.apply (o, as) }",
  "    method visitNum(o) up(as) { visitation.apply (o, as) }",
  "    method visitOp(o) up(as) { visitation.apply (o, as) }",
  "    method visitIndex(o) up(as) { visitation.apply (o, as) }",
  "    method visitBind(o) up(as) { visitation.apply (o, as) }",
  "    method visitDefDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitVarDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitImport(o) up(as) { visitation.apply (o, as) }",
  "    method visitReturn(o) up(as) { visitation.apply (o, as) }",
  "    method visitInherits(o) up(as) { visitation.apply (o, as) }",
  "    method visitDialect(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlank(o) up(as) { visitation.apply (o, as) }",
  "    method visitComment(o) up(as) { visitation.apply (o, as) }",
  "    ",
  "    method asString { \"a pluggable AST visitor\" }",
  "}",
  "",
  "",
  "def patternMarkVisitor = object {",
  "    inherits baseVisitor",
  "    method visitCall(c) up(as) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\").andAlso {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_36(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_36(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_symbolTable_37(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_symbolTable_37(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_comments_38(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_comments_38(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_406(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_687(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_843(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_958(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_959(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_967(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_970(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1047(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_node_1059(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_node_1059(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_1123(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1126(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_1129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_1129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_1130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_1130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_1131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_1131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_1482(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1485(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1486(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_1488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_1488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_1489(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_1489(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_1490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_1491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_1491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_1492(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_1492(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_1941(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1944(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1945(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1946(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1946(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_1947(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_1947(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_1948(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_1948(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2256(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2258(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2258(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elsecase_2260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elsecase_2260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2561(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2566(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2566(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_2567(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_2567(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_rtype_2568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_rtype_2568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_typeParams_2569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_typeParams_2569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_2570(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_3020(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_3025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_3025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_3026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_3026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_3027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_3027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_3028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_3028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_3029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_3029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_3338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_3338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_3339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_3339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nameString_3340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_annotations_3341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_annotations_3341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_typeParams_3342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_typeParams_3342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3666(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_3676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_3677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_3677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_3678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_3678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_3679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_3679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_varargs_3680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_varargs_3680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_typeParams_3681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_typeParams_3681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_selfclosure_3682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_selfclosure_3682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_nameString_3683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_annotations_3684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_annotations_3684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_isFresh_3685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_isFresh_3685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_usesClassSyntax_3686(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[12];
}
Object writer_ast_usesClassSyntax_3686(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[12] = args[0];
  return done;
}
Object reader_ast_outer_4695(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4703(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4705(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_4705(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_with_4706(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_with_4706(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_4707(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_4707(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isPattern_4708(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isPattern_4708(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_4709(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_5240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5255(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5256(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_imports_5257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_imports_5257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_5330(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5346(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5346(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_5347(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_5347(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_usedTraits_5348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_usedTraits_5348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_name_5349(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_name_5349(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inClass_5350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inClass_5350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inTrait_5351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inTrait_5351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_myLocalNames_5352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_myLocalNames_5352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_5353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_5353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_5951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5954(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5955(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5956(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5956(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6085(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6093(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6094(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6095(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6095(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_in_6096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_in_6096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_6097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_6097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_6436(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6441(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6441(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_6442(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_6442(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_6597(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6600(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6601(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_params_6602(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_params_6602(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6760(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6768(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6769(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6770(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6770(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_6771(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_6771(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_6772(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6772(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_6773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_6773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_6774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_6774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_6775(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_6775(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_6776(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_6776(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_6777(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_6777(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_7161(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7171(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7171(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7304(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_7310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_7310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_7311(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_7311(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_7578(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7581(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7582(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_index_7584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_index_7584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7738(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7741(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7742(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_7743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_7743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7744(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7744(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7913(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7921(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7922(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7923(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7923(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7924(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7924(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7925(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7925(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_7926(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_7927(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_7927(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_startToken_7928(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_startToken_7928(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_8381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8388(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8388(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8389(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8390(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8390(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_8841(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8844(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8845(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8846(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8846(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_8847(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_8847(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_8848(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_8848(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_8849(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_8849(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_9124(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9243(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9244(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9245(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9245(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9330(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_9341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_9341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_aliases_9342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_aliases_9342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_exclusions_9343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_exclusions_9343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isUse_9344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isUse_9344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_9705(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9708(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9709(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9710(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_9745(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9781(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9782(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_9784(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_9784(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_vararg_9785(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_vararg_9785(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_typeParams_9786(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_typeParams_9786(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_lineLength_9787(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_lineLength_9787(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_10076(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10089(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10090(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10091(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10091(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_10092(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_10092(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_lineLength_10093(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_lineLength_10093(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_10227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_10232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_10232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_isPartialLine_10233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_isPartialLine_10233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPreceededByBlankLine_10234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPreceededByBlankLine_10234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_endLine_10235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_endLine_10235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10436(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass32;
static Object strlit106;
static Object strlit113;
static Object strlit119;
static Object strlit125;
static Object strlit181;
static Object strlit190;
static Object strlit201;
static Object strlit216;
static Object strlit225;
static Object strlit232;
static Object strlit241;
static Object strlit246;
static Object strlit253;
static Object strlit260;
static Object strlit266;
static Object strlit283;
static Object strlit291;
static Object strlit298;
static Object strlit305;
static Object strlit311;
static Object strlit319;
static Object strlit328;
static Object strlit335;
static Object strlit342;
static Object strlit348;
static Object strlit397;
static ClassData objclass405;
static Object strlit411;
static Object strlit418;
static Object strlit424;
static Object strlit430;
static Object strlit439;
static Object strlit446;
static Object strlit453;
static Object strlit460;
static Object strlit464;
static Object strlit505;
static Object strlit539;
static Object strlit546;
static Object strlit580;
static Object strlit599;
static Object strlit628;
static Object strlit656;
static Object strlit681;
static ClassData objclass686;
static Object strlit839;
static ClassData objclass842;
static Object strlit932;
static Object strlit951;
static ClassData objclass957;
Object module_util;
Object module_util_init();
Object module_identifierKinds;
Object module_identifierKinds_init();
static ClassData objclass966;
static ClassData objclass969;
static Object strlit974;
static ClassData objclass987;
static Object strlit999;
static Object strlit1011;
static Object strlit1026;
static ClassData objclass1046;
static Object strlit1050;
static Object strlit1055;
static ClassData objclass1057;
static Object strlit1061;
static Object strlit1065;
static Object strlit1070;
static Object strlit1075;
static Object strlit1081;
static Object strlit1094;
static Object strlit1098;
static Object strlit1107;
static Object strlit1113;
static Object strlit1120;
static ClassData objclass1122;
static ClassData objclass1125;
static Object strlit1178;
static Object strlit1187;
static Object strlit1194;
static Object strlit1215;
static Object strlit1221;
static Object strlit1228;
static Object strlit1240;
static Object strlit1251;
static Object strlit1263;
static Object strlit1273;
static Object strlit1298;
static Object strlit1307;
static Object strlit1312;
static Object strlit1337;
static Object strlit1346;
static Object strlit1351;
static Object strlit1358;
static Object strlit1367;
static Object strlit1386;
static Object strlit1391;
static Object strlit1406;
static Object strlit1411;
static Object strlit1433;
static Object strlit1438;
static Object strlit1448;
static Object strlit1453;
static Object strlit1477;
static ClassData objclass1481;
static ClassData objclass1484;
static Object strlit1635;
static Object strlit1644;
static Object strlit1651;
static Object strlit1657;
static Object strlit1680;
static Object strlit1689;
static Object strlit1694;
static Object strlit1717;
static Object strlit1733;
static Object strlit1738;
static Object strlit1758;
static Object strlit1765;
static Object strlit1778;
static Object strlit1784;
static Object strlit1795;
static Object strlit1817;
static Object strlit1825;
static Object strlit1847;
static Object strlit1852;
static Object strlit1872;
static Object strlit1877;
static Object strlit1887;
static Object strlit1892;
static Object strlit1924;
static Object strlit1925;
static ClassData objclass1940;
static ClassData objclass1943;
static Object strlit2015;
static Object strlit2024;
static Object strlit2031;
static Object strlit2037;
static Object strlit2062;
static Object strlit2073;
static Object strlit2078;
static Object strlit2082;
static Object strlit2103;
static Object strlit2116;
static Object strlit2121;
static Object strlit2125;
static Object strlit2136;
static Object strlit2149;
static Object strlit2156;
static Object strlit2168;
static Object strlit2185;
static Object strlit2188;
static Object strlit2193;
static Object strlit2221;
static Object strlit2224;
static Object strlit2229;
static Object strlit2249;
static ClassData objclass2252;
static ClassData objclass2255;
static Object strlit2330;
static Object strlit2339;
static Object strlit2346;
static Object strlit2373;
static Object strlit2384;
static Object strlit2389;
static Object strlit2393;
static Object strlit2414;
static Object strlit2427;
static Object strlit2432;
static Object strlit2436;
static Object strlit2447;
static Object strlit2460;
static Object strlit2467;
static Object strlit2476;
static Object strlit2493;
static Object strlit2496;
static Object strlit2501;
static Object strlit2529;
static Object strlit2532;
static Object strlit2537;
static Object strlit2557;
static ClassData objclass2560;
static ClassData objclass2563;
static Object strlit2673;
static Object strlit2682;
static Object strlit2689;
static Object strlit2695;
static Object strlit2702;
static Object strlit2707;
static Object strlit2711;
static Object strlit2727;
static Object strlit2740;
static Object strlit2745;
static Object strlit2750;
static Object strlit2754;
static Object strlit2772;
static Object strlit2777;
static Object strlit2781;
static Object strlit2800;
static Object strlit2805;
static Object strlit2809;
static Object strlit2821;
static Object strlit2832;
static Object strlit2837;
static Object strlit2841;
static Object strlit2852;
static Object strlit2902;
static Object strlit2944;
static Object strlit2964;
static Object strlit2970;
static Object strlit2994;
static Object strlit3013;
static ClassData objclass3019;
static ClassData objclass3022;
static Object strlit3041;
static Object strlit3048;
static Object strlit3054;
static Object strlit3116;
static Object strlit3125;
static Object strlit3132;
static Object strlit3138;
static Object strlit3142;
static Object strlit3165;
static Object strlit3174;
static Object strlit3179;
static Object strlit3201;
static Object strlit3210;
static Object strlit3215;
static Object strlit3228;
static Object strlit3234;
static Object strlit3236;
static Object strlit3254;
static Object strlit3259;
static Object strlit3282;
static Object strlit3287;
static Object strlit3297;
static Object strlit3326;
static Object strlit3329;
static ClassData objclass3332;
static ClassData objclass3335;
static Object strlit3369;
static Object strlit3459;
static Object strlit3468;
static Object strlit3475;
static Object strlit3481;
static Object strlit3507;
static Object strlit3520;
static Object strlit3525;
static Object strlit3529;
static Object strlit3538;
static Object strlit3558;
static Object strlit3582;
static Object strlit3595;
static Object strlit3601;
static Object strlit3603;
static Object strlit3609;
static Object strlit3636;
static Object strlit3653;
static ClassData objclass3665;
static ClassData objclass3673;
static Object strlit3724;
static Object strlit3769;
static Object strlit3951;
static Object strlit3960;
static Object strlit3967;
static Object strlit3983;
static Object strlit3992;
static Object strlit4004;
static Object strlit4009;
static Object strlit4019;
static Object strlit4038;
static Object strlit4046;
static Object strlit4051;
static Object strlit4055;
static Object strlit4067;
static Object strlit4074;
static Object strlit4079;
static Object strlit4083;
static Object strlit4092;
static Object strlit4097;
static Object strlit4101;
static Object strlit4113;
static Object strlit4124;
static Object strlit4129;
static Object strlit4133;
static Object strlit4151;
static Object strlit4164;
static Object strlit4169;
static Object strlit4173;
static Object strlit4184;
static Object strlit4196;
static Object strlit4201;
static Object strlit4205;
static Object strlit4215;
static Object strlit4223;
static Object strlit4228;
static Object strlit4232;
static Object strlit4245;
static Object strlit4259;
static Object strlit4264;
static Object strlit4268;
static Object strlit4280;
static Object strlit4291;
static Object strlit4296;
static Object strlit4300;
static Object strlit4311;
static Object strlit4316;
static Object strlit4339;
static Object strlit4367;
static Object strlit4380;
static Object strlit4386;
static Object strlit4444;
static Object strlit4486;
static Object strlit4506;
static Object strlit4512;
static Object strlit4527;
static Object strlit4536;
static Object strlit4552;
static Object strlit4567;
static Object strlit4571;
static Object strlit4574;
static Object strlit4577;
static Object strlit4585;
static Object strlit4622;
static Object strlit4627;
static Object strlit4637;
static Object strlit4642;
static Object strlit4678;
static ClassData objclass4694;
static ClassData objclass4702;
static Object strlit4726;
static Object strlit4736;
static Object strlit4824;
static Object strlit4833;
static Object strlit4840;
static Object strlit4847;
static Object strlit4859;
static Object strlit4869;
static Object strlit4881;
static Object strlit4894;
static Object strlit4905;
static Object strlit4917;
static Object strlit4934;
static Object strlit4939;
static Object strlit4962;
static Object strlit4973;
static Object strlit4978;
static Object strlit4984;
static Object strlit4987;
static Object strlit4998;
static Object strlit5031;
static Object strlit5040;
static Object strlit5045;
static Object strlit5054;
static Object strlit5083;
static Object strlit5119;
static Object strlit5148;
static Object strlit5181;
static Object strlit5188;
static Object strlit5196;
static Object strlit5203;
static Object strlit5223;
static Object strlit5230;
static ClassData objclass5239;
static ClassData objclass5254;
static Object strlit5316;
static ClassData objclass5329;
static ClassData objclass5343;
static Object strlit5359;
static Object strlit5365;
static Object strlit5372;
static Object strlit5378;
static Object strlit5554;
static Object strlit5560;
static Object strlit5566;
static Object strlit5609;
static Object strlit5618;
static Object strlit5627;
static Object strlit5634;
static Object strlit5639;
static Object strlit5643;
static Object strlit5669;
static Object strlit5674;
static Object strlit5689;
static Object strlit5694;
static Object strlit5704;
static Object strlit5715;
static Object strlit5720;
static Object strlit5724;
static Object strlit5750;
static Object strlit5761;
static Object strlit5774;
static Object strlit5780;
static Object strlit5785;
static Object strlit5793;
static Object strlit5815;
static Object strlit5832;
static Object strlit5853;
static Object strlit5858;
static Object strlit5870;
static Object strlit5875;
static Object strlit5920;
static Object strlit5926;
static Object strlit5935;
static Object strlit5940;
static ClassData objclass5950;
static ClassData objclass5953;
static Object strlit5990;
static Object strlit5999;
static Object strlit6023;
static Object strlit6032;
static Object strlit6059;
static Object strlit6066;
static Object strlit6081;
static ClassData objclass6084;
static ClassData objclass6092;
static Object strlit6156;
static Object strlit6165;
static Object strlit6172;
static Object strlit6179;
static Object strlit6185;
static Object strlit6209;
static Object strlit6214;
static Object strlit6231;
static Object strlit6236;
static Object strlit6246;
static Object strlit6249;
static Object strlit6276;
static Object strlit6286;
static Object strlit6303;
static Object strlit6339;
static Object strlit6358;
static Object strlit6365;
static Object strlit6371;
static Object strlit6385;
static Object strlit6392;
static Object strlit6424;
static Object strlit6431;
static ClassData objclass6435;
static ClassData objclass6438;
static Object strlit6496;
static Object strlit6505;
static Object strlit6511;
static Object strlit6533;
static Object strlit6542;
static Object strlit6547;
static Object strlit6566;
static Object strlit6575;
static Object strlit6593;
static ClassData objclass6596;
static ClassData objclass6599;
static Object strlit6653;
static Object strlit6662;
static Object strlit6669;
static Object strlit6694;
static Object strlit6703;
static Object strlit6707;
static Object strlit6712;
static Object strlit6719;
static Object strlit6723;
static Object strlit6733;
static Object strlit6742;
static Object strlit6756;
static ClassData objclass6759;
static ClassData objclass6767;
static Object strlit6852;
static Object strlit6861;
static Object strlit6873;
static Object strlit6882;
static Object strlit6888;
static Object strlit6896;
static Object strlit6902;
static Object strlit6916;
static Object strlit6921;
static Object strlit6947;
static Object strlit6952;
static Object strlit6972;
static Object strlit6977;
static Object strlit6990;
static Object strlit7013;
static Object strlit7026;
static Object strlit7062;
static Object strlit7084;
static Object strlit7090;
static Object strlit7094;
static Object strlit7100;
static Object strlit7135;
static Object strlit7142;
static Object strlit7152;
static Object strlit7157;
static ClassData objclass7160;
static ClassData objclass7168;
static Object strlit7184;
static Object strlit7191;
static Object strlit7197;
static Object strlit7203;
static Object strlit7222;
static Object strlit7229;
static ClassData objclass7232;
static ClassData objclass7235;
static Object strlit7251;
static Object strlit7258;
static Object strlit7264;
static Object strlit7276;
static Object strlit7282;
static Object strlit7293;
static Object strlit7300;
static ClassData objclass7303;
static ClassData objclass7306;
static Object strlit7351;
static Object strlit7360;
static Object strlit7367;
static Object strlit7374;
static Object strlit7380;
static Object strlit7386;
static Object strlit7406;
static Object strlit7426;
static Object strlit7440;
static Object strlit7449;
static Object strlit7458;
static Object strlit7470;
static Object strlit7482;
static Object strlit7489;
static Object strlit7508;
static Object strlit7517;
static Object strlit7527;
static Object strlit7574;
static ClassData objclass7577;
static ClassData objclass7580;
static Object strlit7619;
static Object strlit7628;
static Object strlit7635;
static Object strlit7656;
static Object strlit7676;
static Object strlit7689;
static Object strlit7704;
static Object strlit7717;
static Object strlit7734;
static ClassData objclass7737;
static ClassData objclass7740;
static Object strlit7749;
static Object strlit7755;
static Object strlit7792;
static Object strlit7801;
static Object strlit7808;
static Object strlit7829;
static Object strlit7849;
static Object strlit7862;
static Object strlit7887;
static Object strlit7902;
static Object strlit7909;
static ClassData objclass7912;
static ClassData objclass7920;
static Object strlit7942;
static Object strlit7950;
static Object strlit8056;
static Object strlit8065;
static Object strlit8072;
static Object strlit8106;
static Object strlit8111;
static Object strlit8136;
static Object strlit8141;
static Object strlit8157;
static Object strlit8161;
static Object strlit8171;
static Object strlit8182;
static Object strlit8186;
static Object strlit8216;
static Object strlit8229;
static Object strlit8236;
static Object strlit8245;
static Object strlit8253;
static Object strlit8276;
static Object strlit8291;
static Object strlit8306;
static Object strlit8310;
static Object strlit8313;
static Object strlit8316;
static Object strlit8337;
static Object strlit8361;
static Object strlit8368;
static ClassData objclass8380;
static ClassData objclass8383;
static Object strlit8404;
static Object strlit8412;
static Object strlit8431;
static Object strlit8440;
static Object strlit8461;
static Object strlit8470;
static Object strlit8574;
static Object strlit8583;
static Object strlit8590;
static Object strlit8618;
static Object strlit8623;
static Object strlit8649;
static Object strlit8654;
static Object strlit8692;
static Object strlit8697;
static Object strlit8704;
static Object strlit8713;
static Object strlit8721;
static Object strlit8744;
static Object strlit8759;
static Object strlit8774;
static Object strlit8778;
static Object strlit8781;
static Object strlit8784;
static Object strlit8805;
static Object strlit8822;
static Object strlit8829;
static ClassData objclass8840;
static ClassData objclass8843;
static Object strlit8877;
static Object strlit8885;
static Object strlit8892;
static Object strlit8900;
static Object strlit8903;
static Object strlit8989;
static Object strlit8998;
static Object strlit9005;
static Object strlit9012;
static Object strlit9019;
static Object strlit9023;
static Object strlit9033;
static Object strlit9040;
static Object strlit9044;
static Object strlit9063;
static Object strlit9070;
static Object strlit9074;
static Object strlit9084;
static Object strlit9091;
static Object strlit9097;
static Object strlit9116;
static ClassData objclass9123;
static ClassData objclass9126;
static Object strlit9137;
static Object strlit9145;
static Object strlit9148;
static Object strlit9170;
static Object strlit9179;
static Object strlit9186;
static Object strlit9193;
static Object strlit9200;
static Object strlit9204;
static Object strlit9214;
static Object strlit9220;
static Object strlit9236;
static ClassData objclass9239;
static ClassData objclass9242;
static Object strlit9270;
static Object strlit9279;
static Object strlit9286;
static Object strlit9313;
static Object strlit9326;
static ClassData objclass9329;
static ClassData objclass9337;
static Object strlit9413;
static Object strlit9422;
static Object strlit9434;
static Object strlit9438;
static Object strlit9455;
static Object strlit9465;
static Object strlit9472;
static Object strlit9476;
static Object strlit9494;
static Object strlit9499;
static Object strlit9503;
static Object strlit9513;
static Object strlit9518;
static Object strlit9522;
static Object strlit9541;
static Object strlit9552;
static Object strlit9556;
static Object strlit9568;
static Object strlit9569;
static Object strlit9583;
static Object strlit9588;
static Object strlit9592;
static Object strlit9606;
static Object strlit9613;
static Object strlit9617;
static Object strlit9677;
static Object strlit9678;
static Object strlit9685;
static ClassData objclass9704;
static ClassData objclass9707;
static Object strlit9724;
static Object strlit9726;
static Object strlit9728;
static Object strlit9740;
static Object strlit9741;
static ClassData objclass9744;
static Object strlit9748;
static ClassData objclass9780;
static Object strlit9866;
static Object strlit9875;
static Object strlit9882;
static Object strlit9889;
static Object strlit9895;
static Object strlit9908;
static Object strlit9913;
static Object strlit9917;
static Object strlit9929;
static Object strlit9940;
static Object strlit9945;
static Object strlit9949;
static Object strlit9967;
static Object strlit9980;
static Object strlit9985;
static Object strlit9989;
static Object strlit10005;
static Object strlit10018;
static Object strlit10023;
static Object strlit10027;
static Object strlit10055;
static Object strlit10061;
static Object strlit10070;
static ClassData objclass10075;
static Object strlit10079;
static ClassData objclass10088;
static Object strlit10112;
static Object strlit10121;
static Object strlit10128;
static Object strlit10135;
static Object strlit10141;
static Object strlit10147;
static Object strlit10152;
static Object strlit10156;
static Object strlit10168;
static Object strlit10179;
static Object strlit10184;
static Object strlit10188;
static Object strlit10215;
static Object strlit10222;
static ClassData objclass10226;
static ClassData objclass10229;
static Object strlit10244;
static Object strlit10251;
static Object strlit10258;
static Object strlit10264;
static Object strlit10278;
static Object strlit10300;
static Object strlit10309;
static Object strlit10318;
static Object strlit10319;
static Object strlit10321;
static Object strlit10328;
static Object strlit10335;
static Object strlit10342;
static Object strlit10347;
static Object strlit10351;
static Object strlit10367;
static Object strlit10373;
static Object strlit10376;
static Object strlit10381;
static Object strlit10391;
static Object strlit10425;
static ClassData objclass10435;
Object meth_ast__apply8(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_as = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe9 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe10 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11 = callmethod(*var_nd, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe10);
// compiled call node returning call11 (depth = 5)
  gc_frame_newslot(call11);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call11;
  partcv[0] = 1;
  Object call12 = callmethod(*var_newList, "addLast",
    1, partcv, params);
  gc_frame_end(callframe9);
// compiled call node returning call12 (depth = 4)
  gc_frame_end(frame);
  return call12;
}
Object meth_ast_listMap_40__41_ancestors1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "listMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method listMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method listMap()ancestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for listMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for listMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3);
// compiled call node returning call4 (depth = 6)
// compiled member node returning call4 (depth = 5)
  partcv[0] = 0;
  Object call5 = callmethod(call4, "empty",
    1, partcv, params);
  gc_frame_end(callframe2);
// compiled call node returning call5 (depth = 4)
// compiled member node returning call5 (depth = 3)
  *var_newList = call5;
  if (call5 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7 = alloc_Block(NULL, NULL, "ast", 19);
  gc_frame_newslot(block7);
// method "_apply"
  block_savedest(block7);
  Object closure8 = createclosure(4, "_apply");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_b);
  addtoclosure(closure8, var_as);
  addtoclosure(closure8, var_newList);
  addtoclosure(closure8, selfslot);
  struct UserObject *uo8 = (struct UserObject*)block7;
  uo8->data[0] = (Object)closure8;
  Method *meth_meth_ast__apply8 = addmethod2pos(block7, "_apply", &meth_ast__apply8, 0);
  int argcv_meth_ast__apply8[] = {1};
  meth_meth_ast__apply8->type = alloc_MethodType(1, argcv_meth_ast__apply8);
  meth_meth_ast__apply8->definitionModule = modulename;
  meth_meth_ast__apply8->definitionLine = 18;
// compiled block node returning block7 (depth = 3)
  gc_frame_newslot(block7);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = block7;
  partcv[0] = 1;
  Object call14 = callmethod(*var_l, "do",
    1, partcv, params);
  gc_frame_end(callframe6);
// compiled call node returning call14 (depth = 2)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_maybeMap_40__41_ancestors15(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for maybeMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool18 = alloc_Boolean(0);
// compiled identifier node returning bool18 (depth = 4)
  int op_slot_right_17 = gc_frame_newslot(bool18);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_17 = gc_frame_newslot(*var_n);
  params[0] = bool18;
  partcv[0] = 1;
  Object opresult20 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult20 (depth = 3)
  Object if16 = done;
  if (istrue(opresult20)) {
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe21 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call22 = callmethod(*var_n, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe21);
// compiled call node returning call22 (depth = 3)
    gc_frame_newslot(call22);
    if16 = call22;
  } else {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if16 = *var_n;
  }
// compiled if node returning if16 (depth = 2)
  gc_frame_end(frame);
  return if16;
}
Object meth_ast_maybeListMap_40__41_ancestors23(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeListMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeListMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for maybeListMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool26 = alloc_Boolean(0);
// compiled identifier node returning bool26 (depth = 4)
  int op_slot_right_25 = gc_frame_newslot(bool26);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_25 = gc_frame_newslot(*var_n);
  params[0] = bool26;
  partcv[0] = 1;
  Object opresult28 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult28 (depth = 3)
  Object if24 = done;
  if (istrue(opresult28)) {
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe29 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_b;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call30 = callmethodflags(self, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe29);
// compiled call node returning call30 (depth = 3)
    gc_frame_newslot(call30);
    if24 = call30;
  } else {
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if24 = *var_n;
  }
// compiled if node returning if24 (depth = 2)
  gc_frame_end(frame);
  return if24;
}
Object meth_ast_kind39(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for kind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for kind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe40 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call41 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe40);
// compiled call node returning call41 (depth = 3)
// compiled member node returning call41 (depth = 2)
  gc_frame_end(frame);
  return call41;
}
Object meth_ast_isAppliedOccurenceOfIdentifier42(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool43 = alloc_Boolean(0);
// compiled identifier node returning bool43 (depth = 2)
  gc_frame_end(frame);
  return bool43;
}
Object meth_ast_isMatchingBlock44(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool45 = alloc_Boolean(0);
// compiled identifier node returning bool45 (depth = 2)
  gc_frame_end(frame);
  return bool45;
}
Object meth_ast_isFieldDec46(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool47 = alloc_Boolean(0);
// compiled identifier node returning bool47 (depth = 2)
  gc_frame_end(frame);
  return bool47;
}
Object meth_ast_isInherits48(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool49 = alloc_Boolean(0);
// compiled identifier node returning bool49 (depth = 2)
  gc_frame_end(frame);
  return bool49;
}
Object meth_ast_isLegalInTrait50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool51 = alloc_Boolean(0);
// compiled identifier node returning bool51 (depth = 2)
  gc_frame_end(frame);
  return bool51;
}
Object meth_ast_isMember52(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool53 = alloc_Boolean(0);
// compiled identifier node returning bool53 (depth = 2)
  gc_frame_end(frame);
  return bool53;
}
Object meth_ast_isMethod54(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool55 = alloc_Boolean(0);
// compiled identifier node returning bool55 (depth = 2)
  gc_frame_end(frame);
  return bool55;
}
Object meth_ast_isExecutable56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool57 = alloc_Boolean(1);
// compiled identifier node returning bool57 (depth = 2)
  gc_frame_end(frame);
  return bool57;
}
Object meth_ast_isCall58(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool59 = alloc_Boolean(0);
// compiled identifier node returning bool59 (depth = 2)
  gc_frame_end(frame);
  return bool59;
}
Object meth_ast_isComment60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isComment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isComment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool61 = alloc_Boolean(0);
// compiled identifier node returning bool61 (depth = 2)
  gc_frame_end(frame);
  return bool61;
}
Object meth_ast_isClass62(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool63 = alloc_Boolean(0);
// compiled identifier node returning bool63 (depth = 2)
  gc_frame_end(frame);
  return bool63;
}
Object meth_ast_inClass64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool65 = alloc_Boolean(0);
// compiled identifier node returning bool65 (depth = 2)
  gc_frame_end(frame);
  return bool65;
}
Object meth_ast_isTrait66(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool67 = alloc_Boolean(0);
// compiled identifier node returning bool67 (depth = 2)
  gc_frame_end(frame);
  return bool67;
}
Object meth_ast_inTrait68(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool69 = alloc_Boolean(0);
// compiled identifier node returning bool69 (depth = 2)
  gc_frame_end(frame);
  return bool69;
}
Object meth_ast_isBind70(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool71 = alloc_Boolean(0);
// compiled identifier node returning bool71 (depth = 2)
  gc_frame_end(frame);
  return bool71;
}
Object meth_ast_isBlock72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool73 = alloc_Boolean(0);
// compiled identifier node returning bool73 (depth = 2)
  gc_frame_end(frame);
  return bool73;
}
Object meth_ast_isObject74(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool75 = alloc_Boolean(0);
// compiled identifier node returning bool75 (depth = 2)
  gc_frame_end(frame);
  return bool75;
}
Object meth_ast_isIdentifier76(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool77 = alloc_Boolean(0);
// compiled identifier node returning bool77 (depth = 2)
  gc_frame_end(frame);
  return bool77;
}
Object meth_ast_isDialect78(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isDialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isDialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool79 = alloc_Boolean(0);
// compiled identifier node returning bool79 (depth = 2)
  gc_frame_end(frame);
  return bool79;
}
Object meth_ast_isImport80(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isImport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isImport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool81 = alloc_Boolean(0);
// compiled identifier node returning bool81 (depth = 2)
  gc_frame_end(frame);
  return bool81;
}
Object meth_ast_isTypeDec82(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTypeDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 2)
  gc_frame_end(frame);
  return bool83;
}
Object meth_ast_isExternal84(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExternal (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExternal");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 2)
  gc_frame_end(frame);
  return bool85;
}
Object meth_ast_canInherit86(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool87 = alloc_Boolean(0);
// compiled identifier node returning bool87 (depth = 2)
  gc_frame_end(frame);
  return bool87;
}
Object meth_ast_returnsObject88(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool89 = alloc_Boolean(0);
// compiled identifier node returning bool89 (depth = 2)
  gc_frame_end(frame);
  return bool89;
}
Object meth_ast_usesAsType90(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool91 = alloc_Boolean(0);
// compiled identifier node returning bool91 (depth = 2)
  gc_frame_end(frame);
  return bool91;
}
Object meth_ast_hash92(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe94 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe95 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call96 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe95);
// compiled call node returning call96 (depth = 6)
// compiled member node returning call96 (depth = 5)
  partcv[0] = 0;
  Object call97 = callmethod(call96, "hash",
    1, partcv, params);
  gc_frame_end(callframe94);
// compiled call node returning call97 (depth = 4)
// compiled member node returning call97 (depth = 3)
  int op_slot_right_93 = gc_frame_newslot(call97);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe99 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call101 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call101 (depth = 6)
// compiled member node returning call101 (depth = 5)
  partcv[0] = 0;
  Object call102 = callmethod(call101, "hash",
    1, partcv, params);
  gc_frame_end(callframe99);
// compiled call node returning call102 (depth = 4)
// compiled member node returning call102 (depth = 3)
  int op_slot_left_93 = gc_frame_newslot(call102);
  params[0] = call97;
  partcv[0] = 1;
  Object prod103 = callmethod(call102, "*", 1, partcv, params);
// compiled op node returning prod103 (depth = 2)
  gc_frame_end(frame);
  return prod103;
}
Object meth_ast_asString104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit106 == NULL) {
    strlit106 = alloc_String("");
    gc_root(strlit106);
  }
// compiled string node returning strlit106 (depth = 3)
  int op_slot_right_105 = gc_frame_newslot(strlit106);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call110 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe109);
// compiled call node returning call110 (depth = 5)
// compiled member node returning call110 (depth = 4)
  int op_slot_right_108 = gc_frame_newslot(call110);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit113 == NULL) {
    strlit113 = alloc_String(" ");
    gc_root(strlit113);
  }
// compiled string node returning strlit113 (depth = 5)
  int op_slot_right_112 = gc_frame_newslot(strlit113);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call117 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 7)
// compiled member node returning call117 (depth = 6)
  int op_slot_right_115 = gc_frame_newslot(call117);
// starting to compile string node (depth = 6)
  if (strlit119 == NULL) {
    strlit119 = alloc_String("");
    gc_root(strlit119);
  }
// compiled string node returning strlit119 (depth = 6)
  int op_slot_left_115 = gc_frame_newslot(strlit119);
  params[0] = call117;
  partcv[0] = 1;
  Object opresult120 = callmethod(strlit119, "++", 1, partcv, params);
// compiled op node returning opresult120 (depth = 5)
  int op_slot_left_112 = gc_frame_newslot(opresult120);
  params[0] = strlit113;
  partcv[0] = 1;
  Object opresult121 = callmethod(opresult120, "++", 1, partcv, params);
// compiled op node returning opresult121 (depth = 4)
  int op_slot_left_108 = gc_frame_newslot(opresult121);
  params[0] = call110;
  partcv[0] = 1;
  Object opresult122 = callmethod(opresult121, "++", 1, partcv, params);
// compiled op node returning opresult122 (depth = 3)
  int op_slot_left_105 = gc_frame_newslot(opresult122);
  params[0] = strlit106;
  partcv[0] = 1;
  Object opresult123 = callmethod(opresult122, "++", 1, partcv, params);
// compiled op node returning opresult123 (depth = 2)
  gc_frame_end(frame);
  return opresult123;
}
Object meth_ast_nameString124(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit125 == NULL) {
    strlit125 = alloc_String("?");
    gc_root(strlit125);
  }
// compiled string node returning strlit125 (depth = 2)
  gc_frame_end(frame);
  return strlit125;
}
Object meth_ast_isWritable126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool127 = alloc_Boolean(1);
// compiled identifier node returning bool127 (depth = 2)
  gc_frame_end(frame);
  return bool127;
}
Object meth_ast_isReadable128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool129 = alloc_Boolean(1);
// compiled identifier node returning bool129 (depth = 2)
  gc_frame_end(frame);
  return bool129;
}
Object meth_ast_isPublic130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool131 = alloc_Boolean(1);
// compiled identifier node returning bool131 (depth = 2)
  gc_frame_end(frame);
  return bool131;
}
Object meth_ast_isConfidential132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe133 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call135 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe134);
// compiled call node returning call135 (depth = 5)
// compiled member node returning call135 (depth = 4)
  partcv[0] = 0;
  Object call136 = callmethod(call135, "not",
    1, partcv, params);
  gc_frame_end(callframe133);
// compiled call node returning call136 (depth = 3)
// compiled member node returning call136 (depth = 2)
  gc_frame_end(frame);
  return call136;
}
Object meth_ast_decType137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool140 = alloc_Boolean(0);
// compiled identifier node returning bool140 (depth = 4)
  int op_slot_right_139 = gc_frame_newslot(bool140);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe142 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call143 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe142);
// compiled call node returning call143 (depth = 5)
// compiled member node returning call143 (depth = 4)
  int op_slot_left_139 = gc_frame_newslot(call143);
  params[0] = bool140;
  partcv[0] = 1;
  Object opresult144 = callmethod(call143, "==", 1, partcv, params);
// compiled op node returning opresult144 (depth = 3)
  Object if138 = done;
  if (istrue(opresult144)) {
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unknownType (depth = 4)
  return *var_unknownType;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if138 = undefined;
  } else {
  }
// compiled if node returning if138 (depth = 2)
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call146 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe145);
// compiled call node returning call146 (depth = 4)
// compiled member node returning call146 (depth = 3)
  return call146;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_isSimple147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool148 = alloc_Boolean(1);
// compiled identifier node returning bool148 (depth = 2)
  gc_frame_end(frame);
  return bool148;
}
Object meth_ast_description149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for description (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for description");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call151 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe150);
// compiled call node returning call151 (depth = 3)
// compiled member node returning call151 (depth = 2)
  gc_frame_end(frame);
  return call151;
}
Object meth_ast_accept152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept");
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe153 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitor (depth = 3)
  gc_frame_newslot(*var_visitor);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ancestorChain (depth = 5)
  partcv[0] = 0;
  Object call155 = callmethod(*var_ancestorChain, "empty",
    1, partcv, params);
  gc_frame_end(callframe154);
// compiled call node returning call155 (depth = 4)
// compiled member node returning call155 (depth = 3)
  gc_frame_newslot(call155);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = call155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call156 = callmethodflags(self, "accept()from", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe153);
// compiled call node returning call156 (depth = 2)
  gc_frame_end(frame);
  return call156;
}
Object meth_ast_scope157(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call159 = callmethodflags(self, "symbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe158);
// compiled call node returning call159 (depth = 3)
// compiled member node returning call159 (depth = 2)
  gc_frame_end(frame);
  return call159;
}
Object meth_ast_scope_58__61_160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe161 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_st (depth = 3)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call162 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe161);
// compiled call node returning call162 (depth = 2)
  gc_frame_end(frame);
  return call162;
}
Object meth_ast_shallowCopyFieldsFrom163(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe164 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe165 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call166 = callmethod(*var_other, "register",
    1, partcv, params);
  gc_frame_end(callframe165);
// compiled call node returning call166 (depth = 4)
// compiled member node returning call166 (depth = 3)
  gc_frame_newslot(call166);
// call case 4: self request
  params[0] = call166;
  partcv[0] = 1;
  Object call167 = callmethodflags(self, "register:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe164);
// compiled call node returning call167 (depth = 2)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe168 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call170 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe169);
// compiled call node returning call170 (depth = 4)
// compiled member node returning call170 (depth = 3)
  gc_frame_newslot(call170);
// call case 4: self request
  params[0] = call170;
  partcv[0] = 1;
  Object call171 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe168);
// compiled call node returning call171 (depth = 2)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe172 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call174 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe173);
// compiled call node returning call174 (depth = 4)
// compiled member node returning call174 (depth = 3)
  gc_frame_newslot(call174);
// call case 4: self request
  params[0] = call174;
  partcv[0] = 1;
  Object call175 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe172);
// compiled call node returning call175 (depth = 2)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe176 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call178 = callmethod(*var_other, "scope",
    1, partcv, params);
  gc_frame_end(callframe177);
// compiled call node returning call178 (depth = 4)
// compiled member node returning call178 (depth = 3)
  gc_frame_newslot(call178);
// call case 4: self request
  params[0] = call178;
  partcv[0] = 1;
  Object call179 = callmethodflags(self, "scope:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe176);
// compiled call node returning call179 (depth = 2)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit190 == NULL) {
    strlit190 = alloc_String("  ");
    gc_root(strlit190);
  }
// compiled string node returning strlit190 (depth = 6)
  int op_slot_right_189 = gc_frame_newslot(strlit190);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_189 = gc_frame_newslot(*var_spc);
  params[0] = strlit190;
  partcv[0] = 1;
  Object opresult192 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult192 (depth = 5)
  *var_spc = opresult192;
  if (opresult192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply199(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit201 == NULL) {
    strlit201 = alloc_String("symbols");
    gc_root(strlit201);
  }
// compiled string node returning strlit201 (depth = 6)
  int op_slot_right_200 = gc_frame_newslot(strlit201);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe203 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call204 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe203);
// compiled call node returning call204 (depth = 7)
// compiled member node returning call204 (depth = 6)
  int op_slot_left_200 = gc_frame_newslot(call204);
  params[0] = strlit201;
  partcv[0] = 1;
  Object opresult205 = callmethod(call204, "==", 1, partcv, params);
// compiled op node returning opresult205 (depth = 5)
  gc_frame_end(frame);
  return opresult205;
}
Object meth_ast_pretty180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit181 == NULL) {
    strlit181 = alloc_String("");
    gc_root(strlit181);
  }
// compiled string node returning strlit181 (depth = 3)
  *var_spc = strlit181;
  if (strlit181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe182 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_183 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num185 = alloc_Float64(0);
// compiled num node returning num185 (depth = 4)
  int op_slot_left_183 = gc_frame_newslot(num185);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult186 = callmethod(num185, "..", 1, partcv, params);
// compiled op node returning opresult186 (depth = 3)
  gc_frame_newslot(opresult186);
// starting to compile block node (depth = 3)
  Object block187 = alloc_Block(NULL, NULL, "ast", 155);
  gc_frame_newslot(block187);
// method "_apply"
  block_savedest(block187);
  Object closure188 = createclosure(2, "_apply");
  setclosureframe(closure188, stackframe);
  addtoclosure(closure188, var_spc);
  addtoclosure(closure188, selfslot);
  struct UserObject *uo188 = (struct UserObject*)block187;
  uo188->data[0] = (Object)closure188;
  Method *meth_meth_ast__apply188 = addmethod2pos(block187, "_apply", &meth_ast__apply188, 0);
  int argcv_meth_ast__apply188[] = {1};
  meth_meth_ast__apply188->type = alloc_MethodType(1, argcv_meth_ast__apply188);
  meth_meth_ast__apply188->definitionModule = modulename;
  meth_meth_ast__apply188->definitionLine = 150;
// compiled block node returning block187 (depth = 3)
  gc_frame_newslot(block187);
// call case 5: prelude request
  params[0] = opresult186;
  params[1] = block187;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call195 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe182);
// compiled call node returning call195 (depth = 2)
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe197 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block198 = alloc_Block(NULL, NULL, "ast", 158);
  gc_frame_newslot(block198);
// method "_apply"
  block_savedest(block198);
  Object closure199 = createclosure(2, "_apply");
  setclosureframe(closure199, stackframe);
  addtoclosure(closure199, var_util);
  addtoclosure(closure199, selfslot);
  struct UserObject *uo199 = (struct UserObject*)block198;
  uo199->data[0] = (Object)closure199;
  Method *meth_meth_ast__apply199 = addmethod2pos(block198, "_apply", &meth_ast__apply199, 0);
  int argcv_meth_ast__apply199[] = {0};
  meth_meth_ast__apply199->type = alloc_MethodType(1, argcv_meth_ast__apply199);
  meth_meth_ast__apply199->definitionModule = modulename;
  meth_meth_ast__apply199->definitionLine = 150;
// compiled block node returning block198 (depth = 4)
  gc_frame_newslot(block198);
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  int op_slot_right_207 = gc_frame_newslot(self);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe209 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call211 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe210);
// compiled call node returning call211 (depth = 8)
// compiled member node returning call211 (depth = 7)
  partcv[0] = 0;
  Object call212 = callmethod(call211, "node",
    1, partcv, params);
  gc_frame_end(callframe209);
// compiled call node returning call212 (depth = 6)
// compiled member node returning call212 (depth = 5)
  int op_slot_left_207 = gc_frame_newslot(call212);
  params[0] = self;
  partcv[0] = 1;
  Object opresult213 = callmethod(call212, "==", 1, partcv, params);
// compiled op node returning opresult213 (depth = 4)
  params[0] = block198;
  partcv[0] = 1;
  Object call214 = callmethod(opresult213, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe197);
// compiled call node returning call214 (depth = 3)
  Object if196 = done;
  if (istrue(call214)) {
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit216 == NULL) {
    strlit216 = alloc_String("");
    gc_root(strlit216);
  }
// compiled string node returning strlit216 (depth = 4)
  int op_slot_right_215 = gc_frame_newslot(strlit216);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe219 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe220 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call221 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe220);
// compiled call node returning call221 (depth = 8)
// compiled member node returning call221 (depth = 7)
  partcv[0] = 0;
  Object call222 = callmethod(call221, "elementScopesAsString",
    1, partcv, params);
  gc_frame_end(callframe219);
// compiled call node returning call222 (depth = 6)
// compiled member node returning call222 (depth = 5)
  int op_slot_right_218 = gc_frame_newslot(call222);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit225 == NULL) {
    strlit225 = alloc_String("");
    gc_root(strlit225);
  }
// compiled string node returning strlit225 (depth = 6)
  int op_slot_right_224 = gc_frame_newslot(strlit225);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe228 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call229 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe228);
// compiled call node returning call229 (depth = 8)
// compiled member node returning call229 (depth = 7)
  int op_slot_right_227 = gc_frame_newslot(call229);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit232 == NULL) {
    strlit232 = alloc_String("): ");
    gc_root(strlit232);
  }
// compiled string node returning strlit232 (depth = 8)
  int op_slot_right_231 = gc_frame_newslot(strlit232);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe235 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call237 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe236);
// compiled call node returning call237 (depth = 12)
// compiled member node returning call237 (depth = 11)
  partcv[0] = 0;
  Object call238 = callmethod(call237, "variety",
    1, partcv, params);
  gc_frame_end(callframe235);
// compiled call node returning call238 (depth = 10)
// compiled member node returning call238 (depth = 9)
  int op_slot_right_234 = gc_frame_newslot(call238);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit241 == NULL) {
    strlit241 = alloc_String("Symbols(");
    gc_root(strlit241);
  }
// compiled string node returning strlit241 (depth = 10)
  int op_slot_right_240 = gc_frame_newslot(strlit241);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_243 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit246 == NULL) {
    strlit246 = alloc_String("""\x0a""");
    gc_root(strlit246);
  }
// compiled string node returning strlit246 (depth = 12)
  int op_slot_right_245 = gc_frame_newslot(strlit246);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call250 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe249);
// compiled call node returning call250 (depth = 14)
// compiled member node returning call250 (depth = 13)
  int op_slot_right_248 = gc_frame_newslot(call250);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit253 == NULL) {
    strlit253 = alloc_String(" ");
    gc_root(strlit253);
  }
// compiled string node returning strlit253 (depth = 14)
  int op_slot_right_252 = gc_frame_newslot(strlit253);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call257 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe256);
// compiled call node returning call257 (depth = 16)
// compiled member node returning call257 (depth = 15)
  int op_slot_right_255 = gc_frame_newslot(call257);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit260 == NULL) {
    strlit260 = alloc_String(":");
    gc_root(strlit260);
  }
// compiled string node returning strlit260 (depth = 16)
  int op_slot_right_259 = gc_frame_newslot(strlit260);
// starting to compile op node (depth = 16)
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call264 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe263);
// compiled call node returning call264 (depth = 18)
// compiled member node returning call264 (depth = 17)
  int op_slot_right_262 = gc_frame_newslot(call264);
// starting to compile string node (depth = 17)
  if (strlit266 == NULL) {
    strlit266 = alloc_String("");
    gc_root(strlit266);
  }
// compiled string node returning strlit266 (depth = 17)
  int op_slot_left_262 = gc_frame_newslot(strlit266);
  params[0] = call264;
  partcv[0] = 1;
  Object opresult267 = callmethod(strlit266, "++", 1, partcv, params);
// compiled op node returning opresult267 (depth = 16)
  int op_slot_left_259 = gc_frame_newslot(opresult267);
  params[0] = strlit260;
  partcv[0] = 1;
  Object opresult268 = callmethod(opresult267, "++", 1, partcv, params);
// compiled op node returning opresult268 (depth = 15)
  int op_slot_left_255 = gc_frame_newslot(opresult268);
  params[0] = call257;
  partcv[0] = 1;
  Object opresult269 = callmethod(opresult268, "++", 1, partcv, params);
// compiled op node returning opresult269 (depth = 14)
  int op_slot_left_252 = gc_frame_newslot(opresult269);
  params[0] = strlit253;
  partcv[0] = 1;
  Object opresult270 = callmethod(opresult269, "++", 1, partcv, params);
// compiled op node returning opresult270 (depth = 13)
  int op_slot_left_248 = gc_frame_newslot(opresult270);
  params[0] = call250;
  partcv[0] = 1;
  Object opresult271 = callmethod(opresult270, "++", 1, partcv, params);
// compiled op node returning opresult271 (depth = 12)
  int op_slot_left_245 = gc_frame_newslot(opresult271);
  params[0] = strlit246;
  partcv[0] = 1;
  Object opresult272 = callmethod(opresult271, "++", 1, partcv, params);
// compiled op node returning opresult272 (depth = 11)
  int op_slot_left_243 = gc_frame_newslot(opresult272);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult273 = callmethod(opresult272, "++", 1, partcv, params);
// compiled op node returning opresult273 (depth = 10)
  int op_slot_left_240 = gc_frame_newslot(opresult273);
  params[0] = strlit241;
  partcv[0] = 1;
  Object opresult274 = callmethod(opresult273, "++", 1, partcv, params);
// compiled op node returning opresult274 (depth = 9)
  int op_slot_left_234 = gc_frame_newslot(opresult274);
  params[0] = call238;
  partcv[0] = 1;
  Object opresult275 = callmethod(opresult274, "++", 1, partcv, params);
// compiled op node returning opresult275 (depth = 8)
  int op_slot_left_231 = gc_frame_newslot(opresult275);
  params[0] = strlit232;
  partcv[0] = 1;
  Object opresult276 = callmethod(opresult275, "++", 1, partcv, params);
// compiled op node returning opresult276 (depth = 7)
  int op_slot_left_227 = gc_frame_newslot(opresult276);
  params[0] = call229;
  partcv[0] = 1;
  Object opresult277 = callmethod(opresult276, "++", 1, partcv, params);
// compiled op node returning opresult277 (depth = 6)
  int op_slot_left_224 = gc_frame_newslot(opresult277);
  params[0] = strlit225;
  partcv[0] = 1;
  Object opresult278 = callmethod(opresult277, "++", 1, partcv, params);
// compiled op node returning opresult278 (depth = 5)
  int op_slot_left_218 = gc_frame_newslot(opresult278);
  params[0] = call222;
  partcv[0] = 1;
  Object opresult279 = callmethod(opresult278, "++", 1, partcv, params);
// compiled op node returning opresult279 (depth = 4)
  int op_slot_left_215 = gc_frame_newslot(opresult279);
  params[0] = strlit216;
  partcv[0] = 1;
  Object opresult280 = callmethod(opresult279, "++", 1, partcv, params);
// compiled op node returning opresult280 (depth = 3)
    gc_frame_newslot(opresult280);
    if196 = opresult280;
  } else {
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit283 == NULL) {
    strlit283 = alloc_String("fake");
    gc_root(strlit283);
  }
// compiled string node returning strlit283 (depth = 5)
  int op_slot_right_282 = gc_frame_newslot(strlit283);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe285 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call287 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe286);
// compiled call node returning call287 (depth = 8)
// compiled member node returning call287 (depth = 7)
  partcv[0] = 0;
  Object call288 = callmethod(call287, "variety",
    1, partcv, params);
  gc_frame_end(callframe285);
// compiled call node returning call288 (depth = 6)
// compiled member node returning call288 (depth = 5)
  int op_slot_left_282 = gc_frame_newslot(call288);
  params[0] = strlit283;
  partcv[0] = 1;
  Object opresult289 = callmethod(call288, "==", 1, partcv, params);
// compiled op node returning opresult289 (depth = 4)
  Object if281 = done;
  if (istrue(opresult289)) {
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit291 == NULL) {
    strlit291 = alloc_String("");
    gc_root(strlit291);
  }
// compiled string node returning strlit291 (depth = 5)
  int op_slot_right_290 = gc_frame_newslot(strlit291);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe294 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call295 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe294);
// compiled call node returning call295 (depth = 7)
// compiled member node returning call295 (depth = 6)
  int op_slot_right_293 = gc_frame_newslot(call295);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit298 == NULL) {
    strlit298 = alloc_String(" ");
    gc_root(strlit298);
  }
// compiled string node returning strlit298 (depth = 7)
  int op_slot_right_297 = gc_frame_newslot(strlit298);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe301 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call302 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe301);
// compiled call node returning call302 (depth = 9)
// compiled member node returning call302 (depth = 8)
  int op_slot_right_300 = gc_frame_newslot(call302);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit305 == NULL) {
    strlit305 = alloc_String(":");
    gc_root(strlit305);
  }
// compiled string node returning strlit305 (depth = 9)
  int op_slot_right_304 = gc_frame_newslot(strlit305);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe308 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call309 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe308);
// compiled call node returning call309 (depth = 11)
// compiled member node returning call309 (depth = 10)
  int op_slot_right_307 = gc_frame_newslot(call309);
// starting to compile string node (depth = 10)
  if (strlit311 == NULL) {
    strlit311 = alloc_String("");
    gc_root(strlit311);
  }
// compiled string node returning strlit311 (depth = 10)
  int op_slot_left_307 = gc_frame_newslot(strlit311);
  params[0] = call309;
  partcv[0] = 1;
  Object opresult312 = callmethod(strlit311, "++", 1, partcv, params);
// compiled op node returning opresult312 (depth = 9)
  int op_slot_left_304 = gc_frame_newslot(opresult312);
  params[0] = strlit305;
  partcv[0] = 1;
  Object opresult313 = callmethod(opresult312, "++", 1, partcv, params);
// compiled op node returning opresult313 (depth = 8)
  int op_slot_left_300 = gc_frame_newslot(opresult313);
  params[0] = call302;
  partcv[0] = 1;
  Object opresult314 = callmethod(opresult313, "++", 1, partcv, params);
// compiled op node returning opresult314 (depth = 7)
  int op_slot_left_297 = gc_frame_newslot(opresult314);
  params[0] = strlit298;
  partcv[0] = 1;
  Object opresult315 = callmethod(opresult314, "++", 1, partcv, params);
// compiled op node returning opresult315 (depth = 6)
  int op_slot_left_293 = gc_frame_newslot(opresult315);
  params[0] = call295;
  partcv[0] = 1;
  Object opresult316 = callmethod(opresult315, "++", 1, partcv, params);
// compiled op node returning opresult316 (depth = 5)
  int op_slot_left_290 = gc_frame_newslot(opresult316);
  params[0] = strlit291;
  partcv[0] = 1;
  Object opresult317 = callmethod(opresult316, "++", 1, partcv, params);
// compiled op node returning opresult317 (depth = 4)
    gc_frame_newslot(opresult317);
    if281 = opresult317;
  } else {
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit319 == NULL) {
    strlit319 = alloc_String("");
    gc_root(strlit319);
  }
// compiled string node returning strlit319 (depth = 5)
  int op_slot_right_318 = gc_frame_newslot(strlit319);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe322 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call324 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe323);
// compiled call node returning call324 (depth = 9)
// compiled member node returning call324 (depth = 8)
  partcv[0] = 0;
  Object call325 = callmethod(call324, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe322);
// compiled call node returning call325 (depth = 7)
// compiled member node returning call325 (depth = 6)
  int op_slot_right_321 = gc_frame_newslot(call325);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit328 == NULL) {
    strlit328 = alloc_String(" ");
    gc_root(strlit328);
  }
// compiled string node returning strlit328 (depth = 7)
  int op_slot_right_327 = gc_frame_newslot(strlit328);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call332 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe331);
// compiled call node returning call332 (depth = 9)
// compiled member node returning call332 (depth = 8)
  int op_slot_right_330 = gc_frame_newslot(call332);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit335 == NULL) {
    strlit335 = alloc_String(" ");
    gc_root(strlit335);
  }
// compiled string node returning strlit335 (depth = 9)
  int op_slot_right_334 = gc_frame_newslot(strlit335);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call339 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe338);
// compiled call node returning call339 (depth = 11)
// compiled member node returning call339 (depth = 10)
  int op_slot_right_337 = gc_frame_newslot(call339);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit342 == NULL) {
    strlit342 = alloc_String(":");
    gc_root(strlit342);
  }
// compiled string node returning strlit342 (depth = 11)
  int op_slot_right_341 = gc_frame_newslot(strlit342);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call346 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe345);
// compiled call node returning call346 (depth = 13)
// compiled member node returning call346 (depth = 12)
  int op_slot_right_344 = gc_frame_newslot(call346);
// starting to compile string node (depth = 12)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 12)
  int op_slot_left_344 = gc_frame_newslot(strlit348);
  params[0] = call346;
  partcv[0] = 1;
  Object opresult349 = callmethod(strlit348, "++", 1, partcv, params);
// compiled op node returning opresult349 (depth = 11)
  int op_slot_left_341 = gc_frame_newslot(opresult349);
  params[0] = strlit342;
  partcv[0] = 1;
  Object opresult350 = callmethod(opresult349, "++", 1, partcv, params);
// compiled op node returning opresult350 (depth = 10)
  int op_slot_left_337 = gc_frame_newslot(opresult350);
  params[0] = call339;
  partcv[0] = 1;
  Object opresult351 = callmethod(opresult350, "++", 1, partcv, params);
// compiled op node returning opresult351 (depth = 9)
  int op_slot_left_334 = gc_frame_newslot(opresult351);
  params[0] = strlit335;
  partcv[0] = 1;
  Object opresult352 = callmethod(opresult351, "++", 1, partcv, params);
// compiled op node returning opresult352 (depth = 8)
  int op_slot_left_330 = gc_frame_newslot(opresult352);
  params[0] = call332;
  partcv[0] = 1;
  Object opresult353 = callmethod(opresult352, "++", 1, partcv, params);
// compiled op node returning opresult353 (depth = 7)
  int op_slot_left_327 = gc_frame_newslot(opresult353);
  params[0] = strlit328;
  partcv[0] = 1;
  Object opresult354 = callmethod(opresult353, "++", 1, partcv, params);
// compiled op node returning opresult354 (depth = 6)
  int op_slot_left_321 = gc_frame_newslot(opresult354);
  params[0] = call325;
  partcv[0] = 1;
  Object opresult355 = callmethod(opresult354, "++", 1, partcv, params);
// compiled op node returning opresult355 (depth = 5)
  int op_slot_left_318 = gc_frame_newslot(opresult355);
  params[0] = strlit319;
  partcv[0] = 1;
  Object opresult356 = callmethod(opresult355, "++", 1, partcv, params);
// compiled op node returning opresult356 (depth = 4)
    gc_frame_newslot(opresult356);
    if281 = opresult356;
  }
// compiled if node returning if281 (depth = 3)
    gc_frame_newslot(if281);
    if196 = if281;
  }
// compiled if node returning if196 (depth = 2)
  gc_frame_end(frame);
  return if196;
}
Object meth_ast__apply360(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_each (depth = 4)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_deepCopy357(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deepCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for deepCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe358 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block359 = alloc_Block(NULL, NULL, "ast", 167);
  gc_frame_newslot(block359);
// method "_apply"
  block_savedest(block359);
  Object closure360 = createclosure(1, "_apply");
  setclosureframe(closure360, stackframe);
  addtoclosure(closure360, selfslot);
  struct UserObject *uo360 = (struct UserObject*)block359;
  uo360->data[0] = (Object)closure360;
  Method *meth_meth_ast__apply360 = addmethod2pos(block359, "_apply", &meth_ast__apply360, 0);
  int argcv_meth_ast__apply360[] = {1};
  meth_meth_ast__apply360->type = alloc_MethodType(1, argcv_meth_ast__apply360);
  meth_meth_ast__apply360->definitionModule = modulename;
  meth_meth_ast__apply360->definitionLine = 163;
// compiled block node returning block359 (depth = 3)
  gc_frame_newslot(block359);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ancestorChain (depth = 5)
  partcv[0] = 0;
  Object call363 = callmethod(*var_ancestorChain, "empty",
    1, partcv, params);
  gc_frame_end(callframe362);
// compiled call node returning call363 (depth = 4)
// compiled member node returning call363 (depth = 3)
  gc_frame_newslot(call363);
// call case 4: self request
  params[0] = block359;
  params[1] = call363;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call364 = callmethodflags(self, "map()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe358);
// compiled call node returning call364 (depth = 2)
  gc_frame_end(frame);
  return call364;
}
Object meth_ast_enclosingObject365(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for enclosingObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for enclosingObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_obj = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "obj");
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe366 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe367 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe368 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call369 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe368);
// compiled call node returning call369 (depth = 8)
// compiled member node returning call369 (depth = 7)
  partcv[0] = 0;
  Object call370 = callmethod(call369, "enclosingObjectScope",
    1, partcv, params);
  gc_frame_end(callframe367);
// compiled call node returning call370 (depth = 6)
// compiled member node returning call370 (depth = 5)
  partcv[0] = 0;
  Object call371 = callmethod(call370, "node",
    1, partcv, params);
  gc_frame_end(callframe366);
// compiled call node returning call371 (depth = 4)
// compiled member node returning call371 (depth = 3)
  *var_obj = call371;
  if (call371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_obj (depth = 2)
  gc_frame_end(frame);
  return *var_obj;
}
Object meth_ast_addComment372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComment");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComment (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addComment");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool375 = alloc_Boolean(0);
// compiled identifier node returning bool375 (depth = 4)
  int op_slot_right_374 = gc_frame_newslot(bool375);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call378 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe377);
// compiled call node returning call378 (depth = 5)
// compiled member node returning call378 (depth = 4)
  int op_slot_left_374 = gc_frame_newslot(call378);
  params[0] = bool375;
  partcv[0] = 1;
  Object opresult379 = callmethod(call378, "==", 1, partcv, params);
// compiled op node returning opresult379 (depth = 3)
  Object if373 = done;
  if (istrue(opresult379)) {
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe380 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 4: self request
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call381 = callmethodflags(self, "comments:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe380);
// compiled call node returning call381 (depth = 3)
    gc_frame_newslot(call381);
    if373 = call381;
  } else {
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe382 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call384 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 5)
// compiled member node returning call384 (depth = 4)
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call385 = callmethod(call384, "extendCommentUsing",
    1, partcv, params);
  gc_frame_end(callframe382);
// compiled call node returning call385 (depth = 3)
    gc_frame_newslot(call385);
    if373 = call385;
  }
// compiled if node returning if373 (depth = 2)
  gc_frame_end(frame);
  return if373;
}
Object meth_ast__apply389(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe390 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call391 = callmethodflags(self, "addComment", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe390);
// compiled call node returning call391 (depth = 4)
  gc_frame_end(frame);
  return call391;
}
Object meth_ast_addComments386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComments");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComments (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNodeList = &(stackframe->slots[0]);
  *var_cmtNodeList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addComments");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe387 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block388 = alloc_Block(NULL, NULL, "ast", 181);
  gc_frame_newslot(block388);
// method "_apply"
  block_savedest(block388);
  Object closure389 = createclosure(1, "_apply");
  setclosureframe(closure389, stackframe);
  addtoclosure(closure389, selfslot);
  struct UserObject *uo389 = (struct UserObject*)block388;
  uo389->data[0] = (Object)closure389;
  Method *meth_meth_ast__apply389 = addmethod2pos(block388, "_apply", &meth_ast__apply389, 0);
  int argcv_meth_ast__apply389[] = {1};
  meth_meth_ast__apply389->type = alloc_MethodType(1, argcv_meth_ast__apply389);
  meth_meth_ast__apply389->definitionModule = modulename;
  meth_meth_ast__apply389->definitionLine = 177;
// compiled block node returning block388 (depth = 3)
  gc_frame_newslot(block388);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cmtNodeList (depth = 3)
  params[0] = block388;
  partcv[0] = 1;
  Object call393 = callmethod(*var_cmtNodeList, "do",
    1, partcv, params);
  gc_frame_end(callframe387);
// compiled call node returning call393 (depth = 2)
  gc_frame_end(frame);
  return call393;
}
Object meth_ast_statementName394(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call396 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe395);
// compiled call node returning call396 (depth = 3)
// compiled member node returning call396 (depth = 2)
  gc_frame_end(frame);
  return call396;
}
Object meth_ast_baseNode31(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject32 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj32 = alloc_userobj2(56,52, objclass32);
  gc_frame_newslot(obj32);
if (objclass32 == NULL) {
  glfree(obj32->class->name);
  obj32->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj32, self, 0);
  addmethodreal(obj32,"outer", &reader_ast_outer_33);
  Object oldself32 = self;
  struct StackFrameObject *oldstackframe32 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe32);
  gc_frame_newslot((Object)stackframe);
  self = obj32;
  Object *oldselfslot32 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter32 = (*(struct UserObject *)self).data[0], lowerouter32 = thisouter32;
  if (inheritingObject32) {
    struct UserObject *inho32 = (struct UserObject *)inheritingObject32;
    while (inho32->super != GraceDefaultObject) inho32 = (struct UserObject *)inho32->super;
    inho32->super = obj32;
    self = inheritingObject32;
    *selfslot = self;
    lowerouter32 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter32;
  }
if (objclass32 == NULL) {
  Method *reader34 = addmethodrealflags(obj32, "register",&reader_ast_register_34, 0);
  Method *writer34 = addmethodrealflags(obj32, "register:=",&writer_ast_register_34, 0);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 87;
  writer34->definitionLine = 87;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 1);
if (objclass32 == NULL) {
  Method *reader35 = addmethodrealflags(obj32, "line",&reader_ast_line_35, 0);
  Method *writer35 = addmethodrealflags(obj32, "line:=",&writer_ast_line_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 88;
  writer35->definitionLine = 88;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 2);
if (objclass32 == NULL) {
  Method *reader36 = addmethodrealflags(obj32, "linePos",&reader_ast_linePos_36, 0);
  Method *writer36 = addmethodrealflags(obj32, "linePos:=",&writer_ast_linePos_36, 0);
  reader36->definitionModule = modulename;
  writer36->definitionModule = modulename;
  reader36->definitionLine = 89;
  writer36->definitionLine = 89;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 3);
if (objclass32 == NULL) {
  Method *reader37 = addmethodrealflags(obj32, "symbolTable",&reader_ast_symbolTable_37, MFLAG_CONFIDENTIAL);
  Method *writer37 = addmethodrealflags(obj32, "symbolTable:=",&writer_ast_symbolTable_37, MFLAG_CONFIDENTIAL);
  reader37->definitionModule = modulename;
  writer37->definitionModule = modulename;
  reader37->definitionLine = 90;
  writer37->definitionLine = 90;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 4);
if (objclass32 == NULL) {
  Method *reader38 = addmethodrealflags(obj32, "comments",&reader_ast_comments_38, 0);
  Method *writer38 = addmethodrealflags(obj32, "comments:=",&writer_ast_comments_38, 0);
  reader38->definitionModule = modulename;
  writer38->definitionModule = modulename;
  reader38->definitionLine = 91;
  writer38->definitionLine = 91;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 5);
// method "kind"
  struct UserObject *uo39 = (struct UserObject*)obj32;
  uo39->data[6] = emptyclosure;
  Method *meth_meth_ast_kind39 = addmethod2pos(obj32, "kind", &meth_ast_kind39, 6);
  int argcv_meth_ast_kind39[] = {0};
  meth_meth_ast_kind39->type = alloc_MethodType(1, argcv_meth_ast_kind39);
  meth_meth_ast_kind39->definitionModule = modulename;
  meth_meth_ast_kind39->definitionLine = 93;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo42 = (struct UserObject*)obj32;
  uo42->data[7] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier42 = addmethod2pos(obj32, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier42, 7);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier42[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier42);
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionLine = 94;
// method "isMatchingBlock"
  struct UserObject *uo44 = (struct UserObject*)obj32;
  uo44->data[8] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock44 = addmethod2pos(obj32, "isMatchingBlock", &meth_ast_isMatchingBlock44, 8);
  int argcv_meth_ast_isMatchingBlock44[] = {0};
  meth_meth_ast_isMatchingBlock44->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock44);
  meth_meth_ast_isMatchingBlock44->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock44->definitionLine = 95;
// method "isFieldDec"
  struct UserObject *uo46 = (struct UserObject*)obj32;
  uo46->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec46 = addmethod2pos(obj32, "isFieldDec", &meth_ast_isFieldDec46, 9);
  int argcv_meth_ast_isFieldDec46[] = {0};
  meth_meth_ast_isFieldDec46->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec46);
  meth_meth_ast_isFieldDec46->definitionModule = modulename;
  meth_meth_ast_isFieldDec46->definitionLine = 96;
// method "isInherits"
  struct UserObject *uo48 = (struct UserObject*)obj32;
  uo48->data[10] = emptyclosure;
  Method *meth_meth_ast_isInherits48 = addmethod2pos(obj32, "isInherits", &meth_ast_isInherits48, 10);
  int argcv_meth_ast_isInherits48[] = {0};
  meth_meth_ast_isInherits48->type = alloc_MethodType(1, argcv_meth_ast_isInherits48);
  meth_meth_ast_isInherits48->definitionModule = modulename;
  meth_meth_ast_isInherits48->definitionLine = 97;
// method "isLegalInTrait"
  struct UserObject *uo50 = (struct UserObject*)obj32;
  uo50->data[11] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait50 = addmethod2pos(obj32, "isLegalInTrait", &meth_ast_isLegalInTrait50, 11);
  int argcv_meth_ast_isLegalInTrait50[] = {0};
  meth_meth_ast_isLegalInTrait50->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait50);
  meth_meth_ast_isLegalInTrait50->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait50->definitionLine = 98;
// method "isMember"
  struct UserObject *uo52 = (struct UserObject*)obj32;
  uo52->data[12] = emptyclosure;
  Method *meth_meth_ast_isMember52 = addmethod2pos(obj32, "isMember", &meth_ast_isMember52, 12);
  int argcv_meth_ast_isMember52[] = {0};
  meth_meth_ast_isMember52->type = alloc_MethodType(1, argcv_meth_ast_isMember52);
  meth_meth_ast_isMember52->definitionModule = modulename;
  meth_meth_ast_isMember52->definitionLine = 99;
// method "isMethod"
  struct UserObject *uo54 = (struct UserObject*)obj32;
  uo54->data[13] = emptyclosure;
  Method *meth_meth_ast_isMethod54 = addmethod2pos(obj32, "isMethod", &meth_ast_isMethod54, 13);
  int argcv_meth_ast_isMethod54[] = {0};
  meth_meth_ast_isMethod54->type = alloc_MethodType(1, argcv_meth_ast_isMethod54);
  meth_meth_ast_isMethod54->definitionModule = modulename;
  meth_meth_ast_isMethod54->definitionLine = 100;
// method "isExecutable"
  struct UserObject *uo56 = (struct UserObject*)obj32;
  uo56->data[14] = emptyclosure;
  Method *meth_meth_ast_isExecutable56 = addmethod2pos(obj32, "isExecutable", &meth_ast_isExecutable56, 14);
  int argcv_meth_ast_isExecutable56[] = {0};
  meth_meth_ast_isExecutable56->type = alloc_MethodType(1, argcv_meth_ast_isExecutable56);
  meth_meth_ast_isExecutable56->definitionModule = modulename;
  meth_meth_ast_isExecutable56->definitionLine = 101;
// method "isCall"
  struct UserObject *uo58 = (struct UserObject*)obj32;
  uo58->data[15] = emptyclosure;
  Method *meth_meth_ast_isCall58 = addmethod2pos(obj32, "isCall", &meth_ast_isCall58, 15);
  int argcv_meth_ast_isCall58[] = {0};
  meth_meth_ast_isCall58->type = alloc_MethodType(1, argcv_meth_ast_isCall58);
  meth_meth_ast_isCall58->definitionModule = modulename;
  meth_meth_ast_isCall58->definitionLine = 102;
// method "isComment"
  struct UserObject *uo60 = (struct UserObject*)obj32;
  uo60->data[16] = emptyclosure;
  Method *meth_meth_ast_isComment60 = addmethod2pos(obj32, "isComment", &meth_ast_isComment60, 16);
  int argcv_meth_ast_isComment60[] = {0};
  meth_meth_ast_isComment60->type = alloc_MethodType(1, argcv_meth_ast_isComment60);
  meth_meth_ast_isComment60->definitionModule = modulename;
  meth_meth_ast_isComment60->definitionLine = 103;
// method "isClass"
  struct UserObject *uo62 = (struct UserObject*)obj32;
  uo62->data[17] = emptyclosure;
  Method *meth_meth_ast_isClass62 = addmethod2pos(obj32, "isClass", &meth_ast_isClass62, 17);
  int argcv_meth_ast_isClass62[] = {0};
  meth_meth_ast_isClass62->type = alloc_MethodType(1, argcv_meth_ast_isClass62);
  meth_meth_ast_isClass62->definitionModule = modulename;
  meth_meth_ast_isClass62->definitionLine = 104;
// method "inClass"
  struct UserObject *uo64 = (struct UserObject*)obj32;
  uo64->data[18] = emptyclosure;
  Method *meth_meth_ast_inClass64 = addmethod2pos(obj32, "inClass", &meth_ast_inClass64, 18);
  int argcv_meth_ast_inClass64[] = {0};
  meth_meth_ast_inClass64->type = alloc_MethodType(1, argcv_meth_ast_inClass64);
  meth_meth_ast_inClass64->definitionModule = modulename;
  meth_meth_ast_inClass64->definitionLine = 105;
// method "isTrait"
  struct UserObject *uo66 = (struct UserObject*)obj32;
  uo66->data[19] = emptyclosure;
  Method *meth_meth_ast_isTrait66 = addmethod2pos(obj32, "isTrait", &meth_ast_isTrait66, 19);
  int argcv_meth_ast_isTrait66[] = {0};
  meth_meth_ast_isTrait66->type = alloc_MethodType(1, argcv_meth_ast_isTrait66);
  meth_meth_ast_isTrait66->definitionModule = modulename;
  meth_meth_ast_isTrait66->definitionLine = 106;
// method "inTrait"
  struct UserObject *uo68 = (struct UserObject*)obj32;
  uo68->data[20] = emptyclosure;
  Method *meth_meth_ast_inTrait68 = addmethod2pos(obj32, "inTrait", &meth_ast_inTrait68, 20);
  int argcv_meth_ast_inTrait68[] = {0};
  meth_meth_ast_inTrait68->type = alloc_MethodType(1, argcv_meth_ast_inTrait68);
  meth_meth_ast_inTrait68->definitionModule = modulename;
  meth_meth_ast_inTrait68->definitionLine = 107;
// method "isBind"
  struct UserObject *uo70 = (struct UserObject*)obj32;
  uo70->data[21] = emptyclosure;
  Method *meth_meth_ast_isBind70 = addmethod2pos(obj32, "isBind", &meth_ast_isBind70, 21);
  int argcv_meth_ast_isBind70[] = {0};
  meth_meth_ast_isBind70->type = alloc_MethodType(1, argcv_meth_ast_isBind70);
  meth_meth_ast_isBind70->definitionModule = modulename;
  meth_meth_ast_isBind70->definitionLine = 108;
// method "isBlock"
  struct UserObject *uo72 = (struct UserObject*)obj32;
  uo72->data[22] = emptyclosure;
  Method *meth_meth_ast_isBlock72 = addmethod2pos(obj32, "isBlock", &meth_ast_isBlock72, 22);
  int argcv_meth_ast_isBlock72[] = {0};
  meth_meth_ast_isBlock72->type = alloc_MethodType(1, argcv_meth_ast_isBlock72);
  meth_meth_ast_isBlock72->definitionModule = modulename;
  meth_meth_ast_isBlock72->definitionLine = 109;
// method "isObject"
  struct UserObject *uo74 = (struct UserObject*)obj32;
  uo74->data[23] = emptyclosure;
  Method *meth_meth_ast_isObject74 = addmethod2pos(obj32, "isObject", &meth_ast_isObject74, 23);
  int argcv_meth_ast_isObject74[] = {0};
  meth_meth_ast_isObject74->type = alloc_MethodType(1, argcv_meth_ast_isObject74);
  meth_meth_ast_isObject74->definitionModule = modulename;
  meth_meth_ast_isObject74->definitionLine = 110;
// method "isIdentifier"
  struct UserObject *uo76 = (struct UserObject*)obj32;
  uo76->data[24] = emptyclosure;
  Method *meth_meth_ast_isIdentifier76 = addmethod2pos(obj32, "isIdentifier", &meth_ast_isIdentifier76, 24);
  int argcv_meth_ast_isIdentifier76[] = {0};
  meth_meth_ast_isIdentifier76->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier76);
  meth_meth_ast_isIdentifier76->definitionModule = modulename;
  meth_meth_ast_isIdentifier76->definitionLine = 111;
// method "isDialect"
  struct UserObject *uo78 = (struct UserObject*)obj32;
  uo78->data[25] = emptyclosure;
  Method *meth_meth_ast_isDialect78 = addmethod2pos(obj32, "isDialect", &meth_ast_isDialect78, 25);
  int argcv_meth_ast_isDialect78[] = {0};
  meth_meth_ast_isDialect78->type = alloc_MethodType(1, argcv_meth_ast_isDialect78);
  meth_meth_ast_isDialect78->definitionModule = modulename;
  meth_meth_ast_isDialect78->definitionLine = 112;
// method "isImport"
  struct UserObject *uo80 = (struct UserObject*)obj32;
  uo80->data[26] = emptyclosure;
  Method *meth_meth_ast_isImport80 = addmethod2pos(obj32, "isImport", &meth_ast_isImport80, 26);
  int argcv_meth_ast_isImport80[] = {0};
  meth_meth_ast_isImport80->type = alloc_MethodType(1, argcv_meth_ast_isImport80);
  meth_meth_ast_isImport80->definitionModule = modulename;
  meth_meth_ast_isImport80->definitionLine = 113;
// method "isTypeDec"
  struct UserObject *uo82 = (struct UserObject*)obj32;
  uo82->data[27] = emptyclosure;
  Method *meth_meth_ast_isTypeDec82 = addmethod2pos(obj32, "isTypeDec", &meth_ast_isTypeDec82, 27);
  int argcv_meth_ast_isTypeDec82[] = {0};
  meth_meth_ast_isTypeDec82->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec82);
  meth_meth_ast_isTypeDec82->definitionModule = modulename;
  meth_meth_ast_isTypeDec82->definitionLine = 114;
// method "isExternal"
  struct UserObject *uo84 = (struct UserObject*)obj32;
  uo84->data[28] = emptyclosure;
  Method *meth_meth_ast_isExternal84 = addmethod2pos(obj32, "isExternal", &meth_ast_isExternal84, 28);
  int argcv_meth_ast_isExternal84[] = {0};
  meth_meth_ast_isExternal84->type = alloc_MethodType(1, argcv_meth_ast_isExternal84);
  meth_meth_ast_isExternal84->definitionModule = modulename;
  meth_meth_ast_isExternal84->definitionLine = 115;
// method "canInherit"
  struct UserObject *uo86 = (struct UserObject*)obj32;
  uo86->data[29] = emptyclosure;
  Method *meth_meth_ast_canInherit86 = addmethod2pos(obj32, "canInherit", &meth_ast_canInherit86, 29);
  int argcv_meth_ast_canInherit86[] = {0};
  meth_meth_ast_canInherit86->type = alloc_MethodType(1, argcv_meth_ast_canInherit86);
  meth_meth_ast_canInherit86->definitionModule = modulename;
  meth_meth_ast_canInherit86->definitionLine = 116;
// method "returnsObject"
  struct UserObject *uo88 = (struct UserObject*)obj32;
  uo88->data[30] = emptyclosure;
  Method *meth_meth_ast_returnsObject88 = addmethod2pos(obj32, "returnsObject", &meth_ast_returnsObject88, 30);
  int argcv_meth_ast_returnsObject88[] = {0};
  meth_meth_ast_returnsObject88->type = alloc_MethodType(1, argcv_meth_ast_returnsObject88);
  meth_meth_ast_returnsObject88->definitionModule = modulename;
  meth_meth_ast_returnsObject88->definitionLine = 117;
// method "usesAsType"
  struct UserObject *uo90 = (struct UserObject*)obj32;
  uo90->data[31] = emptyclosure;
  Method *meth_meth_ast_usesAsType90 = addmethod2pos(obj32, "usesAsType", &meth_ast_usesAsType90, 31);
  int argcv_meth_ast_usesAsType90[] = {1};
  meth_meth_ast_usesAsType90->type = alloc_MethodType(1, argcv_meth_ast_usesAsType90);
  meth_meth_ast_usesAsType90->definitionModule = modulename;
  meth_meth_ast_usesAsType90->definitionLine = 118;
// method "hash"
  struct UserObject *uo92 = (struct UserObject*)obj32;
  uo92->data[32] = emptyclosure;
  Method *meth_meth_ast_hash92 = addmethod2pos(obj32, "hash", &meth_ast_hash92, 32);
  int argcv_meth_ast_hash92[] = {0};
  meth_meth_ast_hash92->type = alloc_MethodType(1, argcv_meth_ast_hash92);
  meth_meth_ast_hash92->definitionModule = modulename;
  meth_meth_ast_hash92->definitionLine = 119;
// method "asString"
  struct UserObject *uo104 = (struct UserObject*)obj32;
  uo104->data[33] = emptyclosure;
  Method *meth_meth_ast_asString104 = addmethod2pos(obj32, "asString", &meth_ast_asString104, 33);
  int argcv_meth_ast_asString104[] = {0};
  meth_meth_ast_asString104->type = alloc_MethodType(1, argcv_meth_ast_asString104);
  meth_meth_ast_asString104->definitionModule = modulename;
  meth_meth_ast_asString104->definitionLine = 120;
// method "nameString"
  struct UserObject *uo124 = (struct UserObject*)obj32;
  uo124->data[34] = emptyclosure;
  Method *meth_meth_ast_nameString124 = addmethod2pos(obj32, "nameString", &meth_ast_nameString124, 34);
  int argcv_meth_ast_nameString124[] = {0};
  meth_meth_ast_nameString124->type = alloc_MethodType(1, argcv_meth_ast_nameString124);
  meth_meth_ast_nameString124->definitionModule = modulename;
  meth_meth_ast_nameString124->definitionLine = 121;
// method "isWritable"
  struct UserObject *uo126 = (struct UserObject*)obj32;
  uo126->data[35] = emptyclosure;
  Method *meth_meth_ast_isWritable126 = addmethod2pos(obj32, "isWritable", &meth_ast_isWritable126, 35);
  int argcv_meth_ast_isWritable126[] = {0};
  meth_meth_ast_isWritable126->type = alloc_MethodType(1, argcv_meth_ast_isWritable126);
  meth_meth_ast_isWritable126->definitionModule = modulename;
  meth_meth_ast_isWritable126->definitionLine = 122;
// method "isReadable"
  struct UserObject *uo128 = (struct UserObject*)obj32;
  uo128->data[36] = emptyclosure;
  Method *meth_meth_ast_isReadable128 = addmethod2pos(obj32, "isReadable", &meth_ast_isReadable128, 36);
  int argcv_meth_ast_isReadable128[] = {0};
  meth_meth_ast_isReadable128->type = alloc_MethodType(1, argcv_meth_ast_isReadable128);
  meth_meth_ast_isReadable128->definitionModule = modulename;
  meth_meth_ast_isReadable128->definitionLine = 123;
// method "isPublic"
  struct UserObject *uo130 = (struct UserObject*)obj32;
  uo130->data[37] = emptyclosure;
  Method *meth_meth_ast_isPublic130 = addmethod2pos(obj32, "isPublic", &meth_ast_isPublic130, 37);
  int argcv_meth_ast_isPublic130[] = {0};
  meth_meth_ast_isPublic130->type = alloc_MethodType(1, argcv_meth_ast_isPublic130);
  meth_meth_ast_isPublic130->definitionModule = modulename;
  meth_meth_ast_isPublic130->definitionLine = 124;
// method "isConfidential"
  struct UserObject *uo132 = (struct UserObject*)obj32;
  uo132->data[38] = emptyclosure;
  Method *meth_meth_ast_isConfidential132 = addmethod2pos(obj32, "isConfidential", &meth_ast_isConfidential132, 38);
  int argcv_meth_ast_isConfidential132[] = {0};
  meth_meth_ast_isConfidential132->type = alloc_MethodType(1, argcv_meth_ast_isConfidential132);
  meth_meth_ast_isConfidential132->definitionModule = modulename;
  meth_meth_ast_isConfidential132->definitionLine = 125;
// method "decType"
  block_savedest(obj32);
  Object closure137 = createclosure(1, "decType");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_unknownType);
  struct UserObject *uo137 = (struct UserObject*)obj32;
  uo137->data[39] = (Object)closure137;
  Method *meth_meth_ast_decType137 = addmethod2pos(obj32, "decType", &meth_ast_decType137, 39);
  int argcv_meth_ast_decType137[] = {0};
  meth_meth_ast_decType137->type = alloc_MethodType(1, argcv_meth_ast_decType137);
  meth_meth_ast_decType137->definitionModule = modulename;
  meth_meth_ast_decType137->definitionLine = 126;
// method "isSimple"
  struct UserObject *uo147 = (struct UserObject*)obj32;
  uo147->data[40] = emptyclosure;
  Method *meth_meth_ast_isSimple147 = addmethod2pos(obj32, "isSimple", &meth_ast_isSimple147, 40);
  int argcv_meth_ast_isSimple147[] = {0};
  meth_meth_ast_isSimple147->type = alloc_MethodType(1, argcv_meth_ast_isSimple147);
  meth_meth_ast_isSimple147->definitionModule = modulename;
  meth_meth_ast_isSimple147->definitionLine = 132;
// method "description"
  struct UserObject *uo149 = (struct UserObject*)obj32;
  uo149->data[41] = emptyclosure;
  Method *meth_meth_ast_description149 = addmethod2pos(obj32, "description", &meth_ast_description149, 41);
  int argcv_meth_ast_description149[] = {0};
  meth_meth_ast_description149->type = alloc_MethodType(1, argcv_meth_ast_description149);
  meth_meth_ast_description149->definitionModule = modulename;
  meth_meth_ast_description149->definitionLine = 133;
// method "accept"
  block_savedest(obj32);
  Object closure152 = createclosure(1, "accept");
  setclosureframe(closure152, stackframe);
  addtoclosure(closure152, var_ancestorChain);
  struct UserObject *uo152 = (struct UserObject*)obj32;
  uo152->data[42] = (Object)closure152;
  Method *meth_meth_ast_accept152 = addmethod2pos(obj32, "accept", &meth_ast_accept152, 42);
  int argcv_meth_ast_accept152[] = {1};
  meth_meth_ast_accept152->type = alloc_MethodType(1, argcv_meth_ast_accept152);
  meth_meth_ast_accept152->definitionModule = modulename;
  meth_meth_ast_accept152->definitionLine = 134;
// method "scope"
  struct UserObject *uo157 = (struct UserObject*)obj32;
  uo157->data[43] = emptyclosure;
  Method *meth_meth_ast_scope157 = addmethod2pos(obj32, "scope", &meth_ast_scope157, 43);
  int argcv_meth_ast_scope157[] = {0};
  meth_meth_ast_scope157->type = alloc_MethodType(1, argcv_meth_ast_scope157);
  meth_meth_ast_scope157->definitionModule = modulename;
  meth_meth_ast_scope157->definitionLine = 137;
// method "scope:="
  struct UserObject *uo160 = (struct UserObject*)obj32;
  uo160->data[44] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_160 = addmethod2pos(obj32, "scope:=", &meth_ast_scope_58__61_160, 44);
  int argcv_meth_ast_scope_58__61_160[] = {1};
  meth_meth_ast_scope_58__61_160->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_160);
  meth_meth_ast_scope_58__61_160->definitionModule = modulename;
  meth_meth_ast_scope_58__61_160->definitionLine = 139;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo163 = (struct UserObject*)obj32;
  uo163->data[45] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom163 = addmethod2pos(obj32, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom163, 45);
  int argcv_meth_ast_shallowCopyFieldsFrom163[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom163->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom163);
  meth_meth_ast_shallowCopyFieldsFrom163->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom163->definitionLine = 146;
// method "pretty"
  block_savedest(obj32);
  Object closure180 = createclosure(1, "pretty");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_util);
  struct UserObject *uo180 = (struct UserObject*)obj32;
  uo180->data[46] = (Object)closure180;
  Method *meth_meth_ast_pretty180 = addmethod2pos(obj32, "pretty", &meth_ast_pretty180, 46);
  int argcv_meth_ast_pretty180[] = {1};
  meth_meth_ast_pretty180->type = alloc_MethodType(1, argcv_meth_ast_pretty180);
  meth_meth_ast_pretty180->definitionModule = modulename;
  meth_meth_ast_pretty180->definitionLine = 153;
// method "deepCopy"
  block_savedest(obj32);
  Object closure357 = createclosure(1, "deepCopy");
  setclosureframe(closure357, stackframe);
  addtoclosure(closure357, var_ancestorChain);
  struct UserObject *uo357 = (struct UserObject*)obj32;
  uo357->data[47] = (Object)closure357;
  Method *meth_meth_ast_deepCopy357 = addmethod2pos(obj32, "deepCopy", &meth_ast_deepCopy357, 47);
  int argcv_meth_ast_deepCopy357[] = {0};
  meth_meth_ast_deepCopy357->type = alloc_MethodType(1, argcv_meth_ast_deepCopy357);
  meth_meth_ast_deepCopy357->definitionModule = modulename;
  meth_meth_ast_deepCopy357->definitionLine = 166;
// method "enclosingObject"
  struct UserObject *uo365 = (struct UserObject*)obj32;
  uo365->data[48] = emptyclosure;
  Method *meth_meth_ast_enclosingObject365 = addmethod2pos(obj32, "enclosingObject", &meth_ast_enclosingObject365, 48);
  int argcv_meth_ast_enclosingObject365[] = {0};
  meth_meth_ast_enclosingObject365->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject365);
  meth_meth_ast_enclosingObject365->definitionModule = modulename;
  meth_meth_ast_enclosingObject365->definitionLine = 169;
// method "addComment"
  struct UserObject *uo372 = (struct UserObject*)obj32;
  uo372->data[49] = emptyclosure;
  Method *meth_meth_ast_addComment372 = addmethod2pos(obj32, "addComment", &meth_ast_addComment372, 49);
  int argcv_meth_ast_addComment372[] = {1};
  meth_meth_ast_addComment372->type = alloc_MethodType(1, argcv_meth_ast_addComment372);
  meth_meth_ast_addComment372->definitionModule = modulename;
  meth_meth_ast_addComment372->definitionLine = 173;
// method "addComments"
  struct UserObject *uo386 = (struct UserObject*)obj32;
  uo386->data[50] = emptyclosure;
  Method *meth_meth_ast_addComments386 = addmethod2pos(obj32, "addComments", &meth_ast_addComments386, 50);
  int argcv_meth_ast_addComments386[] = {1};
  meth_meth_ast_addComments386->type = alloc_MethodType(1, argcv_meth_ast_addComments386);
  meth_meth_ast_addComments386->definitionModule = modulename;
  meth_meth_ast_addComments386->definitionLine = 180;
// method "statementName"
  struct UserObject *uo394 = (struct UserObject*)obj32;
  uo394->data[51] = emptyclosure;
  Method *meth_meth_ast_statementName394 = addmethod2pos(obj32, "statementName", &meth_ast_statementName394, 51);
  int argcv_meth_ast_statementName394[] = {0};
  meth_meth_ast_statementName394->type = alloc_MethodType(1, argcv_meth_ast_statementName394);
  meth_meth_ast_statementName394->definitionModule = modulename;
  meth_meth_ast_statementName394->definitionLine = 183;
  sourceObject = obj32;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 2)
  adddatum2(obj32, strlit397, 1);
  sourceObject = obj32;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call399 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe398);
// compiled call node returning call399 (depth = 3)
// compiled member node returning call399 (depth = 2)
  adddatum2(obj32, call399, 2);
  sourceObject = obj32;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe400 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call401 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe400);
// compiled call node returning call401 (depth = 3)
// compiled member node returning call401 (depth = 2)
  adddatum2(obj32, call401, 3);
  sourceObject = obj32;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj32, *var_fakeSymbolTable, 4);
  sourceObject = obj32;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool402 = alloc_Boolean(0);
// compiled identifier node returning bool402 (depth = 2)
  adddatum2(obj32, bool402, 5);
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  objclass32 = obj32->class;
  objclass32->definitionModule = modulename;
  objclass32->definitionLine = 85;
  (*(struct UserObject *)self).data[0] = lowerouter32;
  self = oldself32;
  selfslot = oldselfslot32;
  stackframe = oldstackframe32;
  gc_frame_end(frame);
  return obj32;
}
Object meth_ast_baseNode31_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject32 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj32 = alloc_userobj2(56,52, objclass32);
  gc_frame_newslot(obj32);
if (objclass32 == NULL) {
  glfree(obj32->class->name);
  obj32->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj32, self, 0);
  addmethodreal(obj32,"outer", &reader_ast_outer_33);
  Object oldself32 = self;
  struct StackFrameObject *oldstackframe32 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe32);
  gc_frame_newslot((Object)stackframe);
  self = obj32;
  Object *oldselfslot32 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter32 = (*(struct UserObject *)self).data[0], lowerouter32 = thisouter32;
  if (inheritingObject32) {
    struct UserObject *inho32 = (struct UserObject *)inheritingObject32;
    while (inho32->super != GraceDefaultObject) inho32 = (struct UserObject *)inho32->super;
    inho32->super = obj32;
    self = inheritingObject32;
    *selfslot = self;
    lowerouter32 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter32;
  }
if (objclass32 == NULL) {
  Method *reader34 = addmethodrealflags(obj32, "register",&reader_ast_register_34, 0);
  Method *writer34 = addmethodrealflags(obj32, "register:=",&writer_ast_register_34, 0);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 87;
  writer34->definitionLine = 87;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 1);
if (objclass32 == NULL) {
  Method *reader35 = addmethodrealflags(obj32, "line",&reader_ast_line_35, 0);
  Method *writer35 = addmethodrealflags(obj32, "line:=",&writer_ast_line_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 88;
  writer35->definitionLine = 88;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 2);
if (objclass32 == NULL) {
  Method *reader36 = addmethodrealflags(obj32, "linePos",&reader_ast_linePos_36, 0);
  Method *writer36 = addmethodrealflags(obj32, "linePos:=",&writer_ast_linePos_36, 0);
  reader36->definitionModule = modulename;
  writer36->definitionModule = modulename;
  reader36->definitionLine = 89;
  writer36->definitionLine = 89;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 3);
if (objclass32 == NULL) {
  Method *reader37 = addmethodrealflags(obj32, "symbolTable",&reader_ast_symbolTable_37, MFLAG_CONFIDENTIAL);
  Method *writer37 = addmethodrealflags(obj32, "symbolTable:=",&writer_ast_symbolTable_37, MFLAG_CONFIDENTIAL);
  reader37->definitionModule = modulename;
  writer37->definitionModule = modulename;
  reader37->definitionLine = 90;
  writer37->definitionLine = 90;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 4);
if (objclass32 == NULL) {
  Method *reader38 = addmethodrealflags(obj32, "comments",&reader_ast_comments_38, 0);
  Method *writer38 = addmethodrealflags(obj32, "comments:=",&writer_ast_comments_38, 0);
  reader38->definitionModule = modulename;
  writer38->definitionModule = modulename;
  reader38->definitionLine = 91;
  writer38->definitionLine = 91;
}
obj32->flags |= OFLAG_MUTABLE;
adddatum2(obj32, alloc_Undefined(), 5);
// method "kind"
  struct UserObject *uo39 = (struct UserObject*)obj32;
  uo39->data[6] = emptyclosure;
  Method *meth_meth_ast_kind39 = addmethod2pos(obj32, "kind", &meth_ast_kind39, 6);
  int argcv_meth_ast_kind39[] = {0};
  meth_meth_ast_kind39->type = alloc_MethodType(1, argcv_meth_ast_kind39);
  meth_meth_ast_kind39->definitionModule = modulename;
  meth_meth_ast_kind39->definitionLine = 93;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo42 = (struct UserObject*)obj32;
  uo42->data[7] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier42 = addmethod2pos(obj32, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier42, 7);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier42[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier42);
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionLine = 94;
// method "isMatchingBlock"
  struct UserObject *uo44 = (struct UserObject*)obj32;
  uo44->data[8] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock44 = addmethod2pos(obj32, "isMatchingBlock", &meth_ast_isMatchingBlock44, 8);
  int argcv_meth_ast_isMatchingBlock44[] = {0};
  meth_meth_ast_isMatchingBlock44->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock44);
  meth_meth_ast_isMatchingBlock44->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock44->definitionLine = 95;
// method "isFieldDec"
  struct UserObject *uo46 = (struct UserObject*)obj32;
  uo46->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec46 = addmethod2pos(obj32, "isFieldDec", &meth_ast_isFieldDec46, 9);
  int argcv_meth_ast_isFieldDec46[] = {0};
  meth_meth_ast_isFieldDec46->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec46);
  meth_meth_ast_isFieldDec46->definitionModule = modulename;
  meth_meth_ast_isFieldDec46->definitionLine = 96;
// method "isInherits"
  struct UserObject *uo48 = (struct UserObject*)obj32;
  uo48->data[10] = emptyclosure;
  Method *meth_meth_ast_isInherits48 = addmethod2pos(obj32, "isInherits", &meth_ast_isInherits48, 10);
  int argcv_meth_ast_isInherits48[] = {0};
  meth_meth_ast_isInherits48->type = alloc_MethodType(1, argcv_meth_ast_isInherits48);
  meth_meth_ast_isInherits48->definitionModule = modulename;
  meth_meth_ast_isInherits48->definitionLine = 97;
// method "isLegalInTrait"
  struct UserObject *uo50 = (struct UserObject*)obj32;
  uo50->data[11] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait50 = addmethod2pos(obj32, "isLegalInTrait", &meth_ast_isLegalInTrait50, 11);
  int argcv_meth_ast_isLegalInTrait50[] = {0};
  meth_meth_ast_isLegalInTrait50->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait50);
  meth_meth_ast_isLegalInTrait50->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait50->definitionLine = 98;
// method "isMember"
  struct UserObject *uo52 = (struct UserObject*)obj32;
  uo52->data[12] = emptyclosure;
  Method *meth_meth_ast_isMember52 = addmethod2pos(obj32, "isMember", &meth_ast_isMember52, 12);
  int argcv_meth_ast_isMember52[] = {0};
  meth_meth_ast_isMember52->type = alloc_MethodType(1, argcv_meth_ast_isMember52);
  meth_meth_ast_isMember52->definitionModule = modulename;
  meth_meth_ast_isMember52->definitionLine = 99;
// method "isMethod"
  struct UserObject *uo54 = (struct UserObject*)obj32;
  uo54->data[13] = emptyclosure;
  Method *meth_meth_ast_isMethod54 = addmethod2pos(obj32, "isMethod", &meth_ast_isMethod54, 13);
  int argcv_meth_ast_isMethod54[] = {0};
  meth_meth_ast_isMethod54->type = alloc_MethodType(1, argcv_meth_ast_isMethod54);
  meth_meth_ast_isMethod54->definitionModule = modulename;
  meth_meth_ast_isMethod54->definitionLine = 100;
// method "isExecutable"
  struct UserObject *uo56 = (struct UserObject*)obj32;
  uo56->data[14] = emptyclosure;
  Method *meth_meth_ast_isExecutable56 = addmethod2pos(obj32, "isExecutable", &meth_ast_isExecutable56, 14);
  int argcv_meth_ast_isExecutable56[] = {0};
  meth_meth_ast_isExecutable56->type = alloc_MethodType(1, argcv_meth_ast_isExecutable56);
  meth_meth_ast_isExecutable56->definitionModule = modulename;
  meth_meth_ast_isExecutable56->definitionLine = 101;
// method "isCall"
  struct UserObject *uo58 = (struct UserObject*)obj32;
  uo58->data[15] = emptyclosure;
  Method *meth_meth_ast_isCall58 = addmethod2pos(obj32, "isCall", &meth_ast_isCall58, 15);
  int argcv_meth_ast_isCall58[] = {0};
  meth_meth_ast_isCall58->type = alloc_MethodType(1, argcv_meth_ast_isCall58);
  meth_meth_ast_isCall58->definitionModule = modulename;
  meth_meth_ast_isCall58->definitionLine = 102;
// method "isComment"
  struct UserObject *uo60 = (struct UserObject*)obj32;
  uo60->data[16] = emptyclosure;
  Method *meth_meth_ast_isComment60 = addmethod2pos(obj32, "isComment", &meth_ast_isComment60, 16);
  int argcv_meth_ast_isComment60[] = {0};
  meth_meth_ast_isComment60->type = alloc_MethodType(1, argcv_meth_ast_isComment60);
  meth_meth_ast_isComment60->definitionModule = modulename;
  meth_meth_ast_isComment60->definitionLine = 103;
// method "isClass"
  struct UserObject *uo62 = (struct UserObject*)obj32;
  uo62->data[17] = emptyclosure;
  Method *meth_meth_ast_isClass62 = addmethod2pos(obj32, "isClass", &meth_ast_isClass62, 17);
  int argcv_meth_ast_isClass62[] = {0};
  meth_meth_ast_isClass62->type = alloc_MethodType(1, argcv_meth_ast_isClass62);
  meth_meth_ast_isClass62->definitionModule = modulename;
  meth_meth_ast_isClass62->definitionLine = 104;
// method "inClass"
  struct UserObject *uo64 = (struct UserObject*)obj32;
  uo64->data[18] = emptyclosure;
  Method *meth_meth_ast_inClass64 = addmethod2pos(obj32, "inClass", &meth_ast_inClass64, 18);
  int argcv_meth_ast_inClass64[] = {0};
  meth_meth_ast_inClass64->type = alloc_MethodType(1, argcv_meth_ast_inClass64);
  meth_meth_ast_inClass64->definitionModule = modulename;
  meth_meth_ast_inClass64->definitionLine = 105;
// method "isTrait"
  struct UserObject *uo66 = (struct UserObject*)obj32;
  uo66->data[19] = emptyclosure;
  Method *meth_meth_ast_isTrait66 = addmethod2pos(obj32, "isTrait", &meth_ast_isTrait66, 19);
  int argcv_meth_ast_isTrait66[] = {0};
  meth_meth_ast_isTrait66->type = alloc_MethodType(1, argcv_meth_ast_isTrait66);
  meth_meth_ast_isTrait66->definitionModule = modulename;
  meth_meth_ast_isTrait66->definitionLine = 106;
// method "inTrait"
  struct UserObject *uo68 = (struct UserObject*)obj32;
  uo68->data[20] = emptyclosure;
  Method *meth_meth_ast_inTrait68 = addmethod2pos(obj32, "inTrait", &meth_ast_inTrait68, 20);
  int argcv_meth_ast_inTrait68[] = {0};
  meth_meth_ast_inTrait68->type = alloc_MethodType(1, argcv_meth_ast_inTrait68);
  meth_meth_ast_inTrait68->definitionModule = modulename;
  meth_meth_ast_inTrait68->definitionLine = 107;
// method "isBind"
  struct UserObject *uo70 = (struct UserObject*)obj32;
  uo70->data[21] = emptyclosure;
  Method *meth_meth_ast_isBind70 = addmethod2pos(obj32, "isBind", &meth_ast_isBind70, 21);
  int argcv_meth_ast_isBind70[] = {0};
  meth_meth_ast_isBind70->type = alloc_MethodType(1, argcv_meth_ast_isBind70);
  meth_meth_ast_isBind70->definitionModule = modulename;
  meth_meth_ast_isBind70->definitionLine = 108;
// method "isBlock"
  struct UserObject *uo72 = (struct UserObject*)obj32;
  uo72->data[22] = emptyclosure;
  Method *meth_meth_ast_isBlock72 = addmethod2pos(obj32, "isBlock", &meth_ast_isBlock72, 22);
  int argcv_meth_ast_isBlock72[] = {0};
  meth_meth_ast_isBlock72->type = alloc_MethodType(1, argcv_meth_ast_isBlock72);
  meth_meth_ast_isBlock72->definitionModule = modulename;
  meth_meth_ast_isBlock72->definitionLine = 109;
// method "isObject"
  struct UserObject *uo74 = (struct UserObject*)obj32;
  uo74->data[23] = emptyclosure;
  Method *meth_meth_ast_isObject74 = addmethod2pos(obj32, "isObject", &meth_ast_isObject74, 23);
  int argcv_meth_ast_isObject74[] = {0};
  meth_meth_ast_isObject74->type = alloc_MethodType(1, argcv_meth_ast_isObject74);
  meth_meth_ast_isObject74->definitionModule = modulename;
  meth_meth_ast_isObject74->definitionLine = 110;
// method "isIdentifier"
  struct UserObject *uo76 = (struct UserObject*)obj32;
  uo76->data[24] = emptyclosure;
  Method *meth_meth_ast_isIdentifier76 = addmethod2pos(obj32, "isIdentifier", &meth_ast_isIdentifier76, 24);
  int argcv_meth_ast_isIdentifier76[] = {0};
  meth_meth_ast_isIdentifier76->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier76);
  meth_meth_ast_isIdentifier76->definitionModule = modulename;
  meth_meth_ast_isIdentifier76->definitionLine = 111;
// method "isDialect"
  struct UserObject *uo78 = (struct UserObject*)obj32;
  uo78->data[25] = emptyclosure;
  Method *meth_meth_ast_isDialect78 = addmethod2pos(obj32, "isDialect", &meth_ast_isDialect78, 25);
  int argcv_meth_ast_isDialect78[] = {0};
  meth_meth_ast_isDialect78->type = alloc_MethodType(1, argcv_meth_ast_isDialect78);
  meth_meth_ast_isDialect78->definitionModule = modulename;
  meth_meth_ast_isDialect78->definitionLine = 112;
// method "isImport"
  struct UserObject *uo80 = (struct UserObject*)obj32;
  uo80->data[26] = emptyclosure;
  Method *meth_meth_ast_isImport80 = addmethod2pos(obj32, "isImport", &meth_ast_isImport80, 26);
  int argcv_meth_ast_isImport80[] = {0};
  meth_meth_ast_isImport80->type = alloc_MethodType(1, argcv_meth_ast_isImport80);
  meth_meth_ast_isImport80->definitionModule = modulename;
  meth_meth_ast_isImport80->definitionLine = 113;
// method "isTypeDec"
  struct UserObject *uo82 = (struct UserObject*)obj32;
  uo82->data[27] = emptyclosure;
  Method *meth_meth_ast_isTypeDec82 = addmethod2pos(obj32, "isTypeDec", &meth_ast_isTypeDec82, 27);
  int argcv_meth_ast_isTypeDec82[] = {0};
  meth_meth_ast_isTypeDec82->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec82);
  meth_meth_ast_isTypeDec82->definitionModule = modulename;
  meth_meth_ast_isTypeDec82->definitionLine = 114;
// method "isExternal"
  struct UserObject *uo84 = (struct UserObject*)obj32;
  uo84->data[28] = emptyclosure;
  Method *meth_meth_ast_isExternal84 = addmethod2pos(obj32, "isExternal", &meth_ast_isExternal84, 28);
  int argcv_meth_ast_isExternal84[] = {0};
  meth_meth_ast_isExternal84->type = alloc_MethodType(1, argcv_meth_ast_isExternal84);
  meth_meth_ast_isExternal84->definitionModule = modulename;
  meth_meth_ast_isExternal84->definitionLine = 115;
// method "canInherit"
  struct UserObject *uo86 = (struct UserObject*)obj32;
  uo86->data[29] = emptyclosure;
  Method *meth_meth_ast_canInherit86 = addmethod2pos(obj32, "canInherit", &meth_ast_canInherit86, 29);
  int argcv_meth_ast_canInherit86[] = {0};
  meth_meth_ast_canInherit86->type = alloc_MethodType(1, argcv_meth_ast_canInherit86);
  meth_meth_ast_canInherit86->definitionModule = modulename;
  meth_meth_ast_canInherit86->definitionLine = 116;
// method "returnsObject"
  struct UserObject *uo88 = (struct UserObject*)obj32;
  uo88->data[30] = emptyclosure;
  Method *meth_meth_ast_returnsObject88 = addmethod2pos(obj32, "returnsObject", &meth_ast_returnsObject88, 30);
  int argcv_meth_ast_returnsObject88[] = {0};
  meth_meth_ast_returnsObject88->type = alloc_MethodType(1, argcv_meth_ast_returnsObject88);
  meth_meth_ast_returnsObject88->definitionModule = modulename;
  meth_meth_ast_returnsObject88->definitionLine = 117;
// method "usesAsType"
  struct UserObject *uo90 = (struct UserObject*)obj32;
  uo90->data[31] = emptyclosure;
  Method *meth_meth_ast_usesAsType90 = addmethod2pos(obj32, "usesAsType", &meth_ast_usesAsType90, 31);
  int argcv_meth_ast_usesAsType90[] = {1};
  meth_meth_ast_usesAsType90->type = alloc_MethodType(1, argcv_meth_ast_usesAsType90);
  meth_meth_ast_usesAsType90->definitionModule = modulename;
  meth_meth_ast_usesAsType90->definitionLine = 118;
// method "hash"
  struct UserObject *uo92 = (struct UserObject*)obj32;
  uo92->data[32] = emptyclosure;
  Method *meth_meth_ast_hash92 = addmethod2pos(obj32, "hash", &meth_ast_hash92, 32);
  int argcv_meth_ast_hash92[] = {0};
  meth_meth_ast_hash92->type = alloc_MethodType(1, argcv_meth_ast_hash92);
  meth_meth_ast_hash92->definitionModule = modulename;
  meth_meth_ast_hash92->definitionLine = 119;
// method "asString"
  struct UserObject *uo104 = (struct UserObject*)obj32;
  uo104->data[33] = emptyclosure;
  Method *meth_meth_ast_asString104 = addmethod2pos(obj32, "asString", &meth_ast_asString104, 33);
  int argcv_meth_ast_asString104[] = {0};
  meth_meth_ast_asString104->type = alloc_MethodType(1, argcv_meth_ast_asString104);
  meth_meth_ast_asString104->definitionModule = modulename;
  meth_meth_ast_asString104->definitionLine = 120;
// method "nameString"
  struct UserObject *uo124 = (struct UserObject*)obj32;
  uo124->data[34] = emptyclosure;
  Method *meth_meth_ast_nameString124 = addmethod2pos(obj32, "nameString", &meth_ast_nameString124, 34);
  int argcv_meth_ast_nameString124[] = {0};
  meth_meth_ast_nameString124->type = alloc_MethodType(1, argcv_meth_ast_nameString124);
  meth_meth_ast_nameString124->definitionModule = modulename;
  meth_meth_ast_nameString124->definitionLine = 121;
// method "isWritable"
  struct UserObject *uo126 = (struct UserObject*)obj32;
  uo126->data[35] = emptyclosure;
  Method *meth_meth_ast_isWritable126 = addmethod2pos(obj32, "isWritable", &meth_ast_isWritable126, 35);
  int argcv_meth_ast_isWritable126[] = {0};
  meth_meth_ast_isWritable126->type = alloc_MethodType(1, argcv_meth_ast_isWritable126);
  meth_meth_ast_isWritable126->definitionModule = modulename;
  meth_meth_ast_isWritable126->definitionLine = 122;
// method "isReadable"
  struct UserObject *uo128 = (struct UserObject*)obj32;
  uo128->data[36] = emptyclosure;
  Method *meth_meth_ast_isReadable128 = addmethod2pos(obj32, "isReadable", &meth_ast_isReadable128, 36);
  int argcv_meth_ast_isReadable128[] = {0};
  meth_meth_ast_isReadable128->type = alloc_MethodType(1, argcv_meth_ast_isReadable128);
  meth_meth_ast_isReadable128->definitionModule = modulename;
  meth_meth_ast_isReadable128->definitionLine = 123;
// method "isPublic"
  struct UserObject *uo130 = (struct UserObject*)obj32;
  uo130->data[37] = emptyclosure;
  Method *meth_meth_ast_isPublic130 = addmethod2pos(obj32, "isPublic", &meth_ast_isPublic130, 37);
  int argcv_meth_ast_isPublic130[] = {0};
  meth_meth_ast_isPublic130->type = alloc_MethodType(1, argcv_meth_ast_isPublic130);
  meth_meth_ast_isPublic130->definitionModule = modulename;
  meth_meth_ast_isPublic130->definitionLine = 124;
// method "isConfidential"
  struct UserObject *uo132 = (struct UserObject*)obj32;
  uo132->data[38] = emptyclosure;
  Method *meth_meth_ast_isConfidential132 = addmethod2pos(obj32, "isConfidential", &meth_ast_isConfidential132, 38);
  int argcv_meth_ast_isConfidential132[] = {0};
  meth_meth_ast_isConfidential132->type = alloc_MethodType(1, argcv_meth_ast_isConfidential132);
  meth_meth_ast_isConfidential132->definitionModule = modulename;
  meth_meth_ast_isConfidential132->definitionLine = 125;
// method "decType"
  block_savedest(obj32);
  Object closure137 = createclosure(1, "decType");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_unknownType);
  struct UserObject *uo137 = (struct UserObject*)obj32;
  uo137->data[39] = (Object)closure137;
  Method *meth_meth_ast_decType137 = addmethod2pos(obj32, "decType", &meth_ast_decType137, 39);
  int argcv_meth_ast_decType137[] = {0};
  meth_meth_ast_decType137->type = alloc_MethodType(1, argcv_meth_ast_decType137);
  meth_meth_ast_decType137->definitionModule = modulename;
  meth_meth_ast_decType137->definitionLine = 126;
// method "isSimple"
  struct UserObject *uo147 = (struct UserObject*)obj32;
  uo147->data[40] = emptyclosure;
  Method *meth_meth_ast_isSimple147 = addmethod2pos(obj32, "isSimple", &meth_ast_isSimple147, 40);
  int argcv_meth_ast_isSimple147[] = {0};
  meth_meth_ast_isSimple147->type = alloc_MethodType(1, argcv_meth_ast_isSimple147);
  meth_meth_ast_isSimple147->definitionModule = modulename;
  meth_meth_ast_isSimple147->definitionLine = 132;
// method "description"
  struct UserObject *uo149 = (struct UserObject*)obj32;
  uo149->data[41] = emptyclosure;
  Method *meth_meth_ast_description149 = addmethod2pos(obj32, "description", &meth_ast_description149, 41);
  int argcv_meth_ast_description149[] = {0};
  meth_meth_ast_description149->type = alloc_MethodType(1, argcv_meth_ast_description149);
  meth_meth_ast_description149->definitionModule = modulename;
  meth_meth_ast_description149->definitionLine = 133;
// method "accept"
  block_savedest(obj32);
  Object closure152 = createclosure(1, "accept");
  setclosureframe(closure152, stackframe);
  addtoclosure(closure152, var_ancestorChain);
  struct UserObject *uo152 = (struct UserObject*)obj32;
  uo152->data[42] = (Object)closure152;
  Method *meth_meth_ast_accept152 = addmethod2pos(obj32, "accept", &meth_ast_accept152, 42);
  int argcv_meth_ast_accept152[] = {1};
  meth_meth_ast_accept152->type = alloc_MethodType(1, argcv_meth_ast_accept152);
  meth_meth_ast_accept152->definitionModule = modulename;
  meth_meth_ast_accept152->definitionLine = 134;
// method "scope"
  struct UserObject *uo157 = (struct UserObject*)obj32;
  uo157->data[43] = emptyclosure;
  Method *meth_meth_ast_scope157 = addmethod2pos(obj32, "scope", &meth_ast_scope157, 43);
  int argcv_meth_ast_scope157[] = {0};
  meth_meth_ast_scope157->type = alloc_MethodType(1, argcv_meth_ast_scope157);
  meth_meth_ast_scope157->definitionModule = modulename;
  meth_meth_ast_scope157->definitionLine = 137;
// method "scope:="
  struct UserObject *uo160 = (struct UserObject*)obj32;
  uo160->data[44] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_160 = addmethod2pos(obj32, "scope:=", &meth_ast_scope_58__61_160, 44);
  int argcv_meth_ast_scope_58__61_160[] = {1};
  meth_meth_ast_scope_58__61_160->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_160);
  meth_meth_ast_scope_58__61_160->definitionModule = modulename;
  meth_meth_ast_scope_58__61_160->definitionLine = 139;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo163 = (struct UserObject*)obj32;
  uo163->data[45] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom163 = addmethod2pos(obj32, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom163, 45);
  int argcv_meth_ast_shallowCopyFieldsFrom163[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom163->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom163);
  meth_meth_ast_shallowCopyFieldsFrom163->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom163->definitionLine = 146;
// method "pretty"
  block_savedest(obj32);
  Object closure180 = createclosure(1, "pretty");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_util);
  struct UserObject *uo180 = (struct UserObject*)obj32;
  uo180->data[46] = (Object)closure180;
  Method *meth_meth_ast_pretty180 = addmethod2pos(obj32, "pretty", &meth_ast_pretty180, 46);
  int argcv_meth_ast_pretty180[] = {1};
  meth_meth_ast_pretty180->type = alloc_MethodType(1, argcv_meth_ast_pretty180);
  meth_meth_ast_pretty180->definitionModule = modulename;
  meth_meth_ast_pretty180->definitionLine = 153;
// method "deepCopy"
  block_savedest(obj32);
  Object closure357 = createclosure(1, "deepCopy");
  setclosureframe(closure357, stackframe);
  addtoclosure(closure357, var_ancestorChain);
  struct UserObject *uo357 = (struct UserObject*)obj32;
  uo357->data[47] = (Object)closure357;
  Method *meth_meth_ast_deepCopy357 = addmethod2pos(obj32, "deepCopy", &meth_ast_deepCopy357, 47);
  int argcv_meth_ast_deepCopy357[] = {0};
  meth_meth_ast_deepCopy357->type = alloc_MethodType(1, argcv_meth_ast_deepCopy357);
  meth_meth_ast_deepCopy357->definitionModule = modulename;
  meth_meth_ast_deepCopy357->definitionLine = 166;
// method "enclosingObject"
  struct UserObject *uo365 = (struct UserObject*)obj32;
  uo365->data[48] = emptyclosure;
  Method *meth_meth_ast_enclosingObject365 = addmethod2pos(obj32, "enclosingObject", &meth_ast_enclosingObject365, 48);
  int argcv_meth_ast_enclosingObject365[] = {0};
  meth_meth_ast_enclosingObject365->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject365);
  meth_meth_ast_enclosingObject365->definitionModule = modulename;
  meth_meth_ast_enclosingObject365->definitionLine = 169;
// method "addComment"
  struct UserObject *uo372 = (struct UserObject*)obj32;
  uo372->data[49] = emptyclosure;
  Method *meth_meth_ast_addComment372 = addmethod2pos(obj32, "addComment", &meth_ast_addComment372, 49);
  int argcv_meth_ast_addComment372[] = {1};
  meth_meth_ast_addComment372->type = alloc_MethodType(1, argcv_meth_ast_addComment372);
  meth_meth_ast_addComment372->definitionModule = modulename;
  meth_meth_ast_addComment372->definitionLine = 173;
// method "addComments"
  struct UserObject *uo386 = (struct UserObject*)obj32;
  uo386->data[50] = emptyclosure;
  Method *meth_meth_ast_addComments386 = addmethod2pos(obj32, "addComments", &meth_ast_addComments386, 50);
  int argcv_meth_ast_addComments386[] = {1};
  meth_meth_ast_addComments386->type = alloc_MethodType(1, argcv_meth_ast_addComments386);
  meth_meth_ast_addComments386->definitionModule = modulename;
  meth_meth_ast_addComments386->definitionLine = 180;
// method "statementName"
  struct UserObject *uo394 = (struct UserObject*)obj32;
  uo394->data[51] = emptyclosure;
  Method *meth_meth_ast_statementName394 = addmethod2pos(obj32, "statementName", &meth_ast_statementName394, 51);
  int argcv_meth_ast_statementName394[] = {0};
  meth_meth_ast_statementName394->type = alloc_MethodType(1, argcv_meth_ast_statementName394);
  meth_meth_ast_statementName394->definitionModule = modulename;
  meth_meth_ast_statementName394->definitionLine = 183;
  sourceObject = obj32;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 2)
  adddatum2(obj32, strlit397, 1);
  sourceObject = obj32;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call399 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe398);
// compiled call node returning call399 (depth = 3)
// compiled member node returning call399 (depth = 2)
  adddatum2(obj32, call399, 2);
  sourceObject = obj32;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe400 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call401 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe400);
// compiled call node returning call401 (depth = 3)
// compiled member node returning call401 (depth = 2)
  adddatum2(obj32, call401, 3);
  sourceObject = obj32;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj32, *var_fakeSymbolTable, 4);
  sourceObject = obj32;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool402 = alloc_Boolean(0);
// compiled identifier node returning bool402 (depth = 2)
  adddatum2(obj32, bool402, 5);
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  sourceObject = obj32;
  objclass32 = obj32->class;
  objclass32->definitionModule = modulename;
  objclass32->definitionLine = 85;
  (*(struct UserObject *)self).data[0] = lowerouter32;
  self = oldself32;
  selfslot = oldselfslot32;
  stackframe = oldstackframe32;
  gc_frame_end(frame);
  return obj32;
}
Object meth_ast_newName407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for newName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_n (depth = 2)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_oldName408(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "oldName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oldName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for oldName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_ast_asString409(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit411 == NULL) {
    strlit411 = alloc_String("");
    gc_root(strlit411);
  }
// compiled string node returning strlit411 (depth = 3)
  int op_slot_right_410 = gc_frame_newslot(strlit411);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call415 = callmethod(*var_o, "nameString",
    1, partcv, params);
  gc_frame_end(callframe414);
// compiled call node returning call415 (depth = 5)
// compiled member node returning call415 (depth = 4)
  int op_slot_right_413 = gc_frame_newslot(call415);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit418 == NULL) {
    strlit418 = alloc_String(" = ");
    gc_root(strlit418);
  }
// compiled string node returning strlit418 (depth = 5)
  int op_slot_right_417 = gc_frame_newslot(strlit418);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call422 = callmethod(*var_n, "nameString",
    1, partcv, params);
  gc_frame_end(callframe421);
// compiled call node returning call422 (depth = 7)
// compiled member node returning call422 (depth = 6)
  int op_slot_right_420 = gc_frame_newslot(call422);
// starting to compile string node (depth = 6)
  if (strlit424 == NULL) {
    strlit424 = alloc_String("alias ");
    gc_root(strlit424);
  }
// compiled string node returning strlit424 (depth = 6)
  int op_slot_left_420 = gc_frame_newslot(strlit424);
  params[0] = call422;
  partcv[0] = 1;
  Object opresult425 = callmethod(strlit424, "++", 1, partcv, params);
// compiled op node returning opresult425 (depth = 5)
  int op_slot_left_417 = gc_frame_newslot(opresult425);
  params[0] = strlit418;
  partcv[0] = 1;
  Object opresult426 = callmethod(opresult425, "++", 1, partcv, params);
// compiled op node returning opresult426 (depth = 4)
  int op_slot_left_413 = gc_frame_newslot(opresult426);
  params[0] = call415;
  partcv[0] = 1;
  Object opresult427 = callmethod(opresult426, "++", 1, partcv, params);
// compiled op node returning opresult427 (depth = 3)
  int op_slot_left_410 = gc_frame_newslot(opresult427);
  params[0] = strlit411;
  partcv[0] = 1;
  Object opresult428 = callmethod(opresult427, "++", 1, partcv, params);
// compiled op node returning opresult428 (depth = 2)
  gc_frame_end(frame);
  return opresult428;
}
Object meth_ast__apply437(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit439 == NULL) {
    strlit439 = alloc_String("  ");
    gc_root(strlit439);
  }
// compiled string node returning strlit439 (depth = 6)
  int op_slot_right_438 = gc_frame_newslot(strlit439);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_438 = gc_frame_newslot(*var_spc);
  params[0] = strlit439;
  partcv[0] = 1;
  Object opresult441 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult441 (depth = 5)
  *var_spc = opresult441;
  if (opresult441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty429(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit430 == NULL) {
    strlit430 = alloc_String("");
    gc_root(strlit430);
  }
// compiled string node returning strlit430 (depth = 3)
  *var_spc = strlit430;
  if (strlit430 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe431 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_432 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num434 = alloc_Float64(0);
// compiled num node returning num434 (depth = 4)
  int op_slot_left_432 = gc_frame_newslot(num434);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult435 = callmethod(num434, "..", 1, partcv, params);
// compiled op node returning opresult435 (depth = 3)
  gc_frame_newslot(opresult435);
// starting to compile block node (depth = 3)
  Object block436 = alloc_Block(NULL, NULL, "ast", 2466);
  gc_frame_newslot(block436);
// method "_apply"
  block_savedest(block436);
  Object closure437 = createclosure(2, "_apply");
  setclosureframe(closure437, stackframe);
  addtoclosure(closure437, var_spc);
  addtoclosure(closure437, selfslot);
  struct UserObject *uo437 = (struct UserObject*)block436;
  uo437->data[0] = (Object)closure437;
  Method *meth_meth_ast__apply437 = addmethod2pos(block436, "_apply", &meth_ast__apply437, 0);
  int argcv_meth_ast__apply437[] = {1};
  meth_meth_ast__apply437->type = alloc_MethodType(1, argcv_meth_ast__apply437);
  meth_meth_ast__apply437->definitionModule = modulename;
  meth_meth_ast__apply437->definitionLine = 2463;
// compiled block node returning block436 (depth = 3)
  gc_frame_newslot(block436);
// call case 5: prelude request
  params[0] = opresult435;
  params[1] = block436;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call444 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe431);
// compiled call node returning call444 (depth = 2)
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit446 == NULL) {
    strlit446 = alloc_String("");
    gc_root(strlit446);
  }
// compiled string node returning strlit446 (depth = 3)
  int op_slot_right_445 = gc_frame_newslot(strlit446);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe449 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call450 = callmethod(*var_o, "pretty",
    1, partcv, params);
  gc_frame_end(callframe449);
// compiled call node returning call450 (depth = 4)
  int op_slot_right_448 = gc_frame_newslot(call450);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit453 == NULL) {
    strlit453 = alloc_String(" = ");
    gc_root(strlit453);
  }
// compiled string node returning strlit453 (depth = 5)
  int op_slot_right_452 = gc_frame_newslot(strlit453);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe456 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call457 = callmethod(*var_n, "pretty",
    1, partcv, params);
  gc_frame_end(callframe456);
// compiled call node returning call457 (depth = 6)
  int op_slot_right_455 = gc_frame_newslot(call457);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit460 == NULL) {
    strlit460 = alloc_String("  alias ");
    gc_root(strlit460);
  }
// compiled string node returning strlit460 (depth = 7)
  int op_slot_right_459 = gc_frame_newslot(strlit460);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_462 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit464 == NULL) {
    strlit464 = alloc_String("");
    gc_root(strlit464);
  }
// compiled string node returning strlit464 (depth = 8)
  int op_slot_left_462 = gc_frame_newslot(strlit464);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult465 = callmethod(strlit464, "++", 1, partcv, params);
// compiled op node returning opresult465 (depth = 7)
  int op_slot_left_459 = gc_frame_newslot(opresult465);
  params[0] = strlit460;
  partcv[0] = 1;
  Object opresult466 = callmethod(opresult465, "++", 1, partcv, params);
// compiled op node returning opresult466 (depth = 6)
  int op_slot_left_455 = gc_frame_newslot(opresult466);
  params[0] = call457;
  partcv[0] = 1;
  Object opresult467 = callmethod(opresult466, "++", 1, partcv, params);
// compiled op node returning opresult467 (depth = 5)
  int op_slot_left_452 = gc_frame_newslot(opresult467);
  params[0] = strlit453;
  partcv[0] = 1;
  Object opresult468 = callmethod(opresult467, "++", 1, partcv, params);
// compiled op node returning opresult468 (depth = 4)
  int op_slot_left_448 = gc_frame_newslot(opresult468);
  params[0] = call450;
  partcv[0] = 1;
  Object opresult469 = callmethod(opresult468, "++", 1, partcv, params);
// compiled op node returning opresult469 (depth = 3)
  int op_slot_left_445 = gc_frame_newslot(opresult469);
  params[0] = strlit446;
  partcv[0] = 1;
  Object opresult470 = callmethod(opresult469, "++", 1, partcv, params);
// compiled op node returning opresult470 (depth = 2)
  gc_frame_end(frame);
  return opresult470;
}
Object meth_ast_hash471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  partcv[0] = 0;
  Object call474 = callmethod(*var_o, "hash",
    1, partcv, params);
  gc_frame_end(callframe473);
// compiled call node returning call474 (depth = 4)
// compiled member node returning call474 (depth = 3)
  int op_slot_right_472 = gc_frame_newslot(call474);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num477 = alloc_Float64(1171);
// compiled num node returning num477 (depth = 4)
  int op_slot_right_476 = gc_frame_newslot(num477);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call480 = callmethod(*var_n, "hash",
    1, partcv, params);
  gc_frame_end(callframe479);
// compiled call node returning call480 (depth = 5)
// compiled member node returning call480 (depth = 4)
  int op_slot_left_476 = gc_frame_newslot(call480);
  params[0] = num477;
  partcv[0] = 1;
  Object prod481 = callmethod(call480, "*", 1, partcv, params);
// compiled op node returning prod481 (depth = 3)
  int op_slot_left_472 = gc_frame_newslot(prod481);
  params[0] = call474;
  partcv[0] = 1;
  Object sum482 = callmethod(prod481, "+", 1, partcv, params);
// compiled op node returning sum482 (depth = 2)
  gc_frame_end(frame);
  return sum482;
}
Object meth_ast_isExecutable483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool484 = alloc_Boolean(0);
// compiled identifier node returning bool484 (depth = 2)
  gc_frame_end(frame);
  return bool484;
}
Object meth_ast__apply488(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_that = &(stackframe->slots[0]);
  *var_that = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_that (depth = 8)
  partcv[0] = 0;
  Object call492 = callmethod(*var_that, "oldName",
    1, partcv, params);
  gc_frame_end(callframe491);
// compiled call node returning call492 (depth = 7)
// compiled member node returning call492 (depth = 6)
  int op_slot_right_490 = gc_frame_newslot(call492);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  int op_slot_left_490 = gc_frame_newslot(*var_o);
  params[0] = call492;
  partcv[0] = 1;
  Object opresult494 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult494 (depth = 5)
  int op_slot_right_489 = gc_frame_newslot(opresult494);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_that (depth = 8)
  partcv[0] = 0;
  Object call498 = callmethod(*var_that, "newName",
    1, partcv, params);
  gc_frame_end(callframe497);
// compiled call node returning call498 (depth = 7)
// compiled member node returning call498 (depth = 6)
  int op_slot_right_496 = gc_frame_newslot(call498);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_496 = gc_frame_newslot(*var_n);
  params[0] = call498;
  partcv[0] = 1;
  Object opresult500 = callmethod(*var_n, "==", 1, partcv, params);
// compiled op node returning opresult500 (depth = 5)
  int op_slot_left_489 = gc_frame_newslot(opresult500);
  params[0] = opresult494;
  partcv[0] = 1;
  Object opresult501 = callmethod(opresult500, "&&", 1, partcv, params);
// compiled op node returning opresult501 (depth = 4)
  gc_frame_end(frame);
  return opresult501;
}
Object meth_ast__apply513(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool514 = alloc_Boolean(0);
// compiled identifier node returning bool514 (depth = 4)
  gc_frame_end(frame);
  return bool514;
}
Object meth_ast__61__61_485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_AliasPair = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame486 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block487 = alloc_Block(NULL, NULL, "ast", 2475);
  gc_frame_newslot(block487);
// method "_apply"
  block_savedest(block487);
  Object closure488 = createclosure(3, "_apply");
  setclosureframe(closure488, stackframe);
  addtoclosure(closure488, var_o);
  addtoclosure(closure488, var_n);
  addtoclosure(closure488, selfslot);
  struct UserObject *uo488 = (struct UserObject*)block487;
  uo488->data[0] = (Object)closure488;
  Method *meth_meth_ast__apply488 = addmethod2pos(block487, "_apply", &meth_ast__apply488, 0);
  int argcv_meth_ast__apply488[] = {1};
  meth_meth_ast__apply488->type = alloc_MethodType(1, argcv_meth_ast__apply488);
  meth_meth_ast__apply488->definitionModule = modulename;
  meth_meth_ast__apply488->definitionLine = 2471;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe503 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe504 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit505 == NULL) {
    strlit505 = alloc_String("that");
    gc_root(strlit505);
  }
// compiled string node returning strlit505 (depth = 6)
  gc_frame_newslot(strlit505);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe506 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call507 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe506);
// compiled call node returning call507 (depth = 7)
// compiled member node returning call507 (depth = 6)
  params[0] = strlit505;
  partcv[0] = 1;
  Object call508 = callmethod(call507, "new",
    1, partcv, params);
  gc_frame_end(callframe504);
// compiled call node returning call508 (depth = 5)
  gc_frame_newslot(call508);
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AliasPair (depth = 5)
  gc_frame_newslot(*var_AliasPair);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe509 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call510 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe509);
// compiled call node returning call510 (depth = 6)
// compiled member node returning call510 (depth = 5)
  params[0] = call508;
  params[1] = *var_AliasPair;
  partcv[0] = 2;
  Object call511 = callmethod(call510, "new",
    1, partcv, params);
  gc_frame_end(callframe503);
// compiled call node returning call511 (depth = 4)
((struct UserObject *)block487)->data[1] = call511;
// compiled block node returning block487 (depth = 3)
  gc_frame_newslot(block487);
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block512 = alloc_Block(NULL, NULL, "ast", 2476);
  gc_frame_newslot(block512);
// method "_apply"
  block_savedest(block512);
  Object closure513 = createclosure(1, "_apply");
  setclosureframe(closure513, stackframe);
  addtoclosure(closure513, selfslot);
  struct UserObject *uo513 = (struct UserObject*)block512;
  uo513->data[0] = (Object)closure513;
  Method *meth_meth_ast__apply513 = addmethod2pos(block512, "_apply", &meth_ast__apply513, 0);
  int argcv_meth_ast__apply513[] = {1};
  meth_meth_ast__apply513->type = alloc_MethodType(1, argcv_meth_ast__apply513);
  meth_meth_ast__apply513->definitionModule = modulename;
  meth_meth_ast__apply513->definitionLine = 0;
// compiled block node returning block512 (depth = 3)
  gc_frame_newslot(block512);
  params[0] = block487;
  params[1] = block512;
  Object matchres486 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame486);
// compiled matchcase node returning matchres486 (depth = 2)
  gc_frame_end(frame);
  return matchres486;
}
Object meth_ast_aliasNew_40__41_old404(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew()old");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew()old (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for aliasNew");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for old");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject405 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj405 = alloc_userobj2(7,8, objclass405);
  gc_frame_newslot(obj405);
if (objclass405 == NULL) {
  glfree(obj405->class->name);
  obj405->class->name = "aliasNew()old";
}
// OBJECT OUTER DEC outer
  adddatum2(obj405, self, 0);
  addmethodreal(obj405,"outer", &reader_ast_outer_406);
  Object oldself405 = self;
  struct StackFrameObject *oldstackframe405 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe405);
  gc_frame_newslot((Object)stackframe);
  self = obj405;
  Object *oldselfslot405 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter405 = (*(struct UserObject *)self).data[0], lowerouter405 = thisouter405;
  if (inheritingObject405) {
    struct UserObject *inho405 = (struct UserObject *)inheritingObject405;
    while (inho405->super != GraceDefaultObject) inho405 = (struct UserObject *)inho405->super;
    inho405->super = obj405;
    self = inheritingObject405;
    *selfslot = self;
    lowerouter405 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter405;
  }
// method "newName"
  block_savedest(obj405);
  Object closure407 = createclosure(1, "newName");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_n);
  struct UserObject *uo407 = (struct UserObject*)obj405;
  uo407->data[1] = (Object)closure407;
  Method *meth_meth_ast_newName407 = addmethod2pos(obj405, "newName", &meth_ast_newName407, 1);
  int argcv_meth_ast_newName407[] = {0};
  meth_meth_ast_newName407->type = alloc_MethodType(1, argcv_meth_ast_newName407);
  meth_meth_ast_newName407->definitionModule = modulename;
  meth_meth_ast_newName407->definitionLine = 2461;
// method "oldName"
  block_savedest(obj405);
  Object closure408 = createclosure(1, "oldName");
  setclosureframe(closure408, stackframe);
  addtoclosure(closure408, var_o);
  struct UserObject *uo408 = (struct UserObject*)obj405;
  uo408->data[2] = (Object)closure408;
  Method *meth_meth_ast_oldName408 = addmethod2pos(obj405, "oldName", &meth_ast_oldName408, 2);
  int argcv_meth_ast_oldName408[] = {0};
  meth_meth_ast_oldName408->type = alloc_MethodType(1, argcv_meth_ast_oldName408);
  meth_meth_ast_oldName408->definitionModule = modulename;
  meth_meth_ast_oldName408->definitionLine = 2462;
// method "asString"
  block_savedest(obj405);
  Object closure409 = createclosure(2, "asString");
  setclosureframe(closure409, stackframe);
  addtoclosure(closure409, var_o);
  addtoclosure(closure409, var_n);
  struct UserObject *uo409 = (struct UserObject*)obj405;
  uo409->data[3] = (Object)closure409;
  Method *meth_meth_ast_asString409 = addmethod2pos(obj405, "asString", &meth_ast_asString409, 3);
  int argcv_meth_ast_asString409[] = {0};
  meth_meth_ast_asString409->type = alloc_MethodType(1, argcv_meth_ast_asString409);
  meth_meth_ast_asString409->definitionModule = modulename;
  meth_meth_ast_asString409->definitionLine = 2463;
// method "pretty"
  block_savedest(obj405);
  Object closure429 = createclosure(2, "pretty");
  setclosureframe(closure429, stackframe);
  addtoclosure(closure429, var_o);
  addtoclosure(closure429, var_n);
  struct UserObject *uo429 = (struct UserObject*)obj405;
  uo429->data[4] = (Object)closure429;
  Method *meth_meth_ast_pretty429 = addmethod2pos(obj405, "pretty", &meth_ast_pretty429, 4);
  int argcv_meth_ast_pretty429[] = {1};
  meth_meth_ast_pretty429->type = alloc_MethodType(1, argcv_meth_ast_pretty429);
  meth_meth_ast_pretty429->definitionModule = modulename;
  meth_meth_ast_pretty429->definitionLine = 2464;
// method "hash"
  block_savedest(obj405);
  Object closure471 = createclosure(2, "hash");
  setclosureframe(closure471, stackframe);
  addtoclosure(closure471, var_o);
  addtoclosure(closure471, var_n);
  struct UserObject *uo471 = (struct UserObject*)obj405;
  uo471->data[5] = (Object)closure471;
  Method *meth_meth_ast_hash471 = addmethod2pos(obj405, "hash", &meth_ast_hash471, 5);
  int argcv_meth_ast_hash471[] = {0};
  meth_meth_ast_hash471->type = alloc_MethodType(1, argcv_meth_ast_hash471);
  meth_meth_ast_hash471->definitionModule = modulename;
  meth_meth_ast_hash471->definitionLine = 2471;
// method "isExecutable"
  struct UserObject *uo483 = (struct UserObject*)obj405;
  uo483->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable483 = addmethod2pos(obj405, "isExecutable", &meth_ast_isExecutable483, 6);
  int argcv_meth_ast_isExecutable483[] = {0};
  meth_meth_ast_isExecutable483->type = alloc_MethodType(1, argcv_meth_ast_isExecutable483);
  meth_meth_ast_isExecutable483->definitionModule = modulename;
  meth_meth_ast_isExecutable483->definitionLine = 2472;
// method "=="
  block_savedest(obj405);
  Object closure485 = createclosure(3, "==");
  setclosureframe(closure485, stackframe);
  addtoclosure(closure485, var_o);
  addtoclosure(closure485, var_n);
  addtoclosure(closure485, var_AliasPair);
  struct UserObject *uo485 = (struct UserObject*)obj405;
  uo485->data[7] = (Object)closure485;
  Method *meth_meth_ast__61__61_485 = addmethod2pos(obj405, "==", &meth_ast__61__61_485, 7);
  int argcv_meth_ast__61__61_485[] = {1};
  meth_meth_ast__61__61_485->type = alloc_MethodType(1, argcv_meth_ast__61__61_485);
  meth_meth_ast__61__61_485->definitionModule = modulename;
  meth_meth_ast__61__61_485->definitionLine = 2473;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  objclass405 = obj405->class;
  objclass405->definitionModule = modulename;
  objclass405->definitionLine = 2460;
  (*(struct UserObject *)self).data[0] = lowerouter405;
  self = oldself405;
  selfslot = oldselfslot405;
  stackframe = oldstackframe405;
  gc_frame_end(frame);
  return obj405;
}
Object meth_ast_aliasNew_40__41_old404_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew()old()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old()object");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew()old (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for aliasNew");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for old");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject405 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj405 = alloc_userobj2(7,8, objclass405);
  gc_frame_newslot(obj405);
if (objclass405 == NULL) {
  glfree(obj405->class->name);
  obj405->class->name = "aliasNew()old";
}
// OBJECT OUTER DEC outer
  adddatum2(obj405, self, 0);
  addmethodreal(obj405,"outer", &reader_ast_outer_406);
  Object oldself405 = self;
  struct StackFrameObject *oldstackframe405 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe405);
  gc_frame_newslot((Object)stackframe);
  self = obj405;
  Object *oldselfslot405 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter405 = (*(struct UserObject *)self).data[0], lowerouter405 = thisouter405;
  if (inheritingObject405) {
    struct UserObject *inho405 = (struct UserObject *)inheritingObject405;
    while (inho405->super != GraceDefaultObject) inho405 = (struct UserObject *)inho405->super;
    inho405->super = obj405;
    self = inheritingObject405;
    *selfslot = self;
    lowerouter405 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter405;
  }
// method "newName"
  block_savedest(obj405);
  Object closure407 = createclosure(1, "newName");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_n);
  struct UserObject *uo407 = (struct UserObject*)obj405;
  uo407->data[1] = (Object)closure407;
  Method *meth_meth_ast_newName407 = addmethod2pos(obj405, "newName", &meth_ast_newName407, 1);
  int argcv_meth_ast_newName407[] = {0};
  meth_meth_ast_newName407->type = alloc_MethodType(1, argcv_meth_ast_newName407);
  meth_meth_ast_newName407->definitionModule = modulename;
  meth_meth_ast_newName407->definitionLine = 2461;
// method "oldName"
  block_savedest(obj405);
  Object closure408 = createclosure(1, "oldName");
  setclosureframe(closure408, stackframe);
  addtoclosure(closure408, var_o);
  struct UserObject *uo408 = (struct UserObject*)obj405;
  uo408->data[2] = (Object)closure408;
  Method *meth_meth_ast_oldName408 = addmethod2pos(obj405, "oldName", &meth_ast_oldName408, 2);
  int argcv_meth_ast_oldName408[] = {0};
  meth_meth_ast_oldName408->type = alloc_MethodType(1, argcv_meth_ast_oldName408);
  meth_meth_ast_oldName408->definitionModule = modulename;
  meth_meth_ast_oldName408->definitionLine = 2462;
// method "asString"
  block_savedest(obj405);
  Object closure409 = createclosure(2, "asString");
  setclosureframe(closure409, stackframe);
  addtoclosure(closure409, var_o);
  addtoclosure(closure409, var_n);
  struct UserObject *uo409 = (struct UserObject*)obj405;
  uo409->data[3] = (Object)closure409;
  Method *meth_meth_ast_asString409 = addmethod2pos(obj405, "asString", &meth_ast_asString409, 3);
  int argcv_meth_ast_asString409[] = {0};
  meth_meth_ast_asString409->type = alloc_MethodType(1, argcv_meth_ast_asString409);
  meth_meth_ast_asString409->definitionModule = modulename;
  meth_meth_ast_asString409->definitionLine = 2463;
// method "pretty"
  block_savedest(obj405);
  Object closure429 = createclosure(2, "pretty");
  setclosureframe(closure429, stackframe);
  addtoclosure(closure429, var_o);
  addtoclosure(closure429, var_n);
  struct UserObject *uo429 = (struct UserObject*)obj405;
  uo429->data[4] = (Object)closure429;
  Method *meth_meth_ast_pretty429 = addmethod2pos(obj405, "pretty", &meth_ast_pretty429, 4);
  int argcv_meth_ast_pretty429[] = {1};
  meth_meth_ast_pretty429->type = alloc_MethodType(1, argcv_meth_ast_pretty429);
  meth_meth_ast_pretty429->definitionModule = modulename;
  meth_meth_ast_pretty429->definitionLine = 2464;
// method "hash"
  block_savedest(obj405);
  Object closure471 = createclosure(2, "hash");
  setclosureframe(closure471, stackframe);
  addtoclosure(closure471, var_o);
  addtoclosure(closure471, var_n);
  struct UserObject *uo471 = (struct UserObject*)obj405;
  uo471->data[5] = (Object)closure471;
  Method *meth_meth_ast_hash471 = addmethod2pos(obj405, "hash", &meth_ast_hash471, 5);
  int argcv_meth_ast_hash471[] = {0};
  meth_meth_ast_hash471->type = alloc_MethodType(1, argcv_meth_ast_hash471);
  meth_meth_ast_hash471->definitionModule = modulename;
  meth_meth_ast_hash471->definitionLine = 2471;
// method "isExecutable"
  struct UserObject *uo483 = (struct UserObject*)obj405;
  uo483->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable483 = addmethod2pos(obj405, "isExecutable", &meth_ast_isExecutable483, 6);
  int argcv_meth_ast_isExecutable483[] = {0};
  meth_meth_ast_isExecutable483->type = alloc_MethodType(1, argcv_meth_ast_isExecutable483);
  meth_meth_ast_isExecutable483->definitionModule = modulename;
  meth_meth_ast_isExecutable483->definitionLine = 2472;
// method "=="
  block_savedest(obj405);
  Object closure485 = createclosure(3, "==");
  setclosureframe(closure485, stackframe);
  addtoclosure(closure485, var_o);
  addtoclosure(closure485, var_n);
  addtoclosure(closure485, var_AliasPair);
  struct UserObject *uo485 = (struct UserObject*)obj405;
  uo485->data[7] = (Object)closure485;
  Method *meth_meth_ast__61__61_485 = addmethod2pos(obj405, "==", &meth_ast__61__61_485, 7);
  int argcv_meth_ast__61__61_485[] = {1};
  meth_meth_ast__61__61_485->type = alloc_MethodType(1, argcv_meth_ast__61__61_485);
  meth_meth_ast__61__61_485->definitionModule = modulename;
  meth_meth_ast__61__61_485->definitionLine = 2473;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  sourceObject = obj405;
  objclass405 = obj405->class;
  objclass405->definitionModule = modulename;
  objclass405->definitionLine = 2460;
  (*(struct UserObject *)self).data[0] = lowerouter405;
  self = oldself405;
  selfslot = oldselfslot405;
  stackframe = oldstackframe405;
  gc_frame_end(frame);
  return obj405;
}
Object meth_ast__apply551(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ind (depth = 8)
  int op_slot_right_552 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_len (depth = 8)
  int op_slot_left_552 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff554 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff554 (depth = 7)
  gc_frame_end(frame);
  return diff554;
}
Object meth_ast__apply544(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe545 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit546 == NULL) {
    strlit546 = alloc_String(" ");
    gc_root(strlit546);
  }
// compiled string node returning strlit546 (depth = 6)
  gc_frame_newslot(strlit546);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_547 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_547 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff549 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff549 (depth = 6)
  gc_frame_newslot(diff549);
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block550 = alloc_Block(NULL, NULL, "ast", 2704);
  gc_frame_newslot(block550);
// method "_apply"
  block_savedest(block550);
  Object closure551 = createclosure(3, "_apply");
  setclosureframe(closure551, stackframe);
  addtoclosure(closure551, var_ind);
  addtoclosure(closure551, var_len);
  addtoclosure(closure551, selfslot);
  struct UserObject *uo551 = (struct UserObject*)block550;
  uo551->data[0] = (Object)closure551;
  Method *meth_meth_ast__apply551 = addmethod2pos(block550, "_apply", &meth_ast__apply551, 0);
  int argcv_meth_ast__apply551[] = {0};
  meth_meth_ast__apply551->type = alloc_MethodType(1, argcv_meth_ast__apply551);
  meth_meth_ast__apply551->definitionModule = modulename;
  meth_meth_ast__apply551->definitionLine = 2696;
// compiled block node returning block550 (depth = 6)
  gc_frame_newslot(block550);
// call case 6: other member request
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = strlit546;
  params[1] = diff549;
  params[2] = block550;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call556 = callmethod(*var_str, "lastIndexOf()startingAt()ifAbsent",
    3, partcv, params);
  gc_frame_end(callframe545);
// compiled call node returning call556 (depth = 5)
  *var_currBreak = call556;
  if (call556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe558 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe559 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num560 = alloc_Float64(1);
// compiled num node returning num560 (depth = 8)
  gc_frame_newslot(num560);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_currBreak (depth = 8)
  gc_frame_newslot(*var_currBreak);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_str (depth = 8)
  params[0] = num560;
  params[1] = *var_currBreak;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call561 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe559);
// compiled call node returning call561 (depth = 7)
  partcv[0] = 0;
  Object call562 = callmethod(call561, "trim",
    1, partcv, params);
  gc_frame_end(callframe558);
// compiled call node returning call562 (depth = 6)
// compiled member node returning call562 (depth = 5)
  *var_trimmedLine = call562;
  if (call562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply577(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_str = getfromclosure(closure, 0);
  Object *var_currBreak = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit580 == NULL) {
    strlit580 = alloc_String(" ");
    gc_root(strlit580);
  }
// compiled string node returning strlit580 (depth = 8)
  int op_slot_right_579 = gc_frame_newslot(strlit580);
// starting to compile call node (depth = 8)
  int callframe582 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call583 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe582);
// compiled call node returning call583 (depth = 8)
  int op_slot_left_579 = gc_frame_newslot(call583);
  params[0] = strlit580;
  partcv[0] = 1;
  Object opresult584 = callmethod(call583, "==", 1, partcv, params);
// compiled op node returning opresult584 (depth = 7)
  Object if578 = done;
  if (istrue(opresult584)) {
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  *var_currBreak = *var_ix;
  if (*var_ix == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if578 = done;
  } else {
  }
// compiled if node returning if578 (depth = 6)
  gc_frame_end(frame);
  return if578;
}
Object meth_ast__apply597(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit599 == NULL) {
    strlit599 = alloc_String(" ");
    gc_root(strlit599);
  }
// compiled string node returning strlit599 (depth = 9)
  int op_slot_right_598 = gc_frame_newslot(strlit599);
// starting to compile call node (depth = 9)
  int callframe601 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_end (depth = 10)
  gc_frame_newslot(*var_end);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_end;
  partcv[0] = 1;
  Object call602 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe601);
// compiled call node returning call602 (depth = 9)
  int op_slot_left_598 = gc_frame_newslot(call602);
  params[0] = strlit599;
  partcv[0] = 1;
  Object opresult603 = callmethod(call602, "==", 1, partcv, params);
// compiled op node returning opresult603 (depth = 8)
  gc_frame_end(frame);
  return opresult603;
}
Object meth_ast__apply594(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe595 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block596 = alloc_Block(NULL, NULL, "ast", 2712);
  gc_frame_newslot(block596);
// method "_apply"
  block_savedest(block596);
  Object closure597 = createclosure(3, "_apply");
  setclosureframe(closure597, stackframe);
  addtoclosure(closure597, var_end);
  addtoclosure(closure597, var_str);
  addtoclosure(closure597, selfslot);
  struct UserObject *uo597 = (struct UserObject*)block596;
  uo597->data[0] = (Object)closure597;
  Method *meth_meth_ast__apply597 = addmethod2pos(block596, "_apply", &meth_ast__apply597, 0);
  int argcv_meth_ast__apply597[] = {0};
  meth_meth_ast__apply597->type = alloc_MethodType(1, argcv_meth_ast__apply597);
  meth_meth_ast__apply597->definitionModule = modulename;
  meth_meth_ast__apply597->definitionLine = 2707;
// compiled block node returning block596 (depth = 7)
  gc_frame_newslot(block596);
// call case 6: other member request
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num606 = alloc_Float64(1);
// compiled num node returning num606 (depth = 8)
  int op_slot_right_605 = gc_frame_newslot(num606);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_605 = gc_frame_newslot(*var_end);
  params[0] = num606;
  partcv[0] = 1;
  Object opresult608 = callmethod(*var_end, ">=", 1, partcv, params);
// compiled op node returning opresult608 (depth = 7)
  params[0] = block596;
  partcv[0] = 1;
  Object call609 = callmethod(opresult608, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe595);
// compiled call node returning call609 (depth = 6)
  gc_frame_end(frame);
  return call609;
}
Object meth_ast__apply612(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num614 = alloc_Float64(1);
// compiled num node returning num614 (depth = 8)
  int op_slot_right_613 = gc_frame_newslot(num614);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_613 = gc_frame_newslot(*var_end);
  params[0] = num614;
  partcv[0] = 1;
  Object diff616 = callmethod(*var_end, "-", 1, partcv, params);
// compiled op node returning diff616 (depth = 7)
  *var_end = diff616;
  if (diff616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply626(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit628 == NULL) {
    strlit628 = alloc_String(" ");
    gc_root(strlit628);
  }
// compiled string node returning strlit628 (depth = 9)
  int op_slot_right_627 = gc_frame_newslot(strlit628);
// starting to compile call node (depth = 9)
  int callframe630 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_start (depth = 10)
  gc_frame_newslot(*var_start);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_start;
  partcv[0] = 1;
  Object call631 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe630);
// compiled call node returning call631 (depth = 9)
  int op_slot_left_627 = gc_frame_newslot(call631);
  params[0] = strlit628;
  partcv[0] = 1;
  Object opresult632 = callmethod(call631, "==", 1, partcv, params);
// compiled op node returning opresult632 (depth = 8)
  gc_frame_end(frame);
  return opresult632;
}
Object meth_ast__apply623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe624 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block625 = alloc_Block(NULL, NULL, "ast", 2716);
  gc_frame_newslot(block625);
// method "_apply"
  block_savedest(block625);
  Object closure626 = createclosure(3, "_apply");
  setclosureframe(closure626, stackframe);
  addtoclosure(closure626, var_start);
  addtoclosure(closure626, var_str);
  addtoclosure(closure626, selfslot);
  struct UserObject *uo626 = (struct UserObject*)block625;
  uo626->data[0] = (Object)closure626;
  Method *meth_meth_ast__apply626 = addmethod2pos(block625, "_apply", &meth_ast__apply626, 0);
  int argcv_meth_ast__apply626[] = {0};
  meth_meth_ast__apply626->type = alloc_MethodType(1, argcv_meth_ast__apply626);
  meth_meth_ast__apply626->definitionModule = modulename;
  meth_meth_ast__apply626->definitionLine = 2707;
// compiled block node returning block625 (depth = 7)
  gc_frame_newslot(block625);
// call case 6: other member request
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call636 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe635);
// compiled call node returning call636 (depth = 9)
// compiled member node returning call636 (depth = 8)
  int op_slot_right_634 = gc_frame_newslot(call636);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_634 = gc_frame_newslot(*var_start);
  params[0] = call636;
  partcv[0] = 1;
  Object opresult638 = callmethod(*var_start, "<=", 1, partcv, params);
// compiled op node returning opresult638 (depth = 7)
  params[0] = block625;
  partcv[0] = 1;
  Object call639 = callmethod(opresult638, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe624);
// compiled call node returning call639 (depth = 6)
  gc_frame_end(frame);
  return call639;
}
Object meth_ast__apply642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num644 = alloc_Float64(1);
// compiled num node returning num644 (depth = 8)
  int op_slot_right_643 = gc_frame_newslot(num644);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_643 = gc_frame_newslot(*var_start);
  params[0] = num644;
  partcv[0] = 1;
  Object sum646 = callmethod(*var_start, "+", 1, partcv, params);
// compiled op node returning sum646 (depth = 7)
  *var_start = sum646;
  if (sum646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply566(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_end = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "end");
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe567 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_568 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_568 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff570 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff570 (depth = 6)
  gc_frame_newslot(diff570);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_str (depth = 8)
  partcv[0] = 0;
  Object call572 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe571);
// compiled call node returning call572 (depth = 7)
// compiled member node returning call572 (depth = 6)
  gc_frame_newslot(call572);
// call case 5: prelude request
  params[0] = diff570;
  params[1] = call572;
  partcv[0] = 2;
  Object call573 = callmethodflags(prelude, "min", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe567);
// compiled call node returning call573 (depth = 5)
  *var_currBreak = call573;
  if (call573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe575 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block576 = alloc_Block(NULL, NULL, "ast", 2708);
  gc_frame_newslot(block576);
// method "_apply"
  block_savedest(block576);
  Object closure577 = createclosure(3, "_apply");
  setclosureframe(closure577, stackframe);
  addtoclosure(closure577, var_str);
  addtoclosure(closure577, var_currBreak);
  addtoclosure(closure577, selfslot);
  struct UserObject *uo577 = (struct UserObject*)block576;
  uo577->data[0] = (Object)closure577;
  Method *meth_meth_ast__apply577 = addmethod2pos(block576, "_apply", &meth_ast__apply577, 0);
  int argcv_meth_ast__apply577[] = {1};
  meth_meth_ast__apply577->type = alloc_MethodType(1, argcv_meth_ast__apply577);
  meth_meth_ast__apply577->definitionModule = modulename;
  meth_meth_ast__apply577->definitionLine = 2707;
// compiled block node returning block576 (depth = 5)
  gc_frame_newslot(block576);
// call case 6: other member request
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_right_587 = gc_frame_newslot(*var_currBreak);
// starting to compile num node (depth = 6)
  Object num589 = alloc_Float64(1);
// compiled num node returning num589 (depth = 6)
  int op_slot_left_587 = gc_frame_newslot(num589);
  params[0] = *var_currBreak;
  partcv[0] = 1;
  Object opresult590 = callmethod(num589, "..", 1, partcv, params);
// compiled op node returning opresult590 (depth = 5)
  params[0] = block576;
  partcv[0] = 1;
  Object call591 = callmethod(opresult590, "do",
    1, partcv, params);
  gc_frame_end(callframe575);
// compiled call node returning call591 (depth = 4)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_currBreak (depth = 5)
  *var_end = *var_currBreak;
  if (*var_currBreak == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe592 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block593 = alloc_Block(NULL, NULL, "ast", 2712);
  gc_frame_newslot(block593);
// method "_apply"
  block_savedest(block593);
  Object closure594 = createclosure(3, "_apply");
  setclosureframe(closure594, stackframe);
  addtoclosure(closure594, var_end);
  addtoclosure(closure594, var_str);
  addtoclosure(closure594, selfslot);
  struct UserObject *uo594 = (struct UserObject*)block593;
  uo594->data[0] = (Object)closure594;
  Method *meth_meth_ast__apply594 = addmethod2pos(block593, "_apply", &meth_ast__apply594, 0);
  int argcv_meth_ast__apply594[] = {0};
  meth_meth_ast__apply594->type = alloc_MethodType(1, argcv_meth_ast__apply594);
  meth_meth_ast__apply594->definitionModule = modulename;
  meth_meth_ast__apply594->definitionLine = 2707;
// compiled block node returning block593 (depth = 5)
  gc_frame_newslot(block593);
// starting to compile block node (depth = 5)
  Object block611 = alloc_Block(NULL, NULL, "ast", 2712);
  gc_frame_newslot(block611);
// method "_apply"
  block_savedest(block611);
  Object closure612 = createclosure(2, "_apply");
  setclosureframe(closure612, stackframe);
  addtoclosure(closure612, var_end);
  addtoclosure(closure612, selfslot);
  struct UserObject *uo612 = (struct UserObject*)block611;
  uo612->data[0] = (Object)closure612;
  Method *meth_meth_ast__apply612 = addmethod2pos(block611, "_apply", &meth_ast__apply612, 0);
  int argcv_meth_ast__apply612[] = {0};
  meth_meth_ast__apply612->type = alloc_MethodType(1, argcv_meth_ast__apply612);
  meth_meth_ast__apply612->definitionModule = modulename;
  meth_meth_ast__apply612->definitionLine = 2707;
// compiled block node returning block611 (depth = 5)
  gc_frame_newslot(block611);
// call case 5: prelude request
  params[0] = block593;
  params[1] = block611;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call619 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe592);
// compiled call node returning call619 (depth = 4)
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num620 = alloc_Float64(1);
// compiled num node returning num620 (depth = 5)
  *var_start = num620;
  if (num620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe621 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block622 = alloc_Block(NULL, NULL, "ast", 2716);
  gc_frame_newslot(block622);
// method "_apply"
  block_savedest(block622);
  Object closure623 = createclosure(3, "_apply");
  setclosureframe(closure623, stackframe);
  addtoclosure(closure623, var_start);
  addtoclosure(closure623, var_str);
  addtoclosure(closure623, selfslot);
  struct UserObject *uo623 = (struct UserObject*)block622;
  uo623->data[0] = (Object)closure623;
  Method *meth_meth_ast__apply623 = addmethod2pos(block622, "_apply", &meth_ast__apply623, 0);
  int argcv_meth_ast__apply623[] = {0};
  meth_meth_ast__apply623->type = alloc_MethodType(1, argcv_meth_ast__apply623);
  meth_meth_ast__apply623->definitionModule = modulename;
  meth_meth_ast__apply623->definitionLine = 2707;
// compiled block node returning block622 (depth = 5)
  gc_frame_newslot(block622);
// starting to compile block node (depth = 5)
  Object block641 = alloc_Block(NULL, NULL, "ast", 2716);
  gc_frame_newslot(block641);
// method "_apply"
  block_savedest(block641);
  Object closure642 = createclosure(2, "_apply");
  setclosureframe(closure642, stackframe);
  addtoclosure(closure642, var_start);
  addtoclosure(closure642, selfslot);
  struct UserObject *uo642 = (struct UserObject*)block641;
  uo642->data[0] = (Object)closure642;
  Method *meth_meth_ast__apply642 = addmethod2pos(block641, "_apply", &meth_ast__apply642, 0);
  int argcv_meth_ast__apply642[] = {0};
  meth_meth_ast__apply642->type = alloc_MethodType(1, argcv_meth_ast__apply642);
  meth_meth_ast__apply642->definitionModule = modulename;
  meth_meth_ast__apply642->definitionLine = 2716;
// compiled block node returning block641 (depth = 5)
  gc_frame_newslot(block641);
// call case 5: prelude request
  params[0] = block622;
  params[1] = block641;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call649 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe621);
// compiled call node returning call649 (depth = 4)
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe650 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = *var_start;
  params[1] = *var_end;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call651 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe650);
// compiled call node returning call651 (depth = 5)
  *var_trimmedLine = call651;
  if (call651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_wrap_40__41_to_40__41_prefix517(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wrap()to()prefix");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap()to()prefix");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap()to()prefix");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap()to()prefix");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for wrap()to()prefix (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for wrap");
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for to");
  Object *var_margin = &(stackframe->slots[2]);
  *var_margin = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for prefix");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ind = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ind");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
  Object *var_currBreak = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "currBreak");
  Object *var_trimmedLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "trimmedLine");
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  partcv[0] = 0;
  Object call519 = callmethod(*var_margin, "size",
    1, partcv, params);
  gc_frame_end(callframe518);
// compiled call node returning call519 (depth = 4)
// compiled member node returning call519 (depth = 3)
  *var_ind = call519;
  if (call519 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe520 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num522 = alloc_Float64(4);
// compiled num node returning num522 (depth = 5)
  int op_slot_right_521 = gc_frame_newslot(num522);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_521 = gc_frame_newslot(*var_ind);
  params[0] = num522;
  partcv[0] = 1;
  Object sum524 = callmethod(*var_ind, "+", 1, partcv, params);
// compiled op node returning sum524 (depth = 4)
  gc_frame_newslot(sum524);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// call case 5: prelude request
  params[0] = sum524;
  params[1] = *var_l;
  partcv[0] = 2;
  Object call525 = callmethodflags(prelude, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe520);
// compiled call node returning call525 (depth = 3)
  *var_len = call525;
  if (call525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_len (depth = 4)
  int op_slot_right_527 = gc_frame_newslot(*var_len);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call531 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe530);
// compiled call node returning call531 (depth = 6)
// compiled member node returning call531 (depth = 5)
  int op_slot_right_529 = gc_frame_newslot(call531);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_529 = gc_frame_newslot(*var_ind);
  params[0] = call531;
  partcv[0] = 1;
  Object sum533 = callmethod(*var_ind, "+", 1, partcv, params);
// compiled op node returning sum533 (depth = 4)
  int op_slot_left_527 = gc_frame_newslot(sum533);
  params[0] = *var_len;
  partcv[0] = 1;
  Object opresult534 = callmethod(sum533, "<=", 1, partcv, params);
// compiled op node returning opresult534 (depth = 3)
  Object if526 = done;
  if (istrue(opresult534)) {
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  int op_slot_right_535 = gc_frame_newslot(*var_str);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_margin (depth = 6)
  int op_slot_right_537 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 6)
  if (strlit539 == NULL) {
    strlit539 = alloc_String("""\x0a""");
    gc_root(strlit539);
  }
// compiled string node returning strlit539 (depth = 6)
  int op_slot_left_537 = gc_frame_newslot(strlit539);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult540 = callmethod(strlit539, "++", 1, partcv, params);
// compiled op node returning opresult540 (depth = 5)
  int op_slot_left_535 = gc_frame_newslot(opresult540);
  params[0] = *var_str;
  partcv[0] = 1;
  Object opresult541 = callmethod(opresult540, "++", 1, partcv, params);
// compiled op node returning opresult541 (depth = 4)
  return opresult541;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if526 = undefined;
  } else {
  }
// compiled if node returning if526 (depth = 2)
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_currBreak = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_trimmedLine = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block543 = alloc_Block(NULL, NULL, "ast", 2702);
  gc_frame_newslot(block543);
// method "_apply"
  block_savedest(block543);
  Object closure544 = createclosure(6, "_apply");
  setclosureframe(closure544, stackframe);
  addtoclosure(closure544, var_ind);
  addtoclosure(closure544, var_len);
  addtoclosure(closure544, var_str);
  addtoclosure(closure544, var_currBreak);
  addtoclosure(closure544, var_trimmedLine);
  addtoclosure(closure544, selfslot);
  struct UserObject *uo544 = (struct UserObject*)block543;
  uo544->data[0] = (Object)closure544;
  Method *meth_meth_ast__apply544 = addmethod2pos(block543, "_apply", &meth_ast__apply544, 0);
  int argcv_meth_ast__apply544[] = {0};
  meth_meth_ast__apply544->type = alloc_MethodType(1, argcv_meth_ast__apply544);
  meth_meth_ast__apply544->definitionModule = modulename;
  meth_meth_ast__apply544->definitionLine = 2696;
// compiled block node returning block543 (depth = 3)
  int frame542 = gc_frame_new();
  gc_frame_newslot(block543);
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block565 = alloc_Block(NULL, NULL, "ast", 2706);
  gc_frame_newslot(block565);
// method "_apply"
  block_savedest(block565);
  Object closure566 = createclosure(6, "_apply");
  setclosureframe(closure566, stackframe);
  addtoclosure(closure566, var_ind);
  addtoclosure(closure566, var_len);
  addtoclosure(closure566, var_str);
  addtoclosure(closure566, var_currBreak);
  addtoclosure(closure566, var_trimmedLine);
  addtoclosure(closure566, selfslot);
  struct UserObject *uo566 = (struct UserObject*)block565;
  uo566->data[0] = (Object)closure566;
  Method *meth_meth_ast__apply566 = addmethod2pos(block565, "_apply", &meth_ast__apply566, 0);
  int argcv_meth_ast__apply566[] = {1};
  meth_meth_ast__apply566->type = alloc_MethodType(1, argcv_meth_ast__apply566);
  meth_meth_ast__apply566->definitionModule = modulename;
  meth_meth_ast__apply566->definitionLine = 2705;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe654 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe655 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit656 == NULL) {
    strlit656 = alloc_String("ex");
    gc_root(strlit656);
  }
// compiled string node returning strlit656 (depth = 6)
  gc_frame_newslot(strlit656);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe657 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call658 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe657);
// compiled call node returning call658 (depth = 7)
// compiled member node returning call658 (depth = 6)
  params[0] = strlit656;
  partcv[0] = 1;
  Object call659 = callmethod(call658, "new",
    1, partcv, params);
  gc_frame_end(callframe655);
// compiled call node returning call659 (depth = 5)
  gc_frame_newslot(call659);
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe660 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call661 = callmethodflags(prelude, "NoSuchMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe660);
// compiled call node returning call661 (depth = 6)
// compiled member node returning call661 (depth = 5)
  gc_frame_newslot(call661);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe662 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call663 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 6)
// compiled member node returning call663 (depth = 5)
  params[0] = call659;
  params[1] = call661;
  partcv[0] = 2;
  Object call664 = callmethod(call663, "new",
    1, partcv, params);
  gc_frame_end(callframe654);
// compiled call node returning call664 (depth = 4)
((struct UserObject *)block565)->data[1] = call664;
// compiled block node returning block565 (depth = 3)
  gc_frame_newslot(block565);
  params[0] = block565;
  setline(2702);
  Object catchres542 = tryCatch(block543, params, 1,NULL);
  gc_frame_end(frame542);
// compiled trycatch node returning catchres542 (depth = 2)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe666 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe667 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num669 = alloc_Float64(1);
// compiled num node returning num669 (depth = 6)
  int op_slot_right_668 = gc_frame_newslot(num669);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_left_668 = gc_frame_newslot(*var_currBreak);
  params[0] = num669;
  partcv[0] = 1;
  Object sum671 = callmethod(*var_currBreak, "+", 1, partcv, params);
// compiled op node returning sum671 (depth = 5)
  gc_frame_newslot(sum671);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call673 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe672);
// compiled call node returning call673 (depth = 6)
// compiled member node returning call673 (depth = 5)
  gc_frame_newslot(call673);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  params[0] = sum671;
  params[1] = call673;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call674 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe667);
// compiled call node returning call674 (depth = 4)
  gc_frame_newslot(call674);
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  gc_frame_newslot(*var_margin);
// call case 4: self request
  params[0] = call674;
  params[1] = *var_l;
  params[2] = *var_margin;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call675 = callmethodflags(self, "wrap()to()prefix", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe666);
// compiled call node returning call675 (depth = 3)
  int op_slot_right_665 = gc_frame_newslot(call675);
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_trimmedLine (depth = 4)
  int op_slot_right_677 = gc_frame_newslot(*var_trimmedLine);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  int op_slot_right_679 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 5)
  if (strlit681 == NULL) {
    strlit681 = alloc_String("""\x0a""");
    gc_root(strlit681);
  }
// compiled string node returning strlit681 (depth = 5)
  int op_slot_left_679 = gc_frame_newslot(strlit681);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult682 = callmethod(strlit681, "++", 1, partcv, params);
// compiled op node returning opresult682 (depth = 4)
  int op_slot_left_677 = gc_frame_newslot(opresult682);
  params[0] = *var_trimmedLine;
  partcv[0] = 1;
  Object opresult683 = callmethod(opresult682, "++", 1, partcv, params);
// compiled op node returning opresult683 (depth = 3)
  int op_slot_left_665 = gc_frame_newslot(opresult683);
  params[0] = call675;
  partcv[0] = 1;
  Object opresult684 = callmethod(opresult683, "++", 1, partcv, params);
// compiled op node returning opresult684 (depth = 2)
  gc_frame_end(frame);
  return opresult684;
}
Object meth_ast_visitIf_40__41_up688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIf");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe689 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call690 = callmethodflags(self, "visitIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe689);
// compiled call node returning call690 (depth = 2)
  gc_frame_end(frame);
  return call690;
}
Object meth_ast_visitBlock_40__41_up691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlock");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe692 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call693 = callmethodflags(self, "visitBlock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe692);
// compiled call node returning call693 (depth = 2)
  gc_frame_end(frame);
  return call693;
}
Object meth_ast_visitMatchCase_40__41_up694(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe695 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call696 = callmethodflags(self, "visitMatchCase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe695);
// compiled call node returning call696 (depth = 2)
  gc_frame_end(frame);
  return call696;
}
Object meth_ast_visitTryCatch_40__41_up697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTryCatch");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe698 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call699 = callmethodflags(self, "visitTryCatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe698);
// compiled call node returning call699 (depth = 2)
  gc_frame_end(frame);
  return call699;
}
Object meth_ast_visitMethodType_40__41_up700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethodType");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe701 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call702 = callmethodflags(self, "visitMethodType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe701);
// compiled call node returning call702 (depth = 2)
  gc_frame_end(frame);
  return call702;
}
Object meth_ast_visitSignaturePart_40__41_up703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitSignaturePart");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe704 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call705 = callmethodflags(self, "visitSignaturePart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe704);
// compiled call node returning call705 (depth = 2)
  gc_frame_end(frame);
  return call705;
}
Object meth_ast_visitTypeDec_40__41_up706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe707 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call708 = callmethodflags(self, "visitTypeDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe707);
// compiled call node returning call708 (depth = 2)
  gc_frame_end(frame);
  return call708;
}
Object meth_ast_visitTypeLiteral_40__41_up709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeLiteral");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe710 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call711 = callmethodflags(self, "visitTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe710);
// compiled call node returning call711 (depth = 2)
  gc_frame_end(frame);
  return call711;
}
Object meth_ast_visitTypeParameters_40__41_up712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeParameters");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe713 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call714 = callmethodflags(self, "visitTypeParameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe713);
// compiled call node returning call714 (depth = 2)
  gc_frame_end(frame);
  return call714;
}
Object meth_ast_visitMethod_40__41_up715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethod");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe716 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call717 = callmethodflags(self, "visitMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe716);
// compiled call node returning call717 (depth = 2)
  gc_frame_end(frame);
  return call717;
}
Object meth_ast_visitCall_40__41_up718(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe719 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call720 = callmethodflags(self, "visitCall", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled call node returning call720 (depth = 2)
  gc_frame_end(frame);
  return call720;
}
Object meth_ast_visitObject_40__41_up721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitObject");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe722 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call723 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe722);
// compiled call node returning call723 (depth = 2)
  gc_frame_end(frame);
  return call723;
}
Object meth_ast_visitModule_40__41_up724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitModule");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe725 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call726 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe725);
// compiled call node returning call726 (depth = 2)
  gc_frame_end(frame);
  return call726;
}
Object meth_ast_visitArray_40__41_up727(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitArray");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe728 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call729 = callmethodflags(self, "visitArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe728);
// compiled call node returning call729 (depth = 2)
  gc_frame_end(frame);
  return call729;
}
Object meth_ast_visitMember_40__41_up730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMember");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe731 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call732 = callmethodflags(self, "visitMember", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe731);
// compiled call node returning call732 (depth = 2)
  gc_frame_end(frame);
  return call732;
}
Object meth_ast_visitGeneric_40__41_up733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitGeneric");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe734 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call735 = callmethodflags(self, "visitGeneric", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe734);
// compiled call node returning call735 (depth = 2)
  gc_frame_end(frame);
  return call735;
}
Object meth_ast_visitIdentifier_40__41_up736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIdentifier");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe737 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call738 = callmethodflags(self, "visitIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe737);
// compiled call node returning call738 (depth = 2)
  gc_frame_end(frame);
  return call738;
}
Object meth_ast_visitString_40__41_up739(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitString");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe740 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call741 = callmethodflags(self, "visitString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe740);
// compiled call node returning call741 (depth = 2)
  gc_frame_end(frame);
  return call741;
}
Object meth_ast_visitNum_40__41_up742(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitNum");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe743 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call744 = callmethodflags(self, "visitNum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe743);
// compiled call node returning call744 (depth = 2)
  gc_frame_end(frame);
  return call744;
}
Object meth_ast_visitOp_40__41_up745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitOp");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe746 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call747 = callmethodflags(self, "visitOp", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe746);
// compiled call node returning call747 (depth = 2)
  gc_frame_end(frame);
  return call747;
}
Object meth_ast_visitIndex_40__41_up748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIndex()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIndex()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIndex()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIndex");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe749 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call750 = callmethodflags(self, "visitIndex", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe749);
// compiled call node returning call750 (depth = 2)
  gc_frame_end(frame);
  return call750;
}
Object meth_ast_visitBind_40__41_up751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBind");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe752 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call753 = callmethodflags(self, "visitBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe752);
// compiled call node returning call753 (depth = 2)
  gc_frame_end(frame);
  return call753;
}
Object meth_ast_visitDefDec_40__41_up754(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDefDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe755 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call756 = callmethodflags(self, "visitDefDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe755);
// compiled call node returning call756 (depth = 2)
  gc_frame_end(frame);
  return call756;
}
Object meth_ast_visitVarDec_40__41_up757(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitVarDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe758 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call759 = callmethodflags(self, "visitVarDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe758);
// compiled call node returning call759 (depth = 2)
  gc_frame_end(frame);
  return call759;
}
Object meth_ast_visitImport_40__41_up760(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitImport");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe761 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call762 = callmethodflags(self, "visitImport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe761);
// compiled call node returning call762 (depth = 2)
  gc_frame_end(frame);
  return call762;
}
Object meth_ast_visitReturn_40__41_up763(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitReturn");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe764 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call765 = callmethodflags(self, "visitReturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe764);
// compiled call node returning call765 (depth = 2)
  gc_frame_end(frame);
  return call765;
}
Object meth_ast_visitInherits_40__41_up766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitInherits");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe767 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call768 = callmethodflags(self, "visitInherits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe767);
// compiled call node returning call768 (depth = 2)
  gc_frame_end(frame);
  return call768;
}
Object meth_ast_visitDialect_40__41_up769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDialect");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe770 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call771 = callmethodflags(self, "visitDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe770);
// compiled call node returning call771 (depth = 2)
  gc_frame_end(frame);
  return call771;
}
Object meth_ast_visitBlank_40__41_up772(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlank");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe773 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call774 = callmethodflags(self, "visitBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe773);
// compiled call node returning call774 (depth = 2)
  gc_frame_end(frame);
  return call774;
}
Object meth_ast_visitComment_40__41_up775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitComment");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe776 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call777 = callmethodflags(self, "visitComment", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe776);
// compiled call node returning call777 (depth = 2)
  gc_frame_end(frame);
  return call777;
}
Object meth_ast_visitIf778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool779 = alloc_Boolean(1);
// compiled identifier node returning bool779 (depth = 2)
  gc_frame_end(frame);
  return bool779;
}
Object meth_ast_visitBlock780(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlock");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool781 = alloc_Boolean(1);
// compiled identifier node returning bool781 (depth = 2)
  gc_frame_end(frame);
  return bool781;
}
Object meth_ast_visitMatchCase782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool783 = alloc_Boolean(1);
// compiled identifier node returning bool783 (depth = 2)
  gc_frame_end(frame);
  return bool783;
}
Object meth_ast_visitTryCatch784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTryCatch");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool785 = alloc_Boolean(1);
// compiled identifier node returning bool785 (depth = 2)
  gc_frame_end(frame);
  return bool785;
}
Object meth_ast_visitMethodType786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethodType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool787 = alloc_Boolean(1);
// compiled identifier node returning bool787 (depth = 2)
  gc_frame_end(frame);
  return bool787;
}
Object meth_ast_visitSignaturePart788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitSignaturePart");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool789 = alloc_Boolean(1);
// compiled identifier node returning bool789 (depth = 2)
  gc_frame_end(frame);
  return bool789;
}
Object meth_ast_visitTypeDec790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool791 = alloc_Boolean(1);
// compiled identifier node returning bool791 (depth = 2)
  gc_frame_end(frame);
  return bool791;
}
Object meth_ast_visitTypeLiteral792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeLiteral");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool793 = alloc_Boolean(1);
// compiled identifier node returning bool793 (depth = 2)
  gc_frame_end(frame);
  return bool793;
}
Object meth_ast_visitTypeParameters794(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeParameters");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool795 = alloc_Boolean(1);
// compiled identifier node returning bool795 (depth = 2)
  gc_frame_end(frame);
  return bool795;
}
Object meth_ast_visitMethod796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethod");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool797 = alloc_Boolean(1);
// compiled identifier node returning bool797 (depth = 2)
  gc_frame_end(frame);
  return bool797;
}
Object meth_ast_visitCall798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool799 = alloc_Boolean(1);
// compiled identifier node returning bool799 (depth = 2)
  gc_frame_end(frame);
  return bool799;
}
Object meth_ast_visitObject800(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitObject (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitObject");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool801 = alloc_Boolean(1);
// compiled identifier node returning bool801 (depth = 2)
  gc_frame_end(frame);
  return bool801;
}
Object meth_ast_visitModule802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitModule (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitModule");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool803 = alloc_Boolean(1);
// compiled identifier node returning bool803 (depth = 2)
  gc_frame_end(frame);
  return bool803;
}
Object meth_ast_visitArray804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitArray");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool805 = alloc_Boolean(1);
// compiled identifier node returning bool805 (depth = 2)
  gc_frame_end(frame);
  return bool805;
}
Object meth_ast_visitMember806(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMember (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMember");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool807 = alloc_Boolean(1);
// compiled identifier node returning bool807 (depth = 2)
  gc_frame_end(frame);
  return bool807;
}
Object meth_ast_visitGeneric808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitGeneric");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool809 = alloc_Boolean(1);
// compiled identifier node returning bool809 (depth = 2)
  gc_frame_end(frame);
  return bool809;
}
Object meth_ast_visitIdentifier810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIdentifier");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool811 = alloc_Boolean(1);
// compiled identifier node returning bool811 (depth = 2)
  gc_frame_end(frame);
  return bool811;
}
Object meth_ast_visitString812(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool813 = alloc_Boolean(1);
// compiled identifier node returning bool813 (depth = 2)
  gc_frame_end(frame);
  return bool813;
}
Object meth_ast_visitNum814(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitNum (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitNum");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool815 = alloc_Boolean(1);
// compiled identifier node returning bool815 (depth = 2)
  gc_frame_end(frame);
  return bool815;
}
Object meth_ast_visitOp816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitOp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitOp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool817 = alloc_Boolean(1);
// compiled identifier node returning bool817 (depth = 2)
  gc_frame_end(frame);
  return bool817;
}
Object meth_ast_visitIndex818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIndex");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIndex (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIndex");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool819 = alloc_Boolean(1);
// compiled identifier node returning bool819 (depth = 2)
  gc_frame_end(frame);
  return bool819;
}
Object meth_ast_visitBind820(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBind (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBind");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool821 = alloc_Boolean(1);
// compiled identifier node returning bool821 (depth = 2)
  gc_frame_end(frame);
  return bool821;
}
Object meth_ast_visitDefDec822(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDefDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool823 = alloc_Boolean(1);
// compiled identifier node returning bool823 (depth = 2)
  gc_frame_end(frame);
  return bool823;
}
Object meth_ast_visitVarDec824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitVarDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool825 = alloc_Boolean(1);
// compiled identifier node returning bool825 (depth = 2)
  gc_frame_end(frame);
  return bool825;
}
Object meth_ast_visitImport826(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool827 = alloc_Boolean(1);
// compiled identifier node returning bool827 (depth = 2)
  gc_frame_end(frame);
  return bool827;
}
Object meth_ast_visitReturn828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitReturn");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool829 = alloc_Boolean(1);
// compiled identifier node returning bool829 (depth = 2)
  gc_frame_end(frame);
  return bool829;
}
Object meth_ast_visitInherits830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitInherits");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool831 = alloc_Boolean(1);
// compiled identifier node returning bool831 (depth = 2)
  gc_frame_end(frame);
  return bool831;
}
Object meth_ast_visitDialect832(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDialect");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool833 = alloc_Boolean(1);
// compiled identifier node returning bool833 (depth = 2)
  gc_frame_end(frame);
  return bool833;
}
Object meth_ast_visitBlank834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlank");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool835 = alloc_Boolean(1);
// compiled identifier node returning bool835 (depth = 2)
  gc_frame_end(frame);
  return bool835;
}
Object meth_ast_visitComment836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitComment (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitComment");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool837 = alloc_Boolean(1);
// compiled identifier node returning bool837 (depth = 2)
  gc_frame_end(frame);
  return bool837;
}
Object meth_ast_asString838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit839 == NULL) {
    strlit839 = alloc_String("an AST visitor");
    gc_root(strlit839);
  }
// compiled string node returning strlit839 (depth = 2)
  gc_frame_end(frame);
  return strlit839;
}
Object meth_ast_baseVisitor685(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject686 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj686 = alloc_userobj2(61,62, objclass686);
  gc_frame_newslot(obj686);
if (objclass686 == NULL) {
  glfree(obj686->class->name);
  obj686->class->name = "baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj686, self, 0);
  addmethodreal(obj686,"outer", &reader_ast_outer_687);
  Object oldself686 = self;
  struct StackFrameObject *oldstackframe686 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe686);
  gc_frame_newslot((Object)stackframe);
  self = obj686;
  Object *oldselfslot686 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter686 = (*(struct UserObject *)self).data[0], lowerouter686 = thisouter686;
  if (inheritingObject686) {
    struct UserObject *inho686 = (struct UserObject *)inheritingObject686;
    while (inho686->super != GraceDefaultObject) inho686 = (struct UserObject *)inho686->super;
    inho686->super = obj686;
    self = inheritingObject686;
    *selfslot = self;
    lowerouter686 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter686;
  }
// method "visitIf()up"
  struct UserObject *uo688 = (struct UserObject*)obj686;
  uo688->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up688 = addmethod2pos(obj686, "visitIf()up", &meth_ast_visitIf_40__41_up688, 1);
  int argcv_meth_ast_visitIf_40__41_up688[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up688->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up688);
  meth_meth_ast_visitIf_40__41_up688->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up688->definitionLine = 2761;
// method "visitBlock()up"
  struct UserObject *uo691 = (struct UserObject*)obj686;
  uo691->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up691 = addmethod2pos(obj686, "visitBlock()up", &meth_ast_visitBlock_40__41_up691, 2);
  int argcv_meth_ast_visitBlock_40__41_up691[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up691->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up691);
  meth_meth_ast_visitBlock_40__41_up691->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up691->definitionLine = 2762;
// method "visitMatchCase()up"
  struct UserObject *uo694 = (struct UserObject*)obj686;
  uo694->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up694 = addmethod2pos(obj686, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up694, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up694[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up694->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up694);
  meth_meth_ast_visitMatchCase_40__41_up694->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up694->definitionLine = 2763;
// method "visitTryCatch()up"
  struct UserObject *uo697 = (struct UserObject*)obj686;
  uo697->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40__41_up697 = addmethod2pos(obj686, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up697, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up697[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up697->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up697);
  meth_meth_ast_visitTryCatch_40__41_up697->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up697->definitionLine = 2764;
// method "visitMethodType()up"
  struct UserObject *uo700 = (struct UserObject*)obj686;
  uo700->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up700 = addmethod2pos(obj686, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up700, 5);
  int argcv_meth_ast_visitMethodType_40__41_up700[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up700->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up700);
  meth_meth_ast_visitMethodType_40__41_up700->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up700->definitionLine = 2765;
// method "visitSignaturePart()up"
  struct UserObject *uo703 = (struct UserObject*)obj686;
  uo703->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up703 = addmethod2pos(obj686, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up703, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up703[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up703->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up703);
  meth_meth_ast_visitSignaturePart_40__41_up703->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up703->definitionLine = 2766;
// method "visitTypeDec()up"
  struct UserObject *uo706 = (struct UserObject*)obj686;
  uo706->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up706 = addmethod2pos(obj686, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up706, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up706[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up706->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up706);
  meth_meth_ast_visitTypeDec_40__41_up706->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up706->definitionLine = 2767;
// method "visitTypeLiteral()up"
  struct UserObject *uo709 = (struct UserObject*)obj686;
  uo709->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up709 = addmethod2pos(obj686, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up709, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up709[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up709->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up709);
  meth_meth_ast_visitTypeLiteral_40__41_up709->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up709->definitionLine = 2768;
// method "visitTypeParameters()up"
  struct UserObject *uo712 = (struct UserObject*)obj686;
  uo712->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40__41_up712 = addmethod2pos(obj686, "visitTypeParameters()up", &meth_ast_visitTypeParameters_40__41_up712, 9);
  int argcv_meth_ast_visitTypeParameters_40__41_up712[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40__41_up712->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40__41_up712);
  meth_meth_ast_visitTypeParameters_40__41_up712->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40__41_up712->definitionLine = 2769;
// method "visitMethod()up"
  struct UserObject *uo715 = (struct UserObject*)obj686;
  uo715->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up715 = addmethod2pos(obj686, "visitMethod()up", &meth_ast_visitMethod_40__41_up715, 10);
  int argcv_meth_ast_visitMethod_40__41_up715[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up715->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up715);
  meth_meth_ast_visitMethod_40__41_up715->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up715->definitionLine = 2770;
// method "visitCall()up"
  struct UserObject *uo718 = (struct UserObject*)obj686;
  uo718->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up718 = addmethod2pos(obj686, "visitCall()up", &meth_ast_visitCall_40__41_up718, 11);
  int argcv_meth_ast_visitCall_40__41_up718[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up718->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up718);
  meth_meth_ast_visitCall_40__41_up718->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up718->definitionLine = 2771;
// method "visitObject()up"
  struct UserObject *uo721 = (struct UserObject*)obj686;
  uo721->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up721 = addmethod2pos(obj686, "visitObject()up", &meth_ast_visitObject_40__41_up721, 12);
  int argcv_meth_ast_visitObject_40__41_up721[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up721->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up721);
  meth_meth_ast_visitObject_40__41_up721->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up721->definitionLine = 2772;
// method "visitModule()up"
  struct UserObject *uo724 = (struct UserObject*)obj686;
  uo724->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40__41_up724 = addmethod2pos(obj686, "visitModule()up", &meth_ast_visitModule_40__41_up724, 13);
  int argcv_meth_ast_visitModule_40__41_up724[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up724->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up724);
  meth_meth_ast_visitModule_40__41_up724->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up724->definitionLine = 2773;
// method "visitArray()up"
  struct UserObject *uo727 = (struct UserObject*)obj686;
  uo727->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up727 = addmethod2pos(obj686, "visitArray()up", &meth_ast_visitArray_40__41_up727, 14);
  int argcv_meth_ast_visitArray_40__41_up727[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up727->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up727);
  meth_meth_ast_visitArray_40__41_up727->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up727->definitionLine = 2774;
// method "visitMember()up"
  struct UserObject *uo730 = (struct UserObject*)obj686;
  uo730->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up730 = addmethod2pos(obj686, "visitMember()up", &meth_ast_visitMember_40__41_up730, 15);
  int argcv_meth_ast_visitMember_40__41_up730[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up730->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up730);
  meth_meth_ast_visitMember_40__41_up730->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up730->definitionLine = 2775;
// method "visitGeneric()up"
  struct UserObject *uo733 = (struct UserObject*)obj686;
  uo733->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up733 = addmethod2pos(obj686, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up733, 16);
  int argcv_meth_ast_visitGeneric_40__41_up733[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up733->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up733);
  meth_meth_ast_visitGeneric_40__41_up733->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up733->definitionLine = 2776;
// method "visitIdentifier()up"
  struct UserObject *uo736 = (struct UserObject*)obj686;
  uo736->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up736 = addmethod2pos(obj686, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up736, 17);
  int argcv_meth_ast_visitIdentifier_40__41_up736[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up736->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up736);
  meth_meth_ast_visitIdentifier_40__41_up736->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up736->definitionLine = 2777;
// method "visitString()up"
  struct UserObject *uo739 = (struct UserObject*)obj686;
  uo739->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up739 = addmethod2pos(obj686, "visitString()up", &meth_ast_visitString_40__41_up739, 18);
  int argcv_meth_ast_visitString_40__41_up739[] = {1, 1};
  meth_meth_ast_visitString_40__41_up739->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up739);
  meth_meth_ast_visitString_40__41_up739->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up739->definitionLine = 2778;
// method "visitNum()up"
  struct UserObject *uo742 = (struct UserObject*)obj686;
  uo742->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up742 = addmethod2pos(obj686, "visitNum()up", &meth_ast_visitNum_40__41_up742, 19);
  int argcv_meth_ast_visitNum_40__41_up742[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up742->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up742);
  meth_meth_ast_visitNum_40__41_up742->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up742->definitionLine = 2779;
// method "visitOp()up"
  struct UserObject *uo745 = (struct UserObject*)obj686;
  uo745->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up745 = addmethod2pos(obj686, "visitOp()up", &meth_ast_visitOp_40__41_up745, 20);
  int argcv_meth_ast_visitOp_40__41_up745[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up745->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up745);
  meth_meth_ast_visitOp_40__41_up745->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up745->definitionLine = 2780;
// method "visitIndex()up"
  struct UserObject *uo748 = (struct UserObject*)obj686;
  uo748->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up748 = addmethod2pos(obj686, "visitIndex()up", &meth_ast_visitIndex_40__41_up748, 21);
  int argcv_meth_ast_visitIndex_40__41_up748[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up748->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up748);
  meth_meth_ast_visitIndex_40__41_up748->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up748->definitionLine = 2781;
// method "visitBind()up"
  struct UserObject *uo751 = (struct UserObject*)obj686;
  uo751->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up751 = addmethod2pos(obj686, "visitBind()up", &meth_ast_visitBind_40__41_up751, 22);
  int argcv_meth_ast_visitBind_40__41_up751[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up751->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up751);
  meth_meth_ast_visitBind_40__41_up751->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up751->definitionLine = 2782;
// method "visitDefDec()up"
  struct UserObject *uo754 = (struct UserObject*)obj686;
  uo754->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up754 = addmethod2pos(obj686, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up754, 23);
  int argcv_meth_ast_visitDefDec_40__41_up754[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up754->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up754);
  meth_meth_ast_visitDefDec_40__41_up754->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up754->definitionLine = 2783;
// method "visitVarDec()up"
  struct UserObject *uo757 = (struct UserObject*)obj686;
  uo757->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up757 = addmethod2pos(obj686, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up757, 24);
  int argcv_meth_ast_visitVarDec_40__41_up757[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up757->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up757);
  meth_meth_ast_visitVarDec_40__41_up757->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up757->definitionLine = 2784;
// method "visitImport()up"
  struct UserObject *uo760 = (struct UserObject*)obj686;
  uo760->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up760 = addmethod2pos(obj686, "visitImport()up", &meth_ast_visitImport_40__41_up760, 25);
  int argcv_meth_ast_visitImport_40__41_up760[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up760->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up760);
  meth_meth_ast_visitImport_40__41_up760->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up760->definitionLine = 2785;
// method "visitReturn()up"
  struct UserObject *uo763 = (struct UserObject*)obj686;
  uo763->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up763 = addmethod2pos(obj686, "visitReturn()up", &meth_ast_visitReturn_40__41_up763, 26);
  int argcv_meth_ast_visitReturn_40__41_up763[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up763->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up763);
  meth_meth_ast_visitReturn_40__41_up763->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up763->definitionLine = 2786;
// method "visitInherits()up"
  struct UserObject *uo766 = (struct UserObject*)obj686;
  uo766->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up766 = addmethod2pos(obj686, "visitInherits()up", &meth_ast_visitInherits_40__41_up766, 27);
  int argcv_meth_ast_visitInherits_40__41_up766[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up766->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up766);
  meth_meth_ast_visitInherits_40__41_up766->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up766->definitionLine = 2787;
// method "visitDialect()up"
  struct UserObject *uo769 = (struct UserObject*)obj686;
  uo769->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up769 = addmethod2pos(obj686, "visitDialect()up", &meth_ast_visitDialect_40__41_up769, 28);
  int argcv_meth_ast_visitDialect_40__41_up769[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up769->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up769);
  meth_meth_ast_visitDialect_40__41_up769->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up769->definitionLine = 2788;
// method "visitBlank()up"
  struct UserObject *uo772 = (struct UserObject*)obj686;
  uo772->data[29] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40__41_up772 = addmethod2pos(obj686, "visitBlank()up", &meth_ast_visitBlank_40__41_up772, 29);
  int argcv_meth_ast_visitBlank_40__41_up772[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up772->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up772);
  meth_meth_ast_visitBlank_40__41_up772->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up772->definitionLine = 2789;
// method "visitComment()up"
  struct UserObject *uo775 = (struct UserObject*)obj686;
  uo775->data[30] = emptyclosure;
  Method *meth_meth_ast_visitComment_40__41_up775 = addmethod2pos(obj686, "visitComment()up", &meth_ast_visitComment_40__41_up775, 30);
  int argcv_meth_ast_visitComment_40__41_up775[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up775->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up775);
  meth_meth_ast_visitComment_40__41_up775->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up775->definitionLine = 2790;
// method "visitIf"
  struct UserObject *uo778 = (struct UserObject*)obj686;
  uo778->data[31] = emptyclosure;
  Method *meth_meth_ast_visitIf778 = addmethod2pos(obj686, "visitIf", &meth_ast_visitIf778, 31);
  int argcv_meth_ast_visitIf778[] = {1};
  meth_meth_ast_visitIf778->type = alloc_MethodType(1, argcv_meth_ast_visitIf778);
  meth_meth_ast_visitIf778->definitionModule = modulename;
  meth_meth_ast_visitIf778->definitionLine = 2792;
// method "visitBlock"
  struct UserObject *uo780 = (struct UserObject*)obj686;
  uo780->data[32] = emptyclosure;
  Method *meth_meth_ast_visitBlock780 = addmethod2pos(obj686, "visitBlock", &meth_ast_visitBlock780, 32);
  int argcv_meth_ast_visitBlock780[] = {1};
  meth_meth_ast_visitBlock780->type = alloc_MethodType(1, argcv_meth_ast_visitBlock780);
  meth_meth_ast_visitBlock780->definitionModule = modulename;
  meth_meth_ast_visitBlock780->definitionLine = 2793;
// method "visitMatchCase"
  struct UserObject *uo782 = (struct UserObject*)obj686;
  uo782->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase782 = addmethod2pos(obj686, "visitMatchCase", &meth_ast_visitMatchCase782, 33);
  int argcv_meth_ast_visitMatchCase782[] = {1};
  meth_meth_ast_visitMatchCase782->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase782);
  meth_meth_ast_visitMatchCase782->definitionModule = modulename;
  meth_meth_ast_visitMatchCase782->definitionLine = 2794;
// method "visitTryCatch"
  struct UserObject *uo784 = (struct UserObject*)obj686;
  uo784->data[34] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch784 = addmethod2pos(obj686, "visitTryCatch", &meth_ast_visitTryCatch784, 34);
  int argcv_meth_ast_visitTryCatch784[] = {1};
  meth_meth_ast_visitTryCatch784->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch784);
  meth_meth_ast_visitTryCatch784->definitionModule = modulename;
  meth_meth_ast_visitTryCatch784->definitionLine = 2795;
// method "visitMethodType"
  struct UserObject *uo786 = (struct UserObject*)obj686;
  uo786->data[35] = emptyclosure;
  Method *meth_meth_ast_visitMethodType786 = addmethod2pos(obj686, "visitMethodType", &meth_ast_visitMethodType786, 35);
  int argcv_meth_ast_visitMethodType786[] = {1};
  meth_meth_ast_visitMethodType786->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType786);
  meth_meth_ast_visitMethodType786->definitionModule = modulename;
  meth_meth_ast_visitMethodType786->definitionLine = 2796;
// method "visitSignaturePart"
  struct UserObject *uo788 = (struct UserObject*)obj686;
  uo788->data[36] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart788 = addmethod2pos(obj686, "visitSignaturePart", &meth_ast_visitSignaturePart788, 36);
  int argcv_meth_ast_visitSignaturePart788[] = {1};
  meth_meth_ast_visitSignaturePart788->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart788);
  meth_meth_ast_visitSignaturePart788->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart788->definitionLine = 2797;
// method "visitTypeDec"
  struct UserObject *uo790 = (struct UserObject*)obj686;
  uo790->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec790 = addmethod2pos(obj686, "visitTypeDec", &meth_ast_visitTypeDec790, 37);
  int argcv_meth_ast_visitTypeDec790[] = {1};
  meth_meth_ast_visitTypeDec790->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec790);
  meth_meth_ast_visitTypeDec790->definitionModule = modulename;
  meth_meth_ast_visitTypeDec790->definitionLine = 2798;
// method "visitTypeLiteral"
  struct UserObject *uo792 = (struct UserObject*)obj686;
  uo792->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral792 = addmethod2pos(obj686, "visitTypeLiteral", &meth_ast_visitTypeLiteral792, 38);
  int argcv_meth_ast_visitTypeLiteral792[] = {1};
  meth_meth_ast_visitTypeLiteral792->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral792);
  meth_meth_ast_visitTypeLiteral792->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral792->definitionLine = 2799;
// method "visitTypeParameters"
  struct UserObject *uo794 = (struct UserObject*)obj686;
  uo794->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters794 = addmethod2pos(obj686, "visitTypeParameters", &meth_ast_visitTypeParameters794, 39);
  int argcv_meth_ast_visitTypeParameters794[] = {1};
  meth_meth_ast_visitTypeParameters794->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters794);
  meth_meth_ast_visitTypeParameters794->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters794->definitionLine = 2800;
// method "visitMethod"
  struct UserObject *uo796 = (struct UserObject*)obj686;
  uo796->data[40] = emptyclosure;
  Method *meth_meth_ast_visitMethod796 = addmethod2pos(obj686, "visitMethod", &meth_ast_visitMethod796, 40);
  int argcv_meth_ast_visitMethod796[] = {1};
  meth_meth_ast_visitMethod796->type = alloc_MethodType(1, argcv_meth_ast_visitMethod796);
  meth_meth_ast_visitMethod796->definitionModule = modulename;
  meth_meth_ast_visitMethod796->definitionLine = 2801;
// method "visitCall"
  struct UserObject *uo798 = (struct UserObject*)obj686;
  uo798->data[41] = emptyclosure;
  Method *meth_meth_ast_visitCall798 = addmethod2pos(obj686, "visitCall", &meth_ast_visitCall798, 41);
  int argcv_meth_ast_visitCall798[] = {1};
  meth_meth_ast_visitCall798->type = alloc_MethodType(1, argcv_meth_ast_visitCall798);
  meth_meth_ast_visitCall798->definitionModule = modulename;
  meth_meth_ast_visitCall798->definitionLine = 2802;
// method "visitObject"
  struct UserObject *uo800 = (struct UserObject*)obj686;
  uo800->data[42] = emptyclosure;
  Method *meth_meth_ast_visitObject800 = addmethod2pos(obj686, "visitObject", &meth_ast_visitObject800, 42);
  int argcv_meth_ast_visitObject800[] = {1};
  meth_meth_ast_visitObject800->type = alloc_MethodType(1, argcv_meth_ast_visitObject800);
  meth_meth_ast_visitObject800->definitionModule = modulename;
  meth_meth_ast_visitObject800->definitionLine = 2803;
// method "visitModule"
  struct UserObject *uo802 = (struct UserObject*)obj686;
  uo802->data[43] = emptyclosure;
  Method *meth_meth_ast_visitModule802 = addmethod2pos(obj686, "visitModule", &meth_ast_visitModule802, 43);
  int argcv_meth_ast_visitModule802[] = {1};
  meth_meth_ast_visitModule802->type = alloc_MethodType(1, argcv_meth_ast_visitModule802);
  meth_meth_ast_visitModule802->definitionModule = modulename;
  meth_meth_ast_visitModule802->definitionLine = 2804;
// method "visitArray"
  struct UserObject *uo804 = (struct UserObject*)obj686;
  uo804->data[44] = emptyclosure;
  Method *meth_meth_ast_visitArray804 = addmethod2pos(obj686, "visitArray", &meth_ast_visitArray804, 44);
  int argcv_meth_ast_visitArray804[] = {1};
  meth_meth_ast_visitArray804->type = alloc_MethodType(1, argcv_meth_ast_visitArray804);
  meth_meth_ast_visitArray804->definitionModule = modulename;
  meth_meth_ast_visitArray804->definitionLine = 2805;
// method "visitMember"
  struct UserObject *uo806 = (struct UserObject*)obj686;
  uo806->data[45] = emptyclosure;
  Method *meth_meth_ast_visitMember806 = addmethod2pos(obj686, "visitMember", &meth_ast_visitMember806, 45);
  int argcv_meth_ast_visitMember806[] = {1};
  meth_meth_ast_visitMember806->type = alloc_MethodType(1, argcv_meth_ast_visitMember806);
  meth_meth_ast_visitMember806->definitionModule = modulename;
  meth_meth_ast_visitMember806->definitionLine = 2806;
// method "visitGeneric"
  struct UserObject *uo808 = (struct UserObject*)obj686;
  uo808->data[46] = emptyclosure;
  Method *meth_meth_ast_visitGeneric808 = addmethod2pos(obj686, "visitGeneric", &meth_ast_visitGeneric808, 46);
  int argcv_meth_ast_visitGeneric808[] = {1};
  meth_meth_ast_visitGeneric808->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric808);
  meth_meth_ast_visitGeneric808->definitionModule = modulename;
  meth_meth_ast_visitGeneric808->definitionLine = 2807;
// method "visitIdentifier"
  struct UserObject *uo810 = (struct UserObject*)obj686;
  uo810->data[47] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier810 = addmethod2pos(obj686, "visitIdentifier", &meth_ast_visitIdentifier810, 47);
  int argcv_meth_ast_visitIdentifier810[] = {1};
  meth_meth_ast_visitIdentifier810->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier810);
  meth_meth_ast_visitIdentifier810->definitionModule = modulename;
  meth_meth_ast_visitIdentifier810->definitionLine = 2808;
// method "visitString"
  struct UserObject *uo812 = (struct UserObject*)obj686;
  uo812->data[48] = emptyclosure;
  Method *meth_meth_ast_visitString812 = addmethod2pos(obj686, "visitString", &meth_ast_visitString812, 48);
  int argcv_meth_ast_visitString812[] = {1};
  meth_meth_ast_visitString812->type = alloc_MethodType(1, argcv_meth_ast_visitString812);
  meth_meth_ast_visitString812->definitionModule = modulename;
  meth_meth_ast_visitString812->definitionLine = 2809;
// method "visitNum"
  struct UserObject *uo814 = (struct UserObject*)obj686;
  uo814->data[49] = emptyclosure;
  Method *meth_meth_ast_visitNum814 = addmethod2pos(obj686, "visitNum", &meth_ast_visitNum814, 49);
  int argcv_meth_ast_visitNum814[] = {1};
  meth_meth_ast_visitNum814->type = alloc_MethodType(1, argcv_meth_ast_visitNum814);
  meth_meth_ast_visitNum814->definitionModule = modulename;
  meth_meth_ast_visitNum814->definitionLine = 2810;
// method "visitOp"
  struct UserObject *uo816 = (struct UserObject*)obj686;
  uo816->data[50] = emptyclosure;
  Method *meth_meth_ast_visitOp816 = addmethod2pos(obj686, "visitOp", &meth_ast_visitOp816, 50);
  int argcv_meth_ast_visitOp816[] = {1};
  meth_meth_ast_visitOp816->type = alloc_MethodType(1, argcv_meth_ast_visitOp816);
  meth_meth_ast_visitOp816->definitionModule = modulename;
  meth_meth_ast_visitOp816->definitionLine = 2811;
// method "visitIndex"
  struct UserObject *uo818 = (struct UserObject*)obj686;
  uo818->data[51] = emptyclosure;
  Method *meth_meth_ast_visitIndex818 = addmethod2pos(obj686, "visitIndex", &meth_ast_visitIndex818, 51);
  int argcv_meth_ast_visitIndex818[] = {1};
  meth_meth_ast_visitIndex818->type = alloc_MethodType(1, argcv_meth_ast_visitIndex818);
  meth_meth_ast_visitIndex818->definitionModule = modulename;
  meth_meth_ast_visitIndex818->definitionLine = 2812;
// method "visitBind"
  struct UserObject *uo820 = (struct UserObject*)obj686;
  uo820->data[52] = emptyclosure;
  Method *meth_meth_ast_visitBind820 = addmethod2pos(obj686, "visitBind", &meth_ast_visitBind820, 52);
  int argcv_meth_ast_visitBind820[] = {1};
  meth_meth_ast_visitBind820->type = alloc_MethodType(1, argcv_meth_ast_visitBind820);
  meth_meth_ast_visitBind820->definitionModule = modulename;
  meth_meth_ast_visitBind820->definitionLine = 2813;
// method "visitDefDec"
  struct UserObject *uo822 = (struct UserObject*)obj686;
  uo822->data[53] = emptyclosure;
  Method *meth_meth_ast_visitDefDec822 = addmethod2pos(obj686, "visitDefDec", &meth_ast_visitDefDec822, 53);
  int argcv_meth_ast_visitDefDec822[] = {1};
  meth_meth_ast_visitDefDec822->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec822);
  meth_meth_ast_visitDefDec822->definitionModule = modulename;
  meth_meth_ast_visitDefDec822->definitionLine = 2814;
// method "visitVarDec"
  struct UserObject *uo824 = (struct UserObject*)obj686;
  uo824->data[54] = emptyclosure;
  Method *meth_meth_ast_visitVarDec824 = addmethod2pos(obj686, "visitVarDec", &meth_ast_visitVarDec824, 54);
  int argcv_meth_ast_visitVarDec824[] = {1};
  meth_meth_ast_visitVarDec824->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec824);
  meth_meth_ast_visitVarDec824->definitionModule = modulename;
  meth_meth_ast_visitVarDec824->definitionLine = 2815;
// method "visitImport"
  struct UserObject *uo826 = (struct UserObject*)obj686;
  uo826->data[55] = emptyclosure;
  Method *meth_meth_ast_visitImport826 = addmethod2pos(obj686, "visitImport", &meth_ast_visitImport826, 55);
  int argcv_meth_ast_visitImport826[] = {1};
  meth_meth_ast_visitImport826->type = alloc_MethodType(1, argcv_meth_ast_visitImport826);
  meth_meth_ast_visitImport826->definitionModule = modulename;
  meth_meth_ast_visitImport826->definitionLine = 2816;
// method "visitReturn"
  struct UserObject *uo828 = (struct UserObject*)obj686;
  uo828->data[56] = emptyclosure;
  Method *meth_meth_ast_visitReturn828 = addmethod2pos(obj686, "visitReturn", &meth_ast_visitReturn828, 56);
  int argcv_meth_ast_visitReturn828[] = {1};
  meth_meth_ast_visitReturn828->type = alloc_MethodType(1, argcv_meth_ast_visitReturn828);
  meth_meth_ast_visitReturn828->definitionModule = modulename;
  meth_meth_ast_visitReturn828->definitionLine = 2817;
// method "visitInherits"
  struct UserObject *uo830 = (struct UserObject*)obj686;
  uo830->data[57] = emptyclosure;
  Method *meth_meth_ast_visitInherits830 = addmethod2pos(obj686, "visitInherits", &meth_ast_visitInherits830, 57);
  int argcv_meth_ast_visitInherits830[] = {1};
  meth_meth_ast_visitInherits830->type = alloc_MethodType(1, argcv_meth_ast_visitInherits830);
  meth_meth_ast_visitInherits830->definitionModule = modulename;
  meth_meth_ast_visitInherits830->definitionLine = 2818;
// method "visitDialect"
  struct UserObject *uo832 = (struct UserObject*)obj686;
  uo832->data[58] = emptyclosure;
  Method *meth_meth_ast_visitDialect832 = addmethod2pos(obj686, "visitDialect", &meth_ast_visitDialect832, 58);
  int argcv_meth_ast_visitDialect832[] = {1};
  meth_meth_ast_visitDialect832->type = alloc_MethodType(1, argcv_meth_ast_visitDialect832);
  meth_meth_ast_visitDialect832->definitionModule = modulename;
  meth_meth_ast_visitDialect832->definitionLine = 2819;
// method "visitBlank"
  struct UserObject *uo834 = (struct UserObject*)obj686;
  uo834->data[59] = emptyclosure;
  Method *meth_meth_ast_visitBlank834 = addmethod2pos(obj686, "visitBlank", &meth_ast_visitBlank834, 59);
  int argcv_meth_ast_visitBlank834[] = {1};
  meth_meth_ast_visitBlank834->type = alloc_MethodType(1, argcv_meth_ast_visitBlank834);
  meth_meth_ast_visitBlank834->definitionModule = modulename;
  meth_meth_ast_visitBlank834->definitionLine = 2820;
// method "visitComment"
  struct UserObject *uo836 = (struct UserObject*)obj686;
  uo836->data[60] = emptyclosure;
  Method *meth_meth_ast_visitComment836 = addmethod2pos(obj686, "visitComment", &meth_ast_visitComment836, 60);
  int argcv_meth_ast_visitComment836[] = {1};
  meth_meth_ast_visitComment836->type = alloc_MethodType(1, argcv_meth_ast_visitComment836);
  meth_meth_ast_visitComment836->definitionModule = modulename;
  meth_meth_ast_visitComment836->definitionLine = 2821;
// method "asString"
  struct UserObject *uo838 = (struct UserObject*)obj686;
  uo838->data[61] = emptyclosure;
  Method *meth_meth_ast_asString838 = addmethod2pos(obj686, "asString", &meth_ast_asString838, 61);
  int argcv_meth_ast_asString838[] = {0};
  meth_meth_ast_asString838->type = alloc_MethodType(1, argcv_meth_ast_asString838);
  meth_meth_ast_asString838->definitionModule = modulename;
  meth_meth_ast_asString838->definitionLine = 2823;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  objclass686 = obj686->class;
  objclass686->definitionModule = modulename;
  objclass686->definitionLine = 2760;
  (*(struct UserObject *)self).data[0] = lowerouter686;
  self = oldself686;
  selfslot = oldselfslot686;
  stackframe = oldstackframe686;
  gc_frame_end(frame);
  return obj686;
}
Object meth_ast_baseVisitor685_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject686 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj686 = alloc_userobj2(61,62, objclass686);
  gc_frame_newslot(obj686);
if (objclass686 == NULL) {
  glfree(obj686->class->name);
  obj686->class->name = "baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj686, self, 0);
  addmethodreal(obj686,"outer", &reader_ast_outer_687);
  Object oldself686 = self;
  struct StackFrameObject *oldstackframe686 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe686);
  gc_frame_newslot((Object)stackframe);
  self = obj686;
  Object *oldselfslot686 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter686 = (*(struct UserObject *)self).data[0], lowerouter686 = thisouter686;
  if (inheritingObject686) {
    struct UserObject *inho686 = (struct UserObject *)inheritingObject686;
    while (inho686->super != GraceDefaultObject) inho686 = (struct UserObject *)inho686->super;
    inho686->super = obj686;
    self = inheritingObject686;
    *selfslot = self;
    lowerouter686 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter686;
  }
// method "visitIf()up"
  struct UserObject *uo688 = (struct UserObject*)obj686;
  uo688->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up688 = addmethod2pos(obj686, "visitIf()up", &meth_ast_visitIf_40__41_up688, 1);
  int argcv_meth_ast_visitIf_40__41_up688[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up688->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up688);
  meth_meth_ast_visitIf_40__41_up688->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up688->definitionLine = 2761;
// method "visitBlock()up"
  struct UserObject *uo691 = (struct UserObject*)obj686;
  uo691->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up691 = addmethod2pos(obj686, "visitBlock()up", &meth_ast_visitBlock_40__41_up691, 2);
  int argcv_meth_ast_visitBlock_40__41_up691[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up691->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up691);
  meth_meth_ast_visitBlock_40__41_up691->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up691->definitionLine = 2762;
// method "visitMatchCase()up"
  struct UserObject *uo694 = (struct UserObject*)obj686;
  uo694->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up694 = addmethod2pos(obj686, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up694, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up694[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up694->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up694);
  meth_meth_ast_visitMatchCase_40__41_up694->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up694->definitionLine = 2763;
// method "visitTryCatch()up"
  struct UserObject *uo697 = (struct UserObject*)obj686;
  uo697->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40__41_up697 = addmethod2pos(obj686, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up697, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up697[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up697->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up697);
  meth_meth_ast_visitTryCatch_40__41_up697->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up697->definitionLine = 2764;
// method "visitMethodType()up"
  struct UserObject *uo700 = (struct UserObject*)obj686;
  uo700->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up700 = addmethod2pos(obj686, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up700, 5);
  int argcv_meth_ast_visitMethodType_40__41_up700[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up700->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up700);
  meth_meth_ast_visitMethodType_40__41_up700->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up700->definitionLine = 2765;
// method "visitSignaturePart()up"
  struct UserObject *uo703 = (struct UserObject*)obj686;
  uo703->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up703 = addmethod2pos(obj686, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up703, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up703[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up703->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up703);
  meth_meth_ast_visitSignaturePart_40__41_up703->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up703->definitionLine = 2766;
// method "visitTypeDec()up"
  struct UserObject *uo706 = (struct UserObject*)obj686;
  uo706->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up706 = addmethod2pos(obj686, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up706, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up706[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up706->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up706);
  meth_meth_ast_visitTypeDec_40__41_up706->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up706->definitionLine = 2767;
// method "visitTypeLiteral()up"
  struct UserObject *uo709 = (struct UserObject*)obj686;
  uo709->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up709 = addmethod2pos(obj686, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up709, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up709[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up709->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up709);
  meth_meth_ast_visitTypeLiteral_40__41_up709->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up709->definitionLine = 2768;
// method "visitTypeParameters()up"
  struct UserObject *uo712 = (struct UserObject*)obj686;
  uo712->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40__41_up712 = addmethod2pos(obj686, "visitTypeParameters()up", &meth_ast_visitTypeParameters_40__41_up712, 9);
  int argcv_meth_ast_visitTypeParameters_40__41_up712[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40__41_up712->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40__41_up712);
  meth_meth_ast_visitTypeParameters_40__41_up712->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40__41_up712->definitionLine = 2769;
// method "visitMethod()up"
  struct UserObject *uo715 = (struct UserObject*)obj686;
  uo715->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up715 = addmethod2pos(obj686, "visitMethod()up", &meth_ast_visitMethod_40__41_up715, 10);
  int argcv_meth_ast_visitMethod_40__41_up715[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up715->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up715);
  meth_meth_ast_visitMethod_40__41_up715->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up715->definitionLine = 2770;
// method "visitCall()up"
  struct UserObject *uo718 = (struct UserObject*)obj686;
  uo718->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up718 = addmethod2pos(obj686, "visitCall()up", &meth_ast_visitCall_40__41_up718, 11);
  int argcv_meth_ast_visitCall_40__41_up718[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up718->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up718);
  meth_meth_ast_visitCall_40__41_up718->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up718->definitionLine = 2771;
// method "visitObject()up"
  struct UserObject *uo721 = (struct UserObject*)obj686;
  uo721->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up721 = addmethod2pos(obj686, "visitObject()up", &meth_ast_visitObject_40__41_up721, 12);
  int argcv_meth_ast_visitObject_40__41_up721[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up721->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up721);
  meth_meth_ast_visitObject_40__41_up721->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up721->definitionLine = 2772;
// method "visitModule()up"
  struct UserObject *uo724 = (struct UserObject*)obj686;
  uo724->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40__41_up724 = addmethod2pos(obj686, "visitModule()up", &meth_ast_visitModule_40__41_up724, 13);
  int argcv_meth_ast_visitModule_40__41_up724[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up724->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up724);
  meth_meth_ast_visitModule_40__41_up724->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up724->definitionLine = 2773;
// method "visitArray()up"
  struct UserObject *uo727 = (struct UserObject*)obj686;
  uo727->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up727 = addmethod2pos(obj686, "visitArray()up", &meth_ast_visitArray_40__41_up727, 14);
  int argcv_meth_ast_visitArray_40__41_up727[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up727->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up727);
  meth_meth_ast_visitArray_40__41_up727->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up727->definitionLine = 2774;
// method "visitMember()up"
  struct UserObject *uo730 = (struct UserObject*)obj686;
  uo730->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up730 = addmethod2pos(obj686, "visitMember()up", &meth_ast_visitMember_40__41_up730, 15);
  int argcv_meth_ast_visitMember_40__41_up730[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up730->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up730);
  meth_meth_ast_visitMember_40__41_up730->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up730->definitionLine = 2775;
// method "visitGeneric()up"
  struct UserObject *uo733 = (struct UserObject*)obj686;
  uo733->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up733 = addmethod2pos(obj686, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up733, 16);
  int argcv_meth_ast_visitGeneric_40__41_up733[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up733->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up733);
  meth_meth_ast_visitGeneric_40__41_up733->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up733->definitionLine = 2776;
// method "visitIdentifier()up"
  struct UserObject *uo736 = (struct UserObject*)obj686;
  uo736->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up736 = addmethod2pos(obj686, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up736, 17);
  int argcv_meth_ast_visitIdentifier_40__41_up736[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up736->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up736);
  meth_meth_ast_visitIdentifier_40__41_up736->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up736->definitionLine = 2777;
// method "visitString()up"
  struct UserObject *uo739 = (struct UserObject*)obj686;
  uo739->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up739 = addmethod2pos(obj686, "visitString()up", &meth_ast_visitString_40__41_up739, 18);
  int argcv_meth_ast_visitString_40__41_up739[] = {1, 1};
  meth_meth_ast_visitString_40__41_up739->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up739);
  meth_meth_ast_visitString_40__41_up739->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up739->definitionLine = 2778;
// method "visitNum()up"
  struct UserObject *uo742 = (struct UserObject*)obj686;
  uo742->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up742 = addmethod2pos(obj686, "visitNum()up", &meth_ast_visitNum_40__41_up742, 19);
  int argcv_meth_ast_visitNum_40__41_up742[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up742->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up742);
  meth_meth_ast_visitNum_40__41_up742->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up742->definitionLine = 2779;
// method "visitOp()up"
  struct UserObject *uo745 = (struct UserObject*)obj686;
  uo745->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up745 = addmethod2pos(obj686, "visitOp()up", &meth_ast_visitOp_40__41_up745, 20);
  int argcv_meth_ast_visitOp_40__41_up745[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up745->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up745);
  meth_meth_ast_visitOp_40__41_up745->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up745->definitionLine = 2780;
// method "visitIndex()up"
  struct UserObject *uo748 = (struct UserObject*)obj686;
  uo748->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up748 = addmethod2pos(obj686, "visitIndex()up", &meth_ast_visitIndex_40__41_up748, 21);
  int argcv_meth_ast_visitIndex_40__41_up748[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up748->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up748);
  meth_meth_ast_visitIndex_40__41_up748->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up748->definitionLine = 2781;
// method "visitBind()up"
  struct UserObject *uo751 = (struct UserObject*)obj686;
  uo751->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up751 = addmethod2pos(obj686, "visitBind()up", &meth_ast_visitBind_40__41_up751, 22);
  int argcv_meth_ast_visitBind_40__41_up751[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up751->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up751);
  meth_meth_ast_visitBind_40__41_up751->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up751->definitionLine = 2782;
// method "visitDefDec()up"
  struct UserObject *uo754 = (struct UserObject*)obj686;
  uo754->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up754 = addmethod2pos(obj686, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up754, 23);
  int argcv_meth_ast_visitDefDec_40__41_up754[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up754->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up754);
  meth_meth_ast_visitDefDec_40__41_up754->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up754->definitionLine = 2783;
// method "visitVarDec()up"
  struct UserObject *uo757 = (struct UserObject*)obj686;
  uo757->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up757 = addmethod2pos(obj686, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up757, 24);
  int argcv_meth_ast_visitVarDec_40__41_up757[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up757->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up757);
  meth_meth_ast_visitVarDec_40__41_up757->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up757->definitionLine = 2784;
// method "visitImport()up"
  struct UserObject *uo760 = (struct UserObject*)obj686;
  uo760->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up760 = addmethod2pos(obj686, "visitImport()up", &meth_ast_visitImport_40__41_up760, 25);
  int argcv_meth_ast_visitImport_40__41_up760[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up760->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up760);
  meth_meth_ast_visitImport_40__41_up760->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up760->definitionLine = 2785;
// method "visitReturn()up"
  struct UserObject *uo763 = (struct UserObject*)obj686;
  uo763->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up763 = addmethod2pos(obj686, "visitReturn()up", &meth_ast_visitReturn_40__41_up763, 26);
  int argcv_meth_ast_visitReturn_40__41_up763[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up763->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up763);
  meth_meth_ast_visitReturn_40__41_up763->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up763->definitionLine = 2786;
// method "visitInherits()up"
  struct UserObject *uo766 = (struct UserObject*)obj686;
  uo766->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up766 = addmethod2pos(obj686, "visitInherits()up", &meth_ast_visitInherits_40__41_up766, 27);
  int argcv_meth_ast_visitInherits_40__41_up766[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up766->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up766);
  meth_meth_ast_visitInherits_40__41_up766->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up766->definitionLine = 2787;
// method "visitDialect()up"
  struct UserObject *uo769 = (struct UserObject*)obj686;
  uo769->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up769 = addmethod2pos(obj686, "visitDialect()up", &meth_ast_visitDialect_40__41_up769, 28);
  int argcv_meth_ast_visitDialect_40__41_up769[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up769->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up769);
  meth_meth_ast_visitDialect_40__41_up769->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up769->definitionLine = 2788;
// method "visitBlank()up"
  struct UserObject *uo772 = (struct UserObject*)obj686;
  uo772->data[29] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40__41_up772 = addmethod2pos(obj686, "visitBlank()up", &meth_ast_visitBlank_40__41_up772, 29);
  int argcv_meth_ast_visitBlank_40__41_up772[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up772->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up772);
  meth_meth_ast_visitBlank_40__41_up772->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up772->definitionLine = 2789;
// method "visitComment()up"
  struct UserObject *uo775 = (struct UserObject*)obj686;
  uo775->data[30] = emptyclosure;
  Method *meth_meth_ast_visitComment_40__41_up775 = addmethod2pos(obj686, "visitComment()up", &meth_ast_visitComment_40__41_up775, 30);
  int argcv_meth_ast_visitComment_40__41_up775[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up775->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up775);
  meth_meth_ast_visitComment_40__41_up775->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up775->definitionLine = 2790;
// method "visitIf"
  struct UserObject *uo778 = (struct UserObject*)obj686;
  uo778->data[31] = emptyclosure;
  Method *meth_meth_ast_visitIf778 = addmethod2pos(obj686, "visitIf", &meth_ast_visitIf778, 31);
  int argcv_meth_ast_visitIf778[] = {1};
  meth_meth_ast_visitIf778->type = alloc_MethodType(1, argcv_meth_ast_visitIf778);
  meth_meth_ast_visitIf778->definitionModule = modulename;
  meth_meth_ast_visitIf778->definitionLine = 2792;
// method "visitBlock"
  struct UserObject *uo780 = (struct UserObject*)obj686;
  uo780->data[32] = emptyclosure;
  Method *meth_meth_ast_visitBlock780 = addmethod2pos(obj686, "visitBlock", &meth_ast_visitBlock780, 32);
  int argcv_meth_ast_visitBlock780[] = {1};
  meth_meth_ast_visitBlock780->type = alloc_MethodType(1, argcv_meth_ast_visitBlock780);
  meth_meth_ast_visitBlock780->definitionModule = modulename;
  meth_meth_ast_visitBlock780->definitionLine = 2793;
// method "visitMatchCase"
  struct UserObject *uo782 = (struct UserObject*)obj686;
  uo782->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase782 = addmethod2pos(obj686, "visitMatchCase", &meth_ast_visitMatchCase782, 33);
  int argcv_meth_ast_visitMatchCase782[] = {1};
  meth_meth_ast_visitMatchCase782->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase782);
  meth_meth_ast_visitMatchCase782->definitionModule = modulename;
  meth_meth_ast_visitMatchCase782->definitionLine = 2794;
// method "visitTryCatch"
  struct UserObject *uo784 = (struct UserObject*)obj686;
  uo784->data[34] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch784 = addmethod2pos(obj686, "visitTryCatch", &meth_ast_visitTryCatch784, 34);
  int argcv_meth_ast_visitTryCatch784[] = {1};
  meth_meth_ast_visitTryCatch784->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch784);
  meth_meth_ast_visitTryCatch784->definitionModule = modulename;
  meth_meth_ast_visitTryCatch784->definitionLine = 2795;
// method "visitMethodType"
  struct UserObject *uo786 = (struct UserObject*)obj686;
  uo786->data[35] = emptyclosure;
  Method *meth_meth_ast_visitMethodType786 = addmethod2pos(obj686, "visitMethodType", &meth_ast_visitMethodType786, 35);
  int argcv_meth_ast_visitMethodType786[] = {1};
  meth_meth_ast_visitMethodType786->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType786);
  meth_meth_ast_visitMethodType786->definitionModule = modulename;
  meth_meth_ast_visitMethodType786->definitionLine = 2796;
// method "visitSignaturePart"
  struct UserObject *uo788 = (struct UserObject*)obj686;
  uo788->data[36] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart788 = addmethod2pos(obj686, "visitSignaturePart", &meth_ast_visitSignaturePart788, 36);
  int argcv_meth_ast_visitSignaturePart788[] = {1};
  meth_meth_ast_visitSignaturePart788->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart788);
  meth_meth_ast_visitSignaturePart788->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart788->definitionLine = 2797;
// method "visitTypeDec"
  struct UserObject *uo790 = (struct UserObject*)obj686;
  uo790->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec790 = addmethod2pos(obj686, "visitTypeDec", &meth_ast_visitTypeDec790, 37);
  int argcv_meth_ast_visitTypeDec790[] = {1};
  meth_meth_ast_visitTypeDec790->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec790);
  meth_meth_ast_visitTypeDec790->definitionModule = modulename;
  meth_meth_ast_visitTypeDec790->definitionLine = 2798;
// method "visitTypeLiteral"
  struct UserObject *uo792 = (struct UserObject*)obj686;
  uo792->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral792 = addmethod2pos(obj686, "visitTypeLiteral", &meth_ast_visitTypeLiteral792, 38);
  int argcv_meth_ast_visitTypeLiteral792[] = {1};
  meth_meth_ast_visitTypeLiteral792->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral792);
  meth_meth_ast_visitTypeLiteral792->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral792->definitionLine = 2799;
// method "visitTypeParameters"
  struct UserObject *uo794 = (struct UserObject*)obj686;
  uo794->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters794 = addmethod2pos(obj686, "visitTypeParameters", &meth_ast_visitTypeParameters794, 39);
  int argcv_meth_ast_visitTypeParameters794[] = {1};
  meth_meth_ast_visitTypeParameters794->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters794);
  meth_meth_ast_visitTypeParameters794->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters794->definitionLine = 2800;
// method "visitMethod"
  struct UserObject *uo796 = (struct UserObject*)obj686;
  uo796->data[40] = emptyclosure;
  Method *meth_meth_ast_visitMethod796 = addmethod2pos(obj686, "visitMethod", &meth_ast_visitMethod796, 40);
  int argcv_meth_ast_visitMethod796[] = {1};
  meth_meth_ast_visitMethod796->type = alloc_MethodType(1, argcv_meth_ast_visitMethod796);
  meth_meth_ast_visitMethod796->definitionModule = modulename;
  meth_meth_ast_visitMethod796->definitionLine = 2801;
// method "visitCall"
  struct UserObject *uo798 = (struct UserObject*)obj686;
  uo798->data[41] = emptyclosure;
  Method *meth_meth_ast_visitCall798 = addmethod2pos(obj686, "visitCall", &meth_ast_visitCall798, 41);
  int argcv_meth_ast_visitCall798[] = {1};
  meth_meth_ast_visitCall798->type = alloc_MethodType(1, argcv_meth_ast_visitCall798);
  meth_meth_ast_visitCall798->definitionModule = modulename;
  meth_meth_ast_visitCall798->definitionLine = 2802;
// method "visitObject"
  struct UserObject *uo800 = (struct UserObject*)obj686;
  uo800->data[42] = emptyclosure;
  Method *meth_meth_ast_visitObject800 = addmethod2pos(obj686, "visitObject", &meth_ast_visitObject800, 42);
  int argcv_meth_ast_visitObject800[] = {1};
  meth_meth_ast_visitObject800->type = alloc_MethodType(1, argcv_meth_ast_visitObject800);
  meth_meth_ast_visitObject800->definitionModule = modulename;
  meth_meth_ast_visitObject800->definitionLine = 2803;
// method "visitModule"
  struct UserObject *uo802 = (struct UserObject*)obj686;
  uo802->data[43] = emptyclosure;
  Method *meth_meth_ast_visitModule802 = addmethod2pos(obj686, "visitModule", &meth_ast_visitModule802, 43);
  int argcv_meth_ast_visitModule802[] = {1};
  meth_meth_ast_visitModule802->type = alloc_MethodType(1, argcv_meth_ast_visitModule802);
  meth_meth_ast_visitModule802->definitionModule = modulename;
  meth_meth_ast_visitModule802->definitionLine = 2804;
// method "visitArray"
  struct UserObject *uo804 = (struct UserObject*)obj686;
  uo804->data[44] = emptyclosure;
  Method *meth_meth_ast_visitArray804 = addmethod2pos(obj686, "visitArray", &meth_ast_visitArray804, 44);
  int argcv_meth_ast_visitArray804[] = {1};
  meth_meth_ast_visitArray804->type = alloc_MethodType(1, argcv_meth_ast_visitArray804);
  meth_meth_ast_visitArray804->definitionModule = modulename;
  meth_meth_ast_visitArray804->definitionLine = 2805;
// method "visitMember"
  struct UserObject *uo806 = (struct UserObject*)obj686;
  uo806->data[45] = emptyclosure;
  Method *meth_meth_ast_visitMember806 = addmethod2pos(obj686, "visitMember", &meth_ast_visitMember806, 45);
  int argcv_meth_ast_visitMember806[] = {1};
  meth_meth_ast_visitMember806->type = alloc_MethodType(1, argcv_meth_ast_visitMember806);
  meth_meth_ast_visitMember806->definitionModule = modulename;
  meth_meth_ast_visitMember806->definitionLine = 2806;
// method "visitGeneric"
  struct UserObject *uo808 = (struct UserObject*)obj686;
  uo808->data[46] = emptyclosure;
  Method *meth_meth_ast_visitGeneric808 = addmethod2pos(obj686, "visitGeneric", &meth_ast_visitGeneric808, 46);
  int argcv_meth_ast_visitGeneric808[] = {1};
  meth_meth_ast_visitGeneric808->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric808);
  meth_meth_ast_visitGeneric808->definitionModule = modulename;
  meth_meth_ast_visitGeneric808->definitionLine = 2807;
// method "visitIdentifier"
  struct UserObject *uo810 = (struct UserObject*)obj686;
  uo810->data[47] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier810 = addmethod2pos(obj686, "visitIdentifier", &meth_ast_visitIdentifier810, 47);
  int argcv_meth_ast_visitIdentifier810[] = {1};
  meth_meth_ast_visitIdentifier810->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier810);
  meth_meth_ast_visitIdentifier810->definitionModule = modulename;
  meth_meth_ast_visitIdentifier810->definitionLine = 2808;
// method "visitString"
  struct UserObject *uo812 = (struct UserObject*)obj686;
  uo812->data[48] = emptyclosure;
  Method *meth_meth_ast_visitString812 = addmethod2pos(obj686, "visitString", &meth_ast_visitString812, 48);
  int argcv_meth_ast_visitString812[] = {1};
  meth_meth_ast_visitString812->type = alloc_MethodType(1, argcv_meth_ast_visitString812);
  meth_meth_ast_visitString812->definitionModule = modulename;
  meth_meth_ast_visitString812->definitionLine = 2809;
// method "visitNum"
  struct UserObject *uo814 = (struct UserObject*)obj686;
  uo814->data[49] = emptyclosure;
  Method *meth_meth_ast_visitNum814 = addmethod2pos(obj686, "visitNum", &meth_ast_visitNum814, 49);
  int argcv_meth_ast_visitNum814[] = {1};
  meth_meth_ast_visitNum814->type = alloc_MethodType(1, argcv_meth_ast_visitNum814);
  meth_meth_ast_visitNum814->definitionModule = modulename;
  meth_meth_ast_visitNum814->definitionLine = 2810;
// method "visitOp"
  struct UserObject *uo816 = (struct UserObject*)obj686;
  uo816->data[50] = emptyclosure;
  Method *meth_meth_ast_visitOp816 = addmethod2pos(obj686, "visitOp", &meth_ast_visitOp816, 50);
  int argcv_meth_ast_visitOp816[] = {1};
  meth_meth_ast_visitOp816->type = alloc_MethodType(1, argcv_meth_ast_visitOp816);
  meth_meth_ast_visitOp816->definitionModule = modulename;
  meth_meth_ast_visitOp816->definitionLine = 2811;
// method "visitIndex"
  struct UserObject *uo818 = (struct UserObject*)obj686;
  uo818->data[51] = emptyclosure;
  Method *meth_meth_ast_visitIndex818 = addmethod2pos(obj686, "visitIndex", &meth_ast_visitIndex818, 51);
  int argcv_meth_ast_visitIndex818[] = {1};
  meth_meth_ast_visitIndex818->type = alloc_MethodType(1, argcv_meth_ast_visitIndex818);
  meth_meth_ast_visitIndex818->definitionModule = modulename;
  meth_meth_ast_visitIndex818->definitionLine = 2812;
// method "visitBind"
  struct UserObject *uo820 = (struct UserObject*)obj686;
  uo820->data[52] = emptyclosure;
  Method *meth_meth_ast_visitBind820 = addmethod2pos(obj686, "visitBind", &meth_ast_visitBind820, 52);
  int argcv_meth_ast_visitBind820[] = {1};
  meth_meth_ast_visitBind820->type = alloc_MethodType(1, argcv_meth_ast_visitBind820);
  meth_meth_ast_visitBind820->definitionModule = modulename;
  meth_meth_ast_visitBind820->definitionLine = 2813;
// method "visitDefDec"
  struct UserObject *uo822 = (struct UserObject*)obj686;
  uo822->data[53] = emptyclosure;
  Method *meth_meth_ast_visitDefDec822 = addmethod2pos(obj686, "visitDefDec", &meth_ast_visitDefDec822, 53);
  int argcv_meth_ast_visitDefDec822[] = {1};
  meth_meth_ast_visitDefDec822->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec822);
  meth_meth_ast_visitDefDec822->definitionModule = modulename;
  meth_meth_ast_visitDefDec822->definitionLine = 2814;
// method "visitVarDec"
  struct UserObject *uo824 = (struct UserObject*)obj686;
  uo824->data[54] = emptyclosure;
  Method *meth_meth_ast_visitVarDec824 = addmethod2pos(obj686, "visitVarDec", &meth_ast_visitVarDec824, 54);
  int argcv_meth_ast_visitVarDec824[] = {1};
  meth_meth_ast_visitVarDec824->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec824);
  meth_meth_ast_visitVarDec824->definitionModule = modulename;
  meth_meth_ast_visitVarDec824->definitionLine = 2815;
// method "visitImport"
  struct UserObject *uo826 = (struct UserObject*)obj686;
  uo826->data[55] = emptyclosure;
  Method *meth_meth_ast_visitImport826 = addmethod2pos(obj686, "visitImport", &meth_ast_visitImport826, 55);
  int argcv_meth_ast_visitImport826[] = {1};
  meth_meth_ast_visitImport826->type = alloc_MethodType(1, argcv_meth_ast_visitImport826);
  meth_meth_ast_visitImport826->definitionModule = modulename;
  meth_meth_ast_visitImport826->definitionLine = 2816;
// method "visitReturn"
  struct UserObject *uo828 = (struct UserObject*)obj686;
  uo828->data[56] = emptyclosure;
  Method *meth_meth_ast_visitReturn828 = addmethod2pos(obj686, "visitReturn", &meth_ast_visitReturn828, 56);
  int argcv_meth_ast_visitReturn828[] = {1};
  meth_meth_ast_visitReturn828->type = alloc_MethodType(1, argcv_meth_ast_visitReturn828);
  meth_meth_ast_visitReturn828->definitionModule = modulename;
  meth_meth_ast_visitReturn828->definitionLine = 2817;
// method "visitInherits"
  struct UserObject *uo830 = (struct UserObject*)obj686;
  uo830->data[57] = emptyclosure;
  Method *meth_meth_ast_visitInherits830 = addmethod2pos(obj686, "visitInherits", &meth_ast_visitInherits830, 57);
  int argcv_meth_ast_visitInherits830[] = {1};
  meth_meth_ast_visitInherits830->type = alloc_MethodType(1, argcv_meth_ast_visitInherits830);
  meth_meth_ast_visitInherits830->definitionModule = modulename;
  meth_meth_ast_visitInherits830->definitionLine = 2818;
// method "visitDialect"
  struct UserObject *uo832 = (struct UserObject*)obj686;
  uo832->data[58] = emptyclosure;
  Method *meth_meth_ast_visitDialect832 = addmethod2pos(obj686, "visitDialect", &meth_ast_visitDialect832, 58);
  int argcv_meth_ast_visitDialect832[] = {1};
  meth_meth_ast_visitDialect832->type = alloc_MethodType(1, argcv_meth_ast_visitDialect832);
  meth_meth_ast_visitDialect832->definitionModule = modulename;
  meth_meth_ast_visitDialect832->definitionLine = 2819;
// method "visitBlank"
  struct UserObject *uo834 = (struct UserObject*)obj686;
  uo834->data[59] = emptyclosure;
  Method *meth_meth_ast_visitBlank834 = addmethod2pos(obj686, "visitBlank", &meth_ast_visitBlank834, 59);
  int argcv_meth_ast_visitBlank834[] = {1};
  meth_meth_ast_visitBlank834->type = alloc_MethodType(1, argcv_meth_ast_visitBlank834);
  meth_meth_ast_visitBlank834->definitionModule = modulename;
  meth_meth_ast_visitBlank834->definitionLine = 2820;
// method "visitComment"
  struct UserObject *uo836 = (struct UserObject*)obj686;
  uo836->data[60] = emptyclosure;
  Method *meth_meth_ast_visitComment836 = addmethod2pos(obj686, "visitComment", &meth_ast_visitComment836, 60);
  int argcv_meth_ast_visitComment836[] = {1};
  meth_meth_ast_visitComment836->type = alloc_MethodType(1, argcv_meth_ast_visitComment836);
  meth_meth_ast_visitComment836->definitionModule = modulename;
  meth_meth_ast_visitComment836->definitionLine = 2821;
// method "asString"
  struct UserObject *uo838 = (struct UserObject*)obj686;
  uo838->data[61] = emptyclosure;
  Method *meth_meth_ast_asString838 = addmethod2pos(obj686, "asString", &meth_ast_asString838, 61);
  int argcv_meth_ast_asString838[] = {0};
  meth_meth_ast_asString838->type = alloc_MethodType(1, argcv_meth_ast_asString838);
  meth_meth_ast_asString838->definitionModule = modulename;
  meth_meth_ast_asString838->definitionLine = 2823;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  sourceObject = obj686;
  objclass686 = obj686->class;
  objclass686->definitionModule = modulename;
  objclass686->definitionLine = 2760;
  (*(struct UserObject *)self).data[0] = lowerouter686;
  self = oldself686;
  selfslot = oldselfslot686;
  stackframe = oldstackframe686;
  gc_frame_end(frame);
  return obj686;
}
Object meth_ast_visitIf_40__41_up844(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIf");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe845 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call846 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe845);
// compiled call node returning call846 (depth = 2)
  gc_frame_end(frame);
  return call846;
}
Object meth_ast_visitBlock_40__41_up847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlock");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe848 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call849 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe848);
// compiled call node returning call849 (depth = 2)
  gc_frame_end(frame);
  return call849;
}
Object meth_ast_visitMatchCase_40__41_up850(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe851 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call852 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe851);
// compiled call node returning call852 (depth = 2)
  gc_frame_end(frame);
  return call852;
}
Object meth_ast_visitTryCatch_40__41_up853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTryCatch()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTryCatch");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe854 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call855 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe854);
// compiled call node returning call855 (depth = 2)
  gc_frame_end(frame);
  return call855;
}
Object meth_ast_visitMethodType_40__41_up856(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethodType");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe857 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call858 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe857);
// compiled call node returning call858 (depth = 2)
  gc_frame_end(frame);
  return call858;
}
Object meth_ast_visitSignaturePart_40__41_up859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitSignaturePart");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe860 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call861 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe860);
// compiled call node returning call861 (depth = 2)
  gc_frame_end(frame);
  return call861;
}
Object meth_ast_visitTypeDec_40__41_up862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe863 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call864 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe863);
// compiled call node returning call864 (depth = 2)
  gc_frame_end(frame);
  return call864;
}
Object meth_ast_visitTypeLiteral_40__41_up865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeLiteral");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe866 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call867 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe866);
// compiled call node returning call867 (depth = 2)
  gc_frame_end(frame);
  return call867;
}
Object meth_ast_visitMethod_40__41_up868(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethod");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe869 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call870 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe869);
// compiled call node returning call870 (depth = 2)
  gc_frame_end(frame);
  return call870;
}
Object meth_ast_visitCall_40__41_up871(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe872 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call873 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe872);
// compiled call node returning call873 (depth = 2)
  gc_frame_end(frame);
  return call873;
}
Object meth_ast_visitObject_40__41_up874(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitObject");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe875 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call876 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe875);
// compiled call node returning call876 (depth = 2)
  gc_frame_end(frame);
  return call876;
}
Object meth_ast_visitModule_40__41_up877(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitModule()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitModule");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe878 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call879 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe878);
// compiled call node returning call879 (depth = 2)
  gc_frame_end(frame);
  return call879;
}
Object meth_ast_visitArray_40__41_up880(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitArray");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe881 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call882 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe881);
// compiled call node returning call882 (depth = 2)
  gc_frame_end(frame);
  return call882;
}
Object meth_ast_visitMember_40__41_up883(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMember");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe884 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call885 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe884);
// compiled call node returning call885 (depth = 2)
  gc_frame_end(frame);
  return call885;
}
Object meth_ast_visitGeneric_40__41_up886(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitGeneric");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe887 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call888 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe887);
// compiled call node returning call888 (depth = 2)
  gc_frame_end(frame);
  return call888;
}
Object meth_ast_visitIdentifier_40__41_up889(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIdentifier");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe890 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call891 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe890);
// compiled call node returning call891 (depth = 2)
  gc_frame_end(frame);
  return call891;
}
Object meth_ast_visitString_40__41_up892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitString");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe893 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call894 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe893);
// compiled call node returning call894 (depth = 2)
  gc_frame_end(frame);
  return call894;
}
Object meth_ast_visitNum_40__41_up895(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitNum");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe896 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call897 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe896);
// compiled call node returning call897 (depth = 2)
  gc_frame_end(frame);
  return call897;
}
Object meth_ast_visitOp_40__41_up898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitOp");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe899 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call900 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe899);
// compiled call node returning call900 (depth = 2)
  gc_frame_end(frame);
  return call900;
}
Object meth_ast_visitIndex_40__41_up901(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIndex()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIndex()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIndex()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIndex()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIndex");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe902 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call903 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe902);
// compiled call node returning call903 (depth = 2)
  gc_frame_end(frame);
  return call903;
}
Object meth_ast_visitBind_40__41_up904(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBind");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe905 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call906 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe905);
// compiled call node returning call906 (depth = 2)
  gc_frame_end(frame);
  return call906;
}
Object meth_ast_visitDefDec_40__41_up907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDefDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe908 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call909 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe908);
// compiled call node returning call909 (depth = 2)
  gc_frame_end(frame);
  return call909;
}
Object meth_ast_visitVarDec_40__41_up910(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitVarDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe911 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call912 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe911);
// compiled call node returning call912 (depth = 2)
  gc_frame_end(frame);
  return call912;
}
Object meth_ast_visitImport_40__41_up913(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitImport");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe914 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call915 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe914);
// compiled call node returning call915 (depth = 2)
  gc_frame_end(frame);
  return call915;
}
Object meth_ast_visitReturn_40__41_up916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitReturn");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe917 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call918 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe917);
// compiled call node returning call918 (depth = 2)
  gc_frame_end(frame);
  return call918;
}
Object meth_ast_visitInherits_40__41_up919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitInherits");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe920 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call921 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe920);
// compiled call node returning call921 (depth = 2)
  gc_frame_end(frame);
  return call921;
}
Object meth_ast_visitDialect_40__41_up922(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDialect");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe923 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call924 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe923);
// compiled call node returning call924 (depth = 2)
  gc_frame_end(frame);
  return call924;
}
Object meth_ast_visitBlank_40__41_up925(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlank()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlank");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe926 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call927 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe926);
// compiled call node returning call927 (depth = 2)
  gc_frame_end(frame);
  return call927;
}
Object meth_ast_visitComment_40__41_up928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitComment()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitComment");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe929 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call930 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe929);
// compiled call node returning call930 (depth = 2)
  gc_frame_end(frame);
  return call930;
}
Object meth_ast_asString931(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit932 == NULL) {
    strlit932 = alloc_String("a pluggable AST visitor");
    gc_root(strlit932);
  }
// compiled string node returning strlit932 (depth = 2)
  gc_frame_end(frame);
  return strlit932;
}
Object meth_ast_pluggableVisitor841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pluggableVisitor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject842 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj842 = alloc_userobj2(30,31, objclass842);
  gc_frame_newslot(obj842);
if (objclass842 == NULL) {
  glfree(obj842->class->name);
  obj842->class->name = "pluggableVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj842, self, 0);
  addmethodreal(obj842,"outer", &reader_ast_outer_843);
  Object oldself842 = self;
  struct StackFrameObject *oldstackframe842 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe842);
  gc_frame_newslot((Object)stackframe);
  self = obj842;
  Object *oldselfslot842 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter842 = (*(struct UserObject *)self).data[0], lowerouter842 = thisouter842;
  if (inheritingObject842) {
    struct UserObject *inho842 = (struct UserObject *)inheritingObject842;
    while (inho842->super != GraceDefaultObject) inho842 = (struct UserObject *)inho842->super;
    inho842->super = obj842;
    self = inheritingObject842;
    *selfslot = self;
    lowerouter842 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter842;
  }
// method "visitIf()up"
  block_savedest(obj842);
  Object closure844 = createclosure(1, "visitIf()up");
  setclosureframe(closure844, stackframe);
  addtoclosure(closure844, var_visitation);
  struct UserObject *uo844 = (struct UserObject*)obj842;
  uo844->data[1] = (Object)closure844;
  Method *meth_meth_ast_visitIf_40__41_up844 = addmethod2pos(obj842, "visitIf()up", &meth_ast_visitIf_40__41_up844, 1);
  int argcv_meth_ast_visitIf_40__41_up844[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up844->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up844);
  meth_meth_ast_visitIf_40__41_up844->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up844->definitionLine = 2833;
// method "visitBlock()up"
  block_savedest(obj842);
  Object closure847 = createclosure(1, "visitBlock()up");
  setclosureframe(closure847, stackframe);
  addtoclosure(closure847, var_visitation);
  struct UserObject *uo847 = (struct UserObject*)obj842;
  uo847->data[2] = (Object)closure847;
  Method *meth_meth_ast_visitBlock_40__41_up847 = addmethod2pos(obj842, "visitBlock()up", &meth_ast_visitBlock_40__41_up847, 2);
  int argcv_meth_ast_visitBlock_40__41_up847[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up847->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up847);
  meth_meth_ast_visitBlock_40__41_up847->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up847->definitionLine = 2834;
// method "visitMatchCase()up"
  block_savedest(obj842);
  Object closure850 = createclosure(1, "visitMatchCase()up");
  setclosureframe(closure850, stackframe);
  addtoclosure(closure850, var_visitation);
  struct UserObject *uo850 = (struct UserObject*)obj842;
  uo850->data[3] = (Object)closure850;
  Method *meth_meth_ast_visitMatchCase_40__41_up850 = addmethod2pos(obj842, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up850, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up850[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up850->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up850);
  meth_meth_ast_visitMatchCase_40__41_up850->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up850->definitionLine = 2835;
// method "visitTryCatch()up"
  block_savedest(obj842);
  Object closure853 = createclosure(1, "visitTryCatch()up");
  setclosureframe(closure853, stackframe);
  addtoclosure(closure853, var_visitation);
  struct UserObject *uo853 = (struct UserObject*)obj842;
  uo853->data[4] = (Object)closure853;
  Method *meth_meth_ast_visitTryCatch_40__41_up853 = addmethod2pos(obj842, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up853, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up853[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up853->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up853);
  meth_meth_ast_visitTryCatch_40__41_up853->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up853->definitionLine = 2836;
// method "visitMethodType()up"
  block_savedest(obj842);
  Object closure856 = createclosure(1, "visitMethodType()up");
  setclosureframe(closure856, stackframe);
  addtoclosure(closure856, var_visitation);
  struct UserObject *uo856 = (struct UserObject*)obj842;
  uo856->data[5] = (Object)closure856;
  Method *meth_meth_ast_visitMethodType_40__41_up856 = addmethod2pos(obj842, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up856, 5);
  int argcv_meth_ast_visitMethodType_40__41_up856[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up856->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up856);
  meth_meth_ast_visitMethodType_40__41_up856->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up856->definitionLine = 2837;
// method "visitSignaturePart()up"
  block_savedest(obj842);
  Object closure859 = createclosure(1, "visitSignaturePart()up");
  setclosureframe(closure859, stackframe);
  addtoclosure(closure859, var_visitation);
  struct UserObject *uo859 = (struct UserObject*)obj842;
  uo859->data[6] = (Object)closure859;
  Method *meth_meth_ast_visitSignaturePart_40__41_up859 = addmethod2pos(obj842, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up859, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up859[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up859->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up859);
  meth_meth_ast_visitSignaturePart_40__41_up859->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up859->definitionLine = 2838;
// method "visitTypeDec()up"
  block_savedest(obj842);
  Object closure862 = createclosure(1, "visitTypeDec()up");
  setclosureframe(closure862, stackframe);
  addtoclosure(closure862, var_visitation);
  struct UserObject *uo862 = (struct UserObject*)obj842;
  uo862->data[7] = (Object)closure862;
  Method *meth_meth_ast_visitTypeDec_40__41_up862 = addmethod2pos(obj842, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up862, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up862[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up862->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up862);
  meth_meth_ast_visitTypeDec_40__41_up862->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up862->definitionLine = 2839;
// method "visitTypeLiteral()up"
  block_savedest(obj842);
  Object closure865 = createclosure(1, "visitTypeLiteral()up");
  setclosureframe(closure865, stackframe);
  addtoclosure(closure865, var_visitation);
  struct UserObject *uo865 = (struct UserObject*)obj842;
  uo865->data[8] = (Object)closure865;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up865 = addmethod2pos(obj842, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up865, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up865[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up865->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up865);
  meth_meth_ast_visitTypeLiteral_40__41_up865->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up865->definitionLine = 2840;
// method "visitMethod()up"
  block_savedest(obj842);
  Object closure868 = createclosure(1, "visitMethod()up");
  setclosureframe(closure868, stackframe);
  addtoclosure(closure868, var_visitation);
  struct UserObject *uo868 = (struct UserObject*)obj842;
  uo868->data[9] = (Object)closure868;
  Method *meth_meth_ast_visitMethod_40__41_up868 = addmethod2pos(obj842, "visitMethod()up", &meth_ast_visitMethod_40__41_up868, 9);
  int argcv_meth_ast_visitMethod_40__41_up868[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up868->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up868);
  meth_meth_ast_visitMethod_40__41_up868->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up868->definitionLine = 2841;
// method "visitCall()up"
  block_savedest(obj842);
  Object closure871 = createclosure(1, "visitCall()up");
  setclosureframe(closure871, stackframe);
  addtoclosure(closure871, var_visitation);
  struct UserObject *uo871 = (struct UserObject*)obj842;
  uo871->data[10] = (Object)closure871;
  Method *meth_meth_ast_visitCall_40__41_up871 = addmethod2pos(obj842, "visitCall()up", &meth_ast_visitCall_40__41_up871, 10);
  int argcv_meth_ast_visitCall_40__41_up871[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up871->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up871);
  meth_meth_ast_visitCall_40__41_up871->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up871->definitionLine = 2842;
// method "visitObject()up"
  block_savedest(obj842);
  Object closure874 = createclosure(1, "visitObject()up");
  setclosureframe(closure874, stackframe);
  addtoclosure(closure874, var_visitation);
  struct UserObject *uo874 = (struct UserObject*)obj842;
  uo874->data[11] = (Object)closure874;
  Method *meth_meth_ast_visitObject_40__41_up874 = addmethod2pos(obj842, "visitObject()up", &meth_ast_visitObject_40__41_up874, 11);
  int argcv_meth_ast_visitObject_40__41_up874[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up874->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up874);
  meth_meth_ast_visitObject_40__41_up874->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up874->definitionLine = 2843;
// method "visitModule()up"
  block_savedest(obj842);
  Object closure877 = createclosure(1, "visitModule()up");
  setclosureframe(closure877, stackframe);
  addtoclosure(closure877, var_visitation);
  struct UserObject *uo877 = (struct UserObject*)obj842;
  uo877->data[12] = (Object)closure877;
  Method *meth_meth_ast_visitModule_40__41_up877 = addmethod2pos(obj842, "visitModule()up", &meth_ast_visitModule_40__41_up877, 12);
  int argcv_meth_ast_visitModule_40__41_up877[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up877->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up877);
  meth_meth_ast_visitModule_40__41_up877->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up877->definitionLine = 2844;
// method "visitArray()up"
  block_savedest(obj842);
  Object closure880 = createclosure(1, "visitArray()up");
  setclosureframe(closure880, stackframe);
  addtoclosure(closure880, var_visitation);
  struct UserObject *uo880 = (struct UserObject*)obj842;
  uo880->data[13] = (Object)closure880;
  Method *meth_meth_ast_visitArray_40__41_up880 = addmethod2pos(obj842, "visitArray()up", &meth_ast_visitArray_40__41_up880, 13);
  int argcv_meth_ast_visitArray_40__41_up880[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up880->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up880);
  meth_meth_ast_visitArray_40__41_up880->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up880->definitionLine = 2845;
// method "visitMember()up"
  block_savedest(obj842);
  Object closure883 = createclosure(1, "visitMember()up");
  setclosureframe(closure883, stackframe);
  addtoclosure(closure883, var_visitation);
  struct UserObject *uo883 = (struct UserObject*)obj842;
  uo883->data[14] = (Object)closure883;
  Method *meth_meth_ast_visitMember_40__41_up883 = addmethod2pos(obj842, "visitMember()up", &meth_ast_visitMember_40__41_up883, 14);
  int argcv_meth_ast_visitMember_40__41_up883[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up883->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up883);
  meth_meth_ast_visitMember_40__41_up883->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up883->definitionLine = 2846;
// method "visitGeneric()up"
  block_savedest(obj842);
  Object closure886 = createclosure(1, "visitGeneric()up");
  setclosureframe(closure886, stackframe);
  addtoclosure(closure886, var_visitation);
  struct UserObject *uo886 = (struct UserObject*)obj842;
  uo886->data[15] = (Object)closure886;
  Method *meth_meth_ast_visitGeneric_40__41_up886 = addmethod2pos(obj842, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up886, 15);
  int argcv_meth_ast_visitGeneric_40__41_up886[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up886->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up886);
  meth_meth_ast_visitGeneric_40__41_up886->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up886->definitionLine = 2847;
// method "visitIdentifier()up"
  block_savedest(obj842);
  Object closure889 = createclosure(1, "visitIdentifier()up");
  setclosureframe(closure889, stackframe);
  addtoclosure(closure889, var_visitation);
  struct UserObject *uo889 = (struct UserObject*)obj842;
  uo889->data[16] = (Object)closure889;
  Method *meth_meth_ast_visitIdentifier_40__41_up889 = addmethod2pos(obj842, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up889, 16);
  int argcv_meth_ast_visitIdentifier_40__41_up889[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up889->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up889);
  meth_meth_ast_visitIdentifier_40__41_up889->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up889->definitionLine = 2848;
// method "visitString()up"
  block_savedest(obj842);
  Object closure892 = createclosure(1, "visitString()up");
  setclosureframe(closure892, stackframe);
  addtoclosure(closure892, var_visitation);
  struct UserObject *uo892 = (struct UserObject*)obj842;
  uo892->data[17] = (Object)closure892;
  Method *meth_meth_ast_visitString_40__41_up892 = addmethod2pos(obj842, "visitString()up", &meth_ast_visitString_40__41_up892, 17);
  int argcv_meth_ast_visitString_40__41_up892[] = {1, 1};
  meth_meth_ast_visitString_40__41_up892->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up892);
  meth_meth_ast_visitString_40__41_up892->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up892->definitionLine = 2849;
// method "visitNum()up"
  block_savedest(obj842);
  Object closure895 = createclosure(1, "visitNum()up");
  setclosureframe(closure895, stackframe);
  addtoclosure(closure895, var_visitation);
  struct UserObject *uo895 = (struct UserObject*)obj842;
  uo895->data[18] = (Object)closure895;
  Method *meth_meth_ast_visitNum_40__41_up895 = addmethod2pos(obj842, "visitNum()up", &meth_ast_visitNum_40__41_up895, 18);
  int argcv_meth_ast_visitNum_40__41_up895[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up895->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up895);
  meth_meth_ast_visitNum_40__41_up895->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up895->definitionLine = 2850;
// method "visitOp()up"
  block_savedest(obj842);
  Object closure898 = createclosure(1, "visitOp()up");
  setclosureframe(closure898, stackframe);
  addtoclosure(closure898, var_visitation);
  struct UserObject *uo898 = (struct UserObject*)obj842;
  uo898->data[19] = (Object)closure898;
  Method *meth_meth_ast_visitOp_40__41_up898 = addmethod2pos(obj842, "visitOp()up", &meth_ast_visitOp_40__41_up898, 19);
  int argcv_meth_ast_visitOp_40__41_up898[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up898->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up898);
  meth_meth_ast_visitOp_40__41_up898->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up898->definitionLine = 2851;
// method "visitIndex()up"
  block_savedest(obj842);
  Object closure901 = createclosure(1, "visitIndex()up");
  setclosureframe(closure901, stackframe);
  addtoclosure(closure901, var_visitation);
  struct UserObject *uo901 = (struct UserObject*)obj842;
  uo901->data[20] = (Object)closure901;
  Method *meth_meth_ast_visitIndex_40__41_up901 = addmethod2pos(obj842, "visitIndex()up", &meth_ast_visitIndex_40__41_up901, 20);
  int argcv_meth_ast_visitIndex_40__41_up901[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up901->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up901);
  meth_meth_ast_visitIndex_40__41_up901->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up901->definitionLine = 2852;
// method "visitBind()up"
  block_savedest(obj842);
  Object closure904 = createclosure(1, "visitBind()up");
  setclosureframe(closure904, stackframe);
  addtoclosure(closure904, var_visitation);
  struct UserObject *uo904 = (struct UserObject*)obj842;
  uo904->data[21] = (Object)closure904;
  Method *meth_meth_ast_visitBind_40__41_up904 = addmethod2pos(obj842, "visitBind()up", &meth_ast_visitBind_40__41_up904, 21);
  int argcv_meth_ast_visitBind_40__41_up904[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up904->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up904);
  meth_meth_ast_visitBind_40__41_up904->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up904->definitionLine = 2853;
// method "visitDefDec()up"
  block_savedest(obj842);
  Object closure907 = createclosure(1, "visitDefDec()up");
  setclosureframe(closure907, stackframe);
  addtoclosure(closure907, var_visitation);
  struct UserObject *uo907 = (struct UserObject*)obj842;
  uo907->data[22] = (Object)closure907;
  Method *meth_meth_ast_visitDefDec_40__41_up907 = addmethod2pos(obj842, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up907, 22);
  int argcv_meth_ast_visitDefDec_40__41_up907[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up907->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up907);
  meth_meth_ast_visitDefDec_40__41_up907->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up907->definitionLine = 2854;
// method "visitVarDec()up"
  block_savedest(obj842);
  Object closure910 = createclosure(1, "visitVarDec()up");
  setclosureframe(closure910, stackframe);
  addtoclosure(closure910, var_visitation);
  struct UserObject *uo910 = (struct UserObject*)obj842;
  uo910->data[23] = (Object)closure910;
  Method *meth_meth_ast_visitVarDec_40__41_up910 = addmethod2pos(obj842, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up910, 23);
  int argcv_meth_ast_visitVarDec_40__41_up910[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up910->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up910);
  meth_meth_ast_visitVarDec_40__41_up910->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up910->definitionLine = 2855;
// method "visitImport()up"
  block_savedest(obj842);
  Object closure913 = createclosure(1, "visitImport()up");
  setclosureframe(closure913, stackframe);
  addtoclosure(closure913, var_visitation);
  struct UserObject *uo913 = (struct UserObject*)obj842;
  uo913->data[24] = (Object)closure913;
  Method *meth_meth_ast_visitImport_40__41_up913 = addmethod2pos(obj842, "visitImport()up", &meth_ast_visitImport_40__41_up913, 24);
  int argcv_meth_ast_visitImport_40__41_up913[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up913->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up913);
  meth_meth_ast_visitImport_40__41_up913->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up913->definitionLine = 2856;
// method "visitReturn()up"
  block_savedest(obj842);
  Object closure916 = createclosure(1, "visitReturn()up");
  setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_visitation);
  struct UserObject *uo916 = (struct UserObject*)obj842;
  uo916->data[25] = (Object)closure916;
  Method *meth_meth_ast_visitReturn_40__41_up916 = addmethod2pos(obj842, "visitReturn()up", &meth_ast_visitReturn_40__41_up916, 25);
  int argcv_meth_ast_visitReturn_40__41_up916[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up916->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up916);
  meth_meth_ast_visitReturn_40__41_up916->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up916->definitionLine = 2857;
// method "visitInherits()up"
  block_savedest(obj842);
  Object closure919 = createclosure(1, "visitInherits()up");
  setclosureframe(closure919, stackframe);
  addtoclosure(closure919, var_visitation);
  struct UserObject *uo919 = (struct UserObject*)obj842;
  uo919->data[26] = (Object)closure919;
  Method *meth_meth_ast_visitInherits_40__41_up919 = addmethod2pos(obj842, "visitInherits()up", &meth_ast_visitInherits_40__41_up919, 26);
  int argcv_meth_ast_visitInherits_40__41_up919[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up919->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up919);
  meth_meth_ast_visitInherits_40__41_up919->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up919->definitionLine = 2858;
// method "visitDialect()up"
  block_savedest(obj842);
  Object closure922 = createclosure(1, "visitDialect()up");
  setclosureframe(closure922, stackframe);
  addtoclosure(closure922, var_visitation);
  struct UserObject *uo922 = (struct UserObject*)obj842;
  uo922->data[27] = (Object)closure922;
  Method *meth_meth_ast_visitDialect_40__41_up922 = addmethod2pos(obj842, "visitDialect()up", &meth_ast_visitDialect_40__41_up922, 27);
  int argcv_meth_ast_visitDialect_40__41_up922[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up922->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up922);
  meth_meth_ast_visitDialect_40__41_up922->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up922->definitionLine = 2859;
// method "visitBlank()up"
  block_savedest(obj842);
  Object closure925 = createclosure(1, "visitBlank()up");
  setclosureframe(closure925, stackframe);
  addtoclosure(closure925, var_visitation);
  struct UserObject *uo925 = (struct UserObject*)obj842;
  uo925->data[28] = (Object)closure925;
  Method *meth_meth_ast_visitBlank_40__41_up925 = addmethod2pos(obj842, "visitBlank()up", &meth_ast_visitBlank_40__41_up925, 28);
  int argcv_meth_ast_visitBlank_40__41_up925[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up925->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up925);
  meth_meth_ast_visitBlank_40__41_up925->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up925->definitionLine = 2860;
// method "visitComment()up"
  block_savedest(obj842);
  Object closure928 = createclosure(1, "visitComment()up");
  setclosureframe(closure928, stackframe);
  addtoclosure(closure928, var_visitation);
  struct UserObject *uo928 = (struct UserObject*)obj842;
  uo928->data[29] = (Object)closure928;
  Method *meth_meth_ast_visitComment_40__41_up928 = addmethod2pos(obj842, "visitComment()up", &meth_ast_visitComment_40__41_up928, 29);
  int argcv_meth_ast_visitComment_40__41_up928[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up928->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up928);
  meth_meth_ast_visitComment_40__41_up928->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up928->definitionLine = 2861;
// method "asString"
  struct UserObject *uo931 = (struct UserObject*)obj842;
  uo931->data[30] = emptyclosure;
  Method *meth_meth_ast_asString931 = addmethod2pos(obj842, "asString", &meth_ast_asString931, 30);
  int argcv_meth_ast_asString931[] = {0};
  meth_meth_ast_asString931->type = alloc_MethodType(1, argcv_meth_ast_asString931);
  meth_meth_ast_asString931->definitionModule = modulename;
  meth_meth_ast_asString931->definitionLine = 2863;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  objclass842 = obj842->class;
  objclass842->definitionModule = modulename;
  objclass842->definitionLine = 2826;
  (*(struct UserObject *)self).data[0] = lowerouter842;
  self = oldself842;
  selfslot = oldselfslot842;
  stackframe = oldstackframe842;
  gc_frame_end(frame);
  return obj842;
}
Object meth_ast_pluggableVisitor841_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pluggableVisitor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject842 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj842 = alloc_userobj2(30,31, objclass842);
  gc_frame_newslot(obj842);
if (objclass842 == NULL) {
  glfree(obj842->class->name);
  obj842->class->name = "pluggableVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj842, self, 0);
  addmethodreal(obj842,"outer", &reader_ast_outer_843);
  Object oldself842 = self;
  struct StackFrameObject *oldstackframe842 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe842);
  gc_frame_newslot((Object)stackframe);
  self = obj842;
  Object *oldselfslot842 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter842 = (*(struct UserObject *)self).data[0], lowerouter842 = thisouter842;
  if (inheritingObject842) {
    struct UserObject *inho842 = (struct UserObject *)inheritingObject842;
    while (inho842->super != GraceDefaultObject) inho842 = (struct UserObject *)inho842->super;
    inho842->super = obj842;
    self = inheritingObject842;
    *selfslot = self;
    lowerouter842 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter842;
  }
// method "visitIf()up"
  block_savedest(obj842);
  Object closure844 = createclosure(1, "visitIf()up");
  setclosureframe(closure844, stackframe);
  addtoclosure(closure844, var_visitation);
  struct UserObject *uo844 = (struct UserObject*)obj842;
  uo844->data[1] = (Object)closure844;
  Method *meth_meth_ast_visitIf_40__41_up844 = addmethod2pos(obj842, "visitIf()up", &meth_ast_visitIf_40__41_up844, 1);
  int argcv_meth_ast_visitIf_40__41_up844[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up844->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up844);
  meth_meth_ast_visitIf_40__41_up844->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up844->definitionLine = 2833;
// method "visitBlock()up"
  block_savedest(obj842);
  Object closure847 = createclosure(1, "visitBlock()up");
  setclosureframe(closure847, stackframe);
  addtoclosure(closure847, var_visitation);
  struct UserObject *uo847 = (struct UserObject*)obj842;
  uo847->data[2] = (Object)closure847;
  Method *meth_meth_ast_visitBlock_40__41_up847 = addmethod2pos(obj842, "visitBlock()up", &meth_ast_visitBlock_40__41_up847, 2);
  int argcv_meth_ast_visitBlock_40__41_up847[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up847->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up847);
  meth_meth_ast_visitBlock_40__41_up847->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up847->definitionLine = 2834;
// method "visitMatchCase()up"
  block_savedest(obj842);
  Object closure850 = createclosure(1, "visitMatchCase()up");
  setclosureframe(closure850, stackframe);
  addtoclosure(closure850, var_visitation);
  struct UserObject *uo850 = (struct UserObject*)obj842;
  uo850->data[3] = (Object)closure850;
  Method *meth_meth_ast_visitMatchCase_40__41_up850 = addmethod2pos(obj842, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up850, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up850[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up850->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up850);
  meth_meth_ast_visitMatchCase_40__41_up850->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up850->definitionLine = 2835;
// method "visitTryCatch()up"
  block_savedest(obj842);
  Object closure853 = createclosure(1, "visitTryCatch()up");
  setclosureframe(closure853, stackframe);
  addtoclosure(closure853, var_visitation);
  struct UserObject *uo853 = (struct UserObject*)obj842;
  uo853->data[4] = (Object)closure853;
  Method *meth_meth_ast_visitTryCatch_40__41_up853 = addmethod2pos(obj842, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up853, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up853[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up853->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up853);
  meth_meth_ast_visitTryCatch_40__41_up853->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up853->definitionLine = 2836;
// method "visitMethodType()up"
  block_savedest(obj842);
  Object closure856 = createclosure(1, "visitMethodType()up");
  setclosureframe(closure856, stackframe);
  addtoclosure(closure856, var_visitation);
  struct UserObject *uo856 = (struct UserObject*)obj842;
  uo856->data[5] = (Object)closure856;
  Method *meth_meth_ast_visitMethodType_40__41_up856 = addmethod2pos(obj842, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up856, 5);
  int argcv_meth_ast_visitMethodType_40__41_up856[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up856->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up856);
  meth_meth_ast_visitMethodType_40__41_up856->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up856->definitionLine = 2837;
// method "visitSignaturePart()up"
  block_savedest(obj842);
  Object closure859 = createclosure(1, "visitSignaturePart()up");
  setclosureframe(closure859, stackframe);
  addtoclosure(closure859, var_visitation);
  struct UserObject *uo859 = (struct UserObject*)obj842;
  uo859->data[6] = (Object)closure859;
  Method *meth_meth_ast_visitSignaturePart_40__41_up859 = addmethod2pos(obj842, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up859, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up859[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up859->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up859);
  meth_meth_ast_visitSignaturePart_40__41_up859->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up859->definitionLine = 2838;
// method "visitTypeDec()up"
  block_savedest(obj842);
  Object closure862 = createclosure(1, "visitTypeDec()up");
  setclosureframe(closure862, stackframe);
  addtoclosure(closure862, var_visitation);
  struct UserObject *uo862 = (struct UserObject*)obj842;
  uo862->data[7] = (Object)closure862;
  Method *meth_meth_ast_visitTypeDec_40__41_up862 = addmethod2pos(obj842, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up862, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up862[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up862->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up862);
  meth_meth_ast_visitTypeDec_40__41_up862->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up862->definitionLine = 2839;
// method "visitTypeLiteral()up"
  block_savedest(obj842);
  Object closure865 = createclosure(1, "visitTypeLiteral()up");
  setclosureframe(closure865, stackframe);
  addtoclosure(closure865, var_visitation);
  struct UserObject *uo865 = (struct UserObject*)obj842;
  uo865->data[8] = (Object)closure865;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up865 = addmethod2pos(obj842, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up865, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up865[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up865->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up865);
  meth_meth_ast_visitTypeLiteral_40__41_up865->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up865->definitionLine = 2840;
// method "visitMethod()up"
  block_savedest(obj842);
  Object closure868 = createclosure(1, "visitMethod()up");
  setclosureframe(closure868, stackframe);
  addtoclosure(closure868, var_visitation);
  struct UserObject *uo868 = (struct UserObject*)obj842;
  uo868->data[9] = (Object)closure868;
  Method *meth_meth_ast_visitMethod_40__41_up868 = addmethod2pos(obj842, "visitMethod()up", &meth_ast_visitMethod_40__41_up868, 9);
  int argcv_meth_ast_visitMethod_40__41_up868[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up868->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up868);
  meth_meth_ast_visitMethod_40__41_up868->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up868->definitionLine = 2841;
// method "visitCall()up"
  block_savedest(obj842);
  Object closure871 = createclosure(1, "visitCall()up");
  setclosureframe(closure871, stackframe);
  addtoclosure(closure871, var_visitation);
  struct UserObject *uo871 = (struct UserObject*)obj842;
  uo871->data[10] = (Object)closure871;
  Method *meth_meth_ast_visitCall_40__41_up871 = addmethod2pos(obj842, "visitCall()up", &meth_ast_visitCall_40__41_up871, 10);
  int argcv_meth_ast_visitCall_40__41_up871[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up871->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up871);
  meth_meth_ast_visitCall_40__41_up871->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up871->definitionLine = 2842;
// method "visitObject()up"
  block_savedest(obj842);
  Object closure874 = createclosure(1, "visitObject()up");
  setclosureframe(closure874, stackframe);
  addtoclosure(closure874, var_visitation);
  struct UserObject *uo874 = (struct UserObject*)obj842;
  uo874->data[11] = (Object)closure874;
  Method *meth_meth_ast_visitObject_40__41_up874 = addmethod2pos(obj842, "visitObject()up", &meth_ast_visitObject_40__41_up874, 11);
  int argcv_meth_ast_visitObject_40__41_up874[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up874->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up874);
  meth_meth_ast_visitObject_40__41_up874->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up874->definitionLine = 2843;
// method "visitModule()up"
  block_savedest(obj842);
  Object closure877 = createclosure(1, "visitModule()up");
  setclosureframe(closure877, stackframe);
  addtoclosure(closure877, var_visitation);
  struct UserObject *uo877 = (struct UserObject*)obj842;
  uo877->data[12] = (Object)closure877;
  Method *meth_meth_ast_visitModule_40__41_up877 = addmethod2pos(obj842, "visitModule()up", &meth_ast_visitModule_40__41_up877, 12);
  int argcv_meth_ast_visitModule_40__41_up877[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up877->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up877);
  meth_meth_ast_visitModule_40__41_up877->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up877->definitionLine = 2844;
// method "visitArray()up"
  block_savedest(obj842);
  Object closure880 = createclosure(1, "visitArray()up");
  setclosureframe(closure880, stackframe);
  addtoclosure(closure880, var_visitation);
  struct UserObject *uo880 = (struct UserObject*)obj842;
  uo880->data[13] = (Object)closure880;
  Method *meth_meth_ast_visitArray_40__41_up880 = addmethod2pos(obj842, "visitArray()up", &meth_ast_visitArray_40__41_up880, 13);
  int argcv_meth_ast_visitArray_40__41_up880[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up880->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up880);
  meth_meth_ast_visitArray_40__41_up880->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up880->definitionLine = 2845;
// method "visitMember()up"
  block_savedest(obj842);
  Object closure883 = createclosure(1, "visitMember()up");
  setclosureframe(closure883, stackframe);
  addtoclosure(closure883, var_visitation);
  struct UserObject *uo883 = (struct UserObject*)obj842;
  uo883->data[14] = (Object)closure883;
  Method *meth_meth_ast_visitMember_40__41_up883 = addmethod2pos(obj842, "visitMember()up", &meth_ast_visitMember_40__41_up883, 14);
  int argcv_meth_ast_visitMember_40__41_up883[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up883->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up883);
  meth_meth_ast_visitMember_40__41_up883->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up883->definitionLine = 2846;
// method "visitGeneric()up"
  block_savedest(obj842);
  Object closure886 = createclosure(1, "visitGeneric()up");
  setclosureframe(closure886, stackframe);
  addtoclosure(closure886, var_visitation);
  struct UserObject *uo886 = (struct UserObject*)obj842;
  uo886->data[15] = (Object)closure886;
  Method *meth_meth_ast_visitGeneric_40__41_up886 = addmethod2pos(obj842, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up886, 15);
  int argcv_meth_ast_visitGeneric_40__41_up886[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up886->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up886);
  meth_meth_ast_visitGeneric_40__41_up886->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up886->definitionLine = 2847;
// method "visitIdentifier()up"
  block_savedest(obj842);
  Object closure889 = createclosure(1, "visitIdentifier()up");
  setclosureframe(closure889, stackframe);
  addtoclosure(closure889, var_visitation);
  struct UserObject *uo889 = (struct UserObject*)obj842;
  uo889->data[16] = (Object)closure889;
  Method *meth_meth_ast_visitIdentifier_40__41_up889 = addmethod2pos(obj842, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up889, 16);
  int argcv_meth_ast_visitIdentifier_40__41_up889[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up889->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up889);
  meth_meth_ast_visitIdentifier_40__41_up889->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up889->definitionLine = 2848;
// method "visitString()up"
  block_savedest(obj842);
  Object closure892 = createclosure(1, "visitString()up");
  setclosureframe(closure892, stackframe);
  addtoclosure(closure892, var_visitation);
  struct UserObject *uo892 = (struct UserObject*)obj842;
  uo892->data[17] = (Object)closure892;
  Method *meth_meth_ast_visitString_40__41_up892 = addmethod2pos(obj842, "visitString()up", &meth_ast_visitString_40__41_up892, 17);
  int argcv_meth_ast_visitString_40__41_up892[] = {1, 1};
  meth_meth_ast_visitString_40__41_up892->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up892);
  meth_meth_ast_visitString_40__41_up892->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up892->definitionLine = 2849;
// method "visitNum()up"
  block_savedest(obj842);
  Object closure895 = createclosure(1, "visitNum()up");
  setclosureframe(closure895, stackframe);
  addtoclosure(closure895, var_visitation);
  struct UserObject *uo895 = (struct UserObject*)obj842;
  uo895->data[18] = (Object)closure895;
  Method *meth_meth_ast_visitNum_40__41_up895 = addmethod2pos(obj842, "visitNum()up", &meth_ast_visitNum_40__41_up895, 18);
  int argcv_meth_ast_visitNum_40__41_up895[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up895->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up895);
  meth_meth_ast_visitNum_40__41_up895->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up895->definitionLine = 2850;
// method "visitOp()up"
  block_savedest(obj842);
  Object closure898 = createclosure(1, "visitOp()up");
  setclosureframe(closure898, stackframe);
  addtoclosure(closure898, var_visitation);
  struct UserObject *uo898 = (struct UserObject*)obj842;
  uo898->data[19] = (Object)closure898;
  Method *meth_meth_ast_visitOp_40__41_up898 = addmethod2pos(obj842, "visitOp()up", &meth_ast_visitOp_40__41_up898, 19);
  int argcv_meth_ast_visitOp_40__41_up898[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up898->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up898);
  meth_meth_ast_visitOp_40__41_up898->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up898->definitionLine = 2851;
// method "visitIndex()up"
  block_savedest(obj842);
  Object closure901 = createclosure(1, "visitIndex()up");
  setclosureframe(closure901, stackframe);
  addtoclosure(closure901, var_visitation);
  struct UserObject *uo901 = (struct UserObject*)obj842;
  uo901->data[20] = (Object)closure901;
  Method *meth_meth_ast_visitIndex_40__41_up901 = addmethod2pos(obj842, "visitIndex()up", &meth_ast_visitIndex_40__41_up901, 20);
  int argcv_meth_ast_visitIndex_40__41_up901[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up901->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up901);
  meth_meth_ast_visitIndex_40__41_up901->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up901->definitionLine = 2852;
// method "visitBind()up"
  block_savedest(obj842);
  Object closure904 = createclosure(1, "visitBind()up");
  setclosureframe(closure904, stackframe);
  addtoclosure(closure904, var_visitation);
  struct UserObject *uo904 = (struct UserObject*)obj842;
  uo904->data[21] = (Object)closure904;
  Method *meth_meth_ast_visitBind_40__41_up904 = addmethod2pos(obj842, "visitBind()up", &meth_ast_visitBind_40__41_up904, 21);
  int argcv_meth_ast_visitBind_40__41_up904[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up904->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up904);
  meth_meth_ast_visitBind_40__41_up904->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up904->definitionLine = 2853;
// method "visitDefDec()up"
  block_savedest(obj842);
  Object closure907 = createclosure(1, "visitDefDec()up");
  setclosureframe(closure907, stackframe);
  addtoclosure(closure907, var_visitation);
  struct UserObject *uo907 = (struct UserObject*)obj842;
  uo907->data[22] = (Object)closure907;
  Method *meth_meth_ast_visitDefDec_40__41_up907 = addmethod2pos(obj842, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up907, 22);
  int argcv_meth_ast_visitDefDec_40__41_up907[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up907->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up907);
  meth_meth_ast_visitDefDec_40__41_up907->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up907->definitionLine = 2854;
// method "visitVarDec()up"
  block_savedest(obj842);
  Object closure910 = createclosure(1, "visitVarDec()up");
  setclosureframe(closure910, stackframe);
  addtoclosure(closure910, var_visitation);
  struct UserObject *uo910 = (struct UserObject*)obj842;
  uo910->data[23] = (Object)closure910;
  Method *meth_meth_ast_visitVarDec_40__41_up910 = addmethod2pos(obj842, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up910, 23);
  int argcv_meth_ast_visitVarDec_40__41_up910[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up910->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up910);
  meth_meth_ast_visitVarDec_40__41_up910->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up910->definitionLine = 2855;
// method "visitImport()up"
  block_savedest(obj842);
  Object closure913 = createclosure(1, "visitImport()up");
  setclosureframe(closure913, stackframe);
  addtoclosure(closure913, var_visitation);
  struct UserObject *uo913 = (struct UserObject*)obj842;
  uo913->data[24] = (Object)closure913;
  Method *meth_meth_ast_visitImport_40__41_up913 = addmethod2pos(obj842, "visitImport()up", &meth_ast_visitImport_40__41_up913, 24);
  int argcv_meth_ast_visitImport_40__41_up913[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up913->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up913);
  meth_meth_ast_visitImport_40__41_up913->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up913->definitionLine = 2856;
// method "visitReturn()up"
  block_savedest(obj842);
  Object closure916 = createclosure(1, "visitReturn()up");
  setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_visitation);
  struct UserObject *uo916 = (struct UserObject*)obj842;
  uo916->data[25] = (Object)closure916;
  Method *meth_meth_ast_visitReturn_40__41_up916 = addmethod2pos(obj842, "visitReturn()up", &meth_ast_visitReturn_40__41_up916, 25);
  int argcv_meth_ast_visitReturn_40__41_up916[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up916->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up916);
  meth_meth_ast_visitReturn_40__41_up916->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up916->definitionLine = 2857;
// method "visitInherits()up"
  block_savedest(obj842);
  Object closure919 = createclosure(1, "visitInherits()up");
  setclosureframe(closure919, stackframe);
  addtoclosure(closure919, var_visitation);
  struct UserObject *uo919 = (struct UserObject*)obj842;
  uo919->data[26] = (Object)closure919;
  Method *meth_meth_ast_visitInherits_40__41_up919 = addmethod2pos(obj842, "visitInherits()up", &meth_ast_visitInherits_40__41_up919, 26);
  int argcv_meth_ast_visitInherits_40__41_up919[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up919->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up919);
  meth_meth_ast_visitInherits_40__41_up919->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up919->definitionLine = 2858;
// method "visitDialect()up"
  block_savedest(obj842);
  Object closure922 = createclosure(1, "visitDialect()up");
  setclosureframe(closure922, stackframe);
  addtoclosure(closure922, var_visitation);
  struct UserObject *uo922 = (struct UserObject*)obj842;
  uo922->data[27] = (Object)closure922;
  Method *meth_meth_ast_visitDialect_40__41_up922 = addmethod2pos(obj842, "visitDialect()up", &meth_ast_visitDialect_40__41_up922, 27);
  int argcv_meth_ast_visitDialect_40__41_up922[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up922->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up922);
  meth_meth_ast_visitDialect_40__41_up922->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up922->definitionLine = 2859;
// method "visitBlank()up"
  block_savedest(obj842);
  Object closure925 = createclosure(1, "visitBlank()up");
  setclosureframe(closure925, stackframe);
  addtoclosure(closure925, var_visitation);
  struct UserObject *uo925 = (struct UserObject*)obj842;
  uo925->data[28] = (Object)closure925;
  Method *meth_meth_ast_visitBlank_40__41_up925 = addmethod2pos(obj842, "visitBlank()up", &meth_ast_visitBlank_40__41_up925, 28);
  int argcv_meth_ast_visitBlank_40__41_up925[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up925->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up925);
  meth_meth_ast_visitBlank_40__41_up925->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up925->definitionLine = 2860;
// method "visitComment()up"
  block_savedest(obj842);
  Object closure928 = createclosure(1, "visitComment()up");
  setclosureframe(closure928, stackframe);
  addtoclosure(closure928, var_visitation);
  struct UserObject *uo928 = (struct UserObject*)obj842;
  uo928->data[29] = (Object)closure928;
  Method *meth_meth_ast_visitComment_40__41_up928 = addmethod2pos(obj842, "visitComment()up", &meth_ast_visitComment_40__41_up928, 29);
  int argcv_meth_ast_visitComment_40__41_up928[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up928->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up928);
  meth_meth_ast_visitComment_40__41_up928->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up928->definitionLine = 2861;
// method "asString"
  struct UserObject *uo931 = (struct UserObject*)obj842;
  uo931->data[30] = emptyclosure;
  Method *meth_meth_ast_asString931 = addmethod2pos(obj842, "asString", &meth_ast_asString931, 30);
  int argcv_meth_ast_asString931[] = {0};
  meth_meth_ast_asString931->type = alloc_MethodType(1, argcv_meth_ast_asString931);
  meth_meth_ast_asString931->definitionModule = modulename;
  meth_meth_ast_asString931->definitionLine = 2863;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  sourceObject = obj842;
  objclass842 = obj842->class;
  objclass842->definitionModule = modulename;
  objclass842->definitionLine = 2826;
  (*(struct UserObject *)self).data[0] = lowerouter842;
  self = oldself842;
  selfslot = oldselfslot842;
  stackframe = oldstackframe842;
  gc_frame_end(frame);
  return obj842;
}
Object meth_ast__apply943(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_944 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  partcv[0] = 0;
  Object call947 = callmethod(*var_ann, "value",
    1, partcv, params);
  gc_frame_end(callframe946);
// compiled call node returning call947 (depth = 9)
// compiled member node returning call947 (depth = 8)
  int op_slot_left_944 = gc_frame_newslot(call947);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult948 = callmethod(call947, "==", 1, partcv, params);
// compiled op node returning opresult948 (depth = 7)
  gc_frame_end(frame);
  return opresult948;
}
Object meth_ast__apply939(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe941 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block942 = alloc_Block(NULL, NULL, "ast", 2877);
  gc_frame_newslot(block942);
// method "_apply"
  block_savedest(block942);
  Object closure943 = createclosure(3, "_apply");
  setclosureframe(closure943, stackframe);
  addtoclosure(closure943, var_annName);
  addtoclosure(closure943, var_ann);
  addtoclosure(closure943, selfslot);
  struct UserObject *uo943 = (struct UserObject*)block942;
  uo943->data[0] = (Object)closure943;
  Method *meth_meth_ast__apply943 = addmethod2pos(block942, "_apply", &meth_ast__apply943, 0);
  int argcv_meth_ast__apply943[] = {0};
  meth_meth_ast__apply943->type = alloc_MethodType(1, argcv_meth_ast__apply943);
  meth_meth_ast__apply943->definitionModule = modulename;
  meth_meth_ast__apply943->definitionLine = 2876;
// compiled block node returning block942 (depth = 6)
  gc_frame_newslot(block942);
// call case 6: other member request
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit951 == NULL) {
    strlit951 = alloc_String("identifier");
    gc_root(strlit951);
  }
// compiled string node returning strlit951 (depth = 7)
  int op_slot_right_950 = gc_frame_newslot(strlit951);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  partcv[0] = 0;
  Object call954 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe953);
// compiled call node returning call954 (depth = 8)
// compiled member node returning call954 (depth = 7)
  int op_slot_left_950 = gc_frame_newslot(call954);
  params[0] = strlit951;
  partcv[0] = 1;
  Object opresult955 = callmethod(call954, "==", 1, partcv, params);
// compiled op node returning opresult955 (depth = 6)
  params[0] = block942;
  partcv[0] = 1;
  Object call956 = callmethod(opresult955, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe941);
// compiled call node returning call956 (depth = 5)
  Object if940 = done;
  if (istrue(call956)) {
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject957 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj957 = alloc_userobj2(1,2, objclass957);
  gc_frame_newslot(obj957);
// OBJECT OUTER DEC outer
  adddatum2(obj957, self, 0);
  addmethodreal(obj957,"outer", &reader_ast_outer_958);
  Object oldself957 = self;
  struct StackFrameObject *oldstackframe957 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe957);
  gc_frame_newslot((Object)stackframe);
  self = obj957;
  Object *oldselfslot957 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter957 = (*(struct UserObject *)self).data[0], lowerouter957 = thisouter957;
  if (inheritingObject957) {
    struct UserObject *inho957 = (struct UserObject *)inheritingObject957;
    while (inho957->super != GraceDefaultObject) inho957 = (struct UserObject *)inho957->super;
    inho957->super = obj957;
    self = inheritingObject957;
    *selfslot = self;
    lowerouter957 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter957;
  }
if (objclass957 == NULL) {
  Method *reader959 = addmethodrealflags(obj957, "value",&reader_ast_value_959, MFLAG_DEF);
  reader959->definitionModule = modulename;
  reader959->definitionLine = 2881;
}
adddatum2(obj957, alloc_Undefined(), 1);
  sourceObject = obj957;
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool960 = alloc_Boolean(1);
// compiled identifier node returning bool960 (depth = 7)
  struct UserObject *obj957_uo = (struct UserObject *)obj957;
  obj957_uo->super = bool960;
  sourceObject = obj957;
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj957, *var_ann, 1);
  objclass957 = obj957->class;
  objclass957->definitionModule = modulename;
  objclass957->definitionLine = 2879;
  (*(struct UserObject *)self).data[0] = lowerouter957;
  self = oldself957;
  selfslot = oldselfslot957;
  stackframe = oldstackframe957;
// compiled object node returning obj957 (depth = 6)
  block_return(realself, obj957);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if940 = undefined;
  } else {
  }
// compiled if node returning if940 (depth = 4)
  gc_frame_end(frame);
  return if940;
}
Object meth_ast_findAnnotation934(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findAnnotation");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for findAnnotation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe935 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call937 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 4)
// compiled member node returning call937 (depth = 3)
  gc_frame_newslot(call937);
// starting to compile block node (depth = 3)
  Object block938 = alloc_Block(NULL, NULL, "ast", 2876);
  gc_frame_newslot(block938);
// method "_apply"
  block_savedest(block938);
  Object closure939 = createclosure(2, "_apply");
  setclosureframe(closure939, stackframe);
  addtoclosure(closure939, var_annName);
  addtoclosure(closure939, selfslot);
  struct UserObject *uo939 = (struct UserObject*)block938;
  uo939->data[0] = (Object)closure939;
  Method *meth_meth_ast__apply939 = addmethod2pos(block938, "_apply", &meth_ast__apply939, 0);
  int argcv_meth_ast__apply939[] = {1};
  meth_meth_ast__apply939->type = alloc_MethodType(1, argcv_meth_ast__apply939);
  meth_meth_ast__apply939->definitionModule = modulename;
  meth_meth_ast__apply939->definitionLine = 2876;
// compiled block node returning block938 (depth = 3)
  gc_frame_newslot(block938);
// call case 5: prelude request
  params[0] = call937;
  params[1] = block938;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call962 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe935);
// compiled call node returning call962 (depth = 2)
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool963 = alloc_Boolean(0);
// compiled identifier node returning bool963 (depth = 2)
  gc_frame_end(frame);
  return bool963;
}
Object meth_ast_lineLength965(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lineLength");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lineLength (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lineLength");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineLength (depth = 3)
  gc_frame_end(frame);
  return *var_lineLength;
}
Object meth_ast_isEmpty971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool972 = alloc_Boolean(1);
// compiled identifier node returning bool972 (depth = 3)
  gc_frame_end(frame);
  return bool972;
}
Object meth_ast_asString973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit974 == NULL) {
    strlit974 = alloc_String("ancestorChain ""\xe2""""\x96""""\xab""");
    gc_root(strlit974);
  }
// compiled string node returning strlit974 (depth = 3)
  gc_frame_end(frame);
  return strlit974;
}
Object meth_ast_extend975(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe976 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe977 = gc_frame_new();
// call case 3: self.outer request
  Object call978 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe977);
// compiled call node returning call978 (depth = 5)
// compiled member node returning call978 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call979 = callmethodflags(call978, "cons()onto", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe976);
// compiled call node returning call979 (depth = 3)
  gc_frame_end(frame);
  return call979;
}
Object meth_ast_empty968(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject969 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj969 = alloc_userobj2(3,4, objclass969);
  gc_frame_newslot(obj969);
if (objclass969 == NULL) {
  glfree(obj969->class->name);
  obj969->class->name = "empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj969, self, 0);
  addmethodreal(obj969,"outer", &reader_ast_outer_970);
  Object oldself969 = self;
  struct StackFrameObject *oldstackframe969 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe969);
  gc_frame_newslot((Object)stackframe);
  self = obj969;
  Object *oldselfslot969 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter969 = (*(struct UserObject *)self).data[0], lowerouter969 = thisouter969;
  if (inheritingObject969) {
    struct UserObject *inho969 = (struct UserObject *)inheritingObject969;
    while (inho969->super != GraceDefaultObject) inho969 = (struct UserObject *)inho969->super;
    inho969->super = obj969;
    self = inheritingObject969;
    *selfslot = self;
    lowerouter969 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter969;
  }
// method "isEmpty"
  struct UserObject *uo971 = (struct UserObject*)obj969;
  uo971->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty971 = addmethod2pos(obj969, "isEmpty", &meth_ast_isEmpty971, 1);
  int argcv_meth_ast_isEmpty971[] = {0};
  meth_meth_ast_isEmpty971->type = alloc_MethodType(1, argcv_meth_ast_isEmpty971);
  meth_meth_ast_isEmpty971->definitionModule = modulename;
  meth_meth_ast_isEmpty971->definitionLine = 39;
// method "asString"
  struct UserObject *uo973 = (struct UserObject*)obj969;
  uo973->data[2] = emptyclosure;
  Method *meth_meth_ast_asString973 = addmethod2pos(obj969, "asString", &meth_ast_asString973, 2);
  int argcv_meth_ast_asString973[] = {0};
  meth_meth_ast_asString973->type = alloc_MethodType(1, argcv_meth_ast_asString973);
  meth_meth_ast_asString973->definitionModule = modulename;
  meth_meth_ast_asString973->definitionLine = 40;
// method "extend"
  struct UserObject *uo975 = (struct UserObject*)obj969;
  uo975->data[3] = emptyclosure;
  Method *meth_meth_ast_extend975 = addmethod2pos(obj969, "extend", &meth_ast_extend975, 3);
  int argcv_meth_ast_extend975[] = {1};
  meth_meth_ast_extend975->type = alloc_MethodType(1, argcv_meth_ast_extend975);
  meth_meth_ast_extend975->definitionModule = modulename;
  meth_meth_ast_extend975->definitionLine = 41;
  sourceObject = obj969;
  sourceObject = obj969;
  sourceObject = obj969;
  objclass969 = obj969->class;
  objclass969->definitionModule = modulename;
  objclass969->definitionLine = 38;
  (*(struct UserObject *)self).data[0] = lowerouter969;
  self = oldself969;
  selfslot = oldselfslot969;
  stackframe = oldstackframe969;
  gc_frame_end(frame);
  return obj969;
}
Object meth_ast_empty968_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject969 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj969 = alloc_userobj2(3,4, objclass969);
  gc_frame_newslot(obj969);
if (objclass969 == NULL) {
  glfree(obj969->class->name);
  obj969->class->name = "empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj969, self, 0);
  addmethodreal(obj969,"outer", &reader_ast_outer_970);
  Object oldself969 = self;
  struct StackFrameObject *oldstackframe969 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe969);
  gc_frame_newslot((Object)stackframe);
  self = obj969;
  Object *oldselfslot969 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter969 = (*(struct UserObject *)self).data[0], lowerouter969 = thisouter969;
  if (inheritingObject969) {
    struct UserObject *inho969 = (struct UserObject *)inheritingObject969;
    while (inho969->super != GraceDefaultObject) inho969 = (struct UserObject *)inho969->super;
    inho969->super = obj969;
    self = inheritingObject969;
    *selfslot = self;
    lowerouter969 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter969;
  }
// method "isEmpty"
  struct UserObject *uo971 = (struct UserObject*)obj969;
  uo971->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty971 = addmethod2pos(obj969, "isEmpty", &meth_ast_isEmpty971, 1);
  int argcv_meth_ast_isEmpty971[] = {0};
  meth_meth_ast_isEmpty971->type = alloc_MethodType(1, argcv_meth_ast_isEmpty971);
  meth_meth_ast_isEmpty971->definitionModule = modulename;
  meth_meth_ast_isEmpty971->definitionLine = 39;
// method "asString"
  struct UserObject *uo973 = (struct UserObject*)obj969;
  uo973->data[2] = emptyclosure;
  Method *meth_meth_ast_asString973 = addmethod2pos(obj969, "asString", &meth_ast_asString973, 2);
  int argcv_meth_ast_asString973[] = {0};
  meth_meth_ast_asString973->type = alloc_MethodType(1, argcv_meth_ast_asString973);
  meth_meth_ast_asString973->definitionModule = modulename;
  meth_meth_ast_asString973->definitionLine = 40;
// method "extend"
  struct UserObject *uo975 = (struct UserObject*)obj969;
  uo975->data[3] = emptyclosure;
  Method *meth_meth_ast_extend975 = addmethod2pos(obj969, "extend", &meth_ast_extend975, 3);
  int argcv_meth_ast_extend975[] = {1};
  meth_meth_ast_extend975->type = alloc_MethodType(1, argcv_meth_ast_extend975);
  meth_meth_ast_extend975->definitionModule = modulename;
  meth_meth_ast_extend975->definitionLine = 41;
  sourceObject = obj969;
  sourceObject = obj969;
  sourceObject = obj969;
  objclass969 = obj969->class;
  objclass969->definitionModule = modulename;
  objclass969->definitionLine = 38;
  (*(struct UserObject *)self).data[0] = lowerouter969;
  self = oldself969;
  selfslot = oldselfslot969;
  stackframe = oldstackframe969;
  gc_frame_end(frame);
  return obj969;
}
Object meth_ast_with981(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method with");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for with (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe982 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe983 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call984 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe983);
// compiled call node returning call984 (depth = 5)
// compiled member node returning call984 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call985 = callmethod(call984, "extend",
    1, partcv, params);
  gc_frame_end(callframe982);
// compiled call node returning call985 (depth = 3)
  gc_frame_end(frame);
  return call985;
}
Object meth_ast_forebears989(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forebears");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_as = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for forebears (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for forebears");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_end(frame);
  return *var_as;
}
Object meth_ast_isEmpty990(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool991 = alloc_Boolean(0);
// compiled identifier node returning bool991 (depth = 3)
  gc_frame_end(frame);
  return bool991;
}
Object meth_ast_parent992(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_p (depth = 3)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_ast_grandparent993(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "grandparent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for grandparent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for grandparent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe994 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe995 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call996 = callmethodflags(self, "forebears", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe995);
// compiled call node returning call996 (depth = 6)
// compiled member node returning call996 (depth = 5)
  partcv[0] = 0;
  Object call997 = callmethod(call996, "parent",
    1, partcv, params);
  gc_frame_end(callframe994);
// compiled call node returning call997 (depth = 4)
// compiled member node returning call997 (depth = 3)
  gc_frame_end(frame);
  return call997;
}
Object meth_ast__apply1002(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1003 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call1005 = callmethod(*var_a, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe1004);
// compiled call node returning call1005 (depth = 8)
// compiled member node returning call1005 (depth = 7)
  partcv[0] = 0;
  Object call1006 = callmethod(call1005, "not",
    1, partcv, params);
  gc_frame_end(callframe1003);
// compiled call node returning call1006 (depth = 6)
// compiled member node returning call1006 (depth = 5)
  gc_frame_end(frame);
  return call1006;
}
Object meth_ast__apply1009(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1011 == NULL) {
    strlit1011 = alloc_String("""\xe2""""\x9e""""\xa4""");
    gc_root(strlit1011);
  }
// compiled string node returning strlit1011 (depth = 7)
  int op_slot_right_1010 = gc_frame_newslot(strlit1011);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call1015 = callmethod(*var_a, "parent",
    1, partcv, params);
  gc_frame_end(callframe1014);
// compiled call node returning call1015 (depth = 9)
// compiled member node returning call1015 (depth = 8)
  int op_slot_right_1013 = gc_frame_newslot(call1015);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1013 = gc_frame_newslot(*var_s);
  params[0] = call1015;
  partcv[0] = 1;
  Object opresult1017 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1017 (depth = 7)
  int op_slot_left_1010 = gc_frame_newslot(opresult1017);
  params[0] = strlit1011;
  partcv[0] = 1;
  Object opresult1018 = callmethod(opresult1017, "++", 1, partcv, params);
// compiled op node returning opresult1018 (depth = 6)
  *var_s = opresult1018;
  if (opresult1018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call1021 = callmethod(*var_a, "forebears",
    1, partcv, params);
  gc_frame_end(callframe1020);
// compiled call node returning call1021 (depth = 7)
// compiled member node returning call1021 (depth = 6)
  *var_a = call1021;
  if (call1021 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString998(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit999 == NULL) {
    strlit999 = alloc_String("ancestorChain ");
    gc_root(strlit999);
  }
// compiled string node returning strlit999 (depth = 4)
  *var_s = strlit999;
  if (strlit999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1000 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1001 = alloc_Block(NULL, NULL, "ast", 53);
  gc_frame_newslot(block1001);
// method "_apply"
  block_savedest(block1001);
  Object closure1002 = createclosure(2, "_apply");
  setclosureframe(closure1002, stackframe);
  addtoclosure(closure1002, var_a);
  addtoclosure(closure1002, selfslot);
  struct UserObject *uo1002 = (struct UserObject*)block1001;
  uo1002->data[0] = (Object)closure1002;
  Method *meth_meth_ast__apply1002 = addmethod2pos(block1001, "_apply", &meth_ast__apply1002, 0);
  int argcv_meth_ast__apply1002[] = {0};
  meth_meth_ast__apply1002->type = alloc_MethodType(1, argcv_meth_ast__apply1002);
  meth_meth_ast__apply1002->definitionModule = modulename;
  meth_meth_ast__apply1002->definitionLine = 48;
// compiled block node returning block1001 (depth = 4)
  gc_frame_newslot(block1001);
// starting to compile block node (depth = 4)
  Object block1008 = alloc_Block(NULL, NULL, "ast", 53);
  gc_frame_newslot(block1008);
// method "_apply"
  block_savedest(block1008);
  Object closure1009 = createclosure(3, "_apply");
  setclosureframe(closure1009, stackframe);
  addtoclosure(closure1009, var_a);
  addtoclosure(closure1009, var_s);
  addtoclosure(closure1009, selfslot);
  struct UserObject *uo1009 = (struct UserObject*)block1008;
  uo1009->data[0] = (Object)closure1009;
  Method *meth_meth_ast__apply1009 = addmethod2pos(block1008, "_apply", &meth_ast__apply1009, 0);
  int argcv_meth_ast__apply1009[] = {0};
  meth_meth_ast__apply1009->type = alloc_MethodType(1, argcv_meth_ast__apply1009);
  meth_meth_ast__apply1009->definitionModule = modulename;
  meth_meth_ast__apply1009->definitionLine = 53;
// compiled block node returning block1008 (depth = 4)
  gc_frame_newslot(block1008);
// call case 5: prelude request
  params[0] = block1001;
  params[1] = block1008;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1024 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1000);
// compiled call node returning call1024 (depth = 3)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1026 == NULL) {
    strlit1026 = alloc_String("""\xe2""""\x96""""\xab""");
    gc_root(strlit1026);
  }
// compiled string node returning strlit1026 (depth = 4)
  int op_slot_right_1025 = gc_frame_newslot(strlit1026);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1025 = gc_frame_newslot(*var_s);
  params[0] = strlit1026;
  partcv[0] = 1;
  Object opresult1028 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1028 (depth = 3)
  gc_frame_end(frame);
  return opresult1028;
}
Object meth_ast_extend1029(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1030 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1031 = gc_frame_new();
// call case 3: self.outer request
  Object call1032 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1031);
// compiled call node returning call1032 (depth = 5)
// compiled member node returning call1032 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1033 = callmethodflags(call1032, "cons()onto", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1030);
// compiled call node returning call1033 (depth = 3)
  gc_frame_end(frame);
  return call1033;
}
Object meth_ast_cons_40__41_onto986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons()onto");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons()onto (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for cons");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj987 = alloc_userobj2(6,7, objclass987);
  gc_frame_newslot(obj987);
if (objclass987 == NULL) {
  glfree(obj987->class->name);
  obj987->class->name = "cons()onto";
}
// OBJECT OUTER DEC outer
  adddatum2(obj987, self, 0);
  addmethodreal(obj987,"outer", &reader_ast_outer_988);
  Object oldself987 = self;
  struct StackFrameObject *oldstackframe987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe987);
  gc_frame_newslot((Object)stackframe);
  self = obj987;
  Object *oldselfslot987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter987 = (*(struct UserObject *)self).data[0], lowerouter987 = thisouter987;
  if (inheritingObject987) {
    struct UserObject *inho987 = (struct UserObject *)inheritingObject987;
    while (inho987->super != GraceDefaultObject) inho987 = (struct UserObject *)inho987->super;
    inho987->super = obj987;
    self = inheritingObject987;
    *selfslot = self;
    lowerouter987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter987;
  }
// method "forebears"
  block_savedest(obj987);
  Object closure989 = createclosure(1, "forebears");
  setclosureframe(closure989, stackframe);
  addtoclosure(closure989, var_as);
  struct UserObject *uo989 = (struct UserObject*)obj987;
  uo989->data[1] = (Object)closure989;
  Method *meth_meth_ast_forebears989 = addmethod2pos(obj987, "forebears", &meth_ast_forebears989, 1);
  int argcv_meth_ast_forebears989[] = {0};
  meth_meth_ast_forebears989->type = alloc_MethodType(1, argcv_meth_ast_forebears989);
  meth_meth_ast_forebears989->definitionModule = modulename;
  meth_meth_ast_forebears989->definitionLine = 45;
// method "isEmpty"
  struct UserObject *uo990 = (struct UserObject*)obj987;
  uo990->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty990 = addmethod2pos(obj987, "isEmpty", &meth_ast_isEmpty990, 2);
  int argcv_meth_ast_isEmpty990[] = {0};
  meth_meth_ast_isEmpty990->type = alloc_MethodType(1, argcv_meth_ast_isEmpty990);
  meth_meth_ast_isEmpty990->definitionModule = modulename;
  meth_meth_ast_isEmpty990->definitionLine = 46;
// method "parent"
  block_savedest(obj987);
  Object closure992 = createclosure(1, "parent");
  setclosureframe(closure992, stackframe);
  addtoclosure(closure992, var_p);
  struct UserObject *uo992 = (struct UserObject*)obj987;
  uo992->data[3] = (Object)closure992;
  Method *meth_meth_ast_parent992 = addmethod2pos(obj987, "parent", &meth_ast_parent992, 3);
  int argcv_meth_ast_parent992[] = {0};
  meth_meth_ast_parent992->type = alloc_MethodType(1, argcv_meth_ast_parent992);
  meth_meth_ast_parent992->definitionModule = modulename;
  meth_meth_ast_parent992->definitionLine = 47;
// method "grandparent"
  struct UserObject *uo993 = (struct UserObject*)obj987;
  uo993->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent993 = addmethod2pos(obj987, "grandparent", &meth_ast_grandparent993, 4);
  int argcv_meth_ast_grandparent993[] = {0};
  meth_meth_ast_grandparent993->type = alloc_MethodType(1, argcv_meth_ast_grandparent993);
  meth_meth_ast_grandparent993->definitionModule = modulename;
  meth_meth_ast_grandparent993->definitionLine = 48;
// method "asString"
  struct UserObject *uo998 = (struct UserObject*)obj987;
  uo998->data[5] = emptyclosure;
  Method *meth_meth_ast_asString998 = addmethod2pos(obj987, "asString", &meth_ast_asString998, 5);
  int argcv_meth_ast_asString998[] = {0};
  meth_meth_ast_asString998->type = alloc_MethodType(1, argcv_meth_ast_asString998);
  meth_meth_ast_asString998->definitionModule = modulename;
  meth_meth_ast_asString998->definitionLine = 50;
// method "extend"
  struct UserObject *uo1029 = (struct UserObject*)obj987;
  uo1029->data[6] = emptyclosure;
  Method *meth_meth_ast_extend1029 = addmethod2pos(obj987, "extend", &meth_ast_extend1029, 6);
  int argcv_meth_ast_extend1029[] = {1};
  meth_meth_ast_extend1029->type = alloc_MethodType(1, argcv_meth_ast_extend1029);
  meth_meth_ast_extend1029->definitionModule = modulename;
  meth_meth_ast_extend1029->definitionLine = 59;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  objclass987 = obj987->class;
  objclass987->definitionModule = modulename;
  objclass987->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter987;
  self = oldself987;
  selfslot = oldselfslot987;
  stackframe = oldstackframe987;
  gc_frame_end(frame);
  return obj987;
}
Object meth_ast_cons_40__41_onto986_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons()onto()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons()onto (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for cons");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj987 = alloc_userobj2(6,7, objclass987);
  gc_frame_newslot(obj987);
if (objclass987 == NULL) {
  glfree(obj987->class->name);
  obj987->class->name = "cons()onto";
}
// OBJECT OUTER DEC outer
  adddatum2(obj987, self, 0);
  addmethodreal(obj987,"outer", &reader_ast_outer_988);
  Object oldself987 = self;
  struct StackFrameObject *oldstackframe987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe987);
  gc_frame_newslot((Object)stackframe);
  self = obj987;
  Object *oldselfslot987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter987 = (*(struct UserObject *)self).data[0], lowerouter987 = thisouter987;
  if (inheritingObject987) {
    struct UserObject *inho987 = (struct UserObject *)inheritingObject987;
    while (inho987->super != GraceDefaultObject) inho987 = (struct UserObject *)inho987->super;
    inho987->super = obj987;
    self = inheritingObject987;
    *selfslot = self;
    lowerouter987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter987;
  }
// method "forebears"
  block_savedest(obj987);
  Object closure989 = createclosure(1, "forebears");
  setclosureframe(closure989, stackframe);
  addtoclosure(closure989, var_as);
  struct UserObject *uo989 = (struct UserObject*)obj987;
  uo989->data[1] = (Object)closure989;
  Method *meth_meth_ast_forebears989 = addmethod2pos(obj987, "forebears", &meth_ast_forebears989, 1);
  int argcv_meth_ast_forebears989[] = {0};
  meth_meth_ast_forebears989->type = alloc_MethodType(1, argcv_meth_ast_forebears989);
  meth_meth_ast_forebears989->definitionModule = modulename;
  meth_meth_ast_forebears989->definitionLine = 45;
// method "isEmpty"
  struct UserObject *uo990 = (struct UserObject*)obj987;
  uo990->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty990 = addmethod2pos(obj987, "isEmpty", &meth_ast_isEmpty990, 2);
  int argcv_meth_ast_isEmpty990[] = {0};
  meth_meth_ast_isEmpty990->type = alloc_MethodType(1, argcv_meth_ast_isEmpty990);
  meth_meth_ast_isEmpty990->definitionModule = modulename;
  meth_meth_ast_isEmpty990->definitionLine = 46;
// method "parent"
  block_savedest(obj987);
  Object closure992 = createclosure(1, "parent");
  setclosureframe(closure992, stackframe);
  addtoclosure(closure992, var_p);
  struct UserObject *uo992 = (struct UserObject*)obj987;
  uo992->data[3] = (Object)closure992;
  Method *meth_meth_ast_parent992 = addmethod2pos(obj987, "parent", &meth_ast_parent992, 3);
  int argcv_meth_ast_parent992[] = {0};
  meth_meth_ast_parent992->type = alloc_MethodType(1, argcv_meth_ast_parent992);
  meth_meth_ast_parent992->definitionModule = modulename;
  meth_meth_ast_parent992->definitionLine = 47;
// method "grandparent"
  struct UserObject *uo993 = (struct UserObject*)obj987;
  uo993->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent993 = addmethod2pos(obj987, "grandparent", &meth_ast_grandparent993, 4);
  int argcv_meth_ast_grandparent993[] = {0};
  meth_meth_ast_grandparent993->type = alloc_MethodType(1, argcv_meth_ast_grandparent993);
  meth_meth_ast_grandparent993->definitionModule = modulename;
  meth_meth_ast_grandparent993->definitionLine = 48;
// method "asString"
  struct UserObject *uo998 = (struct UserObject*)obj987;
  uo998->data[5] = emptyclosure;
  Method *meth_meth_ast_asString998 = addmethod2pos(obj987, "asString", &meth_ast_asString998, 5);
  int argcv_meth_ast_asString998[] = {0};
  meth_meth_ast_asString998->type = alloc_MethodType(1, argcv_meth_ast_asString998);
  meth_meth_ast_asString998->definitionModule = modulename;
  meth_meth_ast_asString998->definitionLine = 50;
// method "extend"
  struct UserObject *uo1029 = (struct UserObject*)obj987;
  uo1029->data[6] = emptyclosure;
  Method *meth_meth_ast_extend1029 = addmethod2pos(obj987, "extend", &meth_ast_extend1029, 6);
  int argcv_meth_ast_extend1029[] = {1};
  meth_meth_ast_extend1029->type = alloc_MethodType(1, argcv_meth_ast_extend1029);
  meth_meth_ast_extend1029->definitionModule = modulename;
  meth_meth_ast_extend1029->definitionLine = 59;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  sourceObject = obj987;
  objclass987 = obj987->class;
  objclass987->definitionModule = modulename;
  objclass987->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter987;
  self = oldself987;
  selfslot = oldselfslot987;
  stackframe = oldstackframe987;
  gc_frame_end(frame);
  return obj987;
}
Object meth_ast_ancestorChain1035(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ancestorChain");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ancestorChain (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ancestorChain");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ancestorChain (depth = 3)
  gc_frame_end(frame);
  return *var_ancestorChain;
}
Object meth_ast_emptySeq1040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for emptySeq (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for emptySeq");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_AstNode1043(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for AstNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for AstNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_SymbolTable1045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for SymbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for SymbolTable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_SymbolTable;
}
Object meth_ast_toGrace1049(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1050 == NULL) {
    strlit1050 = alloc_String("// null");
    gc_root(strlit1050);
  }
// compiled string node returning strlit1050 (depth = 3)
  gc_frame_end(frame);
  return strlit1050;
}
Object meth_ast_nullNode1056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nullNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nullNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_asString1060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1061 == NULL) {
    strlit1061 = alloc_String("fake Symbol Table");
    gc_root(strlit1061);
  }
// compiled string node returning strlit1061 (depth = 3)
  gc_frame_end(frame);
  return strlit1061;
}
Object meth_ast_addNode_40__41_as1062(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addNode()as");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode()as");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode()as");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addNode()as (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addNode");
  Object *var_kind = &(stackframe->slots[1]);
  *var_kind = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for as");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1063 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1065 == NULL) {
    strlit1065 = alloc_String("""\x22"" requested");
    gc_root(strlit1065);
  }
// compiled string node returning strlit1065 (depth = 5)
  int op_slot_right_1064 = gc_frame_newslot(strlit1065);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_kind (depth = 6)
  int op_slot_right_1067 = gc_frame_newslot(*var_kind);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1070 == NULL) {
    strlit1070 = alloc_String(") as ""\x22""");
    gc_root(strlit1070);
  }
// compiled string node returning strlit1070 (depth = 7)
  int op_slot_right_1069 = gc_frame_newslot(strlit1070);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1072 = gc_frame_newslot(*var_n);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1075 == NULL) {
    strlit1075 = alloc_String(").addNode(");
    gc_root(strlit1075);
  }
// compiled string node returning strlit1075 (depth = 9)
  int op_slot_right_1074 = gc_frame_newslot(strlit1075);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1078 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1079 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1078);
// compiled call node returning call1079 (depth = 11)
// compiled member node returning call1079 (depth = 10)
  int op_slot_right_1077 = gc_frame_newslot(call1079);
// starting to compile string node (depth = 10)
  if (strlit1081 == NULL) {
    strlit1081 = alloc_String("fakeSymbolTable(on node ");
    gc_root(strlit1081);
  }
// compiled string node returning strlit1081 (depth = 10)
  int op_slot_left_1077 = gc_frame_newslot(strlit1081);
  params[0] = call1079;
  partcv[0] = 1;
  Object opresult1082 = callmethod(strlit1081, "++", 1, partcv, params);
// compiled op node returning opresult1082 (depth = 9)
  int op_slot_left_1074 = gc_frame_newslot(opresult1082);
  params[0] = strlit1075;
  partcv[0] = 1;
  Object opresult1083 = callmethod(opresult1082, "++", 1, partcv, params);
// compiled op node returning opresult1083 (depth = 8)
  int op_slot_left_1072 = gc_frame_newslot(opresult1083);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1084 = callmethod(opresult1083, "++", 1, partcv, params);
// compiled op node returning opresult1084 (depth = 7)
  int op_slot_left_1069 = gc_frame_newslot(opresult1084);
  params[0] = strlit1070;
  partcv[0] = 1;
  Object opresult1085 = callmethod(opresult1084, "++", 1, partcv, params);
// compiled op node returning opresult1085 (depth = 6)
  int op_slot_left_1067 = gc_frame_newslot(opresult1085);
  params[0] = *var_kind;
  partcv[0] = 1;
  Object opresult1086 = callmethod(opresult1085, "++", 1, partcv, params);
// compiled op node returning opresult1086 (depth = 5)
  int op_slot_left_1064 = gc_frame_newslot(opresult1086);
  params[0] = strlit1065;
  partcv[0] = 1;
  Object opresult1087 = callmethod(opresult1086, "++", 1, partcv, params);
// compiled op node returning opresult1087 (depth = 4)
  gc_frame_newslot(opresult1087);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1088 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1089 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1088);
// compiled call node returning call1089 (depth = 5)
// compiled member node returning call1089 (depth = 4)
  params[0] = opresult1087;
  partcv[0] = 1;
  Object call1090 = callmethod(call1089, "raise",
    1, partcv, params);
  gc_frame_end(callframe1063);
// compiled call node returning call1090 (depth = 3)
  gc_frame_end(frame);
  return call1090;
}
Object meth_ast_thatDefines_40__41_ifNone1091(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "thatDefines()ifNone");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines()ifNone");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines()ifNone");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for thatDefines()ifNone (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for thatDefines");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifNone");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1092 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1094 == NULL) {
    strlit1094 = alloc_String(").");
    gc_root(strlit1094);
  }
// compiled string node returning strlit1094 (depth = 5)
  int op_slot_right_1093 = gc_frame_newslot(strlit1094);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  int op_slot_right_1096 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 6)
  if (strlit1098 == NULL) {
    strlit1098 = alloc_String("fakeSymbolTable.thatDefines(");
    gc_root(strlit1098);
  }
// compiled string node returning strlit1098 (depth = 6)
  int op_slot_left_1096 = gc_frame_newslot(strlit1098);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult1099 = callmethod(strlit1098, "++", 1, partcv, params);
// compiled op node returning opresult1099 (depth = 5)
  int op_slot_left_1093 = gc_frame_newslot(opresult1099);
  params[0] = strlit1094;
  partcv[0] = 1;
  Object opresult1100 = callmethod(opresult1099, "++", 1, partcv, params);
// compiled op node returning opresult1100 (depth = 4)
  gc_frame_newslot(opresult1100);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1101 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1102 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1101);
// compiled call node returning call1102 (depth = 5)
// compiled member node returning call1102 (depth = 4)
  params[0] = opresult1100;
  partcv[0] = 1;
  Object call1103 = callmethod(call1102, "raise",
    1, partcv, params);
  gc_frame_end(callframe1092);
// compiled call node returning call1103 (depth = 3)
  gc_frame_end(frame);
  return call1103;
}
Object meth_ast_enclosingObjectScope1104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for enclosingObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for enclosingObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1105 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1107 == NULL) {
    strlit1107 = alloc_String("");
    gc_root(strlit1107);
  }
// compiled string node returning strlit1107 (depth = 5)
  int op_slot_right_1106 = gc_frame_newslot(strlit1107);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1111 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1110);
// compiled call node returning call1111 (depth = 7)
// compiled member node returning call1111 (depth = 6)
  int op_slot_right_1109 = gc_frame_newslot(call1111);
// starting to compile string node (depth = 6)
  if (strlit1113 == NULL) {
    strlit1113 = alloc_String("fakeSymbolTable.enclosingObjectScope on node ");
    gc_root(strlit1113);
  }
// compiled string node returning strlit1113 (depth = 6)
  int op_slot_left_1109 = gc_frame_newslot(strlit1113);
  params[0] = call1111;
  partcv[0] = 1;
  Object opresult1114 = callmethod(strlit1113, "++", 1, partcv, params);
// compiled op node returning opresult1114 (depth = 5)
  int op_slot_left_1106 = gc_frame_newslot(opresult1114);
  params[0] = strlit1107;
  partcv[0] = 1;
  Object opresult1115 = callmethod(opresult1114, "++", 1, partcv, params);
// compiled op node returning opresult1115 (depth = 4)
  gc_frame_newslot(opresult1115);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1116 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1117 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1116);
// compiled call node returning call1117 (depth = 5)
// compiled member node returning call1117 (depth = 4)
  params[0] = opresult1115;
  partcv[0] = 1;
  Object call1118 = callmethod(call1117, "raise",
    1, partcv, params);
  gc_frame_end(callframe1105);
// compiled call node returning call1118 (depth = 3)
  gc_frame_end(frame);
  return call1118;
}
Object meth_ast_variety1119(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "variety");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for variety (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for variety");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1120 == NULL) {
    strlit1120 = alloc_String("fake");
    gc_root(strlit1120);
  }
// compiled string node returning strlit1120 (depth = 3)
  gc_frame_end(frame);
  return strlit1120;
}
Object meth_ast_fakeSymbolTable1121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fakeSymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fakeSymbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for fakeSymbolTable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_fakeSymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_fakeSymbolTable;
}
Object meth_ast_isSimple1132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1133 = alloc_Boolean(0);
// compiled identifier node returning bool1133 (depth = 3)
  gc_frame_end(frame);
  return bool1133;
}
Object meth_ast_accept_40__41_from1134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1136 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1137 = callmethod(*var_visitor, "visitIf()up",
    2, partcv, params);
  gc_frame_end(callframe1136);
// compiled call node returning call1137 (depth = 4)
  Object if1135 = done;
  if (istrue(call1137)) {
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1138 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1139 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1138);
// compiled call node returning call1139 (depth = 5)
  *var_newChain = call1139;
  if (call1139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1140 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1141 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1142 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1141);
// compiled call node returning call1142 (depth = 6)
// compiled member node returning call1142 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1143 = callmethod(call1142, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1140);
// compiled call node returning call1143 (depth = 4)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1144 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1146 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1145);
// compiled call node returning call1146 (depth = 6)
// compiled member node returning call1146 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1147 = callmethod(call1146, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1144);
// compiled call node returning call1147 (depth = 4)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1148 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1150 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1149);
// compiled call node returning call1150 (depth = 6)
// compiled member node returning call1150 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1151 = callmethod(call1150, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1148);
// compiled call node returning call1151 (depth = 4)
    gc_frame_newslot(call1151);
    if1135 = call1151;
  } else {
  }
// compiled if node returning if1135 (depth = 3)
  gc_frame_end(frame);
  return if1135;
}
Object meth_ast_map_40__41_ancestors1152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1154 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1153);
// compiled call node returning call1154 (depth = 5)
// compiled member node returning call1154 (depth = 4)
  *var_n = call1154;
  if (call1154 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1155 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1156 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1155);
// compiled call node returning call1156 (depth = 4)
  *var_newChain = call1156;
  if (call1156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1157 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1158 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1159 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1160 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1159);
// compiled call node returning call1160 (depth = 6)
// compiled member node returning call1160 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1161 = callmethod(call1160, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1158);
// compiled call node returning call1161 (depth = 4)
  gc_frame_newslot(call1161);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1161;
  partcv[0] = 1;
  Object call1162 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1157);
// compiled call node returning call1162 (depth = 3)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1163 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1164 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1166 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1165);
// compiled call node returning call1166 (depth = 6)
// compiled member node returning call1166 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1167 = callmethod(call1166, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1164);
// compiled call node returning call1167 (depth = 4)
  gc_frame_newslot(call1167);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1167;
  partcv[0] = 1;
  Object call1168 = callmethod(*var_n, "thenblock:=",
    1, partcv, params);
  gc_frame_end(callframe1163);
// compiled call node returning call1168 (depth = 3)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1169 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1170 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1172 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1171);
// compiled call node returning call1172 (depth = 6)
// compiled member node returning call1172 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1173 = callmethod(call1172, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1170);
// compiled call node returning call1173 (depth = 4)
  gc_frame_newslot(call1173);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1173;
  partcv[0] = 1;
  Object call1174 = callmethod(*var_n, "elseblock:=",
    1, partcv, params);
  gc_frame_end(callframe1169);
// compiled call node returning call1174 (depth = 3)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1175 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1176 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1175);
// compiled call node returning call1176 (depth = 3)
  gc_frame_end(frame);
  return call1176;
}
Object meth_ast__apply1185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1187 == NULL) {
    strlit1187 = alloc_String("  ");
    gc_root(strlit1187);
  }
// compiled string node returning strlit1187 (depth = 7)
  int op_slot_right_1186 = gc_frame_newslot(strlit1187);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1186 = gc_frame_newslot(*var_spc);
  params[0] = strlit1187;
  partcv[0] = 1;
  Object opresult1189 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1189 (depth = 6)
  *var_spc = opresult1189;
  if (opresult1189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1286(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1288 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1290 = alloc_Float64(2);
// compiled num node returning num1290 (depth = 10)
  int op_slot_right_1289 = gc_frame_newslot(num1290);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1289 = gc_frame_newslot(*var_depth);
  params[0] = num1290;
  partcv[0] = 1;
  Object sum1292 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1292 (depth = 9)
  gc_frame_newslot(sum1292);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1292;
  partcv[0] = 1;
  Object call1293 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1288);
// compiled call node returning call1293 (depth = 8)
  int op_slot_right_1287 = gc_frame_newslot(call1293);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1295 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1298 == NULL) {
    strlit1298 = alloc_String("""\x0a""  ");
    gc_root(strlit1298);
  }
// compiled string node returning strlit1298 (depth = 10)
  int op_slot_right_1297 = gc_frame_newslot(strlit1298);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1297 = gc_frame_newslot(*var_s);
  params[0] = strlit1298;
  partcv[0] = 1;
  Object opresult1300 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1300 (depth = 9)
  int op_slot_left_1295 = gc_frame_newslot(opresult1300);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1301 = callmethod(opresult1300, "++", 1, partcv, params);
// compiled op node returning opresult1301 (depth = 8)
  int op_slot_left_1287 = gc_frame_newslot(opresult1301);
  params[0] = call1293;
  partcv[0] = 1;
  Object opresult1302 = callmethod(opresult1301, "++", 1, partcv, params);
// compiled op node returning opresult1302 (depth = 7)
  *var_s = opresult1302;
  if (opresult1302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1325(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1327 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1329 = alloc_Float64(2);
// compiled num node returning num1329 (depth = 10)
  int op_slot_right_1328 = gc_frame_newslot(num1329);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1328 = gc_frame_newslot(*var_depth);
  params[0] = num1329;
  partcv[0] = 1;
  Object sum1331 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1331 (depth = 9)
  gc_frame_newslot(sum1331);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1331;
  partcv[0] = 1;
  Object call1332 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1327);
// compiled call node returning call1332 (depth = 8)
  int op_slot_right_1326 = gc_frame_newslot(call1332);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1334 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1337 == NULL) {
    strlit1337 = alloc_String("""\x0a""  ");
    gc_root(strlit1337);
  }
// compiled string node returning strlit1337 (depth = 10)
  int op_slot_right_1336 = gc_frame_newslot(strlit1337);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1336 = gc_frame_newslot(*var_s);
  params[0] = strlit1337;
  partcv[0] = 1;
  Object opresult1339 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1339 (depth = 9)
  int op_slot_left_1334 = gc_frame_newslot(opresult1339);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1340 = callmethod(opresult1339, "++", 1, partcv, params);
// compiled op node returning opresult1340 (depth = 8)
  int op_slot_left_1326 = gc_frame_newslot(opresult1340);
  params[0] = call1332;
  partcv[0] = 1;
  Object opresult1341 = callmethod(opresult1340, "++", 1, partcv, params);
// compiled op node returning opresult1341 (depth = 7)
  *var_s = opresult1341;
  if (opresult1341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1178 == NULL) {
    strlit1178 = alloc_String("");
    gc_root(strlit1178);
  }
// compiled string node returning strlit1178 (depth = 4)
  *var_spc = strlit1178;
  if (strlit1178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1179 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1180 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1182 = alloc_Float64(0);
// compiled num node returning num1182 (depth = 5)
  int op_slot_left_1180 = gc_frame_newslot(num1182);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1183 = callmethod(num1182, "..", 1, partcv, params);
// compiled op node returning opresult1183 (depth = 4)
  gc_frame_newslot(opresult1183);
// starting to compile block node (depth = 4)
  Object block1184 = alloc_Block(NULL, NULL, "ast", 236);
  gc_frame_newslot(block1184);
// method "_apply"
  block_savedest(block1184);
  Object closure1185 = createclosure(2, "_apply");
  setclosureframe(closure1185, stackframe);
  addtoclosure(closure1185, var_spc);
  addtoclosure(closure1185, selfslot);
  struct UserObject *uo1185 = (struct UserObject*)block1184;
  uo1185->data[0] = (Object)closure1185;
  Method *meth_meth_ast__apply1185 = addmethod2pos(block1184, "_apply", &meth_ast__apply1185, 0);
  int argcv_meth_ast__apply1185[] = {1};
  meth_meth_ast__apply1185->type = alloc_MethodType(1, argcv_meth_ast__apply1185);
  meth_meth_ast__apply1185->definitionModule = modulename;
  meth_meth_ast__apply1185->definitionLine = 231;
// compiled block node returning block1184 (depth = 4)
  gc_frame_newslot(block1184);
// call case 5: prelude request
  params[0] = opresult1183;
  params[1] = block1184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1192 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1179);
// compiled call node returning call1192 (depth = 3)
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1194 == NULL) {
    strlit1194 = alloc_String("""\x0a""");
    gc_root(strlit1194);
  }
// compiled string node returning strlit1194 (depth = 5)
  int op_slot_right_1193 = gc_frame_newslot(strlit1194);
// starting to compile call node (depth = 5)
  int callframe1196 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1197 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1196);
// compiled call node returning call1197 (depth = 5)
  int op_slot_left_1193 = gc_frame_newslot(call1197);
  params[0] = strlit1194;
  partcv[0] = 1;
  Object opresult1198 = callmethod(call1197, "++", 1, partcv, params);
// compiled op node returning opresult1198 (depth = 4)
  *var_s = opresult1198;
  if (opresult1198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1200 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1202 = alloc_Float64(1);
// compiled num node returning num1202 (depth = 7)
  int op_slot_right_1201 = gc_frame_newslot(num1202);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1201 = gc_frame_newslot(*var_depth);
  params[0] = num1202;
  partcv[0] = 1;
  Object sum1204 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1204 (depth = 6)
  gc_frame_newslot(sum1204);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1205 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1206 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1205);
// compiled call node returning call1206 (depth = 7)
// compiled member node returning call1206 (depth = 6)
  params[0] = sum1204;
  partcv[0] = 1;
  Object call1207 = callmethod(call1206, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1200);
// compiled call node returning call1207 (depth = 5)
  int op_slot_right_1199 = gc_frame_newslot(call1207);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1209 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1209 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1211 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1211 (depth = 5)
  int op_slot_left_1199 = gc_frame_newslot(opresult1211);
  params[0] = call1207;
  partcv[0] = 1;
  Object opresult1212 = callmethod(opresult1211, "++", 1, partcv, params);
// compiled op node returning opresult1212 (depth = 4)
  *var_s = opresult1212;
  if (opresult1212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1215 == NULL) {
    strlit1215 = alloc_String("""\x0a""");
    gc_root(strlit1215);
  }
// compiled string node returning strlit1215 (depth = 5)
  int op_slot_right_1214 = gc_frame_newslot(strlit1215);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1214 = gc_frame_newslot(*var_s);
  params[0] = strlit1215;
  partcv[0] = 1;
  Object opresult1217 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1217 (depth = 4)
  *var_s = opresult1217;
  if (opresult1217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1221 == NULL) {
    strlit1221 = alloc_String("symbols");
    gc_root(strlit1221);
  }
// compiled string node returning strlit1221 (depth = 5)
  int op_slot_right_1220 = gc_frame_newslot(strlit1221);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call1224 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe1223);
// compiled call node returning call1224 (depth = 6)
// compiled member node returning call1224 (depth = 5)
  int op_slot_left_1220 = gc_frame_newslot(call1224);
  params[0] = strlit1221;
  partcv[0] = 1;
  Object opresult1225 = callmethod(call1224, "==", 1, partcv, params);
// compiled op node returning opresult1225 (depth = 4)
  Object if1219 = done;
  if (istrue(opresult1225)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1228 == NULL) {
    strlit1228 = alloc_String("""\x0a""");
    gc_root(strlit1228);
  }
// compiled string node returning strlit1228 (depth = 7)
  int op_slot_right_1227 = gc_frame_newslot(strlit1228);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1231 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1233 = alloc_Float64(2);
// compiled num node returning num1233 (depth = 10)
  int op_slot_right_1232 = gc_frame_newslot(num1233);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1232 = gc_frame_newslot(*var_depth);
  params[0] = num1233;
  partcv[0] = 1;
  Object sum1235 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1235 (depth = 9)
  gc_frame_newslot(sum1235);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1237 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1236);
// compiled call node returning call1237 (depth = 10)
// compiled member node returning call1237 (depth = 9)
  params[0] = sum1235;
  partcv[0] = 1;
  Object call1238 = callmethod(call1237, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1231);
// compiled call node returning call1238 (depth = 8)
  int op_slot_right_1230 = gc_frame_newslot(call1238);
// starting to compile string node (depth = 8)
  if (strlit1240 == NULL) {
    strlit1240 = alloc_String("Then: ");
    gc_root(strlit1240);
  }
// compiled string node returning strlit1240 (depth = 8)
  int op_slot_left_1230 = gc_frame_newslot(strlit1240);
  params[0] = call1238;
  partcv[0] = 1;
  Object opresult1241 = callmethod(strlit1240, "++", 1, partcv, params);
// compiled op node returning opresult1241 (depth = 7)
  int op_slot_left_1227 = gc_frame_newslot(opresult1241);
  params[0] = strlit1228;
  partcv[0] = 1;
  Object opresult1242 = callmethod(opresult1241, "++", 1, partcv, params);
// compiled op node returning opresult1242 (depth = 6)
  int op_slot_right_1226 = gc_frame_newslot(opresult1242);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1244 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1244 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1246 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1246 (depth = 6)
  int op_slot_left_1226 = gc_frame_newslot(opresult1246);
  params[0] = opresult1242;
  partcv[0] = 1;
  Object opresult1247 = callmethod(opresult1246, "++", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 5)
  *var_s = opresult1247;
  if (opresult1247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1251 == NULL) {
    strlit1251 = alloc_String("");
    gc_root(strlit1251);
  }
// compiled string node returning strlit1251 (depth = 7)
  int op_slot_right_1250 = gc_frame_newslot(strlit1251);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1254 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1256 = alloc_Float64(2);
// compiled num node returning num1256 (depth = 10)
  int op_slot_right_1255 = gc_frame_newslot(num1256);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1255 = gc_frame_newslot(*var_depth);
  params[0] = num1256;
  partcv[0] = 1;
  Object sum1258 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1258 (depth = 9)
  gc_frame_newslot(sum1258);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1259 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1260 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1259);
// compiled call node returning call1260 (depth = 10)
// compiled member node returning call1260 (depth = 9)
  params[0] = sum1258;
  partcv[0] = 1;
  Object call1261 = callmethod(call1260, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1254);
// compiled call node returning call1261 (depth = 8)
  int op_slot_right_1253 = gc_frame_newslot(call1261);
// starting to compile string node (depth = 8)
  if (strlit1263 == NULL) {
    strlit1263 = alloc_String("Else: ");
    gc_root(strlit1263);
  }
// compiled string node returning strlit1263 (depth = 8)
  int op_slot_left_1253 = gc_frame_newslot(strlit1263);
  params[0] = call1261;
  partcv[0] = 1;
  Object opresult1264 = callmethod(strlit1263, "++", 1, partcv, params);
// compiled op node returning opresult1264 (depth = 7)
  int op_slot_left_1250 = gc_frame_newslot(opresult1264);
  params[0] = strlit1251;
  partcv[0] = 1;
  Object opresult1265 = callmethod(opresult1264, "++", 1, partcv, params);
// compiled op node returning opresult1265 (depth = 6)
  int op_slot_right_1249 = gc_frame_newslot(opresult1265);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1267 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1267 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1269 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1269 (depth = 6)
  int op_slot_left_1249 = gc_frame_newslot(opresult1269);
  params[0] = opresult1265;
  partcv[0] = 1;
  Object opresult1270 = callmethod(opresult1269, "++", 1, partcv, params);
// compiled op node returning opresult1270 (depth = 5)
  *var_s = opresult1270;
  if (opresult1270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1219 = done;
  } else {
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1273 == NULL) {
    strlit1273 = alloc_String("Then:");
    gc_root(strlit1273);
  }
// compiled string node returning strlit1273 (depth = 6)
  int op_slot_right_1272 = gc_frame_newslot(strlit1273);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1275 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1275 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1277 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1277 (depth = 6)
  int op_slot_left_1272 = gc_frame_newslot(opresult1277);
  params[0] = strlit1273;
  partcv[0] = 1;
  Object opresult1278 = callmethod(opresult1277, "++", 1, partcv, params);
// compiled op node returning opresult1278 (depth = 5)
  *var_s = opresult1278;
  if (opresult1278 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1280 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1281 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1283 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1282);
// compiled call node returning call1283 (depth = 8)
// compiled member node returning call1283 (depth = 7)
  partcv[0] = 0;
  Object call1284 = callmethod(call1283, "body",
    1, partcv, params);
  gc_frame_end(callframe1281);
// compiled call node returning call1284 (depth = 6)
// compiled member node returning call1284 (depth = 5)
  gc_frame_newslot(call1284);
// starting to compile block node (depth = 5)
  Object block1285 = alloc_Block(NULL, NULL, "ast", 247);
  gc_frame_newslot(block1285);
// method "_apply"
  block_savedest(block1285);
  Object closure1286 = createclosure(4, "_apply");
  setclosureframe(closure1286, stackframe);
  addtoclosure(closure1286, var_depth);
  addtoclosure(closure1286, var_spc);
  addtoclosure(closure1286, var_s);
  addtoclosure(closure1286, selfslot);
  struct UserObject *uo1286 = (struct UserObject*)block1285;
  uo1286->data[0] = (Object)closure1286;
  Method *meth_meth_ast__apply1286 = addmethod2pos(block1285, "_apply", &meth_ast__apply1286, 0);
  int argcv_meth_ast__apply1286[] = {1};
  meth_meth_ast__apply1286->type = alloc_MethodType(1, argcv_meth_ast__apply1286);
  meth_meth_ast__apply1286->definitionModule = modulename;
  meth_meth_ast__apply1286->definitionLine = 247;
// compiled block node returning block1285 (depth = 5)
  gc_frame_newslot(block1285);
// call case 5: prelude request
  params[0] = call1284;
  params[1] = block1285;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1305 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1280);
// compiled call node returning call1305 (depth = 4)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1307 == NULL) {
    strlit1307 = alloc_String("""\x0a""");
    gc_root(strlit1307);
  }
// compiled string node returning strlit1307 (depth = 6)
  int op_slot_right_1306 = gc_frame_newslot(strlit1307);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1306 = gc_frame_newslot(*var_s);
  params[0] = strlit1307;
  partcv[0] = 1;
  Object opresult1309 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1309 (depth = 5)
  *var_s = opresult1309;
  if (opresult1309 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1312 == NULL) {
    strlit1312 = alloc_String("Else:");
    gc_root(strlit1312);
  }
// compiled string node returning strlit1312 (depth = 6)
  int op_slot_right_1311 = gc_frame_newslot(strlit1312);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1314 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1314 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1316 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1316 (depth = 6)
  int op_slot_left_1311 = gc_frame_newslot(opresult1316);
  params[0] = strlit1312;
  partcv[0] = 1;
  Object opresult1317 = callmethod(opresult1316, "++", 1, partcv, params);
// compiled op node returning opresult1317 (depth = 5)
  *var_s = opresult1317;
  if (opresult1317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1319 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1320 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1322 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 8)
// compiled member node returning call1322 (depth = 7)
  partcv[0] = 0;
  Object call1323 = callmethod(call1322, "body",
    1, partcv, params);
  gc_frame_end(callframe1320);
// compiled call node returning call1323 (depth = 6)
// compiled member node returning call1323 (depth = 5)
  gc_frame_newslot(call1323);
// starting to compile block node (depth = 5)
  Object block1324 = alloc_Block(NULL, NULL, "ast", 252);
  gc_frame_newslot(block1324);
// method "_apply"
  block_savedest(block1324);
  Object closure1325 = createclosure(4, "_apply");
  setclosureframe(closure1325, stackframe);
  addtoclosure(closure1325, var_depth);
  addtoclosure(closure1325, var_spc);
  addtoclosure(closure1325, var_s);
  addtoclosure(closure1325, selfslot);
  struct UserObject *uo1325 = (struct UserObject*)block1324;
  uo1325->data[0] = (Object)closure1325;
  Method *meth_meth_ast__apply1325 = addmethod2pos(block1324, "_apply", &meth_ast__apply1325, 0);
  int argcv_meth_ast__apply1325[] = {1};
  meth_meth_ast__apply1325->type = alloc_MethodType(1, argcv_meth_ast__apply1325);
  meth_meth_ast__apply1325->definitionModule = modulename;
  meth_meth_ast__apply1325->definitionLine = 252;
// compiled block node returning block1324 (depth = 5)
  gc_frame_newslot(block1324);
// call case 5: prelude request
  params[0] = call1323;
  params[1] = block1324;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1344 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1319);
// compiled call node returning call1344 (depth = 4)
    gc_frame_newslot(call1344);
    if1219 = call1344;
  }
// compiled if node returning if1219 (depth = 3)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1351 == NULL) {
    strlit1351 = alloc_String("    ");
    gc_root(strlit1351);
  }
// compiled string node returning strlit1351 (depth = 7)
  int op_slot_right_1350 = gc_frame_newslot(strlit1351);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1350 = gc_frame_newslot(*var_spc);
  params[0] = strlit1351;
  partcv[0] = 1;
  Object opresult1353 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1353 (depth = 6)
  *var_spc = opresult1353;
  if (opresult1353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1376(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1378 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1380 = alloc_Float64(1);
// compiled num node returning num1380 (depth = 9)
  int op_slot_right_1379 = gc_frame_newslot(num1380);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1379 = gc_frame_newslot(*var_depth);
  params[0] = num1380;
  partcv[0] = 1;
  Object sum1382 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1382 (depth = 8)
  gc_frame_newslot(sum1382);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  params[0] = sum1382;
  partcv[0] = 1;
  Object call1383 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1378);
// compiled call node returning call1383 (depth = 7)
  int op_slot_right_1377 = gc_frame_newslot(call1383);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1386 == NULL) {
    strlit1386 = alloc_String("    ");
    gc_root(strlit1386);
  }
// compiled string node returning strlit1386 (depth = 8)
  int op_slot_right_1385 = gc_frame_newslot(strlit1386);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1388 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1391 == NULL) {
    strlit1391 = alloc_String("""\x0a""");
    gc_root(strlit1391);
  }
// compiled string node returning strlit1391 (depth = 10)
  int op_slot_right_1390 = gc_frame_newslot(strlit1391);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1390 = gc_frame_newslot(*var_s);
  params[0] = strlit1391;
  partcv[0] = 1;
  Object opresult1393 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1393 (depth = 9)
  int op_slot_left_1388 = gc_frame_newslot(opresult1393);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1394 = callmethod(opresult1393, "++", 1, partcv, params);
// compiled op node returning opresult1394 (depth = 8)
  int op_slot_left_1385 = gc_frame_newslot(opresult1394);
  params[0] = strlit1386;
  partcv[0] = 1;
  Object opresult1395 = callmethod(opresult1394, "++", 1, partcv, params);
// compiled op node returning opresult1395 (depth = 7)
  int op_slot_left_1377 = gc_frame_newslot(opresult1395);
  params[0] = call1383;
  partcv[0] = 1;
  Object opresult1396 = callmethod(opresult1395, "++", 1, partcv, params);
// compiled op node returning opresult1396 (depth = 6)
  *var_s = opresult1396;
  if (opresult1396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1423(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1425 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1427 = alloc_Float64(1);
// compiled num node returning num1427 (depth = 10)
  int op_slot_right_1426 = gc_frame_newslot(num1427);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1426 = gc_frame_newslot(*var_depth);
  params[0] = num1427;
  partcv[0] = 1;
  Object sum1429 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1429 (depth = 9)
  gc_frame_newslot(sum1429);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1429;
  partcv[0] = 1;
  Object call1430 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1425);
// compiled call node returning call1430 (depth = 8)
  int op_slot_right_1424 = gc_frame_newslot(call1430);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1433 == NULL) {
    strlit1433 = alloc_String("    ");
    gc_root(strlit1433);
  }
// compiled string node returning strlit1433 (depth = 9)
  int op_slot_right_1432 = gc_frame_newslot(strlit1433);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1435 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1438 == NULL) {
    strlit1438 = alloc_String("""\x0a""");
    gc_root(strlit1438);
  }
// compiled string node returning strlit1438 (depth = 11)
  int op_slot_right_1437 = gc_frame_newslot(strlit1438);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1437 = gc_frame_newslot(*var_s);
  params[0] = strlit1438;
  partcv[0] = 1;
  Object opresult1440 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1440 (depth = 10)
  int op_slot_left_1435 = gc_frame_newslot(opresult1440);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1441 = callmethod(opresult1440, "++", 1, partcv, params);
// compiled op node returning opresult1441 (depth = 9)
  int op_slot_left_1432 = gc_frame_newslot(opresult1441);
  params[0] = strlit1433;
  partcv[0] = 1;
  Object opresult1442 = callmethod(opresult1441, "++", 1, partcv, params);
// compiled op node returning opresult1442 (depth = 8)
  int op_slot_left_1424 = gc_frame_newslot(opresult1442);
  params[0] = call1430;
  partcv[0] = 1;
  Object opresult1443 = callmethod(opresult1442, "++", 1, partcv, params);
// compiled op node returning opresult1443 (depth = 7)
  *var_s = opresult1443;
  if (opresult1443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1345(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1346 == NULL) {
    strlit1346 = alloc_String("");
    gc_root(strlit1346);
  }
// compiled string node returning strlit1346 (depth = 4)
  *var_spc = strlit1346;
  if (strlit1346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1347 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block1348 = alloc_Block(NULL, NULL, "ast", 260);
  gc_frame_newslot(block1348);
// method "_apply"
  block_savedest(block1348);
  Object closure1349 = createclosure(2, "_apply");
  setclosureframe(closure1349, stackframe);
  addtoclosure(closure1349, var_spc);
  addtoclosure(closure1349, selfslot);
  struct UserObject *uo1349 = (struct UserObject*)block1348;
  uo1349->data[0] = (Object)closure1349;
  Method *meth_meth_ast__apply1349 = addmethod2pos(block1348, "_apply", &meth_ast__apply1349, 0);
  int argcv_meth_ast__apply1349[] = {0};
  meth_meth_ast__apply1349->type = alloc_MethodType(1, argcv_meth_ast__apply1349);
  meth_meth_ast__apply1349->definitionModule = modulename;
  meth_meth_ast__apply1349->definitionLine = 252;
// compiled block node returning block1348 (depth = 4)
  gc_frame_newslot(block1348);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1348;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1356 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1347);
// compiled call node returning call1356 (depth = 3)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1358 == NULL) {
    strlit1358 = alloc_String(") then {");
    gc_root(strlit1358);
  }
// compiled string node returning strlit1358 (depth = 5)
  int op_slot_right_1357 = gc_frame_newslot(strlit1358);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1361 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num1362 = alloc_Float64(0);
// compiled num node returning num1362 (depth = 7)
  gc_frame_newslot(num1362);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1363 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1364 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1363);
// compiled call node returning call1364 (depth = 8)
// compiled member node returning call1364 (depth = 7)
  params[0] = num1362;
  partcv[0] = 1;
  Object call1365 = callmethod(call1364, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1361);
// compiled call node returning call1365 (depth = 6)
  int op_slot_right_1360 = gc_frame_newslot(call1365);
// starting to compile string node (depth = 6)
  if (strlit1367 == NULL) {
    strlit1367 = alloc_String("if (");
    gc_root(strlit1367);
  }
// compiled string node returning strlit1367 (depth = 6)
  int op_slot_left_1360 = gc_frame_newslot(strlit1367);
  params[0] = call1365;
  partcv[0] = 1;
  Object opresult1368 = callmethod(strlit1367, "++", 1, partcv, params);
// compiled op node returning opresult1368 (depth = 5)
  int op_slot_left_1357 = gc_frame_newslot(opresult1368);
  params[0] = strlit1358;
  partcv[0] = 1;
  Object opresult1369 = callmethod(opresult1368, "++", 1, partcv, params);
// compiled op node returning opresult1369 (depth = 4)
  *var_s = opresult1369;
  if (opresult1369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1370 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1371 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1372 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1373 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1372);
// compiled call node returning call1373 (depth = 7)
// compiled member node returning call1373 (depth = 6)
  partcv[0] = 0;
  Object call1374 = callmethod(call1373, "body",
    1, partcv, params);
  gc_frame_end(callframe1371);
// compiled call node returning call1374 (depth = 5)
// compiled member node returning call1374 (depth = 4)
  gc_frame_newslot(call1374);
// starting to compile block node (depth = 4)
  Object block1375 = alloc_Block(NULL, NULL, "ast", 264);
  gc_frame_newslot(block1375);
// method "_apply"
  block_savedest(block1375);
  Object closure1376 = createclosure(4, "_apply");
  setclosureframe(closure1376, stackframe);
  addtoclosure(closure1376, var_depth);
  addtoclosure(closure1376, var_spc);
  addtoclosure(closure1376, var_s);
  addtoclosure(closure1376, selfslot);
  struct UserObject *uo1376 = (struct UserObject*)block1375;
  uo1376->data[0] = (Object)closure1376;
  Method *meth_meth_ast__apply1376 = addmethod2pos(block1375, "_apply", &meth_ast__apply1376, 0);
  int argcv_meth_ast__apply1376[] = {1};
  meth_meth_ast__apply1376->type = alloc_MethodType(1, argcv_meth_ast__apply1376);
  meth_meth_ast__apply1376->definitionModule = modulename;
  meth_meth_ast__apply1376->definitionLine = 264;
// compiled block node returning block1375 (depth = 4)
  gc_frame_newslot(block1375);
// call case 5: prelude request
  params[0] = call1374;
  params[1] = block1375;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1399 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1370);
// compiled call node returning call1399 (depth = 3)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1401 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1403 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1402);
// compiled call node returning call1403 (depth = 7)
// compiled member node returning call1403 (depth = 6)
  partcv[0] = 0;
  Object call1404 = callmethod(call1403, "isntEmpty",
    1, partcv, params);
  gc_frame_end(callframe1401);
// compiled call node returning call1404 (depth = 5)
// compiled member node returning call1404 (depth = 4)
  Object if1400 = done;
  if (istrue(call1404)) {
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1406 == NULL) {
    strlit1406 = alloc_String("} else {");
    gc_root(strlit1406);
  }
// compiled string node returning strlit1406 (depth = 6)
  int op_slot_right_1405 = gc_frame_newslot(strlit1406);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1408 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1411 == NULL) {
    strlit1411 = alloc_String("""\x0a""");
    gc_root(strlit1411);
  }
// compiled string node returning strlit1411 (depth = 8)
  int op_slot_right_1410 = gc_frame_newslot(strlit1411);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1410 = gc_frame_newslot(*var_s);
  params[0] = strlit1411;
  partcv[0] = 1;
  Object opresult1413 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1413 (depth = 7)
  int op_slot_left_1408 = gc_frame_newslot(opresult1413);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1414 = callmethod(opresult1413, "++", 1, partcv, params);
// compiled op node returning opresult1414 (depth = 6)
  int op_slot_left_1405 = gc_frame_newslot(opresult1414);
  params[0] = strlit1406;
  partcv[0] = 1;
  Object opresult1415 = callmethod(opresult1414, "++", 1, partcv, params);
// compiled op node returning opresult1415 (depth = 5)
  *var_s = opresult1415;
  if (opresult1415 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1417 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1418 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1419 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1420 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1419);
// compiled call node returning call1420 (depth = 8)
// compiled member node returning call1420 (depth = 7)
  partcv[0] = 0;
  Object call1421 = callmethod(call1420, "body",
    1, partcv, params);
  gc_frame_end(callframe1418);
// compiled call node returning call1421 (depth = 6)
// compiled member node returning call1421 (depth = 5)
  gc_frame_newslot(call1421);
// starting to compile block node (depth = 5)
  Object block1422 = alloc_Block(NULL, NULL, "ast", 269);
  gc_frame_newslot(block1422);
// method "_apply"
  block_savedest(block1422);
  Object closure1423 = createclosure(4, "_apply");
  setclosureframe(closure1423, stackframe);
  addtoclosure(closure1423, var_depth);
  addtoclosure(closure1423, var_spc);
  addtoclosure(closure1423, var_s);
  addtoclosure(closure1423, selfslot);
  struct UserObject *uo1423 = (struct UserObject*)block1422;
  uo1423->data[0] = (Object)closure1423;
  Method *meth_meth_ast__apply1423 = addmethod2pos(block1422, "_apply", &meth_ast__apply1423, 0);
  int argcv_meth_ast__apply1423[] = {1};
  meth_meth_ast__apply1423->type = alloc_MethodType(1, argcv_meth_ast__apply1423);
  meth_meth_ast__apply1423->definitionModule = modulename;
  meth_meth_ast__apply1423->definitionLine = 269;
// compiled block node returning block1422 (depth = 5)
  gc_frame_newslot(block1422);
// call case 5: prelude request
  params[0] = call1421;
  params[1] = block1422;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1446 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1417);
// compiled call node returning call1446 (depth = 4)
    gc_frame_newslot(call1446);
    if1400 = call1446;
  } else {
  }
// compiled if node returning if1400 (depth = 3)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1448 == NULL) {
    strlit1448 = alloc_String("}");
    gc_root(strlit1448);
  }
// compiled string node returning strlit1448 (depth = 5)
  int op_slot_right_1447 = gc_frame_newslot(strlit1448);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1450 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1453 == NULL) {
    strlit1453 = alloc_String("""\x0a""");
    gc_root(strlit1453);
  }
// compiled string node returning strlit1453 (depth = 7)
  int op_slot_right_1452 = gc_frame_newslot(strlit1453);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1452 = gc_frame_newslot(*var_s);
  params[0] = strlit1453;
  partcv[0] = 1;
  Object opresult1455 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1455 (depth = 6)
  int op_slot_left_1450 = gc_frame_newslot(opresult1455);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1456 = callmethod(opresult1455, "++", 1, partcv, params);
// compiled op node returning opresult1456 (depth = 5)
  int op_slot_left_1447 = gc_frame_newslot(opresult1456);
  params[0] = strlit1448;
  partcv[0] = 1;
  Object opresult1457 = callmethod(opresult1456, "++", 1, partcv, params);
// compiled op node returning opresult1457 (depth = 4)
  *var_s = opresult1457;
  if (opresult1457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1460 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe1461 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ifNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call1462 = callmethod(*var_ifNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1461);
// compiled call node returning call1462 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1463 = callmethod(call1462, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe1460);
// compiled call node returning call1463 (depth = 3)
  gc_frame_end(frame);
  return call1463;
}
Object meth_ast_shallowCopyFieldsFrom1464(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1465 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1466 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1465);
// compiled call node returning call1466 (depth = 3)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1467 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call1469 = callmethod(*var_other, "handledIdentifiers",
    1, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1469 (depth = 5)
// compiled member node returning call1469 (depth = 4)
  gc_frame_newslot(call1469);
// call case 4: self request
  params[0] = call1469;
  partcv[0] = 1;
  Object call1470 = callmethodflags(self, "handledIdentifiers:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1467);
// compiled call node returning call1470 (depth = 3)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new1124(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1125 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1125 = alloc_userobj2(16,13, objclass1125);
  gc_frame_newslot(obj1125);
if (objclass1125 == NULL) {
  glfree(obj1125->class->name);
  obj1125->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1125, self, 0);
  addmethodreal(obj1125,"outer", &reader_ast_outer_1126);
  Object oldself1125 = self;
  struct StackFrameObject *oldstackframe1125 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1125);
  gc_frame_newslot((Object)stackframe);
  self = obj1125;
  Object *oldselfslot1125 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1125 = (*(struct UserObject *)self).data[0], lowerouter1125 = thisouter1125;
  if (inheritingObject1125) {
    struct UserObject *inho1125 = (struct UserObject *)inheritingObject1125;
    while (inho1125->super != GraceDefaultObject) inho1125 = (struct UserObject *)inho1125->super;
    inho1125->super = obj1125;
    self = inheritingObject1125;
    *selfslot = self;
    lowerouter1125 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1125;
  }
if (objclass1125 == NULL) {
  Method *reader1127 = addmethodrealflags(obj1125, "kind",&reader_ast_kind_1127, MFLAG_DEF);
  reader1127->definitionModule = modulename;
  reader1127->definitionLine = 212;
}
adddatum2(obj1125, alloc_Undefined(), 1);
if (objclass1125 == NULL) {
  Method *reader1128 = addmethodrealflags(obj1125, "value",&reader_ast_value_1128, 0);
  Method *writer1128 = addmethodrealflags(obj1125, "value:=",&writer_ast_value_1128, 0);
  reader1128->definitionModule = modulename;
  writer1128->definitionModule = modulename;
  reader1128->definitionLine = 213;
  writer1128->definitionLine = 213;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 2);
if (objclass1125 == NULL) {
  Method *reader1129 = addmethodrealflags(obj1125, "thenblock",&reader_ast_thenblock_1129, 0);
  Method *writer1129 = addmethodrealflags(obj1125, "thenblock:=",&writer_ast_thenblock_1129, 0);
  reader1129->definitionModule = modulename;
  writer1129->definitionModule = modulename;
  reader1129->definitionLine = 214;
  writer1129->definitionLine = 214;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 3);
if (objclass1125 == NULL) {
  Method *reader1130 = addmethodrealflags(obj1125, "elseblock",&reader_ast_elseblock_1130, 0);
  Method *writer1130 = addmethodrealflags(obj1125, "elseblock:=",&writer_ast_elseblock_1130, 0);
  reader1130->definitionModule = modulename;
  writer1130->definitionModule = modulename;
  reader1130->definitionLine = 215;
  writer1130->definitionLine = 215;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 4);
if (objclass1125 == NULL) {
  Method *reader1131 = addmethodrealflags(obj1125, "handledIdentifiers",&reader_ast_handledIdentifiers_1131, 0);
  Method *writer1131 = addmethodrealflags(obj1125, "handledIdentifiers:=",&writer_ast_handledIdentifiers_1131, 0);
  reader1131->definitionModule = modulename;
  writer1131->definitionModule = modulename;
  reader1131->definitionLine = 216;
  writer1131->definitionLine = 216;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1132 = (struct UserObject*)obj1125;
  uo1132->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1132 = addmethod2pos(obj1125, "isSimple", &meth_ast_isSimple1132, 6);
  int argcv_meth_ast_isSimple1132[] = {0};
  meth_meth_ast_isSimple1132->type = alloc_MethodType(1, argcv_meth_ast_isSimple1132);
  meth_meth_ast_isSimple1132->definitionModule = modulename;
  meth_meth_ast_isSimple1132->definitionLine = 217;
// method "accept()from"
  struct UserObject *uo1134 = (struct UserObject*)obj1125;
  uo1134->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1134 = addmethod2pos(obj1125, "accept()from", &meth_ast_accept_40__41_from1134, 7);
  int argcv_meth_ast_accept_40__41_from1134[] = {1, 1};
  meth_meth_ast_accept_40__41_from1134->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1134);
  meth_meth_ast_accept_40__41_from1134->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1134->definitionLine = 218;
// method "map()ancestors"
  struct UserObject *uo1152 = (struct UserObject*)obj1125;
  uo1152->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1152 = addmethod2pos(obj1125, "map()ancestors", &meth_ast_map_40__41_ancestors1152, 8);
  int argcv_meth_ast_map_40__41_ancestors1152[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1152->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1152);
  meth_meth_ast_map_40__41_ancestors1152->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1152->definitionLine = 226;
// method "pretty"
  block_savedest(obj1125);
  Object closure1177 = createclosure(1, "pretty");
  setclosureframe(closure1177, stackframe);
  addtoclosure(closure1177, var_util);
  struct UserObject *uo1177 = (struct UserObject*)obj1125;
  uo1177->data[9] = (Object)closure1177;
  Method *meth_meth_ast_pretty1177 = addmethod2pos(obj1125, "pretty", &meth_ast_pretty1177, 9);
  int argcv_meth_ast_pretty1177[] = {1};
  meth_meth_ast_pretty1177->type = alloc_MethodType(1, argcv_meth_ast_pretty1177);
  meth_meth_ast_pretty1177->definitionModule = modulename;
  meth_meth_ast_pretty1177->definitionLine = 234;
// method "toGrace"
  struct UserObject *uo1345 = (struct UserObject*)obj1125;
  uo1345->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace1345 = addmethod2pos(obj1125, "toGrace", &meth_ast_toGrace1345, 10);
  int argcv_meth_ast_toGrace1345[] = {1};
  meth_meth_ast_toGrace1345->type = alloc_MethodType(1, argcv_meth_ast_toGrace1345);
meth_meth_ast_toGrace1345->type->types[0] = type_Number;
meth_meth_ast_toGrace1345->type->names[0] = "depth";
  meth_meth_ast_toGrace1345->definitionModule = modulename;
  meth_meth_ast_toGrace1345->definitionLine = 258;
// method "shallowCopy"
  block_savedest(obj1125);
  Object closure1459 = createclosure(2, "shallowCopy");
  setclosureframe(closure1459, stackframe);
  addtoclosure(closure1459, var_nullNode);
  addtoclosure(closure1459, var_ifNode);
  struct UserObject *uo1459 = (struct UserObject*)obj1125;
  uo1459->data[11] = (Object)closure1459;
  Method *meth_meth_ast_shallowCopy1459 = addmethod2pos(obj1125, "shallowCopy", &meth_ast_shallowCopy1459, 11);
  int argcv_meth_ast_shallowCopy1459[] = {0};
  meth_meth_ast_shallowCopy1459->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1459);
  meth_meth_ast_shallowCopy1459->definitionModule = modulename;
  meth_meth_ast_shallowCopy1459->definitionLine = 276;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1464 = (struct UserObject*)obj1125;
  uo1464->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1464 = addmethod2pos(obj1125, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1464, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom1464[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1464->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1464);
  meth_meth_ast_shallowCopyFieldsFrom1464->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1464->definitionLine = 279;
  sourceObject = obj1125;
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1471 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1472 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1473 = gc_frame_new();
// call case 3: self.outer request
  Object call1474 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1473);
// compiled call node returning call1474 (depth = 7)
// compiled member node returning call1474 (depth = 6)
  partcv[0] = 0;
  Object call1475 = callmethodflags(call1474, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1472);
// compiled call node returning call1475 (depth = 5)
// compiled member node returning call1475 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1476 = callmethodflags(call1475, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled call node returning call1476 (depth = 3)
  struct UserObject *obj1125_uo = (struct UserObject *)obj1125;
  obj1125_uo->super = call1476;
  sourceObject = obj1125;
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1477 == NULL) {
    strlit1477 = alloc_String("if");
    gc_root(strlit1477);
  }
// compiled string node returning strlit1477 (depth = 3)
  adddatum2(obj1125, strlit1477, 1);
  sourceObject = obj1125;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1125, *var_cond, 2);
  sourceObject = obj1125;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1125, *var_thenblock_39_, 3);
  sourceObject = obj1125;
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1125, *var_elseblock_39_, 4);
  sourceObject = obj1125;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1478 = alloc_Boolean(0);
// compiled identifier node returning bool1478 (depth = 3)
  adddatum2(obj1125, bool1478, 5);
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  objclass1125 = obj1125->class;
  objclass1125->definitionModule = modulename;
  objclass1125->definitionLine = 210;
  (*(struct UserObject *)self).data[0] = lowerouter1125;
  self = oldself1125;
  selfslot = oldselfslot1125;
  stackframe = oldstackframe1125;
  gc_frame_end(frame);
  return obj1125;
}
Object meth_ast_new1124_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1125 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1125 = alloc_userobj2(16,13, objclass1125);
  gc_frame_newslot(obj1125);
if (objclass1125 == NULL) {
  glfree(obj1125->class->name);
  obj1125->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1125, self, 0);
  addmethodreal(obj1125,"outer", &reader_ast_outer_1126);
  Object oldself1125 = self;
  struct StackFrameObject *oldstackframe1125 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1125);
  gc_frame_newslot((Object)stackframe);
  self = obj1125;
  Object *oldselfslot1125 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1125 = (*(struct UserObject *)self).data[0], lowerouter1125 = thisouter1125;
  if (inheritingObject1125) {
    struct UserObject *inho1125 = (struct UserObject *)inheritingObject1125;
    while (inho1125->super != GraceDefaultObject) inho1125 = (struct UserObject *)inho1125->super;
    inho1125->super = obj1125;
    self = inheritingObject1125;
    *selfslot = self;
    lowerouter1125 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1125;
  }
if (objclass1125 == NULL) {
  Method *reader1127 = addmethodrealflags(obj1125, "kind",&reader_ast_kind_1127, MFLAG_DEF);
  reader1127->definitionModule = modulename;
  reader1127->definitionLine = 212;
}
adddatum2(obj1125, alloc_Undefined(), 1);
if (objclass1125 == NULL) {
  Method *reader1128 = addmethodrealflags(obj1125, "value",&reader_ast_value_1128, 0);
  Method *writer1128 = addmethodrealflags(obj1125, "value:=",&writer_ast_value_1128, 0);
  reader1128->definitionModule = modulename;
  writer1128->definitionModule = modulename;
  reader1128->definitionLine = 213;
  writer1128->definitionLine = 213;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 2);
if (objclass1125 == NULL) {
  Method *reader1129 = addmethodrealflags(obj1125, "thenblock",&reader_ast_thenblock_1129, 0);
  Method *writer1129 = addmethodrealflags(obj1125, "thenblock:=",&writer_ast_thenblock_1129, 0);
  reader1129->definitionModule = modulename;
  writer1129->definitionModule = modulename;
  reader1129->definitionLine = 214;
  writer1129->definitionLine = 214;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 3);
if (objclass1125 == NULL) {
  Method *reader1130 = addmethodrealflags(obj1125, "elseblock",&reader_ast_elseblock_1130, 0);
  Method *writer1130 = addmethodrealflags(obj1125, "elseblock:=",&writer_ast_elseblock_1130, 0);
  reader1130->definitionModule = modulename;
  writer1130->definitionModule = modulename;
  reader1130->definitionLine = 215;
  writer1130->definitionLine = 215;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 4);
if (objclass1125 == NULL) {
  Method *reader1131 = addmethodrealflags(obj1125, "handledIdentifiers",&reader_ast_handledIdentifiers_1131, 0);
  Method *writer1131 = addmethodrealflags(obj1125, "handledIdentifiers:=",&writer_ast_handledIdentifiers_1131, 0);
  reader1131->definitionModule = modulename;
  writer1131->definitionModule = modulename;
  reader1131->definitionLine = 216;
  writer1131->definitionLine = 216;
}
obj1125->flags |= OFLAG_MUTABLE;
adddatum2(obj1125, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1132 = (struct UserObject*)obj1125;
  uo1132->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1132 = addmethod2pos(obj1125, "isSimple", &meth_ast_isSimple1132, 6);
  int argcv_meth_ast_isSimple1132[] = {0};
  meth_meth_ast_isSimple1132->type = alloc_MethodType(1, argcv_meth_ast_isSimple1132);
  meth_meth_ast_isSimple1132->definitionModule = modulename;
  meth_meth_ast_isSimple1132->definitionLine = 217;
// method "accept()from"
  struct UserObject *uo1134 = (struct UserObject*)obj1125;
  uo1134->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1134 = addmethod2pos(obj1125, "accept()from", &meth_ast_accept_40__41_from1134, 7);
  int argcv_meth_ast_accept_40__41_from1134[] = {1, 1};
  meth_meth_ast_accept_40__41_from1134->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1134);
  meth_meth_ast_accept_40__41_from1134->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1134->definitionLine = 218;
// method "map()ancestors"
  struct UserObject *uo1152 = (struct UserObject*)obj1125;
  uo1152->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1152 = addmethod2pos(obj1125, "map()ancestors", &meth_ast_map_40__41_ancestors1152, 8);
  int argcv_meth_ast_map_40__41_ancestors1152[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1152->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1152);
  meth_meth_ast_map_40__41_ancestors1152->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1152->definitionLine = 226;
// method "pretty"
  block_savedest(obj1125);
  Object closure1177 = createclosure(1, "pretty");
  setclosureframe(closure1177, stackframe);
  addtoclosure(closure1177, var_util);
  struct UserObject *uo1177 = (struct UserObject*)obj1125;
  uo1177->data[9] = (Object)closure1177;
  Method *meth_meth_ast_pretty1177 = addmethod2pos(obj1125, "pretty", &meth_ast_pretty1177, 9);
  int argcv_meth_ast_pretty1177[] = {1};
  meth_meth_ast_pretty1177->type = alloc_MethodType(1, argcv_meth_ast_pretty1177);
  meth_meth_ast_pretty1177->definitionModule = modulename;
  meth_meth_ast_pretty1177->definitionLine = 234;
// method "toGrace"
  struct UserObject *uo1345 = (struct UserObject*)obj1125;
  uo1345->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace1345 = addmethod2pos(obj1125, "toGrace", &meth_ast_toGrace1345, 10);
  int argcv_meth_ast_toGrace1345[] = {1};
  meth_meth_ast_toGrace1345->type = alloc_MethodType(1, argcv_meth_ast_toGrace1345);
meth_meth_ast_toGrace1345->type->types[0] = type_Number;
meth_meth_ast_toGrace1345->type->names[0] = "depth";
  meth_meth_ast_toGrace1345->definitionModule = modulename;
  meth_meth_ast_toGrace1345->definitionLine = 258;
// method "shallowCopy"
  block_savedest(obj1125);
  Object closure1459 = createclosure(2, "shallowCopy");
  setclosureframe(closure1459, stackframe);
  addtoclosure(closure1459, var_nullNode);
  addtoclosure(closure1459, var_ifNode);
  struct UserObject *uo1459 = (struct UserObject*)obj1125;
  uo1459->data[11] = (Object)closure1459;
  Method *meth_meth_ast_shallowCopy1459 = addmethod2pos(obj1125, "shallowCopy", &meth_ast_shallowCopy1459, 11);
  int argcv_meth_ast_shallowCopy1459[] = {0};
  meth_meth_ast_shallowCopy1459->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1459);
  meth_meth_ast_shallowCopy1459->definitionModule = modulename;
  meth_meth_ast_shallowCopy1459->definitionLine = 276;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1464 = (struct UserObject*)obj1125;
  uo1464->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1464 = addmethod2pos(obj1125, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1464, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom1464[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1464->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1464);
  meth_meth_ast_shallowCopyFieldsFrom1464->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1464->definitionLine = 279;
  sourceObject = obj1125;
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1471 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1472 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1473 = gc_frame_new();
// call case 3: self.outer request
  Object call1474 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1473);
// compiled call node returning call1474 (depth = 7)
// compiled member node returning call1474 (depth = 6)
  partcv[0] = 0;
  Object call1475 = callmethodflags(call1474, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1472);
// compiled call node returning call1475 (depth = 5)
// compiled member node returning call1475 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1476 = callmethodflags(call1475, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled call node returning call1476 (depth = 3)
  struct UserObject *obj1125_uo = (struct UserObject *)obj1125;
  obj1125_uo->super = call1476;
  sourceObject = obj1125;
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1477 == NULL) {
    strlit1477 = alloc_String("if");
    gc_root(strlit1477);
  }
// compiled string node returning strlit1477 (depth = 3)
  adddatum2(obj1125, strlit1477, 1);
  sourceObject = obj1125;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1125, *var_cond, 2);
  sourceObject = obj1125;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1125, *var_thenblock_39_, 3);
  sourceObject = obj1125;
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1125, *var_elseblock_39_, 4);
  sourceObject = obj1125;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1478 = alloc_Boolean(0);
// compiled identifier node returning bool1478 (depth = 3)
  adddatum2(obj1125, bool1478, 5);
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  sourceObject = obj1125;
  objclass1125 = obj1125->class;
  objclass1125->definitionModule = modulename;
  objclass1125->definitionLine = 210;
  (*(struct UserObject *)self).data[0] = lowerouter1125;
  self = oldself1125;
  selfslot = oldselfslot1125;
  stackframe = oldstackframe1125;
  gc_frame_end(frame);
  return obj1125;
}
Object meth_ast_ifNode1480(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ifNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ifNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_isBlock1493(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1494 = alloc_Boolean(1);
// compiled identifier node returning bool1494 (depth = 3)
  gc_frame_end(frame);
  return bool1494;
}
Object meth_ast_isEmpty1495(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1497 = alloc_Float64(0);
// compiled num node returning num1497 (depth = 4)
  int op_slot_right_1496 = gc_frame_newslot(num1497);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1499 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1501 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1500);
// compiled call node returning call1501 (depth = 7)
// compiled member node returning call1501 (depth = 6)
  partcv[0] = 0;
  Object call1502 = callmethod(call1501, "size",
    1, partcv, params);
  gc_frame_end(callframe1499);
// compiled call node returning call1502 (depth = 5)
// compiled member node returning call1502 (depth = 4)
  int op_slot_left_1496 = gc_frame_newslot(call1502);
  params[0] = num1497;
  partcv[0] = 1;
  Object opresult1503 = callmethod(call1502, "==", 1, partcv, params);
// compiled op node returning opresult1503 (depth = 3)
  gc_frame_end(frame);
  return opresult1503;
}
Object meth_ast_isntEmpty1504(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isntEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isntEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isntEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1506 = alloc_Float64(0);
// compiled num node returning num1506 (depth = 4)
  int op_slot_right_1505 = gc_frame_newslot(num1506);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1508 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1510 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1509);
// compiled call node returning call1510 (depth = 7)
// compiled member node returning call1510 (depth = 6)
  partcv[0] = 0;
  Object call1511 = callmethod(call1510, "size",
    1, partcv, params);
  gc_frame_end(callframe1508);
// compiled call node returning call1511 (depth = 5)
// compiled member node returning call1511 (depth = 4)
  int op_slot_left_1505 = gc_frame_newslot(call1511);
  params[0] = num1506;
  partcv[0] = 1;
  Object opresult1512 = callmethod(call1511, ">", 1, partcv, params);
// compiled op node returning opresult1512 (depth = 3)
  gc_frame_end(frame);
  return opresult1512;
}
Object meth_ast_scope_58__61_1513(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1514 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call1515 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1514);
// compiled call node returning call1515 (depth = 3)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1516 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1517 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe1516);
// compiled call node returning call1517 (depth = 3)
  gc_frame_end(frame);
  return call1517;
}
Object meth_ast_declarationKindWithAncestors1518(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call1520 = callmethod(*var_k, "parameter",
    1, partcv, params);
  gc_frame_end(callframe1519);
// compiled call node returning call1520 (depth = 4)
// compiled member node returning call1520 (depth = 3)
  gc_frame_end(frame);
  return call1520;
}
Object meth_ast_isMatchingBlock1521(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1523 = alloc_Float64(1);
// compiled num node returning num1523 (depth = 4)
  int op_slot_right_1522 = gc_frame_newslot(num1523);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1525 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1527 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1526);
// compiled call node returning call1527 (depth = 7)
// compiled member node returning call1527 (depth = 6)
  partcv[0] = 0;
  Object call1528 = callmethod(call1527, "size",
    1, partcv, params);
  gc_frame_end(callframe1525);
// compiled call node returning call1528 (depth = 5)
// compiled member node returning call1528 (depth = 4)
  int op_slot_left_1522 = gc_frame_newslot(call1528);
  params[0] = num1523;
  partcv[0] = 1;
  Object opresult1529 = callmethod(call1528, "==", 1, partcv, params);
// compiled op node returning opresult1529 (depth = 3)
  gc_frame_end(frame);
  return opresult1529;
}
Object meth_ast__apply1533(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1534 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1535 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1536 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1537 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1536);
// compiled call node returning call1537 (depth = 10)
// compiled member node returning call1537 (depth = 9)
  partcv[0] = 0;
  Object call1538 = callmethod(call1537, "last",
    1, partcv, params);
  gc_frame_end(callframe1535);
// compiled call node returning call1538 (depth = 8)
// compiled member node returning call1538 (depth = 7)
  partcv[0] = 0;
  Object call1539 = callmethod(call1538, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe1534);
// compiled call node returning call1539 (depth = 6)
// compiled member node returning call1539 (depth = 5)
  gc_frame_end(frame);
  return call1539;
}
Object meth_ast_returnsObject1530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1531 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1532 = alloc_Block(NULL, NULL, "ast", 311);
  gc_frame_newslot(block1532);
// method "_apply"
  block_savedest(block1532);
  Object closure1533 = createclosure(1, "_apply");
  setclosureframe(closure1533, stackframe);
  addtoclosure(closure1533, selfslot);
  struct UserObject *uo1533 = (struct UserObject*)block1532;
  uo1533->data[0] = (Object)closure1533;
  Method *meth_meth_ast__apply1533 = addmethod2pos(block1532, "_apply", &meth_ast__apply1533, 0);
  int argcv_meth_ast__apply1533[] = {0};
  meth_meth_ast__apply1533->type = alloc_MethodType(1, argcv_meth_ast__apply1533);
  meth_meth_ast__apply1533->definitionModule = modulename;
  meth_meth_ast__apply1533->definitionLine = 309;
// compiled block node returning block1532 (depth = 4)
  gc_frame_newslot(block1532);
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1542 = alloc_Float64(0);
// compiled num node returning num1542 (depth = 5)
  int op_slot_right_1541 = gc_frame_newslot(num1542);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1544 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1545 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1546 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1545);
// compiled call node returning call1546 (depth = 8)
// compiled member node returning call1546 (depth = 7)
  partcv[0] = 0;
  Object call1547 = callmethod(call1546, "size",
    1, partcv, params);
  gc_frame_end(callframe1544);
// compiled call node returning call1547 (depth = 6)
// compiled member node returning call1547 (depth = 5)
  int op_slot_left_1541 = gc_frame_newslot(call1547);
  params[0] = num1542;
  partcv[0] = 1;
  Object opresult1548 = callmethod(call1547, ">", 1, partcv, params);
// compiled op node returning opresult1548 (depth = 4)
  params[0] = block1532;
  partcv[0] = 1;
  Object call1549 = callmethod(opresult1548, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1531);
// compiled call node returning call1549 (depth = 3)
  gc_frame_end(frame);
  return call1549;
}
Object meth_ast_returnedObjectScope1550(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1551 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1552 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1553 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1554 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1553);
// compiled call node returning call1554 (depth = 8)
// compiled member node returning call1554 (depth = 7)
  partcv[0] = 0;
  Object call1555 = callmethod(call1554, "last",
    1, partcv, params);
  gc_frame_end(callframe1552);
// compiled call node returning call1555 (depth = 6)
// compiled member node returning call1555 (depth = 5)
  partcv[0] = 0;
  Object call1556 = callmethod(call1555, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe1551);
// compiled call node returning call1556 (depth = 4)
// compiled member node returning call1556 (depth = 3)
  gc_frame_end(frame);
  return call1556;
}
Object meth_ast_parametersDo1557(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1558 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1560 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1559);
// compiled call node returning call1560 (depth = 5)
// compiled member node returning call1560 (depth = 4)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call1561 = callmethod(call1560, "do",
    1, partcv, params);
  gc_frame_end(callframe1558);
// compiled call node returning call1561 (depth = 3)
  gc_frame_end(frame);
  return call1561;
}
Object meth_ast__apply1572(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1573 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1574 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1573);
// compiled call node returning call1574 (depth = 6)
  gc_frame_end(frame);
  return call1574;
}
Object meth_ast__apply1581(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1582 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1583 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1582);
// compiled call node returning call1583 (depth = 6)
  gc_frame_end(frame);
  return call1583;
}
Object meth_ast_accept_40__41_from1562(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1564 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1565 = callmethod(*var_visitor, "visitBlock()up",
    2, partcv, params);
  gc_frame_end(callframe1564);
// compiled call node returning call1565 (depth = 4)
  Object if1563 = done;
  if (istrue(call1565)) {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1566 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1567 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1566);
// compiled call node returning call1567 (depth = 5)
  *var_newChain = call1567;
  if (call1567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1568 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1569 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1570 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1569);
// compiled call node returning call1570 (depth = 6)
// compiled member node returning call1570 (depth = 5)
  gc_frame_newslot(call1570);
// starting to compile block node (depth = 5)
  Object block1571 = alloc_Block(NULL, NULL, "ast", 323);
  gc_frame_newslot(block1571);
// method "_apply"
  block_savedest(block1571);
  Object closure1572 = createclosure(3, "_apply");
  setclosureframe(closure1572, stackframe);
  addtoclosure(closure1572, var_visitor);
  addtoclosure(closure1572, var_newChain);
  addtoclosure(closure1572, selfslot);
  struct UserObject *uo1572 = (struct UserObject*)block1571;
  uo1572->data[0] = (Object)closure1572;
  Method *meth_meth_ast__apply1572 = addmethod2pos(block1571, "_apply", &meth_ast__apply1572, 0);
  int argcv_meth_ast__apply1572[] = {1};
  meth_meth_ast__apply1572->type = alloc_MethodType(1, argcv_meth_ast__apply1572);
  meth_meth_ast__apply1572->definitionModule = modulename;
  meth_meth_ast__apply1572->definitionLine = 323;
// compiled block node returning block1571 (depth = 5)
  gc_frame_newslot(block1571);
// call case 5: prelude request
  params[0] = call1570;
  params[1] = block1571;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1576 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1568);
// compiled call node returning call1576 (depth = 4)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1577 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1578 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1579 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1578);
// compiled call node returning call1579 (depth = 6)
// compiled member node returning call1579 (depth = 5)
  gc_frame_newslot(call1579);
// starting to compile block node (depth = 5)
  Object block1580 = alloc_Block(NULL, NULL, "ast", 326);
  gc_frame_newslot(block1580);
// method "_apply"
  block_savedest(block1580);
  Object closure1581 = createclosure(3, "_apply");
  setclosureframe(closure1581, stackframe);
  addtoclosure(closure1581, var_visitor);
  addtoclosure(closure1581, var_newChain);
  addtoclosure(closure1581, selfslot);
  struct UserObject *uo1581 = (struct UserObject*)block1580;
  uo1581->data[0] = (Object)closure1581;
  Method *meth_meth_ast__apply1581 = addmethod2pos(block1580, "_apply", &meth_ast__apply1581, 0);
  int argcv_meth_ast__apply1581[] = {1};
  meth_meth_ast__apply1581->type = alloc_MethodType(1, argcv_meth_ast__apply1581);
  meth_meth_ast__apply1581->definitionModule = modulename;
  meth_meth_ast__apply1581->definitionLine = 326;
// compiled block node returning block1580 (depth = 5)
  gc_frame_newslot(block1580);
// call case 5: prelude request
  params[0] = call1579;
  params[1] = block1580;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1585 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1577);
// compiled call node returning call1585 (depth = 4)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1588 = alloc_Boolean(0);
// compiled identifier node returning bool1588 (depth = 6)
  int op_slot_right_1587 = gc_frame_newslot(bool1588);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1590 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1591 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1590);
// compiled call node returning call1591 (depth = 7)
// compiled member node returning call1591 (depth = 6)
  int op_slot_left_1587 = gc_frame_newslot(call1591);
  params[0] = bool1588;
  partcv[0] = 1;
  Object opresult1592 = callmethod(call1591, "!=", 1, partcv, params);
// compiled op node returning opresult1592 (depth = 5)
  Object if1586 = done;
  if (istrue(opresult1592)) {
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1593 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1595 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1594);
// compiled call node returning call1595 (depth = 7)
// compiled member node returning call1595 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1596 = callmethod(call1595, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1593);
// compiled call node returning call1596 (depth = 5)
    gc_frame_newslot(call1596);
    if1586 = call1596;
  } else {
  }
// compiled if node returning if1586 (depth = 4)
    gc_frame_newslot(if1586);
    if1563 = if1586;
  } else {
  }
// compiled if node returning if1563 (depth = 3)
  gc_frame_end(frame);
  return if1563;
}
Object meth_ast_map_40__41_ancestors1597(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1598 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1599 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1598);
// compiled call node returning call1599 (depth = 5)
// compiled member node returning call1599 (depth = 4)
  *var_n = call1599;
  if (call1599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1600 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1601 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1600);
// compiled call node returning call1601 (depth = 4)
  *var_newChain = call1601;
  if (call1601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1602 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1603 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1604 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1605 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1604);
// compiled call node returning call1605 (depth = 6)
// compiled member node returning call1605 (depth = 5)
  gc_frame_newslot(call1605);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1606 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1607 = gc_frame_new();
// call case 3: self.outer request
  Object call1608 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1607);
// compiled call node returning call1608 (depth = 8)
// compiled member node returning call1608 (depth = 7)
  partcv[0] = 0;
  Object call1609 = callmethodflags(call1608, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1606);
// compiled call node returning call1609 (depth = 6)
// compiled member node returning call1609 (depth = 5)
  params[0] = call1605;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1610 = callmethodflags(call1609, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1603);
// compiled call node returning call1610 (depth = 4)
  gc_frame_newslot(call1610);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1610;
  partcv[0] = 1;
  Object call1611 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe1602);
// compiled call node returning call1611 (depth = 3)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1612 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1613 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1614 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1615 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1614);
// compiled call node returning call1615 (depth = 6)
// compiled member node returning call1615 (depth = 5)
  gc_frame_newslot(call1615);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1616 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1617 = gc_frame_new();
// call case 3: self.outer request
  Object call1618 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1617);
// compiled call node returning call1618 (depth = 8)
// compiled member node returning call1618 (depth = 7)
  partcv[0] = 0;
  Object call1619 = callmethodflags(call1618, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1616);
// compiled call node returning call1619 (depth = 6)
// compiled member node returning call1619 (depth = 5)
  params[0] = call1615;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1620 = callmethodflags(call1619, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1613);
// compiled call node returning call1620 (depth = 4)
  gc_frame_newslot(call1620);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1620;
  partcv[0] = 1;
  Object call1621 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe1612);
// compiled call node returning call1621 (depth = 3)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1622 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1623 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1625 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1624);
// compiled call node returning call1625 (depth = 6)
// compiled member node returning call1625 (depth = 5)
  gc_frame_newslot(call1625);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1626 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1627 = gc_frame_new();
// call case 3: self.outer request
  Object call1628 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1627);
// compiled call node returning call1628 (depth = 8)
// compiled member node returning call1628 (depth = 7)
  partcv[0] = 0;
  Object call1629 = callmethodflags(call1628, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1626);
// compiled call node returning call1629 (depth = 6)
// compiled member node returning call1629 (depth = 5)
  params[0] = call1625;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1630 = callmethodflags(call1629, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1623);
// compiled call node returning call1630 (depth = 4)
  gc_frame_newslot(call1630);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1630;
  partcv[0] = 1;
  Object call1631 = callmethod(*var_n, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1622);
// compiled call node returning call1631 (depth = 3)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1632 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1633 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1632);
// compiled call node returning call1633 (depth = 3)
  gc_frame_end(frame);
  return call1633;
}
Object meth_ast__apply1642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1644 == NULL) {
    strlit1644 = alloc_String("  ");
    gc_root(strlit1644);
  }
// compiled string node returning strlit1644 (depth = 7)
  int op_slot_right_1643 = gc_frame_newslot(strlit1644);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1643 = gc_frame_newslot(*var_spc);
  params[0] = strlit1644;
  partcv[0] = 1;
  Object opresult1646 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1646 (depth = 6)
  *var_spc = opresult1646;
  if (opresult1646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1668(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1670 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1672 = alloc_Float64(2);
// compiled num node returning num1672 (depth = 9)
  int op_slot_right_1671 = gc_frame_newslot(num1672);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1671 = gc_frame_newslot(*var_depth);
  params[0] = num1672;
  partcv[0] = 1;
  Object sum1674 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1674 (depth = 8)
  gc_frame_newslot(sum1674);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1674;
  partcv[0] = 1;
  Object call1675 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1670);
// compiled call node returning call1675 (depth = 7)
  int op_slot_right_1669 = gc_frame_newslot(call1675);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1677 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1680 == NULL) {
    strlit1680 = alloc_String("""\x0a""  ");
    gc_root(strlit1680);
  }
// compiled string node returning strlit1680 (depth = 9)
  int op_slot_right_1679 = gc_frame_newslot(strlit1680);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1679 = gc_frame_newslot(*var_s);
  params[0] = strlit1680;
  partcv[0] = 1;
  Object opresult1682 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1682 (depth = 8)
  int op_slot_left_1677 = gc_frame_newslot(opresult1682);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1683 = callmethod(opresult1682, "++", 1, partcv, params);
// compiled op node returning opresult1683 (depth = 7)
  int op_slot_left_1669 = gc_frame_newslot(opresult1683);
  params[0] = call1675;
  partcv[0] = 1;
  Object opresult1684 = callmethod(opresult1683, "++", 1, partcv, params);
// compiled op node returning opresult1684 (depth = 6)
  *var_s = opresult1684;
  if (opresult1684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1705(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1707 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1709 = alloc_Float64(2);
// compiled num node returning num1709 (depth = 9)
  int op_slot_right_1708 = gc_frame_newslot(num1709);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1708 = gc_frame_newslot(*var_depth);
  params[0] = num1709;
  partcv[0] = 1;
  Object sum1711 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1711 (depth = 8)
  gc_frame_newslot(sum1711);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1711;
  partcv[0] = 1;
  Object call1712 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1707);
// compiled call node returning call1712 (depth = 7)
  int op_slot_right_1706 = gc_frame_newslot(call1712);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1714 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1717 == NULL) {
    strlit1717 = alloc_String("""\x0a""  ");
    gc_root(strlit1717);
  }
// compiled string node returning strlit1717 (depth = 9)
  int op_slot_right_1716 = gc_frame_newslot(strlit1717);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1716 = gc_frame_newslot(*var_s);
  params[0] = strlit1717;
  partcv[0] = 1;
  Object opresult1719 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1719 (depth = 8)
  int op_slot_left_1714 = gc_frame_newslot(opresult1719);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1720 = callmethod(opresult1719, "++", 1, partcv, params);
// compiled op node returning opresult1720 (depth = 7)
  int op_slot_left_1706 = gc_frame_newslot(opresult1720);
  params[0] = call1712;
  partcv[0] = 1;
  Object opresult1721 = callmethod(opresult1720, "++", 1, partcv, params);
// compiled op node returning opresult1721 (depth = 6)
  *var_s = opresult1721;
  if (opresult1721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1635 == NULL) {
    strlit1635 = alloc_String("");
    gc_root(strlit1635);
  }
// compiled string node returning strlit1635 (depth = 4)
  *var_spc = strlit1635;
  if (strlit1635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1636 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1637 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1639 = alloc_Float64(0);
// compiled num node returning num1639 (depth = 5)
  int op_slot_left_1637 = gc_frame_newslot(num1639);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1640 = callmethod(num1639, "..", 1, partcv, params);
// compiled op node returning opresult1640 (depth = 4)
  gc_frame_newslot(opresult1640);
// starting to compile block node (depth = 4)
  Object block1641 = alloc_Block(NULL, NULL, "ast", 344);
  gc_frame_newslot(block1641);
// method "_apply"
  block_savedest(block1641);
  Object closure1642 = createclosure(2, "_apply");
  setclosureframe(closure1642, stackframe);
  addtoclosure(closure1642, var_spc);
  addtoclosure(closure1642, selfslot);
  struct UserObject *uo1642 = (struct UserObject*)block1641;
  uo1642->data[0] = (Object)closure1642;
  Method *meth_meth_ast__apply1642 = addmethod2pos(block1641, "_apply", &meth_ast__apply1642, 0);
  int argcv_meth_ast__apply1642[] = {1};
  meth_meth_ast__apply1642->type = alloc_MethodType(1, argcv_meth_ast__apply1642);
  meth_meth_ast__apply1642->definitionModule = modulename;
  meth_meth_ast__apply1642->definitionLine = 339;
// compiled block node returning block1641 (depth = 4)
  gc_frame_newslot(block1641);
// call case 5: prelude request
  params[0] = opresult1640;
  params[1] = block1641;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1649 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1636);
// compiled call node returning call1649 (depth = 3)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1651 == NULL) {
    strlit1651 = alloc_String("""\x0a""");
    gc_root(strlit1651);
  }
// compiled string node returning strlit1651 (depth = 5)
  int op_slot_right_1650 = gc_frame_newslot(strlit1651);
// starting to compile call node (depth = 5)
  int callframe1653 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1654 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1653);
// compiled call node returning call1654 (depth = 5)
  int op_slot_left_1650 = gc_frame_newslot(call1654);
  params[0] = strlit1651;
  partcv[0] = 1;
  Object opresult1655 = callmethod(call1654, "++", 1, partcv, params);
// compiled op node returning opresult1655 (depth = 4)
  *var_s = opresult1655;
  if (opresult1655 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1657 == NULL) {
    strlit1657 = alloc_String("Parameters:");
    gc_root(strlit1657);
  }
// compiled string node returning strlit1657 (depth = 5)
  int op_slot_right_1656 = gc_frame_newslot(strlit1657);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1659 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1659 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1661 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1661 (depth = 5)
  int op_slot_left_1656 = gc_frame_newslot(opresult1661);
  params[0] = strlit1657;
  partcv[0] = 1;
  Object opresult1662 = callmethod(opresult1661, "++", 1, partcv, params);
// compiled op node returning opresult1662 (depth = 4)
  *var_s = opresult1662;
  if (opresult1662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1664 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1665 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1666 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1665);
// compiled call node returning call1666 (depth = 5)
// compiled member node returning call1666 (depth = 4)
  gc_frame_newslot(call1666);
// starting to compile block node (depth = 4)
  Object block1667 = alloc_Block(NULL, NULL, "ast", 349);
  gc_frame_newslot(block1667);
// method "_apply"
  block_savedest(block1667);
  Object closure1668 = createclosure(4, "_apply");
  setclosureframe(closure1668, stackframe);
  addtoclosure(closure1668, var_depth);
  addtoclosure(closure1668, var_spc);
  addtoclosure(closure1668, var_s);
  addtoclosure(closure1668, selfslot);
  struct UserObject *uo1668 = (struct UserObject*)block1667;
  uo1668->data[0] = (Object)closure1668;
  Method *meth_meth_ast__apply1668 = addmethod2pos(block1667, "_apply", &meth_ast__apply1668, 0);
  int argcv_meth_ast__apply1668[] = {1};
  meth_meth_ast__apply1668->type = alloc_MethodType(1, argcv_meth_ast__apply1668);
  meth_meth_ast__apply1668->definitionModule = modulename;
  meth_meth_ast__apply1668->definitionLine = 349;
// compiled block node returning block1667 (depth = 4)
  gc_frame_newslot(block1667);
// call case 5: prelude request
  params[0] = call1666;
  params[1] = block1667;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1687 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1664);
// compiled call node returning call1687 (depth = 3)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1689 == NULL) {
    strlit1689 = alloc_String("""\x0a""");
    gc_root(strlit1689);
  }
// compiled string node returning strlit1689 (depth = 5)
  int op_slot_right_1688 = gc_frame_newslot(strlit1689);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1688 = gc_frame_newslot(*var_s);
  params[0] = strlit1689;
  partcv[0] = 1;
  Object opresult1691 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1691 (depth = 4)
  *var_s = opresult1691;
  if (opresult1691 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1694 == NULL) {
    strlit1694 = alloc_String("Body:");
    gc_root(strlit1694);
  }
// compiled string node returning strlit1694 (depth = 5)
  int op_slot_right_1693 = gc_frame_newslot(strlit1694);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1696 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1696 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1698 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1698 (depth = 5)
  int op_slot_left_1693 = gc_frame_newslot(opresult1698);
  params[0] = strlit1694;
  partcv[0] = 1;
  Object opresult1699 = callmethod(opresult1698, "++", 1, partcv, params);
// compiled op node returning opresult1699 (depth = 4)
  *var_s = opresult1699;
  if (opresult1699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1701 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1703 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1702);
// compiled call node returning call1703 (depth = 5)
// compiled member node returning call1703 (depth = 4)
  gc_frame_newslot(call1703);
// starting to compile block node (depth = 4)
  Object block1704 = alloc_Block(NULL, NULL, "ast", 354);
  gc_frame_newslot(block1704);
// method "_apply"
  block_savedest(block1704);
  Object closure1705 = createclosure(4, "_apply");
  setclosureframe(closure1705, stackframe);
  addtoclosure(closure1705, var_depth);
  addtoclosure(closure1705, var_spc);
  addtoclosure(closure1705, var_s);
  addtoclosure(closure1705, selfslot);
  struct UserObject *uo1705 = (struct UserObject*)block1704;
  uo1705->data[0] = (Object)closure1705;
  Method *meth_meth_ast__apply1705 = addmethod2pos(block1704, "_apply", &meth_ast__apply1705, 0);
  int argcv_meth_ast__apply1705[] = {1};
  meth_meth_ast__apply1705->type = alloc_MethodType(1, argcv_meth_ast__apply1705);
  meth_meth_ast__apply1705->definitionModule = modulename;
  meth_meth_ast__apply1705->definitionLine = 354;
// compiled block node returning block1704 (depth = 4)
  gc_frame_newslot(block1704);
// call case 5: prelude request
  params[0] = call1703;
  params[1] = block1704;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1724 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1701);
// compiled call node returning call1724 (depth = 3)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1727 = alloc_Boolean(0);
// compiled identifier node returning bool1727 (depth = 5)
  int op_slot_right_1726 = gc_frame_newslot(bool1727);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1730 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1729);
// compiled call node returning call1730 (depth = 6)
// compiled member node returning call1730 (depth = 5)
  int op_slot_left_1726 = gc_frame_newslot(call1730);
  params[0] = bool1727;
  partcv[0] = 1;
  Object opresult1731 = callmethod(call1730, "!=", 1, partcv, params);
// compiled op node returning opresult1731 (depth = 4)
  Object if1725 = done;
  if (istrue(opresult1731)) {
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1733 == NULL) {
    strlit1733 = alloc_String("""\x0a""");
    gc_root(strlit1733);
  }
// compiled string node returning strlit1733 (depth = 6)
  int op_slot_right_1732 = gc_frame_newslot(strlit1733);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1732 = gc_frame_newslot(*var_s);
  params[0] = strlit1733;
  partcv[0] = 1;
  Object opresult1735 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1735 (depth = 5)
  *var_s = opresult1735;
  if (opresult1735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1738 == NULL) {
    strlit1738 = alloc_String("Pattern:");
    gc_root(strlit1738);
  }
// compiled string node returning strlit1738 (depth = 6)
  int op_slot_right_1737 = gc_frame_newslot(strlit1738);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1740 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1740 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1742 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1742 (depth = 6)
  int op_slot_left_1737 = gc_frame_newslot(opresult1742);
  params[0] = strlit1738;
  partcv[0] = 1;
  Object opresult1743 = callmethod(opresult1742, "++", 1, partcv, params);
// compiled op node returning opresult1743 (depth = 5)
  *var_s = opresult1743;
  if (opresult1743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1746 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1748 = alloc_Float64(2);
// compiled num node returning num1748 (depth = 8)
  int op_slot_right_1747 = gc_frame_newslot(num1748);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1747 = gc_frame_newslot(*var_depth);
  params[0] = num1748;
  partcv[0] = 1;
  Object sum1750 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1750 (depth = 7)
  gc_frame_newslot(sum1750);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1752 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1751);
// compiled call node returning call1752 (depth = 8)
// compiled member node returning call1752 (depth = 7)
  params[0] = sum1750;
  partcv[0] = 1;
  Object call1753 = callmethod(call1752, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1746);
// compiled call node returning call1753 (depth = 6)
  int op_slot_right_1745 = gc_frame_newslot(call1753);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1755 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1758 == NULL) {
    strlit1758 = alloc_String("""\x0a""  ");
    gc_root(strlit1758);
  }
// compiled string node returning strlit1758 (depth = 8)
  int op_slot_right_1757 = gc_frame_newslot(strlit1758);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1757 = gc_frame_newslot(*var_s);
  params[0] = strlit1758;
  partcv[0] = 1;
  Object opresult1760 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1760 (depth = 7)
  int op_slot_left_1755 = gc_frame_newslot(opresult1760);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1761 = callmethod(opresult1760, "++", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 6)
  int op_slot_left_1745 = gc_frame_newslot(opresult1761);
  params[0] = call1753;
  partcv[0] = 1;
  Object opresult1762 = callmethod(opresult1761, "++", 1, partcv, params);
// compiled op node returning opresult1762 (depth = 5)
  *var_s = opresult1762;
  if (opresult1762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1725 = done;
  } else {
  }
// compiled if node returning if1725 (depth = 3)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1776(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1778 == NULL) {
    strlit1778 = alloc_String("    ");
    gc_root(strlit1778);
  }
// compiled string node returning strlit1778 (depth = 7)
  int op_slot_right_1777 = gc_frame_newslot(strlit1778);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1777 = gc_frame_newslot(*var_spc);
  params[0] = strlit1778;
  partcv[0] = 1;
  Object opresult1780 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1780 (depth = 6)
  *var_spc = opresult1780;
  if (opresult1780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1805(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1807 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1806);
// compiled call node returning call1807 (depth = 9)
// compiled member node returning call1807 (depth = 8)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1808 = callmethod(call1807, "[]", 1, partcv, params);
// compiled index node returning idxres1808 (depth = 7)
  *var_p = idxres1808;
  if (idxres1808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1811 = alloc_Boolean(0);
// compiled identifier node returning bool1811 (depth = 8)
  int op_slot_right_1810 = gc_frame_newslot(bool1811);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1814 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1813);
// compiled call node returning call1814 (depth = 9)
// compiled member node returning call1814 (depth = 8)
  int op_slot_left_1810 = gc_frame_newslot(call1814);
  params[0] = bool1811;
  partcv[0] = 1;
  Object opresult1815 = callmethod(call1814, "!=", 1, partcv, params);
// compiled op node returning opresult1815 (depth = 7)
  Object if1809 = done;
  if (istrue(opresult1815)) {
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1817 == NULL) {
    strlit1817 = alloc_String(")");
    gc_root(strlit1817);
  }
// compiled string node returning strlit1817 (depth = 9)
  int op_slot_right_1816 = gc_frame_newslot(strlit1817);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1820 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num1821 = alloc_Float64(0);
// compiled num node returning num1821 (depth = 11)
  gc_frame_newslot(num1821);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num1821;
  partcv[0] = 1;
  Object call1822 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1820);
// compiled call node returning call1822 (depth = 10)
  int op_slot_right_1819 = gc_frame_newslot(call1822);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1825 == NULL) {
    strlit1825 = alloc_String("(");
    gc_root(strlit1825);
  }
// compiled string node returning strlit1825 (depth = 11)
  int op_slot_right_1824 = gc_frame_newslot(strlit1825);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1824 = gc_frame_newslot(*var_s);
  params[0] = strlit1825;
  partcv[0] = 1;
  Object opresult1827 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1827 (depth = 10)
  int op_slot_left_1819 = gc_frame_newslot(opresult1827);
  params[0] = call1822;
  partcv[0] = 1;
  Object opresult1828 = callmethod(opresult1827, "++", 1, partcv, params);
// compiled op node returning opresult1828 (depth = 9)
  int op_slot_left_1816 = gc_frame_newslot(opresult1828);
  params[0] = strlit1817;
  partcv[0] = 1;
  Object opresult1829 = callmethod(opresult1828, "++", 1, partcv, params);
// compiled op node returning opresult1829 (depth = 8)
  *var_s = opresult1829;
  if (opresult1829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1809 = done;
  } else {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1832 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1833 = alloc_Float64(0);
// compiled num node returning num1833 (depth = 10)
  gc_frame_newslot(num1833);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = num1833;
  partcv[0] = 1;
  Object call1834 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1832);
// compiled call node returning call1834 (depth = 9)
  int op_slot_right_1831 = gc_frame_newslot(call1834);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1831 = gc_frame_newslot(*var_s);
  params[0] = call1834;
  partcv[0] = 1;
  Object opresult1836 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1836 (depth = 8)
  *var_s = opresult1836;
  if (opresult1836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1809 = done;
  }
// compiled if node returning if1809 (depth = 6)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1840 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1842 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1841);
// compiled call node returning call1842 (depth = 11)
// compiled member node returning call1842 (depth = 10)
  partcv[0] = 0;
  Object call1843 = callmethod(call1842, "size",
    1, partcv, params);
  gc_frame_end(callframe1840);
// compiled call node returning call1843 (depth = 9)
// compiled member node returning call1843 (depth = 8)
  int op_slot_right_1839 = gc_frame_newslot(call1843);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1839 = gc_frame_newslot(*var_i);
  params[0] = call1843;
  partcv[0] = 1;
  Object opresult1845 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1845 (depth = 7)
  Object if1838 = done;
  if (istrue(opresult1845)) {
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1847 == NULL) {
    strlit1847 = alloc_String(", ");
    gc_root(strlit1847);
  }
// compiled string node returning strlit1847 (depth = 9)
  int op_slot_right_1846 = gc_frame_newslot(strlit1847);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1846 = gc_frame_newslot(*var_s);
  params[0] = strlit1847;
  partcv[0] = 1;
  Object opresult1849 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 8)
  *var_s = opresult1849;
  if (opresult1849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1838 = done;
  } else {
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1852 == NULL) {
    strlit1852 = alloc_String(" ->");
    gc_root(strlit1852);
  }
// compiled string node returning strlit1852 (depth = 9)
  int op_slot_right_1851 = gc_frame_newslot(strlit1852);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1851 = gc_frame_newslot(*var_s);
  params[0] = strlit1852;
  partcv[0] = 1;
  Object opresult1854 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1854 (depth = 8)
  *var_s = opresult1854;
  if (opresult1854 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1838 = done;
  }
// compiled if node returning if1838 (depth = 6)
  gc_frame_end(frame);
  return if1838;
}
Object meth_ast__apply1862(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1864 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1866 = alloc_Float64(1);
// compiled num node returning num1866 (depth = 9)
  int op_slot_right_1865 = gc_frame_newslot(num1866);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1865 = gc_frame_newslot(*var_depth);
  params[0] = num1866;
  partcv[0] = 1;
  Object sum1868 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1868 (depth = 8)
  gc_frame_newslot(sum1868);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1868;
  partcv[0] = 1;
  Object call1869 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1864);
// compiled call node returning call1869 (depth = 7)
  int op_slot_right_1863 = gc_frame_newslot(call1869);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1872 == NULL) {
    strlit1872 = alloc_String("    ");
    gc_root(strlit1872);
  }
// compiled string node returning strlit1872 (depth = 8)
  int op_slot_right_1871 = gc_frame_newslot(strlit1872);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1874 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1877 == NULL) {
    strlit1877 = alloc_String("""\x0a""");
    gc_root(strlit1877);
  }
// compiled string node returning strlit1877 (depth = 10)
  int op_slot_right_1876 = gc_frame_newslot(strlit1877);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1876 = gc_frame_newslot(*var_s);
  params[0] = strlit1877;
  partcv[0] = 1;
  Object opresult1879 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1879 (depth = 9)
  int op_slot_left_1874 = gc_frame_newslot(opresult1879);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1880 = callmethod(opresult1879, "++", 1, partcv, params);
// compiled op node returning opresult1880 (depth = 8)
  int op_slot_left_1871 = gc_frame_newslot(opresult1880);
  params[0] = strlit1872;
  partcv[0] = 1;
  Object opresult1881 = callmethod(opresult1880, "++", 1, partcv, params);
// compiled op node returning opresult1881 (depth = 7)
  int op_slot_left_1863 = gc_frame_newslot(opresult1881);
  params[0] = call1869;
  partcv[0] = 1;
  Object opresult1882 = callmethod(opresult1881, "++", 1, partcv, params);
// compiled op node returning opresult1882 (depth = 6)
  *var_s = opresult1882;
  if (opresult1882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1764(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1765 == NULL) {
    strlit1765 = alloc_String("");
    gc_root(strlit1765);
  }
// compiled string node returning strlit1765 (depth = 4)
  *var_spc = strlit1765;
  if (strlit1765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1766 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1769 = alloc_Float64(1);
// compiled num node returning num1769 (depth = 6)
  int op_slot_right_1768 = gc_frame_newslot(num1769);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_1768 = gc_frame_newslot(*var_depth);
  params[0] = num1769;
  partcv[0] = 1;
  Object diff1771 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff1771 (depth = 5)
  int op_slot_right_1767 = gc_frame_newslot(diff1771);
// starting to compile num node (depth = 5)
  Object num1773 = alloc_Float64(0);
// compiled num node returning num1773 (depth = 5)
  int op_slot_left_1767 = gc_frame_newslot(num1773);
  params[0] = diff1771;
  partcv[0] = 1;
  Object opresult1774 = callmethod(num1773, "..", 1, partcv, params);
// compiled op node returning opresult1774 (depth = 4)
  gc_frame_newslot(opresult1774);
// starting to compile block node (depth = 4)
  Object block1775 = alloc_Block(NULL, NULL, "ast", 366);
  gc_frame_newslot(block1775);
// method "_apply"
  block_savedest(block1775);
  Object closure1776 = createclosure(2, "_apply");
  setclosureframe(closure1776, stackframe);
  addtoclosure(closure1776, var_spc);
  addtoclosure(closure1776, selfslot);
  struct UserObject *uo1776 = (struct UserObject*)block1775;
  uo1776->data[0] = (Object)closure1776;
  Method *meth_meth_ast__apply1776 = addmethod2pos(block1775, "_apply", &meth_ast__apply1776, 0);
  int argcv_meth_ast__apply1776[] = {1};
  meth_meth_ast__apply1776->type = alloc_MethodType(1, argcv_meth_ast__apply1776);
  meth_meth_ast__apply1776->definitionModule = modulename;
  meth_meth_ast__apply1776->definitionLine = 360;
// compiled block node returning block1775 (depth = 4)
  gc_frame_newslot(block1775);
// call case 5: prelude request
  params[0] = opresult1774;
  params[1] = block1775;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1783 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1766);
// compiled call node returning call1783 (depth = 3)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1784 == NULL) {
    strlit1784 = alloc_String("{");
    gc_root(strlit1784);
  }
// compiled string node returning strlit1784 (depth = 4)
  *var_s = strlit1784;
  if (strlit1784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1787 = alloc_Float64(0);
// compiled num node returning num1787 (depth = 5)
  int op_slot_right_1786 = gc_frame_newslot(num1787);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1789 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1790 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1791 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1790);
// compiled call node returning call1791 (depth = 8)
// compiled member node returning call1791 (depth = 7)
  partcv[0] = 0;
  Object call1792 = callmethod(call1791, "size",
    1, partcv, params);
  gc_frame_end(callframe1789);
// compiled call node returning call1792 (depth = 6)
// compiled member node returning call1792 (depth = 5)
  int op_slot_left_1786 = gc_frame_newslot(call1792);
  params[0] = num1787;
  partcv[0] = 1;
  Object opresult1793 = callmethod(call1792, ">", 1, partcv, params);
// compiled op node returning opresult1793 (depth = 4)
  Object if1785 = done;
  if (istrue(opresult1793)) {
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1795 == NULL) {
    strlit1795 = alloc_String(" ");
    gc_root(strlit1795);
  }
// compiled string node returning strlit1795 (depth = 6)
  int op_slot_right_1794 = gc_frame_newslot(strlit1795);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1794 = gc_frame_newslot(*var_s);
  params[0] = strlit1795;
  partcv[0] = 1;
  Object opresult1797 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1797 (depth = 5)
  *var_s = opresult1797;
  if (opresult1797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1799 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1800 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1802 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1801);
// compiled call node returning call1802 (depth = 8)
// compiled member node returning call1802 (depth = 7)
  partcv[0] = 0;
  Object call1803 = callmethod(call1802, "indices",
    1, partcv, params);
  gc_frame_end(callframe1800);
// compiled call node returning call1803 (depth = 6)
// compiled member node returning call1803 (depth = 5)
  gc_frame_newslot(call1803);
// starting to compile block node (depth = 5)
  Object block1804 = alloc_Block(NULL, NULL, "ast", 372);
  gc_frame_newslot(block1804);
// method "_apply"
  block_savedest(block1804);
  Object closure1805 = createclosure(2, "_apply");
  setclosureframe(closure1805, stackframe);
  addtoclosure(closure1805, var_s);
  addtoclosure(closure1805, selfslot);
  struct UserObject *uo1805 = (struct UserObject*)block1804;
  uo1805->data[0] = (Object)closure1805;
  Method *meth_meth_ast__apply1805 = addmethod2pos(block1804, "_apply", &meth_ast__apply1805, 0);
  int argcv_meth_ast__apply1805[] = {1};
  meth_meth_ast__apply1805->type = alloc_MethodType(1, argcv_meth_ast__apply1805);
  meth_meth_ast__apply1805->definitionModule = modulename;
  meth_meth_ast__apply1805->definitionLine = 372;
// compiled block node returning block1804 (depth = 5)
  gc_frame_newslot(block1804);
// call case 5: prelude request
  params[0] = call1803;
  params[1] = block1804;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1857 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1799);
// compiled call node returning call1857 (depth = 4)
    gc_frame_newslot(call1857);
    if1785 = call1857;
  } else {
  }
// compiled if node returning if1785 (depth = 3)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1858 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1860 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1859);
// compiled call node returning call1860 (depth = 5)
// compiled member node returning call1860 (depth = 4)
  gc_frame_newslot(call1860);
// starting to compile block node (depth = 4)
  Object block1861 = alloc_Block(NULL, NULL, "ast", 386);
  gc_frame_newslot(block1861);
// method "_apply"
  block_savedest(block1861);
  Object closure1862 = createclosure(4, "_apply");
  setclosureframe(closure1862, stackframe);
  addtoclosure(closure1862, var_depth);
  addtoclosure(closure1862, var_spc);
  addtoclosure(closure1862, var_s);
  addtoclosure(closure1862, selfslot);
  struct UserObject *uo1862 = (struct UserObject*)block1861;
  uo1862->data[0] = (Object)closure1862;
  Method *meth_meth_ast__apply1862 = addmethod2pos(block1861, "_apply", &meth_ast__apply1862, 0);
  int argcv_meth_ast__apply1862[] = {1};
  meth_meth_ast__apply1862->type = alloc_MethodType(1, argcv_meth_ast__apply1862);
  meth_meth_ast__apply1862->definitionModule = modulename;
  meth_meth_ast__apply1862->definitionLine = 386;
// compiled block node returning block1861 (depth = 4)
  gc_frame_newslot(block1861);
// call case 5: prelude request
  params[0] = call1860;
  params[1] = block1861;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1885 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1858);
// compiled call node returning call1885 (depth = 3)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1887 == NULL) {
    strlit1887 = alloc_String("}");
    gc_root(strlit1887);
  }
// compiled string node returning strlit1887 (depth = 5)
  int op_slot_right_1886 = gc_frame_newslot(strlit1887);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1889 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1892 == NULL) {
    strlit1892 = alloc_String("""\x0a""");
    gc_root(strlit1892);
  }
// compiled string node returning strlit1892 (depth = 7)
  int op_slot_right_1891 = gc_frame_newslot(strlit1892);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1891 = gc_frame_newslot(*var_s);
  params[0] = strlit1892;
  partcv[0] = 1;
  Object opresult1894 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1894 (depth = 6)
  int op_slot_left_1889 = gc_frame_newslot(opresult1894);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1895 = callmethod(opresult1894, "++", 1, partcv, params);
// compiled op node returning opresult1895 (depth = 5)
  int op_slot_left_1886 = gc_frame_newslot(opresult1895);
  params[0] = strlit1887;
  partcv[0] = 1;
  Object opresult1896 = callmethod(opresult1895, "++", 1, partcv, params);
// compiled op node returning opresult1896 (depth = 4)
  *var_s = opresult1896;
  if (opresult1896 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1899 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe1900 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1901 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1902 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1901);
// compiled call node returning call1902 (depth = 6)
// compiled member node returning call1902 (depth = 5)
  gc_frame_newslot(call1902);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1903 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1904 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1903);
// compiled call node returning call1904 (depth = 6)
// compiled member node returning call1904 (depth = 5)
  gc_frame_newslot(call1904);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blockNode (depth = 5)
  params[0] = call1902;
  params[1] = call1904;
  partcv[0] = 2;
  Object call1905 = callmethod(*var_blockNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1900);
// compiled call node returning call1905 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1906 = callmethod(call1905, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe1899);
// compiled call node returning call1906 (depth = 3)
  gc_frame_end(frame);
  return call1906;
}
Object meth_ast_shallowCopyFieldsFrom1907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1908 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1909 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1908);
// compiled call node returning call1909 (depth = 3)
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1910 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call1912 = callmethod(*var_other, "matchingPattern",
    1, partcv, params);
  gc_frame_end(callframe1911);
// compiled call node returning call1912 (depth = 5)
// compiled member node returning call1912 (depth = 4)
  gc_frame_newslot(call1912);
// call case 4: self request
  params[0] = call1912;
  partcv[0] = 1;
  Object call1913 = callmethodflags(self, "matchingPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1910);
// compiled call node returning call1913 (depth = 3)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1914 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call1916 = callmethod(*var_other, "extraRuntimeData",
    1, partcv, params);
  gc_frame_end(callframe1915);
// compiled call node returning call1916 (depth = 5)
// compiled member node returning call1916 (depth = 4)
  gc_frame_newslot(call1916);
// call case 4: self request
  params[0] = call1916;
  partcv[0] = 1;
  Object call1917 = callmethodflags(self, "extraRuntimeData:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1914);
// compiled call node returning call1917 (depth = 3)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply1931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1932 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_patternMarkVisitor (depth = 6)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile call node (depth = 6)
  int callframe1933 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1934 = callmethod(*var_ancestorChain, "with",
    1, partcv, params);
  gc_frame_end(callframe1933);
// compiled call node returning call1934 (depth = 6)
  gc_frame_newslot(call1934);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  params[0] = *var_patternMarkVisitor;
  params[1] = call1934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1935 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1932);
// compiled call node returning call1935 (depth = 5)
  gc_frame_end(frame);
  return call1935;
}
Object meth_ast_new1483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1484 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1484 = alloc_userobj2(27,24, objclass1484);
  gc_frame_newslot(obj1484);
if (objclass1484 == NULL) {
  glfree(obj1484->class->name);
  obj1484->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1484, self, 0);
  addmethodreal(obj1484,"outer", &reader_ast_outer_1485);
  Object oldself1484 = self;
  struct StackFrameObject *oldstackframe1484 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1484);
  gc_frame_newslot((Object)stackframe);
  self = obj1484;
  Object *oldselfslot1484 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1484 = (*(struct UserObject *)self).data[0], lowerouter1484 = thisouter1484;
  if (inheritingObject1484) {
    struct UserObject *inho1484 = (struct UserObject *)inheritingObject1484;
    while (inho1484->super != GraceDefaultObject) inho1484 = (struct UserObject *)inho1484->super;
    inho1484->super = obj1484;
    self = inheritingObject1484;
    *selfslot = self;
    lowerouter1484 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1484;
  }
if (objclass1484 == NULL) {
  Method *reader1486 = addmethodrealflags(obj1484, "kind",&reader_ast_kind_1486, MFLAG_DEF);
  reader1486->definitionModule = modulename;
  reader1486->definitionLine = 289;
}
adddatum2(obj1484, alloc_Undefined(), 1);
if (objclass1484 == NULL) {
  Method *reader1487 = addmethodrealflags(obj1484, "value",&reader_ast_value_1487, MFLAG_DEF);
  reader1487->definitionModule = modulename;
  reader1487->definitionLine = 290;
}
adddatum2(obj1484, alloc_Undefined(), 2);
if (objclass1484 == NULL) {
  Method *reader1488 = addmethodrealflags(obj1484, "params",&reader_ast_params_1488, 0);
  Method *writer1488 = addmethodrealflags(obj1484, "params:=",&writer_ast_params_1488, 0);
  reader1488->definitionModule = modulename;
  writer1488->definitionModule = modulename;
  reader1488->definitionLine = 291;
  writer1488->definitionLine = 291;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 3);
if (objclass1484 == NULL) {
  Method *reader1489 = addmethodrealflags(obj1484, "body",&reader_ast_body_1489, 0);
  Method *writer1489 = addmethodrealflags(obj1484, "body:=",&writer_ast_body_1489, 0);
  reader1489->definitionModule = modulename;
  writer1489->definitionModule = modulename;
  reader1489->definitionLine = 292;
  writer1489->definitionLine = 292;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 4);
if (objclass1484 == NULL) {
  Method *reader1490 = addmethodrealflags(obj1484, "selfclosure",&reader_ast_selfclosure_1490, MFLAG_DEF);
  reader1490->definitionModule = modulename;
  reader1490->definitionLine = 293;
}
adddatum2(obj1484, alloc_Undefined(), 5);
if (objclass1484 == NULL) {
  Method *reader1491 = addmethodrealflags(obj1484, "matchingPattern",&reader_ast_matchingPattern_1491, 0);
  Method *writer1491 = addmethodrealflags(obj1484, "matchingPattern:=",&writer_ast_matchingPattern_1491, 0);
  reader1491->definitionModule = modulename;
  writer1491->definitionModule = modulename;
  reader1491->definitionLine = 294;
  writer1491->definitionLine = 294;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 6);
if (objclass1484 == NULL) {
  Method *reader1492 = addmethodrealflags(obj1484, "extraRuntimeData",&reader_ast_extraRuntimeData_1492, 0);
  Method *writer1492 = addmethodrealflags(obj1484, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1492, 0);
  reader1492->definitionModule = modulename;
  writer1492->definitionModule = modulename;
  reader1492->definitionLine = 295;
  writer1492->definitionLine = 295;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1493 = (struct UserObject*)obj1484;
  uo1493->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1493 = addmethod2pos(obj1484, "isBlock", &meth_ast_isBlock1493, 8);
  int argcv_meth_ast_isBlock1493[] = {0};
  meth_meth_ast_isBlock1493->type = alloc_MethodType(1, argcv_meth_ast_isBlock1493);
  meth_meth_ast_isBlock1493->definitionModule = modulename;
  meth_meth_ast_isBlock1493->definitionLine = 299;
// method "isEmpty"
  struct UserObject *uo1495 = (struct UserObject*)obj1484;
  uo1495->data[9] = emptyclosure;
  Method *meth_meth_ast_isEmpty1495 = addmethod2pos(obj1484, "isEmpty", &meth_ast_isEmpty1495, 9);
  int argcv_meth_ast_isEmpty1495[] = {0};
  meth_meth_ast_isEmpty1495->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1495);
  meth_meth_ast_isEmpty1495->definitionModule = modulename;
  meth_meth_ast_isEmpty1495->definitionLine = 300;
// method "isntEmpty"
  struct UserObject *uo1504 = (struct UserObject*)obj1484;
  uo1504->data[10] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1504 = addmethod2pos(obj1484, "isntEmpty", &meth_ast_isntEmpty1504, 10);
  int argcv_meth_ast_isntEmpty1504[] = {0};
  meth_meth_ast_isntEmpty1504->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1504);
  meth_meth_ast_isntEmpty1504->definitionModule = modulename;
  meth_meth_ast_isntEmpty1504->definitionLine = 301;
// method "scope:="
  struct UserObject *uo1513 = (struct UserObject*)obj1484;
  uo1513->data[11] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_1513 = addmethod2pos(obj1484, "scope:=", &meth_ast_scope_58__61_1513, 11);
  int argcv_meth_ast_scope_58__61_1513[] = {1};
  meth_meth_ast_scope_58__61_1513->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_1513);
  meth_meth_ast_scope_58__61_1513->definitionModule = modulename;
  meth_meth_ast_scope_58__61_1513->definitionLine = 302;
// method "declarationKindWithAncestors"
  block_savedest(obj1484);
  Object closure1518 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure1518, stackframe);
  addtoclosure(closure1518, var_k);
  struct UserObject *uo1518 = (struct UserObject*)obj1484;
  uo1518->data[12] = (Object)closure1518;
  Method *meth_meth_ast_declarationKindWithAncestors1518 = addmethod2pos(obj1484, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors1518, 12);
  int argcv_meth_ast_declarationKindWithAncestors1518[] = {1};
  meth_meth_ast_declarationKindWithAncestors1518->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors1518);
  meth_meth_ast_declarationKindWithAncestors1518->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors1518->definitionLine = 308;
// method "isMatchingBlock"
  struct UserObject *uo1521 = (struct UserObject*)obj1484;
  uo1521->data[13] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1521 = addmethod2pos(obj1484, "isMatchingBlock", &meth_ast_isMatchingBlock1521, 13);
  int argcv_meth_ast_isMatchingBlock1521[] = {0};
  meth_meth_ast_isMatchingBlock1521->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1521);
  meth_meth_ast_isMatchingBlock1521->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1521->definitionLine = 309;
// method "returnsObject"
  struct UserObject *uo1530 = (struct UserObject*)obj1484;
  uo1530->data[14] = emptyclosure;
  Method *meth_meth_ast_returnsObject1530 = addmethod2pos(obj1484, "returnsObject", &meth_ast_returnsObject1530, 14);
  int argcv_meth_ast_returnsObject1530[] = {0};
  meth_meth_ast_returnsObject1530->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1530);
  meth_meth_ast_returnsObject1530->definitionModule = modulename;
  meth_meth_ast_returnsObject1530->definitionLine = 310;
// method "returnedObjectScope"
  struct UserObject *uo1550 = (struct UserObject*)obj1484;
  uo1550->data[15] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1550 = addmethod2pos(obj1484, "returnedObjectScope", &meth_ast_returnedObjectScope1550, 15);
  int argcv_meth_ast_returnedObjectScope1550[] = {0};
  meth_meth_ast_returnedObjectScope1550->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1550);
  meth_meth_ast_returnedObjectScope1550->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1550->definitionLine = 313;
// method "parametersDo"
  struct UserObject *uo1557 = (struct UserObject*)obj1484;
  uo1557->data[16] = emptyclosure;
  Method *meth_meth_ast_parametersDo1557 = addmethod2pos(obj1484, "parametersDo", &meth_ast_parametersDo1557, 16);
  int argcv_meth_ast_parametersDo1557[] = {1};
  meth_meth_ast_parametersDo1557->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1557);
  meth_meth_ast_parametersDo1557->definitionModule = modulename;
  meth_meth_ast_parametersDo1557->definitionLine = 317;
// method "accept()from"
  struct UserObject *uo1562 = (struct UserObject*)obj1484;
  uo1562->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1562 = addmethod2pos(obj1484, "accept()from", &meth_ast_accept_40__41_from1562, 17);
  int argcv_meth_ast_accept_40__41_from1562[] = {1, 1};
  meth_meth_ast_accept_40__41_from1562->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1562);
  meth_meth_ast_accept_40__41_from1562->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1562->definitionLine = 320;
// method "map()ancestors"
  struct UserObject *uo1597 = (struct UserObject*)obj1484;
  uo1597->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1597 = addmethod2pos(obj1484, "map()ancestors", &meth_ast_map_40__41_ancestors1597, 18);
  int argcv_meth_ast_map_40__41_ancestors1597[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1597->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1597);
  meth_meth_ast_map_40__41_ancestors1597->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1597->definitionLine = 334;
// method "pretty"
  struct UserObject *uo1634 = (struct UserObject*)obj1484;
  uo1634->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty1634 = addmethod2pos(obj1484, "pretty", &meth_ast_pretty1634, 19);
  int argcv_meth_ast_pretty1634[] = {1};
  meth_meth_ast_pretty1634->type = alloc_MethodType(1, argcv_meth_ast_pretty1634);
  meth_meth_ast_pretty1634->definitionModule = modulename;
  meth_meth_ast_pretty1634->definitionLine = 342;
// method "toGrace"
  struct UserObject *uo1764 = (struct UserObject*)obj1484;
  uo1764->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace1764 = addmethod2pos(obj1484, "toGrace", &meth_ast_toGrace1764, 20);
  int argcv_meth_ast_toGrace1764[] = {1};
  meth_meth_ast_toGrace1764->type = alloc_MethodType(1, argcv_meth_ast_toGrace1764);
meth_meth_ast_toGrace1764->type->types[0] = type_Number;
meth_meth_ast_toGrace1764->type->names[0] = "depth";
  meth_meth_ast_toGrace1764->definitionModule = modulename;
  meth_meth_ast_toGrace1764->definitionLine = 364;
// method "shallowCopy"
  block_savedest(obj1484);
  Object closure1898 = createclosure(1, "shallowCopy");
  setclosureframe(closure1898, stackframe);
  addtoclosure(closure1898, var_blockNode);
  struct UserObject *uo1898 = (struct UserObject*)obj1484;
  uo1898->data[21] = (Object)closure1898;
  Method *meth_meth_ast_shallowCopy1898 = addmethod2pos(obj1484, "shallowCopy", &meth_ast_shallowCopy1898, 21);
  int argcv_meth_ast_shallowCopy1898[] = {0};
  meth_meth_ast_shallowCopy1898->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1898);
  meth_meth_ast_shallowCopy1898->definitionModule = modulename;
  meth_meth_ast_shallowCopy1898->definitionLine = 392;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1907 = (struct UserObject*)obj1484;
  uo1907->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1907 = addmethod2pos(obj1484, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1907, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom1907[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1907->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1907);
  meth_meth_ast_shallowCopyFieldsFrom1907->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1907->definitionLine = 395;
  sourceObject = obj1484;
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1918 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1919 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1920 = gc_frame_new();
// call case 3: self.outer request
  Object call1921 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1920);
// compiled call node returning call1921 (depth = 7)
// compiled member node returning call1921 (depth = 6)
  partcv[0] = 0;
  Object call1922 = callmethodflags(call1921, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1919);
// compiled call node returning call1922 (depth = 5)
// compiled member node returning call1922 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1923 = callmethodflags(call1922, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1918);
// compiled call node returning call1923 (depth = 3)
  struct UserObject *obj1484_uo = (struct UserObject *)obj1484;
  obj1484_uo->super = call1923;
  sourceObject = obj1484;
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1924 == NULL) {
    strlit1924 = alloc_String("block");
    gc_root(strlit1924);
  }
// compiled string node returning strlit1924 (depth = 3)
  adddatum2(obj1484, strlit1924, 1);
  sourceObject = obj1484;
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1925 == NULL) {
    strlit1925 = alloc_String("block");
    gc_root(strlit1925);
  }
// compiled string node returning strlit1925 (depth = 3)
  adddatum2(obj1484, strlit1925, 2);
  sourceObject = obj1484;
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1484, *var_params_39_, 3);
  sourceObject = obj1484;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1484, *var_body_39_, 4);
  sourceObject = obj1484;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1926 = alloc_Boolean(1);
// compiled identifier node returning bool1926 (depth = 3)
  adddatum2(obj1484, bool1926, 5);
  sourceObject = obj1484;
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1927 = alloc_Boolean(0);
// compiled identifier node returning bool1927 (depth = 3)
  adddatum2(obj1484, bool1927, 6);
  sourceObject = obj1484;
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1928 = alloc_Boolean(0);
// compiled identifier node returning bool1928 (depth = 3)
  adddatum2(obj1484, bool1928, 7);
  sourceObject = obj1484;
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1929 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block1930 = alloc_Block(NULL, NULL, "ast", 296);
  gc_frame_newslot(block1930);
// method "_apply"
  block_savedest(block1930);
  Object closure1931 = createclosure(3, "_apply");
  setclosureframe(closure1931, stackframe);
  addtoclosure(closure1931, var_patternMarkVisitor);
  addtoclosure(closure1931, var_ancestorChain);
  addtoclosure(closure1931, selfslot);
  struct UserObject *uo1931 = (struct UserObject*)block1930;
  uo1931->data[0] = (Object)closure1931;
  Method *meth_meth_ast__apply1931 = addmethod2pos(block1930, "_apply", &meth_ast__apply1931, 0);
  int argcv_meth_ast__apply1931[] = {1};
  meth_meth_ast__apply1931->type = alloc_MethodType(1, argcv_meth_ast__apply1931);
  meth_meth_ast__apply1931->definitionModule = modulename;
  meth_meth_ast__apply1931->definitionLine = 288;
// compiled block node returning block1930 (depth = 4)
  gc_frame_newslot(block1930);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1930;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1937 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled call node returning call1937 (depth = 3)
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  objclass1484 = obj1484->class;
  objclass1484->definitionModule = modulename;
  objclass1484->definitionLine = 287;
  (*(struct UserObject *)self).data[0] = lowerouter1484;
  self = oldself1484;
  selfslot = oldselfslot1484;
  stackframe = oldstackframe1484;
  gc_frame_end(frame);
  return obj1484;
}
Object meth_ast_new1483_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1484 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1484 = alloc_userobj2(27,24, objclass1484);
  gc_frame_newslot(obj1484);
if (objclass1484 == NULL) {
  glfree(obj1484->class->name);
  obj1484->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1484, self, 0);
  addmethodreal(obj1484,"outer", &reader_ast_outer_1485);
  Object oldself1484 = self;
  struct StackFrameObject *oldstackframe1484 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1484);
  gc_frame_newslot((Object)stackframe);
  self = obj1484;
  Object *oldselfslot1484 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1484 = (*(struct UserObject *)self).data[0], lowerouter1484 = thisouter1484;
  if (inheritingObject1484) {
    struct UserObject *inho1484 = (struct UserObject *)inheritingObject1484;
    while (inho1484->super != GraceDefaultObject) inho1484 = (struct UserObject *)inho1484->super;
    inho1484->super = obj1484;
    self = inheritingObject1484;
    *selfslot = self;
    lowerouter1484 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1484;
  }
if (objclass1484 == NULL) {
  Method *reader1486 = addmethodrealflags(obj1484, "kind",&reader_ast_kind_1486, MFLAG_DEF);
  reader1486->definitionModule = modulename;
  reader1486->definitionLine = 289;
}
adddatum2(obj1484, alloc_Undefined(), 1);
if (objclass1484 == NULL) {
  Method *reader1487 = addmethodrealflags(obj1484, "value",&reader_ast_value_1487, MFLAG_DEF);
  reader1487->definitionModule = modulename;
  reader1487->definitionLine = 290;
}
adddatum2(obj1484, alloc_Undefined(), 2);
if (objclass1484 == NULL) {
  Method *reader1488 = addmethodrealflags(obj1484, "params",&reader_ast_params_1488, 0);
  Method *writer1488 = addmethodrealflags(obj1484, "params:=",&writer_ast_params_1488, 0);
  reader1488->definitionModule = modulename;
  writer1488->definitionModule = modulename;
  reader1488->definitionLine = 291;
  writer1488->definitionLine = 291;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 3);
if (objclass1484 == NULL) {
  Method *reader1489 = addmethodrealflags(obj1484, "body",&reader_ast_body_1489, 0);
  Method *writer1489 = addmethodrealflags(obj1484, "body:=",&writer_ast_body_1489, 0);
  reader1489->definitionModule = modulename;
  writer1489->definitionModule = modulename;
  reader1489->definitionLine = 292;
  writer1489->definitionLine = 292;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 4);
if (objclass1484 == NULL) {
  Method *reader1490 = addmethodrealflags(obj1484, "selfclosure",&reader_ast_selfclosure_1490, MFLAG_DEF);
  reader1490->definitionModule = modulename;
  reader1490->definitionLine = 293;
}
adddatum2(obj1484, alloc_Undefined(), 5);
if (objclass1484 == NULL) {
  Method *reader1491 = addmethodrealflags(obj1484, "matchingPattern",&reader_ast_matchingPattern_1491, 0);
  Method *writer1491 = addmethodrealflags(obj1484, "matchingPattern:=",&writer_ast_matchingPattern_1491, 0);
  reader1491->definitionModule = modulename;
  writer1491->definitionModule = modulename;
  reader1491->definitionLine = 294;
  writer1491->definitionLine = 294;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 6);
if (objclass1484 == NULL) {
  Method *reader1492 = addmethodrealflags(obj1484, "extraRuntimeData",&reader_ast_extraRuntimeData_1492, 0);
  Method *writer1492 = addmethodrealflags(obj1484, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1492, 0);
  reader1492->definitionModule = modulename;
  writer1492->definitionModule = modulename;
  reader1492->definitionLine = 295;
  writer1492->definitionLine = 295;
}
obj1484->flags |= OFLAG_MUTABLE;
adddatum2(obj1484, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1493 = (struct UserObject*)obj1484;
  uo1493->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1493 = addmethod2pos(obj1484, "isBlock", &meth_ast_isBlock1493, 8);
  int argcv_meth_ast_isBlock1493[] = {0};
  meth_meth_ast_isBlock1493->type = alloc_MethodType(1, argcv_meth_ast_isBlock1493);
  meth_meth_ast_isBlock1493->definitionModule = modulename;
  meth_meth_ast_isBlock1493->definitionLine = 299;
// method "isEmpty"
  struct UserObject *uo1495 = (struct UserObject*)obj1484;
  uo1495->data[9] = emptyclosure;
  Method *meth_meth_ast_isEmpty1495 = addmethod2pos(obj1484, "isEmpty", &meth_ast_isEmpty1495, 9);
  int argcv_meth_ast_isEmpty1495[] = {0};
  meth_meth_ast_isEmpty1495->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1495);
  meth_meth_ast_isEmpty1495->definitionModule = modulename;
  meth_meth_ast_isEmpty1495->definitionLine = 300;
// method "isntEmpty"
  struct UserObject *uo1504 = (struct UserObject*)obj1484;
  uo1504->data[10] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1504 = addmethod2pos(obj1484, "isntEmpty", &meth_ast_isntEmpty1504, 10);
  int argcv_meth_ast_isntEmpty1504[] = {0};
  meth_meth_ast_isntEmpty1504->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1504);
  meth_meth_ast_isntEmpty1504->definitionModule = modulename;
  meth_meth_ast_isntEmpty1504->definitionLine = 301;
// method "scope:="
  struct UserObject *uo1513 = (struct UserObject*)obj1484;
  uo1513->data[11] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_1513 = addmethod2pos(obj1484, "scope:=", &meth_ast_scope_58__61_1513, 11);
  int argcv_meth_ast_scope_58__61_1513[] = {1};
  meth_meth_ast_scope_58__61_1513->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_1513);
  meth_meth_ast_scope_58__61_1513->definitionModule = modulename;
  meth_meth_ast_scope_58__61_1513->definitionLine = 302;
// method "declarationKindWithAncestors"
  block_savedest(obj1484);
  Object closure1518 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure1518, stackframe);
  addtoclosure(closure1518, var_k);
  struct UserObject *uo1518 = (struct UserObject*)obj1484;
  uo1518->data[12] = (Object)closure1518;
  Method *meth_meth_ast_declarationKindWithAncestors1518 = addmethod2pos(obj1484, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors1518, 12);
  int argcv_meth_ast_declarationKindWithAncestors1518[] = {1};
  meth_meth_ast_declarationKindWithAncestors1518->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors1518);
  meth_meth_ast_declarationKindWithAncestors1518->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors1518->definitionLine = 308;
// method "isMatchingBlock"
  struct UserObject *uo1521 = (struct UserObject*)obj1484;
  uo1521->data[13] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1521 = addmethod2pos(obj1484, "isMatchingBlock", &meth_ast_isMatchingBlock1521, 13);
  int argcv_meth_ast_isMatchingBlock1521[] = {0};
  meth_meth_ast_isMatchingBlock1521->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1521);
  meth_meth_ast_isMatchingBlock1521->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1521->definitionLine = 309;
// method "returnsObject"
  struct UserObject *uo1530 = (struct UserObject*)obj1484;
  uo1530->data[14] = emptyclosure;
  Method *meth_meth_ast_returnsObject1530 = addmethod2pos(obj1484, "returnsObject", &meth_ast_returnsObject1530, 14);
  int argcv_meth_ast_returnsObject1530[] = {0};
  meth_meth_ast_returnsObject1530->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1530);
  meth_meth_ast_returnsObject1530->definitionModule = modulename;
  meth_meth_ast_returnsObject1530->definitionLine = 310;
// method "returnedObjectScope"
  struct UserObject *uo1550 = (struct UserObject*)obj1484;
  uo1550->data[15] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1550 = addmethod2pos(obj1484, "returnedObjectScope", &meth_ast_returnedObjectScope1550, 15);
  int argcv_meth_ast_returnedObjectScope1550[] = {0};
  meth_meth_ast_returnedObjectScope1550->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1550);
  meth_meth_ast_returnedObjectScope1550->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1550->definitionLine = 313;
// method "parametersDo"
  struct UserObject *uo1557 = (struct UserObject*)obj1484;
  uo1557->data[16] = emptyclosure;
  Method *meth_meth_ast_parametersDo1557 = addmethod2pos(obj1484, "parametersDo", &meth_ast_parametersDo1557, 16);
  int argcv_meth_ast_parametersDo1557[] = {1};
  meth_meth_ast_parametersDo1557->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1557);
  meth_meth_ast_parametersDo1557->definitionModule = modulename;
  meth_meth_ast_parametersDo1557->definitionLine = 317;
// method "accept()from"
  struct UserObject *uo1562 = (struct UserObject*)obj1484;
  uo1562->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1562 = addmethod2pos(obj1484, "accept()from", &meth_ast_accept_40__41_from1562, 17);
  int argcv_meth_ast_accept_40__41_from1562[] = {1, 1};
  meth_meth_ast_accept_40__41_from1562->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1562);
  meth_meth_ast_accept_40__41_from1562->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1562->definitionLine = 320;
// method "map()ancestors"
  struct UserObject *uo1597 = (struct UserObject*)obj1484;
  uo1597->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1597 = addmethod2pos(obj1484, "map()ancestors", &meth_ast_map_40__41_ancestors1597, 18);
  int argcv_meth_ast_map_40__41_ancestors1597[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1597->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1597);
  meth_meth_ast_map_40__41_ancestors1597->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1597->definitionLine = 334;
// method "pretty"
  struct UserObject *uo1634 = (struct UserObject*)obj1484;
  uo1634->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty1634 = addmethod2pos(obj1484, "pretty", &meth_ast_pretty1634, 19);
  int argcv_meth_ast_pretty1634[] = {1};
  meth_meth_ast_pretty1634->type = alloc_MethodType(1, argcv_meth_ast_pretty1634);
  meth_meth_ast_pretty1634->definitionModule = modulename;
  meth_meth_ast_pretty1634->definitionLine = 342;
// method "toGrace"
  struct UserObject *uo1764 = (struct UserObject*)obj1484;
  uo1764->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace1764 = addmethod2pos(obj1484, "toGrace", &meth_ast_toGrace1764, 20);
  int argcv_meth_ast_toGrace1764[] = {1};
  meth_meth_ast_toGrace1764->type = alloc_MethodType(1, argcv_meth_ast_toGrace1764);
meth_meth_ast_toGrace1764->type->types[0] = type_Number;
meth_meth_ast_toGrace1764->type->names[0] = "depth";
  meth_meth_ast_toGrace1764->definitionModule = modulename;
  meth_meth_ast_toGrace1764->definitionLine = 364;
// method "shallowCopy"
  block_savedest(obj1484);
  Object closure1898 = createclosure(1, "shallowCopy");
  setclosureframe(closure1898, stackframe);
  addtoclosure(closure1898, var_blockNode);
  struct UserObject *uo1898 = (struct UserObject*)obj1484;
  uo1898->data[21] = (Object)closure1898;
  Method *meth_meth_ast_shallowCopy1898 = addmethod2pos(obj1484, "shallowCopy", &meth_ast_shallowCopy1898, 21);
  int argcv_meth_ast_shallowCopy1898[] = {0};
  meth_meth_ast_shallowCopy1898->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1898);
  meth_meth_ast_shallowCopy1898->definitionModule = modulename;
  meth_meth_ast_shallowCopy1898->definitionLine = 392;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1907 = (struct UserObject*)obj1484;
  uo1907->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1907 = addmethod2pos(obj1484, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1907, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom1907[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1907->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1907);
  meth_meth_ast_shallowCopyFieldsFrom1907->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1907->definitionLine = 395;
  sourceObject = obj1484;
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1918 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1919 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1920 = gc_frame_new();
// call case 3: self.outer request
  Object call1921 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1920);
// compiled call node returning call1921 (depth = 7)
// compiled member node returning call1921 (depth = 6)
  partcv[0] = 0;
  Object call1922 = callmethodflags(call1921, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1919);
// compiled call node returning call1922 (depth = 5)
// compiled member node returning call1922 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1923 = callmethodflags(call1922, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1918);
// compiled call node returning call1923 (depth = 3)
  struct UserObject *obj1484_uo = (struct UserObject *)obj1484;
  obj1484_uo->super = call1923;
  sourceObject = obj1484;
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1924 == NULL) {
    strlit1924 = alloc_String("block");
    gc_root(strlit1924);
  }
// compiled string node returning strlit1924 (depth = 3)
  adddatum2(obj1484, strlit1924, 1);
  sourceObject = obj1484;
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1925 == NULL) {
    strlit1925 = alloc_String("block");
    gc_root(strlit1925);
  }
// compiled string node returning strlit1925 (depth = 3)
  adddatum2(obj1484, strlit1925, 2);
  sourceObject = obj1484;
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1484, *var_params_39_, 3);
  sourceObject = obj1484;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1484, *var_body_39_, 4);
  sourceObject = obj1484;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1926 = alloc_Boolean(1);
// compiled identifier node returning bool1926 (depth = 3)
  adddatum2(obj1484, bool1926, 5);
  sourceObject = obj1484;
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1927 = alloc_Boolean(0);
// compiled identifier node returning bool1927 (depth = 3)
  adddatum2(obj1484, bool1927, 6);
  sourceObject = obj1484;
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1928 = alloc_Boolean(0);
// compiled identifier node returning bool1928 (depth = 3)
  adddatum2(obj1484, bool1928, 7);
  sourceObject = obj1484;
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1929 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block1930 = alloc_Block(NULL, NULL, "ast", 296);
  gc_frame_newslot(block1930);
// method "_apply"
  block_savedest(block1930);
  Object closure1931 = createclosure(3, "_apply");
  setclosureframe(closure1931, stackframe);
  addtoclosure(closure1931, var_patternMarkVisitor);
  addtoclosure(closure1931, var_ancestorChain);
  addtoclosure(closure1931, selfslot);
  struct UserObject *uo1931 = (struct UserObject*)block1930;
  uo1931->data[0] = (Object)closure1931;
  Method *meth_meth_ast__apply1931 = addmethod2pos(block1930, "_apply", &meth_ast__apply1931, 0);
  int argcv_meth_ast__apply1931[] = {1};
  meth_meth_ast__apply1931->type = alloc_MethodType(1, argcv_meth_ast__apply1931);
  meth_meth_ast__apply1931->definitionModule = modulename;
  meth_meth_ast__apply1931->definitionLine = 288;
// compiled block node returning block1930 (depth = 4)
  gc_frame_newslot(block1930);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1930;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1937 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled call node returning call1937 (depth = 3)
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  sourceObject = obj1484;
  objclass1484 = obj1484->class;
  objclass1484->definitionModule = modulename;
  objclass1484->definitionLine = 287;
  (*(struct UserObject *)self).data[0] = lowerouter1484;
  self = oldself1484;
  selfslot = oldselfslot1484;
  stackframe = oldstackframe1484;
  gc_frame_end(frame);
  return obj1484;
}
Object meth_ast_blockNode1939(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blockNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blockNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_isSimple1949(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1950 = alloc_Boolean(0);
// compiled identifier node returning bool1950 (depth = 3)
  gc_frame_end(frame);
  return bool1950;
}
Object meth_ast__apply1965(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1966 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1967 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1966);
// compiled call node returning call1967 (depth = 6)
  gc_frame_end(frame);
  return call1967;
}
Object meth_ast_accept_40__41_from1951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1953 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1954 = callmethod(*var_visitor, "visitTryCatch()up",
    2, partcv, params);
  gc_frame_end(callframe1953);
// compiled call node returning call1954 (depth = 4)
  Object if1952 = done;
  if (istrue(call1954)) {
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1955 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1956 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1955);
// compiled call node returning call1956 (depth = 5)
  *var_newChain = call1956;
  if (call1956 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1957 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1958 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1959 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1958);
// compiled call node returning call1959 (depth = 6)
// compiled member node returning call1959 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1960 = callmethod(call1959, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1957);
// compiled call node returning call1960 (depth = 4)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1961 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1962 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1963 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1962);
// compiled call node returning call1963 (depth = 6)
// compiled member node returning call1963 (depth = 5)
  gc_frame_newslot(call1963);
// starting to compile block node (depth = 5)
  Object block1964 = alloc_Block(NULL, NULL, "ast", 416);
  gc_frame_newslot(block1964);
// method "_apply"
  block_savedest(block1964);
  Object closure1965 = createclosure(3, "_apply");
  setclosureframe(closure1965, stackframe);
  addtoclosure(closure1965, var_visitor);
  addtoclosure(closure1965, var_newChain);
  addtoclosure(closure1965, selfslot);
  struct UserObject *uo1965 = (struct UserObject*)block1964;
  uo1965->data[0] = (Object)closure1965;
  Method *meth_meth_ast__apply1965 = addmethod2pos(block1964, "_apply", &meth_ast__apply1965, 0);
  int argcv_meth_ast__apply1965[] = {1};
  meth_meth_ast__apply1965->type = alloc_MethodType(1, argcv_meth_ast__apply1965);
  meth_meth_ast__apply1965->definitionModule = modulename;
  meth_meth_ast__apply1965->definitionLine = 416;
// compiled block node returning block1964 (depth = 5)
  gc_frame_newslot(block1964);
// call case 5: prelude request
  params[0] = call1963;
  params[1] = block1964;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1969 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1961);
// compiled call node returning call1969 (depth = 4)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1972 = alloc_Boolean(0);
// compiled identifier node returning bool1972 (depth = 6)
  int op_slot_right_1971 = gc_frame_newslot(bool1972);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1974 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1975 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1974);
// compiled call node returning call1975 (depth = 7)
// compiled member node returning call1975 (depth = 6)
  int op_slot_left_1971 = gc_frame_newslot(call1975);
  params[0] = bool1972;
  partcv[0] = 1;
  Object opresult1976 = callmethod(call1975, "!=", 1, partcv, params);
// compiled op node returning opresult1976 (depth = 5)
  Object if1970 = done;
  if (istrue(opresult1976)) {
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1977 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1979 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1978);
// compiled call node returning call1979 (depth = 7)
// compiled member node returning call1979 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1980 = callmethod(call1979, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1977);
// compiled call node returning call1980 (depth = 5)
    gc_frame_newslot(call1980);
    if1970 = call1980;
  } else {
  }
// compiled if node returning if1970 (depth = 4)
    gc_frame_newslot(if1970);
    if1952 = if1970;
  } else {
  }
// compiled if node returning if1952 (depth = 3)
  gc_frame_end(frame);
  return if1952;
}
Object meth_ast_map_40__41_ancestors1981(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1982 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1983 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1982);
// compiled call node returning call1983 (depth = 5)
// compiled member node returning call1983 (depth = 4)
  *var_n = call1983;
  if (call1983 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1984 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1985 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1984);
// compiled call node returning call1985 (depth = 4)
  *var_newChain = call1985;
  if (call1985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1986 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1987 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1989 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1988);
// compiled call node returning call1989 (depth = 6)
// compiled member node returning call1989 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1990 = callmethod(call1989, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1987);
// compiled call node returning call1990 (depth = 4)
  gc_frame_newslot(call1990);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1990;
  partcv[0] = 1;
  Object call1991 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1986);
// compiled call node returning call1991 (depth = 3)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1992 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1993 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1995 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1994);
// compiled call node returning call1995 (depth = 6)
// compiled member node returning call1995 (depth = 5)
  gc_frame_newslot(call1995);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1996 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1997 = gc_frame_new();
// call case 3: self.outer request
  Object call1998 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1997);
// compiled call node returning call1998 (depth = 8)
// compiled member node returning call1998 (depth = 7)
  partcv[0] = 0;
  Object call1999 = callmethodflags(call1998, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1996);
// compiled call node returning call1999 (depth = 6)
// compiled member node returning call1999 (depth = 5)
  params[0] = call1995;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2000 = callmethodflags(call1999, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled call node returning call2000 (depth = 4)
  gc_frame_newslot(call2000);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2000;
  partcv[0] = 1;
  Object call2001 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe1992);
// compiled call node returning call2001 (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2002 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2003 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2004 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2005 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2004);
// compiled call node returning call2005 (depth = 6)
// compiled member node returning call2005 (depth = 5)
  gc_frame_newslot(call2005);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2006 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2007 = gc_frame_new();
// call case 3: self.outer request
  Object call2008 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2007);
// compiled call node returning call2008 (depth = 8)
// compiled member node returning call2008 (depth = 7)
  partcv[0] = 0;
  Object call2009 = callmethodflags(call2008, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2006);
// compiled call node returning call2009 (depth = 6)
// compiled member node returning call2009 (depth = 5)
  params[0] = call2005;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2010 = callmethodflags(call2009, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2003);
// compiled call node returning call2010 (depth = 4)
  gc_frame_newslot(call2010);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2010;
  partcv[0] = 1;
  Object call2011 = callmethod(*var_n, "finally:=",
    1, partcv, params);
  gc_frame_end(callframe2002);
// compiled call node returning call2011 (depth = 3)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2012 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2013 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2012);
// compiled call node returning call2013 (depth = 3)
  gc_frame_end(frame);
  return call2013;
}
Object meth_ast__apply2022(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2024 == NULL) {
    strlit2024 = alloc_String("  ");
    gc_root(strlit2024);
  }
// compiled string node returning strlit2024 (depth = 7)
  int op_slot_right_2023 = gc_frame_newslot(strlit2024);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2023 = gc_frame_newslot(*var_spc);
  params[0] = strlit2024;
  partcv[0] = 1;
  Object opresult2026 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2026 (depth = 6)
  *var_spc = opresult2026;
  if (opresult2026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2059(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2062 == NULL) {
    strlit2062 = alloc_String("");
    gc_root(strlit2062);
  }
// compiled string node returning strlit2062 (depth = 8)
  int op_slot_right_2061 = gc_frame_newslot(strlit2062);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2065 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2067 = alloc_Float64(2);
// compiled num node returning num2067 (depth = 11)
  int op_slot_right_2066 = gc_frame_newslot(num2067);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2066 = gc_frame_newslot(*var_depth);
  params[0] = num2067;
  partcv[0] = 1;
  Object sum2069 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2069 (depth = 10)
  gc_frame_newslot(sum2069);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2069;
  partcv[0] = 1;
  Object call2070 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2065);
// compiled call node returning call2070 (depth = 9)
  int op_slot_right_2064 = gc_frame_newslot(call2070);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2073 == NULL) {
    strlit2073 = alloc_String("  ");
    gc_root(strlit2073);
  }
// compiled string node returning strlit2073 (depth = 10)
  int op_slot_right_2072 = gc_frame_newslot(strlit2073);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2075 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2078 == NULL) {
    strlit2078 = alloc_String("Case:""\x0a""");
    gc_root(strlit2078);
  }
// compiled string node returning strlit2078 (depth = 12)
  int op_slot_right_2077 = gc_frame_newslot(strlit2078);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2080 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2082 == NULL) {
    strlit2082 = alloc_String("""\x0a""");
    gc_root(strlit2082);
  }
// compiled string node returning strlit2082 (depth = 13)
  int op_slot_left_2080 = gc_frame_newslot(strlit2082);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2083 = callmethod(strlit2082, "++", 1, partcv, params);
// compiled op node returning opresult2083 (depth = 12)
  int op_slot_left_2077 = gc_frame_newslot(opresult2083);
  params[0] = strlit2078;
  partcv[0] = 1;
  Object opresult2084 = callmethod(opresult2083, "++", 1, partcv, params);
// compiled op node returning opresult2084 (depth = 11)
  int op_slot_left_2075 = gc_frame_newslot(opresult2084);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2085 = callmethod(opresult2084, "++", 1, partcv, params);
// compiled op node returning opresult2085 (depth = 10)
  int op_slot_left_2072 = gc_frame_newslot(opresult2085);
  params[0] = strlit2073;
  partcv[0] = 1;
  Object opresult2086 = callmethod(opresult2085, "++", 1, partcv, params);
// compiled op node returning opresult2086 (depth = 9)
  int op_slot_left_2064 = gc_frame_newslot(opresult2086);
  params[0] = call2070;
  partcv[0] = 1;
  Object opresult2087 = callmethod(opresult2086, "++", 1, partcv, params);
// compiled op node returning opresult2087 (depth = 8)
  int op_slot_left_2061 = gc_frame_newslot(opresult2087);
  params[0] = strlit2062;
  partcv[0] = 1;
  Object opresult2088 = callmethod(opresult2087, "++", 1, partcv, params);
// compiled op node returning opresult2088 (depth = 7)
  int op_slot_right_2060 = gc_frame_newslot(opresult2088);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2060 = gc_frame_newslot(*var_s);
  params[0] = opresult2088;
  partcv[0] = 1;
  Object opresult2090 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2090 (depth = 6)
  *var_s = opresult2090;
  if (opresult2090 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2015 == NULL) {
    strlit2015 = alloc_String("");
    gc_root(strlit2015);
  }
// compiled string node returning strlit2015 (depth = 4)
  *var_spc = strlit2015;
  if (strlit2015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2016 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2017 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2019 = alloc_Float64(0);
// compiled num node returning num2019 (depth = 5)
  int op_slot_left_2017 = gc_frame_newslot(num2019);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2020 = callmethod(num2019, "..", 1, partcv, params);
// compiled op node returning opresult2020 (depth = 4)
  gc_frame_newslot(opresult2020);
// starting to compile block node (depth = 4)
  Object block2021 = alloc_Block(NULL, NULL, "ast", 434);
  gc_frame_newslot(block2021);
// method "_apply"
  block_savedest(block2021);
  Object closure2022 = createclosure(2, "_apply");
  setclosureframe(closure2022, stackframe);
  addtoclosure(closure2022, var_spc);
  addtoclosure(closure2022, selfslot);
  struct UserObject *uo2022 = (struct UserObject*)block2021;
  uo2022->data[0] = (Object)closure2022;
  Method *meth_meth_ast__apply2022 = addmethod2pos(block2021, "_apply", &meth_ast__apply2022, 0);
  int argcv_meth_ast__apply2022[] = {1};
  meth_meth_ast__apply2022->type = alloc_MethodType(1, argcv_meth_ast__apply2022);
  meth_meth_ast__apply2022->definitionModule = modulename;
  meth_meth_ast__apply2022->definitionLine = 429;
// compiled block node returning block2021 (depth = 4)
  gc_frame_newslot(block2021);
// call case 5: prelude request
  params[0] = opresult2020;
  params[1] = block2021;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2029 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2016);
// compiled call node returning call2029 (depth = 3)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2031 == NULL) {
    strlit2031 = alloc_String("""\x0a""");
    gc_root(strlit2031);
  }
// compiled string node returning strlit2031 (depth = 5)
  int op_slot_right_2030 = gc_frame_newslot(strlit2031);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2034 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2035 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2034);
// compiled call node returning call2035 (depth = 6)
  int op_slot_right_2033 = gc_frame_newslot(call2035);
// starting to compile string node (depth = 6)
  if (strlit2037 == NULL) {
    strlit2037 = alloc_String("");
    gc_root(strlit2037);
  }
// compiled string node returning strlit2037 (depth = 6)
  int op_slot_left_2033 = gc_frame_newslot(strlit2037);
  params[0] = call2035;
  partcv[0] = 1;
  Object opresult2038 = callmethod(strlit2037, "++", 1, partcv, params);
// compiled op node returning opresult2038 (depth = 5)
  int op_slot_left_2030 = gc_frame_newslot(opresult2038);
  params[0] = strlit2031;
  partcv[0] = 1;
  Object opresult2039 = callmethod(opresult2038, "++", 1, partcv, params);
// compiled op node returning opresult2039 (depth = 4)
  *var_s = opresult2039;
  if (opresult2039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2041 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2043 = alloc_Float64(2);
// compiled num node returning num2043 (depth = 7)
  int op_slot_right_2042 = gc_frame_newslot(num2043);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2042 = gc_frame_newslot(*var_depth);
  params[0] = num2043;
  partcv[0] = 1;
  Object sum2045 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2045 (depth = 6)
  gc_frame_newslot(sum2045);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2047 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2046);
// compiled call node returning call2047 (depth = 7)
// compiled member node returning call2047 (depth = 6)
  params[0] = sum2045;
  partcv[0] = 1;
  Object call2048 = callmethod(call2047, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2041);
// compiled call node returning call2048 (depth = 5)
  int op_slot_right_2040 = gc_frame_newslot(call2048);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2050 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2050 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2052 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2052 (depth = 5)
  int op_slot_left_2040 = gc_frame_newslot(opresult2052);
  params[0] = call2048;
  partcv[0] = 1;
  Object opresult2053 = callmethod(opresult2052, "++", 1, partcv, params);
// compiled op node returning opresult2053 (depth = 4)
  *var_s = opresult2053;
  if (opresult2053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2055 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2056 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2057 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2056);
// compiled call node returning call2057 (depth = 5)
// compiled member node returning call2057 (depth = 4)
  gc_frame_newslot(call2057);
// starting to compile block node (depth = 4)
  Object block2058 = alloc_Block(NULL, NULL, "ast", 439);
  gc_frame_newslot(block2058);
// method "_apply"
  block_savedest(block2058);
  Object closure2059 = createclosure(4, "_apply");
  setclosureframe(closure2059, stackframe);
  addtoclosure(closure2059, var_depth);
  addtoclosure(closure2059, var_spc);
  addtoclosure(closure2059, var_s);
  addtoclosure(closure2059, selfslot);
  struct UserObject *uo2059 = (struct UserObject*)block2058;
  uo2059->data[0] = (Object)closure2059;
  Method *meth_meth_ast__apply2059 = addmethod2pos(block2058, "_apply", &meth_ast__apply2059, 0);
  int argcv_meth_ast__apply2059[] = {1};
  meth_meth_ast__apply2059->type = alloc_MethodType(1, argcv_meth_ast__apply2059);
  meth_meth_ast__apply2059->definitionModule = modulename;
  meth_meth_ast__apply2059->definitionLine = 439;
// compiled block node returning block2058 (depth = 4)
  gc_frame_newslot(block2058);
// call case 5: prelude request
  params[0] = call2057;
  params[1] = block2058;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2093 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2055);
// compiled call node returning call2093 (depth = 3)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2096 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2097 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2096);
// compiled call node returning call2097 (depth = 6)
// compiled member node returning call2097 (depth = 5)
  int op_slot_right_2095 = gc_frame_newslot(call2097);
// starting to compile identifier node (depth = 5)
  Object bool2099 = alloc_Boolean(0);
// compiled identifier node returning bool2099 (depth = 5)
  int op_slot_left_2095 = gc_frame_newslot(bool2099);
  params[0] = call2097;
  partcv[0] = 1;
  Object opresult2100 = callmethod(bool2099, "!=", 1, partcv, params);
// compiled op node returning opresult2100 (depth = 4)
  Object if2094 = done;
  if (istrue(opresult2100)) {
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2103 == NULL) {
    strlit2103 = alloc_String("");
    gc_root(strlit2103);
  }
// compiled string node returning strlit2103 (depth = 7)
  int op_slot_right_2102 = gc_frame_newslot(strlit2103);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2106 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2108 = alloc_Float64(2);
// compiled num node returning num2108 (depth = 10)
  int op_slot_right_2107 = gc_frame_newslot(num2108);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2107 = gc_frame_newslot(*var_depth);
  params[0] = num2108;
  partcv[0] = 1;
  Object sum2110 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2110 (depth = 9)
  gc_frame_newslot(sum2110);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2112 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2111);
// compiled call node returning call2112 (depth = 10)
// compiled member node returning call2112 (depth = 9)
  params[0] = sum2110;
  partcv[0] = 1;
  Object call2113 = callmethod(call2112, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2106);
// compiled call node returning call2113 (depth = 8)
  int op_slot_right_2105 = gc_frame_newslot(call2113);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2116 == NULL) {
    strlit2116 = alloc_String("  ");
    gc_root(strlit2116);
  }
// compiled string node returning strlit2116 (depth = 9)
  int op_slot_right_2115 = gc_frame_newslot(strlit2116);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2118 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2121 == NULL) {
    strlit2121 = alloc_String("Finally:""\x0a""");
    gc_root(strlit2121);
  }
// compiled string node returning strlit2121 (depth = 11)
  int op_slot_right_2120 = gc_frame_newslot(strlit2121);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2123 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2125 == NULL) {
    strlit2125 = alloc_String("""\x0a""");
    gc_root(strlit2125);
  }
// compiled string node returning strlit2125 (depth = 12)
  int op_slot_left_2123 = gc_frame_newslot(strlit2125);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2126 = callmethod(strlit2125, "++", 1, partcv, params);
// compiled op node returning opresult2126 (depth = 11)
  int op_slot_left_2120 = gc_frame_newslot(opresult2126);
  params[0] = strlit2121;
  partcv[0] = 1;
  Object opresult2127 = callmethod(opresult2126, "++", 1, partcv, params);
// compiled op node returning opresult2127 (depth = 10)
  int op_slot_left_2118 = gc_frame_newslot(opresult2127);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2128 = callmethod(opresult2127, "++", 1, partcv, params);
// compiled op node returning opresult2128 (depth = 9)
  int op_slot_left_2115 = gc_frame_newslot(opresult2128);
  params[0] = strlit2116;
  partcv[0] = 1;
  Object opresult2129 = callmethod(opresult2128, "++", 1, partcv, params);
// compiled op node returning opresult2129 (depth = 8)
  int op_slot_left_2105 = gc_frame_newslot(opresult2129);
  params[0] = call2113;
  partcv[0] = 1;
  Object opresult2130 = callmethod(opresult2129, "++", 1, partcv, params);
// compiled op node returning opresult2130 (depth = 7)
  int op_slot_left_2102 = gc_frame_newslot(opresult2130);
  params[0] = strlit2103;
  partcv[0] = 1;
  Object opresult2131 = callmethod(opresult2130, "++", 1, partcv, params);
// compiled op node returning opresult2131 (depth = 6)
  int op_slot_right_2101 = gc_frame_newslot(opresult2131);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2101 = gc_frame_newslot(*var_s);
  params[0] = opresult2131;
  partcv[0] = 1;
  Object opresult2133 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2133 (depth = 5)
  *var_s = opresult2133;
  if (opresult2133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2094 = done;
  } else {
  }
// compiled if node returning if2094 (depth = 3)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2147(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2149 == NULL) {
    strlit2149 = alloc_String("    ");
    gc_root(strlit2149);
  }
// compiled string node returning strlit2149 (depth = 7)
  int op_slot_right_2148 = gc_frame_newslot(strlit2149);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2148 = gc_frame_newslot(*var_spc);
  params[0] = strlit2149;
  partcv[0] = 1;
  Object opresult2151 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2151 (depth = 6)
  *var_spc = opresult2151;
  if (opresult2151 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2175(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2177 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2179 = alloc_Float64(1);
// compiled num node returning num2179 (depth = 9)
  int op_slot_right_2178 = gc_frame_newslot(num2179);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2178 = gc_frame_newslot(*var_depth);
  params[0] = num2179;
  partcv[0] = 1;
  Object sum2181 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2181 (depth = 8)
  gc_frame_newslot(sum2181);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2181;
  partcv[0] = 1;
  Object call2182 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2177);
// compiled call node returning call2182 (depth = 7)
  int op_slot_right_2176 = gc_frame_newslot(call2182);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2185 == NULL) {
    strlit2185 = alloc_String("catch ");
    gc_root(strlit2185);
  }
// compiled string node returning strlit2185 (depth = 8)
  int op_slot_right_2184 = gc_frame_newslot(strlit2185);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2188 == NULL) {
    strlit2188 = alloc_String("    ");
    gc_root(strlit2188);
  }
// compiled string node returning strlit2188 (depth = 9)
  int op_slot_right_2187 = gc_frame_newslot(strlit2188);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2190 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2193 == NULL) {
    strlit2193 = alloc_String("""\x0a""");
    gc_root(strlit2193);
  }
// compiled string node returning strlit2193 (depth = 11)
  int op_slot_right_2192 = gc_frame_newslot(strlit2193);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2192 = gc_frame_newslot(*var_s);
  params[0] = strlit2193;
  partcv[0] = 1;
  Object opresult2195 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2195 (depth = 10)
  int op_slot_left_2190 = gc_frame_newslot(opresult2195);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2196 = callmethod(opresult2195, "++", 1, partcv, params);
// compiled op node returning opresult2196 (depth = 9)
  int op_slot_left_2187 = gc_frame_newslot(opresult2196);
  params[0] = strlit2188;
  partcv[0] = 1;
  Object opresult2197 = callmethod(opresult2196, "++", 1, partcv, params);
// compiled op node returning opresult2197 (depth = 8)
  int op_slot_left_2184 = gc_frame_newslot(opresult2197);
  params[0] = strlit2185;
  partcv[0] = 1;
  Object opresult2198 = callmethod(opresult2197, "++", 1, partcv, params);
// compiled op node returning opresult2198 (depth = 7)
  int op_slot_left_2176 = gc_frame_newslot(opresult2198);
  params[0] = call2182;
  partcv[0] = 1;
  Object opresult2199 = callmethod(opresult2198, "++", 1, partcv, params);
// compiled op node returning opresult2199 (depth = 6)
  *var_s = opresult2199;
  if (opresult2199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2135(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2136 == NULL) {
    strlit2136 = alloc_String("");
    gc_root(strlit2136);
  }
// compiled string node returning strlit2136 (depth = 4)
  *var_spc = strlit2136;
  if (strlit2136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2137 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2140 = alloc_Float64(1);
// compiled num node returning num2140 (depth = 6)
  int op_slot_right_2139 = gc_frame_newslot(num2140);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2139 = gc_frame_newslot(*var_depth);
  params[0] = num2140;
  partcv[0] = 1;
  Object diff2142 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2142 (depth = 5)
  int op_slot_right_2138 = gc_frame_newslot(diff2142);
// starting to compile num node (depth = 5)
  Object num2144 = alloc_Float64(0);
// compiled num node returning num2144 (depth = 5)
  int op_slot_left_2138 = gc_frame_newslot(num2144);
  params[0] = diff2142;
  partcv[0] = 1;
  Object opresult2145 = callmethod(num2144, "..", 1, partcv, params);
// compiled op node returning opresult2145 (depth = 4)
  gc_frame_newslot(opresult2145);
// starting to compile block node (depth = 4)
  Object block2146 = alloc_Block(NULL, NULL, "ast", 449);
  gc_frame_newslot(block2146);
// method "_apply"
  block_savedest(block2146);
  Object closure2147 = createclosure(2, "_apply");
  setclosureframe(closure2147, stackframe);
  addtoclosure(closure2147, var_spc);
  addtoclosure(closure2147, selfslot);
  struct UserObject *uo2147 = (struct UserObject*)block2146;
  uo2147->data[0] = (Object)closure2147;
  Method *meth_meth_ast__apply2147 = addmethod2pos(block2146, "_apply", &meth_ast__apply2147, 0);
  int argcv_meth_ast__apply2147[] = {1};
  meth_meth_ast__apply2147->type = alloc_MethodType(1, argcv_meth_ast__apply2147);
  meth_meth_ast__apply2147->definitionModule = modulename;
  meth_meth_ast__apply2147->definitionLine = 443;
// compiled block node returning block2146 (depth = 4)
  gc_frame_newslot(block2146);
// call case 5: prelude request
  params[0] = opresult2145;
  params[1] = block2146;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2154 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2137);
// compiled call node returning call2154 (depth = 3)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2156 == NULL) {
    strlit2156 = alloc_String(" ");
    gc_root(strlit2156);
  }
// compiled string node returning strlit2156 (depth = 5)
  int op_slot_right_2155 = gc_frame_newslot(strlit2156);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2159 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2161 = alloc_Float64(1);
// compiled num node returning num2161 (depth = 8)
  int op_slot_right_2160 = gc_frame_newslot(num2161);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2160 = gc_frame_newslot(*var_depth);
  params[0] = num2161;
  partcv[0] = 1;
  Object sum2163 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2163 (depth = 7)
  gc_frame_newslot(sum2163);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2165 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2164);
// compiled call node returning call2165 (depth = 8)
// compiled member node returning call2165 (depth = 7)
  params[0] = sum2163;
  partcv[0] = 1;
  Object call2166 = callmethod(call2165, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2159);
// compiled call node returning call2166 (depth = 6)
  int op_slot_right_2158 = gc_frame_newslot(call2166);
// starting to compile string node (depth = 6)
  if (strlit2168 == NULL) {
    strlit2168 = alloc_String("try ");
    gc_root(strlit2168);
  }
// compiled string node returning strlit2168 (depth = 6)
  int op_slot_left_2158 = gc_frame_newslot(strlit2168);
  params[0] = call2166;
  partcv[0] = 1;
  Object opresult2169 = callmethod(strlit2168, "++", 1, partcv, params);
// compiled op node returning opresult2169 (depth = 5)
  int op_slot_left_2155 = gc_frame_newslot(opresult2169);
  params[0] = strlit2156;
  partcv[0] = 1;
  Object opresult2170 = callmethod(opresult2169, "++", 1, partcv, params);
// compiled op node returning opresult2170 (depth = 4)
  *var_s = opresult2170;
  if (opresult2170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2171 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2172 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2173 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2172);
// compiled call node returning call2173 (depth = 5)
// compiled member node returning call2173 (depth = 4)
  gc_frame_newslot(call2173);
// starting to compile block node (depth = 4)
  Object block2174 = alloc_Block(NULL, NULL, "ast", 453);
  gc_frame_newslot(block2174);
// method "_apply"
  block_savedest(block2174);
  Object closure2175 = createclosure(4, "_apply");
  setclosureframe(closure2175, stackframe);
  addtoclosure(closure2175, var_depth);
  addtoclosure(closure2175, var_spc);
  addtoclosure(closure2175, var_s);
  addtoclosure(closure2175, selfslot);
  struct UserObject *uo2175 = (struct UserObject*)block2174;
  uo2175->data[0] = (Object)closure2175;
  Method *meth_meth_ast__apply2175 = addmethod2pos(block2174, "_apply", &meth_ast__apply2175, 0);
  int argcv_meth_ast__apply2175[] = {1};
  meth_meth_ast__apply2175->type = alloc_MethodType(1, argcv_meth_ast__apply2175);
  meth_meth_ast__apply2175->definitionModule = modulename;
  meth_meth_ast__apply2175->definitionLine = 453;
// compiled block node returning block2174 (depth = 4)
  gc_frame_newslot(block2174);
// call case 5: prelude request
  params[0] = call2173;
  params[1] = block2174;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2202 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2171);
// compiled call node returning call2202 (depth = 3)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2205 = alloc_Boolean(0);
// compiled identifier node returning bool2205 (depth = 5)
  int op_slot_right_2204 = gc_frame_newslot(bool2205);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2208 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2207);
// compiled call node returning call2208 (depth = 6)
// compiled member node returning call2208 (depth = 5)
  int op_slot_left_2204 = gc_frame_newslot(call2208);
  params[0] = bool2205;
  partcv[0] = 1;
  Object opresult2209 = callmethod(call2208, "!=", 1, partcv, params);
// compiled op node returning opresult2209 (depth = 4)
  Object if2203 = done;
  if (istrue(opresult2209)) {
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2211 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2213 = alloc_Float64(1);
// compiled num node returning num2213 (depth = 8)
  int op_slot_right_2212 = gc_frame_newslot(num2213);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2212 = gc_frame_newslot(*var_depth);
  params[0] = num2213;
  partcv[0] = 1;
  Object sum2215 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2215 (depth = 7)
  gc_frame_newslot(sum2215);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2217 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2216);
// compiled call node returning call2217 (depth = 8)
// compiled member node returning call2217 (depth = 7)
  params[0] = sum2215;
  partcv[0] = 1;
  Object call2218 = callmethod(call2217, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2211);
// compiled call node returning call2218 (depth = 6)
  int op_slot_right_2210 = gc_frame_newslot(call2218);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2221 == NULL) {
    strlit2221 = alloc_String("finally ");
    gc_root(strlit2221);
  }
// compiled string node returning strlit2221 (depth = 7)
  int op_slot_right_2220 = gc_frame_newslot(strlit2221);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2224 == NULL) {
    strlit2224 = alloc_String("    ");
    gc_root(strlit2224);
  }
// compiled string node returning strlit2224 (depth = 8)
  int op_slot_right_2223 = gc_frame_newslot(strlit2224);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2226 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2229 == NULL) {
    strlit2229 = alloc_String("""\x0a""");
    gc_root(strlit2229);
  }
// compiled string node returning strlit2229 (depth = 10)
  int op_slot_right_2228 = gc_frame_newslot(strlit2229);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2228 = gc_frame_newslot(*var_s);
  params[0] = strlit2229;
  partcv[0] = 1;
  Object opresult2231 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2231 (depth = 9)
  int op_slot_left_2226 = gc_frame_newslot(opresult2231);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2232 = callmethod(opresult2231, "++", 1, partcv, params);
// compiled op node returning opresult2232 (depth = 8)
  int op_slot_left_2223 = gc_frame_newslot(opresult2232);
  params[0] = strlit2224;
  partcv[0] = 1;
  Object opresult2233 = callmethod(opresult2232, "++", 1, partcv, params);
// compiled op node returning opresult2233 (depth = 7)
  int op_slot_left_2220 = gc_frame_newslot(opresult2233);
  params[0] = strlit2221;
  partcv[0] = 1;
  Object opresult2234 = callmethod(opresult2233, "++", 1, partcv, params);
// compiled op node returning opresult2234 (depth = 6)
  int op_slot_left_2210 = gc_frame_newslot(opresult2234);
  params[0] = call2218;
  partcv[0] = 1;
  Object opresult2235 = callmethod(opresult2234, "++", 1, partcv, params);
// compiled op node returning opresult2235 (depth = 5)
  *var_s = opresult2235;
  if (opresult2235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2203 = done;
  } else {
  }
// compiled if node returning if2203 (depth = 3)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2237(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2238 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2239 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2240 = alloc_Boolean(0);
// compiled identifier node returning bool2240 (depth = 5)
  gc_frame_newslot(bool2240);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryCatchNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2240;
  partcv[0] = 3;
  Object call2241 = callmethod(*var_tryCatchNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2239);
// compiled call node returning call2241 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2242 = callmethod(call2241, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2238);
// compiled call node returning call2242 (depth = 3)
  gc_frame_end(frame);
  return call2242;
}
Object meth_ast_new1942(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1943 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1943 = alloc_userobj2(13,11, objclass1943);
  gc_frame_newslot(obj1943);
if (objclass1943 == NULL) {
  glfree(obj1943->class->name);
  obj1943->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1943, self, 0);
  addmethodreal(obj1943,"outer", &reader_ast_outer_1944);
  Object oldself1943 = self;
  struct StackFrameObject *oldstackframe1943 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1943);
  gc_frame_newslot((Object)stackframe);
  self = obj1943;
  Object *oldselfslot1943 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1943 = (*(struct UserObject *)self).data[0], lowerouter1943 = thisouter1943;
  if (inheritingObject1943) {
    struct UserObject *inho1943 = (struct UserObject *)inheritingObject1943;
    while (inho1943->super != GraceDefaultObject) inho1943 = (struct UserObject *)inho1943->super;
    inho1943->super = obj1943;
    self = inheritingObject1943;
    *selfslot = self;
    lowerouter1943 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1943;
  }
if (objclass1943 == NULL) {
  Method *reader1945 = addmethodrealflags(obj1943, "kind",&reader_ast_kind_1945, MFLAG_DEF);
  reader1945->definitionModule = modulename;
  reader1945->definitionLine = 406;
}
adddatum2(obj1943, alloc_Undefined(), 1);
if (objclass1943 == NULL) {
  Method *reader1946 = addmethodrealflags(obj1943, "value",&reader_ast_value_1946, 0);
  Method *writer1946 = addmethodrealflags(obj1943, "value:=",&writer_ast_value_1946, 0);
  reader1946->definitionModule = modulename;
  writer1946->definitionModule = modulename;
  reader1946->definitionLine = 407;
  writer1946->definitionLine = 407;
}
obj1943->flags |= OFLAG_MUTABLE;
adddatum2(obj1943, alloc_Undefined(), 2);
if (objclass1943 == NULL) {
  Method *reader1947 = addmethodrealflags(obj1943, "cases",&reader_ast_cases_1947, 0);
  Method *writer1947 = addmethodrealflags(obj1943, "cases:=",&writer_ast_cases_1947, 0);
  reader1947->definitionModule = modulename;
  writer1947->definitionModule = modulename;
  reader1947->definitionLine = 408;
  writer1947->definitionLine = 408;
}
obj1943->flags |= OFLAG_MUTABLE;
adddatum2(obj1943, alloc_Undefined(), 3);
if (objclass1943 == NULL) {
  Method *reader1948 = addmethodrealflags(obj1943, "finally",&reader_ast_finally_1948, 0);
  Method *writer1948 = addmethodrealflags(obj1943, "finally:=",&writer_ast_finally_1948, 0);
  reader1948->definitionModule = modulename;
  writer1948->definitionModule = modulename;
  reader1948->definitionLine = 409;
  writer1948->definitionLine = 409;
}
obj1943->flags |= OFLAG_MUTABLE;
adddatum2(obj1943, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo1949 = (struct UserObject*)obj1943;
  uo1949->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple1949 = addmethod2pos(obj1943, "isSimple", &meth_ast_isSimple1949, 5);
  int argcv_meth_ast_isSimple1949[] = {0};
  meth_meth_ast_isSimple1949->type = alloc_MethodType(1, argcv_meth_ast_isSimple1949);
  meth_meth_ast_isSimple1949->definitionModule = modulename;
  meth_meth_ast_isSimple1949->definitionLine = 410;
// method "accept()from"
  struct UserObject *uo1951 = (struct UserObject*)obj1943;
  uo1951->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1951 = addmethod2pos(obj1943, "accept()from", &meth_ast_accept_40__41_from1951, 6);
  int argcv_meth_ast_accept_40__41_from1951[] = {1, 1};
  meth_meth_ast_accept_40__41_from1951->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1951);
  meth_meth_ast_accept_40__41_from1951->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1951->definitionLine = 412;
// method "map()ancestors"
  struct UserObject *uo1981 = (struct UserObject*)obj1943;
  uo1981->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1981 = addmethod2pos(obj1943, "map()ancestors", &meth_ast_map_40__41_ancestors1981, 7);
  int argcv_meth_ast_map_40__41_ancestors1981[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1981->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1981);
  meth_meth_ast_map_40__41_ancestors1981->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1981->definitionLine = 424;
// method "pretty"
  struct UserObject *uo2014 = (struct UserObject*)obj1943;
  uo2014->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty2014 = addmethod2pos(obj1943, "pretty", &meth_ast_pretty2014, 8);
  int argcv_meth_ast_pretty2014[] = {1};
  meth_meth_ast_pretty2014->type = alloc_MethodType(1, argcv_meth_ast_pretty2014);
  meth_meth_ast_pretty2014->definitionModule = modulename;
  meth_meth_ast_pretty2014->definitionLine = 432;
// method "toGrace"
  struct UserObject *uo2135 = (struct UserObject*)obj1943;
  uo2135->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace2135 = addmethod2pos(obj1943, "toGrace", &meth_ast_toGrace2135, 9);
  int argcv_meth_ast_toGrace2135[] = {1};
  meth_meth_ast_toGrace2135->type = alloc_MethodType(1, argcv_meth_ast_toGrace2135);
meth_meth_ast_toGrace2135->type->types[0] = type_Number;
meth_meth_ast_toGrace2135->type->names[0] = "depth";
  meth_meth_ast_toGrace2135->definitionModule = modulename;
  meth_meth_ast_toGrace2135->definitionLine = 447;
// method "shallowCopy"
  block_savedest(obj1943);
  Object closure2237 = createclosure(3, "shallowCopy");
  setclosureframe(closure2237, stackframe);
  addtoclosure(closure2237, var_nullNode);
  addtoclosure(closure2237, var_emptySeq);
  addtoclosure(closure2237, var_tryCatchNode);
  struct UserObject *uo2237 = (struct UserObject*)obj1943;
  uo2237->data[10] = (Object)closure2237;
  Method *meth_meth_ast_shallowCopy2237 = addmethod2pos(obj1943, "shallowCopy", &meth_ast_shallowCopy2237, 10);
  int argcv_meth_ast_shallowCopy2237[] = {0};
  meth_meth_ast_shallowCopy2237->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2237);
  meth_meth_ast_shallowCopy2237->definitionModule = modulename;
  meth_meth_ast_shallowCopy2237->definitionLine = 461;
  sourceObject = obj1943;
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2243 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2244 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2245 = gc_frame_new();
// call case 3: self.outer request
  Object call2246 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2245);
// compiled call node returning call2246 (depth = 7)
// compiled member node returning call2246 (depth = 6)
  partcv[0] = 0;
  Object call2247 = callmethodflags(call2246, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2244);
// compiled call node returning call2247 (depth = 5)
// compiled member node returning call2247 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2248 = callmethodflags(call2247, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2243);
// compiled call node returning call2248 (depth = 3)
  struct UserObject *obj1943_uo = (struct UserObject *)obj1943;
  obj1943_uo->super = call2248;
  sourceObject = obj1943;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2249 == NULL) {
    strlit2249 = alloc_String("trycatch");
    gc_root(strlit2249);
  }
// compiled string node returning strlit2249 (depth = 3)
  adddatum2(obj1943, strlit2249, 1);
  sourceObject = obj1943;
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj1943, *var_block, 2);
  sourceObject = obj1943;
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj1943, *var_cases_39_, 3);
  sourceObject = obj1943;
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj1943, *var_finally_39_, 4);
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  objclass1943 = obj1943->class;
  objclass1943->definitionModule = modulename;
  objclass1943->definitionLine = 404;
  (*(struct UserObject *)self).data[0] = lowerouter1943;
  self = oldself1943;
  selfslot = oldselfslot1943;
  stackframe = oldstackframe1943;
  gc_frame_end(frame);
  return obj1943;
}
Object meth_ast_new1942_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1943 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1943 = alloc_userobj2(13,11, objclass1943);
  gc_frame_newslot(obj1943);
if (objclass1943 == NULL) {
  glfree(obj1943->class->name);
  obj1943->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1943, self, 0);
  addmethodreal(obj1943,"outer", &reader_ast_outer_1944);
  Object oldself1943 = self;
  struct StackFrameObject *oldstackframe1943 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1943);
  gc_frame_newslot((Object)stackframe);
  self = obj1943;
  Object *oldselfslot1943 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1943 = (*(struct UserObject *)self).data[0], lowerouter1943 = thisouter1943;
  if (inheritingObject1943) {
    struct UserObject *inho1943 = (struct UserObject *)inheritingObject1943;
    while (inho1943->super != GraceDefaultObject) inho1943 = (struct UserObject *)inho1943->super;
    inho1943->super = obj1943;
    self = inheritingObject1943;
    *selfslot = self;
    lowerouter1943 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1943;
  }
if (objclass1943 == NULL) {
  Method *reader1945 = addmethodrealflags(obj1943, "kind",&reader_ast_kind_1945, MFLAG_DEF);
  reader1945->definitionModule = modulename;
  reader1945->definitionLine = 406;
}
adddatum2(obj1943, alloc_Undefined(), 1);
if (objclass1943 == NULL) {
  Method *reader1946 = addmethodrealflags(obj1943, "value",&reader_ast_value_1946, 0);
  Method *writer1946 = addmethodrealflags(obj1943, "value:=",&writer_ast_value_1946, 0);
  reader1946->definitionModule = modulename;
  writer1946->definitionModule = modulename;
  reader1946->definitionLine = 407;
  writer1946->definitionLine = 407;
}
obj1943->flags |= OFLAG_MUTABLE;
adddatum2(obj1943, alloc_Undefined(), 2);
if (objclass1943 == NULL) {
  Method *reader1947 = addmethodrealflags(obj1943, "cases",&reader_ast_cases_1947, 0);
  Method *writer1947 = addmethodrealflags(obj1943, "cases:=",&writer_ast_cases_1947, 0);
  reader1947->definitionModule = modulename;
  writer1947->definitionModule = modulename;
  reader1947->definitionLine = 408;
  writer1947->definitionLine = 408;
}
obj1943->flags |= OFLAG_MUTABLE;
adddatum2(obj1943, alloc_Undefined(), 3);
if (objclass1943 == NULL) {
  Method *reader1948 = addmethodrealflags(obj1943, "finally",&reader_ast_finally_1948, 0);
  Method *writer1948 = addmethodrealflags(obj1943, "finally:=",&writer_ast_finally_1948, 0);
  reader1948->definitionModule = modulename;
  writer1948->definitionModule = modulename;
  reader1948->definitionLine = 409;
  writer1948->definitionLine = 409;
}
obj1943->flags |= OFLAG_MUTABLE;
adddatum2(obj1943, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo1949 = (struct UserObject*)obj1943;
  uo1949->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple1949 = addmethod2pos(obj1943, "isSimple", &meth_ast_isSimple1949, 5);
  int argcv_meth_ast_isSimple1949[] = {0};
  meth_meth_ast_isSimple1949->type = alloc_MethodType(1, argcv_meth_ast_isSimple1949);
  meth_meth_ast_isSimple1949->definitionModule = modulename;
  meth_meth_ast_isSimple1949->definitionLine = 410;
// method "accept()from"
  struct UserObject *uo1951 = (struct UserObject*)obj1943;
  uo1951->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1951 = addmethod2pos(obj1943, "accept()from", &meth_ast_accept_40__41_from1951, 6);
  int argcv_meth_ast_accept_40__41_from1951[] = {1, 1};
  meth_meth_ast_accept_40__41_from1951->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1951);
  meth_meth_ast_accept_40__41_from1951->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1951->definitionLine = 412;
// method "map()ancestors"
  struct UserObject *uo1981 = (struct UserObject*)obj1943;
  uo1981->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1981 = addmethod2pos(obj1943, "map()ancestors", &meth_ast_map_40__41_ancestors1981, 7);
  int argcv_meth_ast_map_40__41_ancestors1981[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1981->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1981);
  meth_meth_ast_map_40__41_ancestors1981->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1981->definitionLine = 424;
// method "pretty"
  struct UserObject *uo2014 = (struct UserObject*)obj1943;
  uo2014->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty2014 = addmethod2pos(obj1943, "pretty", &meth_ast_pretty2014, 8);
  int argcv_meth_ast_pretty2014[] = {1};
  meth_meth_ast_pretty2014->type = alloc_MethodType(1, argcv_meth_ast_pretty2014);
  meth_meth_ast_pretty2014->definitionModule = modulename;
  meth_meth_ast_pretty2014->definitionLine = 432;
// method "toGrace"
  struct UserObject *uo2135 = (struct UserObject*)obj1943;
  uo2135->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace2135 = addmethod2pos(obj1943, "toGrace", &meth_ast_toGrace2135, 9);
  int argcv_meth_ast_toGrace2135[] = {1};
  meth_meth_ast_toGrace2135->type = alloc_MethodType(1, argcv_meth_ast_toGrace2135);
meth_meth_ast_toGrace2135->type->types[0] = type_Number;
meth_meth_ast_toGrace2135->type->names[0] = "depth";
  meth_meth_ast_toGrace2135->definitionModule = modulename;
  meth_meth_ast_toGrace2135->definitionLine = 447;
// method "shallowCopy"
  block_savedest(obj1943);
  Object closure2237 = createclosure(3, "shallowCopy");
  setclosureframe(closure2237, stackframe);
  addtoclosure(closure2237, var_nullNode);
  addtoclosure(closure2237, var_emptySeq);
  addtoclosure(closure2237, var_tryCatchNode);
  struct UserObject *uo2237 = (struct UserObject*)obj1943;
  uo2237->data[10] = (Object)closure2237;
  Method *meth_meth_ast_shallowCopy2237 = addmethod2pos(obj1943, "shallowCopy", &meth_ast_shallowCopy2237, 10);
  int argcv_meth_ast_shallowCopy2237[] = {0};
  meth_meth_ast_shallowCopy2237->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2237);
  meth_meth_ast_shallowCopy2237->definitionModule = modulename;
  meth_meth_ast_shallowCopy2237->definitionLine = 461;
  sourceObject = obj1943;
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2243 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2244 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2245 = gc_frame_new();
// call case 3: self.outer request
  Object call2246 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2245);
// compiled call node returning call2246 (depth = 7)
// compiled member node returning call2246 (depth = 6)
  partcv[0] = 0;
  Object call2247 = callmethodflags(call2246, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2244);
// compiled call node returning call2247 (depth = 5)
// compiled member node returning call2247 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2248 = callmethodflags(call2247, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2243);
// compiled call node returning call2248 (depth = 3)
  struct UserObject *obj1943_uo = (struct UserObject *)obj1943;
  obj1943_uo->super = call2248;
  sourceObject = obj1943;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2249 == NULL) {
    strlit2249 = alloc_String("trycatch");
    gc_root(strlit2249);
  }
// compiled string node returning strlit2249 (depth = 3)
  adddatum2(obj1943, strlit2249, 1);
  sourceObject = obj1943;
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj1943, *var_block, 2);
  sourceObject = obj1943;
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj1943, *var_cases_39_, 3);
  sourceObject = obj1943;
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj1943, *var_finally_39_, 4);
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  sourceObject = obj1943;
  objclass1943 = obj1943->class;
  objclass1943->definitionModule = modulename;
  objclass1943->definitionLine = 404;
  (*(struct UserObject *)self).data[0] = lowerouter1943;
  self = oldself1943;
  selfslot = oldselfslot1943;
  stackframe = oldstackframe1943;
  gc_frame_end(frame);
  return obj1943;
}
Object meth_ast_tryCatchNode2251(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tryCatchNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tryCatchNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tryCatchNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for tryCatchNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tryCatchNode (depth = 3)
  gc_frame_end(frame);
  return *var_tryCatchNode;
}
Object meth_ast_isSimple2261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2262 = alloc_Boolean(0);
// compiled identifier node returning bool2262 (depth = 3)
  gc_frame_end(frame);
  return bool2262;
}
Object meth_ast_matchee2263(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for matchee (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for matchee");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2265 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2264);
// compiled call node returning call2265 (depth = 4)
// compiled member node returning call2265 (depth = 3)
  gc_frame_end(frame);
  return call2265;
}
Object meth_ast__apply2280(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2281 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2282 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2281);
// compiled call node returning call2282 (depth = 6)
  gc_frame_end(frame);
  return call2282;
}
Object meth_ast_accept_40__41_from2266(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2268 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2269 = callmethod(*var_visitor, "visitMatchCase()up",
    2, partcv, params);
  gc_frame_end(callframe2268);
// compiled call node returning call2269 (depth = 4)
  Object if2267 = done;
  if (istrue(call2269)) {
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2270 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2271 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2270);
// compiled call node returning call2271 (depth = 5)
  *var_newChain = call2271;
  if (call2271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2272 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2273 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2274 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2273);
// compiled call node returning call2274 (depth = 6)
// compiled member node returning call2274 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2275 = callmethod(call2274, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2272);
// compiled call node returning call2275 (depth = 4)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2276 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2278 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2277);
// compiled call node returning call2278 (depth = 6)
// compiled member node returning call2278 (depth = 5)
  gc_frame_newslot(call2278);
// starting to compile block node (depth = 5)
  Object block2279 = alloc_Block(NULL, NULL, "ast", 479);
  gc_frame_newslot(block2279);
// method "_apply"
  block_savedest(block2279);
  Object closure2280 = createclosure(3, "_apply");
  setclosureframe(closure2280, stackframe);
  addtoclosure(closure2280, var_visitor);
  addtoclosure(closure2280, var_newChain);
  addtoclosure(closure2280, selfslot);
  struct UserObject *uo2280 = (struct UserObject*)block2279;
  uo2280->data[0] = (Object)closure2280;
  Method *meth_meth_ast__apply2280 = addmethod2pos(block2279, "_apply", &meth_ast__apply2280, 0);
  int argcv_meth_ast__apply2280[] = {1};
  meth_meth_ast__apply2280->type = alloc_MethodType(1, argcv_meth_ast__apply2280);
  meth_meth_ast__apply2280->definitionModule = modulename;
  meth_meth_ast__apply2280->definitionLine = 479;
// compiled block node returning block2279 (depth = 5)
  gc_frame_newslot(block2279);
// call case 5: prelude request
  params[0] = call2278;
  params[1] = block2279;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2284 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2276);
// compiled call node returning call2284 (depth = 4)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2287 = alloc_Boolean(0);
// compiled identifier node returning bool2287 (depth = 6)
  int op_slot_right_2286 = gc_frame_newslot(bool2287);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2290 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2289);
// compiled call node returning call2290 (depth = 7)
// compiled member node returning call2290 (depth = 6)
  int op_slot_left_2286 = gc_frame_newslot(call2290);
  params[0] = bool2287;
  partcv[0] = 1;
  Object opresult2291 = callmethod(call2290, "!=", 1, partcv, params);
// compiled op node returning opresult2291 (depth = 5)
  Object if2285 = done;
  if (istrue(opresult2291)) {
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2292 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2294 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2293);
// compiled call node returning call2294 (depth = 7)
// compiled member node returning call2294 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2295 = callmethod(call2294, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2292);
// compiled call node returning call2295 (depth = 5)
    gc_frame_newslot(call2295);
    if2285 = call2295;
  } else {
  }
// compiled if node returning if2285 (depth = 4)
    gc_frame_newslot(if2285);
    if2267 = if2285;
  } else {
  }
// compiled if node returning if2267 (depth = 3)
  gc_frame_end(frame);
  return if2267;
}
Object meth_ast_map_40__41_ancestors2296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2298 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2297);
// compiled call node returning call2298 (depth = 5)
// compiled member node returning call2298 (depth = 4)
  *var_n = call2298;
  if (call2298 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2299 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2300 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2299);
// compiled call node returning call2300 (depth = 4)
  *var_newChain = call2300;
  if (call2300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2301 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2302 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2304 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2303);
// compiled call node returning call2304 (depth = 6)
// compiled member node returning call2304 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2305 = callmethod(call2304, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe2302);
// compiled call node returning call2305 (depth = 4)
  gc_frame_newslot(call2305);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2305;
  partcv[0] = 1;
  Object call2306 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe2301);
// compiled call node returning call2306 (depth = 3)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2307 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2308 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2310 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2309);
// compiled call node returning call2310 (depth = 6)
// compiled member node returning call2310 (depth = 5)
  gc_frame_newslot(call2310);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2311 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2312 = gc_frame_new();
// call case 3: self.outer request
  Object call2313 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2312);
// compiled call node returning call2313 (depth = 8)
// compiled member node returning call2313 (depth = 7)
  partcv[0] = 0;
  Object call2314 = callmethodflags(call2313, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2311);
// compiled call node returning call2314 (depth = 6)
// compiled member node returning call2314 (depth = 5)
  params[0] = call2310;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2315 = callmethodflags(call2314, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2308);
// compiled call node returning call2315 (depth = 4)
  gc_frame_newslot(call2315);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2315;
  partcv[0] = 1;
  Object call2316 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe2307);
// compiled call node returning call2316 (depth = 3)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2317 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2318 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2319 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2320 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2319);
// compiled call node returning call2320 (depth = 6)
// compiled member node returning call2320 (depth = 5)
  gc_frame_newslot(call2320);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2321 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2322 = gc_frame_new();
// call case 3: self.outer request
  Object call2323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2322);
// compiled call node returning call2323 (depth = 8)
// compiled member node returning call2323 (depth = 7)
  partcv[0] = 0;
  Object call2324 = callmethodflags(call2323, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2321);
// compiled call node returning call2324 (depth = 6)
// compiled member node returning call2324 (depth = 5)
  params[0] = call2320;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2325 = callmethodflags(call2324, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2318);
// compiled call node returning call2325 (depth = 4)
  gc_frame_newslot(call2325);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2325;
  partcv[0] = 1;
  Object call2326 = callmethod(*var_n, "elsecase:=",
    1, partcv, params);
  gc_frame_end(callframe2317);
// compiled call node returning call2326 (depth = 3)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2327 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2328 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2327);
// compiled call node returning call2328 (depth = 3)
  gc_frame_end(frame);
  return call2328;
}
Object meth_ast__apply2337(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2339 == NULL) {
    strlit2339 = alloc_String("  ");
    gc_root(strlit2339);
  }
// compiled string node returning strlit2339 (depth = 7)
  int op_slot_right_2338 = gc_frame_newslot(strlit2339);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2338 = gc_frame_newslot(*var_spc);
  params[0] = strlit2339;
  partcv[0] = 1;
  Object opresult2341 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2341 (depth = 6)
  *var_spc = opresult2341;
  if (opresult2341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2370(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2373 == NULL) {
    strlit2373 = alloc_String("");
    gc_root(strlit2373);
  }
// compiled string node returning strlit2373 (depth = 8)
  int op_slot_right_2372 = gc_frame_newslot(strlit2373);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2376 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2378 = alloc_Float64(2);
// compiled num node returning num2378 (depth = 11)
  int op_slot_right_2377 = gc_frame_newslot(num2378);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2377 = gc_frame_newslot(*var_depth);
  params[0] = num2378;
  partcv[0] = 1;
  Object sum2380 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2380 (depth = 10)
  gc_frame_newslot(sum2380);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2380;
  partcv[0] = 1;
  Object call2381 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2376);
// compiled call node returning call2381 (depth = 9)
  int op_slot_right_2375 = gc_frame_newslot(call2381);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2384 == NULL) {
    strlit2384 = alloc_String("  ");
    gc_root(strlit2384);
  }
// compiled string node returning strlit2384 (depth = 10)
  int op_slot_right_2383 = gc_frame_newslot(strlit2384);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2386 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2389 == NULL) {
    strlit2389 = alloc_String("Case:""\x0a""");
    gc_root(strlit2389);
  }
// compiled string node returning strlit2389 (depth = 12)
  int op_slot_right_2388 = gc_frame_newslot(strlit2389);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2391 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2393 == NULL) {
    strlit2393 = alloc_String("""\x0a""");
    gc_root(strlit2393);
  }
// compiled string node returning strlit2393 (depth = 13)
  int op_slot_left_2391 = gc_frame_newslot(strlit2393);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2394 = callmethod(strlit2393, "++", 1, partcv, params);
// compiled op node returning opresult2394 (depth = 12)
  int op_slot_left_2388 = gc_frame_newslot(opresult2394);
  params[0] = strlit2389;
  partcv[0] = 1;
  Object opresult2395 = callmethod(opresult2394, "++", 1, partcv, params);
// compiled op node returning opresult2395 (depth = 11)
  int op_slot_left_2386 = gc_frame_newslot(opresult2395);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2396 = callmethod(opresult2395, "++", 1, partcv, params);
// compiled op node returning opresult2396 (depth = 10)
  int op_slot_left_2383 = gc_frame_newslot(opresult2396);
  params[0] = strlit2384;
  partcv[0] = 1;
  Object opresult2397 = callmethod(opresult2396, "++", 1, partcv, params);
// compiled op node returning opresult2397 (depth = 9)
  int op_slot_left_2375 = gc_frame_newslot(opresult2397);
  params[0] = call2381;
  partcv[0] = 1;
  Object opresult2398 = callmethod(opresult2397, "++", 1, partcv, params);
// compiled op node returning opresult2398 (depth = 8)
  int op_slot_left_2372 = gc_frame_newslot(opresult2398);
  params[0] = strlit2373;
  partcv[0] = 1;
  Object opresult2399 = callmethod(opresult2398, "++", 1, partcv, params);
// compiled op node returning opresult2399 (depth = 7)
  int op_slot_right_2371 = gc_frame_newslot(opresult2399);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2371 = gc_frame_newslot(*var_s);
  params[0] = opresult2399;
  partcv[0] = 1;
  Object opresult2401 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2401 (depth = 6)
  *var_s = opresult2401;
  if (opresult2401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2329(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2330 == NULL) {
    strlit2330 = alloc_String("");
    gc_root(strlit2330);
  }
// compiled string node returning strlit2330 (depth = 4)
  *var_spc = strlit2330;
  if (strlit2330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2331 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2332 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2334 = alloc_Float64(0);
// compiled num node returning num2334 (depth = 5)
  int op_slot_left_2332 = gc_frame_newslot(num2334);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2335 = callmethod(num2334, "..", 1, partcv, params);
// compiled op node returning opresult2335 (depth = 4)
  gc_frame_newslot(opresult2335);
// starting to compile block node (depth = 4)
  Object block2336 = alloc_Block(NULL, NULL, "ast", 497);
  gc_frame_newslot(block2336);
// method "_apply"
  block_savedest(block2336);
  Object closure2337 = createclosure(2, "_apply");
  setclosureframe(closure2337, stackframe);
  addtoclosure(closure2337, var_spc);
  addtoclosure(closure2337, selfslot);
  struct UserObject *uo2337 = (struct UserObject*)block2336;
  uo2337->data[0] = (Object)closure2337;
  Method *meth_meth_ast__apply2337 = addmethod2pos(block2336, "_apply", &meth_ast__apply2337, 0);
  int argcv_meth_ast__apply2337[] = {1};
  meth_meth_ast__apply2337->type = alloc_MethodType(1, argcv_meth_ast__apply2337);
  meth_meth_ast__apply2337->definitionModule = modulename;
  meth_meth_ast__apply2337->definitionLine = 492;
// compiled block node returning block2336 (depth = 4)
  gc_frame_newslot(block2336);
// call case 5: prelude request
  params[0] = opresult2335;
  params[1] = block2336;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2344 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2331);
// compiled call node returning call2344 (depth = 3)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2346 == NULL) {
    strlit2346 = alloc_String("""\x0a""");
    gc_root(strlit2346);
  }
// compiled string node returning strlit2346 (depth = 5)
  int op_slot_right_2345 = gc_frame_newslot(strlit2346);
// starting to compile call node (depth = 5)
  int callframe2348 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2349 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2348);
// compiled call node returning call2349 (depth = 5)
  int op_slot_left_2345 = gc_frame_newslot(call2349);
  params[0] = strlit2346;
  partcv[0] = 1;
  Object opresult2350 = callmethod(call2349, "++", 1, partcv, params);
// compiled op node returning opresult2350 (depth = 4)
  *var_s = opresult2350;
  if (opresult2350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2352 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2354 = alloc_Float64(2);
// compiled num node returning num2354 (depth = 7)
  int op_slot_right_2353 = gc_frame_newslot(num2354);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2353 = gc_frame_newslot(*var_depth);
  params[0] = num2354;
  partcv[0] = 1;
  Object sum2356 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2356 (depth = 6)
  gc_frame_newslot(sum2356);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2357 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2358 = callmethodflags(self, "matchee", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2357);
// compiled call node returning call2358 (depth = 7)
// compiled member node returning call2358 (depth = 6)
  params[0] = sum2356;
  partcv[0] = 1;
  Object call2359 = callmethod(call2358, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2352);
// compiled call node returning call2359 (depth = 5)
  int op_slot_right_2351 = gc_frame_newslot(call2359);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2361 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2361 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2363 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2363 (depth = 5)
  int op_slot_left_2351 = gc_frame_newslot(opresult2363);
  params[0] = call2359;
  partcv[0] = 1;
  Object opresult2364 = callmethod(opresult2363, "++", 1, partcv, params);
// compiled op node returning opresult2364 (depth = 4)
  *var_s = opresult2364;
  if (opresult2364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2366 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2367 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2368 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2367);
// compiled call node returning call2368 (depth = 5)
// compiled member node returning call2368 (depth = 4)
  gc_frame_newslot(call2368);
// starting to compile block node (depth = 4)
  Object block2369 = alloc_Block(NULL, NULL, "ast", 502);
  gc_frame_newslot(block2369);
// method "_apply"
  block_savedest(block2369);
  Object closure2370 = createclosure(4, "_apply");
  setclosureframe(closure2370, stackframe);
  addtoclosure(closure2370, var_depth);
  addtoclosure(closure2370, var_spc);
  addtoclosure(closure2370, var_s);
  addtoclosure(closure2370, selfslot);
  struct UserObject *uo2370 = (struct UserObject*)block2369;
  uo2370->data[0] = (Object)closure2370;
  Method *meth_meth_ast__apply2370 = addmethod2pos(block2369, "_apply", &meth_ast__apply2370, 0);
  int argcv_meth_ast__apply2370[] = {1};
  meth_meth_ast__apply2370->type = alloc_MethodType(1, argcv_meth_ast__apply2370);
  meth_meth_ast__apply2370->definitionModule = modulename;
  meth_meth_ast__apply2370->definitionLine = 502;
// compiled block node returning block2369 (depth = 4)
  gc_frame_newslot(block2369);
// call case 5: prelude request
  params[0] = call2368;
  params[1] = block2369;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2404 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2366);
// compiled call node returning call2404 (depth = 3)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2407 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2408 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2407);
// compiled call node returning call2408 (depth = 6)
// compiled member node returning call2408 (depth = 5)
  int op_slot_right_2406 = gc_frame_newslot(call2408);
// starting to compile identifier node (depth = 5)
  Object bool2410 = alloc_Boolean(0);
// compiled identifier node returning bool2410 (depth = 5)
  int op_slot_left_2406 = gc_frame_newslot(bool2410);
  params[0] = call2408;
  partcv[0] = 1;
  Object opresult2411 = callmethod(bool2410, "!=", 1, partcv, params);
// compiled op node returning opresult2411 (depth = 4)
  Object if2405 = done;
  if (istrue(opresult2411)) {
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2414 == NULL) {
    strlit2414 = alloc_String("");
    gc_root(strlit2414);
  }
// compiled string node returning strlit2414 (depth = 7)
  int op_slot_right_2413 = gc_frame_newslot(strlit2414);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2417 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2419 = alloc_Float64(2);
// compiled num node returning num2419 (depth = 10)
  int op_slot_right_2418 = gc_frame_newslot(num2419);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2418 = gc_frame_newslot(*var_depth);
  params[0] = num2419;
  partcv[0] = 1;
  Object sum2421 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2421 (depth = 9)
  gc_frame_newslot(sum2421);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2423 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2422);
// compiled call node returning call2423 (depth = 10)
// compiled member node returning call2423 (depth = 9)
  params[0] = sum2421;
  partcv[0] = 1;
  Object call2424 = callmethod(call2423, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2417);
// compiled call node returning call2424 (depth = 8)
  int op_slot_right_2416 = gc_frame_newslot(call2424);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2427 == NULL) {
    strlit2427 = alloc_String("  ");
    gc_root(strlit2427);
  }
// compiled string node returning strlit2427 (depth = 9)
  int op_slot_right_2426 = gc_frame_newslot(strlit2427);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2429 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2432 == NULL) {
    strlit2432 = alloc_String("Else:""\x0a""");
    gc_root(strlit2432);
  }
// compiled string node returning strlit2432 (depth = 11)
  int op_slot_right_2431 = gc_frame_newslot(strlit2432);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2434 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2436 == NULL) {
    strlit2436 = alloc_String("""\x0a""");
    gc_root(strlit2436);
  }
// compiled string node returning strlit2436 (depth = 12)
  int op_slot_left_2434 = gc_frame_newslot(strlit2436);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2437 = callmethod(strlit2436, "++", 1, partcv, params);
// compiled op node returning opresult2437 (depth = 11)
  int op_slot_left_2431 = gc_frame_newslot(opresult2437);
  params[0] = strlit2432;
  partcv[0] = 1;
  Object opresult2438 = callmethod(opresult2437, "++", 1, partcv, params);
// compiled op node returning opresult2438 (depth = 10)
  int op_slot_left_2429 = gc_frame_newslot(opresult2438);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2439 = callmethod(opresult2438, "++", 1, partcv, params);
// compiled op node returning opresult2439 (depth = 9)
  int op_slot_left_2426 = gc_frame_newslot(opresult2439);
  params[0] = strlit2427;
  partcv[0] = 1;
  Object opresult2440 = callmethod(opresult2439, "++", 1, partcv, params);
// compiled op node returning opresult2440 (depth = 8)
  int op_slot_left_2416 = gc_frame_newslot(opresult2440);
  params[0] = call2424;
  partcv[0] = 1;
  Object opresult2441 = callmethod(opresult2440, "++", 1, partcv, params);
// compiled op node returning opresult2441 (depth = 7)
  int op_slot_left_2413 = gc_frame_newslot(opresult2441);
  params[0] = strlit2414;
  partcv[0] = 1;
  Object opresult2442 = callmethod(opresult2441, "++", 1, partcv, params);
// compiled op node returning opresult2442 (depth = 6)
  int op_slot_right_2412 = gc_frame_newslot(opresult2442);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2412 = gc_frame_newslot(*var_s);
  params[0] = opresult2442;
  partcv[0] = 1;
  Object opresult2444 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2444 (depth = 5)
  *var_s = opresult2444;
  if (opresult2444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2405 = done;
  } else {
  }
// compiled if node returning if2405 (depth = 3)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2458(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2460 == NULL) {
    strlit2460 = alloc_String("    ");
    gc_root(strlit2460);
  }
// compiled string node returning strlit2460 (depth = 7)
  int op_slot_right_2459 = gc_frame_newslot(strlit2460);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2459 = gc_frame_newslot(*var_spc);
  params[0] = strlit2460;
  partcv[0] = 1;
  Object opresult2462 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2462 (depth = 6)
  *var_spc = opresult2462;
  if (opresult2462 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2483(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2485 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2487 = alloc_Float64(2);
// compiled num node returning num2487 (depth = 9)
  int op_slot_right_2486 = gc_frame_newslot(num2487);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2486 = gc_frame_newslot(*var_depth);
  params[0] = num2487;
  partcv[0] = 1;
  Object sum2489 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2489 (depth = 8)
  gc_frame_newslot(sum2489);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2489;
  partcv[0] = 1;
  Object call2490 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2485);
// compiled call node returning call2490 (depth = 7)
  int op_slot_right_2484 = gc_frame_newslot(call2490);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2493 == NULL) {
    strlit2493 = alloc_String("case ");
    gc_root(strlit2493);
  }
// compiled string node returning strlit2493 (depth = 8)
  int op_slot_right_2492 = gc_frame_newslot(strlit2493);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2496 == NULL) {
    strlit2496 = alloc_String("    ");
    gc_root(strlit2496);
  }
// compiled string node returning strlit2496 (depth = 9)
  int op_slot_right_2495 = gc_frame_newslot(strlit2496);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2498 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2501 == NULL) {
    strlit2501 = alloc_String("""\x0a""");
    gc_root(strlit2501);
  }
// compiled string node returning strlit2501 (depth = 11)
  int op_slot_right_2500 = gc_frame_newslot(strlit2501);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2500 = gc_frame_newslot(*var_s);
  params[0] = strlit2501;
  partcv[0] = 1;
  Object opresult2503 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2503 (depth = 10)
  int op_slot_left_2498 = gc_frame_newslot(opresult2503);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2504 = callmethod(opresult2503, "++", 1, partcv, params);
// compiled op node returning opresult2504 (depth = 9)
  int op_slot_left_2495 = gc_frame_newslot(opresult2504);
  params[0] = strlit2496;
  partcv[0] = 1;
  Object opresult2505 = callmethod(opresult2504, "++", 1, partcv, params);
// compiled op node returning opresult2505 (depth = 8)
  int op_slot_left_2492 = gc_frame_newslot(opresult2505);
  params[0] = strlit2493;
  partcv[0] = 1;
  Object opresult2506 = callmethod(opresult2505, "++", 1, partcv, params);
// compiled op node returning opresult2506 (depth = 7)
  int op_slot_left_2484 = gc_frame_newslot(opresult2506);
  params[0] = call2490;
  partcv[0] = 1;
  Object opresult2507 = callmethod(opresult2506, "++", 1, partcv, params);
// compiled op node returning opresult2507 (depth = 6)
  *var_s = opresult2507;
  if (opresult2507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2446(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2447 == NULL) {
    strlit2447 = alloc_String("");
    gc_root(strlit2447);
  }
// compiled string node returning strlit2447 (depth = 4)
  *var_spc = strlit2447;
  if (strlit2447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2448 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2451 = alloc_Float64(1);
// compiled num node returning num2451 (depth = 6)
  int op_slot_right_2450 = gc_frame_newslot(num2451);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2450 = gc_frame_newslot(*var_depth);
  params[0] = num2451;
  partcv[0] = 1;
  Object diff2453 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2453 (depth = 5)
  int op_slot_right_2449 = gc_frame_newslot(diff2453);
// starting to compile num node (depth = 5)
  Object num2455 = alloc_Float64(0);
// compiled num node returning num2455 (depth = 5)
  int op_slot_left_2449 = gc_frame_newslot(num2455);
  params[0] = diff2453;
  partcv[0] = 1;
  Object opresult2456 = callmethod(num2455, "..", 1, partcv, params);
// compiled op node returning opresult2456 (depth = 4)
  gc_frame_newslot(opresult2456);
// starting to compile block node (depth = 4)
  Object block2457 = alloc_Block(NULL, NULL, "ast", 512);
  gc_frame_newslot(block2457);
// method "_apply"
  block_savedest(block2457);
  Object closure2458 = createclosure(2, "_apply");
  setclosureframe(closure2458, stackframe);
  addtoclosure(closure2458, var_spc);
  addtoclosure(closure2458, selfslot);
  struct UserObject *uo2458 = (struct UserObject*)block2457;
  uo2458->data[0] = (Object)closure2458;
  Method *meth_meth_ast__apply2458 = addmethod2pos(block2457, "_apply", &meth_ast__apply2458, 0);
  int argcv_meth_ast__apply2458[] = {1};
  meth_meth_ast__apply2458->type = alloc_MethodType(1, argcv_meth_ast__apply2458);
  meth_meth_ast__apply2458->definitionModule = modulename;
  meth_meth_ast__apply2458->definitionLine = 506;
// compiled block node returning block2457 (depth = 4)
  gc_frame_newslot(block2457);
// call case 5: prelude request
  params[0] = opresult2456;
  params[1] = block2457;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2465 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2448);
// compiled call node returning call2465 (depth = 3)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2467 == NULL) {
    strlit2467 = alloc_String(")");
    gc_root(strlit2467);
  }
// compiled string node returning strlit2467 (depth = 5)
  int op_slot_right_2466 = gc_frame_newslot(strlit2467);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2470 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num2471 = alloc_Float64(0);
// compiled num node returning num2471 (depth = 7)
  gc_frame_newslot(num2471);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2473 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2472);
// compiled call node returning call2473 (depth = 8)
// compiled member node returning call2473 (depth = 7)
  params[0] = num2471;
  partcv[0] = 1;
  Object call2474 = callmethod(call2473, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2470);
// compiled call node returning call2474 (depth = 6)
  int op_slot_right_2469 = gc_frame_newslot(call2474);
// starting to compile string node (depth = 6)
  if (strlit2476 == NULL) {
    strlit2476 = alloc_String("match(");
    gc_root(strlit2476);
  }
// compiled string node returning strlit2476 (depth = 6)
  int op_slot_left_2469 = gc_frame_newslot(strlit2476);
  params[0] = call2474;
  partcv[0] = 1;
  Object opresult2477 = callmethod(strlit2476, "++", 1, partcv, params);
// compiled op node returning opresult2477 (depth = 5)
  int op_slot_left_2466 = gc_frame_newslot(opresult2477);
  params[0] = strlit2467;
  partcv[0] = 1;
  Object opresult2478 = callmethod(opresult2477, "++", 1, partcv, params);
// compiled op node returning opresult2478 (depth = 4)
  *var_s = opresult2478;
  if (opresult2478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2479 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2481 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2480);
// compiled call node returning call2481 (depth = 5)
// compiled member node returning call2481 (depth = 4)
  gc_frame_newslot(call2481);
// starting to compile block node (depth = 4)
  Object block2482 = alloc_Block(NULL, NULL, "ast", 516);
  gc_frame_newslot(block2482);
// method "_apply"
  block_savedest(block2482);
  Object closure2483 = createclosure(4, "_apply");
  setclosureframe(closure2483, stackframe);
  addtoclosure(closure2483, var_depth);
  addtoclosure(closure2483, var_spc);
  addtoclosure(closure2483, var_s);
  addtoclosure(closure2483, selfslot);
  struct UserObject *uo2483 = (struct UserObject*)block2482;
  uo2483->data[0] = (Object)closure2483;
  Method *meth_meth_ast__apply2483 = addmethod2pos(block2482, "_apply", &meth_ast__apply2483, 0);
  int argcv_meth_ast__apply2483[] = {1};
  meth_meth_ast__apply2483->type = alloc_MethodType(1, argcv_meth_ast__apply2483);
  meth_meth_ast__apply2483->definitionModule = modulename;
  meth_meth_ast__apply2483->definitionLine = 516;
// compiled block node returning block2482 (depth = 4)
  gc_frame_newslot(block2482);
// call case 5: prelude request
  params[0] = call2481;
  params[1] = block2482;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2510 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2479);
// compiled call node returning call2510 (depth = 3)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2513 = alloc_Boolean(0);
// compiled identifier node returning bool2513 (depth = 5)
  int op_slot_right_2512 = gc_frame_newslot(bool2513);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2516 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2515);
// compiled call node returning call2516 (depth = 6)
// compiled member node returning call2516 (depth = 5)
  int op_slot_left_2512 = gc_frame_newslot(call2516);
  params[0] = bool2513;
  partcv[0] = 1;
  Object opresult2517 = callmethod(call2516, "!=", 1, partcv, params);
// compiled op node returning opresult2517 (depth = 4)
  Object if2511 = done;
  if (istrue(opresult2517)) {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2519 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2521 = alloc_Float64(2);
// compiled num node returning num2521 (depth = 8)
  int op_slot_right_2520 = gc_frame_newslot(num2521);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2520 = gc_frame_newslot(*var_depth);
  params[0] = num2521;
  partcv[0] = 1;
  Object sum2523 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2523 (depth = 7)
  gc_frame_newslot(sum2523);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2524 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2525 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2524);
// compiled call node returning call2525 (depth = 8)
// compiled member node returning call2525 (depth = 7)
  params[0] = sum2523;
  partcv[0] = 1;
  Object call2526 = callmethod(call2525, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2519);
// compiled call node returning call2526 (depth = 6)
  int op_slot_right_2518 = gc_frame_newslot(call2526);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2529 == NULL) {
    strlit2529 = alloc_String("else ");
    gc_root(strlit2529);
  }
// compiled string node returning strlit2529 (depth = 7)
  int op_slot_right_2528 = gc_frame_newslot(strlit2529);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2532 == NULL) {
    strlit2532 = alloc_String("    ");
    gc_root(strlit2532);
  }
// compiled string node returning strlit2532 (depth = 8)
  int op_slot_right_2531 = gc_frame_newslot(strlit2532);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2534 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2537 == NULL) {
    strlit2537 = alloc_String("""\x0a""");
    gc_root(strlit2537);
  }
// compiled string node returning strlit2537 (depth = 10)
  int op_slot_right_2536 = gc_frame_newslot(strlit2537);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2536 = gc_frame_newslot(*var_s);
  params[0] = strlit2537;
  partcv[0] = 1;
  Object opresult2539 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2539 (depth = 9)
  int op_slot_left_2534 = gc_frame_newslot(opresult2539);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2540 = callmethod(opresult2539, "++", 1, partcv, params);
// compiled op node returning opresult2540 (depth = 8)
  int op_slot_left_2531 = gc_frame_newslot(opresult2540);
  params[0] = strlit2532;
  partcv[0] = 1;
  Object opresult2541 = callmethod(opresult2540, "++", 1, partcv, params);
// compiled op node returning opresult2541 (depth = 7)
  int op_slot_left_2528 = gc_frame_newslot(opresult2541);
  params[0] = strlit2529;
  partcv[0] = 1;
  Object opresult2542 = callmethod(opresult2541, "++", 1, partcv, params);
// compiled op node returning opresult2542 (depth = 6)
  int op_slot_left_2518 = gc_frame_newslot(opresult2542);
  params[0] = call2526;
  partcv[0] = 1;
  Object opresult2543 = callmethod(opresult2542, "++", 1, partcv, params);
// compiled op node returning opresult2543 (depth = 5)
  *var_s = opresult2543;
  if (opresult2543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2511 = done;
  } else {
  }
// compiled if node returning if2511 (depth = 3)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2546 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2547 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2548 = alloc_Boolean(0);
// compiled identifier node returning bool2548 (depth = 5)
  gc_frame_newslot(bool2548);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchCaseNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2548;
  partcv[0] = 3;
  Object call2549 = callmethod(*var_matchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2547);
// compiled call node returning call2549 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2550 = callmethod(call2549, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2546);
// compiled call node returning call2550 (depth = 3)
  gc_frame_end(frame);
  return call2550;
}
Object meth_ast_new2254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2255 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2255 = alloc_userobj2(14,12, objclass2255);
  gc_frame_newslot(obj2255);
if (objclass2255 == NULL) {
  glfree(obj2255->class->name);
  obj2255->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2255, self, 0);
  addmethodreal(obj2255,"outer", &reader_ast_outer_2256);
  Object oldself2255 = self;
  struct StackFrameObject *oldstackframe2255 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2255);
  gc_frame_newslot((Object)stackframe);
  self = obj2255;
  Object *oldselfslot2255 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2255 = (*(struct UserObject *)self).data[0], lowerouter2255 = thisouter2255;
  if (inheritingObject2255) {
    struct UserObject *inho2255 = (struct UserObject *)inheritingObject2255;
    while (inho2255->super != GraceDefaultObject) inho2255 = (struct UserObject *)inho2255->super;
    inho2255->super = obj2255;
    self = inheritingObject2255;
    *selfslot = self;
    lowerouter2255 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2255;
  }
if (objclass2255 == NULL) {
  Method *reader2257 = addmethodrealflags(obj2255, "kind",&reader_ast_kind_2257, MFLAG_DEF);
  reader2257->definitionModule = modulename;
  reader2257->definitionLine = 469;
}
adddatum2(obj2255, alloc_Undefined(), 1);
if (objclass2255 == NULL) {
  Method *reader2258 = addmethodrealflags(obj2255, "value",&reader_ast_value_2258, 0);
  Method *writer2258 = addmethodrealflags(obj2255, "value:=",&writer_ast_value_2258, 0);
  reader2258->definitionModule = modulename;
  writer2258->definitionModule = modulename;
  reader2258->definitionLine = 470;
  writer2258->definitionLine = 470;
}
obj2255->flags |= OFLAG_MUTABLE;
adddatum2(obj2255, alloc_Undefined(), 2);
if (objclass2255 == NULL) {
  Method *reader2259 = addmethodrealflags(obj2255, "cases",&reader_ast_cases_2259, 0);
  Method *writer2259 = addmethodrealflags(obj2255, "cases:=",&writer_ast_cases_2259, 0);
  reader2259->definitionModule = modulename;
  writer2259->definitionModule = modulename;
  reader2259->definitionLine = 471;
  writer2259->definitionLine = 471;
}
obj2255->flags |= OFLAG_MUTABLE;
adddatum2(obj2255, alloc_Undefined(), 3);
if (objclass2255 == NULL) {
  Method *reader2260 = addmethodrealflags(obj2255, "elsecase",&reader_ast_elsecase_2260, 0);
  Method *writer2260 = addmethodrealflags(obj2255, "elsecase:=",&writer_ast_elsecase_2260, 0);
  reader2260->definitionModule = modulename;
  writer2260->definitionModule = modulename;
  reader2260->definitionLine = 472;
  writer2260->definitionLine = 472;
}
obj2255->flags |= OFLAG_MUTABLE;
adddatum2(obj2255, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2261 = (struct UserObject*)obj2255;
  uo2261->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2261 = addmethod2pos(obj2255, "isSimple", &meth_ast_isSimple2261, 5);
  int argcv_meth_ast_isSimple2261[] = {0};
  meth_meth_ast_isSimple2261->type = alloc_MethodType(1, argcv_meth_ast_isSimple2261);
  meth_meth_ast_isSimple2261->definitionModule = modulename;
  meth_meth_ast_isSimple2261->definitionLine = 473;
// method "matchee"
  struct UserObject *uo2263 = (struct UserObject*)obj2255;
  uo2263->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2263 = addmethod2pos(obj2255, "matchee", &meth_ast_matchee2263, 6);
  int argcv_meth_ast_matchee2263[] = {0};
  meth_meth_ast_matchee2263->type = alloc_MethodType(1, argcv_meth_ast_matchee2263);
  meth_meth_ast_matchee2263->definitionModule = modulename;
  meth_meth_ast_matchee2263->definitionLine = 474;
// method "accept()from"
  struct UserObject *uo2266 = (struct UserObject*)obj2255;
  uo2266->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2266 = addmethod2pos(obj2255, "accept()from", &meth_ast_accept_40__41_from2266, 7);
  int argcv_meth_ast_accept_40__41_from2266[] = {1, 1};
  meth_meth_ast_accept_40__41_from2266->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2266);
  meth_meth_ast_accept_40__41_from2266->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2266->definitionLine = 475;
// method "map()ancestors"
  struct UserObject *uo2296 = (struct UserObject*)obj2255;
  uo2296->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2296 = addmethod2pos(obj2255, "map()ancestors", &meth_ast_map_40__41_ancestors2296, 8);
  int argcv_meth_ast_map_40__41_ancestors2296[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2296->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2296);
  meth_meth_ast_map_40__41_ancestors2296->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2296->definitionLine = 487;
// method "pretty"
  struct UserObject *uo2329 = (struct UserObject*)obj2255;
  uo2329->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty2329 = addmethod2pos(obj2255, "pretty", &meth_ast_pretty2329, 9);
  int argcv_meth_ast_pretty2329[] = {1};
  meth_meth_ast_pretty2329->type = alloc_MethodType(1, argcv_meth_ast_pretty2329);
  meth_meth_ast_pretty2329->definitionModule = modulename;
  meth_meth_ast_pretty2329->definitionLine = 495;
// method "toGrace"
  struct UserObject *uo2446 = (struct UserObject*)obj2255;
  uo2446->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2446 = addmethod2pos(obj2255, "toGrace", &meth_ast_toGrace2446, 10);
  int argcv_meth_ast_toGrace2446[] = {1};
  meth_meth_ast_toGrace2446->type = alloc_MethodType(1, argcv_meth_ast_toGrace2446);
meth_meth_ast_toGrace2446->type->types[0] = type_Number;
meth_meth_ast_toGrace2446->type->names[0] = "depth";
  meth_meth_ast_toGrace2446->definitionModule = modulename;
  meth_meth_ast_toGrace2446->definitionLine = 510;
// method "shallowCopy"
  block_savedest(obj2255);
  Object closure2545 = createclosure(3, "shallowCopy");
  setclosureframe(closure2545, stackframe);
  addtoclosure(closure2545, var_nullNode);
  addtoclosure(closure2545, var_emptySeq);
  addtoclosure(closure2545, var_matchCaseNode);
  struct UserObject *uo2545 = (struct UserObject*)obj2255;
  uo2545->data[11] = (Object)closure2545;
  Method *meth_meth_ast_shallowCopy2545 = addmethod2pos(obj2255, "shallowCopy", &meth_ast_shallowCopy2545, 11);
  int argcv_meth_ast_shallowCopy2545[] = {0};
  meth_meth_ast_shallowCopy2545->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2545);
  meth_meth_ast_shallowCopy2545->definitionModule = modulename;
  meth_meth_ast_shallowCopy2545->definitionLine = 524;
  sourceObject = obj2255;
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2551 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2552 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2553 = gc_frame_new();
// call case 3: self.outer request
  Object call2554 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2553);
// compiled call node returning call2554 (depth = 7)
// compiled member node returning call2554 (depth = 6)
  partcv[0] = 0;
  Object call2555 = callmethodflags(call2554, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2552);
// compiled call node returning call2555 (depth = 5)
// compiled member node returning call2555 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2556 = callmethodflags(call2555, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2551);
// compiled call node returning call2556 (depth = 3)
  struct UserObject *obj2255_uo = (struct UserObject *)obj2255;
  obj2255_uo->super = call2556;
  sourceObject = obj2255;
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2557 == NULL) {
    strlit2557 = alloc_String("matchcase");
    gc_root(strlit2557);
  }
// compiled string node returning strlit2557 (depth = 3)
  adddatum2(obj2255, strlit2557, 1);
  sourceObject = obj2255;
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2255, *var_matchee_39_, 2);
  sourceObject = obj2255;
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2255, *var_cases_39_, 3);
  sourceObject = obj2255;
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2255, *var_elsecase_39_, 4);
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  objclass2255 = obj2255->class;
  objclass2255->definitionModule = modulename;
  objclass2255->definitionLine = 467;
  (*(struct UserObject *)self).data[0] = lowerouter2255;
  self = oldself2255;
  selfslot = oldselfslot2255;
  stackframe = oldstackframe2255;
  gc_frame_end(frame);
  return obj2255;
}
Object meth_ast_new2254_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2255 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2255 = alloc_userobj2(14,12, objclass2255);
  gc_frame_newslot(obj2255);
if (objclass2255 == NULL) {
  glfree(obj2255->class->name);
  obj2255->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2255, self, 0);
  addmethodreal(obj2255,"outer", &reader_ast_outer_2256);
  Object oldself2255 = self;
  struct StackFrameObject *oldstackframe2255 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2255);
  gc_frame_newslot((Object)stackframe);
  self = obj2255;
  Object *oldselfslot2255 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2255 = (*(struct UserObject *)self).data[0], lowerouter2255 = thisouter2255;
  if (inheritingObject2255) {
    struct UserObject *inho2255 = (struct UserObject *)inheritingObject2255;
    while (inho2255->super != GraceDefaultObject) inho2255 = (struct UserObject *)inho2255->super;
    inho2255->super = obj2255;
    self = inheritingObject2255;
    *selfslot = self;
    lowerouter2255 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2255;
  }
if (objclass2255 == NULL) {
  Method *reader2257 = addmethodrealflags(obj2255, "kind",&reader_ast_kind_2257, MFLAG_DEF);
  reader2257->definitionModule = modulename;
  reader2257->definitionLine = 469;
}
adddatum2(obj2255, alloc_Undefined(), 1);
if (objclass2255 == NULL) {
  Method *reader2258 = addmethodrealflags(obj2255, "value",&reader_ast_value_2258, 0);
  Method *writer2258 = addmethodrealflags(obj2255, "value:=",&writer_ast_value_2258, 0);
  reader2258->definitionModule = modulename;
  writer2258->definitionModule = modulename;
  reader2258->definitionLine = 470;
  writer2258->definitionLine = 470;
}
obj2255->flags |= OFLAG_MUTABLE;
adddatum2(obj2255, alloc_Undefined(), 2);
if (objclass2255 == NULL) {
  Method *reader2259 = addmethodrealflags(obj2255, "cases",&reader_ast_cases_2259, 0);
  Method *writer2259 = addmethodrealflags(obj2255, "cases:=",&writer_ast_cases_2259, 0);
  reader2259->definitionModule = modulename;
  writer2259->definitionModule = modulename;
  reader2259->definitionLine = 471;
  writer2259->definitionLine = 471;
}
obj2255->flags |= OFLAG_MUTABLE;
adddatum2(obj2255, alloc_Undefined(), 3);
if (objclass2255 == NULL) {
  Method *reader2260 = addmethodrealflags(obj2255, "elsecase",&reader_ast_elsecase_2260, 0);
  Method *writer2260 = addmethodrealflags(obj2255, "elsecase:=",&writer_ast_elsecase_2260, 0);
  reader2260->definitionModule = modulename;
  writer2260->definitionModule = modulename;
  reader2260->definitionLine = 472;
  writer2260->definitionLine = 472;
}
obj2255->flags |= OFLAG_MUTABLE;
adddatum2(obj2255, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2261 = (struct UserObject*)obj2255;
  uo2261->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2261 = addmethod2pos(obj2255, "isSimple", &meth_ast_isSimple2261, 5);
  int argcv_meth_ast_isSimple2261[] = {0};
  meth_meth_ast_isSimple2261->type = alloc_MethodType(1, argcv_meth_ast_isSimple2261);
  meth_meth_ast_isSimple2261->definitionModule = modulename;
  meth_meth_ast_isSimple2261->definitionLine = 473;
// method "matchee"
  struct UserObject *uo2263 = (struct UserObject*)obj2255;
  uo2263->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2263 = addmethod2pos(obj2255, "matchee", &meth_ast_matchee2263, 6);
  int argcv_meth_ast_matchee2263[] = {0};
  meth_meth_ast_matchee2263->type = alloc_MethodType(1, argcv_meth_ast_matchee2263);
  meth_meth_ast_matchee2263->definitionModule = modulename;
  meth_meth_ast_matchee2263->definitionLine = 474;
// method "accept()from"
  struct UserObject *uo2266 = (struct UserObject*)obj2255;
  uo2266->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2266 = addmethod2pos(obj2255, "accept()from", &meth_ast_accept_40__41_from2266, 7);
  int argcv_meth_ast_accept_40__41_from2266[] = {1, 1};
  meth_meth_ast_accept_40__41_from2266->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2266);
  meth_meth_ast_accept_40__41_from2266->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2266->definitionLine = 475;
// method "map()ancestors"
  struct UserObject *uo2296 = (struct UserObject*)obj2255;
  uo2296->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2296 = addmethod2pos(obj2255, "map()ancestors", &meth_ast_map_40__41_ancestors2296, 8);
  int argcv_meth_ast_map_40__41_ancestors2296[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2296->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2296);
  meth_meth_ast_map_40__41_ancestors2296->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2296->definitionLine = 487;
// method "pretty"
  struct UserObject *uo2329 = (struct UserObject*)obj2255;
  uo2329->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty2329 = addmethod2pos(obj2255, "pretty", &meth_ast_pretty2329, 9);
  int argcv_meth_ast_pretty2329[] = {1};
  meth_meth_ast_pretty2329->type = alloc_MethodType(1, argcv_meth_ast_pretty2329);
  meth_meth_ast_pretty2329->definitionModule = modulename;
  meth_meth_ast_pretty2329->definitionLine = 495;
// method "toGrace"
  struct UserObject *uo2446 = (struct UserObject*)obj2255;
  uo2446->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2446 = addmethod2pos(obj2255, "toGrace", &meth_ast_toGrace2446, 10);
  int argcv_meth_ast_toGrace2446[] = {1};
  meth_meth_ast_toGrace2446->type = alloc_MethodType(1, argcv_meth_ast_toGrace2446);
meth_meth_ast_toGrace2446->type->types[0] = type_Number;
meth_meth_ast_toGrace2446->type->names[0] = "depth";
  meth_meth_ast_toGrace2446->definitionModule = modulename;
  meth_meth_ast_toGrace2446->definitionLine = 510;
// method "shallowCopy"
  block_savedest(obj2255);
  Object closure2545 = createclosure(3, "shallowCopy");
  setclosureframe(closure2545, stackframe);
  addtoclosure(closure2545, var_nullNode);
  addtoclosure(closure2545, var_emptySeq);
  addtoclosure(closure2545, var_matchCaseNode);
  struct UserObject *uo2545 = (struct UserObject*)obj2255;
  uo2545->data[11] = (Object)closure2545;
  Method *meth_meth_ast_shallowCopy2545 = addmethod2pos(obj2255, "shallowCopy", &meth_ast_shallowCopy2545, 11);
  int argcv_meth_ast_shallowCopy2545[] = {0};
  meth_meth_ast_shallowCopy2545->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2545);
  meth_meth_ast_shallowCopy2545->definitionModule = modulename;
  meth_meth_ast_shallowCopy2545->definitionLine = 524;
  sourceObject = obj2255;
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2551 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2552 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2553 = gc_frame_new();
// call case 3: self.outer request
  Object call2554 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2553);
// compiled call node returning call2554 (depth = 7)
// compiled member node returning call2554 (depth = 6)
  partcv[0] = 0;
  Object call2555 = callmethodflags(call2554, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2552);
// compiled call node returning call2555 (depth = 5)
// compiled member node returning call2555 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2556 = callmethodflags(call2555, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2551);
// compiled call node returning call2556 (depth = 3)
  struct UserObject *obj2255_uo = (struct UserObject *)obj2255;
  obj2255_uo->super = call2556;
  sourceObject = obj2255;
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2557 == NULL) {
    strlit2557 = alloc_String("matchcase");
    gc_root(strlit2557);
  }
// compiled string node returning strlit2557 (depth = 3)
  adddatum2(obj2255, strlit2557, 1);
  sourceObject = obj2255;
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2255, *var_matchee_39_, 2);
  sourceObject = obj2255;
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2255, *var_cases_39_, 3);
  sourceObject = obj2255;
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2255, *var_elsecase_39_, 4);
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  sourceObject = obj2255;
  objclass2255 = obj2255->class;
  objclass2255->definitionModule = modulename;
  objclass2255->definitionLine = 467;
  (*(struct UserObject *)self).data[0] = lowerouter2255;
  self = oldself2255;
  selfslot = oldselfslot2255;
  stackframe = oldstackframe2255;
  gc_frame_end(frame);
  return obj2255;
}
Object meth_ast_matchCaseNode2559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for matchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for matchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast_isExecutable2571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2572 = alloc_Boolean(0);
// compiled identifier node returning bool2572 (depth = 3)
  gc_frame_end(frame);
  return bool2572;
}
Object meth_ast__apply2579(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2580 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2581 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe2580);
// compiled call node returning call2581 (depth = 7)
  gc_frame_end(frame);
  return call2581;
}
Object meth_ast__apply2576(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2577 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2578 = alloc_Block(NULL, NULL, "ast", 558);
  gc_frame_newslot(block2578);
// method "_apply"
  block_savedest(block2578);
  Object closure2579 = createclosure(2, "_apply");
  setclosureframe(closure2579, stackframe);
  addtoclosure(closure2579, var_b);
  addtoclosure(closure2579, selfslot);
  struct UserObject *uo2579 = (struct UserObject*)block2578;
  uo2579->data[0] = (Object)closure2579;
  Method *meth_meth_ast__apply2579 = addmethod2pos(block2578, "_apply", &meth_ast__apply2579, 0);
  int argcv_meth_ast__apply2579[] = {1};
  meth_meth_ast__apply2579->type = alloc_MethodType(1, argcv_meth_ast__apply2579);
  meth_meth_ast__apply2579->definitionModule = modulename;
  meth_meth_ast__apply2579->definitionLine = 468;
// compiled block node returning block2578 (depth = 6)
  gc_frame_newslot(block2578);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call2584 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2583);
// compiled call node returning call2584 (depth = 7)
// compiled member node returning call2584 (depth = 6)
  params[0] = block2578;
  partcv[0] = 1;
  Object call2585 = callmethod(call2584, "do",
    1, partcv, params);
  gc_frame_end(callframe2577);
// compiled call node returning call2585 (depth = 5)
  gc_frame_end(frame);
  return call2585;
}
Object meth_ast_parametersDo2573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2574 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2575 = alloc_Block(NULL, NULL, "ast", 557);
  gc_frame_newslot(block2575);
// method "_apply"
  block_savedest(block2575);
  Object closure2576 = createclosure(2, "_apply");
  setclosureframe(closure2576, stackframe);
  addtoclosure(closure2576, var_b);
  addtoclosure(closure2576, selfslot);
  struct UserObject *uo2576 = (struct UserObject*)block2575;
  uo2576->data[0] = (Object)closure2576;
  Method *meth_meth_ast__apply2576 = addmethod2pos(block2575, "_apply", &meth_ast__apply2576, 0);
  int argcv_meth_ast__apply2576[] = {1};
  meth_meth_ast__apply2576->type = alloc_MethodType(1, argcv_meth_ast__apply2576);
  meth_meth_ast__apply2576->definitionModule = modulename;
  meth_meth_ast__apply2576->definitionLine = 468;
// compiled block node returning block2575 (depth = 4)
  gc_frame_newslot(block2575);
// call case 6: other member request
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2587 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2588 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2587);
// compiled call node returning call2588 (depth = 5)
// compiled member node returning call2588 (depth = 4)
  params[0] = block2575;
  partcv[0] = 1;
  Object call2589 = callmethod(call2588, "do",
    1, partcv, params);
  gc_frame_end(callframe2574);
// compiled call node returning call2589 (depth = 3)
  gc_frame_end(frame);
  return call2589;
}
Object meth_ast_scope_58__61_2590(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2591 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call2592 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2591);
// compiled call node returning call2592 (depth = 3)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2593 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2594 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe2593);
// compiled call node returning call2594 (depth = 3)
  gc_frame_end(frame);
  return call2594;
}
Object meth_ast_declarationKindWithAncestors2595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2596 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call2597 = callmethod(*var_k, "typedec",
    1, partcv, params);
  gc_frame_end(callframe2596);
// compiled call node returning call2597 (depth = 4)
// compiled member node returning call2597 (depth = 3)
  gc_frame_end(frame);
  return call2597;
}
Object meth_ast__apply2630(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2631 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2632 = callmethod(*var_part, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2631);
// compiled call node returning call2632 (depth = 6)
  gc_frame_end(frame);
  return call2632;
}
Object meth_ast_accept_40__41_from2598(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2600 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2601 = callmethod(*var_visitor, "visitMethodType()up",
    2, partcv, params);
  gc_frame_end(callframe2600);
// compiled call node returning call2601 (depth = 4)
  Object if2599 = done;
  if (istrue(call2601)) {
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2602 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2603 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2602);
// compiled call node returning call2603 (depth = 5)
  *var_newChain = call2603;
  if (call2603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2607 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2606);
// compiled call node returning call2607 (depth = 7)
// compiled member node returning call2607 (depth = 6)
  int op_slot_right_2605 = gc_frame_newslot(call2607);
// starting to compile identifier node (depth = 6)
  Object bool2609 = alloc_Boolean(0);
// compiled identifier node returning bool2609 (depth = 6)
  int op_slot_left_2605 = gc_frame_newslot(bool2609);
  params[0] = call2607;
  partcv[0] = 1;
  Object opresult2610 = callmethod(bool2609, "!=", 1, partcv, params);
// compiled op node returning opresult2610 (depth = 5)
  Object if2604 = done;
  if (istrue(opresult2610)) {
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2611 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2612 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2613 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2612);
// compiled call node returning call2613 (depth = 7)
// compiled member node returning call2613 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2614 = callmethod(call2613, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2611);
// compiled call node returning call2614 (depth = 5)
    gc_frame_newslot(call2614);
    if2604 = call2614;
  } else {
  }
// compiled if node returning if2604 (depth = 4)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2617 = alloc_Boolean(0);
// compiled identifier node returning bool2617 (depth = 6)
  int op_slot_right_2616 = gc_frame_newslot(bool2617);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2619 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2620 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2619);
// compiled call node returning call2620 (depth = 7)
// compiled member node returning call2620 (depth = 6)
  int op_slot_left_2616 = gc_frame_newslot(call2620);
  params[0] = bool2617;
  partcv[0] = 1;
  Object opresult2621 = callmethod(call2620, "!=", 1, partcv, params);
// compiled op node returning opresult2621 (depth = 5)
  Object if2615 = done;
  if (istrue(opresult2621)) {
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2622 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2624 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2623);
// compiled call node returning call2624 (depth = 7)
// compiled member node returning call2624 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2625 = callmethod(call2624, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2622);
// compiled call node returning call2625 (depth = 5)
    gc_frame_newslot(call2625);
    if2615 = call2625;
  } else {
  }
// compiled if node returning if2615 (depth = 4)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2626 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2628 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2627);
// compiled call node returning call2628 (depth = 6)
// compiled member node returning call2628 (depth = 5)
  gc_frame_newslot(call2628);
// starting to compile block node (depth = 5)
  Object block2629 = alloc_Block(NULL, NULL, "ast", 577);
  gc_frame_newslot(block2629);
// method "_apply"
  block_savedest(block2629);
  Object closure2630 = createclosure(3, "_apply");
  setclosureframe(closure2630, stackframe);
  addtoclosure(closure2630, var_visitor);
  addtoclosure(closure2630, var_newChain);
  addtoclosure(closure2630, selfslot);
  struct UserObject *uo2630 = (struct UserObject*)block2629;
  uo2630->data[0] = (Object)closure2630;
  Method *meth_meth_ast__apply2630 = addmethod2pos(block2629, "_apply", &meth_ast__apply2630, 0);
  int argcv_meth_ast__apply2630[] = {1};
  meth_meth_ast__apply2630->type = alloc_MethodType(1, argcv_meth_ast__apply2630);
  meth_meth_ast__apply2630->definitionModule = modulename;
  meth_meth_ast__apply2630->definitionLine = 577;
// compiled block node returning block2629 (depth = 5)
  gc_frame_newslot(block2629);
// call case 5: prelude request
  params[0] = call2628;
  params[1] = block2629;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2634 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2626);
// compiled call node returning call2634 (depth = 4)
    gc_frame_newslot(call2634);
    if2599 = call2634;
  } else {
  }
// compiled if node returning if2599 (depth = 3)
  gc_frame_end(frame);
  return if2599;
}
Object meth_ast_map_40__41_ancestors2635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2636 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2637 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2636);
// compiled call node returning call2637 (depth = 5)
// compiled member node returning call2637 (depth = 4)
  *var_n = call2637;
  if (call2637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2638 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2639 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2638);
// compiled call node returning call2639 (depth = 4)
  *var_newChain = call2639;
  if (call2639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2640 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2641 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2642 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2643 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2642);
// compiled call node returning call2643 (depth = 6)
// compiled member node returning call2643 (depth = 5)
  gc_frame_newslot(call2643);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2644 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2645 = gc_frame_new();
// call case 3: self.outer request
  Object call2646 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2645);
// compiled call node returning call2646 (depth = 8)
// compiled member node returning call2646 (depth = 7)
  partcv[0] = 0;
  Object call2647 = callmethodflags(call2646, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2644);
// compiled call node returning call2647 (depth = 6)
// compiled member node returning call2647 (depth = 5)
  params[0] = call2643;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2648 = callmethodflags(call2647, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2641);
// compiled call node returning call2648 (depth = 4)
  gc_frame_newslot(call2648);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2648;
  partcv[0] = 1;
  Object call2649 = callmethod(*var_n, "rtype:=",
    1, partcv, params);
  gc_frame_end(callframe2640);
// compiled call node returning call2649 (depth = 3)
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2650 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2651 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2652 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2653 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2652);
// compiled call node returning call2653 (depth = 6)
// compiled member node returning call2653 (depth = 5)
  gc_frame_newslot(call2653);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2654 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2655 = gc_frame_new();
// call case 3: self.outer request
  Object call2656 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2655);
// compiled call node returning call2656 (depth = 8)
// compiled member node returning call2656 (depth = 7)
  partcv[0] = 0;
  Object call2657 = callmethodflags(call2656, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2654);
// compiled call node returning call2657 (depth = 6)
// compiled member node returning call2657 (depth = 5)
  params[0] = call2653;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2658 = callmethodflags(call2657, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2651);
// compiled call node returning call2658 (depth = 4)
  gc_frame_newslot(call2658);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2658;
  partcv[0] = 1;
  Object call2659 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe2650);
// compiled call node returning call2659 (depth = 3)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2660 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2661 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2662 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2663 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2662);
// compiled call node returning call2663 (depth = 6)
// compiled member node returning call2663 (depth = 5)
  gc_frame_newslot(call2663);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2664 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2665 = gc_frame_new();
// call case 3: self.outer request
  Object call2666 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2665);
// compiled call node returning call2666 (depth = 8)
// compiled member node returning call2666 (depth = 7)
  partcv[0] = 0;
  Object call2667 = callmethodflags(call2666, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2664);
// compiled call node returning call2667 (depth = 6)
// compiled member node returning call2667 (depth = 5)
  params[0] = call2663;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2668 = callmethodflags(call2667, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2661);
// compiled call node returning call2668 (depth = 4)
  gc_frame_newslot(call2668);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2668;
  partcv[0] = 1;
  Object call2669 = callmethod(*var_n, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe2660);
// compiled call node returning call2669 (depth = 3)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2670 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2671 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2670);
// compiled call node returning call2671 (depth = 3)
  gc_frame_end(frame);
  return call2671;
}
Object meth_ast__apply2680(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2682 == NULL) {
    strlit2682 = alloc_String("  ");
    gc_root(strlit2682);
  }
// compiled string node returning strlit2682 (depth = 7)
  int op_slot_right_2681 = gc_frame_newslot(strlit2682);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2681 = gc_frame_newslot(*var_spc);
  params[0] = strlit2682;
  partcv[0] = 1;
  Object opresult2684 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2684 (depth = 6)
  *var_spc = opresult2684;
  if (opresult2684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2819(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2821 == NULL) {
    strlit2821 = alloc_String("");
    gc_root(strlit2821);
  }
// compiled string node returning strlit2821 (depth = 7)
  int op_slot_right_2820 = gc_frame_newslot(strlit2821);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2824 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2826 = alloc_Float64(2);
// compiled num node returning num2826 (depth = 10)
  int op_slot_right_2825 = gc_frame_newslot(num2826);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2825 = gc_frame_newslot(*var_depth);
  params[0] = num2826;
  partcv[0] = 1;
  Object sum2828 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2828 (depth = 9)
  gc_frame_newslot(sum2828);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = sum2828;
  partcv[0] = 1;
  Object call2829 = callmethod(*var_part, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2824);
// compiled call node returning call2829 (depth = 8)
  int op_slot_right_2823 = gc_frame_newslot(call2829);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2832 == NULL) {
    strlit2832 = alloc_String("");
    gc_root(strlit2832);
  }
// compiled string node returning strlit2832 (depth = 9)
  int op_slot_right_2831 = gc_frame_newslot(strlit2832);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2834 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2837 == NULL) {
    strlit2837 = alloc_String("""\x0a""  ");
    gc_root(strlit2837);
  }
// compiled string node returning strlit2837 (depth = 11)
  int op_slot_right_2836 = gc_frame_newslot(strlit2837);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_2839 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit2841 == NULL) {
    strlit2841 = alloc_String("");
    gc_root(strlit2841);
  }
// compiled string node returning strlit2841 (depth = 12)
  int op_slot_left_2839 = gc_frame_newslot(strlit2841);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2842 = callmethod(strlit2841, "++", 1, partcv, params);
// compiled op node returning opresult2842 (depth = 11)
  int op_slot_left_2836 = gc_frame_newslot(opresult2842);
  params[0] = strlit2837;
  partcv[0] = 1;
  Object opresult2843 = callmethod(opresult2842, "++", 1, partcv, params);
// compiled op node returning opresult2843 (depth = 10)
  int op_slot_left_2834 = gc_frame_newslot(opresult2843);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2844 = callmethod(opresult2843, "++", 1, partcv, params);
// compiled op node returning opresult2844 (depth = 9)
  int op_slot_left_2831 = gc_frame_newslot(opresult2844);
  params[0] = strlit2832;
  partcv[0] = 1;
  Object opresult2845 = callmethod(opresult2844, "++", 1, partcv, params);
// compiled op node returning opresult2845 (depth = 8)
  int op_slot_left_2823 = gc_frame_newslot(opresult2845);
  params[0] = call2829;
  partcv[0] = 1;
  Object opresult2846 = callmethod(opresult2845, "++", 1, partcv, params);
// compiled op node returning opresult2846 (depth = 7)
  int op_slot_left_2820 = gc_frame_newslot(opresult2846);
  params[0] = strlit2821;
  partcv[0] = 1;
  Object opresult2847 = callmethod(opresult2846, "++", 1, partcv, params);
// compiled op node returning opresult2847 (depth = 6)
  *var_s = opresult2847;
  if (opresult2847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2673 == NULL) {
    strlit2673 = alloc_String("");
    gc_root(strlit2673);
  }
// compiled string node returning strlit2673 (depth = 4)
  *var_spc = strlit2673;
  if (strlit2673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2674 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2675 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2677 = alloc_Float64(0);
// compiled num node returning num2677 (depth = 5)
  int op_slot_left_2675 = gc_frame_newslot(num2677);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2678 = callmethod(num2677, "..", 1, partcv, params);
// compiled op node returning opresult2678 (depth = 4)
  gc_frame_newslot(opresult2678);
// starting to compile block node (depth = 4)
  Object block2679 = alloc_Block(NULL, NULL, "ast", 592);
  gc_frame_newslot(block2679);
// method "_apply"
  block_savedest(block2679);
  Object closure2680 = createclosure(2, "_apply");
  setclosureframe(closure2680, stackframe);
  addtoclosure(closure2680, var_spc);
  addtoclosure(closure2680, selfslot);
  struct UserObject *uo2680 = (struct UserObject*)block2679;
  uo2680->data[0] = (Object)closure2680;
  Method *meth_meth_ast__apply2680 = addmethod2pos(block2679, "_apply", &meth_ast__apply2680, 0);
  int argcv_meth_ast__apply2680[] = {1};
  meth_meth_ast__apply2680->type = alloc_MethodType(1, argcv_meth_ast__apply2680);
  meth_meth_ast__apply2680->definitionModule = modulename;
  meth_meth_ast__apply2680->definitionLine = 587;
// compiled block node returning block2679 (depth = 4)
  gc_frame_newslot(block2679);
// call case 5: prelude request
  params[0] = opresult2678;
  params[1] = block2679;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2687 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2674);
// compiled call node returning call2687 (depth = 3)
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2689 == NULL) {
    strlit2689 = alloc_String("""\x0a""");
    gc_root(strlit2689);
  }
// compiled string node returning strlit2689 (depth = 5)
  int op_slot_right_2688 = gc_frame_newslot(strlit2689);
// starting to compile call node (depth = 5)
  int callframe2691 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2692 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2691);
// compiled call node returning call2692 (depth = 5)
  int op_slot_left_2688 = gc_frame_newslot(call2692);
  params[0] = strlit2689;
  partcv[0] = 1;
  Object opresult2693 = callmethod(call2692, "++", 1, partcv, params);
// compiled op node returning opresult2693 (depth = 4)
  *var_s = opresult2693;
  if (opresult2693 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2695 == NULL) {
    strlit2695 = alloc_String("""\x0a""");
    gc_root(strlit2695);
  }
// compiled string node returning strlit2695 (depth = 5)
  int op_slot_right_2694 = gc_frame_newslot(strlit2695);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2699 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2698);
// compiled call node returning call2699 (depth = 7)
// compiled member node returning call2699 (depth = 6)
  int op_slot_right_2697 = gc_frame_newslot(call2699);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2702 == NULL) {
    strlit2702 = alloc_String("Name: ");
    gc_root(strlit2702);
  }
// compiled string node returning strlit2702 (depth = 7)
  int op_slot_right_2701 = gc_frame_newslot(strlit2702);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2704 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2707 == NULL) {
    strlit2707 = alloc_String("");
    gc_root(strlit2707);
  }
// compiled string node returning strlit2707 (depth = 9)
  int op_slot_right_2706 = gc_frame_newslot(strlit2707);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_2709 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit2711 == NULL) {
    strlit2711 = alloc_String("");
    gc_root(strlit2711);
  }
// compiled string node returning strlit2711 (depth = 10)
  int op_slot_left_2709 = gc_frame_newslot(strlit2711);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2712 = callmethod(strlit2711, "++", 1, partcv, params);
// compiled op node returning opresult2712 (depth = 9)
  int op_slot_left_2706 = gc_frame_newslot(opresult2712);
  params[0] = strlit2707;
  partcv[0] = 1;
  Object opresult2713 = callmethod(opresult2712, "++", 1, partcv, params);
// compiled op node returning opresult2713 (depth = 8)
  int op_slot_left_2704 = gc_frame_newslot(opresult2713);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2714 = callmethod(opresult2713, "++", 1, partcv, params);
// compiled op node returning opresult2714 (depth = 7)
  int op_slot_left_2701 = gc_frame_newslot(opresult2714);
  params[0] = strlit2702;
  partcv[0] = 1;
  Object opresult2715 = callmethod(opresult2714, "++", 1, partcv, params);
// compiled op node returning opresult2715 (depth = 6)
  int op_slot_left_2697 = gc_frame_newslot(opresult2715);
  params[0] = call2699;
  partcv[0] = 1;
  Object opresult2716 = callmethod(opresult2715, "++", 1, partcv, params);
// compiled op node returning opresult2716 (depth = 5)
  int op_slot_left_2694 = gc_frame_newslot(opresult2716);
  params[0] = strlit2695;
  partcv[0] = 1;
  Object opresult2717 = callmethod(opresult2716, "++", 1, partcv, params);
// compiled op node returning opresult2717 (depth = 4)
  *var_s = opresult2717;
  if (opresult2717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2721 = alloc_Boolean(0);
// compiled identifier node returning bool2721 (depth = 5)
  int op_slot_right_2720 = gc_frame_newslot(bool2721);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2723 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2724 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2723);
// compiled call node returning call2724 (depth = 6)
// compiled member node returning call2724 (depth = 5)
  int op_slot_left_2720 = gc_frame_newslot(call2724);
  params[0] = bool2721;
  partcv[0] = 1;
  Object opresult2725 = callmethod(call2724, "!=", 1, partcv, params);
// compiled op node returning opresult2725 (depth = 4)
  Object if2719 = done;
  if (istrue(opresult2725)) {
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2727 == NULL) {
    strlit2727 = alloc_String("");
    gc_root(strlit2727);
  }
// compiled string node returning strlit2727 (depth = 6)
  int op_slot_right_2726 = gc_frame_newslot(strlit2727);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2730 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2732 = alloc_Float64(2);
// compiled num node returning num2732 (depth = 9)
  int op_slot_right_2731 = gc_frame_newslot(num2732);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2731 = gc_frame_newslot(*var_depth);
  params[0] = num2732;
  partcv[0] = 1;
  Object sum2734 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2734 (depth = 8)
  gc_frame_newslot(sum2734);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2735 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2736 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2735);
// compiled call node returning call2736 (depth = 9)
// compiled member node returning call2736 (depth = 8)
  params[0] = sum2734;
  partcv[0] = 1;
  Object call2737 = callmethod(call2736, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2730);
// compiled call node returning call2737 (depth = 7)
  int op_slot_right_2729 = gc_frame_newslot(call2737);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2740 == NULL) {
    strlit2740 = alloc_String("");
    gc_root(strlit2740);
  }
// compiled string node returning strlit2740 (depth = 8)
  int op_slot_right_2739 = gc_frame_newslot(strlit2740);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2742 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2745 == NULL) {
    strlit2745 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit2745);
  }
// compiled string node returning strlit2745 (depth = 10)
  int op_slot_right_2744 = gc_frame_newslot(strlit2745);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2747 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2750 == NULL) {
    strlit2750 = alloc_String("");
    gc_root(strlit2750);
  }
// compiled string node returning strlit2750 (depth = 12)
  int op_slot_right_2749 = gc_frame_newslot(strlit2750);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_2752 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit2754 == NULL) {
    strlit2754 = alloc_String("");
    gc_root(strlit2754);
  }
// compiled string node returning strlit2754 (depth = 13)
  int op_slot_left_2752 = gc_frame_newslot(strlit2754);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2755 = callmethod(strlit2754, "++", 1, partcv, params);
// compiled op node returning opresult2755 (depth = 12)
  int op_slot_left_2749 = gc_frame_newslot(opresult2755);
  params[0] = strlit2750;
  partcv[0] = 1;
  Object opresult2756 = callmethod(opresult2755, "++", 1, partcv, params);
// compiled op node returning opresult2756 (depth = 11)
  int op_slot_left_2747 = gc_frame_newslot(opresult2756);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2757 = callmethod(opresult2756, "++", 1, partcv, params);
// compiled op node returning opresult2757 (depth = 10)
  int op_slot_left_2744 = gc_frame_newslot(opresult2757);
  params[0] = strlit2745;
  partcv[0] = 1;
  Object opresult2758 = callmethod(opresult2757, "++", 1, partcv, params);
// compiled op node returning opresult2758 (depth = 9)
  int op_slot_left_2742 = gc_frame_newslot(opresult2758);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2759 = callmethod(opresult2758, "++", 1, partcv, params);
// compiled op node returning opresult2759 (depth = 8)
  int op_slot_left_2739 = gc_frame_newslot(opresult2759);
  params[0] = strlit2740;
  partcv[0] = 1;
  Object opresult2760 = callmethod(opresult2759, "++", 1, partcv, params);
// compiled op node returning opresult2760 (depth = 7)
  int op_slot_left_2729 = gc_frame_newslot(opresult2760);
  params[0] = call2737;
  partcv[0] = 1;
  Object opresult2761 = callmethod(opresult2760, "++", 1, partcv, params);
// compiled op node returning opresult2761 (depth = 6)
  int op_slot_left_2726 = gc_frame_newslot(opresult2761);
  params[0] = strlit2727;
  partcv[0] = 1;
  Object opresult2762 = callmethod(opresult2761, "++", 1, partcv, params);
// compiled op node returning opresult2762 (depth = 5)
  *var_s = opresult2762;
  if (opresult2762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2719 = done;
  } else {
  }
// compiled if node returning if2719 (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2766 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2767 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2766);
// compiled call node returning call2767 (depth = 6)
// compiled member node returning call2767 (depth = 5)
  int op_slot_right_2765 = gc_frame_newslot(call2767);
// starting to compile identifier node (depth = 5)
  Object bool2769 = alloc_Boolean(0);
// compiled identifier node returning bool2769 (depth = 5)
  int op_slot_left_2765 = gc_frame_newslot(bool2769);
  params[0] = call2767;
  partcv[0] = 1;
  Object opresult2770 = callmethod(bool2769, "!=", 1, partcv, params);
// compiled op node returning opresult2770 (depth = 4)
  Object if2764 = done;
  if (istrue(opresult2770)) {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String("TypeParams:""\x0a""");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 6)
  int op_slot_right_2771 = gc_frame_newslot(strlit2772);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2774 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2777 == NULL) {
    strlit2777 = alloc_String("""\x0a""");
    gc_root(strlit2777);
  }
// compiled string node returning strlit2777 (depth = 8)
  int op_slot_right_2776 = gc_frame_newslot(strlit2777);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_2779 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit2781 == NULL) {
    strlit2781 = alloc_String("");
    gc_root(strlit2781);
  }
// compiled string node returning strlit2781 (depth = 9)
  int op_slot_left_2779 = gc_frame_newslot(strlit2781);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2782 = callmethod(strlit2781, "++", 1, partcv, params);
// compiled op node returning opresult2782 (depth = 8)
  int op_slot_left_2776 = gc_frame_newslot(opresult2782);
  params[0] = strlit2777;
  partcv[0] = 1;
  Object opresult2783 = callmethod(opresult2782, "++", 1, partcv, params);
// compiled op node returning opresult2783 (depth = 7)
  int op_slot_left_2774 = gc_frame_newslot(opresult2783);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2784 = callmethod(opresult2783, "++", 1, partcv, params);
// compiled op node returning opresult2784 (depth = 6)
  int op_slot_left_2771 = gc_frame_newslot(opresult2784);
  params[0] = strlit2772;
  partcv[0] = 1;
  Object opresult2785 = callmethod(opresult2784, "++", 1, partcv, params);
// compiled op node returning opresult2785 (depth = 5)
  *var_s = opresult2785;
  if (opresult2785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2788 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2790 = alloc_Float64(2);
// compiled num node returning num2790 (depth = 8)
  int op_slot_right_2789 = gc_frame_newslot(num2790);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2789 = gc_frame_newslot(*var_depth);
  params[0] = num2790;
  partcv[0] = 1;
  Object sum2792 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2792 (depth = 7)
  gc_frame_newslot(sum2792);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2794 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2793);
// compiled call node returning call2794 (depth = 8)
// compiled member node returning call2794 (depth = 7)
  params[0] = sum2792;
  partcv[0] = 1;
  Object call2795 = callmethod(call2794, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2788);
// compiled call node returning call2795 (depth = 6)
  int op_slot_right_2787 = gc_frame_newslot(call2795);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2787 = gc_frame_newslot(*var_s);
  params[0] = call2795;
  partcv[0] = 1;
  Object opresult2797 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2797 (depth = 5)
  *var_s = opresult2797;
  if (opresult2797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2764 = done;
  } else {
  }
// compiled if node returning if2764 (depth = 3)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2800 == NULL) {
    strlit2800 = alloc_String("Signature:");
    gc_root(strlit2800);
  }
// compiled string node returning strlit2800 (depth = 5)
  int op_slot_right_2799 = gc_frame_newslot(strlit2800);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2802 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2805 == NULL) {
    strlit2805 = alloc_String("""\x0a""");
    gc_root(strlit2805);
  }
// compiled string node returning strlit2805 (depth = 7)
  int op_slot_right_2804 = gc_frame_newslot(strlit2805);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_2807 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit2809 == NULL) {
    strlit2809 = alloc_String("");
    gc_root(strlit2809);
  }
// compiled string node returning strlit2809 (depth = 8)
  int op_slot_left_2807 = gc_frame_newslot(strlit2809);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2810 = callmethod(strlit2809, "++", 1, partcv, params);
// compiled op node returning opresult2810 (depth = 7)
  int op_slot_left_2804 = gc_frame_newslot(opresult2810);
  params[0] = strlit2805;
  partcv[0] = 1;
  Object opresult2811 = callmethod(opresult2810, "++", 1, partcv, params);
// compiled op node returning opresult2811 (depth = 6)
  int op_slot_left_2802 = gc_frame_newslot(opresult2811);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2812 = callmethod(opresult2811, "++", 1, partcv, params);
// compiled op node returning opresult2812 (depth = 5)
  int op_slot_left_2799 = gc_frame_newslot(opresult2812);
  params[0] = strlit2800;
  partcv[0] = 1;
  Object opresult2813 = callmethod(opresult2812, "++", 1, partcv, params);
// compiled op node returning opresult2813 (depth = 4)
  *var_s = opresult2813;
  if (opresult2813 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2815 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2817 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2816);
// compiled call node returning call2817 (depth = 5)
// compiled member node returning call2817 (depth = 4)
  gc_frame_newslot(call2817);
// starting to compile block node (depth = 4)
  Object block2818 = alloc_Block(NULL, NULL, "ast", 605);
  gc_frame_newslot(block2818);
// method "_apply"
  block_savedest(block2818);
  Object closure2819 = createclosure(4, "_apply");
  setclosureframe(closure2819, stackframe);
  addtoclosure(closure2819, var_depth);
  addtoclosure(closure2819, var_spc);
  addtoclosure(closure2819, var_s);
  addtoclosure(closure2819, selfslot);
  struct UserObject *uo2819 = (struct UserObject*)block2818;
  uo2819->data[0] = (Object)closure2819;
  Method *meth_meth_ast__apply2819 = addmethod2pos(block2818, "_apply", &meth_ast__apply2819, 0);
  int argcv_meth_ast__apply2819[] = {1};
  meth_meth_ast__apply2819->type = alloc_MethodType(1, argcv_meth_ast__apply2819);
  meth_meth_ast__apply2819->definitionModule = modulename;
  meth_meth_ast__apply2819->definitionLine = 605;
// compiled block node returning block2818 (depth = 4)
  gc_frame_newslot(block2818);
// call case 5: prelude request
  params[0] = call2817;
  params[1] = block2818;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2850 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2815);
// compiled call node returning call2850 (depth = 3)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2912(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 9)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call2914 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2913);
// compiled call node returning call2914 (depth = 11)
// compiled member node returning call2914 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2915 = callmethod(call2914, "[]", 1, partcv, params);
// compiled index node returning idxres2915 (depth = 9)
  *var_p = idxres2915;
  if (idxres2915 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2917 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2919 = alloc_Float64(1);
// compiled num node returning num2919 (depth = 12)
  int op_slot_right_2918 = gc_frame_newslot(num2919);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_2918 = gc_frame_newslot(*var_depth);
  params[0] = num2919;
  partcv[0] = 1;
  Object sum2921 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2921 (depth = 11)
  gc_frame_newslot(sum2921);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum2921;
  partcv[0] = 1;
  Object call2922 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2917);
// compiled call node returning call2922 (depth = 10)
  int op_slot_right_2916 = gc_frame_newslot(call2922);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2916 = gc_frame_newslot(*var_s);
  params[0] = call2922;
  partcv[0] = 1;
  Object opresult2924 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2924 (depth = 9)
  *var_s = opresult2924;
  if (opresult2924 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool2929 = alloc_Boolean(0);
// compiled identifier node returning bool2929 (depth = 11)
  int op_slot_right_2928 = gc_frame_newslot(bool2929);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call2932 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2931);
// compiled call node returning call2932 (depth = 12)
// compiled member node returning call2932 (depth = 11)
  int op_slot_left_2928 = gc_frame_newslot(call2932);
  params[0] = bool2929;
  partcv[0] = 1;
  Object opresult2933 = callmethod(call2932, "!=", 1, partcv, params);
// compiled op node returning opresult2933 (depth = 10)
  int op_slot_right_2927 = gc_frame_newslot(opresult2933);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call2938 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2937);
// compiled call node returning call2938 (depth = 14)
// compiled member node returning call2938 (depth = 13)
  partcv[0] = 0;
  Object call2939 = callmethod(call2938, "size",
    1, partcv, params);
  gc_frame_end(callframe2936);
// compiled call node returning call2939 (depth = 12)
// compiled member node returning call2939 (depth = 11)
  int op_slot_right_2935 = gc_frame_newslot(call2939);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pnr (depth = 11)
  int op_slot_left_2935 = gc_frame_newslot(*var_pnr);
  params[0] = call2939;
  partcv[0] = 1;
  Object opresult2941 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult2941 (depth = 10)
  int op_slot_left_2927 = gc_frame_newslot(opresult2941);
  params[0] = opresult2933;
  partcv[0] = 1;
  Object opresult2942 = callmethod(opresult2941, "||", 1, partcv, params);
// compiled op node returning opresult2942 (depth = 9)
  Object if2926 = done;
  if (istrue(opresult2942)) {
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2944 == NULL) {
    strlit2944 = alloc_String(", ");
    gc_root(strlit2944);
  }
// compiled string node returning strlit2944 (depth = 11)
  int op_slot_right_2943 = gc_frame_newslot(strlit2944);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2943 = gc_frame_newslot(*var_s);
  params[0] = strlit2944;
  partcv[0] = 1;
  Object opresult2946 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2946 (depth = 10)
  *var_s = opresult2946;
  if (opresult2946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2926 = done;
  } else {
  }
// compiled if node returning if2926 (depth = 8)
  gc_frame_end(frame);
  return if2926;
}
Object meth_ast__apply2858(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call2861 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2860);
// compiled call node returning call2861 (depth = 8)
// compiled member node returning call2861 (depth = 7)
  int op_slot_right_2859 = gc_frame_newslot(call2861);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2859 = gc_frame_newslot(*var_s);
  params[0] = call2861;
  partcv[0] = 1;
  Object opresult2863 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2863 (depth = 6)
  *var_s = opresult2863;
  if (opresult2863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_firstPart (depth = 6)
  Object if2865 = done;
  if (istrue(*var_firstPart)) {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2866 = alloc_Boolean(0);
// compiled identifier node returning bool2866 (depth = 7)
  *var_firstPart = bool2866;
  if (bool2866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2871 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2870);
// compiled call node returning call2871 (depth = 9)
// compiled member node returning call2871 (depth = 8)
  int op_slot_right_2869 = gc_frame_newslot(call2871);
// starting to compile identifier node (depth = 8)
  Object bool2873 = alloc_Boolean(0);
// compiled identifier node returning bool2873 (depth = 8)
  int op_slot_left_2869 = gc_frame_newslot(bool2873);
  params[0] = call2871;
  partcv[0] = 1;
  Object opresult2874 = callmethod(bool2873, "!=", 1, partcv, params);
// compiled op node returning opresult2874 (depth = 7)
  Object if2868 = done;
  if (istrue(opresult2874)) {
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2875 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2877 = alloc_Float64(1);
// compiled num node returning num2877 (depth = 9)
  int op_slot_right_2876 = gc_frame_newslot(num2877);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2876 = gc_frame_newslot(*var_depth);
  params[0] = num2877;
  partcv[0] = 1;
  Object sum2879 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2879 (depth = 8)
  gc_frame_newslot(sum2879);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2881 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2880);
// compiled call node returning call2881 (depth = 9)
// compiled member node returning call2881 (depth = 8)
  params[0] = sum2879;
  partcv[0] = 1;
  Object call2882 = callmethod(call2881, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2875);
// compiled call node returning call2882 (depth = 7)
    gc_frame_newslot(call2882);
    if2868 = call2882;
  } else {
  }
// compiled if node returning if2868 (depth = 6)
    gc_frame_newslot(if2868);
    if2865 = if2868;
  } else {
  }
// compiled if node returning if2865 (depth = 5)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2886 = alloc_Boolean(0);
// compiled identifier node returning bool2886 (depth = 8)
  int op_slot_right_2885 = gc_frame_newslot(bool2886);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call2889 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2888);
// compiled call node returning call2889 (depth = 9)
// compiled member node returning call2889 (depth = 8)
  int op_slot_left_2885 = gc_frame_newslot(call2889);
  params[0] = bool2886;
  partcv[0] = 1;
  Object opresult2890 = callmethod(call2889, "!=", 1, partcv, params);
// compiled op node returning opresult2890 (depth = 7)
  int op_slot_right_2884 = gc_frame_newslot(opresult2890);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2893 = alloc_Float64(0);
// compiled num node returning num2893 (depth = 8)
  int op_slot_right_2892 = gc_frame_newslot(num2893);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2895 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2896 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call2897 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2896);
// compiled call node returning call2897 (depth = 11)
// compiled member node returning call2897 (depth = 10)
  partcv[0] = 0;
  Object call2898 = callmethod(call2897, "size",
    1, partcv, params);
  gc_frame_end(callframe2895);
// compiled call node returning call2898 (depth = 9)
// compiled member node returning call2898 (depth = 8)
  int op_slot_left_2892 = gc_frame_newslot(call2898);
  params[0] = num2893;
  partcv[0] = 1;
  Object opresult2899 = callmethod(call2898, ">", 1, partcv, params);
// compiled op node returning opresult2899 (depth = 7)
  int op_slot_left_2884 = gc_frame_newslot(opresult2899);
  params[0] = opresult2890;
  partcv[0] = 1;
  Object opresult2900 = callmethod(opresult2899, "||", 1, partcv, params);
// compiled op node returning opresult2900 (depth = 6)
  Object if2883 = done;
  if (istrue(opresult2900)) {
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2902 == NULL) {
    strlit2902 = alloc_String("(");
    gc_root(strlit2902);
  }
// compiled string node returning strlit2902 (depth = 8)
  int op_slot_right_2901 = gc_frame_newslot(strlit2902);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2901 = gc_frame_newslot(*var_s);
  params[0] = strlit2902;
  partcv[0] = 1;
  Object opresult2904 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2904 (depth = 7)
  *var_s = opresult2904;
  if (opresult2904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2906 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2907 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2909 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2908);
// compiled call node returning call2909 (depth = 10)
// compiled member node returning call2909 (depth = 9)
  partcv[0] = 0;
  Object call2910 = callmethod(call2909, "indices",
    1, partcv, params);
  gc_frame_end(callframe2907);
// compiled call node returning call2910 (depth = 8)
// compiled member node returning call2910 (depth = 7)
  gc_frame_newslot(call2910);
// starting to compile block node (depth = 7)
  Object block2911 = alloc_Block(NULL, NULL, "ast", 623);
  gc_frame_newslot(block2911);
// method "_apply"
  block_savedest(block2911);
  Object closure2912 = createclosure(4, "_apply");
  setclosureframe(closure2912, stackframe);
  addtoclosure(closure2912, var_part);
  addtoclosure(closure2912, var_depth);
  addtoclosure(closure2912, var_s);
  addtoclosure(closure2912, selfslot);
  struct UserObject *uo2912 = (struct UserObject*)block2911;
  uo2912->data[0] = (Object)closure2912;
  Method *meth_meth_ast__apply2912 = addmethod2pos(block2911, "_apply", &meth_ast__apply2912, 0);
  int argcv_meth_ast__apply2912[] = {1};
  meth_meth_ast__apply2912->type = alloc_MethodType(1, argcv_meth_ast__apply2912);
  meth_meth_ast__apply2912->definitionModule = modulename;
  meth_meth_ast__apply2912->definitionLine = 623;
// compiled block node returning block2911 (depth = 7)
  gc_frame_newslot(block2911);
// call case 5: prelude request
  params[0] = call2910;
  params[1] = block2911;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2949 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2906);
// compiled call node returning call2949 (depth = 6)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2952 = alloc_Boolean(0);
// compiled identifier node returning bool2952 (depth = 8)
  int op_slot_right_2951 = gc_frame_newslot(bool2952);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call2955 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2954);
// compiled call node returning call2955 (depth = 9)
// compiled member node returning call2955 (depth = 8)
  int op_slot_left_2951 = gc_frame_newslot(call2955);
  params[0] = bool2952;
  partcv[0] = 1;
  Object opresult2956 = callmethod(call2955, "!=", 1, partcv, params);
// compiled op node returning opresult2956 (depth = 7)
  Object if2950 = done;
  if (istrue(opresult2956)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2958 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call2960 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2959);
// compiled call node returning call2960 (depth = 12)
// compiled member node returning call2960 (depth = 11)
  partcv[0] = 0;
  Object call2961 = callmethod(call2960, "value",
    1, partcv, params);
  gc_frame_end(callframe2958);
// compiled call node returning call2961 (depth = 10)
// compiled member node returning call2961 (depth = 9)
  int op_slot_right_2957 = gc_frame_newslot(call2961);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2964 == NULL) {
    strlit2964 = alloc_String("*");
    gc_root(strlit2964);
  }
// compiled string node returning strlit2964 (depth = 10)
  int op_slot_right_2963 = gc_frame_newslot(strlit2964);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2963 = gc_frame_newslot(*var_s);
  params[0] = strlit2964;
  partcv[0] = 1;
  Object opresult2966 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2966 (depth = 9)
  int op_slot_left_2957 = gc_frame_newslot(opresult2966);
  params[0] = call2961;
  partcv[0] = 1;
  Object opresult2967 = callmethod(opresult2966, "++", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 8)
  *var_s = opresult2967;
  if (opresult2967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2950 = done;
  } else {
  }
// compiled if node returning if2950 (depth = 6)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2970 == NULL) {
    strlit2970 = alloc_String(")");
    gc_root(strlit2970);
  }
// compiled string node returning strlit2970 (depth = 8)
  int op_slot_right_2969 = gc_frame_newslot(strlit2970);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2969 = gc_frame_newslot(*var_s);
  params[0] = strlit2970;
  partcv[0] = 1;
  Object opresult2972 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2972 (depth = 7)
  *var_s = opresult2972;
  if (opresult2972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2883 = done;
  } else {
  }
// compiled if node returning if2883 (depth = 5)
  gc_frame_end(frame);
  return if2883;
}
Object meth_ast_toGrace2851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_firstPart = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstPart");
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2852 == NULL) {
    strlit2852 = alloc_String("");
    gc_root(strlit2852);
  }
// compiled string node returning strlit2852 (depth = 4)
  *var_s = strlit2852;
  if (strlit2852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2853 = alloc_Boolean(1);
// compiled identifier node returning bool2853 (depth = 4)
  *var_firstPart = bool2853;
  if (bool2853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2854 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2856 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2855);
// compiled call node returning call2856 (depth = 5)
// compiled member node returning call2856 (depth = 4)
  gc_frame_newslot(call2856);
// starting to compile block node (depth = 4)
  Object block2857 = alloc_Block(NULL, NULL, "ast", 613);
  gc_frame_newslot(block2857);
// method "_apply"
  block_savedest(block2857);
  Object closure2858 = createclosure(4, "_apply");
  setclosureframe(closure2858, stackframe);
  addtoclosure(closure2858, var_s);
  addtoclosure(closure2858, var_firstPart);
  addtoclosure(closure2858, var_depth);
  addtoclosure(closure2858, selfslot);
  struct UserObject *uo2858 = (struct UserObject*)block2857;
  uo2858->data[0] = (Object)closure2858;
  Method *meth_meth_ast__apply2858 = addmethod2pos(block2857, "_apply", &meth_ast__apply2858, 0);
  int argcv_meth_ast__apply2858[] = {1};
  meth_meth_ast__apply2858->type = alloc_MethodType(1, argcv_meth_ast__apply2858);
  meth_meth_ast__apply2858->definitionModule = modulename;
  meth_meth_ast__apply2858->definitionLine = 613;
// compiled block node returning block2857 (depth = 4)
  gc_frame_newslot(block2857);
// call case 5: prelude request
  params[0] = call2856;
  params[1] = block2857;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2975 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2854);
// compiled call node returning call2975 (depth = 3)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2978 = alloc_Boolean(0);
// compiled identifier node returning bool2978 (depth = 5)
  int op_slot_right_2977 = gc_frame_newslot(bool2978);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2980 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2981 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2980);
// compiled call node returning call2981 (depth = 6)
// compiled member node returning call2981 (depth = 5)
  int op_slot_left_2977 = gc_frame_newslot(call2981);
  params[0] = bool2978;
  partcv[0] = 1;
  Object opresult2982 = callmethod(call2981, "!=", 1, partcv, params);
// compiled op node returning opresult2982 (depth = 4)
  Object if2976 = done;
  if (istrue(opresult2982)) {
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2984 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2986 = alloc_Float64(1);
// compiled num node returning num2986 (depth = 8)
  int op_slot_right_2985 = gc_frame_newslot(num2986);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2985 = gc_frame_newslot(*var_depth);
  params[0] = num2986;
  partcv[0] = 1;
  Object sum2988 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2988 (depth = 7)
  gc_frame_newslot(sum2988);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2989 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2990 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2989);
// compiled call node returning call2990 (depth = 8)
// compiled member node returning call2990 (depth = 7)
  params[0] = sum2988;
  partcv[0] = 1;
  Object call2991 = callmethod(call2990, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2984);
// compiled call node returning call2991 (depth = 6)
  int op_slot_right_2983 = gc_frame_newslot(call2991);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2994 == NULL) {
    strlit2994 = alloc_String(" -> ");
    gc_root(strlit2994);
  }
// compiled string node returning strlit2994 (depth = 7)
  int op_slot_right_2993 = gc_frame_newslot(strlit2994);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2993 = gc_frame_newslot(*var_s);
  params[0] = strlit2994;
  partcv[0] = 1;
  Object opresult2996 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2996 (depth = 6)
  int op_slot_left_2983 = gc_frame_newslot(opresult2996);
  params[0] = call2991;
  partcv[0] = 1;
  Object opresult2997 = callmethod(opresult2996, "++", 1, partcv, params);
// compiled op node returning opresult2997 (depth = 5)
  *var_s = opresult2997;
  if (opresult2997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2976 = done;
  } else {
  }
// compiled if node returning if2976 (depth = 3)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2999(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3000 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe3001 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3003 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3002);
// compiled call node returning call3003 (depth = 6)
// compiled member node returning call3003 (depth = 5)
  gc_frame_newslot(call3003);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool3004 = alloc_Boolean(0);
// compiled identifier node returning bool3004 (depth = 5)
  gc_frame_newslot(bool3004);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeNode (depth = 5)
  params[0] = call3003;
  params[1] = *var_emptySeq;
  params[2] = bool3004;
  partcv[0] = 3;
  Object call3005 = callmethod(*var_methodTypeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3001);
// compiled call node returning call3005 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3006 = callmethod(call3005, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3000);
// compiled call node returning call3006 (depth = 3)
  gc_frame_end(frame);
  return call3006;
}
Object meth_ast_new2562(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_methodTypeNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2563 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2563 = alloc_userobj2(19,16, objclass2563);
  gc_frame_newslot(obj2563);
if (objclass2563 == NULL) {
  glfree(obj2563->class->name);
  obj2563->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2563, self, 0);
  addmethodreal(obj2563,"outer", &reader_ast_outer_2564);
  Object oldself2563 = self;
  struct StackFrameObject *oldstackframe2563 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2563);
  gc_frame_newslot((Object)stackframe);
  self = obj2563;
  Object *oldselfslot2563 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2563 = (*(struct UserObject *)self).data[0], lowerouter2563 = thisouter2563;
  if (inheritingObject2563) {
    struct UserObject *inho2563 = (struct UserObject *)inheritingObject2563;
    while (inho2563->super != GraceDefaultObject) inho2563 = (struct UserObject *)inho2563->super;
    inho2563->super = obj2563;
    self = inheritingObject2563;
    *selfslot = self;
    lowerouter2563 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2563;
  }
if (objclass2563 == NULL) {
  Method *reader2565 = addmethodrealflags(obj2563, "kind",&reader_ast_kind_2565, MFLAG_DEF);
  reader2565->definitionModule = modulename;
  reader2565->definitionLine = 548;
}
adddatum2(obj2563, alloc_Undefined(), 1);
if (objclass2563 == NULL) {
  Method *reader2566 = addmethodrealflags(obj2563, "value",&reader_ast_value_2566, 0);
  Method *writer2566 = addmethodrealflags(obj2563, "value:=",&writer_ast_value_2566, 0);
  reader2566->definitionModule = modulename;
  writer2566->definitionModule = modulename;
  reader2566->definitionLine = 549;
  writer2566->definitionLine = 549;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 2);
if (objclass2563 == NULL) {
  Method *reader2567 = addmethodrealflags(obj2563, "signature",&reader_ast_signature_2567, 0);
  Method *writer2567 = addmethodrealflags(obj2563, "signature:=",&writer_ast_signature_2567, 0);
  reader2567->definitionModule = modulename;
  writer2567->definitionModule = modulename;
  reader2567->definitionLine = 550;
  writer2567->definitionLine = 550;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 3);
if (objclass2563 == NULL) {
  Method *reader2568 = addmethodrealflags(obj2563, "rtype",&reader_ast_rtype_2568, 0);
  Method *writer2568 = addmethodrealflags(obj2563, "rtype:=",&writer_ast_rtype_2568, 0);
  reader2568->definitionModule = modulename;
  writer2568->definitionModule = modulename;
  reader2568->definitionLine = 551;
  writer2568->definitionLine = 551;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 4);
if (objclass2563 == NULL) {
  Method *reader2569 = addmethodrealflags(obj2563, "typeParams",&reader_ast_typeParams_2569, 0);
  Method *writer2569 = addmethodrealflags(obj2563, "typeParams:=",&writer_ast_typeParams_2569, 0);
  reader2569->definitionModule = modulename;
  writer2569->definitionModule = modulename;
  reader2569->definitionLine = 552;
  writer2569->definitionLine = 552;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 5);
if (objclass2563 == NULL) {
  Method *reader2570 = addmethodrealflags(obj2563, "nameString",&reader_ast_nameString_2570, MFLAG_DEF);
  reader2570->definitionModule = modulename;
  reader2570->definitionLine = 553;
}
adddatum2(obj2563, alloc_Undefined(), 6);
// method "isExecutable"
  struct UserObject *uo2571 = (struct UserObject*)obj2563;
  uo2571->data[7] = emptyclosure;
  Method *meth_meth_ast_isExecutable2571 = addmethod2pos(obj2563, "isExecutable", &meth_ast_isExecutable2571, 7);
  int argcv_meth_ast_isExecutable2571[] = {0};
  meth_meth_ast_isExecutable2571->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2571);
  meth_meth_ast_isExecutable2571->definitionModule = modulename;
  meth_meth_ast_isExecutable2571->definitionLine = 555;
// method "parametersDo"
  struct UserObject *uo2573 = (struct UserObject*)obj2563;
  uo2573->data[8] = emptyclosure;
  Method *meth_meth_ast_parametersDo2573 = addmethod2pos(obj2563, "parametersDo", &meth_ast_parametersDo2573, 8);
  int argcv_meth_ast_parametersDo2573[] = {1};
  meth_meth_ast_parametersDo2573->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2573);
  meth_meth_ast_parametersDo2573->definitionModule = modulename;
  meth_meth_ast_parametersDo2573->definitionLine = 556;
// method "scope:="
  struct UserObject *uo2590 = (struct UserObject*)obj2563;
  uo2590->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_2590 = addmethod2pos(obj2563, "scope:=", &meth_ast_scope_58__61_2590, 9);
  int argcv_meth_ast_scope_58__61_2590[] = {1};
  meth_meth_ast_scope_58__61_2590->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_2590);
  meth_meth_ast_scope_58__61_2590->definitionModule = modulename;
  meth_meth_ast_scope_58__61_2590->definitionLine = 561;
// method "declarationKindWithAncestors"
  block_savedest(obj2563);
  Object closure2595 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure2595, stackframe);
  addtoclosure(closure2595, var_k);
  struct UserObject *uo2595 = (struct UserObject*)obj2563;
  uo2595->data[10] = (Object)closure2595;
  Method *meth_meth_ast_declarationKindWithAncestors2595 = addmethod2pos(obj2563, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors2595, 10);
  int argcv_meth_ast_declarationKindWithAncestors2595[] = {1};
  meth_meth_ast_declarationKindWithAncestors2595->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors2595);
  meth_meth_ast_declarationKindWithAncestors2595->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors2595->definitionLine = 567;
// method "accept()from"
  struct UserObject *uo2598 = (struct UserObject*)obj2563;
  uo2598->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2598 = addmethod2pos(obj2563, "accept()from", &meth_ast_accept_40__41_from2598, 11);
  int argcv_meth_ast_accept_40__41_from2598[] = {1, 1};
  meth_meth_ast_accept_40__41_from2598->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2598);
  meth_meth_ast_accept_40__41_from2598->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2598->definitionLine = 568;
// method "map()ancestors"
  struct UserObject *uo2635 = (struct UserObject*)obj2563;
  uo2635->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2635 = addmethod2pos(obj2563, "map()ancestors", &meth_ast_map_40__41_ancestors2635, 12);
  int argcv_meth_ast_map_40__41_ancestors2635[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2635->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2635);
  meth_meth_ast_map_40__41_ancestors2635->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2635->definitionLine = 582;
// method "pretty"
  struct UserObject *uo2672 = (struct UserObject*)obj2563;
  uo2672->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2672 = addmethod2pos(obj2563, "pretty", &meth_ast_pretty2672, 13);
  int argcv_meth_ast_pretty2672[] = {1};
  meth_meth_ast_pretty2672->type = alloc_MethodType(1, argcv_meth_ast_pretty2672);
  meth_meth_ast_pretty2672->definitionModule = modulename;
  meth_meth_ast_pretty2672->definitionLine = 590;
// method "toGrace"
  struct UserObject *uo2851 = (struct UserObject*)obj2563;
  uo2851->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2851 = addmethod2pos(obj2563, "toGrace", &meth_ast_toGrace2851, 14);
  int argcv_meth_ast_toGrace2851[] = {1};
  meth_meth_ast_toGrace2851->type = alloc_MethodType(1, argcv_meth_ast_toGrace2851);
meth_meth_ast_toGrace2851->type->types[0] = type_Number;
meth_meth_ast_toGrace2851->type->names[0] = "depth";
  meth_meth_ast_toGrace2851->definitionModule = modulename;
  meth_meth_ast_toGrace2851->definitionLine = 610;
// method "shallowCopy"
  block_savedest(obj2563);
  Object closure2999 = createclosure(2, "shallowCopy");
  setclosureframe(closure2999, stackframe);
  addtoclosure(closure2999, var_emptySeq);
  addtoclosure(closure2999, var_methodTypeNode);
  struct UserObject *uo2999 = (struct UserObject*)obj2563;
  uo2999->data[15] = (Object)closure2999;
  Method *meth_meth_ast_shallowCopy2999 = addmethod2pos(obj2563, "shallowCopy", &meth_ast_shallowCopy2999, 15);
  int argcv_meth_ast_shallowCopy2999[] = {0};
  meth_meth_ast_shallowCopy2999->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2999);
  meth_meth_ast_shallowCopy2999->definitionModule = modulename;
  meth_meth_ast_shallowCopy2999->definitionLine = 641;
  sourceObject = obj2563;
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3007 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3008 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3009 = gc_frame_new();
// call case 3: self.outer request
  Object call3010 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3009);
// compiled call node returning call3010 (depth = 7)
// compiled member node returning call3010 (depth = 6)
  partcv[0] = 0;
  Object call3011 = callmethodflags(call3010, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3008);
// compiled call node returning call3011 (depth = 5)
// compiled member node returning call3011 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3012 = callmethodflags(call3011, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3007);
// compiled call node returning call3012 (depth = 3)
  struct UserObject *obj2563_uo = (struct UserObject *)obj2563;
  obj2563_uo->super = call3012;
  sourceObject = obj2563;
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3013 == NULL) {
    strlit3013 = alloc_String("methodtype");
    gc_root(strlit3013);
  }
// compiled string node returning strlit3013 (depth = 3)
  adddatum2(obj2563, strlit3013, 1);
  sourceObject = obj2563;
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj2563, *var_name_39_, 2);
  sourceObject = obj2563;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2563, *var_signature_39_, 3);
  sourceObject = obj2563;
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2563, *var_rtype_39_, 4);
  sourceObject = obj2563;
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3014 = alloc_Boolean(0);
// compiled identifier node returning bool3014 (depth = 3)
  adddatum2(obj2563, bool3014, 5);
  sourceObject = obj2563;
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3016 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3015);
// compiled call node returning call3016 (depth = 4)
// compiled member node returning call3016 (depth = 3)
  adddatum2(obj2563, call3016, 6);
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  objclass2563 = obj2563->class;
  objclass2563->definitionModule = modulename;
  objclass2563->definitionLine = 530;
  (*(struct UserObject *)self).data[0] = lowerouter2563;
  self = oldself2563;
  selfslot = oldselfslot2563;
  stackframe = oldstackframe2563;
  gc_frame_end(frame);
  return obj2563;
}
Object meth_ast_new2562_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_methodTypeNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2563 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2563 = alloc_userobj2(19,16, objclass2563);
  gc_frame_newslot(obj2563);
if (objclass2563 == NULL) {
  glfree(obj2563->class->name);
  obj2563->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2563, self, 0);
  addmethodreal(obj2563,"outer", &reader_ast_outer_2564);
  Object oldself2563 = self;
  struct StackFrameObject *oldstackframe2563 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2563);
  gc_frame_newslot((Object)stackframe);
  self = obj2563;
  Object *oldselfslot2563 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2563 = (*(struct UserObject *)self).data[0], lowerouter2563 = thisouter2563;
  if (inheritingObject2563) {
    struct UserObject *inho2563 = (struct UserObject *)inheritingObject2563;
    while (inho2563->super != GraceDefaultObject) inho2563 = (struct UserObject *)inho2563->super;
    inho2563->super = obj2563;
    self = inheritingObject2563;
    *selfslot = self;
    lowerouter2563 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2563;
  }
if (objclass2563 == NULL) {
  Method *reader2565 = addmethodrealflags(obj2563, "kind",&reader_ast_kind_2565, MFLAG_DEF);
  reader2565->definitionModule = modulename;
  reader2565->definitionLine = 548;
}
adddatum2(obj2563, alloc_Undefined(), 1);
if (objclass2563 == NULL) {
  Method *reader2566 = addmethodrealflags(obj2563, "value",&reader_ast_value_2566, 0);
  Method *writer2566 = addmethodrealflags(obj2563, "value:=",&writer_ast_value_2566, 0);
  reader2566->definitionModule = modulename;
  writer2566->definitionModule = modulename;
  reader2566->definitionLine = 549;
  writer2566->definitionLine = 549;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 2);
if (objclass2563 == NULL) {
  Method *reader2567 = addmethodrealflags(obj2563, "signature",&reader_ast_signature_2567, 0);
  Method *writer2567 = addmethodrealflags(obj2563, "signature:=",&writer_ast_signature_2567, 0);
  reader2567->definitionModule = modulename;
  writer2567->definitionModule = modulename;
  reader2567->definitionLine = 550;
  writer2567->definitionLine = 550;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 3);
if (objclass2563 == NULL) {
  Method *reader2568 = addmethodrealflags(obj2563, "rtype",&reader_ast_rtype_2568, 0);
  Method *writer2568 = addmethodrealflags(obj2563, "rtype:=",&writer_ast_rtype_2568, 0);
  reader2568->definitionModule = modulename;
  writer2568->definitionModule = modulename;
  reader2568->definitionLine = 551;
  writer2568->definitionLine = 551;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 4);
if (objclass2563 == NULL) {
  Method *reader2569 = addmethodrealflags(obj2563, "typeParams",&reader_ast_typeParams_2569, 0);
  Method *writer2569 = addmethodrealflags(obj2563, "typeParams:=",&writer_ast_typeParams_2569, 0);
  reader2569->definitionModule = modulename;
  writer2569->definitionModule = modulename;
  reader2569->definitionLine = 552;
  writer2569->definitionLine = 552;
}
obj2563->flags |= OFLAG_MUTABLE;
adddatum2(obj2563, alloc_Undefined(), 5);
if (objclass2563 == NULL) {
  Method *reader2570 = addmethodrealflags(obj2563, "nameString",&reader_ast_nameString_2570, MFLAG_DEF);
  reader2570->definitionModule = modulename;
  reader2570->definitionLine = 553;
}
adddatum2(obj2563, alloc_Undefined(), 6);
// method "isExecutable"
  struct UserObject *uo2571 = (struct UserObject*)obj2563;
  uo2571->data[7] = emptyclosure;
  Method *meth_meth_ast_isExecutable2571 = addmethod2pos(obj2563, "isExecutable", &meth_ast_isExecutable2571, 7);
  int argcv_meth_ast_isExecutable2571[] = {0};
  meth_meth_ast_isExecutable2571->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2571);
  meth_meth_ast_isExecutable2571->definitionModule = modulename;
  meth_meth_ast_isExecutable2571->definitionLine = 555;
// method "parametersDo"
  struct UserObject *uo2573 = (struct UserObject*)obj2563;
  uo2573->data[8] = emptyclosure;
  Method *meth_meth_ast_parametersDo2573 = addmethod2pos(obj2563, "parametersDo", &meth_ast_parametersDo2573, 8);
  int argcv_meth_ast_parametersDo2573[] = {1};
  meth_meth_ast_parametersDo2573->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2573);
  meth_meth_ast_parametersDo2573->definitionModule = modulename;
  meth_meth_ast_parametersDo2573->definitionLine = 556;
// method "scope:="
  struct UserObject *uo2590 = (struct UserObject*)obj2563;
  uo2590->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_2590 = addmethod2pos(obj2563, "scope:=", &meth_ast_scope_58__61_2590, 9);
  int argcv_meth_ast_scope_58__61_2590[] = {1};
  meth_meth_ast_scope_58__61_2590->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_2590);
  meth_meth_ast_scope_58__61_2590->definitionModule = modulename;
  meth_meth_ast_scope_58__61_2590->definitionLine = 561;
// method "declarationKindWithAncestors"
  block_savedest(obj2563);
  Object closure2595 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure2595, stackframe);
  addtoclosure(closure2595, var_k);
  struct UserObject *uo2595 = (struct UserObject*)obj2563;
  uo2595->data[10] = (Object)closure2595;
  Method *meth_meth_ast_declarationKindWithAncestors2595 = addmethod2pos(obj2563, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors2595, 10);
  int argcv_meth_ast_declarationKindWithAncestors2595[] = {1};
  meth_meth_ast_declarationKindWithAncestors2595->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors2595);
  meth_meth_ast_declarationKindWithAncestors2595->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors2595->definitionLine = 567;
// method "accept()from"
  struct UserObject *uo2598 = (struct UserObject*)obj2563;
  uo2598->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2598 = addmethod2pos(obj2563, "accept()from", &meth_ast_accept_40__41_from2598, 11);
  int argcv_meth_ast_accept_40__41_from2598[] = {1, 1};
  meth_meth_ast_accept_40__41_from2598->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2598);
  meth_meth_ast_accept_40__41_from2598->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2598->definitionLine = 568;
// method "map()ancestors"
  struct UserObject *uo2635 = (struct UserObject*)obj2563;
  uo2635->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2635 = addmethod2pos(obj2563, "map()ancestors", &meth_ast_map_40__41_ancestors2635, 12);
  int argcv_meth_ast_map_40__41_ancestors2635[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2635->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2635);
  meth_meth_ast_map_40__41_ancestors2635->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2635->definitionLine = 582;
// method "pretty"
  struct UserObject *uo2672 = (struct UserObject*)obj2563;
  uo2672->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2672 = addmethod2pos(obj2563, "pretty", &meth_ast_pretty2672, 13);
  int argcv_meth_ast_pretty2672[] = {1};
  meth_meth_ast_pretty2672->type = alloc_MethodType(1, argcv_meth_ast_pretty2672);
  meth_meth_ast_pretty2672->definitionModule = modulename;
  meth_meth_ast_pretty2672->definitionLine = 590;
// method "toGrace"
  struct UserObject *uo2851 = (struct UserObject*)obj2563;
  uo2851->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2851 = addmethod2pos(obj2563, "toGrace", &meth_ast_toGrace2851, 14);
  int argcv_meth_ast_toGrace2851[] = {1};
  meth_meth_ast_toGrace2851->type = alloc_MethodType(1, argcv_meth_ast_toGrace2851);
meth_meth_ast_toGrace2851->type->types[0] = type_Number;
meth_meth_ast_toGrace2851->type->names[0] = "depth";
  meth_meth_ast_toGrace2851->definitionModule = modulename;
  meth_meth_ast_toGrace2851->definitionLine = 610;
// method "shallowCopy"
  block_savedest(obj2563);
  Object closure2999 = createclosure(2, "shallowCopy");
  setclosureframe(closure2999, stackframe);
  addtoclosure(closure2999, var_emptySeq);
  addtoclosure(closure2999, var_methodTypeNode);
  struct UserObject *uo2999 = (struct UserObject*)obj2563;
  uo2999->data[15] = (Object)closure2999;
  Method *meth_meth_ast_shallowCopy2999 = addmethod2pos(obj2563, "shallowCopy", &meth_ast_shallowCopy2999, 15);
  int argcv_meth_ast_shallowCopy2999[] = {0};
  meth_meth_ast_shallowCopy2999->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2999);
  meth_meth_ast_shallowCopy2999->definitionModule = modulename;
  meth_meth_ast_shallowCopy2999->definitionLine = 641;
  sourceObject = obj2563;
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3007 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3008 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3009 = gc_frame_new();
// call case 3: self.outer request
  Object call3010 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3009);
// compiled call node returning call3010 (depth = 7)
// compiled member node returning call3010 (depth = 6)
  partcv[0] = 0;
  Object call3011 = callmethodflags(call3010, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3008);
// compiled call node returning call3011 (depth = 5)
// compiled member node returning call3011 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3012 = callmethodflags(call3011, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3007);
// compiled call node returning call3012 (depth = 3)
  struct UserObject *obj2563_uo = (struct UserObject *)obj2563;
  obj2563_uo->super = call3012;
  sourceObject = obj2563;
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3013 == NULL) {
    strlit3013 = alloc_String("methodtype");
    gc_root(strlit3013);
  }
// compiled string node returning strlit3013 (depth = 3)
  adddatum2(obj2563, strlit3013, 1);
  sourceObject = obj2563;
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj2563, *var_name_39_, 2);
  sourceObject = obj2563;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2563, *var_signature_39_, 3);
  sourceObject = obj2563;
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2563, *var_rtype_39_, 4);
  sourceObject = obj2563;
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3014 = alloc_Boolean(0);
// compiled identifier node returning bool3014 (depth = 3)
  adddatum2(obj2563, bool3014, 5);
  sourceObject = obj2563;
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3016 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3015);
// compiled call node returning call3016 (depth = 4)
// compiled member node returning call3016 (depth = 3)
  adddatum2(obj2563, call3016, 6);
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  sourceObject = obj2563;
  objclass2563 = obj2563->class;
  objclass2563->definitionModule = modulename;
  objclass2563->definitionLine = 530;
  (*(struct UserObject *)self).data[0] = lowerouter2563;
  self = oldself2563;
  selfslot = oldselfslot2563;
  stackframe = oldstackframe2563;
  gc_frame_end(frame);
  return obj2563;
}
Object meth_ast_methodTypeNode3018(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodTypeNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for methodTypeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast_name3030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3032 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3031);
// compiled call node returning call3032 (depth = 4)
// compiled member node returning call3032 (depth = 3)
  gc_frame_end(frame);
  return call3032;
}
Object meth_ast_name_58__61_3033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for name:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3034 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3035 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3034);
// compiled call node returning call3035 (depth = 3)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3036 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3037 = alloc_Boolean(0);
// compiled identifier node returning bool3037 (depth = 4)
  gc_frame_newslot(bool3037);
// call case 4: self request
  params[0] = bool3037;
  partcv[0] = 1;
  Object call3038 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3036);
// compiled call node returning call3038 (depth = 3)
  gc_frame_end(frame);
  return call3038;
}
Object meth_ast_asString3039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3041 == NULL) {
    strlit3041 = alloc_String("");
    gc_root(strlit3041);
  }
// compiled string node returning strlit3041 (depth = 4)
  int op_slot_right_3040 = gc_frame_newslot(strlit3041);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3044 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3045 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3044);
// compiled call node returning call3045 (depth = 6)
// compiled member node returning call3045 (depth = 5)
  int op_slot_right_3043 = gc_frame_newslot(call3045);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3048 == NULL) {
    strlit3048 = alloc_String(", types = ");
    gc_root(strlit3048);
  }
// compiled string node returning strlit3048 (depth = 6)
  int op_slot_right_3047 = gc_frame_newslot(strlit3048);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3052 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3051);
// compiled call node returning call3052 (depth = 8)
// compiled member node returning call3052 (depth = 7)
  int op_slot_right_3050 = gc_frame_newslot(call3052);
// starting to compile string node (depth = 7)
  if (strlit3054 == NULL) {
    strlit3054 = alloc_String("typeliteral: methods = ");
    gc_root(strlit3054);
  }
// compiled string node returning strlit3054 (depth = 7)
  int op_slot_left_3050 = gc_frame_newslot(strlit3054);
  params[0] = call3052;
  partcv[0] = 1;
  Object opresult3055 = callmethod(strlit3054, "++", 1, partcv, params);
// compiled op node returning opresult3055 (depth = 6)
  int op_slot_left_3047 = gc_frame_newslot(opresult3055);
  params[0] = strlit3048;
  partcv[0] = 1;
  Object opresult3056 = callmethod(opresult3055, "++", 1, partcv, params);
// compiled op node returning opresult3056 (depth = 5)
  int op_slot_left_3043 = gc_frame_newslot(opresult3056);
  params[0] = call3045;
  partcv[0] = 1;
  Object opresult3057 = callmethod(opresult3056, "++", 1, partcv, params);
// compiled op node returning opresult3057 (depth = 4)
  int op_slot_left_3040 = gc_frame_newslot(opresult3057);
  params[0] = strlit3041;
  partcv[0] = 1;
  Object opresult3058 = callmethod(opresult3057, "++", 1, partcv, params);
// compiled op node returning opresult3058 (depth = 3)
  gc_frame_end(frame);
  return opresult3058;
}
Object meth_ast_declarationKindWithAncestors3059(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call3061 = callmethod(*var_k, "typedec",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compiled call node returning call3061 (depth = 4)
// compiled member node returning call3061 (depth = 3)
  gc_frame_end(frame);
  return call3061;
}
Object meth_ast_isExecutable3062(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3063 = alloc_Boolean(0);
// compiled identifier node returning bool3063 (depth = 3)
  gc_frame_end(frame);
  return bool3063;
}
Object meth_ast__apply3074(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3075 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3076 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3075);
// compiled call node returning call3076 (depth = 6)
  gc_frame_end(frame);
  return call3076;
}
Object meth_ast__apply3083(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3084 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3085 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3084);
// compiled call node returning call3085 (depth = 6)
  gc_frame_end(frame);
  return call3085;
}
Object meth_ast_accept_40__41_from3064(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3066 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3067 = callmethod(*var_visitor, "visitTypeLiteral()up",
    2, partcv, params);
  gc_frame_end(callframe3066);
// compiled call node returning call3067 (depth = 4)
  Object if3065 = done;
  if (istrue(call3067)) {
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3068 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3069 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3068);
// compiled call node returning call3069 (depth = 5)
  *var_newChain = call3069;
  if (call3069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3070 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3071 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3072 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3071);
// compiled call node returning call3072 (depth = 6)
// compiled member node returning call3072 (depth = 5)
  gc_frame_newslot(call3072);
// starting to compile block node (depth = 5)
  Object block3073 = alloc_Block(NULL, NULL, "ast", 670);
  gc_frame_newslot(block3073);
// method "_apply"
  block_savedest(block3073);
  Object closure3074 = createclosure(3, "_apply");
  setclosureframe(closure3074, stackframe);
  addtoclosure(closure3074, var_visitor);
  addtoclosure(closure3074, var_newChain);
  addtoclosure(closure3074, selfslot);
  struct UserObject *uo3074 = (struct UserObject*)block3073;
  uo3074->data[0] = (Object)closure3074;
  Method *meth_meth_ast__apply3074 = addmethod2pos(block3073, "_apply", &meth_ast__apply3074, 0);
  int argcv_meth_ast__apply3074[] = {1};
  meth_meth_ast__apply3074->type = alloc_MethodType(1, argcv_meth_ast__apply3074);
  meth_meth_ast__apply3074->definitionModule = modulename;
  meth_meth_ast__apply3074->definitionLine = 670;
// compiled block node returning block3073 (depth = 5)
  gc_frame_newslot(block3073);
// call case 5: prelude request
  params[0] = call3072;
  params[1] = block3073;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3078 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3070);
// compiled call node returning call3078 (depth = 4)
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3079 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3080 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3081 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3080);
// compiled call node returning call3081 (depth = 6)
// compiled member node returning call3081 (depth = 5)
  gc_frame_newslot(call3081);
// starting to compile block node (depth = 5)
  Object block3082 = alloc_Block(NULL, NULL, "ast", 673);
  gc_frame_newslot(block3082);
// method "_apply"
  block_savedest(block3082);
  Object closure3083 = createclosure(3, "_apply");
  setclosureframe(closure3083, stackframe);
  addtoclosure(closure3083, var_visitor);
  addtoclosure(closure3083, var_newChain);
  addtoclosure(closure3083, selfslot);
  struct UserObject *uo3083 = (struct UserObject*)block3082;
  uo3083->data[0] = (Object)closure3083;
  Method *meth_meth_ast__apply3083 = addmethod2pos(block3082, "_apply", &meth_ast__apply3083, 0);
  int argcv_meth_ast__apply3083[] = {1};
  meth_meth_ast__apply3083->type = alloc_MethodType(1, argcv_meth_ast__apply3083);
  meth_meth_ast__apply3083->definitionModule = modulename;
  meth_meth_ast__apply3083->definitionLine = 673;
// compiled block node returning block3082 (depth = 5)
  gc_frame_newslot(block3082);
// call case 5: prelude request
  params[0] = call3081;
  params[1] = block3082;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3087 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3079);
// compiled call node returning call3087 (depth = 4)
    gc_frame_newslot(call3087);
    if3065 = call3087;
  } else {
  }
// compiled if node returning if3065 (depth = 3)
  gc_frame_end(frame);
  return if3065;
}
Object meth_ast_map_40__41_ancestors3088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3090 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3089);
// compiled call node returning call3090 (depth = 5)
// compiled member node returning call3090 (depth = 4)
  *var_n = call3090;
  if (call3090 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3091 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3092 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3091);
// compiled call node returning call3092 (depth = 4)
  *var_newChain = call3092;
  if (call3092 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3093 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3094 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3096 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3095);
// compiled call node returning call3096 (depth = 6)
// compiled member node returning call3096 (depth = 5)
  gc_frame_newslot(call3096);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3097 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3098 = gc_frame_new();
// call case 3: self.outer request
  Object call3099 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3098);
// compiled call node returning call3099 (depth = 8)
// compiled member node returning call3099 (depth = 7)
  partcv[0] = 0;
  Object call3100 = callmethodflags(call3099, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3097);
// compiled call node returning call3100 (depth = 6)
// compiled member node returning call3100 (depth = 5)
  params[0] = call3096;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3101 = callmethodflags(call3100, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3094);
// compiled call node returning call3101 (depth = 4)
  gc_frame_newslot(call3101);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3101;
  partcv[0] = 1;
  Object call3102 = callmethod(*var_n, "methods:=",
    1, partcv, params);
  gc_frame_end(callframe3093);
// compiled call node returning call3102 (depth = 3)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3103 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3104 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3105 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3106 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3105);
// compiled call node returning call3106 (depth = 6)
// compiled member node returning call3106 (depth = 5)
  gc_frame_newslot(call3106);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3107 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3108 = gc_frame_new();
// call case 3: self.outer request
  Object call3109 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3108);
// compiled call node returning call3109 (depth = 8)
// compiled member node returning call3109 (depth = 7)
  partcv[0] = 0;
  Object call3110 = callmethodflags(call3109, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3107);
// compiled call node returning call3110 (depth = 6)
// compiled member node returning call3110 (depth = 5)
  params[0] = call3106;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3111 = callmethodflags(call3110, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3104);
// compiled call node returning call3111 (depth = 4)
  gc_frame_newslot(call3111);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3111;
  partcv[0] = 1;
  Object call3112 = callmethod(*var_n, "types:=",
    1, partcv, params);
  gc_frame_end(callframe3103);
// compiled call node returning call3112 (depth = 3)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3113 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3114 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3113);
// compiled call node returning call3114 (depth = 3)
  gc_frame_end(frame);
  return call3114;
}
Object meth_ast__apply3123(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3125 == NULL) {
    strlit3125 = alloc_String("  ");
    gc_root(strlit3125);
  }
// compiled string node returning strlit3125 (depth = 7)
  int op_slot_right_3124 = gc_frame_newslot(strlit3125);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3124 = gc_frame_newslot(*var_spc);
  params[0] = strlit3125;
  partcv[0] = 1;
  Object opresult3127 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3127 (depth = 6)
  *var_spc = opresult3127;
  if (opresult3127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3153(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3155 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3157 = alloc_Float64(2);
// compiled num node returning num3157 (depth = 9)
  int op_slot_right_3156 = gc_frame_newslot(num3157);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3156 = gc_frame_newslot(*var_depth);
  params[0] = num3157;
  partcv[0] = 1;
  Object sum3159 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3159 (depth = 8)
  gc_frame_newslot(sum3159);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3159;
  partcv[0] = 1;
  Object call3160 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3155);
// compiled call node returning call3160 (depth = 7)
  int op_slot_right_3154 = gc_frame_newslot(call3160);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3162 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3165 == NULL) {
    strlit3165 = alloc_String("""\x0a""  ");
    gc_root(strlit3165);
  }
// compiled string node returning strlit3165 (depth = 9)
  int op_slot_right_3164 = gc_frame_newslot(strlit3165);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3164 = gc_frame_newslot(*var_s);
  params[0] = strlit3165;
  partcv[0] = 1;
  Object opresult3167 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3167 (depth = 8)
  int op_slot_left_3162 = gc_frame_newslot(opresult3167);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3168 = callmethod(opresult3167, "++", 1, partcv, params);
// compiled op node returning opresult3168 (depth = 7)
  int op_slot_left_3154 = gc_frame_newslot(opresult3168);
  params[0] = call3160;
  partcv[0] = 1;
  Object opresult3169 = callmethod(opresult3168, "++", 1, partcv, params);
// compiled op node returning opresult3169 (depth = 6)
  *var_s = opresult3169;
  if (opresult3169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3189(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3191 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3193 = alloc_Float64(2);
// compiled num node returning num3193 (depth = 9)
  int op_slot_right_3192 = gc_frame_newslot(num3193);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3192 = gc_frame_newslot(*var_depth);
  params[0] = num3193;
  partcv[0] = 1;
  Object sum3195 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3195 (depth = 8)
  gc_frame_newslot(sum3195);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3195;
  partcv[0] = 1;
  Object call3196 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3191);
// compiled call node returning call3196 (depth = 7)
  int op_slot_right_3190 = gc_frame_newslot(call3196);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3198 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3201 == NULL) {
    strlit3201 = alloc_String("""\x0a""  ");
    gc_root(strlit3201);
  }
// compiled string node returning strlit3201 (depth = 9)
  int op_slot_right_3200 = gc_frame_newslot(strlit3201);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3200 = gc_frame_newslot(*var_s);
  params[0] = strlit3201;
  partcv[0] = 1;
  Object opresult3203 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3203 (depth = 8)
  int op_slot_left_3198 = gc_frame_newslot(opresult3203);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3204 = callmethod(opresult3203, "++", 1, partcv, params);
// compiled op node returning opresult3204 (depth = 7)
  int op_slot_left_3190 = gc_frame_newslot(opresult3204);
  params[0] = call3196;
  partcv[0] = 1;
  Object opresult3205 = callmethod(opresult3204, "++", 1, partcv, params);
// compiled op node returning opresult3205 (depth = 6)
  *var_s = opresult3205;
  if (opresult3205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3115(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3116 == NULL) {
    strlit3116 = alloc_String("");
    gc_root(strlit3116);
  }
// compiled string node returning strlit3116 (depth = 4)
  *var_spc = strlit3116;
  if (strlit3116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3117 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3118 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3120 = alloc_Float64(0);
// compiled num node returning num3120 (depth = 5)
  int op_slot_left_3118 = gc_frame_newslot(num3120);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3121 = callmethod(num3120, "..", 1, partcv, params);
// compiled op node returning opresult3121 (depth = 4)
  gc_frame_newslot(opresult3121);
// starting to compile block node (depth = 4)
  Object block3122 = alloc_Block(NULL, NULL, "ast", 687);
  gc_frame_newslot(block3122);
// method "_apply"
  block_savedest(block3122);
  Object closure3123 = createclosure(2, "_apply");
  setclosureframe(closure3123, stackframe);
  addtoclosure(closure3123, var_spc);
  addtoclosure(closure3123, selfslot);
  struct UserObject *uo3123 = (struct UserObject*)block3122;
  uo3123->data[0] = (Object)closure3123;
  Method *meth_meth_ast__apply3123 = addmethod2pos(block3122, "_apply", &meth_ast__apply3123, 0);
  int argcv_meth_ast__apply3123[] = {1};
  meth_meth_ast__apply3123->type = alloc_MethodType(1, argcv_meth_ast__apply3123);
  meth_meth_ast__apply3123->definitionModule = modulename;
  meth_meth_ast__apply3123->definitionLine = 682;
// compiled block node returning block3122 (depth = 4)
  gc_frame_newslot(block3122);
// call case 5: prelude request
  params[0] = opresult3121;
  params[1] = block3122;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3130 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3117);
// compiled call node returning call3130 (depth = 3)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3132 == NULL) {
    strlit3132 = alloc_String("""\x0a""");
    gc_root(strlit3132);
  }
// compiled string node returning strlit3132 (depth = 5)
  int op_slot_right_3131 = gc_frame_newslot(strlit3132);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3135 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3136 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3135);
// compiled call node returning call3136 (depth = 6)
  int op_slot_right_3134 = gc_frame_newslot(call3136);
// starting to compile string node (depth = 6)
  if (strlit3138 == NULL) {
    strlit3138 = alloc_String("");
    gc_root(strlit3138);
  }
// compiled string node returning strlit3138 (depth = 6)
  int op_slot_left_3134 = gc_frame_newslot(strlit3138);
  params[0] = call3136;
  partcv[0] = 1;
  Object opresult3139 = callmethod(strlit3138, "++", 1, partcv, params);
// compiled op node returning opresult3139 (depth = 5)
  int op_slot_left_3131 = gc_frame_newslot(opresult3139);
  params[0] = strlit3132;
  partcv[0] = 1;
  Object opresult3140 = callmethod(opresult3139, "++", 1, partcv, params);
// compiled op node returning opresult3140 (depth = 4)
  *var_s = opresult3140;
  if (opresult3140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3142 == NULL) {
    strlit3142 = alloc_String("Types:");
    gc_root(strlit3142);
  }
// compiled string node returning strlit3142 (depth = 5)
  int op_slot_right_3141 = gc_frame_newslot(strlit3142);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3144 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3144 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3146 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3146 (depth = 5)
  int op_slot_left_3141 = gc_frame_newslot(opresult3146);
  params[0] = strlit3142;
  partcv[0] = 1;
  Object opresult3147 = callmethod(opresult3146, "++", 1, partcv, params);
// compiled op node returning opresult3147 (depth = 4)
  *var_s = opresult3147;
  if (opresult3147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3149 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3151 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3150);
// compiled call node returning call3151 (depth = 5)
// compiled member node returning call3151 (depth = 4)
  gc_frame_newslot(call3151);
// starting to compile block node (depth = 4)
  Object block3152 = alloc_Block(NULL, NULL, "ast", 692);
  gc_frame_newslot(block3152);
// method "_apply"
  block_savedest(block3152);
  Object closure3153 = createclosure(4, "_apply");
  setclosureframe(closure3153, stackframe);
  addtoclosure(closure3153, var_depth);
  addtoclosure(closure3153, var_spc);
  addtoclosure(closure3153, var_s);
  addtoclosure(closure3153, selfslot);
  struct UserObject *uo3153 = (struct UserObject*)block3152;
  uo3153->data[0] = (Object)closure3153;
  Method *meth_meth_ast__apply3153 = addmethod2pos(block3152, "_apply", &meth_ast__apply3153, 0);
  int argcv_meth_ast__apply3153[] = {1};
  meth_meth_ast__apply3153->type = alloc_MethodType(1, argcv_meth_ast__apply3153);
  meth_meth_ast__apply3153->definitionModule = modulename;
  meth_meth_ast__apply3153->definitionLine = 692;
// compiled block node returning block3152 (depth = 4)
  gc_frame_newslot(block3152);
// call case 5: prelude request
  params[0] = call3151;
  params[1] = block3152;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3172 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3149);
// compiled call node returning call3172 (depth = 3)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3174 == NULL) {
    strlit3174 = alloc_String("Methods:");
    gc_root(strlit3174);
  }
// compiled string node returning strlit3174 (depth = 5)
  int op_slot_right_3173 = gc_frame_newslot(strlit3174);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3176 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3179 == NULL) {
    strlit3179 = alloc_String("""\x0a""");
    gc_root(strlit3179);
  }
// compiled string node returning strlit3179 (depth = 7)
  int op_slot_right_3178 = gc_frame_newslot(strlit3179);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3178 = gc_frame_newslot(*var_s);
  params[0] = strlit3179;
  partcv[0] = 1;
  Object opresult3181 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3181 (depth = 6)
  int op_slot_left_3176 = gc_frame_newslot(opresult3181);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3182 = callmethod(opresult3181, "++", 1, partcv, params);
// compiled op node returning opresult3182 (depth = 5)
  int op_slot_left_3173 = gc_frame_newslot(opresult3182);
  params[0] = strlit3174;
  partcv[0] = 1;
  Object opresult3183 = callmethod(opresult3182, "++", 1, partcv, params);
// compiled op node returning opresult3183 (depth = 4)
  *var_s = opresult3183;
  if (opresult3183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3185 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3186 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3187 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3186);
// compiled call node returning call3187 (depth = 5)
// compiled member node returning call3187 (depth = 4)
  gc_frame_newslot(call3187);
// starting to compile block node (depth = 4)
  Object block3188 = alloc_Block(NULL, NULL, "ast", 696);
  gc_frame_newslot(block3188);
// method "_apply"
  block_savedest(block3188);
  Object closure3189 = createclosure(4, "_apply");
  setclosureframe(closure3189, stackframe);
  addtoclosure(closure3189, var_depth);
  addtoclosure(closure3189, var_spc);
  addtoclosure(closure3189, var_s);
  addtoclosure(closure3189, selfslot);
  struct UserObject *uo3189 = (struct UserObject*)block3188;
  uo3189->data[0] = (Object)closure3189;
  Method *meth_meth_ast__apply3189 = addmethod2pos(block3188, "_apply", &meth_ast__apply3189, 0);
  int argcv_meth_ast__apply3189[] = {1};
  meth_meth_ast__apply3189->type = alloc_MethodType(1, argcv_meth_ast__apply3189);
  meth_meth_ast__apply3189->definitionModule = modulename;
  meth_meth_ast__apply3189->definitionLine = 696;
// compiled block node returning block3188 (depth = 4)
  gc_frame_newslot(block3188);
// call case 5: prelude request
  params[0] = call3187;
  params[1] = block3188;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3208 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3185);
// compiled call node returning call3208 (depth = 3)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3210 == NULL) {
    strlit3210 = alloc_String("""\x0a""");
    gc_root(strlit3210);
  }
// compiled string node returning strlit3210 (depth = 5)
  int op_slot_right_3209 = gc_frame_newslot(strlit3210);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3209 = gc_frame_newslot(*var_s);
  params[0] = strlit3210;
  partcv[0] = 1;
  Object opresult3212 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3212 (depth = 4)
  *var_s = opresult3212;
  if (opresult3212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3226(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3228 == NULL) {
    strlit3228 = alloc_String("    ");
    gc_root(strlit3228);
  }
// compiled string node returning strlit3228 (depth = 7)
  int op_slot_right_3227 = gc_frame_newslot(strlit3228);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3227 = gc_frame_newslot(*var_spc);
  params[0] = strlit3228;
  partcv[0] = 1;
  Object opresult3230 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3230 (depth = 6)
  *var_spc = opresult3230;
  if (opresult3230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3244(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3246 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3248 = alloc_Float64(1);
// compiled num node returning num3248 (depth = 9)
  int op_slot_right_3247 = gc_frame_newslot(num3248);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3247 = gc_frame_newslot(*var_depth);
  params[0] = num3248;
  partcv[0] = 1;
  Object sum3250 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3250 (depth = 8)
  gc_frame_newslot(sum3250);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3250;
  partcv[0] = 1;
  Object call3251 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3246);
// compiled call node returning call3251 (depth = 7)
  int op_slot_right_3245 = gc_frame_newslot(call3251);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3254 == NULL) {
    strlit3254 = alloc_String("    ");
    gc_root(strlit3254);
  }
// compiled string node returning strlit3254 (depth = 8)
  int op_slot_right_3253 = gc_frame_newslot(strlit3254);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3256 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3259 == NULL) {
    strlit3259 = alloc_String("""\x0a""");
    gc_root(strlit3259);
  }
// compiled string node returning strlit3259 (depth = 10)
  int op_slot_right_3258 = gc_frame_newslot(strlit3259);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3258 = gc_frame_newslot(*var_s);
  params[0] = strlit3259;
  partcv[0] = 1;
  Object opresult3261 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3261 (depth = 9)
  int op_slot_left_3256 = gc_frame_newslot(opresult3261);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3262 = callmethod(opresult3261, "++", 1, partcv, params);
// compiled op node returning opresult3262 (depth = 8)
  int op_slot_left_3253 = gc_frame_newslot(opresult3262);
  params[0] = strlit3254;
  partcv[0] = 1;
  Object opresult3263 = callmethod(opresult3262, "++", 1, partcv, params);
// compiled op node returning opresult3263 (depth = 7)
  int op_slot_left_3245 = gc_frame_newslot(opresult3263);
  params[0] = call3251;
  partcv[0] = 1;
  Object opresult3264 = callmethod(opresult3263, "++", 1, partcv, params);
// compiled op node returning opresult3264 (depth = 6)
  *var_s = opresult3264;
  if (opresult3264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3272(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3274 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3276 = alloc_Float64(1);
// compiled num node returning num3276 (depth = 9)
  int op_slot_right_3275 = gc_frame_newslot(num3276);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3275 = gc_frame_newslot(*var_depth);
  params[0] = num3276;
  partcv[0] = 1;
  Object sum3278 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3278 (depth = 8)
  gc_frame_newslot(sum3278);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3278;
  partcv[0] = 1;
  Object call3279 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3274);
// compiled call node returning call3279 (depth = 7)
  int op_slot_right_3273 = gc_frame_newslot(call3279);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3282 == NULL) {
    strlit3282 = alloc_String("    ");
    gc_root(strlit3282);
  }
// compiled string node returning strlit3282 (depth = 8)
  int op_slot_right_3281 = gc_frame_newslot(strlit3282);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3284 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3287 == NULL) {
    strlit3287 = alloc_String("""\x0a""");
    gc_root(strlit3287);
  }
// compiled string node returning strlit3287 (depth = 10)
  int op_slot_right_3286 = gc_frame_newslot(strlit3287);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3286 = gc_frame_newslot(*var_s);
  params[0] = strlit3287;
  partcv[0] = 1;
  Object opresult3289 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3289 (depth = 9)
  int op_slot_left_3284 = gc_frame_newslot(opresult3289);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3290 = callmethod(opresult3289, "++", 1, partcv, params);
// compiled op node returning opresult3290 (depth = 8)
  int op_slot_left_3281 = gc_frame_newslot(opresult3290);
  params[0] = strlit3282;
  partcv[0] = 1;
  Object opresult3291 = callmethod(opresult3290, "++", 1, partcv, params);
// compiled op node returning opresult3291 (depth = 7)
  int op_slot_left_3273 = gc_frame_newslot(opresult3291);
  params[0] = call3279;
  partcv[0] = 1;
  Object opresult3292 = callmethod(opresult3291, "++", 1, partcv, params);
// compiled op node returning opresult3292 (depth = 6)
  *var_s = opresult3292;
  if (opresult3292 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3215 == NULL) {
    strlit3215 = alloc_String("");
    gc_root(strlit3215);
  }
// compiled string node returning strlit3215 (depth = 4)
  *var_spc = strlit3215;
  if (strlit3215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3216 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3219 = alloc_Float64(1);
// compiled num node returning num3219 (depth = 6)
  int op_slot_right_3218 = gc_frame_newslot(num3219);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3218 = gc_frame_newslot(*var_depth);
  params[0] = num3219;
  partcv[0] = 1;
  Object diff3221 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3221 (depth = 5)
  int op_slot_right_3217 = gc_frame_newslot(diff3221);
// starting to compile num node (depth = 5)
  Object num3223 = alloc_Float64(0);
// compiled num node returning num3223 (depth = 5)
  int op_slot_left_3217 = gc_frame_newslot(num3223);
  params[0] = diff3221;
  partcv[0] = 1;
  Object opresult3224 = callmethod(num3223, "..", 1, partcv, params);
// compiled op node returning opresult3224 (depth = 4)
  gc_frame_newslot(opresult3224);
// starting to compile block node (depth = 4)
  Object block3225 = alloc_Block(NULL, NULL, "ast", 704);
  gc_frame_newslot(block3225);
// method "_apply"
  block_savedest(block3225);
  Object closure3226 = createclosure(2, "_apply");
  setclosureframe(closure3226, stackframe);
  addtoclosure(closure3226, var_spc);
  addtoclosure(closure3226, selfslot);
  struct UserObject *uo3226 = (struct UserObject*)block3225;
  uo3226->data[0] = (Object)closure3226;
  Method *meth_meth_ast__apply3226 = addmethod2pos(block3225, "_apply", &meth_ast__apply3226, 0);
  int argcv_meth_ast__apply3226[] = {1};
  meth_meth_ast__apply3226->type = alloc_MethodType(1, argcv_meth_ast__apply3226);
  meth_meth_ast__apply3226->definitionModule = modulename;
  meth_meth_ast__apply3226->definitionLine = 696;
// compiled block node returning block3225 (depth = 4)
  gc_frame_newslot(block3225);
// call case 5: prelude request
  params[0] = opresult3224;
  params[1] = block3225;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3233 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3216);
// compiled call node returning call3233 (depth = 3)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3234 == NULL) {
    strlit3234 = alloc_String("type");
    gc_root(strlit3234);
  }
// compiled string node returning strlit3234 (depth = 4)
  *var_s = strlit3234;
  if (strlit3234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3236 == NULL) {
    strlit3236 = alloc_String(" = {");
    gc_root(strlit3236);
  }
// compiled string node returning strlit3236 (depth = 5)
  int op_slot_right_3235 = gc_frame_newslot(strlit3236);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3235 = gc_frame_newslot(*var_s);
  params[0] = strlit3236;
  partcv[0] = 1;
  Object opresult3238 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3238 (depth = 4)
  *var_s = opresult3238;
  if (opresult3238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3240 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3242 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3241);
// compiled call node returning call3242 (depth = 5)
// compiled member node returning call3242 (depth = 4)
  gc_frame_newslot(call3242);
// starting to compile block node (depth = 4)
  Object block3243 = alloc_Block(NULL, NULL, "ast", 709);
  gc_frame_newslot(block3243);
// method "_apply"
  block_savedest(block3243);
  Object closure3244 = createclosure(4, "_apply");
  setclosureframe(closure3244, stackframe);
  addtoclosure(closure3244, var_depth);
  addtoclosure(closure3244, var_spc);
  addtoclosure(closure3244, var_s);
  addtoclosure(closure3244, selfslot);
  struct UserObject *uo3244 = (struct UserObject*)block3243;
  uo3244->data[0] = (Object)closure3244;
  Method *meth_meth_ast__apply3244 = addmethod2pos(block3243, "_apply", &meth_ast__apply3244, 0);
  int argcv_meth_ast__apply3244[] = {1};
  meth_meth_ast__apply3244->type = alloc_MethodType(1, argcv_meth_ast__apply3244);
  meth_meth_ast__apply3244->definitionModule = modulename;
  meth_meth_ast__apply3244->definitionLine = 709;
// compiled block node returning block3243 (depth = 4)
  gc_frame_newslot(block3243);
// call case 5: prelude request
  params[0] = call3242;
  params[1] = block3243;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3267 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3240);
// compiled call node returning call3267 (depth = 3)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3268 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3269 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3270 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3269);
// compiled call node returning call3270 (depth = 5)
// compiled member node returning call3270 (depth = 4)
  gc_frame_newslot(call3270);
// starting to compile block node (depth = 4)
  Object block3271 = alloc_Block(NULL, NULL, "ast", 712);
  gc_frame_newslot(block3271);
// method "_apply"
  block_savedest(block3271);
  Object closure3272 = createclosure(4, "_apply");
  setclosureframe(closure3272, stackframe);
  addtoclosure(closure3272, var_depth);
  addtoclosure(closure3272, var_spc);
  addtoclosure(closure3272, var_s);
  addtoclosure(closure3272, selfslot);
  struct UserObject *uo3272 = (struct UserObject*)block3271;
  uo3272->data[0] = (Object)closure3272;
  Method *meth_meth_ast__apply3272 = addmethod2pos(block3271, "_apply", &meth_ast__apply3272, 0);
  int argcv_meth_ast__apply3272[] = {1};
  meth_meth_ast__apply3272->type = alloc_MethodType(1, argcv_meth_ast__apply3272);
  meth_meth_ast__apply3272->definitionModule = modulename;
  meth_meth_ast__apply3272->definitionLine = 712;
// compiled block node returning block3271 (depth = 4)
  gc_frame_newslot(block3271);
// call case 5: prelude request
  params[0] = call3270;
  params[1] = block3271;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3295 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3268);
// compiled call node returning call3295 (depth = 3)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3297 == NULL) {
    strlit3297 = alloc_String("}");
    gc_root(strlit3297);
  }
// compiled string node returning strlit3297 (depth = 4)
  int op_slot_right_3296 = gc_frame_newslot(strlit3297);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_3296 = gc_frame_newslot(*var_s);
  params[0] = strlit3297;
  partcv[0] = 1;
  Object opresult3299 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3299 (depth = 3)
  gc_frame_end(frame);
  return opresult3299;
}
Object meth_ast_shallowCopy3300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3301 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe3302 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call3303 = callmethod(*var_typeLiteralNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3302);
// compiled call node returning call3303 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3304 = callmethod(call3303, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3301);
// compiled call node returning call3304 (depth = 3)
  gc_frame_end(frame);
  return call3304;
}
Object meth_ast_shallowCopyFieldsFrom3305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3306 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3307 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3306);
// compiled call node returning call3307 (depth = 3)
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3308 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call3310 = callmethod(*var_other, "nominal",
    1, partcv, params);
  gc_frame_end(callframe3309);
// compiled call node returning call3310 (depth = 5)
// compiled member node returning call3310 (depth = 4)
  gc_frame_newslot(call3310);
// call case 4: self request
  params[0] = call3310;
  partcv[0] = 1;
  Object call3311 = callmethodflags(self, "nominal:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3308);
// compiled call node returning call3311 (depth = 3)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3312 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call3314 = callmethod(*var_other, "anonymous",
    1, partcv, params);
  gc_frame_end(callframe3313);
// compiled call node returning call3314 (depth = 5)
// compiled member node returning call3314 (depth = 4)
  gc_frame_newslot(call3314);
// call case 4: self request
  params[0] = call3314;
  partcv[0] = 1;
  Object call3315 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3312);
// compiled call node returning call3315 (depth = 3)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3316 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3317 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call3318 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe3317);
// compiled call node returning call3318 (depth = 5)
// compiled member node returning call3318 (depth = 4)
  gc_frame_newslot(call3318);
// call case 4: self request
  params[0] = call3318;
  partcv[0] = 1;
  Object call3319 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3316);
// compiled call node returning call3319 (depth = 3)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new3021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3022 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3022 = alloc_userobj2(22,18, objclass3022);
  gc_frame_newslot(obj3022);
if (objclass3022 == NULL) {
  glfree(obj3022->class->name);
  obj3022->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3022, self, 0);
  addmethodreal(obj3022,"outer", &reader_ast_outer_3023);
  Object oldself3022 = self;
  struct StackFrameObject *oldstackframe3022 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3022);
  gc_frame_newslot((Object)stackframe);
  self = obj3022;
  Object *oldselfslot3022 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3022 = (*(struct UserObject *)self).data[0], lowerouter3022 = thisouter3022;
  if (inheritingObject3022) {
    struct UserObject *inho3022 = (struct UserObject *)inheritingObject3022;
    while (inho3022->super != GraceDefaultObject) inho3022 = (struct UserObject *)inho3022->super;
    inho3022->super = obj3022;
    self = inheritingObject3022;
    *selfslot = self;
    lowerouter3022 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3022;
  }
if (objclass3022 == NULL) {
  Method *reader3024 = addmethodrealflags(obj3022, "kind",&reader_ast_kind_3024, MFLAG_DEF);
  reader3024->definitionModule = modulename;
  reader3024->definitionLine = 649;
}
adddatum2(obj3022, alloc_Undefined(), 1);
if (objclass3022 == NULL) {
  Method *reader3025 = addmethodrealflags(obj3022, "methods",&reader_ast_methods_3025, 0);
  Method *writer3025 = addmethodrealflags(obj3022, "methods:=",&writer_ast_methods_3025, 0);
  reader3025->definitionModule = modulename;
  writer3025->definitionModule = modulename;
  reader3025->definitionLine = 650;
  writer3025->definitionLine = 650;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 2);
if (objclass3022 == NULL) {
  Method *reader3026 = addmethodrealflags(obj3022, "types",&reader_ast_types_3026, 0);
  Method *writer3026 = addmethodrealflags(obj3022, "types:=",&writer_ast_types_3026, 0);
  reader3026->definitionModule = modulename;
  writer3026->definitionModule = modulename;
  reader3026->definitionLine = 651;
  writer3026->definitionLine = 651;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 3);
if (objclass3022 == NULL) {
  Method *reader3027 = addmethodrealflags(obj3022, "nominal",&reader_ast_nominal_3027, 0);
  Method *writer3027 = addmethodrealflags(obj3022, "nominal:=",&writer_ast_nominal_3027, 0);
  reader3027->definitionModule = modulename;
  writer3027->definitionModule = modulename;
  reader3027->definitionLine = 652;
  writer3027->definitionLine = 652;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 4);
if (objclass3022 == NULL) {
  Method *reader3028 = addmethodrealflags(obj3022, "anonymous",&reader_ast_anonymous_3028, 0);
  Method *writer3028 = addmethodrealflags(obj3022, "anonymous:=",&writer_ast_anonymous_3028, 0);
  reader3028->definitionModule = modulename;
  writer3028->definitionModule = modulename;
  reader3028->definitionLine = 653;
  writer3028->definitionLine = 653;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 5);
if (objclass3022 == NULL) {
  Method *reader3029 = addmethodrealflags(obj3022, "value",&reader_ast_value_3029, 0);
  Method *writer3029 = addmethodrealflags(obj3022, "value:=",&writer_ast_value_3029, 0);
  reader3029->definitionModule = modulename;
  writer3029->definitionModule = modulename;
  reader3029->definitionLine = 654;
  writer3029->definitionLine = 654;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3030 = (struct UserObject*)obj3022;
  uo3030->data[7] = emptyclosure;
  Method *meth_meth_ast_name3030 = addmethod2pos(obj3022, "name", &meth_ast_name3030, 7);
  int argcv_meth_ast_name3030[] = {0};
  meth_meth_ast_name3030->type = alloc_MethodType(1, argcv_meth_ast_name3030);
  meth_meth_ast_name3030->definitionModule = modulename;
  meth_meth_ast_name3030->definitionLine = 656;
// method "name:="
  struct UserObject *uo3033 = (struct UserObject*)obj3022;
  uo3033->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_3033 = addmethod2pos(obj3022, "name:=", &meth_ast_name_58__61_3033, 8);
  int argcv_meth_ast_name_58__61_3033[] = {1};
  meth_meth_ast_name_58__61_3033->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_3033);
  meth_meth_ast_name_58__61_3033->definitionModule = modulename;
  meth_meth_ast_name_58__61_3033->definitionLine = 657;
// method "asString"
  struct UserObject *uo3039 = (struct UserObject*)obj3022;
  uo3039->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3039 = addmethod2pos(obj3022, "asString", &meth_ast_asString3039, 9);
  int argcv_meth_ast_asString3039[] = {0};
  meth_meth_ast_asString3039->type = alloc_MethodType(1, argcv_meth_ast_asString3039);
  meth_meth_ast_asString3039->definitionModule = modulename;
  meth_meth_ast_asString3039->definitionLine = 661;
// method "declarationKindWithAncestors"
  block_savedest(obj3022);
  Object closure3059 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3059, stackframe);
  addtoclosure(closure3059, var_k);
  struct UserObject *uo3059 = (struct UserObject*)obj3022;
  uo3059->data[10] = (Object)closure3059;
  Method *meth_meth_ast_declarationKindWithAncestors3059 = addmethod2pos(obj3022, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3059, 10);
  int argcv_meth_ast_declarationKindWithAncestors3059[] = {1};
  meth_meth_ast_declarationKindWithAncestors3059->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3059);
  meth_meth_ast_declarationKindWithAncestors3059->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3059->definitionLine = 664;
// method "isExecutable"
  struct UserObject *uo3062 = (struct UserObject*)obj3022;
  uo3062->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3062 = addmethod2pos(obj3022, "isExecutable", &meth_ast_isExecutable3062, 11);
  int argcv_meth_ast_isExecutable3062[] = {0};
  meth_meth_ast_isExecutable3062->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3062);
  meth_meth_ast_isExecutable3062->definitionModule = modulename;
  meth_meth_ast_isExecutable3062->definitionLine = 665;
// method "accept()from"
  struct UserObject *uo3064 = (struct UserObject*)obj3022;
  uo3064->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3064 = addmethod2pos(obj3022, "accept()from", &meth_ast_accept_40__41_from3064, 12);
  int argcv_meth_ast_accept_40__41_from3064[] = {1, 1};
  meth_meth_ast_accept_40__41_from3064->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3064);
  meth_meth_ast_accept_40__41_from3064->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3064->definitionLine = 667;
// method "map()ancestors"
  struct UserObject *uo3088 = (struct UserObject*)obj3022;
  uo3088->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3088 = addmethod2pos(obj3022, "map()ancestors", &meth_ast_map_40__41_ancestors3088, 13);
  int argcv_meth_ast_map_40__41_ancestors3088[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3088->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3088);
  meth_meth_ast_map_40__41_ancestors3088->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3088->definitionLine = 678;
// method "pretty"
  struct UserObject *uo3115 = (struct UserObject*)obj3022;
  uo3115->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty3115 = addmethod2pos(obj3022, "pretty", &meth_ast_pretty3115, 14);
  int argcv_meth_ast_pretty3115[] = {1};
  meth_meth_ast_pretty3115->type = alloc_MethodType(1, argcv_meth_ast_pretty3115);
  meth_meth_ast_pretty3115->definitionModule = modulename;
  meth_meth_ast_pretty3115->definitionLine = 685;
// method "toGrace"
  struct UserObject *uo3214 = (struct UserObject*)obj3022;
  uo3214->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace3214 = addmethod2pos(obj3022, "toGrace", &meth_ast_toGrace3214, 15);
  int argcv_meth_ast_toGrace3214[] = {1};
  meth_meth_ast_toGrace3214->type = alloc_MethodType(1, argcv_meth_ast_toGrace3214);
meth_meth_ast_toGrace3214->type->types[0] = type_Number;
meth_meth_ast_toGrace3214->type->names[0] = "depth";
  meth_meth_ast_toGrace3214->definitionModule = modulename;
  meth_meth_ast_toGrace3214->definitionLine = 702;
// method "shallowCopy"
  block_savedest(obj3022);
  Object closure3300 = createclosure(2, "shallowCopy");
  setclosureframe(closure3300, stackframe);
  addtoclosure(closure3300, var_emptySeq);
  addtoclosure(closure3300, var_typeLiteralNode);
  struct UserObject *uo3300 = (struct UserObject*)obj3022;
  uo3300->data[16] = (Object)closure3300;
  Method *meth_meth_ast_shallowCopy3300 = addmethod2pos(obj3022, "shallowCopy", &meth_ast_shallowCopy3300, 16);
  int argcv_meth_ast_shallowCopy3300[] = {0};
  meth_meth_ast_shallowCopy3300->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3300);
  meth_meth_ast_shallowCopy3300->definitionModule = modulename;
  meth_meth_ast_shallowCopy3300->definitionLine = 717;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo3305 = (struct UserObject*)obj3022;
  uo3305->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom3305 = addmethod2pos(obj3022, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom3305, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom3305[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom3305->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom3305);
  meth_meth_ast_shallowCopyFieldsFrom3305->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom3305->definitionLine = 720;
  sourceObject = obj3022;
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3320 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3321 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3322 = gc_frame_new();
// call case 3: self.outer request
  Object call3323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3322);
// compiled call node returning call3323 (depth = 7)
// compiled member node returning call3323 (depth = 6)
  partcv[0] = 0;
  Object call3324 = callmethodflags(call3323, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3321);
// compiled call node returning call3324 (depth = 5)
// compiled member node returning call3324 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3325 = callmethodflags(call3324, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3320);
// compiled call node returning call3325 (depth = 3)
  struct UserObject *obj3022_uo = (struct UserObject *)obj3022;
  obj3022_uo->super = call3325;
  sourceObject = obj3022;
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3326 == NULL) {
    strlit3326 = alloc_String("typeliteral");
    gc_root(strlit3326);
  }
// compiled string node returning strlit3326 (depth = 3)
  adddatum2(obj3022, strlit3326, 1);
  sourceObject = obj3022;
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3022, *var_methods_39_, 2);
  sourceObject = obj3022;
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3022, *var_types_39_, 3);
  sourceObject = obj3022;
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3327 = alloc_Boolean(0);
// compiled identifier node returning bool3327 (depth = 3)
  adddatum2(obj3022, bool3327, 4);
  sourceObject = obj3022;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3328 = alloc_Boolean(1);
// compiled identifier node returning bool3328 (depth = 3)
  adddatum2(obj3022, bool3328, 5);
  sourceObject = obj3022;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3329 == NULL) {
    strlit3329 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3329);
  }
// compiled string node returning strlit3329 (depth = 3)
  adddatum2(obj3022, strlit3329, 6);
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  objclass3022 = obj3022->class;
  objclass3022->definitionModule = modulename;
  objclass3022->definitionLine = 647;
  (*(struct UserObject *)self).data[0] = lowerouter3022;
  self = oldself3022;
  selfslot = oldselfslot3022;
  stackframe = oldstackframe3022;
  gc_frame_end(frame);
  return obj3022;
}
Object meth_ast_new3021_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3022 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3022 = alloc_userobj2(22,18, objclass3022);
  gc_frame_newslot(obj3022);
if (objclass3022 == NULL) {
  glfree(obj3022->class->name);
  obj3022->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3022, self, 0);
  addmethodreal(obj3022,"outer", &reader_ast_outer_3023);
  Object oldself3022 = self;
  struct StackFrameObject *oldstackframe3022 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3022);
  gc_frame_newslot((Object)stackframe);
  self = obj3022;
  Object *oldselfslot3022 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3022 = (*(struct UserObject *)self).data[0], lowerouter3022 = thisouter3022;
  if (inheritingObject3022) {
    struct UserObject *inho3022 = (struct UserObject *)inheritingObject3022;
    while (inho3022->super != GraceDefaultObject) inho3022 = (struct UserObject *)inho3022->super;
    inho3022->super = obj3022;
    self = inheritingObject3022;
    *selfslot = self;
    lowerouter3022 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3022;
  }
if (objclass3022 == NULL) {
  Method *reader3024 = addmethodrealflags(obj3022, "kind",&reader_ast_kind_3024, MFLAG_DEF);
  reader3024->definitionModule = modulename;
  reader3024->definitionLine = 649;
}
adddatum2(obj3022, alloc_Undefined(), 1);
if (objclass3022 == NULL) {
  Method *reader3025 = addmethodrealflags(obj3022, "methods",&reader_ast_methods_3025, 0);
  Method *writer3025 = addmethodrealflags(obj3022, "methods:=",&writer_ast_methods_3025, 0);
  reader3025->definitionModule = modulename;
  writer3025->definitionModule = modulename;
  reader3025->definitionLine = 650;
  writer3025->definitionLine = 650;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 2);
if (objclass3022 == NULL) {
  Method *reader3026 = addmethodrealflags(obj3022, "types",&reader_ast_types_3026, 0);
  Method *writer3026 = addmethodrealflags(obj3022, "types:=",&writer_ast_types_3026, 0);
  reader3026->definitionModule = modulename;
  writer3026->definitionModule = modulename;
  reader3026->definitionLine = 651;
  writer3026->definitionLine = 651;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 3);
if (objclass3022 == NULL) {
  Method *reader3027 = addmethodrealflags(obj3022, "nominal",&reader_ast_nominal_3027, 0);
  Method *writer3027 = addmethodrealflags(obj3022, "nominal:=",&writer_ast_nominal_3027, 0);
  reader3027->definitionModule = modulename;
  writer3027->definitionModule = modulename;
  reader3027->definitionLine = 652;
  writer3027->definitionLine = 652;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 4);
if (objclass3022 == NULL) {
  Method *reader3028 = addmethodrealflags(obj3022, "anonymous",&reader_ast_anonymous_3028, 0);
  Method *writer3028 = addmethodrealflags(obj3022, "anonymous:=",&writer_ast_anonymous_3028, 0);
  reader3028->definitionModule = modulename;
  writer3028->definitionModule = modulename;
  reader3028->definitionLine = 653;
  writer3028->definitionLine = 653;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 5);
if (objclass3022 == NULL) {
  Method *reader3029 = addmethodrealflags(obj3022, "value",&reader_ast_value_3029, 0);
  Method *writer3029 = addmethodrealflags(obj3022, "value:=",&writer_ast_value_3029, 0);
  reader3029->definitionModule = modulename;
  writer3029->definitionModule = modulename;
  reader3029->definitionLine = 654;
  writer3029->definitionLine = 654;
}
obj3022->flags |= OFLAG_MUTABLE;
adddatum2(obj3022, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3030 = (struct UserObject*)obj3022;
  uo3030->data[7] = emptyclosure;
  Method *meth_meth_ast_name3030 = addmethod2pos(obj3022, "name", &meth_ast_name3030, 7);
  int argcv_meth_ast_name3030[] = {0};
  meth_meth_ast_name3030->type = alloc_MethodType(1, argcv_meth_ast_name3030);
  meth_meth_ast_name3030->definitionModule = modulename;
  meth_meth_ast_name3030->definitionLine = 656;
// method "name:="
  struct UserObject *uo3033 = (struct UserObject*)obj3022;
  uo3033->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_3033 = addmethod2pos(obj3022, "name:=", &meth_ast_name_58__61_3033, 8);
  int argcv_meth_ast_name_58__61_3033[] = {1};
  meth_meth_ast_name_58__61_3033->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_3033);
  meth_meth_ast_name_58__61_3033->definitionModule = modulename;
  meth_meth_ast_name_58__61_3033->definitionLine = 657;
// method "asString"
  struct UserObject *uo3039 = (struct UserObject*)obj3022;
  uo3039->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3039 = addmethod2pos(obj3022, "asString", &meth_ast_asString3039, 9);
  int argcv_meth_ast_asString3039[] = {0};
  meth_meth_ast_asString3039->type = alloc_MethodType(1, argcv_meth_ast_asString3039);
  meth_meth_ast_asString3039->definitionModule = modulename;
  meth_meth_ast_asString3039->definitionLine = 661;
// method "declarationKindWithAncestors"
  block_savedest(obj3022);
  Object closure3059 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3059, stackframe);
  addtoclosure(closure3059, var_k);
  struct UserObject *uo3059 = (struct UserObject*)obj3022;
  uo3059->data[10] = (Object)closure3059;
  Method *meth_meth_ast_declarationKindWithAncestors3059 = addmethod2pos(obj3022, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3059, 10);
  int argcv_meth_ast_declarationKindWithAncestors3059[] = {1};
  meth_meth_ast_declarationKindWithAncestors3059->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3059);
  meth_meth_ast_declarationKindWithAncestors3059->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3059->definitionLine = 664;
// method "isExecutable"
  struct UserObject *uo3062 = (struct UserObject*)obj3022;
  uo3062->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3062 = addmethod2pos(obj3022, "isExecutable", &meth_ast_isExecutable3062, 11);
  int argcv_meth_ast_isExecutable3062[] = {0};
  meth_meth_ast_isExecutable3062->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3062);
  meth_meth_ast_isExecutable3062->definitionModule = modulename;
  meth_meth_ast_isExecutable3062->definitionLine = 665;
// method "accept()from"
  struct UserObject *uo3064 = (struct UserObject*)obj3022;
  uo3064->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3064 = addmethod2pos(obj3022, "accept()from", &meth_ast_accept_40__41_from3064, 12);
  int argcv_meth_ast_accept_40__41_from3064[] = {1, 1};
  meth_meth_ast_accept_40__41_from3064->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3064);
  meth_meth_ast_accept_40__41_from3064->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3064->definitionLine = 667;
// method "map()ancestors"
  struct UserObject *uo3088 = (struct UserObject*)obj3022;
  uo3088->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3088 = addmethod2pos(obj3022, "map()ancestors", &meth_ast_map_40__41_ancestors3088, 13);
  int argcv_meth_ast_map_40__41_ancestors3088[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3088->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3088);
  meth_meth_ast_map_40__41_ancestors3088->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3088->definitionLine = 678;
// method "pretty"
  struct UserObject *uo3115 = (struct UserObject*)obj3022;
  uo3115->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty3115 = addmethod2pos(obj3022, "pretty", &meth_ast_pretty3115, 14);
  int argcv_meth_ast_pretty3115[] = {1};
  meth_meth_ast_pretty3115->type = alloc_MethodType(1, argcv_meth_ast_pretty3115);
  meth_meth_ast_pretty3115->definitionModule = modulename;
  meth_meth_ast_pretty3115->definitionLine = 685;
// method "toGrace"
  struct UserObject *uo3214 = (struct UserObject*)obj3022;
  uo3214->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace3214 = addmethod2pos(obj3022, "toGrace", &meth_ast_toGrace3214, 15);
  int argcv_meth_ast_toGrace3214[] = {1};
  meth_meth_ast_toGrace3214->type = alloc_MethodType(1, argcv_meth_ast_toGrace3214);
meth_meth_ast_toGrace3214->type->types[0] = type_Number;
meth_meth_ast_toGrace3214->type->names[0] = "depth";
  meth_meth_ast_toGrace3214->definitionModule = modulename;
  meth_meth_ast_toGrace3214->definitionLine = 702;
// method "shallowCopy"
  block_savedest(obj3022);
  Object closure3300 = createclosure(2, "shallowCopy");
  setclosureframe(closure3300, stackframe);
  addtoclosure(closure3300, var_emptySeq);
  addtoclosure(closure3300, var_typeLiteralNode);
  struct UserObject *uo3300 = (struct UserObject*)obj3022;
  uo3300->data[16] = (Object)closure3300;
  Method *meth_meth_ast_shallowCopy3300 = addmethod2pos(obj3022, "shallowCopy", &meth_ast_shallowCopy3300, 16);
  int argcv_meth_ast_shallowCopy3300[] = {0};
  meth_meth_ast_shallowCopy3300->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3300);
  meth_meth_ast_shallowCopy3300->definitionModule = modulename;
  meth_meth_ast_shallowCopy3300->definitionLine = 717;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo3305 = (struct UserObject*)obj3022;
  uo3305->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom3305 = addmethod2pos(obj3022, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom3305, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom3305[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom3305->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom3305);
  meth_meth_ast_shallowCopyFieldsFrom3305->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom3305->definitionLine = 720;
  sourceObject = obj3022;
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3320 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3321 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3322 = gc_frame_new();
// call case 3: self.outer request
  Object call3323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3322);
// compiled call node returning call3323 (depth = 7)
// compiled member node returning call3323 (depth = 6)
  partcv[0] = 0;
  Object call3324 = callmethodflags(call3323, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3321);
// compiled call node returning call3324 (depth = 5)
// compiled member node returning call3324 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3325 = callmethodflags(call3324, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3320);
// compiled call node returning call3325 (depth = 3)
  struct UserObject *obj3022_uo = (struct UserObject *)obj3022;
  obj3022_uo->super = call3325;
  sourceObject = obj3022;
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3326 == NULL) {
    strlit3326 = alloc_String("typeliteral");
    gc_root(strlit3326);
  }
// compiled string node returning strlit3326 (depth = 3)
  adddatum2(obj3022, strlit3326, 1);
  sourceObject = obj3022;
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3022, *var_methods_39_, 2);
  sourceObject = obj3022;
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3022, *var_types_39_, 3);
  sourceObject = obj3022;
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3327 = alloc_Boolean(0);
// compiled identifier node returning bool3327 (depth = 3)
  adddatum2(obj3022, bool3327, 4);
  sourceObject = obj3022;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3328 = alloc_Boolean(1);
// compiled identifier node returning bool3328 (depth = 3)
  adddatum2(obj3022, bool3328, 5);
  sourceObject = obj3022;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3329 == NULL) {
    strlit3329 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3329);
  }
// compiled string node returning strlit3329 (depth = 3)
  adddatum2(obj3022, strlit3329, 6);
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  sourceObject = obj3022;
  objclass3022 = obj3022->class;
  objclass3022->definitionModule = modulename;
  objclass3022->definitionLine = 647;
  (*(struct UserObject *)self).data[0] = lowerouter3022;
  self = oldself3022;
  selfslot = oldselfslot3022;
  stackframe = oldstackframe3022;
  gc_frame_end(frame);
  return obj3022;
}
Object meth_ast_typeLiteralNode3331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeLiteralNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeLiteralNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_isLegalInTrait3343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3344 = alloc_Boolean(1);
// compiled identifier node returning bool3344 (depth = 3)
  gc_frame_end(frame);
  return bool3344;
}
Object meth_ast_isTypeDec3345(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTypeDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3346 = alloc_Boolean(1);
// compiled identifier node returning bool3346 (depth = 3)
  gc_frame_end(frame);
  return bool3346;
}
Object meth_ast_scope_58__61_3347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3348 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3349 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3348);
// compiled call node returning call3349 (depth = 3)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3350 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3351 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe3350);
// compiled call node returning call3351 (depth = 3)
  gc_frame_end(frame);
  return call3351;
}
Object meth_ast_isExecutable3352(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3353 = alloc_Boolean(1);
// compiled identifier node returning bool3353 (depth = 3)
  gc_frame_end(frame);
  return bool3353;
}
Object meth_ast_declarationKindWithAncestors3354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call3356 = callmethod(*var_k, "typeparam",
    1, partcv, params);
  gc_frame_end(callframe3355);
// compiled call node returning call3356 (depth = 4)
// compiled member node returning call3356 (depth = 3)
  gc_frame_end(frame);
  return call3356;
}
Object meth_ast_isConfidential3357(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3360 = alloc_Float64(0);
// compiled num node returning num3360 (depth = 5)
  int op_slot_right_3359 = gc_frame_newslot(num3360);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3362 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3363 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3364 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3363);
// compiled call node returning call3364 (depth = 8)
// compiled member node returning call3364 (depth = 7)
  partcv[0] = 0;
  Object call3365 = callmethod(call3364, "size",
    1, partcv, params);
  gc_frame_end(callframe3362);
// compiled call node returning call3365 (depth = 6)
// compiled member node returning call3365 (depth = 5)
  int op_slot_left_3359 = gc_frame_newslot(call3365);
  params[0] = num3360;
  partcv[0] = 1;
  Object opresult3366 = callmethod(call3365, "==", 1, partcv, params);
// compiled op node returning opresult3366 (depth = 4)
  Object if3358 = done;
  if (istrue(opresult3366)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3367 = alloc_Boolean(0);
// compiled identifier node returning bool3367 (depth = 5)
  return bool3367;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3358 = undefined;
  } else {
  }
// compiled if node returning if3358 (depth = 3)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3368 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3369 == NULL) {
    strlit3369 = alloc_String("confidential");
    gc_root(strlit3369);
  }
// compiled string node returning strlit3369 (depth = 4)
  gc_frame_newslot(strlit3369);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3370 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3371 = gc_frame_new();
// call case 3: self.outer request
  Object call3372 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3371);
// compiled call node returning call3372 (depth = 7)
// compiled member node returning call3372 (depth = 6)
  partcv[0] = 0;
  Object call3373 = callmethodflags(call3372, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3370);
// compiled call node returning call3373 (depth = 5)
// compiled member node returning call3373 (depth = 4)
  params[0] = self;
  params[1] = strlit3369;
  partcv[0] = 2;
  Object call3374 = callmethodflags(call3373, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3368);
// compiled call node returning call3374 (depth = 3)
  gc_frame_end(frame);
  return call3374;
}
Object meth_ast_isPublic3375(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3376 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3378 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3377);
// compiled call node returning call3378 (depth = 6)
// compiled member node returning call3378 (depth = 5)
  partcv[0] = 0;
  Object call3379 = callmethod(call3378, "not",
    1, partcv, params);
  gc_frame_end(callframe3376);
// compiled call node returning call3379 (depth = 4)
// compiled member node returning call3379 (depth = 3)
  gc_frame_end(frame);
  return call3379;
}
Object meth_ast_isWritable3380(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3381 = alloc_Boolean(0);
// compiled identifier node returning bool3381 (depth = 3)
  gc_frame_end(frame);
  return bool3381;
}
Object meth_ast_isReadable3382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3384 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3383);
// compiled call node returning call3384 (depth = 4)
// compiled member node returning call3384 (depth = 3)
  gc_frame_end(frame);
  return call3384;
}
Object meth_ast__apply3408(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe3409 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3410 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3409);
// compiled call node returning call3410 (depth = 6)
  gc_frame_end(frame);
  return call3410;
}
Object meth_ast_accept_40__41_from3385(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3387 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3388 = callmethod(*var_visitor, "visitTypeDec()up",
    2, partcv, params);
  gc_frame_end(callframe3387);
// compiled call node returning call3388 (depth = 4)
  Object if3386 = done;
  if (istrue(call3388)) {
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3389 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3390 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3389);
// compiled call node returning call3390 (depth = 5)
  *var_newChain = call3390;
  if (call3390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3391 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3392 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3393 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3392);
// compiled call node returning call3393 (depth = 6)
// compiled member node returning call3393 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3394 = callmethod(call3393, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3391);
// compiled call node returning call3394 (depth = 4)
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3397 = alloc_Boolean(0);
// compiled identifier node returning bool3397 (depth = 6)
  int op_slot_right_3396 = gc_frame_newslot(bool3397);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3400 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3399);
// compiled call node returning call3400 (depth = 7)
// compiled member node returning call3400 (depth = 6)
  int op_slot_left_3396 = gc_frame_newslot(call3400);
  params[0] = bool3397;
  partcv[0] = 1;
  Object opresult3401 = callmethod(call3400, "!=", 1, partcv, params);
// compiled op node returning opresult3401 (depth = 5)
  Object if3395 = done;
  if (istrue(opresult3401)) {
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3402 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3403 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3404 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3403);
// compiled call node returning call3404 (depth = 7)
// compiled member node returning call3404 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3405 = callmethod(call3404, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3402);
// compiled call node returning call3405 (depth = 5)
    gc_frame_newslot(call3405);
    if3395 = call3405;
  } else {
  }
// compiled if node returning if3395 (depth = 4)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3406 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3407 = alloc_Block(NULL, NULL, "ast", 766);
  gc_frame_newslot(block3407);
// method "_apply"
  block_savedest(block3407);
  Object closure3408 = createclosure(3, "_apply");
  setclosureframe(closure3408, stackframe);
  addtoclosure(closure3408, var_visitor);
  addtoclosure(closure3408, var_newChain);
  addtoclosure(closure3408, selfslot);
  struct UserObject *uo3408 = (struct UserObject*)block3407;
  uo3408->data[0] = (Object)closure3408;
  Method *meth_meth_ast__apply3408 = addmethod2pos(block3407, "_apply", &meth_ast__apply3408, 0);
  int argcv_meth_ast__apply3408[] = {1};
  meth_meth_ast__apply3408->type = alloc_MethodType(1, argcv_meth_ast__apply3408);
  meth_meth_ast__apply3408->definitionModule = modulename;
  meth_meth_ast__apply3408->definitionLine = 764;
// compiled block node returning block3407 (depth = 5)
  gc_frame_newslot(block3407);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3412 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3413 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3412);
// compiled call node returning call3413 (depth = 6)
// compiled member node returning call3413 (depth = 5)
  params[0] = block3407;
  partcv[0] = 1;
  Object call3414 = callmethod(call3413, "do",
    1, partcv, params);
  gc_frame_end(callframe3406);
// compiled call node returning call3414 (depth = 4)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3415 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3417 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3416);
// compiled call node returning call3417 (depth = 6)
// compiled member node returning call3417 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3418 = callmethod(call3417, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3415);
// compiled call node returning call3418 (depth = 4)
    gc_frame_newslot(call3418);
    if3386 = call3418;
  } else {
  }
// compiled if node returning if3386 (depth = 3)
  gc_frame_end(frame);
  return if3386;
}
Object meth_ast_map_40__41_ancestors3419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3421 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3420);
// compiled call node returning call3421 (depth = 5)
// compiled member node returning call3421 (depth = 4)
  *var_n = call3421;
  if (call3421 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3422 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3423 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3422);
// compiled call node returning call3423 (depth = 4)
  *var_newChain = call3423;
  if (call3423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3424 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3425 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3426 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3427 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3426);
// compiled call node returning call3427 (depth = 6)
// compiled member node returning call3427 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3428 = callmethod(call3427, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe3425);
// compiled call node returning call3428 (depth = 4)
  gc_frame_newslot(call3428);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3428;
  partcv[0] = 1;
  Object call3429 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe3424);
// compiled call node returning call3429 (depth = 3)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3430 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3431 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3432 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3433 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3432);
// compiled call node returning call3433 (depth = 6)
// compiled member node returning call3433 (depth = 5)
  gc_frame_newslot(call3433);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3434 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3435 = gc_frame_new();
// call case 3: self.outer request
  Object call3436 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3435);
// compiled call node returning call3436 (depth = 8)
// compiled member node returning call3436 (depth = 7)
  partcv[0] = 0;
  Object call3437 = callmethodflags(call3436, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3434);
// compiled call node returning call3437 (depth = 6)
// compiled member node returning call3437 (depth = 5)
  params[0] = call3433;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3438 = callmethodflags(call3437, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3431);
// compiled call node returning call3438 (depth = 4)
  gc_frame_newslot(call3438);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3438;
  partcv[0] = 1;
  Object call3439 = callmethod(*var_n, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe3430);
// compiled call node returning call3439 (depth = 3)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3440 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3441 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3443 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3442);
// compiled call node returning call3443 (depth = 6)
// compiled member node returning call3443 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3444 = callmethod(call3443, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe3441);
// compiled call node returning call3444 (depth = 4)
  gc_frame_newslot(call3444);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3444;
  partcv[0] = 1;
  Object call3445 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe3440);
// compiled call node returning call3445 (depth = 3)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3446 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3447 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3448 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3449 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3448);
// compiled call node returning call3449 (depth = 6)
// compiled member node returning call3449 (depth = 5)
  gc_frame_newslot(call3449);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3450 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3451 = gc_frame_new();
// call case 3: self.outer request
  Object call3452 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3451);
// compiled call node returning call3452 (depth = 8)
// compiled member node returning call3452 (depth = 7)
  partcv[0] = 0;
  Object call3453 = callmethodflags(call3452, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3450);
// compiled call node returning call3453 (depth = 6)
// compiled member node returning call3453 (depth = 5)
  params[0] = call3449;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3454 = callmethodflags(call3453, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3447);
// compiled call node returning call3454 (depth = 4)
  gc_frame_newslot(call3454);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3454;
  partcv[0] = 1;
  Object call3455 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3446);
// compiled call node returning call3455 (depth = 3)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3456 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3457 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3456);
// compiled call node returning call3457 (depth = 3)
  gc_frame_end(frame);
  return call3457;
}
Object meth_ast__apply3466(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3468 == NULL) {
    strlit3468 = alloc_String("  ");
    gc_root(strlit3468);
  }
// compiled string node returning strlit3468 (depth = 7)
  int op_slot_right_3467 = gc_frame_newslot(strlit3468);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3467 = gc_frame_newslot(*var_spc);
  params[0] = strlit3468;
  partcv[0] = 1;
  Object opresult3470 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3470 (depth = 6)
  *var_spc = opresult3470;
  if (opresult3470 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3458(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3459 == NULL) {
    strlit3459 = alloc_String("");
    gc_root(strlit3459);
  }
// compiled string node returning strlit3459 (depth = 4)
  *var_spc = strlit3459;
  if (strlit3459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3460 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3461 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3463 = alloc_Float64(0);
// compiled num node returning num3463 (depth = 5)
  int op_slot_left_3461 = gc_frame_newslot(num3463);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3464 = callmethod(num3463, "..", 1, partcv, params);
// compiled op node returning opresult3464 (depth = 4)
  gc_frame_newslot(opresult3464);
// starting to compile block node (depth = 4)
  Object block3465 = alloc_Block(NULL, NULL, "ast", 781);
  gc_frame_newslot(block3465);
// method "_apply"
  block_savedest(block3465);
  Object closure3466 = createclosure(2, "_apply");
  setclosureframe(closure3466, stackframe);
  addtoclosure(closure3466, var_spc);
  addtoclosure(closure3466, selfslot);
  struct UserObject *uo3466 = (struct UserObject*)block3465;
  uo3466->data[0] = (Object)closure3466;
  Method *meth_meth_ast__apply3466 = addmethod2pos(block3465, "_apply", &meth_ast__apply3466, 0);
  int argcv_meth_ast__apply3466[] = {1};
  meth_meth_ast__apply3466->type = alloc_MethodType(1, argcv_meth_ast__apply3466);
  meth_meth_ast__apply3466->definitionModule = modulename;
  meth_meth_ast__apply3466->definitionLine = 776;
// compiled block node returning block3465 (depth = 4)
  gc_frame_newslot(block3465);
// call case 5: prelude request
  params[0] = opresult3464;
  params[1] = block3465;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3473 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3460);
// compiled call node returning call3473 (depth = 3)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3475 == NULL) {
    strlit3475 = alloc_String("""\x0a""");
    gc_root(strlit3475);
  }
// compiled string node returning strlit3475 (depth = 5)
  int op_slot_right_3474 = gc_frame_newslot(strlit3475);
// starting to compile call node (depth = 5)
  int callframe3477 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3478 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3477);
// compiled call node returning call3478 (depth = 5)
  int op_slot_left_3474 = gc_frame_newslot(call3478);
  params[0] = strlit3475;
  partcv[0] = 1;
  Object opresult3479 = callmethod(call3478, "++", 1, partcv, params);
// compiled op node returning opresult3479 (depth = 4)
  *var_s = opresult3479;
  if (opresult3479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3481 == NULL) {
    strlit3481 = alloc_String("""\x0a""");
    gc_root(strlit3481);
  }
// compiled string node returning strlit3481 (depth = 5)
  int op_slot_right_3480 = gc_frame_newslot(strlit3481);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3484 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3486 = alloc_Float64(1);
// compiled num node returning num3486 (depth = 8)
  int op_slot_right_3485 = gc_frame_newslot(num3486);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3485 = gc_frame_newslot(*var_depth);
  params[0] = num3486;
  partcv[0] = 1;
  Object sum3488 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3488 (depth = 7)
  gc_frame_newslot(sum3488);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3489 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3490 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3489);
// compiled call node returning call3490 (depth = 8)
// compiled member node returning call3490 (depth = 7)
  params[0] = sum3488;
  partcv[0] = 1;
  Object call3491 = callmethod(call3490, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3484);
// compiled call node returning call3491 (depth = 6)
  int op_slot_right_3483 = gc_frame_newslot(call3491);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3493 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3493 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3495 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3495 (depth = 6)
  int op_slot_left_3483 = gc_frame_newslot(opresult3495);
  params[0] = call3491;
  partcv[0] = 1;
  Object opresult3496 = callmethod(opresult3495, "++", 1, partcv, params);
// compiled op node returning opresult3496 (depth = 5)
  int op_slot_left_3480 = gc_frame_newslot(opresult3496);
  params[0] = strlit3481;
  partcv[0] = 1;
  Object opresult3497 = callmethod(opresult3496, "++", 1, partcv, params);
// compiled op node returning opresult3497 (depth = 4)
  *var_s = opresult3497;
  if (opresult3497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3501 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3502 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3501);
// compiled call node returning call3502 (depth = 6)
// compiled member node returning call3502 (depth = 5)
  int op_slot_right_3500 = gc_frame_newslot(call3502);
// starting to compile identifier node (depth = 5)
  Object bool3504 = alloc_Boolean(0);
// compiled identifier node returning bool3504 (depth = 5)
  int op_slot_left_3500 = gc_frame_newslot(bool3504);
  params[0] = call3502;
  partcv[0] = 1;
  Object opresult3505 = callmethod(bool3504, "!=", 1, partcv, params);
// compiled op node returning opresult3505 (depth = 4)
  Object if3499 = done;
  if (istrue(opresult3505)) {
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3507 == NULL) {
    strlit3507 = alloc_String("""\x0a""");
    gc_root(strlit3507);
  }
// compiled string node returning strlit3507 (depth = 6)
  int op_slot_right_3506 = gc_frame_newslot(strlit3507);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3510 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3512 = alloc_Float64(2);
// compiled num node returning num3512 (depth = 9)
  int op_slot_right_3511 = gc_frame_newslot(num3512);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3511 = gc_frame_newslot(*var_depth);
  params[0] = num3512;
  partcv[0] = 1;
  Object sum3514 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3514 (depth = 8)
  gc_frame_newslot(sum3514);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3516 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3515);
// compiled call node returning call3516 (depth = 9)
// compiled member node returning call3516 (depth = 8)
  params[0] = sum3514;
  partcv[0] = 1;
  Object call3517 = callmethod(call3516, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3510);
// compiled call node returning call3517 (depth = 7)
  int op_slot_right_3509 = gc_frame_newslot(call3517);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3520 == NULL) {
    strlit3520 = alloc_String("Type parameters:""\x0a""");
    gc_root(strlit3520);
  }
// compiled string node returning strlit3520 (depth = 8)
  int op_slot_right_3519 = gc_frame_newslot(strlit3520);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3522 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3525 == NULL) {
    strlit3525 = alloc_String("");
    gc_root(strlit3525);
  }
// compiled string node returning strlit3525 (depth = 10)
  int op_slot_right_3524 = gc_frame_newslot(strlit3525);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_3527 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String("");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 11)
  int op_slot_left_3527 = gc_frame_newslot(strlit3529);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3530 = callmethod(strlit3529, "++", 1, partcv, params);
// compiled op node returning opresult3530 (depth = 10)
  int op_slot_left_3524 = gc_frame_newslot(opresult3530);
  params[0] = strlit3525;
  partcv[0] = 1;
  Object opresult3531 = callmethod(opresult3530, "++", 1, partcv, params);
// compiled op node returning opresult3531 (depth = 9)
  int op_slot_left_3522 = gc_frame_newslot(opresult3531);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3532 = callmethod(opresult3531, "++", 1, partcv, params);
// compiled op node returning opresult3532 (depth = 8)
  int op_slot_left_3519 = gc_frame_newslot(opresult3532);
  params[0] = strlit3520;
  partcv[0] = 1;
  Object opresult3533 = callmethod(opresult3532, "++", 1, partcv, params);
// compiled op node returning opresult3533 (depth = 7)
  int op_slot_left_3509 = gc_frame_newslot(opresult3533);
  params[0] = call3517;
  partcv[0] = 1;
  Object opresult3534 = callmethod(opresult3533, "++", 1, partcv, params);
// compiled op node returning opresult3534 (depth = 6)
  int op_slot_left_3506 = gc_frame_newslot(opresult3534);
  params[0] = strlit3507;
  partcv[0] = 1;
  Object opresult3535 = callmethod(opresult3534, "++", 1, partcv, params);
// compiled op node returning opresult3535 (depth = 5)
  *var_s = opresult3535;
  if (opresult3535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3499 = done;
  } else {
  }
// compiled if node returning if3499 (depth = 3)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3538 == NULL) {
    strlit3538 = alloc_String("Value:");
    gc_root(strlit3538);
  }
// compiled string node returning strlit3538 (depth = 5)
  int op_slot_right_3537 = gc_frame_newslot(strlit3538);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3540 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3540 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3542 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3542 (depth = 5)
  int op_slot_left_3537 = gc_frame_newslot(opresult3542);
  params[0] = strlit3538;
  partcv[0] = 1;
  Object opresult3543 = callmethod(opresult3542, "++", 1, partcv, params);
// compiled op node returning opresult3543 (depth = 4)
  *var_s = opresult3543;
  if (opresult3543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3546 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3548 = alloc_Float64(2);
// compiled num node returning num3548 (depth = 7)
  int op_slot_right_3547 = gc_frame_newslot(num3548);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3547 = gc_frame_newslot(*var_depth);
  params[0] = num3548;
  partcv[0] = 1;
  Object sum3550 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3550 (depth = 6)
  gc_frame_newslot(sum3550);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3552 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3551);
// compiled call node returning call3552 (depth = 7)
// compiled member node returning call3552 (depth = 6)
  params[0] = sum3550;
  partcv[0] = 1;
  Object call3553 = callmethod(call3552, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3546);
// compiled call node returning call3553 (depth = 5)
  int op_slot_right_3545 = gc_frame_newslot(call3553);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3545 = gc_frame_newslot(*var_s);
  params[0] = call3553;
  partcv[0] = 1;
  Object opresult3555 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3555 (depth = 4)
  *var_s = opresult3555;
  if (opresult3555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3558 == NULL) {
    strlit3558 = alloc_String("""\x0a""");
    gc_root(strlit3558);
  }
// compiled string node returning strlit3558 (depth = 5)
  int op_slot_right_3557 = gc_frame_newslot(strlit3558);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3557 = gc_frame_newslot(*var_s);
  params[0] = strlit3558;
  partcv[0] = 1;
  Object opresult3560 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3560 (depth = 4)
  *var_s = opresult3560;
  if (opresult3560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3565 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3564);
// compiled call node returning call3565 (depth = 6)
// compiled member node returning call3565 (depth = 5)
  int op_slot_right_3563 = gc_frame_newslot(call3565);
// starting to compile identifier node (depth = 5)
  Object bool3567 = alloc_Boolean(0);
// compiled identifier node returning bool3567 (depth = 5)
  int op_slot_left_3563 = gc_frame_newslot(bool3567);
  params[0] = call3565;
  partcv[0] = 1;
  Object opresult3568 = callmethod(bool3567, "!=", 1, partcv, params);
// compiled op node returning opresult3568 (depth = 4)
  Object if3562 = done;
  if (istrue(opresult3568)) {
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3570 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3572 = alloc_Float64(2);
// compiled num node returning num3572 (depth = 8)
  int op_slot_right_3571 = gc_frame_newslot(num3572);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3571 = gc_frame_newslot(*var_depth);
  params[0] = num3572;
  partcv[0] = 1;
  Object sum3574 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3574 (depth = 7)
  gc_frame_newslot(sum3574);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3575 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3576 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3575);
// compiled call node returning call3576 (depth = 8)
// compiled member node returning call3576 (depth = 7)
  params[0] = sum3574;
  partcv[0] = 1;
  Object call3577 = callmethod(call3576, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3570);
// compiled call node returning call3577 (depth = 6)
  int op_slot_right_3569 = gc_frame_newslot(call3577);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3569 = gc_frame_newslot(*var_s);
  params[0] = call3577;
  partcv[0] = 1;
  Object opresult3579 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3579 (depth = 5)
  *var_s = opresult3579;
  if (opresult3579 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3562 = done;
  } else {
  }
// compiled if node returning if3562 (depth = 3)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3593(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3595 == NULL) {
    strlit3595 = alloc_String("    ");
    gc_root(strlit3595);
  }
// compiled string node returning strlit3595 (depth = 7)
  int op_slot_right_3594 = gc_frame_newslot(strlit3595);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3594 = gc_frame_newslot(*var_spc);
  params[0] = strlit3595;
  partcv[0] = 1;
  Object opresult3597 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3597 (depth = 6)
  *var_spc = opresult3597;
  if (opresult3597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3582 == NULL) {
    strlit3582 = alloc_String("");
    gc_root(strlit3582);
  }
// compiled string node returning strlit3582 (depth = 4)
  *var_spc = strlit3582;
  if (strlit3582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3583 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3586 = alloc_Float64(1);
// compiled num node returning num3586 (depth = 6)
  int op_slot_right_3585 = gc_frame_newslot(num3586);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3585 = gc_frame_newslot(*var_depth);
  params[0] = num3586;
  partcv[0] = 1;
  Object diff3588 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3588 (depth = 5)
  int op_slot_right_3584 = gc_frame_newslot(diff3588);
// starting to compile num node (depth = 5)
  Object num3590 = alloc_Float64(0);
// compiled num node returning num3590 (depth = 5)
  int op_slot_left_3584 = gc_frame_newslot(num3590);
  params[0] = diff3588;
  partcv[0] = 1;
  Object opresult3591 = callmethod(num3590, "..", 1, partcv, params);
// compiled op node returning opresult3591 (depth = 4)
  gc_frame_newslot(opresult3591);
// starting to compile block node (depth = 4)
  Object block3592 = alloc_Block(NULL, NULL, "ast", 799);
  gc_frame_newslot(block3592);
// method "_apply"
  block_savedest(block3592);
  Object closure3593 = createclosure(2, "_apply");
  setclosureframe(closure3593, stackframe);
  addtoclosure(closure3593, var_spc);
  addtoclosure(closure3593, selfslot);
  struct UserObject *uo3593 = (struct UserObject*)block3592;
  uo3593->data[0] = (Object)closure3593;
  Method *meth_meth_ast__apply3593 = addmethod2pos(block3592, "_apply", &meth_ast__apply3593, 0);
  int argcv_meth_ast__apply3593[] = {1};
  meth_meth_ast__apply3593->type = alloc_MethodType(1, argcv_meth_ast__apply3593);
  meth_meth_ast__apply3593->definitionModule = modulename;
  meth_meth_ast__apply3593->definitionLine = 793;
// compiled block node returning block3592 (depth = 4)
  gc_frame_newslot(block3592);
// call case 5: prelude request
  params[0] = opresult3591;
  params[1] = block3592;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3600 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3583);
// compiled call node returning call3600 (depth = 3)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3601 == NULL) {
    strlit3601 = alloc_String("");
    gc_root(strlit3601);
  }
// compiled string node returning strlit3601 (depth = 4)
  *var_s = strlit3601;
  if (strlit3601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3603 == NULL) {
    strlit3603 = alloc_String("");
    gc_root(strlit3603);
  }
// compiled string node returning strlit3603 (depth = 5)
  int op_slot_right_3602 = gc_frame_newslot(strlit3603);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3607 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3606);
// compiled call node returning call3607 (depth = 7)
// compiled member node returning call3607 (depth = 6)
  int op_slot_right_3605 = gc_frame_newslot(call3607);
// starting to compile string node (depth = 6)
  if (strlit3609 == NULL) {
    strlit3609 = alloc_String("type ");
    gc_root(strlit3609);
  }
// compiled string node returning strlit3609 (depth = 6)
  int op_slot_left_3605 = gc_frame_newslot(strlit3609);
  params[0] = call3607;
  partcv[0] = 1;
  Object opresult3610 = callmethod(strlit3609, "++", 1, partcv, params);
// compiled op node returning opresult3610 (depth = 5)
  int op_slot_left_3602 = gc_frame_newslot(opresult3610);
  params[0] = strlit3603;
  partcv[0] = 1;
  Object opresult3611 = callmethod(opresult3610, "++", 1, partcv, params);
// compiled op node returning opresult3611 (depth = 4)
  *var_s = opresult3611;
  if (opresult3611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3615 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3616 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3615);
// compiled call node returning call3616 (depth = 6)
// compiled member node returning call3616 (depth = 5)
  int op_slot_right_3614 = gc_frame_newslot(call3616);
// starting to compile identifier node (depth = 5)
  Object bool3618 = alloc_Boolean(0);
// compiled identifier node returning bool3618 (depth = 5)
  int op_slot_left_3614 = gc_frame_newslot(bool3618);
  params[0] = call3616;
  partcv[0] = 1;
  Object opresult3619 = callmethod(bool3618, "!=", 1, partcv, params);
// compiled op node returning opresult3619 (depth = 4)
  Object if3613 = done;
  if (istrue(opresult3619)) {
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3620 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num3621 = alloc_Float64(0);
// compiled num node returning num3621 (depth = 5)
  gc_frame_newslot(num3621);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3623 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3622);
// compiled call node returning call3623 (depth = 6)
// compiled member node returning call3623 (depth = 5)
  params[0] = num3621;
  partcv[0] = 1;
  Object call3624 = callmethod(call3623, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3620);
// compiled call node returning call3624 (depth = 4)
    gc_frame_newslot(call3624);
    if3613 = call3624;
  } else {
  }
// compiled if node returning if3613 (depth = 3)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3626 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3628 = alloc_Float64(2);
// compiled num node returning num3628 (depth = 6)
  int op_slot_right_3627 = gc_frame_newslot(num3628);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3627 = gc_frame_newslot(*var_depth);
  params[0] = num3628;
  partcv[0] = 1;
  Object sum3630 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3630 (depth = 5)
  gc_frame_newslot(sum3630);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3632 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3631);
// compiled call node returning call3632 (depth = 6)
// compiled member node returning call3632 (depth = 5)
  params[0] = sum3630;
  partcv[0] = 1;
  Object call3633 = callmethod(call3632, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3626);
// compiled call node returning call3633 (depth = 4)
  int op_slot_right_3625 = gc_frame_newslot(call3633);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3636 == NULL) {
    strlit3636 = alloc_String(" = ");
    gc_root(strlit3636);
  }
// compiled string node returning strlit3636 (depth = 5)
  int op_slot_right_3635 = gc_frame_newslot(strlit3636);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3635 = gc_frame_newslot(*var_s);
  params[0] = strlit3636;
  partcv[0] = 1;
  Object opresult3638 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3638 (depth = 4)
  int op_slot_left_3625 = gc_frame_newslot(opresult3638);
  params[0] = call3633;
  partcv[0] = 1;
  Object opresult3639 = callmethod(opresult3638, "++", 1, partcv, params);
// compiled op node returning opresult3639 (depth = 3)
  gc_frame_end(frame);
  return opresult3639;
}
Object meth_ast_shallowCopy3640(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3641 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe3642 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3644 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3643);
// compiled call node returning call3644 (depth = 6)
// compiled member node returning call3644 (depth = 5)
  gc_frame_newslot(call3644);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeDecNode (depth = 5)
  params[0] = call3644;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3645 = callmethod(*var_typeDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3642);
// compiled call node returning call3645 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3646 = callmethod(call3645, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3641);
// compiled call node returning call3646 (depth = 3)
  gc_frame_end(frame);
  return call3646;
}
Object meth_ast_new3334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3335 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3335 = alloc_userobj2(24,21, objclass3335);
  gc_frame_newslot(obj3335);
if (objclass3335 == NULL) {
  glfree(obj3335->class->name);
  obj3335->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3335, self, 0);
  addmethodreal(obj3335,"outer", &reader_ast_outer_3336);
  Object oldself3335 = self;
  struct StackFrameObject *oldstackframe3335 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3335);
  gc_frame_newslot((Object)stackframe);
  self = obj3335;
  Object *oldselfslot3335 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3335 = (*(struct UserObject *)self).data[0], lowerouter3335 = thisouter3335;
  if (inheritingObject3335) {
    struct UserObject *inho3335 = (struct UserObject *)inheritingObject3335;
    while (inho3335->super != GraceDefaultObject) inho3335 = (struct UserObject *)inho3335->super;
    inho3335->super = obj3335;
    self = inheritingObject3335;
    *selfslot = self;
    lowerouter3335 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3335;
  }
if (objclass3335 == NULL) {
  Method *reader3337 = addmethodrealflags(obj3335, "kind",&reader_ast_kind_3337, MFLAG_DEF);
  reader3337->definitionModule = modulename;
  reader3337->definitionLine = 733;
}
adddatum2(obj3335, alloc_Undefined(), 1);
if (objclass3335 == NULL) {
  Method *reader3338 = addmethodrealflags(obj3335, "name",&reader_ast_name_3338, 0);
  Method *writer3338 = addmethodrealflags(obj3335, "name:=",&writer_ast_name_3338, 0);
  reader3338->definitionModule = modulename;
  writer3338->definitionModule = modulename;
  reader3338->definitionLine = 734;
  writer3338->definitionLine = 734;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 2);
if (objclass3335 == NULL) {
  Method *reader3339 = addmethodrealflags(obj3335, "value",&reader_ast_value_3339, 0);
  Method *writer3339 = addmethodrealflags(obj3335, "value:=",&writer_ast_value_3339, 0);
  reader3339->definitionModule = modulename;
  writer3339->definitionModule = modulename;
  reader3339->definitionLine = 735;
  writer3339->definitionLine = 735;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 3);
if (objclass3335 == NULL) {
  Method *reader3340 = addmethodrealflags(obj3335, "nameString",&reader_ast_nameString_3340, MFLAG_DEF);
  reader3340->definitionModule = modulename;
  reader3340->definitionLine = 736;
}
adddatum2(obj3335, alloc_Undefined(), 4);
if (objclass3335 == NULL) {
  Method *reader3341 = addmethodrealflags(obj3335, "annotations",&reader_ast_annotations_3341, 0);
  Method *writer3341 = addmethodrealflags(obj3335, "annotations:=",&writer_ast_annotations_3341, 0);
  reader3341->definitionModule = modulename;
  writer3341->definitionModule = modulename;
  reader3341->definitionLine = 737;
  writer3341->definitionLine = 737;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 5);
if (objclass3335 == NULL) {
  Method *reader3342 = addmethodrealflags(obj3335, "typeParams",&reader_ast_typeParams_3342, 0);
  Method *writer3342 = addmethodrealflags(obj3335, "typeParams:=",&writer_ast_typeParams_3342, 0);
  reader3342->definitionModule = modulename;
  writer3342->definitionModule = modulename;
  reader3342->definitionLine = 738;
  writer3342->definitionLine = 738;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3343 = (struct UserObject*)obj3335;
  uo3343->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3343 = addmethod2pos(obj3335, "isLegalInTrait", &meth_ast_isLegalInTrait3343, 7);
  int argcv_meth_ast_isLegalInTrait3343[] = {0};
  meth_meth_ast_isLegalInTrait3343->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3343);
  meth_meth_ast_isLegalInTrait3343->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3343->definitionLine = 740;
// method "isTypeDec"
  struct UserObject *uo3345 = (struct UserObject*)obj3335;
  uo3345->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3345 = addmethod2pos(obj3335, "isTypeDec", &meth_ast_isTypeDec3345, 8);
  int argcv_meth_ast_isTypeDec3345[] = {0};
  meth_meth_ast_isTypeDec3345->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3345);
  meth_meth_ast_isTypeDec3345->definitionModule = modulename;
  meth_meth_ast_isTypeDec3345->definitionLine = 741;
// method "scope:="
  struct UserObject *uo3347 = (struct UserObject*)obj3335;
  uo3347->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3347 = addmethod2pos(obj3335, "scope:=", &meth_ast_scope_58__61_3347, 9);
  int argcv_meth_ast_scope_58__61_3347[] = {1};
  meth_meth_ast_scope_58__61_3347->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3347);
  meth_meth_ast_scope_58__61_3347->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3347->definitionLine = 742;
// method "isExecutable"
  struct UserObject *uo3352 = (struct UserObject*)obj3335;
  uo3352->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3352 = addmethod2pos(obj3335, "isExecutable", &meth_ast_isExecutable3352, 10);
  int argcv_meth_ast_isExecutable3352[] = {0};
  meth_meth_ast_isExecutable3352->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3352);
  meth_meth_ast_isExecutable3352->definitionModule = modulename;
  meth_meth_ast_isExecutable3352->definitionLine = 749;
// method "declarationKindWithAncestors"
  block_savedest(obj3335);
  Object closure3354 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3354, stackframe);
  addtoclosure(closure3354, var_k);
  struct UserObject *uo3354 = (struct UserObject*)obj3335;
  uo3354->data[11] = (Object)closure3354;
  Method *meth_meth_ast_declarationKindWithAncestors3354 = addmethod2pos(obj3335, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3354, 11);
  int argcv_meth_ast_declarationKindWithAncestors3354[] = {1};
  meth_meth_ast_declarationKindWithAncestors3354->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3354);
  meth_meth_ast_declarationKindWithAncestors3354->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3354->definitionLine = 750;
// method "isConfidential"
  struct UserObject *uo3357 = (struct UserObject*)obj3335;
  uo3357->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3357 = addmethod2pos(obj3335, "isConfidential", &meth_ast_isConfidential3357, 12);
  int argcv_meth_ast_isConfidential3357[] = {0};
  meth_meth_ast_isConfidential3357->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3357);
  meth_meth_ast_isConfidential3357->definitionModule = modulename;
  meth_meth_ast_isConfidential3357->definitionLine = 751;
// method "isPublic"
  struct UserObject *uo3375 = (struct UserObject*)obj3335;
  uo3375->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3375 = addmethod2pos(obj3335, "isPublic", &meth_ast_isPublic3375, 13);
  int argcv_meth_ast_isPublic3375[] = {0};
  meth_meth_ast_isPublic3375->type = alloc_MethodType(1, argcv_meth_ast_isPublic3375);
  meth_meth_ast_isPublic3375->definitionModule = modulename;
  meth_meth_ast_isPublic3375->definitionLine = 755;
// method "isWritable"
  struct UserObject *uo3380 = (struct UserObject*)obj3335;
  uo3380->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3380 = addmethod2pos(obj3335, "isWritable", &meth_ast_isWritable3380, 14);
  int argcv_meth_ast_isWritable3380[] = {0};
  meth_meth_ast_isWritable3380->type = alloc_MethodType(1, argcv_meth_ast_isWritable3380);
  meth_meth_ast_isWritable3380->definitionModule = modulename;
  meth_meth_ast_isWritable3380->definitionLine = 756;
// method "isReadable"
  struct UserObject *uo3382 = (struct UserObject*)obj3335;
  uo3382->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3382 = addmethod2pos(obj3335, "isReadable", &meth_ast_isReadable3382, 15);
  int argcv_meth_ast_isReadable3382[] = {0};
  meth_meth_ast_isReadable3382->type = alloc_MethodType(1, argcv_meth_ast_isReadable3382);
  meth_meth_ast_isReadable3382->definitionModule = modulename;
  meth_meth_ast_isReadable3382->definitionLine = 757;
// method "accept()from"
  struct UserObject *uo3385 = (struct UserObject*)obj3335;
  uo3385->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3385 = addmethod2pos(obj3335, "accept()from", &meth_ast_accept_40__41_from3385, 16);
  int argcv_meth_ast_accept_40__41_from3385[] = {1, 1};
  meth_meth_ast_accept_40__41_from3385->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3385);
  meth_meth_ast_accept_40__41_from3385->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3385->definitionLine = 759;
// method "map()ancestors"
  struct UserObject *uo3419 = (struct UserObject*)obj3335;
  uo3419->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3419 = addmethod2pos(obj3335, "map()ancestors", &meth_ast_map_40__41_ancestors3419, 17);
  int argcv_meth_ast_map_40__41_ancestors3419[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3419->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3419);
  meth_meth_ast_map_40__41_ancestors3419->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3419->definitionLine = 770;
// method "pretty"
  struct UserObject *uo3458 = (struct UserObject*)obj3335;
  uo3458->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty3458 = addmethod2pos(obj3335, "pretty", &meth_ast_pretty3458, 18);
  int argcv_meth_ast_pretty3458[] = {1};
  meth_meth_ast_pretty3458->type = alloc_MethodType(1, argcv_meth_ast_pretty3458);
  meth_meth_ast_pretty3458->definitionModule = modulename;
  meth_meth_ast_pretty3458->definitionLine = 779;
// method "toGrace"
  struct UserObject *uo3581 = (struct UserObject*)obj3335;
  uo3581->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace3581 = addmethod2pos(obj3335, "toGrace", &meth_ast_toGrace3581, 19);
  int argcv_meth_ast_toGrace3581[] = {1};
  meth_meth_ast_toGrace3581->type = alloc_MethodType(1, argcv_meth_ast_toGrace3581);
meth_meth_ast_toGrace3581->type->types[0] = type_Number;
meth_meth_ast_toGrace3581->type->names[0] = "depth";
  meth_meth_ast_toGrace3581->definitionModule = modulename;
  meth_meth_ast_toGrace3581->definitionLine = 797;
// method "shallowCopy"
  block_savedest(obj3335);
  Object closure3640 = createclosure(2, "shallowCopy");
  setclosureframe(closure3640, stackframe);
  addtoclosure(closure3640, var_nullNode);
  addtoclosure(closure3640, var_typeDecNode);
  struct UserObject *uo3640 = (struct UserObject*)obj3335;
  uo3640->data[20] = (Object)closure3640;
  Method *meth_meth_ast_shallowCopy3640 = addmethod2pos(obj3335, "shallowCopy", &meth_ast_shallowCopy3640, 20);
  int argcv_meth_ast_shallowCopy3640[] = {0};
  meth_meth_ast_shallowCopy3640->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3640);
  meth_meth_ast_shallowCopy3640->definitionModule = modulename;
  meth_meth_ast_shallowCopy3640->definitionLine = 809;
  sourceObject = obj3335;
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3647 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3648 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3649 = gc_frame_new();
// call case 3: self.outer request
  Object call3650 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3649);
// compiled call node returning call3650 (depth = 7)
// compiled member node returning call3650 (depth = 6)
  partcv[0] = 0;
  Object call3651 = callmethodflags(call3650, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3648);
// compiled call node returning call3651 (depth = 5)
// compiled member node returning call3651 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3652 = callmethodflags(call3651, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3647);
// compiled call node returning call3652 (depth = 3)
  struct UserObject *obj3335_uo = (struct UserObject *)obj3335;
  obj3335_uo->super = call3652;
  sourceObject = obj3335;
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3653 == NULL) {
    strlit3653 = alloc_String("typedec");
    gc_root(strlit3653);
  }
// compiled string node returning strlit3653 (depth = 3)
  adddatum2(obj3335, strlit3653, 1);
  sourceObject = obj3335;
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3335, *var_name_39_, 2);
  sourceObject = obj3335;
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3335, *var_typeValue, 3);
  sourceObject = obj3335;
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3654 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3656 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3655);
// compiled call node returning call3656 (depth = 6)
// compiled member node returning call3656 (depth = 5)
  partcv[0] = 0;
  Object call3657 = callmethod(call3656, "value",
    1, partcv, params);
  gc_frame_end(callframe3654);
// compiled call node returning call3657 (depth = 4)
// compiled member node returning call3657 (depth = 3)
  adddatum2(obj3335, call3657, 4);
  sourceObject = obj3335;
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3658 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3659 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3660 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3659);
// compiled call node returning call3660 (depth = 6)
// compiled member node returning call3660 (depth = 5)
  partcv[0] = 0;
  Object call3661 = callmethod(call3660, "empty",
    1, partcv, params);
  gc_frame_end(callframe3658);
// compiled call node returning call3661 (depth = 4)
// compiled member node returning call3661 (depth = 3)
  adddatum2(obj3335, call3661, 5);
  sourceObject = obj3335;
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3662 = alloc_Boolean(0);
// compiled identifier node returning bool3662 (depth = 3)
  adddatum2(obj3335, bool3662, 6);
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  objclass3335 = obj3335->class;
  objclass3335->definitionModule = modulename;
  objclass3335->definitionLine = 731;
  (*(struct UserObject *)self).data[0] = lowerouter3335;
  self = oldself3335;
  selfslot = oldselfslot3335;
  stackframe = oldstackframe3335;
  gc_frame_end(frame);
  return obj3335;
}
Object meth_ast_new3334_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3335 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3335 = alloc_userobj2(24,21, objclass3335);
  gc_frame_newslot(obj3335);
if (objclass3335 == NULL) {
  glfree(obj3335->class->name);
  obj3335->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3335, self, 0);
  addmethodreal(obj3335,"outer", &reader_ast_outer_3336);
  Object oldself3335 = self;
  struct StackFrameObject *oldstackframe3335 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3335);
  gc_frame_newslot((Object)stackframe);
  self = obj3335;
  Object *oldselfslot3335 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3335 = (*(struct UserObject *)self).data[0], lowerouter3335 = thisouter3335;
  if (inheritingObject3335) {
    struct UserObject *inho3335 = (struct UserObject *)inheritingObject3335;
    while (inho3335->super != GraceDefaultObject) inho3335 = (struct UserObject *)inho3335->super;
    inho3335->super = obj3335;
    self = inheritingObject3335;
    *selfslot = self;
    lowerouter3335 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3335;
  }
if (objclass3335 == NULL) {
  Method *reader3337 = addmethodrealflags(obj3335, "kind",&reader_ast_kind_3337, MFLAG_DEF);
  reader3337->definitionModule = modulename;
  reader3337->definitionLine = 733;
}
adddatum2(obj3335, alloc_Undefined(), 1);
if (objclass3335 == NULL) {
  Method *reader3338 = addmethodrealflags(obj3335, "name",&reader_ast_name_3338, 0);
  Method *writer3338 = addmethodrealflags(obj3335, "name:=",&writer_ast_name_3338, 0);
  reader3338->definitionModule = modulename;
  writer3338->definitionModule = modulename;
  reader3338->definitionLine = 734;
  writer3338->definitionLine = 734;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 2);
if (objclass3335 == NULL) {
  Method *reader3339 = addmethodrealflags(obj3335, "value",&reader_ast_value_3339, 0);
  Method *writer3339 = addmethodrealflags(obj3335, "value:=",&writer_ast_value_3339, 0);
  reader3339->definitionModule = modulename;
  writer3339->definitionModule = modulename;
  reader3339->definitionLine = 735;
  writer3339->definitionLine = 735;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 3);
if (objclass3335 == NULL) {
  Method *reader3340 = addmethodrealflags(obj3335, "nameString",&reader_ast_nameString_3340, MFLAG_DEF);
  reader3340->definitionModule = modulename;
  reader3340->definitionLine = 736;
}
adddatum2(obj3335, alloc_Undefined(), 4);
if (objclass3335 == NULL) {
  Method *reader3341 = addmethodrealflags(obj3335, "annotations",&reader_ast_annotations_3341, 0);
  Method *writer3341 = addmethodrealflags(obj3335, "annotations:=",&writer_ast_annotations_3341, 0);
  reader3341->definitionModule = modulename;
  writer3341->definitionModule = modulename;
  reader3341->definitionLine = 737;
  writer3341->definitionLine = 737;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 5);
if (objclass3335 == NULL) {
  Method *reader3342 = addmethodrealflags(obj3335, "typeParams",&reader_ast_typeParams_3342, 0);
  Method *writer3342 = addmethodrealflags(obj3335, "typeParams:=",&writer_ast_typeParams_3342, 0);
  reader3342->definitionModule = modulename;
  writer3342->definitionModule = modulename;
  reader3342->definitionLine = 738;
  writer3342->definitionLine = 738;
}
obj3335->flags |= OFLAG_MUTABLE;
adddatum2(obj3335, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3343 = (struct UserObject*)obj3335;
  uo3343->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3343 = addmethod2pos(obj3335, "isLegalInTrait", &meth_ast_isLegalInTrait3343, 7);
  int argcv_meth_ast_isLegalInTrait3343[] = {0};
  meth_meth_ast_isLegalInTrait3343->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3343);
  meth_meth_ast_isLegalInTrait3343->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3343->definitionLine = 740;
// method "isTypeDec"
  struct UserObject *uo3345 = (struct UserObject*)obj3335;
  uo3345->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3345 = addmethod2pos(obj3335, "isTypeDec", &meth_ast_isTypeDec3345, 8);
  int argcv_meth_ast_isTypeDec3345[] = {0};
  meth_meth_ast_isTypeDec3345->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3345);
  meth_meth_ast_isTypeDec3345->definitionModule = modulename;
  meth_meth_ast_isTypeDec3345->definitionLine = 741;
// method "scope:="
  struct UserObject *uo3347 = (struct UserObject*)obj3335;
  uo3347->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3347 = addmethod2pos(obj3335, "scope:=", &meth_ast_scope_58__61_3347, 9);
  int argcv_meth_ast_scope_58__61_3347[] = {1};
  meth_meth_ast_scope_58__61_3347->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3347);
  meth_meth_ast_scope_58__61_3347->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3347->definitionLine = 742;
// method "isExecutable"
  struct UserObject *uo3352 = (struct UserObject*)obj3335;
  uo3352->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3352 = addmethod2pos(obj3335, "isExecutable", &meth_ast_isExecutable3352, 10);
  int argcv_meth_ast_isExecutable3352[] = {0};
  meth_meth_ast_isExecutable3352->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3352);
  meth_meth_ast_isExecutable3352->definitionModule = modulename;
  meth_meth_ast_isExecutable3352->definitionLine = 749;
// method "declarationKindWithAncestors"
  block_savedest(obj3335);
  Object closure3354 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3354, stackframe);
  addtoclosure(closure3354, var_k);
  struct UserObject *uo3354 = (struct UserObject*)obj3335;
  uo3354->data[11] = (Object)closure3354;
  Method *meth_meth_ast_declarationKindWithAncestors3354 = addmethod2pos(obj3335, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3354, 11);
  int argcv_meth_ast_declarationKindWithAncestors3354[] = {1};
  meth_meth_ast_declarationKindWithAncestors3354->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3354);
  meth_meth_ast_declarationKindWithAncestors3354->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3354->definitionLine = 750;
// method "isConfidential"
  struct UserObject *uo3357 = (struct UserObject*)obj3335;
  uo3357->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3357 = addmethod2pos(obj3335, "isConfidential", &meth_ast_isConfidential3357, 12);
  int argcv_meth_ast_isConfidential3357[] = {0};
  meth_meth_ast_isConfidential3357->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3357);
  meth_meth_ast_isConfidential3357->definitionModule = modulename;
  meth_meth_ast_isConfidential3357->definitionLine = 751;
// method "isPublic"
  struct UserObject *uo3375 = (struct UserObject*)obj3335;
  uo3375->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3375 = addmethod2pos(obj3335, "isPublic", &meth_ast_isPublic3375, 13);
  int argcv_meth_ast_isPublic3375[] = {0};
  meth_meth_ast_isPublic3375->type = alloc_MethodType(1, argcv_meth_ast_isPublic3375);
  meth_meth_ast_isPublic3375->definitionModule = modulename;
  meth_meth_ast_isPublic3375->definitionLine = 755;
// method "isWritable"
  struct UserObject *uo3380 = (struct UserObject*)obj3335;
  uo3380->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3380 = addmethod2pos(obj3335, "isWritable", &meth_ast_isWritable3380, 14);
  int argcv_meth_ast_isWritable3380[] = {0};
  meth_meth_ast_isWritable3380->type = alloc_MethodType(1, argcv_meth_ast_isWritable3380);
  meth_meth_ast_isWritable3380->definitionModule = modulename;
  meth_meth_ast_isWritable3380->definitionLine = 756;
// method "isReadable"
  struct UserObject *uo3382 = (struct UserObject*)obj3335;
  uo3382->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3382 = addmethod2pos(obj3335, "isReadable", &meth_ast_isReadable3382, 15);
  int argcv_meth_ast_isReadable3382[] = {0};
  meth_meth_ast_isReadable3382->type = alloc_MethodType(1, argcv_meth_ast_isReadable3382);
  meth_meth_ast_isReadable3382->definitionModule = modulename;
  meth_meth_ast_isReadable3382->definitionLine = 757;
// method "accept()from"
  struct UserObject *uo3385 = (struct UserObject*)obj3335;
  uo3385->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3385 = addmethod2pos(obj3335, "accept()from", &meth_ast_accept_40__41_from3385, 16);
  int argcv_meth_ast_accept_40__41_from3385[] = {1, 1};
  meth_meth_ast_accept_40__41_from3385->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3385);
  meth_meth_ast_accept_40__41_from3385->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3385->definitionLine = 759;
// method "map()ancestors"
  struct UserObject *uo3419 = (struct UserObject*)obj3335;
  uo3419->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3419 = addmethod2pos(obj3335, "map()ancestors", &meth_ast_map_40__41_ancestors3419, 17);
  int argcv_meth_ast_map_40__41_ancestors3419[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3419->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3419);
  meth_meth_ast_map_40__41_ancestors3419->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3419->definitionLine = 770;
// method "pretty"
  struct UserObject *uo3458 = (struct UserObject*)obj3335;
  uo3458->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty3458 = addmethod2pos(obj3335, "pretty", &meth_ast_pretty3458, 18);
  int argcv_meth_ast_pretty3458[] = {1};
  meth_meth_ast_pretty3458->type = alloc_MethodType(1, argcv_meth_ast_pretty3458);
  meth_meth_ast_pretty3458->definitionModule = modulename;
  meth_meth_ast_pretty3458->definitionLine = 779;
// method "toGrace"
  struct UserObject *uo3581 = (struct UserObject*)obj3335;
  uo3581->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace3581 = addmethod2pos(obj3335, "toGrace", &meth_ast_toGrace3581, 19);
  int argcv_meth_ast_toGrace3581[] = {1};
  meth_meth_ast_toGrace3581->type = alloc_MethodType(1, argcv_meth_ast_toGrace3581);
meth_meth_ast_toGrace3581->type->types[0] = type_Number;
meth_meth_ast_toGrace3581->type->names[0] = "depth";
  meth_meth_ast_toGrace3581->definitionModule = modulename;
  meth_meth_ast_toGrace3581->definitionLine = 797;
// method "shallowCopy"
  block_savedest(obj3335);
  Object closure3640 = createclosure(2, "shallowCopy");
  setclosureframe(closure3640, stackframe);
  addtoclosure(closure3640, var_nullNode);
  addtoclosure(closure3640, var_typeDecNode);
  struct UserObject *uo3640 = (struct UserObject*)obj3335;
  uo3640->data[20] = (Object)closure3640;
  Method *meth_meth_ast_shallowCopy3640 = addmethod2pos(obj3335, "shallowCopy", &meth_ast_shallowCopy3640, 20);
  int argcv_meth_ast_shallowCopy3640[] = {0};
  meth_meth_ast_shallowCopy3640->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3640);
  meth_meth_ast_shallowCopy3640->definitionModule = modulename;
  meth_meth_ast_shallowCopy3640->definitionLine = 809;
  sourceObject = obj3335;
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3647 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3648 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3649 = gc_frame_new();
// call case 3: self.outer request
  Object call3650 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3649);
// compiled call node returning call3650 (depth = 7)
// compiled member node returning call3650 (depth = 6)
  partcv[0] = 0;
  Object call3651 = callmethodflags(call3650, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3648);
// compiled call node returning call3651 (depth = 5)
// compiled member node returning call3651 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3652 = callmethodflags(call3651, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3647);
// compiled call node returning call3652 (depth = 3)
  struct UserObject *obj3335_uo = (struct UserObject *)obj3335;
  obj3335_uo->super = call3652;
  sourceObject = obj3335;
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3653 == NULL) {
    strlit3653 = alloc_String("typedec");
    gc_root(strlit3653);
  }
// compiled string node returning strlit3653 (depth = 3)
  adddatum2(obj3335, strlit3653, 1);
  sourceObject = obj3335;
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3335, *var_name_39_, 2);
  sourceObject = obj3335;
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3335, *var_typeValue, 3);
  sourceObject = obj3335;
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3654 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3656 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3655);
// compiled call node returning call3656 (depth = 6)
// compiled member node returning call3656 (depth = 5)
  partcv[0] = 0;
  Object call3657 = callmethod(call3656, "value",
    1, partcv, params);
  gc_frame_end(callframe3654);
// compiled call node returning call3657 (depth = 4)
// compiled member node returning call3657 (depth = 3)
  adddatum2(obj3335, call3657, 4);
  sourceObject = obj3335;
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3658 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3659 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3660 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3659);
// compiled call node returning call3660 (depth = 6)
// compiled member node returning call3660 (depth = 5)
  partcv[0] = 0;
  Object call3661 = callmethod(call3660, "empty",
    1, partcv, params);
  gc_frame_end(callframe3658);
// compiled call node returning call3661 (depth = 4)
// compiled member node returning call3661 (depth = 3)
  adddatum2(obj3335, call3661, 5);
  sourceObject = obj3335;
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3662 = alloc_Boolean(0);
// compiled identifier node returning bool3662 (depth = 3)
  adddatum2(obj3335, bool3662, 6);
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  sourceObject = obj3335;
  objclass3335 = obj3335->class;
  objclass3335->definitionModule = modulename;
  objclass3335->definitionLine = 731;
  (*(struct UserObject *)self).data[0] = lowerouter3335;
  self = oldself3335;
  selfslot = oldselfslot3335;
  stackframe = oldstackframe3335;
  gc_frame_end(frame);
  return obj3335;
}
Object meth_ast_typeDecNode3664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_new_40__41_scope3667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[4];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_body = &(stackframe->slots[2]);
  *var_body = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[3]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[4]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3668 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call3669 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3668);
// compiled call node returning call3669 (depth = 4)
  *var_result = call3669;
  if (call3669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3670 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call3671 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe3670);
// compiled call node returning call3671 (depth = 3)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isMethod3687(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3688 = alloc_Boolean(1);
// compiled identifier node returning bool3688 (depth = 3)
  gc_frame_end(frame);
  return bool3688;
}
Object meth_ast_isExecutable3689(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3690 = alloc_Boolean(0);
// compiled identifier node returning bool3690 (depth = 3)
  gc_frame_end(frame);
  return bool3690;
}
Object meth_ast_isLegalInTrait3691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3692 = alloc_Boolean(1);
// compiled identifier node returning bool3692 (depth = 3)
  gc_frame_end(frame);
  return bool3692;
}
Object meth_ast_isClass3693(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3695 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3696 = callmethodflags(self, "usesClassSyntax", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3695);
// compiled call node returning call3696 (depth = 5)
// compiled member node returning call3696 (depth = 4)
  int op_slot_right_3694 = gc_frame_newslot(call3696);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3699 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3698);
// compiled call node returning call3699 (depth = 5)
// compiled member node returning call3699 (depth = 4)
  int op_slot_left_3694 = gc_frame_newslot(call3699);
  params[0] = call3696;
  partcv[0] = 1;
  Object opresult3700 = callmethod(call3699, "||", 1, partcv, params);
// compiled op node returning opresult3700 (depth = 3)
  gc_frame_end(frame);
  return opresult3700;
}
Object meth_ast_isTrait3701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3703 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3704 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3703);
// compiled call node returning call3704 (depth = 5)
// compiled member node returning call3704 (depth = 4)
  Object if3702 = done;
  if (istrue(call3704)) {
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3705 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3706 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3707 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3708 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3707);
// compiled call node returning call3708 (depth = 9)
// compiled member node returning call3708 (depth = 8)
  partcv[0] = 0;
  Object call3709 = callmethod(call3708, "last",
    1, partcv, params);
  gc_frame_end(callframe3706);
// compiled call node returning call3709 (depth = 7)
// compiled member node returning call3709 (depth = 6)
  partcv[0] = 0;
  Object call3710 = callmethod(call3709, "isTrait",
    1, partcv, params);
  gc_frame_end(callframe3705);
// compiled call node returning call3710 (depth = 5)
// compiled member node returning call3710 (depth = 4)
    gc_frame_newslot(call3710);
    if3702 = call3710;
  } else {
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3711 = alloc_Boolean(0);
// compiled identifier node returning bool3711 (depth = 4)
    gc_frame_newslot(bool3711);
    if3702 = bool3711;
  }
// compiled if node returning if3702 (depth = 3)
  gc_frame_end(frame);
  return if3702;
}
Object meth_ast__apply3722(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3724 == NULL) {
    strlit3724 = alloc_String("Unknown");
    gc_root(strlit3724);
  }
// compiled string node returning strlit3724 (depth = 11)
  int op_slot_right_3723 = gc_frame_newslot(strlit3724);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3726 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_p (depth = 15)
  partcv[0] = 0;
  Object call3728 = callmethod(*var_p, "dtype",
    1, partcv, params);
  gc_frame_end(callframe3727);
// compiled call node returning call3728 (depth = 14)
// compiled member node returning call3728 (depth = 13)
  partcv[0] = 0;
  Object call3729 = callmethod(call3728, "nameString",
    1, partcv, params);
  gc_frame_end(callframe3726);
// compiled call node returning call3729 (depth = 12)
// compiled member node returning call3729 (depth = 11)
  int op_slot_left_3723 = gc_frame_newslot(call3729);
  params[0] = strlit3724;
  partcv[0] = 1;
  Object opresult3730 = callmethod(call3729, "!=", 1, partcv, params);
// compiled op node returning opresult3730 (depth = 10)
  gc_frame_end(frame);
  return opresult3730;
}
Object meth_ast__apply3718(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3720 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block3721 = alloc_Block(NULL, NULL, "ast", 857);
  gc_frame_newslot(block3721);
// method "_apply"
  block_savedest(block3721);
  Object closure3722 = createclosure(2, "_apply");
  setclosureframe(closure3722, stackframe);
  addtoclosure(closure3722, var_p);
  addtoclosure(closure3722, selfslot);
  struct UserObject *uo3722 = (struct UserObject*)block3721;
  uo3722->data[0] = (Object)closure3722;
  Method *meth_meth_ast__apply3722 = addmethod2pos(block3721, "_apply", &meth_ast__apply3722, 0);
  int argcv_meth_ast__apply3722[] = {0};
  meth_meth_ast__apply3722->type = alloc_MethodType(1, argcv_meth_ast__apply3722);
  meth_meth_ast__apply3722->definitionModule = modulename;
  meth_meth_ast__apply3722->definitionLine = 849;
// compiled block node returning block3721 (depth = 9)
  gc_frame_newslot(block3721);
// call case 6: other member request
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool3733 = alloc_Boolean(0);
// compiled identifier node returning bool3733 (depth = 10)
  int op_slot_right_3732 = gc_frame_newslot(bool3733);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3735 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  partcv[0] = 0;
  Object call3736 = callmethod(*var_p, "dtype",
    1, partcv, params);
  gc_frame_end(callframe3735);
// compiled call node returning call3736 (depth = 11)
// compiled member node returning call3736 (depth = 10)
  int op_slot_left_3732 = gc_frame_newslot(call3736);
  params[0] = bool3733;
  partcv[0] = 1;
  Object opresult3737 = callmethod(call3736, "!=", 1, partcv, params);
// compiled op node returning opresult3737 (depth = 9)
  params[0] = block3721;
  partcv[0] = 1;
  Object call3738 = callmethod(opresult3737, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3720);
// compiled call node returning call3738 (depth = 8)
  Object if3719 = done;
  if (istrue(call3738)) {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3739 = alloc_Boolean(1);
// compiled identifier node returning bool3739 (depth = 9)
  block_return(realself, bool3739);
// compiled return node returning undefined (depth = 8)
    gc_frame_newslot(undefined);
    if3719 = undefined;
  } else {
  }
// compiled if node returning if3719 (depth = 7)
  gc_frame_end(frame);
  return if3719;
}
Object meth_ast__apply3715(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3716 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3717 = alloc_Block(NULL, NULL, "ast", 856);
  gc_frame_newslot(block3717);
// method "_apply"
  block_savedest(block3717);
  Object closure3718 = createclosure(1, "_apply");
  setclosureframe(closure3718, stackframe);
  addtoclosure(closure3718, selfslot);
  struct UserObject *uo3718 = (struct UserObject*)block3717;
  uo3718->data[0] = (Object)closure3718;
  Method *meth_meth_ast__apply3718 = addmethod2pos(block3717, "_apply", &meth_ast__apply3718, 0);
  int argcv_meth_ast__apply3718[] = {1};
  meth_meth_ast__apply3718->type = alloc_MethodType(1, argcv_meth_ast__apply3718);
  meth_meth_ast__apply3718->definitionModule = modulename;
  meth_meth_ast__apply3718->definitionLine = 849;
// compiled block node returning block3717 (depth = 6)
  gc_frame_newslot(block3717);
// call case 6: other member request
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3741 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call3742 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3741);
// compiled call node returning call3742 (depth = 7)
// compiled member node returning call3742 (depth = 6)
  params[0] = block3717;
  partcv[0] = 1;
  Object call3743 = callmethod(call3742, "do",
    1, partcv, params);
  gc_frame_end(callframe3716);
// compiled call node returning call3743 (depth = 5)
  gc_frame_end(frame);
  return call3743;
}
Object meth_ast_needsArgChecks3712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "needsArgChecks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for needsArgChecks (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for needsArgChecks");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3713 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3714 = alloc_Block(NULL, NULL, "ast", 855);
  gc_frame_newslot(block3714);
// method "_apply"
  block_savedest(block3714);
  Object closure3715 = createclosure(1, "_apply");
  setclosureframe(closure3715, stackframe);
  addtoclosure(closure3715, selfslot);
  struct UserObject *uo3715 = (struct UserObject*)block3714;
  uo3715->data[0] = (Object)closure3715;
  Method *meth_meth_ast__apply3715 = addmethod2pos(block3714, "_apply", &meth_ast__apply3715, 0);
  int argcv_meth_ast__apply3715[] = {1};
  meth_meth_ast__apply3715->type = alloc_MethodType(1, argcv_meth_ast__apply3715);
  meth_meth_ast__apply3715->definitionModule = modulename;
  meth_meth_ast__apply3715->definitionLine = 849;
// compiled block node returning block3714 (depth = 4)
  gc_frame_newslot(block3714);
// call case 6: other member request
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3745 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3746 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3745);
// compiled call node returning call3746 (depth = 5)
// compiled member node returning call3746 (depth = 4)
  params[0] = block3714;
  partcv[0] = 1;
  Object call3747 = callmethod(call3746, "do",
    1, partcv, params);
  gc_frame_end(callframe3713);
// compiled call node returning call3747 (depth = 3)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3748 = alloc_Boolean(0);
// compiled identifier node returning bool3748 (depth = 4)
  return bool3748;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_scope_58__61_3749(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3751 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3750);
// compiled call node returning call3751 (depth = 3)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3752 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3753 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe3752);
// compiled call node returning call3753 (depth = 3)
  gc_frame_end(frame);
  return call3753;
}
Object meth_ast_declarationKindWithAncestors3754(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call3756 = callmethod(*var_k, "parameter",
    1, partcv, params);
  gc_frame_end(callframe3755);
// compiled call node returning call3756 (depth = 4)
// compiled member node returning call3756 (depth = 3)
  gc_frame_end(frame);
  return call3756;
}
Object meth_ast_isConfidential3757(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3760 = alloc_Float64(0);
// compiled num node returning num3760 (depth = 5)
  int op_slot_right_3759 = gc_frame_newslot(num3760);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3762 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3763 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3764 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3763);
// compiled call node returning call3764 (depth = 8)
// compiled member node returning call3764 (depth = 7)
  partcv[0] = 0;
  Object call3765 = callmethod(call3764, "size",
    1, partcv, params);
  gc_frame_end(callframe3762);
// compiled call node returning call3765 (depth = 6)
// compiled member node returning call3765 (depth = 5)
  int op_slot_left_3759 = gc_frame_newslot(call3765);
  params[0] = num3760;
  partcv[0] = 1;
  Object opresult3766 = callmethod(call3765, "==", 1, partcv, params);
// compiled op node returning opresult3766 (depth = 4)
  Object if3758 = done;
  if (istrue(opresult3766)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3767 = alloc_Boolean(0);
// compiled identifier node returning bool3767 (depth = 5)
  return bool3767;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3758 = undefined;
  } else {
  }
// compiled if node returning if3758 (depth = 3)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3768 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3769 == NULL) {
    strlit3769 = alloc_String("confidential");
    gc_root(strlit3769);
  }
// compiled string node returning strlit3769 (depth = 4)
  gc_frame_newslot(strlit3769);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3770 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3771 = gc_frame_new();
// call case 3: self.outer request
  Object call3772 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3771);
// compiled call node returning call3772 (depth = 7)
// compiled member node returning call3772 (depth = 6)
  partcv[0] = 0;
  Object call3773 = callmethodflags(call3772, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3770);
// compiled call node returning call3773 (depth = 5)
// compiled member node returning call3773 (depth = 4)
  params[0] = self;
  params[1] = strlit3769;
  partcv[0] = 2;
  Object call3774 = callmethodflags(call3773, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3768);
// compiled call node returning call3774 (depth = 3)
  gc_frame_end(frame);
  return call3774;
}
Object meth_ast_isPublic3775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3776 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3777 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3778 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3777);
// compiled call node returning call3778 (depth = 6)
// compiled member node returning call3778 (depth = 5)
  partcv[0] = 0;
  Object call3779 = callmethod(call3778, "not",
    1, partcv, params);
  gc_frame_end(callframe3776);
// compiled call node returning call3779 (depth = 4)
// compiled member node returning call3779 (depth = 3)
  gc_frame_end(frame);
  return call3779;
}
Object meth_ast_isWritable3780(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3781 = alloc_Boolean(0);
// compiled identifier node returning bool3781 (depth = 3)
  gc_frame_end(frame);
  return bool3781;
}
Object meth_ast_isReadable3782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3783 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3784 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3783);
// compiled call node returning call3784 (depth = 4)
// compiled member node returning call3784 (depth = 3)
  gc_frame_end(frame);
  return call3784;
}
Object meth_ast_usesAsType3785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3788 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3787);
// compiled call node returning call3788 (depth = 5)
// compiled member node returning call3788 (depth = 4)
  int op_slot_right_3786 = gc_frame_newslot(call3788);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_3786 = gc_frame_newslot(*var_aNode);
  params[0] = call3788;
  partcv[0] = 1;
  Object opresult3790 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult3790 (depth = 3)
  gc_frame_end(frame);
  return opresult3790;
}
Object meth_ast__apply3794(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3795 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3796 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3798 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3797);
// compiled call node returning call3798 (depth = 10)
// compiled member node returning call3798 (depth = 9)
  partcv[0] = 0;
  Object call3799 = callmethod(call3798, "last",
    1, partcv, params);
  gc_frame_end(callframe3796);
// compiled call node returning call3799 (depth = 8)
// compiled member node returning call3799 (depth = 7)
  partcv[0] = 0;
  Object call3800 = callmethod(call3799, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe3795);
// compiled call node returning call3800 (depth = 6)
// compiled member node returning call3800 (depth = 5)
  gc_frame_end(frame);
  return call3800;
}
Object meth_ast_returnsObject3791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3792 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3793 = alloc_Block(NULL, NULL, "ast", 883);
  gc_frame_newslot(block3793);
// method "_apply"
  block_savedest(block3793);
  Object closure3794 = createclosure(1, "_apply");
  setclosureframe(closure3794, stackframe);
  addtoclosure(closure3794, selfslot);
  struct UserObject *uo3794 = (struct UserObject*)block3793;
  uo3794->data[0] = (Object)closure3794;
  Method *meth_meth_ast__apply3794 = addmethod2pos(block3793, "_apply", &meth_ast__apply3794, 0);
  int argcv_meth_ast__apply3794[] = {0};
  meth_meth_ast__apply3794->type = alloc_MethodType(1, argcv_meth_ast__apply3794);
  meth_meth_ast__apply3794->definitionModule = modulename;
  meth_meth_ast__apply3794->definitionLine = 880;
// compiled block node returning block3793 (depth = 4)
  gc_frame_newslot(block3793);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3802 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3803 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3805 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3804);
// compiled call node returning call3805 (depth = 9)
// compiled member node returning call3805 (depth = 8)
  partcv[0] = 0;
  Object call3806 = callmethod(call3805, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe3803);
// compiled call node returning call3806 (depth = 7)
// compiled member node returning call3806 (depth = 6)
  partcv[0] = 0;
  Object call3807 = callmethod(call3806, "not",
    1, partcv, params);
  gc_frame_end(callframe3802);
// compiled call node returning call3807 (depth = 5)
// compiled member node returning call3807 (depth = 4)
  params[0] = block3793;
  partcv[0] = 1;
  Object call3808 = callmethod(call3807, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3792);
// compiled call node returning call3808 (depth = 3)
  gc_frame_end(frame);
  return call3808;
}
Object meth_ast_returnedObjectScope3809(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3810 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3811 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3812 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3813 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3812);
// compiled call node returning call3813 (depth = 8)
// compiled member node returning call3813 (depth = 7)
  partcv[0] = 0;
  Object call3814 = callmethod(call3813, "last",
    1, partcv, params);
  gc_frame_end(callframe3811);
// compiled call node returning call3814 (depth = 6)
// compiled member node returning call3814 (depth = 5)
  partcv[0] = 0;
  Object call3815 = callmethod(call3814, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe3810);
// compiled call node returning call3815 (depth = 4)
// compiled member node returning call3815 (depth = 3)
  gc_frame_end(frame);
  return call3815;
}
Object meth_ast__apply3846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3847 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3848 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3847);
// compiled call node returning call3848 (depth = 8)
  gc_frame_end(frame);
  return call3848;
}
Object meth_ast__apply3841(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3842 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3843 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call3844 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3843);
// compiled call node returning call3844 (depth = 8)
// compiled member node returning call3844 (depth = 7)
  gc_frame_newslot(call3844);
// starting to compile block node (depth = 7)
  Object block3845 = alloc_Block(NULL, NULL, "ast", 897);
  gc_frame_newslot(block3845);
// method "_apply"
  block_savedest(block3845);
  Object closure3846 = createclosure(3, "_apply");
  setclosureframe(closure3846, stackframe);
  addtoclosure(closure3846, var_visitor);
  addtoclosure(closure3846, var_newChain);
  addtoclosure(closure3846, selfslot);
  struct UserObject *uo3846 = (struct UserObject*)block3845;
  uo3846->data[0] = (Object)closure3846;
  Method *meth_meth_ast__apply3846 = addmethod2pos(block3845, "_apply", &meth_ast__apply3846, 0);
  int argcv_meth_ast__apply3846[] = {1};
  meth_meth_ast__apply3846->type = alloc_MethodType(1, argcv_meth_ast__apply3846);
  meth_meth_ast__apply3846->definitionModule = modulename;
  meth_meth_ast__apply3846->definitionLine = 897;
// compiled block node returning block3845 (depth = 7)
  gc_frame_newslot(block3845);
// call case 5: prelude request
  params[0] = call3844;
  params[1] = block3845;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3850 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3842);
// compiled call node returning call3850 (depth = 6)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3853 = alloc_Boolean(0);
// compiled identifier node returning bool3853 (depth = 8)
  int op_slot_right_3852 = gc_frame_newslot(bool3853);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3855 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3856 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3855);
// compiled call node returning call3856 (depth = 9)
// compiled member node returning call3856 (depth = 8)
  int op_slot_left_3852 = gc_frame_newslot(call3856);
  params[0] = bool3853;
  partcv[0] = 1;
  Object opresult3857 = callmethod(call3856, "!=", 1, partcv, params);
// compiled op node returning opresult3857 (depth = 7)
  Object if3851 = done;
  if (istrue(opresult3857)) {
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3858 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3859 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3860 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3859);
// compiled call node returning call3860 (depth = 9)
// compiled member node returning call3860 (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3861 = callmethod(call3860, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3858);
// compiled call node returning call3861 (depth = 7)
    gc_frame_newslot(call3861);
    if3851 = call3861;
  } else {
  }
// compiled if node returning if3851 (depth = 6)
  gc_frame_end(frame);
  return if3851;
}
Object meth_ast__apply3879(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3880 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3881 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3880);
// compiled call node returning call3881 (depth = 6)
  gc_frame_end(frame);
  return call3881;
}
Object meth_ast__apply3888(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3889 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3890 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3889);
// compiled call node returning call3890 (depth = 6)
  gc_frame_end(frame);
  return call3890;
}
Object meth_ast_accept_40__41_from3816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3818 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3819 = callmethod(*var_visitor, "visitMethod()up",
    2, partcv, params);
  gc_frame_end(callframe3818);
// compiled call node returning call3819 (depth = 4)
  Object if3817 = done;
  if (istrue(call3819)) {
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3820 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3821 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3820);
// compiled call node returning call3821 (depth = 5)
  *var_newChain = call3821;
  if (call3821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3822 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3823 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3824 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3823);
// compiled call node returning call3824 (depth = 6)
// compiled member node returning call3824 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3825 = callmethod(call3824, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3822);
// compiled call node returning call3825 (depth = 4)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3828 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3829 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3828);
// compiled call node returning call3829 (depth = 7)
// compiled member node returning call3829 (depth = 6)
  int op_slot_right_3827 = gc_frame_newslot(call3829);
// starting to compile identifier node (depth = 6)
  Object bool3831 = alloc_Boolean(0);
// compiled identifier node returning bool3831 (depth = 6)
  int op_slot_left_3827 = gc_frame_newslot(bool3831);
  params[0] = call3829;
  partcv[0] = 1;
  Object opresult3832 = callmethod(bool3831, "!=", 1, partcv, params);
// compiled op node returning opresult3832 (depth = 5)
  Object if3826 = done;
  if (istrue(opresult3832)) {
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3833 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3834 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3835 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3834);
// compiled call node returning call3835 (depth = 7)
// compiled member node returning call3835 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3836 = callmethod(call3835, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3833);
// compiled call node returning call3836 (depth = 5)
    gc_frame_newslot(call3836);
    if3826 = call3836;
  } else {
  }
// compiled if node returning if3826 (depth = 4)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3837 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3839 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3838);
// compiled call node returning call3839 (depth = 6)
// compiled member node returning call3839 (depth = 5)
  gc_frame_newslot(call3839);
// starting to compile block node (depth = 5)
  Object block3840 = alloc_Block(NULL, NULL, "ast", 896);
  gc_frame_newslot(block3840);
// method "_apply"
  block_savedest(block3840);
  Object closure3841 = createclosure(3, "_apply");
  setclosureframe(closure3841, stackframe);
  addtoclosure(closure3841, var_visitor);
  addtoclosure(closure3841, var_newChain);
  addtoclosure(closure3841, selfslot);
  struct UserObject *uo3841 = (struct UserObject*)block3840;
  uo3841->data[0] = (Object)closure3841;
  Method *meth_meth_ast__apply3841 = addmethod2pos(block3840, "_apply", &meth_ast__apply3841, 0);
  int argcv_meth_ast__apply3841[] = {1};
  meth_meth_ast__apply3841->type = alloc_MethodType(1, argcv_meth_ast__apply3841);
  meth_meth_ast__apply3841->definitionModule = modulename;
  meth_meth_ast__apply3841->definitionLine = 896;
// compiled block node returning block3840 (depth = 5)
  gc_frame_newslot(block3840);
// call case 5: prelude request
  params[0] = call3839;
  params[1] = block3840;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3863 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3837);
// compiled call node returning call3863 (depth = 4)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3866 = alloc_Boolean(0);
// compiled identifier node returning bool3866 (depth = 6)
  int op_slot_right_3865 = gc_frame_newslot(bool3866);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3869 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3868);
// compiled call node returning call3869 (depth = 7)
// compiled member node returning call3869 (depth = 6)
  int op_slot_left_3865 = gc_frame_newslot(call3869);
  params[0] = bool3866;
  partcv[0] = 1;
  Object opresult3870 = callmethod(call3869, "!=", 1, partcv, params);
// compiled op node returning opresult3870 (depth = 5)
  Object if3864 = done;
  if (istrue(opresult3870)) {
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3871 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3873 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3872);
// compiled call node returning call3873 (depth = 7)
// compiled member node returning call3873 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3874 = callmethod(call3873, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3871);
// compiled call node returning call3874 (depth = 5)
    gc_frame_newslot(call3874);
    if3864 = call3874;
  } else {
  }
// compiled if node returning if3864 (depth = 4)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3875 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3876 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3877 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3876);
// compiled call node returning call3877 (depth = 6)
// compiled member node returning call3877 (depth = 5)
  gc_frame_newslot(call3877);
// starting to compile block node (depth = 5)
  Object block3878 = alloc_Block(NULL, NULL, "ast", 907);
  gc_frame_newslot(block3878);
// method "_apply"
  block_savedest(block3878);
  Object closure3879 = createclosure(3, "_apply");
  setclosureframe(closure3879, stackframe);
  addtoclosure(closure3879, var_visitor);
  addtoclosure(closure3879, var_newChain);
  addtoclosure(closure3879, selfslot);
  struct UserObject *uo3879 = (struct UserObject*)block3878;
  uo3879->data[0] = (Object)closure3879;
  Method *meth_meth_ast__apply3879 = addmethod2pos(block3878, "_apply", &meth_ast__apply3879, 0);
  int argcv_meth_ast__apply3879[] = {1};
  meth_meth_ast__apply3879->type = alloc_MethodType(1, argcv_meth_ast__apply3879);
  meth_meth_ast__apply3879->definitionModule = modulename;
  meth_meth_ast__apply3879->definitionLine = 907;
// compiled block node returning block3878 (depth = 5)
  gc_frame_newslot(block3878);
// call case 5: prelude request
  params[0] = call3877;
  params[1] = block3878;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3883 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3875);
// compiled call node returning call3883 (depth = 4)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3884 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3885 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3886 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3885);
// compiled call node returning call3886 (depth = 6)
// compiled member node returning call3886 (depth = 5)
  gc_frame_newslot(call3886);
// starting to compile block node (depth = 5)
  Object block3887 = alloc_Block(NULL, NULL, "ast", 910);
  gc_frame_newslot(block3887);
// method "_apply"
  block_savedest(block3887);
  Object closure3888 = createclosure(3, "_apply");
  setclosureframe(closure3888, stackframe);
  addtoclosure(closure3888, var_visitor);
  addtoclosure(closure3888, var_newChain);
  addtoclosure(closure3888, selfslot);
  struct UserObject *uo3888 = (struct UserObject*)block3887;
  uo3888->data[0] = (Object)closure3888;
  Method *meth_meth_ast__apply3888 = addmethod2pos(block3887, "_apply", &meth_ast__apply3888, 0);
  int argcv_meth_ast__apply3888[] = {1};
  meth_meth_ast__apply3888->type = alloc_MethodType(1, argcv_meth_ast__apply3888);
  meth_meth_ast__apply3888->definitionModule = modulename;
  meth_meth_ast__apply3888->definitionLine = 910;
// compiled block node returning block3887 (depth = 5)
  gc_frame_newslot(block3887);
// call case 5: prelude request
  params[0] = call3886;
  params[1] = block3887;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3892 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3884);
// compiled call node returning call3892 (depth = 4)
    gc_frame_newslot(call3892);
    if3817 = call3892;
  } else {
  }
// compiled if node returning if3817 (depth = 3)
  gc_frame_end(frame);
  return if3817;
}
Object meth_ast_map_40__41_ancestors3893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3895 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3894);
// compiled call node returning call3895 (depth = 5)
// compiled member node returning call3895 (depth = 4)
  *var_n = call3895;
  if (call3895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3896 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3897 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3896);
// compiled call node returning call3897 (depth = 4)
  *var_newChain = call3897;
  if (call3897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3898 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3899 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3900 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3901 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3900);
// compiled call node returning call3901 (depth = 6)
// compiled member node returning call3901 (depth = 5)
  gc_frame_newslot(call3901);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3902 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3903 = gc_frame_new();
// call case 3: self.outer request
  Object call3904 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3903);
// compiled call node returning call3904 (depth = 8)
// compiled member node returning call3904 (depth = 7)
  partcv[0] = 0;
  Object call3905 = callmethodflags(call3904, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3902);
// compiled call node returning call3905 (depth = 6)
// compiled member node returning call3905 (depth = 5)
  params[0] = call3901;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3906 = callmethodflags(call3905, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3899);
// compiled call node returning call3906 (depth = 4)
  gc_frame_newslot(call3906);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3906;
  partcv[0] = 1;
  Object call3907 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe3898);
// compiled call node returning call3907 (depth = 3)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3908 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3909 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3911 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3910);
// compiled call node returning call3911 (depth = 6)
// compiled member node returning call3911 (depth = 5)
  gc_frame_newslot(call3911);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3912 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3913 = gc_frame_new();
// call case 3: self.outer request
  Object call3914 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3913);
// compiled call node returning call3914 (depth = 8)
// compiled member node returning call3914 (depth = 7)
  partcv[0] = 0;
  Object call3915 = callmethodflags(call3914, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3912);
// compiled call node returning call3915 (depth = 6)
// compiled member node returning call3915 (depth = 5)
  params[0] = call3911;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3916 = callmethodflags(call3915, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3909);
// compiled call node returning call3916 (depth = 4)
  gc_frame_newslot(call3916);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3916;
  partcv[0] = 1;
  Object call3917 = callmethod(*var_n, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe3908);
// compiled call node returning call3917 (depth = 3)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3918 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3919 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3920 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3921 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3920);
// compiled call node returning call3921 (depth = 6)
// compiled member node returning call3921 (depth = 5)
  gc_frame_newslot(call3921);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3922 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3923 = gc_frame_new();
// call case 3: self.outer request
  Object call3924 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3923);
// compiled call node returning call3924 (depth = 8)
// compiled member node returning call3924 (depth = 7)
  partcv[0] = 0;
  Object call3925 = callmethodflags(call3924, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3922);
// compiled call node returning call3925 (depth = 6)
// compiled member node returning call3925 (depth = 5)
  params[0] = call3921;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3926 = callmethodflags(call3925, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3919);
// compiled call node returning call3926 (depth = 4)
  gc_frame_newslot(call3926);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3926;
  partcv[0] = 1;
  Object call3927 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe3918);
// compiled call node returning call3927 (depth = 3)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3928 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3929 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3930 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3931 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3930);
// compiled call node returning call3931 (depth = 6)
// compiled member node returning call3931 (depth = 5)
  gc_frame_newslot(call3931);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3932 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3933 = gc_frame_new();
// call case 3: self.outer request
  Object call3934 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3933);
// compiled call node returning call3934 (depth = 8)
// compiled member node returning call3934 (depth = 7)
  partcv[0] = 0;
  Object call3935 = callmethodflags(call3934, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3932);
// compiled call node returning call3935 (depth = 6)
// compiled member node returning call3935 (depth = 5)
  params[0] = call3931;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3936 = callmethodflags(call3935, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3929);
// compiled call node returning call3936 (depth = 4)
  gc_frame_newslot(call3936);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3936;
  partcv[0] = 1;
  Object call3937 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3928);
// compiled call node returning call3937 (depth = 3)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3938 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3939 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3940 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3941 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3940);
// compiled call node returning call3941 (depth = 6)
// compiled member node returning call3941 (depth = 5)
  gc_frame_newslot(call3941);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3942 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3943 = gc_frame_new();
// call case 3: self.outer request
  Object call3944 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3943);
// compiled call node returning call3944 (depth = 8)
// compiled member node returning call3944 (depth = 7)
  partcv[0] = 0;
  Object call3945 = callmethodflags(call3944, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3942);
// compiled call node returning call3945 (depth = 6)
// compiled member node returning call3945 (depth = 5)
  params[0] = call3941;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3946 = callmethodflags(call3945, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3939);
// compiled call node returning call3946 (depth = 4)
  gc_frame_newslot(call3946);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3946;
  partcv[0] = 1;
  Object call3947 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe3938);
// compiled call node returning call3947 (depth = 3)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3948 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3949 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3948);
// compiled call node returning call3949 (depth = 3)
  gc_frame_end(frame);
  return call3949;
}
Object meth_ast__apply3958(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3960 == NULL) {
    strlit3960 = alloc_String("  ");
    gc_root(strlit3960);
  }
// compiled string node returning strlit3960 (depth = 7)
  int op_slot_right_3959 = gc_frame_newslot(strlit3960);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3959 = gc_frame_newslot(*var_spc);
  params[0] = strlit3960;
  partcv[0] = 1;
  Object opresult3962 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3962 (depth = 6)
  *var_spc = opresult3962;
  if (opresult3962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4111(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4113 == NULL) {
    strlit4113 = alloc_String("");
    gc_root(strlit4113);
  }
// compiled string node returning strlit4113 (depth = 9)
  int op_slot_right_4112 = gc_frame_newslot(strlit4113);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4116 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4118 = alloc_Float64(4);
// compiled num node returning num4118 (depth = 12)
  int op_slot_right_4117 = gc_frame_newslot(num4118);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4117 = gc_frame_newslot(*var_depth);
  params[0] = num4118;
  partcv[0] = 1;
  Object sum4120 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4120 (depth = 11)
  gc_frame_newslot(sum4120);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4120;
  partcv[0] = 1;
  Object call4121 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4116);
// compiled call node returning call4121 (depth = 10)
  int op_slot_right_4115 = gc_frame_newslot(call4121);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4124 == NULL) {
    strlit4124 = alloc_String("");
    gc_root(strlit4124);
  }
// compiled string node returning strlit4124 (depth = 11)
  int op_slot_right_4123 = gc_frame_newslot(strlit4124);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_4126 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit4129 == NULL) {
    strlit4129 = alloc_String("""\x0a""      ");
    gc_root(strlit4129);
  }
// compiled string node returning strlit4129 (depth = 13)
  int op_slot_right_4128 = gc_frame_newslot(strlit4129);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_4131 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit4133 == NULL) {
    strlit4133 = alloc_String("");
    gc_root(strlit4133);
  }
// compiled string node returning strlit4133 (depth = 14)
  int op_slot_left_4131 = gc_frame_newslot(strlit4133);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4134 = callmethod(strlit4133, "++", 1, partcv, params);
// compiled op node returning opresult4134 (depth = 13)
  int op_slot_left_4128 = gc_frame_newslot(opresult4134);
  params[0] = strlit4129;
  partcv[0] = 1;
  Object opresult4135 = callmethod(opresult4134, "++", 1, partcv, params);
// compiled op node returning opresult4135 (depth = 12)
  int op_slot_left_4126 = gc_frame_newslot(opresult4135);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4136 = callmethod(opresult4135, "++", 1, partcv, params);
// compiled op node returning opresult4136 (depth = 11)
  int op_slot_left_4123 = gc_frame_newslot(opresult4136);
  params[0] = strlit4124;
  partcv[0] = 1;
  Object opresult4137 = callmethod(opresult4136, "++", 1, partcv, params);
// compiled op node returning opresult4137 (depth = 10)
  int op_slot_left_4115 = gc_frame_newslot(opresult4137);
  params[0] = call4121;
  partcv[0] = 1;
  Object opresult4138 = callmethod(opresult4137, "++", 1, partcv, params);
// compiled op node returning opresult4138 (depth = 9)
  int op_slot_left_4112 = gc_frame_newslot(opresult4138);
  params[0] = strlit4113;
  partcv[0] = 1;
  Object opresult4139 = callmethod(opresult4138, "++", 1, partcv, params);
// compiled op node returning opresult4139 (depth = 8)
  *var_s = opresult4139;
  if (opresult4139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4065(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4067 == NULL) {
    strlit4067 = alloc_String("");
    gc_root(strlit4067);
  }
// compiled string node returning strlit4067 (depth = 7)
  int op_slot_right_4066 = gc_frame_newslot(strlit4067);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4071 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4070);
// compiled call node returning call4071 (depth = 9)
// compiled member node returning call4071 (depth = 8)
  int op_slot_right_4069 = gc_frame_newslot(call4071);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4074 == NULL) {
    strlit4074 = alloc_String("Part: ");
    gc_root(strlit4074);
  }
// compiled string node returning strlit4074 (depth = 9)
  int op_slot_right_4073 = gc_frame_newslot(strlit4074);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4076 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4079 == NULL) {
    strlit4079 = alloc_String("""\x0a""  ");
    gc_root(strlit4079);
  }
// compiled string node returning strlit4079 (depth = 11)
  int op_slot_right_4078 = gc_frame_newslot(strlit4079);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_4081 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit4083 == NULL) {
    strlit4083 = alloc_String("");
    gc_root(strlit4083);
  }
// compiled string node returning strlit4083 (depth = 12)
  int op_slot_left_4081 = gc_frame_newslot(strlit4083);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4084 = callmethod(strlit4083, "++", 1, partcv, params);
// compiled op node returning opresult4084 (depth = 11)
  int op_slot_left_4078 = gc_frame_newslot(opresult4084);
  params[0] = strlit4079;
  partcv[0] = 1;
  Object opresult4085 = callmethod(opresult4084, "++", 1, partcv, params);
// compiled op node returning opresult4085 (depth = 10)
  int op_slot_left_4076 = gc_frame_newslot(opresult4085);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4086 = callmethod(opresult4085, "++", 1, partcv, params);
// compiled op node returning opresult4086 (depth = 9)
  int op_slot_left_4073 = gc_frame_newslot(opresult4086);
  params[0] = strlit4074;
  partcv[0] = 1;
  Object opresult4087 = callmethod(opresult4086, "++", 1, partcv, params);
// compiled op node returning opresult4087 (depth = 8)
  int op_slot_left_4069 = gc_frame_newslot(opresult4087);
  params[0] = call4071;
  partcv[0] = 1;
  Object opresult4088 = callmethod(opresult4087, "++", 1, partcv, params);
// compiled op node returning opresult4088 (depth = 7)
  int op_slot_left_4066 = gc_frame_newslot(opresult4088);
  params[0] = strlit4067;
  partcv[0] = 1;
  Object opresult4089 = callmethod(opresult4088, "++", 1, partcv, params);
// compiled op node returning opresult4089 (depth = 6)
  *var_s = opresult4089;
  if (opresult4089 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4092 == NULL) {
    strlit4092 = alloc_String("Parameters:");
    gc_root(strlit4092);
  }
// compiled string node returning strlit4092 (depth = 7)
  int op_slot_right_4091 = gc_frame_newslot(strlit4092);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4094 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4097 == NULL) {
    strlit4097 = alloc_String("""\x0a""    ");
    gc_root(strlit4097);
  }
// compiled string node returning strlit4097 (depth = 9)
  int op_slot_right_4096 = gc_frame_newslot(strlit4097);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_4099 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit4101 == NULL) {
    strlit4101 = alloc_String("");
    gc_root(strlit4101);
  }
// compiled string node returning strlit4101 (depth = 10)
  int op_slot_left_4099 = gc_frame_newslot(strlit4101);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4102 = callmethod(strlit4101, "++", 1, partcv, params);
// compiled op node returning opresult4102 (depth = 9)
  int op_slot_left_4096 = gc_frame_newslot(opresult4102);
  params[0] = strlit4097;
  partcv[0] = 1;
  Object opresult4103 = callmethod(opresult4102, "++", 1, partcv, params);
// compiled op node returning opresult4103 (depth = 8)
  int op_slot_left_4094 = gc_frame_newslot(opresult4103);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4104 = callmethod(opresult4103, "++", 1, partcv, params);
// compiled op node returning opresult4104 (depth = 7)
  int op_slot_left_4091 = gc_frame_newslot(opresult4104);
  params[0] = strlit4092;
  partcv[0] = 1;
  Object opresult4105 = callmethod(opresult4104, "++", 1, partcv, params);
// compiled op node returning opresult4105 (depth = 6)
  *var_s = opresult4105;
  if (opresult4105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4107 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4109 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4108);
// compiled call node returning call4109 (depth = 7)
// compiled member node returning call4109 (depth = 6)
  gc_frame_newslot(call4109);
// starting to compile block node (depth = 6)
  Object block4110 = alloc_Block(NULL, NULL, "ast", 942);
  gc_frame_newslot(block4110);
// method "_apply"
  block_savedest(block4110);
  Object closure4111 = createclosure(4, "_apply");
  setclosureframe(closure4111, stackframe);
  addtoclosure(closure4111, var_depth);
  addtoclosure(closure4111, var_spc);
  addtoclosure(closure4111, var_s);
  addtoclosure(closure4111, selfslot);
  struct UserObject *uo4111 = (struct UserObject*)block4110;
  uo4111->data[0] = (Object)closure4111;
  Method *meth_meth_ast__apply4111 = addmethod2pos(block4110, "_apply", &meth_ast__apply4111, 0);
  int argcv_meth_ast__apply4111[] = {1};
  meth_meth_ast__apply4111->type = alloc_MethodType(1, argcv_meth_ast__apply4111);
  meth_meth_ast__apply4111->definitionModule = modulename;
  meth_meth_ast__apply4111->definitionLine = 942;
// compiled block node returning block4110 (depth = 6)
  gc_frame_newslot(block4110);
// call case 5: prelude request
  params[0] = call4109;
  params[1] = block4110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4142 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4107);
// compiled call node returning call4142 (depth = 5)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool4145 = alloc_Boolean(0);
// compiled identifier node returning bool4145 (depth = 7)
  int op_slot_right_4144 = gc_frame_newslot(bool4145);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4147 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4148 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4147);
// compiled call node returning call4148 (depth = 8)
// compiled member node returning call4148 (depth = 7)
  int op_slot_left_4144 = gc_frame_newslot(call4148);
  params[0] = bool4145;
  partcv[0] = 1;
  Object opresult4149 = callmethod(call4148, "!=", 1, partcv, params);
// compiled op node returning opresult4149 (depth = 6)
  Object if4143 = done;
  if (istrue(opresult4149)) {
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4151 == NULL) {
    strlit4151 = alloc_String("");
    gc_root(strlit4151);
  }
// compiled string node returning strlit4151 (depth = 8)
  int op_slot_right_4150 = gc_frame_newslot(strlit4151);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4154 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4156 = alloc_Float64(3);
// compiled num node returning num4156 (depth = 11)
  int op_slot_right_4155 = gc_frame_newslot(num4156);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4155 = gc_frame_newslot(*var_depth);
  params[0] = num4156;
  partcv[0] = 1;
  Object sum4158 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4158 (depth = 10)
  gc_frame_newslot(sum4158);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4160 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4159);
// compiled call node returning call4160 (depth = 11)
// compiled member node returning call4160 (depth = 10)
  params[0] = sum4158;
  partcv[0] = 1;
  Object call4161 = callmethod(call4160, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4154);
// compiled call node returning call4161 (depth = 9)
  int op_slot_right_4153 = gc_frame_newslot(call4161);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4164 == NULL) {
    strlit4164 = alloc_String("Vararg: ");
    gc_root(strlit4164);
  }
// compiled string node returning strlit4164 (depth = 10)
  int op_slot_right_4163 = gc_frame_newslot(strlit4164);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4166 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4169 == NULL) {
    strlit4169 = alloc_String("""\x0a""    ");
    gc_root(strlit4169);
  }
// compiled string node returning strlit4169 (depth = 12)
  int op_slot_right_4168 = gc_frame_newslot(strlit4169);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4171 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4173 == NULL) {
    strlit4173 = alloc_String("");
    gc_root(strlit4173);
  }
// compiled string node returning strlit4173 (depth = 13)
  int op_slot_left_4171 = gc_frame_newslot(strlit4173);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4174 = callmethod(strlit4173, "++", 1, partcv, params);
// compiled op node returning opresult4174 (depth = 12)
  int op_slot_left_4168 = gc_frame_newslot(opresult4174);
  params[0] = strlit4169;
  partcv[0] = 1;
  Object opresult4175 = callmethod(opresult4174, "++", 1, partcv, params);
// compiled op node returning opresult4175 (depth = 11)
  int op_slot_left_4166 = gc_frame_newslot(opresult4175);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4176 = callmethod(opresult4175, "++", 1, partcv, params);
// compiled op node returning opresult4176 (depth = 10)
  int op_slot_left_4163 = gc_frame_newslot(opresult4176);
  params[0] = strlit4164;
  partcv[0] = 1;
  Object opresult4177 = callmethod(opresult4176, "++", 1, partcv, params);
// compiled op node returning opresult4177 (depth = 9)
  int op_slot_left_4153 = gc_frame_newslot(opresult4177);
  params[0] = call4161;
  partcv[0] = 1;
  Object opresult4178 = callmethod(opresult4177, "++", 1, partcv, params);
// compiled op node returning opresult4178 (depth = 8)
  int op_slot_left_4150 = gc_frame_newslot(opresult4178);
  params[0] = strlit4151;
  partcv[0] = 1;
  Object opresult4179 = callmethod(opresult4178, "++", 1, partcv, params);
// compiled op node returning opresult4179 (depth = 7)
  *var_s = opresult4179;
  if (opresult4179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4143 = done;
  } else {
  }
// compiled if node returning if4143 (depth = 5)
  gc_frame_end(frame);
  return if4143;
}
Object meth_ast__apply4213(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4215 == NULL) {
    strlit4215 = alloc_String("");
    gc_root(strlit4215);
  }
// compiled string node returning strlit4215 (depth = 8)
  int op_slot_right_4214 = gc_frame_newslot(strlit4215);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4218 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4219 = alloc_Float64(0);
// compiled num node returning num4219 (depth = 10)
  gc_frame_newslot(num4219);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num4219;
  partcv[0] = 1;
  Object call4220 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4218);
// compiled call node returning call4220 (depth = 9)
  int op_slot_right_4217 = gc_frame_newslot(call4220);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4223 == NULL) {
    strlit4223 = alloc_String("  ");
    gc_root(strlit4223);
  }
// compiled string node returning strlit4223 (depth = 10)
  int op_slot_right_4222 = gc_frame_newslot(strlit4223);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4225 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4228 == NULL) {
    strlit4228 = alloc_String("""\x0a""");
    gc_root(strlit4228);
  }
// compiled string node returning strlit4228 (depth = 12)
  int op_slot_right_4227 = gc_frame_newslot(strlit4228);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4230 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4232 == NULL) {
    strlit4232 = alloc_String("");
    gc_root(strlit4232);
  }
// compiled string node returning strlit4232 (depth = 13)
  int op_slot_left_4230 = gc_frame_newslot(strlit4232);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4233 = callmethod(strlit4232, "++", 1, partcv, params);
// compiled op node returning opresult4233 (depth = 12)
  int op_slot_left_4227 = gc_frame_newslot(opresult4233);
  params[0] = strlit4228;
  partcv[0] = 1;
  Object opresult4234 = callmethod(opresult4233, "++", 1, partcv, params);
// compiled op node returning opresult4234 (depth = 11)
  int op_slot_left_4225 = gc_frame_newslot(opresult4234);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4235 = callmethod(opresult4234, "++", 1, partcv, params);
// compiled op node returning opresult4235 (depth = 10)
  int op_slot_left_4222 = gc_frame_newslot(opresult4235);
  params[0] = strlit4223;
  partcv[0] = 1;
  Object opresult4236 = callmethod(opresult4235, "++", 1, partcv, params);
// compiled op node returning opresult4236 (depth = 9)
  int op_slot_left_4217 = gc_frame_newslot(opresult4236);
  params[0] = call4220;
  partcv[0] = 1;
  Object opresult4237 = callmethod(opresult4236, "++", 1, partcv, params);
// compiled op node returning opresult4237 (depth = 8)
  int op_slot_left_4214 = gc_frame_newslot(opresult4237);
  params[0] = strlit4215;
  partcv[0] = 1;
  Object opresult4238 = callmethod(opresult4237, "++", 1, partcv, params);
// compiled op node returning opresult4238 (depth = 7)
  *var_s = opresult4238;
  if (opresult4238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4278(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4280 == NULL) {
    strlit4280 = alloc_String("");
    gc_root(strlit4280);
  }
// compiled string node returning strlit4280 (depth = 8)
  int op_slot_right_4279 = gc_frame_newslot(strlit4280);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4283 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4285 = alloc_Float64(2);
// compiled num node returning num4285 (depth = 11)
  int op_slot_right_4284 = gc_frame_newslot(num4285);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4284 = gc_frame_newslot(*var_depth);
  params[0] = num4285;
  partcv[0] = 1;
  Object sum4287 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4287 (depth = 10)
  gc_frame_newslot(sum4287);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_an (depth = 10)
  params[0] = sum4287;
  partcv[0] = 1;
  Object call4288 = callmethod(*var_an, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4283);
// compiled call node returning call4288 (depth = 9)
  int op_slot_right_4282 = gc_frame_newslot(call4288);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4291 == NULL) {
    strlit4291 = alloc_String("  ");
    gc_root(strlit4291);
  }
// compiled string node returning strlit4291 (depth = 10)
  int op_slot_right_4290 = gc_frame_newslot(strlit4291);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4293 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4296 == NULL) {
    strlit4296 = alloc_String("""\x0a""");
    gc_root(strlit4296);
  }
// compiled string node returning strlit4296 (depth = 12)
  int op_slot_right_4295 = gc_frame_newslot(strlit4296);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4298 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4300 == NULL) {
    strlit4300 = alloc_String("");
    gc_root(strlit4300);
  }
// compiled string node returning strlit4300 (depth = 13)
  int op_slot_left_4298 = gc_frame_newslot(strlit4300);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4301 = callmethod(strlit4300, "++", 1, partcv, params);
// compiled op node returning opresult4301 (depth = 12)
  int op_slot_left_4295 = gc_frame_newslot(opresult4301);
  params[0] = strlit4296;
  partcv[0] = 1;
  Object opresult4302 = callmethod(opresult4301, "++", 1, partcv, params);
// compiled op node returning opresult4302 (depth = 11)
  int op_slot_left_4293 = gc_frame_newslot(opresult4302);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4303 = callmethod(opresult4302, "++", 1, partcv, params);
// compiled op node returning opresult4303 (depth = 10)
  int op_slot_left_4290 = gc_frame_newslot(opresult4303);
  params[0] = strlit4291;
  partcv[0] = 1;
  Object opresult4304 = callmethod(opresult4303, "++", 1, partcv, params);
// compiled op node returning opresult4304 (depth = 9)
  int op_slot_left_4282 = gc_frame_newslot(opresult4304);
  params[0] = call4288;
  partcv[0] = 1;
  Object opresult4305 = callmethod(opresult4304, "++", 1, partcv, params);
// compiled op node returning opresult4305 (depth = 8)
  int op_slot_left_4279 = gc_frame_newslot(opresult4305);
  params[0] = strlit4280;
  partcv[0] = 1;
  Object opresult4306 = callmethod(opresult4305, "++", 1, partcv, params);
// compiled op node returning opresult4306 (depth = 7)
  *var_s = opresult4306;
  if (opresult4306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4329 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4331 = alloc_Float64(2);
// compiled num node returning num4331 (depth = 9)
  int op_slot_right_4330 = gc_frame_newslot(num4331);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4330 = gc_frame_newslot(*var_depth);
  params[0] = num4331;
  partcv[0] = 1;
  Object sum4333 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4333 (depth = 8)
  gc_frame_newslot(sum4333);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4333;
  partcv[0] = 1;
  Object call4334 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4329);
// compiled call node returning call4334 (depth = 7)
  int op_slot_right_4328 = gc_frame_newslot(call4334);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4336 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4339 == NULL) {
    strlit4339 = alloc_String("""\x0a""  ");
    gc_root(strlit4339);
  }
// compiled string node returning strlit4339 (depth = 9)
  int op_slot_right_4338 = gc_frame_newslot(strlit4339);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4338 = gc_frame_newslot(*var_s);
  params[0] = strlit4339;
  partcv[0] = 1;
  Object opresult4341 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4341 (depth = 8)
  int op_slot_left_4336 = gc_frame_newslot(opresult4341);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4342 = callmethod(opresult4341, "++", 1, partcv, params);
// compiled op node returning opresult4342 (depth = 7)
  int op_slot_left_4328 = gc_frame_newslot(opresult4342);
  params[0] = call4334;
  partcv[0] = 1;
  Object opresult4343 = callmethod(opresult4342, "++", 1, partcv, params);
// compiled op node returning opresult4343 (depth = 6)
  *var_s = opresult4343;
  if (opresult4343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3950(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3951 == NULL) {
    strlit3951 = alloc_String("");
    gc_root(strlit3951);
  }
// compiled string node returning strlit3951 (depth = 4)
  *var_spc = strlit3951;
  if (strlit3951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3952 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3953 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3955 = alloc_Float64(0);
// compiled num node returning num3955 (depth = 5)
  int op_slot_left_3953 = gc_frame_newslot(num3955);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3956 = callmethod(num3955, "..", 1, partcv, params);
// compiled op node returning opresult3956 (depth = 4)
  gc_frame_newslot(opresult3956);
// starting to compile block node (depth = 4)
  Object block3957 = alloc_Block(NULL, NULL, "ast", 927);
  gc_frame_newslot(block3957);
// method "_apply"
  block_savedest(block3957);
  Object closure3958 = createclosure(2, "_apply");
  setclosureframe(closure3958, stackframe);
  addtoclosure(closure3958, var_spc);
  addtoclosure(closure3958, selfslot);
  struct UserObject *uo3958 = (struct UserObject*)block3957;
  uo3958->data[0] = (Object)closure3958;
  Method *meth_meth_ast__apply3958 = addmethod2pos(block3957, "_apply", &meth_ast__apply3958, 0);
  int argcv_meth_ast__apply3958[] = {1};
  meth_meth_ast__apply3958->type = alloc_MethodType(1, argcv_meth_ast__apply3958);
  meth_meth_ast__apply3958->definitionModule = modulename;
  meth_meth_ast__apply3958->definitionLine = 922;
// compiled block node returning block3957 (depth = 4)
  gc_frame_newslot(block3957);
// call case 5: prelude request
  params[0] = opresult3956;
  params[1] = block3957;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3965 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3952);
// compiled call node returning call3965 (depth = 3)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3967 == NULL) {
    strlit3967 = alloc_String("""\x0a""");
    gc_root(strlit3967);
  }
// compiled string node returning strlit3967 (depth = 5)
  int op_slot_right_3966 = gc_frame_newslot(strlit3967);
// starting to compile call node (depth = 5)
  int callframe3969 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3970 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3969);
// compiled call node returning call3970 (depth = 5)
  int op_slot_left_3966 = gc_frame_newslot(call3970);
  params[0] = strlit3967;
  partcv[0] = 1;
  Object opresult3971 = callmethod(call3970, "++", 1, partcv, params);
// compiled op node returning opresult3971 (depth = 4)
  *var_s = opresult3971;
  if (opresult3971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3973 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3975 = alloc_Float64(1);
// compiled num node returning num3975 (depth = 7)
  int op_slot_right_3974 = gc_frame_newslot(num3975);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3974 = gc_frame_newslot(*var_depth);
  params[0] = num3975;
  partcv[0] = 1;
  Object sum3977 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3977 (depth = 6)
  gc_frame_newslot(sum3977);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3979 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3978);
// compiled call node returning call3979 (depth = 7)
// compiled member node returning call3979 (depth = 6)
  params[0] = sum3977;
  partcv[0] = 1;
  Object call3980 = callmethod(call3979, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3973);
// compiled call node returning call3980 (depth = 5)
  int op_slot_right_3972 = gc_frame_newslot(call3980);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3983 == NULL) {
    strlit3983 = alloc_String("Name: ");
    gc_root(strlit3983);
  }
// compiled string node returning strlit3983 (depth = 6)
  int op_slot_right_3982 = gc_frame_newslot(strlit3983);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3985 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3985 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3987 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3987 (depth = 6)
  int op_slot_left_3982 = gc_frame_newslot(opresult3987);
  params[0] = strlit3983;
  partcv[0] = 1;
  Object opresult3988 = callmethod(opresult3987, "++", 1, partcv, params);
// compiled op node returning opresult3988 (depth = 5)
  int op_slot_left_3972 = gc_frame_newslot(opresult3988);
  params[0] = call3980;
  partcv[0] = 1;
  Object opresult3989 = callmethod(opresult3988, "++", 1, partcv, params);
// compiled op node returning opresult3989 (depth = 4)
  *var_s = opresult3989;
  if (opresult3989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3992 == NULL) {
    strlit3992 = alloc_String("""\x0a""");
    gc_root(strlit3992);
  }
// compiled string node returning strlit3992 (depth = 5)
  int op_slot_right_3991 = gc_frame_newslot(strlit3992);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3991 = gc_frame_newslot(*var_s);
  params[0] = strlit3992;
  partcv[0] = 1;
  Object opresult3994 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3994 (depth = 4)
  *var_s = opresult3994;
  if (opresult3994 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3999 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3998);
// compiled call node returning call3999 (depth = 6)
// compiled member node returning call3999 (depth = 5)
  int op_slot_right_3997 = gc_frame_newslot(call3999);
// starting to compile identifier node (depth = 5)
  Object bool4001 = alloc_Boolean(0);
// compiled identifier node returning bool4001 (depth = 5)
  int op_slot_left_3997 = gc_frame_newslot(bool4001);
  params[0] = call3999;
  partcv[0] = 1;
  Object opresult4002 = callmethod(bool4001, "!=", 1, partcv, params);
// compiled op node returning opresult4002 (depth = 4)
  Object if3996 = done;
  if (istrue(opresult4002)) {
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4004 == NULL) {
    strlit4004 = alloc_String("  ");
    gc_root(strlit4004);
  }
// compiled string node returning strlit4004 (depth = 6)
  int op_slot_right_4003 = gc_frame_newslot(strlit4004);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4006 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4009 == NULL) {
    strlit4009 = alloc_String("Returns:""\x0a""");
    gc_root(strlit4009);
  }
// compiled string node returning strlit4009 (depth = 8)
  int op_slot_right_4008 = gc_frame_newslot(strlit4009);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4011 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4011 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4013 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4013 (depth = 8)
  int op_slot_left_4008 = gc_frame_newslot(opresult4013);
  params[0] = strlit4009;
  partcv[0] = 1;
  Object opresult4014 = callmethod(opresult4013, "++", 1, partcv, params);
// compiled op node returning opresult4014 (depth = 7)
  int op_slot_left_4006 = gc_frame_newslot(opresult4014);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4015 = callmethod(opresult4014, "++", 1, partcv, params);
// compiled op node returning opresult4015 (depth = 6)
  int op_slot_left_4003 = gc_frame_newslot(opresult4015);
  params[0] = strlit4004;
  partcv[0] = 1;
  Object opresult4016 = callmethod(opresult4015, "++", 1, partcv, params);
// compiled op node returning opresult4016 (depth = 5)
  *var_s = opresult4016;
  if (opresult4016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4019 == NULL) {
    strlit4019 = alloc_String("""\x0a""");
    gc_root(strlit4019);
  }
// compiled string node returning strlit4019 (depth = 6)
  int op_slot_right_4018 = gc_frame_newslot(strlit4019);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4022 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4024 = alloc_Float64(2);
// compiled num node returning num4024 (depth = 9)
  int op_slot_right_4023 = gc_frame_newslot(num4024);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4023 = gc_frame_newslot(*var_depth);
  params[0] = num4024;
  partcv[0] = 1;
  Object sum4026 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4026 (depth = 8)
  gc_frame_newslot(sum4026);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4027 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4028 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4027);
// compiled call node returning call4028 (depth = 9)
// compiled member node returning call4028 (depth = 8)
  params[0] = sum4026;
  partcv[0] = 1;
  Object call4029 = callmethod(call4028, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4022);
// compiled call node returning call4029 (depth = 7)
  int op_slot_right_4021 = gc_frame_newslot(call4029);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4021 = gc_frame_newslot(*var_s);
  params[0] = call4029;
  partcv[0] = 1;
  Object opresult4031 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4031 (depth = 6)
  int op_slot_left_4018 = gc_frame_newslot(opresult4031);
  params[0] = strlit4019;
  partcv[0] = 1;
  Object opresult4032 = callmethod(opresult4031, "++", 1, partcv, params);
// compiled op node returning opresult4032 (depth = 5)
  *var_s = opresult4032;
  if (opresult4032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3996 = done;
  } else {
  }
// compiled if node returning if3996 (depth = 3)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4035 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4036 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4035);
// compiled call node returning call4036 (depth = 5)
// compiled member node returning call4036 (depth = 4)
  Object if4034 = done;
  if (istrue(call4036)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4038 == NULL) {
    strlit4038 = alloc_String("Fresh""\x0a""");
    gc_root(strlit4038);
  }
// compiled string node returning strlit4038 (depth = 6)
  int op_slot_right_4037 = gc_frame_newslot(strlit4038);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4040 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4040 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4042 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4042 (depth = 6)
  int op_slot_left_4037 = gc_frame_newslot(opresult4042);
  params[0] = strlit4038;
  partcv[0] = 1;
  Object opresult4043 = callmethod(opresult4042, "++", 1, partcv, params);
// compiled op node returning opresult4043 (depth = 5)
  *var_s = opresult4043;
  if (opresult4043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4034 = done;
  } else {
  }
// compiled if node returning if4034 (depth = 3)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4046 == NULL) {
    strlit4046 = alloc_String("Signature:");
    gc_root(strlit4046);
  }
// compiled string node returning strlit4046 (depth = 5)
  int op_slot_right_4045 = gc_frame_newslot(strlit4046);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4048 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4051 == NULL) {
    strlit4051 = alloc_String("");
    gc_root(strlit4051);
  }
// compiled string node returning strlit4051 (depth = 7)
  int op_slot_right_4050 = gc_frame_newslot(strlit4051);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_4053 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit4055 == NULL) {
    strlit4055 = alloc_String("");
    gc_root(strlit4055);
  }
// compiled string node returning strlit4055 (depth = 8)
  int op_slot_left_4053 = gc_frame_newslot(strlit4055);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4056 = callmethod(strlit4055, "++", 1, partcv, params);
// compiled op node returning opresult4056 (depth = 7)
  int op_slot_left_4050 = gc_frame_newslot(opresult4056);
  params[0] = strlit4051;
  partcv[0] = 1;
  Object opresult4057 = callmethod(opresult4056, "++", 1, partcv, params);
// compiled op node returning opresult4057 (depth = 6)
  int op_slot_left_4048 = gc_frame_newslot(opresult4057);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4058 = callmethod(opresult4057, "++", 1, partcv, params);
// compiled op node returning opresult4058 (depth = 5)
  int op_slot_left_4045 = gc_frame_newslot(opresult4058);
  params[0] = strlit4046;
  partcv[0] = 1;
  Object opresult4059 = callmethod(opresult4058, "++", 1, partcv, params);
// compiled op node returning opresult4059 (depth = 4)
  *var_s = opresult4059;
  if (opresult4059 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4061 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4062 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4063 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4062);
// compiled call node returning call4063 (depth = 5)
// compiled member node returning call4063 (depth = 4)
  gc_frame_newslot(call4063);
// starting to compile block node (depth = 4)
  Object block4064 = alloc_Block(NULL, NULL, "ast", 939);
  gc_frame_newslot(block4064);
// method "_apply"
  block_savedest(block4064);
  Object closure4065 = createclosure(4, "_apply");
  setclosureframe(closure4065, stackframe);
  addtoclosure(closure4065, var_spc);
  addtoclosure(closure4065, var_s);
  addtoclosure(closure4065, var_depth);
  addtoclosure(closure4065, selfslot);
  struct UserObject *uo4065 = (struct UserObject*)block4064;
  uo4065->data[0] = (Object)closure4065;
  Method *meth_meth_ast__apply4065 = addmethod2pos(block4064, "_apply", &meth_ast__apply4065, 0);
  int argcv_meth_ast__apply4065[] = {1};
  meth_meth_ast__apply4065->type = alloc_MethodType(1, argcv_meth_ast__apply4065);
  meth_meth_ast__apply4065->definitionModule = modulename;
  meth_meth_ast__apply4065->definitionLine = 939;
// compiled block node returning block4064 (depth = 4)
  gc_frame_newslot(block4064);
// call case 5: prelude request
  params[0] = call4063;
  params[1] = block4064;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4182 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4061);
// compiled call node returning call4182 (depth = 3)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4184 == NULL) {
    strlit4184 = alloc_String("""\x0a""");
    gc_root(strlit4184);
  }
// compiled string node returning strlit4184 (depth = 5)
  int op_slot_right_4183 = gc_frame_newslot(strlit4184);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4183 = gc_frame_newslot(*var_s);
  params[0] = strlit4184;
  partcv[0] = 1;
  Object opresult4186 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4186 (depth = 4)
  *var_s = opresult4186;
  if (opresult4186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4190 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4191 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4190);
// compiled call node returning call4191 (depth = 6)
// compiled member node returning call4191 (depth = 5)
  int op_slot_right_4189 = gc_frame_newslot(call4191);
// starting to compile identifier node (depth = 5)
  Object bool4193 = alloc_Boolean(0);
// compiled identifier node returning bool4193 (depth = 5)
  int op_slot_left_4189 = gc_frame_newslot(bool4193);
  params[0] = call4191;
  partcv[0] = 1;
  Object opresult4194 = callmethod(bool4193, "!=", 1, partcv, params);
// compiled op node returning opresult4194 (depth = 4)
  Object if4188 = done;
  if (istrue(opresult4194)) {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4196 == NULL) {
    strlit4196 = alloc_String("Generics:");
    gc_root(strlit4196);
  }
// compiled string node returning strlit4196 (depth = 6)
  int op_slot_right_4195 = gc_frame_newslot(strlit4196);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4198 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4201 == NULL) {
    strlit4201 = alloc_String("");
    gc_root(strlit4201);
  }
// compiled string node returning strlit4201 (depth = 8)
  int op_slot_right_4200 = gc_frame_newslot(strlit4201);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4203 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4205 == NULL) {
    strlit4205 = alloc_String("");
    gc_root(strlit4205);
  }
// compiled string node returning strlit4205 (depth = 9)
  int op_slot_left_4203 = gc_frame_newslot(strlit4205);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4206 = callmethod(strlit4205, "++", 1, partcv, params);
// compiled op node returning opresult4206 (depth = 8)
  int op_slot_left_4200 = gc_frame_newslot(opresult4206);
  params[0] = strlit4201;
  partcv[0] = 1;
  Object opresult4207 = callmethod(opresult4206, "++", 1, partcv, params);
// compiled op node returning opresult4207 (depth = 7)
  int op_slot_left_4198 = gc_frame_newslot(opresult4207);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4208 = callmethod(opresult4207, "++", 1, partcv, params);
// compiled op node returning opresult4208 (depth = 6)
  int op_slot_left_4195 = gc_frame_newslot(opresult4208);
  params[0] = strlit4196;
  partcv[0] = 1;
  Object opresult4209 = callmethod(opresult4208, "++", 1, partcv, params);
// compiled op node returning opresult4209 (depth = 5)
  *var_s = opresult4209;
  if (opresult4209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4211 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4212 = alloc_Block(NULL, NULL, "ast", 952);
  gc_frame_newslot(block4212);
// method "_apply"
  block_savedest(block4212);
  Object closure4213 = createclosure(3, "_apply");
  setclosureframe(closure4213, stackframe);
  addtoclosure(closure4213, var_spc);
  addtoclosure(closure4213, var_s);
  addtoclosure(closure4213, selfslot);
  struct UserObject *uo4213 = (struct UserObject*)block4212;
  uo4213->data[0] = (Object)closure4213;
  Method *meth_meth_ast__apply4213 = addmethod2pos(block4212, "_apply", &meth_ast__apply4213, 0);
  int argcv_meth_ast__apply4213[] = {1};
  meth_meth_ast__apply4213->type = alloc_MethodType(1, argcv_meth_ast__apply4213);
  meth_meth_ast__apply4213->definitionModule = modulename;
  meth_meth_ast__apply4213->definitionLine = 950;
// compiled block node returning block4212 (depth = 5)
  gc_frame_newslot(block4212);
// call case 6: other member request
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4242 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4241);
// compiled call node returning call4242 (depth = 6)
// compiled member node returning call4242 (depth = 5)
  params[0] = block4212;
  partcv[0] = 1;
  Object call4243 = callmethod(call4242, "do",
    1, partcv, params);
  gc_frame_end(callframe4211);
// compiled call node returning call4243 (depth = 4)
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4245 == NULL) {
    strlit4245 = alloc_String("""\x0a""");
    gc_root(strlit4245);
  }
// compiled string node returning strlit4245 (depth = 6)
  int op_slot_right_4244 = gc_frame_newslot(strlit4245);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4244 = gc_frame_newslot(*var_s);
  params[0] = strlit4245;
  partcv[0] = 1;
  Object opresult4247 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4247 (depth = 5)
  *var_s = opresult4247;
  if (opresult4247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4188 = done;
  } else {
  }
// compiled if node returning if4188 (depth = 3)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4251 = alloc_Float64(0);
// compiled num node returning num4251 (depth = 5)
  int op_slot_right_4250 = gc_frame_newslot(num4251);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4253 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4255 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4254);
// compiled call node returning call4255 (depth = 8)
// compiled member node returning call4255 (depth = 7)
  partcv[0] = 0;
  Object call4256 = callmethod(call4255, "size",
    1, partcv, params);
  gc_frame_end(callframe4253);
// compiled call node returning call4256 (depth = 6)
// compiled member node returning call4256 (depth = 5)
  int op_slot_left_4250 = gc_frame_newslot(call4256);
  params[0] = num4251;
  partcv[0] = 1;
  Object opresult4257 = callmethod(call4256, ">", 1, partcv, params);
// compiled op node returning opresult4257 (depth = 4)
  Object if4249 = done;
  if (istrue(opresult4257)) {
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4259 == NULL) {
    strlit4259 = alloc_String("Annotations:");
    gc_root(strlit4259);
  }
// compiled string node returning strlit4259 (depth = 6)
  int op_slot_right_4258 = gc_frame_newslot(strlit4259);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4261 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4264 == NULL) {
    strlit4264 = alloc_String("");
    gc_root(strlit4264);
  }
// compiled string node returning strlit4264 (depth = 8)
  int op_slot_right_4263 = gc_frame_newslot(strlit4264);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4266 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4268 == NULL) {
    strlit4268 = alloc_String("");
    gc_root(strlit4268);
  }
// compiled string node returning strlit4268 (depth = 9)
  int op_slot_left_4266 = gc_frame_newslot(strlit4268);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4269 = callmethod(strlit4268, "++", 1, partcv, params);
// compiled op node returning opresult4269 (depth = 8)
  int op_slot_left_4263 = gc_frame_newslot(opresult4269);
  params[0] = strlit4264;
  partcv[0] = 1;
  Object opresult4270 = callmethod(opresult4269, "++", 1, partcv, params);
// compiled op node returning opresult4270 (depth = 7)
  int op_slot_left_4261 = gc_frame_newslot(opresult4270);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4271 = callmethod(opresult4270, "++", 1, partcv, params);
// compiled op node returning opresult4271 (depth = 6)
  int op_slot_left_4258 = gc_frame_newslot(opresult4271);
  params[0] = strlit4259;
  partcv[0] = 1;
  Object opresult4272 = callmethod(opresult4271, "++", 1, partcv, params);
// compiled op node returning opresult4272 (depth = 5)
  *var_s = opresult4272;
  if (opresult4272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4274 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4276 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4275);
// compiled call node returning call4276 (depth = 6)
// compiled member node returning call4276 (depth = 5)
  gc_frame_newslot(call4276);
// starting to compile block node (depth = 5)
  Object block4277 = alloc_Block(NULL, NULL, "ast", 959);
  gc_frame_newslot(block4277);
// method "_apply"
  block_savedest(block4277);
  Object closure4278 = createclosure(4, "_apply");
  setclosureframe(closure4278, stackframe);
  addtoclosure(closure4278, var_depth);
  addtoclosure(closure4278, var_spc);
  addtoclosure(closure4278, var_s);
  addtoclosure(closure4278, selfslot);
  struct UserObject *uo4278 = (struct UserObject*)block4277;
  uo4278->data[0] = (Object)closure4278;
  Method *meth_meth_ast__apply4278 = addmethod2pos(block4277, "_apply", &meth_ast__apply4278, 0);
  int argcv_meth_ast__apply4278[] = {1};
  meth_meth_ast__apply4278->type = alloc_MethodType(1, argcv_meth_ast__apply4278);
  meth_meth_ast__apply4278->definitionModule = modulename;
  meth_meth_ast__apply4278->definitionLine = 959;
// compiled block node returning block4277 (depth = 5)
  gc_frame_newslot(block4277);
// call case 5: prelude request
  params[0] = call4276;
  params[1] = block4277;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4309 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4274);
// compiled call node returning call4309 (depth = 4)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4311 == NULL) {
    strlit4311 = alloc_String("""\x0a""");
    gc_root(strlit4311);
  }
// compiled string node returning strlit4311 (depth = 6)
  int op_slot_right_4310 = gc_frame_newslot(strlit4311);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4310 = gc_frame_newslot(*var_s);
  params[0] = strlit4311;
  partcv[0] = 1;
  Object opresult4313 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4313 (depth = 5)
  *var_s = opresult4313;
  if (opresult4313 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4249 = done;
  } else {
  }
// compiled if node returning if4249 (depth = 3)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4316 == NULL) {
    strlit4316 = alloc_String("Body:");
    gc_root(strlit4316);
  }
// compiled string node returning strlit4316 (depth = 5)
  int op_slot_right_4315 = gc_frame_newslot(strlit4316);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4318 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4318 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4320 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4320 (depth = 5)
  int op_slot_left_4315 = gc_frame_newslot(opresult4320);
  params[0] = strlit4316;
  partcv[0] = 1;
  Object opresult4321 = callmethod(opresult4320, "++", 1, partcv, params);
// compiled op node returning opresult4321 (depth = 4)
  *var_s = opresult4321;
  if (opresult4321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4323 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4325 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 5)
// compiled member node returning call4325 (depth = 4)
  gc_frame_newslot(call4325);
// starting to compile block node (depth = 4)
  Object block4326 = alloc_Block(NULL, NULL, "ast", 965);
  gc_frame_newslot(block4326);
// method "_apply"
  block_savedest(block4326);
  Object closure4327 = createclosure(4, "_apply");
  setclosureframe(closure4327, stackframe);
  addtoclosure(closure4327, var_depth);
  addtoclosure(closure4327, var_spc);
  addtoclosure(closure4327, var_s);
  addtoclosure(closure4327, selfslot);
  struct UserObject *uo4327 = (struct UserObject*)block4326;
  uo4327->data[0] = (Object)closure4327;
  Method *meth_meth_ast__apply4327 = addmethod2pos(block4326, "_apply", &meth_ast__apply4327, 0);
  int argcv_meth_ast__apply4327[] = {1};
  meth_meth_ast__apply4327->type = alloc_MethodType(1, argcv_meth_ast__apply4327);
  meth_meth_ast__apply4327->definitionModule = modulename;
  meth_meth_ast__apply4327->definitionLine = 965;
// compiled block node returning block4326 (depth = 4)
  gc_frame_newslot(block4326);
// call case 5: prelude request
  params[0] = call4325;
  params[1] = block4326;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4346 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4323);
// compiled call node returning call4346 (depth = 3)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4350 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4349);
// compiled call node returning call4350 (depth = 6)
// compiled member node returning call4350 (depth = 5)
  int op_slot_right_4348 = gc_frame_newslot(call4350);
// starting to compile identifier node (depth = 5)
  Object bool4352 = alloc_Boolean(0);
// compiled identifier node returning bool4352 (depth = 5)
  int op_slot_left_4348 = gc_frame_newslot(bool4352);
  params[0] = call4350;
  partcv[0] = 1;
  Object opresult4353 = callmethod(bool4352, "!=", 1, partcv, params);
// compiled op node returning opresult4353 (depth = 4)
  Object if4347 = done;
  if (istrue(opresult4353)) {
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4355 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4357 = alloc_Float64(2);
// compiled num node returning num4357 (depth = 8)
  int op_slot_right_4356 = gc_frame_newslot(num4357);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4356 = gc_frame_newslot(*var_depth);
  params[0] = num4357;
  partcv[0] = 1;
  Object sum4359 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4359 (depth = 7)
  gc_frame_newslot(sum4359);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4361 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4360);
// compiled call node returning call4361 (depth = 8)
// compiled member node returning call4361 (depth = 7)
  params[0] = sum4359;
  partcv[0] = 1;
  Object call4362 = callmethod(call4361, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4355);
// compiled call node returning call4362 (depth = 6)
  int op_slot_right_4354 = gc_frame_newslot(call4362);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4354 = gc_frame_newslot(*var_s);
  params[0] = call4362;
  partcv[0] = 1;
  Object opresult4364 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4364 (depth = 5)
  *var_s = opresult4364;
  if (opresult4364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4347 = done;
  } else {
  }
// compiled if node returning if4347 (depth = 3)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4378(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4380 == NULL) {
    strlit4380 = alloc_String("    ");
    gc_root(strlit4380);
  }
// compiled string node returning strlit4380 (depth = 7)
  int op_slot_right_4379 = gc_frame_newslot(strlit4380);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4379 = gc_frame_newslot(*var_spc);
  params[0] = strlit4380;
  partcv[0] = 1;
  Object opresult4382 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4382 (depth = 6)
  *var_spc = opresult4382;
  if (opresult4382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4402(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4405 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4404);
// compiled call node returning call4405 (depth = 10)
// compiled member node returning call4405 (depth = 9)
  int op_slot_right_4403 = gc_frame_newslot(call4405);
// starting to compile identifier node (depth = 9)
  Object bool4407 = alloc_Boolean(0);
// compiled identifier node returning bool4407 (depth = 9)
  int op_slot_left_4403 = gc_frame_newslot(bool4407);
  params[0] = call4405;
  partcv[0] = 1;
  Object opresult4408 = callmethod(bool4407, "!=", 1, partcv, params);
// compiled op node returning opresult4408 (depth = 8)
  gc_frame_end(frame);
  return opresult4408;
}
Object meth_ast__apply4454(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 9)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4456 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4455);
// compiled call node returning call4456 (depth = 11)
// compiled member node returning call4456 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4457 = callmethod(call4456, "[]", 1, partcv, params);
// compiled index node returning idxres4457 (depth = 9)
  *var_p = idxres4457;
  if (idxres4457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4459 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4461 = alloc_Float64(1);
// compiled num node returning num4461 (depth = 12)
  int op_slot_right_4460 = gc_frame_newslot(num4461);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4460 = gc_frame_newslot(*var_depth);
  params[0] = num4461;
  partcv[0] = 1;
  Object sum4463 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4463 (depth = 11)
  gc_frame_newslot(sum4463);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4463;
  partcv[0] = 1;
  Object call4464 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4459);
// compiled call node returning call4464 (depth = 10)
  int op_slot_right_4458 = gc_frame_newslot(call4464);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4458 = gc_frame_newslot(*var_s);
  params[0] = call4464;
  partcv[0] = 1;
  Object opresult4466 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4466 (depth = 9)
  *var_s = opresult4466;
  if (opresult4466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4471 = alloc_Boolean(0);
// compiled identifier node returning bool4471 (depth = 11)
  int op_slot_right_4470 = gc_frame_newslot(bool4471);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4474 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4473);
// compiled call node returning call4474 (depth = 12)
// compiled member node returning call4474 (depth = 11)
  int op_slot_left_4470 = gc_frame_newslot(call4474);
  params[0] = bool4471;
  partcv[0] = 1;
  Object opresult4475 = callmethod(call4474, "!=", 1, partcv, params);
// compiled op node returning opresult4475 (depth = 10)
  int op_slot_right_4469 = gc_frame_newslot(opresult4475);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4478 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call4480 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4479);
// compiled call node returning call4480 (depth = 14)
// compiled member node returning call4480 (depth = 13)
  partcv[0] = 0;
  Object call4481 = callmethod(call4480, "size",
    1, partcv, params);
  gc_frame_end(callframe4478);
// compiled call node returning call4481 (depth = 12)
// compiled member node returning call4481 (depth = 11)
  int op_slot_right_4477 = gc_frame_newslot(call4481);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pnr (depth = 11)
  int op_slot_left_4477 = gc_frame_newslot(*var_pnr);
  params[0] = call4481;
  partcv[0] = 1;
  Object opresult4483 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult4483 (depth = 10)
  int op_slot_left_4469 = gc_frame_newslot(opresult4483);
  params[0] = opresult4475;
  partcv[0] = 1;
  Object opresult4484 = callmethod(opresult4483, "||", 1, partcv, params);
// compiled op node returning opresult4484 (depth = 9)
  Object if4468 = done;
  if (istrue(opresult4484)) {
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4486 == NULL) {
    strlit4486 = alloc_String(", ");
    gc_root(strlit4486);
  }
// compiled string node returning strlit4486 (depth = 11)
  int op_slot_right_4485 = gc_frame_newslot(strlit4486);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4485 = gc_frame_newslot(*var_s);
  params[0] = strlit4486;
  partcv[0] = 1;
  Object opresult4488 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4488 (depth = 10)
  *var_s = opresult4488;
  if (opresult4488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4468 = done;
  } else {
  }
// compiled if node returning if4468 (depth = 8)
  gc_frame_end(frame);
  return if4468;
}
Object meth_ast__apply4392(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4395 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4394);
// compiled call node returning call4395 (depth = 8)
// compiled member node returning call4395 (depth = 7)
  int op_slot_right_4393 = gc_frame_newslot(call4395);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4393 = gc_frame_newslot(*var_s);
  params[0] = call4395;
  partcv[0] = 1;
  Object opresult4397 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4397 (depth = 6)
  *var_s = opresult4397;
  if (opresult4397 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4400 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4401 = alloc_Block(NULL, NULL, "ast", 982);
  gc_frame_newslot(block4401);
// method "_apply"
  block_savedest(block4401);
  Object closure4402 = createclosure(1, "_apply");
  setclosureframe(closure4402, stackframe);
  addtoclosure(closure4402, selfslot);
  struct UserObject *uo4402 = (struct UserObject*)block4401;
  uo4402->data[0] = (Object)closure4402;
  Method *meth_meth_ast__apply4402 = addmethod2pos(block4401, "_apply", &meth_ast__apply4402, 0);
  int argcv_meth_ast__apply4402[] = {0};
  meth_meth_ast__apply4402->type = alloc_MethodType(1, argcv_meth_ast__apply4402);
  meth_meth_ast__apply4402->definitionModule = modulename;
  meth_meth_ast__apply4402->definitionLine = 981;
// compiled block node returning block4401 (depth = 7)
  gc_frame_newslot(block4401);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  params[0] = block4401;
  partcv[0] = 1;
  Object call4410 = callmethod(*var_firstPart, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe4400);
// compiled call node returning call4410 (depth = 6)
  Object if4399 = done;
  if (istrue(call4410)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4412 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4414 = alloc_Float64(1);
// compiled num node returning num4414 (depth = 10)
  int op_slot_right_4413 = gc_frame_newslot(num4414);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4413 = gc_frame_newslot(*var_depth);
  params[0] = num4414;
  partcv[0] = 1;
  Object sum4416 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4416 (depth = 9)
  gc_frame_newslot(sum4416);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4417 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4418 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4417);
// compiled call node returning call4418 (depth = 10)
// compiled member node returning call4418 (depth = 9)
  params[0] = sum4416;
  partcv[0] = 1;
  Object call4419 = callmethod(call4418, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4412);
// compiled call node returning call4419 (depth = 8)
  int op_slot_right_4411 = gc_frame_newslot(call4419);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4411 = gc_frame_newslot(*var_s);
  params[0] = call4419;
  partcv[0] = 1;
  Object opresult4421 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4421 (depth = 7)
  *var_s = opresult4421;
  if (opresult4421 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4399 = done;
  } else {
  }
// compiled if node returning if4399 (depth = 5)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4423 = alloc_Boolean(0);
// compiled identifier node returning bool4423 (depth = 6)
  *var_firstPart = bool4423;
  if (bool4423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4428 = alloc_Boolean(0);
// compiled identifier node returning bool4428 (depth = 8)
  int op_slot_right_4427 = gc_frame_newslot(bool4428);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4431 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4430);
// compiled call node returning call4431 (depth = 9)
// compiled member node returning call4431 (depth = 8)
  int op_slot_left_4427 = gc_frame_newslot(call4431);
  params[0] = bool4428;
  partcv[0] = 1;
  Object opresult4432 = callmethod(call4431, "!=", 1, partcv, params);
// compiled op node returning opresult4432 (depth = 7)
  int op_slot_right_4426 = gc_frame_newslot(opresult4432);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4435 = alloc_Float64(0);
// compiled num node returning num4435 (depth = 8)
  int op_slot_right_4434 = gc_frame_newslot(num4435);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4437 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4439 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4438);
// compiled call node returning call4439 (depth = 11)
// compiled member node returning call4439 (depth = 10)
  partcv[0] = 0;
  Object call4440 = callmethod(call4439, "size",
    1, partcv, params);
  gc_frame_end(callframe4437);
// compiled call node returning call4440 (depth = 9)
// compiled member node returning call4440 (depth = 8)
  int op_slot_left_4434 = gc_frame_newslot(call4440);
  params[0] = num4435;
  partcv[0] = 1;
  Object opresult4441 = callmethod(call4440, ">", 1, partcv, params);
// compiled op node returning opresult4441 (depth = 7)
  int op_slot_left_4426 = gc_frame_newslot(opresult4441);
  params[0] = opresult4432;
  partcv[0] = 1;
  Object opresult4442 = callmethod(opresult4441, "||", 1, partcv, params);
// compiled op node returning opresult4442 (depth = 6)
  Object if4425 = done;
  if (istrue(opresult4442)) {
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4444 == NULL) {
    strlit4444 = alloc_String("(");
    gc_root(strlit4444);
  }
// compiled string node returning strlit4444 (depth = 8)
  int op_slot_right_4443 = gc_frame_newslot(strlit4444);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4443 = gc_frame_newslot(*var_s);
  params[0] = strlit4444;
  partcv[0] = 1;
  Object opresult4446 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4446 (depth = 7)
  *var_s = opresult4446;
  if (opresult4446 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4448 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4449 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4451 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4450);
// compiled call node returning call4451 (depth = 10)
// compiled member node returning call4451 (depth = 9)
  partcv[0] = 0;
  Object call4452 = callmethod(call4451, "indices",
    1, partcv, params);
  gc_frame_end(callframe4449);
// compiled call node returning call4452 (depth = 8)
// compiled member node returning call4452 (depth = 7)
  gc_frame_newslot(call4452);
// starting to compile block node (depth = 7)
  Object block4453 = alloc_Block(NULL, NULL, "ast", 988);
  gc_frame_newslot(block4453);
// method "_apply"
  block_savedest(block4453);
  Object closure4454 = createclosure(4, "_apply");
  setclosureframe(closure4454, stackframe);
  addtoclosure(closure4454, var_part);
  addtoclosure(closure4454, var_depth);
  addtoclosure(closure4454, var_s);
  addtoclosure(closure4454, selfslot);
  struct UserObject *uo4454 = (struct UserObject*)block4453;
  uo4454->data[0] = (Object)closure4454;
  Method *meth_meth_ast__apply4454 = addmethod2pos(block4453, "_apply", &meth_ast__apply4454, 0);
  int argcv_meth_ast__apply4454[] = {1};
  meth_meth_ast__apply4454->type = alloc_MethodType(1, argcv_meth_ast__apply4454);
  meth_meth_ast__apply4454->definitionModule = modulename;
  meth_meth_ast__apply4454->definitionLine = 988;
// compiled block node returning block4453 (depth = 7)
  gc_frame_newslot(block4453);
// call case 5: prelude request
  params[0] = call4452;
  params[1] = block4453;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4491 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4448);
// compiled call node returning call4491 (depth = 6)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4494 = alloc_Boolean(0);
// compiled identifier node returning bool4494 (depth = 8)
  int op_slot_right_4493 = gc_frame_newslot(bool4494);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4497 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4496);
// compiled call node returning call4497 (depth = 9)
// compiled member node returning call4497 (depth = 8)
  int op_slot_left_4493 = gc_frame_newslot(call4497);
  params[0] = bool4494;
  partcv[0] = 1;
  Object opresult4498 = callmethod(call4497, "!=", 1, partcv, params);
// compiled op node returning opresult4498 (depth = 7)
  Object if4492 = done;
  if (istrue(opresult4498)) {
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4500 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4502 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4501);
// compiled call node returning call4502 (depth = 12)
// compiled member node returning call4502 (depth = 11)
  partcv[0] = 0;
  Object call4503 = callmethod(call4502, "value",
    1, partcv, params);
  gc_frame_end(callframe4500);
// compiled call node returning call4503 (depth = 10)
// compiled member node returning call4503 (depth = 9)
  int op_slot_right_4499 = gc_frame_newslot(call4503);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4506 == NULL) {
    strlit4506 = alloc_String("*");
    gc_root(strlit4506);
  }
// compiled string node returning strlit4506 (depth = 10)
  int op_slot_right_4505 = gc_frame_newslot(strlit4506);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4505 = gc_frame_newslot(*var_s);
  params[0] = strlit4506;
  partcv[0] = 1;
  Object opresult4508 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4508 (depth = 9)
  int op_slot_left_4499 = gc_frame_newslot(opresult4508);
  params[0] = call4503;
  partcv[0] = 1;
  Object opresult4509 = callmethod(opresult4508, "++", 1, partcv, params);
// compiled op node returning opresult4509 (depth = 8)
  *var_s = opresult4509;
  if (opresult4509 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if4492 = done;
  } else {
  }
// compiled if node returning if4492 (depth = 6)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4512 == NULL) {
    strlit4512 = alloc_String(")");
    gc_root(strlit4512);
  }
// compiled string node returning strlit4512 (depth = 8)
  int op_slot_right_4511 = gc_frame_newslot(strlit4512);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4511 = gc_frame_newslot(*var_s);
  params[0] = strlit4512;
  partcv[0] = 1;
  Object opresult4514 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4514 (depth = 7)
  *var_s = opresult4514;
  if (opresult4514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4425 = done;
  } else {
  }
// compiled if node returning if4425 (depth = 5)
  gc_frame_end(frame);
  return if4425;
}
Object meth_ast__apply4559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4561 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4562 = alloc_Float64(0);
// compiled num node returning num4562 (depth = 10)
  gc_frame_newslot(num4562);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num4562;
  partcv[0] = 1;
  Object call4563 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4561);
// compiled call node returning call4563 (depth = 9)
  int op_slot_right_4560 = gc_frame_newslot(call4563);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4567 == NULL) {
    strlit4567 = alloc_String("");
    gc_root(strlit4567);
  }
// compiled string node returning strlit4567 (depth = 11)
  int op_slot_right_4566 = gc_frame_newslot(strlit4567);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4566 = gc_frame_newslot(*var_a);
  params[0] = strlit4567;
  partcv[0] = 1;
  Object opresult4569 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult4569 (depth = 10)
  Object if4565 = done;
struct StackFrameObject *iftmpstackframe4565 = stackframe;
  if (istrue(opresult4569)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4565);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4571 == NULL) {
    strlit4571 = alloc_String(", ");
    gc_root(strlit4571);
  }
// compiled string node returning strlit4571 (depth = 11)
  int op_slot_right_4570 = gc_frame_newslot(strlit4571);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4570 = gc_frame_newslot(*var_a);
  params[0] = strlit4571;
  partcv[0] = 1;
  Object opresult4573 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult4573 (depth = 10)
    gc_frame_newslot(opresult4573);
    if4565 = opresult4573;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4565);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit4574 == NULL) {
    strlit4574 = alloc_String("");
    gc_root(strlit4574);
  }
// compiled string node returning strlit4574 (depth = 10)
    gc_frame_newslot(strlit4574);
    if4565 = strlit4574;
  }
stackframe = iftmpstackframe4565;
// compiled if node returning if4565 (depth = 9)
  int op_slot_left_4560 = gc_frame_newslot(if4565);
  params[0] = call4563;
  partcv[0] = 1;
  Object opresult4575 = callmethod(if4565, "++", 1, partcv, params);
// compiled op node returning opresult4575 (depth = 8)
  gc_frame_end(frame);
  return opresult4575;
}
Object meth_ast__apply4612(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4614 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4616 = alloc_Float64(1);
// compiled num node returning num4616 (depth = 9)
  int op_slot_right_4615 = gc_frame_newslot(num4616);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4615 = gc_frame_newslot(*var_depth);
  params[0] = num4616;
  partcv[0] = 1;
  Object sum4618 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4618 (depth = 8)
  gc_frame_newslot(sum4618);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4618;
  partcv[0] = 1;
  Object call4619 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4614);
// compiled call node returning call4619 (depth = 7)
  int op_slot_right_4613 = gc_frame_newslot(call4619);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4622 == NULL) {
    strlit4622 = alloc_String("    ");
    gc_root(strlit4622);
  }
// compiled string node returning strlit4622 (depth = 8)
  int op_slot_right_4621 = gc_frame_newslot(strlit4622);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4624 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4627 == NULL) {
    strlit4627 = alloc_String("""\x0a""");
    gc_root(strlit4627);
  }
// compiled string node returning strlit4627 (depth = 10)
  int op_slot_right_4626 = gc_frame_newslot(strlit4627);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4626 = gc_frame_newslot(*var_s);
  params[0] = strlit4627;
  partcv[0] = 1;
  Object opresult4629 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4629 (depth = 9)
  int op_slot_left_4624 = gc_frame_newslot(opresult4629);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4630 = callmethod(opresult4629, "++", 1, partcv, params);
// compiled op node returning opresult4630 (depth = 8)
  int op_slot_left_4621 = gc_frame_newslot(opresult4630);
  params[0] = strlit4622;
  partcv[0] = 1;
  Object opresult4631 = callmethod(opresult4630, "++", 1, partcv, params);
// compiled op node returning opresult4631 (depth = 7)
  int op_slot_left_4613 = gc_frame_newslot(opresult4631);
  params[0] = call4619;
  partcv[0] = 1;
  Object opresult4632 = callmethod(opresult4631, "++", 1, partcv, params);
// compiled op node returning opresult4632 (depth = 6)
  *var_s = opresult4632;
  if (opresult4632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace4366(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4367 == NULL) {
    strlit4367 = alloc_String("");
    gc_root(strlit4367);
  }
// compiled string node returning strlit4367 (depth = 4)
  *var_spc = strlit4367;
  if (strlit4367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4368 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4371 = alloc_Float64(1);
// compiled num node returning num4371 (depth = 6)
  int op_slot_right_4370 = gc_frame_newslot(num4371);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_4370 = gc_frame_newslot(*var_depth);
  params[0] = num4371;
  partcv[0] = 1;
  Object diff4373 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff4373 (depth = 5)
  int op_slot_right_4369 = gc_frame_newslot(diff4373);
// starting to compile num node (depth = 5)
  Object num4375 = alloc_Float64(0);
// compiled num node returning num4375 (depth = 5)
  int op_slot_left_4369 = gc_frame_newslot(num4375);
  params[0] = diff4373;
  partcv[0] = 1;
  Object opresult4376 = callmethod(num4375, "..", 1, partcv, params);
// compiled op node returning opresult4376 (depth = 4)
  gc_frame_newslot(opresult4376);
// starting to compile block node (depth = 4)
  Object block4377 = alloc_Block(NULL, NULL, "ast", 975);
  gc_frame_newslot(block4377);
// method "_apply"
  block_savedest(block4377);
  Object closure4378 = createclosure(2, "_apply");
  setclosureframe(closure4378, stackframe);
  addtoclosure(closure4378, var_spc);
  addtoclosure(closure4378, selfslot);
  struct UserObject *uo4378 = (struct UserObject*)block4377;
  uo4378->data[0] = (Object)closure4378;
  Method *meth_meth_ast__apply4378 = addmethod2pos(block4377, "_apply", &meth_ast__apply4378, 0);
  int argcv_meth_ast__apply4378[] = {1};
  meth_meth_ast__apply4378->type = alloc_MethodType(1, argcv_meth_ast__apply4378);
  meth_meth_ast__apply4378->definitionModule = modulename;
  meth_meth_ast__apply4378->definitionLine = 969;
// compiled block node returning block4377 (depth = 4)
  gc_frame_newslot(block4377);
// call case 5: prelude request
  params[0] = opresult4376;
  params[1] = block4377;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4385 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4368);
// compiled call node returning call4385 (depth = 3)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4386 == NULL) {
    strlit4386 = alloc_String("method ");
    gc_root(strlit4386);
  }
// compiled string node returning strlit4386 (depth = 4)
  *var_s = strlit4386;
  if (strlit4386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4387 = alloc_Boolean(1);
// compiled identifier node returning bool4387 (depth = 4)
  *var_firstPart = bool4387;
  if (bool4387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4388 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4390 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4389);
// compiled call node returning call4390 (depth = 5)
// compiled member node returning call4390 (depth = 4)
  gc_frame_newslot(call4390);
// starting to compile block node (depth = 4)
  Object block4391 = alloc_Block(NULL, NULL, "ast", 980);
  gc_frame_newslot(block4391);
// method "_apply"
  block_savedest(block4391);
  Object closure4392 = createclosure(4, "_apply");
  setclosureframe(closure4392, stackframe);
  addtoclosure(closure4392, var_s);
  addtoclosure(closure4392, var_firstPart);
  addtoclosure(closure4392, var_depth);
  addtoclosure(closure4392, selfslot);
  struct UserObject *uo4392 = (struct UserObject*)block4391;
  uo4392->data[0] = (Object)closure4392;
  Method *meth_meth_ast__apply4392 = addmethod2pos(block4391, "_apply", &meth_ast__apply4392, 0);
  int argcv_meth_ast__apply4392[] = {1};
  meth_meth_ast__apply4392->type = alloc_MethodType(1, argcv_meth_ast__apply4392);
  meth_meth_ast__apply4392->definitionModule = modulename;
  meth_meth_ast__apply4392->definitionLine = 980;
// compiled block node returning block4391 (depth = 4)
  gc_frame_newslot(block4391);
// call case 5: prelude request
  params[0] = call4390;
  params[1] = block4391;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4517 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4388);
// compiled call node returning call4517 (depth = 3)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4520 = alloc_Boolean(0);
// compiled identifier node returning bool4520 (depth = 5)
  int op_slot_right_4519 = gc_frame_newslot(bool4520);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4523 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4522);
// compiled call node returning call4523 (depth = 6)
// compiled member node returning call4523 (depth = 5)
  int op_slot_left_4519 = gc_frame_newslot(call4523);
  params[0] = bool4520;
  partcv[0] = 1;
  Object opresult4524 = callmethod(call4523, "!=", 1, partcv, params);
// compiled op node returning opresult4524 (depth = 4)
  Object if4518 = done;
  if (istrue(opresult4524)) {
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4527 == NULL) {
    strlit4527 = alloc_String("");
    gc_root(strlit4527);
  }
// compiled string node returning strlit4527 (depth = 7)
  int op_slot_right_4526 = gc_frame_newslot(strlit4527);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4530 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4531 = alloc_Float64(0);
// compiled num node returning num4531 (depth = 9)
  gc_frame_newslot(num4531);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4532 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4533 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4532);
// compiled call node returning call4533 (depth = 10)
// compiled member node returning call4533 (depth = 9)
  params[0] = num4531;
  partcv[0] = 1;
  Object call4534 = callmethod(call4533, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4530);
// compiled call node returning call4534 (depth = 8)
  int op_slot_right_4529 = gc_frame_newslot(call4534);
// starting to compile string node (depth = 8)
  if (strlit4536 == NULL) {
    strlit4536 = alloc_String(" -> ");
    gc_root(strlit4536);
  }
// compiled string node returning strlit4536 (depth = 8)
  int op_slot_left_4529 = gc_frame_newslot(strlit4536);
  params[0] = call4534;
  partcv[0] = 1;
  Object opresult4537 = callmethod(strlit4536, "++", 1, partcv, params);
// compiled op node returning opresult4537 (depth = 7)
  int op_slot_left_4526 = gc_frame_newslot(opresult4537);
  params[0] = strlit4527;
  partcv[0] = 1;
  Object opresult4538 = callmethod(opresult4537, "++", 1, partcv, params);
// compiled op node returning opresult4538 (depth = 6)
  int op_slot_right_4525 = gc_frame_newslot(opresult4538);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4525 = gc_frame_newslot(*var_s);
  params[0] = opresult4538;
  partcv[0] = 1;
  Object opresult4540 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4540 (depth = 5)
  *var_s = opresult4540;
  if (opresult4540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4518 = done;
  } else {
  }
// compiled if node returning if4518 (depth = 3)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4544 = alloc_Float64(0);
// compiled num node returning num4544 (depth = 5)
  int op_slot_right_4543 = gc_frame_newslot(num4544);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4546 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4548 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 8)
// compiled member node returning call4548 (depth = 7)
  partcv[0] = 0;
  Object call4549 = callmethod(call4548, "size",
    1, partcv, params);
  gc_frame_end(callframe4546);
// compiled call node returning call4549 (depth = 6)
// compiled member node returning call4549 (depth = 5)
  int op_slot_left_4543 = gc_frame_newslot(call4549);
  params[0] = num4544;
  partcv[0] = 1;
  Object opresult4550 = callmethod(call4549, ">", 1, partcv, params);
// compiled op node returning opresult4550 (depth = 4)
  Object if4542 = done;
  if (istrue(opresult4550)) {
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4552 == NULL) {
    strlit4552 = alloc_String(" is ");
    gc_root(strlit4552);
  }
// compiled string node returning strlit4552 (depth = 6)
  int op_slot_right_4551 = gc_frame_newslot(strlit4552);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4551 = gc_frame_newslot(*var_s);
  params[0] = strlit4552;
  partcv[0] = 1;
  Object opresult4554 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4554 (depth = 5)
  *var_s = opresult4554;
  if (opresult4554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4557 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4558 = alloc_Block(NULL, NULL, "ast", 1006);
  gc_frame_newslot(block4558);
// method "_apply"
  block_savedest(block4558);
  Object closure4559 = createclosure(1, "_apply");
  setclosureframe(closure4559, stackframe);
  addtoclosure(closure4559, selfslot);
  struct UserObject *uo4559 = (struct UserObject*)block4558;
  uo4559->data[0] = (Object)closure4559;
  Method *meth_meth_ast__apply4559 = addmethod2pos(block4558, "_apply", &meth_ast__apply4559, 0);
  int argcv_meth_ast__apply4559[] = {2};
  meth_meth_ast__apply4559->type = alloc_MethodType(1, argcv_meth_ast__apply4559);
  meth_meth_ast__apply4559->definitionModule = modulename;
  meth_meth_ast__apply4559->definitionLine = 1004;
// compiled block node returning block4558 (depth = 7)
  gc_frame_newslot(block4558);
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4577 == NULL) {
    strlit4577 = alloc_String("");
    gc_root(strlit4577);
  }
// compiled string node returning strlit4577 (depth = 7)
  gc_frame_newslot(strlit4577);
// call case 6: other member request
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4578 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4579 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4578);
// compiled call node returning call4579 (depth = 8)
// compiled member node returning call4579 (depth = 7)
  params[0] = block4558;
  params[1] = strlit4577;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4580 = callmethod(call4579, "fold()startingWith",
    2, partcv, params);
  gc_frame_end(callframe4557);
// compiled call node returning call4580 (depth = 6)
  int op_slot_right_4556 = gc_frame_newslot(call4580);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4556 = gc_frame_newslot(*var_s);
  params[0] = call4580;
  partcv[0] = 1;
  Object opresult4582 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4582 (depth = 5)
  *var_s = opresult4582;
  if (opresult4582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4542 = done;
  } else {
  }
// compiled if node returning if4542 (depth = 3)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4585 == NULL) {
    strlit4585 = alloc_String(" {");
    gc_root(strlit4585);
  }
// compiled string node returning strlit4585 (depth = 5)
  int op_slot_right_4584 = gc_frame_newslot(strlit4585);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4584 = gc_frame_newslot(*var_s);
  params[0] = strlit4585;
  partcv[0] = 1;
  Object opresult4587 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4587 (depth = 4)
  *var_s = opresult4587;
  if (opresult4587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4591 = alloc_Boolean(0);
// compiled identifier node returning bool4591 (depth = 5)
  int op_slot_right_4590 = gc_frame_newslot(bool4591);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4593 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4594 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4593);
// compiled call node returning call4594 (depth = 6)
// compiled member node returning call4594 (depth = 5)
  int op_slot_left_4590 = gc_frame_newslot(call4594);
  params[0] = bool4591;
  partcv[0] = 1;
  Object opresult4595 = callmethod(call4594, "!=", 1, partcv, params);
// compiled op node returning opresult4595 (depth = 4)
  Object if4589 = done;
  if (istrue(opresult4595)) {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4597 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4599 = alloc_Float64(1);
// compiled num node returning num4599 (depth = 8)
  int op_slot_right_4598 = gc_frame_newslot(num4599);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4598 = gc_frame_newslot(*var_depth);
  params[0] = num4599;
  partcv[0] = 1;
  Object sum4601 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4601 (depth = 7)
  gc_frame_newslot(sum4601);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4602 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4603 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4602);
// compiled call node returning call4603 (depth = 8)
// compiled member node returning call4603 (depth = 7)
  params[0] = sum4601;
  partcv[0] = 1;
  Object call4604 = callmethod(call4603, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4597);
// compiled call node returning call4604 (depth = 6)
  int op_slot_right_4596 = gc_frame_newslot(call4604);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4596 = gc_frame_newslot(*var_s);
  params[0] = call4604;
  partcv[0] = 1;
  Object opresult4606 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4606 (depth = 5)
  *var_s = opresult4606;
  if (opresult4606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4589 = done;
  } else {
  }
// compiled if node returning if4589 (depth = 3)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4608 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4609 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4610 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4609);
// compiled call node returning call4610 (depth = 5)
// compiled member node returning call4610 (depth = 4)
  gc_frame_newslot(call4610);
// starting to compile block node (depth = 4)
  Object block4611 = alloc_Block(NULL, NULL, "ast", 1014);
  gc_frame_newslot(block4611);
// method "_apply"
  block_savedest(block4611);
  Object closure4612 = createclosure(4, "_apply");
  setclosureframe(closure4612, stackframe);
  addtoclosure(closure4612, var_depth);
  addtoclosure(closure4612, var_spc);
  addtoclosure(closure4612, var_s);
  addtoclosure(closure4612, selfslot);
  struct UserObject *uo4612 = (struct UserObject*)block4611;
  uo4612->data[0] = (Object)closure4612;
  Method *meth_meth_ast__apply4612 = addmethod2pos(block4611, "_apply", &meth_ast__apply4612, 0);
  int argcv_meth_ast__apply4612[] = {1};
  meth_meth_ast__apply4612->type = alloc_MethodType(1, argcv_meth_ast__apply4612);
  meth_meth_ast__apply4612->definitionModule = modulename;
  meth_meth_ast__apply4612->definitionLine = 1014;
// compiled block node returning block4611 (depth = 4)
  gc_frame_newslot(block4611);
// call case 5: prelude request
  params[0] = call4610;
  params[1] = block4611;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4635 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4608);
// compiled call node returning call4635 (depth = 3)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4637 == NULL) {
    strlit4637 = alloc_String("}");
    gc_root(strlit4637);
  }
// compiled string node returning strlit4637 (depth = 5)
  int op_slot_right_4636 = gc_frame_newslot(strlit4637);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4639 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4642 == NULL) {
    strlit4642 = alloc_String("""\x0a""");
    gc_root(strlit4642);
  }
// compiled string node returning strlit4642 (depth = 7)
  int op_slot_right_4641 = gc_frame_newslot(strlit4642);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4641 = gc_frame_newslot(*var_s);
  params[0] = strlit4642;
  partcv[0] = 1;
  Object opresult4644 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4644 (depth = 6)
  int op_slot_left_4639 = gc_frame_newslot(opresult4644);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4645 = callmethod(opresult4644, "++", 1, partcv, params);
// compiled op node returning opresult4645 (depth = 5)
  int op_slot_left_4636 = gc_frame_newslot(opresult4645);
  params[0] = strlit4637;
  partcv[0] = 1;
  Object opresult4646 = callmethod(opresult4645, "++", 1, partcv, params);
// compiled op node returning opresult4646 (depth = 4)
  *var_s = opresult4646;
  if (opresult4646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy4648(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4649 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe4650 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4652 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4651);
// compiled call node returning call4652 (depth = 6)
// compiled member node returning call4652 (depth = 5)
  gc_frame_newslot(call4652);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4653 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4654 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4653);
// compiled call node returning call4654 (depth = 6)
// compiled member node returning call4654 (depth = 5)
  gc_frame_newslot(call4654);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4656 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4655);
// compiled call node returning call4656 (depth = 6)
// compiled member node returning call4656 (depth = 5)
  gc_frame_newslot(call4656);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4657 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4658 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4657);
// compiled call node returning call4658 (depth = 6)
// compiled member node returning call4658 (depth = 5)
  gc_frame_newslot(call4658);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodNode (depth = 5)
  params[0] = call4652;
  params[1] = call4654;
  params[2] = call4656;
  params[3] = call4658;
  partcv[0] = 4;
  Object call4659 = callmethod(*var_methodNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4650);
// compiled call node returning call4659 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4660 = callmethod(call4659, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe4649);
// compiled call node returning call4660 (depth = 3)
  gc_frame_end(frame);
  return call4660;
}
Object meth_ast_shallowCopyFieldsFrom4661(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4662 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call4663 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4662);
// compiled call node returning call4663 (depth = 3)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4664 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call4666 = callmethod(*var_other, "isFresh",
    1, partcv, params);
  gc_frame_end(callframe4665);
// compiled call node returning call4666 (depth = 5)
// compiled member node returning call4666 (depth = 4)
  gc_frame_newslot(call4666);
// call case 4: self request
  params[0] = call4666;
  partcv[0] = 1;
  Object call4667 = callmethodflags(self, "isFresh:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4664);
// compiled call node returning call4667 (depth = 3)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4668 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call4670 = callmethod(*var_other, "selfclosure",
    1, partcv, params);
  gc_frame_end(callframe4669);
// compiled call node returning call4670 (depth = 5)
// compiled member node returning call4670 (depth = 4)
  gc_frame_newslot(call4670);
// call case 4: self request
  params[0] = call4670;
  partcv[0] = 1;
  Object call4671 = callmethodflags(self, "selfclosure:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4668);
// compiled call node returning call4671 (depth = 3)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new3672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_methodNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3673 = alloc_userobj2(43,34, objclass3673);
  gc_frame_newslot(obj3673);
if (objclass3673 == NULL) {
  glfree(obj3673->class->name);
  obj3673->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3673, self, 0);
  addmethodreal(obj3673,"outer", &reader_ast_outer_3674);
  Object oldself3673 = self;
  struct StackFrameObject *oldstackframe3673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3673);
  gc_frame_newslot((Object)stackframe);
  self = obj3673;
  Object *oldselfslot3673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3673 = (*(struct UserObject *)self).data[0], lowerouter3673 = thisouter3673;
  if (inheritingObject3673) {
    struct UserObject *inho3673 = (struct UserObject *)inheritingObject3673;
    while (inho3673->super != GraceDefaultObject) inho3673 = (struct UserObject *)inho3673->super;
    inho3673->super = obj3673;
    self = inheritingObject3673;
    *selfslot = self;
    lowerouter3673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3673;
  }
if (objclass3673 == NULL) {
  Method *reader3675 = addmethodrealflags(obj3673, "kind",&reader_ast_kind_3675, MFLAG_DEF);
  reader3675->definitionModule = modulename;
  reader3675->definitionLine = 830;
}
adddatum2(obj3673, alloc_Undefined(), 1);
if (objclass3673 == NULL) {
  Method *reader3676 = addmethodrealflags(obj3673, "value",&reader_ast_value_3676, 0);
  Method *writer3676 = addmethodrealflags(obj3673, "value:=",&writer_ast_value_3676, 0);
  reader3676->definitionModule = modulename;
  writer3676->definitionModule = modulename;
  reader3676->definitionLine = 831;
  writer3676->definitionLine = 831;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 2);
if (objclass3673 == NULL) {
  Method *reader3677 = addmethodrealflags(obj3673, "signature",&reader_ast_signature_3677, 0);
  Method *writer3677 = addmethodrealflags(obj3673, "signature:=",&writer_ast_signature_3677, 0);
  reader3677->definitionModule = modulename;
  writer3677->definitionModule = modulename;
  reader3677->definitionLine = 832;
  writer3677->definitionLine = 832;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 3);
if (objclass3673 == NULL) {
  Method *reader3678 = addmethodrealflags(obj3673, "body",&reader_ast_body_3678, 0);
  Method *writer3678 = addmethodrealflags(obj3673, "body:=",&writer_ast_body_3678, 0);
  reader3678->definitionModule = modulename;
  writer3678->definitionModule = modulename;
  reader3678->definitionLine = 833;
  writer3678->definitionLine = 833;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 4);
if (objclass3673 == NULL) {
  Method *reader3679 = addmethodrealflags(obj3673, "dtype",&reader_ast_dtype_3679, 0);
  Method *writer3679 = addmethodrealflags(obj3673, "dtype:=",&writer_ast_dtype_3679, 0);
  reader3679->definitionModule = modulename;
  writer3679->definitionModule = modulename;
  reader3679->definitionLine = 834;
  writer3679->definitionLine = 834;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 5);
if (objclass3673 == NULL) {
  Method *reader3680 = addmethodrealflags(obj3673, "varargs",&reader_ast_varargs_3680, 0);
  Method *writer3680 = addmethodrealflags(obj3673, "varargs:=",&writer_ast_varargs_3680, 0);
  reader3680->definitionModule = modulename;
  writer3680->definitionModule = modulename;
  reader3680->definitionLine = 835;
  writer3680->definitionLine = 835;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 6);
if (objclass3673 == NULL) {
  Method *reader3681 = addmethodrealflags(obj3673, "typeParams",&reader_ast_typeParams_3681, 0);
  Method *writer3681 = addmethodrealflags(obj3673, "typeParams:=",&writer_ast_typeParams_3681, 0);
  reader3681->definitionModule = modulename;
  writer3681->definitionModule = modulename;
  reader3681->definitionLine = 836;
  writer3681->definitionLine = 836;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 7);
if (objclass3673 == NULL) {
  Method *reader3682 = addmethodrealflags(obj3673, "selfclosure",&reader_ast_selfclosure_3682, 0);
  Method *writer3682 = addmethodrealflags(obj3673, "selfclosure:=",&writer_ast_selfclosure_3682, 0);
  reader3682->definitionModule = modulename;
  writer3682->definitionModule = modulename;
  reader3682->definitionLine = 837;
  writer3682->definitionLine = 837;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 8);
if (objclass3673 == NULL) {
  Method *reader3683 = addmethodrealflags(obj3673, "nameString",&reader_ast_nameString_3683, MFLAG_DEF);
  reader3683->definitionModule = modulename;
  reader3683->definitionLine = 838;
}
adddatum2(obj3673, alloc_Undefined(), 9);
if (objclass3673 == NULL) {
  Method *reader3684 = addmethodrealflags(obj3673, "annotations",&reader_ast_annotations_3684, 0);
  Method *writer3684 = addmethodrealflags(obj3673, "annotations:=",&writer_ast_annotations_3684, 0);
  reader3684->definitionModule = modulename;
  writer3684->definitionModule = modulename;
  reader3684->definitionLine = 839;
  writer3684->definitionLine = 839;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 10);
if (objclass3673 == NULL) {
  Method *reader3685 = addmethodrealflags(obj3673, "isFresh",&reader_ast_isFresh_3685, 0);
  Method *writer3685 = addmethodrealflags(obj3673, "isFresh:=",&writer_ast_isFresh_3685, 0);
  reader3685->definitionModule = modulename;
  writer3685->definitionModule = modulename;
  reader3685->definitionLine = 840;
  writer3685->definitionLine = 840;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 11);
if (objclass3673 == NULL) {
  Method *reader3686 = addmethodrealflags(obj3673, "usesClassSyntax",&reader_ast_usesClassSyntax_3686, 0);
  Method *writer3686 = addmethodrealflags(obj3673, "usesClassSyntax:=",&writer_ast_usesClassSyntax_3686, 0);
  reader3686->definitionModule = modulename;
  writer3686->definitionModule = modulename;
  reader3686->definitionLine = 841;
  writer3686->definitionLine = 841;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 12);
// method "isMethod"
  struct UserObject *uo3687 = (struct UserObject*)obj3673;
  uo3687->data[13] = emptyclosure;
  Method *meth_meth_ast_isMethod3687 = addmethod2pos(obj3673, "isMethod", &meth_ast_isMethod3687, 13);
  int argcv_meth_ast_isMethod3687[] = {0};
  meth_meth_ast_isMethod3687->type = alloc_MethodType(1, argcv_meth_ast_isMethod3687);
  meth_meth_ast_isMethod3687->definitionModule = modulename;
  meth_meth_ast_isMethod3687->definitionLine = 843;
// method "isExecutable"
  struct UserObject *uo3689 = (struct UserObject*)obj3673;
  uo3689->data[14] = emptyclosure;
  Method *meth_meth_ast_isExecutable3689 = addmethod2pos(obj3673, "isExecutable", &meth_ast_isExecutable3689, 14);
  int argcv_meth_ast_isExecutable3689[] = {0};
  meth_meth_ast_isExecutable3689->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3689);
  meth_meth_ast_isExecutable3689->definitionModule = modulename;
  meth_meth_ast_isExecutable3689->definitionLine = 844;
// method "isLegalInTrait"
  struct UserObject *uo3691 = (struct UserObject*)obj3673;
  uo3691->data[15] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3691 = addmethod2pos(obj3673, "isLegalInTrait", &meth_ast_isLegalInTrait3691, 15);
  int argcv_meth_ast_isLegalInTrait3691[] = {0};
  meth_meth_ast_isLegalInTrait3691->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3691);
  meth_meth_ast_isLegalInTrait3691->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3691->definitionLine = 845;
// method "isClass"
  struct UserObject *uo3693 = (struct UserObject*)obj3673;
  uo3693->data[16] = emptyclosure;
  Method *meth_meth_ast_isClass3693 = addmethod2pos(obj3673, "isClass", &meth_ast_isClass3693, 16);
  int argcv_meth_ast_isClass3693[] = {0};
  meth_meth_ast_isClass3693->type = alloc_MethodType(1, argcv_meth_ast_isClass3693);
  meth_meth_ast_isClass3693->definitionModule = modulename;
  meth_meth_ast_isClass3693->definitionLine = 846;
// method "isTrait"
  struct UserObject *uo3701 = (struct UserObject*)obj3673;
  uo3701->data[17] = emptyclosure;
  Method *meth_meth_ast_isTrait3701 = addmethod2pos(obj3673, "isTrait", &meth_ast_isTrait3701, 17);
  int argcv_meth_ast_isTrait3701[] = {0};
  meth_meth_ast_isTrait3701->type = alloc_MethodType(1, argcv_meth_ast_isTrait3701);
  meth_meth_ast_isTrait3701->definitionModule = modulename;
  meth_meth_ast_isTrait3701->definitionLine = 847;
// method "needsArgChecks"
  struct UserObject *uo3712 = (struct UserObject*)obj3673;
  uo3712->data[18] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3712 = addmethod2pos(obj3673, "needsArgChecks", &meth_ast_needsArgChecks3712, 18);
  int argcv_meth_ast_needsArgChecks3712[] = {0};
  meth_meth_ast_needsArgChecks3712->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3712);
  meth_meth_ast_needsArgChecks3712->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3712->definitionLine = 854;
// method "scope:="
  struct UserObject *uo3749 = (struct UserObject*)obj3673;
  uo3749->data[19] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3749 = addmethod2pos(obj3673, "scope:=", &meth_ast_scope_58__61_3749, 19);
  int argcv_meth_ast_scope_58__61_3749[] = {1};
  meth_meth_ast_scope_58__61_3749->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3749);
  meth_meth_ast_scope_58__61_3749->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3749->definitionLine = 865;
// method "declarationKindWithAncestors"
  block_savedest(obj3673);
  Object closure3754 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3754, stackframe);
  addtoclosure(closure3754, var_k);
  struct UserObject *uo3754 = (struct UserObject*)obj3673;
  uo3754->data[20] = (Object)closure3754;
  Method *meth_meth_ast_declarationKindWithAncestors3754 = addmethod2pos(obj3673, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3754, 20);
  int argcv_meth_ast_declarationKindWithAncestors3754[] = {1};
  meth_meth_ast_declarationKindWithAncestors3754->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3754);
  meth_meth_ast_declarationKindWithAncestors3754->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3754->definitionLine = 871;
// method "isConfidential"
  struct UserObject *uo3757 = (struct UserObject*)obj3673;
  uo3757->data[21] = emptyclosure;
  Method *meth_meth_ast_isConfidential3757 = addmethod2pos(obj3673, "isConfidential", &meth_ast_isConfidential3757, 21);
  int argcv_meth_ast_isConfidential3757[] = {0};
  meth_meth_ast_isConfidential3757->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3757);
  meth_meth_ast_isConfidential3757->definitionModule = modulename;
  meth_meth_ast_isConfidential3757->definitionLine = 872;
// method "isPublic"
  struct UserObject *uo3775 = (struct UserObject*)obj3673;
  uo3775->data[22] = emptyclosure;
  Method *meth_meth_ast_isPublic3775 = addmethod2pos(obj3673, "isPublic", &meth_ast_isPublic3775, 22);
  int argcv_meth_ast_isPublic3775[] = {0};
  meth_meth_ast_isPublic3775->type = alloc_MethodType(1, argcv_meth_ast_isPublic3775);
  meth_meth_ast_isPublic3775->definitionModule = modulename;
  meth_meth_ast_isPublic3775->definitionLine = 876;
// method "isWritable"
  struct UserObject *uo3780 = (struct UserObject*)obj3673;
  uo3780->data[23] = emptyclosure;
  Method *meth_meth_ast_isWritable3780 = addmethod2pos(obj3673, "isWritable", &meth_ast_isWritable3780, 23);
  int argcv_meth_ast_isWritable3780[] = {0};
  meth_meth_ast_isWritable3780->type = alloc_MethodType(1, argcv_meth_ast_isWritable3780);
  meth_meth_ast_isWritable3780->definitionModule = modulename;
  meth_meth_ast_isWritable3780->definitionLine = 877;
// method "isReadable"
  struct UserObject *uo3782 = (struct UserObject*)obj3673;
  uo3782->data[24] = emptyclosure;
  Method *meth_meth_ast_isReadable3782 = addmethod2pos(obj3673, "isReadable", &meth_ast_isReadable3782, 24);
  int argcv_meth_ast_isReadable3782[] = {0};
  meth_meth_ast_isReadable3782->type = alloc_MethodType(1, argcv_meth_ast_isReadable3782);
  meth_meth_ast_isReadable3782->definitionModule = modulename;
  meth_meth_ast_isReadable3782->definitionLine = 878;
// method "usesAsType"
  struct UserObject *uo3785 = (struct UserObject*)obj3673;
  uo3785->data[25] = emptyclosure;
  Method *meth_meth_ast_usesAsType3785 = addmethod2pos(obj3673, "usesAsType", &meth_ast_usesAsType3785, 25);
  int argcv_meth_ast_usesAsType3785[] = {1};
  meth_meth_ast_usesAsType3785->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3785);
  meth_meth_ast_usesAsType3785->definitionModule = modulename;
  meth_meth_ast_usesAsType3785->definitionLine = 879;
// method "returnsObject"
  struct UserObject *uo3791 = (struct UserObject*)obj3673;
  uo3791->data[26] = emptyclosure;
  Method *meth_meth_ast_returnsObject3791 = addmethod2pos(obj3673, "returnsObject", &meth_ast_returnsObject3791, 26);
  int argcv_meth_ast_returnsObject3791[] = {0};
  meth_meth_ast_returnsObject3791->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3791);
  meth_meth_ast_returnsObject3791->definitionModule = modulename;
  meth_meth_ast_returnsObject3791->definitionLine = 882;
// method "returnedObjectScope"
  struct UserObject *uo3809 = (struct UserObject*)obj3673;
  uo3809->data[27] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3809 = addmethod2pos(obj3673, "returnedObjectScope", &meth_ast_returnedObjectScope3809, 27);
  int argcv_meth_ast_returnedObjectScope3809[] = {0};
  meth_meth_ast_returnedObjectScope3809->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3809);
  meth_meth_ast_returnedObjectScope3809->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3809->definitionLine = 885;
// method "accept()from"
  struct UserObject *uo3816 = (struct UserObject*)obj3673;
  uo3816->data[28] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3816 = addmethod2pos(obj3673, "accept()from", &meth_ast_accept_40__41_from3816, 28);
  int argcv_meth_ast_accept_40__41_from3816[] = {1, 1};
  meth_meth_ast_accept_40__41_from3816->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3816);
  meth_meth_ast_accept_40__41_from3816->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3816->definitionLine = 889;
// method "map()ancestors"
  struct UserObject *uo3893 = (struct UserObject*)obj3673;
  uo3893->data[29] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3893 = addmethod2pos(obj3673, "map()ancestors", &meth_ast_map_40__41_ancestors3893, 29);
  int argcv_meth_ast_map_40__41_ancestors3893[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3893->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3893);
  meth_meth_ast_map_40__41_ancestors3893->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3893->definitionLine = 915;
// method "pretty"
  struct UserObject *uo3950 = (struct UserObject*)obj3673;
  uo3950->data[30] = emptyclosure;
  Method *meth_meth_ast_pretty3950 = addmethod2pos(obj3673, "pretty", &meth_ast_pretty3950, 30);
  int argcv_meth_ast_pretty3950[] = {1};
  meth_meth_ast_pretty3950->type = alloc_MethodType(1, argcv_meth_ast_pretty3950);
  meth_meth_ast_pretty3950->definitionModule = modulename;
  meth_meth_ast_pretty3950->definitionLine = 925;
// method "toGrace"
  struct UserObject *uo4366 = (struct UserObject*)obj3673;
  uo4366->data[31] = emptyclosure;
  Method *meth_meth_ast_toGrace4366 = addmethod2pos(obj3673, "toGrace", &meth_ast_toGrace4366, 31);
  int argcv_meth_ast_toGrace4366[] = {1};
  meth_meth_ast_toGrace4366->type = alloc_MethodType(1, argcv_meth_ast_toGrace4366);
meth_meth_ast_toGrace4366->type->types[0] = type_Number;
meth_meth_ast_toGrace4366->type->names[0] = "depth";
  meth_meth_ast_toGrace4366->definitionModule = modulename;
  meth_meth_ast_toGrace4366->definitionLine = 973;
// method "shallowCopy"
  block_savedest(obj3673);
  Object closure4648 = createclosure(1, "shallowCopy");
  setclosureframe(closure4648, stackframe);
  addtoclosure(closure4648, var_methodNode);
  struct UserObject *uo4648 = (struct UserObject*)obj3673;
  uo4648->data[32] = (Object)closure4648;
  Method *meth_meth_ast_shallowCopy4648 = addmethod2pos(obj3673, "shallowCopy", &meth_ast_shallowCopy4648, 32);
  int argcv_meth_ast_shallowCopy4648[] = {0};
  meth_meth_ast_shallowCopy4648->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4648);
  meth_meth_ast_shallowCopy4648->definitionModule = modulename;
  meth_meth_ast_shallowCopy4648->definitionLine = 1020;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo4661 = (struct UserObject*)obj3673;
  uo4661->data[33] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom4661 = addmethod2pos(obj3673, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom4661, 33);
  int argcv_meth_ast_shallowCopyFieldsFrom4661[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom4661->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom4661);
  meth_meth_ast_shallowCopyFieldsFrom4661->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom4661->definitionLine = 1023;
  sourceObject = obj3673;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4672 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4673 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4674 = gc_frame_new();
// call case 3: self.outer request
  Object call4675 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4674);
// compiled call node returning call4675 (depth = 7)
// compiled member node returning call4675 (depth = 6)
  partcv[0] = 0;
  Object call4676 = callmethodflags(call4675, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4673);
// compiled call node returning call4676 (depth = 5)
// compiled member node returning call4676 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4677 = callmethodflags(call4676, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4672);
// compiled call node returning call4677 (depth = 3)
  struct UserObject *obj3673_uo = (struct UserObject *)obj3673;
  obj3673_uo->super = call4677;
  sourceObject = obj3673;
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4678 == NULL) {
    strlit4678 = alloc_String("method");
    gc_root(strlit4678);
  }
// compiled string node returning strlit4678 (depth = 3)
  adddatum2(obj3673, strlit4678, 1);
  sourceObject = obj3673;
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3673, *var_name_39_, 2);
  sourceObject = obj3673;
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3673, *var_signature_39_, 3);
  sourceObject = obj3673;
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3673, *var_body_39_, 4);
  sourceObject = obj3673;
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3673, *var_dtype_39_, 5);
  sourceObject = obj3673;
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4679 = alloc_Boolean(0);
// compiled identifier node returning bool4679 (depth = 3)
  adddatum2(obj3673, bool4679, 6);
  sourceObject = obj3673;
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4680 = alloc_Boolean(0);
// compiled identifier node returning bool4680 (depth = 3)
  adddatum2(obj3673, bool4680, 7);
  sourceObject = obj3673;
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4681 = alloc_Boolean(0);
// compiled identifier node returning bool4681 (depth = 3)
  adddatum2(obj3673, bool4681, 8);
  sourceObject = obj3673;
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4682 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4683 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4684 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4683);
// compiled call node returning call4684 (depth = 6)
// compiled member node returning call4684 (depth = 5)
  partcv[0] = 0;
  Object call4685 = callmethod(call4684, "value",
    1, partcv, params);
  gc_frame_end(callframe4682);
// compiled call node returning call4685 (depth = 4)
// compiled member node returning call4685 (depth = 3)
  adddatum2(obj3673, call4685, 9);
  sourceObject = obj3673;
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4686 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4687 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4688 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4687);
// compiled call node returning call4688 (depth = 6)
// compiled member node returning call4688 (depth = 5)
  partcv[0] = 0;
  Object call4689 = callmethod(call4688, "empty",
    1, partcv, params);
  gc_frame_end(callframe4686);
// compiled call node returning call4689 (depth = 4)
// compiled member node returning call4689 (depth = 3)
  adddatum2(obj3673, call4689, 10);
  sourceObject = obj3673;
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4690 = alloc_Boolean(0);
// compiled identifier node returning bool4690 (depth = 3)
  adddatum2(obj3673, bool4690, 11);
  sourceObject = obj3673;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4691 = alloc_Boolean(0);
// compiled identifier node returning bool4691 (depth = 3)
  adddatum2(obj3673, bool4691, 12);
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  objclass3673 = obj3673->class;
  objclass3673->definitionModule = modulename;
  objclass3673->definitionLine = 822;
  (*(struct UserObject *)self).data[0] = lowerouter3673;
  self = oldself3673;
  selfslot = oldselfslot3673;
  stackframe = oldstackframe3673;
  gc_frame_end(frame);
  return obj3673;
}
Object meth_ast_new3672_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 4)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_methodNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3673 = alloc_userobj2(43,34, objclass3673);
  gc_frame_newslot(obj3673);
if (objclass3673 == NULL) {
  glfree(obj3673->class->name);
  obj3673->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3673, self, 0);
  addmethodreal(obj3673,"outer", &reader_ast_outer_3674);
  Object oldself3673 = self;
  struct StackFrameObject *oldstackframe3673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3673);
  gc_frame_newslot((Object)stackframe);
  self = obj3673;
  Object *oldselfslot3673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3673 = (*(struct UserObject *)self).data[0], lowerouter3673 = thisouter3673;
  if (inheritingObject3673) {
    struct UserObject *inho3673 = (struct UserObject *)inheritingObject3673;
    while (inho3673->super != GraceDefaultObject) inho3673 = (struct UserObject *)inho3673->super;
    inho3673->super = obj3673;
    self = inheritingObject3673;
    *selfslot = self;
    lowerouter3673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3673;
  }
if (objclass3673 == NULL) {
  Method *reader3675 = addmethodrealflags(obj3673, "kind",&reader_ast_kind_3675, MFLAG_DEF);
  reader3675->definitionModule = modulename;
  reader3675->definitionLine = 830;
}
adddatum2(obj3673, alloc_Undefined(), 1);
if (objclass3673 == NULL) {
  Method *reader3676 = addmethodrealflags(obj3673, "value",&reader_ast_value_3676, 0);
  Method *writer3676 = addmethodrealflags(obj3673, "value:=",&writer_ast_value_3676, 0);
  reader3676->definitionModule = modulename;
  writer3676->definitionModule = modulename;
  reader3676->definitionLine = 831;
  writer3676->definitionLine = 831;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 2);
if (objclass3673 == NULL) {
  Method *reader3677 = addmethodrealflags(obj3673, "signature",&reader_ast_signature_3677, 0);
  Method *writer3677 = addmethodrealflags(obj3673, "signature:=",&writer_ast_signature_3677, 0);
  reader3677->definitionModule = modulename;
  writer3677->definitionModule = modulename;
  reader3677->definitionLine = 832;
  writer3677->definitionLine = 832;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 3);
if (objclass3673 == NULL) {
  Method *reader3678 = addmethodrealflags(obj3673, "body",&reader_ast_body_3678, 0);
  Method *writer3678 = addmethodrealflags(obj3673, "body:=",&writer_ast_body_3678, 0);
  reader3678->definitionModule = modulename;
  writer3678->definitionModule = modulename;
  reader3678->definitionLine = 833;
  writer3678->definitionLine = 833;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 4);
if (objclass3673 == NULL) {
  Method *reader3679 = addmethodrealflags(obj3673, "dtype",&reader_ast_dtype_3679, 0);
  Method *writer3679 = addmethodrealflags(obj3673, "dtype:=",&writer_ast_dtype_3679, 0);
  reader3679->definitionModule = modulename;
  writer3679->definitionModule = modulename;
  reader3679->definitionLine = 834;
  writer3679->definitionLine = 834;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 5);
if (objclass3673 == NULL) {
  Method *reader3680 = addmethodrealflags(obj3673, "varargs",&reader_ast_varargs_3680, 0);
  Method *writer3680 = addmethodrealflags(obj3673, "varargs:=",&writer_ast_varargs_3680, 0);
  reader3680->definitionModule = modulename;
  writer3680->definitionModule = modulename;
  reader3680->definitionLine = 835;
  writer3680->definitionLine = 835;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 6);
if (objclass3673 == NULL) {
  Method *reader3681 = addmethodrealflags(obj3673, "typeParams",&reader_ast_typeParams_3681, 0);
  Method *writer3681 = addmethodrealflags(obj3673, "typeParams:=",&writer_ast_typeParams_3681, 0);
  reader3681->definitionModule = modulename;
  writer3681->definitionModule = modulename;
  reader3681->definitionLine = 836;
  writer3681->definitionLine = 836;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 7);
if (objclass3673 == NULL) {
  Method *reader3682 = addmethodrealflags(obj3673, "selfclosure",&reader_ast_selfclosure_3682, 0);
  Method *writer3682 = addmethodrealflags(obj3673, "selfclosure:=",&writer_ast_selfclosure_3682, 0);
  reader3682->definitionModule = modulename;
  writer3682->definitionModule = modulename;
  reader3682->definitionLine = 837;
  writer3682->definitionLine = 837;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 8);
if (objclass3673 == NULL) {
  Method *reader3683 = addmethodrealflags(obj3673, "nameString",&reader_ast_nameString_3683, MFLAG_DEF);
  reader3683->definitionModule = modulename;
  reader3683->definitionLine = 838;
}
adddatum2(obj3673, alloc_Undefined(), 9);
if (objclass3673 == NULL) {
  Method *reader3684 = addmethodrealflags(obj3673, "annotations",&reader_ast_annotations_3684, 0);
  Method *writer3684 = addmethodrealflags(obj3673, "annotations:=",&writer_ast_annotations_3684, 0);
  reader3684->definitionModule = modulename;
  writer3684->definitionModule = modulename;
  reader3684->definitionLine = 839;
  writer3684->definitionLine = 839;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 10);
if (objclass3673 == NULL) {
  Method *reader3685 = addmethodrealflags(obj3673, "isFresh",&reader_ast_isFresh_3685, 0);
  Method *writer3685 = addmethodrealflags(obj3673, "isFresh:=",&writer_ast_isFresh_3685, 0);
  reader3685->definitionModule = modulename;
  writer3685->definitionModule = modulename;
  reader3685->definitionLine = 840;
  writer3685->definitionLine = 840;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 11);
if (objclass3673 == NULL) {
  Method *reader3686 = addmethodrealflags(obj3673, "usesClassSyntax",&reader_ast_usesClassSyntax_3686, 0);
  Method *writer3686 = addmethodrealflags(obj3673, "usesClassSyntax:=",&writer_ast_usesClassSyntax_3686, 0);
  reader3686->definitionModule = modulename;
  writer3686->definitionModule = modulename;
  reader3686->definitionLine = 841;
  writer3686->definitionLine = 841;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 12);
// method "isMethod"
  struct UserObject *uo3687 = (struct UserObject*)obj3673;
  uo3687->data[13] = emptyclosure;
  Method *meth_meth_ast_isMethod3687 = addmethod2pos(obj3673, "isMethod", &meth_ast_isMethod3687, 13);
  int argcv_meth_ast_isMethod3687[] = {0};
  meth_meth_ast_isMethod3687->type = alloc_MethodType(1, argcv_meth_ast_isMethod3687);
  meth_meth_ast_isMethod3687->definitionModule = modulename;
  meth_meth_ast_isMethod3687->definitionLine = 843;
// method "isExecutable"
  struct UserObject *uo3689 = (struct UserObject*)obj3673;
  uo3689->data[14] = emptyclosure;
  Method *meth_meth_ast_isExecutable3689 = addmethod2pos(obj3673, "isExecutable", &meth_ast_isExecutable3689, 14);
  int argcv_meth_ast_isExecutable3689[] = {0};
  meth_meth_ast_isExecutable3689->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3689);
  meth_meth_ast_isExecutable3689->definitionModule = modulename;
  meth_meth_ast_isExecutable3689->definitionLine = 844;
// method "isLegalInTrait"
  struct UserObject *uo3691 = (struct UserObject*)obj3673;
  uo3691->data[15] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3691 = addmethod2pos(obj3673, "isLegalInTrait", &meth_ast_isLegalInTrait3691, 15);
  int argcv_meth_ast_isLegalInTrait3691[] = {0};
  meth_meth_ast_isLegalInTrait3691->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3691);
  meth_meth_ast_isLegalInTrait3691->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3691->definitionLine = 845;
// method "isClass"
  struct UserObject *uo3693 = (struct UserObject*)obj3673;
  uo3693->data[16] = emptyclosure;
  Method *meth_meth_ast_isClass3693 = addmethod2pos(obj3673, "isClass", &meth_ast_isClass3693, 16);
  int argcv_meth_ast_isClass3693[] = {0};
  meth_meth_ast_isClass3693->type = alloc_MethodType(1, argcv_meth_ast_isClass3693);
  meth_meth_ast_isClass3693->definitionModule = modulename;
  meth_meth_ast_isClass3693->definitionLine = 846;
// method "isTrait"
  struct UserObject *uo3701 = (struct UserObject*)obj3673;
  uo3701->data[17] = emptyclosure;
  Method *meth_meth_ast_isTrait3701 = addmethod2pos(obj3673, "isTrait", &meth_ast_isTrait3701, 17);
  int argcv_meth_ast_isTrait3701[] = {0};
  meth_meth_ast_isTrait3701->type = alloc_MethodType(1, argcv_meth_ast_isTrait3701);
  meth_meth_ast_isTrait3701->definitionModule = modulename;
  meth_meth_ast_isTrait3701->definitionLine = 847;
// method "needsArgChecks"
  struct UserObject *uo3712 = (struct UserObject*)obj3673;
  uo3712->data[18] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3712 = addmethod2pos(obj3673, "needsArgChecks", &meth_ast_needsArgChecks3712, 18);
  int argcv_meth_ast_needsArgChecks3712[] = {0};
  meth_meth_ast_needsArgChecks3712->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3712);
  meth_meth_ast_needsArgChecks3712->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3712->definitionLine = 854;
// method "scope:="
  struct UserObject *uo3749 = (struct UserObject*)obj3673;
  uo3749->data[19] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3749 = addmethod2pos(obj3673, "scope:=", &meth_ast_scope_58__61_3749, 19);
  int argcv_meth_ast_scope_58__61_3749[] = {1};
  meth_meth_ast_scope_58__61_3749->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3749);
  meth_meth_ast_scope_58__61_3749->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3749->definitionLine = 865;
// method "declarationKindWithAncestors"
  block_savedest(obj3673);
  Object closure3754 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3754, stackframe);
  addtoclosure(closure3754, var_k);
  struct UserObject *uo3754 = (struct UserObject*)obj3673;
  uo3754->data[20] = (Object)closure3754;
  Method *meth_meth_ast_declarationKindWithAncestors3754 = addmethod2pos(obj3673, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3754, 20);
  int argcv_meth_ast_declarationKindWithAncestors3754[] = {1};
  meth_meth_ast_declarationKindWithAncestors3754->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3754);
  meth_meth_ast_declarationKindWithAncestors3754->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3754->definitionLine = 871;
// method "isConfidential"
  struct UserObject *uo3757 = (struct UserObject*)obj3673;
  uo3757->data[21] = emptyclosure;
  Method *meth_meth_ast_isConfidential3757 = addmethod2pos(obj3673, "isConfidential", &meth_ast_isConfidential3757, 21);
  int argcv_meth_ast_isConfidential3757[] = {0};
  meth_meth_ast_isConfidential3757->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3757);
  meth_meth_ast_isConfidential3757->definitionModule = modulename;
  meth_meth_ast_isConfidential3757->definitionLine = 872;
// method "isPublic"
  struct UserObject *uo3775 = (struct UserObject*)obj3673;
  uo3775->data[22] = emptyclosure;
  Method *meth_meth_ast_isPublic3775 = addmethod2pos(obj3673, "isPublic", &meth_ast_isPublic3775, 22);
  int argcv_meth_ast_isPublic3775[] = {0};
  meth_meth_ast_isPublic3775->type = alloc_MethodType(1, argcv_meth_ast_isPublic3775);
  meth_meth_ast_isPublic3775->definitionModule = modulename;
  meth_meth_ast_isPublic3775->definitionLine = 876;
// method "isWritable"
  struct UserObject *uo3780 = (struct UserObject*)obj3673;
  uo3780->data[23] = emptyclosure;
  Method *meth_meth_ast_isWritable3780 = addmethod2pos(obj3673, "isWritable", &meth_ast_isWritable3780, 23);
  int argcv_meth_ast_isWritable3780[] = {0};
  meth_meth_ast_isWritable3780->type = alloc_MethodType(1, argcv_meth_ast_isWritable3780);
  meth_meth_ast_isWritable3780->definitionModule = modulename;
  meth_meth_ast_isWritable3780->definitionLine = 877;
// method "isReadable"
  struct UserObject *uo3782 = (struct UserObject*)obj3673;
  uo3782->data[24] = emptyclosure;
  Method *meth_meth_ast_isReadable3782 = addmethod2pos(obj3673, "isReadable", &meth_ast_isReadable3782, 24);
  int argcv_meth_ast_isReadable3782[] = {0};
  meth_meth_ast_isReadable3782->type = alloc_MethodType(1, argcv_meth_ast_isReadable3782);
  meth_meth_ast_isReadable3782->definitionModule = modulename;
  meth_meth_ast_isReadable3782->definitionLine = 878;
// method "usesAsType"
  struct UserObject *uo3785 = (struct UserObject*)obj3673;
  uo3785->data[25] = emptyclosure;
  Method *meth_meth_ast_usesAsType3785 = addmethod2pos(obj3673, "usesAsType", &meth_ast_usesAsType3785, 25);
  int argcv_meth_ast_usesAsType3785[] = {1};
  meth_meth_ast_usesAsType3785->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3785);
  meth_meth_ast_usesAsType3785->definitionModule = modulename;
  meth_meth_ast_usesAsType3785->definitionLine = 879;
// method "returnsObject"
  struct UserObject *uo3791 = (struct UserObject*)obj3673;
  uo3791->data[26] = emptyclosure;
  Method *meth_meth_ast_returnsObject3791 = addmethod2pos(obj3673, "returnsObject", &meth_ast_returnsObject3791, 26);
  int argcv_meth_ast_returnsObject3791[] = {0};
  meth_meth_ast_returnsObject3791->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3791);
  meth_meth_ast_returnsObject3791->definitionModule = modulename;
  meth_meth_ast_returnsObject3791->definitionLine = 882;
// method "returnedObjectScope"
  struct UserObject *uo3809 = (struct UserObject*)obj3673;
  uo3809->data[27] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3809 = addmethod2pos(obj3673, "returnedObjectScope", &meth_ast_returnedObjectScope3809, 27);
  int argcv_meth_ast_returnedObjectScope3809[] = {0};
  meth_meth_ast_returnedObjectScope3809->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3809);
  meth_meth_ast_returnedObjectScope3809->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3809->definitionLine = 885;
// method "accept()from"
  struct UserObject *uo3816 = (struct UserObject*)obj3673;
  uo3816->data[28] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3816 = addmethod2pos(obj3673, "accept()from", &meth_ast_accept_40__41_from3816, 28);
  int argcv_meth_ast_accept_40__41_from3816[] = {1, 1};
  meth_meth_ast_accept_40__41_from3816->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3816);
  meth_meth_ast_accept_40__41_from3816->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3816->definitionLine = 889;
// method "map()ancestors"
  struct UserObject *uo3893 = (struct UserObject*)obj3673;
  uo3893->data[29] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3893 = addmethod2pos(obj3673, "map()ancestors", &meth_ast_map_40__41_ancestors3893, 29);
  int argcv_meth_ast_map_40__41_ancestors3893[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3893->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3893);
  meth_meth_ast_map_40__41_ancestors3893->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3893->definitionLine = 915;
// method "pretty"
  struct UserObject *uo3950 = (struct UserObject*)obj3673;
  uo3950->data[30] = emptyclosure;
  Method *meth_meth_ast_pretty3950 = addmethod2pos(obj3673, "pretty", &meth_ast_pretty3950, 30);
  int argcv_meth_ast_pretty3950[] = {1};
  meth_meth_ast_pretty3950->type = alloc_MethodType(1, argcv_meth_ast_pretty3950);
  meth_meth_ast_pretty3950->definitionModule = modulename;
  meth_meth_ast_pretty3950->definitionLine = 925;
// method "toGrace"
  struct UserObject *uo4366 = (struct UserObject*)obj3673;
  uo4366->data[31] = emptyclosure;
  Method *meth_meth_ast_toGrace4366 = addmethod2pos(obj3673, "toGrace", &meth_ast_toGrace4366, 31);
  int argcv_meth_ast_toGrace4366[] = {1};
  meth_meth_ast_toGrace4366->type = alloc_MethodType(1, argcv_meth_ast_toGrace4366);
meth_meth_ast_toGrace4366->type->types[0] = type_Number;
meth_meth_ast_toGrace4366->type->names[0] = "depth";
  meth_meth_ast_toGrace4366->definitionModule = modulename;
  meth_meth_ast_toGrace4366->definitionLine = 973;
// method "shallowCopy"
  block_savedest(obj3673);
  Object closure4648 = createclosure(1, "shallowCopy");
  setclosureframe(closure4648, stackframe);
  addtoclosure(closure4648, var_methodNode);
  struct UserObject *uo4648 = (struct UserObject*)obj3673;
  uo4648->data[32] = (Object)closure4648;
  Method *meth_meth_ast_shallowCopy4648 = addmethod2pos(obj3673, "shallowCopy", &meth_ast_shallowCopy4648, 32);
  int argcv_meth_ast_shallowCopy4648[] = {0};
  meth_meth_ast_shallowCopy4648->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4648);
  meth_meth_ast_shallowCopy4648->definitionModule = modulename;
  meth_meth_ast_shallowCopy4648->definitionLine = 1020;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo4661 = (struct UserObject*)obj3673;
  uo4661->data[33] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom4661 = addmethod2pos(obj3673, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom4661, 33);
  int argcv_meth_ast_shallowCopyFieldsFrom4661[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom4661->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom4661);
  meth_meth_ast_shallowCopyFieldsFrom4661->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom4661->definitionLine = 1023;
  sourceObject = obj3673;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4672 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4673 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4674 = gc_frame_new();
// call case 3: self.outer request
  Object call4675 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4674);
// compiled call node returning call4675 (depth = 7)
// compiled member node returning call4675 (depth = 6)
  partcv[0] = 0;
  Object call4676 = callmethodflags(call4675, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4673);
// compiled call node returning call4676 (depth = 5)
// compiled member node returning call4676 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4677 = callmethodflags(call4676, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4672);
// compiled call node returning call4677 (depth = 3)
  struct UserObject *obj3673_uo = (struct UserObject *)obj3673;
  obj3673_uo->super = call4677;
  sourceObject = obj3673;
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4678 == NULL) {
    strlit4678 = alloc_String("method");
    gc_root(strlit4678);
  }
// compiled string node returning strlit4678 (depth = 3)
  adddatum2(obj3673, strlit4678, 1);
  sourceObject = obj3673;
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3673, *var_name_39_, 2);
  sourceObject = obj3673;
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3673, *var_signature_39_, 3);
  sourceObject = obj3673;
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3673, *var_body_39_, 4);
  sourceObject = obj3673;
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3673, *var_dtype_39_, 5);
  sourceObject = obj3673;
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4679 = alloc_Boolean(0);
// compiled identifier node returning bool4679 (depth = 3)
  adddatum2(obj3673, bool4679, 6);
  sourceObject = obj3673;
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4680 = alloc_Boolean(0);
// compiled identifier node returning bool4680 (depth = 3)
  adddatum2(obj3673, bool4680, 7);
  sourceObject = obj3673;
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4681 = alloc_Boolean(0);
// compiled identifier node returning bool4681 (depth = 3)
  adddatum2(obj3673, bool4681, 8);
  sourceObject = obj3673;
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4682 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4683 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4684 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4683);
// compiled call node returning call4684 (depth = 6)
// compiled member node returning call4684 (depth = 5)
  partcv[0] = 0;
  Object call4685 = callmethod(call4684, "value",
    1, partcv, params);
  gc_frame_end(callframe4682);
// compiled call node returning call4685 (depth = 4)
// compiled member node returning call4685 (depth = 3)
  adddatum2(obj3673, call4685, 9);
  sourceObject = obj3673;
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4686 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4687 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4688 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4687);
// compiled call node returning call4688 (depth = 6)
// compiled member node returning call4688 (depth = 5)
  partcv[0] = 0;
  Object call4689 = callmethod(call4688, "empty",
    1, partcv, params);
  gc_frame_end(callframe4686);
// compiled call node returning call4689 (depth = 4)
// compiled member node returning call4689 (depth = 3)
  adddatum2(obj3673, call4689, 10);
  sourceObject = obj3673;
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4690 = alloc_Boolean(0);
// compiled identifier node returning bool4690 (depth = 3)
  adddatum2(obj3673, bool4690, 11);
  sourceObject = obj3673;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4691 = alloc_Boolean(0);
// compiled identifier node returning bool4691 (depth = 3)
  adddatum2(obj3673, bool4691, 12);
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  objclass3673 = obj3673->class;
  objclass3673->definitionModule = modulename;
  objclass3673->definitionLine = 822;
  (*(struct UserObject *)self).data[0] = lowerouter3673;
  self = oldself3673;
  selfslot = oldselfslot3673;
  stackframe = oldstackframe3673;
  gc_frame_end(frame);
  return obj3673;
}
Object meth_ast_methodNode4693(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for methodNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_new_40__41_scope4696(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with = &(stackframe->slots[1]);
  *var_with = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4697 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_what (depth = 5)
  gc_frame_newslot(*var_what);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_with (depth = 5)
  gc_frame_newslot(*var_with);
// call case 4: self request
  params[0] = *var_what;
  params[1] = *var_with;
  partcv[0] = 2;
  Object call4698 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4697);
// compiled call node returning call4698 (depth = 4)
  *var_result = call4698;
  if (call4698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4699 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call4700 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe4699);
// compiled call node returning call4700 (depth = 3)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_target4710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4711 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4712 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4711);
// compiled call node returning call4712 (depth = 4)
// compiled member node returning call4712 (depth = 3)
  gc_frame_end(frame);
  return call4712;
}
Object meth_ast_isCall4713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4714 = alloc_Boolean(1);
// compiled identifier node returning bool4714 (depth = 3)
  gc_frame_end(frame);
  return bool4714;
}
Object meth_ast_returnsObject4715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4717 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4718 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4719 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4720 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4719);
// compiled call node returning call4720 (depth = 9)
// compiled member node returning call4720 (depth = 8)
  partcv[0] = 0;
  Object call4721 = callmethod(call4720, "isMember",
    1, partcv, params);
  gc_frame_end(callframe4718);
// compiled call node returning call4721 (depth = 7)
// compiled member node returning call4721 (depth = 6)
  partcv[0] = 0;
  Object call4722 = callmethod(call4721, "not",
    1, partcv, params);
  gc_frame_end(callframe4717);
// compiled call node returning call4722 (depth = 5)
// compiled member node returning call4722 (depth = 4)
  Object if4716 = done;
  if (istrue(call4722)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4723 = alloc_Boolean(0);
// compiled identifier node returning bool4723 (depth = 5)
  return bool4723;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4716 = undefined;
  } else {
  }
// compiled if node returning if4716 (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4726 == NULL) {
    strlit4726 = alloc_String("clone");
    gc_root(strlit4726);
  }
// compiled string node returning strlit4726 (depth = 5)
  int op_slot_right_4725 = gc_frame_newslot(strlit4726);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4728 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4730 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4729);
// compiled call node returning call4730 (depth = 8)
// compiled member node returning call4730 (depth = 7)
  partcv[0] = 0;
  Object call4731 = callmethod(call4730, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4728);
// compiled call node returning call4731 (depth = 6)
// compiled member node returning call4731 (depth = 5)
  int op_slot_left_4725 = gc_frame_newslot(call4731);
  params[0] = strlit4726;
  partcv[0] = 1;
  Object opresult4732 = callmethod(call4731, "==", 1, partcv, params);
// compiled op node returning opresult4732 (depth = 4)
  Object if4724 = done;
  if (istrue(opresult4732)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4733 = alloc_Boolean(1);
// compiled identifier node returning bool4733 (depth = 5)
  return bool4733;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4724 = undefined;
  } else {
  }
// compiled if node returning if4724 (depth = 3)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4736 == NULL) {
    strlit4736 = alloc_String("copy");
    gc_root(strlit4736);
  }
// compiled string node returning strlit4736 (depth = 5)
  int op_slot_right_4735 = gc_frame_newslot(strlit4736);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4738 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4739 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4740 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4739);
// compiled call node returning call4740 (depth = 8)
// compiled member node returning call4740 (depth = 7)
  partcv[0] = 0;
  Object call4741 = callmethod(call4740, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4738);
// compiled call node returning call4741 (depth = 6)
// compiled member node returning call4741 (depth = 5)
  int op_slot_left_4735 = gc_frame_newslot(call4741);
  params[0] = strlit4736;
  partcv[0] = 1;
  Object opresult4742 = callmethod(call4741, "==", 1, partcv, params);
// compiled op node returning opresult4742 (depth = 4)
  Object if4734 = done;
  if (istrue(opresult4742)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4743 = alloc_Boolean(1);
// compiled identifier node returning bool4743 (depth = 5)
  return bool4743;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4734 = undefined;
  } else {
  }
// compiled if node returning if4734 (depth = 3)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4744 = alloc_Boolean(0);
// compiled identifier node returning bool4744 (depth = 4)
  return bool4744;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_returnedObjectScope4745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4746 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4747 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4746);
// compiled call node returning call4747 (depth = 4)
// compiled member node returning call4747 (depth = 3)
  gc_frame_end(frame);
  return call4747;
}
Object meth_ast__apply4767(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4768 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4769 = callmethod(*var_arg, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4768);
// compiled call node returning call4769 (depth = 8)
  gc_frame_end(frame);
  return call4769;
}
Object meth_ast__apply4762(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4763 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4765 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4764);
// compiled call node returning call4765 (depth = 8)
// compiled member node returning call4765 (depth = 7)
  gc_frame_newslot(call4765);
// starting to compile block node (depth = 7)
  Object block4766 = alloc_Block(NULL, NULL, "ast", 1080);
  gc_frame_newslot(block4766);
// method "_apply"
  block_savedest(block4766);
  Object closure4767 = createclosure(3, "_apply");
  setclosureframe(closure4767, stackframe);
  addtoclosure(closure4767, var_visitor);
  addtoclosure(closure4767, var_newChain);
  addtoclosure(closure4767, selfslot);
  struct UserObject *uo4767 = (struct UserObject*)block4766;
  uo4767->data[0] = (Object)closure4767;
  Method *meth_meth_ast__apply4767 = addmethod2pos(block4766, "_apply", &meth_ast__apply4767, 0);
  int argcv_meth_ast__apply4767[] = {1};
  meth_meth_ast__apply4767->type = alloc_MethodType(1, argcv_meth_ast__apply4767);
  meth_meth_ast__apply4767->definitionModule = modulename;
  meth_meth_ast__apply4767->definitionLine = 1080;
// compiled block node returning block4766 (depth = 7)
  gc_frame_newslot(block4766);
// call case 5: prelude request
  params[0] = call4765;
  params[1] = block4766;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4771 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4763);
// compiled call node returning call4771 (depth = 6)
  gc_frame_end(frame);
  return call4771;
}
Object meth_ast__apply4783(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4784 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4785 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4784);
// compiled call node returning call4785 (depth = 7)
  gc_frame_end(frame);
  return call4785;
}
Object meth_ast_accept_40__41_from4748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4750 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4751 = callmethod(*var_visitor, "visitCall()up",
    2, partcv, params);
  gc_frame_end(callframe4750);
// compiled call node returning call4751 (depth = 4)
  Object if4749 = done;
  if (istrue(call4751)) {
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4752 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call4753 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe4752);
// compiled call node returning call4753 (depth = 5)
  *var_newChain = call4753;
  if (call4753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4754 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4755 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4756 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4755);
// compiled call node returning call4756 (depth = 6)
// compiled member node returning call4756 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4757 = callmethod(call4756, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4754);
// compiled call node returning call4757 (depth = 4)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4758 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4759 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4760 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4759);
// compiled call node returning call4760 (depth = 6)
// compiled member node returning call4760 (depth = 5)
  gc_frame_newslot(call4760);
// starting to compile block node (depth = 5)
  Object block4761 = alloc_Block(NULL, NULL, "ast", 1079);
  gc_frame_newslot(block4761);
// method "_apply"
  block_savedest(block4761);
  Object closure4762 = createclosure(3, "_apply");
  setclosureframe(closure4762, stackframe);
  addtoclosure(closure4762, var_visitor);
  addtoclosure(closure4762, var_newChain);
  addtoclosure(closure4762, selfslot);
  struct UserObject *uo4762 = (struct UserObject*)block4761;
  uo4762->data[0] = (Object)closure4762;
  Method *meth_meth_ast__apply4762 = addmethod2pos(block4761, "_apply", &meth_ast__apply4762, 0);
  int argcv_meth_ast__apply4762[] = {1};
  meth_meth_ast__apply4762->type = alloc_MethodType(1, argcv_meth_ast__apply4762);
  meth_meth_ast__apply4762->definitionModule = modulename;
  meth_meth_ast__apply4762->definitionLine = 1079;
// compiled block node returning block4761 (depth = 5)
  gc_frame_newslot(block4761);
// call case 5: prelude request
  params[0] = call4760;
  params[1] = block4761;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4773 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4758);
// compiled call node returning call4773 (depth = 4)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4777 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4776);
// compiled call node returning call4777 (depth = 7)
// compiled member node returning call4777 (depth = 6)
  int op_slot_right_4775 = gc_frame_newslot(call4777);
// starting to compile identifier node (depth = 6)
  Object bool4779 = alloc_Boolean(0);
// compiled identifier node returning bool4779 (depth = 6)
  int op_slot_left_4775 = gc_frame_newslot(bool4779);
  params[0] = call4777;
  partcv[0] = 1;
  Object opresult4780 = callmethod(bool4779, "!=", 1, partcv, params);
// compiled op node returning opresult4780 (depth = 5)
  Object if4774 = done;
  if (istrue(opresult4780)) {
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4781 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4782 = alloc_Block(NULL, NULL, "ast", 1085);
  gc_frame_newslot(block4782);
// method "_apply"
  block_savedest(block4782);
  Object closure4783 = createclosure(3, "_apply");
  setclosureframe(closure4783, stackframe);
  addtoclosure(closure4783, var_visitor);
  addtoclosure(closure4783, var_newChain);
  addtoclosure(closure4783, selfslot);
  struct UserObject *uo4783 = (struct UserObject*)block4782;
  uo4783->data[0] = (Object)closure4783;
  Method *meth_meth_ast__apply4783 = addmethod2pos(block4782, "_apply", &meth_ast__apply4783, 0);
  int argcv_meth_ast__apply4783[] = {1};
  meth_meth_ast__apply4783->type = alloc_MethodType(1, argcv_meth_ast__apply4783);
  meth_meth_ast__apply4783->definitionModule = modulename;
  meth_meth_ast__apply4783->definitionLine = 1084;
// compiled block node returning block4782 (depth = 6)
  gc_frame_newslot(block4782);
// call case 6: other member request
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4788 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4787);
// compiled call node returning call4788 (depth = 7)
// compiled member node returning call4788 (depth = 6)
  params[0] = block4782;
  partcv[0] = 1;
  Object call4789 = callmethod(call4788, "do",
    1, partcv, params);
  gc_frame_end(callframe4781);
// compiled call node returning call4789 (depth = 5)
    gc_frame_newslot(call4789);
    if4774 = call4789;
  } else {
  }
// compiled if node returning if4774 (depth = 4)
    gc_frame_newslot(if4774);
    if4749 = if4774;
  } else {
  }
// compiled if node returning if4749 (depth = 3)
  gc_frame_end(frame);
  return if4749;
}
Object meth_ast_map_40__41_ancestors4790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4792 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4791);
// compiled call node returning call4792 (depth = 5)
// compiled member node returning call4792 (depth = 4)
  *var_n = call4792;
  if (call4792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4793 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4794 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe4793);
// compiled call node returning call4794 (depth = 4)
  *var_newChain = call4794;
  if (call4794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4795 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4796 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4798 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4797);
// compiled call node returning call4798 (depth = 6)
// compiled member node returning call4798 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4799 = callmethod(call4798, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe4796);
// compiled call node returning call4799 (depth = 4)
  gc_frame_newslot(call4799);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4799;
  partcv[0] = 1;
  Object call4800 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe4795);
// compiled call node returning call4800 (depth = 3)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4801 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4802 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4803 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4804 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4803);
// compiled call node returning call4804 (depth = 6)
// compiled member node returning call4804 (depth = 5)
  gc_frame_newslot(call4804);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4805 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4806 = gc_frame_new();
// call case 3: self.outer request
  Object call4807 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4806);
// compiled call node returning call4807 (depth = 8)
// compiled member node returning call4807 (depth = 7)
  partcv[0] = 0;
  Object call4808 = callmethodflags(call4807, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4805);
// compiled call node returning call4808 (depth = 6)
// compiled member node returning call4808 (depth = 5)
  params[0] = call4804;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4809 = callmethodflags(call4808, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4802);
// compiled call node returning call4809 (depth = 4)
  gc_frame_newslot(call4809);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4809;
  partcv[0] = 1;
  Object call4810 = callmethod(*var_n, "with:=",
    1, partcv, params);
  gc_frame_end(callframe4801);
// compiled call node returning call4810 (depth = 3)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4811 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4812 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4814 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4813);
// compiled call node returning call4814 (depth = 6)
// compiled member node returning call4814 (depth = 5)
  gc_frame_newslot(call4814);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4815 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4816 = gc_frame_new();
// call case 3: self.outer request
  Object call4817 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4816);
// compiled call node returning call4817 (depth = 8)
// compiled member node returning call4817 (depth = 7)
  partcv[0] = 0;
  Object call4818 = callmethodflags(call4817, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4815);
// compiled call node returning call4818 (depth = 6)
// compiled member node returning call4818 (depth = 5)
  params[0] = call4814;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4819 = callmethodflags(call4818, "maybeListMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4812);
// compiled call node returning call4819 (depth = 4)
  gc_frame_newslot(call4819);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4819;
  partcv[0] = 1;
  Object call4820 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe4811);
// compiled call node returning call4820 (depth = 3)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4821 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4822 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4821);
// compiled call node returning call4822 (depth = 3)
  gc_frame_end(frame);
  return call4822;
}
Object meth_ast__apply4831(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4833 == NULL) {
    strlit4833 = alloc_String("  ");
    gc_root(strlit4833);
  }
// compiled string node returning strlit4833 (depth = 7)
  int op_slot_right_4832 = gc_frame_newslot(strlit4833);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4832 = gc_frame_newslot(*var_spc);
  params[0] = strlit4833;
  partcv[0] = 1;
  Object opresult4835 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4835 (depth = 6)
  *var_spc = opresult4835;
  if (opresult4835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4894 == NULL) {
    strlit4894 = alloc_String("""\x0a""");
    gc_root(strlit4894);
  }
// compiled string node returning strlit4894 (depth = 8)
  int op_slot_right_4893 = gc_frame_newslot(strlit4894);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4897 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4899 = alloc_Float64(2);
// compiled num node returning num4899 (depth = 11)
  int op_slot_right_4898 = gc_frame_newslot(num4899);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4898 = gc_frame_newslot(*var_depth);
  params[0] = num4899;
  partcv[0] = 1;
  Object sum4901 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4901 (depth = 10)
  gc_frame_newslot(sum4901);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum4901;
  partcv[0] = 1;
  Object call4902 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4897);
// compiled call node returning call4902 (depth = 9)
  int op_slot_right_4896 = gc_frame_newslot(call4902);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4905 == NULL) {
    strlit4905 = alloc_String("    ");
    gc_root(strlit4905);
  }
// compiled string node returning strlit4905 (depth = 10)
  int op_slot_right_4904 = gc_frame_newslot(strlit4905);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4907 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4907 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4909 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4909 (depth = 10)
  int op_slot_left_4904 = gc_frame_newslot(opresult4909);
  params[0] = strlit4905;
  partcv[0] = 1;
  Object opresult4910 = callmethod(opresult4909, "++", 1, partcv, params);
// compiled op node returning opresult4910 (depth = 9)
  int op_slot_left_4896 = gc_frame_newslot(opresult4910);
  params[0] = call4902;
  partcv[0] = 1;
  Object opresult4911 = callmethod(opresult4910, "++", 1, partcv, params);
// compiled op node returning opresult4911 (depth = 8)
  int op_slot_left_4893 = gc_frame_newslot(opresult4911);
  params[0] = strlit4894;
  partcv[0] = 1;
  Object opresult4912 = callmethod(opresult4911, "++", 1, partcv, params);
// compiled op node returning opresult4912 (depth = 7)
  *var_s = opresult4912;
  if (opresult4912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4950(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4952 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4954 = alloc_Float64(2);
// compiled num node returning num4954 (depth = 11)
  int op_slot_right_4953 = gc_frame_newslot(num4954);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4953 = gc_frame_newslot(*var_depth);
  params[0] = num4954;
  partcv[0] = 1;
  Object sum4956 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4956 (depth = 10)
  gc_frame_newslot(sum4956);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  params[0] = sum4956;
  partcv[0] = 1;
  Object call4957 = callmethod(*var_arg, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4952);
// compiled call node returning call4957 (depth = 9)
  int op_slot_right_4951 = gc_frame_newslot(call4957);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4959 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4962 == NULL) {
    strlit4962 = alloc_String("""\x0a""      ");
    gc_root(strlit4962);
  }
// compiled string node returning strlit4962 (depth = 11)
  int op_slot_right_4961 = gc_frame_newslot(strlit4962);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4961 = gc_frame_newslot(*var_s);
  params[0] = strlit4962;
  partcv[0] = 1;
  Object opresult4964 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4964 (depth = 10)
  int op_slot_left_4959 = gc_frame_newslot(opresult4964);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4965 = callmethod(opresult4964, "++", 1, partcv, params);
// compiled op node returning opresult4965 (depth = 9)
  int op_slot_left_4951 = gc_frame_newslot(opresult4965);
  params[0] = call4957;
  partcv[0] = 1;
  Object opresult4966 = callmethod(opresult4965, "++", 1, partcv, params);
// compiled op node returning opresult4966 (depth = 8)
  *var_s = opresult4966;
  if (opresult4966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4928(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4931 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4930);
// compiled call node returning call4931 (depth = 8)
// compiled member node returning call4931 (depth = 7)
  int op_slot_right_4929 = gc_frame_newslot(call4931);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4934 == NULL) {
    strlit4934 = alloc_String("Part: ");
    gc_root(strlit4934);
  }
// compiled string node returning strlit4934 (depth = 8)
  int op_slot_right_4933 = gc_frame_newslot(strlit4934);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4936 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4939 == NULL) {
    strlit4939 = alloc_String("""\x0a""  ");
    gc_root(strlit4939);
  }
// compiled string node returning strlit4939 (depth = 10)
  int op_slot_right_4938 = gc_frame_newslot(strlit4939);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4938 = gc_frame_newslot(*var_s);
  params[0] = strlit4939;
  partcv[0] = 1;
  Object opresult4941 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4941 (depth = 9)
  int op_slot_left_4936 = gc_frame_newslot(opresult4941);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4942 = callmethod(opresult4941, "++", 1, partcv, params);
// compiled op node returning opresult4942 (depth = 8)
  int op_slot_left_4933 = gc_frame_newslot(opresult4942);
  params[0] = strlit4934;
  partcv[0] = 1;
  Object opresult4943 = callmethod(opresult4942, "++", 1, partcv, params);
// compiled op node returning opresult4943 (depth = 7)
  int op_slot_left_4929 = gc_frame_newslot(opresult4943);
  params[0] = call4931;
  partcv[0] = 1;
  Object opresult4944 = callmethod(opresult4943, "++", 1, partcv, params);
// compiled op node returning opresult4944 (depth = 6)
  *var_s = opresult4944;
  if (opresult4944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4946 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4948 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4947);
// compiled call node returning call4948 (depth = 7)
// compiled member node returning call4948 (depth = 6)
  gc_frame_newslot(call4948);
// starting to compile block node (depth = 6)
  Object block4949 = alloc_Block(NULL, NULL, "ast", 1116);
  gc_frame_newslot(block4949);
// method "_apply"
  block_savedest(block4949);
  Object closure4950 = createclosure(4, "_apply");
  setclosureframe(closure4950, stackframe);
  addtoclosure(closure4950, var_depth);
  addtoclosure(closure4950, var_spc);
  addtoclosure(closure4950, var_s);
  addtoclosure(closure4950, selfslot);
  struct UserObject *uo4950 = (struct UserObject*)block4949;
  uo4950->data[0] = (Object)closure4950;
  Method *meth_meth_ast__apply4950 = addmethod2pos(block4949, "_apply", &meth_ast__apply4950, 0);
  int argcv_meth_ast__apply4950[] = {1};
  meth_meth_ast__apply4950->type = alloc_MethodType(1, argcv_meth_ast__apply4950);
  meth_meth_ast__apply4950->definitionModule = modulename;
  meth_meth_ast__apply4950->definitionLine = 1116;
// compiled block node returning block4949 (depth = 6)
  gc_frame_newslot(block4949);
// call case 5: prelude request
  params[0] = call4948;
  params[1] = block4949;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4969 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4946);
// compiled call node returning call4969 (depth = 5)
  gc_frame_end(frame);
  return call4969;
}
Object meth_ast_pretty4823(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4824 == NULL) {
    strlit4824 = alloc_String("");
    gc_root(strlit4824);
  }
// compiled string node returning strlit4824 (depth = 4)
  *var_spc = strlit4824;
  if (strlit4824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4825 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4826 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num4828 = alloc_Float64(0);
// compiled num node returning num4828 (depth = 5)
  int op_slot_left_4826 = gc_frame_newslot(num4828);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4829 = callmethod(num4828, "..", 1, partcv, params);
// compiled op node returning opresult4829 (depth = 4)
  gc_frame_newslot(opresult4829);
// starting to compile block node (depth = 4)
  Object block4830 = alloc_Block(NULL, NULL, "ast", 1101);
  gc_frame_newslot(block4830);
// method "_apply"
  block_savedest(block4830);
  Object closure4831 = createclosure(2, "_apply");
  setclosureframe(closure4831, stackframe);
  addtoclosure(closure4831, var_spc);
  addtoclosure(closure4831, selfslot);
  struct UserObject *uo4831 = (struct UserObject*)block4830;
  uo4831->data[0] = (Object)closure4831;
  Method *meth_meth_ast__apply4831 = addmethod2pos(block4830, "_apply", &meth_ast__apply4831, 0);
  int argcv_meth_ast__apply4831[] = {1};
  meth_meth_ast__apply4831->type = alloc_MethodType(1, argcv_meth_ast__apply4831);
  meth_meth_ast__apply4831->definitionModule = modulename;
  meth_meth_ast__apply4831->definitionLine = 1096;
// compiled block node returning block4830 (depth = 4)
  gc_frame_newslot(block4830);
// call case 5: prelude request
  params[0] = opresult4829;
  params[1] = block4830;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4838 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4825);
// compiled call node returning call4838 (depth = 3)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String("""\x0a""");
    gc_root(strlit4840);
  }
// compiled string node returning strlit4840 (depth = 5)
  int op_slot_right_4839 = gc_frame_newslot(strlit4840);
// starting to compile call node (depth = 5)
  int callframe4842 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4843 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4842);
// compiled call node returning call4843 (depth = 5)
  int op_slot_left_4839 = gc_frame_newslot(call4843);
  params[0] = strlit4840;
  partcv[0] = 1;
  Object opresult4844 = callmethod(call4843, "++", 1, partcv, params);
// compiled op node returning opresult4844 (depth = 4)
  *var_s = opresult4844;
  if (opresult4844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4847 == NULL) {
    strlit4847 = alloc_String("");
    gc_root(strlit4847);
  }
// compiled string node returning strlit4847 (depth = 6)
  int op_slot_right_4846 = gc_frame_newslot(strlit4847);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4850 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4852 = alloc_Float64(1);
// compiled num node returning num4852 (depth = 9)
  int op_slot_right_4851 = gc_frame_newslot(num4852);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4851 = gc_frame_newslot(*var_depth);
  params[0] = num4852;
  partcv[0] = 1;
  Object sum4854 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4854 (depth = 8)
  gc_frame_newslot(sum4854);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4856 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4855);
// compiled call node returning call4856 (depth = 9)
// compiled member node returning call4856 (depth = 8)
  params[0] = sum4854;
  partcv[0] = 1;
  Object call4857 = callmethod(call4856, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4850);
// compiled call node returning call4857 (depth = 7)
  int op_slot_right_4849 = gc_frame_newslot(call4857);
// starting to compile string node (depth = 7)
  if (strlit4859 == NULL) {
    strlit4859 = alloc_String("Method Name: ");
    gc_root(strlit4859);
  }
// compiled string node returning strlit4859 (depth = 7)
  int op_slot_left_4849 = gc_frame_newslot(strlit4859);
  params[0] = call4857;
  partcv[0] = 1;
  Object opresult4860 = callmethod(strlit4859, "++", 1, partcv, params);
// compiled op node returning opresult4860 (depth = 6)
  int op_slot_left_4846 = gc_frame_newslot(opresult4860);
  params[0] = strlit4847;
  partcv[0] = 1;
  Object opresult4861 = callmethod(opresult4860, "++", 1, partcv, params);
// compiled op node returning opresult4861 (depth = 5)
  int op_slot_right_4845 = gc_frame_newslot(opresult4861);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4863 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4863 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4865 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4865 (depth = 5)
  int op_slot_left_4845 = gc_frame_newslot(opresult4865);
  params[0] = opresult4861;
  partcv[0] = 1;
  Object opresult4866 = callmethod(opresult4865, "++", 1, partcv, params);
// compiled op node returning opresult4866 (depth = 4)
  *var_s = opresult4866;
  if (opresult4866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4869 == NULL) {
    strlit4869 = alloc_String("""\x0a""");
    gc_root(strlit4869);
  }
// compiled string node returning strlit4869 (depth = 5)
  int op_slot_right_4868 = gc_frame_newslot(strlit4869);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4868 = gc_frame_newslot(*var_s);
  params[0] = strlit4869;
  partcv[0] = 1;
  Object opresult4871 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4871 (depth = 4)
  *var_s = opresult4871;
  if (opresult4871 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4876 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4875);
// compiled call node returning call4876 (depth = 6)
// compiled member node returning call4876 (depth = 5)
  int op_slot_right_4874 = gc_frame_newslot(call4876);
// starting to compile identifier node (depth = 5)
  Object bool4878 = alloc_Boolean(0);
// compiled identifier node returning bool4878 (depth = 5)
  int op_slot_left_4874 = gc_frame_newslot(bool4878);
  params[0] = call4876;
  partcv[0] = 1;
  Object opresult4879 = callmethod(bool4878, "!=", 1, partcv, params);
// compiled op node returning opresult4879 (depth = 4)
  Object if4873 = done;
  if (istrue(opresult4879)) {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4881 == NULL) {
    strlit4881 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit4881);
  }
// compiled string node returning strlit4881 (depth = 6)
  int op_slot_right_4880 = gc_frame_newslot(strlit4881);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4883 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4883 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4885 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4885 (depth = 6)
  int op_slot_left_4880 = gc_frame_newslot(opresult4885);
  params[0] = strlit4881;
  partcv[0] = 1;
  Object opresult4886 = callmethod(opresult4885, "++", 1, partcv, params);
// compiled op node returning opresult4886 (depth = 5)
  *var_s = opresult4886;
  if (opresult4886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4888 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4889 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4890 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4889);
// compiled call node returning call4890 (depth = 6)
// compiled member node returning call4890 (depth = 5)
  gc_frame_newslot(call4890);
// starting to compile block node (depth = 5)
  Object block4891 = alloc_Block(NULL, NULL, "ast", 1109);
  gc_frame_newslot(block4891);
// method "_apply"
  block_savedest(block4891);
  Object closure4892 = createclosure(4, "_apply");
  setclosureframe(closure4892, stackframe);
  addtoclosure(closure4892, var_depth);
  addtoclosure(closure4892, var_spc);
  addtoclosure(closure4892, var_s);
  addtoclosure(closure4892, selfslot);
  struct UserObject *uo4892 = (struct UserObject*)block4891;
  uo4892->data[0] = (Object)closure4892;
  Method *meth_meth_ast__apply4892 = addmethod2pos(block4891, "_apply", &meth_ast__apply4892, 0);
  int argcv_meth_ast__apply4892[] = {1};
  meth_meth_ast__apply4892->type = alloc_MethodType(1, argcv_meth_ast__apply4892);
  meth_meth_ast__apply4892->definitionModule = modulename;
  meth_meth_ast__apply4892->definitionLine = 1109;
// compiled block node returning block4891 (depth = 5)
  gc_frame_newslot(block4891);
// call case 5: prelude request
  params[0] = call4890;
  params[1] = block4891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4915 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4888);
// compiled call node returning call4915 (depth = 4)
    gc_frame_newslot(call4915);
    if4873 = call4915;
  } else {
  }
// compiled if node returning if4873 (depth = 3)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4917 == NULL) {
    strlit4917 = alloc_String("Arguments:");
    gc_root(strlit4917);
  }
// compiled string node returning strlit4917 (depth = 5)
  int op_slot_right_4916 = gc_frame_newslot(strlit4917);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4919 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4919 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4921 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4921 (depth = 5)
  int op_slot_left_4916 = gc_frame_newslot(opresult4921);
  params[0] = strlit4917;
  partcv[0] = 1;
  Object opresult4922 = callmethod(opresult4921, "++", 1, partcv, params);
// compiled op node returning opresult4922 (depth = 4)
  *var_s = opresult4922;
  if (opresult4922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4924 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4926 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4925);
// compiled call node returning call4926 (depth = 5)
// compiled member node returning call4926 (depth = 4)
  gc_frame_newslot(call4926);
// starting to compile block node (depth = 4)
  Object block4927 = alloc_Block(NULL, NULL, "ast", 1114);
  gc_frame_newslot(block4927);
// method "_apply"
  block_savedest(block4927);
  Object closure4928 = createclosure(4, "_apply");
  setclosureframe(closure4928, stackframe);
  addtoclosure(closure4928, var_spc);
  addtoclosure(closure4928, var_s);
  addtoclosure(closure4928, var_depth);
  addtoclosure(closure4928, selfslot);
  struct UserObject *uo4928 = (struct UserObject*)block4927;
  uo4928->data[0] = (Object)closure4928;
  Method *meth_meth_ast__apply4928 = addmethod2pos(block4927, "_apply", &meth_ast__apply4928, 0);
  int argcv_meth_ast__apply4928[] = {1};
  meth_meth_ast__apply4928->type = alloc_MethodType(1, argcv_meth_ast__apply4928);
  meth_meth_ast__apply4928->definitionModule = modulename;
  meth_meth_ast__apply4928->definitionLine = 1114;
// compiled block node returning block4927 (depth = 4)
  gc_frame_newslot(block4927);
// call case 5: prelude request
  params[0] = call4926;
  params[1] = block4927;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4971 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4924);
// compiled call node returning call4971 (depth = 3)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4976(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4978 == NULL) {
    strlit4978 = alloc_String("    ");
    gc_root(strlit4978);
  }
// compiled string node returning strlit4978 (depth = 7)
  int op_slot_right_4977 = gc_frame_newslot(strlit4978);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4977 = gc_frame_newslot(*var_spc);
  params[0] = strlit4978;
  partcv[0] = 1;
  Object opresult4980 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4980 (depth = 6)
  *var_spc = opresult4980;
  if (opresult4980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5073(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool5075 = alloc_Boolean(0);
// compiled identifier node returning bool5075 (depth = 9)
  int op_slot_right_5074 = gc_frame_newslot(bool5075);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5077 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5078 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5077);
// compiled call node returning call5078 (depth = 10)
// compiled member node returning call5078 (depth = 9)
  int op_slot_left_5074 = gc_frame_newslot(call5078);
  params[0] = bool5075;
  partcv[0] = 1;
  Object opresult5079 = callmethod(call5078, "!=", 1, partcv, params);
// compiled op node returning opresult5079 (depth = 8)
  gc_frame_end(frame);
  return opresult5079;
}
Object meth_ast__apply5101(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5103 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num5105 = alloc_Float64(1);
// compiled num node returning num5105 (depth = 12)
  int op_slot_right_5104 = gc_frame_newslot(num5105);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_5104 = gc_frame_newslot(*var_depth);
  params[0] = num5105;
  partcv[0] = 1;
  Object sum5107 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5107 (depth = 11)
  gc_frame_newslot(sum5107);
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe5108 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ix (depth = 12)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5110 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5109);
// compiled call node returning call5110 (depth = 13)
// compiled member node returning call5110 (depth = 12)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call5111 = callmethod(call5110, "at",
    1, partcv, params);
  gc_frame_end(callframe5108);
// compiled call node returning call5111 (depth = 11)
  params[0] = sum5107;
  partcv[0] = 1;
  Object call5112 = callmethod(call5111, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5103);
// compiled call node returning call5112 (depth = 10)
  int op_slot_right_5102 = gc_frame_newslot(call5112);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5102 = gc_frame_newslot(*var_s);
  params[0] = call5112;
  partcv[0] = 1;
  Object opresult5114 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5114 (depth = 9)
  *var_s = opresult5114;
  if (opresult5114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5158(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_anr = &(stackframe->slots[0]);
  *var_anr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "arg");
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 9)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call5160 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5159);
// compiled call node returning call5160 (depth = 11)
// compiled member node returning call5160 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_anr (depth = 10)
  params[0] = *var_anr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5161 = callmethod(call5160, "[]", 1, partcv, params);
// compiled index node returning idxres5161 (depth = 9)
  *var_arg = idxres5161;
  if (idxres5161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5163 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num5165 = alloc_Float64(1);
// compiled num node returning num5165 (depth = 12)
  int op_slot_right_5164 = gc_frame_newslot(num5165);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_5164 = gc_frame_newslot(*var_depth);
  params[0] = num5165;
  partcv[0] = 1;
  Object sum5167 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5167 (depth = 11)
  gc_frame_newslot(sum5167);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  params[0] = sum5167;
  partcv[0] = 1;
  Object call5168 = callmethod(*var_arg, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5163);
// compiled call node returning call5168 (depth = 10)
  int op_slot_right_5162 = gc_frame_newslot(call5168);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5162 = gc_frame_newslot(*var_s);
  params[0] = call5168;
  partcv[0] = 1;
  Object opresult5170 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5170 (depth = 9)
  *var_s = opresult5170;
  if (opresult5170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5174 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call5176 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5175);
// compiled call node returning call5176 (depth = 13)
// compiled member node returning call5176 (depth = 12)
  partcv[0] = 0;
  Object call5177 = callmethod(call5176, "size",
    1, partcv, params);
  gc_frame_end(callframe5174);
// compiled call node returning call5177 (depth = 11)
// compiled member node returning call5177 (depth = 10)
  int op_slot_right_5173 = gc_frame_newslot(call5177);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_anr (depth = 10)
  int op_slot_left_5173 = gc_frame_newslot(*var_anr);
  params[0] = call5177;
  partcv[0] = 1;
  Object opresult5179 = callmethod(*var_anr, "<", 1, partcv, params);
// compiled op node returning opresult5179 (depth = 9)
  Object if5172 = done;
  if (istrue(opresult5179)) {
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5181 == NULL) {
    strlit5181 = alloc_String(", ");
    gc_root(strlit5181);
  }
// compiled string node returning strlit5181 (depth = 11)
  int op_slot_right_5180 = gc_frame_newslot(strlit5181);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5180 = gc_frame_newslot(*var_s);
  params[0] = strlit5181;
  partcv[0] = 1;
  Object opresult5183 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5183 (depth = 10)
  *var_s = opresult5183;
  if (opresult5183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if5172 = done;
  } else {
  }
// compiled if node returning if5172 (depth = 8)
  gc_frame_end(frame);
  return if5172;
}
Object meth_ast__apply5063(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call5066 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe5065);
// compiled call node returning call5066 (depth = 8)
// compiled member node returning call5066 (depth = 7)
  int op_slot_right_5064 = gc_frame_newslot(call5066);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5064 = gc_frame_newslot(*var_s);
  params[0] = call5066;
  partcv[0] = 1;
  Object opresult5068 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5068 (depth = 6)
  *var_s = opresult5068;
  if (opresult5068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5071 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5072 = alloc_Block(NULL, NULL, "ast", 1144);
  gc_frame_newslot(block5072);
// method "_apply"
  block_savedest(block5072);
  Object closure5073 = createclosure(1, "_apply");
  setclosureframe(closure5073, stackframe);
  addtoclosure(closure5073, selfslot);
  struct UserObject *uo5073 = (struct UserObject*)block5072;
  uo5073->data[0] = (Object)closure5073;
  Method *meth_meth_ast__apply5073 = addmethod2pos(block5072, "_apply", &meth_ast__apply5073, 0);
  int argcv_meth_ast__apply5073[] = {0};
  meth_meth_ast__apply5073->type = alloc_MethodType(1, argcv_meth_ast__apply5073);
  meth_meth_ast__apply5073->definitionModule = modulename;
  meth_meth_ast__apply5073->definitionLine = 1143;
// compiled block node returning block5072 (depth = 7)
  gc_frame_newslot(block5072);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  params[0] = block5072;
  partcv[0] = 1;
  Object call5081 = callmethod(*var_firstPart, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5071);
// compiled call node returning call5081 (depth = 6)
  Object if5070 = done;
  if (istrue(call5081)) {
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5083 == NULL) {
    strlit5083 = alloc_String("<");
    gc_root(strlit5083);
  }
// compiled string node returning strlit5083 (depth = 8)
  int op_slot_right_5082 = gc_frame_newslot(strlit5083);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5082 = gc_frame_newslot(*var_s);
  params[0] = strlit5083;
  partcv[0] = 1;
  Object opresult5085 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5085 (depth = 7)
  *var_s = opresult5085;
  if (opresult5085 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5087 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5090 = alloc_Float64(1);
// compiled num node returning num5090 (depth = 9)
  int op_slot_right_5089 = gc_frame_newslot(num5090);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5092 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5093 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5094 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5093);
// compiled call node returning call5094 (depth = 12)
// compiled member node returning call5094 (depth = 11)
  partcv[0] = 0;
  Object call5095 = callmethod(call5094, "size",
    1, partcv, params);
  gc_frame_end(callframe5092);
// compiled call node returning call5095 (depth = 10)
// compiled member node returning call5095 (depth = 9)
  int op_slot_left_5089 = gc_frame_newslot(call5095);
  params[0] = num5090;
  partcv[0] = 1;
  Object diff5096 = callmethod(call5095, "-", 1, partcv, params);
// compiled op node returning diff5096 (depth = 8)
  int op_slot_right_5088 = gc_frame_newslot(diff5096);
// starting to compile num node (depth = 8)
  Object num5098 = alloc_Float64(1);
// compiled num node returning num5098 (depth = 8)
  int op_slot_left_5088 = gc_frame_newslot(num5098);
  params[0] = diff5096;
  partcv[0] = 1;
  Object opresult5099 = callmethod(num5098, "..", 1, partcv, params);
// compiled op node returning opresult5099 (depth = 7)
  gc_frame_newslot(opresult5099);
// starting to compile block node (depth = 7)
  Object block5100 = alloc_Block(NULL, NULL, "ast", 1146);
  gc_frame_newslot(block5100);
// method "_apply"
  block_savedest(block5100);
  Object closure5101 = createclosure(3, "_apply");
  setclosureframe(closure5101, stackframe);
  addtoclosure(closure5101, var_depth);
  addtoclosure(closure5101, var_s);
  addtoclosure(closure5101, selfslot);
  struct UserObject *uo5101 = (struct UserObject*)block5100;
  uo5101->data[0] = (Object)closure5101;
  Method *meth_meth_ast__apply5101 = addmethod2pos(block5100, "_apply", &meth_ast__apply5101, 0);
  int argcv_meth_ast__apply5101[] = {1};
  meth_meth_ast__apply5101->type = alloc_MethodType(1, argcv_meth_ast__apply5101);
  meth_meth_ast__apply5101->definitionModule = modulename;
  meth_meth_ast__apply5101->definitionLine = 1146;
// compiled block node returning block5100 (depth = 7)
  gc_frame_newslot(block5100);
// call case 5: prelude request
  params[0] = opresult5099;
  params[1] = block5100;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5117 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5087);
// compiled call node returning call5117 (depth = 6)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5119 == NULL) {
    strlit5119 = alloc_String(">");
    gc_root(strlit5119);
  }
// compiled string node returning strlit5119 (depth = 8)
  int op_slot_right_5118 = gc_frame_newslot(strlit5119);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5122 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5124 = alloc_Float64(1);
// compiled num node returning num5124 (depth = 11)
  int op_slot_right_5123 = gc_frame_newslot(num5124);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5123 = gc_frame_newslot(*var_depth);
  params[0] = num5124;
  partcv[0] = 1;
  Object sum5126 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5126 (depth = 10)
  gc_frame_newslot(sum5126);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5127 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5129 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5128);
// compiled call node returning call5129 (depth = 13)
// compiled member node returning call5129 (depth = 12)
  partcv[0] = 0;
  Object call5130 = callmethod(call5129, "last",
    1, partcv, params);
  gc_frame_end(callframe5127);
// compiled call node returning call5130 (depth = 11)
// compiled member node returning call5130 (depth = 10)
  params[0] = sum5126;
  partcv[0] = 1;
  Object call5131 = callmethod(call5130, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5122);
// compiled call node returning call5131 (depth = 9)
  int op_slot_right_5121 = gc_frame_newslot(call5131);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5121 = gc_frame_newslot(*var_s);
  params[0] = call5131;
  partcv[0] = 1;
  Object opresult5133 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5133 (depth = 8)
  int op_slot_left_5118 = gc_frame_newslot(opresult5133);
  params[0] = strlit5119;
  partcv[0] = 1;
  Object opresult5134 = callmethod(opresult5133, "++", 1, partcv, params);
// compiled op node returning opresult5134 (depth = 7)
  *var_s = opresult5134;
  if (opresult5134 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5070 = done;
  } else {
  }
// compiled if node returning if5070 (depth = 5)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5136 = alloc_Boolean(0);
// compiled identifier node returning bool5136 (depth = 6)
  *var_firstPart = bool5136;
  if (bool5136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5140 = alloc_Float64(0);
// compiled num node returning num5140 (depth = 7)
  int op_slot_right_5139 = gc_frame_newslot(num5140);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5142 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5143 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5144 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5143);
// compiled call node returning call5144 (depth = 10)
// compiled member node returning call5144 (depth = 9)
  partcv[0] = 0;
  Object call5145 = callmethod(call5144, "size",
    1, partcv, params);
  gc_frame_end(callframe5142);
// compiled call node returning call5145 (depth = 8)
// compiled member node returning call5145 (depth = 7)
  int op_slot_left_5139 = gc_frame_newslot(call5145);
  params[0] = num5140;
  partcv[0] = 1;
  Object opresult5146 = callmethod(call5145, ">", 1, partcv, params);
// compiled op node returning opresult5146 (depth = 6)
  Object if5138 = done;
  if (istrue(opresult5146)) {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5148 == NULL) {
    strlit5148 = alloc_String("(");
    gc_root(strlit5148);
  }
// compiled string node returning strlit5148 (depth = 8)
  int op_slot_right_5147 = gc_frame_newslot(strlit5148);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5147 = gc_frame_newslot(*var_s);
  params[0] = strlit5148;
  partcv[0] = 1;
  Object opresult5150 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5150 (depth = 7)
  *var_s = opresult5150;
  if (opresult5150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5152 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5153 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5155 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5154);
// compiled call node returning call5155 (depth = 10)
// compiled member node returning call5155 (depth = 9)
  partcv[0] = 0;
  Object call5156 = callmethod(call5155, "indices",
    1, partcv, params);
  gc_frame_end(callframe5153);
// compiled call node returning call5156 (depth = 8)
// compiled member node returning call5156 (depth = 7)
  gc_frame_newslot(call5156);
// starting to compile block node (depth = 7)
  Object block5157 = alloc_Block(NULL, NULL, "ast", 1154);
  gc_frame_newslot(block5157);
// method "_apply"
  block_savedest(block5157);
  Object closure5158 = createclosure(4, "_apply");
  setclosureframe(closure5158, stackframe);
  addtoclosure(closure5158, var_part);
  addtoclosure(closure5158, var_depth);
  addtoclosure(closure5158, var_s);
  addtoclosure(closure5158, selfslot);
  struct UserObject *uo5158 = (struct UserObject*)block5157;
  uo5158->data[0] = (Object)closure5158;
  Method *meth_meth_ast__apply5158 = addmethod2pos(block5157, "_apply", &meth_ast__apply5158, 0);
  int argcv_meth_ast__apply5158[] = {1};
  meth_meth_ast__apply5158->type = alloc_MethodType(1, argcv_meth_ast__apply5158);
  meth_meth_ast__apply5158->definitionModule = modulename;
  meth_meth_ast__apply5158->definitionLine = 1154;
// compiled block node returning block5157 (depth = 7)
  gc_frame_newslot(block5157);
// call case 5: prelude request
  params[0] = call5156;
  params[1] = block5157;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5186 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compiled call node returning call5186 (depth = 6)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5188 == NULL) {
    strlit5188 = alloc_String(")");
    gc_root(strlit5188);
  }
// compiled string node returning strlit5188 (depth = 8)
  int op_slot_right_5187 = gc_frame_newslot(strlit5188);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5187 = gc_frame_newslot(*var_s);
  params[0] = strlit5188;
  partcv[0] = 1;
  Object opresult5190 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5190 (depth = 7)
  *var_s = opresult5190;
  if (opresult5190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5138 = done;
  } else {
  }
// compiled if node returning if5138 (depth = 5)
  gc_frame_end(frame);
  return if5138;
}
Object meth_ast_toGrace4972(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_member = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "member");
  Object *var_firstPart = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "firstPart");
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4973 == NULL) {
    strlit4973 = alloc_String("");
    gc_root(strlit4973);
  }
// compiled string node returning strlit4973 (depth = 4)
  *var_spc = strlit4973;
  if (strlit4973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4974 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block4975 = alloc_Block(NULL, NULL, "ast", 1124);
  gc_frame_newslot(block4975);
// method "_apply"
  block_savedest(block4975);
  Object closure4976 = createclosure(2, "_apply");
  setclosureframe(closure4976, stackframe);
  addtoclosure(closure4976, var_spc);
  addtoclosure(closure4976, selfslot);
  struct UserObject *uo4976 = (struct UserObject*)block4975;
  uo4976->data[0] = (Object)closure4976;
  Method *meth_meth_ast__apply4976 = addmethod2pos(block4975, "_apply", &meth_ast__apply4976, 0);
  int argcv_meth_ast__apply4976[] = {0};
  meth_meth_ast__apply4976->type = alloc_MethodType(1, argcv_meth_ast__apply4976);
  meth_meth_ast__apply4976->definitionModule = modulename;
  meth_meth_ast__apply4976->definitionLine = 1116;
// compiled block node returning block4975 (depth = 4)
  gc_frame_newslot(block4975);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block4975;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4983 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4974);
// compiled call node returning call4983 (depth = 3)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4984 == NULL) {
    strlit4984 = alloc_String("");
    gc_root(strlit4984);
  }
// compiled string node returning strlit4984 (depth = 4)
  *var_s = strlit4984;
  if (strlit4984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4987 == NULL) {
    strlit4987 = alloc_String("member");
    gc_root(strlit4987);
  }
// compiled string node returning strlit4987 (depth = 5)
  int op_slot_right_4986 = gc_frame_newslot(strlit4987);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4989 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4990 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4991 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4990);
// compiled call node returning call4991 (depth = 8)
// compiled member node returning call4991 (depth = 7)
  partcv[0] = 0;
  Object call4992 = callmethod(call4991, "kind",
    1, partcv, params);
  gc_frame_end(callframe4989);
// compiled call node returning call4992 (depth = 6)
// compiled member node returning call4992 (depth = 5)
  int op_slot_left_4986 = gc_frame_newslot(call4992);
  params[0] = strlit4987;
  partcv[0] = 1;
  Object opresult4993 = callmethod(call4992, "==", 1, partcv, params);
// compiled op node returning opresult4993 (depth = 4)
  Object if4985 = done;
  if (istrue(opresult4993)) {
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4995 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4994);
// compiled call node returning call4995 (depth = 6)
// compiled member node returning call4995 (depth = 5)
  *var_member = call4995;
  if (call4995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4998 == NULL) {
    strlit4998 = alloc_String("prefix");
    gc_root(strlit4998);
  }
// compiled string node returning strlit4998 (depth = 6)
  int op_slot_right_4997 = gc_frame_newslot(strlit4998);
// starting to compile call node (depth = 6)
  int callframe5000 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num5001 = alloc_Float64(1);
// compiled num node returning num5001 (depth = 7)
  gc_frame_newslot(num5001);
// starting to compile num node (depth = 7)
  Object num5002 = alloc_Float64(6);
// compiled num node returning num5002 (depth = 7)
  gc_frame_newslot(num5002);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call5004 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe5003);
// compiled call node returning call5004 (depth = 8)
// compiled member node returning call5004 (depth = 7)
  params[0] = num5001;
  params[1] = num5002;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5005 = callmethod(call5004, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe5000);
// compiled call node returning call5005 (depth = 6)
  int op_slot_left_4997 = gc_frame_newslot(call5005);
  params[0] = strlit4998;
  partcv[0] = 1;
  Object opresult5006 = callmethod(call5005, "==", 1, partcv, params);
// compiled op node returning opresult5006 (depth = 5)
  Object if4996 = done;
  if (istrue(opresult5006)) {
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5007 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num5008 = alloc_Float64(7);
// compiled num node returning num5008 (depth = 7)
  gc_frame_newslot(num5008);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5009 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call5011 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe5010);
// compiled call node returning call5011 (depth = 10)
// compiled member node returning call5011 (depth = 9)
  partcv[0] = 0;
  Object call5012 = callmethod(call5011, "size",
    1, partcv, params);
  gc_frame_end(callframe5009);
// compiled call node returning call5012 (depth = 8)
// compiled member node returning call5012 (depth = 7)
  gc_frame_newslot(call5012);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call5014 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe5013);
// compiled call node returning call5014 (depth = 8)
// compiled member node returning call5014 (depth = 7)
  params[0] = num5008;
  params[1] = call5012;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5015 = callmethod(call5014, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe5007);
// compiled call node returning call5015 (depth = 6)
  *var_s = call5015;
  if (call5015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5018 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5019 = alloc_Float64(0);
// compiled num node returning num5019 (depth = 8)
  gc_frame_newslot(num5019);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_member (depth = 10)
  partcv[0] = 0;
  Object call5021 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe5020);
// compiled call node returning call5021 (depth = 9)
// compiled member node returning call5021 (depth = 8)
  params[0] = num5019;
  partcv[0] = 1;
  Object call5022 = callmethod(call5021, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5018);
// compiled call node returning call5022 (depth = 7)
  int op_slot_right_5017 = gc_frame_newslot(call5022);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5017 = gc_frame_newslot(*var_s);
  params[0] = call5022;
  partcv[0] = 1;
  Object opresult5024 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5024 (depth = 6)
  return opresult5024;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4996 = undefined;
  } else {
  }
// compiled if node returning if4996 (depth = 4)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5026 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5027 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call5028 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe5027);
// compiled call node returning call5028 (depth = 8)
// compiled member node returning call5028 (depth = 7)
  partcv[0] = 0;
  Object call5029 = callmethod(call5028, "isSimple",
    1, partcv, params);
  gc_frame_end(callframe5026);
// compiled call node returning call5029 (depth = 6)
// compiled member node returning call5029 (depth = 5)
  Object if5025 = done;
  if (istrue(call5029)) {
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5031 == NULL) {
    strlit5031 = alloc_String(".");
    gc_root(strlit5031);
  }
// compiled string node returning strlit5031 (depth = 7)
  int op_slot_right_5030 = gc_frame_newslot(strlit5031);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5034 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num5035 = alloc_Float64(0);
// compiled num node returning num5035 (depth = 9)
  gc_frame_newslot(num5035);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5036 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call5037 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe5036);
// compiled call node returning call5037 (depth = 10)
// compiled member node returning call5037 (depth = 9)
  params[0] = num5035;
  partcv[0] = 1;
  Object call5038 = callmethod(call5037, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5034);
// compiled call node returning call5038 (depth = 8)
  int op_slot_right_5033 = gc_frame_newslot(call5038);
// starting to compile string node (depth = 8)
  if (strlit5040 == NULL) {
    strlit5040 = alloc_String("");
    gc_root(strlit5040);
  }
// compiled string node returning strlit5040 (depth = 8)
  int op_slot_left_5033 = gc_frame_newslot(strlit5040);
  params[0] = call5038;
  partcv[0] = 1;
  Object opresult5041 = callmethod(strlit5040, "++", 1, partcv, params);
// compiled op node returning opresult5041 (depth = 7)
  int op_slot_left_5030 = gc_frame_newslot(opresult5041);
  params[0] = strlit5031;
  partcv[0] = 1;
  Object opresult5042 = callmethod(opresult5041, "++", 1, partcv, params);
// compiled op node returning opresult5042 (depth = 6)
  *var_s = opresult5042;
  if (opresult5042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5025 = done;
  } else {
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5045 == NULL) {
    strlit5045 = alloc_String(").");
    gc_root(strlit5045);
  }
// compiled string node returning strlit5045 (depth = 7)
  int op_slot_right_5044 = gc_frame_newslot(strlit5045);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5048 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num5049 = alloc_Float64(0);
// compiled num node returning num5049 (depth = 9)
  gc_frame_newslot(num5049);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5050 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call5051 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe5050);
// compiled call node returning call5051 (depth = 10)
// compiled member node returning call5051 (depth = 9)
  params[0] = num5049;
  partcv[0] = 1;
  Object call5052 = callmethod(call5051, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5048);
// compiled call node returning call5052 (depth = 8)
  int op_slot_right_5047 = gc_frame_newslot(call5052);
// starting to compile string node (depth = 8)
  if (strlit5054 == NULL) {
    strlit5054 = alloc_String("(");
    gc_root(strlit5054);
  }
// compiled string node returning strlit5054 (depth = 8)
  int op_slot_left_5047 = gc_frame_newslot(strlit5054);
  params[0] = call5052;
  partcv[0] = 1;
  Object opresult5055 = callmethod(strlit5054, "++", 1, partcv, params);
// compiled op node returning opresult5055 (depth = 7)
  int op_slot_left_5044 = gc_frame_newslot(opresult5055);
  params[0] = strlit5045;
  partcv[0] = 1;
  Object opresult5056 = callmethod(opresult5055, "++", 1, partcv, params);
// compiled op node returning opresult5056 (depth = 6)
  *var_s = opresult5056;
  if (opresult5056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5025 = done;
  }
// compiled if node returning if5025 (depth = 4)
    gc_frame_newslot(if5025);
    if4985 = if5025;
  } else {
  }
// compiled if node returning if4985 (depth = 3)
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5058 = alloc_Boolean(1);
// compiled identifier node returning bool5058 (depth = 4)
  *var_firstPart = bool5058;
  if (bool5058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5059 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5060 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5061 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5060);
// compiled call node returning call5061 (depth = 5)
// compiled member node returning call5061 (depth = 4)
  gc_frame_newslot(call5061);
// starting to compile block node (depth = 4)
  Object block5062 = alloc_Block(NULL, NULL, "ast", 1142);
  gc_frame_newslot(block5062);
// method "_apply"
  block_savedest(block5062);
  Object closure5063 = createclosure(4, "_apply");
  setclosureframe(closure5063, stackframe);
  addtoclosure(closure5063, var_s);
  addtoclosure(closure5063, var_firstPart);
  addtoclosure(closure5063, var_depth);
  addtoclosure(closure5063, selfslot);
  struct UserObject *uo5063 = (struct UserObject*)block5062;
  uo5063->data[0] = (Object)closure5063;
  Method *meth_meth_ast__apply5063 = addmethod2pos(block5062, "_apply", &meth_ast__apply5063, 0);
  int argcv_meth_ast__apply5063[] = {1};
  meth_meth_ast__apply5063->type = alloc_MethodType(1, argcv_meth_ast__apply5063);
  meth_meth_ast__apply5063->definitionModule = modulename;
  meth_meth_ast__apply5063->definitionLine = 1142;
// compiled block node returning block5062 (depth = 4)
  gc_frame_newslot(block5062);
// call case 5: prelude request
  params[0] = call5061;
  params[1] = block5062;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5193 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5059);
// compiled call node returning call5193 (depth = 3)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString5194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_what = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5196 == NULL) {
    strlit5196 = alloc_String("");
    gc_root(strlit5196);
  }
// compiled string node returning strlit5196 (depth = 4)
  int op_slot_right_5195 = gc_frame_newslot(strlit5196);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5199 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5200 = alloc_Float64(0);
// compiled num node returning num5200 (depth = 6)
  gc_frame_newslot(num5200);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_what (depth = 6)
  params[0] = num5200;
  partcv[0] = 1;
  Object call5201 = callmethod(*var_what, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5199);
// compiled call node returning call5201 (depth = 5)
  int op_slot_right_5198 = gc_frame_newslot(call5201);
// starting to compile string node (depth = 5)
  if (strlit5203 == NULL) {
    strlit5203 = alloc_String("call ");
    gc_root(strlit5203);
  }
// compiled string node returning strlit5203 (depth = 5)
  int op_slot_left_5198 = gc_frame_newslot(strlit5203);
  params[0] = call5201;
  partcv[0] = 1;
  Object opresult5204 = callmethod(strlit5203, "++", 1, partcv, params);
// compiled op node returning opresult5204 (depth = 4)
  int op_slot_left_5195 = gc_frame_newslot(opresult5204);
  params[0] = strlit5196;
  partcv[0] = 1;
  Object opresult5205 = callmethod(opresult5204, "++", 1, partcv, params);
// compiled op node returning opresult5205 (depth = 3)
  gc_frame_end(frame);
  return opresult5205;
}
Object meth_ast_shallowCopy5206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5207 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5208 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5209 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5210 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5209);
// compiled call node returning call5210 (depth = 6)
// compiled member node returning call5210 (depth = 5)
  gc_frame_newslot(call5210);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5211 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5212 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5211);
// compiled call node returning call5212 (depth = 6)
// compiled member node returning call5212 (depth = 5)
  gc_frame_newslot(call5212);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callNode (depth = 5)
  params[0] = call5210;
  params[1] = call5212;
  partcv[0] = 2;
  Object call5213 = callmethod(*var_callNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5208);
// compiled call node returning call5213 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5214 = callmethod(call5213, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5207);
// compiled call node returning call5214 (depth = 3)
  gc_frame_end(frame);
  return call5214;
}
Object meth_ast_shallowCopyFieldsFrom5215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5216 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5217 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5216);
// compiled call node returning call5217 (depth = 3)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5218 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5220 = callmethod(*var_other, "isPattern",
    1, partcv, params);
  gc_frame_end(callframe5219);
// compiled call node returning call5220 (depth = 5)
// compiled member node returning call5220 (depth = 4)
  gc_frame_newslot(call5220);
// call case 4: self request
  params[0] = call5220;
  partcv[0] = 1;
  Object call5221 = callmethodflags(self, "isPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5218);
// compiled call node returning call5221 (depth = 3)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName5222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5223 == NULL) {
    strlit5223 = alloc_String("request");
    gc_root(strlit5223);
  }
// compiled string node returning strlit5223 (depth = 3)
  gc_frame_end(frame);
  return strlit5223;
}
Object meth_ast_new4701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4702 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4702 = alloc_userobj2(22,19, objclass4702);
  gc_frame_newslot(obj4702);
if (objclass4702 == NULL) {
  glfree(obj4702->class->name);
  obj4702->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4702, self, 0);
  addmethodreal(obj4702,"outer", &reader_ast_outer_4703);
  Object oldself4702 = self;
  struct StackFrameObject *oldstackframe4702 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4702);
  gc_frame_newslot((Object)stackframe);
  self = obj4702;
  Object *oldselfslot4702 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4702 = (*(struct UserObject *)self).data[0], lowerouter4702 = thisouter4702;
  if (inheritingObject4702) {
    struct UserObject *inho4702 = (struct UserObject *)inheritingObject4702;
    while (inho4702->super != GraceDefaultObject) inho4702 = (struct UserObject *)inho4702->super;
    inho4702->super = obj4702;
    self = inheritingObject4702;
    *selfslot = self;
    lowerouter4702 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4702;
  }
if (objclass4702 == NULL) {
  Method *reader4704 = addmethodrealflags(obj4702, "kind",&reader_ast_kind_4704, MFLAG_DEF);
  reader4704->definitionModule = modulename;
  reader4704->definitionLine = 1056;
}
adddatum2(obj4702, alloc_Undefined(), 1);
if (objclass4702 == NULL) {
  Method *reader4705 = addmethodrealflags(obj4702, "value",&reader_ast_value_4705, 0);
  Method *writer4705 = addmethodrealflags(obj4702, "value:=",&writer_ast_value_4705, 0);
  reader4705->definitionModule = modulename;
  writer4705->definitionModule = modulename;
  reader4705->definitionLine = 1057;
  writer4705->definitionLine = 1057;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 2);
if (objclass4702 == NULL) {
  Method *reader4706 = addmethodrealflags(obj4702, "with",&reader_ast_with_4706, 0);
  Method *writer4706 = addmethodrealflags(obj4702, "with:=",&writer_ast_with_4706, 0);
  reader4706->definitionModule = modulename;
  writer4706->definitionModule = modulename;
  reader4706->definitionLine = 1058;
  writer4706->definitionLine = 1058;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 3);
if (objclass4702 == NULL) {
  Method *reader4707 = addmethodrealflags(obj4702, "generics",&reader_ast_generics_4707, 0);
  Method *writer4707 = addmethodrealflags(obj4702, "generics:=",&writer_ast_generics_4707, 0);
  reader4707->definitionModule = modulename;
  writer4707->definitionModule = modulename;
  reader4707->definitionLine = 1059;
  writer4707->definitionLine = 1059;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 4);
if (objclass4702 == NULL) {
  Method *reader4708 = addmethodrealflags(obj4702, "isPattern",&reader_ast_isPattern_4708, 0);
  Method *writer4708 = addmethodrealflags(obj4702, "isPattern:=",&writer_ast_isPattern_4708, 0);
  reader4708->definitionModule = modulename;
  writer4708->definitionModule = modulename;
  reader4708->definitionLine = 1060;
  writer4708->definitionLine = 1060;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 5);
if (objclass4702 == NULL) {
  Method *reader4709 = addmethodrealflags(obj4702, "nameString",&reader_ast_nameString_4709, MFLAG_DEF);
  reader4709->definitionModule = modulename;
  reader4709->definitionLine = 1061;
}
adddatum2(obj4702, alloc_Undefined(), 6);
// method "target"
  struct UserObject *uo4710 = (struct UserObject*)obj4702;
  uo4710->data[7] = emptyclosure;
  Method *meth_meth_ast_target4710 = addmethod2pos(obj4702, "target", &meth_ast_target4710, 7);
  int argcv_meth_ast_target4710[] = {0};
  meth_meth_ast_target4710->type = alloc_MethodType(1, argcv_meth_ast_target4710);
  meth_meth_ast_target4710->definitionModule = modulename;
  meth_meth_ast_target4710->definitionLine = 1063;
// method "isCall"
  struct UserObject *uo4713 = (struct UserObject*)obj4702;
  uo4713->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4713 = addmethod2pos(obj4702, "isCall", &meth_ast_isCall4713, 8);
  int argcv_meth_ast_isCall4713[] = {0};
  meth_meth_ast_isCall4713->type = alloc_MethodType(1, argcv_meth_ast_isCall4713);
  meth_meth_ast_isCall4713->definitionModule = modulename;
  meth_meth_ast_isCall4713->definitionLine = 1064;
// method "returnsObject"
  struct UserObject *uo4715 = (struct UserObject*)obj4702;
  uo4715->data[9] = emptyclosure;
  Method *meth_meth_ast_returnsObject4715 = addmethod2pos(obj4702, "returnsObject", &meth_ast_returnsObject4715, 9);
  int argcv_meth_ast_returnsObject4715[] = {0};
  meth_meth_ast_returnsObject4715->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4715);
  meth_meth_ast_returnsObject4715->definitionModule = modulename;
  meth_meth_ast_returnsObject4715->definitionLine = 1065;
// method "returnedObjectScope"
  struct UserObject *uo4745 = (struct UserObject*)obj4702;
  uo4745->data[10] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4745 = addmethod2pos(obj4702, "returnedObjectScope", &meth_ast_returnedObjectScope4745, 10);
  int argcv_meth_ast_returnedObjectScope4745[] = {0};
  meth_meth_ast_returnedObjectScope4745->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4745);
  meth_meth_ast_returnedObjectScope4745->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4745->definitionLine = 1071;
// method "accept()from"
  struct UserObject *uo4748 = (struct UserObject*)obj4702;
  uo4748->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4748 = addmethod2pos(obj4702, "accept()from", &meth_ast_accept_40__41_from4748, 11);
  int argcv_meth_ast_accept_40__41_from4748[] = {1, 1};
  meth_meth_ast_accept_40__41_from4748->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4748);
  meth_meth_ast_accept_40__41_from4748->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4748->definitionLine = 1075;
// method "map()ancestors"
  struct UserObject *uo4790 = (struct UserObject*)obj4702;
  uo4790->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors4790 = addmethod2pos(obj4702, "map()ancestors", &meth_ast_map_40__41_ancestors4790, 12);
  int argcv_meth_ast_map_40__41_ancestors4790[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors4790->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors4790);
  meth_meth_ast_map_40__41_ancestors4790->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors4790->definitionLine = 1091;
// method "pretty"
  struct UserObject *uo4823 = (struct UserObject*)obj4702;
  uo4823->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty4823 = addmethod2pos(obj4702, "pretty", &meth_ast_pretty4823, 13);
  int argcv_meth_ast_pretty4823[] = {1};
  meth_meth_ast_pretty4823->type = alloc_MethodType(1, argcv_meth_ast_pretty4823);
  meth_meth_ast_pretty4823->definitionModule = modulename;
  meth_meth_ast_pretty4823->definitionLine = 1099;
// method "toGrace"
  struct UserObject *uo4972 = (struct UserObject*)obj4702;
  uo4972->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace4972 = addmethod2pos(obj4702, "toGrace", &meth_ast_toGrace4972, 14);
  int argcv_meth_ast_toGrace4972[] = {1};
  meth_meth_ast_toGrace4972->type = alloc_MethodType(1, argcv_meth_ast_toGrace4972);
meth_meth_ast_toGrace4972->type->types[0] = type_Number;
meth_meth_ast_toGrace4972->type->names[0] = "depth";
  meth_meth_ast_toGrace4972->definitionModule = modulename;
  meth_meth_ast_toGrace4972->definitionLine = 1122;
// method "asString"
  block_savedest(obj4702);
  Object closure5194 = createclosure(1, "asString");
  setclosureframe(closure5194, stackframe);
  addtoclosure(closure5194, var_what);
  struct UserObject *uo5194 = (struct UserObject*)obj4702;
  uo5194->data[15] = (Object)closure5194;
  Method *meth_meth_ast_asString5194 = addmethod2pos(obj4702, "asString", &meth_ast_asString5194, 15);
  int argcv_meth_ast_asString5194[] = {0};
  meth_meth_ast_asString5194->type = alloc_MethodType(1, argcv_meth_ast_asString5194);
  meth_meth_ast_asString5194->definitionModule = modulename;
  meth_meth_ast_asString5194->definitionLine = 1166;
// method "shallowCopy"
  block_savedest(obj4702);
  Object closure5206 = createclosure(1, "shallowCopy");
  setclosureframe(closure5206, stackframe);
  addtoclosure(closure5206, var_callNode);
  struct UserObject *uo5206 = (struct UserObject*)obj4702;
  uo5206->data[16] = (Object)closure5206;
  Method *meth_meth_ast_shallowCopy5206 = addmethod2pos(obj4702, "shallowCopy", &meth_ast_shallowCopy5206, 16);
  int argcv_meth_ast_shallowCopy5206[] = {0};
  meth_meth_ast_shallowCopy5206->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5206);
  meth_meth_ast_shallowCopy5206->definitionModule = modulename;
  meth_meth_ast_shallowCopy5206->definitionLine = 1167;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5215 = (struct UserObject*)obj4702;
  uo5215->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5215 = addmethod2pos(obj4702, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5215, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom5215[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5215->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5215);
  meth_meth_ast_shallowCopyFieldsFrom5215->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5215->definitionLine = 1170;
// method "statementName"
  struct UserObject *uo5222 = (struct UserObject*)obj4702;
  uo5222->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName5222 = addmethod2pos(obj4702, "statementName", &meth_ast_statementName5222, 18);
  int argcv_meth_ast_statementName5222[] = {0};
  meth_meth_ast_statementName5222->type = alloc_MethodType(1, argcv_meth_ast_statementName5222);
  meth_meth_ast_statementName5222->definitionModule = modulename;
  meth_meth_ast_statementName5222->definitionLine = 1175;
  sourceObject = obj4702;
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5224 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5225 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5226 = gc_frame_new();
// call case 3: self.outer request
  Object call5227 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5226);
// compiled call node returning call5227 (depth = 7)
// compiled member node returning call5227 (depth = 6)
  partcv[0] = 0;
  Object call5228 = callmethodflags(call5227, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5225);
// compiled call node returning call5228 (depth = 5)
// compiled member node returning call5228 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5229 = callmethodflags(call5228, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5224);
// compiled call node returning call5229 (depth = 3)
  struct UserObject *obj4702_uo = (struct UserObject *)obj4702;
  obj4702_uo->super = call5229;
  sourceObject = obj4702;
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5230 == NULL) {
    strlit5230 = alloc_String("call");
    gc_root(strlit5230);
  }
// compiled string node returning strlit5230 (depth = 3)
  adddatum2(obj4702, strlit5230, 1);
  sourceObject = obj4702;
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_what (depth = 3)
  adddatum2(obj4702, *var_what, 2);
  sourceObject = obj4702;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_with_39_ (depth = 3)
  adddatum2(obj4702, *var_with_39_, 3);
  sourceObject = obj4702;
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5231 = alloc_Boolean(0);
// compiled identifier node returning bool5231 (depth = 3)
  adddatum2(obj4702, bool5231, 4);
  sourceObject = obj4702;
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5232 = alloc_Boolean(0);
// compiled identifier node returning bool5232 (depth = 3)
  adddatum2(obj4702, bool5232, 5);
  sourceObject = obj4702;
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5233 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5234 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5235 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5234);
// compiled call node returning call5235 (depth = 6)
// compiled member node returning call5235 (depth = 5)
  partcv[0] = 0;
  Object call5236 = callmethod(call5235, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5233);
// compiled call node returning call5236 (depth = 4)
// compiled member node returning call5236 (depth = 3)
  adddatum2(obj4702, call5236, 6);
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  objclass4702 = obj4702->class;
  objclass4702->definitionModule = modulename;
  objclass4702->definitionLine = 1037;
  (*(struct UserObject *)self).data[0] = lowerouter4702;
  self = oldself4702;
  selfslot = oldselfslot4702;
  stackframe = oldstackframe4702;
  gc_frame_end(frame);
  return obj4702;
}
Object meth_ast_new4701_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4702 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4702 = alloc_userobj2(22,19, objclass4702);
  gc_frame_newslot(obj4702);
if (objclass4702 == NULL) {
  glfree(obj4702->class->name);
  obj4702->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4702, self, 0);
  addmethodreal(obj4702,"outer", &reader_ast_outer_4703);
  Object oldself4702 = self;
  struct StackFrameObject *oldstackframe4702 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4702);
  gc_frame_newslot((Object)stackframe);
  self = obj4702;
  Object *oldselfslot4702 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4702 = (*(struct UserObject *)self).data[0], lowerouter4702 = thisouter4702;
  if (inheritingObject4702) {
    struct UserObject *inho4702 = (struct UserObject *)inheritingObject4702;
    while (inho4702->super != GraceDefaultObject) inho4702 = (struct UserObject *)inho4702->super;
    inho4702->super = obj4702;
    self = inheritingObject4702;
    *selfslot = self;
    lowerouter4702 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4702;
  }
if (objclass4702 == NULL) {
  Method *reader4704 = addmethodrealflags(obj4702, "kind",&reader_ast_kind_4704, MFLAG_DEF);
  reader4704->definitionModule = modulename;
  reader4704->definitionLine = 1056;
}
adddatum2(obj4702, alloc_Undefined(), 1);
if (objclass4702 == NULL) {
  Method *reader4705 = addmethodrealflags(obj4702, "value",&reader_ast_value_4705, 0);
  Method *writer4705 = addmethodrealflags(obj4702, "value:=",&writer_ast_value_4705, 0);
  reader4705->definitionModule = modulename;
  writer4705->definitionModule = modulename;
  reader4705->definitionLine = 1057;
  writer4705->definitionLine = 1057;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 2);
if (objclass4702 == NULL) {
  Method *reader4706 = addmethodrealflags(obj4702, "with",&reader_ast_with_4706, 0);
  Method *writer4706 = addmethodrealflags(obj4702, "with:=",&writer_ast_with_4706, 0);
  reader4706->definitionModule = modulename;
  writer4706->definitionModule = modulename;
  reader4706->definitionLine = 1058;
  writer4706->definitionLine = 1058;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 3);
if (objclass4702 == NULL) {
  Method *reader4707 = addmethodrealflags(obj4702, "generics",&reader_ast_generics_4707, 0);
  Method *writer4707 = addmethodrealflags(obj4702, "generics:=",&writer_ast_generics_4707, 0);
  reader4707->definitionModule = modulename;
  writer4707->definitionModule = modulename;
  reader4707->definitionLine = 1059;
  writer4707->definitionLine = 1059;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 4);
if (objclass4702 == NULL) {
  Method *reader4708 = addmethodrealflags(obj4702, "isPattern",&reader_ast_isPattern_4708, 0);
  Method *writer4708 = addmethodrealflags(obj4702, "isPattern:=",&writer_ast_isPattern_4708, 0);
  reader4708->definitionModule = modulename;
  writer4708->definitionModule = modulename;
  reader4708->definitionLine = 1060;
  writer4708->definitionLine = 1060;
}
obj4702->flags |= OFLAG_MUTABLE;
adddatum2(obj4702, alloc_Undefined(), 5);
if (objclass4702 == NULL) {
  Method *reader4709 = addmethodrealflags(obj4702, "nameString",&reader_ast_nameString_4709, MFLAG_DEF);
  reader4709->definitionModule = modulename;
  reader4709->definitionLine = 1061;
}
adddatum2(obj4702, alloc_Undefined(), 6);
// method "target"
  struct UserObject *uo4710 = (struct UserObject*)obj4702;
  uo4710->data[7] = emptyclosure;
  Method *meth_meth_ast_target4710 = addmethod2pos(obj4702, "target", &meth_ast_target4710, 7);
  int argcv_meth_ast_target4710[] = {0};
  meth_meth_ast_target4710->type = alloc_MethodType(1, argcv_meth_ast_target4710);
  meth_meth_ast_target4710->definitionModule = modulename;
  meth_meth_ast_target4710->definitionLine = 1063;
// method "isCall"
  struct UserObject *uo4713 = (struct UserObject*)obj4702;
  uo4713->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4713 = addmethod2pos(obj4702, "isCall", &meth_ast_isCall4713, 8);
  int argcv_meth_ast_isCall4713[] = {0};
  meth_meth_ast_isCall4713->type = alloc_MethodType(1, argcv_meth_ast_isCall4713);
  meth_meth_ast_isCall4713->definitionModule = modulename;
  meth_meth_ast_isCall4713->definitionLine = 1064;
// method "returnsObject"
  struct UserObject *uo4715 = (struct UserObject*)obj4702;
  uo4715->data[9] = emptyclosure;
  Method *meth_meth_ast_returnsObject4715 = addmethod2pos(obj4702, "returnsObject", &meth_ast_returnsObject4715, 9);
  int argcv_meth_ast_returnsObject4715[] = {0};
  meth_meth_ast_returnsObject4715->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4715);
  meth_meth_ast_returnsObject4715->definitionModule = modulename;
  meth_meth_ast_returnsObject4715->definitionLine = 1065;
// method "returnedObjectScope"
  struct UserObject *uo4745 = (struct UserObject*)obj4702;
  uo4745->data[10] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4745 = addmethod2pos(obj4702, "returnedObjectScope", &meth_ast_returnedObjectScope4745, 10);
  int argcv_meth_ast_returnedObjectScope4745[] = {0};
  meth_meth_ast_returnedObjectScope4745->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4745);
  meth_meth_ast_returnedObjectScope4745->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4745->definitionLine = 1071;
// method "accept()from"
  struct UserObject *uo4748 = (struct UserObject*)obj4702;
  uo4748->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4748 = addmethod2pos(obj4702, "accept()from", &meth_ast_accept_40__41_from4748, 11);
  int argcv_meth_ast_accept_40__41_from4748[] = {1, 1};
  meth_meth_ast_accept_40__41_from4748->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4748);
  meth_meth_ast_accept_40__41_from4748->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4748->definitionLine = 1075;
// method "map()ancestors"
  struct UserObject *uo4790 = (struct UserObject*)obj4702;
  uo4790->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors4790 = addmethod2pos(obj4702, "map()ancestors", &meth_ast_map_40__41_ancestors4790, 12);
  int argcv_meth_ast_map_40__41_ancestors4790[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors4790->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors4790);
  meth_meth_ast_map_40__41_ancestors4790->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors4790->definitionLine = 1091;
// method "pretty"
  struct UserObject *uo4823 = (struct UserObject*)obj4702;
  uo4823->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty4823 = addmethod2pos(obj4702, "pretty", &meth_ast_pretty4823, 13);
  int argcv_meth_ast_pretty4823[] = {1};
  meth_meth_ast_pretty4823->type = alloc_MethodType(1, argcv_meth_ast_pretty4823);
  meth_meth_ast_pretty4823->definitionModule = modulename;
  meth_meth_ast_pretty4823->definitionLine = 1099;
// method "toGrace"
  struct UserObject *uo4972 = (struct UserObject*)obj4702;
  uo4972->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace4972 = addmethod2pos(obj4702, "toGrace", &meth_ast_toGrace4972, 14);
  int argcv_meth_ast_toGrace4972[] = {1};
  meth_meth_ast_toGrace4972->type = alloc_MethodType(1, argcv_meth_ast_toGrace4972);
meth_meth_ast_toGrace4972->type->types[0] = type_Number;
meth_meth_ast_toGrace4972->type->names[0] = "depth";
  meth_meth_ast_toGrace4972->definitionModule = modulename;
  meth_meth_ast_toGrace4972->definitionLine = 1122;
// method "asString"
  block_savedest(obj4702);
  Object closure5194 = createclosure(1, "asString");
  setclosureframe(closure5194, stackframe);
  addtoclosure(closure5194, var_what);
  struct UserObject *uo5194 = (struct UserObject*)obj4702;
  uo5194->data[15] = (Object)closure5194;
  Method *meth_meth_ast_asString5194 = addmethod2pos(obj4702, "asString", &meth_ast_asString5194, 15);
  int argcv_meth_ast_asString5194[] = {0};
  meth_meth_ast_asString5194->type = alloc_MethodType(1, argcv_meth_ast_asString5194);
  meth_meth_ast_asString5194->definitionModule = modulename;
  meth_meth_ast_asString5194->definitionLine = 1166;
// method "shallowCopy"
  block_savedest(obj4702);
  Object closure5206 = createclosure(1, "shallowCopy");
  setclosureframe(closure5206, stackframe);
  addtoclosure(closure5206, var_callNode);
  struct UserObject *uo5206 = (struct UserObject*)obj4702;
  uo5206->data[16] = (Object)closure5206;
  Method *meth_meth_ast_shallowCopy5206 = addmethod2pos(obj4702, "shallowCopy", &meth_ast_shallowCopy5206, 16);
  int argcv_meth_ast_shallowCopy5206[] = {0};
  meth_meth_ast_shallowCopy5206->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5206);
  meth_meth_ast_shallowCopy5206->definitionModule = modulename;
  meth_meth_ast_shallowCopy5206->definitionLine = 1167;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5215 = (struct UserObject*)obj4702;
  uo5215->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5215 = addmethod2pos(obj4702, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5215, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom5215[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5215->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5215);
  meth_meth_ast_shallowCopyFieldsFrom5215->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5215->definitionLine = 1170;
// method "statementName"
  struct UserObject *uo5222 = (struct UserObject*)obj4702;
  uo5222->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName5222 = addmethod2pos(obj4702, "statementName", &meth_ast_statementName5222, 18);
  int argcv_meth_ast_statementName5222[] = {0};
  meth_meth_ast_statementName5222->type = alloc_MethodType(1, argcv_meth_ast_statementName5222);
  meth_meth_ast_statementName5222->definitionModule = modulename;
  meth_meth_ast_statementName5222->definitionLine = 1175;
  sourceObject = obj4702;
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5224 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5225 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5226 = gc_frame_new();
// call case 3: self.outer request
  Object call5227 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5226);
// compiled call node returning call5227 (depth = 7)
// compiled member node returning call5227 (depth = 6)
  partcv[0] = 0;
  Object call5228 = callmethodflags(call5227, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5225);
// compiled call node returning call5228 (depth = 5)
// compiled member node returning call5228 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5229 = callmethodflags(call5228, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5224);
// compiled call node returning call5229 (depth = 3)
  struct UserObject *obj4702_uo = (struct UserObject *)obj4702;
  obj4702_uo->super = call5229;
  sourceObject = obj4702;
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5230 == NULL) {
    strlit5230 = alloc_String("call");
    gc_root(strlit5230);
  }
// compiled string node returning strlit5230 (depth = 3)
  adddatum2(obj4702, strlit5230, 1);
  sourceObject = obj4702;
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_what (depth = 3)
  adddatum2(obj4702, *var_what, 2);
  sourceObject = obj4702;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_with_39_ (depth = 3)
  adddatum2(obj4702, *var_with_39_, 3);
  sourceObject = obj4702;
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5231 = alloc_Boolean(0);
// compiled identifier node returning bool5231 (depth = 3)
  adddatum2(obj4702, bool5231, 4);
  sourceObject = obj4702;
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5232 = alloc_Boolean(0);
// compiled identifier node returning bool5232 (depth = 3)
  adddatum2(obj4702, bool5232, 5);
  sourceObject = obj4702;
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5233 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5234 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5235 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5234);
// compiled call node returning call5235 (depth = 6)
// compiled member node returning call5235 (depth = 5)
  partcv[0] = 0;
  Object call5236 = callmethod(call5235, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5233);
// compiled call node returning call5236 (depth = 4)
// compiled member node returning call5236 (depth = 3)
  adddatum2(obj4702, call5236, 6);
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  sourceObject = obj4702;
  objclass4702 = obj4702->class;
  objclass4702->definitionModule = modulename;
  objclass4702->definitionLine = 1037;
  (*(struct UserObject *)self).data[0] = lowerouter4702;
  self = oldself4702;
  selfslot = oldselfslot4702;
  stackframe = oldstackframe4702;
  gc_frame_end(frame);
  return obj4702;
}
Object meth_ast_callNode5238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for callNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_body_40__41_named_40__41_scope5241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body()named()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5242 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5243 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5242);
// compiled call node returning call5243 (depth = 4)
  *var_result = call5243;
  if (call5243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5244 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5245 = callmethod(*var_result, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5244);
// compiled call node returning call5245 (depth = 3)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5246 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5247 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe5246);
// compiled call node returning call5247 (depth = 3)
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40__41_named5248(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body()named (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5249 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5250 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5249);
// compiled call node returning call5250 (depth = 4)
  *var_result = call5250;
  if (call5250 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5252 = callmethod(*var_result, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5251);
// compiled call node returning call5252 (depth = 3)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isModule5258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isModule (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isModule");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5259 = alloc_Boolean(1);
// compiled identifier node returning bool5259 (depth = 3)
  gc_frame_end(frame);
  return bool5259;
}
Object meth_ast_returnsObject5260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5261 = alloc_Boolean(0);
// compiled identifier node returning bool5261 (depth = 3)
  gc_frame_end(frame);
  return bool5261;
}
Object meth_ast__apply5265(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5267 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5268 = callmethod(*var_o, "isExternal",
    1, partcv, params);
  gc_frame_end(callframe5267);
// compiled call node returning call5268 (depth = 7)
// compiled member node returning call5268 (depth = 6)
  Object if5266 = done;
  if (istrue(call5268)) {
// starting to compile call node (depth = 6)
  int callframe5269 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5270 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5269);
// compiled call node returning call5270 (depth = 6)
    gc_frame_newslot(call5270);
    if5266 = call5270;
  } else {
  }
// compiled if node returning if5266 (depth = 5)
  gc_frame_end(frame);
  return if5266;
}
Object meth_ast_externalsDo5262(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "externalsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method externalsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for externalsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for externalsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5263 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5264 = alloc_Block(NULL, NULL, "ast", 1200);
  gc_frame_newslot(block5264);
// method "_apply"
  block_savedest(block5264);
  Object closure5265 = createclosure(2, "_apply");
  setclosureframe(closure5265, stackframe);
  addtoclosure(closure5265, var_action);
  addtoclosure(closure5265, selfslot);
  struct UserObject *uo5265 = (struct UserObject*)block5264;
  uo5265->data[0] = (Object)closure5265;
  Method *meth_meth_ast__apply5265 = addmethod2pos(block5264, "_apply", &meth_ast__apply5265, 0);
  int argcv_meth_ast__apply5265[] = {1};
  meth_meth_ast__apply5265->type = alloc_MethodType(1, argcv_meth_ast__apply5265);
  meth_meth_ast__apply5265->definitionModule = modulename;
  meth_meth_ast__apply5265->definitionLine = 1061;
// compiled block node returning block5264 (depth = 4)
  gc_frame_newslot(block5264);
// call case 6: other member request
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5273 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5272);
// compiled call node returning call5273 (depth = 5)
// compiled member node returning call5273 (depth = 4)
  params[0] = block5264;
  partcv[0] = 1;
  Object call5274 = callmethod(call5273, "do",
    1, partcv, params);
  gc_frame_end(callframe5263);
// compiled call node returning call5274 (depth = 3)
  gc_frame_end(frame);
  return call5274;
}
Object meth_ast__apply5296(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5297 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5298 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5297);
// compiled call node returning call5298 (depth = 6)
  gc_frame_end(frame);
  return call5298;
}
Object meth_ast_accept_40__41_from5275(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5277 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5278 = callmethod(*var_visitor, "visitModule()up",
    2, partcv, params);
  gc_frame_end(callframe5277);
// compiled call node returning call5278 (depth = 4)
  Object if5276 = done;
  if (istrue(call5278)) {
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5279 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5280 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5279);
// compiled call node returning call5280 (depth = 5)
  *var_newChain = call5280;
  if (call5280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5283 = alloc_Boolean(0);
// compiled identifier node returning bool5283 (depth = 6)
  int op_slot_right_5282 = gc_frame_newslot(bool5283);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5285 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5286 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5285);
// compiled call node returning call5286 (depth = 7)
// compiled member node returning call5286 (depth = 6)
  int op_slot_left_5282 = gc_frame_newslot(call5286);
  params[0] = bool5283;
  partcv[0] = 1;
  Object opresult5287 = callmethod(call5286, "!=", 1, partcv, params);
// compiled op node returning opresult5287 (depth = 5)
  Object if5281 = done;
  if (istrue(opresult5287)) {
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5288 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5290 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5289);
// compiled call node returning call5290 (depth = 7)
// compiled member node returning call5290 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5291 = callmethod(call5290, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5288);
// compiled call node returning call5291 (depth = 5)
    gc_frame_newslot(call5291);
    if5281 = call5291;
  } else {
  }
// compiled if node returning if5281 (depth = 4)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5292 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5294 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5293);
// compiled call node returning call5294 (depth = 6)
// compiled member node returning call5294 (depth = 5)
  gc_frame_newslot(call5294);
// starting to compile block node (depth = 5)
  Object block5295 = alloc_Block(NULL, NULL, "ast", 1210);
  gc_frame_newslot(block5295);
// method "_apply"
  block_savedest(block5295);
  Object closure5296 = createclosure(3, "_apply");
  setclosureframe(closure5296, stackframe);
  addtoclosure(closure5296, var_visitor);
  addtoclosure(closure5296, var_newChain);
  addtoclosure(closure5296, selfslot);
  struct UserObject *uo5296 = (struct UserObject*)block5295;
  uo5296->data[0] = (Object)closure5296;
  Method *meth_meth_ast__apply5296 = addmethod2pos(block5295, "_apply", &meth_ast__apply5296, 0);
  int argcv_meth_ast__apply5296[] = {1};
  meth_meth_ast__apply5296->type = alloc_MethodType(1, argcv_meth_ast__apply5296);
  meth_meth_ast__apply5296->definitionModule = modulename;
  meth_meth_ast__apply5296->definitionLine = 1210;
// compiled block node returning block5295 (depth = 5)
  gc_frame_newslot(block5295);
// call case 5: prelude request
  params[0] = call5294;
  params[1] = block5295;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5300 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5292);
// compiled call node returning call5300 (depth = 4)
    gc_frame_newslot(call5300);
    if5276 = call5300;
  } else {
  }
// compiled if node returning if5276 (depth = 3)
  gc_frame_end(frame);
  return if5276;
}
Object meth_ast_shallowCopy5301(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5302 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5303 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call5304 = callmethod(*var_moduleNode, "body",
    1, partcv, params);
  gc_frame_end(callframe5303);
// compiled call node returning call5304 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5305 = callmethod(call5304, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5302);
// compiled call node returning call5305 (depth = 3)
  gc_frame_end(frame);
  return call5305;
}
Object meth_ast_shallowCopyFieldsFrom5306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5307 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5308 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5307);
// compiled call node returning call5308 (depth = 3)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5309 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5311 = callmethod(*var_other, "imports",
    1, partcv, params);
  gc_frame_end(callframe5310);
// compiled call node returning call5311 (depth = 5)
// compiled member node returning call5311 (depth = 4)
  gc_frame_newslot(call5311);
// call case 4: self request
  params[0] = call5311;
  partcv[0] = 1;
  Object call5312 = callmethodflags(self, "imports:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5309);
// compiled call node returning call5312 (depth = 3)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_body5253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5254 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5254 = alloc_userobj2(11,11, objclass5254);
  gc_frame_newslot(obj5254);
if (objclass5254 == NULL) {
  glfree(obj5254->class->name);
  obj5254->class->name = "body";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5254, self, 0);
  addmethodreal(obj5254,"outer", &reader_ast_outer_5255);
  Object oldself5254 = self;
  struct StackFrameObject *oldstackframe5254 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5254);
  gc_frame_newslot((Object)stackframe);
  self = obj5254;
  Object *oldselfslot5254 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5254 = (*(struct UserObject *)self).data[0], lowerouter5254 = thisouter5254;
  if (inheritingObject5254) {
    struct UserObject *inho5254 = (struct UserObject *)inheritingObject5254;
    while (inho5254->super != GraceDefaultObject) inho5254 = (struct UserObject *)inho5254->super;
    inho5254->super = obj5254;
    self = inheritingObject5254;
    *selfslot = self;
    lowerouter5254 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5254;
  }
if (objclass5254 == NULL) {
  Method *reader5256 = addmethodrealflags(obj5254, "kind",&reader_ast_kind_5256, MFLAG_DEF);
  reader5256->definitionModule = modulename;
  reader5256->definitionLine = 1192;
}
adddatum2(obj5254, alloc_Undefined(), 1);
if (objclass5254 == NULL) {
  Method *reader5257 = addmethodrealflags(obj5254, "imports",&reader_ast_imports_5257, 0);
  Method *writer5257 = addmethodrealflags(obj5254, "imports:=",&writer_ast_imports_5257, 0);
  reader5257->definitionModule = modulename;
  writer5257->definitionModule = modulename;
  reader5257->definitionLine = 1195;
  writer5257->definitionLine = 1195;
}
obj5254->flags |= OFLAG_MUTABLE;
adddatum2(obj5254, alloc_Undefined(), 2);
// method "isModule"
  struct UserObject *uo5258 = (struct UserObject*)obj5254;
  uo5258->data[3] = emptyclosure;
  Method *meth_meth_ast_isModule5258 = addmethod2pos(obj5254, "isModule", &meth_ast_isModule5258, 3);
  int argcv_meth_ast_isModule5258[] = {0};
  meth_meth_ast_isModule5258->type = alloc_MethodType(1, argcv_meth_ast_isModule5258);
  meth_meth_ast_isModule5258->definitionModule = modulename;
  meth_meth_ast_isModule5258->definitionLine = 1197;
// method "returnsObject"
  struct UserObject *uo5260 = (struct UserObject*)obj5254;
  uo5260->data[4] = emptyclosure;
  Method *meth_meth_ast_returnsObject5260 = addmethod2pos(obj5254, "returnsObject", &meth_ast_returnsObject5260, 4);
  int argcv_meth_ast_returnsObject5260[] = {0};
  meth_meth_ast_returnsObject5260->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5260);
  meth_meth_ast_returnsObject5260->definitionModule = modulename;
  meth_meth_ast_returnsObject5260->definitionLine = 1198;
// method "externalsDo"
  struct UserObject *uo5262 = (struct UserObject*)obj5254;
  uo5262->data[5] = emptyclosure;
  Method *meth_meth_ast_externalsDo5262 = addmethod2pos(obj5254, "externalsDo", &meth_ast_externalsDo5262, 5);
  int argcv_meth_ast_externalsDo5262[] = {1};
  meth_meth_ast_externalsDo5262->type = alloc_MethodType(1, argcv_meth_ast_externalsDo5262);
  meth_meth_ast_externalsDo5262->definitionModule = modulename;
  meth_meth_ast_externalsDo5262->definitionLine = 1199;
// method "accept()from"
  struct UserObject *uo5275 = (struct UserObject*)obj5254;
  uo5275->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5275 = addmethod2pos(obj5254, "accept()from", &meth_ast_accept_40__41_from5275, 6);
  int argcv_meth_ast_accept_40__41_from5275[] = {1, 1};
  meth_meth_ast_accept_40__41_from5275->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5275);
  meth_meth_ast_accept_40__41_from5275->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5275->definitionLine = 1204;
// method "shallowCopy"
  block_savedest(obj5254);
  Object closure5301 = createclosure(2, "shallowCopy");
  setclosureframe(closure5301, stackframe);
  addtoclosure(closure5301, var_emptySeq);
  addtoclosure(closure5301, var_moduleNode);
  struct UserObject *uo5301 = (struct UserObject*)obj5254;
  uo5301->data[7] = (Object)closure5301;
  Method *meth_meth_ast_shallowCopy5301 = addmethod2pos(obj5254, "shallowCopy", &meth_ast_shallowCopy5301, 7);
  int argcv_meth_ast_shallowCopy5301[] = {0};
  meth_meth_ast_shallowCopy5301->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5301);
  meth_meth_ast_shallowCopy5301->definitionModule = modulename;
  meth_meth_ast_shallowCopy5301->definitionLine = 1215;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5306 = (struct UserObject*)obj5254;
  uo5306->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5306 = addmethod2pos(obj5254, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5306, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom5306[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5306->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5306);
  meth_meth_ast_shallowCopyFieldsFrom5306->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5306->definitionLine = 1218;
  sourceObject = obj5254;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5313 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5314 = alloc_Boolean(0);
// compiled identifier node returning bool5314 (depth = 4)
  gc_frame_newslot(bool5314);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5314;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5315 = callmethod(*var_objectNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5313);
// compiled call node returning call5315 (depth = 3)
  struct UserObject *obj5254_uo = (struct UserObject *)obj5254;
  obj5254_uo->super = call5315;
  sourceObject = obj5254;
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5316 == NULL) {
    strlit5316 = alloc_String("module");
    gc_root(strlit5316);
  }
// compiled string node returning strlit5316 (depth = 3)
  adddatum2(obj5254, strlit5316, 1);
  sourceObject = obj5254;
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5317 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5318 = alloc_Float64(0);
// compiled num node returning num5318 (depth = 4)
  gc_frame_newslot(num5318);
// call case 4: self request
  params[0] = num5318;
  partcv[0] = 1;
  Object call5319 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5317);
// compiled call node returning call5319 (depth = 3)
  sourceObject = obj5254;
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5320 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5321 = alloc_Float64(0);
// compiled num node returning num5321 (depth = 4)
  gc_frame_newslot(num5321);
// call case 4: self request
  params[0] = num5321;
  partcv[0] = 1;
  Object call5322 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5320);
// compiled call node returning call5322 (depth = 3)
  sourceObject = obj5254;
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5323 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5324 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5325 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5324);
// compiled call node returning call5325 (depth = 6)
// compiled member node returning call5325 (depth = 5)
  partcv[0] = 0;
  Object call5326 = callmethod(call5325, "empty",
    1, partcv, params);
  gc_frame_end(callframe5323);
// compiled call node returning call5326 (depth = 4)
// compiled member node returning call5326 (depth = 3)
  adddatum2(obj5254, call5326, 2);
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  objclass5254 = obj5254->class;
  objclass5254->definitionModule = modulename;
  objclass5254->definitionLine = 1190;
  (*(struct UserObject *)self).data[0] = lowerouter5254;
  self = oldself5254;
  selfslot = oldselfslot5254;
  stackframe = oldstackframe5254;
  gc_frame_end(frame);
  return obj5254;
}
Object meth_ast_body5253_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()object");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5254 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5254 = alloc_userobj2(11,11, objclass5254);
  gc_frame_newslot(obj5254);
if (objclass5254 == NULL) {
  glfree(obj5254->class->name);
  obj5254->class->name = "body";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5254, self, 0);
  addmethodreal(obj5254,"outer", &reader_ast_outer_5255);
  Object oldself5254 = self;
  struct StackFrameObject *oldstackframe5254 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5254);
  gc_frame_newslot((Object)stackframe);
  self = obj5254;
  Object *oldselfslot5254 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5254 = (*(struct UserObject *)self).data[0], lowerouter5254 = thisouter5254;
  if (inheritingObject5254) {
    struct UserObject *inho5254 = (struct UserObject *)inheritingObject5254;
    while (inho5254->super != GraceDefaultObject) inho5254 = (struct UserObject *)inho5254->super;
    inho5254->super = obj5254;
    self = inheritingObject5254;
    *selfslot = self;
    lowerouter5254 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5254;
  }
if (objclass5254 == NULL) {
  Method *reader5256 = addmethodrealflags(obj5254, "kind",&reader_ast_kind_5256, MFLAG_DEF);
  reader5256->definitionModule = modulename;
  reader5256->definitionLine = 1192;
}
adddatum2(obj5254, alloc_Undefined(), 1);
if (objclass5254 == NULL) {
  Method *reader5257 = addmethodrealflags(obj5254, "imports",&reader_ast_imports_5257, 0);
  Method *writer5257 = addmethodrealflags(obj5254, "imports:=",&writer_ast_imports_5257, 0);
  reader5257->definitionModule = modulename;
  writer5257->definitionModule = modulename;
  reader5257->definitionLine = 1195;
  writer5257->definitionLine = 1195;
}
obj5254->flags |= OFLAG_MUTABLE;
adddatum2(obj5254, alloc_Undefined(), 2);
// method "isModule"
  struct UserObject *uo5258 = (struct UserObject*)obj5254;
  uo5258->data[3] = emptyclosure;
  Method *meth_meth_ast_isModule5258 = addmethod2pos(obj5254, "isModule", &meth_ast_isModule5258, 3);
  int argcv_meth_ast_isModule5258[] = {0};
  meth_meth_ast_isModule5258->type = alloc_MethodType(1, argcv_meth_ast_isModule5258);
  meth_meth_ast_isModule5258->definitionModule = modulename;
  meth_meth_ast_isModule5258->definitionLine = 1197;
// method "returnsObject"
  struct UserObject *uo5260 = (struct UserObject*)obj5254;
  uo5260->data[4] = emptyclosure;
  Method *meth_meth_ast_returnsObject5260 = addmethod2pos(obj5254, "returnsObject", &meth_ast_returnsObject5260, 4);
  int argcv_meth_ast_returnsObject5260[] = {0};
  meth_meth_ast_returnsObject5260->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5260);
  meth_meth_ast_returnsObject5260->definitionModule = modulename;
  meth_meth_ast_returnsObject5260->definitionLine = 1198;
// method "externalsDo"
  struct UserObject *uo5262 = (struct UserObject*)obj5254;
  uo5262->data[5] = emptyclosure;
  Method *meth_meth_ast_externalsDo5262 = addmethod2pos(obj5254, "externalsDo", &meth_ast_externalsDo5262, 5);
  int argcv_meth_ast_externalsDo5262[] = {1};
  meth_meth_ast_externalsDo5262->type = alloc_MethodType(1, argcv_meth_ast_externalsDo5262);
  meth_meth_ast_externalsDo5262->definitionModule = modulename;
  meth_meth_ast_externalsDo5262->definitionLine = 1199;
// method "accept()from"
  struct UserObject *uo5275 = (struct UserObject*)obj5254;
  uo5275->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5275 = addmethod2pos(obj5254, "accept()from", &meth_ast_accept_40__41_from5275, 6);
  int argcv_meth_ast_accept_40__41_from5275[] = {1, 1};
  meth_meth_ast_accept_40__41_from5275->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5275);
  meth_meth_ast_accept_40__41_from5275->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5275->definitionLine = 1204;
// method "shallowCopy"
  block_savedest(obj5254);
  Object closure5301 = createclosure(2, "shallowCopy");
  setclosureframe(closure5301, stackframe);
  addtoclosure(closure5301, var_emptySeq);
  addtoclosure(closure5301, var_moduleNode);
  struct UserObject *uo5301 = (struct UserObject*)obj5254;
  uo5301->data[7] = (Object)closure5301;
  Method *meth_meth_ast_shallowCopy5301 = addmethod2pos(obj5254, "shallowCopy", &meth_ast_shallowCopy5301, 7);
  int argcv_meth_ast_shallowCopy5301[] = {0};
  meth_meth_ast_shallowCopy5301->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5301);
  meth_meth_ast_shallowCopy5301->definitionModule = modulename;
  meth_meth_ast_shallowCopy5301->definitionLine = 1215;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5306 = (struct UserObject*)obj5254;
  uo5306->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5306 = addmethod2pos(obj5254, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5306, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom5306[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5306->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5306);
  meth_meth_ast_shallowCopyFieldsFrom5306->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5306->definitionLine = 1218;
  sourceObject = obj5254;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5313 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5314 = alloc_Boolean(0);
// compiled identifier node returning bool5314 (depth = 4)
  gc_frame_newslot(bool5314);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5314;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5315 = callmethod(*var_objectNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5313);
// compiled call node returning call5315 (depth = 3)
  struct UserObject *obj5254_uo = (struct UserObject *)obj5254;
  obj5254_uo->super = call5315;
  sourceObject = obj5254;
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5316 == NULL) {
    strlit5316 = alloc_String("module");
    gc_root(strlit5316);
  }
// compiled string node returning strlit5316 (depth = 3)
  adddatum2(obj5254, strlit5316, 1);
  sourceObject = obj5254;
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5317 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5318 = alloc_Float64(0);
// compiled num node returning num5318 (depth = 4)
  gc_frame_newslot(num5318);
// call case 4: self request
  params[0] = num5318;
  partcv[0] = 1;
  Object call5319 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5317);
// compiled call node returning call5319 (depth = 3)
  sourceObject = obj5254;
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5320 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5321 = alloc_Float64(0);
// compiled num node returning num5321 (depth = 4)
  gc_frame_newslot(num5321);
// call case 4: self request
  params[0] = num5321;
  partcv[0] = 1;
  Object call5322 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5320);
// compiled call node returning call5322 (depth = 3)
  sourceObject = obj5254;
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5323 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5324 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5325 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5324);
// compiled call node returning call5325 (depth = 6)
// compiled member node returning call5325 (depth = 5)
  partcv[0] = 0;
  Object call5326 = callmethod(call5325, "empty",
    1, partcv, params);
  gc_frame_end(callframe5323);
// compiled call node returning call5326 (depth = 4)
// compiled member node returning call5326 (depth = 3)
  adddatum2(obj5254, call5326, 2);
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  sourceObject = obj5254;
  objclass5254 = obj5254->class;
  objclass5254->definitionModule = modulename;
  objclass5254->definitionLine = 1190;
  (*(struct UserObject *)self).data[0] = lowerouter5254;
  self = oldself5254;
  selfslot = oldselfslot5254;
  stackframe = oldstackframe5254;
  gc_frame_end(frame);
  return obj5254;
}
Object meth_ast_moduleNode5328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleNode (depth = 3)
  gc_frame_end(frame);
  return *var_moduleNode;
}
Object meth_ast_body_40__41_named_40__41_scope5331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body()named()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5332 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
  Object bool5333 = alloc_Boolean(0);
// compiled identifier node returning bool5333 (depth = 5)
  gc_frame_newslot(bool5333);
// call case 4: self request
  params[0] = *var_b;
  params[1] = bool5333;
  partcv[0] = 2;
  Object call5334 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5332);
// compiled call node returning call5334 (depth = 4)
  *var_result = call5334;
  if (call5334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5335 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5336 = callmethod(*var_result, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5335);
// compiled call node returning call5336 (depth = 3)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5337 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5338 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe5337);
// compiled call node returning call5338 (depth = 3)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40__41_named5339(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body()named");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  Object params[3];
  int partcv[3];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body()named (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5340 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  gc_frame_newslot(*var_fakeSymbolTable);
// call case 4: self request
  params[0] = *var_b;
  params[1] = *var_n;
  params[2] = *var_fakeSymbolTable;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5341 = callmethodflags(self, "body()named()scope", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5340);
// compiled call node returning call5341 (depth = 3)
  gc_frame_end(frame);
  return call5341;
}
Object meth_ast_description5354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for description (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for description");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5356 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5357 = callmethodflags(self, "isTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5356);
// compiled call node returning call5357 (depth = 5)
// compiled member node returning call5357 (depth = 4)
  Object if5355 = done;
  if (istrue(call5357)) {
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5359 == NULL) {
    strlit5359 = alloc_String(" (trait)");
    gc_root(strlit5359);
  }
// compiled string node returning strlit5359 (depth = 5)
  int op_slot_right_5358 = gc_frame_newslot(strlit5359);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5362 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5363 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5362);
// compiled call node returning call5363 (depth = 7)
// compiled member node returning call5363 (depth = 6)
  int op_slot_right_5361 = gc_frame_newslot(call5363);
// starting to compile string node (depth = 6)
  if (strlit5365 == NULL) {
    strlit5365 = alloc_String("");
    gc_root(strlit5365);
  }
// compiled string node returning strlit5365 (depth = 6)
  int op_slot_left_5361 = gc_frame_newslot(strlit5365);
  params[0] = call5363;
  partcv[0] = 1;
  Object opresult5366 = callmethod(strlit5365, "++", 1, partcv, params);
// compiled op node returning opresult5366 (depth = 5)
  int op_slot_left_5358 = gc_frame_newslot(opresult5366);
  params[0] = strlit5359;
  partcv[0] = 1;
  Object opresult5367 = callmethod(opresult5366, "++", 1, partcv, params);
// compiled op node returning opresult5367 (depth = 4)
    gc_frame_newslot(opresult5367);
    if5355 = opresult5367;
  } else {
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5370 = callmethodflags(self, "inClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5369);
// compiled call node returning call5370 (depth = 6)
// compiled member node returning call5370 (depth = 5)
  Object if5368 = done;
  if (istrue(call5370)) {
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5372 == NULL) {
    strlit5372 = alloc_String(" (class)");
    gc_root(strlit5372);
  }
// compiled string node returning strlit5372 (depth = 6)
  int op_slot_right_5371 = gc_frame_newslot(strlit5372);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5376 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5375);
// compiled call node returning call5376 (depth = 8)
// compiled member node returning call5376 (depth = 7)
  int op_slot_right_5374 = gc_frame_newslot(call5376);
// starting to compile string node (depth = 7)
  if (strlit5378 == NULL) {
    strlit5378 = alloc_String("");
    gc_root(strlit5378);
  }
// compiled string node returning strlit5378 (depth = 7)
  int op_slot_left_5374 = gc_frame_newslot(strlit5378);
  params[0] = call5376;
  partcv[0] = 1;
  Object opresult5379 = callmethod(strlit5378, "++", 1, partcv, params);
// compiled op node returning opresult5379 (depth = 6)
  int op_slot_left_5371 = gc_frame_newslot(opresult5379);
  params[0] = strlit5372;
  partcv[0] = 1;
  Object opresult5380 = callmethod(opresult5379, "++", 1, partcv, params);
// compiled op node returning opresult5380 (depth = 5)
    gc_frame_newslot(opresult5380);
    if5368 = opresult5380;
  } else {
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5381 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5382 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5381);
// compiled call node returning call5382 (depth = 6)
// compiled member node returning call5382 (depth = 5)
    gc_frame_newslot(call5382);
    if5368 = call5382;
  }
// compiled if node returning if5368 (depth = 4)
    gc_frame_newslot(if5368);
    if5355 = if5368;
  }
// compiled if node returning if5355 (depth = 3)
  gc_frame_end(frame);
  return if5355;
}
Object meth_ast__apply5398(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5400 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  partcv[0] = 0;
  Object call5402 = callmethod(*var_each, "isLegalInTrait",
    1, partcv, params);
  gc_frame_end(callframe5401);
// compiled call node returning call5402 (depth = 9)
// compiled member node returning call5402 (depth = 8)
  partcv[0] = 0;
  Object call5403 = callmethod(call5402, "not",
    1, partcv, params);
  gc_frame_end(callframe5400);
// compiled call node returning call5403 (depth = 7)
// compiled member node returning call5403 (depth = 6)
  Object if5399 = done;
  if (istrue(call5403)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5404 = alloc_Boolean(0);
// compiled identifier node returning bool5404 (depth = 7)
  block_return(realself, bool5404);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5399 = undefined;
  } else {
  }
// compiled if node returning if5399 (depth = 5)
  gc_frame_end(frame);
  return if5399;
}
Object meth_ast_isTrait5383(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5386 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5385);
// compiled call node returning call5386 (depth = 5)
// compiled member node returning call5386 (depth = 4)
  Object if5384 = done;
  if (istrue(call5386)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5387 = alloc_Boolean(1);
// compiled identifier node returning bool5387 (depth = 5)
  return bool5387;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5384 = undefined;
  } else {
  }
// compiled if node returning if5384 (depth = 3)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5390 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5391 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5390);
// compiled call node returning call5391 (depth = 6)
// compiled member node returning call5391 (depth = 5)
  int op_slot_right_5389 = gc_frame_newslot(call5391);
// starting to compile identifier node (depth = 5)
  Object bool5393 = alloc_Boolean(0);
// compiled identifier node returning bool5393 (depth = 5)
  int op_slot_left_5389 = gc_frame_newslot(bool5393);
  params[0] = call5391;
  partcv[0] = 1;
  Object opresult5394 = callmethod(bool5393, "!=", 1, partcv, params);
// compiled op node returning opresult5394 (depth = 4)
  Object if5388 = done;
  if (istrue(opresult5394)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5395 = alloc_Boolean(0);
// compiled identifier node returning bool5395 (depth = 5)
  return bool5395;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5388 = undefined;
  } else {
  }
// compiled if node returning if5388 (depth = 3)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5396 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5397 = alloc_Block(NULL, NULL, "ast", 1261);
  gc_frame_newslot(block5397);
// method "_apply"
  block_savedest(block5397);
  Object closure5398 = createclosure(1, "_apply");
  setclosureframe(closure5398, stackframe);
  addtoclosure(closure5398, selfslot);
  struct UserObject *uo5398 = (struct UserObject*)block5397;
  uo5398->data[0] = (Object)closure5398;
  Method *meth_meth_ast__apply5398 = addmethod2pos(block5397, "_apply", &meth_ast__apply5398, 0);
  int argcv_meth_ast__apply5398[] = {1};
  meth_meth_ast__apply5398->type = alloc_MethodType(1, argcv_meth_ast__apply5398);
  meth_meth_ast__apply5398->definitionModule = modulename;
  meth_meth_ast__apply5398->definitionLine = 1260;
// compiled block node returning block5397 (depth = 4)
  gc_frame_newslot(block5397);
// call case 6: other member request
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5406 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5407 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5406);
// compiled call node returning call5407 (depth = 5)
// compiled member node returning call5407 (depth = 4)
  params[0] = block5397;
  partcv[0] = 1;
  Object call5408 = callmethod(call5407, "do",
    1, partcv, params);
  gc_frame_end(callframe5396);
// compiled call node returning call5408 (depth = 3)
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5409 = alloc_Boolean(1);
// compiled identifier node returning bool5409 (depth = 4)
  return bool5409;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply5426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call5430 = callmethod(*var_node, "isMethod",
    1, partcv, params);
  gc_frame_end(callframe5429);
// compiled call node returning call5430 (depth = 9)
// compiled member node returning call5430 (depth = 8)
  int op_slot_right_5428 = gc_frame_newslot(call5430);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5432 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call5433 = callmethod(*var_node, "isFieldDec",
    1, partcv, params);
  gc_frame_end(callframe5432);
// compiled call node returning call5433 (depth = 9)
// compiled member node returning call5433 (depth = 8)
  int op_slot_left_5428 = gc_frame_newslot(call5433);
  params[0] = call5430;
  partcv[0] = 1;
  Object opresult5434 = callmethod(call5433, "||", 1, partcv, params);
// compiled op node returning opresult5434 (depth = 7)
  Object if5427 = done;
  if (istrue(opresult5434)) {
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5435 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call5437 = callmethod(*var_node, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5436);
// compiled call node returning call5437 (depth = 9)
// compiled member node returning call5437 (depth = 8)
  gc_frame_newslot(call5437);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5438 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5439 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5438);
// compiled call node returning call5439 (depth = 9)
// compiled member node returning call5439 (depth = 8)
  params[0] = call5437;
  partcv[0] = 1;
  Object call5440 = callmethod(call5439, "add",
    1, partcv, params);
  gc_frame_end(callframe5435);
// compiled call node returning call5440 (depth = 7)
    gc_frame_newslot(call5440);
    if5427 = call5440;
  } else {
  }
// compiled if node returning if5427 (depth = 6)
  gc_frame_end(frame);
  return if5427;
}
Object meth_ast_localNames5410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "localNames");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for localNames (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for localNames");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5413 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5414 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5413);
// compiled call node returning call5414 (depth = 6)
// compiled member node returning call5414 (depth = 5)
  int op_slot_right_5412 = gc_frame_newslot(call5414);
// starting to compile identifier node (depth = 5)
  Object bool5416 = alloc_Boolean(0);
// compiled identifier node returning bool5416 (depth = 5)
  int op_slot_left_5412 = gc_frame_newslot(bool5416);
  params[0] = call5414;
  partcv[0] = 1;
  Object opresult5417 = callmethod(bool5416, "==", 1, partcv, params);
// compiled op node returning opresult5417 (depth = 4)
  Object if5411 = done;
  if (istrue(opresult5417)) {
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5418 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5419 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5420 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5421 = callmethodflags(prelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5420);
// compiled call node returning call5421 (depth = 8)
// compiled member node returning call5421 (depth = 7)
  partcv[0] = 0;
  Object call5422 = callmethod(call5421, "empty",
    1, partcv, params);
  gc_frame_end(callframe5419);
// compiled call node returning call5422 (depth = 6)
// compiled member node returning call5422 (depth = 5)
  gc_frame_newslot(call5422);
// call case 4: self request
  params[0] = call5422;
  partcv[0] = 1;
  Object call5423 = callmethodflags(self, "myLocalNames:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5418);
// compiled call node returning call5423 (depth = 4)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5424 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5425 = alloc_Block(NULL, NULL, "ast", 1272);
  gc_frame_newslot(block5425);
// method "_apply"
  block_savedest(block5425);
  Object closure5426 = createclosure(1, "_apply");
  setclosureframe(closure5426, stackframe);
  addtoclosure(closure5426, selfslot);
  struct UserObject *uo5426 = (struct UserObject*)block5425;
  uo5426->data[0] = (Object)closure5426;
  Method *meth_meth_ast__apply5426 = addmethod2pos(block5425, "_apply", &meth_ast__apply5426, 0);
  int argcv_meth_ast__apply5426[] = {1};
  meth_meth_ast__apply5426->type = alloc_MethodType(1, argcv_meth_ast__apply5426);
  meth_meth_ast__apply5426->definitionModule = modulename;
  meth_meth_ast__apply5426->definitionLine = 1271;
// compiled block node returning block5425 (depth = 5)
  gc_frame_newslot(block5425);
// call case 6: other member request
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5443 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5442);
// compiled call node returning call5443 (depth = 6)
// compiled member node returning call5443 (depth = 5)
  params[0] = block5425;
  partcv[0] = 1;
  Object call5444 = callmethod(call5443, "do",
    1, partcv, params);
  gc_frame_end(callframe5424);
// compiled call node returning call5444 (depth = 4)
    gc_frame_newslot(call5444);
    if5411 = call5444;
  } else {
  }
// compiled if node returning if5411 (depth = 3)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5445 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5446 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5445);
// compiled call node returning call5446 (depth = 4)
// compiled member node returning call5446 (depth = 3)
  gc_frame_end(frame);
  return call5446;
}
Object meth_ast__apply5461(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5462 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call5463 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5462);
// compiled call node returning call5463 (depth = 5)
  gc_frame_end(frame);
  return call5463;
}
Object meth_ast_parentsDo5447(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parentsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parentsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parentsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parentsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5450 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5451 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5450);
// compiled call node returning call5451 (depth = 6)
// compiled member node returning call5451 (depth = 5)
  int op_slot_right_5449 = gc_frame_newslot(call5451);
// starting to compile identifier node (depth = 5)
  Object bool5453 = alloc_Boolean(0);
// compiled identifier node returning bool5453 (depth = 5)
  int op_slot_left_5449 = gc_frame_newslot(bool5453);
  params[0] = call5451;
  partcv[0] = 1;
  Object opresult5454 = callmethod(bool5453, "!=", 1, partcv, params);
// compiled op node returning opresult5454 (depth = 4)
  Object if5448 = done;
  if (istrue(opresult5454)) {
// starting to compile call node (depth = 4)
  int callframe5455 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5456 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5457 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5456);
// compiled call node returning call5457 (depth = 6)
// compiled member node returning call5457 (depth = 5)
  gc_frame_newslot(call5457);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call5457;
  partcv[0] = 1;
  Object call5458 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5455);
// compiled call node returning call5458 (depth = 4)
    gc_frame_newslot(call5458);
    if5448 = call5458;
  } else {
  }
// compiled if node returning if5448 (depth = 3)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5459 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5460 = alloc_Block(NULL, NULL, "ast", 1285);
  gc_frame_newslot(block5460);
// method "_apply"
  block_savedest(block5460);
  Object closure5461 = createclosure(2, "_apply");
  setclosureframe(closure5461, stackframe);
  addtoclosure(closure5461, var_action);
  addtoclosure(closure5461, selfslot);
  struct UserObject *uo5461 = (struct UserObject*)block5460;
  uo5461->data[0] = (Object)closure5461;
  Method *meth_meth_ast__apply5461 = addmethod2pos(block5460, "_apply", &meth_ast__apply5461, 0);
  int argcv_meth_ast__apply5461[] = {1};
  meth_meth_ast__apply5461->type = alloc_MethodType(1, argcv_meth_ast__apply5461);
  meth_meth_ast__apply5461->definitionModule = modulename;
  meth_meth_ast__apply5461->definitionLine = 1284;
// compiled block node returning block5460 (depth = 4)
  gc_frame_newslot(block5460);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5466 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5465);
// compiled call node returning call5466 (depth = 5)
// compiled member node returning call5466 (depth = 4)
  params[0] = block5460;
  partcv[0] = 1;
  Object call5467 = callmethod(call5466, "do",
    1, partcv, params);
  gc_frame_end(callframe5459);
// compiled call node returning call5467 (depth = 3)
  gc_frame_end(frame);
  return call5467;
}
Object meth_ast__apply5471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5474 = callmethod(*var_o, "isMethod",
    1, partcv, params);
  gc_frame_end(callframe5473);
// compiled call node returning call5474 (depth = 7)
// compiled member node returning call5474 (depth = 6)
  Object if5472 = done;
  if (istrue(call5474)) {
// starting to compile call node (depth = 6)
  int callframe5475 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5476 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5475);
// compiled call node returning call5476 (depth = 6)
    gc_frame_newslot(call5476);
    if5472 = call5476;
  } else {
  }
// compiled if node returning if5472 (depth = 5)
  gc_frame_end(frame);
  return if5472;
}
Object meth_ast_methodsDo5468(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "methodsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for methodsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5469 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5470 = alloc_Block(NULL, NULL, "ast", 1291);
  gc_frame_newslot(block5470);
// method "_apply"
  block_savedest(block5470);
  Object closure5471 = createclosure(2, "_apply");
  setclosureframe(closure5471, stackframe);
  addtoclosure(closure5471, var_action);
  addtoclosure(closure5471, selfslot);
  struct UserObject *uo5471 = (struct UserObject*)block5470;
  uo5471->data[0] = (Object)closure5471;
  Method *meth_meth_ast__apply5471 = addmethod2pos(block5470, "_apply", &meth_ast__apply5471, 0);
  int argcv_meth_ast__apply5471[] = {1};
  meth_meth_ast__apply5471->type = alloc_MethodType(1, argcv_meth_ast__apply5471);
  meth_meth_ast__apply5471->definitionModule = modulename;
  meth_meth_ast__apply5471->definitionLine = 1285;
// compiled block node returning block5470 (depth = 4)
  gc_frame_newslot(block5470);
// call case 6: other member request
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5479 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5478);
// compiled call node returning call5479 (depth = 5)
// compiled member node returning call5479 (depth = 4)
  params[0] = block5470;
  partcv[0] = 1;
  Object call5480 = callmethod(call5479, "do",
    1, partcv, params);
  gc_frame_end(callframe5469);
// compiled call node returning call5480 (depth = 3)
  gc_frame_end(frame);
  return call5480;
}
Object meth_ast__apply5484(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5487 = callmethod(*var_o, "isExecutable",
    1, partcv, params);
  gc_frame_end(callframe5486);
// compiled call node returning call5487 (depth = 7)
// compiled member node returning call5487 (depth = 6)
  Object if5485 = done;
  if (istrue(call5487)) {
// starting to compile call node (depth = 6)
  int callframe5488 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5489 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5488);
// compiled call node returning call5489 (depth = 6)
    gc_frame_newslot(call5489);
    if5485 = call5489;
  } else {
  }
// compiled if node returning if5485 (depth = 5)
  gc_frame_end(frame);
  return if5485;
}
Object meth_ast_executableComponentsDo5481(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "executableComponentsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method executableComponentsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for executableComponentsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for executableComponentsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5482 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5483 = alloc_Block(NULL, NULL, "ast", 1299);
  gc_frame_newslot(block5483);
// method "_apply"
  block_savedest(block5483);
  Object closure5484 = createclosure(2, "_apply");
  setclosureframe(closure5484, stackframe);
  addtoclosure(closure5484, var_action);
  addtoclosure(closure5484, selfslot);
  struct UserObject *uo5484 = (struct UserObject*)block5483;
  uo5484->data[0] = (Object)closure5484;
  Method *meth_meth_ast__apply5484 = addmethod2pos(block5483, "_apply", &meth_ast__apply5484, 0);
  int argcv_meth_ast__apply5484[] = {1};
  meth_meth_ast__apply5484->type = alloc_MethodType(1, argcv_meth_ast__apply5484);
  meth_meth_ast__apply5484->definitionModule = modulename;
  meth_meth_ast__apply5484->definitionLine = 1291;
// compiled block node returning block5483 (depth = 4)
  gc_frame_newslot(block5483);
// call case 6: other member request
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5492 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5491);
// compiled call node returning call5492 (depth = 5)
// compiled member node returning call5492 (depth = 4)
  params[0] = block5483;
  partcv[0] = 1;
  Object call5493 = callmethod(call5492, "do",
    1, partcv, params);
  gc_frame_end(callframe5482);
// compiled call node returning call5493 (depth = 3)
  gc_frame_end(frame);
  return call5493;
}
Object meth_ast_scope_58__61_5494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5495 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call5496 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5495);
// compiled call node returning call5496 (depth = 3)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5497 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5498 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe5497);
// compiled call node returning call5498 (depth = 3)
  gc_frame_end(frame);
  return call5498;
}
Object meth_ast_body5499(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5501 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5500);
// compiled call node returning call5501 (depth = 4)
// compiled member node returning call5501 (depth = 3)
  gc_frame_end(frame);
  return call5501;
}
Object meth_ast_returnsObject5502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5503 = alloc_Boolean(1);
// compiled identifier node returning bool5503 (depth = 3)
  gc_frame_end(frame);
  return bool5503;
}
Object meth_ast_returnedObjectScope5504(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5505 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5506 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5505);
// compiled call node returning call5506 (depth = 4)
// compiled member node returning call5506 (depth = 3)
  gc_frame_end(frame);
  return call5506;
}
Object meth_ast_canInherit5507(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5508 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5510 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5509);
// compiled call node returning call5510 (depth = 6)
// compiled member node returning call5510 (depth = 5)
  partcv[0] = 0;
  Object call5511 = callmethod(call5510, "not",
    1, partcv, params);
  gc_frame_end(callframe5508);
// compiled call node returning call5511 (depth = 4)
// compiled member node returning call5511 (depth = 3)
  gc_frame_end(frame);
  return call5511;
}
Object meth_ast_canUse5512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for canUse (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for canUse");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5513 = alloc_Boolean(1);
// compiled identifier node returning bool5513 (depth = 3)
  gc_frame_end(frame);
  return bool5513;
}
Object meth_ast_isObject5514(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5515 = alloc_Boolean(1);
// compiled identifier node returning bool5515 (depth = 3)
  gc_frame_end(frame);
  return bool5515;
}
Object meth_ast__apply5535(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5536 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5537 = callmethod(*var_t, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5536);
// compiled call node returning call5537 (depth = 6)
  gc_frame_end(frame);
  return call5537;
}
Object meth_ast__apply5544(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5545 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5546 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5545);
// compiled call node returning call5546 (depth = 6)
  gc_frame_end(frame);
  return call5546;
}
Object meth_ast_accept_40__41_from5516(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5518 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5519 = callmethod(*var_visitor, "visitObject()up",
    2, partcv, params);
  gc_frame_end(callframe5518);
// compiled call node returning call5519 (depth = 4)
  Object if5517 = done;
  if (istrue(call5519)) {
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5520 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5521 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5520);
// compiled call node returning call5521 (depth = 5)
  *var_newChain = call5521;
  if (call5521 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5524 = alloc_Boolean(0);
// compiled identifier node returning bool5524 (depth = 6)
  int op_slot_right_5523 = gc_frame_newslot(bool5524);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5527 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5526);
// compiled call node returning call5527 (depth = 7)
// compiled member node returning call5527 (depth = 6)
  int op_slot_left_5523 = gc_frame_newslot(call5527);
  params[0] = bool5524;
  partcv[0] = 1;
  Object opresult5528 = callmethod(call5527, "!=", 1, partcv, params);
// compiled op node returning opresult5528 (depth = 5)
  Object if5522 = done;
  if (istrue(opresult5528)) {
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5529 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5531 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5530);
// compiled call node returning call5531 (depth = 7)
// compiled member node returning call5531 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5532 = callmethod(call5531, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5529);
// compiled call node returning call5532 (depth = 5)
    gc_frame_newslot(call5532);
    if5522 = call5532;
  } else {
  }
// compiled if node returning if5522 (depth = 4)
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5533 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5534 = alloc_Block(NULL, NULL, "ast", 1322);
  gc_frame_newslot(block5534);
// method "_apply"
  block_savedest(block5534);
  Object closure5535 = createclosure(3, "_apply");
  setclosureframe(closure5535, stackframe);
  addtoclosure(closure5535, var_visitor);
  addtoclosure(closure5535, var_newChain);
  addtoclosure(closure5535, selfslot);
  struct UserObject *uo5535 = (struct UserObject*)block5534;
  uo5535->data[0] = (Object)closure5535;
  Method *meth_meth_ast__apply5535 = addmethod2pos(block5534, "_apply", &meth_ast__apply5535, 0);
  int argcv_meth_ast__apply5535[] = {1};
  meth_meth_ast__apply5535->type = alloc_MethodType(1, argcv_meth_ast__apply5535);
  meth_meth_ast__apply5535->definitionModule = modulename;
  meth_meth_ast__apply5535->definitionLine = 1320;
// compiled block node returning block5534 (depth = 5)
  gc_frame_newslot(block5534);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5539 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5540 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5539);
// compiled call node returning call5540 (depth = 6)
// compiled member node returning call5540 (depth = 5)
  params[0] = block5534;
  partcv[0] = 1;
  Object call5541 = callmethod(call5540, "do",
    1, partcv, params);
  gc_frame_end(callframe5533);
// compiled call node returning call5541 (depth = 4)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5542 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5543 = alloc_Block(NULL, NULL, "ast", 1323);
  gc_frame_newslot(block5543);
// method "_apply"
  block_savedest(block5543);
  Object closure5544 = createclosure(3, "_apply");
  setclosureframe(closure5544, stackframe);
  addtoclosure(closure5544, var_visitor);
  addtoclosure(closure5544, var_newChain);
  addtoclosure(closure5544, selfslot);
  struct UserObject *uo5544 = (struct UserObject*)block5543;
  uo5544->data[0] = (Object)closure5544;
  Method *meth_meth_ast__apply5544 = addmethod2pos(block5543, "_apply", &meth_ast__apply5544, 0);
  int argcv_meth_ast__apply5544[] = {1};
  meth_meth_ast__apply5544->type = alloc_MethodType(1, argcv_meth_ast__apply5544);
  meth_meth_ast__apply5544->definitionModule = modulename;
  meth_meth_ast__apply5544->definitionLine = 1322;
// compiled block node returning block5543 (depth = 5)
  gc_frame_newslot(block5543);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5548 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5549 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5548);
// compiled call node returning call5549 (depth = 6)
// compiled member node returning call5549 (depth = 5)
  params[0] = block5543;
  partcv[0] = 1;
  Object call5550 = callmethod(call5549, "do",
    1, partcv, params);
  gc_frame_end(callframe5542);
// compiled call node returning call5550 (depth = 4)
    gc_frame_newslot(call5550);
    if5517 = call5550;
  } else {
  }
// compiled if node returning if5517 (depth = 3)
  gc_frame_end(frame);
  return if5517;
}
Object meth_ast_nameString5551(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5554 == NULL) {
    strlit5554 = alloc_String("object");
    gc_root(strlit5554);
  }
// compiled string node returning strlit5554 (depth = 5)
  int op_slot_right_5553 = gc_frame_newslot(strlit5554);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5557 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5556);
// compiled call node returning call5557 (depth = 6)
// compiled member node returning call5557 (depth = 5)
  int op_slot_left_5553 = gc_frame_newslot(call5557);
  params[0] = strlit5554;
  partcv[0] = 1;
  Object opresult5558 = callmethod(call5557, "==", 1, partcv, params);
// compiled op node returning opresult5558 (depth = 4)
  Object if5552 = done;
  if (istrue(opresult5558)) {
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5560 == NULL) {
    strlit5560 = alloc_String("");
    gc_root(strlit5560);
  }
// compiled string node returning strlit5560 (depth = 5)
  int op_slot_right_5559 = gc_frame_newslot(strlit5560);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5563 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5564 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5563);
// compiled call node returning call5564 (depth = 7)
// compiled member node returning call5564 (depth = 6)
  int op_slot_right_5562 = gc_frame_newslot(call5564);
// starting to compile string node (depth = 6)
  if (strlit5566 == NULL) {
    strlit5566 = alloc_String("object_on_line_");
    gc_root(strlit5566);
  }
// compiled string node returning strlit5566 (depth = 6)
  int op_slot_left_5562 = gc_frame_newslot(strlit5566);
  params[0] = call5564;
  partcv[0] = 1;
  Object opresult5567 = callmethod(strlit5566, "++", 1, partcv, params);
// compiled op node returning opresult5567 (depth = 5)
  int op_slot_left_5559 = gc_frame_newslot(opresult5567);
  params[0] = strlit5560;
  partcv[0] = 1;
  Object opresult5568 = callmethod(opresult5567, "++", 1, partcv, params);
// compiled op node returning opresult5568 (depth = 4)
    gc_frame_newslot(opresult5568);
    if5552 = opresult5568;
  } else {
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5569 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5570 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5569);
// compiled call node returning call5570 (depth = 5)
// compiled member node returning call5570 (depth = 4)
    gc_frame_newslot(call5570);
    if5552 = call5570;
  }
// compiled if node returning if5552 (depth = 3)
  gc_frame_end(frame);
  return if5552;
}
Object meth_ast_map_40__41_ancestors5571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5572 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5573 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5572);
// compiled call node returning call5573 (depth = 5)
// compiled member node returning call5573 (depth = 4)
  *var_n = call5573;
  if (call5573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5574 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5575 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5574);
// compiled call node returning call5575 (depth = 4)
  *var_newChain = call5575;
  if (call5575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5576 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5577 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5578 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5579 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5578);
// compiled call node returning call5579 (depth = 6)
// compiled member node returning call5579 (depth = 5)
  gc_frame_newslot(call5579);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5580 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5581 = gc_frame_new();
// call case 3: self.outer request
  Object call5582 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5581);
// compiled call node returning call5582 (depth = 8)
// compiled member node returning call5582 (depth = 7)
  partcv[0] = 0;
  Object call5583 = callmethodflags(call5582, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5580);
// compiled call node returning call5583 (depth = 6)
// compiled member node returning call5583 (depth = 5)
  params[0] = call5579;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5584 = callmethodflags(call5583, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5577);
// compiled call node returning call5584 (depth = 4)
  gc_frame_newslot(call5584);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5584;
  partcv[0] = 1;
  Object call5585 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe5576);
// compiled call node returning call5585 (depth = 3)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5586 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5587 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5589 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5588);
// compiled call node returning call5589 (depth = 6)
// compiled member node returning call5589 (depth = 5)
  gc_frame_newslot(call5589);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5590 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5591 = gc_frame_new();
// call case 3: self.outer request
  Object call5592 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5591);
// compiled call node returning call5592 (depth = 8)
// compiled member node returning call5592 (depth = 7)
  partcv[0] = 0;
  Object call5593 = callmethodflags(call5592, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5590);
// compiled call node returning call5593 (depth = 6)
// compiled member node returning call5593 (depth = 5)
  params[0] = call5589;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5594 = callmethodflags(call5593, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5587);
// compiled call node returning call5594 (depth = 4)
  gc_frame_newslot(call5594);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5594;
  partcv[0] = 1;
  Object call5595 = callmethod(*var_n, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe5586);
// compiled call node returning call5595 (depth = 3)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5596 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5597 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5598 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5599 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5598);
// compiled call node returning call5599 (depth = 6)
// compiled member node returning call5599 (depth = 5)
  gc_frame_newslot(call5599);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5600 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5601 = gc_frame_new();
// call case 3: self.outer request
  Object call5602 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5601);
// compiled call node returning call5602 (depth = 8)
// compiled member node returning call5602 (depth = 7)
  partcv[0] = 0;
  Object call5603 = callmethodflags(call5602, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5600);
// compiled call node returning call5603 (depth = 6)
// compiled member node returning call5603 (depth = 5)
  params[0] = call5599;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5604 = callmethodflags(call5603, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5597);
// compiled call node returning call5604 (depth = 4)
  gc_frame_newslot(call5604);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5604;
  partcv[0] = 1;
  Object call5605 = callmethod(*var_n, "usedTraits:=",
    1, partcv, params);
  gc_frame_end(callframe5596);
// compiled call node returning call5605 (depth = 3)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5606 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5607 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5606);
// compiled call node returning call5607 (depth = 3)
  gc_frame_end(frame);
  return call5607;
}
Object meth_ast__apply5616(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5618 == NULL) {
    strlit5618 = alloc_String("  ");
    gc_root(strlit5618);
  }
// compiled string node returning strlit5618 (depth = 7)
  int op_slot_right_5617 = gc_frame_newslot(strlit5618);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5617 = gc_frame_newslot(*var_spc);
  params[0] = strlit5618;
  partcv[0] = 1;
  Object opresult5620 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5620 (depth = 6)
  *var_spc = opresult5620;
  if (opresult5620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5704 == NULL) {
    strlit5704 = alloc_String("");
    gc_root(strlit5704);
  }
// compiled string node returning strlit5704 (depth = 8)
  int op_slot_right_5703 = gc_frame_newslot(strlit5704);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5707 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5709 = alloc_Float64(1);
// compiled num node returning num5709 (depth = 11)
  int op_slot_right_5708 = gc_frame_newslot(num5709);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5708 = gc_frame_newslot(*var_depth);
  params[0] = num5709;
  partcv[0] = 1;
  Object sum5711 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5711 (depth = 10)
  gc_frame_newslot(sum5711);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  params[0] = sum5711;
  partcv[0] = 1;
  Object call5712 = callmethod(*var_t, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5707);
// compiled call node returning call5712 (depth = 9)
  int op_slot_right_5706 = gc_frame_newslot(call5712);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5715 == NULL) {
    strlit5715 = alloc_String("  ");
    gc_root(strlit5715);
  }
// compiled string node returning strlit5715 (depth = 10)
  int op_slot_right_5714 = gc_frame_newslot(strlit5715);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5717 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5720 == NULL) {
    strlit5720 = alloc_String("""\x0a""");
    gc_root(strlit5720);
  }
// compiled string node returning strlit5720 (depth = 12)
  int op_slot_right_5719 = gc_frame_newslot(strlit5720);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_5722 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit5724 == NULL) {
    strlit5724 = alloc_String("");
    gc_root(strlit5724);
  }
// compiled string node returning strlit5724 (depth = 13)
  int op_slot_left_5722 = gc_frame_newslot(strlit5724);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5725 = callmethod(strlit5724, "++", 1, partcv, params);
// compiled op node returning opresult5725 (depth = 12)
  int op_slot_left_5719 = gc_frame_newslot(opresult5725);
  params[0] = strlit5720;
  partcv[0] = 1;
  Object opresult5726 = callmethod(opresult5725, "++", 1, partcv, params);
// compiled op node returning opresult5726 (depth = 11)
  int op_slot_left_5717 = gc_frame_newslot(opresult5726);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5727 = callmethod(opresult5726, "++", 1, partcv, params);
// compiled op node returning opresult5727 (depth = 10)
  int op_slot_left_5714 = gc_frame_newslot(opresult5727);
  params[0] = strlit5715;
  partcv[0] = 1;
  Object opresult5728 = callmethod(opresult5727, "++", 1, partcv, params);
// compiled op node returning opresult5728 (depth = 9)
  int op_slot_left_5706 = gc_frame_newslot(opresult5728);
  params[0] = call5712;
  partcv[0] = 1;
  Object opresult5729 = callmethod(opresult5728, "++", 1, partcv, params);
// compiled op node returning opresult5729 (depth = 8)
  int op_slot_left_5703 = gc_frame_newslot(opresult5729);
  params[0] = strlit5704;
  partcv[0] = 1;
  Object opresult5730 = callmethod(opresult5729, "++", 1, partcv, params);
// compiled op node returning opresult5730 (depth = 7)
  *var_s = opresult5730;
  if (opresult5730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5738(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5740 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5742 = alloc_Float64(1);
// compiled num node returning num5742 (depth = 9)
  int op_slot_right_5741 = gc_frame_newslot(num5742);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5741 = gc_frame_newslot(*var_depth);
  params[0] = num5742;
  partcv[0] = 1;
  Object sum5744 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5744 (depth = 8)
  gc_frame_newslot(sum5744);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5744;
  partcv[0] = 1;
  Object call5745 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5740);
// compiled call node returning call5745 (depth = 7)
  int op_slot_right_5739 = gc_frame_newslot(call5745);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5747 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5750 == NULL) {
    strlit5750 = alloc_String("""\x0a""");
    gc_root(strlit5750);
  }
// compiled string node returning strlit5750 (depth = 9)
  int op_slot_right_5749 = gc_frame_newslot(strlit5750);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5749 = gc_frame_newslot(*var_s);
  params[0] = strlit5750;
  partcv[0] = 1;
  Object opresult5752 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5752 (depth = 8)
  int op_slot_left_5747 = gc_frame_newslot(opresult5752);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5753 = callmethod(opresult5752, "++", 1, partcv, params);
// compiled op node returning opresult5753 (depth = 7)
  int op_slot_left_5739 = gc_frame_newslot(opresult5753);
  params[0] = call5745;
  partcv[0] = 1;
  Object opresult5754 = callmethod(opresult5753, "++", 1, partcv, params);
// compiled op node returning opresult5754 (depth = 6)
  *var_s = opresult5754;
  if (opresult5754 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth_39_ (depth = 4)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5609 == NULL) {
    strlit5609 = alloc_String("");
    gc_root(strlit5609);
  }
// compiled string node returning strlit5609 (depth = 4)
  *var_spc = strlit5609;
  if (strlit5609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5610 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5611 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5613 = alloc_Float64(0);
// compiled num node returning num5613 (depth = 5)
  int op_slot_left_5611 = gc_frame_newslot(num5613);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5614 = callmethod(num5613, "..", 1, partcv, params);
// compiled op node returning opresult5614 (depth = 4)
  gc_frame_newslot(opresult5614);
// starting to compile block node (depth = 4)
  Object block5615 = alloc_Block(NULL, NULL, "ast", 1344);
  gc_frame_newslot(block5615);
// method "_apply"
  block_savedest(block5615);
  Object closure5616 = createclosure(2, "_apply");
  setclosureframe(closure5616, stackframe);
  addtoclosure(closure5616, var_spc);
  addtoclosure(closure5616, selfslot);
  struct UserObject *uo5616 = (struct UserObject*)block5615;
  uo5616->data[0] = (Object)closure5616;
  Method *meth_meth_ast__apply5616 = addmethod2pos(block5615, "_apply", &meth_ast__apply5616, 0);
  int argcv_meth_ast__apply5616[] = {1};
  meth_meth_ast__apply5616->type = alloc_MethodType(1, argcv_meth_ast__apply5616);
  meth_meth_ast__apply5616->definitionModule = modulename;
  meth_meth_ast__apply5616->definitionLine = 1338;
// compiled block node returning block5615 (depth = 4)
  gc_frame_newslot(block5615);
// call case 5: prelude request
  params[0] = opresult5614;
  params[1] = block5615;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5623 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5610);
// compiled call node returning call5623 (depth = 3)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5624 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5625 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5624);
// compiled call node returning call5625 (depth = 4)
  *var_s = call5625;
  if (call5625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5627 == NULL) {
    strlit5627 = alloc_String("");
    gc_root(strlit5627);
  }
// compiled string node returning strlit5627 (depth = 5)
  int op_slot_right_5626 = gc_frame_newslot(strlit5627);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5631 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5630);
// compiled call node returning call5631 (depth = 7)
// compiled member node returning call5631 (depth = 6)
  int op_slot_right_5629 = gc_frame_newslot(call5631);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5634 == NULL) {
    strlit5634 = alloc_String("Name: ");
    gc_root(strlit5634);
  }
// compiled string node returning strlit5634 (depth = 7)
  int op_slot_right_5633 = gc_frame_newslot(strlit5634);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5636 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5639 == NULL) {
    strlit5639 = alloc_String("""\x0a""");
    gc_root(strlit5639);
  }
// compiled string node returning strlit5639 (depth = 9)
  int op_slot_right_5638 = gc_frame_newslot(strlit5639);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_5641 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit5643 == NULL) {
    strlit5643 = alloc_String("");
    gc_root(strlit5643);
  }
// compiled string node returning strlit5643 (depth = 10)
  int op_slot_left_5641 = gc_frame_newslot(strlit5643);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5644 = callmethod(strlit5643, "++", 1, partcv, params);
// compiled op node returning opresult5644 (depth = 9)
  int op_slot_left_5638 = gc_frame_newslot(opresult5644);
  params[0] = strlit5639;
  partcv[0] = 1;
  Object opresult5645 = callmethod(opresult5644, "++", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 8)
  int op_slot_left_5636 = gc_frame_newslot(opresult5645);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5646 = callmethod(opresult5645, "++", 1, partcv, params);
// compiled op node returning opresult5646 (depth = 7)
  int op_slot_left_5633 = gc_frame_newslot(opresult5646);
  params[0] = strlit5634;
  partcv[0] = 1;
  Object opresult5647 = callmethod(opresult5646, "++", 1, partcv, params);
// compiled op node returning opresult5647 (depth = 6)
  int op_slot_left_5629 = gc_frame_newslot(opresult5647);
  params[0] = call5631;
  partcv[0] = 1;
  Object opresult5648 = callmethod(opresult5647, "++", 1, partcv, params);
// compiled op node returning opresult5648 (depth = 5)
  int op_slot_left_5626 = gc_frame_newslot(opresult5648);
  params[0] = strlit5627;
  partcv[0] = 1;
  Object opresult5649 = callmethod(opresult5648, "++", 1, partcv, params);
// compiled op node returning opresult5649 (depth = 4)
  *var_s = opresult5649;
  if (opresult5649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5653 = alloc_Boolean(0);
// compiled identifier node returning bool5653 (depth = 5)
  int op_slot_right_5652 = gc_frame_newslot(bool5653);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5656 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5655);
// compiled call node returning call5656 (depth = 6)
// compiled member node returning call5656 (depth = 5)
  int op_slot_left_5652 = gc_frame_newslot(call5656);
  params[0] = bool5653;
  partcv[0] = 1;
  Object opresult5657 = callmethod(call5656, "!=", 1, partcv, params);
// compiled op node returning opresult5657 (depth = 4)
  Object if5651 = done;
  if (istrue(opresult5657)) {
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5659 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5661 = alloc_Float64(1);
// compiled num node returning num5661 (depth = 8)
  int op_slot_right_5660 = gc_frame_newslot(num5661);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5660 = gc_frame_newslot(*var_depth);
  params[0] = num5661;
  partcv[0] = 1;
  Object sum5663 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5663 (depth = 7)
  gc_frame_newslot(sum5663);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5664 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5665 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5664);
// compiled call node returning call5665 (depth = 8)
// compiled member node returning call5665 (depth = 7)
  params[0] = sum5663;
  partcv[0] = 1;
  Object call5666 = callmethod(call5665, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5659);
// compiled call node returning call5666 (depth = 6)
  int op_slot_right_5658 = gc_frame_newslot(call5666);
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5669 == NULL) {
    strlit5669 = alloc_String("Superclass: ");
    gc_root(strlit5669);
  }
// compiled string node returning strlit5669 (depth = 7)
  int op_slot_right_5668 = gc_frame_newslot(strlit5669);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5671 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5674 == NULL) {
    strlit5674 = alloc_String("""\x0a""");
    gc_root(strlit5674);
  }
// compiled string node returning strlit5674 (depth = 9)
  int op_slot_right_5673 = gc_frame_newslot(strlit5674);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5673 = gc_frame_newslot(*var_s);
  params[0] = strlit5674;
  partcv[0] = 1;
  Object opresult5676 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5676 (depth = 8)
  int op_slot_left_5671 = gc_frame_newslot(opresult5676);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5677 = callmethod(opresult5676, "++", 1, partcv, params);
// compiled op node returning opresult5677 (depth = 7)
  int op_slot_left_5668 = gc_frame_newslot(opresult5677);
  params[0] = strlit5669;
  partcv[0] = 1;
  Object opresult5678 = callmethod(opresult5677, "++", 1, partcv, params);
// compiled op node returning opresult5678 (depth = 6)
  int op_slot_left_5658 = gc_frame_newslot(opresult5678);
  params[0] = call5666;
  partcv[0] = 1;
  Object opresult5679 = callmethod(opresult5678, "++", 1, partcv, params);
// compiled op node returning opresult5679 (depth = 5)
  *var_s = opresult5679;
  if (opresult5679 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5651 = done;
  } else {
  }
// compiled if node returning if5651 (depth = 3)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5682 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5683 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5684 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5685 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5684);
// compiled call node returning call5685 (depth = 9)
// compiled member node returning call5685 (depth = 8)
  partcv[0] = 0;
  Object call5686 = callmethod(call5685, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe5683);
// compiled call node returning call5686 (depth = 7)
// compiled member node returning call5686 (depth = 6)
  partcv[0] = 0;
  Object call5687 = callmethod(call5686, "not",
    1, partcv, params);
  gc_frame_end(callframe5682);
// compiled call node returning call5687 (depth = 5)
// compiled member node returning call5687 (depth = 4)
  Object if5681 = done;
  if (istrue(call5687)) {
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5689 == NULL) {
    strlit5689 = alloc_String("Traits:");
    gc_root(strlit5689);
  }
// compiled string node returning strlit5689 (depth = 6)
  int op_slot_right_5688 = gc_frame_newslot(strlit5689);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5691 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5694 == NULL) {
    strlit5694 = alloc_String("""\x0a""");
    gc_root(strlit5694);
  }
// compiled string node returning strlit5694 (depth = 8)
  int op_slot_right_5693 = gc_frame_newslot(strlit5694);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5693 = gc_frame_newslot(*var_s);
  params[0] = strlit5694;
  partcv[0] = 1;
  Object opresult5696 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5696 (depth = 7)
  int op_slot_left_5691 = gc_frame_newslot(opresult5696);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5697 = callmethod(opresult5696, "++", 1, partcv, params);
// compiled op node returning opresult5697 (depth = 6)
  int op_slot_left_5688 = gc_frame_newslot(opresult5697);
  params[0] = strlit5689;
  partcv[0] = 1;
  Object opresult5698 = callmethod(opresult5697, "++", 1, partcv, params);
// compiled op node returning opresult5698 (depth = 5)
  *var_s = opresult5698;
  if (opresult5698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5700 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5701 = alloc_Block(NULL, NULL, "ast", 1355);
  gc_frame_newslot(block5701);
// method "_apply"
  block_savedest(block5701);
  Object closure5702 = createclosure(4, "_apply");
  setclosureframe(closure5702, stackframe);
  addtoclosure(closure5702, var_depth);
  addtoclosure(closure5702, var_spc);
  addtoclosure(closure5702, var_s);
  addtoclosure(closure5702, selfslot);
  struct UserObject *uo5702 = (struct UserObject*)block5701;
  uo5702->data[0] = (Object)closure5702;
  Method *meth_meth_ast__apply5702 = addmethod2pos(block5701, "_apply", &meth_ast__apply5702, 0);
  int argcv_meth_ast__apply5702[] = {1};
  meth_meth_ast__apply5702->type = alloc_MethodType(1, argcv_meth_ast__apply5702);
  meth_meth_ast__apply5702->definitionModule = modulename;
  meth_meth_ast__apply5702->definitionLine = 1353;
// compiled block node returning block5701 (depth = 5)
  gc_frame_newslot(block5701);
// call case 6: other member request
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5733 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5734 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5733);
// compiled call node returning call5734 (depth = 6)
// compiled member node returning call5734 (depth = 5)
  params[0] = block5701;
  partcv[0] = 1;
  Object call5735 = callmethod(call5734, "do",
    1, partcv, params);
  gc_frame_end(callframe5700);
// compiled call node returning call5735 (depth = 4)
    gc_frame_newslot(call5735);
    if5681 = call5735;
  } else {
  }
// compiled if node returning if5681 (depth = 3)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5736 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5737 = alloc_Block(NULL, NULL, "ast", 1359);
  gc_frame_newslot(block5737);
// method "_apply"
  block_savedest(block5737);
  Object closure5738 = createclosure(4, "_apply");
  setclosureframe(closure5738, stackframe);
  addtoclosure(closure5738, var_depth);
  addtoclosure(closure5738, var_spc);
  addtoclosure(closure5738, var_s);
  addtoclosure(closure5738, selfslot);
  struct UserObject *uo5738 = (struct UserObject*)block5737;
  uo5738->data[0] = (Object)closure5738;
  Method *meth_meth_ast__apply5738 = addmethod2pos(block5737, "_apply", &meth_ast__apply5738, 0);
  int argcv_meth_ast__apply5738[] = {1};
  meth_meth_ast__apply5738->type = alloc_MethodType(1, argcv_meth_ast__apply5738);
  meth_meth_ast__apply5738->definitionModule = modulename;
  meth_meth_ast__apply5738->definitionLine = 1355;
// compiled block node returning block5737 (depth = 4)
  gc_frame_newslot(block5737);
// call case 6: other member request
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5757 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5758 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5757);
// compiled call node returning call5758 (depth = 5)
// compiled member node returning call5758 (depth = 4)
  params[0] = block5737;
  partcv[0] = 1;
  Object call5759 = callmethod(call5758, "do",
    1, partcv, params);
  gc_frame_end(callframe5736);
// compiled call node returning call5759 (depth = 3)
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5772(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5774 == NULL) {
    strlit5774 = alloc_String("    ");
    gc_root(strlit5774);
  }
// compiled string node returning strlit5774 (depth = 7)
  int op_slot_right_5773 = gc_frame_newslot(strlit5774);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5773 = gc_frame_newslot(*var_spc);
  params[0] = strlit5774;
  partcv[0] = 1;
  Object opresult5776 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5776 (depth = 6)
  *var_spc = opresult5776;
  if (opresult5776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5822(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5824 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5826 = alloc_Float64(1);
// compiled num node returning num5826 (depth = 9)
  int op_slot_right_5825 = gc_frame_newslot(num5826);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5825 = gc_frame_newslot(*var_depth);
  params[0] = num5826;
  partcv[0] = 1;
  Object sum5828 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5828 (depth = 8)
  gc_frame_newslot(sum5828);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = sum5828;
  partcv[0] = 1;
  Object call5829 = callmethod(*var_t, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5824);
// compiled call node returning call5829 (depth = 7)
  int op_slot_right_5823 = gc_frame_newslot(call5829);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5832 == NULL) {
    strlit5832 = alloc_String("""\x0a""");
    gc_root(strlit5832);
  }
// compiled string node returning strlit5832 (depth = 8)
  int op_slot_right_5831 = gc_frame_newslot(strlit5832);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5831 = gc_frame_newslot(*var_s);
  params[0] = strlit5832;
  partcv[0] = 1;
  Object opresult5834 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5834 (depth = 7)
  int op_slot_left_5823 = gc_frame_newslot(opresult5834);
  params[0] = call5829;
  partcv[0] = 1;
  Object opresult5835 = callmethod(opresult5834, "++", 1, partcv, params);
// compiled op node returning opresult5835 (depth = 6)
  *var_s = opresult5835;
  if (opresult5835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5843(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5845 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5847 = alloc_Float64(1);
// compiled num node returning num5847 (depth = 9)
  int op_slot_right_5846 = gc_frame_newslot(num5847);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5846 = gc_frame_newslot(*var_depth);
  params[0] = num5847;
  partcv[0] = 1;
  Object sum5849 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5849 (depth = 8)
  gc_frame_newslot(sum5849);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5849;
  partcv[0] = 1;
  Object call5850 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5845);
// compiled call node returning call5850 (depth = 7)
  int op_slot_right_5844 = gc_frame_newslot(call5850);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5853 == NULL) {
    strlit5853 = alloc_String("    ");
    gc_root(strlit5853);
  }
// compiled string node returning strlit5853 (depth = 8)
  int op_slot_right_5852 = gc_frame_newslot(strlit5853);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5855 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5858 == NULL) {
    strlit5858 = alloc_String("""\x0a""");
    gc_root(strlit5858);
  }
// compiled string node returning strlit5858 (depth = 10)
  int op_slot_right_5857 = gc_frame_newslot(strlit5858);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5857 = gc_frame_newslot(*var_s);
  params[0] = strlit5858;
  partcv[0] = 1;
  Object opresult5860 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5860 (depth = 9)
  int op_slot_left_5855 = gc_frame_newslot(opresult5860);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5861 = callmethod(opresult5860, "++", 1, partcv, params);
// compiled op node returning opresult5861 (depth = 8)
  int op_slot_left_5852 = gc_frame_newslot(opresult5861);
  params[0] = strlit5853;
  partcv[0] = 1;
  Object opresult5862 = callmethod(opresult5861, "++", 1, partcv, params);
// compiled op node returning opresult5862 (depth = 7)
  int op_slot_left_5844 = gc_frame_newslot(opresult5862);
  params[0] = call5850;
  partcv[0] = 1;
  Object opresult5863 = callmethod(opresult5862, "++", 1, partcv, params);
// compiled op node returning opresult5863 (depth = 6)
  *var_s = opresult5863;
  if (opresult5863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5760(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5761 == NULL) {
    strlit5761 = alloc_String("");
    gc_root(strlit5761);
  }
// compiled string node returning strlit5761 (depth = 4)
  *var_spc = strlit5761;
  if (strlit5761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5762 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5765 = alloc_Float64(1);
// compiled num node returning num5765 (depth = 6)
  int op_slot_right_5764 = gc_frame_newslot(num5765);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_5764 = gc_frame_newslot(*var_depth);
  params[0] = num5765;
  partcv[0] = 1;
  Object diff5767 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff5767 (depth = 5)
  int op_slot_right_5763 = gc_frame_newslot(diff5767);
// starting to compile num node (depth = 5)
  Object num5769 = alloc_Float64(0);
// compiled num node returning num5769 (depth = 5)
  int op_slot_left_5763 = gc_frame_newslot(num5769);
  params[0] = diff5767;
  partcv[0] = 1;
  Object opresult5770 = callmethod(num5769, "..", 1, partcv, params);
// compiled op node returning opresult5770 (depth = 4)
  gc_frame_newslot(opresult5770);
// starting to compile block node (depth = 4)
  Object block5771 = alloc_Block(NULL, NULL, "ast", 1366);
  gc_frame_newslot(block5771);
// method "_apply"
  block_savedest(block5771);
  Object closure5772 = createclosure(2, "_apply");
  setclosureframe(closure5772, stackframe);
  addtoclosure(closure5772, var_spc);
  addtoclosure(closure5772, selfslot);
  struct UserObject *uo5772 = (struct UserObject*)block5771;
  uo5772->data[0] = (Object)closure5772;
  Method *meth_meth_ast__apply5772 = addmethod2pos(block5771, "_apply", &meth_ast__apply5772, 0);
  int argcv_meth_ast__apply5772[] = {1};
  meth_meth_ast__apply5772->type = alloc_MethodType(1, argcv_meth_ast__apply5772);
  meth_meth_ast__apply5772->definitionModule = modulename;
  meth_meth_ast__apply5772->definitionLine = 1359;
// compiled block node returning block5771 (depth = 4)
  gc_frame_newslot(block5771);
// call case 5: prelude request
  params[0] = opresult5770;
  params[1] = block5771;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5779 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5762);
// compiled call node returning call5779 (depth = 3)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5780 == NULL) {
    strlit5780 = alloc_String("object {");
    gc_root(strlit5780);
  }
// compiled string node returning strlit5780 (depth = 4)
  *var_s = strlit5780;
  if (strlit5780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5783 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5782);
// compiled call node returning call5783 (depth = 5)
// compiled member node returning call5783 (depth = 4)
  Object if5781 = done;
  if (istrue(call5783)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5785 == NULL) {
    strlit5785 = alloc_String("   // trait");
    gc_root(strlit5785);
  }
// compiled string node returning strlit5785 (depth = 6)
  int op_slot_right_5784 = gc_frame_newslot(strlit5785);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5784 = gc_frame_newslot(*var_s);
  params[0] = strlit5785;
  partcv[0] = 1;
  Object opresult5787 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5787 (depth = 5)
  *var_s = opresult5787;
  if (opresult5787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5781 = done;
  } else {
  }
// compiled if node returning if5781 (depth = 3)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5790 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5791 = callmethodflags(self, "inClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5790);
// compiled call node returning call5791 (depth = 5)
// compiled member node returning call5791 (depth = 4)
  Object if5789 = done;
  if (istrue(call5791)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5793 == NULL) {
    strlit5793 = alloc_String("   // class");
    gc_root(strlit5793);
  }
// compiled string node returning strlit5793 (depth = 6)
  int op_slot_right_5792 = gc_frame_newslot(strlit5793);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5792 = gc_frame_newslot(*var_s);
  params[0] = strlit5793;
  partcv[0] = 1;
  Object opresult5795 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5795 (depth = 5)
  *var_s = opresult5795;
  if (opresult5795 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5789 = done;
  } else {
  }
// compiled if node returning if5789 (depth = 3)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5799 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5800 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5799);
// compiled call node returning call5800 (depth = 6)
// compiled member node returning call5800 (depth = 5)
  int op_slot_right_5798 = gc_frame_newslot(call5800);
// starting to compile identifier node (depth = 5)
  Object bool5802 = alloc_Boolean(0);
// compiled identifier node returning bool5802 (depth = 5)
  int op_slot_left_5798 = gc_frame_newslot(bool5802);
  params[0] = call5800;
  partcv[0] = 1;
  Object opresult5803 = callmethod(bool5802, "!=", 1, partcv, params);
// compiled op node returning opresult5803 (depth = 4)
  Object if5797 = done;
  if (istrue(opresult5803)) {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5805 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5807 = alloc_Float64(1);
// compiled num node returning num5807 (depth = 8)
  int op_slot_right_5806 = gc_frame_newslot(num5807);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5806 = gc_frame_newslot(*var_depth);
  params[0] = num5807;
  partcv[0] = 1;
  Object sum5809 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5809 (depth = 7)
  gc_frame_newslot(sum5809);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5810 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5811 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5810);
// compiled call node returning call5811 (depth = 8)
// compiled member node returning call5811 (depth = 7)
  params[0] = sum5809;
  partcv[0] = 1;
  Object call5812 = callmethod(call5811, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5805);
// compiled call node returning call5812 (depth = 6)
  int op_slot_right_5804 = gc_frame_newslot(call5812);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5815 == NULL) {
    strlit5815 = alloc_String("""\x0a""");
    gc_root(strlit5815);
  }
// compiled string node returning strlit5815 (depth = 7)
  int op_slot_right_5814 = gc_frame_newslot(strlit5815);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5814 = gc_frame_newslot(*var_s);
  params[0] = strlit5815;
  partcv[0] = 1;
  Object opresult5817 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5817 (depth = 6)
  int op_slot_left_5804 = gc_frame_newslot(opresult5817);
  params[0] = call5812;
  partcv[0] = 1;
  Object opresult5818 = callmethod(opresult5817, "++", 1, partcv, params);
// compiled op node returning opresult5818 (depth = 5)
  *var_s = opresult5818;
  if (opresult5818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5797 = done;
  } else {
  }
// compiled if node returning if5797 (depth = 3)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5820 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5821 = alloc_Block(NULL, NULL, "ast", 1375);
  gc_frame_newslot(block5821);
// method "_apply"
  block_savedest(block5821);
  Object closure5822 = createclosure(3, "_apply");
  setclosureframe(closure5822, stackframe);
  addtoclosure(closure5822, var_depth);
  addtoclosure(closure5822, var_s);
  addtoclosure(closure5822, selfslot);
  struct UserObject *uo5822 = (struct UserObject*)block5821;
  uo5822->data[0] = (Object)closure5822;
  Method *meth_meth_ast__apply5822 = addmethod2pos(block5821, "_apply", &meth_ast__apply5822, 0);
  int argcv_meth_ast__apply5822[] = {1};
  meth_meth_ast__apply5822->type = alloc_MethodType(1, argcv_meth_ast__apply5822);
  meth_meth_ast__apply5822->definitionModule = modulename;
  meth_meth_ast__apply5822->definitionLine = 1373;
// compiled block node returning block5821 (depth = 4)
  gc_frame_newslot(block5821);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5839 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5838);
// compiled call node returning call5839 (depth = 5)
// compiled member node returning call5839 (depth = 4)
  params[0] = block5821;
  partcv[0] = 1;
  Object call5840 = callmethod(call5839, "do",
    1, partcv, params);
  gc_frame_end(callframe5820);
// compiled call node returning call5840 (depth = 3)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5841 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5842 = alloc_Block(NULL, NULL, "ast", 1376);
  gc_frame_newslot(block5842);
// method "_apply"
  block_savedest(block5842);
  Object closure5843 = createclosure(4, "_apply");
  setclosureframe(closure5843, stackframe);
  addtoclosure(closure5843, var_depth);
  addtoclosure(closure5843, var_spc);
  addtoclosure(closure5843, var_s);
  addtoclosure(closure5843, selfslot);
  struct UserObject *uo5843 = (struct UserObject*)block5842;
  uo5843->data[0] = (Object)closure5843;
  Method *meth_meth_ast__apply5843 = addmethod2pos(block5842, "_apply", &meth_ast__apply5843, 0);
  int argcv_meth_ast__apply5843[] = {1};
  meth_meth_ast__apply5843->type = alloc_MethodType(1, argcv_meth_ast__apply5843);
  meth_meth_ast__apply5843->definitionModule = modulename;
  meth_meth_ast__apply5843->definitionLine = 1375;
// compiled block node returning block5842 (depth = 4)
  gc_frame_newslot(block5842);
// call case 6: other member request
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5866 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5867 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5866);
// compiled call node returning call5867 (depth = 5)
// compiled member node returning call5867 (depth = 4)
  params[0] = block5842;
  partcv[0] = 1;
  Object call5868 = callmethod(call5867, "do",
    1, partcv, params);
  gc_frame_end(callframe5841);
// compiled call node returning call5868 (depth = 3)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5870 == NULL) {
    strlit5870 = alloc_String("}");
    gc_root(strlit5870);
  }
// compiled string node returning strlit5870 (depth = 5)
  int op_slot_right_5869 = gc_frame_newslot(strlit5870);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5872 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5875 == NULL) {
    strlit5875 = alloc_String("""\x0a""");
    gc_root(strlit5875);
  }
// compiled string node returning strlit5875 (depth = 7)
  int op_slot_right_5874 = gc_frame_newslot(strlit5875);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5874 = gc_frame_newslot(*var_s);
  params[0] = strlit5875;
  partcv[0] = 1;
  Object opresult5877 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5877 (depth = 6)
  int op_slot_left_5872 = gc_frame_newslot(opresult5877);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5878 = callmethod(opresult5877, "++", 1, partcv, params);
// compiled op node returning opresult5878 (depth = 5)
  int op_slot_left_5869 = gc_frame_newslot(opresult5878);
  params[0] = strlit5870;
  partcv[0] = 1;
  Object opresult5879 = callmethod(opresult5878, "++", 1, partcv, params);
// compiled op node returning opresult5879 (depth = 4)
  *var_s = opresult5879;
  if (opresult5879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy5881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5882 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5883 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool5884 = alloc_Boolean(0);
// compiled identifier node returning bool5884 (depth = 5)
  gc_frame_newslot(bool5884);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objectNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = bool5884;
  partcv[0] = 2;
  Object call5885 = callmethod(*var_objectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5883);
// compiled call node returning call5885 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5886 = callmethod(call5885, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5882);
// compiled call node returning call5886 (depth = 3)
  gc_frame_end(frame);
  return call5886;
}
Object meth_ast_shallowCopyFieldsFrom5887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5888 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5889 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5888);
// compiled call node returning call5889 (depth = 3)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5890 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5892 = callmethod(*var_other, "name",
    1, partcv, params);
  gc_frame_end(callframe5891);
// compiled call node returning call5892 (depth = 5)
// compiled member node returning call5892 (depth = 4)
  gc_frame_newslot(call5892);
// call case 4: self request
  params[0] = call5892;
  partcv[0] = 1;
  Object call5893 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5890);
// compiled call node returning call5893 (depth = 3)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5894 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5895 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5896 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe5895);
// compiled call node returning call5896 (depth = 5)
// compiled member node returning call5896 (depth = 4)
  gc_frame_newslot(call5896);
// call case 4: self request
  params[0] = call5896;
  partcv[0] = 1;
  Object call5897 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5894);
// compiled call node returning call5897 (depth = 3)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5898 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5900 = callmethod(*var_other, "superclass",
    1, partcv, params);
  gc_frame_end(callframe5899);
// compiled call node returning call5900 (depth = 5)
// compiled member node returning call5900 (depth = 4)
  gc_frame_newslot(call5900);
// call case 4: self request
  params[0] = call5900;
  partcv[0] = 1;
  Object call5901 = callmethodflags(self, "superclass:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5898);
// compiled call node returning call5901 (depth = 3)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5902 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5903 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5904 = callmethod(*var_other, "usedTraits",
    1, partcv, params);
  gc_frame_end(callframe5903);
// compiled call node returning call5904 (depth = 5)
// compiled member node returning call5904 (depth = 4)
  gc_frame_newslot(call5904);
// call case 4: self request
  params[0] = call5904;
  partcv[0] = 1;
  Object call5905 = callmethodflags(self, "usedTraits:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5902);
// compiled call node returning call5905 (depth = 3)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5906 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5907 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5908 = callmethod(*var_other, "inClass",
    1, partcv, params);
  gc_frame_end(callframe5907);
// compiled call node returning call5908 (depth = 5)
// compiled member node returning call5908 (depth = 4)
  gc_frame_newslot(call5908);
// call case 4: self request
  params[0] = call5908;
  partcv[0] = 1;
  Object call5909 = callmethodflags(self, "inClass:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5906);
// compiled call node returning call5909 (depth = 3)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5910 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5912 = callmethod(*var_other, "inTrait",
    1, partcv, params);
  gc_frame_end(callframe5911);
// compiled call node returning call5912 (depth = 5)
// compiled member node returning call5912 (depth = 4)
  gc_frame_newslot(call5912);
// call case 4: self request
  params[0] = call5912;
  partcv[0] = 1;
  Object call5913 = callmethodflags(self, "inTrait:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5910);
// compiled call node returning call5913 (depth = 3)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5914 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5916 = callmethod(*var_other, "annotations",
    1, partcv, params);
  gc_frame_end(callframe5915);
// compiled call node returning call5916 (depth = 5)
// compiled member node returning call5916 (depth = 4)
  gc_frame_newslot(call5916);
// call case 4: self request
  params[0] = call5916;
  partcv[0] = 1;
  Object call5917 = callmethodflags(self, "annotations:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5914);
// compiled call node returning call5917 (depth = 3)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString5918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5920 == NULL) {
    strlit5920 = alloc_String("");
    gc_root(strlit5920);
  }
// compiled string node returning strlit5920 (depth = 4)
  int op_slot_right_5919 = gc_frame_newslot(strlit5920);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5923 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5924 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5923);
// compiled call node returning call5924 (depth = 6)
// compiled member node returning call5924 (depth = 5)
  int op_slot_right_5922 = gc_frame_newslot(call5924);
// starting to compile string node (depth = 5)
  if (strlit5926 == NULL) {
    strlit5926 = alloc_String("object ");
    gc_root(strlit5926);
  }
// compiled string node returning strlit5926 (depth = 5)
  int op_slot_left_5922 = gc_frame_newslot(strlit5926);
  params[0] = call5924;
  partcv[0] = 1;
  Object opresult5927 = callmethod(strlit5926, "++", 1, partcv, params);
// compiled op node returning opresult5927 (depth = 4)
  int op_slot_left_5919 = gc_frame_newslot(opresult5927);
  params[0] = strlit5920;
  partcv[0] = 1;
  Object opresult5928 = callmethod(opresult5927, "++", 1, partcv, params);
// compiled op node returning opresult5928 (depth = 3)
  gc_frame_end(frame);
  return opresult5928;
}
Object meth_ast_new5342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5343 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5343 = alloc_userobj2(38,31, objclass5343);
  gc_frame_newslot(obj5343);
if (objclass5343 == NULL) {
  glfree(obj5343->class->name);
  obj5343->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5343, self, 0);
  addmethodreal(obj5343,"outer", &reader_ast_outer_5344);
  Object oldself5343 = self;
  struct StackFrameObject *oldstackframe5343 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5343);
  gc_frame_newslot((Object)stackframe);
  self = obj5343;
  Object *oldselfslot5343 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5343 = (*(struct UserObject *)self).data[0], lowerouter5343 = thisouter5343;
  if (inheritingObject5343) {
    struct UserObject *inho5343 = (struct UserObject *)inheritingObject5343;
    while (inho5343->super != GraceDefaultObject) inho5343 = (struct UserObject *)inho5343->super;
    inho5343->super = obj5343;
    self = inheritingObject5343;
    *selfslot = self;
    lowerouter5343 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5343;
  }
if (objclass5343 == NULL) {
  Method *reader5345 = addmethodrealflags(obj5343, "kind",&reader_ast_kind_5345, MFLAG_DEF);
  reader5345->definitionModule = modulename;
  reader5345->definitionLine = 1237;
}
adddatum2(obj5343, alloc_Undefined(), 1);
if (objclass5343 == NULL) {
  Method *reader5346 = addmethodrealflags(obj5343, "value",&reader_ast_value_5346, 0);
  Method *writer5346 = addmethodrealflags(obj5343, "value:=",&writer_ast_value_5346, 0);
  reader5346->definitionModule = modulename;
  writer5346->definitionModule = modulename;
  reader5346->definitionLine = 1238;
  writer5346->definitionLine = 1238;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 2);
if (objclass5343 == NULL) {
  Method *reader5347 = addmethodrealflags(obj5343, "superclass",&reader_ast_superclass_5347, 0);
  Method *writer5347 = addmethodrealflags(obj5343, "superclass:=",&writer_ast_superclass_5347, 0);
  reader5347->definitionModule = modulename;
  writer5347->definitionModule = modulename;
  reader5347->definitionLine = 1239;
  writer5347->definitionLine = 1239;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 3);
if (objclass5343 == NULL) {
  Method *reader5348 = addmethodrealflags(obj5343, "usedTraits",&reader_ast_usedTraits_5348, 0);
  Method *writer5348 = addmethodrealflags(obj5343, "usedTraits:=",&writer_ast_usedTraits_5348, 0);
  reader5348->definitionModule = modulename;
  writer5348->definitionModule = modulename;
  reader5348->definitionLine = 1240;
  writer5348->definitionLine = 1240;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 4);
if (objclass5343 == NULL) {
  Method *reader5349 = addmethodrealflags(obj5343, "name",&reader_ast_name_5349, 0);
  Method *writer5349 = addmethodrealflags(obj5343, "name:=",&writer_ast_name_5349, 0);
  reader5349->definitionModule = modulename;
  writer5349->definitionModule = modulename;
  reader5349->definitionLine = 1241;
  writer5349->definitionLine = 1241;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 5);
if (objclass5343 == NULL) {
  Method *reader5350 = addmethodrealflags(obj5343, "inClass",&reader_ast_inClass_5350, 0);
  Method *writer5350 = addmethodrealflags(obj5343, "inClass:=",&writer_ast_inClass_5350, 0);
  reader5350->definitionModule = modulename;
  writer5350->definitionModule = modulename;
  reader5350->definitionLine = 1242;
  writer5350->definitionLine = 1242;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 6);
if (objclass5343 == NULL) {
  Method *reader5351 = addmethodrealflags(obj5343, "inTrait",&reader_ast_inTrait_5351, 0);
  Method *writer5351 = addmethodrealflags(obj5343, "inTrait:=",&writer_ast_inTrait_5351, 0);
  reader5351->definitionModule = modulename;
  writer5351->definitionModule = modulename;
  reader5351->definitionLine = 1243;
  writer5351->definitionLine = 1243;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 7);
if (objclass5343 == NULL) {
  Method *reader5352 = addmethodrealflags(obj5343, "myLocalNames",&reader_ast_myLocalNames_5352, MFLAG_CONFIDENTIAL);
  Method *writer5352 = addmethodrealflags(obj5343, "myLocalNames:=",&writer_ast_myLocalNames_5352, MFLAG_CONFIDENTIAL);
  reader5352->definitionModule = modulename;
  writer5352->definitionModule = modulename;
  reader5352->definitionLine = 1244;
  writer5352->definitionLine = 1244;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 8);
if (objclass5343 == NULL) {
  Method *reader5353 = addmethodrealflags(obj5343, "annotations",&reader_ast_annotations_5353, 0);
  Method *writer5353 = addmethodrealflags(obj5343, "annotations:=",&writer_ast_annotations_5353, 0);
  reader5353->definitionModule = modulename;
  writer5353->definitionModule = modulename;
  reader5353->definitionLine = 1245;
  writer5353->definitionLine = 1245;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5354 = (struct UserObject*)obj5343;
  uo5354->data[10] = emptyclosure;
  Method *meth_meth_ast_description5354 = addmethod2pos(obj5343, "description", &meth_ast_description5354, 10);
  int argcv_meth_ast_description5354[] = {0};
  meth_meth_ast_description5354->type = alloc_MethodType(1, argcv_meth_ast_description5354);
  meth_meth_ast_description5354->definitionModule = modulename;
  meth_meth_ast_description5354->definitionLine = 1247;
// method "isTrait"
  struct UserObject *uo5383 = (struct UserObject*)obj5343;
  uo5383->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5383 = addmethod2pos(obj5343, "isTrait", &meth_ast_isTrait5383, 11);
  int argcv_meth_ast_isTrait5383[] = {0};
  meth_meth_ast_isTrait5383->type = alloc_MethodType(1, argcv_meth_ast_isTrait5383);
  meth_meth_ast_isTrait5383->definitionModule = modulename;
  meth_meth_ast_isTrait5383->definitionLine = 1256;
// method "localNames"
  struct UserObject *uo5410 = (struct UserObject*)obj5343;
  uo5410->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5410 = addmethod2pos(obj5343, "localNames", &meth_ast_localNames5410, 12);
  int argcv_meth_ast_localNames5410[] = {0};
  meth_meth_ast_localNames5410->type = alloc_MethodType(1, argcv_meth_ast_localNames5410);
  meth_meth_ast_localNames5410->definitionModule = modulename;
  meth_meth_ast_localNames5410->definitionLine = 1267;
// method "parentsDo"
  struct UserObject *uo5447 = (struct UserObject*)obj5343;
  uo5447->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo5447 = addmethod2pos(obj5343, "parentsDo", &meth_ast_parentsDo5447, 13);
  int argcv_meth_ast_parentsDo5447[] = {1};
  meth_meth_ast_parentsDo5447->type = alloc_MethodType(1, argcv_meth_ast_parentsDo5447);
  meth_meth_ast_parentsDo5447->definitionModule = modulename;
  meth_meth_ast_parentsDo5447->definitionLine = 1281;
// method "methodsDo"
  struct UserObject *uo5468 = (struct UserObject*)obj5343;
  uo5468->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo5468 = addmethod2pos(obj5343, "methodsDo", &meth_ast_methodsDo5468, 14);
  int argcv_meth_ast_methodsDo5468[] = {1};
  meth_meth_ast_methodsDo5468->type = alloc_MethodType(1, argcv_meth_ast_methodsDo5468);
  meth_meth_ast_methodsDo5468->definitionModule = modulename;
  meth_meth_ast_methodsDo5468->definitionLine = 1288;
// method "executableComponentsDo"
  struct UserObject *uo5481 = (struct UserObject*)obj5343;
  uo5481->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo5481 = addmethod2pos(obj5343, "executableComponentsDo", &meth_ast_executableComponentsDo5481, 15);
  int argcv_meth_ast_executableComponentsDo5481[] = {1};
  meth_meth_ast_executableComponentsDo5481->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo5481);
  meth_meth_ast_executableComponentsDo5481->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo5481->definitionLine = 1296;
// method "scope:="
  struct UserObject *uo5494 = (struct UserObject*)obj5343;
  uo5494->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_5494 = addmethod2pos(obj5343, "scope:=", &meth_ast_scope_58__61_5494, 16);
  int argcv_meth_ast_scope_58__61_5494[] = {1};
  meth_meth_ast_scope_58__61_5494->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_5494);
  meth_meth_ast_scope_58__61_5494->definitionModule = modulename;
  meth_meth_ast_scope_58__61_5494->definitionLine = 1304;
// method "body"
  struct UserObject *uo5499 = (struct UserObject*)obj5343;
  uo5499->data[17] = emptyclosure;
  Method *meth_meth_ast_body5499 = addmethod2pos(obj5343, "body", &meth_ast_body5499, 17);
  int argcv_meth_ast_body5499[] = {0};
  meth_meth_ast_body5499->type = alloc_MethodType(1, argcv_meth_ast_body5499);
  meth_meth_ast_body5499->definitionModule = modulename;
  meth_meth_ast_body5499->definitionLine = 1310;
// method "returnsObject"
  struct UserObject *uo5502 = (struct UserObject*)obj5343;
  uo5502->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5502 = addmethod2pos(obj5343, "returnsObject", &meth_ast_returnsObject5502, 18);
  int argcv_meth_ast_returnsObject5502[] = {0};
  meth_meth_ast_returnsObject5502->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5502);
  meth_meth_ast_returnsObject5502->definitionModule = modulename;
  meth_meth_ast_returnsObject5502->definitionLine = 1311;
// method "returnedObjectScope"
  struct UserObject *uo5504 = (struct UserObject*)obj5343;
  uo5504->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5504 = addmethod2pos(obj5343, "returnedObjectScope", &meth_ast_returnedObjectScope5504, 19);
  int argcv_meth_ast_returnedObjectScope5504[] = {0};
  meth_meth_ast_returnedObjectScope5504->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5504);
  meth_meth_ast_returnedObjectScope5504->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5504->definitionLine = 1312;
// method "canInherit"
  struct UserObject *uo5507 = (struct UserObject*)obj5343;
  uo5507->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5507 = addmethod2pos(obj5343, "canInherit", &meth_ast_canInherit5507, 20);
  int argcv_meth_ast_canInherit5507[] = {0};
  meth_meth_ast_canInherit5507->type = alloc_MethodType(1, argcv_meth_ast_canInherit5507);
  meth_meth_ast_canInherit5507->definitionModule = modulename;
  meth_meth_ast_canInherit5507->definitionLine = 1313;
// method "canUse"
  struct UserObject *uo5512 = (struct UserObject*)obj5343;
  uo5512->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5512 = addmethod2pos(obj5343, "canUse", &meth_ast_canUse5512, 21);
  int argcv_meth_ast_canUse5512[] = {0};
  meth_meth_ast_canUse5512->type = alloc_MethodType(1, argcv_meth_ast_canUse5512);
  meth_meth_ast_canUse5512->definitionModule = modulename;
  meth_meth_ast_canUse5512->definitionLine = 1314;
// method "isObject"
  struct UserObject *uo5514 = (struct UserObject*)obj5343;
  uo5514->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5514 = addmethod2pos(obj5343, "isObject", &meth_ast_isObject5514, 22);
  int argcv_meth_ast_isObject5514[] = {0};
  meth_meth_ast_isObject5514->type = alloc_MethodType(1, argcv_meth_ast_isObject5514);
  meth_meth_ast_isObject5514->definitionModule = modulename;
  meth_meth_ast_isObject5514->definitionLine = 1315;
// method "accept()from"
  struct UserObject *uo5516 = (struct UserObject*)obj5343;
  uo5516->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5516 = addmethod2pos(obj5343, "accept()from", &meth_ast_accept_40__41_from5516, 23);
  int argcv_meth_ast_accept_40__41_from5516[] = {1, 1};
  meth_meth_ast_accept_40__41_from5516->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5516);
  meth_meth_ast_accept_40__41_from5516->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5516->definitionLine = 1316;
// method "nameString"
  struct UserObject *uo5551 = (struct UserObject*)obj5343;
  uo5551->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5551 = addmethod2pos(obj5343, "nameString", &meth_ast_nameString5551, 24);
  int argcv_meth_ast_nameString5551[] = {0};
  meth_meth_ast_nameString5551->type = alloc_MethodType(1, argcv_meth_ast_nameString5551);
  meth_meth_ast_nameString5551->definitionModule = modulename;
  meth_meth_ast_nameString5551->definitionLine = 1326;
// method "map()ancestors"
  struct UserObject *uo5571 = (struct UserObject*)obj5343;
  uo5571->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5571 = addmethod2pos(obj5343, "map()ancestors", &meth_ast_map_40__41_ancestors5571, 25);
  int argcv_meth_ast_map_40__41_ancestors5571[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5571->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5571);
  meth_meth_ast_map_40__41_ancestors5571->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5571->definitionLine = 1333;
// method "pretty"
  struct UserObject *uo5608 = (struct UserObject*)obj5343;
  uo5608->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty5608 = addmethod2pos(obj5343, "pretty", &meth_ast_pretty5608, 26);
  int argcv_meth_ast_pretty5608[] = {1};
  meth_meth_ast_pretty5608->type = alloc_MethodType(1, argcv_meth_ast_pretty5608);
  meth_meth_ast_pretty5608->definitionModule = modulename;
  meth_meth_ast_pretty5608->definitionLine = 1341;
// method "toGrace"
  struct UserObject *uo5760 = (struct UserObject*)obj5343;
  uo5760->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace5760 = addmethod2pos(obj5343, "toGrace", &meth_ast_toGrace5760, 27);
  int argcv_meth_ast_toGrace5760[] = {1};
  meth_meth_ast_toGrace5760->type = alloc_MethodType(1, argcv_meth_ast_toGrace5760);
meth_meth_ast_toGrace5760->type->types[0] = type_Number;
meth_meth_ast_toGrace5760->type->names[0] = "depth";
  meth_meth_ast_toGrace5760->definitionModule = modulename;
  meth_meth_ast_toGrace5760->definitionLine = 1364;
// method "shallowCopy"
  block_savedest(obj5343);
  Object closure5881 = createclosure(2, "shallowCopy");
  setclosureframe(closure5881, stackframe);
  addtoclosure(closure5881, var_emptySeq);
  addtoclosure(closure5881, var_objectNode);
  struct UserObject *uo5881 = (struct UserObject*)obj5343;
  uo5881->data[28] = (Object)closure5881;
  Method *meth_meth_ast_shallowCopy5881 = addmethod2pos(obj5343, "shallowCopy", &meth_ast_shallowCopy5881, 28);
  int argcv_meth_ast_shallowCopy5881[] = {0};
  meth_meth_ast_shallowCopy5881->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5881);
  meth_meth_ast_shallowCopy5881->definitionModule = modulename;
  meth_meth_ast_shallowCopy5881->definitionLine = 1382;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5887 = (struct UserObject*)obj5343;
  uo5887->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5887 = addmethod2pos(obj5343, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5887, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom5887[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5887->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5887);
  meth_meth_ast_shallowCopyFieldsFrom5887->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5887->definitionLine = 1385;
// method "asString"
  struct UserObject *uo5918 = (struct UserObject*)obj5343;
  uo5918->data[30] = emptyclosure;
  Method *meth_meth_ast_asString5918 = addmethod2pos(obj5343, "asString", &meth_ast_asString5918, 30);
  int argcv_meth_ast_asString5918[] = {0};
  meth_meth_ast_asString5918->type = alloc_MethodType(1, argcv_meth_ast_asString5918);
  meth_meth_ast_asString5918->definitionModule = modulename;
  meth_meth_ast_asString5918->definitionLine = 1396;
  sourceObject = obj5343;
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5929 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5930 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5931 = gc_frame_new();
// call case 3: self.outer request
  Object call5932 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5931);
// compiled call node returning call5932 (depth = 7)
// compiled member node returning call5932 (depth = 6)
  partcv[0] = 0;
  Object call5933 = callmethodflags(call5932, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5930);
// compiled call node returning call5933 (depth = 5)
// compiled member node returning call5933 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5934 = callmethodflags(call5933, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5929);
// compiled call node returning call5934 (depth = 3)
  struct UserObject *obj5343_uo = (struct UserObject *)obj5343;
  obj5343_uo->super = call5934;
  sourceObject = obj5343;
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5935 == NULL) {
    strlit5935 = alloc_String("object");
    gc_root(strlit5935);
  }
// compiled string node returning strlit5935 (depth = 3)
  adddatum2(obj5343, strlit5935, 1);
  sourceObject = obj5343;
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5343, *var_b, 2);
  sourceObject = obj5343;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5343, *var_superclass_39_, 3);
  sourceObject = obj5343;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5937 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5938 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5937);
// compiled call node returning call5938 (depth = 6)
// compiled member node returning call5938 (depth = 5)
  partcv[0] = 0;
  Object call5939 = callmethod(call5938, "empty",
    1, partcv, params);
  gc_frame_end(callframe5936);
// compiled call node returning call5939 (depth = 4)
// compiled member node returning call5939 (depth = 3)
  adddatum2(obj5343, call5939, 4);
  sourceObject = obj5343;
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5940 == NULL) {
    strlit5940 = alloc_String("object");
    gc_root(strlit5940);
  }
// compiled string node returning strlit5940 (depth = 3)
  adddatum2(obj5343, strlit5940, 5);
  sourceObject = obj5343;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5941 = alloc_Boolean(0);
// compiled identifier node returning bool5941 (depth = 3)
  adddatum2(obj5343, bool5941, 6);
  sourceObject = obj5343;
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5942 = alloc_Boolean(0);
// compiled identifier node returning bool5942 (depth = 3)
  adddatum2(obj5343, bool5942, 7);
  sourceObject = obj5343;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5943 = alloc_Boolean(0);
// compiled identifier node returning bool5943 (depth = 3)
  adddatum2(obj5343, bool5943, 8);
  sourceObject = obj5343;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5944 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5945 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5946 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5945);
// compiled call node returning call5946 (depth = 6)
// compiled member node returning call5946 (depth = 5)
  partcv[0] = 0;
  Object call5947 = callmethod(call5946, "empty",
    1, partcv, params);
  gc_frame_end(callframe5944);
// compiled call node returning call5947 (depth = 4)
// compiled member node returning call5947 (depth = 3)
  adddatum2(obj5343, call5947, 9);
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  objclass5343 = obj5343->class;
  objclass5343->definitionModule = modulename;
  objclass5343->definitionLine = 1235;
  (*(struct UserObject *)self).data[0] = lowerouter5343;
  self = oldself5343;
  selfslot = oldselfslot5343;
  stackframe = oldstackframe5343;
  gc_frame_end(frame);
  return obj5343;
}
Object meth_ast_new5342_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5343 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5343 = alloc_userobj2(38,31, objclass5343);
  gc_frame_newslot(obj5343);
if (objclass5343 == NULL) {
  glfree(obj5343->class->name);
  obj5343->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5343, self, 0);
  addmethodreal(obj5343,"outer", &reader_ast_outer_5344);
  Object oldself5343 = self;
  struct StackFrameObject *oldstackframe5343 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5343);
  gc_frame_newslot((Object)stackframe);
  self = obj5343;
  Object *oldselfslot5343 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5343 = (*(struct UserObject *)self).data[0], lowerouter5343 = thisouter5343;
  if (inheritingObject5343) {
    struct UserObject *inho5343 = (struct UserObject *)inheritingObject5343;
    while (inho5343->super != GraceDefaultObject) inho5343 = (struct UserObject *)inho5343->super;
    inho5343->super = obj5343;
    self = inheritingObject5343;
    *selfslot = self;
    lowerouter5343 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5343;
  }
if (objclass5343 == NULL) {
  Method *reader5345 = addmethodrealflags(obj5343, "kind",&reader_ast_kind_5345, MFLAG_DEF);
  reader5345->definitionModule = modulename;
  reader5345->definitionLine = 1237;
}
adddatum2(obj5343, alloc_Undefined(), 1);
if (objclass5343 == NULL) {
  Method *reader5346 = addmethodrealflags(obj5343, "value",&reader_ast_value_5346, 0);
  Method *writer5346 = addmethodrealflags(obj5343, "value:=",&writer_ast_value_5346, 0);
  reader5346->definitionModule = modulename;
  writer5346->definitionModule = modulename;
  reader5346->definitionLine = 1238;
  writer5346->definitionLine = 1238;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 2);
if (objclass5343 == NULL) {
  Method *reader5347 = addmethodrealflags(obj5343, "superclass",&reader_ast_superclass_5347, 0);
  Method *writer5347 = addmethodrealflags(obj5343, "superclass:=",&writer_ast_superclass_5347, 0);
  reader5347->definitionModule = modulename;
  writer5347->definitionModule = modulename;
  reader5347->definitionLine = 1239;
  writer5347->definitionLine = 1239;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 3);
if (objclass5343 == NULL) {
  Method *reader5348 = addmethodrealflags(obj5343, "usedTraits",&reader_ast_usedTraits_5348, 0);
  Method *writer5348 = addmethodrealflags(obj5343, "usedTraits:=",&writer_ast_usedTraits_5348, 0);
  reader5348->definitionModule = modulename;
  writer5348->definitionModule = modulename;
  reader5348->definitionLine = 1240;
  writer5348->definitionLine = 1240;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 4);
if (objclass5343 == NULL) {
  Method *reader5349 = addmethodrealflags(obj5343, "name",&reader_ast_name_5349, 0);
  Method *writer5349 = addmethodrealflags(obj5343, "name:=",&writer_ast_name_5349, 0);
  reader5349->definitionModule = modulename;
  writer5349->definitionModule = modulename;
  reader5349->definitionLine = 1241;
  writer5349->definitionLine = 1241;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 5);
if (objclass5343 == NULL) {
  Method *reader5350 = addmethodrealflags(obj5343, "inClass",&reader_ast_inClass_5350, 0);
  Method *writer5350 = addmethodrealflags(obj5343, "inClass:=",&writer_ast_inClass_5350, 0);
  reader5350->definitionModule = modulename;
  writer5350->definitionModule = modulename;
  reader5350->definitionLine = 1242;
  writer5350->definitionLine = 1242;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 6);
if (objclass5343 == NULL) {
  Method *reader5351 = addmethodrealflags(obj5343, "inTrait",&reader_ast_inTrait_5351, 0);
  Method *writer5351 = addmethodrealflags(obj5343, "inTrait:=",&writer_ast_inTrait_5351, 0);
  reader5351->definitionModule = modulename;
  writer5351->definitionModule = modulename;
  reader5351->definitionLine = 1243;
  writer5351->definitionLine = 1243;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 7);
if (objclass5343 == NULL) {
  Method *reader5352 = addmethodrealflags(obj5343, "myLocalNames",&reader_ast_myLocalNames_5352, MFLAG_CONFIDENTIAL);
  Method *writer5352 = addmethodrealflags(obj5343, "myLocalNames:=",&writer_ast_myLocalNames_5352, MFLAG_CONFIDENTIAL);
  reader5352->definitionModule = modulename;
  writer5352->definitionModule = modulename;
  reader5352->definitionLine = 1244;
  writer5352->definitionLine = 1244;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 8);
if (objclass5343 == NULL) {
  Method *reader5353 = addmethodrealflags(obj5343, "annotations",&reader_ast_annotations_5353, 0);
  Method *writer5353 = addmethodrealflags(obj5343, "annotations:=",&writer_ast_annotations_5353, 0);
  reader5353->definitionModule = modulename;
  writer5353->definitionModule = modulename;
  reader5353->definitionLine = 1245;
  writer5353->definitionLine = 1245;
}
obj5343->flags |= OFLAG_MUTABLE;
adddatum2(obj5343, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5354 = (struct UserObject*)obj5343;
  uo5354->data[10] = emptyclosure;
  Method *meth_meth_ast_description5354 = addmethod2pos(obj5343, "description", &meth_ast_description5354, 10);
  int argcv_meth_ast_description5354[] = {0};
  meth_meth_ast_description5354->type = alloc_MethodType(1, argcv_meth_ast_description5354);
  meth_meth_ast_description5354->definitionModule = modulename;
  meth_meth_ast_description5354->definitionLine = 1247;
// method "isTrait"
  struct UserObject *uo5383 = (struct UserObject*)obj5343;
  uo5383->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5383 = addmethod2pos(obj5343, "isTrait", &meth_ast_isTrait5383, 11);
  int argcv_meth_ast_isTrait5383[] = {0};
  meth_meth_ast_isTrait5383->type = alloc_MethodType(1, argcv_meth_ast_isTrait5383);
  meth_meth_ast_isTrait5383->definitionModule = modulename;
  meth_meth_ast_isTrait5383->definitionLine = 1256;
// method "localNames"
  struct UserObject *uo5410 = (struct UserObject*)obj5343;
  uo5410->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5410 = addmethod2pos(obj5343, "localNames", &meth_ast_localNames5410, 12);
  int argcv_meth_ast_localNames5410[] = {0};
  meth_meth_ast_localNames5410->type = alloc_MethodType(1, argcv_meth_ast_localNames5410);
  meth_meth_ast_localNames5410->definitionModule = modulename;
  meth_meth_ast_localNames5410->definitionLine = 1267;
// method "parentsDo"
  struct UserObject *uo5447 = (struct UserObject*)obj5343;
  uo5447->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo5447 = addmethod2pos(obj5343, "parentsDo", &meth_ast_parentsDo5447, 13);
  int argcv_meth_ast_parentsDo5447[] = {1};
  meth_meth_ast_parentsDo5447->type = alloc_MethodType(1, argcv_meth_ast_parentsDo5447);
  meth_meth_ast_parentsDo5447->definitionModule = modulename;
  meth_meth_ast_parentsDo5447->definitionLine = 1281;
// method "methodsDo"
  struct UserObject *uo5468 = (struct UserObject*)obj5343;
  uo5468->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo5468 = addmethod2pos(obj5343, "methodsDo", &meth_ast_methodsDo5468, 14);
  int argcv_meth_ast_methodsDo5468[] = {1};
  meth_meth_ast_methodsDo5468->type = alloc_MethodType(1, argcv_meth_ast_methodsDo5468);
  meth_meth_ast_methodsDo5468->definitionModule = modulename;
  meth_meth_ast_methodsDo5468->definitionLine = 1288;
// method "executableComponentsDo"
  struct UserObject *uo5481 = (struct UserObject*)obj5343;
  uo5481->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo5481 = addmethod2pos(obj5343, "executableComponentsDo", &meth_ast_executableComponentsDo5481, 15);
  int argcv_meth_ast_executableComponentsDo5481[] = {1};
  meth_meth_ast_executableComponentsDo5481->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo5481);
  meth_meth_ast_executableComponentsDo5481->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo5481->definitionLine = 1296;
// method "scope:="
  struct UserObject *uo5494 = (struct UserObject*)obj5343;
  uo5494->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_5494 = addmethod2pos(obj5343, "scope:=", &meth_ast_scope_58__61_5494, 16);
  int argcv_meth_ast_scope_58__61_5494[] = {1};
  meth_meth_ast_scope_58__61_5494->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_5494);
  meth_meth_ast_scope_58__61_5494->definitionModule = modulename;
  meth_meth_ast_scope_58__61_5494->definitionLine = 1304;
// method "body"
  struct UserObject *uo5499 = (struct UserObject*)obj5343;
  uo5499->data[17] = emptyclosure;
  Method *meth_meth_ast_body5499 = addmethod2pos(obj5343, "body", &meth_ast_body5499, 17);
  int argcv_meth_ast_body5499[] = {0};
  meth_meth_ast_body5499->type = alloc_MethodType(1, argcv_meth_ast_body5499);
  meth_meth_ast_body5499->definitionModule = modulename;
  meth_meth_ast_body5499->definitionLine = 1310;
// method "returnsObject"
  struct UserObject *uo5502 = (struct UserObject*)obj5343;
  uo5502->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5502 = addmethod2pos(obj5343, "returnsObject", &meth_ast_returnsObject5502, 18);
  int argcv_meth_ast_returnsObject5502[] = {0};
  meth_meth_ast_returnsObject5502->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5502);
  meth_meth_ast_returnsObject5502->definitionModule = modulename;
  meth_meth_ast_returnsObject5502->definitionLine = 1311;
// method "returnedObjectScope"
  struct UserObject *uo5504 = (struct UserObject*)obj5343;
  uo5504->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5504 = addmethod2pos(obj5343, "returnedObjectScope", &meth_ast_returnedObjectScope5504, 19);
  int argcv_meth_ast_returnedObjectScope5504[] = {0};
  meth_meth_ast_returnedObjectScope5504->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5504);
  meth_meth_ast_returnedObjectScope5504->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5504->definitionLine = 1312;
// method "canInherit"
  struct UserObject *uo5507 = (struct UserObject*)obj5343;
  uo5507->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5507 = addmethod2pos(obj5343, "canInherit", &meth_ast_canInherit5507, 20);
  int argcv_meth_ast_canInherit5507[] = {0};
  meth_meth_ast_canInherit5507->type = alloc_MethodType(1, argcv_meth_ast_canInherit5507);
  meth_meth_ast_canInherit5507->definitionModule = modulename;
  meth_meth_ast_canInherit5507->definitionLine = 1313;
// method "canUse"
  struct UserObject *uo5512 = (struct UserObject*)obj5343;
  uo5512->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5512 = addmethod2pos(obj5343, "canUse", &meth_ast_canUse5512, 21);
  int argcv_meth_ast_canUse5512[] = {0};
  meth_meth_ast_canUse5512->type = alloc_MethodType(1, argcv_meth_ast_canUse5512);
  meth_meth_ast_canUse5512->definitionModule = modulename;
  meth_meth_ast_canUse5512->definitionLine = 1314;
// method "isObject"
  struct UserObject *uo5514 = (struct UserObject*)obj5343;
  uo5514->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5514 = addmethod2pos(obj5343, "isObject", &meth_ast_isObject5514, 22);
  int argcv_meth_ast_isObject5514[] = {0};
  meth_meth_ast_isObject5514->type = alloc_MethodType(1, argcv_meth_ast_isObject5514);
  meth_meth_ast_isObject5514->definitionModule = modulename;
  meth_meth_ast_isObject5514->definitionLine = 1315;
// method "accept()from"
  struct UserObject *uo5516 = (struct UserObject*)obj5343;
  uo5516->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5516 = addmethod2pos(obj5343, "accept()from", &meth_ast_accept_40__41_from5516, 23);
  int argcv_meth_ast_accept_40__41_from5516[] = {1, 1};
  meth_meth_ast_accept_40__41_from5516->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5516);
  meth_meth_ast_accept_40__41_from5516->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5516->definitionLine = 1316;
// method "nameString"
  struct UserObject *uo5551 = (struct UserObject*)obj5343;
  uo5551->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5551 = addmethod2pos(obj5343, "nameString", &meth_ast_nameString5551, 24);
  int argcv_meth_ast_nameString5551[] = {0};
  meth_meth_ast_nameString5551->type = alloc_MethodType(1, argcv_meth_ast_nameString5551);
  meth_meth_ast_nameString5551->definitionModule = modulename;
  meth_meth_ast_nameString5551->definitionLine = 1326;
// method "map()ancestors"
  struct UserObject *uo5571 = (struct UserObject*)obj5343;
  uo5571->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5571 = addmethod2pos(obj5343, "map()ancestors", &meth_ast_map_40__41_ancestors5571, 25);
  int argcv_meth_ast_map_40__41_ancestors5571[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5571->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5571);
  meth_meth_ast_map_40__41_ancestors5571->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5571->definitionLine = 1333;
// method "pretty"
  struct UserObject *uo5608 = (struct UserObject*)obj5343;
  uo5608->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty5608 = addmethod2pos(obj5343, "pretty", &meth_ast_pretty5608, 26);
  int argcv_meth_ast_pretty5608[] = {1};
  meth_meth_ast_pretty5608->type = alloc_MethodType(1, argcv_meth_ast_pretty5608);
  meth_meth_ast_pretty5608->definitionModule = modulename;
  meth_meth_ast_pretty5608->definitionLine = 1341;
// method "toGrace"
  struct UserObject *uo5760 = (struct UserObject*)obj5343;
  uo5760->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace5760 = addmethod2pos(obj5343, "toGrace", &meth_ast_toGrace5760, 27);
  int argcv_meth_ast_toGrace5760[] = {1};
  meth_meth_ast_toGrace5760->type = alloc_MethodType(1, argcv_meth_ast_toGrace5760);
meth_meth_ast_toGrace5760->type->types[0] = type_Number;
meth_meth_ast_toGrace5760->type->names[0] = "depth";
  meth_meth_ast_toGrace5760->definitionModule = modulename;
  meth_meth_ast_toGrace5760->definitionLine = 1364;
// method "shallowCopy"
  block_savedest(obj5343);
  Object closure5881 = createclosure(2, "shallowCopy");
  setclosureframe(closure5881, stackframe);
  addtoclosure(closure5881, var_emptySeq);
  addtoclosure(closure5881, var_objectNode);
  struct UserObject *uo5881 = (struct UserObject*)obj5343;
  uo5881->data[28] = (Object)closure5881;
  Method *meth_meth_ast_shallowCopy5881 = addmethod2pos(obj5343, "shallowCopy", &meth_ast_shallowCopy5881, 28);
  int argcv_meth_ast_shallowCopy5881[] = {0};
  meth_meth_ast_shallowCopy5881->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5881);
  meth_meth_ast_shallowCopy5881->definitionModule = modulename;
  meth_meth_ast_shallowCopy5881->definitionLine = 1382;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5887 = (struct UserObject*)obj5343;
  uo5887->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5887 = addmethod2pos(obj5343, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5887, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom5887[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5887->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5887);
  meth_meth_ast_shallowCopyFieldsFrom5887->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5887->definitionLine = 1385;
// method "asString"
  struct UserObject *uo5918 = (struct UserObject*)obj5343;
  uo5918->data[30] = emptyclosure;
  Method *meth_meth_ast_asString5918 = addmethod2pos(obj5343, "asString", &meth_ast_asString5918, 30);
  int argcv_meth_ast_asString5918[] = {0};
  meth_meth_ast_asString5918->type = alloc_MethodType(1, argcv_meth_ast_asString5918);
  meth_meth_ast_asString5918->definitionModule = modulename;
  meth_meth_ast_asString5918->definitionLine = 1396;
  sourceObject = obj5343;
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5929 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5930 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5931 = gc_frame_new();
// call case 3: self.outer request
  Object call5932 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5931);
// compiled call node returning call5932 (depth = 7)
// compiled member node returning call5932 (depth = 6)
  partcv[0] = 0;
  Object call5933 = callmethodflags(call5932, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5930);
// compiled call node returning call5933 (depth = 5)
// compiled member node returning call5933 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5934 = callmethodflags(call5933, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5929);
// compiled call node returning call5934 (depth = 3)
  struct UserObject *obj5343_uo = (struct UserObject *)obj5343;
  obj5343_uo->super = call5934;
  sourceObject = obj5343;
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5935 == NULL) {
    strlit5935 = alloc_String("object");
    gc_root(strlit5935);
  }
// compiled string node returning strlit5935 (depth = 3)
  adddatum2(obj5343, strlit5935, 1);
  sourceObject = obj5343;
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5343, *var_b, 2);
  sourceObject = obj5343;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5343, *var_superclass_39_, 3);
  sourceObject = obj5343;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5937 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5938 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5937);
// compiled call node returning call5938 (depth = 6)
// compiled member node returning call5938 (depth = 5)
  partcv[0] = 0;
  Object call5939 = callmethod(call5938, "empty",
    1, partcv, params);
  gc_frame_end(callframe5936);
// compiled call node returning call5939 (depth = 4)
// compiled member node returning call5939 (depth = 3)
  adddatum2(obj5343, call5939, 4);
  sourceObject = obj5343;
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5940 == NULL) {
    strlit5940 = alloc_String("object");
    gc_root(strlit5940);
  }
// compiled string node returning strlit5940 (depth = 3)
  adddatum2(obj5343, strlit5940, 5);
  sourceObject = obj5343;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5941 = alloc_Boolean(0);
// compiled identifier node returning bool5941 (depth = 3)
  adddatum2(obj5343, bool5941, 6);
  sourceObject = obj5343;
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5942 = alloc_Boolean(0);
// compiled identifier node returning bool5942 (depth = 3)
  adddatum2(obj5343, bool5942, 7);
  sourceObject = obj5343;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5943 = alloc_Boolean(0);
// compiled identifier node returning bool5943 (depth = 3)
  adddatum2(obj5343, bool5943, 8);
  sourceObject = obj5343;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5944 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5945 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5946 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5945);
// compiled call node returning call5946 (depth = 6)
// compiled member node returning call5946 (depth = 5)
  partcv[0] = 0;
  Object call5947 = callmethod(call5946, "empty",
    1, partcv, params);
  gc_frame_end(callframe5944);
// compiled call node returning call5947 (depth = 4)
// compiled member node returning call5947 (depth = 3)
  adddatum2(obj5343, call5947, 9);
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  sourceObject = obj5343;
  objclass5343 = obj5343->class;
  objclass5343->definitionModule = modulename;
  objclass5343->definitionLine = 1235;
  (*(struct UserObject *)self).data[0] = lowerouter5343;
  self = oldself5343;
  selfslot = oldselfslot5343;
  stackframe = oldstackframe5343;
  gc_frame_end(frame);
  return obj5343;
}
Object meth_ast_objectNode5949(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for objectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for objectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast__apply5967(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5968 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ax (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5969 = callmethod(*var_ax, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5968);
// compiled call node returning call5969 (depth = 6)
  gc_frame_end(frame);
  return call5969;
}
Object meth_ast_accept_40__41_from5957(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5959 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5960 = callmethod(*var_visitor, "visitArray()up",
    2, partcv, params);
  gc_frame_end(callframe5959);
// compiled call node returning call5960 (depth = 4)
  Object if5958 = done;
  if (istrue(call5960)) {
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5961 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5962 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5961);
// compiled call node returning call5962 (depth = 5)
  *var_newChain = call5962;
  if (call5962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5963 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5964 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5965 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5964);
// compiled call node returning call5965 (depth = 6)
// compiled member node returning call5965 (depth = 5)
  gc_frame_newslot(call5965);
// starting to compile block node (depth = 5)
  Object block5966 = alloc_Block(NULL, NULL, "ast", 1409);
  gc_frame_newslot(block5966);
// method "_apply"
  block_savedest(block5966);
  Object closure5967 = createclosure(3, "_apply");
  setclosureframe(closure5967, stackframe);
  addtoclosure(closure5967, var_visitor);
  addtoclosure(closure5967, var_newChain);
  addtoclosure(closure5967, selfslot);
  struct UserObject *uo5967 = (struct UserObject*)block5966;
  uo5967->data[0] = (Object)closure5967;
  Method *meth_meth_ast__apply5967 = addmethod2pos(block5966, "_apply", &meth_ast__apply5967, 0);
  int argcv_meth_ast__apply5967[] = {1};
  meth_meth_ast__apply5967->type = alloc_MethodType(1, argcv_meth_ast__apply5967);
  meth_meth_ast__apply5967->definitionModule = modulename;
  meth_meth_ast__apply5967->definitionLine = 1409;
// compiled block node returning block5966 (depth = 5)
  gc_frame_newslot(block5966);
// call case 5: prelude request
  params[0] = call5965;
  params[1] = block5966;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5971 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5963);
// compiled call node returning call5971 (depth = 4)
    gc_frame_newslot(call5971);
    if5958 = call5971;
  } else {
  }
// compiled if node returning if5958 (depth = 3)
  gc_frame_end(frame);
  return if5958;
}
Object meth_ast_map_40__41_ancestors5972(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5973 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5974 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5973);
// compiled call node returning call5974 (depth = 5)
// compiled member node returning call5974 (depth = 4)
  *var_n = call5974;
  if (call5974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5975 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5976 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5975);
// compiled call node returning call5976 (depth = 4)
  *var_newChain = call5976;
  if (call5976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5977 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5978 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5979 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5980 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5979);
// compiled call node returning call5980 (depth = 6)
// compiled member node returning call5980 (depth = 5)
  gc_frame_newslot(call5980);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5981 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5982 = gc_frame_new();
// call case 3: self.outer request
  Object call5983 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5982);
// compiled call node returning call5983 (depth = 8)
// compiled member node returning call5983 (depth = 7)
  partcv[0] = 0;
  Object call5984 = callmethodflags(call5983, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5981);
// compiled call node returning call5984 (depth = 6)
// compiled member node returning call5984 (depth = 5)
  params[0] = call5980;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5985 = callmethodflags(call5984, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5978);
// compiled call node returning call5985 (depth = 4)
  gc_frame_newslot(call5985);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5985;
  partcv[0] = 1;
  Object call5986 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe5977);
// compiled call node returning call5986 (depth = 3)
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5987 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5988 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5987);
// compiled call node returning call5988 (depth = 3)
  gc_frame_end(frame);
  return call5988;
}
Object meth_ast__apply5997(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5999 == NULL) {
    strlit5999 = alloc_String("  ");
    gc_root(strlit5999);
  }
// compiled string node returning strlit5999 (depth = 7)
  int op_slot_right_5998 = gc_frame_newslot(strlit5999);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5998 = gc_frame_newslot(*var_spc);
  params[0] = strlit5999;
  partcv[0] = 1;
  Object opresult6001 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6001 (depth = 6)
  *var_spc = opresult6001;
  if (opresult6001 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6011(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6013 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6015 = alloc_Float64(1);
// compiled num node returning num6015 (depth = 9)
  int op_slot_right_6014 = gc_frame_newslot(num6015);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6014 = gc_frame_newslot(*var_depth);
  params[0] = num6015;
  partcv[0] = 1;
  Object sum6017 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6017 (depth = 8)
  gc_frame_newslot(sum6017);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = sum6017;
  partcv[0] = 1;
  Object call6018 = callmethod(*var_ax, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6013);
// compiled call node returning call6018 (depth = 7)
  int op_slot_right_6012 = gc_frame_newslot(call6018);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6020 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6023 == NULL) {
    strlit6023 = alloc_String("""\x0a""");
    gc_root(strlit6023);
  }
// compiled string node returning strlit6023 (depth = 9)
  int op_slot_right_6022 = gc_frame_newslot(strlit6023);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6022 = gc_frame_newslot(*var_s);
  params[0] = strlit6023;
  partcv[0] = 1;
  Object opresult6025 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6025 (depth = 8)
  int op_slot_left_6020 = gc_frame_newslot(opresult6025);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6026 = callmethod(opresult6025, "++", 1, partcv, params);
// compiled op node returning opresult6026 (depth = 7)
  int op_slot_left_6012 = gc_frame_newslot(opresult6026);
  params[0] = call6018;
  partcv[0] = 1;
  Object opresult6027 = callmethod(opresult6026, "++", 1, partcv, params);
// compiled op node returning opresult6027 (depth = 6)
  *var_s = opresult6027;
  if (opresult6027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5989(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5990 == NULL) {
    strlit5990 = alloc_String("");
    gc_root(strlit5990);
  }
// compiled string node returning strlit5990 (depth = 4)
  *var_spc = strlit5990;
  if (strlit5990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5991 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5992 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5994 = alloc_Float64(0);
// compiled num node returning num5994 (depth = 5)
  int op_slot_left_5992 = gc_frame_newslot(num5994);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5995 = callmethod(num5994, "..", 1, partcv, params);
// compiled op node returning opresult5995 (depth = 4)
  gc_frame_newslot(opresult5995);
// starting to compile block node (depth = 4)
  Object block5996 = alloc_Block(NULL, NULL, "ast", 1422);
  gc_frame_newslot(block5996);
// method "_apply"
  block_savedest(block5996);
  Object closure5997 = createclosure(2, "_apply");
  setclosureframe(closure5997, stackframe);
  addtoclosure(closure5997, var_spc);
  addtoclosure(closure5997, selfslot);
  struct UserObject *uo5997 = (struct UserObject*)block5996;
  uo5997->data[0] = (Object)closure5997;
  Method *meth_meth_ast__apply5997 = addmethod2pos(block5996, "_apply", &meth_ast__apply5997, 0);
  int argcv_meth_ast__apply5997[] = {1};
  meth_meth_ast__apply5997->type = alloc_MethodType(1, argcv_meth_ast__apply5997);
  meth_meth_ast__apply5997->definitionModule = modulename;
  meth_meth_ast__apply5997->definitionLine = 1417;
// compiled block node returning block5996 (depth = 4)
  gc_frame_newslot(block5996);
// call case 5: prelude request
  params[0] = opresult5995;
  params[1] = block5996;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6004 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5991);
// compiled call node returning call6004 (depth = 3)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6005 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6006 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6005);
// compiled call node returning call6006 (depth = 4)
  *var_s = call6006;
  if (call6006 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6007 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6009 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6008);
// compiled call node returning call6009 (depth = 5)
// compiled member node returning call6009 (depth = 4)
  gc_frame_newslot(call6009);
// starting to compile block node (depth = 4)
  Object block6010 = alloc_Block(NULL, NULL, "ast", 1426);
  gc_frame_newslot(block6010);
// method "_apply"
  block_savedest(block6010);
  Object closure6011 = createclosure(4, "_apply");
  setclosureframe(closure6011, stackframe);
  addtoclosure(closure6011, var_depth);
  addtoclosure(closure6011, var_spc);
  addtoclosure(closure6011, var_s);
  addtoclosure(closure6011, selfslot);
  struct UserObject *uo6011 = (struct UserObject*)block6010;
  uo6011->data[0] = (Object)closure6011;
  Method *meth_meth_ast__apply6011 = addmethod2pos(block6010, "_apply", &meth_ast__apply6011, 0);
  int argcv_meth_ast__apply6011[] = {1};
  meth_meth_ast__apply6011->type = alloc_MethodType(1, argcv_meth_ast__apply6011);
  meth_meth_ast__apply6011->definitionModule = modulename;
  meth_meth_ast__apply6011->definitionLine = 1426;
// compiled block node returning block6010 (depth = 4)
  gc_frame_newslot(block6010);
// call case 5: prelude request
  params[0] = call6009;
  params[1] = block6010;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6030 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6007);
// compiled call node returning call6030 (depth = 3)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6041 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6042 = alloc_Float64(0);
// compiled num node returning num6042 (depth = 8)
  gc_frame_newslot(num6042);
// call case 6: other member request
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6043 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6044 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6043);
// compiled call node returning call6044 (depth = 10)
// compiled member node returning call6044 (depth = 9)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres6045 = callmethod(call6044, "[]", 1, partcv, params);
// compiled index node returning idxres6045 (depth = 8)
  params[0] = num6042;
  partcv[0] = 1;
  Object call6046 = callmethod(idxres6045, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6041);
// compiled call node returning call6046 (depth = 7)
  int op_slot_right_6040 = gc_frame_newslot(call6046);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6040 = gc_frame_newslot(*var_s);
  params[0] = call6046;
  partcv[0] = 1;
  Object opresult6048 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6048 (depth = 6)
  *var_s = opresult6048;
  if (opresult6048 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6052 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6054 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6053);
// compiled call node returning call6054 (depth = 10)
// compiled member node returning call6054 (depth = 9)
  partcv[0] = 0;
  Object call6055 = callmethod(call6054, "size",
    1, partcv, params);
  gc_frame_end(callframe6052);
// compiled call node returning call6055 (depth = 8)
// compiled member node returning call6055 (depth = 7)
  int op_slot_right_6051 = gc_frame_newslot(call6055);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_6051 = gc_frame_newslot(*var_i);
  params[0] = call6055;
  partcv[0] = 1;
  Object opresult6057 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult6057 (depth = 6)
  Object if6050 = done;
  if (istrue(opresult6057)) {
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6059 == NULL) {
    strlit6059 = alloc_String(", ");
    gc_root(strlit6059);
  }
// compiled string node returning strlit6059 (depth = 8)
  int op_slot_right_6058 = gc_frame_newslot(strlit6059);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6058 = gc_frame_newslot(*var_s);
  params[0] = strlit6059;
  partcv[0] = 1;
  Object opresult6061 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6061 (depth = 7)
  *var_s = opresult6061;
  if (opresult6061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6050 = done;
  } else {
  }
// compiled if node returning if6050 (depth = 5)
  gc_frame_end(frame);
  return if6050;
}
Object meth_ast_toGrace6031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6032 == NULL) {
    strlit6032 = alloc_String("[");
    gc_root(strlit6032);
  }
// compiled string node returning strlit6032 (depth = 4)
  *var_s = strlit6032;
  if (strlit6032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6033 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6034 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6035 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6036 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6035);
// compiled call node returning call6036 (depth = 7)
// compiled member node returning call6036 (depth = 6)
  partcv[0] = 0;
  Object call6037 = callmethod(call6036, "indices",
    1, partcv, params);
  gc_frame_end(callframe6034);
// compiled call node returning call6037 (depth = 5)
// compiled member node returning call6037 (depth = 4)
  gc_frame_newslot(call6037);
// starting to compile block node (depth = 4)
  Object block6038 = alloc_Block(NULL, NULL, "ast", 1433);
  gc_frame_newslot(block6038);
// method "_apply"
  block_savedest(block6038);
  Object closure6039 = createclosure(2, "_apply");
  setclosureframe(closure6039, stackframe);
  addtoclosure(closure6039, var_s);
  addtoclosure(closure6039, selfslot);
  struct UserObject *uo6039 = (struct UserObject*)block6038;
  uo6039->data[0] = (Object)closure6039;
  Method *meth_meth_ast__apply6039 = addmethod2pos(block6038, "_apply", &meth_ast__apply6039, 0);
  int argcv_meth_ast__apply6039[] = {1};
  meth_meth_ast__apply6039->type = alloc_MethodType(1, argcv_meth_ast__apply6039);
  meth_meth_ast__apply6039->definitionModule = modulename;
  meth_meth_ast__apply6039->definitionLine = 1433;
// compiled block node returning block6038 (depth = 4)
  gc_frame_newslot(block6038);
// call case 5: prelude request
  params[0] = call6037;
  params[1] = block6038;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6064 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6033);
// compiled call node returning call6064 (depth = 3)
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6066 == NULL) {
    strlit6066 = alloc_String("]");
    gc_root(strlit6066);
  }
// compiled string node returning strlit6066 (depth = 5)
  int op_slot_right_6065 = gc_frame_newslot(strlit6066);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6065 = gc_frame_newslot(*var_s);
  params[0] = strlit6066;
  partcv[0] = 1;
  Object opresult6068 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6068 (depth = 4)
  *var_s = opresult6068;
  if (opresult6068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy6070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6071 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6072 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arrayNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6073 = callmethod(*var_arrayNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6072);
// compiled call node returning call6073 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6074 = callmethod(call6073, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6071);
// compiled call node returning call6074 (depth = 3)
  gc_frame_end(frame);
  return call6074;
}
Object meth_ast_new5952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5953 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5953 = alloc_userobj2(8,8, objclass5953);
  gc_frame_newslot(obj5953);
if (objclass5953 == NULL) {
  glfree(obj5953->class->name);
  obj5953->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5953, self, 0);
  addmethodreal(obj5953,"outer", &reader_ast_outer_5954);
  Object oldself5953 = self;
  struct StackFrameObject *oldstackframe5953 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5953);
  gc_frame_newslot((Object)stackframe);
  self = obj5953;
  Object *oldselfslot5953 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5953 = (*(struct UserObject *)self).data[0], lowerouter5953 = thisouter5953;
  if (inheritingObject5953) {
    struct UserObject *inho5953 = (struct UserObject *)inheritingObject5953;
    while (inho5953->super != GraceDefaultObject) inho5953 = (struct UserObject *)inho5953->super;
    inho5953->super = obj5953;
    self = inheritingObject5953;
    *selfslot = self;
    lowerouter5953 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5953;
  }
if (objclass5953 == NULL) {
  Method *reader5955 = addmethodrealflags(obj5953, "kind",&reader_ast_kind_5955, MFLAG_DEF);
  reader5955->definitionModule = modulename;
  reader5955->definitionLine = 1404;
}
adddatum2(obj5953, alloc_Undefined(), 1);
if (objclass5953 == NULL) {
  Method *reader5956 = addmethodrealflags(obj5953, "value",&reader_ast_value_5956, 0);
  Method *writer5956 = addmethodrealflags(obj5953, "value:=",&writer_ast_value_5956, 0);
  reader5956->definitionModule = modulename;
  writer5956->definitionModule = modulename;
  reader5956->definitionLine = 1405;
  writer5956->definitionLine = 1405;
}
obj5953->flags |= OFLAG_MUTABLE;
adddatum2(obj5953, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo5957 = (struct UserObject*)obj5953;
  uo5957->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5957 = addmethod2pos(obj5953, "accept()from", &meth_ast_accept_40__41_from5957, 3);
  int argcv_meth_ast_accept_40__41_from5957[] = {1, 1};
  meth_meth_ast_accept_40__41_from5957->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5957);
  meth_meth_ast_accept_40__41_from5957->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5957->definitionLine = 1406;
// method "map()ancestors"
  struct UserObject *uo5972 = (struct UserObject*)obj5953;
  uo5972->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5972 = addmethod2pos(obj5953, "map()ancestors", &meth_ast_map_40__41_ancestors5972, 4);
  int argcv_meth_ast_map_40__41_ancestors5972[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5972->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5972);
  meth_meth_ast_map_40__41_ancestors5972->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5972->definitionLine = 1414;
// method "pretty"
  struct UserObject *uo5989 = (struct UserObject*)obj5953;
  uo5989->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty5989 = addmethod2pos(obj5953, "pretty", &meth_ast_pretty5989, 5);
  int argcv_meth_ast_pretty5989[] = {1};
  meth_meth_ast_pretty5989->type = alloc_MethodType(1, argcv_meth_ast_pretty5989);
  meth_meth_ast_pretty5989->definitionModule = modulename;
  meth_meth_ast_pretty5989->definitionLine = 1420;
// method "toGrace"
  struct UserObject *uo6031 = (struct UserObject*)obj5953;
  uo6031->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace6031 = addmethod2pos(obj5953, "toGrace", &meth_ast_toGrace6031, 6);
  int argcv_meth_ast_toGrace6031[] = {1};
  meth_meth_ast_toGrace6031->type = alloc_MethodType(1, argcv_meth_ast_toGrace6031);
meth_meth_ast_toGrace6031->type->types[0] = type_Number;
meth_meth_ast_toGrace6031->type->names[0] = "depth";
  meth_meth_ast_toGrace6031->definitionModule = modulename;
  meth_meth_ast_toGrace6031->definitionLine = 1431;
// method "shallowCopy"
  block_savedest(obj5953);
  Object closure6070 = createclosure(2, "shallowCopy");
  setclosureframe(closure6070, stackframe);
  addtoclosure(closure6070, var_emptySeq);
  addtoclosure(closure6070, var_arrayNode);
  struct UserObject *uo6070 = (struct UserObject*)obj5953;
  uo6070->data[7] = (Object)closure6070;
  Method *meth_meth_ast_shallowCopy6070 = addmethod2pos(obj5953, "shallowCopy", &meth_ast_shallowCopy6070, 7);
  int argcv_meth_ast_shallowCopy6070[] = {0};
  meth_meth_ast_shallowCopy6070->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6070);
  meth_meth_ast_shallowCopy6070->definitionModule = modulename;
  meth_meth_ast_shallowCopy6070->definitionLine = 1442;
  sourceObject = obj5953;
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6075 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6076 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6077 = gc_frame_new();
// call case 3: self.outer request
  Object call6078 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6077);
// compiled call node returning call6078 (depth = 7)
// compiled member node returning call6078 (depth = 6)
  partcv[0] = 0;
  Object call6079 = callmethodflags(call6078, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6076);
// compiled call node returning call6079 (depth = 5)
// compiled member node returning call6079 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6080 = callmethodflags(call6079, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6075);
// compiled call node returning call6080 (depth = 3)
  struct UserObject *obj5953_uo = (struct UserObject *)obj5953;
  obj5953_uo->super = call6080;
  sourceObject = obj5953;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6081 == NULL) {
    strlit6081 = alloc_String("array");
    gc_root(strlit6081);
  }
// compiled string node returning strlit6081 (depth = 3)
  adddatum2(obj5953, strlit6081, 1);
  sourceObject = obj5953;
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj5953, *var_values, 2);
  sourceObject = obj5953;
  sourceObject = obj5953;
  sourceObject = obj5953;
  sourceObject = obj5953;
  sourceObject = obj5953;
  objclass5953 = obj5953->class;
  objclass5953->definitionModule = modulename;
  objclass5953->definitionLine = 1402;
  (*(struct UserObject *)self).data[0] = lowerouter5953;
  self = oldself5953;
  selfslot = oldselfslot5953;
  stackframe = oldstackframe5953;
  gc_frame_end(frame);
  return obj5953;
}
Object meth_ast_new5952_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5953 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5953 = alloc_userobj2(8,8, objclass5953);
  gc_frame_newslot(obj5953);
if (objclass5953 == NULL) {
  glfree(obj5953->class->name);
  obj5953->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5953, self, 0);
  addmethodreal(obj5953,"outer", &reader_ast_outer_5954);
  Object oldself5953 = self;
  struct StackFrameObject *oldstackframe5953 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5953);
  gc_frame_newslot((Object)stackframe);
  self = obj5953;
  Object *oldselfslot5953 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5953 = (*(struct UserObject *)self).data[0], lowerouter5953 = thisouter5953;
  if (inheritingObject5953) {
    struct UserObject *inho5953 = (struct UserObject *)inheritingObject5953;
    while (inho5953->super != GraceDefaultObject) inho5953 = (struct UserObject *)inho5953->super;
    inho5953->super = obj5953;
    self = inheritingObject5953;
    *selfslot = self;
    lowerouter5953 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5953;
  }
if (objclass5953 == NULL) {
  Method *reader5955 = addmethodrealflags(obj5953, "kind",&reader_ast_kind_5955, MFLAG_DEF);
  reader5955->definitionModule = modulename;
  reader5955->definitionLine = 1404;
}
adddatum2(obj5953, alloc_Undefined(), 1);
if (objclass5953 == NULL) {
  Method *reader5956 = addmethodrealflags(obj5953, "value",&reader_ast_value_5956, 0);
  Method *writer5956 = addmethodrealflags(obj5953, "value:=",&writer_ast_value_5956, 0);
  reader5956->definitionModule = modulename;
  writer5956->definitionModule = modulename;
  reader5956->definitionLine = 1405;
  writer5956->definitionLine = 1405;
}
obj5953->flags |= OFLAG_MUTABLE;
adddatum2(obj5953, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo5957 = (struct UserObject*)obj5953;
  uo5957->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5957 = addmethod2pos(obj5953, "accept()from", &meth_ast_accept_40__41_from5957, 3);
  int argcv_meth_ast_accept_40__41_from5957[] = {1, 1};
  meth_meth_ast_accept_40__41_from5957->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5957);
  meth_meth_ast_accept_40__41_from5957->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5957->definitionLine = 1406;
// method "map()ancestors"
  struct UserObject *uo5972 = (struct UserObject*)obj5953;
  uo5972->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5972 = addmethod2pos(obj5953, "map()ancestors", &meth_ast_map_40__41_ancestors5972, 4);
  int argcv_meth_ast_map_40__41_ancestors5972[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5972->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5972);
  meth_meth_ast_map_40__41_ancestors5972->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5972->definitionLine = 1414;
// method "pretty"
  struct UserObject *uo5989 = (struct UserObject*)obj5953;
  uo5989->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty5989 = addmethod2pos(obj5953, "pretty", &meth_ast_pretty5989, 5);
  int argcv_meth_ast_pretty5989[] = {1};
  meth_meth_ast_pretty5989->type = alloc_MethodType(1, argcv_meth_ast_pretty5989);
  meth_meth_ast_pretty5989->definitionModule = modulename;
  meth_meth_ast_pretty5989->definitionLine = 1420;
// method "toGrace"
  struct UserObject *uo6031 = (struct UserObject*)obj5953;
  uo6031->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace6031 = addmethod2pos(obj5953, "toGrace", &meth_ast_toGrace6031, 6);
  int argcv_meth_ast_toGrace6031[] = {1};
  meth_meth_ast_toGrace6031->type = alloc_MethodType(1, argcv_meth_ast_toGrace6031);
meth_meth_ast_toGrace6031->type->types[0] = type_Number;
meth_meth_ast_toGrace6031->type->names[0] = "depth";
  meth_meth_ast_toGrace6031->definitionModule = modulename;
  meth_meth_ast_toGrace6031->definitionLine = 1431;
// method "shallowCopy"
  block_savedest(obj5953);
  Object closure6070 = createclosure(2, "shallowCopy");
  setclosureframe(closure6070, stackframe);
  addtoclosure(closure6070, var_emptySeq);
  addtoclosure(closure6070, var_arrayNode);
  struct UserObject *uo6070 = (struct UserObject*)obj5953;
  uo6070->data[7] = (Object)closure6070;
  Method *meth_meth_ast_shallowCopy6070 = addmethod2pos(obj5953, "shallowCopy", &meth_ast_shallowCopy6070, 7);
  int argcv_meth_ast_shallowCopy6070[] = {0};
  meth_meth_ast_shallowCopy6070->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6070);
  meth_meth_ast_shallowCopy6070->definitionModule = modulename;
  meth_meth_ast_shallowCopy6070->definitionLine = 1442;
  sourceObject = obj5953;
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6075 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6076 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6077 = gc_frame_new();
// call case 3: self.outer request
  Object call6078 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6077);
// compiled call node returning call6078 (depth = 7)
// compiled member node returning call6078 (depth = 6)
  partcv[0] = 0;
  Object call6079 = callmethodflags(call6078, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6076);
// compiled call node returning call6079 (depth = 5)
// compiled member node returning call6079 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6080 = callmethodflags(call6079, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6075);
// compiled call node returning call6080 (depth = 3)
  struct UserObject *obj5953_uo = (struct UserObject *)obj5953;
  obj5953_uo->super = call6080;
  sourceObject = obj5953;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6081 == NULL) {
    strlit6081 = alloc_String("array");
    gc_root(strlit6081);
  }
// compiled string node returning strlit6081 (depth = 3)
  adddatum2(obj5953, strlit6081, 1);
  sourceObject = obj5953;
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj5953, *var_values, 2);
  sourceObject = obj5953;
  sourceObject = obj5953;
  sourceObject = obj5953;
  sourceObject = obj5953;
  sourceObject = obj5953;
  objclass5953 = obj5953->class;
  objclass5953->definitionModule = modulename;
  objclass5953->definitionLine = 1402;
  (*(struct UserObject *)self).data[0] = lowerouter5953;
  self = oldself5953;
  selfslot = oldselfslot5953;
  stackframe = oldstackframe5953;
  gc_frame_end(frame);
  return obj5953;
}
Object meth_ast_arrayNode6083(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for arrayNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for arrayNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast_new_40__41_scope6086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6087 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// call case 4: self request
  params[0] = *var_request;
  params[1] = *var_receiver;
  partcv[0] = 2;
  Object call6088 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6087);
// compiled call node returning call6088 (depth = 4)
  *var_result = call6088;
  if (call6088 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6089 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6090 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe6089);
// compiled call node returning call6090 (depth = 3)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_target6098(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6099 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6100 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6099);
// compiled call node returning call6100 (depth = 4)
// compiled member node returning call6100 (depth = 3)
  gc_frame_end(frame);
  return call6100;
}
Object meth_ast_nameString6101(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6103 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6102);
// compiled call node returning call6103 (depth = 4)
// compiled member node returning call6103 (depth = 3)
  gc_frame_end(frame);
  return call6103;
}
Object meth_ast_isMember6104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6105 = alloc_Boolean(1);
// compiled identifier node returning bool6105 (depth = 3)
  gc_frame_end(frame);
  return bool6105;
}
Object meth_ast__apply6121(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6122 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6123 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6122);
// compiled call node returning call6123 (depth = 7)
  gc_frame_end(frame);
  return call6123;
}
Object meth_ast_accept_40__41_from6106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6108 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6109 = callmethod(*var_visitor, "visitMember()up",
    2, partcv, params);
  gc_frame_end(callframe6108);
// compiled call node returning call6109 (depth = 4)
  Object if6107 = done;
  if (istrue(call6109)) {
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6110 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6111 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6110);
// compiled call node returning call6111 (depth = 5)
  *var_newChain = call6111;
  if (call6111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6114 = alloc_Boolean(0);
// compiled identifier node returning bool6114 (depth = 6)
  int op_slot_right_6113 = gc_frame_newslot(bool6114);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6117 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6116);
// compiled call node returning call6117 (depth = 7)
// compiled member node returning call6117 (depth = 6)
  int op_slot_left_6113 = gc_frame_newslot(call6117);
  params[0] = bool6114;
  partcv[0] = 1;
  Object opresult6118 = callmethod(call6117, "!=", 1, partcv, params);
// compiled op node returning opresult6118 (depth = 5)
  Object if6112 = done;
  if (istrue(opresult6118)) {
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6119 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6120 = alloc_Block(NULL, NULL, "ast", 1468);
  gc_frame_newslot(block6120);
// method "_apply"
  block_savedest(block6120);
  Object closure6121 = createclosure(3, "_apply");
  setclosureframe(closure6121, stackframe);
  addtoclosure(closure6121, var_visitor);
  addtoclosure(closure6121, var_newChain);
  addtoclosure(closure6121, selfslot);
  struct UserObject *uo6121 = (struct UserObject*)block6120;
  uo6121->data[0] = (Object)closure6121;
  Method *meth_meth_ast__apply6121 = addmethod2pos(block6120, "_apply", &meth_ast__apply6121, 0);
  int argcv_meth_ast__apply6121[] = {1};
  meth_meth_ast__apply6121->type = alloc_MethodType(1, argcv_meth_ast__apply6121);
  meth_meth_ast__apply6121->definitionModule = modulename;
  meth_meth_ast__apply6121->definitionLine = 1467;
// compiled block node returning block6120 (depth = 6)
  gc_frame_newslot(block6120);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6125 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6126 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6125);
// compiled call node returning call6126 (depth = 7)
// compiled member node returning call6126 (depth = 6)
  params[0] = block6120;
  partcv[0] = 1;
  Object call6127 = callmethod(call6126, "do",
    1, partcv, params);
  gc_frame_end(callframe6119);
// compiled call node returning call6127 (depth = 5)
    gc_frame_newslot(call6127);
    if6112 = call6127;
  } else {
  }
// compiled if node returning if6112 (depth = 4)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6128 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6130 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6129);
// compiled call node returning call6130 (depth = 6)
// compiled member node returning call6130 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6131 = callmethod(call6130, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6128);
// compiled call node returning call6131 (depth = 4)
    gc_frame_newslot(call6131);
    if6107 = call6131;
  } else {
  }
// compiled if node returning if6107 (depth = 3)
  gc_frame_end(frame);
  return if6107;
}
Object meth_ast_map_40__41_ancestors6132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6133 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6134 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6133);
// compiled call node returning call6134 (depth = 5)
// compiled member node returning call6134 (depth = 4)
  *var_n = call6134;
  if (call6134 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6135 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6136 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6135);
// compiled call node returning call6136 (depth = 4)
  *var_newChain = call6136;
  if (call6136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6137 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6138 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6140 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6139);
// compiled call node returning call6140 (depth = 6)
// compiled member node returning call6140 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6141 = callmethod(call6140, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe6138);
// compiled call node returning call6141 (depth = 4)
  gc_frame_newslot(call6141);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6141;
  partcv[0] = 1;
  Object call6142 = callmethod(*var_n, "in:=",
    1, partcv, params);
  gc_frame_end(callframe6137);
// compiled call node returning call6142 (depth = 3)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6143 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6144 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6146 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6145);
// compiled call node returning call6146 (depth = 6)
// compiled member node returning call6146 (depth = 5)
  gc_frame_newslot(call6146);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6147 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6148 = gc_frame_new();
// call case 3: self.outer request
  Object call6149 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6148);
// compiled call node returning call6149 (depth = 8)
// compiled member node returning call6149 (depth = 7)
  partcv[0] = 0;
  Object call6150 = callmethodflags(call6149, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6147);
// compiled call node returning call6150 (depth = 6)
// compiled member node returning call6150 (depth = 5)
  params[0] = call6146;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6151 = callmethodflags(call6150, "maybeListMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6144);
// compiled call node returning call6151 (depth = 4)
  gc_frame_newslot(call6151);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6151;
  partcv[0] = 1;
  Object call6152 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6143);
// compiled call node returning call6152 (depth = 3)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6153 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6154 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6153);
// compiled call node returning call6154 (depth = 3)
  gc_frame_end(frame);
  return call6154;
}
Object meth_ast__apply6163(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6165 == NULL) {
    strlit6165 = alloc_String("  ");
    gc_root(strlit6165);
  }
// compiled string node returning strlit6165 (depth = 7)
  int op_slot_right_6164 = gc_frame_newslot(strlit6165);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6164 = gc_frame_newslot(*var_spc);
  params[0] = strlit6165;
  partcv[0] = 1;
  Object opresult6167 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6167 (depth = 6)
  *var_spc = opresult6167;
  if (opresult6167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6224(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6226 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6227 = alloc_Float64(0);
// compiled num node returning num6227 (depth = 9)
  gc_frame_newslot(num6227);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = num6227;
  partcv[0] = 1;
  Object call6228 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6226);
// compiled call node returning call6228 (depth = 8)
  int op_slot_right_6225 = gc_frame_newslot(call6228);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6231 == NULL) {
    strlit6231 = alloc_String("    ");
    gc_root(strlit6231);
  }
// compiled string node returning strlit6231 (depth = 9)
  int op_slot_right_6230 = gc_frame_newslot(strlit6231);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6233 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6236 == NULL) {
    strlit6236 = alloc_String("""\x0a""");
    gc_root(strlit6236);
  }
// compiled string node returning strlit6236 (depth = 11)
  int op_slot_right_6235 = gc_frame_newslot(strlit6236);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6235 = gc_frame_newslot(*var_s);
  params[0] = strlit6236;
  partcv[0] = 1;
  Object opresult6238 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6238 (depth = 10)
  int op_slot_left_6233 = gc_frame_newslot(opresult6238);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6239 = callmethod(opresult6238, "++", 1, partcv, params);
// compiled op node returning opresult6239 (depth = 9)
  int op_slot_left_6230 = gc_frame_newslot(opresult6239);
  params[0] = strlit6231;
  partcv[0] = 1;
  Object opresult6240 = callmethod(opresult6239, "++", 1, partcv, params);
// compiled op node returning opresult6240 (depth = 8)
  int op_slot_left_6225 = gc_frame_newslot(opresult6240);
  params[0] = call6228;
  partcv[0] = 1;
  Object opresult6241 = callmethod(opresult6240, "++", 1, partcv, params);
// compiled op node returning opresult6241 (depth = 7)
  *var_s = opresult6241;
  if (opresult6241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6155(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6156 == NULL) {
    strlit6156 = alloc_String("");
    gc_root(strlit6156);
  }
// compiled string node returning strlit6156 (depth = 4)
  *var_spc = strlit6156;
  if (strlit6156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6157 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6158 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6160 = alloc_Float64(0);
// compiled num node returning num6160 (depth = 5)
  int op_slot_left_6158 = gc_frame_newslot(num6160);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6161 = callmethod(num6160, "..", 1, partcv, params);
// compiled op node returning opresult6161 (depth = 4)
  gc_frame_newslot(opresult6161);
// starting to compile block node (depth = 4)
  Object block6162 = alloc_Block(NULL, NULL, "ast", 1482);
  gc_frame_newslot(block6162);
// method "_apply"
  block_savedest(block6162);
  Object closure6163 = createclosure(2, "_apply");
  setclosureframe(closure6163, stackframe);
  addtoclosure(closure6163, var_spc);
  addtoclosure(closure6163, selfslot);
  struct UserObject *uo6163 = (struct UserObject*)block6162;
  uo6163->data[0] = (Object)closure6163;
  Method *meth_meth_ast__apply6163 = addmethod2pos(block6162, "_apply", &meth_ast__apply6163, 0);
  int argcv_meth_ast__apply6163[] = {1};
  meth_meth_ast__apply6163->type = alloc_MethodType(1, argcv_meth_ast__apply6163);
  meth_meth_ast__apply6163->definitionModule = modulename;
  meth_meth_ast__apply6163->definitionLine = 1477;
// compiled block node returning block6162 (depth = 4)
  gc_frame_newslot(block6162);
// call case 5: prelude request
  params[0] = opresult6161;
  params[1] = block6162;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6170 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6157);
// compiled call node returning call6170 (depth = 3)
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6172 == NULL) {
    strlit6172 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit6172);
  }
// compiled string node returning strlit6172 (depth = 5)
  int op_slot_right_6171 = gc_frame_newslot(strlit6172);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6176 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6175);
// compiled call node returning call6176 (depth = 7)
// compiled member node returning call6176 (depth = 6)
  int op_slot_right_6174 = gc_frame_newslot(call6176);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6179 == NULL) {
    strlit6179 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6179);
  }
// compiled string node returning strlit6179 (depth = 7)
  int op_slot_right_6178 = gc_frame_newslot(strlit6179);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6182 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6183 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6182);
// compiled call node returning call6183 (depth = 8)
  int op_slot_right_6181 = gc_frame_newslot(call6183);
// starting to compile string node (depth = 8)
  if (strlit6185 == NULL) {
    strlit6185 = alloc_String("");
    gc_root(strlit6185);
  }
// compiled string node returning strlit6185 (depth = 8)
  int op_slot_left_6181 = gc_frame_newslot(strlit6185);
  params[0] = call6183;
  partcv[0] = 1;
  Object opresult6186 = callmethod(strlit6185, "++", 1, partcv, params);
// compiled op node returning opresult6186 (depth = 7)
  int op_slot_left_6178 = gc_frame_newslot(opresult6186);
  params[0] = strlit6179;
  partcv[0] = 1;
  Object opresult6187 = callmethod(opresult6186, "++", 1, partcv, params);
// compiled op node returning opresult6187 (depth = 6)
  int op_slot_left_6174 = gc_frame_newslot(opresult6187);
  params[0] = call6176;
  partcv[0] = 1;
  Object opresult6188 = callmethod(opresult6187, "++", 1, partcv, params);
// compiled op node returning opresult6188 (depth = 5)
  int op_slot_left_6171 = gc_frame_newslot(opresult6188);
  params[0] = strlit6172;
  partcv[0] = 1;
  Object opresult6189 = callmethod(opresult6188, "++", 1, partcv, params);
// compiled op node returning opresult6189 (depth = 4)
  *var_s = opresult6189;
  if (opresult6189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6191 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6193 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6192);
// compiled call node returning call6193 (depth = 7)
// compiled member node returning call6193 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6194 = callmethod(call6193, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6191);
// compiled call node returning call6194 (depth = 5)
  int op_slot_right_6190 = gc_frame_newslot(call6194);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6196 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6196 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6198 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6198 (depth = 5)
  int op_slot_left_6190 = gc_frame_newslot(opresult6198);
  params[0] = call6194;
  partcv[0] = 1;
  Object opresult6199 = callmethod(opresult6198, "++", 1, partcv, params);
// compiled op node returning opresult6199 (depth = 4)
  *var_s = opresult6199;
  if (opresult6199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6203 = alloc_Boolean(0);
// compiled identifier node returning bool6203 (depth = 5)
  int op_slot_right_6202 = gc_frame_newslot(bool6203);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6205 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6206 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6205);
// compiled call node returning call6206 (depth = 6)
// compiled member node returning call6206 (depth = 5)
  int op_slot_left_6202 = gc_frame_newslot(call6206);
  params[0] = bool6203;
  partcv[0] = 1;
  Object opresult6207 = callmethod(call6206, "!=", 1, partcv, params);
// compiled op node returning opresult6207 (depth = 4)
  Object if6201 = done;
  if (istrue(opresult6207)) {
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6209 == NULL) {
    strlit6209 = alloc_String("  Generics:");
    gc_root(strlit6209);
  }
// compiled string node returning strlit6209 (depth = 6)
  int op_slot_right_6208 = gc_frame_newslot(strlit6209);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6211 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6214 == NULL) {
    strlit6214 = alloc_String("""\x0a""");
    gc_root(strlit6214);
  }
// compiled string node returning strlit6214 (depth = 8)
  int op_slot_right_6213 = gc_frame_newslot(strlit6214);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6213 = gc_frame_newslot(*var_s);
  params[0] = strlit6214;
  partcv[0] = 1;
  Object opresult6216 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6216 (depth = 7)
  int op_slot_left_6211 = gc_frame_newslot(opresult6216);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6217 = callmethod(opresult6216, "++", 1, partcv, params);
// compiled op node returning opresult6217 (depth = 6)
  int op_slot_left_6208 = gc_frame_newslot(opresult6217);
  params[0] = strlit6209;
  partcv[0] = 1;
  Object opresult6218 = callmethod(opresult6217, "++", 1, partcv, params);
// compiled op node returning opresult6218 (depth = 5)
  *var_s = opresult6218;
  if (opresult6218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6220 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6222 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6221);
// compiled call node returning call6222 (depth = 6)
// compiled member node returning call6222 (depth = 5)
  gc_frame_newslot(call6222);
// starting to compile block node (depth = 5)
  Object block6223 = alloc_Block(NULL, NULL, "ast", 1489);
  gc_frame_newslot(block6223);
// method "_apply"
  block_savedest(block6223);
  Object closure6224 = createclosure(3, "_apply");
  setclosureframe(closure6224, stackframe);
  addtoclosure(closure6224, var_spc);
  addtoclosure(closure6224, var_s);
  addtoclosure(closure6224, selfslot);
  struct UserObject *uo6224 = (struct UserObject*)block6223;
  uo6224->data[0] = (Object)closure6224;
  Method *meth_meth_ast__apply6224 = addmethod2pos(block6223, "_apply", &meth_ast__apply6224, 0);
  int argcv_meth_ast__apply6224[] = {1};
  meth_meth_ast__apply6224->type = alloc_MethodType(1, argcv_meth_ast__apply6224);
  meth_meth_ast__apply6224->definitionModule = modulename;
  meth_meth_ast__apply6224->definitionLine = 1489;
// compiled block node returning block6223 (depth = 5)
  gc_frame_newslot(block6223);
// call case 5: prelude request
  params[0] = call6222;
  params[1] = block6223;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6244 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6220);
// compiled call node returning call6244 (depth = 4)
    gc_frame_newslot(call6244);
    if6201 = call6244;
  } else {
  }
// compiled if node returning if6201 (depth = 3)
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6321(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6323 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6325 = alloc_Float64(1);
// compiled num node returning num6325 (depth = 10)
  int op_slot_right_6324 = gc_frame_newslot(num6325);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6324 = gc_frame_newslot(*var_depth);
  params[0] = num6325;
  partcv[0] = 1;
  Object sum6327 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6327 (depth = 9)
  gc_frame_newslot(sum6327);
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6328 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6329 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6330 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6329);
// compiled call node returning call6330 (depth = 11)
// compiled member node returning call6330 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6331 = callmethod(call6330, "at",
    1, partcv, params);
  gc_frame_end(callframe6328);
// compiled call node returning call6331 (depth = 9)
  params[0] = sum6327;
  partcv[0] = 1;
  Object call6332 = callmethod(call6331, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6323);
// compiled call node returning call6332 (depth = 8)
  int op_slot_right_6322 = gc_frame_newslot(call6332);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6322 = gc_frame_newslot(*var_s);
  params[0] = call6332;
  partcv[0] = 1;
  Object opresult6334 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6334 (depth = 7)
  *var_s = opresult6334;
  if (opresult6334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6245(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6246 == NULL) {
    strlit6246 = alloc_String("");
    gc_root(strlit6246);
  }
// compiled string node returning strlit6246 (depth = 4)
  *var_s = strlit6246;
  if (strlit6246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6249 == NULL) {
    strlit6249 = alloc_String("prefix");
    gc_root(strlit6249);
  }
// compiled string node returning strlit6249 (depth = 5)
  int op_slot_right_6248 = gc_frame_newslot(strlit6249);
// starting to compile call node (depth = 5)
  int callframe6251 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6252 = alloc_Float64(1);
// compiled num node returning num6252 (depth = 6)
  gc_frame_newslot(num6252);
// starting to compile num node (depth = 6)
  Object num6253 = alloc_Float64(6);
// compiled num node returning num6253 (depth = 6)
  gc_frame_newslot(num6253);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6255 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6254);
// compiled call node returning call6255 (depth = 7)
// compiled member node returning call6255 (depth = 6)
  params[0] = num6252;
  params[1] = num6253;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6256 = callmethod(call6255, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6251);
// compiled call node returning call6256 (depth = 5)
  int op_slot_left_6248 = gc_frame_newslot(call6256);
  params[0] = strlit6249;
  partcv[0] = 1;
  Object opresult6257 = callmethod(call6256, "==", 1, partcv, params);
// compiled op node returning opresult6257 (depth = 4)
  Object if6247 = done;
  if (istrue(opresult6257)) {
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6258 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6259 = alloc_Float64(7);
// compiled num node returning num6259 (depth = 6)
  gc_frame_newslot(num6259);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6260 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6262 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6261);
// compiled call node returning call6262 (depth = 9)
// compiled member node returning call6262 (depth = 8)
  partcv[0] = 0;
  Object call6263 = callmethod(call6262, "size",
    1, partcv, params);
  gc_frame_end(callframe6260);
// compiled call node returning call6263 (depth = 7)
// compiled member node returning call6263 (depth = 6)
  gc_frame_newslot(call6263);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6265 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6264);
// compiled call node returning call6265 (depth = 7)
// compiled member node returning call6265 (depth = 6)
  params[0] = num6259;
  params[1] = call6263;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6266 = callmethod(call6265, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6258);
// compiled call node returning call6266 (depth = 5)
  *var_s = call6266;
  if (call6266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6269 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6270 = alloc_Float64(0);
// compiled num node returning num6270 (depth = 7)
  gc_frame_newslot(num6270);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6272 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6271);
// compiled call node returning call6272 (depth = 8)
// compiled member node returning call6272 (depth = 7)
  params[0] = num6270;
  partcv[0] = 1;
  Object call6273 = callmethod(call6272, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6269);
// compiled call node returning call6273 (depth = 6)
  int op_slot_right_6268 = gc_frame_newslot(call6273);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6276 == NULL) {
    strlit6276 = alloc_String(" ");
    gc_root(strlit6276);
  }
// compiled string node returning strlit6276 (depth = 7)
  int op_slot_right_6275 = gc_frame_newslot(strlit6276);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6275 = gc_frame_newslot(*var_s);
  params[0] = strlit6276;
  partcv[0] = 1;
  Object opresult6278 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6278 (depth = 6)
  int op_slot_left_6268 = gc_frame_newslot(opresult6278);
  params[0] = call6273;
  partcv[0] = 1;
  Object opresult6279 = callmethod(opresult6278, "++", 1, partcv, params);
// compiled op node returning opresult6279 (depth = 5)
  *var_s = opresult6279;
  if (opresult6279 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6247 = done;
  } else {
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6283 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6282);
// compiled call node returning call6283 (depth = 7)
// compiled member node returning call6283 (depth = 6)
  int op_slot_right_6281 = gc_frame_newslot(call6283);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6286 == NULL) {
    strlit6286 = alloc_String(".");
    gc_root(strlit6286);
  }
// compiled string node returning strlit6286 (depth = 7)
  int op_slot_right_6285 = gc_frame_newslot(strlit6286);
// starting to compile call node (depth = 7)
  int callframe6288 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6290 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6289);
// compiled call node returning call6290 (depth = 9)
// compiled member node returning call6290 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6291 = callmethod(call6290, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6288);
// compiled call node returning call6291 (depth = 7)
  int op_slot_left_6285 = gc_frame_newslot(call6291);
  params[0] = strlit6286;
  partcv[0] = 1;
  Object opresult6292 = callmethod(call6291, "++", 1, partcv, params);
// compiled op node returning opresult6292 (depth = 6)
  int op_slot_left_6281 = gc_frame_newslot(opresult6292);
  params[0] = call6283;
  partcv[0] = 1;
  Object opresult6293 = callmethod(opresult6292, "++", 1, partcv, params);
// compiled op node returning opresult6293 (depth = 5)
  *var_s = opresult6293;
  if (opresult6293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6247 = done;
  }
// compiled if node returning if6247 (depth = 3)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6297 = alloc_Boolean(0);
// compiled identifier node returning bool6297 (depth = 5)
  int op_slot_right_6296 = gc_frame_newslot(bool6297);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6299 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6300 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6299);
// compiled call node returning call6300 (depth = 6)
// compiled member node returning call6300 (depth = 5)
  int op_slot_left_6296 = gc_frame_newslot(call6300);
  params[0] = bool6297;
  partcv[0] = 1;
  Object opresult6301 = callmethod(call6300, "!=", 1, partcv, params);
// compiled op node returning opresult6301 (depth = 4)
  Object if6295 = done;
  if (istrue(opresult6301)) {
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6303 == NULL) {
    strlit6303 = alloc_String("<");
    gc_root(strlit6303);
  }
// compiled string node returning strlit6303 (depth = 6)
  int op_slot_right_6302 = gc_frame_newslot(strlit6303);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6302 = gc_frame_newslot(*var_s);
  params[0] = strlit6303;
  partcv[0] = 1;
  Object opresult6305 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6305 (depth = 5)
  *var_s = opresult6305;
  if (opresult6305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6307 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6310 = alloc_Float64(1);
// compiled num node returning num6310 (depth = 7)
  int op_slot_right_6309 = gc_frame_newslot(num6310);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6312 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6313 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6314 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6313);
// compiled call node returning call6314 (depth = 10)
// compiled member node returning call6314 (depth = 9)
  partcv[0] = 0;
  Object call6315 = callmethod(call6314, "size",
    1, partcv, params);
  gc_frame_end(callframe6312);
// compiled call node returning call6315 (depth = 8)
// compiled member node returning call6315 (depth = 7)
  int op_slot_left_6309 = gc_frame_newslot(call6315);
  params[0] = num6310;
  partcv[0] = 1;
  Object diff6316 = callmethod(call6315, "-", 1, partcv, params);
// compiled op node returning diff6316 (depth = 6)
  int op_slot_right_6308 = gc_frame_newslot(diff6316);
// starting to compile num node (depth = 6)
  Object num6318 = alloc_Float64(1);
// compiled num node returning num6318 (depth = 6)
  int op_slot_left_6308 = gc_frame_newslot(num6318);
  params[0] = diff6316;
  partcv[0] = 1;
  Object opresult6319 = callmethod(num6318, "..", 1, partcv, params);
// compiled op node returning opresult6319 (depth = 5)
  gc_frame_newslot(opresult6319);
// starting to compile block node (depth = 5)
  Object block6320 = alloc_Block(NULL, NULL, "ast", 1505);
  gc_frame_newslot(block6320);
// method "_apply"
  block_savedest(block6320);
  Object closure6321 = createclosure(3, "_apply");
  setclosureframe(closure6321, stackframe);
  addtoclosure(closure6321, var_depth);
  addtoclosure(closure6321, var_s);
  addtoclosure(closure6321, selfslot);
  struct UserObject *uo6321 = (struct UserObject*)block6320;
  uo6321->data[0] = (Object)closure6321;
  Method *meth_meth_ast__apply6321 = addmethod2pos(block6320, "_apply", &meth_ast__apply6321, 0);
  int argcv_meth_ast__apply6321[] = {1};
  meth_meth_ast__apply6321->type = alloc_MethodType(1, argcv_meth_ast__apply6321);
  meth_meth_ast__apply6321->definitionModule = modulename;
  meth_meth_ast__apply6321->definitionLine = 1505;
// compiled block node returning block6320 (depth = 5)
  gc_frame_newslot(block6320);
// call case 5: prelude request
  params[0] = opresult6319;
  params[1] = block6320;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6337 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6307);
// compiled call node returning call6337 (depth = 4)
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6339 == NULL) {
    strlit6339 = alloc_String(">");
    gc_root(strlit6339);
  }
// compiled string node returning strlit6339 (depth = 6)
  int op_slot_right_6338 = gc_frame_newslot(strlit6339);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6342 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6344 = alloc_Float64(1);
// compiled num node returning num6344 (depth = 9)
  int op_slot_right_6343 = gc_frame_newslot(num6344);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6343 = gc_frame_newslot(*var_depth);
  params[0] = num6344;
  partcv[0] = 1;
  Object sum6346 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6346 (depth = 8)
  gc_frame_newslot(sum6346);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6347 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6349 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6348);
// compiled call node returning call6349 (depth = 11)
// compiled member node returning call6349 (depth = 10)
  partcv[0] = 0;
  Object call6350 = callmethod(call6349, "last",
    1, partcv, params);
  gc_frame_end(callframe6347);
// compiled call node returning call6350 (depth = 9)
// compiled member node returning call6350 (depth = 8)
  params[0] = sum6346;
  partcv[0] = 1;
  Object call6351 = callmethod(call6350, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6342);
// compiled call node returning call6351 (depth = 7)
  int op_slot_right_6341 = gc_frame_newslot(call6351);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6341 = gc_frame_newslot(*var_s);
  params[0] = call6351;
  partcv[0] = 1;
  Object opresult6353 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6353 (depth = 6)
  int op_slot_left_6338 = gc_frame_newslot(opresult6353);
  params[0] = strlit6339;
  partcv[0] = 1;
  Object opresult6354 = callmethod(opresult6353, "++", 1, partcv, params);
// compiled op node returning opresult6354 (depth = 5)
  *var_s = opresult6354;
  if (opresult6354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6295 = done;
  } else {
  }
// compiled if node returning if6295 (depth = 3)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6356(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6358 == NULL) {
    strlit6358 = alloc_String("");
    gc_root(strlit6358);
  }
// compiled string node returning strlit6358 (depth = 4)
  int op_slot_right_6357 = gc_frame_newslot(strlit6358);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6361 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6362 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6361);
// compiled call node returning call6362 (depth = 6)
// compiled member node returning call6362 (depth = 5)
  int op_slot_right_6360 = gc_frame_newslot(call6362);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6365 == NULL) {
    strlit6365 = alloc_String(".");
    gc_root(strlit6365);
  }
// compiled string node returning strlit6365 (depth = 6)
  int op_slot_right_6364 = gc_frame_newslot(strlit6365);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6368 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6369 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6368);
// compiled call node returning call6369 (depth = 8)
// compiled member node returning call6369 (depth = 7)
  int op_slot_right_6367 = gc_frame_newslot(call6369);
// starting to compile string node (depth = 7)
  if (strlit6371 == NULL) {
    strlit6371 = alloc_String("");
    gc_root(strlit6371);
  }
// compiled string node returning strlit6371 (depth = 7)
  int op_slot_left_6367 = gc_frame_newslot(strlit6371);
  params[0] = call6369;
  partcv[0] = 1;
  Object opresult6372 = callmethod(strlit6371, "++", 1, partcv, params);
// compiled op node returning opresult6372 (depth = 6)
  int op_slot_left_6364 = gc_frame_newslot(opresult6372);
  params[0] = strlit6365;
  partcv[0] = 1;
  Object opresult6373 = callmethod(opresult6372, "++", 1, partcv, params);
// compiled op node returning opresult6373 (depth = 5)
  int op_slot_left_6360 = gc_frame_newslot(opresult6373);
  params[0] = call6362;
  partcv[0] = 1;
  Object opresult6374 = callmethod(opresult6373, "++", 1, partcv, params);
// compiled op node returning opresult6374 (depth = 4)
  int op_slot_left_6357 = gc_frame_newslot(opresult6374);
  params[0] = strlit6358;
  partcv[0] = 1;
  Object opresult6375 = callmethod(opresult6374, "++", 1, partcv, params);
// compiled op node returning opresult6375 (depth = 3)
  gc_frame_end(frame);
  return opresult6375;
}
Object meth_ast_asIdentifier6376(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_right_6378 = gc_frame_newslot(*var_fakeSymbolTable);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6381 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6380);
// compiled call node returning call6381 (depth = 6)
// compiled member node returning call6381 (depth = 5)
  int op_slot_left_6378 = gc_frame_newslot(call6381);
  params[0] = *var_fakeSymbolTable;
  partcv[0] = 1;
  Object opresult6382 = callmethod(call6381, "==", 1, partcv, params);
// compiled op node returning opresult6382 (depth = 4)
  Object if6377 = done;
  if (istrue(opresult6382)) {
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6383 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6385 == NULL) {
    strlit6385 = alloc_String(" when scope was fake");
    gc_root(strlit6385);
  }
// compiled string node returning strlit6385 (depth = 6)
  int op_slot_right_6384 = gc_frame_newslot(strlit6385);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6388 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6389 = alloc_Float64(0);
// compiled num node returning num6389 (depth = 8)
  gc_frame_newslot(num6389);
// call case 4: self request
  params[0] = num6389;
  partcv[0] = 1;
  Object call6390 = callmethodflags(self, "pretty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6388);
// compiled call node returning call6390 (depth = 7)
  int op_slot_right_6387 = gc_frame_newslot(call6390);
// starting to compile string node (depth = 7)
  if (strlit6392 == NULL) {
    strlit6392 = alloc_String("asIdentifier requested on ");
    gc_root(strlit6392);
  }
// compiled string node returning strlit6392 (depth = 7)
  int op_slot_left_6387 = gc_frame_newslot(strlit6392);
  params[0] = call6390;
  partcv[0] = 1;
  Object opresult6393 = callmethod(strlit6392, "++", 1, partcv, params);
// compiled op node returning opresult6393 (depth = 6)
  int op_slot_left_6384 = gc_frame_newslot(opresult6393);
  params[0] = strlit6385;
  partcv[0] = 1;
  Object opresult6394 = callmethod(opresult6393, "++", 1, partcv, params);
// compiled op node returning opresult6394 (depth = 5)
  gc_frame_newslot(opresult6394);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6395 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6396 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6395);
// compiled call node returning call6396 (depth = 6)
// compiled member node returning call6396 (depth = 5)
  params[0] = opresult6394;
  partcv[0] = 1;
  Object call6397 = callmethod(call6396, "raise",
    1, partcv, params);
  gc_frame_end(callframe6383);
// compiled call node returning call6397 (depth = 4)
    gc_frame_newslot(call6397);
    if6377 = call6397;
  } else {
  }
// compiled if node returning if6377 (depth = 3)
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6398 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6400 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6399);
// compiled call node returning call6400 (depth = 6)
// compiled member node returning call6400 (depth = 5)
  gc_frame_newslot(call6400);
// starting to compile identifier node (depth = 5)
  Object bool6401 = alloc_Boolean(0);
// compiled identifier node returning bool6401 (depth = 5)
  gc_frame_newslot(bool6401);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6403 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6402);
// compiled call node returning call6403 (depth = 6)
// compiled member node returning call6403 (depth = 5)
  gc_frame_newslot(call6403);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call6400;
  params[1] = bool6401;
  params[2] = call6403;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6404 = callmethod(*var_identifierNode, "new()scope",
    2, partcv, params);
  gc_frame_end(callframe6398);
// compiled call node returning call6404 (depth = 4)
  *var_resultNode = call6404;
  if (call6404 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6405 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6406 = alloc_Boolean(1);
// compiled identifier node returning bool6406 (depth = 4)
  gc_frame_newslot(bool6406);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool6406;
  partcv[0] = 1;
  Object call6407 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe6405);
// compiled call node returning call6407 (depth = 3)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6408 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6409 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6410 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6409);
// compiled call node returning call6410 (depth = 5)
// compiled member node returning call6410 (depth = 4)
  gc_frame_newslot(call6410);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6410;
  partcv[0] = 1;
  Object call6411 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6408);
// compiled call node returning call6411 (depth = 3)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6412 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6413 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6414 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6413);
// compiled call node returning call6414 (depth = 5)
// compiled member node returning call6414 (depth = 4)
  gc_frame_newslot(call6414);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6414;
  partcv[0] = 1;
  Object call6415 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6412);
// compiled call node returning call6415 (depth = 3)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy6416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_memberNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6417 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6418 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6419 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6420 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6419);
// compiled call node returning call6420 (depth = 6)
// compiled member node returning call6420 (depth = 5)
  gc_frame_newslot(call6420);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_memberNode (depth = 5)
  params[0] = call6420;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call6421 = callmethod(*var_memberNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6418);
// compiled call node returning call6421 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6422 = callmethod(call6421, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6417);
// compiled call node returning call6422 (depth = 3)
  gc_frame_end(frame);
  return call6422;
}
Object meth_ast_statementName6423(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6424 == NULL) {
    strlit6424 = alloc_String("expression");
    gc_root(strlit6424);
  }
// compiled string node returning strlit6424 (depth = 3)
  gc_frame_end(frame);
  return strlit6424;
}
Object meth_ast_new6091(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6092 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6092 = alloc_userobj2(18,16, objclass6092);
  gc_frame_newslot(obj6092);
if (objclass6092 == NULL) {
  glfree(obj6092->class->name);
  obj6092->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6092, self, 0);
  addmethodreal(obj6092,"outer", &reader_ast_outer_6093);
  Object oldself6092 = self;
  struct StackFrameObject *oldstackframe6092 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6092);
  gc_frame_newslot((Object)stackframe);
  self = obj6092;
  Object *oldselfslot6092 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6092 = (*(struct UserObject *)self).data[0], lowerouter6092 = thisouter6092;
  if (inheritingObject6092) {
    struct UserObject *inho6092 = (struct UserObject *)inheritingObject6092;
    while (inho6092->super != GraceDefaultObject) inho6092 = (struct UserObject *)inho6092->super;
    inho6092->super = obj6092;
    self = inheritingObject6092;
    *selfslot = self;
    lowerouter6092 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6092;
  }
if (objclass6092 == NULL) {
  Method *reader6094 = addmethodrealflags(obj6092, "kind",&reader_ast_kind_6094, MFLAG_DEF);
  reader6094->definitionModule = modulename;
  reader6094->definitionLine = 1456;
}
adddatum2(obj6092, alloc_Undefined(), 1);
if (objclass6092 == NULL) {
  Method *reader6095 = addmethodrealflags(obj6092, "value",&reader_ast_value_6095, 0);
  Method *writer6095 = addmethodrealflags(obj6092, "value:=",&writer_ast_value_6095, 0);
  reader6095->definitionModule = modulename;
  writer6095->definitionModule = modulename;
  reader6095->definitionLine = 1457;
  writer6095->definitionLine = 1457;
}
obj6092->flags |= OFLAG_MUTABLE;
adddatum2(obj6092, alloc_Undefined(), 2);
if (objclass6092 == NULL) {
  Method *reader6096 = addmethodrealflags(obj6092, "in",&reader_ast_in_6096, 0);
  Method *writer6096 = addmethodrealflags(obj6092, "in:=",&writer_ast_in_6096, 0);
  reader6096->definitionModule = modulename;
  writer6096->definitionModule = modulename;
  reader6096->definitionLine = 1458;
  writer6096->definitionLine = 1458;
}
obj6092->flags |= OFLAG_MUTABLE;
adddatum2(obj6092, alloc_Undefined(), 3);
if (objclass6092 == NULL) {
  Method *reader6097 = addmethodrealflags(obj6092, "generics",&reader_ast_generics_6097, 0);
  Method *writer6097 = addmethodrealflags(obj6092, "generics:=",&writer_ast_generics_6097, 0);
  reader6097->definitionModule = modulename;
  writer6097->definitionModule = modulename;
  reader6097->definitionLine = 1459;
  writer6097->definitionLine = 1459;
}
obj6092->flags |= OFLAG_MUTABLE;
adddatum2(obj6092, alloc_Undefined(), 4);
// method "target"
  struct UserObject *uo6098 = (struct UserObject*)obj6092;
  uo6098->data[5] = emptyclosure;
  Method *meth_meth_ast_target6098 = addmethod2pos(obj6092, "target", &meth_ast_target6098, 5);
  int argcv_meth_ast_target6098[] = {0};
  meth_meth_ast_target6098->type = alloc_MethodType(1, argcv_meth_ast_target6098);
  meth_meth_ast_target6098->definitionModule = modulename;
  meth_meth_ast_target6098->definitionLine = 1461;
// method "nameString"
  struct UserObject *uo6101 = (struct UserObject*)obj6092;
  uo6101->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString6101 = addmethod2pos(obj6092, "nameString", &meth_ast_nameString6101, 6);
  int argcv_meth_ast_nameString6101[] = {0};
  meth_meth_ast_nameString6101->type = alloc_MethodType(1, argcv_meth_ast_nameString6101);
  meth_meth_ast_nameString6101->definitionModule = modulename;
  meth_meth_ast_nameString6101->definitionLine = 1462;
// method "isMember"
  struct UserObject *uo6104 = (struct UserObject*)obj6092;
  uo6104->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember6104 = addmethod2pos(obj6092, "isMember", &meth_ast_isMember6104, 7);
  int argcv_meth_ast_isMember6104[] = {0};
  meth_meth_ast_isMember6104->type = alloc_MethodType(1, argcv_meth_ast_isMember6104);
  meth_meth_ast_isMember6104->definitionModule = modulename;
  meth_meth_ast_isMember6104->definitionLine = 1463;
// method "accept()from"
  struct UserObject *uo6106 = (struct UserObject*)obj6092;
  uo6106->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6106 = addmethod2pos(obj6092, "accept()from", &meth_ast_accept_40__41_from6106, 8);
  int argcv_meth_ast_accept_40__41_from6106[] = {1, 1};
  meth_meth_ast_accept_40__41_from6106->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6106);
  meth_meth_ast_accept_40__41_from6106->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6106->definitionLine = 1464;
// method "map()ancestors"
  struct UserObject *uo6132 = (struct UserObject*)obj6092;
  uo6132->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6132 = addmethod2pos(obj6092, "map()ancestors", &meth_ast_map_40__41_ancestors6132, 9);
  int argcv_meth_ast_map_40__41_ancestors6132[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6132->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6132);
  meth_meth_ast_map_40__41_ancestors6132->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6132->definitionLine = 1473;
// method "pretty"
  struct UserObject *uo6155 = (struct UserObject*)obj6092;
  uo6155->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6155 = addmethod2pos(obj6092, "pretty", &meth_ast_pretty6155, 10);
  int argcv_meth_ast_pretty6155[] = {1};
  meth_meth_ast_pretty6155->type = alloc_MethodType(1, argcv_meth_ast_pretty6155);
  meth_meth_ast_pretty6155->definitionModule = modulename;
  meth_meth_ast_pretty6155->definitionLine = 1480;
// method "toGrace"
  struct UserObject *uo6245 = (struct UserObject*)obj6092;
  uo6245->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6245 = addmethod2pos(obj6092, "toGrace", &meth_ast_toGrace6245, 11);
  int argcv_meth_ast_toGrace6245[] = {1};
  meth_meth_ast_toGrace6245->type = alloc_MethodType(1, argcv_meth_ast_toGrace6245);
meth_meth_ast_toGrace6245->type->types[0] = type_Number;
meth_meth_ast_toGrace6245->type->names[0] = "depth";
  meth_meth_ast_toGrace6245->definitionModule = modulename;
  meth_meth_ast_toGrace6245->definitionLine = 1495;
// method "asString"
  struct UserObject *uo6356 = (struct UserObject*)obj6092;
  uo6356->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6356 = addmethod2pos(obj6092, "asString", &meth_ast_asString6356, 12);
  int argcv_meth_ast_asString6356[] = {0};
  meth_meth_ast_asString6356->type = alloc_MethodType(1, argcv_meth_ast_asString6356);
  meth_meth_ast_asString6356->definitionModule = modulename;
  meth_meth_ast_asString6356->definitionLine = 1512;
// method "asIdentifier"
  block_savedest(obj6092);
  Object closure6376 = createclosure(2, "asIdentifier");
  setclosureframe(closure6376, stackframe);
  addtoclosure(closure6376, var_fakeSymbolTable);
  addtoclosure(closure6376, var_identifierNode);
  struct UserObject *uo6376 = (struct UserObject*)obj6092;
  uo6376->data[13] = (Object)closure6376;
  Method *meth_meth_ast_asIdentifier6376 = addmethod2pos(obj6092, "asIdentifier", &meth_ast_asIdentifier6376, 13);
  int argcv_meth_ast_asIdentifier6376[] = {0};
  meth_meth_ast_asIdentifier6376->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6376);
  meth_meth_ast_asIdentifier6376->definitionModule = modulename;
  meth_meth_ast_asIdentifier6376->definitionLine = 1513;
// method "shallowCopy"
  block_savedest(obj6092);
  Object closure6416 = createclosure(2, "shallowCopy");
  setclosureframe(closure6416, stackframe);
  addtoclosure(closure6416, var_nullNode);
  addtoclosure(closure6416, var_memberNode);
  struct UserObject *uo6416 = (struct UserObject*)obj6092;
  uo6416->data[14] = (Object)closure6416;
  Method *meth_meth_ast_shallowCopy6416 = addmethod2pos(obj6092, "shallowCopy", &meth_ast_shallowCopy6416, 14);
  int argcv_meth_ast_shallowCopy6416[] = {0};
  meth_meth_ast_shallowCopy6416->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6416);
  meth_meth_ast_shallowCopy6416->definitionModule = modulename;
  meth_meth_ast_shallowCopy6416->definitionLine = 1524;
// method "statementName"
  struct UserObject *uo6423 = (struct UserObject*)obj6092;
  uo6423->data[15] = emptyclosure;
  Method *meth_meth_ast_statementName6423 = addmethod2pos(obj6092, "statementName", &meth_ast_statementName6423, 15);
  int argcv_meth_ast_statementName6423[] = {0};
  meth_meth_ast_statementName6423->type = alloc_MethodType(1, argcv_meth_ast_statementName6423);
  meth_meth_ast_statementName6423->definitionModule = modulename;
  meth_meth_ast_statementName6423->definitionLine = 1527;
  sourceObject = obj6092;
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6425 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6426 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6427 = gc_frame_new();
// call case 3: self.outer request
  Object call6428 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6427);
// compiled call node returning call6428 (depth = 7)
// compiled member node returning call6428 (depth = 6)
  partcv[0] = 0;
  Object call6429 = callmethodflags(call6428, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6426);
// compiled call node returning call6429 (depth = 5)
// compiled member node returning call6429 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6430 = callmethodflags(call6429, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6425);
// compiled call node returning call6430 (depth = 3)
  struct UserObject *obj6092_uo = (struct UserObject *)obj6092;
  obj6092_uo->super = call6430;
  sourceObject = obj6092;
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6431 == NULL) {
    strlit6431 = alloc_String("member");
    gc_root(strlit6431);
  }
// compiled string node returning strlit6431 (depth = 3)
  adddatum2(obj6092, strlit6431, 1);
  sourceObject = obj6092;
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6092, *var_request, 2);
  sourceObject = obj6092;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver (depth = 3)
  adddatum2(obj6092, *var_receiver, 3);
  sourceObject = obj6092;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6432 = alloc_Boolean(0);
// compiled identifier node returning bool6432 (depth = 3)
  adddatum2(obj6092, bool6432, 4);
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  objclass6092 = obj6092->class;
  objclass6092->definitionModule = modulename;
  objclass6092->definitionLine = 1453;
  (*(struct UserObject *)self).data[0] = lowerouter6092;
  self = oldself6092;
  selfslot = oldselfslot6092;
  stackframe = oldstackframe6092;
  gc_frame_end(frame);
  return obj6092;
}
Object meth_ast_new6091_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6092 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6092 = alloc_userobj2(18,16, objclass6092);
  gc_frame_newslot(obj6092);
if (objclass6092 == NULL) {
  glfree(obj6092->class->name);
  obj6092->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6092, self, 0);
  addmethodreal(obj6092,"outer", &reader_ast_outer_6093);
  Object oldself6092 = self;
  struct StackFrameObject *oldstackframe6092 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6092);
  gc_frame_newslot((Object)stackframe);
  self = obj6092;
  Object *oldselfslot6092 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6092 = (*(struct UserObject *)self).data[0], lowerouter6092 = thisouter6092;
  if (inheritingObject6092) {
    struct UserObject *inho6092 = (struct UserObject *)inheritingObject6092;
    while (inho6092->super != GraceDefaultObject) inho6092 = (struct UserObject *)inho6092->super;
    inho6092->super = obj6092;
    self = inheritingObject6092;
    *selfslot = self;
    lowerouter6092 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6092;
  }
if (objclass6092 == NULL) {
  Method *reader6094 = addmethodrealflags(obj6092, "kind",&reader_ast_kind_6094, MFLAG_DEF);
  reader6094->definitionModule = modulename;
  reader6094->definitionLine = 1456;
}
adddatum2(obj6092, alloc_Undefined(), 1);
if (objclass6092 == NULL) {
  Method *reader6095 = addmethodrealflags(obj6092, "value",&reader_ast_value_6095, 0);
  Method *writer6095 = addmethodrealflags(obj6092, "value:=",&writer_ast_value_6095, 0);
  reader6095->definitionModule = modulename;
  writer6095->definitionModule = modulename;
  reader6095->definitionLine = 1457;
  writer6095->definitionLine = 1457;
}
obj6092->flags |= OFLAG_MUTABLE;
adddatum2(obj6092, alloc_Undefined(), 2);
if (objclass6092 == NULL) {
  Method *reader6096 = addmethodrealflags(obj6092, "in",&reader_ast_in_6096, 0);
  Method *writer6096 = addmethodrealflags(obj6092, "in:=",&writer_ast_in_6096, 0);
  reader6096->definitionModule = modulename;
  writer6096->definitionModule = modulename;
  reader6096->definitionLine = 1458;
  writer6096->definitionLine = 1458;
}
obj6092->flags |= OFLAG_MUTABLE;
adddatum2(obj6092, alloc_Undefined(), 3);
if (objclass6092 == NULL) {
  Method *reader6097 = addmethodrealflags(obj6092, "generics",&reader_ast_generics_6097, 0);
  Method *writer6097 = addmethodrealflags(obj6092, "generics:=",&writer_ast_generics_6097, 0);
  reader6097->definitionModule = modulename;
  writer6097->definitionModule = modulename;
  reader6097->definitionLine = 1459;
  writer6097->definitionLine = 1459;
}
obj6092->flags |= OFLAG_MUTABLE;
adddatum2(obj6092, alloc_Undefined(), 4);
// method "target"
  struct UserObject *uo6098 = (struct UserObject*)obj6092;
  uo6098->data[5] = emptyclosure;
  Method *meth_meth_ast_target6098 = addmethod2pos(obj6092, "target", &meth_ast_target6098, 5);
  int argcv_meth_ast_target6098[] = {0};
  meth_meth_ast_target6098->type = alloc_MethodType(1, argcv_meth_ast_target6098);
  meth_meth_ast_target6098->definitionModule = modulename;
  meth_meth_ast_target6098->definitionLine = 1461;
// method "nameString"
  struct UserObject *uo6101 = (struct UserObject*)obj6092;
  uo6101->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString6101 = addmethod2pos(obj6092, "nameString", &meth_ast_nameString6101, 6);
  int argcv_meth_ast_nameString6101[] = {0};
  meth_meth_ast_nameString6101->type = alloc_MethodType(1, argcv_meth_ast_nameString6101);
  meth_meth_ast_nameString6101->definitionModule = modulename;
  meth_meth_ast_nameString6101->definitionLine = 1462;
// method "isMember"
  struct UserObject *uo6104 = (struct UserObject*)obj6092;
  uo6104->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember6104 = addmethod2pos(obj6092, "isMember", &meth_ast_isMember6104, 7);
  int argcv_meth_ast_isMember6104[] = {0};
  meth_meth_ast_isMember6104->type = alloc_MethodType(1, argcv_meth_ast_isMember6104);
  meth_meth_ast_isMember6104->definitionModule = modulename;
  meth_meth_ast_isMember6104->definitionLine = 1463;
// method "accept()from"
  struct UserObject *uo6106 = (struct UserObject*)obj6092;
  uo6106->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6106 = addmethod2pos(obj6092, "accept()from", &meth_ast_accept_40__41_from6106, 8);
  int argcv_meth_ast_accept_40__41_from6106[] = {1, 1};
  meth_meth_ast_accept_40__41_from6106->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6106);
  meth_meth_ast_accept_40__41_from6106->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6106->definitionLine = 1464;
// method "map()ancestors"
  struct UserObject *uo6132 = (struct UserObject*)obj6092;
  uo6132->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6132 = addmethod2pos(obj6092, "map()ancestors", &meth_ast_map_40__41_ancestors6132, 9);
  int argcv_meth_ast_map_40__41_ancestors6132[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6132->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6132);
  meth_meth_ast_map_40__41_ancestors6132->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6132->definitionLine = 1473;
// method "pretty"
  struct UserObject *uo6155 = (struct UserObject*)obj6092;
  uo6155->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6155 = addmethod2pos(obj6092, "pretty", &meth_ast_pretty6155, 10);
  int argcv_meth_ast_pretty6155[] = {1};
  meth_meth_ast_pretty6155->type = alloc_MethodType(1, argcv_meth_ast_pretty6155);
  meth_meth_ast_pretty6155->definitionModule = modulename;
  meth_meth_ast_pretty6155->definitionLine = 1480;
// method "toGrace"
  struct UserObject *uo6245 = (struct UserObject*)obj6092;
  uo6245->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6245 = addmethod2pos(obj6092, "toGrace", &meth_ast_toGrace6245, 11);
  int argcv_meth_ast_toGrace6245[] = {1};
  meth_meth_ast_toGrace6245->type = alloc_MethodType(1, argcv_meth_ast_toGrace6245);
meth_meth_ast_toGrace6245->type->types[0] = type_Number;
meth_meth_ast_toGrace6245->type->names[0] = "depth";
  meth_meth_ast_toGrace6245->definitionModule = modulename;
  meth_meth_ast_toGrace6245->definitionLine = 1495;
// method "asString"
  struct UserObject *uo6356 = (struct UserObject*)obj6092;
  uo6356->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6356 = addmethod2pos(obj6092, "asString", &meth_ast_asString6356, 12);
  int argcv_meth_ast_asString6356[] = {0};
  meth_meth_ast_asString6356->type = alloc_MethodType(1, argcv_meth_ast_asString6356);
  meth_meth_ast_asString6356->definitionModule = modulename;
  meth_meth_ast_asString6356->definitionLine = 1512;
// method "asIdentifier"
  block_savedest(obj6092);
  Object closure6376 = createclosure(2, "asIdentifier");
  setclosureframe(closure6376, stackframe);
  addtoclosure(closure6376, var_fakeSymbolTable);
  addtoclosure(closure6376, var_identifierNode);
  struct UserObject *uo6376 = (struct UserObject*)obj6092;
  uo6376->data[13] = (Object)closure6376;
  Method *meth_meth_ast_asIdentifier6376 = addmethod2pos(obj6092, "asIdentifier", &meth_ast_asIdentifier6376, 13);
  int argcv_meth_ast_asIdentifier6376[] = {0};
  meth_meth_ast_asIdentifier6376->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6376);
  meth_meth_ast_asIdentifier6376->definitionModule = modulename;
  meth_meth_ast_asIdentifier6376->definitionLine = 1513;
// method "shallowCopy"
  block_savedest(obj6092);
  Object closure6416 = createclosure(2, "shallowCopy");
  setclosureframe(closure6416, stackframe);
  addtoclosure(closure6416, var_nullNode);
  addtoclosure(closure6416, var_memberNode);
  struct UserObject *uo6416 = (struct UserObject*)obj6092;
  uo6416->data[14] = (Object)closure6416;
  Method *meth_meth_ast_shallowCopy6416 = addmethod2pos(obj6092, "shallowCopy", &meth_ast_shallowCopy6416, 14);
  int argcv_meth_ast_shallowCopy6416[] = {0};
  meth_meth_ast_shallowCopy6416->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6416);
  meth_meth_ast_shallowCopy6416->definitionModule = modulename;
  meth_meth_ast_shallowCopy6416->definitionLine = 1524;
// method "statementName"
  struct UserObject *uo6423 = (struct UserObject*)obj6092;
  uo6423->data[15] = emptyclosure;
  Method *meth_meth_ast_statementName6423 = addmethod2pos(obj6092, "statementName", &meth_ast_statementName6423, 15);
  int argcv_meth_ast_statementName6423[] = {0};
  meth_meth_ast_statementName6423->type = alloc_MethodType(1, argcv_meth_ast_statementName6423);
  meth_meth_ast_statementName6423->definitionModule = modulename;
  meth_meth_ast_statementName6423->definitionLine = 1527;
  sourceObject = obj6092;
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6425 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6426 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6427 = gc_frame_new();
// call case 3: self.outer request
  Object call6428 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6427);
// compiled call node returning call6428 (depth = 7)
// compiled member node returning call6428 (depth = 6)
  partcv[0] = 0;
  Object call6429 = callmethodflags(call6428, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6426);
// compiled call node returning call6429 (depth = 5)
// compiled member node returning call6429 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6430 = callmethodflags(call6429, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6425);
// compiled call node returning call6430 (depth = 3)
  struct UserObject *obj6092_uo = (struct UserObject *)obj6092;
  obj6092_uo->super = call6430;
  sourceObject = obj6092;
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6431 == NULL) {
    strlit6431 = alloc_String("member");
    gc_root(strlit6431);
  }
// compiled string node returning strlit6431 (depth = 3)
  adddatum2(obj6092, strlit6431, 1);
  sourceObject = obj6092;
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6092, *var_request, 2);
  sourceObject = obj6092;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver (depth = 3)
  adddatum2(obj6092, *var_receiver, 3);
  sourceObject = obj6092;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6432 = alloc_Boolean(0);
// compiled identifier node returning bool6432 (depth = 3)
  adddatum2(obj6092, bool6432, 4);
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  sourceObject = obj6092;
  objclass6092 = obj6092->class;
  objclass6092->definitionModule = modulename;
  objclass6092->definitionLine = 1453;
  (*(struct UserObject *)self).data[0] = lowerouter6092;
  self = oldself6092;
  selfslot = oldselfslot6092;
  stackframe = oldstackframe6092;
  gc_frame_end(frame);
  return obj6092;
}
Object meth_ast_memberNode6434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for memberNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for memberNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_nameString6443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6444 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6445 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6446 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6445);
// compiled call node returning call6446 (depth = 6)
// compiled member node returning call6446 (depth = 5)
  partcv[0] = 0;
  Object call6447 = callmethod(call6446, "nameString",
    1, partcv, params);
  gc_frame_end(callframe6444);
// compiled call node returning call6447 (depth = 4)
// compiled member node returning call6447 (depth = 3)
  gc_frame_end(frame);
  return call6447;
}
Object meth_ast_asString6448(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6449 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6450 = alloc_Float64(0);
// compiled num node returning num6450 (depth = 4)
  gc_frame_newslot(num6450);
// call case 4: self request
  params[0] = num6450;
  partcv[0] = 1;
  Object call6451 = callmethodflags(self, "toGrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6449);
// compiled call node returning call6451 (depth = 3)
  gc_frame_end(frame);
  return call6451;
}
Object meth_ast__apply6466(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6467 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6468 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6467);
// compiled call node returning call6468 (depth = 6)
  gc_frame_end(frame);
  return call6468;
}
Object meth_ast_accept_40__41_from6452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6454 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6455 = callmethod(*var_visitor, "visitGeneric()up",
    2, partcv, params);
  gc_frame_end(callframe6454);
// compiled call node returning call6455 (depth = 4)
  Object if6453 = done;
  if (istrue(call6455)) {
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6456 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6457 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6456);
// compiled call node returning call6457 (depth = 5)
  *var_newChain = call6457;
  if (call6457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6458 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6459 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6460 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6459);
// compiled call node returning call6460 (depth = 6)
// compiled member node returning call6460 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6461 = callmethod(call6460, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6458);
// compiled call node returning call6461 (depth = 4)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6462 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6463 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6464 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6463);
// compiled call node returning call6464 (depth = 6)
// compiled member node returning call6464 (depth = 5)
  gc_frame_newslot(call6464);
// starting to compile block node (depth = 5)
  Object block6465 = alloc_Block(NULL, NULL, "ast", 1545);
  gc_frame_newslot(block6465);
// method "_apply"
  block_savedest(block6465);
  Object closure6466 = createclosure(3, "_apply");
  setclosureframe(closure6466, stackframe);
  addtoclosure(closure6466, var_visitor);
  addtoclosure(closure6466, var_newChain);
  addtoclosure(closure6466, selfslot);
  struct UserObject *uo6466 = (struct UserObject*)block6465;
  uo6466->data[0] = (Object)closure6466;
  Method *meth_meth_ast__apply6466 = addmethod2pos(block6465, "_apply", &meth_ast__apply6466, 0);
  int argcv_meth_ast__apply6466[] = {1};
  meth_meth_ast__apply6466->type = alloc_MethodType(1, argcv_meth_ast__apply6466);
  meth_meth_ast__apply6466->definitionModule = modulename;
  meth_meth_ast__apply6466->definitionLine = 1545;
// compiled block node returning block6465 (depth = 5)
  gc_frame_newslot(block6465);
// call case 5: prelude request
  params[0] = call6464;
  params[1] = block6465;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6470 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6462);
// compiled call node returning call6470 (depth = 4)
    gc_frame_newslot(call6470);
    if6453 = call6470;
  } else {
  }
// compiled if node returning if6453 (depth = 3)
  gc_frame_end(frame);
  return if6453;
}
Object meth_ast_map_40__41_ancestors6471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6473 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6472);
// compiled call node returning call6473 (depth = 5)
// compiled member node returning call6473 (depth = 4)
  *var_n = call6473;
  if (call6473 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6474 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6475 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6474);
// compiled call node returning call6475 (depth = 4)
  *var_newChain = call6475;
  if (call6475 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6476 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6477 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6479 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6478);
// compiled call node returning call6479 (depth = 6)
// compiled member node returning call6479 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6480 = callmethod(call6479, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe6477);
// compiled call node returning call6480 (depth = 4)
  gc_frame_newslot(call6480);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6480;
  partcv[0] = 1;
  Object call6481 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe6476);
// compiled call node returning call6481 (depth = 3)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6482 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6483 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6485 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6484);
// compiled call node returning call6485 (depth = 6)
// compiled member node returning call6485 (depth = 5)
  gc_frame_newslot(call6485);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6486 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6487 = gc_frame_new();
// call case 3: self.outer request
  Object call6488 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6487);
// compiled call node returning call6488 (depth = 8)
// compiled member node returning call6488 (depth = 7)
  partcv[0] = 0;
  Object call6489 = callmethodflags(call6488, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6486);
// compiled call node returning call6489 (depth = 6)
// compiled member node returning call6489 (depth = 5)
  params[0] = call6485;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6490 = callmethodflags(call6489, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6483);
// compiled call node returning call6490 (depth = 4)
  gc_frame_newslot(call6490);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6490;
  partcv[0] = 1;
  Object call6491 = callmethod(*var_n, "args:=",
    1, partcv, params);
  gc_frame_end(callframe6482);
// compiled call node returning call6491 (depth = 3)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6492 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6493 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6492);
// compiled call node returning call6493 (depth = 3)
  gc_frame_end(frame);
  return call6493;
}
Object meth_ast__apply6518(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6520 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6522 = alloc_Float64(2);
// compiled num node returning num6522 (depth = 9)
  int op_slot_right_6521 = gc_frame_newslot(num6522);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6521 = gc_frame_newslot(*var_depth);
  params[0] = num6522;
  partcv[0] = 1;
  Object sum6524 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6524 (depth = 8)
  gc_frame_newslot(sum6524);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6524;
  partcv[0] = 1;
  Object call6525 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6520);
// compiled call node returning call6525 (depth = 7)
  int op_slot_right_6519 = gc_frame_newslot(call6525);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6519 = gc_frame_newslot(*var_s);
  params[0] = call6525;
  partcv[0] = 1;
  Object opresult6527 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6527 (depth = 6)
  *var_s = opresult6527;
  if (opresult6527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6531(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6533 == NULL) {
    strlit6533 = alloc_String(", ");
    gc_root(strlit6533);
  }
// compiled string node returning strlit6533 (depth = 7)
  int op_slot_right_6532 = gc_frame_newslot(strlit6533);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6532 = gc_frame_newslot(*var_s);
  params[0] = strlit6533;
  partcv[0] = 1;
  Object opresult6535 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6535 (depth = 6)
  *var_s = opresult6535;
  if (opresult6535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6496 == NULL) {
    strlit6496 = alloc_String(")<");
    gc_root(strlit6496);
  }
// compiled string node returning strlit6496 (depth = 5)
  int op_slot_right_6495 = gc_frame_newslot(strlit6496);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6499 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6501 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6500);
// compiled call node returning call6501 (depth = 8)
// compiled member node returning call6501 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6502 = callmethod(call6501, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6499);
// compiled call node returning call6502 (depth = 6)
  int op_slot_right_6498 = gc_frame_newslot(call6502);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6505 == NULL) {
    strlit6505 = alloc_String("(");
    gc_root(strlit6505);
  }
// compiled string node returning strlit6505 (depth = 7)
  int op_slot_right_6504 = gc_frame_newslot(strlit6505);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6508 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6509 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6508);
// compiled call node returning call6509 (depth = 8)
  int op_slot_right_6507 = gc_frame_newslot(call6509);
// starting to compile string node (depth = 8)
  if (strlit6511 == NULL) {
    strlit6511 = alloc_String("");
    gc_root(strlit6511);
  }
// compiled string node returning strlit6511 (depth = 8)
  int op_slot_left_6507 = gc_frame_newslot(strlit6511);
  params[0] = call6509;
  partcv[0] = 1;
  Object opresult6512 = callmethod(strlit6511, "++", 1, partcv, params);
// compiled op node returning opresult6512 (depth = 7)
  int op_slot_left_6504 = gc_frame_newslot(opresult6512);
  params[0] = strlit6505;
  partcv[0] = 1;
  Object opresult6513 = callmethod(opresult6512, "++", 1, partcv, params);
// compiled op node returning opresult6513 (depth = 6)
  int op_slot_left_6498 = gc_frame_newslot(opresult6513);
  params[0] = call6502;
  partcv[0] = 1;
  Object opresult6514 = callmethod(opresult6513, "++", 1, partcv, params);
// compiled op node returning opresult6514 (depth = 5)
  int op_slot_left_6495 = gc_frame_newslot(opresult6514);
  params[0] = strlit6496;
  partcv[0] = 1;
  Object opresult6515 = callmethod(opresult6514, "++", 1, partcv, params);
// compiled op node returning opresult6515 (depth = 4)
  *var_s = opresult6515;
  if (opresult6515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6516 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6517 = alloc_Block(NULL, NULL, "ast", 1559);
  gc_frame_newslot(block6517);
// method "_apply"
  block_savedest(block6517);
  Object closure6518 = createclosure(3, "_apply");
  setclosureframe(closure6518, stackframe);
  addtoclosure(closure6518, var_depth);
  addtoclosure(closure6518, var_s);
  addtoclosure(closure6518, selfslot);
  struct UserObject *uo6518 = (struct UserObject*)block6517;
  uo6518->data[0] = (Object)closure6518;
  Method *meth_meth_ast__apply6518 = addmethod2pos(block6517, "_apply", &meth_ast__apply6518, 0);
  int argcv_meth_ast__apply6518[] = {1};
  meth_meth_ast__apply6518->type = alloc_MethodType(1, argcv_meth_ast__apply6518);
  meth_meth_ast__apply6518->definitionModule = modulename;
  meth_meth_ast__apply6518->definitionLine = 1558;
// compiled block node returning block6517 (depth = 4)
  gc_frame_newslot(block6517);
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6530 = alloc_Block(NULL, NULL, "ast", 1560);
  gc_frame_newslot(block6530);
// method "_apply"
  block_savedest(block6530);
  Object closure6531 = createclosure(2, "_apply");
  setclosureframe(closure6531, stackframe);
  addtoclosure(closure6531, var_s);
  addtoclosure(closure6531, selfslot);
  struct UserObject *uo6531 = (struct UserObject*)block6530;
  uo6531->data[0] = (Object)closure6531;
  Method *meth_meth_ast__apply6531 = addmethod2pos(block6530, "_apply", &meth_ast__apply6531, 0);
  int argcv_meth_ast__apply6531[] = {0};
  meth_meth_ast__apply6531->type = alloc_MethodType(1, argcv_meth_ast__apply6531);
  meth_meth_ast__apply6531->definitionModule = modulename;
  meth_meth_ast__apply6531->definitionLine = 1558;
// compiled block node returning block6530 (depth = 4)
  gc_frame_newslot(block6530);
// call case 6: other member request
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6538 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6539 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6538);
// compiled call node returning call6539 (depth = 5)
// compiled member node returning call6539 (depth = 4)
  params[0] = block6517;
  params[1] = block6530;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6540 = callmethod(call6539, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6516);
// compiled call node returning call6540 (depth = 3)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6542 == NULL) {
    strlit6542 = alloc_String(">");
    gc_root(strlit6542);
  }
// compiled string node returning strlit6542 (depth = 4)
  int op_slot_right_6541 = gc_frame_newslot(strlit6542);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6541 = gc_frame_newslot(*var_s);
  params[0] = strlit6542;
  partcv[0] = 1;
  Object opresult6544 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6544 (depth = 3)
  gc_frame_end(frame);
  return opresult6544;
}
Object meth_ast__apply6554(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6556 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6557 = alloc_Float64(0);
// compiled num node returning num6557 (depth = 8)
  gc_frame_newslot(num6557);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = num6557;
  partcv[0] = 1;
  Object call6558 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6556);
// compiled call node returning call6558 (depth = 7)
  int op_slot_right_6555 = gc_frame_newslot(call6558);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6555 = gc_frame_newslot(*var_s);
  params[0] = call6558;
  partcv[0] = 1;
  Object opresult6560 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6560 (depth = 6)
  *var_s = opresult6560;
  if (opresult6560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6564(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6566 == NULL) {
    strlit6566 = alloc_String(", ");
    gc_root(strlit6566);
  }
// compiled string node returning strlit6566 (depth = 7)
  int op_slot_right_6565 = gc_frame_newslot(strlit6566);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6565 = gc_frame_newslot(*var_s);
  params[0] = strlit6566;
  partcv[0] = 1;
  Object opresult6568 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6568 (depth = 6)
  *var_s = opresult6568;
  if (opresult6568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6547 == NULL) {
    strlit6547 = alloc_String("<");
    gc_root(strlit6547);
  }
// compiled string node returning strlit6547 (depth = 5)
  int op_slot_right_6546 = gc_frame_newslot(strlit6547);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6549 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6550 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6549);
// compiled call node returning call6550 (depth = 6)
// compiled member node returning call6550 (depth = 5)
  int op_slot_left_6546 = gc_frame_newslot(call6550);
  params[0] = strlit6547;
  partcv[0] = 1;
  Object opresult6551 = callmethod(call6550, "++", 1, partcv, params);
// compiled op node returning opresult6551 (depth = 4)
  *var_s = opresult6551;
  if (opresult6551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6552 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6553 = alloc_Block(NULL, NULL, "ast", 1565);
  gc_frame_newslot(block6553);
// method "_apply"
  block_savedest(block6553);
  Object closure6554 = createclosure(2, "_apply");
  setclosureframe(closure6554, stackframe);
  addtoclosure(closure6554, var_s);
  addtoclosure(closure6554, selfslot);
  struct UserObject *uo6554 = (struct UserObject*)block6553;
  uo6554->data[0] = (Object)closure6554;
  Method *meth_meth_ast__apply6554 = addmethod2pos(block6553, "_apply", &meth_ast__apply6554, 0);
  int argcv_meth_ast__apply6554[] = {1};
  meth_meth_ast__apply6554->type = alloc_MethodType(1, argcv_meth_ast__apply6554);
  meth_meth_ast__apply6554->definitionModule = modulename;
  meth_meth_ast__apply6554->definitionLine = 1564;
// compiled block node returning block6553 (depth = 4)
  gc_frame_newslot(block6553);
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6563 = alloc_Block(NULL, NULL, "ast", 1566);
  gc_frame_newslot(block6563);
// method "_apply"
  block_savedest(block6563);
  Object closure6564 = createclosure(2, "_apply");
  setclosureframe(closure6564, stackframe);
  addtoclosure(closure6564, var_s);
  addtoclosure(closure6564, selfslot);
  struct UserObject *uo6564 = (struct UserObject*)block6563;
  uo6564->data[0] = (Object)closure6564;
  Method *meth_meth_ast__apply6564 = addmethod2pos(block6563, "_apply", &meth_ast__apply6564, 0);
  int argcv_meth_ast__apply6564[] = {0};
  meth_meth_ast__apply6564->type = alloc_MethodType(1, argcv_meth_ast__apply6564);
  meth_meth_ast__apply6564->definitionModule = modulename;
  meth_meth_ast__apply6564->definitionLine = 1564;
// compiled block node returning block6563 (depth = 4)
  gc_frame_newslot(block6563);
// call case 6: other member request
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6572 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6571);
// compiled call node returning call6572 (depth = 5)
// compiled member node returning call6572 (depth = 4)
  params[0] = block6553;
  params[1] = block6563;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6573 = callmethod(call6572, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6552);
// compiled call node returning call6573 (depth = 3)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6575 == NULL) {
    strlit6575 = alloc_String(">");
    gc_root(strlit6575);
  }
// compiled string node returning strlit6575 (depth = 4)
  int op_slot_right_6574 = gc_frame_newslot(strlit6575);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6574 = gc_frame_newslot(*var_s);
  params[0] = strlit6575;
  partcv[0] = 1;
  Object opresult6577 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6577 (depth = 3)
  gc_frame_end(frame);
  return opresult6577;
}
Object meth_ast_shallowCopy6578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6579 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6580 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6581 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6582 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6581);
// compiled call node returning call6582 (depth = 6)
// compiled member node returning call6582 (depth = 5)
  gc_frame_newslot(call6582);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6583 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6584 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6583);
// compiled call node returning call6584 (depth = 6)
// compiled member node returning call6584 (depth = 5)
  gc_frame_newslot(call6584);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericNode (depth = 5)
  params[0] = call6582;
  params[1] = call6584;
  partcv[0] = 2;
  Object call6585 = callmethod(*var_genericNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6580);
// compiled call node returning call6585 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6586 = callmethod(call6585, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6579);
// compiled call node returning call6586 (depth = 3)
  gc_frame_end(frame);
  return call6586;
}
Object meth_ast_new6437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6438 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6438 = alloc_userobj2(12,11, objclass6438);
  gc_frame_newslot(obj6438);
if (objclass6438 == NULL) {
  glfree(obj6438->class->name);
  obj6438->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6438, self, 0);
  addmethodreal(obj6438,"outer", &reader_ast_outer_6439);
  Object oldself6438 = self;
  struct StackFrameObject *oldstackframe6438 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6438);
  gc_frame_newslot((Object)stackframe);
  self = obj6438;
  Object *oldselfslot6438 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6438 = (*(struct UserObject *)self).data[0], lowerouter6438 = thisouter6438;
  if (inheritingObject6438) {
    struct UserObject *inho6438 = (struct UserObject *)inheritingObject6438;
    while (inho6438->super != GraceDefaultObject) inho6438 = (struct UserObject *)inho6438->super;
    inho6438->super = obj6438;
    self = inheritingObject6438;
    *selfslot = self;
    lowerouter6438 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6438;
  }
if (objclass6438 == NULL) {
  Method *reader6440 = addmethodrealflags(obj6438, "kind",&reader_ast_kind_6440, MFLAG_DEF);
  reader6440->definitionModule = modulename;
  reader6440->definitionLine = 1534;
}
adddatum2(obj6438, alloc_Undefined(), 1);
if (objclass6438 == NULL) {
  Method *reader6441 = addmethodrealflags(obj6438, "value",&reader_ast_value_6441, 0);
  Method *writer6441 = addmethodrealflags(obj6438, "value:=",&writer_ast_value_6441, 0);
  reader6441->definitionModule = modulename;
  writer6441->definitionModule = modulename;
  reader6441->definitionLine = 1535;
  writer6441->definitionLine = 1535;
}
obj6438->flags |= OFLAG_MUTABLE;
adddatum2(obj6438, alloc_Undefined(), 2);
if (objclass6438 == NULL) {
  Method *reader6442 = addmethodrealflags(obj6438, "args",&reader_ast_args_6442, 0);
  Method *writer6442 = addmethodrealflags(obj6438, "args:=",&writer_ast_args_6442, 0);
  reader6442->definitionModule = modulename;
  writer6442->definitionModule = modulename;
  reader6442->definitionLine = 1538;
  writer6442->definitionLine = 1538;
}
obj6438->flags |= OFLAG_MUTABLE;
adddatum2(obj6438, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6443 = (struct UserObject*)obj6438;
  uo6443->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6443 = addmethod2pos(obj6438, "nameString", &meth_ast_nameString6443, 4);
  int argcv_meth_ast_nameString6443[] = {0};
  meth_meth_ast_nameString6443->type = alloc_MethodType(1, argcv_meth_ast_nameString6443);
  meth_meth_ast_nameString6443->definitionModule = modulename;
  meth_meth_ast_nameString6443->definitionLine = 1539;
// method "asString"
  struct UserObject *uo6448 = (struct UserObject*)obj6438;
  uo6448->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6448 = addmethod2pos(obj6438, "asString", &meth_ast_asString6448, 5);
  int argcv_meth_ast_asString6448[] = {0};
  meth_meth_ast_asString6448->type = alloc_MethodType(1, argcv_meth_ast_asString6448);
  meth_meth_ast_asString6448->definitionModule = modulename;
  meth_meth_ast_asString6448->definitionLine = 1540;
// method "accept()from"
  struct UserObject *uo6452 = (struct UserObject*)obj6438;
  uo6452->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6452 = addmethod2pos(obj6438, "accept()from", &meth_ast_accept_40__41_from6452, 6);
  int argcv_meth_ast_accept_40__41_from6452[] = {1, 1};
  meth_meth_ast_accept_40__41_from6452->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6452);
  meth_meth_ast_accept_40__41_from6452->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6452->definitionLine = 1541;
// method "map()ancestors"
  struct UserObject *uo6471 = (struct UserObject*)obj6438;
  uo6471->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6471 = addmethod2pos(obj6438, "map()ancestors", &meth_ast_map_40__41_ancestors6471, 7);
  int argcv_meth_ast_map_40__41_ancestors6471[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6471->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6471);
  meth_meth_ast_map_40__41_ancestors6471->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6471->definitionLine = 1550;
// method "pretty"
  struct UserObject *uo6494 = (struct UserObject*)obj6438;
  uo6494->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6494 = addmethod2pos(obj6438, "pretty", &meth_ast_pretty6494, 8);
  int argcv_meth_ast_pretty6494[] = {1};
  meth_meth_ast_pretty6494->type = alloc_MethodType(1, argcv_meth_ast_pretty6494);
  meth_meth_ast_pretty6494->definitionModule = modulename;
  meth_meth_ast_pretty6494->definitionLine = 1557;
// method "toGrace"
  struct UserObject *uo6545 = (struct UserObject*)obj6438;
  uo6545->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6545 = addmethod2pos(obj6438, "toGrace", &meth_ast_toGrace6545, 9);
  int argcv_meth_ast_toGrace6545[] = {1};
  meth_meth_ast_toGrace6545->type = alloc_MethodType(1, argcv_meth_ast_toGrace6545);
meth_meth_ast_toGrace6545->type->types[0] = type_Number;
meth_meth_ast_toGrace6545->type->names[0] = "depth";
  meth_meth_ast_toGrace6545->definitionModule = modulename;
  meth_meth_ast_toGrace6545->definitionLine = 1563;
// method "shallowCopy"
  block_savedest(obj6438);
  Object closure6578 = createclosure(1, "shallowCopy");
  setclosureframe(closure6578, stackframe);
  addtoclosure(closure6578, var_genericNode);
  struct UserObject *uo6578 = (struct UserObject*)obj6438;
  uo6578->data[10] = (Object)closure6578;
  Method *meth_meth_ast_shallowCopy6578 = addmethod2pos(obj6438, "shallowCopy", &meth_ast_shallowCopy6578, 10);
  int argcv_meth_ast_shallowCopy6578[] = {0};
  meth_meth_ast_shallowCopy6578->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6578);
  meth_meth_ast_shallowCopy6578->definitionModule = modulename;
  meth_meth_ast_shallowCopy6578->definitionLine = 1569;
  sourceObject = obj6438;
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6587 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6588 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6589 = gc_frame_new();
// call case 3: self.outer request
  Object call6590 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6589);
// compiled call node returning call6590 (depth = 7)
// compiled member node returning call6590 (depth = 6)
  partcv[0] = 0;
  Object call6591 = callmethodflags(call6590, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6588);
// compiled call node returning call6591 (depth = 5)
// compiled member node returning call6591 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6592 = callmethodflags(call6591, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6587);
// compiled call node returning call6592 (depth = 3)
  struct UserObject *obj6438_uo = (struct UserObject *)obj6438;
  obj6438_uo->super = call6592;
  sourceObject = obj6438;
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6593 == NULL) {
    strlit6593 = alloc_String("generic");
    gc_root(strlit6593);
  }
// compiled string node returning strlit6593 (depth = 3)
  adddatum2(obj6438, strlit6593, 1);
  sourceObject = obj6438;
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6438, *var_base, 2);
  sourceObject = obj6438;
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6438, *var_arguments, 3);
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  objclass6438 = obj6438->class;
  objclass6438->definitionModule = modulename;
  objclass6438->definitionLine = 1531;
  (*(struct UserObject *)self).data[0] = lowerouter6438;
  self = oldself6438;
  selfslot = oldselfslot6438;
  stackframe = oldstackframe6438;
  gc_frame_end(frame);
  return obj6438;
}
Object meth_ast_new6437_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6438 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6438 = alloc_userobj2(12,11, objclass6438);
  gc_frame_newslot(obj6438);
if (objclass6438 == NULL) {
  glfree(obj6438->class->name);
  obj6438->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6438, self, 0);
  addmethodreal(obj6438,"outer", &reader_ast_outer_6439);
  Object oldself6438 = self;
  struct StackFrameObject *oldstackframe6438 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6438);
  gc_frame_newslot((Object)stackframe);
  self = obj6438;
  Object *oldselfslot6438 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6438 = (*(struct UserObject *)self).data[0], lowerouter6438 = thisouter6438;
  if (inheritingObject6438) {
    struct UserObject *inho6438 = (struct UserObject *)inheritingObject6438;
    while (inho6438->super != GraceDefaultObject) inho6438 = (struct UserObject *)inho6438->super;
    inho6438->super = obj6438;
    self = inheritingObject6438;
    *selfslot = self;
    lowerouter6438 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6438;
  }
if (objclass6438 == NULL) {
  Method *reader6440 = addmethodrealflags(obj6438, "kind",&reader_ast_kind_6440, MFLAG_DEF);
  reader6440->definitionModule = modulename;
  reader6440->definitionLine = 1534;
}
adddatum2(obj6438, alloc_Undefined(), 1);
if (objclass6438 == NULL) {
  Method *reader6441 = addmethodrealflags(obj6438, "value",&reader_ast_value_6441, 0);
  Method *writer6441 = addmethodrealflags(obj6438, "value:=",&writer_ast_value_6441, 0);
  reader6441->definitionModule = modulename;
  writer6441->definitionModule = modulename;
  reader6441->definitionLine = 1535;
  writer6441->definitionLine = 1535;
}
obj6438->flags |= OFLAG_MUTABLE;
adddatum2(obj6438, alloc_Undefined(), 2);
if (objclass6438 == NULL) {
  Method *reader6442 = addmethodrealflags(obj6438, "args",&reader_ast_args_6442, 0);
  Method *writer6442 = addmethodrealflags(obj6438, "args:=",&writer_ast_args_6442, 0);
  reader6442->definitionModule = modulename;
  writer6442->definitionModule = modulename;
  reader6442->definitionLine = 1538;
  writer6442->definitionLine = 1538;
}
obj6438->flags |= OFLAG_MUTABLE;
adddatum2(obj6438, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6443 = (struct UserObject*)obj6438;
  uo6443->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6443 = addmethod2pos(obj6438, "nameString", &meth_ast_nameString6443, 4);
  int argcv_meth_ast_nameString6443[] = {0};
  meth_meth_ast_nameString6443->type = alloc_MethodType(1, argcv_meth_ast_nameString6443);
  meth_meth_ast_nameString6443->definitionModule = modulename;
  meth_meth_ast_nameString6443->definitionLine = 1539;
// method "asString"
  struct UserObject *uo6448 = (struct UserObject*)obj6438;
  uo6448->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6448 = addmethod2pos(obj6438, "asString", &meth_ast_asString6448, 5);
  int argcv_meth_ast_asString6448[] = {0};
  meth_meth_ast_asString6448->type = alloc_MethodType(1, argcv_meth_ast_asString6448);
  meth_meth_ast_asString6448->definitionModule = modulename;
  meth_meth_ast_asString6448->definitionLine = 1540;
// method "accept()from"
  struct UserObject *uo6452 = (struct UserObject*)obj6438;
  uo6452->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6452 = addmethod2pos(obj6438, "accept()from", &meth_ast_accept_40__41_from6452, 6);
  int argcv_meth_ast_accept_40__41_from6452[] = {1, 1};
  meth_meth_ast_accept_40__41_from6452->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6452);
  meth_meth_ast_accept_40__41_from6452->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6452->definitionLine = 1541;
// method "map()ancestors"
  struct UserObject *uo6471 = (struct UserObject*)obj6438;
  uo6471->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6471 = addmethod2pos(obj6438, "map()ancestors", &meth_ast_map_40__41_ancestors6471, 7);
  int argcv_meth_ast_map_40__41_ancestors6471[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6471->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6471);
  meth_meth_ast_map_40__41_ancestors6471->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6471->definitionLine = 1550;
// method "pretty"
  struct UserObject *uo6494 = (struct UserObject*)obj6438;
  uo6494->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6494 = addmethod2pos(obj6438, "pretty", &meth_ast_pretty6494, 8);
  int argcv_meth_ast_pretty6494[] = {1};
  meth_meth_ast_pretty6494->type = alloc_MethodType(1, argcv_meth_ast_pretty6494);
  meth_meth_ast_pretty6494->definitionModule = modulename;
  meth_meth_ast_pretty6494->definitionLine = 1557;
// method "toGrace"
  struct UserObject *uo6545 = (struct UserObject*)obj6438;
  uo6545->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6545 = addmethod2pos(obj6438, "toGrace", &meth_ast_toGrace6545, 9);
  int argcv_meth_ast_toGrace6545[] = {1};
  meth_meth_ast_toGrace6545->type = alloc_MethodType(1, argcv_meth_ast_toGrace6545);
meth_meth_ast_toGrace6545->type->types[0] = type_Number;
meth_meth_ast_toGrace6545->type->names[0] = "depth";
  meth_meth_ast_toGrace6545->definitionModule = modulename;
  meth_meth_ast_toGrace6545->definitionLine = 1563;
// method "shallowCopy"
  block_savedest(obj6438);
  Object closure6578 = createclosure(1, "shallowCopy");
  setclosureframe(closure6578, stackframe);
  addtoclosure(closure6578, var_genericNode);
  struct UserObject *uo6578 = (struct UserObject*)obj6438;
  uo6578->data[10] = (Object)closure6578;
  Method *meth_meth_ast_shallowCopy6578 = addmethod2pos(obj6438, "shallowCopy", &meth_ast_shallowCopy6578, 10);
  int argcv_meth_ast_shallowCopy6578[] = {0};
  meth_meth_ast_shallowCopy6578->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6578);
  meth_meth_ast_shallowCopy6578->definitionModule = modulename;
  meth_meth_ast_shallowCopy6578->definitionLine = 1569;
  sourceObject = obj6438;
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6587 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6588 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6589 = gc_frame_new();
// call case 3: self.outer request
  Object call6590 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6589);
// compiled call node returning call6590 (depth = 7)
// compiled member node returning call6590 (depth = 6)
  partcv[0] = 0;
  Object call6591 = callmethodflags(call6590, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6588);
// compiled call node returning call6591 (depth = 5)
// compiled member node returning call6591 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6592 = callmethodflags(call6591, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6587);
// compiled call node returning call6592 (depth = 3)
  struct UserObject *obj6438_uo = (struct UserObject *)obj6438;
  obj6438_uo->super = call6592;
  sourceObject = obj6438;
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6593 == NULL) {
    strlit6593 = alloc_String("generic");
    gc_root(strlit6593);
  }
// compiled string node returning strlit6593 (depth = 3)
  adddatum2(obj6438, strlit6593, 1);
  sourceObject = obj6438;
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6438, *var_base, 2);
  sourceObject = obj6438;
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6438, *var_arguments, 3);
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  sourceObject = obj6438;
  objclass6438 = obj6438->class;
  objclass6438->definitionModule = modulename;
  objclass6438->definitionLine = 1531;
  (*(struct UserObject *)self).data[0] = lowerouter6438;
  self = oldself6438;
  selfslot = oldselfslot6438;
  stackframe = oldstackframe6438;
  gc_frame_end(frame);
  return obj6438;
}
Object meth_ast_genericNode6595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for genericNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for genericNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_asString6603(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6604 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6605 = alloc_Float64(0);
// compiled num node returning num6605 (depth = 4)
  gc_frame_newslot(num6605);
// call case 4: self request
  params[0] = num6605;
  partcv[0] = 1;
  Object call6606 = callmethodflags(self, "toGrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6604);
// compiled call node returning call6606 (depth = 3)
  gc_frame_end(frame);
  return call6606;
}
Object meth_ast_declarationKindWithAncestors6607(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6608 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call6609 = callmethod(*var_k, "typeparam",
    1, partcv, params);
  gc_frame_end(callframe6608);
// compiled call node returning call6609 (depth = 4)
// compiled member node returning call6609 (depth = 3)
  gc_frame_end(frame);
  return call6609;
}
Object meth_ast__apply6618(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6619 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6620 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6619);
// compiled call node returning call6620 (depth = 6)
  gc_frame_end(frame);
  return call6620;
}
Object meth_ast_accept_40__41_from6610(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6612 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6613 = callmethod(*var_visitor, "visitTypeParameters()up",
    2, partcv, params);
  gc_frame_end(callframe6612);
// compiled call node returning call6613 (depth = 4)
  Object if6611 = done;
  if (istrue(call6613)) {
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6614 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6615 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6614);
// compiled call node returning call6615 (depth = 5)
  *var_newChain = call6615;
  if (call6615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6616 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6617 = alloc_Block(NULL, NULL, "ast", 1586);
  gc_frame_newslot(block6617);
// method "_apply"
  block_savedest(block6617);
  Object closure6618 = createclosure(3, "_apply");
  setclosureframe(closure6618, stackframe);
  addtoclosure(closure6618, var_visitor);
  addtoclosure(closure6618, var_newChain);
  addtoclosure(closure6618, selfslot);
  struct UserObject *uo6618 = (struct UserObject*)block6617;
  uo6618->data[0] = (Object)closure6618;
  Method *meth_meth_ast__apply6618 = addmethod2pos(block6617, "_apply", &meth_ast__apply6618, 0);
  int argcv_meth_ast__apply6618[] = {1};
  meth_meth_ast__apply6618->type = alloc_MethodType(1, argcv_meth_ast__apply6618);
  meth_meth_ast__apply6618->definitionModule = modulename;
  meth_meth_ast__apply6618->definitionLine = 1581;
// compiled block node returning block6617 (depth = 5)
  gc_frame_newslot(block6617);
// call case 6: other member request
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6623 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6622);
// compiled call node returning call6623 (depth = 6)
// compiled member node returning call6623 (depth = 5)
  params[0] = block6617;
  partcv[0] = 1;
  Object call6624 = callmethod(call6623, "do",
    1, partcv, params);
  gc_frame_end(callframe6616);
// compiled call node returning call6624 (depth = 4)
    gc_frame_newslot(call6624);
    if6611 = call6624;
  } else {
  }
// compiled if node returning if6611 (depth = 3)
  gc_frame_end(frame);
  return if6611;
}
Object meth_ast_do6625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6626 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6628 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6627);
// compiled call node returning call6628 (depth = 5)
// compiled member node returning call6628 (depth = 4)
  params[0] = *var_blk;
  partcv[0] = 1;
  Object call6629 = callmethod(call6628, "do",
    1, partcv, params);
  gc_frame_end(callframe6626);
// compiled call node returning call6629 (depth = 3)
  gc_frame_end(frame);
  return call6629;
}
Object meth_ast_size6630(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6631 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6632 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6633 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6632);
// compiled call node returning call6633 (depth = 6)
// compiled member node returning call6633 (depth = 5)
  partcv[0] = 0;
  Object call6634 = callmethod(call6633, "size",
    1, partcv, params);
  gc_frame_end(callframe6631);
// compiled call node returning call6634 (depth = 4)
// compiled member node returning call6634 (depth = 3)
  gc_frame_end(frame);
  return call6634;
}
Object meth_ast_map_40__41_ancestors6635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6636 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6637 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6636);
// compiled call node returning call6637 (depth = 5)
// compiled member node returning call6637 (depth = 4)
  *var_n = call6637;
  if (call6637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6638 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6639 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6638);
// compiled call node returning call6639 (depth = 4)
  *var_newChain = call6639;
  if (call6639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6640 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6641 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6642 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6643 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6642);
// compiled call node returning call6643 (depth = 6)
// compiled member node returning call6643 (depth = 5)
  gc_frame_newslot(call6643);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6644 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6645 = gc_frame_new();
// call case 3: self.outer request
  Object call6646 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6645);
// compiled call node returning call6646 (depth = 8)
// compiled member node returning call6646 (depth = 7)
  partcv[0] = 0;
  Object call6647 = callmethodflags(call6646, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6644);
// compiled call node returning call6647 (depth = 6)
// compiled member node returning call6647 (depth = 5)
  params[0] = call6643;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6648 = callmethodflags(call6647, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6641);
// compiled call node returning call6648 (depth = 4)
  gc_frame_newslot(call6648);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6648;
  partcv[0] = 1;
  Object call6649 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe6640);
// compiled call node returning call6649 (depth = 3)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6650 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6651 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6650);
// compiled call node returning call6651 (depth = 3)
  gc_frame_end(frame);
  return call6651;
}
Object meth_ast__apply6660(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6662 == NULL) {
    strlit6662 = alloc_String("  ");
    gc_root(strlit6662);
  }
// compiled string node returning strlit6662 (depth = 7)
  int op_slot_right_6661 = gc_frame_newslot(strlit6662);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6661 = gc_frame_newslot(*var_spc);
  params[0] = strlit6662;
  partcv[0] = 1;
  Object opresult6664 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6664 (depth = 6)
  *var_spc = opresult6664;
  if (opresult6664 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6679(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6681 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6683 = alloc_Float64(2);
// compiled num node returning num6683 (depth = 9)
  int op_slot_right_6682 = gc_frame_newslot(num6683);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6682 = gc_frame_newslot(*var_depth);
  params[0] = num6683;
  partcv[0] = 1;
  Object sum6685 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6685 (depth = 8)
  gc_frame_newslot(sum6685);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6685;
  partcv[0] = 1;
  Object call6686 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6681);
// compiled call node returning call6686 (depth = 7)
  int op_slot_right_6680 = gc_frame_newslot(call6686);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6680 = gc_frame_newslot(*var_s);
  params[0] = call6686;
  partcv[0] = 1;
  Object opresult6688 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6688 (depth = 6)
  *var_s = opresult6688;
  if (opresult6688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6692(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6694 == NULL) {
    strlit6694 = alloc_String(", ");
    gc_root(strlit6694);
  }
// compiled string node returning strlit6694 (depth = 7)
  int op_slot_right_6693 = gc_frame_newslot(strlit6694);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6693 = gc_frame_newslot(*var_s);
  params[0] = strlit6694;
  partcv[0] = 1;
  Object opresult6696 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6696 (depth = 6)
  *var_s = opresult6696;
  if (opresult6696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6652(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6653 == NULL) {
    strlit6653 = alloc_String("");
    gc_root(strlit6653);
  }
// compiled string node returning strlit6653 (depth = 4)
  *var_spc = strlit6653;
  if (strlit6653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6654 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6655 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6657 = alloc_Float64(0);
// compiled num node returning num6657 (depth = 5)
  int op_slot_left_6655 = gc_frame_newslot(num6657);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6658 = callmethod(num6657, "..", 1, partcv, params);
// compiled op node returning opresult6658 (depth = 4)
  gc_frame_newslot(opresult6658);
// starting to compile block node (depth = 4)
  Object block6659 = alloc_Block(NULL, NULL, "ast", 1603);
  gc_frame_newslot(block6659);
// method "_apply"
  block_savedest(block6659);
  Object closure6660 = createclosure(2, "_apply");
  setclosureframe(closure6660, stackframe);
  addtoclosure(closure6660, var_spc);
  addtoclosure(closure6660, selfslot);
  struct UserObject *uo6660 = (struct UserObject*)block6659;
  uo6660->data[0] = (Object)closure6660;
  Method *meth_meth_ast__apply6660 = addmethod2pos(block6659, "_apply", &meth_ast__apply6660, 0);
  int argcv_meth_ast__apply6660[] = {1};
  meth_meth_ast__apply6660->type = alloc_MethodType(1, argcv_meth_ast__apply6660);
  meth_meth_ast__apply6660->definitionModule = modulename;
  meth_meth_ast__apply6660->definitionLine = 1598;
// compiled block node returning block6659 (depth = 4)
  gc_frame_newslot(block6659);
// call case 5: prelude request
  params[0] = opresult6658;
  params[1] = block6659;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6667 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6654);
// compiled call node returning call6667 (depth = 3)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6669 == NULL) {
    strlit6669 = alloc_String("<");
    gc_root(strlit6669);
  }
// compiled string node returning strlit6669 (depth = 5)
  int op_slot_right_6668 = gc_frame_newslot(strlit6669);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6672 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6673 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6672);
// compiled call node returning call6673 (depth = 6)
  int op_slot_right_6671 = gc_frame_newslot(call6673);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_6671 = gc_frame_newslot(*var_spc);
  params[0] = call6673;
  partcv[0] = 1;
  Object opresult6675 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6675 (depth = 5)
  int op_slot_left_6668 = gc_frame_newslot(opresult6675);
  params[0] = strlit6669;
  partcv[0] = 1;
  Object opresult6676 = callmethod(opresult6675, "++", 1, partcv, params);
// compiled op node returning opresult6676 (depth = 4)
  *var_s = opresult6676;
  if (opresult6676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6677 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6678 = alloc_Block(NULL, NULL, "ast", 1607);
  gc_frame_newslot(block6678);
// method "_apply"
  block_savedest(block6678);
  Object closure6679 = createclosure(3, "_apply");
  setclosureframe(closure6679, stackframe);
  addtoclosure(closure6679, var_depth);
  addtoclosure(closure6679, var_s);
  addtoclosure(closure6679, selfslot);
  struct UserObject *uo6679 = (struct UserObject*)block6678;
  uo6679->data[0] = (Object)closure6679;
  Method *meth_meth_ast__apply6679 = addmethod2pos(block6678, "_apply", &meth_ast__apply6679, 0);
  int argcv_meth_ast__apply6679[] = {1};
  meth_meth_ast__apply6679->type = alloc_MethodType(1, argcv_meth_ast__apply6679);
  meth_meth_ast__apply6679->definitionModule = modulename;
  meth_meth_ast__apply6679->definitionLine = 1598;
// compiled block node returning block6678 (depth = 4)
  gc_frame_newslot(block6678);
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6691 = alloc_Block(NULL, NULL, "ast", 1608);
  gc_frame_newslot(block6691);
// method "_apply"
  block_savedest(block6691);
  Object closure6692 = createclosure(2, "_apply");
  setclosureframe(closure6692, stackframe);
  addtoclosure(closure6692, var_s);
  addtoclosure(closure6692, selfslot);
  struct UserObject *uo6692 = (struct UserObject*)block6691;
  uo6692->data[0] = (Object)closure6692;
  Method *meth_meth_ast__apply6692 = addmethod2pos(block6691, "_apply", &meth_ast__apply6692, 0);
  int argcv_meth_ast__apply6692[] = {0};
  meth_meth_ast__apply6692->type = alloc_MethodType(1, argcv_meth_ast__apply6692);
  meth_meth_ast__apply6692->definitionModule = modulename;
  meth_meth_ast__apply6692->definitionLine = 1598;
// compiled block node returning block6691 (depth = 4)
  gc_frame_newslot(block6691);
// call case 6: other member request
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6700 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6699);
// compiled call node returning call6700 (depth = 5)
// compiled member node returning call6700 (depth = 4)
  params[0] = block6678;
  params[1] = block6691;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6701 = callmethod(call6700, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6677);
// compiled call node returning call6701 (depth = 3)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6703 == NULL) {
    strlit6703 = alloc_String(">");
    gc_root(strlit6703);
  }
// compiled string node returning strlit6703 (depth = 4)
  int op_slot_right_6702 = gc_frame_newslot(strlit6703);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6702 = gc_frame_newslot(*var_s);
  params[0] = strlit6703;
  partcv[0] = 1;
  Object opresult6705 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6705 (depth = 3)
  gc_frame_end(frame);
  return opresult6705;
}
Object meth_ast__apply6710(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6712 == NULL) {
    strlit6712 = alloc_String("");
    gc_root(strlit6712);
  }
// compiled string node returning strlit6712 (depth = 7)
  int op_slot_right_6711 = gc_frame_newslot(strlit6712);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6715 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6716 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6715);
// compiled call node returning call6716 (depth = 8)
  int op_slot_right_6714 = gc_frame_newslot(call6716);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6719 == NULL) {
    strlit6719 = alloc_String("");
    gc_root(strlit6719);
  }
// compiled string node returning strlit6719 (depth = 9)
  int op_slot_right_6718 = gc_frame_newslot(strlit6719);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_6721 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit6723 == NULL) {
    strlit6723 = alloc_String("");
    gc_root(strlit6723);
  }
// compiled string node returning strlit6723 (depth = 10)
  int op_slot_left_6721 = gc_frame_newslot(strlit6723);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6724 = callmethod(strlit6723, "++", 1, partcv, params);
// compiled op node returning opresult6724 (depth = 9)
  int op_slot_left_6718 = gc_frame_newslot(opresult6724);
  params[0] = strlit6719;
  partcv[0] = 1;
  Object opresult6725 = callmethod(opresult6724, "++", 1, partcv, params);
// compiled op node returning opresult6725 (depth = 8)
  int op_slot_left_6714 = gc_frame_newslot(opresult6725);
  params[0] = call6716;
  partcv[0] = 1;
  Object opresult6726 = callmethod(opresult6725, "++", 1, partcv, params);
// compiled op node returning opresult6726 (depth = 7)
  int op_slot_left_6711 = gc_frame_newslot(opresult6726);
  params[0] = strlit6712;
  partcv[0] = 1;
  Object opresult6727 = callmethod(opresult6726, "++", 1, partcv, params);
// compiled op node returning opresult6727 (depth = 6)
  *var_s = opresult6727;
  if (opresult6727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6731(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6733 == NULL) {
    strlit6733 = alloc_String(", ");
    gc_root(strlit6733);
  }
// compiled string node returning strlit6733 (depth = 7)
  int op_slot_right_6732 = gc_frame_newslot(strlit6733);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6732 = gc_frame_newslot(*var_s);
  params[0] = strlit6733;
  partcv[0] = 1;
  Object opresult6735 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6735 (depth = 6)
  *var_s = opresult6735;
  if (opresult6735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6707 == NULL) {
    strlit6707 = alloc_String("<");
    gc_root(strlit6707);
  }
// compiled string node returning strlit6707 (depth = 4)
  *var_s = strlit6707;
  if (strlit6707 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6708 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6709 = alloc_Block(NULL, NULL, "ast", 1613);
  gc_frame_newslot(block6709);
// method "_apply"
  block_savedest(block6709);
  Object closure6710 = createclosure(3, "_apply");
  setclosureframe(closure6710, stackframe);
  addtoclosure(closure6710, var_depth);
  addtoclosure(closure6710, var_s);
  addtoclosure(closure6710, selfslot);
  struct UserObject *uo6710 = (struct UserObject*)block6709;
  uo6710->data[0] = (Object)closure6710;
  Method *meth_meth_ast__apply6710 = addmethod2pos(block6709, "_apply", &meth_ast__apply6710, 0);
  int argcv_meth_ast__apply6710[] = {1};
  meth_meth_ast__apply6710->type = alloc_MethodType(1, argcv_meth_ast__apply6710);
  meth_meth_ast__apply6710->definitionModule = modulename;
  meth_meth_ast__apply6710->definitionLine = 1607;
// compiled block node returning block6709 (depth = 4)
  gc_frame_newslot(block6709);
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6730 = alloc_Block(NULL, NULL, "ast", 1614);
  gc_frame_newslot(block6730);
// method "_apply"
  block_savedest(block6730);
  Object closure6731 = createclosure(2, "_apply");
  setclosureframe(closure6731, stackframe);
  addtoclosure(closure6731, var_s);
  addtoclosure(closure6731, selfslot);
  struct UserObject *uo6731 = (struct UserObject*)block6730;
  uo6731->data[0] = (Object)closure6731;
  Method *meth_meth_ast__apply6731 = addmethod2pos(block6730, "_apply", &meth_ast__apply6731, 0);
  int argcv_meth_ast__apply6731[] = {0};
  meth_meth_ast__apply6731->type = alloc_MethodType(1, argcv_meth_ast__apply6731);
  meth_meth_ast__apply6731->definitionModule = modulename;
  meth_meth_ast__apply6731->definitionLine = 1607;
// compiled block node returning block6730 (depth = 4)
  gc_frame_newslot(block6730);
// call case 6: other member request
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6739 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6738);
// compiled call node returning call6739 (depth = 5)
// compiled member node returning call6739 (depth = 4)
  params[0] = block6709;
  params[1] = block6730;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6740 = callmethod(call6739, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6708);
// compiled call node returning call6740 (depth = 3)
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6742 == NULL) {
    strlit6742 = alloc_String(">");
    gc_root(strlit6742);
  }
// compiled string node returning strlit6742 (depth = 4)
  int op_slot_right_6741 = gc_frame_newslot(strlit6742);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6741 = gc_frame_newslot(*var_s);
  params[0] = strlit6742;
  partcv[0] = 1;
  Object opresult6744 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6744 (depth = 3)
  gc_frame_end(frame);
  return opresult6744;
}
Object meth_ast_shallowCopy6745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6746 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6747 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeParametersNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6748 = callmethod(*var_typeParametersNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6747);
// compiled call node returning call6748 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6749 = callmethod(call6748, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6746);
// compiled call node returning call6749 (depth = 3)
  gc_frame_end(frame);
  return call6749;
}
Object meth_ast_new6598(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6599 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6599 = alloc_userobj2(12,12, objclass6599);
  gc_frame_newslot(obj6599);
if (objclass6599 == NULL) {
  glfree(obj6599->class->name);
  obj6599->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6599, self, 0);
  addmethodreal(obj6599,"outer", &reader_ast_outer_6600);
  Object oldself6599 = self;
  struct StackFrameObject *oldstackframe6599 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6599);
  gc_frame_newslot((Object)stackframe);
  self = obj6599;
  Object *oldselfslot6599 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6599 = (*(struct UserObject *)self).data[0], lowerouter6599 = thisouter6599;
  if (inheritingObject6599) {
    struct UserObject *inho6599 = (struct UserObject *)inheritingObject6599;
    while (inho6599->super != GraceDefaultObject) inho6599 = (struct UserObject *)inho6599->super;
    inho6599->super = obj6599;
    self = inheritingObject6599;
    *selfslot = self;
    lowerouter6599 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6599;
  }
if (objclass6599 == NULL) {
  Method *reader6601 = addmethodrealflags(obj6599, "kind",&reader_ast_kind_6601, MFLAG_DEF);
  reader6601->definitionModule = modulename;
  reader6601->definitionLine = 1578;
}
adddatum2(obj6599, alloc_Undefined(), 1);
if (objclass6599 == NULL) {
  Method *reader6602 = addmethodrealflags(obj6599, "params",&reader_ast_params_6602, 0);
  Method *writer6602 = addmethodrealflags(obj6599, "params:=",&writer_ast_params_6602, 0);
  reader6602->definitionModule = modulename;
  writer6602->definitionModule = modulename;
  reader6602->definitionLine = 1579;
  writer6602->definitionLine = 1579;
}
obj6599->flags |= OFLAG_MUTABLE;
adddatum2(obj6599, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6603 = (struct UserObject*)obj6599;
  uo6603->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6603 = addmethod2pos(obj6599, "asString", &meth_ast_asString6603, 3);
  int argcv_meth_ast_asString6603[] = {0};
  meth_meth_ast_asString6603->type = alloc_MethodType(1, argcv_meth_ast_asString6603);
  meth_meth_ast_asString6603->definitionModule = modulename;
  meth_meth_ast_asString6603->definitionLine = 1580;
// method "declarationKindWithAncestors"
  block_savedest(obj6599);
  Object closure6607 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure6607, stackframe);
  addtoclosure(closure6607, var_k);
  struct UserObject *uo6607 = (struct UserObject*)obj6599;
  uo6607->data[4] = (Object)closure6607;
  Method *meth_meth_ast_declarationKindWithAncestors6607 = addmethod2pos(obj6599, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6607, 4);
  int argcv_meth_ast_declarationKindWithAncestors6607[] = {1};
  meth_meth_ast_declarationKindWithAncestors6607->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6607);
  meth_meth_ast_declarationKindWithAncestors6607->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6607->definitionLine = 1581;
// method "accept()from"
  struct UserObject *uo6610 = (struct UserObject*)obj6599;
  uo6610->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6610 = addmethod2pos(obj6599, "accept()from", &meth_ast_accept_40__41_from6610, 5);
  int argcv_meth_ast_accept_40__41_from6610[] = {1, 1};
  meth_meth_ast_accept_40__41_from6610->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6610);
  meth_meth_ast_accept_40__41_from6610->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6610->definitionLine = 1583;
// method "do"
  struct UserObject *uo6625 = (struct UserObject*)obj6599;
  uo6625->data[6] = emptyclosure;
  Method *meth_meth_ast_do6625 = addmethod2pos(obj6599, "do", &meth_ast_do6625, 6);
  int argcv_meth_ast_do6625[] = {1};
  meth_meth_ast_do6625->type = alloc_MethodType(1, argcv_meth_ast_do6625);
  meth_meth_ast_do6625->definitionModule = modulename;
  meth_meth_ast_do6625->definitionLine = 1591;
// method "size"
  struct UserObject *uo6630 = (struct UserObject*)obj6599;
  uo6630->data[7] = emptyclosure;
  Method *meth_meth_ast_size6630 = addmethod2pos(obj6599, "size", &meth_ast_size6630, 7);
  int argcv_meth_ast_size6630[] = {0};
  meth_meth_ast_size6630->type = alloc_MethodType(1, argcv_meth_ast_size6630);
  meth_meth_ast_size6630->definitionModule = modulename;
  meth_meth_ast_size6630->definitionLine = 1594;
// method "map()ancestors"
  struct UserObject *uo6635 = (struct UserObject*)obj6599;
  uo6635->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6635 = addmethod2pos(obj6599, "map()ancestors", &meth_ast_map_40__41_ancestors6635, 8);
  int argcv_meth_ast_map_40__41_ancestors6635[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6635->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6635);
  meth_meth_ast_map_40__41_ancestors6635->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6635->definitionLine = 1595;
// method "pretty"
  struct UserObject *uo6652 = (struct UserObject*)obj6599;
  uo6652->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty6652 = addmethod2pos(obj6599, "pretty", &meth_ast_pretty6652, 9);
  int argcv_meth_ast_pretty6652[] = {1};
  meth_meth_ast_pretty6652->type = alloc_MethodType(1, argcv_meth_ast_pretty6652);
  meth_meth_ast_pretty6652->definitionModule = modulename;
  meth_meth_ast_pretty6652->definitionLine = 1601;
// method "toGrace"
  struct UserObject *uo6706 = (struct UserObject*)obj6599;
  uo6706->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace6706 = addmethod2pos(obj6599, "toGrace", &meth_ast_toGrace6706, 10);
  int argcv_meth_ast_toGrace6706[] = {1};
  meth_meth_ast_toGrace6706->type = alloc_MethodType(1, argcv_meth_ast_toGrace6706);
meth_meth_ast_toGrace6706->type->types[0] = type_Number;
meth_meth_ast_toGrace6706->type->names[0] = "depth";
  meth_meth_ast_toGrace6706->definitionModule = modulename;
  meth_meth_ast_toGrace6706->definitionLine = 1611;
// method "shallowCopy"
  block_savedest(obj6599);
  Object closure6745 = createclosure(2, "shallowCopy");
  setclosureframe(closure6745, stackframe);
  addtoclosure(closure6745, var_emptySeq);
  addtoclosure(closure6745, var_typeParametersNode);
  struct UserObject *uo6745 = (struct UserObject*)obj6599;
  uo6745->data[11] = (Object)closure6745;
  Method *meth_meth_ast_shallowCopy6745 = addmethod2pos(obj6599, "shallowCopy", &meth_ast_shallowCopy6745, 11);
  int argcv_meth_ast_shallowCopy6745[] = {0};
  meth_meth_ast_shallowCopy6745->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6745);
  meth_meth_ast_shallowCopy6745->definitionModule = modulename;
  meth_meth_ast_shallowCopy6745->definitionLine = 1617;
  sourceObject = obj6599;
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6751 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6752 = gc_frame_new();
// call case 3: self.outer request
  Object call6753 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6752);
// compiled call node returning call6753 (depth = 7)
// compiled member node returning call6753 (depth = 6)
  partcv[0] = 0;
  Object call6754 = callmethodflags(call6753, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6751);
// compiled call node returning call6754 (depth = 5)
// compiled member node returning call6754 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6755 = callmethodflags(call6754, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6750);
// compiled call node returning call6755 (depth = 3)
  struct UserObject *obj6599_uo = (struct UserObject *)obj6599;
  obj6599_uo->super = call6755;
  sourceObject = obj6599;
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6756 == NULL) {
    strlit6756 = alloc_String("typeparams");
    gc_root(strlit6756);
  }
// compiled string node returning strlit6756 (depth = 3)
  adddatum2(obj6599, strlit6756, 1);
  sourceObject = obj6599;
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6599, *var_params_39_, 2);
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  objclass6599 = obj6599->class;
  objclass6599->definitionModule = modulename;
  objclass6599->definitionLine = 1576;
  (*(struct UserObject *)self).data[0] = lowerouter6599;
  self = oldself6599;
  selfslot = oldselfslot6599;
  stackframe = oldstackframe6599;
  gc_frame_end(frame);
  return obj6599;
}
Object meth_ast_new6598_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6599 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6599 = alloc_userobj2(12,12, objclass6599);
  gc_frame_newslot(obj6599);
if (objclass6599 == NULL) {
  glfree(obj6599->class->name);
  obj6599->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6599, self, 0);
  addmethodreal(obj6599,"outer", &reader_ast_outer_6600);
  Object oldself6599 = self;
  struct StackFrameObject *oldstackframe6599 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6599);
  gc_frame_newslot((Object)stackframe);
  self = obj6599;
  Object *oldselfslot6599 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6599 = (*(struct UserObject *)self).data[0], lowerouter6599 = thisouter6599;
  if (inheritingObject6599) {
    struct UserObject *inho6599 = (struct UserObject *)inheritingObject6599;
    while (inho6599->super != GraceDefaultObject) inho6599 = (struct UserObject *)inho6599->super;
    inho6599->super = obj6599;
    self = inheritingObject6599;
    *selfslot = self;
    lowerouter6599 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6599;
  }
if (objclass6599 == NULL) {
  Method *reader6601 = addmethodrealflags(obj6599, "kind",&reader_ast_kind_6601, MFLAG_DEF);
  reader6601->definitionModule = modulename;
  reader6601->definitionLine = 1578;
}
adddatum2(obj6599, alloc_Undefined(), 1);
if (objclass6599 == NULL) {
  Method *reader6602 = addmethodrealflags(obj6599, "params",&reader_ast_params_6602, 0);
  Method *writer6602 = addmethodrealflags(obj6599, "params:=",&writer_ast_params_6602, 0);
  reader6602->definitionModule = modulename;
  writer6602->definitionModule = modulename;
  reader6602->definitionLine = 1579;
  writer6602->definitionLine = 1579;
}
obj6599->flags |= OFLAG_MUTABLE;
adddatum2(obj6599, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6603 = (struct UserObject*)obj6599;
  uo6603->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6603 = addmethod2pos(obj6599, "asString", &meth_ast_asString6603, 3);
  int argcv_meth_ast_asString6603[] = {0};
  meth_meth_ast_asString6603->type = alloc_MethodType(1, argcv_meth_ast_asString6603);
  meth_meth_ast_asString6603->definitionModule = modulename;
  meth_meth_ast_asString6603->definitionLine = 1580;
// method "declarationKindWithAncestors"
  block_savedest(obj6599);
  Object closure6607 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure6607, stackframe);
  addtoclosure(closure6607, var_k);
  struct UserObject *uo6607 = (struct UserObject*)obj6599;
  uo6607->data[4] = (Object)closure6607;
  Method *meth_meth_ast_declarationKindWithAncestors6607 = addmethod2pos(obj6599, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6607, 4);
  int argcv_meth_ast_declarationKindWithAncestors6607[] = {1};
  meth_meth_ast_declarationKindWithAncestors6607->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6607);
  meth_meth_ast_declarationKindWithAncestors6607->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6607->definitionLine = 1581;
// method "accept()from"
  struct UserObject *uo6610 = (struct UserObject*)obj6599;
  uo6610->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6610 = addmethod2pos(obj6599, "accept()from", &meth_ast_accept_40__41_from6610, 5);
  int argcv_meth_ast_accept_40__41_from6610[] = {1, 1};
  meth_meth_ast_accept_40__41_from6610->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6610);
  meth_meth_ast_accept_40__41_from6610->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6610->definitionLine = 1583;
// method "do"
  struct UserObject *uo6625 = (struct UserObject*)obj6599;
  uo6625->data[6] = emptyclosure;
  Method *meth_meth_ast_do6625 = addmethod2pos(obj6599, "do", &meth_ast_do6625, 6);
  int argcv_meth_ast_do6625[] = {1};
  meth_meth_ast_do6625->type = alloc_MethodType(1, argcv_meth_ast_do6625);
  meth_meth_ast_do6625->definitionModule = modulename;
  meth_meth_ast_do6625->definitionLine = 1591;
// method "size"
  struct UserObject *uo6630 = (struct UserObject*)obj6599;
  uo6630->data[7] = emptyclosure;
  Method *meth_meth_ast_size6630 = addmethod2pos(obj6599, "size", &meth_ast_size6630, 7);
  int argcv_meth_ast_size6630[] = {0};
  meth_meth_ast_size6630->type = alloc_MethodType(1, argcv_meth_ast_size6630);
  meth_meth_ast_size6630->definitionModule = modulename;
  meth_meth_ast_size6630->definitionLine = 1594;
// method "map()ancestors"
  struct UserObject *uo6635 = (struct UserObject*)obj6599;
  uo6635->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6635 = addmethod2pos(obj6599, "map()ancestors", &meth_ast_map_40__41_ancestors6635, 8);
  int argcv_meth_ast_map_40__41_ancestors6635[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6635->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6635);
  meth_meth_ast_map_40__41_ancestors6635->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6635->definitionLine = 1595;
// method "pretty"
  struct UserObject *uo6652 = (struct UserObject*)obj6599;
  uo6652->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty6652 = addmethod2pos(obj6599, "pretty", &meth_ast_pretty6652, 9);
  int argcv_meth_ast_pretty6652[] = {1};
  meth_meth_ast_pretty6652->type = alloc_MethodType(1, argcv_meth_ast_pretty6652);
  meth_meth_ast_pretty6652->definitionModule = modulename;
  meth_meth_ast_pretty6652->definitionLine = 1601;
// method "toGrace"
  struct UserObject *uo6706 = (struct UserObject*)obj6599;
  uo6706->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace6706 = addmethod2pos(obj6599, "toGrace", &meth_ast_toGrace6706, 10);
  int argcv_meth_ast_toGrace6706[] = {1};
  meth_meth_ast_toGrace6706->type = alloc_MethodType(1, argcv_meth_ast_toGrace6706);
meth_meth_ast_toGrace6706->type->types[0] = type_Number;
meth_meth_ast_toGrace6706->type->names[0] = "depth";
  meth_meth_ast_toGrace6706->definitionModule = modulename;
  meth_meth_ast_toGrace6706->definitionLine = 1611;
// method "shallowCopy"
  block_savedest(obj6599);
  Object closure6745 = createclosure(2, "shallowCopy");
  setclosureframe(closure6745, stackframe);
  addtoclosure(closure6745, var_emptySeq);
  addtoclosure(closure6745, var_typeParametersNode);
  struct UserObject *uo6745 = (struct UserObject*)obj6599;
  uo6745->data[11] = (Object)closure6745;
  Method *meth_meth_ast_shallowCopy6745 = addmethod2pos(obj6599, "shallowCopy", &meth_ast_shallowCopy6745, 11);
  int argcv_meth_ast_shallowCopy6745[] = {0};
  meth_meth_ast_shallowCopy6745->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6745);
  meth_meth_ast_shallowCopy6745->definitionModule = modulename;
  meth_meth_ast_shallowCopy6745->definitionLine = 1617;
  sourceObject = obj6599;
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6751 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6752 = gc_frame_new();
// call case 3: self.outer request
  Object call6753 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6752);
// compiled call node returning call6753 (depth = 7)
// compiled member node returning call6753 (depth = 6)
  partcv[0] = 0;
  Object call6754 = callmethodflags(call6753, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6751);
// compiled call node returning call6754 (depth = 5)
// compiled member node returning call6754 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6755 = callmethodflags(call6754, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6750);
// compiled call node returning call6755 (depth = 3)
  struct UserObject *obj6599_uo = (struct UserObject *)obj6599;
  obj6599_uo->super = call6755;
  sourceObject = obj6599;
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6756 == NULL) {
    strlit6756 = alloc_String("typeparams");
    gc_root(strlit6756);
  }
// compiled string node returning strlit6756 (depth = 3)
  adddatum2(obj6599, strlit6756, 1);
  sourceObject = obj6599;
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6599, *var_params_39_, 2);
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  sourceObject = obj6599;
  objclass6599 = obj6599->class;
  objclass6599->definitionModule = modulename;
  objclass6599->definitionLine = 1576;
  (*(struct UserObject *)self).data[0] = lowerouter6599;
  self = oldself6599;
  selfslot = oldselfslot6599;
  stackframe = oldstackframe6599;
  gc_frame_end(frame);
  return obj6599;
}
Object meth_ast_typeParametersNode6758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeParametersNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeParametersNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeParametersNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeParametersNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeParametersNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeParametersNode;
}
Object meth_ast_new_40__41_scope6761(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[1]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6762 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call6763 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6762);
// compiled call node returning call6763 (depth = 4)
  *var_result = call6763;
  if (call6763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6764 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6765 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe6764);
// compiled call node returning call6765 (depth = 3)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString6778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6780 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6779);
// compiled call node returning call6780 (depth = 4)
// compiled member node returning call6780 (depth = 3)
  gc_frame_end(frame);
  return call6780;
}
Object meth_ast_quoted6781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "quoted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for quoted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for quoted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6782 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6783 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6784 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6783);
// compiled call node returning call6784 (depth = 6)
// compiled member node returning call6784 (depth = 5)
  partcv[0] = 0;
  Object call6785 = callmethod(call6784, "quoted",
    1, partcv, params);
  gc_frame_end(callframe6782);
// compiled call node returning call6785 (depth = 4)
// compiled member node returning call6785 (depth = 3)
  gc_frame_end(frame);
  return call6785;
}
Object meth_ast_isIdentifier6786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6787 = alloc_Boolean(1);
// compiled identifier node returning bool6787 (depth = 3)
  gc_frame_end(frame);
  return bool6787;
}
Object meth_ast_isAppliedOccurenceOfIdentifier6788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6790 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6791 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6790);
// compiled call node returning call6791 (depth = 5)
// compiled member node returning call6791 (depth = 4)
  Object if6789 = done;
  if (istrue(call6791)) {
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6792 = alloc_Boolean(0);
// compiled identifier node returning bool6792 (depth = 4)
    gc_frame_newslot(bool6792);
    if6789 = bool6792;
  } else {
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6793 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6795 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6794);
// compiled call node returning call6795 (depth = 7)
// compiled member node returning call6795 (depth = 6)
  partcv[0] = 0;
  Object call6796 = callmethod(call6795, "not",
    1, partcv, params);
  gc_frame_end(callframe6793);
// compiled call node returning call6796 (depth = 5)
// compiled member node returning call6796 (depth = 4)
    gc_frame_newslot(call6796);
    if6789 = call6796;
  }
// compiled if node returning if6789 (depth = 3)
  gc_frame_end(frame);
  return if6789;
}
Object meth_ast_declarationKindWithAncestors6797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6798 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6799 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call6800 = callmethod(*var_as, "parent",
    1, partcv, params);
  gc_frame_end(callframe6799);
// compiled call node returning call6800 (depth = 5)
// compiled member node returning call6800 (depth = 4)
  params[0] = *var_as;
  partcv[0] = 1;
  Object call6801 = callmethod(call6800, "declarationKindWithAncestors",
    1, partcv, params);
  gc_frame_end(callframe6798);
// compiled call node returning call6801 (depth = 3)
  gc_frame_end(frame);
  return call6801;
}
Object meth_ast_inTypePositionWithAncestors6802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePositionWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inTypePositionWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTypePositionWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for inTypePositionWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call6805 = callmethod(*var_as, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe6804);
// compiled call node returning call6805 (depth = 5)
// compiled member node returning call6805 (depth = 4)
  Object if6803 = done;
  if (istrue(call6805)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6806 = alloc_Boolean(0);
// compiled identifier node returning bool6806 (depth = 5)
  return bool6806;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6803 = undefined;
  } else {
  }
// compiled if node returning if6803 (depth = 3)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6807 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call6809 = callmethod(*var_as, "parent",
    1, partcv, params);
  gc_frame_end(callframe6808);
// compiled call node returning call6809 (depth = 5)
// compiled member node returning call6809 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6810 = callmethod(call6809, "usesAsType",
    1, partcv, params);
  gc_frame_end(callframe6807);
// compiled call node returning call6810 (depth = 3)
  gc_frame_end(frame);
  return call6810;
}
Object meth_ast_usesAsType6811(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6814 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6813);
// compiled call node returning call6814 (depth = 5)
// compiled member node returning call6814 (depth = 4)
  int op_slot_right_6812 = gc_frame_newslot(call6814);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_6812 = gc_frame_newslot(*var_aNode);
  params[0] = call6814;
  partcv[0] = 1;
  Object opresult6816 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult6816 (depth = 3)
  gc_frame_end(frame);
  return opresult6816;
}
Object meth_ast_accept_40__41_from6817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6819 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6820 = callmethod(*var_visitor, "visitIdentifier()up",
    2, partcv, params);
  gc_frame_end(callframe6819);
// compiled call node returning call6820 (depth = 4)
  Object if6818 = done;
  if (istrue(call6820)) {
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6821 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6822 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6821);
// compiled call node returning call6822 (depth = 5)
  *var_newChain = call6822;
  if (call6822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6825 = alloc_Boolean(0);
// compiled identifier node returning bool6825 (depth = 6)
  int op_slot_right_6824 = gc_frame_newslot(bool6825);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6828 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6827);
// compiled call node returning call6828 (depth = 7)
// compiled member node returning call6828 (depth = 6)
  int op_slot_left_6824 = gc_frame_newslot(call6828);
  params[0] = bool6825;
  partcv[0] = 1;
  Object opresult6829 = callmethod(call6828, "!=", 1, partcv, params);
// compiled op node returning opresult6829 (depth = 5)
  Object if6823 = done;
  if (istrue(opresult6829)) {
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6830 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6831 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6832 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6831);
// compiled call node returning call6832 (depth = 7)
// compiled member node returning call6832 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6833 = callmethod(call6832, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6830);
// compiled call node returning call6833 (depth = 5)
    gc_frame_newslot(call6833);
    if6823 = call6833;
  } else {
  }
// compiled if node returning if6823 (depth = 4)
    gc_frame_newslot(if6823);
    if6818 = if6823;
  } else {
  }
// compiled if node returning if6818 (depth = 3)
  gc_frame_end(frame);
  return if6818;
}
Object meth_ast_map_40__41_ancestors6834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6836 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6835);
// compiled call node returning call6836 (depth = 5)
// compiled member node returning call6836 (depth = 4)
  *var_n = call6836;
  if (call6836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6837 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6838 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6837);
// compiled call node returning call6838 (depth = 4)
  *var_newChain = call6838;
  if (call6838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6839 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6840 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6842 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6841);
// compiled call node returning call6842 (depth = 6)
// compiled member node returning call6842 (depth = 5)
  gc_frame_newslot(call6842);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6843 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6844 = gc_frame_new();
// call case 3: self.outer request
  Object call6845 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6844);
// compiled call node returning call6845 (depth = 8)
// compiled member node returning call6845 (depth = 7)
  partcv[0] = 0;
  Object call6846 = callmethodflags(call6845, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6843);
// compiled call node returning call6846 (depth = 6)
// compiled member node returning call6846 (depth = 5)
  params[0] = call6842;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6847 = callmethodflags(call6846, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6840);
// compiled call node returning call6847 (depth = 4)
  gc_frame_newslot(call6847);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6847;
  partcv[0] = 1;
  Object call6848 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6839);
// compiled call node returning call6848 (depth = 3)
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6849 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6850 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6849);
// compiled call node returning call6850 (depth = 3)
  gc_frame_end(frame);
  return call6850;
}
Object meth_ast__apply6859(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6861 == NULL) {
    strlit6861 = alloc_String("  ");
    gc_root(strlit6861);
  }
// compiled string node returning strlit6861 (depth = 7)
  int op_slot_right_6860 = gc_frame_newslot(strlit6861);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6860 = gc_frame_newslot(*var_spc);
  params[0] = strlit6861;
  partcv[0] = 1;
  Object opresult6863 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6863 (depth = 6)
  *var_spc = opresult6863;
  if (opresult6863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6962(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6964 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6966 = alloc_Float64(2);
// compiled num node returning num6966 (depth = 10)
  int op_slot_right_6965 = gc_frame_newslot(num6966);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6965 = gc_frame_newslot(*var_depth);
  params[0] = num6966;
  partcv[0] = 1;
  Object sum6968 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6968 (depth = 9)
  gc_frame_newslot(sum6968);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = sum6968;
  partcv[0] = 1;
  Object call6969 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6964);
// compiled call node returning call6969 (depth = 8)
  int op_slot_right_6963 = gc_frame_newslot(call6969);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6972 == NULL) {
    strlit6972 = alloc_String("  ");
    gc_root(strlit6972);
  }
// compiled string node returning strlit6972 (depth = 9)
  int op_slot_right_6971 = gc_frame_newslot(strlit6972);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6974 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6977 == NULL) {
    strlit6977 = alloc_String("""\x0a""");
    gc_root(strlit6977);
  }
// compiled string node returning strlit6977 (depth = 11)
  int op_slot_right_6976 = gc_frame_newslot(strlit6977);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6976 = gc_frame_newslot(*var_s);
  params[0] = strlit6977;
  partcv[0] = 1;
  Object opresult6979 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6979 (depth = 10)
  int op_slot_left_6974 = gc_frame_newslot(opresult6979);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6980 = callmethod(opresult6979, "++", 1, partcv, params);
// compiled op node returning opresult6980 (depth = 9)
  int op_slot_left_6971 = gc_frame_newslot(opresult6980);
  params[0] = strlit6972;
  partcv[0] = 1;
  Object opresult6981 = callmethod(opresult6980, "++", 1, partcv, params);
// compiled op node returning opresult6981 (depth = 8)
  int op_slot_left_6963 = gc_frame_newslot(opresult6981);
  params[0] = call6969;
  partcv[0] = 1;
  Object opresult6982 = callmethod(opresult6981, "++", 1, partcv, params);
// compiled op node returning opresult6982 (depth = 7)
  *var_s = opresult6982;
  if (opresult6982 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6852 == NULL) {
    strlit6852 = alloc_String("");
    gc_root(strlit6852);
  }
// compiled string node returning strlit6852 (depth = 4)
  *var_spc = strlit6852;
  if (strlit6852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6853 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6854 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6856 = alloc_Float64(0);
// compiled num node returning num6856 (depth = 5)
  int op_slot_left_6854 = gc_frame_newslot(num6856);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6857 = callmethod(num6856, "..", 1, partcv, params);
// compiled op node returning opresult6857 (depth = 4)
  gc_frame_newslot(opresult6857);
// starting to compile block node (depth = 4)
  Object block6858 = alloc_Block(NULL, NULL, "ast", 1682);
  gc_frame_newslot(block6858);
// method "_apply"
  block_savedest(block6858);
  Object closure6859 = createclosure(2, "_apply");
  setclosureframe(closure6859, stackframe);
  addtoclosure(closure6859, var_spc);
  addtoclosure(closure6859, selfslot);
  struct UserObject *uo6859 = (struct UserObject*)block6858;
  uo6859->data[0] = (Object)closure6859;
  Method *meth_meth_ast__apply6859 = addmethod2pos(block6858, "_apply", &meth_ast__apply6859, 0);
  int argcv_meth_ast__apply6859[] = {1};
  meth_meth_ast__apply6859->type = alloc_MethodType(1, argcv_meth_ast__apply6859);
  meth_meth_ast__apply6859->definitionModule = modulename;
  meth_meth_ast__apply6859->definitionLine = 1677;
// compiled block node returning block6858 (depth = 4)
  gc_frame_newslot(block6858);
// call case 5: prelude request
  params[0] = opresult6857;
  params[1] = block6858;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6866 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6853);
// compiled call node returning call6866 (depth = 3)
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6867 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6868 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6867);
// compiled call node returning call6868 (depth = 4)
  *var_s = call6868;
  if (call6868 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6871 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6870);
// compiled call node returning call6871 (depth = 5)
// compiled member node returning call6871 (depth = 4)
  Object if6869 = done;
  if (istrue(call6871)) {
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6873 == NULL) {
    strlit6873 = alloc_String(" Wildcard");
    gc_root(strlit6873);
  }
// compiled string node returning strlit6873 (depth = 6)
  int op_slot_right_6872 = gc_frame_newslot(strlit6873);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6872 = gc_frame_newslot(*var_s);
  params[0] = strlit6873;
  partcv[0] = 1;
  Object opresult6875 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6875 (depth = 5)
  *var_s = opresult6875;
  if (opresult6875 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6869 = done;
  } else {
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6879 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6878);
// compiled call node returning call6879 (depth = 6)
// compiled member node returning call6879 (depth = 5)
  Object if6877 = done;
  if (istrue(call6879)) {
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6882 == NULL) {
    strlit6882 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6882);
  }
// compiled string node returning strlit6882 (depth = 8)
  int op_slot_right_6881 = gc_frame_newslot(strlit6882);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6885 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6886 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6885);
// compiled call node returning call6886 (depth = 10)
// compiled member node returning call6886 (depth = 9)
  int op_slot_right_6884 = gc_frame_newslot(call6886);
// starting to compile string node (depth = 9)
  if (strlit6888 == NULL) {
    strlit6888 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit6888);
  }
// compiled string node returning strlit6888 (depth = 9)
  int op_slot_left_6884 = gc_frame_newslot(strlit6888);
  params[0] = call6886;
  partcv[0] = 1;
  Object opresult6889 = callmethod(strlit6888, "++", 1, partcv, params);
// compiled op node returning opresult6889 (depth = 8)
  int op_slot_left_6881 = gc_frame_newslot(opresult6889);
  params[0] = strlit6882;
  partcv[0] = 1;
  Object opresult6890 = callmethod(opresult6889, "++", 1, partcv, params);
// compiled op node returning opresult6890 (depth = 7)
  int op_slot_right_6880 = gc_frame_newslot(opresult6890);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6880 = gc_frame_newslot(*var_s);
  params[0] = opresult6890;
  partcv[0] = 1;
  Object opresult6892 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6892 (depth = 6)
  *var_s = opresult6892;
  if (opresult6892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6877 = done;
  } else {
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6896 == NULL) {
    strlit6896 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6896);
  }
// compiled string node returning strlit6896 (depth = 8)
  int op_slot_right_6895 = gc_frame_newslot(strlit6896);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6899 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6900 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6899);
// compiled call node returning call6900 (depth = 10)
// compiled member node returning call6900 (depth = 9)
  int op_slot_right_6898 = gc_frame_newslot(call6900);
// starting to compile string node (depth = 9)
  if (strlit6902 == NULL) {
    strlit6902 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6902);
  }
// compiled string node returning strlit6902 (depth = 9)
  int op_slot_left_6898 = gc_frame_newslot(strlit6902);
  params[0] = call6900;
  partcv[0] = 1;
  Object opresult6903 = callmethod(strlit6902, "++", 1, partcv, params);
// compiled op node returning opresult6903 (depth = 8)
  int op_slot_left_6895 = gc_frame_newslot(opresult6903);
  params[0] = strlit6896;
  partcv[0] = 1;
  Object opresult6904 = callmethod(opresult6903, "++", 1, partcv, params);
// compiled op node returning opresult6904 (depth = 7)
  int op_slot_right_6894 = gc_frame_newslot(opresult6904);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6894 = gc_frame_newslot(*var_s);
  params[0] = opresult6904;
  partcv[0] = 1;
  Object opresult6906 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6906 (depth = 6)
  *var_s = opresult6906;
  if (opresult6906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6877 = done;
  }
// compiled if node returning if6877 (depth = 4)
    gc_frame_newslot(if6877);
    if6869 = if6877;
  }
// compiled if node returning if6869 (depth = 3)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6910 = alloc_Boolean(0);
// compiled identifier node returning bool6910 (depth = 5)
  int op_slot_right_6909 = gc_frame_newslot(bool6910);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6913 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6912);
// compiled call node returning call6913 (depth = 6)
// compiled member node returning call6913 (depth = 5)
  int op_slot_left_6909 = gc_frame_newslot(call6913);
  params[0] = bool6910;
  partcv[0] = 1;
  Object opresult6914 = callmethod(call6913, "!=", 1, partcv, params);
// compiled op node returning opresult6914 (depth = 4)
  Object if6908 = done;
  if (istrue(opresult6914)) {
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6916 == NULL) {
    strlit6916 = alloc_String("  Type: ");
    gc_root(strlit6916);
  }
// compiled string node returning strlit6916 (depth = 6)
  int op_slot_right_6915 = gc_frame_newslot(strlit6916);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6918 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6921 == NULL) {
    strlit6921 = alloc_String("""\x0a""");
    gc_root(strlit6921);
  }
// compiled string node returning strlit6921 (depth = 8)
  int op_slot_right_6920 = gc_frame_newslot(strlit6921);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6920 = gc_frame_newslot(*var_s);
  params[0] = strlit6921;
  partcv[0] = 1;
  Object opresult6923 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6923 (depth = 7)
  int op_slot_left_6918 = gc_frame_newslot(opresult6923);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6924 = callmethod(opresult6923, "++", 1, partcv, params);
// compiled op node returning opresult6924 (depth = 6)
  int op_slot_left_6915 = gc_frame_newslot(opresult6924);
  params[0] = strlit6916;
  partcv[0] = 1;
  Object opresult6925 = callmethod(opresult6924, "++", 1, partcv, params);
// compiled op node returning opresult6925 (depth = 5)
  *var_s = opresult6925;
  if (opresult6925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6928 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6930 = alloc_Float64(2);
// compiled num node returning num6930 (depth = 8)
  int op_slot_right_6929 = gc_frame_newslot(num6930);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_6929 = gc_frame_newslot(*var_depth);
  params[0] = num6930;
  partcv[0] = 1;
  Object sum6932 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6932 (depth = 7)
  gc_frame_newslot(sum6932);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6933 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6934 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6933);
// compiled call node returning call6934 (depth = 8)
// compiled member node returning call6934 (depth = 7)
  params[0] = sum6932;
  partcv[0] = 1;
  Object call6935 = callmethod(call6934, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6928);
// compiled call node returning call6935 (depth = 6)
  int op_slot_right_6927 = gc_frame_newslot(call6935);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6927 = gc_frame_newslot(*var_s);
  params[0] = call6935;
  partcv[0] = 1;
  Object opresult6937 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6937 (depth = 5)
  *var_s = opresult6937;
  if (opresult6937 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6908 = done;
  } else {
  }
// compiled if node returning if6908 (depth = 3)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6941 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6942 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6941);
// compiled call node returning call6942 (depth = 6)
// compiled member node returning call6942 (depth = 5)
  int op_slot_right_6940 = gc_frame_newslot(call6942);
// starting to compile identifier node (depth = 5)
  Object bool6944 = alloc_Boolean(0);
// compiled identifier node returning bool6944 (depth = 5)
  int op_slot_left_6940 = gc_frame_newslot(bool6944);
  params[0] = call6942;
  partcv[0] = 1;
  Object opresult6945 = callmethod(bool6944, "!=", 1, partcv, params);
// compiled op node returning opresult6945 (depth = 4)
  Object if6939 = done;
  if (istrue(opresult6945)) {
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6947 == NULL) {
    strlit6947 = alloc_String("Generics:");
    gc_root(strlit6947);
  }
// compiled string node returning strlit6947 (depth = 6)
  int op_slot_right_6946 = gc_frame_newslot(strlit6947);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6949 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6952 == NULL) {
    strlit6952 = alloc_String("""\x0a""");
    gc_root(strlit6952);
  }
// compiled string node returning strlit6952 (depth = 8)
  int op_slot_right_6951 = gc_frame_newslot(strlit6952);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6951 = gc_frame_newslot(*var_s);
  params[0] = strlit6952;
  partcv[0] = 1;
  Object opresult6954 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6954 (depth = 7)
  int op_slot_left_6949 = gc_frame_newslot(opresult6954);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6955 = callmethod(opresult6954, "++", 1, partcv, params);
// compiled op node returning opresult6955 (depth = 6)
  int op_slot_left_6946 = gc_frame_newslot(opresult6955);
  params[0] = strlit6947;
  partcv[0] = 1;
  Object opresult6956 = callmethod(opresult6955, "++", 1, partcv, params);
// compiled op node returning opresult6956 (depth = 5)
  *var_s = opresult6956;
  if (opresult6956 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6958 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6960 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6959);
// compiled call node returning call6960 (depth = 6)
// compiled member node returning call6960 (depth = 5)
  gc_frame_newslot(call6960);
// starting to compile block node (depth = 5)
  Object block6961 = alloc_Block(NULL, NULL, "ast", 1699);
  gc_frame_newslot(block6961);
// method "_apply"
  block_savedest(block6961);
  Object closure6962 = createclosure(4, "_apply");
  setclosureframe(closure6962, stackframe);
  addtoclosure(closure6962, var_depth);
  addtoclosure(closure6962, var_spc);
  addtoclosure(closure6962, var_s);
  addtoclosure(closure6962, selfslot);
  struct UserObject *uo6962 = (struct UserObject*)block6961;
  uo6962->data[0] = (Object)closure6962;
  Method *meth_meth_ast__apply6962 = addmethod2pos(block6961, "_apply", &meth_ast__apply6962, 0);
  int argcv_meth_ast__apply6962[] = {1};
  meth_meth_ast__apply6962->type = alloc_MethodType(1, argcv_meth_ast__apply6962);
  meth_meth_ast__apply6962->definitionModule = modulename;
  meth_meth_ast__apply6962->definitionLine = 1699;
// compiled block node returning block6961 (depth = 5)
  gc_frame_newslot(block6961);
// call case 5: prelude request
  params[0] = call6960;
  params[1] = block6961;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6985 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6958);
// compiled call node returning call6985 (depth = 4)
    gc_frame_newslot(call6985);
    if6939 = call6985;
  } else {
  }
// compiled if node returning if6939 (depth = 3)
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7044(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7046 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7048 = alloc_Float64(1);
// compiled num node returning num7048 (depth = 10)
  int op_slot_right_7047 = gc_frame_newslot(num7048);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7047 = gc_frame_newslot(*var_depth);
  params[0] = num7048;
  partcv[0] = 1;
  Object sum7050 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7050 (depth = 9)
  gc_frame_newslot(sum7050);
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe7051 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7053 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7052);
// compiled call node returning call7053 (depth = 11)
// compiled member node returning call7053 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call7054 = callmethod(call7053, "at",
    1, partcv, params);
  gc_frame_end(callframe7051);
// compiled call node returning call7054 (depth = 9)
  params[0] = sum7050;
  partcv[0] = 1;
  Object call7055 = callmethod(call7054, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7046);
// compiled call node returning call7055 (depth = 8)
  int op_slot_right_7045 = gc_frame_newslot(call7055);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7045 = gc_frame_newslot(*var_s);
  params[0] = call7055;
  partcv[0] = 1;
  Object opresult7057 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7057 (depth = 7)
  *var_s = opresult7057;
  if (opresult7057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_s = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6989 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6988);
// compiled call node returning call6989 (depth = 5)
// compiled member node returning call6989 (depth = 4)
  Object if6987 = done;
  if (istrue(call6989)) {
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6990 == NULL) {
    strlit6990 = alloc_String("_");
    gc_root(strlit6990);
  }
// compiled string node returning strlit6990 (depth = 5)
  *var_s = strlit6990;
  if (strlit6990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6987 = done;
  } else {
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6992 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6993 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6992);
// compiled call node returning call6993 (depth = 6)
// compiled member node returning call6993 (depth = 5)
  *var_s = call6993;
  if (call6993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6987 = done;
  }
// compiled if node returning if6987 (depth = 3)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6997 = alloc_Boolean(0);
// compiled identifier node returning bool6997 (depth = 5)
  int op_slot_right_6996 = gc_frame_newslot(bool6997);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6999 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7000 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6999);
// compiled call node returning call7000 (depth = 6)
// compiled member node returning call7000 (depth = 5)
  int op_slot_left_6996 = gc_frame_newslot(call7000);
  params[0] = bool6997;
  partcv[0] = 1;
  Object opresult7001 = callmethod(call7000, "!=", 1, partcv, params);
// compiled op node returning opresult7001 (depth = 4)
  Object if6995 = done;
  if (istrue(opresult7001)) {
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7003 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7005 = alloc_Float64(1);
// compiled num node returning num7005 (depth = 8)
  int op_slot_right_7004 = gc_frame_newslot(num7005);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7004 = gc_frame_newslot(*var_depth);
  params[0] = num7005;
  partcv[0] = 1;
  Object sum7007 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7007 (depth = 7)
  gc_frame_newslot(sum7007);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7009 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7008);
// compiled call node returning call7009 (depth = 8)
// compiled member node returning call7009 (depth = 7)
  params[0] = sum7007;
  partcv[0] = 1;
  Object call7010 = callmethod(call7009, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7003);
// compiled call node returning call7010 (depth = 6)
  int op_slot_right_7002 = gc_frame_newslot(call7010);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7013 == NULL) {
    strlit7013 = alloc_String(" : ");
    gc_root(strlit7013);
  }
// compiled string node returning strlit7013 (depth = 7)
  int op_slot_right_7012 = gc_frame_newslot(strlit7013);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7012 = gc_frame_newslot(*var_s);
  params[0] = strlit7013;
  partcv[0] = 1;
  Object opresult7015 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7015 (depth = 6)
  int op_slot_left_7002 = gc_frame_newslot(opresult7015);
  params[0] = call7010;
  partcv[0] = 1;
  Object opresult7016 = callmethod(opresult7015, "++", 1, partcv, params);
// compiled op node returning opresult7016 (depth = 5)
  *var_s = opresult7016;
  if (opresult7016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6995 = done;
  } else {
  }
// compiled if node returning if6995 (depth = 3)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7020 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7021 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7020);
// compiled call node returning call7021 (depth = 6)
// compiled member node returning call7021 (depth = 5)
  int op_slot_right_7019 = gc_frame_newslot(call7021);
// starting to compile identifier node (depth = 5)
  Object bool7023 = alloc_Boolean(0);
// compiled identifier node returning bool7023 (depth = 5)
  int op_slot_left_7019 = gc_frame_newslot(bool7023);
  params[0] = call7021;
  partcv[0] = 1;
  Object opresult7024 = callmethod(bool7023, "!=", 1, partcv, params);
// compiled op node returning opresult7024 (depth = 4)
  Object if7018 = done;
  if (istrue(opresult7024)) {
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7026 == NULL) {
    strlit7026 = alloc_String("<");
    gc_root(strlit7026);
  }
// compiled string node returning strlit7026 (depth = 6)
  int op_slot_right_7025 = gc_frame_newslot(strlit7026);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7025 = gc_frame_newslot(*var_s);
  params[0] = strlit7026;
  partcv[0] = 1;
  Object opresult7028 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7028 (depth = 5)
  *var_s = opresult7028;
  if (opresult7028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7030 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7033 = alloc_Float64(1);
// compiled num node returning num7033 (depth = 7)
  int op_slot_right_7032 = gc_frame_newslot(num7033);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7035 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7037 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7036);
// compiled call node returning call7037 (depth = 10)
// compiled member node returning call7037 (depth = 9)
  partcv[0] = 0;
  Object call7038 = callmethod(call7037, "size",
    1, partcv, params);
  gc_frame_end(callframe7035);
// compiled call node returning call7038 (depth = 8)
// compiled member node returning call7038 (depth = 7)
  int op_slot_left_7032 = gc_frame_newslot(call7038);
  params[0] = num7033;
  partcv[0] = 1;
  Object diff7039 = callmethod(call7038, "-", 1, partcv, params);
// compiled op node returning diff7039 (depth = 6)
  int op_slot_right_7031 = gc_frame_newslot(diff7039);
// starting to compile num node (depth = 6)
  Object num7041 = alloc_Float64(1);
// compiled num node returning num7041 (depth = 6)
  int op_slot_left_7031 = gc_frame_newslot(num7041);
  params[0] = diff7039;
  partcv[0] = 1;
  Object opresult7042 = callmethod(num7041, "..", 1, partcv, params);
// compiled op node returning opresult7042 (depth = 5)
  gc_frame_newslot(opresult7042);
// starting to compile block node (depth = 5)
  Object block7043 = alloc_Block(NULL, NULL, "ast", 1717);
  gc_frame_newslot(block7043);
// method "_apply"
  block_savedest(block7043);
  Object closure7044 = createclosure(3, "_apply");
  setclosureframe(closure7044, stackframe);
  addtoclosure(closure7044, var_depth);
  addtoclosure(closure7044, var_s);
  addtoclosure(closure7044, selfslot);
  struct UserObject *uo7044 = (struct UserObject*)block7043;
  uo7044->data[0] = (Object)closure7044;
  Method *meth_meth_ast__apply7044 = addmethod2pos(block7043, "_apply", &meth_ast__apply7044, 0);
  int argcv_meth_ast__apply7044[] = {1};
  meth_meth_ast__apply7044->type = alloc_MethodType(1, argcv_meth_ast__apply7044);
  meth_meth_ast__apply7044->definitionModule = modulename;
  meth_meth_ast__apply7044->definitionLine = 1717;
// compiled block node returning block7043 (depth = 5)
  gc_frame_newslot(block7043);
// call case 5: prelude request
  params[0] = opresult7042;
  params[1] = block7043;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7060 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7030);
// compiled call node returning call7060 (depth = 4)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7062 == NULL) {
    strlit7062 = alloc_String(">");
    gc_root(strlit7062);
  }
// compiled string node returning strlit7062 (depth = 6)
  int op_slot_right_7061 = gc_frame_newslot(strlit7062);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7065 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7067 = alloc_Float64(1);
// compiled num node returning num7067 (depth = 9)
  int op_slot_right_7066 = gc_frame_newslot(num7067);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7066 = gc_frame_newslot(*var_depth);
  params[0] = num7067;
  partcv[0] = 1;
  Object sum7069 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7069 (depth = 8)
  gc_frame_newslot(sum7069);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7070 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7071 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7072 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7071);
// compiled call node returning call7072 (depth = 11)
// compiled member node returning call7072 (depth = 10)
  partcv[0] = 0;
  Object call7073 = callmethod(call7072, "last",
    1, partcv, params);
  gc_frame_end(callframe7070);
// compiled call node returning call7073 (depth = 9)
// compiled member node returning call7073 (depth = 8)
  params[0] = sum7069;
  partcv[0] = 1;
  Object call7074 = callmethod(call7073, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7065);
// compiled call node returning call7074 (depth = 7)
  int op_slot_right_7064 = gc_frame_newslot(call7074);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7064 = gc_frame_newslot(*var_s);
  params[0] = call7074;
  partcv[0] = 1;
  Object opresult7076 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7076 (depth = 6)
  int op_slot_left_7061 = gc_frame_newslot(opresult7076);
  params[0] = strlit7062;
  partcv[0] = 1;
  Object opresult7077 = callmethod(opresult7076, "++", 1, partcv, params);
// compiled op node returning opresult7077 (depth = 5)
  *var_s = opresult7077;
  if (opresult7077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7018 = done;
  } else {
  }
// compiled if node returning if7018 (depth = 3)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString7079(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7081 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7082 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7081);
// compiled call node returning call7082 (depth = 5)
// compiled member node returning call7082 (depth = 4)
  Object if7080 = done;
  if (istrue(call7082)) {
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7084 == NULL) {
    strlit7084 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7084);
  }
// compiled string node returning strlit7084 (depth = 5)
  int op_slot_right_7083 = gc_frame_newslot(strlit7084);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7088 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7087);
// compiled call node returning call7088 (depth = 7)
// compiled member node returning call7088 (depth = 6)
  int op_slot_right_7086 = gc_frame_newslot(call7088);
// starting to compile string node (depth = 6)
  if (strlit7090 == NULL) {
    strlit7090 = alloc_String("identifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7090);
  }
// compiled string node returning strlit7090 (depth = 6)
  int op_slot_left_7086 = gc_frame_newslot(strlit7090);
  params[0] = call7088;
  partcv[0] = 1;
  Object opresult7091 = callmethod(strlit7090, "++", 1, partcv, params);
// compiled op node returning opresult7091 (depth = 5)
  int op_slot_left_7083 = gc_frame_newslot(opresult7091);
  params[0] = strlit7084;
  partcv[0] = 1;
  Object opresult7092 = callmethod(opresult7091, "++", 1, partcv, params);
// compiled op node returning opresult7092 (depth = 4)
    gc_frame_newslot(opresult7092);
    if7080 = opresult7092;
  } else {
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7094 == NULL) {
    strlit7094 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7094);
  }
// compiled string node returning strlit7094 (depth = 5)
  int op_slot_right_7093 = gc_frame_newslot(strlit7094);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7097 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7098 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compiled call node returning call7098 (depth = 7)
// compiled member node returning call7098 (depth = 6)
  int op_slot_right_7096 = gc_frame_newslot(call7098);
// starting to compile string node (depth = 6)
  if (strlit7100 == NULL) {
    strlit7100 = alloc_String("identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit7100);
  }
// compiled string node returning strlit7100 (depth = 6)
  int op_slot_left_7096 = gc_frame_newslot(strlit7100);
  params[0] = call7098;
  partcv[0] = 1;
  Object opresult7101 = callmethod(strlit7100, "++", 1, partcv, params);
// compiled op node returning opresult7101 (depth = 5)
  int op_slot_left_7093 = gc_frame_newslot(opresult7101);
  params[0] = strlit7094;
  partcv[0] = 1;
  Object opresult7102 = callmethod(opresult7101, "++", 1, partcv, params);
// compiled op node returning opresult7102 (depth = 4)
    gc_frame_newslot(opresult7102);
    if7080 = opresult7102;
  }
// compiled if node returning if7080 (depth = 3)
  gc_frame_end(frame);
  return if7080;
}
Object meth_ast_shallowCopy7103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7104 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7105 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7106 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7107 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7106);
// compiled call node returning call7107 (depth = 6)
// compiled member node returning call7107 (depth = 5)
  gc_frame_newslot(call7107);
// starting to compile identifier node (depth = 5)
  Object bool7108 = alloc_Boolean(0);
// compiled identifier node returning bool7108 (depth = 5)
  gc_frame_newslot(bool7108);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7107;
  params[1] = bool7108;
  partcv[0] = 2;
  Object call7109 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7105);
// compiled call node returning call7109 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7110 = callmethod(call7109, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7104);
// compiled call node returning call7110 (depth = 3)
  gc_frame_end(frame);
  return call7110;
}
Object meth_ast_shallowCopyFieldsFrom7111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7112 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call7113 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7112);
// compiled call node returning call7113 (depth = 3)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7114 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7116 = callmethod(*var_other, "wildcard",
    1, partcv, params);
  gc_frame_end(callframe7115);
// compiled call node returning call7116 (depth = 5)
// compiled member node returning call7116 (depth = 4)
  gc_frame_newslot(call7116);
// call case 4: self request
  params[0] = call7116;
  partcv[0] = 1;
  Object call7117 = callmethodflags(self, "wildcard:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7114);
// compiled call node returning call7117 (depth = 3)
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7118 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7120 = callmethod(*var_other, "isBindingOccurrence",
    1, partcv, params);
  gc_frame_end(callframe7119);
// compiled call node returning call7120 (depth = 5)
// compiled member node returning call7120 (depth = 4)
  gc_frame_newslot(call7120);
// call case 4: self request
  params[0] = call7120;
  partcv[0] = 1;
  Object call7121 = callmethodflags(self, "isBindingOccurrence:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7118);
// compiled call node returning call7121 (depth = 3)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7122 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7124 = callmethod(*var_other, "isDeclaredByParent",
    1, partcv, params);
  gc_frame_end(callframe7123);
// compiled call node returning call7124 (depth = 5)
// compiled member node returning call7124 (depth = 4)
  gc_frame_newslot(call7124);
// call case 4: self request
  params[0] = call7124;
  partcv[0] = 1;
  Object call7125 = callmethodflags(self, "isDeclaredByParent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7122);
// compiled call node returning call7125 (depth = 3)
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7126 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7128 = callmethod(*var_other, "isAssigned",
    1, partcv, params);
  gc_frame_end(callframe7127);
// compiled call node returning call7128 (depth = 5)
// compiled member node returning call7128 (depth = 4)
  gc_frame_newslot(call7128);
// call case 4: self request
  params[0] = call7128;
  partcv[0] = 1;
  Object call7129 = callmethodflags(self, "isAssigned:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7126);
// compiled call node returning call7129 (depth = 3)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7130 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7132 = callmethod(*var_other, "inRequest",
    1, partcv, params);
  gc_frame_end(callframe7131);
// compiled call node returning call7132 (depth = 5)
// compiled member node returning call7132 (depth = 4)
  gc_frame_newslot(call7132);
// call case 4: self request
  params[0] = call7132;
  partcv[0] = 1;
  Object call7133 = callmethodflags(self, "inRequest:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7130);
// compiled call node returning call7133 (depth = 3)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName7134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7135 == NULL) {
    strlit7135 = alloc_String("expression");
    gc_root(strlit7135);
  }
// compiled string node returning strlit7135 (depth = 3)
  gc_frame_end(frame);
  return strlit7135;
}
Object meth_ast_new6766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6767 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6767 = alloc_userobj2(32,25, objclass6767);
  gc_frame_newslot(obj6767);
if (objclass6767 == NULL) {
  glfree(obj6767->class->name);
  obj6767->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6767, self, 0);
  addmethodreal(obj6767,"outer", &reader_ast_outer_6768);
  Object oldself6767 = self;
  struct StackFrameObject *oldstackframe6767 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6767);
  gc_frame_newslot((Object)stackframe);
  self = obj6767;
  Object *oldselfslot6767 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6767 = (*(struct UserObject *)self).data[0], lowerouter6767 = thisouter6767;
  if (inheritingObject6767) {
    struct UserObject *inho6767 = (struct UserObject *)inheritingObject6767;
    while (inho6767->super != GraceDefaultObject) inho6767 = (struct UserObject *)inho6767->super;
    inho6767->super = obj6767;
    self = inheritingObject6767;
    *selfslot = self;
    lowerouter6767 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6767;
  }
if (objclass6767 == NULL) {
  Method *reader6769 = addmethodrealflags(obj6767, "kind",&reader_ast_kind_6769, MFLAG_DEF);
  reader6769->definitionModule = modulename;
  reader6769->definitionLine = 1632;
}
adddatum2(obj6767, alloc_Undefined(), 1);
if (objclass6767 == NULL) {
  Method *reader6770 = addmethodrealflags(obj6767, "value",&reader_ast_value_6770, 0);
  Method *writer6770 = addmethodrealflags(obj6767, "value:=",&writer_ast_value_6770, 0);
  reader6770->definitionModule = modulename;
  writer6770->definitionModule = modulename;
  reader6770->definitionLine = 1633;
  writer6770->definitionLine = 1633;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 2);
if (objclass6767 == NULL) {
  Method *reader6771 = addmethodrealflags(obj6767, "wildcard",&reader_ast_wildcard_6771, 0);
  Method *writer6771 = addmethodrealflags(obj6767, "wildcard:=",&writer_ast_wildcard_6771, 0);
  reader6771->definitionModule = modulename;
  writer6771->definitionModule = modulename;
  reader6771->definitionLine = 1634;
  writer6771->definitionLine = 1634;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 3);
if (objclass6767 == NULL) {
  Method *reader6772 = addmethodrealflags(obj6767, "dtype",&reader_ast_dtype_6772, 0);
  Method *writer6772 = addmethodrealflags(obj6767, "dtype:=",&writer_ast_dtype_6772, 0);
  reader6772->definitionModule = modulename;
  writer6772->definitionModule = modulename;
  reader6772->definitionLine = 1635;
  writer6772->definitionLine = 1635;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 4);
if (objclass6767 == NULL) {
  Method *reader6773 = addmethodrealflags(obj6767, "isBindingOccurrence",&reader_ast_isBindingOccurrence_6773, 0);
  Method *writer6773 = addmethodrealflags(obj6767, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_6773, 0);
  reader6773->definitionModule = modulename;
  writer6773->definitionModule = modulename;
  reader6773->definitionLine = 1636;
  writer6773->definitionLine = 1636;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 5);
if (objclass6767 == NULL) {
  Method *reader6774 = addmethodrealflags(obj6767, "isAssigned",&reader_ast_isAssigned_6774, 0);
  Method *writer6774 = addmethodrealflags(obj6767, "isAssigned:=",&writer_ast_isAssigned_6774, 0);
  reader6774->definitionModule = modulename;
  writer6774->definitionModule = modulename;
  reader6774->definitionLine = 1637;
  writer6774->definitionLine = 1637;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 6);
if (objclass6767 == NULL) {
  Method *reader6775 = addmethodrealflags(obj6767, "inRequest",&reader_ast_inRequest_6775, 0);
  Method *writer6775 = addmethodrealflags(obj6767, "inRequest:=",&writer_ast_inRequest_6775, 0);
  reader6775->definitionModule = modulename;
  writer6775->definitionModule = modulename;
  reader6775->definitionLine = 1638;
  writer6775->definitionLine = 1638;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 7);
if (objclass6767 == NULL) {
  Method *reader6776 = addmethodrealflags(obj6767, "generics",&reader_ast_generics_6776, 0);
  Method *writer6776 = addmethodrealflags(obj6767, "generics:=",&writer_ast_generics_6776, 0);
  reader6776->definitionModule = modulename;
  writer6776->definitionModule = modulename;
  reader6776->definitionLine = 1639;
  writer6776->definitionLine = 1639;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 8);
if (objclass6767 == NULL) {
  Method *reader6777 = addmethodrealflags(obj6767, "isDeclaredByParent",&reader_ast_isDeclaredByParent_6777, 0);
  Method *writer6777 = addmethodrealflags(obj6767, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_6777, 0);
  reader6777->definitionModule = modulename;
  writer6777->definitionModule = modulename;
  reader6777->definitionLine = 1640;
  writer6777->definitionLine = 1640;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6778 = (struct UserObject*)obj6767;
  uo6778->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6778 = addmethod2pos(obj6767, "nameString", &meth_ast_nameString6778, 10);
  int argcv_meth_ast_nameString6778[] = {0};
  meth_meth_ast_nameString6778->type = alloc_MethodType(1, argcv_meth_ast_nameString6778);
  meth_meth_ast_nameString6778->definitionModule = modulename;
  meth_meth_ast_nameString6778->definitionLine = 1642;
// method "quoted"
  struct UserObject *uo6781 = (struct UserObject*)obj6767;
  uo6781->data[11] = emptyclosure;
  Method *meth_meth_ast_quoted6781 = addmethod2pos(obj6767, "quoted", &meth_ast_quoted6781, 11);
  int argcv_meth_ast_quoted6781[] = {0};
  meth_meth_ast_quoted6781->type = alloc_MethodType(1, argcv_meth_ast_quoted6781);
  meth_meth_ast_quoted6781->definitionModule = modulename;
  meth_meth_ast_quoted6781->definitionLine = 1643;
// method "isIdentifier"
  struct UserObject *uo6786 = (struct UserObject*)obj6767;
  uo6786->data[12] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6786 = addmethod2pos(obj6767, "isIdentifier", &meth_ast_isIdentifier6786, 12);
  int argcv_meth_ast_isIdentifier6786[] = {0};
  meth_meth_ast_isIdentifier6786->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6786);
  meth_meth_ast_isIdentifier6786->definitionModule = modulename;
  meth_meth_ast_isIdentifier6786->definitionLine = 1644;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6788 = (struct UserObject*)obj6767;
  uo6788->data[13] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6788 = addmethod2pos(obj6767, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6788, 13);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6788[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6788->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6788);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6788->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6788->definitionLine = 1646;
// method "declarationKindWithAncestors"
  struct UserObject *uo6797 = (struct UserObject*)obj6767;
  uo6797->data[14] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors6797 = addmethod2pos(obj6767, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6797, 14);
  int argcv_meth_ast_declarationKindWithAncestors6797[] = {1};
  meth_meth_ast_declarationKindWithAncestors6797->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6797);
  meth_meth_ast_declarationKindWithAncestors6797->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6797->definitionLine = 1653;
// method "inTypePositionWithAncestors"
  struct UserObject *uo6802 = (struct UserObject*)obj6767;
  uo6802->data[15] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors6802 = addmethod2pos(obj6767, "inTypePositionWithAncestors", &meth_ast_inTypePositionWithAncestors6802, 15);
  int argcv_meth_ast_inTypePositionWithAncestors6802[] = {1};
  meth_meth_ast_inTypePositionWithAncestors6802->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors6802);
  meth_meth_ast_inTypePositionWithAncestors6802->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors6802->definitionLine = 1656;
// method "usesAsType"
  struct UserObject *uo6811 = (struct UserObject*)obj6767;
  uo6811->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType6811 = addmethod2pos(obj6767, "usesAsType", &meth_ast_usesAsType6811, 16);
  int argcv_meth_ast_usesAsType6811[] = {1};
  meth_meth_ast_usesAsType6811->type = alloc_MethodType(1, argcv_meth_ast_usesAsType6811);
  meth_meth_ast_usesAsType6811->definitionModule = modulename;
  meth_meth_ast_usesAsType6811->definitionLine = 1663;
// method "accept()from"
  struct UserObject *uo6817 = (struct UserObject*)obj6767;
  uo6817->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6817 = addmethod2pos(obj6767, "accept()from", &meth_ast_accept_40__41_from6817, 17);
  int argcv_meth_ast_accept_40__41_from6817[] = {1, 1};
  meth_meth_ast_accept_40__41_from6817->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6817);
  meth_meth_ast_accept_40__41_from6817->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6817->definitionLine = 1666;
// method "map()ancestors"
  struct UserObject *uo6834 = (struct UserObject*)obj6767;
  uo6834->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6834 = addmethod2pos(obj6767, "map()ancestors", &meth_ast_map_40__41_ancestors6834, 18);
  int argcv_meth_ast_map_40__41_ancestors6834[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6834->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6834);
  meth_meth_ast_map_40__41_ancestors6834->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6834->definitionLine = 1674;
// method "pretty"
  struct UserObject *uo6851 = (struct UserObject*)obj6767;
  uo6851->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty6851 = addmethod2pos(obj6767, "pretty", &meth_ast_pretty6851, 19);
  int argcv_meth_ast_pretty6851[] = {1};
  meth_meth_ast_pretty6851->type = alloc_MethodType(1, argcv_meth_ast_pretty6851);
  meth_meth_ast_pretty6851->definitionModule = modulename;
  meth_meth_ast_pretty6851->definitionLine = 1680;
// method "toGrace"
  struct UserObject *uo6986 = (struct UserObject*)obj6767;
  uo6986->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace6986 = addmethod2pos(obj6767, "toGrace", &meth_ast_toGrace6986, 20);
  int argcv_meth_ast_toGrace6986[] = {1};
  meth_meth_ast_toGrace6986->type = alloc_MethodType(1, argcv_meth_ast_toGrace6986);
meth_meth_ast_toGrace6986->type->types[0] = type_Number;
meth_meth_ast_toGrace6986->type->names[0] = "depth";
  meth_meth_ast_toGrace6986->definitionModule = modulename;
  meth_meth_ast_toGrace6986->definitionLine = 1705;
// method "asString"
  struct UserObject *uo7079 = (struct UserObject*)obj6767;
  uo7079->data[21] = emptyclosure;
  Method *meth_meth_ast_asString7079 = addmethod2pos(obj6767, "asString", &meth_ast_asString7079, 21);
  int argcv_meth_ast_asString7079[] = {0};
  meth_meth_ast_asString7079->type = alloc_MethodType(1, argcv_meth_ast_asString7079);
  meth_meth_ast_asString7079->definitionModule = modulename;
  meth_meth_ast_asString7079->definitionLine = 1725;
// method "shallowCopy"
  block_savedest(obj6767);
  Object closure7103 = createclosure(1, "shallowCopy");
  setclosureframe(closure7103, stackframe);
  addtoclosure(closure7103, var_identifierNode);
  struct UserObject *uo7103 = (struct UserObject*)obj6767;
  uo7103->data[22] = (Object)closure7103;
  Method *meth_meth_ast_shallowCopy7103 = addmethod2pos(obj6767, "shallowCopy", &meth_ast_shallowCopy7103, 22);
  int argcv_meth_ast_shallowCopy7103[] = {0};
  meth_meth_ast_shallowCopy7103->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7103);
  meth_meth_ast_shallowCopy7103->definitionModule = modulename;
  meth_meth_ast_shallowCopy7103->definitionLine = 1732;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo7111 = (struct UserObject*)obj6767;
  uo7111->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom7111 = addmethod2pos(obj6767, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom7111, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom7111[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom7111->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom7111);
  meth_meth_ast_shallowCopyFieldsFrom7111->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom7111->definitionLine = 1735;
// method "statementName"
  struct UserObject *uo7134 = (struct UserObject*)obj6767;
  uo7134->data[24] = emptyclosure;
  Method *meth_meth_ast_statementName7134 = addmethod2pos(obj6767, "statementName", &meth_ast_statementName7134, 24);
  int argcv_meth_ast_statementName7134[] = {0};
  meth_meth_ast_statementName7134->type = alloc_MethodType(1, argcv_meth_ast_statementName7134);
  meth_meth_ast_statementName7134->definitionModule = modulename;
  meth_meth_ast_statementName7134->definitionLine = 1744;
  sourceObject = obj6767;
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7136 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7137 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7138 = gc_frame_new();
// call case 3: self.outer request
  Object call7139 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7138);
// compiled call node returning call7139 (depth = 7)
// compiled member node returning call7139 (depth = 6)
  partcv[0] = 0;
  Object call7140 = callmethodflags(call7139, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7137);
// compiled call node returning call7140 (depth = 5)
// compiled member node returning call7140 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7141 = callmethodflags(call7140, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7136);
// compiled call node returning call7141 (depth = 3)
  struct UserObject *obj6767_uo = (struct UserObject *)obj6767;
  obj6767_uo->super = call7141;
  sourceObject = obj6767;
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7142 == NULL) {
    strlit7142 = alloc_String("identifier");
    gc_root(strlit7142);
  }
// compiled string node returning strlit7142 (depth = 3)
  adddatum2(obj6767, strlit7142, 1);
  sourceObject = obj6767;
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6767, *var_name, 2);
  sourceObject = obj6767;
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7143 = alloc_Boolean(0);
// compiled identifier node returning bool7143 (depth = 3)
  adddatum2(obj6767, bool7143, 3);
  sourceObject = obj6767;
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6767, *var_dtype_39_, 4);
  sourceObject = obj6767;
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7144 = alloc_Boolean(0);
// compiled identifier node returning bool7144 (depth = 3)
  adddatum2(obj6767, bool7144, 5);
  sourceObject = obj6767;
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7145 = alloc_Boolean(0);
// compiled identifier node returning bool7145 (depth = 3)
  adddatum2(obj6767, bool7145, 6);
  sourceObject = obj6767;
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7146 = alloc_Boolean(0);
// compiled identifier node returning bool7146 (depth = 3)
  adddatum2(obj6767, bool7146, 7);
  sourceObject = obj6767;
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7147 = alloc_Boolean(0);
// compiled identifier node returning bool7147 (depth = 3)
  adddatum2(obj6767, bool7147, 8);
  sourceObject = obj6767;
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7148 = alloc_Boolean(0);
// compiled identifier node returning bool7148 (depth = 3)
  adddatum2(obj6767, bool7148, 9);
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  objclass6767 = obj6767->class;
  objclass6767->definitionModule = modulename;
  objclass6767->definitionLine = 1630;
  (*(struct UserObject *)self).data[0] = lowerouter6767;
  self = oldself6767;
  selfslot = oldselfslot6767;
  stackframe = oldstackframe6767;
  gc_frame_end(frame);
  return obj6767;
}
Object meth_ast_new6766_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6767 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6767 = alloc_userobj2(32,25, objclass6767);
  gc_frame_newslot(obj6767);
if (objclass6767 == NULL) {
  glfree(obj6767->class->name);
  obj6767->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6767, self, 0);
  addmethodreal(obj6767,"outer", &reader_ast_outer_6768);
  Object oldself6767 = self;
  struct StackFrameObject *oldstackframe6767 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6767);
  gc_frame_newslot((Object)stackframe);
  self = obj6767;
  Object *oldselfslot6767 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6767 = (*(struct UserObject *)self).data[0], lowerouter6767 = thisouter6767;
  if (inheritingObject6767) {
    struct UserObject *inho6767 = (struct UserObject *)inheritingObject6767;
    while (inho6767->super != GraceDefaultObject) inho6767 = (struct UserObject *)inho6767->super;
    inho6767->super = obj6767;
    self = inheritingObject6767;
    *selfslot = self;
    lowerouter6767 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6767;
  }
if (objclass6767 == NULL) {
  Method *reader6769 = addmethodrealflags(obj6767, "kind",&reader_ast_kind_6769, MFLAG_DEF);
  reader6769->definitionModule = modulename;
  reader6769->definitionLine = 1632;
}
adddatum2(obj6767, alloc_Undefined(), 1);
if (objclass6767 == NULL) {
  Method *reader6770 = addmethodrealflags(obj6767, "value",&reader_ast_value_6770, 0);
  Method *writer6770 = addmethodrealflags(obj6767, "value:=",&writer_ast_value_6770, 0);
  reader6770->definitionModule = modulename;
  writer6770->definitionModule = modulename;
  reader6770->definitionLine = 1633;
  writer6770->definitionLine = 1633;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 2);
if (objclass6767 == NULL) {
  Method *reader6771 = addmethodrealflags(obj6767, "wildcard",&reader_ast_wildcard_6771, 0);
  Method *writer6771 = addmethodrealflags(obj6767, "wildcard:=",&writer_ast_wildcard_6771, 0);
  reader6771->definitionModule = modulename;
  writer6771->definitionModule = modulename;
  reader6771->definitionLine = 1634;
  writer6771->definitionLine = 1634;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 3);
if (objclass6767 == NULL) {
  Method *reader6772 = addmethodrealflags(obj6767, "dtype",&reader_ast_dtype_6772, 0);
  Method *writer6772 = addmethodrealflags(obj6767, "dtype:=",&writer_ast_dtype_6772, 0);
  reader6772->definitionModule = modulename;
  writer6772->definitionModule = modulename;
  reader6772->definitionLine = 1635;
  writer6772->definitionLine = 1635;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 4);
if (objclass6767 == NULL) {
  Method *reader6773 = addmethodrealflags(obj6767, "isBindingOccurrence",&reader_ast_isBindingOccurrence_6773, 0);
  Method *writer6773 = addmethodrealflags(obj6767, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_6773, 0);
  reader6773->definitionModule = modulename;
  writer6773->definitionModule = modulename;
  reader6773->definitionLine = 1636;
  writer6773->definitionLine = 1636;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 5);
if (objclass6767 == NULL) {
  Method *reader6774 = addmethodrealflags(obj6767, "isAssigned",&reader_ast_isAssigned_6774, 0);
  Method *writer6774 = addmethodrealflags(obj6767, "isAssigned:=",&writer_ast_isAssigned_6774, 0);
  reader6774->definitionModule = modulename;
  writer6774->definitionModule = modulename;
  reader6774->definitionLine = 1637;
  writer6774->definitionLine = 1637;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 6);
if (objclass6767 == NULL) {
  Method *reader6775 = addmethodrealflags(obj6767, "inRequest",&reader_ast_inRequest_6775, 0);
  Method *writer6775 = addmethodrealflags(obj6767, "inRequest:=",&writer_ast_inRequest_6775, 0);
  reader6775->definitionModule = modulename;
  writer6775->definitionModule = modulename;
  reader6775->definitionLine = 1638;
  writer6775->definitionLine = 1638;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 7);
if (objclass6767 == NULL) {
  Method *reader6776 = addmethodrealflags(obj6767, "generics",&reader_ast_generics_6776, 0);
  Method *writer6776 = addmethodrealflags(obj6767, "generics:=",&writer_ast_generics_6776, 0);
  reader6776->definitionModule = modulename;
  writer6776->definitionModule = modulename;
  reader6776->definitionLine = 1639;
  writer6776->definitionLine = 1639;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 8);
if (objclass6767 == NULL) {
  Method *reader6777 = addmethodrealflags(obj6767, "isDeclaredByParent",&reader_ast_isDeclaredByParent_6777, 0);
  Method *writer6777 = addmethodrealflags(obj6767, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_6777, 0);
  reader6777->definitionModule = modulename;
  writer6777->definitionModule = modulename;
  reader6777->definitionLine = 1640;
  writer6777->definitionLine = 1640;
}
obj6767->flags |= OFLAG_MUTABLE;
adddatum2(obj6767, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6778 = (struct UserObject*)obj6767;
  uo6778->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6778 = addmethod2pos(obj6767, "nameString", &meth_ast_nameString6778, 10);
  int argcv_meth_ast_nameString6778[] = {0};
  meth_meth_ast_nameString6778->type = alloc_MethodType(1, argcv_meth_ast_nameString6778);
  meth_meth_ast_nameString6778->definitionModule = modulename;
  meth_meth_ast_nameString6778->definitionLine = 1642;
// method "quoted"
  struct UserObject *uo6781 = (struct UserObject*)obj6767;
  uo6781->data[11] = emptyclosure;
  Method *meth_meth_ast_quoted6781 = addmethod2pos(obj6767, "quoted", &meth_ast_quoted6781, 11);
  int argcv_meth_ast_quoted6781[] = {0};
  meth_meth_ast_quoted6781->type = alloc_MethodType(1, argcv_meth_ast_quoted6781);
  meth_meth_ast_quoted6781->definitionModule = modulename;
  meth_meth_ast_quoted6781->definitionLine = 1643;
// method "isIdentifier"
  struct UserObject *uo6786 = (struct UserObject*)obj6767;
  uo6786->data[12] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6786 = addmethod2pos(obj6767, "isIdentifier", &meth_ast_isIdentifier6786, 12);
  int argcv_meth_ast_isIdentifier6786[] = {0};
  meth_meth_ast_isIdentifier6786->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6786);
  meth_meth_ast_isIdentifier6786->definitionModule = modulename;
  meth_meth_ast_isIdentifier6786->definitionLine = 1644;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6788 = (struct UserObject*)obj6767;
  uo6788->data[13] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6788 = addmethod2pos(obj6767, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6788, 13);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6788[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6788->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6788);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6788->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6788->definitionLine = 1646;
// method "declarationKindWithAncestors"
  struct UserObject *uo6797 = (struct UserObject*)obj6767;
  uo6797->data[14] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors6797 = addmethod2pos(obj6767, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6797, 14);
  int argcv_meth_ast_declarationKindWithAncestors6797[] = {1};
  meth_meth_ast_declarationKindWithAncestors6797->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6797);
  meth_meth_ast_declarationKindWithAncestors6797->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6797->definitionLine = 1653;
// method "inTypePositionWithAncestors"
  struct UserObject *uo6802 = (struct UserObject*)obj6767;
  uo6802->data[15] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors6802 = addmethod2pos(obj6767, "inTypePositionWithAncestors", &meth_ast_inTypePositionWithAncestors6802, 15);
  int argcv_meth_ast_inTypePositionWithAncestors6802[] = {1};
  meth_meth_ast_inTypePositionWithAncestors6802->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors6802);
  meth_meth_ast_inTypePositionWithAncestors6802->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors6802->definitionLine = 1656;
// method "usesAsType"
  struct UserObject *uo6811 = (struct UserObject*)obj6767;
  uo6811->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType6811 = addmethod2pos(obj6767, "usesAsType", &meth_ast_usesAsType6811, 16);
  int argcv_meth_ast_usesAsType6811[] = {1};
  meth_meth_ast_usesAsType6811->type = alloc_MethodType(1, argcv_meth_ast_usesAsType6811);
  meth_meth_ast_usesAsType6811->definitionModule = modulename;
  meth_meth_ast_usesAsType6811->definitionLine = 1663;
// method "accept()from"
  struct UserObject *uo6817 = (struct UserObject*)obj6767;
  uo6817->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6817 = addmethod2pos(obj6767, "accept()from", &meth_ast_accept_40__41_from6817, 17);
  int argcv_meth_ast_accept_40__41_from6817[] = {1, 1};
  meth_meth_ast_accept_40__41_from6817->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6817);
  meth_meth_ast_accept_40__41_from6817->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6817->definitionLine = 1666;
// method "map()ancestors"
  struct UserObject *uo6834 = (struct UserObject*)obj6767;
  uo6834->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6834 = addmethod2pos(obj6767, "map()ancestors", &meth_ast_map_40__41_ancestors6834, 18);
  int argcv_meth_ast_map_40__41_ancestors6834[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6834->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6834);
  meth_meth_ast_map_40__41_ancestors6834->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6834->definitionLine = 1674;
// method "pretty"
  struct UserObject *uo6851 = (struct UserObject*)obj6767;
  uo6851->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty6851 = addmethod2pos(obj6767, "pretty", &meth_ast_pretty6851, 19);
  int argcv_meth_ast_pretty6851[] = {1};
  meth_meth_ast_pretty6851->type = alloc_MethodType(1, argcv_meth_ast_pretty6851);
  meth_meth_ast_pretty6851->definitionModule = modulename;
  meth_meth_ast_pretty6851->definitionLine = 1680;
// method "toGrace"
  struct UserObject *uo6986 = (struct UserObject*)obj6767;
  uo6986->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace6986 = addmethod2pos(obj6767, "toGrace", &meth_ast_toGrace6986, 20);
  int argcv_meth_ast_toGrace6986[] = {1};
  meth_meth_ast_toGrace6986->type = alloc_MethodType(1, argcv_meth_ast_toGrace6986);
meth_meth_ast_toGrace6986->type->types[0] = type_Number;
meth_meth_ast_toGrace6986->type->names[0] = "depth";
  meth_meth_ast_toGrace6986->definitionModule = modulename;
  meth_meth_ast_toGrace6986->definitionLine = 1705;
// method "asString"
  struct UserObject *uo7079 = (struct UserObject*)obj6767;
  uo7079->data[21] = emptyclosure;
  Method *meth_meth_ast_asString7079 = addmethod2pos(obj6767, "asString", &meth_ast_asString7079, 21);
  int argcv_meth_ast_asString7079[] = {0};
  meth_meth_ast_asString7079->type = alloc_MethodType(1, argcv_meth_ast_asString7079);
  meth_meth_ast_asString7079->definitionModule = modulename;
  meth_meth_ast_asString7079->definitionLine = 1725;
// method "shallowCopy"
  block_savedest(obj6767);
  Object closure7103 = createclosure(1, "shallowCopy");
  setclosureframe(closure7103, stackframe);
  addtoclosure(closure7103, var_identifierNode);
  struct UserObject *uo7103 = (struct UserObject*)obj6767;
  uo7103->data[22] = (Object)closure7103;
  Method *meth_meth_ast_shallowCopy7103 = addmethod2pos(obj6767, "shallowCopy", &meth_ast_shallowCopy7103, 22);
  int argcv_meth_ast_shallowCopy7103[] = {0};
  meth_meth_ast_shallowCopy7103->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7103);
  meth_meth_ast_shallowCopy7103->definitionModule = modulename;
  meth_meth_ast_shallowCopy7103->definitionLine = 1732;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo7111 = (struct UserObject*)obj6767;
  uo7111->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom7111 = addmethod2pos(obj6767, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom7111, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom7111[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom7111->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom7111);
  meth_meth_ast_shallowCopyFieldsFrom7111->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom7111->definitionLine = 1735;
// method "statementName"
  struct UserObject *uo7134 = (struct UserObject*)obj6767;
  uo7134->data[24] = emptyclosure;
  Method *meth_meth_ast_statementName7134 = addmethod2pos(obj6767, "statementName", &meth_ast_statementName7134, 24);
  int argcv_meth_ast_statementName7134[] = {0};
  meth_meth_ast_statementName7134->type = alloc_MethodType(1, argcv_meth_ast_statementName7134);
  meth_meth_ast_statementName7134->definitionModule = modulename;
  meth_meth_ast_statementName7134->definitionLine = 1744;
  sourceObject = obj6767;
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7136 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7137 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7138 = gc_frame_new();
// call case 3: self.outer request
  Object call7139 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7138);
// compiled call node returning call7139 (depth = 7)
// compiled member node returning call7139 (depth = 6)
  partcv[0] = 0;
  Object call7140 = callmethodflags(call7139, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7137);
// compiled call node returning call7140 (depth = 5)
// compiled member node returning call7140 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7141 = callmethodflags(call7140, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7136);
// compiled call node returning call7141 (depth = 3)
  struct UserObject *obj6767_uo = (struct UserObject *)obj6767;
  obj6767_uo->super = call7141;
  sourceObject = obj6767;
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7142 == NULL) {
    strlit7142 = alloc_String("identifier");
    gc_root(strlit7142);
  }
// compiled string node returning strlit7142 (depth = 3)
  adddatum2(obj6767, strlit7142, 1);
  sourceObject = obj6767;
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6767, *var_name, 2);
  sourceObject = obj6767;
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7143 = alloc_Boolean(0);
// compiled identifier node returning bool7143 (depth = 3)
  adddatum2(obj6767, bool7143, 3);
  sourceObject = obj6767;
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6767, *var_dtype_39_, 4);
  sourceObject = obj6767;
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7144 = alloc_Boolean(0);
// compiled identifier node returning bool7144 (depth = 3)
  adddatum2(obj6767, bool7144, 5);
  sourceObject = obj6767;
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7145 = alloc_Boolean(0);
// compiled identifier node returning bool7145 (depth = 3)
  adddatum2(obj6767, bool7145, 6);
  sourceObject = obj6767;
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7146 = alloc_Boolean(0);
// compiled identifier node returning bool7146 (depth = 3)
  adddatum2(obj6767, bool7146, 7);
  sourceObject = obj6767;
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7147 = alloc_Boolean(0);
// compiled identifier node returning bool7147 (depth = 3)
  adddatum2(obj6767, bool7147, 8);
  sourceObject = obj6767;
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7148 = alloc_Boolean(0);
// compiled identifier node returning bool7148 (depth = 3)
  adddatum2(obj6767, bool7148, 9);
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  sourceObject = obj6767;
  objclass6767 = obj6767->class;
  objclass6767->definitionModule = modulename;
  objclass6767->definitionLine = 1630;
  (*(struct UserObject *)self).data[0] = lowerouter6767;
  self = oldself6767;
  selfslot = oldselfslot6767;
  stackframe = oldstackframe6767;
  gc_frame_end(frame);
  return obj6767;
}
Object meth_ast_identifierNode7150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for identifierNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for identifierNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_typeType7155(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_unknownType7159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for unknownType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for unknownType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_new_40__41_scope7162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7163 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call7164 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7163);
// compiled call node returning call7164 (depth = 4)
  *var_result = call7164;
  if (call7164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7165 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7166 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe7165);
// compiled call node returning call7166 (depth = 3)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_accept_40__41_from7172(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7173 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7174 = callmethod(*var_visitor, "visitString()up",
    2, partcv, params);
  gc_frame_end(callframe7173);
// compiled call node returning call7174 (depth = 3)
  gc_frame_end(frame);
  return call7174;
}
Object meth_ast_map_40__41_ancestors7175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7176 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7177 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7176);
// compiled call node returning call7177 (depth = 5)
// compiled member node returning call7177 (depth = 4)
  *var_n = call7177;
  if (call7177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7178 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7179 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7178);
// compiled call node returning call7179 (depth = 4)
  *var_newChain = call7179;
  if (call7179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7180 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7181 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7180);
// compiled call node returning call7181 (depth = 3)
  gc_frame_end(frame);
  return call7181;
}
Object meth_ast_pretty7182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7184 == NULL) {
    strlit7184 = alloc_String(")");
    gc_root(strlit7184);
  }
// compiled string node returning strlit7184 (depth = 4)
  int op_slot_right_7183 = gc_frame_newslot(strlit7184);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7187 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7188 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7187);
// compiled call node returning call7188 (depth = 6)
// compiled member node returning call7188 (depth = 5)
  int op_slot_right_7186 = gc_frame_newslot(call7188);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7191 == NULL) {
    strlit7191 = alloc_String("(");
    gc_root(strlit7191);
  }
// compiled string node returning strlit7191 (depth = 6)
  int op_slot_right_7190 = gc_frame_newslot(strlit7191);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7194 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7195 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7194);
// compiled call node returning call7195 (depth = 7)
  int op_slot_right_7193 = gc_frame_newslot(call7195);
// starting to compile string node (depth = 7)
  if (strlit7197 == NULL) {
    strlit7197 = alloc_String("");
    gc_root(strlit7197);
  }
// compiled string node returning strlit7197 (depth = 7)
  int op_slot_left_7193 = gc_frame_newslot(strlit7197);
  params[0] = call7195;
  partcv[0] = 1;
  Object opresult7198 = callmethod(strlit7197, "++", 1, partcv, params);
// compiled op node returning opresult7198 (depth = 6)
  int op_slot_left_7190 = gc_frame_newslot(opresult7198);
  params[0] = strlit7191;
  partcv[0] = 1;
  Object opresult7199 = callmethod(opresult7198, "++", 1, partcv, params);
// compiled op node returning opresult7199 (depth = 5)
  int op_slot_left_7186 = gc_frame_newslot(opresult7199);
  params[0] = call7188;
  partcv[0] = 1;
  Object opresult7200 = callmethod(opresult7199, "++", 1, partcv, params);
// compiled op node returning opresult7200 (depth = 4)
  int op_slot_left_7183 = gc_frame_newslot(opresult7200);
  params[0] = strlit7184;
  partcv[0] = 1;
  Object opresult7201 = callmethod(opresult7200, "++", 1, partcv, params);
// compiled op node returning opresult7201 (depth = 3)
  gc_frame_end(frame);
  return opresult7201;
}
Object meth_ast_toGrace7202(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_q = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "q");
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7203 == NULL) {
    strlit7203 = alloc_String("""\x22""");
    gc_root(strlit7203);
  }
// compiled string node returning strlit7203 (depth = 4)
  *var_q = strlit7203;
  if (strlit7203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_q (depth = 4)
  int op_slot_right_7204 = gc_frame_newslot(*var_q);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7207 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7208 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7209 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7208);
// compiled call node returning call7209 (depth = 8)
// compiled member node returning call7209 (depth = 7)
  partcv[0] = 0;
  Object call7210 = callmethod(call7209, "quoted",
    1, partcv, params);
  gc_frame_end(callframe7207);
// compiled call node returning call7210 (depth = 6)
// compiled member node returning call7210 (depth = 5)
  int op_slot_right_7206 = gc_frame_newslot(call7210);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_q (depth = 5)
  int op_slot_left_7206 = gc_frame_newslot(*var_q);
  params[0] = call7210;
  partcv[0] = 1;
  Object opresult7212 = callmethod(*var_q, "++", 1, partcv, params);
// compiled op node returning opresult7212 (depth = 4)
  int op_slot_left_7204 = gc_frame_newslot(opresult7212);
  params[0] = *var_q;
  partcv[0] = 1;
  Object opresult7213 = callmethod(opresult7212, "++", 1, partcv, params);
// compiled op node returning opresult7213 (depth = 3)
  gc_frame_end(frame);
  return opresult7213;
}
Object meth_ast_shallowCopy7214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7215 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7216 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7218 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7217);
// compiled call node returning call7218 (depth = 6)
// compiled member node returning call7218 (depth = 5)
  gc_frame_newslot(call7218);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringNode (depth = 5)
  params[0] = call7218;
  partcv[0] = 1;
  Object call7219 = callmethod(*var_stringNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7216);
// compiled call node returning call7219 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7220 = callmethod(call7219, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7215);
// compiled call node returning call7220 (depth = 3)
  gc_frame_end(frame);
  return call7220;
}
Object meth_ast_statementName7221(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7222 == NULL) {
    strlit7222 = alloc_String("expression");
    gc_root(strlit7222);
  }
// compiled string node returning strlit7222 (depth = 3)
  gc_frame_end(frame);
  return strlit7222;
}
Object meth_ast_new7167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7168 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7168 = alloc_userobj2(9,9, objclass7168);
  gc_frame_newslot(obj7168);
if (objclass7168 == NULL) {
  glfree(obj7168->class->name);
  obj7168->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7168, self, 0);
  addmethodreal(obj7168,"outer", &reader_ast_outer_7169);
  Object oldself7168 = self;
  struct StackFrameObject *oldstackframe7168 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7168);
  gc_frame_newslot((Object)stackframe);
  self = obj7168;
  Object *oldselfslot7168 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7168 = (*(struct UserObject *)self).data[0], lowerouter7168 = thisouter7168;
  if (inheritingObject7168) {
    struct UserObject *inho7168 = (struct UserObject *)inheritingObject7168;
    while (inho7168->super != GraceDefaultObject) inho7168 = (struct UserObject *)inho7168->super;
    inho7168->super = obj7168;
    self = inheritingObject7168;
    *selfslot = self;
    lowerouter7168 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7168;
  }
if (objclass7168 == NULL) {
  Method *reader7170 = addmethodrealflags(obj7168, "kind",&reader_ast_kind_7170, MFLAG_DEF);
  reader7170->definitionModule = modulename;
  reader7170->definitionLine = 1760;
}
adddatum2(obj7168, alloc_Undefined(), 1);
if (objclass7168 == NULL) {
  Method *reader7171 = addmethodrealflags(obj7168, "value",&reader_ast_value_7171, 0);
  Method *writer7171 = addmethodrealflags(obj7168, "value:=",&writer_ast_value_7171, 0);
  reader7171->definitionModule = modulename;
  writer7171->definitionModule = modulename;
  reader7171->definitionLine = 1761;
  writer7171->definitionLine = 1761;
}
obj7168->flags |= OFLAG_MUTABLE;
adddatum2(obj7168, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7172 = (struct UserObject*)obj7168;
  uo7172->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7172 = addmethod2pos(obj7168, "accept()from", &meth_ast_accept_40__41_from7172, 3);
  int argcv_meth_ast_accept_40__41_from7172[] = {1, 1};
  meth_meth_ast_accept_40__41_from7172->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7172);
  meth_meth_ast_accept_40__41_from7172->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7172->definitionLine = 1762;
// method "map()ancestors"
  struct UserObject *uo7175 = (struct UserObject*)obj7168;
  uo7175->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7175 = addmethod2pos(obj7168, "map()ancestors", &meth_ast_map_40__41_ancestors7175, 4);
  int argcv_meth_ast_map_40__41_ancestors7175[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7175->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7175);
  meth_meth_ast_map_40__41_ancestors7175->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7175->definitionLine = 1765;
// method "pretty"
  struct UserObject *uo7182 = (struct UserObject*)obj7168;
  uo7182->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7182 = addmethod2pos(obj7168, "pretty", &meth_ast_pretty7182, 5);
  int argcv_meth_ast_pretty7182[] = {1};
  meth_meth_ast_pretty7182->type = alloc_MethodType(1, argcv_meth_ast_pretty7182);
  meth_meth_ast_pretty7182->definitionModule = modulename;
  meth_meth_ast_pretty7182->definitionLine = 1770;
// method "toGrace"
  struct UserObject *uo7202 = (struct UserObject*)obj7168;
  uo7202->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7202 = addmethod2pos(obj7168, "toGrace", &meth_ast_toGrace7202, 6);
  int argcv_meth_ast_toGrace7202[] = {1};
  meth_meth_ast_toGrace7202->type = alloc_MethodType(1, argcv_meth_ast_toGrace7202);
meth_meth_ast_toGrace7202->type->types[0] = type_Number;
meth_meth_ast_toGrace7202->type->names[0] = "depth";
  meth_meth_ast_toGrace7202->definitionModule = modulename;
  meth_meth_ast_toGrace7202->definitionLine = 1773;
// method "shallowCopy"
  block_savedest(obj7168);
  Object closure7214 = createclosure(1, "shallowCopy");
  setclosureframe(closure7214, stackframe);
  addtoclosure(closure7214, var_stringNode);
  struct UserObject *uo7214 = (struct UserObject*)obj7168;
  uo7214->data[7] = (Object)closure7214;
  Method *meth_meth_ast_shallowCopy7214 = addmethod2pos(obj7168, "shallowCopy", &meth_ast_shallowCopy7214, 7);
  int argcv_meth_ast_shallowCopy7214[] = {0};
  meth_meth_ast_shallowCopy7214->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7214);
  meth_meth_ast_shallowCopy7214->definitionModule = modulename;
  meth_meth_ast_shallowCopy7214->definitionLine = 1777;
// method "statementName"
  struct UserObject *uo7221 = (struct UserObject*)obj7168;
  uo7221->data[8] = emptyclosure;
  Method *meth_meth_ast_statementName7221 = addmethod2pos(obj7168, "statementName", &meth_ast_statementName7221, 8);
  int argcv_meth_ast_statementName7221[] = {0};
  meth_meth_ast_statementName7221->type = alloc_MethodType(1, argcv_meth_ast_statementName7221);
  meth_meth_ast_statementName7221->definitionModule = modulename;
  meth_meth_ast_statementName7221->definitionLine = 1780;
  sourceObject = obj7168;
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7223 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7224 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7225 = gc_frame_new();
// call case 3: self.outer request
  Object call7226 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7225);
// compiled call node returning call7226 (depth = 7)
// compiled member node returning call7226 (depth = 6)
  partcv[0] = 0;
  Object call7227 = callmethodflags(call7226, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7224);
// compiled call node returning call7227 (depth = 5)
// compiled member node returning call7227 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7228 = callmethodflags(call7227, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7223);
// compiled call node returning call7228 (depth = 3)
  struct UserObject *obj7168_uo = (struct UserObject *)obj7168;
  obj7168_uo->super = call7228;
  sourceObject = obj7168;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7229 == NULL) {
    strlit7229 = alloc_String("string");
    gc_root(strlit7229);
  }
// compiled string node returning strlit7229 (depth = 3)
  adddatum2(obj7168, strlit7229, 1);
  sourceObject = obj7168;
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7168, *var_v, 2);
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  objclass7168 = obj7168->class;
  objclass7168->definitionModule = modulename;
  objclass7168->definitionLine = 1758;
  (*(struct UserObject *)self).data[0] = lowerouter7168;
  self = oldself7168;
  selfslot = oldselfslot7168;
  stackframe = oldstackframe7168;
  gc_frame_end(frame);
  return obj7168;
}
Object meth_ast_new7167_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7168 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7168 = alloc_userobj2(9,9, objclass7168);
  gc_frame_newslot(obj7168);
if (objclass7168 == NULL) {
  glfree(obj7168->class->name);
  obj7168->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7168, self, 0);
  addmethodreal(obj7168,"outer", &reader_ast_outer_7169);
  Object oldself7168 = self;
  struct StackFrameObject *oldstackframe7168 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7168);
  gc_frame_newslot((Object)stackframe);
  self = obj7168;
  Object *oldselfslot7168 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7168 = (*(struct UserObject *)self).data[0], lowerouter7168 = thisouter7168;
  if (inheritingObject7168) {
    struct UserObject *inho7168 = (struct UserObject *)inheritingObject7168;
    while (inho7168->super != GraceDefaultObject) inho7168 = (struct UserObject *)inho7168->super;
    inho7168->super = obj7168;
    self = inheritingObject7168;
    *selfslot = self;
    lowerouter7168 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7168;
  }
if (objclass7168 == NULL) {
  Method *reader7170 = addmethodrealflags(obj7168, "kind",&reader_ast_kind_7170, MFLAG_DEF);
  reader7170->definitionModule = modulename;
  reader7170->definitionLine = 1760;
}
adddatum2(obj7168, alloc_Undefined(), 1);
if (objclass7168 == NULL) {
  Method *reader7171 = addmethodrealflags(obj7168, "value",&reader_ast_value_7171, 0);
  Method *writer7171 = addmethodrealflags(obj7168, "value:=",&writer_ast_value_7171, 0);
  reader7171->definitionModule = modulename;
  writer7171->definitionModule = modulename;
  reader7171->definitionLine = 1761;
  writer7171->definitionLine = 1761;
}
obj7168->flags |= OFLAG_MUTABLE;
adddatum2(obj7168, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7172 = (struct UserObject*)obj7168;
  uo7172->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7172 = addmethod2pos(obj7168, "accept()from", &meth_ast_accept_40__41_from7172, 3);
  int argcv_meth_ast_accept_40__41_from7172[] = {1, 1};
  meth_meth_ast_accept_40__41_from7172->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7172);
  meth_meth_ast_accept_40__41_from7172->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7172->definitionLine = 1762;
// method "map()ancestors"
  struct UserObject *uo7175 = (struct UserObject*)obj7168;
  uo7175->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7175 = addmethod2pos(obj7168, "map()ancestors", &meth_ast_map_40__41_ancestors7175, 4);
  int argcv_meth_ast_map_40__41_ancestors7175[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7175->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7175);
  meth_meth_ast_map_40__41_ancestors7175->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7175->definitionLine = 1765;
// method "pretty"
  struct UserObject *uo7182 = (struct UserObject*)obj7168;
  uo7182->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7182 = addmethod2pos(obj7168, "pretty", &meth_ast_pretty7182, 5);
  int argcv_meth_ast_pretty7182[] = {1};
  meth_meth_ast_pretty7182->type = alloc_MethodType(1, argcv_meth_ast_pretty7182);
  meth_meth_ast_pretty7182->definitionModule = modulename;
  meth_meth_ast_pretty7182->definitionLine = 1770;
// method "toGrace"
  struct UserObject *uo7202 = (struct UserObject*)obj7168;
  uo7202->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7202 = addmethod2pos(obj7168, "toGrace", &meth_ast_toGrace7202, 6);
  int argcv_meth_ast_toGrace7202[] = {1};
  meth_meth_ast_toGrace7202->type = alloc_MethodType(1, argcv_meth_ast_toGrace7202);
meth_meth_ast_toGrace7202->type->types[0] = type_Number;
meth_meth_ast_toGrace7202->type->names[0] = "depth";
  meth_meth_ast_toGrace7202->definitionModule = modulename;
  meth_meth_ast_toGrace7202->definitionLine = 1773;
// method "shallowCopy"
  block_savedest(obj7168);
  Object closure7214 = createclosure(1, "shallowCopy");
  setclosureframe(closure7214, stackframe);
  addtoclosure(closure7214, var_stringNode);
  struct UserObject *uo7214 = (struct UserObject*)obj7168;
  uo7214->data[7] = (Object)closure7214;
  Method *meth_meth_ast_shallowCopy7214 = addmethod2pos(obj7168, "shallowCopy", &meth_ast_shallowCopy7214, 7);
  int argcv_meth_ast_shallowCopy7214[] = {0};
  meth_meth_ast_shallowCopy7214->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7214);
  meth_meth_ast_shallowCopy7214->definitionModule = modulename;
  meth_meth_ast_shallowCopy7214->definitionLine = 1777;
// method "statementName"
  struct UserObject *uo7221 = (struct UserObject*)obj7168;
  uo7221->data[8] = emptyclosure;
  Method *meth_meth_ast_statementName7221 = addmethod2pos(obj7168, "statementName", &meth_ast_statementName7221, 8);
  int argcv_meth_ast_statementName7221[] = {0};
  meth_meth_ast_statementName7221->type = alloc_MethodType(1, argcv_meth_ast_statementName7221);
  meth_meth_ast_statementName7221->definitionModule = modulename;
  meth_meth_ast_statementName7221->definitionLine = 1780;
  sourceObject = obj7168;
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7223 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7224 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7225 = gc_frame_new();
// call case 3: self.outer request
  Object call7226 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7225);
// compiled call node returning call7226 (depth = 7)
// compiled member node returning call7226 (depth = 6)
  partcv[0] = 0;
  Object call7227 = callmethodflags(call7226, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7224);
// compiled call node returning call7227 (depth = 5)
// compiled member node returning call7227 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7228 = callmethodflags(call7227, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7223);
// compiled call node returning call7228 (depth = 3)
  struct UserObject *obj7168_uo = (struct UserObject *)obj7168;
  obj7168_uo->super = call7228;
  sourceObject = obj7168;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7229 == NULL) {
    strlit7229 = alloc_String("string");
    gc_root(strlit7229);
  }
// compiled string node returning strlit7229 (depth = 3)
  adddatum2(obj7168, strlit7229, 1);
  sourceObject = obj7168;
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7168, *var_v, 2);
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  sourceObject = obj7168;
  objclass7168 = obj7168->class;
  objclass7168->definitionModule = modulename;
  objclass7168->definitionLine = 1758;
  (*(struct UserObject *)self).data[0] = lowerouter7168;
  self = oldself7168;
  selfslot = oldselfslot7168;
  stackframe = oldstackframe7168;
  gc_frame_end(frame);
  return obj7168;
}
Object meth_ast_stringNode7231(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for stringNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for stringNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept_40__41_from7239(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7240 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7241 = callmethod(*var_visitor, "visitNum()up",
    2, partcv, params);
  gc_frame_end(callframe7240);
// compiled call node returning call7241 (depth = 3)
  gc_frame_end(frame);
  return call7241;
}
Object meth_ast_map_40__41_ancestors7242(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7243 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7244 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7243);
// compiled call node returning call7244 (depth = 5)
// compiled member node returning call7244 (depth = 4)
  *var_n = call7244;
  if (call7244 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7245 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7246 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7245);
// compiled call node returning call7246 (depth = 4)
  *var_newChain = call7246;
  if (call7246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7247 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7248 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7247);
// compiled call node returning call7248 (depth = 3)
  gc_frame_end(frame);
  return call7248;
}
Object meth_ast_pretty7249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7251 == NULL) {
    strlit7251 = alloc_String(")");
    gc_root(strlit7251);
  }
// compiled string node returning strlit7251 (depth = 4)
  int op_slot_right_7250 = gc_frame_newslot(strlit7251);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7255 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7254);
// compiled call node returning call7255 (depth = 6)
// compiled member node returning call7255 (depth = 5)
  int op_slot_right_7253 = gc_frame_newslot(call7255);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7258 == NULL) {
    strlit7258 = alloc_String("(");
    gc_root(strlit7258);
  }
// compiled string node returning strlit7258 (depth = 6)
  int op_slot_right_7257 = gc_frame_newslot(strlit7258);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7261 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7262 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7261);
// compiled call node returning call7262 (depth = 7)
  int op_slot_right_7260 = gc_frame_newslot(call7262);
// starting to compile string node (depth = 7)
  if (strlit7264 == NULL) {
    strlit7264 = alloc_String("");
    gc_root(strlit7264);
  }
// compiled string node returning strlit7264 (depth = 7)
  int op_slot_left_7260 = gc_frame_newslot(strlit7264);
  params[0] = call7262;
  partcv[0] = 1;
  Object opresult7265 = callmethod(strlit7264, "++", 1, partcv, params);
// compiled op node returning opresult7265 (depth = 6)
  int op_slot_left_7257 = gc_frame_newslot(opresult7265);
  params[0] = strlit7258;
  partcv[0] = 1;
  Object opresult7266 = callmethod(opresult7265, "++", 1, partcv, params);
// compiled op node returning opresult7266 (depth = 5)
  int op_slot_left_7253 = gc_frame_newslot(opresult7266);
  params[0] = call7255;
  partcv[0] = 1;
  Object opresult7267 = callmethod(opresult7266, "++", 1, partcv, params);
// compiled op node returning opresult7267 (depth = 4)
  int op_slot_left_7250 = gc_frame_newslot(opresult7267);
  params[0] = strlit7251;
  partcv[0] = 1;
  Object opresult7268 = callmethod(opresult7267, "++", 1, partcv, params);
// compiled op node returning opresult7268 (depth = 3)
  gc_frame_end(frame);
  return opresult7268;
}
Object meth_ast_toGrace7269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7270 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7272 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7271);
// compiled call node returning call7272 (depth = 6)
// compiled member node returning call7272 (depth = 5)
  partcv[0] = 0;
  Object call7273 = callmethod(call7272, "asString",
    1, partcv, params);
  gc_frame_end(callframe7270);
// compiled call node returning call7273 (depth = 4)
// compiled member node returning call7273 (depth = 3)
  gc_frame_end(frame);
  return call7273;
}
Object meth_ast_asString7274(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7276 == NULL) {
    strlit7276 = alloc_String("");
    gc_root(strlit7276);
  }
// compiled string node returning strlit7276 (depth = 4)
  int op_slot_right_7275 = gc_frame_newslot(strlit7276);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7279 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7280 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7279);
// compiled call node returning call7280 (depth = 6)
// compiled member node returning call7280 (depth = 5)
  int op_slot_right_7278 = gc_frame_newslot(call7280);
// starting to compile string node (depth = 5)
  if (strlit7282 == NULL) {
    strlit7282 = alloc_String("num ");
    gc_root(strlit7282);
  }
// compiled string node returning strlit7282 (depth = 5)
  int op_slot_left_7278 = gc_frame_newslot(strlit7282);
  params[0] = call7280;
  partcv[0] = 1;
  Object opresult7283 = callmethod(strlit7282, "++", 1, partcv, params);
// compiled op node returning opresult7283 (depth = 4)
  int op_slot_left_7275 = gc_frame_newslot(opresult7283);
  params[0] = strlit7276;
  partcv[0] = 1;
  Object opresult7284 = callmethod(opresult7283, "++", 1, partcv, params);
// compiled op node returning opresult7284 (depth = 3)
  gc_frame_end(frame);
  return opresult7284;
}
Object meth_ast_shallowCopy7285(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7286 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7287 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7288 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7289 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7288);
// compiled call node returning call7289 (depth = 6)
// compiled member node returning call7289 (depth = 5)
  gc_frame_newslot(call7289);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_numNode (depth = 5)
  params[0] = call7289;
  partcv[0] = 1;
  Object call7290 = callmethod(*var_numNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7287);
// compiled call node returning call7290 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7291 = callmethod(call7290, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7286);
// compiled call node returning call7291 (depth = 3)
  gc_frame_end(frame);
  return call7291;
}
Object meth_ast_statementName7292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7293 == NULL) {
    strlit7293 = alloc_String("expression");
    gc_root(strlit7293);
  }
// compiled string node returning strlit7293 (depth = 3)
  gc_frame_end(frame);
  return strlit7293;
}
Object meth_ast_new7234(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7235 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7235 = alloc_userobj2(10,10, objclass7235);
  gc_frame_newslot(obj7235);
if (objclass7235 == NULL) {
  glfree(obj7235->class->name);
  obj7235->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7235, self, 0);
  addmethodreal(obj7235,"outer", &reader_ast_outer_7236);
  Object oldself7235 = self;
  struct StackFrameObject *oldstackframe7235 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7235);
  gc_frame_newslot((Object)stackframe);
  self = obj7235;
  Object *oldselfslot7235 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7235 = (*(struct UserObject *)self).data[0], lowerouter7235 = thisouter7235;
  if (inheritingObject7235) {
    struct UserObject *inho7235 = (struct UserObject *)inheritingObject7235;
    while (inho7235->super != GraceDefaultObject) inho7235 = (struct UserObject *)inho7235->super;
    inho7235->super = obj7235;
    self = inheritingObject7235;
    *selfslot = self;
    lowerouter7235 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7235;
  }
if (objclass7235 == NULL) {
  Method *reader7237 = addmethodrealflags(obj7235, "kind",&reader_ast_kind_7237, MFLAG_DEF);
  reader7237->definitionModule = modulename;
  reader7237->definitionLine = 1786;
}
adddatum2(obj7235, alloc_Undefined(), 1);
if (objclass7235 == NULL) {
  Method *reader7238 = addmethodrealflags(obj7235, "value",&reader_ast_value_7238, 0);
  Method *writer7238 = addmethodrealflags(obj7235, "value:=",&writer_ast_value_7238, 0);
  reader7238->definitionModule = modulename;
  writer7238->definitionModule = modulename;
  reader7238->definitionLine = 1787;
  writer7238->definitionLine = 1787;
}
obj7235->flags |= OFLAG_MUTABLE;
adddatum2(obj7235, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7239 = (struct UserObject*)obj7235;
  uo7239->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7239 = addmethod2pos(obj7235, "accept()from", &meth_ast_accept_40__41_from7239, 3);
  int argcv_meth_ast_accept_40__41_from7239[] = {1, 1};
  meth_meth_ast_accept_40__41_from7239->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7239);
  meth_meth_ast_accept_40__41_from7239->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7239->definitionLine = 1788;
// method "map()ancestors"
  struct UserObject *uo7242 = (struct UserObject*)obj7235;
  uo7242->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7242 = addmethod2pos(obj7235, "map()ancestors", &meth_ast_map_40__41_ancestors7242, 4);
  int argcv_meth_ast_map_40__41_ancestors7242[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7242->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7242);
  meth_meth_ast_map_40__41_ancestors7242->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7242->definitionLine = 1791;
// method "pretty"
  struct UserObject *uo7249 = (struct UserObject*)obj7235;
  uo7249->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7249 = addmethod2pos(obj7235, "pretty", &meth_ast_pretty7249, 5);
  int argcv_meth_ast_pretty7249[] = {1};
  meth_meth_ast_pretty7249->type = alloc_MethodType(1, argcv_meth_ast_pretty7249);
  meth_meth_ast_pretty7249->definitionModule = modulename;
  meth_meth_ast_pretty7249->definitionLine = 1796;
// method "toGrace"
  struct UserObject *uo7269 = (struct UserObject*)obj7235;
  uo7269->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7269 = addmethod2pos(obj7235, "toGrace", &meth_ast_toGrace7269, 6);
  int argcv_meth_ast_toGrace7269[] = {1};
  meth_meth_ast_toGrace7269->type = alloc_MethodType(1, argcv_meth_ast_toGrace7269);
meth_meth_ast_toGrace7269->type->types[0] = type_Number;
meth_meth_ast_toGrace7269->type->names[0] = "depth";
  meth_meth_ast_toGrace7269->definitionModule = modulename;
  meth_meth_ast_toGrace7269->definitionLine = 1799;
// method "asString"
  struct UserObject *uo7274 = (struct UserObject*)obj7235;
  uo7274->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7274 = addmethod2pos(obj7235, "asString", &meth_ast_asString7274, 7);
  int argcv_meth_ast_asString7274[] = {0};
  meth_meth_ast_asString7274->type = alloc_MethodType(1, argcv_meth_ast_asString7274);
  meth_meth_ast_asString7274->definitionModule = modulename;
  meth_meth_ast_asString7274->definitionLine = 1802;
// method "shallowCopy"
  block_savedest(obj7235);
  Object closure7285 = createclosure(1, "shallowCopy");
  setclosureframe(closure7285, stackframe);
  addtoclosure(closure7285, var_numNode);
  struct UserObject *uo7285 = (struct UserObject*)obj7235;
  uo7285->data[8] = (Object)closure7285;
  Method *meth_meth_ast_shallowCopy7285 = addmethod2pos(obj7235, "shallowCopy", &meth_ast_shallowCopy7285, 8);
  int argcv_meth_ast_shallowCopy7285[] = {0};
  meth_meth_ast_shallowCopy7285->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7285);
  meth_meth_ast_shallowCopy7285->definitionModule = modulename;
  meth_meth_ast_shallowCopy7285->definitionLine = 1803;
// method "statementName"
  struct UserObject *uo7292 = (struct UserObject*)obj7235;
  uo7292->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7292 = addmethod2pos(obj7235, "statementName", &meth_ast_statementName7292, 9);
  int argcv_meth_ast_statementName7292[] = {0};
  meth_meth_ast_statementName7292->type = alloc_MethodType(1, argcv_meth_ast_statementName7292);
  meth_meth_ast_statementName7292->definitionModule = modulename;
  meth_meth_ast_statementName7292->definitionLine = 1806;
  sourceObject = obj7235;
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7294 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7295 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7296 = gc_frame_new();
// call case 3: self.outer request
  Object call7297 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7296);
// compiled call node returning call7297 (depth = 7)
// compiled member node returning call7297 (depth = 6)
  partcv[0] = 0;
  Object call7298 = callmethodflags(call7297, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7295);
// compiled call node returning call7298 (depth = 5)
// compiled member node returning call7298 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7299 = callmethodflags(call7298, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7294);
// compiled call node returning call7299 (depth = 3)
  struct UserObject *obj7235_uo = (struct UserObject *)obj7235;
  obj7235_uo->super = call7299;
  sourceObject = obj7235;
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7300 == NULL) {
    strlit7300 = alloc_String("num");
    gc_root(strlit7300);
  }
// compiled string node returning strlit7300 (depth = 3)
  adddatum2(obj7235, strlit7300, 1);
  sourceObject = obj7235;
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7235, *var_val, 2);
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  objclass7235 = obj7235->class;
  objclass7235->definitionModule = modulename;
  objclass7235->definitionLine = 1784;
  (*(struct UserObject *)self).data[0] = lowerouter7235;
  self = oldself7235;
  selfslot = oldselfslot7235;
  stackframe = oldstackframe7235;
  gc_frame_end(frame);
  return obj7235;
}
Object meth_ast_new7234_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7235 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7235 = alloc_userobj2(10,10, objclass7235);
  gc_frame_newslot(obj7235);
if (objclass7235 == NULL) {
  glfree(obj7235->class->name);
  obj7235->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7235, self, 0);
  addmethodreal(obj7235,"outer", &reader_ast_outer_7236);
  Object oldself7235 = self;
  struct StackFrameObject *oldstackframe7235 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7235);
  gc_frame_newslot((Object)stackframe);
  self = obj7235;
  Object *oldselfslot7235 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7235 = (*(struct UserObject *)self).data[0], lowerouter7235 = thisouter7235;
  if (inheritingObject7235) {
    struct UserObject *inho7235 = (struct UserObject *)inheritingObject7235;
    while (inho7235->super != GraceDefaultObject) inho7235 = (struct UserObject *)inho7235->super;
    inho7235->super = obj7235;
    self = inheritingObject7235;
    *selfslot = self;
    lowerouter7235 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7235;
  }
if (objclass7235 == NULL) {
  Method *reader7237 = addmethodrealflags(obj7235, "kind",&reader_ast_kind_7237, MFLAG_DEF);
  reader7237->definitionModule = modulename;
  reader7237->definitionLine = 1786;
}
adddatum2(obj7235, alloc_Undefined(), 1);
if (objclass7235 == NULL) {
  Method *reader7238 = addmethodrealflags(obj7235, "value",&reader_ast_value_7238, 0);
  Method *writer7238 = addmethodrealflags(obj7235, "value:=",&writer_ast_value_7238, 0);
  reader7238->definitionModule = modulename;
  writer7238->definitionModule = modulename;
  reader7238->definitionLine = 1787;
  writer7238->definitionLine = 1787;
}
obj7235->flags |= OFLAG_MUTABLE;
adddatum2(obj7235, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7239 = (struct UserObject*)obj7235;
  uo7239->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7239 = addmethod2pos(obj7235, "accept()from", &meth_ast_accept_40__41_from7239, 3);
  int argcv_meth_ast_accept_40__41_from7239[] = {1, 1};
  meth_meth_ast_accept_40__41_from7239->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7239);
  meth_meth_ast_accept_40__41_from7239->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7239->definitionLine = 1788;
// method "map()ancestors"
  struct UserObject *uo7242 = (struct UserObject*)obj7235;
  uo7242->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7242 = addmethod2pos(obj7235, "map()ancestors", &meth_ast_map_40__41_ancestors7242, 4);
  int argcv_meth_ast_map_40__41_ancestors7242[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7242->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7242);
  meth_meth_ast_map_40__41_ancestors7242->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7242->definitionLine = 1791;
// method "pretty"
  struct UserObject *uo7249 = (struct UserObject*)obj7235;
  uo7249->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7249 = addmethod2pos(obj7235, "pretty", &meth_ast_pretty7249, 5);
  int argcv_meth_ast_pretty7249[] = {1};
  meth_meth_ast_pretty7249->type = alloc_MethodType(1, argcv_meth_ast_pretty7249);
  meth_meth_ast_pretty7249->definitionModule = modulename;
  meth_meth_ast_pretty7249->definitionLine = 1796;
// method "toGrace"
  struct UserObject *uo7269 = (struct UserObject*)obj7235;
  uo7269->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7269 = addmethod2pos(obj7235, "toGrace", &meth_ast_toGrace7269, 6);
  int argcv_meth_ast_toGrace7269[] = {1};
  meth_meth_ast_toGrace7269->type = alloc_MethodType(1, argcv_meth_ast_toGrace7269);
meth_meth_ast_toGrace7269->type->types[0] = type_Number;
meth_meth_ast_toGrace7269->type->names[0] = "depth";
  meth_meth_ast_toGrace7269->definitionModule = modulename;
  meth_meth_ast_toGrace7269->definitionLine = 1799;
// method "asString"
  struct UserObject *uo7274 = (struct UserObject*)obj7235;
  uo7274->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7274 = addmethod2pos(obj7235, "asString", &meth_ast_asString7274, 7);
  int argcv_meth_ast_asString7274[] = {0};
  meth_meth_ast_asString7274->type = alloc_MethodType(1, argcv_meth_ast_asString7274);
  meth_meth_ast_asString7274->definitionModule = modulename;
  meth_meth_ast_asString7274->definitionLine = 1802;
// method "shallowCopy"
  block_savedest(obj7235);
  Object closure7285 = createclosure(1, "shallowCopy");
  setclosureframe(closure7285, stackframe);
  addtoclosure(closure7285, var_numNode);
  struct UserObject *uo7285 = (struct UserObject*)obj7235;
  uo7285->data[8] = (Object)closure7285;
  Method *meth_meth_ast_shallowCopy7285 = addmethod2pos(obj7235, "shallowCopy", &meth_ast_shallowCopy7285, 8);
  int argcv_meth_ast_shallowCopy7285[] = {0};
  meth_meth_ast_shallowCopy7285->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7285);
  meth_meth_ast_shallowCopy7285->definitionModule = modulename;
  meth_meth_ast_shallowCopy7285->definitionLine = 1803;
// method "statementName"
  struct UserObject *uo7292 = (struct UserObject*)obj7235;
  uo7292->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7292 = addmethod2pos(obj7235, "statementName", &meth_ast_statementName7292, 9);
  int argcv_meth_ast_statementName7292[] = {0};
  meth_meth_ast_statementName7292->type = alloc_MethodType(1, argcv_meth_ast_statementName7292);
  meth_meth_ast_statementName7292->definitionModule = modulename;
  meth_meth_ast_statementName7292->definitionLine = 1806;
  sourceObject = obj7235;
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7294 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7295 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7296 = gc_frame_new();
// call case 3: self.outer request
  Object call7297 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7296);
// compiled call node returning call7297 (depth = 7)
// compiled member node returning call7297 (depth = 6)
  partcv[0] = 0;
  Object call7298 = callmethodflags(call7297, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7295);
// compiled call node returning call7298 (depth = 5)
// compiled member node returning call7298 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7299 = callmethodflags(call7298, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7294);
// compiled call node returning call7299 (depth = 3)
  struct UserObject *obj7235_uo = (struct UserObject *)obj7235;
  obj7235_uo->super = call7299;
  sourceObject = obj7235;
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7300 == NULL) {
    strlit7300 = alloc_String("num");
    gc_root(strlit7300);
  }
// compiled string node returning strlit7300 (depth = 3)
  adddatum2(obj7235, strlit7300, 1);
  sourceObject = obj7235;
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7235, *var_val, 2);
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  sourceObject = obj7235;
  objclass7235 = obj7235->class;
  objclass7235->definitionModule = modulename;
  objclass7235->definitionLine = 1784;
  (*(struct UserObject *)self).data[0] = lowerouter7235;
  self = oldself7235;
  selfslot = oldselfslot7235;
  stackframe = oldstackframe7235;
  gc_frame_end(frame);
  return obj7235;
}
Object meth_ast_numNode7302(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for numNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for numNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_isSimple7312(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7313 = alloc_Boolean(0);
// compiled identifier node returning bool7313 (depth = 3)
  gc_frame_end(frame);
  return bool7313;
}
Object meth_ast_nameString7314(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7316 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7315);
// compiled call node returning call7316 (depth = 4)
// compiled member node returning call7316 (depth = 3)
  gc_frame_end(frame);
  return call7316;
}
Object meth_ast_accept_40__41_from7317(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7319 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7320 = callmethod(*var_visitor, "visitOp()up",
    2, partcv, params);
  gc_frame_end(callframe7319);
// compiled call node returning call7320 (depth = 4)
  Object if7318 = done;
  if (istrue(call7320)) {
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7321 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7322 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7321);
// compiled call node returning call7322 (depth = 5)
  *var_newChain = call7322;
  if (call7322 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7323 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7325 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7324);
// compiled call node returning call7325 (depth = 6)
// compiled member node returning call7325 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7326 = callmethod(call7325, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7323);
// compiled call node returning call7326 (depth = 4)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7327 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7329 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7328);
// compiled call node returning call7329 (depth = 6)
// compiled member node returning call7329 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7330 = callmethod(call7329, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7327);
// compiled call node returning call7330 (depth = 4)
    gc_frame_newslot(call7330);
    if7318 = call7330;
  } else {
  }
// compiled if node returning if7318 (depth = 3)
  gc_frame_end(frame);
  return if7318;
}
Object meth_ast_map_40__41_ancestors7331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7333 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7332);
// compiled call node returning call7333 (depth = 5)
// compiled member node returning call7333 (depth = 4)
  *var_n = call7333;
  if (call7333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7334 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7335 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7334);
// compiled call node returning call7335 (depth = 4)
  *var_newChain = call7335;
  if (call7335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7336 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7337 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7339 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7338);
// compiled call node returning call7339 (depth = 6)
// compiled member node returning call7339 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7340 = callmethod(call7339, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7337);
// compiled call node returning call7340 (depth = 4)
  gc_frame_newslot(call7340);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7340;
  partcv[0] = 1;
  Object call7341 = callmethod(*var_n, "left:=",
    1, partcv, params);
  gc_frame_end(callframe7336);
// compiled call node returning call7341 (depth = 3)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7342 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7343 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7345 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7344);
// compiled call node returning call7345 (depth = 6)
// compiled member node returning call7345 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7346 = callmethod(call7345, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7343);
// compiled call node returning call7346 (depth = 4)
  gc_frame_newslot(call7346);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7346;
  partcv[0] = 1;
  Object call7347 = callmethod(*var_n, "right:=",
    1, partcv, params);
  gc_frame_end(callframe7342);
// compiled call node returning call7347 (depth = 3)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7348 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7349 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7348);
// compiled call node returning call7349 (depth = 3)
  gc_frame_end(frame);
  return call7349;
}
Object meth_ast__apply7358(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7360 == NULL) {
    strlit7360 = alloc_String("  ");
    gc_root(strlit7360);
  }
// compiled string node returning strlit7360 (depth = 7)
  int op_slot_right_7359 = gc_frame_newslot(strlit7360);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7359 = gc_frame_newslot(*var_spc);
  params[0] = strlit7360;
  partcv[0] = 1;
  Object opresult7362 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7362 (depth = 6)
  *var_spc = opresult7362;
  if (opresult7362 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7351 == NULL) {
    strlit7351 = alloc_String("");
    gc_root(strlit7351);
  }
// compiled string node returning strlit7351 (depth = 4)
  *var_spc = strlit7351;
  if (strlit7351 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7352 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7353 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7355 = alloc_Float64(0);
// compiled num node returning num7355 (depth = 5)
  int op_slot_left_7353 = gc_frame_newslot(num7355);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7356 = callmethod(num7355, "..", 1, partcv, params);
// compiled op node returning opresult7356 (depth = 4)
  gc_frame_newslot(opresult7356);
// starting to compile block node (depth = 4)
  Object block7357 = alloc_Block(NULL, NULL, "ast", 1834);
  gc_frame_newslot(block7357);
// method "_apply"
  block_savedest(block7357);
  Object closure7358 = createclosure(2, "_apply");
  setclosureframe(closure7358, stackframe);
  addtoclosure(closure7358, var_spc);
  addtoclosure(closure7358, selfslot);
  struct UserObject *uo7358 = (struct UserObject*)block7357;
  uo7358->data[0] = (Object)closure7358;
  Method *meth_meth_ast__apply7358 = addmethod2pos(block7357, "_apply", &meth_ast__apply7358, 0);
  int argcv_meth_ast__apply7358[] = {1};
  meth_meth_ast__apply7358->type = alloc_MethodType(1, argcv_meth_ast__apply7358);
  meth_meth_ast__apply7358->definitionModule = modulename;
  meth_meth_ast__apply7358->definitionLine = 1829;
// compiled block node returning block7357 (depth = 4)
  gc_frame_newslot(block7357);
// call case 5: prelude request
  params[0] = opresult7356;
  params[1] = block7357;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7365 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7352);
// compiled call node returning call7365 (depth = 3)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7367 == NULL) {
    strlit7367 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7367);
  }
// compiled string node returning strlit7367 (depth = 5)
  int op_slot_right_7366 = gc_frame_newslot(strlit7367);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7371 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7370);
// compiled call node returning call7371 (depth = 7)
// compiled member node returning call7371 (depth = 6)
  int op_slot_right_7369 = gc_frame_newslot(call7371);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7374 == NULL) {
    strlit7374 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7374);
  }
// compiled string node returning strlit7374 (depth = 7)
  int op_slot_right_7373 = gc_frame_newslot(strlit7374);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7377 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7378 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7377);
// compiled call node returning call7378 (depth = 8)
  int op_slot_right_7376 = gc_frame_newslot(call7378);
// starting to compile string node (depth = 8)
  if (strlit7380 == NULL) {
    strlit7380 = alloc_String("");
    gc_root(strlit7380);
  }
// compiled string node returning strlit7380 (depth = 8)
  int op_slot_left_7376 = gc_frame_newslot(strlit7380);
  params[0] = call7378;
  partcv[0] = 1;
  Object opresult7381 = callmethod(strlit7380, "++", 1, partcv, params);
// compiled op node returning opresult7381 (depth = 7)
  int op_slot_left_7373 = gc_frame_newslot(opresult7381);
  params[0] = strlit7374;
  partcv[0] = 1;
  Object opresult7382 = callmethod(opresult7381, "++", 1, partcv, params);
// compiled op node returning opresult7382 (depth = 6)
  int op_slot_left_7369 = gc_frame_newslot(opresult7382);
  params[0] = call7371;
  partcv[0] = 1;
  Object opresult7383 = callmethod(opresult7382, "++", 1, partcv, params);
// compiled op node returning opresult7383 (depth = 5)
  int op_slot_left_7366 = gc_frame_newslot(opresult7383);
  params[0] = strlit7367;
  partcv[0] = 1;
  Object opresult7384 = callmethod(opresult7383, "++", 1, partcv, params);
// compiled op node returning opresult7384 (depth = 4)
  *var_s = opresult7384;
  if (opresult7384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7386 == NULL) {
    strlit7386 = alloc_String("""\x0a""");
    gc_root(strlit7386);
  }
// compiled string node returning strlit7386 (depth = 5)
  int op_slot_right_7385 = gc_frame_newslot(strlit7386);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7385 = gc_frame_newslot(*var_s);
  params[0] = strlit7386;
  partcv[0] = 1;
  Object opresult7388 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7388 (depth = 4)
  *var_s = opresult7388;
  if (opresult7388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7391 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7393 = alloc_Float64(1);
// compiled num node returning num7393 (depth = 7)
  int op_slot_right_7392 = gc_frame_newslot(num7393);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7392 = gc_frame_newslot(*var_depth);
  params[0] = num7393;
  partcv[0] = 1;
  Object sum7395 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7395 (depth = 6)
  gc_frame_newslot(sum7395);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7397 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7396);
// compiled call node returning call7397 (depth = 7)
// compiled member node returning call7397 (depth = 6)
  params[0] = sum7395;
  partcv[0] = 1;
  Object call7398 = callmethod(call7397, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7391);
// compiled call node returning call7398 (depth = 5)
  int op_slot_right_7390 = gc_frame_newslot(call7398);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7400 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7400 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7402 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7402 (depth = 5)
  int op_slot_left_7390 = gc_frame_newslot(opresult7402);
  params[0] = call7398;
  partcv[0] = 1;
  Object opresult7403 = callmethod(opresult7402, "++", 1, partcv, params);
// compiled op node returning opresult7403 (depth = 4)
  *var_s = opresult7403;
  if (opresult7403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7406 == NULL) {
    strlit7406 = alloc_String("""\x0a""");
    gc_root(strlit7406);
  }
// compiled string node returning strlit7406 (depth = 5)
  int op_slot_right_7405 = gc_frame_newslot(strlit7406);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7405 = gc_frame_newslot(*var_s);
  params[0] = strlit7406;
  partcv[0] = 1;
  Object opresult7408 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7408 (depth = 4)
  *var_s = opresult7408;
  if (opresult7408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7411 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7413 = alloc_Float64(1);
// compiled num node returning num7413 (depth = 7)
  int op_slot_right_7412 = gc_frame_newslot(num7413);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7412 = gc_frame_newslot(*var_depth);
  params[0] = num7413;
  partcv[0] = 1;
  Object sum7415 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7415 (depth = 6)
  gc_frame_newslot(sum7415);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7417 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7416);
// compiled call node returning call7417 (depth = 7)
// compiled member node returning call7417 (depth = 6)
  params[0] = sum7415;
  partcv[0] = 1;
  Object call7418 = callmethod(call7417, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7411);
// compiled call node returning call7418 (depth = 5)
  int op_slot_right_7410 = gc_frame_newslot(call7418);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7420 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7420 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7422 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7422 (depth = 5)
  int op_slot_left_7410 = gc_frame_newslot(opresult7422);
  params[0] = call7418;
  partcv[0] = 1;
  Object opresult7423 = callmethod(opresult7422, "++", 1, partcv, params);
// compiled op node returning opresult7423 (depth = 4)
  *var_s = opresult7423;
  if (opresult7423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7425(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7426 == NULL) {
    strlit7426 = alloc_String("");
    gc_root(strlit7426);
  }
// compiled string node returning strlit7426 (depth = 4)
  *var_s = strlit7426;
  if (strlit7426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7430 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7431 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7430);
// compiled call node returning call7431 (depth = 7)
// compiled member node returning call7431 (depth = 6)
  int op_slot_right_7429 = gc_frame_newslot(call7431);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7433 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7434 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7435 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7434);
// compiled call node returning call7435 (depth = 9)
// compiled member node returning call7435 (depth = 8)
  partcv[0] = 0;
  Object call7436 = callmethod(call7435, "value",
    1, partcv, params);
  gc_frame_end(callframe7433);
// compiled call node returning call7436 (depth = 7)
// compiled member node returning call7436 (depth = 6)
  int op_slot_left_7429 = gc_frame_newslot(call7436);
  params[0] = call7431;
  partcv[0] = 1;
  Object opresult7437 = callmethod(call7436, "!=", 1, partcv, params);
// compiled op node returning opresult7437 (depth = 5)
  int op_slot_right_7428 = gc_frame_newslot(opresult7437);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7440 == NULL) {
    strlit7440 = alloc_String("op");
    gc_root(strlit7440);
  }
// compiled string node returning strlit7440 (depth = 6)
  int op_slot_right_7439 = gc_frame_newslot(strlit7440);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7442 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7443 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7444 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7443);
// compiled call node returning call7444 (depth = 9)
// compiled member node returning call7444 (depth = 8)
  partcv[0] = 0;
  Object call7445 = callmethod(call7444, "kind",
    1, partcv, params);
  gc_frame_end(callframe7442);
// compiled call node returning call7445 (depth = 7)
// compiled member node returning call7445 (depth = 6)
  int op_slot_left_7439 = gc_frame_newslot(call7445);
  params[0] = strlit7440;
  partcv[0] = 1;
  Object opresult7446 = callmethod(call7445, "==", 1, partcv, params);
// compiled op node returning opresult7446 (depth = 5)
  int op_slot_left_7428 = gc_frame_newslot(opresult7446);
  params[0] = opresult7437;
  partcv[0] = 1;
  Object opresult7447 = callmethod(opresult7446, "&&", 1, partcv, params);
// compiled op node returning opresult7447 (depth = 4)
  Object if7427 = done;
  if (istrue(opresult7447)) {
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7449 == NULL) {
    strlit7449 = alloc_String(")");
    gc_root(strlit7449);
  }
// compiled string node returning strlit7449 (depth = 6)
  int op_slot_right_7448 = gc_frame_newslot(strlit7449);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7452 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7453 = alloc_Float64(0);
// compiled num node returning num7453 (depth = 8)
  gc_frame_newslot(num7453);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7455 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7454);
// compiled call node returning call7455 (depth = 9)
// compiled member node returning call7455 (depth = 8)
  params[0] = num7453;
  partcv[0] = 1;
  Object call7456 = callmethod(call7455, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7452);
// compiled call node returning call7456 (depth = 7)
  int op_slot_right_7451 = gc_frame_newslot(call7456);
// starting to compile string node (depth = 7)
  if (strlit7458 == NULL) {
    strlit7458 = alloc_String("(");
    gc_root(strlit7458);
  }
// compiled string node returning strlit7458 (depth = 7)
  int op_slot_left_7451 = gc_frame_newslot(strlit7458);
  params[0] = call7456;
  partcv[0] = 1;
  Object opresult7459 = callmethod(strlit7458, "++", 1, partcv, params);
// compiled op node returning opresult7459 (depth = 6)
  int op_slot_left_7448 = gc_frame_newslot(opresult7459);
  params[0] = strlit7449;
  partcv[0] = 1;
  Object opresult7460 = callmethod(opresult7459, "++", 1, partcv, params);
// compiled op node returning opresult7460 (depth = 5)
  *var_s = opresult7460;
  if (opresult7460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7427 = done;
  } else {
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7462 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num7463 = alloc_Float64(0);
// compiled num node returning num7463 (depth = 6)
  gc_frame_newslot(num7463);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7465 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7464);
// compiled call node returning call7465 (depth = 7)
// compiled member node returning call7465 (depth = 6)
  params[0] = num7463;
  partcv[0] = 1;
  Object call7466 = callmethod(call7465, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7462);
// compiled call node returning call7466 (depth = 5)
  *var_s = call7466;
  if (call7466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7427 = done;
  }
// compiled if node returning if7427 (depth = 3)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7470 == NULL) {
    strlit7470 = alloc_String("..");
    gc_root(strlit7470);
  }
// compiled string node returning strlit7470 (depth = 5)
  int op_slot_right_7469 = gc_frame_newslot(strlit7470);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7473 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7472);
// compiled call node returning call7473 (depth = 6)
// compiled member node returning call7473 (depth = 5)
  int op_slot_left_7469 = gc_frame_newslot(call7473);
  params[0] = strlit7470;
  partcv[0] = 1;
  Object opresult7474 = callmethod(call7473, "==", 1, partcv, params);
// compiled op node returning opresult7474 (depth = 4)
  Object if7468 = done;
  if (istrue(opresult7474)) {
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7477 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7476);
// compiled call node returning call7477 (depth = 7)
// compiled member node returning call7477 (depth = 6)
  int op_slot_right_7475 = gc_frame_newslot(call7477);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7475 = gc_frame_newslot(*var_s);
  params[0] = call7477;
  partcv[0] = 1;
  Object opresult7479 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7479 (depth = 5)
  *var_s = opresult7479;
  if (opresult7479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7468 = done;
  } else {
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7482 == NULL) {
    strlit7482 = alloc_String(" ");
    gc_root(strlit7482);
  }
// compiled string node returning strlit7482 (depth = 6)
  int op_slot_right_7481 = gc_frame_newslot(strlit7482);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7485 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7486 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7485);
// compiled call node returning call7486 (depth = 8)
// compiled member node returning call7486 (depth = 7)
  int op_slot_right_7484 = gc_frame_newslot(call7486);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7489 == NULL) {
    strlit7489 = alloc_String(" ");
    gc_root(strlit7489);
  }
// compiled string node returning strlit7489 (depth = 8)
  int op_slot_right_7488 = gc_frame_newslot(strlit7489);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7488 = gc_frame_newslot(*var_s);
  params[0] = strlit7489;
  partcv[0] = 1;
  Object opresult7491 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7491 (depth = 7)
  int op_slot_left_7484 = gc_frame_newslot(opresult7491);
  params[0] = call7486;
  partcv[0] = 1;
  Object opresult7492 = callmethod(opresult7491, "++", 1, partcv, params);
// compiled op node returning opresult7492 (depth = 6)
  int op_slot_left_7481 = gc_frame_newslot(opresult7492);
  params[0] = strlit7482;
  partcv[0] = 1;
  Object opresult7493 = callmethod(opresult7492, "++", 1, partcv, params);
// compiled op node returning opresult7493 (depth = 5)
  *var_s = opresult7493;
  if (opresult7493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7468 = done;
  }
// compiled if node returning if7468 (depth = 3)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7498 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7499 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7498);
// compiled call node returning call7499 (depth = 7)
// compiled member node returning call7499 (depth = 6)
  int op_slot_right_7497 = gc_frame_newslot(call7499);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7501 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7503 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7502);
// compiled call node returning call7503 (depth = 9)
// compiled member node returning call7503 (depth = 8)
  partcv[0] = 0;
  Object call7504 = callmethod(call7503, "value",
    1, partcv, params);
  gc_frame_end(callframe7501);
// compiled call node returning call7504 (depth = 7)
// compiled member node returning call7504 (depth = 6)
  int op_slot_left_7497 = gc_frame_newslot(call7504);
  params[0] = call7499;
  partcv[0] = 1;
  Object opresult7505 = callmethod(call7504, "!=", 1, partcv, params);
// compiled op node returning opresult7505 (depth = 5)
  int op_slot_right_7496 = gc_frame_newslot(opresult7505);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7508 == NULL) {
    strlit7508 = alloc_String("op");
    gc_root(strlit7508);
  }
// compiled string node returning strlit7508 (depth = 6)
  int op_slot_right_7507 = gc_frame_newslot(strlit7508);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7510 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7511 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7512 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7511);
// compiled call node returning call7512 (depth = 9)
// compiled member node returning call7512 (depth = 8)
  partcv[0] = 0;
  Object call7513 = callmethod(call7512, "kind",
    1, partcv, params);
  gc_frame_end(callframe7510);
// compiled call node returning call7513 (depth = 7)
// compiled member node returning call7513 (depth = 6)
  int op_slot_left_7507 = gc_frame_newslot(call7513);
  params[0] = strlit7508;
  partcv[0] = 1;
  Object opresult7514 = callmethod(call7513, "==", 1, partcv, params);
// compiled op node returning opresult7514 (depth = 5)
  int op_slot_left_7496 = gc_frame_newslot(opresult7514);
  params[0] = opresult7505;
  partcv[0] = 1;
  Object opresult7515 = callmethod(opresult7514, "&&", 1, partcv, params);
// compiled op node returning opresult7515 (depth = 4)
  Object if7495 = done;
  if (istrue(opresult7515)) {
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7517 == NULL) {
    strlit7517 = alloc_String(")");
    gc_root(strlit7517);
  }
// compiled string node returning strlit7517 (depth = 6)
  int op_slot_right_7516 = gc_frame_newslot(strlit7517);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7520 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7521 = alloc_Float64(0);
// compiled num node returning num7521 (depth = 8)
  gc_frame_newslot(num7521);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7523 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7522);
// compiled call node returning call7523 (depth = 9)
// compiled member node returning call7523 (depth = 8)
  params[0] = num7521;
  partcv[0] = 1;
  Object call7524 = callmethod(call7523, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7520);
// compiled call node returning call7524 (depth = 7)
  int op_slot_right_7519 = gc_frame_newslot(call7524);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7527 == NULL) {
    strlit7527 = alloc_String("(");
    gc_root(strlit7527);
  }
// compiled string node returning strlit7527 (depth = 8)
  int op_slot_right_7526 = gc_frame_newslot(strlit7527);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7526 = gc_frame_newslot(*var_s);
  params[0] = strlit7527;
  partcv[0] = 1;
  Object opresult7529 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7529 (depth = 7)
  int op_slot_left_7519 = gc_frame_newslot(opresult7529);
  params[0] = call7524;
  partcv[0] = 1;
  Object opresult7530 = callmethod(opresult7529, "++", 1, partcv, params);
// compiled op node returning opresult7530 (depth = 6)
  int op_slot_left_7516 = gc_frame_newslot(opresult7530);
  params[0] = strlit7517;
  partcv[0] = 1;
  Object opresult7531 = callmethod(opresult7530, "++", 1, partcv, params);
// compiled op node returning opresult7531 (depth = 5)
  *var_s = opresult7531;
  if (opresult7531 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7495 = done;
  } else {
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7534 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7535 = alloc_Float64(0);
// compiled num node returning num7535 (depth = 7)
  gc_frame_newslot(num7535);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7536 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7537 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7536);
// compiled call node returning call7537 (depth = 8)
// compiled member node returning call7537 (depth = 7)
  params[0] = num7535;
  partcv[0] = 1;
  Object call7538 = callmethod(call7537, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7534);
// compiled call node returning call7538 (depth = 6)
  int op_slot_right_7533 = gc_frame_newslot(call7538);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7533 = gc_frame_newslot(*var_s);
  params[0] = call7538;
  partcv[0] = 1;
  Object opresult7540 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7540 (depth = 5)
  *var_s = opresult7540;
  if (opresult7540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7495 = done;
  }
// compiled if node returning if7495 (depth = 3)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier7542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7543 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7545 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7544);
// compiled call node returning call7545 (depth = 6)
// compiled member node returning call7545 (depth = 5)
  gc_frame_newslot(call7545);
// starting to compile identifier node (depth = 5)
  Object bool7546 = alloc_Boolean(0);
// compiled identifier node returning bool7546 (depth = 5)
  gc_frame_newslot(bool7546);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7548 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7547);
// compiled call node returning call7548 (depth = 6)
// compiled member node returning call7548 (depth = 5)
  gc_frame_newslot(call7548);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7545;
  params[1] = bool7546;
  params[2] = call7548;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7549 = callmethod(*var_identifierNode, "new()scope",
    2, partcv, params);
  gc_frame_end(callframe7543);
// compiled call node returning call7549 (depth = 4)
  *var_resultNode = call7549;
  if (call7549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7550 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7551 = alloc_Boolean(1);
// compiled identifier node returning bool7551 (depth = 4)
  gc_frame_newslot(bool7551);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool7551;
  partcv[0] = 1;
  Object call7552 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe7550);
// compiled call node returning call7552 (depth = 3)
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7553 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7554 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7555 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7554);
// compiled call node returning call7555 (depth = 5)
// compiled member node returning call7555 (depth = 4)
  gc_frame_newslot(call7555);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7555;
  partcv[0] = 1;
  Object call7556 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7553);
// compiled call node returning call7556 (depth = 3)
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7557 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7558 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7559 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7558);
// compiled call node returning call7559 (depth = 5)
// compiled member node returning call7559 (depth = 4)
  gc_frame_newslot(call7559);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7559;
  partcv[0] = 1;
  Object call7560 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe7557);
// compiled call node returning call7560 (depth = 3)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy7561(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7562 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7563 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7565 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7564);
// compiled call node returning call7565 (depth = 6)
// compiled member node returning call7565 (depth = 5)
  gc_frame_newslot(call7565);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opNode (depth = 5)
  params[0] = call7565;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call7566 = callmethod(*var_opNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7563);
// compiled call node returning call7566 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7567 = callmethod(call7566, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7562);
// compiled call node returning call7567 (depth = 3)
  gc_frame_end(frame);
  return call7567;
}
Object meth_ast_new7305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7306 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7306 = alloc_userobj2(14,13, objclass7306);
  gc_frame_newslot(obj7306);
if (objclass7306 == NULL) {
  glfree(obj7306->class->name);
  obj7306->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7306, self, 0);
  addmethodreal(obj7306,"outer", &reader_ast_outer_7307);
  Object oldself7306 = self;
  struct StackFrameObject *oldstackframe7306 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7306);
  gc_frame_newslot((Object)stackframe);
  self = obj7306;
  Object *oldselfslot7306 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7306 = (*(struct UserObject *)self).data[0], lowerouter7306 = thisouter7306;
  if (inheritingObject7306) {
    struct UserObject *inho7306 = (struct UserObject *)inheritingObject7306;
    while (inho7306->super != GraceDefaultObject) inho7306 = (struct UserObject *)inho7306->super;
    inho7306->super = obj7306;
    self = inheritingObject7306;
    *selfslot = self;
    lowerouter7306 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7306;
  }
if (objclass7306 == NULL) {
  Method *reader7308 = addmethodrealflags(obj7306, "kind",&reader_ast_kind_7308, MFLAG_DEF);
  reader7308->definitionModule = modulename;
  reader7308->definitionLine = 1812;
}
adddatum2(obj7306, alloc_Undefined(), 1);
if (objclass7306 == NULL) {
  Method *reader7309 = addmethodrealflags(obj7306, "value",&reader_ast_value_7309, MFLAG_DEF);
  reader7309->definitionModule = modulename;
  reader7309->definitionLine = 1813;
}
adddatum2(obj7306, alloc_Undefined(), 2);
if (objclass7306 == NULL) {
  Method *reader7310 = addmethodrealflags(obj7306, "left",&reader_ast_left_7310, 0);
  Method *writer7310 = addmethodrealflags(obj7306, "left:=",&writer_ast_left_7310, 0);
  reader7310->definitionModule = modulename;
  writer7310->definitionModule = modulename;
  reader7310->definitionLine = 1814;
  writer7310->definitionLine = 1814;
}
obj7306->flags |= OFLAG_MUTABLE;
adddatum2(obj7306, alloc_Undefined(), 3);
if (objclass7306 == NULL) {
  Method *reader7311 = addmethodrealflags(obj7306, "right",&reader_ast_right_7311, 0);
  Method *writer7311 = addmethodrealflags(obj7306, "right:=",&writer_ast_right_7311, 0);
  reader7311->definitionModule = modulename;
  writer7311->definitionModule = modulename;
  reader7311->definitionLine = 1815;
  writer7311->definitionLine = 1815;
}
obj7306->flags |= OFLAG_MUTABLE;
adddatum2(obj7306, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7312 = (struct UserObject*)obj7306;
  uo7312->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7312 = addmethod2pos(obj7306, "isSimple", &meth_ast_isSimple7312, 5);
  int argcv_meth_ast_isSimple7312[] = {0};
  meth_meth_ast_isSimple7312->type = alloc_MethodType(1, argcv_meth_ast_isSimple7312);
  meth_meth_ast_isSimple7312->definitionModule = modulename;
  meth_meth_ast_isSimple7312->definitionLine = 1816;
// method "nameString"
  struct UserObject *uo7314 = (struct UserObject*)obj7306;
  uo7314->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7314 = addmethod2pos(obj7306, "nameString", &meth_ast_nameString7314, 6);
  int argcv_meth_ast_nameString7314[] = {0};
  meth_meth_ast_nameString7314->type = alloc_MethodType(1, argcv_meth_ast_nameString7314);
  meth_meth_ast_nameString7314->definitionModule = modulename;
  meth_meth_ast_nameString7314->definitionLine = 1817;
// method "accept()from"
  struct UserObject *uo7317 = (struct UserObject*)obj7306;
  uo7317->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7317 = addmethod2pos(obj7306, "accept()from", &meth_ast_accept_40__41_from7317, 7);
  int argcv_meth_ast_accept_40__41_from7317[] = {1, 1};
  meth_meth_ast_accept_40__41_from7317->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7317);
  meth_meth_ast_accept_40__41_from7317->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7317->definitionLine = 1818;
// method "map()ancestors"
  struct UserObject *uo7331 = (struct UserObject*)obj7306;
  uo7331->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7331 = addmethod2pos(obj7306, "map()ancestors", &meth_ast_map_40__41_ancestors7331, 8);
  int argcv_meth_ast_map_40__41_ancestors7331[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7331->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7331);
  meth_meth_ast_map_40__41_ancestors7331->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7331->definitionLine = 1825;
// method "pretty"
  struct UserObject *uo7350 = (struct UserObject*)obj7306;
  uo7350->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7350 = addmethod2pos(obj7306, "pretty", &meth_ast_pretty7350, 9);
  int argcv_meth_ast_pretty7350[] = {1};
  meth_meth_ast_pretty7350->type = alloc_MethodType(1, argcv_meth_ast_pretty7350);
  meth_meth_ast_pretty7350->definitionModule = modulename;
  meth_meth_ast_pretty7350->definitionLine = 1832;
// method "toGrace"
  struct UserObject *uo7425 = (struct UserObject*)obj7306;
  uo7425->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7425 = addmethod2pos(obj7306, "toGrace", &meth_ast_toGrace7425, 10);
  int argcv_meth_ast_toGrace7425[] = {1};
  meth_meth_ast_toGrace7425->type = alloc_MethodType(1, argcv_meth_ast_toGrace7425);
meth_meth_ast_toGrace7425->type->types[0] = type_Number;
meth_meth_ast_toGrace7425->type->names[0] = "depth";
  meth_meth_ast_toGrace7425->definitionModule = modulename;
  meth_meth_ast_toGrace7425->definitionLine = 1844;
// method "asIdentifier"
  block_savedest(obj7306);
  Object closure7542 = createclosure(1, "asIdentifier");
  setclosureframe(closure7542, stackframe);
  addtoclosure(closure7542, var_identifierNode);
  struct UserObject *uo7542 = (struct UserObject*)obj7306;
  uo7542->data[11] = (Object)closure7542;
  Method *meth_meth_ast_asIdentifier7542 = addmethod2pos(obj7306, "asIdentifier", &meth_ast_asIdentifier7542, 11);
  int argcv_meth_ast_asIdentifier7542[] = {0};
  meth_meth_ast_asIdentifier7542->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7542);
  meth_meth_ast_asIdentifier7542->definitionModule = modulename;
  meth_meth_ast_asIdentifier7542->definitionLine = 1863;
// method "shallowCopy"
  block_savedest(obj7306);
  Object closure7561 = createclosure(2, "shallowCopy");
  setclosureframe(closure7561, stackframe);
  addtoclosure(closure7561, var_nullNode);
  addtoclosure(closure7561, var_opNode);
  struct UserObject *uo7561 = (struct UserObject*)obj7306;
  uo7561->data[12] = (Object)closure7561;
  Method *meth_meth_ast_shallowCopy7561 = addmethod2pos(obj7306, "shallowCopy", &meth_ast_shallowCopy7561, 12);
  int argcv_meth_ast_shallowCopy7561[] = {0};
  meth_meth_ast_shallowCopy7561->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7561);
  meth_meth_ast_shallowCopy7561->definitionModule = modulename;
  meth_meth_ast_shallowCopy7561->definitionLine = 1871;
  sourceObject = obj7306;
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7568 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7569 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7570 = gc_frame_new();
// call case 3: self.outer request
  Object call7571 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7570);
// compiled call node returning call7571 (depth = 7)
// compiled member node returning call7571 (depth = 6)
  partcv[0] = 0;
  Object call7572 = callmethodflags(call7571, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7569);
// compiled call node returning call7572 (depth = 5)
// compiled member node returning call7572 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7573 = callmethodflags(call7572, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7568);
// compiled call node returning call7573 (depth = 3)
  struct UserObject *obj7306_uo = (struct UserObject *)obj7306;
  obj7306_uo->super = call7573;
  sourceObject = obj7306;
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7574 == NULL) {
    strlit7574 = alloc_String("op");
    gc_root(strlit7574);
  }
// compiled string node returning strlit7574 (depth = 3)
  adddatum2(obj7306, strlit7574, 1);
  sourceObject = obj7306;
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7306, *var_op, 2);
  sourceObject = obj7306;
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7306, *var_l, 3);
  sourceObject = obj7306;
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7306, *var_r, 4);
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  objclass7306 = obj7306->class;
  objclass7306->definitionModule = modulename;
  objclass7306->definitionLine = 1810;
  (*(struct UserObject *)self).data[0] = lowerouter7306;
  self = oldself7306;
  selfslot = oldselfslot7306;
  stackframe = oldstackframe7306;
  gc_frame_end(frame);
  return obj7306;
}
Object meth_ast_new7305_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7306 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7306 = alloc_userobj2(14,13, objclass7306);
  gc_frame_newslot(obj7306);
if (objclass7306 == NULL) {
  glfree(obj7306->class->name);
  obj7306->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7306, self, 0);
  addmethodreal(obj7306,"outer", &reader_ast_outer_7307);
  Object oldself7306 = self;
  struct StackFrameObject *oldstackframe7306 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7306);
  gc_frame_newslot((Object)stackframe);
  self = obj7306;
  Object *oldselfslot7306 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7306 = (*(struct UserObject *)self).data[0], lowerouter7306 = thisouter7306;
  if (inheritingObject7306) {
    struct UserObject *inho7306 = (struct UserObject *)inheritingObject7306;
    while (inho7306->super != GraceDefaultObject) inho7306 = (struct UserObject *)inho7306->super;
    inho7306->super = obj7306;
    self = inheritingObject7306;
    *selfslot = self;
    lowerouter7306 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7306;
  }
if (objclass7306 == NULL) {
  Method *reader7308 = addmethodrealflags(obj7306, "kind",&reader_ast_kind_7308, MFLAG_DEF);
  reader7308->definitionModule = modulename;
  reader7308->definitionLine = 1812;
}
adddatum2(obj7306, alloc_Undefined(), 1);
if (objclass7306 == NULL) {
  Method *reader7309 = addmethodrealflags(obj7306, "value",&reader_ast_value_7309, MFLAG_DEF);
  reader7309->definitionModule = modulename;
  reader7309->definitionLine = 1813;
}
adddatum2(obj7306, alloc_Undefined(), 2);
if (objclass7306 == NULL) {
  Method *reader7310 = addmethodrealflags(obj7306, "left",&reader_ast_left_7310, 0);
  Method *writer7310 = addmethodrealflags(obj7306, "left:=",&writer_ast_left_7310, 0);
  reader7310->definitionModule = modulename;
  writer7310->definitionModule = modulename;
  reader7310->definitionLine = 1814;
  writer7310->definitionLine = 1814;
}
obj7306->flags |= OFLAG_MUTABLE;
adddatum2(obj7306, alloc_Undefined(), 3);
if (objclass7306 == NULL) {
  Method *reader7311 = addmethodrealflags(obj7306, "right",&reader_ast_right_7311, 0);
  Method *writer7311 = addmethodrealflags(obj7306, "right:=",&writer_ast_right_7311, 0);
  reader7311->definitionModule = modulename;
  writer7311->definitionModule = modulename;
  reader7311->definitionLine = 1815;
  writer7311->definitionLine = 1815;
}
obj7306->flags |= OFLAG_MUTABLE;
adddatum2(obj7306, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7312 = (struct UserObject*)obj7306;
  uo7312->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7312 = addmethod2pos(obj7306, "isSimple", &meth_ast_isSimple7312, 5);
  int argcv_meth_ast_isSimple7312[] = {0};
  meth_meth_ast_isSimple7312->type = alloc_MethodType(1, argcv_meth_ast_isSimple7312);
  meth_meth_ast_isSimple7312->definitionModule = modulename;
  meth_meth_ast_isSimple7312->definitionLine = 1816;
// method "nameString"
  struct UserObject *uo7314 = (struct UserObject*)obj7306;
  uo7314->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7314 = addmethod2pos(obj7306, "nameString", &meth_ast_nameString7314, 6);
  int argcv_meth_ast_nameString7314[] = {0};
  meth_meth_ast_nameString7314->type = alloc_MethodType(1, argcv_meth_ast_nameString7314);
  meth_meth_ast_nameString7314->definitionModule = modulename;
  meth_meth_ast_nameString7314->definitionLine = 1817;
// method "accept()from"
  struct UserObject *uo7317 = (struct UserObject*)obj7306;
  uo7317->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7317 = addmethod2pos(obj7306, "accept()from", &meth_ast_accept_40__41_from7317, 7);
  int argcv_meth_ast_accept_40__41_from7317[] = {1, 1};
  meth_meth_ast_accept_40__41_from7317->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7317);
  meth_meth_ast_accept_40__41_from7317->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7317->definitionLine = 1818;
// method "map()ancestors"
  struct UserObject *uo7331 = (struct UserObject*)obj7306;
  uo7331->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7331 = addmethod2pos(obj7306, "map()ancestors", &meth_ast_map_40__41_ancestors7331, 8);
  int argcv_meth_ast_map_40__41_ancestors7331[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7331->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7331);
  meth_meth_ast_map_40__41_ancestors7331->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7331->definitionLine = 1825;
// method "pretty"
  struct UserObject *uo7350 = (struct UserObject*)obj7306;
  uo7350->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7350 = addmethod2pos(obj7306, "pretty", &meth_ast_pretty7350, 9);
  int argcv_meth_ast_pretty7350[] = {1};
  meth_meth_ast_pretty7350->type = alloc_MethodType(1, argcv_meth_ast_pretty7350);
  meth_meth_ast_pretty7350->definitionModule = modulename;
  meth_meth_ast_pretty7350->definitionLine = 1832;
// method "toGrace"
  struct UserObject *uo7425 = (struct UserObject*)obj7306;
  uo7425->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7425 = addmethod2pos(obj7306, "toGrace", &meth_ast_toGrace7425, 10);
  int argcv_meth_ast_toGrace7425[] = {1};
  meth_meth_ast_toGrace7425->type = alloc_MethodType(1, argcv_meth_ast_toGrace7425);
meth_meth_ast_toGrace7425->type->types[0] = type_Number;
meth_meth_ast_toGrace7425->type->names[0] = "depth";
  meth_meth_ast_toGrace7425->definitionModule = modulename;
  meth_meth_ast_toGrace7425->definitionLine = 1844;
// method "asIdentifier"
  block_savedest(obj7306);
  Object closure7542 = createclosure(1, "asIdentifier");
  setclosureframe(closure7542, stackframe);
  addtoclosure(closure7542, var_identifierNode);
  struct UserObject *uo7542 = (struct UserObject*)obj7306;
  uo7542->data[11] = (Object)closure7542;
  Method *meth_meth_ast_asIdentifier7542 = addmethod2pos(obj7306, "asIdentifier", &meth_ast_asIdentifier7542, 11);
  int argcv_meth_ast_asIdentifier7542[] = {0};
  meth_meth_ast_asIdentifier7542->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7542);
  meth_meth_ast_asIdentifier7542->definitionModule = modulename;
  meth_meth_ast_asIdentifier7542->definitionLine = 1863;
// method "shallowCopy"
  block_savedest(obj7306);
  Object closure7561 = createclosure(2, "shallowCopy");
  setclosureframe(closure7561, stackframe);
  addtoclosure(closure7561, var_nullNode);
  addtoclosure(closure7561, var_opNode);
  struct UserObject *uo7561 = (struct UserObject*)obj7306;
  uo7561->data[12] = (Object)closure7561;
  Method *meth_meth_ast_shallowCopy7561 = addmethod2pos(obj7306, "shallowCopy", &meth_ast_shallowCopy7561, 12);
  int argcv_meth_ast_shallowCopy7561[] = {0};
  meth_meth_ast_shallowCopy7561->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7561);
  meth_meth_ast_shallowCopy7561->definitionModule = modulename;
  meth_meth_ast_shallowCopy7561->definitionLine = 1871;
  sourceObject = obj7306;
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7568 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7569 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7570 = gc_frame_new();
// call case 3: self.outer request
  Object call7571 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7570);
// compiled call node returning call7571 (depth = 7)
// compiled member node returning call7571 (depth = 6)
  partcv[0] = 0;
  Object call7572 = callmethodflags(call7571, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7569);
// compiled call node returning call7572 (depth = 5)
// compiled member node returning call7572 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7573 = callmethodflags(call7572, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7568);
// compiled call node returning call7573 (depth = 3)
  struct UserObject *obj7306_uo = (struct UserObject *)obj7306;
  obj7306_uo->super = call7573;
  sourceObject = obj7306;
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7574 == NULL) {
    strlit7574 = alloc_String("op");
    gc_root(strlit7574);
  }
// compiled string node returning strlit7574 (depth = 3)
  adddatum2(obj7306, strlit7574, 1);
  sourceObject = obj7306;
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7306, *var_op, 2);
  sourceObject = obj7306;
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7306, *var_l, 3);
  sourceObject = obj7306;
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7306, *var_r, 4);
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  sourceObject = obj7306;
  objclass7306 = obj7306->class;
  objclass7306->definitionModule = modulename;
  objclass7306->definitionLine = 1810;
  (*(struct UserObject *)self).data[0] = lowerouter7306;
  self = oldself7306;
  selfslot = oldselfslot7306;
  stackframe = oldstackframe7306;
  gc_frame_end(frame);
  return obj7306;
}
Object meth_ast_opNode7576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for opNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for opNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_accept_40__41_from7585(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7587 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7588 = callmethod(*var_visitor, "visitIndex()up",
    2, partcv, params);
  gc_frame_end(callframe7587);
// compiled call node returning call7588 (depth = 4)
  Object if7586 = done;
  if (istrue(call7588)) {
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7589 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7590 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7589);
// compiled call node returning call7590 (depth = 5)
  *var_newChain = call7590;
  if (call7590 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7591 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7592 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7593 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7592);
// compiled call node returning call7593 (depth = 6)
// compiled member node returning call7593 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7594 = callmethod(call7593, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7591);
// compiled call node returning call7594 (depth = 4)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7595 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7596 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7597 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7596);
// compiled call node returning call7597 (depth = 6)
// compiled member node returning call7597 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7598 = callmethod(call7597, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7595);
// compiled call node returning call7598 (depth = 4)
    gc_frame_newslot(call7598);
    if7586 = call7598;
  } else {
  }
// compiled if node returning if7586 (depth = 3)
  gc_frame_end(frame);
  return if7586;
}
Object meth_ast_map_40__41_ancestors7599(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7600 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7601 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7600);
// compiled call node returning call7601 (depth = 5)
// compiled member node returning call7601 (depth = 4)
  *var_n = call7601;
  if (call7601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7602 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7603 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7602);
// compiled call node returning call7603 (depth = 4)
  *var_newChain = call7603;
  if (call7603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7604 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7605 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7607 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7606);
// compiled call node returning call7607 (depth = 6)
// compiled member node returning call7607 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7608 = callmethod(call7607, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7605);
// compiled call node returning call7608 (depth = 4)
  gc_frame_newslot(call7608);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7608;
  partcv[0] = 1;
  Object call7609 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7604);
// compiled call node returning call7609 (depth = 3)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7610 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7611 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7612 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7613 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compiled call node returning call7613 (depth = 6)
// compiled member node returning call7613 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7614 = callmethod(call7613, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7611);
// compiled call node returning call7614 (depth = 4)
  gc_frame_newslot(call7614);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7614;
  partcv[0] = 1;
  Object call7615 = callmethod(*var_n, "index:=",
    1, partcv, params);
  gc_frame_end(callframe7610);
// compiled call node returning call7615 (depth = 3)
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7616 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7617 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7616);
// compiled call node returning call7617 (depth = 3)
  gc_frame_end(frame);
  return call7617;
}
Object meth_ast__apply7626(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7628 == NULL) {
    strlit7628 = alloc_String("  ");
    gc_root(strlit7628);
  }
// compiled string node returning strlit7628 (depth = 7)
  int op_slot_right_7627 = gc_frame_newslot(strlit7628);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7627 = gc_frame_newslot(*var_spc);
  params[0] = strlit7628;
  partcv[0] = 1;
  Object opresult7630 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7630 (depth = 6)
  *var_spc = opresult7630;
  if (opresult7630 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7618(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7619 == NULL) {
    strlit7619 = alloc_String("");
    gc_root(strlit7619);
  }
// compiled string node returning strlit7619 (depth = 4)
  *var_spc = strlit7619;
  if (strlit7619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7620 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7621 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7623 = alloc_Float64(0);
// compiled num node returning num7623 (depth = 5)
  int op_slot_left_7621 = gc_frame_newslot(num7623);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7624 = callmethod(num7623, "..", 1, partcv, params);
// compiled op node returning opresult7624 (depth = 4)
  gc_frame_newslot(opresult7624);
// starting to compile block node (depth = 4)
  Object block7625 = alloc_Block(NULL, NULL, "ast", 1900);
  gc_frame_newslot(block7625);
// method "_apply"
  block_savedest(block7625);
  Object closure7626 = createclosure(2, "_apply");
  setclosureframe(closure7626, stackframe);
  addtoclosure(closure7626, var_spc);
  addtoclosure(closure7626, selfslot);
  struct UserObject *uo7626 = (struct UserObject*)block7625;
  uo7626->data[0] = (Object)closure7626;
  Method *meth_meth_ast__apply7626 = addmethod2pos(block7625, "_apply", &meth_ast__apply7626, 0);
  int argcv_meth_ast__apply7626[] = {1};
  meth_meth_ast__apply7626->type = alloc_MethodType(1, argcv_meth_ast__apply7626);
  meth_meth_ast__apply7626->definitionModule = modulename;
  meth_meth_ast__apply7626->definitionLine = 1895;
// compiled block node returning block7625 (depth = 4)
  gc_frame_newslot(block7625);
// call case 5: prelude request
  params[0] = opresult7624;
  params[1] = block7625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7633 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7620);
// compiled call node returning call7633 (depth = 3)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7635 == NULL) {
    strlit7635 = alloc_String("""\x0a""");
    gc_root(strlit7635);
  }
// compiled string node returning strlit7635 (depth = 5)
  int op_slot_right_7634 = gc_frame_newslot(strlit7635);
// starting to compile call node (depth = 5)
  int callframe7637 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7638 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7637);
// compiled call node returning call7638 (depth = 5)
  int op_slot_left_7634 = gc_frame_newslot(call7638);
  params[0] = strlit7635;
  partcv[0] = 1;
  Object opresult7639 = callmethod(call7638, "++", 1, partcv, params);
// compiled op node returning opresult7639 (depth = 4)
  *var_s = opresult7639;
  if (opresult7639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7641 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7643 = alloc_Float64(1);
// compiled num node returning num7643 (depth = 7)
  int op_slot_right_7642 = gc_frame_newslot(num7643);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7642 = gc_frame_newslot(*var_depth);
  params[0] = num7643;
  partcv[0] = 1;
  Object sum7645 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7645 (depth = 6)
  gc_frame_newslot(sum7645);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7646 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7647 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7646);
// compiled call node returning call7647 (depth = 7)
// compiled member node returning call7647 (depth = 6)
  params[0] = sum7645;
  partcv[0] = 1;
  Object call7648 = callmethod(call7647, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7641);
// compiled call node returning call7648 (depth = 5)
  int op_slot_right_7640 = gc_frame_newslot(call7648);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7650 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7650 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7652 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7652 (depth = 5)
  int op_slot_left_7640 = gc_frame_newslot(opresult7652);
  params[0] = call7648;
  partcv[0] = 1;
  Object opresult7653 = callmethod(opresult7652, "++", 1, partcv, params);
// compiled op node returning opresult7653 (depth = 4)
  *var_s = opresult7653;
  if (opresult7653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7656 == NULL) {
    strlit7656 = alloc_String("""\x0a""");
    gc_root(strlit7656);
  }
// compiled string node returning strlit7656 (depth = 5)
  int op_slot_right_7655 = gc_frame_newslot(strlit7656);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7655 = gc_frame_newslot(*var_s);
  params[0] = strlit7656;
  partcv[0] = 1;
  Object opresult7658 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7658 (depth = 4)
  *var_s = opresult7658;
  if (opresult7658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7661 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7663 = alloc_Float64(1);
// compiled num node returning num7663 (depth = 7)
  int op_slot_right_7662 = gc_frame_newslot(num7663);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7662 = gc_frame_newslot(*var_depth);
  params[0] = num7663;
  partcv[0] = 1;
  Object sum7665 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7665 (depth = 6)
  gc_frame_newslot(sum7665);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7667 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7666);
// compiled call node returning call7667 (depth = 7)
// compiled member node returning call7667 (depth = 6)
  params[0] = sum7665;
  partcv[0] = 1;
  Object call7668 = callmethod(call7667, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7661);
// compiled call node returning call7668 (depth = 5)
  int op_slot_right_7660 = gc_frame_newslot(call7668);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7670 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7670 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7672 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7672 (depth = 5)
  int op_slot_left_7660 = gc_frame_newslot(opresult7672);
  params[0] = call7668;
  partcv[0] = 1;
  Object opresult7673 = callmethod(opresult7672, "++", 1, partcv, params);
// compiled op node returning opresult7673 (depth = 4)
  *var_s = opresult7673;
  if (opresult7673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7687(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7689 == NULL) {
    strlit7689 = alloc_String("    ");
    gc_root(strlit7689);
  }
// compiled string node returning strlit7689 (depth = 7)
  int op_slot_right_7688 = gc_frame_newslot(strlit7689);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7688 = gc_frame_newslot(*var_spc);
  params[0] = strlit7689;
  partcv[0] = 1;
  Object opresult7691 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7691 (depth = 6)
  *var_spc = opresult7691;
  if (opresult7691 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace7675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7676 == NULL) {
    strlit7676 = alloc_String("");
    gc_root(strlit7676);
  }
// compiled string node returning strlit7676 (depth = 4)
  *var_spc = strlit7676;
  if (strlit7676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7677 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7680 = alloc_Float64(1);
// compiled num node returning num7680 (depth = 6)
  int op_slot_right_7679 = gc_frame_newslot(num7680);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7679 = gc_frame_newslot(*var_depth);
  params[0] = num7680;
  partcv[0] = 1;
  Object diff7682 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff7682 (depth = 5)
  int op_slot_right_7678 = gc_frame_newslot(diff7682);
// starting to compile num node (depth = 5)
  Object num7684 = alloc_Float64(0);
// compiled num node returning num7684 (depth = 5)
  int op_slot_left_7678 = gc_frame_newslot(num7684);
  params[0] = diff7682;
  partcv[0] = 1;
  Object opresult7685 = callmethod(num7684, "..", 1, partcv, params);
// compiled op node returning opresult7685 (depth = 4)
  gc_frame_newslot(opresult7685);
// starting to compile block node (depth = 4)
  Object block7686 = alloc_Block(NULL, NULL, "ast", 1911);
  gc_frame_newslot(block7686);
// method "_apply"
  block_savedest(block7686);
  Object closure7687 = createclosure(2, "_apply");
  setclosureframe(closure7687, stackframe);
  addtoclosure(closure7687, var_spc);
  addtoclosure(closure7687, selfslot);
  struct UserObject *uo7687 = (struct UserObject*)block7686;
  uo7687->data[0] = (Object)closure7687;
  Method *meth_meth_ast__apply7687 = addmethod2pos(block7686, "_apply", &meth_ast__apply7687, 0);
  int argcv_meth_ast__apply7687[] = {1};
  meth_meth_ast__apply7687->type = alloc_MethodType(1, argcv_meth_ast__apply7687);
  meth_meth_ast__apply7687->definitionModule = modulename;
  meth_meth_ast__apply7687->definitionLine = 1906;
// compiled block node returning block7686 (depth = 4)
  gc_frame_newslot(block7686);
// call case 5: prelude request
  params[0] = opresult7685;
  params[1] = block7686;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7694 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7677);
// compiled call node returning call7694 (depth = 3)
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7695 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7697 = alloc_Float64(1);
// compiled num node returning num7697 (depth = 6)
  int op_slot_right_7696 = gc_frame_newslot(num7697);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7696 = gc_frame_newslot(*var_depth);
  params[0] = num7697;
  partcv[0] = 1;
  Object sum7699 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7699 (depth = 5)
  gc_frame_newslot(sum7699);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7701 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7700);
// compiled call node returning call7701 (depth = 6)
// compiled member node returning call7701 (depth = 5)
  params[0] = sum7699;
  partcv[0] = 1;
  Object call7702 = callmethod(call7701, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7695);
// compiled call node returning call7702 (depth = 4)
  *var_s = call7702;
  if (call7702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7704 == NULL) {
    strlit7704 = alloc_String("]");
    gc_root(strlit7704);
  }
// compiled string node returning strlit7704 (depth = 5)
  int op_slot_right_7703 = gc_frame_newslot(strlit7704);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7707 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7709 = alloc_Float64(1);
// compiled num node returning num7709 (depth = 8)
  int op_slot_right_7708 = gc_frame_newslot(num7709);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7708 = gc_frame_newslot(*var_depth);
  params[0] = num7709;
  partcv[0] = 1;
  Object sum7711 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7711 (depth = 7)
  gc_frame_newslot(sum7711);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7712 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7713 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7712);
// compiled call node returning call7713 (depth = 8)
// compiled member node returning call7713 (depth = 7)
  params[0] = sum7711;
  partcv[0] = 1;
  Object call7714 = callmethod(call7713, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7707);
// compiled call node returning call7714 (depth = 6)
  int op_slot_right_7706 = gc_frame_newslot(call7714);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7717 == NULL) {
    strlit7717 = alloc_String("[");
    gc_root(strlit7717);
  }
// compiled string node returning strlit7717 (depth = 7)
  int op_slot_right_7716 = gc_frame_newslot(strlit7717);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7716 = gc_frame_newslot(*var_s);
  params[0] = strlit7717;
  partcv[0] = 1;
  Object opresult7719 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7719 (depth = 6)
  int op_slot_left_7706 = gc_frame_newslot(opresult7719);
  params[0] = call7714;
  partcv[0] = 1;
  Object opresult7720 = callmethod(opresult7719, "++", 1, partcv, params);
// compiled op node returning opresult7720 (depth = 5)
  int op_slot_left_7703 = gc_frame_newslot(opresult7720);
  params[0] = strlit7704;
  partcv[0] = 1;
  Object opresult7721 = callmethod(opresult7720, "++", 1, partcv, params);
// compiled op node returning opresult7721 (depth = 4)
  *var_s = opresult7721;
  if (opresult7721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7724 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7725 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_indexNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call7726 = callmethod(*var_indexNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7725);
// compiled call node returning call7726 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7727 = callmethod(call7726, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7724);
// compiled call node returning call7727 (depth = 3)
  gc_frame_end(frame);
  return call7727;
}
Object meth_ast_new7579(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7580 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7580 = alloc_userobj2(10,9, objclass7580);
  gc_frame_newslot(obj7580);
if (objclass7580 == NULL) {
  glfree(obj7580->class->name);
  obj7580->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7580, self, 0);
  addmethodreal(obj7580,"outer", &reader_ast_outer_7581);
  Object oldself7580 = self;
  struct StackFrameObject *oldstackframe7580 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7580);
  gc_frame_newslot((Object)stackframe);
  self = obj7580;
  Object *oldselfslot7580 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7580 = (*(struct UserObject *)self).data[0], lowerouter7580 = thisouter7580;
  if (inheritingObject7580) {
    struct UserObject *inho7580 = (struct UserObject *)inheritingObject7580;
    while (inho7580->super != GraceDefaultObject) inho7580 = (struct UserObject *)inho7580->super;
    inho7580->super = obj7580;
    self = inheritingObject7580;
    *selfslot = self;
    lowerouter7580 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7580;
  }
if (objclass7580 == NULL) {
  Method *reader7582 = addmethodrealflags(obj7580, "kind",&reader_ast_kind_7582, MFLAG_DEF);
  reader7582->definitionModule = modulename;
  reader7582->definitionLine = 1880;
}
adddatum2(obj7580, alloc_Undefined(), 1);
if (objclass7580 == NULL) {
  Method *reader7583 = addmethodrealflags(obj7580, "value",&reader_ast_value_7583, 0);
  Method *writer7583 = addmethodrealflags(obj7580, "value:=",&writer_ast_value_7583, 0);
  reader7583->definitionModule = modulename;
  writer7583->definitionModule = modulename;
  reader7583->definitionLine = 1881;
  writer7583->definitionLine = 1881;
}
obj7580->flags |= OFLAG_MUTABLE;
adddatum2(obj7580, alloc_Undefined(), 2);
if (objclass7580 == NULL) {
  Method *reader7584 = addmethodrealflags(obj7580, "index",&reader_ast_index_7584, 0);
  Method *writer7584 = addmethodrealflags(obj7580, "index:=",&writer_ast_index_7584, 0);
  reader7584->definitionModule = modulename;
  writer7584->definitionModule = modulename;
  reader7584->definitionLine = 1882;
  writer7584->definitionLine = 1882;
}
obj7580->flags |= OFLAG_MUTABLE;
adddatum2(obj7580, alloc_Undefined(), 3);
// method "accept()from"
  struct UserObject *uo7585 = (struct UserObject*)obj7580;
  uo7585->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7585 = addmethod2pos(obj7580, "accept()from", &meth_ast_accept_40__41_from7585, 4);
  int argcv_meth_ast_accept_40__41_from7585[] = {1, 1};
  meth_meth_ast_accept_40__41_from7585->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7585);
  meth_meth_ast_accept_40__41_from7585->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7585->definitionLine = 1884;
// method "map()ancestors"
  struct UserObject *uo7599 = (struct UserObject*)obj7580;
  uo7599->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7599 = addmethod2pos(obj7580, "map()ancestors", &meth_ast_map_40__41_ancestors7599, 5);
  int argcv_meth_ast_map_40__41_ancestors7599[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7599->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7599);
  meth_meth_ast_map_40__41_ancestors7599->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7599->definitionLine = 1891;
// method "pretty"
  struct UserObject *uo7618 = (struct UserObject*)obj7580;
  uo7618->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7618 = addmethod2pos(obj7580, "pretty", &meth_ast_pretty7618, 6);
  int argcv_meth_ast_pretty7618[] = {1};
  meth_meth_ast_pretty7618->type = alloc_MethodType(1, argcv_meth_ast_pretty7618);
  meth_meth_ast_pretty7618->definitionModule = modulename;
  meth_meth_ast_pretty7618->definitionLine = 1898;
// method "toGrace"
  struct UserObject *uo7675 = (struct UserObject*)obj7580;
  uo7675->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7675 = addmethod2pos(obj7580, "toGrace", &meth_ast_toGrace7675, 7);
  int argcv_meth_ast_toGrace7675[] = {1};
  meth_meth_ast_toGrace7675->type = alloc_MethodType(1, argcv_meth_ast_toGrace7675);
meth_meth_ast_toGrace7675->type->types[0] = type_Number;
meth_meth_ast_toGrace7675->type->names[0] = "depth";
  meth_meth_ast_toGrace7675->definitionModule = modulename;
  meth_meth_ast_toGrace7675->definitionLine = 1909;
// method "shallowCopy"
  block_savedest(obj7580);
  Object closure7723 = createclosure(2, "shallowCopy");
  setclosureframe(closure7723, stackframe);
  addtoclosure(closure7723, var_nullNode);
  addtoclosure(closure7723, var_indexNode);
  struct UserObject *uo7723 = (struct UserObject*)obj7580;
  uo7723->data[8] = (Object)closure7723;
  Method *meth_meth_ast_shallowCopy7723 = addmethod2pos(obj7580, "shallowCopy", &meth_ast_shallowCopy7723, 8);
  int argcv_meth_ast_shallowCopy7723[] = {0};
  meth_meth_ast_shallowCopy7723->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7723);
  meth_meth_ast_shallowCopy7723->definitionModule = modulename;
  meth_meth_ast_shallowCopy7723->definitionLine = 1918;
  sourceObject = obj7580;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7728 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7729 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7730 = gc_frame_new();
// call case 3: self.outer request
  Object call7731 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7730);
// compiled call node returning call7731 (depth = 7)
// compiled member node returning call7731 (depth = 6)
  partcv[0] = 0;
  Object call7732 = callmethodflags(call7731, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7729);
// compiled call node returning call7732 (depth = 5)
// compiled member node returning call7732 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7733 = callmethodflags(call7732, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7728);
// compiled call node returning call7733 (depth = 3)
  struct UserObject *obj7580_uo = (struct UserObject *)obj7580;
  obj7580_uo->super = call7733;
  sourceObject = obj7580;
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7734 == NULL) {
    strlit7734 = alloc_String("index");
    gc_root(strlit7734);
  }
// compiled string node returning strlit7734 (depth = 3)
  adddatum2(obj7580, strlit7734, 1);
  sourceObject = obj7580;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj7580, *var_expr, 2);
  sourceObject = obj7580;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_index_39_ (depth = 3)
  adddatum2(obj7580, *var_index_39_, 3);
  sourceObject = obj7580;
  sourceObject = obj7580;
  sourceObject = obj7580;
  sourceObject = obj7580;
  sourceObject = obj7580;
  objclass7580 = obj7580->class;
  objclass7580->definitionModule = modulename;
  objclass7580->definitionLine = 1877;
  (*(struct UserObject *)self).data[0] = lowerouter7580;
  self = oldself7580;
  selfslot = oldselfslot7580;
  stackframe = oldstackframe7580;
  gc_frame_end(frame);
  return obj7580;
}
Object meth_ast_new7579_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7580 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7580 = alloc_userobj2(10,9, objclass7580);
  gc_frame_newslot(obj7580);
if (objclass7580 == NULL) {
  glfree(obj7580->class->name);
  obj7580->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7580, self, 0);
  addmethodreal(obj7580,"outer", &reader_ast_outer_7581);
  Object oldself7580 = self;
  struct StackFrameObject *oldstackframe7580 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7580);
  gc_frame_newslot((Object)stackframe);
  self = obj7580;
  Object *oldselfslot7580 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7580 = (*(struct UserObject *)self).data[0], lowerouter7580 = thisouter7580;
  if (inheritingObject7580) {
    struct UserObject *inho7580 = (struct UserObject *)inheritingObject7580;
    while (inho7580->super != GraceDefaultObject) inho7580 = (struct UserObject *)inho7580->super;
    inho7580->super = obj7580;
    self = inheritingObject7580;
    *selfslot = self;
    lowerouter7580 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7580;
  }
if (objclass7580 == NULL) {
  Method *reader7582 = addmethodrealflags(obj7580, "kind",&reader_ast_kind_7582, MFLAG_DEF);
  reader7582->definitionModule = modulename;
  reader7582->definitionLine = 1880;
}
adddatum2(obj7580, alloc_Undefined(), 1);
if (objclass7580 == NULL) {
  Method *reader7583 = addmethodrealflags(obj7580, "value",&reader_ast_value_7583, 0);
  Method *writer7583 = addmethodrealflags(obj7580, "value:=",&writer_ast_value_7583, 0);
  reader7583->definitionModule = modulename;
  writer7583->definitionModule = modulename;
  reader7583->definitionLine = 1881;
  writer7583->definitionLine = 1881;
}
obj7580->flags |= OFLAG_MUTABLE;
adddatum2(obj7580, alloc_Undefined(), 2);
if (objclass7580 == NULL) {
  Method *reader7584 = addmethodrealflags(obj7580, "index",&reader_ast_index_7584, 0);
  Method *writer7584 = addmethodrealflags(obj7580, "index:=",&writer_ast_index_7584, 0);
  reader7584->definitionModule = modulename;
  writer7584->definitionModule = modulename;
  reader7584->definitionLine = 1882;
  writer7584->definitionLine = 1882;
}
obj7580->flags |= OFLAG_MUTABLE;
adddatum2(obj7580, alloc_Undefined(), 3);
// method "accept()from"
  struct UserObject *uo7585 = (struct UserObject*)obj7580;
  uo7585->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7585 = addmethod2pos(obj7580, "accept()from", &meth_ast_accept_40__41_from7585, 4);
  int argcv_meth_ast_accept_40__41_from7585[] = {1, 1};
  meth_meth_ast_accept_40__41_from7585->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7585);
  meth_meth_ast_accept_40__41_from7585->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7585->definitionLine = 1884;
// method "map()ancestors"
  struct UserObject *uo7599 = (struct UserObject*)obj7580;
  uo7599->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7599 = addmethod2pos(obj7580, "map()ancestors", &meth_ast_map_40__41_ancestors7599, 5);
  int argcv_meth_ast_map_40__41_ancestors7599[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7599->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7599);
  meth_meth_ast_map_40__41_ancestors7599->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7599->definitionLine = 1891;
// method "pretty"
  struct UserObject *uo7618 = (struct UserObject*)obj7580;
  uo7618->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7618 = addmethod2pos(obj7580, "pretty", &meth_ast_pretty7618, 6);
  int argcv_meth_ast_pretty7618[] = {1};
  meth_meth_ast_pretty7618->type = alloc_MethodType(1, argcv_meth_ast_pretty7618);
  meth_meth_ast_pretty7618->definitionModule = modulename;
  meth_meth_ast_pretty7618->definitionLine = 1898;
// method "toGrace"
  struct UserObject *uo7675 = (struct UserObject*)obj7580;
  uo7675->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7675 = addmethod2pos(obj7580, "toGrace", &meth_ast_toGrace7675, 7);
  int argcv_meth_ast_toGrace7675[] = {1};
  meth_meth_ast_toGrace7675->type = alloc_MethodType(1, argcv_meth_ast_toGrace7675);
meth_meth_ast_toGrace7675->type->types[0] = type_Number;
meth_meth_ast_toGrace7675->type->names[0] = "depth";
  meth_meth_ast_toGrace7675->definitionModule = modulename;
  meth_meth_ast_toGrace7675->definitionLine = 1909;
// method "shallowCopy"
  block_savedest(obj7580);
  Object closure7723 = createclosure(2, "shallowCopy");
  setclosureframe(closure7723, stackframe);
  addtoclosure(closure7723, var_nullNode);
  addtoclosure(closure7723, var_indexNode);
  struct UserObject *uo7723 = (struct UserObject*)obj7580;
  uo7723->data[8] = (Object)closure7723;
  Method *meth_meth_ast_shallowCopy7723 = addmethod2pos(obj7580, "shallowCopy", &meth_ast_shallowCopy7723, 8);
  int argcv_meth_ast_shallowCopy7723[] = {0};
  meth_meth_ast_shallowCopy7723->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7723);
  meth_meth_ast_shallowCopy7723->definitionModule = modulename;
  meth_meth_ast_shallowCopy7723->definitionLine = 1918;
  sourceObject = obj7580;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7728 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7729 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7730 = gc_frame_new();
// call case 3: self.outer request
  Object call7731 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7730);
// compiled call node returning call7731 (depth = 7)
// compiled member node returning call7731 (depth = 6)
  partcv[0] = 0;
  Object call7732 = callmethodflags(call7731, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7729);
// compiled call node returning call7732 (depth = 5)
// compiled member node returning call7732 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7733 = callmethodflags(call7732, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7728);
// compiled call node returning call7733 (depth = 3)
  struct UserObject *obj7580_uo = (struct UserObject *)obj7580;
  obj7580_uo->super = call7733;
  sourceObject = obj7580;
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7734 == NULL) {
    strlit7734 = alloc_String("index");
    gc_root(strlit7734);
  }
// compiled string node returning strlit7734 (depth = 3)
  adddatum2(obj7580, strlit7734, 1);
  sourceObject = obj7580;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj7580, *var_expr, 2);
  sourceObject = obj7580;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_index_39_ (depth = 3)
  adddatum2(obj7580, *var_index_39_, 3);
  sourceObject = obj7580;
  sourceObject = obj7580;
  sourceObject = obj7580;
  sourceObject = obj7580;
  sourceObject = obj7580;
  objclass7580 = obj7580->class;
  objclass7580->definitionModule = modulename;
  objclass7580->definitionLine = 1877;
  (*(struct UserObject *)self).data[0] = lowerouter7580;
  self = oldself7580;
  selfslot = oldselfslot7580;
  stackframe = oldstackframe7580;
  gc_frame_end(frame);
  return obj7580;
}
Object meth_ast_indexNode7736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indexNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for indexNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexNode (depth = 3)
  gc_frame_end(frame);
  return *var_indexNode;
}
Object meth_ast_isBind7745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7746 = alloc_Boolean(1);
// compiled identifier node returning bool7746 (depth = 3)
  gc_frame_end(frame);
  return bool7746;
}
Object meth_ast_asString7747(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7749 == NULL) {
    strlit7749 = alloc_String("");
    gc_root(strlit7749);
  }
// compiled string node returning strlit7749 (depth = 4)
  int op_slot_right_7748 = gc_frame_newslot(strlit7749);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7753 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7752);
// compiled call node returning call7753 (depth = 6)
// compiled member node returning call7753 (depth = 5)
  int op_slot_right_7751 = gc_frame_newslot(call7753);
// starting to compile string node (depth = 5)
  if (strlit7755 == NULL) {
    strlit7755 = alloc_String("bind ");
    gc_root(strlit7755);
  }
// compiled string node returning strlit7755 (depth = 5)
  int op_slot_left_7751 = gc_frame_newslot(strlit7755);
  params[0] = call7753;
  partcv[0] = 1;
  Object opresult7756 = callmethod(strlit7755, "++", 1, partcv, params);
// compiled op node returning opresult7756 (depth = 4)
  int op_slot_left_7748 = gc_frame_newslot(opresult7756);
  params[0] = strlit7749;
  partcv[0] = 1;
  Object opresult7757 = callmethod(opresult7756, "++", 1, partcv, params);
// compiled op node returning opresult7757 (depth = 3)
  gc_frame_end(frame);
  return opresult7757;
}
Object meth_ast_accept_40__41_from7758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7760 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7761 = callmethod(*var_visitor, "visitBind()up",
    2, partcv, params);
  gc_frame_end(callframe7760);
// compiled call node returning call7761 (depth = 4)
  Object if7759 = done;
  if (istrue(call7761)) {
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7762 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7763 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7762);
// compiled call node returning call7763 (depth = 5)
  *var_newChain = call7763;
  if (call7763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7764 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7765 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7766 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7765);
// compiled call node returning call7766 (depth = 6)
// compiled member node returning call7766 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7767 = callmethod(call7766, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7764);
// compiled call node returning call7767 (depth = 4)
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7768 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7769 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7770 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7769);
// compiled call node returning call7770 (depth = 6)
// compiled member node returning call7770 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7771 = callmethod(call7770, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7768);
// compiled call node returning call7771 (depth = 4)
    gc_frame_newslot(call7771);
    if7759 = call7771;
  } else {
  }
// compiled if node returning if7759 (depth = 3)
  gc_frame_end(frame);
  return if7759;
}
Object meth_ast_map_40__41_ancestors7772(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7773 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7774 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7773);
// compiled call node returning call7774 (depth = 5)
// compiled member node returning call7774 (depth = 4)
  *var_n = call7774;
  if (call7774 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7775 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7776 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7775);
// compiled call node returning call7776 (depth = 4)
  *var_newChain = call7776;
  if (call7776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7777 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7778 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7780 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7779);
// compiled call node returning call7780 (depth = 6)
// compiled member node returning call7780 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7781 = callmethod(call7780, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7778);
// compiled call node returning call7781 (depth = 4)
  gc_frame_newslot(call7781);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7781;
  partcv[0] = 1;
  Object call7782 = callmethod(*var_n, "dest:=",
    1, partcv, params);
  gc_frame_end(callframe7777);
// compiled call node returning call7782 (depth = 3)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7783 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7784 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7785 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7786 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7785);
// compiled call node returning call7786 (depth = 6)
// compiled member node returning call7786 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7787 = callmethod(call7786, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7784);
// compiled call node returning call7787 (depth = 4)
  gc_frame_newslot(call7787);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7787;
  partcv[0] = 1;
  Object call7788 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7783);
// compiled call node returning call7788 (depth = 3)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7789 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7790 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7789);
// compiled call node returning call7790 (depth = 3)
  gc_frame_end(frame);
  return call7790;
}
Object meth_ast__apply7799(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7801 == NULL) {
    strlit7801 = alloc_String("  ");
    gc_root(strlit7801);
  }
// compiled string node returning strlit7801 (depth = 7)
  int op_slot_right_7800 = gc_frame_newslot(strlit7801);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7800 = gc_frame_newslot(*var_spc);
  params[0] = strlit7801;
  partcv[0] = 1;
  Object opresult7803 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7803 (depth = 6)
  *var_spc = opresult7803;
  if (opresult7803 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7792 == NULL) {
    strlit7792 = alloc_String("");
    gc_root(strlit7792);
  }
// compiled string node returning strlit7792 (depth = 4)
  *var_spc = strlit7792;
  if (strlit7792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7793 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7794 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7796 = alloc_Float64(0);
// compiled num node returning num7796 (depth = 5)
  int op_slot_left_7794 = gc_frame_newslot(num7796);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7797 = callmethod(num7796, "..", 1, partcv, params);
// compiled op node returning opresult7797 (depth = 4)
  gc_frame_newslot(opresult7797);
// starting to compile block node (depth = 4)
  Object block7798 = alloc_Block(NULL, NULL, "ast", 1949);
  gc_frame_newslot(block7798);
// method "_apply"
  block_savedest(block7798);
  Object closure7799 = createclosure(2, "_apply");
  setclosureframe(closure7799, stackframe);
  addtoclosure(closure7799, var_spc);
  addtoclosure(closure7799, selfslot);
  struct UserObject *uo7799 = (struct UserObject*)block7798;
  uo7799->data[0] = (Object)closure7799;
  Method *meth_meth_ast__apply7799 = addmethod2pos(block7798, "_apply", &meth_ast__apply7799, 0);
  int argcv_meth_ast__apply7799[] = {1};
  meth_meth_ast__apply7799->type = alloc_MethodType(1, argcv_meth_ast__apply7799);
  meth_meth_ast__apply7799->definitionModule = modulename;
  meth_meth_ast__apply7799->definitionLine = 1944;
// compiled block node returning block7798 (depth = 4)
  gc_frame_newslot(block7798);
// call case 5: prelude request
  params[0] = opresult7797;
  params[1] = block7798;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7806 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7793);
// compiled call node returning call7806 (depth = 3)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7808 == NULL) {
    strlit7808 = alloc_String("""\x0a""");
    gc_root(strlit7808);
  }
// compiled string node returning strlit7808 (depth = 5)
  int op_slot_right_7807 = gc_frame_newslot(strlit7808);
// starting to compile call node (depth = 5)
  int callframe7810 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7811 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7810);
// compiled call node returning call7811 (depth = 5)
  int op_slot_left_7807 = gc_frame_newslot(call7811);
  params[0] = strlit7808;
  partcv[0] = 1;
  Object opresult7812 = callmethod(call7811, "++", 1, partcv, params);
// compiled op node returning opresult7812 (depth = 4)
  *var_s = opresult7812;
  if (opresult7812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7814 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7816 = alloc_Float64(1);
// compiled num node returning num7816 (depth = 7)
  int op_slot_right_7815 = gc_frame_newslot(num7816);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7815 = gc_frame_newslot(*var_depth);
  params[0] = num7816;
  partcv[0] = 1;
  Object sum7818 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7818 (depth = 6)
  gc_frame_newslot(sum7818);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7819 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7820 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7819);
// compiled call node returning call7820 (depth = 7)
// compiled member node returning call7820 (depth = 6)
  params[0] = sum7818;
  partcv[0] = 1;
  Object call7821 = callmethod(call7820, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7814);
// compiled call node returning call7821 (depth = 5)
  int op_slot_right_7813 = gc_frame_newslot(call7821);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7823 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7823 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7825 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7825 (depth = 5)
  int op_slot_left_7813 = gc_frame_newslot(opresult7825);
  params[0] = call7821;
  partcv[0] = 1;
  Object opresult7826 = callmethod(opresult7825, "++", 1, partcv, params);
// compiled op node returning opresult7826 (depth = 4)
  *var_s = opresult7826;
  if (opresult7826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7829 == NULL) {
    strlit7829 = alloc_String("""\x0a""");
    gc_root(strlit7829);
  }
// compiled string node returning strlit7829 (depth = 5)
  int op_slot_right_7828 = gc_frame_newslot(strlit7829);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7828 = gc_frame_newslot(*var_s);
  params[0] = strlit7829;
  partcv[0] = 1;
  Object opresult7831 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7831 (depth = 4)
  *var_s = opresult7831;
  if (opresult7831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7834 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7836 = alloc_Float64(1);
// compiled num node returning num7836 (depth = 7)
  int op_slot_right_7835 = gc_frame_newslot(num7836);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7835 = gc_frame_newslot(*var_depth);
  params[0] = num7836;
  partcv[0] = 1;
  Object sum7838 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7838 (depth = 6)
  gc_frame_newslot(sum7838);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7839 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7840 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7839);
// compiled call node returning call7840 (depth = 7)
// compiled member node returning call7840 (depth = 6)
  params[0] = sum7838;
  partcv[0] = 1;
  Object call7841 = callmethod(call7840, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7834);
// compiled call node returning call7841 (depth = 5)
  int op_slot_right_7833 = gc_frame_newslot(call7841);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7843 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7843 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7845 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7845 (depth = 5)
  int op_slot_left_7833 = gc_frame_newslot(opresult7845);
  params[0] = call7841;
  partcv[0] = 1;
  Object opresult7846 = callmethod(opresult7845, "++", 1, partcv, params);
// compiled op node returning opresult7846 (depth = 4)
  *var_s = opresult7846;
  if (opresult7846 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7860(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7862 == NULL) {
    strlit7862 = alloc_String("    ");
    gc_root(strlit7862);
  }
// compiled string node returning strlit7862 (depth = 7)
  int op_slot_right_7861 = gc_frame_newslot(strlit7862);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7861 = gc_frame_newslot(*var_spc);
  params[0] = strlit7862;
  partcv[0] = 1;
  Object opresult7864 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7864 (depth = 6)
  *var_spc = opresult7864;
  if (opresult7864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace7848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7849 == NULL) {
    strlit7849 = alloc_String("");
    gc_root(strlit7849);
  }
// compiled string node returning strlit7849 (depth = 4)
  *var_spc = strlit7849;
  if (strlit7849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7850 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7853 = alloc_Float64(1);
// compiled num node returning num7853 (depth = 6)
  int op_slot_right_7852 = gc_frame_newslot(num7853);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7852 = gc_frame_newslot(*var_depth);
  params[0] = num7853;
  partcv[0] = 1;
  Object diff7855 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff7855 (depth = 5)
  int op_slot_right_7851 = gc_frame_newslot(diff7855);
// starting to compile num node (depth = 5)
  Object num7857 = alloc_Float64(0);
// compiled num node returning num7857 (depth = 5)
  int op_slot_left_7851 = gc_frame_newslot(num7857);
  params[0] = diff7855;
  partcv[0] = 1;
  Object opresult7858 = callmethod(num7857, "..", 1, partcv, params);
// compiled op node returning opresult7858 (depth = 4)
  gc_frame_newslot(opresult7858);
// starting to compile block node (depth = 4)
  Object block7859 = alloc_Block(NULL, NULL, "ast", 1960);
  gc_frame_newslot(block7859);
// method "_apply"
  block_savedest(block7859);
  Object closure7860 = createclosure(2, "_apply");
  setclosureframe(closure7860, stackframe);
  addtoclosure(closure7860, var_spc);
  addtoclosure(closure7860, selfslot);
  struct UserObject *uo7860 = (struct UserObject*)block7859;
  uo7860->data[0] = (Object)closure7860;
  Method *meth_meth_ast__apply7860 = addmethod2pos(block7859, "_apply", &meth_ast__apply7860, 0);
  int argcv_meth_ast__apply7860[] = {1};
  meth_meth_ast__apply7860->type = alloc_MethodType(1, argcv_meth_ast__apply7860);
  meth_meth_ast__apply7860->definitionModule = modulename;
  meth_meth_ast__apply7860->definitionLine = 1955;
// compiled block node returning block7859 (depth = 4)
  gc_frame_newslot(block7859);
// call case 5: prelude request
  params[0] = opresult7858;
  params[1] = block7859;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7867 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7850);
// compiled call node returning call7867 (depth = 3)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7868 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7870 = alloc_Float64(1);
// compiled num node returning num7870 (depth = 6)
  int op_slot_right_7869 = gc_frame_newslot(num7870);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7869 = gc_frame_newslot(*var_depth);
  params[0] = num7870;
  partcv[0] = 1;
  Object sum7872 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7872 (depth = 5)
  gc_frame_newslot(sum7872);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7873 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7874 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7873);
// compiled call node returning call7874 (depth = 6)
// compiled member node returning call7874 (depth = 5)
  params[0] = sum7872;
  partcv[0] = 1;
  Object call7875 = callmethod(call7874, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7868);
// compiled call node returning call7875 (depth = 4)
  *var_s = call7875;
  if (call7875 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7877 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7879 = alloc_Float64(1);
// compiled num node returning num7879 (depth = 7)
  int op_slot_right_7878 = gc_frame_newslot(num7879);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7878 = gc_frame_newslot(*var_depth);
  params[0] = num7879;
  partcv[0] = 1;
  Object sum7881 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7881 (depth = 6)
  gc_frame_newslot(sum7881);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7882 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7883 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7882);
// compiled call node returning call7883 (depth = 7)
// compiled member node returning call7883 (depth = 6)
  params[0] = sum7881;
  partcv[0] = 1;
  Object call7884 = callmethod(call7883, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7877);
// compiled call node returning call7884 (depth = 5)
  int op_slot_right_7876 = gc_frame_newslot(call7884);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7887 == NULL) {
    strlit7887 = alloc_String(" := ");
    gc_root(strlit7887);
  }
// compiled string node returning strlit7887 (depth = 6)
  int op_slot_right_7886 = gc_frame_newslot(strlit7887);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7886 = gc_frame_newslot(*var_s);
  params[0] = strlit7887;
  partcv[0] = 1;
  Object opresult7889 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7889 (depth = 5)
  int op_slot_left_7876 = gc_frame_newslot(opresult7889);
  params[0] = call7884;
  partcv[0] = 1;
  Object opresult7890 = callmethod(opresult7889, "++", 1, partcv, params);
// compiled op node returning opresult7890 (depth = 4)
  *var_s = opresult7890;
  if (opresult7890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7893 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7894 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7895 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7896 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7895);
// compiled call node returning call7896 (depth = 6)
// compiled member node returning call7896 (depth = 5)
  gc_frame_newslot(call7896);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7897 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7898 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7897);
// compiled call node returning call7898 (depth = 6)
// compiled member node returning call7898 (depth = 5)
  gc_frame_newslot(call7898);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_bindNode (depth = 5)
  params[0] = call7896;
  params[1] = call7898;
  partcv[0] = 2;
  Object call7899 = callmethod(*var_bindNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7894);
// compiled call node returning call7899 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7900 = callmethod(call7899, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7893);
// compiled call node returning call7900 (depth = 3)
  gc_frame_end(frame);
  return call7900;
}
Object meth_ast_statementName7901(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7902 == NULL) {
    strlit7902 = alloc_String("assignment or assigment request");
    gc_root(strlit7902);
  }
// compiled string node returning strlit7902 (depth = 3)
  gc_frame_end(frame);
  return strlit7902;
}
Object meth_ast_new7739(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7740 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7740 = alloc_userobj2(13,12, objclass7740);
  gc_frame_newslot(obj7740);
if (objclass7740 == NULL) {
  glfree(obj7740->class->name);
  obj7740->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7740, self, 0);
  addmethodreal(obj7740,"outer", &reader_ast_outer_7741);
  Object oldself7740 = self;
  struct StackFrameObject *oldstackframe7740 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7740);
  gc_frame_newslot((Object)stackframe);
  self = obj7740;
  Object *oldselfslot7740 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7740 = (*(struct UserObject *)self).data[0], lowerouter7740 = thisouter7740;
  if (inheritingObject7740) {
    struct UserObject *inho7740 = (struct UserObject *)inheritingObject7740;
    while (inho7740->super != GraceDefaultObject) inho7740 = (struct UserObject *)inho7740->super;
    inho7740->super = obj7740;
    self = inheritingObject7740;
    *selfslot = self;
    lowerouter7740 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7740;
  }
if (objclass7740 == NULL) {
  Method *reader7742 = addmethodrealflags(obj7740, "kind",&reader_ast_kind_7742, MFLAG_DEF);
  reader7742->definitionModule = modulename;
  reader7742->definitionLine = 1927;
}
adddatum2(obj7740, alloc_Undefined(), 1);
if (objclass7740 == NULL) {
  Method *reader7743 = addmethodrealflags(obj7740, "dest",&reader_ast_dest_7743, 0);
  Method *writer7743 = addmethodrealflags(obj7740, "dest:=",&writer_ast_dest_7743, 0);
  reader7743->definitionModule = modulename;
  writer7743->definitionModule = modulename;
  reader7743->definitionLine = 1928;
  writer7743->definitionLine = 1928;
}
obj7740->flags |= OFLAG_MUTABLE;
adddatum2(obj7740, alloc_Undefined(), 2);
if (objclass7740 == NULL) {
  Method *reader7744 = addmethodrealflags(obj7740, "value",&reader_ast_value_7744, 0);
  Method *writer7744 = addmethodrealflags(obj7740, "value:=",&writer_ast_value_7744, 0);
  reader7744->definitionModule = modulename;
  writer7744->definitionModule = modulename;
  reader7744->definitionLine = 1929;
  writer7744->definitionLine = 1929;
}
obj7740->flags |= OFLAG_MUTABLE;
adddatum2(obj7740, alloc_Undefined(), 3);
// method "isBind"
  struct UserObject *uo7745 = (struct UserObject*)obj7740;
  uo7745->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7745 = addmethod2pos(obj7740, "isBind", &meth_ast_isBind7745, 4);
  int argcv_meth_ast_isBind7745[] = {0};
  meth_meth_ast_isBind7745->type = alloc_MethodType(1, argcv_meth_ast_isBind7745);
  meth_meth_ast_isBind7745->definitionModule = modulename;
  meth_meth_ast_isBind7745->definitionLine = 1931;
// method "asString"
  struct UserObject *uo7747 = (struct UserObject*)obj7740;
  uo7747->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7747 = addmethod2pos(obj7740, "asString", &meth_ast_asString7747, 5);
  int argcv_meth_ast_asString7747[] = {0};
  meth_meth_ast_asString7747->type = alloc_MethodType(1, argcv_meth_ast_asString7747);
  meth_meth_ast_asString7747->definitionModule = modulename;
  meth_meth_ast_asString7747->definitionLine = 1932;
// method "accept()from"
  struct UserObject *uo7758 = (struct UserObject*)obj7740;
  uo7758->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7758 = addmethod2pos(obj7740, "accept()from", &meth_ast_accept_40__41_from7758, 6);
  int argcv_meth_ast_accept_40__41_from7758[] = {1, 1};
  meth_meth_ast_accept_40__41_from7758->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7758);
  meth_meth_ast_accept_40__41_from7758->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7758->definitionLine = 1933;
// method "map()ancestors"
  struct UserObject *uo7772 = (struct UserObject*)obj7740;
  uo7772->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7772 = addmethod2pos(obj7740, "map()ancestors", &meth_ast_map_40__41_ancestors7772, 7);
  int argcv_meth_ast_map_40__41_ancestors7772[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7772->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7772);
  meth_meth_ast_map_40__41_ancestors7772->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7772->definitionLine = 1940;
// method "pretty"
  struct UserObject *uo7791 = (struct UserObject*)obj7740;
  uo7791->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7791 = addmethod2pos(obj7740, "pretty", &meth_ast_pretty7791, 8);
  int argcv_meth_ast_pretty7791[] = {1};
  meth_meth_ast_pretty7791->type = alloc_MethodType(1, argcv_meth_ast_pretty7791);
  meth_meth_ast_pretty7791->definitionModule = modulename;
  meth_meth_ast_pretty7791->definitionLine = 1947;
// method "toGrace"
  struct UserObject *uo7848 = (struct UserObject*)obj7740;
  uo7848->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7848 = addmethod2pos(obj7740, "toGrace", &meth_ast_toGrace7848, 9);
  int argcv_meth_ast_toGrace7848[] = {1};
  meth_meth_ast_toGrace7848->type = alloc_MethodType(1, argcv_meth_ast_toGrace7848);
meth_meth_ast_toGrace7848->type->types[0] = type_Number;
meth_meth_ast_toGrace7848->type->names[0] = "depth";
  meth_meth_ast_toGrace7848->definitionModule = modulename;
  meth_meth_ast_toGrace7848->definitionLine = 1958;
// method "shallowCopy"
  block_savedest(obj7740);
  Object closure7892 = createclosure(1, "shallowCopy");
  setclosureframe(closure7892, stackframe);
  addtoclosure(closure7892, var_bindNode);
  struct UserObject *uo7892 = (struct UserObject*)obj7740;
  uo7892->data[10] = (Object)closure7892;
  Method *meth_meth_ast_shallowCopy7892 = addmethod2pos(obj7740, "shallowCopy", &meth_ast_shallowCopy7892, 10);
  int argcv_meth_ast_shallowCopy7892[] = {0};
  meth_meth_ast_shallowCopy7892->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7892);
  meth_meth_ast_shallowCopy7892->definitionModule = modulename;
  meth_meth_ast_shallowCopy7892->definitionLine = 1967;
// method "statementName"
  struct UserObject *uo7901 = (struct UserObject*)obj7740;
  uo7901->data[11] = emptyclosure;
  Method *meth_meth_ast_statementName7901 = addmethod2pos(obj7740, "statementName", &meth_ast_statementName7901, 11);
  int argcv_meth_ast_statementName7901[] = {0};
  meth_meth_ast_statementName7901->type = alloc_MethodType(1, argcv_meth_ast_statementName7901);
  meth_meth_ast_statementName7901->definitionModule = modulename;
  meth_meth_ast_statementName7901->definitionLine = 1970;
  sourceObject = obj7740;
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7903 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7904 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7905 = gc_frame_new();
// call case 3: self.outer request
  Object call7906 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7905);
// compiled call node returning call7906 (depth = 7)
// compiled member node returning call7906 (depth = 6)
  partcv[0] = 0;
  Object call7907 = callmethodflags(call7906, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7904);
// compiled call node returning call7907 (depth = 5)
// compiled member node returning call7907 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7908 = callmethodflags(call7907, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7903);
// compiled call node returning call7908 (depth = 3)
  struct UserObject *obj7740_uo = (struct UserObject *)obj7740;
  obj7740_uo->super = call7908;
  sourceObject = obj7740;
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7909 == NULL) {
    strlit7909 = alloc_String("bind");
    gc_root(strlit7909);
  }
// compiled string node returning strlit7909 (depth = 3)
  adddatum2(obj7740, strlit7909, 1);
  sourceObject = obj7740;
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7740, *var_dest_39_, 2);
  sourceObject = obj7740;
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7740, *var_val_39_, 3);
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  objclass7740 = obj7740->class;
  objclass7740->definitionModule = modulename;
  objclass7740->definitionLine = 1924;
  (*(struct UserObject *)self).data[0] = lowerouter7740;
  self = oldself7740;
  selfslot = oldselfslot7740;
  stackframe = oldstackframe7740;
  gc_frame_end(frame);
  return obj7740;
}
Object meth_ast_new7739_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7740 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7740 = alloc_userobj2(13,12, objclass7740);
  gc_frame_newslot(obj7740);
if (objclass7740 == NULL) {
  glfree(obj7740->class->name);
  obj7740->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7740, self, 0);
  addmethodreal(obj7740,"outer", &reader_ast_outer_7741);
  Object oldself7740 = self;
  struct StackFrameObject *oldstackframe7740 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7740);
  gc_frame_newslot((Object)stackframe);
  self = obj7740;
  Object *oldselfslot7740 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7740 = (*(struct UserObject *)self).data[0], lowerouter7740 = thisouter7740;
  if (inheritingObject7740) {
    struct UserObject *inho7740 = (struct UserObject *)inheritingObject7740;
    while (inho7740->super != GraceDefaultObject) inho7740 = (struct UserObject *)inho7740->super;
    inho7740->super = obj7740;
    self = inheritingObject7740;
    *selfslot = self;
    lowerouter7740 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7740;
  }
if (objclass7740 == NULL) {
  Method *reader7742 = addmethodrealflags(obj7740, "kind",&reader_ast_kind_7742, MFLAG_DEF);
  reader7742->definitionModule = modulename;
  reader7742->definitionLine = 1927;
}
adddatum2(obj7740, alloc_Undefined(), 1);
if (objclass7740 == NULL) {
  Method *reader7743 = addmethodrealflags(obj7740, "dest",&reader_ast_dest_7743, 0);
  Method *writer7743 = addmethodrealflags(obj7740, "dest:=",&writer_ast_dest_7743, 0);
  reader7743->definitionModule = modulename;
  writer7743->definitionModule = modulename;
  reader7743->definitionLine = 1928;
  writer7743->definitionLine = 1928;
}
obj7740->flags |= OFLAG_MUTABLE;
adddatum2(obj7740, alloc_Undefined(), 2);
if (objclass7740 == NULL) {
  Method *reader7744 = addmethodrealflags(obj7740, "value",&reader_ast_value_7744, 0);
  Method *writer7744 = addmethodrealflags(obj7740, "value:=",&writer_ast_value_7744, 0);
  reader7744->definitionModule = modulename;
  writer7744->definitionModule = modulename;
  reader7744->definitionLine = 1929;
  writer7744->definitionLine = 1929;
}
obj7740->flags |= OFLAG_MUTABLE;
adddatum2(obj7740, alloc_Undefined(), 3);
// method "isBind"
  struct UserObject *uo7745 = (struct UserObject*)obj7740;
  uo7745->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7745 = addmethod2pos(obj7740, "isBind", &meth_ast_isBind7745, 4);
  int argcv_meth_ast_isBind7745[] = {0};
  meth_meth_ast_isBind7745->type = alloc_MethodType(1, argcv_meth_ast_isBind7745);
  meth_meth_ast_isBind7745->definitionModule = modulename;
  meth_meth_ast_isBind7745->definitionLine = 1931;
// method "asString"
  struct UserObject *uo7747 = (struct UserObject*)obj7740;
  uo7747->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7747 = addmethod2pos(obj7740, "asString", &meth_ast_asString7747, 5);
  int argcv_meth_ast_asString7747[] = {0};
  meth_meth_ast_asString7747->type = alloc_MethodType(1, argcv_meth_ast_asString7747);
  meth_meth_ast_asString7747->definitionModule = modulename;
  meth_meth_ast_asString7747->definitionLine = 1932;
// method "accept()from"
  struct UserObject *uo7758 = (struct UserObject*)obj7740;
  uo7758->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7758 = addmethod2pos(obj7740, "accept()from", &meth_ast_accept_40__41_from7758, 6);
  int argcv_meth_ast_accept_40__41_from7758[] = {1, 1};
  meth_meth_ast_accept_40__41_from7758->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7758);
  meth_meth_ast_accept_40__41_from7758->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7758->definitionLine = 1933;
// method "map()ancestors"
  struct UserObject *uo7772 = (struct UserObject*)obj7740;
  uo7772->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7772 = addmethod2pos(obj7740, "map()ancestors", &meth_ast_map_40__41_ancestors7772, 7);
  int argcv_meth_ast_map_40__41_ancestors7772[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7772->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7772);
  meth_meth_ast_map_40__41_ancestors7772->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7772->definitionLine = 1940;
// method "pretty"
  struct UserObject *uo7791 = (struct UserObject*)obj7740;
  uo7791->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7791 = addmethod2pos(obj7740, "pretty", &meth_ast_pretty7791, 8);
  int argcv_meth_ast_pretty7791[] = {1};
  meth_meth_ast_pretty7791->type = alloc_MethodType(1, argcv_meth_ast_pretty7791);
  meth_meth_ast_pretty7791->definitionModule = modulename;
  meth_meth_ast_pretty7791->definitionLine = 1947;
// method "toGrace"
  struct UserObject *uo7848 = (struct UserObject*)obj7740;
  uo7848->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7848 = addmethod2pos(obj7740, "toGrace", &meth_ast_toGrace7848, 9);
  int argcv_meth_ast_toGrace7848[] = {1};
  meth_meth_ast_toGrace7848->type = alloc_MethodType(1, argcv_meth_ast_toGrace7848);
meth_meth_ast_toGrace7848->type->types[0] = type_Number;
meth_meth_ast_toGrace7848->type->names[0] = "depth";
  meth_meth_ast_toGrace7848->definitionModule = modulename;
  meth_meth_ast_toGrace7848->definitionLine = 1958;
// method "shallowCopy"
  block_savedest(obj7740);
  Object closure7892 = createclosure(1, "shallowCopy");
  setclosureframe(closure7892, stackframe);
  addtoclosure(closure7892, var_bindNode);
  struct UserObject *uo7892 = (struct UserObject*)obj7740;
  uo7892->data[10] = (Object)closure7892;
  Method *meth_meth_ast_shallowCopy7892 = addmethod2pos(obj7740, "shallowCopy", &meth_ast_shallowCopy7892, 10);
  int argcv_meth_ast_shallowCopy7892[] = {0};
  meth_meth_ast_shallowCopy7892->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7892);
  meth_meth_ast_shallowCopy7892->definitionModule = modulename;
  meth_meth_ast_shallowCopy7892->definitionLine = 1967;
// method "statementName"
  struct UserObject *uo7901 = (struct UserObject*)obj7740;
  uo7901->data[11] = emptyclosure;
  Method *meth_meth_ast_statementName7901 = addmethod2pos(obj7740, "statementName", &meth_ast_statementName7901, 11);
  int argcv_meth_ast_statementName7901[] = {0};
  meth_meth_ast_statementName7901->type = alloc_MethodType(1, argcv_meth_ast_statementName7901);
  meth_meth_ast_statementName7901->definitionModule = modulename;
  meth_meth_ast_statementName7901->definitionLine = 1970;
  sourceObject = obj7740;
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7903 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7904 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7905 = gc_frame_new();
// call case 3: self.outer request
  Object call7906 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7905);
// compiled call node returning call7906 (depth = 7)
// compiled member node returning call7906 (depth = 6)
  partcv[0] = 0;
  Object call7907 = callmethodflags(call7906, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7904);
// compiled call node returning call7907 (depth = 5)
// compiled member node returning call7907 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7908 = callmethodflags(call7907, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7903);
// compiled call node returning call7908 (depth = 3)
  struct UserObject *obj7740_uo = (struct UserObject *)obj7740;
  obj7740_uo->super = call7908;
  sourceObject = obj7740;
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7909 == NULL) {
    strlit7909 = alloc_String("bind");
    gc_root(strlit7909);
  }
// compiled string node returning strlit7909 (depth = 3)
  adddatum2(obj7740, strlit7909, 1);
  sourceObject = obj7740;
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7740, *var_dest_39_, 2);
  sourceObject = obj7740;
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7740, *var_val_39_, 3);
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  sourceObject = obj7740;
  objclass7740 = obj7740->class;
  objclass7740->definitionModule = modulename;
  objclass7740->definitionLine = 1924;
  (*(struct UserObject *)self).data[0] = lowerouter7740;
  self = oldself7740;
  selfslot = oldselfslot7740;
  stackframe = oldstackframe7740;
  gc_frame_end(frame);
  return obj7740;
}
Object meth_ast_bindNode7911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for bindNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for bindNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_new_40__41_scope7914(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7915 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name_39_ (depth = 5)
  gc_frame_newslot(*var_name_39_);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype_39_ (depth = 5)
  gc_frame_newslot(*var_dtype_39_);
// call case 4: self request
  params[0] = *var_name_39_;
  params[1] = *var_val;
  params[2] = *var_dtype_39_;
  partcv[0] = 3;
  Object call7916 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7915);
// compiled call node returning call7916 (depth = 4)
  *var_result = call7916;
  if (call7916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7917 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7918 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe7917);
// compiled call node returning call7918 (depth = 3)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isPublic7929(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7932 = alloc_Float64(0);
// compiled num node returning num7932 (depth = 5)
  int op_slot_right_7931 = gc_frame_newslot(num7932);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7934 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7935 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7936 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7935);
// compiled call node returning call7936 (depth = 8)
// compiled member node returning call7936 (depth = 7)
  partcv[0] = 0;
  Object call7937 = callmethod(call7936, "size",
    1, partcv, params);
  gc_frame_end(callframe7934);
// compiled call node returning call7937 (depth = 6)
// compiled member node returning call7937 (depth = 5)
  int op_slot_left_7931 = gc_frame_newslot(call7937);
  params[0] = num7932;
  partcv[0] = 1;
  Object opresult7938 = callmethod(call7937, "==", 1, partcv, params);
// compiled op node returning opresult7938 (depth = 4)
  Object if7930 = done;
  if (istrue(opresult7938)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7939 = alloc_Boolean(0);
// compiled identifier node returning bool7939 (depth = 5)
  return bool7939;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7930 = undefined;
  } else {
  }
// compiled if node returning if7930 (depth = 3)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7941 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit7942 == NULL) {
    strlit7942 = alloc_String("public");
    gc_root(strlit7942);
  }
// compiled string node returning strlit7942 (depth = 5)
  gc_frame_newslot(strlit7942);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7943 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7944 = gc_frame_new();
// call case 3: self.outer request
  Object call7945 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7944);
// compiled call node returning call7945 (depth = 8)
// compiled member node returning call7945 (depth = 7)
  partcv[0] = 0;
  Object call7946 = callmethodflags(call7945, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7943);
// compiled call node returning call7946 (depth = 6)
// compiled member node returning call7946 (depth = 5)
  params[0] = self;
  params[1] = strlit7942;
  partcv[0] = 2;
  Object call7947 = callmethodflags(call7946, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7941);
// compiled call node returning call7947 (depth = 4)
  Object if7940 = done;
  if (istrue(call7947)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7948 = alloc_Boolean(1);
// compiled identifier node returning bool7948 (depth = 5)
  return bool7948;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7940 = undefined;
  } else {
  }
// compiled if node returning if7940 (depth = 3)
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7949 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit7950 == NULL) {
    strlit7950 = alloc_String("readable");
    gc_root(strlit7950);
  }
// compiled string node returning strlit7950 (depth = 4)
  gc_frame_newslot(strlit7950);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7951 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7952 = gc_frame_new();
// call case 3: self.outer request
  Object call7953 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7952);
// compiled call node returning call7953 (depth = 7)
// compiled member node returning call7953 (depth = 6)
  partcv[0] = 0;
  Object call7954 = callmethodflags(call7953, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7951);
// compiled call node returning call7954 (depth = 5)
// compiled member node returning call7954 (depth = 4)
  params[0] = self;
  params[1] = strlit7950;
  partcv[0] = 2;
  Object call7955 = callmethodflags(call7954, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7949);
// compiled call node returning call7955 (depth = 3)
  gc_frame_end(frame);
  return call7955;
}
Object meth_ast_isFieldDec7956(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7957 = alloc_Boolean(1);
// compiled identifier node returning bool7957 (depth = 3)
  gc_frame_end(frame);
  return bool7957;
}
Object meth_ast_isWritable7958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7959 = alloc_Boolean(0);
// compiled identifier node returning bool7959 (depth = 3)
  gc_frame_end(frame);
  return bool7959;
}
Object meth_ast_isReadable7960(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7961 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7962 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7961);
// compiled call node returning call7962 (depth = 4)
// compiled member node returning call7962 (depth = 3)
  gc_frame_end(frame);
  return call7962;
}
Object meth_ast_returnsObject7963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7964 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7965 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7966 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7965);
// compiled call node returning call7966 (depth = 6)
// compiled member node returning call7966 (depth = 5)
  partcv[0] = 0;
  Object call7967 = callmethod(call7966, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe7964);
// compiled call node returning call7967 (depth = 4)
// compiled member node returning call7967 (depth = 3)
  gc_frame_end(frame);
  return call7967;
}
Object meth_ast_returnedObjectScope7968(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7969 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7970 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7971 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7970);
// compiled call node returning call7971 (depth = 6)
// compiled member node returning call7971 (depth = 5)
  partcv[0] = 0;
  Object call7972 = callmethod(call7971, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe7969);
// compiled call node returning call7972 (depth = 4)
// compiled member node returning call7972 (depth = 3)
  gc_frame_end(frame);
  return call7972;
}
Object meth_ast_usesAsType7973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7975 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7976 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7975);
// compiled call node returning call7976 (depth = 5)
// compiled member node returning call7976 (depth = 4)
  int op_slot_right_7974 = gc_frame_newslot(call7976);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_7974 = gc_frame_newslot(*var_aNode);
  params[0] = call7976;
  partcv[0] = 1;
  Object opresult7978 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult7978 (depth = 3)
  gc_frame_end(frame);
  return opresult7978;
}
Object meth_ast_declarationKindWithAncestors7979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7980 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call7981 = callmethod(*var_k, "defdec",
    1, partcv, params);
  gc_frame_end(callframe7980);
// compiled call node returning call7981 (depth = 4)
// compiled member node returning call7981 (depth = 3)
  gc_frame_end(frame);
  return call7981;
}
Object meth_ast__apply8007(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8008 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8009 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8008);
// compiled call node returning call8009 (depth = 6)
  gc_frame_end(frame);
  return call8009;
}
Object meth_ast_accept_40__41_from7982(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7984 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7985 = callmethod(*var_visitor, "visitDefDec()up",
    2, partcv, params);
  gc_frame_end(callframe7984);
// compiled call node returning call7985 (depth = 4)
  Object if7983 = done;
  if (istrue(call7985)) {
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7986 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7987 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7986);
// compiled call node returning call7987 (depth = 5)
  *var_newChain = call7987;
  if (call7987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7988 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7989 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7990 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7989);
// compiled call node returning call7990 (depth = 6)
// compiled member node returning call7990 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7991 = callmethod(call7990, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7988);
// compiled call node returning call7991 (depth = 4)
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7994 = alloc_Boolean(0);
// compiled identifier node returning bool7994 (depth = 6)
  int op_slot_right_7993 = gc_frame_newslot(bool7994);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7996 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7997 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7996);
// compiled call node returning call7997 (depth = 7)
// compiled member node returning call7997 (depth = 6)
  int op_slot_left_7993 = gc_frame_newslot(call7997);
  params[0] = bool7994;
  partcv[0] = 1;
  Object opresult7998 = callmethod(call7997, "!=", 1, partcv, params);
// compiled op node returning opresult7998 (depth = 5)
  Object if7992 = done;
  if (istrue(opresult7998)) {
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7999 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8001 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8000);
// compiled call node returning call8001 (depth = 7)
// compiled member node returning call8001 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8002 = callmethod(call8001, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7999);
// compiled call node returning call8002 (depth = 5)
    gc_frame_newslot(call8002);
    if7992 = call8002;
  } else {
  }
// compiled if node returning if7992 (depth = 4)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8003 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8004 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8005 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8004);
// compiled call node returning call8005 (depth = 6)
// compiled member node returning call8005 (depth = 5)
  gc_frame_newslot(call8005);
// starting to compile block node (depth = 5)
  Object block8006 = alloc_Block(NULL, NULL, "ast", 2019);
  gc_frame_newslot(block8006);
// method "_apply"
  block_savedest(block8006);
  Object closure8007 = createclosure(3, "_apply");
  setclosureframe(closure8007, stackframe);
  addtoclosure(closure8007, var_visitor);
  addtoclosure(closure8007, var_newChain);
  addtoclosure(closure8007, selfslot);
  struct UserObject *uo8007 = (struct UserObject*)block8006;
  uo8007->data[0] = (Object)closure8007;
  Method *meth_meth_ast__apply8007 = addmethod2pos(block8006, "_apply", &meth_ast__apply8007, 0);
  int argcv_meth_ast__apply8007[] = {1};
  meth_meth_ast__apply8007->type = alloc_MethodType(1, argcv_meth_ast__apply8007);
  meth_meth_ast__apply8007->definitionModule = modulename;
  meth_meth_ast__apply8007->definitionLine = 2019;
// compiled block node returning block8006 (depth = 5)
  gc_frame_newslot(block8006);
// call case 5: prelude request
  params[0] = call8005;
  params[1] = block8006;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8011 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8003);
// compiled call node returning call8011 (depth = 4)
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8012 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8014 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8013);
// compiled call node returning call8014 (depth = 6)
// compiled member node returning call8014 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8015 = callmethod(call8014, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8012);
// compiled call node returning call8015 (depth = 4)
    gc_frame_newslot(call8015);
    if7983 = call8015;
  } else {
  }
// compiled if node returning if7983 (depth = 3)
  gc_frame_end(frame);
  return if7983;
}
Object meth_ast_map_40__41_ancestors8016(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8018 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8017);
// compiled call node returning call8018 (depth = 5)
// compiled member node returning call8018 (depth = 4)
  *var_n = call8018;
  if (call8018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8019 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8020 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8019);
// compiled call node returning call8020 (depth = 4)
  *var_newChain = call8020;
  if (call8020 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8021 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8022 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8024 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8023);
// compiled call node returning call8024 (depth = 6)
// compiled member node returning call8024 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8025 = callmethod(call8024, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8022);
// compiled call node returning call8025 (depth = 4)
  gc_frame_newslot(call8025);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8025;
  partcv[0] = 1;
  Object call8026 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8021);
// compiled call node returning call8026 (depth = 3)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8027 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8028 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8030 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8029);
// compiled call node returning call8030 (depth = 6)
// compiled member node returning call8030 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8031 = callmethod(call8030, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8028);
// compiled call node returning call8031 (depth = 4)
  gc_frame_newslot(call8031);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8031;
  partcv[0] = 1;
  Object call8032 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8027);
// compiled call node returning call8032 (depth = 3)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8033 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8034 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8035 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8036 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8035);
// compiled call node returning call8036 (depth = 6)
// compiled member node returning call8036 (depth = 5)
  gc_frame_newslot(call8036);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8037 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8038 = gc_frame_new();
// call case 3: self.outer request
  Object call8039 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8038);
// compiled call node returning call8039 (depth = 8)
// compiled member node returning call8039 (depth = 7)
  partcv[0] = 0;
  Object call8040 = callmethodflags(call8039, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8037);
// compiled call node returning call8040 (depth = 6)
// compiled member node returning call8040 (depth = 5)
  params[0] = call8036;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8041 = callmethodflags(call8040, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8034);
// compiled call node returning call8041 (depth = 4)
  gc_frame_newslot(call8041);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8041;
  partcv[0] = 1;
  Object call8042 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8033);
// compiled call node returning call8042 (depth = 3)
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8043 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8044 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8045 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8046 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8045);
// compiled call node returning call8046 (depth = 6)
// compiled member node returning call8046 (depth = 5)
  gc_frame_newslot(call8046);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8047 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8048 = gc_frame_new();
// call case 3: self.outer request
  Object call8049 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8048);
// compiled call node returning call8049 (depth = 8)
// compiled member node returning call8049 (depth = 7)
  partcv[0] = 0;
  Object call8050 = callmethodflags(call8049, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8047);
// compiled call node returning call8050 (depth = 6)
// compiled member node returning call8050 (depth = 5)
  params[0] = call8046;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8051 = callmethodflags(call8050, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8044);
// compiled call node returning call8051 (depth = 4)
  gc_frame_newslot(call8051);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8051;
  partcv[0] = 1;
  Object call8052 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8043);
// compiled call node returning call8052 (depth = 3)
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8053 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8054 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8053);
// compiled call node returning call8054 (depth = 3)
  gc_frame_end(frame);
  return call8054;
}
Object meth_ast__apply8063(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8065 == NULL) {
    strlit8065 = alloc_String("  ");
    gc_root(strlit8065);
  }
// compiled string node returning strlit8065 (depth = 7)
  int op_slot_right_8064 = gc_frame_newslot(strlit8065);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8064 = gc_frame_newslot(*var_spc);
  params[0] = strlit8065;
  partcv[0] = 1;
  Object opresult8067 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8067 (depth = 6)
  *var_spc = opresult8067;
  if (opresult8067 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8169(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8171 == NULL) {
    strlit8171 = alloc_String("");
    gc_root(strlit8171);
  }
// compiled string node returning strlit8171 (depth = 8)
  int op_slot_right_8170 = gc_frame_newslot(strlit8171);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8174 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num8176 = alloc_Float64(2);
// compiled num node returning num8176 (depth = 11)
  int op_slot_right_8175 = gc_frame_newslot(num8176);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_8175 = gc_frame_newslot(*var_depth);
  params[0] = num8176;
  partcv[0] = 1;
  Object sum8178 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8178 (depth = 10)
  gc_frame_newslot(sum8178);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  params[0] = sum8178;
  partcv[0] = 1;
  Object call8179 = callmethod(*var_ann, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8174);
// compiled call node returning call8179 (depth = 9)
  int op_slot_right_8173 = gc_frame_newslot(call8179);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8182 == NULL) {
    strlit8182 = alloc_String(" ");
    gc_root(strlit8182);
  }
// compiled string node returning strlit8182 (depth = 10)
  int op_slot_right_8181 = gc_frame_newslot(strlit8182);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_8184 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit8186 == NULL) {
    strlit8186 = alloc_String("");
    gc_root(strlit8186);
  }
// compiled string node returning strlit8186 (depth = 11)
  int op_slot_left_8184 = gc_frame_newslot(strlit8186);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult8187 = callmethod(strlit8186, "++", 1, partcv, params);
// compiled op node returning opresult8187 (depth = 10)
  int op_slot_left_8181 = gc_frame_newslot(opresult8187);
  params[0] = strlit8182;
  partcv[0] = 1;
  Object opresult8188 = callmethod(opresult8187, "++", 1, partcv, params);
// compiled op node returning opresult8188 (depth = 9)
  int op_slot_left_8173 = gc_frame_newslot(opresult8188);
  params[0] = call8179;
  partcv[0] = 1;
  Object opresult8189 = callmethod(opresult8188, "++", 1, partcv, params);
// compiled op node returning opresult8189 (depth = 8)
  int op_slot_left_8170 = gc_frame_newslot(opresult8189);
  params[0] = strlit8171;
  partcv[0] = 1;
  Object opresult8190 = callmethod(opresult8189, "++", 1, partcv, params);
// compiled op node returning opresult8190 (depth = 7)
  *var_s = opresult8190;
  if (opresult8190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8055(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8056 == NULL) {
    strlit8056 = alloc_String("");
    gc_root(strlit8056);
  }
// compiled string node returning strlit8056 (depth = 4)
  *var_spc = strlit8056;
  if (strlit8056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8057 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8058 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8060 = alloc_Float64(0);
// compiled num node returning num8060 (depth = 5)
  int op_slot_left_8058 = gc_frame_newslot(num8060);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8061 = callmethod(num8060, "..", 1, partcv, params);
// compiled op node returning opresult8061 (depth = 4)
  gc_frame_newslot(opresult8061);
// starting to compile block node (depth = 4)
  Object block8062 = alloc_Block(NULL, NULL, "ast", 2036);
  gc_frame_newslot(block8062);
// method "_apply"
  block_savedest(block8062);
  Object closure8063 = createclosure(2, "_apply");
  setclosureframe(closure8063, stackframe);
  addtoclosure(closure8063, var_spc);
  addtoclosure(closure8063, selfslot);
  struct UserObject *uo8063 = (struct UserObject*)block8062;
  uo8063->data[0] = (Object)closure8063;
  Method *meth_meth_ast__apply8063 = addmethod2pos(block8062, "_apply", &meth_ast__apply8063, 0);
  int argcv_meth_ast__apply8063[] = {1};
  meth_meth_ast__apply8063->type = alloc_MethodType(1, argcv_meth_ast__apply8063);
  meth_meth_ast__apply8063->definitionModule = modulename;
  meth_meth_ast__apply8063->definitionLine = 2031;
// compiled block node returning block8062 (depth = 4)
  gc_frame_newslot(block8062);
// call case 5: prelude request
  params[0] = opresult8061;
  params[1] = block8062;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8070 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8057);
// compiled call node returning call8070 (depth = 3)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8072 == NULL) {
    strlit8072 = alloc_String("""\x0a""");
    gc_root(strlit8072);
  }
// compiled string node returning strlit8072 (depth = 5)
  int op_slot_right_8071 = gc_frame_newslot(strlit8072);
// starting to compile call node (depth = 5)
  int callframe8074 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8075 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8074);
// compiled call node returning call8075 (depth = 5)
  int op_slot_left_8071 = gc_frame_newslot(call8075);
  params[0] = strlit8072;
  partcv[0] = 1;
  Object opresult8076 = callmethod(call8075, "++", 1, partcv, params);
// compiled op node returning opresult8076 (depth = 4)
  *var_s = opresult8076;
  if (opresult8076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8078 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8080 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8079);
// compiled call node returning call8080 (depth = 7)
// compiled member node returning call8080 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8081 = callmethod(call8080, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8078);
// compiled call node returning call8081 (depth = 5)
  int op_slot_right_8077 = gc_frame_newslot(call8081);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8083 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8083 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8085 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8085 (depth = 5)
  int op_slot_left_8077 = gc_frame_newslot(opresult8085);
  params[0] = call8081;
  partcv[0] = 1;
  Object opresult8086 = callmethod(opresult8085, "++", 1, partcv, params);
// compiled op node returning opresult8086 (depth = 4)
  *var_s = opresult8086;
  if (opresult8086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8090 = alloc_Boolean(0);
// compiled identifier node returning bool8090 (depth = 5)
  int op_slot_right_8089 = gc_frame_newslot(bool8090);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8092 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8093 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8092);
// compiled call node returning call8093 (depth = 6)
// compiled member node returning call8093 (depth = 5)
  int op_slot_left_8089 = gc_frame_newslot(call8093);
  params[0] = bool8090;
  partcv[0] = 1;
  Object opresult8094 = callmethod(call8093, "!=", 1, partcv, params);
// compiled op node returning opresult8094 (depth = 4)
  Object if8088 = done;
  if (istrue(opresult8094)) {
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8096 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8098 = alloc_Float64(2);
// compiled num node returning num8098 (depth = 8)
  int op_slot_right_8097 = gc_frame_newslot(num8098);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8097 = gc_frame_newslot(*var_depth);
  params[0] = num8098;
  partcv[0] = 1;
  Object sum8100 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8100 (depth = 7)
  gc_frame_newslot(sum8100);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8102 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8101);
// compiled call node returning call8102 (depth = 8)
// compiled member node returning call8102 (depth = 7)
  params[0] = sum8100;
  partcv[0] = 1;
  Object call8103 = callmethod(call8102, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8096);
// compiled call node returning call8103 (depth = 6)
  int op_slot_right_8095 = gc_frame_newslot(call8103);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8106 == NULL) {
    strlit8106 = alloc_String("Type: ");
    gc_root(strlit8106);
  }
// compiled string node returning strlit8106 (depth = 7)
  int op_slot_right_8105 = gc_frame_newslot(strlit8106);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8108 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8111 == NULL) {
    strlit8111 = alloc_String("""\x0a""");
    gc_root(strlit8111);
  }
// compiled string node returning strlit8111 (depth = 9)
  int op_slot_right_8110 = gc_frame_newslot(strlit8111);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8110 = gc_frame_newslot(*var_s);
  params[0] = strlit8111;
  partcv[0] = 1;
  Object opresult8113 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8113 (depth = 8)
  int op_slot_left_8108 = gc_frame_newslot(opresult8113);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8114 = callmethod(opresult8113, "++", 1, partcv, params);
// compiled op node returning opresult8114 (depth = 7)
  int op_slot_left_8105 = gc_frame_newslot(opresult8114);
  params[0] = strlit8106;
  partcv[0] = 1;
  Object opresult8115 = callmethod(opresult8114, "++", 1, partcv, params);
// compiled op node returning opresult8115 (depth = 6)
  int op_slot_left_8095 = gc_frame_newslot(opresult8115);
  params[0] = call8103;
  partcv[0] = 1;
  Object opresult8116 = callmethod(opresult8115, "++", 1, partcv, params);
// compiled op node returning opresult8116 (depth = 5)
  *var_s = opresult8116;
  if (opresult8116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8088 = done;
  } else {
  }
// compiled if node returning if8088 (depth = 3)
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8121 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8120);
// compiled call node returning call8121 (depth = 6)
// compiled member node returning call8121 (depth = 5)
  int op_slot_right_8119 = gc_frame_newslot(call8121);
// starting to compile identifier node (depth = 5)
  Object bool8123 = alloc_Boolean(0);
// compiled identifier node returning bool8123 (depth = 5)
  int op_slot_left_8119 = gc_frame_newslot(bool8123);
  params[0] = call8121;
  partcv[0] = 1;
  Object opresult8124 = callmethod(bool8123, "!=", 1, partcv, params);
// compiled op node returning opresult8124 (depth = 4)
  Object if8118 = done;
  if (istrue(opresult8124)) {
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8126 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8128 = alloc_Float64(2);
// compiled num node returning num8128 (depth = 8)
  int op_slot_right_8127 = gc_frame_newslot(num8128);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8127 = gc_frame_newslot(*var_depth);
  params[0] = num8128;
  partcv[0] = 1;
  Object sum8130 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8130 (depth = 7)
  gc_frame_newslot(sum8130);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8132 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8131);
// compiled call node returning call8132 (depth = 8)
// compiled member node returning call8132 (depth = 7)
  params[0] = sum8130;
  partcv[0] = 1;
  Object call8133 = callmethod(call8132, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8126);
// compiled call node returning call8133 (depth = 6)
  int op_slot_right_8125 = gc_frame_newslot(call8133);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8136 == NULL) {
    strlit8136 = alloc_String("Value: ");
    gc_root(strlit8136);
  }
// compiled string node returning strlit8136 (depth = 7)
  int op_slot_right_8135 = gc_frame_newslot(strlit8136);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8138 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8141 == NULL) {
    strlit8141 = alloc_String("""\x0a""");
    gc_root(strlit8141);
  }
// compiled string node returning strlit8141 (depth = 9)
  int op_slot_right_8140 = gc_frame_newslot(strlit8141);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8140 = gc_frame_newslot(*var_s);
  params[0] = strlit8141;
  partcv[0] = 1;
  Object opresult8143 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8143 (depth = 8)
  int op_slot_left_8138 = gc_frame_newslot(opresult8143);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8144 = callmethod(opresult8143, "++", 1, partcv, params);
// compiled op node returning opresult8144 (depth = 7)
  int op_slot_left_8135 = gc_frame_newslot(opresult8144);
  params[0] = strlit8136;
  partcv[0] = 1;
  Object opresult8145 = callmethod(opresult8144, "++", 1, partcv, params);
// compiled op node returning opresult8145 (depth = 6)
  int op_slot_left_8125 = gc_frame_newslot(opresult8145);
  params[0] = call8133;
  partcv[0] = 1;
  Object opresult8146 = callmethod(opresult8145, "++", 1, partcv, params);
// compiled op node returning opresult8146 (depth = 5)
  *var_s = opresult8146;
  if (opresult8146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8118 = done;
  } else {
  }
// compiled if node returning if8118 (depth = 3)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8149 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8150 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8151 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8152 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8151);
// compiled call node returning call8152 (depth = 9)
// compiled member node returning call8152 (depth = 8)
  partcv[0] = 0;
  Object call8153 = callmethod(call8152, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe8150);
// compiled call node returning call8153 (depth = 7)
// compiled member node returning call8153 (depth = 6)
  partcv[0] = 0;
  Object call8154 = callmethod(call8153, "not",
    1, partcv, params);
  gc_frame_end(callframe8149);
// compiled call node returning call8154 (depth = 5)
// compiled member node returning call8154 (depth = 4)
  Object if8148 = done;
  if (istrue(call8154)) {
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8157 == NULL) {
    strlit8157 = alloc_String("Annotations:");
    gc_root(strlit8157);
  }
// compiled string node returning strlit8157 (depth = 7)
  int op_slot_right_8156 = gc_frame_newslot(strlit8157);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8159 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit8161 == NULL) {
    strlit8161 = alloc_String("""\x0a""");
    gc_root(strlit8161);
  }
// compiled string node returning strlit8161 (depth = 8)
  int op_slot_left_8159 = gc_frame_newslot(strlit8161);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8162 = callmethod(strlit8161, "++", 1, partcv, params);
// compiled op node returning opresult8162 (depth = 7)
  int op_slot_left_8156 = gc_frame_newslot(opresult8162);
  params[0] = strlit8157;
  partcv[0] = 1;
  Object opresult8163 = callmethod(opresult8162, "++", 1, partcv, params);
// compiled op node returning opresult8163 (depth = 6)
  int op_slot_right_8155 = gc_frame_newslot(opresult8163);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8155 = gc_frame_newslot(*var_s);
  params[0] = opresult8163;
  partcv[0] = 1;
  Object opresult8165 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8165 (depth = 5)
  *var_s = opresult8165;
  if (opresult8165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8167 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8168 = alloc_Block(NULL, NULL, "ast", 2049);
  gc_frame_newslot(block8168);
// method "_apply"
  block_savedest(block8168);
  Object closure8169 = createclosure(3, "_apply");
  setclosureframe(closure8169, stackframe);
  addtoclosure(closure8169, var_depth);
  addtoclosure(closure8169, var_s);
  addtoclosure(closure8169, selfslot);
  struct UserObject *uo8169 = (struct UserObject*)block8168;
  uo8169->data[0] = (Object)closure8169;
  Method *meth_meth_ast__apply8169 = addmethod2pos(block8168, "_apply", &meth_ast__apply8169, 0);
  int argcv_meth_ast__apply8169[] = {1};
  meth_meth_ast__apply8169->type = alloc_MethodType(1, argcv_meth_ast__apply8169);
  meth_meth_ast__apply8169->definitionModule = modulename;
  meth_meth_ast__apply8169->definitionLine = 2047;
// compiled block node returning block8168 (depth = 5)
  gc_frame_newslot(block8168);
// call case 6: other member request
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8193 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8194 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8193);
// compiled call node returning call8194 (depth = 6)
// compiled member node returning call8194 (depth = 5)
  params[0] = block8168;
  partcv[0] = 1;
  Object call8195 = callmethod(call8194, "do",
    1, partcv, params);
  gc_frame_end(callframe8167);
// compiled call node returning call8195 (depth = 4)
    gc_frame_newslot(call8195);
    if8148 = call8195;
  } else {
  }
// compiled if node returning if8148 (depth = 3)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8198 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8199 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8198);
// compiled call node returning call8199 (depth = 6)
// compiled member node returning call8199 (depth = 5)
  int op_slot_right_8197 = gc_frame_newslot(call8199);
// starting to compile identifier node (depth = 5)
  Object bool8201 = alloc_Boolean(0);
// compiled identifier node returning bool8201 (depth = 5)
  int op_slot_left_8197 = gc_frame_newslot(bool8201);
  params[0] = call8199;
  partcv[0] = 1;
  Object opresult8202 = callmethod(bool8201, "!=", 1, partcv, params);
// compiled op node returning opresult8202 (depth = 4)
  Object if8196 = done;
  if (istrue(opresult8202)) {
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8204 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8206 = alloc_Float64(2);
// compiled num node returning num8206 (depth = 8)
  int op_slot_right_8205 = gc_frame_newslot(num8206);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8205 = gc_frame_newslot(*var_depth);
  params[0] = num8206;
  partcv[0] = 1;
  Object sum8208 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8208 (depth = 7)
  gc_frame_newslot(sum8208);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8209 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8210 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8209);
// compiled call node returning call8210 (depth = 8)
// compiled member node returning call8210 (depth = 7)
  params[0] = sum8208;
  partcv[0] = 1;
  Object call8211 = callmethod(call8210, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8204);
// compiled call node returning call8211 (depth = 6)
  int op_slot_right_8203 = gc_frame_newslot(call8211);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8203 = gc_frame_newslot(*var_s);
  params[0] = call8211;
  partcv[0] = 1;
  Object opresult8213 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8213 (depth = 5)
  *var_s = opresult8213;
  if (opresult8213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8196 = done;
  } else {
  }
// compiled if node returning if8196 (depth = 3)
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8227(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8229 == NULL) {
    strlit8229 = alloc_String("    ");
    gc_root(strlit8229);
  }
// compiled string node returning strlit8229 (depth = 7)
  int op_slot_right_8228 = gc_frame_newslot(strlit8229);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8228 = gc_frame_newslot(*var_spc);
  params[0] = strlit8229;
  partcv[0] = 1;
  Object opresult8231 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8231 (depth = 6)
  *var_spc = opresult8231;
  if (opresult8231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8251(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8253 == NULL) {
    strlit8253 = alloc_String("Unknown");
    gc_root(strlit8253);
  }
// compiled string node returning strlit8253 (depth = 7)
  int op_slot_right_8252 = gc_frame_newslot(strlit8253);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8255 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8257 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8256);
// compiled call node returning call8257 (depth = 10)
// compiled member node returning call8257 (depth = 9)
  partcv[0] = 0;
  Object call8258 = callmethod(call8257, "value",
    1, partcv, params);
  gc_frame_end(callframe8255);
// compiled call node returning call8258 (depth = 8)
// compiled member node returning call8258 (depth = 7)
  int op_slot_left_8252 = gc_frame_newslot(call8258);
  params[0] = strlit8253;
  partcv[0] = 1;
  Object opresult8259 = callmethod(call8258, "!=", 1, partcv, params);
// compiled op node returning opresult8259 (depth = 6)
  gc_frame_end(frame);
  return opresult8259;
}
Object meth_ast__apply8298(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8300 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8301 = alloc_Float64(0);
// compiled num node returning num8301 (depth = 10)
  gc_frame_newslot(num8301);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8301;
  partcv[0] = 1;
  Object call8302 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8300);
// compiled call node returning call8302 (depth = 9)
  int op_slot_right_8299 = gc_frame_newslot(call8302);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8306 == NULL) {
    strlit8306 = alloc_String("");
    gc_root(strlit8306);
  }
// compiled string node returning strlit8306 (depth = 11)
  int op_slot_right_8305 = gc_frame_newslot(strlit8306);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8305 = gc_frame_newslot(*var_a);
  params[0] = strlit8306;
  partcv[0] = 1;
  Object opresult8308 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult8308 (depth = 10)
  Object if8304 = done;
struct StackFrameObject *iftmpstackframe8304 = stackframe;
  if (istrue(opresult8308)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8304);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8310 == NULL) {
    strlit8310 = alloc_String(", ");
    gc_root(strlit8310);
  }
// compiled string node returning strlit8310 (depth = 11)
  int op_slot_right_8309 = gc_frame_newslot(strlit8310);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8309 = gc_frame_newslot(*var_a);
  params[0] = strlit8310;
  partcv[0] = 1;
  Object opresult8312 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8312 (depth = 10)
    gc_frame_newslot(opresult8312);
    if8304 = opresult8312;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8304);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8313 == NULL) {
    strlit8313 = alloc_String("");
    gc_root(strlit8313);
  }
// compiled string node returning strlit8313 (depth = 10)
    gc_frame_newslot(strlit8313);
    if8304 = strlit8313;
  }
stackframe = iftmpstackframe8304;
// compiled if node returning if8304 (depth = 9)
  int op_slot_left_8299 = gc_frame_newslot(if8304);
  params[0] = call8302;
  partcv[0] = 1;
  Object opresult8314 = callmethod(if8304, "++", 1, partcv, params);
// compiled op node returning opresult8314 (depth = 8)
  gc_frame_end(frame);
  return opresult8314;
}
Object meth_ast_toGrace8215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8216 == NULL) {
    strlit8216 = alloc_String("");
    gc_root(strlit8216);
  }
// compiled string node returning strlit8216 (depth = 4)
  *var_spc = strlit8216;
  if (strlit8216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8217 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8220 = alloc_Float64(1);
// compiled num node returning num8220 (depth = 6)
  int op_slot_right_8219 = gc_frame_newslot(num8220);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8219 = gc_frame_newslot(*var_depth);
  params[0] = num8220;
  partcv[0] = 1;
  Object diff8222 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff8222 (depth = 5)
  int op_slot_right_8218 = gc_frame_newslot(diff8222);
// starting to compile num node (depth = 5)
  Object num8224 = alloc_Float64(0);
// compiled num node returning num8224 (depth = 5)
  int op_slot_left_8218 = gc_frame_newslot(num8224);
  params[0] = diff8222;
  partcv[0] = 1;
  Object opresult8225 = callmethod(num8224, "..", 1, partcv, params);
// compiled op node returning opresult8225 (depth = 4)
  gc_frame_newslot(opresult8225);
// starting to compile block node (depth = 4)
  Object block8226 = alloc_Block(NULL, NULL, "ast", 2060);
  gc_frame_newslot(block8226);
// method "_apply"
  block_savedest(block8226);
  Object closure8227 = createclosure(2, "_apply");
  setclosureframe(closure8227, stackframe);
  addtoclosure(closure8227, var_spc);
  addtoclosure(closure8227, selfslot);
  struct UserObject *uo8227 = (struct UserObject*)block8226;
  uo8227->data[0] = (Object)closure8227;
  Method *meth_meth_ast__apply8227 = addmethod2pos(block8226, "_apply", &meth_ast__apply8227, 0);
  int argcv_meth_ast__apply8227[] = {1};
  meth_meth_ast__apply8227->type = alloc_MethodType(1, argcv_meth_ast__apply8227);
  meth_meth_ast__apply8227->definitionModule = modulename;
  meth_meth_ast__apply8227->definitionLine = 2054;
// compiled block node returning block8226 (depth = 4)
  gc_frame_newslot(block8226);
// call case 5: prelude request
  params[0] = opresult8225;
  params[1] = block8226;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8234 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8217);
// compiled call node returning call8234 (depth = 3)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8236 == NULL) {
    strlit8236 = alloc_String("");
    gc_root(strlit8236);
  }
// compiled string node returning strlit8236 (depth = 5)
  int op_slot_right_8235 = gc_frame_newslot(strlit8236);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8239 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8240 = alloc_Float64(0);
// compiled num node returning num8240 (depth = 7)
  gc_frame_newslot(num8240);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8242 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8241);
// compiled call node returning call8242 (depth = 8)
// compiled member node returning call8242 (depth = 7)
  params[0] = num8240;
  partcv[0] = 1;
  Object call8243 = callmethod(call8242, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8239);
// compiled call node returning call8243 (depth = 6)
  int op_slot_right_8238 = gc_frame_newslot(call8243);
// starting to compile string node (depth = 6)
  if (strlit8245 == NULL) {
    strlit8245 = alloc_String("def ");
    gc_root(strlit8245);
  }
// compiled string node returning strlit8245 (depth = 6)
  int op_slot_left_8238 = gc_frame_newslot(strlit8245);
  params[0] = call8243;
  partcv[0] = 1;
  Object opresult8246 = callmethod(strlit8245, "++", 1, partcv, params);
// compiled op node returning opresult8246 (depth = 5)
  int op_slot_left_8235 = gc_frame_newslot(opresult8246);
  params[0] = strlit8236;
  partcv[0] = 1;
  Object opresult8247 = callmethod(opresult8246, "++", 1, partcv, params);
// compiled op node returning opresult8247 (depth = 4)
  *var_s = opresult8247;
  if (opresult8247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8249 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8250 = alloc_Block(NULL, NULL, "ast", 2064);
  gc_frame_newslot(block8250);
// method "_apply"
  block_savedest(block8250);
  Object closure8251 = createclosure(1, "_apply");
  setclosureframe(closure8251, stackframe);
  addtoclosure(closure8251, selfslot);
  struct UserObject *uo8251 = (struct UserObject*)block8250;
  uo8251->data[0] = (Object)closure8251;
  Method *meth_meth_ast__apply8251 = addmethod2pos(block8250, "_apply", &meth_ast__apply8251, 0);
  int argcv_meth_ast__apply8251[] = {0};
  meth_meth_ast__apply8251->type = alloc_MethodType(1, argcv_meth_ast__apply8251);
  meth_meth_ast__apply8251->definitionModule = modulename;
  meth_meth_ast__apply8251->definitionLine = 2063;
// compiled block node returning block8250 (depth = 5)
  gc_frame_newslot(block8250);
// call case 6: other member request
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8262 = alloc_Boolean(0);
// compiled identifier node returning bool8262 (depth = 6)
  int op_slot_right_8261 = gc_frame_newslot(bool8262);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8265 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8264);
// compiled call node returning call8265 (depth = 7)
// compiled member node returning call8265 (depth = 6)
  int op_slot_left_8261 = gc_frame_newslot(call8265);
  params[0] = bool8262;
  partcv[0] = 1;
  Object opresult8266 = callmethod(call8265, "!=", 1, partcv, params);
// compiled op node returning opresult8266 (depth = 5)
  params[0] = block8250;
  partcv[0] = 1;
  Object call8267 = callmethod(opresult8266, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8249);
// compiled call node returning call8267 (depth = 4)
  Object if8248 = done;
  if (istrue(call8267)) {
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8269 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8270 = alloc_Float64(0);
// compiled num node returning num8270 (depth = 7)
  gc_frame_newslot(num8270);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8272 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8271);
// compiled call node returning call8272 (depth = 8)
// compiled member node returning call8272 (depth = 7)
  params[0] = num8270;
  partcv[0] = 1;
  Object call8273 = callmethod(call8272, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8269);
// compiled call node returning call8273 (depth = 6)
  int op_slot_right_8268 = gc_frame_newslot(call8273);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8276 == NULL) {
    strlit8276 = alloc_String(" : ");
    gc_root(strlit8276);
  }
// compiled string node returning strlit8276 (depth = 7)
  int op_slot_right_8275 = gc_frame_newslot(strlit8276);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8275 = gc_frame_newslot(*var_s);
  params[0] = strlit8276;
  partcv[0] = 1;
  Object opresult8278 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8278 (depth = 6)
  int op_slot_left_8268 = gc_frame_newslot(opresult8278);
  params[0] = call8273;
  partcv[0] = 1;
  Object opresult8279 = callmethod(opresult8278, "++", 1, partcv, params);
// compiled op node returning opresult8279 (depth = 5)
  *var_s = opresult8279;
  if (opresult8279 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8248 = done;
  } else {
  }
// compiled if node returning if8248 (depth = 3)
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8283 = alloc_Float64(0);
// compiled num node returning num8283 (depth = 5)
  int op_slot_right_8282 = gc_frame_newslot(num8283);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8285 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8287 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8286);
// compiled call node returning call8287 (depth = 8)
// compiled member node returning call8287 (depth = 7)
  partcv[0] = 0;
  Object call8288 = callmethod(call8287, "size",
    1, partcv, params);
  gc_frame_end(callframe8285);
// compiled call node returning call8288 (depth = 6)
// compiled member node returning call8288 (depth = 5)
  int op_slot_left_8282 = gc_frame_newslot(call8288);
  params[0] = num8283;
  partcv[0] = 1;
  Object opresult8289 = callmethod(call8288, ">", 1, partcv, params);
// compiled op node returning opresult8289 (depth = 4)
  Object if8281 = done;
  if (istrue(opresult8289)) {
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8291 == NULL) {
    strlit8291 = alloc_String(" is ");
    gc_root(strlit8291);
  }
// compiled string node returning strlit8291 (depth = 6)
  int op_slot_right_8290 = gc_frame_newslot(strlit8291);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8290 = gc_frame_newslot(*var_s);
  params[0] = strlit8291;
  partcv[0] = 1;
  Object opresult8293 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8293 (depth = 5)
  *var_s = opresult8293;
  if (opresult8293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8296 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8297 = alloc_Block(NULL, NULL, "ast", 2070);
  gc_frame_newslot(block8297);
// method "_apply"
  block_savedest(block8297);
  Object closure8298 = createclosure(1, "_apply");
  setclosureframe(closure8298, stackframe);
  addtoclosure(closure8298, selfslot);
  struct UserObject *uo8298 = (struct UserObject*)block8297;
  uo8298->data[0] = (Object)closure8298;
  Method *meth_meth_ast__apply8298 = addmethod2pos(block8297, "_apply", &meth_ast__apply8298, 0);
  int argcv_meth_ast__apply8298[] = {2};
  meth_meth_ast__apply8298->type = alloc_MethodType(1, argcv_meth_ast__apply8298);
  meth_meth_ast__apply8298->definitionModule = modulename;
  meth_meth_ast__apply8298->definitionLine = 2068;
// compiled block node returning block8297 (depth = 7)
  gc_frame_newslot(block8297);
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8316 == NULL) {
    strlit8316 = alloc_String("");
    gc_root(strlit8316);
  }
// compiled string node returning strlit8316 (depth = 7)
  gc_frame_newslot(strlit8316);
// call case 6: other member request
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8317 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8318 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8317);
// compiled call node returning call8318 (depth = 8)
// compiled member node returning call8318 (depth = 7)
  params[0] = block8297;
  params[1] = strlit8316;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8319 = callmethod(call8318, "fold()startingWith",
    2, partcv, params);
  gc_frame_end(callframe8296);
// compiled call node returning call8319 (depth = 6)
  int op_slot_right_8295 = gc_frame_newslot(call8319);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8295 = gc_frame_newslot(*var_s);
  params[0] = call8319;
  partcv[0] = 1;
  Object opresult8321 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8321 (depth = 5)
  *var_s = opresult8321;
  if (opresult8321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8281 = done;
  } else {
  }
// compiled if node returning if8281 (depth = 3)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8325 = alloc_Boolean(0);
// compiled identifier node returning bool8325 (depth = 5)
  int op_slot_right_8324 = gc_frame_newslot(bool8325);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8328 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8327);
// compiled call node returning call8328 (depth = 6)
// compiled member node returning call8328 (depth = 5)
  int op_slot_left_8324 = gc_frame_newslot(call8328);
  params[0] = bool8325;
  partcv[0] = 1;
  Object opresult8329 = callmethod(call8328, "!=", 1, partcv, params);
// compiled op node returning opresult8329 (depth = 4)
  Object if8323 = done;
  if (istrue(opresult8329)) {
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8331 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8333 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8332);
// compiled call node returning call8333 (depth = 8)
// compiled member node returning call8333 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8334 = callmethod(call8333, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8331);
// compiled call node returning call8334 (depth = 6)
  int op_slot_right_8330 = gc_frame_newslot(call8334);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8337 == NULL) {
    strlit8337 = alloc_String(" = ");
    gc_root(strlit8337);
  }
// compiled string node returning strlit8337 (depth = 7)
  int op_slot_right_8336 = gc_frame_newslot(strlit8337);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8336 = gc_frame_newslot(*var_s);
  params[0] = strlit8337;
  partcv[0] = 1;
  Object opresult8339 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8339 (depth = 6)
  int op_slot_left_8330 = gc_frame_newslot(opresult8339);
  params[0] = call8334;
  partcv[0] = 1;
  Object opresult8340 = callmethod(opresult8339, "++", 1, partcv, params);
// compiled op node returning opresult8340 (depth = 5)
  *var_s = opresult8340;
  if (opresult8340 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8323 = done;
  } else {
  }
// compiled if node returning if8323 (depth = 3)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8343 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8344 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8346 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8345);
// compiled call node returning call8346 (depth = 6)
// compiled member node returning call8346 (depth = 5)
  gc_frame_newslot(call8346);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8347 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8348 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8347);
// compiled call node returning call8348 (depth = 6)
// compiled member node returning call8348 (depth = 5)
  gc_frame_newslot(call8348);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8350 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8349);
// compiled call node returning call8350 (depth = 6)
// compiled member node returning call8350 (depth = 5)
  gc_frame_newslot(call8350);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDecNode (depth = 5)
  params[0] = call8346;
  params[1] = call8348;
  params[2] = call8350;
  partcv[0] = 3;
  Object call8351 = callmethod(*var_defDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8344);
// compiled call node returning call8351 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8352 = callmethod(call8351, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8343);
// compiled call node returning call8352 (depth = 3)
  gc_frame_end(frame);
  return call8352;
}
Object meth_ast_shallowCopyFieldsFrom8353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8354 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call8355 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8354);
// compiled call node returning call8355 (depth = 3)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8356 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call8358 = callmethod(*var_other, "startToken",
    1, partcv, params);
  gc_frame_end(callframe8357);
// compiled call node returning call8358 (depth = 5)
// compiled member node returning call8358 (depth = 4)
  gc_frame_newslot(call8358);
// call case 4: self request
  params[0] = call8358;
  partcv[0] = 1;
  Object call8359 = callmethodflags(self, "startToken:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8356);
// compiled call node returning call8359 (depth = 3)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName8360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8361 == NULL) {
    strlit8361 = alloc_String("definition");
    gc_root(strlit8361);
  }
// compiled string node returning strlit8361 (depth = 3)
  gc_frame_end(frame);
  return strlit8361;
}
Object meth_ast_new7919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7920 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7920 = alloc_userobj2(27,23, objclass7920);
  gc_frame_newslot(obj7920);
if (objclass7920 == NULL) {
  glfree(obj7920->class->name);
  obj7920->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7920, self, 0);
  addmethodreal(obj7920,"outer", &reader_ast_outer_7921);
  Object oldself7920 = self;
  struct StackFrameObject *oldstackframe7920 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7920);
  gc_frame_newslot((Object)stackframe);
  self = obj7920;
  Object *oldselfslot7920 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7920 = (*(struct UserObject *)self).data[0], lowerouter7920 = thisouter7920;
  if (inheritingObject7920) {
    struct UserObject *inho7920 = (struct UserObject *)inheritingObject7920;
    while (inho7920->super != GraceDefaultObject) inho7920 = (struct UserObject *)inho7920->super;
    inho7920->super = obj7920;
    self = inheritingObject7920;
    *selfslot = self;
    lowerouter7920 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7920;
  }
if (objclass7920 == NULL) {
  Method *reader7922 = addmethodrealflags(obj7920, "kind",&reader_ast_kind_7922, MFLAG_DEF);
  reader7922->definitionModule = modulename;
  reader7922->definitionLine = 1982;
}
adddatum2(obj7920, alloc_Undefined(), 1);
if (objclass7920 == NULL) {
  Method *reader7923 = addmethodrealflags(obj7920, "name",&reader_ast_name_7923, 0);
  Method *writer7923 = addmethodrealflags(obj7920, "name:=",&writer_ast_name_7923, 0);
  reader7923->definitionModule = modulename;
  writer7923->definitionModule = modulename;
  reader7923->definitionLine = 1983;
  writer7923->definitionLine = 1983;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 2);
if (objclass7920 == NULL) {
  Method *reader7924 = addmethodrealflags(obj7920, "value",&reader_ast_value_7924, 0);
  Method *writer7924 = addmethodrealflags(obj7920, "value:=",&writer_ast_value_7924, 0);
  reader7924->definitionModule = modulename;
  writer7924->definitionModule = modulename;
  reader7924->definitionLine = 1984;
  writer7924->definitionLine = 1984;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 3);
if (objclass7920 == NULL) {
  Method *reader7925 = addmethodrealflags(obj7920, "dtype",&reader_ast_dtype_7925, 0);
  Method *writer7925 = addmethodrealflags(obj7920, "dtype:=",&writer_ast_dtype_7925, 0);
  reader7925->definitionModule = modulename;
  writer7925->definitionModule = modulename;
  reader7925->definitionLine = 1985;
  writer7925->definitionLine = 1985;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 4);
if (objclass7920 == NULL) {
  Method *reader7926 = addmethodrealflags(obj7920, "nameString",&reader_ast_nameString_7926, MFLAG_DEF);
  reader7926->definitionModule = modulename;
  reader7926->definitionLine = 1986;
}
adddatum2(obj7920, alloc_Undefined(), 5);
if (objclass7920 == NULL) {
  Method *reader7927 = addmethodrealflags(obj7920, "annotations",&reader_ast_annotations_7927, 0);
  Method *writer7927 = addmethodrealflags(obj7920, "annotations:=",&writer_ast_annotations_7927, 0);
  reader7927->definitionModule = modulename;
  writer7927->definitionModule = modulename;
  reader7927->definitionLine = 1987;
  writer7927->definitionLine = 1987;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 6);
if (objclass7920 == NULL) {
  Method *reader7928 = addmethodrealflags(obj7920, "startToken",&reader_ast_startToken_7928, 0);
  Method *writer7928 = addmethodrealflags(obj7920, "startToken:=",&writer_ast_startToken_7928, 0);
  reader7928->definitionModule = modulename;
  writer7928->definitionModule = modulename;
  reader7928->definitionLine = 1988;
  writer7928->definitionLine = 1988;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7929 = (struct UserObject*)obj7920;
  uo7929->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7929 = addmethod2pos(obj7920, "isPublic", &meth_ast_isPublic7929, 8);
  int argcv_meth_ast_isPublic7929[] = {0};
  meth_meth_ast_isPublic7929->type = alloc_MethodType(1, argcv_meth_ast_isPublic7929);
  meth_meth_ast_isPublic7929->definitionModule = modulename;
  meth_meth_ast_isPublic7929->definitionLine = 1990;
// method "isFieldDec"
  struct UserObject *uo7956 = (struct UserObject*)obj7920;
  uo7956->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7956 = addmethod2pos(obj7920, "isFieldDec", &meth_ast_isFieldDec7956, 9);
  int argcv_meth_ast_isFieldDec7956[] = {0};
  meth_meth_ast_isFieldDec7956->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7956);
  meth_meth_ast_isFieldDec7956->definitionModule = modulename;
  meth_meth_ast_isFieldDec7956->definitionLine = 1996;
// method "isWritable"
  struct UserObject *uo7958 = (struct UserObject*)obj7920;
  uo7958->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7958 = addmethod2pos(obj7920, "isWritable", &meth_ast_isWritable7958, 10);
  int argcv_meth_ast_isWritable7958[] = {0};
  meth_meth_ast_isWritable7958->type = alloc_MethodType(1, argcv_meth_ast_isWritable7958);
  meth_meth_ast_isWritable7958->definitionModule = modulename;
  meth_meth_ast_isWritable7958->definitionLine = 1997;
// method "isReadable"
  struct UserObject *uo7960 = (struct UserObject*)obj7920;
  uo7960->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7960 = addmethod2pos(obj7920, "isReadable", &meth_ast_isReadable7960, 11);
  int argcv_meth_ast_isReadable7960[] = {0};
  meth_meth_ast_isReadable7960->type = alloc_MethodType(1, argcv_meth_ast_isReadable7960);
  meth_meth_ast_isReadable7960->definitionModule = modulename;
  meth_meth_ast_isReadable7960->definitionLine = 1998;
// method "returnsObject"
  struct UserObject *uo7963 = (struct UserObject*)obj7920;
  uo7963->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject7963 = addmethod2pos(obj7920, "returnsObject", &meth_ast_returnsObject7963, 12);
  int argcv_meth_ast_returnsObject7963[] = {0};
  meth_meth_ast_returnsObject7963->type = alloc_MethodType(1, argcv_meth_ast_returnsObject7963);
  meth_meth_ast_returnsObject7963->definitionModule = modulename;
  meth_meth_ast_returnsObject7963->definitionLine = 2000;
// method "returnedObjectScope"
  struct UserObject *uo7968 = (struct UserObject*)obj7920;
  uo7968->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope7968 = addmethod2pos(obj7920, "returnedObjectScope", &meth_ast_returnedObjectScope7968, 13);
  int argcv_meth_ast_returnedObjectScope7968[] = {0};
  meth_meth_ast_returnedObjectScope7968->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope7968);
  meth_meth_ast_returnedObjectScope7968->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope7968->definitionLine = 2003;
// method "usesAsType"
  struct UserObject *uo7973 = (struct UserObject*)obj7920;
  uo7973->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType7973 = addmethod2pos(obj7920, "usesAsType", &meth_ast_usesAsType7973, 14);
  int argcv_meth_ast_usesAsType7973[] = {1};
  meth_meth_ast_usesAsType7973->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7973);
  meth_meth_ast_usesAsType7973->definitionModule = modulename;
  meth_meth_ast_usesAsType7973->definitionLine = 2007;
// method "declarationKindWithAncestors"
  block_savedest(obj7920);
  Object closure7979 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure7979, stackframe);
  addtoclosure(closure7979, var_k);
  struct UserObject *uo7979 = (struct UserObject*)obj7920;
  uo7979->data[15] = (Object)closure7979;
  Method *meth_meth_ast_declarationKindWithAncestors7979 = addmethod2pos(obj7920, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7979, 15);
  int argcv_meth_ast_declarationKindWithAncestors7979[] = {1};
  meth_meth_ast_declarationKindWithAncestors7979->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7979);
  meth_meth_ast_declarationKindWithAncestors7979->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7979->definitionLine = 2010;
// method "accept()from"
  struct UserObject *uo7982 = (struct UserObject*)obj7920;
  uo7982->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7982 = addmethod2pos(obj7920, "accept()from", &meth_ast_accept_40__41_from7982, 16);
  int argcv_meth_ast_accept_40__41_from7982[] = {1, 1};
  meth_meth_ast_accept_40__41_from7982->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7982);
  meth_meth_ast_accept_40__41_from7982->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7982->definitionLine = 2012;
// method "map()ancestors"
  struct UserObject *uo8016 = (struct UserObject*)obj7920;
  uo8016->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8016 = addmethod2pos(obj7920, "map()ancestors", &meth_ast_map_40__41_ancestors8016, 17);
  int argcv_meth_ast_map_40__41_ancestors8016[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8016->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8016);
  meth_meth_ast_map_40__41_ancestors8016->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8016->definitionLine = 2025;
// method "pretty"
  struct UserObject *uo8055 = (struct UserObject*)obj7920;
  uo8055->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty8055 = addmethod2pos(obj7920, "pretty", &meth_ast_pretty8055, 18);
  int argcv_meth_ast_pretty8055[] = {1};
  meth_meth_ast_pretty8055->type = alloc_MethodType(1, argcv_meth_ast_pretty8055);
  meth_meth_ast_pretty8055->definitionModule = modulename;
  meth_meth_ast_pretty8055->definitionLine = 2034;
// method "toGrace"
  struct UserObject *uo8215 = (struct UserObject*)obj7920;
  uo8215->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace8215 = addmethod2pos(obj7920, "toGrace", &meth_ast_toGrace8215, 19);
  int argcv_meth_ast_toGrace8215[] = {1};
  meth_meth_ast_toGrace8215->type = alloc_MethodType(1, argcv_meth_ast_toGrace8215);
meth_meth_ast_toGrace8215->type->types[0] = type_Number;
meth_meth_ast_toGrace8215->type->names[0] = "depth";
  meth_meth_ast_toGrace8215->definitionModule = modulename;
  meth_meth_ast_toGrace8215->definitionLine = 2058;
// method "shallowCopy"
  block_savedest(obj7920);
  Object closure8342 = createclosure(1, "shallowCopy");
  setclosureframe(closure8342, stackframe);
  addtoclosure(closure8342, var_defDecNode);
  struct UserObject *uo8342 = (struct UserObject*)obj7920;
  uo8342->data[20] = (Object)closure8342;
  Method *meth_meth_ast_shallowCopy8342 = addmethod2pos(obj7920, "shallowCopy", &meth_ast_shallowCopy8342, 20);
  int argcv_meth_ast_shallowCopy8342[] = {0};
  meth_meth_ast_shallowCopy8342->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8342);
  meth_meth_ast_shallowCopy8342->definitionModule = modulename;
  meth_meth_ast_shallowCopy8342->definitionLine = 2079;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo8353 = (struct UserObject*)obj7920;
  uo8353->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom8353 = addmethod2pos(obj7920, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom8353, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom8353[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom8353->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom8353);
  meth_meth_ast_shallowCopyFieldsFrom8353->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom8353->definitionLine = 2082;
// method "statementName"
  struct UserObject *uo8360 = (struct UserObject*)obj7920;
  uo8360->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8360 = addmethod2pos(obj7920, "statementName", &meth_ast_statementName8360, 22);
  int argcv_meth_ast_statementName8360[] = {0};
  meth_meth_ast_statementName8360->type = alloc_MethodType(1, argcv_meth_ast_statementName8360);
  meth_meth_ast_statementName8360->definitionModule = modulename;
  meth_meth_ast_statementName8360->definitionLine = 2087;
  sourceObject = obj7920;
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8362 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8363 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8364 = gc_frame_new();
// call case 3: self.outer request
  Object call8365 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8364);
// compiled call node returning call8365 (depth = 7)
// compiled member node returning call8365 (depth = 6)
  partcv[0] = 0;
  Object call8366 = callmethodflags(call8365, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8363);
// compiled call node returning call8366 (depth = 5)
// compiled member node returning call8366 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8367 = callmethodflags(call8366, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8362);
// compiled call node returning call8367 (depth = 3)
  struct UserObject *obj7920_uo = (struct UserObject *)obj7920;
  obj7920_uo->super = call8367;
  sourceObject = obj7920;
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8368 == NULL) {
    strlit8368 = alloc_String("defdec");
    gc_root(strlit8368);
  }
// compiled string node returning strlit8368 (depth = 3)
  adddatum2(obj7920, strlit8368, 1);
  sourceObject = obj7920;
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7920, *var_name_39_, 2);
  sourceObject = obj7920;
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7920, *var_val, 3);
  sourceObject = obj7920;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7920, *var_dtype_39_, 4);
  sourceObject = obj7920;
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8369 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8371 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8370);
// compiled call node returning call8371 (depth = 6)
// compiled member node returning call8371 (depth = 5)
  partcv[0] = 0;
  Object call8372 = callmethod(call8371, "value",
    1, partcv, params);
  gc_frame_end(callframe8369);
// compiled call node returning call8372 (depth = 4)
// compiled member node returning call8372 (depth = 3)
  adddatum2(obj7920, call8372, 5);
  sourceObject = obj7920;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8373 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8374 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8375 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8374);
// compiled call node returning call8375 (depth = 6)
// compiled member node returning call8375 (depth = 5)
  partcv[0] = 0;
  Object call8376 = callmethod(call8375, "empty",
    1, partcv, params);
  gc_frame_end(callframe8373);
// compiled call node returning call8376 (depth = 4)
// compiled member node returning call8376 (depth = 3)
  adddatum2(obj7920, call8376, 6);
  sourceObject = obj7920;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8377 = alloc_Boolean(0);
// compiled identifier node returning bool8377 (depth = 3)
  adddatum2(obj7920, bool8377, 7);
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  objclass7920 = obj7920->class;
  objclass7920->definitionModule = modulename;
  objclass7920->definitionLine = 1980;
  (*(struct UserObject *)self).data[0] = lowerouter7920;
  self = oldself7920;
  selfslot = oldselfslot7920;
  stackframe = oldstackframe7920;
  gc_frame_end(frame);
  return obj7920;
}
Object meth_ast_new7919_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7920 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7920 = alloc_userobj2(27,23, objclass7920);
  gc_frame_newslot(obj7920);
if (objclass7920 == NULL) {
  glfree(obj7920->class->name);
  obj7920->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7920, self, 0);
  addmethodreal(obj7920,"outer", &reader_ast_outer_7921);
  Object oldself7920 = self;
  struct StackFrameObject *oldstackframe7920 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7920);
  gc_frame_newslot((Object)stackframe);
  self = obj7920;
  Object *oldselfslot7920 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7920 = (*(struct UserObject *)self).data[0], lowerouter7920 = thisouter7920;
  if (inheritingObject7920) {
    struct UserObject *inho7920 = (struct UserObject *)inheritingObject7920;
    while (inho7920->super != GraceDefaultObject) inho7920 = (struct UserObject *)inho7920->super;
    inho7920->super = obj7920;
    self = inheritingObject7920;
    *selfslot = self;
    lowerouter7920 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7920;
  }
if (objclass7920 == NULL) {
  Method *reader7922 = addmethodrealflags(obj7920, "kind",&reader_ast_kind_7922, MFLAG_DEF);
  reader7922->definitionModule = modulename;
  reader7922->definitionLine = 1982;
}
adddatum2(obj7920, alloc_Undefined(), 1);
if (objclass7920 == NULL) {
  Method *reader7923 = addmethodrealflags(obj7920, "name",&reader_ast_name_7923, 0);
  Method *writer7923 = addmethodrealflags(obj7920, "name:=",&writer_ast_name_7923, 0);
  reader7923->definitionModule = modulename;
  writer7923->definitionModule = modulename;
  reader7923->definitionLine = 1983;
  writer7923->definitionLine = 1983;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 2);
if (objclass7920 == NULL) {
  Method *reader7924 = addmethodrealflags(obj7920, "value",&reader_ast_value_7924, 0);
  Method *writer7924 = addmethodrealflags(obj7920, "value:=",&writer_ast_value_7924, 0);
  reader7924->definitionModule = modulename;
  writer7924->definitionModule = modulename;
  reader7924->definitionLine = 1984;
  writer7924->definitionLine = 1984;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 3);
if (objclass7920 == NULL) {
  Method *reader7925 = addmethodrealflags(obj7920, "dtype",&reader_ast_dtype_7925, 0);
  Method *writer7925 = addmethodrealflags(obj7920, "dtype:=",&writer_ast_dtype_7925, 0);
  reader7925->definitionModule = modulename;
  writer7925->definitionModule = modulename;
  reader7925->definitionLine = 1985;
  writer7925->definitionLine = 1985;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 4);
if (objclass7920 == NULL) {
  Method *reader7926 = addmethodrealflags(obj7920, "nameString",&reader_ast_nameString_7926, MFLAG_DEF);
  reader7926->definitionModule = modulename;
  reader7926->definitionLine = 1986;
}
adddatum2(obj7920, alloc_Undefined(), 5);
if (objclass7920 == NULL) {
  Method *reader7927 = addmethodrealflags(obj7920, "annotations",&reader_ast_annotations_7927, 0);
  Method *writer7927 = addmethodrealflags(obj7920, "annotations:=",&writer_ast_annotations_7927, 0);
  reader7927->definitionModule = modulename;
  writer7927->definitionModule = modulename;
  reader7927->definitionLine = 1987;
  writer7927->definitionLine = 1987;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 6);
if (objclass7920 == NULL) {
  Method *reader7928 = addmethodrealflags(obj7920, "startToken",&reader_ast_startToken_7928, 0);
  Method *writer7928 = addmethodrealflags(obj7920, "startToken:=",&writer_ast_startToken_7928, 0);
  reader7928->definitionModule = modulename;
  writer7928->definitionModule = modulename;
  reader7928->definitionLine = 1988;
  writer7928->definitionLine = 1988;
}
obj7920->flags |= OFLAG_MUTABLE;
adddatum2(obj7920, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7929 = (struct UserObject*)obj7920;
  uo7929->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7929 = addmethod2pos(obj7920, "isPublic", &meth_ast_isPublic7929, 8);
  int argcv_meth_ast_isPublic7929[] = {0};
  meth_meth_ast_isPublic7929->type = alloc_MethodType(1, argcv_meth_ast_isPublic7929);
  meth_meth_ast_isPublic7929->definitionModule = modulename;
  meth_meth_ast_isPublic7929->definitionLine = 1990;
// method "isFieldDec"
  struct UserObject *uo7956 = (struct UserObject*)obj7920;
  uo7956->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7956 = addmethod2pos(obj7920, "isFieldDec", &meth_ast_isFieldDec7956, 9);
  int argcv_meth_ast_isFieldDec7956[] = {0};
  meth_meth_ast_isFieldDec7956->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7956);
  meth_meth_ast_isFieldDec7956->definitionModule = modulename;
  meth_meth_ast_isFieldDec7956->definitionLine = 1996;
// method "isWritable"
  struct UserObject *uo7958 = (struct UserObject*)obj7920;
  uo7958->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7958 = addmethod2pos(obj7920, "isWritable", &meth_ast_isWritable7958, 10);
  int argcv_meth_ast_isWritable7958[] = {0};
  meth_meth_ast_isWritable7958->type = alloc_MethodType(1, argcv_meth_ast_isWritable7958);
  meth_meth_ast_isWritable7958->definitionModule = modulename;
  meth_meth_ast_isWritable7958->definitionLine = 1997;
// method "isReadable"
  struct UserObject *uo7960 = (struct UserObject*)obj7920;
  uo7960->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7960 = addmethod2pos(obj7920, "isReadable", &meth_ast_isReadable7960, 11);
  int argcv_meth_ast_isReadable7960[] = {0};
  meth_meth_ast_isReadable7960->type = alloc_MethodType(1, argcv_meth_ast_isReadable7960);
  meth_meth_ast_isReadable7960->definitionModule = modulename;
  meth_meth_ast_isReadable7960->definitionLine = 1998;
// method "returnsObject"
  struct UserObject *uo7963 = (struct UserObject*)obj7920;
  uo7963->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject7963 = addmethod2pos(obj7920, "returnsObject", &meth_ast_returnsObject7963, 12);
  int argcv_meth_ast_returnsObject7963[] = {0};
  meth_meth_ast_returnsObject7963->type = alloc_MethodType(1, argcv_meth_ast_returnsObject7963);
  meth_meth_ast_returnsObject7963->definitionModule = modulename;
  meth_meth_ast_returnsObject7963->definitionLine = 2000;
// method "returnedObjectScope"
  struct UserObject *uo7968 = (struct UserObject*)obj7920;
  uo7968->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope7968 = addmethod2pos(obj7920, "returnedObjectScope", &meth_ast_returnedObjectScope7968, 13);
  int argcv_meth_ast_returnedObjectScope7968[] = {0};
  meth_meth_ast_returnedObjectScope7968->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope7968);
  meth_meth_ast_returnedObjectScope7968->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope7968->definitionLine = 2003;
// method "usesAsType"
  struct UserObject *uo7973 = (struct UserObject*)obj7920;
  uo7973->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType7973 = addmethod2pos(obj7920, "usesAsType", &meth_ast_usesAsType7973, 14);
  int argcv_meth_ast_usesAsType7973[] = {1};
  meth_meth_ast_usesAsType7973->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7973);
  meth_meth_ast_usesAsType7973->definitionModule = modulename;
  meth_meth_ast_usesAsType7973->definitionLine = 2007;
// method "declarationKindWithAncestors"
  block_savedest(obj7920);
  Object closure7979 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure7979, stackframe);
  addtoclosure(closure7979, var_k);
  struct UserObject *uo7979 = (struct UserObject*)obj7920;
  uo7979->data[15] = (Object)closure7979;
  Method *meth_meth_ast_declarationKindWithAncestors7979 = addmethod2pos(obj7920, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7979, 15);
  int argcv_meth_ast_declarationKindWithAncestors7979[] = {1};
  meth_meth_ast_declarationKindWithAncestors7979->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7979);
  meth_meth_ast_declarationKindWithAncestors7979->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7979->definitionLine = 2010;
// method "accept()from"
  struct UserObject *uo7982 = (struct UserObject*)obj7920;
  uo7982->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7982 = addmethod2pos(obj7920, "accept()from", &meth_ast_accept_40__41_from7982, 16);
  int argcv_meth_ast_accept_40__41_from7982[] = {1, 1};
  meth_meth_ast_accept_40__41_from7982->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7982);
  meth_meth_ast_accept_40__41_from7982->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7982->definitionLine = 2012;
// method "map()ancestors"
  struct UserObject *uo8016 = (struct UserObject*)obj7920;
  uo8016->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8016 = addmethod2pos(obj7920, "map()ancestors", &meth_ast_map_40__41_ancestors8016, 17);
  int argcv_meth_ast_map_40__41_ancestors8016[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8016->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8016);
  meth_meth_ast_map_40__41_ancestors8016->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8016->definitionLine = 2025;
// method "pretty"
  struct UserObject *uo8055 = (struct UserObject*)obj7920;
  uo8055->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty8055 = addmethod2pos(obj7920, "pretty", &meth_ast_pretty8055, 18);
  int argcv_meth_ast_pretty8055[] = {1};
  meth_meth_ast_pretty8055->type = alloc_MethodType(1, argcv_meth_ast_pretty8055);
  meth_meth_ast_pretty8055->definitionModule = modulename;
  meth_meth_ast_pretty8055->definitionLine = 2034;
// method "toGrace"
  struct UserObject *uo8215 = (struct UserObject*)obj7920;
  uo8215->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace8215 = addmethod2pos(obj7920, "toGrace", &meth_ast_toGrace8215, 19);
  int argcv_meth_ast_toGrace8215[] = {1};
  meth_meth_ast_toGrace8215->type = alloc_MethodType(1, argcv_meth_ast_toGrace8215);
meth_meth_ast_toGrace8215->type->types[0] = type_Number;
meth_meth_ast_toGrace8215->type->names[0] = "depth";
  meth_meth_ast_toGrace8215->definitionModule = modulename;
  meth_meth_ast_toGrace8215->definitionLine = 2058;
// method "shallowCopy"
  block_savedest(obj7920);
  Object closure8342 = createclosure(1, "shallowCopy");
  setclosureframe(closure8342, stackframe);
  addtoclosure(closure8342, var_defDecNode);
  struct UserObject *uo8342 = (struct UserObject*)obj7920;
  uo8342->data[20] = (Object)closure8342;
  Method *meth_meth_ast_shallowCopy8342 = addmethod2pos(obj7920, "shallowCopy", &meth_ast_shallowCopy8342, 20);
  int argcv_meth_ast_shallowCopy8342[] = {0};
  meth_meth_ast_shallowCopy8342->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8342);
  meth_meth_ast_shallowCopy8342->definitionModule = modulename;
  meth_meth_ast_shallowCopy8342->definitionLine = 2079;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo8353 = (struct UserObject*)obj7920;
  uo8353->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom8353 = addmethod2pos(obj7920, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom8353, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom8353[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom8353->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom8353);
  meth_meth_ast_shallowCopyFieldsFrom8353->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom8353->definitionLine = 2082;
// method "statementName"
  struct UserObject *uo8360 = (struct UserObject*)obj7920;
  uo8360->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8360 = addmethod2pos(obj7920, "statementName", &meth_ast_statementName8360, 22);
  int argcv_meth_ast_statementName8360[] = {0};
  meth_meth_ast_statementName8360->type = alloc_MethodType(1, argcv_meth_ast_statementName8360);
  meth_meth_ast_statementName8360->definitionModule = modulename;
  meth_meth_ast_statementName8360->definitionLine = 2087;
  sourceObject = obj7920;
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8362 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8363 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8364 = gc_frame_new();
// call case 3: self.outer request
  Object call8365 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8364);
// compiled call node returning call8365 (depth = 7)
// compiled member node returning call8365 (depth = 6)
  partcv[0] = 0;
  Object call8366 = callmethodflags(call8365, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8363);
// compiled call node returning call8366 (depth = 5)
// compiled member node returning call8366 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8367 = callmethodflags(call8366, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8362);
// compiled call node returning call8367 (depth = 3)
  struct UserObject *obj7920_uo = (struct UserObject *)obj7920;
  obj7920_uo->super = call8367;
  sourceObject = obj7920;
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8368 == NULL) {
    strlit8368 = alloc_String("defdec");
    gc_root(strlit8368);
  }
// compiled string node returning strlit8368 (depth = 3)
  adddatum2(obj7920, strlit8368, 1);
  sourceObject = obj7920;
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7920, *var_name_39_, 2);
  sourceObject = obj7920;
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7920, *var_val, 3);
  sourceObject = obj7920;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7920, *var_dtype_39_, 4);
  sourceObject = obj7920;
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8369 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8371 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8370);
// compiled call node returning call8371 (depth = 6)
// compiled member node returning call8371 (depth = 5)
  partcv[0] = 0;
  Object call8372 = callmethod(call8371, "value",
    1, partcv, params);
  gc_frame_end(callframe8369);
// compiled call node returning call8372 (depth = 4)
// compiled member node returning call8372 (depth = 3)
  adddatum2(obj7920, call8372, 5);
  sourceObject = obj7920;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8373 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8374 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8375 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8374);
// compiled call node returning call8375 (depth = 6)
// compiled member node returning call8375 (depth = 5)
  partcv[0] = 0;
  Object call8376 = callmethod(call8375, "empty",
    1, partcv, params);
  gc_frame_end(callframe8373);
// compiled call node returning call8376 (depth = 4)
// compiled member node returning call8376 (depth = 3)
  adddatum2(obj7920, call8376, 6);
  sourceObject = obj7920;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8377 = alloc_Boolean(0);
// compiled identifier node returning bool8377 (depth = 3)
  adddatum2(obj7920, bool8377, 7);
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  sourceObject = obj7920;
  objclass7920 = obj7920->class;
  objclass7920->definitionModule = modulename;
  objclass7920->definitionLine = 1980;
  (*(struct UserObject *)self).data[0] = lowerouter7920;
  self = oldself7920;
  selfslot = oldselfslot7920;
  stackframe = oldstackframe7920;
  gc_frame_end(frame);
  return obj7920;
}
Object meth_ast_defDecNode8379(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_isPublic8391(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8394 = alloc_Float64(0);
// compiled num node returning num8394 (depth = 5)
  int op_slot_right_8393 = gc_frame_newslot(num8394);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8396 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8398 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8397);
// compiled call node returning call8398 (depth = 8)
// compiled member node returning call8398 (depth = 7)
  partcv[0] = 0;
  Object call8399 = callmethod(call8398, "size",
    1, partcv, params);
  gc_frame_end(callframe8396);
// compiled call node returning call8399 (depth = 6)
// compiled member node returning call8399 (depth = 5)
  int op_slot_left_8393 = gc_frame_newslot(call8399);
  params[0] = num8394;
  partcv[0] = 1;
  Object opresult8400 = callmethod(call8399, "==", 1, partcv, params);
// compiled op node returning opresult8400 (depth = 4)
  Object if8392 = done;
  if (istrue(opresult8400)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8401 = alloc_Boolean(0);
// compiled identifier node returning bool8401 (depth = 5)
  return bool8401;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8392 = undefined;
  } else {
  }
// compiled if node returning if8392 (depth = 3)
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8403 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8404 == NULL) {
    strlit8404 = alloc_String("public");
    gc_root(strlit8404);
  }
// compiled string node returning strlit8404 (depth = 5)
  gc_frame_newslot(strlit8404);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8405 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8406 = gc_frame_new();
// call case 3: self.outer request
  Object call8407 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8406);
// compiled call node returning call8407 (depth = 8)
// compiled member node returning call8407 (depth = 7)
  partcv[0] = 0;
  Object call8408 = callmethodflags(call8407, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8405);
// compiled call node returning call8408 (depth = 6)
// compiled member node returning call8408 (depth = 5)
  params[0] = self;
  params[1] = strlit8404;
  partcv[0] = 2;
  Object call8409 = callmethodflags(call8408, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8403);
// compiled call node returning call8409 (depth = 4)
  Object if8402 = done;
  if (istrue(call8409)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8410 = alloc_Boolean(1);
// compiled identifier node returning bool8410 (depth = 5)
  return bool8410;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8402 = undefined;
  } else {
  }
// compiled if node returning if8402 (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8411 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8412 == NULL) {
    strlit8412 = alloc_String("readable");
    gc_root(strlit8412);
  }
// compiled string node returning strlit8412 (depth = 4)
  gc_frame_newslot(strlit8412);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8413 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8414 = gc_frame_new();
// call case 3: self.outer request
  Object call8415 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8414);
// compiled call node returning call8415 (depth = 7)
// compiled member node returning call8415 (depth = 6)
  partcv[0] = 0;
  Object call8416 = callmethodflags(call8415, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8413);
// compiled call node returning call8416 (depth = 5)
// compiled member node returning call8416 (depth = 4)
  params[0] = self;
  params[1] = strlit8412;
  partcv[0] = 2;
  Object call8417 = callmethodflags(call8416, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8411);
// compiled call node returning call8417 (depth = 3)
  gc_frame_end(frame);
  return call8417;
}
Object meth_ast_isWritable8418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8421 = alloc_Float64(0);
// compiled num node returning num8421 (depth = 5)
  int op_slot_right_8420 = gc_frame_newslot(num8421);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8423 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8424 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8425 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8424);
// compiled call node returning call8425 (depth = 8)
// compiled member node returning call8425 (depth = 7)
  partcv[0] = 0;
  Object call8426 = callmethod(call8425, "size",
    1, partcv, params);
  gc_frame_end(callframe8423);
// compiled call node returning call8426 (depth = 6)
// compiled member node returning call8426 (depth = 5)
  int op_slot_left_8420 = gc_frame_newslot(call8426);
  params[0] = num8421;
  partcv[0] = 1;
  Object opresult8427 = callmethod(call8426, "==", 1, partcv, params);
// compiled op node returning opresult8427 (depth = 4)
  Object if8419 = done;
  if (istrue(opresult8427)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8428 = alloc_Boolean(0);
// compiled identifier node returning bool8428 (depth = 5)
  return bool8428;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8419 = undefined;
  } else {
  }
// compiled if node returning if8419 (depth = 3)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8430 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8431 == NULL) {
    strlit8431 = alloc_String("public");
    gc_root(strlit8431);
  }
// compiled string node returning strlit8431 (depth = 5)
  gc_frame_newslot(strlit8431);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8432 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8433 = gc_frame_new();
// call case 3: self.outer request
  Object call8434 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8433);
// compiled call node returning call8434 (depth = 8)
// compiled member node returning call8434 (depth = 7)
  partcv[0] = 0;
  Object call8435 = callmethodflags(call8434, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8432);
// compiled call node returning call8435 (depth = 6)
// compiled member node returning call8435 (depth = 5)
  params[0] = self;
  params[1] = strlit8431;
  partcv[0] = 2;
  Object call8436 = callmethodflags(call8435, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8430);
// compiled call node returning call8436 (depth = 4)
  Object if8429 = done;
  if (istrue(call8436)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8437 = alloc_Boolean(1);
// compiled identifier node returning bool8437 (depth = 5)
  return bool8437;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8429 = undefined;
  } else {
  }
// compiled if node returning if8429 (depth = 3)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8439 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8440 == NULL) {
    strlit8440 = alloc_String("writable");
    gc_root(strlit8440);
  }
// compiled string node returning strlit8440 (depth = 5)
  gc_frame_newslot(strlit8440);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8441 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8442 = gc_frame_new();
// call case 3: self.outer request
  Object call8443 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8442);
// compiled call node returning call8443 (depth = 8)
// compiled member node returning call8443 (depth = 7)
  partcv[0] = 0;
  Object call8444 = callmethodflags(call8443, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8441);
// compiled call node returning call8444 (depth = 6)
// compiled member node returning call8444 (depth = 5)
  params[0] = self;
  params[1] = strlit8440;
  partcv[0] = 2;
  Object call8445 = callmethodflags(call8444, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8439);
// compiled call node returning call8445 (depth = 4)
  Object if8438 = done;
  if (istrue(call8445)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8446 = alloc_Boolean(1);
// compiled identifier node returning bool8446 (depth = 5)
  return bool8446;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8438 = undefined;
  } else {
  }
// compiled if node returning if8438 (depth = 3)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8447 = alloc_Boolean(0);
// compiled identifier node returning bool8447 (depth = 3)
  gc_frame_end(frame);
  return bool8447;
}
Object meth_ast_isReadable8448(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8451 = alloc_Float64(0);
// compiled num node returning num8451 (depth = 5)
  int op_slot_right_8450 = gc_frame_newslot(num8451);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8453 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8455 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8454);
// compiled call node returning call8455 (depth = 8)
// compiled member node returning call8455 (depth = 7)
  partcv[0] = 0;
  Object call8456 = callmethod(call8455, "size",
    1, partcv, params);
  gc_frame_end(callframe8453);
// compiled call node returning call8456 (depth = 6)
// compiled member node returning call8456 (depth = 5)
  int op_slot_left_8450 = gc_frame_newslot(call8456);
  params[0] = num8451;
  partcv[0] = 1;
  Object opresult8457 = callmethod(call8456, "==", 1, partcv, params);
// compiled op node returning opresult8457 (depth = 4)
  Object if8449 = done;
  if (istrue(opresult8457)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8458 = alloc_Boolean(0);
// compiled identifier node returning bool8458 (depth = 5)
  return bool8458;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8449 = undefined;
  } else {
  }
// compiled if node returning if8449 (depth = 3)
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8460 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8461 == NULL) {
    strlit8461 = alloc_String("public");
    gc_root(strlit8461);
  }
// compiled string node returning strlit8461 (depth = 5)
  gc_frame_newslot(strlit8461);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8462 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8463 = gc_frame_new();
// call case 3: self.outer request
  Object call8464 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8463);
// compiled call node returning call8464 (depth = 8)
// compiled member node returning call8464 (depth = 7)
  partcv[0] = 0;
  Object call8465 = callmethodflags(call8464, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8462);
// compiled call node returning call8465 (depth = 6)
// compiled member node returning call8465 (depth = 5)
  params[0] = self;
  params[1] = strlit8461;
  partcv[0] = 2;
  Object call8466 = callmethodflags(call8465, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8460);
// compiled call node returning call8466 (depth = 4)
  Object if8459 = done;
  if (istrue(call8466)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8467 = alloc_Boolean(1);
// compiled identifier node returning bool8467 (depth = 5)
  return bool8467;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8459 = undefined;
  } else {
  }
// compiled if node returning if8459 (depth = 3)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8469 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8470 == NULL) {
    strlit8470 = alloc_String("readable");
    gc_root(strlit8470);
  }
// compiled string node returning strlit8470 (depth = 5)
  gc_frame_newslot(strlit8470);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8471 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8472 = gc_frame_new();
// call case 3: self.outer request
  Object call8473 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8472);
// compiled call node returning call8473 (depth = 8)
// compiled member node returning call8473 (depth = 7)
  partcv[0] = 0;
  Object call8474 = callmethodflags(call8473, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8471);
// compiled call node returning call8474 (depth = 6)
// compiled member node returning call8474 (depth = 5)
  params[0] = self;
  params[1] = strlit8470;
  partcv[0] = 2;
  Object call8475 = callmethodflags(call8474, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8469);
// compiled call node returning call8475 (depth = 4)
  Object if8468 = done;
  if (istrue(call8475)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8476 = alloc_Boolean(1);
// compiled identifier node returning bool8476 (depth = 5)
  return bool8476;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8468 = undefined;
  } else {
  }
// compiled if node returning if8468 (depth = 3)
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8477 = alloc_Boolean(0);
// compiled identifier node returning bool8477 (depth = 3)
  gc_frame_end(frame);
  return bool8477;
}
Object meth_ast_isFieldDec8478(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8479 = alloc_Boolean(1);
// compiled identifier node returning bool8479 (depth = 3)
  gc_frame_end(frame);
  return bool8479;
}
Object meth_ast_usesAsType8480(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8482 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8483 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8482);
// compiled call node returning call8483 (depth = 5)
// compiled member node returning call8483 (depth = 4)
  int op_slot_right_8481 = gc_frame_newslot(call8483);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8481 = gc_frame_newslot(*var_aNode);
  params[0] = call8483;
  partcv[0] = 1;
  Object opresult8485 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8485 (depth = 3)
  gc_frame_end(frame);
  return opresult8485;
}
Object meth_ast_declarationKindWithAncestors8486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8487 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call8488 = callmethod(*var_k, "vardec",
    1, partcv, params);
  gc_frame_end(callframe8487);
// compiled call node returning call8488 (depth = 4)
// compiled member node returning call8488 (depth = 3)
  gc_frame_end(frame);
  return call8488;
}
Object meth_ast__apply8514(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8515 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8516 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8515);
// compiled call node returning call8516 (depth = 6)
  gc_frame_end(frame);
  return call8516;
}
Object meth_ast_accept_40__41_from8489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8491 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8492 = callmethod(*var_visitor, "visitVarDec()up",
    2, partcv, params);
  gc_frame_end(callframe8491);
// compiled call node returning call8492 (depth = 4)
  Object if8490 = done;
  if (istrue(call8492)) {
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8493 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8494 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8493);
// compiled call node returning call8494 (depth = 5)
  *var_newChain = call8494;
  if (call8494 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8495 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8496 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8497 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8496);
// compiled call node returning call8497 (depth = 6)
// compiled member node returning call8497 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8498 = callmethod(call8497, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8495);
// compiled call node returning call8498 (depth = 4)
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8501 = alloc_Boolean(0);
// compiled identifier node returning bool8501 (depth = 6)
  int op_slot_right_8500 = gc_frame_newslot(bool8501);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8504 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8503);
// compiled call node returning call8504 (depth = 7)
// compiled member node returning call8504 (depth = 6)
  int op_slot_left_8500 = gc_frame_newslot(call8504);
  params[0] = bool8501;
  partcv[0] = 1;
  Object opresult8505 = callmethod(call8504, "!=", 1, partcv, params);
// compiled op node returning opresult8505 (depth = 5)
  Object if8499 = done;
  if (istrue(opresult8505)) {
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8506 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8507 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8508 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8507);
// compiled call node returning call8508 (depth = 7)
// compiled member node returning call8508 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8509 = callmethod(call8508, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8506);
// compiled call node returning call8509 (depth = 5)
    gc_frame_newslot(call8509);
    if8499 = call8509;
  } else {
  }
// compiled if node returning if8499 (depth = 4)
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8510 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8511 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8512 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8511);
// compiled call node returning call8512 (depth = 6)
// compiled member node returning call8512 (depth = 5)
  gc_frame_newslot(call8512);
// starting to compile block node (depth = 5)
  Object block8513 = alloc_Block(NULL, NULL, "ast", 2133);
  gc_frame_newslot(block8513);
// method "_apply"
  block_savedest(block8513);
  Object closure8514 = createclosure(3, "_apply");
  setclosureframe(closure8514, stackframe);
  addtoclosure(closure8514, var_visitor);
  addtoclosure(closure8514, var_newChain);
  addtoclosure(closure8514, selfslot);
  struct UserObject *uo8514 = (struct UserObject*)block8513;
  uo8514->data[0] = (Object)closure8514;
  Method *meth_meth_ast__apply8514 = addmethod2pos(block8513, "_apply", &meth_ast__apply8514, 0);
  int argcv_meth_ast__apply8514[] = {1};
  meth_meth_ast__apply8514->type = alloc_MethodType(1, argcv_meth_ast__apply8514);
  meth_meth_ast__apply8514->definitionModule = modulename;
  meth_meth_ast__apply8514->definitionLine = 2133;
// compiled block node returning block8513 (depth = 5)
  gc_frame_newslot(block8513);
// call case 5: prelude request
  params[0] = call8512;
  params[1] = block8513;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8518 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8510);
// compiled call node returning call8518 (depth = 4)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8521 = alloc_Boolean(0);
// compiled identifier node returning bool8521 (depth = 6)
  int op_slot_right_8520 = gc_frame_newslot(bool8521);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8523 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8524 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8523);
// compiled call node returning call8524 (depth = 7)
// compiled member node returning call8524 (depth = 6)
  int op_slot_left_8520 = gc_frame_newslot(call8524);
  params[0] = bool8521;
  partcv[0] = 1;
  Object opresult8525 = callmethod(call8524, "!=", 1, partcv, params);
// compiled op node returning opresult8525 (depth = 5)
  Object if8519 = done;
  if (istrue(opresult8525)) {
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8526 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8528 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8527);
// compiled call node returning call8528 (depth = 7)
// compiled member node returning call8528 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8529 = callmethod(call8528, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8526);
// compiled call node returning call8529 (depth = 5)
    gc_frame_newslot(call8529);
    if8519 = call8529;
  } else {
  }
// compiled if node returning if8519 (depth = 4)
    gc_frame_newslot(if8519);
    if8490 = if8519;
  } else {
  }
// compiled if node returning if8490 (depth = 3)
  gc_frame_end(frame);
  return if8490;
}
Object meth_ast_map_40__41_ancestors8530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8532 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8531);
// compiled call node returning call8532 (depth = 5)
// compiled member node returning call8532 (depth = 4)
  *var_n = call8532;
  if (call8532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8533 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8534 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8533);
// compiled call node returning call8534 (depth = 4)
  *var_newChain = call8534;
  if (call8534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8535 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8536 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8537 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8538 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8537);
// compiled call node returning call8538 (depth = 6)
// compiled member node returning call8538 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8539 = callmethod(call8538, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8536);
// compiled call node returning call8539 (depth = 4)
  gc_frame_newslot(call8539);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8539;
  partcv[0] = 1;
  Object call8540 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8535);
// compiled call node returning call8540 (depth = 3)
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8541 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8542 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8544 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8543);
// compiled call node returning call8544 (depth = 6)
// compiled member node returning call8544 (depth = 5)
  gc_frame_newslot(call8544);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8545 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8546 = gc_frame_new();
// call case 3: self.outer request
  Object call8547 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8546);
// compiled call node returning call8547 (depth = 8)
// compiled member node returning call8547 (depth = 7)
  partcv[0] = 0;
  Object call8548 = callmethodflags(call8547, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8545);
// compiled call node returning call8548 (depth = 6)
// compiled member node returning call8548 (depth = 5)
  params[0] = call8544;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8549 = callmethodflags(call8548, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8542);
// compiled call node returning call8549 (depth = 4)
  gc_frame_newslot(call8549);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8549;
  partcv[0] = 1;
  Object call8550 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8541);
// compiled call node returning call8550 (depth = 3)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8551 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8552 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8553 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8554 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8553);
// compiled call node returning call8554 (depth = 6)
// compiled member node returning call8554 (depth = 5)
  gc_frame_newslot(call8554);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8555 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8556 = gc_frame_new();
// call case 3: self.outer request
  Object call8557 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8556);
// compiled call node returning call8557 (depth = 8)
// compiled member node returning call8557 (depth = 7)
  partcv[0] = 0;
  Object call8558 = callmethodflags(call8557, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8555);
// compiled call node returning call8558 (depth = 6)
// compiled member node returning call8558 (depth = 5)
  params[0] = call8554;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8559 = callmethodflags(call8558, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8552);
// compiled call node returning call8559 (depth = 4)
  gc_frame_newslot(call8559);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8559;
  partcv[0] = 1;
  Object call8560 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8551);
// compiled call node returning call8560 (depth = 3)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8561 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8562 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8563 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8564 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8563);
// compiled call node returning call8564 (depth = 6)
// compiled member node returning call8564 (depth = 5)
  gc_frame_newslot(call8564);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8565 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8566 = gc_frame_new();
// call case 3: self.outer request
  Object call8567 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8566);
// compiled call node returning call8567 (depth = 8)
// compiled member node returning call8567 (depth = 7)
  partcv[0] = 0;
  Object call8568 = callmethodflags(call8567, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8565);
// compiled call node returning call8568 (depth = 6)
// compiled member node returning call8568 (depth = 5)
  params[0] = call8564;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8569 = callmethodflags(call8568, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8562);
// compiled call node returning call8569 (depth = 4)
  gc_frame_newslot(call8569);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8569;
  partcv[0] = 1;
  Object call8570 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8561);
// compiled call node returning call8570 (depth = 3)
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8571 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8572 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8571);
// compiled call node returning call8572 (depth = 3)
  gc_frame_end(frame);
  return call8572;
}
Object meth_ast__apply8581(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8583 == NULL) {
    strlit8583 = alloc_String("  ");
    gc_root(strlit8583);
  }
// compiled string node returning strlit8583 (depth = 7)
  int op_slot_right_8582 = gc_frame_newslot(strlit8583);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8582 = gc_frame_newslot(*var_spc);
  params[0] = strlit8583;
  partcv[0] = 1;
  Object opresult8585 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8585 (depth = 6)
  *var_spc = opresult8585;
  if (opresult8585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8574 == NULL) {
    strlit8574 = alloc_String("");
    gc_root(strlit8574);
  }
// compiled string node returning strlit8574 (depth = 4)
  *var_spc = strlit8574;
  if (strlit8574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8575 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8576 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8578 = alloc_Float64(0);
// compiled num node returning num8578 (depth = 5)
  int op_slot_left_8576 = gc_frame_newslot(num8578);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8579 = callmethod(num8578, "..", 1, partcv, params);
// compiled op node returning opresult8579 (depth = 4)
  gc_frame_newslot(opresult8579);
// starting to compile block node (depth = 4)
  Object block8580 = alloc_Block(NULL, NULL, "ast", 2152);
  gc_frame_newslot(block8580);
// method "_apply"
  block_savedest(block8580);
  Object closure8581 = createclosure(2, "_apply");
  setclosureframe(closure8581, stackframe);
  addtoclosure(closure8581, var_spc);
  addtoclosure(closure8581, selfslot);
  struct UserObject *uo8581 = (struct UserObject*)block8580;
  uo8581->data[0] = (Object)closure8581;
  Method *meth_meth_ast__apply8581 = addmethod2pos(block8580, "_apply", &meth_ast__apply8581, 0);
  int argcv_meth_ast__apply8581[] = {1};
  meth_meth_ast__apply8581->type = alloc_MethodType(1, argcv_meth_ast__apply8581);
  meth_meth_ast__apply8581->definitionModule = modulename;
  meth_meth_ast__apply8581->definitionLine = 2147;
// compiled block node returning block8580 (depth = 4)
  gc_frame_newslot(block8580);
// call case 5: prelude request
  params[0] = opresult8579;
  params[1] = block8580;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8588 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8575);
// compiled call node returning call8588 (depth = 3)
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8590 == NULL) {
    strlit8590 = alloc_String("""\x0a""");
    gc_root(strlit8590);
  }
// compiled string node returning strlit8590 (depth = 5)
  int op_slot_right_8589 = gc_frame_newslot(strlit8590);
// starting to compile call node (depth = 5)
  int callframe8592 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8593 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8592);
// compiled call node returning call8593 (depth = 5)
  int op_slot_left_8589 = gc_frame_newslot(call8593);
  params[0] = strlit8590;
  partcv[0] = 1;
  Object opresult8594 = callmethod(call8593, "++", 1, partcv, params);
// compiled op node returning opresult8594 (depth = 4)
  *var_s = opresult8594;
  if (opresult8594 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8596 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8598 = alloc_Float64(1);
// compiled num node returning num8598 (depth = 7)
  int op_slot_right_8597 = gc_frame_newslot(num8598);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8597 = gc_frame_newslot(*var_depth);
  params[0] = num8598;
  partcv[0] = 1;
  Object sum8600 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8600 (depth = 6)
  gc_frame_newslot(sum8600);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8601 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8602 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8601);
// compiled call node returning call8602 (depth = 7)
// compiled member node returning call8602 (depth = 6)
  params[0] = sum8600;
  partcv[0] = 1;
  Object call8603 = callmethod(call8602, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8596);
// compiled call node returning call8603 (depth = 5)
  int op_slot_right_8595 = gc_frame_newslot(call8603);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8605 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8605 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8607 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8607 (depth = 5)
  int op_slot_left_8595 = gc_frame_newslot(opresult8607);
  params[0] = call8603;
  partcv[0] = 1;
  Object opresult8608 = callmethod(opresult8607, "++", 1, partcv, params);
// compiled op node returning opresult8608 (depth = 4)
  *var_s = opresult8608;
  if (opresult8608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8612 = alloc_Boolean(0);
// compiled identifier node returning bool8612 (depth = 5)
  int op_slot_right_8611 = gc_frame_newslot(bool8612);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8614 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8615 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8614);
// compiled call node returning call8615 (depth = 6)
// compiled member node returning call8615 (depth = 5)
  int op_slot_left_8611 = gc_frame_newslot(call8615);
  params[0] = bool8612;
  partcv[0] = 1;
  Object opresult8616 = callmethod(call8615, "!=", 1, partcv, params);
// compiled op node returning opresult8616 (depth = 4)
  Object if8610 = done;
  if (istrue(opresult8616)) {
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8618 == NULL) {
    strlit8618 = alloc_String("Type: ");
    gc_root(strlit8618);
  }
// compiled string node returning strlit8618 (depth = 6)
  int op_slot_right_8617 = gc_frame_newslot(strlit8618);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8620 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8623 == NULL) {
    strlit8623 = alloc_String("""\x0a""");
    gc_root(strlit8623);
  }
// compiled string node returning strlit8623 (depth = 8)
  int op_slot_right_8622 = gc_frame_newslot(strlit8623);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8622 = gc_frame_newslot(*var_s);
  params[0] = strlit8623;
  partcv[0] = 1;
  Object opresult8625 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8625 (depth = 7)
  int op_slot_left_8620 = gc_frame_newslot(opresult8625);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8626 = callmethod(opresult8625, "++", 1, partcv, params);
// compiled op node returning opresult8626 (depth = 6)
  int op_slot_left_8617 = gc_frame_newslot(opresult8626);
  params[0] = strlit8618;
  partcv[0] = 1;
  Object opresult8627 = callmethod(opresult8626, "++", 1, partcv, params);
// compiled op node returning opresult8627 (depth = 5)
  *var_s = opresult8627;
  if (opresult8627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8630 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8632 = alloc_Float64(2);
// compiled num node returning num8632 (depth = 8)
  int op_slot_right_8631 = gc_frame_newslot(num8632);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8631 = gc_frame_newslot(*var_depth);
  params[0] = num8632;
  partcv[0] = 1;
  Object sum8634 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8634 (depth = 7)
  gc_frame_newslot(sum8634);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8635 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8636 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8635);
// compiled call node returning call8636 (depth = 8)
// compiled member node returning call8636 (depth = 7)
  params[0] = sum8634;
  partcv[0] = 1;
  Object call8637 = callmethod(call8636, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8630);
// compiled call node returning call8637 (depth = 6)
  int op_slot_right_8629 = gc_frame_newslot(call8637);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8629 = gc_frame_newslot(*var_s);
  params[0] = call8637;
  partcv[0] = 1;
  Object opresult8639 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8639 (depth = 5)
  *var_s = opresult8639;
  if (opresult8639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8610 = done;
  } else {
  }
// compiled if node returning if8610 (depth = 3)
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8644 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8643);
// compiled call node returning call8644 (depth = 6)
// compiled member node returning call8644 (depth = 5)
  int op_slot_right_8642 = gc_frame_newslot(call8644);
// starting to compile identifier node (depth = 5)
  Object bool8646 = alloc_Boolean(0);
// compiled identifier node returning bool8646 (depth = 5)
  int op_slot_left_8642 = gc_frame_newslot(bool8646);
  params[0] = call8644;
  partcv[0] = 1;
  Object opresult8647 = callmethod(bool8646, "!=", 1, partcv, params);
// compiled op node returning opresult8647 (depth = 4)
  Object if8641 = done;
  if (istrue(opresult8647)) {
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8649 == NULL) {
    strlit8649 = alloc_String("Value: ");
    gc_root(strlit8649);
  }
// compiled string node returning strlit8649 (depth = 6)
  int op_slot_right_8648 = gc_frame_newslot(strlit8649);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8651 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8654 == NULL) {
    strlit8654 = alloc_String("""\x0a""");
    gc_root(strlit8654);
  }
// compiled string node returning strlit8654 (depth = 8)
  int op_slot_right_8653 = gc_frame_newslot(strlit8654);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8653 = gc_frame_newslot(*var_s);
  params[0] = strlit8654;
  partcv[0] = 1;
  Object opresult8656 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8656 (depth = 7)
  int op_slot_left_8651 = gc_frame_newslot(opresult8656);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8657 = callmethod(opresult8656, "++", 1, partcv, params);
// compiled op node returning opresult8657 (depth = 6)
  int op_slot_left_8648 = gc_frame_newslot(opresult8657);
  params[0] = strlit8649;
  partcv[0] = 1;
  Object opresult8658 = callmethod(opresult8657, "++", 1, partcv, params);
// compiled op node returning opresult8658 (depth = 5)
  *var_s = opresult8658;
  if (opresult8658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8661 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8663 = alloc_Float64(2);
// compiled num node returning num8663 (depth = 8)
  int op_slot_right_8662 = gc_frame_newslot(num8663);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8662 = gc_frame_newslot(*var_depth);
  params[0] = num8663;
  partcv[0] = 1;
  Object sum8665 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8665 (depth = 7)
  gc_frame_newslot(sum8665);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8667 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8666);
// compiled call node returning call8667 (depth = 8)
// compiled member node returning call8667 (depth = 7)
  params[0] = sum8665;
  partcv[0] = 1;
  Object call8668 = callmethod(call8667, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8661);
// compiled call node returning call8668 (depth = 6)
  int op_slot_right_8660 = gc_frame_newslot(call8668);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8660 = gc_frame_newslot(*var_s);
  params[0] = call8668;
  partcv[0] = 1;
  Object opresult8670 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8670 (depth = 5)
  *var_s = opresult8670;
  if (opresult8670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8641 = done;
  } else {
  }
// compiled if node returning if8641 (depth = 3)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8674 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8675 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8674);
// compiled call node returning call8675 (depth = 6)
// compiled member node returning call8675 (depth = 5)
  int op_slot_right_8673 = gc_frame_newslot(call8675);
// starting to compile identifier node (depth = 5)
  Object bool8677 = alloc_Boolean(0);
// compiled identifier node returning bool8677 (depth = 5)
  int op_slot_left_8673 = gc_frame_newslot(bool8677);
  params[0] = call8675;
  partcv[0] = 1;
  Object opresult8678 = callmethod(bool8677, "!=", 1, partcv, params);
// compiled op node returning opresult8678 (depth = 4)
  Object if8672 = done;
  if (istrue(opresult8678)) {
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8680 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8682 = alloc_Float64(2);
// compiled num node returning num8682 (depth = 8)
  int op_slot_right_8681 = gc_frame_newslot(num8682);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8681 = gc_frame_newslot(*var_depth);
  params[0] = num8682;
  partcv[0] = 1;
  Object sum8684 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8684 (depth = 7)
  gc_frame_newslot(sum8684);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8685 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8686 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8685);
// compiled call node returning call8686 (depth = 8)
// compiled member node returning call8686 (depth = 7)
  params[0] = sum8684;
  partcv[0] = 1;
  Object call8687 = callmethod(call8686, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8680);
// compiled call node returning call8687 (depth = 6)
  int op_slot_right_8679 = gc_frame_newslot(call8687);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8679 = gc_frame_newslot(*var_s);
  params[0] = call8687;
  partcv[0] = 1;
  Object opresult8689 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8689 (depth = 5)
  *var_s = opresult8689;
  if (opresult8689 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8672 = done;
  } else {
  }
// compiled if node returning if8672 (depth = 3)
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8695(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8697 == NULL) {
    strlit8697 = alloc_String("    ");
    gc_root(strlit8697);
  }
// compiled string node returning strlit8697 (depth = 7)
  int op_slot_right_8696 = gc_frame_newslot(strlit8697);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8696 = gc_frame_newslot(*var_spc);
  params[0] = strlit8697;
  partcv[0] = 1;
  Object opresult8699 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8699 (depth = 6)
  *var_spc = opresult8699;
  if (opresult8699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8719(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8721 == NULL) {
    strlit8721 = alloc_String("Unknown");
    gc_root(strlit8721);
  }
// compiled string node returning strlit8721 (depth = 7)
  int op_slot_right_8720 = gc_frame_newslot(strlit8721);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8723 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8724 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8725 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8724);
// compiled call node returning call8725 (depth = 10)
// compiled member node returning call8725 (depth = 9)
  partcv[0] = 0;
  Object call8726 = callmethod(call8725, "value",
    1, partcv, params);
  gc_frame_end(callframe8723);
// compiled call node returning call8726 (depth = 8)
// compiled member node returning call8726 (depth = 7)
  int op_slot_left_8720 = gc_frame_newslot(call8726);
  params[0] = strlit8721;
  partcv[0] = 1;
  Object opresult8727 = callmethod(call8726, "!=", 1, partcv, params);
// compiled op node returning opresult8727 (depth = 6)
  gc_frame_end(frame);
  return opresult8727;
}
Object meth_ast__apply8766(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8768 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8769 = alloc_Float64(0);
// compiled num node returning num8769 (depth = 10)
  gc_frame_newslot(num8769);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8769;
  partcv[0] = 1;
  Object call8770 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8768);
// compiled call node returning call8770 (depth = 9)
  int op_slot_right_8767 = gc_frame_newslot(call8770);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8774 == NULL) {
    strlit8774 = alloc_String("");
    gc_root(strlit8774);
  }
// compiled string node returning strlit8774 (depth = 11)
  int op_slot_right_8773 = gc_frame_newslot(strlit8774);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8773 = gc_frame_newslot(*var_a);
  params[0] = strlit8774;
  partcv[0] = 1;
  Object opresult8776 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult8776 (depth = 10)
  Object if8772 = done;
struct StackFrameObject *iftmpstackframe8772 = stackframe;
  if (istrue(opresult8776)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8772);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8778 == NULL) {
    strlit8778 = alloc_String(", ");
    gc_root(strlit8778);
  }
// compiled string node returning strlit8778 (depth = 11)
  int op_slot_right_8777 = gc_frame_newslot(strlit8778);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8777 = gc_frame_newslot(*var_a);
  params[0] = strlit8778;
  partcv[0] = 1;
  Object opresult8780 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8780 (depth = 10)
    gc_frame_newslot(opresult8780);
    if8772 = opresult8780;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8772);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8781 == NULL) {
    strlit8781 = alloc_String("");
    gc_root(strlit8781);
  }
// compiled string node returning strlit8781 (depth = 10)
    gc_frame_newslot(strlit8781);
    if8772 = strlit8781;
  }
stackframe = iftmpstackframe8772;
// compiled if node returning if8772 (depth = 9)
  int op_slot_left_8767 = gc_frame_newslot(if8772);
  params[0] = call8770;
  partcv[0] = 1;
  Object opresult8782 = callmethod(if8772, "++", 1, partcv, params);
// compiled op node returning opresult8782 (depth = 8)
  gc_frame_end(frame);
  return opresult8782;
}
Object meth_ast_toGrace8691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8692 == NULL) {
    strlit8692 = alloc_String("");
    gc_root(strlit8692);
  }
// compiled string node returning strlit8692 (depth = 4)
  *var_spc = strlit8692;
  if (strlit8692 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8693 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block8694 = alloc_Block(NULL, NULL, "ast", 2172);
  gc_frame_newslot(block8694);
// method "_apply"
  block_savedest(block8694);
  Object closure8695 = createclosure(2, "_apply");
  setclosureframe(closure8695, stackframe);
  addtoclosure(closure8695, var_spc);
  addtoclosure(closure8695, selfslot);
  struct UserObject *uo8695 = (struct UserObject*)block8694;
  uo8695->data[0] = (Object)closure8695;
  Method *meth_meth_ast__apply8695 = addmethod2pos(block8694, "_apply", &meth_ast__apply8695, 0);
  int argcv_meth_ast__apply8695[] = {0};
  meth_meth_ast__apply8695->type = alloc_MethodType(1, argcv_meth_ast__apply8695);
  meth_meth_ast__apply8695->definitionModule = modulename;
  meth_meth_ast__apply8695->definitionLine = 2166;
// compiled block node returning block8694 (depth = 4)
  gc_frame_newslot(block8694);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block8694;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8702 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8693);
// compiled call node returning call8702 (depth = 3)
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8704 == NULL) {
    strlit8704 = alloc_String("");
    gc_root(strlit8704);
  }
// compiled string node returning strlit8704 (depth = 5)
  int op_slot_right_8703 = gc_frame_newslot(strlit8704);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8707 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8708 = alloc_Float64(0);
// compiled num node returning num8708 (depth = 7)
  gc_frame_newslot(num8708);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8709 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8710 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8709);
// compiled call node returning call8710 (depth = 8)
// compiled member node returning call8710 (depth = 7)
  params[0] = num8708;
  partcv[0] = 1;
  Object call8711 = callmethod(call8710, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8707);
// compiled call node returning call8711 (depth = 6)
  int op_slot_right_8706 = gc_frame_newslot(call8711);
// starting to compile string node (depth = 6)
  if (strlit8713 == NULL) {
    strlit8713 = alloc_String("var ");
    gc_root(strlit8713);
  }
// compiled string node returning strlit8713 (depth = 6)
  int op_slot_left_8706 = gc_frame_newslot(strlit8713);
  params[0] = call8711;
  partcv[0] = 1;
  Object opresult8714 = callmethod(strlit8713, "++", 1, partcv, params);
// compiled op node returning opresult8714 (depth = 5)
  int op_slot_left_8703 = gc_frame_newslot(opresult8714);
  params[0] = strlit8704;
  partcv[0] = 1;
  Object opresult8715 = callmethod(opresult8714, "++", 1, partcv, params);
// compiled op node returning opresult8715 (depth = 4)
  *var_s = opresult8715;
  if (opresult8715 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8717 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8718 = alloc_Block(NULL, NULL, "ast", 2176);
  gc_frame_newslot(block8718);
// method "_apply"
  block_savedest(block8718);
  Object closure8719 = createclosure(1, "_apply");
  setclosureframe(closure8719, stackframe);
  addtoclosure(closure8719, selfslot);
  struct UserObject *uo8719 = (struct UserObject*)block8718;
  uo8719->data[0] = (Object)closure8719;
  Method *meth_meth_ast__apply8719 = addmethod2pos(block8718, "_apply", &meth_ast__apply8719, 0);
  int argcv_meth_ast__apply8719[] = {0};
  meth_meth_ast__apply8719->type = alloc_MethodType(1, argcv_meth_ast__apply8719);
  meth_meth_ast__apply8719->definitionModule = modulename;
  meth_meth_ast__apply8719->definitionLine = 2175;
// compiled block node returning block8718 (depth = 5)
  gc_frame_newslot(block8718);
// call case 6: other member request
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8730 = alloc_Boolean(0);
// compiled identifier node returning bool8730 (depth = 6)
  int op_slot_right_8729 = gc_frame_newslot(bool8730);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8732 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8733 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8732);
// compiled call node returning call8733 (depth = 7)
// compiled member node returning call8733 (depth = 6)
  int op_slot_left_8729 = gc_frame_newslot(call8733);
  params[0] = bool8730;
  partcv[0] = 1;
  Object opresult8734 = callmethod(call8733, "!=", 1, partcv, params);
// compiled op node returning opresult8734 (depth = 5)
  params[0] = block8718;
  partcv[0] = 1;
  Object call8735 = callmethod(opresult8734, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8717);
// compiled call node returning call8735 (depth = 4)
  Object if8716 = done;
  if (istrue(call8735)) {
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8737 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8738 = alloc_Float64(0);
// compiled num node returning num8738 (depth = 7)
  gc_frame_newslot(num8738);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8739 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8740 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8739);
// compiled call node returning call8740 (depth = 8)
// compiled member node returning call8740 (depth = 7)
  params[0] = num8738;
  partcv[0] = 1;
  Object call8741 = callmethod(call8740, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8737);
// compiled call node returning call8741 (depth = 6)
  int op_slot_right_8736 = gc_frame_newslot(call8741);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8744 == NULL) {
    strlit8744 = alloc_String(" : ");
    gc_root(strlit8744);
  }
// compiled string node returning strlit8744 (depth = 7)
  int op_slot_right_8743 = gc_frame_newslot(strlit8744);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8743 = gc_frame_newslot(*var_s);
  params[0] = strlit8744;
  partcv[0] = 1;
  Object opresult8746 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8746 (depth = 6)
  int op_slot_left_8736 = gc_frame_newslot(opresult8746);
  params[0] = call8741;
  partcv[0] = 1;
  Object opresult8747 = callmethod(opresult8746, "++", 1, partcv, params);
// compiled op node returning opresult8747 (depth = 5)
  *var_s = opresult8747;
  if (opresult8747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8716 = done;
  } else {
  }
// compiled if node returning if8716 (depth = 3)
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8751 = alloc_Float64(0);
// compiled num node returning num8751 (depth = 5)
  int op_slot_right_8750 = gc_frame_newslot(num8751);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8753 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8755 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8754);
// compiled call node returning call8755 (depth = 8)
// compiled member node returning call8755 (depth = 7)
  partcv[0] = 0;
  Object call8756 = callmethod(call8755, "size",
    1, partcv, params);
  gc_frame_end(callframe8753);
// compiled call node returning call8756 (depth = 6)
// compiled member node returning call8756 (depth = 5)
  int op_slot_left_8750 = gc_frame_newslot(call8756);
  params[0] = num8751;
  partcv[0] = 1;
  Object opresult8757 = callmethod(call8756, ">", 1, partcv, params);
// compiled op node returning opresult8757 (depth = 4)
  Object if8749 = done;
  if (istrue(opresult8757)) {
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8759 == NULL) {
    strlit8759 = alloc_String(" is ");
    gc_root(strlit8759);
  }
// compiled string node returning strlit8759 (depth = 6)
  int op_slot_right_8758 = gc_frame_newslot(strlit8759);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8758 = gc_frame_newslot(*var_s);
  params[0] = strlit8759;
  partcv[0] = 1;
  Object opresult8761 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8761 (depth = 5)
  *var_s = opresult8761;
  if (opresult8761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8764 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8765 = alloc_Block(NULL, NULL, "ast", 2182);
  gc_frame_newslot(block8765);
// method "_apply"
  block_savedest(block8765);
  Object closure8766 = createclosure(1, "_apply");
  setclosureframe(closure8766, stackframe);
  addtoclosure(closure8766, selfslot);
  struct UserObject *uo8766 = (struct UserObject*)block8765;
  uo8766->data[0] = (Object)closure8766;
  Method *meth_meth_ast__apply8766 = addmethod2pos(block8765, "_apply", &meth_ast__apply8766, 0);
  int argcv_meth_ast__apply8766[] = {2};
  meth_meth_ast__apply8766->type = alloc_MethodType(1, argcv_meth_ast__apply8766);
  meth_meth_ast__apply8766->definitionModule = modulename;
  meth_meth_ast__apply8766->definitionLine = 2180;
// compiled block node returning block8765 (depth = 7)
  gc_frame_newslot(block8765);
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8784 == NULL) {
    strlit8784 = alloc_String("");
    gc_root(strlit8784);
  }
// compiled string node returning strlit8784 (depth = 7)
  gc_frame_newslot(strlit8784);
// call case 6: other member request
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8785 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8786 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8785);
// compiled call node returning call8786 (depth = 8)
// compiled member node returning call8786 (depth = 7)
  params[0] = block8765;
  params[1] = strlit8784;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8787 = callmethod(call8786, "fold()startingWith",
    2, partcv, params);
  gc_frame_end(callframe8764);
// compiled call node returning call8787 (depth = 6)
  int op_slot_right_8763 = gc_frame_newslot(call8787);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8763 = gc_frame_newslot(*var_s);
  params[0] = call8787;
  partcv[0] = 1;
  Object opresult8789 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8789 (depth = 5)
  *var_s = opresult8789;
  if (opresult8789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8749 = done;
  } else {
  }
// compiled if node returning if8749 (depth = 3)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8793 = alloc_Boolean(0);
// compiled identifier node returning bool8793 (depth = 5)
  int op_slot_right_8792 = gc_frame_newslot(bool8793);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8796 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8795);
// compiled call node returning call8796 (depth = 6)
// compiled member node returning call8796 (depth = 5)
  int op_slot_left_8792 = gc_frame_newslot(call8796);
  params[0] = bool8793;
  partcv[0] = 1;
  Object opresult8797 = callmethod(call8796, "!=", 1, partcv, params);
// compiled op node returning opresult8797 (depth = 4)
  Object if8791 = done;
  if (istrue(opresult8797)) {
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8799 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8801 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8800);
// compiled call node returning call8801 (depth = 8)
// compiled member node returning call8801 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8802 = callmethod(call8801, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8799);
// compiled call node returning call8802 (depth = 6)
  int op_slot_right_8798 = gc_frame_newslot(call8802);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8805 == NULL) {
    strlit8805 = alloc_String(" := ");
    gc_root(strlit8805);
  }
// compiled string node returning strlit8805 (depth = 7)
  int op_slot_right_8804 = gc_frame_newslot(strlit8805);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8804 = gc_frame_newslot(*var_s);
  params[0] = strlit8805;
  partcv[0] = 1;
  Object opresult8807 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8807 (depth = 6)
  int op_slot_left_8798 = gc_frame_newslot(opresult8807);
  params[0] = call8802;
  partcv[0] = 1;
  Object opresult8808 = callmethod(opresult8807, "++", 1, partcv, params);
// compiled op node returning opresult8808 (depth = 5)
  *var_s = opresult8808;
  if (opresult8808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8791 = done;
  } else {
  }
// compiled if node returning if8791 (depth = 3)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8811 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8812 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8814 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8813);
// compiled call node returning call8814 (depth = 6)
// compiled member node returning call8814 (depth = 5)
  gc_frame_newslot(call8814);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8815 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8816 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8815);
// compiled call node returning call8816 (depth = 6)
// compiled member node returning call8816 (depth = 5)
  gc_frame_newslot(call8816);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8817 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8818 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8817);
// compiled call node returning call8818 (depth = 6)
// compiled member node returning call8818 (depth = 5)
  gc_frame_newslot(call8818);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_varDecNode (depth = 5)
  params[0] = call8814;
  params[1] = call8816;
  params[2] = call8818;
  partcv[0] = 3;
  Object call8819 = callmethod(*var_varDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8812);
// compiled call node returning call8819 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8820 = callmethod(call8819, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8811);
// compiled call node returning call8820 (depth = 3)
  gc_frame_end(frame);
  return call8820;
}
Object meth_ast_statementName8821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8822 == NULL) {
    strlit8822 = alloc_String("variable declaration");
    gc_root(strlit8822);
  }
// compiled string node returning strlit8822 (depth = 3)
  gc_frame_end(frame);
  return strlit8822;
}
Object meth_ast_new8382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8383 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8383 = alloc_userobj2(22,19, objclass8383);
  gc_frame_newslot(obj8383);
if (objclass8383 == NULL) {
  glfree(obj8383->class->name);
  obj8383->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8383, self, 0);
  addmethodreal(obj8383,"outer", &reader_ast_outer_8384);
  Object oldself8383 = self;
  struct StackFrameObject *oldstackframe8383 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8383);
  gc_frame_newslot((Object)stackframe);
  self = obj8383;
  Object *oldselfslot8383 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8383 = (*(struct UserObject *)self).data[0], lowerouter8383 = thisouter8383;
  if (inheritingObject8383) {
    struct UserObject *inho8383 = (struct UserObject *)inheritingObject8383;
    while (inho8383->super != GraceDefaultObject) inho8383 = (struct UserObject *)inho8383->super;
    inho8383->super = obj8383;
    self = inheritingObject8383;
    *selfslot = self;
    lowerouter8383 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8383;
  }
if (objclass8383 == NULL) {
  Method *reader8385 = addmethodrealflags(obj8383, "kind",&reader_ast_kind_8385, MFLAG_DEF);
  reader8385->definitionModule = modulename;
  reader8385->definitionLine = 2093;
}
adddatum2(obj8383, alloc_Undefined(), 1);
if (objclass8383 == NULL) {
  Method *reader8386 = addmethodrealflags(obj8383, "name",&reader_ast_name_8386, 0);
  Method *writer8386 = addmethodrealflags(obj8383, "name:=",&writer_ast_name_8386, 0);
  reader8386->definitionModule = modulename;
  writer8386->definitionModule = modulename;
  reader8386->definitionLine = 2094;
  writer8386->definitionLine = 2094;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 2);
if (objclass8383 == NULL) {
  Method *reader8387 = addmethodrealflags(obj8383, "value",&reader_ast_value_8387, 0);
  Method *writer8387 = addmethodrealflags(obj8383, "value:=",&writer_ast_value_8387, 0);
  reader8387->definitionModule = modulename;
  writer8387->definitionModule = modulename;
  reader8387->definitionLine = 2095;
  writer8387->definitionLine = 2095;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 3);
if (objclass8383 == NULL) {
  Method *reader8388 = addmethodrealflags(obj8383, "dtype",&reader_ast_dtype_8388, 0);
  Method *writer8388 = addmethodrealflags(obj8383, "dtype:=",&writer_ast_dtype_8388, 0);
  reader8388->definitionModule = modulename;
  writer8388->definitionModule = modulename;
  reader8388->definitionLine = 2096;
  writer8388->definitionLine = 2096;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 4);
if (objclass8383 == NULL) {
  Method *reader8389 = addmethodrealflags(obj8383, "nameString",&reader_ast_nameString_8389, MFLAG_DEF);
  reader8389->definitionModule = modulename;
  reader8389->definitionLine = 2097;
}
adddatum2(obj8383, alloc_Undefined(), 5);
if (objclass8383 == NULL) {
  Method *reader8390 = addmethodrealflags(obj8383, "annotations",&reader_ast_annotations_8390, 0);
  Method *writer8390 = addmethodrealflags(obj8383, "annotations:=",&writer_ast_annotations_8390, 0);
  reader8390->definitionModule = modulename;
  writer8390->definitionModule = modulename;
  reader8390->definitionLine = 2098;
  writer8390->definitionLine = 2098;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8391 = (struct UserObject*)obj8383;
  uo8391->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8391 = addmethod2pos(obj8383, "isPublic", &meth_ast_isPublic8391, 7);
  int argcv_meth_ast_isPublic8391[] = {0};
  meth_meth_ast_isPublic8391->type = alloc_MethodType(1, argcv_meth_ast_isPublic8391);
  meth_meth_ast_isPublic8391->definitionModule = modulename;
  meth_meth_ast_isPublic8391->definitionLine = 2100;
// method "isWritable"
  struct UserObject *uo8418 = (struct UserObject*)obj8383;
  uo8418->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8418 = addmethod2pos(obj8383, "isWritable", &meth_ast_isWritable8418, 8);
  int argcv_meth_ast_isWritable8418[] = {0};
  meth_meth_ast_isWritable8418->type = alloc_MethodType(1, argcv_meth_ast_isWritable8418);
  meth_meth_ast_isWritable8418->definitionModule = modulename;
  meth_meth_ast_isWritable8418->definitionLine = 2106;
// method "isReadable"
  struct UserObject *uo8448 = (struct UserObject*)obj8383;
  uo8448->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8448 = addmethod2pos(obj8383, "isReadable", &meth_ast_isReadable8448, 9);
  int argcv_meth_ast_isReadable8448[] = {0};
  meth_meth_ast_isReadable8448->type = alloc_MethodType(1, argcv_meth_ast_isReadable8448);
  meth_meth_ast_isReadable8448->definitionModule = modulename;
  meth_meth_ast_isReadable8448->definitionLine = 2112;
// method "isFieldDec"
  struct UserObject *uo8478 = (struct UserObject*)obj8383;
  uo8478->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8478 = addmethod2pos(obj8383, "isFieldDec", &meth_ast_isFieldDec8478, 10);
  int argcv_meth_ast_isFieldDec8478[] = {0};
  meth_meth_ast_isFieldDec8478->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8478);
  meth_meth_ast_isFieldDec8478->definitionModule = modulename;
  meth_meth_ast_isFieldDec8478->definitionLine = 2118;
// method "usesAsType"
  struct UserObject *uo8480 = (struct UserObject*)obj8383;
  uo8480->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType8480 = addmethod2pos(obj8383, "usesAsType", &meth_ast_usesAsType8480, 11);
  int argcv_meth_ast_usesAsType8480[] = {1};
  meth_meth_ast_usesAsType8480->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8480);
  meth_meth_ast_usesAsType8480->definitionModule = modulename;
  meth_meth_ast_usesAsType8480->definitionLine = 2120;
// method "declarationKindWithAncestors"
  block_savedest(obj8383);
  Object closure8486 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8486, stackframe);
  addtoclosure(closure8486, var_k);
  struct UserObject *uo8486 = (struct UserObject*)obj8383;
  uo8486->data[12] = (Object)closure8486;
  Method *meth_meth_ast_declarationKindWithAncestors8486 = addmethod2pos(obj8383, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8486, 12);
  int argcv_meth_ast_declarationKindWithAncestors8486[] = {1};
  meth_meth_ast_declarationKindWithAncestors8486->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8486);
  meth_meth_ast_declarationKindWithAncestors8486->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8486->definitionLine = 2124;
// method "accept()from"
  struct UserObject *uo8489 = (struct UserObject*)obj8383;
  uo8489->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8489 = addmethod2pos(obj8383, "accept()from", &meth_ast_accept_40__41_from8489, 13);
  int argcv_meth_ast_accept_40__41_from8489[] = {1, 1};
  meth_meth_ast_accept_40__41_from8489->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8489);
  meth_meth_ast_accept_40__41_from8489->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8489->definitionLine = 2126;
// method "map()ancestors"
  struct UserObject *uo8530 = (struct UserObject*)obj8383;
  uo8530->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8530 = addmethod2pos(obj8383, "map()ancestors", &meth_ast_map_40__41_ancestors8530, 14);
  int argcv_meth_ast_map_40__41_ancestors8530[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8530->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8530);
  meth_meth_ast_map_40__41_ancestors8530->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8530->definitionLine = 2141;
// method "pretty"
  struct UserObject *uo8573 = (struct UserObject*)obj8383;
  uo8573->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty8573 = addmethod2pos(obj8383, "pretty", &meth_ast_pretty8573, 15);
  int argcv_meth_ast_pretty8573[] = {1};
  meth_meth_ast_pretty8573->type = alloc_MethodType(1, argcv_meth_ast_pretty8573);
  meth_meth_ast_pretty8573->definitionModule = modulename;
  meth_meth_ast_pretty8573->definitionLine = 2150;
// method "toGrace"
  struct UserObject *uo8691 = (struct UserObject*)obj8383;
  uo8691->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace8691 = addmethod2pos(obj8383, "toGrace", &meth_ast_toGrace8691, 16);
  int argcv_meth_ast_toGrace8691[] = {1};
  meth_meth_ast_toGrace8691->type = alloc_MethodType(1, argcv_meth_ast_toGrace8691);
meth_meth_ast_toGrace8691->type->types[0] = type_Number;
meth_meth_ast_toGrace8691->type->names[0] = "depth";
  meth_meth_ast_toGrace8691->definitionModule = modulename;
  meth_meth_ast_toGrace8691->definitionLine = 2170;
// method "shallowCopy"
  block_savedest(obj8383);
  Object closure8810 = createclosure(1, "shallowCopy");
  setclosureframe(closure8810, stackframe);
  addtoclosure(closure8810, var_varDecNode);
  struct UserObject *uo8810 = (struct UserObject*)obj8383;
  uo8810->data[17] = (Object)closure8810;
  Method *meth_meth_ast_shallowCopy8810 = addmethod2pos(obj8383, "shallowCopy", &meth_ast_shallowCopy8810, 17);
  int argcv_meth_ast_shallowCopy8810[] = {0};
  meth_meth_ast_shallowCopy8810->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8810);
  meth_meth_ast_shallowCopy8810->definitionModule = modulename;
  meth_meth_ast_shallowCopy8810->definitionLine = 2191;
// method "statementName"
  struct UserObject *uo8821 = (struct UserObject*)obj8383;
  uo8821->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8821 = addmethod2pos(obj8383, "statementName", &meth_ast_statementName8821, 18);
  int argcv_meth_ast_statementName8821[] = {0};
  meth_meth_ast_statementName8821->type = alloc_MethodType(1, argcv_meth_ast_statementName8821);
  meth_meth_ast_statementName8821->definitionModule = modulename;
  meth_meth_ast_statementName8821->definitionLine = 2194;
  sourceObject = obj8383;
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8823 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8824 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8825 = gc_frame_new();
// call case 3: self.outer request
  Object call8826 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8825);
// compiled call node returning call8826 (depth = 7)
// compiled member node returning call8826 (depth = 6)
  partcv[0] = 0;
  Object call8827 = callmethodflags(call8826, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8824);
// compiled call node returning call8827 (depth = 5)
// compiled member node returning call8827 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8828 = callmethodflags(call8827, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8823);
// compiled call node returning call8828 (depth = 3)
  struct UserObject *obj8383_uo = (struct UserObject *)obj8383;
  obj8383_uo->super = call8828;
  sourceObject = obj8383;
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8829 == NULL) {
    strlit8829 = alloc_String("vardec");
    gc_root(strlit8829);
  }
// compiled string node returning strlit8829 (depth = 3)
  adddatum2(obj8383, strlit8829, 1);
  sourceObject = obj8383;
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8383, *var_name_39_, 2);
  sourceObject = obj8383;
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8383, *var_val_39_, 3);
  sourceObject = obj8383;
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8383, *var_dtype_39_, 4);
  sourceObject = obj8383;
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8830 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8831 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8832 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8831);
// compiled call node returning call8832 (depth = 6)
// compiled member node returning call8832 (depth = 5)
  partcv[0] = 0;
  Object call8833 = callmethod(call8832, "value",
    1, partcv, params);
  gc_frame_end(callframe8830);
// compiled call node returning call8833 (depth = 4)
// compiled member node returning call8833 (depth = 3)
  adddatum2(obj8383, call8833, 5);
  sourceObject = obj8383;
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8834 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8835 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8836 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8835);
// compiled call node returning call8836 (depth = 6)
// compiled member node returning call8836 (depth = 5)
  partcv[0] = 0;
  Object call8837 = callmethod(call8836, "empty",
    1, partcv, params);
  gc_frame_end(callframe8834);
// compiled call node returning call8837 (depth = 4)
// compiled member node returning call8837 (depth = 3)
  adddatum2(obj8383, call8837, 6);
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  objclass8383 = obj8383->class;
  objclass8383->definitionModule = modulename;
  objclass8383->definitionLine = 2091;
  (*(struct UserObject *)self).data[0] = lowerouter8383;
  self = oldself8383;
  selfslot = oldselfslot8383;
  stackframe = oldstackframe8383;
  gc_frame_end(frame);
  return obj8383;
}
Object meth_ast_new8382_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8383 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8383 = alloc_userobj2(22,19, objclass8383);
  gc_frame_newslot(obj8383);
if (objclass8383 == NULL) {
  glfree(obj8383->class->name);
  obj8383->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8383, self, 0);
  addmethodreal(obj8383,"outer", &reader_ast_outer_8384);
  Object oldself8383 = self;
  struct StackFrameObject *oldstackframe8383 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8383);
  gc_frame_newslot((Object)stackframe);
  self = obj8383;
  Object *oldselfslot8383 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8383 = (*(struct UserObject *)self).data[0], lowerouter8383 = thisouter8383;
  if (inheritingObject8383) {
    struct UserObject *inho8383 = (struct UserObject *)inheritingObject8383;
    while (inho8383->super != GraceDefaultObject) inho8383 = (struct UserObject *)inho8383->super;
    inho8383->super = obj8383;
    self = inheritingObject8383;
    *selfslot = self;
    lowerouter8383 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8383;
  }
if (objclass8383 == NULL) {
  Method *reader8385 = addmethodrealflags(obj8383, "kind",&reader_ast_kind_8385, MFLAG_DEF);
  reader8385->definitionModule = modulename;
  reader8385->definitionLine = 2093;
}
adddatum2(obj8383, alloc_Undefined(), 1);
if (objclass8383 == NULL) {
  Method *reader8386 = addmethodrealflags(obj8383, "name",&reader_ast_name_8386, 0);
  Method *writer8386 = addmethodrealflags(obj8383, "name:=",&writer_ast_name_8386, 0);
  reader8386->definitionModule = modulename;
  writer8386->definitionModule = modulename;
  reader8386->definitionLine = 2094;
  writer8386->definitionLine = 2094;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 2);
if (objclass8383 == NULL) {
  Method *reader8387 = addmethodrealflags(obj8383, "value",&reader_ast_value_8387, 0);
  Method *writer8387 = addmethodrealflags(obj8383, "value:=",&writer_ast_value_8387, 0);
  reader8387->definitionModule = modulename;
  writer8387->definitionModule = modulename;
  reader8387->definitionLine = 2095;
  writer8387->definitionLine = 2095;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 3);
if (objclass8383 == NULL) {
  Method *reader8388 = addmethodrealflags(obj8383, "dtype",&reader_ast_dtype_8388, 0);
  Method *writer8388 = addmethodrealflags(obj8383, "dtype:=",&writer_ast_dtype_8388, 0);
  reader8388->definitionModule = modulename;
  writer8388->definitionModule = modulename;
  reader8388->definitionLine = 2096;
  writer8388->definitionLine = 2096;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 4);
if (objclass8383 == NULL) {
  Method *reader8389 = addmethodrealflags(obj8383, "nameString",&reader_ast_nameString_8389, MFLAG_DEF);
  reader8389->definitionModule = modulename;
  reader8389->definitionLine = 2097;
}
adddatum2(obj8383, alloc_Undefined(), 5);
if (objclass8383 == NULL) {
  Method *reader8390 = addmethodrealflags(obj8383, "annotations",&reader_ast_annotations_8390, 0);
  Method *writer8390 = addmethodrealflags(obj8383, "annotations:=",&writer_ast_annotations_8390, 0);
  reader8390->definitionModule = modulename;
  writer8390->definitionModule = modulename;
  reader8390->definitionLine = 2098;
  writer8390->definitionLine = 2098;
}
obj8383->flags |= OFLAG_MUTABLE;
adddatum2(obj8383, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8391 = (struct UserObject*)obj8383;
  uo8391->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8391 = addmethod2pos(obj8383, "isPublic", &meth_ast_isPublic8391, 7);
  int argcv_meth_ast_isPublic8391[] = {0};
  meth_meth_ast_isPublic8391->type = alloc_MethodType(1, argcv_meth_ast_isPublic8391);
  meth_meth_ast_isPublic8391->definitionModule = modulename;
  meth_meth_ast_isPublic8391->definitionLine = 2100;
// method "isWritable"
  struct UserObject *uo8418 = (struct UserObject*)obj8383;
  uo8418->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8418 = addmethod2pos(obj8383, "isWritable", &meth_ast_isWritable8418, 8);
  int argcv_meth_ast_isWritable8418[] = {0};
  meth_meth_ast_isWritable8418->type = alloc_MethodType(1, argcv_meth_ast_isWritable8418);
  meth_meth_ast_isWritable8418->definitionModule = modulename;
  meth_meth_ast_isWritable8418->definitionLine = 2106;
// method "isReadable"
  struct UserObject *uo8448 = (struct UserObject*)obj8383;
  uo8448->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8448 = addmethod2pos(obj8383, "isReadable", &meth_ast_isReadable8448, 9);
  int argcv_meth_ast_isReadable8448[] = {0};
  meth_meth_ast_isReadable8448->type = alloc_MethodType(1, argcv_meth_ast_isReadable8448);
  meth_meth_ast_isReadable8448->definitionModule = modulename;
  meth_meth_ast_isReadable8448->definitionLine = 2112;
// method "isFieldDec"
  struct UserObject *uo8478 = (struct UserObject*)obj8383;
  uo8478->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8478 = addmethod2pos(obj8383, "isFieldDec", &meth_ast_isFieldDec8478, 10);
  int argcv_meth_ast_isFieldDec8478[] = {0};
  meth_meth_ast_isFieldDec8478->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8478);
  meth_meth_ast_isFieldDec8478->definitionModule = modulename;
  meth_meth_ast_isFieldDec8478->definitionLine = 2118;
// method "usesAsType"
  struct UserObject *uo8480 = (struct UserObject*)obj8383;
  uo8480->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType8480 = addmethod2pos(obj8383, "usesAsType", &meth_ast_usesAsType8480, 11);
  int argcv_meth_ast_usesAsType8480[] = {1};
  meth_meth_ast_usesAsType8480->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8480);
  meth_meth_ast_usesAsType8480->definitionModule = modulename;
  meth_meth_ast_usesAsType8480->definitionLine = 2120;
// method "declarationKindWithAncestors"
  block_savedest(obj8383);
  Object closure8486 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8486, stackframe);
  addtoclosure(closure8486, var_k);
  struct UserObject *uo8486 = (struct UserObject*)obj8383;
  uo8486->data[12] = (Object)closure8486;
  Method *meth_meth_ast_declarationKindWithAncestors8486 = addmethod2pos(obj8383, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8486, 12);
  int argcv_meth_ast_declarationKindWithAncestors8486[] = {1};
  meth_meth_ast_declarationKindWithAncestors8486->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8486);
  meth_meth_ast_declarationKindWithAncestors8486->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8486->definitionLine = 2124;
// method "accept()from"
  struct UserObject *uo8489 = (struct UserObject*)obj8383;
  uo8489->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8489 = addmethod2pos(obj8383, "accept()from", &meth_ast_accept_40__41_from8489, 13);
  int argcv_meth_ast_accept_40__41_from8489[] = {1, 1};
  meth_meth_ast_accept_40__41_from8489->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8489);
  meth_meth_ast_accept_40__41_from8489->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8489->definitionLine = 2126;
// method "map()ancestors"
  struct UserObject *uo8530 = (struct UserObject*)obj8383;
  uo8530->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8530 = addmethod2pos(obj8383, "map()ancestors", &meth_ast_map_40__41_ancestors8530, 14);
  int argcv_meth_ast_map_40__41_ancestors8530[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8530->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8530);
  meth_meth_ast_map_40__41_ancestors8530->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8530->definitionLine = 2141;
// method "pretty"
  struct UserObject *uo8573 = (struct UserObject*)obj8383;
  uo8573->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty8573 = addmethod2pos(obj8383, "pretty", &meth_ast_pretty8573, 15);
  int argcv_meth_ast_pretty8573[] = {1};
  meth_meth_ast_pretty8573->type = alloc_MethodType(1, argcv_meth_ast_pretty8573);
  meth_meth_ast_pretty8573->definitionModule = modulename;
  meth_meth_ast_pretty8573->definitionLine = 2150;
// method "toGrace"
  struct UserObject *uo8691 = (struct UserObject*)obj8383;
  uo8691->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace8691 = addmethod2pos(obj8383, "toGrace", &meth_ast_toGrace8691, 16);
  int argcv_meth_ast_toGrace8691[] = {1};
  meth_meth_ast_toGrace8691->type = alloc_MethodType(1, argcv_meth_ast_toGrace8691);
meth_meth_ast_toGrace8691->type->types[0] = type_Number;
meth_meth_ast_toGrace8691->type->names[0] = "depth";
  meth_meth_ast_toGrace8691->definitionModule = modulename;
  meth_meth_ast_toGrace8691->definitionLine = 2170;
// method "shallowCopy"
  block_savedest(obj8383);
  Object closure8810 = createclosure(1, "shallowCopy");
  setclosureframe(closure8810, stackframe);
  addtoclosure(closure8810, var_varDecNode);
  struct UserObject *uo8810 = (struct UserObject*)obj8383;
  uo8810->data[17] = (Object)closure8810;
  Method *meth_meth_ast_shallowCopy8810 = addmethod2pos(obj8383, "shallowCopy", &meth_ast_shallowCopy8810, 17);
  int argcv_meth_ast_shallowCopy8810[] = {0};
  meth_meth_ast_shallowCopy8810->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8810);
  meth_meth_ast_shallowCopy8810->definitionModule = modulename;
  meth_meth_ast_shallowCopy8810->definitionLine = 2191;
// method "statementName"
  struct UserObject *uo8821 = (struct UserObject*)obj8383;
  uo8821->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8821 = addmethod2pos(obj8383, "statementName", &meth_ast_statementName8821, 18);
  int argcv_meth_ast_statementName8821[] = {0};
  meth_meth_ast_statementName8821->type = alloc_MethodType(1, argcv_meth_ast_statementName8821);
  meth_meth_ast_statementName8821->definitionModule = modulename;
  meth_meth_ast_statementName8821->definitionLine = 2194;
  sourceObject = obj8383;
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8823 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8824 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8825 = gc_frame_new();
// call case 3: self.outer request
  Object call8826 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8825);
// compiled call node returning call8826 (depth = 7)
// compiled member node returning call8826 (depth = 6)
  partcv[0] = 0;
  Object call8827 = callmethodflags(call8826, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8824);
// compiled call node returning call8827 (depth = 5)
// compiled member node returning call8827 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8828 = callmethodflags(call8827, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8823);
// compiled call node returning call8828 (depth = 3)
  struct UserObject *obj8383_uo = (struct UserObject *)obj8383;
  obj8383_uo->super = call8828;
  sourceObject = obj8383;
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8829 == NULL) {
    strlit8829 = alloc_String("vardec");
    gc_root(strlit8829);
  }
// compiled string node returning strlit8829 (depth = 3)
  adddatum2(obj8383, strlit8829, 1);
  sourceObject = obj8383;
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8383, *var_name_39_, 2);
  sourceObject = obj8383;
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8383, *var_val_39_, 3);
  sourceObject = obj8383;
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8383, *var_dtype_39_, 4);
  sourceObject = obj8383;
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8830 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8831 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8832 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8831);
// compiled call node returning call8832 (depth = 6)
// compiled member node returning call8832 (depth = 5)
  partcv[0] = 0;
  Object call8833 = callmethod(call8832, "value",
    1, partcv, params);
  gc_frame_end(callframe8830);
// compiled call node returning call8833 (depth = 4)
// compiled member node returning call8833 (depth = 3)
  adddatum2(obj8383, call8833, 5);
  sourceObject = obj8383;
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8834 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8835 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8836 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8835);
// compiled call node returning call8836 (depth = 6)
// compiled member node returning call8836 (depth = 5)
  partcv[0] = 0;
  Object call8837 = callmethod(call8836, "empty",
    1, partcv, params);
  gc_frame_end(callframe8834);
// compiled call node returning call8837 (depth = 4)
// compiled member node returning call8837 (depth = 3)
  adddatum2(obj8383, call8837, 6);
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  sourceObject = obj8383;
  objclass8383 = obj8383->class;
  objclass8383->definitionModule = modulename;
  objclass8383->definitionLine = 2091;
  (*(struct UserObject *)self).data[0] = lowerouter8383;
  self = oldself8383;
  selfslot = oldselfslot8383;
  stackframe = oldstackframe8383;
  gc_frame_end(frame);
  return obj8383;
}
Object meth_ast_varDecNode8839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for varDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for varDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_isImport8850(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isImport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isImport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8851 = alloc_Boolean(1);
// compiled identifier node returning bool8851 (depth = 3)
  gc_frame_end(frame);
  return bool8851;
}
Object meth_ast_isExternal8852(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExternal (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExternal");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8853 = alloc_Boolean(1);
// compiled identifier node returning bool8853 (depth = 3)
  gc_frame_end(frame);
  return bool8853;
}
Object meth_ast_isExecutable8854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8855 = alloc_Boolean(0);
// compiled identifier node returning bool8855 (depth = 3)
  gc_frame_end(frame);
  return bool8855;
}
Object meth_ast_name8856(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8857 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8858 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8857);
// compiled call node returning call8858 (depth = 4)
// compiled member node returning call8858 (depth = 3)
  gc_frame_end(frame);
  return call8858;
}
Object meth_ast_nameString8859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8860 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8862 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8861);
// compiled call node returning call8862 (depth = 6)
// compiled member node returning call8862 (depth = 5)
  partcv[0] = 0;
  Object call8863 = callmethod(call8862, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8860);
// compiled call node returning call8863 (depth = 4)
// compiled member node returning call8863 (depth = 3)
  gc_frame_end(frame);
  return call8863;
}
Object meth_ast_isPublic8864(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8867 = alloc_Float64(0);
// compiled num node returning num8867 (depth = 5)
  int op_slot_right_8866 = gc_frame_newslot(num8867);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8869 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8871 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8870);
// compiled call node returning call8871 (depth = 8)
// compiled member node returning call8871 (depth = 7)
  partcv[0] = 0;
  Object call8872 = callmethod(call8871, "size",
    1, partcv, params);
  gc_frame_end(callframe8869);
// compiled call node returning call8872 (depth = 6)
// compiled member node returning call8872 (depth = 5)
  int op_slot_left_8866 = gc_frame_newslot(call8872);
  params[0] = num8867;
  partcv[0] = 1;
  Object opresult8873 = callmethod(call8872, "==", 1, partcv, params);
// compiled op node returning opresult8873 (depth = 4)
  Object if8865 = done;
  if (istrue(opresult8873)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8874 = alloc_Boolean(0);
// compiled identifier node returning bool8874 (depth = 5)
  return bool8874;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8865 = undefined;
  } else {
  }
// compiled if node returning if8865 (depth = 3)
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8876 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8877 == NULL) {
    strlit8877 = alloc_String("public");
    gc_root(strlit8877);
  }
// compiled string node returning strlit8877 (depth = 5)
  gc_frame_newslot(strlit8877);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8878 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8879 = gc_frame_new();
// call case 3: self.outer request
  Object call8880 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8879);
// compiled call node returning call8880 (depth = 8)
// compiled member node returning call8880 (depth = 7)
  partcv[0] = 0;
  Object call8881 = callmethodflags(call8880, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8878);
// compiled call node returning call8881 (depth = 6)
// compiled member node returning call8881 (depth = 5)
  params[0] = self;
  params[1] = strlit8877;
  partcv[0] = 2;
  Object call8882 = callmethodflags(call8881, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8876);
// compiled call node returning call8882 (depth = 4)
  Object if8875 = done;
  if (istrue(call8882)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8883 = alloc_Boolean(1);
// compiled identifier node returning bool8883 (depth = 5)
  return bool8883;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8875 = undefined;
  } else {
  }
// compiled if node returning if8875 (depth = 3)
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8884 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8885 == NULL) {
    strlit8885 = alloc_String("readable");
    gc_root(strlit8885);
  }
// compiled string node returning strlit8885 (depth = 4)
  gc_frame_newslot(strlit8885);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8886 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8887 = gc_frame_new();
// call case 3: self.outer request
  Object call8888 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8887);
// compiled call node returning call8888 (depth = 7)
// compiled member node returning call8888 (depth = 6)
  partcv[0] = 0;
  Object call8889 = callmethodflags(call8888, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8886);
// compiled call node returning call8889 (depth = 5)
// compiled member node returning call8889 (depth = 4)
  params[0] = self;
  params[1] = strlit8885;
  partcv[0] = 2;
  Object call8890 = callmethodflags(call8889, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8884);
// compiled call node returning call8890 (depth = 3)
  gc_frame_end(frame);
  return call8890;
}
Object meth_ast__apply8897(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8900 == NULL) {
    strlit8900 = alloc_String("/");
    gc_root(strlit8900);
  }
// compiled string node returning strlit8900 (depth = 7)
  int op_slot_right_8899 = gc_frame_newslot(strlit8900);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_8899 = gc_frame_newslot(*var_c);
  params[0] = strlit8900;
  partcv[0] = 1;
  Object opresult8902 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult8902 (depth = 6)
  Object if8898 = done;
  if (istrue(opresult8902)) {
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8903 == NULL) {
    strlit8903 = alloc_String("");
    gc_root(strlit8903);
  }
// compiled string node returning strlit8903 (depth = 7)
  *var_bnm = strlit8903;
  if (strlit8903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8898 = done;
  } else {
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_8905 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_8905 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult8907 = callmethod(*var_bnm, "++", 1, partcv, params);
// compiled op node returning opresult8907 (depth = 7)
  *var_bnm = opresult8907;
  if (opresult8907 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8898 = done;
  }
// compiled if node returning if8898 (depth = 5)
  gc_frame_end(frame);
  return if8898;
}
Object meth_ast_moduleName8891(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8892 == NULL) {
    strlit8892 = alloc_String("");
    gc_root(strlit8892);
  }
// compiled string node returning strlit8892 (depth = 4)
  *var_bnm = strlit8892;
  if (strlit8892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8893 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8895 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8894);
// compiled call node returning call8895 (depth = 5)
// compiled member node returning call8895 (depth = 4)
  gc_frame_newslot(call8895);
// starting to compile block node (depth = 4)
  Object block8896 = alloc_Block(NULL, NULL, "ast", 2219);
  gc_frame_newslot(block8896);
// method "_apply"
  block_savedest(block8896);
  Object closure8897 = createclosure(2, "_apply");
  setclosureframe(closure8897, stackframe);
  addtoclosure(closure8897, var_bnm);
  addtoclosure(closure8897, selfslot);
  struct UserObject *uo8897 = (struct UserObject*)block8896;
  uo8897->data[0] = (Object)closure8897;
  Method *meth_meth_ast__apply8897 = addmethod2pos(block8896, "_apply", &meth_ast__apply8897, 0);
  int argcv_meth_ast__apply8897[] = {1};
  meth_meth_ast__apply8897->type = alloc_MethodType(1, argcv_meth_ast__apply8897);
  meth_meth_ast__apply8897->definitionModule = modulename;
  meth_meth_ast__apply8897->definitionLine = 2219;
// compiled block node returning block8896 (depth = 4)
  gc_frame_newslot(block8896);
// call case 5: prelude request
  params[0] = call8895;
  params[1] = block8896;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8910 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8893);
// compiled call node returning call8910 (depth = 3)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_isWritable8911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8912 = alloc_Boolean(0);
// compiled identifier node returning bool8912 (depth = 3)
  gc_frame_end(frame);
  return bool8912;
}
Object meth_ast_isReadable8913(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8914 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8915 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8914);
// compiled call node returning call8915 (depth = 4)
// compiled member node returning call8915 (depth = 3)
  gc_frame_end(frame);
  return call8915;
}
Object meth_ast_declarationKindWithAncestors8916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8917 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call8918 = callmethod(*var_k, "defdec",
    1, partcv, params);
  gc_frame_end(callframe8917);
// compiled call node returning call8918 (depth = 4)
// compiled member node returning call8918 (depth = 3)
  gc_frame_end(frame);
  return call8918;
}
Object meth_ast_usesAsType8919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8921 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8922 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8921);
// compiled call node returning call8922 (depth = 5)
// compiled member node returning call8922 (depth = 4)
  int op_slot_right_8920 = gc_frame_newslot(call8922);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8920 = gc_frame_newslot(*var_aNode);
  params[0] = call8922;
  partcv[0] = 1;
  Object opresult8924 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8924 (depth = 3)
  gc_frame_end(frame);
  return opresult8924;
}
Object meth_ast__apply8935(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8936 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8937 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8936);
// compiled call node returning call8937 (depth = 6)
  gc_frame_end(frame);
  return call8937;
}
Object meth_ast_accept_40__41_from8925(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8927 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8928 = callmethod(*var_visitor, "visitImport()up",
    2, partcv, params);
  gc_frame_end(callframe8927);
// compiled call node returning call8928 (depth = 4)
  Object if8926 = done;
  if (istrue(call8928)) {
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8929 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8930 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8929);
// compiled call node returning call8930 (depth = 5)
  *var_newChain = call8930;
  if (call8930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8931 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8933 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8932);
// compiled call node returning call8933 (depth = 6)
// compiled member node returning call8933 (depth = 5)
  gc_frame_newslot(call8933);
// starting to compile block node (depth = 5)
  Object block8934 = alloc_Block(NULL, NULL, "ast", 2237);
  gc_frame_newslot(block8934);
// method "_apply"
  block_savedest(block8934);
  Object closure8935 = createclosure(3, "_apply");
  setclosureframe(closure8935, stackframe);
  addtoclosure(closure8935, var_visitor);
  addtoclosure(closure8935, var_newChain);
  addtoclosure(closure8935, selfslot);
  struct UserObject *uo8935 = (struct UserObject*)block8934;
  uo8935->data[0] = (Object)closure8935;
  Method *meth_meth_ast__apply8935 = addmethod2pos(block8934, "_apply", &meth_ast__apply8935, 0);
  int argcv_meth_ast__apply8935[] = {1};
  meth_meth_ast__apply8935->type = alloc_MethodType(1, argcv_meth_ast__apply8935);
  meth_meth_ast__apply8935->definitionModule = modulename;
  meth_meth_ast__apply8935->definitionLine = 2237;
// compiled block node returning block8934 (depth = 5)
  gc_frame_newslot(block8934);
// call case 5: prelude request
  params[0] = call8933;
  params[1] = block8934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8939 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8931);
// compiled call node returning call8939 (depth = 4)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8940 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8941 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8942 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8941);
// compiled call node returning call8942 (depth = 6)
// compiled member node returning call8942 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8943 = callmethod(call8942, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8940);
// compiled call node returning call8943 (depth = 4)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8946 = alloc_Boolean(0);
// compiled identifier node returning bool8946 (depth = 6)
  int op_slot_right_8945 = gc_frame_newslot(bool8946);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8948 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8949 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8948);
// compiled call node returning call8949 (depth = 7)
// compiled member node returning call8949 (depth = 6)
  int op_slot_left_8945 = gc_frame_newslot(call8949);
  params[0] = bool8946;
  partcv[0] = 1;
  Object opresult8950 = callmethod(call8949, "!=", 1, partcv, params);
// compiled op node returning opresult8950 (depth = 5)
  Object if8944 = done;
  if (istrue(opresult8950)) {
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8951 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8952 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8953 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8952);
// compiled call node returning call8953 (depth = 7)
// compiled member node returning call8953 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8954 = callmethod(call8953, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8951);
// compiled call node returning call8954 (depth = 5)
    gc_frame_newslot(call8954);
    if8944 = call8954;
  } else {
  }
// compiled if node returning if8944 (depth = 4)
    gc_frame_newslot(if8944);
    if8926 = if8944;
  } else {
  }
// compiled if node returning if8926 (depth = 3)
  gc_frame_end(frame);
  return if8926;
}
Object meth_ast_map_40__41_ancestors8955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8956 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8957 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8956);
// compiled call node returning call8957 (depth = 5)
// compiled member node returning call8957 (depth = 4)
  *var_n = call8957;
  if (call8957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8958 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8959 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8958);
// compiled call node returning call8959 (depth = 4)
  *var_newChain = call8959;
  if (call8959 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8960 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8961 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8962 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8963 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8962);
// compiled call node returning call8963 (depth = 6)
// compiled member node returning call8963 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8964 = callmethod(call8963, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8961);
// compiled call node returning call8964 (depth = 4)
  gc_frame_newslot(call8964);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8964;
  partcv[0] = 1;
  Object call8965 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8960);
// compiled call node returning call8965 (depth = 3)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8966 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8967 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8968 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8969 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8968);
// compiled call node returning call8969 (depth = 6)
// compiled member node returning call8969 (depth = 5)
  gc_frame_newslot(call8969);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8970 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8971 = gc_frame_new();
// call case 3: self.outer request
  Object call8972 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8971);
// compiled call node returning call8972 (depth = 8)
// compiled member node returning call8972 (depth = 7)
  partcv[0] = 0;
  Object call8973 = callmethodflags(call8972, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8970);
// compiled call node returning call8973 (depth = 6)
// compiled member node returning call8973 (depth = 5)
  params[0] = call8969;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8974 = callmethodflags(call8973, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8967);
// compiled call node returning call8974 (depth = 4)
  gc_frame_newslot(call8974);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8974;
  partcv[0] = 1;
  Object call8975 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8966);
// compiled call node returning call8975 (depth = 3)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8976 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8977 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8979 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8978);
// compiled call node returning call8979 (depth = 6)
// compiled member node returning call8979 (depth = 5)
  gc_frame_newslot(call8979);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8980 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8981 = gc_frame_new();
// call case 3: self.outer request
  Object call8982 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8981);
// compiled call node returning call8982 (depth = 8)
// compiled member node returning call8982 (depth = 7)
  partcv[0] = 0;
  Object call8983 = callmethodflags(call8982, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8980);
// compiled call node returning call8983 (depth = 6)
// compiled member node returning call8983 (depth = 5)
  params[0] = call8979;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8984 = callmethodflags(call8983, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8977);
// compiled call node returning call8984 (depth = 4)
  gc_frame_newslot(call8984);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8984;
  partcv[0] = 1;
  Object call8985 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8976);
// compiled call node returning call8985 (depth = 3)
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8986 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8987 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8986);
// compiled call node returning call8987 (depth = 3)
  gc_frame_end(frame);
  return call8987;
}
Object meth_ast__apply8996(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8998 == NULL) {
    strlit8998 = alloc_String("  ");
    gc_root(strlit8998);
  }
// compiled string node returning strlit8998 (depth = 7)
  int op_slot_right_8997 = gc_frame_newslot(strlit8998);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8997 = gc_frame_newslot(*var_spc);
  params[0] = strlit8998;
  partcv[0] = 1;
  Object opresult9000 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9000 (depth = 6)
  *var_spc = opresult9000;
  if (opresult9000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8988(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8989 == NULL) {
    strlit8989 = alloc_String("");
    gc_root(strlit8989);
  }
// compiled string node returning strlit8989 (depth = 4)
  *var_spc = strlit8989;
  if (strlit8989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8990 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8991 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8993 = alloc_Float64(0);
// compiled num node returning num8993 (depth = 5)
  int op_slot_left_8991 = gc_frame_newslot(num8993);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8994 = callmethod(num8993, "..", 1, partcv, params);
// compiled op node returning opresult8994 (depth = 4)
  gc_frame_newslot(opresult8994);
// starting to compile block node (depth = 4)
  Object block8995 = alloc_Block(NULL, NULL, "ast", 2256);
  gc_frame_newslot(block8995);
// method "_apply"
  block_savedest(block8995);
  Object closure8996 = createclosure(2, "_apply");
  setclosureframe(closure8996, stackframe);
  addtoclosure(closure8996, var_spc);
  addtoclosure(closure8996, selfslot);
  struct UserObject *uo8996 = (struct UserObject*)block8995;
  uo8996->data[0] = (Object)closure8996;
  Method *meth_meth_ast__apply8996 = addmethod2pos(block8995, "_apply", &meth_ast__apply8996, 0);
  int argcv_meth_ast__apply8996[] = {1};
  meth_meth_ast__apply8996->type = alloc_MethodType(1, argcv_meth_ast__apply8996);
  meth_meth_ast__apply8996->definitionModule = modulename;
  meth_meth_ast__apply8996->definitionLine = 2251;
// compiled block node returning block8995 (depth = 4)
  gc_frame_newslot(block8995);
// call case 5: prelude request
  params[0] = opresult8994;
  params[1] = block8995;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9003 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8990);
// compiled call node returning call9003 (depth = 3)
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9005 == NULL) {
    strlit9005 = alloc_String("""\x0a""");
    gc_root(strlit9005);
  }
// compiled string node returning strlit9005 (depth = 5)
  int op_slot_right_9004 = gc_frame_newslot(strlit9005);
// starting to compile call node (depth = 5)
  int callframe9007 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9008 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9007);
// compiled call node returning call9008 (depth = 5)
  int op_slot_left_9004 = gc_frame_newslot(call9008);
  params[0] = strlit9005;
  partcv[0] = 1;
  Object opresult9009 = callmethod(call9008, "++", 1, partcv, params);
// compiled op node returning opresult9009 (depth = 4)
  *var_s = opresult9009;
  if (opresult9009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9012 == NULL) {
    strlit9012 = alloc_String("""\x0a""");
    gc_root(strlit9012);
  }
// compiled string node returning strlit9012 (depth = 6)
  int op_slot_right_9011 = gc_frame_newslot(strlit9012);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9016 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9015);
// compiled call node returning call9016 (depth = 8)
// compiled member node returning call9016 (depth = 7)
  int op_slot_right_9014 = gc_frame_newslot(call9016);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9019 == NULL) {
    strlit9019 = alloc_String("Path: ");
    gc_root(strlit9019);
  }
// compiled string node returning strlit9019 (depth = 8)
  int op_slot_right_9018 = gc_frame_newslot(strlit9019);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9021 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9023 == NULL) {
    strlit9023 = alloc_String("");
    gc_root(strlit9023);
  }
// compiled string node returning strlit9023 (depth = 9)
  int op_slot_left_9021 = gc_frame_newslot(strlit9023);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9024 = callmethod(strlit9023, "++", 1, partcv, params);
// compiled op node returning opresult9024 (depth = 8)
  int op_slot_left_9018 = gc_frame_newslot(opresult9024);
  params[0] = strlit9019;
  partcv[0] = 1;
  Object opresult9025 = callmethod(opresult9024, "++", 1, partcv, params);
// compiled op node returning opresult9025 (depth = 7)
  int op_slot_left_9014 = gc_frame_newslot(opresult9025);
  params[0] = call9016;
  partcv[0] = 1;
  Object opresult9026 = callmethod(opresult9025, "++", 1, partcv, params);
// compiled op node returning opresult9026 (depth = 6)
  int op_slot_left_9011 = gc_frame_newslot(opresult9026);
  params[0] = strlit9012;
  partcv[0] = 1;
  Object opresult9027 = callmethod(opresult9026, "++", 1, partcv, params);
// compiled op node returning opresult9027 (depth = 5)
  int op_slot_right_9010 = gc_frame_newslot(opresult9027);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9010 = gc_frame_newslot(*var_s);
  params[0] = opresult9027;
  partcv[0] = 1;
  Object opresult9029 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9029 (depth = 4)
  *var_s = opresult9029;
  if (opresult9029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9033 == NULL) {
    strlit9033 = alloc_String("""\x0a""");
    gc_root(strlit9033);
  }
// compiled string node returning strlit9033 (depth = 6)
  int op_slot_right_9032 = gc_frame_newslot(strlit9033);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9037 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9036);
// compiled call node returning call9037 (depth = 8)
// compiled member node returning call9037 (depth = 7)
  int op_slot_right_9035 = gc_frame_newslot(call9037);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9040 == NULL) {
    strlit9040 = alloc_String("Identifier: ");
    gc_root(strlit9040);
  }
// compiled string node returning strlit9040 (depth = 8)
  int op_slot_right_9039 = gc_frame_newslot(strlit9040);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9042 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9044 == NULL) {
    strlit9044 = alloc_String("");
    gc_root(strlit9044);
  }
// compiled string node returning strlit9044 (depth = 9)
  int op_slot_left_9042 = gc_frame_newslot(strlit9044);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9045 = callmethod(strlit9044, "++", 1, partcv, params);
// compiled op node returning opresult9045 (depth = 8)
  int op_slot_left_9039 = gc_frame_newslot(opresult9045);
  params[0] = strlit9040;
  partcv[0] = 1;
  Object opresult9046 = callmethod(opresult9045, "++", 1, partcv, params);
// compiled op node returning opresult9046 (depth = 7)
  int op_slot_left_9035 = gc_frame_newslot(opresult9046);
  params[0] = call9037;
  partcv[0] = 1;
  Object opresult9047 = callmethod(opresult9046, "++", 1, partcv, params);
// compiled op node returning opresult9047 (depth = 6)
  int op_slot_left_9032 = gc_frame_newslot(opresult9047);
  params[0] = strlit9033;
  partcv[0] = 1;
  Object opresult9048 = callmethod(opresult9047, "++", 1, partcv, params);
// compiled op node returning opresult9048 (depth = 5)
  int op_slot_right_9031 = gc_frame_newslot(opresult9048);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9031 = gc_frame_newslot(*var_s);
  params[0] = opresult9048;
  partcv[0] = 1;
  Object opresult9050 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9050 (depth = 4)
  *var_s = opresult9050;
  if (opresult9050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9054 = alloc_Float64(0);
// compiled num node returning num9054 (depth = 5)
  int op_slot_right_9053 = gc_frame_newslot(num9054);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9056 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9058 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9057);
// compiled call node returning call9058 (depth = 8)
// compiled member node returning call9058 (depth = 7)
  partcv[0] = 0;
  Object call9059 = callmethod(call9058, "size",
    1, partcv, params);
  gc_frame_end(callframe9056);
// compiled call node returning call9059 (depth = 6)
// compiled member node returning call9059 (depth = 5)
  int op_slot_left_9053 = gc_frame_newslot(call9059);
  params[0] = num9054;
  partcv[0] = 1;
  Object opresult9060 = callmethod(call9059, ">", 1, partcv, params);
// compiled op node returning opresult9060 (depth = 4)
  Object if9052 = done;
  if (istrue(opresult9060)) {
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9063 == NULL) {
    strlit9063 = alloc_String("""\x0a""");
    gc_root(strlit9063);
  }
// compiled string node returning strlit9063 (depth = 7)
  int op_slot_right_9062 = gc_frame_newslot(strlit9063);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9066 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9067 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9066);
// compiled call node returning call9067 (depth = 9)
// compiled member node returning call9067 (depth = 8)
  int op_slot_right_9065 = gc_frame_newslot(call9067);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9070 == NULL) {
    strlit9070 = alloc_String("Anotations: ");
    gc_root(strlit9070);
  }
// compiled string node returning strlit9070 (depth = 9)
  int op_slot_right_9069 = gc_frame_newslot(strlit9070);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9072 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9074 == NULL) {
    strlit9074 = alloc_String("");
    gc_root(strlit9074);
  }
// compiled string node returning strlit9074 (depth = 10)
  int op_slot_left_9072 = gc_frame_newslot(strlit9074);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9075 = callmethod(strlit9074, "++", 1, partcv, params);
// compiled op node returning opresult9075 (depth = 9)
  int op_slot_left_9069 = gc_frame_newslot(opresult9075);
  params[0] = strlit9070;
  partcv[0] = 1;
  Object opresult9076 = callmethod(opresult9075, "++", 1, partcv, params);
// compiled op node returning opresult9076 (depth = 8)
  int op_slot_left_9065 = gc_frame_newslot(opresult9076);
  params[0] = call9067;
  partcv[0] = 1;
  Object opresult9077 = callmethod(opresult9076, "++", 1, partcv, params);
// compiled op node returning opresult9077 (depth = 7)
  int op_slot_left_9062 = gc_frame_newslot(opresult9077);
  params[0] = strlit9063;
  partcv[0] = 1;
  Object opresult9078 = callmethod(opresult9077, "++", 1, partcv, params);
// compiled op node returning opresult9078 (depth = 6)
  int op_slot_right_9061 = gc_frame_newslot(opresult9078);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9061 = gc_frame_newslot(*var_s);
  params[0] = opresult9078;
  partcv[0] = 1;
  Object opresult9080 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9080 (depth = 5)
  *var_s = opresult9080;
  if (opresult9080 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9052 = done;
  } else {
  }
// compiled if node returning if9052 (depth = 3)
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9082(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9084 == NULL) {
    strlit9084 = alloc_String("");
    gc_root(strlit9084);
  }
// compiled string node returning strlit9084 (depth = 4)
  int op_slot_right_9083 = gc_frame_newslot(strlit9084);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9088 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9087);
// compiled call node returning call9088 (depth = 6)
// compiled member node returning call9088 (depth = 5)
  int op_slot_right_9086 = gc_frame_newslot(call9088);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9091 == NULL) {
    strlit9091 = alloc_String("""\x22"" as ");
    gc_root(strlit9091);
  }
// compiled string node returning strlit9091 (depth = 6)
  int op_slot_right_9090 = gc_frame_newslot(strlit9091);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9095 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9094);
// compiled call node returning call9095 (depth = 8)
// compiled member node returning call9095 (depth = 7)
  int op_slot_right_9093 = gc_frame_newslot(call9095);
// starting to compile string node (depth = 7)
  if (strlit9097 == NULL) {
    strlit9097 = alloc_String("import ""\x22""");
    gc_root(strlit9097);
  }
// compiled string node returning strlit9097 (depth = 7)
  int op_slot_left_9093 = gc_frame_newslot(strlit9097);
  params[0] = call9095;
  partcv[0] = 1;
  Object opresult9098 = callmethod(strlit9097, "++", 1, partcv, params);
// compiled op node returning opresult9098 (depth = 6)
  int op_slot_left_9090 = gc_frame_newslot(opresult9098);
  params[0] = strlit9091;
  partcv[0] = 1;
  Object opresult9099 = callmethod(opresult9098, "++", 1, partcv, params);
// compiled op node returning opresult9099 (depth = 5)
  int op_slot_left_9086 = gc_frame_newslot(opresult9099);
  params[0] = call9088;
  partcv[0] = 1;
  Object opresult9100 = callmethod(opresult9099, "++", 1, partcv, params);
// compiled op node returning opresult9100 (depth = 4)
  int op_slot_left_9083 = gc_frame_newslot(opresult9100);
  params[0] = strlit9084;
  partcv[0] = 1;
  Object opresult9101 = callmethod(opresult9100, "++", 1, partcv, params);
// compiled op node returning opresult9101 (depth = 3)
  gc_frame_end(frame);
  return opresult9101;
}
Object meth_ast_shallowCopy9102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9103 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9104 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9105 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9106 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9105);
// compiled call node returning call9106 (depth = 6)
// compiled member node returning call9106 (depth = 5)
  gc_frame_newslot(call9106);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
  Object bool9107 = alloc_Boolean(0);
// compiled identifier node returning bool9107 (depth = 5)
  gc_frame_newslot(bool9107);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importNode (depth = 5)
  params[0] = call9106;
  params[1] = *var_nullNode;
  params[2] = bool9107;
  partcv[0] = 3;
  Object call9108 = callmethod(*var_importNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9104);
// compiled call node returning call9108 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9109 = callmethod(call9108, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9103);
// compiled call node returning call9109 (depth = 3)
  gc_frame_end(frame);
  return call9109;
}
Object meth_ast_new8842(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8843 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8843 = alloc_userobj2(25,22, objclass8843);
  gc_frame_newslot(obj8843);
if (objclass8843 == NULL) {
  glfree(obj8843->class->name);
  obj8843->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8843, self, 0);
  addmethodreal(obj8843,"outer", &reader_ast_outer_8844);
  Object oldself8843 = self;
  struct StackFrameObject *oldstackframe8843 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8843);
  gc_frame_newslot((Object)stackframe);
  self = obj8843;
  Object *oldselfslot8843 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8843 = (*(struct UserObject *)self).data[0], lowerouter8843 = thisouter8843;
  if (inheritingObject8843) {
    struct UserObject *inho8843 = (struct UserObject *)inheritingObject8843;
    while (inho8843->super != GraceDefaultObject) inho8843 = (struct UserObject *)inho8843->super;
    inho8843->super = obj8843;
    self = inheritingObject8843;
    *selfslot = self;
    lowerouter8843 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8843;
  }
if (objclass8843 == NULL) {
  Method *reader8845 = addmethodrealflags(obj8843, "kind",&reader_ast_kind_8845, MFLAG_DEF);
  reader8845->definitionModule = modulename;
  reader8845->definitionLine = 2201;
}
adddatum2(obj8843, alloc_Undefined(), 1);
if (objclass8843 == NULL) {
  Method *reader8846 = addmethodrealflags(obj8843, "value",&reader_ast_value_8846, 0);
  Method *writer8846 = addmethodrealflags(obj8843, "value:=",&writer_ast_value_8846, 0);
  reader8846->definitionModule = modulename;
  writer8846->definitionModule = modulename;
  reader8846->definitionLine = 2202;
  writer8846->definitionLine = 2202;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 2);
if (objclass8843 == NULL) {
  Method *reader8847 = addmethodrealflags(obj8843, "path",&reader_ast_path_8847, 0);
  Method *writer8847 = addmethodrealflags(obj8843, "path:=",&writer_ast_path_8847, 0);
  reader8847->definitionModule = modulename;
  writer8847->definitionModule = modulename;
  reader8847->definitionLine = 2203;
  writer8847->definitionLine = 2203;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 3);
if (objclass8843 == NULL) {
  Method *reader8848 = addmethodrealflags(obj8843, "annotations",&reader_ast_annotations_8848, 0);
  Method *writer8848 = addmethodrealflags(obj8843, "annotations:=",&writer_ast_annotations_8848, 0);
  reader8848->definitionModule = modulename;
  writer8848->definitionModule = modulename;
  reader8848->definitionLine = 2204;
  writer8848->definitionLine = 2204;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 4);
if (objclass8843 == NULL) {
  Method *reader8849 = addmethodrealflags(obj8843, "dtype",&reader_ast_dtype_8849, 0);
  Method *writer8849 = addmethodrealflags(obj8843, "dtype:=",&writer_ast_dtype_8849, 0);
  reader8849->definitionModule = modulename;
  writer8849->definitionModule = modulename;
  reader8849->definitionLine = 2205;
  writer8849->definitionLine = 2205;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8850 = (struct UserObject*)obj8843;
  uo8850->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8850 = addmethod2pos(obj8843, "isImport", &meth_ast_isImport8850, 6);
  int argcv_meth_ast_isImport8850[] = {0};
  meth_meth_ast_isImport8850->type = alloc_MethodType(1, argcv_meth_ast_isImport8850);
  meth_meth_ast_isImport8850->definitionModule = modulename;
  meth_meth_ast_isImport8850->definitionLine = 2206;
// method "isExternal"
  struct UserObject *uo8852 = (struct UserObject*)obj8843;
  uo8852->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8852 = addmethod2pos(obj8843, "isExternal", &meth_ast_isExternal8852, 7);
  int argcv_meth_ast_isExternal8852[] = {0};
  meth_meth_ast_isExternal8852->type = alloc_MethodType(1, argcv_meth_ast_isExternal8852);
  meth_meth_ast_isExternal8852->definitionModule = modulename;
  meth_meth_ast_isExternal8852->definitionLine = 2207;
// method "isExecutable"
  struct UserObject *uo8854 = (struct UserObject*)obj8843;
  uo8854->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8854 = addmethod2pos(obj8843, "isExecutable", &meth_ast_isExecutable8854, 8);
  int argcv_meth_ast_isExecutable8854[] = {0};
  meth_meth_ast_isExecutable8854->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8854);
  meth_meth_ast_isExecutable8854->definitionModule = modulename;
  meth_meth_ast_isExecutable8854->definitionLine = 2208;
// method "name"
  struct UserObject *uo8856 = (struct UserObject*)obj8843;
  uo8856->data[9] = emptyclosure;
  Method *meth_meth_ast_name8856 = addmethod2pos(obj8843, "name", &meth_ast_name8856, 9);
  int argcv_meth_ast_name8856[] = {0};
  meth_meth_ast_name8856->type = alloc_MethodType(1, argcv_meth_ast_name8856);
  meth_meth_ast_name8856->definitionModule = modulename;
  meth_meth_ast_name8856->definitionLine = 2209;
// method "nameString"
  struct UserObject *uo8859 = (struct UserObject*)obj8843;
  uo8859->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8859 = addmethod2pos(obj8843, "nameString", &meth_ast_nameString8859, 10);
  int argcv_meth_ast_nameString8859[] = {0};
  meth_meth_ast_nameString8859->type = alloc_MethodType(1, argcv_meth_ast_nameString8859);
  meth_meth_ast_nameString8859->definitionModule = modulename;
  meth_meth_ast_nameString8859->definitionLine = 2210;
// method "isPublic"
  struct UserObject *uo8864 = (struct UserObject*)obj8843;
  uo8864->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8864 = addmethod2pos(obj8843, "isPublic", &meth_ast_isPublic8864, 11);
  int argcv_meth_ast_isPublic8864[] = {0};
  meth_meth_ast_isPublic8864->type = alloc_MethodType(1, argcv_meth_ast_isPublic8864);
  meth_meth_ast_isPublic8864->definitionModule = modulename;
  meth_meth_ast_isPublic8864->definitionLine = 2211;
// method "moduleName"
  struct UserObject *uo8891 = (struct UserObject*)obj8843;
  uo8891->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8891 = addmethod2pos(obj8843, "moduleName", &meth_ast_moduleName8891, 12);
  int argcv_meth_ast_moduleName8891[] = {0};
  meth_meth_ast_moduleName8891->type = alloc_MethodType(1, argcv_meth_ast_moduleName8891);
  meth_meth_ast_moduleName8891->definitionModule = modulename;
  meth_meth_ast_moduleName8891->definitionLine = 2217;
// method "isWritable"
  struct UserObject *uo8911 = (struct UserObject*)obj8843;
  uo8911->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8911 = addmethod2pos(obj8843, "isWritable", &meth_ast_isWritable8911, 13);
  int argcv_meth_ast_isWritable8911[] = {0};
  meth_meth_ast_isWritable8911->type = alloc_MethodType(1, argcv_meth_ast_isWritable8911);
  meth_meth_ast_isWritable8911->definitionModule = modulename;
  meth_meth_ast_isWritable8911->definitionLine = 2228;
// method "isReadable"
  struct UserObject *uo8913 = (struct UserObject*)obj8843;
  uo8913->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8913 = addmethod2pos(obj8843, "isReadable", &meth_ast_isReadable8913, 14);
  int argcv_meth_ast_isReadable8913[] = {0};
  meth_meth_ast_isReadable8913->type = alloc_MethodType(1, argcv_meth_ast_isReadable8913);
  meth_meth_ast_isReadable8913->definitionModule = modulename;
  meth_meth_ast_isReadable8913->definitionLine = 2229;
// method "declarationKindWithAncestors"
  block_savedest(obj8843);
  Object closure8916 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8916, stackframe);
  addtoclosure(closure8916, var_k);
  struct UserObject *uo8916 = (struct UserObject*)obj8843;
  uo8916->data[15] = (Object)closure8916;
  Method *meth_meth_ast_declarationKindWithAncestors8916 = addmethod2pos(obj8843, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8916, 15);
  int argcv_meth_ast_declarationKindWithAncestors8916[] = {1};
  meth_meth_ast_declarationKindWithAncestors8916->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8916);
  meth_meth_ast_declarationKindWithAncestors8916->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8916->definitionLine = 2230;
// method "usesAsType"
  struct UserObject *uo8919 = (struct UserObject*)obj8843;
  uo8919->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType8919 = addmethod2pos(obj8843, "usesAsType", &meth_ast_usesAsType8919, 16);
  int argcv_meth_ast_usesAsType8919[] = {1};
  meth_meth_ast_usesAsType8919->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8919);
  meth_meth_ast_usesAsType8919->definitionModule = modulename;
  meth_meth_ast_usesAsType8919->definitionLine = 2231;
// method "accept()from"
  struct UserObject *uo8925 = (struct UserObject*)obj8843;
  uo8925->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8925 = addmethod2pos(obj8843, "accept()from", &meth_ast_accept_40__41_from8925, 17);
  int argcv_meth_ast_accept_40__41_from8925[] = {1, 1};
  meth_meth_ast_accept_40__41_from8925->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8925);
  meth_meth_ast_accept_40__41_from8925->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8925->definitionLine = 2234;
// method "map()ancestors"
  struct UserObject *uo8955 = (struct UserObject*)obj8843;
  uo8955->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8955 = addmethod2pos(obj8843, "map()ancestors", &meth_ast_map_40__41_ancestors8955, 18);
  int argcv_meth_ast_map_40__41_ancestors8955[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8955->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8955);
  meth_meth_ast_map_40__41_ancestors8955->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8955->definitionLine = 2246;
// method "pretty"
  struct UserObject *uo8988 = (struct UserObject*)obj8843;
  uo8988->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty8988 = addmethod2pos(obj8843, "pretty", &meth_ast_pretty8988, 19);
  int argcv_meth_ast_pretty8988[] = {1};
  meth_meth_ast_pretty8988->type = alloc_MethodType(1, argcv_meth_ast_pretty8988);
  meth_meth_ast_pretty8988->definitionModule = modulename;
  meth_meth_ast_pretty8988->definitionLine = 2254;
// method "toGrace"
  struct UserObject *uo9082 = (struct UserObject*)obj8843;
  uo9082->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace9082 = addmethod2pos(obj8843, "toGrace", &meth_ast_toGrace9082, 20);
  int argcv_meth_ast_toGrace9082[] = {1};
  meth_meth_ast_toGrace9082->type = alloc_MethodType(1, argcv_meth_ast_toGrace9082);
meth_meth_ast_toGrace9082->type->types[0] = type_Number;
meth_meth_ast_toGrace9082->type->names[0] = "depth";
  meth_meth_ast_toGrace9082->definitionModule = modulename;
  meth_meth_ast_toGrace9082->definitionLine = 2267;
// method "shallowCopy"
  block_savedest(obj8843);
  Object closure9102 = createclosure(2, "shallowCopy");
  setclosureframe(closure9102, stackframe);
  addtoclosure(closure9102, var_nullNode);
  addtoclosure(closure9102, var_importNode);
  struct UserObject *uo9102 = (struct UserObject*)obj8843;
  uo9102->data[21] = (Object)closure9102;
  Method *meth_meth_ast_shallowCopy9102 = addmethod2pos(obj8843, "shallowCopy", &meth_ast_shallowCopy9102, 21);
  int argcv_meth_ast_shallowCopy9102[] = {0};
  meth_meth_ast_shallowCopy9102->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9102);
  meth_meth_ast_shallowCopy9102->definitionModule = modulename;
  meth_meth_ast_shallowCopy9102->definitionLine = 2270;
  sourceObject = obj8843;
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9110 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9111 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9112 = gc_frame_new();
// call case 3: self.outer request
  Object call9113 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9112);
// compiled call node returning call9113 (depth = 7)
// compiled member node returning call9113 (depth = 6)
  partcv[0] = 0;
  Object call9114 = callmethodflags(call9113, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9111);
// compiled call node returning call9114 (depth = 5)
// compiled member node returning call9114 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9115 = callmethodflags(call9114, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9110);
// compiled call node returning call9115 (depth = 3)
  struct UserObject *obj8843_uo = (struct UserObject *)obj8843;
  obj8843_uo->super = call9115;
  sourceObject = obj8843;
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9116 == NULL) {
    strlit9116 = alloc_String("import");
    gc_root(strlit9116);
  }
// compiled string node returning strlit9116 (depth = 3)
  adddatum2(obj8843, strlit9116, 1);
  sourceObject = obj8843;
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8843, *var_name_39_, 2);
  sourceObject = obj8843;
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8843, *var_path_39_, 3);
  sourceObject = obj8843;
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9117 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9118 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9119 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9118);
// compiled call node returning call9119 (depth = 6)
// compiled member node returning call9119 (depth = 5)
  partcv[0] = 0;
  Object call9120 = callmethod(call9119, "empty",
    1, partcv, params);
  gc_frame_end(callframe9117);
// compiled call node returning call9120 (depth = 4)
// compiled member node returning call9120 (depth = 3)
  adddatum2(obj8843, call9120, 4);
  sourceObject = obj8843;
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8843, *var_dtype_39_, 5);
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  objclass8843 = obj8843->class;
  objclass8843->definitionModule = modulename;
  objclass8843->definitionLine = 2199;
  (*(struct UserObject *)self).data[0] = lowerouter8843;
  self = oldself8843;
  selfslot = oldselfslot8843;
  stackframe = oldstackframe8843;
  gc_frame_end(frame);
  return obj8843;
}
Object meth_ast_new8842_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8843 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8843 = alloc_userobj2(25,22, objclass8843);
  gc_frame_newslot(obj8843);
if (objclass8843 == NULL) {
  glfree(obj8843->class->name);
  obj8843->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8843, self, 0);
  addmethodreal(obj8843,"outer", &reader_ast_outer_8844);
  Object oldself8843 = self;
  struct StackFrameObject *oldstackframe8843 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8843);
  gc_frame_newslot((Object)stackframe);
  self = obj8843;
  Object *oldselfslot8843 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8843 = (*(struct UserObject *)self).data[0], lowerouter8843 = thisouter8843;
  if (inheritingObject8843) {
    struct UserObject *inho8843 = (struct UserObject *)inheritingObject8843;
    while (inho8843->super != GraceDefaultObject) inho8843 = (struct UserObject *)inho8843->super;
    inho8843->super = obj8843;
    self = inheritingObject8843;
    *selfslot = self;
    lowerouter8843 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8843;
  }
if (objclass8843 == NULL) {
  Method *reader8845 = addmethodrealflags(obj8843, "kind",&reader_ast_kind_8845, MFLAG_DEF);
  reader8845->definitionModule = modulename;
  reader8845->definitionLine = 2201;
}
adddatum2(obj8843, alloc_Undefined(), 1);
if (objclass8843 == NULL) {
  Method *reader8846 = addmethodrealflags(obj8843, "value",&reader_ast_value_8846, 0);
  Method *writer8846 = addmethodrealflags(obj8843, "value:=",&writer_ast_value_8846, 0);
  reader8846->definitionModule = modulename;
  writer8846->definitionModule = modulename;
  reader8846->definitionLine = 2202;
  writer8846->definitionLine = 2202;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 2);
if (objclass8843 == NULL) {
  Method *reader8847 = addmethodrealflags(obj8843, "path",&reader_ast_path_8847, 0);
  Method *writer8847 = addmethodrealflags(obj8843, "path:=",&writer_ast_path_8847, 0);
  reader8847->definitionModule = modulename;
  writer8847->definitionModule = modulename;
  reader8847->definitionLine = 2203;
  writer8847->definitionLine = 2203;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 3);
if (objclass8843 == NULL) {
  Method *reader8848 = addmethodrealflags(obj8843, "annotations",&reader_ast_annotations_8848, 0);
  Method *writer8848 = addmethodrealflags(obj8843, "annotations:=",&writer_ast_annotations_8848, 0);
  reader8848->definitionModule = modulename;
  writer8848->definitionModule = modulename;
  reader8848->definitionLine = 2204;
  writer8848->definitionLine = 2204;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 4);
if (objclass8843 == NULL) {
  Method *reader8849 = addmethodrealflags(obj8843, "dtype",&reader_ast_dtype_8849, 0);
  Method *writer8849 = addmethodrealflags(obj8843, "dtype:=",&writer_ast_dtype_8849, 0);
  reader8849->definitionModule = modulename;
  writer8849->definitionModule = modulename;
  reader8849->definitionLine = 2205;
  writer8849->definitionLine = 2205;
}
obj8843->flags |= OFLAG_MUTABLE;
adddatum2(obj8843, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8850 = (struct UserObject*)obj8843;
  uo8850->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8850 = addmethod2pos(obj8843, "isImport", &meth_ast_isImport8850, 6);
  int argcv_meth_ast_isImport8850[] = {0};
  meth_meth_ast_isImport8850->type = alloc_MethodType(1, argcv_meth_ast_isImport8850);
  meth_meth_ast_isImport8850->definitionModule = modulename;
  meth_meth_ast_isImport8850->definitionLine = 2206;
// method "isExternal"
  struct UserObject *uo8852 = (struct UserObject*)obj8843;
  uo8852->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8852 = addmethod2pos(obj8843, "isExternal", &meth_ast_isExternal8852, 7);
  int argcv_meth_ast_isExternal8852[] = {0};
  meth_meth_ast_isExternal8852->type = alloc_MethodType(1, argcv_meth_ast_isExternal8852);
  meth_meth_ast_isExternal8852->definitionModule = modulename;
  meth_meth_ast_isExternal8852->definitionLine = 2207;
// method "isExecutable"
  struct UserObject *uo8854 = (struct UserObject*)obj8843;
  uo8854->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8854 = addmethod2pos(obj8843, "isExecutable", &meth_ast_isExecutable8854, 8);
  int argcv_meth_ast_isExecutable8854[] = {0};
  meth_meth_ast_isExecutable8854->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8854);
  meth_meth_ast_isExecutable8854->definitionModule = modulename;
  meth_meth_ast_isExecutable8854->definitionLine = 2208;
// method "name"
  struct UserObject *uo8856 = (struct UserObject*)obj8843;
  uo8856->data[9] = emptyclosure;
  Method *meth_meth_ast_name8856 = addmethod2pos(obj8843, "name", &meth_ast_name8856, 9);
  int argcv_meth_ast_name8856[] = {0};
  meth_meth_ast_name8856->type = alloc_MethodType(1, argcv_meth_ast_name8856);
  meth_meth_ast_name8856->definitionModule = modulename;
  meth_meth_ast_name8856->definitionLine = 2209;
// method "nameString"
  struct UserObject *uo8859 = (struct UserObject*)obj8843;
  uo8859->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8859 = addmethod2pos(obj8843, "nameString", &meth_ast_nameString8859, 10);
  int argcv_meth_ast_nameString8859[] = {0};
  meth_meth_ast_nameString8859->type = alloc_MethodType(1, argcv_meth_ast_nameString8859);
  meth_meth_ast_nameString8859->definitionModule = modulename;
  meth_meth_ast_nameString8859->definitionLine = 2210;
// method "isPublic"
  struct UserObject *uo8864 = (struct UserObject*)obj8843;
  uo8864->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8864 = addmethod2pos(obj8843, "isPublic", &meth_ast_isPublic8864, 11);
  int argcv_meth_ast_isPublic8864[] = {0};
  meth_meth_ast_isPublic8864->type = alloc_MethodType(1, argcv_meth_ast_isPublic8864);
  meth_meth_ast_isPublic8864->definitionModule = modulename;
  meth_meth_ast_isPublic8864->definitionLine = 2211;
// method "moduleName"
  struct UserObject *uo8891 = (struct UserObject*)obj8843;
  uo8891->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8891 = addmethod2pos(obj8843, "moduleName", &meth_ast_moduleName8891, 12);
  int argcv_meth_ast_moduleName8891[] = {0};
  meth_meth_ast_moduleName8891->type = alloc_MethodType(1, argcv_meth_ast_moduleName8891);
  meth_meth_ast_moduleName8891->definitionModule = modulename;
  meth_meth_ast_moduleName8891->definitionLine = 2217;
// method "isWritable"
  struct UserObject *uo8911 = (struct UserObject*)obj8843;
  uo8911->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8911 = addmethod2pos(obj8843, "isWritable", &meth_ast_isWritable8911, 13);
  int argcv_meth_ast_isWritable8911[] = {0};
  meth_meth_ast_isWritable8911->type = alloc_MethodType(1, argcv_meth_ast_isWritable8911);
  meth_meth_ast_isWritable8911->definitionModule = modulename;
  meth_meth_ast_isWritable8911->definitionLine = 2228;
// method "isReadable"
  struct UserObject *uo8913 = (struct UserObject*)obj8843;
  uo8913->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8913 = addmethod2pos(obj8843, "isReadable", &meth_ast_isReadable8913, 14);
  int argcv_meth_ast_isReadable8913[] = {0};
  meth_meth_ast_isReadable8913->type = alloc_MethodType(1, argcv_meth_ast_isReadable8913);
  meth_meth_ast_isReadable8913->definitionModule = modulename;
  meth_meth_ast_isReadable8913->definitionLine = 2229;
// method "declarationKindWithAncestors"
  block_savedest(obj8843);
  Object closure8916 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8916, stackframe);
  addtoclosure(closure8916, var_k);
  struct UserObject *uo8916 = (struct UserObject*)obj8843;
  uo8916->data[15] = (Object)closure8916;
  Method *meth_meth_ast_declarationKindWithAncestors8916 = addmethod2pos(obj8843, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8916, 15);
  int argcv_meth_ast_declarationKindWithAncestors8916[] = {1};
  meth_meth_ast_declarationKindWithAncestors8916->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8916);
  meth_meth_ast_declarationKindWithAncestors8916->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8916->definitionLine = 2230;
// method "usesAsType"
  struct UserObject *uo8919 = (struct UserObject*)obj8843;
  uo8919->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType8919 = addmethod2pos(obj8843, "usesAsType", &meth_ast_usesAsType8919, 16);
  int argcv_meth_ast_usesAsType8919[] = {1};
  meth_meth_ast_usesAsType8919->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8919);
  meth_meth_ast_usesAsType8919->definitionModule = modulename;
  meth_meth_ast_usesAsType8919->definitionLine = 2231;
// method "accept()from"
  struct UserObject *uo8925 = (struct UserObject*)obj8843;
  uo8925->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8925 = addmethod2pos(obj8843, "accept()from", &meth_ast_accept_40__41_from8925, 17);
  int argcv_meth_ast_accept_40__41_from8925[] = {1, 1};
  meth_meth_ast_accept_40__41_from8925->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8925);
  meth_meth_ast_accept_40__41_from8925->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8925->definitionLine = 2234;
// method "map()ancestors"
  struct UserObject *uo8955 = (struct UserObject*)obj8843;
  uo8955->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8955 = addmethod2pos(obj8843, "map()ancestors", &meth_ast_map_40__41_ancestors8955, 18);
  int argcv_meth_ast_map_40__41_ancestors8955[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8955->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8955);
  meth_meth_ast_map_40__41_ancestors8955->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8955->definitionLine = 2246;
// method "pretty"
  struct UserObject *uo8988 = (struct UserObject*)obj8843;
  uo8988->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty8988 = addmethod2pos(obj8843, "pretty", &meth_ast_pretty8988, 19);
  int argcv_meth_ast_pretty8988[] = {1};
  meth_meth_ast_pretty8988->type = alloc_MethodType(1, argcv_meth_ast_pretty8988);
  meth_meth_ast_pretty8988->definitionModule = modulename;
  meth_meth_ast_pretty8988->definitionLine = 2254;
// method "toGrace"
  struct UserObject *uo9082 = (struct UserObject*)obj8843;
  uo9082->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace9082 = addmethod2pos(obj8843, "toGrace", &meth_ast_toGrace9082, 20);
  int argcv_meth_ast_toGrace9082[] = {1};
  meth_meth_ast_toGrace9082->type = alloc_MethodType(1, argcv_meth_ast_toGrace9082);
meth_meth_ast_toGrace9082->type->types[0] = type_Number;
meth_meth_ast_toGrace9082->type->names[0] = "depth";
  meth_meth_ast_toGrace9082->definitionModule = modulename;
  meth_meth_ast_toGrace9082->definitionLine = 2267;
// method "shallowCopy"
  block_savedest(obj8843);
  Object closure9102 = createclosure(2, "shallowCopy");
  setclosureframe(closure9102, stackframe);
  addtoclosure(closure9102, var_nullNode);
  addtoclosure(closure9102, var_importNode);
  struct UserObject *uo9102 = (struct UserObject*)obj8843;
  uo9102->data[21] = (Object)closure9102;
  Method *meth_meth_ast_shallowCopy9102 = addmethod2pos(obj8843, "shallowCopy", &meth_ast_shallowCopy9102, 21);
  int argcv_meth_ast_shallowCopy9102[] = {0};
  meth_meth_ast_shallowCopy9102->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9102);
  meth_meth_ast_shallowCopy9102->definitionModule = modulename;
  meth_meth_ast_shallowCopy9102->definitionLine = 2270;
  sourceObject = obj8843;
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9110 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9111 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9112 = gc_frame_new();
// call case 3: self.outer request
  Object call9113 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9112);
// compiled call node returning call9113 (depth = 7)
// compiled member node returning call9113 (depth = 6)
  partcv[0] = 0;
  Object call9114 = callmethodflags(call9113, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9111);
// compiled call node returning call9114 (depth = 5)
// compiled member node returning call9114 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9115 = callmethodflags(call9114, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9110);
// compiled call node returning call9115 (depth = 3)
  struct UserObject *obj8843_uo = (struct UserObject *)obj8843;
  obj8843_uo->super = call9115;
  sourceObject = obj8843;
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9116 == NULL) {
    strlit9116 = alloc_String("import");
    gc_root(strlit9116);
  }
// compiled string node returning strlit9116 (depth = 3)
  adddatum2(obj8843, strlit9116, 1);
  sourceObject = obj8843;
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8843, *var_name_39_, 2);
  sourceObject = obj8843;
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8843, *var_path_39_, 3);
  sourceObject = obj8843;
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9117 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9118 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9119 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9118);
// compiled call node returning call9119 (depth = 6)
// compiled member node returning call9119 (depth = 5)
  partcv[0] = 0;
  Object call9120 = callmethod(call9119, "empty",
    1, partcv, params);
  gc_frame_end(callframe9117);
// compiled call node returning call9120 (depth = 4)
// compiled member node returning call9120 (depth = 3)
  adddatum2(obj8843, call9120, 4);
  sourceObject = obj8843;
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8843, *var_dtype_39_, 5);
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  sourceObject = obj8843;
  objclass8843 = obj8843->class;
  objclass8843->definitionModule = modulename;
  objclass8843->definitionLine = 2199;
  (*(struct UserObject *)self).data[0] = lowerouter8843;
  self = oldself8843;
  selfslot = oldselfslot8843;
  stackframe = oldstackframe8843;
  gc_frame_end(frame);
  return obj8843;
}
Object meth_ast_importNode9122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for importNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for importNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_isDialect9130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isDialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isDialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9131 = alloc_Boolean(1);
// compiled identifier node returning bool9131 (depth = 3)
  gc_frame_end(frame);
  return bool9131;
}
Object meth_ast_isExternal9132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExternal (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExternal");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9133 = alloc_Boolean(1);
// compiled identifier node returning bool9133 (depth = 3)
  gc_frame_end(frame);
  return bool9133;
}
Object meth_ast_isExecutable9134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9135 = alloc_Boolean(0);
// compiled identifier node returning bool9135 (depth = 3)
  gc_frame_end(frame);
  return bool9135;
}
Object meth_ast__apply9142(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9145 == NULL) {
    strlit9145 = alloc_String("/");
    gc_root(strlit9145);
  }
// compiled string node returning strlit9145 (depth = 7)
  int op_slot_right_9144 = gc_frame_newslot(strlit9145);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_9144 = gc_frame_newslot(*var_c);
  params[0] = strlit9145;
  partcv[0] = 1;
  Object opresult9147 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult9147 (depth = 6)
  Object if9143 = done;
  if (istrue(opresult9147)) {
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9148 == NULL) {
    strlit9148 = alloc_String("");
    gc_root(strlit9148);
  }
// compiled string node returning strlit9148 (depth = 7)
  *var_bnm = strlit9148;
  if (strlit9148 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9143 = done;
  } else {
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_9150 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_9150 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9152 = callmethod(*var_bnm, "++", 1, partcv, params);
// compiled op node returning opresult9152 (depth = 7)
  *var_bnm = opresult9152;
  if (opresult9152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9143 = done;
  }
// compiled if node returning if9143 (depth = 5)
  gc_frame_end(frame);
  return if9143;
}
Object meth_ast_moduleName9136(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9137 == NULL) {
    strlit9137 = alloc_String("");
    gc_root(strlit9137);
  }
// compiled string node returning strlit9137 (depth = 4)
  *var_bnm = strlit9137;
  if (strlit9137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9138 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9140 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9139);
// compiled call node returning call9140 (depth = 5)
// compiled member node returning call9140 (depth = 4)
  gc_frame_newslot(call9140);
// starting to compile block node (depth = 4)
  Object block9141 = alloc_Block(NULL, NULL, "ast", 2286);
  gc_frame_newslot(block9141);
// method "_apply"
  block_savedest(block9141);
  Object closure9142 = createclosure(2, "_apply");
  setclosureframe(closure9142, stackframe);
  addtoclosure(closure9142, var_bnm);
  addtoclosure(closure9142, selfslot);
  struct UserObject *uo9142 = (struct UserObject*)block9141;
  uo9142->data[0] = (Object)closure9142;
  Method *meth_meth_ast__apply9142 = addmethod2pos(block9141, "_apply", &meth_ast__apply9142, 0);
  int argcv_meth_ast__apply9142[] = {1};
  meth_meth_ast__apply9142->type = alloc_MethodType(1, argcv_meth_ast__apply9142);
  meth_meth_ast__apply9142->definitionModule = modulename;
  meth_meth_ast__apply9142->definitionLine = 2286;
// compiled block node returning block9141 (depth = 4)
  gc_frame_newslot(block9141);
// call case 5: prelude request
  params[0] = call9140;
  params[1] = block9141;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9155 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9138);
// compiled call node returning call9155 (depth = 3)
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_path9156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "path");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for path (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for path");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9157 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9158 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9157);
// compiled call node returning call9158 (depth = 4)
// compiled member node returning call9158 (depth = 3)
  gc_frame_end(frame);
  return call9158;
}
Object meth_ast_accept_40__41_from9159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9160 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9161 = callmethod(*var_visitor, "visitDialect()up",
    2, partcv, params);
  gc_frame_end(callframe9160);
// compiled call node returning call9161 (depth = 3)
  gc_frame_end(frame);
  return call9161;
}
Object meth_ast_map_40__41_ancestors9162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9164 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9163);
// compiled call node returning call9164 (depth = 5)
// compiled member node returning call9164 (depth = 4)
  *var_n = call9164;
  if (call9164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9165 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9166 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9165);
// compiled call node returning call9166 (depth = 4)
  *var_newChain = call9166;
  if (call9166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9167 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9168 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9167);
// compiled call node returning call9168 (depth = 3)
  gc_frame_end(frame);
  return call9168;
}
Object meth_ast__apply9177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9179 == NULL) {
    strlit9179 = alloc_String("  ");
    gc_root(strlit9179);
  }
// compiled string node returning strlit9179 (depth = 7)
  int op_slot_right_9178 = gc_frame_newslot(strlit9179);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9178 = gc_frame_newslot(*var_spc);
  params[0] = strlit9179;
  partcv[0] = 1;
  Object opresult9181 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9181 (depth = 6)
  *var_spc = opresult9181;
  if (opresult9181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9170 == NULL) {
    strlit9170 = alloc_String("");
    gc_root(strlit9170);
  }
// compiled string node returning strlit9170 (depth = 4)
  *var_spc = strlit9170;
  if (strlit9170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9171 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9172 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9174 = alloc_Float64(0);
// compiled num node returning num9174 (depth = 5)
  int op_slot_left_9172 = gc_frame_newslot(num9174);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9175 = callmethod(num9174, "..", 1, partcv, params);
// compiled op node returning opresult9175 (depth = 4)
  gc_frame_newslot(opresult9175);
// starting to compile block node (depth = 4)
  Object block9176 = alloc_Block(NULL, NULL, "ast", 2308);
  gc_frame_newslot(block9176);
// method "_apply"
  block_savedest(block9176);
  Object closure9177 = createclosure(2, "_apply");
  setclosureframe(closure9177, stackframe);
  addtoclosure(closure9177, var_spc);
  addtoclosure(closure9177, selfslot);
  struct UserObject *uo9177 = (struct UserObject*)block9176;
  uo9177->data[0] = (Object)closure9177;
  Method *meth_meth_ast__apply9177 = addmethod2pos(block9176, "_apply", &meth_ast__apply9177, 0);
  int argcv_meth_ast__apply9177[] = {1};
  meth_meth_ast__apply9177->type = alloc_MethodType(1, argcv_meth_ast__apply9177);
  meth_meth_ast__apply9177->definitionModule = modulename;
  meth_meth_ast__apply9177->definitionLine = 2302;
// compiled block node returning block9176 (depth = 4)
  gc_frame_newslot(block9176);
// call case 5: prelude request
  params[0] = opresult9175;
  params[1] = block9176;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9184 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9171);
// compiled call node returning call9184 (depth = 3)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9186 == NULL) {
    strlit9186 = alloc_String("""\x0a""");
    gc_root(strlit9186);
  }
// compiled string node returning strlit9186 (depth = 5)
  int op_slot_right_9185 = gc_frame_newslot(strlit9186);
// starting to compile call node (depth = 5)
  int callframe9188 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9189 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9188);
// compiled call node returning call9189 (depth = 5)
  int op_slot_left_9185 = gc_frame_newslot(call9189);
  params[0] = strlit9186;
  partcv[0] = 1;
  Object opresult9190 = callmethod(call9189, "++", 1, partcv, params);
// compiled op node returning opresult9190 (depth = 4)
  *var_s = opresult9190;
  if (opresult9190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9193 == NULL) {
    strlit9193 = alloc_String("""\x0a""");
    gc_root(strlit9193);
  }
// compiled string node returning strlit9193 (depth = 6)
  int op_slot_right_9192 = gc_frame_newslot(strlit9193);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9196 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9197 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9196);
// compiled call node returning call9197 (depth = 8)
// compiled member node returning call9197 (depth = 7)
  int op_slot_right_9195 = gc_frame_newslot(call9197);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9200 == NULL) {
    strlit9200 = alloc_String("Path: ");
    gc_root(strlit9200);
  }
// compiled string node returning strlit9200 (depth = 8)
  int op_slot_right_9199 = gc_frame_newslot(strlit9200);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9202 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9204 == NULL) {
    strlit9204 = alloc_String("");
    gc_root(strlit9204);
  }
// compiled string node returning strlit9204 (depth = 9)
  int op_slot_left_9202 = gc_frame_newslot(strlit9204);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9205 = callmethod(strlit9204, "++", 1, partcv, params);
// compiled op node returning opresult9205 (depth = 8)
  int op_slot_left_9199 = gc_frame_newslot(opresult9205);
  params[0] = strlit9200;
  partcv[0] = 1;
  Object opresult9206 = callmethod(opresult9205, "++", 1, partcv, params);
// compiled op node returning opresult9206 (depth = 7)
  int op_slot_left_9195 = gc_frame_newslot(opresult9206);
  params[0] = call9197;
  partcv[0] = 1;
  Object opresult9207 = callmethod(opresult9206, "++", 1, partcv, params);
// compiled op node returning opresult9207 (depth = 6)
  int op_slot_left_9192 = gc_frame_newslot(opresult9207);
  params[0] = strlit9193;
  partcv[0] = 1;
  Object opresult9208 = callmethod(opresult9207, "++", 1, partcv, params);
// compiled op node returning opresult9208 (depth = 5)
  int op_slot_right_9191 = gc_frame_newslot(opresult9208);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9191 = gc_frame_newslot(*var_s);
  params[0] = opresult9208;
  partcv[0] = 1;
  Object opresult9210 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9210 (depth = 4)
  *var_s = opresult9210;
  if (opresult9210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9214 == NULL) {
    strlit9214 = alloc_String("""\x22""");
    gc_root(strlit9214);
  }
// compiled string node returning strlit9214 (depth = 4)
  int op_slot_right_9213 = gc_frame_newslot(strlit9214);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9218 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9217);
// compiled call node returning call9218 (depth = 6)
// compiled member node returning call9218 (depth = 5)
  int op_slot_right_9216 = gc_frame_newslot(call9218);
// starting to compile string node (depth = 5)
  if (strlit9220 == NULL) {
    strlit9220 = alloc_String("dialect ""\x22""");
    gc_root(strlit9220);
  }
// compiled string node returning strlit9220 (depth = 5)
  int op_slot_left_9216 = gc_frame_newslot(strlit9220);
  params[0] = call9218;
  partcv[0] = 1;
  Object opresult9221 = callmethod(strlit9220, "++", 1, partcv, params);
// compiled op node returning opresult9221 (depth = 4)
  int op_slot_left_9213 = gc_frame_newslot(opresult9221);
  params[0] = strlit9214;
  partcv[0] = 1;
  Object opresult9222 = callmethod(opresult9221, "++", 1, partcv, params);
// compiled op node returning opresult9222 (depth = 3)
  gc_frame_end(frame);
  return opresult9222;
}
Object meth_ast_shallowCopy9223(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9224 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9225 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9226 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9227 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9226);
// compiled call node returning call9227 (depth = 6)
// compiled member node returning call9227 (depth = 5)
  gc_frame_newslot(call9227);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dialectNode (depth = 5)
  params[0] = call9227;
  partcv[0] = 1;
  Object call9228 = callmethod(*var_dialectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9225);
// compiled call node returning call9228 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9229 = callmethod(call9228, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9224);
// compiled call node returning call9229 (depth = 3)
  gc_frame_end(frame);
  return call9229;
}
Object meth_ast_new9125(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9126 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9126 = alloc_userobj2(13,13, objclass9126);
  gc_frame_newslot(obj9126);
if (objclass9126 == NULL) {
  glfree(obj9126->class->name);
  obj9126->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9126, self, 0);
  addmethodreal(obj9126,"outer", &reader_ast_outer_9127);
  Object oldself9126 = self;
  struct StackFrameObject *oldstackframe9126 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9126);
  gc_frame_newslot((Object)stackframe);
  self = obj9126;
  Object *oldselfslot9126 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9126 = (*(struct UserObject *)self).data[0], lowerouter9126 = thisouter9126;
  if (inheritingObject9126) {
    struct UserObject *inho9126 = (struct UserObject *)inheritingObject9126;
    while (inho9126->super != GraceDefaultObject) inho9126 = (struct UserObject *)inho9126->super;
    inho9126->super = obj9126;
    self = inheritingObject9126;
    *selfslot = self;
    lowerouter9126 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9126;
  }
if (objclass9126 == NULL) {
  Method *reader9128 = addmethodrealflags(obj9126, "kind",&reader_ast_kind_9128, MFLAG_DEF);
  reader9128->definitionModule = modulename;
  reader9128->definitionLine = 2278;
}
adddatum2(obj9126, alloc_Undefined(), 1);
if (objclass9126 == NULL) {
  Method *reader9129 = addmethodrealflags(obj9126, "value",&reader_ast_value_9129, 0);
  Method *writer9129 = addmethodrealflags(obj9126, "value:=",&writer_ast_value_9129, 0);
  reader9129->definitionModule = modulename;
  writer9129->definitionModule = modulename;
  reader9129->definitionLine = 2279;
  writer9129->definitionLine = 2279;
}
obj9126->flags |= OFLAG_MUTABLE;
adddatum2(obj9126, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo9130 = (struct UserObject*)obj9126;
  uo9130->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9130 = addmethod2pos(obj9126, "isDialect", &meth_ast_isDialect9130, 3);
  int argcv_meth_ast_isDialect9130[] = {0};
  meth_meth_ast_isDialect9130->type = alloc_MethodType(1, argcv_meth_ast_isDialect9130);
  meth_meth_ast_isDialect9130->definitionModule = modulename;
  meth_meth_ast_isDialect9130->definitionLine = 2281;
// method "isExternal"
  struct UserObject *uo9132 = (struct UserObject*)obj9126;
  uo9132->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal9132 = addmethod2pos(obj9126, "isExternal", &meth_ast_isExternal9132, 4);
  int argcv_meth_ast_isExternal9132[] = {0};
  meth_meth_ast_isExternal9132->type = alloc_MethodType(1, argcv_meth_ast_isExternal9132);
  meth_meth_ast_isExternal9132->definitionModule = modulename;
  meth_meth_ast_isExternal9132->definitionLine = 2282;
// method "isExecutable"
  struct UserObject *uo9134 = (struct UserObject*)obj9126;
  uo9134->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable9134 = addmethod2pos(obj9126, "isExecutable", &meth_ast_isExecutable9134, 5);
  int argcv_meth_ast_isExecutable9134[] = {0};
  meth_meth_ast_isExecutable9134->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9134);
  meth_meth_ast_isExecutable9134->definitionModule = modulename;
  meth_meth_ast_isExecutable9134->definitionLine = 2283;
// method "moduleName"
  struct UserObject *uo9136 = (struct UserObject*)obj9126;
  uo9136->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName9136 = addmethod2pos(obj9126, "moduleName", &meth_ast_moduleName9136, 6);
  int argcv_meth_ast_moduleName9136[] = {0};
  meth_meth_ast_moduleName9136->type = alloc_MethodType(1, argcv_meth_ast_moduleName9136);
  meth_meth_ast_moduleName9136->definitionModule = modulename;
  meth_meth_ast_moduleName9136->definitionLine = 2284;
// method "path"
  struct UserObject *uo9156 = (struct UserObject*)obj9126;
  uo9156->data[7] = emptyclosure;
  Method *meth_meth_ast_path9156 = addmethod2pos(obj9126, "path", &meth_ast_path9156, 7);
  int argcv_meth_ast_path9156[] = {0};
  meth_meth_ast_path9156->type = alloc_MethodType(1, argcv_meth_ast_path9156);
  meth_meth_ast_path9156->definitionModule = modulename;
  meth_meth_ast_path9156->definitionLine = 2295;
// method "accept()from"
  struct UserObject *uo9159 = (struct UserObject*)obj9126;
  uo9159->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9159 = addmethod2pos(obj9126, "accept()from", &meth_ast_accept_40__41_from9159, 8);
  int argcv_meth_ast_accept_40__41_from9159[] = {1, 1};
  meth_meth_ast_accept_40__41_from9159->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9159);
  meth_meth_ast_accept_40__41_from9159->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9159->definitionLine = 2298;
// method "map()ancestors"
  struct UserObject *uo9162 = (struct UserObject*)obj9126;
  uo9162->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9162 = addmethod2pos(obj9126, "map()ancestors", &meth_ast_map_40__41_ancestors9162, 9);
  int argcv_meth_ast_map_40__41_ancestors9162[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9162->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9162);
  meth_meth_ast_map_40__41_ancestors9162->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9162->definitionLine = 2301;
// method "pretty"
  struct UserObject *uo9169 = (struct UserObject*)obj9126;
  uo9169->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty9169 = addmethod2pos(obj9126, "pretty", &meth_ast_pretty9169, 10);
  int argcv_meth_ast_pretty9169[] = {1};
  meth_meth_ast_pretty9169->type = alloc_MethodType(1, argcv_meth_ast_pretty9169);
  meth_meth_ast_pretty9169->definitionModule = modulename;
  meth_meth_ast_pretty9169->definitionLine = 2306;
// method "toGrace"
  struct UserObject *uo9212 = (struct UserObject*)obj9126;
  uo9212->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace9212 = addmethod2pos(obj9126, "toGrace", &meth_ast_toGrace9212, 11);
  int argcv_meth_ast_toGrace9212[] = {1};
  meth_meth_ast_toGrace9212->type = alloc_MethodType(1, argcv_meth_ast_toGrace9212);
meth_meth_ast_toGrace9212->type->types[0] = type_Number;
meth_meth_ast_toGrace9212->type->names[0] = "depth";
  meth_meth_ast_toGrace9212->definitionModule = modulename;
  meth_meth_ast_toGrace9212->definitionLine = 2315;
// method "shallowCopy"
  block_savedest(obj9126);
  Object closure9223 = createclosure(1, "shallowCopy");
  setclosureframe(closure9223, stackframe);
  addtoclosure(closure9223, var_dialectNode);
  struct UserObject *uo9223 = (struct UserObject*)obj9126;
  uo9223->data[12] = (Object)closure9223;
  Method *meth_meth_ast_shallowCopy9223 = addmethod2pos(obj9126, "shallowCopy", &meth_ast_shallowCopy9223, 12);
  int argcv_meth_ast_shallowCopy9223[] = {0};
  meth_meth_ast_shallowCopy9223->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9223);
  meth_meth_ast_shallowCopy9223->definitionModule = modulename;
  meth_meth_ast_shallowCopy9223->definitionLine = 2318;
  sourceObject = obj9126;
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9230 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9231 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9232 = gc_frame_new();
// call case 3: self.outer request
  Object call9233 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9232);
// compiled call node returning call9233 (depth = 7)
// compiled member node returning call9233 (depth = 6)
  partcv[0] = 0;
  Object call9234 = callmethodflags(call9233, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9231);
// compiled call node returning call9234 (depth = 5)
// compiled member node returning call9234 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9235 = callmethodflags(call9234, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9230);
// compiled call node returning call9235 (depth = 3)
  struct UserObject *obj9126_uo = (struct UserObject *)obj9126;
  obj9126_uo->super = call9235;
  sourceObject = obj9126;
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9236 == NULL) {
    strlit9236 = alloc_String("dialect");
    gc_root(strlit9236);
  }
// compiled string node returning strlit9236 (depth = 3)
  adddatum2(obj9126, strlit9236, 1);
  sourceObject = obj9126;
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9126, *var_path_39_, 2);
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  objclass9126 = obj9126->class;
  objclass9126->definitionModule = modulename;
  objclass9126->definitionLine = 2276;
  (*(struct UserObject *)self).data[0] = lowerouter9126;
  self = oldself9126;
  selfslot = oldselfslot9126;
  stackframe = oldstackframe9126;
  gc_frame_end(frame);
  return obj9126;
}
Object meth_ast_new9125_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9126 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9126 = alloc_userobj2(13,13, objclass9126);
  gc_frame_newslot(obj9126);
if (objclass9126 == NULL) {
  glfree(obj9126->class->name);
  obj9126->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9126, self, 0);
  addmethodreal(obj9126,"outer", &reader_ast_outer_9127);
  Object oldself9126 = self;
  struct StackFrameObject *oldstackframe9126 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9126);
  gc_frame_newslot((Object)stackframe);
  self = obj9126;
  Object *oldselfslot9126 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9126 = (*(struct UserObject *)self).data[0], lowerouter9126 = thisouter9126;
  if (inheritingObject9126) {
    struct UserObject *inho9126 = (struct UserObject *)inheritingObject9126;
    while (inho9126->super != GraceDefaultObject) inho9126 = (struct UserObject *)inho9126->super;
    inho9126->super = obj9126;
    self = inheritingObject9126;
    *selfslot = self;
    lowerouter9126 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9126;
  }
if (objclass9126 == NULL) {
  Method *reader9128 = addmethodrealflags(obj9126, "kind",&reader_ast_kind_9128, MFLAG_DEF);
  reader9128->definitionModule = modulename;
  reader9128->definitionLine = 2278;
}
adddatum2(obj9126, alloc_Undefined(), 1);
if (objclass9126 == NULL) {
  Method *reader9129 = addmethodrealflags(obj9126, "value",&reader_ast_value_9129, 0);
  Method *writer9129 = addmethodrealflags(obj9126, "value:=",&writer_ast_value_9129, 0);
  reader9129->definitionModule = modulename;
  writer9129->definitionModule = modulename;
  reader9129->definitionLine = 2279;
  writer9129->definitionLine = 2279;
}
obj9126->flags |= OFLAG_MUTABLE;
adddatum2(obj9126, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo9130 = (struct UserObject*)obj9126;
  uo9130->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9130 = addmethod2pos(obj9126, "isDialect", &meth_ast_isDialect9130, 3);
  int argcv_meth_ast_isDialect9130[] = {0};
  meth_meth_ast_isDialect9130->type = alloc_MethodType(1, argcv_meth_ast_isDialect9130);
  meth_meth_ast_isDialect9130->definitionModule = modulename;
  meth_meth_ast_isDialect9130->definitionLine = 2281;
// method "isExternal"
  struct UserObject *uo9132 = (struct UserObject*)obj9126;
  uo9132->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal9132 = addmethod2pos(obj9126, "isExternal", &meth_ast_isExternal9132, 4);
  int argcv_meth_ast_isExternal9132[] = {0};
  meth_meth_ast_isExternal9132->type = alloc_MethodType(1, argcv_meth_ast_isExternal9132);
  meth_meth_ast_isExternal9132->definitionModule = modulename;
  meth_meth_ast_isExternal9132->definitionLine = 2282;
// method "isExecutable"
  struct UserObject *uo9134 = (struct UserObject*)obj9126;
  uo9134->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable9134 = addmethod2pos(obj9126, "isExecutable", &meth_ast_isExecutable9134, 5);
  int argcv_meth_ast_isExecutable9134[] = {0};
  meth_meth_ast_isExecutable9134->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9134);
  meth_meth_ast_isExecutable9134->definitionModule = modulename;
  meth_meth_ast_isExecutable9134->definitionLine = 2283;
// method "moduleName"
  struct UserObject *uo9136 = (struct UserObject*)obj9126;
  uo9136->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName9136 = addmethod2pos(obj9126, "moduleName", &meth_ast_moduleName9136, 6);
  int argcv_meth_ast_moduleName9136[] = {0};
  meth_meth_ast_moduleName9136->type = alloc_MethodType(1, argcv_meth_ast_moduleName9136);
  meth_meth_ast_moduleName9136->definitionModule = modulename;
  meth_meth_ast_moduleName9136->definitionLine = 2284;
// method "path"
  struct UserObject *uo9156 = (struct UserObject*)obj9126;
  uo9156->data[7] = emptyclosure;
  Method *meth_meth_ast_path9156 = addmethod2pos(obj9126, "path", &meth_ast_path9156, 7);
  int argcv_meth_ast_path9156[] = {0};
  meth_meth_ast_path9156->type = alloc_MethodType(1, argcv_meth_ast_path9156);
  meth_meth_ast_path9156->definitionModule = modulename;
  meth_meth_ast_path9156->definitionLine = 2295;
// method "accept()from"
  struct UserObject *uo9159 = (struct UserObject*)obj9126;
  uo9159->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9159 = addmethod2pos(obj9126, "accept()from", &meth_ast_accept_40__41_from9159, 8);
  int argcv_meth_ast_accept_40__41_from9159[] = {1, 1};
  meth_meth_ast_accept_40__41_from9159->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9159);
  meth_meth_ast_accept_40__41_from9159->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9159->definitionLine = 2298;
// method "map()ancestors"
  struct UserObject *uo9162 = (struct UserObject*)obj9126;
  uo9162->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9162 = addmethod2pos(obj9126, "map()ancestors", &meth_ast_map_40__41_ancestors9162, 9);
  int argcv_meth_ast_map_40__41_ancestors9162[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9162->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9162);
  meth_meth_ast_map_40__41_ancestors9162->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9162->definitionLine = 2301;
// method "pretty"
  struct UserObject *uo9169 = (struct UserObject*)obj9126;
  uo9169->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty9169 = addmethod2pos(obj9126, "pretty", &meth_ast_pretty9169, 10);
  int argcv_meth_ast_pretty9169[] = {1};
  meth_meth_ast_pretty9169->type = alloc_MethodType(1, argcv_meth_ast_pretty9169);
  meth_meth_ast_pretty9169->definitionModule = modulename;
  meth_meth_ast_pretty9169->definitionLine = 2306;
// method "toGrace"
  struct UserObject *uo9212 = (struct UserObject*)obj9126;
  uo9212->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace9212 = addmethod2pos(obj9126, "toGrace", &meth_ast_toGrace9212, 11);
  int argcv_meth_ast_toGrace9212[] = {1};
  meth_meth_ast_toGrace9212->type = alloc_MethodType(1, argcv_meth_ast_toGrace9212);
meth_meth_ast_toGrace9212->type->types[0] = type_Number;
meth_meth_ast_toGrace9212->type->names[0] = "depth";
  meth_meth_ast_toGrace9212->definitionModule = modulename;
  meth_meth_ast_toGrace9212->definitionLine = 2315;
// method "shallowCopy"
  block_savedest(obj9126);
  Object closure9223 = createclosure(1, "shallowCopy");
  setclosureframe(closure9223, stackframe);
  addtoclosure(closure9223, var_dialectNode);
  struct UserObject *uo9223 = (struct UserObject*)obj9126;
  uo9223->data[12] = (Object)closure9223;
  Method *meth_meth_ast_shallowCopy9223 = addmethod2pos(obj9126, "shallowCopy", &meth_ast_shallowCopy9223, 12);
  int argcv_meth_ast_shallowCopy9223[] = {0};
  meth_meth_ast_shallowCopy9223->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9223);
  meth_meth_ast_shallowCopy9223->definitionModule = modulename;
  meth_meth_ast_shallowCopy9223->definitionLine = 2318;
  sourceObject = obj9126;
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9230 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9231 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9232 = gc_frame_new();
// call case 3: self.outer request
  Object call9233 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9232);
// compiled call node returning call9233 (depth = 7)
// compiled member node returning call9233 (depth = 6)
  partcv[0] = 0;
  Object call9234 = callmethodflags(call9233, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9231);
// compiled call node returning call9234 (depth = 5)
// compiled member node returning call9234 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9235 = callmethodflags(call9234, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9230);
// compiled call node returning call9235 (depth = 3)
  struct UserObject *obj9126_uo = (struct UserObject *)obj9126;
  obj9126_uo->super = call9235;
  sourceObject = obj9126;
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9236 == NULL) {
    strlit9236 = alloc_String("dialect");
    gc_root(strlit9236);
  }
// compiled string node returning strlit9236 (depth = 3)
  adddatum2(obj9126, strlit9236, 1);
  sourceObject = obj9126;
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9126, *var_path_39_, 2);
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  sourceObject = obj9126;
  objclass9126 = obj9126->class;
  objclass9126->definitionModule = modulename;
  objclass9126->definitionLine = 2276;
  (*(struct UserObject *)self).data[0] = lowerouter9126;
  self = oldself9126;
  selfslot = oldselfslot9126;
  stackframe = oldstackframe9126;
  gc_frame_end(frame);
  return obj9126;
}
Object meth_ast_dialectNode9238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dialectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dialectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept_40__41_from9246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9248 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9249 = callmethod(*var_visitor, "visitReturn()up",
    2, partcv, params);
  gc_frame_end(callframe9248);
// compiled call node returning call9249 (depth = 4)
  Object if9247 = done;
  if (istrue(call9249)) {
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9250 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9251 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9250);
// compiled call node returning call9251 (depth = 5)
  *var_newChain = call9251;
  if (call9251 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9252 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9253 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9254 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9253);
// compiled call node returning call9254 (depth = 6)
// compiled member node returning call9254 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9255 = callmethod(call9254, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9252);
// compiled call node returning call9255 (depth = 4)
    gc_frame_newslot(call9255);
    if9247 = call9255;
  } else {
  }
// compiled if node returning if9247 (depth = 3)
  gc_frame_end(frame);
  return if9247;
}
Object meth_ast_map_40__41_ancestors9256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9257 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9258 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9257);
// compiled call node returning call9258 (depth = 5)
// compiled member node returning call9258 (depth = 4)
  *var_n = call9258;
  if (call9258 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9259 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9260 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9259);
// compiled call node returning call9260 (depth = 4)
  *var_newChain = call9260;
  if (call9260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9261 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9262 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9264 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9263);
// compiled call node returning call9264 (depth = 6)
// compiled member node returning call9264 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9265 = callmethod(call9264, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9262);
// compiled call node returning call9265 (depth = 4)
  gc_frame_newslot(call9265);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9265;
  partcv[0] = 1;
  Object call9266 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9261);
// compiled call node returning call9266 (depth = 3)
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9267 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9268 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9267);
// compiled call node returning call9268 (depth = 3)
  gc_frame_end(frame);
  return call9268;
}
Object meth_ast__apply9277(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9279 == NULL) {
    strlit9279 = alloc_String("  ");
    gc_root(strlit9279);
  }
// compiled string node returning strlit9279 (depth = 7)
  int op_slot_right_9278 = gc_frame_newslot(strlit9279);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9278 = gc_frame_newslot(*var_spc);
  params[0] = strlit9279;
  partcv[0] = 1;
  Object opresult9281 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9281 (depth = 6)
  *var_spc = opresult9281;
  if (opresult9281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9270 == NULL) {
    strlit9270 = alloc_String("");
    gc_root(strlit9270);
  }
// compiled string node returning strlit9270 (depth = 4)
  *var_spc = strlit9270;
  if (strlit9270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9271 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9272 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9274 = alloc_Float64(0);
// compiled num node returning num9274 (depth = 5)
  int op_slot_left_9272 = gc_frame_newslot(num9274);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9275 = callmethod(num9274, "..", 1, partcv, params);
// compiled op node returning opresult9275 (depth = 4)
  gc_frame_newslot(opresult9275);
// starting to compile block node (depth = 4)
  Object block9276 = alloc_Block(NULL, NULL, "ast", 2343);
  gc_frame_newslot(block9276);
// method "_apply"
  block_savedest(block9276);
  Object closure9277 = createclosure(2, "_apply");
  setclosureframe(closure9277, stackframe);
  addtoclosure(closure9277, var_spc);
  addtoclosure(closure9277, selfslot);
  struct UserObject *uo9277 = (struct UserObject*)block9276;
  uo9277->data[0] = (Object)closure9277;
  Method *meth_meth_ast__apply9277 = addmethod2pos(block9276, "_apply", &meth_ast__apply9277, 0);
  int argcv_meth_ast__apply9277[] = {1};
  meth_meth_ast__apply9277->type = alloc_MethodType(1, argcv_meth_ast__apply9277);
  meth_meth_ast__apply9277->definitionModule = modulename;
  meth_meth_ast__apply9277->definitionLine = 2338;
// compiled block node returning block9276 (depth = 4)
  gc_frame_newslot(block9276);
// call case 5: prelude request
  params[0] = opresult9275;
  params[1] = block9276;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9284 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9271);
// compiled call node returning call9284 (depth = 3)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9286 == NULL) {
    strlit9286 = alloc_String("""\x0a""");
    gc_root(strlit9286);
  }
// compiled string node returning strlit9286 (depth = 5)
  int op_slot_right_9285 = gc_frame_newslot(strlit9286);
// starting to compile call node (depth = 5)
  int callframe9288 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9289 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9288);
// compiled call node returning call9289 (depth = 5)
  int op_slot_left_9285 = gc_frame_newslot(call9289);
  params[0] = strlit9286;
  partcv[0] = 1;
  Object opresult9290 = callmethod(call9289, "++", 1, partcv, params);
// compiled op node returning opresult9290 (depth = 4)
  *var_s = opresult9290;
  if (opresult9290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9292 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9294 = alloc_Float64(1);
// compiled num node returning num9294 (depth = 7)
  int op_slot_right_9293 = gc_frame_newslot(num9294);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9293 = gc_frame_newslot(*var_depth);
  params[0] = num9294;
  partcv[0] = 1;
  Object sum9296 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9296 (depth = 6)
  gc_frame_newslot(sum9296);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9298 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9297);
// compiled call node returning call9298 (depth = 7)
// compiled member node returning call9298 (depth = 6)
  params[0] = sum9296;
  partcv[0] = 1;
  Object call9299 = callmethod(call9298, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9292);
// compiled call node returning call9299 (depth = 5)
  int op_slot_right_9291 = gc_frame_newslot(call9299);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9301 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9301 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9303 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9303 (depth = 5)
  int op_slot_left_9291 = gc_frame_newslot(opresult9303);
  params[0] = call9299;
  partcv[0] = 1;
  Object opresult9304 = callmethod(opresult9303, "++", 1, partcv, params);
// compiled op node returning opresult9304 (depth = 4)
  *var_s = opresult9304;
  if (opresult9304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9308 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9310 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9309);
// compiled call node returning call9310 (depth = 6)
// compiled member node returning call9310 (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9311 = callmethod(call9310, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9308);
// compiled call node returning call9311 (depth = 4)
  int op_slot_right_9307 = gc_frame_newslot(call9311);
// starting to compile string node (depth = 4)
  if (strlit9313 == NULL) {
    strlit9313 = alloc_String("return ");
    gc_root(strlit9313);
  }
// compiled string node returning strlit9313 (depth = 4)
  int op_slot_left_9307 = gc_frame_newslot(strlit9313);
  params[0] = call9311;
  partcv[0] = 1;
  Object opresult9314 = callmethod(strlit9313, "++", 1, partcv, params);
// compiled op node returning opresult9314 (depth = 3)
  gc_frame_end(frame);
  return opresult9314;
}
Object meth_ast_shallowCopy9315(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9316 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9317 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_returnNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9318 = callmethod(*var_returnNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9317);
// compiled call node returning call9318 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9319 = callmethod(call9318, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9316);
// compiled call node returning call9319 (depth = 3)
  gc_frame_end(frame);
  return call9319;
}
Object meth_ast_new9241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9242 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9242 = alloc_userobj2(8,8, objclass9242);
  gc_frame_newslot(obj9242);
if (objclass9242 == NULL) {
  glfree(obj9242->class->name);
  obj9242->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9242, self, 0);
  addmethodreal(obj9242,"outer", &reader_ast_outer_9243);
  Object oldself9242 = self;
  struct StackFrameObject *oldstackframe9242 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9242);
  gc_frame_newslot((Object)stackframe);
  self = obj9242;
  Object *oldselfslot9242 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9242 = (*(struct UserObject *)self).data[0], lowerouter9242 = thisouter9242;
  if (inheritingObject9242) {
    struct UserObject *inho9242 = (struct UserObject *)inheritingObject9242;
    while (inho9242->super != GraceDefaultObject) inho9242 = (struct UserObject *)inho9242->super;
    inho9242->super = obj9242;
    self = inheritingObject9242;
    *selfslot = self;
    lowerouter9242 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9242;
  }
if (objclass9242 == NULL) {
  Method *reader9244 = addmethodrealflags(obj9242, "kind",&reader_ast_kind_9244, MFLAG_DEF);
  reader9244->definitionModule = modulename;
  reader9244->definitionLine = 2326;
}
adddatum2(obj9242, alloc_Undefined(), 1);
if (objclass9242 == NULL) {
  Method *reader9245 = addmethodrealflags(obj9242, "value",&reader_ast_value_9245, 0);
  Method *writer9245 = addmethodrealflags(obj9242, "value:=",&writer_ast_value_9245, 0);
  reader9245->definitionModule = modulename;
  writer9245->definitionModule = modulename;
  reader9245->definitionLine = 2327;
  writer9245->definitionLine = 2327;
}
obj9242->flags |= OFLAG_MUTABLE;
adddatum2(obj9242, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo9246 = (struct UserObject*)obj9242;
  uo9246->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9246 = addmethod2pos(obj9242, "accept()from", &meth_ast_accept_40__41_from9246, 3);
  int argcv_meth_ast_accept_40__41_from9246[] = {1, 1};
  meth_meth_ast_accept_40__41_from9246->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9246);
  meth_meth_ast_accept_40__41_from9246->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9246->definitionLine = 2329;
// method "map()ancestors"
  struct UserObject *uo9256 = (struct UserObject*)obj9242;
  uo9256->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9256 = addmethod2pos(obj9242, "map()ancestors", &meth_ast_map_40__41_ancestors9256, 4);
  int argcv_meth_ast_map_40__41_ancestors9256[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9256->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9256);
  meth_meth_ast_map_40__41_ancestors9256->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9256->definitionLine = 2335;
// method "pretty"
  struct UserObject *uo9269 = (struct UserObject*)obj9242;
  uo9269->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty9269 = addmethod2pos(obj9242, "pretty", &meth_ast_pretty9269, 5);
  int argcv_meth_ast_pretty9269[] = {1};
  meth_meth_ast_pretty9269->type = alloc_MethodType(1, argcv_meth_ast_pretty9269);
  meth_meth_ast_pretty9269->definitionModule = modulename;
  meth_meth_ast_pretty9269->definitionLine = 2341;
// method "toGrace"
  struct UserObject *uo9306 = (struct UserObject*)obj9242;
  uo9306->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9306 = addmethod2pos(obj9242, "toGrace", &meth_ast_toGrace9306, 6);
  int argcv_meth_ast_toGrace9306[] = {1};
  meth_meth_ast_toGrace9306->type = alloc_MethodType(1, argcv_meth_ast_toGrace9306);
meth_meth_ast_toGrace9306->type->types[0] = type_Number;
meth_meth_ast_toGrace9306->type->names[0] = "depth";
  meth_meth_ast_toGrace9306->definitionModule = modulename;
  meth_meth_ast_toGrace9306->definitionLine = 2350;
// method "shallowCopy"
  block_savedest(obj9242);
  Object closure9315 = createclosure(2, "shallowCopy");
  setclosureframe(closure9315, stackframe);
  addtoclosure(closure9315, var_nullNode);
  addtoclosure(closure9315, var_returnNode);
  struct UserObject *uo9315 = (struct UserObject*)obj9242;
  uo9315->data[7] = (Object)closure9315;
  Method *meth_meth_ast_shallowCopy9315 = addmethod2pos(obj9242, "shallowCopy", &meth_ast_shallowCopy9315, 7);
  int argcv_meth_ast_shallowCopy9315[] = {0};
  meth_meth_ast_shallowCopy9315->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9315);
  meth_meth_ast_shallowCopy9315->definitionModule = modulename;
  meth_meth_ast_shallowCopy9315->definitionLine = 2353;
  sourceObject = obj9242;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9320 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9321 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9322 = gc_frame_new();
// call case 3: self.outer request
  Object call9323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9322);
// compiled call node returning call9323 (depth = 7)
// compiled member node returning call9323 (depth = 6)
  partcv[0] = 0;
  Object call9324 = callmethodflags(call9323, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9321);
// compiled call node returning call9324 (depth = 5)
// compiled member node returning call9324 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9325 = callmethodflags(call9324, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9320);
// compiled call node returning call9325 (depth = 3)
  struct UserObject *obj9242_uo = (struct UserObject *)obj9242;
  obj9242_uo->super = call9325;
  sourceObject = obj9242;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9326 == NULL) {
    strlit9326 = alloc_String("return");
    gc_root(strlit9326);
  }
// compiled string node returning strlit9326 (depth = 3)
  adddatum2(obj9242, strlit9326, 1);
  sourceObject = obj9242;
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9242, *var_expr, 2);
  sourceObject = obj9242;
  sourceObject = obj9242;
  sourceObject = obj9242;
  sourceObject = obj9242;
  sourceObject = obj9242;
  objclass9242 = obj9242->class;
  objclass9242->definitionModule = modulename;
  objclass9242->definitionLine = 2324;
  (*(struct UserObject *)self).data[0] = lowerouter9242;
  self = oldself9242;
  selfslot = oldselfslot9242;
  stackframe = oldstackframe9242;
  gc_frame_end(frame);
  return obj9242;
}
Object meth_ast_new9241_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9242 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9242 = alloc_userobj2(8,8, objclass9242);
  gc_frame_newslot(obj9242);
if (objclass9242 == NULL) {
  glfree(obj9242->class->name);
  obj9242->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9242, self, 0);
  addmethodreal(obj9242,"outer", &reader_ast_outer_9243);
  Object oldself9242 = self;
  struct StackFrameObject *oldstackframe9242 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9242);
  gc_frame_newslot((Object)stackframe);
  self = obj9242;
  Object *oldselfslot9242 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9242 = (*(struct UserObject *)self).data[0], lowerouter9242 = thisouter9242;
  if (inheritingObject9242) {
    struct UserObject *inho9242 = (struct UserObject *)inheritingObject9242;
    while (inho9242->super != GraceDefaultObject) inho9242 = (struct UserObject *)inho9242->super;
    inho9242->super = obj9242;
    self = inheritingObject9242;
    *selfslot = self;
    lowerouter9242 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9242;
  }
if (objclass9242 == NULL) {
  Method *reader9244 = addmethodrealflags(obj9242, "kind",&reader_ast_kind_9244, MFLAG_DEF);
  reader9244->definitionModule = modulename;
  reader9244->definitionLine = 2326;
}
adddatum2(obj9242, alloc_Undefined(), 1);
if (objclass9242 == NULL) {
  Method *reader9245 = addmethodrealflags(obj9242, "value",&reader_ast_value_9245, 0);
  Method *writer9245 = addmethodrealflags(obj9242, "value:=",&writer_ast_value_9245, 0);
  reader9245->definitionModule = modulename;
  writer9245->definitionModule = modulename;
  reader9245->definitionLine = 2327;
  writer9245->definitionLine = 2327;
}
obj9242->flags |= OFLAG_MUTABLE;
adddatum2(obj9242, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo9246 = (struct UserObject*)obj9242;
  uo9246->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9246 = addmethod2pos(obj9242, "accept()from", &meth_ast_accept_40__41_from9246, 3);
  int argcv_meth_ast_accept_40__41_from9246[] = {1, 1};
  meth_meth_ast_accept_40__41_from9246->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9246);
  meth_meth_ast_accept_40__41_from9246->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9246->definitionLine = 2329;
// method "map()ancestors"
  struct UserObject *uo9256 = (struct UserObject*)obj9242;
  uo9256->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9256 = addmethod2pos(obj9242, "map()ancestors", &meth_ast_map_40__41_ancestors9256, 4);
  int argcv_meth_ast_map_40__41_ancestors9256[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9256->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9256);
  meth_meth_ast_map_40__41_ancestors9256->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9256->definitionLine = 2335;
// method "pretty"
  struct UserObject *uo9269 = (struct UserObject*)obj9242;
  uo9269->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty9269 = addmethod2pos(obj9242, "pretty", &meth_ast_pretty9269, 5);
  int argcv_meth_ast_pretty9269[] = {1};
  meth_meth_ast_pretty9269->type = alloc_MethodType(1, argcv_meth_ast_pretty9269);
  meth_meth_ast_pretty9269->definitionModule = modulename;
  meth_meth_ast_pretty9269->definitionLine = 2341;
// method "toGrace"
  struct UserObject *uo9306 = (struct UserObject*)obj9242;
  uo9306->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9306 = addmethod2pos(obj9242, "toGrace", &meth_ast_toGrace9306, 6);
  int argcv_meth_ast_toGrace9306[] = {1};
  meth_meth_ast_toGrace9306->type = alloc_MethodType(1, argcv_meth_ast_toGrace9306);
meth_meth_ast_toGrace9306->type->types[0] = type_Number;
meth_meth_ast_toGrace9306->type->names[0] = "depth";
  meth_meth_ast_toGrace9306->definitionModule = modulename;
  meth_meth_ast_toGrace9306->definitionLine = 2350;
// method "shallowCopy"
  block_savedest(obj9242);
  Object closure9315 = createclosure(2, "shallowCopy");
  setclosureframe(closure9315, stackframe);
  addtoclosure(closure9315, var_nullNode);
  addtoclosure(closure9315, var_returnNode);
  struct UserObject *uo9315 = (struct UserObject*)obj9242;
  uo9315->data[7] = (Object)closure9315;
  Method *meth_meth_ast_shallowCopy9315 = addmethod2pos(obj9242, "shallowCopy", &meth_ast_shallowCopy9315, 7);
  int argcv_meth_ast_shallowCopy9315[] = {0};
  meth_meth_ast_shallowCopy9315->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9315);
  meth_meth_ast_shallowCopy9315->definitionModule = modulename;
  meth_meth_ast_shallowCopy9315->definitionLine = 2353;
  sourceObject = obj9242;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9320 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9321 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9322 = gc_frame_new();
// call case 3: self.outer request
  Object call9323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9322);
// compiled call node returning call9323 (depth = 7)
// compiled member node returning call9323 (depth = 6)
  partcv[0] = 0;
  Object call9324 = callmethodflags(call9323, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9321);
// compiled call node returning call9324 (depth = 5)
// compiled member node returning call9324 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9325 = callmethodflags(call9324, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9320);
// compiled call node returning call9325 (depth = 3)
  struct UserObject *obj9242_uo = (struct UserObject *)obj9242;
  obj9242_uo->super = call9325;
  sourceObject = obj9242;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9326 == NULL) {
    strlit9326 = alloc_String("return");
    gc_root(strlit9326);
  }
// compiled string node returning strlit9326 (depth = 3)
  adddatum2(obj9242, strlit9326, 1);
  sourceObject = obj9242;
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9242, *var_expr, 2);
  sourceObject = obj9242;
  sourceObject = obj9242;
  sourceObject = obj9242;
  sourceObject = obj9242;
  sourceObject = obj9242;
  objclass9242 = obj9242->class;
  objclass9242->definitionModule = modulename;
  objclass9242->definitionLine = 2324;
  (*(struct UserObject *)self).data[0] = lowerouter9242;
  self = oldself9242;
  selfslot = oldselfslot9242;
  stackframe = oldstackframe9242;
  gc_frame_end(frame);
  return obj9242;
}
Object meth_ast_returnNode9328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_new_40__41_scope9331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9332 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// call case 4: self request
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call9333 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9332);
// compiled call node returning call9333 (depth = 4)
  *var_result = call9333;
  if (call9333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9334 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9335 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9334);
// compiled call node returning call9335 (depth = 3)
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isLegalInTrait9345(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9347 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9346);
// compiled call node returning call9347 (depth = 4)
// compiled member node returning call9347 (depth = 3)
  gc_frame_end(frame);
  return call9347;
}
Object meth_ast_isInherits9348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9349 = alloc_Boolean(1);
// compiled identifier node returning bool9349 (depth = 3)
  gc_frame_end(frame);
  return bool9349;
}
Object meth_ast_inheritsFromMember9350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsFromMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsFromMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9351 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9352 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9353 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9352);
// compiled call node returning call9353 (depth = 6)
// compiled member node returning call9353 (depth = 5)
  partcv[0] = 0;
  Object call9354 = callmethod(call9353, "isMember",
    1, partcv, params);
  gc_frame_end(callframe9351);
// compiled call node returning call9354 (depth = 4)
// compiled member node returning call9354 (depth = 3)
  gc_frame_end(frame);
  return call9354;
}
Object meth_ast_inheritsFromCall9355(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsFromCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsFromCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9356 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9357 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9358 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9357);
// compiled call node returning call9358 (depth = 6)
// compiled member node returning call9358 (depth = 5)
  partcv[0] = 0;
  Object call9359 = callmethod(call9358, "isCall",
    1, partcv, params);
  gc_frame_end(callframe9356);
// compiled call node returning call9359 (depth = 4)
// compiled member node returning call9359 (depth = 3)
  gc_frame_end(frame);
  return call9359;
}
Object meth_ast_isExecutable9360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9361 = alloc_Boolean(0);
// compiled identifier node returning bool9361 (depth = 3)
  gc_frame_end(frame);
  return bool9361;
}
Object meth_ast__apply9374(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9375 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call9377 = callmethod(*var_a, "newName",
    1, partcv, params);
  gc_frame_end(callframe9376);
// compiled call node returning call9377 (depth = 8)
// compiled member node returning call9377 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9378 = callmethod(call9377, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9375);
// compiled call node returning call9378 (depth = 6)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9379 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call9381 = callmethod(*var_a, "oldName",
    1, partcv, params);
  gc_frame_end(callframe9380);
// compiled call node returning call9381 (depth = 8)
// compiled member node returning call9381 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9382 = callmethod(call9381, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9379);
// compiled call node returning call9382 (depth = 6)
  gc_frame_end(frame);
  return call9382;
}
Object meth_ast__apply9389(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9390 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_e (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9391 = callmethod(*var_e, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9390);
// compiled call node returning call9391 (depth = 6)
  gc_frame_end(frame);
  return call9391;
}
Object meth_ast_accept_40__41_from9362(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9364 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9365 = callmethod(*var_visitor, "visitInherits()up",
    2, partcv, params);
  gc_frame_end(callframe9364);
// compiled call node returning call9365 (depth = 4)
  Object if9363 = done;
  if (istrue(call9365)) {
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9366 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9367 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9366);
// compiled call node returning call9367 (depth = 5)
  *var_newChain = call9367;
  if (call9367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9368 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9370 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9369);
// compiled call node returning call9370 (depth = 6)
// compiled member node returning call9370 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9371 = callmethod(call9370, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9368);
// compiled call node returning call9371 (depth = 4)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9372 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9373 = alloc_Block(NULL, NULL, "ast", 2382);
  gc_frame_newslot(block9373);
// method "_apply"
  block_savedest(block9373);
  Object closure9374 = createclosure(3, "_apply");
  setclosureframe(closure9374, stackframe);
  addtoclosure(closure9374, var_visitor);
  addtoclosure(closure9374, var_newChain);
  addtoclosure(closure9374, selfslot);
  struct UserObject *uo9374 = (struct UserObject*)block9373;
  uo9374->data[0] = (Object)closure9374;
  Method *meth_meth_ast__apply9374 = addmethod2pos(block9373, "_apply", &meth_ast__apply9374, 0);
  int argcv_meth_ast__apply9374[] = {1};
  meth_meth_ast__apply9374->type = alloc_MethodType(1, argcv_meth_ast__apply9374);
  meth_meth_ast__apply9374->definitionModule = modulename;
  meth_meth_ast__apply9374->definitionLine = 2381;
// compiled block node returning block9373 (depth = 5)
  gc_frame_newslot(block9373);
// call case 6: other member request
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9385 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9384);
// compiled call node returning call9385 (depth = 6)
// compiled member node returning call9385 (depth = 5)
  params[0] = block9373;
  partcv[0] = 1;
  Object call9386 = callmethod(call9385, "do",
    1, partcv, params);
  gc_frame_end(callframe9372);
// compiled call node returning call9386 (depth = 4)
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9387 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9388 = alloc_Block(NULL, NULL, "ast", 2386);
  gc_frame_newslot(block9388);
// method "_apply"
  block_savedest(block9388);
  Object closure9389 = createclosure(3, "_apply");
  setclosureframe(closure9389, stackframe);
  addtoclosure(closure9389, var_visitor);
  addtoclosure(closure9389, var_newChain);
  addtoclosure(closure9389, selfslot);
  struct UserObject *uo9389 = (struct UserObject*)block9388;
  uo9389->data[0] = (Object)closure9389;
  Method *meth_meth_ast__apply9389 = addmethod2pos(block9388, "_apply", &meth_ast__apply9389, 0);
  int argcv_meth_ast__apply9389[] = {1};
  meth_meth_ast__apply9389->type = alloc_MethodType(1, argcv_meth_ast__apply9389);
  meth_meth_ast__apply9389->definitionModule = modulename;
  meth_meth_ast__apply9389->definitionLine = 2382;
// compiled block node returning block9388 (depth = 5)
  gc_frame_newslot(block9388);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9393 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9394 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9393);
// compiled call node returning call9394 (depth = 6)
// compiled member node returning call9394 (depth = 5)
  params[0] = block9388;
  partcv[0] = 1;
  Object call9395 = callmethod(call9394, "do",
    1, partcv, params);
  gc_frame_end(callframe9387);
// compiled call node returning call9395 (depth = 4)
    gc_frame_newslot(call9395);
    if9363 = call9395;
  } else {
  }
// compiled if node returning if9363 (depth = 3)
  gc_frame_end(frame);
  return if9363;
}
Object meth_ast_declarationKindWithAncestors9396(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9397 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call9398 = callmethod(*var_k, "methdec",
    1, partcv, params);
  gc_frame_end(callframe9397);
// compiled call node returning call9398 (depth = 4)
// compiled member node returning call9398 (depth = 3)
  gc_frame_end(frame);
  return call9398;
}
Object meth_ast_map_40__41_ancestors9399(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9401 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9400);
// compiled call node returning call9401 (depth = 5)
// compiled member node returning call9401 (depth = 4)
  *var_n = call9401;
  if (call9401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9402 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9403 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9402);
// compiled call node returning call9403 (depth = 4)
  *var_newChain = call9403;
  if (call9403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9404 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9405 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9406 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9407 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9406);
// compiled call node returning call9407 (depth = 6)
// compiled member node returning call9407 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9408 = callmethod(call9407, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9405);
// compiled call node returning call9408 (depth = 4)
  gc_frame_newslot(call9408);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9408;
  partcv[0] = 1;
  Object call9409 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9404);
// compiled call node returning call9409 (depth = 3)
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9410 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9411 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9410);
// compiled call node returning call9411 (depth = 3)
  gc_frame_end(frame);
  return call9411;
}
Object meth_ast__apply9420(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9422 == NULL) {
    strlit9422 = alloc_String("  ");
    gc_root(strlit9422);
  }
// compiled string node returning strlit9422 (depth = 7)
  int op_slot_right_9421 = gc_frame_newslot(strlit9422);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9421 = gc_frame_newslot(*var_spc);
  params[0] = strlit9422;
  partcv[0] = 1;
  Object opresult9424 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9424 (depth = 6)
  *var_spc = opresult9424;
  if (opresult9424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9463(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9465 == NULL) {
    strlit9465 = alloc_String("");
    gc_root(strlit9465);
  }
// compiled string node returning strlit9465 (depth = 7)
  int op_slot_right_9464 = gc_frame_newslot(strlit9465);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9468 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9469 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9468);
// compiled call node returning call9469 (depth = 8)
  int op_slot_right_9467 = gc_frame_newslot(call9469);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9472 == NULL) {
    strlit9472 = alloc_String("""\x0a""");
    gc_root(strlit9472);
  }
// compiled string node returning strlit9472 (depth = 9)
  int op_slot_right_9471 = gc_frame_newslot(strlit9472);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9474 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9476 == NULL) {
    strlit9476 = alloc_String("");
    gc_root(strlit9476);
  }
// compiled string node returning strlit9476 (depth = 10)
  int op_slot_left_9474 = gc_frame_newslot(strlit9476);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9477 = callmethod(strlit9476, "++", 1, partcv, params);
// compiled op node returning opresult9477 (depth = 9)
  int op_slot_left_9471 = gc_frame_newslot(opresult9477);
  params[0] = strlit9472;
  partcv[0] = 1;
  Object opresult9478 = callmethod(opresult9477, "++", 1, partcv, params);
// compiled op node returning opresult9478 (depth = 8)
  int op_slot_left_9467 = gc_frame_newslot(opresult9478);
  params[0] = call9469;
  partcv[0] = 1;
  Object opresult9479 = callmethod(opresult9478, "++", 1, partcv, params);
// compiled op node returning opresult9479 (depth = 7)
  int op_slot_left_9464 = gc_frame_newslot(opresult9479);
  params[0] = strlit9465;
  partcv[0] = 1;
  Object opresult9480 = callmethod(opresult9479, "++", 1, partcv, params);
// compiled op node returning opresult9480 (depth = 6)
  *var_s = opresult9480;
  if (opresult9480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9513 == NULL) {
    strlit9513 = alloc_String(" ");
    gc_root(strlit9513);
  }
// compiled string node returning strlit9513 (depth = 7)
  int op_slot_right_9512 = gc_frame_newslot(strlit9513);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_e (depth = 8)
  int op_slot_right_9515 = gc_frame_newslot(*var_e);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9518 == NULL) {
    strlit9518 = alloc_String(" exclude ");
    gc_root(strlit9518);
  }
// compiled string node returning strlit9518 (depth = 9)
  int op_slot_right_9517 = gc_frame_newslot(strlit9518);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9520 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9522 == NULL) {
    strlit9522 = alloc_String("");
    gc_root(strlit9522);
  }
// compiled string node returning strlit9522 (depth = 10)
  int op_slot_left_9520 = gc_frame_newslot(strlit9522);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9523 = callmethod(strlit9522, "++", 1, partcv, params);
// compiled op node returning opresult9523 (depth = 9)
  int op_slot_left_9517 = gc_frame_newslot(opresult9523);
  params[0] = strlit9518;
  partcv[0] = 1;
  Object opresult9524 = callmethod(opresult9523, "++", 1, partcv, params);
// compiled op node returning opresult9524 (depth = 8)
  int op_slot_left_9515 = gc_frame_newslot(opresult9524);
  params[0] = *var_e;
  partcv[0] = 1;
  Object opresult9525 = callmethod(opresult9524, "++", 1, partcv, params);
// compiled op node returning opresult9525 (depth = 7)
  int op_slot_left_9512 = gc_frame_newslot(opresult9525);
  params[0] = strlit9513;
  partcv[0] = 1;
  Object opresult9526 = callmethod(opresult9525, "++", 1, partcv, params);
// compiled op node returning opresult9526 (depth = 6)
  *var_s = opresult9526;
  if (opresult9526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9413 == NULL) {
    strlit9413 = alloc_String("");
    gc_root(strlit9413);
  }
// compiled string node returning strlit9413 (depth = 4)
  *var_spc = strlit9413;
  if (strlit9413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9414 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9415 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9417 = alloc_Float64(0);
// compiled num node returning num9417 (depth = 5)
  int op_slot_left_9415 = gc_frame_newslot(num9417);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9418 = callmethod(num9417, "..", 1, partcv, params);
// compiled op node returning opresult9418 (depth = 4)
  gc_frame_newslot(opresult9418);
// starting to compile block node (depth = 4)
  Object block9419 = alloc_Block(NULL, NULL, "ast", 2403);
  gc_frame_newslot(block9419);
// method "_apply"
  block_savedest(block9419);
  Object closure9420 = createclosure(2, "_apply");
  setclosureframe(closure9420, stackframe);
  addtoclosure(closure9420, var_spc);
  addtoclosure(closure9420, selfslot);
  struct UserObject *uo9420 = (struct UserObject*)block9419;
  uo9420->data[0] = (Object)closure9420;
  Method *meth_meth_ast__apply9420 = addmethod2pos(block9419, "_apply", &meth_ast__apply9420, 0);
  int argcv_meth_ast__apply9420[] = {1};
  meth_meth_ast__apply9420->type = alloc_MethodType(1, argcv_meth_ast__apply9420);
  meth_meth_ast__apply9420->definitionModule = modulename;
  meth_meth_ast__apply9420->definitionLine = 2398;
// compiled block node returning block9419 (depth = 4)
  gc_frame_newslot(block9419);
// call case 5: prelude request
  params[0] = opresult9418;
  params[1] = block9419;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9427 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9414);
// compiled call node returning call9427 (depth = 3)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9428 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9429 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9428);
// compiled call node returning call9429 (depth = 4)
  *var_s = call9429;
  if (call9429 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9432 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9431);
// compiled call node returning call9432 (depth = 5)
// compiled member node returning call9432 (depth = 4)
  Object if9430 = done;
  if (istrue(call9432)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9434 == NULL) {
    strlit9434 = alloc_String(" (use)");
    gc_root(strlit9434);
  }
// compiled string node returning strlit9434 (depth = 6)
  int op_slot_right_9433 = gc_frame_newslot(strlit9434);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_9436 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 7)
  if (strlit9438 == NULL) {
    strlit9438 = alloc_String("");
    gc_root(strlit9438);
  }
// compiled string node returning strlit9438 (depth = 7)
  int op_slot_left_9436 = gc_frame_newslot(strlit9438);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9439 = callmethod(strlit9438, "++", 1, partcv, params);
// compiled op node returning opresult9439 (depth = 6)
  int op_slot_left_9433 = gc_frame_newslot(opresult9439);
  params[0] = strlit9434;
  partcv[0] = 1;
  Object opresult9440 = callmethod(opresult9439, "++", 1, partcv, params);
// compiled op node returning opresult9440 (depth = 5)
  *var_s = opresult9440;
  if (opresult9440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9430 = done;
  } else {
  }
// compiled if node returning if9430 (depth = 3)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9443 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9445 = alloc_Float64(1);
// compiled num node returning num9445 (depth = 7)
  int op_slot_right_9444 = gc_frame_newslot(num9445);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9444 = gc_frame_newslot(*var_depth);
  params[0] = num9445;
  partcv[0] = 1;
  Object sum9447 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9447 (depth = 6)
  gc_frame_newslot(sum9447);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9448 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9449 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9448);
// compiled call node returning call9449 (depth = 7)
// compiled member node returning call9449 (depth = 6)
  params[0] = sum9447;
  partcv[0] = 1;
  Object call9450 = callmethod(call9449, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9443);
// compiled call node returning call9450 (depth = 5)
  int op_slot_right_9442 = gc_frame_newslot(call9450);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9452 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9455 == NULL) {
    strlit9455 = alloc_String("""\x0a""");
    gc_root(strlit9455);
  }
// compiled string node returning strlit9455 (depth = 7)
  int op_slot_right_9454 = gc_frame_newslot(strlit9455);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9454 = gc_frame_newslot(*var_s);
  params[0] = strlit9455;
  partcv[0] = 1;
  Object opresult9457 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9457 (depth = 6)
  int op_slot_left_9452 = gc_frame_newslot(opresult9457);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9458 = callmethod(opresult9457, "++", 1, partcv, params);
// compiled op node returning opresult9458 (depth = 5)
  int op_slot_left_9442 = gc_frame_newslot(opresult9458);
  params[0] = call9450;
  partcv[0] = 1;
  Object opresult9459 = callmethod(opresult9458, "++", 1, partcv, params);
// compiled op node returning opresult9459 (depth = 4)
  *var_s = opresult9459;
  if (opresult9459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9461 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9462 = alloc_Block(NULL, NULL, "ast", 2409);
  gc_frame_newslot(block9462);
// method "_apply"
  block_savedest(block9462);
  Object closure9463 = createclosure(3, "_apply");
  setclosureframe(closure9463, stackframe);
  addtoclosure(closure9463, var_depth);
  addtoclosure(closure9463, var_s);
  addtoclosure(closure9463, selfslot);
  struct UserObject *uo9463 = (struct UserObject*)block9462;
  uo9463->data[0] = (Object)closure9463;
  Method *meth_meth_ast__apply9463 = addmethod2pos(block9462, "_apply", &meth_ast__apply9463, 0);
  int argcv_meth_ast__apply9463[] = {1};
  meth_meth_ast__apply9463->type = alloc_MethodType(1, argcv_meth_ast__apply9463);
  meth_meth_ast__apply9463->definitionModule = modulename;
  meth_meth_ast__apply9463->definitionLine = 2408;
// compiled block node returning block9462 (depth = 4)
  gc_frame_newslot(block9462);
// call case 6: other member request
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9483 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9484 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9483);
// compiled call node returning call9484 (depth = 5)
// compiled member node returning call9484 (depth = 4)
  params[0] = block9462;
  partcv[0] = 1;
  Object call9485 = callmethod(call9484, "do",
    1, partcv, params);
  gc_frame_end(callframe9461);
// compiled call node returning call9485 (depth = 3)
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9487 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9488 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9489 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9490 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9489);
// compiled call node returning call9490 (depth = 9)
// compiled member node returning call9490 (depth = 8)
  partcv[0] = 0;
  Object call9491 = callmethod(call9490, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9488);
// compiled call node returning call9491 (depth = 7)
// compiled member node returning call9491 (depth = 6)
  partcv[0] = 0;
  Object call9492 = callmethod(call9491, "not",
    1, partcv, params);
  gc_frame_end(callframe9487);
// compiled call node returning call9492 (depth = 5)
// compiled member node returning call9492 (depth = 4)
  Object if9486 = done;
  if (istrue(call9492)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9494 == NULL) {
    strlit9494 = alloc_String("");
    gc_root(strlit9494);
  }
// compiled string node returning strlit9494 (depth = 6)
  int op_slot_right_9493 = gc_frame_newslot(strlit9494);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9496 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9499 == NULL) {
    strlit9499 = alloc_String("""\x0a""");
    gc_root(strlit9499);
  }
// compiled string node returning strlit9499 (depth = 8)
  int op_slot_right_9498 = gc_frame_newslot(strlit9499);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9501 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9503 == NULL) {
    strlit9503 = alloc_String("");
    gc_root(strlit9503);
  }
// compiled string node returning strlit9503 (depth = 9)
  int op_slot_left_9501 = gc_frame_newslot(strlit9503);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9504 = callmethod(strlit9503, "++", 1, partcv, params);
// compiled op node returning opresult9504 (depth = 8)
  int op_slot_left_9498 = gc_frame_newslot(opresult9504);
  params[0] = strlit9499;
  partcv[0] = 1;
  Object opresult9505 = callmethod(opresult9504, "++", 1, partcv, params);
// compiled op node returning opresult9505 (depth = 7)
  int op_slot_left_9496 = gc_frame_newslot(opresult9505);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9506 = callmethod(opresult9505, "++", 1, partcv, params);
// compiled op node returning opresult9506 (depth = 6)
  int op_slot_left_9493 = gc_frame_newslot(opresult9506);
  params[0] = strlit9494;
  partcv[0] = 1;
  Object opresult9507 = callmethod(opresult9506, "++", 1, partcv, params);
// compiled op node returning opresult9507 (depth = 5)
  *var_s = opresult9507;
  if (opresult9507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9486 = done;
  } else {
  }
// compiled if node returning if9486 (depth = 3)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9509 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9510 = alloc_Block(NULL, NULL, "ast", 2413);
  gc_frame_newslot(block9510);
// method "_apply"
  block_savedest(block9510);
  Object closure9511 = createclosure(2, "_apply");
  setclosureframe(closure9511, stackframe);
  addtoclosure(closure9511, var_s);
  addtoclosure(closure9511, selfslot);
  struct UserObject *uo9511 = (struct UserObject*)block9510;
  uo9511->data[0] = (Object)closure9511;
  Method *meth_meth_ast__apply9511 = addmethod2pos(block9510, "_apply", &meth_ast__apply9511, 0);
  int argcv_meth_ast__apply9511[] = {1};
  meth_meth_ast__apply9511->type = alloc_MethodType(1, argcv_meth_ast__apply9511);
  meth_meth_ast__apply9511->definitionModule = modulename;
  meth_meth_ast__apply9511->definitionLine = 2412;
// compiled block node returning block9510 (depth = 4)
  gc_frame_newslot(block9510);
// call case 6: other member request
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9529 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9530 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9529);
// compiled call node returning call9530 (depth = 5)
// compiled member node returning call9530 (depth = 4)
  params[0] = block9510;
  partcv[0] = 1;
  Object call9531 = callmethod(call9530, "do",
    1, partcv, params);
  gc_frame_end(callframe9509);
// compiled call node returning call9531 (depth = 3)
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9533 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9534 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9536 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9535);
// compiled call node returning call9536 (depth = 9)
// compiled member node returning call9536 (depth = 8)
  partcv[0] = 0;
  Object call9537 = callmethod(call9536, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9534);
// compiled call node returning call9537 (depth = 7)
// compiled member node returning call9537 (depth = 6)
  partcv[0] = 0;
  Object call9538 = callmethod(call9537, "not",
    1, partcv, params);
  gc_frame_end(callframe9533);
// compiled call node returning call9538 (depth = 5)
// compiled member node returning call9538 (depth = 4)
  Object if9532 = done;
  if (istrue(call9538)) {
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9541 == NULL) {
    strlit9541 = alloc_String("");
    gc_root(strlit9541);
  }
// compiled string node returning strlit9541 (depth = 7)
  int op_slot_right_9540 = gc_frame_newslot(strlit9541);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9544 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9545 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9546 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9547 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9546);
// compiled call node returning call9547 (depth = 13)
// compiled member node returning call9547 (depth = 12)
  partcv[0] = 0;
  Object call9548 = callmethod(call9547, "asList",
    1, partcv, params);
  gc_frame_end(callframe9545);
// compiled call node returning call9548 (depth = 11)
// compiled member node returning call9548 (depth = 10)
  partcv[0] = 0;
  Object call9549 = callmethod(call9548, "sort",
    1, partcv, params);
  gc_frame_end(callframe9544);
// compiled call node returning call9549 (depth = 9)
// compiled member node returning call9549 (depth = 8)
  int op_slot_right_9543 = gc_frame_newslot(call9549);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9552 == NULL) {
    strlit9552 = alloc_String("Provided names: ");
    gc_root(strlit9552);
  }
// compiled string node returning strlit9552 (depth = 9)
  int op_slot_right_9551 = gc_frame_newslot(strlit9552);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9554 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9556 == NULL) {
    strlit9556 = alloc_String("""\x0a""");
    gc_root(strlit9556);
  }
// compiled string node returning strlit9556 (depth = 10)
  int op_slot_left_9554 = gc_frame_newslot(strlit9556);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9557 = callmethod(strlit9556, "++", 1, partcv, params);
// compiled op node returning opresult9557 (depth = 9)
  int op_slot_left_9551 = gc_frame_newslot(opresult9557);
  params[0] = strlit9552;
  partcv[0] = 1;
  Object opresult9558 = callmethod(opresult9557, "++", 1, partcv, params);
// compiled op node returning opresult9558 (depth = 8)
  int op_slot_left_9543 = gc_frame_newslot(opresult9558);
  params[0] = call9549;
  partcv[0] = 1;
  Object opresult9559 = callmethod(opresult9558, "++", 1, partcv, params);
// compiled op node returning opresult9559 (depth = 7)
  int op_slot_left_9540 = gc_frame_newslot(opresult9559);
  params[0] = strlit9541;
  partcv[0] = 1;
  Object opresult9560 = callmethod(opresult9559, "++", 1, partcv, params);
// compiled op node returning opresult9560 (depth = 6)
  int op_slot_right_9539 = gc_frame_newslot(opresult9560);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9539 = gc_frame_newslot(*var_s);
  params[0] = opresult9560;
  partcv[0] = 1;
  Object opresult9562 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9562 (depth = 5)
  *var_s = opresult9562;
  if (opresult9562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9532 = done;
  } else {
  }
// compiled if node returning if9532 (depth = 3)
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply9581(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9583 == NULL) {
    strlit9583 = alloc_String(" ");
    gc_root(strlit9583);
  }
// compiled string node returning strlit9583 (depth = 7)
  int op_slot_right_9582 = gc_frame_newslot(strlit9583);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_right_9585 = gc_frame_newslot(*var_a);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9588 == NULL) {
    strlit9588 = alloc_String(" ");
    gc_root(strlit9588);
  }
// compiled string node returning strlit9588 (depth = 9)
  int op_slot_right_9587 = gc_frame_newslot(strlit9588);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9590 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9592 == NULL) {
    strlit9592 = alloc_String("");
    gc_root(strlit9592);
  }
// compiled string node returning strlit9592 (depth = 10)
  int op_slot_left_9590 = gc_frame_newslot(strlit9592);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9593 = callmethod(strlit9592, "++", 1, partcv, params);
// compiled op node returning opresult9593 (depth = 9)
  int op_slot_left_9587 = gc_frame_newslot(opresult9593);
  params[0] = strlit9588;
  partcv[0] = 1;
  Object opresult9594 = callmethod(opresult9593, "++", 1, partcv, params);
// compiled op node returning opresult9594 (depth = 8)
  int op_slot_left_9585 = gc_frame_newslot(opresult9594);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult9595 = callmethod(opresult9594, "++", 1, partcv, params);
// compiled op node returning opresult9595 (depth = 7)
  int op_slot_left_9582 = gc_frame_newslot(opresult9595);
  params[0] = strlit9583;
  partcv[0] = 1;
  Object opresult9596 = callmethod(opresult9595, "++", 1, partcv, params);
// compiled op node returning opresult9596 (depth = 6)
  *var_s = opresult9596;
  if (opresult9596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9604(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9606 == NULL) {
    strlit9606 = alloc_String(" ");
    gc_root(strlit9606);
  }
// compiled string node returning strlit9606 (depth = 7)
  int op_slot_right_9605 = gc_frame_newslot(strlit9606);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_e (depth = 10)
  partcv[0] = 0;
  Object call9610 = callmethod(*var_e, "nameString",
    1, partcv, params);
  gc_frame_end(callframe9609);
// compiled call node returning call9610 (depth = 9)
// compiled member node returning call9610 (depth = 8)
  int op_slot_right_9608 = gc_frame_newslot(call9610);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9613 == NULL) {
    strlit9613 = alloc_String(" exclude ");
    gc_root(strlit9613);
  }
// compiled string node returning strlit9613 (depth = 9)
  int op_slot_right_9612 = gc_frame_newslot(strlit9613);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9615 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9617 == NULL) {
    strlit9617 = alloc_String("");
    gc_root(strlit9617);
  }
// compiled string node returning strlit9617 (depth = 10)
  int op_slot_left_9615 = gc_frame_newslot(strlit9617);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9618 = callmethod(strlit9617, "++", 1, partcv, params);
// compiled op node returning opresult9618 (depth = 9)
  int op_slot_left_9612 = gc_frame_newslot(opresult9618);
  params[0] = strlit9613;
  partcv[0] = 1;
  Object opresult9619 = callmethod(opresult9618, "++", 1, partcv, params);
// compiled op node returning opresult9619 (depth = 8)
  int op_slot_left_9608 = gc_frame_newslot(opresult9619);
  params[0] = call9610;
  partcv[0] = 1;
  Object opresult9620 = callmethod(opresult9619, "++", 1, partcv, params);
// compiled op node returning opresult9620 (depth = 7)
  int op_slot_left_9605 = gc_frame_newslot(opresult9620);
  params[0] = strlit9606;
  partcv[0] = 1;
  Object opresult9621 = callmethod(opresult9620, "++", 1, partcv, params);
// compiled op node returning opresult9621 (depth = 6)
  *var_s = opresult9621;
  if (opresult9621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace9564(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9567 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9566);
// compiled call node returning call9567 (depth = 6)
// compiled member node returning call9567 (depth = 5)
  Object if9565 = done;
struct StackFrameObject *iftmpstackframe9565 = stackframe;
  if (istrue(call9567)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9565);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9568 == NULL) {
    strlit9568 = alloc_String("use ");
    gc_root(strlit9568);
  }
// compiled string node returning strlit9568 (depth = 5)
    gc_frame_newslot(strlit9568);
    if9565 = strlit9568;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9565);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9569 == NULL) {
    strlit9569 = alloc_String("inherit ");
    gc_root(strlit9569);
  }
// compiled string node returning strlit9569 (depth = 5)
    gc_frame_newslot(strlit9569);
    if9565 = strlit9569;
  }
stackframe = iftmpstackframe9565;
// compiled if node returning if9565 (depth = 4)
  *var_s = if9565;
  if (if9565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9571 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num9572 = alloc_Float64(0);
// compiled num node returning num9572 (depth = 6)
  gc_frame_newslot(num9572);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9573 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9574 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9573);
// compiled call node returning call9574 (depth = 7)
// compiled member node returning call9574 (depth = 6)
  params[0] = num9572;
  partcv[0] = 1;
  Object call9575 = callmethod(call9574, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9571);
// compiled call node returning call9575 (depth = 5)
  int op_slot_right_9570 = gc_frame_newslot(call9575);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9570 = gc_frame_newslot(*var_s);
  params[0] = call9575;
  partcv[0] = 1;
  Object opresult9577 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9577 (depth = 4)
  *var_s = opresult9577;
  if (opresult9577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9579 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9580 = alloc_Block(NULL, NULL, "ast", 2424);
  gc_frame_newslot(block9580);
// method "_apply"
  block_savedest(block9580);
  Object closure9581 = createclosure(2, "_apply");
  setclosureframe(closure9581, stackframe);
  addtoclosure(closure9581, var_s);
  addtoclosure(closure9581, selfslot);
  struct UserObject *uo9581 = (struct UserObject*)block9580;
  uo9581->data[0] = (Object)closure9581;
  Method *meth_meth_ast__apply9581 = addmethod2pos(block9580, "_apply", &meth_ast__apply9581, 0);
  int argcv_meth_ast__apply9581[] = {1};
  meth_meth_ast__apply9581->type = alloc_MethodType(1, argcv_meth_ast__apply9581);
  meth_meth_ast__apply9581->definitionModule = modulename;
  meth_meth_ast__apply9581->definitionLine = 2423;
// compiled block node returning block9580 (depth = 4)
  gc_frame_newslot(block9580);
// call case 6: other member request
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9600 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9599);
// compiled call node returning call9600 (depth = 5)
// compiled member node returning call9600 (depth = 4)
  params[0] = block9580;
  partcv[0] = 1;
  Object call9601 = callmethod(call9600, "do",
    1, partcv, params);
  gc_frame_end(callframe9579);
// compiled call node returning call9601 (depth = 3)
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9602 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9603 = alloc_Block(NULL, NULL, "ast", 2427);
  gc_frame_newslot(block9603);
// method "_apply"
  block_savedest(block9603);
  Object closure9604 = createclosure(2, "_apply");
  setclosureframe(closure9604, stackframe);
  addtoclosure(closure9604, var_s);
  addtoclosure(closure9604, selfslot);
  struct UserObject *uo9604 = (struct UserObject*)block9603;
  uo9604->data[0] = (Object)closure9604;
  Method *meth_meth_ast__apply9604 = addmethod2pos(block9603, "_apply", &meth_ast__apply9604, 0);
  int argcv_meth_ast__apply9604[] = {1};
  meth_meth_ast__apply9604->type = alloc_MethodType(1, argcv_meth_ast__apply9604);
  meth_meth_ast__apply9604->definitionModule = modulename;
  meth_meth_ast__apply9604->definitionLine = 2424;
// compiled block node returning block9603 (depth = 4)
  gc_frame_newslot(block9603);
// call case 6: other member request
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9625 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9624);
// compiled call node returning call9625 (depth = 5)
// compiled member node returning call9625 (depth = 4)
  params[0] = block9603;
  partcv[0] = 1;
  Object call9626 = callmethod(call9625, "do",
    1, partcv, params);
  gc_frame_end(callframe9602);
// compiled call node returning call9626 (depth = 3)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_nameString9627(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9628 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9629 = alloc_Float64(0);
// compiled num node returning num9629 (depth = 4)
  gc_frame_newslot(num9629);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9631 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9630);
// compiled call node returning call9631 (depth = 5)
// compiled member node returning call9631 (depth = 4)
  params[0] = num9629;
  partcv[0] = 1;
  Object call9632 = callmethod(call9631, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9628);
// compiled call node returning call9632 (depth = 3)
  gc_frame_end(frame);
  return call9632;
}
Object meth_ast_addAlias_40__41_for9633(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAlias()for");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias()for");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias()for");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addAlias()for (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_newName = &(stackframe->slots[0]);
  *var_newName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAlias");
  Object *var_oldName = &(stackframe->slots[1]);
  *var_oldName = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for for");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9634 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9635 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newName (depth = 5)
  gc_frame_newslot(*var_newName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldName (depth = 5)
  gc_frame_newslot(*var_oldName);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9636 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9637 = gc_frame_new();
// call case 3: self.outer request
  Object call9638 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9637);
// compiled call node returning call9638 (depth = 8)
// compiled member node returning call9638 (depth = 7)
  partcv[0] = 0;
  Object call9639 = callmethodflags(call9638, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9636);
// compiled call node returning call9639 (depth = 6)
// compiled member node returning call9639 (depth = 5)
  params[0] = *var_newName;
  params[1] = *var_oldName;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9640 = callmethodflags(call9639, "aliasNew()old", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9635);
// compiled call node returning call9640 (depth = 4)
  gc_frame_newslot(call9640);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9641 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9642 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9641);
// compiled call node returning call9642 (depth = 5)
// compiled member node returning call9642 (depth = 4)
  params[0] = call9640;
  partcv[0] = 1;
  Object call9643 = callmethod(call9642, "push",
    1, partcv, params);
  gc_frame_end(callframe9634);
// compiled call node returning call9643 (depth = 3)
  gc_frame_end(frame);
  return call9643;
}
Object meth_ast_addExclusion9644(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addExclusion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addExclusion");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addExclusion (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methName = &(stackframe->slots[0]);
  *var_methName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addExclusion");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9645 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methName (depth = 4)
  gc_frame_newslot(*var_methName);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9646 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9647 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9646);
// compiled call node returning call9647 (depth = 5)
// compiled member node returning call9647 (depth = 4)
  params[0] = *var_methName;
  partcv[0] = 1;
  Object call9648 = callmethod(call9647, "push",
    1, partcv, params);
  gc_frame_end(callframe9645);
// compiled call node returning call9648 (depth = 3)
  gc_frame_end(frame);
  return call9648;
}
Object meth_ast_shallowCopy9649(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9650 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9651 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inheritsNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9652 = callmethod(*var_inheritsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9651);
// compiled call node returning call9652 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9653 = callmethod(call9652, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9650);
// compiled call node returning call9653 (depth = 3)
  gc_frame_end(frame);
  return call9653;
}
Object meth_ast_shallowCopyFieldsFrom9654(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9655 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9656 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9655);
// compiled call node returning call9656 (depth = 3)
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9657 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9658 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9659 = callmethod(*var_other, "providedNames",
    1, partcv, params);
  gc_frame_end(callframe9658);
// compiled call node returning call9659 (depth = 5)
// compiled member node returning call9659 (depth = 4)
  gc_frame_newslot(call9659);
// call case 4: self request
  params[0] = call9659;
  partcv[0] = 1;
  Object call9660 = callmethodflags(self, "providedNames:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9657);
// compiled call node returning call9660 (depth = 3)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9661 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9663 = callmethod(*var_other, "aliases",
    1, partcv, params);
  gc_frame_end(callframe9662);
// compiled call node returning call9663 (depth = 5)
// compiled member node returning call9663 (depth = 4)
  gc_frame_newslot(call9663);
// call case 4: self request
  params[0] = call9663;
  partcv[0] = 1;
  Object call9664 = callmethodflags(self, "aliases:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9661);
// compiled call node returning call9664 (depth = 3)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9665 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9667 = callmethod(*var_other, "exclusions",
    1, partcv, params);
  gc_frame_end(callframe9666);
// compiled call node returning call9667 (depth = 5)
// compiled member node returning call9667 (depth = 4)
  gc_frame_newslot(call9667);
// call case 4: self request
  params[0] = call9667;
  partcv[0] = 1;
  Object call9668 = callmethodflags(self, "exclusions:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9665);
// compiled call node returning call9668 (depth = 3)
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9669 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9670 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9671 = callmethod(*var_other, "isUse",
    1, partcv, params);
  gc_frame_end(callframe9670);
// compiled call node returning call9671 (depth = 5)
// compiled member node returning call9671 (depth = 4)
  gc_frame_newslot(call9671);
// call case 4: self request
  params[0] = call9671;
  partcv[0] = 1;
  Object call9672 = callmethodflags(self, "isUse:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9669);
// compiled call node returning call9672 (depth = 3)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName9673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9676 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9675);
// compiled call node returning call9676 (depth = 5)
// compiled member node returning call9676 (depth = 4)
  Object if9674 = done;
  if (istrue(call9676)) {
// starting to compile string node (depth = 4)
  if (strlit9677 == NULL) {
    strlit9677 = alloc_String("use");
    gc_root(strlit9677);
  }
// compiled string node returning strlit9677 (depth = 4)
    gc_frame_newslot(strlit9677);
    if9674 = strlit9677;
  } else {
// starting to compile string node (depth = 4)
  if (strlit9678 == NULL) {
    strlit9678 = alloc_String("inherit");
    gc_root(strlit9678);
  }
// compiled string node returning strlit9678 (depth = 4)
    gc_frame_newslot(strlit9678);
    if9674 = strlit9678;
  }
// compiled if node returning if9674 (depth = 3)
  gc_frame_end(frame);
  return if9674;
}
Object meth_ast_new9336(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9337 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9337 = alloc_userobj2(27,23, objclass9337);
  gc_frame_newslot(obj9337);
if (objclass9337 == NULL) {
  glfree(obj9337->class->name);
  obj9337->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9337, self, 0);
  addmethodreal(obj9337,"outer", &reader_ast_outer_9338);
  Object oldself9337 = self;
  struct StackFrameObject *oldstackframe9337 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9337);
  gc_frame_newslot((Object)stackframe);
  self = obj9337;
  Object *oldselfslot9337 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9337 = (*(struct UserObject *)self).data[0], lowerouter9337 = thisouter9337;
  if (inheritingObject9337) {
    struct UserObject *inho9337 = (struct UserObject *)inheritingObject9337;
    while (inho9337->super != GraceDefaultObject) inho9337 = (struct UserObject *)inho9337->super;
    inho9337->super = obj9337;
    self = inheritingObject9337;
    *selfslot = self;
    lowerouter9337 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9337;
  }
if (objclass9337 == NULL) {
  Method *reader9339 = addmethodrealflags(obj9337, "kind",&reader_ast_kind_9339, MFLAG_DEF);
  reader9339->definitionModule = modulename;
  reader9339->definitionLine = 2366;
}
adddatum2(obj9337, alloc_Undefined(), 1);
if (objclass9337 == NULL) {
  Method *reader9340 = addmethodrealflags(obj9337, "value",&reader_ast_value_9340, 0);
  Method *writer9340 = addmethodrealflags(obj9337, "value:=",&writer_ast_value_9340, 0);
  reader9340->definitionModule = modulename;
  writer9340->definitionModule = modulename;
  reader9340->definitionLine = 2367;
  writer9340->definitionLine = 2367;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 2);
if (objclass9337 == NULL) {
  Method *reader9341 = addmethodrealflags(obj9337, "providedNames",&reader_ast_providedNames_9341, 0);
  Method *writer9341 = addmethodrealflags(obj9337, "providedNames:=",&writer_ast_providedNames_9341, 0);
  reader9341->definitionModule = modulename;
  writer9341->definitionModule = modulename;
  reader9341->definitionLine = 2368;
  writer9341->definitionLine = 2368;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 3);
if (objclass9337 == NULL) {
  Method *reader9342 = addmethodrealflags(obj9337, "aliases",&reader_ast_aliases_9342, 0);
  Method *writer9342 = addmethodrealflags(obj9337, "aliases:=",&writer_ast_aliases_9342, 0);
  reader9342->definitionModule = modulename;
  writer9342->definitionModule = modulename;
  reader9342->definitionLine = 2369;
  writer9342->definitionLine = 2369;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 4);
if (objclass9337 == NULL) {
  Method *reader9343 = addmethodrealflags(obj9337, "exclusions",&reader_ast_exclusions_9343, 0);
  Method *writer9343 = addmethodrealflags(obj9337, "exclusions:=",&writer_ast_exclusions_9343, 0);
  reader9343->definitionModule = modulename;
  writer9343->definitionModule = modulename;
  reader9343->definitionLine = 2370;
  writer9343->definitionLine = 2370;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 5);
if (objclass9337 == NULL) {
  Method *reader9344 = addmethodrealflags(obj9337, "isUse",&reader_ast_isUse_9344, 0);
  Method *writer9344 = addmethodrealflags(obj9337, "isUse:=",&writer_ast_isUse_9344, 0);
  reader9344->definitionModule = modulename;
  writer9344->definitionModule = modulename;
  reader9344->definitionLine = 2371;
  writer9344->definitionLine = 2371;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9345 = (struct UserObject*)obj9337;
  uo9345->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9345 = addmethod2pos(obj9337, "isLegalInTrait", &meth_ast_isLegalInTrait9345, 7);
  int argcv_meth_ast_isLegalInTrait9345[] = {0};
  meth_meth_ast_isLegalInTrait9345->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9345);
  meth_meth_ast_isLegalInTrait9345->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9345->definitionLine = 2373;
// method "isInherits"
  struct UserObject *uo9348 = (struct UserObject*)obj9337;
  uo9348->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9348 = addmethod2pos(obj9337, "isInherits", &meth_ast_isInherits9348, 8);
  int argcv_meth_ast_isInherits9348[] = {0};
  meth_meth_ast_isInherits9348->type = alloc_MethodType(1, argcv_meth_ast_isInherits9348);
  meth_meth_ast_isInherits9348->definitionModule = modulename;
  meth_meth_ast_isInherits9348->definitionLine = 2374;
// method "inheritsFromMember"
  struct UserObject *uo9350 = (struct UserObject*)obj9337;
  uo9350->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9350 = addmethod2pos(obj9337, "inheritsFromMember", &meth_ast_inheritsFromMember9350, 9);
  int argcv_meth_ast_inheritsFromMember9350[] = {0};
  meth_meth_ast_inheritsFromMember9350->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9350);
  meth_meth_ast_inheritsFromMember9350->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9350->definitionLine = 2375;
// method "inheritsFromCall"
  struct UserObject *uo9355 = (struct UserObject*)obj9337;
  uo9355->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9355 = addmethod2pos(obj9337, "inheritsFromCall", &meth_ast_inheritsFromCall9355, 10);
  int argcv_meth_ast_inheritsFromCall9355[] = {0};
  meth_meth_ast_inheritsFromCall9355->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9355);
  meth_meth_ast_inheritsFromCall9355->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9355->definitionLine = 2376;
// method "isExecutable"
  struct UserObject *uo9360 = (struct UserObject*)obj9337;
  uo9360->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9360 = addmethod2pos(obj9337, "isExecutable", &meth_ast_isExecutable9360, 11);
  int argcv_meth_ast_isExecutable9360[] = {0};
  meth_meth_ast_isExecutable9360->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9360);
  meth_meth_ast_isExecutable9360->definitionModule = modulename;
  meth_meth_ast_isExecutable9360->definitionLine = 2377;
// method "accept()from"
  struct UserObject *uo9362 = (struct UserObject*)obj9337;
  uo9362->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9362 = addmethod2pos(obj9337, "accept()from", &meth_ast_accept_40__41_from9362, 12);
  int argcv_meth_ast_accept_40__41_from9362[] = {1, 1};
  meth_meth_ast_accept_40__41_from9362->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9362);
  meth_meth_ast_accept_40__41_from9362->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9362->definitionLine = 2378;
// method "declarationKindWithAncestors"
  block_savedest(obj9337);
  Object closure9396 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9396, stackframe);
  addtoclosure(closure9396, var_k);
  struct UserObject *uo9396 = (struct UserObject*)obj9337;
  uo9396->data[13] = (Object)closure9396;
  Method *meth_meth_ast_declarationKindWithAncestors9396 = addmethod2pos(obj9337, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9396, 13);
  int argcv_meth_ast_declarationKindWithAncestors9396[] = {1};
  meth_meth_ast_declarationKindWithAncestors9396->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9396);
  meth_meth_ast_declarationKindWithAncestors9396->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9396->definitionLine = 2389;
// method "map()ancestors"
  struct UserObject *uo9399 = (struct UserObject*)obj9337;
  uo9399->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9399 = addmethod2pos(obj9337, "map()ancestors", &meth_ast_map_40__41_ancestors9399, 14);
  int argcv_meth_ast_map_40__41_ancestors9399[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9399->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9399);
  meth_meth_ast_map_40__41_ancestors9399->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9399->definitionLine = 2395;
// method "pretty"
  struct UserObject *uo9412 = (struct UserObject*)obj9337;
  uo9412->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty9412 = addmethod2pos(obj9337, "pretty", &meth_ast_pretty9412, 15);
  int argcv_meth_ast_pretty9412[] = {1};
  meth_meth_ast_pretty9412->type = alloc_MethodType(1, argcv_meth_ast_pretty9412);
  meth_meth_ast_pretty9412->definitionModule = modulename;
  meth_meth_ast_pretty9412->definitionLine = 2401;
// method "toGrace"
  struct UserObject *uo9564 = (struct UserObject*)obj9337;
  uo9564->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace9564 = addmethod2pos(obj9337, "toGrace", &meth_ast_toGrace9564, 16);
  int argcv_meth_ast_toGrace9564[] = {1};
  meth_meth_ast_toGrace9564->type = alloc_MethodType(1, argcv_meth_ast_toGrace9564);
meth_meth_ast_toGrace9564->type->types[0] = type_Number;
meth_meth_ast_toGrace9564->type->names[0] = "depth";
  meth_meth_ast_toGrace9564->definitionModule = modulename;
  meth_meth_ast_toGrace9564->definitionLine = 2421;
// method "nameString"
  struct UserObject *uo9627 = (struct UserObject*)obj9337;
  uo9627->data[17] = emptyclosure;
  Method *meth_meth_ast_nameString9627 = addmethod2pos(obj9337, "nameString", &meth_ast_nameString9627, 17);
  int argcv_meth_ast_nameString9627[] = {0};
  meth_meth_ast_nameString9627->type = alloc_MethodType(1, argcv_meth_ast_nameString9627);
  meth_meth_ast_nameString9627->definitionModule = modulename;
  meth_meth_ast_nameString9627->definitionLine = 2432;
// method "addAlias()for"
  struct UserObject *uo9633 = (struct UserObject*)obj9337;
  uo9633->data[18] = emptyclosure;
  Method *meth_meth_ast_addAlias_40__41_for9633 = addmethod2pos(obj9337, "addAlias()for", &meth_ast_addAlias_40__41_for9633, 18);
  int argcv_meth_ast_addAlias_40__41_for9633[] = {1, 1};
  meth_meth_ast_addAlias_40__41_for9633->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40__41_for9633);
  meth_meth_ast_addAlias_40__41_for9633->definitionModule = modulename;
  meth_meth_ast_addAlias_40__41_for9633->definitionLine = 2433;
// method "addExclusion"
  struct UserObject *uo9644 = (struct UserObject*)obj9337;
  uo9644->data[19] = emptyclosure;
  Method *meth_meth_ast_addExclusion9644 = addmethod2pos(obj9337, "addExclusion", &meth_ast_addExclusion9644, 19);
  int argcv_meth_ast_addExclusion9644[] = {1};
  meth_meth_ast_addExclusion9644->type = alloc_MethodType(1, argcv_meth_ast_addExclusion9644);
  meth_meth_ast_addExclusion9644->definitionModule = modulename;
  meth_meth_ast_addExclusion9644->definitionLine = 2436;
// method "shallowCopy"
  block_savedest(obj9337);
  Object closure9649 = createclosure(2, "shallowCopy");
  setclosureframe(closure9649, stackframe);
  addtoclosure(closure9649, var_nullNode);
  addtoclosure(closure9649, var_inheritsNode);
  struct UserObject *uo9649 = (struct UserObject*)obj9337;
  uo9649->data[20] = (Object)closure9649;
  Method *meth_meth_ast_shallowCopy9649 = addmethod2pos(obj9337, "shallowCopy", &meth_ast_shallowCopy9649, 20);
  int argcv_meth_ast_shallowCopy9649[] = {0};
  meth_meth_ast_shallowCopy9649->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9649);
  meth_meth_ast_shallowCopy9649->definitionModule = modulename;
  meth_meth_ast_shallowCopy9649->definitionLine = 2439;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9654 = (struct UserObject*)obj9337;
  uo9654->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9654 = addmethod2pos(obj9337, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9654, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom9654[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9654->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9654);
  meth_meth_ast_shallowCopyFieldsFrom9654->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9654->definitionLine = 2442;
// method "statementName"
  struct UserObject *uo9673 = (struct UserObject*)obj9337;
  uo9673->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName9673 = addmethod2pos(obj9337, "statementName", &meth_ast_statementName9673, 22);
  int argcv_meth_ast_statementName9673[] = {0};
  meth_meth_ast_statementName9673->type = alloc_MethodType(1, argcv_meth_ast_statementName9673);
  meth_meth_ast_statementName9673->definitionModule = modulename;
  meth_meth_ast_statementName9673->definitionLine = 2450;
  sourceObject = obj9337;
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9679 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9680 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9681 = gc_frame_new();
// call case 3: self.outer request
  Object call9682 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9681);
// compiled call node returning call9682 (depth = 7)
// compiled member node returning call9682 (depth = 6)
  partcv[0] = 0;
  Object call9683 = callmethodflags(call9682, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9680);
// compiled call node returning call9683 (depth = 5)
// compiled member node returning call9683 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9684 = callmethodflags(call9683, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9679);
// compiled call node returning call9684 (depth = 3)
  struct UserObject *obj9337_uo = (struct UserObject *)obj9337;
  obj9337_uo->super = call9684;
  sourceObject = obj9337;
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9685 == NULL) {
    strlit9685 = alloc_String("inherits");
    gc_root(strlit9685);
  }
// compiled string node returning strlit9685 (depth = 3)
  adddatum2(obj9337, strlit9685, 1);
  sourceObject = obj9337;
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9337, *var_expr, 2);
  sourceObject = obj9337;
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9686 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9687 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9688 = callmethodflags(prelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9687);
// compiled call node returning call9688 (depth = 6)
// compiled member node returning call9688 (depth = 5)
  partcv[0] = 0;
  Object call9689 = callmethod(call9688, "empty",
    1, partcv, params);
  gc_frame_end(callframe9686);
// compiled call node returning call9689 (depth = 4)
// compiled member node returning call9689 (depth = 3)
  adddatum2(obj9337, call9689, 3);
  sourceObject = obj9337;
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9690 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9691 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9692 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9691);
// compiled call node returning call9692 (depth = 6)
// compiled member node returning call9692 (depth = 5)
  partcv[0] = 0;
  Object call9693 = callmethod(call9692, "empty",
    1, partcv, params);
  gc_frame_end(callframe9690);
// compiled call node returning call9693 (depth = 4)
// compiled member node returning call9693 (depth = 3)
  adddatum2(obj9337, call9693, 4);
  sourceObject = obj9337;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9694 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9695 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9696 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9695);
// compiled call node returning call9696 (depth = 6)
// compiled member node returning call9696 (depth = 5)
  partcv[0] = 0;
  Object call9697 = callmethod(call9696, "empty",
    1, partcv, params);
  gc_frame_end(callframe9694);
// compiled call node returning call9697 (depth = 4)
// compiled member node returning call9697 (depth = 3)
  adddatum2(obj9337, call9697, 5);
  sourceObject = obj9337;
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9698 = alloc_Boolean(0);
// compiled identifier node returning bool9698 (depth = 3)
  adddatum2(obj9337, bool9698, 6);
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  objclass9337 = obj9337->class;
  objclass9337->definitionModule = modulename;
  objclass9337->definitionLine = 2364;
  (*(struct UserObject *)self).data[0] = lowerouter9337;
  self = oldself9337;
  selfslot = oldselfslot9337;
  stackframe = oldstackframe9337;
  gc_frame_end(frame);
  return obj9337;
}
Object meth_ast_new9336_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9337 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9337 = alloc_userobj2(27,23, objclass9337);
  gc_frame_newslot(obj9337);
if (objclass9337 == NULL) {
  glfree(obj9337->class->name);
  obj9337->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9337, self, 0);
  addmethodreal(obj9337,"outer", &reader_ast_outer_9338);
  Object oldself9337 = self;
  struct StackFrameObject *oldstackframe9337 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9337);
  gc_frame_newslot((Object)stackframe);
  self = obj9337;
  Object *oldselfslot9337 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9337 = (*(struct UserObject *)self).data[0], lowerouter9337 = thisouter9337;
  if (inheritingObject9337) {
    struct UserObject *inho9337 = (struct UserObject *)inheritingObject9337;
    while (inho9337->super != GraceDefaultObject) inho9337 = (struct UserObject *)inho9337->super;
    inho9337->super = obj9337;
    self = inheritingObject9337;
    *selfslot = self;
    lowerouter9337 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9337;
  }
if (objclass9337 == NULL) {
  Method *reader9339 = addmethodrealflags(obj9337, "kind",&reader_ast_kind_9339, MFLAG_DEF);
  reader9339->definitionModule = modulename;
  reader9339->definitionLine = 2366;
}
adddatum2(obj9337, alloc_Undefined(), 1);
if (objclass9337 == NULL) {
  Method *reader9340 = addmethodrealflags(obj9337, "value",&reader_ast_value_9340, 0);
  Method *writer9340 = addmethodrealflags(obj9337, "value:=",&writer_ast_value_9340, 0);
  reader9340->definitionModule = modulename;
  writer9340->definitionModule = modulename;
  reader9340->definitionLine = 2367;
  writer9340->definitionLine = 2367;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 2);
if (objclass9337 == NULL) {
  Method *reader9341 = addmethodrealflags(obj9337, "providedNames",&reader_ast_providedNames_9341, 0);
  Method *writer9341 = addmethodrealflags(obj9337, "providedNames:=",&writer_ast_providedNames_9341, 0);
  reader9341->definitionModule = modulename;
  writer9341->definitionModule = modulename;
  reader9341->definitionLine = 2368;
  writer9341->definitionLine = 2368;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 3);
if (objclass9337 == NULL) {
  Method *reader9342 = addmethodrealflags(obj9337, "aliases",&reader_ast_aliases_9342, 0);
  Method *writer9342 = addmethodrealflags(obj9337, "aliases:=",&writer_ast_aliases_9342, 0);
  reader9342->definitionModule = modulename;
  writer9342->definitionModule = modulename;
  reader9342->definitionLine = 2369;
  writer9342->definitionLine = 2369;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 4);
if (objclass9337 == NULL) {
  Method *reader9343 = addmethodrealflags(obj9337, "exclusions",&reader_ast_exclusions_9343, 0);
  Method *writer9343 = addmethodrealflags(obj9337, "exclusions:=",&writer_ast_exclusions_9343, 0);
  reader9343->definitionModule = modulename;
  writer9343->definitionModule = modulename;
  reader9343->definitionLine = 2370;
  writer9343->definitionLine = 2370;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 5);
if (objclass9337 == NULL) {
  Method *reader9344 = addmethodrealflags(obj9337, "isUse",&reader_ast_isUse_9344, 0);
  Method *writer9344 = addmethodrealflags(obj9337, "isUse:=",&writer_ast_isUse_9344, 0);
  reader9344->definitionModule = modulename;
  writer9344->definitionModule = modulename;
  reader9344->definitionLine = 2371;
  writer9344->definitionLine = 2371;
}
obj9337->flags |= OFLAG_MUTABLE;
adddatum2(obj9337, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9345 = (struct UserObject*)obj9337;
  uo9345->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9345 = addmethod2pos(obj9337, "isLegalInTrait", &meth_ast_isLegalInTrait9345, 7);
  int argcv_meth_ast_isLegalInTrait9345[] = {0};
  meth_meth_ast_isLegalInTrait9345->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9345);
  meth_meth_ast_isLegalInTrait9345->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9345->definitionLine = 2373;
// method "isInherits"
  struct UserObject *uo9348 = (struct UserObject*)obj9337;
  uo9348->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9348 = addmethod2pos(obj9337, "isInherits", &meth_ast_isInherits9348, 8);
  int argcv_meth_ast_isInherits9348[] = {0};
  meth_meth_ast_isInherits9348->type = alloc_MethodType(1, argcv_meth_ast_isInherits9348);
  meth_meth_ast_isInherits9348->definitionModule = modulename;
  meth_meth_ast_isInherits9348->definitionLine = 2374;
// method "inheritsFromMember"
  struct UserObject *uo9350 = (struct UserObject*)obj9337;
  uo9350->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9350 = addmethod2pos(obj9337, "inheritsFromMember", &meth_ast_inheritsFromMember9350, 9);
  int argcv_meth_ast_inheritsFromMember9350[] = {0};
  meth_meth_ast_inheritsFromMember9350->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9350);
  meth_meth_ast_inheritsFromMember9350->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9350->definitionLine = 2375;
// method "inheritsFromCall"
  struct UserObject *uo9355 = (struct UserObject*)obj9337;
  uo9355->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9355 = addmethod2pos(obj9337, "inheritsFromCall", &meth_ast_inheritsFromCall9355, 10);
  int argcv_meth_ast_inheritsFromCall9355[] = {0};
  meth_meth_ast_inheritsFromCall9355->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9355);
  meth_meth_ast_inheritsFromCall9355->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9355->definitionLine = 2376;
// method "isExecutable"
  struct UserObject *uo9360 = (struct UserObject*)obj9337;
  uo9360->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9360 = addmethod2pos(obj9337, "isExecutable", &meth_ast_isExecutable9360, 11);
  int argcv_meth_ast_isExecutable9360[] = {0};
  meth_meth_ast_isExecutable9360->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9360);
  meth_meth_ast_isExecutable9360->definitionModule = modulename;
  meth_meth_ast_isExecutable9360->definitionLine = 2377;
// method "accept()from"
  struct UserObject *uo9362 = (struct UserObject*)obj9337;
  uo9362->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9362 = addmethod2pos(obj9337, "accept()from", &meth_ast_accept_40__41_from9362, 12);
  int argcv_meth_ast_accept_40__41_from9362[] = {1, 1};
  meth_meth_ast_accept_40__41_from9362->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9362);
  meth_meth_ast_accept_40__41_from9362->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9362->definitionLine = 2378;
// method "declarationKindWithAncestors"
  block_savedest(obj9337);
  Object closure9396 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9396, stackframe);
  addtoclosure(closure9396, var_k);
  struct UserObject *uo9396 = (struct UserObject*)obj9337;
  uo9396->data[13] = (Object)closure9396;
  Method *meth_meth_ast_declarationKindWithAncestors9396 = addmethod2pos(obj9337, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9396, 13);
  int argcv_meth_ast_declarationKindWithAncestors9396[] = {1};
  meth_meth_ast_declarationKindWithAncestors9396->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9396);
  meth_meth_ast_declarationKindWithAncestors9396->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9396->definitionLine = 2389;
// method "map()ancestors"
  struct UserObject *uo9399 = (struct UserObject*)obj9337;
  uo9399->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9399 = addmethod2pos(obj9337, "map()ancestors", &meth_ast_map_40__41_ancestors9399, 14);
  int argcv_meth_ast_map_40__41_ancestors9399[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9399->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9399);
  meth_meth_ast_map_40__41_ancestors9399->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9399->definitionLine = 2395;
// method "pretty"
  struct UserObject *uo9412 = (struct UserObject*)obj9337;
  uo9412->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty9412 = addmethod2pos(obj9337, "pretty", &meth_ast_pretty9412, 15);
  int argcv_meth_ast_pretty9412[] = {1};
  meth_meth_ast_pretty9412->type = alloc_MethodType(1, argcv_meth_ast_pretty9412);
  meth_meth_ast_pretty9412->definitionModule = modulename;
  meth_meth_ast_pretty9412->definitionLine = 2401;
// method "toGrace"
  struct UserObject *uo9564 = (struct UserObject*)obj9337;
  uo9564->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace9564 = addmethod2pos(obj9337, "toGrace", &meth_ast_toGrace9564, 16);
  int argcv_meth_ast_toGrace9564[] = {1};
  meth_meth_ast_toGrace9564->type = alloc_MethodType(1, argcv_meth_ast_toGrace9564);
meth_meth_ast_toGrace9564->type->types[0] = type_Number;
meth_meth_ast_toGrace9564->type->names[0] = "depth";
  meth_meth_ast_toGrace9564->definitionModule = modulename;
  meth_meth_ast_toGrace9564->definitionLine = 2421;
// method "nameString"
  struct UserObject *uo9627 = (struct UserObject*)obj9337;
  uo9627->data[17] = emptyclosure;
  Method *meth_meth_ast_nameString9627 = addmethod2pos(obj9337, "nameString", &meth_ast_nameString9627, 17);
  int argcv_meth_ast_nameString9627[] = {0};
  meth_meth_ast_nameString9627->type = alloc_MethodType(1, argcv_meth_ast_nameString9627);
  meth_meth_ast_nameString9627->definitionModule = modulename;
  meth_meth_ast_nameString9627->definitionLine = 2432;
// method "addAlias()for"
  struct UserObject *uo9633 = (struct UserObject*)obj9337;
  uo9633->data[18] = emptyclosure;
  Method *meth_meth_ast_addAlias_40__41_for9633 = addmethod2pos(obj9337, "addAlias()for", &meth_ast_addAlias_40__41_for9633, 18);
  int argcv_meth_ast_addAlias_40__41_for9633[] = {1, 1};
  meth_meth_ast_addAlias_40__41_for9633->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40__41_for9633);
  meth_meth_ast_addAlias_40__41_for9633->definitionModule = modulename;
  meth_meth_ast_addAlias_40__41_for9633->definitionLine = 2433;
// method "addExclusion"
  struct UserObject *uo9644 = (struct UserObject*)obj9337;
  uo9644->data[19] = emptyclosure;
  Method *meth_meth_ast_addExclusion9644 = addmethod2pos(obj9337, "addExclusion", &meth_ast_addExclusion9644, 19);
  int argcv_meth_ast_addExclusion9644[] = {1};
  meth_meth_ast_addExclusion9644->type = alloc_MethodType(1, argcv_meth_ast_addExclusion9644);
  meth_meth_ast_addExclusion9644->definitionModule = modulename;
  meth_meth_ast_addExclusion9644->definitionLine = 2436;
// method "shallowCopy"
  block_savedest(obj9337);
  Object closure9649 = createclosure(2, "shallowCopy");
  setclosureframe(closure9649, stackframe);
  addtoclosure(closure9649, var_nullNode);
  addtoclosure(closure9649, var_inheritsNode);
  struct UserObject *uo9649 = (struct UserObject*)obj9337;
  uo9649->data[20] = (Object)closure9649;
  Method *meth_meth_ast_shallowCopy9649 = addmethod2pos(obj9337, "shallowCopy", &meth_ast_shallowCopy9649, 20);
  int argcv_meth_ast_shallowCopy9649[] = {0};
  meth_meth_ast_shallowCopy9649->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9649);
  meth_meth_ast_shallowCopy9649->definitionModule = modulename;
  meth_meth_ast_shallowCopy9649->definitionLine = 2439;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9654 = (struct UserObject*)obj9337;
  uo9654->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9654 = addmethod2pos(obj9337, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9654, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom9654[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9654->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9654);
  meth_meth_ast_shallowCopyFieldsFrom9654->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9654->definitionLine = 2442;
// method "statementName"
  struct UserObject *uo9673 = (struct UserObject*)obj9337;
  uo9673->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName9673 = addmethod2pos(obj9337, "statementName", &meth_ast_statementName9673, 22);
  int argcv_meth_ast_statementName9673[] = {0};
  meth_meth_ast_statementName9673->type = alloc_MethodType(1, argcv_meth_ast_statementName9673);
  meth_meth_ast_statementName9673->definitionModule = modulename;
  meth_meth_ast_statementName9673->definitionLine = 2450;
  sourceObject = obj9337;
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9679 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9680 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9681 = gc_frame_new();
// call case 3: self.outer request
  Object call9682 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9681);
// compiled call node returning call9682 (depth = 7)
// compiled member node returning call9682 (depth = 6)
  partcv[0] = 0;
  Object call9683 = callmethodflags(call9682, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9680);
// compiled call node returning call9683 (depth = 5)
// compiled member node returning call9683 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9684 = callmethodflags(call9683, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9679);
// compiled call node returning call9684 (depth = 3)
  struct UserObject *obj9337_uo = (struct UserObject *)obj9337;
  obj9337_uo->super = call9684;
  sourceObject = obj9337;
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9685 == NULL) {
    strlit9685 = alloc_String("inherits");
    gc_root(strlit9685);
  }
// compiled string node returning strlit9685 (depth = 3)
  adddatum2(obj9337, strlit9685, 1);
  sourceObject = obj9337;
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9337, *var_expr, 2);
  sourceObject = obj9337;
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9686 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9687 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9688 = callmethodflags(prelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9687);
// compiled call node returning call9688 (depth = 6)
// compiled member node returning call9688 (depth = 5)
  partcv[0] = 0;
  Object call9689 = callmethod(call9688, "empty",
    1, partcv, params);
  gc_frame_end(callframe9686);
// compiled call node returning call9689 (depth = 4)
// compiled member node returning call9689 (depth = 3)
  adddatum2(obj9337, call9689, 3);
  sourceObject = obj9337;
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9690 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9691 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9692 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9691);
// compiled call node returning call9692 (depth = 6)
// compiled member node returning call9692 (depth = 5)
  partcv[0] = 0;
  Object call9693 = callmethod(call9692, "empty",
    1, partcv, params);
  gc_frame_end(callframe9690);
// compiled call node returning call9693 (depth = 4)
// compiled member node returning call9693 (depth = 3)
  adddatum2(obj9337, call9693, 4);
  sourceObject = obj9337;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9694 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9695 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9696 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9695);
// compiled call node returning call9696 (depth = 6)
// compiled member node returning call9696 (depth = 5)
  partcv[0] = 0;
  Object call9697 = callmethod(call9696, "empty",
    1, partcv, params);
  gc_frame_end(callframe9694);
// compiled call node returning call9697 (depth = 4)
// compiled member node returning call9697 (depth = 3)
  adddatum2(obj9337, call9697, 5);
  sourceObject = obj9337;
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9698 = alloc_Boolean(0);
// compiled identifier node returning bool9698 (depth = 3)
  adddatum2(obj9337, bool9698, 6);
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  sourceObject = obj9337;
  objclass9337 = obj9337->class;
  objclass9337->definitionModule = modulename;
  objclass9337->definitionLine = 2364;
  (*(struct UserObject *)self).data[0] = lowerouter9337;
  self = oldself9337;
  selfslot = oldselfslot9337;
  stackframe = oldstackframe9337;
  gc_frame_end(frame);
  return obj9337;
}
Object meth_ast_inheritsNode9700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritsNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_AliasPair9703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AliasPair");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for AliasPair (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for AliasPair");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AliasPair (depth = 3)
  gc_frame_end(frame);
  return *var_AliasPair;
}
Object meth_ast_isExecutable9711(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9712 = alloc_Boolean(0);
// compiled identifier node returning bool9712 (depth = 3)
  gc_frame_end(frame);
  return bool9712;
}
Object meth_ast_accept_40__41_from9713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9714 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9715 = callmethod(*var_visitor, "visitBlank()up",
    2, partcv, params);
  gc_frame_end(callframe9714);
// compiled call node returning call9715 (depth = 3)
  gc_frame_end(frame);
  return call9715;
}
Object meth_ast_map_40__41_ancestors9716(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9718 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9717);
// compiled call node returning call9718 (depth = 5)
// compiled member node returning call9718 (depth = 4)
  *var_n = call9718;
  if (call9718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9719 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9720 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9719);
// compiled call node returning call9720 (depth = 4)
  *var_newChain = call9720;
  if (call9720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9722 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9721);
// compiled call node returning call9722 (depth = 3)
  gc_frame_end(frame);
  return call9722;
}
Object meth_ast_nameString9723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9724 == NULL) {
    strlit9724 = alloc_String("");
    gc_root(strlit9724);
  }
// compiled string node returning strlit9724 (depth = 3)
  gc_frame_end(frame);
  return strlit9724;
}
Object meth_ast_asString9725(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9726 == NULL) {
    strlit9726 = alloc_String("blank");
    gc_root(strlit9726);
  }
// compiled string node returning strlit9726 (depth = 3)
  gc_frame_end(frame);
  return strlit9726;
}
Object meth_ast_toGrace9727(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9728 == NULL) {
    strlit9728 = alloc_String("");
    gc_root(strlit9728);
  }
// compiled string node returning strlit9728 (depth = 3)
  gc_frame_end(frame);
  return strlit9728;
}
Object meth_ast_shallowCopy9729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9730 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blankNode (depth = 6)
  partcv[0] = 0;
  Object call9732 = callmethod(*var_blankNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9731);
// compiled call node returning call9732 (depth = 5)
// compiled member node returning call9732 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9733 = callmethod(call9732, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9730);
// compiled call node returning call9733 (depth = 3)
  gc_frame_end(frame);
  return call9733;
}
Object meth_ast_new9706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9707 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9707 = alloc_userobj2(9,10, objclass9707);
  gc_frame_newslot(obj9707);
if (objclass9707 == NULL) {
  glfree(obj9707->class->name);
  obj9707->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9707, self, 0);
  addmethodreal(obj9707,"outer", &reader_ast_outer_9708);
  Object oldself9707 = self;
  struct StackFrameObject *oldstackframe9707 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9707);
  gc_frame_newslot((Object)stackframe);
  self = obj9707;
  Object *oldselfslot9707 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9707 = (*(struct UserObject *)self).data[0], lowerouter9707 = thisouter9707;
  if (inheritingObject9707) {
    struct UserObject *inho9707 = (struct UserObject *)inheritingObject9707;
    while (inho9707->super != GraceDefaultObject) inho9707 = (struct UserObject *)inho9707->super;
    inho9707->super = obj9707;
    self = inheritingObject9707;
    *selfslot = self;
    lowerouter9707 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9707;
  }
if (objclass9707 == NULL) {
  Method *reader9709 = addmethodrealflags(obj9707, "kind",&reader_ast_kind_9709, MFLAG_DEF);
  reader9709->definitionModule = modulename;
  reader9709->definitionLine = 2482;
}
adddatum2(obj9707, alloc_Undefined(), 1);
if (objclass9707 == NULL) {
  Method *reader9710 = addmethodrealflags(obj9707, "value",&reader_ast_value_9710, MFLAG_DEF);
  reader9710->definitionModule = modulename;
  reader9710->definitionLine = 2483;
}
adddatum2(obj9707, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9711 = (struct UserObject*)obj9707;
  uo9711->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9711 = addmethod2pos(obj9707, "isExecutable", &meth_ast_isExecutable9711, 3);
  int argcv_meth_ast_isExecutable9711[] = {0};
  meth_meth_ast_isExecutable9711->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9711);
  meth_meth_ast_isExecutable9711->definitionModule = modulename;
  meth_meth_ast_isExecutable9711->definitionLine = 2484;
// method "accept()from"
  struct UserObject *uo9713 = (struct UserObject*)obj9707;
  uo9713->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9713 = addmethod2pos(obj9707, "accept()from", &meth_ast_accept_40__41_from9713, 4);
  int argcv_meth_ast_accept_40__41_from9713[] = {1, 1};
  meth_meth_ast_accept_40__41_from9713->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9713);
  meth_meth_ast_accept_40__41_from9713->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9713->definitionLine = 2487;
// method "map()ancestors"
  struct UserObject *uo9716 = (struct UserObject*)obj9707;
  uo9716->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9716 = addmethod2pos(obj9707, "map()ancestors", &meth_ast_map_40__41_ancestors9716, 5);
  int argcv_meth_ast_map_40__41_ancestors9716[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9716->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9716);
  meth_meth_ast_map_40__41_ancestors9716->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9716->definitionLine = 2490;
// method "nameString"
  struct UserObject *uo9723 = (struct UserObject*)obj9707;
  uo9723->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9723 = addmethod2pos(obj9707, "nameString", &meth_ast_nameString9723, 6);
  int argcv_meth_ast_nameString9723[] = {0};
  meth_meth_ast_nameString9723->type = alloc_MethodType(1, argcv_meth_ast_nameString9723);
  meth_meth_ast_nameString9723->definitionModule = modulename;
  meth_meth_ast_nameString9723->definitionLine = 2495;
// method "asString"
  struct UserObject *uo9725 = (struct UserObject*)obj9707;
  uo9725->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9725 = addmethod2pos(obj9707, "asString", &meth_ast_asString9725, 7);
  int argcv_meth_ast_asString9725[] = {0};
  meth_meth_ast_asString9725->type = alloc_MethodType(1, argcv_meth_ast_asString9725);
  meth_meth_ast_asString9725->definitionModule = modulename;
  meth_meth_ast_asString9725->definitionLine = 2496;
// method "toGrace"
  struct UserObject *uo9727 = (struct UserObject*)obj9707;
  uo9727->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace9727 = addmethod2pos(obj9707, "toGrace", &meth_ast_toGrace9727, 8);
  int argcv_meth_ast_toGrace9727[] = {1};
  meth_meth_ast_toGrace9727->type = alloc_MethodType(1, argcv_meth_ast_toGrace9727);
meth_meth_ast_toGrace9727->type->types[0] = type_Number;
meth_meth_ast_toGrace9727->type->names[0] = "depth";
  meth_meth_ast_toGrace9727->definitionModule = modulename;
  meth_meth_ast_toGrace9727->definitionLine = 2497;
// method "shallowCopy"
  block_savedest(obj9707);
  Object closure9729 = createclosure(1, "shallowCopy");
  setclosureframe(closure9729, stackframe);
  addtoclosure(closure9729, var_blankNode);
  struct UserObject *uo9729 = (struct UserObject*)obj9707;
  uo9729->data[9] = (Object)closure9729;
  Method *meth_meth_ast_shallowCopy9729 = addmethod2pos(obj9707, "shallowCopy", &meth_ast_shallowCopy9729, 9);
  int argcv_meth_ast_shallowCopy9729[] = {0};
  meth_meth_ast_shallowCopy9729->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9729);
  meth_meth_ast_shallowCopy9729->definitionModule = modulename;
  meth_meth_ast_shallowCopy9729->definitionLine = 2498;
  sourceObject = obj9707;
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9734 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9735 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9736 = gc_frame_new();
// call case 3: self.outer request
  Object call9737 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9736);
// compiled call node returning call9737 (depth = 7)
// compiled member node returning call9737 (depth = 6)
  partcv[0] = 0;
  Object call9738 = callmethodflags(call9737, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9735);
// compiled call node returning call9738 (depth = 5)
// compiled member node returning call9738 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9739 = callmethodflags(call9738, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9734);
// compiled call node returning call9739 (depth = 3)
  struct UserObject *obj9707_uo = (struct UserObject *)obj9707;
  obj9707_uo->super = call9739;
  sourceObject = obj9707;
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9740 == NULL) {
    strlit9740 = alloc_String("blank");
    gc_root(strlit9740);
  }
// compiled string node returning strlit9740 (depth = 3)
  adddatum2(obj9707, strlit9740, 1);
  sourceObject = obj9707;
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9741 == NULL) {
    strlit9741 = alloc_String("blank");
    gc_root(strlit9741);
  }
// compiled string node returning strlit9741 (depth = 3)
  adddatum2(obj9707, strlit9741, 2);
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  objclass9707 = obj9707->class;
  objclass9707->definitionModule = modulename;
  objclass9707->definitionLine = 2480;
  (*(struct UserObject *)self).data[0] = lowerouter9707;
  self = oldself9707;
  selfslot = oldselfslot9707;
  stackframe = oldstackframe9707;
  gc_frame_end(frame);
  return obj9707;
}
Object meth_ast_new9706_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9707 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9707 = alloc_userobj2(9,10, objclass9707);
  gc_frame_newslot(obj9707);
if (objclass9707 == NULL) {
  glfree(obj9707->class->name);
  obj9707->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9707, self, 0);
  addmethodreal(obj9707,"outer", &reader_ast_outer_9708);
  Object oldself9707 = self;
  struct StackFrameObject *oldstackframe9707 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9707);
  gc_frame_newslot((Object)stackframe);
  self = obj9707;
  Object *oldselfslot9707 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9707 = (*(struct UserObject *)self).data[0], lowerouter9707 = thisouter9707;
  if (inheritingObject9707) {
    struct UserObject *inho9707 = (struct UserObject *)inheritingObject9707;
    while (inho9707->super != GraceDefaultObject) inho9707 = (struct UserObject *)inho9707->super;
    inho9707->super = obj9707;
    self = inheritingObject9707;
    *selfslot = self;
    lowerouter9707 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9707;
  }
if (objclass9707 == NULL) {
  Method *reader9709 = addmethodrealflags(obj9707, "kind",&reader_ast_kind_9709, MFLAG_DEF);
  reader9709->definitionModule = modulename;
  reader9709->definitionLine = 2482;
}
adddatum2(obj9707, alloc_Undefined(), 1);
if (objclass9707 == NULL) {
  Method *reader9710 = addmethodrealflags(obj9707, "value",&reader_ast_value_9710, MFLAG_DEF);
  reader9710->definitionModule = modulename;
  reader9710->definitionLine = 2483;
}
adddatum2(obj9707, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9711 = (struct UserObject*)obj9707;
  uo9711->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9711 = addmethod2pos(obj9707, "isExecutable", &meth_ast_isExecutable9711, 3);
  int argcv_meth_ast_isExecutable9711[] = {0};
  meth_meth_ast_isExecutable9711->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9711);
  meth_meth_ast_isExecutable9711->definitionModule = modulename;
  meth_meth_ast_isExecutable9711->definitionLine = 2484;
// method "accept()from"
  struct UserObject *uo9713 = (struct UserObject*)obj9707;
  uo9713->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9713 = addmethod2pos(obj9707, "accept()from", &meth_ast_accept_40__41_from9713, 4);
  int argcv_meth_ast_accept_40__41_from9713[] = {1, 1};
  meth_meth_ast_accept_40__41_from9713->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9713);
  meth_meth_ast_accept_40__41_from9713->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9713->definitionLine = 2487;
// method "map()ancestors"
  struct UserObject *uo9716 = (struct UserObject*)obj9707;
  uo9716->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9716 = addmethod2pos(obj9707, "map()ancestors", &meth_ast_map_40__41_ancestors9716, 5);
  int argcv_meth_ast_map_40__41_ancestors9716[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9716->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9716);
  meth_meth_ast_map_40__41_ancestors9716->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9716->definitionLine = 2490;
// method "nameString"
  struct UserObject *uo9723 = (struct UserObject*)obj9707;
  uo9723->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9723 = addmethod2pos(obj9707, "nameString", &meth_ast_nameString9723, 6);
  int argcv_meth_ast_nameString9723[] = {0};
  meth_meth_ast_nameString9723->type = alloc_MethodType(1, argcv_meth_ast_nameString9723);
  meth_meth_ast_nameString9723->definitionModule = modulename;
  meth_meth_ast_nameString9723->definitionLine = 2495;
// method "asString"
  struct UserObject *uo9725 = (struct UserObject*)obj9707;
  uo9725->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9725 = addmethod2pos(obj9707, "asString", &meth_ast_asString9725, 7);
  int argcv_meth_ast_asString9725[] = {0};
  meth_meth_ast_asString9725->type = alloc_MethodType(1, argcv_meth_ast_asString9725);
  meth_meth_ast_asString9725->definitionModule = modulename;
  meth_meth_ast_asString9725->definitionLine = 2496;
// method "toGrace"
  struct UserObject *uo9727 = (struct UserObject*)obj9707;
  uo9727->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace9727 = addmethod2pos(obj9707, "toGrace", &meth_ast_toGrace9727, 8);
  int argcv_meth_ast_toGrace9727[] = {1};
  meth_meth_ast_toGrace9727->type = alloc_MethodType(1, argcv_meth_ast_toGrace9727);
meth_meth_ast_toGrace9727->type->types[0] = type_Number;
meth_meth_ast_toGrace9727->type->names[0] = "depth";
  meth_meth_ast_toGrace9727->definitionModule = modulename;
  meth_meth_ast_toGrace9727->definitionLine = 2497;
// method "shallowCopy"
  block_savedest(obj9707);
  Object closure9729 = createclosure(1, "shallowCopy");
  setclosureframe(closure9729, stackframe);
  addtoclosure(closure9729, var_blankNode);
  struct UserObject *uo9729 = (struct UserObject*)obj9707;
  uo9729->data[9] = (Object)closure9729;
  Method *meth_meth_ast_shallowCopy9729 = addmethod2pos(obj9707, "shallowCopy", &meth_ast_shallowCopy9729, 9);
  int argcv_meth_ast_shallowCopy9729[] = {0};
  meth_meth_ast_shallowCopy9729->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9729);
  meth_meth_ast_shallowCopy9729->definitionModule = modulename;
  meth_meth_ast_shallowCopy9729->definitionLine = 2498;
  sourceObject = obj9707;
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9734 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9735 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9736 = gc_frame_new();
// call case 3: self.outer request
  Object call9737 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9736);
// compiled call node returning call9737 (depth = 7)
// compiled member node returning call9737 (depth = 6)
  partcv[0] = 0;
  Object call9738 = callmethodflags(call9737, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9735);
// compiled call node returning call9738 (depth = 5)
// compiled member node returning call9738 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9739 = callmethodflags(call9738, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9734);
// compiled call node returning call9739 (depth = 3)
  struct UserObject *obj9707_uo = (struct UserObject *)obj9707;
  obj9707_uo->super = call9739;
  sourceObject = obj9707;
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9740 == NULL) {
    strlit9740 = alloc_String("blank");
    gc_root(strlit9740);
  }
// compiled string node returning strlit9740 (depth = 3)
  adddatum2(obj9707, strlit9740, 1);
  sourceObject = obj9707;
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9741 == NULL) {
    strlit9741 = alloc_String("blank");
    gc_root(strlit9741);
  }
// compiled string node returning strlit9741 (depth = 3)
  adddatum2(obj9707, strlit9741, 2);
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  sourceObject = obj9707;
  objclass9707 = obj9707->class;
  objclass9707->definitionModule = modulename;
  objclass9707->definitionLine = 2480;
  (*(struct UserObject *)self).data[0] = lowerouter9707;
  self = oldself9707;
  selfslot = oldselfslot9707;
  stackframe = oldstackframe9707;
  gc_frame_end(frame);
  return obj9707;
}
Object meth_ast_blankNode9743(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blankNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankNode (depth = 3)
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_new9746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9747 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9748 == NULL) {
    strlit9748 = alloc_String("");
    gc_root(strlit9748);
  }
// compiled string node returning strlit9748 (depth = 4)
  gc_frame_newslot(strlit9748);
// starting to compile array node (depth = 4)
  Object array9749 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9749 (depth = 4)
  gc_frame_newslot(array9749);
// starting to compile identifier node (depth = 4)
  Object bool9750 = alloc_Boolean(0);
// compiled identifier node returning bool9750 (depth = 4)
  gc_frame_newslot(bool9750);
// call case 4: self request
  params[0] = strlit9748;
  params[1] = array9749;
  params[2] = bool9750;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9751 = callmethodflags(self, "partName()params()variableParam", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9747);
// compiled call node returning call9751 (depth = 3)
  gc_frame_end(frame);
  return call9751;
}
Object meth_ast_partName_40__41_scope9752(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()scope");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9753 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 5)
  Object array9754 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9754 (depth = 5)
  gc_frame_newslot(array9754);
// starting to compile identifier node (depth = 5)
  Object bool9755 = alloc_Boolean(0);
// compiled identifier node returning bool9755 (depth = 5)
  gc_frame_newslot(bool9755);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9754;
  params[2] = bool9755;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9756 = callmethodflags(self, "partName()params()variableParam", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9753);
// compiled call node returning call9756 (depth = 4)
  *var_result = call9756;
  if (call9756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9757 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9758 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9757);
// compiled call node returning call9758 (depth = 3)
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40__41_params_40__41_scope9759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName()params()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()scope");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName()params()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9760 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ps (depth = 5)
  gc_frame_newslot(*var_ps);
// starting to compile identifier node (depth = 5)
  Object bool9761 = alloc_Boolean(0);
// compiled identifier node returning bool9761 (depth = 5)
  gc_frame_newslot(bool9761);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  params[2] = bool9761;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9762 = callmethodflags(self, "partName()params()variableParam", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9760);
// compiled call node returning call9762 (depth = 4)
  *var_result = call9762;
  if (call9762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9763 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9764 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9763);
// compiled call node returning call9764 (depth = 3)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName()params()variableParam()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()scope");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()scope");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for partName()params()variableParam()scope (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *var_v = &(stackframe->slots[2]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for variableParam");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9766 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ps (depth = 5)
  gc_frame_newslot(*var_ps);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  params[2] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9767 = callmethodflags(self, "partName()params()variableParam", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9766);
// compiled call node returning call9767 (depth = 4)
  *var_result = call9767;
  if (call9767 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9768 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9769 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9768);
// compiled call node returning call9769 (depth = 3)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName9770(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for partName (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9771 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 4)
  Object array9772 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9772 (depth = 4)
  gc_frame_newslot(array9772);
// starting to compile identifier node (depth = 4)
  Object bool9773 = alloc_Boolean(0);
// compiled identifier node returning bool9773 (depth = 4)
  gc_frame_newslot(bool9773);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9772;
  params[2] = bool9773;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9774 = callmethodflags(self, "partName()params()variableParam", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9771);
// compiled call node returning call9774 (depth = 3)
  gc_frame_end(frame);
  return call9774;
}
Object meth_ast_partName_40__41_params9775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName()params");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName()params (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9776 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ps (depth = 4)
  gc_frame_newslot(*var_ps);
// starting to compile identifier node (depth = 4)
  Object bool9777 = alloc_Boolean(0);
// compiled identifier node returning bool9777 (depth = 4)
  gc_frame_newslot(bool9777);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  params[2] = bool9777;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9778 = callmethodflags(self, "partName()params()variableParam", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9776);
// compiled call node returning call9778 (depth = 3)
  gc_frame_end(frame);
  return call9778;
}
Object meth_ast__apply9796(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9797 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9798 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9797);
// compiled call node returning call9798 (depth = 6)
  gc_frame_end(frame);
  return call9798;
}
Object meth_ast_accept_40__41_from9788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9790 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9791 = callmethod(*var_visitor, "visitSignaturePart()up",
    2, partcv, params);
  gc_frame_end(callframe9790);
// compiled call node returning call9791 (depth = 4)
  Object if9789 = done;
  if (istrue(call9791)) {
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9792 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9793 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9792);
// compiled call node returning call9793 (depth = 5)
  *var_newChain = call9793;
  if (call9793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9794 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9795 = alloc_Block(NULL, NULL, "ast", 2540);
  gc_frame_newslot(block9795);
// method "_apply"
  block_savedest(block9795);
  Object closure9796 = createclosure(3, "_apply");
  setclosureframe(closure9796, stackframe);
  addtoclosure(closure9796, var_visitor);
  addtoclosure(closure9796, var_newChain);
  addtoclosure(closure9796, selfslot);
  struct UserObject *uo9796 = (struct UserObject*)block9795;
  uo9796->data[0] = (Object)closure9796;
  Method *meth_meth_ast__apply9796 = addmethod2pos(block9795, "_apply", &meth_ast__apply9796, 0);
  int argcv_meth_ast__apply9796[] = {1};
  meth_meth_ast__apply9796->type = alloc_MethodType(1, argcv_meth_ast__apply9796);
  meth_meth_ast__apply9796->definitionModule = modulename;
  meth_meth_ast__apply9796->definitionLine = 2481;
// compiled block node returning block9795 (depth = 5)
  gc_frame_newslot(block9795);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9801 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9800);
// compiled call node returning call9801 (depth = 6)
// compiled member node returning call9801 (depth = 5)
  params[0] = block9795;
  partcv[0] = 1;
  Object call9802 = callmethod(call9801, "do",
    1, partcv, params);
  gc_frame_end(callframe9794);
// compiled call node returning call9802 (depth = 4)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9805 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9806 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9805);
// compiled call node returning call9806 (depth = 7)
// compiled member node returning call9806 (depth = 6)
  int op_slot_right_9804 = gc_frame_newslot(call9806);
// starting to compile identifier node (depth = 6)
  Object bool9808 = alloc_Boolean(0);
// compiled identifier node returning bool9808 (depth = 6)
  int op_slot_left_9804 = gc_frame_newslot(bool9808);
  params[0] = call9806;
  partcv[0] = 1;
  Object opresult9809 = callmethod(bool9808, "!=", 1, partcv, params);
// compiled op node returning opresult9809 (depth = 5)
  Object if9803 = done;
  if (istrue(opresult9809)) {
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9810 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9812 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9811);
// compiled call node returning call9812 (depth = 7)
// compiled member node returning call9812 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9813 = callmethod(call9812, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9810);
// compiled call node returning call9813 (depth = 5)
    gc_frame_newslot(call9813);
    if9803 = call9813;
  } else {
  }
// compiled if node returning if9803 (depth = 4)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9817 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9816);
// compiled call node returning call9817 (depth = 7)
// compiled member node returning call9817 (depth = 6)
  int op_slot_right_9815 = gc_frame_newslot(call9817);
// starting to compile identifier node (depth = 6)
  Object bool9819 = alloc_Boolean(0);
// compiled identifier node returning bool9819 (depth = 6)
  int op_slot_left_9815 = gc_frame_newslot(bool9819);
  params[0] = call9817;
  partcv[0] = 1;
  Object opresult9820 = callmethod(bool9819, "!=", 1, partcv, params);
// compiled op node returning opresult9820 (depth = 5)
  Object if9814 = done;
  if (istrue(opresult9820)) {
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9821 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9822 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9823 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9822);
// compiled call node returning call9823 (depth = 7)
// compiled member node returning call9823 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9824 = callmethod(call9823, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9821);
// compiled call node returning call9824 (depth = 5)
    gc_frame_newslot(call9824);
    if9814 = call9824;
  } else {
  }
// compiled if node returning if9814 (depth = 4)
    gc_frame_newslot(if9814);
    if9789 = if9814;
  } else {
  }
// compiled if node returning if9789 (depth = 3)
  gc_frame_end(frame);
  return if9789;
}
Object meth_ast_declarationKindWithAncestors9825(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call9827 = callmethod(*var_k, "parameter",
    1, partcv, params);
  gc_frame_end(callframe9826);
// compiled call node returning call9827 (depth = 4)
// compiled member node returning call9827 (depth = 3)
  gc_frame_end(frame);
  return call9827;
}
Object meth_ast_map_40__41_ancestors9828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nd");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9830 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9829);
// compiled call node returning call9830 (depth = 5)
// compiled member node returning call9830 (depth = 4)
  *var_nd = call9830;
  if (call9830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9831 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nd (depth = 5)
  gc_frame_newslot(*var_nd);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_nd;
  partcv[0] = 1;
  Object call9832 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9831);
// compiled call node returning call9832 (depth = 4)
  *var_newChain = call9832;
  if (call9832 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9833 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9834 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9836 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9835);
// compiled call node returning call9836 (depth = 6)
// compiled member node returning call9836 (depth = 5)
  gc_frame_newslot(call9836);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9837 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9838 = gc_frame_new();
// call case 3: self.outer request
  Object call9839 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9838);
// compiled call node returning call9839 (depth = 8)
// compiled member node returning call9839 (depth = 7)
  partcv[0] = 0;
  Object call9840 = callmethodflags(call9839, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9837);
// compiled call node returning call9840 (depth = 6)
// compiled member node returning call9840 (depth = 5)
  params[0] = call9836;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9841 = callmethodflags(call9840, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9834);
// compiled call node returning call9841 (depth = 4)
  gc_frame_newslot(call9841);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9841;
  partcv[0] = 1;
  Object call9842 = callmethod(*var_nd, "params:=",
    1, partcv, params);
  gc_frame_end(callframe9833);
// compiled call node returning call9842 (depth = 3)
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9843 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9844 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9846 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9845);
// compiled call node returning call9846 (depth = 6)
// compiled member node returning call9846 (depth = 5)
  gc_frame_newslot(call9846);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9847 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9848 = gc_frame_new();
// call case 3: self.outer request
  Object call9849 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9848);
// compiled call node returning call9849 (depth = 8)
// compiled member node returning call9849 (depth = 7)
  partcv[0] = 0;
  Object call9850 = callmethodflags(call9849, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9847);
// compiled call node returning call9850 (depth = 6)
// compiled member node returning call9850 (depth = 5)
  params[0] = call9846;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9851 = callmethodflags(call9850, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9844);
// compiled call node returning call9851 (depth = 4)
  gc_frame_newslot(call9851);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9851;
  partcv[0] = 1;
  Object call9852 = callmethod(*var_nd, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9843);
// compiled call node returning call9852 (depth = 3)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9853 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9854 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9856 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9855);
// compiled call node returning call9856 (depth = 6)
// compiled member node returning call9856 (depth = 5)
  gc_frame_newslot(call9856);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9857 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9858 = gc_frame_new();
// call case 3: self.outer request
  Object call9859 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9858);
// compiled call node returning call9859 (depth = 8)
// compiled member node returning call9859 (depth = 7)
  partcv[0] = 0;
  Object call9860 = callmethodflags(call9859, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9857);
// compiled call node returning call9860 (depth = 6)
// compiled member node returning call9860 (depth = 5)
  params[0] = call9856;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9861 = callmethodflags(call9860, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9854);
// compiled call node returning call9861 (depth = 4)
  gc_frame_newslot(call9861);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9861;
  partcv[0] = 1;
  Object call9862 = callmethod(*var_nd, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe9853);
// compiled call node returning call9862 (depth = 3)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9863 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_nd;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9864 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9863);
// compiled call node returning call9864 (depth = 3)
  gc_frame_end(frame);
  return call9864;
}
Object meth_ast__apply9873(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9875 == NULL) {
    strlit9875 = alloc_String("  ");
    gc_root(strlit9875);
  }
// compiled string node returning strlit9875 (depth = 7)
  int op_slot_right_9874 = gc_frame_newslot(strlit9875);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9874 = gc_frame_newslot(*var_spc);
  params[0] = strlit9875;
  partcv[0] = 1;
  Object opresult9877 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9877 (depth = 6)
  *var_spc = opresult9877;
  if (opresult9877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9927(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9929 == NULL) {
    strlit9929 = alloc_String("");
    gc_root(strlit9929);
  }
// compiled string node returning strlit9929 (depth = 7)
  int op_slot_right_9928 = gc_frame_newslot(strlit9929);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9932 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9934 = alloc_Float64(2);
// compiled num node returning num9934 (depth = 10)
  int op_slot_right_9933 = gc_frame_newslot(num9934);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_9933 = gc_frame_newslot(*var_depth);
  params[0] = num9934;
  partcv[0] = 1;
  Object sum9936 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9936 (depth = 9)
  gc_frame_newslot(sum9936);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = sum9936;
  partcv[0] = 1;
  Object call9937 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9932);
// compiled call node returning call9937 (depth = 8)
  int op_slot_right_9931 = gc_frame_newslot(call9937);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9940 == NULL) {
    strlit9940 = alloc_String("");
    gc_root(strlit9940);
  }
// compiled string node returning strlit9940 (depth = 9)
  int op_slot_right_9939 = gc_frame_newslot(strlit9940);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9942 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9945 == NULL) {
    strlit9945 = alloc_String("""\x0a""  ");
    gc_root(strlit9945);
  }
// compiled string node returning strlit9945 (depth = 11)
  int op_slot_right_9944 = gc_frame_newslot(strlit9945);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_9947 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit9949 == NULL) {
    strlit9949 = alloc_String("");
    gc_root(strlit9949);
  }
// compiled string node returning strlit9949 (depth = 12)
  int op_slot_left_9947 = gc_frame_newslot(strlit9949);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9950 = callmethod(strlit9949, "++", 1, partcv, params);
// compiled op node returning opresult9950 (depth = 11)
  int op_slot_left_9944 = gc_frame_newslot(opresult9950);
  params[0] = strlit9945;
  partcv[0] = 1;
  Object opresult9951 = callmethod(opresult9950, "++", 1, partcv, params);
// compiled op node returning opresult9951 (depth = 10)
  int op_slot_left_9942 = gc_frame_newslot(opresult9951);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9952 = callmethod(opresult9951, "++", 1, partcv, params);
// compiled op node returning opresult9952 (depth = 9)
  int op_slot_left_9939 = gc_frame_newslot(opresult9952);
  params[0] = strlit9940;
  partcv[0] = 1;
  Object opresult9953 = callmethod(opresult9952, "++", 1, partcv, params);
// compiled op node returning opresult9953 (depth = 8)
  int op_slot_left_9931 = gc_frame_newslot(opresult9953);
  params[0] = call9937;
  partcv[0] = 1;
  Object opresult9954 = callmethod(opresult9953, "++", 1, partcv, params);
// compiled op node returning opresult9954 (depth = 7)
  int op_slot_left_9928 = gc_frame_newslot(opresult9954);
  params[0] = strlit9929;
  partcv[0] = 1;
  Object opresult9955 = callmethod(opresult9954, "++", 1, partcv, params);
// compiled op node returning opresult9955 (depth = 6)
  *var_s = opresult9955;
  if (opresult9955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9866 == NULL) {
    strlit9866 = alloc_String("");
    gc_root(strlit9866);
  }
// compiled string node returning strlit9866 (depth = 4)
  *var_spc = strlit9866;
  if (strlit9866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9867 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9868 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9870 = alloc_Float64(0);
// compiled num node returning num9870 (depth = 5)
  int op_slot_left_9868 = gc_frame_newslot(num9870);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9871 = callmethod(num9870, "..", 1, partcv, params);
// compiled op node returning opresult9871 (depth = 4)
  gc_frame_newslot(opresult9871);
// starting to compile block node (depth = 4)
  Object block9872 = alloc_Block(NULL, NULL, "ast", 2560);
  gc_frame_newslot(block9872);
// method "_apply"
  block_savedest(block9872);
  Object closure9873 = createclosure(2, "_apply");
  setclosureframe(closure9873, stackframe);
  addtoclosure(closure9873, var_spc);
  addtoclosure(closure9873, selfslot);
  struct UserObject *uo9873 = (struct UserObject*)block9872;
  uo9873->data[0] = (Object)closure9873;
  Method *meth_meth_ast__apply9873 = addmethod2pos(block9872, "_apply", &meth_ast__apply9873, 0);
  int argcv_meth_ast__apply9873[] = {1};
  meth_meth_ast__apply9873->type = alloc_MethodType(1, argcv_meth_ast__apply9873);
  meth_meth_ast__apply9873->definitionModule = modulename;
  meth_meth_ast__apply9873->definitionLine = 2555;
// compiled block node returning block9872 (depth = 4)
  gc_frame_newslot(block9872);
// call case 5: prelude request
  params[0] = opresult9871;
  params[1] = block9872;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9880 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9867);
// compiled call node returning call9880 (depth = 3)
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9882 == NULL) {
    strlit9882 = alloc_String("");
    gc_root(strlit9882);
  }
// compiled string node returning strlit9882 (depth = 5)
  int op_slot_right_9881 = gc_frame_newslot(strlit9882);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9885 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9886 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9885);
// compiled call node returning call9886 (depth = 7)
// compiled member node returning call9886 (depth = 6)
  int op_slot_right_9884 = gc_frame_newslot(call9886);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9889 == NULL) {
    strlit9889 = alloc_String(": ");
    gc_root(strlit9889);
  }
// compiled string node returning strlit9889 (depth = 7)
  int op_slot_right_9888 = gc_frame_newslot(strlit9889);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9892 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9893 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9892);
// compiled call node returning call9893 (depth = 8)
  int op_slot_right_9891 = gc_frame_newslot(call9893);
// starting to compile string node (depth = 8)
  if (strlit9895 == NULL) {
    strlit9895 = alloc_String("");
    gc_root(strlit9895);
  }
// compiled string node returning strlit9895 (depth = 8)
  int op_slot_left_9891 = gc_frame_newslot(strlit9895);
  params[0] = call9893;
  partcv[0] = 1;
  Object opresult9896 = callmethod(strlit9895, "++", 1, partcv, params);
// compiled op node returning opresult9896 (depth = 7)
  int op_slot_left_9888 = gc_frame_newslot(opresult9896);
  params[0] = strlit9889;
  partcv[0] = 1;
  Object opresult9897 = callmethod(opresult9896, "++", 1, partcv, params);
// compiled op node returning opresult9897 (depth = 6)
  int op_slot_left_9884 = gc_frame_newslot(opresult9897);
  params[0] = call9886;
  partcv[0] = 1;
  Object opresult9898 = callmethod(opresult9897, "++", 1, partcv, params);
// compiled op node returning opresult9898 (depth = 5)
  int op_slot_left_9881 = gc_frame_newslot(opresult9898);
  params[0] = strlit9882;
  partcv[0] = 1;
  Object opresult9899 = callmethod(opresult9898, "++", 1, partcv, params);
// compiled op node returning opresult9899 (depth = 4)
  *var_s = opresult9899;
  if (opresult9899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9901 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9902 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9903 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9904 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9903);
// compiled call node returning call9904 (depth = 9)
// compiled member node returning call9904 (depth = 8)
  partcv[0] = 0;
  Object call9905 = callmethod(call9904, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9902);
// compiled call node returning call9905 (depth = 7)
// compiled member node returning call9905 (depth = 6)
  partcv[0] = 0;
  Object call9906 = callmethod(call9905, "not",
    1, partcv, params);
  gc_frame_end(callframe9901);
// compiled call node returning call9906 (depth = 5)
// compiled member node returning call9906 (depth = 4)
  Object if9900 = done;
  if (istrue(call9906)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9908 == NULL) {
    strlit9908 = alloc_String("Parameters:");
    gc_root(strlit9908);
  }
// compiled string node returning strlit9908 (depth = 6)
  int op_slot_right_9907 = gc_frame_newslot(strlit9908);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9910 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9913 == NULL) {
    strlit9913 = alloc_String("""\x0a""");
    gc_root(strlit9913);
  }
// compiled string node returning strlit9913 (depth = 8)
  int op_slot_right_9912 = gc_frame_newslot(strlit9913);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9915 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9917 == NULL) {
    strlit9917 = alloc_String("");
    gc_root(strlit9917);
  }
// compiled string node returning strlit9917 (depth = 9)
  int op_slot_left_9915 = gc_frame_newslot(strlit9917);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9918 = callmethod(strlit9917, "++", 1, partcv, params);
// compiled op node returning opresult9918 (depth = 8)
  int op_slot_left_9912 = gc_frame_newslot(opresult9918);
  params[0] = strlit9913;
  partcv[0] = 1;
  Object opresult9919 = callmethod(opresult9918, "++", 1, partcv, params);
// compiled op node returning opresult9919 (depth = 7)
  int op_slot_left_9910 = gc_frame_newslot(opresult9919);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9920 = callmethod(opresult9919, "++", 1, partcv, params);
// compiled op node returning opresult9920 (depth = 6)
  int op_slot_left_9907 = gc_frame_newslot(opresult9920);
  params[0] = strlit9908;
  partcv[0] = 1;
  Object opresult9921 = callmethod(opresult9920, "++", 1, partcv, params);
// compiled op node returning opresult9921 (depth = 5)
  *var_s = opresult9921;
  if (opresult9921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9900 = done;
  } else {
  }
// compiled if node returning if9900 (depth = 3)
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9923 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9924 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9925 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9924);
// compiled call node returning call9925 (depth = 5)
// compiled member node returning call9925 (depth = 4)
  gc_frame_newslot(call9925);
// starting to compile block node (depth = 4)
  Object block9926 = alloc_Block(NULL, NULL, "ast", 2565);
  gc_frame_newslot(block9926);
// method "_apply"
  block_savedest(block9926);
  Object closure9927 = createclosure(4, "_apply");
  setclosureframe(closure9927, stackframe);
  addtoclosure(closure9927, var_depth);
  addtoclosure(closure9927, var_spc);
  addtoclosure(closure9927, var_s);
  addtoclosure(closure9927, selfslot);
  struct UserObject *uo9927 = (struct UserObject*)block9926;
  uo9927->data[0] = (Object)closure9927;
  Method *meth_meth_ast__apply9927 = addmethod2pos(block9926, "_apply", &meth_ast__apply9927, 0);
  int argcv_meth_ast__apply9927[] = {1};
  meth_meth_ast__apply9927->type = alloc_MethodType(1, argcv_meth_ast__apply9927);
  meth_meth_ast__apply9927->definitionModule = modulename;
  meth_meth_ast__apply9927->definitionLine = 2565;
// compiled block node returning block9926 (depth = 4)
  gc_frame_newslot(block9926);
// call case 5: prelude request
  params[0] = call9925;
  params[1] = block9926;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9958 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9923);
// compiled call node returning call9958 (depth = 3)
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9961 = alloc_Boolean(0);
// compiled identifier node returning bool9961 (depth = 5)
  int op_slot_right_9960 = gc_frame_newslot(bool9961);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9964 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9963);
// compiled call node returning call9964 (depth = 6)
// compiled member node returning call9964 (depth = 5)
  int op_slot_left_9960 = gc_frame_newslot(call9964);
  params[0] = bool9961;
  partcv[0] = 1;
  Object opresult9965 = callmethod(call9964, "!=", 1, partcv, params);
// compiled op node returning opresult9965 (depth = 4)
  Object if9959 = done;
  if (istrue(opresult9965)) {
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9967 == NULL) {
    strlit9967 = alloc_String("");
    gc_root(strlit9967);
  }
// compiled string node returning strlit9967 (depth = 6)
  int op_slot_right_9966 = gc_frame_newslot(strlit9967);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9970 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9972 = alloc_Float64(1);
// compiled num node returning num9972 (depth = 9)
  int op_slot_right_9971 = gc_frame_newslot(num9972);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_9971 = gc_frame_newslot(*var_depth);
  params[0] = num9972;
  partcv[0] = 1;
  Object sum9974 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9974 (depth = 8)
  gc_frame_newslot(sum9974);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9975 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9976 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9975);
// compiled call node returning call9976 (depth = 9)
// compiled member node returning call9976 (depth = 8)
  params[0] = sum9974;
  partcv[0] = 1;
  Object call9977 = callmethod(call9976, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9970);
// compiled call node returning call9977 (depth = 7)
  int op_slot_right_9969 = gc_frame_newslot(call9977);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9980 == NULL) {
    strlit9980 = alloc_String("Vararg: ");
    gc_root(strlit9980);
  }
// compiled string node returning strlit9980 (depth = 8)
  int op_slot_right_9979 = gc_frame_newslot(strlit9980);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9982 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9985 == NULL) {
    strlit9985 = alloc_String("""\x0a""  ");
    gc_root(strlit9985);
  }
// compiled string node returning strlit9985 (depth = 10)
  int op_slot_right_9984 = gc_frame_newslot(strlit9985);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_9987 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit9989 == NULL) {
    strlit9989 = alloc_String("");
    gc_root(strlit9989);
  }
// compiled string node returning strlit9989 (depth = 11)
  int op_slot_left_9987 = gc_frame_newslot(strlit9989);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9990 = callmethod(strlit9989, "++", 1, partcv, params);
// compiled op node returning opresult9990 (depth = 10)
  int op_slot_left_9984 = gc_frame_newslot(opresult9990);
  params[0] = strlit9985;
  partcv[0] = 1;
  Object opresult9991 = callmethod(opresult9990, "++", 1, partcv, params);
// compiled op node returning opresult9991 (depth = 9)
  int op_slot_left_9982 = gc_frame_newslot(opresult9991);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9992 = callmethod(opresult9991, "++", 1, partcv, params);
// compiled op node returning opresult9992 (depth = 8)
  int op_slot_left_9979 = gc_frame_newslot(opresult9992);
  params[0] = strlit9980;
  partcv[0] = 1;
  Object opresult9993 = callmethod(opresult9992, "++", 1, partcv, params);
// compiled op node returning opresult9993 (depth = 7)
  int op_slot_left_9969 = gc_frame_newslot(opresult9993);
  params[0] = call9977;
  partcv[0] = 1;
  Object opresult9994 = callmethod(opresult9993, "++", 1, partcv, params);
// compiled op node returning opresult9994 (depth = 6)
  int op_slot_left_9966 = gc_frame_newslot(opresult9994);
  params[0] = strlit9967;
  partcv[0] = 1;
  Object opresult9995 = callmethod(opresult9994, "++", 1, partcv, params);
// compiled op node returning opresult9995 (depth = 5)
  *var_s = opresult9995;
  if (opresult9995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9959 = done;
  } else {
  }
// compiled if node returning if9959 (depth = 3)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9999 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10000 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9999);
// compiled call node returning call10000 (depth = 6)
// compiled member node returning call10000 (depth = 5)
  int op_slot_right_9998 = gc_frame_newslot(call10000);
// starting to compile identifier node (depth = 5)
  Object bool10002 = alloc_Boolean(0);
// compiled identifier node returning bool10002 (depth = 5)
  int op_slot_left_9998 = gc_frame_newslot(bool10002);
  params[0] = call10000;
  partcv[0] = 1;
  Object opresult10003 = callmethod(bool10002, "!=", 1, partcv, params);
// compiled op node returning opresult10003 (depth = 4)
  Object if9997 = done;
  if (istrue(opresult10003)) {
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10005 == NULL) {
    strlit10005 = alloc_String("");
    gc_root(strlit10005);
  }
// compiled string node returning strlit10005 (depth = 6)
  int op_slot_right_10004 = gc_frame_newslot(strlit10005);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10008 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10010 = alloc_Float64(1);
// compiled num node returning num10010 (depth = 9)
  int op_slot_right_10009 = gc_frame_newslot(num10010);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_10009 = gc_frame_newslot(*var_depth);
  params[0] = num10010;
  partcv[0] = 1;
  Object sum10012 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10012 (depth = 8)
  gc_frame_newslot(sum10012);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10014 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10013);
// compiled call node returning call10014 (depth = 9)
// compiled member node returning call10014 (depth = 8)
  params[0] = sum10012;
  partcv[0] = 1;
  Object call10015 = callmethod(call10014, "pretty",
    1, partcv, params);
  gc_frame_end(callframe10008);
// compiled call node returning call10015 (depth = 7)
  int op_slot_right_10007 = gc_frame_newslot(call10015);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10018 == NULL) {
    strlit10018 = alloc_String("TypeParams: ");
    gc_root(strlit10018);
  }
// compiled string node returning strlit10018 (depth = 8)
  int op_slot_right_10017 = gc_frame_newslot(strlit10018);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_10020 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10023 == NULL) {
    strlit10023 = alloc_String("""\x0a""  ");
    gc_root(strlit10023);
  }
// compiled string node returning strlit10023 (depth = 10)
  int op_slot_right_10022 = gc_frame_newslot(strlit10023);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_10025 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit10027 == NULL) {
    strlit10027 = alloc_String("");
    gc_root(strlit10027);
  }
// compiled string node returning strlit10027 (depth = 11)
  int op_slot_left_10025 = gc_frame_newslot(strlit10027);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10028 = callmethod(strlit10027, "++", 1, partcv, params);
// compiled op node returning opresult10028 (depth = 10)
  int op_slot_left_10022 = gc_frame_newslot(opresult10028);
  params[0] = strlit10023;
  partcv[0] = 1;
  Object opresult10029 = callmethod(opresult10028, "++", 1, partcv, params);
// compiled op node returning opresult10029 (depth = 9)
  int op_slot_left_10020 = gc_frame_newslot(opresult10029);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10030 = callmethod(opresult10029, "++", 1, partcv, params);
// compiled op node returning opresult10030 (depth = 8)
  int op_slot_left_10017 = gc_frame_newslot(opresult10030);
  params[0] = strlit10018;
  partcv[0] = 1;
  Object opresult10031 = callmethod(opresult10030, "++", 1, partcv, params);
// compiled op node returning opresult10031 (depth = 7)
  int op_slot_left_10007 = gc_frame_newslot(opresult10031);
  params[0] = call10015;
  partcv[0] = 1;
  Object opresult10032 = callmethod(opresult10031, "++", 1, partcv, params);
// compiled op node returning opresult10032 (depth = 6)
  int op_slot_left_10004 = gc_frame_newslot(opresult10032);
  params[0] = strlit10005;
  partcv[0] = 1;
  Object opresult10033 = callmethod(opresult10032, "++", 1, partcv, params);
// compiled op node returning opresult10033 (depth = 5)
  *var_s = opresult10033;
  if (opresult10033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9997 = done;
  } else {
  }
// compiled if node returning if9997 (depth = 3)
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10035(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10036 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10037 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10039 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10038);
// compiled call node returning call10039 (depth = 6)
// compiled member node returning call10039 (depth = 5)
  gc_frame_newslot(call10039);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10040 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10041 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10040);
// compiled call node returning call10041 (depth = 6)
// compiled member node returning call10041 (depth = 5)
  gc_frame_newslot(call10041);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10043 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10042);
// compiled call node returning call10043 (depth = 6)
// compiled member node returning call10043 (depth = 5)
  gc_frame_newslot(call10043);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signaturePart (depth = 5)
  params[0] = call10039;
  params[1] = call10041;
  params[2] = call10043;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10044 = callmethod(*var_signaturePart, "partName()params()variableParam",
    3, partcv, params);
  gc_frame_end(callframe10037);
// compiled call node returning call10044 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10045 = callmethod(call10044, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10036);
// compiled call node returning call10045 (depth = 3)
  gc_frame_end(frame);
  return call10045;
}
Object meth_ast_shallowCopyFieldsFrom10046(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10047 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10048 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10047);
// compiled call node returning call10048 (depth = 3)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10049 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10050 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10051 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe10050);
// compiled call node returning call10051 (depth = 5)
// compiled member node returning call10051 (depth = 4)
  gc_frame_newslot(call10051);
// call case 4: self request
  params[0] = call10051;
  partcv[0] = 1;
  Object call10052 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10049);
// compiled call node returning call10052 (depth = 3)
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString10053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10055 == NULL) {
    strlit10055 = alloc_String("");
    gc_root(strlit10055);
  }
// compiled string node returning strlit10055 (depth = 4)
  int op_slot_right_10054 = gc_frame_newslot(strlit10055);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10059 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10058);
// compiled call node returning call10059 (depth = 6)
// compiled member node returning call10059 (depth = 5)
  int op_slot_right_10057 = gc_frame_newslot(call10059);
// starting to compile string node (depth = 5)
  if (strlit10061 == NULL) {
    strlit10061 = alloc_String("part: ");
    gc_root(strlit10061);
  }
// compiled string node returning strlit10061 (depth = 5)
  int op_slot_left_10057 = gc_frame_newslot(strlit10061);
  params[0] = call10059;
  partcv[0] = 1;
  Object opresult10062 = callmethod(strlit10061, "++", 1, partcv, params);
// compiled op node returning opresult10062 (depth = 4)
  int op_slot_left_10054 = gc_frame_newslot(opresult10062);
  params[0] = strlit10055;
  partcv[0] = 1;
  Object opresult10063 = callmethod(opresult10062, "++", 1, partcv, params);
// compiled op node returning opresult10063 (depth = 3)
  gc_frame_end(frame);
  return opresult10063;
}
Object meth_ast_partName_40__41_params_40__41_variableParam9779(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName()params()variableParam");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName()params()variableParam (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *var_v = &(stackframe->slots[2]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for variableParam");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9780 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9780 = alloc_userobj2(18,14, objclass9780);
  gc_frame_newslot(obj9780);
if (objclass9780 == NULL) {
  glfree(obj9780->class->name);
  obj9780->class->name = "partName()params()variableParam";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9780, self, 0);
  addmethodreal(obj9780,"outer", &reader_ast_outer_9781);
  Object oldself9780 = self;
  struct StackFrameObject *oldstackframe9780 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9780);
  gc_frame_newslot((Object)stackframe);
  self = obj9780;
  Object *oldselfslot9780 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9780 = (*(struct UserObject *)self).data[0], lowerouter9780 = thisouter9780;
  if (inheritingObject9780) {
    struct UserObject *inho9780 = (struct UserObject *)inheritingObject9780;
    while (inho9780->super != GraceDefaultObject) inho9780 = (struct UserObject *)inho9780->super;
    inho9780->super = obj9780;
    self = inheritingObject9780;
    *selfslot = self;
    lowerouter9780 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9780;
  }
if (objclass9780 == NULL) {
  Method *reader9782 = addmethodrealflags(obj9780, "kind",&reader_ast_kind_9782, MFLAG_DEF);
  reader9782->definitionModule = modulename;
  reader9782->definitionLine = 2530;
}
adddatum2(obj9780, alloc_Undefined(), 1);
if (objclass9780 == NULL) {
  Method *reader9783 = addmethodrealflags(obj9780, "name",&reader_ast_name_9783, 0);
  Method *writer9783 = addmethodrealflags(obj9780, "name:=",&writer_ast_name_9783, 0);
  reader9783->definitionModule = modulename;
  writer9783->definitionModule = modulename;
  reader9783->definitionLine = 2531;
  writer9783->definitionLine = 2531;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 2);
if (objclass9780 == NULL) {
  Method *reader9784 = addmethodrealflags(obj9780, "params",&reader_ast_params_9784, 0);
  Method *writer9784 = addmethodrealflags(obj9780, "params:=",&writer_ast_params_9784, 0);
  reader9784->definitionModule = modulename;
  writer9784->definitionModule = modulename;
  reader9784->definitionLine = 2532;
  writer9784->definitionLine = 2532;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 3);
if (objclass9780 == NULL) {
  Method *reader9785 = addmethodrealflags(obj9780, "vararg",&reader_ast_vararg_9785, 0);
  Method *writer9785 = addmethodrealflags(obj9780, "vararg:=",&writer_ast_vararg_9785, 0);
  reader9785->definitionModule = modulename;
  writer9785->definitionModule = modulename;
  reader9785->definitionLine = 2533;
  writer9785->definitionLine = 2533;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 4);
if (objclass9780 == NULL) {
  Method *reader9786 = addmethodrealflags(obj9780, "typeParams",&reader_ast_typeParams_9786, 0);
  Method *writer9786 = addmethodrealflags(obj9780, "typeParams:=",&writer_ast_typeParams_9786, 0);
  reader9786->definitionModule = modulename;
  writer9786->definitionModule = modulename;
  reader9786->definitionLine = 2534;
  writer9786->definitionLine = 2534;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 5);
if (objclass9780 == NULL) {
  Method *reader9787 = addmethodrealflags(obj9780, "lineLength",&reader_ast_lineLength_9787, 0);
  Method *writer9787 = addmethodrealflags(obj9780, "lineLength:=",&writer_ast_lineLength_9787, 0);
  reader9787->definitionModule = modulename;
  writer9787->definitionModule = modulename;
  reader9787->definitionLine = 2535;
  writer9787->definitionLine = 2535;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 6);
// method "accept()from"
  struct UserObject *uo9788 = (struct UserObject*)obj9780;
  uo9788->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9788 = addmethod2pos(obj9780, "accept()from", &meth_ast_accept_40__41_from9788, 7);
  int argcv_meth_ast_accept_40__41_from9788[] = {1, 1};
  meth_meth_ast_accept_40__41_from9788->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9788);
  meth_meth_ast_accept_40__41_from9788->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9788->definitionLine = 2537;
// method "declarationKindWithAncestors"
  block_savedest(obj9780);
  Object closure9825 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9825, stackframe);
  addtoclosure(closure9825, var_k);
  struct UserObject *uo9825 = (struct UserObject*)obj9780;
  uo9825->data[8] = (Object)closure9825;
  Method *meth_meth_ast_declarationKindWithAncestors9825 = addmethod2pos(obj9780, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9825, 8);
  int argcv_meth_ast_declarationKindWithAncestors9825[] = {1};
  meth_meth_ast_declarationKindWithAncestors9825->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9825);
  meth_meth_ast_declarationKindWithAncestors9825->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9825->definitionLine = 2549;
// method "map()ancestors"
  struct UserObject *uo9828 = (struct UserObject*)obj9780;
  uo9828->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9828 = addmethod2pos(obj9780, "map()ancestors", &meth_ast_map_40__41_ancestors9828, 9);
  int argcv_meth_ast_map_40__41_ancestors9828[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9828->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9828);
  meth_meth_ast_map_40__41_ancestors9828->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9828->definitionLine = 2550;
// method "pretty"
  struct UserObject *uo9865 = (struct UserObject*)obj9780;
  uo9865->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty9865 = addmethod2pos(obj9780, "pretty", &meth_ast_pretty9865, 10);
  int argcv_meth_ast_pretty9865[] = {1};
  meth_meth_ast_pretty9865->type = alloc_MethodType(1, argcv_meth_ast_pretty9865);
  meth_meth_ast_pretty9865->definitionModule = modulename;
  meth_meth_ast_pretty9865->definitionLine = 2558;
// method "shallowCopy"
  block_savedest(obj9780);
  Object closure10035 = createclosure(1, "shallowCopy");
  setclosureframe(closure10035, stackframe);
  addtoclosure(closure10035, var_signaturePart);
  struct UserObject *uo10035 = (struct UserObject*)obj9780;
  uo10035->data[11] = (Object)closure10035;
  Method *meth_meth_ast_shallowCopy10035 = addmethod2pos(obj9780, "shallowCopy", &meth_ast_shallowCopy10035, 11);
  int argcv_meth_ast_shallowCopy10035[] = {0};
  meth_meth_ast_shallowCopy10035->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10035);
  meth_meth_ast_shallowCopy10035->definitionModule = modulename;
  meth_meth_ast_shallowCopy10035->definitionLine = 2576;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10046 = (struct UserObject*)obj9780;
  uo10046->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10046 = addmethod2pos(obj9780, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10046, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom10046[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10046->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10046);
  meth_meth_ast_shallowCopyFieldsFrom10046->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10046->definitionLine = 2580;
// method "asString"
  struct UserObject *uo10053 = (struct UserObject*)obj9780;
  uo10053->data[13] = emptyclosure;
  Method *meth_meth_ast_asString10053 = addmethod2pos(obj9780, "asString", &meth_ast_asString10053, 13);
  int argcv_meth_ast_asString10053[] = {0};
  meth_meth_ast_asString10053->type = alloc_MethodType(1, argcv_meth_ast_asString10053);
  meth_meth_ast_asString10053->definitionModule = modulename;
  meth_meth_ast_asString10053->definitionLine = 2585;
  sourceObject = obj9780;
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10064 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10065 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10066 = gc_frame_new();
// call case 3: self.outer request
  Object call10067 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10066);
// compiled call node returning call10067 (depth = 7)
// compiled member node returning call10067 (depth = 6)
  partcv[0] = 0;
  Object call10068 = callmethodflags(call10067, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10065);
// compiled call node returning call10068 (depth = 5)
// compiled member node returning call10068 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10069 = callmethodflags(call10068, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10064);
// compiled call node returning call10069 (depth = 3)
  struct UserObject *obj9780_uo = (struct UserObject *)obj9780;
  obj9780_uo->super = call10069;
  sourceObject = obj9780;
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10070 == NULL) {
    strlit10070 = alloc_String("signaturepart");
    gc_root(strlit10070);
  }
// compiled string node returning strlit10070 (depth = 3)
  adddatum2(obj9780, strlit10070, 1);
  sourceObject = obj9780;
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9780, *var_n, 2);
  sourceObject = obj9780;
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9780, *var_ps, 3);
  sourceObject = obj9780;
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj9780, *var_v, 4);
  sourceObject = obj9780;
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10071 = alloc_Boolean(0);
// compiled identifier node returning bool10071 (depth = 3)
  adddatum2(obj9780, bool10071, 5);
  sourceObject = obj9780;
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10072 = alloc_Float64(0);
// compiled num node returning num10072 (depth = 3)
  adddatum2(obj9780, num10072, 6);
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  objclass9780 = obj9780->class;
  objclass9780->definitionModule = modulename;
  objclass9780->definitionLine = 2528;
  (*(struct UserObject *)self).data[0] = lowerouter9780;
  self = oldself9780;
  selfslot = oldselfslot9780;
  stackframe = oldstackframe9780;
  gc_frame_end(frame);
  return obj9780;
}
Object meth_ast_partName_40__41_params_40__41_variableParam9779_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName()params()variableParam()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1] + argcv[2]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()object");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()variableParam()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName()params()variableParam (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *var_v = &(stackframe->slots[2]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for variableParam");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9780 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9780 = alloc_userobj2(18,14, objclass9780);
  gc_frame_newslot(obj9780);
if (objclass9780 == NULL) {
  glfree(obj9780->class->name);
  obj9780->class->name = "partName()params()variableParam";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9780, self, 0);
  addmethodreal(obj9780,"outer", &reader_ast_outer_9781);
  Object oldself9780 = self;
  struct StackFrameObject *oldstackframe9780 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9780);
  gc_frame_newslot((Object)stackframe);
  self = obj9780;
  Object *oldselfslot9780 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9780 = (*(struct UserObject *)self).data[0], lowerouter9780 = thisouter9780;
  if (inheritingObject9780) {
    struct UserObject *inho9780 = (struct UserObject *)inheritingObject9780;
    while (inho9780->super != GraceDefaultObject) inho9780 = (struct UserObject *)inho9780->super;
    inho9780->super = obj9780;
    self = inheritingObject9780;
    *selfslot = self;
    lowerouter9780 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9780;
  }
if (objclass9780 == NULL) {
  Method *reader9782 = addmethodrealflags(obj9780, "kind",&reader_ast_kind_9782, MFLAG_DEF);
  reader9782->definitionModule = modulename;
  reader9782->definitionLine = 2530;
}
adddatum2(obj9780, alloc_Undefined(), 1);
if (objclass9780 == NULL) {
  Method *reader9783 = addmethodrealflags(obj9780, "name",&reader_ast_name_9783, 0);
  Method *writer9783 = addmethodrealflags(obj9780, "name:=",&writer_ast_name_9783, 0);
  reader9783->definitionModule = modulename;
  writer9783->definitionModule = modulename;
  reader9783->definitionLine = 2531;
  writer9783->definitionLine = 2531;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 2);
if (objclass9780 == NULL) {
  Method *reader9784 = addmethodrealflags(obj9780, "params",&reader_ast_params_9784, 0);
  Method *writer9784 = addmethodrealflags(obj9780, "params:=",&writer_ast_params_9784, 0);
  reader9784->definitionModule = modulename;
  writer9784->definitionModule = modulename;
  reader9784->definitionLine = 2532;
  writer9784->definitionLine = 2532;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 3);
if (objclass9780 == NULL) {
  Method *reader9785 = addmethodrealflags(obj9780, "vararg",&reader_ast_vararg_9785, 0);
  Method *writer9785 = addmethodrealflags(obj9780, "vararg:=",&writer_ast_vararg_9785, 0);
  reader9785->definitionModule = modulename;
  writer9785->definitionModule = modulename;
  reader9785->definitionLine = 2533;
  writer9785->definitionLine = 2533;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 4);
if (objclass9780 == NULL) {
  Method *reader9786 = addmethodrealflags(obj9780, "typeParams",&reader_ast_typeParams_9786, 0);
  Method *writer9786 = addmethodrealflags(obj9780, "typeParams:=",&writer_ast_typeParams_9786, 0);
  reader9786->definitionModule = modulename;
  writer9786->definitionModule = modulename;
  reader9786->definitionLine = 2534;
  writer9786->definitionLine = 2534;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 5);
if (objclass9780 == NULL) {
  Method *reader9787 = addmethodrealflags(obj9780, "lineLength",&reader_ast_lineLength_9787, 0);
  Method *writer9787 = addmethodrealflags(obj9780, "lineLength:=",&writer_ast_lineLength_9787, 0);
  reader9787->definitionModule = modulename;
  writer9787->definitionModule = modulename;
  reader9787->definitionLine = 2535;
  writer9787->definitionLine = 2535;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 6);
// method "accept()from"
  struct UserObject *uo9788 = (struct UserObject*)obj9780;
  uo9788->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9788 = addmethod2pos(obj9780, "accept()from", &meth_ast_accept_40__41_from9788, 7);
  int argcv_meth_ast_accept_40__41_from9788[] = {1, 1};
  meth_meth_ast_accept_40__41_from9788->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9788);
  meth_meth_ast_accept_40__41_from9788->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9788->definitionLine = 2537;
// method "declarationKindWithAncestors"
  block_savedest(obj9780);
  Object closure9825 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9825, stackframe);
  addtoclosure(closure9825, var_k);
  struct UserObject *uo9825 = (struct UserObject*)obj9780;
  uo9825->data[8] = (Object)closure9825;
  Method *meth_meth_ast_declarationKindWithAncestors9825 = addmethod2pos(obj9780, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9825, 8);
  int argcv_meth_ast_declarationKindWithAncestors9825[] = {1};
  meth_meth_ast_declarationKindWithAncestors9825->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9825);
  meth_meth_ast_declarationKindWithAncestors9825->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9825->definitionLine = 2549;
// method "map()ancestors"
  struct UserObject *uo9828 = (struct UserObject*)obj9780;
  uo9828->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9828 = addmethod2pos(obj9780, "map()ancestors", &meth_ast_map_40__41_ancestors9828, 9);
  int argcv_meth_ast_map_40__41_ancestors9828[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9828->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9828);
  meth_meth_ast_map_40__41_ancestors9828->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9828->definitionLine = 2550;
// method "pretty"
  struct UserObject *uo9865 = (struct UserObject*)obj9780;
  uo9865->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty9865 = addmethod2pos(obj9780, "pretty", &meth_ast_pretty9865, 10);
  int argcv_meth_ast_pretty9865[] = {1};
  meth_meth_ast_pretty9865->type = alloc_MethodType(1, argcv_meth_ast_pretty9865);
  meth_meth_ast_pretty9865->definitionModule = modulename;
  meth_meth_ast_pretty9865->definitionLine = 2558;
// method "shallowCopy"
  block_savedest(obj9780);
  Object closure10035 = createclosure(1, "shallowCopy");
  setclosureframe(closure10035, stackframe);
  addtoclosure(closure10035, var_signaturePart);
  struct UserObject *uo10035 = (struct UserObject*)obj9780;
  uo10035->data[11] = (Object)closure10035;
  Method *meth_meth_ast_shallowCopy10035 = addmethod2pos(obj9780, "shallowCopy", &meth_ast_shallowCopy10035, 11);
  int argcv_meth_ast_shallowCopy10035[] = {0};
  meth_meth_ast_shallowCopy10035->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10035);
  meth_meth_ast_shallowCopy10035->definitionModule = modulename;
  meth_meth_ast_shallowCopy10035->definitionLine = 2576;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10046 = (struct UserObject*)obj9780;
  uo10046->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10046 = addmethod2pos(obj9780, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10046, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom10046[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10046->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10046);
  meth_meth_ast_shallowCopyFieldsFrom10046->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10046->definitionLine = 2580;
// method "asString"
  struct UserObject *uo10053 = (struct UserObject*)obj9780;
  uo10053->data[13] = emptyclosure;
  Method *meth_meth_ast_asString10053 = addmethod2pos(obj9780, "asString", &meth_ast_asString10053, 13);
  int argcv_meth_ast_asString10053[] = {0};
  meth_meth_ast_asString10053->type = alloc_MethodType(1, argcv_meth_ast_asString10053);
  meth_meth_ast_asString10053->definitionModule = modulename;
  meth_meth_ast_asString10053->definitionLine = 2585;
  sourceObject = obj9780;
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10064 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10065 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10066 = gc_frame_new();
// call case 3: self.outer request
  Object call10067 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10066);
// compiled call node returning call10067 (depth = 7)
// compiled member node returning call10067 (depth = 6)
  partcv[0] = 0;
  Object call10068 = callmethodflags(call10067, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10065);
// compiled call node returning call10068 (depth = 5)
// compiled member node returning call10068 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10069 = callmethodflags(call10068, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10064);
// compiled call node returning call10069 (depth = 3)
  struct UserObject *obj9780_uo = (struct UserObject *)obj9780;
  obj9780_uo->super = call10069;
  sourceObject = obj9780;
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10070 == NULL) {
    strlit10070 = alloc_String("signaturepart");
    gc_root(strlit10070);
  }
// compiled string node returning strlit10070 (depth = 3)
  adddatum2(obj9780, strlit10070, 1);
  sourceObject = obj9780;
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9780, *var_n, 2);
  sourceObject = obj9780;
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9780, *var_ps, 3);
  sourceObject = obj9780;
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj9780, *var_v, 4);
  sourceObject = obj9780;
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10071 = alloc_Boolean(0);
// compiled identifier node returning bool10071 (depth = 3)
  adddatum2(obj9780, bool10071, 5);
  sourceObject = obj9780;
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10072 = alloc_Float64(0);
// compiled num node returning num10072 (depth = 3)
  adddatum2(obj9780, num10072, 6);
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  objclass9780 = obj9780->class;
  objclass9780->definitionModule = modulename;
  objclass9780->definitionLine = 2528;
  (*(struct UserObject *)self).data[0] = lowerouter9780;
  self = oldself9780;
  selfslot = oldselfslot9780;
  stackframe = oldstackframe9780;
  gc_frame_end(frame);
  return obj9780;
}
Object meth_ast_signaturePart10074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for signaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for signaturePart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_new10077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10078 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10079 == NULL) {
    strlit10079 = alloc_String("");
    gc_root(strlit10079);
  }
// compiled string node returning strlit10079 (depth = 4)
  gc_frame_newslot(strlit10079);
// starting to compile array node (depth = 4)
  Object array10080 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10080 (depth = 4)
  gc_frame_newslot(array10080);
// call case 4: self request
  params[0] = strlit10079;
  params[1] = array10080;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10081 = callmethodflags(self, "request()withArgs", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10078);
// compiled call node returning call10081 (depth = 3)
  gc_frame_end(frame);
  return call10081;
}
Object meth_ast_request_40__41_withArgs_40__41_scope10082(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "request()withArgs()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()scope");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for request()withArgs()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for request");
  Object *var_argList = &(stackframe->slots[1]);
  *var_argList = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withArgs");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10083 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_argList (depth = 5)
  gc_frame_newslot(*var_argList);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10084 = callmethodflags(self, "request()withArgs", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10083);
// compiled call node returning call10084 (depth = 4)
  *var_result = call10084;
  if (call10084 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10085 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10086 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe10085);
// compiled call node returning call10086 (depth = 3)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_map_40__41_ancestors10094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10096 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10095);
// compiled call node returning call10096 (depth = 5)
// compiled member node returning call10096 (depth = 4)
  *var_n = call10096;
  if (call10096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10097 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10098 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe10097);
// compiled call node returning call10098 (depth = 4)
  *var_newChain = call10098;
  if (call10098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10099 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10100 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10102 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10101);
// compiled call node returning call10102 (depth = 6)
// compiled member node returning call10102 (depth = 5)
  gc_frame_newslot(call10102);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10103 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10104 = gc_frame_new();
// call case 3: self.outer request
  Object call10105 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10104);
// compiled call node returning call10105 (depth = 8)
// compiled member node returning call10105 (depth = 7)
  partcv[0] = 0;
  Object call10106 = callmethodflags(call10105, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10103);
// compiled call node returning call10106 (depth = 6)
// compiled member node returning call10106 (depth = 5)
  params[0] = call10102;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10107 = callmethodflags(call10106, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10100);
// compiled call node returning call10107 (depth = 4)
  gc_frame_newslot(call10107);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call10107;
  partcv[0] = 1;
  Object call10108 = callmethod(*var_n, "args:=",
    1, partcv, params);
  gc_frame_end(callframe10099);
// compiled call node returning call10108 (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10109 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10110 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe10109);
// compiled call node returning call10110 (depth = 3)
  gc_frame_end(frame);
  return call10110;
}
Object meth_ast__apply10119(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10121 == NULL) {
    strlit10121 = alloc_String("  ");
    gc_root(strlit10121);
  }
// compiled string node returning strlit10121 (depth = 7)
  int op_slot_right_10120 = gc_frame_newslot(strlit10121);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_10120 = gc_frame_newslot(*var_spc);
  params[0] = strlit10121;
  partcv[0] = 1;
  Object opresult10123 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10123 (depth = 6)
  *var_spc = opresult10123;
  if (opresult10123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10166(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10168 == NULL) {
    strlit10168 = alloc_String("");
    gc_root(strlit10168);
  }
// compiled string node returning strlit10168 (depth = 7)
  int op_slot_right_10167 = gc_frame_newslot(strlit10168);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10171 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10173 = alloc_Float64(4);
// compiled num node returning num10173 (depth = 10)
  int op_slot_right_10172 = gc_frame_newslot(num10173);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10172 = gc_frame_newslot(*var_depth);
  params[0] = num10173;
  partcv[0] = 1;
  Object sum10175 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10175 (depth = 9)
  gc_frame_newslot(sum10175);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = sum10175;
  partcv[0] = 1;
  Object call10176 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe10171);
// compiled call node returning call10176 (depth = 8)
  int op_slot_right_10170 = gc_frame_newslot(call10176);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10179 == NULL) {
    strlit10179 = alloc_String("");
    gc_root(strlit10179);
  }
// compiled string node returning strlit10179 (depth = 9)
  int op_slot_right_10178 = gc_frame_newslot(strlit10179);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10181 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10184 == NULL) {
    strlit10184 = alloc_String("""\x0a""    ");
    gc_root(strlit10184);
  }
// compiled string node returning strlit10184 (depth = 11)
  int op_slot_right_10183 = gc_frame_newslot(strlit10184);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10186 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10188 == NULL) {
    strlit10188 = alloc_String("");
    gc_root(strlit10188);
  }
// compiled string node returning strlit10188 (depth = 12)
  int op_slot_left_10186 = gc_frame_newslot(strlit10188);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10189 = callmethod(strlit10188, "++", 1, partcv, params);
// compiled op node returning opresult10189 (depth = 11)
  int op_slot_left_10183 = gc_frame_newslot(opresult10189);
  params[0] = strlit10184;
  partcv[0] = 1;
  Object opresult10190 = callmethod(opresult10189, "++", 1, partcv, params);
// compiled op node returning opresult10190 (depth = 10)
  int op_slot_left_10181 = gc_frame_newslot(opresult10190);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10191 = callmethod(opresult10190, "++", 1, partcv, params);
// compiled op node returning opresult10191 (depth = 9)
  int op_slot_left_10178 = gc_frame_newslot(opresult10191);
  params[0] = strlit10179;
  partcv[0] = 1;
  Object opresult10192 = callmethod(opresult10191, "++", 1, partcv, params);
// compiled op node returning opresult10192 (depth = 8)
  int op_slot_left_10170 = gc_frame_newslot(opresult10192);
  params[0] = call10176;
  partcv[0] = 1;
  Object opresult10193 = callmethod(opresult10192, "++", 1, partcv, params);
// compiled op node returning opresult10193 (depth = 7)
  int op_slot_left_10167 = gc_frame_newslot(opresult10193);
  params[0] = strlit10168;
  partcv[0] = 1;
  Object opresult10194 = callmethod(opresult10193, "++", 1, partcv, params);
// compiled op node returning opresult10194 (depth = 6)
  *var_s = opresult10194;
  if (opresult10194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty10111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10112 == NULL) {
    strlit10112 = alloc_String("");
    gc_root(strlit10112);
  }
// compiled string node returning strlit10112 (depth = 4)
  *var_spc = strlit10112;
  if (strlit10112 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10113 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10115 = alloc_Float64(1);
// compiled num node returning num10115 (depth = 5)
  int op_slot_right_10114 = gc_frame_newslot(num10115);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10114 = gc_frame_newslot(*var_depth);
  params[0] = num10115;
  partcv[0] = 1;
  Object sum10117 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum10117 (depth = 4)
  gc_frame_newslot(sum10117);
// starting to compile block node (depth = 4)
  Object block10118 = alloc_Block(NULL, NULL, "ast", 2615);
  gc_frame_newslot(block10118);
// method "_apply"
  block_savedest(block10118);
  Object closure10119 = createclosure(2, "_apply");
  setclosureframe(closure10119, stackframe);
  addtoclosure(closure10119, var_spc);
  addtoclosure(closure10119, selfslot);
  struct UserObject *uo10119 = (struct UserObject*)block10118;
  uo10119->data[0] = (Object)closure10119;
  Method *meth_meth_ast__apply10119 = addmethod2pos(block10118, "_apply", &meth_ast__apply10119, 0);
  int argcv_meth_ast__apply10119[] = {0};
  meth_meth_ast__apply10119->type = alloc_MethodType(1, argcv_meth_ast__apply10119);
  meth_meth_ast__apply10119->definitionModule = modulename;
  meth_meth_ast__apply10119->definitionLine = 2610;
// compiled block node returning block10118 (depth = 4)
  gc_frame_newslot(block10118);
// call case 5: prelude request
  params[0] = sum10117;
  params[1] = block10118;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10126 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10113);
// compiled call node returning call10126 (depth = 3)
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10128 == NULL) {
    strlit10128 = alloc_String("");
    gc_root(strlit10128);
  }
// compiled string node returning strlit10128 (depth = 5)
  int op_slot_right_10127 = gc_frame_newslot(strlit10128);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10132 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10131);
// compiled call node returning call10132 (depth = 7)
// compiled member node returning call10132 (depth = 6)
  int op_slot_right_10130 = gc_frame_newslot(call10132);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10135 == NULL) {
    strlit10135 = alloc_String(": ");
    gc_root(strlit10135);
  }
// compiled string node returning strlit10135 (depth = 7)
  int op_slot_right_10134 = gc_frame_newslot(strlit10135);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10138 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10139 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10138);
// compiled call node returning call10139 (depth = 8)
  int op_slot_right_10137 = gc_frame_newslot(call10139);
// starting to compile string node (depth = 8)
  if (strlit10141 == NULL) {
    strlit10141 = alloc_String("");
    gc_root(strlit10141);
  }
// compiled string node returning strlit10141 (depth = 8)
  int op_slot_left_10137 = gc_frame_newslot(strlit10141);
  params[0] = call10139;
  partcv[0] = 1;
  Object opresult10142 = callmethod(strlit10141, "++", 1, partcv, params);
// compiled op node returning opresult10142 (depth = 7)
  int op_slot_left_10134 = gc_frame_newslot(opresult10142);
  params[0] = strlit10135;
  partcv[0] = 1;
  Object opresult10143 = callmethod(opresult10142, "++", 1, partcv, params);
// compiled op node returning opresult10143 (depth = 6)
  int op_slot_left_10130 = gc_frame_newslot(opresult10143);
  params[0] = call10132;
  partcv[0] = 1;
  Object opresult10144 = callmethod(opresult10143, "++", 1, partcv, params);
// compiled op node returning opresult10144 (depth = 5)
  int op_slot_left_10127 = gc_frame_newslot(opresult10144);
  params[0] = strlit10128;
  partcv[0] = 1;
  Object opresult10145 = callmethod(opresult10144, "++", 1, partcv, params);
// compiled op node returning opresult10145 (depth = 4)
  *var_s = opresult10145;
  if (opresult10145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10147 == NULL) {
    strlit10147 = alloc_String("Args:");
    gc_root(strlit10147);
  }
// compiled string node returning strlit10147 (depth = 5)
  int op_slot_right_10146 = gc_frame_newslot(strlit10147);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_10149 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10152 == NULL) {
    strlit10152 = alloc_String("""\x0a""    ");
    gc_root(strlit10152);
  }
// compiled string node returning strlit10152 (depth = 7)
  int op_slot_right_10151 = gc_frame_newslot(strlit10152);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_10154 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit10156 == NULL) {
    strlit10156 = alloc_String("");
    gc_root(strlit10156);
  }
// compiled string node returning strlit10156 (depth = 8)
  int op_slot_left_10154 = gc_frame_newslot(strlit10156);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10157 = callmethod(strlit10156, "++", 1, partcv, params);
// compiled op node returning opresult10157 (depth = 7)
  int op_slot_left_10151 = gc_frame_newslot(opresult10157);
  params[0] = strlit10152;
  partcv[0] = 1;
  Object opresult10158 = callmethod(opresult10157, "++", 1, partcv, params);
// compiled op node returning opresult10158 (depth = 6)
  int op_slot_left_10149 = gc_frame_newslot(opresult10158);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10159 = callmethod(opresult10158, "++", 1, partcv, params);
// compiled op node returning opresult10159 (depth = 5)
  int op_slot_left_10146 = gc_frame_newslot(opresult10159);
  params[0] = strlit10147;
  partcv[0] = 1;
  Object opresult10160 = callmethod(opresult10159, "++", 1, partcv, params);
// compiled op node returning opresult10160 (depth = 4)
  *var_s = opresult10160;
  if (opresult10160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10162 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10164 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10163);
// compiled call node returning call10164 (depth = 5)
// compiled member node returning call10164 (depth = 4)
  gc_frame_newslot(call10164);
// starting to compile block node (depth = 4)
  Object block10165 = alloc_Block(NULL, NULL, "ast", 2620);
  gc_frame_newslot(block10165);
// method "_apply"
  block_savedest(block10165);
  Object closure10166 = createclosure(4, "_apply");
  setclosureframe(closure10166, stackframe);
  addtoclosure(closure10166, var_depth);
  addtoclosure(closure10166, var_spc);
  addtoclosure(closure10166, var_s);
  addtoclosure(closure10166, selfslot);
  struct UserObject *uo10166 = (struct UserObject*)block10165;
  uo10166->data[0] = (Object)closure10166;
  Method *meth_meth_ast__apply10166 = addmethod2pos(block10165, "_apply", &meth_ast__apply10166, 0);
  int argcv_meth_ast__apply10166[] = {1};
  meth_meth_ast__apply10166->type = alloc_MethodType(1, argcv_meth_ast__apply10166);
  meth_meth_ast__apply10166->definitionModule = modulename;
  meth_meth_ast__apply10166->definitionLine = 2620;
// compiled block node returning block10165 (depth = 4)
  gc_frame_newslot(block10165);
// call case 5: prelude request
  params[0] = call10164;
  params[1] = block10165;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10197 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10162);
// compiled call node returning call10197 (depth = 3)
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10199 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10200 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10202 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10201);
// compiled call node returning call10202 (depth = 6)
// compiled member node returning call10202 (depth = 5)
  gc_frame_newslot(call10202);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10203 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10204 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10203);
// compiled call node returning call10204 (depth = 6)
// compiled member node returning call10204 (depth = 5)
  gc_frame_newslot(call10204);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callWithPart (depth = 5)
  params[0] = call10202;
  params[1] = call10204;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10205 = callmethod(*var_callWithPart, "request()withArgs",
    2, partcv, params);
  gc_frame_end(callframe10200);
// compiled call node returning call10205 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10206 = callmethod(call10205, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10199);
// compiled call node returning call10206 (depth = 3)
  gc_frame_end(frame);
  return call10206;
}
Object meth_ast_shallowCopyFieldsFrom10207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10208 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10209 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10208);
// compiled call node returning call10209 (depth = 3)
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10210 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10212 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe10211);
// compiled call node returning call10212 (depth = 5)
// compiled member node returning call10212 (depth = 4)
  gc_frame_newslot(call10212);
// call case 4: self request
  params[0] = call10212;
  partcv[0] = 1;
  Object call10213 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10210);
// compiled call node returning call10213 (depth = 3)
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName10214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10215 == NULL) {
    strlit10215 = alloc_String("request");
    gc_root(strlit10215);
  }
// compiled string node returning strlit10215 (depth = 3)
  gc_frame_end(frame);
  return strlit10215;
}
Object meth_ast_request_40__41_withArgs10087(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request()withArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs");
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request()withArgs (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for request");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withArgs");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10088 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10088 = alloc_userobj2(12,10, objclass10088);
  gc_frame_newslot(obj10088);
if (objclass10088 == NULL) {
  glfree(obj10088->class->name);
  obj10088->class->name = "request()withArgs";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10088, self, 0);
  addmethodreal(obj10088,"outer", &reader_ast_outer_10089);
  Object oldself10088 = self;
  struct StackFrameObject *oldstackframe10088 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10088);
  gc_frame_newslot((Object)stackframe);
  self = obj10088;
  Object *oldselfslot10088 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10088 = (*(struct UserObject *)self).data[0], lowerouter10088 = thisouter10088;
  if (inheritingObject10088) {
    struct UserObject *inho10088 = (struct UserObject *)inheritingObject10088;
    while (inho10088->super != GraceDefaultObject) inho10088 = (struct UserObject *)inho10088->super;
    inho10088->super = obj10088;
    self = inheritingObject10088;
    *selfslot = self;
    lowerouter10088 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10088;
  }
if (objclass10088 == NULL) {
  Method *reader10090 = addmethodrealflags(obj10088, "kind",&reader_ast_kind_10090, MFLAG_DEF);
  reader10090->definitionModule = modulename;
  reader10090->definitionLine = 2602;
}
adddatum2(obj10088, alloc_Undefined(), 1);
if (objclass10088 == NULL) {
  Method *reader10091 = addmethodrealflags(obj10088, "name",&reader_ast_name_10091, 0);
  Method *writer10091 = addmethodrealflags(obj10088, "name:=",&writer_ast_name_10091, 0);
  reader10091->definitionModule = modulename;
  writer10091->definitionModule = modulename;
  reader10091->definitionLine = 2603;
  writer10091->definitionLine = 2603;
}
obj10088->flags |= OFLAG_MUTABLE;
adddatum2(obj10088, alloc_Undefined(), 2);
if (objclass10088 == NULL) {
  Method *reader10092 = addmethodrealflags(obj10088, "args",&reader_ast_args_10092, 0);
  Method *writer10092 = addmethodrealflags(obj10088, "args:=",&writer_ast_args_10092, 0);
  reader10092->definitionModule = modulename;
  writer10092->definitionModule = modulename;
  reader10092->definitionLine = 2604;
  writer10092->definitionLine = 2604;
}
obj10088->flags |= OFLAG_MUTABLE;
adddatum2(obj10088, alloc_Undefined(), 3);
if (objclass10088 == NULL) {
  Method *reader10093 = addmethodrealflags(obj10088, "lineLength",&reader_ast_lineLength_10093, 0);
  Method *writer10093 = addmethodrealflags(obj10088, "lineLength:=",&writer_ast_lineLength_10093, 0);
  reader10093->definitionModule = modulename;
  writer10093->definitionModule = modulename;
  reader10093->definitionLine = 2605;
  writer10093->definitionLine = 2605;
}
obj10088->flags |= OFLAG_MUTABLE;
adddatum2(obj10088, alloc_Undefined(), 4);
// method "map()ancestors"
  struct UserObject *uo10094 = (struct UserObject*)obj10088;
  uo10094->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10094 = addmethod2pos(obj10088, "map()ancestors", &meth_ast_map_40__41_ancestors10094, 5);
  int argcv_meth_ast_map_40__41_ancestors10094[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10094->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10094);
  meth_meth_ast_map_40__41_ancestors10094->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10094->definitionLine = 2607;
// method "pretty"
  struct UserObject *uo10111 = (struct UserObject*)obj10088;
  uo10111->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty10111 = addmethod2pos(obj10088, "pretty", &meth_ast_pretty10111, 6);
  int argcv_meth_ast_pretty10111[] = {1};
  meth_meth_ast_pretty10111->type = alloc_MethodType(1, argcv_meth_ast_pretty10111);
  meth_meth_ast_pretty10111->definitionModule = modulename;
  meth_meth_ast_pretty10111->definitionLine = 2613;
// method "shallowCopy"
  block_savedest(obj10088);
  Object closure10198 = createclosure(1, "shallowCopy");
  setclosureframe(closure10198, stackframe);
  addtoclosure(closure10198, var_callWithPart);
  struct UserObject *uo10198 = (struct UserObject*)obj10088;
  uo10198->data[7] = (Object)closure10198;
  Method *meth_meth_ast_shallowCopy10198 = addmethod2pos(obj10088, "shallowCopy", &meth_ast_shallowCopy10198, 7);
  int argcv_meth_ast_shallowCopy10198[] = {0};
  meth_meth_ast_shallowCopy10198->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10198);
  meth_meth_ast_shallowCopy10198->definitionModule = modulename;
  meth_meth_ast_shallowCopy10198->definitionLine = 2625;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10207 = (struct UserObject*)obj10088;
  uo10207->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10207 = addmethod2pos(obj10088, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10207, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom10207[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10207->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10207);
  meth_meth_ast_shallowCopyFieldsFrom10207->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10207->definitionLine = 2628;
// method "statementName"
  struct UserObject *uo10214 = (struct UserObject*)obj10088;
  uo10214->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName10214 = addmethod2pos(obj10088, "statementName", &meth_ast_statementName10214, 9);
  int argcv_meth_ast_statementName10214[] = {0};
  meth_meth_ast_statementName10214->type = alloc_MethodType(1, argcv_meth_ast_statementName10214);
  meth_meth_ast_statementName10214->definitionModule = modulename;
  meth_meth_ast_statementName10214->definitionLine = 2633;
  sourceObject = obj10088;
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10216 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10217 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10218 = gc_frame_new();
// call case 3: self.outer request
  Object call10219 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10218);
// compiled call node returning call10219 (depth = 7)
// compiled member node returning call10219 (depth = 6)
  partcv[0] = 0;
  Object call10220 = callmethodflags(call10219, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10217);
// compiled call node returning call10220 (depth = 5)
// compiled member node returning call10220 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10221 = callmethodflags(call10220, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10216);
// compiled call node returning call10221 (depth = 3)
  struct UserObject *obj10088_uo = (struct UserObject *)obj10088;
  obj10088_uo->super = call10221;
  sourceObject = obj10088;
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10222 == NULL) {
    strlit10222 = alloc_String("callwithpart");
    gc_root(strlit10222);
  }
// compiled string node returning strlit10222 (depth = 3)
  adddatum2(obj10088, strlit10222, 1);
  sourceObject = obj10088;
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10088, *var_rPart, 2);
  sourceObject = obj10088;
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10088, *var_xs, 3);
  sourceObject = obj10088;
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10223 = alloc_Float64(0);
// compiled num node returning num10223 (depth = 3)
  adddatum2(obj10088, num10223, 4);
  sourceObject = obj10088;
  sourceObject = obj10088;
  sourceObject = obj10088;
  sourceObject = obj10088;
  sourceObject = obj10088;
  objclass10088 = obj10088->class;
  objclass10088->definitionModule = modulename;
  objclass10088->definitionLine = 2600;
  (*(struct UserObject *)self).data[0] = lowerouter10088;
  self = oldself10088;
  selfslot = oldselfslot10088;
  stackframe = oldstackframe10088;
  gc_frame_end(frame);
  return obj10088;
}
Object meth_ast_request_40__41_withArgs10087_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request()withArgs()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()object");
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request()withArgs (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for request");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withArgs");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10088 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10088 = alloc_userobj2(12,10, objclass10088);
  gc_frame_newslot(obj10088);
if (objclass10088 == NULL) {
  glfree(obj10088->class->name);
  obj10088->class->name = "request()withArgs";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10088, self, 0);
  addmethodreal(obj10088,"outer", &reader_ast_outer_10089);
  Object oldself10088 = self;
  struct StackFrameObject *oldstackframe10088 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10088);
  gc_frame_newslot((Object)stackframe);
  self = obj10088;
  Object *oldselfslot10088 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10088 = (*(struct UserObject *)self).data[0], lowerouter10088 = thisouter10088;
  if (inheritingObject10088) {
    struct UserObject *inho10088 = (struct UserObject *)inheritingObject10088;
    while (inho10088->super != GraceDefaultObject) inho10088 = (struct UserObject *)inho10088->super;
    inho10088->super = obj10088;
    self = inheritingObject10088;
    *selfslot = self;
    lowerouter10088 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10088;
  }
if (objclass10088 == NULL) {
  Method *reader10090 = addmethodrealflags(obj10088, "kind",&reader_ast_kind_10090, MFLAG_DEF);
  reader10090->definitionModule = modulename;
  reader10090->definitionLine = 2602;
}
adddatum2(obj10088, alloc_Undefined(), 1);
if (objclass10088 == NULL) {
  Method *reader10091 = addmethodrealflags(obj10088, "name",&reader_ast_name_10091, 0);
  Method *writer10091 = addmethodrealflags(obj10088, "name:=",&writer_ast_name_10091, 0);
  reader10091->definitionModule = modulename;
  writer10091->definitionModule = modulename;
  reader10091->definitionLine = 2603;
  writer10091->definitionLine = 2603;
}
obj10088->flags |= OFLAG_MUTABLE;
adddatum2(obj10088, alloc_Undefined(), 2);
if (objclass10088 == NULL) {
  Method *reader10092 = addmethodrealflags(obj10088, "args",&reader_ast_args_10092, 0);
  Method *writer10092 = addmethodrealflags(obj10088, "args:=",&writer_ast_args_10092, 0);
  reader10092->definitionModule = modulename;
  writer10092->definitionModule = modulename;
  reader10092->definitionLine = 2604;
  writer10092->definitionLine = 2604;
}
obj10088->flags |= OFLAG_MUTABLE;
adddatum2(obj10088, alloc_Undefined(), 3);
if (objclass10088 == NULL) {
  Method *reader10093 = addmethodrealflags(obj10088, "lineLength",&reader_ast_lineLength_10093, 0);
  Method *writer10093 = addmethodrealflags(obj10088, "lineLength:=",&writer_ast_lineLength_10093, 0);
  reader10093->definitionModule = modulename;
  writer10093->definitionModule = modulename;
  reader10093->definitionLine = 2605;
  writer10093->definitionLine = 2605;
}
obj10088->flags |= OFLAG_MUTABLE;
adddatum2(obj10088, alloc_Undefined(), 4);
// method "map()ancestors"
  struct UserObject *uo10094 = (struct UserObject*)obj10088;
  uo10094->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10094 = addmethod2pos(obj10088, "map()ancestors", &meth_ast_map_40__41_ancestors10094, 5);
  int argcv_meth_ast_map_40__41_ancestors10094[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10094->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10094);
  meth_meth_ast_map_40__41_ancestors10094->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10094->definitionLine = 2607;
// method "pretty"
  struct UserObject *uo10111 = (struct UserObject*)obj10088;
  uo10111->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty10111 = addmethod2pos(obj10088, "pretty", &meth_ast_pretty10111, 6);
  int argcv_meth_ast_pretty10111[] = {1};
  meth_meth_ast_pretty10111->type = alloc_MethodType(1, argcv_meth_ast_pretty10111);
  meth_meth_ast_pretty10111->definitionModule = modulename;
  meth_meth_ast_pretty10111->definitionLine = 2613;
// method "shallowCopy"
  block_savedest(obj10088);
  Object closure10198 = createclosure(1, "shallowCopy");
  setclosureframe(closure10198, stackframe);
  addtoclosure(closure10198, var_callWithPart);
  struct UserObject *uo10198 = (struct UserObject*)obj10088;
  uo10198->data[7] = (Object)closure10198;
  Method *meth_meth_ast_shallowCopy10198 = addmethod2pos(obj10088, "shallowCopy", &meth_ast_shallowCopy10198, 7);
  int argcv_meth_ast_shallowCopy10198[] = {0};
  meth_meth_ast_shallowCopy10198->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10198);
  meth_meth_ast_shallowCopy10198->definitionModule = modulename;
  meth_meth_ast_shallowCopy10198->definitionLine = 2625;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10207 = (struct UserObject*)obj10088;
  uo10207->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10207 = addmethod2pos(obj10088, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10207, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom10207[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10207->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10207);
  meth_meth_ast_shallowCopyFieldsFrom10207->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10207->definitionLine = 2628;
// method "statementName"
  struct UserObject *uo10214 = (struct UserObject*)obj10088;
  uo10214->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName10214 = addmethod2pos(obj10088, "statementName", &meth_ast_statementName10214, 9);
  int argcv_meth_ast_statementName10214[] = {0};
  meth_meth_ast_statementName10214->type = alloc_MethodType(1, argcv_meth_ast_statementName10214);
  meth_meth_ast_statementName10214->definitionModule = modulename;
  meth_meth_ast_statementName10214->definitionLine = 2633;
  sourceObject = obj10088;
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10216 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10217 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10218 = gc_frame_new();
// call case 3: self.outer request
  Object call10219 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10218);
// compiled call node returning call10219 (depth = 7)
// compiled member node returning call10219 (depth = 6)
  partcv[0] = 0;
  Object call10220 = callmethodflags(call10219, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10217);
// compiled call node returning call10220 (depth = 5)
// compiled member node returning call10220 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10221 = callmethodflags(call10220, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10216);
// compiled call node returning call10221 (depth = 3)
  struct UserObject *obj10088_uo = (struct UserObject *)obj10088;
  obj10088_uo->super = call10221;
  sourceObject = obj10088;
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10222 == NULL) {
    strlit10222 = alloc_String("callwithpart");
    gc_root(strlit10222);
  }
// compiled string node returning strlit10222 (depth = 3)
  adddatum2(obj10088, strlit10222, 1);
  sourceObject = obj10088;
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10088, *var_rPart, 2);
  sourceObject = obj10088;
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10088, *var_xs, 3);
  sourceObject = obj10088;
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10223 = alloc_Float64(0);
// compiled num node returning num10223 (depth = 3)
  adddatum2(obj10088, num10223, 4);
  sourceObject = obj10088;
  sourceObject = obj10088;
  sourceObject = obj10088;
  sourceObject = obj10088;
  sourceObject = obj10088;
  objclass10088 = obj10088->class;
  objclass10088->definitionModule = modulename;
  objclass10088->definitionLine = 2600;
  (*(struct UserObject *)self).data[0] = lowerouter10088;
  self = oldself10088;
  selfslot = oldselfslot10088;
  stackframe = oldstackframe10088;
  gc_frame_end(frame);
  return obj10088;
}
Object meth_ast_callWithPart10225(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callWithPart (depth = 3)
  gc_frame_end(frame);
  return *var_callWithPart;
}
Object meth_ast_isComment10236(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isComment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isComment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10237 = alloc_Boolean(1);
// compiled identifier node returning bool10237 (depth = 3)
  gc_frame_end(frame);
  return bool10237;
}
Object meth_ast_isLegalInTrait10238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10239 = alloc_Boolean(1);
// compiled identifier node returning bool10239 (depth = 3)
  gc_frame_end(frame);
  return bool10239;
}
Object meth_ast_isExecutable10240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10241 = alloc_Boolean(0);
// compiled identifier node returning bool10241 (depth = 3)
  gc_frame_end(frame);
  return bool10241;
}
Object meth_ast_asString10242(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10244 == NULL) {
    strlit10244 = alloc_String("");
    gc_root(strlit10244);
  }
// compiled string node returning strlit10244 (depth = 4)
  int op_slot_right_10243 = gc_frame_newslot(strlit10244);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10248 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10247);
// compiled call node returning call10248 (depth = 6)
// compiled member node returning call10248 (depth = 5)
  int op_slot_right_10246 = gc_frame_newslot(call10248);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10251 == NULL) {
    strlit10251 = alloc_String("): ");
    gc_root(strlit10251);
  }
// compiled string node returning strlit10251 (depth = 6)
  int op_slot_right_10250 = gc_frame_newslot(strlit10251);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10255 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10254);
// compiled call node returning call10255 (depth = 8)
// compiled member node returning call10255 (depth = 7)
  int op_slot_right_10253 = gc_frame_newslot(call10255);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10258 == NULL) {
    strlit10258 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10258);
  }
// compiled string node returning strlit10258 (depth = 8)
  int op_slot_right_10257 = gc_frame_newslot(strlit10258);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10262 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10261);
// compiled call node returning call10262 (depth = 10)
// compiled member node returning call10262 (depth = 9)
  int op_slot_right_10260 = gc_frame_newslot(call10262);
// starting to compile string node (depth = 9)
  if (strlit10264 == NULL) {
    strlit10264 = alloc_String("comment (");
    gc_root(strlit10264);
  }
// compiled string node returning strlit10264 (depth = 9)
  int op_slot_left_10260 = gc_frame_newslot(strlit10264);
  params[0] = call10262;
  partcv[0] = 1;
  Object opresult10265 = callmethod(strlit10264, "++", 1, partcv, params);
// compiled op node returning opresult10265 (depth = 8)
  int op_slot_left_10257 = gc_frame_newslot(opresult10265);
  params[0] = strlit10258;
  partcv[0] = 1;
  Object opresult10266 = callmethod(opresult10265, "++", 1, partcv, params);
// compiled op node returning opresult10266 (depth = 7)
  int op_slot_left_10253 = gc_frame_newslot(opresult10266);
  params[0] = call10255;
  partcv[0] = 1;
  Object opresult10267 = callmethod(opresult10266, "++", 1, partcv, params);
// compiled op node returning opresult10267 (depth = 6)
  int op_slot_left_10250 = gc_frame_newslot(opresult10267);
  params[0] = strlit10251;
  partcv[0] = 1;
  Object opresult10268 = callmethod(opresult10267, "++", 1, partcv, params);
// compiled op node returning opresult10268 (depth = 5)
  int op_slot_left_10246 = gc_frame_newslot(opresult10268);
  params[0] = call10248;
  partcv[0] = 1;
  Object opresult10269 = callmethod(opresult10268, "++", 1, partcv, params);
// compiled op node returning opresult10269 (depth = 4)
  int op_slot_left_10243 = gc_frame_newslot(opresult10269);
  params[0] = strlit10244;
  partcv[0] = 1;
  Object opresult10270 = callmethod(opresult10269, "++", 1, partcv, params);
// compiled op node returning opresult10270 (depth = 3)
  gc_frame_end(frame);
  return opresult10270;
}
Object meth_ast_extendCommentUsing10271(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extendCommentUsing");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extendCommentUsing");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extendCommentUsing (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extendCommentUsing");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10272 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10274 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cmtNode (depth = 7)
  partcv[0] = 0;
  Object call10275 = callmethod(*var_cmtNode, "value",
    1, partcv, params);
  gc_frame_end(callframe10274);
// compiled call node returning call10275 (depth = 6)
// compiled member node returning call10275 (depth = 5)
  int op_slot_right_10273 = gc_frame_newslot(call10275);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10278 == NULL) {
    strlit10278 = alloc_String(" ");
    gc_root(strlit10278);
  }
// compiled string node returning strlit10278 (depth = 6)
  int op_slot_right_10277 = gc_frame_newslot(strlit10278);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10280 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10281 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10280);
// compiled call node returning call10281 (depth = 7)
// compiled member node returning call10281 (depth = 6)
  int op_slot_left_10277 = gc_frame_newslot(call10281);
  params[0] = strlit10278;
  partcv[0] = 1;
  Object opresult10282 = callmethod(call10281, "++", 1, partcv, params);
// compiled op node returning opresult10282 (depth = 5)
  int op_slot_left_10273 = gc_frame_newslot(opresult10282);
  params[0] = call10275;
  partcv[0] = 1;
  Object opresult10283 = callmethod(opresult10282, "++", 1, partcv, params);
// compiled op node returning opresult10283 (depth = 4)
  gc_frame_newslot(opresult10283);
// call case 4: self request
  params[0] = opresult10283;
  partcv[0] = 1;
  Object call10284 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10272);
// compiled call node returning call10284 (depth = 3)
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10285 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cmtNode (depth = 6)
  partcv[0] = 0;
  Object call10287 = callmethod(*var_cmtNode, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10286);
// compiled call node returning call10287 (depth = 5)
// compiled member node returning call10287 (depth = 4)
  gc_frame_newslot(call10287);
// call case 4: self request
  params[0] = call10287;
  partcv[0] = 1;
  Object call10288 = callmethodflags(self, "endLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10285);
// compiled call node returning call10288 (depth = 3)
  gc_frame_end(frame);
  return call10288;
}
Object meth_ast_map_40__41_ancestors10289(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10291 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10290);
// compiled call node returning call10291 (depth = 5)
// compiled member node returning call10291 (depth = 4)
  *var_n = call10291;
  if (call10291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10292 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10293 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe10292);
// compiled call node returning call10293 (depth = 4)
  *var_newChain = call10293;
  if (call10293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10294 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10295 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe10294);
// compiled call node returning call10295 (depth = 3)
  gc_frame_end(frame);
  return call10295;
}
Object meth_ast_accept_40__41_from10296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10297 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10298 = callmethod(*var_visitor, "visitComment()up",
    2, partcv, params);
  gc_frame_end(callframe10297);
// compiled call node returning call10298 (depth = 3)
  gc_frame_end(frame);
  return call10298;
}
Object meth_ast__apply10307(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10309 == NULL) {
    strlit10309 = alloc_String("  ");
    gc_root(strlit10309);
  }
// compiled string node returning strlit10309 (depth = 7)
  int op_slot_right_10308 = gc_frame_newslot(strlit10309);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10308 = gc_frame_newslot(*var_s);
  params[0] = strlit10309;
  partcv[0] = 1;
  Object opresult10311 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult10311 (depth = 6)
  *var_s = opresult10311;
  if (opresult10311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty10299(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_pb = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pb");
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10300 == NULL) {
    strlit10300 = alloc_String("""\x0a""");
    gc_root(strlit10300);
  }
// compiled string node returning strlit10300 (depth = 4)
  *var_s = strlit10300;
  if (strlit10300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10301 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10303 = alloc_Float64(1);
// compiled num node returning num10303 (depth = 5)
  int op_slot_right_10302 = gc_frame_newslot(num10303);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10302 = gc_frame_newslot(*var_depth);
  params[0] = num10303;
  partcv[0] = 1;
  Object diff10305 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff10305 (depth = 4)
  gc_frame_newslot(diff10305);
// starting to compile block node (depth = 4)
  Object block10306 = alloc_Block(NULL, NULL, "ast", 2663);
  gc_frame_newslot(block10306);
// method "_apply"
  block_savedest(block10306);
  Object closure10307 = createclosure(2, "_apply");
  setclosureframe(closure10307, stackframe);
  addtoclosure(closure10307, var_s);
  addtoclosure(closure10307, selfslot);
  struct UserObject *uo10307 = (struct UserObject*)block10306;
  uo10307->data[0] = (Object)closure10307;
  Method *meth_meth_ast__apply10307 = addmethod2pos(block10306, "_apply", &meth_ast__apply10307, 0);
  int argcv_meth_ast__apply10307[] = {0};
  meth_meth_ast__apply10307->type = alloc_MethodType(1, argcv_meth_ast__apply10307);
  meth_meth_ast__apply10307->definitionModule = modulename;
  meth_meth_ast__apply10307->definitionLine = 2654;
// compiled block node returning block10306 (depth = 4)
  gc_frame_newslot(block10306);
// call case 5: prelude request
  params[0] = diff10305;
  params[1] = block10306;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10314 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10301);
// compiled call node returning call10314 (depth = 3)
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10317 = callmethodflags(self, "isPreceededByBlankLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10316);
// compiled call node returning call10317 (depth = 6)
// compiled member node returning call10317 (depth = 5)
  Object if10315 = done;
struct StackFrameObject *iftmpstackframe10315 = stackframe;
  if (istrue(call10317)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10315);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10318 == NULL) {
    strlit10318 = alloc_String(" > blank");
    gc_root(strlit10318);
  }
// compiled string node returning strlit10318 (depth = 5)
    gc_frame_newslot(strlit10318);
    if10315 = strlit10318;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10315);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10319 == NULL) {
    strlit10319 = alloc_String("");
    gc_root(strlit10319);
  }
// compiled string node returning strlit10319 (depth = 5)
    gc_frame_newslot(strlit10319);
    if10315 = strlit10319;
  }
stackframe = iftmpstackframe10315;
// compiled if node returning if10315 (depth = 4)
  *var_pb = if10315;
  if (if10315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10321 == NULL) {
    strlit10321 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit10321);
  }
// compiled string node returning strlit10321 (depth = 4)
  int op_slot_right_10320 = gc_frame_newslot(strlit10321);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10325 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10324);
// compiled call node returning call10325 (depth = 6)
// compiled member node returning call10325 (depth = 5)
  int op_slot_right_10323 = gc_frame_newslot(call10325);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10328 == NULL) {
    strlit10328 = alloc_String("): ""\xe2""""\x80""""\xb9""");
    gc_root(strlit10328);
  }
// compiled string node returning strlit10328 (depth = 6)
  int op_slot_right_10327 = gc_frame_newslot(strlit10328);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10332 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10331);
// compiled call node returning call10332 (depth = 8)
// compiled member node returning call10332 (depth = 7)
  int op_slot_right_10330 = gc_frame_newslot(call10332);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10335 == NULL) {
    strlit10335 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10335);
  }
// compiled string node returning strlit10335 (depth = 8)
  int op_slot_right_10334 = gc_frame_newslot(strlit10335);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10339 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10338);
// compiled call node returning call10339 (depth = 10)
// compiled member node returning call10339 (depth = 9)
  int op_slot_right_10337 = gc_frame_newslot(call10339);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10342 == NULL) {
    strlit10342 = alloc_String("(");
    gc_root(strlit10342);
  }
// compiled string node returning strlit10342 (depth = 10)
  int op_slot_right_10341 = gc_frame_newslot(strlit10342);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pb (depth = 11)
  int op_slot_right_10344 = gc_frame_newslot(*var_pb);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10347 == NULL) {
    strlit10347 = alloc_String("Comment");
    gc_root(strlit10347);
  }
// compiled string node returning strlit10347 (depth = 12)
  int op_slot_right_10346 = gc_frame_newslot(strlit10347);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_10349 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit10351 == NULL) {
    strlit10351 = alloc_String("");
    gc_root(strlit10351);
  }
// compiled string node returning strlit10351 (depth = 13)
  int op_slot_left_10349 = gc_frame_newslot(strlit10351);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10352 = callmethod(strlit10351, "++", 1, partcv, params);
// compiled op node returning opresult10352 (depth = 12)
  int op_slot_left_10346 = gc_frame_newslot(opresult10352);
  params[0] = strlit10347;
  partcv[0] = 1;
  Object opresult10353 = callmethod(opresult10352, "++", 1, partcv, params);
// compiled op node returning opresult10353 (depth = 11)
  int op_slot_left_10344 = gc_frame_newslot(opresult10353);
  params[0] = *var_pb;
  partcv[0] = 1;
  Object opresult10354 = callmethod(opresult10353, "++", 1, partcv, params);
// compiled op node returning opresult10354 (depth = 10)
  int op_slot_left_10341 = gc_frame_newslot(opresult10354);
  params[0] = strlit10342;
  partcv[0] = 1;
  Object opresult10355 = callmethod(opresult10354, "++", 1, partcv, params);
// compiled op node returning opresult10355 (depth = 9)
  int op_slot_left_10337 = gc_frame_newslot(opresult10355);
  params[0] = call10339;
  partcv[0] = 1;
  Object opresult10356 = callmethod(opresult10355, "++", 1, partcv, params);
// compiled op node returning opresult10356 (depth = 8)
  int op_slot_left_10334 = gc_frame_newslot(opresult10356);
  params[0] = strlit10335;
  partcv[0] = 1;
  Object opresult10357 = callmethod(opresult10356, "++", 1, partcv, params);
// compiled op node returning opresult10357 (depth = 7)
  int op_slot_left_10330 = gc_frame_newslot(opresult10357);
  params[0] = call10332;
  partcv[0] = 1;
  Object opresult10358 = callmethod(opresult10357, "++", 1, partcv, params);
// compiled op node returning opresult10358 (depth = 6)
  int op_slot_left_10327 = gc_frame_newslot(opresult10358);
  params[0] = strlit10328;
  partcv[0] = 1;
  Object opresult10359 = callmethod(opresult10358, "++", 1, partcv, params);
// compiled op node returning opresult10359 (depth = 5)
  int op_slot_left_10323 = gc_frame_newslot(opresult10359);
  params[0] = call10325;
  partcv[0] = 1;
  Object opresult10360 = callmethod(opresult10359, "++", 1, partcv, params);
// compiled op node returning opresult10360 (depth = 4)
  int op_slot_left_10320 = gc_frame_newslot(opresult10360);
  params[0] = strlit10321;
  partcv[0] = 1;
  Object opresult10361 = callmethod(opresult10360, "++", 1, partcv, params);
// compiled op node returning opresult10361 (depth = 3)
  gc_frame_end(frame);
  return opresult10361;
}
Object meth_ast__apply10379(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10381 == NULL) {
    strlit10381 = alloc_String("    ");
    gc_root(strlit10381);
  }
// compiled string node returning strlit10381 (depth = 8)
  int op_slot_right_10380 = gc_frame_newslot(strlit10381);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_10380 = gc_frame_newslot(*var_spc);
  params[0] = strlit10381;
  partcv[0] = 1;
  Object opresult10383 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10383 (depth = 7)
  *var_spc = opresult10383;
  if (opresult10383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace10362(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[3];
  int partcv[3];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10364 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10365 = callmethodflags(self, "isPartialLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10364);
// compiled call node returning call10365 (depth = 5)
// compiled member node returning call10365 (depth = 4)
  Object if10363 = done;
  if (istrue(call10365)) {
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10367 == NULL) {
    strlit10367 = alloc_String("");
    gc_root(strlit10367);
  }
// compiled string node returning strlit10367 (depth = 5)
  int op_slot_right_10366 = gc_frame_newslot(strlit10367);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10371 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10370);
// compiled call node returning call10371 (depth = 7)
// compiled member node returning call10371 (depth = 6)
  int op_slot_right_10369 = gc_frame_newslot(call10371);
// starting to compile string node (depth = 6)
  if (strlit10373 == NULL) {
    strlit10373 = alloc_String("// (partial) ");
    gc_root(strlit10373);
  }
// compiled string node returning strlit10373 (depth = 6)
  int op_slot_left_10369 = gc_frame_newslot(strlit10373);
  params[0] = call10371;
  partcv[0] = 1;
  Object opresult10374 = callmethod(strlit10373, "++", 1, partcv, params);
// compiled op node returning opresult10374 (depth = 5)
  int op_slot_left_10366 = gc_frame_newslot(opresult10374);
  params[0] = strlit10367;
  partcv[0] = 1;
  Object opresult10375 = callmethod(opresult10374, "++", 1, partcv, params);
// compiled op node returning opresult10375 (depth = 4)
    gc_frame_newslot(opresult10375);
    if10363 = opresult10375;
  } else {
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10376 == NULL) {
    strlit10376 = alloc_String("");
    gc_root(strlit10376);
  }
// compiled string node returning strlit10376 (depth = 5)
  *var_spc = strlit10376;
  if (strlit10376 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10377 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block10378 = alloc_Block(NULL, NULL, "ast", 2676);
  gc_frame_newslot(block10378);
// method "_apply"
  block_savedest(block10378);
  Object closure10379 = createclosure(2, "_apply");
  setclosureframe(closure10379, stackframe);
  addtoclosure(closure10379, var_spc);
  addtoclosure(closure10379, selfslot);
  struct UserObject *uo10379 = (struct UserObject*)block10378;
  uo10379->data[0] = (Object)closure10379;
  Method *meth_meth_ast__apply10379 = addmethod2pos(block10378, "_apply", &meth_ast__apply10379, 0);
  int argcv_meth_ast__apply10379[] = {0};
  meth_meth_ast__apply10379->type = alloc_MethodType(1, argcv_meth_ast__apply10379);
  meth_meth_ast__apply10379->definitionModule = modulename;
  meth_meth_ast__apply10379->definitionLine = 2673;
// compiled block node returning block10378 (depth = 5)
  gc_frame_newslot(block10378);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block10378;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10386 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10377);
// compiled call node returning call10386 (depth = 4)
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10387 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10389 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10388);
// compiled call node returning call10389 (depth = 6)
// compiled member node returning call10389 (depth = 5)
  gc_frame_newslot(call10389);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineLength (depth = 5)
  gc_frame_newslot(*var_lineLength);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10391 == NULL) {
    strlit10391 = alloc_String("// ");
    gc_root(strlit10391);
  }
// compiled string node returning strlit10391 (depth = 6)
  int op_slot_right_10390 = gc_frame_newslot(strlit10391);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_10390 = gc_frame_newslot(*var_spc);
  params[0] = strlit10391;
  partcv[0] = 1;
  Object opresult10393 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10393 (depth = 5)
  gc_frame_newslot(opresult10393);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10394 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10395 = gc_frame_new();
// call case 3: self.outer request
  Object call10396 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10395);
// compiled call node returning call10396 (depth = 8)
// compiled member node returning call10396 (depth = 7)
  partcv[0] = 0;
  Object call10397 = callmethodflags(call10396, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10394);
// compiled call node returning call10397 (depth = 6)
// compiled member node returning call10397 (depth = 5)
  params[0] = call10389;
  params[1] = *var_lineLength;
  params[2] = opresult10393;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10398 = callmethodflags(call10397, "wrap()to()prefix", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10387);
// compiled call node returning call10398 (depth = 4)
    gc_frame_newslot(call10398);
    if10363 = call10398;
  }
// compiled if node returning if10363 (depth = 3)
  gc_frame_end(frame);
  return if10363;
}
Object meth_ast_shallowCopy10399(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_commentNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10400 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10401 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_commentNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call10402 = callmethod(*var_commentNode, "new",
    1, partcv, params);
  gc_frame_end(callframe10401);
// compiled call node returning call10402 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10403 = callmethod(call10402, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10400);
// compiled call node returning call10403 (depth = 3)
  gc_frame_end(frame);
  return call10403;
}
Object meth_ast_shallowCopyFieldsFrom10404(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10405 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10406 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10405);
// compiled call node returning call10406 (depth = 3)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10407 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10409 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe10408);
// compiled call node returning call10409 (depth = 5)
// compiled member node returning call10409 (depth = 4)
  gc_frame_newslot(call10409);
// call case 4: self request
  params[0] = call10409;
  partcv[0] = 1;
  Object call10410 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10407);
// compiled call node returning call10410 (depth = 3)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10411 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10413 = callmethod(*var_other, "isPartialLine",
    1, partcv, params);
  gc_frame_end(callframe10412);
// compiled call node returning call10413 (depth = 5)
// compiled member node returning call10413 (depth = 4)
  gc_frame_newslot(call10413);
// call case 4: self request
  params[0] = call10413;
  partcv[0] = 1;
  Object call10414 = callmethodflags(self, "isPartialLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10411);
// compiled call node returning call10414 (depth = 3)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10415 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10417 = callmethod(*var_other, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10416);
// compiled call node returning call10417 (depth = 5)
// compiled member node returning call10417 (depth = 4)
  gc_frame_newslot(call10417);
// call case 4: self request
  params[0] = call10417;
  partcv[0] = 1;
  Object call10418 = callmethodflags(self, "endLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10415);
// compiled call node returning call10418 (depth = 3)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new10228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10229 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10229 = alloc_userobj2(20,17, objclass10229);
  gc_frame_newslot(obj10229);
if (objclass10229 == NULL) {
  glfree(obj10229->class->name);
  obj10229->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10229, self, 0);
  addmethodreal(obj10229,"outer", &reader_ast_outer_10230);
  Object oldself10229 = self;
  struct StackFrameObject *oldstackframe10229 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10229);
  gc_frame_newslot((Object)stackframe);
  self = obj10229;
  Object *oldselfslot10229 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10229 = (*(struct UserObject *)self).data[0], lowerouter10229 = thisouter10229;
  if (inheritingObject10229) {
    struct UserObject *inho10229 = (struct UserObject *)inheritingObject10229;
    while (inho10229->super != GraceDefaultObject) inho10229 = (struct UserObject *)inho10229->super;
    inho10229->super = obj10229;
    self = inheritingObject10229;
    *selfslot = self;
    lowerouter10229 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10229;
  }
if (objclass10229 == NULL) {
  Method *reader10231 = addmethodrealflags(obj10229, "kind",&reader_ast_kind_10231, MFLAG_DEF);
  reader10231->definitionModule = modulename;
  reader10231->definitionLine = 2640;
}
adddatum2(obj10229, alloc_Undefined(), 1);
if (objclass10229 == NULL) {
  Method *reader10232 = addmethodrealflags(obj10229, "value",&reader_ast_value_10232, 0);
  Method *writer10232 = addmethodrealflags(obj10229, "value:=",&writer_ast_value_10232, 0);
  reader10232->definitionModule = modulename;
  writer10232->definitionModule = modulename;
  reader10232->definitionLine = 2641;
  writer10232->definitionLine = 2641;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 2);
if (objclass10229 == NULL) {
  Method *reader10233 = addmethodrealflags(obj10229, "isPartialLine",&reader_ast_isPartialLine_10233, 0);
  Method *writer10233 = addmethodrealflags(obj10229, "isPartialLine:=",&writer_ast_isPartialLine_10233, 0);
  reader10233->definitionModule = modulename;
  writer10233->definitionModule = modulename;
  reader10233->definitionLine = 2642;
  writer10233->definitionLine = 2642;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 3);
if (objclass10229 == NULL) {
  Method *reader10234 = addmethodrealflags(obj10229, "isPreceededByBlankLine",&reader_ast_isPreceededByBlankLine_10234, 0);
  Method *writer10234 = addmethodrealflags(obj10229, "isPreceededByBlankLine:=",&writer_ast_isPreceededByBlankLine_10234, 0);
  reader10234->definitionModule = modulename;
  writer10234->definitionModule = modulename;
  reader10234->definitionLine = 2643;
  writer10234->definitionLine = 2643;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 4);
if (objclass10229 == NULL) {
  Method *reader10235 = addmethodrealflags(obj10229, "endLine",&reader_ast_endLine_10235, 0);
  Method *writer10235 = addmethodrealflags(obj10229, "endLine:=",&writer_ast_endLine_10235, 0);
  reader10235->definitionModule = modulename;
  writer10235->definitionModule = modulename;
  reader10235->definitionLine = 2644;
  writer10235->definitionLine = 2644;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo10236 = (struct UserObject*)obj10229;
  uo10236->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10236 = addmethod2pos(obj10229, "isComment", &meth_ast_isComment10236, 6);
  int argcv_meth_ast_isComment10236[] = {0};
  meth_meth_ast_isComment10236->type = alloc_MethodType(1, argcv_meth_ast_isComment10236);
  meth_meth_ast_isComment10236->definitionModule = modulename;
  meth_meth_ast_isComment10236->definitionLine = 2645;
// method "isLegalInTrait"
  struct UserObject *uo10238 = (struct UserObject*)obj10229;
  uo10238->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait10238 = addmethod2pos(obj10229, "isLegalInTrait", &meth_ast_isLegalInTrait10238, 7);
  int argcv_meth_ast_isLegalInTrait10238[] = {0};
  meth_meth_ast_isLegalInTrait10238->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait10238);
  meth_meth_ast_isLegalInTrait10238->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait10238->definitionLine = 2646;
// method "isExecutable"
  struct UserObject *uo10240 = (struct UserObject*)obj10229;
  uo10240->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable10240 = addmethod2pos(obj10229, "isExecutable", &meth_ast_isExecutable10240, 8);
  int argcv_meth_ast_isExecutable10240[] = {0};
  meth_meth_ast_isExecutable10240->type = alloc_MethodType(1, argcv_meth_ast_isExecutable10240);
  meth_meth_ast_isExecutable10240->definitionModule = modulename;
  meth_meth_ast_isExecutable10240->definitionLine = 2647;
// method "asString"
  struct UserObject *uo10242 = (struct UserObject*)obj10229;
  uo10242->data[9] = emptyclosure;
  Method *meth_meth_ast_asString10242 = addmethod2pos(obj10229, "asString", &meth_ast_asString10242, 9);
  int argcv_meth_ast_asString10242[] = {0};
  meth_meth_ast_asString10242->type = alloc_MethodType(1, argcv_meth_ast_asString10242);
  meth_meth_ast_asString10242->definitionModule = modulename;
  meth_meth_ast_asString10242->definitionLine = 2648;
// method "extendCommentUsing"
  struct UserObject *uo10271 = (struct UserObject*)obj10229;
  uo10271->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing10271 = addmethod2pos(obj10229, "extendCommentUsing", &meth_ast_extendCommentUsing10271, 10);
  int argcv_meth_ast_extendCommentUsing10271[] = {1};
  meth_meth_ast_extendCommentUsing10271->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing10271);
  meth_meth_ast_extendCommentUsing10271->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing10271->definitionLine = 2649;
// method "map()ancestors"
  struct UserObject *uo10289 = (struct UserObject*)obj10229;
  uo10289->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10289 = addmethod2pos(obj10229, "map()ancestors", &meth_ast_map_40__41_ancestors10289, 11);
  int argcv_meth_ast_map_40__41_ancestors10289[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10289->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10289);
  meth_meth_ast_map_40__41_ancestors10289->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10289->definitionLine = 2653;
// method "accept()from"
  struct UserObject *uo10296 = (struct UserObject*)obj10229;
  uo10296->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from10296 = addmethod2pos(obj10229, "accept()from", &meth_ast_accept_40__41_from10296, 12);
  int argcv_meth_ast_accept_40__41_from10296[] = {1, 1};
  meth_meth_ast_accept_40__41_from10296->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from10296);
  meth_meth_ast_accept_40__41_from10296->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from10296->definitionLine = 2658;
// method "pretty"
  struct UserObject *uo10299 = (struct UserObject*)obj10229;
  uo10299->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty10299 = addmethod2pos(obj10229, "pretty", &meth_ast_pretty10299, 13);
  int argcv_meth_ast_pretty10299[] = {1};
  meth_meth_ast_pretty10299->type = alloc_MethodType(1, argcv_meth_ast_pretty10299);
  meth_meth_ast_pretty10299->definitionModule = modulename;
  meth_meth_ast_pretty10299->definitionLine = 2661;
// method "toGrace"
  block_savedest(obj10229);
  Object closure10362 = createclosure(1, "toGrace");
  setclosureframe(closure10362, stackframe);
  addtoclosure(closure10362, var_lineLength);
  struct UserObject *uo10362 = (struct UserObject*)obj10229;
  uo10362->data[14] = (Object)closure10362;
  Method *meth_meth_ast_toGrace10362 = addmethod2pos(obj10229, "toGrace", &meth_ast_toGrace10362, 14);
  int argcv_meth_ast_toGrace10362[] = {1};
  meth_meth_ast_toGrace10362->type = alloc_MethodType(1, argcv_meth_ast_toGrace10362);
  meth_meth_ast_toGrace10362->definitionModule = modulename;
  meth_meth_ast_toGrace10362->definitionLine = 2669;
// method "shallowCopy"
  block_savedest(obj10229);
  Object closure10399 = createclosure(2, "shallowCopy");
  setclosureframe(closure10399, stackframe);
  addtoclosure(closure10399, var_nullNode);
  addtoclosure(closure10399, var_commentNode);
  struct UserObject *uo10399 = (struct UserObject*)obj10229;
  uo10399->data[15] = (Object)closure10399;
  Method *meth_meth_ast_shallowCopy10399 = addmethod2pos(obj10229, "shallowCopy", &meth_ast_shallowCopy10399, 15);
  int argcv_meth_ast_shallowCopy10399[] = {0};
  meth_meth_ast_shallowCopy10399->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10399);
  meth_meth_ast_shallowCopy10399->definitionModule = modulename;
  meth_meth_ast_shallowCopy10399->definitionLine = 2680;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10404 = (struct UserObject*)obj10229;
  uo10404->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10404 = addmethod2pos(obj10229, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10404, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom10404[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10404->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10404);
  meth_meth_ast_shallowCopyFieldsFrom10404->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10404->definitionLine = 2683;
  sourceObject = obj10229;
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10419 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10420 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10421 = gc_frame_new();
// call case 3: self.outer request
  Object call10422 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10421);
// compiled call node returning call10422 (depth = 7)
// compiled member node returning call10422 (depth = 6)
  partcv[0] = 0;
  Object call10423 = callmethodflags(call10422, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10420);
// compiled call node returning call10423 (depth = 5)
// compiled member node returning call10423 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10424 = callmethodflags(call10423, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10419);
// compiled call node returning call10424 (depth = 3)
  struct UserObject *obj10229_uo = (struct UserObject *)obj10229;
  obj10229_uo->super = call10424;
  sourceObject = obj10229;
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10425 == NULL) {
    strlit10425 = alloc_String("comment");
    gc_root(strlit10425);
  }
// compiled string node returning strlit10425 (depth = 3)
  adddatum2(obj10229, strlit10425, 1);
  sourceObject = obj10229;
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10229, *var_val_39_, 2);
  sourceObject = obj10229;
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10426 = alloc_Boolean(0);
// compiled identifier node returning bool10426 (depth = 3)
  adddatum2(obj10229, bool10426, 3);
  sourceObject = obj10229;
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10427 = alloc_Boolean(0);
// compiled identifier node returning bool10427 (depth = 3)
  adddatum2(obj10229, bool10427, 4);
  sourceObject = obj10229;
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call10429 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe10428);
// compiled call node returning call10429 (depth = 4)
// compiled member node returning call10429 (depth = 3)
  adddatum2(obj10229, call10429, 5);
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  objclass10229 = obj10229->class;
  objclass10229->definitionModule = modulename;
  objclass10229->definitionLine = 2638;
  (*(struct UserObject *)self).data[0] = lowerouter10229;
  self = oldself10229;
  selfslot = oldselfslot10229;
  stackframe = oldstackframe10229;
  gc_frame_end(frame);
  return obj10229;
}
Object meth_ast_new10228_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10229 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10229 = alloc_userobj2(20,17, objclass10229);
  gc_frame_newslot(obj10229);
if (objclass10229 == NULL) {
  glfree(obj10229->class->name);
  obj10229->class->name = "new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10229, self, 0);
  addmethodreal(obj10229,"outer", &reader_ast_outer_10230);
  Object oldself10229 = self;
  struct StackFrameObject *oldstackframe10229 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10229);
  gc_frame_newslot((Object)stackframe);
  self = obj10229;
  Object *oldselfslot10229 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10229 = (*(struct UserObject *)self).data[0], lowerouter10229 = thisouter10229;
  if (inheritingObject10229) {
    struct UserObject *inho10229 = (struct UserObject *)inheritingObject10229;
    while (inho10229->super != GraceDefaultObject) inho10229 = (struct UserObject *)inho10229->super;
    inho10229->super = obj10229;
    self = inheritingObject10229;
    *selfslot = self;
    lowerouter10229 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10229;
  }
if (objclass10229 == NULL) {
  Method *reader10231 = addmethodrealflags(obj10229, "kind",&reader_ast_kind_10231, MFLAG_DEF);
  reader10231->definitionModule = modulename;
  reader10231->definitionLine = 2640;
}
adddatum2(obj10229, alloc_Undefined(), 1);
if (objclass10229 == NULL) {
  Method *reader10232 = addmethodrealflags(obj10229, "value",&reader_ast_value_10232, 0);
  Method *writer10232 = addmethodrealflags(obj10229, "value:=",&writer_ast_value_10232, 0);
  reader10232->definitionModule = modulename;
  writer10232->definitionModule = modulename;
  reader10232->definitionLine = 2641;
  writer10232->definitionLine = 2641;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 2);
if (objclass10229 == NULL) {
  Method *reader10233 = addmethodrealflags(obj10229, "isPartialLine",&reader_ast_isPartialLine_10233, 0);
  Method *writer10233 = addmethodrealflags(obj10229, "isPartialLine:=",&writer_ast_isPartialLine_10233, 0);
  reader10233->definitionModule = modulename;
  writer10233->definitionModule = modulename;
  reader10233->definitionLine = 2642;
  writer10233->definitionLine = 2642;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 3);
if (objclass10229 == NULL) {
  Method *reader10234 = addmethodrealflags(obj10229, "isPreceededByBlankLine",&reader_ast_isPreceededByBlankLine_10234, 0);
  Method *writer10234 = addmethodrealflags(obj10229, "isPreceededByBlankLine:=",&writer_ast_isPreceededByBlankLine_10234, 0);
  reader10234->definitionModule = modulename;
  writer10234->definitionModule = modulename;
  reader10234->definitionLine = 2643;
  writer10234->definitionLine = 2643;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 4);
if (objclass10229 == NULL) {
  Method *reader10235 = addmethodrealflags(obj10229, "endLine",&reader_ast_endLine_10235, 0);
  Method *writer10235 = addmethodrealflags(obj10229, "endLine:=",&writer_ast_endLine_10235, 0);
  reader10235->definitionModule = modulename;
  writer10235->definitionModule = modulename;
  reader10235->definitionLine = 2644;
  writer10235->definitionLine = 2644;
}
obj10229->flags |= OFLAG_MUTABLE;
adddatum2(obj10229, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo10236 = (struct UserObject*)obj10229;
  uo10236->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10236 = addmethod2pos(obj10229, "isComment", &meth_ast_isComment10236, 6);
  int argcv_meth_ast_isComment10236[] = {0};
  meth_meth_ast_isComment10236->type = alloc_MethodType(1, argcv_meth_ast_isComment10236);
  meth_meth_ast_isComment10236->definitionModule = modulename;
  meth_meth_ast_isComment10236->definitionLine = 2645;
// method "isLegalInTrait"
  struct UserObject *uo10238 = (struct UserObject*)obj10229;
  uo10238->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait10238 = addmethod2pos(obj10229, "isLegalInTrait", &meth_ast_isLegalInTrait10238, 7);
  int argcv_meth_ast_isLegalInTrait10238[] = {0};
  meth_meth_ast_isLegalInTrait10238->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait10238);
  meth_meth_ast_isLegalInTrait10238->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait10238->definitionLine = 2646;
// method "isExecutable"
  struct UserObject *uo10240 = (struct UserObject*)obj10229;
  uo10240->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable10240 = addmethod2pos(obj10229, "isExecutable", &meth_ast_isExecutable10240, 8);
  int argcv_meth_ast_isExecutable10240[] = {0};
  meth_meth_ast_isExecutable10240->type = alloc_MethodType(1, argcv_meth_ast_isExecutable10240);
  meth_meth_ast_isExecutable10240->definitionModule = modulename;
  meth_meth_ast_isExecutable10240->definitionLine = 2647;
// method "asString"
  struct UserObject *uo10242 = (struct UserObject*)obj10229;
  uo10242->data[9] = emptyclosure;
  Method *meth_meth_ast_asString10242 = addmethod2pos(obj10229, "asString", &meth_ast_asString10242, 9);
  int argcv_meth_ast_asString10242[] = {0};
  meth_meth_ast_asString10242->type = alloc_MethodType(1, argcv_meth_ast_asString10242);
  meth_meth_ast_asString10242->definitionModule = modulename;
  meth_meth_ast_asString10242->definitionLine = 2648;
// method "extendCommentUsing"
  struct UserObject *uo10271 = (struct UserObject*)obj10229;
  uo10271->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing10271 = addmethod2pos(obj10229, "extendCommentUsing", &meth_ast_extendCommentUsing10271, 10);
  int argcv_meth_ast_extendCommentUsing10271[] = {1};
  meth_meth_ast_extendCommentUsing10271->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing10271);
  meth_meth_ast_extendCommentUsing10271->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing10271->definitionLine = 2649;
// method "map()ancestors"
  struct UserObject *uo10289 = (struct UserObject*)obj10229;
  uo10289->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors10289 = addmethod2pos(obj10229, "map()ancestors", &meth_ast_map_40__41_ancestors10289, 11);
  int argcv_meth_ast_map_40__41_ancestors10289[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors10289->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors10289);
  meth_meth_ast_map_40__41_ancestors10289->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors10289->definitionLine = 2653;
// method "accept()from"
  struct UserObject *uo10296 = (struct UserObject*)obj10229;
  uo10296->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from10296 = addmethod2pos(obj10229, "accept()from", &meth_ast_accept_40__41_from10296, 12);
  int argcv_meth_ast_accept_40__41_from10296[] = {1, 1};
  meth_meth_ast_accept_40__41_from10296->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from10296);
  meth_meth_ast_accept_40__41_from10296->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from10296->definitionLine = 2658;
// method "pretty"
  struct UserObject *uo10299 = (struct UserObject*)obj10229;
  uo10299->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty10299 = addmethod2pos(obj10229, "pretty", &meth_ast_pretty10299, 13);
  int argcv_meth_ast_pretty10299[] = {1};
  meth_meth_ast_pretty10299->type = alloc_MethodType(1, argcv_meth_ast_pretty10299);
  meth_meth_ast_pretty10299->definitionModule = modulename;
  meth_meth_ast_pretty10299->definitionLine = 2661;
// method "toGrace"
  block_savedest(obj10229);
  Object closure10362 = createclosure(1, "toGrace");
  setclosureframe(closure10362, stackframe);
  addtoclosure(closure10362, var_lineLength);
  struct UserObject *uo10362 = (struct UserObject*)obj10229;
  uo10362->data[14] = (Object)closure10362;
  Method *meth_meth_ast_toGrace10362 = addmethod2pos(obj10229, "toGrace", &meth_ast_toGrace10362, 14);
  int argcv_meth_ast_toGrace10362[] = {1};
  meth_meth_ast_toGrace10362->type = alloc_MethodType(1, argcv_meth_ast_toGrace10362);
  meth_meth_ast_toGrace10362->definitionModule = modulename;
  meth_meth_ast_toGrace10362->definitionLine = 2669;
// method "shallowCopy"
  block_savedest(obj10229);
  Object closure10399 = createclosure(2, "shallowCopy");
  setclosureframe(closure10399, stackframe);
  addtoclosure(closure10399, var_nullNode);
  addtoclosure(closure10399, var_commentNode);
  struct UserObject *uo10399 = (struct UserObject*)obj10229;
  uo10399->data[15] = (Object)closure10399;
  Method *meth_meth_ast_shallowCopy10399 = addmethod2pos(obj10229, "shallowCopy", &meth_ast_shallowCopy10399, 15);
  int argcv_meth_ast_shallowCopy10399[] = {0};
  meth_meth_ast_shallowCopy10399->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10399);
  meth_meth_ast_shallowCopy10399->definitionModule = modulename;
  meth_meth_ast_shallowCopy10399->definitionLine = 2680;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10404 = (struct UserObject*)obj10229;
  uo10404->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10404 = addmethod2pos(obj10229, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10404, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom10404[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10404->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10404);
  meth_meth_ast_shallowCopyFieldsFrom10404->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10404->definitionLine = 2683;
  sourceObject = obj10229;
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10419 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10420 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10421 = gc_frame_new();
// call case 3: self.outer request
  Object call10422 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10421);
// compiled call node returning call10422 (depth = 7)
// compiled member node returning call10422 (depth = 6)
  partcv[0] = 0;
  Object call10423 = callmethodflags(call10422, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10420);
// compiled call node returning call10423 (depth = 5)
// compiled member node returning call10423 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10424 = callmethodflags(call10423, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10419);
// compiled call node returning call10424 (depth = 3)
  struct UserObject *obj10229_uo = (struct UserObject *)obj10229;
  obj10229_uo->super = call10424;
  sourceObject = obj10229;
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10425 == NULL) {
    strlit10425 = alloc_String("comment");
    gc_root(strlit10425);
  }
// compiled string node returning strlit10425 (depth = 3)
  adddatum2(obj10229, strlit10425, 1);
  sourceObject = obj10229;
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10229, *var_val_39_, 2);
  sourceObject = obj10229;
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10426 = alloc_Boolean(0);
// compiled identifier node returning bool10426 (depth = 3)
  adddatum2(obj10229, bool10426, 3);
  sourceObject = obj10229;
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10427 = alloc_Boolean(0);
// compiled identifier node returning bool10427 (depth = 3)
  adddatum2(obj10229, bool10427, 4);
  sourceObject = obj10229;
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call10429 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe10428);
// compiled call node returning call10429 (depth = 4)
// compiled member node returning call10429 (depth = 3)
  adddatum2(obj10229, call10429, 5);
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  sourceObject = obj10229;
  objclass10229 = obj10229->class;
  objclass10229->definitionModule = modulename;
  objclass10229->definitionLine = 2638;
  (*(struct UserObject *)self).data[0] = lowerouter10229;
  self = oldself10229;
  selfslot = oldselfslot10229;
  stackframe = oldstackframe10229;
  gc_frame_end(frame);
  return obj10229;
}
Object meth_ast_commentNode10431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "commentNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_commentNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for commentNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for commentNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_commentNode (depth = 3)
  gc_frame_end(frame);
  return *var_commentNode;
}
Object meth_ast_ASTVisitor10434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ASTVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ASTVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ASTVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitCall_40__41_up10437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10438 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10439 = alloc_Boolean(1);
// compiled identifier node returning bool10439 (depth = 4)
  gc_frame_newslot(bool10439);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  params[0] = bool10439;
  partcv[0] = 1;
  Object call10440 = callmethod(*var_c, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe10438);
// compiled call node returning call10440 (depth = 3)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10441 = alloc_Boolean(1);
// compiled identifier node returning bool10441 (depth = 3)
  gc_frame_end(frame);
  return bool10441;
}
Object meth_ast_patternMarkVisitor10446(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for patternMarkVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for patternMarkVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(58, 58);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(58, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[2];
  Object *var_util = alloc_var();
  Object *var_k = alloc_var();
  Object *var_lineLength = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineLength");
  Object *var_ancestorChain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ancestorChain");
  Object *var_emptySeq = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "AstNode");
  Object *var_SymbolTable = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "SymbolTable");
  Object *var_nullNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nullNode");
  Object *var_fakeSymbolTable = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "fakeSymbolTable");
  Object *var_ifNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "ifNode");
  Object *var_blockNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "blockNode");
  Object *var_tryCatchNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tryCatchNode");
  Object *var_matchCaseNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "methodNode");
  Object *var_callNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "callNode");
  Object *var_moduleNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "moduleNode");
  Object *var_objectNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "memberNode");
  Object *var_genericNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "genericNode");
  Object *var_typeParametersNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "typeParametersNode");
  Object *var_identifierNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "identifierNode");
  Object *var_typeType = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "typeType");
  Object *var_unknownType = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "unknownType");
  Object *var_stringNode = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "stringNode");
  Object *var_numNode = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "numNode");
  Object *var_opNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "opNode");
  Object *var_indexNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "indexNode");
  Object *var_bindNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "varDecNode");
  Object *var_importNode = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "importNode");
  Object *var_dialectNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "inheritsNode");
  Object *var_AliasPair = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "AliasPair");
  Object *var_blankNode = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "signaturePart");
  Object *var_callWithPart = &(stackframe->slots[40]);
  setframeelementname(stackframe, 40, "callWithPart");
  Object *var_commentNode = &(stackframe->slots[41]);
  setframeelementname(stackframe, 41, "commentNode");
  Object *var_ASTVisitor = &(stackframe->slots[42]);
  setframeelementname(stackframe, 42, "ASTVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[43]);
  setframeelementname(stackframe, 43, "patternMarkVisitor");
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "listMap()ancestors"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_ast_listMap_40__41_ancestors1 = addmethod2pos(self, "listMap()ancestors", &meth_ast_listMap_40__41_ancestors1, 1);
  int argcv_meth_ast_listMap_40__41_ancestors1[] = {2, 1};
  meth_meth_ast_listMap_40__41_ancestors1->type = alloc_MethodType(2, argcv_meth_ast_listMap_40__41_ancestors1);
  meth_meth_ast_listMap_40__41_ancestors1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_listMap_40__41_ancestors1->definitionModule = modulename;
  meth_meth_ast_listMap_40__41_ancestors1->definitionLine = 17;
// compiled method node returning  (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeMap()ancestors"
  struct UserObject *uo15 = (struct UserObject*)self;
  uo15->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap_40__41_ancestors15 = addmethod2pos(self, "maybeMap()ancestors", &meth_ast_maybeMap_40__41_ancestors15, 2);
  int argcv_meth_ast_maybeMap_40__41_ancestors15[] = {2, 1};
  meth_meth_ast_maybeMap_40__41_ancestors15->type = alloc_MethodType(2, argcv_meth_ast_maybeMap_40__41_ancestors15);
  meth_meth_ast_maybeMap_40__41_ancestors15->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeMap_40__41_ancestors15->definitionModule = modulename;
  meth_meth_ast_maybeMap_40__41_ancestors15->definitionLine = 22;
// compiled method node returning  (depth = 1)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeListMap()ancestors"
  struct UserObject *uo23 = (struct UserObject*)self;
  uo23->data[3] = emptyclosure;
  Method *meth_meth_ast_maybeListMap_40__41_ancestors23 = addmethod2pos(self, "maybeListMap()ancestors", &meth_ast_maybeListMap_40__41_ancestors23, 3);
  int argcv_meth_ast_maybeListMap_40__41_ancestors23[] = {2, 1};
  meth_meth_ast_maybeListMap_40__41_ancestors23->type = alloc_MethodType(2, argcv_meth_ast_maybeListMap_40__41_ancestors23);
  meth_meth_ast_maybeListMap_40__41_ancestors23->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeListMap_40__41_ancestors23->definitionModule = modulename;
  meth_meth_ast_maybeListMap_40__41_ancestors23->definitionLine = 29;
// compiled method node returning  (depth = 1)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseNode"
  block_savedest(self);
  Object closure31 = createclosure(4, "baseNode");
  setclosureframe(closure31, stackframe);
  addtoclosure(closure31, var_unknownType);
  addtoclosure(closure31, var_ancestorChain);
  addtoclosure(closure31, var_util);
  addtoclosure(closure31, var_fakeSymbolTable);
  struct UserObject *uo31 = (struct UserObject*)self;
  uo31->data[4] = (Object)closure31;
  Method *meth_meth_ast_baseNode31 = addmethod2pos(self, "baseNode", &meth_ast_baseNode31, 4);
  int argcv_meth_ast_baseNode31[] = {0};
  meth_meth_ast_baseNode31->type = alloc_MethodType(1, argcv_meth_ast_baseNode31);
  meth_meth_ast_baseNode31->definitionModule = modulename;
  meth_meth_ast_baseNode31->definitionLine = 85;
  block_savedest(self);
  Object closure403 = createclosure(4, "baseNode()object");
  setclosureframe(closure403, stackframe);
  addtoclosure(closure403, var_unknownType);
  addtoclosure(closure403, var_ancestorChain);
  addtoclosure(closure403, var_util);
  addtoclosure(closure403, var_fakeSymbolTable);
  Method *meth_meth_ast_baseNode31_object = addmethod2pos(self, "baseNode()object", &meth_ast_baseNode31_object, 4);
  meth_meth_ast_baseNode31_object->definitionModule = modulename;
  meth_meth_ast_baseNode31_object->definitionLine = 85;
// compiled method node returning  (depth = 1)
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "aliasNew()old"
  block_savedest(self);
  Object closure404 = createclosure(1, "aliasNew()old");
  setclosureframe(closure404, stackframe);
  addtoclosure(closure404, var_AliasPair);
  struct UserObject *uo404 = (struct UserObject*)self;
  uo404->data[5] = (Object)closure404;
  Method *meth_meth_ast_aliasNew_40__41_old404 = addmethod2pos(self, "aliasNew()old", &meth_ast_aliasNew_40__41_old404, 5);
  int argcv_meth_ast_aliasNew_40__41_old404[] = {1, 1};
  meth_meth_ast_aliasNew_40__41_old404->type = alloc_MethodType(2, argcv_meth_ast_aliasNew_40__41_old404);
  meth_meth_ast_aliasNew_40__41_old404->definitionModule = modulename;
  meth_meth_ast_aliasNew_40__41_old404->definitionLine = 2460;
  block_savedest(self);
  Object closure516 = createclosure(1, "aliasNew()old()object");
  setclosureframe(closure516, stackframe);
  addtoclosure(closure516, var_AliasPair);
  Method *meth_meth_ast_aliasNew_40__41_old404_object = addmethod2pos(self, "aliasNew()old()object", &meth_ast_aliasNew_40__41_old404_object, 5);
  meth_meth_ast_aliasNew_40__41_old404_object->definitionModule = modulename;
  meth_meth_ast_aliasNew_40__41_old404_object->definitionLine = 2460;
// compiled method node returning  (depth = 1)
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "wrap()to()prefix"
  struct UserObject *uo517 = (struct UserObject*)self;
  uo517->data[6] = emptyclosure;
  Method *meth_meth_ast_wrap_40__41_to_40__41_prefix517 = addmethod2pos(self, "wrap()to()prefix", &meth_ast_wrap_40__41_to_40__41_prefix517, 6);
  int argcv_meth_ast_wrap_40__41_to_40__41_prefix517[] = {1, 1, 1};
  meth_meth_ast_wrap_40__41_to_40__41_prefix517->type = alloc_MethodType(3, argcv_meth_ast_wrap_40__41_to_40__41_prefix517);
meth_meth_ast_wrap_40__41_to_40__41_prefix517->type->types[0] = type_String;
meth_meth_ast_wrap_40__41_to_40__41_prefix517->type->names[0] = "str";
meth_meth_ast_wrap_40__41_to_40__41_prefix517->type->types[1] = type_Number;
meth_meth_ast_wrap_40__41_to_40__41_prefix517->type->names[1] = "l";
meth_meth_ast_wrap_40__41_to_40__41_prefix517->type->types[2] = type_String;
meth_meth_ast_wrap_40__41_to_40__41_prefix517->type->names[2] = "margin";
  meth_meth_ast_wrap_40__41_to_40__41_prefix517->definitionModule = modulename;
  meth_meth_ast_wrap_40__41_to_40__41_prefix517->definitionLine = 2693;
// compiled method node returning  (depth = 1)
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseVisitor"
  struct UserObject *uo685 = (struct UserObject*)self;
  uo685->data[7] = emptyclosure;
  Method *meth_meth_ast_baseVisitor685 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor685, 7);
  int argcv_meth_ast_baseVisitor685[] = {0};
  meth_meth_ast_baseVisitor685->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor685);
  meth_meth_ast_baseVisitor685->definitionModule = modulename;
  meth_meth_ast_baseVisitor685->definitionLine = 2760;
  Method *meth_meth_ast_baseVisitor685_object = addmethod2pos(self, "baseVisitor()object", &meth_ast_baseVisitor685_object, 7);
  int argcv_meth_ast_baseVisitor685_object[] = {0};
  meth_meth_ast_baseVisitor685_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor685_object);
  meth_meth_ast_baseVisitor685_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor685_object->definitionLine = 2760;
// compiled method node returning  (depth = 1)
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pluggableVisitor"
  struct UserObject *uo841 = (struct UserObject*)self;
  uo841->data[8] = emptyclosure;
  Method *meth_meth_ast_pluggableVisitor841 = addmethod2pos(self, "pluggableVisitor", &meth_ast_pluggableVisitor841, 8);
  int argcv_meth_ast_pluggableVisitor841[] = {1};
  meth_meth_ast_pluggableVisitor841->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor841);
  meth_meth_ast_pluggableVisitor841->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor841->definitionLine = 2826;
  Method *meth_meth_ast_pluggableVisitor841_object = addmethod2pos(self, "pluggableVisitor()object", &meth_ast_pluggableVisitor841_object, 8);
  int argcv_meth_ast_pluggableVisitor841_object[] = {1};
  meth_meth_ast_pluggableVisitor841_object->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor841_object);
  meth_meth_ast_pluggableVisitor841_object->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor841_object->definitionLine = 2826;
// compiled method node returning  (depth = 1)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findAnnotation"
  struct UserObject *uo934 = (struct UserObject*)self;
  uo934->data[9] = emptyclosure;
  Method *meth_meth_ast_findAnnotation934 = addmethod2pos(self, "findAnnotation", &meth_ast_findAnnotation934, 9);
  int argcv_meth_ast_findAnnotation934[] = {2};
  meth_meth_ast_findAnnotation934->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation934);
  meth_meth_ast_findAnnotation934->definitionModule = modulename;
  meth_meth_ast_findAnnotation934->definitionLine = 2875;
// compiled method node returning  (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of identifierKinds as k
  if (module_identifierKinds == NULL)
    module_identifierKinds = LOAD_MODULE(identifierKinds);
  *var_k = module_identifierKinds;
// compiled import node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num964 = alloc_Float64(80);
// compiled num node returning num964 (depth = 2)
  *var_lineLength = num964;
  if (num964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lineLength"
  block_savedest(self);
  Object closure965 = createclosure(1, "lineLength");
  setclosureframe(closure965, stackframe);
  addtoclosure(closure965, var_lineLength);
  struct UserObject *uo965 = (struct UserObject*)self;
  uo965->data[10] = (Object)closure965;
  Method *meth_meth_ast_lineLength965 = addmethod2pos(self, "lineLength", &meth_ast_lineLength965, 10);
  int argcv_meth_ast_lineLength965[] = {0};
  meth_meth_ast_lineLength965->type = alloc_MethodType(1, argcv_meth_ast_lineLength965);
  meth_meth_ast_lineLength965->definitionModule = modulename;
  meth_meth_ast_lineLength965->definitionLine = 2877;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject966 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj966 = alloc_userobj2(5,6, objclass966);
  gc_frame_newslot(obj966);
// OBJECT OUTER DEC outer
  adddatum2(obj966, self, 0);
  addmethodreal(obj966,"outer", &reader_ast_outer_967);
  Object oldself966 = self;
  struct StackFrameObject *oldstackframe966 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe966);
  gc_frame_newslot((Object)stackframe);
  self = obj966;
  Object *oldselfslot966 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter966 = (*(struct UserObject *)self).data[0], lowerouter966 = thisouter966;
  if (inheritingObject966) {
    struct UserObject *inho966 = (struct UserObject *)inheritingObject966;
    while (inho966->super != GraceDefaultObject) inho966 = (struct UserObject *)inho966->super;
    inho966->super = obj966;
    self = inheritingObject966;
    *selfslot = self;
    lowerouter966 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter966;
  }
// method "empty"
  struct UserObject *uo968 = (struct UserObject*)obj966;
  uo968->data[1] = emptyclosure;
  Method *meth_meth_ast_empty968 = addmethod2pos(obj966, "empty", &meth_ast_empty968, 1);
  int argcv_meth_ast_empty968[] = {0};
  meth_meth_ast_empty968->type = alloc_MethodType(1, argcv_meth_ast_empty968);
  meth_meth_ast_empty968->definitionModule = modulename;
  meth_meth_ast_empty968->definitionLine = 38;
  Method *meth_meth_ast_empty968_object = addmethod2pos(obj966, "empty()object", &meth_ast_empty968_object, 1);
  int argcv_meth_ast_empty968_object[] = {0};
  meth_meth_ast_empty968_object->type = alloc_MethodType(1, argcv_meth_ast_empty968_object);
  meth_meth_ast_empty968_object->definitionModule = modulename;
  meth_meth_ast_empty968_object->definitionLine = 38;
// method "with"
  struct UserObject *uo981 = (struct UserObject*)obj966;
  uo981->data[2] = emptyclosure;
  Method *meth_meth_ast_with981 = addmethod2pos(obj966, "with", &meth_ast_with981, 2);
  int argcv_meth_ast_with981[] = {1};
  meth_meth_ast_with981->type = alloc_MethodType(1, argcv_meth_ast_with981);
  meth_meth_ast_with981->definitionModule = modulename;
  meth_meth_ast_with981->definitionLine = 43;
// method "cons()onto"
  struct UserObject *uo986 = (struct UserObject*)obj966;
  uo986->data[3] = emptyclosure;
  Method *meth_meth_ast_cons_40__41_onto986 = addmethod2pos(obj966, "cons()onto", &meth_ast_cons_40__41_onto986, 3);
  int argcv_meth_ast_cons_40__41_onto986[] = {1, 1};
  meth_meth_ast_cons_40__41_onto986->type = alloc_MethodType(2, argcv_meth_ast_cons_40__41_onto986);
  meth_meth_ast_cons_40__41_onto986->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40__41_onto986->definitionModule = modulename;
  meth_meth_ast_cons_40__41_onto986->definitionLine = 44;
  Method *meth_meth_ast_cons_40__41_onto986_object = addmethod2pos(obj966, "cons()onto()object", &meth_ast_cons_40__41_onto986_object, 3);
  int argcv_meth_ast_cons_40__41_onto986_object[] = {1, 1};
  meth_meth_ast_cons_40__41_onto986_object->type = alloc_MethodType(2, argcv_meth_ast_cons_40__41_onto986_object);
  meth_meth_ast_cons_40__41_onto986_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40__41_onto986_object->definitionModule = modulename;
  meth_meth_ast_cons_40__41_onto986_object->definitionLine = 44;
  sourceObject = obj966;
  sourceObject = obj966;
  sourceObject = obj966;
  objclass966 = obj966->class;
  objclass966->definitionModule = modulename;
  objclass966->definitionLine = 37;
  (*(struct UserObject *)self).data[0] = lowerouter966;
  self = oldself966;
  selfslot = oldselfslot966;
  stackframe = oldstackframe966;
// compiled object node returning obj966 (depth = 2)
  *var_ancestorChain = obj966;
  if (obj966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "ancestorChain"
  block_savedest(self);
  Object closure1035 = createclosure(1, "ancestorChain");
  setclosureframe(closure1035, stackframe);
  addtoclosure(closure1035, var_ancestorChain);
  struct UserObject *uo1035 = (struct UserObject*)self;
  uo1035->data[11] = (Object)closure1035;
  Method *meth_meth_ast_ancestorChain1035 = addmethod2pos(self, "ancestorChain", &meth_ast_ancestorChain1035, 11);
  int argcv_meth_ast_ancestorChain1035[] = {0};
  meth_meth_ast_ancestorChain1035->type = alloc_MethodType(1, argcv_meth_ast_ancestorChain1035);
  meth_meth_ast_ancestorChain1035->definitionModule = modulename;
  meth_meth_ast_ancestorChain1035->definitionLine = 59;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1036 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1037 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1038 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1037);
// compiled call node returning call1038 (depth = 5)
// compiled member node returning call1038 (depth = 4)
  partcv[0] = 0;
  Object call1039 = callmethod(call1038, "empty",
    1, partcv, params);
  gc_frame_end(callframe1036);
// compiled call node returning call1039 (depth = 3)
// compiled member node returning call1039 (depth = 2)
  *var_emptySeq = call1039;
  if (call1039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "emptySeq"
  block_savedest(self);
  Object closure1040 = createclosure(1, "emptySeq");
  setclosureframe(closure1040, stackframe);
  addtoclosure(closure1040, var_emptySeq);
  struct UserObject *uo1040 = (struct UserObject*)self;
  uo1040->data[12] = (Object)closure1040;
  Method *meth_meth_ast_emptySeq1040 = addmethod2pos(self, "emptySeq", &meth_ast_emptySeq1040, 12);
  int argcv_meth_ast_emptySeq1040[] = {0};
  meth_meth_ast_emptySeq1040->type = alloc_MethodType(1, argcv_meth_ast_emptySeq1040);
  meth_meth_ast_emptySeq1040->definitionModule = modulename;
  meth_meth_ast_emptySeq1040->definitionLine = 63;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type1042 = alloc_Type("AstNode", 9);
    add_Method((ClassData)type1042, "kind", NULL);
    add_Method((ClassData)type1042, "register", NULL);
    add_Method((ClassData)type1042, "line", NULL);
    add_Method((ClassData)type1042, "line:=", NULL);
    add_Method((ClassData)type1042, "linePos", NULL);
    add_Method((ClassData)type1042, "linePos:=", NULL);
    add_Method((ClassData)type1042, "scope", NULL);
    add_Method((ClassData)type1042, "pretty", NULL);
    add_Method((ClassData)type1042, "comments", NULL);
// compiled typeliteral node returning type1042 (depth = 2)
  *var_AstNode = type1042;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AstNode"
  block_savedest(self);
  Object closure1043 = createclosure(1, "AstNode");
  setclosureframe(closure1043, stackframe);
  addtoclosure(closure1043, var_AstNode);
  struct UserObject *uo1043 = (struct UserObject*)self;
  uo1043->data[13] = (Object)closure1043;
  Method *meth_meth_ast_AstNode1043 = addmethod2pos(self, "AstNode", &meth_ast_AstNode1043, 13);
  int argcv_meth_ast_AstNode1043[] = {0};
  meth_meth_ast_AstNode1043->type = alloc_MethodType(1, argcv_meth_ast_AstNode1043);
  meth_meth_ast_AstNode1043->definitionModule = modulename;
  meth_meth_ast_AstNode1043->definitionLine = 63;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SymbolTable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SymbolTable = *var_Unknown;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SymbolTable"
  block_savedest(self);
  Object closure1045 = createclosure(1, "SymbolTable");
  setclosureframe(closure1045, stackframe);
  addtoclosure(closure1045, var_SymbolTable);
  struct UserObject *uo1045 = (struct UserObject*)self;
  uo1045->data[14] = (Object)closure1045;
  Method *meth_meth_ast_SymbolTable1045 = addmethod2pos(self, "SymbolTable", &meth_ast_SymbolTable1045, 14);
  int argcv_meth_ast_SymbolTable1045[] = {0};
  meth_meth_ast_SymbolTable1045->type = alloc_MethodType(1, argcv_meth_ast_SymbolTable1045);
  meth_meth_ast_SymbolTable1045->definitionModule = modulename;
  meth_meth_ast_SymbolTable1045->definitionLine = 63;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1046 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1046 = alloc_userobj2(2,4, objclass1046);
  gc_frame_newslot(obj1046);
// OBJECT OUTER DEC outer
  adddatum2(obj1046, self, 0);
  addmethodreal(obj1046,"outer", &reader_ast_outer_1047);
  Object oldself1046 = self;
  struct StackFrameObject *oldstackframe1046 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1046);
  gc_frame_newslot((Object)stackframe);
  self = obj1046;
  Object *oldselfslot1046 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1046 = (*(struct UserObject *)self).data[0], lowerouter1046 = thisouter1046;
  if (inheritingObject1046) {
    struct UserObject *inho1046 = (struct UserObject *)inheritingObject1046;
    while (inho1046->super != GraceDefaultObject) inho1046 = (struct UserObject *)inho1046->super;
    inho1046->super = obj1046;
    self = inheritingObject1046;
    *selfslot = self;
    lowerouter1046 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1046;
  }
if (objclass1046 == NULL) {
  Method *reader1048 = addmethodrealflags(obj1046, "kind",&reader_ast_kind_1048, MFLAG_DEF);
  reader1048->definitionModule = modulename;
  reader1048->definitionLine = 188;
}
adddatum2(obj1046, alloc_Undefined(), 1);
// method "toGrace"
  struct UserObject *uo1049 = (struct UserObject*)obj1046;
  uo1049->data[2] = emptyclosure;
  Method *meth_meth_ast_toGrace1049 = addmethod2pos(obj1046, "toGrace", &meth_ast_toGrace1049, 2);
  int argcv_meth_ast_toGrace1049[] = {1};
  meth_meth_ast_toGrace1049->type = alloc_MethodType(1, argcv_meth_ast_toGrace1049);
  meth_meth_ast_toGrace1049->definitionModule = modulename;
  meth_meth_ast_toGrace1049->definitionLine = 189;
  sourceObject = obj1046;
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1051 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1052 = gc_frame_new();
// call case 3: self.outer request
  Object call1053 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1052);
// compiled call node returning call1053 (depth = 5)
// compiled member node returning call1053 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1054 = callmethodflags(call1053, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1051);
// compiled call node returning call1054 (depth = 3)
  struct UserObject *obj1046_uo = (struct UserObject *)obj1046;
  obj1046_uo->super = call1054;
  sourceObject = obj1046;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1055 == NULL) {
    strlit1055 = alloc_String("null");
    gc_root(strlit1055);
  }
// compiled string node returning strlit1055 (depth = 3)
  adddatum2(obj1046, strlit1055, 1);
  sourceObject = obj1046;
  objclass1046 = obj1046->class;
  objclass1046->definitionModule = modulename;
  objclass1046->definitionLine = 186;
  (*(struct UserObject *)self).data[0] = lowerouter1046;
  self = oldself1046;
  selfslot = oldselfslot1046;
  stackframe = oldstackframe1046;
// compiled object node returning obj1046 (depth = 2)
  *var_nullNode = obj1046;
  if (obj1046 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "nullNode"
  block_savedest(self);
  Object closure1056 = createclosure(1, "nullNode");
  setclosureframe(closure1056, stackframe);
  addtoclosure(closure1056, var_nullNode);
  struct UserObject *uo1056 = (struct UserObject*)self;
  uo1056->data[15] = (Object)closure1056;
  Method *meth_meth_ast_nullNode1056 = addmethod2pos(self, "nullNode", &meth_ast_nullNode1056, 15);
  int argcv_meth_ast_nullNode1056[] = {0};
  meth_meth_ast_nullNode1056->type = alloc_MethodType(1, argcv_meth_ast_nullNode1056);
  meth_meth_ast_nullNode1056->definitionModule = modulename;
  meth_meth_ast_nullNode1056->definitionLine = 187;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1057 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1057 = alloc_userobj2(7,7, objclass1057);
  gc_frame_newslot(obj1057);
// OBJECT OUTER DEC outer
  adddatum2(obj1057, self, 0);
  addmethodreal(obj1057,"outer", &reader_ast_outer_1058);
  Object oldself1057 = self;
  struct StackFrameObject *oldstackframe1057 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1057);
  gc_frame_newslot((Object)stackframe);
  self = obj1057;
  Object *oldselfslot1057 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1057 = (*(struct UserObject *)self).data[0], lowerouter1057 = thisouter1057;
  if (inheritingObject1057) {
    struct UserObject *inho1057 = (struct UserObject *)inheritingObject1057;
    while (inho1057->super != GraceDefaultObject) inho1057 = (struct UserObject *)inho1057->super;
    inho1057->super = obj1057;
    self = inheritingObject1057;
    *selfslot = self;
    lowerouter1057 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1057;
  }
if (objclass1057 == NULL) {
  Method *reader1059 = addmethodrealflags(obj1057, "node",&reader_ast_node_1059, 0);
  Method *writer1059 = addmethodrealflags(obj1057, "node:=",&writer_ast_node_1059, 0);
  reader1059->definitionModule = modulename;
  writer1059->definitionModule = modulename;
  reader1059->definitionLine = 195;
  writer1059->definitionLine = 195;
}
obj1057->flags |= OFLAG_MUTABLE;
adddatum2(obj1057, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo1060 = (struct UserObject*)obj1057;
  uo1060->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1060 = addmethod2pos(obj1057, "asString", &meth_ast_asString1060, 2);
  int argcv_meth_ast_asString1060[] = {0};
  meth_meth_ast_asString1060->type = alloc_MethodType(1, argcv_meth_ast_asString1060);
  meth_meth_ast_asString1060->definitionModule = modulename;
  meth_meth_ast_asString1060->definitionLine = 196;
// method "addNode()as"
  struct UserObject *uo1062 = (struct UserObject*)obj1057;
  uo1062->data[3] = emptyclosure;
  Method *meth_meth_ast_addNode_40__41_as1062 = addmethod2pos(obj1057, "addNode()as", &meth_ast_addNode_40__41_as1062, 3);
  int argcv_meth_ast_addNode_40__41_as1062[] = {1, 1};
  meth_meth_ast_addNode_40__41_as1062->type = alloc_MethodType(2, argcv_meth_ast_addNode_40__41_as1062);
  meth_meth_ast_addNode_40__41_as1062->definitionModule = modulename;
  meth_meth_ast_addNode_40__41_as1062->definitionLine = 197;
// method "thatDefines()ifNone"
  struct UserObject *uo1091 = (struct UserObject*)obj1057;
  uo1091->data[4] = emptyclosure;
  Method *meth_meth_ast_thatDefines_40__41_ifNone1091 = addmethod2pos(obj1057, "thatDefines()ifNone", &meth_ast_thatDefines_40__41_ifNone1091, 4);
  int argcv_meth_ast_thatDefines_40__41_ifNone1091[] = {1, 1};
  meth_meth_ast_thatDefines_40__41_ifNone1091->type = alloc_MethodType(2, argcv_meth_ast_thatDefines_40__41_ifNone1091);
  meth_meth_ast_thatDefines_40__41_ifNone1091->definitionModule = modulename;
  meth_meth_ast_thatDefines_40__41_ifNone1091->definitionLine = 200;
// method "enclosingObjectScope"
  struct UserObject *uo1104 = (struct UserObject*)obj1057;
  uo1104->data[5] = emptyclosure;
  Method *meth_meth_ast_enclosingObjectScope1104 = addmethod2pos(obj1057, "enclosingObjectScope", &meth_ast_enclosingObjectScope1104, 5);
  int argcv_meth_ast_enclosingObjectScope1104[] = {0};
  meth_meth_ast_enclosingObjectScope1104->type = alloc_MethodType(1, argcv_meth_ast_enclosingObjectScope1104);
  meth_meth_ast_enclosingObjectScope1104->definitionModule = modulename;
  meth_meth_ast_enclosingObjectScope1104->definitionLine = 203;
// method "variety"
  struct UserObject *uo1119 = (struct UserObject*)obj1057;
  uo1119->data[6] = emptyclosure;
  Method *meth_meth_ast_variety1119 = addmethod2pos(obj1057, "variety", &meth_ast_variety1119, 6);
  int argcv_meth_ast_variety1119[] = {0};
  meth_meth_ast_variety1119->type = alloc_MethodType(1, argcv_meth_ast_variety1119);
  meth_meth_ast_variety1119->definitionModule = modulename;
  meth_meth_ast_variety1119->definitionLine = 206;
  sourceObject = obj1057;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  adddatum2(obj1057, *var_nullNode, 1);
  sourceObject = obj1057;
  sourceObject = obj1057;
  sourceObject = obj1057;
  sourceObject = obj1057;
  sourceObject = obj1057;
  objclass1057 = obj1057->class;
  objclass1057->definitionModule = modulename;
  objclass1057->definitionLine = 194;
  (*(struct UserObject *)self).data[0] = lowerouter1057;
  self = oldself1057;
  selfslot = oldselfslot1057;
  stackframe = oldstackframe1057;
// compiled object node returning obj1057 (depth = 2)
  *var_fakeSymbolTable = obj1057;
  if (obj1057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "fakeSymbolTable"
  block_savedest(self);
  Object closure1121 = createclosure(1, "fakeSymbolTable");
  setclosureframe(closure1121, stackframe);
  addtoclosure(closure1121, var_fakeSymbolTable);
  struct UserObject *uo1121 = (struct UserObject*)self;
  uo1121->data[16] = (Object)closure1121;
  Method *meth_meth_ast_fakeSymbolTable1121 = addmethod2pos(self, "fakeSymbolTable", &meth_ast_fakeSymbolTable1121, 16);
  int argcv_meth_ast_fakeSymbolTable1121[] = {0};
  meth_meth_ast_fakeSymbolTable1121->type = alloc_MethodType(1, argcv_meth_ast_fakeSymbolTable1121);
  meth_meth_ast_fakeSymbolTable1121->definitionModule = modulename;
  meth_meth_ast_fakeSymbolTable1121->definitionLine = 204;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1122 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1122 = alloc_userobj2(2,4, objclass1122);
  gc_frame_newslot(obj1122);
// OBJECT OUTER DEC outer
  adddatum2(obj1122, self, 0);
  addmethodreal(obj1122,"outer", &reader_ast_outer_1123);
  Object oldself1122 = self;
  struct StackFrameObject *oldstackframe1122 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1122);
  gc_frame_newslot((Object)stackframe);
  self = obj1122;
  Object *oldselfslot1122 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1122 = (*(struct UserObject *)self).data[0], lowerouter1122 = thisouter1122;
  if (inheritingObject1122) {
    struct UserObject *inho1122 = (struct UserObject *)inheritingObject1122;
    while (inho1122->super != GraceDefaultObject) inho1122 = (struct UserObject *)inho1122->super;
    inho1122->super = obj1122;
    self = inheritingObject1122;
    *selfslot = self;
    lowerouter1122 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1122;
  }
// method "new"
  block_savedest(obj1122);
  Object closure1124 = createclosure(3, "new");
  setclosureframe(closure1124, stackframe);
  addtoclosure(closure1124, var_util);
  addtoclosure(closure1124, var_nullNode);
  addtoclosure(closure1124, var_ifNode);
  struct UserObject *uo1124 = (struct UserObject*)obj1122;
  uo1124->data[1] = (Object)closure1124;
  Method *meth_meth_ast_new1124 = addmethod2pos(obj1122, "new", &meth_ast_new1124, 1);
  int argcv_meth_ast_new1124[] = {3};
  meth_meth_ast_new1124->type = alloc_MethodType(1, argcv_meth_ast_new1124);
  meth_meth_ast_new1124->definitionModule = modulename;
  meth_meth_ast_new1124->definitionLine = 210;
  block_savedest(obj1122);
  Object closure1479 = createclosure(3, "new()object");
  setclosureframe(closure1479, stackframe);
  addtoclosure(closure1479, var_util);
  addtoclosure(closure1479, var_nullNode);
  addtoclosure(closure1479, var_ifNode);
  Method *meth_meth_ast_new1124_object = addmethod2pos(obj1122, "new()object", &meth_ast_new1124_object, 1);
  meth_meth_ast_new1124_object->definitionModule = modulename;
  meth_meth_ast_new1124_object->definitionLine = 210;
  sourceObject = obj1122;
  objclass1122 = obj1122->class;
  objclass1122->definitionModule = modulename;
  objclass1122->definitionLine = 209;
  (*(struct UserObject *)self).data[0] = lowerouter1122;
  self = oldself1122;
  selfslot = oldselfslot1122;
  stackframe = oldstackframe1122;
// compiled object node returning obj1122 (depth = 2)
  *var_ifNode = obj1122;
  if (obj1122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ifNode"
  block_savedest(self);
  Object closure1480 = createclosure(1, "ifNode");
  setclosureframe(closure1480, stackframe);
  addtoclosure(closure1480, var_ifNode);
  struct UserObject *uo1480 = (struct UserObject*)self;
  uo1480->data[17] = (Object)closure1480;
  Method *meth_meth_ast_ifNode1480 = addmethod2pos(self, "ifNode", &meth_ast_ifNode1480, 17);
  int argcv_meth_ast_ifNode1480[] = {0};
  meth_meth_ast_ifNode1480->type = alloc_MethodType(1, argcv_meth_ast_ifNode1480);
  meth_meth_ast_ifNode1480->definitionModule = modulename;
  meth_meth_ast_ifNode1480->definitionLine = 211;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1481 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1481 = alloc_userobj2(2,4, objclass1481);
  gc_frame_newslot(obj1481);
// OBJECT OUTER DEC outer
  adddatum2(obj1481, self, 0);
  addmethodreal(obj1481,"outer", &reader_ast_outer_1482);
  Object oldself1481 = self;
  struct StackFrameObject *oldstackframe1481 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1481);
  gc_frame_newslot((Object)stackframe);
  self = obj1481;
  Object *oldselfslot1481 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1481 = (*(struct UserObject *)self).data[0], lowerouter1481 = thisouter1481;
  if (inheritingObject1481) {
    struct UserObject *inho1481 = (struct UserObject *)inheritingObject1481;
    while (inho1481->super != GraceDefaultObject) inho1481 = (struct UserObject *)inho1481->super;
    inho1481->super = obj1481;
    self = inheritingObject1481;
    *selfslot = self;
    lowerouter1481 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1481;
  }
// method "new"
  block_savedest(obj1481);
  Object closure1483 = createclosure(4, "new");
  setclosureframe(closure1483, stackframe);
  addtoclosure(closure1483, var_k);
  addtoclosure(closure1483, var_blockNode);
  addtoclosure(closure1483, var_patternMarkVisitor);
  addtoclosure(closure1483, var_ancestorChain);
  struct UserObject *uo1483 = (struct UserObject*)obj1481;
  uo1483->data[1] = (Object)closure1483;
  Method *meth_meth_ast_new1483 = addmethod2pos(obj1481, "new", &meth_ast_new1483, 1);
  int argcv_meth_ast_new1483[] = {2};
  meth_meth_ast_new1483->type = alloc_MethodType(1, argcv_meth_ast_new1483);
  meth_meth_ast_new1483->definitionModule = modulename;
  meth_meth_ast_new1483->definitionLine = 287;
  block_savedest(obj1481);
  Object closure1938 = createclosure(4, "new()object");
  setclosureframe(closure1938, stackframe);
  addtoclosure(closure1938, var_k);
  addtoclosure(closure1938, var_blockNode);
  addtoclosure(closure1938, var_patternMarkVisitor);
  addtoclosure(closure1938, var_ancestorChain);
  Method *meth_meth_ast_new1483_object = addmethod2pos(obj1481, "new()object", &meth_ast_new1483_object, 1);
  meth_meth_ast_new1483_object->definitionModule = modulename;
  meth_meth_ast_new1483_object->definitionLine = 287;
  sourceObject = obj1481;
  objclass1481 = obj1481->class;
  objclass1481->definitionModule = modulename;
  objclass1481->definitionLine = 286;
  (*(struct UserObject *)self).data[0] = lowerouter1481;
  self = oldself1481;
  selfslot = oldselfslot1481;
  stackframe = oldstackframe1481;
// compiled object node returning obj1481 (depth = 2)
  *var_blockNode = obj1481;
  if (obj1481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blockNode"
  block_savedest(self);
  Object closure1939 = createclosure(1, "blockNode");
  setclosureframe(closure1939, stackframe);
  addtoclosure(closure1939, var_blockNode);
  struct UserObject *uo1939 = (struct UserObject*)self;
  uo1939->data[18] = (Object)closure1939;
  Method *meth_meth_ast_blockNode1939 = addmethod2pos(self, "blockNode", &meth_ast_blockNode1939, 18);
  int argcv_meth_ast_blockNode1939[] = {0};
  meth_meth_ast_blockNode1939->type = alloc_MethodType(1, argcv_meth_ast_blockNode1939);
  meth_meth_ast_blockNode1939->definitionModule = modulename;
  meth_meth_ast_blockNode1939->definitionLine = 288;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1940 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1940 = alloc_userobj2(2,4, objclass1940);
  gc_frame_newslot(obj1940);
// OBJECT OUTER DEC outer
  adddatum2(obj1940, self, 0);
  addmethodreal(obj1940,"outer", &reader_ast_outer_1941);
  Object oldself1940 = self;
  struct StackFrameObject *oldstackframe1940 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1940);
  gc_frame_newslot((Object)stackframe);
  self = obj1940;
  Object *oldselfslot1940 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1940 = (*(struct UserObject *)self).data[0], lowerouter1940 = thisouter1940;
  if (inheritingObject1940) {
    struct UserObject *inho1940 = (struct UserObject *)inheritingObject1940;
    while (inho1940->super != GraceDefaultObject) inho1940 = (struct UserObject *)inho1940->super;
    inho1940->super = obj1940;
    self = inheritingObject1940;
    *selfslot = self;
    lowerouter1940 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1940;
  }
// method "new"
  block_savedest(obj1940);
  Object closure1942 = createclosure(3, "new");
  setclosureframe(closure1942, stackframe);
  addtoclosure(closure1942, var_nullNode);
  addtoclosure(closure1942, var_emptySeq);
  addtoclosure(closure1942, var_tryCatchNode);
  struct UserObject *uo1942 = (struct UserObject*)obj1940;
  uo1942->data[1] = (Object)closure1942;
  Method *meth_meth_ast_new1942 = addmethod2pos(obj1940, "new", &meth_ast_new1942, 1);
  int argcv_meth_ast_new1942[] = {3};
  meth_meth_ast_new1942->type = alloc_MethodType(1, argcv_meth_ast_new1942);
  meth_meth_ast_new1942->definitionModule = modulename;
  meth_meth_ast_new1942->definitionLine = 404;
  block_savedest(obj1940);
  Object closure2250 = createclosure(3, "new()object");
  setclosureframe(closure2250, stackframe);
  addtoclosure(closure2250, var_nullNode);
  addtoclosure(closure2250, var_emptySeq);
  addtoclosure(closure2250, var_tryCatchNode);
  Method *meth_meth_ast_new1942_object = addmethod2pos(obj1940, "new()object", &meth_ast_new1942_object, 1);
  meth_meth_ast_new1942_object->definitionModule = modulename;
  meth_meth_ast_new1942_object->definitionLine = 404;
  sourceObject = obj1940;
  objclass1940 = obj1940->class;
  objclass1940->definitionModule = modulename;
  objclass1940->definitionLine = 403;
  (*(struct UserObject *)self).data[0] = lowerouter1940;
  self = oldself1940;
  selfslot = oldselfslot1940;
  stackframe = oldstackframe1940;
// compiled object node returning obj1940 (depth = 2)
  *var_tryCatchNode = obj1940;
  if (obj1940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tryCatchNode"
  block_savedest(self);
  Object closure2251 = createclosure(1, "tryCatchNode");
  setclosureframe(closure2251, stackframe);
  addtoclosure(closure2251, var_tryCatchNode);
  struct UserObject *uo2251 = (struct UserObject*)self;
  uo2251->data[19] = (Object)closure2251;
  Method *meth_meth_ast_tryCatchNode2251 = addmethod2pos(self, "tryCatchNode", &meth_ast_tryCatchNode2251, 19);
  int argcv_meth_ast_tryCatchNode2251[] = {0};
  meth_meth_ast_tryCatchNode2251->type = alloc_MethodType(1, argcv_meth_ast_tryCatchNode2251);
  meth_meth_ast_tryCatchNode2251->definitionModule = modulename;
  meth_meth_ast_tryCatchNode2251->definitionLine = 405;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2252 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2252 = alloc_userobj2(2,4, objclass2252);
  gc_frame_newslot(obj2252);
// OBJECT OUTER DEC outer
  adddatum2(obj2252, self, 0);
  addmethodreal(obj2252,"outer", &reader_ast_outer_2253);
  Object oldself2252 = self;
  struct StackFrameObject *oldstackframe2252 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2252);
  gc_frame_newslot((Object)stackframe);
  self = obj2252;
  Object *oldselfslot2252 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2252 = (*(struct UserObject *)self).data[0], lowerouter2252 = thisouter2252;
  if (inheritingObject2252) {
    struct UserObject *inho2252 = (struct UserObject *)inheritingObject2252;
    while (inho2252->super != GraceDefaultObject) inho2252 = (struct UserObject *)inho2252->super;
    inho2252->super = obj2252;
    self = inheritingObject2252;
    *selfslot = self;
    lowerouter2252 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2252;
  }
// method "new"
  block_savedest(obj2252);
  Object closure2254 = createclosure(3, "new");
  setclosureframe(closure2254, stackframe);
  addtoclosure(closure2254, var_nullNode);
  addtoclosure(closure2254, var_emptySeq);
  addtoclosure(closure2254, var_matchCaseNode);
  struct UserObject *uo2254 = (struct UserObject*)obj2252;
  uo2254->data[1] = (Object)closure2254;
  Method *meth_meth_ast_new2254 = addmethod2pos(obj2252, "new", &meth_ast_new2254, 1);
  int argcv_meth_ast_new2254[] = {3};
  meth_meth_ast_new2254->type = alloc_MethodType(1, argcv_meth_ast_new2254);
  meth_meth_ast_new2254->definitionModule = modulename;
  meth_meth_ast_new2254->definitionLine = 467;
  block_savedest(obj2252);
  Object closure2558 = createclosure(3, "new()object");
  setclosureframe(closure2558, stackframe);
  addtoclosure(closure2558, var_nullNode);
  addtoclosure(closure2558, var_emptySeq);
  addtoclosure(closure2558, var_matchCaseNode);
  Method *meth_meth_ast_new2254_object = addmethod2pos(obj2252, "new()object", &meth_ast_new2254_object, 1);
  meth_meth_ast_new2254_object->definitionModule = modulename;
  meth_meth_ast_new2254_object->definitionLine = 467;
  sourceObject = obj2252;
  objclass2252 = obj2252->class;
  objclass2252->definitionModule = modulename;
  objclass2252->definitionLine = 466;
  (*(struct UserObject *)self).data[0] = lowerouter2252;
  self = oldself2252;
  selfslot = oldselfslot2252;
  stackframe = oldstackframe2252;
// compiled object node returning obj2252 (depth = 2)
  *var_matchCaseNode = obj2252;
  if (obj2252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "matchCaseNode"
  block_savedest(self);
  Object closure2559 = createclosure(1, "matchCaseNode");
  setclosureframe(closure2559, stackframe);
  addtoclosure(closure2559, var_matchCaseNode);
  struct UserObject *uo2559 = (struct UserObject*)self;
  uo2559->data[20] = (Object)closure2559;
  Method *meth_meth_ast_matchCaseNode2559 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode2559, 20);
  int argcv_meth_ast_matchCaseNode2559[] = {0};
  meth_meth_ast_matchCaseNode2559->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode2559);
  meth_meth_ast_matchCaseNode2559->definitionModule = modulename;
  meth_meth_ast_matchCaseNode2559->definitionLine = 468;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2560 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2560 = alloc_userobj2(2,4, objclass2560);
  gc_frame_newslot(obj2560);
// OBJECT OUTER DEC outer
  adddatum2(obj2560, self, 0);
  addmethodreal(obj2560,"outer", &reader_ast_outer_2561);
  Object oldself2560 = self;
  struct StackFrameObject *oldstackframe2560 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2560);
  gc_frame_newslot((Object)stackframe);
  self = obj2560;
  Object *oldselfslot2560 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2560 = (*(struct UserObject *)self).data[0], lowerouter2560 = thisouter2560;
  if (inheritingObject2560) {
    struct UserObject *inho2560 = (struct UserObject *)inheritingObject2560;
    while (inho2560->super != GraceDefaultObject) inho2560 = (struct UserObject *)inho2560->super;
    inho2560->super = obj2560;
    self = inheritingObject2560;
    *selfslot = self;
    lowerouter2560 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2560;
  }
// method "new"
  block_savedest(obj2560);
  Object closure2562 = createclosure(3, "new");
  setclosureframe(closure2562, stackframe);
  addtoclosure(closure2562, var_k);
  addtoclosure(closure2562, var_emptySeq);
  addtoclosure(closure2562, var_methodTypeNode);
  struct UserObject *uo2562 = (struct UserObject*)obj2560;
  uo2562->data[1] = (Object)closure2562;
  Method *meth_meth_ast_new2562 = addmethod2pos(obj2560, "new", &meth_ast_new2562, 1);
  int argcv_meth_ast_new2562[] = {3};
  meth_meth_ast_new2562->type = alloc_MethodType(1, argcv_meth_ast_new2562);
  meth_meth_ast_new2562->definitionModule = modulename;
  meth_meth_ast_new2562->definitionLine = 530;
  block_savedest(obj2560);
  Object closure3017 = createclosure(3, "new()object");
  setclosureframe(closure3017, stackframe);
  addtoclosure(closure3017, var_k);
  addtoclosure(closure3017, var_emptySeq);
  addtoclosure(closure3017, var_methodTypeNode);
  Method *meth_meth_ast_new2562_object = addmethod2pos(obj2560, "new()object", &meth_ast_new2562_object, 1);
  meth_meth_ast_new2562_object->definitionModule = modulename;
  meth_meth_ast_new2562_object->definitionLine = 530;
  sourceObject = obj2560;
  objclass2560 = obj2560->class;
  objclass2560->definitionModule = modulename;
  objclass2560->definitionLine = 529;
  (*(struct UserObject *)self).data[0] = lowerouter2560;
  self = oldself2560;
  selfslot = oldselfslot2560;
  stackframe = oldstackframe2560;
// compiled object node returning obj2560 (depth = 2)
  *var_methodTypeNode = obj2560;
  if (obj2560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "methodTypeNode"
  block_savedest(self);
  Object closure3018 = createclosure(1, "methodTypeNode");
  setclosureframe(closure3018, stackframe);
  addtoclosure(closure3018, var_methodTypeNode);
  struct UserObject *uo3018 = (struct UserObject*)self;
  uo3018->data[21] = (Object)closure3018;
  Method *meth_meth_ast_methodTypeNode3018 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode3018, 21);
  int argcv_meth_ast_methodTypeNode3018[] = {0};
  meth_meth_ast_methodTypeNode3018->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode3018);
  meth_meth_ast_methodTypeNode3018->definitionModule = modulename;
  meth_meth_ast_methodTypeNode3018->definitionLine = 553;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3019 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3019 = alloc_userobj2(2,4, objclass3019);
  gc_frame_newslot(obj3019);
// OBJECT OUTER DEC outer
  adddatum2(obj3019, self, 0);
  addmethodreal(obj3019,"outer", &reader_ast_outer_3020);
  Object oldself3019 = self;
  struct StackFrameObject *oldstackframe3019 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3019);
  gc_frame_newslot((Object)stackframe);
  self = obj3019;
  Object *oldselfslot3019 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3019 = (*(struct UserObject *)self).data[0], lowerouter3019 = thisouter3019;
  if (inheritingObject3019) {
    struct UserObject *inho3019 = (struct UserObject *)inheritingObject3019;
    while (inho3019->super != GraceDefaultObject) inho3019 = (struct UserObject *)inho3019->super;
    inho3019->super = obj3019;
    self = inheritingObject3019;
    *selfslot = self;
    lowerouter3019 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3019;
  }
// method "new"
  block_savedest(obj3019);
  Object closure3021 = createclosure(3, "new");
  setclosureframe(closure3021, stackframe);
  addtoclosure(closure3021, var_k);
  addtoclosure(closure3021, var_emptySeq);
  addtoclosure(closure3021, var_typeLiteralNode);
  struct UserObject *uo3021 = (struct UserObject*)obj3019;
  uo3021->data[1] = (Object)closure3021;
  Method *meth_meth_ast_new3021 = addmethod2pos(obj3019, "new", &meth_ast_new3021, 1);
  int argcv_meth_ast_new3021[] = {2};
  meth_meth_ast_new3021->type = alloc_MethodType(1, argcv_meth_ast_new3021);
  meth_meth_ast_new3021->definitionModule = modulename;
  meth_meth_ast_new3021->definitionLine = 647;
  block_savedest(obj3019);
  Object closure3330 = createclosure(3, "new()object");
  setclosureframe(closure3330, stackframe);
  addtoclosure(closure3330, var_k);
  addtoclosure(closure3330, var_emptySeq);
  addtoclosure(closure3330, var_typeLiteralNode);
  Method *meth_meth_ast_new3021_object = addmethod2pos(obj3019, "new()object", &meth_ast_new3021_object, 1);
  meth_meth_ast_new3021_object->definitionModule = modulename;
  meth_meth_ast_new3021_object->definitionLine = 647;
  sourceObject = obj3019;
  objclass3019 = obj3019->class;
  objclass3019->definitionModule = modulename;
  objclass3019->definitionLine = 646;
  (*(struct UserObject *)self).data[0] = lowerouter3019;
  self = oldself3019;
  selfslot = oldselfslot3019;
  stackframe = oldstackframe3019;
// compiled object node returning obj3019 (depth = 2)
  *var_typeLiteralNode = obj3019;
  if (obj3019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeLiteralNode"
  block_savedest(self);
  Object closure3331 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure3331, stackframe);
  addtoclosure(closure3331, var_typeLiteralNode);
  struct UserObject *uo3331 = (struct UserObject*)self;
  uo3331->data[22] = (Object)closure3331;
  Method *meth_meth_ast_typeLiteralNode3331 = addmethod2pos(self, "typeLiteralNode", &meth_ast_typeLiteralNode3331, 22);
  int argcv_meth_ast_typeLiteralNode3331[] = {0};
  meth_meth_ast_typeLiteralNode3331->type = alloc_MethodType(1, argcv_meth_ast_typeLiteralNode3331);
  meth_meth_ast_typeLiteralNode3331->definitionModule = modulename;
  meth_meth_ast_typeLiteralNode3331->definitionLine = 648;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3332 = alloc_userobj2(2,4, objclass3332);
  gc_frame_newslot(obj3332);
// OBJECT OUTER DEC outer
  adddatum2(obj3332, self, 0);
  addmethodreal(obj3332,"outer", &reader_ast_outer_3333);
  Object oldself3332 = self;
  struct StackFrameObject *oldstackframe3332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3332);
  gc_frame_newslot((Object)stackframe);
  self = obj3332;
  Object *oldselfslot3332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3332 = (*(struct UserObject *)self).data[0], lowerouter3332 = thisouter3332;
  if (inheritingObject3332) {
    struct UserObject *inho3332 = (struct UserObject *)inheritingObject3332;
    while (inho3332->super != GraceDefaultObject) inho3332 = (struct UserObject *)inho3332->super;
    inho3332->super = obj3332;
    self = inheritingObject3332;
    *selfslot = self;
    lowerouter3332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3332;
  }
// method "new"
  block_savedest(obj3332);
  Object closure3334 = createclosure(3, "new");
  setclosureframe(closure3334, stackframe);
  addtoclosure(closure3334, var_k);
  addtoclosure(closure3334, var_nullNode);
  addtoclosure(closure3334, var_typeDecNode);
  struct UserObject *uo3334 = (struct UserObject*)obj3332;
  uo3334->data[1] = (Object)closure3334;
  Method *meth_meth_ast_new3334 = addmethod2pos(obj3332, "new", &meth_ast_new3334, 1);
  int argcv_meth_ast_new3334[] = {2};
  meth_meth_ast_new3334->type = alloc_MethodType(1, argcv_meth_ast_new3334);
  meth_meth_ast_new3334->definitionModule = modulename;
  meth_meth_ast_new3334->definitionLine = 731;
  block_savedest(obj3332);
  Object closure3663 = createclosure(3, "new()object");
  setclosureframe(closure3663, stackframe);
  addtoclosure(closure3663, var_k);
  addtoclosure(closure3663, var_nullNode);
  addtoclosure(closure3663, var_typeDecNode);
  Method *meth_meth_ast_new3334_object = addmethod2pos(obj3332, "new()object", &meth_ast_new3334_object, 1);
  meth_meth_ast_new3334_object->definitionModule = modulename;
  meth_meth_ast_new3334_object->definitionLine = 731;
  sourceObject = obj3332;
  objclass3332 = obj3332->class;
  objclass3332->definitionModule = modulename;
  objclass3332->definitionLine = 730;
  (*(struct UserObject *)self).data[0] = lowerouter3332;
  self = oldself3332;
  selfslot = oldselfslot3332;
  stackframe = oldstackframe3332;
// compiled object node returning obj3332 (depth = 2)
  *var_typeDecNode = obj3332;
  if (obj3332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeDecNode"
  block_savedest(self);
  Object closure3664 = createclosure(1, "typeDecNode");
  setclosureframe(closure3664, stackframe);
  addtoclosure(closure3664, var_typeDecNode);
  struct UserObject *uo3664 = (struct UserObject*)self;
  uo3664->data[23] = (Object)closure3664;
  Method *meth_meth_ast_typeDecNode3664 = addmethod2pos(self, "typeDecNode", &meth_ast_typeDecNode3664, 23);
  int argcv_meth_ast_typeDecNode3664[] = {0};
  meth_meth_ast_typeDecNode3664->type = alloc_MethodType(1, argcv_meth_ast_typeDecNode3664);
  meth_meth_ast_typeDecNode3664->definitionModule = modulename;
  meth_meth_ast_typeDecNode3664->definitionLine = 737;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3665 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3665 = alloc_userobj2(3,4, objclass3665);
  gc_frame_newslot(obj3665);
// OBJECT OUTER DEC outer
  adddatum2(obj3665, self, 0);
  addmethodreal(obj3665,"outer", &reader_ast_outer_3666);
  Object oldself3665 = self;
  struct StackFrameObject *oldstackframe3665 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3665);
  gc_frame_newslot((Object)stackframe);
  self = obj3665;
  Object *oldselfslot3665 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3665 = (*(struct UserObject *)self).data[0], lowerouter3665 = thisouter3665;
  if (inheritingObject3665) {
    struct UserObject *inho3665 = (struct UserObject *)inheritingObject3665;
    while (inho3665->super != GraceDefaultObject) inho3665 = (struct UserObject *)inho3665->super;
    inho3665->super = obj3665;
    self = inheritingObject3665;
    *selfslot = self;
    lowerouter3665 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3665;
  }
// method "new()scope"
  struct UserObject *uo3667 = (struct UserObject*)obj3665;
  uo3667->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope3667 = addmethod2pos(obj3665, "new()scope", &meth_ast_new_40__41_scope3667, 1);
  int argcv_meth_ast_new_40__41_scope3667[] = {4, 1};
  meth_meth_ast_new_40__41_scope3667->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope3667);
  meth_meth_ast_new_40__41_scope3667->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope3667->definitionLine = 816;
// method "new"
  block_savedest(obj3665);
  Object closure3672 = createclosure(2, "new");
  setclosureframe(closure3672, stackframe);
  addtoclosure(closure3672, var_k);
  addtoclosure(closure3672, var_methodNode);
  struct UserObject *uo3672 = (struct UserObject*)obj3665;
  uo3672->data[2] = (Object)closure3672;
  Method *meth_meth_ast_new3672 = addmethod2pos(obj3665, "new", &meth_ast_new3672, 2);
  int argcv_meth_ast_new3672[] = {4};
  meth_meth_ast_new3672->type = alloc_MethodType(1, argcv_meth_ast_new3672);
  meth_meth_ast_new3672->definitionModule = modulename;
  meth_meth_ast_new3672->definitionLine = 822;
  block_savedest(obj3665);
  Object closure4692 = createclosure(2, "new()object");
  setclosureframe(closure4692, stackframe);
  addtoclosure(closure4692, var_k);
  addtoclosure(closure4692, var_methodNode);
  Method *meth_meth_ast_new3672_object = addmethod2pos(obj3665, "new()object", &meth_ast_new3672_object, 2);
  meth_meth_ast_new3672_object->definitionModule = modulename;
  meth_meth_ast_new3672_object->definitionLine = 822;
  sourceObject = obj3665;
  sourceObject = obj3665;
  objclass3665 = obj3665->class;
  objclass3665->definitionModule = modulename;
  objclass3665->definitionLine = 815;
  (*(struct UserObject *)self).data[0] = lowerouter3665;
  self = oldself3665;
  selfslot = oldselfslot3665;
  stackframe = oldstackframe3665;
// compiled object node returning obj3665 (depth = 2)
  *var_methodNode = obj3665;
  if (obj3665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodNode"
  block_savedest(self);
  Object closure4693 = createclosure(1, "methodNode");
  setclosureframe(closure4693, stackframe);
  addtoclosure(closure4693, var_methodNode);
  struct UserObject *uo4693 = (struct UserObject*)self;
  uo4693->data[24] = (Object)closure4693;
  Method *meth_meth_ast_methodNode4693 = addmethod2pos(self, "methodNode", &meth_ast_methodNode4693, 24);
  int argcv_meth_ast_methodNode4693[] = {0};
  meth_meth_ast_methodNode4693->type = alloc_MethodType(1, argcv_meth_ast_methodNode4693);
  meth_meth_ast_methodNode4693->definitionModule = modulename;
  meth_meth_ast_methodNode4693->definitionLine = 839;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject4694 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4694 = alloc_userobj2(3,4, objclass4694);
  gc_frame_newslot(obj4694);
// OBJECT OUTER DEC outer
  adddatum2(obj4694, self, 0);
  addmethodreal(obj4694,"outer", &reader_ast_outer_4695);
  Object oldself4694 = self;
  struct StackFrameObject *oldstackframe4694 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4694);
  gc_frame_newslot((Object)stackframe);
  self = obj4694;
  Object *oldselfslot4694 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4694 = (*(struct UserObject *)self).data[0], lowerouter4694 = thisouter4694;
  if (inheritingObject4694) {
    struct UserObject *inho4694 = (struct UserObject *)inheritingObject4694;
    while (inho4694->super != GraceDefaultObject) inho4694 = (struct UserObject *)inho4694->super;
    inho4694->super = obj4694;
    self = inheritingObject4694;
    *selfslot = self;
    lowerouter4694 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4694;
  }
// method "new()scope"
  struct UserObject *uo4696 = (struct UserObject*)obj4694;
  uo4696->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope4696 = addmethod2pos(obj4694, "new()scope", &meth_ast_new_40__41_scope4696, 1);
  int argcv_meth_ast_new_40__41_scope4696[] = {2, 1};
  meth_meth_ast_new_40__41_scope4696->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope4696);
  meth_meth_ast_new_40__41_scope4696->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope4696->definitionLine = 1032;
// method "new"
  block_savedest(obj4694);
  Object closure4701 = createclosure(1, "new");
  setclosureframe(closure4701, stackframe);
  addtoclosure(closure4701, var_callNode);
  struct UserObject *uo4701 = (struct UserObject*)obj4694;
  uo4701->data[2] = (Object)closure4701;
  Method *meth_meth_ast_new4701 = addmethod2pos(obj4694, "new", &meth_ast_new4701, 2);
  int argcv_meth_ast_new4701[] = {2};
  meth_meth_ast_new4701->type = alloc_MethodType(1, argcv_meth_ast_new4701);
  meth_meth_ast_new4701->definitionModule = modulename;
  meth_meth_ast_new4701->definitionLine = 1037;
  block_savedest(obj4694);
  Object closure5237 = createclosure(1, "new()object");
  setclosureframe(closure5237, stackframe);
  addtoclosure(closure5237, var_callNode);
  Method *meth_meth_ast_new4701_object = addmethod2pos(obj4694, "new()object", &meth_ast_new4701_object, 2);
  meth_meth_ast_new4701_object->definitionModule = modulename;
  meth_meth_ast_new4701_object->definitionLine = 1037;
  sourceObject = obj4694;
  sourceObject = obj4694;
  objclass4694 = obj4694->class;
  objclass4694->definitionModule = modulename;
  objclass4694->definitionLine = 1031;
  (*(struct UserObject *)self).data[0] = lowerouter4694;
  self = oldself4694;
  selfslot = oldselfslot4694;
  stackframe = oldstackframe4694;
// compiled object node returning obj4694 (depth = 2)
  *var_callNode = obj4694;
  if (obj4694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "callNode"
  block_savedest(self);
  Object closure5238 = createclosure(1, "callNode");
  setclosureframe(closure5238, stackframe);
  addtoclosure(closure5238, var_callNode);
  struct UserObject *uo5238 = (struct UserObject*)self;
  uo5238->data[25] = (Object)closure5238;
  Method *meth_meth_ast_callNode5238 = addmethod2pos(self, "callNode", &meth_ast_callNode5238, 25);
  int argcv_meth_ast_callNode5238[] = {0};
  meth_meth_ast_callNode5238->type = alloc_MethodType(1, argcv_meth_ast_callNode5238);
  meth_meth_ast_callNode5238->definitionModule = modulename;
  meth_meth_ast_callNode5238->definitionLine = 1061;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5239 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5239 = alloc_userobj2(4,5, objclass5239);
  gc_frame_newslot(obj5239);
// OBJECT OUTER DEC outer
  adddatum2(obj5239, self, 0);
  addmethodreal(obj5239,"outer", &reader_ast_outer_5240);
  Object oldself5239 = self;
  struct StackFrameObject *oldstackframe5239 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5239);
  gc_frame_newslot((Object)stackframe);
  self = obj5239;
  Object *oldselfslot5239 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5239 = (*(struct UserObject *)self).data[0], lowerouter5239 = thisouter5239;
  if (inheritingObject5239) {
    struct UserObject *inho5239 = (struct UserObject *)inheritingObject5239;
    while (inho5239->super != GraceDefaultObject) inho5239 = (struct UserObject *)inho5239->super;
    inho5239->super = obj5239;
    self = inheritingObject5239;
    *selfslot = self;
    lowerouter5239 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5239;
  }
// method "body()named()scope"
  struct UserObject *uo5241 = (struct UserObject*)obj5239;
  uo5241->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named_40__41_scope5241 = addmethod2pos(obj5239, "body()named()scope", &meth_ast_body_40__41_named_40__41_scope5241, 1);
  int argcv_meth_ast_body_40__41_named_40__41_scope5241[] = {1, 1, 1};
  meth_meth_ast_body_40__41_named_40__41_scope5241->type = alloc_MethodType(3, argcv_meth_ast_body_40__41_named_40__41_scope5241);
  meth_meth_ast_body_40__41_named_40__41_scope5241->definitionModule = modulename;
  meth_meth_ast_body_40__41_named_40__41_scope5241->definitionLine = 1179;
// method "body()named"
  struct UserObject *uo5248 = (struct UserObject*)obj5239;
  uo5248->data[2] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named5248 = addmethod2pos(obj5239, "body()named", &meth_ast_body_40__41_named5248, 2);
  int argcv_meth_ast_body_40__41_named5248[] = {1, 1};
  meth_meth_ast_body_40__41_named5248->type = alloc_MethodType(2, argcv_meth_ast_body_40__41_named5248);
  meth_meth_ast_body_40__41_named5248->definitionModule = modulename;
  meth_meth_ast_body_40__41_named5248->definitionLine = 1185;
// method "body"
  block_savedest(obj5239);
  Object closure5253 = createclosure(3, "body");
  setclosureframe(closure5253, stackframe);
  addtoclosure(closure5253, var_emptySeq);
  addtoclosure(closure5253, var_moduleNode);
  addtoclosure(closure5253, var_objectNode);
  struct UserObject *uo5253 = (struct UserObject*)obj5239;
  uo5253->data[3] = (Object)closure5253;
  Method *meth_meth_ast_body5253 = addmethod2pos(obj5239, "body", &meth_ast_body5253, 3);
  int argcv_meth_ast_body5253[] = {1};
  meth_meth_ast_body5253->type = alloc_MethodType(1, argcv_meth_ast_body5253);
  meth_meth_ast_body5253->definitionModule = modulename;
  meth_meth_ast_body5253->definitionLine = 1190;
  block_savedest(obj5239);
  Object closure5327 = createclosure(3, "body()object");
  setclosureframe(closure5327, stackframe);
  addtoclosure(closure5327, var_emptySeq);
  addtoclosure(closure5327, var_moduleNode);
  addtoclosure(closure5327, var_objectNode);
  Method *meth_meth_ast_body5253_object = addmethod2pos(obj5239, "body()object", &meth_ast_body5253_object, 3);
  meth_meth_ast_body5253_object->definitionModule = modulename;
  meth_meth_ast_body5253_object->definitionLine = 1190;
  sourceObject = obj5239;
  sourceObject = obj5239;
  sourceObject = obj5239;
  objclass5239 = obj5239->class;
  objclass5239->definitionModule = modulename;
  objclass5239->definitionLine = 1178;
  (*(struct UserObject *)self).data[0] = lowerouter5239;
  self = oldself5239;
  selfslot = oldselfslot5239;
  stackframe = oldstackframe5239;
// compiled object node returning obj5239 (depth = 2)
  *var_moduleNode = obj5239;
  if (obj5239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "moduleNode"
  block_savedest(self);
  Object closure5328 = createclosure(1, "moduleNode");
  setclosureframe(closure5328, stackframe);
  addtoclosure(closure5328, var_moduleNode);
  struct UserObject *uo5328 = (struct UserObject*)self;
  uo5328->data[26] = (Object)closure5328;
  Method *meth_meth_ast_moduleNode5328 = addmethod2pos(self, "moduleNode", &meth_ast_moduleNode5328, 26);
  int argcv_meth_ast_moduleNode5328[] = {0};
  meth_meth_ast_moduleNode5328->type = alloc_MethodType(1, argcv_meth_ast_moduleNode5328);
  meth_meth_ast_moduleNode5328->definitionModule = modulename;
  meth_meth_ast_moduleNode5328->definitionLine = 1195;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5329 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5329 = alloc_userobj2(4,5, objclass5329);
  gc_frame_newslot(obj5329);
// OBJECT OUTER DEC outer
  adddatum2(obj5329, self, 0);
  addmethodreal(obj5329,"outer", &reader_ast_outer_5330);
  Object oldself5329 = self;
  struct StackFrameObject *oldstackframe5329 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5329);
  gc_frame_newslot((Object)stackframe);
  self = obj5329;
  Object *oldselfslot5329 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5329 = (*(struct UserObject *)self).data[0], lowerouter5329 = thisouter5329;
  if (inheritingObject5329) {
    struct UserObject *inho5329 = (struct UserObject *)inheritingObject5329;
    while (inho5329->super != GraceDefaultObject) inho5329 = (struct UserObject *)inho5329->super;
    inho5329->super = obj5329;
    self = inheritingObject5329;
    *selfslot = self;
    lowerouter5329 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5329;
  }
// method "body()named()scope"
  struct UserObject *uo5331 = (struct UserObject*)obj5329;
  uo5331->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named_40__41_scope5331 = addmethod2pos(obj5329, "body()named()scope", &meth_ast_body_40__41_named_40__41_scope5331, 1);
  int argcv_meth_ast_body_40__41_named_40__41_scope5331[] = {1, 1, 1};
  meth_meth_ast_body_40__41_named_40__41_scope5331->type = alloc_MethodType(3, argcv_meth_ast_body_40__41_named_40__41_scope5331);
  meth_meth_ast_body_40__41_named_40__41_scope5331->definitionModule = modulename;
  meth_meth_ast_body_40__41_named_40__41_scope5331->definitionLine = 1226;
// method "body()named"
  block_savedest(obj5329);
  Object closure5339 = createclosure(1, "body()named");
  setclosureframe(closure5339, stackframe);
  addtoclosure(closure5339, var_fakeSymbolTable);
  struct UserObject *uo5339 = (struct UserObject*)obj5329;
  uo5339->data[2] = (Object)closure5339;
  Method *meth_meth_ast_body_40__41_named5339 = addmethod2pos(obj5329, "body()named", &meth_ast_body_40__41_named5339, 2);
  int argcv_meth_ast_body_40__41_named5339[] = {1, 1};
  meth_meth_ast_body_40__41_named5339->type = alloc_MethodType(2, argcv_meth_ast_body_40__41_named5339);
  meth_meth_ast_body_40__41_named5339->definitionModule = modulename;
  meth_meth_ast_body_40__41_named5339->definitionLine = 1232;
// method "new"
  block_savedest(obj5329);
  Object closure5342 = createclosure(2, "new");
  setclosureframe(closure5342, stackframe);
  addtoclosure(closure5342, var_emptySeq);
  addtoclosure(closure5342, var_objectNode);
  struct UserObject *uo5342 = (struct UserObject*)obj5329;
  uo5342->data[3] = (Object)closure5342;
  Method *meth_meth_ast_new5342 = addmethod2pos(obj5329, "new", &meth_ast_new5342, 3);
  int argcv_meth_ast_new5342[] = {2};
  meth_meth_ast_new5342->type = alloc_MethodType(1, argcv_meth_ast_new5342);
  meth_meth_ast_new5342->definitionModule = modulename;
  meth_meth_ast_new5342->definitionLine = 1235;
  block_savedest(obj5329);
  Object closure5948 = createclosure(2, "new()object");
  setclosureframe(closure5948, stackframe);
  addtoclosure(closure5948, var_emptySeq);
  addtoclosure(closure5948, var_objectNode);
  Method *meth_meth_ast_new5342_object = addmethod2pos(obj5329, "new()object", &meth_ast_new5342_object, 3);
  meth_meth_ast_new5342_object->definitionModule = modulename;
  meth_meth_ast_new5342_object->definitionLine = 1235;
  sourceObject = obj5329;
  sourceObject = obj5329;
  sourceObject = obj5329;
  objclass5329 = obj5329->class;
  objclass5329->definitionModule = modulename;
  objclass5329->definitionLine = 1225;
  (*(struct UserObject *)self).data[0] = lowerouter5329;
  self = oldself5329;
  selfslot = oldselfslot5329;
  stackframe = oldstackframe5329;
// compiled object node returning obj5329 (depth = 2)
  *var_objectNode = obj5329;
  if (obj5329 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "objectNode"
  block_savedest(self);
  Object closure5949 = createclosure(1, "objectNode");
  setclosureframe(closure5949, stackframe);
  addtoclosure(closure5949, var_objectNode);
  struct UserObject *uo5949 = (struct UserObject*)self;
  uo5949->data[27] = (Object)closure5949;
  Method *meth_meth_ast_objectNode5949 = addmethod2pos(self, "objectNode", &meth_ast_objectNode5949, 27);
  int argcv_meth_ast_objectNode5949[] = {0};
  meth_meth_ast_objectNode5949->type = alloc_MethodType(1, argcv_meth_ast_objectNode5949);
  meth_meth_ast_objectNode5949->definitionModule = modulename;
  meth_meth_ast_objectNode5949->definitionLine = 1245;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5950 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5950 = alloc_userobj2(2,4, objclass5950);
  gc_frame_newslot(obj5950);
// OBJECT OUTER DEC outer
  adddatum2(obj5950, self, 0);
  addmethodreal(obj5950,"outer", &reader_ast_outer_5951);
  Object oldself5950 = self;
  struct StackFrameObject *oldstackframe5950 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5950);
  gc_frame_newslot((Object)stackframe);
  self = obj5950;
  Object *oldselfslot5950 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5950 = (*(struct UserObject *)self).data[0], lowerouter5950 = thisouter5950;
  if (inheritingObject5950) {
    struct UserObject *inho5950 = (struct UserObject *)inheritingObject5950;
    while (inho5950->super != GraceDefaultObject) inho5950 = (struct UserObject *)inho5950->super;
    inho5950->super = obj5950;
    self = inheritingObject5950;
    *selfslot = self;
    lowerouter5950 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5950;
  }
// method "new"
  block_savedest(obj5950);
  Object closure5952 = createclosure(2, "new");
  setclosureframe(closure5952, stackframe);
  addtoclosure(closure5952, var_emptySeq);
  addtoclosure(closure5952, var_arrayNode);
  struct UserObject *uo5952 = (struct UserObject*)obj5950;
  uo5952->data[1] = (Object)closure5952;
  Method *meth_meth_ast_new5952 = addmethod2pos(obj5950, "new", &meth_ast_new5952, 1);
  int argcv_meth_ast_new5952[] = {1};
  meth_meth_ast_new5952->type = alloc_MethodType(1, argcv_meth_ast_new5952);
  meth_meth_ast_new5952->definitionModule = modulename;
  meth_meth_ast_new5952->definitionLine = 1402;
  block_savedest(obj5950);
  Object closure6082 = createclosure(2, "new()object");
  setclosureframe(closure6082, stackframe);
  addtoclosure(closure6082, var_emptySeq);
  addtoclosure(closure6082, var_arrayNode);
  Method *meth_meth_ast_new5952_object = addmethod2pos(obj5950, "new()object", &meth_ast_new5952_object, 1);
  meth_meth_ast_new5952_object->definitionModule = modulename;
  meth_meth_ast_new5952_object->definitionLine = 1402;
  sourceObject = obj5950;
  objclass5950 = obj5950->class;
  objclass5950->definitionModule = modulename;
  objclass5950->definitionLine = 1401;
  (*(struct UserObject *)self).data[0] = lowerouter5950;
  self = oldself5950;
  selfslot = oldselfslot5950;
  stackframe = oldstackframe5950;
// compiled object node returning obj5950 (depth = 2)
  *var_arrayNode = obj5950;
  if (obj5950 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "arrayNode"
  block_savedest(self);
  Object closure6083 = createclosure(1, "arrayNode");
  setclosureframe(closure6083, stackframe);
  addtoclosure(closure6083, var_arrayNode);
  struct UserObject *uo6083 = (struct UserObject*)self;
  uo6083->data[28] = (Object)closure6083;
  Method *meth_meth_ast_arrayNode6083 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode6083, 28);
  int argcv_meth_ast_arrayNode6083[] = {0};
  meth_meth_ast_arrayNode6083->type = alloc_MethodType(1, argcv_meth_ast_arrayNode6083);
  meth_meth_ast_arrayNode6083->definitionModule = modulename;
  meth_meth_ast_arrayNode6083->definitionLine = 1403;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6084 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6084 = alloc_userobj2(3,4, objclass6084);
  gc_frame_newslot(obj6084);
// OBJECT OUTER DEC outer
  adddatum2(obj6084, self, 0);
  addmethodreal(obj6084,"outer", &reader_ast_outer_6085);
  Object oldself6084 = self;
  struct StackFrameObject *oldstackframe6084 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6084);
  gc_frame_newslot((Object)stackframe);
  self = obj6084;
  Object *oldselfslot6084 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6084 = (*(struct UserObject *)self).data[0], lowerouter6084 = thisouter6084;
  if (inheritingObject6084) {
    struct UserObject *inho6084 = (struct UserObject *)inheritingObject6084;
    while (inho6084->super != GraceDefaultObject) inho6084 = (struct UserObject *)inho6084->super;
    inho6084->super = obj6084;
    self = inheritingObject6084;
    *selfslot = self;
    lowerouter6084 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6084;
  }
// method "new()scope"
  struct UserObject *uo6086 = (struct UserObject*)obj6084;
  uo6086->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope6086 = addmethod2pos(obj6084, "new()scope", &meth_ast_new_40__41_scope6086, 1);
  int argcv_meth_ast_new_40__41_scope6086[] = {2, 1};
  meth_meth_ast_new_40__41_scope6086->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope6086);
  meth_meth_ast_new_40__41_scope6086->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope6086->definitionLine = 1448;
// method "new"
  block_savedest(obj6084);
  Object closure6091 = createclosure(4, "new");
  setclosureframe(closure6091, stackframe);
  addtoclosure(closure6091, var_fakeSymbolTable);
  addtoclosure(closure6091, var_identifierNode);
  addtoclosure(closure6091, var_nullNode);
  addtoclosure(closure6091, var_memberNode);
  struct UserObject *uo6091 = (struct UserObject*)obj6084;
  uo6091->data[2] = (Object)closure6091;
  Method *meth_meth_ast_new6091 = addmethod2pos(obj6084, "new", &meth_ast_new6091, 2);
  int argcv_meth_ast_new6091[] = {2};
  meth_meth_ast_new6091->type = alloc_MethodType(1, argcv_meth_ast_new6091);
  meth_meth_ast_new6091->definitionModule = modulename;
  meth_meth_ast_new6091->definitionLine = 1453;
  block_savedest(obj6084);
  Object closure6433 = createclosure(4, "new()object");
  setclosureframe(closure6433, stackframe);
  addtoclosure(closure6433, var_fakeSymbolTable);
  addtoclosure(closure6433, var_identifierNode);
  addtoclosure(closure6433, var_nullNode);
  addtoclosure(closure6433, var_memberNode);
  Method *meth_meth_ast_new6091_object = addmethod2pos(obj6084, "new()object", &meth_ast_new6091_object, 2);
  meth_meth_ast_new6091_object->definitionModule = modulename;
  meth_meth_ast_new6091_object->definitionLine = 1453;
  sourceObject = obj6084;
  sourceObject = obj6084;
  objclass6084 = obj6084->class;
  objclass6084->definitionModule = modulename;
  objclass6084->definitionLine = 1447;
  (*(struct UserObject *)self).data[0] = lowerouter6084;
  self = oldself6084;
  selfslot = oldselfslot6084;
  stackframe = oldstackframe6084;
// compiled object node returning obj6084 (depth = 2)
  *var_memberNode = obj6084;
  if (obj6084 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "memberNode"
  block_savedest(self);
  Object closure6434 = createclosure(1, "memberNode");
  setclosureframe(closure6434, stackframe);
  addtoclosure(closure6434, var_memberNode);
  struct UserObject *uo6434 = (struct UserObject*)self;
  uo6434->data[29] = (Object)closure6434;
  Method *meth_meth_ast_memberNode6434 = addmethod2pos(self, "memberNode", &meth_ast_memberNode6434, 29);
  int argcv_meth_ast_memberNode6434[] = {0};
  meth_meth_ast_memberNode6434->type = alloc_MethodType(1, argcv_meth_ast_memberNode6434);
  meth_meth_ast_memberNode6434->definitionModule = modulename;
  meth_meth_ast_memberNode6434->definitionLine = 1455;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6435 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6435 = alloc_userobj2(2,4, objclass6435);
  gc_frame_newslot(obj6435);
// OBJECT OUTER DEC outer
  adddatum2(obj6435, self, 0);
  addmethodreal(obj6435,"outer", &reader_ast_outer_6436);
  Object oldself6435 = self;
  struct StackFrameObject *oldstackframe6435 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6435);
  gc_frame_newslot((Object)stackframe);
  self = obj6435;
  Object *oldselfslot6435 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6435 = (*(struct UserObject *)self).data[0], lowerouter6435 = thisouter6435;
  if (inheritingObject6435) {
    struct UserObject *inho6435 = (struct UserObject *)inheritingObject6435;
    while (inho6435->super != GraceDefaultObject) inho6435 = (struct UserObject *)inho6435->super;
    inho6435->super = obj6435;
    self = inheritingObject6435;
    *selfslot = self;
    lowerouter6435 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6435;
  }
// method "new"
  block_savedest(obj6435);
  Object closure6437 = createclosure(1, "new");
  setclosureframe(closure6437, stackframe);
  addtoclosure(closure6437, var_genericNode);
  struct UserObject *uo6437 = (struct UserObject*)obj6435;
  uo6437->data[1] = (Object)closure6437;
  Method *meth_meth_ast_new6437 = addmethod2pos(obj6435, "new", &meth_ast_new6437, 1);
  int argcv_meth_ast_new6437[] = {2};
  meth_meth_ast_new6437->type = alloc_MethodType(1, argcv_meth_ast_new6437);
  meth_meth_ast_new6437->definitionModule = modulename;
  meth_meth_ast_new6437->definitionLine = 1531;
  block_savedest(obj6435);
  Object closure6594 = createclosure(1, "new()object");
  setclosureframe(closure6594, stackframe);
  addtoclosure(closure6594, var_genericNode);
  Method *meth_meth_ast_new6437_object = addmethod2pos(obj6435, "new()object", &meth_ast_new6437_object, 1);
  meth_meth_ast_new6437_object->definitionModule = modulename;
  meth_meth_ast_new6437_object->definitionLine = 1531;
  sourceObject = obj6435;
  objclass6435 = obj6435->class;
  objclass6435->definitionModule = modulename;
  objclass6435->definitionLine = 1530;
  (*(struct UserObject *)self).data[0] = lowerouter6435;
  self = oldself6435;
  selfslot = oldselfslot6435;
  stackframe = oldstackframe6435;
// compiled object node returning obj6435 (depth = 2)
  *var_genericNode = obj6435;
  if (obj6435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "genericNode"
  block_savedest(self);
  Object closure6595 = createclosure(1, "genericNode");
  setclosureframe(closure6595, stackframe);
  addtoclosure(closure6595, var_genericNode);
  struct UserObject *uo6595 = (struct UserObject*)self;
  uo6595->data[30] = (Object)closure6595;
  Method *meth_meth_ast_genericNode6595 = addmethod2pos(self, "genericNode", &meth_ast_genericNode6595, 30);
  int argcv_meth_ast_genericNode6595[] = {0};
  meth_meth_ast_genericNode6595->type = alloc_MethodType(1, argcv_meth_ast_genericNode6595);
  meth_meth_ast_genericNode6595->definitionModule = modulename;
  meth_meth_ast_genericNode6595->definitionLine = 1533;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6596 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6596 = alloc_userobj2(2,4, objclass6596);
  gc_frame_newslot(obj6596);
// OBJECT OUTER DEC outer
  adddatum2(obj6596, self, 0);
  addmethodreal(obj6596,"outer", &reader_ast_outer_6597);
  Object oldself6596 = self;
  struct StackFrameObject *oldstackframe6596 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6596);
  gc_frame_newslot((Object)stackframe);
  self = obj6596;
  Object *oldselfslot6596 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6596 = (*(struct UserObject *)self).data[0], lowerouter6596 = thisouter6596;
  if (inheritingObject6596) {
    struct UserObject *inho6596 = (struct UserObject *)inheritingObject6596;
    while (inho6596->super != GraceDefaultObject) inho6596 = (struct UserObject *)inho6596->super;
    inho6596->super = obj6596;
    self = inheritingObject6596;
    *selfslot = self;
    lowerouter6596 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6596;
  }
// method "new"
  block_savedest(obj6596);
  Object closure6598 = createclosure(3, "new");
  setclosureframe(closure6598, stackframe);
  addtoclosure(closure6598, var_k);
  addtoclosure(closure6598, var_emptySeq);
  addtoclosure(closure6598, var_typeParametersNode);
  struct UserObject *uo6598 = (struct UserObject*)obj6596;
  uo6598->data[1] = (Object)closure6598;
  Method *meth_meth_ast_new6598 = addmethod2pos(obj6596, "new", &meth_ast_new6598, 1);
  int argcv_meth_ast_new6598[] = {1};
  meth_meth_ast_new6598->type = alloc_MethodType(1, argcv_meth_ast_new6598);
  meth_meth_ast_new6598->definitionModule = modulename;
  meth_meth_ast_new6598->definitionLine = 1576;
  block_savedest(obj6596);
  Object closure6757 = createclosure(3, "new()object");
  setclosureframe(closure6757, stackframe);
  addtoclosure(closure6757, var_k);
  addtoclosure(closure6757, var_emptySeq);
  addtoclosure(closure6757, var_typeParametersNode);
  Method *meth_meth_ast_new6598_object = addmethod2pos(obj6596, "new()object", &meth_ast_new6598_object, 1);
  meth_meth_ast_new6598_object->definitionModule = modulename;
  meth_meth_ast_new6598_object->definitionLine = 1576;
  sourceObject = obj6596;
  objclass6596 = obj6596->class;
  objclass6596->definitionModule = modulename;
  objclass6596->definitionLine = 1575;
  (*(struct UserObject *)self).data[0] = lowerouter6596;
  self = oldself6596;
  selfslot = oldselfslot6596;
  stackframe = oldstackframe6596;
// compiled object node returning obj6596 (depth = 2)
  *var_typeParametersNode = obj6596;
  if (obj6596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeParametersNode"
  block_savedest(self);
  Object closure6758 = createclosure(1, "typeParametersNode");
  setclosureframe(closure6758, stackframe);
  addtoclosure(closure6758, var_typeParametersNode);
  struct UserObject *uo6758 = (struct UserObject*)self;
  uo6758->data[31] = (Object)closure6758;
  Method *meth_meth_ast_typeParametersNode6758 = addmethod2pos(self, "typeParametersNode", &meth_ast_typeParametersNode6758, 31);
  int argcv_meth_ast_typeParametersNode6758[] = {0};
  meth_meth_ast_typeParametersNode6758->type = alloc_MethodType(1, argcv_meth_ast_typeParametersNode6758);
  meth_meth_ast_typeParametersNode6758->definitionModule = modulename;
  meth_meth_ast_typeParametersNode6758->definitionLine = 1577;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6759 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6759 = alloc_userobj2(3,4, objclass6759);
  gc_frame_newslot(obj6759);
// OBJECT OUTER DEC outer
  adddatum2(obj6759, self, 0);
  addmethodreal(obj6759,"outer", &reader_ast_outer_6760);
  Object oldself6759 = self;
  struct StackFrameObject *oldstackframe6759 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6759);
  gc_frame_newslot((Object)stackframe);
  self = obj6759;
  Object *oldselfslot6759 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6759 = (*(struct UserObject *)self).data[0], lowerouter6759 = thisouter6759;
  if (inheritingObject6759) {
    struct UserObject *inho6759 = (struct UserObject *)inheritingObject6759;
    while (inho6759->super != GraceDefaultObject) inho6759 = (struct UserObject *)inho6759->super;
    inho6759->super = obj6759;
    self = inheritingObject6759;
    *selfslot = self;
    lowerouter6759 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6759;
  }
// method "new()scope"
  struct UserObject *uo6761 = (struct UserObject*)obj6759;
  uo6761->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope6761 = addmethod2pos(obj6759, "new()scope", &meth_ast_new_40__41_scope6761, 1);
  int argcv_meth_ast_new_40__41_scope6761[] = {2, 1};
  meth_meth_ast_new_40__41_scope6761->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope6761);
  meth_meth_ast_new_40__41_scope6761->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope6761->definitionLine = 1624;
// method "new"
  block_savedest(obj6759);
  Object closure6766 = createclosure(1, "new");
  setclosureframe(closure6766, stackframe);
  addtoclosure(closure6766, var_identifierNode);
  struct UserObject *uo6766 = (struct UserObject*)obj6759;
  uo6766->data[2] = (Object)closure6766;
  Method *meth_meth_ast_new6766 = addmethod2pos(obj6759, "new", &meth_ast_new6766, 2);
  int argcv_meth_ast_new6766[] = {2};
  meth_meth_ast_new6766->type = alloc_MethodType(1, argcv_meth_ast_new6766);
  meth_meth_ast_new6766->definitionModule = modulename;
  meth_meth_ast_new6766->definitionLine = 1630;
  block_savedest(obj6759);
  Object closure7149 = createclosure(1, "new()object");
  setclosureframe(closure7149, stackframe);
  addtoclosure(closure7149, var_identifierNode);
  Method *meth_meth_ast_new6766_object = addmethod2pos(obj6759, "new()object", &meth_ast_new6766_object, 2);
  meth_meth_ast_new6766_object->definitionModule = modulename;
  meth_meth_ast_new6766_object->definitionLine = 1630;
  sourceObject = obj6759;
  sourceObject = obj6759;
  objclass6759 = obj6759->class;
  objclass6759->definitionModule = modulename;
  objclass6759->definitionLine = 1622;
  (*(struct UserObject *)self).data[0] = lowerouter6759;
  self = oldself6759;
  selfslot = oldselfslot6759;
  stackframe = oldstackframe6759;
// compiled object node returning obj6759 (depth = 2)
  *var_identifierNode = obj6759;
  if (obj6759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "identifierNode"
  block_savedest(self);
  Object closure7150 = createclosure(1, "identifierNode");
  setclosureframe(closure7150, stackframe);
  addtoclosure(closure7150, var_identifierNode);
  struct UserObject *uo7150 = (struct UserObject*)self;
  uo7150->data[32] = (Object)closure7150;
  Method *meth_meth_ast_identifierNode7150 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode7150, 32);
  int argcv_meth_ast_identifierNode7150[] = {0};
  meth_meth_ast_identifierNode7150->type = alloc_MethodType(1, argcv_meth_ast_identifierNode7150);
  meth_meth_ast_identifierNode7150->definitionModule = modulename;
  meth_meth_ast_identifierNode7150->definitionLine = 1631;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7151 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7152 == NULL) {
    strlit7152 = alloc_String("Type");
    gc_root(strlit7152);
  }
// compiled string node returning strlit7152 (depth = 3)
  gc_frame_newslot(strlit7152);
// starting to compile identifier node (depth = 3)
  Object bool7153 = alloc_Boolean(0);
// compiled identifier node returning bool7153 (depth = 3)
  gc_frame_newslot(bool7153);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7152;
  params[1] = bool7153;
  partcv[0] = 2;
  Object call7154 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7151);
// compiled call node returning call7154 (depth = 2)
  *var_typeType = call7154;
  if (call7154 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeType"
  block_savedest(self);
  Object closure7155 = createclosure(1, "typeType");
  setclosureframe(closure7155, stackframe);
  addtoclosure(closure7155, var_typeType);
  struct UserObject *uo7155 = (struct UserObject*)self;
  uo7155->data[33] = (Object)closure7155;
  Method *meth_meth_ast_typeType7155 = addmethod2pos(self, "typeType", &meth_ast_typeType7155, 33);
  int argcv_meth_ast_typeType7155[] = {0};
  meth_meth_ast_typeType7155->type = alloc_MethodType(1, argcv_meth_ast_typeType7155);
  meth_meth_ast_typeType7155->definitionModule = modulename;
  meth_meth_ast_typeType7155->definitionLine = 1631;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7156 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7157 == NULL) {
    strlit7157 = alloc_String("Unknown");
    gc_root(strlit7157);
  }
// compiled string node returning strlit7157 (depth = 3)
  gc_frame_newslot(strlit7157);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7157;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call7158 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7156);
// compiled call node returning call7158 (depth = 2)
  *var_unknownType = call7158;
  if (call7158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unknownType"
  block_savedest(self);
  Object closure7159 = createclosure(1, "unknownType");
  setclosureframe(closure7159, stackframe);
  addtoclosure(closure7159, var_unknownType);
  struct UserObject *uo7159 = (struct UserObject*)self;
  uo7159->data[34] = (Object)closure7159;
  Method *meth_meth_ast_unknownType7159 = addmethod2pos(self, "unknownType", &meth_ast_unknownType7159, 34);
  int argcv_meth_ast_unknownType7159[] = {0};
  meth_meth_ast_unknownType7159->type = alloc_MethodType(1, argcv_meth_ast_unknownType7159);
  meth_meth_ast_unknownType7159->definitionModule = modulename;
  meth_meth_ast_unknownType7159->definitionLine = 1631;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7160 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7160 = alloc_userobj2(3,4, objclass7160);
  gc_frame_newslot(obj7160);
// OBJECT OUTER DEC outer
  adddatum2(obj7160, self, 0);
  addmethodreal(obj7160,"outer", &reader_ast_outer_7161);
  Object oldself7160 = self;
  struct StackFrameObject *oldstackframe7160 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7160);
  gc_frame_newslot((Object)stackframe);
  self = obj7160;
  Object *oldselfslot7160 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7160 = (*(struct UserObject *)self).data[0], lowerouter7160 = thisouter7160;
  if (inheritingObject7160) {
    struct UserObject *inho7160 = (struct UserObject *)inheritingObject7160;
    while (inho7160->super != GraceDefaultObject) inho7160 = (struct UserObject *)inho7160->super;
    inho7160->super = obj7160;
    self = inheritingObject7160;
    *selfslot = self;
    lowerouter7160 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7160;
  }
// method "new()scope"
  struct UserObject *uo7162 = (struct UserObject*)obj7160;
  uo7162->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope7162 = addmethod2pos(obj7160, "new()scope", &meth_ast_new_40__41_scope7162, 1);
  int argcv_meth_ast_new_40__41_scope7162[] = {1, 1};
  meth_meth_ast_new_40__41_scope7162->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope7162);
  meth_meth_ast_new_40__41_scope7162->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope7162->definitionLine = 1752;
// method "new"
  block_savedest(obj7160);
  Object closure7167 = createclosure(1, "new");
  setclosureframe(closure7167, stackframe);
  addtoclosure(closure7167, var_stringNode);
  struct UserObject *uo7167 = (struct UserObject*)obj7160;
  uo7167->data[2] = (Object)closure7167;
  Method *meth_meth_ast_new7167 = addmethod2pos(obj7160, "new", &meth_ast_new7167, 2);
  int argcv_meth_ast_new7167[] = {1};
  meth_meth_ast_new7167->type = alloc_MethodType(1, argcv_meth_ast_new7167);
  meth_meth_ast_new7167->definitionModule = modulename;
  meth_meth_ast_new7167->definitionLine = 1758;
  block_savedest(obj7160);
  Object closure7230 = createclosure(1, "new()object");
  setclosureframe(closure7230, stackframe);
  addtoclosure(closure7230, var_stringNode);
  Method *meth_meth_ast_new7167_object = addmethod2pos(obj7160, "new()object", &meth_ast_new7167_object, 2);
  meth_meth_ast_new7167_object->definitionModule = modulename;
  meth_meth_ast_new7167_object->definitionLine = 1758;
  sourceObject = obj7160;
  sourceObject = obj7160;
  objclass7160 = obj7160->class;
  objclass7160->definitionModule = modulename;
  objclass7160->definitionLine = 1751;
  (*(struct UserObject *)self).data[0] = lowerouter7160;
  self = oldself7160;
  selfslot = oldselfslot7160;
  stackframe = oldstackframe7160;
// compiled object node returning obj7160 (depth = 2)
  *var_stringNode = obj7160;
  if (obj7160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "stringNode"
  block_savedest(self);
  Object closure7231 = createclosure(1, "stringNode");
  setclosureframe(closure7231, stackframe);
  addtoclosure(closure7231, var_stringNode);
  struct UserObject *uo7231 = (struct UserObject*)self;
  uo7231->data[35] = (Object)closure7231;
  Method *meth_meth_ast_stringNode7231 = addmethod2pos(self, "stringNode", &meth_ast_stringNode7231, 35);
  int argcv_meth_ast_stringNode7231[] = {0};
  meth_meth_ast_stringNode7231->type = alloc_MethodType(1, argcv_meth_ast_stringNode7231);
  meth_meth_ast_stringNode7231->definitionModule = modulename;
  meth_meth_ast_stringNode7231->definitionLine = 1759;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7232 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7232 = alloc_userobj2(2,4, objclass7232);
  gc_frame_newslot(obj7232);
// OBJECT OUTER DEC outer
  adddatum2(obj7232, self, 0);
  addmethodreal(obj7232,"outer", &reader_ast_outer_7233);
  Object oldself7232 = self;
  struct StackFrameObject *oldstackframe7232 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7232);
  gc_frame_newslot((Object)stackframe);
  self = obj7232;
  Object *oldselfslot7232 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7232 = (*(struct UserObject *)self).data[0], lowerouter7232 = thisouter7232;
  if (inheritingObject7232) {
    struct UserObject *inho7232 = (struct UserObject *)inheritingObject7232;
    while (inho7232->super != GraceDefaultObject) inho7232 = (struct UserObject *)inho7232->super;
    inho7232->super = obj7232;
    self = inheritingObject7232;
    *selfslot = self;
    lowerouter7232 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7232;
  }
// method "new"
  block_savedest(obj7232);
  Object closure7234 = createclosure(1, "new");
  setclosureframe(closure7234, stackframe);
  addtoclosure(closure7234, var_numNode);
  struct UserObject *uo7234 = (struct UserObject*)obj7232;
  uo7234->data[1] = (Object)closure7234;
  Method *meth_meth_ast_new7234 = addmethod2pos(obj7232, "new", &meth_ast_new7234, 1);
  int argcv_meth_ast_new7234[] = {1};
  meth_meth_ast_new7234->type = alloc_MethodType(1, argcv_meth_ast_new7234);
  meth_meth_ast_new7234->definitionModule = modulename;
  meth_meth_ast_new7234->definitionLine = 1784;
  block_savedest(obj7232);
  Object closure7301 = createclosure(1, "new()object");
  setclosureframe(closure7301, stackframe);
  addtoclosure(closure7301, var_numNode);
  Method *meth_meth_ast_new7234_object = addmethod2pos(obj7232, "new()object", &meth_ast_new7234_object, 1);
  meth_meth_ast_new7234_object->definitionModule = modulename;
  meth_meth_ast_new7234_object->definitionLine = 1784;
  sourceObject = obj7232;
  objclass7232 = obj7232->class;
  objclass7232->definitionModule = modulename;
  objclass7232->definitionLine = 1783;
  (*(struct UserObject *)self).data[0] = lowerouter7232;
  self = oldself7232;
  selfslot = oldselfslot7232;
  stackframe = oldstackframe7232;
// compiled object node returning obj7232 (depth = 2)
  *var_numNode = obj7232;
  if (obj7232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "numNode"
  block_savedest(self);
  Object closure7302 = createclosure(1, "numNode");
  setclosureframe(closure7302, stackframe);
  addtoclosure(closure7302, var_numNode);
  struct UserObject *uo7302 = (struct UserObject*)self;
  uo7302->data[36] = (Object)closure7302;
  Method *meth_meth_ast_numNode7302 = addmethod2pos(self, "numNode", &meth_ast_numNode7302, 36);
  int argcv_meth_ast_numNode7302[] = {0};
  meth_meth_ast_numNode7302->type = alloc_MethodType(1, argcv_meth_ast_numNode7302);
  meth_meth_ast_numNode7302->definitionModule = modulename;
  meth_meth_ast_numNode7302->definitionLine = 1785;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7303 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7303 = alloc_userobj2(2,4, objclass7303);
  gc_frame_newslot(obj7303);
// OBJECT OUTER DEC outer
  adddatum2(obj7303, self, 0);
  addmethodreal(obj7303,"outer", &reader_ast_outer_7304);
  Object oldself7303 = self;
  struct StackFrameObject *oldstackframe7303 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7303);
  gc_frame_newslot((Object)stackframe);
  self = obj7303;
  Object *oldselfslot7303 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7303 = (*(struct UserObject *)self).data[0], lowerouter7303 = thisouter7303;
  if (inheritingObject7303) {
    struct UserObject *inho7303 = (struct UserObject *)inheritingObject7303;
    while (inho7303->super != GraceDefaultObject) inho7303 = (struct UserObject *)inho7303->super;
    inho7303->super = obj7303;
    self = inheritingObject7303;
    *selfslot = self;
    lowerouter7303 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7303;
  }
// method "new"
  block_savedest(obj7303);
  Object closure7305 = createclosure(3, "new");
  setclosureframe(closure7305, stackframe);
  addtoclosure(closure7305, var_identifierNode);
  addtoclosure(closure7305, var_nullNode);
  addtoclosure(closure7305, var_opNode);
  struct UserObject *uo7305 = (struct UserObject*)obj7303;
  uo7305->data[1] = (Object)closure7305;
  Method *meth_meth_ast_new7305 = addmethod2pos(obj7303, "new", &meth_ast_new7305, 1);
  int argcv_meth_ast_new7305[] = {3};
  meth_meth_ast_new7305->type = alloc_MethodType(1, argcv_meth_ast_new7305);
  meth_meth_ast_new7305->definitionModule = modulename;
  meth_meth_ast_new7305->definitionLine = 1810;
  block_savedest(obj7303);
  Object closure7575 = createclosure(3, "new()object");
  setclosureframe(closure7575, stackframe);
  addtoclosure(closure7575, var_identifierNode);
  addtoclosure(closure7575, var_nullNode);
  addtoclosure(closure7575, var_opNode);
  Method *meth_meth_ast_new7305_object = addmethod2pos(obj7303, "new()object", &meth_ast_new7305_object, 1);
  meth_meth_ast_new7305_object->definitionModule = modulename;
  meth_meth_ast_new7305_object->definitionLine = 1810;
  sourceObject = obj7303;
  objclass7303 = obj7303->class;
  objclass7303->definitionModule = modulename;
  objclass7303->definitionLine = 1809;
  (*(struct UserObject *)self).data[0] = lowerouter7303;
  self = oldself7303;
  selfslot = oldselfslot7303;
  stackframe = oldstackframe7303;
// compiled object node returning obj7303 (depth = 2)
  *var_opNode = obj7303;
  if (obj7303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "opNode"
  block_savedest(self);
  Object closure7576 = createclosure(1, "opNode");
  setclosureframe(closure7576, stackframe);
  addtoclosure(closure7576, var_opNode);
  struct UserObject *uo7576 = (struct UserObject*)self;
  uo7576->data[37] = (Object)closure7576;
  Method *meth_meth_ast_opNode7576 = addmethod2pos(self, "opNode", &meth_ast_opNode7576, 37);
  int argcv_meth_ast_opNode7576[] = {0};
  meth_meth_ast_opNode7576->type = alloc_MethodType(1, argcv_meth_ast_opNode7576);
  meth_meth_ast_opNode7576->definitionModule = modulename;
  meth_meth_ast_opNode7576->definitionLine = 1811;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7577 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7577 = alloc_userobj2(2,4, objclass7577);
  gc_frame_newslot(obj7577);
// OBJECT OUTER DEC outer
  adddatum2(obj7577, self, 0);
  addmethodreal(obj7577,"outer", &reader_ast_outer_7578);
  Object oldself7577 = self;
  struct StackFrameObject *oldstackframe7577 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7577);
  gc_frame_newslot((Object)stackframe);
  self = obj7577;
  Object *oldselfslot7577 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7577 = (*(struct UserObject *)self).data[0], lowerouter7577 = thisouter7577;
  if (inheritingObject7577) {
    struct UserObject *inho7577 = (struct UserObject *)inheritingObject7577;
    while (inho7577->super != GraceDefaultObject) inho7577 = (struct UserObject *)inho7577->super;
    inho7577->super = obj7577;
    self = inheritingObject7577;
    *selfslot = self;
    lowerouter7577 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7577;
  }
// method "new"
  block_savedest(obj7577);
  Object closure7579 = createclosure(2, "new");
  setclosureframe(closure7579, stackframe);
  addtoclosure(closure7579, var_nullNode);
  addtoclosure(closure7579, var_indexNode);
  struct UserObject *uo7579 = (struct UserObject*)obj7577;
  uo7579->data[1] = (Object)closure7579;
  Method *meth_meth_ast_new7579 = addmethod2pos(obj7577, "new", &meth_ast_new7579, 1);
  int argcv_meth_ast_new7579[] = {2};
  meth_meth_ast_new7579->type = alloc_MethodType(1, argcv_meth_ast_new7579);
  meth_meth_ast_new7579->definitionModule = modulename;
  meth_meth_ast_new7579->definitionLine = 1877;
  block_savedest(obj7577);
  Object closure7735 = createclosure(2, "new()object");
  setclosureframe(closure7735, stackframe);
  addtoclosure(closure7735, var_nullNode);
  addtoclosure(closure7735, var_indexNode);
  Method *meth_meth_ast_new7579_object = addmethod2pos(obj7577, "new()object", &meth_ast_new7579_object, 1);
  meth_meth_ast_new7579_object->definitionModule = modulename;
  meth_meth_ast_new7579_object->definitionLine = 1877;
  sourceObject = obj7577;
  objclass7577 = obj7577->class;
  objclass7577->definitionModule = modulename;
  objclass7577->definitionLine = 1876;
  (*(struct UserObject *)self).data[0] = lowerouter7577;
  self = oldself7577;
  selfslot = oldselfslot7577;
  stackframe = oldstackframe7577;
// compiled object node returning obj7577 (depth = 2)
  *var_indexNode = obj7577;
  if (obj7577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indexNode"
  block_savedest(self);
  Object closure7736 = createclosure(1, "indexNode");
  setclosureframe(closure7736, stackframe);
  addtoclosure(closure7736, var_indexNode);
  struct UserObject *uo7736 = (struct UserObject*)self;
  uo7736->data[38] = (Object)closure7736;
  Method *meth_meth_ast_indexNode7736 = addmethod2pos(self, "indexNode", &meth_ast_indexNode7736, 38);
  int argcv_meth_ast_indexNode7736[] = {0};
  meth_meth_ast_indexNode7736->type = alloc_MethodType(1, argcv_meth_ast_indexNode7736);
  meth_meth_ast_indexNode7736->definitionModule = modulename;
  meth_meth_ast_indexNode7736->definitionLine = 1879;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7737 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7737 = alloc_userobj2(2,4, objclass7737);
  gc_frame_newslot(obj7737);
// OBJECT OUTER DEC outer
  adddatum2(obj7737, self, 0);
  addmethodreal(obj7737,"outer", &reader_ast_outer_7738);
  Object oldself7737 = self;
  struct StackFrameObject *oldstackframe7737 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7737);
  gc_frame_newslot((Object)stackframe);
  self = obj7737;
  Object *oldselfslot7737 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7737 = (*(struct UserObject *)self).data[0], lowerouter7737 = thisouter7737;
  if (inheritingObject7737) {
    struct UserObject *inho7737 = (struct UserObject *)inheritingObject7737;
    while (inho7737->super != GraceDefaultObject) inho7737 = (struct UserObject *)inho7737->super;
    inho7737->super = obj7737;
    self = inheritingObject7737;
    *selfslot = self;
    lowerouter7737 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7737;
  }
// method "new"
  block_savedest(obj7737);
  Object closure7739 = createclosure(1, "new");
  setclosureframe(closure7739, stackframe);
  addtoclosure(closure7739, var_bindNode);
  struct UserObject *uo7739 = (struct UserObject*)obj7737;
  uo7739->data[1] = (Object)closure7739;
  Method *meth_meth_ast_new7739 = addmethod2pos(obj7737, "new", &meth_ast_new7739, 1);
  int argcv_meth_ast_new7739[] = {2};
  meth_meth_ast_new7739->type = alloc_MethodType(1, argcv_meth_ast_new7739);
  meth_meth_ast_new7739->definitionModule = modulename;
  meth_meth_ast_new7739->definitionLine = 1924;
  block_savedest(obj7737);
  Object closure7910 = createclosure(1, "new()object");
  setclosureframe(closure7910, stackframe);
  addtoclosure(closure7910, var_bindNode);
  Method *meth_meth_ast_new7739_object = addmethod2pos(obj7737, "new()object", &meth_ast_new7739_object, 1);
  meth_meth_ast_new7739_object->definitionModule = modulename;
  meth_meth_ast_new7739_object->definitionLine = 1924;
  sourceObject = obj7737;
  objclass7737 = obj7737->class;
  objclass7737->definitionModule = modulename;
  objclass7737->definitionLine = 1923;
  (*(struct UserObject *)self).data[0] = lowerouter7737;
  self = oldself7737;
  selfslot = oldselfslot7737;
  stackframe = oldstackframe7737;
// compiled object node returning obj7737 (depth = 2)
  *var_bindNode = obj7737;
  if (obj7737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "bindNode"
  block_savedest(self);
  Object closure7911 = createclosure(1, "bindNode");
  setclosureframe(closure7911, stackframe);
  addtoclosure(closure7911, var_bindNode);
  struct UserObject *uo7911 = (struct UserObject*)self;
  uo7911->data[39] = (Object)closure7911;
  Method *meth_meth_ast_bindNode7911 = addmethod2pos(self, "bindNode", &meth_ast_bindNode7911, 39);
  int argcv_meth_ast_bindNode7911[] = {0};
  meth_meth_ast_bindNode7911->type = alloc_MethodType(1, argcv_meth_ast_bindNode7911);
  meth_meth_ast_bindNode7911->definitionModule = modulename;
  meth_meth_ast_bindNode7911->definitionLine = 1926;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7912 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7912 = alloc_userobj2(3,4, objclass7912);
  gc_frame_newslot(obj7912);
// OBJECT OUTER DEC outer
  adddatum2(obj7912, self, 0);
  addmethodreal(obj7912,"outer", &reader_ast_outer_7913);
  Object oldself7912 = self;
  struct StackFrameObject *oldstackframe7912 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7912);
  gc_frame_newslot((Object)stackframe);
  self = obj7912;
  Object *oldselfslot7912 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7912 = (*(struct UserObject *)self).data[0], lowerouter7912 = thisouter7912;
  if (inheritingObject7912) {
    struct UserObject *inho7912 = (struct UserObject *)inheritingObject7912;
    while (inho7912->super != GraceDefaultObject) inho7912 = (struct UserObject *)inho7912->super;
    inho7912->super = obj7912;
    self = inheritingObject7912;
    *selfslot = self;
    lowerouter7912 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7912;
  }
// method "new()scope"
  struct UserObject *uo7914 = (struct UserObject*)obj7912;
  uo7914->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope7914 = addmethod2pos(obj7912, "new()scope", &meth_ast_new_40__41_scope7914, 1);
  int argcv_meth_ast_new_40__41_scope7914[] = {3, 1};
  meth_meth_ast_new_40__41_scope7914->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope7914);
  meth_meth_ast_new_40__41_scope7914->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope7914->definitionLine = 1974;
// method "new"
  block_savedest(obj7912);
  Object closure7919 = createclosure(2, "new");
  setclosureframe(closure7919, stackframe);
  addtoclosure(closure7919, var_k);
  addtoclosure(closure7919, var_defDecNode);
  struct UserObject *uo7919 = (struct UserObject*)obj7912;
  uo7919->data[2] = (Object)closure7919;
  Method *meth_meth_ast_new7919 = addmethod2pos(obj7912, "new", &meth_ast_new7919, 2);
  int argcv_meth_ast_new7919[] = {3};
  meth_meth_ast_new7919->type = alloc_MethodType(1, argcv_meth_ast_new7919);
  meth_meth_ast_new7919->definitionModule = modulename;
  meth_meth_ast_new7919->definitionLine = 1980;
  block_savedest(obj7912);
  Object closure8378 = createclosure(2, "new()object");
  setclosureframe(closure8378, stackframe);
  addtoclosure(closure8378, var_k);
  addtoclosure(closure8378, var_defDecNode);
  Method *meth_meth_ast_new7919_object = addmethod2pos(obj7912, "new()object", &meth_ast_new7919_object, 2);
  meth_meth_ast_new7919_object->definitionModule = modulename;
  meth_meth_ast_new7919_object->definitionLine = 1980;
  sourceObject = obj7912;
  sourceObject = obj7912;
  objclass7912 = obj7912->class;
  objclass7912->definitionModule = modulename;
  objclass7912->definitionLine = 1973;
  (*(struct UserObject *)self).data[0] = lowerouter7912;
  self = oldself7912;
  selfslot = oldselfslot7912;
  stackframe = oldstackframe7912;
// compiled object node returning obj7912 (depth = 2)
  *var_defDecNode = obj7912;
  if (obj7912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defDecNode"
  block_savedest(self);
  Object closure8379 = createclosure(1, "defDecNode");
  setclosureframe(closure8379, stackframe);
  addtoclosure(closure8379, var_defDecNode);
  struct UserObject *uo8379 = (struct UserObject*)self;
  uo8379->data[40] = (Object)closure8379;
  Method *meth_meth_ast_defDecNode8379 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode8379, 40);
  int argcv_meth_ast_defDecNode8379[] = {0};
  meth_meth_ast_defDecNode8379->type = alloc_MethodType(1, argcv_meth_ast_defDecNode8379);
  meth_meth_ast_defDecNode8379->definitionModule = modulename;
  meth_meth_ast_defDecNode8379->definitionLine = 1987;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8380 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8380 = alloc_userobj2(2,4, objclass8380);
  gc_frame_newslot(obj8380);
// OBJECT OUTER DEC outer
  adddatum2(obj8380, self, 0);
  addmethodreal(obj8380,"outer", &reader_ast_outer_8381);
  Object oldself8380 = self;
  struct StackFrameObject *oldstackframe8380 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8380);
  gc_frame_newslot((Object)stackframe);
  self = obj8380;
  Object *oldselfslot8380 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8380 = (*(struct UserObject *)self).data[0], lowerouter8380 = thisouter8380;
  if (inheritingObject8380) {
    struct UserObject *inho8380 = (struct UserObject *)inheritingObject8380;
    while (inho8380->super != GraceDefaultObject) inho8380 = (struct UserObject *)inho8380->super;
    inho8380->super = obj8380;
    self = inheritingObject8380;
    *selfslot = self;
    lowerouter8380 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8380;
  }
// method "new"
  block_savedest(obj8380);
  Object closure8382 = createclosure(2, "new");
  setclosureframe(closure8382, stackframe);
  addtoclosure(closure8382, var_k);
  addtoclosure(closure8382, var_varDecNode);
  struct UserObject *uo8382 = (struct UserObject*)obj8380;
  uo8382->data[1] = (Object)closure8382;
  Method *meth_meth_ast_new8382 = addmethod2pos(obj8380, "new", &meth_ast_new8382, 1);
  int argcv_meth_ast_new8382[] = {3};
  meth_meth_ast_new8382->type = alloc_MethodType(1, argcv_meth_ast_new8382);
  meth_meth_ast_new8382->definitionModule = modulename;
  meth_meth_ast_new8382->definitionLine = 2091;
  block_savedest(obj8380);
  Object closure8838 = createclosure(2, "new()object");
  setclosureframe(closure8838, stackframe);
  addtoclosure(closure8838, var_k);
  addtoclosure(closure8838, var_varDecNode);
  Method *meth_meth_ast_new8382_object = addmethod2pos(obj8380, "new()object", &meth_ast_new8382_object, 1);
  meth_meth_ast_new8382_object->definitionModule = modulename;
  meth_meth_ast_new8382_object->definitionLine = 2091;
  sourceObject = obj8380;
  objclass8380 = obj8380->class;
  objclass8380->definitionModule = modulename;
  objclass8380->definitionLine = 2090;
  (*(struct UserObject *)self).data[0] = lowerouter8380;
  self = oldself8380;
  selfslot = oldselfslot8380;
  stackframe = oldstackframe8380;
// compiled object node returning obj8380 (depth = 2)
  *var_varDecNode = obj8380;
  if (obj8380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "varDecNode"
  block_savedest(self);
  Object closure8839 = createclosure(1, "varDecNode");
  setclosureframe(closure8839, stackframe);
  addtoclosure(closure8839, var_varDecNode);
  struct UserObject *uo8839 = (struct UserObject*)self;
  uo8839->data[41] = (Object)closure8839;
  Method *meth_meth_ast_varDecNode8839 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode8839, 41);
  int argcv_meth_ast_varDecNode8839[] = {0};
  meth_meth_ast_varDecNode8839->type = alloc_MethodType(1, argcv_meth_ast_varDecNode8839);
  meth_meth_ast_varDecNode8839->definitionModule = modulename;
  meth_meth_ast_varDecNode8839->definitionLine = 2098;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8840 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8840 = alloc_userobj2(2,4, objclass8840);
  gc_frame_newslot(obj8840);
// OBJECT OUTER DEC outer
  adddatum2(obj8840, self, 0);
  addmethodreal(obj8840,"outer", &reader_ast_outer_8841);
  Object oldself8840 = self;
  struct StackFrameObject *oldstackframe8840 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8840);
  gc_frame_newslot((Object)stackframe);
  self = obj8840;
  Object *oldselfslot8840 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8840 = (*(struct UserObject *)self).data[0], lowerouter8840 = thisouter8840;
  if (inheritingObject8840) {
    struct UserObject *inho8840 = (struct UserObject *)inheritingObject8840;
    while (inho8840->super != GraceDefaultObject) inho8840 = (struct UserObject *)inho8840->super;
    inho8840->super = obj8840;
    self = inheritingObject8840;
    *selfslot = self;
    lowerouter8840 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8840;
  }
// method "new"
  block_savedest(obj8840);
  Object closure8842 = createclosure(3, "new");
  setclosureframe(closure8842, stackframe);
  addtoclosure(closure8842, var_k);
  addtoclosure(closure8842, var_nullNode);
  addtoclosure(closure8842, var_importNode);
  struct UserObject *uo8842 = (struct UserObject*)obj8840;
  uo8842->data[1] = (Object)closure8842;
  Method *meth_meth_ast_new8842 = addmethod2pos(obj8840, "new", &meth_ast_new8842, 1);
  int argcv_meth_ast_new8842[] = {3};
  meth_meth_ast_new8842->type = alloc_MethodType(1, argcv_meth_ast_new8842);
  meth_meth_ast_new8842->definitionModule = modulename;
  meth_meth_ast_new8842->definitionLine = 2199;
  block_savedest(obj8840);
  Object closure9121 = createclosure(3, "new()object");
  setclosureframe(closure9121, stackframe);
  addtoclosure(closure9121, var_k);
  addtoclosure(closure9121, var_nullNode);
  addtoclosure(closure9121, var_importNode);
  Method *meth_meth_ast_new8842_object = addmethod2pos(obj8840, "new()object", &meth_ast_new8842_object, 1);
  meth_meth_ast_new8842_object->definitionModule = modulename;
  meth_meth_ast_new8842_object->definitionLine = 2199;
  sourceObject = obj8840;
  objclass8840 = obj8840->class;
  objclass8840->definitionModule = modulename;
  objclass8840->definitionLine = 2198;
  (*(struct UserObject *)self).data[0] = lowerouter8840;
  self = oldself8840;
  selfslot = oldselfslot8840;
  stackframe = oldstackframe8840;
// compiled object node returning obj8840 (depth = 2)
  *var_importNode = obj8840;
  if (obj8840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "importNode"
  block_savedest(self);
  Object closure9122 = createclosure(1, "importNode");
  setclosureframe(closure9122, stackframe);
  addtoclosure(closure9122, var_importNode);
  struct UserObject *uo9122 = (struct UserObject*)self;
  uo9122->data[42] = (Object)closure9122;
  Method *meth_meth_ast_importNode9122 = addmethod2pos(self, "importNode", &meth_ast_importNode9122, 42);
  int argcv_meth_ast_importNode9122[] = {0};
  meth_meth_ast_importNode9122->type = alloc_MethodType(1, argcv_meth_ast_importNode9122);
  meth_meth_ast_importNode9122->definitionModule = modulename;
  meth_meth_ast_importNode9122->definitionLine = 2204;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9123 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9123 = alloc_userobj2(2,4, objclass9123);
  gc_frame_newslot(obj9123);
// OBJECT OUTER DEC outer
  adddatum2(obj9123, self, 0);
  addmethodreal(obj9123,"outer", &reader_ast_outer_9124);
  Object oldself9123 = self;
  struct StackFrameObject *oldstackframe9123 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9123);
  gc_frame_newslot((Object)stackframe);
  self = obj9123;
  Object *oldselfslot9123 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9123 = (*(struct UserObject *)self).data[0], lowerouter9123 = thisouter9123;
  if (inheritingObject9123) {
    struct UserObject *inho9123 = (struct UserObject *)inheritingObject9123;
    while (inho9123->super != GraceDefaultObject) inho9123 = (struct UserObject *)inho9123->super;
    inho9123->super = obj9123;
    self = inheritingObject9123;
    *selfslot = self;
    lowerouter9123 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9123;
  }
// method "new"
  block_savedest(obj9123);
  Object closure9125 = createclosure(1, "new");
  setclosureframe(closure9125, stackframe);
  addtoclosure(closure9125, var_dialectNode);
  struct UserObject *uo9125 = (struct UserObject*)obj9123;
  uo9125->data[1] = (Object)closure9125;
  Method *meth_meth_ast_new9125 = addmethod2pos(obj9123, "new", &meth_ast_new9125, 1);
  int argcv_meth_ast_new9125[] = {1};
  meth_meth_ast_new9125->type = alloc_MethodType(1, argcv_meth_ast_new9125);
  meth_meth_ast_new9125->definitionModule = modulename;
  meth_meth_ast_new9125->definitionLine = 2276;
  block_savedest(obj9123);
  Object closure9237 = createclosure(1, "new()object");
  setclosureframe(closure9237, stackframe);
  addtoclosure(closure9237, var_dialectNode);
  Method *meth_meth_ast_new9125_object = addmethod2pos(obj9123, "new()object", &meth_ast_new9125_object, 1);
  meth_meth_ast_new9125_object->definitionModule = modulename;
  meth_meth_ast_new9125_object->definitionLine = 2276;
  sourceObject = obj9123;
  objclass9123 = obj9123->class;
  objclass9123->definitionModule = modulename;
  objclass9123->definitionLine = 2275;
  (*(struct UserObject *)self).data[0] = lowerouter9123;
  self = oldself9123;
  selfslot = oldselfslot9123;
  stackframe = oldstackframe9123;
// compiled object node returning obj9123 (depth = 2)
  *var_dialectNode = obj9123;
  if (obj9123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "dialectNode"
  block_savedest(self);
  Object closure9238 = createclosure(1, "dialectNode");
  setclosureframe(closure9238, stackframe);
  addtoclosure(closure9238, var_dialectNode);
  struct UserObject *uo9238 = (struct UserObject*)self;
  uo9238->data[43] = (Object)closure9238;
  Method *meth_meth_ast_dialectNode9238 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode9238, 43);
  int argcv_meth_ast_dialectNode9238[] = {0};
  meth_meth_ast_dialectNode9238->type = alloc_MethodType(1, argcv_meth_ast_dialectNode9238);
  meth_meth_ast_dialectNode9238->definitionModule = modulename;
  meth_meth_ast_dialectNode9238->definitionLine = 2277;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9239 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9239 = alloc_userobj2(2,4, objclass9239);
  gc_frame_newslot(obj9239);
// OBJECT OUTER DEC outer
  adddatum2(obj9239, self, 0);
  addmethodreal(obj9239,"outer", &reader_ast_outer_9240);
  Object oldself9239 = self;
  struct StackFrameObject *oldstackframe9239 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9239);
  gc_frame_newslot((Object)stackframe);
  self = obj9239;
  Object *oldselfslot9239 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9239 = (*(struct UserObject *)self).data[0], lowerouter9239 = thisouter9239;
  if (inheritingObject9239) {
    struct UserObject *inho9239 = (struct UserObject *)inheritingObject9239;
    while (inho9239->super != GraceDefaultObject) inho9239 = (struct UserObject *)inho9239->super;
    inho9239->super = obj9239;
    self = inheritingObject9239;
    *selfslot = self;
    lowerouter9239 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9239;
  }
// method "new"
  block_savedest(obj9239);
  Object closure9241 = createclosure(2, "new");
  setclosureframe(closure9241, stackframe);
  addtoclosure(closure9241, var_nullNode);
  addtoclosure(closure9241, var_returnNode);
  struct UserObject *uo9241 = (struct UserObject*)obj9239;
  uo9241->data[1] = (Object)closure9241;
  Method *meth_meth_ast_new9241 = addmethod2pos(obj9239, "new", &meth_ast_new9241, 1);
  int argcv_meth_ast_new9241[] = {1};
  meth_meth_ast_new9241->type = alloc_MethodType(1, argcv_meth_ast_new9241);
  meth_meth_ast_new9241->definitionModule = modulename;
  meth_meth_ast_new9241->definitionLine = 2324;
  block_savedest(obj9239);
  Object closure9327 = createclosure(2, "new()object");
  setclosureframe(closure9327, stackframe);
  addtoclosure(closure9327, var_nullNode);
  addtoclosure(closure9327, var_returnNode);
  Method *meth_meth_ast_new9241_object = addmethod2pos(obj9239, "new()object", &meth_ast_new9241_object, 1);
  meth_meth_ast_new9241_object->definitionModule = modulename;
  meth_meth_ast_new9241_object->definitionLine = 2324;
  sourceObject = obj9239;
  objclass9239 = obj9239->class;
  objclass9239->definitionModule = modulename;
  objclass9239->definitionLine = 2323;
  (*(struct UserObject *)self).data[0] = lowerouter9239;
  self = oldself9239;
  selfslot = oldselfslot9239;
  stackframe = oldstackframe9239;
// compiled object node returning obj9239 (depth = 2)
  *var_returnNode = obj9239;
  if (obj9239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "returnNode"
  block_savedest(self);
  Object closure9328 = createclosure(1, "returnNode");
  setclosureframe(closure9328, stackframe);
  addtoclosure(closure9328, var_returnNode);
  struct UserObject *uo9328 = (struct UserObject*)self;
  uo9328->data[44] = (Object)closure9328;
  Method *meth_meth_ast_returnNode9328 = addmethod2pos(self, "returnNode", &meth_ast_returnNode9328, 44);
  int argcv_meth_ast_returnNode9328[] = {0};
  meth_meth_ast_returnNode9328->type = alloc_MethodType(1, argcv_meth_ast_returnNode9328);
  meth_meth_ast_returnNode9328->definitionModule = modulename;
  meth_meth_ast_returnNode9328->definitionLine = 2325;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9329 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9329 = alloc_userobj2(3,4, objclass9329);
  gc_frame_newslot(obj9329);
// OBJECT OUTER DEC outer
  adddatum2(obj9329, self, 0);
  addmethodreal(obj9329,"outer", &reader_ast_outer_9330);
  Object oldself9329 = self;
  struct StackFrameObject *oldstackframe9329 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9329);
  gc_frame_newslot((Object)stackframe);
  self = obj9329;
  Object *oldselfslot9329 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9329 = (*(struct UserObject *)self).data[0], lowerouter9329 = thisouter9329;
  if (inheritingObject9329) {
    struct UserObject *inho9329 = (struct UserObject *)inheritingObject9329;
    while (inho9329->super != GraceDefaultObject) inho9329 = (struct UserObject *)inho9329->super;
    inho9329->super = obj9329;
    self = inheritingObject9329;
    *selfslot = self;
    lowerouter9329 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9329;
  }
// method "new()scope"
  struct UserObject *uo9331 = (struct UserObject*)obj9329;
  uo9331->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope9331 = addmethod2pos(obj9329, "new()scope", &meth_ast_new_40__41_scope9331, 1);
  int argcv_meth_ast_new_40__41_scope9331[] = {1, 1};
  meth_meth_ast_new_40__41_scope9331->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope9331);
  meth_meth_ast_new_40__41_scope9331->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope9331->definitionLine = 2359;
// method "new"
  block_savedest(obj9329);
  Object closure9336 = createclosure(3, "new");
  setclosureframe(closure9336, stackframe);
  addtoclosure(closure9336, var_k);
  addtoclosure(closure9336, var_nullNode);
  addtoclosure(closure9336, var_inheritsNode);
  struct UserObject *uo9336 = (struct UserObject*)obj9329;
  uo9336->data[2] = (Object)closure9336;
  Method *meth_meth_ast_new9336 = addmethod2pos(obj9329, "new", &meth_ast_new9336, 2);
  int argcv_meth_ast_new9336[] = {1};
  meth_meth_ast_new9336->type = alloc_MethodType(1, argcv_meth_ast_new9336);
  meth_meth_ast_new9336->definitionModule = modulename;
  meth_meth_ast_new9336->definitionLine = 2364;
  block_savedest(obj9329);
  Object closure9699 = createclosure(3, "new()object");
  setclosureframe(closure9699, stackframe);
  addtoclosure(closure9699, var_k);
  addtoclosure(closure9699, var_nullNode);
  addtoclosure(closure9699, var_inheritsNode);
  Method *meth_meth_ast_new9336_object = addmethod2pos(obj9329, "new()object", &meth_ast_new9336_object, 2);
  meth_meth_ast_new9336_object->definitionModule = modulename;
  meth_meth_ast_new9336_object->definitionLine = 2364;
  sourceObject = obj9329;
  sourceObject = obj9329;
  objclass9329 = obj9329->class;
  objclass9329->definitionModule = modulename;
  objclass9329->definitionLine = 2358;
  (*(struct UserObject *)self).data[0] = lowerouter9329;
  self = oldself9329;
  selfslot = oldselfslot9329;
  stackframe = oldstackframe9329;
// compiled object node returning obj9329 (depth = 2)
  *var_inheritsNode = obj9329;
  if (obj9329 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "inheritsNode"
  block_savedest(self);
  Object closure9700 = createclosure(1, "inheritsNode");
  setclosureframe(closure9700, stackframe);
  addtoclosure(closure9700, var_inheritsNode);
  struct UserObject *uo9700 = (struct UserObject*)self;
  uo9700->data[45] = (Object)closure9700;
  Method *meth_meth_ast_inheritsNode9700 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode9700, 45);
  int argcv_meth_ast_inheritsNode9700[] = {0};
  meth_meth_ast_inheritsNode9700->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode9700);
  meth_meth_ast_inheritsNode9700->definitionModule = modulename;
  meth_meth_ast_inheritsNode9700->definitionLine = 2370;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AliasPair
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type9702 = alloc_Type("AliasPair", 2);
    add_Method((ClassData)type9702, "newName", NULL);
    add_Method((ClassData)type9702, "oldName", NULL);
// compiled typeliteral node returning type9702 (depth = 2)
  *var_AliasPair = type9702;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AliasPair"
  block_savedest(self);
  Object closure9703 = createclosure(1, "AliasPair");
  setclosureframe(closure9703, stackframe);
  addtoclosure(closure9703, var_AliasPair);
  struct UserObject *uo9703 = (struct UserObject*)self;
  uo9703->data[46] = (Object)closure9703;
  Method *meth_meth_ast_AliasPair9703 = addmethod2pos(self, "AliasPair", &meth_ast_AliasPair9703, 46);
  int argcv_meth_ast_AliasPair9703[] = {0};
  meth_meth_ast_AliasPair9703->type = alloc_MethodType(1, argcv_meth_ast_AliasPair9703);
  meth_meth_ast_AliasPair9703->definitionModule = modulename;
  meth_meth_ast_AliasPair9703->definitionLine = 2370;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9704 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9704 = alloc_userobj2(2,4, objclass9704);
  gc_frame_newslot(obj9704);
// OBJECT OUTER DEC outer
  adddatum2(obj9704, self, 0);
  addmethodreal(obj9704,"outer", &reader_ast_outer_9705);
  Object oldself9704 = self;
  struct StackFrameObject *oldstackframe9704 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9704);
  gc_frame_newslot((Object)stackframe);
  self = obj9704;
  Object *oldselfslot9704 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9704 = (*(struct UserObject *)self).data[0], lowerouter9704 = thisouter9704;
  if (inheritingObject9704) {
    struct UserObject *inho9704 = (struct UserObject *)inheritingObject9704;
    while (inho9704->super != GraceDefaultObject) inho9704 = (struct UserObject *)inho9704->super;
    inho9704->super = obj9704;
    self = inheritingObject9704;
    *selfslot = self;
    lowerouter9704 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9704;
  }
// method "new"
  block_savedest(obj9704);
  Object closure9706 = createclosure(1, "new");
  setclosureframe(closure9706, stackframe);
  addtoclosure(closure9706, var_blankNode);
  struct UserObject *uo9706 = (struct UserObject*)obj9704;
  uo9706->data[1] = (Object)closure9706;
  Method *meth_meth_ast_new9706 = addmethod2pos(obj9704, "new", &meth_ast_new9706, 1);
  int argcv_meth_ast_new9706[] = {0};
  meth_meth_ast_new9706->type = alloc_MethodType(1, argcv_meth_ast_new9706);
  meth_meth_ast_new9706->definitionModule = modulename;
  meth_meth_ast_new9706->definitionLine = 2480;
  block_savedest(obj9704);
  Object closure9742 = createclosure(1, "new()object");
  setclosureframe(closure9742, stackframe);
  addtoclosure(closure9742, var_blankNode);
  Method *meth_meth_ast_new9706_object = addmethod2pos(obj9704, "new()object", &meth_ast_new9706_object, 1);
  meth_meth_ast_new9706_object->definitionModule = modulename;
  meth_meth_ast_new9706_object->definitionLine = 2480;
  sourceObject = obj9704;
  objclass9704 = obj9704->class;
  objclass9704->definitionModule = modulename;
  objclass9704->definitionLine = 2479;
  (*(struct UserObject *)self).data[0] = lowerouter9704;
  self = oldself9704;
  selfslot = oldselfslot9704;
  stackframe = oldstackframe9704;
// compiled object node returning obj9704 (depth = 2)
  *var_blankNode = obj9704;
  if (obj9704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankNode"
  block_savedest(self);
  Object closure9743 = createclosure(1, "blankNode");
  setclosureframe(closure9743, stackframe);
  addtoclosure(closure9743, var_blankNode);
  struct UserObject *uo9743 = (struct UserObject*)self;
  uo9743->data[47] = (Object)closure9743;
  Method *meth_meth_ast_blankNode9743 = addmethod2pos(self, "blankNode", &meth_ast_blankNode9743, 47);
  int argcv_meth_ast_blankNode9743[] = {0};
  meth_meth_ast_blankNode9743->type = alloc_MethodType(1, argcv_meth_ast_blankNode9743);
  meth_meth_ast_blankNode9743->definitionModule = modulename;
  meth_meth_ast_blankNode9743->definitionLine = 2481;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9744 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9744 = alloc_userobj2(8,9, objclass9744);
  gc_frame_newslot(obj9744);
// OBJECT OUTER DEC outer
  adddatum2(obj9744, self, 0);
  addmethodreal(obj9744,"outer", &reader_ast_outer_9745);
  Object oldself9744 = self;
  struct StackFrameObject *oldstackframe9744 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9744);
  gc_frame_newslot((Object)stackframe);
  self = obj9744;
  Object *oldselfslot9744 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9744 = (*(struct UserObject *)self).data[0], lowerouter9744 = thisouter9744;
  if (inheritingObject9744) {
    struct UserObject *inho9744 = (struct UserObject *)inheritingObject9744;
    while (inho9744->super != GraceDefaultObject) inho9744 = (struct UserObject *)inho9744->super;
    inho9744->super = obj9744;
    self = inheritingObject9744;
    *selfslot = self;
    lowerouter9744 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9744;
  }
// method "new"
  struct UserObject *uo9746 = (struct UserObject*)obj9744;
  uo9746->data[1] = emptyclosure;
  Method *meth_meth_ast_new9746 = addmethod2pos(obj9744, "new", &meth_ast_new9746, 1);
  int argcv_meth_ast_new9746[] = {0};
  meth_meth_ast_new9746->type = alloc_MethodType(1, argcv_meth_ast_new9746);
  meth_meth_ast_new9746->definitionModule = modulename;
  meth_meth_ast_new9746->definitionLine = 2504;
// method "partName()scope"
  struct UserObject *uo9752 = (struct UserObject*)obj9744;
  uo9752->data[2] = emptyclosure;
  Method *meth_meth_ast_partName_40__41_scope9752 = addmethod2pos(obj9744, "partName()scope", &meth_ast_partName_40__41_scope9752, 2);
  int argcv_meth_ast_partName_40__41_scope9752[] = {1, 1};
  meth_meth_ast_partName_40__41_scope9752->type = alloc_MethodType(2, argcv_meth_ast_partName_40__41_scope9752);
  meth_meth_ast_partName_40__41_scope9752->definitionModule = modulename;
  meth_meth_ast_partName_40__41_scope9752->definitionLine = 2507;
// method "partName()params()scope"
  struct UserObject *uo9759 = (struct UserObject*)obj9744;
  uo9759->data[3] = emptyclosure;
  Method *meth_meth_ast_partName_40__41_params_40__41_scope9759 = addmethod2pos(obj9744, "partName()params()scope", &meth_ast_partName_40__41_params_40__41_scope9759, 3);
  int argcv_meth_ast_partName_40__41_params_40__41_scope9759[] = {1, 1, 1};
  meth_meth_ast_partName_40__41_params_40__41_scope9759->type = alloc_MethodType(3, argcv_meth_ast_partName_40__41_params_40__41_scope9759);
  meth_meth_ast_partName_40__41_params_40__41_scope9759->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params_40__41_scope9759->definitionLine = 2512;
// method "partName()params()variableParam()scope"
  struct UserObject *uo9765 = (struct UserObject*)obj9744;
  uo9765->data[4] = emptyclosure;
  Method *meth_meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765 = addmethod2pos(obj9744, "partName()params()variableParam()scope", &meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765, 4);
  int argcv_meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765[] = {1, 1, 1, 1};
  meth_meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765->type = alloc_MethodType(4, argcv_meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765);
  meth_meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params_40__41_variableParam_40__41_scope9765->definitionLine = 2517;
// method "partName"
  struct UserObject *uo9770 = (struct UserObject*)obj9744;
  uo9770->data[5] = emptyclosure;
  Method *meth_meth_ast_partName9770 = addmethod2pos(obj9744, "partName", &meth_ast_partName9770, 5);
  int argcv_meth_ast_partName9770[] = {1};
  meth_meth_ast_partName9770->type = alloc_MethodType(1, argcv_meth_ast_partName9770);
  meth_meth_ast_partName9770->definitionModule = modulename;
  meth_meth_ast_partName9770->definitionLine = 2522;
// method "partName()params"
  struct UserObject *uo9775 = (struct UserObject*)obj9744;
  uo9775->data[6] = emptyclosure;
  Method *meth_meth_ast_partName_40__41_params9775 = addmethod2pos(obj9744, "partName()params", &meth_ast_partName_40__41_params9775, 6);
  int argcv_meth_ast_partName_40__41_params9775[] = {1, 1};
  meth_meth_ast_partName_40__41_params9775->type = alloc_MethodType(2, argcv_meth_ast_partName_40__41_params9775);
  meth_meth_ast_partName_40__41_params9775->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params9775->definitionLine = 2525;
// method "partName()params()variableParam"
  block_savedest(obj9744);
  Object closure9779 = createclosure(2, "partName()params()variableParam");
  setclosureframe(closure9779, stackframe);
  addtoclosure(closure9779, var_k);
  addtoclosure(closure9779, var_signaturePart);
  struct UserObject *uo9779 = (struct UserObject*)obj9744;
  uo9779->data[7] = (Object)closure9779;
  Method *meth_meth_ast_partName_40__41_params_40__41_variableParam9779 = addmethod2pos(obj9744, "partName()params()variableParam", &meth_ast_partName_40__41_params_40__41_variableParam9779, 7);
  int argcv_meth_ast_partName_40__41_params_40__41_variableParam9779[] = {1, 1, 1};
  meth_meth_ast_partName_40__41_params_40__41_variableParam9779->type = alloc_MethodType(3, argcv_meth_ast_partName_40__41_params_40__41_variableParam9779);
  meth_meth_ast_partName_40__41_params_40__41_variableParam9779->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params_40__41_variableParam9779->definitionLine = 2528;
  block_savedest(obj9744);
  Object closure10073 = createclosure(2, "partName()params()variableParam()object");
  setclosureframe(closure10073, stackframe);
  addtoclosure(closure10073, var_k);
  addtoclosure(closure10073, var_signaturePart);
  Method *meth_meth_ast_partName_40__41_params_40__41_variableParam9779_object = addmethod2pos(obj9744, "partName()params()variableParam()object", &meth_ast_partName_40__41_params_40__41_variableParam9779_object, 7);
  meth_meth_ast_partName_40__41_params_40__41_variableParam9779_object->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params_40__41_variableParam9779_object->definitionLine = 2528;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  sourceObject = obj9744;
  objclass9744 = obj9744->class;
  objclass9744->definitionModule = modulename;
  objclass9744->definitionLine = 2503;
  (*(struct UserObject *)self).data[0] = lowerouter9744;
  self = oldself9744;
  selfslot = oldselfslot9744;
  stackframe = oldstackframe9744;
// compiled object node returning obj9744 (depth = 2)
  *var_signaturePart = obj9744;
  if (obj9744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "signaturePart"
  block_savedest(self);
  Object closure10074 = createclosure(1, "signaturePart");
  setclosureframe(closure10074, stackframe);
  addtoclosure(closure10074, var_signaturePart);
  struct UserObject *uo10074 = (struct UserObject*)self;
  uo10074->data[48] = (Object)closure10074;
  Method *meth_meth_ast_signaturePart10074 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart10074, 48);
  int argcv_meth_ast_signaturePart10074[] = {0};
  meth_meth_ast_signaturePart10074->type = alloc_MethodType(1, argcv_meth_ast_signaturePart10074);
  meth_meth_ast_signaturePart10074->definitionModule = modulename;
  meth_meth_ast_signaturePart10074->definitionLine = 2529;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10075 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10075 = alloc_userobj2(4,5, objclass10075);
  gc_frame_newslot(obj10075);
// OBJECT OUTER DEC outer
  adddatum2(obj10075, self, 0);
  addmethodreal(obj10075,"outer", &reader_ast_outer_10076);
  Object oldself10075 = self;
  struct StackFrameObject *oldstackframe10075 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10075);
  gc_frame_newslot((Object)stackframe);
  self = obj10075;
  Object *oldselfslot10075 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10075 = (*(struct UserObject *)self).data[0], lowerouter10075 = thisouter10075;
  if (inheritingObject10075) {
    struct UserObject *inho10075 = (struct UserObject *)inheritingObject10075;
    while (inho10075->super != GraceDefaultObject) inho10075 = (struct UserObject *)inho10075->super;
    inho10075->super = obj10075;
    self = inheritingObject10075;
    *selfslot = self;
    lowerouter10075 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10075;
  }
// method "new"
  struct UserObject *uo10077 = (struct UserObject*)obj10075;
  uo10077->data[1] = emptyclosure;
  Method *meth_meth_ast_new10077 = addmethod2pos(obj10075, "new", &meth_ast_new10077, 1);
  int argcv_meth_ast_new10077[] = {0};
  meth_meth_ast_new10077->type = alloc_MethodType(1, argcv_meth_ast_new10077);
  meth_meth_ast_new10077->definitionModule = modulename;
  meth_meth_ast_new10077->definitionLine = 2592;
// method "request()withArgs()scope"
  struct UserObject *uo10082 = (struct UserObject*)obj10075;
  uo10082->data[2] = emptyclosure;
  Method *meth_meth_ast_request_40__41_withArgs_40__41_scope10082 = addmethod2pos(obj10075, "request()withArgs()scope", &meth_ast_request_40__41_withArgs_40__41_scope10082, 2);
  int argcv_meth_ast_request_40__41_withArgs_40__41_scope10082[] = {1, 1, 1};
  meth_meth_ast_request_40__41_withArgs_40__41_scope10082->type = alloc_MethodType(3, argcv_meth_ast_request_40__41_withArgs_40__41_scope10082);
  meth_meth_ast_request_40__41_withArgs_40__41_scope10082->definitionModule = modulename;
  meth_meth_ast_request_40__41_withArgs_40__41_scope10082->definitionLine = 2595;
// method "request()withArgs"
  block_savedest(obj10075);
  Object closure10087 = createclosure(1, "request()withArgs");
  setclosureframe(closure10087, stackframe);
  addtoclosure(closure10087, var_callWithPart);
  struct UserObject *uo10087 = (struct UserObject*)obj10075;
  uo10087->data[3] = (Object)closure10087;
  Method *meth_meth_ast_request_40__41_withArgs10087 = addmethod2pos(obj10075, "request()withArgs", &meth_ast_request_40__41_withArgs10087, 3);
  int argcv_meth_ast_request_40__41_withArgs10087[] = {1, 1};
  meth_meth_ast_request_40__41_withArgs10087->type = alloc_MethodType(2, argcv_meth_ast_request_40__41_withArgs10087);
meth_meth_ast_request_40__41_withArgs10087->type->types[0] = type_String;
meth_meth_ast_request_40__41_withArgs10087->type->names[0] = "rPart";
  meth_meth_ast_request_40__41_withArgs10087->definitionModule = modulename;
  meth_meth_ast_request_40__41_withArgs10087->definitionLine = 2600;
  block_savedest(obj10075);
  Object closure10224 = createclosure(1, "request()withArgs()object");
  setclosureframe(closure10224, stackframe);
  addtoclosure(closure10224, var_callWithPart);
  Method *meth_meth_ast_request_40__41_withArgs10087_object = addmethod2pos(obj10075, "request()withArgs()object", &meth_ast_request_40__41_withArgs10087_object, 3);
  meth_meth_ast_request_40__41_withArgs10087_object->definitionModule = modulename;
  meth_meth_ast_request_40__41_withArgs10087_object->definitionLine = 2600;
  sourceObject = obj10075;
  sourceObject = obj10075;
  sourceObject = obj10075;
  objclass10075 = obj10075->class;
  objclass10075->definitionModule = modulename;
  objclass10075->definitionLine = 2591;
  (*(struct UserObject *)self).data[0] = lowerouter10075;
  self = oldself10075;
  selfslot = oldselfslot10075;
  stackframe = oldstackframe10075;
// compiled object node returning obj10075 (depth = 2)
  *var_callWithPart = obj10075;
  if (obj10075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "callWithPart"
  block_savedest(self);
  Object closure10225 = createclosure(1, "callWithPart");
  setclosureframe(closure10225, stackframe);
  addtoclosure(closure10225, var_callWithPart);
  struct UserObject *uo10225 = (struct UserObject*)self;
  uo10225->data[49] = (Object)closure10225;
  Method *meth_meth_ast_callWithPart10225 = addmethod2pos(self, "callWithPart", &meth_ast_callWithPart10225, 49);
  int argcv_meth_ast_callWithPart10225[] = {0};
  meth_meth_ast_callWithPart10225->type = alloc_MethodType(1, argcv_meth_ast_callWithPart10225);
  meth_meth_ast_callWithPart10225->definitionModule = modulename;
  meth_meth_ast_callWithPart10225->definitionLine = 2601;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10226 = alloc_userobj2(2,4, objclass10226);
  gc_frame_newslot(obj10226);
// OBJECT OUTER DEC outer
  adddatum2(obj10226, self, 0);
  addmethodreal(obj10226,"outer", &reader_ast_outer_10227);
  Object oldself10226 = self;
  struct StackFrameObject *oldstackframe10226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10226);
  gc_frame_newslot((Object)stackframe);
  self = obj10226;
  Object *oldselfslot10226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10226 = (*(struct UserObject *)self).data[0], lowerouter10226 = thisouter10226;
  if (inheritingObject10226) {
    struct UserObject *inho10226 = (struct UserObject *)inheritingObject10226;
    while (inho10226->super != GraceDefaultObject) inho10226 = (struct UserObject *)inho10226->super;
    inho10226->super = obj10226;
    self = inheritingObject10226;
    *selfslot = self;
    lowerouter10226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10226;
  }
// method "new"
  block_savedest(obj10226);
  Object closure10228 = createclosure(4, "new");
  setclosureframe(closure10228, stackframe);
  addtoclosure(closure10228, var_lineLength);
  addtoclosure(closure10228, var_nullNode);
  addtoclosure(closure10228, var_commentNode);
  addtoclosure(closure10228, var_util);
  struct UserObject *uo10228 = (struct UserObject*)obj10226;
  uo10228->data[1] = (Object)closure10228;
  Method *meth_meth_ast_new10228 = addmethod2pos(obj10226, "new", &meth_ast_new10228, 1);
  int argcv_meth_ast_new10228[] = {1};
  meth_meth_ast_new10228->type = alloc_MethodType(1, argcv_meth_ast_new10228);
  meth_meth_ast_new10228->definitionModule = modulename;
  meth_meth_ast_new10228->definitionLine = 2638;
  block_savedest(obj10226);
  Object closure10430 = createclosure(4, "new()object");
  setclosureframe(closure10430, stackframe);
  addtoclosure(closure10430, var_lineLength);
  addtoclosure(closure10430, var_nullNode);
  addtoclosure(closure10430, var_commentNode);
  addtoclosure(closure10430, var_util);
  Method *meth_meth_ast_new10228_object = addmethod2pos(obj10226, "new()object", &meth_ast_new10228_object, 1);
  meth_meth_ast_new10228_object->definitionModule = modulename;
  meth_meth_ast_new10228_object->definitionLine = 2638;
  sourceObject = obj10226;
  objclass10226 = obj10226->class;
  objclass10226->definitionModule = modulename;
  objclass10226->definitionLine = 2637;
  (*(struct UserObject *)self).data[0] = lowerouter10226;
  self = oldself10226;
  selfslot = oldselfslot10226;
  stackframe = oldstackframe10226;
// compiled object node returning obj10226 (depth = 2)
  *var_commentNode = obj10226;
  if (obj10226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "commentNode"
  block_savedest(self);
  Object closure10431 = createclosure(1, "commentNode");
  setclosureframe(closure10431, stackframe);
  addtoclosure(closure10431, var_commentNode);
  struct UserObject *uo10431 = (struct UserObject*)self;
  uo10431->data[50] = (Object)closure10431;
  Method *meth_meth_ast_commentNode10431 = addmethod2pos(self, "commentNode", &meth_ast_commentNode10431, 50);
  int argcv_meth_ast_commentNode10431[] = {0};
  meth_meth_ast_commentNode10431->type = alloc_MethodType(1, argcv_meth_ast_commentNode10431);
  meth_meth_ast_commentNode10431->definitionModule = modulename;
  meth_meth_ast_commentNode10431->definitionLine = 2644;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ASTVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type10433 = alloc_Type("ASTVisitor", 30);
    add_Method((ClassData)type10433, "visitIf()up", NULL);
    add_Method((ClassData)type10433, "visitBlock()up", NULL);
    add_Method((ClassData)type10433, "visitMatchCase()up", NULL);
    add_Method((ClassData)type10433, "visitTryCatch()up", NULL);
    add_Method((ClassData)type10433, "visitMethodType()up", NULL);
    add_Method((ClassData)type10433, "visitSignaturePart()up", NULL);
    add_Method((ClassData)type10433, "visitTypeLiteral()up", NULL);
    add_Method((ClassData)type10433, "visitTypeParameters()up", NULL);
    add_Method((ClassData)type10433, "visitTypeDec()up", NULL);
    add_Method((ClassData)type10433, "visitMethod()up", NULL);
    add_Method((ClassData)type10433, "visitCall()up", NULL);
    add_Method((ClassData)type10433, "visitObject()up", NULL);
    add_Method((ClassData)type10433, "visitModule()up", NULL);
    add_Method((ClassData)type10433, "visitArray()up", NULL);
    add_Method((ClassData)type10433, "visitMember()up", NULL);
    add_Method((ClassData)type10433, "visitGeneric()up", NULL);
    add_Method((ClassData)type10433, "visitIdentifier()up", NULL);
    add_Method((ClassData)type10433, "visitString()up", NULL);
    add_Method((ClassData)type10433, "visitNum()up", NULL);
    add_Method((ClassData)type10433, "visitOp()up", NULL);
    add_Method((ClassData)type10433, "visitIndex()up", NULL);
    add_Method((ClassData)type10433, "visitBind()up", NULL);
    add_Method((ClassData)type10433, "visitDefDec()up", NULL);
    add_Method((ClassData)type10433, "visitVarDec()up", NULL);
    add_Method((ClassData)type10433, "visitImport()up", NULL);
    add_Method((ClassData)type10433, "visitReturn()up", NULL);
    add_Method((ClassData)type10433, "visitInherits()up", NULL);
    add_Method((ClassData)type10433, "visitDialect()up", NULL);
    add_Method((ClassData)type10433, "visitBlank()up", NULL);
    add_Method((ClassData)type10433, "visitComment()up", NULL);
// compiled typeliteral node returning type10433 (depth = 2)
  *var_ASTVisitor = type10433;
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ASTVisitor"
  block_savedest(self);
  Object closure10434 = createclosure(1, "ASTVisitor");
  setclosureframe(closure10434, stackframe);
  addtoclosure(closure10434, var_ASTVisitor);
  struct UserObject *uo10434 = (struct UserObject*)self;
  uo10434->data[51] = (Object)closure10434;
  Method *meth_meth_ast_ASTVisitor10434 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor10434, 51);
  int argcv_meth_ast_ASTVisitor10434[] = {0};
  meth_meth_ast_ASTVisitor10434->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor10434);
  meth_meth_ast_ASTVisitor10434->definitionModule = modulename;
  meth_meth_ast_ASTVisitor10434->definitionLine = 2644;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10435 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10435 = alloc_userobj2(1,2, objclass10435);
  gc_frame_newslot(obj10435);
// OBJECT OUTER DEC outer
  adddatum2(obj10435, self, 0);
  addmethodreal(obj10435,"outer", &reader_ast_outer_10436);
  Object oldself10435 = self;
  struct StackFrameObject *oldstackframe10435 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10435);
  gc_frame_newslot((Object)stackframe);
  self = obj10435;
  Object *oldselfslot10435 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10435 = (*(struct UserObject *)self).data[0], lowerouter10435 = thisouter10435;
  if (inheritingObject10435) {
    struct UserObject *inho10435 = (struct UserObject *)inheritingObject10435;
    while (inho10435->super != GraceDefaultObject) inho10435 = (struct UserObject *)inho10435->super;
    inho10435->super = obj10435;
    self = inheritingObject10435;
    *selfslot = self;
    lowerouter10435 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10435;
  }
// method "visitCall()up"
  struct UserObject *uo10437 = (struct UserObject*)obj10435;
  uo10437->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up10437 = addmethod2pos(obj10435, "visitCall()up", &meth_ast_visitCall_40__41_up10437, 1);
  int argcv_meth_ast_visitCall_40__41_up10437[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up10437->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up10437);
  meth_meth_ast_visitCall_40__41_up10437->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up10437->definitionLine = 2869;
  sourceObject = obj10435;
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10442 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10443 = gc_frame_new();
// call case 3: self.outer request
  Object call10444 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10443);
// compiled call node returning call10444 (depth = 5)
// compiled member node returning call10444 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10445 = callmethodflags(call10444, "baseVisitor()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10442);
// compiled call node returning call10445 (depth = 3)
  struct UserObject *obj10435_uo = (struct UserObject *)obj10435;
  obj10435_uo->super = call10445;
  sourceObject = obj10435;
  objclass10435 = obj10435->class;
  objclass10435->definitionModule = modulename;
  objclass10435->definitionLine = 2867;
  (*(struct UserObject *)self).data[0] = lowerouter10435;
  self = oldself10435;
  selfslot = oldselfslot10435;
  stackframe = oldstackframe10435;
// compiled object node returning obj10435 (depth = 2)
  *var_patternMarkVisitor = obj10435;
  if (obj10435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "patternMarkVisitor"
  block_savedest(self);
  Object closure10446 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure10446, stackframe);
  addtoclosure(closure10446, var_patternMarkVisitor);
  struct UserObject *uo10446 = (struct UserObject*)self;
  uo10446->data[52] = (Object)closure10446;
  Method *meth_meth_ast_patternMarkVisitor10446 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor10446, 52);
  int argcv_meth_ast_patternMarkVisitor10446[] = {0};
  meth_meth_ast_patternMarkVisitor10446->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor10446);
  meth_meth_ast_patternMarkVisitor10446->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor10446->definitionLine = 2868;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
