#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "cd3e574fdd2e41661ad9235356bfb71684d9b9bc";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"errormessages\" as errormessages",
  "",
  "var blankLocation := 0",
  "var lastLine := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var values := list.empty",
  "var moduleObject",
  "var comments := list.empty",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "var braceIsType := false",
  "var defaultDefVisibility := \"confidential\"",
  "var defaultVarVisibility := \"confidential\"",
  "var defaultMethodVisibility := \"public\"",
  "def emptySequence = sequence.empty",
  "",
  "// sym is a module-level field containing the current token",
  "var sym := object {",
  "    def kind is public = \"start\"",
  "    def line is public = 0",
  "    def linePos is public = 0",
  "    def indent is public = 0",
  "    def value is public = \"\"",
  "    def size is public = 0",
  "}",
  "",
  "var lastToken := sym",
  "var previousCommentToken := lastToken",
  "var statementToken := lastToken     // the token starting the current statement",
  "var comment := false",
  "",
  "method noteBlank {",
  "    blankLocation := sym.line - 1",
  "}",
  "",
  "var firstCallOfNext := true",
  "",
  "method next {",
  "    // Advance to the next token in the stream, assigning it to sym.",
  "    // Put the position in the input into util module variables.",
  "",
  "    if (tokens.size > 0) then {",
  "        lastToken := sym",
  "        lastLine := lastToken.line",
  "        lastIndent := lastToken.indent",
  "        sym := tokens.poll",
  "        if (sym.line > (lastLine + 1)) then { noteBlank }",
  "        pushComments",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        errormessages.syntaxError(\"unexpectedly found the end of the input. \" ",
  "            ++ \"This is often caused by a missing '\\}'\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "    }",
  "}",
  "",
  "",
  "method findNextToken(tokenMatcher) {",
  "    // Search for the next token for which the given block returns true.",
  "    // Used for generating suggestions.",
  "",
  "    if (tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }.andAlso { n.indent >= lastToken.indent }} do {",
  "        if(tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if(((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }} do {",
  "        if(((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = set.with(\"dot\", \"comma\", \"colon\", \"rparen\",",
  "            \"rbrace\", \"rsquare\", \"arrow\", \"bind\");",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if(validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if(!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for token (that is the beginning of a control",
  "// structure) -- an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(token, inserted) {",
  "    var n := sym",
  "    var numOpening := if(inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found is public",
  "        var tok is public",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif { n.kind == \"rbrace\" } then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if (n.kind == \"lbrace\") then {",
  "            numOpening := numOpening + 1",
  "        } elseif { n.kind == \"rbrace\" } then {",
  "            numClosing := numClosing + 1 ",
  "        }",
  "        n := n.next",
  "    }",
  "    if (n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif {(n.prev.kind == \"rbrace\") && (numOpening == numClosing)} then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "",
  "method accept(t) {",
  "    // True if the current token has kind t, where",
  "    // t is \"num\", \"string\", \"method\", etc.",
  "    sym.kind == t",
  "}",
  "",
  "method acceptKeyword (kw) {",
  "    if (sym.kind != \"keyword\") then { return false }",
  "    return sym.value == kw",
  "}",
  "",
  "method acceptSameLine (t) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line (either because it's on the same physical line, or because",
  "    // it's on an indented continuation line).",
  "",
  "    (sym.kind == t) && ",
  "        ((lastLine == sym.line) || (sym.indent > lastIndent))",
  "}",
  "method acceptWithoutSpaces (t) {",
  "    // True if the current token is a t, and follows the previous token",
  "    // without any intervening spaces or continuation lines.",
  "",
  "    (sym.kind == t) && ",
  "        (lastLine == sym.line) && (sym.linePos == (lastToken.linePos + lastToken.size))",
  "}",
  "method acceptAfterSpaces (t) {",
  "    // True if the current token is a t, and is separated from the previous token",
  "    // by one or more spaces, or a continuation line.",
  "",
  "    if (sym.kind != t) then { return false }",
  "    if (lastLine == sym.line) then {",
  "        return sym.linePos != (lastToken.linePos + lastToken.size)",
  "    }",
  "    return sym.linePos == (sym.indent + 1)",
  "}",
  "method accept (t) onLineOf (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as other (either because it's on the same physical",
  "    // line, or because it's on an indented continuation line).",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "method acceptAfterSpaces (t) onLineOf (other) {",
  "    // True if the current token is a t, is on the same logical line as other,",
  "    // and is separated from the previous token by one or more spaces, ",
  "    // or a continuation line.",
  "",
  "    if (sym.kind != t) then { return false }",
  "    if (sym.line == other.line) then {",
  "        return sym.linePos != (lastToken.linePos + lastToken.size)",
  "    } else {",
  "        return sym.linePos == (sym.indent + 1)",
  "    }",
  "}",
  "method accept (t) onLineOfLastOr (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as the last token, or the other token.",
  "    (sym.kind == t) && (((other.line == sym.line) ||",
  "        (sym.indent > other.indent)) || (lastToken.line == sym.line))",
  "}",
  "method acceptArgumentOnLineOf(tok) {",
  "    // True if the current token can start an argument to a request",
  "    if (accept \"string\" onLineOf(tok)) then { return true }",
  "    if (accept \"num\" onLineOf(tok)) then { return true }",
  "    if (accept \"lbrace\" onLineOf(tok)) then { return true }",
  "    if (acceptAfterSpaces \"lsquare\" onLineOf(tok)) then { return true }",
  "    if (accept \"identifier\" onLineOf(tok)) then { ",
  "        return (sym.value == \"true\") || (sym.value == \"false\")",
  "    }",
  "    return false",
  "}",
  "method tokenOnSameLine {",
  "    // True if there is a token on the current logical line",
  "    (lastLine == sym.line) || (sym.indent > lastIndent)",
  "}",
  "method didConsume(aParsingBlock) {",
  "    // True if executing aParsingBlock consumes at least one token.",
  "    var sz := tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size != sz",
  "}",
  "method ifConsume(ablock)then(tblock) {",
  "    // If ablock consumes at least one token, execute tblock.",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    if (tokens.size != sz) then {",
  "        tblock.apply",
  "    }",
  "}",
  "",
  "// Push the current token onto the output stack as a number",
  "method pushnum {",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an octet literal",
  "method pushoctets {",
  "    var o := ast.octetsNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as a string",
  "method pushstring {",
  "    var o := ast.stringNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.identifierNode.new(sym.value, false)",
  "    if (o.value == \"_\") then {",
  "        o.value := \"__\" ++ auto_count",
  "        o.wildcard := true",
  "        auto_count := auto_count + 1",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method adjustVisibilityOf(node) withSpecialDefault(sd) overriding(nd) {",
  "    // If a compiler directive has set a special default visibility, then",
  "    // translate this into an annotation.  The normal defaults are dealt with",
  "    // by methods on the ast nodes.",
  "    if (sd == nd) then { return done }",
  "    for (node.annotations) do {a->",
  "        if (a.kind == \"identifier\") then",
  "        {   if (a.value == \"public\") then { return done }",
  "            if (a.value == \"readable\") then { return done }",
  "            if (a.value == \"confidential\") then { return done }",
  "            if (a.value == \"writable\") then { return done }",
  "        }",
  "    }",
  "    def newAnn = ast.identifierNode.new(sd, false)",
  "    node.annotations.push(newAnn)",
  "}",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\").andAlso {a.dtype != false}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"an argument to an annotation cannot have a type.\")atRange(",
  "                        tok.line, tok.linePos, tok.next.linePos + tok.next.size - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if (acceptKeyword \"is\" .not) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = list.empty",
  "    if(didConsume({expression(noBlocks)}).not) then {",
  "        def suggestions = list.empty",
  "        var suggestion := errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"bind\"] )",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "        }",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"bind\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method blank {",
  "    if (blankLocation == 0) then {",
  "        if ( sym.line <= (lastToken.line + 1) ) then { return }",
  "        if ( sym.line <= (previousCommentToken.line + 1) ) then { return }",
  "    }",
  "    pushComments",
  "    if ((values.size == 0) || ",
  "            ((values.size > 0).andAlso { values.last.kind != \"blank\" })) then {",
  "        if (blankLocation > 0) then {",
  "            util.setPosition(blankLocation, 0)",
  "            blankLocation := 0",
  "        } else {",
  "            util.setPosition(sym.line - 1, 0)",
  "        }",
  "        values.push(ast.blankNode.new)",
  "    }",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept \"identifier\") then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (acceptKeyword \"type\") then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept \"lparen\") then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if(didConsume({typeexpression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«type expression»\")",
  "            }",
  "            errormessages.syntaxError(\"parentheses must contain a valid type expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a type expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new(emptySequence, thenList)",
  "    def elseBlock = ast.blockNode.new(emptySequence, elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "method block {",
  "    // parse a block",
  "    if (accept \"lbrace\") then {",
  "        def btok = sym",
  "        next",
  "        var minInd := statementIndent + 2",
  "        var startIndent := statementIndent",
  "        var expr1",
  "        var s := sym",
  "        var tmp",
  "        var params := list.empty",
  "        var body := list.empty",
  "        var havearrow := true",
  "        var found := false",
  "        var i := 0",
  "        var isMatchingBlock := false",
  "        statementToken := sym",
  "        if (sym.kind == \"lparen\") then {",
  "            isMatchingBlock := true",
  "        }",
  "        // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "        // The paren lets us distinguish parameter ‹a› from pattern ‹(a)› .",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (accept(\"comma\") || accept(\"arrow\") || accept(\"colon\")) then {",
  "                // This block has parameters or patterns",
  "                expr1 := values.pop",
  "                if (accept \"colon\") then {",
  "                    // We allow an expression here for the case of v : T",
  "                    // patterns, where T may be \"Pair(hd, tl)\" or similar.",
  "                    next",
  "                    braceIsType := true",
  "                    if(didConsume({expression(blocksOK)}).not) then {",
  "                        def suggestions = list.empty",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken( [\"arrow\", \"rbrace\"] )",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"a block must have an expression after the ':'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestions(suggestions)",
  "                    }",
  "                    braceIsType := false",
  "                    expr1.dtype := values.pop",
  "                }",
  "                params.push(expr1)",
  "                if (isMatchingBlock.not && expr1.isIdentifier) then {",
  "                    expr1.isBindingOccurrence := true",
  "                } else {",
  "                    isMatchingBlock := true",
  "                }",
  "                if (isMatchingBlock && {accept(\"comma\")}) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion",
  "                    def arrow = findNextToken({ t -> t.kind == \"arrow\" })",
  "                    if(arrow != false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, arrow.prev)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" |\")",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a matching block may only have one parameter.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                while {accept(\"comma\")} do {",
  "                    // Keep doing the above for the rest of the parameters.",
  "                    next",
  "                    pushidentifier",
  "                    expr1 := values.pop",
  "                    expr1.isBindingOccurrence := true",
  "                    expr1.dtype := optionalTypeAnnotation",
  "                    params.push(expr1)",
  "                }",
  "                if ((accept(\"arrow\")).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "                        suggestion.replaceToken(sym)with(\"->\")",
  "                    } else {",
  "                        suggestion.insert(\" ->\")afterToken(lastToken)",
  "                    }",
  "                    errormessages.syntaxError(\"a block must have one or more parameters followed by '->' and an expression.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } elseif { accept \"semicolon\" } then {",
  "                body.push(values.pop)",
  "                next",
  "                if (accept \"semicolon\") then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } elseif { ((values.last.kind == \"member\")",
  "                        || (values.last.kind == \"identifier\")",
  "                        || (values.last.kind == \"index\"))",
  "                        && accept(\"bind\") } then {",
  "                var lhs := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var rhs := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                body.push(ast.bindNode.new(lhs, rhs))",
  "                if (accept \"semicolon\") then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } else {",
  "                checkUnexpectedTokenAfterStatement",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        if (accept \"arrow\") then {",
  "            next",
  "        }",
  "        if (sym.line == lastToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := minInd",
  "        }",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // Take the body of the block",
  "            if(didConsume({statement}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"}\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a block must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            tmp := values.pop",
  "            body.push(tmp)",
  "        }",
  "        minIndentLevel := minInd - 2",
  "        statementIndent := startIndent",
  "        next",
  "        util.setPosition(btok.line, btok.linePos)",
  "        var o := ast.blockNode.new(params, body)",
  "        if (isMatchingBlock) then {",
  "            if (params.size > 0) then {",
  "                o.matchingPattern := params.first",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        def opener = if ((sym.kind == \"lparen\").orElse{sym.kind == \"lbrace\"})",
  "                        then { sym.value } else { \"-missing-\" }",
  "        def closer = if (opener == \"(\") then { \")\" }",
  "                        else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "        if (opener == \"-missing-\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if (nextTok == false) then {",
  "                suggestion.insert(\" («condition») then \\{\")afterToken(btok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif { nextTok.kind == \"lbrace\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" («condition») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have a condition \" ++",
  "                \"in parentheses or braces after the 'if'.\")",
  "                atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if(nextTok == false) then {",
  "                nextTok := findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a \" ++",
  "                      \"condition in parentheses or braces after the 'if'.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestion(suggestion)",
  "            } else {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atPosition(sym.line, sym.linePos)",
  "                        withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atRange(sym.line, sym.linePos, nextTok.linePos - 1)",
  "                        withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.value != closer) then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a \"++",
  "                  \"'{opener}' must end with a '{closer}'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 2",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if(sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if(didConsume({statement}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"an if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                def elopener = if ((sym.kind == \"lparen\").orElse{sym.kind == \"lbrace\"})",
  "                                then { sym.value } else { \"-missing-\" }",
  "                def elcloser = if (elopener == \"(\") then { \")\" }",
  "                                else { if (elopener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "                if (elopener == \"-missing-\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if(nextTok == false) then {",
  "                        suggestion.insert(\" («expression») then \\{\")afterToken(statementToken)",
  "                    } elseif { nextTok.kind == \"rparen\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                        }",
  "                    } elseif { nextTok.kind == \"lbrace\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" («expression») then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif { nextTok.kind == \"identifier\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a \" ++",
  "                          \"condition in parentheses or braces after the 'elseif'.\")",
  "                          atPosition(sym.line, sym.linePos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        ((t.kind == \"rparen\") || (t.kind == \"rbrace\"))})",
  "                    if(nextTok == false) then {",
  "                        nextTok := findNextValidToken( [\"rparen\"] )",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"an elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"an elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if(sym.value != elcloser) then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an expression beginning with a \" ++",
  "                        \"'{elopener}' must end with a '{elcloser}'.\")",
  "                        atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            util.setPosition(btok.line, btok.linePos)",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have 'then' after \" ++",
  "                  \"the condition in parentheses.\")",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept \"identifier\") then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    if (accept \"op\") then {",
  "        var op := sym.value",
  "        var val",
  "        next",
  "        if (accept \"lparen\") then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if(lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"a prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "        val := values.pop",
  "        var mem := ast.memberNode.new(\"prefix\" ++ op, val)",
  "        var call := ast.callNode.new(mem, [ast.callWithPart.request(mem.value) withArgs( [] )])",
  "        values.push(call)",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept \"lgeneric\") then {",
  "        def id = values.pop",
  "        def gens = list.empty",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept \"comma\") then {",
  "                next",
  "            } else {",
  "                if(sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"a type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"a type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept(\"identifier\") && (sym.value == \"try\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    if (accept \"lbrace\") then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif { nextTok.kind == \"rbrace\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(catchTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"a try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try-finally statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(catchTok.line, catchTok.linePos)",
  "    values.push(ast.tryCatchNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if(sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if(nextTok == false) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif { nextTok.kind == \"rparen\" } then {",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif { nextTok.kind == \"identifier\" } then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if(didConsume({expression(blocksOK)}).not) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"rparen\"] )",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    var elsecase := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    util.setPosition(matchTok.line, matchTok.linePos)",
  "    values.push(ast.matchCaseNode.new(matchee, cases, elsecase))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"num\") then {",
  "        pushnum",
  "    } elseif { accept \"string\" } then {",
  "        pushstring",
  "    } elseif { accept \"identifier\" && (sym.value == \"match\") } then {",
  "        matchcase",
  "    } elseif { accept(\"identifier\") && (sym.value == \"try\") } then {",
  "        trycatch",
  "    } elseif { accept \"identifier\" } then {",
  "        identifier",
  "    } elseif { acceptKeyword \"object\" } then {",
  "        doobject",
  "    } elseif { acceptKeyword \"type\" } then {",
  "        dotypeLiteral",
  "    } elseif { accept \"lbrace\" } then {",
  "        block",
  "    } elseif { acceptAfterSpaces \"lsquare\" } then {",
  "        doarray",
  "    } elseif { (lastToken.kind != \"identifier\") && (accept \"lsquare\") } then {",
  "        doarray",
  "    } elseif { accept \"op\" } then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"lparen\") then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if (didConsume{expression(acceptBlocks)}.not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                      leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Accept postcircumfix square brackets (as in x[y]) and replace the",
  "// preceding expression with an index node into itself.",
  "method postfixsquare {",
  "    if (acceptWithoutSpaces(\"lsquare\")) then {",
  "        next",
  "        var expr := values.pop",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«index»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«index»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            if(nextTok.kind == \"rsquare\") then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        var index := values.pop",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var o := ast.indexNode.new(expr, index)",
  "        values.push(o)",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif { o == \"/\" } then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept \"op\") then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parametrised so that it",
  "    // can be used for both type- and value- expressions.",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken).andAlso",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"an expression containing both arithmetic and non-arithmetic operators requires parentheses.\")atPosition(",
  "                lastToken.prev.line, lastToken.prev.linePos)withSuggestions(suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            util.setPosition(tmp.line, tmp.linePos)",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept \"lparen\") then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if(didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (!tokenOnSameLine) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines[sym.line])afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"comma\", \"rparen\", \"rsquare\", \"rbrace\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        util.setPosition(tmp.line, tmp.linePos)",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "// Accept a member lookup with \".\". This consumes the dot and",
  "// a following identifier, and will pass along to further lookups or",
  "// method calls on the result.",
  "method dotrest(acceptBlocks) {",
  "    if (acceptSameLine(\"dot\")) then {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept \"identifier\") then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            var dro := ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept \"dot\") then {",
  "                dotrest(acceptBlocks)",
  "            } elseif { accept \"lparen\" || (acceptBlocks && accept \"lbrace\")",
  "                  || accept(\"num\") || accept(\"string\") || accept(\"lsquare\")",
  "                  || accept(\"lgeneric\") } then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a method invocation indicated by parentheses. Unparenthesised",
  "// method calls are left as \"member\" AST nodes and processed correctly at",
  "// a later stage.",
  "method callrest(acceptBlocks) {",
  "    if (values.size == 0) then {",
  "        return 0",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return 0",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.value",
  "    def btok = sym",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var signature := []",
  "    var part := ast.callWithPart.new",
  "    signature.push(part)",
  "    var hadcall := false",
  "    var tok := lastToken",
  "    var startInd := minIndentLevel",
  "    var genericIdents := false",
  "    if (acceptSameLine \"lgeneric\") then {",
  "        genericIdents := typeArgs",
  "    }",
  "    if (acceptSameLine(\"lparen\")) then {",
  "        part.line := sym.line",
  "        part.linePos := sym.linePos",
  "        part.name := methn",
  "        tok := sym",
  "        hadcall := true",
  "        parenthesizedArg(part)",
  "    } elseif { acceptBlocks.not && {accept(\"lbrace\")onLineOf(tok)} } then {",
  "        values.push(meth)",
  "    } elseif { acceptArgumentOnLineOf(tok) } then {",
  "        tok := sym",
  "        hadcall := true",
  "        part.name := methn",
  "        term",
  "        var ar := values.pop",
  "        part.args.push(ar)",
  "    } elseif { meth.kind == \"identifier\" } then {",
  "        values.push(meth)",
  "    } elseif { meth.kind == \"member\" } then {",
  "        var root := meth.in",
  "        var outroot := meth",
  "        while {root.kind == \"member\"} do {",
  "            outroot := root",
  "            root := root.in",
  "        }",
  "        if (root.kind == \"identifier\") then {",
  "            values.push(meth)",
  "        } else {",
  "            meth.generics := genericIdents",
  "            values.push(meth)",
  "        }",
  "    }",
  "    if (hadcall) then {",
  "        if (accept(\"identifier\")onLineOfLastOr(tok)) then {",
  "            // Multi-part method name",
  "            def meth' = ast.identifierNode.new(methn, false)",
  "            meth'.line := lnum",
  "            meth'.linePos := lpos",
  "            methn := callmprest(meth', signature, tok)",
  "            if (meth.kind == \"member\") then {",
  "                // callmprest loses this information, so restore",
  "                // the member lookup (for x.between(3)and(10)-type",
  "                // calls).",
  "                meth := ast.memberNode.new(methn.value, meth.in)",
  "                meth.line := methn.line",
  "                meth.linePos := methn.linePos",
  "            } else {",
  "                meth := methn",
  "            }",
  "        }",
  "        util.setline(lnum)",
  "        def call = ast.callNode.new(meth, signature)",
  "        call.generics := genericIdents",
  "        values.push(call)",
  "    } elseif {genericIdents != false} then {",
  "        meth.generics := genericIdents",
  "    }",
  "    minIndentLevel := startInd",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parenthesizedArg(part) {",
  "    next",
  "    ifConsume {expression(blocksOK)} then {",
  "        // For matching blocks - same as below",
  "        if (accept \"colon\") then {",
  "            def expr = values.pop",
  "            if (expr.kind != \"identifier\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                if(sym.next.kind == \"identifier\") then {",
  "                    suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                checkBadTypeLiteral",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            expr.dtype := values.pop",
  "            values.push(expr)",
  "        }",
  "        while {accept(\"comma\")} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a method request must have an expression after a ','.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            // For matching blocks - same as above",
  "            if (accept \"colon\") then {",
  "                def arg = values.pop",
  "                if (arg.kind != \"identifier\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.next.kind == \"identifier\") then {",
  "                        suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"only declarations may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"only declarations may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    checkBadTypeLiteral",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                arg.dtype := values.pop",
  "                values.push(arg)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method request beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parse one or more type arguments, if present, and answer them as a list.",
  "    def startToken = sym",
  "    def args = list.empty",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert(\" \")beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError(\"a method request containing a '<' must have a matching '>'. \"",
  "            ++ \"If '<' is intended as an operator, precede it by a space.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leave it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        } else {",
  "            // values.push(values.pop)",
  "        }",
  "    } elseif {didConsume{dotypeLiteral}} then {",
  "        // values.push(values.pop)",
  "    }",
  "}",
  "",
  "method callmprest(meth, signature, tok) {",
  "    // Parses the rest of a multi-part method name.",
  "    // meth is an identifierNode representing the first part of the name.",
  "    // Returns a new identifierNode, representing the full method name,",
  "    // and updates signature.params with the parsed arguments.",
  "    var methname := meth.value",
  "    var nxt",
  "    var lp := meth.linePos",
  "    var part",
  "    while {accept(\"identifier\")onLineOf(tok)",
  "           || accept(\"identifier\")onLineOf(lastToken)} do {",
  "        // Each word must start on the same line as the preceding parameter",
  "        // ended.",
  "        part := ast.callWithPart.new",
  "        signature.push(part)",
  "        methname := methname ++ \"()\"",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var isTerm := false",
  "        if (accept \"lparen\") then {",
  "            next    // skip over the `(`",
  "        } elseif { acceptArgumentOnLineOf(lastToken) } then {",
  "            isTerm := true",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"identifier\") then {",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                if(methname == \"while()do\") then {",
  "                    errormessages.syntaxError(\"a while loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif { methname == \"for()do\" } then {",
  "                    errormessages.syntaxError(\"a for loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if (methname == \"while()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a while loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif { methname == \"for()do\" } then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a for loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.insert(\"()\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a multi-part method request must end with '()'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        def isEmpty = accept \"rparen\"",
  "        if (isTerm) then {",
  "            term",
  "        } else {",
  "            if(sym.kind != \"rparen\") then {",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a method request must have an expression or a ')' after a '('.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                nxt := values.pop",
  "                part.args.push(nxt)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (!isEmpty) then {",
  "            nxt := values.pop",
  "            part.args.push(nxt)",
  "        }",
  "        if (isTerm.not) then {",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a part of a multi-part method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        if (accept(\"rparen\") && isTerm.not) then {",
  "            next",
  "        }",
  "    }",
  "    def meth' = ast.identifierNode.new(methname, false)",
  "    meth'.line := meth.line",
  "    meth'.linePos := meth.linePos",
  "    meth'",
  "}",
  "",
  "// Accept a const declaration",
  "method defdec {",
  "    if (acceptKeyword \"def\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "                && (t.value == \"=\") && (t.line == sym.line)})",
  "            if (nextToken == false) then {",
  "                suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "            } elseif { nextToken == sym } then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"a definition must have a name, '=', \" ++",
  "                  \"and a value after the 'def'.\") atPosition(sym.line, sym.linePos)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        var dtype := optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a definition must have a value after the '='.\")",
  "                      atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                      withSuggestion(suggestion)",
  "            }",
  "            val := values.pop",
  "        } elseif { accept \"bind\" } then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(sym)with(\"=\")",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a definition must use '=' instead of ':='. \" ++",
  "                \"A variable declaration uses 'var' and ':='.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + 1) withSuggestions(suggestions)",
  "        } else {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a definition must have '=' and a value after the name. \"",
  "                ++ \"A variable declaration does not require a value but uses 'var', not 'def'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(defTok.line, defTok.linePos)",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultDefVisibility) overriding(\"confidential\")",
  "        o.startToken := defTok",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a var declaration",
  "method vardec {",
  "    if (acceptKeyword \"var\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if((nextToken == false).orElse({nextToken == sym})) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError \"a variable declaration must have a name after the 'var'.\"",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept \"bind\") then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        util.setPosition(line, pos)",
  "        def o = ast.varDecNode.new(name, val, dtype)",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultVarVisibility) overriding(\"confidential\")",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a square-bracketed list literal like [1,2,3].",
  "method doarray {",
  "    if (accept \"lsquare\") then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        ifConsume {expression(blocksOK)} then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rsquare\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a list must contain zero or more valid expressions separated by commas.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a list beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"dialect \"X\"\"",
  "method dodialect {",
  "    if (acceptKeyword \"dialect\") then {",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"a dialect statement must have the name of the dialect in quotes after the 'dialect'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        values.push(ast.dialectNode.new(sym.value))",
  "        next",
  "    }",
  "}",
  "",
  "method inheritsOrUses {",
  "    // Parses \"inherit «object expression»\"",
  "",
  "    if (! accept \"keyword\") then { return }",
  "    if ((sym.value == \"inherits\") || (sym.value == \"inherit\") || (sym.value == \"use\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            var msg := \"The {btok.value} keyword must be followed by an expression that creates \"",
  "            if (btok.value == \"use\") then {",
  "                msg := msg ++ \"the trait being used.\"",
  "            } else {",
  "                msg := msg ++ \"the object being inherited.\"",
  "            }",
  "            errormessages.syntaxError(msg)",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritsNode.new(values.pop)",
  "        if (btok.value == \"use\") then {",
  "            inhNode.isUse := true",
  "        }",
  "        while { inheritsModifier(inhNode) onLineOf(btok) } do { }",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "method inheritsModifier(node) onLineOf(startToken) {",
  "    // parse an alias or excludes modifier on an `inherits` clause",
  "    if (! accept \"keyword\" onLineOf(startToken) ) then { ",
  "        return false",
  "    }",
  "    if (sym.value == \"alias\") then { ",
  "        parseAlias(node) ",
  "    } elseif {sym.value == \"exclude\"} then {",
  "        parseExclude(node)",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parseAlias(node) {",
  "    next    // skip the alias keyword",
  "    def newSig = methodsignature(true)",
  "    def newMeth = newSig.m",
  "    if (accept \"op\" && (sym.value == \"=\")) then {",
  "        next",
  "        def oldSig = methodsignature(true)",
  "        def oldMeth = oldSig.m",
  "        oldMeth.isBindingOccurrence := false",
  "        node.addAlias (newMeth) for (oldMeth)",
  "    } else {",
  "        errormessages.syntaxError (\"An alias modifier must take the form \" ++",
  "            \"'newMethodName = oldMethodName'\") ",
  "            atPosition (lastToken.line, lastToken.linePos + lastToken.size)",
  "    }",
  "    return true",
  "}",
  "method parseExclude(node) {",
  "    next    // skip the exclude keyword",
  "    def exSig = methodsignature(true)",
  "    def excludedMeth = exSig.m",
  "    excludedMeth.isBindingOccurrence := false",
  "    node.addExclusion (excludedMeth)",
  "    return true",
  "}",
  "",
  "method doobject {",
  "    // Parse an object constructor.",
  "    // this method is called doobject because \"object\" is a keyword",
  "",
  "    if (acceptKeyword \"object\") then {",
  "        next",
  "        parseObjectConstructorBody \"an object constructor\" ",
  "            startingWith (lastToken) after \"'object'\"",
  "    }",
  "}",
  "",
  "method parseObjectConstructorBody(constructName) startingWith (btok) after (prev) {",
  "    // Parse the body of an object constructor, leaving the node on the",
  "    // values stack.  Common code for parsing object, class, and factory method",
  "    // bodies; constructName says which, so that error messages are correct.",
  "    // btok is the keyword token that started the construct: class, object, or trait.",
  "    def localMinIndentLevel = minIndentLevel",
  "    def anns = doannotation",
  "    if (sym.kind != \"lbrace\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextToken { t -> t.kind == \"rbrace\" }",
  "        if(nextTok == false) then {",
  "            suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "        }",
  "        errormessages.syntaxError \"{constructName} must have a '\\{' after the {prev}.\"",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (sym.line == statementToken.line) then {",
  "        minIndentLevel := sym.linePos - 2",
  "    } else {",
  "        minIndentLevel := statementToken.indent + 2",
  "    }",
  "    def body = []",
  "    var superObject := false",
  "    def usedTraits = []",
  "    var inPreamble := true  // => processing inherit and use statements",
  "    while {(accept(\"rbrace\")).not.andAlso{sym.kind != \"eof\"}} do {",
  "        if (didConsume {inheritsOrUses}) then {",
  "            def parentNode = values.pop",
  "            if (inPreamble) then {",
  "                if (parentNode.isUse) then {",
  "                    usedTraits.add(parentNode)",
  "                } elseif { usedTraits.isEmpty } then {",
  "                    superObject := parentNode",
  "                } else {",
  "                    errormessages.syntaxError(\"'inherit' must come \" ++",
  "                        \"before 'use' in {constructName}\")",
  "                        atPosition(parentNode.line, parentNode.linePos,",
  "                        parentNode.linePos + 7)",
  "                }",
  "            } else {",
  "                errormessages.syntaxError(\"'{parentNode.statementName}' must \" ++",
  "                    \"come at the start of {constructName}\")",
  "                    atPosition(parentNode.line, parentNode.linePos,",
  "                            parentNode.linePos + parentNode.statementName.size)",
  "            }",
  "        } elseif { didConsume {methoddec} } then {",
  "            inPreamble := false",
  "            body.push(values.pop)",
  "        } elseif { didConsume {statement} } then {",
  "            inPreamble := false",
  "            body.push(values.pop)",
  "        } else {",
  "            errormessages.syntaxError(\"unexpected symbol '{sym.value}' in body \" ++",
  "                \"of of {constructName}\")",
  "                atPosition(sym.line, sym.linePos, sym.linePos + sym.value.size - 1)",
  "        }",
  "    }",
  "    next",
  "    util.setPosition(btok.line, btok.linePos)",
  "    def objNode = ast.objectNode.new(body, superObject)",
  "    if (anns != false) then { objNode.annotations.addAll(anns) }",
  "    objNode.usedTraits := usedTraits",
  "    values.push(objNode)",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method doclass {",
  "    // Accepts a class declaration with or without a `dot`",
  "    // Class declarations were formerly of the form:",
  "    //",
  "    //   class objName.methodName (param1, param2) {",
  "    //     inherits <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // Now they are of the form:",
  "    //",
  "    // class methodName (param1, param2) {",
  "    //     inherits <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // The old \"dotted\" form is compiled into a defDecNode that contains",
  "    // an objectNode that contains the class method and an asString method.",
  "    // The current form is compiled into a methodNode that contains",
  "    // an objectNode, i.e., it is treated as syntactic sugar for",
  "    //",
  "    // method methodName (param1, param2) {",
  "    //     object {",
  "    //         inherits <expr>",
  "    //         var x",
  "    //         method y(z) { ... }",
  "    //     }",
  "    // }",
  "",
  "    def btok = sym",
  "    next",
  "    def localMinIndentLevel = minIndentLevel",
  "    if(sym.kind != \"identifier\") then {",
  "        def suggestions = list.empty",
  "        if(sym.kind == \"lbrace\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(lastToken)with(\"object\")",
  "            suggestions.push(suggestion)",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "        }",
  "        errormessages.syntaxError(\"a class must have a name after the 'class'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    var objName := false",
  "    if (tokens.first.kind == \"dot\") then {",
  "        pushidentifier // the name of the class object",
  "        objName := values.pop",
  "        objName.isBindingOccurrence := true",
  "        next    // skip over the dot",
  "    }",
  "    def s = methodsignature(false)",
  "    def csig = s.sig",
  "    def methodName = s.m",
  "    methodName.isBindingOccurrence := true",
  "    def dtype = s.rtype",
  "    parseObjectConstructorBody \"a class\" startingWith (btok) after \"method header\"",
  "    def objNode = values.pop",
  "    util.setPosition(btok.line, btok.linePos)",
  "    def meth = ast.methodNode.new(methodName, csig, [objNode], dtype)",
  "    meth.typeParams := s.typeParams",
  "    meth.usesClassSyntax := true",
  "    meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "    // see comment in dofactoryMethod",
  "    if (false != objName) then {   // deal with (deprecated) dotted class",
  "        objNode.name := objName.nameString ++ \".\" ++ methodName.nameString",
  "        def asStringBody = [ ast.stringNode.new(\"class {objName.nameString}\") ]",
  "        def asStringMeth = ast.methodNode.new(",
  "            ast.identifierNode.new(\"asString\", false), [], asStringBody, false)",
  "        def metaBody = [meth, asStringMeth]",
  "        def metaObj = ast.objectNode.body (metaBody) named \"class {objName.nameString}\"",
  "        def defDec = ast.defDecNode.new(objName, metaObj, ast.unknownType)",
  "        defDec.startToken := btok",
  "        defDec.annotations.add(ast.identifierNode.new(\"public\", false))",
  "        values.push(defDec)",
  "    } else {",
  "        objNode.name := methodName.nameString",
  "        if (btok.value == \"class\") then {",
  "            objNode.inClass := true",
  "        } elseif { btok.value == \"trait\" } then {",
  "            objNode.inTrait := true",
  "        }",
  "        values.push(meth)",
  "    }",
  "    reconcileComments",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method dofactoryMethod {",
  "    // Accept a factory method declaration",
  "    if ((acceptKeyword \"factory\").andAlso{",
  "            tokens.first.kind == \"keyword\"}.andAlso{",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestions = list.empty",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «method name» \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError \"a factory method must have a name after the 'method'.\"",
  "                atPosition (lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions (suggestions)",
  "        }",
  "        var s := methodsignature(false)",
  "        def csig = s.sig",
  "        var methodName := s.m",
  "        methodName.isBindingOccurrence := true",
  "        def dtype = s.rtype",
  "        parseObjectConstructorBody \"a factory method\" startingWith (btok) after \"method header\"",
  "        def objNode = values.pop",
  "        objNode.name := methodName",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def meth = ast.methodNode.new(methodName, csig, [objNode], dtype)",
  "        meth.typeParams := s.typeParams",
  "        meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "        // In a class or factory method declaration, there is just one place",
  "        // for annotations.  These might include annotations on the method (such",
  "        // as confidential), and annotations on the object (such as imutable)",
  "        values.push(meth)",
  "        reconcileComments",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "method methoddec {",
  "    // Parse a method declaration",
  "",
  "    if (acceptKeyword \"method\") then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        var stok := sym",
  "        next",
  "        def m = methodsignature(false)",
  "        def meth = m.m",
  "        def signature = m.sig",
  "        def dtype = m.rtype",
  "        def varargs = m.v",
  "        def body = []",
  "        var localMin",
  "        def anns = doannotation",
  "        if (accept \"lbrace\") then {",
  "            next",
  "            localMin := minIndentLevel",
  "            if (sym.line == stok.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := stok.indent + 1",
  "            }",
  "            values.push(object {",
  "                def kind is public = \"lbrace\"",
  "                var register is public := \"\"",
  "            })  // a dummy token to mark the position in the values stack",
  "            statement",
  "            var s := values.pop",
  "            while {s.kind != \"lbrace\"} do {",
  "                // The body is a sequence of statements, and",
  "                // the method ends when no further statement",
  "                // is found.",
  "                body.push(s)",
  "                statement",
  "                s := values.pop",
  "            }",
  "            if(sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"a method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if(closingBrace.found == false) then {",
  "                if(closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"a method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.methodNode.new(meth, signature, body, dtype)",
  "        if (varargs) then {",
  "            o.varargs := true",
  "        }",
  "        o.typeParams := m.typeParams",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "",
  "method methodDecRest(tm, sameline) {",
  "    // Process the remainder of a method header. These follow",
  "    // mostly the same rules as calls, but aren't strictly enforced to be on",
  "    // a single line (because they are ended by \"{\"). ",
  "    //",
  "    // tm is a methodNode.  This method returns a replacement method name ",
  "    // identifier, and modifies tm.params in place.",
  "",
  "    var methname := tm.value.value",
  "    var signature := tm.signature",
  "    var nxt",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        methname := methname ++ \"()\"",
  "        var part := ast.signaturePart.new",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var vararg := false",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"the declaration of a method with multiple \" ++",
  "                  \"parameter lists must have parentheses around each parameter list.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept \"op\") then {",
  "                next",
  "                vararg := true",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"a variable length parameter (a parameter beginning with '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            pushidentifier",
  "            nxt := values.pop",
  "            nxt.isBindingOccurrence := true",
  "            nxt.dtype := optionalTypeAnnotation",
  "            if (vararg) then {",
  "                part.vararg := nxt",
  "                tm.varargs := true",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } else {",
  "                part.params.push(nxt)",
  "            }",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "    def newName = ast.identifierNode.new(methname, false)",
  "    newName.isBindingOccurrence := true",
  "    newName",
  "}",
  "",
  "method optionalTypeAnnotation {",
  "    // Accept a type annotation if present.",
  "    // Returns the type, or false if there is no annotation",
  "    if (accept \"colon\") then {",
  "        next",
  "        if (didConsume { typeexpression }) then {",
  "            values.pop",
  "        } else {",
  "            checkBadTypeLiteral",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } else {",
  "        false",
  "    }",
  "}",
  "method methodsignature(sameline) {",
  "    // Accept a method signature",
  "    if((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method name must start with an identifier, or be an operator or '[]'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    pushidentifier",
  "    var meth := values.pop",
  "    meth.isBindingOccurrence := true",
  "    var signature := list.empty",
  "    def part = ast.signaturePart.partName(meth.value)",
  "    part.line := meth.line",
  "    part.linePos := meth.linePos",
  "    signature.push(part)",
  "    if (meth.value == \"[\") then {",
  "        if(sym.kind != \"rsquare\") then {",
  "            if((sym.kind == \"identifier\") && ((tokens.size == 0).orElse",
  "                {tokens.first.kind == \"rsquare\"})) then {",
  "                def suggestions = list.empty",
  "                def suggestion = errormessages.suggestion.new",
  "                if(tokens.size == 0) then {",
  "                    suggestion.replaceToken(sym)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                } elseif { tokens.first.line == meth.line } then {",
  "                    suggestion.replaceTokenRange(sym, tokens.first)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"a method named '[]' must have a single parameter in parentheses after the '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"]\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a method name must start with either an identifier or '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        next",
  "        meth.value := \"[]\"",
  "    }",
  "    var myTypeParams := false",
  "    if (accept \"lgeneric\") then { myTypeParams := typeparameters }",
  "    if (accept \"bind\") then {",
  "        next",
  "        meth.value := meth.value ++ \":=\"",
  "        part.name := part.name ++ \":=\"",
  "    } elseif { accept \"op\"  && (meth.value == \"prefix\") } then {",
  "        meth.value := meth.value ++ sym.value",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    var dtype := false",
  "    var varargs := false",
  "    var vararg := false",
  "    if (accept \"lparen\") then {",
  "        def lparen = sym",
  "        part.linePos := sym.linePos",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept \"op\") then {",
  "                next",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"a variable length parameter (a parameter beginning with a '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "                vararg := true",
  "                varargs := true",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            dtype := optionalTypeAnnotation",
  "            id.dtype := dtype",
  "            if (vararg) then {",
  "                part.vararg := id",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == sym.line) })",
  "                    if((sym.kind == \"comma\") && (rparen != false)) then {",
  "                        suggestion.insert(\",*{id.value}\")beforeToken(rparen)",
  "                        suggestion.deleteTokenRange(lparen.next, sym)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"a variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.\")atRange(",
  "                            lastToken.line, sym.linePos, rparen.linePos - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.insert(\")\")afterToken(lastToken)",
  "                        errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "            } else {",
  "                part.params.push(id)",
  "            }",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            } elseif { sym.kind != \"rparen\" } then {",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if(rparen == false) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            var tm := ast.methodNode.new(meth, signature, [], false)",
  "            meth := methodDecRest(tm, sameline)",
  "            varargs := varargs || tm.varargs",
  "        }",
  "    }",
  "    if (accept \"arrow\") then {",
  "        // Return dtype",
  "        next",
  "        typeexpression",
  "        dtype := values.pop",
  "    } else {",
  "        dtype := false",
  "    }",
  "    object {",
  "        def m is public = meth",
  "        def sig is public  = signature",
  "        def rtype is public = dtype",
  "        def v is public = varargs",
  "        def typeParams is public = myTypeParams",
  "    }",
  "}",
  "",
  "method typeparameters {",
  "    next",
  "    def typeIds = list.empty",
  "    while {accept(\"identifier\")} do {",
  "        identifier",
  "        def id = values.pop",
  "        id.isBindingOccurrence := true",
  "        typeIds.push(id)",
  "        if (accept \"comma\") then {",
  "            next",
  "        }",
  "    }",
  "    typeIds.do { each -> each.isBindingOccurrence := true }",
  "    def result = ast.typeParametersNode.new(typeIds)",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a list of type parameters starting with '<' must end with '>'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    result",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (acceptKeyword \"import\") then {",
  "        def importline = sym.line",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        util.setline(importline)",
  "        def o = ast.importNode.new(p.value, name, dtype)",
  "        def anns = doannotation",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultDefVisibility) overriding(\"confidential\")",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method doreturn {",
  "    // Accept a return statement; 'return' is followed by an optional expression.",
  "    if (acceptKeyword \"return\") then {",
  "        def retTok = sym",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine).andAlso{accept(\"rbrace\").not}) then {",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a return statement must have either an expression or a new-line after 'return'.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestions(suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false)",
  "        }",
  "        util.setPosition(retTok.line, retTok.linePos)",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    def methodTypeTok = sym",
  "    var m := methodsignature(true)",
  "    var meth := m.m",
  "    var signature := m.sig",
  "    var dtype := m.rtype",
  "    var varargs := m.v",
  "    if (dtype == false) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    util.setPosition(methodTypeTok.line, methodTypeTok.linePos)",
  "    def o = ast.methodTypeNode.new(meth.value, signature, dtype)",
  "    o.typeParams := m.typeParams",
  "    values.push(o)",
  "    reconcileComments",
  "    if (accept \"semicolon\") then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines[sym.line].substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading 'type' keyword.",
  "    def typeLiteralTok = sym",
  "    if (acceptKeyword \"type\") then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"type literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept \"lbrace\") then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (acceptKeyword \"type\") then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setPosition(typeLiteralTok.line, typeLiteralTok.linePos)",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (acceptKeyword \"type\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        util.setPosition(line, pos)",
  "        def nt = ast.typeDecNode.new(values.pop, false)",
  "        if (accept \"lgeneric\") then { nt.typeParams := typeparameters }",
  "        nt.name.isBindingOccurrence := true",
  "        def anns = doannotation",
  "        if((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if((nextTok == false).orElse({nextTok == sym})) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError \"a type declaration must have an '=' after the type name.\"",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept \"lbrace\") then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        nt.value := values.pop",
  "        if (false != anns) then {",
  "            nt.annotations.addAll(anns)",
  "        }",
  "        values.push(nt)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif { sym.kind == \"semicolon\" } then {",
  "        // pass",
  "    } elseif {(sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "          || (sym.kind == \"rsquare\")} then {",
  "        // pass",
  "    } elseif { sym.kind == \"eof\" } then {",
  "    } elseif { sym.indent < minIndentLevel } then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            for(1..(minIndentLevel - (sym.linePos - 1))) do { _ ->",
  "                suggestion.insert \" \" atPosition 1 onLine(sym.line)",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { ",
  "                tok := tok.prev ",
  "            }",
  "            var line := \"\"",
  "            for(1..(tok.indent)) do { _ ->",
  "                line := line ++ \" \"",
  "            }",
  "            line := line ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"the indentation for this line must be \" ++",
  "                  \"at least {minIndentLevel}. This is often caused by a missing '}'.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif { sym.indent > (minIndentLevel + 1) } then {",
  "        minIndentLevel := sym.indent",
  "    } elseif { (sym.indent - lastIndent).abs == 1 } then {",
  "        def m1 = \"the indentation for this line can't differ \"",
  "        def m2 = \"from that of the previous line by 1.\\n  To start a block, or \"",
  "        def m3 = \"to signal a continuation line, increase the indent by 2 or more. \"",
  "        def m4 = \"To end a block, or end the continuation, decrease the indent \"",
  "        def m5 = \"to the prior level. Otherwise, use the same indent as the previous line.\"",
  "        def msg = m1 ++ m2 ++ m3 ++ m4 ++ m5",
  "        errormessages.syntaxError(msg) atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "method statement {",
  "    // Accept a statement. A statement is any of the above that may exist",
  "    // at the top level, and includes expressions.",
  "    // A statement may also be a bind statement x := y, which creates a",
  "    // bind AST node out of the expressions on either side (which at this point",
  "    // can be any arbitrary expression).",
  "",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    def btok = sym",
  "    checkIndent",
  "    if (accept \"keyword\") then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif { sym.value == \"def\" } then {",
  "            defdec",
  "        } elseif { sym.value == \"import\" } then {",
  "            doimport",
  "        } elseif { sym.value == \"dialect\" } then {",
  "            dodialect",
  "        } elseif { sym.value == \"type\" } then {",
  "            typedec",
  "        } elseif { sym.value == \"class\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"trait\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"factory\" } then {",
  "            dofactoryMethod",
  "        } elseif { sym.value == \"return\" } then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                if (dest.kind == \"lbrace\") then {",
  "                    print \"sym = {sym}, sym.line = {sym.line}\"",
  "                    ProgrammingError.raise \"popped lbrace token while parsing statement\"",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var val := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    reconcileComments",
  "    if (accept \"eof\") then {",
  "        return true",
  "    }",
  "    if (accept \"semicolon\") then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method pushComments {",
  "    // Push a comment onto the comments stack as a commentNode. If",
  "    // there are consecutive comments following, deal with them all.",
  "    // Adjacent comments extend the first; a break of a blank line",
  "    // starts a new comment node.",
  "",
  "    if ( ! accept \"comment\" ) then { return }",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.commentNode.new(sym.value)",
  "    if ((lastToken.line == sym.line) && (lastToken.kind != \"comment\")) then {",
  "        o.isPartialLine := true",
  "    } elseif { lastToken.line < (sym.line - 1) } then {",
  "        o.isPreceededByBlankLine := true",
  "    }",
  "    comments.push(o)",
  "    while { ",
  "        previousCommentToken := sym",
  "        sym := tokens.poll",
  "        if (sym.line > (previousCommentToken.line + 1)) then { noteBlank }",
  "        accept \"comment\"",
  "    } do {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        o := ast.commentNode.new(sym.value)",
  "        if ( comments.last.endLine == (sym.line - 1) ) then {",
  "            comments.last.extendCommentUsing(o)",
  "        } else {",
  "            comments.push(o)",
  "            if ( lastToken.line < (sym.line - 1) ) then {",
  "                o.isPreceededByBlankLine := true",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method reconcileComments {",
  "    // Should be requested after a new node that represents a \"syntactic unit\"",
  "    // to which comments can be attached is pushed onto `values`",
  "    // Finds comments associated with that node, remove thems from comments",
  "    // stack, and puts them in that node's comments attribute.",
  "",
  "    pushComments",
  "    def node = if (values.isEmpty) then {",
  "        moduleObject ",
  "    } else {",
  "        values.last",
  "    }",
  "    if (node.kind == \"lbrace\") then {",
  "        // lbrace nodes are not AST nodes.  They are used to mark the stack for",
  "        // nested expressions.  Hence, no comments should be attached to them.",
  "        return",
  "    }",
  "    def oLine = node.line",
  "    def preComments = list.empty",
  "    def postComments = list.empty",
  "",
  "    var ix := comments.size",
  "    while { ix > 0 } do {",
  "        def each = comments.at(ix)",
  "        def isPostComment = (each.line == oLine) || (each.line == (oLine+1))",
  "        def isPreComment = each.isPreceededByBlankLine && (each.endLine == (oLine-1))",
  "        if (isPostComment) then {",
  "            postComments.push(comments.removeAt(ix))",
  "        } elseif { isPreComment } then {",
  "            preComments.addFirst(comments.removeAt(ix))",
  "        } elseif { each.endLine < (oLine-1) } then {",
  "            ix := 0     // exit from while",
  "        }",
  "        ix := ix - 1",
  "    }",
  "",
  "    def postSz = postComments.size",
  "    def preSz = preComments.size",
  "",
  "    if ((postSz > 1) && (preSz > 1)) then {",
  "        preComments.last.value := preComments.last.value ++ \"\\n\"",
  "    }",
  "    node.addComments(preComments)",
  "    node.addComments(postComments)",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "    if (sym.kind == \"rgeneric\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\" \")beforeToken(sym)",
  "        errormessages.syntaxError(\"the '>' operator must be preceded by a space.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = list.empty",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind == \"rgeneric\") then {",
  "            def sugg = errormessages.suggestion.new",
  "            sugg.insert(\" \")atPosition(sym.linePos)onLine(sym.line)",
  "            errormessages.syntaxError(",
  "                    \"The '>' operator must have a space before it.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestion(sugg)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = list.empty",
  "            var suggestion",
  "            if ((values.size > 0).andAlso {",
  "                    (values.last.kind == \"identifier\").orElse {",
  "                        values.last.kind == \"member\"",
  "                    }.andAlso {",
  "                        sym.kind == \"identifier\"",
  "                    }",
  "                }) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken( [\"rbrace\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines[lastToken.line].substringFrom(1)to(lastToken.linePos + lastToken.size - 1))",
  "                def newLine = util.lines[sym.line].substringFrom(sym.linePos)to(util.lines[sym.line].size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "",
  "method parse(toks) {",
  "    // Parse the given list of tokens, toks, returning an AST moduleNode",
  "    // corresponding to it.",
  "",
  "    util.log_verbose \"parsing.\"",
  "    moduleObject := ast.moduleNode.body(values) named (util.modname)",
  "",
  "    if (util.extensions.contains(\"DefaultVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultDefVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultDefVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultVarVisibility\")) then {",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVarVisibility\")",
  "    }",
  "    if (toks.size == 0) then {",
  "        return list.empty",
  "    }",
  "    tokens := toks",
  "    next",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError \"the first line must not be indented.\"",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        blank",
  "        methoddec",
  "        blank",
  "        ifConsume { inheritsOrUses } then {",
  "            def parentNode = values.pop",
  "            if (parentNode.isUse) then {",
  "                moduleObject.usedTraits.add(parentNode)",
  "            } elseif { moduleObject.usedTraits.isEmpty } then {",
  "                moduleObject.superclass := parentNode",
  "            } else {",
  "                errormessages.syntaxError(\"'inherit' must come \" ++",
  "                    \"before 'use' in a module.\")",
  "                    atPosition(parentNode.line, parentNode.linePos,",
  "                    parentNode.linePos + 7)",
  "            }",
  "        }",
  "        blank",
  "        statement",
  "        blank",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError(\"invalid statement. This is often \" ++",
  "                \"caused by an extra '}', ')', or ']'.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos + sym.size - 1)",
  "                withSuggestion(suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    blank",
  "    statement",
  "    blank",
  "    return moduleObject",
  "}",
  NULL
};
Object reader_parser_outer_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8454(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8455(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_register_8456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_9576(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_m_9577(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_sig_9578(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_rtype_9579(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_v_9580(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_typeParams_9581(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_outer_11824(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11825(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_line_11826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_linePos_11827(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_indent_11828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_value_11829(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_size_11830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit49;
static Object strlit51;
static Object strlit109;
static Object strlit156;
static Object strlit188;
static Object strlit189;
static Object strlit190;
static Object strlit191;
static Object strlit192;
static Object strlit193;
static Object strlit194;
static Object strlit195;
static Object strlit203;
static ClassData objclass233;
static Object strlit250;
static Object strlit261;
static Object strlit273;
static Object strlit301;
static Object strlit312;
static Object strlit324;
static Object strlit341;
static Object strlit358;
static Object strlit389;
static Object strlit592;
static Object strlit597;
static Object strlit602;
static Object strlit607;
static Object strlit612;
static Object strlit616;
static Object strlit623;
static Object strlit716;
static Object strlit724;
static Object strlit751;
static Object strlit758;
static Object strlit765;
static Object strlit772;
static Object strlit779;
static Object strlit798;
static Object strlit825;
static Object strlit835;
static Object strlit859;
static Object strlit888;
static Object strlit918;
static Object strlit925;
static Object strlit932;
static Object strlit950;
static Object strlit969;
static Object strlit1002;
static Object strlit1009;
static Object strlit1016;
static Object strlit1034;
static Object strlit1095;
static Object strlit1146;
static Object strlit1156;
static Object strlit1165;
static Object strlit1186;
static Object strlit1193;
static Object strlit1200;
static Object strlit1203;
static Object strlit1211;
static Object strlit1223;
static Object strlit1226;
static Object strlit1268;
static Object strlit1291;
static Object strlit1309;
static Object strlit1314;
static Object strlit1318;
static Object strlit1327;
static Object strlit1353;
static Object strlit1354;
static Object strlit1361;
static Object strlit1368;
static Object strlit1386;
static Object strlit1418;
static Object strlit1431;
static Object strlit1462;
static Object strlit1467;
static Object strlit1479;
static Object strlit1505;
static Object strlit1515;
static Object strlit1522;
static Object strlit1529;
static Object strlit1532;
static Object strlit1535;
static Object strlit1545;
static Object strlit1555;
static Object strlit1572;
static Object strlit1577;
static Object strlit1587;
static Object strlit1596;
static Object strlit1630;
static Object strlit1637;
static Object strlit1644;
static Object strlit1662;
static Object strlit1684;
static Object strlit1708;
static Object strlit1733;
static Object strlit1754;
static Object strlit1757;
static Object strlit1806;
static Object strlit1813;
static Object strlit1823;
static Object strlit1830;
static Object strlit1838;
static Object strlit1841;
static Object strlit1844;
static Object strlit1847;
static Object strlit1850;
static Object strlit1851;
static Object strlit1854;
static Object strlit1868;
static Object strlit1875;
static Object strlit1884;
static Object strlit1892;
static Object strlit1899;
static Object strlit1924;
static Object strlit1928;
static Object strlit1938;
static Object strlit1941;
static Object strlit1945;
static Object strlit1955;
static Object strlit1958;
static Object strlit1961;
static Object strlit1968;
static Object strlit1978;
static Object strlit1981;
static Object strlit1984;
static Object strlit1991;
static Object strlit1993;
static Object strlit2021;
static Object strlit2044;
static Object strlit2052;
static Object strlit2059;
static Object strlit2063;
static Object strlit2065;
static Object strlit2077;
static Object strlit2081;
static Object strlit2083;
static Object strlit2095;
static Object strlit2099;
static Object strlit2101;
static Object strlit2127;
static Object strlit2132;
static Object strlit2137;
static Object strlit2141;
static Object strlit2147;
static Object strlit2172;
static Object strlit2179;
static Object strlit2186;
static Object strlit2214;
static Object strlit2225;
static Object strlit2230;
static Object strlit2235;
static Object strlit2238;
static Object strlit2272;
static Object strlit2309;
static Object strlit2320;
static Object strlit2325;
static Object strlit2345;
static Object strlit2352;
static Object strlit2366;
static Object strlit2373;
static Object strlit2381;
static Object strlit2384;
static Object strlit2387;
static Object strlit2390;
static Object strlit2393;
static Object strlit2394;
static Object strlit2397;
static Object strlit2411;
static Object strlit2418;
static Object strlit2427;
static Object strlit2435;
static Object strlit2442;
static Object strlit2467;
static Object strlit2471;
static Object strlit2481;
static Object strlit2484;
static Object strlit2488;
static Object strlit2498;
static Object strlit2501;
static Object strlit2504;
static Object strlit2511;
static Object strlit2521;
static Object strlit2524;
static Object strlit2527;
static Object strlit2534;
static Object strlit2536;
static Object strlit2565;
static Object strlit2572;
static Object strlit2596;
static Object strlit2604;
static Object strlit2611;
static Object strlit2614;
static Object strlit2625;
static Object strlit2628;
static Object strlit2639;
static Object strlit2642;
static Object strlit2667;
static Object strlit2672;
static Object strlit2677;
static Object strlit2681;
static Object strlit2687;
static Object strlit2707;
static Object strlit2714;
static Object strlit2727;
static Object strlit2751;
static Object strlit2756;
static Object strlit2767;
static Object strlit2772;
static Object strlit2791;
static Object strlit2794;
static Object strlit2805;
static Object strlit2808;
static Object strlit2811;
static Object strlit2819;
static Object strlit2847;
static Object strlit2858;
static Object strlit2863;
static Object strlit2868;
static Object strlit2871;
static Object strlit2905;
static Object strlit2942;
static Object strlit2953;
static Object strlit2958;
static Object strlit2986;
static Object strlit2993;
static Object strlit3000;
static Object strlit3028;
static Object strlit3039;
static Object strlit3044;
static Object strlit3049;
static Object strlit3052;
static Object strlit3086;
static Object strlit3123;
static Object strlit3134;
static Object strlit3139;
static Object strlit3170;
static Object strlit3194;
static Object strlit3199;
static Object strlit3210;
static Object strlit3215;
static Object strlit3234;
static Object strlit3237;
static Object strlit3248;
static Object strlit3251;
static Object strlit3255;
static Object strlit3257;
static Object strlit3269;
static Object strlit3273;
static Object strlit3285;
static Object strlit3293;
static Object strlit3313;
static Object strlit3320;
static Object strlit3327;
static Object strlit3330;
static Object strlit3338;
static Object strlit3350;
static Object strlit3353;
static Object strlit3386;
static Object strlit3393;
static Object strlit3400;
static Object strlit3406;
static Object strlit3433;
static Object strlit3456;
static Object strlit3478;
static Object strlit3492;
static Object strlit3503;
static Object strlit3514;
static Object strlit3528;
static Object strlit3542;
static Object strlit3582;
static Object strlit3588;
static Object strlit3598;
static Object strlit3605;
static Object strlit3609;
static Object strlit3624;
static Object strlit3634;
static Object strlit3641;
static Object strlit3645;
static Object strlit3669;
static Object strlit3676;
static Object strlit3685;
static Object strlit3691;
static Object strlit3706;
static Object strlit3713;
static Object strlit3731;
static Object strlit3739;
static Object strlit3754;
static Object strlit3758;
static Object strlit3764;
static Object strlit3768;
static Object strlit3778;
static Object strlit3782;
static Object strlit3787;
static Object strlit3793;
static Object strlit3796;
static Object strlit3799;
static Object strlit3832;
static Object strlit3839;
static Object strlit3846;
static Object strlit3849;
static Object strlit3857;
static Object strlit3869;
static Object strlit3872;
static Object strlit3894;
static Object strlit3901;
static Object strlit3911;
static Object strlit3917;
static Object strlit3937;
static Object strlit3944;
static Object strlit3951;
static Object strlit3954;
static Object strlit3962;
static Object strlit3974;
static Object strlit3977;
static Object strlit4006;
static Object strlit4011;
static Object strlit4020;
static Object strlit4030;
static Object strlit4035;
static Object strlit4040;
static Object strlit4045;
static Object strlit4060;
static Object strlit4067;
static Object strlit4075;
static Object strlit4079;
static Object strlit4082;
static Object strlit4084;
static Object strlit4101;
static Object strlit4108;
static Object strlit4115;
static Object strlit4121;
static Object strlit4141;
static Object strlit4148;
static Object strlit4155;
static Object strlit4158;
static Object strlit4166;
static Object strlit4178;
static Object strlit4181;
static Object strlit4210;
static Object strlit4215;
static Object strlit4224;
static Object strlit4234;
static Object strlit4239;
static Object strlit4244;
static Object strlit4249;
static Object strlit4276;
static Object strlit4283;
static Object strlit4292;
static Object strlit4307;
static Object strlit4314;
static Object strlit4331;
static Object strlit4346;
static Object strlit4350;
static Object strlit4360;
static Object strlit4363;
static Object strlit4367;
static Object strlit4373;
static Object strlit4376;
static Object strlit4382;
static Object strlit4411;
static Object strlit4418;
static Object strlit4425;
static Object strlit4428;
static Object strlit4438;
static Object strlit4450;
static Object strlit4453;
static Object strlit4473;
static Object strlit4480;
static Object strlit4490;
static Object strlit4496;
static Object strlit4516;
static Object strlit4523;
static Object strlit4530;
static Object strlit4533;
static Object strlit4541;
static Object strlit4553;
static Object strlit4556;
static Object strlit4585;
static Object strlit4590;
static Object strlit4599;
static Object strlit4609;
static Object strlit4614;
static Object strlit4619;
static Object strlit4624;
static Object strlit4658;
static Object strlit4664;
static Object strlit4671;
static Object strlit4678;
static Object strlit4686;
static Object strlit4693;
static Object strlit4700;
static Object strlit4706;
static Object strlit4712;
static Object strlit4718;
static Object strlit4724;
static Object strlit4731;
static Object strlit4735;
static Object strlit4745;
static Object strlit4760;
static Object strlit4787;
static Object strlit4794;
static Object strlit4801;
static Object strlit4804;
static Object strlit4812;
static Object strlit4824;
static Object strlit4827;
static Object strlit4860;
static Object strlit4886;
static Object strlit4893;
static Object strlit4900;
static Object strlit4906;
static Object strlit4923;
static Object strlit4933;
static Object strlit4943;
static Object strlit4946;
static Object strlit4974;
static Object strlit4980;
static Object strlit5001;
static Object strlit5004;
static Object strlit5014;
static Object strlit5017;
static Object strlit5033;
static Object strlit5041;
static Object strlit5048;
static Object strlit5070;
static Object strlit5076;
static Object strlit5082;
static Object strlit5087;
static Object strlit5106;
static Object strlit5120;
static Object strlit5123;
static Object strlit5135;
static Object strlit5140;
static Object strlit5151;
static Object strlit5210;
static Object strlit5225;
static Object strlit5233;
static Object strlit5237;
static Object strlit5247;
static Object strlit5251;
static Object strlit5257;
static Object strlit5261;
static Object strlit5271;
static Object strlit5283;
static Object strlit5286;
static Object strlit5325;
static Object strlit5329;
static Object strlit5348;
static Object strlit5359;
static Object strlit5365;
static Object strlit5398;
static Object strlit5399;
static Object strlit5400;
static Object strlit5401;
static Object strlit5409;
static Object strlit5413;
static Object strlit5423;
static Object strlit5427;
static Object strlit5448;
static Object strlit5455;
static Object strlit5459;
static Object strlit5536;
static Object strlit5545;
static Object strlit5559;
static Object strlit5579;
static Object strlit5586;
static Object strlit5591;
static Object strlit5596;
static Object strlit5601;
static Object strlit5607;
static Object strlit5613;
static Object strlit5640;
static Object strlit5645;
static Object strlit5664;
static Object strlit5671;
static Object strlit5702;
static Object strlit5709;
static Object strlit5731;
static Object strlit5758;
static Object strlit5767;
static Object strlit5778;
static Object strlit5794;
static Object strlit5808;
static Object strlit5824;
static Object strlit5880;
static Object strlit5886;
static Object strlit5897;
static Object strlit5911;
static Object strlit5937;
static Object strlit5969;
static Object strlit5976;
static Object strlit5983;
static Object strlit6001;
static Object strlit6017;
static Object strlit6050;
static Object strlit6057;
static Object strlit6064;
static Object strlit6082;
static Object strlit6090;
static Object strlit6096;
static Object strlit6107;
static Object strlit6121;
static Object strlit6145;
static Object strlit6177;
static Object strlit6184;
static Object strlit6191;
static Object strlit6209;
static Object strlit6233;
static Object strlit6245;
static Object strlit6248;
static Object strlit6285;
static Object strlit6311;
static Object strlit6322;
static Object strlit6332;
static Object strlit6339;
static Object strlit6344;
static Object strlit6346;
static Object strlit6363;
static Object strlit6369;
static Object strlit6402;
static Object strlit6406;
static Object strlit6420;
static Object strlit6442;
static Object strlit6457;
static Object strlit6466;
static Object strlit6472;
static Object strlit6478;
static Object strlit6482;
static Object strlit6490;
static Object strlit6494;
static Object strlit6501;
static Object strlit6509;
static Object strlit6513;
static Object strlit6516;
static Object strlit6524;
static Object strlit6528;
static Object strlit6531;
static Object strlit6538;
static Object strlit6541;
static Object strlit6548;
static Object strlit6555;
static Object strlit6580;
static Object strlit6587;
static Object strlit6594;
static Object strlit6612;
static Object strlit6622;
static Object strlit6656;
static Object strlit6663;
static Object strlit6670;
static Object strlit6688;
static Object strlit6711;
static Object strlit6723;
static Object strlit6726;
static Object strlit6743;
static Object strlit6766;
static Object strlit6776;
static Object strlit6799;
static Object strlit6806;
static Object strlit6821;
static Object strlit6828;
static Object strlit6835;
static Object strlit6839;
static Object strlit6841;
static Object strlit6863;
static Object strlit6870;
static Object strlit6897;
static Object strlit6904;
static Object strlit6907;
static Object strlit6923;
static Object strlit6934;
static Object strlit6944;
static Object strlit6950;
static Object strlit6952;
static Object strlit6974;
static Object strlit6984;
static Object strlit6990;
static Object strlit6992;
static Object strlit7019;
static Object strlit7030;
static Object strlit7040;
static Object strlit7062;
static Object strlit7084;
static Object strlit7091;
static Object strlit7094;
static Object strlit7114;
static Object strlit7144;
static Object strlit7151;
static Object strlit7170;
static Object strlit7172;
static Object strlit7190;
static Object strlit7197;
static Object strlit7209;
static Object strlit7219;
static Object strlit7224;
static Object strlit7248;
static Object strlit7257;
static Object strlit7274;
static Object strlit7306;
static Object strlit7313;
static Object strlit7320;
static Object strlit7338;
static Object strlit7355;
static Object strlit7365;
static Object strlit7368;
static Object strlit7390;
static Object strlit7396;
static Object strlit7416;
static Object strlit7424;
static Object strlit7430;
static Object strlit7438;
static Object strlit7453;
static Object strlit7471;
static Object strlit7477;
static Object strlit7485;
static Object strlit7492;
static Object strlit7523;
static Object strlit7530;
static Object strlit7537;
static Object strlit7555;
static Object strlit7561;
static Object strlit7566;
static Object strlit7572;
static Object strlit7577;
static Object strlit7610;
static Object strlit7634;
static Object strlit7640;
static Object strlit7649;
static Object strlit7668;
static Object strlit7675;
static Object strlit7692;
static Object strlit7694;
static Object strlit7724;
static Object strlit7729;
static Object strlit7730;
static Object strlit7737;
static Object strlit7750;
static Object strlit7763;
static Object strlit7766;
static Object strlit7770;
static Object strlit7775;
static Object strlit7779;
static Object strlit7829;
static Object strlit7837;
static Object strlit7867;
static Object strlit7871;
static Object strlit7875;
static Object strlit7891;
static Object strlit7895;
static Object strlit7900;
static Object strlit7906;
static Object strlit7955;
static Object strlit7959;
static Object strlit7964;
static Object strlit7970;
static Object strlit8025;
static Object strlit8036;
static Object strlit8046;
static Object strlit8056;
static Object strlit8065;
static Object strlit8070;
static Object strlit8088;
static Object strlit8118;
static Object strlit8119;
static Object strlit8158;
static Object strlit8168;
static Object strlit8174;
static Object strlit8182;
static Object strlit8195;
static Object strlit8201;
static Object strlit8217;
static Object strlit8233;
static Object strlit8243;
static Object strlit8262;
static Object strlit8274;
static Object strlit8283;
static Object strlit8293;
static Object strlit8304;
static Object strlit8314;
static Object strlit8324;
static Object strlit8333;
static Object strlit8338;
static Object strlit8366;
static Object strlit8367;
static Object strlit8402;
static Object strlit8425;
static ClassData objclass8453;
static Object strlit8457;
static Object strlit8458;
static Object strlit8468;
static Object strlit8487;
static Object strlit8513;
static Object strlit8524;
static Object strlit8529;
static Object strlit8559;
static Object strlit8571;
static Object strlit8574;
static Object strlit8578;
static Object strlit8582;
static Object strlit8634;
static Object strlit8639;
static Object strlit8650;
static Object strlit8677;
static Object strlit8685;
static Object strlit8689;
static Object strlit8691;
static Object strlit8707;
static Object strlit8714;
static Object strlit8719;
static Object strlit8727;
static Object strlit8735;
static Object strlit8749;
static Object strlit8777;
static Object strlit8808;
static Object strlit8818;
static Object strlit8821;
static Object strlit8838;
static Object strlit8847;
static Object strlit8857;
static Object strlit8860;
static Object strlit8888;
static Object strlit8913;
static Object strlit8929;
static Object strlit8940;
static Object strlit8948;
static Object strlit8955;
static Object strlit8967;
static Object strlit8970;
static Object strlit9010;
static Object strlit9017;
static Object strlit9028;
static Object strlit9045;
static Object strlit9068;
static Object strlit9074;
static Object strlit9094;
static Object strlit9100;
static Object strlit9107;
static Object strlit9123;
static Object strlit9126;
static Object strlit9140;
static Object strlit9145;
static Object strlit9152;
static Object strlit9158;
static Object strlit9166;
static Object strlit9175;
static Object strlit9182;
static Object strlit9210;
static Object strlit9225;
static Object strlit9232;
static Object strlit9237;
static Object strlit9245;
static Object strlit9251;
static Object strlit9265;
static Object strlit9293;
static Object strlit9326;
static Object strlit9348;
static Object strlit9364;
static Object strlit9372;
static Object strlit9378;
static Object strlit9389;
static Object strlit9402;
static Object strlit9405;
static Object strlit9422;
static Object strlit9429;
static Object strlit9436;
static Object strlit9446;
static Object strlit9449;
static Object strlit9464;
static Object strlit9486;
static Object strlit9500;
static Object strlit9505;
static Object strlit9535;
static Object strlit9540;
static Object strlit9564;
static ClassData objclass9575;
static Object strlit9594;
static Object strlit9610;
static Object strlit9630;
static Object strlit9640;
static Object strlit9643;
static Object strlit9659;
static Object strlit9667;
static Object strlit9687;
static Object strlit9695;
static Object strlit9701;
static Object strlit9709;
static Object strlit9724;
static Object strlit9735;
static Object strlit9742;
static Object strlit9763;
static Object strlit9770;
static Object strlit9774;
static Object strlit9780;
static Object strlit9785;
static Object strlit9804;
static Object strlit9824;
static Object strlit9832;
static Object strlit9838;
static Object strlit9847;
static Object strlit9853;
static Object strlit9870;
static Object strlit9903;
static Object strlit9912;
static Object strlit9922;
static Object strlit9949;
static Object strlit9956;
static Object strlit9974;
static Object strlit9992;
static Object strlit10013;
static Object strlit10049;
static Object strlit10077;
static Object strlit10084;
static Object strlit10131;
static Object strlit10140;
static Object strlit10147;
static Object strlit10155;
static Object strlit10158;
static Object strlit10166;
static Object strlit10182;
static Object strlit10190;
static Object strlit10223;
static Object strlit10233;
static Object strlit10243;
static Object strlit10246;
static Object strlit10274;
static Object strlit10290;
static Object strlit10297;
static Object strlit10311;
static Object strlit10332;
static Object strlit10337;
static Object strlit10340;
static Object strlit10359;
static Object strlit10388;
static Object strlit10396;
static Object strlit10404;
static Object strlit10411;
static Object strlit10420;
static Object strlit10466;
static Object strlit10510;
static Object strlit10521;
static Object strlit10528;
static Object strlit10545;
static Object strlit10549;
static Object strlit10553;
static Object strlit10585;
static Object strlit10586;
static Object strlit10587;
static Object strlit10588;
static Object strlit10589;
static Object strlit10617;
static Object strlit10621;
static Object strlit10630;
static Object strlit10639;
static Object strlit10648;
static Object strlit10657;
static Object strlit10666;
static Object strlit10675;
static Object strlit10684;
static Object strlit10693;
static Object strlit10713;
static Object strlit10718;
static Object strlit10728;
static Object strlit10737;
static Object strlit10751;
static Object strlit10757;
static Object strlit10764;
static Object strlit10768;
static Object strlit10775;
static Object strlit10801;
static Object strlit10808;
static Object strlit10815;
static Object strlit10833;
static Object strlit10859;
static Object strlit10864;
static Object strlit10884;
static Object strlit10902;
static Object strlit10958;
static Object strlit11023;
static Object strlit11130;
static Object strlit11147;
static Object strlit11157;
static Object strlit11160;
static Object strlit11170;
static Object strlit11180;
static Object strlit11183;
static Object strlit11194;
static Object strlit11204;
static Object strlit11207;
static Object strlit11227;
static Object strlit11235;
static Object strlit11242;
static Object strlit11260;
static Object strlit11271;
static Object strlit11276;
static Object strlit11286;
static Object strlit11296;
static Object strlit11303;
static Object strlit11313;
static Object strlit11330;
static Object strlit11340;
static Object strlit11349;
static Object strlit11375;
static Object strlit11381;
static Object strlit11413;
static Object strlit11419;
static Object strlit11424;
static Object strlit11432;
static Object strlit11448;
static Object strlit11454;
static Object strlit11462;
static Object strlit11536;
static Object strlit11544;
static Object strlit11555;
static Object strlit11560;
static Object strlit11566;
static Object strlit11573;
static Object strlit11578;
static Object strlit11585;
static Object strlit11590;
static Object strlit11628;
static Object strlit11681;
static Object strlit11683;
static Object strlit11718;
static Object strlit11720;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_errormessages;
Object module_errormessages_init();
static Object strlit11806;
static Object strlit11810;
static Object strlit11814;
static ClassData objclass11823;
static Object strlit11831;
static Object strlit11835;
Object meth_parser_noteBlank1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noteBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blankLocation = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for noteBlank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for noteBlank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3 = alloc_Float64(1);
// compiled num node returning num3 (depth = 4)
  int op_slot_right_2 = gc_frame_newslot(num3);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5);
// compiled call node returning call6 (depth = 5)
// compiled member node returning call6 (depth = 4)
  int op_slot_left_2 = gc_frame_newslot(call6);
  params[0] = num3;
  partcv[0] = 1;
  Object diff7 = callmethod(call6, "-", 1, partcv, params);
// compiled op node returning diff7 (depth = 3)
  *var_blankLocation = diff7;
  if (diff7 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_next9(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_lastLine = getfromclosure(closure, 3);
  Object *var_lastIndent = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num12 = alloc_Float64(0);
// compiled num node returning num12 (depth = 4)
  int op_slot_right_11 = gc_frame_newslot(num12);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe14 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call15 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe14);
// compiled call node returning call15 (depth = 5)
// compiled member node returning call15 (depth = 4)
  int op_slot_left_11 = gc_frame_newslot(call15);
  params[0] = num12;
  partcv[0] = 1;
  Object opresult16 = callmethod(call15, ">", 1, partcv, params);
// compiled op node returning opresult16 (depth = 3)
  Object if10 = done;
  if (istrue(opresult16)) {
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe18 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call19 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe18);
// compiled call node returning call19 (depth = 5)
// compiled member node returning call19 (depth = 4)
  *var_lastLine = call19;
  if (call19 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe21 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call22 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe21);
// compiled call node returning call22 (depth = 5)
// compiled member node returning call22 (depth = 4)
  *var_lastIndent = call22;
  if (call22 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe24 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call25 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe24);
// compiled call node returning call25 (depth = 5)
// compiled member node returning call25 (depth = 4)
  *var_sym = call25;
  if (call25 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num30 = alloc_Float64(1);
// compiled num node returning num30 (depth = 6)
  int op_slot_right_29 = gc_frame_newslot(num30);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastLine (depth = 6)
  int op_slot_left_29 = gc_frame_newslot(*var_lastLine);
  params[0] = num30;
  partcv[0] = 1;
  Object sum32 = callmethod(*var_lastLine, "+", 1, partcv, params);
// compiled op node returning sum32 (depth = 5)
  int op_slot_right_28 = gc_frame_newslot(sum32);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe34 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call35 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe34);
// compiled call node returning call35 (depth = 6)
// compiled member node returning call35 (depth = 5)
  int op_slot_left_28 = gc_frame_newslot(call35);
  params[0] = sum32;
  partcv[0] = 1;
  Object opresult36 = callmethod(call35, ">", 1, partcv, params);
// compiled op node returning opresult36 (depth = 4)
  Object if27 = done;
  if (istrue(opresult36)) {
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe37 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call38 = callmethodflags(self, "noteBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compiled call node returning call38 (depth = 5)
// compiled member node returning call38 (depth = 4)
    gc_frame_newslot(call38);
    if27 = call38;
  } else {
  }
// compiled if node returning if27 (depth = 3)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe39 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call40 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe39);
// compiled call node returning call40 (depth = 4)
// compiled member node returning call40 (depth = 3)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe41 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe42 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call43 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe42);
// compiled call node returning call43 (depth = 5)
// compiled member node returning call43 (depth = 4)
  gc_frame_newslot(call43);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe44 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call45 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 5)
// compiled member node returning call45 (depth = 4)
  gc_frame_newslot(call45);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call43;
  params[1] = call45;
  partcv[0] = 2;
  Object call46 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe41);
// compiled call node returning call46 (depth = 3)
    gc_frame_newslot(call46);
    if10 = call46;
  } else {
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe47 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit49 == NULL) {
    strlit49 = alloc_String("This is often caused by a missing '}'");
    gc_root(strlit49);
  }
// compiled string node returning strlit49 (depth = 5)
  int op_slot_right_48 = gc_frame_newslot(strlit49);
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit51 == NULL) {
    strlit51 = alloc_String("unexpectedly found the end of the input. ");
    gc_root(strlit51);
  }
// compiled string node returning strlit51 (depth = 5)
  int op_slot_left_48 = gc_frame_newslot(strlit51);
  params[0] = strlit49;
  partcv[0] = 1;
  Object opresult52 = callmethod(strlit51, "++", 1, partcv, params);
// compiled op node returning opresult52 (depth = 4)
  gc_frame_newslot(opresult52);
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe53 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call54 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe53);
// compiled call node returning call54 (depth = 5)
// compiled member node returning call54 (depth = 4)
  gc_frame_newslot(call54);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe55 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call56 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe55);
// compiled call node returning call56 (depth = 5)
// compiled member node returning call56 (depth = 4)
  gc_frame_newslot(call56);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe57 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call58 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe57);
// compiled call node returning call58 (depth = 5)
// compiled member node returning call58 (depth = 4)
  gc_frame_newslot(call58);
// call case 6: other member request
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult52;
  params[1] = call54;
  params[2] = call56;
  params[3] = call58;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call59 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe47);
// compiled call node returning call59 (depth = 3)
    gc_frame_newslot(call59);
    if10 = call59;
  }
// compiled if node returning if10 (depth = 2)
  gc_frame_end(frame);
  return if10;
}
Object meth_parser__apply70(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe72 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call73 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe72);
// compiled call node returning call73 (depth = 8)
// compiled member node returning call73 (depth = 7)
  int op_slot_right_71 = gc_frame_newslot(call73);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe75 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call76 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe75);
// compiled call node returning call76 (depth = 8)
// compiled member node returning call76 (depth = 7)
  int op_slot_left_71 = gc_frame_newslot(call76);
  params[0] = call73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, ">=", 1, partcv, params);
// compiled op node returning opresult77 (depth = 6)
  gc_frame_end(frame);
  return opresult77;
}
Object meth_parser__apply81(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 8)
  int op_slot_right_82 = gc_frame_newslot(bool83);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_82 = gc_frame_newslot(*var_nextTok);
  params[0] = bool83;
  partcv[0] = 1;
  Object opresult85 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult85 (depth = 7)
  gc_frame_end(frame);
  return opresult85;
}
Object meth_parser__apply67(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe68 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block69 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block69);
// method "_apply"
  block_savedest(block69);
  Object closure70 = createclosure(3, "_apply");
  setclosureframe(closure70, stackframe);
  addtoclosure(closure70, var_lastToken);
  addtoclosure(closure70, var_n);
  addtoclosure(closure70, selfslot);
  struct UserObject *uo70 = (struct UserObject*)block69;
  uo70->data[0] = (Object)closure70;
  Method *meth_meth_parser__apply70 = addmethod2pos(block69, "_apply", &meth_parser__apply70, 0);
  int argcv_meth_parser__apply70[] = {0};
  meth_meth_parser__apply70->type = alloc_MethodType(1, argcv_meth_parser__apply70);
  meth_meth_parser__apply70->definitionModule = modulename;
  meth_meth_parser__apply70->definitionLine = 61;
// compiled block node returning block69 (depth = 5)
  gc_frame_newslot(block69);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe79 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block80 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block80);
// method "_apply"
  block_savedest(block80);
  Object closure81 = createclosure(2, "_apply");
  setclosureframe(closure81, stackframe);
  addtoclosure(closure81, var_nextTok);
  addtoclosure(closure81, selfslot);
  struct UserObject *uo81 = (struct UserObject*)block80;
  uo81->data[0] = (Object)closure81;
  Method *meth_meth_parser__apply81 = addmethod2pos(block80, "_apply", &meth_parser__apply81, 0);
  int argcv_meth_parser__apply81[] = {0};
  meth_meth_parser__apply81->type = alloc_MethodType(1, argcv_meth_parser__apply81);
  meth_meth_parser__apply81->definitionModule = modulename;
  meth_meth_parser__apply81->definitionLine = 75;
// compiled block node returning block80 (depth = 6)
  gc_frame_newslot(block80);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool88 = alloc_Boolean(0);
// compiled identifier node returning bool88 (depth = 7)
  int op_slot_right_87 = gc_frame_newslot(bool88);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_87 = gc_frame_newslot(*var_n);
  params[0] = bool88;
  partcv[0] = 1;
  Object opresult90 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult90 (depth = 6)
  params[0] = block80;
  partcv[0] = 1;
  Object call91 = callmethod(opresult90, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe79);
// compiled call node returning call91 (depth = 5)
  params[0] = block69;
  partcv[0] = 1;
  Object call92 = callmethod(call91, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe68);
// compiled call node returning call92 (depth = 4)
  gc_frame_end(frame);
  return call92;
}
Object meth_parser__apply95(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe97 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call98 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe97);
// compiled call node returning call98 (depth = 5)
  Object if96 = done;
  if (istrue(call98)) {
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if96 = done;
  } else {
  }
// compiled if node returning if96 (depth = 4)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe100 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call101 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe100);
// compiled call node returning call101 (depth = 6)
// compiled member node returning call101 (depth = 5)
  *var_n = call101;
  if (call101 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextToken60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextToken");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findNextToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe62 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call63 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe62);
// compiled call node returning call63 (depth = 3)
  Object if61 = done;
  if (istrue(call63)) {
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if61 = undefined;
  } else {
  }
// compiled if node returning if61 (depth = 2)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool64 = alloc_Boolean(0);
// compiled identifier node returning bool64 (depth = 3)
  *var_nextTok = bool64;
  if (bool64 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe65 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block66 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block66);
// method "_apply"
  block_savedest(block66);
  Object closure67 = createclosure(4, "_apply");
  setclosureframe(closure67, stackframe);
  addtoclosure(closure67, var_lastToken);
  addtoclosure(closure67, var_n);
  addtoclosure(closure67, var_nextTok);
  addtoclosure(closure67, selfslot);
  struct UserObject *uo67 = (struct UserObject*)block66;
  uo67->data[0] = (Object)closure67;
  Method *meth_meth_parser__apply67 = addmethod2pos(block66, "_apply", &meth_parser__apply67, 0);
  int argcv_meth_parser__apply67[] = {0};
  meth_meth_parser__apply67->type = alloc_MethodType(1, argcv_meth_parser__apply67);
  meth_meth_parser__apply67->definitionModule = modulename;
  meth_meth_parser__apply67->definitionLine = 61;
// compiled block node returning block66 (depth = 3)
  gc_frame_newslot(block66);
// starting to compile block node (depth = 3)
  Object block94 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block94);
// method "_apply"
  block_savedest(block94);
  Object closure95 = createclosure(4, "_apply");
  setclosureframe(closure95, stackframe);
  addtoclosure(closure95, var_n);
  addtoclosure(closure95, var_tokenMatcher);
  addtoclosure(closure95, var_nextTok);
  addtoclosure(closure95, selfslot);
  struct UserObject *uo95 = (struct UserObject*)block94;
  uo95->data[0] = (Object)closure95;
  Method *meth_meth_parser__apply95 = addmethod2pos(block94, "_apply", &meth_parser__apply95, 0);
  int argcv_meth_parser__apply95[] = {0};
  meth_meth_parser__apply95->type = alloc_MethodType(1, argcv_meth_parser__apply95);
  meth_meth_parser__apply95->definitionModule = modulename;
  meth_meth_parser__apply95->definitionLine = 75;
// compiled block node returning block94 (depth = 3)
  gc_frame_newslot(block94);
// call case 5: prelude request
  params[0] = block66;
  params[1] = block94;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call104 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe65);
// compiled call node returning call104 (depth = 2)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply139(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool141 = alloc_Boolean(0);
// compiled identifier node returning bool141 (depth = 7)
  int op_slot_right_140 = gc_frame_newslot(bool141);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_140 = gc_frame_newslot(*var_nextTok);
  params[0] = bool141;
  partcv[0] = 1;
  Object opresult143 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult143 (depth = 6)
  gc_frame_end(frame);
  return opresult143;
}
Object meth_parser__apply136(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe137 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block138 = alloc_Block(NULL, NULL, "parser", 90);
  gc_frame_newslot(block138);
// method "_apply"
  block_savedest(block138);
  Object closure139 = createclosure(2, "_apply");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_nextTok);
  addtoclosure(closure139, selfslot);
  struct UserObject *uo139 = (struct UserObject*)block138;
  uo139->data[0] = (Object)closure139;
  Method *meth_meth_parser__apply139 = addmethod2pos(block138, "_apply", &meth_parser__apply139, 0);
  int argcv_meth_parser__apply139[] = {0};
  meth_meth_parser__apply139->type = alloc_MethodType(1, argcv_meth_parser__apply139);
  meth_meth_parser__apply139->definitionModule = modulename;
  meth_meth_parser__apply139->definitionLine = 85;
// compiled block node returning block138 (depth = 5)
  gc_frame_newslot(block138);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool146 = alloc_Boolean(0);
// compiled identifier node returning bool146 (depth = 6)
  int op_slot_right_145 = gc_frame_newslot(bool146);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_145 = gc_frame_newslot(*var_n);
  params[0] = bool146;
  partcv[0] = 1;
  Object opresult148 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult148 (depth = 5)
  params[0] = block138;
  partcv[0] = 1;
  Object call149 = callmethod(opresult148, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe137);
// compiled call node returning call149 (depth = 4)
  gc_frame_end(frame);
  return call149;
}
Object meth_parser__apply152(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit156 == NULL) {
    strlit156 = alloc_String("eof");
    gc_root(strlit156);
  }
// compiled string node returning strlit156 (depth = 7)
  int op_slot_right_155 = gc_frame_newslot(strlit156);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call159 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe158);
// compiled call node returning call159 (depth = 8)
// compiled member node returning call159 (depth = 7)
  int op_slot_left_155 = gc_frame_newslot(call159);
  params[0] = strlit156;
  partcv[0] = 1;
  Object opresult160 = callmethod(call159, "==", 1, partcv, params);
// compiled op node returning opresult160 (depth = 6)
  int op_slot_right_154 = gc_frame_newslot(opresult160);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call165 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe164);
// compiled call node returning call165 (depth = 9)
// compiled member node returning call165 (depth = 8)
  int op_slot_right_163 = gc_frame_newslot(call165);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call168 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe167);
// compiled call node returning call168 (depth = 9)
// compiled member node returning call168 (depth = 8)
  int op_slot_left_163 = gc_frame_newslot(call168);
  params[0] = call165;
  partcv[0] = 1;
  Object opresult169 = callmethod(call168, "<=", 1, partcv, params);
// compiled op node returning opresult169 (depth = 7)
  int op_slot_right_162 = gc_frame_newslot(opresult169);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call173 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe172);
// compiled call node returning call173 (depth = 9)
// compiled member node returning call173 (depth = 8)
  int op_slot_right_171 = gc_frame_newslot(call173);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call176 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe175);
// compiled call node returning call176 (depth = 9)
// compiled member node returning call176 (depth = 8)
  int op_slot_left_171 = gc_frame_newslot(call176);
  params[0] = call173;
  partcv[0] = 1;
  Object opresult177 = callmethod(call176, ">", 1, partcv, params);
// compiled op node returning opresult177 (depth = 7)
  int op_slot_left_162 = gc_frame_newslot(opresult177);
  params[0] = opresult169;
  partcv[0] = 1;
  Object opresult178 = callmethod(opresult177, "&&", 1, partcv, params);
// compiled op node returning opresult178 (depth = 6)
  int op_slot_left_154 = gc_frame_newslot(opresult178);
  params[0] = opresult160;
  partcv[0] = 1;
  Object opresult179 = callmethod(opresult178, "||", 1, partcv, params);
// compiled op node returning opresult179 (depth = 5)
  Object if153 = done;
  if (istrue(opresult179)) {
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if153 = done;
  } else {
  }
// compiled if node returning if153 (depth = 4)
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe181 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call182 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe181);
// compiled call node returning call182 (depth = 6)
// compiled member node returning call182 (depth = 5)
  *var_n = call182;
  if (call182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextTokenIndentedAt105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextTokenIndentedAt");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextTokenIndentedAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findNextTokenIndentedAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit109 == NULL) {
    strlit109 = alloc_String("eof");
    gc_root(strlit109);
  }
// compiled string node returning strlit109 (depth = 5)
  int op_slot_right_108 = gc_frame_newslot(strlit109);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call112 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe111);
// compiled call node returning call112 (depth = 6)
// compiled member node returning call112 (depth = 5)
  int op_slot_left_108 = gc_frame_newslot(call112);
  params[0] = strlit109;
  partcv[0] = 1;
  Object opresult113 = callmethod(call112, "==", 1, partcv, params);
// compiled op node returning opresult113 (depth = 4)
  int op_slot_right_107 = gc_frame_newslot(opresult113);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call118 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe117);
// compiled call node returning call118 (depth = 7)
// compiled member node returning call118 (depth = 6)
  int op_slot_right_116 = gc_frame_newslot(call118);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe120 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call121 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe120);
// compiled call node returning call121 (depth = 7)
// compiled member node returning call121 (depth = 6)
  int op_slot_left_116 = gc_frame_newslot(call121);
  params[0] = call118;
  partcv[0] = 1;
  Object opresult122 = callmethod(call121, "<=", 1, partcv, params);
// compiled op node returning opresult122 (depth = 5)
  int op_slot_right_115 = gc_frame_newslot(opresult122);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe125 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call126 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe125);
// compiled call node returning call126 (depth = 7)
// compiled member node returning call126 (depth = 6)
  int op_slot_right_124 = gc_frame_newslot(call126);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call129 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe128);
// compiled call node returning call129 (depth = 7)
// compiled member node returning call129 (depth = 6)
  int op_slot_left_124 = gc_frame_newslot(call129);
  params[0] = call126;
  partcv[0] = 1;
  Object opresult130 = callmethod(call129, ">", 1, partcv, params);
// compiled op node returning opresult130 (depth = 5)
  int op_slot_left_115 = gc_frame_newslot(opresult130);
  params[0] = opresult122;
  partcv[0] = 1;
  Object opresult131 = callmethod(opresult130, "&&", 1, partcv, params);
// compiled op node returning opresult131 (depth = 4)
  int op_slot_left_107 = gc_frame_newslot(opresult131);
  params[0] = opresult113;
  partcv[0] = 1;
  Object opresult132 = callmethod(opresult131, "||", 1, partcv, params);
// compiled op node returning opresult132 (depth = 3)
  Object if106 = done;
  if (istrue(opresult132)) {
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if106 = undefined;
  } else {
  }
// compiled if node returning if106 (depth = 2)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool133 = alloc_Boolean(0);
// compiled identifier node returning bool133 (depth = 3)
  *var_nextTok = bool133;
  if (bool133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe134 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block135 = alloc_Block(NULL, NULL, "parser", 90);
  gc_frame_newslot(block135);
// method "_apply"
  block_savedest(block135);
  Object closure136 = createclosure(3, "_apply");
  setclosureframe(closure136, stackframe);
  addtoclosure(closure136, var_nextTok);
  addtoclosure(closure136, var_n);
  addtoclosure(closure136, selfslot);
  struct UserObject *uo136 = (struct UserObject*)block135;
  uo136->data[0] = (Object)closure136;
  Method *meth_meth_parser__apply136 = addmethod2pos(block135, "_apply", &meth_parser__apply136, 0);
  int argcv_meth_parser__apply136[] = {0};
  meth_meth_parser__apply136->type = alloc_MethodType(1, argcv_meth_parser__apply136);
  meth_meth_parser__apply136->definitionModule = modulename;
  meth_meth_parser__apply136->definitionLine = 85;
// compiled block node returning block135 (depth = 3)
  gc_frame_newslot(block135);
// starting to compile block node (depth = 3)
  Object block151 = alloc_Block(NULL, NULL, "parser", 90);
  gc_frame_newslot(block151);
// method "_apply"
  block_savedest(block151);
  Object closure152 = createclosure(5, "_apply");
  setclosureframe(closure152, stackframe);
  addtoclosure(closure152, var_sym);
  addtoclosure(closure152, var_tok);
  addtoclosure(closure152, var_n);
  addtoclosure(closure152, var_nextTok);
  addtoclosure(closure152, selfslot);
  struct UserObject *uo152 = (struct UserObject*)block151;
  uo152->data[0] = (Object)closure152;
  Method *meth_meth_parser__apply152 = addmethod2pos(block151, "_apply", &meth_parser__apply152, 0);
  int argcv_meth_parser__apply152[] = {0};
  meth_meth_parser__apply152->type = alloc_MethodType(1, argcv_meth_parser__apply152);
  meth_meth_parser__apply152->definitionModule = modulename;
  meth_meth_parser__apply152->definitionLine = 85;
// compiled block node returning block151 (depth = 3)
  gc_frame_newslot(block151);
// call case 5: prelude request
  params[0] = block135;
  params[1] = block151;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call185 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe134);
// compiled call node returning call185 (depth = 2)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply201(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit203 == NULL) {
    strlit203 = alloc_String("eof");
    gc_root(strlit203);
  }
// compiled string node returning strlit203 (depth = 5)
  int op_slot_right_202 = gc_frame_newslot(strlit203);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call206 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe205);
// compiled call node returning call206 (depth = 6)
// compiled member node returning call206 (depth = 5)
  int op_slot_left_202 = gc_frame_newslot(call206);
  params[0] = strlit203;
  partcv[0] = 1;
  Object opresult207 = callmethod(call206, "!=", 1, partcv, params);
// compiled op node returning opresult207 (depth = 4)
  gc_frame_end(frame);
  return opresult207;
}
Object meth_parser__apply210(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe212 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  partcv[0] = 0;
  Object call214 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe213);
// compiled call node returning call214 (depth = 7)
// compiled member node returning call214 (depth = 6)
  gc_frame_newslot(call214);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call214;
  partcv[0] = 1;
  Object call215 = callmethod(*var_validFollowTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe212);
// compiled call node returning call215 (depth = 5)
  Object if211 = done;
  if (istrue(call215)) {
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if211 = undefined;
  } else {
  }
// compiled if node returning if211 (depth = 4)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe217 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe218 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_validToken (depth = 9)
  partcv[0] = 0;
  Object call220 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe219);
// compiled call node returning call220 (depth = 8)
// compiled member node returning call220 (depth = 7)
  gc_frame_newslot(call220);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call220;
  partcv[0] = 1;
  Object call221 = callmethod(*var_invalidTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe218);
// compiled call node returning call221 (depth = 6)
  partcv[0] = 0;
  Object call222 = callmethod(call221, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe217);
// compiled call node returning call222 (depth = 5)
  Object if216 = done;
  if (istrue(call222)) {
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if216 = undefined;
  } else {
  }
// compiled if node returning if216 (depth = 4)
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call224 = callmethod(*var_validToken, "next",
    1, partcv, params);
  gc_frame_end(callframe223);
// compiled call node returning call224 (depth = 6)
// compiled member node returning call224 (depth = 5)
  *var_validToken = call224;
  if (call224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextValidToken186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextValidToken");
  Object params[8];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextValidToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findNextValidToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe187 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit188 == NULL) {
    strlit188 = alloc_String("dot");
    gc_root(strlit188);
  }
// compiled string node returning strlit188 (depth = 4)
  gc_frame_newslot(strlit188);
// starting to compile string node (depth = 4)
  if (strlit189 == NULL) {
    strlit189 = alloc_String("comma");
    gc_root(strlit189);
  }
// compiled string node returning strlit189 (depth = 4)
  gc_frame_newslot(strlit189);
// starting to compile string node (depth = 4)
  if (strlit190 == NULL) {
    strlit190 = alloc_String("colon");
    gc_root(strlit190);
  }
// compiled string node returning strlit190 (depth = 4)
  gc_frame_newslot(strlit190);
// starting to compile string node (depth = 4)
  if (strlit191 == NULL) {
    strlit191 = alloc_String("rparen");
    gc_root(strlit191);
  }
// compiled string node returning strlit191 (depth = 4)
  gc_frame_newslot(strlit191);
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit192 == NULL) {
    strlit192 = alloc_String("rbrace");
    gc_root(strlit192);
  }
// compiled string node returning strlit192 (depth = 4)
  gc_frame_newslot(strlit192);
// starting to compile string node (depth = 4)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("rsquare");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 4)
  gc_frame_newslot(strlit193);
// starting to compile string node (depth = 4)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("arrow");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 4)
  gc_frame_newslot(strlit194);
// starting to compile string node (depth = 4)
  if (strlit195 == NULL) {
    strlit195 = alloc_String("bind");
    gc_root(strlit195);
  }
// compiled string node returning strlit195 (depth = 4)
  gc_frame_newslot(strlit195);
// call case 6: other member request
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe196 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call197 = callmethodflags(prelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe196);
// compiled call node returning call197 (depth = 5)
// compiled member node returning call197 (depth = 4)
  params[0] = strlit188;
  params[1] = strlit189;
  params[2] = strlit190;
  params[3] = strlit191;
  params[4] = strlit192;
  params[5] = strlit193;
  params[6] = strlit194;
  params[7] = strlit195;
  partcv[0] = 8;
  Object call198 = callmethod(call197, "with",
    1, partcv, params);
  gc_frame_end(callframe187);
// compiled call node returning call198 (depth = 3)
  *var_invalidTokens = call198;
  if (call198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe199 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block200 = alloc_Block(NULL, NULL, "parser", 104);
  gc_frame_newslot(block200);
// method "_apply"
  block_savedest(block200);
  Object closure201 = createclosure(2, "_apply");
  setclosureframe(closure201, stackframe);
  addtoclosure(closure201, var_validToken);
  addtoclosure(closure201, selfslot);
  struct UserObject *uo201 = (struct UserObject*)block200;
  uo201->data[0] = (Object)closure201;
  Method *meth_meth_parser__apply201 = addmethod2pos(block200, "_apply", &meth_parser__apply201, 0);
  int argcv_meth_parser__apply201[] = {0};
  meth_meth_parser__apply201->type = alloc_MethodType(1, argcv_meth_parser__apply201);
  meth_meth_parser__apply201->definitionModule = modulename;
  meth_meth_parser__apply201->definitionLine = 101;
// compiled block node returning block200 (depth = 3)
  gc_frame_newslot(block200);
// starting to compile block node (depth = 3)
  Object block209 = alloc_Block(NULL, NULL, "parser", 104);
  gc_frame_newslot(block209);
// method "_apply"
  block_savedest(block209);
  Object closure210 = createclosure(4, "_apply");
  setclosureframe(closure210, stackframe);
  addtoclosure(closure210, var_validToken);
  addtoclosure(closure210, var_validFollowTokens);
  addtoclosure(closure210, var_invalidTokens);
  addtoclosure(closure210, selfslot);
  struct UserObject *uo210 = (struct UserObject*)block209;
  uo210->data[0] = (Object)closure210;
  Method *meth_meth_parser__apply210 = addmethod2pos(block209, "_apply", &meth_parser__apply210, 0);
  int argcv_meth_parser__apply210[] = {0};
  meth_meth_parser__apply210->type = alloc_MethodType(1, argcv_meth_parser__apply210);
  meth_meth_parser__apply210->definitionModule = modulename;
  meth_meth_parser__apply210->definitionLine = 104;
// compiled block node returning block209 (depth = 3)
  gc_frame_newslot(block209);
// call case 5: prelude request
  params[0] = block200;
  params[1] = block209;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call227 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe199);
// compiled call node returning call227 (depth = 2)
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply239(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call243 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe242);
// compiled call node returning call243 (depth = 7)
// compiled member node returning call243 (depth = 6)
  int op_slot_right_241 = gc_frame_newslot(call243);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call246 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe245);
// compiled call node returning call246 (depth = 7)
// compiled member node returning call246 (depth = 6)
  int op_slot_left_241 = gc_frame_newslot(call246);
  params[0] = call243;
  partcv[0] = 1;
  Object opresult247 = callmethod(call246, "==", 1, partcv, params);
// compiled op node returning opresult247 (depth = 5)
  int op_slot_right_240 = gc_frame_newslot(opresult247);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit250 == NULL) {
    strlit250 = alloc_String("eof");
    gc_root(strlit250);
  }
// compiled string node returning strlit250 (depth = 6)
  int op_slot_right_249 = gc_frame_newslot(strlit250);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call253 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe252);
// compiled call node returning call253 (depth = 7)
// compiled member node returning call253 (depth = 6)
  int op_slot_left_249 = gc_frame_newslot(call253);
  params[0] = strlit250;
  partcv[0] = 1;
  Object opresult254 = callmethod(call253, "!=", 1, partcv, params);
// compiled op node returning opresult254 (depth = 5)
  int op_slot_left_240 = gc_frame_newslot(opresult254);
  params[0] = opresult247;
  partcv[0] = 1;
  Object opresult255 = callmethod(opresult254, "&&", 1, partcv, params);
// compiled op node returning opresult255 (depth = 4)
  gc_frame_end(frame);
  return opresult255;
}
Object meth_parser__apply258(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit261 == NULL) {
    strlit261 = alloc_String("lbrace");
    gc_root(strlit261);
  }
// compiled string node returning strlit261 (depth = 6)
  int op_slot_right_260 = gc_frame_newslot(strlit261);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe263 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call264 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe263);
// compiled call node returning call264 (depth = 7)
// compiled member node returning call264 (depth = 6)
  int op_slot_left_260 = gc_frame_newslot(call264);
  params[0] = strlit261;
  partcv[0] = 1;
  Object opresult265 = callmethod(call264, "==", 1, partcv, params);
// compiled op node returning opresult265 (depth = 5)
  Object if259 = done;
  if (istrue(opresult265)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num267 = alloc_Float64(1);
// compiled num node returning num267 (depth = 7)
  int op_slot_right_266 = gc_frame_newslot(num267);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_266 = gc_frame_newslot(*var_numOpening);
  params[0] = num267;
  partcv[0] = 1;
  Object sum269 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum269 (depth = 6)
  *var_numOpening = sum269;
  if (sum269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if259 = done;
  } else {
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit273 == NULL) {
    strlit273 = alloc_String("rbrace");
    gc_root(strlit273);
  }
// compiled string node returning strlit273 (depth = 7)
  int op_slot_right_272 = gc_frame_newslot(strlit273);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call276 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe275);
// compiled call node returning call276 (depth = 8)
// compiled member node returning call276 (depth = 7)
  int op_slot_left_272 = gc_frame_newslot(call276);
  params[0] = strlit273;
  partcv[0] = 1;
  Object opresult277 = callmethod(call276, "==", 1, partcv, params);
// compiled op node returning opresult277 (depth = 6)
  Object if271 = done;
  if (istrue(opresult277)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num279 = alloc_Float64(1);
// compiled num node returning num279 (depth = 8)
  int op_slot_right_278 = gc_frame_newslot(num279);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_278 = gc_frame_newslot(*var_numClosing);
  params[0] = num279;
  partcv[0] = 1;
  Object sum281 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum281 (depth = 7)
  *var_numClosing = sum281;
  if (sum281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if271 = done;
  } else {
  }
// compiled if node returning if271 (depth = 5)
    gc_frame_newslot(if271);
    if259 = if271;
  }
// compiled if node returning if259 (depth = 4)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call284 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe283);
// compiled call node returning call284 (depth = 6)
// compiled member node returning call284 (depth = 5)
  *var_n = call284;
  if (call284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply290(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call294 = callmethod(*var_token, "indent",
    1, partcv, params);
  gc_frame_end(callframe293);
// compiled call node returning call294 (depth = 7)
// compiled member node returning call294 (depth = 6)
  int op_slot_right_292 = gc_frame_newslot(call294);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe296 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call297 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe296);
// compiled call node returning call297 (depth = 7)
// compiled member node returning call297 (depth = 6)
  int op_slot_left_292 = gc_frame_newslot(call297);
  params[0] = call294;
  partcv[0] = 1;
  Object opresult298 = callmethod(call297, ">", 1, partcv, params);
// compiled op node returning opresult298 (depth = 5)
  int op_slot_right_291 = gc_frame_newslot(opresult298);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit301 == NULL) {
    strlit301 = alloc_String("eof");
    gc_root(strlit301);
  }
// compiled string node returning strlit301 (depth = 6)
  int op_slot_right_300 = gc_frame_newslot(strlit301);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call304 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe303);
// compiled call node returning call304 (depth = 7)
// compiled member node returning call304 (depth = 6)
  int op_slot_left_300 = gc_frame_newslot(call304);
  params[0] = strlit301;
  partcv[0] = 1;
  Object opresult305 = callmethod(call304, "!=", 1, partcv, params);
// compiled op node returning opresult305 (depth = 5)
  int op_slot_left_291 = gc_frame_newslot(opresult305);
  params[0] = opresult298;
  partcv[0] = 1;
  Object opresult306 = callmethod(opresult305, "&&", 1, partcv, params);
// compiled op node returning opresult306 (depth = 4)
  gc_frame_end(frame);
  return opresult306;
}
Object meth_parser__apply309(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit312 == NULL) {
    strlit312 = alloc_String("lbrace");
    gc_root(strlit312);
  }
// compiled string node returning strlit312 (depth = 6)
  int op_slot_right_311 = gc_frame_newslot(strlit312);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe314 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call315 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe314);
// compiled call node returning call315 (depth = 7)
// compiled member node returning call315 (depth = 6)
  int op_slot_left_311 = gc_frame_newslot(call315);
  params[0] = strlit312;
  partcv[0] = 1;
  Object opresult316 = callmethod(call315, "==", 1, partcv, params);
// compiled op node returning opresult316 (depth = 5)
  Object if310 = done;
  if (istrue(opresult316)) {
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num318 = alloc_Float64(1);
// compiled num node returning num318 (depth = 7)
  int op_slot_right_317 = gc_frame_newslot(num318);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_317 = gc_frame_newslot(*var_numOpening);
  params[0] = num318;
  partcv[0] = 1;
  Object sum320 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum320 (depth = 6)
  *var_numOpening = sum320;
  if (sum320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if310 = done;
  } else {
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit324 == NULL) {
    strlit324 = alloc_String("rbrace");
    gc_root(strlit324);
  }
// compiled string node returning strlit324 (depth = 7)
  int op_slot_right_323 = gc_frame_newslot(strlit324);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe326 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call327 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe326);
// compiled call node returning call327 (depth = 8)
// compiled member node returning call327 (depth = 7)
  int op_slot_left_323 = gc_frame_newslot(call327);
  params[0] = strlit324;
  partcv[0] = 1;
  Object opresult328 = callmethod(call327, "==", 1, partcv, params);
// compiled op node returning opresult328 (depth = 6)
  Object if322 = done;
  if (istrue(opresult328)) {
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num330 = alloc_Float64(1);
// compiled num node returning num330 (depth = 8)
  int op_slot_right_329 = gc_frame_newslot(num330);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_329 = gc_frame_newslot(*var_numClosing);
  params[0] = num330;
  partcv[0] = 1;
  Object sum332 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum332 (depth = 7)
  *var_numClosing = sum332;
  if (sum332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if322 = done;
  } else {
  }
// compiled if node returning if322 (depth = 5)
    gc_frame_newslot(if322);
    if310 = if322;
  }
// compiled if node returning if310 (depth = 4)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe334 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call335 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe334);
// compiled call node returning call335 (depth = 6)
// compiled member node returning call335 (depth = 5)
  *var_n = call335;
  if (call335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findClosingBrace228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findClosingBrace");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findClosingBrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for findClosingBrace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if229 = done;
struct StackFrameObject *iftmpstackframe229 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe229);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num230 = alloc_Float64(1);
// compiled num node returning num230 (depth = 4)
    gc_frame_newslot(num230);
    if229 = num230;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe229);
  gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num231 = alloc_Float64(0);
// compiled num node returning num231 (depth = 4)
    gc_frame_newslot(num231);
    if229 = num231;
  }
stackframe = iftmpstackframe229;
// compiled if node returning if229 (depth = 3)
  *var_numOpening = if229;
  if (if229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num232 = alloc_Float64(0);
// compiled num node returning num232 (depth = 3)
  *var_numClosing = num232;
  if (num232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject233 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj233 = alloc_userobj2(4,4, objclass233);
  gc_frame_newslot(obj233);
// OBJECT OUTER DEC outer
  adddatum2(obj233, self, 0);
  addmethodreal(obj233,"outer", &reader_parser_outer_234);
  Object oldself233 = self;
  struct StackFrameObject *oldstackframe233 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe233);
  gc_frame_newslot((Object)stackframe);
  self = obj233;
  Object *oldselfslot233 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter233 = (*(struct UserObject *)self).data[0], lowerouter233 = thisouter233;
  if (inheritingObject233) {
    struct UserObject *inho233 = (struct UserObject *)inheritingObject233;
    while (inho233->super != GraceDefaultObject) inho233 = (struct UserObject *)inho233->super;
    inho233->super = obj233;
    self = inheritingObject233;
    *selfslot = self;
    lowerouter233 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter233;
  }
if (objclass233 == NULL) {
  Method *reader235 = addmethodrealflags(obj233, "found",&reader_parser_found_235, 0);
  Method *writer235 = addmethodrealflags(obj233, "found:=",&writer_parser_found_235, 0);
  reader235->definitionModule = modulename;
  writer235->definitionModule = modulename;
  reader235->definitionLine = 129;
  writer235->definitionLine = 129;
}
obj233->flags |= OFLAG_MUTABLE;
adddatum2(obj233, alloc_Undefined(), 1);
if (objclass233 == NULL) {
  Method *reader236 = addmethodrealflags(obj233, "tok",&reader_parser_tok_236, 0);
  Method *writer236 = addmethodrealflags(obj233, "tok:=",&writer_parser_tok_236, 0);
  reader236->definitionModule = modulename;
  writer236->definitionModule = modulename;
  reader236->definitionLine = 130;
  writer236->definitionLine = 130;
}
obj233->flags |= OFLAG_MUTABLE;
adddatum2(obj233, alloc_Undefined(), 2);
  sourceObject = obj233;
  adddatum2(obj233, undefined, 1);
  sourceObject = obj233;
  adddatum2(obj233, undefined, 2);
  objclass233 = obj233->class;
  objclass233->definitionModule = modulename;
  objclass233->definitionLine = 128;
  (*(struct UserObject *)self).data[0] = lowerouter233;
  self = oldself233;
  selfslot = oldselfslot233;
  stackframe = oldstackframe233;
// compiled object node returning obj233 (depth = 3)
  *var_result = obj233;
  if (obj233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe237 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block238 = alloc_Block(NULL, NULL, "parser", 133);
  gc_frame_newslot(block238);
// method "_apply"
  block_savedest(block238);
  Object closure239 = createclosure(3, "_apply");
  setclosureframe(closure239, stackframe);
  addtoclosure(closure239, var_token);
  addtoclosure(closure239, var_n);
  addtoclosure(closure239, selfslot);
  struct UserObject *uo239 = (struct UserObject*)block238;
  uo239->data[0] = (Object)closure239;
  Method *meth_meth_parser__apply239 = addmethod2pos(block238, "_apply", &meth_parser__apply239, 0);
  int argcv_meth_parser__apply239[] = {0};
  meth_meth_parser__apply239->type = alloc_MethodType(1, argcv_meth_parser__apply239);
  meth_meth_parser__apply239->definitionModule = modulename;
  meth_meth_parser__apply239->definitionLine = 114;
// compiled block node returning block238 (depth = 3)
  gc_frame_newslot(block238);
// starting to compile block node (depth = 3)
  Object block257 = alloc_Block(NULL, NULL, "parser", 133);
  gc_frame_newslot(block257);
// method "_apply"
  block_savedest(block257);
  Object closure258 = createclosure(4, "_apply");
  setclosureframe(closure258, stackframe);
  addtoclosure(closure258, var_n);
  addtoclosure(closure258, var_numOpening);
  addtoclosure(closure258, var_numClosing);
  addtoclosure(closure258, selfslot);
  struct UserObject *uo258 = (struct UserObject*)block257;
  uo258->data[0] = (Object)closure258;
  Method *meth_meth_parser__apply258 = addmethod2pos(block257, "_apply", &meth_parser__apply258, 0);
  int argcv_meth_parser__apply258[] = {0};
  meth_meth_parser__apply258->type = alloc_MethodType(1, argcv_meth_parser__apply258);
  meth_meth_parser__apply258->definitionModule = modulename;
  meth_meth_parser__apply258->definitionLine = 133;
// compiled block node returning block257 (depth = 3)
  gc_frame_newslot(block257);
// call case 5: prelude request
  params[0] = block238;
  params[1] = block257;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call287 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe237);
// compiled call node returning call287 (depth = 2)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe288 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block289 = alloc_Block(NULL, NULL, "parser", 139);
  gc_frame_newslot(block289);
// method "_apply"
  block_savedest(block289);
  Object closure290 = createclosure(3, "_apply");
  setclosureframe(closure290, stackframe);
  addtoclosure(closure290, var_token);
  addtoclosure(closure290, var_n);
  addtoclosure(closure290, selfslot);
  struct UserObject *uo290 = (struct UserObject*)block289;
  uo290->data[0] = (Object)closure290;
  Method *meth_meth_parser__apply290 = addmethod2pos(block289, "_apply", &meth_parser__apply290, 0);
  int argcv_meth_parser__apply290[] = {0};
  meth_meth_parser__apply290->type = alloc_MethodType(1, argcv_meth_parser__apply290);
  meth_meth_parser__apply290->definitionModule = modulename;
  meth_meth_parser__apply290->definitionLine = 136;
// compiled block node returning block289 (depth = 3)
  gc_frame_newslot(block289);
// starting to compile block node (depth = 3)
  Object block308 = alloc_Block(NULL, NULL, "parser", 139);
  gc_frame_newslot(block308);
// method "_apply"
  block_savedest(block308);
  Object closure309 = createclosure(4, "_apply");
  setclosureframe(closure309, stackframe);
  addtoclosure(closure309, var_n);
  addtoclosure(closure309, var_numOpening);
  addtoclosure(closure309, var_numClosing);
  addtoclosure(closure309, selfslot);
  struct UserObject *uo309 = (struct UserObject*)block308;
  uo309->data[0] = (Object)closure309;
  Method *meth_meth_parser__apply309 = addmethod2pos(block308, "_apply", &meth_parser__apply309, 0);
  int argcv_meth_parser__apply309[] = {0};
  meth_meth_parser__apply309->type = alloc_MethodType(1, argcv_meth_parser__apply309);
  meth_meth_parser__apply309->definitionModule = modulename;
  meth_meth_parser__apply309->definitionLine = 139;
// compiled block node returning block308 (depth = 3)
  gc_frame_newslot(block308);
// call case 5: prelude request
  params[0] = block289;
  params[1] = block308;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call338 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe288);
// compiled call node returning call338 (depth = 2)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit341 == NULL) {
    strlit341 = alloc_String("rbrace");
    gc_root(strlit341);
  }
// compiled string node returning strlit341 (depth = 4)
  int op_slot_right_340 = gc_frame_newslot(strlit341);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call344 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe343);
// compiled call node returning call344 (depth = 5)
// compiled member node returning call344 (depth = 4)
  int op_slot_left_340 = gc_frame_newslot(call344);
  params[0] = strlit341;
  partcv[0] = 1;
  Object opresult345 = callmethod(call344, "==", 1, partcv, params);
// compiled op node returning opresult345 (depth = 3)
  Object if339 = done;
  if (istrue(opresult345)) {
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe346 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool347 = alloc_Boolean(1);
// compiled identifier node returning bool347 (depth = 4)
  gc_frame_newslot(bool347);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = bool347;
  partcv[0] = 1;
  Object call348 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe346);
// compiled call node returning call348 (depth = 3)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe349 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call350 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe349);
// compiled call node returning call350 (depth = 3)
    gc_frame_newslot(call350);
    if339 = call350;
  } else {
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_353 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_353 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult355 = callmethod(*var_numOpening, "==", 1, partcv, params);
// compiled op node returning opresult355 (depth = 5)
  int op_slot_right_352 = gc_frame_newslot(opresult355);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit358 == NULL) {
    strlit358 = alloc_String("rbrace");
    gc_root(strlit358);
  }
// compiled string node returning strlit358 (depth = 6)
  int op_slot_right_357 = gc_frame_newslot(strlit358);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe360 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe361 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call362 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe361);
// compiled call node returning call362 (depth = 9)
// compiled member node returning call362 (depth = 8)
  partcv[0] = 0;
  Object call363 = callmethod(call362, "kind",
    1, partcv, params);
  gc_frame_end(callframe360);
// compiled call node returning call363 (depth = 7)
// compiled member node returning call363 (depth = 6)
  int op_slot_left_357 = gc_frame_newslot(call363);
  params[0] = strlit358;
  partcv[0] = 1;
  Object opresult364 = callmethod(call363, "==", 1, partcv, params);
// compiled op node returning opresult364 (depth = 5)
  int op_slot_left_352 = gc_frame_newslot(opresult364);
  params[0] = opresult355;
  partcv[0] = 1;
  Object opresult365 = callmethod(opresult364, "&&", 1, partcv, params);
// compiled op node returning opresult365 (depth = 4)
  Object if351 = done;
  if (istrue(opresult365)) {
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe366 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool367 = alloc_Boolean(1);
// compiled identifier node returning bool367 (depth = 5)
  gc_frame_newslot(bool367);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool367;
  partcv[0] = 1;
  Object call368 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe366);
// compiled call node returning call368 (depth = 4)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe369 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call371 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe370);
// compiled call node returning call371 (depth = 6)
// compiled member node returning call371 (depth = 5)
  gc_frame_newslot(call371);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call371;
  partcv[0] = 1;
  Object call372 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call372 (depth = 4)
    gc_frame_newslot(call372);
    if351 = call372;
  } else {
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe373 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool374 = alloc_Boolean(0);
// compiled identifier node returning bool374 (depth = 5)
  gc_frame_newslot(bool374);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool374;
  partcv[0] = 1;
  Object call375 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe373);
// compiled call node returning call375 (depth = 4)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe376 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe377 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call378 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe377);
// compiled call node returning call378 (depth = 6)
// compiled member node returning call378 (depth = 5)
  gc_frame_newslot(call378);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call378;
  partcv[0] = 1;
  Object call379 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe376);
// compiled call node returning call379 (depth = 4)
    gc_frame_newslot(call379);
    if351 = call379;
  }
// compiled if node returning if351 (depth = 3)
    gc_frame_newslot(if351);
    if339 = if351;
  }
// compiled if node returning if339 (depth = 2)
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_accept380(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_381 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call384 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 4)
// compiled member node returning call384 (depth = 3)
  int op_slot_left_381 = gc_frame_newslot(call384);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult385 = callmethod(call384, "==", 1, partcv, params);
// compiled op node returning opresult385 (depth = 2)
  gc_frame_end(frame);
  return opresult385;
}
Object meth_parser_acceptKeyword386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptKeyword");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptKeyword (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_kw = &(stackframe->slots[0]);
  *var_kw = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptKeyword");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit389 == NULL) {
    strlit389 = alloc_String("keyword");
    gc_root(strlit389);
  }
// compiled string node returning strlit389 (depth = 4)
  int op_slot_right_388 = gc_frame_newslot(strlit389);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call392 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe391);
// compiled call node returning call392 (depth = 5)
// compiled member node returning call392 (depth = 4)
  int op_slot_left_388 = gc_frame_newslot(call392);
  params[0] = strlit389;
  partcv[0] = 1;
  Object opresult393 = callmethod(call392, "!=", 1, partcv, params);
// compiled op node returning opresult393 (depth = 3)
  Object if387 = done;
  if (istrue(opresult393)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool394 = alloc_Boolean(0);
// compiled identifier node returning bool394 (depth = 4)
  return bool394;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if387 = undefined;
  } else {
  }
// compiled if node returning if387 (depth = 2)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw (depth = 4)
  int op_slot_right_395 = gc_frame_newslot(*var_kw);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe397 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call398 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe397);
// compiled call node returning call398 (depth = 5)
// compiled member node returning call398 (depth = 4)
  int op_slot_left_395 = gc_frame_newslot(call398);
  params[0] = *var_kw;
  partcv[0] = 1;
  Object opresult399 = callmethod(call398, "==", 1, partcv, params);
// compiled op node returning opresult399 (depth = 3)
  return opresult399;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_acceptSameLine400(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptSameLine");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptSameLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_403 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call406 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe405);
// compiled call node returning call406 (depth = 6)
// compiled member node returning call406 (depth = 5)
  int op_slot_left_403 = gc_frame_newslot(call406);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult407 = callmethod(call406, ">", 1, partcv, params);
// compiled op node returning opresult407 (depth = 4)
  int op_slot_right_402 = gc_frame_newslot(opresult407);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe410 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call411 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe410);
// compiled call node returning call411 (depth = 6)
// compiled member node returning call411 (depth = 5)
  int op_slot_right_409 = gc_frame_newslot(call411);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_409 = gc_frame_newslot(*var_lastLine);
  params[0] = call411;
  partcv[0] = 1;
  Object opresult413 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult413 (depth = 4)
  int op_slot_left_402 = gc_frame_newslot(opresult413);
  params[0] = opresult407;
  partcv[0] = 1;
  Object opresult414 = callmethod(opresult413, "||", 1, partcv, params);
// compiled op node returning opresult414 (depth = 3)
  int op_slot_right_401 = gc_frame_newslot(opresult414);
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_416 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call419 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe418);
// compiled call node returning call419 (depth = 5)
// compiled member node returning call419 (depth = 4)
  int op_slot_left_416 = gc_frame_newslot(call419);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult420 = callmethod(call419, "==", 1, partcv, params);
// compiled op node returning opresult420 (depth = 3)
  int op_slot_left_401 = gc_frame_newslot(opresult420);
  params[0] = opresult414;
  partcv[0] = 1;
  Object opresult421 = callmethod(opresult420, "&&", 1, partcv, params);
// compiled op node returning opresult421 (depth = 2)
  gc_frame_end(frame);
  return opresult421;
}
Object meth_parser_acceptWithoutSpaces422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptWithoutSpaces");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptWithoutSpaces");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptWithoutSpaces (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptWithoutSpaces");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call427 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe426);
// compiled call node returning call427 (depth = 6)
// compiled member node returning call427 (depth = 5)
  int op_slot_right_425 = gc_frame_newslot(call427);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call430 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe429);
// compiled call node returning call430 (depth = 6)
// compiled member node returning call430 (depth = 5)
  int op_slot_left_425 = gc_frame_newslot(call430);
  params[0] = call427;
  partcv[0] = 1;
  Object sum431 = callmethod(call430, "+", 1, partcv, params);
// compiled op node returning sum431 (depth = 4)
  int op_slot_right_424 = gc_frame_newslot(sum431);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call434 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe433);
// compiled call node returning call434 (depth = 5)
// compiled member node returning call434 (depth = 4)
  int op_slot_left_424 = gc_frame_newslot(call434);
  params[0] = sum431;
  partcv[0] = 1;
  Object opresult435 = callmethod(call434, "==", 1, partcv, params);
// compiled op node returning opresult435 (depth = 3)
  int op_slot_right_423 = gc_frame_newslot(opresult435);
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call440 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe439);
// compiled call node returning call440 (depth = 6)
// compiled member node returning call440 (depth = 5)
  int op_slot_right_438 = gc_frame_newslot(call440);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_438 = gc_frame_newslot(*var_lastLine);
  params[0] = call440;
  partcv[0] = 1;
  Object opresult442 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult442 (depth = 4)
  int op_slot_right_437 = gc_frame_newslot(opresult442);
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  int op_slot_right_444 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call447 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe446);
// compiled call node returning call447 (depth = 6)
// compiled member node returning call447 (depth = 5)
  int op_slot_left_444 = gc_frame_newslot(call447);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult448 = callmethod(call447, "==", 1, partcv, params);
// compiled op node returning opresult448 (depth = 4)
  int op_slot_left_437 = gc_frame_newslot(opresult448);
  params[0] = opresult442;
  partcv[0] = 1;
  Object opresult449 = callmethod(opresult448, "&&", 1, partcv, params);
// compiled op node returning opresult449 (depth = 3)
  int op_slot_left_423 = gc_frame_newslot(opresult449);
  params[0] = opresult435;
  partcv[0] = 1;
  Object opresult450 = callmethod(opresult449, "&&", 1, partcv, params);
// compiled op node returning opresult450 (depth = 2)
  gc_frame_end(frame);
  return opresult450;
}
Object meth_parser_acceptAfterSpaces451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptAfterSpaces");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptAfterSpaces (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptAfterSpaces");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_453 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call456 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe455);
// compiled call node returning call456 (depth = 5)
// compiled member node returning call456 (depth = 4)
  int op_slot_left_453 = gc_frame_newslot(call456);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult457 = callmethod(call456, "!=", 1, partcv, params);
// compiled op node returning opresult457 (depth = 3)
  Object if452 = done;
  if (istrue(opresult457)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool458 = alloc_Boolean(0);
// compiled identifier node returning bool458 (depth = 4)
  return bool458;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if452 = undefined;
  } else {
  }
// compiled if node returning if452 (depth = 2)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call462 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe461);
// compiled call node returning call462 (depth = 5)
// compiled member node returning call462 (depth = 4)
  int op_slot_right_460 = gc_frame_newslot(call462);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_460 = gc_frame_newslot(*var_lastLine);
  params[0] = call462;
  partcv[0] = 1;
  Object opresult464 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult464 (depth = 3)
  Object if459 = done;
  if (istrue(opresult464)) {
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call468 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe467);
// compiled call node returning call468 (depth = 7)
// compiled member node returning call468 (depth = 6)
  int op_slot_right_466 = gc_frame_newslot(call468);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call471 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe470);
// compiled call node returning call471 (depth = 7)
// compiled member node returning call471 (depth = 6)
  int op_slot_left_466 = gc_frame_newslot(call471);
  params[0] = call468;
  partcv[0] = 1;
  Object sum472 = callmethod(call471, "+", 1, partcv, params);
// compiled op node returning sum472 (depth = 5)
  int op_slot_right_465 = gc_frame_newslot(sum472);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call475 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe474);
// compiled call node returning call475 (depth = 6)
// compiled member node returning call475 (depth = 5)
  int op_slot_left_465 = gc_frame_newslot(call475);
  params[0] = sum472;
  partcv[0] = 1;
  Object opresult476 = callmethod(call475, "!=", 1, partcv, params);
// compiled op node returning opresult476 (depth = 4)
  return opresult476;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if459 = undefined;
  } else {
  }
// compiled if node returning if459 (depth = 2)
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num479 = alloc_Float64(1);
// compiled num node returning num479 (depth = 5)
  int op_slot_right_478 = gc_frame_newslot(num479);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call482 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe481);
// compiled call node returning call482 (depth = 6)
// compiled member node returning call482 (depth = 5)
  int op_slot_left_478 = gc_frame_newslot(call482);
  params[0] = num479;
  partcv[0] = 1;
  Object sum483 = callmethod(call482, "+", 1, partcv, params);
// compiled op node returning sum483 (depth = 4)
  int op_slot_right_477 = gc_frame_newslot(sum483);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call486 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe485);
// compiled call node returning call486 (depth = 5)
// compiled member node returning call486 (depth = 4)
  int op_slot_left_477 = gc_frame_newslot(call486);
  params[0] = sum483;
  partcv[0] = 1;
  Object opresult487 = callmethod(call486, "==", 1, partcv, params);
// compiled op node returning opresult487 (depth = 3)
  return opresult487;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_accept_40__41_onLineOf488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOf");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe492 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call493 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe492);
// compiled call node returning call493 (depth = 6)
// compiled member node returning call493 (depth = 5)
  int op_slot_right_491 = gc_frame_newslot(call493);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call496 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe495);
// compiled call node returning call496 (depth = 6)
// compiled member node returning call496 (depth = 5)
  int op_slot_left_491 = gc_frame_newslot(call496);
  params[0] = call493;
  partcv[0] = 1;
  Object opresult497 = callmethod(call496, ">", 1, partcv, params);
// compiled op node returning opresult497 (depth = 4)
  int op_slot_right_490 = gc_frame_newslot(opresult497);
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call501 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe500);
// compiled call node returning call501 (depth = 6)
// compiled member node returning call501 (depth = 5)
  int op_slot_right_499 = gc_frame_newslot(call501);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe503 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call504 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe503);
// compiled call node returning call504 (depth = 6)
// compiled member node returning call504 (depth = 5)
  int op_slot_left_499 = gc_frame_newslot(call504);
  params[0] = call501;
  partcv[0] = 1;
  Object opresult505 = callmethod(call504, "==", 1, partcv, params);
// compiled op node returning opresult505 (depth = 4)
  int op_slot_left_490 = gc_frame_newslot(opresult505);
  params[0] = opresult497;
  partcv[0] = 1;
  Object opresult506 = callmethod(opresult505, "||", 1, partcv, params);
// compiled op node returning opresult506 (depth = 3)
  int op_slot_right_489 = gc_frame_newslot(opresult506);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_508 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call511 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe510);
// compiled call node returning call511 (depth = 5)
// compiled member node returning call511 (depth = 4)
  int op_slot_left_508 = gc_frame_newslot(call511);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult512 = callmethod(call511, "==", 1, partcv, params);
// compiled op node returning opresult512 (depth = 3)
  int op_slot_left_489 = gc_frame_newslot(opresult512);
  params[0] = opresult506;
  partcv[0] = 1;
  Object opresult513 = callmethod(opresult512, "&&", 1, partcv, params);
// compiled op node returning opresult513 (depth = 2)
  gc_frame_end(frame);
  return opresult513;
}
Object meth_parser_acceptAfterSpaces_40__41_onLineOf514(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptAfterSpaces()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces()onLineOf");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for acceptAfterSpaces()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptAfterSpaces");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_516 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call519 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe518);
// compiled call node returning call519 (depth = 5)
// compiled member node returning call519 (depth = 4)
  int op_slot_left_516 = gc_frame_newslot(call519);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult520 = callmethod(call519, "!=", 1, partcv, params);
// compiled op node returning opresult520 (depth = 3)
  Object if515 = done;
  if (istrue(opresult520)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool521 = alloc_Boolean(0);
// compiled identifier node returning bool521 (depth = 4)
  return bool521;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if515 = undefined;
  } else {
  }
// compiled if node returning if515 (depth = 2)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call525 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe524);
// compiled call node returning call525 (depth = 5)
// compiled member node returning call525 (depth = 4)
  int op_slot_right_523 = gc_frame_newslot(call525);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call528 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe527);
// compiled call node returning call528 (depth = 5)
// compiled member node returning call528 (depth = 4)
  int op_slot_left_523 = gc_frame_newslot(call528);
  params[0] = call525;
  partcv[0] = 1;
  Object opresult529 = callmethod(call528, "==", 1, partcv, params);
// compiled op node returning opresult529 (depth = 3)
  Object if522 = done;
  if (istrue(opresult529)) {
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call533 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe532);
// compiled call node returning call533 (depth = 7)
// compiled member node returning call533 (depth = 6)
  int op_slot_right_531 = gc_frame_newslot(call533);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call536 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe535);
// compiled call node returning call536 (depth = 7)
// compiled member node returning call536 (depth = 6)
  int op_slot_left_531 = gc_frame_newslot(call536);
  params[0] = call533;
  partcv[0] = 1;
  Object sum537 = callmethod(call536, "+", 1, partcv, params);
// compiled op node returning sum537 (depth = 5)
  int op_slot_right_530 = gc_frame_newslot(sum537);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call540 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe539);
// compiled call node returning call540 (depth = 6)
// compiled member node returning call540 (depth = 5)
  int op_slot_left_530 = gc_frame_newslot(call540);
  params[0] = sum537;
  partcv[0] = 1;
  Object opresult541 = callmethod(call540, "!=", 1, partcv, params);
// compiled op node returning opresult541 (depth = 4)
  return opresult541;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if522 = undefined;
  } else {
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num544 = alloc_Float64(1);
// compiled num node returning num544 (depth = 6)
  int op_slot_right_543 = gc_frame_newslot(num544);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe546 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call547 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe546);
// compiled call node returning call547 (depth = 7)
// compiled member node returning call547 (depth = 6)
  int op_slot_left_543 = gc_frame_newslot(call547);
  params[0] = num544;
  partcv[0] = 1;
  Object sum548 = callmethod(call547, "+", 1, partcv, params);
// compiled op node returning sum548 (depth = 5)
  int op_slot_right_542 = gc_frame_newslot(sum548);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call551 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe550);
// compiled call node returning call551 (depth = 6)
// compiled member node returning call551 (depth = 5)
  int op_slot_left_542 = gc_frame_newslot(call551);
  params[0] = sum548;
  partcv[0] = 1;
  Object opresult552 = callmethod(call551, "==", 1, partcv, params);
// compiled op node returning opresult552 (depth = 4)
  return opresult552;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if522 = undefined;
  }
// compiled if node returning if522 (depth = 2)
  gc_frame_end(frame);
  return if522;
}
Object meth_parser_accept_40__41_onLineOfLastOr553(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOfLastOr");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOfLastOr");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOfLastOr");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()onLineOfLastOr (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOfLastOr");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call558 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe557);
// compiled call node returning call558 (depth = 6)
// compiled member node returning call558 (depth = 5)
  int op_slot_right_556 = gc_frame_newslot(call558);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe560 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call561 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe560);
// compiled call node returning call561 (depth = 6)
// compiled member node returning call561 (depth = 5)
  int op_slot_left_556 = gc_frame_newslot(call561);
  params[0] = call558;
  partcv[0] = 1;
  Object opresult562 = callmethod(call561, "==", 1, partcv, params);
// compiled op node returning opresult562 (depth = 4)
  int op_slot_right_555 = gc_frame_newslot(opresult562);
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe566 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call567 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe566);
// compiled call node returning call567 (depth = 7)
// compiled member node returning call567 (depth = 6)
  int op_slot_right_565 = gc_frame_newslot(call567);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call570 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe569);
// compiled call node returning call570 (depth = 7)
// compiled member node returning call570 (depth = 6)
  int op_slot_left_565 = gc_frame_newslot(call570);
  params[0] = call567;
  partcv[0] = 1;
  Object opresult571 = callmethod(call570, ">", 1, partcv, params);
// compiled op node returning opresult571 (depth = 5)
  int op_slot_right_564 = gc_frame_newslot(opresult571);
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call575 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe574);
// compiled call node returning call575 (depth = 7)
// compiled member node returning call575 (depth = 6)
  int op_slot_right_573 = gc_frame_newslot(call575);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe577 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call578 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe577);
// compiled call node returning call578 (depth = 7)
// compiled member node returning call578 (depth = 6)
  int op_slot_left_573 = gc_frame_newslot(call578);
  params[0] = call575;
  partcv[0] = 1;
  Object opresult579 = callmethod(call578, "==", 1, partcv, params);
// compiled op node returning opresult579 (depth = 5)
  int op_slot_left_564 = gc_frame_newslot(opresult579);
  params[0] = opresult571;
  partcv[0] = 1;
  Object opresult580 = callmethod(opresult579, "||", 1, partcv, params);
// compiled op node returning opresult580 (depth = 4)
  int op_slot_left_555 = gc_frame_newslot(opresult580);
  params[0] = opresult562;
  partcv[0] = 1;
  Object opresult581 = callmethod(opresult580, "||", 1, partcv, params);
// compiled op node returning opresult581 (depth = 3)
  int op_slot_right_554 = gc_frame_newslot(opresult581);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_583 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe585 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call586 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe585);
// compiled call node returning call586 (depth = 5)
// compiled member node returning call586 (depth = 4)
  int op_slot_left_583 = gc_frame_newslot(call586);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult587 = callmethod(call586, "==", 1, partcv, params);
// compiled op node returning opresult587 (depth = 3)
  int op_slot_left_554 = gc_frame_newslot(opresult587);
  params[0] = opresult581;
  partcv[0] = 1;
  Object opresult588 = callmethod(opresult587, "&&", 1, partcv, params);
// compiled op node returning opresult588 (depth = 2)
  gc_frame_end(frame);
  return opresult588;
}
Object meth_parser_acceptArgumentOnLineOf589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptArgumentOnLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptArgumentOnLineOf");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptArgumentOnLineOf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptArgumentOnLineOf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe591 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit592 == NULL) {
    strlit592 = alloc_String("string");
    gc_root(strlit592);
  }
// compiled string node returning strlit592 (depth = 4)
  gc_frame_newslot(strlit592);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit592;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call593 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe591);
// compiled call node returning call593 (depth = 3)
  Object if590 = done;
  if (istrue(call593)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool594 = alloc_Boolean(1);
// compiled identifier node returning bool594 (depth = 4)
  return bool594;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if590 = undefined;
  } else {
  }
// compiled if node returning if590 (depth = 2)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe596 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit597 == NULL) {
    strlit597 = alloc_String("num");
    gc_root(strlit597);
  }
// compiled string node returning strlit597 (depth = 4)
  gc_frame_newslot(strlit597);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit597;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call598 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe596);
// compiled call node returning call598 (depth = 3)
  Object if595 = done;
  if (istrue(call598)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool599 = alloc_Boolean(1);
// compiled identifier node returning bool599 (depth = 4)
  return bool599;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if595 = undefined;
  } else {
  }
// compiled if node returning if595 (depth = 2)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe601 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit602 == NULL) {
    strlit602 = alloc_String("lbrace");
    gc_root(strlit602);
  }
// compiled string node returning strlit602 (depth = 4)
  gc_frame_newslot(strlit602);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit602;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call603 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe601);
// compiled call node returning call603 (depth = 3)
  Object if600 = done;
  if (istrue(call603)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool604 = alloc_Boolean(1);
// compiled identifier node returning bool604 (depth = 4)
  return bool604;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if600 = undefined;
  } else {
  }
// compiled if node returning if600 (depth = 2)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe606 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit607 == NULL) {
    strlit607 = alloc_String("lsquare");
    gc_root(strlit607);
  }
// compiled string node returning strlit607 (depth = 4)
  gc_frame_newslot(strlit607);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit607;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call608 = callmethodflags(self, "acceptAfterSpaces()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe606);
// compiled call node returning call608 (depth = 3)
  Object if605 = done;
  if (istrue(call608)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool609 = alloc_Boolean(1);
// compiled identifier node returning bool609 (depth = 4)
  return bool609;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if605 = undefined;
  } else {
  }
// compiled if node returning if605 (depth = 2)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe611 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit612 == NULL) {
    strlit612 = alloc_String("identifier");
    gc_root(strlit612);
  }
// compiled string node returning strlit612 (depth = 4)
  gc_frame_newslot(strlit612);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit612;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call613 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe611);
// compiled call node returning call613 (depth = 3)
  Object if610 = done;
  if (istrue(call613)) {
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit616 == NULL) {
    strlit616 = alloc_String("false");
    gc_root(strlit616);
  }
// compiled string node returning strlit616 (depth = 6)
  int op_slot_right_615 = gc_frame_newslot(strlit616);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe618 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call619 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe618);
// compiled call node returning call619 (depth = 7)
// compiled member node returning call619 (depth = 6)
  int op_slot_left_615 = gc_frame_newslot(call619);
  params[0] = strlit616;
  partcv[0] = 1;
  Object opresult620 = callmethod(call619, "==", 1, partcv, params);
// compiled op node returning opresult620 (depth = 5)
  int op_slot_right_614 = gc_frame_newslot(opresult620);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit623 == NULL) {
    strlit623 = alloc_String("true");
    gc_root(strlit623);
  }
// compiled string node returning strlit623 (depth = 6)
  int op_slot_right_622 = gc_frame_newslot(strlit623);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe625 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call626 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe625);
// compiled call node returning call626 (depth = 7)
// compiled member node returning call626 (depth = 6)
  int op_slot_left_622 = gc_frame_newslot(call626);
  params[0] = strlit623;
  partcv[0] = 1;
  Object opresult627 = callmethod(call626, "==", 1, partcv, params);
// compiled op node returning opresult627 (depth = 5)
  int op_slot_left_614 = gc_frame_newslot(opresult627);
  params[0] = opresult620;
  partcv[0] = 1;
  Object opresult628 = callmethod(opresult627, "||", 1, partcv, params);
// compiled op node returning opresult628 (depth = 4)
  return opresult628;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if610 = undefined;
  } else {
  }
// compiled if node returning if610 (depth = 2)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool629 = alloc_Boolean(0);
// compiled identifier node returning bool629 (depth = 3)
  return bool629;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_tokenOnSameLine630(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokenOnSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for tokenOnSameLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_632 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call635 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe634);
// compiled call node returning call635 (depth = 5)
// compiled member node returning call635 (depth = 4)
  int op_slot_left_632 = gc_frame_newslot(call635);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult636 = callmethod(call635, ">", 1, partcv, params);
// compiled op node returning opresult636 (depth = 3)
  int op_slot_right_631 = gc_frame_newslot(opresult636);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe639 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call640 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe639);
// compiled call node returning call640 (depth = 5)
// compiled member node returning call640 (depth = 4)
  int op_slot_right_638 = gc_frame_newslot(call640);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_638 = gc_frame_newslot(*var_lastLine);
  params[0] = call640;
  partcv[0] = 1;
  Object opresult642 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult642 (depth = 3)
  int op_slot_left_631 = gc_frame_newslot(opresult642);
  params[0] = opresult636;
  partcv[0] = 1;
  Object opresult643 = callmethod(opresult642, "||", 1, partcv, params);
// compiled op node returning opresult643 (depth = 2)
  gc_frame_end(frame);
  return opresult643;
}
Object meth_parser_didConsume644(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didConsume");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didConsume (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for didConsume");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe645 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call646 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe645);
// compiled call node returning call646 (depth = 4)
// compiled member node returning call646 (depth = 3)
  *var_sz = call646;
  if (call646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aParsingBlock (depth = 4)
  partcv[0] = 0;
  Object call648 = callmethod(*var_aParsingBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe647);
// compiled call node returning call648 (depth = 3)
// compiled member node returning call648 (depth = 2)
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_649 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call652 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe651);
// compiled call node returning call652 (depth = 4)
// compiled member node returning call652 (depth = 3)
  int op_slot_left_649 = gc_frame_newslot(call652);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult653 = callmethod(call652, "!=", 1, partcv, params);
// compiled op node returning opresult653 (depth = 2)
  gc_frame_end(frame);
  return opresult653;
}
Object meth_parser_ifConsume_40__41_then654(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifConsume()then");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ifConsume()then");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ifConsume()then");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for ifConsume()then (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifConsume");
  Object *var_tblock = &(stackframe->slots[1]);
  *var_tblock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for then");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sz");
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe655 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call656 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe655);
// compiled call node returning call656 (depth = 4)
// compiled member node returning call656 (depth = 3)
  *var_sz = call656;
  if (call656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe657 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ablock (depth = 4)
  partcv[0] = 0;
  Object call658 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe657);
// compiled call node returning call658 (depth = 3)
// compiled member node returning call658 (depth = 2)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_660 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call663 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 5)
// compiled member node returning call663 (depth = 4)
  int op_slot_left_660 = gc_frame_newslot(call663);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult664 = callmethod(call663, "!=", 1, partcv, params);
// compiled op node returning opresult664 (depth = 3)
  Object if659 = done;
  if (istrue(opresult664)) {
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tblock (depth = 5)
  partcv[0] = 0;
  Object call666 = callmethod(*var_tblock, "apply",
    1, partcv, params);
  gc_frame_end(callframe665);
// compiled call node returning call666 (depth = 4)
// compiled member node returning call666 (depth = 3)
    gc_frame_newslot(call666);
    if659 = call666;
  } else {
  }
// compiled if node returning if659 (depth = 2)
  gc_frame_end(frame);
  return if659;
}
Object meth_parser_pushnum667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushnum (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushnum");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe668 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call670 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe669);
// compiled call node returning call670 (depth = 5)
// compiled member node returning call670 (depth = 4)
  gc_frame_newslot(call670);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call672 = callmethod(*var_ast, "numNode",
    1, partcv, params);
  gc_frame_end(callframe671);
// compiled call node returning call672 (depth = 5)
// compiled member node returning call672 (depth = 4)
  params[0] = call670;
  partcv[0] = 1;
  Object call673 = callmethod(call672, "new",
    1, partcv, params);
  gc_frame_end(callframe668);
// compiled call node returning call673 (depth = 3)
  *var_o = call673;
  if (call673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe674 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call675 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe674);
// compiled call node returning call675 (depth = 2)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe676 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call677 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe676);
// compiled call node returning call677 (depth = 3)
// compiled member node returning call677 (depth = 2)
  gc_frame_end(frame);
  return call677;
}
Object meth_parser_pushoctets678(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushoctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushoctets (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushoctets");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe679 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call681 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe680);
// compiled call node returning call681 (depth = 5)
// compiled member node returning call681 (depth = 4)
  gc_frame_newslot(call681);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call683 = callmethod(*var_ast, "octetsNode",
    1, partcv, params);
  gc_frame_end(callframe682);
// compiled call node returning call683 (depth = 5)
// compiled member node returning call683 (depth = 4)
  params[0] = call681;
  partcv[0] = 1;
  Object call684 = callmethod(call683, "new",
    1, partcv, params);
  gc_frame_end(callframe679);
// compiled call node returning call684 (depth = 3)
  *var_o = call684;
  if (call684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe685 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call686 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe685);
// compiled call node returning call686 (depth = 2)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe687 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call688 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe687);
// compiled call node returning call688 (depth = 3)
// compiled member node returning call688 (depth = 2)
  gc_frame_end(frame);
  return call688;
}
Object meth_parser_pushstring689(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushstring (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushstring");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe690 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call692 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe691);
// compiled call node returning call692 (depth = 5)
// compiled member node returning call692 (depth = 4)
  gc_frame_newslot(call692);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call694 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe693);
// compiled call node returning call694 (depth = 5)
// compiled member node returning call694 (depth = 4)
  params[0] = call692;
  partcv[0] = 1;
  Object call695 = callmethod(call694, "new",
    1, partcv, params);
  gc_frame_end(callframe690);
// compiled call node returning call695 (depth = 3)
  *var_o = call695;
  if (call695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe696 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call697 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe696);
// compiled call node returning call697 (depth = 2)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call699 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe698);
// compiled call node returning call699 (depth = 3)
// compiled member node returning call699 (depth = 2)
  gc_frame_end(frame);
  return call699;
}
Object meth_parser_pushidentifier700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushidentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushidentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe701 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call703 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe702);
// compiled call node returning call703 (depth = 4)
// compiled member node returning call703 (depth = 3)
  gc_frame_newslot(call703);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call705 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe704);
// compiled call node returning call705 (depth = 4)
// compiled member node returning call705 (depth = 3)
  gc_frame_newslot(call705);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call703;
  params[1] = call705;
  partcv[0] = 2;
  Object call706 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe701);
// compiled call node returning call706 (depth = 2)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe707 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe708 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call709 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe708);
// compiled call node returning call709 (depth = 5)
// compiled member node returning call709 (depth = 4)
  gc_frame_newslot(call709);
// starting to compile identifier node (depth = 4)
  Object bool710 = alloc_Boolean(0);
// compiled identifier node returning bool710 (depth = 4)
  gc_frame_newslot(bool710);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe711 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call712 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe711);
// compiled call node returning call712 (depth = 5)
// compiled member node returning call712 (depth = 4)
  params[0] = call709;
  params[1] = bool710;
  partcv[0] = 2;
  Object call713 = callmethod(call712, "new",
    1, partcv, params);
  gc_frame_end(callframe707);
// compiled call node returning call713 (depth = 3)
  *var_o = call713;
  if (call713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit716 == NULL) {
    strlit716 = alloc_String("_");
    gc_root(strlit716);
  }
// compiled string node returning strlit716 (depth = 4)
  int op_slot_right_715 = gc_frame_newslot(strlit716);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call719 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe718);
// compiled call node returning call719 (depth = 5)
// compiled member node returning call719 (depth = 4)
  int op_slot_left_715 = gc_frame_newslot(call719);
  params[0] = strlit716;
  partcv[0] = 1;
  Object opresult720 = callmethod(call719, "==", 1, partcv, params);
// compiled op node returning opresult720 (depth = 3)
  Object if714 = done;
  if (istrue(opresult720)) {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe721 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_right_722 = gc_frame_newslot(*var_auto_count);
// starting to compile string node (depth = 5)
  if (strlit724 == NULL) {
    strlit724 = alloc_String("__");
    gc_root(strlit724);
  }
// compiled string node returning strlit724 (depth = 5)
  int op_slot_left_722 = gc_frame_newslot(strlit724);
  params[0] = *var_auto_count;
  partcv[0] = 1;
  Object opresult725 = callmethod(strlit724, "++", 1, partcv, params);
// compiled op node returning opresult725 (depth = 4)
  gc_frame_newslot(opresult725);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = opresult725;
  partcv[0] = 1;
  Object call726 = callmethod(*var_o, "value:=",
    1, partcv, params);
  gc_frame_end(callframe721);
// compiled call node returning call726 (depth = 3)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe727 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool728 = alloc_Boolean(1);
// compiled identifier node returning bool728 (depth = 4)
  gc_frame_newslot(bool728);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool728;
  partcv[0] = 1;
  Object call729 = callmethod(*var_o, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe727);
// compiled call node returning call729 (depth = 3)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num731 = alloc_Float64(1);
// compiled num node returning num731 (depth = 5)
  int op_slot_right_730 = gc_frame_newslot(num731);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_730 = gc_frame_newslot(*var_auto_count);
  params[0] = num731;
  partcv[0] = 1;
  Object sum733 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum733 (depth = 4)
  *var_auto_count = sum733;
  if (sum733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if714 = done;
  } else {
  }
// compiled if node returning if714 (depth = 2)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe735 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call736 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe735);
// compiled call node returning call736 (depth = 2)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe737 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call738 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe737);
// compiled call node returning call738 (depth = 3)
// compiled member node returning call738 (depth = 2)
  gc_frame_end(frame);
  return call738;
}
Object meth_parser__apply748(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit751 == NULL) {
    strlit751 = alloc_String("identifier");
    gc_root(strlit751);
  }
// compiled string node returning strlit751 (depth = 6)
  int op_slot_right_750 = gc_frame_newslot(strlit751);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call754 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe753);
// compiled call node returning call754 (depth = 7)
// compiled member node returning call754 (depth = 6)
  int op_slot_left_750 = gc_frame_newslot(call754);
  params[0] = strlit751;
  partcv[0] = 1;
  Object opresult755 = callmethod(call754, "==", 1, partcv, params);
// compiled op node returning opresult755 (depth = 5)
  Object if749 = done;
  if (istrue(opresult755)) {
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit758 == NULL) {
    strlit758 = alloc_String("public");
    gc_root(strlit758);
  }
// compiled string node returning strlit758 (depth = 7)
  int op_slot_right_757 = gc_frame_newslot(strlit758);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call761 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe760);
// compiled call node returning call761 (depth = 8)
// compiled member node returning call761 (depth = 7)
  int op_slot_left_757 = gc_frame_newslot(call761);
  params[0] = strlit758;
  partcv[0] = 1;
  Object opresult762 = callmethod(call761, "==", 1, partcv, params);
// compiled op node returning opresult762 (depth = 6)
  Object if756 = done;
  if (istrue(opresult762)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if756 = undefined;
  } else {
  }
// compiled if node returning if756 (depth = 5)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit765 == NULL) {
    strlit765 = alloc_String("readable");
    gc_root(strlit765);
  }
// compiled string node returning strlit765 (depth = 7)
  int op_slot_right_764 = gc_frame_newslot(strlit765);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe767 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call768 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe767);
// compiled call node returning call768 (depth = 8)
// compiled member node returning call768 (depth = 7)
  int op_slot_left_764 = gc_frame_newslot(call768);
  params[0] = strlit765;
  partcv[0] = 1;
  Object opresult769 = callmethod(call768, "==", 1, partcv, params);
// compiled op node returning opresult769 (depth = 6)
  Object if763 = done;
  if (istrue(opresult769)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if763 = undefined;
  } else {
  }
// compiled if node returning if763 (depth = 5)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit772 == NULL) {
    strlit772 = alloc_String("confidential");
    gc_root(strlit772);
  }
// compiled string node returning strlit772 (depth = 7)
  int op_slot_right_771 = gc_frame_newslot(strlit772);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe774 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call775 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe774);
// compiled call node returning call775 (depth = 8)
// compiled member node returning call775 (depth = 7)
  int op_slot_left_771 = gc_frame_newslot(call775);
  params[0] = strlit772;
  partcv[0] = 1;
  Object opresult776 = callmethod(call775, "==", 1, partcv, params);
// compiled op node returning opresult776 (depth = 6)
  Object if770 = done;
  if (istrue(opresult776)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if770 = undefined;
  } else {
  }
// compiled if node returning if770 (depth = 5)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit779 == NULL) {
    strlit779 = alloc_String("writable");
    gc_root(strlit779);
  }
// compiled string node returning strlit779 (depth = 7)
  int op_slot_right_778 = gc_frame_newslot(strlit779);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call782 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe781);
// compiled call node returning call782 (depth = 8)
// compiled member node returning call782 (depth = 7)
  int op_slot_left_778 = gc_frame_newslot(call782);
  params[0] = strlit779;
  partcv[0] = 1;
  Object opresult783 = callmethod(call782, "==", 1, partcv, params);
// compiled op node returning opresult783 (depth = 6)
  Object if777 = done;
  if (istrue(opresult783)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if777 = undefined;
  } else {
  }
// compiled if node returning if777 (depth = 5)
    gc_frame_newslot(if777);
    if749 = if777;
  } else {
  }
// compiled if node returning if749 (depth = 4)
  gc_frame_end(frame);
  return if749;
}
Object meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "adjustVisibilityOf()withSpecialDefault()overriding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for adjustVisibilityOf()withSpecialDefault()overriding (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for adjustVisibilityOf");
  Object *var_sd = &(stackframe->slots[1]);
  *var_sd = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSpecialDefault");
  Object *var_nd = &(stackframe->slots[2]);
  *var_nd = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for overriding");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newAnn = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newAnn");
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  int op_slot_right_741 = gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sd (depth = 4)
  int op_slot_left_741 = gc_frame_newslot(*var_sd);
  params[0] = *var_nd;
  partcv[0] = 1;
  Object opresult743 = callmethod(*var_sd, "==", 1, partcv, params);
// compiled op node returning opresult743 (depth = 3)
  Object if740 = done;
  if (istrue(opresult743)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if740 = undefined;
  } else {
  }
// compiled if node returning if740 (depth = 2)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe744 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call746 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe745);
// compiled call node returning call746 (depth = 4)
// compiled member node returning call746 (depth = 3)
  gc_frame_newslot(call746);
// starting to compile block node (depth = 3)
  Object block747 = alloc_Block(NULL, NULL, "parser", 293);
  gc_frame_newslot(block747);
// method "_apply"
  block_savedest(block747);
  Object closure748 = createclosure(2, "_apply");
  setclosureframe(closure748, stackframe);
  addtoclosure(closure748, var_done);
  addtoclosure(closure748, selfslot);
  struct UserObject *uo748 = (struct UserObject*)block747;
  uo748->data[0] = (Object)closure748;
  Method *meth_meth_parser__apply748 = addmethod2pos(block747, "_apply", &meth_parser__apply748, 0);
  int argcv_meth_parser__apply748[] = {1};
  meth_meth_parser__apply748->type = alloc_MethodType(1, argcv_meth_parser__apply748);
  meth_meth_parser__apply748->definitionModule = modulename;
  meth_meth_parser__apply748->definitionLine = 293;
// compiled block node returning block747 (depth = 3)
  gc_frame_newslot(block747);
// call case 5: prelude request
  params[0] = call746;
  params[1] = block747;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call785 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe744);
// compiled call node returning call785 (depth = 2)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe786 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sd (depth = 4)
  gc_frame_newslot(*var_sd);
// starting to compile identifier node (depth = 4)
  Object bool787 = alloc_Boolean(0);
// compiled identifier node returning bool787 (depth = 4)
  gc_frame_newslot(bool787);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call789 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe788);
// compiled call node returning call789 (depth = 5)
// compiled member node returning call789 (depth = 4)
  params[0] = *var_sd;
  params[1] = bool787;
  partcv[0] = 2;
  Object call790 = callmethod(call789, "new",
    1, partcv, params);
  gc_frame_end(callframe786);
// compiled call node returning call790 (depth = 3)
  *var_newAnn = call790;
  if (call790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe791 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newAnn (depth = 3)
  gc_frame_newslot(*var_newAnn);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe792 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call793 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe792);
// compiled call node returning call793 (depth = 4)
// compiled member node returning call793 (depth = 3)
  params[0] = *var_newAnn;
  partcv[0] = 1;
  Object call794 = callmethod(call793, "push",
    1, partcv, params);
  gc_frame_end(callframe791);
// compiled call node returning call794 (depth = 2)
  gc_frame_end(frame);
  return call794;
}
Object meth_parser__apply816(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool818 = alloc_Boolean(0);
// compiled identifier node returning bool818 (depth = 11)
  int op_slot_right_817 = gc_frame_newslot(bool818);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call821 = callmethod(*var_a, "dtype",
    1, partcv, params);
  gc_frame_end(callframe820);
// compiled call node returning call821 (depth = 12)
// compiled member node returning call821 (depth = 11)
  int op_slot_left_817 = gc_frame_newslot(call821);
  params[0] = bool818;
  partcv[0] = 1;
  Object opresult822 = callmethod(call821, "!=", 1, partcv, params);
// compiled op node returning opresult822 (depth = 10)
  gc_frame_end(frame);
  return opresult822;
}
Object meth_parser__apply833(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit835 == NULL) {
    strlit835 = alloc_String(":");
    gc_root(strlit835);
  }
// compiled string node returning strlit835 (depth = 11)
  int op_slot_right_834 = gc_frame_newslot(strlit835);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe837 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call838 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe837);
// compiled call node returning call838 (depth = 12)
// compiled member node returning call838 (depth = 11)
  int op_slot_left_834 = gc_frame_newslot(call838);
  params[0] = strlit835;
  partcv[0] = 1;
  Object opresult839 = callmethod(call838, "!=", 1, partcv, params);
// compiled op node returning opresult839 (depth = 10)
  gc_frame_end(frame);
  return opresult839;
}
Object meth_parser__apply842(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe843 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call844 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe843);
// compiled call node returning call844 (depth = 12)
// compiled member node returning call844 (depth = 11)
  *var_tok = call844;
  if (call844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply812(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe814 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block815 = alloc_Block(NULL, NULL, "parser", 308);
  gc_frame_newslot(block815);
// method "_apply"
  block_savedest(block815);
  Object closure816 = createclosure(2, "_apply");
  setclosureframe(closure816, stackframe);
  addtoclosure(closure816, var_a);
  addtoclosure(closure816, selfslot);
  struct UserObject *uo816 = (struct UserObject*)block815;
  uo816->data[0] = (Object)closure816;
  Method *meth_meth_parser__apply816 = addmethod2pos(block815, "_apply", &meth_parser__apply816, 0);
  int argcv_meth_parser__apply816[] = {0};
  meth_meth_parser__apply816->type = alloc_MethodType(1, argcv_meth_parser__apply816);
  meth_meth_parser__apply816->definitionModule = modulename;
  meth_meth_parser__apply816->definitionLine = 307;
// compiled block node returning block815 (depth = 9)
  gc_frame_newslot(block815);
// call case 6: other member request
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit825 == NULL) {
    strlit825 = alloc_String("identifier");
    gc_root(strlit825);
  }
// compiled string node returning strlit825 (depth = 10)
  int op_slot_right_824 = gc_frame_newslot(strlit825);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe827 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call828 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe827);
// compiled call node returning call828 (depth = 11)
// compiled member node returning call828 (depth = 10)
  int op_slot_left_824 = gc_frame_newslot(call828);
  params[0] = strlit825;
  partcv[0] = 1;
  Object opresult829 = callmethod(call828, "==", 1, partcv, params);
// compiled op node returning opresult829 (depth = 9)
  params[0] = block815;
  partcv[0] = 1;
  Object call830 = callmethod(opresult829, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe814);
// compiled call node returning call830 (depth = 8)
  Object if813 = done;
  if (istrue(call830)) {
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe831 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block832 = alloc_Block(NULL, NULL, "parser", 311);
  gc_frame_newslot(block832);
// method "_apply"
  block_savedest(block832);
  Object closure833 = createclosure(2, "_apply");
  setclosureframe(closure833, stackframe);
  addtoclosure(closure833, var_tok);
  addtoclosure(closure833, selfslot);
  struct UserObject *uo833 = (struct UserObject*)block832;
  uo833->data[0] = (Object)closure833;
  Method *meth_meth_parser__apply833 = addmethod2pos(block832, "_apply", &meth_parser__apply833, 0);
  int argcv_meth_parser__apply833[] = {0};
  meth_meth_parser__apply833->type = alloc_MethodType(1, argcv_meth_parser__apply833);
  meth_meth_parser__apply833->definitionModule = modulename;
  meth_meth_parser__apply833->definitionLine = 308;
// compiled block node returning block832 (depth = 9)
  gc_frame_newslot(block832);
// starting to compile block node (depth = 9)
  Object block841 = alloc_Block(NULL, NULL, "parser", 311);
  gc_frame_newslot(block841);
// method "_apply"
  block_savedest(block841);
  Object closure842 = createclosure(2, "_apply");
  setclosureframe(closure842, stackframe);
  addtoclosure(closure842, var_tok);
  addtoclosure(closure842, selfslot);
  struct UserObject *uo842 = (struct UserObject*)block841;
  uo842->data[0] = (Object)closure842;
  Method *meth_meth_parser__apply842 = addmethod2pos(block841, "_apply", &meth_parser__apply842, 0);
  int argcv_meth_parser__apply842[] = {0};
  meth_meth_parser__apply842->type = alloc_MethodType(1, argcv_meth_parser__apply842);
  meth_meth_parser__apply842->definitionModule = modulename;
  meth_meth_parser__apply842->definitionLine = 311;
// compiled block node returning block841 (depth = 9)
  gc_frame_newslot(block841);
// call case 5: prelude request
  params[0] = block832;
  params[1] = block841;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call847 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe831);
// compiled call node returning call847 (depth = 8)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe848 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe849 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call850 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe849);
// compiled call node returning call850 (depth = 12)
// compiled member node returning call850 (depth = 11)
  partcv[0] = 0;
  Object call851 = callmethod(call850, "new",
    1, partcv, params);
  gc_frame_end(callframe848);
// compiled call node returning call851 (depth = 10)
// compiled member node returning call851 (depth = 9)
  *var_suggestion = call851;
  if (call851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe852 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe853 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call854 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe853);
// compiled call node returning call854 (depth = 10)
// compiled member node returning call854 (depth = 9)
  gc_frame_newslot(call854);
// starting to compile identifier node (depth = 9)
  Object bool855 = alloc_Boolean(1);
// compiled identifier node returning bool855 (depth = 9)
  gc_frame_newslot(bool855);
// starting to compile identifier node (depth = 9)
  Object bool856 = alloc_Boolean(0);
// compiled identifier node returning bool856 (depth = 9)
  gc_frame_newslot(bool856);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call854;
  params[2] = bool855;
  params[3] = bool856;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call857 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe852);
// compiled call node returning call857 (depth = 8)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe858 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit859 == NULL) {
    strlit859 = alloc_String("an argument to an annotation cannot have a type.");
    gc_root(strlit859);
  }
// compiled string node returning strlit859 (depth = 9)
  gc_frame_newslot(strlit859);
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call861 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe860);
// compiled call node returning call861 (depth = 10)
// compiled member node returning call861 (depth = 9)
  gc_frame_newslot(call861);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call863 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe862);
// compiled call node returning call863 (depth = 10)
// compiled member node returning call863 (depth = 9)
  gc_frame_newslot(call863);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num865 = alloc_Float64(1);
// compiled num node returning num865 (depth = 10)
  int op_slot_right_864 = gc_frame_newslot(num865);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe868 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe869 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call870 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe869);
// compiled call node returning call870 (depth = 14)
// compiled member node returning call870 (depth = 13)
  partcv[0] = 0;
  Object call871 = callmethod(call870, "size",
    1, partcv, params);
  gc_frame_end(callframe868);
// compiled call node returning call871 (depth = 12)
// compiled member node returning call871 (depth = 11)
  int op_slot_right_867 = gc_frame_newslot(call871);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe873 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe874 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call875 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe874);
// compiled call node returning call875 (depth = 14)
// compiled member node returning call875 (depth = 13)
  partcv[0] = 0;
  Object call876 = callmethod(call875, "linePos",
    1, partcv, params);
  gc_frame_end(callframe873);
// compiled call node returning call876 (depth = 12)
// compiled member node returning call876 (depth = 11)
  int op_slot_left_867 = gc_frame_newslot(call876);
  params[0] = call871;
  partcv[0] = 1;
  Object sum877 = callmethod(call876, "+", 1, partcv, params);
// compiled op node returning sum877 (depth = 10)
  int op_slot_left_864 = gc_frame_newslot(sum877);
  params[0] = num865;
  partcv[0] = 1;
  Object diff878 = callmethod(sum877, "-", 1, partcv, params);
// compiled op node returning diff878 (depth = 9)
  gc_frame_newslot(diff878);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit859;
  params[1] = call861;
  params[2] = call863;
  params[3] = diff878;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call879 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe858);
// compiled call node returning call879 (depth = 8)
    gc_frame_newslot(call879);
    if813 = call879;
  } else {
  }
// compiled if node returning if813 (depth = 7)
  gc_frame_end(frame);
  return if813;
}
Object meth_parser__apply807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe808 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  partcv[0] = 0;
  Object call810 = callmethod(*var_p, "args",
    1, partcv, params);
  gc_frame_end(callframe809);
// compiled call node returning call810 (depth = 7)
// compiled member node returning call810 (depth = 6)
  gc_frame_newslot(call810);
// starting to compile block node (depth = 6)
  Object block811 = alloc_Block(NULL, NULL, "parser", 307);
  gc_frame_newslot(block811);
// method "_apply"
  block_savedest(block811);
  Object closure812 = createclosure(3, "_apply");
  setclosureframe(closure812, stackframe);
  addtoclosure(closure812, var_sym);
  addtoclosure(closure812, var_errormessages);
  addtoclosure(closure812, selfslot);
  struct UserObject *uo812 = (struct UserObject*)block811;
  uo812->data[0] = (Object)closure812;
  Method *meth_meth_parser__apply812 = addmethod2pos(block811, "_apply", &meth_parser__apply812, 0);
  int argcv_meth_parser__apply812[] = {1};
  meth_meth_parser__apply812->type = alloc_MethodType(1, argcv_meth_parser__apply812);
  meth_meth_parser__apply812->definitionModule = modulename;
  meth_meth_parser__apply812->definitionLine = 307;
// compiled block node returning block811 (depth = 6)
  gc_frame_newslot(block811);
// call case 5: prelude request
  params[0] = call810;
  params[1] = block811;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call881 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe808);
// compiled call node returning call881 (depth = 5)
  gc_frame_end(frame);
  return call881;
}
Object meth_parser_checkAnnotation795(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkAnnotation");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for checkAnnotation");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit798 == NULL) {
    strlit798 = alloc_String("call");
    gc_root(strlit798);
  }
// compiled string node returning strlit798 (depth = 4)
  int op_slot_right_797 = gc_frame_newslot(strlit798);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call801 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe800);
// compiled call node returning call801 (depth = 5)
// compiled member node returning call801 (depth = 4)
  int op_slot_left_797 = gc_frame_newslot(call801);
  params[0] = strlit798;
  partcv[0] = 1;
  Object opresult802 = callmethod(call801, "==", 1, partcv, params);
// compiled op node returning opresult802 (depth = 3)
  Object if796 = done;
  if (istrue(opresult802)) {
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe803 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call805 = callmethod(*var_ann, "with",
    1, partcv, params);
  gc_frame_end(callframe804);
// compiled call node returning call805 (depth = 5)
// compiled member node returning call805 (depth = 4)
  gc_frame_newslot(call805);
// starting to compile block node (depth = 4)
  Object block806 = alloc_Block(NULL, NULL, "parser", 306);
  gc_frame_newslot(block806);
// method "_apply"
  block_savedest(block806);
  Object closure807 = createclosure(3, "_apply");
  setclosureframe(closure807, stackframe);
  addtoclosure(closure807, var_sym);
  addtoclosure(closure807, var_errormessages);
  addtoclosure(closure807, selfslot);
  struct UserObject *uo807 = (struct UserObject*)block806;
  uo807->data[0] = (Object)closure807;
  Method *meth_meth_parser__apply807 = addmethod2pos(block806, "_apply", &meth_parser__apply807, 0);
  int argcv_meth_parser__apply807[] = {1};
  meth_meth_parser__apply807->type = alloc_MethodType(1, argcv_meth_parser__apply807);
  meth_meth_parser__apply807->definitionModule = modulename;
  meth_meth_parser__apply807->definitionLine = 306;
// compiled block node returning block806 (depth = 4)
  gc_frame_newslot(block806);
// call case 5: prelude request
  params[0] = call805;
  params[1] = block806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call883 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe803);
// compiled call node returning call883 (depth = 3)
    gc_frame_newslot(call883);
    if796 = call883;
  } else {
  }
// compiled if node returning if796 (depth = 2)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser__apply902(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe903 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call904 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe903);
// compiled call node returning call904 (depth = 7)
  gc_frame_end(frame);
  return call904;
}
Object meth_parser__apply967(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe968 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit969 == NULL) {
    strlit969 = alloc_String("comma");
    gc_root(strlit969);
  }
// compiled string node returning strlit969 (depth = 5)
  gc_frame_newslot(strlit969);
// call case 4: self request
  params[0] = strlit969;
  partcv[0] = 1;
  Object call970 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe968);
// compiled call node returning call970 (depth = 4)
  gc_frame_end(frame);
  return call970;
}
Object meth_parser__apply986(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe987 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_noBlocks (depth = 10)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call988 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe987);
// compiled call node returning call988 (depth = 9)
  gc_frame_end(frame);
  return call988;
}
Object meth_parser__apply973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe974 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe975 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call977 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe976);
// compiled call node returning call977 (depth = 7)
// compiled member node returning call977 (depth = 6)
  gc_frame_newslot(call977);
// call case 4: self request
  params[0] = call977;
  partcv[0] = 1;
  Object call978 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe975);
// compiled call node returning call978 (depth = 5)
  gc_frame_newslot(call978);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call978;
  partcv[0] = 1;
  Object call979 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe974);
// compiled call node returning call979 (depth = 4)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe980 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call981 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe980);
// compiled call node returning call981 (depth = 5)
// compiled member node returning call981 (depth = 4)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe983 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe984 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block985 = alloc_Block(NULL, NULL, "parser", 347);
  gc_frame_newslot(block985);
// method "_apply"
  block_savedest(block985);
  Object closure986 = createclosure(2, "_apply");
  setclosureframe(closure986, stackframe);
  addtoclosure(closure986, var_noBlocks);
  addtoclosure(closure986, selfslot);
  struct UserObject *uo986 = (struct UserObject*)block985;
  uo986->data[0] = (Object)closure986;
  Method *meth_meth_parser__apply986 = addmethod2pos(block985, "_apply", &meth_parser__apply986, 0);
  int argcv_meth_parser__apply986[] = {0};
  meth_meth_parser__apply986->type = alloc_MethodType(1, argcv_meth_parser__apply986);
  meth_meth_parser__apply986->definitionModule = modulename;
  meth_meth_parser__apply986->definitionLine = 347;
// compiled block node returning block985 (depth = 8)
  gc_frame_newslot(block985);
// call case 4: self request
  params[0] = block985;
  partcv[0] = 1;
  Object call990 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe984);
// compiled call node returning call990 (depth = 7)
  partcv[0] = 0;
  Object call991 = callmethod(call990, "not",
    1, partcv, params);
  gc_frame_end(callframe983);
// compiled call node returning call991 (depth = 6)
// compiled member node returning call991 (depth = 5)
  Object if982 = done;
  if (istrue(call991)) {
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe992 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe993 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call994 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe993);
// compiled call node returning call994 (depth = 9)
// compiled member node returning call994 (depth = 8)
  partcv[0] = 0;
  Object call995 = callmethod(call994, "empty",
    1, partcv, params);
  gc_frame_end(callframe992);
// compiled call node returning call995 (depth = 7)
// compiled member node returning call995 (depth = 6)
  *var_suggestions = call995;
  if (call995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe996 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call998 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe997);
// compiled call node returning call998 (depth = 9)
// compiled member node returning call998 (depth = 8)
  partcv[0] = 0;
  Object call999 = callmethod(call998, "new",
    1, partcv, params);
  gc_frame_end(callframe996);
// compiled call node returning call999 (depth = 7)
// compiled member node returning call999 (depth = 6)
  *var_suggestion = call999;
  if (call999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1000 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array1001 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1002 == NULL) {
    strlit1002 = alloc_String("bind");
    gc_root(strlit1002);
  }
// compiled string node returning strlit1002 (depth = 8)
  params[0] = strlit1002;
  partcv[0] = 1;
  callmethod(array1001, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array1001 (depth = 7)
  gc_frame_newslot(array1001);
// call case 4: self request
  params[0] = array1001;
  partcv[0] = 1;
  Object call1003 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1000);
// compiled call node returning call1003 (depth = 6)
  *var_nextTok = call1003;
  if (call1003 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1005 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1005 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1007 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1007 (depth = 6)
  Object if1004 = done;
  if (istrue(opresult1007)) {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1008 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1009 == NULL) {
    strlit1009 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit1009);
  }
// compiled string node returning strlit1009 (depth = 7)
  gc_frame_newslot(strlit1009);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1009;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1010 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1008);
// compiled call node returning call1010 (depth = 6)
    gc_frame_newslot(call1010);
    if1004 = call1010;
  } else {
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1011 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1013 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1012);
// compiled call node returning call1013 (depth = 8)
// compiled member node returning call1013 (depth = 7)
  gc_frame_newslot(call1013);
// starting to compile identifier node (depth = 7)
  Object bool1014 = alloc_Boolean(1);
// compiled identifier node returning bool1014 (depth = 7)
  gc_frame_newslot(bool1014);
// starting to compile identifier node (depth = 7)
  Object bool1015 = alloc_Boolean(0);
// compiled identifier node returning bool1015 (depth = 7)
  gc_frame_newslot(bool1015);
// starting to compile string node (depth = 7)
  if (strlit1016 == NULL) {
    strlit1016 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit1016);
  }
// compiled string node returning strlit1016 (depth = 7)
  gc_frame_newslot(strlit1016);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1013;
  params[2] = bool1014;
  params[3] = bool1015;
  params[4] = strlit1016;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1017 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1011);
// compiled call node returning call1017 (depth = 6)
    gc_frame_newslot(call1017);
    if1004 = call1017;
  }
// compiled if node returning if1004 (depth = 5)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1018 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1019 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1018);
// compiled call node returning call1019 (depth = 5)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1020 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1021 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call1022 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1021);
// compiled call node returning call1022 (depth = 9)
// compiled member node returning call1022 (depth = 8)
  partcv[0] = 0;
  Object call1023 = callmethod(call1022, "new",
    1, partcv, params);
  gc_frame_end(callframe1020);
// compiled call node returning call1023 (depth = 7)
// compiled member node returning call1023 (depth = 6)
  *var_suggestion = call1023;
  if (call1023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1025 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1027 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1026);
// compiled call node returning call1027 (depth = 7)
// compiled member node returning call1027 (depth = 6)
  gc_frame_newslot(call1027);
// starting to compile identifier node (depth = 6)
  Object bool1028 = alloc_Boolean(1);
// compiled identifier node returning bool1028 (depth = 6)
  gc_frame_newslot(bool1028);
// starting to compile identifier node (depth = 6)
  Object bool1029 = alloc_Boolean(0);
// compiled identifier node returning bool1029 (depth = 6)
  gc_frame_newslot(bool1029);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call1027;
  params[2] = bool1028;
  params[3] = bool1029;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1030 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1025);
// compiled call node returning call1030 (depth = 5)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1031 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1032 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1031);
// compiled call node returning call1032 (depth = 5)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1033 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1034 == NULL) {
    strlit1034 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit1034);
  }
// compiled string node returning strlit1034 (depth = 6)
  gc_frame_newslot(strlit1034);
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1036 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1035);
// compiled call node returning call1036 (depth = 7)
// compiled member node returning call1036 (depth = 6)
  gc_frame_newslot(call1036);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1038 = alloc_Float64(1);
// compiled num node returning num1038 (depth = 7)
  int op_slot_right_1037 = gc_frame_newslot(num1038);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1041 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call1042 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1041);
// compiled call node returning call1042 (depth = 9)
// compiled member node returning call1042 (depth = 8)
  int op_slot_right_1040 = gc_frame_newslot(call1042);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1044 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call1045 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1044);
// compiled call node returning call1045 (depth = 9)
// compiled member node returning call1045 (depth = 8)
  int op_slot_left_1040 = gc_frame_newslot(call1045);
  params[0] = call1042;
  partcv[0] = 1;
  Object sum1046 = callmethod(call1045, "+", 1, partcv, params);
// compiled op node returning sum1046 (depth = 7)
  int op_slot_left_1037 = gc_frame_newslot(sum1046);
  params[0] = num1038;
  partcv[0] = 1;
  Object sum1047 = callmethod(sum1046, "+", 1, partcv, params);
// compiled op node returning sum1047 (depth = 6)
  gc_frame_newslot(sum1047);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1034;
  params[1] = call1036;
  params[2] = sum1047;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1048 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1033);
// compiled call node returning call1048 (depth = 5)
    gc_frame_newslot(call1048);
    if982 = call1048;
  } else {
  }
// compiled if node returning if982 (depth = 4)
  gc_frame_end(frame);
  return if982;
}
Object meth_parser_doannotation884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doannotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doannotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe886 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe887 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit888 == NULL) {
    strlit888 = alloc_String("is");
    gc_root(strlit888);
  }
// compiled string node returning strlit888 (depth = 6)
  gc_frame_newslot(strlit888);
// call case 4: self request
  params[0] = strlit888;
  partcv[0] = 1;
  Object call889 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe887);
// compiled call node returning call889 (depth = 5)
  partcv[0] = 0;
  Object call890 = callmethod(call889, "not",
    1, partcv, params);
  gc_frame_end(callframe886);
// compiled call node returning call890 (depth = 4)
// compiled member node returning call890 (depth = 3)
  Object if885 = done;
  if (istrue(call890)) {
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool891 = alloc_Boolean(0);
// compiled identifier node returning bool891 (depth = 4)
  return bool891;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if885 = undefined;
  } else {
  }
// compiled if node returning if885 (depth = 2)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe892 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call893 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe892);
// compiled call node returning call893 (depth = 3)
// compiled member node returning call893 (depth = 2)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe894 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe895 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call896 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe895);
// compiled call node returning call896 (depth = 6)
// compiled member node returning call896 (depth = 5)
  partcv[0] = 0;
  Object call897 = callmethod(call896, "empty",
    1, partcv, params);
  gc_frame_end(callframe894);
// compiled call node returning call897 (depth = 4)
// compiled member node returning call897 (depth = 3)
  *var_anns = call897;
  if (call897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe899 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe900 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block901 = alloc_Block(NULL, NULL, "parser", 328);
  gc_frame_newslot(block901);
// method "_apply"
  block_savedest(block901);
  Object closure902 = createclosure(2, "_apply");
  setclosureframe(closure902, stackframe);
  addtoclosure(closure902, var_noBlocks);
  addtoclosure(closure902, selfslot);
  struct UserObject *uo902 = (struct UserObject*)block901;
  uo902->data[0] = (Object)closure902;
  Method *meth_meth_parser__apply902 = addmethod2pos(block901, "_apply", &meth_parser__apply902, 0);
  int argcv_meth_parser__apply902[] = {0};
  meth_meth_parser__apply902->type = alloc_MethodType(1, argcv_meth_parser__apply902);
  meth_meth_parser__apply902->definitionModule = modulename;
  meth_meth_parser__apply902->definitionLine = 328;
// compiled block node returning block901 (depth = 6)
  gc_frame_newslot(block901);
// call case 4: self request
  params[0] = block901;
  partcv[0] = 1;
  Object call906 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe900);
// compiled call node returning call906 (depth = 5)
  partcv[0] = 0;
  Object call907 = callmethod(call906, "not",
    1, partcv, params);
  gc_frame_end(callframe899);
// compiled call node returning call907 (depth = 4)
// compiled member node returning call907 (depth = 3)
  Object if898 = done;
  if (istrue(call907)) {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe908 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe909 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call910 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe909);
// compiled call node returning call910 (depth = 7)
// compiled member node returning call910 (depth = 6)
  partcv[0] = 0;
  Object call911 = callmethod(call910, "empty",
    1, partcv, params);
  gc_frame_end(callframe908);
// compiled call node returning call911 (depth = 5)
// compiled member node returning call911 (depth = 4)
  *var_suggestions = call911;
  if (call911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe912 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call914 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe913);
// compiled call node returning call914 (depth = 7)
// compiled member node returning call914 (depth = 6)
  partcv[0] = 0;
  Object call915 = callmethod(call914, "new",
    1, partcv, params);
  gc_frame_end(callframe912);
// compiled call node returning call915 (depth = 5)
// compiled member node returning call915 (depth = 4)
  *var_suggestion = call915;
  if (call915 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe916 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array917 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit918 == NULL) {
    strlit918 = alloc_String("bind");
    gc_root(strlit918);
  }
// compiled string node returning strlit918 (depth = 6)
  params[0] = strlit918;
  partcv[0] = 1;
  callmethod(array917, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array917 (depth = 5)
  gc_frame_newslot(array917);
// call case 4: self request
  params[0] = array917;
  partcv[0] = 1;
  Object call919 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe916);
// compiled call node returning call919 (depth = 4)
  *var_nextTok = call919;
  if (call919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_921 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_921 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult923 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult923 (depth = 4)
  Object if920 = done;
  if (istrue(opresult923)) {
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe924 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit925 == NULL) {
    strlit925 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit925);
  }
// compiled string node returning strlit925 (depth = 5)
  gc_frame_newslot(strlit925);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit925;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call926 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe924);
// compiled call node returning call926 (depth = 4)
    gc_frame_newslot(call926);
    if920 = call926;
  } else {
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe927 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call929 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe928);
// compiled call node returning call929 (depth = 6)
// compiled member node returning call929 (depth = 5)
  gc_frame_newslot(call929);
// starting to compile identifier node (depth = 5)
  Object bool930 = alloc_Boolean(1);
// compiled identifier node returning bool930 (depth = 5)
  gc_frame_newslot(bool930);
// starting to compile identifier node (depth = 5)
  Object bool931 = alloc_Boolean(0);
// compiled identifier node returning bool931 (depth = 5)
  gc_frame_newslot(bool931);
// starting to compile string node (depth = 5)
  if (strlit932 == NULL) {
    strlit932 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit932);
  }
// compiled string node returning strlit932 (depth = 5)
  gc_frame_newslot(strlit932);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call929;
  params[2] = bool930;
  params[3] = bool931;
  params[4] = strlit932;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call933 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe927);
// compiled call node returning call933 (depth = 4)
    gc_frame_newslot(call933);
    if920 = call933;
  }
// compiled if node returning if920 (depth = 3)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe934 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call935 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe934);
// compiled call node returning call935 (depth = 3)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call938 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe937);
// compiled call node returning call938 (depth = 7)
// compiled member node returning call938 (depth = 6)
  partcv[0] = 0;
  Object call939 = callmethod(call938, "new",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call939 (depth = 5)
// compiled member node returning call939 (depth = 4)
  *var_suggestion = call939;
  if (call939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe941 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  partcv[0] = 0;
  Object call943 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe942);
// compiled call node returning call943 (depth = 5)
// compiled member node returning call943 (depth = 4)
  gc_frame_newslot(call943);
// starting to compile identifier node (depth = 4)
  Object bool944 = alloc_Boolean(1);
// compiled identifier node returning bool944 (depth = 4)
  gc_frame_newslot(bool944);
// starting to compile identifier node (depth = 4)
  Object bool945 = alloc_Boolean(0);
// compiled identifier node returning bool945 (depth = 4)
  gc_frame_newslot(bool945);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_lastToken;
  params[1] = call943;
  params[2] = bool944;
  params[3] = bool945;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call946 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe941);
// compiled call node returning call946 (depth = 3)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe947 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call948 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe947);
// compiled call node returning call948 (depth = 3)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe949 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit950 == NULL) {
    strlit950 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit950);
  }
// compiled string node returning strlit950 (depth = 4)
  gc_frame_newslot(strlit950);
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call952 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe951);
// compiled call node returning call952 (depth = 5)
// compiled member node returning call952 (depth = 4)
  gc_frame_newslot(call952);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num954 = alloc_Float64(1);
// compiled num node returning num954 (depth = 5)
  int op_slot_right_953 = gc_frame_newslot(num954);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call958 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe957);
// compiled call node returning call958 (depth = 7)
// compiled member node returning call958 (depth = 6)
  int op_slot_right_956 = gc_frame_newslot(call958);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe960 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call961 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe960);
// compiled call node returning call961 (depth = 7)
// compiled member node returning call961 (depth = 6)
  int op_slot_left_956 = gc_frame_newslot(call961);
  params[0] = call958;
  partcv[0] = 1;
  Object sum962 = callmethod(call961, "+", 1, partcv, params);
// compiled op node returning sum962 (depth = 5)
  int op_slot_left_953 = gc_frame_newslot(sum962);
  params[0] = num954;
  partcv[0] = 1;
  Object sum963 = callmethod(sum962, "+", 1, partcv, params);
// compiled op node returning sum963 (depth = 4)
  gc_frame_newslot(sum963);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit950;
  params[1] = call952;
  params[2] = sum963;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call964 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe949);
// compiled call node returning call964 (depth = 3)
    gc_frame_newslot(call964);
    if898 = call964;
  } else {
  }
// compiled if node returning if898 (depth = 2)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe965 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block966 = alloc_Block(NULL, NULL, "parser", 344);
  gc_frame_newslot(block966);
// method "_apply"
  block_savedest(block966);
  Object closure967 = createclosure(1, "_apply");
  setclosureframe(closure967, stackframe);
  addtoclosure(closure967, selfslot);
  struct UserObject *uo967 = (struct UserObject*)block966;
  uo967->data[0] = (Object)closure967;
  Method *meth_meth_parser__apply967 = addmethod2pos(block966, "_apply", &meth_parser__apply967, 0);
  int argcv_meth_parser__apply967[] = {0};
  meth_meth_parser__apply967->type = alloc_MethodType(1, argcv_meth_parser__apply967);
  meth_meth_parser__apply967->definitionModule = modulename;
  meth_meth_parser__apply967->definitionLine = 342;
// compiled block node returning block966 (depth = 3)
  gc_frame_newslot(block966);
// starting to compile block node (depth = 3)
  Object block972 = alloc_Block(NULL, NULL, "parser", 344);
  gc_frame_newslot(block972);
// method "_apply"
  block_savedest(block972);
  Object closure973 = createclosure(7, "_apply");
  setclosureframe(closure973, stackframe);
  addtoclosure(closure973, var_values);
  addtoclosure(closure973, var_anns);
  addtoclosure(closure973, var_noBlocks);
  addtoclosure(closure973, var_errormessages);
  addtoclosure(closure973, var_sym);
  addtoclosure(closure973, var_lastToken);
  addtoclosure(closure973, selfslot);
  struct UserObject *uo973 = (struct UserObject*)block972;
  uo973->data[0] = (Object)closure973;
  Method *meth_meth_parser__apply973 = addmethod2pos(block972, "_apply", &meth_parser__apply973, 0);
  int argcv_meth_parser__apply973[] = {0};
  meth_meth_parser__apply973->type = alloc_MethodType(1, argcv_meth_parser__apply973);
  meth_meth_parser__apply973->definitionModule = modulename;
  meth_meth_parser__apply973->definitionLine = 342;
// compiled block node returning block972 (depth = 3)
  gc_frame_newslot(block972);
// call case 5: prelude request
  params[0] = block966;
  params[1] = block972;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1050 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe965);
// compiled call node returning call1050 (depth = 2)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1051 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1052 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1054 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1053);
// compiled call node returning call1054 (depth = 5)
// compiled member node returning call1054 (depth = 4)
  gc_frame_newslot(call1054);
// call case 4: self request
  params[0] = call1054;
  partcv[0] = 1;
  Object call1055 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1052);
// compiled call node returning call1055 (depth = 3)
  gc_frame_newslot(call1055);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call1055;
  partcv[0] = 1;
  Object call1056 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe1051);
// compiled call node returning call1056 (depth = 2)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser__apply1093(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1095 == NULL) {
    strlit1095 = alloc_String("blank");
    gc_root(strlit1095);
  }
// compiled string node returning strlit1095 (depth = 7)
  int op_slot_right_1094 = gc_frame_newslot(strlit1095);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1097 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1099 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1098);
// compiled call node returning call1099 (depth = 10)
// compiled member node returning call1099 (depth = 9)
  partcv[0] = 0;
  Object call1100 = callmethod(call1099, "kind",
    1, partcv, params);
  gc_frame_end(callframe1097);
// compiled call node returning call1100 (depth = 8)
// compiled member node returning call1100 (depth = 7)
  int op_slot_left_1094 = gc_frame_newslot(call1100);
  params[0] = strlit1095;
  partcv[0] = 1;
  Object opresult1101 = callmethod(call1100, "!=", 1, partcv, params);
// compiled op node returning opresult1101 (depth = 6)
  gc_frame_end(frame);
  return opresult1101;
}
Object meth_parser_blank1057(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_done = getfromclosure(closure, 3);
  Object *var_previousCommentToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1060 = alloc_Float64(0);
// compiled num node returning num1060 (depth = 4)
  int op_slot_right_1059 = gc_frame_newslot(num1060);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blankLocation (depth = 4)
  int op_slot_left_1059 = gc_frame_newslot(*var_blankLocation);
  params[0] = num1060;
  partcv[0] = 1;
  Object opresult1062 = callmethod(*var_blankLocation, "==", 1, partcv, params);
// compiled op node returning opresult1062 (depth = 3)
  Object if1058 = done;
  if (istrue(opresult1062)) {
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1066 = alloc_Float64(1);
// compiled num node returning num1066 (depth = 6)
  int op_slot_right_1065 = gc_frame_newslot(num1066);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1069 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1068);
// compiled call node returning call1069 (depth = 7)
// compiled member node returning call1069 (depth = 6)
  int op_slot_left_1065 = gc_frame_newslot(call1069);
  params[0] = num1066;
  partcv[0] = 1;
  Object sum1070 = callmethod(call1069, "+", 1, partcv, params);
// compiled op node returning sum1070 (depth = 5)
  int op_slot_right_1064 = gc_frame_newslot(sum1070);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1072 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1073 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1072);
// compiled call node returning call1073 (depth = 6)
// compiled member node returning call1073 (depth = 5)
  int op_slot_left_1064 = gc_frame_newslot(call1073);
  params[0] = sum1070;
  partcv[0] = 1;
  Object opresult1074 = callmethod(call1073, "<=", 1, partcv, params);
// compiled op node returning opresult1074 (depth = 4)
  Object if1063 = done;
  if (istrue(opresult1074)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1063 = undefined;
  } else {
  }
// compiled if node returning if1063 (depth = 3)
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1078 = alloc_Float64(1);
// compiled num node returning num1078 (depth = 6)
  int op_slot_right_1077 = gc_frame_newslot(num1078);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_previousCommentToken (depth = 8)
  partcv[0] = 0;
  Object call1081 = callmethod(*var_previousCommentToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1080);
// compiled call node returning call1081 (depth = 7)
// compiled member node returning call1081 (depth = 6)
  int op_slot_left_1077 = gc_frame_newslot(call1081);
  params[0] = num1078;
  partcv[0] = 1;
  Object sum1082 = callmethod(call1081, "+", 1, partcv, params);
// compiled op node returning sum1082 (depth = 5)
  int op_slot_right_1076 = gc_frame_newslot(sum1082);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1084 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1085 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1084);
// compiled call node returning call1085 (depth = 6)
// compiled member node returning call1085 (depth = 5)
  int op_slot_left_1076 = gc_frame_newslot(call1085);
  params[0] = sum1082;
  partcv[0] = 1;
  Object opresult1086 = callmethod(call1085, "<=", 1, partcv, params);
// compiled op node returning opresult1086 (depth = 4)
  Object if1075 = done;
  if (istrue(opresult1086)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1075 = undefined;
  } else {
  }
// compiled if node returning if1075 (depth = 3)
    gc_frame_newslot(if1075);
    if1058 = if1075;
  } else {
  }
// compiled if node returning if1058 (depth = 2)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1088 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1087);
// compiled call node returning call1088 (depth = 3)
// compiled member node returning call1088 (depth = 2)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1091 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1092 = alloc_Block(NULL, NULL, "parser", 375);
  gc_frame_newslot(block1092);
// method "_apply"
  block_savedest(block1092);
  Object closure1093 = createclosure(2, "_apply");
  setclosureframe(closure1093, stackframe);
  addtoclosure(closure1093, var_values);
  addtoclosure(closure1093, selfslot);
  struct UserObject *uo1093 = (struct UserObject*)block1092;
  uo1093->data[0] = (Object)closure1093;
  Method *meth_meth_parser__apply1093 = addmethod2pos(block1092, "_apply", &meth_parser__apply1093, 0);
  int argcv_meth_parser__apply1093[] = {0};
  meth_meth_parser__apply1093->type = alloc_MethodType(1, argcv_meth_parser__apply1093);
  meth_meth_parser__apply1093->definitionModule = modulename;
  meth_meth_parser__apply1093->definitionLine = 373;
// compiled block node returning block1092 (depth = 5)
  gc_frame_newslot(block1092);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1104 = alloc_Float64(0);
// compiled num node returning num1104 (depth = 6)
  int op_slot_right_1103 = gc_frame_newslot(num1104);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1107 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1106);
// compiled call node returning call1107 (depth = 7)
// compiled member node returning call1107 (depth = 6)
  int op_slot_left_1103 = gc_frame_newslot(call1107);
  params[0] = num1104;
  partcv[0] = 1;
  Object opresult1108 = callmethod(call1107, ">", 1, partcv, params);
// compiled op node returning opresult1108 (depth = 5)
  params[0] = block1092;
  partcv[0] = 1;
  Object call1109 = callmethod(opresult1108, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1091);
// compiled call node returning call1109 (depth = 4)
  int op_slot_right_1090 = gc_frame_newslot(call1109);
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1112 = alloc_Float64(0);
// compiled num node returning num1112 (depth = 5)
  int op_slot_right_1111 = gc_frame_newslot(num1112);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call1115 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1114);
// compiled call node returning call1115 (depth = 6)
// compiled member node returning call1115 (depth = 5)
  int op_slot_left_1111 = gc_frame_newslot(call1115);
  params[0] = num1112;
  partcv[0] = 1;
  Object opresult1116 = callmethod(call1115, "==", 1, partcv, params);
// compiled op node returning opresult1116 (depth = 4)
  int op_slot_left_1090 = gc_frame_newslot(opresult1116);
  params[0] = call1109;
  partcv[0] = 1;
  Object opresult1117 = callmethod(opresult1116, "||", 1, partcv, params);
// compiled op node returning opresult1117 (depth = 3)
  Object if1089 = done;
  if (istrue(opresult1117)) {
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1120 = alloc_Float64(0);
// compiled num node returning num1120 (depth = 5)
  int op_slot_right_1119 = gc_frame_newslot(num1120);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  int op_slot_left_1119 = gc_frame_newslot(*var_blankLocation);
  params[0] = num1120;
  partcv[0] = 1;
  Object opresult1122 = callmethod(*var_blankLocation, ">", 1, partcv, params);
// compiled op node returning opresult1122 (depth = 4)
  Object if1118 = done;
  if (istrue(opresult1122)) {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1123 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  gc_frame_newslot(*var_blankLocation);
// starting to compile num node (depth = 5)
  Object num1124 = alloc_Float64(0);
// compiled num node returning num1124 (depth = 5)
  gc_frame_newslot(num1124);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_blankLocation;
  params[1] = num1124;
  partcv[0] = 2;
  Object call1125 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1123);
// compiled call node returning call1125 (depth = 4)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1126 = alloc_Float64(0);
// compiled num node returning num1126 (depth = 5)
  *var_blankLocation = num1126;
  if (num1126 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1118 = done;
  } else {
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1128 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1130 = alloc_Float64(1);
// compiled num node returning num1130 (depth = 6)
  int op_slot_right_1129 = gc_frame_newslot(num1130);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1132 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1133 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1132);
// compiled call node returning call1133 (depth = 7)
// compiled member node returning call1133 (depth = 6)
  int op_slot_left_1129 = gc_frame_newslot(call1133);
  params[0] = num1130;
  partcv[0] = 1;
  Object diff1134 = callmethod(call1133, "-", 1, partcv, params);
// compiled op node returning diff1134 (depth = 5)
  gc_frame_newslot(diff1134);
// starting to compile num node (depth = 5)
  Object num1135 = alloc_Float64(0);
// compiled num node returning num1135 (depth = 5)
  gc_frame_newslot(num1135);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = diff1134;
  params[1] = num1135;
  partcv[0] = 2;
  Object call1136 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1128);
// compiled call node returning call1136 (depth = 4)
    gc_frame_newslot(call1136);
    if1118 = call1136;
  }
// compiled if node returning if1118 (depth = 3)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1137 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1138 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1139 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call1140 = callmethod(*var_ast, "blankNode",
    1, partcv, params);
  gc_frame_end(callframe1139);
// compiled call node returning call1140 (depth = 7)
// compiled member node returning call1140 (depth = 6)
  partcv[0] = 0;
  Object call1141 = callmethod(call1140, "new",
    1, partcv, params);
  gc_frame_end(callframe1138);
// compiled call node returning call1141 (depth = 5)
// compiled member node returning call1141 (depth = 4)
  gc_frame_newslot(call1141);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call1141;
  partcv[0] = 1;
  Object call1142 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1137);
// compiled call node returning call1142 (depth = 3)
    gc_frame_newslot(call1142);
    if1089 = call1142;
  } else {
  }
// compiled if node returning if1089 (depth = 2)
  gc_frame_end(frame);
  return if1089;
}
Object meth_parser_dotypeterm1143(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotypeterm (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dotypeterm");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1145 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1146 == NULL) {
    strlit1146 = alloc_String("identifier");
    gc_root(strlit1146);
  }
// compiled string node returning strlit1146 (depth = 4)
  gc_frame_newslot(strlit1146);
// call case 4: self request
  params[0] = strlit1146;
  partcv[0] = 1;
  Object call1147 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1145);
// compiled call node returning call1147 (depth = 3)
  Object if1144 = done;
  if (istrue(call1147)) {
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1149 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1148);
// compiled call node returning call1149 (depth = 4)
// compiled member node returning call1149 (depth = 3)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1151 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1150);
// compiled call node returning call1151 (depth = 4)
// compiled member node returning call1151 (depth = 3)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1152 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1153 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1152);
// compiled call node returning call1153 (depth = 3)
    gc_frame_newslot(call1153);
    if1144 = call1153;
  } else {
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1155 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1156 == NULL) {
    strlit1156 = alloc_String("type");
    gc_root(strlit1156);
  }
// compiled string node returning strlit1156 (depth = 5)
  gc_frame_newslot(strlit1156);
// call case 4: self request
  params[0] = strlit1156;
  partcv[0] = 1;
  Object call1157 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1155);
// compiled call node returning call1157 (depth = 4)
  Object if1154 = done;
  if (istrue(call1157)) {
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1159 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1158);
// compiled call node returning call1159 (depth = 5)
// compiled member node returning call1159 (depth = 4)
    gc_frame_newslot(call1159);
    if1154 = call1159;
  } else {
  }
// compiled if node returning if1154 (depth = 3)
    gc_frame_newslot(if1154);
    if1144 = if1154;
  }
// compiled if node returning if1144 (depth = 2)
  gc_frame_end(frame);
  return if1144;
}
Object meth_parser__apply1174(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1176 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1175);
// compiled call node returning call1176 (depth = 9)
// compiled member node returning call1176 (depth = 8)
  gc_frame_end(frame);
  return call1176;
}
Object meth_parser_typeexpression1160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeexpression (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeexpression");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call1162 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1161);
// compiled call node returning call1162 (depth = 4)
// compiled member node returning call1162 (depth = 3)
  *var_sz = call1162;
  if (call1162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1164 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1165 == NULL) {
    strlit1165 = alloc_String("lparen");
    gc_root(strlit1165);
  }
// compiled string node returning strlit1165 (depth = 4)
  gc_frame_newslot(strlit1165);
// call case 4: self request
  params[0] = strlit1165;
  partcv[0] = 1;
  Object call1166 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled call node returning call1166 (depth = 3)
  Object if1163 = done;
  if (istrue(call1166)) {
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1169 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1168);
// compiled call node returning call1169 (depth = 4)
// compiled member node returning call1169 (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1171 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1172 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1173 = alloc_Block(NULL, NULL, "parser", 404);
  gc_frame_newslot(block1173);
// method "_apply"
  block_savedest(block1173);
  Object closure1174 = createclosure(1, "_apply");
  setclosureframe(closure1174, stackframe);
  addtoclosure(closure1174, selfslot);
  struct UserObject *uo1174 = (struct UserObject*)block1173;
  uo1174->data[0] = (Object)closure1174;
  Method *meth_meth_parser__apply1174 = addmethod2pos(block1173, "_apply", &meth_parser__apply1174, 0);
  int argcv_meth_parser__apply1174[] = {0};
  meth_meth_parser__apply1174->type = alloc_MethodType(1, argcv_meth_parser__apply1174);
  meth_meth_parser__apply1174->definitionModule = modulename;
  meth_meth_parser__apply1174->definitionLine = 404;
// compiled block node returning block1173 (depth = 7)
  gc_frame_newslot(block1173);
// call case 4: self request
  params[0] = block1173;
  partcv[0] = 1;
  Object call1178 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1172);
// compiled call node returning call1178 (depth = 6)
  partcv[0] = 0;
  Object call1179 = callmethod(call1178, "not",
    1, partcv, params);
  gc_frame_end(callframe1171);
// compiled call node returning call1179 (depth = 5)
// compiled member node returning call1179 (depth = 4)
  Object if1170 = done;
  if (istrue(call1179)) {
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1180 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1181 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1182 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1181);
// compiled call node returning call1182 (depth = 8)
// compiled member node returning call1182 (depth = 7)
  partcv[0] = 0;
  Object call1183 = callmethod(call1182, "new",
    1, partcv, params);
  gc_frame_end(callframe1180);
// compiled call node returning call1183 (depth = 6)
// compiled member node returning call1183 (depth = 5)
  *var_suggestion = call1183;
  if (call1183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1184 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array1185 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit1186 == NULL) {
    strlit1186 = alloc_String("rparen");
    gc_root(strlit1186);
  }
// compiled string node returning strlit1186 (depth = 7)
  params[0] = strlit1186;
  partcv[0] = 1;
  callmethod(array1185, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array1185 (depth = 6)
  gc_frame_newslot(array1185);
// call case 4: self request
  params[0] = array1185;
  partcv[0] = 1;
  Object call1187 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1184);
// compiled call node returning call1187 (depth = 5)
  *var_nextTok = call1187;
  if (call1187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_1189 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1189 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1191 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1191 (depth = 5)
  Object if1188 = done;
  if (istrue(opresult1191)) {
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1192 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1193 == NULL) {
    strlit1193 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1193);
  }
// compiled string node returning strlit1193 (depth = 6)
  gc_frame_newslot(strlit1193);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1193;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1194 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1192);
// compiled call node returning call1194 (depth = 5)
    gc_frame_newslot(call1194);
    if1188 = call1194;
  } else {
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1195 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1197 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1196);
// compiled call node returning call1197 (depth = 7)
// compiled member node returning call1197 (depth = 6)
  gc_frame_newslot(call1197);
// starting to compile identifier node (depth = 6)
  Object bool1198 = alloc_Boolean(1);
// compiled identifier node returning bool1198 (depth = 6)
  gc_frame_newslot(bool1198);
// starting to compile identifier node (depth = 6)
  Object bool1199 = alloc_Boolean(0);
// compiled identifier node returning bool1199 (depth = 6)
  gc_frame_newslot(bool1199);
// starting to compile string node (depth = 6)
  if (strlit1200 == NULL) {
    strlit1200 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1200);
  }
// compiled string node returning strlit1200 (depth = 6)
  gc_frame_newslot(strlit1200);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call1197;
  params[2] = bool1198;
  params[3] = bool1199;
  params[4] = strlit1200;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1201 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1195);
// compiled call node returning call1201 (depth = 5)
    gc_frame_newslot(call1201);
    if1188 = call1201;
  }
// compiled if node returning if1188 (depth = 4)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1202 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1203 == NULL) {
    strlit1203 = alloc_String("parentheses must contain a valid type expression.");
    gc_root(strlit1203);
  }
// compiled string node returning strlit1203 (depth = 5)
  gc_frame_newslot(strlit1203);
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1205 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1204);
// compiled call node returning call1205 (depth = 6)
// compiled member node returning call1205 (depth = 5)
  gc_frame_newslot(call1205);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1207 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1206);
// compiled call node returning call1207 (depth = 6)
// compiled member node returning call1207 (depth = 5)
  gc_frame_newslot(call1207);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1203;
  params[1] = call1205;
  params[2] = call1207;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1208 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1202);
// compiled call node returning call1208 (depth = 4)
    gc_frame_newslot(call1208);
    if1170 = call1208;
  } else {
  }
// compiled if node returning if1170 (depth = 3)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1211 == NULL) {
    strlit1211 = alloc_String("rparen");
    gc_root(strlit1211);
  }
// compiled string node returning strlit1211 (depth = 5)
  int op_slot_right_1210 = gc_frame_newslot(strlit1211);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1214 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1213);
// compiled call node returning call1214 (depth = 6)
// compiled member node returning call1214 (depth = 5)
  int op_slot_left_1210 = gc_frame_newslot(call1214);
  params[0] = strlit1211;
  partcv[0] = 1;
  Object opresult1215 = callmethod(call1214, "!=", 1, partcv, params);
// compiled op node returning opresult1215 (depth = 4)
  Object if1209 = done;
  if (istrue(opresult1215)) {
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1217 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1216);
// compiled call node returning call1217 (depth = 5)
// compiled member node returning call1217 (depth = 4)
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1218 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1220 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1219);
// compiled call node returning call1220 (depth = 8)
// compiled member node returning call1220 (depth = 7)
  partcv[0] = 0;
  Object call1221 = callmethod(call1220, "new",
    1, partcv, params);
  gc_frame_end(callframe1218);
// compiled call node returning call1221 (depth = 6)
// compiled member node returning call1221 (depth = 5)
  *var_suggestion = call1221;
  if (call1221 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1222 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1223 == NULL) {
    strlit1223 = alloc_String(")");
    gc_root(strlit1223);
  }
// compiled string node returning strlit1223 (depth = 5)
  gc_frame_newslot(strlit1223);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1223;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1224 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1222);
// compiled call node returning call1224 (depth = 4)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1225 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1226 == NULL) {
    strlit1226 = alloc_String("a type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1226);
  }
// compiled string node returning strlit1226 (depth = 5)
  gc_frame_newslot(strlit1226);
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1228 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1227);
// compiled call node returning call1228 (depth = 6)
// compiled member node returning call1228 (depth = 5)
  gc_frame_newslot(call1228);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1231 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1230);
// compiled call node returning call1231 (depth = 7)
// compiled member node returning call1231 (depth = 6)
  int op_slot_right_1229 = gc_frame_newslot(call1231);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1233 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1234 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1233);
// compiled call node returning call1234 (depth = 7)
// compiled member node returning call1234 (depth = 6)
  int op_slot_left_1229 = gc_frame_newslot(call1234);
  params[0] = call1231;
  partcv[0] = 1;
  Object sum1235 = callmethod(call1234, "+", 1, partcv, params);
// compiled op node returning sum1235 (depth = 5)
  gc_frame_newslot(sum1235);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1226;
  params[1] = call1228;
  params[2] = sum1235;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1236 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1225);
// compiled call node returning call1236 (depth = 4)
    gc_frame_newslot(call1236);
    if1209 = call1236;
  } else {
  }
// compiled if node returning if1209 (depth = 3)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1239 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compiled call node returning call1239 (depth = 4)
// compiled member node returning call1239 (depth = 3)
    gc_frame_newslot(call1239);
    if1163 = call1239;
  } else {
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1241 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1240);
// compiled call node returning call1241 (depth = 4)
// compiled member node returning call1241 (depth = 3)
    gc_frame_newslot(call1241);
    if1163 = call1241;
  }
// compiled if node returning if1163 (depth = 2)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1243 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1246 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1245);
// compiled call node returning call1246 (depth = 5)
// compiled member node returning call1246 (depth = 4)
  int op_slot_left_1243 = gc_frame_newslot(call1246);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1247 = callmethod(call1246, ">", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 3)
  Object if1242 = done;
  if (istrue(opresult1247)) {
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1248 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1249 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1248);
// compiled call node returning call1249 (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1251 = callmethodflags(self, "typeexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1250);
// compiled call node returning call1251 (depth = 4)
// compiled member node returning call1251 (depth = 3)
    gc_frame_newslot(call1251);
    if1242 = call1251;
  } else {
  }
// compiled if node returning if1242 (depth = 2)
  gc_frame_end(frame);
  return if1242;
}
Object meth_parser_newIf1252(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method newIf");
  Object params[3];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for newIf");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1253 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  gc_frame_newslot(*var_emptySequence);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1255 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1254);
// compiled call node returning call1255 (depth = 5)
// compiled member node returning call1255 (depth = 4)
  params[0] = *var_emptySequence;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1256 = callmethod(call1255, "new",
    1, partcv, params);
  gc_frame_end(callframe1253);
// compiled call node returning call1256 (depth = 3)
  *var_thenBlock = call1256;
  if (call1256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1257 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  gc_frame_newslot(*var_emptySequence);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1258 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1259 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1258);
// compiled call node returning call1259 (depth = 5)
// compiled member node returning call1259 (depth = 4)
  params[0] = *var_emptySequence;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1260 = callmethod(call1259, "new",
    1, partcv, params);
  gc_frame_end(callframe1257);
// compiled call node returning call1260 (depth = 3)
  *var_elseBlock = call1260;
  if (call1260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1261 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1262 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call1263 = callmethod(*var_ast, "ifNode",
    1, partcv, params);
  gc_frame_end(callframe1262);
// compiled call node returning call1263 (depth = 4)
// compiled member node returning call1263 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1264 = callmethod(call1263, "new",
    1, partcv, params);
  gc_frame_end(callframe1261);
// compiled call node returning call1264 (depth = 2)
  gc_frame_end(frame);
  return call1264;
}
Object meth_parser__apply1300(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe1301 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1302 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1301);
// compiled call node returning call1302 (depth = 5)
  gc_frame_end(frame);
  return call1302;
}
Object meth_parser__apply1337(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe1338 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1339 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1338);
// compiled call node returning call1339 (depth = 12)
  gc_frame_end(frame);
  return call1339;
}
Object meth_parser__apply1416(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe1417 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1418 == NULL) {
    strlit1418 = alloc_String("comma");
    gc_root(strlit1418);
  }
// compiled string node returning strlit1418 (depth = 10)
  gc_frame_newslot(strlit1418);
// call case 4: self request
  params[0] = strlit1418;
  partcv[0] = 1;
  Object call1419 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1417);
// compiled call node returning call1419 (depth = 9)
  gc_frame_end(frame);
  return call1419;
}
Object meth_parser__apply1429(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1431 == NULL) {
    strlit1431 = alloc_String("arrow");
    gc_root(strlit1431);
  }
// compiled string node returning strlit1431 (depth = 11)
  int op_slot_right_1430 = gc_frame_newslot(strlit1431);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1434 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1433);
// compiled call node returning call1434 (depth = 12)
// compiled member node returning call1434 (depth = 11)
  int op_slot_left_1430 = gc_frame_newslot(call1434);
  params[0] = strlit1431;
  partcv[0] = 1;
  Object opresult1435 = callmethod(call1434, "==", 1, partcv, params);
// compiled op node returning opresult1435 (depth = 10)
  gc_frame_end(frame);
  return opresult1435;
}
Object meth_parser__apply1477(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1478 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1479 == NULL) {
    strlit1479 = alloc_String("comma");
    gc_root(strlit1479);
  }
// compiled string node returning strlit1479 (depth = 9)
  gc_frame_newslot(strlit1479);
// call case 4: self request
  params[0] = strlit1479;
  partcv[0] = 1;
  Object call1480 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1478);
// compiled call node returning call1480 (depth = 8)
  gc_frame_end(frame);
  return call1480;
}
Object meth_parser__apply1483(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1485 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1484);
// compiled call node returning call1485 (depth = 9)
// compiled member node returning call1485 (depth = 8)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1487 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1486);
// compiled call node returning call1487 (depth = 9)
// compiled member node returning call1487 (depth = 8)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1489 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1488);
// compiled call node returning call1489 (depth = 10)
// compiled member node returning call1489 (depth = 9)
  *var_expr1 = call1489;
  if (call1489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1491 = gc_frame_new();
// starting to compile identifier node (depth = 9)
  Object bool1492 = alloc_Boolean(1);
// compiled identifier node returning bool1492 (depth = 9)
  gc_frame_newslot(bool1492);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = bool1492;
  partcv[0] = 1;
  Object call1493 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1491);
// compiled call node returning call1493 (depth = 8)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1494 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1495 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1496 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1495);
// compiled call node returning call1496 (depth = 10)
// compiled member node returning call1496 (depth = 9)
  gc_frame_newslot(call1496);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = call1496;
  partcv[0] = 1;
  Object call1497 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1494);
// compiled call node returning call1497 (depth = 8)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1498 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1499 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1498);
// compiled call node returning call1499 (depth = 8)
  gc_frame_end(frame);
  return call1499;
}
Object meth_parser__apply1614(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 13)
  int callframe1615 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_blocksOK (depth = 14)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1616 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1615);
// compiled call node returning call1616 (depth = 13)
  gc_frame_end(frame);
  return call1616;
}
Object meth_parser__apply1305(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_braceIsType = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_params = getfromclosure(closure, 7);
  Object *var_isMatchingBlock = getfromclosure(closure, 8);
  Object *var_body = getfromclosure(closure, 9);
  Object *var_indentFreePass = getfromclosure(closure, 10);
  Object *var_btok = getfromclosure(closure, 11);
  Object *var_util = getfromclosure(closure, 12);
  Object *var_ast = getfromclosure(closure, 13);
  Object self = *(getfromclosure(closure, 14));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arrow = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arrow");
  Object *var_lhs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lhs");
  Object *var_rhs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rhs");
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1308 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1309 == NULL) {
    strlit1309 = alloc_String("colon");
    gc_root(strlit1309);
  }
// compiled string node returning strlit1309 (depth = 8)
  gc_frame_newslot(strlit1309);
// call case 4: self request
  params[0] = strlit1309;
  partcv[0] = 1;
  Object call1310 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1308);
// compiled call node returning call1310 (depth = 7)
  int op_slot_right_1307 = gc_frame_newslot(call1310);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1313 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1314 == NULL) {
    strlit1314 = alloc_String("arrow");
    gc_root(strlit1314);
  }
// compiled string node returning strlit1314 (depth = 9)
  gc_frame_newslot(strlit1314);
// call case 4: self request
  params[0] = strlit1314;
  partcv[0] = 1;
  Object call1315 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1313);
// compiled call node returning call1315 (depth = 8)
  int op_slot_right_1312 = gc_frame_newslot(call1315);
// starting to compile call node (depth = 8)
  int callframe1317 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1318 == NULL) {
    strlit1318 = alloc_String("comma");
    gc_root(strlit1318);
  }
// compiled string node returning strlit1318 (depth = 9)
  gc_frame_newslot(strlit1318);
// call case 4: self request
  params[0] = strlit1318;
  partcv[0] = 1;
  Object call1319 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1317);
// compiled call node returning call1319 (depth = 8)
  int op_slot_left_1312 = gc_frame_newslot(call1319);
  params[0] = call1315;
  partcv[0] = 1;
  Object opresult1320 = callmethod(call1319, "||", 1, partcv, params);
// compiled op node returning opresult1320 (depth = 7)
  int op_slot_left_1307 = gc_frame_newslot(opresult1320);
  params[0] = call1310;
  partcv[0] = 1;
  Object opresult1321 = callmethod(opresult1320, "||", 1, partcv, params);
// compiled op node returning opresult1321 (depth = 6)
  Object if1306 = done;
  if (istrue(opresult1321)) {
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1322 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call1323 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1322);
// compiled call node returning call1323 (depth = 8)
// compiled member node returning call1323 (depth = 7)
  *var_expr1 = call1323;
  if (call1323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1326 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1327 == NULL) {
    strlit1327 = alloc_String("colon");
    gc_root(strlit1327);
  }
// compiled string node returning strlit1327 (depth = 8)
  gc_frame_newslot(strlit1327);
// call case 4: self request
  params[0] = strlit1327;
  partcv[0] = 1;
  Object call1328 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1326);
// compiled call node returning call1328 (depth = 7)
  Object if1325 = done;
  if (istrue(call1328)) {
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1329 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1330 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1329);
// compiled call node returning call1330 (depth = 8)
// compiled member node returning call1330 (depth = 7)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1331 = alloc_Boolean(1);
// compiled identifier node returning bool1331 (depth = 8)
  *var_braceIsType = bool1331;
  if (bool1331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1334 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe1335 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block1336 = alloc_Block(NULL, NULL, "parser", 472);
  gc_frame_newslot(block1336);
// method "_apply"
  block_savedest(block1336);
  Object closure1337 = createclosure(2, "_apply");
  setclosureframe(closure1337, stackframe);
  addtoclosure(closure1337, var_blocksOK);
  addtoclosure(closure1337, selfslot);
  struct UserObject *uo1337 = (struct UserObject*)block1336;
  uo1337->data[0] = (Object)closure1337;
  Method *meth_meth_parser__apply1337 = addmethod2pos(block1336, "_apply", &meth_parser__apply1337, 0);
  int argcv_meth_parser__apply1337[] = {0};
  meth_meth_parser__apply1337->type = alloc_MethodType(1, argcv_meth_parser__apply1337);
  meth_meth_parser__apply1337->definitionModule = modulename;
  meth_meth_parser__apply1337->definitionLine = 472;
// compiled block node returning block1336 (depth = 11)
  gc_frame_newslot(block1336);
// call case 4: self request
  params[0] = block1336;
  partcv[0] = 1;
  Object call1341 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1335);
// compiled call node returning call1341 (depth = 10)
  partcv[0] = 0;
  Object call1342 = callmethod(call1341, "not",
    1, partcv, params);
  gc_frame_end(callframe1334);
// compiled call node returning call1342 (depth = 9)
// compiled member node returning call1342 (depth = 8)
  Object if1333 = done;
  if (istrue(call1342)) {
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1343 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1344 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1345 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1344);
// compiled call node returning call1345 (depth = 12)
// compiled member node returning call1345 (depth = 11)
  partcv[0] = 0;
  Object call1346 = callmethod(call1345, "empty",
    1, partcv, params);
  gc_frame_end(callframe1343);
// compiled call node returning call1346 (depth = 10)
// compiled member node returning call1346 (depth = 9)
  *var_suggestions = call1346;
  if (call1346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1347 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1349 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1348);
// compiled call node returning call1349 (depth = 12)
// compiled member node returning call1349 (depth = 11)
  partcv[0] = 0;
  Object call1350 = callmethod(call1349, "new",
    1, partcv, params);
  gc_frame_end(callframe1347);
// compiled call node returning call1350 (depth = 10)
// compiled member node returning call1350 (depth = 9)
  *var_suggestion = call1350;
  if (call1350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1351 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array1352 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit1353 == NULL) {
    strlit1353 = alloc_String("arrow");
    gc_root(strlit1353);
  }
// compiled string node returning strlit1353 (depth = 11)
  params[0] = strlit1353;
  partcv[0] = 1;
  callmethod(array1352, "push", 1, partcv, params);
// starting to compile string node (depth = 11)
  if (strlit1354 == NULL) {
    strlit1354 = alloc_String("rbrace");
    gc_root(strlit1354);
  }
// compiled string node returning strlit1354 (depth = 11)
  params[0] = strlit1354;
  partcv[0] = 1;
  callmethod(array1352, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array1352 (depth = 10)
  gc_frame_newslot(array1352);
// call case 4: self request
  params[0] = array1352;
  partcv[0] = 1;
  Object call1355 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1351);
// compiled call node returning call1355 (depth = 9)
  *var_nextTok = call1355;
  if (call1355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1357 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1357 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1359 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1359 (depth = 9)
  Object if1356 = done;
  if (istrue(opresult1359)) {
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1360 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1361 == NULL) {
    strlit1361 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1361);
  }
// compiled string node returning strlit1361 (depth = 10)
  gc_frame_newslot(strlit1361);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1361;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1362 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1360);
// compiled call node returning call1362 (depth = 9)
    gc_frame_newslot(call1362);
    if1356 = call1362;
  } else {
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1363 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1364 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1365 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1364);
// compiled call node returning call1365 (depth = 11)
// compiled member node returning call1365 (depth = 10)
  gc_frame_newslot(call1365);
// starting to compile identifier node (depth = 10)
  Object bool1366 = alloc_Boolean(1);
// compiled identifier node returning bool1366 (depth = 10)
  gc_frame_newslot(bool1366);
// starting to compile identifier node (depth = 10)
  Object bool1367 = alloc_Boolean(0);
// compiled identifier node returning bool1367 (depth = 10)
  gc_frame_newslot(bool1367);
// starting to compile string node (depth = 10)
  if (strlit1368 == NULL) {
    strlit1368 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1368);
  }
// compiled string node returning strlit1368 (depth = 10)
  gc_frame_newslot(strlit1368);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call1365;
  params[2] = bool1366;
  params[3] = bool1367;
  params[4] = strlit1368;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1369 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1363);
// compiled call node returning call1369 (depth = 9)
    gc_frame_newslot(call1369);
    if1356 = call1369;
  }
// compiled if node returning if1356 (depth = 8)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1370 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1371 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1370);
// compiled call node returning call1371 (depth = 8)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1372 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1373 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1374 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1373);
// compiled call node returning call1374 (depth = 12)
// compiled member node returning call1374 (depth = 11)
  partcv[0] = 0;
  Object call1375 = callmethod(call1374, "new",
    1, partcv, params);
  gc_frame_end(callframe1372);
// compiled call node returning call1375 (depth = 10)
// compiled member node returning call1375 (depth = 9)
  *var_suggestion = call1375;
  if (call1375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1377 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1378 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1379 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1378);
// compiled call node returning call1379 (depth = 10)
// compiled member node returning call1379 (depth = 9)
  gc_frame_newslot(call1379);
// starting to compile identifier node (depth = 9)
  Object bool1380 = alloc_Boolean(1);
// compiled identifier node returning bool1380 (depth = 9)
  gc_frame_newslot(bool1380);
// starting to compile identifier node (depth = 9)
  Object bool1381 = alloc_Boolean(0);
// compiled identifier node returning bool1381 (depth = 9)
  gc_frame_newslot(bool1381);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call1379;
  params[2] = bool1380;
  params[3] = bool1381;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1382 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1377);
// compiled call node returning call1382 (depth = 8)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1383 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1384 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1383);
// compiled call node returning call1384 (depth = 8)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1385 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1386 == NULL) {
    strlit1386 = alloc_String("a block must have an expression after the ':'.");
    gc_root(strlit1386);
  }
// compiled string node returning strlit1386 (depth = 9)
  gc_frame_newslot(strlit1386);
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1387 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1388 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1387);
// compiled call node returning call1388 (depth = 10)
// compiled member node returning call1388 (depth = 9)
  gc_frame_newslot(call1388);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1390 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1389);
// compiled call node returning call1390 (depth = 10)
// compiled member node returning call1390 (depth = 9)
  gc_frame_newslot(call1390);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit1386;
  params[1] = call1388;
  params[2] = call1390;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1391 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1385);
// compiled call node returning call1391 (depth = 8)
    gc_frame_newslot(call1391);
    if1333 = call1391;
  } else {
  }
// compiled if node returning if1333 (depth = 7)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1392 = alloc_Boolean(0);
// compiled identifier node returning bool1392 (depth = 8)
  *var_braceIsType = bool1392;
  if (bool1392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1394 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call1396 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1395);
// compiled call node returning call1396 (depth = 9)
// compiled member node returning call1396 (depth = 8)
  gc_frame_newslot(call1396);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr1 (depth = 8)
  params[0] = call1396;
  partcv[0] = 1;
  Object call1397 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1394);
// compiled call node returning call1397 (depth = 7)
    gc_frame_newslot(call1397);
    if1325 = call1397;
  } else {
  }
// compiled if node returning if1325 (depth = 6)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1398 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr1 (depth = 7)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1399 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1398);
// compiled call node returning call1399 (depth = 6)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  partcv[0] = 0;
  Object call1403 = callmethod(*var_expr1, "isIdentifier",
    1, partcv, params);
  gc_frame_end(callframe1402);
// compiled call node returning call1403 (depth = 9)
// compiled member node returning call1403 (depth = 8)
  int op_slot_right_1401 = gc_frame_newslot(call1403);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_isMatchingBlock (depth = 10)
  partcv[0] = 0;
  Object call1406 = callmethod(*var_isMatchingBlock, "not",
    1, partcv, params);
  gc_frame_end(callframe1405);
// compiled call node returning call1406 (depth = 9)
// compiled member node returning call1406 (depth = 8)
  int op_slot_left_1401 = gc_frame_newslot(call1406);
  params[0] = call1403;
  partcv[0] = 1;
  Object opresult1407 = callmethod(call1406, "&&", 1, partcv, params);
// compiled op node returning opresult1407 (depth = 7)
  Object if1400 = done;
  if (istrue(opresult1407)) {
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1408 = gc_frame_new();
// starting to compile identifier node (depth = 8)
  Object bool1409 = alloc_Boolean(1);
// compiled identifier node returning bool1409 (depth = 8)
  gc_frame_newslot(bool1409);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr1 (depth = 8)
  params[0] = bool1409;
  partcv[0] = 1;
  Object call1410 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1408);
// compiled call node returning call1410 (depth = 7)
    gc_frame_newslot(call1410);
    if1400 = call1410;
  } else {
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1411 = alloc_Boolean(1);
// compiled identifier node returning bool1411 (depth = 8)
  *var_isMatchingBlock = bool1411;
  if (bool1411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1400 = done;
  }
// compiled if node returning if1400 (depth = 6)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1415 = alloc_Block(NULL, NULL, "parser", 497);
  gc_frame_newslot(block1415);
// method "_apply"
  block_savedest(block1415);
  Object closure1416 = createclosure(1, "_apply");
  setclosureframe(closure1416, stackframe);
  addtoclosure(closure1416, selfslot);
  struct UserObject *uo1416 = (struct UserObject*)block1415;
  uo1416->data[0] = (Object)closure1416;
  Method *meth_meth_parser__apply1416 = addmethod2pos(block1415, "_apply", &meth_parser__apply1416, 0);
  int argcv_meth_parser__apply1416[] = {0};
  meth_meth_parser__apply1416->type = alloc_MethodType(1, argcv_meth_parser__apply1416);
  meth_meth_parser__apply1416->definitionModule = modulename;
  meth_meth_parser__apply1416->definitionLine = 492;
// compiled block node returning block1415 (depth = 8)
  int op_slot_right_1414 = gc_frame_newslot(block1415);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isMatchingBlock (depth = 8)
  int op_slot_left_1414 = gc_frame_newslot(*var_isMatchingBlock);
  params[0] = block1415;
  partcv[0] = 1;
  Object opresult1422 = callmethod(*var_isMatchingBlock, "&&", 1, partcv, params);
// compiled op node returning opresult1422 (depth = 7)
  Object if1413 = done;
  if (istrue(opresult1422)) {
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1423 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1424 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1425 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1424);
// compiled call node returning call1425 (depth = 11)
// compiled member node returning call1425 (depth = 10)
  partcv[0] = 0;
  Object call1426 = callmethod(call1425, "empty",
    1, partcv, params);
  gc_frame_end(callframe1423);
// compiled call node returning call1426 (depth = 9)
// compiled member node returning call1426 (depth = 8)
  *var_suggestions = call1426;
  if (call1426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 7)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1427 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1428 = alloc_Block(NULL, NULL, "parser", 500);
  gc_frame_newslot(block1428);
// method "_apply"
  block_savedest(block1428);
  Object closure1429 = createclosure(1, "_apply");
  setclosureframe(closure1429, stackframe);
  addtoclosure(closure1429, selfslot);
  struct UserObject *uo1429 = (struct UserObject*)block1428;
  uo1429->data[0] = (Object)closure1429;
  Method *meth_meth_parser__apply1429 = addmethod2pos(block1428, "_apply", &meth_parser__apply1429, 0);
  int argcv_meth_parser__apply1429[] = {1};
  meth_meth_parser__apply1429->type = alloc_MethodType(1, argcv_meth_parser__apply1429);
  meth_meth_parser__apply1429->definitionModule = modulename;
  meth_meth_parser__apply1429->definitionLine = 498;
// compiled block node returning block1428 (depth = 9)
  gc_frame_newslot(block1428);
// call case 4: self request
  params[0] = block1428;
  partcv[0] = 1;
  Object call1437 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1427);
// compiled call node returning call1437 (depth = 8)
  *var_arrow = call1437;
  if (call1437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1440 = alloc_Boolean(0);
// compiled identifier node returning bool1440 (depth = 9)
  int op_slot_right_1439 = gc_frame_newslot(bool1440);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arrow (depth = 9)
  int op_slot_left_1439 = gc_frame_newslot(*var_arrow);
  params[0] = bool1440;
  partcv[0] = 1;
  Object opresult1442 = callmethod(*var_arrow, "!=", 1, partcv, params);
// compiled op node returning opresult1442 (depth = 8)
  Object if1438 = done;
  if (istrue(opresult1442)) {
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1443 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1445 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1444);
// compiled call node returning call1445 (depth = 12)
// compiled member node returning call1445 (depth = 11)
  partcv[0] = 0;
  Object call1446 = callmethod(call1445, "new",
    1, partcv, params);
  gc_frame_end(callframe1443);
// compiled call node returning call1446 (depth = 10)
// compiled member node returning call1446 (depth = 9)
  *var_suggestion = call1446;
  if (call1446 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1448 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arrow (depth = 11)
  partcv[0] = 0;
  Object call1450 = callmethod(*var_arrow, "prev",
    1, partcv, params);
  gc_frame_end(callframe1449);
// compiled call node returning call1450 (depth = 10)
// compiled member node returning call1450 (depth = 9)
  gc_frame_newslot(call1450);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call1450;
  partcv[0] = 2;
  Object call1451 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe1448);
// compiled call node returning call1451 (depth = 8)
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1452 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1453 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1452);
// compiled call node returning call1453 (depth = 8)
    gc_frame_newslot(call1453);
    if1438 = call1453;
  } else {
  }
// compiled if node returning if1438 (depth = 7)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1454 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1456 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1455);
// compiled call node returning call1456 (depth = 11)
// compiled member node returning call1456 (depth = 10)
  partcv[0] = 0;
  Object call1457 = callmethod(call1456, "new",
    1, partcv, params);
  gc_frame_end(callframe1454);
// compiled call node returning call1457 (depth = 9)
// compiled member node returning call1457 (depth = 8)
  *var_suggestion = call1457;
  if (call1457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1459 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool1460 = alloc_Boolean(1);
// compiled identifier node returning bool1460 (depth = 8)
  gc_frame_newslot(bool1460);
// starting to compile identifier node (depth = 8)
  Object bool1461 = alloc_Boolean(0);
// compiled identifier node returning bool1461 (depth = 8)
  gc_frame_newslot(bool1461);
// starting to compile string node (depth = 8)
  if (strlit1462 == NULL) {
    strlit1462 = alloc_String(" |");
    gc_root(strlit1462);
  }
// compiled string node returning strlit1462 (depth = 8)
  gc_frame_newslot(strlit1462);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool1460;
  params[2] = bool1461;
  params[3] = strlit1462;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1463 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1459);
// compiled call node returning call1463 (depth = 7)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1464 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1465 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1464);
// compiled call node returning call1465 (depth = 7)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1466 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1467 == NULL) {
    strlit1467 = alloc_String("a matching block may only have one parameter.");
    gc_root(strlit1467);
  }
// compiled string node returning strlit1467 (depth = 8)
  gc_frame_newslot(strlit1467);
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1469 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1469 (depth = 9)
// compiled member node returning call1469 (depth = 8)
  gc_frame_newslot(call1469);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1471 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1470);
// compiled call node returning call1471 (depth = 9)
// compiled member node returning call1471 (depth = 8)
  gc_frame_newslot(call1471);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1472 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1473 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1472);
// compiled call node returning call1473 (depth = 9)
// compiled member node returning call1473 (depth = 8)
  gc_frame_newslot(call1473);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1467;
  params[1] = call1469;
  params[2] = call1471;
  params[3] = call1473;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1474 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1466);
// compiled call node returning call1474 (depth = 7)
    gc_frame_newslot(call1474);
    if1413 = call1474;
  } else {
  }
// compiled if node returning if1413 (depth = 6)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1475 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1476 = alloc_Block(NULL, NULL, "parser", 512);
  gc_frame_newslot(block1476);
// method "_apply"
  block_savedest(block1476);
  Object closure1477 = createclosure(1, "_apply");
  setclosureframe(closure1477, stackframe);
  addtoclosure(closure1477, selfslot);
  struct UserObject *uo1477 = (struct UserObject*)block1476;
  uo1477->data[0] = (Object)closure1477;
  Method *meth_meth_parser__apply1477 = addmethod2pos(block1476, "_apply", &meth_parser__apply1477, 0);
  int argcv_meth_parser__apply1477[] = {0};
  meth_meth_parser__apply1477->type = alloc_MethodType(1, argcv_meth_parser__apply1477);
  meth_meth_parser__apply1477->definitionModule = modulename;
  meth_meth_parser__apply1477->definitionLine = 510;
// compiled block node returning block1476 (depth = 7)
  gc_frame_newslot(block1476);
// starting to compile block node (depth = 7)
  Object block1482 = alloc_Block(NULL, NULL, "parser", 512);
  gc_frame_newslot(block1482);
// method "_apply"
  block_savedest(block1482);
  Object closure1483 = createclosure(4, "_apply");
  setclosureframe(closure1483, stackframe);
  addtoclosure(closure1483, var_values);
  addtoclosure(closure1483, var_expr1);
  addtoclosure(closure1483, var_params);
  addtoclosure(closure1483, selfslot);
  struct UserObject *uo1483 = (struct UserObject*)block1482;
  uo1483->data[0] = (Object)closure1483;
  Method *meth_meth_parser__apply1483 = addmethod2pos(block1482, "_apply", &meth_parser__apply1483, 0);
  int argcv_meth_parser__apply1483[] = {0};
  meth_meth_parser__apply1483->type = alloc_MethodType(1, argcv_meth_parser__apply1483);
  meth_meth_parser__apply1483->definitionModule = modulename;
  meth_meth_parser__apply1483->definitionLine = 510;
// compiled block node returning block1482 (depth = 7)
  gc_frame_newslot(block1482);
// call case 5: prelude request
  params[0] = block1476;
  params[1] = block1482;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1501 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1475);
// compiled call node returning call1501 (depth = 6)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1503 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe1504 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1505 == NULL) {
    strlit1505 = alloc_String("arrow");
    gc_root(strlit1505);
  }
// compiled string node returning strlit1505 (depth = 10)
  gc_frame_newslot(strlit1505);
// call case 4: self request
  params[0] = strlit1505;
  partcv[0] = 1;
  Object call1506 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1504);
// compiled call node returning call1506 (depth = 9)
  partcv[0] = 0;
  Object call1507 = callmethod(call1506, "not",
    1, partcv, params);
  gc_frame_end(callframe1503);
// compiled call node returning call1507 (depth = 8)
// compiled member node returning call1507 (depth = 7)
  Object if1502 = done;
  if (istrue(call1507)) {
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1508 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1509 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1510 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1509);
// compiled call node returning call1510 (depth = 11)
// compiled member node returning call1510 (depth = 10)
  partcv[0] = 0;
  Object call1511 = callmethod(call1510, "new",
    1, partcv, params);
  gc_frame_end(callframe1508);
// compiled call node returning call1511 (depth = 9)
// compiled member node returning call1511 (depth = 8)
  *var_suggestion = call1511;
  if (call1511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1515 == NULL) {
    strlit1515 = alloc_String("=");
    gc_root(strlit1515);
  }
// compiled string node returning strlit1515 (depth = 10)
  int op_slot_right_1514 = gc_frame_newslot(strlit1515);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1517 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1518 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1517);
// compiled call node returning call1518 (depth = 11)
// compiled member node returning call1518 (depth = 10)
  int op_slot_left_1514 = gc_frame_newslot(call1518);
  params[0] = strlit1515;
  partcv[0] = 1;
  Object opresult1519 = callmethod(call1518, "==", 1, partcv, params);
// compiled op node returning opresult1519 (depth = 9)
  int op_slot_right_1513 = gc_frame_newslot(opresult1519);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1522 == NULL) {
    strlit1522 = alloc_String("bind");
    gc_root(strlit1522);
  }
// compiled string node returning strlit1522 (depth = 10)
  int op_slot_right_1521 = gc_frame_newslot(strlit1522);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1525 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1524);
// compiled call node returning call1525 (depth = 11)
// compiled member node returning call1525 (depth = 10)
  int op_slot_left_1521 = gc_frame_newslot(call1525);
  params[0] = strlit1522;
  partcv[0] = 1;
  Object opresult1526 = callmethod(call1525, "==", 1, partcv, params);
// compiled op node returning opresult1526 (depth = 9)
  int op_slot_left_1513 = gc_frame_newslot(opresult1526);
  params[0] = opresult1519;
  partcv[0] = 1;
  Object opresult1527 = callmethod(opresult1526, "||", 1, partcv, params);
// compiled op node returning opresult1527 (depth = 8)
  Object if1512 = done;
  if (istrue(opresult1527)) {
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1528 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 9)
  if (strlit1529 == NULL) {
    strlit1529 = alloc_String("->");
    gc_root(strlit1529);
  }
// compiled string node returning strlit1529 (depth = 9)
  gc_frame_newslot(strlit1529);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = strlit1529;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1530 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe1528);
// compiled call node returning call1530 (depth = 8)
    gc_frame_newslot(call1530);
    if1512 = call1530;
  } else {
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1531 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1532 == NULL) {
    strlit1532 = alloc_String(" ->");
    gc_root(strlit1532);
  }
// compiled string node returning strlit1532 (depth = 9)
  gc_frame_newslot(strlit1532);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1532;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1533 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1531);
// compiled call node returning call1533 (depth = 8)
    gc_frame_newslot(call1533);
    if1512 = call1533;
  }
// compiled if node returning if1512 (depth = 7)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1534 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("a block must have one or more parameters followed by '->' and an expression.");
    gc_root(strlit1535);
  }
// compiled string node returning strlit1535 (depth = 8)
  gc_frame_newslot(strlit1535);
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1537 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1536);
// compiled call node returning call1537 (depth = 9)
// compiled member node returning call1537 (depth = 8)
  gc_frame_newslot(call1537);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1539 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1538);
// compiled call node returning call1539 (depth = 9)
// compiled member node returning call1539 (depth = 8)
  gc_frame_newslot(call1539);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1535;
  params[1] = call1537;
  params[2] = call1539;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1540 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1534);
// compiled call node returning call1540 (depth = 7)
    gc_frame_newslot(call1540);
    if1502 = call1540;
  } else {
  }
// compiled if node returning if1502 (depth = 6)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1541 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1542 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1541);
// compiled call node returning call1542 (depth = 7)
// compiled member node returning call1542 (depth = 6)
    gc_frame_newslot(call1542);
    if1306 = call1542;
  } else {
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1544 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1545 == NULL) {
    strlit1545 = alloc_String("semicolon");
    gc_root(strlit1545);
  }
// compiled string node returning strlit1545 (depth = 8)
  gc_frame_newslot(strlit1545);
// call case 4: self request
  params[0] = strlit1545;
  partcv[0] = 1;
  Object call1546 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1544);
// compiled call node returning call1546 (depth = 7)
  Object if1543 = done;
  if (istrue(call1546)) {
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1547 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call1549 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1548);
// compiled call node returning call1549 (depth = 9)
// compiled member node returning call1549 (depth = 8)
  gc_frame_newslot(call1549);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call1549;
  partcv[0] = 1;
  Object call1550 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1547);
// compiled call node returning call1550 (depth = 7)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1552 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1551);
// compiled call node returning call1552 (depth = 8)
// compiled member node returning call1552 (depth = 7)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1554 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1555 == NULL) {
    strlit1555 = alloc_String("semicolon");
    gc_root(strlit1555);
  }
// compiled string node returning strlit1555 (depth = 9)
  gc_frame_newslot(strlit1555);
// call case 4: self request
  params[0] = strlit1555;
  partcv[0] = 1;
  Object call1556 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1554);
// compiled call node returning call1556 (depth = 8)
  Object if1553 = done;
  if (istrue(call1556)) {
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1558 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1557);
// compiled call node returning call1558 (depth = 9)
// compiled member node returning call1558 (depth = 8)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call1562 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1561);
// compiled call node returning call1562 (depth = 11)
// compiled member node returning call1562 (depth = 10)
  int op_slot_right_1560 = gc_frame_newslot(call1562);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1564 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1565 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1564);
// compiled call node returning call1565 (depth = 11)
// compiled member node returning call1565 (depth = 10)
  int op_slot_left_1560 = gc_frame_newslot(call1565);
  params[0] = call1562;
  partcv[0] = 1;
  Object opresult1566 = callmethod(call1565, "==", 1, partcv, params);
// compiled op node returning opresult1566 (depth = 9)
  Object if1559 = done;
  if (istrue(opresult1566)) {
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1567 = alloc_Boolean(1);
// compiled identifier node returning bool1567 (depth = 10)
  *var_indentFreePass = bool1567;
  if (bool1567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1559 = done;
  } else {
  }
// compiled if node returning if1559 (depth = 8)
    gc_frame_newslot(if1559);
    if1553 = if1559;
  } else {
  }
// compiled if node returning if1553 (depth = 7)
    gc_frame_newslot(if1553);
    if1543 = if1553;
  } else {
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1571 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1572 == NULL) {
    strlit1572 = alloc_String("bind");
    gc_root(strlit1572);
  }
// compiled string node returning strlit1572 (depth = 10)
  gc_frame_newslot(strlit1572);
// call case 4: self request
  params[0] = strlit1572;
  partcv[0] = 1;
  Object call1573 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1571);
// compiled call node returning call1573 (depth = 9)
  int op_slot_right_1570 = gc_frame_newslot(call1573);
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1577 == NULL) {
    strlit1577 = alloc_String("index");
    gc_root(strlit1577);
  }
// compiled string node returning strlit1577 (depth = 11)
  int op_slot_right_1576 = gc_frame_newslot(strlit1577);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1579 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call1581 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1580);
// compiled call node returning call1581 (depth = 14)
// compiled member node returning call1581 (depth = 13)
  partcv[0] = 0;
  Object call1582 = callmethod(call1581, "kind",
    1, partcv, params);
  gc_frame_end(callframe1579);
// compiled call node returning call1582 (depth = 12)
// compiled member node returning call1582 (depth = 11)
  int op_slot_left_1576 = gc_frame_newslot(call1582);
  params[0] = strlit1577;
  partcv[0] = 1;
  Object opresult1583 = callmethod(call1582, "==", 1, partcv, params);
// compiled op node returning opresult1583 (depth = 10)
  int op_slot_right_1575 = gc_frame_newslot(opresult1583);
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1587 == NULL) {
    strlit1587 = alloc_String("identifier");
    gc_root(strlit1587);
  }
// compiled string node returning strlit1587 (depth = 12)
  int op_slot_right_1586 = gc_frame_newslot(strlit1587);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1589 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1591 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1590);
// compiled call node returning call1591 (depth = 15)
// compiled member node returning call1591 (depth = 14)
  partcv[0] = 0;
  Object call1592 = callmethod(call1591, "kind",
    1, partcv, params);
  gc_frame_end(callframe1589);
// compiled call node returning call1592 (depth = 13)
// compiled member node returning call1592 (depth = 12)
  int op_slot_left_1586 = gc_frame_newslot(call1592);
  params[0] = strlit1587;
  partcv[0] = 1;
  Object opresult1593 = callmethod(call1592, "==", 1, partcv, params);
// compiled op node returning opresult1593 (depth = 11)
  int op_slot_right_1585 = gc_frame_newslot(opresult1593);
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1596 == NULL) {
    strlit1596 = alloc_String("member");
    gc_root(strlit1596);
  }
// compiled string node returning strlit1596 (depth = 12)
  int op_slot_right_1595 = gc_frame_newslot(strlit1596);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1598 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1600 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1599);
// compiled call node returning call1600 (depth = 15)
// compiled member node returning call1600 (depth = 14)
  partcv[0] = 0;
  Object call1601 = callmethod(call1600, "kind",
    1, partcv, params);
  gc_frame_end(callframe1598);
// compiled call node returning call1601 (depth = 13)
// compiled member node returning call1601 (depth = 12)
  int op_slot_left_1595 = gc_frame_newslot(call1601);
  params[0] = strlit1596;
  partcv[0] = 1;
  Object opresult1602 = callmethod(call1601, "==", 1, partcv, params);
// compiled op node returning opresult1602 (depth = 11)
  int op_slot_left_1585 = gc_frame_newslot(opresult1602);
  params[0] = opresult1593;
  partcv[0] = 1;
  Object opresult1603 = callmethod(opresult1602, "||", 1, partcv, params);
// compiled op node returning opresult1603 (depth = 10)
  int op_slot_left_1575 = gc_frame_newslot(opresult1603);
  params[0] = opresult1583;
  partcv[0] = 1;
  Object opresult1604 = callmethod(opresult1603, "||", 1, partcv, params);
// compiled op node returning opresult1604 (depth = 9)
  int op_slot_left_1570 = gc_frame_newslot(opresult1604);
  params[0] = call1573;
  partcv[0] = 1;
  Object opresult1605 = callmethod(opresult1604, "&&", 1, partcv, params);
// compiled op node returning opresult1605 (depth = 8)
  Object if1569 = done;
  if (istrue(opresult1605)) {
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1607 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1606);
// compiled call node returning call1607 (depth = 10)
// compiled member node returning call1607 (depth = 9)
  *var_lhs = call1607;
  if (call1607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1608 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1609 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1608);
// compiled call node returning call1609 (depth = 9)
// compiled member node returning call1609 (depth = 8)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1611 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe1612 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block1613 = alloc_Block(NULL, NULL, "parser", 547);
  gc_frame_newslot(block1613);
// method "_apply"
  block_savedest(block1613);
  Object closure1614 = createclosure(2, "_apply");
  setclosureframe(closure1614, stackframe);
  addtoclosure(closure1614, var_blocksOK);
  addtoclosure(closure1614, selfslot);
  struct UserObject *uo1614 = (struct UserObject*)block1613;
  uo1614->data[0] = (Object)closure1614;
  Method *meth_meth_parser__apply1614 = addmethod2pos(block1613, "_apply", &meth_parser__apply1614, 0);
  int argcv_meth_parser__apply1614[] = {0};
  meth_meth_parser__apply1614->type = alloc_MethodType(1, argcv_meth_parser__apply1614);
  meth_meth_parser__apply1614->definitionModule = modulename;
  meth_meth_parser__apply1614->definitionLine = 547;
// compiled block node returning block1613 (depth = 12)
  gc_frame_newslot(block1613);
// call case 4: self request
  params[0] = block1613;
  partcv[0] = 1;
  Object call1618 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1612);
// compiled call node returning call1618 (depth = 11)
  partcv[0] = 0;
  Object call1619 = callmethod(call1618, "not",
    1, partcv, params);
  gc_frame_end(callframe1611);
// compiled call node returning call1619 (depth = 10)
// compiled member node returning call1619 (depth = 9)
  Object if1610 = done;
  if (istrue(call1619)) {
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1620 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1621 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1622 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1621);
// compiled call node returning call1622 (depth = 13)
// compiled member node returning call1622 (depth = 12)
  partcv[0] = 0;
  Object call1623 = callmethod(call1622, "empty",
    1, partcv, params);
  gc_frame_end(callframe1620);
// compiled call node returning call1623 (depth = 11)
// compiled member node returning call1623 (depth = 10)
  *var_suggestions = call1623;
  if (call1623 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1624 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1625 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1626 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1625);
// compiled call node returning call1626 (depth = 13)
// compiled member node returning call1626 (depth = 12)
  partcv[0] = 0;
  Object call1627 = callmethod(call1626, "new",
    1, partcv, params);
  gc_frame_end(callframe1624);
// compiled call node returning call1627 (depth = 11)
// compiled member node returning call1627 (depth = 10)
  *var_suggestion = call1627;
  if (call1627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1628 = gc_frame_new();
// starting to compile array node (depth = 11)
  Object array1629 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 12)
  if (strlit1630 == NULL) {
    strlit1630 = alloc_String("rbrace");
    gc_root(strlit1630);
  }
// compiled string node returning strlit1630 (depth = 12)
  params[0] = strlit1630;
  partcv[0] = 1;
  callmethod(array1629, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array1629 (depth = 11)
  gc_frame_newslot(array1629);
// call case 4: self request
  params[0] = array1629;
  partcv[0] = 1;
  Object call1631 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1628);
// compiled call node returning call1631 (depth = 10)
  *var_nextTok = call1631;
  if (call1631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_1633 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_1633 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1635 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1635 (depth = 10)
  Object if1632 = done;
  if (istrue(opresult1635)) {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1636 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1637 == NULL) {
    strlit1637 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1637);
  }
// compiled string node returning strlit1637 (depth = 11)
  gc_frame_newslot(strlit1637);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit1637;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1638 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1636);
// compiled call node returning call1638 (depth = 10)
    gc_frame_newslot(call1638);
    if1632 = call1638;
  } else {
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1639 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1640 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call1641 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1640);
// compiled call node returning call1641 (depth = 12)
// compiled member node returning call1641 (depth = 11)
  gc_frame_newslot(call1641);
// starting to compile identifier node (depth = 11)
  Object bool1642 = alloc_Boolean(1);
// compiled identifier node returning bool1642 (depth = 11)
  gc_frame_newslot(bool1642);
// starting to compile identifier node (depth = 11)
  Object bool1643 = alloc_Boolean(0);
// compiled identifier node returning bool1643 (depth = 11)
  gc_frame_newslot(bool1643);
// starting to compile string node (depth = 11)
  if (strlit1644 == NULL) {
    strlit1644 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1644);
  }
// compiled string node returning strlit1644 (depth = 11)
  gc_frame_newslot(strlit1644);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = call1641;
  params[2] = bool1642;
  params[3] = bool1643;
  params[4] = strlit1644;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1645 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1639);
// compiled call node returning call1645 (depth = 10)
    gc_frame_newslot(call1645);
    if1632 = call1645;
  }
// compiled if node returning if1632 (depth = 9)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1646 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1647 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1646);
// compiled call node returning call1647 (depth = 9)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1648 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1650 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1649);
// compiled call node returning call1650 (depth = 13)
// compiled member node returning call1650 (depth = 12)
  partcv[0] = 0;
  Object call1651 = callmethod(call1650, "new",
    1, partcv, params);
  gc_frame_end(callframe1648);
// compiled call node returning call1651 (depth = 11)
// compiled member node returning call1651 (depth = 10)
  *var_suggestion = call1651;
  if (call1651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1653 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1654 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1655 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1654);
// compiled call node returning call1655 (depth = 11)
// compiled member node returning call1655 (depth = 10)
  gc_frame_newslot(call1655);
// starting to compile identifier node (depth = 10)
  Object bool1656 = alloc_Boolean(1);
// compiled identifier node returning bool1656 (depth = 10)
  gc_frame_newslot(bool1656);
// starting to compile identifier node (depth = 10)
  Object bool1657 = alloc_Boolean(0);
// compiled identifier node returning bool1657 (depth = 10)
  gc_frame_newslot(bool1657);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = call1655;
  params[2] = bool1656;
  params[3] = bool1657;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1658 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1653);
// compiled call node returning call1658 (depth = 9)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1659 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1660 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1659);
// compiled call node returning call1660 (depth = 9)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1661 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1662 == NULL) {
    strlit1662 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit1662);
  }
// compiled string node returning strlit1662 (depth = 10)
  gc_frame_newslot(strlit1662);
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1664 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1663);
// compiled call node returning call1664 (depth = 11)
// compiled member node returning call1664 (depth = 10)
  gc_frame_newslot(call1664);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1666 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1665);
// compiled call node returning call1666 (depth = 11)
// compiled member node returning call1666 (depth = 10)
  gc_frame_newslot(call1666);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit1662;
  params[1] = call1664;
  params[2] = call1666;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1667 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1661);
// compiled call node returning call1667 (depth = 9)
    gc_frame_newslot(call1667);
    if1610 = call1667;
  } else {
  }
// compiled if node returning if1610 (depth = 8)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1669 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1668);
// compiled call node returning call1669 (depth = 10)
// compiled member node returning call1669 (depth = 9)
  *var_rhs = call1669;
  if (call1669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1670 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1672 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1671);
// compiled call node returning call1672 (depth = 10)
// compiled member node returning call1672 (depth = 9)
  gc_frame_newslot(call1672);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1674 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1673);
// compiled call node returning call1674 (depth = 10)
// compiled member node returning call1674 (depth = 9)
  gc_frame_newslot(call1674);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  params[0] = call1672;
  params[1] = call1674;
  partcv[0] = 2;
  Object call1675 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1670);
// compiled call node returning call1675 (depth = 8)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1676 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1677 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lhs (depth = 10)
  gc_frame_newslot(*var_lhs);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rhs (depth = 10)
  gc_frame_newslot(*var_rhs);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1678 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ast (depth = 12)
  partcv[0] = 0;
  Object call1679 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe1678);
// compiled call node returning call1679 (depth = 11)
// compiled member node returning call1679 (depth = 10)
  params[0] = *var_lhs;
  params[1] = *var_rhs;
  partcv[0] = 2;
  Object call1680 = callmethod(call1679, "new",
    1, partcv, params);
  gc_frame_end(callframe1677);
// compiled call node returning call1680 (depth = 9)
  gc_frame_newslot(call1680);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1680;
  partcv[0] = 1;
  Object call1681 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1676);
// compiled call node returning call1681 (depth = 8)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1683 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1684 == NULL) {
    strlit1684 = alloc_String("semicolon");
    gc_root(strlit1684);
  }
// compiled string node returning strlit1684 (depth = 10)
  gc_frame_newslot(strlit1684);
// call case 4: self request
  params[0] = strlit1684;
  partcv[0] = 1;
  Object call1685 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1683);
// compiled call node returning call1685 (depth = 9)
  Object if1682 = done;
  if (istrue(call1685)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1687 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1686);
// compiled call node returning call1687 (depth = 10)
// compiled member node returning call1687 (depth = 9)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1690 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  partcv[0] = 0;
  Object call1691 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1690);
// compiled call node returning call1691 (depth = 12)
// compiled member node returning call1691 (depth = 11)
  int op_slot_right_1689 = gc_frame_newslot(call1691);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call1694 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1693);
// compiled call node returning call1694 (depth = 12)
// compiled member node returning call1694 (depth = 11)
  int op_slot_left_1689 = gc_frame_newslot(call1694);
  params[0] = call1691;
  partcv[0] = 1;
  Object opresult1695 = callmethod(call1694, "==", 1, partcv, params);
// compiled op node returning opresult1695 (depth = 10)
  Object if1688 = done;
  if (istrue(opresult1695)) {
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool1696 = alloc_Boolean(1);
// compiled identifier node returning bool1696 (depth = 11)
  *var_indentFreePass = bool1696;
  if (bool1696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1688 = done;
  } else {
  }
// compiled if node returning if1688 (depth = 9)
    gc_frame_newslot(if1688);
    if1682 = if1688;
  } else {
  }
// compiled if node returning if1682 (depth = 8)
    gc_frame_newslot(if1682);
    if1569 = if1682;
  } else {
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1699 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1698);
// compiled call node returning call1699 (depth = 9)
// compiled member node returning call1699 (depth = 8)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1700 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1702 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1701);
// compiled call node returning call1702 (depth = 10)
// compiled member node returning call1702 (depth = 9)
  gc_frame_newslot(call1702);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1702;
  partcv[0] = 1;
  Object call1703 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1700);
// compiled call node returning call1703 (depth = 8)
    gc_frame_newslot(call1703);
    if1569 = call1703;
  }
// compiled if node returning if1569 (depth = 7)
    gc_frame_newslot(if1569);
    if1543 = if1569;
  }
// compiled if node returning if1543 (depth = 6)
    gc_frame_newslot(if1543);
    if1306 = if1543;
  }
// compiled if node returning if1306 (depth = 5)
  gc_frame_end(frame);
  return if1306;
}
Object meth_parser__apply1730(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1731 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe1732 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1733 == NULL) {
    strlit1733 = alloc_String("rbrace");
    gc_root(strlit1733);
  }
// compiled string node returning strlit1733 (depth = 8)
  gc_frame_newslot(strlit1733);
// call case 4: self request
  params[0] = strlit1733;
  partcv[0] = 1;
  Object call1734 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1732);
// compiled call node returning call1734 (depth = 7)
  partcv[0] = 0;
  Object call1735 = callmethod(call1734, "not",
    1, partcv, params);
  gc_frame_end(callframe1731);
// compiled call node returning call1735 (depth = 6)
// compiled member node returning call1735 (depth = 5)
  gc_frame_end(frame);
  return call1735;
}
Object meth_parser__apply1743(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1745 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1744);
// compiled call node returning call1745 (depth = 11)
// compiled member node returning call1745 (depth = 10)
  gc_frame_end(frame);
  return call1745;
}
Object meth_parser__apply1738(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_body = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1740 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1741 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1742 = alloc_Block(NULL, NULL, "parser", 587);
  gc_frame_newslot(block1742);
// method "_apply"
  block_savedest(block1742);
  Object closure1743 = createclosure(1, "_apply");
  setclosureframe(closure1743, stackframe);
  addtoclosure(closure1743, selfslot);
  struct UserObject *uo1743 = (struct UserObject*)block1742;
  uo1743->data[0] = (Object)closure1743;
  Method *meth_meth_parser__apply1743 = addmethod2pos(block1742, "_apply", &meth_parser__apply1743, 0);
  int argcv_meth_parser__apply1743[] = {0};
  meth_meth_parser__apply1743->type = alloc_MethodType(1, argcv_meth_parser__apply1743);
  meth_meth_parser__apply1743->definitionModule = modulename;
  meth_meth_parser__apply1743->definitionLine = 587;
// compiled block node returning block1742 (depth = 9)
  gc_frame_newslot(block1742);
// call case 4: self request
  params[0] = block1742;
  partcv[0] = 1;
  Object call1747 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1741);
// compiled call node returning call1747 (depth = 8)
  partcv[0] = 0;
  Object call1748 = callmethod(call1747, "not",
    1, partcv, params);
  gc_frame_end(callframe1740);
// compiled call node returning call1748 (depth = 7)
// compiled member node returning call1748 (depth = 6)
  Object if1739 = done;
  if (istrue(call1748)) {
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1749 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1751 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1750);
// compiled call node returning call1751 (depth = 10)
// compiled member node returning call1751 (depth = 9)
  partcv[0] = 0;
  Object call1752 = callmethod(call1751, "new",
    1, partcv, params);
  gc_frame_end(callframe1749);
// compiled call node returning call1752 (depth = 8)
// compiled member node returning call1752 (depth = 7)
  *var_suggestion = call1752;
  if (call1752 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1753 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1754 == NULL) {
    strlit1754 = alloc_String("}");
    gc_root(strlit1754);
  }
// compiled string node returning strlit1754 (depth = 7)
  gc_frame_newslot(strlit1754);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1754;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1755 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1753);
// compiled call node returning call1755 (depth = 6)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1756 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1757 == NULL) {
    strlit1757 = alloc_String("a block must end with a '}'.");
    gc_root(strlit1757);
  }
// compiled string node returning strlit1757 (depth = 7)
  gc_frame_newslot(strlit1757);
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1759 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1758);
// compiled call node returning call1759 (depth = 8)
// compiled member node returning call1759 (depth = 7)
  gc_frame_newslot(call1759);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1761 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1760);
// compiled call node returning call1761 (depth = 8)
// compiled member node returning call1761 (depth = 7)
  gc_frame_newslot(call1761);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1757;
  params[1] = call1759;
  params[2] = call1761;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1762 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1756);
// compiled call node returning call1762 (depth = 6)
    gc_frame_newslot(call1762);
    if1739 = call1762;
  } else {
  }
// compiled if node returning if1739 (depth = 5)
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1764 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1763);
// compiled call node returning call1764 (depth = 7)
// compiled member node returning call1764 (depth = 6)
  *var_tmp = call1764;
  if (call1764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1766 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call1767 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1766);
// compiled call node returning call1767 (depth = 5)
  gc_frame_end(frame);
  return call1767;
}
Object meth_parser_block1265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_braceIsType = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_indentFreePass = getfromclosure(closure, 8);
  Object *var_util = getfromclosure(closure, 9);
  Object *var_ast = getfromclosure(closure, 10);
  Object *var_minIndentLevel = getfromclosure(closure, 11);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for block (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for block");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minInd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minInd");
  Object *var_startIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startIndent");
  Object *var_expr1 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "expr1");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_params = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "params");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_havearrow = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "havearrow");
  Object *var_found = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "found");
  Object *var_i = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "i");
  Object *var_isMatchingBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "isMatchingBlock");
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1267 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1268 == NULL) {
    strlit1268 = alloc_String("lbrace");
    gc_root(strlit1268);
  }
// compiled string node returning strlit1268 (depth = 4)
  gc_frame_newslot(strlit1268);
// call case 4: self request
  params[0] = strlit1268;
  partcv[0] = 1;
  Object call1269 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1267);
// compiled call node returning call1269 (depth = 3)
  Object if1266 = done;
  if (istrue(call1269)) {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1271 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1270);
// compiled call node returning call1271 (depth = 4)
// compiled member node returning call1271 (depth = 3)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1273 = alloc_Float64(2);
// compiled num node returning num1273 (depth = 5)
  int op_slot_right_1272 = gc_frame_newslot(num1273);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1272 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1273;
  partcv[0] = 1;
  Object sum1275 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum1275 (depth = 4)
  *var_minInd = sum1275;
  if (sum1275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_startIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_expr1 = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_s = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1276 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1277 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1278 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1277);
// compiled call node returning call1278 (depth = 7)
// compiled member node returning call1278 (depth = 6)
  partcv[0] = 0;
  Object call1279 = callmethod(call1278, "empty",
    1, partcv, params);
  gc_frame_end(callframe1276);
// compiled call node returning call1279 (depth = 5)
// compiled member node returning call1279 (depth = 4)
  *var_params = call1279;
  if (call1279 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1280 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1281 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1282 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compiled call node returning call1282 (depth = 7)
// compiled member node returning call1282 (depth = 6)
  partcv[0] = 0;
  Object call1283 = callmethod(call1282, "empty",
    1, partcv, params);
  gc_frame_end(callframe1280);
// compiled call node returning call1283 (depth = 5)
// compiled member node returning call1283 (depth = 4)
  *var_body = call1283;
  if (call1283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1284 = alloc_Boolean(1);
// compiled identifier node returning bool1284 (depth = 4)
  *var_havearrow = bool1284;
  if (bool1284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1285 = alloc_Boolean(0);
// compiled identifier node returning bool1285 (depth = 4)
  *var_found = bool1285;
  if (bool1285 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1286 = alloc_Float64(0);
// compiled num node returning num1286 (depth = 4)
  *var_i = num1286;
  if (num1286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1287 = alloc_Boolean(0);
// compiled identifier node returning bool1287 (depth = 4)
  *var_isMatchingBlock = bool1287;
  if (bool1287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1291 == NULL) {
    strlit1291 = alloc_String("lparen");
    gc_root(strlit1291);
  }
// compiled string node returning strlit1291 (depth = 5)
  int op_slot_right_1290 = gc_frame_newslot(strlit1291);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1294 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1293);
// compiled call node returning call1294 (depth = 6)
// compiled member node returning call1294 (depth = 5)
  int op_slot_left_1290 = gc_frame_newslot(call1294);
  params[0] = strlit1291;
  partcv[0] = 1;
  Object opresult1295 = callmethod(call1294, "==", 1, partcv, params);
// compiled op node returning opresult1295 (depth = 4)
  Object if1289 = done;
  if (istrue(opresult1295)) {
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1296 = alloc_Boolean(1);
// compiled identifier node returning bool1296 (depth = 5)
  *var_isMatchingBlock = bool1296;
  if (bool1296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1289 = done;
  } else {
  }
// compiled if node returning if1289 (depth = 3)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1298 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1299 = alloc_Block(NULL, NULL, "parser", 463);
  gc_frame_newslot(block1299);
// method "_apply"
  block_savedest(block1299);
  Object closure1300 = createclosure(2, "_apply");
  setclosureframe(closure1300, stackframe);
  addtoclosure(closure1300, var_blocksOK);
  addtoclosure(closure1300, selfslot);
  struct UserObject *uo1300 = (struct UserObject*)block1299;
  uo1300->data[0] = (Object)closure1300;
  Method *meth_meth_parser__apply1300 = addmethod2pos(block1299, "_apply", &meth_parser__apply1300, 0);
  int argcv_meth_parser__apply1300[] = {0};
  meth_meth_parser__apply1300->type = alloc_MethodType(1, argcv_meth_parser__apply1300);
  meth_meth_parser__apply1300->definitionModule = modulename;
  meth_meth_parser__apply1300->definitionLine = 458;
// compiled block node returning block1299 (depth = 4)
  gc_frame_newslot(block1299);
// starting to compile block node (depth = 4)
  Object block1304 = alloc_Block(NULL, NULL, "parser", 463);
  gc_frame_newslot(block1304);
// method "_apply"
  block_savedest(block1304);
  Object closure1305 = createclosure(15, "_apply");
  setclosureframe(closure1305, stackframe);
  addtoclosure(closure1305, var_values);
  addtoclosure(closure1305, var_expr1);
  addtoclosure(closure1305, var_braceIsType);
  addtoclosure(closure1305, var_blocksOK);
  addtoclosure(closure1305, var_errormessages);
  addtoclosure(closure1305, var_sym);
  addtoclosure(closure1305, var_lastToken);
  addtoclosure(closure1305, var_params);
  addtoclosure(closure1305, var_isMatchingBlock);
  addtoclosure(closure1305, var_body);
  addtoclosure(closure1305, var_indentFreePass);
  addtoclosure(closure1305, var_btok);
  addtoclosure(closure1305, var_util);
  addtoclosure(closure1305, var_ast);
  addtoclosure(closure1305, selfslot);
  struct UserObject *uo1305 = (struct UserObject*)block1304;
  uo1305->data[0] = (Object)closure1305;
  Method *meth_meth_parser__apply1305 = addmethod2pos(block1304, "_apply", &meth_parser__apply1305, 0);
  int argcv_meth_parser__apply1305[] = {0};
  meth_meth_parser__apply1305->type = alloc_MethodType(1, argcv_meth_parser__apply1305);
  meth_meth_parser__apply1305->definitionModule = modulename;
  meth_meth_parser__apply1305->definitionLine = 458;
// compiled block node returning block1304 (depth = 4)
  gc_frame_newslot(block1304);
// call case 4: self request
  params[0] = block1299;
  params[1] = block1304;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1705 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1298);
// compiled call node returning call1705 (depth = 3)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1707 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1708 == NULL) {
    strlit1708 = alloc_String("arrow");
    gc_root(strlit1708);
  }
// compiled string node returning strlit1708 (depth = 5)
  gc_frame_newslot(strlit1708);
// call case 4: self request
  params[0] = strlit1708;
  partcv[0] = 1;
  Object call1709 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1707);
// compiled call node returning call1709 (depth = 4)
  Object if1706 = done;
  if (istrue(call1709)) {
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1710 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1711 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1710);
// compiled call node returning call1711 (depth = 5)
// compiled member node returning call1711 (depth = 4)
    gc_frame_newslot(call1711);
    if1706 = call1711;
  } else {
  }
// compiled if node returning if1706 (depth = 3)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1714 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1715 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1714);
// compiled call node returning call1715 (depth = 6)
// compiled member node returning call1715 (depth = 5)
  int op_slot_right_1713 = gc_frame_newslot(call1715);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1717 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1718 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1717);
// compiled call node returning call1718 (depth = 6)
// compiled member node returning call1718 (depth = 5)
  int op_slot_left_1713 = gc_frame_newslot(call1718);
  params[0] = call1715;
  partcv[0] = 1;
  Object opresult1719 = callmethod(call1718, "==", 1, partcv, params);
// compiled op node returning opresult1719 (depth = 4)
  Object if1712 = done;
  if (istrue(opresult1719)) {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1721 = alloc_Float64(1);
// compiled num node returning num1721 (depth = 6)
  int op_slot_right_1720 = gc_frame_newslot(num1721);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1723 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1724 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1723);
// compiled call node returning call1724 (depth = 7)
// compiled member node returning call1724 (depth = 6)
  int op_slot_left_1720 = gc_frame_newslot(call1724);
  params[0] = num1721;
  partcv[0] = 1;
  Object diff1725 = callmethod(call1724, "-", 1, partcv, params);
// compiled op node returning diff1725 (depth = 5)
  *var_minIndentLevel = diff1725;
  if (diff1725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1712 = done;
  } else {
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1712 = done;
  }
// compiled if node returning if1712 (depth = 3)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1728 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1729 = alloc_Block(NULL, NULL, "parser", 585);
  gc_frame_newslot(block1729);
// method "_apply"
  block_savedest(block1729);
  Object closure1730 = createclosure(1, "_apply");
  setclosureframe(closure1730, stackframe);
  addtoclosure(closure1730, selfslot);
  struct UserObject *uo1730 = (struct UserObject*)block1729;
  uo1730->data[0] = (Object)closure1730;
  Method *meth_meth_parser__apply1730 = addmethod2pos(block1729, "_apply", &meth_parser__apply1730, 0);
  int argcv_meth_parser__apply1730[] = {0};
  meth_meth_parser__apply1730->type = alloc_MethodType(1, argcv_meth_parser__apply1730);
  meth_meth_parser__apply1730->definitionModule = modulename;
  meth_meth_parser__apply1730->definitionLine = 581;
// compiled block node returning block1729 (depth = 4)
  gc_frame_newslot(block1729);
// starting to compile block node (depth = 4)
  Object block1737 = alloc_Block(NULL, NULL, "parser", 585);
  gc_frame_newslot(block1737);
// method "_apply"
  block_savedest(block1737);
  Object closure1738 = createclosure(7, "_apply");
  setclosureframe(closure1738, stackframe);
  addtoclosure(closure1738, var_errormessages);
  addtoclosure(closure1738, var_lastToken);
  addtoclosure(closure1738, var_sym);
  addtoclosure(closure1738, var_values);
  addtoclosure(closure1738, var_tmp);
  addtoclosure(closure1738, var_body);
  addtoclosure(closure1738, selfslot);
  struct UserObject *uo1738 = (struct UserObject*)block1737;
  uo1738->data[0] = (Object)closure1738;
  Method *meth_meth_parser__apply1738 = addmethod2pos(block1737, "_apply", &meth_parser__apply1738, 0);
  int argcv_meth_parser__apply1738[] = {0};
  meth_meth_parser__apply1738->type = alloc_MethodType(1, argcv_meth_parser__apply1738);
  meth_meth_parser__apply1738->definitionModule = modulename;
  meth_meth_parser__apply1738->definitionLine = 585;
// compiled block node returning block1737 (depth = 4)
  gc_frame_newslot(block1737);
// call case 5: prelude request
  params[0] = block1729;
  params[1] = block1737;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1769 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1728);
// compiled call node returning call1769 (depth = 3)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1771 = alloc_Float64(2);
// compiled num node returning num1771 (depth = 5)
  int op_slot_right_1770 = gc_frame_newslot(num1771);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  int op_slot_left_1770 = gc_frame_newslot(*var_minInd);
  params[0] = num1771;
  partcv[0] = 1;
  Object diff1773 = callmethod(*var_minInd, "-", 1, partcv, params);
// compiled op node returning diff1773 (depth = 4)
  *var_minIndentLevel = diff1773;
  if (diff1773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_statementIndent = *var_startIndent;
  if (*var_startIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1777 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1776);
// compiled call node returning call1777 (depth = 4)
// compiled member node returning call1777 (depth = 3)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1778 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1780 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1779);
// compiled call node returning call1780 (depth = 5)
// compiled member node returning call1780 (depth = 4)
  gc_frame_newslot(call1780);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1782 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1781);
// compiled call node returning call1782 (depth = 5)
// compiled member node returning call1782 (depth = 4)
  gc_frame_newslot(call1782);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call1780;
  params[1] = call1782;
  partcv[0] = 2;
  Object call1783 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1778);
// compiled call node returning call1783 (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1784 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call1786 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1785);
// compiled call node returning call1786 (depth = 6)
// compiled member node returning call1786 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1787 = callmethod(call1786, "new",
    1, partcv, params);
  gc_frame_end(callframe1784);
// compiled call node returning call1787 (depth = 4)
  *var_o = call1787;
  if (call1787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_isMatchingBlock (depth = 4)
  Object if1788 = done;
  if (istrue(*var_isMatchingBlock)) {
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1791 = alloc_Float64(0);
// compiled num node returning num1791 (depth = 6)
  int op_slot_right_1790 = gc_frame_newslot(num1791);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1793 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  partcv[0] = 0;
  Object call1794 = callmethod(*var_params, "size",
    1, partcv, params);
  gc_frame_end(callframe1793);
// compiled call node returning call1794 (depth = 7)
// compiled member node returning call1794 (depth = 6)
  int op_slot_left_1790 = gc_frame_newslot(call1794);
  params[0] = num1791;
  partcv[0] = 1;
  Object opresult1795 = callmethod(call1794, ">", 1, partcv, params);
// compiled op node returning opresult1795 (depth = 5)
  Object if1789 = done;
  if (istrue(opresult1795)) {
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1796 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1797 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  partcv[0] = 0;
  Object call1798 = callmethod(*var_params, "first",
    1, partcv, params);
  gc_frame_end(callframe1797);
// compiled call node returning call1798 (depth = 7)
// compiled member node returning call1798 (depth = 6)
  gc_frame_newslot(call1798);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  params[0] = call1798;
  partcv[0] = 1;
  Object call1799 = callmethod(*var_o, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1796);
// compiled call node returning call1799 (depth = 5)
    gc_frame_newslot(call1799);
    if1789 = call1799;
  } else {
  }
// compiled if node returning if1789 (depth = 4)
    gc_frame_newslot(if1789);
    if1788 = if1789;
  } else {
  }
// compiled if node returning if1788 (depth = 3)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1800 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1801 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1800);
// compiled call node returning call1801 (depth = 3)
    gc_frame_newslot(call1801);
    if1266 = call1801;
  } else {
  }
// compiled if node returning if1266 (depth = 2)
  gc_frame_end(frame);
  return if1266;
}
Object meth_parser__apply1821(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1823 == NULL) {
    strlit1823 = alloc_String("lbrace");
    gc_root(strlit1823);
  }
// compiled string node returning strlit1823 (depth = 8)
  int op_slot_right_1822 = gc_frame_newslot(strlit1823);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1826 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1825);
// compiled call node returning call1826 (depth = 9)
// compiled member node returning call1826 (depth = 8)
  int op_slot_left_1822 = gc_frame_newslot(call1826);
  params[0] = strlit1823;
  partcv[0] = 1;
  Object opresult1827 = callmethod(call1826, "==", 1, partcv, params);
// compiled op node returning opresult1827 (depth = 7)
  gc_frame_end(frame);
  return opresult1827;
}
Object meth_parser__apply1863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1868 == NULL) {
    strlit1868 = alloc_String("then");
    gc_root(strlit1868);
  }
// compiled string node returning strlit1868 (depth = 11)
  int op_slot_right_1867 = gc_frame_newslot(strlit1868);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1871 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe1870);
// compiled call node returning call1871 (depth = 12)
// compiled member node returning call1871 (depth = 11)
  int op_slot_left_1867 = gc_frame_newslot(call1871);
  params[0] = strlit1868;
  partcv[0] = 1;
  Object opresult1872 = callmethod(call1871, "==", 1, partcv, params);
// compiled op node returning opresult1872 (depth = 10)
  int op_slot_right_1866 = gc_frame_newslot(opresult1872);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1875 == NULL) {
    strlit1875 = alloc_String("identifier");
    gc_root(strlit1875);
  }
// compiled string node returning strlit1875 (depth = 11)
  int op_slot_right_1874 = gc_frame_newslot(strlit1875);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1878 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1877);
// compiled call node returning call1878 (depth = 12)
// compiled member node returning call1878 (depth = 11)
  int op_slot_left_1874 = gc_frame_newslot(call1878);
  params[0] = strlit1875;
  partcv[0] = 1;
  Object opresult1879 = callmethod(call1878, "==", 1, partcv, params);
// compiled op node returning opresult1879 (depth = 10)
  int op_slot_left_1866 = gc_frame_newslot(opresult1879);
  params[0] = opresult1872;
  partcv[0] = 1;
  Object opresult1880 = callmethod(opresult1879, "&&", 1, partcv, params);
// compiled op node returning opresult1880 (depth = 9)
  int op_slot_right_1865 = gc_frame_newslot(opresult1880);
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1884 == NULL) {
    strlit1884 = alloc_String("lbrace");
    gc_root(strlit1884);
  }
// compiled string node returning strlit1884 (depth = 11)
  int op_slot_right_1883 = gc_frame_newslot(strlit1884);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1887 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1886);
// compiled call node returning call1887 (depth = 12)
// compiled member node returning call1887 (depth = 11)
  int op_slot_left_1883 = gc_frame_newslot(call1887);
  params[0] = strlit1884;
  partcv[0] = 1;
  Object opresult1888 = callmethod(call1887, "==", 1, partcv, params);
// compiled op node returning opresult1888 (depth = 10)
  int op_slot_right_1882 = gc_frame_newslot(opresult1888);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1892 == NULL) {
    strlit1892 = alloc_String("rbrace");
    gc_root(strlit1892);
  }
// compiled string node returning strlit1892 (depth = 12)
  int op_slot_right_1891 = gc_frame_newslot(strlit1892);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call1895 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1894);
// compiled call node returning call1895 (depth = 13)
// compiled member node returning call1895 (depth = 12)
  int op_slot_left_1891 = gc_frame_newslot(call1895);
  params[0] = strlit1892;
  partcv[0] = 1;
  Object opresult1896 = callmethod(call1895, "==", 1, partcv, params);
// compiled op node returning opresult1896 (depth = 11)
  int op_slot_right_1890 = gc_frame_newslot(opresult1896);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1899 == NULL) {
    strlit1899 = alloc_String("rparen");
    gc_root(strlit1899);
  }
// compiled string node returning strlit1899 (depth = 12)
  int op_slot_right_1898 = gc_frame_newslot(strlit1899);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call1902 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1901);
// compiled call node returning call1902 (depth = 13)
// compiled member node returning call1902 (depth = 12)
  int op_slot_left_1898 = gc_frame_newslot(call1902);
  params[0] = strlit1899;
  partcv[0] = 1;
  Object opresult1903 = callmethod(call1902, "==", 1, partcv, params);
// compiled op node returning opresult1903 (depth = 11)
  int op_slot_left_1890 = gc_frame_newslot(opresult1903);
  params[0] = opresult1896;
  partcv[0] = 1;
  Object opresult1904 = callmethod(opresult1903, "||", 1, partcv, params);
// compiled op node returning opresult1904 (depth = 10)
  int op_slot_left_1882 = gc_frame_newslot(opresult1904);
  params[0] = opresult1888;
  partcv[0] = 1;
  Object opresult1905 = callmethod(opresult1904, "||", 1, partcv, params);
// compiled op node returning opresult1905 (depth = 9)
  int op_slot_left_1865 = gc_frame_newslot(opresult1905);
  params[0] = opresult1880;
  partcv[0] = 1;
  Object opresult1906 = callmethod(opresult1905, "||", 1, partcv, params);
// compiled op node returning opresult1906 (depth = 8)
  int op_slot_right_1864 = gc_frame_newslot(opresult1906);
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1910 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1909);
// compiled call node returning call1910 (depth = 10)
// compiled member node returning call1910 (depth = 9)
  int op_slot_right_1908 = gc_frame_newslot(call1910);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1913 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1912);
// compiled call node returning call1913 (depth = 10)
// compiled member node returning call1913 (depth = 9)
  int op_slot_left_1908 = gc_frame_newslot(call1913);
  params[0] = call1910;
  partcv[0] = 1;
  Object opresult1914 = callmethod(call1913, "==", 1, partcv, params);
// compiled op node returning opresult1914 (depth = 8)
  int op_slot_left_1864 = gc_frame_newslot(opresult1914);
  params[0] = opresult1906;
  partcv[0] = 1;
  Object opresult1915 = callmethod(opresult1914, "&&", 1, partcv, params);
// compiled op node returning opresult1915 (depth = 7)
  gc_frame_end(frame);
  return opresult1915;
}
Object meth_parser__apply2006(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe2007 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2008 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2007);
// compiled call node returning call2008 (depth = 8)
  gc_frame_end(frame);
  return call2008;
}
Object meth_parser__apply2018(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2021 == NULL) {
    strlit2021 = alloc_String("rparen");
    gc_root(strlit2021);
  }
// compiled string node returning strlit2021 (depth = 9)
  int op_slot_right_2020 = gc_frame_newslot(strlit2021);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call2024 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2023);
// compiled call node returning call2024 (depth = 10)
// compiled member node returning call2024 (depth = 9)
  int op_slot_left_2020 = gc_frame_newslot(call2024);
  params[0] = strlit2021;
  partcv[0] = 1;
  Object opresult2025 = callmethod(call2024, "==", 1, partcv, params);
// compiled op node returning opresult2025 (depth = 8)
  int op_slot_right_2019 = gc_frame_newslot(opresult2025);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2029 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2028);
// compiled call node returning call2029 (depth = 10)
// compiled member node returning call2029 (depth = 9)
  int op_slot_right_2027 = gc_frame_newslot(call2029);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2031 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call2032 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2031);
// compiled call node returning call2032 (depth = 10)
// compiled member node returning call2032 (depth = 9)
  int op_slot_left_2027 = gc_frame_newslot(call2032);
  params[0] = call2029;
  partcv[0] = 1;
  Object opresult2033 = callmethod(call2032, "==", 1, partcv, params);
// compiled op node returning opresult2033 (depth = 8)
  int op_slot_left_2019 = gc_frame_newslot(opresult2033);
  params[0] = opresult2025;
  partcv[0] = 1;
  Object opresult2034 = callmethod(opresult2033, "&&", 1, partcv, params);
// compiled op node returning opresult2034 (depth = 7)
  gc_frame_end(frame);
  return opresult2034;
}
Object meth_parser__apply2269(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2270 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe2271 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2272 == NULL) {
    strlit2272 = alloc_String("rbrace");
    gc_root(strlit2272);
  }
// compiled string node returning strlit2272 (depth = 9)
  gc_frame_newslot(strlit2272);
// call case 4: self request
  params[0] = strlit2272;
  partcv[0] = 1;
  Object call2273 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2271);
// compiled call node returning call2273 (depth = 8)
  partcv[0] = 0;
  Object call2274 = callmethod(call2273, "not",
    1, partcv, params);
  gc_frame_end(callframe2270);
// compiled call node returning call2274 (depth = 7)
// compiled member node returning call2274 (depth = 6)
  gc_frame_end(frame);
  return call2274;
}
Object meth_parser__apply2282(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2284 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2283);
// compiled call node returning call2284 (depth = 12)
// compiled member node returning call2284 (depth = 11)
  gc_frame_end(frame);
  return call2284;
}
Object meth_parser__apply2277(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2279 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2280 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2281 = alloc_Block(NULL, NULL, "parser", 738);
  gc_frame_newslot(block2281);
// method "_apply"
  block_savedest(block2281);
  Object closure2282 = createclosure(1, "_apply");
  setclosureframe(closure2282, stackframe);
  addtoclosure(closure2282, selfslot);
  struct UserObject *uo2282 = (struct UserObject*)block2281;
  uo2282->data[0] = (Object)closure2282;
  Method *meth_meth_parser__apply2282 = addmethod2pos(block2281, "_apply", &meth_parser__apply2282, 0);
  int argcv_meth_parser__apply2282[] = {0};
  meth_meth_parser__apply2282->type = alloc_MethodType(1, argcv_meth_parser__apply2282);
  meth_meth_parser__apply2282->definitionModule = modulename;
  meth_meth_parser__apply2282->definitionLine = 738;
// compiled block node returning block2281 (depth = 10)
  gc_frame_newslot(block2281);
// call case 4: self request
  params[0] = block2281;
  partcv[0] = 1;
  Object call2286 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2280);
// compiled call node returning call2286 (depth = 9)
  partcv[0] = 0;
  Object call2287 = callmethod(call2286, "not",
    1, partcv, params);
  gc_frame_end(callframe2279);
// compiled call node returning call2287 (depth = 8)
// compiled member node returning call2287 (depth = 7)
  Object if2278 = done;
  if (istrue(call2287)) {
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2288 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2289 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2290 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2289);
// compiled call node returning call2290 (depth = 11)
// compiled member node returning call2290 (depth = 10)
  partcv[0] = 0;
  Object call2291 = callmethod(call2290, "new",
    1, partcv, params);
  gc_frame_end(callframe2288);
// compiled call node returning call2291 (depth = 9)
// compiled member node returning call2291 (depth = 8)
  *var_suggestion = call2291;
  if (call2291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2292 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2293 = alloc_Boolean(0);
// compiled identifier node returning bool2293 (depth = 9)
  gc_frame_newslot(bool2293);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2293;
  partcv[0] = 2;
  Object call2294 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2292);
// compiled call node returning call2294 (depth = 8)
  *var_closingBrace = call2294;
  if (call2294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2297 = alloc_Boolean(0);
// compiled identifier node returning bool2297 (depth = 9)
  int op_slot_right_2296 = gc_frame_newslot(bool2297);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2300 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2299);
// compiled call node returning call2300 (depth = 10)
// compiled member node returning call2300 (depth = 9)
  int op_slot_left_2296 = gc_frame_newslot(call2300);
  params[0] = bool2297;
  partcv[0] = 1;
  Object opresult2301 = callmethod(call2300, "==", 1, partcv, params);
// compiled op node returning opresult2301 (depth = 8)
  Object if2295 = done;
  if (istrue(opresult2301)) {
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2303 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2306 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2305);
// compiled call node returning call2306 (depth = 11)
// compiled member node returning call2306 (depth = 10)
  int op_slot_left_2303 = gc_frame_newslot(call2306);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2307 = callmethod(call2306, "==", 1, partcv, params);
// compiled op node returning opresult2307 (depth = 9)
  Object if2302 = done;
  if (istrue(opresult2307)) {
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2308 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2309 == NULL) {
    strlit2309 = alloc_String("}");
    gc_root(strlit2309);
  }
// compiled string node returning strlit2309 (depth = 10)
  gc_frame_newslot(strlit2309);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2309;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2310 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2308);
// compiled call node returning call2310 (depth = 9)
    gc_frame_newslot(call2310);
    if2302 = call2310;
  } else {
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2311 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2313 = alloc_Float64(0.1);
// compiled num node returning num2313 (depth = 11)
  int op_slot_right_2312 = gc_frame_newslot(num2313);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2315 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2317 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2316);
// compiled call node returning call2317 (depth = 14)
// compiled member node returning call2317 (depth = 13)
  partcv[0] = 0;
  Object call2318 = callmethod(call2317, "line",
    1, partcv, params);
  gc_frame_end(callframe2315);
// compiled call node returning call2318 (depth = 12)
// compiled member node returning call2318 (depth = 11)
  int op_slot_left_2312 = gc_frame_newslot(call2318);
  params[0] = num2313;
  partcv[0] = 1;
  Object sum2319 = callmethod(call2318, "+", 1, partcv, params);
// compiled op node returning sum2319 (depth = 10)
  gc_frame_newslot(sum2319);
// starting to compile string node (depth = 10)
  if (strlit2320 == NULL) {
    strlit2320 = alloc_String("}");
    gc_root(strlit2320);
  }
// compiled string node returning strlit2320 (depth = 10)
  gc_frame_newslot(strlit2320);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2319;
  params[1] = strlit2320;
  partcv[0] = 2;
  Object call2321 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2311);
// compiled call node returning call2321 (depth = 9)
    gc_frame_newslot(call2321);
    if2302 = call2321;
  }
// compiled if node returning if2302 (depth = 8)
    gc_frame_newslot(if2302);
    if2295 = if2302;
  } else {
  }
// compiled if node returning if2295 (depth = 7)
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2322 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2323 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2322);
// compiled call node returning call2323 (depth = 7)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2324 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2325 == NULL) {
    strlit2325 = alloc_String("an if statement must end with a '}'.");
    gc_root(strlit2325);
  }
// compiled string node returning strlit2325 (depth = 8)
  gc_frame_newslot(strlit2325);
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2326 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2327 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2326);
// compiled call node returning call2327 (depth = 9)
// compiled member node returning call2327 (depth = 8)
  gc_frame_newslot(call2327);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2329 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2328);
// compiled call node returning call2329 (depth = 9)
// compiled member node returning call2329 (depth = 8)
  gc_frame_newslot(call2329);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2325;
  params[1] = call2327;
  params[2] = call2329;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2330 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2324);
// compiled call node returning call2330 (depth = 7)
    gc_frame_newslot(call2330);
    if2278 = call2330;
  } else {
  }
// compiled if node returning if2278 (depth = 6)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2331 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2332 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2331);
// compiled call node returning call2332 (depth = 8)
// compiled member node returning call2332 (depth = 7)
  *var_v = call2332;
  if (call2332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2334 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2335 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe2334);
// compiled call node returning call2335 (depth = 6)
  gc_frame_end(frame);
  return call2335;
}
Object meth_parser__apply2342(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2345 == NULL) {
    strlit2345 = alloc_String("elseif");
    gc_root(strlit2345);
  }
// compiled string node returning strlit2345 (depth = 8)
  int op_slot_right_2344 = gc_frame_newslot(strlit2345);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2347 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2348 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2347);
// compiled call node returning call2348 (depth = 9)
// compiled member node returning call2348 (depth = 8)
  int op_slot_left_2344 = gc_frame_newslot(call2348);
  params[0] = strlit2345;
  partcv[0] = 1;
  Object opresult2349 = callmethod(call2348, "==", 1, partcv, params);
// compiled op node returning opresult2349 (depth = 7)
  int op_slot_right_2343 = gc_frame_newslot(opresult2349);
// starting to compile call node (depth = 7)
  int callframe2351 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2352 == NULL) {
    strlit2352 = alloc_String("identifier");
    gc_root(strlit2352);
  }
// compiled string node returning strlit2352 (depth = 8)
  gc_frame_newslot(strlit2352);
// call case 4: self request
  params[0] = strlit2352;
  partcv[0] = 1;
  Object call2353 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2351);
// compiled call node returning call2353 (depth = 7)
  int op_slot_left_2343 = gc_frame_newslot(call2353);
  params[0] = opresult2349;
  partcv[0] = 1;
  Object opresult2354 = callmethod(call2353, "&&", 1, partcv, params);
// compiled op node returning opresult2354 (depth = 6)
  gc_frame_end(frame);
  return opresult2354;
}
Object meth_parser__apply2364(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2366 == NULL) {
    strlit2366 = alloc_String("lbrace");
    gc_root(strlit2366);
  }
// compiled string node returning strlit2366 (depth = 11)
  int op_slot_right_2365 = gc_frame_newslot(strlit2366);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2368 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call2369 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2368);
// compiled call node returning call2369 (depth = 12)
// compiled member node returning call2369 (depth = 11)
  int op_slot_left_2365 = gc_frame_newslot(call2369);
  params[0] = strlit2366;
  partcv[0] = 1;
  Object opresult2370 = callmethod(call2369, "==", 1, partcv, params);
// compiled op node returning opresult2370 (depth = 10)
  gc_frame_end(frame);
  return opresult2370;
}
Object meth_parser__apply2406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2411 == NULL) {
    strlit2411 = alloc_String("then");
    gc_root(strlit2411);
  }
// compiled string node returning strlit2411 (depth = 14)
  int op_slot_right_2410 = gc_frame_newslot(strlit2411);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2414 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe2413);
// compiled call node returning call2414 (depth = 15)
// compiled member node returning call2414 (depth = 14)
  int op_slot_left_2410 = gc_frame_newslot(call2414);
  params[0] = strlit2411;
  partcv[0] = 1;
  Object opresult2415 = callmethod(call2414, "==", 1, partcv, params);
// compiled op node returning opresult2415 (depth = 13)
  int op_slot_right_2409 = gc_frame_newslot(opresult2415);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2418 == NULL) {
    strlit2418 = alloc_String("identifier");
    gc_root(strlit2418);
  }
// compiled string node returning strlit2418 (depth = 14)
  int op_slot_right_2417 = gc_frame_newslot(strlit2418);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2421 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2420);
// compiled call node returning call2421 (depth = 15)
// compiled member node returning call2421 (depth = 14)
  int op_slot_left_2417 = gc_frame_newslot(call2421);
  params[0] = strlit2418;
  partcv[0] = 1;
  Object opresult2422 = callmethod(call2421, "==", 1, partcv, params);
// compiled op node returning opresult2422 (depth = 13)
  int op_slot_left_2409 = gc_frame_newslot(opresult2422);
  params[0] = opresult2415;
  partcv[0] = 1;
  Object opresult2423 = callmethod(opresult2422, "&&", 1, partcv, params);
// compiled op node returning opresult2423 (depth = 12)
  int op_slot_right_2408 = gc_frame_newslot(opresult2423);
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2427 == NULL) {
    strlit2427 = alloc_String("lbrace");
    gc_root(strlit2427);
  }
// compiled string node returning strlit2427 (depth = 14)
  int op_slot_right_2426 = gc_frame_newslot(strlit2427);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2430 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2429);
// compiled call node returning call2430 (depth = 15)
// compiled member node returning call2430 (depth = 14)
  int op_slot_left_2426 = gc_frame_newslot(call2430);
  params[0] = strlit2427;
  partcv[0] = 1;
  Object opresult2431 = callmethod(call2430, "==", 1, partcv, params);
// compiled op node returning opresult2431 (depth = 13)
  int op_slot_right_2425 = gc_frame_newslot(opresult2431);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2435 == NULL) {
    strlit2435 = alloc_String("rbrace");
    gc_root(strlit2435);
  }
// compiled string node returning strlit2435 (depth = 15)
  int op_slot_right_2434 = gc_frame_newslot(strlit2435);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2438 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2437);
// compiled call node returning call2438 (depth = 16)
// compiled member node returning call2438 (depth = 15)
  int op_slot_left_2434 = gc_frame_newslot(call2438);
  params[0] = strlit2435;
  partcv[0] = 1;
  Object opresult2439 = callmethod(call2438, "==", 1, partcv, params);
// compiled op node returning opresult2439 (depth = 14)
  int op_slot_right_2433 = gc_frame_newslot(opresult2439);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2442 == NULL) {
    strlit2442 = alloc_String("rparen");
    gc_root(strlit2442);
  }
// compiled string node returning strlit2442 (depth = 15)
  int op_slot_right_2441 = gc_frame_newslot(strlit2442);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2445 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2444);
// compiled call node returning call2445 (depth = 16)
// compiled member node returning call2445 (depth = 15)
  int op_slot_left_2441 = gc_frame_newslot(call2445);
  params[0] = strlit2442;
  partcv[0] = 1;
  Object opresult2446 = callmethod(call2445, "==", 1, partcv, params);
// compiled op node returning opresult2446 (depth = 14)
  int op_slot_left_2433 = gc_frame_newslot(opresult2446);
  params[0] = opresult2439;
  partcv[0] = 1;
  Object opresult2447 = callmethod(opresult2446, "||", 1, partcv, params);
// compiled op node returning opresult2447 (depth = 13)
  int op_slot_left_2425 = gc_frame_newslot(opresult2447);
  params[0] = opresult2431;
  partcv[0] = 1;
  Object opresult2448 = callmethod(opresult2447, "||", 1, partcv, params);
// compiled op node returning opresult2448 (depth = 12)
  int op_slot_left_2408 = gc_frame_newslot(opresult2448);
  params[0] = opresult2423;
  partcv[0] = 1;
  Object opresult2449 = callmethod(opresult2448, "||", 1, partcv, params);
// compiled op node returning opresult2449 (depth = 11)
  int op_slot_right_2407 = gc_frame_newslot(opresult2449);
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_statementToken (depth = 14)
  partcv[0] = 0;
  Object call2453 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2452);
// compiled call node returning call2453 (depth = 13)
// compiled member node returning call2453 (depth = 12)
  int op_slot_right_2451 = gc_frame_newslot(call2453);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2456 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2455);
// compiled call node returning call2456 (depth = 13)
// compiled member node returning call2456 (depth = 12)
  int op_slot_left_2451 = gc_frame_newslot(call2456);
  params[0] = call2453;
  partcv[0] = 1;
  Object opresult2457 = callmethod(call2456, "==", 1, partcv, params);
// compiled op node returning opresult2457 (depth = 11)
  int op_slot_left_2407 = gc_frame_newslot(opresult2457);
  params[0] = opresult2449;
  partcv[0] = 1;
  Object opresult2458 = callmethod(opresult2457, "&&", 1, partcv, params);
// compiled op node returning opresult2458 (depth = 10)
  gc_frame_end(frame);
  return opresult2458;
}
Object meth_parser__apply2549(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe2550 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2551 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2550);
// compiled call node returning call2551 (depth = 11)
  gc_frame_end(frame);
  return call2551;
}
Object meth_parser__apply2561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2565 == NULL) {
    strlit2565 = alloc_String("rbrace");
    gc_root(strlit2565);
  }
// compiled string node returning strlit2565 (depth = 13)
  int op_slot_right_2564 = gc_frame_newslot(strlit2565);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2568 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2567);
// compiled call node returning call2568 (depth = 14)
// compiled member node returning call2568 (depth = 13)
  int op_slot_left_2564 = gc_frame_newslot(call2568);
  params[0] = strlit2565;
  partcv[0] = 1;
  Object opresult2569 = callmethod(call2568, "==", 1, partcv, params);
// compiled op node returning opresult2569 (depth = 12)
  int op_slot_right_2563 = gc_frame_newslot(opresult2569);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2572 == NULL) {
    strlit2572 = alloc_String("rparen");
    gc_root(strlit2572);
  }
// compiled string node returning strlit2572 (depth = 13)
  int op_slot_right_2571 = gc_frame_newslot(strlit2572);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2575 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2574);
// compiled call node returning call2575 (depth = 14)
// compiled member node returning call2575 (depth = 13)
  int op_slot_left_2571 = gc_frame_newslot(call2575);
  params[0] = strlit2572;
  partcv[0] = 1;
  Object opresult2576 = callmethod(call2575, "==", 1, partcv, params);
// compiled op node returning opresult2576 (depth = 12)
  int op_slot_left_2563 = gc_frame_newslot(opresult2576);
  params[0] = opresult2569;
  partcv[0] = 1;
  Object opresult2577 = callmethod(opresult2576, "||", 1, partcv, params);
// compiled op node returning opresult2577 (depth = 11)
  int op_slot_right_2562 = gc_frame_newslot(opresult2577);
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lastToken (depth = 14)
  partcv[0] = 0;
  Object call2581 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2580);
// compiled call node returning call2581 (depth = 13)
// compiled member node returning call2581 (depth = 12)
  int op_slot_right_2579 = gc_frame_newslot(call2581);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2584 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2583);
// compiled call node returning call2584 (depth = 13)
// compiled member node returning call2584 (depth = 12)
  int op_slot_left_2579 = gc_frame_newslot(call2584);
  params[0] = call2581;
  partcv[0] = 1;
  Object opresult2585 = callmethod(call2584, "==", 1, partcv, params);
// compiled op node returning opresult2585 (depth = 11)
  int op_slot_left_2562 = gc_frame_newslot(opresult2585);
  params[0] = opresult2577;
  partcv[0] = 1;
  Object opresult2586 = callmethod(opresult2585, "&&", 1, partcv, params);
// compiled op node returning opresult2586 (depth = 10)
  gc_frame_end(frame);
  return opresult2586;
}
Object meth_parser__apply2902(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2903 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2904 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2905 == NULL) {
    strlit2905 = alloc_String("rbrace");
    gc_root(strlit2905);
  }
// compiled string node returning strlit2905 (depth = 11)
  gc_frame_newslot(strlit2905);
// call case 4: self request
  params[0] = strlit2905;
  partcv[0] = 1;
  Object call2906 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2904);
// compiled call node returning call2906 (depth = 10)
  partcv[0] = 0;
  Object call2907 = callmethod(call2906, "not",
    1, partcv, params);
  gc_frame_end(callframe2903);
// compiled call node returning call2907 (depth = 9)
// compiled member node returning call2907 (depth = 8)
  gc_frame_end(frame);
  return call2907;
}
Object meth_parser__apply2915(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2916 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2917 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2916);
// compiled call node returning call2917 (depth = 14)
// compiled member node returning call2917 (depth = 13)
  gc_frame_end(frame);
  return call2917;
}
Object meth_parser__apply2910(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2912 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe2913 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block2914 = alloc_Block(NULL, NULL, "parser", 900);
  gc_frame_newslot(block2914);
// method "_apply"
  block_savedest(block2914);
  Object closure2915 = createclosure(1, "_apply");
  setclosureframe(closure2915, stackframe);
  addtoclosure(closure2915, selfslot);
  struct UserObject *uo2915 = (struct UserObject*)block2914;
  uo2915->data[0] = (Object)closure2915;
  Method *meth_meth_parser__apply2915 = addmethod2pos(block2914, "_apply", &meth_parser__apply2915, 0);
  int argcv_meth_parser__apply2915[] = {0};
  meth_meth_parser__apply2915->type = alloc_MethodType(1, argcv_meth_parser__apply2915);
  meth_meth_parser__apply2915->definitionModule = modulename;
  meth_meth_parser__apply2915->definitionLine = 900;
// compiled block node returning block2914 (depth = 12)
  gc_frame_newslot(block2914);
// call case 4: self request
  params[0] = block2914;
  partcv[0] = 1;
  Object call2919 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2913);
// compiled call node returning call2919 (depth = 11)
  partcv[0] = 0;
  Object call2920 = callmethod(call2919, "not",
    1, partcv, params);
  gc_frame_end(callframe2912);
// compiled call node returning call2920 (depth = 10)
// compiled member node returning call2920 (depth = 9)
  Object if2911 = done;
  if (istrue(call2920)) {
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2921 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2923 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2922);
// compiled call node returning call2923 (depth = 13)
// compiled member node returning call2923 (depth = 12)
  partcv[0] = 0;
  Object call2924 = callmethod(call2923, "new",
    1, partcv, params);
  gc_frame_end(callframe2921);
// compiled call node returning call2924 (depth = 11)
// compiled member node returning call2924 (depth = 10)
  *var_suggestion = call2924;
  if (call2924 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2925 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2926 = alloc_Boolean(0);
// compiled identifier node returning bool2926 (depth = 11)
  gc_frame_newslot(bool2926);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2926;
  partcv[0] = 2;
  Object call2927 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2925);
// compiled call node returning call2927 (depth = 10)
  *var_closingBrace = call2927;
  if (call2927 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool2930 = alloc_Boolean(0);
// compiled identifier node returning bool2930 (depth = 11)
  int op_slot_right_2929 = gc_frame_newslot(bool2930);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2933 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2932);
// compiled call node returning call2933 (depth = 12)
// compiled member node returning call2933 (depth = 11)
  int op_slot_left_2929 = gc_frame_newslot(call2933);
  params[0] = bool2930;
  partcv[0] = 1;
  Object opresult2934 = callmethod(call2933, "==", 1, partcv, params);
// compiled op node returning opresult2934 (depth = 10)
  Object if2928 = done;
  if (istrue(opresult2934)) {
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2936 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2938 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2939 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2938);
// compiled call node returning call2939 (depth = 13)
// compiled member node returning call2939 (depth = 12)
  int op_slot_left_2936 = gc_frame_newslot(call2939);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2940 = callmethod(call2939, "==", 1, partcv, params);
// compiled op node returning opresult2940 (depth = 11)
  Object if2935 = done;
  if (istrue(opresult2940)) {
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2941 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2942 == NULL) {
    strlit2942 = alloc_String("}");
    gc_root(strlit2942);
  }
// compiled string node returning strlit2942 (depth = 12)
  gc_frame_newslot(strlit2942);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2942;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2943 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2941);
// compiled call node returning call2943 (depth = 11)
    gc_frame_newslot(call2943);
    if2935 = call2943;
  } else {
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2944 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2946 = alloc_Float64(0.1);
// compiled num node returning num2946 (depth = 13)
  int op_slot_right_2945 = gc_frame_newslot(num2946);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2948 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_closingBrace (depth = 17)
  partcv[0] = 0;
  Object call2950 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2949);
// compiled call node returning call2950 (depth = 16)
// compiled member node returning call2950 (depth = 15)
  partcv[0] = 0;
  Object call2951 = callmethod(call2950, "line",
    1, partcv, params);
  gc_frame_end(callframe2948);
// compiled call node returning call2951 (depth = 14)
// compiled member node returning call2951 (depth = 13)
  int op_slot_left_2945 = gc_frame_newslot(call2951);
  params[0] = num2946;
  partcv[0] = 1;
  Object sum2952 = callmethod(call2951, "+", 1, partcv, params);
// compiled op node returning sum2952 (depth = 12)
  gc_frame_newslot(sum2952);
// starting to compile string node (depth = 12)
  if (strlit2953 == NULL) {
    strlit2953 = alloc_String("}");
    gc_root(strlit2953);
  }
// compiled string node returning strlit2953 (depth = 12)
  gc_frame_newslot(strlit2953);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2952;
  params[1] = strlit2953;
  partcv[0] = 2;
  Object call2954 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2944);
// compiled call node returning call2954 (depth = 11)
    gc_frame_newslot(call2954);
    if2935 = call2954;
  }
// compiled if node returning if2935 (depth = 10)
    gc_frame_newslot(if2935);
    if2928 = if2935;
  } else {
  }
// compiled if node returning if2928 (depth = 9)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2955 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2956 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2955);
// compiled call node returning call2956 (depth = 9)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2957 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2958 == NULL) {
    strlit2958 = alloc_String("an elseif statement must end with a '}'.");
    gc_root(strlit2958);
  }
// compiled string node returning strlit2958 (depth = 10)
  gc_frame_newslot(strlit2958);
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2960 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2959);
// compiled call node returning call2960 (depth = 11)
// compiled member node returning call2960 (depth = 10)
  gc_frame_newslot(call2960);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2962 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2961);
// compiled call node returning call2962 (depth = 11)
// compiled member node returning call2962 (depth = 10)
  gc_frame_newslot(call2962);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2958;
  params[1] = call2960;
  params[2] = call2962;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2963 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2957);
// compiled call node returning call2963 (depth = 9)
    gc_frame_newslot(call2963);
    if2911 = call2963;
  } else {
  }
// compiled if node returning if2911 (depth = 8)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call2965 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2964);
// compiled call node returning call2965 (depth = 10)
// compiled member node returning call2965 (depth = 9)
  *var_v = call2965;
  if (call2965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2967 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2968 = callmethod(*var_ebody, "push",
    1, partcv, params);
  gc_frame_end(callframe2967);
// compiled call node returning call2968 (depth = 8)
  gc_frame_end(frame);
  return call2968;
}
Object meth_parser__apply2357(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_econd = getfromclosure(closure, 6);
  Object *var_ebody = getfromclosure(closure, 7);
  Object *var_btok = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_minInd = getfromclosure(closure, 10);
  Object *var_v = getfromclosure(closure, 11);
  Object *var_newelse = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_elopener = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "elopener");
  Object *var_elcloser = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "elcloser");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_closingBrace = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "closingBrace");
// starting to compile bind node (depth = 6)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2359 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2360 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2359);
// compiled call node returning call2360 (depth = 7)
// compiled member node returning call2360 (depth = 6)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2362 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2363 = alloc_Block(NULL, NULL, "parser", 766);
  gc_frame_newslot(block2363);
// method "_apply"
  block_savedest(block2363);
  Object closure2364 = createclosure(2, "_apply");
  setclosureframe(closure2364, stackframe);
  addtoclosure(closure2364, var_sym);
  addtoclosure(closure2364, selfslot);
  struct UserObject *uo2364 = (struct UserObject*)block2363;
  uo2364->data[0] = (Object)closure2364;
  Method *meth_meth_parser__apply2364 = addmethod2pos(block2363, "_apply", &meth_parser__apply2364, 0);
  int argcv_meth_parser__apply2364[] = {0};
  meth_meth_parser__apply2364->type = alloc_MethodType(1, argcv_meth_parser__apply2364);
  meth_meth_parser__apply2364->definitionModule = modulename;
  meth_meth_parser__apply2364->definitionLine = 765;
// compiled block node returning block2363 (depth = 9)
  gc_frame_newslot(block2363);
// call case 6: other member request
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2373 == NULL) {
    strlit2373 = alloc_String("lparen");
    gc_root(strlit2373);
  }
// compiled string node returning strlit2373 (depth = 10)
  int op_slot_right_2372 = gc_frame_newslot(strlit2373);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2376 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2375);
// compiled call node returning call2376 (depth = 11)
// compiled member node returning call2376 (depth = 10)
  int op_slot_left_2372 = gc_frame_newslot(call2376);
  params[0] = strlit2373;
  partcv[0] = 1;
  Object opresult2377 = callmethod(call2376, "==", 1, partcv, params);
// compiled op node returning opresult2377 (depth = 9)
  params[0] = block2363;
  partcv[0] = 1;
  Object call2378 = callmethod(opresult2377, "orElse",
    1, partcv, params);
  gc_frame_end(callframe2362);
// compiled call node returning call2378 (depth = 8)
  Object if2361 = done;
struct StackFrameObject *iftmpstackframe2361 = stackframe;
  if (istrue(call2378)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2361);
gc_frame_newslot((Object)stackframe);
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2379 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2380 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2379);
// compiled call node returning call2380 (depth = 9)
// compiled member node returning call2380 (depth = 8)
    gc_frame_newslot(call2380);
    if2361 = call2380;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2361);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2381 == NULL) {
    strlit2381 = alloc_String("-missing-");
    gc_root(strlit2381);
  }
// compiled string node returning strlit2381 (depth = 8)
    gc_frame_newslot(strlit2381);
    if2361 = strlit2381;
  }
stackframe = iftmpstackframe2361;
// compiled if node returning if2361 (depth = 7)
  *var_elopener = if2361;
  if (if2361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2384 == NULL) {
    strlit2384 = alloc_String("(");
    gc_root(strlit2384);
  }
// compiled string node returning strlit2384 (depth = 9)
  int op_slot_right_2383 = gc_frame_newslot(strlit2384);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_elopener (depth = 9)
  int op_slot_left_2383 = gc_frame_newslot(*var_elopener);
  params[0] = strlit2384;
  partcv[0] = 1;
  Object opresult2386 = callmethod(*var_elopener, "==", 1, partcv, params);
// compiled op node returning opresult2386 (depth = 8)
  Object if2382 = done;
struct StackFrameObject *iftmpstackframe2382 = stackframe;
  if (istrue(opresult2386)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2382);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2387 == NULL) {
    strlit2387 = alloc_String(")");
    gc_root(strlit2387);
  }
// compiled string node returning strlit2387 (depth = 8)
    gc_frame_newslot(strlit2387);
    if2382 = strlit2387;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2382);
  gc_frame_newslot((Object)stackframe);
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2390 == NULL) {
    strlit2390 = alloc_String("{");
    gc_root(strlit2390);
  }
// compiled string node returning strlit2390 (depth = 10)
  int op_slot_right_2389 = gc_frame_newslot(strlit2390);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_elopener (depth = 10)
  int op_slot_left_2389 = gc_frame_newslot(*var_elopener);
  params[0] = strlit2390;
  partcv[0] = 1;
  Object opresult2392 = callmethod(*var_elopener, "==", 1, partcv, params);
// compiled op node returning opresult2392 (depth = 9)
  Object if2388 = done;
  if (istrue(opresult2392)) {
// starting to compile string node (depth = 9)
  if (strlit2393 == NULL) {
    strlit2393 = alloc_String("}");
    gc_root(strlit2393);
  }
// compiled string node returning strlit2393 (depth = 9)
    gc_frame_newslot(strlit2393);
    if2388 = strlit2393;
  } else {
// starting to compile string node (depth = 9)
  if (strlit2394 == NULL) {
    strlit2394 = alloc_String("-nothing-");
    gc_root(strlit2394);
  }
// compiled string node returning strlit2394 (depth = 9)
    gc_frame_newslot(strlit2394);
    if2388 = strlit2394;
  }
// compiled if node returning if2388 (depth = 8)
    gc_frame_newslot(if2388);
    if2382 = if2388;
  }
stackframe = iftmpstackframe2382;
// compiled if node returning if2382 (depth = 7)
  *var_elcloser = if2382;
  if (if2382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2397 == NULL) {
    strlit2397 = alloc_String("-missing-");
    gc_root(strlit2397);
  }
// compiled string node returning strlit2397 (depth = 8)
  int op_slot_right_2396 = gc_frame_newslot(strlit2397);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elopener (depth = 8)
  int op_slot_left_2396 = gc_frame_newslot(*var_elopener);
  params[0] = strlit2397;
  partcv[0] = 1;
  Object opresult2399 = callmethod(*var_elopener, "==", 1, partcv, params);
// compiled op node returning opresult2399 (depth = 7)
  Object if2395 = done;
  if (istrue(opresult2399)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2400 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2402 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2401);
// compiled call node returning call2402 (depth = 11)
// compiled member node returning call2402 (depth = 10)
  partcv[0] = 0;
  Object call2403 = callmethod(call2402, "new",
    1, partcv, params);
  gc_frame_end(callframe2400);
// compiled call node returning call2403 (depth = 9)
// compiled member node returning call2403 (depth = 8)
  *var_suggestion = call2403;
  if (call2403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2404 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2405 = alloc_Block(NULL, NULL, "parser", 773);
  gc_frame_newslot(block2405);
// method "_apply"
  block_savedest(block2405);
  Object closure2406 = createclosure(2, "_apply");
  setclosureframe(closure2406, stackframe);
  addtoclosure(closure2406, var_statementToken);
  addtoclosure(closure2406, selfslot);
  struct UserObject *uo2406 = (struct UserObject*)block2405;
  uo2406->data[0] = (Object)closure2406;
  Method *meth_meth_parser__apply2406 = addmethod2pos(block2405, "_apply", &meth_parser__apply2406, 0);
  int argcv_meth_parser__apply2406[] = {1};
  meth_meth_parser__apply2406->type = alloc_MethodType(1, argcv_meth_parser__apply2406);
  meth_meth_parser__apply2406->definitionModule = modulename;
  meth_meth_parser__apply2406->definitionLine = 771;
// compiled block node returning block2405 (depth = 9)
  gc_frame_newslot(block2405);
// call case 4: self request
  params[0] = block2405;
  partcv[0] = 1;
  Object call2460 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2404);
// compiled call node returning call2460 (depth = 8)
  *var_nextTok = call2460;
  if (call2460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2463 = alloc_Boolean(0);
// compiled identifier node returning bool2463 (depth = 9)
  int op_slot_right_2462 = gc_frame_newslot(bool2463);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_2462 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2463;
  partcv[0] = 1;
  Object opresult2465 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2465 (depth = 8)
  Object if2461 = done;
  if (istrue(opresult2465)) {
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2466 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2467 == NULL) {
    strlit2467 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2467);
  }
// compiled string node returning strlit2467 (depth = 9)
  gc_frame_newslot(strlit2467);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2467;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2468 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2466);
// compiled call node returning call2468 (depth = 8)
    gc_frame_newslot(call2468);
    if2461 = call2468;
  } else {
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2471 == NULL) {
    strlit2471 = alloc_String("rparen");
    gc_root(strlit2471);
  }
// compiled string node returning strlit2471 (depth = 10)
  int op_slot_right_2470 = gc_frame_newslot(strlit2471);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2474 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2473);
// compiled call node returning call2474 (depth = 11)
// compiled member node returning call2474 (depth = 10)
  int op_slot_left_2470 = gc_frame_newslot(call2474);
  params[0] = strlit2471;
  partcv[0] = 1;
  Object opresult2475 = callmethod(call2474, "==", 1, partcv, params);
// compiled op node returning opresult2475 (depth = 9)
  Object if2469 = done;
  if (istrue(opresult2475)) {
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2477 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2477 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2479 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2479 (depth = 10)
  Object if2476 = done;
  if (istrue(opresult2479)) {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2480 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2481 == NULL) {
    strlit2481 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2481);
  }
// compiled string node returning strlit2481 (depth = 11)
  gc_frame_newslot(strlit2481);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2481;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2482 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2480);
// compiled call node returning call2482 (depth = 10)
    gc_frame_newslot(call2482);
    if2476 = call2482;
  } else {
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2483 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2484 == NULL) {
    strlit2484 = alloc_String("(");
    gc_root(strlit2484);
  }
// compiled string node returning strlit2484 (depth = 11)
  gc_frame_newslot(strlit2484);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2484;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2485 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2483);
// compiled call node returning call2485 (depth = 10)
    gc_frame_newslot(call2485);
    if2476 = call2485;
  }
// compiled if node returning if2476 (depth = 9)
    gc_frame_newslot(if2476);
    if2469 = if2476;
  } else {
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2488 == NULL) {
    strlit2488 = alloc_String("lbrace");
    gc_root(strlit2488);
  }
// compiled string node returning strlit2488 (depth = 11)
  int op_slot_right_2487 = gc_frame_newslot(strlit2488);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2490 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2491 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2490);
// compiled call node returning call2491 (depth = 12)
// compiled member node returning call2491 (depth = 11)
  int op_slot_left_2487 = gc_frame_newslot(call2491);
  params[0] = strlit2488;
  partcv[0] = 1;
  Object opresult2492 = callmethod(call2491, "==", 1, partcv, params);
// compiled op node returning opresult2492 (depth = 10)
  Object if2486 = done;
  if (istrue(opresult2492)) {
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2494 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2494 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2496 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2496 (depth = 11)
  Object if2493 = done;
  if (istrue(opresult2496)) {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2497 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2498 == NULL) {
    strlit2498 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit2498);
  }
// compiled string node returning strlit2498 (depth = 12)
  gc_frame_newslot(strlit2498);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2498;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2499 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2497);
// compiled call node returning call2499 (depth = 11)
    gc_frame_newslot(call2499);
    if2493 = call2499;
  } else {
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2500 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2501 == NULL) {
    strlit2501 = alloc_String("(");
    gc_root(strlit2501);
  }
// compiled string node returning strlit2501 (depth = 12)
  gc_frame_newslot(strlit2501);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2501;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2502 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2500);
// compiled call node returning call2502 (depth = 11)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2503 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2504 == NULL) {
    strlit2504 = alloc_String(") then");
    gc_root(strlit2504);
  }
// compiled string node returning strlit2504 (depth = 12)
  gc_frame_newslot(strlit2504);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2506 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2505);
// compiled call node returning call2506 (depth = 13)
// compiled member node returning call2506 (depth = 12)
  gc_frame_newslot(call2506);
// starting to compile identifier node (depth = 12)
  Object bool2507 = alloc_Boolean(1);
// compiled identifier node returning bool2507 (depth = 12)
  gc_frame_newslot(bool2507);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2504;
  params[1] = call2506;
  params[2] = bool2507;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2508 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2503);
// compiled call node returning call2508 (depth = 11)
    gc_frame_newslot(call2508);
    if2493 = call2508;
  }
// compiled if node returning if2493 (depth = 10)
    gc_frame_newslot(if2493);
    if2486 = if2493;
  } else {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2511 == NULL) {
    strlit2511 = alloc_String("identifier");
    gc_root(strlit2511);
  }
// compiled string node returning strlit2511 (depth = 12)
  int op_slot_right_2510 = gc_frame_newslot(strlit2511);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2513 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2514 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2513);
// compiled call node returning call2514 (depth = 13)
// compiled member node returning call2514 (depth = 12)
  int op_slot_left_2510 = gc_frame_newslot(call2514);
  params[0] = strlit2511;
  partcv[0] = 1;
  Object opresult2515 = callmethod(call2514, "==", 1, partcv, params);
// compiled op node returning opresult2515 (depth = 11)
  Object if2509 = done;
  if (istrue(opresult2515)) {
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2517 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2517 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2519 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2519 (depth = 12)
  Object if2516 = done;
  if (istrue(opresult2519)) {
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2520 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2521 == NULL) {
    strlit2521 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit2521);
  }
// compiled string node returning strlit2521 (depth = 13)
  gc_frame_newslot(strlit2521);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2521;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2522 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2520);
// compiled call node returning call2522 (depth = 12)
    gc_frame_newslot(call2522);
    if2516 = call2522;
  } else {
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2523 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2524 == NULL) {
    strlit2524 = alloc_String("(");
    gc_root(strlit2524);
  }
// compiled string node returning strlit2524 (depth = 13)
  gc_frame_newslot(strlit2524);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2524;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2525 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2523);
// compiled call node returning call2525 (depth = 12)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2526 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2527 == NULL) {
    strlit2527 = alloc_String(")");
    gc_root(strlit2527);
  }
// compiled string node returning strlit2527 (depth = 13)
  gc_frame_newslot(strlit2527);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2528 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_nextTok (depth = 15)
  partcv[0] = 0;
  Object call2529 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2528);
// compiled call node returning call2529 (depth = 14)
// compiled member node returning call2529 (depth = 13)
  gc_frame_newslot(call2529);
// starting to compile identifier node (depth = 13)
  Object bool2530 = alloc_Boolean(1);
// compiled identifier node returning bool2530 (depth = 13)
  gc_frame_newslot(bool2530);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2527;
  params[1] = call2529;
  params[2] = bool2530;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2531 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2526);
// compiled call node returning call2531 (depth = 12)
    gc_frame_newslot(call2531);
    if2516 = call2531;
  }
// compiled if node returning if2516 (depth = 11)
    gc_frame_newslot(if2516);
    if2509 = if2516;
  } else {
  }
// compiled if node returning if2509 (depth = 10)
    gc_frame_newslot(if2509);
    if2486 = if2509;
  }
// compiled if node returning if2486 (depth = 9)
    gc_frame_newslot(if2486);
    if2469 = if2486;
  }
// compiled if node returning if2469 (depth = 8)
    gc_frame_newslot(if2469);
    if2461 = if2469;
  }
// compiled if node returning if2461 (depth = 7)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2532 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2534 == NULL) {
    strlit2534 = alloc_String("condition in parentheses or braces after the 'elseif'.");
    gc_root(strlit2534);
  }
// compiled string node returning strlit2534 (depth = 9)
  int op_slot_right_2533 = gc_frame_newslot(strlit2534);
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2536 == NULL) {
    strlit2536 = alloc_String("an elseif statement must have a ");
    gc_root(strlit2536);
  }
// compiled string node returning strlit2536 (depth = 9)
  int op_slot_left_2533 = gc_frame_newslot(strlit2536);
  params[0] = strlit2534;
  partcv[0] = 1;
  Object opresult2537 = callmethod(strlit2536, "++", 1, partcv, params);
// compiled op node returning opresult2537 (depth = 8)
  gc_frame_newslot(opresult2537);
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2539 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2538);
// compiled call node returning call2539 (depth = 9)
// compiled member node returning call2539 (depth = 8)
  gc_frame_newslot(call2539);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2540 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2541 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2540);
// compiled call node returning call2541 (depth = 9)
// compiled member node returning call2541 (depth = 8)
  gc_frame_newslot(call2541);
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2537;
  params[1] = call2539;
  params[2] = call2541;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2542 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2532);
// compiled call node returning call2542 (depth = 7)
    gc_frame_newslot(call2542);
    if2395 = call2542;
  } else {
  }
// compiled if node returning if2395 (depth = 6)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2544 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2543);
// compiled call node returning call2544 (depth = 7)
// compiled member node returning call2544 (depth = 6)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2546 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2547 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2548 = alloc_Block(NULL, NULL, "parser", 805);
  gc_frame_newslot(block2548);
// method "_apply"
  block_savedest(block2548);
  Object closure2549 = createclosure(2, "_apply");
  setclosureframe(closure2549, stackframe);
  addtoclosure(closure2549, var_blocksOK);
  addtoclosure(closure2549, selfslot);
  struct UserObject *uo2549 = (struct UserObject*)block2548;
  uo2549->data[0] = (Object)closure2549;
  Method *meth_meth_parser__apply2549 = addmethod2pos(block2548, "_apply", &meth_parser__apply2549, 0);
  int argcv_meth_parser__apply2549[] = {0};
  meth_meth_parser__apply2549->type = alloc_MethodType(1, argcv_meth_parser__apply2549);
  meth_meth_parser__apply2549->definitionModule = modulename;
  meth_meth_parser__apply2549->definitionLine = 805;
// compiled block node returning block2548 (depth = 10)
  gc_frame_newslot(block2548);
// call case 4: self request
  params[0] = block2548;
  partcv[0] = 1;
  Object call2553 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2547);
// compiled call node returning call2553 (depth = 9)
  partcv[0] = 0;
  Object call2554 = callmethod(call2553, "not",
    1, partcv, params);
  gc_frame_end(callframe2546);
// compiled call node returning call2554 (depth = 8)
// compiled member node returning call2554 (depth = 7)
  Object if2545 = done;
  if (istrue(call2554)) {
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2555 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2557 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2556);
// compiled call node returning call2557 (depth = 11)
// compiled member node returning call2557 (depth = 10)
  partcv[0] = 0;
  Object call2558 = callmethod(call2557, "new",
    1, partcv, params);
  gc_frame_end(callframe2555);
// compiled call node returning call2558 (depth = 9)
// compiled member node returning call2558 (depth = 8)
  *var_suggestion = call2558;
  if (call2558 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2559 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2560 = alloc_Block(NULL, NULL, "parser", 808);
  gc_frame_newslot(block2560);
// method "_apply"
  block_savedest(block2560);
  Object closure2561 = createclosure(2, "_apply");
  setclosureframe(closure2561, stackframe);
  addtoclosure(closure2561, var_lastToken);
  addtoclosure(closure2561, selfslot);
  struct UserObject *uo2561 = (struct UserObject*)block2560;
  uo2561->data[0] = (Object)closure2561;
  Method *meth_meth_parser__apply2561 = addmethod2pos(block2560, "_apply", &meth_parser__apply2561, 0);
  int argcv_meth_parser__apply2561[] = {1};
  meth_meth_parser__apply2561->type = alloc_MethodType(1, argcv_meth_parser__apply2561);
  meth_meth_parser__apply2561->definitionModule = modulename;
  meth_meth_parser__apply2561->definitionLine = 806;
// compiled block node returning block2560 (depth = 9)
  gc_frame_newslot(block2560);
// call case 4: self request
  params[0] = block2560;
  partcv[0] = 1;
  Object call2588 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2559);
// compiled call node returning call2588 (depth = 8)
  *var_nextTok = call2588;
  if (call2588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2591 = alloc_Boolean(0);
// compiled identifier node returning bool2591 (depth = 9)
  int op_slot_right_2590 = gc_frame_newslot(bool2591);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_2590 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2591;
  partcv[0] = 1;
  Object opresult2593 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2593 (depth = 8)
  Object if2589 = done;
  if (istrue(opresult2593)) {
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2594 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array2595 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit2596 == NULL) {
    strlit2596 = alloc_String("rparen");
    gc_root(strlit2596);
  }
// compiled string node returning strlit2596 (depth = 11)
  params[0] = strlit2596;
  partcv[0] = 1;
  callmethod(array2595, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array2595 (depth = 10)
  gc_frame_newslot(array2595);
// call case 4: self request
  params[0] = array2595;
  partcv[0] = 1;
  Object call2597 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2594);
// compiled call node returning call2597 (depth = 9)
  *var_nextTok = call2597;
  if (call2597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2600 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2600 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2602 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2602 (depth = 9)
  Object if2599 = done;
  if (istrue(opresult2602)) {
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2603 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2604 == NULL) {
    strlit2604 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2604);
  }
// compiled string node returning strlit2604 (depth = 10)
  gc_frame_newslot(strlit2604);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2604;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2605 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2603);
// compiled call node returning call2605 (depth = 9)
    gc_frame_newslot(call2605);
    if2599 = call2605;
  } else {
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2606 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2608 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2607);
// compiled call node returning call2608 (depth = 11)
// compiled member node returning call2608 (depth = 10)
  gc_frame_newslot(call2608);
// starting to compile identifier node (depth = 10)
  Object bool2609 = alloc_Boolean(1);
// compiled identifier node returning bool2609 (depth = 10)
  gc_frame_newslot(bool2609);
// starting to compile identifier node (depth = 10)
  Object bool2610 = alloc_Boolean(0);
// compiled identifier node returning bool2610 (depth = 10)
  gc_frame_newslot(bool2610);
// starting to compile string node (depth = 10)
  if (strlit2611 == NULL) {
    strlit2611 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2611);
  }
// compiled string node returning strlit2611 (depth = 10)
  gc_frame_newslot(strlit2611);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2608;
  params[2] = bool2609;
  params[3] = bool2610;
  params[4] = strlit2611;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2612 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2606);
// compiled call node returning call2612 (depth = 9)
    gc_frame_newslot(call2612);
    if2599 = call2612;
  }
// compiled if node returning if2599 (depth = 8)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2613 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2614 == NULL) {
    strlit2614 = alloc_String("an elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2614);
  }
// compiled string node returning strlit2614 (depth = 9)
  gc_frame_newslot(strlit2614);
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2616 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2615);
// compiled call node returning call2616 (depth = 10)
// compiled member node returning call2616 (depth = 9)
  gc_frame_newslot(call2616);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2617 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2618 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2617);
// compiled call node returning call2618 (depth = 10)
// compiled member node returning call2618 (depth = 9)
  gc_frame_newslot(call2618);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2614;
  params[1] = call2616;
  params[2] = call2618;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2619 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2613);
// compiled call node returning call2619 (depth = 8)
    gc_frame_newslot(call2619);
    if2589 = call2619;
  } else {
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2621 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2621 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2623 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2623 (depth = 9)
  Object if2620 = done;
  if (istrue(opresult2623)) {
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2624 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2625 == NULL) {
    strlit2625 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2625);
  }
// compiled string node returning strlit2625 (depth = 10)
  gc_frame_newslot(strlit2625);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2625;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2626 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2624);
// compiled call node returning call2626 (depth = 9)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2627 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2628 == NULL) {
    strlit2628 = alloc_String("an elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2628);
  }
// compiled string node returning strlit2628 (depth = 10)
  gc_frame_newslot(strlit2628);
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2630 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2629);
// compiled call node returning call2630 (depth = 11)
// compiled member node returning call2630 (depth = 10)
  gc_frame_newslot(call2630);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2632 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2631);
// compiled call node returning call2632 (depth = 11)
// compiled member node returning call2632 (depth = 10)
  gc_frame_newslot(call2632);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2628;
  params[1] = call2630;
  params[2] = call2632;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2633 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2627);
// compiled call node returning call2633 (depth = 9)
    gc_frame_newslot(call2633);
    if2620 = call2633;
  } else {
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2634 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2636 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2635);
// compiled call node returning call2636 (depth = 11)
// compiled member node returning call2636 (depth = 10)
  gc_frame_newslot(call2636);
// starting to compile identifier node (depth = 10)
  Object bool2637 = alloc_Boolean(0);
// compiled identifier node returning bool2637 (depth = 10)
  gc_frame_newslot(bool2637);
// starting to compile identifier node (depth = 10)
  Object bool2638 = alloc_Boolean(1);
// compiled identifier node returning bool2638 (depth = 10)
  gc_frame_newslot(bool2638);
// starting to compile string node (depth = 10)
  if (strlit2639 == NULL) {
    strlit2639 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2639);
  }
// compiled string node returning strlit2639 (depth = 10)
  gc_frame_newslot(strlit2639);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2636;
  params[2] = bool2637;
  params[3] = bool2638;
  params[4] = strlit2639;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2640 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2634);
// compiled call node returning call2640 (depth = 9)
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2641 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2642 == NULL) {
    strlit2642 = alloc_String("4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2642);
  }
// compiled string node returning strlit2642 (depth = 10)
  gc_frame_newslot(strlit2642);
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2644 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2643);
// compiled call node returning call2644 (depth = 11)
// compiled member node returning call2644 (depth = 10)
  gc_frame_newslot(call2644);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2645 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2646 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2645);
// compiled call node returning call2646 (depth = 11)
// compiled member node returning call2646 (depth = 10)
  gc_frame_newslot(call2646);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2648 = alloc_Float64(1);
// compiled num node returning num2648 (depth = 11)
  int op_slot_right_2647 = gc_frame_newslot(num2648);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2651 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2650);
// compiled call node returning call2651 (depth = 12)
// compiled member node returning call2651 (depth = 11)
  int op_slot_left_2647 = gc_frame_newslot(call2651);
  params[0] = num2648;
  partcv[0] = 1;
  Object diff2652 = callmethod(call2651, "-", 1, partcv, params);
// compiled op node returning diff2652 (depth = 10)
  gc_frame_newslot(diff2652);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2642;
  params[1] = call2644;
  params[2] = call2646;
  params[3] = diff2652;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2653 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2641);
// compiled call node returning call2653 (depth = 9)
    gc_frame_newslot(call2653);
    if2620 = call2653;
  }
// compiled if node returning if2620 (depth = 8)
    gc_frame_newslot(if2620);
    if2589 = if2620;
  }
// compiled if node returning if2589 (depth = 7)
    gc_frame_newslot(if2589);
    if2545 = if2589;
  } else {
  }
// compiled if node returning if2545 (depth = 6)
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elcloser (depth = 8)
  int op_slot_right_2655 = gc_frame_newslot(*var_elcloser);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2657 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2658 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2657);
// compiled call node returning call2658 (depth = 9)
// compiled member node returning call2658 (depth = 8)
  int op_slot_left_2655 = gc_frame_newslot(call2658);
  params[0] = *var_elcloser;
  partcv[0] = 1;
  Object opresult2659 = callmethod(call2658, "!=", 1, partcv, params);
// compiled op node returning opresult2659 (depth = 7)
  Object if2654 = done;
  if (istrue(opresult2659)) {
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2661 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2660);
// compiled call node returning call2661 (depth = 8)
// compiled member node returning call2661 (depth = 7)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2662 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2664 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2663);
// compiled call node returning call2664 (depth = 11)
// compiled member node returning call2664 (depth = 10)
  partcv[0] = 0;
  Object call2665 = callmethod(call2664, "new",
    1, partcv, params);
  gc_frame_end(callframe2662);
// compiled call node returning call2665 (depth = 9)
// compiled member node returning call2665 (depth = 8)
  *var_suggestion = call2665;
  if (call2665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2666 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2667 == NULL) {
    strlit2667 = alloc_String(")");
    gc_root(strlit2667);
  }
// compiled string node returning strlit2667 (depth = 8)
  gc_frame_newslot(strlit2667);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2667;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2668 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2666);
// compiled call node returning call2668 (depth = 7)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2669 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2672 == NULL) {
    strlit2672 = alloc_String("'.");
    gc_root(strlit2672);
  }
// compiled string node returning strlit2672 (depth = 10)
  int op_slot_right_2671 = gc_frame_newslot(strlit2672);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_elcloser (depth = 11)
  int op_slot_right_2674 = gc_frame_newslot(*var_elcloser);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2677 == NULL) {
    strlit2677 = alloc_String("' must end with a '");
    gc_root(strlit2677);
  }
// compiled string node returning strlit2677 (depth = 12)
  int op_slot_right_2676 = gc_frame_newslot(strlit2677);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_elopener (depth = 13)
  int op_slot_right_2679 = gc_frame_newslot(*var_elopener);
// starting to compile string node (depth = 13)
  if (strlit2681 == NULL) {
    strlit2681 = alloc_String("'");
    gc_root(strlit2681);
  }
// compiled string node returning strlit2681 (depth = 13)
  int op_slot_left_2679 = gc_frame_newslot(strlit2681);
  params[0] = *var_elopener;
  partcv[0] = 1;
  Object opresult2682 = callmethod(strlit2681, "++", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 12)
  int op_slot_left_2676 = gc_frame_newslot(opresult2682);
  params[0] = strlit2677;
  partcv[0] = 1;
  Object opresult2683 = callmethod(opresult2682, "++", 1, partcv, params);
// compiled op node returning opresult2683 (depth = 11)
  int op_slot_left_2674 = gc_frame_newslot(opresult2683);
  params[0] = *var_elcloser;
  partcv[0] = 1;
  Object opresult2684 = callmethod(opresult2683, "++", 1, partcv, params);
// compiled op node returning opresult2684 (depth = 10)
  int op_slot_left_2671 = gc_frame_newslot(opresult2684);
  params[0] = strlit2672;
  partcv[0] = 1;
  Object opresult2685 = callmethod(opresult2684, "++", 1, partcv, params);
// compiled op node returning opresult2685 (depth = 9)
  int op_slot_right_2670 = gc_frame_newslot(opresult2685);
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2687 == NULL) {
    strlit2687 = alloc_String("an expression beginning with a ");
    gc_root(strlit2687);
  }
// compiled string node returning strlit2687 (depth = 9)
  int op_slot_left_2670 = gc_frame_newslot(strlit2687);
  params[0] = opresult2685;
  partcv[0] = 1;
  Object opresult2688 = callmethod(strlit2687, "++", 1, partcv, params);
// compiled op node returning opresult2688 (depth = 8)
  gc_frame_newslot(opresult2688);
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2690 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2689);
// compiled call node returning call2690 (depth = 9)
// compiled member node returning call2690 (depth = 8)
  gc_frame_newslot(call2690);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2693 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2692);
// compiled call node returning call2693 (depth = 10)
// compiled member node returning call2693 (depth = 9)
  int op_slot_right_2691 = gc_frame_newslot(call2693);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2696 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2695);
// compiled call node returning call2696 (depth = 10)
// compiled member node returning call2696 (depth = 9)
  int op_slot_left_2691 = gc_frame_newslot(call2696);
  params[0] = call2693;
  partcv[0] = 1;
  Object sum2697 = callmethod(call2696, "+", 1, partcv, params);
// compiled op node returning sum2697 (depth = 8)
  gc_frame_newslot(sum2697);
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2688;
  params[1] = call2690;
  params[2] = sum2697;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2698 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2669);
// compiled call node returning call2698 (depth = 7)
    gc_frame_newslot(call2698);
    if2654 = call2698;
  } else {
  }
// compiled if node returning if2654 (depth = 6)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2700 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2699);
// compiled call node returning call2700 (depth = 7)
// compiled member node returning call2700 (depth = 6)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2702 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2701);
// compiled call node returning call2702 (depth = 8)
// compiled member node returning call2702 (depth = 7)
  *var_econd = call2702;
  if (call2702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2707 == NULL) {
    strlit2707 = alloc_String("then");
    gc_root(strlit2707);
  }
// compiled string node returning strlit2707 (depth = 9)
  int op_slot_right_2706 = gc_frame_newslot(strlit2707);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2710 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2709);
// compiled call node returning call2710 (depth = 10)
// compiled member node returning call2710 (depth = 9)
  int op_slot_left_2706 = gc_frame_newslot(call2710);
  params[0] = strlit2707;
  partcv[0] = 1;
  Object opresult2711 = callmethod(call2710, "==", 1, partcv, params);
// compiled op node returning opresult2711 (depth = 8)
  int op_slot_right_2705 = gc_frame_newslot(opresult2711);
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2713 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2714 == NULL) {
    strlit2714 = alloc_String("identifier");
    gc_root(strlit2714);
  }
// compiled string node returning strlit2714 (depth = 9)
  gc_frame_newslot(strlit2714);
// call case 4: self request
  params[0] = strlit2714;
  partcv[0] = 1;
  Object call2715 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2713);
// compiled call node returning call2715 (depth = 8)
  int op_slot_left_2705 = gc_frame_newslot(call2715);
  params[0] = opresult2711;
  partcv[0] = 1;
  Object opresult2716 = callmethod(call2715, "&&", 1, partcv, params);
// compiled op node returning opresult2716 (depth = 7)
  Object if2704 = done;
  if (istrue(opresult2716)) {
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2718 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2717);
// compiled call node returning call2718 (depth = 8)
// compiled member node returning call2718 (depth = 7)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile array node (depth = 8)
  Object array2719 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2719 (depth = 8)
  *var_ebody = array2719;
  if (array2719 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2704 = done;
  } else {
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2721 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2722 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2723 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2722);
// compiled call node returning call2723 (depth = 11)
// compiled member node returning call2723 (depth = 10)
  partcv[0] = 0;
  Object call2724 = callmethod(call2723, "new",
    1, partcv, params);
  gc_frame_end(callframe2721);
// compiled call node returning call2724 (depth = 9)
// compiled member node returning call2724 (depth = 8)
  *var_suggestion = call2724;
  if (call2724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2727 == NULL) {
    strlit2727 = alloc_String("lbrace");
    gc_root(strlit2727);
  }
// compiled string node returning strlit2727 (depth = 9)
  int op_slot_right_2726 = gc_frame_newslot(strlit2727);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2729 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2730 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2729);
// compiled call node returning call2730 (depth = 10)
// compiled member node returning call2730 (depth = 9)
  int op_slot_left_2726 = gc_frame_newslot(call2730);
  params[0] = strlit2727;
  partcv[0] = 1;
  Object opresult2731 = callmethod(call2730, "==", 1, partcv, params);
// compiled op node returning opresult2731 (depth = 8)
  Object if2725 = done;
  if (istrue(opresult2731)) {
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2732 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2733 = alloc_Boolean(0);
// compiled identifier node returning bool2733 (depth = 10)
  gc_frame_newslot(bool2733);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2733;
  partcv[0] = 2;
  Object call2734 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2732);
// compiled call node returning call2734 (depth = 9)
  *var_closingBrace = call2734;
  if (call2734 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2737 = alloc_Boolean(0);
// compiled identifier node returning bool2737 (depth = 10)
  int op_slot_right_2736 = gc_frame_newslot(bool2737);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2740 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2739);
// compiled call node returning call2740 (depth = 11)
// compiled member node returning call2740 (depth = 10)
  int op_slot_left_2736 = gc_frame_newslot(call2740);
  params[0] = bool2737;
  partcv[0] = 1;
  Object opresult2741 = callmethod(call2740, "==", 1, partcv, params);
// compiled op node returning opresult2741 (depth = 9)
  Object if2735 = done;
  if (istrue(opresult2741)) {
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2743 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2746 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2745);
// compiled call node returning call2746 (depth = 12)
// compiled member node returning call2746 (depth = 11)
  int op_slot_left_2743 = gc_frame_newslot(call2746);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2747 = callmethod(call2746, "==", 1, partcv, params);
// compiled op node returning opresult2747 (depth = 10)
  Object if2742 = done;
  if (istrue(opresult2747)) {
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2748 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2749 = alloc_Boolean(1);
// compiled identifier node returning bool2749 (depth = 11)
  gc_frame_newslot(bool2749);
// starting to compile identifier node (depth = 11)
  Object bool2750 = alloc_Boolean(0);
// compiled identifier node returning bool2750 (depth = 11)
  gc_frame_newslot(bool2750);
// starting to compile string node (depth = 11)
  if (strlit2751 == NULL) {
    strlit2751 = alloc_String(" then {}");
    gc_root(strlit2751);
  }
// compiled string node returning strlit2751 (depth = 11)
  gc_frame_newslot(strlit2751);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2749;
  params[2] = bool2750;
  params[3] = strlit2751;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2752 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2748);
// compiled call node returning call2752 (depth = 10)
    gc_frame_newslot(call2752);
    if2742 = call2752;
  } else {
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2753 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2754 = alloc_Boolean(1);
// compiled identifier node returning bool2754 (depth = 11)
  gc_frame_newslot(bool2754);
// starting to compile identifier node (depth = 11)
  Object bool2755 = alloc_Boolean(0);
// compiled identifier node returning bool2755 (depth = 11)
  gc_frame_newslot(bool2755);
// starting to compile string node (depth = 11)
  if (strlit2756 == NULL) {
    strlit2756 = alloc_String(" then {");
    gc_root(strlit2756);
  }
// compiled string node returning strlit2756 (depth = 11)
  gc_frame_newslot(strlit2756);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2754;
  params[2] = bool2755;
  params[3] = strlit2756;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2757 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2753);
// compiled call node returning call2757 (depth = 10)
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2758 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2760 = alloc_Float64(0.1);
// compiled num node returning num2760 (depth = 12)
  int op_slot_right_2759 = gc_frame_newslot(num2760);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2762 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2764 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2763);
// compiled call node returning call2764 (depth = 15)
// compiled member node returning call2764 (depth = 14)
  partcv[0] = 0;
  Object call2765 = callmethod(call2764, "line",
    1, partcv, params);
  gc_frame_end(callframe2762);
// compiled call node returning call2765 (depth = 13)
// compiled member node returning call2765 (depth = 12)
  int op_slot_left_2759 = gc_frame_newslot(call2765);
  params[0] = num2760;
  partcv[0] = 1;
  Object sum2766 = callmethod(call2765, "+", 1, partcv, params);
// compiled op node returning sum2766 (depth = 11)
  gc_frame_newslot(sum2766);
// starting to compile string node (depth = 11)
  if (strlit2767 == NULL) {
    strlit2767 = alloc_String("}");
    gc_root(strlit2767);
  }
// compiled string node returning strlit2767 (depth = 11)
  gc_frame_newslot(strlit2767);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2766;
  params[1] = strlit2767;
  partcv[0] = 2;
  Object call2768 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2758);
// compiled call node returning call2768 (depth = 10)
    gc_frame_newslot(call2768);
    if2742 = call2768;
  }
// compiled if node returning if2742 (depth = 9)
    gc_frame_newslot(if2742);
    if2735 = if2742;
  } else {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2769 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2770 = alloc_Boolean(1);
// compiled identifier node returning bool2770 (depth = 10)
  gc_frame_newslot(bool2770);
// starting to compile identifier node (depth = 10)
  Object bool2771 = alloc_Boolean(0);
// compiled identifier node returning bool2771 (depth = 10)
  gc_frame_newslot(bool2771);
// starting to compile string node (depth = 10)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String(" then {");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 10)
  gc_frame_newslot(strlit2772);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2770;
  params[2] = bool2771;
  params[3] = strlit2772;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2773 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2769);
// compiled call node returning call2773 (depth = 9)
    gc_frame_newslot(call2773);
    if2735 = call2773;
  }
// compiled if node returning if2735 (depth = 8)
    gc_frame_newslot(if2735);
    if2725 = if2735;
  } else {
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2774 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2775 = alloc_Boolean(1);
// compiled identifier node returning bool2775 (depth = 10)
  gc_frame_newslot(bool2775);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2775;
  partcv[0] = 2;
  Object call2776 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2774);
// compiled call node returning call2776 (depth = 9)
  *var_closingBrace = call2776;
  if (call2776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2779 = alloc_Boolean(0);
// compiled identifier node returning bool2779 (depth = 10)
  int op_slot_right_2778 = gc_frame_newslot(bool2779);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2782 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2781);
// compiled call node returning call2782 (depth = 11)
// compiled member node returning call2782 (depth = 10)
  int op_slot_left_2778 = gc_frame_newslot(call2782);
  params[0] = bool2779;
  partcv[0] = 1;
  Object opresult2783 = callmethod(call2782, "==", 1, partcv, params);
// compiled op node returning opresult2783 (depth = 9)
  Object if2777 = done;
  if (istrue(opresult2783)) {
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2785 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2788 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2787);
// compiled call node returning call2788 (depth = 12)
// compiled member node returning call2788 (depth = 11)
  int op_slot_left_2785 = gc_frame_newslot(call2788);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2789 = callmethod(call2788, "==", 1, partcv, params);
// compiled op node returning opresult2789 (depth = 10)
  Object if2784 = done;
  if (istrue(opresult2789)) {
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2790 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2791 == NULL) {
    strlit2791 = alloc_String(" then {}");
    gc_root(strlit2791);
  }
// compiled string node returning strlit2791 (depth = 11)
  gc_frame_newslot(strlit2791);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2791;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2792 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2790);
// compiled call node returning call2792 (depth = 10)
    gc_frame_newslot(call2792);
    if2784 = call2792;
  } else {
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2793 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2794 == NULL) {
    strlit2794 = alloc_String(" then {");
    gc_root(strlit2794);
  }
// compiled string node returning strlit2794 (depth = 11)
  gc_frame_newslot(strlit2794);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2794;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2795 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2793);
// compiled call node returning call2795 (depth = 10)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2796 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2798 = alloc_Float64(0.1);
// compiled num node returning num2798 (depth = 12)
  int op_slot_right_2797 = gc_frame_newslot(num2798);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2800 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2802 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2801);
// compiled call node returning call2802 (depth = 15)
// compiled member node returning call2802 (depth = 14)
  partcv[0] = 0;
  Object call2803 = callmethod(call2802, "line",
    1, partcv, params);
  gc_frame_end(callframe2800);
// compiled call node returning call2803 (depth = 13)
// compiled member node returning call2803 (depth = 12)
  int op_slot_left_2797 = gc_frame_newslot(call2803);
  params[0] = num2798;
  partcv[0] = 1;
  Object sum2804 = callmethod(call2803, "+", 1, partcv, params);
// compiled op node returning sum2804 (depth = 11)
  gc_frame_newslot(sum2804);
// starting to compile string node (depth = 11)
  if (strlit2805 == NULL) {
    strlit2805 = alloc_String("}");
    gc_root(strlit2805);
  }
// compiled string node returning strlit2805 (depth = 11)
  gc_frame_newslot(strlit2805);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2804;
  params[1] = strlit2805;
  partcv[0] = 2;
  Object call2806 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2796);
// compiled call node returning call2806 (depth = 10)
    gc_frame_newslot(call2806);
    if2784 = call2806;
  }
// compiled if node returning if2784 (depth = 9)
    gc_frame_newslot(if2784);
    if2777 = if2784;
  } else {
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2807 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2808 == NULL) {
    strlit2808 = alloc_String(" then {");
    gc_root(strlit2808);
  }
// compiled string node returning strlit2808 (depth = 10)
  gc_frame_newslot(strlit2808);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2808;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2809 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2807);
// compiled call node returning call2809 (depth = 9)
    gc_frame_newslot(call2809);
    if2777 = call2809;
  }
// compiled if node returning if2777 (depth = 8)
    gc_frame_newslot(if2777);
    if2725 = if2777;
  }
// compiled if node returning if2725 (depth = 7)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2810 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2811 == NULL) {
    strlit2811 = alloc_String("an elseif statement must have 'then' after the expression in parentheses.");
    gc_root(strlit2811);
  }
// compiled string node returning strlit2811 (depth = 8)
  gc_frame_newslot(strlit2811);
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2813 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2812);
// compiled call node returning call2813 (depth = 9)
// compiled member node returning call2813 (depth = 8)
  gc_frame_newslot(call2813);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2815 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2814);
// compiled call node returning call2815 (depth = 9)
// compiled member node returning call2815 (depth = 8)
  gc_frame_newslot(call2815);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2811;
  params[1] = call2813;
  params[2] = call2815;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2816 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2810);
// compiled call node returning call2816 (depth = 7)
    gc_frame_newslot(call2816);
    if2704 = call2816;
  }
// compiled if node returning if2704 (depth = 6)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2819 == NULL) {
    strlit2819 = alloc_String("lbrace");
    gc_root(strlit2819);
  }
// compiled string node returning strlit2819 (depth = 8)
  int op_slot_right_2818 = gc_frame_newslot(strlit2819);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2821 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2822 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2821);
// compiled call node returning call2822 (depth = 9)
// compiled member node returning call2822 (depth = 8)
  int op_slot_left_2818 = gc_frame_newslot(call2822);
  params[0] = strlit2819;
  partcv[0] = 1;
  Object opresult2823 = callmethod(call2822, "!=", 1, partcv, params);
// compiled op node returning opresult2823 (depth = 7)
  Object if2817 = done;
  if (istrue(opresult2823)) {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2824 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2826 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2825);
// compiled call node returning call2826 (depth = 11)
// compiled member node returning call2826 (depth = 10)
  partcv[0] = 0;
  Object call2827 = callmethod(call2826, "new",
    1, partcv, params);
  gc_frame_end(callframe2824);
// compiled call node returning call2827 (depth = 9)
// compiled member node returning call2827 (depth = 8)
  *var_suggestion = call2827;
  if (call2827 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2828 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2829 = alloc_Boolean(1);
// compiled identifier node returning bool2829 (depth = 9)
  gc_frame_newslot(bool2829);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2829;
  partcv[0] = 2;
  Object call2830 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2828);
// compiled call node returning call2830 (depth = 8)
  *var_closingBrace = call2830;
  if (call2830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2833 = alloc_Boolean(0);
// compiled identifier node returning bool2833 (depth = 9)
  int op_slot_right_2832 = gc_frame_newslot(bool2833);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2835 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2836 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2835);
// compiled call node returning call2836 (depth = 10)
// compiled member node returning call2836 (depth = 9)
  int op_slot_left_2832 = gc_frame_newslot(call2836);
  params[0] = bool2833;
  partcv[0] = 1;
  Object opresult2837 = callmethod(call2836, "==", 1, partcv, params);
// compiled op node returning opresult2837 (depth = 8)
  Object if2831 = done;
  if (istrue(opresult2837)) {
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2839 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2841 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2842 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2841);
// compiled call node returning call2842 (depth = 11)
// compiled member node returning call2842 (depth = 10)
  int op_slot_left_2839 = gc_frame_newslot(call2842);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2843 = callmethod(call2842, "==", 1, partcv, params);
// compiled op node returning opresult2843 (depth = 9)
  Object if2838 = done;
  if (istrue(opresult2843)) {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2844 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2845 = alloc_Boolean(0);
// compiled identifier node returning bool2845 (depth = 10)
  gc_frame_newslot(bool2845);
// starting to compile identifier node (depth = 10)
  Object bool2846 = alloc_Boolean(1);
// compiled identifier node returning bool2846 (depth = 10)
  gc_frame_newslot(bool2846);
// starting to compile string node (depth = 10)
  if (strlit2847 == NULL) {
    strlit2847 = alloc_String("then {}");
    gc_root(strlit2847);
  }
// compiled string node returning strlit2847 (depth = 10)
  gc_frame_newslot(strlit2847);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2845;
  params[2] = bool2846;
  params[3] = strlit2847;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2848 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2844);
// compiled call node returning call2848 (depth = 9)
    gc_frame_newslot(call2848);
    if2838 = call2848;
  } else {
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2849 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2851 = alloc_Float64(0.1);
// compiled num node returning num2851 (depth = 11)
  int op_slot_right_2850 = gc_frame_newslot(num2851);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2853 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2854 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2855 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2854);
// compiled call node returning call2855 (depth = 14)
// compiled member node returning call2855 (depth = 13)
  partcv[0] = 0;
  Object call2856 = callmethod(call2855, "line",
    1, partcv, params);
  gc_frame_end(callframe2853);
// compiled call node returning call2856 (depth = 12)
// compiled member node returning call2856 (depth = 11)
  int op_slot_left_2850 = gc_frame_newslot(call2856);
  params[0] = num2851;
  partcv[0] = 1;
  Object sum2857 = callmethod(call2856, "+", 1, partcv, params);
// compiled op node returning sum2857 (depth = 10)
  gc_frame_newslot(sum2857);
// starting to compile string node (depth = 10)
  if (strlit2858 == NULL) {
    strlit2858 = alloc_String("}");
    gc_root(strlit2858);
  }
// compiled string node returning strlit2858 (depth = 10)
  gc_frame_newslot(strlit2858);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2857;
  params[1] = strlit2858;
  partcv[0] = 2;
  Object call2859 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2849);
// compiled call node returning call2859 (depth = 9)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2860 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2861 = alloc_Boolean(0);
// compiled identifier node returning bool2861 (depth = 10)
  gc_frame_newslot(bool2861);
// starting to compile identifier node (depth = 10)
  Object bool2862 = alloc_Boolean(1);
// compiled identifier node returning bool2862 (depth = 10)
  gc_frame_newslot(bool2862);
// starting to compile string node (depth = 10)
  if (strlit2863 == NULL) {
    strlit2863 = alloc_String("then {");
    gc_root(strlit2863);
  }
// compiled string node returning strlit2863 (depth = 10)
  gc_frame_newslot(strlit2863);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2861;
  params[2] = bool2862;
  params[3] = strlit2863;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2864 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2860);
// compiled call node returning call2864 (depth = 9)
    gc_frame_newslot(call2864);
    if2838 = call2864;
  }
// compiled if node returning if2838 (depth = 8)
    gc_frame_newslot(if2838);
    if2831 = if2838;
  } else {
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2865 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2866 = alloc_Boolean(0);
// compiled identifier node returning bool2866 (depth = 9)
  gc_frame_newslot(bool2866);
// starting to compile identifier node (depth = 9)
  Object bool2867 = alloc_Boolean(1);
// compiled identifier node returning bool2867 (depth = 9)
  gc_frame_newslot(bool2867);
// starting to compile string node (depth = 9)
  if (strlit2868 == NULL) {
    strlit2868 = alloc_String("then {");
    gc_root(strlit2868);
  }
// compiled string node returning strlit2868 (depth = 9)
  gc_frame_newslot(strlit2868);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2866;
  params[2] = bool2867;
  params[3] = strlit2868;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2869 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2865);
// compiled call node returning call2869 (depth = 8)
    gc_frame_newslot(call2869);
    if2831 = call2869;
  }
// compiled if node returning if2831 (depth = 7)
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2870 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2871 == NULL) {
    strlit2871 = alloc_String("an elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2871);
  }
// compiled string node returning strlit2871 (depth = 8)
  gc_frame_newslot(strlit2871);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2872 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2873 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2872);
// compiled call node returning call2873 (depth = 9)
// compiled member node returning call2873 (depth = 8)
  gc_frame_newslot(call2873);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2875 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2876 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2875);
// compiled call node returning call2876 (depth = 10)
// compiled member node returning call2876 (depth = 9)
  int op_slot_right_2874 = gc_frame_newslot(call2876);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2879 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2878);
// compiled call node returning call2879 (depth = 10)
// compiled member node returning call2879 (depth = 9)
  int op_slot_left_2874 = gc_frame_newslot(call2879);
  params[0] = call2876;
  partcv[0] = 1;
  Object sum2880 = callmethod(call2879, "+", 1, partcv, params);
// compiled op node returning sum2880 (depth = 8)
  gc_frame_newslot(sum2880);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2871;
  params[1] = call2873;
  params[2] = sum2880;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2881 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2870);
// compiled call node returning call2881 (depth = 7)
    gc_frame_newslot(call2881);
    if2817 = call2881;
  } else {
  }
// compiled if node returning if2817 (depth = 6)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2882 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2883 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2882);
// compiled call node returning call2883 (depth = 7)
// compiled member node returning call2883 (depth = 6)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2887 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2886);
// compiled call node returning call2887 (depth = 9)
// compiled member node returning call2887 (depth = 8)
  int op_slot_right_2885 = gc_frame_newslot(call2887);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2889 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2890 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2889);
// compiled call node returning call2890 (depth = 9)
// compiled member node returning call2890 (depth = 8)
  int op_slot_left_2885 = gc_frame_newslot(call2890);
  params[0] = call2887;
  partcv[0] = 1;
  Object opresult2891 = callmethod(call2890, "==", 1, partcv, params);
// compiled op node returning opresult2891 (depth = 7)
  Object if2884 = done;
  if (istrue(opresult2891)) {
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2893 = alloc_Float64(1);
// compiled num node returning num2893 (depth = 9)
  int op_slot_right_2892 = gc_frame_newslot(num2893);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2895 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2896 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2895);
// compiled call node returning call2896 (depth = 10)
// compiled member node returning call2896 (depth = 9)
  int op_slot_left_2892 = gc_frame_newslot(call2896);
  params[0] = num2893;
  partcv[0] = 1;
  Object diff2897 = callmethod(call2896, "-", 1, partcv, params);
// compiled op node returning diff2897 (depth = 8)
  *var_minIndentLevel = diff2897;
  if (diff2897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2884 = done;
  } else {
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2884 = done;
  }
// compiled if node returning if2884 (depth = 6)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2900 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2901 = alloc_Block(NULL, NULL, "parser", 899);
  gc_frame_newslot(block2901);
// method "_apply"
  block_savedest(block2901);
  Object closure2902 = createclosure(1, "_apply");
  setclosureframe(closure2902, stackframe);
  addtoclosure(closure2902, selfslot);
  struct UserObject *uo2902 = (struct UserObject*)block2901;
  uo2902->data[0] = (Object)closure2902;
  Method *meth_meth_parser__apply2902 = addmethod2pos(block2901, "_apply", &meth_parser__apply2902, 0);
  int argcv_meth_parser__apply2902[] = {0};
  meth_meth_parser__apply2902->type = alloc_MethodType(1, argcv_meth_parser__apply2902);
  meth_meth_parser__apply2902->definitionModule = modulename;
  meth_meth_parser__apply2902->definitionLine = 895;
// compiled block node returning block2901 (depth = 7)
  gc_frame_newslot(block2901);
// starting to compile block node (depth = 7)
  Object block2909 = alloc_Block(NULL, NULL, "parser", 899);
  gc_frame_newslot(block2909);
// method "_apply"
  block_savedest(block2909);
  Object closure2910 = createclosure(8, "_apply");
  setclosureframe(closure2910, stackframe);
  addtoclosure(closure2910, var_errormessages);
  addtoclosure(closure2910, var_btok);
  addtoclosure(closure2910, var_lastToken);
  addtoclosure(closure2910, var_sym);
  addtoclosure(closure2910, var_values);
  addtoclosure(closure2910, var_v);
  addtoclosure(closure2910, var_ebody);
  addtoclosure(closure2910, selfslot);
  struct UserObject *uo2910 = (struct UserObject*)block2909;
  uo2910->data[0] = (Object)closure2910;
  Method *meth_meth_parser__apply2910 = addmethod2pos(block2909, "_apply", &meth_parser__apply2910, 0);
  int argcv_meth_parser__apply2910[] = {0};
  meth_meth_parser__apply2910->type = alloc_MethodType(1, argcv_meth_parser__apply2910);
  meth_meth_parser__apply2910->definitionModule = modulename;
  meth_meth_parser__apply2910->definitionLine = 899;
// compiled block node returning block2909 (depth = 7)
  gc_frame_newslot(block2909);
// call case 5: prelude request
  params[0] = block2901;
  params[1] = block2909;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2970 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2900);
// compiled call node returning call2970 (depth = 6)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2972 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2971);
// compiled call node returning call2972 (depth = 7)
// compiled member node returning call2972 (depth = 6)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile array node (depth = 7)
  Object array2973 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2973 (depth = 7)
  *var_newelse = array2973;
  if (array2973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2975 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 4: self request
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2976 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2975);
// compiled call node returning call2976 (depth = 7)
  *var_eif = call2976;
  if (call2976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2978 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2979 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2978);
// compiled call node returning call2979 (depth = 6)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply3083(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3084 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe3085 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit3086 == NULL) {
    strlit3086 = alloc_String("rbrace");
    gc_root(strlit3086);
  }
// compiled string node returning strlit3086 (depth = 10)
  gc_frame_newslot(strlit3086);
// call case 4: self request
  params[0] = strlit3086;
  partcv[0] = 1;
  Object call3087 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3085);
// compiled call node returning call3087 (depth = 9)
  partcv[0] = 0;
  Object call3088 = callmethod(call3087, "not",
    1, partcv, params);
  gc_frame_end(callframe3084);
// compiled call node returning call3088 (depth = 8)
// compiled member node returning call3088 (depth = 7)
  gc_frame_end(frame);
  return call3088;
}
Object meth_parser__apply3096(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3097 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3098 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3097);
// compiled call node returning call3098 (depth = 13)
// compiled member node returning call3098 (depth = 12)
  gc_frame_end(frame);
  return call3098;
}
Object meth_parser__apply3091(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3093 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe3094 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block3095 = alloc_Block(NULL, NULL, "parser", 954);
  gc_frame_newslot(block3095);
// method "_apply"
  block_savedest(block3095);
  Object closure3096 = createclosure(1, "_apply");
  setclosureframe(closure3096, stackframe);
  addtoclosure(closure3096, selfslot);
  struct UserObject *uo3096 = (struct UserObject*)block3095;
  uo3096->data[0] = (Object)closure3096;
  Method *meth_meth_parser__apply3096 = addmethod2pos(block3095, "_apply", &meth_parser__apply3096, 0);
  int argcv_meth_parser__apply3096[] = {0};
  meth_meth_parser__apply3096->type = alloc_MethodType(1, argcv_meth_parser__apply3096);
  meth_meth_parser__apply3096->definitionModule = modulename;
  meth_meth_parser__apply3096->definitionLine = 954;
// compiled block node returning block3095 (depth = 11)
  gc_frame_newslot(block3095);
// call case 4: self request
  params[0] = block3095;
  partcv[0] = 1;
  Object call3100 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3094);
// compiled call node returning call3100 (depth = 10)
  partcv[0] = 0;
  Object call3101 = callmethod(call3100, "not",
    1, partcv, params);
  gc_frame_end(callframe3093);
// compiled call node returning call3101 (depth = 9)
// compiled member node returning call3101 (depth = 8)
  Object if3092 = done;
  if (istrue(call3101)) {
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3102 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3104 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3103);
// compiled call node returning call3104 (depth = 12)
// compiled member node returning call3104 (depth = 11)
  partcv[0] = 0;
  Object call3105 = callmethod(call3104, "new",
    1, partcv, params);
  gc_frame_end(callframe3102);
// compiled call node returning call3105 (depth = 10)
// compiled member node returning call3105 (depth = 9)
  *var_suggestion = call3105;
  if (call3105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3106 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool3107 = alloc_Boolean(0);
// compiled identifier node returning bool3107 (depth = 10)
  gc_frame_newslot(bool3107);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3107;
  partcv[0] = 2;
  Object call3108 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3106);
// compiled call node returning call3108 (depth = 9)
  *var_closingBrace = call3108;
  if (call3108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool3111 = alloc_Boolean(0);
// compiled identifier node returning bool3111 (depth = 10)
  int op_slot_right_3110 = gc_frame_newslot(bool3111);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call3114 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3113);
// compiled call node returning call3114 (depth = 11)
// compiled member node returning call3114 (depth = 10)
  int op_slot_left_3110 = gc_frame_newslot(call3114);
  params[0] = bool3111;
  partcv[0] = 1;
  Object opresult3115 = callmethod(call3114, "==", 1, partcv, params);
// compiled op node returning opresult3115 (depth = 9)
  Object if3109 = done;
  if (istrue(opresult3115)) {
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_3117 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3120 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3119);
// compiled call node returning call3120 (depth = 12)
// compiled member node returning call3120 (depth = 11)
  int op_slot_left_3117 = gc_frame_newslot(call3120);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3121 = callmethod(call3120, "==", 1, partcv, params);
// compiled op node returning opresult3121 (depth = 10)
  Object if3116 = done;
  if (istrue(opresult3121)) {
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3122 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3123 == NULL) {
    strlit3123 = alloc_String("}");
    gc_root(strlit3123);
  }
// compiled string node returning strlit3123 (depth = 11)
  gc_frame_newslot(strlit3123);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit3123;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3124 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3122);
// compiled call node returning call3124 (depth = 10)
    gc_frame_newslot(call3124);
    if3116 = call3124;
  } else {
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3125 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3127 = alloc_Float64(0.1);
// compiled num node returning num3127 (depth = 12)
  int op_slot_right_3126 = gc_frame_newslot(num3127);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3129 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe3130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call3131 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3130);
// compiled call node returning call3131 (depth = 15)
// compiled member node returning call3131 (depth = 14)
  partcv[0] = 0;
  Object call3132 = callmethod(call3131, "line",
    1, partcv, params);
  gc_frame_end(callframe3129);
// compiled call node returning call3132 (depth = 13)
// compiled member node returning call3132 (depth = 12)
  int op_slot_left_3126 = gc_frame_newslot(call3132);
  params[0] = num3127;
  partcv[0] = 1;
  Object sum3133 = callmethod(call3132, "+", 1, partcv, params);
// compiled op node returning sum3133 (depth = 11)
  gc_frame_newslot(sum3133);
// starting to compile string node (depth = 11)
  if (strlit3134 == NULL) {
    strlit3134 = alloc_String("}");
    gc_root(strlit3134);
  }
// compiled string node returning strlit3134 (depth = 11)
  gc_frame_newslot(strlit3134);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3133;
  params[1] = strlit3134;
  partcv[0] = 2;
  Object call3135 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3125);
// compiled call node returning call3135 (depth = 10)
    gc_frame_newslot(call3135);
    if3116 = call3135;
  }
// compiled if node returning if3116 (depth = 9)
    gc_frame_newslot(if3116);
    if3109 = if3116;
  } else {
  }
// compiled if node returning if3109 (depth = 8)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3136 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call3137 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3136);
// compiled call node returning call3137 (depth = 8)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3138 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3139 == NULL) {
    strlit3139 = alloc_String("an else statement must end with a '}'.");
    gc_root(strlit3139);
  }
// compiled string node returning strlit3139 (depth = 9)
  gc_frame_newslot(strlit3139);
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3141 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3140);
// compiled call node returning call3141 (depth = 10)
// compiled member node returning call3141 (depth = 9)
  gc_frame_newslot(call3141);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3143 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3142);
// compiled call node returning call3143 (depth = 10)
// compiled member node returning call3143 (depth = 9)
  gc_frame_newslot(call3143);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3139;
  params[1] = call3141;
  params[2] = call3143;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3144 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3138);
// compiled call node returning call3144 (depth = 8)
    gc_frame_newslot(call3144);
    if3092 = call3144;
  } else {
  }
// compiled if node returning if3092 (depth = 7)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3146 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3145);
// compiled call node returning call3146 (depth = 9)
// compiled member node returning call3146 (depth = 8)
  *var_v = call3146;
  if (call3146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3148 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3149 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe3148);
// compiled call node returning call3149 (depth = 7)
  gc_frame_end(frame);
  return call3149;
}
Object meth_parser_doif1802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(29, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doif (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doif");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_opener = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "opener");
  Object *var_closer = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closer");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_cond = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cond");
  Object *var_body = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "body");
  Object *var_elseblock = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "elseblock");
  Object *var_curelse = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "curelse");
  Object *var_v = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "v");
  Object *var_localMin = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "minInd");
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
  Object *var_econd = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "econd");
  Object *var_eif = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "eif");
  Object *var_newelse = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "newelse");
  Object *var_ebody = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "ebody");
  Object *var_o = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "o");
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1806 == NULL) {
    strlit1806 = alloc_String("if");
    gc_root(strlit1806);
  }
// compiled string node returning strlit1806 (depth = 5)
  int op_slot_right_1805 = gc_frame_newslot(strlit1806);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1809 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1808);
// compiled call node returning call1809 (depth = 6)
// compiled member node returning call1809 (depth = 5)
  int op_slot_left_1805 = gc_frame_newslot(call1809);
  params[0] = strlit1806;
  partcv[0] = 1;
  Object opresult1810 = callmethod(call1809, "==", 1, partcv, params);
// compiled op node returning opresult1810 (depth = 4)
  int op_slot_right_1804 = gc_frame_newslot(opresult1810);
// starting to compile call node (depth = 4)
  int callframe1812 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1813 == NULL) {
    strlit1813 = alloc_String("identifier");
    gc_root(strlit1813);
  }
// compiled string node returning strlit1813 (depth = 5)
  gc_frame_newslot(strlit1813);
// call case 4: self request
  params[0] = strlit1813;
  partcv[0] = 1;
  Object call1814 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1812);
// compiled call node returning call1814 (depth = 4)
  int op_slot_left_1804 = gc_frame_newslot(call1814);
  params[0] = opresult1810;
  partcv[0] = 1;
  Object opresult1815 = callmethod(call1814, "&&", 1, partcv, params);
// compiled op node returning opresult1815 (depth = 3)
  Object if1803 = done;
  if (istrue(opresult1815)) {
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1817 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1816);
// compiled call node returning call1817 (depth = 4)
// compiled member node returning call1817 (depth = 3)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1819 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1820 = alloc_Block(NULL, NULL, "parser", 617);
  gc_frame_newslot(block1820);
// method "_apply"
  block_savedest(block1820);
  Object closure1821 = createclosure(2, "_apply");
  setclosureframe(closure1821, stackframe);
  addtoclosure(closure1821, var_sym);
  addtoclosure(closure1821, selfslot);
  struct UserObject *uo1821 = (struct UserObject*)block1820;
  uo1821->data[0] = (Object)closure1821;
  Method *meth_meth_parser__apply1821 = addmethod2pos(block1820, "_apply", &meth_parser__apply1821, 0);
  int argcv_meth_parser__apply1821[] = {0};
  meth_meth_parser__apply1821->type = alloc_MethodType(1, argcv_meth_parser__apply1821);
  meth_meth_parser__apply1821->definitionModule = modulename;
  meth_meth_parser__apply1821->definitionLine = 616;
// compiled block node returning block1820 (depth = 6)
  gc_frame_newslot(block1820);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1830 == NULL) {
    strlit1830 = alloc_String("lparen");
    gc_root(strlit1830);
  }
// compiled string node returning strlit1830 (depth = 7)
  int op_slot_right_1829 = gc_frame_newslot(strlit1830);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1832 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1833 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1832);
// compiled call node returning call1833 (depth = 8)
// compiled member node returning call1833 (depth = 7)
  int op_slot_left_1829 = gc_frame_newslot(call1833);
  params[0] = strlit1830;
  partcv[0] = 1;
  Object opresult1834 = callmethod(call1833, "==", 1, partcv, params);
// compiled op node returning opresult1834 (depth = 6)
  params[0] = block1820;
  partcv[0] = 1;
  Object call1835 = callmethod(opresult1834, "orElse",
    1, partcv, params);
  gc_frame_end(callframe1819);
// compiled call node returning call1835 (depth = 5)
  Object if1818 = done;
struct StackFrameObject *iftmpstackframe1818 = stackframe;
  if (istrue(call1835)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1818);
gc_frame_newslot((Object)stackframe);
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1836 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1837 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1836);
// compiled call node returning call1837 (depth = 6)
// compiled member node returning call1837 (depth = 5)
    gc_frame_newslot(call1837);
    if1818 = call1837;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1818);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit1838 == NULL) {
    strlit1838 = alloc_String("-missing-");
    gc_root(strlit1838);
  }
// compiled string node returning strlit1838 (depth = 5)
    gc_frame_newslot(strlit1838);
    if1818 = strlit1838;
  }
stackframe = iftmpstackframe1818;
// compiled if node returning if1818 (depth = 4)
  *var_opener = if1818;
  if (if1818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1841 == NULL) {
    strlit1841 = alloc_String("(");
    gc_root(strlit1841);
  }
// compiled string node returning strlit1841 (depth = 6)
  int op_slot_right_1840 = gc_frame_newslot(strlit1841);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opener (depth = 6)
  int op_slot_left_1840 = gc_frame_newslot(*var_opener);
  params[0] = strlit1841;
  partcv[0] = 1;
  Object opresult1843 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult1843 (depth = 5)
  Object if1839 = done;
struct StackFrameObject *iftmpstackframe1839 = stackframe;
  if (istrue(opresult1843)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1839);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit1844 == NULL) {
    strlit1844 = alloc_String(")");
    gc_root(strlit1844);
  }
// compiled string node returning strlit1844 (depth = 5)
    gc_frame_newslot(strlit1844);
    if1839 = strlit1844;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1839);
  gc_frame_newslot((Object)stackframe);
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1847 == NULL) {
    strlit1847 = alloc_String("{");
    gc_root(strlit1847);
  }
// compiled string node returning strlit1847 (depth = 7)
  int op_slot_right_1846 = gc_frame_newslot(strlit1847);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_opener (depth = 7)
  int op_slot_left_1846 = gc_frame_newslot(*var_opener);
  params[0] = strlit1847;
  partcv[0] = 1;
  Object opresult1849 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 6)
  Object if1845 = done;
  if (istrue(opresult1849)) {
// starting to compile string node (depth = 6)
  if (strlit1850 == NULL) {
    strlit1850 = alloc_String("}");
    gc_root(strlit1850);
  }
// compiled string node returning strlit1850 (depth = 6)
    gc_frame_newslot(strlit1850);
    if1845 = strlit1850;
  } else {
// starting to compile string node (depth = 6)
  if (strlit1851 == NULL) {
    strlit1851 = alloc_String("-nothing-");
    gc_root(strlit1851);
  }
// compiled string node returning strlit1851 (depth = 6)
    gc_frame_newslot(strlit1851);
    if1845 = strlit1851;
  }
// compiled if node returning if1845 (depth = 5)
    gc_frame_newslot(if1845);
    if1839 = if1845;
  }
stackframe = iftmpstackframe1839;
// compiled if node returning if1839 (depth = 4)
  *var_closer = if1839;
  if (if1839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1854 == NULL) {
    strlit1854 = alloc_String("-missing-");
    gc_root(strlit1854);
  }
// compiled string node returning strlit1854 (depth = 5)
  int op_slot_right_1853 = gc_frame_newslot(strlit1854);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opener (depth = 5)
  int op_slot_left_1853 = gc_frame_newslot(*var_opener);
  params[0] = strlit1854;
  partcv[0] = 1;
  Object opresult1856 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult1856 (depth = 4)
  Object if1852 = done;
  if (istrue(opresult1856)) {
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1857 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1858 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1859 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1858);
// compiled call node returning call1859 (depth = 8)
// compiled member node returning call1859 (depth = 7)
  partcv[0] = 0;
  Object call1860 = callmethod(call1859, "new",
    1, partcv, params);
  gc_frame_end(callframe1857);
// compiled call node returning call1860 (depth = 6)
// compiled member node returning call1860 (depth = 5)
  *var_suggestion = call1860;
  if (call1860 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1861 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1862 = alloc_Block(NULL, NULL, "parser", 624);
  gc_frame_newslot(block1862);
// method "_apply"
  block_savedest(block1862);
  Object closure1863 = createclosure(2, "_apply");
  setclosureframe(closure1863, stackframe);
  addtoclosure(closure1863, var_btok);
  addtoclosure(closure1863, selfslot);
  struct UserObject *uo1863 = (struct UserObject*)block1862;
  uo1863->data[0] = (Object)closure1863;
  Method *meth_meth_parser__apply1863 = addmethod2pos(block1862, "_apply", &meth_parser__apply1863, 0);
  int argcv_meth_parser__apply1863[] = {1};
  meth_meth_parser__apply1863->type = alloc_MethodType(1, argcv_meth_parser__apply1863);
  meth_meth_parser__apply1863->definitionModule = modulename;
  meth_meth_parser__apply1863->definitionLine = 622;
// compiled block node returning block1862 (depth = 6)
  gc_frame_newslot(block1862);
// call case 4: self request
  params[0] = block1862;
  partcv[0] = 1;
  Object call1917 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1861);
// compiled call node returning call1917 (depth = 5)
  *var_nextTok = call1917;
  if (call1917 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1920 = alloc_Boolean(0);
// compiled identifier node returning bool1920 (depth = 6)
  int op_slot_right_1919 = gc_frame_newslot(bool1920);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1919 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1920;
  partcv[0] = 1;
  Object opresult1922 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1922 (depth = 5)
  Object if1918 = done;
  if (istrue(opresult1922)) {
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1923 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1924 == NULL) {
    strlit1924 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then {");
    gc_root(strlit1924);
  }
// compiled string node returning strlit1924 (depth = 6)
  gc_frame_newslot(strlit1924);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1924;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1925 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1923);
// compiled call node returning call1925 (depth = 5)
    gc_frame_newslot(call1925);
    if1918 = call1925;
  } else {
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1928 == NULL) {
    strlit1928 = alloc_String("rparen");
    gc_root(strlit1928);
  }
// compiled string node returning strlit1928 (depth = 7)
  int op_slot_right_1927 = gc_frame_newslot(strlit1928);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1931 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1930);
// compiled call node returning call1931 (depth = 8)
// compiled member node returning call1931 (depth = 7)
  int op_slot_left_1927 = gc_frame_newslot(call1931);
  params[0] = strlit1928;
  partcv[0] = 1;
  Object opresult1932 = callmethod(call1931, "==", 1, partcv, params);
// compiled op node returning opresult1932 (depth = 6)
  Object if1926 = done;
  if (istrue(opresult1932)) {
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1934 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1934 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1936 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1936 (depth = 7)
  Object if1933 = done;
  if (istrue(opresult1936)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1937 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1938 == NULL) {
    strlit1938 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb""");
    gc_root(strlit1938);
  }
// compiled string node returning strlit1938 (depth = 8)
  gc_frame_newslot(strlit1938);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1938;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1939 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1937);
// compiled call node returning call1939 (depth = 7)
    gc_frame_newslot(call1939);
    if1933 = call1939;
  } else {
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1940 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1941 == NULL) {
    strlit1941 = alloc_String("(");
    gc_root(strlit1941);
  }
// compiled string node returning strlit1941 (depth = 8)
  gc_frame_newslot(strlit1941);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1941;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1942 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1940);
// compiled call node returning call1942 (depth = 7)
    gc_frame_newslot(call1942);
    if1933 = call1942;
  }
// compiled if node returning if1933 (depth = 6)
    gc_frame_newslot(if1933);
    if1926 = if1933;
  } else {
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1945 == NULL) {
    strlit1945 = alloc_String("lbrace");
    gc_root(strlit1945);
  }
// compiled string node returning strlit1945 (depth = 8)
  int op_slot_right_1944 = gc_frame_newslot(strlit1945);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1948 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1947);
// compiled call node returning call1948 (depth = 9)
// compiled member node returning call1948 (depth = 8)
  int op_slot_left_1944 = gc_frame_newslot(call1948);
  params[0] = strlit1945;
  partcv[0] = 1;
  Object opresult1949 = callmethod(call1948, "==", 1, partcv, params);
// compiled op node returning opresult1949 (depth = 7)
  Object if1943 = done;
  if (istrue(opresult1949)) {
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1951 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1951 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1953 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1953 (depth = 8)
  Object if1950 = done;
  if (istrue(opresult1953)) {
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1954 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1955 == NULL) {
    strlit1955 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then");
    gc_root(strlit1955);
  }
// compiled string node returning strlit1955 (depth = 9)
  gc_frame_newslot(strlit1955);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1955;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1956 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1954);
// compiled call node returning call1956 (depth = 8)
    gc_frame_newslot(call1956);
    if1950 = call1956;
  } else {
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1957 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1958 == NULL) {
    strlit1958 = alloc_String("(");
    gc_root(strlit1958);
  }
// compiled string node returning strlit1958 (depth = 9)
  gc_frame_newslot(strlit1958);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1958;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1959 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1957);
// compiled call node returning call1959 (depth = 8)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1960 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1961 == NULL) {
    strlit1961 = alloc_String(") then");
    gc_root(strlit1961);
  }
// compiled string node returning strlit1961 (depth = 9)
  gc_frame_newslot(strlit1961);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1963 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1962);
// compiled call node returning call1963 (depth = 10)
// compiled member node returning call1963 (depth = 9)
  gc_frame_newslot(call1963);
// starting to compile identifier node (depth = 9)
  Object bool1964 = alloc_Boolean(1);
// compiled identifier node returning bool1964 (depth = 9)
  gc_frame_newslot(bool1964);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1961;
  params[1] = call1963;
  params[2] = bool1964;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1965 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1960);
// compiled call node returning call1965 (depth = 8)
    gc_frame_newslot(call1965);
    if1950 = call1965;
  }
// compiled if node returning if1950 (depth = 7)
    gc_frame_newslot(if1950);
    if1943 = if1950;
  } else {
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1968 == NULL) {
    strlit1968 = alloc_String("identifier");
    gc_root(strlit1968);
  }
// compiled string node returning strlit1968 (depth = 9)
  int op_slot_right_1967 = gc_frame_newslot(strlit1968);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1971 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1970);
// compiled call node returning call1971 (depth = 10)
// compiled member node returning call1971 (depth = 9)
  int op_slot_left_1967 = gc_frame_newslot(call1971);
  params[0] = strlit1968;
  partcv[0] = 1;
  Object opresult1972 = callmethod(call1971, "==", 1, partcv, params);
// compiled op node returning opresult1972 (depth = 8)
  Object if1966 = done;
  if (istrue(opresult1972)) {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1974 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1974 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1976 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1976 (depth = 9)
  Object if1973 = done;
  if (istrue(opresult1976)) {
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1977 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1978 == NULL) {
    strlit1978 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb"") ");
    gc_root(strlit1978);
  }
// compiled string node returning strlit1978 (depth = 10)
  gc_frame_newslot(strlit1978);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1978;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1979 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1977);
// compiled call node returning call1979 (depth = 9)
    gc_frame_newslot(call1979);
    if1973 = call1979;
  } else {
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1980 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1981 == NULL) {
    strlit1981 = alloc_String("(");
    gc_root(strlit1981);
  }
// compiled string node returning strlit1981 (depth = 10)
  gc_frame_newslot(strlit1981);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1981;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1982 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1980);
// compiled call node returning call1982 (depth = 9)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1983 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1984 == NULL) {
    strlit1984 = alloc_String(")");
    gc_root(strlit1984);
  }
// compiled string node returning strlit1984 (depth = 10)
  gc_frame_newslot(strlit1984);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1986 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1985);
// compiled call node returning call1986 (depth = 11)
// compiled member node returning call1986 (depth = 10)
  gc_frame_newslot(call1986);
// starting to compile identifier node (depth = 10)
  Object bool1987 = alloc_Boolean(1);
// compiled identifier node returning bool1987 (depth = 10)
  gc_frame_newslot(bool1987);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1984;
  params[1] = call1986;
  params[2] = bool1987;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1988 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1983);
// compiled call node returning call1988 (depth = 9)
    gc_frame_newslot(call1988);
    if1973 = call1988;
  }
// compiled if node returning if1973 (depth = 8)
    gc_frame_newslot(if1973);
    if1966 = if1973;
  } else {
  }
// compiled if node returning if1966 (depth = 7)
    gc_frame_newslot(if1966);
    if1943 = if1966;
  }
// compiled if node returning if1943 (depth = 6)
    gc_frame_newslot(if1943);
    if1926 = if1943;
  }
// compiled if node returning if1926 (depth = 5)
    gc_frame_newslot(if1926);
    if1918 = if1926;
  }
// compiled if node returning if1918 (depth = 4)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1989 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1991 == NULL) {
    strlit1991 = alloc_String("in parentheses or braces after the 'if'.");
    gc_root(strlit1991);
  }
// compiled string node returning strlit1991 (depth = 6)
  int op_slot_right_1990 = gc_frame_newslot(strlit1991);
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1993 == NULL) {
    strlit1993 = alloc_String("an if statement must have a condition ");
    gc_root(strlit1993);
  }
// compiled string node returning strlit1993 (depth = 6)
  int op_slot_left_1990 = gc_frame_newslot(strlit1993);
  params[0] = strlit1991;
  partcv[0] = 1;
  Object opresult1994 = callmethod(strlit1993, "++", 1, partcv, params);
// compiled op node returning opresult1994 (depth = 5)
  gc_frame_newslot(opresult1994);
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1996 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1995);
// compiled call node returning call1996 (depth = 6)
// compiled member node returning call1996 (depth = 5)
  gc_frame_newslot(call1996);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1998 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1997);
// compiled call node returning call1998 (depth = 6)
// compiled member node returning call1998 (depth = 5)
  gc_frame_newslot(call1998);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1994;
  params[1] = call1996;
  params[2] = call1998;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1999 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1989);
// compiled call node returning call1999 (depth = 4)
    gc_frame_newslot(call1999);
    if1852 = call1999;
  } else {
  }
// compiled if node returning if1852 (depth = 3)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2001 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2000);
// compiled call node returning call2001 (depth = 4)
// compiled member node returning call2001 (depth = 3)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2003 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe2004 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2005 = alloc_Block(NULL, NULL, "parser", 655);
  gc_frame_newslot(block2005);
// method "_apply"
  block_savedest(block2005);
  Object closure2006 = createclosure(2, "_apply");
  setclosureframe(closure2006, stackframe);
  addtoclosure(closure2006, var_blocksOK);
  addtoclosure(closure2006, selfslot);
  struct UserObject *uo2006 = (struct UserObject*)block2005;
  uo2006->data[0] = (Object)closure2006;
  Method *meth_meth_parser__apply2006 = addmethod2pos(block2005, "_apply", &meth_parser__apply2006, 0);
  int argcv_meth_parser__apply2006[] = {0};
  meth_meth_parser__apply2006->type = alloc_MethodType(1, argcv_meth_parser__apply2006);
  meth_meth_parser__apply2006->definitionModule = modulename;
  meth_meth_parser__apply2006->definitionLine = 655;
// compiled block node returning block2005 (depth = 7)
  gc_frame_newslot(block2005);
// call case 4: self request
  params[0] = block2005;
  partcv[0] = 1;
  Object call2010 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2004);
// compiled call node returning call2010 (depth = 6)
  partcv[0] = 0;
  Object call2011 = callmethod(call2010, "not",
    1, partcv, params);
  gc_frame_end(callframe2003);
// compiled call node returning call2011 (depth = 5)
// compiled member node returning call2011 (depth = 4)
  Object if2002 = done;
  if (istrue(call2011)) {
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2012 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call2014 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2013);
// compiled call node returning call2014 (depth = 8)
// compiled member node returning call2014 (depth = 7)
  partcv[0] = 0;
  Object call2015 = callmethod(call2014, "new",
    1, partcv, params);
  gc_frame_end(callframe2012);
// compiled call node returning call2015 (depth = 6)
// compiled member node returning call2015 (depth = 5)
  *var_suggestion = call2015;
  if (call2015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2016 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2017 = alloc_Block(NULL, NULL, "parser", 658);
  gc_frame_newslot(block2017);
// method "_apply"
  block_savedest(block2017);
  Object closure2018 = createclosure(2, "_apply");
  setclosureframe(closure2018, stackframe);
  addtoclosure(closure2018, var_lastToken);
  addtoclosure(closure2018, selfslot);
  struct UserObject *uo2018 = (struct UserObject*)block2017;
  uo2018->data[0] = (Object)closure2018;
  Method *meth_meth_parser__apply2018 = addmethod2pos(block2017, "_apply", &meth_parser__apply2018, 0);
  int argcv_meth_parser__apply2018[] = {1};
  meth_meth_parser__apply2018->type = alloc_MethodType(1, argcv_meth_parser__apply2018);
  meth_meth_parser__apply2018->definitionModule = modulename;
  meth_meth_parser__apply2018->definitionLine = 656;
// compiled block node returning block2017 (depth = 6)
  gc_frame_newslot(block2017);
// call case 4: self request
  params[0] = block2017;
  partcv[0] = 1;
  Object call2036 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2016);
// compiled call node returning call2036 (depth = 5)
  *var_nextTok = call2036;
  if (call2036 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2039 = alloc_Boolean(0);
// compiled identifier node returning bool2039 (depth = 6)
  int op_slot_right_2038 = gc_frame_newslot(bool2039);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_2038 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2039;
  partcv[0] = 1;
  Object opresult2041 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2041 (depth = 5)
  Object if2037 = done;
  if (istrue(opresult2041)) {
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2042 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array2043 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit2044 == NULL) {
    strlit2044 = alloc_String("rparen");
    gc_root(strlit2044);
  }
// compiled string node returning strlit2044 (depth = 8)
  params[0] = strlit2044;
  partcv[0] = 1;
  callmethod(array2043, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array2043 (depth = 7)
  gc_frame_newslot(array2043);
// call case 4: self request
  params[0] = array2043;
  partcv[0] = 1;
  Object call2045 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2042);
// compiled call node returning call2045 (depth = 6)
  *var_nextTok = call2045;
  if (call2045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_2048 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_2048 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2050 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2050 (depth = 6)
  Object if2047 = done;
  if (istrue(opresult2050)) {
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2051 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2052 == NULL) {
    strlit2052 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2052);
  }
// compiled string node returning strlit2052 (depth = 7)
  gc_frame_newslot(strlit2052);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2052;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2053 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2051);
// compiled call node returning call2053 (depth = 6)
    gc_frame_newslot(call2053);
    if2047 = call2053;
  } else {
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2054 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call2056 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2055);
// compiled call node returning call2056 (depth = 8)
// compiled member node returning call2056 (depth = 7)
  gc_frame_newslot(call2056);
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool2057 = alloc_Boolean(1);
// compiled identifier node returning bool2057 (depth = 7)
  gc_frame_newslot(bool2057);
// starting to compile identifier node (depth = 7)
  Object bool2058 = alloc_Boolean(0);
// compiled identifier node returning bool2058 (depth = 7)
  gc_frame_newslot(bool2058);
// starting to compile string node (depth = 7)
  if (strlit2059 == NULL) {
    strlit2059 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2059);
  }
// compiled string node returning strlit2059 (depth = 7)
  gc_frame_newslot(strlit2059);
// call case 6: other member request
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2056;
  params[2] = bool2057;
  params[3] = bool2058;
  params[4] = strlit2059;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2060 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2054);
// compiled call node returning call2060 (depth = 6)
    gc_frame_newslot(call2060);
    if2047 = call2060;
  }
// compiled if node returning if2047 (depth = 5)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2061 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit2063 == NULL) {
    strlit2063 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit2063);
  }
// compiled string node returning strlit2063 (depth = 7)
  int op_slot_right_2062 = gc_frame_newslot(strlit2063);
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit2065 == NULL) {
    strlit2065 = alloc_String("an if statement must have a ");
    gc_root(strlit2065);
  }
// compiled string node returning strlit2065 (depth = 7)
  int op_slot_left_2062 = gc_frame_newslot(strlit2065);
  params[0] = strlit2063;
  partcv[0] = 1;
  Object opresult2066 = callmethod(strlit2065, "++", 1, partcv, params);
// compiled op node returning opresult2066 (depth = 6)
  gc_frame_newslot(opresult2066);
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2067 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2068 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2067);
// compiled call node returning call2068 (depth = 7)
// compiled member node returning call2068 (depth = 6)
  gc_frame_newslot(call2068);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2070 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2069);
// compiled call node returning call2070 (depth = 7)
// compiled member node returning call2070 (depth = 6)
  gc_frame_newslot(call2070);
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult2066;
  params[1] = call2068;
  params[2] = call2070;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2071 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2061);
// compiled call node returning call2071 (depth = 5)
    gc_frame_newslot(call2071);
    if2037 = call2071;
  } else {
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_2073 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_2073 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2075 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2075 (depth = 6)
  Object if2072 = done;
  if (istrue(opresult2075)) {
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2076 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2077 == NULL) {
    strlit2077 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2077);
  }
// compiled string node returning strlit2077 (depth = 7)
  gc_frame_newslot(strlit2077);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2077;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2078 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2076);
// compiled call node returning call2078 (depth = 6)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2079 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2081 == NULL) {
    strlit2081 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit2081);
  }
// compiled string node returning strlit2081 (depth = 8)
  int op_slot_right_2080 = gc_frame_newslot(strlit2081);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2083 == NULL) {
    strlit2083 = alloc_String("an if statement must have a ");
    gc_root(strlit2083);
  }
// compiled string node returning strlit2083 (depth = 8)
  int op_slot_left_2080 = gc_frame_newslot(strlit2083);
  params[0] = strlit2081;
  partcv[0] = 1;
  Object opresult2084 = callmethod(strlit2083, "++", 1, partcv, params);
// compiled op node returning opresult2084 (depth = 7)
  gc_frame_newslot(opresult2084);
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2086 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2085);
// compiled call node returning call2086 (depth = 8)
// compiled member node returning call2086 (depth = 7)
  gc_frame_newslot(call2086);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2088 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2087);
// compiled call node returning call2088 (depth = 8)
// compiled member node returning call2088 (depth = 7)
  gc_frame_newslot(call2088);
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2084;
  params[1] = call2086;
  params[2] = call2088;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2089 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2079);
// compiled call node returning call2089 (depth = 6)
    gc_frame_newslot(call2089);
    if2072 = call2089;
  } else {
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2090 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call2092 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2091);
// compiled call node returning call2092 (depth = 8)
// compiled member node returning call2092 (depth = 7)
  gc_frame_newslot(call2092);
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool2093 = alloc_Boolean(0);
// compiled identifier node returning bool2093 (depth = 7)
  gc_frame_newslot(bool2093);
// starting to compile identifier node (depth = 7)
  Object bool2094 = alloc_Boolean(1);
// compiled identifier node returning bool2094 (depth = 7)
  gc_frame_newslot(bool2094);
// starting to compile string node (depth = 7)
  if (strlit2095 == NULL) {
    strlit2095 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2095);
  }
// compiled string node returning strlit2095 (depth = 7)
  gc_frame_newslot(strlit2095);
// call case 6: other member request
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2092;
  params[2] = bool2093;
  params[3] = bool2094;
  params[4] = strlit2095;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2096 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2090);
// compiled call node returning call2096 (depth = 6)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2097 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2099 == NULL) {
    strlit2099 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit2099);
  }
// compiled string node returning strlit2099 (depth = 8)
  int op_slot_right_2098 = gc_frame_newslot(strlit2099);
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2101 == NULL) {
    strlit2101 = alloc_String("an if statement must have a ");
    gc_root(strlit2101);
  }
// compiled string node returning strlit2101 (depth = 8)
  int op_slot_left_2098 = gc_frame_newslot(strlit2101);
  params[0] = strlit2099;
  partcv[0] = 1;
  Object opresult2102 = callmethod(strlit2101, "++", 1, partcv, params);
// compiled op node returning opresult2102 (depth = 7)
  gc_frame_newslot(opresult2102);
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2104 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2103);
// compiled call node returning call2104 (depth = 8)
// compiled member node returning call2104 (depth = 7)
  gc_frame_newslot(call2104);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2105 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2106 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2105);
// compiled call node returning call2106 (depth = 8)
// compiled member node returning call2106 (depth = 7)
  gc_frame_newslot(call2106);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2108 = alloc_Float64(1);
// compiled num node returning num2108 (depth = 8)
  int op_slot_right_2107 = gc_frame_newslot(num2108);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call2111 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2110);
// compiled call node returning call2111 (depth = 9)
// compiled member node returning call2111 (depth = 8)
  int op_slot_left_2107 = gc_frame_newslot(call2111);
  params[0] = num2108;
  partcv[0] = 1;
  Object diff2112 = callmethod(call2111, "-", 1, partcv, params);
// compiled op node returning diff2112 (depth = 7)
  gc_frame_newslot(diff2112);
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2102;
  params[1] = call2104;
  params[2] = call2106;
  params[3] = diff2112;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2113 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2097);
// compiled call node returning call2113 (depth = 6)
    gc_frame_newslot(call2113);
    if2072 = call2113;
  }
// compiled if node returning if2072 (depth = 5)
    gc_frame_newslot(if2072);
    if2037 = if2072;
  }
// compiled if node returning if2037 (depth = 4)
    gc_frame_newslot(if2037);
    if2002 = if2037;
  } else {
  }
// compiled if node returning if2002 (depth = 3)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_closer (depth = 5)
  int op_slot_right_2115 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call2118 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2117);
// compiled call node returning call2118 (depth = 6)
// compiled member node returning call2118 (depth = 5)
  int op_slot_left_2115 = gc_frame_newslot(call2118);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2119 = callmethod(call2118, "!=", 1, partcv, params);
// compiled op node returning opresult2119 (depth = 4)
  Object if2114 = done;
  if (istrue(opresult2119)) {
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2121 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2120);
// compiled call node returning call2121 (depth = 5)
// compiled member node returning call2121 (depth = 4)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2122 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call2124 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2123);
// compiled call node returning call2124 (depth = 8)
// compiled member node returning call2124 (depth = 7)
  partcv[0] = 0;
  Object call2125 = callmethod(call2124, "new",
    1, partcv, params);
  gc_frame_end(callframe2122);
// compiled call node returning call2125 (depth = 6)
// compiled member node returning call2125 (depth = 5)
  *var_suggestion = call2125;
  if (call2125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2126 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2127 == NULL) {
    strlit2127 = alloc_String(")");
    gc_root(strlit2127);
  }
// compiled string node returning strlit2127 (depth = 5)
  gc_frame_newslot(strlit2127);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit2127;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2128 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2126);
// compiled call node returning call2128 (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2129 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2132 == NULL) {
    strlit2132 = alloc_String("'.");
    gc_root(strlit2132);
  }
// compiled string node returning strlit2132 (depth = 7)
  int op_slot_right_2131 = gc_frame_newslot(strlit2132);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_2134 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2137 == NULL) {
    strlit2137 = alloc_String("' must end with a '");
    gc_root(strlit2137);
  }
// compiled string node returning strlit2137 (depth = 9)
  int op_slot_right_2136 = gc_frame_newslot(strlit2137);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_right_2139 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 10)
  if (strlit2141 == NULL) {
    strlit2141 = alloc_String("'");
    gc_root(strlit2141);
  }
// compiled string node returning strlit2141 (depth = 10)
  int op_slot_left_2139 = gc_frame_newslot(strlit2141);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult2142 = callmethod(strlit2141, "++", 1, partcv, params);
// compiled op node returning opresult2142 (depth = 9)
  int op_slot_left_2136 = gc_frame_newslot(opresult2142);
  params[0] = strlit2137;
  partcv[0] = 1;
  Object opresult2143 = callmethod(opresult2142, "++", 1, partcv, params);
// compiled op node returning opresult2143 (depth = 8)
  int op_slot_left_2134 = gc_frame_newslot(opresult2143);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2144 = callmethod(opresult2143, "++", 1, partcv, params);
// compiled op node returning opresult2144 (depth = 7)
  int op_slot_left_2131 = gc_frame_newslot(opresult2144);
  params[0] = strlit2132;
  partcv[0] = 1;
  Object opresult2145 = callmethod(opresult2144, "++", 1, partcv, params);
// compiled op node returning opresult2145 (depth = 6)
  int op_slot_right_2130 = gc_frame_newslot(opresult2145);
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2147 == NULL) {
    strlit2147 = alloc_String("an expression beginning with a ");
    gc_root(strlit2147);
  }
// compiled string node returning strlit2147 (depth = 6)
  int op_slot_left_2130 = gc_frame_newslot(strlit2147);
  params[0] = opresult2145;
  partcv[0] = 1;
  Object opresult2148 = callmethod(strlit2147, "++", 1, partcv, params);
// compiled op node returning opresult2148 (depth = 5)
  gc_frame_newslot(opresult2148);
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call2150 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2149);
// compiled call node returning call2150 (depth = 6)
// compiled member node returning call2150 (depth = 5)
  gc_frame_newslot(call2150);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2153 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2152);
// compiled call node returning call2153 (depth = 7)
// compiled member node returning call2153 (depth = 6)
  int op_slot_right_2151 = gc_frame_newslot(call2153);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2156 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2155);
// compiled call node returning call2156 (depth = 7)
// compiled member node returning call2156 (depth = 6)
  int op_slot_left_2151 = gc_frame_newslot(call2156);
  params[0] = call2153;
  partcv[0] = 1;
  Object sum2157 = callmethod(call2156, "+", 1, partcv, params);
// compiled op node returning sum2157 (depth = 5)
  gc_frame_newslot(sum2157);
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult2148;
  params[1] = call2150;
  params[2] = sum2157;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2158 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2129);
// compiled call node returning call2158 (depth = 4)
    gc_frame_newslot(call2158);
    if2114 = call2158;
  } else {
  }
// compiled if node returning if2114 (depth = 3)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2159 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2160 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2159);
// compiled call node returning call2160 (depth = 4)
// compiled member node returning call2160 (depth = 3)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call2162 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2161);
// compiled call node returning call2162 (depth = 5)
// compiled member node returning call2162 (depth = 4)
  *var_cond = call2162;
  if (call2162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2163 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2163 (depth = 4)
  *var_body = array2163;
  if (array2163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2164 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2164 (depth = 4)
  *var_elseblock = array2164;
  if (array2164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2166 = alloc_Float64(2);
// compiled num node returning num2166 (depth = 5)
  int op_slot_right_2165 = gc_frame_newslot(num2166);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_2165 = gc_frame_newslot(*var_statementIndent);
  params[0] = num2166;
  partcv[0] = 1;
  Object sum2168 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum2168 (depth = 4)
  *var_minInd = sum2168;
  if (sum2168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2172 == NULL) {
    strlit2172 = alloc_String("then");
    gc_root(strlit2172);
  }
// compiled string node returning strlit2172 (depth = 6)
  int op_slot_right_2171 = gc_frame_newslot(strlit2172);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2175 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2174);
// compiled call node returning call2175 (depth = 7)
// compiled member node returning call2175 (depth = 6)
  int op_slot_left_2171 = gc_frame_newslot(call2175);
  params[0] = strlit2172;
  partcv[0] = 1;
  Object opresult2176 = callmethod(call2175, "==", 1, partcv, params);
// compiled op node returning opresult2176 (depth = 5)
  int op_slot_right_2170 = gc_frame_newslot(opresult2176);
// starting to compile call node (depth = 5)
  int callframe2178 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2179 == NULL) {
    strlit2179 = alloc_String("identifier");
    gc_root(strlit2179);
  }
// compiled string node returning strlit2179 (depth = 6)
  gc_frame_newslot(strlit2179);
// call case 4: self request
  params[0] = strlit2179;
  partcv[0] = 1;
  Object call2180 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2178);
// compiled call node returning call2180 (depth = 5)
  int op_slot_left_2170 = gc_frame_newslot(call2180);
  params[0] = opresult2176;
  partcv[0] = 1;
  Object opresult2181 = callmethod(call2180, "&&", 1, partcv, params);
// compiled op node returning opresult2181 (depth = 4)
  Object if2169 = done;
  if (istrue(opresult2181)) {
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2182 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2183 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2182);
// compiled call node returning call2183 (depth = 5)
// compiled member node returning call2183 (depth = 4)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2186 == NULL) {
    strlit2186 = alloc_String("lbrace");
    gc_root(strlit2186);
  }
// compiled string node returning strlit2186 (depth = 6)
  int op_slot_right_2185 = gc_frame_newslot(strlit2186);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2189 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2188);
// compiled call node returning call2189 (depth = 7)
// compiled member node returning call2189 (depth = 6)
  int op_slot_left_2185 = gc_frame_newslot(call2189);
  params[0] = strlit2186;
  partcv[0] = 1;
  Object opresult2190 = callmethod(call2189, "!=", 1, partcv, params);
// compiled op node returning opresult2190 (depth = 5)
  Object if2184 = done;
  if (istrue(opresult2190)) {
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2191 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2193 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2192);
// compiled call node returning call2193 (depth = 9)
// compiled member node returning call2193 (depth = 8)
  partcv[0] = 0;
  Object call2194 = callmethod(call2193, "new",
    1, partcv, params);
  gc_frame_end(callframe2191);
// compiled call node returning call2194 (depth = 7)
// compiled member node returning call2194 (depth = 6)
  *var_suggestion = call2194;
  if (call2194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2195 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2196 = alloc_Boolean(1);
// compiled identifier node returning bool2196 (depth = 7)
  gc_frame_newslot(bool2196);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2196;
  partcv[0] = 2;
  Object call2197 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2195);
// compiled call node returning call2197 (depth = 6)
  *var_closingBrace = call2197;
  if (call2197 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2200 = alloc_Boolean(0);
// compiled identifier node returning bool2200 (depth = 7)
  int op_slot_right_2199 = gc_frame_newslot(bool2200);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2202 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2203 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2202);
// compiled call node returning call2203 (depth = 8)
// compiled member node returning call2203 (depth = 7)
  int op_slot_left_2199 = gc_frame_newslot(call2203);
  params[0] = bool2200;
  partcv[0] = 1;
  Object opresult2204 = callmethod(call2203, "==", 1, partcv, params);
// compiled op node returning opresult2204 (depth = 6)
  Object if2198 = done;
  if (istrue(opresult2204)) {
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_2206 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2209 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2208);
// compiled call node returning call2209 (depth = 9)
// compiled member node returning call2209 (depth = 8)
  int op_slot_left_2206 = gc_frame_newslot(call2209);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2210 = callmethod(call2209, "==", 1, partcv, params);
// compiled op node returning opresult2210 (depth = 7)
  Object if2205 = done;
  if (istrue(opresult2210)) {
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2211 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2212 = alloc_Boolean(0);
// compiled identifier node returning bool2212 (depth = 8)
  gc_frame_newslot(bool2212);
// starting to compile identifier node (depth = 8)
  Object bool2213 = alloc_Boolean(1);
// compiled identifier node returning bool2213 (depth = 8)
  gc_frame_newslot(bool2213);
// starting to compile string node (depth = 8)
  if (strlit2214 == NULL) {
    strlit2214 = alloc_String("then {}");
    gc_root(strlit2214);
  }
// compiled string node returning strlit2214 (depth = 8)
  gc_frame_newslot(strlit2214);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2212;
  params[2] = bool2213;
  params[3] = strlit2214;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2215 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2211);
// compiled call node returning call2215 (depth = 7)
    gc_frame_newslot(call2215);
    if2205 = call2215;
  } else {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2216 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2218 = alloc_Float64(0.1);
// compiled num node returning num2218 (depth = 9)
  int op_slot_right_2217 = gc_frame_newslot(num2218);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2220 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2222 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2221);
// compiled call node returning call2222 (depth = 12)
// compiled member node returning call2222 (depth = 11)
  partcv[0] = 0;
  Object call2223 = callmethod(call2222, "line",
    1, partcv, params);
  gc_frame_end(callframe2220);
// compiled call node returning call2223 (depth = 10)
// compiled member node returning call2223 (depth = 9)
  int op_slot_left_2217 = gc_frame_newslot(call2223);
  params[0] = num2218;
  partcv[0] = 1;
  Object sum2224 = callmethod(call2223, "+", 1, partcv, params);
// compiled op node returning sum2224 (depth = 8)
  gc_frame_newslot(sum2224);
// starting to compile string node (depth = 8)
  if (strlit2225 == NULL) {
    strlit2225 = alloc_String("}");
    gc_root(strlit2225);
  }
// compiled string node returning strlit2225 (depth = 8)
  gc_frame_newslot(strlit2225);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2224;
  params[1] = strlit2225;
  partcv[0] = 2;
  Object call2226 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2216);
// compiled call node returning call2226 (depth = 7)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2227 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2228 = alloc_Boolean(0);
// compiled identifier node returning bool2228 (depth = 8)
  gc_frame_newslot(bool2228);
// starting to compile identifier node (depth = 8)
  Object bool2229 = alloc_Boolean(1);
// compiled identifier node returning bool2229 (depth = 8)
  gc_frame_newslot(bool2229);
// starting to compile string node (depth = 8)
  if (strlit2230 == NULL) {
    strlit2230 = alloc_String("then {");
    gc_root(strlit2230);
  }
// compiled string node returning strlit2230 (depth = 8)
  gc_frame_newslot(strlit2230);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2228;
  params[2] = bool2229;
  params[3] = strlit2230;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2231 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2227);
// compiled call node returning call2231 (depth = 7)
    gc_frame_newslot(call2231);
    if2205 = call2231;
  }
// compiled if node returning if2205 (depth = 6)
    gc_frame_newslot(if2205);
    if2198 = if2205;
  } else {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2232 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool2233 = alloc_Boolean(0);
// compiled identifier node returning bool2233 (depth = 7)
  gc_frame_newslot(bool2233);
// starting to compile identifier node (depth = 7)
  Object bool2234 = alloc_Boolean(1);
// compiled identifier node returning bool2234 (depth = 7)
  gc_frame_newslot(bool2234);
// starting to compile string node (depth = 7)
  if (strlit2235 == NULL) {
    strlit2235 = alloc_String("then {");
    gc_root(strlit2235);
  }
// compiled string node returning strlit2235 (depth = 7)
  gc_frame_newslot(strlit2235);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool2233;
  params[2] = bool2234;
  params[3] = strlit2235;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2236 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2232);
// compiled call node returning call2236 (depth = 6)
    gc_frame_newslot(call2236);
    if2198 = call2236;
  }
// compiled if node returning if2198 (depth = 5)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2237 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2238 == NULL) {
    strlit2238 = alloc_String("an if statement must have a '{' after the 'then'.");
    gc_root(strlit2238);
  }
// compiled string node returning strlit2238 (depth = 6)
  gc_frame_newslot(strlit2238);
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2240 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2239);
// compiled call node returning call2240 (depth = 7)
// compiled member node returning call2240 (depth = 6)
  gc_frame_newslot(call2240);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2243 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2242);
// compiled call node returning call2243 (depth = 8)
// compiled member node returning call2243 (depth = 7)
  int op_slot_right_2241 = gc_frame_newslot(call2243);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2246 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2245);
// compiled call node returning call2246 (depth = 8)
// compiled member node returning call2246 (depth = 7)
  int op_slot_left_2241 = gc_frame_newslot(call2246);
  params[0] = call2243;
  partcv[0] = 1;
  Object sum2247 = callmethod(call2246, "+", 1, partcv, params);
// compiled op node returning sum2247 (depth = 6)
  gc_frame_newslot(sum2247);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2238;
  params[1] = call2240;
  params[2] = sum2247;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2248 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2237);
// compiled call node returning call2248 (depth = 5)
    gc_frame_newslot(call2248);
    if2184 = call2248;
  } else {
  }
// compiled if node returning if2184 (depth = 4)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2250 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2249);
// compiled call node returning call2250 (depth = 5)
// compiled member node returning call2250 (depth = 4)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2254 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2253);
// compiled call node returning call2254 (depth = 7)
// compiled member node returning call2254 (depth = 6)
  int op_slot_right_2252 = gc_frame_newslot(call2254);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2256 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2257 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2256);
// compiled call node returning call2257 (depth = 7)
// compiled member node returning call2257 (depth = 6)
  int op_slot_left_2252 = gc_frame_newslot(call2257);
  params[0] = call2254;
  partcv[0] = 1;
  Object opresult2258 = callmethod(call2257, "==", 1, partcv, params);
// compiled op node returning opresult2258 (depth = 5)
  Object if2251 = done;
  if (istrue(opresult2258)) {
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2260 = alloc_Float64(1);
// compiled num node returning num2260 (depth = 7)
  int op_slot_right_2259 = gc_frame_newslot(num2260);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2262 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2263 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2262);
// compiled call node returning call2263 (depth = 8)
// compiled member node returning call2263 (depth = 7)
  int op_slot_left_2259 = gc_frame_newslot(call2263);
  params[0] = num2260;
  partcv[0] = 1;
  Object diff2264 = callmethod(call2263, "-", 1, partcv, params);
// compiled op node returning diff2264 (depth = 6)
  *var_minIndentLevel = diff2264;
  if (diff2264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2251 = done;
  } else {
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2251 = done;
  }
// compiled if node returning if2251 (depth = 4)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2267 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2268 = alloc_Block(NULL, NULL, "parser", 737);
  gc_frame_newslot(block2268);
// method "_apply"
  block_savedest(block2268);
  Object closure2269 = createclosure(1, "_apply");
  setclosureframe(closure2269, stackframe);
  addtoclosure(closure2269, selfslot);
  struct UserObject *uo2269 = (struct UserObject*)block2268;
  uo2269->data[0] = (Object)closure2269;
  Method *meth_meth_parser__apply2269 = addmethod2pos(block2268, "_apply", &meth_parser__apply2269, 0);
  int argcv_meth_parser__apply2269[] = {0};
  meth_meth_parser__apply2269->type = alloc_MethodType(1, argcv_meth_parser__apply2269);
  meth_meth_parser__apply2269->definitionModule = modulename;
  meth_meth_parser__apply2269->definitionLine = 733;
// compiled block node returning block2268 (depth = 5)
  gc_frame_newslot(block2268);
// starting to compile block node (depth = 5)
  Object block2276 = alloc_Block(NULL, NULL, "parser", 737);
  gc_frame_newslot(block2276);
// method "_apply"
  block_savedest(block2276);
  Object closure2277 = createclosure(8, "_apply");
  setclosureframe(closure2277, stackframe);
  addtoclosure(closure2277, var_errormessages);
  addtoclosure(closure2277, var_btok);
  addtoclosure(closure2277, var_lastToken);
  addtoclosure(closure2277, var_sym);
  addtoclosure(closure2277, var_values);
  addtoclosure(closure2277, var_v);
  addtoclosure(closure2277, var_body);
  addtoclosure(closure2277, selfslot);
  struct UserObject *uo2277 = (struct UserObject*)block2276;
  uo2277->data[0] = (Object)closure2277;
  Method *meth_meth_parser__apply2277 = addmethod2pos(block2276, "_apply", &meth_parser__apply2277, 0);
  int argcv_meth_parser__apply2277[] = {0};
  meth_meth_parser__apply2277->type = alloc_MethodType(1, argcv_meth_parser__apply2277);
  meth_meth_parser__apply2277->definitionModule = modulename;
  meth_meth_parser__apply2277->definitionLine = 737;
// compiled block node returning block2276 (depth = 5)
  gc_frame_newslot(block2276);
// call case 5: prelude request
  params[0] = block2268;
  params[1] = block2276;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2337 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2267);
// compiled call node returning call2337 (depth = 4)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2339 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compiled call node returning call2339 (depth = 5)
// compiled member node returning call2339 (depth = 4)
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2340 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2341 = alloc_Block(NULL, NULL, "parser", 760);
  gc_frame_newslot(block2341);
// method "_apply"
  block_savedest(block2341);
  Object closure2342 = createclosure(2, "_apply");
  setclosureframe(closure2342, stackframe);
  addtoclosure(closure2342, var_sym);
  addtoclosure(closure2342, selfslot);
  struct UserObject *uo2342 = (struct UserObject*)block2341;
  uo2342->data[0] = (Object)closure2342;
  Method *meth_meth_parser__apply2342 = addmethod2pos(block2341, "_apply", &meth_parser__apply2342, 0);
  int argcv_meth_parser__apply2342[] = {0};
  meth_meth_parser__apply2342->type = alloc_MethodType(1, argcv_meth_parser__apply2342);
  meth_meth_parser__apply2342->definitionModule = modulename;
  meth_meth_parser__apply2342->definitionLine = 755;
// compiled block node returning block2341 (depth = 5)
  gc_frame_newslot(block2341);
// starting to compile block node (depth = 5)
  Object block2356 = alloc_Block(NULL, NULL, "parser", 760);
  gc_frame_newslot(block2356);
// method "_apply"
  block_savedest(block2356);
  Object closure2357 = createclosure(16, "_apply");
  setclosureframe(closure2357, stackframe);
  addtoclosure(closure2357, var_sym);
  addtoclosure(closure2357, var_statementToken);
  addtoclosure(closure2357, var_errormessages);
  addtoclosure(closure2357, var_blocksOK);
  addtoclosure(closure2357, var_lastToken);
  addtoclosure(closure2357, var_values);
  addtoclosure(closure2357, var_econd);
  addtoclosure(closure2357, var_ebody);
  addtoclosure(closure2357, var_btok);
  addtoclosure(closure2357, var_minIndentLevel);
  addtoclosure(closure2357, var_minInd);
  addtoclosure(closure2357, var_v);
  addtoclosure(closure2357, var_newelse);
  addtoclosure(closure2357, var_eif);
  addtoclosure(closure2357, var_curelse);
  addtoclosure(closure2357, selfslot);
  struct UserObject *uo2357 = (struct UserObject*)block2356;
  uo2357->data[0] = (Object)closure2357;
  Method *meth_meth_parser__apply2357 = addmethod2pos(block2356, "_apply", &meth_parser__apply2357, 0);
  int argcv_meth_parser__apply2357[] = {0};
  meth_meth_parser__apply2357->type = alloc_MethodType(1, argcv_meth_parser__apply2357);
  meth_meth_parser__apply2357->definitionModule = modulename;
  meth_meth_parser__apply2357->definitionLine = 760;
// compiled block node returning block2356 (depth = 5)
  gc_frame_newslot(block2356);
// call case 5: prelude request
  params[0] = block2341;
  params[1] = block2356;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2982 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2340);
// compiled call node returning call2982 (depth = 4)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2986 == NULL) {
    strlit2986 = alloc_String("else");
    gc_root(strlit2986);
  }
// compiled string node returning strlit2986 (depth = 7)
  int op_slot_right_2985 = gc_frame_newslot(strlit2986);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2989 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2988);
// compiled call node returning call2989 (depth = 8)
// compiled member node returning call2989 (depth = 7)
  int op_slot_left_2985 = gc_frame_newslot(call2989);
  params[0] = strlit2986;
  partcv[0] = 1;
  Object opresult2990 = callmethod(call2989, "==", 1, partcv, params);
// compiled op node returning opresult2990 (depth = 6)
  int op_slot_right_2984 = gc_frame_newslot(opresult2990);
// starting to compile call node (depth = 6)
  int callframe2992 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2993 == NULL) {
    strlit2993 = alloc_String("identifier");
    gc_root(strlit2993);
  }
// compiled string node returning strlit2993 (depth = 7)
  gc_frame_newslot(strlit2993);
// call case 4: self request
  params[0] = strlit2993;
  partcv[0] = 1;
  Object call2994 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2992);
// compiled call node returning call2994 (depth = 6)
  int op_slot_left_2984 = gc_frame_newslot(call2994);
  params[0] = opresult2990;
  partcv[0] = 1;
  Object opresult2995 = callmethod(call2994, "&&", 1, partcv, params);
// compiled op node returning opresult2995 (depth = 5)
  Object if2983 = done;
  if (istrue(opresult2995)) {
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2996 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2997 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2996);
// compiled call node returning call2997 (depth = 6)
// compiled member node returning call2997 (depth = 5)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3000 == NULL) {
    strlit3000 = alloc_String("lbrace");
    gc_root(strlit3000);
  }
// compiled string node returning strlit3000 (depth = 7)
  int op_slot_right_2999 = gc_frame_newslot(strlit3000);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3003 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3002);
// compiled call node returning call3003 (depth = 8)
// compiled member node returning call3003 (depth = 7)
  int op_slot_left_2999 = gc_frame_newslot(call3003);
  params[0] = strlit3000;
  partcv[0] = 1;
  Object opresult3004 = callmethod(call3003, "!=", 1, partcv, params);
// compiled op node returning opresult3004 (depth = 6)
  Object if2998 = done;
  if (istrue(opresult3004)) {
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3005 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3007 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3006);
// compiled call node returning call3007 (depth = 10)
// compiled member node returning call3007 (depth = 9)
  partcv[0] = 0;
  Object call3008 = callmethod(call3007, "new",
    1, partcv, params);
  gc_frame_end(callframe3005);
// compiled call node returning call3008 (depth = 8)
// compiled member node returning call3008 (depth = 7)
  *var_suggestion = call3008;
  if (call3008 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3009 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool3010 = alloc_Boolean(1);
// compiled identifier node returning bool3010 (depth = 8)
  gc_frame_newslot(bool3010);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3010;
  partcv[0] = 2;
  Object call3011 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3009);
// compiled call node returning call3011 (depth = 7)
  *var_closingBrace = call3011;
  if (call3011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3014 = alloc_Boolean(0);
// compiled identifier node returning bool3014 (depth = 8)
  int op_slot_right_3013 = gc_frame_newslot(bool3014);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3017 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3016);
// compiled call node returning call3017 (depth = 9)
// compiled member node returning call3017 (depth = 8)
  int op_slot_left_3013 = gc_frame_newslot(call3017);
  params[0] = bool3014;
  partcv[0] = 1;
  Object opresult3018 = callmethod(call3017, "==", 1, partcv, params);
// compiled op node returning opresult3018 (depth = 7)
  Object if3012 = done;
  if (istrue(opresult3018)) {
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_3020 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call3023 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3022);
// compiled call node returning call3023 (depth = 10)
// compiled member node returning call3023 (depth = 9)
  int op_slot_left_3020 = gc_frame_newslot(call3023);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3024 = callmethod(call3023, "==", 1, partcv, params);
// compiled op node returning opresult3024 (depth = 8)
  Object if3019 = done;
  if (istrue(opresult3024)) {
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3025 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3026 = alloc_Boolean(0);
// compiled identifier node returning bool3026 (depth = 9)
  gc_frame_newslot(bool3026);
// starting to compile identifier node (depth = 9)
  Object bool3027 = alloc_Boolean(1);
// compiled identifier node returning bool3027 (depth = 9)
  gc_frame_newslot(bool3027);
// starting to compile string node (depth = 9)
  if (strlit3028 == NULL) {
    strlit3028 = alloc_String("else {}");
    gc_root(strlit3028);
  }
// compiled string node returning strlit3028 (depth = 9)
  gc_frame_newslot(strlit3028);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool3026;
  params[2] = bool3027;
  params[3] = strlit3028;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3029 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3025);
// compiled call node returning call3029 (depth = 8)
    gc_frame_newslot(call3029);
    if3019 = call3029;
  } else {
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3030 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3032 = alloc_Float64(0.1);
// compiled num node returning num3032 (depth = 10)
  int op_slot_right_3031 = gc_frame_newslot(num3032);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3034 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call3036 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3035);
// compiled call node returning call3036 (depth = 13)
// compiled member node returning call3036 (depth = 12)
  partcv[0] = 0;
  Object call3037 = callmethod(call3036, "line",
    1, partcv, params);
  gc_frame_end(callframe3034);
// compiled call node returning call3037 (depth = 11)
// compiled member node returning call3037 (depth = 10)
  int op_slot_left_3031 = gc_frame_newslot(call3037);
  params[0] = num3032;
  partcv[0] = 1;
  Object sum3038 = callmethod(call3037, "+", 1, partcv, params);
// compiled op node returning sum3038 (depth = 9)
  gc_frame_newslot(sum3038);
// starting to compile string node (depth = 9)
  if (strlit3039 == NULL) {
    strlit3039 = alloc_String("}");
    gc_root(strlit3039);
  }
// compiled string node returning strlit3039 (depth = 9)
  gc_frame_newslot(strlit3039);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum3038;
  params[1] = strlit3039;
  partcv[0] = 2;
  Object call3040 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3030);
// compiled call node returning call3040 (depth = 8)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3041 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3042 = alloc_Boolean(0);
// compiled identifier node returning bool3042 (depth = 9)
  gc_frame_newslot(bool3042);
// starting to compile identifier node (depth = 9)
  Object bool3043 = alloc_Boolean(1);
// compiled identifier node returning bool3043 (depth = 9)
  gc_frame_newslot(bool3043);
// starting to compile string node (depth = 9)
  if (strlit3044 == NULL) {
    strlit3044 = alloc_String("else {");
    gc_root(strlit3044);
  }
// compiled string node returning strlit3044 (depth = 9)
  gc_frame_newslot(strlit3044);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool3042;
  params[2] = bool3043;
  params[3] = strlit3044;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3045 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3041);
// compiled call node returning call3045 (depth = 8)
    gc_frame_newslot(call3045);
    if3019 = call3045;
  }
// compiled if node returning if3019 (depth = 7)
    gc_frame_newslot(if3019);
    if3012 = if3019;
  } else {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3046 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool3047 = alloc_Boolean(0);
// compiled identifier node returning bool3047 (depth = 8)
  gc_frame_newslot(bool3047);
// starting to compile identifier node (depth = 8)
  Object bool3048 = alloc_Boolean(1);
// compiled identifier node returning bool3048 (depth = 8)
  gc_frame_newslot(bool3048);
// starting to compile string node (depth = 8)
  if (strlit3049 == NULL) {
    strlit3049 = alloc_String("else {");
    gc_root(strlit3049);
  }
// compiled string node returning strlit3049 (depth = 8)
  gc_frame_newslot(strlit3049);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool3047;
  params[2] = bool3048;
  params[3] = strlit3049;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3050 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3046);
// compiled call node returning call3050 (depth = 7)
    gc_frame_newslot(call3050);
    if3012 = call3050;
  }
// compiled if node returning if3012 (depth = 6)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3051 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3052 == NULL) {
    strlit3052 = alloc_String("an else statement must have a '{' after the 'else'.");
    gc_root(strlit3052);
  }
// compiled string node returning strlit3052 (depth = 7)
  gc_frame_newslot(strlit3052);
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3054 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3053);
// compiled call node returning call3054 (depth = 8)
// compiled member node returning call3054 (depth = 7)
  gc_frame_newslot(call3054);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3057 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3056);
// compiled call node returning call3057 (depth = 9)
// compiled member node returning call3057 (depth = 8)
  int op_slot_right_3055 = gc_frame_newslot(call3057);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3060 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3059);
// compiled call node returning call3060 (depth = 9)
// compiled member node returning call3060 (depth = 8)
  int op_slot_left_3055 = gc_frame_newslot(call3060);
  params[0] = call3057;
  partcv[0] = 1;
  Object sum3061 = callmethod(call3060, "+", 1, partcv, params);
// compiled op node returning sum3061 (depth = 7)
  gc_frame_newslot(sum3061);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3052;
  params[1] = call3054;
  params[2] = sum3061;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3062 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3051);
// compiled call node returning call3062 (depth = 6)
    gc_frame_newslot(call3062);
    if2998 = call3062;
  } else {
  }
// compiled if node returning if2998 (depth = 5)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3064 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compiled call node returning call3064 (depth = 6)
// compiled member node returning call3064 (depth = 5)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3067 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3068 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3067);
// compiled call node returning call3068 (depth = 8)
// compiled member node returning call3068 (depth = 7)
  int op_slot_right_3066 = gc_frame_newslot(call3068);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3071 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3070);
// compiled call node returning call3071 (depth = 8)
// compiled member node returning call3071 (depth = 7)
  int op_slot_left_3066 = gc_frame_newslot(call3071);
  params[0] = call3068;
  partcv[0] = 1;
  Object opresult3072 = callmethod(call3071, "==", 1, partcv, params);
// compiled op node returning opresult3072 (depth = 6)
  Object if3065 = done;
  if (istrue(opresult3072)) {
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3074 = alloc_Float64(1);
// compiled num node returning num3074 (depth = 8)
  int op_slot_right_3073 = gc_frame_newslot(num3074);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3076 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3077 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3076);
// compiled call node returning call3077 (depth = 9)
// compiled member node returning call3077 (depth = 8)
  int op_slot_left_3073 = gc_frame_newslot(call3077);
  params[0] = num3074;
  partcv[0] = 1;
  Object diff3078 = callmethod(call3077, "-", 1, partcv, params);
// compiled op node returning diff3078 (depth = 7)
  *var_minIndentLevel = diff3078;
  if (diff3078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3065 = done;
  } else {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3065 = done;
  }
// compiled if node returning if3065 (depth = 5)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3081 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3082 = alloc_Block(NULL, NULL, "parser", 953);
  gc_frame_newslot(block3082);
// method "_apply"
  block_savedest(block3082);
  Object closure3083 = createclosure(1, "_apply");
  setclosureframe(closure3083, stackframe);
  addtoclosure(closure3083, selfslot);
  struct UserObject *uo3083 = (struct UserObject*)block3082;
  uo3083->data[0] = (Object)closure3083;
  Method *meth_meth_parser__apply3083 = addmethod2pos(block3082, "_apply", &meth_parser__apply3083, 0);
  int argcv_meth_parser__apply3083[] = {0};
  meth_meth_parser__apply3083->type = alloc_MethodType(1, argcv_meth_parser__apply3083);
  meth_meth_parser__apply3083->definitionModule = modulename;
  meth_meth_parser__apply3083->definitionLine = 949;
// compiled block node returning block3082 (depth = 6)
  gc_frame_newslot(block3082);
// starting to compile block node (depth = 6)
  Object block3090 = alloc_Block(NULL, NULL, "parser", 953);
  gc_frame_newslot(block3090);
// method "_apply"
  block_savedest(block3090);
  Object closure3091 = createclosure(8, "_apply");
  setclosureframe(closure3091, stackframe);
  addtoclosure(closure3091, var_errormessages);
  addtoclosure(closure3091, var_btok);
  addtoclosure(closure3091, var_lastToken);
  addtoclosure(closure3091, var_sym);
  addtoclosure(closure3091, var_values);
  addtoclosure(closure3091, var_v);
  addtoclosure(closure3091, var_curelse);
  addtoclosure(closure3091, selfslot);
  struct UserObject *uo3091 = (struct UserObject*)block3090;
  uo3091->data[0] = (Object)closure3091;
  Method *meth_meth_parser__apply3091 = addmethod2pos(block3090, "_apply", &meth_parser__apply3091, 0);
  int argcv_meth_parser__apply3091[] = {0};
  meth_meth_parser__apply3091->type = alloc_MethodType(1, argcv_meth_parser__apply3091);
  meth_meth_parser__apply3091->definitionModule = modulename;
  meth_meth_parser__apply3091->definitionLine = 953;
// compiled block node returning block3090 (depth = 6)
  gc_frame_newslot(block3090);
// call case 5: prelude request
  params[0] = block3082;
  params[1] = block3090;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3151 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3081);
// compiled call node returning call3151 (depth = 5)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3153 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3152);
// compiled call node returning call3153 (depth = 6)
// compiled member node returning call3153 (depth = 5)
    gc_frame_newslot(call3153);
    if2983 = call3153;
  } else {
  }
// compiled if node returning if2983 (depth = 4)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3154 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call3156 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe3155);
// compiled call node returning call3156 (depth = 6)
// compiled member node returning call3156 (depth = 5)
  gc_frame_newslot(call3156);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call3158 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3157);
// compiled call node returning call3158 (depth = 6)
// compiled member node returning call3158 (depth = 5)
  gc_frame_newslot(call3158);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call3156;
  params[1] = call3158;
  partcv[0] = 2;
  Object call3159 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe3154);
// compiled call node returning call3159 (depth = 4)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3160 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 4: self request
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call3161 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 5)
  *var_o = call3161;
  if (call3161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3162 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call3163 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3162);
// compiled call node returning call3163 (depth = 4)
    gc_frame_newslot(call3163);
    if2169 = call3163;
  } else {
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3164 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3165 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3166 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3165);
// compiled call node returning call3166 (depth = 8)
// compiled member node returning call3166 (depth = 7)
  partcv[0] = 0;
  Object call3167 = callmethod(call3166, "new",
    1, partcv, params);
  gc_frame_end(callframe3164);
// compiled call node returning call3167 (depth = 6)
// compiled member node returning call3167 (depth = 5)
  *var_suggestion = call3167;
  if (call3167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3170 == NULL) {
    strlit3170 = alloc_String("lbrace");
    gc_root(strlit3170);
  }
// compiled string node returning strlit3170 (depth = 6)
  int op_slot_right_3169 = gc_frame_newslot(strlit3170);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3173 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3172);
// compiled call node returning call3173 (depth = 7)
// compiled member node returning call3173 (depth = 6)
  int op_slot_left_3169 = gc_frame_newslot(call3173);
  params[0] = strlit3170;
  partcv[0] = 1;
  Object opresult3174 = callmethod(call3173, "==", 1, partcv, params);
// compiled op node returning opresult3174 (depth = 5)
  Object if3168 = done;
  if (istrue(opresult3174)) {
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3175 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool3176 = alloc_Boolean(0);
// compiled identifier node returning bool3176 (depth = 7)
  gc_frame_newslot(bool3176);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3176;
  partcv[0] = 2;
  Object call3177 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3175);
// compiled call node returning call3177 (depth = 6)
  *var_closingBrace = call3177;
  if (call3177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3180 = alloc_Boolean(0);
// compiled identifier node returning bool3180 (depth = 7)
  int op_slot_right_3179 = gc_frame_newslot(bool3180);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call3183 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3182);
// compiled call node returning call3183 (depth = 8)
// compiled member node returning call3183 (depth = 7)
  int op_slot_left_3179 = gc_frame_newslot(call3183);
  params[0] = bool3180;
  partcv[0] = 1;
  Object opresult3184 = callmethod(call3183, "==", 1, partcv, params);
// compiled op node returning opresult3184 (depth = 6)
  Object if3178 = done;
  if (istrue(opresult3184)) {
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3186 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3189 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3188);
// compiled call node returning call3189 (depth = 9)
// compiled member node returning call3189 (depth = 8)
  int op_slot_left_3186 = gc_frame_newslot(call3189);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3190 = callmethod(call3189, "==", 1, partcv, params);
// compiled op node returning opresult3190 (depth = 7)
  Object if3185 = done;
  if (istrue(opresult3190)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3191 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool3192 = alloc_Boolean(1);
// compiled identifier node returning bool3192 (depth = 8)
  gc_frame_newslot(bool3192);
// starting to compile identifier node (depth = 8)
  Object bool3193 = alloc_Boolean(0);
// compiled identifier node returning bool3193 (depth = 8)
  gc_frame_newslot(bool3193);
// starting to compile string node (depth = 8)
  if (strlit3194 == NULL) {
    strlit3194 = alloc_String(" then {}");
    gc_root(strlit3194);
  }
// compiled string node returning strlit3194 (depth = 8)
  gc_frame_newslot(strlit3194);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool3192;
  params[2] = bool3193;
  params[3] = strlit3194;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3195 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3191);
// compiled call node returning call3195 (depth = 7)
    gc_frame_newslot(call3195);
    if3185 = call3195;
  } else {
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3196 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool3197 = alloc_Boolean(1);
// compiled identifier node returning bool3197 (depth = 8)
  gc_frame_newslot(bool3197);
// starting to compile identifier node (depth = 8)
  Object bool3198 = alloc_Boolean(0);
// compiled identifier node returning bool3198 (depth = 8)
  gc_frame_newslot(bool3198);
// starting to compile string node (depth = 8)
  if (strlit3199 == NULL) {
    strlit3199 = alloc_String(" then {");
    gc_root(strlit3199);
  }
// compiled string node returning strlit3199 (depth = 8)
  gc_frame_newslot(strlit3199);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool3197;
  params[2] = bool3198;
  params[3] = strlit3199;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3200 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3196);
// compiled call node returning call3200 (depth = 7)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3201 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3203 = alloc_Float64(0.1);
// compiled num node returning num3203 (depth = 9)
  int op_slot_right_3202 = gc_frame_newslot(num3203);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3205 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3207 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3206);
// compiled call node returning call3207 (depth = 12)
// compiled member node returning call3207 (depth = 11)
  partcv[0] = 0;
  Object call3208 = callmethod(call3207, "line",
    1, partcv, params);
  gc_frame_end(callframe3205);
// compiled call node returning call3208 (depth = 10)
// compiled member node returning call3208 (depth = 9)
  int op_slot_left_3202 = gc_frame_newslot(call3208);
  params[0] = num3203;
  partcv[0] = 1;
  Object sum3209 = callmethod(call3208, "+", 1, partcv, params);
// compiled op node returning sum3209 (depth = 8)
  gc_frame_newslot(sum3209);
// starting to compile string node (depth = 8)
  if (strlit3210 == NULL) {
    strlit3210 = alloc_String("}");
    gc_root(strlit3210);
  }
// compiled string node returning strlit3210 (depth = 8)
  gc_frame_newslot(strlit3210);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3209;
  params[1] = strlit3210;
  partcv[0] = 2;
  Object call3211 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3201);
// compiled call node returning call3211 (depth = 7)
    gc_frame_newslot(call3211);
    if3185 = call3211;
  }
// compiled if node returning if3185 (depth = 6)
    gc_frame_newslot(if3185);
    if3178 = if3185;
  } else {
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3212 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool3213 = alloc_Boolean(1);
// compiled identifier node returning bool3213 (depth = 7)
  gc_frame_newslot(bool3213);
// starting to compile identifier node (depth = 7)
  Object bool3214 = alloc_Boolean(0);
// compiled identifier node returning bool3214 (depth = 7)
  gc_frame_newslot(bool3214);
// starting to compile string node (depth = 7)
  if (strlit3215 == NULL) {
    strlit3215 = alloc_String(" then {");
    gc_root(strlit3215);
  }
// compiled string node returning strlit3215 (depth = 7)
  gc_frame_newslot(strlit3215);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool3213;
  params[2] = bool3214;
  params[3] = strlit3215;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3216 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3212);
// compiled call node returning call3216 (depth = 6)
    gc_frame_newslot(call3216);
    if3178 = call3216;
  }
// compiled if node returning if3178 (depth = 5)
    gc_frame_newslot(if3178);
    if3168 = if3178;
  } else {
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3217 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool3218 = alloc_Boolean(1);
// compiled identifier node returning bool3218 (depth = 7)
  gc_frame_newslot(bool3218);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3218;
  partcv[0] = 2;
  Object call3219 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3217);
// compiled call node returning call3219 (depth = 6)
  *var_closingBrace = call3219;
  if (call3219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3222 = alloc_Boolean(0);
// compiled identifier node returning bool3222 (depth = 7)
  int op_slot_right_3221 = gc_frame_newslot(bool3222);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call3225 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3224);
// compiled call node returning call3225 (depth = 8)
// compiled member node returning call3225 (depth = 7)
  int op_slot_left_3221 = gc_frame_newslot(call3225);
  params[0] = bool3222;
  partcv[0] = 1;
  Object opresult3226 = callmethod(call3225, "==", 1, partcv, params);
// compiled op node returning opresult3226 (depth = 6)
  Object if3220 = done;
  if (istrue(opresult3226)) {
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_3228 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3231 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3230);
// compiled call node returning call3231 (depth = 9)
// compiled member node returning call3231 (depth = 8)
  int op_slot_left_3228 = gc_frame_newslot(call3231);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3232 = callmethod(call3231, "==", 1, partcv, params);
// compiled op node returning opresult3232 (depth = 7)
  Object if3227 = done;
  if (istrue(opresult3232)) {
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3233 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3234 == NULL) {
    strlit3234 = alloc_String(" then {}");
    gc_root(strlit3234);
  }
// compiled string node returning strlit3234 (depth = 8)
  gc_frame_newslot(strlit3234);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3234;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3235 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3233);
// compiled call node returning call3235 (depth = 7)
    gc_frame_newslot(call3235);
    if3227 = call3235;
  } else {
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3236 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String(" then {");
    gc_root(strlit3237);
  }
// compiled string node returning strlit3237 (depth = 8)
  gc_frame_newslot(strlit3237);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3237;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3238 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3236);
// compiled call node returning call3238 (depth = 7)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3239 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3241 = alloc_Float64(0.1);
// compiled num node returning num3241 (depth = 9)
  int op_slot_right_3240 = gc_frame_newslot(num3241);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3243 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3245 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3244);
// compiled call node returning call3245 (depth = 12)
// compiled member node returning call3245 (depth = 11)
  partcv[0] = 0;
  Object call3246 = callmethod(call3245, "line",
    1, partcv, params);
  gc_frame_end(callframe3243);
// compiled call node returning call3246 (depth = 10)
// compiled member node returning call3246 (depth = 9)
  int op_slot_left_3240 = gc_frame_newslot(call3246);
  params[0] = num3241;
  partcv[0] = 1;
  Object sum3247 = callmethod(call3246, "+", 1, partcv, params);
// compiled op node returning sum3247 (depth = 8)
  gc_frame_newslot(sum3247);
// starting to compile string node (depth = 8)
  if (strlit3248 == NULL) {
    strlit3248 = alloc_String("}");
    gc_root(strlit3248);
  }
// compiled string node returning strlit3248 (depth = 8)
  gc_frame_newslot(strlit3248);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3247;
  params[1] = strlit3248;
  partcv[0] = 2;
  Object call3249 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3239);
// compiled call node returning call3249 (depth = 7)
    gc_frame_newslot(call3249);
    if3227 = call3249;
  }
// compiled if node returning if3227 (depth = 6)
    gc_frame_newslot(if3227);
    if3220 = if3227;
  } else {
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3250 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3251 == NULL) {
    strlit3251 = alloc_String(" then {");
    gc_root(strlit3251);
  }
// compiled string node returning strlit3251 (depth = 7)
  gc_frame_newslot(strlit3251);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3251;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3252 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3250);
// compiled call node returning call3252 (depth = 6)
    gc_frame_newslot(call3252);
    if3220 = call3252;
  }
// compiled if node returning if3220 (depth = 5)
    gc_frame_newslot(if3220);
    if3168 = if3220;
  }
// compiled if node returning if3168 (depth = 4)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3253 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3255 == NULL) {
    strlit3255 = alloc_String("the condition in parentheses.");
    gc_root(strlit3255);
  }
// compiled string node returning strlit3255 (depth = 6)
  int op_slot_right_3254 = gc_frame_newslot(strlit3255);
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3257 == NULL) {
    strlit3257 = alloc_String("an if statement must have 'then' after ");
    gc_root(strlit3257);
  }
// compiled string node returning strlit3257 (depth = 6)
  int op_slot_left_3254 = gc_frame_newslot(strlit3257);
  params[0] = strlit3255;
  partcv[0] = 1;
  Object opresult3258 = callmethod(strlit3257, "++", 1, partcv, params);
// compiled op node returning opresult3258 (depth = 5)
  gc_frame_newslot(opresult3258);
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3260 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3259);
// compiled call node returning call3260 (depth = 6)
// compiled member node returning call3260 (depth = 5)
  gc_frame_newslot(call3260);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3262 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3261);
// compiled call node returning call3262 (depth = 6)
// compiled member node returning call3262 (depth = 5)
  gc_frame_newslot(call3262);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3258;
  params[1] = call3260;
  params[2] = call3262;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3263 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3253);
// compiled call node returning call3263 (depth = 4)
    gc_frame_newslot(call3263);
    if2169 = call3263;
  }
// compiled if node returning if2169 (depth = 3)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1803 = done;
  } else {
  }
// compiled if node returning if1803 (depth = 2)
  gc_frame_end(frame);
  return if1803;
}
Object meth_parser_identifier3266(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for identifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for identifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3268 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3269 == NULL) {
    strlit3269 = alloc_String("identifier");
    gc_root(strlit3269);
  }
// compiled string node returning strlit3269 (depth = 4)
  gc_frame_newslot(strlit3269);
// call case 4: self request
  params[0] = strlit3269;
  partcv[0] = 1;
  Object call3270 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3268);
// compiled call node returning call3270 (depth = 3)
  Object if3267 = done;
  if (istrue(call3270)) {
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3273 == NULL) {
    strlit3273 = alloc_String("if");
    gc_root(strlit3273);
  }
// compiled string node returning strlit3273 (depth = 5)
  int op_slot_right_3272 = gc_frame_newslot(strlit3273);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3276 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3275);
// compiled call node returning call3276 (depth = 6)
// compiled member node returning call3276 (depth = 5)
  int op_slot_left_3272 = gc_frame_newslot(call3276);
  params[0] = strlit3273;
  partcv[0] = 1;
  Object opresult3277 = callmethod(call3276, "==", 1, partcv, params);
// compiled op node returning opresult3277 (depth = 4)
  Object if3271 = done;
  if (istrue(opresult3277)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3278 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3279 = callmethodflags(self, "doif", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3278);
// compiled call node returning call3279 (depth = 5)
// compiled member node returning call3279 (depth = 4)
    gc_frame_newslot(call3279);
    if3271 = call3279;
  } else {
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3280 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3281 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3280);
// compiled call node returning call3281 (depth = 5)
// compiled member node returning call3281 (depth = 4)
    gc_frame_newslot(call3281);
    if3271 = call3281;
  }
// compiled if node returning if3271 (depth = 3)
    gc_frame_newslot(if3271);
    if3267 = if3271;
  } else {
  }
// compiled if node returning if3267 (depth = 2)
  gc_frame_end(frame);
  return if3267;
}
Object meth_parser__apply3301(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe3302 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3303 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3302);
// compiled call node returning call3303 (depth = 9)
  gc_frame_end(frame);
  return call3303;
}
Object meth_parser__apply3370(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3372 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3371);
// compiled call node returning call3372 (depth = 10)
// compiled member node returning call3372 (depth = 9)
  gc_frame_end(frame);
  return call3372;
}
Object meth_parser_prefixop3282(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for prefixop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for prefixop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_op = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "op");
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_mem = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "mem");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3284 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("op");
    gc_root(strlit3285);
  }
// compiled string node returning strlit3285 (depth = 4)
  gc_frame_newslot(strlit3285);
// call case 4: self request
  params[0] = strlit3285;
  partcv[0] = 1;
  Object call3286 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3284);
// compiled call node returning call3286 (depth = 3)
  Object if3283 = done;
  if (istrue(call3286)) {
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3288 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3287);
// compiled call node returning call3288 (depth = 5)
// compiled member node returning call3288 (depth = 4)
  *var_op = call3288;
  if (call3288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_val = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3290 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3289);
// compiled call node returning call3290 (depth = 4)
// compiled member node returning call3290 (depth = 3)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3292 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3293 == NULL) {
    strlit3293 = alloc_String("lparen");
    gc_root(strlit3293);
  }
// compiled string node returning strlit3293 (depth = 5)
  gc_frame_newslot(strlit3293);
// call case 4: self request
  params[0] = strlit3293;
  partcv[0] = 1;
  Object call3294 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3292);
// compiled call node returning call3294 (depth = 4)
  Object if3291 = done;
  if (istrue(call3294)) {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3296 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3295);
// compiled call node returning call3296 (depth = 5)
// compiled member node returning call3296 (depth = 4)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3298 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3299 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3300 = alloc_Block(NULL, NULL, "parser", 1032);
  gc_frame_newslot(block3300);
// method "_apply"
  block_savedest(block3300);
  Object closure3301 = createclosure(2, "_apply");
  setclosureframe(closure3301, stackframe);
  addtoclosure(closure3301, var_blocksOK);
  addtoclosure(closure3301, selfslot);
  struct UserObject *uo3301 = (struct UserObject*)block3300;
  uo3301->data[0] = (Object)closure3301;
  Method *meth_meth_parser__apply3301 = addmethod2pos(block3300, "_apply", &meth_parser__apply3301, 0);
  int argcv_meth_parser__apply3301[] = {0};
  meth_meth_parser__apply3301->type = alloc_MethodType(1, argcv_meth_parser__apply3301);
  meth_meth_parser__apply3301->definitionModule = modulename;
  meth_meth_parser__apply3301->definitionLine = 1032;
// compiled block node returning block3300 (depth = 8)
  gc_frame_newslot(block3300);
// call case 4: self request
  params[0] = block3300;
  partcv[0] = 1;
  Object call3305 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3299);
// compiled call node returning call3305 (depth = 7)
  partcv[0] = 0;
  Object call3306 = callmethod(call3305, "not",
    1, partcv, params);
  gc_frame_end(callframe3298);
// compiled call node returning call3306 (depth = 6)
// compiled member node returning call3306 (depth = 5)
  Object if3297 = done;
  if (istrue(call3306)) {
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3307 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3309 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3308);
// compiled call node returning call3309 (depth = 9)
// compiled member node returning call3309 (depth = 8)
  partcv[0] = 0;
  Object call3310 = callmethod(call3309, "new",
    1, partcv, params);
  gc_frame_end(callframe3307);
// compiled call node returning call3310 (depth = 7)
// compiled member node returning call3310 (depth = 6)
  *var_suggestion = call3310;
  if (call3310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3311 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3312 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3313 == NULL) {
    strlit3313 = alloc_String("rparen");
    gc_root(strlit3313);
  }
// compiled string node returning strlit3313 (depth = 8)
  params[0] = strlit3313;
  partcv[0] = 1;
  callmethod(array3312, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3312 (depth = 7)
  gc_frame_newslot(array3312);
// call case 4: self request
  params[0] = array3312;
  partcv[0] = 1;
  Object call3314 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3311);
// compiled call node returning call3314 (depth = 6)
  *var_nextTok = call3314;
  if (call3314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3316 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3316 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3318 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3318 (depth = 6)
  Object if3315 = done;
  if (istrue(opresult3318)) {
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3319 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3320 == NULL) {
    strlit3320 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3320);
  }
// compiled string node returning strlit3320 (depth = 7)
  gc_frame_newslot(strlit3320);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3320;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3321 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3319);
// compiled call node returning call3321 (depth = 6)
    gc_frame_newslot(call3321);
    if3315 = call3321;
  } else {
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3322 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3324 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3323);
// compiled call node returning call3324 (depth = 8)
// compiled member node returning call3324 (depth = 7)
  gc_frame_newslot(call3324);
// starting to compile identifier node (depth = 7)
  Object bool3325 = alloc_Boolean(1);
// compiled identifier node returning bool3325 (depth = 7)
  gc_frame_newslot(bool3325);
// starting to compile identifier node (depth = 7)
  Object bool3326 = alloc_Boolean(0);
// compiled identifier node returning bool3326 (depth = 7)
  gc_frame_newslot(bool3326);
// starting to compile string node (depth = 7)
  if (strlit3327 == NULL) {
    strlit3327 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3327);
  }
// compiled string node returning strlit3327 (depth = 7)
  gc_frame_newslot(strlit3327);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3324;
  params[2] = bool3325;
  params[3] = bool3326;
  params[4] = strlit3327;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3328 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3322);
// compiled call node returning call3328 (depth = 6)
    gc_frame_newslot(call3328);
    if3315 = call3328;
  }
// compiled if node returning if3315 (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3329 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3330 == NULL) {
    strlit3330 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit3330);
  }
// compiled string node returning strlit3330 (depth = 6)
  gc_frame_newslot(strlit3330);
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3331 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3332 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3331);
// compiled call node returning call3332 (depth = 7)
// compiled member node returning call3332 (depth = 6)
  gc_frame_newslot(call3332);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3334 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3333);
// compiled call node returning call3334 (depth = 7)
// compiled member node returning call3334 (depth = 6)
  gc_frame_newslot(call3334);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3330;
  params[1] = call3332;
  params[2] = call3334;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3335 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3329);
// compiled call node returning call3335 (depth = 5)
    gc_frame_newslot(call3335);
    if3297 = call3335;
  } else {
  }
// compiled if node returning if3297 (depth = 4)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3338 == NULL) {
    strlit3338 = alloc_String("rparen");
    gc_root(strlit3338);
  }
// compiled string node returning strlit3338 (depth = 6)
  int op_slot_right_3337 = gc_frame_newslot(strlit3338);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3340 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3341 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3340);
// compiled call node returning call3341 (depth = 7)
// compiled member node returning call3341 (depth = 6)
  int op_slot_left_3337 = gc_frame_newslot(call3341);
  params[0] = strlit3338;
  partcv[0] = 1;
  Object opresult3342 = callmethod(call3341, "!=", 1, partcv, params);
// compiled op node returning opresult3342 (depth = 5)
  Object if3336 = done;
  if (istrue(opresult3342)) {
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3344 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3343);
// compiled call node returning call3344 (depth = 6)
// compiled member node returning call3344 (depth = 5)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3345 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3347 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3346);
// compiled call node returning call3347 (depth = 9)
// compiled member node returning call3347 (depth = 8)
  partcv[0] = 0;
  Object call3348 = callmethod(call3347, "new",
    1, partcv, params);
  gc_frame_end(callframe3345);
// compiled call node returning call3348 (depth = 7)
// compiled member node returning call3348 (depth = 6)
  *var_suggestion = call3348;
  if (call3348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3349 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3350 == NULL) {
    strlit3350 = alloc_String(")");
    gc_root(strlit3350);
  }
// compiled string node returning strlit3350 (depth = 6)
  gc_frame_newslot(strlit3350);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3350;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3351 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3349);
// compiled call node returning call3351 (depth = 5)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3352 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3353 == NULL) {
    strlit3353 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3353);
  }
// compiled string node returning strlit3353 (depth = 6)
  gc_frame_newslot(strlit3353);
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3355 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3354);
// compiled call node returning call3355 (depth = 7)
// compiled member node returning call3355 (depth = 6)
  gc_frame_newslot(call3355);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3358 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3357);
// compiled call node returning call3358 (depth = 8)
// compiled member node returning call3358 (depth = 7)
  int op_slot_right_3356 = gc_frame_newslot(call3358);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3360 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3361 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3360);
// compiled call node returning call3361 (depth = 8)
// compiled member node returning call3361 (depth = 7)
  int op_slot_left_3356 = gc_frame_newslot(call3361);
  params[0] = call3358;
  partcv[0] = 1;
  Object sum3362 = callmethod(call3361, "+", 1, partcv, params);
// compiled op node returning sum3362 (depth = 6)
  gc_frame_newslot(sum3362);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3353;
  params[1] = call3355;
  params[2] = sum3362;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3363 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3352);
// compiled call node returning call3363 (depth = 5)
    gc_frame_newslot(call3363);
    if3336 = call3363;
  } else {
  }
// compiled if node returning if3336 (depth = 4)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3364 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3365 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3364);
// compiled call node returning call3365 (depth = 5)
// compiled member node returning call3365 (depth = 4)
    gc_frame_newslot(call3365);
    if3291 = call3365;
  } else {
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3367 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3368 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3369 = alloc_Block(NULL, NULL, "parser", 1052);
  gc_frame_newslot(block3369);
// method "_apply"
  block_savedest(block3369);
  Object closure3370 = createclosure(1, "_apply");
  setclosureframe(closure3370, stackframe);
  addtoclosure(closure3370, selfslot);
  struct UserObject *uo3370 = (struct UserObject*)block3369;
  uo3370->data[0] = (Object)closure3370;
  Method *meth_meth_parser__apply3370 = addmethod2pos(block3369, "_apply", &meth_parser__apply3370, 0);
  int argcv_meth_parser__apply3370[] = {0};
  meth_meth_parser__apply3370->type = alloc_MethodType(1, argcv_meth_parser__apply3370);
  meth_meth_parser__apply3370->definitionModule = modulename;
  meth_meth_parser__apply3370->definitionLine = 1052;
// compiled block node returning block3369 (depth = 8)
  gc_frame_newslot(block3369);
// call case 4: self request
  params[0] = block3369;
  partcv[0] = 1;
  Object call3374 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3368);
// compiled call node returning call3374 (depth = 7)
  partcv[0] = 0;
  Object call3375 = callmethod(call3374, "not",
    1, partcv, params);
  gc_frame_end(callframe3367);
// compiled call node returning call3375 (depth = 6)
// compiled member node returning call3375 (depth = 5)
  Object if3366 = done;
  if (istrue(call3375)) {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3376 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3377 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3378 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3377);
// compiled call node returning call3378 (depth = 9)
// compiled member node returning call3378 (depth = 8)
  partcv[0] = 0;
  Object call3379 = callmethod(call3378, "empty",
    1, partcv, params);
  gc_frame_end(callframe3376);
// compiled call node returning call3379 (depth = 7)
// compiled member node returning call3379 (depth = 6)
  *var_suggestions = call3379;
  if (call3379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3380 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3382 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3381);
// compiled call node returning call3382 (depth = 9)
// compiled member node returning call3382 (depth = 8)
  partcv[0] = 0;
  Object call3383 = callmethod(call3382, "new",
    1, partcv, params);
  gc_frame_end(callframe3380);
// compiled call node returning call3383 (depth = 7)
// compiled member node returning call3383 (depth = 6)
  *var_suggestion = call3383;
  if (call3383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3384 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3385 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3386 == NULL) {
    strlit3386 = alloc_String("rparen");
    gc_root(strlit3386);
  }
// compiled string node returning strlit3386 (depth = 8)
  params[0] = strlit3386;
  partcv[0] = 1;
  callmethod(array3385, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3385 (depth = 7)
  gc_frame_newslot(array3385);
// call case 4: self request
  params[0] = array3385;
  partcv[0] = 1;
  Object call3387 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3384);
// compiled call node returning call3387 (depth = 6)
  *var_nextTok = call3387;
  if (call3387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3389 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3389 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3391 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3391 (depth = 6)
  Object if3388 = done;
  if (istrue(opresult3391)) {
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3392 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3393 == NULL) {
    strlit3393 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3393);
  }
// compiled string node returning strlit3393 (depth = 7)
  gc_frame_newslot(strlit3393);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3393;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3394 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3392);
// compiled call node returning call3394 (depth = 6)
    gc_frame_newslot(call3394);
    if3388 = call3394;
  } else {
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3395 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3397 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3396);
// compiled call node returning call3397 (depth = 8)
// compiled member node returning call3397 (depth = 7)
  gc_frame_newslot(call3397);
// starting to compile identifier node (depth = 7)
  Object bool3398 = alloc_Boolean(1);
// compiled identifier node returning bool3398 (depth = 7)
  gc_frame_newslot(bool3398);
// starting to compile identifier node (depth = 7)
  Object bool3399 = alloc_Boolean(0);
// compiled identifier node returning bool3399 (depth = 7)
  gc_frame_newslot(bool3399);
// starting to compile string node (depth = 7)
  if (strlit3400 == NULL) {
    strlit3400 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3400);
  }
// compiled string node returning strlit3400 (depth = 7)
  gc_frame_newslot(strlit3400);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3397;
  params[2] = bool3398;
  params[3] = bool3399;
  params[4] = strlit3400;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3401 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3395);
// compiled call node returning call3401 (depth = 6)
    gc_frame_newslot(call3401);
    if3388 = call3401;
  }
// compiled if node returning if3388 (depth = 5)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3402 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3403 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3402);
// compiled call node returning call3403 (depth = 5)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3406 == NULL) {
    strlit3406 = alloc_String("bind");
    gc_root(strlit3406);
  }
// compiled string node returning strlit3406 (depth = 7)
  int op_slot_right_3405 = gc_frame_newslot(strlit3406);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3408 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3409 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3410 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3409);
// compiled call node returning call3410 (depth = 10)
// compiled member node returning call3410 (depth = 9)
  partcv[0] = 0;
  Object call3411 = callmethod(call3410, "kind",
    1, partcv, params);
  gc_frame_end(callframe3408);
// compiled call node returning call3411 (depth = 8)
// compiled member node returning call3411 (depth = 7)
  int op_slot_left_3405 = gc_frame_newslot(call3411);
  params[0] = strlit3406;
  partcv[0] = 1;
  Object opresult3412 = callmethod(call3411, "==", 1, partcv, params);
// compiled op node returning opresult3412 (depth = 6)
  Object if3404 = done;
  if (istrue(opresult3412)) {
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3413 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3415 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3414);
// compiled call node returning call3415 (depth = 10)
// compiled member node returning call3415 (depth = 9)
  partcv[0] = 0;
  Object call3416 = callmethod(call3415, "new",
    1, partcv, params);
  gc_frame_end(callframe3413);
// compiled call node returning call3416 (depth = 8)
// compiled member node returning call3416 (depth = 7)
  *var_suggestion = call3416;
  if (call3416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3418 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3420 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3419);
// compiled call node returning call3420 (depth = 8)
// compiled member node returning call3420 (depth = 7)
  gc_frame_newslot(call3420);
// starting to compile identifier node (depth = 7)
  Object bool3421 = alloc_Boolean(1);
// compiled identifier node returning bool3421 (depth = 7)
  gc_frame_newslot(bool3421);
// starting to compile identifier node (depth = 7)
  Object bool3422 = alloc_Boolean(0);
// compiled identifier node returning bool3422 (depth = 7)
  gc_frame_newslot(bool3422);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call3420;
  params[2] = bool3421;
  params[3] = bool3422;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3423 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3418);
// compiled call node returning call3423 (depth = 6)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3424 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3425 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3426 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3425);
// compiled call node returning call3426 (depth = 8)
// compiled member node returning call3426 (depth = 7)
  gc_frame_newslot(call3426);
// starting to compile identifier node (depth = 7)
  Object bool3427 = alloc_Boolean(1);
// compiled identifier node returning bool3427 (depth = 7)
  gc_frame_newslot(bool3427);
// starting to compile identifier node (depth = 7)
  Object bool3428 = alloc_Boolean(0);
// compiled identifier node returning bool3428 (depth = 7)
  gc_frame_newslot(bool3428);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call3426;
  params[1] = bool3427;
  params[2] = bool3428;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3429 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3424);
// compiled call node returning call3429 (depth = 6)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3430 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3431 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3430);
// compiled call node returning call3431 (depth = 6)
    gc_frame_newslot(call3431);
    if3404 = call3431;
  } else {
  }
// compiled if node returning if3404 (depth = 5)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3432 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3433 == NULL) {
    strlit3433 = alloc_String("a prefix operator must be followed by an expression.");
    gc_root(strlit3433);
  }
// compiled string node returning strlit3433 (depth = 6)
  gc_frame_newslot(strlit3433);
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3435 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3434);
// compiled call node returning call3435 (depth = 7)
// compiled member node returning call3435 (depth = 6)
  gc_frame_newslot(call3435);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3438 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3437);
// compiled call node returning call3438 (depth = 8)
// compiled member node returning call3438 (depth = 7)
  int op_slot_right_3436 = gc_frame_newslot(call3438);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3441 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3440);
// compiled call node returning call3441 (depth = 8)
// compiled member node returning call3441 (depth = 7)
  int op_slot_left_3436 = gc_frame_newslot(call3441);
  params[0] = call3438;
  partcv[0] = 1;
  Object sum3442 = callmethod(call3441, "+", 1, partcv, params);
// compiled op node returning sum3442 (depth = 6)
  gc_frame_newslot(sum3442);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3433;
  params[1] = call3435;
  params[2] = sum3442;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3443 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3432);
// compiled call node returning call3443 (depth = 5)
    gc_frame_newslot(call3443);
    if3366 = call3443;
  } else {
  }
// compiled if node returning if3366 (depth = 4)
    gc_frame_newslot(if3366);
    if3291 = if3366;
  }
// compiled if node returning if3291 (depth = 3)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3444 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3445 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3444);
// compiled call node returning call3445 (depth = 3)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3446 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3447 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compiled call node returning call3447 (depth = 3)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3448 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3449 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3448);
// compiled call node returning call3449 (depth = 4)
// compiled member node returning call3449 (depth = 3)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3451 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3450);
// compiled call node returning call3451 (depth = 5)
// compiled member node returning call3451 (depth = 4)
  *var_val = call3451;
  if (call3451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3453 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_op (depth = 6)
  int op_slot_right_3454 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 6)
  if (strlit3456 == NULL) {
    strlit3456 = alloc_String("prefix");
    gc_root(strlit3456);
  }
// compiled string node returning strlit3456 (depth = 6)
  int op_slot_left_3454 = gc_frame_newslot(strlit3456);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3457 = callmethod(strlit3456, "++", 1, partcv, params);
// compiled op node returning opresult3457 (depth = 5)
  gc_frame_newslot(opresult3457);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3459 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3458);
// compiled call node returning call3459 (depth = 6)
// compiled member node returning call3459 (depth = 5)
  params[0] = opresult3457;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call3460 = callmethod(call3459, "new",
    1, partcv, params);
  gc_frame_end(callframe3453);
// compiled call node returning call3460 (depth = 4)
  *var_mem = call3460;
  if (call3460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3461 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mem (depth = 5)
  gc_frame_newslot(*var_mem);
// starting to compile array node (depth = 5)
  Object array3462 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe3463 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mem (depth = 9)
  partcv[0] = 0;
  Object call3465 = callmethod(*var_mem, "value",
    1, partcv, params);
  gc_frame_end(callframe3464);
// compiled call node returning call3465 (depth = 8)
// compiled member node returning call3465 (depth = 7)
  gc_frame_newslot(call3465);
// starting to compile array node (depth = 7)
  Object array3466 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3466 (depth = 7)
  gc_frame_newslot(array3466);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call3468 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe3467);
// compiled call node returning call3468 (depth = 8)
// compiled member node returning call3468 (depth = 7)
  params[0] = call3465;
  params[1] = array3466;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3469 = callmethod(call3468, "request()withArgs",
    2, partcv, params);
  gc_frame_end(callframe3463);
// compiled call node returning call3469 (depth = 6)
  params[0] = call3469;
  partcv[0] = 1;
  callmethod(array3462, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3462 (depth = 5)
  gc_frame_newslot(array3462);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3471 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe3470);
// compiled call node returning call3471 (depth = 6)
// compiled member node returning call3471 (depth = 5)
  params[0] = *var_mem;
  params[1] = array3462;
  partcv[0] = 2;
  Object call3472 = callmethod(call3471, "new",
    1, partcv, params);
  gc_frame_end(callframe3461);
// compiled call node returning call3472 (depth = 4)
  *var_call = call3472;
  if (call3472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3473 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3474 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3473);
// compiled call node returning call3474 (depth = 3)
    gc_frame_newslot(call3474);
    if3283 = call3474;
  } else {
  }
// compiled if node returning if3283 (depth = 2)
  gc_frame_end(frame);
  return if3283;
}
Object meth_parser__apply3490(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3491 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3492 == NULL) {
    strlit3492 = alloc_String("identifier");
    gc_root(strlit3492);
  }
// compiled string node returning strlit3492 (depth = 6)
  gc_frame_newslot(strlit3492);
// call case 4: self request
  params[0] = strlit3492;
  partcv[0] = 1;
  Object call3493 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3491);
// compiled call node returning call3493 (depth = 5)
  gc_frame_end(frame);
  return call3493;
}
Object meth_parser__apply3501(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3502 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3503 == NULL) {
    strlit3503 = alloc_String("dot");
    gc_root(strlit3503);
  }
// compiled string node returning strlit3503 (depth = 8)
  gc_frame_newslot(strlit3503);
// call case 4: self request
  params[0] = strlit3503;
  partcv[0] = 1;
  Object call3504 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3502);
// compiled call node returning call3504 (depth = 7)
  gc_frame_end(frame);
  return call3504;
}
Object meth_parser__apply3507(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3508 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3509 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3508);
// compiled call node returning call3509 (depth = 8)
// compiled member node returning call3509 (depth = 7)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3511 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3510);
// compiled call node returning call3511 (depth = 9)
// compiled member node returning call3511 (depth = 8)
  *var_memberIn = call3511;
  if (call3511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3514 == NULL) {
    strlit3514 = alloc_String("identifier");
    gc_root(strlit3514);
  }
// compiled string node returning strlit3514 (depth = 9)
  int op_slot_right_3513 = gc_frame_newslot(strlit3514);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3517 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3516);
// compiled call node returning call3517 (depth = 10)
// compiled member node returning call3517 (depth = 9)
  int op_slot_left_3513 = gc_frame_newslot(call3517);
  params[0] = strlit3514;
  partcv[0] = 1;
  Object opresult3518 = callmethod(call3517, "!=", 1, partcv, params);
// compiled op node returning opresult3518 (depth = 8)
  Object if3512 = done;
  if (istrue(opresult3518)) {
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3519 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3520 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3521 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3520);
// compiled call node returning call3521 (depth = 12)
// compiled member node returning call3521 (depth = 11)
  partcv[0] = 0;
  Object call3522 = callmethod(call3521, "empty",
    1, partcv, params);
  gc_frame_end(callframe3519);
// compiled call node returning call3522 (depth = 10)
// compiled member node returning call3522 (depth = 9)
  *var_suggestions = call3522;
  if (call3522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3523 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3525 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3524);
// compiled call node returning call3525 (depth = 12)
// compiled member node returning call3525 (depth = 11)
  partcv[0] = 0;
  Object call3526 = callmethod(call3525, "new",
    1, partcv, params);
  gc_frame_end(callframe3523);
// compiled call node returning call3526 (depth = 10)
// compiled member node returning call3526 (depth = 9)
  *var_suggestion = call3526;
  if (call3526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3527 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3528 == NULL) {
    strlit3528 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3528);
  }
// compiled string node returning strlit3528 (depth = 9)
  gc_frame_newslot(strlit3528);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3528;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3529 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3527);
// compiled call node returning call3529 (depth = 8)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3530 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3531 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3530);
// compiled call node returning call3531 (depth = 8)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3532 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3533 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3534 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3533);
// compiled call node returning call3534 (depth = 12)
// compiled member node returning call3534 (depth = 11)
  partcv[0] = 0;
  Object call3535 = callmethod(call3534, "new",
    1, partcv, params);
  gc_frame_end(callframe3532);
// compiled call node returning call3535 (depth = 10)
// compiled member node returning call3535 (depth = 9)
  *var_suggestion = call3535;
  if (call3535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3537 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3538 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3537);
// compiled call node returning call3538 (depth = 8)
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3539 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3540 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3539);
// compiled call node returning call3540 (depth = 8)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3541 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3542 == NULL) {
    strlit3542 = alloc_String("a type name must follow the '.'.");
    gc_root(strlit3542);
  }
// compiled string node returning strlit3542 (depth = 9)
  gc_frame_newslot(strlit3542);
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3543 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3544 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3543);
// compiled call node returning call3544 (depth = 10)
// compiled member node returning call3544 (depth = 9)
  gc_frame_newslot(call3544);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3546 = alloc_Float64(1);
// compiled num node returning num3546 (depth = 10)
  int op_slot_right_3545 = gc_frame_newslot(num3546);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call3549 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3548);
// compiled call node returning call3549 (depth = 11)
// compiled member node returning call3549 (depth = 10)
  int op_slot_left_3545 = gc_frame_newslot(call3549);
  params[0] = num3546;
  partcv[0] = 1;
  Object sum3550 = callmethod(call3549, "+", 1, partcv, params);
// compiled op node returning sum3550 (depth = 9)
  gc_frame_newslot(sum3550);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3542;
  params[1] = call3544;
  params[2] = sum3550;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3551 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3541);
// compiled call node returning call3551 (depth = 8)
    gc_frame_newslot(call3551);
    if3512 = call3551;
  } else {
  }
// compiled if node returning if3512 (depth = 7)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3552 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3553 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3552);
// compiled call node returning call3553 (depth = 8)
// compiled member node returning call3553 (depth = 7)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3555 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3554);
// compiled call node returning call3555 (depth = 9)
// compiled member node returning call3555 (depth = 8)
  *var_memberName = call3555;
  if (call3555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3556 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3558 = callmethod(*var_memberName, "value",
    1, partcv, params);
  gc_frame_end(callframe3557);
// compiled call node returning call3558 (depth = 10)
// compiled member node returning call3558 (depth = 9)
  gc_frame_newslot(call3558);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ast (depth = 11)
  partcv[0] = 0;
  Object call3560 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3559);
// compiled call node returning call3560 (depth = 10)
// compiled member node returning call3560 (depth = 9)
  params[0] = call3558;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3561 = callmethod(call3560, "new",
    1, partcv, params);
  gc_frame_end(callframe3556);
// compiled call node returning call3561 (depth = 8)
  *var_memberNd = call3561;
  if (call3561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3562 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3563 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  partcv[0] = 0;
  Object call3564 = callmethod(*var_memberName, "line",
    1, partcv, params);
  gc_frame_end(callframe3563);
// compiled call node returning call3564 (depth = 9)
// compiled member node returning call3564 (depth = 8)
  gc_frame_newslot(call3564);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3564;
  partcv[0] = 1;
  Object call3565 = callmethod(*var_memberNd, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3562);
// compiled call node returning call3565 (depth = 7)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3566 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  partcv[0] = 0;
  Object call3568 = callmethod(*var_memberName, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3567);
// compiled call node returning call3568 (depth = 9)
// compiled member node returning call3568 (depth = 8)
  gc_frame_newslot(call3568);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3568;
  partcv[0] = 1;
  Object call3569 = callmethod(*var_memberNd, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe3566);
// compiled call node returning call3569 (depth = 7)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3570 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3571 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3570);
// compiled call node returning call3571 (depth = 7)
  gc_frame_end(frame);
  return call3571;
}
Object meth_parser__apply3496(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3498 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3497);
// compiled call node returning call3498 (depth = 6)
// compiled member node returning call3498 (depth = 5)
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3499 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3500 = alloc_Block(NULL, NULL, "parser", 1090);
  gc_frame_newslot(block3500);
// method "_apply"
  block_savedest(block3500);
  Object closure3501 = createclosure(1, "_apply");
  setclosureframe(closure3501, stackframe);
  addtoclosure(closure3501, selfslot);
  struct UserObject *uo3501 = (struct UserObject*)block3500;
  uo3501->data[0] = (Object)closure3501;
  Method *meth_meth_parser__apply3501 = addmethod2pos(block3500, "_apply", &meth_parser__apply3501, 0);
  int argcv_meth_parser__apply3501[] = {0};
  meth_meth_parser__apply3501->type = alloc_MethodType(1, argcv_meth_parser__apply3501);
  meth_meth_parser__apply3501->definitionModule = modulename;
  meth_meth_parser__apply3501->definitionLine = 1089;
// compiled block node returning block3500 (depth = 6)
  gc_frame_newslot(block3500);
// starting to compile block node (depth = 6)
  Object block3506 = alloc_Block(NULL, NULL, "parser", 1090);
  gc_frame_newslot(block3506);
// method "_apply"
  block_savedest(block3506);
  Object closure3507 = createclosure(6, "_apply");
  setclosureframe(closure3507, stackframe);
  addtoclosure(closure3507, var_values);
  addtoclosure(closure3507, var_sym);
  addtoclosure(closure3507, var_errormessages);
  addtoclosure(closure3507, var_lastToken);
  addtoclosure(closure3507, var_ast);
  addtoclosure(closure3507, selfslot);
  struct UserObject *uo3507 = (struct UserObject*)block3506;
  uo3507->data[0] = (Object)closure3507;
  Method *meth_meth_parser__apply3507 = addmethod2pos(block3506, "_apply", &meth_parser__apply3507, 0);
  int argcv_meth_parser__apply3507[] = {0};
  meth_meth_parser__apply3507->type = alloc_MethodType(1, argcv_meth_parser__apply3507);
  meth_meth_parser__apply3507->definitionModule = modulename;
  meth_meth_parser__apply3507->definitionLine = 1089;
// compiled block node returning block3506 (depth = 6)
  gc_frame_newslot(block3506);
// call case 5: prelude request
  params[0] = block3500;
  params[1] = block3506;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3573 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3499);
// compiled call node returning call3573 (depth = 5)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3575 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3574);
// compiled call node returning call3575 (depth = 6)
// compiled member node returning call3575 (depth = 5)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3576 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3577 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call3578 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3577);
// compiled call node returning call3578 (depth = 7)
// compiled member node returning call3578 (depth = 6)
  gc_frame_newslot(call3578);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3578;
  partcv[0] = 1;
  Object call3579 = callmethod(*var_gens, "push",
    1, partcv, params);
  gc_frame_end(callframe3576);
// compiled call node returning call3579 (depth = 5)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3581 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3582 == NULL) {
    strlit3582 = alloc_String("comma");
    gc_root(strlit3582);
  }
// compiled string node returning strlit3582 (depth = 7)
  gc_frame_newslot(strlit3582);
// call case 4: self request
  params[0] = strlit3582;
  partcv[0] = 1;
  Object call3583 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3581);
// compiled call node returning call3583 (depth = 6)
  Object if3580 = done;
  if (istrue(call3583)) {
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3585 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3584);
// compiled call node returning call3585 (depth = 7)
// compiled member node returning call3585 (depth = 6)
    gc_frame_newslot(call3585);
    if3580 = call3585;
  } else {
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3588 == NULL) {
    strlit3588 = alloc_String("rgeneric");
    gc_root(strlit3588);
  }
// compiled string node returning strlit3588 (depth = 8)
  int op_slot_right_3587 = gc_frame_newslot(strlit3588);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3591 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3590);
// compiled call node returning call3591 (depth = 9)
// compiled member node returning call3591 (depth = 8)
  int op_slot_left_3587 = gc_frame_newslot(call3591);
  params[0] = strlit3588;
  partcv[0] = 1;
  Object opresult3592 = callmethod(call3591, "!=", 1, partcv, params);
// compiled op node returning opresult3592 (depth = 7)
  Object if3586 = done;
  if (istrue(opresult3592)) {
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3593 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3594 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3595 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3594);
// compiled call node returning call3595 (depth = 11)
// compiled member node returning call3595 (depth = 10)
  partcv[0] = 0;
  Object call3596 = callmethod(call3595, "new",
    1, partcv, params);
  gc_frame_end(callframe3593);
// compiled call node returning call3596 (depth = 9)
// compiled member node returning call3596 (depth = 8)
  *var_suggestion = call3596;
  if (call3596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3597 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3598 == NULL) {
    strlit3598 = alloc_String(">");
    gc_root(strlit3598);
  }
// compiled string node returning strlit3598 (depth = 8)
  gc_frame_newslot(strlit3598);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3598;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3599 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3597);
// compiled call node returning call3599 (depth = 7)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3600 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3601 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3602 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3601);
// compiled call node returning call3602 (depth = 11)
// compiled member node returning call3602 (depth = 10)
  partcv[0] = 0;
  Object call3603 = callmethod(call3602, "new",
    1, partcv, params);
  gc_frame_end(callframe3600);
// compiled call node returning call3603 (depth = 9)
// compiled member node returning call3603 (depth = 8)
  *var_suggestion2 = call3603;
  if (call3603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3604 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3605 == NULL) {
    strlit3605 = alloc_String(" ");
    gc_root(strlit3605);
  }
// compiled string node returning strlit3605 (depth = 8)
  gc_frame_newslot(strlit3605);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3605;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3606 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3604);
// compiled call node returning call3606 (depth = 7)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array3607 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3607, "push", 1, partcv, params);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3607, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3607 (depth = 8)
  *var_suggestions = array3607;
  if (array3607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3608 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3609 == NULL) {
    strlit3609 = alloc_String("a type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3609);
  }
// compiled string node returning strlit3609 (depth = 8)
  gc_frame_newslot(strlit3609);
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3610 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3611 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3610);
// compiled call node returning call3611 (depth = 9)
// compiled member node returning call3611 (depth = 8)
  gc_frame_newslot(call3611);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3614 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3613);
// compiled call node returning call3614 (depth = 10)
// compiled member node returning call3614 (depth = 9)
  int op_slot_right_3612 = gc_frame_newslot(call3614);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3617 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3616);
// compiled call node returning call3617 (depth = 10)
// compiled member node returning call3617 (depth = 9)
  int op_slot_left_3612 = gc_frame_newslot(call3617);
  params[0] = call3614;
  partcv[0] = 1;
  Object sum3618 = callmethod(call3617, "+", 1, partcv, params);
// compiled op node returning sum3618 (depth = 8)
  gc_frame_newslot(sum3618);
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3609;
  params[1] = call3611;
  params[2] = sum3618;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3619 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3608);
// compiled call node returning call3619 (depth = 7)
    gc_frame_newslot(call3619);
    if3586 = call3619;
  } else {
  }
// compiled if node returning if3586 (depth = 6)
    gc_frame_newslot(if3586);
    if3580 = if3586;
  }
// compiled if node returning if3580 (depth = 5)
  gc_frame_end(frame);
  return if3580;
}
Object meth_parser_generic3475(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for generic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for generic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3477 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("lgeneric");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 4)
  gc_frame_newslot(strlit3478);
// call case 4: self request
  params[0] = strlit3478;
  partcv[0] = 1;
  Object call3479 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3477);
// compiled call node returning call3479 (depth = 3)
  Object if3476 = done;
  if (istrue(call3479)) {
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3481 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 5)
// compiled member node returning call3481 (depth = 4)
  *var_id = call3481;
  if (call3481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3482 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3483 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3484 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3483);
// compiled call node returning call3484 (depth = 7)
// compiled member node returning call3484 (depth = 6)
  partcv[0] = 0;
  Object call3485 = callmethod(call3484, "empty",
    1, partcv, params);
  gc_frame_end(callframe3482);
// compiled call node returning call3485 (depth = 5)
// compiled member node returning call3485 (depth = 4)
  *var_gens = call3485;
  if (call3485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3487 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3486);
// compiled call node returning call3487 (depth = 4)
// compiled member node returning call3487 (depth = 3)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3488 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3489 = alloc_Block(NULL, NULL, "parser", 1088);
  gc_frame_newslot(block3489);
// method "_apply"
  block_savedest(block3489);
  Object closure3490 = createclosure(1, "_apply");
  setclosureframe(closure3490, stackframe);
  addtoclosure(closure3490, selfslot);
  struct UserObject *uo3490 = (struct UserObject*)block3489;
  uo3490->data[0] = (Object)closure3490;
  Method *meth_meth_parser__apply3490 = addmethod2pos(block3489, "_apply", &meth_parser__apply3490, 0);
  int argcv_meth_parser__apply3490[] = {0};
  meth_meth_parser__apply3490->type = alloc_MethodType(1, argcv_meth_parser__apply3490);
  meth_meth_parser__apply3490->definitionModule = modulename;
  meth_meth_parser__apply3490->definitionLine = 1087;
// compiled block node returning block3489 (depth = 4)
  gc_frame_newslot(block3489);
// starting to compile block node (depth = 4)
  Object block3495 = alloc_Block(NULL, NULL, "parser", 1088);
  gc_frame_newslot(block3495);
// method "_apply"
  block_savedest(block3495);
  Object closure3496 = createclosure(8, "_apply");
  setclosureframe(closure3496, stackframe);
  addtoclosure(closure3496, var_values);
  addtoclosure(closure3496, var_sym);
  addtoclosure(closure3496, var_errormessages);
  addtoclosure(closure3496, var_lastToken);
  addtoclosure(closure3496, var_ast);
  addtoclosure(closure3496, var_gens);
  addtoclosure(closure3496, var_startToken);
  addtoclosure(closure3496, selfslot);
  struct UserObject *uo3496 = (struct UserObject*)block3495;
  uo3496->data[0] = (Object)closure3496;
  Method *meth_meth_parser__apply3496 = addmethod2pos(block3495, "_apply", &meth_parser__apply3496, 0);
  int argcv_meth_parser__apply3496[] = {0};
  meth_meth_parser__apply3496->type = alloc_MethodType(1, argcv_meth_parser__apply3496);
  meth_meth_parser__apply3496->definitionModule = modulename;
  meth_meth_parser__apply3496->definitionLine = 1087;
// compiled block node returning block3495 (depth = 4)
  gc_frame_newslot(block3495);
// call case 5: prelude request
  params[0] = block3489;
  params[1] = block3495;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3621 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3488);
// compiled call node returning call3621 (depth = 3)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3624 == NULL) {
    strlit3624 = alloc_String("rgeneric");
    gc_root(strlit3624);
  }
// compiled string node returning strlit3624 (depth = 5)
  int op_slot_right_3623 = gc_frame_newslot(strlit3624);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3627 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3626);
// compiled call node returning call3627 (depth = 6)
// compiled member node returning call3627 (depth = 5)
  int op_slot_left_3623 = gc_frame_newslot(call3627);
  params[0] = strlit3624;
  partcv[0] = 1;
  Object opresult3628 = callmethod(call3627, "!=", 1, partcv, params);
// compiled op node returning opresult3628 (depth = 4)
  Object if3622 = done;
  if (istrue(opresult3628)) {
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3629 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3631 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3630);
// compiled call node returning call3631 (depth = 8)
// compiled member node returning call3631 (depth = 7)
  partcv[0] = 0;
  Object call3632 = callmethod(call3631, "new",
    1, partcv, params);
  gc_frame_end(callframe3629);
// compiled call node returning call3632 (depth = 6)
// compiled member node returning call3632 (depth = 5)
  *var_suggestion = call3632;
  if (call3632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3633 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3634 == NULL) {
    strlit3634 = alloc_String(">");
    gc_root(strlit3634);
  }
// compiled string node returning strlit3634 (depth = 5)
  gc_frame_newslot(strlit3634);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3634;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3635 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3633);
// compiled call node returning call3635 (depth = 4)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3636 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3638 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3637);
// compiled call node returning call3638 (depth = 8)
// compiled member node returning call3638 (depth = 7)
  partcv[0] = 0;
  Object call3639 = callmethod(call3638, "new",
    1, partcv, params);
  gc_frame_end(callframe3636);
// compiled call node returning call3639 (depth = 6)
// compiled member node returning call3639 (depth = 5)
  *var_suggestion2 = call3639;
  if (call3639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3640 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3641 == NULL) {
    strlit3641 = alloc_String(" ");
    gc_root(strlit3641);
  }
// compiled string node returning strlit3641 (depth = 5)
  gc_frame_newslot(strlit3641);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3641;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3642 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3640);
// compiled call node returning call3642 (depth = 4)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array3643 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3643, "push", 1, partcv, params);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3643, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3643 (depth = 5)
  *var_suggestions = array3643;
  if (array3643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3644 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3645 == NULL) {
    strlit3645 = alloc_String("a type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3645);
  }
// compiled string node returning strlit3645 (depth = 5)
  gc_frame_newslot(strlit3645);
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3647 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3646);
// compiled call node returning call3647 (depth = 6)
// compiled member node returning call3647 (depth = 5)
  gc_frame_newslot(call3647);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3650 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3649);
// compiled call node returning call3650 (depth = 7)
// compiled member node returning call3650 (depth = 6)
  int op_slot_right_3648 = gc_frame_newslot(call3650);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3652 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3653 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3652);
// compiled call node returning call3653 (depth = 7)
// compiled member node returning call3653 (depth = 6)
  int op_slot_left_3648 = gc_frame_newslot(call3653);
  params[0] = call3650;
  partcv[0] = 1;
  Object sum3654 = callmethod(call3653, "+", 1, partcv, params);
// compiled op node returning sum3654 (depth = 5)
  gc_frame_newslot(sum3654);
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3645;
  params[1] = call3647;
  params[2] = sum3654;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3655 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3644);
// compiled call node returning call3655 (depth = 4)
    gc_frame_newslot(call3655);
    if3622 = call3655;
  } else {
  }
// compiled if node returning if3622 (depth = 3)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3657 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3656);
// compiled call node returning call3657 (depth = 4)
// compiled member node returning call3657 (depth = 3)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3658 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3659 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3661 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe3660);
// compiled call node returning call3661 (depth = 6)
// compiled member node returning call3661 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3662 = callmethod(call3661, "new",
    1, partcv, params);
  gc_frame_end(callframe3659);
// compiled call node returning call3662 (depth = 4)
  gc_frame_newslot(call3662);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3662;
  partcv[0] = 1;
  Object call3663 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3658);
// compiled call node returning call3663 (depth = 3)
    gc_frame_newslot(call3663);
    if3476 = call3663;
  } else {
  }
// compiled if node returning if3476 (depth = 2)
  gc_frame_end(frame);
  return if3476;
}
Object meth_parser__apply3702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3706 == NULL) {
    strlit3706 = alloc_String("catch");
    gc_root(strlit3706);
  }
// compiled string node returning strlit3706 (depth = 10)
  int op_slot_right_3705 = gc_frame_newslot(strlit3706);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3708 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3709 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe3708);
// compiled call node returning call3709 (depth = 11)
// compiled member node returning call3709 (depth = 10)
  int op_slot_left_3705 = gc_frame_newslot(call3709);
  params[0] = strlit3706;
  partcv[0] = 1;
  Object opresult3710 = callmethod(call3709, "==", 1, partcv, params);
// compiled op node returning opresult3710 (depth = 9)
  int op_slot_right_3704 = gc_frame_newslot(opresult3710);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3713 == NULL) {
    strlit3713 = alloc_String("identifier");
    gc_root(strlit3713);
  }
// compiled string node returning strlit3713 (depth = 10)
  int op_slot_right_3712 = gc_frame_newslot(strlit3713);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3716 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3715);
// compiled call node returning call3716 (depth = 11)
// compiled member node returning call3716 (depth = 10)
  int op_slot_left_3712 = gc_frame_newslot(call3716);
  params[0] = strlit3713;
  partcv[0] = 1;
  Object opresult3717 = callmethod(call3716, "==", 1, partcv, params);
// compiled op node returning opresult3717 (depth = 9)
  int op_slot_left_3704 = gc_frame_newslot(opresult3717);
  params[0] = opresult3710;
  partcv[0] = 1;
  Object opresult3718 = callmethod(opresult3717, "&&", 1, partcv, params);
// compiled op node returning opresult3718 (depth = 8)
  int op_slot_right_3703 = gc_frame_newslot(opresult3718);
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3723 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_catchTok (depth = 13)
  partcv[0] = 0;
  Object call3724 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3723);
// compiled call node returning call3724 (depth = 12)
// compiled member node returning call3724 (depth = 11)
  int op_slot_right_3722 = gc_frame_newslot(call3724);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3726 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3727 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe3726);
// compiled call node returning call3727 (depth = 12)
// compiled member node returning call3727 (depth = 11)
  int op_slot_left_3722 = gc_frame_newslot(call3727);
  params[0] = call3724;
  partcv[0] = 1;
  Object opresult3728 = callmethod(call3727, "==", 1, partcv, params);
// compiled op node returning opresult3728 (depth = 10)
  int op_slot_right_3721 = gc_frame_newslot(opresult3728);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3731 == NULL) {
    strlit3731 = alloc_String("rparen");
    gc_root(strlit3731);
  }
// compiled string node returning strlit3731 (depth = 11)
  int op_slot_right_3730 = gc_frame_newslot(strlit3731);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3734 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3733);
// compiled call node returning call3734 (depth = 12)
// compiled member node returning call3734 (depth = 11)
  int op_slot_left_3730 = gc_frame_newslot(call3734);
  params[0] = strlit3731;
  partcv[0] = 1;
  Object opresult3735 = callmethod(call3734, "==", 1, partcv, params);
// compiled op node returning opresult3735 (depth = 10)
  int op_slot_left_3721 = gc_frame_newslot(opresult3735);
  params[0] = opresult3728;
  partcv[0] = 1;
  Object opresult3736 = callmethod(opresult3735, "&&", 1, partcv, params);
// compiled op node returning opresult3736 (depth = 9)
  int op_slot_right_3720 = gc_frame_newslot(opresult3736);
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3739 == NULL) {
    strlit3739 = alloc_String("rbrace");
    gc_root(strlit3739);
  }
// compiled string node returning strlit3739 (depth = 10)
  int op_slot_right_3738 = gc_frame_newslot(strlit3739);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3741 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3742 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3741);
// compiled call node returning call3742 (depth = 11)
// compiled member node returning call3742 (depth = 10)
  int op_slot_left_3738 = gc_frame_newslot(call3742);
  params[0] = strlit3739;
  partcv[0] = 1;
  Object opresult3743 = callmethod(call3742, "==", 1, partcv, params);
// compiled op node returning opresult3743 (depth = 9)
  int op_slot_left_3720 = gc_frame_newslot(opresult3743);
  params[0] = opresult3736;
  partcv[0] = 1;
  Object opresult3744 = callmethod(opresult3743, "||", 1, partcv, params);
// compiled op node returning opresult3744 (depth = 8)
  int op_slot_left_3703 = gc_frame_newslot(opresult3744);
  params[0] = opresult3718;
  partcv[0] = 1;
  Object opresult3745 = callmethod(opresult3744, "||", 1, partcv, params);
// compiled op node returning opresult3745 (depth = 7)
  gc_frame_end(frame);
  return opresult3745;
}
Object meth_parser__apply3820(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe3821 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3822 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3821);
// compiled call node returning call3822 (depth = 8)
  gc_frame_end(frame);
  return call3822;
}
Object meth_parser__apply3891(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3894 == NULL) {
    strlit3894 = alloc_String("catch");
    gc_root(strlit3894);
  }
// compiled string node returning strlit3894 (depth = 6)
  int op_slot_right_3893 = gc_frame_newslot(strlit3894);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3896 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3897 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3896);
// compiled call node returning call3897 (depth = 7)
// compiled member node returning call3897 (depth = 6)
  int op_slot_left_3893 = gc_frame_newslot(call3897);
  params[0] = strlit3894;
  partcv[0] = 1;
  Object opresult3898 = callmethod(call3897, "==", 1, partcv, params);
// compiled op node returning opresult3898 (depth = 5)
  int op_slot_right_3892 = gc_frame_newslot(opresult3898);
// starting to compile call node (depth = 5)
  int callframe3900 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3901 == NULL) {
    strlit3901 = alloc_String("identifier");
    gc_root(strlit3901);
  }
// compiled string node returning strlit3901 (depth = 6)
  gc_frame_newslot(strlit3901);
// call case 4: self request
  params[0] = strlit3901;
  partcv[0] = 1;
  Object call3902 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3900);
// compiled call node returning call3902 (depth = 5)
  int op_slot_left_3892 = gc_frame_newslot(call3902);
  params[0] = opresult3898;
  partcv[0] = 1;
  Object opresult3903 = callmethod(call3902, "&&", 1, partcv, params);
// compiled op node returning opresult3903 (depth = 4)
  gc_frame_end(frame);
  return opresult3903;
}
Object meth_parser__apply3925(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe3926 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3927 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3926);
// compiled call node returning call3927 (depth = 11)
  gc_frame_end(frame);
  return call3927;
}
Object meth_parser__apply3906(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3908 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compiled call node returning call3908 (depth = 5)
// compiled member node returning call3908 (depth = 4)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3910 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3911 == NULL) {
    strlit3911 = alloc_String("lbrace");
    gc_root(strlit3911);
  }
// compiled string node returning strlit3911 (depth = 6)
  gc_frame_newslot(strlit3911);
// call case 4: self request
  params[0] = strlit3911;
  partcv[0] = 1;
  Object call3912 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3910);
// compiled call node returning call3912 (depth = 5)
  Object if3909 = done;
  if (istrue(call3912)) {
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3913 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3914 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3913);
// compiled call node returning call3914 (depth = 6)
// compiled member node returning call3914 (depth = 5)
    gc_frame_newslot(call3914);
    if3909 = call3914;
  } else {
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3916 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3917 == NULL) {
    strlit3917 = alloc_String("lparen");
    gc_root(strlit3917);
  }
// compiled string node returning strlit3917 (depth = 7)
  gc_frame_newslot(strlit3917);
// call case 4: self request
  params[0] = strlit3917;
  partcv[0] = 1;
  Object call3918 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3916);
// compiled call node returning call3918 (depth = 6)
  Object if3915 = done;
  if (istrue(call3918)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3920 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3919);
// compiled call node returning call3920 (depth = 7)
// compiled member node returning call3920 (depth = 6)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3922 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe3923 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block3924 = alloc_Block(NULL, NULL, "parser", 1205);
  gc_frame_newslot(block3924);
// method "_apply"
  block_savedest(block3924);
  Object closure3925 = createclosure(2, "_apply");
  setclosureframe(closure3925, stackframe);
  addtoclosure(closure3925, var_blocksOK);
  addtoclosure(closure3925, selfslot);
  struct UserObject *uo3925 = (struct UserObject*)block3924;
  uo3925->data[0] = (Object)closure3925;
  Method *meth_meth_parser__apply3925 = addmethod2pos(block3924, "_apply", &meth_parser__apply3925, 0);
  int argcv_meth_parser__apply3925[] = {0};
  meth_meth_parser__apply3925->type = alloc_MethodType(1, argcv_meth_parser__apply3925);
  meth_meth_parser__apply3925->definitionModule = modulename;
  meth_meth_parser__apply3925->definitionLine = 1205;
// compiled block node returning block3924 (depth = 10)
  gc_frame_newslot(block3924);
// call case 4: self request
  params[0] = block3924;
  partcv[0] = 1;
  Object call3929 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3923);
// compiled call node returning call3929 (depth = 9)
  partcv[0] = 0;
  Object call3930 = callmethod(call3929, "not",
    1, partcv, params);
  gc_frame_end(callframe3922);
// compiled call node returning call3930 (depth = 8)
// compiled member node returning call3930 (depth = 7)
  Object if3921 = done;
  if (istrue(call3930)) {
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3931 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3933 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3932);
// compiled call node returning call3933 (depth = 11)
// compiled member node returning call3933 (depth = 10)
  partcv[0] = 0;
  Object call3934 = callmethod(call3933, "new",
    1, partcv, params);
  gc_frame_end(callframe3931);
// compiled call node returning call3934 (depth = 9)
// compiled member node returning call3934 (depth = 8)
  *var_suggestion = call3934;
  if (call3934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3935 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array3936 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit3937 == NULL) {
    strlit3937 = alloc_String("rparen");
    gc_root(strlit3937);
  }
// compiled string node returning strlit3937 (depth = 10)
  params[0] = strlit3937;
  partcv[0] = 1;
  callmethod(array3936, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3936 (depth = 9)
  gc_frame_newslot(array3936);
// call case 4: self request
  params[0] = array3936;
  partcv[0] = 1;
  Object call3938 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3935);
// compiled call node returning call3938 (depth = 8)
  *var_nextTok = call3938;
  if (call3938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3940 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3940 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3942 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3942 (depth = 8)
  Object if3939 = done;
  if (istrue(opresult3942)) {
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3943 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3944 == NULL) {
    strlit3944 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3944);
  }
// compiled string node returning strlit3944 (depth = 9)
  gc_frame_newslot(strlit3944);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3944;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3945 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3943);
// compiled call node returning call3945 (depth = 8)
    gc_frame_newslot(call3945);
    if3939 = call3945;
  } else {
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3946 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3948 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3947);
// compiled call node returning call3948 (depth = 10)
// compiled member node returning call3948 (depth = 9)
  gc_frame_newslot(call3948);
// starting to compile identifier node (depth = 9)
  Object bool3949 = alloc_Boolean(1);
// compiled identifier node returning bool3949 (depth = 9)
  gc_frame_newslot(bool3949);
// starting to compile identifier node (depth = 9)
  Object bool3950 = alloc_Boolean(0);
// compiled identifier node returning bool3950 (depth = 9)
  gc_frame_newslot(bool3950);
// starting to compile string node (depth = 9)
  if (strlit3951 == NULL) {
    strlit3951 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3951);
  }
// compiled string node returning strlit3951 (depth = 9)
  gc_frame_newslot(strlit3951);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3948;
  params[2] = bool3949;
  params[3] = bool3950;
  params[4] = strlit3951;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3952 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3946);
// compiled call node returning call3952 (depth = 8)
    gc_frame_newslot(call3952);
    if3939 = call3952;
  }
// compiled if node returning if3939 (depth = 7)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3953 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3954 == NULL) {
    strlit3954 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3954);
  }
// compiled string node returning strlit3954 (depth = 8)
  gc_frame_newslot(strlit3954);
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3956 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3955);
// compiled call node returning call3956 (depth = 9)
// compiled member node returning call3956 (depth = 8)
  gc_frame_newslot(call3956);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3958 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3957);
// compiled call node returning call3958 (depth = 9)
// compiled member node returning call3958 (depth = 8)
  gc_frame_newslot(call3958);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3954;
  params[1] = call3956;
  params[2] = call3958;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3959 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3953);
// compiled call node returning call3959 (depth = 7)
    gc_frame_newslot(call3959);
    if3921 = call3959;
  } else {
  }
// compiled if node returning if3921 (depth = 6)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3962 == NULL) {
    strlit3962 = alloc_String("rparen");
    gc_root(strlit3962);
  }
// compiled string node returning strlit3962 (depth = 8)
  int op_slot_right_3961 = gc_frame_newslot(strlit3962);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3965 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3964);
// compiled call node returning call3965 (depth = 9)
// compiled member node returning call3965 (depth = 8)
  int op_slot_left_3961 = gc_frame_newslot(call3965);
  params[0] = strlit3962;
  partcv[0] = 1;
  Object opresult3966 = callmethod(call3965, "!=", 1, partcv, params);
// compiled op node returning opresult3966 (depth = 7)
  Object if3960 = done;
  if (istrue(opresult3966)) {
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3967 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3968 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3967);
// compiled call node returning call3968 (depth = 8)
// compiled member node returning call3968 (depth = 7)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3969 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3971 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3970);
// compiled call node returning call3971 (depth = 11)
// compiled member node returning call3971 (depth = 10)
  partcv[0] = 0;
  Object call3972 = callmethod(call3971, "new",
    1, partcv, params);
  gc_frame_end(callframe3969);
// compiled call node returning call3972 (depth = 9)
// compiled member node returning call3972 (depth = 8)
  *var_suggestion = call3972;
  if (call3972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3973 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3974 == NULL) {
    strlit3974 = alloc_String(")");
    gc_root(strlit3974);
  }
// compiled string node returning strlit3974 (depth = 8)
  gc_frame_newslot(strlit3974);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3974;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3975 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3973);
// compiled call node returning call3975 (depth = 7)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3976 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3977 == NULL) {
    strlit3977 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3977);
  }
// compiled string node returning strlit3977 (depth = 8)
  gc_frame_newslot(strlit3977);
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3979 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3978);
// compiled call node returning call3979 (depth = 9)
// compiled member node returning call3979 (depth = 8)
  gc_frame_newslot(call3979);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3982 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3981);
// compiled call node returning call3982 (depth = 10)
// compiled member node returning call3982 (depth = 9)
  int op_slot_right_3980 = gc_frame_newslot(call3982);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3984 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3985 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3984);
// compiled call node returning call3985 (depth = 10)
// compiled member node returning call3985 (depth = 9)
  int op_slot_left_3980 = gc_frame_newslot(call3985);
  params[0] = call3982;
  partcv[0] = 1;
  Object sum3986 = callmethod(call3985, "+", 1, partcv, params);
// compiled op node returning sum3986 (depth = 8)
  gc_frame_newslot(sum3986);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3977;
  params[1] = call3979;
  params[2] = sum3986;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3987 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3976);
// compiled call node returning call3987 (depth = 7)
    gc_frame_newslot(call3987);
    if3960 = call3987;
  } else {
  }
// compiled if node returning if3960 (depth = 6)
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3989 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3988);
// compiled call node returning call3989 (depth = 7)
// compiled member node returning call3989 (depth = 6)
    gc_frame_newslot(call3989);
    if3915 = call3989;
  } else {
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3990 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3991 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3992 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3991);
// compiled call node returning call3992 (depth = 10)
// compiled member node returning call3992 (depth = 9)
  partcv[0] = 0;
  Object call3993 = callmethod(call3992, "empty",
    1, partcv, params);
  gc_frame_end(callframe3990);
// compiled call node returning call3993 (depth = 8)
// compiled member node returning call3993 (depth = 7)
  *var_suggestions = call3993;
  if (call3993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3994 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3995 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3994);
// compiled call node returning call3995 (depth = 7)
  *var_nextTok = call3995;
  if (call3995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3996 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3998 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3997);
// compiled call node returning call3998 (depth = 10)
// compiled member node returning call3998 (depth = 9)
  partcv[0] = 0;
  Object call3999 = callmethod(call3998, "new",
    1, partcv, params);
  gc_frame_end(callframe3996);
// compiled call node returning call3999 (depth = 8)
// compiled member node returning call3999 (depth = 7)
  *var_suggestion = call3999;
  if (call3999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4002 = alloc_Boolean(0);
// compiled identifier node returning bool4002 (depth = 8)
  int op_slot_right_4001 = gc_frame_newslot(bool4002);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4001 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4002;
  partcv[0] = 1;
  Object opresult4004 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4004 (depth = 7)
  Object if4000 = done;
  if (istrue(opresult4004)) {
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4005 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4006 == NULL) {
    strlit4006 = alloc_String(" }");
    gc_root(strlit4006);
  }
// compiled string node returning strlit4006 (depth = 8)
  gc_frame_newslot(strlit4006);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4008 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4007);
// compiled call node returning call4008 (depth = 9)
// compiled member node returning call4008 (depth = 8)
  gc_frame_newslot(call4008);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4006;
  params[1] = call4008;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4009 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4005);
// compiled call node returning call4009 (depth = 7)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4010 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4011 == NULL) {
    strlit4011 = alloc_String(" {");
    gc_root(strlit4011);
  }
// compiled string node returning strlit4011 (depth = 8)
  gc_frame_newslot(strlit4011);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4011;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4012 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4010);
// compiled call node returning call4012 (depth = 7)
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4013 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4014 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4013);
// compiled call node returning call4014 (depth = 7)
    gc_frame_newslot(call4014);
    if4000 = call4014;
  } else {
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4016 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4016 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4018 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4018 (depth = 8)
  Object if4015 = done;
  if (istrue(opresult4018)) {
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4019 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4020 == NULL) {
    strlit4020 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4020);
  }
// compiled string node returning strlit4020 (depth = 9)
  gc_frame_newslot(strlit4020);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4020;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4021 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4019);
// compiled call node returning call4021 (depth = 8)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4022 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4023 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4022);
// compiled call node returning call4023 (depth = 8)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4024 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4026 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4025);
// compiled call node returning call4026 (depth = 12)
// compiled member node returning call4026 (depth = 11)
  partcv[0] = 0;
  Object call4027 = callmethod(call4026, "new",
    1, partcv, params);
  gc_frame_end(callframe4024);
// compiled call node returning call4027 (depth = 10)
// compiled member node returning call4027 (depth = 9)
  *var_suggestion = call4027;
  if (call4027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4029 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4030 == NULL) {
    strlit4030 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4030);
  }
// compiled string node returning strlit4030 (depth = 9)
  gc_frame_newslot(strlit4030);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4030;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4031 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4029);
// compiled call node returning call4031 (depth = 8)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4032 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4033 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4032);
// compiled call node returning call4033 (depth = 8)
    gc_frame_newslot(call4033);
    if4015 = call4033;
  } else {
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4034 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4035 == NULL) {
    strlit4035 = alloc_String(" }");
    gc_root(strlit4035);
  }
// compiled string node returning strlit4035 (depth = 9)
  gc_frame_newslot(strlit4035);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4036 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4037 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4036);
// compiled call node returning call4037 (depth = 10)
// compiled member node returning call4037 (depth = 9)
  gc_frame_newslot(call4037);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4035;
  params[1] = call4037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4038 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4034);
// compiled call node returning call4038 (depth = 8)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4039 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4040 == NULL) {
    strlit4040 = alloc_String(" {");
    gc_root(strlit4040);
  }
// compiled string node returning strlit4040 (depth = 9)
  gc_frame_newslot(strlit4040);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4040;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4041 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4039);
// compiled call node returning call4041 (depth = 8)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4042 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4043 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4042);
// compiled call node returning call4043 (depth = 8)
    gc_frame_newslot(call4043);
    if4015 = call4043;
  }
// compiled if node returning if4015 (depth = 7)
    gc_frame_newslot(if4015);
    if4000 = if4015;
  }
// compiled if node returning if4000 (depth = 6)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4044 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4045 == NULL) {
    strlit4045 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4045);
  }
// compiled string node returning strlit4045 (depth = 7)
  gc_frame_newslot(strlit4045);
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4047 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4046);
// compiled call node returning call4047 (depth = 8)
// compiled member node returning call4047 (depth = 7)
  gc_frame_newslot(call4047);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4049 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4048);
// compiled call node returning call4049 (depth = 8)
// compiled member node returning call4049 (depth = 7)
  gc_frame_newslot(call4049);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4045;
  params[1] = call4047;
  params[2] = call4049;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4050 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4044);
// compiled call node returning call4050 (depth = 6)
    gc_frame_newslot(call4050);
    if3915 = call4050;
  }
// compiled if node returning if3915 (depth = 5)
    gc_frame_newslot(if3915);
    if3909 = if3915;
  }
// compiled if node returning if3909 (depth = 4)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4051 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4052 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4053 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4052);
// compiled call node returning call4053 (depth = 6)
// compiled member node returning call4053 (depth = 5)
  gc_frame_newslot(call4053);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4053;
  partcv[0] = 1;
  Object call4054 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4051);
// compiled call node returning call4054 (depth = 4)
  gc_frame_end(frame);
  return call4054;
}
Object meth_parser__apply4129(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe4130 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4131 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4130);
// compiled call node returning call4131 (depth = 10)
  gc_frame_end(frame);
  return call4131;
}
Object meth_parser_trycatch3664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for trycatch (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for trycatch");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3666 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3669 == NULL) {
    strlit3669 = alloc_String("try");
    gc_root(strlit3669);
  }
// compiled string node returning strlit3669 (depth = 6)
  int op_slot_right_3668 = gc_frame_newslot(strlit3669);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3672 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3671);
// compiled call node returning call3672 (depth = 7)
// compiled member node returning call3672 (depth = 6)
  int op_slot_left_3668 = gc_frame_newslot(call3672);
  params[0] = strlit3669;
  partcv[0] = 1;
  Object opresult3673 = callmethod(call3672, "==", 1, partcv, params);
// compiled op node returning opresult3673 (depth = 5)
  int op_slot_right_3667 = gc_frame_newslot(opresult3673);
// starting to compile call node (depth = 5)
  int callframe3675 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3676 == NULL) {
    strlit3676 = alloc_String("identifier");
    gc_root(strlit3676);
  }
// compiled string node returning strlit3676 (depth = 6)
  gc_frame_newslot(strlit3676);
// call case 4: self request
  params[0] = strlit3676;
  partcv[0] = 1;
  Object call3677 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3675);
// compiled call node returning call3677 (depth = 5)
  int op_slot_left_3667 = gc_frame_newslot(call3677);
  params[0] = opresult3673;
  partcv[0] = 1;
  Object opresult3678 = callmethod(call3677, "&&", 1, partcv, params);
// compiled op node returning opresult3678 (depth = 4)
  partcv[0] = 0;
  Object call3679 = callmethod(opresult3678, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3666);
// compiled call node returning call3679 (depth = 3)
  Object if3665 = done;
  if (istrue(call3679)) {
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3680 = alloc_Float64(0);
// compiled num node returning num3680 (depth = 4)
  return num3680;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3665 = undefined;
  } else {
  }
// compiled if node returning if3665 (depth = 2)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3682 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3681);
// compiled call node returning call3682 (depth = 3)
// compiled member node returning call3682 (depth = 2)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3684 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3685 == NULL) {
    strlit3685 = alloc_String("lbrace");
    gc_root(strlit3685);
  }
// compiled string node returning strlit3685 (depth = 4)
  gc_frame_newslot(strlit3685);
// call case 4: self request
  params[0] = strlit3685;
  partcv[0] = 1;
  Object call3686 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3684);
// compiled call node returning call3686 (depth = 3)
  Object if3683 = done;
  if (istrue(call3686)) {
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3687 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3688 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3687);
// compiled call node returning call3688 (depth = 4)
// compiled member node returning call3688 (depth = 3)
    gc_frame_newslot(call3688);
    if3683 = call3688;
  } else {
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3691 == NULL) {
    strlit3691 = alloc_String("lparen");
    gc_root(strlit3691);
  }
// compiled string node returning strlit3691 (depth = 5)
  int op_slot_right_3690 = gc_frame_newslot(strlit3691);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3694 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3693);
// compiled call node returning call3694 (depth = 6)
// compiled member node returning call3694 (depth = 5)
  int op_slot_left_3690 = gc_frame_newslot(call3694);
  params[0] = strlit3691;
  partcv[0] = 1;
  Object opresult3695 = callmethod(call3694, "!=", 1, partcv, params);
// compiled op node returning opresult3695 (depth = 4)
  Object if3689 = done;
  if (istrue(opresult3695)) {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3696 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3697 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3698 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3697);
// compiled call node returning call3698 (depth = 8)
// compiled member node returning call3698 (depth = 7)
  partcv[0] = 0;
  Object call3699 = callmethod(call3698, "new",
    1, partcv, params);
  gc_frame_end(callframe3696);
// compiled call node returning call3699 (depth = 6)
// compiled member node returning call3699 (depth = 5)
  *var_suggestion = call3699;
  if (call3699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3700 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3701 = alloc_Block(NULL, NULL, "parser", 1155);
  gc_frame_newslot(block3701);
// method "_apply"
  block_savedest(block3701);
  Object closure3702 = createclosure(2, "_apply");
  setclosureframe(closure3702, stackframe);
  addtoclosure(closure3702, var_catchTok);
  addtoclosure(closure3702, selfslot);
  struct UserObject *uo3702 = (struct UserObject*)block3701;
  uo3702->data[0] = (Object)closure3702;
  Method *meth_meth_parser__apply3702 = addmethod2pos(block3701, "_apply", &meth_parser__apply3702, 0);
  int argcv_meth_parser__apply3702[] = {1};
  meth_meth_parser__apply3702->type = alloc_MethodType(1, argcv_meth_parser__apply3702);
  meth_meth_parser__apply3702->definitionModule = modulename;
  meth_meth_parser__apply3702->definitionLine = 1153;
// compiled block node returning block3701 (depth = 6)
  gc_frame_newslot(block3701);
// call case 4: self request
  params[0] = block3701;
  partcv[0] = 1;
  Object call3747 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3700);
// compiled call node returning call3747 (depth = 5)
  *var_nextTok = call3747;
  if (call3747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3750 = alloc_Boolean(0);
// compiled identifier node returning bool3750 (depth = 6)
  int op_slot_right_3749 = gc_frame_newslot(bool3750);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3749 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3750;
  partcv[0] = 1;
  Object opresult3752 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3752 (depth = 5)
  Object if3748 = done;
  if (istrue(opresult3752)) {
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3753 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3754 == NULL) {
    strlit3754 = alloc_String(" {}");
    gc_root(strlit3754);
  }
// compiled string node returning strlit3754 (depth = 6)
  gc_frame_newslot(strlit3754);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3754;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3755 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3753);
// compiled call node returning call3755 (depth = 5)
    gc_frame_newslot(call3755);
    if3748 = call3755;
  } else {
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3758 == NULL) {
    strlit3758 = alloc_String("rbrace");
    gc_root(strlit3758);
  }
// compiled string node returning strlit3758 (depth = 7)
  int op_slot_right_3757 = gc_frame_newslot(strlit3758);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3761 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3760);
// compiled call node returning call3761 (depth = 8)
// compiled member node returning call3761 (depth = 7)
  int op_slot_left_3757 = gc_frame_newslot(call3761);
  params[0] = strlit3758;
  partcv[0] = 1;
  Object opresult3762 = callmethod(call3761, "==", 1, partcv, params);
// compiled op node returning opresult3762 (depth = 6)
  Object if3756 = done;
  if (istrue(opresult3762)) {
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3763 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3764 == NULL) {
    strlit3764 = alloc_String(" {");
    gc_root(strlit3764);
  }
// compiled string node returning strlit3764 (depth = 7)
  gc_frame_newslot(strlit3764);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3764;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3765 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3763);
// compiled call node returning call3765 (depth = 6)
    gc_frame_newslot(call3765);
    if3756 = call3765;
  } else {
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3768 == NULL) {
    strlit3768 = alloc_String("rparen");
    gc_root(strlit3768);
  }
// compiled string node returning strlit3768 (depth = 8)
  int op_slot_right_3767 = gc_frame_newslot(strlit3768);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3771 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3770);
// compiled call node returning call3771 (depth = 9)
// compiled member node returning call3771 (depth = 8)
  int op_slot_left_3767 = gc_frame_newslot(call3771);
  params[0] = strlit3768;
  partcv[0] = 1;
  Object opresult3772 = callmethod(call3771, "==", 1, partcv, params);
// compiled op node returning opresult3772 (depth = 7)
  Object if3766 = done;
  if (istrue(opresult3772)) {
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3774 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3774 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3776 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3776 (depth = 8)
  Object if3773 = done;
  if (istrue(opresult3776)) {
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3777 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3778 == NULL) {
    strlit3778 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3778);
  }
// compiled string node returning strlit3778 (depth = 9)
  gc_frame_newslot(strlit3778);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3779 = alloc_Boolean(1);
// compiled identifier node returning bool3779 (depth = 9)
  gc_frame_newslot(bool3779);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3778;
  params[1] = *var_lastToken;
  params[2] = bool3779;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3780 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3777);
// compiled call node returning call3780 (depth = 8)
    gc_frame_newslot(call3780);
    if3773 = call3780;
  } else {
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3781 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3782 == NULL) {
    strlit3782 = alloc_String("(");
    gc_root(strlit3782);
  }
// compiled string node returning strlit3782 (depth = 9)
  gc_frame_newslot(strlit3782);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3783 = alloc_Boolean(1);
// compiled identifier node returning bool3783 (depth = 9)
  gc_frame_newslot(bool3783);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3782;
  params[1] = *var_lastToken;
  params[2] = bool3783;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3784 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3781);
// compiled call node returning call3784 (depth = 8)
    gc_frame_newslot(call3784);
    if3773 = call3784;
  }
// compiled if node returning if3773 (depth = 7)
    gc_frame_newslot(if3773);
    if3766 = if3773;
  } else {
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3787 == NULL) {
    strlit3787 = alloc_String("identifier");
    gc_root(strlit3787);
  }
// compiled string node returning strlit3787 (depth = 9)
  int op_slot_right_3786 = gc_frame_newslot(strlit3787);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3790 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3789);
// compiled call node returning call3790 (depth = 10)
// compiled member node returning call3790 (depth = 9)
  int op_slot_left_3786 = gc_frame_newslot(call3790);
  params[0] = strlit3787;
  partcv[0] = 1;
  Object opresult3791 = callmethod(call3790, "==", 1, partcv, params);
// compiled op node returning opresult3791 (depth = 8)
  Object if3785 = done;
  if (istrue(opresult3791)) {
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3792 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3793 == NULL) {
    strlit3793 = alloc_String(" {");
    gc_root(strlit3793);
  }
// compiled string node returning strlit3793 (depth = 9)
  gc_frame_newslot(strlit3793);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3793;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3794 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3792);
// compiled call node returning call3794 (depth = 8)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3795 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3796 == NULL) {
    strlit3796 = alloc_String("} ");
    gc_root(strlit3796);
  }
// compiled string node returning strlit3796 (depth = 9)
  gc_frame_newslot(strlit3796);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3796;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3797 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3795);
// compiled call node returning call3797 (depth = 8)
    gc_frame_newslot(call3797);
    if3785 = call3797;
  } else {
  }
// compiled if node returning if3785 (depth = 7)
    gc_frame_newslot(if3785);
    if3766 = if3785;
  }
// compiled if node returning if3766 (depth = 6)
    gc_frame_newslot(if3766);
    if3756 = if3766;
  }
// compiled if node returning if3756 (depth = 5)
    gc_frame_newslot(if3756);
    if3748 = if3756;
  }
// compiled if node returning if3748 (depth = 4)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3798 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3799 == NULL) {
    strlit3799 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3799);
  }
// compiled string node returning strlit3799 (depth = 5)
  gc_frame_newslot(strlit3799);
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  partcv[0] = 0;
  Object call3801 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3800);
// compiled call node returning call3801 (depth = 6)
// compiled member node returning call3801 (depth = 5)
  gc_frame_newslot(call3801);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3803 = alloc_Float64(1);
// compiled num node returning num3803 (depth = 6)
  int op_slot_right_3802 = gc_frame_newslot(num3803);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3806 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3807 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe3806);
// compiled call node returning call3807 (depth = 8)
// compiled member node returning call3807 (depth = 7)
  int op_slot_right_3805 = gc_frame_newslot(call3807);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3810 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3809);
// compiled call node returning call3810 (depth = 8)
// compiled member node returning call3810 (depth = 7)
  int op_slot_left_3805 = gc_frame_newslot(call3810);
  params[0] = call3807;
  partcv[0] = 1;
  Object sum3811 = callmethod(call3810, "+", 1, partcv, params);
// compiled op node returning sum3811 (depth = 6)
  int op_slot_left_3802 = gc_frame_newslot(sum3811);
  params[0] = num3803;
  partcv[0] = 1;
  Object sum3812 = callmethod(sum3811, "+", 1, partcv, params);
// compiled op node returning sum3812 (depth = 5)
  gc_frame_newslot(sum3812);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3799;
  params[1] = call3801;
  params[2] = sum3812;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3813 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3798);
// compiled call node returning call3813 (depth = 4)
    gc_frame_newslot(call3813);
    if3689 = call3813;
  } else {
  }
// compiled if node returning if3689 (depth = 3)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3815 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3814);
// compiled call node returning call3815 (depth = 4)
// compiled member node returning call3815 (depth = 3)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3817 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3818 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3819 = alloc_Block(NULL, NULL, "parser", 1176);
  gc_frame_newslot(block3819);
// method "_apply"
  block_savedest(block3819);
  Object closure3820 = createclosure(2, "_apply");
  setclosureframe(closure3820, stackframe);
  addtoclosure(closure3820, var_blocksOK);
  addtoclosure(closure3820, selfslot);
  struct UserObject *uo3820 = (struct UserObject*)block3819;
  uo3820->data[0] = (Object)closure3820;
  Method *meth_meth_parser__apply3820 = addmethod2pos(block3819, "_apply", &meth_parser__apply3820, 0);
  int argcv_meth_parser__apply3820[] = {0};
  meth_meth_parser__apply3820->type = alloc_MethodType(1, argcv_meth_parser__apply3820);
  meth_meth_parser__apply3820->definitionModule = modulename;
  meth_meth_parser__apply3820->definitionLine = 1176;
// compiled block node returning block3819 (depth = 7)
  gc_frame_newslot(block3819);
// call case 4: self request
  params[0] = block3819;
  partcv[0] = 1;
  Object call3824 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3818);
// compiled call node returning call3824 (depth = 6)
  partcv[0] = 0;
  Object call3825 = callmethod(call3824, "not",
    1, partcv, params);
  gc_frame_end(callframe3817);
// compiled call node returning call3825 (depth = 5)
// compiled member node returning call3825 (depth = 4)
  Object if3816 = done;
  if (istrue(call3825)) {
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3826 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3827 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3828 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3827);
// compiled call node returning call3828 (depth = 8)
// compiled member node returning call3828 (depth = 7)
  partcv[0] = 0;
  Object call3829 = callmethod(call3828, "new",
    1, partcv, params);
  gc_frame_end(callframe3826);
// compiled call node returning call3829 (depth = 6)
// compiled member node returning call3829 (depth = 5)
  *var_suggestion = call3829;
  if (call3829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3830 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array3831 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit3832 == NULL) {
    strlit3832 = alloc_String("rparen");
    gc_root(strlit3832);
  }
// compiled string node returning strlit3832 (depth = 7)
  params[0] = strlit3832;
  partcv[0] = 1;
  callmethod(array3831, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3831 (depth = 6)
  gc_frame_newslot(array3831);
// call case 4: self request
  params[0] = array3831;
  partcv[0] = 1;
  Object call3833 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3830);
// compiled call node returning call3833 (depth = 5)
  *var_nextTok = call3833;
  if (call3833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3835 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3835 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3837 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3837 (depth = 5)
  Object if3834 = done;
  if (istrue(opresult3837)) {
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3838 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3839 == NULL) {
    strlit3839 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3839);
  }
// compiled string node returning strlit3839 (depth = 6)
  gc_frame_newslot(strlit3839);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3839;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3840 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3838);
// compiled call node returning call3840 (depth = 5)
    gc_frame_newslot(call3840);
    if3834 = call3840;
  } else {
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3841 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3843 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3842);
// compiled call node returning call3843 (depth = 7)
// compiled member node returning call3843 (depth = 6)
  gc_frame_newslot(call3843);
// starting to compile identifier node (depth = 6)
  Object bool3844 = alloc_Boolean(1);
// compiled identifier node returning bool3844 (depth = 6)
  gc_frame_newslot(bool3844);
// starting to compile identifier node (depth = 6)
  Object bool3845 = alloc_Boolean(0);
// compiled identifier node returning bool3845 (depth = 6)
  gc_frame_newslot(bool3845);
// starting to compile string node (depth = 6)
  if (strlit3846 == NULL) {
    strlit3846 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3846);
  }
// compiled string node returning strlit3846 (depth = 6)
  gc_frame_newslot(strlit3846);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3843;
  params[2] = bool3844;
  params[3] = bool3845;
  params[4] = strlit3846;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3847 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3841);
// compiled call node returning call3847 (depth = 5)
    gc_frame_newslot(call3847);
    if3834 = call3847;
  }
// compiled if node returning if3834 (depth = 4)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3848 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3849 == NULL) {
    strlit3849 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3849);
  }
// compiled string node returning strlit3849 (depth = 5)
  gc_frame_newslot(strlit3849);
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3851 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3850);
// compiled call node returning call3851 (depth = 6)
// compiled member node returning call3851 (depth = 5)
  gc_frame_newslot(call3851);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3852 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3853 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3852);
// compiled call node returning call3853 (depth = 6)
// compiled member node returning call3853 (depth = 5)
  gc_frame_newslot(call3853);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3849;
  params[1] = call3851;
  params[2] = call3853;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3854 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3848);
// compiled call node returning call3854 (depth = 4)
    gc_frame_newslot(call3854);
    if3816 = call3854;
  } else {
  }
// compiled if node returning if3816 (depth = 3)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3857 == NULL) {
    strlit3857 = alloc_String("rparen");
    gc_root(strlit3857);
  }
// compiled string node returning strlit3857 (depth = 5)
  int op_slot_right_3856 = gc_frame_newslot(strlit3857);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3859 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3860 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3859);
// compiled call node returning call3860 (depth = 6)
// compiled member node returning call3860 (depth = 5)
  int op_slot_left_3856 = gc_frame_newslot(call3860);
  params[0] = strlit3857;
  partcv[0] = 1;
  Object opresult3861 = callmethod(call3860, "!=", 1, partcv, params);
// compiled op node returning opresult3861 (depth = 4)
  Object if3855 = done;
  if (istrue(opresult3861)) {
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3862 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3863 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3862);
// compiled call node returning call3863 (depth = 5)
// compiled member node returning call3863 (depth = 4)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3864 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3866 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3865);
// compiled call node returning call3866 (depth = 8)
// compiled member node returning call3866 (depth = 7)
  partcv[0] = 0;
  Object call3867 = callmethod(call3866, "new",
    1, partcv, params);
  gc_frame_end(callframe3864);
// compiled call node returning call3867 (depth = 6)
// compiled member node returning call3867 (depth = 5)
  *var_suggestion = call3867;
  if (call3867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3868 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3869 == NULL) {
    strlit3869 = alloc_String(")");
    gc_root(strlit3869);
  }
// compiled string node returning strlit3869 (depth = 5)
  gc_frame_newslot(strlit3869);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3869;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3870 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3868);
// compiled call node returning call3870 (depth = 4)
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3871 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3872 == NULL) {
    strlit3872 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3872);
  }
// compiled string node returning strlit3872 (depth = 5)
  gc_frame_newslot(strlit3872);
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3874 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3873);
// compiled call node returning call3874 (depth = 6)
// compiled member node returning call3874 (depth = 5)
  gc_frame_newslot(call3874);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3876 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3877 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3876);
// compiled call node returning call3877 (depth = 7)
// compiled member node returning call3877 (depth = 6)
  int op_slot_right_3875 = gc_frame_newslot(call3877);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3880 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3879);
// compiled call node returning call3880 (depth = 7)
// compiled member node returning call3880 (depth = 6)
  int op_slot_left_3875 = gc_frame_newslot(call3880);
  params[0] = call3877;
  partcv[0] = 1;
  Object sum3881 = callmethod(call3880, "+", 1, partcv, params);
// compiled op node returning sum3881 (depth = 5)
  gc_frame_newslot(sum3881);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3872;
  params[1] = call3874;
  params[2] = sum3881;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3882 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3871);
// compiled call node returning call3882 (depth = 4)
    gc_frame_newslot(call3882);
    if3855 = call3882;
  } else {
  }
// compiled if node returning if3855 (depth = 3)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3883 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3884 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3883);
// compiled call node returning call3884 (depth = 4)
// compiled member node returning call3884 (depth = 3)
    gc_frame_newslot(call3884);
    if3683 = call3884;
  }
// compiled if node returning if3683 (depth = 2)
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3885 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3886 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3885);
// compiled call node returning call3886 (depth = 4)
// compiled member node returning call3886 (depth = 3)
  *var_mainblock = call3886;
  if (call3886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3887 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3887 (depth = 3)
  *var_cases = array3887;
  if (array3887 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3888 = alloc_Boolean(0);
// compiled identifier node returning bool3888 (depth = 3)
  *var_finally = bool3888;
  if (bool3888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3889 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3890 = alloc_Block(NULL, NULL, "parser", 1199);
  gc_frame_newslot(block3890);
// method "_apply"
  block_savedest(block3890);
  Object closure3891 = createclosure(2, "_apply");
  setclosureframe(closure3891, stackframe);
  addtoclosure(closure3891, var_sym);
  addtoclosure(closure3891, selfslot);
  struct UserObject *uo3891 = (struct UserObject*)block3890;
  uo3891->data[0] = (Object)closure3891;
  Method *meth_meth_parser__apply3891 = addmethod2pos(block3890, "_apply", &meth_parser__apply3891, 0);
  int argcv_meth_parser__apply3891[] = {0};
  meth_meth_parser__apply3891->type = alloc_MethodType(1, argcv_meth_parser__apply3891);
  meth_meth_parser__apply3891->definitionModule = modulename;
  meth_meth_parser__apply3891->definitionLine = 1196;
// compiled block node returning block3890 (depth = 3)
  gc_frame_newslot(block3890);
// starting to compile block node (depth = 3)
  Object block3905 = alloc_Block(NULL, NULL, "parser", 1199);
  gc_frame_newslot(block3905);
// method "_apply"
  block_savedest(block3905);
  Object closure3906 = createclosure(8, "_apply");
  setclosureframe(closure3906, stackframe);
  addtoclosure(closure3906, var_blocksOK);
  addtoclosure(closure3906, var_errormessages);
  addtoclosure(closure3906, var_sym);
  addtoclosure(closure3906, var_lastToken);
  addtoclosure(closure3906, var_tokens);
  addtoclosure(closure3906, var_values);
  addtoclosure(closure3906, var_cases);
  addtoclosure(closure3906, selfslot);
  struct UserObject *uo3906 = (struct UserObject*)block3905;
  uo3906->data[0] = (Object)closure3906;
  Method *meth_meth_parser__apply3906 = addmethod2pos(block3905, "_apply", &meth_parser__apply3906, 0);
  int argcv_meth_parser__apply3906[] = {0};
  meth_meth_parser__apply3906->type = alloc_MethodType(1, argcv_meth_parser__apply3906);
  meth_meth_parser__apply3906->definitionModule = modulename;
  meth_meth_parser__apply3906->definitionLine = 1199;
// compiled block node returning block3905 (depth = 3)
  gc_frame_newslot(block3905);
// call case 5: prelude request
  params[0] = block3890;
  params[1] = block3905;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4056 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3889);
// compiled call node returning call4056 (depth = 2)
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4060 == NULL) {
    strlit4060 = alloc_String("case");
    gc_root(strlit4060);
  }
// compiled string node returning strlit4060 (depth = 5)
  int op_slot_right_4059 = gc_frame_newslot(strlit4060);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4062 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4063 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4062);
// compiled call node returning call4063 (depth = 6)
// compiled member node returning call4063 (depth = 5)
  int op_slot_left_4059 = gc_frame_newslot(call4063);
  params[0] = strlit4060;
  partcv[0] = 1;
  Object opresult4064 = callmethod(call4063, "==", 1, partcv, params);
// compiled op node returning opresult4064 (depth = 4)
  int op_slot_right_4058 = gc_frame_newslot(opresult4064);
// starting to compile call node (depth = 4)
  int callframe4066 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4067 == NULL) {
    strlit4067 = alloc_String("identifier");
    gc_root(strlit4067);
  }
// compiled string node returning strlit4067 (depth = 5)
  gc_frame_newslot(strlit4067);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  gc_frame_newslot(*var_catchTok);
// call case 4: self request
  params[0] = strlit4067;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4068 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4066);
// compiled call node returning call4068 (depth = 4)
  int op_slot_left_4058 = gc_frame_newslot(call4068);
  params[0] = opresult4064;
  partcv[0] = 1;
  Object opresult4069 = callmethod(call4068, "&&", 1, partcv, params);
// compiled op node returning opresult4069 (depth = 3)
  Object if4057 = done;
  if (istrue(opresult4069)) {
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4070 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4072 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4071);
// compiled call node returning call4072 (depth = 7)
// compiled member node returning call4072 (depth = 6)
  partcv[0] = 0;
  Object call4073 = callmethod(call4072, "new",
    1, partcv, params);
  gc_frame_end(callframe4070);
// compiled call node returning call4073 (depth = 5)
// compiled member node returning call4073 (depth = 4)
  *var_suggestion = call4073;
  if (call4073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4074 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit4075 == NULL) {
    strlit4075 = alloc_String("catch");
    gc_root(strlit4075);
  }
// compiled string node returning strlit4075 (depth = 4)
  gc_frame_newslot(strlit4075);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit4075;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4076 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe4074);
// compiled call node returning call4076 (depth = 3)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4077 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4079 == NULL) {
    strlit4079 = alloc_String("are no 'case' blocks.");
    gc_root(strlit4079);
  }
// compiled string node returning strlit4079 (depth = 5)
  int op_slot_right_4078 = gc_frame_newslot(strlit4079);
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4082 == NULL) {
    strlit4082 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit4082);
  }
// compiled string node returning strlit4082 (depth = 6)
  int op_slot_right_4081 = gc_frame_newslot(strlit4082);
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4084 == NULL) {
    strlit4084 = alloc_String("a try-catch statement starts with a ");
    gc_root(strlit4084);
  }
// compiled string node returning strlit4084 (depth = 6)
  int op_slot_left_4081 = gc_frame_newslot(strlit4084);
  params[0] = strlit4082;
  partcv[0] = 1;
  Object opresult4085 = callmethod(strlit4084, "++", 1, partcv, params);
// compiled op node returning opresult4085 (depth = 5)
  int op_slot_left_4078 = gc_frame_newslot(opresult4085);
  params[0] = strlit4079;
  partcv[0] = 1;
  Object opresult4086 = callmethod(opresult4085, "++", 1, partcv, params);
// compiled op node returning opresult4086 (depth = 4)
  gc_frame_newslot(opresult4086);
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4088 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4087);
// compiled call node returning call4088 (depth = 5)
// compiled member node returning call4088 (depth = 4)
  gc_frame_newslot(call4088);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4089 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4090 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4089);
// compiled call node returning call4090 (depth = 5)
// compiled member node returning call4090 (depth = 4)
  gc_frame_newslot(call4090);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4092 = alloc_Float64(3);
// compiled num node returning num4092 (depth = 5)
  int op_slot_right_4091 = gc_frame_newslot(num4092);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4094 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4095 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4094);
// compiled call node returning call4095 (depth = 6)
// compiled member node returning call4095 (depth = 5)
  int op_slot_left_4091 = gc_frame_newslot(call4095);
  params[0] = num4092;
  partcv[0] = 1;
  Object sum4096 = callmethod(call4095, "+", 1, partcv, params);
// compiled op node returning sum4096 (depth = 4)
  gc_frame_newslot(sum4096);
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult4086;
  params[1] = call4088;
  params[2] = call4090;
  params[3] = sum4096;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call4097 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4077);
// compiled call node returning call4097 (depth = 3)
    gc_frame_newslot(call4097);
    if4057 = call4097;
  } else {
  }
// compiled if node returning if4057 (depth = 2)
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4101 == NULL) {
    strlit4101 = alloc_String("finally");
    gc_root(strlit4101);
  }
// compiled string node returning strlit4101 (depth = 5)
  int op_slot_right_4100 = gc_frame_newslot(strlit4101);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4104 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4103);
// compiled call node returning call4104 (depth = 6)
// compiled member node returning call4104 (depth = 5)
  int op_slot_left_4100 = gc_frame_newslot(call4104);
  params[0] = strlit4101;
  partcv[0] = 1;
  Object opresult4105 = callmethod(call4104, "==", 1, partcv, params);
// compiled op node returning opresult4105 (depth = 4)
  int op_slot_right_4099 = gc_frame_newslot(opresult4105);
// starting to compile call node (depth = 4)
  int callframe4107 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4108 == NULL) {
    strlit4108 = alloc_String("identifier");
    gc_root(strlit4108);
  }
// compiled string node returning strlit4108 (depth = 5)
  gc_frame_newslot(strlit4108);
// call case 4: self request
  params[0] = strlit4108;
  partcv[0] = 1;
  Object call4109 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4107);
// compiled call node returning call4109 (depth = 4)
  int op_slot_left_4099 = gc_frame_newslot(call4109);
  params[0] = opresult4105;
  partcv[0] = 1;
  Object opresult4110 = callmethod(call4109, "&&", 1, partcv, params);
// compiled op node returning opresult4110 (depth = 3)
  Object if4098 = done;
  if (istrue(opresult4110)) {
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4112 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4111);
// compiled call node returning call4112 (depth = 4)
// compiled member node returning call4112 (depth = 3)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4114 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4115 == NULL) {
    strlit4115 = alloc_String("lbrace");
    gc_root(strlit4115);
  }
// compiled string node returning strlit4115 (depth = 5)
  gc_frame_newslot(strlit4115);
// call case 4: self request
  params[0] = strlit4115;
  partcv[0] = 1;
  Object call4116 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4114);
// compiled call node returning call4116 (depth = 4)
  Object if4113 = done;
  if (istrue(call4116)) {
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4117 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4118 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4117);
// compiled call node returning call4118 (depth = 5)
// compiled member node returning call4118 (depth = 4)
    gc_frame_newslot(call4118);
    if4113 = call4118;
  } else {
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4120 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4121 == NULL) {
    strlit4121 = alloc_String("lparen");
    gc_root(strlit4121);
  }
// compiled string node returning strlit4121 (depth = 6)
  gc_frame_newslot(strlit4121);
// call case 4: self request
  params[0] = strlit4121;
  partcv[0] = 1;
  Object call4122 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4120);
// compiled call node returning call4122 (depth = 5)
  Object if4119 = done;
  if (istrue(call4122)) {
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4124 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4123);
// compiled call node returning call4124 (depth = 6)
// compiled member node returning call4124 (depth = 5)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4126 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe4127 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block4128 = alloc_Block(NULL, NULL, "parser", 1263);
  gc_frame_newslot(block4128);
// method "_apply"
  block_savedest(block4128);
  Object closure4129 = createclosure(2, "_apply");
  setclosureframe(closure4129, stackframe);
  addtoclosure(closure4129, var_blocksOK);
  addtoclosure(closure4129, selfslot);
  struct UserObject *uo4129 = (struct UserObject*)block4128;
  uo4129->data[0] = (Object)closure4129;
  Method *meth_meth_parser__apply4129 = addmethod2pos(block4128, "_apply", &meth_parser__apply4129, 0);
  int argcv_meth_parser__apply4129[] = {0};
  meth_meth_parser__apply4129->type = alloc_MethodType(1, argcv_meth_parser__apply4129);
  meth_meth_parser__apply4129->definitionModule = modulename;
  meth_meth_parser__apply4129->definitionLine = 1263;
// compiled block node returning block4128 (depth = 9)
  gc_frame_newslot(block4128);
// call case 4: self request
  params[0] = block4128;
  partcv[0] = 1;
  Object call4133 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4127);
// compiled call node returning call4133 (depth = 8)
  partcv[0] = 0;
  Object call4134 = callmethod(call4133, "not",
    1, partcv, params);
  gc_frame_end(callframe4126);
// compiled call node returning call4134 (depth = 7)
// compiled member node returning call4134 (depth = 6)
  Object if4125 = done;
  if (istrue(call4134)) {
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4135 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4137 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4136);
// compiled call node returning call4137 (depth = 10)
// compiled member node returning call4137 (depth = 9)
  partcv[0] = 0;
  Object call4138 = callmethod(call4137, "new",
    1, partcv, params);
  gc_frame_end(callframe4135);
// compiled call node returning call4138 (depth = 8)
// compiled member node returning call4138 (depth = 7)
  *var_suggestion = call4138;
  if (call4138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4139 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array4140 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit4141 == NULL) {
    strlit4141 = alloc_String("rparen");
    gc_root(strlit4141);
  }
// compiled string node returning strlit4141 (depth = 9)
  params[0] = strlit4141;
  partcv[0] = 1;
  callmethod(array4140, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array4140 (depth = 8)
  gc_frame_newslot(array4140);
// call case 4: self request
  params[0] = array4140;
  partcv[0] = 1;
  Object call4142 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4139);
// compiled call node returning call4142 (depth = 7)
  *var_nextTok = call4142;
  if (call4142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4144 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4144 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4146 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4146 (depth = 7)
  Object if4143 = done;
  if (istrue(opresult4146)) {
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4147 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4148 == NULL) {
    strlit4148 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4148);
  }
// compiled string node returning strlit4148 (depth = 8)
  gc_frame_newslot(strlit4148);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4148;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4149 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4147);
// compiled call node returning call4149 (depth = 7)
    gc_frame_newslot(call4149);
    if4143 = call4149;
  } else {
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4150 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4152 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4151);
// compiled call node returning call4152 (depth = 9)
// compiled member node returning call4152 (depth = 8)
  gc_frame_newslot(call4152);
// starting to compile identifier node (depth = 8)
  Object bool4153 = alloc_Boolean(1);
// compiled identifier node returning bool4153 (depth = 8)
  gc_frame_newslot(bool4153);
// starting to compile identifier node (depth = 8)
  Object bool4154 = alloc_Boolean(0);
// compiled identifier node returning bool4154 (depth = 8)
  gc_frame_newslot(bool4154);
// starting to compile string node (depth = 8)
  if (strlit4155 == NULL) {
    strlit4155 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4155);
  }
// compiled string node returning strlit4155 (depth = 8)
  gc_frame_newslot(strlit4155);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4152;
  params[2] = bool4153;
  params[3] = bool4154;
  params[4] = strlit4155;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4156 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4150);
// compiled call node returning call4156 (depth = 7)
    gc_frame_newslot(call4156);
    if4143 = call4156;
  }
// compiled if node returning if4143 (depth = 6)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4157 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4158 == NULL) {
    strlit4158 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4158);
  }
// compiled string node returning strlit4158 (depth = 7)
  gc_frame_newslot(strlit4158);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4160 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4159);
// compiled call node returning call4160 (depth = 8)
// compiled member node returning call4160 (depth = 7)
  gc_frame_newslot(call4160);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4162 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4161);
// compiled call node returning call4162 (depth = 8)
// compiled member node returning call4162 (depth = 7)
  gc_frame_newslot(call4162);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4158;
  params[1] = call4160;
  params[2] = call4162;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4163 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4157);
// compiled call node returning call4163 (depth = 6)
    gc_frame_newslot(call4163);
    if4125 = call4163;
  } else {
  }
// compiled if node returning if4125 (depth = 5)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4166 == NULL) {
    strlit4166 = alloc_String("rparen");
    gc_root(strlit4166);
  }
// compiled string node returning strlit4166 (depth = 7)
  int op_slot_right_4165 = gc_frame_newslot(strlit4166);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4169 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4168);
// compiled call node returning call4169 (depth = 8)
// compiled member node returning call4169 (depth = 7)
  int op_slot_left_4165 = gc_frame_newslot(call4169);
  params[0] = strlit4166;
  partcv[0] = 1;
  Object opresult4170 = callmethod(call4169, "!=", 1, partcv, params);
// compiled op node returning opresult4170 (depth = 6)
  Object if4164 = done;
  if (istrue(opresult4170)) {
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4172 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4171);
// compiled call node returning call4172 (depth = 7)
// compiled member node returning call4172 (depth = 6)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4173 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4175 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4174);
// compiled call node returning call4175 (depth = 10)
// compiled member node returning call4175 (depth = 9)
  partcv[0] = 0;
  Object call4176 = callmethod(call4175, "new",
    1, partcv, params);
  gc_frame_end(callframe4173);
// compiled call node returning call4176 (depth = 8)
// compiled member node returning call4176 (depth = 7)
  *var_suggestion = call4176;
  if (call4176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4177 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4178 == NULL) {
    strlit4178 = alloc_String(")");
    gc_root(strlit4178);
  }
// compiled string node returning strlit4178 (depth = 7)
  gc_frame_newslot(strlit4178);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4178;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4179 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4177);
// compiled call node returning call4179 (depth = 6)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4180 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4181 == NULL) {
    strlit4181 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4181);
  }
// compiled string node returning strlit4181 (depth = 7)
  gc_frame_newslot(strlit4181);
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4183 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4182);
// compiled call node returning call4183 (depth = 8)
// compiled member node returning call4183 (depth = 7)
  gc_frame_newslot(call4183);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4186 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4185);
// compiled call node returning call4186 (depth = 9)
// compiled member node returning call4186 (depth = 8)
  int op_slot_right_4184 = gc_frame_newslot(call4186);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4189 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4188);
// compiled call node returning call4189 (depth = 9)
// compiled member node returning call4189 (depth = 8)
  int op_slot_left_4184 = gc_frame_newslot(call4189);
  params[0] = call4186;
  partcv[0] = 1;
  Object sum4190 = callmethod(call4189, "+", 1, partcv, params);
// compiled op node returning sum4190 (depth = 7)
  gc_frame_newslot(sum4190);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4181;
  params[1] = call4183;
  params[2] = sum4190;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4191 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4180);
// compiled call node returning call4191 (depth = 6)
    gc_frame_newslot(call4191);
    if4164 = call4191;
  } else {
  }
// compiled if node returning if4164 (depth = 5)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4193 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4192);
// compiled call node returning call4193 (depth = 6)
// compiled member node returning call4193 (depth = 5)
    gc_frame_newslot(call4193);
    if4119 = call4193;
  } else {
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4194 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4195 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4196 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4195);
// compiled call node returning call4196 (depth = 9)
// compiled member node returning call4196 (depth = 8)
  partcv[0] = 0;
  Object call4197 = callmethod(call4196, "empty",
    1, partcv, params);
  gc_frame_end(callframe4194);
// compiled call node returning call4197 (depth = 7)
// compiled member node returning call4197 (depth = 6)
  *var_suggestions = call4197;
  if (call4197 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4198 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4199 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4198);
// compiled call node returning call4199 (depth = 6)
  *var_nextTok = call4199;
  if (call4199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4200 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4201 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4202 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4201);
// compiled call node returning call4202 (depth = 9)
// compiled member node returning call4202 (depth = 8)
  partcv[0] = 0;
  Object call4203 = callmethod(call4202, "new",
    1, partcv, params);
  gc_frame_end(callframe4200);
// compiled call node returning call4203 (depth = 7)
// compiled member node returning call4203 (depth = 6)
  *var_suggestion = call4203;
  if (call4203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool4206 = alloc_Boolean(0);
// compiled identifier node returning bool4206 (depth = 7)
  int op_slot_right_4205 = gc_frame_newslot(bool4206);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4205 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4206;
  partcv[0] = 1;
  Object opresult4208 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4208 (depth = 6)
  Object if4204 = done;
  if (istrue(opresult4208)) {
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4209 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4210 == NULL) {
    strlit4210 = alloc_String(" }");
    gc_root(strlit4210);
  }
// compiled string node returning strlit4210 (depth = 7)
  gc_frame_newslot(strlit4210);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call4212 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe4211);
// compiled call node returning call4212 (depth = 8)
// compiled member node returning call4212 (depth = 7)
  gc_frame_newslot(call4212);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4210;
  params[1] = call4212;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4213 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4209);
// compiled call node returning call4213 (depth = 6)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4214 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4215 == NULL) {
    strlit4215 = alloc_String(" {");
    gc_root(strlit4215);
  }
// compiled string node returning strlit4215 (depth = 7)
  gc_frame_newslot(strlit4215);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4215;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4216 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4214);
// compiled call node returning call4216 (depth = 6)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4217 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4218 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4217);
// compiled call node returning call4218 (depth = 6)
    gc_frame_newslot(call4218);
    if4204 = call4218;
  } else {
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4220 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4220 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4222 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4222 (depth = 7)
  Object if4219 = done;
  if (istrue(opresult4222)) {
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4223 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4224 == NULL) {
    strlit4224 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4224);
  }
// compiled string node returning strlit4224 (depth = 8)
  gc_frame_newslot(strlit4224);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4224;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4225 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4223);
// compiled call node returning call4225 (depth = 7)
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4226 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4227 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4226);
// compiled call node returning call4227 (depth = 7)
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4228 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4230 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4229);
// compiled call node returning call4230 (depth = 11)
// compiled member node returning call4230 (depth = 10)
  partcv[0] = 0;
  Object call4231 = callmethod(call4230, "new",
    1, partcv, params);
  gc_frame_end(callframe4228);
// compiled call node returning call4231 (depth = 9)
// compiled member node returning call4231 (depth = 8)
  *var_suggestion = call4231;
  if (call4231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4233 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4234 == NULL) {
    strlit4234 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4234);
  }
// compiled string node returning strlit4234 (depth = 8)
  gc_frame_newslot(strlit4234);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4234;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4235 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4233);
// compiled call node returning call4235 (depth = 7)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4236 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4237 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4236);
// compiled call node returning call4237 (depth = 7)
    gc_frame_newslot(call4237);
    if4219 = call4237;
  } else {
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4238 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4239 == NULL) {
    strlit4239 = alloc_String(" }");
    gc_root(strlit4239);
  }
// compiled string node returning strlit4239 (depth = 8)
  gc_frame_newslot(strlit4239);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4241 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4240);
// compiled call node returning call4241 (depth = 9)
// compiled member node returning call4241 (depth = 8)
  gc_frame_newslot(call4241);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4239;
  params[1] = call4241;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4242 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4238);
// compiled call node returning call4242 (depth = 7)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4243 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4244 == NULL) {
    strlit4244 = alloc_String(" {");
    gc_root(strlit4244);
  }
// compiled string node returning strlit4244 (depth = 8)
  gc_frame_newslot(strlit4244);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4244;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4245 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4243);
// compiled call node returning call4245 (depth = 7)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4246 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4247 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4246);
// compiled call node returning call4247 (depth = 7)
    gc_frame_newslot(call4247);
    if4219 = call4247;
  }
// compiled if node returning if4219 (depth = 6)
    gc_frame_newslot(if4219);
    if4204 = if4219;
  }
// compiled if node returning if4204 (depth = 5)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4248 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4249 == NULL) {
    strlit4249 = alloc_String("a try-finally statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4249);
  }
// compiled string node returning strlit4249 (depth = 6)
  gc_frame_newslot(strlit4249);
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4250 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4251 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4250);
// compiled call node returning call4251 (depth = 7)
// compiled member node returning call4251 (depth = 6)
  gc_frame_newslot(call4251);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4253 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4252);
// compiled call node returning call4253 (depth = 7)
// compiled member node returning call4253 (depth = 6)
  gc_frame_newslot(call4253);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4249;
  params[1] = call4251;
  params[2] = call4253;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4254 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4248);
// compiled call node returning call4254 (depth = 5)
    gc_frame_newslot(call4254);
    if4119 = call4254;
  }
// compiled if node returning if4119 (depth = 4)
    gc_frame_newslot(if4119);
    if4113 = if4119;
  }
// compiled if node returning if4113 (depth = 3)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4255 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4256 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4255);
// compiled call node returning call4256 (depth = 5)
// compiled member node returning call4256 (depth = 4)
  *var_finally = call4256;
  if (call4256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if4098 = done;
  } else {
  }
// compiled if node returning if4098 (depth = 2)
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4258 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4260 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4259);
// compiled call node returning call4260 (depth = 4)
// compiled member node returning call4260 (depth = 3)
  gc_frame_newslot(call4260);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4262 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4261);
// compiled call node returning call4262 (depth = 4)
// compiled member node returning call4262 (depth = 3)
  gc_frame_newslot(call4262);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4260;
  params[1] = call4262;
  partcv[0] = 2;
  Object call4263 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4258);
// compiled call node returning call4263 (depth = 2)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4264 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4265 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4266 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4267 = callmethod(*var_ast, "tryCatchNode",
    1, partcv, params);
  gc_frame_end(callframe4266);
// compiled call node returning call4267 (depth = 5)
// compiled member node returning call4267 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4268 = callmethod(call4267, "new",
    1, partcv, params);
  gc_frame_end(callframe4265);
// compiled call node returning call4268 (depth = 3)
  gc_frame_newslot(call4268);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4268;
  partcv[0] = 1;
  Object call4269 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4264);
// compiled call node returning call4269 (depth = 2)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4303(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4307 == NULL) {
    strlit4307 = alloc_String("case");
    gc_root(strlit4307);
  }
// compiled string node returning strlit4307 (depth = 9)
  int op_slot_right_4306 = gc_frame_newslot(strlit4307);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4310 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4309);
// compiled call node returning call4310 (depth = 10)
// compiled member node returning call4310 (depth = 9)
  int op_slot_left_4306 = gc_frame_newslot(call4310);
  params[0] = strlit4307;
  partcv[0] = 1;
  Object opresult4311 = callmethod(call4310, "==", 1, partcv, params);
// compiled op node returning opresult4311 (depth = 8)
  int op_slot_right_4305 = gc_frame_newslot(opresult4311);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4314 == NULL) {
    strlit4314 = alloc_String("identifier");
    gc_root(strlit4314);
  }
// compiled string node returning strlit4314 (depth = 9)
  int op_slot_right_4313 = gc_frame_newslot(strlit4314);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4317 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4316);
// compiled call node returning call4317 (depth = 10)
// compiled member node returning call4317 (depth = 9)
  int op_slot_left_4313 = gc_frame_newslot(call4317);
  params[0] = strlit4314;
  partcv[0] = 1;
  Object opresult4318 = callmethod(call4317, "==", 1, partcv, params);
// compiled op node returning opresult4318 (depth = 8)
  int op_slot_left_4305 = gc_frame_newslot(opresult4318);
  params[0] = opresult4311;
  partcv[0] = 1;
  Object opresult4319 = callmethod(opresult4318, "&&", 1, partcv, params);
// compiled op node returning opresult4319 (depth = 7)
  int op_slot_right_4304 = gc_frame_newslot(opresult4319);
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_matchTok (depth = 11)
  partcv[0] = 0;
  Object call4324 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4323);
// compiled call node returning call4324 (depth = 10)
// compiled member node returning call4324 (depth = 9)
  int op_slot_right_4322 = gc_frame_newslot(call4324);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4326 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4327 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4326);
// compiled call node returning call4327 (depth = 10)
// compiled member node returning call4327 (depth = 9)
  int op_slot_left_4322 = gc_frame_newslot(call4327);
  params[0] = call4324;
  partcv[0] = 1;
  Object opresult4328 = callmethod(call4327, "==", 1, partcv, params);
// compiled op node returning opresult4328 (depth = 8)
  int op_slot_right_4321 = gc_frame_newslot(opresult4328);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4331 == NULL) {
    strlit4331 = alloc_String("rparen");
    gc_root(strlit4331);
  }
// compiled string node returning strlit4331 (depth = 9)
  int op_slot_right_4330 = gc_frame_newslot(strlit4331);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4334 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4333);
// compiled call node returning call4334 (depth = 10)
// compiled member node returning call4334 (depth = 9)
  int op_slot_left_4330 = gc_frame_newslot(call4334);
  params[0] = strlit4331;
  partcv[0] = 1;
  Object opresult4335 = callmethod(call4334, "==", 1, partcv, params);
// compiled op node returning opresult4335 (depth = 8)
  int op_slot_left_4321 = gc_frame_newslot(opresult4335);
  params[0] = opresult4328;
  partcv[0] = 1;
  Object opresult4336 = callmethod(opresult4335, "&&", 1, partcv, params);
// compiled op node returning opresult4336 (depth = 7)
  int op_slot_left_4304 = gc_frame_newslot(opresult4336);
  params[0] = opresult4319;
  partcv[0] = 1;
  Object opresult4337 = callmethod(opresult4336, "||", 1, partcv, params);
// compiled op node returning opresult4337 (depth = 6)
  gc_frame_end(frame);
  return opresult4337;
}
Object meth_parser__apply4399(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4400 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4401 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4400);
// compiled call node returning call4401 (depth = 7)
  gc_frame_end(frame);
  return call4401;
}
Object meth_parser__apply4470(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4473 == NULL) {
    strlit4473 = alloc_String("case");
    gc_root(strlit4473);
  }
// compiled string node returning strlit4473 (depth = 6)
  int op_slot_right_4472 = gc_frame_newslot(strlit4473);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4475 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4476 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4475);
// compiled call node returning call4476 (depth = 7)
// compiled member node returning call4476 (depth = 6)
  int op_slot_left_4472 = gc_frame_newslot(call4476);
  params[0] = strlit4473;
  partcv[0] = 1;
  Object opresult4477 = callmethod(call4476, "==", 1, partcv, params);
// compiled op node returning opresult4477 (depth = 5)
  int op_slot_right_4471 = gc_frame_newslot(opresult4477);
// starting to compile call node (depth = 5)
  int callframe4479 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4480 == NULL) {
    strlit4480 = alloc_String("identifier");
    gc_root(strlit4480);
  }
// compiled string node returning strlit4480 (depth = 6)
  gc_frame_newslot(strlit4480);
// call case 4: self request
  params[0] = strlit4480;
  partcv[0] = 1;
  Object call4481 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4479);
// compiled call node returning call4481 (depth = 5)
  int op_slot_left_4471 = gc_frame_newslot(call4481);
  params[0] = opresult4477;
  partcv[0] = 1;
  Object opresult4482 = callmethod(call4481, "&&", 1, partcv, params);
// compiled op node returning opresult4482 (depth = 4)
  gc_frame_end(frame);
  return opresult4482;
}
Object meth_parser__apply4504(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe4505 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4506 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4505);
// compiled call node returning call4506 (depth = 11)
  gc_frame_end(frame);
  return call4506;
}
Object meth_parser__apply4485(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4487 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4486);
// compiled call node returning call4487 (depth = 5)
// compiled member node returning call4487 (depth = 4)
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4489 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4490 == NULL) {
    strlit4490 = alloc_String("lbrace");
    gc_root(strlit4490);
  }
// compiled string node returning strlit4490 (depth = 6)
  gc_frame_newslot(strlit4490);
// call case 4: self request
  params[0] = strlit4490;
  partcv[0] = 1;
  Object call4491 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4489);
// compiled call node returning call4491 (depth = 5)
  Object if4488 = done;
  if (istrue(call4491)) {
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4492 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4493 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4492);
// compiled call node returning call4493 (depth = 6)
// compiled member node returning call4493 (depth = 5)
    gc_frame_newslot(call4493);
    if4488 = call4493;
  } else {
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4495 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4496 == NULL) {
    strlit4496 = alloc_String("lparen");
    gc_root(strlit4496);
  }
// compiled string node returning strlit4496 (depth = 7)
  gc_frame_newslot(strlit4496);
// call case 4: self request
  params[0] = strlit4496;
  partcv[0] = 1;
  Object call4497 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4495);
// compiled call node returning call4497 (depth = 6)
  Object if4494 = done;
  if (istrue(call4497)) {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4498 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4499 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4498);
// compiled call node returning call4499 (depth = 7)
// compiled member node returning call4499 (depth = 6)
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4501 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe4502 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block4503 = alloc_Block(NULL, NULL, "parser", 1366);
  gc_frame_newslot(block4503);
// method "_apply"
  block_savedest(block4503);
  Object closure4504 = createclosure(2, "_apply");
  setclosureframe(closure4504, stackframe);
  addtoclosure(closure4504, var_blocksOK);
  addtoclosure(closure4504, selfslot);
  struct UserObject *uo4504 = (struct UserObject*)block4503;
  uo4504->data[0] = (Object)closure4504;
  Method *meth_meth_parser__apply4504 = addmethod2pos(block4503, "_apply", &meth_parser__apply4504, 0);
  int argcv_meth_parser__apply4504[] = {0};
  meth_meth_parser__apply4504->type = alloc_MethodType(1, argcv_meth_parser__apply4504);
  meth_meth_parser__apply4504->definitionModule = modulename;
  meth_meth_parser__apply4504->definitionLine = 1366;
// compiled block node returning block4503 (depth = 10)
  gc_frame_newslot(block4503);
// call case 4: self request
  params[0] = block4503;
  partcv[0] = 1;
  Object call4508 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4502);
// compiled call node returning call4508 (depth = 9)
  partcv[0] = 0;
  Object call4509 = callmethod(call4508, "not",
    1, partcv, params);
  gc_frame_end(callframe4501);
// compiled call node returning call4509 (depth = 8)
// compiled member node returning call4509 (depth = 7)
  Object if4500 = done;
  if (istrue(call4509)) {
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4510 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4512 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4511);
// compiled call node returning call4512 (depth = 11)
// compiled member node returning call4512 (depth = 10)
  partcv[0] = 0;
  Object call4513 = callmethod(call4512, "new",
    1, partcv, params);
  gc_frame_end(callframe4510);
// compiled call node returning call4513 (depth = 9)
// compiled member node returning call4513 (depth = 8)
  *var_suggestion = call4513;
  if (call4513 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4514 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array4515 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit4516 == NULL) {
    strlit4516 = alloc_String("rparen");
    gc_root(strlit4516);
  }
// compiled string node returning strlit4516 (depth = 10)
  params[0] = strlit4516;
  partcv[0] = 1;
  callmethod(array4515, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array4515 (depth = 9)
  gc_frame_newslot(array4515);
// call case 4: self request
  params[0] = array4515;
  partcv[0] = 1;
  Object call4517 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4514);
// compiled call node returning call4517 (depth = 8)
  *var_nextTok = call4517;
  if (call4517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4519 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4519 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4521 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4521 (depth = 8)
  Object if4518 = done;
  if (istrue(opresult4521)) {
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4522 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4523 == NULL) {
    strlit4523 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4523);
  }
// compiled string node returning strlit4523 (depth = 9)
  gc_frame_newslot(strlit4523);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4523;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4524 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4522);
// compiled call node returning call4524 (depth = 8)
    gc_frame_newslot(call4524);
    if4518 = call4524;
  } else {
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4525 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4527 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4526);
// compiled call node returning call4527 (depth = 10)
// compiled member node returning call4527 (depth = 9)
  gc_frame_newslot(call4527);
// starting to compile identifier node (depth = 9)
  Object bool4528 = alloc_Boolean(1);
// compiled identifier node returning bool4528 (depth = 9)
  gc_frame_newslot(bool4528);
// starting to compile identifier node (depth = 9)
  Object bool4529 = alloc_Boolean(0);
// compiled identifier node returning bool4529 (depth = 9)
  gc_frame_newslot(bool4529);
// starting to compile string node (depth = 9)
  if (strlit4530 == NULL) {
    strlit4530 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4530);
  }
// compiled string node returning strlit4530 (depth = 9)
  gc_frame_newslot(strlit4530);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4527;
  params[2] = bool4528;
  params[3] = bool4529;
  params[4] = strlit4530;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4531 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4525);
// compiled call node returning call4531 (depth = 8)
    gc_frame_newslot(call4531);
    if4518 = call4531;
  }
// compiled if node returning if4518 (depth = 7)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4532 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4533 == NULL) {
    strlit4533 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4533);
  }
// compiled string node returning strlit4533 (depth = 8)
  gc_frame_newslot(strlit4533);
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4535 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4534);
// compiled call node returning call4535 (depth = 9)
// compiled member node returning call4535 (depth = 8)
  gc_frame_newslot(call4535);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4537 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4536);
// compiled call node returning call4537 (depth = 9)
// compiled member node returning call4537 (depth = 8)
  gc_frame_newslot(call4537);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4533;
  params[1] = call4535;
  params[2] = call4537;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4538 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4532);
// compiled call node returning call4538 (depth = 7)
    gc_frame_newslot(call4538);
    if4500 = call4538;
  } else {
  }
// compiled if node returning if4500 (depth = 6)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4541 == NULL) {
    strlit4541 = alloc_String("rparen");
    gc_root(strlit4541);
  }
// compiled string node returning strlit4541 (depth = 8)
  int op_slot_right_4540 = gc_frame_newslot(strlit4541);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4543 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4544 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4543);
// compiled call node returning call4544 (depth = 9)
// compiled member node returning call4544 (depth = 8)
  int op_slot_left_4540 = gc_frame_newslot(call4544);
  params[0] = strlit4541;
  partcv[0] = 1;
  Object opresult4545 = callmethod(call4544, "!=", 1, partcv, params);
// compiled op node returning opresult4545 (depth = 7)
  Object if4539 = done;
  if (istrue(opresult4545)) {
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4546 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4547 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4546);
// compiled call node returning call4547 (depth = 8)
// compiled member node returning call4547 (depth = 7)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4548 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4550 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4549);
// compiled call node returning call4550 (depth = 11)
// compiled member node returning call4550 (depth = 10)
  partcv[0] = 0;
  Object call4551 = callmethod(call4550, "new",
    1, partcv, params);
  gc_frame_end(callframe4548);
// compiled call node returning call4551 (depth = 9)
// compiled member node returning call4551 (depth = 8)
  *var_suggestion = call4551;
  if (call4551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4552 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4553 == NULL) {
    strlit4553 = alloc_String(")");
    gc_root(strlit4553);
  }
// compiled string node returning strlit4553 (depth = 8)
  gc_frame_newslot(strlit4553);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4553;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4554 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4552);
// compiled call node returning call4554 (depth = 7)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4555 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4556 == NULL) {
    strlit4556 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4556);
  }
// compiled string node returning strlit4556 (depth = 8)
  gc_frame_newslot(strlit4556);
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4558 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4557);
// compiled call node returning call4558 (depth = 9)
// compiled member node returning call4558 (depth = 8)
  gc_frame_newslot(call4558);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4560 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4561 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4560);
// compiled call node returning call4561 (depth = 10)
// compiled member node returning call4561 (depth = 9)
  int op_slot_right_4559 = gc_frame_newslot(call4561);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4563 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4564 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4563);
// compiled call node returning call4564 (depth = 10)
// compiled member node returning call4564 (depth = 9)
  int op_slot_left_4559 = gc_frame_newslot(call4564);
  params[0] = call4561;
  partcv[0] = 1;
  Object sum4565 = callmethod(call4564, "+", 1, partcv, params);
// compiled op node returning sum4565 (depth = 8)
  gc_frame_newslot(sum4565);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4556;
  params[1] = call4558;
  params[2] = sum4565;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4566 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4555);
// compiled call node returning call4566 (depth = 7)
    gc_frame_newslot(call4566);
    if4539 = call4566;
  } else {
  }
// compiled if node returning if4539 (depth = 6)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4567 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4568 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4567);
// compiled call node returning call4568 (depth = 7)
// compiled member node returning call4568 (depth = 6)
    gc_frame_newslot(call4568);
    if4494 = call4568;
  } else {
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4569 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4570 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4571 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4570);
// compiled call node returning call4571 (depth = 10)
// compiled member node returning call4571 (depth = 9)
  partcv[0] = 0;
  Object call4572 = callmethod(call4571, "empty",
    1, partcv, params);
  gc_frame_end(callframe4569);
// compiled call node returning call4572 (depth = 8)
// compiled member node returning call4572 (depth = 7)
  *var_suggestions = call4572;
  if (call4572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4573 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4574 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4573);
// compiled call node returning call4574 (depth = 7)
  *var_nextTok = call4574;
  if (call4574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4575 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4577 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4576);
// compiled call node returning call4577 (depth = 10)
// compiled member node returning call4577 (depth = 9)
  partcv[0] = 0;
  Object call4578 = callmethod(call4577, "new",
    1, partcv, params);
  gc_frame_end(callframe4575);
// compiled call node returning call4578 (depth = 8)
// compiled member node returning call4578 (depth = 7)
  *var_suggestion = call4578;
  if (call4578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4581 = alloc_Boolean(0);
// compiled identifier node returning bool4581 (depth = 8)
  int op_slot_right_4580 = gc_frame_newslot(bool4581);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4580 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4581;
  partcv[0] = 1;
  Object opresult4583 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4583 (depth = 7)
  Object if4579 = done;
  if (istrue(opresult4583)) {
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4584 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4585 == NULL) {
    strlit4585 = alloc_String(" }");
    gc_root(strlit4585);
  }
// compiled string node returning strlit4585 (depth = 8)
  gc_frame_newslot(strlit4585);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4587 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4586);
// compiled call node returning call4587 (depth = 9)
// compiled member node returning call4587 (depth = 8)
  gc_frame_newslot(call4587);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4585;
  params[1] = call4587;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4588 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4584);
// compiled call node returning call4588 (depth = 7)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4589 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4590 == NULL) {
    strlit4590 = alloc_String(" {");
    gc_root(strlit4590);
  }
// compiled string node returning strlit4590 (depth = 8)
  gc_frame_newslot(strlit4590);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4590;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4591 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4589);
// compiled call node returning call4591 (depth = 7)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4592 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4593 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4592);
// compiled call node returning call4593 (depth = 7)
    gc_frame_newslot(call4593);
    if4579 = call4593;
  } else {
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4595 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4595 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4597 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4597 (depth = 8)
  Object if4594 = done;
  if (istrue(opresult4597)) {
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4598 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4599 == NULL) {
    strlit4599 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4599);
  }
// compiled string node returning strlit4599 (depth = 9)
  gc_frame_newslot(strlit4599);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4599;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4600 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4598);
// compiled call node returning call4600 (depth = 8)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4601 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4602 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4601);
// compiled call node returning call4602 (depth = 8)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4603 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4604 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4605 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4604);
// compiled call node returning call4605 (depth = 12)
// compiled member node returning call4605 (depth = 11)
  partcv[0] = 0;
  Object call4606 = callmethod(call4605, "new",
    1, partcv, params);
  gc_frame_end(callframe4603);
// compiled call node returning call4606 (depth = 10)
// compiled member node returning call4606 (depth = 9)
  *var_suggestion = call4606;
  if (call4606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4608 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4609 == NULL) {
    strlit4609 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4609);
  }
// compiled string node returning strlit4609 (depth = 9)
  gc_frame_newslot(strlit4609);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4609;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4610 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4608);
// compiled call node returning call4610 (depth = 8)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4611 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4612 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4611);
// compiled call node returning call4612 (depth = 8)
    gc_frame_newslot(call4612);
    if4594 = call4612;
  } else {
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4613 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4614 == NULL) {
    strlit4614 = alloc_String(" }");
    gc_root(strlit4614);
  }
// compiled string node returning strlit4614 (depth = 9)
  gc_frame_newslot(strlit4614);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4616 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4615);
// compiled call node returning call4616 (depth = 10)
// compiled member node returning call4616 (depth = 9)
  gc_frame_newslot(call4616);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4614;
  params[1] = call4616;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4617 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4613);
// compiled call node returning call4617 (depth = 8)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4618 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4619 == NULL) {
    strlit4619 = alloc_String(" {");
    gc_root(strlit4619);
  }
// compiled string node returning strlit4619 (depth = 9)
  gc_frame_newslot(strlit4619);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4619;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4620 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4618);
// compiled call node returning call4620 (depth = 8)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4621 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4622 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4621);
// compiled call node returning call4622 (depth = 8)
    gc_frame_newslot(call4622);
    if4594 = call4622;
  }
// compiled if node returning if4594 (depth = 7)
    gc_frame_newslot(if4594);
    if4579 = if4594;
  }
// compiled if node returning if4579 (depth = 6)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4623 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4624 == NULL) {
    strlit4624 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4624);
  }
// compiled string node returning strlit4624 (depth = 7)
  gc_frame_newslot(strlit4624);
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4625 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4626 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4625);
// compiled call node returning call4626 (depth = 8)
// compiled member node returning call4626 (depth = 7)
  gc_frame_newslot(call4626);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4628 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4627);
// compiled call node returning call4628 (depth = 8)
// compiled member node returning call4628 (depth = 7)
  gc_frame_newslot(call4628);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4624;
  params[1] = call4626;
  params[2] = call4628;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4629 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4623);
// compiled call node returning call4629 (depth = 6)
    gc_frame_newslot(call4629);
    if4494 = call4629;
  }
// compiled if node returning if4494 (depth = 5)
    gc_frame_newslot(if4494);
    if4488 = if4494;
  }
// compiled if node returning if4488 (depth = 4)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4630 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4632 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4631);
// compiled call node returning call4632 (depth = 6)
// compiled member node returning call4632 (depth = 5)
  gc_frame_newslot(call4632);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4632;
  partcv[0] = 1;
  Object call4633 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4630);
// compiled call node returning call4633 (depth = 4)
  gc_frame_end(frame);
  return call4633;
}
Object meth_parser_matchcase4271(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for matchcase (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for matchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_elsecase = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "elsecase");
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4273 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4276 == NULL) {
    strlit4276 = alloc_String("match");
    gc_root(strlit4276);
  }
// compiled string node returning strlit4276 (depth = 6)
  int op_slot_right_4275 = gc_frame_newslot(strlit4276);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4278 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4279 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4278);
// compiled call node returning call4279 (depth = 7)
// compiled member node returning call4279 (depth = 6)
  int op_slot_left_4275 = gc_frame_newslot(call4279);
  params[0] = strlit4276;
  partcv[0] = 1;
  Object opresult4280 = callmethod(call4279, "==", 1, partcv, params);
// compiled op node returning opresult4280 (depth = 5)
  int op_slot_right_4274 = gc_frame_newslot(opresult4280);
// starting to compile call node (depth = 5)
  int callframe4282 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4283 == NULL) {
    strlit4283 = alloc_String("identifier");
    gc_root(strlit4283);
  }
// compiled string node returning strlit4283 (depth = 6)
  gc_frame_newslot(strlit4283);
// call case 4: self request
  params[0] = strlit4283;
  partcv[0] = 1;
  Object call4284 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4282);
// compiled call node returning call4284 (depth = 5)
  int op_slot_left_4274 = gc_frame_newslot(call4284);
  params[0] = opresult4280;
  partcv[0] = 1;
  Object opresult4285 = callmethod(call4284, "&&", 1, partcv, params);
// compiled op node returning opresult4285 (depth = 4)
  partcv[0] = 0;
  Object call4286 = callmethod(opresult4285, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4273);
// compiled call node returning call4286 (depth = 3)
  Object if4272 = done;
  if (istrue(call4286)) {
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4287 = alloc_Float64(0);
// compiled num node returning num4287 (depth = 4)
  return num4287;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4272 = undefined;
  } else {
  }
// compiled if node returning if4272 (depth = 2)
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4288 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4289 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4288);
// compiled call node returning call4289 (depth = 3)
// compiled member node returning call4289 (depth = 2)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4292 == NULL) {
    strlit4292 = alloc_String("lparen");
    gc_root(strlit4292);
  }
// compiled string node returning strlit4292 (depth = 4)
  int op_slot_right_4291 = gc_frame_newslot(strlit4292);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4294 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4295 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4294);
// compiled call node returning call4295 (depth = 5)
// compiled member node returning call4295 (depth = 4)
  int op_slot_left_4291 = gc_frame_newslot(call4295);
  params[0] = strlit4292;
  partcv[0] = 1;
  Object opresult4296 = callmethod(call4295, "!=", 1, partcv, params);
// compiled op node returning opresult4296 (depth = 3)
  Object if4290 = done;
  if (istrue(opresult4296)) {
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4297 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4299 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4298);
// compiled call node returning call4299 (depth = 7)
// compiled member node returning call4299 (depth = 6)
  partcv[0] = 0;
  Object call4300 = callmethod(call4299, "new",
    1, partcv, params);
  gc_frame_end(callframe4297);
// compiled call node returning call4300 (depth = 5)
// compiled member node returning call4300 (depth = 4)
  *var_suggestion = call4300;
  if (call4300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4301 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4302 = alloc_Block(NULL, NULL, "parser", 1320);
  gc_frame_newslot(block4302);
// method "_apply"
  block_savedest(block4302);
  Object closure4303 = createclosure(2, "_apply");
  setclosureframe(closure4303, stackframe);
  addtoclosure(closure4303, var_matchTok);
  addtoclosure(closure4303, selfslot);
  struct UserObject *uo4303 = (struct UserObject*)block4302;
  uo4303->data[0] = (Object)closure4303;
  Method *meth_meth_parser__apply4303 = addmethod2pos(block4302, "_apply", &meth_parser__apply4303, 0);
  int argcv_meth_parser__apply4303[] = {1};
  meth_meth_parser__apply4303->type = alloc_MethodType(1, argcv_meth_parser__apply4303);
  meth_meth_parser__apply4303->definitionModule = modulename;
  meth_meth_parser__apply4303->definitionLine = 1318;
// compiled block node returning block4302 (depth = 5)
  gc_frame_newslot(block4302);
// call case 4: self request
  params[0] = block4302;
  partcv[0] = 1;
  Object call4339 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4301);
// compiled call node returning call4339 (depth = 4)
  *var_nextTok = call4339;
  if (call4339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4342 = alloc_Boolean(0);
// compiled identifier node returning bool4342 (depth = 5)
  int op_slot_right_4341 = gc_frame_newslot(bool4342);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4341 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4342;
  partcv[0] = 1;
  Object opresult4344 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4344 (depth = 4)
  Object if4340 = done;
  if (istrue(opresult4344)) {
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4345 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4346 == NULL) {
    strlit4346 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4346);
  }
// compiled string node returning strlit4346 (depth = 5)
  gc_frame_newslot(strlit4346);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4346;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4347 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4345);
// compiled call node returning call4347 (depth = 4)
    gc_frame_newslot(call4347);
    if4340 = call4347;
  } else {
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4350 == NULL) {
    strlit4350 = alloc_String("rparen");
    gc_root(strlit4350);
  }
// compiled string node returning strlit4350 (depth = 6)
  int op_slot_right_4349 = gc_frame_newslot(strlit4350);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4352 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4353 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4352);
// compiled call node returning call4353 (depth = 7)
// compiled member node returning call4353 (depth = 6)
  int op_slot_left_4349 = gc_frame_newslot(call4353);
  params[0] = strlit4350;
  partcv[0] = 1;
  Object opresult4354 = callmethod(call4353, "==", 1, partcv, params);
// compiled op node returning opresult4354 (depth = 5)
  Object if4348 = done;
  if (istrue(opresult4354)) {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_4356 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4356 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4358 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4358 (depth = 6)
  Object if4355 = done;
  if (istrue(opresult4358)) {
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4359 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4360 == NULL) {
    strlit4360 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4360);
  }
// compiled string node returning strlit4360 (depth = 7)
  gc_frame_newslot(strlit4360);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4360;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4361 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4361 (depth = 6)
    gc_frame_newslot(call4361);
    if4355 = call4361;
  } else {
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4362 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4363 == NULL) {
    strlit4363 = alloc_String("(");
    gc_root(strlit4363);
  }
// compiled string node returning strlit4363 (depth = 7)
  gc_frame_newslot(strlit4363);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4363;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4364 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4362);
// compiled call node returning call4364 (depth = 6)
    gc_frame_newslot(call4364);
    if4355 = call4364;
  }
// compiled if node returning if4355 (depth = 5)
    gc_frame_newslot(if4355);
    if4348 = if4355;
  } else {
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4367 == NULL) {
    strlit4367 = alloc_String("identifier");
    gc_root(strlit4367);
  }
// compiled string node returning strlit4367 (depth = 7)
  int op_slot_right_4366 = gc_frame_newslot(strlit4367);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4370 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4369);
// compiled call node returning call4370 (depth = 8)
// compiled member node returning call4370 (depth = 7)
  int op_slot_left_4366 = gc_frame_newslot(call4370);
  params[0] = strlit4367;
  partcv[0] = 1;
  Object opresult4371 = callmethod(call4370, "==", 1, partcv, params);
// compiled op node returning opresult4371 (depth = 6)
  Object if4365 = done;
  if (istrue(opresult4371)) {
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4372 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4373 == NULL) {
    strlit4373 = alloc_String("(");
    gc_root(strlit4373);
  }
// compiled string node returning strlit4373 (depth = 7)
  gc_frame_newslot(strlit4373);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4373;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4374 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4372);
// compiled call node returning call4374 (depth = 6)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4375 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4376 == NULL) {
    strlit4376 = alloc_String(")");
    gc_root(strlit4376);
  }
// compiled string node returning strlit4376 (depth = 7)
  gc_frame_newslot(strlit4376);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4377 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4378 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4377);
// compiled call node returning call4378 (depth = 8)
// compiled member node returning call4378 (depth = 7)
  gc_frame_newslot(call4378);
// starting to compile identifier node (depth = 7)
  Object bool4379 = alloc_Boolean(1);
// compiled identifier node returning bool4379 (depth = 7)
  gc_frame_newslot(bool4379);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4376;
  params[1] = call4378;
  params[2] = bool4379;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4380 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4375);
// compiled call node returning call4380 (depth = 6)
    gc_frame_newslot(call4380);
    if4365 = call4380;
  } else {
  }
// compiled if node returning if4365 (depth = 5)
    gc_frame_newslot(if4365);
    if4348 = if4365;
  }
// compiled if node returning if4348 (depth = 4)
    gc_frame_newslot(if4348);
    if4340 = if4348;
  }
// compiled if node returning if4340 (depth = 3)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4381 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4382 == NULL) {
    strlit4382 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4382);
  }
// compiled string node returning strlit4382 (depth = 4)
  gc_frame_newslot(strlit4382);
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  partcv[0] = 0;
  Object call4384 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4383);
// compiled call node returning call4384 (depth = 5)
// compiled member node returning call4384 (depth = 4)
  gc_frame_newslot(call4384);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4386 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4387 = callmethod(*var_matchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4386);
// compiled call node returning call4387 (depth = 6)
// compiled member node returning call4387 (depth = 5)
  int op_slot_right_4385 = gc_frame_newslot(call4387);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4390 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4389);
// compiled call node returning call4390 (depth = 6)
// compiled member node returning call4390 (depth = 5)
  int op_slot_left_4385 = gc_frame_newslot(call4390);
  params[0] = call4387;
  partcv[0] = 1;
  Object sum4391 = callmethod(call4390, "+", 1, partcv, params);
// compiled op node returning sum4391 (depth = 4)
  gc_frame_newslot(sum4391);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4382;
  params[1] = call4384;
  params[2] = sum4391;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4392 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4381);
// compiled call node returning call4392 (depth = 3)
    gc_frame_newslot(call4392);
    if4290 = call4392;
  } else {
  }
// compiled if node returning if4290 (depth = 2)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4393 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4394 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4393);
// compiled call node returning call4394 (depth = 3)
// compiled member node returning call4394 (depth = 2)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4396 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe4397 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4398 = alloc_Block(NULL, NULL, "parser", 1338);
  gc_frame_newslot(block4398);
// method "_apply"
  block_savedest(block4398);
  Object closure4399 = createclosure(2, "_apply");
  setclosureframe(closure4399, stackframe);
  addtoclosure(closure4399, var_blocksOK);
  addtoclosure(closure4399, selfslot);
  struct UserObject *uo4399 = (struct UserObject*)block4398;
  uo4399->data[0] = (Object)closure4399;
  Method *meth_meth_parser__apply4399 = addmethod2pos(block4398, "_apply", &meth_parser__apply4399, 0);
  int argcv_meth_parser__apply4399[] = {0};
  meth_meth_parser__apply4399->type = alloc_MethodType(1, argcv_meth_parser__apply4399);
  meth_meth_parser__apply4399->definitionModule = modulename;
  meth_meth_parser__apply4399->definitionLine = 1338;
// compiled block node returning block4398 (depth = 6)
  gc_frame_newslot(block4398);
// call case 4: self request
  params[0] = block4398;
  partcv[0] = 1;
  Object call4403 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4397);
// compiled call node returning call4403 (depth = 5)
  partcv[0] = 0;
  Object call4404 = callmethod(call4403, "not",
    1, partcv, params);
  gc_frame_end(callframe4396);
// compiled call node returning call4404 (depth = 4)
// compiled member node returning call4404 (depth = 3)
  Object if4395 = done;
  if (istrue(call4404)) {
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4405 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4406 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4407 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4406);
// compiled call node returning call4407 (depth = 7)
// compiled member node returning call4407 (depth = 6)
  partcv[0] = 0;
  Object call4408 = callmethod(call4407, "new",
    1, partcv, params);
  gc_frame_end(callframe4405);
// compiled call node returning call4408 (depth = 5)
// compiled member node returning call4408 (depth = 4)
  *var_suggestion = call4408;
  if (call4408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4409 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array4410 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit4411 == NULL) {
    strlit4411 = alloc_String("rparen");
    gc_root(strlit4411);
  }
// compiled string node returning strlit4411 (depth = 6)
  params[0] = strlit4411;
  partcv[0] = 1;
  callmethod(array4410, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array4410 (depth = 5)
  gc_frame_newslot(array4410);
// call case 4: self request
  params[0] = array4410;
  partcv[0] = 1;
  Object call4412 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4409);
// compiled call node returning call4412 (depth = 4)
  *var_nextTok = call4412;
  if (call4412 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_4414 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4414 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4416 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4416 (depth = 4)
  Object if4413 = done;
  if (istrue(opresult4416)) {
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4417 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4418 == NULL) {
    strlit4418 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4418);
  }
// compiled string node returning strlit4418 (depth = 5)
  gc_frame_newslot(strlit4418);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4418;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4419 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4417);
// compiled call node returning call4419 (depth = 4)
    gc_frame_newslot(call4419);
    if4413 = call4419;
  } else {
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4420 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call4422 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4421);
// compiled call node returning call4422 (depth = 6)
// compiled member node returning call4422 (depth = 5)
  gc_frame_newslot(call4422);
// starting to compile identifier node (depth = 5)
  Object bool4423 = alloc_Boolean(1);
// compiled identifier node returning bool4423 (depth = 5)
  gc_frame_newslot(bool4423);
// starting to compile identifier node (depth = 5)
  Object bool4424 = alloc_Boolean(0);
// compiled identifier node returning bool4424 (depth = 5)
  gc_frame_newslot(bool4424);
// starting to compile string node (depth = 5)
  if (strlit4425 == NULL) {
    strlit4425 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4425);
  }
// compiled string node returning strlit4425 (depth = 5)
  gc_frame_newslot(strlit4425);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call4422;
  params[2] = bool4423;
  params[3] = bool4424;
  params[4] = strlit4425;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4426 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4420);
// compiled call node returning call4426 (depth = 4)
    gc_frame_newslot(call4426);
    if4413 = call4426;
  }
// compiled if node returning if4413 (depth = 3)
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4427 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4428 == NULL) {
    strlit4428 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4428);
  }
// compiled string node returning strlit4428 (depth = 4)
  gc_frame_newslot(strlit4428);
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4430 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4429);
// compiled call node returning call4430 (depth = 5)
// compiled member node returning call4430 (depth = 4)
  gc_frame_newslot(call4430);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4431 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4432 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4431);
// compiled call node returning call4432 (depth = 5)
// compiled member node returning call4432 (depth = 4)
  gc_frame_newslot(call4432);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4428;
  params[1] = call4430;
  params[2] = call4432;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4433 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4427);
// compiled call node returning call4433 (depth = 3)
    gc_frame_newslot(call4433);
    if4395 = call4433;
  } else {
  }
// compiled if node returning if4395 (depth = 2)
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4435 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4434);
// compiled call node returning call4435 (depth = 4)
// compiled member node returning call4435 (depth = 3)
  *var_matchee = call4435;
  if (call4435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4438 == NULL) {
    strlit4438 = alloc_String("rparen");
    gc_root(strlit4438);
  }
// compiled string node returning strlit4438 (depth = 4)
  int op_slot_right_4437 = gc_frame_newslot(strlit4438);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4441 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4440);
// compiled call node returning call4441 (depth = 5)
// compiled member node returning call4441 (depth = 4)
  int op_slot_left_4437 = gc_frame_newslot(call4441);
  params[0] = strlit4438;
  partcv[0] = 1;
  Object opresult4442 = callmethod(call4441, "!=", 1, partcv, params);
// compiled op node returning opresult4442 (depth = 3)
  Object if4436 = done;
  if (istrue(opresult4442)) {
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4443 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4444 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4443);
// compiled call node returning call4444 (depth = 4)
// compiled member node returning call4444 (depth = 3)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4445 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4447 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4446);
// compiled call node returning call4447 (depth = 7)
// compiled member node returning call4447 (depth = 6)
  partcv[0] = 0;
  Object call4448 = callmethod(call4447, "new",
    1, partcv, params);
  gc_frame_end(callframe4445);
// compiled call node returning call4448 (depth = 5)
// compiled member node returning call4448 (depth = 4)
  *var_suggestion = call4448;
  if (call4448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4449 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4450 == NULL) {
    strlit4450 = alloc_String(")");
    gc_root(strlit4450);
  }
// compiled string node returning strlit4450 (depth = 4)
  gc_frame_newslot(strlit4450);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit4450;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4451 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4449);
// compiled call node returning call4451 (depth = 3)
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4452 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4453 == NULL) {
    strlit4453 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4453);
  }
// compiled string node returning strlit4453 (depth = 4)
  gc_frame_newslot(strlit4453);
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4454 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4455 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4454);
// compiled call node returning call4455 (depth = 5)
// compiled member node returning call4455 (depth = 4)
  gc_frame_newslot(call4455);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4458 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4457);
// compiled call node returning call4458 (depth = 6)
// compiled member node returning call4458 (depth = 5)
  int op_slot_right_4456 = gc_frame_newslot(call4458);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4460 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4461 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4460);
// compiled call node returning call4461 (depth = 6)
// compiled member node returning call4461 (depth = 5)
  int op_slot_left_4456 = gc_frame_newslot(call4461);
  params[0] = call4458;
  partcv[0] = 1;
  Object sum4462 = callmethod(call4461, "+", 1, partcv, params);
// compiled op node returning sum4462 (depth = 4)
  gc_frame_newslot(sum4462);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4453;
  params[1] = call4455;
  params[2] = sum4462;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4463 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4452);
// compiled call node returning call4463 (depth = 3)
    gc_frame_newslot(call4463);
    if4436 = call4463;
  } else {
  }
// compiled if node returning if4436 (depth = 2)
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4465 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4464);
// compiled call node returning call4465 (depth = 3)
// compiled member node returning call4465 (depth = 2)
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4466 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4466 (depth = 3)
  *var_cases = array4466;
  if (array4466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4467 = alloc_Boolean(0);
// compiled identifier node returning bool4467 (depth = 3)
  *var_elsecase = bool4467;
  if (bool4467 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4468 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4469 = alloc_Block(NULL, NULL, "parser", 1360);
  gc_frame_newslot(block4469);
// method "_apply"
  block_savedest(block4469);
  Object closure4470 = createclosure(2, "_apply");
  setclosureframe(closure4470, stackframe);
  addtoclosure(closure4470, var_sym);
  addtoclosure(closure4470, selfslot);
  struct UserObject *uo4470 = (struct UserObject*)block4469;
  uo4470->data[0] = (Object)closure4470;
  Method *meth_meth_parser__apply4470 = addmethod2pos(block4469, "_apply", &meth_parser__apply4470, 0);
  int argcv_meth_parser__apply4470[] = {0};
  meth_meth_parser__apply4470->type = alloc_MethodType(1, argcv_meth_parser__apply4470);
  meth_meth_parser__apply4470->definitionModule = modulename;
  meth_meth_parser__apply4470->definitionLine = 1357;
// compiled block node returning block4469 (depth = 3)
  gc_frame_newslot(block4469);
// starting to compile block node (depth = 3)
  Object block4484 = alloc_Block(NULL, NULL, "parser", 1360);
  gc_frame_newslot(block4484);
// method "_apply"
  block_savedest(block4484);
  Object closure4485 = createclosure(8, "_apply");
  setclosureframe(closure4485, stackframe);
  addtoclosure(closure4485, var_blocksOK);
  addtoclosure(closure4485, var_errormessages);
  addtoclosure(closure4485, var_sym);
  addtoclosure(closure4485, var_lastToken);
  addtoclosure(closure4485, var_tokens);
  addtoclosure(closure4485, var_values);
  addtoclosure(closure4485, var_cases);
  addtoclosure(closure4485, selfslot);
  struct UserObject *uo4485 = (struct UserObject*)block4484;
  uo4485->data[0] = (Object)closure4485;
  Method *meth_meth_parser__apply4485 = addmethod2pos(block4484, "_apply", &meth_parser__apply4485, 0);
  int argcv_meth_parser__apply4485[] = {0};
  meth_meth_parser__apply4485->type = alloc_MethodType(1, argcv_meth_parser__apply4485);
  meth_meth_parser__apply4485->definitionModule = modulename;
  meth_meth_parser__apply4485->definitionLine = 1360;
// compiled block node returning block4484 (depth = 3)
  gc_frame_newslot(block4484);
// call case 5: prelude request
  params[0] = block4469;
  params[1] = block4484;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4635 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4468);
// compiled call node returning call4635 (depth = 2)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4636 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4638 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4637);
// compiled call node returning call4638 (depth = 4)
// compiled member node returning call4638 (depth = 3)
  gc_frame_newslot(call4638);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4639 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4640 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4639);
// compiled call node returning call4640 (depth = 4)
// compiled member node returning call4640 (depth = 3)
  gc_frame_newslot(call4640);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4638;
  params[1] = call4640;
  partcv[0] = 2;
  Object call4641 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4636);
// compiled call node returning call4641 (depth = 2)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4642 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4643 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase (depth = 4)
  gc_frame_newslot(*var_elsecase);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4645 = callmethod(*var_ast, "matchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4644);
// compiled call node returning call4645 (depth = 5)
// compiled member node returning call4645 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  params[2] = *var_elsecase;
  partcv[0] = 3;
  Object call4646 = callmethod(call4645, "new",
    1, partcv, params);
  gc_frame_end(callframe4643);
// compiled call node returning call4646 (depth = 3)
  gc_frame_newslot(call4646);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4646;
  partcv[0] = 1;
  Object call4647 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4642);
// compiled call node returning call4647 (depth = 2)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_term4649(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for term (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for term");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4650 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4652 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4651);
// compiled call node returning call4652 (depth = 4)
// compiled member node returning call4652 (depth = 3)
  gc_frame_newslot(call4652);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4653 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4654 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4653);
// compiled call node returning call4654 (depth = 4)
// compiled member node returning call4654 (depth = 3)
  gc_frame_newslot(call4654);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4652;
  params[1] = call4654;
  partcv[0] = 2;
  Object call4655 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4650);
// compiled call node returning call4655 (depth = 2)
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4657 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4658 == NULL) {
    strlit4658 = alloc_String("num");
    gc_root(strlit4658);
  }
// compiled string node returning strlit4658 (depth = 4)
  gc_frame_newslot(strlit4658);
// call case 4: self request
  params[0] = strlit4658;
  partcv[0] = 1;
  Object call4659 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4657);
// compiled call node returning call4659 (depth = 3)
  Object if4656 = done;
  if (istrue(call4659)) {
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4661 = callmethodflags(self, "pushnum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4660);
// compiled call node returning call4661 (depth = 4)
// compiled member node returning call4661 (depth = 3)
    gc_frame_newslot(call4661);
    if4656 = call4661;
  } else {
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4663 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4664 == NULL) {
    strlit4664 = alloc_String("string");
    gc_root(strlit4664);
  }
// compiled string node returning strlit4664 (depth = 5)
  gc_frame_newslot(strlit4664);
// call case 4: self request
  params[0] = strlit4664;
  partcv[0] = 1;
  Object call4665 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4663);
// compiled call node returning call4665 (depth = 4)
  Object if4662 = done;
  if (istrue(call4665)) {
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4667 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4666);
// compiled call node returning call4667 (depth = 5)
// compiled member node returning call4667 (depth = 4)
    gc_frame_newslot(call4667);
    if4662 = call4667;
  } else {
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4671 == NULL) {
    strlit4671 = alloc_String("match");
    gc_root(strlit4671);
  }
// compiled string node returning strlit4671 (depth = 7)
  int op_slot_right_4670 = gc_frame_newslot(strlit4671);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4674 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4673);
// compiled call node returning call4674 (depth = 8)
// compiled member node returning call4674 (depth = 7)
  int op_slot_left_4670 = gc_frame_newslot(call4674);
  params[0] = strlit4671;
  partcv[0] = 1;
  Object opresult4675 = callmethod(call4674, "==", 1, partcv, params);
// compiled op node returning opresult4675 (depth = 6)
  int op_slot_right_4669 = gc_frame_newslot(opresult4675);
// starting to compile call node (depth = 6)
  int callframe4677 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4678 == NULL) {
    strlit4678 = alloc_String("identifier");
    gc_root(strlit4678);
  }
// compiled string node returning strlit4678 (depth = 7)
  gc_frame_newslot(strlit4678);
// call case 4: self request
  params[0] = strlit4678;
  partcv[0] = 1;
  Object call4679 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4677);
// compiled call node returning call4679 (depth = 6)
  int op_slot_left_4669 = gc_frame_newslot(call4679);
  params[0] = opresult4675;
  partcv[0] = 1;
  Object opresult4680 = callmethod(call4679, "&&", 1, partcv, params);
// compiled op node returning opresult4680 (depth = 5)
  Object if4668 = done;
  if (istrue(opresult4680)) {
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4682 = callmethodflags(self, "matchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4681);
// compiled call node returning call4682 (depth = 6)
// compiled member node returning call4682 (depth = 5)
    gc_frame_newslot(call4682);
    if4668 = call4682;
  } else {
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4686 == NULL) {
    strlit4686 = alloc_String("try");
    gc_root(strlit4686);
  }
// compiled string node returning strlit4686 (depth = 8)
  int op_slot_right_4685 = gc_frame_newslot(strlit4686);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4689 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4688);
// compiled call node returning call4689 (depth = 9)
// compiled member node returning call4689 (depth = 8)
  int op_slot_left_4685 = gc_frame_newslot(call4689);
  params[0] = strlit4686;
  partcv[0] = 1;
  Object opresult4690 = callmethod(call4689, "==", 1, partcv, params);
// compiled op node returning opresult4690 (depth = 7)
  int op_slot_right_4684 = gc_frame_newslot(opresult4690);
// starting to compile call node (depth = 7)
  int callframe4692 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4693 == NULL) {
    strlit4693 = alloc_String("identifier");
    gc_root(strlit4693);
  }
// compiled string node returning strlit4693 (depth = 8)
  gc_frame_newslot(strlit4693);
// call case 4: self request
  params[0] = strlit4693;
  partcv[0] = 1;
  Object call4694 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4692);
// compiled call node returning call4694 (depth = 7)
  int op_slot_left_4684 = gc_frame_newslot(call4694);
  params[0] = opresult4690;
  partcv[0] = 1;
  Object opresult4695 = callmethod(call4694, "&&", 1, partcv, params);
// compiled op node returning opresult4695 (depth = 6)
  Object if4683 = done;
  if (istrue(opresult4695)) {
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4697 = callmethodflags(self, "trycatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4696);
// compiled call node returning call4697 (depth = 7)
// compiled member node returning call4697 (depth = 6)
    gc_frame_newslot(call4697);
    if4683 = call4697;
  } else {
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4699 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4700 == NULL) {
    strlit4700 = alloc_String("identifier");
    gc_root(strlit4700);
  }
// compiled string node returning strlit4700 (depth = 8)
  gc_frame_newslot(strlit4700);
// call case 4: self request
  params[0] = strlit4700;
  partcv[0] = 1;
  Object call4701 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4699);
// compiled call node returning call4701 (depth = 7)
  Object if4698 = done;
  if (istrue(call4701)) {
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4703 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4702);
// compiled call node returning call4703 (depth = 8)
// compiled member node returning call4703 (depth = 7)
    gc_frame_newslot(call4703);
    if4698 = call4703;
  } else {
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4705 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4706 == NULL) {
    strlit4706 = alloc_String("object");
    gc_root(strlit4706);
  }
// compiled string node returning strlit4706 (depth = 9)
  gc_frame_newslot(strlit4706);
// call case 4: self request
  params[0] = strlit4706;
  partcv[0] = 1;
  Object call4707 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4705);
// compiled call node returning call4707 (depth = 8)
  Object if4704 = done;
  if (istrue(call4707)) {
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4708 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4709 = callmethodflags(self, "doobject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4708);
// compiled call node returning call4709 (depth = 9)
// compiled member node returning call4709 (depth = 8)
    gc_frame_newslot(call4709);
    if4704 = call4709;
  } else {
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4711 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4712 == NULL) {
    strlit4712 = alloc_String("type");
    gc_root(strlit4712);
  }
// compiled string node returning strlit4712 (depth = 10)
  gc_frame_newslot(strlit4712);
// call case 4: self request
  params[0] = strlit4712;
  partcv[0] = 1;
  Object call4713 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4711);
// compiled call node returning call4713 (depth = 9)
  Object if4710 = done;
  if (istrue(call4713)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4715 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4714);
// compiled call node returning call4715 (depth = 10)
// compiled member node returning call4715 (depth = 9)
    gc_frame_newslot(call4715);
    if4710 = call4715;
  } else {
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe4717 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit4718 == NULL) {
    strlit4718 = alloc_String("lbrace");
    gc_root(strlit4718);
  }
// compiled string node returning strlit4718 (depth = 11)
  gc_frame_newslot(strlit4718);
// call case 4: self request
  params[0] = strlit4718;
  partcv[0] = 1;
  Object call4719 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4717);
// compiled call node returning call4719 (depth = 10)
  Object if4716 = done;
  if (istrue(call4719)) {
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4720 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4721 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4720);
// compiled call node returning call4721 (depth = 11)
// compiled member node returning call4721 (depth = 10)
    gc_frame_newslot(call4721);
    if4716 = call4721;
  } else {
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe4723 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit4724 == NULL) {
    strlit4724 = alloc_String("lsquare");
    gc_root(strlit4724);
  }
// compiled string node returning strlit4724 (depth = 12)
  gc_frame_newslot(strlit4724);
// call case 4: self request
  params[0] = strlit4724;
  partcv[0] = 1;
  Object call4725 = callmethodflags(self, "acceptAfterSpaces", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4723);
// compiled call node returning call4725 (depth = 11)
  Object if4722 = done;
  if (istrue(call4725)) {
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4727 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4726);
// compiled call node returning call4727 (depth = 12)
// compiled member node returning call4727 (depth = 11)
    gc_frame_newslot(call4727);
    if4722 = call4727;
  } else {
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4730 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit4731 == NULL) {
    strlit4731 = alloc_String("lsquare");
    gc_root(strlit4731);
  }
// compiled string node returning strlit4731 (depth = 14)
  gc_frame_newslot(strlit4731);
// call case 4: self request
  params[0] = strlit4731;
  partcv[0] = 1;
  Object call4732 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4730);
// compiled call node returning call4732 (depth = 13)
  int op_slot_right_4729 = gc_frame_newslot(call4732);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit4735 == NULL) {
    strlit4735 = alloc_String("identifier");
    gc_root(strlit4735);
  }
// compiled string node returning strlit4735 (depth = 14)
  int op_slot_right_4734 = gc_frame_newslot(strlit4735);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe4737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_lastToken (depth = 16)
  partcv[0] = 0;
  Object call4738 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe4737);
// compiled call node returning call4738 (depth = 15)
// compiled member node returning call4738 (depth = 14)
  int op_slot_left_4734 = gc_frame_newslot(call4738);
  params[0] = strlit4735;
  partcv[0] = 1;
  Object opresult4739 = callmethod(call4738, "!=", 1, partcv, params);
// compiled op node returning opresult4739 (depth = 13)
  int op_slot_left_4729 = gc_frame_newslot(opresult4739);
  params[0] = call4732;
  partcv[0] = 1;
  Object opresult4740 = callmethod(opresult4739, "&&", 1, partcv, params);
// compiled op node returning opresult4740 (depth = 12)
  Object if4728 = done;
  if (istrue(opresult4740)) {
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4741 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4742 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4741);
// compiled call node returning call4742 (depth = 13)
// compiled member node returning call4742 (depth = 12)
    gc_frame_newslot(call4742);
    if4728 = call4742;
  } else {
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe4744 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit4745 == NULL) {
    strlit4745 = alloc_String("op");
    gc_root(strlit4745);
  }
// compiled string node returning strlit4745 (depth = 14)
  gc_frame_newslot(strlit4745);
// call case 4: self request
  params[0] = strlit4745;
  partcv[0] = 1;
  Object call4746 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4744);
// compiled call node returning call4746 (depth = 13)
  Object if4743 = done;
  if (istrue(call4746)) {
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4748 = callmethodflags(self, "prefixop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4747);
// compiled call node returning call4748 (depth = 14)
// compiled member node returning call4748 (depth = 13)
    gc_frame_newslot(call4748);
    if4743 = call4748;
  } else {
  }
// compiled if node returning if4743 (depth = 12)
    gc_frame_newslot(if4743);
    if4728 = if4743;
  }
// compiled if node returning if4728 (depth = 11)
    gc_frame_newslot(if4728);
    if4722 = if4728;
  }
// compiled if node returning if4722 (depth = 10)
    gc_frame_newslot(if4722);
    if4716 = if4722;
  }
// compiled if node returning if4716 (depth = 9)
    gc_frame_newslot(if4716);
    if4710 = if4716;
  }
// compiled if node returning if4710 (depth = 8)
    gc_frame_newslot(if4710);
    if4704 = if4710;
  }
// compiled if node returning if4704 (depth = 7)
    gc_frame_newslot(if4704);
    if4698 = if4704;
  }
// compiled if node returning if4698 (depth = 6)
    gc_frame_newslot(if4698);
    if4683 = if4698;
  }
// compiled if node returning if4683 (depth = 5)
    gc_frame_newslot(if4683);
    if4668 = if4683;
  }
// compiled if node returning if4668 (depth = 4)
    gc_frame_newslot(if4668);
    if4662 = if4668;
  }
// compiled if node returning if4662 (depth = 3)
    gc_frame_newslot(if4662);
    if4656 = if4662;
  }
// compiled if node returning if4656 (depth = 2)
  gc_frame_end(frame);
  return if4656;
}
Object meth_parser__apply4775(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4776 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_acceptBlocks (depth = 9)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4777 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4776);
// compiled call node returning call4777 (depth = 8)
  gc_frame_end(frame);
  return call4777;
}
Object meth_parser_expression4749(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expression");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expression (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for expression");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4751 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe4750);
// compiled call node returning call4751 (depth = 4)
// compiled member node returning call4751 (depth = 3)
  *var_sz = call4751;
  if (call4751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4752 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4754 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4753);
// compiled call node returning call4754 (depth = 4)
// compiled member node returning call4754 (depth = 3)
  gc_frame_newslot(call4754);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4756 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4755);
// compiled call node returning call4756 (depth = 4)
// compiled member node returning call4756 (depth = 3)
  gc_frame_newslot(call4756);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4754;
  params[1] = call4756;
  partcv[0] = 2;
  Object call4757 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4752);
// compiled call node returning call4757 (depth = 2)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4759 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4760 == NULL) {
    strlit4760 = alloc_String("lparen");
    gc_root(strlit4760);
  }
// compiled string node returning strlit4760 (depth = 4)
  gc_frame_newslot(strlit4760);
// call case 4: self request
  params[0] = strlit4760;
  partcv[0] = 1;
  Object call4761 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4759);
// compiled call node returning call4761 (depth = 3)
  Object if4758 = done;
  if (istrue(call4761)) {
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4763 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4765 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4764);
// compiled call node returning call4765 (depth = 5)
// compiled member node returning call4765 (depth = 4)
  gc_frame_newslot(call4765);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4767 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4766);
// compiled call node returning call4767 (depth = 5)
// compiled member node returning call4767 (depth = 4)
  gc_frame_newslot(call4767);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call4765;
  params[1] = call4767;
  partcv[0] = 2;
  Object call4768 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4763);
// compiled call node returning call4768 (depth = 3)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4769 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4770 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4769);
// compiled call node returning call4770 (depth = 4)
// compiled member node returning call4770 (depth = 3)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4772 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4773 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4774 = alloc_Block(NULL, NULL, "parser", 1455);
  gc_frame_newslot(block4774);
// method "_apply"
  block_savedest(block4774);
  Object closure4775 = createclosure(2, "_apply");
  setclosureframe(closure4775, stackframe);
  addtoclosure(closure4775, var_acceptBlocks);
  addtoclosure(closure4775, selfslot);
  struct UserObject *uo4775 = (struct UserObject*)block4774;
  uo4775->data[0] = (Object)closure4775;
  Method *meth_meth_parser__apply4775 = addmethod2pos(block4774, "_apply", &meth_parser__apply4775, 0);
  int argcv_meth_parser__apply4775[] = {0};
  meth_meth_parser__apply4775->type = alloc_MethodType(1, argcv_meth_parser__apply4775);
  meth_meth_parser__apply4775->definitionModule = modulename;
  meth_meth_parser__apply4775->definitionLine = 1455;
// compiled block node returning block4774 (depth = 7)
  gc_frame_newslot(block4774);
// call case 4: self request
  params[0] = block4774;
  partcv[0] = 1;
  Object call4779 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4773);
// compiled call node returning call4779 (depth = 6)
  partcv[0] = 0;
  Object call4780 = callmethod(call4779, "not",
    1, partcv, params);
  gc_frame_end(callframe4772);
// compiled call node returning call4780 (depth = 5)
// compiled member node returning call4780 (depth = 4)
  Object if4771 = done;
  if (istrue(call4780)) {
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4781 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4782 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4783 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4782);
// compiled call node returning call4783 (depth = 8)
// compiled member node returning call4783 (depth = 7)
  partcv[0] = 0;
  Object call4784 = callmethod(call4783, "new",
    1, partcv, params);
  gc_frame_end(callframe4781);
// compiled call node returning call4784 (depth = 6)
// compiled member node returning call4784 (depth = 5)
  *var_suggestion = call4784;
  if (call4784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4785 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4786 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4787 == NULL) {
    strlit4787 = alloc_String("rparen");
    gc_root(strlit4787);
  }
// compiled string node returning strlit4787 (depth = 7)
  params[0] = strlit4787;
  partcv[0] = 1;
  callmethod(array4786, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array4786 (depth = 6)
  gc_frame_newslot(array4786);
// call case 4: self request
  params[0] = array4786;
  partcv[0] = 1;
  Object call4788 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4785);
// compiled call node returning call4788 (depth = 5)
  *var_nextTok = call4788;
  if (call4788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4790 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4790 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4792 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4792 (depth = 5)
  Object if4789 = done;
  if (istrue(opresult4792)) {
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4793 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4794 == NULL) {
    strlit4794 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4794);
  }
// compiled string node returning strlit4794 (depth = 6)
  gc_frame_newslot(strlit4794);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4794;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4795 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4793);
// compiled call node returning call4795 (depth = 5)
    gc_frame_newslot(call4795);
    if4789 = call4795;
  } else {
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4796 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4797 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4798 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4797);
// compiled call node returning call4798 (depth = 7)
// compiled member node returning call4798 (depth = 6)
  gc_frame_newslot(call4798);
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool4799 = alloc_Boolean(1);
// compiled identifier node returning bool4799 (depth = 6)
  gc_frame_newslot(bool4799);
// starting to compile identifier node (depth = 6)
  Object bool4800 = alloc_Boolean(0);
// compiled identifier node returning bool4800 (depth = 6)
  gc_frame_newslot(bool4800);
// starting to compile string node (depth = 6)
  if (strlit4801 == NULL) {
    strlit4801 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4801);
  }
// compiled string node returning strlit4801 (depth = 6)
  gc_frame_newslot(strlit4801);
// call case 6: other member request
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4798;
  params[2] = bool4799;
  params[3] = bool4800;
  params[4] = strlit4801;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4802 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4796);
// compiled call node returning call4802 (depth = 5)
    gc_frame_newslot(call4802);
    if4789 = call4802;
  }
// compiled if node returning if4789 (depth = 4)
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4803 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4804 == NULL) {
    strlit4804 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit4804);
  }
// compiled string node returning strlit4804 (depth = 5)
  gc_frame_newslot(strlit4804);
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4805 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4806 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4805);
// compiled call node returning call4806 (depth = 6)
// compiled member node returning call4806 (depth = 5)
  gc_frame_newslot(call4806);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4808 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4807);
// compiled call node returning call4808 (depth = 6)
// compiled member node returning call4808 (depth = 5)
  gc_frame_newslot(call4808);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4804;
  params[1] = call4806;
  params[2] = call4808;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4809 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4803);
// compiled call node returning call4809 (depth = 4)
    gc_frame_newslot(call4809);
    if4771 = call4809;
  } else {
  }
// compiled if node returning if4771 (depth = 3)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("rparen");
    gc_root(strlit4812);
  }
// compiled string node returning strlit4812 (depth = 5)
  int op_slot_right_4811 = gc_frame_newslot(strlit4812);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4815 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4814);
// compiled call node returning call4815 (depth = 6)
// compiled member node returning call4815 (depth = 5)
  int op_slot_left_4811 = gc_frame_newslot(call4815);
  params[0] = strlit4812;
  partcv[0] = 1;
  Object opresult4816 = callmethod(call4815, "!=", 1, partcv, params);
// compiled op node returning opresult4816 (depth = 4)
  Object if4810 = done;
  if (istrue(opresult4816)) {
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4817 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4818 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4817);
// compiled call node returning call4818 (depth = 5)
// compiled member node returning call4818 (depth = 4)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4819 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4821 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4820);
// compiled call node returning call4821 (depth = 8)
// compiled member node returning call4821 (depth = 7)
  partcv[0] = 0;
  Object call4822 = callmethod(call4821, "new",
    1, partcv, params);
  gc_frame_end(callframe4819);
// compiled call node returning call4822 (depth = 6)
// compiled member node returning call4822 (depth = 5)
  *var_suggestion = call4822;
  if (call4822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4823 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4824 == NULL) {
    strlit4824 = alloc_String(")");
    gc_root(strlit4824);
  }
// compiled string node returning strlit4824 (depth = 5)
  gc_frame_newslot(strlit4824);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4824;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4825 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4823);
// compiled call node returning call4825 (depth = 4)
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4826 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4827 == NULL) {
    strlit4827 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4827);
  }
// compiled string node returning strlit4827 (depth = 5)
  gc_frame_newslot(strlit4827);
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4828 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4829 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4828);
// compiled call node returning call4829 (depth = 6)
// compiled member node returning call4829 (depth = 5)
  gc_frame_newslot(call4829);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4832 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4831);
// compiled call node returning call4832 (depth = 7)
// compiled member node returning call4832 (depth = 6)
  int op_slot_right_4830 = gc_frame_newslot(call4832);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4835 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4834);
// compiled call node returning call4835 (depth = 7)
// compiled member node returning call4835 (depth = 6)
  int op_slot_left_4830 = gc_frame_newslot(call4835);
  params[0] = call4832;
  partcv[0] = 1;
  Object sum4836 = callmethod(call4835, "+", 1, partcv, params);
// compiled op node returning sum4836 (depth = 5)
  gc_frame_newslot(sum4836);
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4827;
  params[1] = call4829;
  params[2] = sum4836;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4837 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4826);
// compiled call node returning call4837 (depth = 4)
    gc_frame_newslot(call4837);
    if4810 = call4837;
  } else {
  }
// compiled if node returning if4810 (depth = 3)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4839 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4840 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4839);
// compiled call node returning call4840 (depth = 4)
// compiled member node returning call4840 (depth = 3)
    gc_frame_newslot(call4840);
    if4758 = call4840;
  } else {
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4842 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4841);
// compiled call node returning call4842 (depth = 4)
// compiled member node returning call4842 (depth = 3)
    gc_frame_newslot(call4842);
    if4758 = call4842;
  }
// compiled if node returning if4758 (depth = 2)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_4844 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4846 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4847 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe4846);
// compiled call node returning call4847 (depth = 5)
// compiled member node returning call4847 (depth = 4)
  int op_slot_left_4844 = gc_frame_newslot(call4847);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult4848 = callmethod(call4847, ">", 1, partcv, params);
// compiled op node returning opresult4848 (depth = 3)
  Object if4843 = done;
  if (istrue(opresult4848)) {
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4849 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4850 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4849);
// compiled call node returning call4850 (depth = 3)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4851 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4852 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4851);
// compiled call node returning call4852 (depth = 3)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4854 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4853);
// compiled call node returning call4854 (depth = 4)
// compiled member node returning call4854 (depth = 3)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4856 = callmethodflags(self, "valueexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4855);
// compiled call node returning call4856 (depth = 4)
// compiled member node returning call4856 (depth = 3)
    gc_frame_newslot(call4856);
    if4843 = call4856;
  } else {
  }
// compiled if node returning if4843 (depth = 2)
  gc_frame_end(frame);
  return if4843;
}
Object meth_parser__apply4870(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4871 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4872 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4871);
// compiled call node returning call4872 (depth = 8)
  gc_frame_end(frame);
  return call4872;
}
Object meth_parser_postfixsquare4857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "postfixsquare");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postfixsquare (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for postfixsquare");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_index = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "index");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4859 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4860 == NULL) {
    strlit4860 = alloc_String("lsquare");
    gc_root(strlit4860);
  }
// compiled string node returning strlit4860 (depth = 4)
  gc_frame_newslot(strlit4860);
// call case 4: self request
  params[0] = strlit4860;
  partcv[0] = 1;
  Object call4861 = callmethodflags(self, "acceptWithoutSpaces", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4859);
// compiled call node returning call4861 (depth = 3)
  Object if4858 = done;
  if (istrue(call4861)) {
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4862 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4863 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4862);
// compiled call node returning call4863 (depth = 4)
// compiled member node returning call4863 (depth = 3)
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4865 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4864);
// compiled call node returning call4865 (depth = 5)
// compiled member node returning call4865 (depth = 4)
  *var_expr = call4865;
  if (call4865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4867 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4868 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4869 = alloc_Block(NULL, NULL, "parser", 1494);
  gc_frame_newslot(block4869);
// method "_apply"
  block_savedest(block4869);
  Object closure4870 = createclosure(2, "_apply");
  setclosureframe(closure4870, stackframe);
  addtoclosure(closure4870, var_blocksOK);
  addtoclosure(closure4870, selfslot);
  struct UserObject *uo4870 = (struct UserObject*)block4869;
  uo4870->data[0] = (Object)closure4870;
  Method *meth_meth_parser__apply4870 = addmethod2pos(block4869, "_apply", &meth_parser__apply4870, 0);
  int argcv_meth_parser__apply4870[] = {0};
  meth_meth_parser__apply4870->type = alloc_MethodType(1, argcv_meth_parser__apply4870);
  meth_meth_parser__apply4870->definitionModule = modulename;
  meth_meth_parser__apply4870->definitionLine = 1494;
// compiled block node returning block4869 (depth = 7)
  gc_frame_newslot(block4869);
// call case 4: self request
  params[0] = block4869;
  partcv[0] = 1;
  Object call4874 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4868);
// compiled call node returning call4874 (depth = 6)
  partcv[0] = 0;
  Object call4875 = callmethod(call4874, "not",
    1, partcv, params);
  gc_frame_end(callframe4867);
// compiled call node returning call4875 (depth = 5)
// compiled member node returning call4875 (depth = 4)
  Object if4866 = done;
  if (istrue(call4875)) {
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4876 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4877 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4878 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4877);
// compiled call node returning call4878 (depth = 8)
// compiled member node returning call4878 (depth = 7)
  partcv[0] = 0;
  Object call4879 = callmethod(call4878, "empty",
    1, partcv, params);
  gc_frame_end(callframe4876);
// compiled call node returning call4879 (depth = 6)
// compiled member node returning call4879 (depth = 5)
  *var_suggestions = call4879;
  if (call4879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4880 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4881 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4882 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4881);
// compiled call node returning call4882 (depth = 8)
// compiled member node returning call4882 (depth = 7)
  partcv[0] = 0;
  Object call4883 = callmethod(call4882, "new",
    1, partcv, params);
  gc_frame_end(callframe4880);
// compiled call node returning call4883 (depth = 6)
// compiled member node returning call4883 (depth = 5)
  *var_suggestion = call4883;
  if (call4883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4884 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4885 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4886 == NULL) {
    strlit4886 = alloc_String("rsquare");
    gc_root(strlit4886);
  }
// compiled string node returning strlit4886 (depth = 7)
  params[0] = strlit4886;
  partcv[0] = 1;
  callmethod(array4885, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array4885 (depth = 6)
  gc_frame_newslot(array4885);
// call case 4: self request
  params[0] = array4885;
  partcv[0] = 1;
  Object call4887 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4884);
// compiled call node returning call4887 (depth = 5)
  *var_nextTok = call4887;
  if (call4887 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4889 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4889 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4891 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4891 (depth = 5)
  Object if4888 = done;
  if (istrue(opresult4891)) {
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4892 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4893 == NULL) {
    strlit4893 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit4893);
  }
// compiled string node returning strlit4893 (depth = 6)
  gc_frame_newslot(strlit4893);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4893;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4894 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4892);
// compiled call node returning call4894 (depth = 5)
    gc_frame_newslot(call4894);
    if4888 = call4894;
  } else {
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4895 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4896 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4897 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4896);
// compiled call node returning call4897 (depth = 7)
// compiled member node returning call4897 (depth = 6)
  gc_frame_newslot(call4897);
// starting to compile identifier node (depth = 6)
  Object bool4898 = alloc_Boolean(1);
// compiled identifier node returning bool4898 (depth = 6)
  gc_frame_newslot(bool4898);
// starting to compile identifier node (depth = 6)
  Object bool4899 = alloc_Boolean(0);
// compiled identifier node returning bool4899 (depth = 6)
  gc_frame_newslot(bool4899);
// starting to compile string node (depth = 6)
  if (strlit4900 == NULL) {
    strlit4900 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit4900);
  }
// compiled string node returning strlit4900 (depth = 6)
  gc_frame_newslot(strlit4900);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4897;
  params[2] = bool4898;
  params[3] = bool4899;
  params[4] = strlit4900;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4901 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4895);
// compiled call node returning call4901 (depth = 5)
    gc_frame_newslot(call4901);
    if4888 = call4901;
  }
// compiled if node returning if4888 (depth = 4)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4902 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4903 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4902);
// compiled call node returning call4903 (depth = 4)
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4906 == NULL) {
    strlit4906 = alloc_String("rsquare");
    gc_root(strlit4906);
  }
// compiled string node returning strlit4906 (depth = 6)
  int op_slot_right_4905 = gc_frame_newslot(strlit4906);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4909 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4908);
// compiled call node returning call4909 (depth = 7)
// compiled member node returning call4909 (depth = 6)
  int op_slot_left_4905 = gc_frame_newslot(call4909);
  params[0] = strlit4906;
  partcv[0] = 1;
  Object opresult4910 = callmethod(call4909, "==", 1, partcv, params);
// compiled op node returning opresult4910 (depth = 5)
  Object if4904 = done;
  if (istrue(opresult4910)) {
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4911 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4913 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4912);
// compiled call node returning call4913 (depth = 9)
// compiled member node returning call4913 (depth = 8)
  partcv[0] = 0;
  Object call4914 = callmethod(call4913, "new",
    1, partcv, params);
  gc_frame_end(callframe4911);
// compiled call node returning call4914 (depth = 7)
// compiled member node returning call4914 (depth = 6)
  *var_suggestion = call4914;
  if (call4914 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4916 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool4917 = alloc_Boolean(1);
// compiled identifier node returning bool4917 (depth = 6)
  gc_frame_newslot(bool4917);
// starting to compile identifier node (depth = 6)
  Object bool4918 = alloc_Boolean(0);
// compiled identifier node returning bool4918 (depth = 6)
  gc_frame_newslot(bool4918);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = *var_nextTok;
  params[2] = bool4917;
  params[3] = bool4918;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4919 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe4916);
// compiled call node returning call4919 (depth = 5)
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4920 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4921 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4920);
// compiled call node returning call4921 (depth = 5)
    gc_frame_newslot(call4921);
    if4904 = call4921;
  } else {
  }
// compiled if node returning if4904 (depth = 4)
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4922 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4923 == NULL) {
    strlit4923 = alloc_String("a '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit4923);
  }
// compiled string node returning strlit4923 (depth = 5)
  gc_frame_newslot(strlit4923);
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4925 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4924);
// compiled call node returning call4925 (depth = 6)
// compiled member node returning call4925 (depth = 5)
  gc_frame_newslot(call4925);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4926 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4927 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4926);
// compiled call node returning call4927 (depth = 6)
// compiled member node returning call4927 (depth = 5)
  gc_frame_newslot(call4927);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4923;
  params[1] = call4925;
  params[2] = call4927;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4928 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4922);
// compiled call node returning call4928 (depth = 4)
    gc_frame_newslot(call4928);
    if4866 = call4928;
  } else {
  }
// compiled if node returning if4866 (depth = 3)
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4929 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4930 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4929);
// compiled call node returning call4930 (depth = 5)
// compiled member node returning call4930 (depth = 4)
  *var_index = call4930;
  if (call4930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4933 == NULL) {
    strlit4933 = alloc_String("rsquare");
    gc_root(strlit4933);
  }
// compiled string node returning strlit4933 (depth = 5)
  int op_slot_right_4932 = gc_frame_newslot(strlit4933);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4936 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4935);
// compiled call node returning call4936 (depth = 6)
// compiled member node returning call4936 (depth = 5)
  int op_slot_left_4932 = gc_frame_newslot(call4936);
  params[0] = strlit4933;
  partcv[0] = 1;
  Object opresult4937 = callmethod(call4936, "!=", 1, partcv, params);
// compiled op node returning opresult4937 (depth = 4)
  Object if4931 = done;
  if (istrue(opresult4937)) {
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4938 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4940 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4939);
// compiled call node returning call4940 (depth = 8)
// compiled member node returning call4940 (depth = 7)
  partcv[0] = 0;
  Object call4941 = callmethod(call4940, "new",
    1, partcv, params);
  gc_frame_end(callframe4938);
// compiled call node returning call4941 (depth = 6)
// compiled member node returning call4941 (depth = 5)
  *var_suggestion = call4941;
  if (call4941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4942 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4943 == NULL) {
    strlit4943 = alloc_String("]");
    gc_root(strlit4943);
  }
// compiled string node returning strlit4943 (depth = 5)
  gc_frame_newslot(strlit4943);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4943;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4944 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4942);
// compiled call node returning call4944 (depth = 4)
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4945 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4946 == NULL) {
    strlit4946 = alloc_String("a '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit4946);
  }
// compiled string node returning strlit4946 (depth = 5)
  gc_frame_newslot(strlit4946);
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4948 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4947);
// compiled call node returning call4948 (depth = 6)
// compiled member node returning call4948 (depth = 5)
  gc_frame_newslot(call4948);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4951 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4950);
// compiled call node returning call4951 (depth = 7)
// compiled member node returning call4951 (depth = 6)
  int op_slot_right_4949 = gc_frame_newslot(call4951);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4954 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4953);
// compiled call node returning call4954 (depth = 7)
// compiled member node returning call4954 (depth = 6)
  int op_slot_left_4949 = gc_frame_newslot(call4954);
  params[0] = call4951;
  partcv[0] = 1;
  Object sum4955 = callmethod(call4954, "+", 1, partcv, params);
// compiled op node returning sum4955 (depth = 5)
  gc_frame_newslot(sum4955);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4946;
  params[1] = call4948;
  params[2] = sum4955;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4956 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4945);
// compiled call node returning call4956 (depth = 4)
    gc_frame_newslot(call4956);
    if4931 = call4956;
  } else {
  }
// compiled if node returning if4931 (depth = 3)
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4957 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4958 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4957);
// compiled call node returning call4958 (depth = 4)
// compiled member node returning call4958 (depth = 3)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4959 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_index (depth = 5)
  gc_frame_newslot(*var_index);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4960 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call4961 = callmethod(*var_ast, "indexNode",
    1, partcv, params);
  gc_frame_end(callframe4960);
// compiled call node returning call4961 (depth = 6)
// compiled member node returning call4961 (depth = 5)
  params[0] = *var_expr;
  params[1] = *var_index;
  partcv[0] = 2;
  Object call4962 = callmethod(call4961, "new",
    1, partcv, params);
  gc_frame_end(callframe4959);
// compiled call node returning call4962 (depth = 4)
  *var_o = call4962;
  if (call4962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4963 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4964 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4963);
// compiled call node returning call4964 (depth = 3)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4965 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4966 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4965);
// compiled call node returning call4966 (depth = 3)
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4967 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4968 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4967);
// compiled call node returning call4968 (depth = 3)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4970 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4969);
// compiled call node returning call4970 (depth = 4)
// compiled member node returning call4970 (depth = 3)
    gc_frame_newslot(call4970);
    if4858 = call4970;
  } else {
  }
// compiled if node returning if4858 (depth = 2)
  gc_frame_end(frame);
  return if4858;
}
Object meth_parser_oprec4971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method oprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for oprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4974 == NULL) {
    strlit4974 = alloc_String("*");
    gc_root(strlit4974);
  }
// compiled string node returning strlit4974 (depth = 4)
  int op_slot_right_4973 = gc_frame_newslot(strlit4974);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_4973 = gc_frame_newslot(*var_o);
  params[0] = strlit4974;
  partcv[0] = 1;
  Object opresult4976 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult4976 (depth = 3)
  Object if4972 = done;
  if (istrue(opresult4976)) {
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4977 = alloc_Float64(10);
// compiled num node returning num4977 (depth = 4)
  return num4977;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4972 = undefined;
  } else {
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4980 == NULL) {
    strlit4980 = alloc_String("/");
    gc_root(strlit4980);
  }
// compiled string node returning strlit4980 (depth = 5)
  int op_slot_right_4979 = gc_frame_newslot(strlit4980);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_4979 = gc_frame_newslot(*var_o);
  params[0] = strlit4980;
  partcv[0] = 1;
  Object opresult4982 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult4982 (depth = 4)
  Object if4978 = done;
  if (istrue(opresult4982)) {
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4983 = alloc_Float64(10);
// compiled num node returning num4983 (depth = 5)
  return num4983;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4978 = undefined;
  } else {
  }
// compiled if node returning if4978 (depth = 3)
    gc_frame_newslot(if4978);
    if4972 = if4978;
  }
// compiled if node returning if4972 (depth = 2)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4984 = alloc_Float64(5);
// compiled num node returning num4984 (depth = 3)
  return num4984;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_toprec4985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4988 = alloc_Float64(0);
// compiled num node returning num4988 (depth = 4)
  int op_slot_right_4987 = gc_frame_newslot(num4988);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4990 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call4991 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe4990);
// compiled call node returning call4991 (depth = 5)
// compiled member node returning call4991 (depth = 4)
  int op_slot_left_4987 = gc_frame_newslot(call4991);
  params[0] = num4988;
  partcv[0] = 1;
  Object opresult4992 = callmethod(call4991, ">", 1, partcv, params);
// compiled op node returning opresult4992 (depth = 3)
  Object if4986 = done;
  if (istrue(opresult4992)) {
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call4994 = callmethod(*var_ops, "last",
    1, partcv, params);
  gc_frame_end(callframe4993);
// compiled call node returning call4994 (depth = 5)
// compiled member node returning call4994 (depth = 4)
  *var_o = call4994;
  if (call4994 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4995 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4996 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4995);
// compiled call node returning call4996 (depth = 4)
  return call4996;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4986 = undefined;
  } else {
  }
// compiled if node returning if4986 (depth = 2)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4997 = alloc_Float64(0);
// compiled num node returning num4997 (depth = 2)
  gc_frame_end(frame);
  return num4997;
}
Object meth_parser__apply5006(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5007 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5008 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5007);
// compiled call node returning call5008 (depth = 6)
// compiled member node returning call5008 (depth = 5)
  gc_frame_end(frame);
  return call5008;
}
Object meth_parser_typeexpressionrest4998(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5000 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5001 == NULL) {
    strlit5001 = alloc_String("op");
    gc_root(strlit5001);
  }
// compiled string node returning strlit5001 (depth = 4)
  gc_frame_newslot(strlit5001);
// call case 4: self request
  params[0] = strlit5001;
  partcv[0] = 1;
  Object call5002 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5000);
// compiled call node returning call5002 (depth = 3)
  Object if4999 = done;
  if (istrue(call5002)) {
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5003 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5004 == NULL) {
    strlit5004 = alloc_String("type expression");
    gc_root(strlit5004);
  }
// compiled string node returning strlit5004 (depth = 4)
  gc_frame_newslot(strlit5004);
// starting to compile block node (depth = 4)
  Object block5005 = alloc_Block(NULL, NULL, "parser", 1552);
  gc_frame_newslot(block5005);
// method "_apply"
  block_savedest(block5005);
  Object closure5006 = createclosure(1, "_apply");
  setclosureframe(closure5006, stackframe);
  addtoclosure(closure5006, selfslot);
  struct UserObject *uo5006 = (struct UserObject*)block5005;
  uo5006->data[0] = (Object)closure5006;
  Method *meth_meth_parser__apply5006 = addmethod2pos(block5005, "_apply", &meth_parser__apply5006, 0);
  int argcv_meth_parser__apply5006[] = {0};
  meth_meth_parser__apply5006->type = alloc_MethodType(1, argcv_meth_parser__apply5006);
  meth_meth_parser__apply5006->definitionModule = modulename;
  meth_meth_parser__apply5006->definitionLine = 1543;
// compiled block node returning block5005 (depth = 4)
  gc_frame_newslot(block5005);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = strlit5004;
  params[1] = block5005;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5010 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5003);
// compiled call node returning call5010 (depth = 3)
    gc_frame_newslot(call5010);
    if4999 = call5010;
  } else {
  }
// compiled if node returning if4999 (depth = 2)
  gc_frame_end(frame);
  return if4999;
}
Object meth_parser__apply5019(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5020 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5021 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5020);
// compiled call node returning call5021 (depth = 5)
  gc_frame_end(frame);
  return call5021;
}
Object meth_parser_valueexpressionrest5011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valueexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for valueexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5013 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5014 == NULL) {
    strlit5014 = alloc_String("op");
    gc_root(strlit5014);
  }
// compiled string node returning strlit5014 (depth = 4)
  gc_frame_newslot(strlit5014);
// call case 4: self request
  params[0] = strlit5014;
  partcv[0] = 1;
  Object call5015 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5013);
// compiled call node returning call5015 (depth = 3)
  Object if5012 = done;
  if (istrue(call5015)) {
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5016 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5017 == NULL) {
    strlit5017 = alloc_String("expression");
    gc_root(strlit5017);
  }
// compiled string node returning strlit5017 (depth = 4)
  gc_frame_newslot(strlit5017);
// starting to compile block node (depth = 4)
  Object block5018 = alloc_Block(NULL, NULL, "parser", 1558);
  gc_frame_newslot(block5018);
// method "_apply"
  block_savedest(block5018);
  Object closure5019 = createclosure(2, "_apply");
  setclosureframe(closure5019, stackframe);
  addtoclosure(closure5019, var_blocksOK);
  addtoclosure(closure5019, selfslot);
  struct UserObject *uo5019 = (struct UserObject*)block5018;
  uo5019->data[0] = (Object)closure5019;
  Method *meth_meth_parser__apply5019 = addmethod2pos(block5018, "_apply", &meth_parser__apply5019, 0);
  int argcv_meth_parser__apply5019[] = {0};
  meth_meth_parser__apply5019->type = alloc_MethodType(1, argcv_meth_parser__apply5019);
  meth_meth_parser__apply5019->definitionModule = modulename;
  meth_meth_parser__apply5019->definitionLine = 1552;
// compiled block node returning block5018 (depth = 4)
  gc_frame_newslot(block5018);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = strlit5017;
  params[1] = block5018;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5023 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5016);
// compiled call node returning call5023 (depth = 3)
    gc_frame_newslot(call5023);
    if5012 = call5023;
  } else {
  }
// compiled if node returning if5012 (depth = 2)
  gc_frame_end(frame);
  return if5012;
}
Object meth_parser__apply5039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5041 == NULL) {
    strlit5041 = alloc_String("=");
    gc_root(strlit5041);
  }
// compiled string node returning strlit5041 (depth = 7)
  int op_slot_right_5040 = gc_frame_newslot(strlit5041);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5043 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5044 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5043);
// compiled call node returning call5044 (depth = 8)
// compiled member node returning call5044 (depth = 7)
  int op_slot_left_5040 = gc_frame_newslot(call5044);
  params[0] = strlit5041;
  partcv[0] = 1;
  Object opresult5045 = callmethod(call5044, "!=", 1, partcv, params);
// compiled op node returning opresult5045 (depth = 6)
  gc_frame_end(frame);
  return opresult5045;
}
Object meth_parser__apply5036(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5037 = gc_frame_new();
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5038 = alloc_Block(NULL, NULL, "parser", 1580);
  gc_frame_newslot(block5038);
// method "_apply"
  block_savedest(block5038);
  Object closure5039 = createclosure(2, "_apply");
  setclosureframe(closure5039, stackframe);
  addtoclosure(closure5039, var_sym);
  addtoclosure(closure5039, selfslot);
  struct UserObject *uo5039 = (struct UserObject*)block5038;
  uo5039->data[0] = (Object)closure5039;
  Method *meth_meth_parser__apply5039 = addmethod2pos(block5038, "_apply", &meth_parser__apply5039, 0);
  int argcv_meth_parser__apply5039[] = {0};
  meth_meth_parser__apply5039->type = alloc_MethodType(1, argcv_meth_parser__apply5039);
  meth_meth_parser__apply5039->definitionModule = modulename;
  meth_meth_parser__apply5039->definitionLine = 1573;
// compiled block node returning block5038 (depth = 5)
  gc_frame_newslot(block5038);
// call case 6: other member request
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5047 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5048 == NULL) {
    strlit5048 = alloc_String("op");
    gc_root(strlit5048);
  }
// compiled string node returning strlit5048 (depth = 6)
  gc_frame_newslot(strlit5048);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 4: self request
  params[0] = strlit5048;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5049 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5047);
// compiled call node returning call5049 (depth = 5)
  params[0] = block5038;
  partcv[0] = 1;
  Object call5050 = callmethod(call5049, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5037);
// compiled call node returning call5050 (depth = 4)
  gc_frame_end(frame);
  return call5050;
}
Object meth_parser__apply5164(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5167 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 4: self request
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call5168 = callmethodflags(self, "toprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5167);
// compiled call node returning call5168 (depth = 8)
  int op_slot_right_5166 = gc_frame_newslot(call5168);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_5166 = gc_frame_newslot(*var_prec);
  params[0] = call5168;
  partcv[0] = 1;
  Object opresult5170 = callmethod(*var_prec, "<=", 1, partcv, params);
// compiled op node returning opresult5170 (depth = 7)
  int op_slot_right_5165 = gc_frame_newslot(opresult5170);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5173 = alloc_Float64(0);
// compiled num node returning num5173 (depth = 8)
  int op_slot_right_5172 = gc_frame_newslot(num5173);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ops (depth = 10)
  partcv[0] = 0;
  Object call5176 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5175);
// compiled call node returning call5176 (depth = 9)
// compiled member node returning call5176 (depth = 8)
  int op_slot_left_5172 = gc_frame_newslot(call5176);
  params[0] = num5173;
  partcv[0] = 1;
  Object opresult5177 = callmethod(call5176, ">", 1, partcv, params);
// compiled op node returning opresult5177 (depth = 7)
  int op_slot_left_5165 = gc_frame_newslot(opresult5177);
  params[0] = opresult5170;
  partcv[0] = 1;
  Object opresult5178 = callmethod(opresult5177, "&&", 1, partcv, params);
// compiled op node returning opresult5178 (depth = 6)
  gc_frame_end(frame);
  return opresult5178;
}
Object meth_parser__apply5181(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  partcv[0] = 0;
  Object call5183 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5182);
// compiled call node returning call5183 (depth = 8)
// compiled member node returning call5183 (depth = 7)
  *var_o2 = call5183;
  if (call5183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5186 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5185);
// compiled call node returning call5186 (depth = 8)
// compiled member node returning call5186 (depth = 7)
  *var_tmp2 = call5186;
  if (call5186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5189 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5188);
// compiled call node returning call5189 (depth = 8)
// compiled member node returning call5189 (depth = 7)
  *var_tmp = call5189;
  if (call5189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5191 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tmp (depth = 9)
  partcv[0] = 0;
  Object call5193 = callmethod(*var_tmp, "line",
    1, partcv, params);
  gc_frame_end(callframe5192);
// compiled call node returning call5193 (depth = 8)
// compiled member node returning call5193 (depth = 7)
  gc_frame_newslot(call5193);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5194 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tmp (depth = 9)
  partcv[0] = 0;
  Object call5195 = callmethod(*var_tmp, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5194);
// compiled call node returning call5195 (depth = 8)
// compiled member node returning call5195 (depth = 7)
  gc_frame_newslot(call5195);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call5193;
  params[1] = call5195;
  partcv[0] = 2;
  Object call5196 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5191);
// compiled call node returning call5196 (depth = 6)
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5197 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call5199 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5198);
// compiled call node returning call5199 (depth = 9)
// compiled member node returning call5199 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5200 = callmethod(call5199, "new",
    1, partcv, params);
  gc_frame_end(callframe5197);
// compiled call node returning call5200 (depth = 7)
  *var_tmp = call5200;
  if (call5200 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5202 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5203 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5202);
// compiled call node returning call5203 (depth = 6)
  gc_frame_end(frame);
  return call5203;
}
Object meth_parser__apply5382(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5384 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5383);
// compiled call node returning call5384 (depth = 11)
// compiled member node returning call5384 (depth = 10)
  gc_frame_end(frame);
  return call5384;
}
Object meth_parser__apply5053(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_util = getfromclosure(closure, 13);
  Object *var_ast = getfromclosure(closure, 14);
  Object *var_recurse = getfromclosure(closure, 15);
  Object *var_name = getfromclosure(closure, 16);
  Object *var_acceptBlocks = getfromclosure(closure, 17);
  Object *var_values = getfromclosure(closure, 18);
  Object self = *(getfromclosure(closure, 19));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5055 = alloc_Float64(1);
// compiled num node returning num5055 (depth = 6)
  int op_slot_right_5054 = gc_frame_newslot(num5055);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_5054 = gc_frame_newslot(*var_opcount);
  params[0] = num5055;
  partcv[0] = 1;
  Object sum5057 = callmethod(*var_opcount, "+", 1, partcv, params);
// compiled op node returning sum5057 (depth = 5)
  *var_opcount = sum5057;
  if (sum5057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5060 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5059);
// compiled call node returning call5060 (depth = 6)
// compiled member node returning call5060 (depth = 5)
  *var_o = call5060;
  if (call5060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5062 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5063 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5062);
// compiled call node returning call5063 (depth = 5)
// compiled member node returning call5063 (depth = 4)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5064 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5065 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5064);
// compiled call node returning call5065 (depth = 5)
  *var_prec = call5065;
  if (call5065 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5070 == NULL) {
    strlit5070 = alloc_String("-");
    gc_root(strlit5070);
  }
// compiled string node returning strlit5070 (depth = 7)
  int op_slot_right_5069 = gc_frame_newslot(strlit5070);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_5069 = gc_frame_newslot(*var_o);
  params[0] = strlit5070;
  partcv[0] = 1;
  Object opresult5072 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5072 (depth = 6)
  int op_slot_right_5068 = gc_frame_newslot(opresult5072);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5076 == NULL) {
    strlit5076 = alloc_String("+");
    gc_root(strlit5076);
  }
// compiled string node returning strlit5076 (depth = 8)
  int op_slot_right_5075 = gc_frame_newslot(strlit5076);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_5075 = gc_frame_newslot(*var_o);
  params[0] = strlit5076;
  partcv[0] = 1;
  Object opresult5078 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5078 (depth = 7)
  int op_slot_right_5074 = gc_frame_newslot(opresult5078);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5082 == NULL) {
    strlit5082 = alloc_String("/");
    gc_root(strlit5082);
  }
// compiled string node returning strlit5082 (depth = 9)
  int op_slot_right_5081 = gc_frame_newslot(strlit5082);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_5081 = gc_frame_newslot(*var_o);
  params[0] = strlit5082;
  partcv[0] = 1;
  Object opresult5084 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5084 (depth = 8)
  int op_slot_right_5080 = gc_frame_newslot(opresult5084);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5087 == NULL) {
    strlit5087 = alloc_String("*");
    gc_root(strlit5087);
  }
// compiled string node returning strlit5087 (depth = 9)
  int op_slot_right_5086 = gc_frame_newslot(strlit5087);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_5086 = gc_frame_newslot(*var_o);
  params[0] = strlit5087;
  partcv[0] = 1;
  Object opresult5089 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5089 (depth = 8)
  int op_slot_left_5080 = gc_frame_newslot(opresult5089);
  params[0] = opresult5084;
  partcv[0] = 1;
  Object opresult5090 = callmethod(opresult5089, "&&", 1, partcv, params);
// compiled op node returning opresult5090 (depth = 7)
  int op_slot_left_5074 = gc_frame_newslot(opresult5090);
  params[0] = opresult5078;
  partcv[0] = 1;
  Object opresult5091 = callmethod(opresult5090, "&&", 1, partcv, params);
// compiled op node returning opresult5091 (depth = 6)
  int op_slot_left_5068 = gc_frame_newslot(opresult5091);
  params[0] = opresult5072;
  partcv[0] = 1;
  Object opresult5092 = callmethod(opresult5091, "&&", 1, partcv, params);
// compiled op node returning opresult5092 (depth = 5)
  Object if5067 = done;
  if (istrue(opresult5092)) {
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5093 = alloc_Boolean(0);
// compiled identifier node returning bool5093 (depth = 6)
  *var_allarith = bool5093;
  if (bool5093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5067 = done;
  } else {
  }
// compiled if node returning if5067 (depth = 4)
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_allarith (depth = 8)
  partcv[0] = 0;
  Object call5098 = callmethod(*var_allarith, "not",
    1, partcv, params);
  gc_frame_end(callframe5097);
// compiled call node returning call5098 (depth = 7)
// compiled member node returning call5098 (depth = 6)
  int op_slot_right_5096 = gc_frame_newslot(call5098);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_5101 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_5101 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult5103 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compiled op node returning opresult5103 (depth = 7)
  int op_slot_right_5100 = gc_frame_newslot(opresult5103);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5106 == NULL) {
    strlit5106 = alloc_String("");
    gc_root(strlit5106);
  }
// compiled string node returning strlit5106 (depth = 8)
  int op_slot_right_5105 = gc_frame_newslot(strlit5106);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_5105 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit5106;
  partcv[0] = 1;
  Object opresult5108 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compiled op node returning opresult5108 (depth = 7)
  int op_slot_left_5100 = gc_frame_newslot(opresult5108);
  params[0] = opresult5103;
  partcv[0] = 1;
  Object opresult5109 = callmethod(opresult5108, "&&", 1, partcv, params);
// compiled op node returning opresult5109 (depth = 6)
  int op_slot_left_5096 = gc_frame_newslot(opresult5109);
  params[0] = call5098;
  partcv[0] = 1;
  Object opresult5110 = callmethod(opresult5109, "&&", 1, partcv, params);
// compiled op node returning opresult5110 (depth = 5)
  Object if5095 = done;
  if (istrue(opresult5110)) {
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5111 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5112 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5113 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5112);
// compiled call node returning call5113 (depth = 9)
// compiled member node returning call5113 (depth = 8)
  partcv[0] = 0;
  Object call5114 = callmethod(call5113, "empty",
    1, partcv, params);
  gc_frame_end(callframe5111);
// compiled call node returning call5114 (depth = 7)
// compiled member node returning call5114 (depth = 6)
  *var_suggestions = call5114;
  if (call5114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5115 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5117 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5116);
// compiled call node returning call5117 (depth = 9)
// compiled member node returning call5117 (depth = 8)
  partcv[0] = 0;
  Object call5118 = callmethod(call5117, "new",
    1, partcv, params);
  gc_frame_end(callframe5115);
// compiled call node returning call5118 (depth = 7)
// compiled member node returning call5118 (depth = 6)
  *var_suggestion = call5118;
  if (call5118 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5119 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5120 == NULL) {
    strlit5120 = alloc_String(")");
    gc_root(strlit5120);
  }
// compiled string node returning strlit5120 (depth = 6)
  gc_frame_newslot(strlit5120);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5120;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5121 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5119);
// compiled call node returning call5121 (depth = 5)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5122 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5123 == NULL) {
    strlit5123 = alloc_String("(");
    gc_root(strlit5123);
  }
// compiled string node returning strlit5123 (depth = 6)
  gc_frame_newslot(strlit5123);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5125 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5124);
// compiled call node returning call5125 (depth = 7)
// compiled member node returning call5125 (depth = 6)
  gc_frame_newslot(call5125);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5123;
  params[1] = call5125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5126 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5122);
// compiled call node returning call5126 (depth = 5)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5128 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5127);
// compiled call node returning call5128 (depth = 5)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5129 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5131 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5130);
// compiled call node returning call5131 (depth = 9)
// compiled member node returning call5131 (depth = 8)
  partcv[0] = 0;
  Object call5132 = callmethod(call5131, "new",
    1, partcv, params);
  gc_frame_end(callframe5129);
// compiled call node returning call5132 (depth = 7)
// compiled member node returning call5132 (depth = 6)
  *var_suggestion = call5132;
  if (call5132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5134 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5135 == NULL) {
    strlit5135 = alloc_String(")");
    gc_root(strlit5135);
  }
// compiled string node returning strlit5135 (depth = 6)
  gc_frame_newslot(strlit5135);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5137 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5136);
// compiled call node returning call5137 (depth = 7)
// compiled member node returning call5137 (depth = 6)
  gc_frame_newslot(call5137);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5135;
  params[1] = call5137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5138 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5134);
// compiled call node returning call5138 (depth = 5)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5139 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5140 == NULL) {
    strlit5140 = alloc_String("(");
    gc_root(strlit5140);
  }
// compiled string node returning strlit5140 (depth = 6)
  gc_frame_newslot(strlit5140);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5141 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5142 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5143 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call5144 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5143);
// compiled call node returning call5144 (depth = 11)
// compiled member node returning call5144 (depth = 10)
  partcv[0] = 0;
  Object call5145 = callmethod(call5144, "prev",
    1, partcv, params);
  gc_frame_end(callframe5142);
// compiled call node returning call5145 (depth = 9)
// compiled member node returning call5145 (depth = 8)
  partcv[0] = 0;
  Object call5146 = callmethod(call5145, "prev",
    1, partcv, params);
  gc_frame_end(callframe5141);
// compiled call node returning call5146 (depth = 7)
// compiled member node returning call5146 (depth = 6)
  gc_frame_newslot(call5146);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5140;
  params[1] = call5146;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5147 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5139);
// compiled call node returning call5147 (depth = 5)
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5148 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5149 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5148);
// compiled call node returning call5149 (depth = 5)
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5150 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5151 == NULL) {
    strlit5151 = alloc_String("an expression containing both arithmetic and non-arithmetic operators requires parentheses.");
    gc_root(strlit5151);
  }
// compiled string node returning strlit5151 (depth = 6)
  gc_frame_newslot(strlit5151);
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5152 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5153 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5154 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5153);
// compiled call node returning call5154 (depth = 9)
// compiled member node returning call5154 (depth = 8)
  partcv[0] = 0;
  Object call5155 = callmethod(call5154, "line",
    1, partcv, params);
  gc_frame_end(callframe5152);
// compiled call node returning call5155 (depth = 7)
// compiled member node returning call5155 (depth = 6)
  gc_frame_newslot(call5155);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5156 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5158 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5157);
// compiled call node returning call5158 (depth = 9)
// compiled member node returning call5158 (depth = 8)
  partcv[0] = 0;
  Object call5159 = callmethod(call5158, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5156);
// compiled call node returning call5159 (depth = 7)
// compiled member node returning call5159 (depth = 6)
  gc_frame_newslot(call5159);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit5151;
  params[1] = call5155;
  params[2] = call5159;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5160 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5150);
// compiled call node returning call5160 (depth = 5)
    gc_frame_newslot(call5160);
    if5095 = call5160;
  } else {
  }
// compiled if node returning if5095 (depth = 4)
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5162 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5163 = alloc_Block(NULL, NULL, "parser", 1605);
  gc_frame_newslot(block5163);
// method "_apply"
  block_savedest(block5163);
  Object closure5164 = createclosure(3, "_apply");
  setclosureframe(closure5164, stackframe);
  addtoclosure(closure5164, var_ops);
  addtoclosure(closure5164, var_prec);
  addtoclosure(closure5164, selfslot);
  struct UserObject *uo5164 = (struct UserObject*)block5163;
  uo5164->data[0] = (Object)closure5164;
  Method *meth_meth_parser__apply5164 = addmethod2pos(block5163, "_apply", &meth_parser__apply5164, 0);
  int argcv_meth_parser__apply5164[] = {0};
  meth_meth_parser__apply5164->type = alloc_MethodType(1, argcv_meth_parser__apply5164);
  meth_meth_parser__apply5164->definitionModule = modulename;
  meth_meth_parser__apply5164->definitionLine = 1602;
// compiled block node returning block5163 (depth = 5)
  gc_frame_newslot(block5163);
// starting to compile block node (depth = 5)
  Object block5180 = alloc_Block(NULL, NULL, "parser", 1605);
  gc_frame_newslot(block5180);
// method "_apply"
  block_savedest(block5180);
  Object closure5181 = createclosure(8, "_apply");
  setclosureframe(closure5181, stackframe);
  addtoclosure(closure5181, var_ops);
  addtoclosure(closure5181, var_o2);
  addtoclosure(closure5181, var_terms);
  addtoclosure(closure5181, var_tmp2);
  addtoclosure(closure5181, var_tmp);
  addtoclosure(closure5181, var_util);
  addtoclosure(closure5181, var_ast);
  addtoclosure(closure5181, selfslot);
  struct UserObject *uo5181 = (struct UserObject*)block5180;
  uo5181->data[0] = (Object)closure5181;
  Method *meth_meth_parser__apply5181 = addmethod2pos(block5180, "_apply", &meth_parser__apply5181, 0);
  int argcv_meth_parser__apply5181[] = {0};
  meth_meth_parser__apply5181->type = alloc_MethodType(1, argcv_meth_parser__apply5181);
  meth_meth_parser__apply5181->definitionModule = modulename;
  meth_meth_parser__apply5181->definitionLine = 1605;
// compiled block node returning block5180 (depth = 5)
  gc_frame_newslot(block5180);
// call case 5: prelude request
  params[0] = block5163;
  params[1] = block5180;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5205 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5162);
// compiled call node returning call5205 (depth = 4)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5206 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5207 = callmethod(*var_ops, "push",
    1, partcv, params);
  gc_frame_end(callframe5206);
// compiled call node returning call5207 (depth = 4)
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5209 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5210 == NULL) {
    strlit5210 = alloc_String("lparen");
    gc_root(strlit5210);
  }
// compiled string node returning strlit5210 (depth = 6)
  gc_frame_newslot(strlit5210);
// call case 4: self request
  params[0] = strlit5210;
  partcv[0] = 1;
  Object call5211 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5209);
// compiled call node returning call5211 (depth = 5)
  Object if5208 = done;
  if (istrue(call5211)) {
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5213 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5212);
// compiled call node returning call5213 (depth = 6)
// compiled member node returning call5213 (depth = 5)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5215 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5216 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_recurse (depth = 9)
  gc_frame_newslot(*var_recurse);
// call case 4: self request
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call5217 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5216);
// compiled call node returning call5217 (depth = 8)
  partcv[0] = 0;
  Object call5218 = callmethod(call5217, "not",
    1, partcv, params);
  gc_frame_end(callframe5215);
// compiled call node returning call5218 (depth = 7)
// compiled member node returning call5218 (depth = 6)
  Object if5214 = done;
  if (istrue(call5218)) {
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5219 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5221 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5220);
// compiled call node returning call5221 (depth = 10)
// compiled member node returning call5221 (depth = 9)
  partcv[0] = 0;
  Object call5222 = callmethod(call5221, "new",
    1, partcv, params);
  gc_frame_end(callframe5219);
// compiled call node returning call5222 (depth = 8)
// compiled member node returning call5222 (depth = 7)
  *var_suggestion = call5222;
  if (call5222 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5223 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5224 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5225 == NULL) {
    strlit5225 = alloc_String("rparen");
    gc_root(strlit5225);
  }
// compiled string node returning strlit5225 (depth = 9)
  params[0] = strlit5225;
  partcv[0] = 1;
  callmethod(array5224, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array5224 (depth = 8)
  gc_frame_newslot(array5224);
// call case 4: self request
  params[0] = array5224;
  partcv[0] = 1;
  Object call5226 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5223);
// compiled call node returning call5226 (depth = 7)
  *var_nextTok = call5226;
  if (call5226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5228 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5228 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5230 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5230 (depth = 7)
  Object if5227 = done;
  if (istrue(opresult5230)) {
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5231 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5233 == NULL) {
    strlit5233 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5233);
  }
// compiled string node returning strlit5233 (depth = 9)
  int op_slot_right_5232 = gc_frame_newslot(strlit5233);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5235 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5237 == NULL) {
    strlit5237 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5237);
  }
// compiled string node returning strlit5237 (depth = 10)
  int op_slot_left_5235 = gc_frame_newslot(strlit5237);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5238 = callmethod(strlit5237, "++", 1, partcv, params);
// compiled op node returning opresult5238 (depth = 9)
  int op_slot_left_5232 = gc_frame_newslot(opresult5238);
  params[0] = strlit5233;
  partcv[0] = 1;
  Object opresult5239 = callmethod(opresult5238, "++", 1, partcv, params);
// compiled op node returning opresult5239 (depth = 8)
  gc_frame_newslot(opresult5239);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5239;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5240 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5231);
// compiled call node returning call5240 (depth = 7)
    gc_frame_newslot(call5240);
    if5227 = call5240;
  } else {
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5241 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5243 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5242);
// compiled call node returning call5243 (depth = 9)
// compiled member node returning call5243 (depth = 8)
  gc_frame_newslot(call5243);
// starting to compile identifier node (depth = 8)
  Object bool5244 = alloc_Boolean(1);
// compiled identifier node returning bool5244 (depth = 8)
  gc_frame_newslot(bool5244);
// starting to compile identifier node (depth = 8)
  Object bool5245 = alloc_Boolean(0);
// compiled identifier node returning bool5245 (depth = 8)
  gc_frame_newslot(bool5245);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5247 == NULL) {
    strlit5247 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5247);
  }
// compiled string node returning strlit5247 (depth = 9)
  int op_slot_right_5246 = gc_frame_newslot(strlit5247);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5249 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5251 == NULL) {
    strlit5251 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5251);
  }
// compiled string node returning strlit5251 (depth = 10)
  int op_slot_left_5249 = gc_frame_newslot(strlit5251);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5252 = callmethod(strlit5251, "++", 1, partcv, params);
// compiled op node returning opresult5252 (depth = 9)
  int op_slot_left_5246 = gc_frame_newslot(opresult5252);
  params[0] = strlit5247;
  partcv[0] = 1;
  Object opresult5253 = callmethod(opresult5252, "++", 1, partcv, params);
// compiled op node returning opresult5253 (depth = 8)
  gc_frame_newslot(opresult5253);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5243;
  params[2] = bool5244;
  params[3] = bool5245;
  params[4] = opresult5253;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5254 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5241);
// compiled call node returning call5254 (depth = 7)
    gc_frame_newslot(call5254);
    if5227 = call5254;
  }
// compiled if node returning if5227 (depth = 6)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5255 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5257 == NULL) {
    strlit5257 = alloc_String(".");
    gc_root(strlit5257);
  }
// compiled string node returning strlit5257 (depth = 8)
  int op_slot_right_5256 = gc_frame_newslot(strlit5257);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5259 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5261 == NULL) {
    strlit5261 = alloc_String("parentheses must contain a valid ");
    gc_root(strlit5261);
  }
// compiled string node returning strlit5261 (depth = 9)
  int op_slot_left_5259 = gc_frame_newslot(strlit5261);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5262 = callmethod(strlit5261, "++", 1, partcv, params);
// compiled op node returning opresult5262 (depth = 8)
  int op_slot_left_5256 = gc_frame_newslot(opresult5262);
  params[0] = strlit5257;
  partcv[0] = 1;
  Object opresult5263 = callmethod(opresult5262, "++", 1, partcv, params);
// compiled op node returning opresult5263 (depth = 7)
  gc_frame_newslot(opresult5263);
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5264 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5265 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5264);
// compiled call node returning call5265 (depth = 8)
// compiled member node returning call5265 (depth = 7)
  gc_frame_newslot(call5265);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5266 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5267 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5266);
// compiled call node returning call5267 (depth = 8)
// compiled member node returning call5267 (depth = 7)
  gc_frame_newslot(call5267);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5263;
  params[1] = call5265;
  params[2] = call5267;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5268 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5255);
// compiled call node returning call5268 (depth = 6)
    gc_frame_newslot(call5268);
    if5214 = call5268;
  } else {
  }
// compiled if node returning if5214 (depth = 5)
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5271 == NULL) {
    strlit5271 = alloc_String("rparen");
    gc_root(strlit5271);
  }
// compiled string node returning strlit5271 (depth = 7)
  int op_slot_right_5270 = gc_frame_newslot(strlit5271);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5273 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5274 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5273);
// compiled call node returning call5274 (depth = 8)
// compiled member node returning call5274 (depth = 7)
  int op_slot_left_5270 = gc_frame_newslot(call5274);
  params[0] = strlit5271;
  partcv[0] = 1;
  Object opresult5275 = callmethod(call5274, "!=", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 6)
  Object if5269 = done;
  if (istrue(opresult5275)) {
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5276 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5277 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5276);
// compiled call node returning call5277 (depth = 7)
// compiled member node returning call5277 (depth = 6)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5278 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5280 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5279);
// compiled call node returning call5280 (depth = 10)
// compiled member node returning call5280 (depth = 9)
  partcv[0] = 0;
  Object call5281 = callmethod(call5280, "new",
    1, partcv, params);
  gc_frame_end(callframe5278);
// compiled call node returning call5281 (depth = 8)
// compiled member node returning call5281 (depth = 7)
  *var_suggestion = call5281;
  if (call5281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5282 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5283 == NULL) {
    strlit5283 = alloc_String(")");
    gc_root(strlit5283);
  }
// compiled string node returning strlit5283 (depth = 7)
  gc_frame_newslot(strlit5283);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5283;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5284 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5282);
// compiled call node returning call5284 (depth = 6)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5285 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5286 == NULL) {
    strlit5286 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5286);
  }
// compiled string node returning strlit5286 (depth = 7)
  gc_frame_newslot(strlit5286);
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5288 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5287);
// compiled call node returning call5288 (depth = 8)
// compiled member node returning call5288 (depth = 7)
  gc_frame_newslot(call5288);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5291 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5290);
// compiled call node returning call5291 (depth = 9)
// compiled member node returning call5291 (depth = 8)
  int op_slot_right_5289 = gc_frame_newslot(call5291);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5294 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5293);
// compiled call node returning call5294 (depth = 9)
// compiled member node returning call5294 (depth = 8)
  int op_slot_left_5289 = gc_frame_newslot(call5294);
  params[0] = call5291;
  partcv[0] = 1;
  Object sum5295 = callmethod(call5294, "+", 1, partcv, params);
// compiled op node returning sum5295 (depth = 7)
  gc_frame_newslot(sum5295);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5286;
  params[1] = call5288;
  params[2] = sum5295;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5296 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5285);
// compiled call node returning call5296 (depth = 6)
    gc_frame_newslot(call5296);
    if5269 = call5296;
  } else {
  }
// compiled if node returning if5269 (depth = 5)
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5298 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5297);
// compiled call node returning call5298 (depth = 6)
// compiled member node returning call5298 (depth = 5)
    gc_frame_newslot(call5298);
    if5208 = call5298;
  } else {
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5300 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5301 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5302 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5301);
// compiled call node returning call5302 (depth = 8)
// compiled member node returning call5302 (depth = 7)
  partcv[0] = 0;
  Object call5303 = callmethod(call5302, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe5300);
// compiled call node returning call5303 (depth = 6)
  Object if5299 = done;
  if (istrue(call5303)) {
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5304 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5305 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5306 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5305);
// compiled call node returning call5306 (depth = 10)
// compiled member node returning call5306 (depth = 9)
  partcv[0] = 0;
  Object call5307 = callmethod(call5306, "empty",
    1, partcv, params);
  gc_frame_end(callframe5304);
// compiled call node returning call5307 (depth = 8)
// compiled member node returning call5307 (depth = 7)
  *var_suggestions = call5307;
  if (call5307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5308 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5310 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5309);
// compiled call node returning call5310 (depth = 10)
// compiled member node returning call5310 (depth = 9)
  partcv[0] = 0;
  Object call5311 = callmethod(call5310, "new",
    1, partcv, params);
  gc_frame_end(callframe5308);
// compiled call node returning call5311 (depth = 8)
// compiled member node returning call5311 (depth = 7)
  *var_suggestion = call5311;
  if (call5311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5312 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool5313 = alloc_Boolean(1);
// compiled identifier node returning bool5313 (depth = 7)
  gc_frame_newslot(bool5313);
// starting to compile identifier node (depth = 7)
  Object bool5314 = alloc_Boolean(0);
// compiled identifier node returning bool5314 (depth = 7)
  gc_frame_newslot(bool5314);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool5313;
  params[2] = bool5314;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5315 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5312);
// compiled call node returning call5315 (depth = 6)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5316 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5317 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5316);
// compiled call node returning call5317 (depth = 6)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5318 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5320 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5319);
// compiled call node returning call5320 (depth = 10)
// compiled member node returning call5320 (depth = 9)
  partcv[0] = 0;
  Object call5321 = callmethod(call5320, "new",
    1, partcv, params);
  gc_frame_end(callframe5318);
// compiled call node returning call5321 (depth = 8)
// compiled member node returning call5321 (depth = 7)
  *var_suggestion = call5321;
  if (call5321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5323 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5325 == NULL) {
    strlit5325 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5325);
  }
// compiled string node returning strlit5325 (depth = 8)
  int op_slot_right_5324 = gc_frame_newslot(strlit5325);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5327 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5329 == NULL) {
    strlit5329 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5329);
  }
// compiled string node returning strlit5329 (depth = 9)
  int op_slot_left_5327 = gc_frame_newslot(strlit5329);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5330 = callmethod(strlit5329, "++", 1, partcv, params);
// compiled op node returning opresult5330 (depth = 8)
  int op_slot_left_5324 = gc_frame_newslot(opresult5330);
  params[0] = strlit5325;
  partcv[0] = 1;
  Object opresult5331 = callmethod(opresult5330, "++", 1, partcv, params);
// compiled op node returning opresult5331 (depth = 7)
  gc_frame_newslot(opresult5331);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5331;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5332 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5323);
// compiled call node returning call5332 (depth = 6)
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5333 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5334 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5333);
// compiled call node returning call5334 (depth = 6)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5335 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5337 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5336);
// compiled call node returning call5337 (depth = 10)
// compiled member node returning call5337 (depth = 9)
  partcv[0] = 0;
  Object call5338 = callmethod(call5337, "new",
    1, partcv, params);
  gc_frame_end(callframe5335);
// compiled call node returning call5338 (depth = 8)
// compiled member node returning call5338 (depth = 7)
  *var_suggestion = call5338;
  if (call5338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5340 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5342 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call5343 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5342);
// compiled call node returning call5343 (depth = 10)
// compiled member node returning call5343 (depth = 9)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5344 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call5345 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5344);
// compiled call node returning call5345 (depth = 10)
// compiled member node returning call5345 (depth = 9)
  params[0] = call5345;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5346 = callmethod(call5343, "[]", 1, partcv, params);
// compiled index node returning idxres5346 (depth = 8)
  int op_slot_right_5341 = gc_frame_newslot(idxres5346);
// starting to compile string node (depth = 8)
  if (strlit5348 == NULL) {
    strlit5348 = alloc_String(" ");
    gc_root(strlit5348);
  }
// compiled string node returning strlit5348 (depth = 8)
  int op_slot_left_5341 = gc_frame_newslot(strlit5348);
  params[0] = idxres5346;
  partcv[0] = 1;
  Object opresult5349 = callmethod(strlit5348, "++", 1, partcv, params);
// compiled op node returning opresult5349 (depth = 7)
  gc_frame_newslot(opresult5349);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5349;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5350 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5340);
// compiled call node returning call5350 (depth = 6)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5351 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5352 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5353 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5352);
// compiled call node returning call5353 (depth = 8)
// compiled member node returning call5353 (depth = 7)
  gc_frame_newslot(call5353);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call5353;
  partcv[0] = 1;
  Object call5354 = callmethod(*var_suggestion, "deleteLine",
    1, partcv, params);
  gc_frame_end(callframe5351);
// compiled call node returning call5354 (depth = 6)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5355 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5356 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5355);
// compiled call node returning call5356 (depth = 6)
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5357 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5359 == NULL) {
    strlit5359 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5359);
  }
// compiled string node returning strlit5359 (depth = 8)
  int op_slot_right_5358 = gc_frame_newslot(strlit5359);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5363 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5362);
// compiled call node returning call5363 (depth = 10)
// compiled member node returning call5363 (depth = 9)
  int op_slot_right_5361 = gc_frame_newslot(call5363);
// starting to compile string node (depth = 9)
  if (strlit5365 == NULL) {
    strlit5365 = alloc_String("a valid expression must follow '");
    gc_root(strlit5365);
  }
// compiled string node returning strlit5365 (depth = 9)
  int op_slot_left_5361 = gc_frame_newslot(strlit5365);
  params[0] = call5363;
  partcv[0] = 1;
  Object opresult5366 = callmethod(strlit5365, "++", 1, partcv, params);
// compiled op node returning opresult5366 (depth = 8)
  int op_slot_left_5358 = gc_frame_newslot(opresult5366);
  params[0] = strlit5359;
  partcv[0] = 1;
  Object opresult5367 = callmethod(opresult5366, "++", 1, partcv, params);
// compiled op node returning opresult5367 (depth = 7)
  gc_frame_newslot(opresult5367);
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5368 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5369 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5368);
// compiled call node returning call5369 (depth = 8)
// compiled member node returning call5369 (depth = 7)
  gc_frame_newslot(call5369);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5372 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5371);
// compiled call node returning call5372 (depth = 9)
// compiled member node returning call5372 (depth = 8)
  int op_slot_right_5370 = gc_frame_newslot(call5372);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5375 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5374);
// compiled call node returning call5375 (depth = 9)
// compiled member node returning call5375 (depth = 8)
  int op_slot_left_5370 = gc_frame_newslot(call5375);
  params[0] = call5372;
  partcv[0] = 1;
  Object sum5376 = callmethod(call5375, "+", 1, partcv, params);
// compiled op node returning sum5376 (depth = 7)
  gc_frame_newslot(sum5376);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5367;
  params[1] = call5369;
  params[2] = sum5376;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5377 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5357);
// compiled call node returning call5377 (depth = 6)
    gc_frame_newslot(call5377);
    if5299 = call5377;
  } else {
  }
// compiled if node returning if5299 (depth = 5)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5379 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5380 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5381 = alloc_Block(NULL, NULL, "parser", 1662);
  gc_frame_newslot(block5381);
// method "_apply"
  block_savedest(block5381);
  Object closure5382 = createclosure(1, "_apply");
  setclosureframe(closure5382, stackframe);
  addtoclosure(closure5382, selfslot);
  struct UserObject *uo5382 = (struct UserObject*)block5381;
  uo5382->data[0] = (Object)closure5382;
  Method *meth_meth_parser__apply5382 = addmethod2pos(block5381, "_apply", &meth_parser__apply5382, 0);
  int argcv_meth_parser__apply5382[] = {0};
  meth_meth_parser__apply5382->type = alloc_MethodType(1, argcv_meth_parser__apply5382);
  meth_meth_parser__apply5382->definitionModule = modulename;
  meth_meth_parser__apply5382->definitionLine = 1662;
// compiled block node returning block5381 (depth = 9)
  gc_frame_newslot(block5381);
// call case 4: self request
  params[0] = block5381;
  partcv[0] = 1;
  Object call5386 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5380);
// compiled call node returning call5386 (depth = 8)
  partcv[0] = 0;
  Object call5387 = callmethod(call5386, "not",
    1, partcv, params);
  gc_frame_end(callframe5379);
// compiled call node returning call5387 (depth = 7)
// compiled member node returning call5387 (depth = 6)
  Object if5378 = done;
  if (istrue(call5387)) {
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5388 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5389 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5390 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5389);
// compiled call node returning call5390 (depth = 10)
// compiled member node returning call5390 (depth = 9)
  partcv[0] = 0;
  Object call5391 = callmethod(call5390, "empty",
    1, partcv, params);
  gc_frame_end(callframe5388);
// compiled call node returning call5391 (depth = 8)
// compiled member node returning call5391 (depth = 7)
  *var_suggestions = call5391;
  if (call5391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5392 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5394 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5393);
// compiled call node returning call5394 (depth = 10)
// compiled member node returning call5394 (depth = 9)
  partcv[0] = 0;
  Object call5395 = callmethod(call5394, "new",
    1, partcv, params);
  gc_frame_end(callframe5392);
// compiled call node returning call5395 (depth = 8)
// compiled member node returning call5395 (depth = 7)
  *var_suggestion = call5395;
  if (call5395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5396 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5397 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5398 == NULL) {
    strlit5398 = alloc_String("comma");
    gc_root(strlit5398);
  }
// compiled string node returning strlit5398 (depth = 9)
  params[0] = strlit5398;
  partcv[0] = 1;
  callmethod(array5397, "push", 1, partcv, params);
// starting to compile string node (depth = 9)
  if (strlit5399 == NULL) {
    strlit5399 = alloc_String("rparen");
    gc_root(strlit5399);
  }
// compiled string node returning strlit5399 (depth = 9)
  params[0] = strlit5399;
  partcv[0] = 1;
  callmethod(array5397, "push", 1, partcv, params);
// starting to compile string node (depth = 9)
  if (strlit5400 == NULL) {
    strlit5400 = alloc_String("rsquare");
    gc_root(strlit5400);
  }
// compiled string node returning strlit5400 (depth = 9)
  params[0] = strlit5400;
  partcv[0] = 1;
  callmethod(array5397, "push", 1, partcv, params);
// starting to compile string node (depth = 9)
  if (strlit5401 == NULL) {
    strlit5401 = alloc_String("rbrace");
    gc_root(strlit5401);
  }
// compiled string node returning strlit5401 (depth = 9)
  params[0] = strlit5401;
  partcv[0] = 1;
  callmethod(array5397, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array5397 (depth = 8)
  gc_frame_newslot(array5397);
// call case 4: self request
  params[0] = array5397;
  partcv[0] = 1;
  Object call5402 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5396);
// compiled call node returning call5402 (depth = 7)
  *var_nextTok = call5402;
  if (call5402 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5404 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5404 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5406 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5406 (depth = 7)
  Object if5403 = done;
  if (istrue(opresult5406)) {
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5407 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5409 == NULL) {
    strlit5409 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5409);
  }
// compiled string node returning strlit5409 (depth = 9)
  int op_slot_right_5408 = gc_frame_newslot(strlit5409);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5411 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5413 == NULL) {
    strlit5413 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5413);
  }
// compiled string node returning strlit5413 (depth = 10)
  int op_slot_left_5411 = gc_frame_newslot(strlit5413);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5414 = callmethod(strlit5413, "++", 1, partcv, params);
// compiled op node returning opresult5414 (depth = 9)
  int op_slot_left_5408 = gc_frame_newslot(opresult5414);
  params[0] = strlit5409;
  partcv[0] = 1;
  Object opresult5415 = callmethod(opresult5414, "++", 1, partcv, params);
// compiled op node returning opresult5415 (depth = 8)
  gc_frame_newslot(opresult5415);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5415;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5416 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5407);
// compiled call node returning call5416 (depth = 7)
    gc_frame_newslot(call5416);
    if5403 = call5416;
  } else {
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5417 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5419 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5418);
// compiled call node returning call5419 (depth = 9)
// compiled member node returning call5419 (depth = 8)
  gc_frame_newslot(call5419);
// starting to compile identifier node (depth = 8)
  Object bool5420 = alloc_Boolean(1);
// compiled identifier node returning bool5420 (depth = 8)
  gc_frame_newslot(bool5420);
// starting to compile identifier node (depth = 8)
  Object bool5421 = alloc_Boolean(0);
// compiled identifier node returning bool5421 (depth = 8)
  gc_frame_newslot(bool5421);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5423 == NULL) {
    strlit5423 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5423);
  }
// compiled string node returning strlit5423 (depth = 9)
  int op_slot_right_5422 = gc_frame_newslot(strlit5423);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5425 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5427 == NULL) {
    strlit5427 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5427);
  }
// compiled string node returning strlit5427 (depth = 10)
  int op_slot_left_5425 = gc_frame_newslot(strlit5427);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5428 = callmethod(strlit5427, "++", 1, partcv, params);
// compiled op node returning opresult5428 (depth = 9)
  int op_slot_left_5422 = gc_frame_newslot(opresult5428);
  params[0] = strlit5423;
  partcv[0] = 1;
  Object opresult5429 = callmethod(opresult5428, "++", 1, partcv, params);
// compiled op node returning opresult5429 (depth = 8)
  gc_frame_newslot(opresult5429);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5419;
  params[2] = bool5420;
  params[3] = bool5421;
  params[4] = opresult5429;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5430 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5417);
// compiled call node returning call5430 (depth = 7)
    gc_frame_newslot(call5430);
    if5403 = call5430;
  }
// compiled if node returning if5403 (depth = 6)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5431 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5432 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5431);
// compiled call node returning call5432 (depth = 6)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5433 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5435 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5434);
// compiled call node returning call5435 (depth = 10)
// compiled member node returning call5435 (depth = 9)
  partcv[0] = 0;
  Object call5436 = callmethod(call5435, "new",
    1, partcv, params);
  gc_frame_end(callframe5433);
// compiled call node returning call5436 (depth = 8)
// compiled member node returning call5436 (depth = 7)
  *var_suggestion = call5436;
  if (call5436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5438 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5440 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5439);
// compiled call node returning call5440 (depth = 8)
// compiled member node returning call5440 (depth = 7)
  gc_frame_newslot(call5440);
// starting to compile identifier node (depth = 7)
  Object bool5441 = alloc_Boolean(1);
// compiled identifier node returning bool5441 (depth = 7)
  gc_frame_newslot(bool5441);
// starting to compile identifier node (depth = 7)
  Object bool5442 = alloc_Boolean(0);
// compiled identifier node returning bool5442 (depth = 7)
  gc_frame_newslot(bool5442);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5440;
  params[2] = bool5441;
  params[3] = bool5442;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5443 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5438);
// compiled call node returning call5443 (depth = 6)
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5444 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5445 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5444);
// compiled call node returning call5445 (depth = 6)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5446 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5448 == NULL) {
    strlit5448 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5448);
  }
// compiled string node returning strlit5448 (depth = 8)
  int op_slot_right_5447 = gc_frame_newslot(strlit5448);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5452 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5451);
// compiled call node returning call5452 (depth = 10)
// compiled member node returning call5452 (depth = 9)
  int op_slot_right_5450 = gc_frame_newslot(call5452);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5455 == NULL) {
    strlit5455 = alloc_String(" must follow '");
    gc_root(strlit5455);
  }
// compiled string node returning strlit5455 (depth = 10)
  int op_slot_right_5454 = gc_frame_newslot(strlit5455);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_5457 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit5459 == NULL) {
    strlit5459 = alloc_String("a valid ");
    gc_root(strlit5459);
  }
// compiled string node returning strlit5459 (depth = 11)
  int op_slot_left_5457 = gc_frame_newslot(strlit5459);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5460 = callmethod(strlit5459, "++", 1, partcv, params);
// compiled op node returning opresult5460 (depth = 10)
  int op_slot_left_5454 = gc_frame_newslot(opresult5460);
  params[0] = strlit5455;
  partcv[0] = 1;
  Object opresult5461 = callmethod(opresult5460, "++", 1, partcv, params);
// compiled op node returning opresult5461 (depth = 9)
  int op_slot_left_5450 = gc_frame_newslot(opresult5461);
  params[0] = call5452;
  partcv[0] = 1;
  Object opresult5462 = callmethod(opresult5461, "++", 1, partcv, params);
// compiled op node returning opresult5462 (depth = 8)
  int op_slot_left_5447 = gc_frame_newslot(opresult5462);
  params[0] = strlit5448;
  partcv[0] = 1;
  Object opresult5463 = callmethod(opresult5462, "++", 1, partcv, params);
// compiled op node returning opresult5463 (depth = 7)
  gc_frame_newslot(opresult5463);
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5465 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5464);
// compiled call node returning call5465 (depth = 8)
// compiled member node returning call5465 (depth = 7)
  gc_frame_newslot(call5465);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5468 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5467);
// compiled call node returning call5468 (depth = 9)
// compiled member node returning call5468 (depth = 8)
  int op_slot_right_5466 = gc_frame_newslot(call5468);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5471 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5470);
// compiled call node returning call5471 (depth = 9)
// compiled member node returning call5471 (depth = 8)
  int op_slot_left_5466 = gc_frame_newslot(call5471);
  params[0] = call5468;
  partcv[0] = 1;
  Object sum5472 = callmethod(call5471, "+", 1, partcv, params);
// compiled op node returning sum5472 (depth = 7)
  gc_frame_newslot(sum5472);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5463;
  params[1] = call5465;
  params[2] = sum5472;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5473 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5446);
// compiled call node returning call5473 (depth = 6)
    gc_frame_newslot(call5473);
    if5378 = call5473;
  } else {
  }
// compiled if node returning if5378 (depth = 5)
    gc_frame_newslot(if5378);
    if5208 = if5378;
  }
// compiled if node returning if5208 (depth = 4)
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5474 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5475 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5474);
// compiled call node returning call5475 (depth = 4)
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5476 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5477 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5476);
// compiled call node returning call5477 (depth = 4)
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5479 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5478);
// compiled call node returning call5479 (depth = 5)
// compiled member node returning call5479 (depth = 4)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5481 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5480);
// compiled call node returning call5481 (depth = 6)
// compiled member node returning call5481 (depth = 5)
  *var_tmp = call5481;
  if (call5481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5483 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5484 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5483);
// compiled call node returning call5484 (depth = 4)
  gc_frame_end(frame);
  return call5484;
}
Object meth_parser__apply5489(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5491 = alloc_Float64(0);
// compiled num node returning num5491 (depth = 5)
  int op_slot_right_5490 = gc_frame_newslot(num5491);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5493 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5494 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5493);
// compiled call node returning call5494 (depth = 6)
// compiled member node returning call5494 (depth = 5)
  int op_slot_left_5490 = gc_frame_newslot(call5494);
  params[0] = num5491;
  partcv[0] = 1;
  Object opresult5495 = callmethod(call5494, ">", 1, partcv, params);
// compiled op node returning opresult5495 (depth = 4)
  gc_frame_end(frame);
  return opresult5495;
}
Object meth_parser__apply5498(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5499 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5500 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5499);
// compiled call node returning call5500 (depth = 6)
// compiled member node returning call5500 (depth = 5)
  *var_o = call5500;
  if (call5500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5503 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5502);
// compiled call node returning call5503 (depth = 6)
// compiled member node returning call5503 (depth = 5)
  *var_tmp2 = call5503;
  if (call5503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5506 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5505);
// compiled call node returning call5506 (depth = 6)
// compiled member node returning call5506 (depth = 5)
  *var_tmp = call5506;
  if (call5506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5508 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5509 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  partcv[0] = 0;
  Object call5510 = callmethod(*var_tmp, "line",
    1, partcv, params);
  gc_frame_end(callframe5509);
// compiled call node returning call5510 (depth = 6)
// compiled member node returning call5510 (depth = 5)
  gc_frame_newslot(call5510);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  partcv[0] = 0;
  Object call5512 = callmethod(*var_tmp, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5511);
// compiled call node returning call5512 (depth = 6)
// compiled member node returning call5512 (depth = 5)
  gc_frame_newslot(call5512);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5510;
  params[1] = call5512;
  partcv[0] = 2;
  Object call5513 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5508);
// compiled call node returning call5513 (depth = 4)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5514 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5516 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5515);
// compiled call node returning call5516 (depth = 7)
// compiled member node returning call5516 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5517 = callmethod(call5516, "new",
    1, partcv, params);
  gc_frame_end(callframe5514);
// compiled call node returning call5517 (depth = 5)
  *var_tmp = call5517;
  if (call5517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5519 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5520 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5519);
// compiled call node returning call5520 (depth = 4)
  gc_frame_end(frame);
  return call5520;
}
Object meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest()recursingWith()blocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest()recursingWith()blocks");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for expressionrest()recursingWith()blocks (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for expressionrest");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for recursingWith");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for blocks");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_terms = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "terms");
  Object *var_ops = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ops");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_o2 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o2");
  Object *var_tmp2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tmp2");
  Object *var_tmp = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp");
  Object *var_prec = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prec");
  Object *var_allarith = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "allarith");
  Object *var_opcount = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "opcount");
  Object *var_opdtype = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opdtype");
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5025 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5025 (depth = 3)
  *var_terms = array5025;
  if (array5025 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5026 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5026 (depth = 3)
  *var_ops = array5026;
  if (array5026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5027 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5028 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5027);
// compiled call node returning call5028 (depth = 4)
// compiled member node returning call5028 (depth = 3)
  *var_tmp = call5028;
  if (call5028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5029 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5030 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5029);
// compiled call node returning call5030 (depth = 2)
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5031 = alloc_Boolean(1);
// compiled identifier node returning bool5031 (depth = 3)
  *var_allarith = bool5031;
  if (bool5031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5032 = alloc_Float64(0);
// compiled num node returning num5032 (depth = 3)
  *var_opcount = num5032;
  if (num5032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5033 == NULL) {
    strlit5033 = alloc_String("");
    gc_root(strlit5033);
  }
// compiled string node returning strlit5033 (depth = 3)
  *var_opdtype = strlit5033;
  if (strlit5033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5034 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5035 = alloc_Block(NULL, NULL, "parser", 1579);
  gc_frame_newslot(block5035);
// method "_apply"
  block_savedest(block5035);
  Object closure5036 = createclosure(3, "_apply");
  setclosureframe(closure5036, stackframe);
  addtoclosure(closure5036, var_sym);
  addtoclosure(closure5036, var_statementToken);
  addtoclosure(closure5036, selfslot);
  struct UserObject *uo5036 = (struct UserObject*)block5035;
  uo5036->data[0] = (Object)closure5036;
  Method *meth_meth_parser__apply5036 = addmethod2pos(block5035, "_apply", &meth_parser__apply5036, 0);
  int argcv_meth_parser__apply5036[] = {0};
  meth_meth_parser__apply5036->type = alloc_MethodType(1, argcv_meth_parser__apply5036);
  meth_meth_parser__apply5036->definitionModule = modulename;
  meth_meth_parser__apply5036->definitionLine = 1573;
// compiled block node returning block5035 (depth = 3)
  gc_frame_newslot(block5035);
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5052 = alloc_Block(NULL, NULL, "parser", 1580);
  gc_frame_newslot(block5052);
// method "_apply"
  block_savedest(block5052);
  Object closure5053 = createclosure(20, "_apply");
  setclosureframe(closure5053, stackframe);
  addtoclosure(closure5053, var_opcount);
  addtoclosure(closure5053, var_sym);
  addtoclosure(closure5053, var_o);
  addtoclosure(closure5053, var_prec);
  addtoclosure(closure5053, var_allarith);
  addtoclosure(closure5053, var_opdtype);
  addtoclosure(closure5053, var_errormessages);
  addtoclosure(closure5053, var_lastToken);
  addtoclosure(closure5053, var_ops);
  addtoclosure(closure5053, var_o2);
  addtoclosure(closure5053, var_terms);
  addtoclosure(closure5053, var_tmp2);
  addtoclosure(closure5053, var_tmp);
  addtoclosure(closure5053, var_util);
  addtoclosure(closure5053, var_ast);
  addtoclosure(closure5053, var_recurse);
  addtoclosure(closure5053, var_name);
  addtoclosure(closure5053, var_acceptBlocks);
  addtoclosure(closure5053, var_values);
  addtoclosure(closure5053, selfslot);
  struct UserObject *uo5053 = (struct UserObject*)block5052;
  uo5053->data[0] = (Object)closure5053;
  Method *meth_meth_parser__apply5053 = addmethod2pos(block5052, "_apply", &meth_parser__apply5053, 0);
  int argcv_meth_parser__apply5053[] = {0};
  meth_meth_parser__apply5053->type = alloc_MethodType(1, argcv_meth_parser__apply5053);
  meth_meth_parser__apply5053->definitionModule = modulename;
  meth_meth_parser__apply5053->definitionLine = 1580;
// compiled block node returning block5052 (depth = 3)
  gc_frame_newslot(block5052);
// call case 5: prelude request
  params[0] = block5035;
  params[1] = block5052;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5486 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5034);
// compiled call node returning call5486 (depth = 2)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5487 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5488 = alloc_Block(NULL, NULL, "parser", 1690);
  gc_frame_newslot(block5488);
// method "_apply"
  block_savedest(block5488);
  Object closure5489 = createclosure(2, "_apply");
  setclosureframe(closure5489, stackframe);
  addtoclosure(closure5489, var_ops);
  addtoclosure(closure5489, selfslot);
  struct UserObject *uo5489 = (struct UserObject*)block5488;
  uo5489->data[0] = (Object)closure5489;
  Method *meth_meth_parser__apply5489 = addmethod2pos(block5488, "_apply", &meth_parser__apply5489, 0);
  int argcv_meth_parser__apply5489[] = {0};
  meth_meth_parser__apply5489->type = alloc_MethodType(1, argcv_meth_parser__apply5489);
  meth_meth_parser__apply5489->definitionModule = modulename;
  meth_meth_parser__apply5489->definitionLine = 1687;
// compiled block node returning block5488 (depth = 3)
  gc_frame_newslot(block5488);
// starting to compile block node (depth = 3)
  Object block5497 = alloc_Block(NULL, NULL, "parser", 1690);
  gc_frame_newslot(block5497);
// method "_apply"
  block_savedest(block5497);
  Object closure5498 = createclosure(8, "_apply");
  setclosureframe(closure5498, stackframe);
  addtoclosure(closure5498, var_ops);
  addtoclosure(closure5498, var_o);
  addtoclosure(closure5498, var_terms);
  addtoclosure(closure5498, var_tmp2);
  addtoclosure(closure5498, var_tmp);
  addtoclosure(closure5498, var_util);
  addtoclosure(closure5498, var_ast);
  addtoclosure(closure5498, selfslot);
  struct UserObject *uo5498 = (struct UserObject*)block5497;
  uo5498->data[0] = (Object)closure5498;
  Method *meth_meth_parser__apply5498 = addmethod2pos(block5497, "_apply", &meth_parser__apply5498, 0);
  int argcv_meth_parser__apply5498[] = {0};
  meth_meth_parser__apply5498->type = alloc_MethodType(1, argcv_meth_parser__apply5498);
  meth_meth_parser__apply5498->definitionModule = modulename;
  meth_meth_parser__apply5498->definitionLine = 1690;
// compiled block node returning block5497 (depth = 3)
  gc_frame_newslot(block5497);
// call case 5: prelude request
  params[0] = block5488;
  params[1] = block5497;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5522 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5487);
// compiled call node returning call5522 (depth = 2)
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  partcv[0] = 0;
  Object call5524 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5523);
// compiled call node returning call5524 (depth = 4)
// compiled member node returning call5524 (depth = 3)
  *var_tmp = call5524;
  if (call5524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5526 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5527 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5526);
// compiled call node returning call5527 (depth = 2)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5530 = alloc_Float64(0);
// compiled num node returning num5530 (depth = 4)
  int op_slot_right_5529 = gc_frame_newslot(num5530);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  partcv[0] = 0;
  Object call5533 = callmethod(*var_terms, "size",
    1, partcv, params);
  gc_frame_end(callframe5532);
// compiled call node returning call5533 (depth = 5)
// compiled member node returning call5533 (depth = 4)
  int op_slot_left_5529 = gc_frame_newslot(call5533);
  params[0] = num5530;
  partcv[0] = 1;
  Object opresult5534 = callmethod(call5533, ">", 1, partcv, params);
// compiled op node returning opresult5534 (depth = 3)
  Object if5528 = done;
  if (istrue(opresult5534)) {
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5535 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5536 == NULL) {
    strlit5536 = alloc_String("values left on term stack.");
    gc_root(strlit5536);
  }
// compiled string node returning strlit5536 (depth = 4)
  gc_frame_newslot(strlit5536);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5538 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5537);
// compiled call node returning call5538 (depth = 5)
// compiled member node returning call5538 (depth = 4)
  gc_frame_newslot(call5538);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5540 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5539);
// compiled call node returning call5540 (depth = 5)
// compiled member node returning call5540 (depth = 4)
  gc_frame_newslot(call5540);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5536;
  params[1] = call5538;
  params[2] = call5540;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5541 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe5535);
// compiled call node returning call5541 (depth = 3)
    gc_frame_newslot(call5541);
    if5528 = call5541;
  } else {
  }
// compiled if node returning if5528 (depth = 2)
  gc_frame_end(frame);
  return if5528;
}
Object meth_parser_dotrest5542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method dotrest");
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for dotrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lookuptarget = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lookuptarget");
  Object *var_dro = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dro");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5544 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5545 == NULL) {
    strlit5545 = alloc_String("dot");
    gc_root(strlit5545);
  }
// compiled string node returning strlit5545 (depth = 4)
  gc_frame_newslot(strlit5545);
// call case 4: self request
  params[0] = strlit5545;
  partcv[0] = 1;
  Object call5546 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5544);
// compiled call node returning call5546 (depth = 3)
  Object if5543 = done;
  if (istrue(call5546)) {
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5547 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5549 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5548);
// compiled call node returning call5549 (depth = 5)
// compiled member node returning call5549 (depth = 4)
  gc_frame_newslot(call5549);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5551 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5550);
// compiled call node returning call5551 (depth = 5)
// compiled member node returning call5551 (depth = 4)
  gc_frame_newslot(call5551);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5549;
  params[1] = call5551;
  partcv[0] = 2;
  Object call5552 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5547);
// compiled call node returning call5552 (depth = 3)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5553 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5554 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5553);
// compiled call node returning call5554 (depth = 5)
// compiled member node returning call5554 (depth = 4)
  *var_lookuptarget = call5554;
  if (call5554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5555 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5556 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5555);
// compiled call node returning call5556 (depth = 4)
// compiled member node returning call5556 (depth = 3)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5558 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5559 == NULL) {
    strlit5559 = alloc_String("identifier");
    gc_root(strlit5559);
  }
// compiled string node returning strlit5559 (depth = 5)
  gc_frame_newslot(strlit5559);
// call case 4: self request
  params[0] = strlit5559;
  partcv[0] = 1;
  Object call5560 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5558);
// compiled call node returning call5560 (depth = 4)
  Object if5557 = done;
  if (istrue(call5560)) {
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5561 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5563 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5562);
// compiled call node returning call5563 (depth = 6)
// compiled member node returning call5563 (depth = 5)
  gc_frame_newslot(call5563);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5564 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5565 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5564);
// compiled call node returning call5565 (depth = 6)
// compiled member node returning call5565 (depth = 5)
  gc_frame_newslot(call5565);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5563;
  params[1] = call5565;
  partcv[0] = 2;
  Object call5566 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5561);
// compiled call node returning call5566 (depth = 4)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5567 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5569 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5568);
// compiled call node returning call5569 (depth = 7)
// compiled member node returning call5569 (depth = 6)
  gc_frame_newslot(call5569);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5571 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5570);
// compiled call node returning call5571 (depth = 7)
// compiled member node returning call5571 (depth = 6)
  params[0] = call5569;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5572 = callmethod(call5571, "new",
    1, partcv, params);
  gc_frame_end(callframe5567);
// compiled call node returning call5572 (depth = 5)
  *var_dro = call5572;
  if (call5572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5573 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5574 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5573);
// compiled call node returning call5574 (depth = 4)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5575 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5576 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5575);
// compiled call node returning call5576 (depth = 5)
// compiled member node returning call5576 (depth = 4)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5578 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5579 == NULL) {
    strlit5579 = alloc_String("dot");
    gc_root(strlit5579);
  }
// compiled string node returning strlit5579 (depth = 6)
  gc_frame_newslot(strlit5579);
// call case 4: self request
  params[0] = strlit5579;
  partcv[0] = 1;
  Object call5580 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5578);
// compiled call node returning call5580 (depth = 5)
  Object if5577 = done;
  if (istrue(call5580)) {
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5581 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5582 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5581);
// compiled call node returning call5582 (depth = 5)
    gc_frame_newslot(call5582);
    if5577 = call5582;
  } else {
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5585 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5586 == NULL) {
    strlit5586 = alloc_String("lgeneric");
    gc_root(strlit5586);
  }
// compiled string node returning strlit5586 (depth = 8)
  gc_frame_newslot(strlit5586);
// call case 4: self request
  params[0] = strlit5586;
  partcv[0] = 1;
  Object call5587 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5585);
// compiled call node returning call5587 (depth = 7)
  int op_slot_right_5584 = gc_frame_newslot(call5587);
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5590 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5591 == NULL) {
    strlit5591 = alloc_String("lsquare");
    gc_root(strlit5591);
  }
// compiled string node returning strlit5591 (depth = 9)
  gc_frame_newslot(strlit5591);
// call case 4: self request
  params[0] = strlit5591;
  partcv[0] = 1;
  Object call5592 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5590);
// compiled call node returning call5592 (depth = 8)
  int op_slot_right_5589 = gc_frame_newslot(call5592);
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5595 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5596 == NULL) {
    strlit5596 = alloc_String("string");
    gc_root(strlit5596);
  }
// compiled string node returning strlit5596 (depth = 10)
  gc_frame_newslot(strlit5596);
// call case 4: self request
  params[0] = strlit5596;
  partcv[0] = 1;
  Object call5597 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5595);
// compiled call node returning call5597 (depth = 9)
  int op_slot_right_5594 = gc_frame_newslot(call5597);
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe5600 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit5601 == NULL) {
    strlit5601 = alloc_String("num");
    gc_root(strlit5601);
  }
// compiled string node returning strlit5601 (depth = 11)
  gc_frame_newslot(strlit5601);
// call case 4: self request
  params[0] = strlit5601;
  partcv[0] = 1;
  Object call5602 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5600);
// compiled call node returning call5602 (depth = 10)
  int op_slot_right_5599 = gc_frame_newslot(call5602);
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5606 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5607 == NULL) {
    strlit5607 = alloc_String("lbrace");
    gc_root(strlit5607);
  }
// compiled string node returning strlit5607 (depth = 13)
  gc_frame_newslot(strlit5607);
// call case 4: self request
  params[0] = strlit5607;
  partcv[0] = 1;
  Object call5608 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5606);
// compiled call node returning call5608 (depth = 12)
  int op_slot_right_5605 = gc_frame_newslot(call5608);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_acceptBlocks (depth = 12)
  int op_slot_left_5605 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call5608;
  partcv[0] = 1;
  Object opresult5610 = callmethod(*var_acceptBlocks, "&&", 1, partcv, params);
// compiled op node returning opresult5610 (depth = 11)
  int op_slot_right_5604 = gc_frame_newslot(opresult5610);
// starting to compile call node (depth = 11)
  int callframe5612 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5613 == NULL) {
    strlit5613 = alloc_String("lparen");
    gc_root(strlit5613);
  }
// compiled string node returning strlit5613 (depth = 12)
  gc_frame_newslot(strlit5613);
// call case 4: self request
  params[0] = strlit5613;
  partcv[0] = 1;
  Object call5614 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5612);
// compiled call node returning call5614 (depth = 11)
  int op_slot_left_5604 = gc_frame_newslot(call5614);
  params[0] = opresult5610;
  partcv[0] = 1;
  Object opresult5615 = callmethod(call5614, "||", 1, partcv, params);
// compiled op node returning opresult5615 (depth = 10)
  int op_slot_left_5599 = gc_frame_newslot(opresult5615);
  params[0] = call5602;
  partcv[0] = 1;
  Object opresult5616 = callmethod(opresult5615, "||", 1, partcv, params);
// compiled op node returning opresult5616 (depth = 9)
  int op_slot_left_5594 = gc_frame_newslot(opresult5616);
  params[0] = call5597;
  partcv[0] = 1;
  Object opresult5617 = callmethod(opresult5616, "||", 1, partcv, params);
// compiled op node returning opresult5617 (depth = 8)
  int op_slot_left_5589 = gc_frame_newslot(opresult5617);
  params[0] = call5592;
  partcv[0] = 1;
  Object opresult5618 = callmethod(opresult5617, "||", 1, partcv, params);
// compiled op node returning opresult5618 (depth = 7)
  int op_slot_left_5584 = gc_frame_newslot(opresult5618);
  params[0] = call5587;
  partcv[0] = 1;
  Object opresult5619 = callmethod(opresult5618, "||", 1, partcv, params);
// compiled op node returning opresult5619 (depth = 6)
  Object if5583 = done;
  if (istrue(opresult5619)) {
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5620 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5621 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5620);
// compiled call node returning call5621 (depth = 6)
    gc_frame_newslot(call5621);
    if5583 = call5621;
  } else {
  }
// compiled if node returning if5583 (depth = 5)
    gc_frame_newslot(if5583);
    if5577 = if5583;
  }
// compiled if node returning if5577 (depth = 4)
    gc_frame_newslot(if5577);
    if5557 = if5577;
  } else {
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5622 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5623 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5624 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5623);
// compiled call node returning call5624 (depth = 8)
// compiled member node returning call5624 (depth = 7)
  partcv[0] = 0;
  Object call5625 = callmethod(call5624, "empty",
    1, partcv, params);
  gc_frame_end(callframe5622);
// compiled call node returning call5625 (depth = 6)
// compiled member node returning call5625 (depth = 5)
  *var_suggestions = call5625;
  if (call5625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5626 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5628 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5627);
// compiled call node returning call5628 (depth = 8)
// compiled member node returning call5628 (depth = 7)
  partcv[0] = 0;
  Object call5629 = callmethod(call5628, "new",
    1, partcv, params);
  gc_frame_end(callframe5626);
// compiled call node returning call5629 (depth = 6)
// compiled member node returning call5629 (depth = 5)
  *var_suggestion = call5629;
  if (call5629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5630 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5631 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe5630);
// compiled call node returning call5631 (depth = 4)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5632 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5633 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5632);
// compiled call node returning call5633 (depth = 4)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5634 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5636 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5635);
// compiled call node returning call5636 (depth = 8)
// compiled member node returning call5636 (depth = 7)
  partcv[0] = 0;
  Object call5637 = callmethod(call5636, "new",
    1, partcv, params);
  gc_frame_end(callframe5634);
// compiled call node returning call5637 (depth = 6)
// compiled member node returning call5637 (depth = 5)
  *var_suggestion = call5637;
  if (call5637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5639 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5640 == NULL) {
    strlit5640 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5640);
  }
// compiled string node returning strlit5640 (depth = 5)
  gc_frame_newslot(strlit5640);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5640;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5641 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5639);
// compiled call node returning call5641 (depth = 4)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5642 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5643 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5642);
// compiled call node returning call5643 (depth = 4)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5644 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5645 == NULL) {
    strlit5645 = alloc_String("a field or method name must follow a '.'.");
    gc_root(strlit5645);
  }
// compiled string node returning strlit5645 (depth = 5)
  gc_frame_newslot(strlit5645);
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5647 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5646);
// compiled call node returning call5647 (depth = 6)
// compiled member node returning call5647 (depth = 5)
  gc_frame_newslot(call5647);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5648 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5649 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5648);
// compiled call node returning call5649 (depth = 6)
// compiled member node returning call5649 (depth = 5)
  gc_frame_newslot(call5649);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5645;
  params[1] = call5647;
  params[2] = call5649;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5650 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5644);
// compiled call node returning call5650 (depth = 4)
    gc_frame_newslot(call5650);
    if5557 = call5650;
  }
// compiled if node returning if5557 (depth = 3)
    gc_frame_newslot(if5557);
    if5543 = if5557;
  } else {
  }
// compiled if node returning if5543 (depth = 2)
  gc_frame_end(frame);
  return if5543;
}
Object meth_parser__apply5729(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5730 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5731 == NULL) {
    strlit5731 = alloc_String("lbrace");
    gc_root(strlit5731);
  }
// compiled string node returning strlit5731 (depth = 7)
  gc_frame_newslot(strlit5731);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit5731;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5732 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5730);
// compiled call node returning call5732 (depth = 6)
  gc_frame_end(frame);
  return call5732;
}
Object meth_parser__apply5776(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5778 == NULL) {
    strlit5778 = alloc_String("member");
    gc_root(strlit5778);
  }
// compiled string node returning strlit5778 (depth = 10)
  int op_slot_right_5777 = gc_frame_newslot(strlit5778);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5780 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call5781 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe5780);
// compiled call node returning call5781 (depth = 11)
// compiled member node returning call5781 (depth = 10)
  int op_slot_left_5777 = gc_frame_newslot(call5781);
  params[0] = strlit5778;
  partcv[0] = 1;
  Object opresult5782 = callmethod(call5781, "==", 1, partcv, params);
// compiled op node returning opresult5782 (depth = 9)
  gc_frame_end(frame);
  return opresult5782;
}
Object meth_parser__apply5785(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object *var_outroot = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 9)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_root (depth = 10)
  *var_outroot = *var_root;
  if (*var_root == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call5788 = callmethod(*var_root, "in",
    1, partcv, params);
  gc_frame_end(callframe5787);
// compiled call node returning call5788 (depth = 11)
// compiled member node returning call5788 (depth = 10)
  *var_root = call5788;
  if (call5788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_callrest5651(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method callrest");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for callrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_btok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "btok");
  Object *var_signature = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "signature");
  Object *var_part = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "part");
  Object *var_hadcall = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "hadcall");
  Object *var_tok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tok");
  Object *var_startInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "startInd");
  Object *var_genericIdents = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "genericIdents");
  Object *var_ar = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "ar");
  Object *var_root = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "root");
  Object *var_outroot = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "outroot");
  Object *var_meth_39_ = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "meth'");
  Object *var_call = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "call");
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5654 = alloc_Float64(0);
// compiled num node returning num5654 (depth = 4)
  int op_slot_right_5653 = gc_frame_newslot(num5654);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5656 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5657 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5656);
// compiled call node returning call5657 (depth = 5)
// compiled member node returning call5657 (depth = 4)
  int op_slot_left_5653 = gc_frame_newslot(call5657);
  params[0] = num5654;
  partcv[0] = 1;
  Object opresult5658 = callmethod(call5657, "==", 1, partcv, params);
// compiled op node returning opresult5658 (depth = 3)
  Object if5652 = done;
  if (istrue(opresult5658)) {
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5659 = alloc_Float64(0);
// compiled num node returning num5659 (depth = 4)
  return num5659;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5652 = undefined;
  } else {
  }
// compiled if node returning if5652 (depth = 2)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5661 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5660);
// compiled call node returning call5661 (depth = 4)
// compiled member node returning call5661 (depth = 3)
  *var_meth = call5661;
  if (call5661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5664 == NULL) {
    strlit5664 = alloc_String("identifier");
    gc_root(strlit5664);
  }
// compiled string node returning strlit5664 (depth = 4)
  int op_slot_right_5663 = gc_frame_newslot(strlit5664);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call5667 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5666);
// compiled call node returning call5667 (depth = 5)
// compiled member node returning call5667 (depth = 4)
  int op_slot_left_5663 = gc_frame_newslot(call5667);
  params[0] = strlit5664;
  partcv[0] = 1;
  Object opresult5668 = callmethod(call5667, "!=", 1, partcv, params);
// compiled op node returning opresult5668 (depth = 3)
  Object if5662 = done;
  if (istrue(opresult5668)) {
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5671 == NULL) {
    strlit5671 = alloc_String("member");
    gc_root(strlit5671);
  }
// compiled string node returning strlit5671 (depth = 5)
  int op_slot_right_5670 = gc_frame_newslot(strlit5671);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call5674 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5673);
// compiled call node returning call5674 (depth = 6)
// compiled member node returning call5674 (depth = 5)
  int op_slot_left_5670 = gc_frame_newslot(call5674);
  params[0] = strlit5671;
  partcv[0] = 1;
  Object opresult5675 = callmethod(call5674, "!=", 1, partcv, params);
// compiled op node returning opresult5675 (depth = 4)
  Object if5669 = done;
  if (istrue(opresult5675)) {
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5676 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5677 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5676);
// compiled call node returning call5677 (depth = 4)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5678 = alloc_Float64(0);
// compiled num node returning num5678 (depth = 5)
  return num5678;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5669 = undefined;
  } else {
  }
// compiled if node returning if5669 (depth = 3)
    gc_frame_newslot(if5669);
    if5662 = if5669;
  } else {
  }
// compiled if node returning if5662 (depth = 2)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5680 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe5679);
// compiled call node returning call5680 (depth = 4)
// compiled member node returning call5680 (depth = 3)
  *var_lnum = call5680;
  if (call5680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5681 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5682 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5681);
// compiled call node returning call5682 (depth = 4)
// compiled member node returning call5682 (depth = 3)
  *var_lpos = call5682;
  if (call5682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5683 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5684 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe5683);
// compiled call node returning call5684 (depth = 4)
// compiled member node returning call5684 (depth = 3)
  *var_methn = call5684;
  if (call5684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5685 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5686 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5687 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5686);
// compiled call node returning call5687 (depth = 4)
// compiled member node returning call5687 (depth = 3)
  gc_frame_newslot(call5687);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5689 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5688);
// compiled call node returning call5689 (depth = 4)
// compiled member node returning call5689 (depth = 3)
  gc_frame_newslot(call5689);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call5687;
  params[1] = call5689;
  partcv[0] = 2;
  Object call5690 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5685);
// compiled call node returning call5690 (depth = 2)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5691 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5691 (depth = 3)
  *var_signature = array5691;
  if (array5691 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5692 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5694 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe5693);
// compiled call node returning call5694 (depth = 6)
// compiled member node returning call5694 (depth = 5)
  partcv[0] = 0;
  Object call5695 = callmethod(call5694, "new",
    1, partcv, params);
  gc_frame_end(callframe5692);
// compiled call node returning call5695 (depth = 4)
// compiled member node returning call5695 (depth = 3)
  *var_part = call5695;
  if (call5695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5696 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5697 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe5696);
// compiled call node returning call5697 (depth = 2)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5698 = alloc_Boolean(0);
// compiled identifier node returning bool5698 (depth = 3)
  *var_hadcall = bool5698;
  if (bool5698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startInd = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5699 = alloc_Boolean(0);
// compiled identifier node returning bool5699 (depth = 3)
  *var_genericIdents = bool5699;
  if (bool5699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5701 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5702 == NULL) {
    strlit5702 = alloc_String("lgeneric");
    gc_root(strlit5702);
  }
// compiled string node returning strlit5702 (depth = 4)
  gc_frame_newslot(strlit5702);
// call case 4: self request
  params[0] = strlit5702;
  partcv[0] = 1;
  Object call5703 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5701);
// compiled call node returning call5703 (depth = 3)
  Object if5700 = done;
  if (istrue(call5703)) {
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5704 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5705 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5704);
// compiled call node returning call5705 (depth = 5)
// compiled member node returning call5705 (depth = 4)
  *var_genericIdents = call5705;
  if (call5705 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5700 = done;
  } else {
  }
// compiled if node returning if5700 (depth = 2)
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5708 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5709 == NULL) {
    strlit5709 = alloc_String("lparen");
    gc_root(strlit5709);
  }
// compiled string node returning strlit5709 (depth = 4)
  gc_frame_newslot(strlit5709);
// call case 4: self request
  params[0] = strlit5709;
  partcv[0] = 1;
  Object call5710 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5708);
// compiled call node returning call5710 (depth = 3)
  Object if5707 = done;
  if (istrue(call5710)) {
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5711 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5713 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5712);
// compiled call node returning call5713 (depth = 5)
// compiled member node returning call5713 (depth = 4)
  gc_frame_newslot(call5713);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call5713;
  partcv[0] = 1;
  Object call5714 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5711);
// compiled call node returning call5714 (depth = 3)
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5715 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5717 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5716);
// compiled call node returning call5717 (depth = 5)
// compiled member node returning call5717 (depth = 4)
  gc_frame_newslot(call5717);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call5717;
  partcv[0] = 1;
  Object call5718 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5715);
// compiled call node returning call5718 (depth = 3)
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5719 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methn (depth = 4)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5720 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5719);
// compiled call node returning call5720 (depth = 3)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5722 = alloc_Boolean(1);
// compiled identifier node returning bool5722 (depth = 4)
  *var_hadcall = bool5722;
  if (bool5722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5724 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// call case 4: self request
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5725 = callmethodflags(self, "parenthesizedArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5724);
// compiled call node returning call5725 (depth = 3)
    gc_frame_newslot(call5725);
    if5707 = call5725;
  } else {
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block5728 = alloc_Block(NULL, NULL, "parser", 1776);
  gc_frame_newslot(block5728);
// method "_apply"
  block_savedest(block5728);
  Object closure5729 = createclosure(2, "_apply");
  setclosureframe(closure5729, stackframe);
  addtoclosure(closure5729, var_tok);
  addtoclosure(closure5729, selfslot);
  struct UserObject *uo5729 = (struct UserObject*)block5728;
  uo5729->data[0] = (Object)closure5729;
  Method *meth_meth_parser__apply5729 = addmethod2pos(block5728, "_apply", &meth_parser__apply5729, 0);
  int argcv_meth_parser__apply5729[] = {0};
  meth_meth_parser__apply5729->type = alloc_MethodType(1, argcv_meth_parser__apply5729);
  meth_meth_parser__apply5729->definitionModule = modulename;
  meth_meth_parser__apply5729->definitionLine = 1771;
// compiled block node returning block5728 (depth = 5)
  int op_slot_right_5727 = gc_frame_newslot(block5728);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5735 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  partcv[0] = 0;
  Object call5736 = callmethod(*var_acceptBlocks, "not",
    1, partcv, params);
  gc_frame_end(callframe5735);
// compiled call node returning call5736 (depth = 6)
// compiled member node returning call5736 (depth = 5)
  int op_slot_left_5727 = gc_frame_newslot(call5736);
  params[0] = block5728;
  partcv[0] = 1;
  Object opresult5737 = callmethod(call5736, "&&", 1, partcv, params);
// compiled op node returning opresult5737 (depth = 4)
  Object if5726 = done;
  if (istrue(opresult5737)) {
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5738 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5739 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5738);
// compiled call node returning call5739 (depth = 4)
    gc_frame_newslot(call5739);
    if5726 = call5739;
  } else {
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5741 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call5742 = callmethodflags(self, "acceptArgumentOnLineOf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5741);
// compiled call node returning call5742 (depth = 5)
  Object if5740 = done;
  if (istrue(call5742)) {
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5744 = alloc_Boolean(1);
// compiled identifier node returning bool5744 (depth = 6)
  *var_hadcall = bool5744;
  if (bool5744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5746 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5747 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5746);
// compiled call node returning call5747 (depth = 5)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5749 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5748);
// compiled call node returning call5749 (depth = 6)
// compiled member node returning call5749 (depth = 5)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call5751 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5750);
// compiled call node returning call5751 (depth = 7)
// compiled member node returning call5751 (depth = 6)
  *var_ar = call5751;
  if (call5751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5752 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ar (depth = 6)
  gc_frame_newslot(*var_ar);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call5754 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5753);
// compiled call node returning call5754 (depth = 7)
// compiled member node returning call5754 (depth = 6)
  params[0] = *var_ar;
  partcv[0] = 1;
  Object call5755 = callmethod(call5754, "push",
    1, partcv, params);
  gc_frame_end(callframe5752);
// compiled call node returning call5755 (depth = 5)
    gc_frame_newslot(call5755);
    if5740 = call5755;
  } else {
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5758 == NULL) {
    strlit5758 = alloc_String("identifier");
    gc_root(strlit5758);
  }
// compiled string node returning strlit5758 (depth = 7)
  int op_slot_right_5757 = gc_frame_newslot(strlit5758);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call5761 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5760);
// compiled call node returning call5761 (depth = 8)
// compiled member node returning call5761 (depth = 7)
  int op_slot_left_5757 = gc_frame_newslot(call5761);
  params[0] = strlit5758;
  partcv[0] = 1;
  Object opresult5762 = callmethod(call5761, "==", 1, partcv, params);
// compiled op node returning opresult5762 (depth = 6)
  Object if5756 = done;
  if (istrue(opresult5762)) {
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5763 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5764 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5763);
// compiled call node returning call5764 (depth = 6)
    gc_frame_newslot(call5764);
    if5756 = call5764;
  } else {
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5767 == NULL) {
    strlit5767 = alloc_String("member");
    gc_root(strlit5767);
  }
// compiled string node returning strlit5767 (depth = 8)
  int op_slot_right_5766 = gc_frame_newslot(strlit5767);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5769 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call5770 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5769);
// compiled call node returning call5770 (depth = 9)
// compiled member node returning call5770 (depth = 8)
  int op_slot_left_5766 = gc_frame_newslot(call5770);
  params[0] = strlit5767;
  partcv[0] = 1;
  Object opresult5771 = callmethod(call5770, "==", 1, partcv, params);
// compiled op node returning opresult5771 (depth = 7)
  Object if5765 = done;
  if (istrue(opresult5771)) {
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5772 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call5773 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe5772);
// compiled call node returning call5773 (depth = 9)
// compiled member node returning call5773 (depth = 8)
  *var_root = call5773;
  if (call5773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  *var_outroot = *var_meth;
  if (*var_meth == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5774 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block5775 = alloc_Block(NULL, NULL, "parser", 1790);
  gc_frame_newslot(block5775);
// method "_apply"
  block_savedest(block5775);
  Object closure5776 = createclosure(2, "_apply");
  setclosureframe(closure5776, stackframe);
  addtoclosure(closure5776, var_root);
  addtoclosure(closure5776, selfslot);
  struct UserObject *uo5776 = (struct UserObject*)block5775;
  uo5776->data[0] = (Object)closure5776;
  Method *meth_meth_parser__apply5776 = addmethod2pos(block5775, "_apply", &meth_parser__apply5776, 0);
  int argcv_meth_parser__apply5776[] = {0};
  meth_meth_parser__apply5776->type = alloc_MethodType(1, argcv_meth_parser__apply5776);
  meth_meth_parser__apply5776->definitionModule = modulename;
  meth_meth_parser__apply5776->definitionLine = 1788;
// compiled block node returning block5775 (depth = 8)
  gc_frame_newslot(block5775);
// starting to compile block node (depth = 8)
  Object block5784 = alloc_Block(NULL, NULL, "parser", 1790);
  gc_frame_newslot(block5784);
// method "_apply"
  block_savedest(block5784);
  Object closure5785 = createclosure(3, "_apply");
  setclosureframe(closure5785, stackframe);
  addtoclosure(closure5785, var_root);
  addtoclosure(closure5785, var_outroot);
  addtoclosure(closure5785, selfslot);
  struct UserObject *uo5785 = (struct UserObject*)block5784;
  uo5785->data[0] = (Object)closure5785;
  Method *meth_meth_parser__apply5785 = addmethod2pos(block5784, "_apply", &meth_parser__apply5785, 0);
  int argcv_meth_parser__apply5785[] = {0};
  meth_meth_parser__apply5785->type = alloc_MethodType(1, argcv_meth_parser__apply5785);
  meth_meth_parser__apply5785->definitionModule = modulename;
  meth_meth_parser__apply5785->definitionLine = 1790;
// compiled block node returning block5784 (depth = 8)
  gc_frame_newslot(block5784);
// call case 5: prelude request
  params[0] = block5775;
  params[1] = block5784;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5791 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5774);
// compiled call node returning call5791 (depth = 7)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5794 == NULL) {
    strlit5794 = alloc_String("identifier");
    gc_root(strlit5794);
  }
// compiled string node returning strlit5794 (depth = 9)
  int op_slot_right_5793 = gc_frame_newslot(strlit5794);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5796 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_root (depth = 11)
  partcv[0] = 0;
  Object call5797 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe5796);
// compiled call node returning call5797 (depth = 10)
// compiled member node returning call5797 (depth = 9)
  int op_slot_left_5793 = gc_frame_newslot(call5797);
  params[0] = strlit5794;
  partcv[0] = 1;
  Object opresult5798 = callmethod(call5797, "==", 1, partcv, params);
// compiled op node returning opresult5798 (depth = 8)
  Object if5792 = done;
  if (istrue(opresult5798)) {
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5799 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5800 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5799);
// compiled call node returning call5800 (depth = 8)
    gc_frame_newslot(call5800);
    if5792 = call5800;
  } else {
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5801 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_genericIdents (depth = 9)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5802 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5801);
// compiled call node returning call5802 (depth = 8)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5803 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5804 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5803);
// compiled call node returning call5804 (depth = 8)
    gc_frame_newslot(call5804);
    if5792 = call5804;
  }
// compiled if node returning if5792 (depth = 7)
    gc_frame_newslot(if5792);
    if5765 = if5792;
  } else {
  }
// compiled if node returning if5765 (depth = 6)
    gc_frame_newslot(if5765);
    if5756 = if5765;
  }
// compiled if node returning if5756 (depth = 5)
    gc_frame_newslot(if5756);
    if5740 = if5756;
  }
// compiled if node returning if5740 (depth = 4)
    gc_frame_newslot(if5740);
    if5726 = if5740;
  }
// compiled if node returning if5726 (depth = 3)
    gc_frame_newslot(if5726);
    if5707 = if5726;
  }
// compiled if node returning if5707 (depth = 2)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_hadcall (depth = 3)
  Object if5805 = done;
  if (istrue(*var_hadcall)) {
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5807 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5808 == NULL) {
    strlit5808 = alloc_String("identifier");
    gc_root(strlit5808);
  }
// compiled string node returning strlit5808 (depth = 5)
  gc_frame_newslot(strlit5808);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit5808;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5809 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5807);
// compiled call node returning call5809 (depth = 4)
  Object if5806 = done;
  if (istrue(call5809)) {
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5810 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// starting to compile identifier node (depth = 6)
  Object bool5811 = alloc_Boolean(0);
// compiled identifier node returning bool5811 (depth = 6)
  gc_frame_newslot(bool5811);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5813 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe5812);
// compiled call node returning call5813 (depth = 7)
// compiled member node returning call5813 (depth = 6)
  params[0] = *var_methn;
  params[1] = bool5811;
  partcv[0] = 2;
  Object call5814 = callmethod(call5813, "new",
    1, partcv, params);
  gc_frame_end(callframe5810);
// compiled call node returning call5814 (depth = 5)
  *var_meth_39_ = call5814;
  if (call5814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5815 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lnum (depth = 5)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth_39_ (depth = 5)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call5816 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5815);
// compiled call node returning call5816 (depth = 4)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5817 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lpos (depth = 5)
  gc_frame_newslot(*var_lpos);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth_39_ (depth = 5)
  params[0] = *var_lpos;
  partcv[0] = 1;
  Object call5818 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5817);
// compiled call node returning call5818 (depth = 4)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5819 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  gc_frame_newslot(*var_meth_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_meth_39_;
  params[1] = *var_signature;
  params[2] = *var_tok;
  partcv[0] = 3;
  Object call5820 = callmethodflags(self, "callmprest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5819);
// compiled call node returning call5820 (depth = 5)
  *var_methn = call5820;
  if (call5820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5824 == NULL) {
    strlit5824 = alloc_String("member");
    gc_root(strlit5824);
  }
// compiled string node returning strlit5824 (depth = 6)
  int op_slot_right_5823 = gc_frame_newslot(strlit5824);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call5827 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5826);
// compiled call node returning call5827 (depth = 7)
// compiled member node returning call5827 (depth = 6)
  int op_slot_left_5823 = gc_frame_newslot(call5827);
  params[0] = strlit5824;
  partcv[0] = 1;
  Object opresult5828 = callmethod(call5827, "==", 1, partcv, params);
// compiled op node returning opresult5828 (depth = 5)
  Object if5822 = done;
  if (istrue(opresult5828)) {
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5829 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call5831 = callmethod(*var_methn, "value",
    1, partcv, params);
  gc_frame_end(callframe5830);
// compiled call node returning call5831 (depth = 8)
// compiled member node returning call5831 (depth = 7)
  gc_frame_newslot(call5831);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5832 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call5833 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe5832);
// compiled call node returning call5833 (depth = 8)
// compiled member node returning call5833 (depth = 7)
  gc_frame_newslot(call5833);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call5835 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5834);
// compiled call node returning call5835 (depth = 8)
// compiled member node returning call5835 (depth = 7)
  params[0] = call5831;
  params[1] = call5833;
  partcv[0] = 2;
  Object call5836 = callmethod(call5835, "new",
    1, partcv, params);
  gc_frame_end(callframe5829);
// compiled call node returning call5836 (depth = 6)
  *var_meth = call5836;
  if (call5836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5838 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methn (depth = 8)
  partcv[0] = 0;
  Object call5840 = callmethod(*var_methn, "line",
    1, partcv, params);
  gc_frame_end(callframe5839);
// compiled call node returning call5840 (depth = 7)
// compiled member node returning call5840 (depth = 6)
  gc_frame_newslot(call5840);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = call5840;
  partcv[0] = 1;
  Object call5841 = callmethod(*var_meth, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5838);
// compiled call node returning call5841 (depth = 5)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5842 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5843 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methn (depth = 8)
  partcv[0] = 0;
  Object call5844 = callmethod(*var_methn, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5843);
// compiled call node returning call5844 (depth = 7)
// compiled member node returning call5844 (depth = 6)
  gc_frame_newslot(call5844);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = call5844;
  partcv[0] = 1;
  Object call5845 = callmethod(*var_meth, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5842);
// compiled call node returning call5845 (depth = 5)
    gc_frame_newslot(call5845);
    if5822 = call5845;
  } else {
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  *var_meth = *var_methn;
  if (*var_methn == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5822 = done;
  }
// compiled if node returning if5822 (depth = 4)
    gc_frame_newslot(if5822);
    if5806 = if5822;
  } else {
  }
// compiled if node returning if5806 (depth = 3)
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5847 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lnum (depth = 4)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call5848 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe5847);
// compiled call node returning call5848 (depth = 3)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5849 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5851 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe5850);
// compiled call node returning call5851 (depth = 6)
// compiled member node returning call5851 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  partcv[0] = 2;
  Object call5852 = callmethod(call5851, "new",
    1, partcv, params);
  gc_frame_end(callframe5849);
// compiled call node returning call5852 (depth = 4)
  *var_call = call5852;
  if (call5852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5853 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genericIdents (depth = 4)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5854 = callmethod(*var_call, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5853);
// compiled call node returning call5854 (depth = 3)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5855 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call5856 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5855);
// compiled call node returning call5856 (depth = 3)
    gc_frame_newslot(call5856);
    if5805 = call5856;
  } else {
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5859 = alloc_Boolean(0);
// compiled identifier node returning bool5859 (depth = 5)
  int op_slot_right_5858 = gc_frame_newslot(bool5859);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  int op_slot_left_5858 = gc_frame_newslot(*var_genericIdents);
  params[0] = bool5859;
  partcv[0] = 1;
  Object opresult5861 = callmethod(*var_genericIdents, "!=", 1, partcv, params);
// compiled op node returning opresult5861 (depth = 4)
  Object if5857 = done;
  if (istrue(opresult5861)) {
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5862 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5863 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5862);
// compiled call node returning call5863 (depth = 4)
    gc_frame_newslot(call5863);
    if5857 = call5863;
  } else {
  }
// compiled if node returning if5857 (depth = 3)
    gc_frame_newslot(if5857);
    if5805 = if5857;
  }
// compiled if node returning if5805 (depth = 2)
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startInd (depth = 3)
  *var_minIndentLevel = *var_startInd;
  if (*var_startInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5865 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5866 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5865);
// compiled call node returning call5866 (depth = 2)
  gc_frame_end(frame);
  return call5866;
}
Object meth_parser__apply5872(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5873 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blocksOK (depth = 5)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5874 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5873);
// compiled call node returning call5874 (depth = 4)
  gc_frame_end(frame);
  return call5874;
}
Object meth_parser__apply5951(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe5952 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5953 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5952);
// compiled call node returning call5953 (depth = 10)
  gc_frame_end(frame);
  return call5953;
}
Object meth_parser__apply6015(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe6016 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6017 == NULL) {
    strlit6017 = alloc_String("comma");
    gc_root(strlit6017);
  }
// compiled string node returning strlit6017 (depth = 7)
  gc_frame_newslot(strlit6017);
// call case 4: self request
  params[0] = strlit6017;
  partcv[0] = 1;
  Object call6018 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6016);
// compiled call node returning call6018 (depth = 6)
  gc_frame_end(frame);
  return call6018;
}
Object meth_parser__apply6034(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6035 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6036 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6035);
// compiled call node returning call6036 (depth = 11)
  gc_frame_end(frame);
  return call6036;
}
Object meth_parser__apply6159(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe6160 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6161 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6160);
// compiled call node returning call6161 (depth = 12)
  gc_frame_end(frame);
  return call6161;
}
Object meth_parser__apply6021(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arg = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arg");
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6022 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call6024 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6023);
// compiled call node returning call6024 (depth = 8)
// compiled member node returning call6024 (depth = 7)
  gc_frame_newslot(call6024);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call6026 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6025);
// compiled call node returning call6026 (depth = 8)
// compiled member node returning call6026 (depth = 7)
  params[0] = call6024;
  partcv[0] = 1;
  Object call6027 = callmethod(call6026, "push",
    1, partcv, params);
  gc_frame_end(callframe6022);
// compiled call node returning call6027 (depth = 6)
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6028 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6029 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6028);
// compiled call node returning call6029 (depth = 7)
// compiled member node returning call6029 (depth = 6)
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6031 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6032 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6033 = alloc_Block(NULL, NULL, "parser", 1872);
  gc_frame_newslot(block6033);
// method "_apply"
  block_savedest(block6033);
  Object closure6034 = createclosure(2, "_apply");
  setclosureframe(closure6034, stackframe);
  addtoclosure(closure6034, var_blocksOK);
  addtoclosure(closure6034, selfslot);
  struct UserObject *uo6034 = (struct UserObject*)block6033;
  uo6034->data[0] = (Object)closure6034;
  Method *meth_meth_parser__apply6034 = addmethod2pos(block6033, "_apply", &meth_parser__apply6034, 0);
  int argcv_meth_parser__apply6034[] = {0};
  meth_meth_parser__apply6034->type = alloc_MethodType(1, argcv_meth_parser__apply6034);
  meth_meth_parser__apply6034->definitionModule = modulename;
  meth_meth_parser__apply6034->definitionLine = 1872;
// compiled block node returning block6033 (depth = 10)
  gc_frame_newslot(block6033);
// call case 4: self request
  params[0] = block6033;
  partcv[0] = 1;
  Object call6038 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6032);
// compiled call node returning call6038 (depth = 9)
  partcv[0] = 0;
  Object call6039 = callmethod(call6038, "not",
    1, partcv, params);
  gc_frame_end(callframe6031);
// compiled call node returning call6039 (depth = 8)
// compiled member node returning call6039 (depth = 7)
  Object if6030 = done;
  if (istrue(call6039)) {
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6040 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6041 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6042 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6041);
// compiled call node returning call6042 (depth = 11)
// compiled member node returning call6042 (depth = 10)
  partcv[0] = 0;
  Object call6043 = callmethod(call6042, "empty",
    1, partcv, params);
  gc_frame_end(callframe6040);
// compiled call node returning call6043 (depth = 9)
// compiled member node returning call6043 (depth = 8)
  *var_suggestions = call6043;
  if (call6043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6044 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6045 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6046 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6045);
// compiled call node returning call6046 (depth = 11)
// compiled member node returning call6046 (depth = 10)
  partcv[0] = 0;
  Object call6047 = callmethod(call6046, "new",
    1, partcv, params);
  gc_frame_end(callframe6044);
// compiled call node returning call6047 (depth = 9)
// compiled member node returning call6047 (depth = 8)
  *var_suggestion = call6047;
  if (call6047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6048 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array6049 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit6050 == NULL) {
    strlit6050 = alloc_String("rparen");
    gc_root(strlit6050);
  }
// compiled string node returning strlit6050 (depth = 10)
  params[0] = strlit6050;
  partcv[0] = 1;
  callmethod(array6049, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6049 (depth = 9)
  gc_frame_newslot(array6049);
// call case 4: self request
  params[0] = array6049;
  partcv[0] = 1;
  Object call6051 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6048);
// compiled call node returning call6051 (depth = 8)
  *var_nextTok = call6051;
  if (call6051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6053 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6053 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6055 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6055 (depth = 8)
  Object if6052 = done;
  if (istrue(opresult6055)) {
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6056 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6057 == NULL) {
    strlit6057 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6057);
  }
// compiled string node returning strlit6057 (depth = 9)
  gc_frame_newslot(strlit6057);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6057;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6058 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6056);
// compiled call node returning call6058 (depth = 8)
    gc_frame_newslot(call6058);
    if6052 = call6058;
  } else {
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6059 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6061 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6060);
// compiled call node returning call6061 (depth = 10)
// compiled member node returning call6061 (depth = 9)
  gc_frame_newslot(call6061);
// starting to compile identifier node (depth = 9)
  Object bool6062 = alloc_Boolean(1);
// compiled identifier node returning bool6062 (depth = 9)
  gc_frame_newslot(bool6062);
// starting to compile identifier node (depth = 9)
  Object bool6063 = alloc_Boolean(0);
// compiled identifier node returning bool6063 (depth = 9)
  gc_frame_newslot(bool6063);
// starting to compile string node (depth = 9)
  if (strlit6064 == NULL) {
    strlit6064 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6064);
  }
// compiled string node returning strlit6064 (depth = 9)
  gc_frame_newslot(strlit6064);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6061;
  params[2] = bool6062;
  params[3] = bool6063;
  params[4] = strlit6064;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6065 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6059);
// compiled call node returning call6065 (depth = 8)
    gc_frame_newslot(call6065);
    if6052 = call6065;
  }
// compiled if node returning if6052 (depth = 7)
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6066 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6067 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6066);
// compiled call node returning call6067 (depth = 7)
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6068 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6070 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6069);
// compiled call node returning call6070 (depth = 11)
// compiled member node returning call6070 (depth = 10)
  partcv[0] = 0;
  Object call6071 = callmethod(call6070, "new",
    1, partcv, params);
  gc_frame_end(callframe6068);
// compiled call node returning call6071 (depth = 9)
// compiled member node returning call6071 (depth = 8)
  *var_suggestion = call6071;
  if (call6071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6073 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6074 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call6075 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6074);
// compiled call node returning call6075 (depth = 9)
// compiled member node returning call6075 (depth = 8)
  gc_frame_newslot(call6075);
// starting to compile identifier node (depth = 8)
  Object bool6076 = alloc_Boolean(1);
// compiled identifier node returning bool6076 (depth = 8)
  gc_frame_newslot(bool6076);
// starting to compile identifier node (depth = 8)
  Object bool6077 = alloc_Boolean(0);
// compiled identifier node returning bool6077 (depth = 8)
  gc_frame_newslot(bool6077);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call6075;
  params[2] = bool6076;
  params[3] = bool6077;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6078 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6073);
// compiled call node returning call6078 (depth = 7)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6079 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6080 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6079);
// compiled call node returning call6080 (depth = 7)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6081 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6082 == NULL) {
    strlit6082 = alloc_String("a method request must have an expression after a ','.");
    gc_root(strlit6082);
  }
// compiled string node returning strlit6082 (depth = 8)
  gc_frame_newslot(strlit6082);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6084 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6083);
// compiled call node returning call6084 (depth = 9)
// compiled member node returning call6084 (depth = 8)
  gc_frame_newslot(call6084);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6086 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6085);
// compiled call node returning call6086 (depth = 9)
// compiled member node returning call6086 (depth = 8)
  gc_frame_newslot(call6086);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6082;
  params[1] = call6084;
  params[2] = call6086;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6087 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6081);
// compiled call node returning call6087 (depth = 7)
    gc_frame_newslot(call6087);
    if6030 = call6087;
  } else {
  }
// compiled if node returning if6030 (depth = 6)
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6089 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6090 == NULL) {
    strlit6090 = alloc_String("colon");
    gc_root(strlit6090);
  }
// compiled string node returning strlit6090 (depth = 8)
  gc_frame_newslot(strlit6090);
// call case 4: self request
  params[0] = strlit6090;
  partcv[0] = 1;
  Object call6091 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6089);
// compiled call node returning call6091 (depth = 7)
  Object if6088 = done;
  if (istrue(call6091)) {
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6092 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6093 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6092);
// compiled call node returning call6093 (depth = 9)
// compiled member node returning call6093 (depth = 8)
  *var_arg = call6093;
  if (call6093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6096 == NULL) {
    strlit6096 = alloc_String("identifier");
    gc_root(strlit6096);
  }
// compiled string node returning strlit6096 (depth = 9)
  int op_slot_right_6095 = gc_frame_newslot(strlit6096);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  partcv[0] = 0;
  Object call6099 = callmethod(*var_arg, "kind",
    1, partcv, params);
  gc_frame_end(callframe6098);
// compiled call node returning call6099 (depth = 10)
// compiled member node returning call6099 (depth = 9)
  int op_slot_left_6095 = gc_frame_newslot(call6099);
  params[0] = strlit6096;
  partcv[0] = 1;
  Object opresult6100 = callmethod(call6099, "!=", 1, partcv, params);
// compiled op node returning opresult6100 (depth = 8)
  Object if6094 = done;
  if (istrue(opresult6100)) {
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6101 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6102 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6103 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6102);
// compiled call node returning call6103 (depth = 12)
// compiled member node returning call6103 (depth = 11)
  partcv[0] = 0;
  Object call6104 = callmethod(call6103, "new",
    1, partcv, params);
  gc_frame_end(callframe6101);
// compiled call node returning call6104 (depth = 10)
// compiled member node returning call6104 (depth = 9)
  *var_suggestion = call6104;
  if (call6104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6107 == NULL) {
    strlit6107 = alloc_String("identifier");
    gc_root(strlit6107);
  }
// compiled string node returning strlit6107 (depth = 10)
  int op_slot_right_6106 = gc_frame_newslot(strlit6107);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6109 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6111 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6110);
// compiled call node returning call6111 (depth = 13)
// compiled member node returning call6111 (depth = 12)
  partcv[0] = 0;
  Object call6112 = callmethod(call6111, "kind",
    1, partcv, params);
  gc_frame_end(callframe6109);
// compiled call node returning call6112 (depth = 11)
// compiled member node returning call6112 (depth = 10)
  int op_slot_left_6106 = gc_frame_newslot(call6112);
  params[0] = strlit6107;
  partcv[0] = 1;
  Object opresult6113 = callmethod(call6112, "==", 1, partcv, params);
// compiled op node returning opresult6113 (depth = 9)
  Object if6105 = done;
  if (istrue(opresult6113)) {
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6114 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6116 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6115);
// compiled call node returning call6116 (depth = 11)
// compiled member node returning call6116 (depth = 10)
  gc_frame_newslot(call6116);
// starting to compile identifier node (depth = 10)
  Object bool6117 = alloc_Boolean(1);
// compiled identifier node returning bool6117 (depth = 10)
  gc_frame_newslot(bool6117);
// starting to compile identifier node (depth = 10)
  Object bool6118 = alloc_Boolean(0);
// compiled identifier node returning bool6118 (depth = 10)
  gc_frame_newslot(bool6118);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6116;
  params[2] = bool6117;
  params[3] = bool6118;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6119 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6114);
// compiled call node returning call6119 (depth = 9)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6120 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6121 == NULL) {
    strlit6121 = alloc_String("only declarations may be followed by a ':' and a type.");
    gc_root(strlit6121);
  }
// compiled string node returning strlit6121 (depth = 10)
  gc_frame_newslot(strlit6121);
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6123 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6122);
// compiled call node returning call6123 (depth = 11)
// compiled member node returning call6123 (depth = 10)
  gc_frame_newslot(call6123);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6125 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6124);
// compiled call node returning call6125 (depth = 11)
// compiled member node returning call6125 (depth = 10)
  gc_frame_newslot(call6125);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6127 = alloc_Float64(1);
// compiled num node returning num6127 (depth = 11)
  int op_slot_right_6126 = gc_frame_newslot(num6127);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6130 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe6131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call6132 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6131);
// compiled call node returning call6132 (depth = 15)
// compiled member node returning call6132 (depth = 14)
  partcv[0] = 0;
  Object call6133 = callmethod(call6132, "size",
    1, partcv, params);
  gc_frame_end(callframe6130);
// compiled call node returning call6133 (depth = 13)
// compiled member node returning call6133 (depth = 12)
  int op_slot_right_6129 = gc_frame_newslot(call6133);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6135 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe6136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call6137 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6136);
// compiled call node returning call6137 (depth = 15)
// compiled member node returning call6137 (depth = 14)
  partcv[0] = 0;
  Object call6138 = callmethod(call6137, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6135);
// compiled call node returning call6138 (depth = 13)
// compiled member node returning call6138 (depth = 12)
  int op_slot_left_6129 = gc_frame_newslot(call6138);
  params[0] = call6133;
  partcv[0] = 1;
  Object sum6139 = callmethod(call6138, "+", 1, partcv, params);
// compiled op node returning sum6139 (depth = 11)
  int op_slot_left_6126 = gc_frame_newslot(sum6139);
  params[0] = num6127;
  partcv[0] = 1;
  Object diff6140 = callmethod(sum6139, "-", 1, partcv, params);
// compiled op node returning diff6140 (depth = 10)
  gc_frame_newslot(diff6140);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6121;
  params[1] = call6123;
  params[2] = call6125;
  params[3] = diff6140;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6141 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6120);
// compiled call node returning call6141 (depth = 9)
    gc_frame_newslot(call6141);
    if6105 = call6141;
  } else {
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6142 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6143 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe6142);
// compiled call node returning call6143 (depth = 9)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6144 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6145 == NULL) {
    strlit6145 = alloc_String("only declarations may be followed by a ':' and a type.");
    gc_root(strlit6145);
  }
// compiled string node returning strlit6145 (depth = 10)
  gc_frame_newslot(strlit6145);
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6147 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6146);
// compiled call node returning call6147 (depth = 11)
// compiled member node returning call6147 (depth = 10)
  gc_frame_newslot(call6147);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6149 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6148);
// compiled call node returning call6149 (depth = 11)
// compiled member node returning call6149 (depth = 10)
  gc_frame_newslot(call6149);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6151 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6150);
// compiled call node returning call6151 (depth = 11)
// compiled member node returning call6151 (depth = 10)
  gc_frame_newslot(call6151);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6145;
  params[1] = call6147;
  params[2] = call6149;
  params[3] = call6151;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6152 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6144);
// compiled call node returning call6152 (depth = 9)
    gc_frame_newslot(call6152);
    if6105 = call6152;
  }
// compiled if node returning if6105 (depth = 8)
    gc_frame_newslot(if6105);
    if6094 = if6105;
  } else {
  }
// compiled if node returning if6094 (depth = 7)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6154 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6153);
// compiled call node returning call6154 (depth = 8)
// compiled member node returning call6154 (depth = 7)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6156 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6157 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block6158 = alloc_Block(NULL, NULL, "parser", 1904);
  gc_frame_newslot(block6158);
// method "_apply"
  block_savedest(block6158);
  Object closure6159 = createclosure(2, "_apply");
  setclosureframe(closure6159, stackframe);
  addtoclosure(closure6159, var_blocksOK);
  addtoclosure(closure6159, selfslot);
  struct UserObject *uo6159 = (struct UserObject*)block6158;
  uo6159->data[0] = (Object)closure6159;
  Method *meth_meth_parser__apply6159 = addmethod2pos(block6158, "_apply", &meth_parser__apply6159, 0);
  int argcv_meth_parser__apply6159[] = {0};
  meth_meth_parser__apply6159->type = alloc_MethodType(1, argcv_meth_parser__apply6159);
  meth_meth_parser__apply6159->definitionModule = modulename;
  meth_meth_parser__apply6159->definitionLine = 1904;
// compiled block node returning block6158 (depth = 11)
  gc_frame_newslot(block6158);
// call case 4: self request
  params[0] = block6158;
  partcv[0] = 1;
  Object call6163 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6157);
// compiled call node returning call6163 (depth = 10)
  partcv[0] = 0;
  Object call6164 = callmethod(call6163, "not",
    1, partcv, params);
  gc_frame_end(callframe6156);
// compiled call node returning call6164 (depth = 9)
// compiled member node returning call6164 (depth = 8)
  Object if6155 = done;
  if (istrue(call6164)) {
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6166 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6165);
// compiled call node returning call6166 (depth = 9)
// compiled member node returning call6166 (depth = 8)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6167 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6168 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6169 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6168);
// compiled call node returning call6169 (depth = 12)
// compiled member node returning call6169 (depth = 11)
  partcv[0] = 0;
  Object call6170 = callmethod(call6169, "empty",
    1, partcv, params);
  gc_frame_end(callframe6167);
// compiled call node returning call6170 (depth = 10)
// compiled member node returning call6170 (depth = 9)
  *var_suggestions = call6170;
  if (call6170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6171 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6173 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6172);
// compiled call node returning call6173 (depth = 12)
// compiled member node returning call6173 (depth = 11)
  partcv[0] = 0;
  Object call6174 = callmethod(call6173, "new",
    1, partcv, params);
  gc_frame_end(callframe6171);
// compiled call node returning call6174 (depth = 10)
// compiled member node returning call6174 (depth = 9)
  *var_suggestion = call6174;
  if (call6174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6175 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array6176 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit6177 == NULL) {
    strlit6177 = alloc_String("rparen");
    gc_root(strlit6177);
  }
// compiled string node returning strlit6177 (depth = 11)
  params[0] = strlit6177;
  partcv[0] = 1;
  callmethod(array6176, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6176 (depth = 10)
  gc_frame_newslot(array6176);
// call case 4: self request
  params[0] = array6176;
  partcv[0] = 1;
  Object call6178 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6175);
// compiled call node returning call6178 (depth = 9)
  *var_nextTok = call6178;
  if (call6178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6180 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6180 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6182 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6182 (depth = 9)
  Object if6179 = done;
  if (istrue(opresult6182)) {
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6183 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6184 == NULL) {
    strlit6184 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6184);
  }
// compiled string node returning strlit6184 (depth = 10)
  gc_frame_newslot(strlit6184);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6184;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6185 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6183);
// compiled call node returning call6185 (depth = 9)
    gc_frame_newslot(call6185);
    if6179 = call6185;
  } else {
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6186 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call6188 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6187);
// compiled call node returning call6188 (depth = 11)
// compiled member node returning call6188 (depth = 10)
  gc_frame_newslot(call6188);
// starting to compile identifier node (depth = 10)
  Object bool6189 = alloc_Boolean(1);
// compiled identifier node returning bool6189 (depth = 10)
  gc_frame_newslot(bool6189);
// starting to compile identifier node (depth = 10)
  Object bool6190 = alloc_Boolean(0);
// compiled identifier node returning bool6190 (depth = 10)
  gc_frame_newslot(bool6190);
// starting to compile string node (depth = 10)
  if (strlit6191 == NULL) {
    strlit6191 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6191);
  }
// compiled string node returning strlit6191 (depth = 10)
  gc_frame_newslot(strlit6191);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6188;
  params[2] = bool6189;
  params[3] = bool6190;
  params[4] = strlit6191;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6192 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6186);
// compiled call node returning call6192 (depth = 9)
    gc_frame_newslot(call6192);
    if6179 = call6192;
  }
// compiled if node returning if6179 (depth = 8)
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6193 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6194 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6193);
// compiled call node returning call6194 (depth = 8)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6195 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6197 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6196);
// compiled call node returning call6197 (depth = 12)
// compiled member node returning call6197 (depth = 11)
  partcv[0] = 0;
  Object call6198 = callmethod(call6197, "new",
    1, partcv, params);
  gc_frame_end(callframe6195);
// compiled call node returning call6198 (depth = 10)
// compiled member node returning call6198 (depth = 9)
  *var_suggestion = call6198;
  if (call6198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6200 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6201 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6202 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6201);
// compiled call node returning call6202 (depth = 10)
// compiled member node returning call6202 (depth = 9)
  gc_frame_newslot(call6202);
// starting to compile identifier node (depth = 9)
  Object bool6203 = alloc_Boolean(1);
// compiled identifier node returning bool6203 (depth = 9)
  gc_frame_newslot(bool6203);
// starting to compile identifier node (depth = 9)
  Object bool6204 = alloc_Boolean(0);
// compiled identifier node returning bool6204 (depth = 9)
  gc_frame_newslot(bool6204);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6202;
  params[2] = bool6203;
  params[3] = bool6204;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6205 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6200);
// compiled call node returning call6205 (depth = 8)
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6206 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6207 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6206);
// compiled call node returning call6207 (depth = 8)
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6208 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6209 == NULL) {
    strlit6209 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit6209);
  }
// compiled string node returning strlit6209 (depth = 9)
  gc_frame_newslot(strlit6209);
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6211 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6210);
// compiled call node returning call6211 (depth = 10)
// compiled member node returning call6211 (depth = 9)
  gc_frame_newslot(call6211);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6213 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6212);
// compiled call node returning call6213 (depth = 10)
// compiled member node returning call6213 (depth = 9)
  gc_frame_newslot(call6213);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6209;
  params[1] = call6211;
  params[2] = call6213;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6214 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6208);
// compiled call node returning call6214 (depth = 8)
    gc_frame_newslot(call6214);
    if6155 = call6214;
  } else {
  }
// compiled if node returning if6155 (depth = 7)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6215 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6216 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6217 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6216);
// compiled call node returning call6217 (depth = 9)
// compiled member node returning call6217 (depth = 8)
  gc_frame_newslot(call6217);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  params[0] = call6217;
  partcv[0] = 1;
  Object call6218 = callmethod(*var_arg, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6215);
// compiled call node returning call6218 (depth = 7)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6219 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call6220 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6219);
// compiled call node returning call6220 (depth = 7)
    gc_frame_newslot(call6220);
    if6088 = call6220;
  } else {
  }
// compiled if node returning if6088 (depth = 6)
  gc_frame_end(frame);
  return if6088;
}
Object meth_parser__apply5877(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5879 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5880 == NULL) {
    strlit5880 = alloc_String("colon");
    gc_root(strlit5880);
  }
// compiled string node returning strlit5880 (depth = 6)
  gc_frame_newslot(strlit5880);
// call case 4: self request
  params[0] = strlit5880;
  partcv[0] = 1;
  Object call5881 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5879);
// compiled call node returning call5881 (depth = 5)
  Object if5878 = done;
  if (istrue(call5881)) {
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5882 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call5883 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5882);
// compiled call node returning call5883 (depth = 7)
// compiled member node returning call5883 (depth = 6)
  *var_expr = call5883;
  if (call5883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5886 == NULL) {
    strlit5886 = alloc_String("identifier");
    gc_root(strlit5886);
  }
// compiled string node returning strlit5886 (depth = 7)
  int op_slot_right_5885 = gc_frame_newslot(strlit5886);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr (depth = 9)
  partcv[0] = 0;
  Object call5889 = callmethod(*var_expr, "kind",
    1, partcv, params);
  gc_frame_end(callframe5888);
// compiled call node returning call5889 (depth = 8)
// compiled member node returning call5889 (depth = 7)
  int op_slot_left_5885 = gc_frame_newslot(call5889);
  params[0] = strlit5886;
  partcv[0] = 1;
  Object opresult5890 = callmethod(call5889, "!=", 1, partcv, params);
// compiled op node returning opresult5890 (depth = 6)
  Object if5884 = done;
  if (istrue(opresult5890)) {
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5891 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5893 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5892);
// compiled call node returning call5893 (depth = 10)
// compiled member node returning call5893 (depth = 9)
  partcv[0] = 0;
  Object call5894 = callmethod(call5893, "new",
    1, partcv, params);
  gc_frame_end(callframe5891);
// compiled call node returning call5894 (depth = 8)
// compiled member node returning call5894 (depth = 7)
  *var_suggestion = call5894;
  if (call5894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5897 == NULL) {
    strlit5897 = alloc_String("identifier");
    gc_root(strlit5897);
  }
// compiled string node returning strlit5897 (depth = 8)
  int op_slot_right_5896 = gc_frame_newslot(strlit5897);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5899 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call5901 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5900);
// compiled call node returning call5901 (depth = 11)
// compiled member node returning call5901 (depth = 10)
  partcv[0] = 0;
  Object call5902 = callmethod(call5901, "kind",
    1, partcv, params);
  gc_frame_end(callframe5899);
// compiled call node returning call5902 (depth = 9)
// compiled member node returning call5902 (depth = 8)
  int op_slot_left_5896 = gc_frame_newslot(call5902);
  params[0] = strlit5897;
  partcv[0] = 1;
  Object opresult5903 = callmethod(call5902, "==", 1, partcv, params);
// compiled op node returning opresult5903 (depth = 7)
  Object if5895 = done;
  if (istrue(opresult5903)) {
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5904 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5905 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5906 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5905);
// compiled call node returning call5906 (depth = 9)
// compiled member node returning call5906 (depth = 8)
  gc_frame_newslot(call5906);
// starting to compile identifier node (depth = 8)
  Object bool5907 = alloc_Boolean(1);
// compiled identifier node returning bool5907 (depth = 8)
  gc_frame_newslot(bool5907);
// starting to compile identifier node (depth = 8)
  Object bool5908 = alloc_Boolean(0);
// compiled identifier node returning bool5908 (depth = 8)
  gc_frame_newslot(bool5908);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5906;
  params[2] = bool5907;
  params[3] = bool5908;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5909 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5904);
// compiled call node returning call5909 (depth = 7)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5910 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5911 == NULL) {
    strlit5911 = alloc_String("only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit5911);
  }
// compiled string node returning strlit5911 (depth = 8)
  gc_frame_newslot(strlit5911);
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5913 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5912);
// compiled call node returning call5913 (depth = 9)
// compiled member node returning call5913 (depth = 8)
  gc_frame_newslot(call5913);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5914 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5915 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5914);
// compiled call node returning call5915 (depth = 9)
// compiled member node returning call5915 (depth = 8)
  gc_frame_newslot(call5915);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5917 = alloc_Float64(1);
// compiled num node returning num5917 (depth = 9)
  int op_slot_right_5916 = gc_frame_newslot(num5917);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5920 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5922 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5921);
// compiled call node returning call5922 (depth = 13)
// compiled member node returning call5922 (depth = 12)
  partcv[0] = 0;
  Object call5923 = callmethod(call5922, "size",
    1, partcv, params);
  gc_frame_end(callframe5920);
// compiled call node returning call5923 (depth = 11)
// compiled member node returning call5923 (depth = 10)
  int op_slot_right_5919 = gc_frame_newslot(call5923);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5926 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5927 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5926);
// compiled call node returning call5927 (depth = 13)
// compiled member node returning call5927 (depth = 12)
  partcv[0] = 0;
  Object call5928 = callmethod(call5927, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5925);
// compiled call node returning call5928 (depth = 11)
// compiled member node returning call5928 (depth = 10)
  int op_slot_left_5919 = gc_frame_newslot(call5928);
  params[0] = call5923;
  partcv[0] = 1;
  Object sum5929 = callmethod(call5928, "+", 1, partcv, params);
// compiled op node returning sum5929 (depth = 9)
  int op_slot_left_5916 = gc_frame_newslot(sum5929);
  params[0] = num5917;
  partcv[0] = 1;
  Object diff5930 = callmethod(sum5929, "-", 1, partcv, params);
// compiled op node returning diff5930 (depth = 8)
  gc_frame_newslot(diff5930);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5911;
  params[1] = call5913;
  params[2] = call5915;
  params[3] = diff5930;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5931 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5910);
// compiled call node returning call5931 (depth = 7)
    gc_frame_newslot(call5931);
    if5895 = call5931;
  } else {
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5932 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool5933 = alloc_Boolean(1);
// compiled identifier node returning bool5933 (depth = 8)
  gc_frame_newslot(bool5933);
// starting to compile identifier node (depth = 8)
  Object bool5934 = alloc_Boolean(0);
// compiled identifier node returning bool5934 (depth = 8)
  gc_frame_newslot(bool5934);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool5933;
  params[2] = bool5934;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5935 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5932);
// compiled call node returning call5935 (depth = 7)
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5936 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5937 == NULL) {
    strlit5937 = alloc_String("only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit5937);
  }
// compiled string node returning strlit5937 (depth = 8)
  gc_frame_newslot(strlit5937);
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5938 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5939 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5938);
// compiled call node returning call5939 (depth = 9)
// compiled member node returning call5939 (depth = 8)
  gc_frame_newslot(call5939);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5941 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5940);
// compiled call node returning call5941 (depth = 9)
// compiled member node returning call5941 (depth = 8)
  gc_frame_newslot(call5941);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5943 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5942);
// compiled call node returning call5943 (depth = 9)
// compiled member node returning call5943 (depth = 8)
  gc_frame_newslot(call5943);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5937;
  params[1] = call5939;
  params[2] = call5941;
  params[3] = call5943;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5944 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5936);
// compiled call node returning call5944 (depth = 7)
    gc_frame_newslot(call5944);
    if5895 = call5944;
  }
// compiled if node returning if5895 (depth = 6)
    gc_frame_newslot(if5895);
    if5884 = if5895;
  } else {
  }
// compiled if node returning if5884 (depth = 5)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5946 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5945);
// compiled call node returning call5946 (depth = 6)
// compiled member node returning call5946 (depth = 5)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5948 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5949 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5950 = alloc_Block(NULL, NULL, "parser", 1849);
  gc_frame_newslot(block5950);
// method "_apply"
  block_savedest(block5950);
  Object closure5951 = createclosure(2, "_apply");
  setclosureframe(closure5951, stackframe);
  addtoclosure(closure5951, var_blocksOK);
  addtoclosure(closure5951, selfslot);
  struct UserObject *uo5951 = (struct UserObject*)block5950;
  uo5951->data[0] = (Object)closure5951;
  Method *meth_meth_parser__apply5951 = addmethod2pos(block5950, "_apply", &meth_parser__apply5951, 0);
  int argcv_meth_parser__apply5951[] = {0};
  meth_meth_parser__apply5951->type = alloc_MethodType(1, argcv_meth_parser__apply5951);
  meth_meth_parser__apply5951->definitionModule = modulename;
  meth_meth_parser__apply5951->definitionLine = 1849;
// compiled block node returning block5950 (depth = 9)
  gc_frame_newslot(block5950);
// call case 4: self request
  params[0] = block5950;
  partcv[0] = 1;
  Object call5955 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5949);
// compiled call node returning call5955 (depth = 8)
  partcv[0] = 0;
  Object call5956 = callmethod(call5955, "not",
    1, partcv, params);
  gc_frame_end(callframe5948);
// compiled call node returning call5956 (depth = 7)
// compiled member node returning call5956 (depth = 6)
  Object if5947 = done;
  if (istrue(call5956)) {
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5957 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5958 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5957);
// compiled call node returning call5958 (depth = 7)
// compiled member node returning call5958 (depth = 6)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5959 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5960 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5961 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5960);
// compiled call node returning call5961 (depth = 10)
// compiled member node returning call5961 (depth = 9)
  partcv[0] = 0;
  Object call5962 = callmethod(call5961, "empty",
    1, partcv, params);
  gc_frame_end(callframe5959);
// compiled call node returning call5962 (depth = 8)
// compiled member node returning call5962 (depth = 7)
  *var_suggestions = call5962;
  if (call5962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5963 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5965 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5964);
// compiled call node returning call5965 (depth = 10)
// compiled member node returning call5965 (depth = 9)
  partcv[0] = 0;
  Object call5966 = callmethod(call5965, "new",
    1, partcv, params);
  gc_frame_end(callframe5963);
// compiled call node returning call5966 (depth = 8)
// compiled member node returning call5966 (depth = 7)
  *var_suggestion = call5966;
  if (call5966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5967 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5968 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5969 == NULL) {
    strlit5969 = alloc_String("rparen");
    gc_root(strlit5969);
  }
// compiled string node returning strlit5969 (depth = 9)
  params[0] = strlit5969;
  partcv[0] = 1;
  callmethod(array5968, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array5968 (depth = 8)
  gc_frame_newslot(array5968);
// call case 4: self request
  params[0] = array5968;
  partcv[0] = 1;
  Object call5970 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5967);
// compiled call node returning call5970 (depth = 7)
  *var_nextTok = call5970;
  if (call5970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5972 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5972 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5974 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5974 (depth = 7)
  Object if5971 = done;
  if (istrue(opresult5974)) {
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5975 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5976 == NULL) {
    strlit5976 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5976);
  }
// compiled string node returning strlit5976 (depth = 8)
  gc_frame_newslot(strlit5976);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit5976;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5977 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5975);
// compiled call node returning call5977 (depth = 7)
    gc_frame_newslot(call5977);
    if5971 = call5977;
  } else {
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5978 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5980 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5979);
// compiled call node returning call5980 (depth = 9)
// compiled member node returning call5980 (depth = 8)
  gc_frame_newslot(call5980);
// starting to compile identifier node (depth = 8)
  Object bool5981 = alloc_Boolean(1);
// compiled identifier node returning bool5981 (depth = 8)
  gc_frame_newslot(bool5981);
// starting to compile identifier node (depth = 8)
  Object bool5982 = alloc_Boolean(0);
// compiled identifier node returning bool5982 (depth = 8)
  gc_frame_newslot(bool5982);
// starting to compile string node (depth = 8)
  if (strlit5983 == NULL) {
    strlit5983 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5983);
  }
// compiled string node returning strlit5983 (depth = 8)
  gc_frame_newslot(strlit5983);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5980;
  params[2] = bool5981;
  params[3] = bool5982;
  params[4] = strlit5983;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5984 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5978);
// compiled call node returning call5984 (depth = 7)
    gc_frame_newslot(call5984);
    if5971 = call5984;
  }
// compiled if node returning if5971 (depth = 6)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5985 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5986 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5985);
// compiled call node returning call5986 (depth = 6)
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5987 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5989 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5988);
// compiled call node returning call5989 (depth = 10)
// compiled member node returning call5989 (depth = 9)
  partcv[0] = 0;
  Object call5990 = callmethod(call5989, "new",
    1, partcv, params);
  gc_frame_end(callframe5987);
// compiled call node returning call5990 (depth = 8)
// compiled member node returning call5990 (depth = 7)
  *var_suggestion = call5990;
  if (call5990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5992 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5994 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5993);
// compiled call node returning call5994 (depth = 8)
// compiled member node returning call5994 (depth = 7)
  gc_frame_newslot(call5994);
// starting to compile identifier node (depth = 7)
  Object bool5995 = alloc_Boolean(1);
// compiled identifier node returning bool5995 (depth = 7)
  gc_frame_newslot(bool5995);
// starting to compile identifier node (depth = 7)
  Object bool5996 = alloc_Boolean(0);
// compiled identifier node returning bool5996 (depth = 7)
  gc_frame_newslot(bool5996);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5994;
  params[2] = bool5995;
  params[3] = bool5996;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5997 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5992);
// compiled call node returning call5997 (depth = 6)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5998 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5999 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5998);
// compiled call node returning call5999 (depth = 6)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6000 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6001 == NULL) {
    strlit6001 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit6001);
  }
// compiled string node returning strlit6001 (depth = 7)
  gc_frame_newslot(strlit6001);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6003 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6002);
// compiled call node returning call6003 (depth = 8)
// compiled member node returning call6003 (depth = 7)
  gc_frame_newslot(call6003);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6005 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6004);
// compiled call node returning call6005 (depth = 8)
// compiled member node returning call6005 (depth = 7)
  gc_frame_newslot(call6005);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6001;
  params[1] = call6003;
  params[2] = call6005;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6006 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6000);
// compiled call node returning call6006 (depth = 6)
    gc_frame_newslot(call6006);
    if5947 = call6006;
  } else {
  }
// compiled if node returning if5947 (depth = 5)
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6007 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6009 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6008);
// compiled call node returning call6009 (depth = 7)
// compiled member node returning call6009 (depth = 6)
  gc_frame_newslot(call6009);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  params[0] = call6009;
  partcv[0] = 1;
  Object call6010 = callmethod(*var_expr, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6007);
// compiled call node returning call6010 (depth = 5)
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6011 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  gc_frame_newslot(*var_expr);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call6012 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6011);
// compiled call node returning call6012 (depth = 5)
    gc_frame_newslot(call6012);
    if5878 = call6012;
  } else {
  }
// compiled if node returning if5878 (depth = 4)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6013 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6014 = alloc_Block(NULL, NULL, "parser", 1869);
  gc_frame_newslot(block6014);
// method "_apply"
  block_savedest(block6014);
  Object closure6015 = createclosure(1, "_apply");
  setclosureframe(closure6015, stackframe);
  addtoclosure(closure6015, selfslot);
  struct UserObject *uo6015 = (struct UserObject*)block6014;
  uo6015->data[0] = (Object)closure6015;
  Method *meth_meth_parser__apply6015 = addmethod2pos(block6014, "_apply", &meth_parser__apply6015, 0);
  int argcv_meth_parser__apply6015[] = {0};
  meth_meth_parser__apply6015->type = alloc_MethodType(1, argcv_meth_parser__apply6015);
  meth_meth_parser__apply6015->definitionModule = modulename;
  meth_meth_parser__apply6015->definitionLine = 1866;
// compiled block node returning block6014 (depth = 5)
  gc_frame_newslot(block6014);
// starting to compile block node (depth = 5)
  Object block6020 = alloc_Block(NULL, NULL, "parser", 1869);
  gc_frame_newslot(block6020);
// method "_apply"
  block_savedest(block6020);
  Object closure6021 = createclosure(7, "_apply");
  setclosureframe(closure6021, stackframe);
  addtoclosure(closure6021, var_values);
  addtoclosure(closure6021, var_part);
  addtoclosure(closure6021, var_blocksOK);
  addtoclosure(closure6021, var_errormessages);
  addtoclosure(closure6021, var_sym);
  addtoclosure(closure6021, var_lastToken);
  addtoclosure(closure6021, selfslot);
  struct UserObject *uo6021 = (struct UserObject*)block6020;
  uo6021->data[0] = (Object)closure6021;
  Method *meth_meth_parser__apply6021 = addmethod2pos(block6020, "_apply", &meth_parser__apply6021, 0);
  int argcv_meth_parser__apply6021[] = {0};
  meth_meth_parser__apply6021->type = alloc_MethodType(1, argcv_meth_parser__apply6021);
  meth_meth_parser__apply6021->definitionModule = modulename;
  meth_meth_parser__apply6021->definitionLine = 1866;
// compiled block node returning block6020 (depth = 5)
  gc_frame_newslot(block6020);
// call case 5: prelude request
  params[0] = block6014;
  params[1] = block6020;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6222 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6013);
// compiled call node returning call6222 (depth = 4)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6223 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6225 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6224);
// compiled call node returning call6225 (depth = 6)
// compiled member node returning call6225 (depth = 5)
  gc_frame_newslot(call6225);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6226 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call6227 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6226);
// compiled call node returning call6227 (depth = 6)
// compiled member node returning call6227 (depth = 5)
  params[0] = call6225;
  partcv[0] = 1;
  Object call6228 = callmethod(call6227, "push",
    1, partcv, params);
  gc_frame_end(callframe6223);
// compiled call node returning call6228 (depth = 4)
  gc_frame_end(frame);
  return call6228;
}
Object meth_parser_parenthesizedArg5867(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArg");
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parenthesizedArg (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parenthesizedArg");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5869 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5868);
// compiled call node returning call5869 (depth = 3)
// compiled member node returning call5869 (depth = 2)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5870 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5871 = alloc_Block(NULL, NULL, "parser", 1832);
  gc_frame_newslot(block5871);
// method "_apply"
  block_savedest(block5871);
  Object closure5872 = createclosure(2, "_apply");
  setclosureframe(closure5872, stackframe);
  addtoclosure(closure5872, var_blocksOK);
  addtoclosure(closure5872, selfslot);
  struct UserObject *uo5872 = (struct UserObject*)block5871;
  uo5872->data[0] = (Object)closure5872;
  Method *meth_meth_parser__apply5872 = addmethod2pos(block5871, "_apply", &meth_parser__apply5872, 0);
  int argcv_meth_parser__apply5872[] = {0};
  meth_meth_parser__apply5872->type = alloc_MethodType(1, argcv_meth_parser__apply5872);
  meth_meth_parser__apply5872->definitionModule = modulename;
  meth_meth_parser__apply5872->definitionLine = 1831;
// compiled block node returning block5871 (depth = 3)
  gc_frame_newslot(block5871);
// starting to compile block node (depth = 3)
  Object block5876 = alloc_Block(NULL, NULL, "parser", 1832);
  gc_frame_newslot(block5876);
// method "_apply"
  block_savedest(block5876);
  Object closure5877 = createclosure(7, "_apply");
  setclosureframe(closure5877, stackframe);
  addtoclosure(closure5877, var_values);
  addtoclosure(closure5877, var_errormessages);
  addtoclosure(closure5877, var_sym);
  addtoclosure(closure5877, var_blocksOK);
  addtoclosure(closure5877, var_lastToken);
  addtoclosure(closure5877, var_part);
  addtoclosure(closure5877, selfslot);
  struct UserObject *uo5877 = (struct UserObject*)block5876;
  uo5877->data[0] = (Object)closure5877;
  Method *meth_meth_parser__apply5877 = addmethod2pos(block5876, "_apply", &meth_parser__apply5877, 0);
  int argcv_meth_parser__apply5877[] = {0};
  meth_meth_parser__apply5877->type = alloc_MethodType(1, argcv_meth_parser__apply5877);
  meth_meth_parser__apply5877->definitionModule = modulename;
  meth_meth_parser__apply5877->definitionLine = 1831;
// compiled block node returning block5876 (depth = 3)
  gc_frame_newslot(block5876);
// call case 4: self request
  params[0] = block5871;
  params[1] = block5876;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6230 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5870);
// compiled call node returning call6230 (depth = 2)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6233 == NULL) {
    strlit6233 = alloc_String("rparen");
    gc_root(strlit6233);
  }
// compiled string node returning strlit6233 (depth = 4)
  int op_slot_right_6232 = gc_frame_newslot(strlit6233);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6236 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6235);
// compiled call node returning call6236 (depth = 5)
// compiled member node returning call6236 (depth = 4)
  int op_slot_left_6232 = gc_frame_newslot(call6236);
  params[0] = strlit6233;
  partcv[0] = 1;
  Object opresult6237 = callmethod(call6236, "!=", 1, partcv, params);
// compiled op node returning opresult6237 (depth = 3)
  Object if6231 = done;
  if (istrue(opresult6237)) {
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6239 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6238);
// compiled call node returning call6239 (depth = 4)
// compiled member node returning call6239 (depth = 3)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6240 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6241 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6242 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6241);
// compiled call node returning call6242 (depth = 7)
// compiled member node returning call6242 (depth = 6)
  partcv[0] = 0;
  Object call6243 = callmethod(call6242, "new",
    1, partcv, params);
  gc_frame_end(callframe6240);
// compiled call node returning call6243 (depth = 5)
// compiled member node returning call6243 (depth = 4)
  *var_suggestion = call6243;
  if (call6243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6244 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6245 == NULL) {
    strlit6245 = alloc_String(")");
    gc_root(strlit6245);
  }
// compiled string node returning strlit6245 (depth = 4)
  gc_frame_newslot(strlit6245);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6245;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6246 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6244);
// compiled call node returning call6246 (depth = 3)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6247 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6248 == NULL) {
    strlit6248 = alloc_String("a method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6248);
  }
// compiled string node returning strlit6248 (depth = 4)
  gc_frame_newslot(strlit6248);
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6249 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6250 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6249);
// compiled call node returning call6250 (depth = 5)
// compiled member node returning call6250 (depth = 4)
  gc_frame_newslot(call6250);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6253 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6252);
// compiled call node returning call6253 (depth = 6)
// compiled member node returning call6253 (depth = 5)
  int op_slot_right_6251 = gc_frame_newslot(call6253);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6255 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6256 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6255);
// compiled call node returning call6256 (depth = 6)
// compiled member node returning call6256 (depth = 5)
  int op_slot_left_6251 = gc_frame_newslot(call6256);
  params[0] = call6253;
  partcv[0] = 1;
  Object sum6257 = callmethod(call6256, "+", 1, partcv, params);
// compiled op node returning sum6257 (depth = 4)
  gc_frame_newslot(sum6257);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6248;
  params[1] = call6250;
  params[2] = sum6257;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6258 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6247);
// compiled call node returning call6258 (depth = 3)
    gc_frame_newslot(call6258);
    if6231 = call6258;
  } else {
  }
// compiled if node returning if6231 (depth = 2)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call6262 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe6261);
// compiled call node returning call6262 (depth = 5)
// compiled member node returning call6262 (depth = 4)
  int op_slot_right_6260 = gc_frame_newslot(call6262);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6264 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6265 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6264);
// compiled call node returning call6265 (depth = 5)
// compiled member node returning call6265 (depth = 4)
  int op_slot_left_6260 = gc_frame_newslot(call6265);
  params[0] = call6262;
  partcv[0] = 1;
  Object opresult6266 = callmethod(call6265, "==", 1, partcv, params);
// compiled op node returning opresult6266 (depth = 3)
  Object if6259 = done;
  if (istrue(opresult6266)) {
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6267 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6269 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call6270 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6269);
// compiled call node returning call6270 (depth = 6)
// compiled member node returning call6270 (depth = 5)
  int op_slot_right_6268 = gc_frame_newslot(call6270);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6273 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6272);
// compiled call node returning call6273 (depth = 6)
// compiled member node returning call6273 (depth = 5)
  int op_slot_left_6268 = gc_frame_newslot(call6273);
  params[0] = call6270;
  partcv[0] = 1;
  Object diff6274 = callmethod(call6273, "-", 1, partcv, params);
// compiled op node returning diff6274 (depth = 4)
  gc_frame_newslot(diff6274);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = diff6274;
  partcv[0] = 1;
  Object call6275 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe6267);
// compiled call node returning call6275 (depth = 3)
    gc_frame_newslot(call6275);
    if6259 = call6275;
  } else {
  }
// compiled if node returning if6259 (depth = 2)
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6276 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6277 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6276);
// compiled call node returning call6277 (depth = 3)
// compiled member node returning call6277 (depth = 2)
  gc_frame_end(frame);
  return call6277;
}
Object meth_parser__apply6297(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6298 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6299 = callmethodflags(self, "typeArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6298);
// compiled call node returning call6299 (depth = 7)
// compiled member node returning call6299 (depth = 6)
  gc_frame_end(frame);
  return call6299;
}
Object meth_parser__apply6294(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6295 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6296 = alloc_Block(NULL, NULL, "parser", 1946);
  gc_frame_newslot(block6296);
// method "_apply"
  block_savedest(block6296);
  Object closure6297 = createclosure(1, "_apply");
  setclosureframe(closure6297, stackframe);
  addtoclosure(closure6297, selfslot);
  struct UserObject *uo6297 = (struct UserObject*)block6296;
  uo6297->data[0] = (Object)closure6297;
  Method *meth_meth_parser__apply6297 = addmethod2pos(block6296, "_apply", &meth_parser__apply6297, 0);
  int argcv_meth_parser__apply6297[] = {0};
  meth_meth_parser__apply6297->type = alloc_MethodType(1, argcv_meth_parser__apply6297);
  meth_meth_parser__apply6297->definitionModule = modulename;
  meth_meth_parser__apply6297->definitionLine = 1945;
// compiled block node returning block6296 (depth = 5)
  gc_frame_newslot(block6296);
// call case 4: self request
  params[0] = block6296;
  partcv[0] = 1;
  Object call6301 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6295);
// compiled call node returning call6301 (depth = 4)
  gc_frame_end(frame);
  return call6301;
}
Object meth_parser__apply6304(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6305 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6307 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6306);
// compiled call node returning call6307 (depth = 6)
// compiled member node returning call6307 (depth = 5)
  gc_frame_newslot(call6307);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call6307;
  partcv[0] = 1;
  Object call6308 = callmethod(*var_args, "add",
    1, partcv, params);
  gc_frame_end(callframe6305);
// compiled call node returning call6308 (depth = 4)
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6311 == NULL) {
    strlit6311 = alloc_String("comma");
    gc_root(strlit6311);
  }
// compiled string node returning strlit6311 (depth = 6)
  int op_slot_right_6310 = gc_frame_newslot(strlit6311);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6314 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6313);
// compiled call node returning call6314 (depth = 7)
// compiled member node returning call6314 (depth = 6)
  int op_slot_left_6310 = gc_frame_newslot(call6314);
  params[0] = strlit6311;
  partcv[0] = 1;
  Object opresult6315 = callmethod(call6314, "==", 1, partcv, params);
// compiled op node returning opresult6315 (depth = 5)
  Object if6309 = done;
  if (istrue(opresult6315)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6317 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6316);
// compiled call node returning call6317 (depth = 6)
// compiled member node returning call6317 (depth = 5)
    gc_frame_newslot(call6317);
    if6309 = call6317;
  } else {
  }
// compiled if node returning if6309 (depth = 4)
  gc_frame_end(frame);
  return if6309;
}
Object meth_parser_typeArgs6278(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeArgs (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeArgs");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_startToken = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startToken");
  Object *var_args = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "args");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6279 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6280 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6281 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6280);
// compiled call node returning call6281 (depth = 6)
// compiled member node returning call6281 (depth = 5)
  partcv[0] = 0;
  Object call6282 = callmethod(call6281, "empty",
    1, partcv, params);
  gc_frame_end(callframe6279);
// compiled call node returning call6282 (depth = 4)
// compiled member node returning call6282 (depth = 3)
  *var_args = call6282;
  if (call6282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6285 == NULL) {
    strlit6285 = alloc_String("lgeneric");
    gc_root(strlit6285);
  }
// compiled string node returning strlit6285 (depth = 4)
  int op_slot_right_6284 = gc_frame_newslot(strlit6285);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6288 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6287);
// compiled call node returning call6288 (depth = 5)
// compiled member node returning call6288 (depth = 4)
  int op_slot_left_6284 = gc_frame_newslot(call6288);
  params[0] = strlit6285;
  partcv[0] = 1;
  Object opresult6289 = callmethod(call6288, "!=", 1, partcv, params);
// compiled op node returning opresult6289 (depth = 3)
  Object if6283 = done;
  if (istrue(opresult6289)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6283 = undefined;
  } else {
  }
// compiled if node returning if6283 (depth = 2)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6291 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6290);
// compiled call node returning call6291 (depth = 3)
// compiled member node returning call6291 (depth = 2)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6292 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6293 = alloc_Block(NULL, NULL, "parser", 1946);
  gc_frame_newslot(block6293);
// method "_apply"
  block_savedest(block6293);
  Object closure6294 = createclosure(1, "_apply");
  setclosureframe(closure6294, stackframe);
  addtoclosure(closure6294, selfslot);
  struct UserObject *uo6294 = (struct UserObject*)block6293;
  uo6294->data[0] = (Object)closure6294;
  Method *meth_meth_parser__apply6294 = addmethod2pos(block6293, "_apply", &meth_parser__apply6294, 0);
  int argcv_meth_parser__apply6294[] = {0};
  meth_meth_parser__apply6294->type = alloc_MethodType(1, argcv_meth_parser__apply6294);
  meth_meth_parser__apply6294->definitionModule = modulename;
  meth_meth_parser__apply6294->definitionLine = 1945;
// compiled block node returning block6293 (depth = 3)
  gc_frame_newslot(block6293);
// starting to compile block node (depth = 3)
  Object block6303 = alloc_Block(NULL, NULL, "parser", 1946);
  gc_frame_newslot(block6303);
// method "_apply"
  block_savedest(block6303);
  Object closure6304 = createclosure(4, "_apply");
  setclosureframe(closure6304, stackframe);
  addtoclosure(closure6304, var_values);
  addtoclosure(closure6304, var_args);
  addtoclosure(closure6304, var_sym);
  addtoclosure(closure6304, selfslot);
  struct UserObject *uo6304 = (struct UserObject*)block6303;
  uo6304->data[0] = (Object)closure6304;
  Method *meth_meth_parser__apply6304 = addmethod2pos(block6303, "_apply", &meth_parser__apply6304, 0);
  int argcv_meth_parser__apply6304[] = {0};
  meth_meth_parser__apply6304->type = alloc_MethodType(1, argcv_meth_parser__apply6304);
  meth_meth_parser__apply6304->definitionModule = modulename;
  meth_meth_parser__apply6304->definitionLine = 1946;
// compiled block node returning block6303 (depth = 3)
  gc_frame_newslot(block6303);
// call case 5: prelude request
  params[0] = block6293;
  params[1] = block6303;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6319 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6292);
// compiled call node returning call6319 (depth = 2)
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6322 == NULL) {
    strlit6322 = alloc_String("rgeneric");
    gc_root(strlit6322);
  }
// compiled string node returning strlit6322 (depth = 4)
  int op_slot_right_6321 = gc_frame_newslot(strlit6322);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6325 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6324);
// compiled call node returning call6325 (depth = 5)
// compiled member node returning call6325 (depth = 4)
  int op_slot_left_6321 = gc_frame_newslot(call6325);
  params[0] = strlit6322;
  partcv[0] = 1;
  Object opresult6326 = callmethod(call6325, "!=", 1, partcv, params);
// compiled op node returning opresult6326 (depth = 3)
  Object if6320 = done;
  if (istrue(opresult6326)) {
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6327 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6329 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6328);
// compiled call node returning call6329 (depth = 7)
// compiled member node returning call6329 (depth = 6)
  partcv[0] = 0;
  Object call6330 = callmethod(call6329, "new",
    1, partcv, params);
  gc_frame_end(callframe6327);
// compiled call node returning call6330 (depth = 5)
// compiled member node returning call6330 (depth = 4)
  *var_suggestion = call6330;
  if (call6330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6331 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6332 == NULL) {
    strlit6332 = alloc_String(">");
    gc_root(strlit6332);
  }
// compiled string node returning strlit6332 (depth = 4)
  gc_frame_newslot(strlit6332);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6332;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6333 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6331);
// compiled call node returning call6333 (depth = 3)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6334 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6336 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6335);
// compiled call node returning call6336 (depth = 7)
// compiled member node returning call6336 (depth = 6)
  partcv[0] = 0;
  Object call6337 = callmethod(call6336, "new",
    1, partcv, params);
  gc_frame_end(callframe6334);
// compiled call node returning call6337 (depth = 5)
// compiled member node returning call6337 (depth = 4)
  *var_suggestion2 = call6337;
  if (call6337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6338 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6339 == NULL) {
    strlit6339 = alloc_String(" ");
    gc_root(strlit6339);
  }
// compiled string node returning strlit6339 (depth = 4)
  gc_frame_newslot(strlit6339);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit6339;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6340 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe6338);
// compiled call node returning call6340 (depth = 3)
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6341 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array6341, "push", 1, partcv, params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array6341, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6341 (depth = 4)
  *var_suggestions = array6341;
  if (array6341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6342 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6344 == NULL) {
    strlit6344 = alloc_String("If '<' is intended as an operator, precede it by a space.");
    gc_root(strlit6344);
  }
// compiled string node returning strlit6344 (depth = 5)
  int op_slot_right_6343 = gc_frame_newslot(strlit6344);
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6346 == NULL) {
    strlit6346 = alloc_String("a method request containing a '<' must have a matching '>'. ");
    gc_root(strlit6346);
  }
// compiled string node returning strlit6346 (depth = 5)
  int op_slot_left_6343 = gc_frame_newslot(strlit6346);
  params[0] = strlit6344;
  partcv[0] = 1;
  Object opresult6347 = callmethod(strlit6346, "++", 1, partcv, params);
// compiled op node returning opresult6347 (depth = 4)
  gc_frame_newslot(opresult6347);
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6349 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6348);
// compiled call node returning call6349 (depth = 5)
// compiled member node returning call6349 (depth = 4)
  gc_frame_newslot(call6349);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6351 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6352 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6351);
// compiled call node returning call6352 (depth = 6)
// compiled member node returning call6352 (depth = 5)
  int op_slot_right_6350 = gc_frame_newslot(call6352);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6355 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6354);
// compiled call node returning call6355 (depth = 6)
// compiled member node returning call6355 (depth = 5)
  int op_slot_left_6350 = gc_frame_newslot(call6355);
  params[0] = call6352;
  partcv[0] = 1;
  Object sum6356 = callmethod(call6355, "+", 1, partcv, params);
// compiled op node returning sum6356 (depth = 4)
  gc_frame_newslot(sum6356);
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6347;
  params[1] = call6349;
  params[2] = sum6356;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6357 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6342);
// compiled call node returning call6357 (depth = 3)
    gc_frame_newslot(call6357);
    if6320 = call6357;
  } else {
  }
// compiled if node returning if6320 (depth = 2)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6359 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6358);
// compiled call node returning call6359 (depth = 3)
// compiled member node returning call6359 (depth = 2)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply6387(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6389 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6388);
// compiled call node returning call6389 (depth = 7)
// compiled member node returning call6389 (depth = 6)
  gc_frame_end(frame);
  return call6389;
}
Object meth_parser_typeArg6360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeArg (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeArg");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6362 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6363 == NULL) {
    strlit6363 = alloc_String("identifier");
    gc_root(strlit6363);
  }
// compiled string node returning strlit6363 (depth = 4)
  gc_frame_newslot(strlit6363);
// call case 4: self request
  params[0] = strlit6363;
  partcv[0] = 1;
  Object call6364 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6362);
// compiled call node returning call6364 (depth = 3)
  Object if6361 = done;
  if (istrue(call6364)) {
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6366 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6365);
// compiled call node returning call6366 (depth = 4)
// compiled member node returning call6366 (depth = 3)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6369 == NULL) {
    strlit6369 = alloc_String("lgeneric");
    gc_root(strlit6369);
  }
// compiled string node returning strlit6369 (depth = 5)
  int op_slot_right_6368 = gc_frame_newslot(strlit6369);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6372 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6371);
// compiled call node returning call6372 (depth = 6)
// compiled member node returning call6372 (depth = 5)
  int op_slot_left_6368 = gc_frame_newslot(call6372);
  params[0] = strlit6369;
  partcv[0] = 1;
  Object opresult6373 = callmethod(call6372, "==", 1, partcv, params);
// compiled op node returning opresult6373 (depth = 4)
  Object if6367 = done;
  if (istrue(opresult6373)) {
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6374 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe6375 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6377 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6376);
// compiled call node returning call6377 (depth = 7)
// compiled member node returning call6377 (depth = 6)
  gc_frame_newslot(call6377);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6378 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6379 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6378);
// compiled call node returning call6379 (depth = 7)
// compiled member node returning call6379 (depth = 6)
  gc_frame_newslot(call6379);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call6381 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe6380);
// compiled call node returning call6381 (depth = 7)
// compiled member node returning call6381 (depth = 6)
  params[0] = call6377;
  params[1] = call6379;
  partcv[0] = 2;
  Object call6382 = callmethod(call6381, "new",
    1, partcv, params);
  gc_frame_end(callframe6375);
// compiled call node returning call6382 (depth = 5)
  gc_frame_newslot(call6382);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call6382;
  partcv[0] = 1;
  Object call6383 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6374);
// compiled call node returning call6383 (depth = 4)
    gc_frame_newslot(call6383);
    if6367 = call6383;
  } else {
  }
// compiled if node returning if6367 (depth = 3)
    gc_frame_newslot(if6367);
    if6361 = if6367;
  } else {
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6385 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6386 = alloc_Block(NULL, NULL, "parser", 1976);
  gc_frame_newslot(block6386);
// method "_apply"
  block_savedest(block6386);
  Object closure6387 = createclosure(1, "_apply");
  setclosureframe(closure6387, stackframe);
  addtoclosure(closure6387, selfslot);
  struct UserObject *uo6387 = (struct UserObject*)block6386;
  uo6387->data[0] = (Object)closure6387;
  Method *meth_meth_parser__apply6387 = addmethod2pos(block6386, "_apply", &meth_parser__apply6387, 0);
  int argcv_meth_parser__apply6387[] = {0};
  meth_meth_parser__apply6387->type = alloc_MethodType(1, argcv_meth_parser__apply6387);
  meth_meth_parser__apply6387->definitionModule = modulename;
  meth_meth_parser__apply6387->definitionLine = 1972;
// compiled block node returning block6386 (depth = 5)
  gc_frame_newslot(block6386);
// call case 4: self request
  params[0] = block6386;
  partcv[0] = 1;
  Object call6391 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6385);
// compiled call node returning call6391 (depth = 4)
  Object if6384 = done;
  if (istrue(call6391)) {
    gc_frame_newslot(done);
    if6384 = done;
  } else {
  }
// compiled if node returning if6384 (depth = 3)
    gc_frame_newslot(if6384);
    if6361 = if6384;
  }
// compiled if node returning if6361 (depth = 2)
  gc_frame_end(frame);
  return if6361;
}
Object meth_parser__apply6399(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6401 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6402 == NULL) {
    strlit6402 = alloc_String("identifier");
    gc_root(strlit6402);
  }
// compiled string node returning strlit6402 (depth = 6)
  gc_frame_newslot(strlit6402);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = strlit6402;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6403 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6401);
// compiled call node returning call6403 (depth = 5)
  int op_slot_right_6400 = gc_frame_newslot(call6403);
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6405 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6406 == NULL) {
    strlit6406 = alloc_String("identifier");
    gc_root(strlit6406);
  }
// compiled string node returning strlit6406 (depth = 6)
  gc_frame_newslot(strlit6406);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6406;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6407 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6405);
// compiled call node returning call6407 (depth = 5)
  int op_slot_left_6400 = gc_frame_newslot(call6407);
  params[0] = call6403;
  partcv[0] = 1;
  Object opresult6408 = callmethod(call6407, "||", 1, partcv, params);
// compiled op node returning opresult6408 (depth = 4)
  gc_frame_end(frame);
  return opresult6408;
}
Object meth_parser__apply6564(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6565 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6566 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6565);
// compiled call node returning call6566 (depth = 11)
  gc_frame_end(frame);
  return call6566;
}
Object meth_parser__apply6620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6621 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6622 == NULL) {
    strlit6622 = alloc_String("comma");
    gc_root(strlit6622);
  }
// compiled string node returning strlit6622 (depth = 8)
  gc_frame_newslot(strlit6622);
// call case 4: self request
  params[0] = strlit6622;
  partcv[0] = 1;
  Object call6623 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6621);
// compiled call node returning call6623 (depth = 7)
  gc_frame_end(frame);
  return call6623;
}
Object meth_parser__apply6640(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe6641 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6642 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6641);
// compiled call node returning call6642 (depth = 12)
  gc_frame_end(frame);
  return call6642;
}
Object meth_parser__apply6626(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_nxt = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6628 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6627);
// compiled call node returning call6628 (depth = 9)
// compiled member node returning call6628 (depth = 8)
  *var_nxt = call6628;
  if (call6628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6630 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call6632 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6631);
// compiled call node returning call6632 (depth = 9)
// compiled member node returning call6632 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6633 = callmethod(call6632, "push",
    1, partcv, params);
  gc_frame_end(callframe6630);
// compiled call node returning call6633 (depth = 7)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6634 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6635 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6634);
// compiled call node returning call6635 (depth = 8)
// compiled member node returning call6635 (depth = 7)
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6637 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6638 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block6639 = alloc_Block(NULL, NULL, "parser", 2061);
  gc_frame_newslot(block6639);
// method "_apply"
  block_savedest(block6639);
  Object closure6640 = createclosure(2, "_apply");
  setclosureframe(closure6640, stackframe);
  addtoclosure(closure6640, var_blocksOK);
  addtoclosure(closure6640, selfslot);
  struct UserObject *uo6640 = (struct UserObject*)block6639;
  uo6640->data[0] = (Object)closure6640;
  Method *meth_meth_parser__apply6640 = addmethod2pos(block6639, "_apply", &meth_parser__apply6640, 0);
  int argcv_meth_parser__apply6640[] = {0};
  meth_meth_parser__apply6640->type = alloc_MethodType(1, argcv_meth_parser__apply6640);
  meth_meth_parser__apply6640->definitionModule = modulename;
  meth_meth_parser__apply6640->definitionLine = 2061;
// compiled block node returning block6639 (depth = 11)
  gc_frame_newslot(block6639);
// call case 4: self request
  params[0] = block6639;
  partcv[0] = 1;
  Object call6644 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6638);
// compiled call node returning call6644 (depth = 10)
  partcv[0] = 0;
  Object call6645 = callmethod(call6644, "not",
    1, partcv, params);
  gc_frame_end(callframe6637);
// compiled call node returning call6645 (depth = 9)
// compiled member node returning call6645 (depth = 8)
  Object if6636 = done;
  if (istrue(call6645)) {
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6646 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6647 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6648 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6647);
// compiled call node returning call6648 (depth = 12)
// compiled member node returning call6648 (depth = 11)
  partcv[0] = 0;
  Object call6649 = callmethod(call6648, "empty",
    1, partcv, params);
  gc_frame_end(callframe6646);
// compiled call node returning call6649 (depth = 10)
// compiled member node returning call6649 (depth = 9)
  *var_suggestions = call6649;
  if (call6649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6650 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6652 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6651);
// compiled call node returning call6652 (depth = 12)
// compiled member node returning call6652 (depth = 11)
  partcv[0] = 0;
  Object call6653 = callmethod(call6652, "new",
    1, partcv, params);
  gc_frame_end(callframe6650);
// compiled call node returning call6653 (depth = 10)
// compiled member node returning call6653 (depth = 9)
  *var_suggestion = call6653;
  if (call6653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6654 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array6655 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit6656 == NULL) {
    strlit6656 = alloc_String("rparen");
    gc_root(strlit6656);
  }
// compiled string node returning strlit6656 (depth = 11)
  params[0] = strlit6656;
  partcv[0] = 1;
  callmethod(array6655, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6655 (depth = 10)
  gc_frame_newslot(array6655);
// call case 4: self request
  params[0] = array6655;
  partcv[0] = 1;
  Object call6657 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6654);
// compiled call node returning call6657 (depth = 9)
  *var_nextTok = call6657;
  if (call6657 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6659 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6659 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6661 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6661 (depth = 9)
  Object if6658 = done;
  if (istrue(opresult6661)) {
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6662 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6663 == NULL) {
    strlit6663 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6663);
  }
// compiled string node returning strlit6663 (depth = 10)
  gc_frame_newslot(strlit6663);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6663;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6664 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6662);
// compiled call node returning call6664 (depth = 9)
    gc_frame_newslot(call6664);
    if6658 = call6664;
  } else {
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6665 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call6667 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6666);
// compiled call node returning call6667 (depth = 11)
// compiled member node returning call6667 (depth = 10)
  gc_frame_newslot(call6667);
// starting to compile identifier node (depth = 10)
  Object bool6668 = alloc_Boolean(1);
// compiled identifier node returning bool6668 (depth = 10)
  gc_frame_newslot(bool6668);
// starting to compile identifier node (depth = 10)
  Object bool6669 = alloc_Boolean(0);
// compiled identifier node returning bool6669 (depth = 10)
  gc_frame_newslot(bool6669);
// starting to compile string node (depth = 10)
  if (strlit6670 == NULL) {
    strlit6670 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6670);
  }
// compiled string node returning strlit6670 (depth = 10)
  gc_frame_newslot(strlit6670);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6667;
  params[2] = bool6668;
  params[3] = bool6669;
  params[4] = strlit6670;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6671 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6665);
// compiled call node returning call6671 (depth = 9)
    gc_frame_newslot(call6671);
    if6658 = call6671;
  }
// compiled if node returning if6658 (depth = 8)
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6672 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6673 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6672);
// compiled call node returning call6673 (depth = 8)
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6674 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6676 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6675);
// compiled call node returning call6676 (depth = 12)
// compiled member node returning call6676 (depth = 11)
  partcv[0] = 0;
  Object call6677 = callmethod(call6676, "new",
    1, partcv, params);
  gc_frame_end(callframe6674);
// compiled call node returning call6677 (depth = 10)
// compiled member node returning call6677 (depth = 9)
  *var_suggestion = call6677;
  if (call6677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6679 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6681 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6680);
// compiled call node returning call6681 (depth = 10)
// compiled member node returning call6681 (depth = 9)
  gc_frame_newslot(call6681);
// starting to compile identifier node (depth = 9)
  Object bool6682 = alloc_Boolean(1);
// compiled identifier node returning bool6682 (depth = 9)
  gc_frame_newslot(bool6682);
// starting to compile identifier node (depth = 9)
  Object bool6683 = alloc_Boolean(0);
// compiled identifier node returning bool6683 (depth = 9)
  gc_frame_newslot(bool6683);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6681;
  params[2] = bool6682;
  params[3] = bool6683;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6684 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6679);
// compiled call node returning call6684 (depth = 8)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6685 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6686 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6685);
// compiled call node returning call6686 (depth = 8)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6687 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6688 == NULL) {
    strlit6688 = alloc_String("a method request must have an expression after a ','.");
    gc_root(strlit6688);
  }
// compiled string node returning strlit6688 (depth = 9)
  gc_frame_newslot(strlit6688);
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6690 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6689);
// compiled call node returning call6690 (depth = 10)
// compiled member node returning call6690 (depth = 9)
  gc_frame_newslot(call6690);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6692 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6691);
// compiled call node returning call6692 (depth = 10)
// compiled member node returning call6692 (depth = 9)
  gc_frame_newslot(call6692);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6688;
  params[1] = call6690;
  params[2] = call6692;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6693 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6687);
// compiled call node returning call6693 (depth = 8)
    gc_frame_newslot(call6693);
    if6636 = call6693;
  } else {
  }
// compiled if node returning if6636 (depth = 7)
  gc_frame_end(frame);
  return if6636;
}
Object meth_parser__apply6411(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_signature = getfromclosure(closure, 2);
  Object *var_methname = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_nxt = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_errormessages = getfromclosure(closure, 7);
  Object *var_sym = getfromclosure(closure, 8);
  Object *var_blocksOK = getfromclosure(closure, 9);
  Object self = *(getfromclosure(closure, 10));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isTerm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "isTerm");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_isEmpty = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isEmpty");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6412 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call6414 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe6413);
// compiled call node returning call6414 (depth = 8)
// compiled member node returning call6414 (depth = 7)
  partcv[0] = 0;
  Object call6415 = callmethod(call6414, "new",
    1, partcv, params);
  gc_frame_end(callframe6412);
// compiled call node returning call6415 (depth = 6)
// compiled member node returning call6415 (depth = 5)
  *var_part = call6415;
  if (call6415 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6417 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6418 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe6417);
// compiled call node returning call6418 (depth = 4)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6420 == NULL) {
    strlit6420 = alloc_String("()");
    gc_root(strlit6420);
  }
// compiled string node returning strlit6420 (depth = 6)
  int op_slot_right_6419 = gc_frame_newslot(strlit6420);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6419 = gc_frame_newslot(*var_methname);
  params[0] = strlit6420;
  partcv[0] = 1;
  Object opresult6422 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6422 (depth = 5)
  *var_methname = opresult6422;
  if (opresult6422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6424 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6425 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6424);
// compiled call node returning call6425 (depth = 5)
// compiled member node returning call6425 (depth = 4)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6427 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6426);
// compiled call node returning call6427 (depth = 6)
// compiled member node returning call6427 (depth = 5)
  *var_nxt = call6427;
  if (call6427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call6431 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6430);
// compiled call node returning call6431 (depth = 7)
// compiled member node returning call6431 (depth = 6)
  int op_slot_right_6429 = gc_frame_newslot(call6431);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6429 = gc_frame_newslot(*var_methname);
  params[0] = call6431;
  partcv[0] = 1;
  Object opresult6433 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6433 (depth = 5)
  *var_methname = opresult6433;
  if (opresult6433 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6435 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  partcv[0] = 0;
  Object call6437 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6436);
// compiled call node returning call6437 (depth = 6)
// compiled member node returning call6437 (depth = 5)
  gc_frame_newslot(call6437);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call6437;
  partcv[0] = 1;
  Object call6438 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6435);
// compiled call node returning call6438 (depth = 4)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6439 = alloc_Boolean(0);
// compiled identifier node returning bool6439 (depth = 5)
  *var_isTerm = bool6439;
  if (bool6439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6441 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6442 == NULL) {
    strlit6442 = alloc_String("lparen");
    gc_root(strlit6442);
  }
// compiled string node returning strlit6442 (depth = 6)
  gc_frame_newslot(strlit6442);
// call case 4: self request
  params[0] = strlit6442;
  partcv[0] = 1;
  Object call6443 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6441);
// compiled call node returning call6443 (depth = 5)
  Object if6440 = done;
  if (istrue(call6443)) {
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6444 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6445 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6444);
// compiled call node returning call6445 (depth = 6)
// compiled member node returning call6445 (depth = 5)
    gc_frame_newslot(call6445);
    if6440 = call6445;
  } else {
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6447 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call6448 = callmethodflags(self, "acceptArgumentOnLineOf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6447);
// compiled call node returning call6448 (depth = 6)
  Object if6446 = done;
  if (istrue(call6448)) {
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6449 = alloc_Boolean(1);
// compiled identifier node returning bool6449 (depth = 7)
  *var_isTerm = bool6449;
  if (bool6449 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6446 = done;
  } else {
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6451 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6453 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6452);
// compiled call node returning call6453 (depth = 10)
// compiled member node returning call6453 (depth = 9)
  partcv[0] = 0;
  Object call6454 = callmethod(call6453, "new",
    1, partcv, params);
  gc_frame_end(callframe6451);
// compiled call node returning call6454 (depth = 8)
// compiled member node returning call6454 (depth = 7)
  *var_suggestion = call6454;
  if (call6454 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6457 == NULL) {
    strlit6457 = alloc_String("identifier");
    gc_root(strlit6457);
  }
// compiled string node returning strlit6457 (depth = 8)
  int op_slot_right_6456 = gc_frame_newslot(strlit6457);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6460 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6459);
// compiled call node returning call6460 (depth = 9)
// compiled member node returning call6460 (depth = 8)
  int op_slot_left_6456 = gc_frame_newslot(call6460);
  params[0] = strlit6457;
  partcv[0] = 1;
  Object opresult6461 = callmethod(call6460, "==", 1, partcv, params);
// compiled op node returning opresult6461 (depth = 7)
  Object if6455 = done;
  if (istrue(opresult6461)) {
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6462 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool6463 = alloc_Boolean(1);
// compiled identifier node returning bool6463 (depth = 8)
  gc_frame_newslot(bool6463);
// starting to compile identifier node (depth = 8)
  Object bool6464 = alloc_Boolean(0);
// compiled identifier node returning bool6464 (depth = 8)
  gc_frame_newslot(bool6464);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6466 == NULL) {
    strlit6466 = alloc_String(")");
    gc_root(strlit6466);
  }
// compiled string node returning strlit6466 (depth = 9)
  int op_slot_right_6465 = gc_frame_newslot(strlit6466);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6469 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6470 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6469);
// compiled call node returning call6470 (depth = 11)
// compiled member node returning call6470 (depth = 10)
  int op_slot_right_6468 = gc_frame_newslot(call6470);
// starting to compile string node (depth = 10)
  if (strlit6472 == NULL) {
    strlit6472 = alloc_String("(");
    gc_root(strlit6472);
  }
// compiled string node returning strlit6472 (depth = 10)
  int op_slot_left_6468 = gc_frame_newslot(strlit6472);
  params[0] = call6470;
  partcv[0] = 1;
  Object opresult6473 = callmethod(strlit6472, "++", 1, partcv, params);
// compiled op node returning opresult6473 (depth = 9)
  int op_slot_left_6465 = gc_frame_newslot(opresult6473);
  params[0] = strlit6466;
  partcv[0] = 1;
  Object opresult6474 = callmethod(opresult6473, "++", 1, partcv, params);
// compiled op node returning opresult6474 (depth = 8)
  gc_frame_newslot(opresult6474);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool6463;
  params[2] = bool6464;
  params[3] = opresult6474;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6475 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6462);
// compiled call node returning call6475 (depth = 7)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6478 == NULL) {
    strlit6478 = alloc_String("while()do");
    gc_root(strlit6478);
  }
// compiled string node returning strlit6478 (depth = 9)
  int op_slot_right_6477 = gc_frame_newslot(strlit6478);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6477 = gc_frame_newslot(*var_methname);
  params[0] = strlit6478;
  partcv[0] = 1;
  Object opresult6480 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6480 (depth = 8)
  Object if6476 = done;
  if (istrue(opresult6480)) {
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6481 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6482 == NULL) {
    strlit6482 = alloc_String("a while loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6482);
  }
// compiled string node returning strlit6482 (depth = 9)
  gc_frame_newslot(strlit6482);
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6484 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6483);
// compiled call node returning call6484 (depth = 10)
// compiled member node returning call6484 (depth = 9)
  gc_frame_newslot(call6484);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6486 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6485);
// compiled call node returning call6486 (depth = 10)
// compiled member node returning call6486 (depth = 9)
  gc_frame_newslot(call6486);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6482;
  params[1] = call6484;
  params[2] = call6486;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6487 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6481);
// compiled call node returning call6487 (depth = 8)
    gc_frame_newslot(call6487);
    if6476 = call6487;
  } else {
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6490 == NULL) {
    strlit6490 = alloc_String("for()do");
    gc_root(strlit6490);
  }
// compiled string node returning strlit6490 (depth = 10)
  int op_slot_right_6489 = gc_frame_newslot(strlit6490);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_methname (depth = 10)
  int op_slot_left_6489 = gc_frame_newslot(*var_methname);
  params[0] = strlit6490;
  partcv[0] = 1;
  Object opresult6492 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6492 (depth = 9)
  Object if6488 = done;
  if (istrue(opresult6492)) {
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6493 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6494 == NULL) {
    strlit6494 = alloc_String("a for loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6494);
  }
// compiled string node returning strlit6494 (depth = 10)
  gc_frame_newslot(strlit6494);
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6496 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6495);
// compiled call node returning call6496 (depth = 11)
// compiled member node returning call6496 (depth = 10)
  gc_frame_newslot(call6496);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6498 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6497);
// compiled call node returning call6498 (depth = 11)
// compiled member node returning call6498 (depth = 10)
  gc_frame_newslot(call6498);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6494;
  params[1] = call6496;
  params[2] = call6498;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6499 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6493);
// compiled call node returning call6499 (depth = 9)
    gc_frame_newslot(call6499);
    if6488 = call6499;
  } else {
  }
// compiled if node returning if6488 (depth = 8)
    gc_frame_newslot(if6488);
    if6476 = if6488;
  }
// compiled if node returning if6476 (depth = 7)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6500 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6501 == NULL) {
    strlit6501 = alloc_String("each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.");
    gc_root(strlit6501);
  }
// compiled string node returning strlit6501 (depth = 8)
  gc_frame_newslot(strlit6501);
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6503 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6502);
// compiled call node returning call6503 (depth = 9)
// compiled member node returning call6503 (depth = 8)
  gc_frame_newslot(call6503);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6504 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6505 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6504);
// compiled call node returning call6505 (depth = 9)
// compiled member node returning call6505 (depth = 8)
  gc_frame_newslot(call6505);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6501;
  params[1] = call6503;
  params[2] = call6505;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6506 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6500);
// compiled call node returning call6506 (depth = 7)
    gc_frame_newslot(call6506);
    if6455 = call6506;
  } else {
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6509 == NULL) {
    strlit6509 = alloc_String("while()do");
    gc_root(strlit6509);
  }
// compiled string node returning strlit6509 (depth = 9)
  int op_slot_right_6508 = gc_frame_newslot(strlit6509);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6508 = gc_frame_newslot(*var_methname);
  params[0] = strlit6509;
  partcv[0] = 1;
  Object opresult6511 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6511 (depth = 8)
  Object if6507 = done;
  if (istrue(opresult6511)) {
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6512 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6513 == NULL) {
    strlit6513 = alloc_String(" {}");
    gc_root(strlit6513);
  }
// compiled string node returning strlit6513 (depth = 9)
  gc_frame_newslot(strlit6513);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6513;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6514 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6512);
// compiled call node returning call6514 (depth = 8)
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6515 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6516 == NULL) {
    strlit6516 = alloc_String("a while loop must have a body.");
    gc_root(strlit6516);
  }
// compiled string node returning strlit6516 (depth = 9)
  gc_frame_newslot(strlit6516);
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6517 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6518 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6517);
// compiled call node returning call6518 (depth = 10)
// compiled member node returning call6518 (depth = 9)
  gc_frame_newslot(call6518);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6520 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6519);
// compiled call node returning call6520 (depth = 10)
// compiled member node returning call6520 (depth = 9)
  gc_frame_newslot(call6520);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6516;
  params[1] = call6518;
  params[2] = call6520;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6521 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6515);
// compiled call node returning call6521 (depth = 8)
    gc_frame_newslot(call6521);
    if6507 = call6521;
  } else {
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6524 == NULL) {
    strlit6524 = alloc_String("for()do");
    gc_root(strlit6524);
  }
// compiled string node returning strlit6524 (depth = 10)
  int op_slot_right_6523 = gc_frame_newslot(strlit6524);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_methname (depth = 10)
  int op_slot_left_6523 = gc_frame_newslot(*var_methname);
  params[0] = strlit6524;
  partcv[0] = 1;
  Object opresult6526 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6526 (depth = 9)
  Object if6522 = done;
  if (istrue(opresult6526)) {
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6527 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6528 == NULL) {
    strlit6528 = alloc_String(" {}");
    gc_root(strlit6528);
  }
// compiled string node returning strlit6528 (depth = 10)
  gc_frame_newslot(strlit6528);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6528;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6529 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6527);
// compiled call node returning call6529 (depth = 9)
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6530 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6531 == NULL) {
    strlit6531 = alloc_String("a for loop must have a body.");
    gc_root(strlit6531);
  }
// compiled string node returning strlit6531 (depth = 10)
  gc_frame_newslot(strlit6531);
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6533 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6532);
// compiled call node returning call6533 (depth = 11)
// compiled member node returning call6533 (depth = 10)
  gc_frame_newslot(call6533);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6535 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6534);
// compiled call node returning call6535 (depth = 11)
// compiled member node returning call6535 (depth = 10)
  gc_frame_newslot(call6535);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6531;
  params[1] = call6533;
  params[2] = call6535;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6536 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6530);
// compiled call node returning call6536 (depth = 9)
    gc_frame_newslot(call6536);
    if6522 = call6536;
  } else {
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6537 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6538 == NULL) {
    strlit6538 = alloc_String("()");
    gc_root(strlit6538);
  }
// compiled string node returning strlit6538 (depth = 10)
  gc_frame_newslot(strlit6538);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6538;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6539 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6537);
// compiled call node returning call6539 (depth = 9)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6540 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6541 == NULL) {
    strlit6541 = alloc_String("a multi-part method request must end with '()'.");
    gc_root(strlit6541);
  }
// compiled string node returning strlit6541 (depth = 10)
  gc_frame_newslot(strlit6541);
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6543 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6542);
// compiled call node returning call6543 (depth = 11)
// compiled member node returning call6543 (depth = 10)
  gc_frame_newslot(call6543);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6545 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6544);
// compiled call node returning call6545 (depth = 11)
// compiled member node returning call6545 (depth = 10)
  gc_frame_newslot(call6545);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6541;
  params[1] = call6543;
  params[2] = call6545;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6546 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6540);
// compiled call node returning call6546 (depth = 9)
    gc_frame_newslot(call6546);
    if6522 = call6546;
  }
// compiled if node returning if6522 (depth = 8)
    gc_frame_newslot(if6522);
    if6507 = if6522;
  }
// compiled if node returning if6507 (depth = 7)
    gc_frame_newslot(if6507);
    if6455 = if6507;
  }
// compiled if node returning if6455 (depth = 6)
    gc_frame_newslot(if6455);
    if6446 = if6455;
  }
// compiled if node returning if6446 (depth = 5)
    gc_frame_newslot(if6446);
    if6440 = if6446;
  }
// compiled if node returning if6440 (depth = 4)
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6547 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6548 == NULL) {
    strlit6548 = alloc_String("rparen");
    gc_root(strlit6548);
  }
// compiled string node returning strlit6548 (depth = 6)
  gc_frame_newslot(strlit6548);
// call case 4: self request
  params[0] = strlit6548;
  partcv[0] = 1;
  Object call6549 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6547);
// compiled call node returning call6549 (depth = 5)
  *var_isEmpty = call6549;
  if (call6549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isTerm (depth = 5)
  Object if6550 = done;
  if (istrue(*var_isTerm)) {
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6552 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6551);
// compiled call node returning call6552 (depth = 6)
// compiled member node returning call6552 (depth = 5)
    gc_frame_newslot(call6552);
    if6550 = call6552;
  } else {
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6555 == NULL) {
    strlit6555 = alloc_String("rparen");
    gc_root(strlit6555);
  }
// compiled string node returning strlit6555 (depth = 7)
  int op_slot_right_6554 = gc_frame_newslot(strlit6555);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6558 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6557);
// compiled call node returning call6558 (depth = 8)
// compiled member node returning call6558 (depth = 7)
  int op_slot_left_6554 = gc_frame_newslot(call6558);
  params[0] = strlit6555;
  partcv[0] = 1;
  Object opresult6559 = callmethod(call6558, "!=", 1, partcv, params);
// compiled op node returning opresult6559 (depth = 6)
  Object if6553 = done;
  if (istrue(opresult6559)) {
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6561 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6562 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6563 = alloc_Block(NULL, NULL, "parser", 2040);
  gc_frame_newslot(block6563);
// method "_apply"
  block_savedest(block6563);
  Object closure6564 = createclosure(2, "_apply");
  setclosureframe(closure6564, stackframe);
  addtoclosure(closure6564, var_blocksOK);
  addtoclosure(closure6564, selfslot);
  struct UserObject *uo6564 = (struct UserObject*)block6563;
  uo6564->data[0] = (Object)closure6564;
  Method *meth_meth_parser__apply6564 = addmethod2pos(block6563, "_apply", &meth_parser__apply6564, 0);
  int argcv_meth_parser__apply6564[] = {0};
  meth_meth_parser__apply6564->type = alloc_MethodType(1, argcv_meth_parser__apply6564);
  meth_meth_parser__apply6564->definitionModule = modulename;
  meth_meth_parser__apply6564->definitionLine = 2040;
// compiled block node returning block6563 (depth = 10)
  gc_frame_newslot(block6563);
// call case 4: self request
  params[0] = block6563;
  partcv[0] = 1;
  Object call6568 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6562);
// compiled call node returning call6568 (depth = 9)
  partcv[0] = 0;
  Object call6569 = callmethod(call6568, "not",
    1, partcv, params);
  gc_frame_end(callframe6561);
// compiled call node returning call6569 (depth = 8)
// compiled member node returning call6569 (depth = 7)
  Object if6560 = done;
  if (istrue(call6569)) {
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6570 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6571 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6572 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6571);
// compiled call node returning call6572 (depth = 11)
// compiled member node returning call6572 (depth = 10)
  partcv[0] = 0;
  Object call6573 = callmethod(call6572, "empty",
    1, partcv, params);
  gc_frame_end(callframe6570);
// compiled call node returning call6573 (depth = 9)
// compiled member node returning call6573 (depth = 8)
  *var_suggestions = call6573;
  if (call6573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6574 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6575 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6576 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6575);
// compiled call node returning call6576 (depth = 11)
// compiled member node returning call6576 (depth = 10)
  partcv[0] = 0;
  Object call6577 = callmethod(call6576, "new",
    1, partcv, params);
  gc_frame_end(callframe6574);
// compiled call node returning call6577 (depth = 9)
// compiled member node returning call6577 (depth = 8)
  *var_suggestion = call6577;
  if (call6577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6578 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array6579 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit6580 == NULL) {
    strlit6580 = alloc_String("rparen");
    gc_root(strlit6580);
  }
// compiled string node returning strlit6580 (depth = 10)
  params[0] = strlit6580;
  partcv[0] = 1;
  callmethod(array6579, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6579 (depth = 9)
  gc_frame_newslot(array6579);
// call case 4: self request
  params[0] = array6579;
  partcv[0] = 1;
  Object call6581 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6578);
// compiled call node returning call6581 (depth = 8)
  *var_nextTok = call6581;
  if (call6581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6583 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6583 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6585 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6585 (depth = 8)
  Object if6582 = done;
  if (istrue(opresult6585)) {
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6586 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6587 == NULL) {
    strlit6587 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6587);
  }
// compiled string node returning strlit6587 (depth = 9)
  gc_frame_newslot(strlit6587);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6587;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6588 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6586);
// compiled call node returning call6588 (depth = 8)
    gc_frame_newslot(call6588);
    if6582 = call6588;
  } else {
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6589 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6591 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6590);
// compiled call node returning call6591 (depth = 10)
// compiled member node returning call6591 (depth = 9)
  gc_frame_newslot(call6591);
// starting to compile identifier node (depth = 9)
  Object bool6592 = alloc_Boolean(1);
// compiled identifier node returning bool6592 (depth = 9)
  gc_frame_newslot(bool6592);
// starting to compile identifier node (depth = 9)
  Object bool6593 = alloc_Boolean(0);
// compiled identifier node returning bool6593 (depth = 9)
  gc_frame_newslot(bool6593);
// starting to compile string node (depth = 9)
  if (strlit6594 == NULL) {
    strlit6594 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6594);
  }
// compiled string node returning strlit6594 (depth = 9)
  gc_frame_newslot(strlit6594);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6591;
  params[2] = bool6592;
  params[3] = bool6593;
  params[4] = strlit6594;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6595 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6589);
// compiled call node returning call6595 (depth = 8)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6596 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6597 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6596);
// compiled call node returning call6597 (depth = 8)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6598 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6600 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6599);
// compiled call node returning call6600 (depth = 12)
// compiled member node returning call6600 (depth = 11)
  partcv[0] = 0;
  Object call6601 = callmethod(call6600, "new",
    1, partcv, params);
  gc_frame_end(callframe6598);
// compiled call node returning call6601 (depth = 10)
// compiled member node returning call6601 (depth = 9)
  *var_suggestion = call6601;
  if (call6601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6603 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6604 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6605 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6604);
// compiled call node returning call6605 (depth = 10)
// compiled member node returning call6605 (depth = 9)
  gc_frame_newslot(call6605);
// starting to compile identifier node (depth = 9)
  Object bool6606 = alloc_Boolean(1);
// compiled identifier node returning bool6606 (depth = 9)
  gc_frame_newslot(bool6606);
// starting to compile identifier node (depth = 9)
  Object bool6607 = alloc_Boolean(0);
// compiled identifier node returning bool6607 (depth = 9)
  gc_frame_newslot(bool6607);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6605;
  params[2] = bool6606;
  params[3] = bool6607;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6608 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6603);
// compiled call node returning call6608 (depth = 8)
    gc_frame_newslot(call6608);
    if6582 = call6608;
  }
// compiled if node returning if6582 (depth = 7)
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6609 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6610 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6609);
// compiled call node returning call6610 (depth = 7)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6611 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6612 == NULL) {
    strlit6612 = alloc_String("a method request must have an expression or a ')' after a '('.");
    gc_root(strlit6612);
  }
// compiled string node returning strlit6612 (depth = 8)
  gc_frame_newslot(strlit6612);
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6614 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6613);
// compiled call node returning call6614 (depth = 9)
// compiled member node returning call6614 (depth = 8)
  gc_frame_newslot(call6614);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6616 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6615);
// compiled call node returning call6616 (depth = 9)
// compiled member node returning call6616 (depth = 8)
  gc_frame_newslot(call6616);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6612;
  params[1] = call6614;
  params[2] = call6616;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6617 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6611);
// compiled call node returning call6617 (depth = 7)
    gc_frame_newslot(call6617);
    if6560 = call6617;
  } else {
  }
// compiled if node returning if6560 (depth = 6)
    gc_frame_newslot(if6560);
    if6553 = if6560;
  } else {
  }
// compiled if node returning if6553 (depth = 5)
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6618 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6619 = alloc_Block(NULL, NULL, "parser", 2057);
  gc_frame_newslot(block6619);
// method "_apply"
  block_savedest(block6619);
  Object closure6620 = createclosure(1, "_apply");
  setclosureframe(closure6620, stackframe);
  addtoclosure(closure6620, selfslot);
  struct UserObject *uo6620 = (struct UserObject*)block6619;
  uo6620->data[0] = (Object)closure6620;
  Method *meth_meth_parser__apply6620 = addmethod2pos(block6619, "_apply", &meth_parser__apply6620, 0);
  int argcv_meth_parser__apply6620[] = {0};
  meth_meth_parser__apply6620->type = alloc_MethodType(1, argcv_meth_parser__apply6620);
  meth_meth_parser__apply6620->definitionModule = modulename;
  meth_meth_parser__apply6620->definitionLine = 2054;
// compiled block node returning block6619 (depth = 6)
  gc_frame_newslot(block6619);
// starting to compile block node (depth = 6)
  Object block6625 = alloc_Block(NULL, NULL, "parser", 2057);
  gc_frame_newslot(block6625);
// method "_apply"
  block_savedest(block6625);
  Object closure6626 = createclosure(8, "_apply");
  setclosureframe(closure6626, stackframe);
  addtoclosure(closure6626, var_values);
  addtoclosure(closure6626, var_nxt);
  addtoclosure(closure6626, var_part);
  addtoclosure(closure6626, var_blocksOK);
  addtoclosure(closure6626, var_errormessages);
  addtoclosure(closure6626, var_sym);
  addtoclosure(closure6626, var_lastToken);
  addtoclosure(closure6626, selfslot);
  struct UserObject *uo6626 = (struct UserObject*)block6625;
  uo6626->data[0] = (Object)closure6626;
  Method *meth_meth_parser__apply6626 = addmethod2pos(block6625, "_apply", &meth_parser__apply6626, 0);
  int argcv_meth_parser__apply6626[] = {0};
  meth_meth_parser__apply6626->type = alloc_MethodType(1, argcv_meth_parser__apply6626);
  meth_meth_parser__apply6626->definitionModule = modulename;
  meth_meth_parser__apply6626->definitionLine = 2054;
// compiled block node returning block6625 (depth = 6)
  gc_frame_newslot(block6625);
// call case 5: prelude request
  params[0] = block6619;
  params[1] = block6625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6695 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6618);
// compiled call node returning call6695 (depth = 5)
    gc_frame_newslot(call6695);
    if6550 = call6695;
  }
// compiled if node returning if6550 (depth = 4)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6697 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isEmpty (depth = 6)
  partcv[0] = 0;
  Object call6698 = callmethod(*var_isEmpty, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe6697);
// compiled call node returning call6698 (depth = 5)
  Object if6696 = done;
  if (istrue(call6698)) {
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6700 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6699);
// compiled call node returning call6700 (depth = 7)
// compiled member node returning call6700 (depth = 6)
  *var_nxt = call6700;
  if (call6700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6702 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nxt (depth = 6)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6703 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call6704 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6703);
// compiled call node returning call6704 (depth = 7)
// compiled member node returning call6704 (depth = 6)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6705 = callmethod(call6704, "push",
    1, partcv, params);
  gc_frame_end(callframe6702);
// compiled call node returning call6705 (depth = 5)
    gc_frame_newslot(call6705);
    if6696 = call6705;
  } else {
  }
// compiled if node returning if6696 (depth = 4)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_isTerm (depth = 7)
  partcv[0] = 0;
  Object call6708 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe6707);
// compiled call node returning call6708 (depth = 6)
// compiled member node returning call6708 (depth = 5)
  Object if6706 = done;
  if (istrue(call6708)) {
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6711 == NULL) {
    strlit6711 = alloc_String("rparen");
    gc_root(strlit6711);
  }
// compiled string node returning strlit6711 (depth = 7)
  int op_slot_right_6710 = gc_frame_newslot(strlit6711);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6713 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6714 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6713);
// compiled call node returning call6714 (depth = 8)
// compiled member node returning call6714 (depth = 7)
  int op_slot_left_6710 = gc_frame_newslot(call6714);
  params[0] = strlit6711;
  partcv[0] = 1;
  Object opresult6715 = callmethod(call6714, "!=", 1, partcv, params);
// compiled op node returning opresult6715 (depth = 6)
  Object if6709 = done;
  if (istrue(opresult6715)) {
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6716 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6717 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6716);
// compiled call node returning call6717 (depth = 7)
// compiled member node returning call6717 (depth = 6)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6718 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6720 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6719);
// compiled call node returning call6720 (depth = 10)
// compiled member node returning call6720 (depth = 9)
  partcv[0] = 0;
  Object call6721 = callmethod(call6720, "new",
    1, partcv, params);
  gc_frame_end(callframe6718);
// compiled call node returning call6721 (depth = 8)
// compiled member node returning call6721 (depth = 7)
  *var_suggestion = call6721;
  if (call6721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6722 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6723 == NULL) {
    strlit6723 = alloc_String(")");
    gc_root(strlit6723);
  }
// compiled string node returning strlit6723 (depth = 7)
  gc_frame_newslot(strlit6723);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6723;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6724 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6722);
// compiled call node returning call6724 (depth = 6)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6725 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6726 == NULL) {
    strlit6726 = alloc_String("a part of a multi-part method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6726);
  }
// compiled string node returning strlit6726 (depth = 7)
  gc_frame_newslot(strlit6726);
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6728 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6727);
// compiled call node returning call6728 (depth = 8)
// compiled member node returning call6728 (depth = 7)
  gc_frame_newslot(call6728);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call6731 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6730);
// compiled call node returning call6731 (depth = 9)
// compiled member node returning call6731 (depth = 8)
  int op_slot_right_6729 = gc_frame_newslot(call6731);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call6734 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6733);
// compiled call node returning call6734 (depth = 9)
// compiled member node returning call6734 (depth = 8)
  int op_slot_left_6729 = gc_frame_newslot(call6734);
  params[0] = call6731;
  partcv[0] = 1;
  Object sum6735 = callmethod(call6734, "+", 1, partcv, params);
// compiled op node returning sum6735 (depth = 7)
  gc_frame_newslot(sum6735);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6726;
  params[1] = call6728;
  params[2] = sum6735;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6736 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6725);
// compiled call node returning call6736 (depth = 6)
    gc_frame_newslot(call6736);
    if6709 = call6736;
  } else {
  }
// compiled if node returning if6709 (depth = 5)
    gc_frame_newslot(if6709);
    if6706 = if6709;
  } else {
  }
// compiled if node returning if6706 (depth = 4)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isTerm (depth = 8)
  partcv[0] = 0;
  Object call6740 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe6739);
// compiled call node returning call6740 (depth = 7)
// compiled member node returning call6740 (depth = 6)
  int op_slot_right_6738 = gc_frame_newslot(call6740);
// starting to compile call node (depth = 6)
  int callframe6742 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6743 == NULL) {
    strlit6743 = alloc_String("rparen");
    gc_root(strlit6743);
  }
// compiled string node returning strlit6743 (depth = 7)
  gc_frame_newslot(strlit6743);
// call case 4: self request
  params[0] = strlit6743;
  partcv[0] = 1;
  Object call6744 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6742);
// compiled call node returning call6744 (depth = 6)
  int op_slot_left_6738 = gc_frame_newslot(call6744);
  params[0] = call6740;
  partcv[0] = 1;
  Object opresult6745 = callmethod(call6744, "&&", 1, partcv, params);
// compiled op node returning opresult6745 (depth = 5)
  Object if6737 = done;
  if (istrue(opresult6745)) {
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6746 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6747 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6746);
// compiled call node returning call6747 (depth = 6)
// compiled member node returning call6747 (depth = 5)
    gc_frame_newslot(call6747);
    if6737 = call6747;
  } else {
  }
// compiled if node returning if6737 (depth = 4)
  gc_frame_end(frame);
  return if6737;
}
Object meth_parser_callmprest6392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callmprest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method callmprest");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callmprest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for callmprest");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methname");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_lp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lp");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_meth_39_ = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "meth'");
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6394 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6393);
// compiled call node returning call6394 (depth = 4)
// compiled member node returning call6394 (depth = 3)
  *var_methname = call6394;
  if (call6394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6396 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6395);
// compiled call node returning call6396 (depth = 4)
// compiled member node returning call6396 (depth = 3)
  *var_lp = call6396;
  if (call6396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_part = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6397 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6398 = alloc_Block(NULL, NULL, "parser", 1990);
  gc_frame_newslot(block6398);
// method "_apply"
  block_savedest(block6398);
  Object closure6399 = createclosure(3, "_apply");
  setclosureframe(closure6399, stackframe);
  addtoclosure(closure6399, var_lastToken);
  addtoclosure(closure6399, var_tok);
  addtoclosure(closure6399, selfslot);
  struct UserObject *uo6399 = (struct UserObject*)block6398;
  uo6399->data[0] = (Object)closure6399;
  Method *meth_meth_parser__apply6399 = addmethod2pos(block6398, "_apply", &meth_parser__apply6399, 0);
  int argcv_meth_parser__apply6399[] = {0};
  meth_meth_parser__apply6399->type = alloc_MethodType(1, argcv_meth_parser__apply6399);
  meth_meth_parser__apply6399->definitionModule = modulename;
  meth_meth_parser__apply6399->definitionLine = 1988;
// compiled block node returning block6398 (depth = 3)
  gc_frame_newslot(block6398);
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6410 = alloc_Block(NULL, NULL, "parser", 1991);
  gc_frame_newslot(block6410);
// method "_apply"
  block_savedest(block6410);
  Object closure6411 = createclosure(11, "_apply");
  setclosureframe(closure6411, stackframe);
  addtoclosure(closure6411, var_ast);
  addtoclosure(closure6411, var_part);
  addtoclosure(closure6411, var_signature);
  addtoclosure(closure6411, var_methname);
  addtoclosure(closure6411, var_values);
  addtoclosure(closure6411, var_nxt);
  addtoclosure(closure6411, var_lastToken);
  addtoclosure(closure6411, var_errormessages);
  addtoclosure(closure6411, var_sym);
  addtoclosure(closure6411, var_blocksOK);
  addtoclosure(closure6411, selfslot);
  struct UserObject *uo6411 = (struct UserObject*)block6410;
  uo6411->data[0] = (Object)closure6411;
  Method *meth_meth_parser__apply6411 = addmethod2pos(block6410, "_apply", &meth_parser__apply6411, 0);
  int argcv_meth_parser__apply6411[] = {0};
  meth_meth_parser__apply6411->type = alloc_MethodType(1, argcv_meth_parser__apply6411);
  meth_meth_parser__apply6411->definitionModule = modulename;
  meth_meth_parser__apply6411->definitionLine = 1988;
// compiled block node returning block6410 (depth = 3)
  gc_frame_newslot(block6410);
// call case 5: prelude request
  params[0] = block6398;
  params[1] = block6410;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6749 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6397);
// compiled call node returning call6749 (depth = 2)
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool6751 = alloc_Boolean(0);
// compiled identifier node returning bool6751 (depth = 4)
  gc_frame_newslot(bool6751);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6752 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call6753 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe6752);
// compiled call node returning call6753 (depth = 5)
// compiled member node returning call6753 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool6751;
  partcv[0] = 2;
  Object call6754 = callmethod(call6753, "new",
    1, partcv, params);
  gc_frame_end(callframe6750);
// compiled call node returning call6754 (depth = 3)
  *var_meth_39_ = call6754;
  if (call6754 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6755 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6757 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe6756);
// compiled call node returning call6757 (depth = 4)
// compiled member node returning call6757 (depth = 3)
  gc_frame_newslot(call6757);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth_39_ (depth = 3)
  params[0] = call6757;
  partcv[0] = 1;
  Object call6758 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6755);
// compiled call node returning call6758 (depth = 2)
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6759 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6761 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6760);
// compiled call node returning call6761 (depth = 4)
// compiled member node returning call6761 (depth = 3)
  gc_frame_newslot(call6761);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth_39_ (depth = 3)
  params[0] = call6761;
  partcv[0] = 1;
  Object call6762 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6759);
// compiled call node returning call6762 (depth = 2)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth_39_ (depth = 2)
  gc_frame_end(frame);
  return *var_meth_39_;
}
Object meth_parser__apply6787(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6791 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6790);
// compiled call node returning call6791 (depth = 10)
// compiled member node returning call6791 (depth = 9)
  int op_slot_right_6789 = gc_frame_newslot(call6791);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6793 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call6794 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe6793);
// compiled call node returning call6794 (depth = 10)
// compiled member node returning call6794 (depth = 9)
  int op_slot_left_6789 = gc_frame_newslot(call6794);
  params[0] = call6791;
  partcv[0] = 1;
  Object opresult6795 = callmethod(call6794, "==", 1, partcv, params);
// compiled op node returning opresult6795 (depth = 8)
  int op_slot_right_6788 = gc_frame_newslot(opresult6795);
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6799 == NULL) {
    strlit6799 = alloc_String("=");
    gc_root(strlit6799);
  }
// compiled string node returning strlit6799 (depth = 10)
  int op_slot_right_6798 = gc_frame_newslot(strlit6799);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call6802 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe6801);
// compiled call node returning call6802 (depth = 11)
// compiled member node returning call6802 (depth = 10)
  int op_slot_left_6798 = gc_frame_newslot(call6802);
  params[0] = strlit6799;
  partcv[0] = 1;
  Object opresult6803 = callmethod(call6802, "==", 1, partcv, params);
// compiled op node returning opresult6803 (depth = 9)
  int op_slot_right_6797 = gc_frame_newslot(opresult6803);
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6806 == NULL) {
    strlit6806 = alloc_String("op");
    gc_root(strlit6806);
  }
// compiled string node returning strlit6806 (depth = 10)
  int op_slot_right_6805 = gc_frame_newslot(strlit6806);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call6809 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe6808);
// compiled call node returning call6809 (depth = 11)
// compiled member node returning call6809 (depth = 10)
  int op_slot_left_6805 = gc_frame_newslot(call6809);
  params[0] = strlit6806;
  partcv[0] = 1;
  Object opresult6810 = callmethod(call6809, "==", 1, partcv, params);
// compiled op node returning opresult6810 (depth = 9)
  int op_slot_left_6797 = gc_frame_newslot(opresult6810);
  params[0] = opresult6803;
  partcv[0] = 1;
  Object opresult6811 = callmethod(opresult6810, "&&", 1, partcv, params);
// compiled op node returning opresult6811 (depth = 8)
  int op_slot_left_6788 = gc_frame_newslot(opresult6811);
  params[0] = opresult6795;
  partcv[0] = 1;
  Object opresult6812 = callmethod(opresult6811, "&&", 1, partcv, params);
// compiled op node returning opresult6812 (depth = 7)
  gc_frame_end(frame);
  return opresult6812;
}
Object meth_parser__apply6879(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe6880 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6881 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6880);
// compiled call node returning call6881 (depth = 9)
  gc_frame_end(frame);
  return call6881;
}
Object meth_parser_defdec6763(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_defaultDefVisibility = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defdec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_defTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "defTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_nextTok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "nextTok");
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6765 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6766 == NULL) {
    strlit6766 = alloc_String("def");
    gc_root(strlit6766);
  }
// compiled string node returning strlit6766 (depth = 4)
  gc_frame_newslot(strlit6766);
// call case 4: self request
  params[0] = strlit6766;
  partcv[0] = 1;
  Object call6767 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6765);
// compiled call node returning call6767 (depth = 3)
  Object if6764 = done;
  if (istrue(call6767)) {
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6768 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6769 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6768);
// compiled call node returning call6769 (depth = 5)
// compiled member node returning call6769 (depth = 4)
  *var_line = call6769;
  if (call6769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6771 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6770);
// compiled call node returning call6771 (depth = 5)
// compiled member node returning call6771 (depth = 4)
  *var_pos = call6771;
  if (call6771 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6773 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6772);
// compiled call node returning call6773 (depth = 4)
// compiled member node returning call6773 (depth = 3)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6776 == NULL) {
    strlit6776 = alloc_String("identifier");
    gc_root(strlit6776);
  }
// compiled string node returning strlit6776 (depth = 5)
  int op_slot_right_6775 = gc_frame_newslot(strlit6776);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6778 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6779 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6778);
// compiled call node returning call6779 (depth = 6)
// compiled member node returning call6779 (depth = 5)
  int op_slot_left_6775 = gc_frame_newslot(call6779);
  params[0] = strlit6776;
  partcv[0] = 1;
  Object opresult6780 = callmethod(call6779, "!=", 1, partcv, params);
// compiled op node returning opresult6780 (depth = 4)
  Object if6774 = done;
  if (istrue(opresult6780)) {
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6781 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6782 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call6783 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6782);
// compiled call node returning call6783 (depth = 8)
// compiled member node returning call6783 (depth = 7)
  partcv[0] = 0;
  Object call6784 = callmethod(call6783, "new",
    1, partcv, params);
  gc_frame_end(callframe6781);
// compiled call node returning call6784 (depth = 6)
// compiled member node returning call6784 (depth = 5)
  *var_suggestion = call6784;
  if (call6784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6785 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6786 = alloc_Block(NULL, NULL, "parser", 2111);
  gc_frame_newslot(block6786);
// method "_apply"
  block_savedest(block6786);
  Object closure6787 = createclosure(2, "_apply");
  setclosureframe(closure6787, stackframe);
  addtoclosure(closure6787, var_sym);
  addtoclosure(closure6787, selfslot);
  struct UserObject *uo6787 = (struct UserObject*)block6786;
  uo6787->data[0] = (Object)closure6787;
  Method *meth_meth_parser__apply6787 = addmethod2pos(block6786, "_apply", &meth_parser__apply6787, 0);
  int argcv_meth_parser__apply6787[] = {1};
  meth_meth_parser__apply6787->type = alloc_MethodType(1, argcv_meth_parser__apply6787);
  meth_meth_parser__apply6787->definitionModule = modulename;
  meth_meth_parser__apply6787->definitionLine = 2110;
// compiled block node returning block6786 (depth = 6)
  gc_frame_newslot(block6786);
// call case 4: self request
  params[0] = block6786;
  partcv[0] = 1;
  Object call6814 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6785);
// compiled call node returning call6814 (depth = 5)
  *var_nextToken = call6814;
  if (call6814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6817 = alloc_Boolean(0);
// compiled identifier node returning bool6817 (depth = 6)
  int op_slot_right_6816 = gc_frame_newslot(bool6817);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  int op_slot_left_6816 = gc_frame_newslot(*var_nextToken);
  params[0] = bool6817;
  partcv[0] = 1;
  Object opresult6819 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult6819 (depth = 5)
  Object if6815 = done;
  if (istrue(opresult6819)) {
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6820 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6821 == NULL) {
    strlit6821 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit6821);
  }
// compiled string node returning strlit6821 (depth = 6)
  gc_frame_newslot(strlit6821);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6821;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6822 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6820);
// compiled call node returning call6822 (depth = 5)
    gc_frame_newslot(call6822);
    if6815 = call6822;
  } else {
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6824 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_6824 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6826 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult6826 (depth = 6)
  Object if6823 = done;
  if (istrue(opresult6826)) {
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6827 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6828 == NULL) {
    strlit6828 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit6828);
  }
// compiled string node returning strlit6828 (depth = 7)
  gc_frame_newslot(strlit6828);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6828;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6829 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6827);
// compiled call node returning call6829 (depth = 6)
    gc_frame_newslot(call6829);
    if6823 = call6829;
  } else {
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6830 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextToken (depth = 9)
  partcv[0] = 0;
  Object call6832 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe6831);
// compiled call node returning call6832 (depth = 8)
// compiled member node returning call6832 (depth = 7)
  gc_frame_newslot(call6832);
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6833 = alloc_Boolean(0);
// compiled identifier node returning bool6833 (depth = 7)
  gc_frame_newslot(bool6833);
// starting to compile identifier node (depth = 7)
  Object bool6834 = alloc_Boolean(1);
// compiled identifier node returning bool6834 (depth = 7)
  gc_frame_newslot(bool6834);
// starting to compile string node (depth = 7)
  if (strlit6835 == NULL) {
    strlit6835 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit6835);
  }
// compiled string node returning strlit6835 (depth = 7)
  gc_frame_newslot(strlit6835);
// call case 6: other member request
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6832;
  params[2] = bool6833;
  params[3] = bool6834;
  params[4] = strlit6835;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6836 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6830);
// compiled call node returning call6836 (depth = 6)
    gc_frame_newslot(call6836);
    if6823 = call6836;
  }
// compiled if node returning if6823 (depth = 5)
    gc_frame_newslot(if6823);
    if6815 = if6823;
  }
// compiled if node returning if6815 (depth = 4)
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6837 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6839 == NULL) {
    strlit6839 = alloc_String("and a value after the 'def'.");
    gc_root(strlit6839);
  }
// compiled string node returning strlit6839 (depth = 6)
  int op_slot_right_6838 = gc_frame_newslot(strlit6839);
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6841 == NULL) {
    strlit6841 = alloc_String("a definition must have a name, '=', ");
    gc_root(strlit6841);
  }
// compiled string node returning strlit6841 (depth = 6)
  int op_slot_left_6838 = gc_frame_newslot(strlit6841);
  params[0] = strlit6839;
  partcv[0] = 1;
  Object opresult6842 = callmethod(strlit6841, "++", 1, partcv, params);
// compiled op node returning opresult6842 (depth = 5)
  gc_frame_newslot(opresult6842);
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6843 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6844 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6843);
// compiled call node returning call6844 (depth = 6)
// compiled member node returning call6844 (depth = 5)
  gc_frame_newslot(call6844);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6845 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6846 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6845);
// compiled call node returning call6846 (depth = 6)
// compiled member node returning call6846 (depth = 5)
  gc_frame_newslot(call6846);
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult6842;
  params[1] = call6844;
  params[2] = call6846;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6847 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6837);
// compiled call node returning call6847 (depth = 4)
    gc_frame_newslot(call6847);
    if6774 = call6847;
  } else {
  }
// compiled if node returning if6774 (depth = 3)
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6849 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6848);
// compiled call node returning call6849 (depth = 4)
// compiled member node returning call6849 (depth = 3)
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6850 = alloc_Boolean(0);
// compiled identifier node returning bool6850 (depth = 4)
  *var_val = bool6850;
  if (bool6850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6851 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6852 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6851);
// compiled call node returning call6852 (depth = 5)
// compiled member node returning call6852 (depth = 4)
  *var_name = call6852;
  if (call6852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6853 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6854 = alloc_Boolean(1);
// compiled identifier node returning bool6854 (depth = 4)
  gc_frame_newslot(bool6854);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool6854;
  partcv[0] = 1;
  Object call6855 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe6853);
// compiled call node returning call6855 (depth = 3)
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6856 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6857 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6856);
// compiled call node returning call6857 (depth = 5)
// compiled member node returning call6857 (depth = 4)
  *var_dtype = call6857;
  if (call6857 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6858 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6859 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6858);
// compiled call node returning call6859 (depth = 5)
// compiled member node returning call6859 (depth = 4)
  *var_anns = call6859;
  if (call6859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6863 == NULL) {
    strlit6863 = alloc_String("=");
    gc_root(strlit6863);
  }
// compiled string node returning strlit6863 (depth = 6)
  int op_slot_right_6862 = gc_frame_newslot(strlit6863);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6866 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6865);
// compiled call node returning call6866 (depth = 7)
// compiled member node returning call6866 (depth = 6)
  int op_slot_left_6862 = gc_frame_newslot(call6866);
  params[0] = strlit6863;
  partcv[0] = 1;
  Object opresult6867 = callmethod(call6866, "==", 1, partcv, params);
// compiled op node returning opresult6867 (depth = 5)
  int op_slot_right_6861 = gc_frame_newslot(opresult6867);
// starting to compile call node (depth = 5)
  int callframe6869 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6870 == NULL) {
    strlit6870 = alloc_String("op");
    gc_root(strlit6870);
  }
// compiled string node returning strlit6870 (depth = 6)
  gc_frame_newslot(strlit6870);
// call case 4: self request
  params[0] = strlit6870;
  partcv[0] = 1;
  Object call6871 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6869);
// compiled call node returning call6871 (depth = 5)
  int op_slot_left_6861 = gc_frame_newslot(call6871);
  params[0] = opresult6867;
  partcv[0] = 1;
  Object opresult6872 = callmethod(call6871, "&&", 1, partcv, params);
// compiled op node returning opresult6872 (depth = 4)
  Object if6860 = done;
  if (istrue(opresult6872)) {
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6873 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6874 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6873);
// compiled call node returning call6874 (depth = 5)
// compiled member node returning call6874 (depth = 4)
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6876 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe6877 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6878 = alloc_Block(NULL, NULL, "parser", 2133);
  gc_frame_newslot(block6878);
// method "_apply"
  block_savedest(block6878);
  Object closure6879 = createclosure(2, "_apply");
  setclosureframe(closure6879, stackframe);
  addtoclosure(closure6879, var_blocksOK);
  addtoclosure(closure6879, selfslot);
  struct UserObject *uo6879 = (struct UserObject*)block6878;
  uo6879->data[0] = (Object)closure6879;
  Method *meth_meth_parser__apply6879 = addmethod2pos(block6878, "_apply", &meth_parser__apply6879, 0);
  int argcv_meth_parser__apply6879[] = {0};
  meth_meth_parser__apply6879->type = alloc_MethodType(1, argcv_meth_parser__apply6879);
  meth_meth_parser__apply6879->definitionModule = modulename;
  meth_meth_parser__apply6879->definitionLine = 2133;
// compiled block node returning block6878 (depth = 8)
  gc_frame_newslot(block6878);
// call case 4: self request
  params[0] = block6878;
  partcv[0] = 1;
  Object call6883 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6877);
// compiled call node returning call6883 (depth = 7)
  partcv[0] = 0;
  Object call6884 = callmethod(call6883, "not",
    1, partcv, params);
  gc_frame_end(callframe6876);
// compiled call node returning call6884 (depth = 6)
// compiled member node returning call6884 (depth = 5)
  Object if6875 = done;
  if (istrue(call6884)) {
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6885 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6887 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6886);
// compiled call node returning call6887 (depth = 9)
// compiled member node returning call6887 (depth = 8)
  partcv[0] = 0;
  Object call6888 = callmethod(call6887, "new",
    1, partcv, params);
  gc_frame_end(callframe6885);
// compiled call node returning call6888 (depth = 7)
// compiled member node returning call6888 (depth = 6)
  *var_suggestion = call6888;
  if (call6888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6889 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array6890 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6890 (depth = 7)
  gc_frame_newslot(array6890);
// call case 4: self request
  params[0] = array6890;
  partcv[0] = 1;
  Object call6891 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6889);
// compiled call node returning call6891 (depth = 6)
  *var_nextTok = call6891;
  if (call6891 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6893 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_6893 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6895 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6895 (depth = 6)
  Object if6892 = done;
  if (istrue(opresult6895)) {
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6896 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6897 == NULL) {
    strlit6897 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6897);
  }
// compiled string node returning strlit6897 (depth = 7)
  gc_frame_newslot(strlit6897);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6897;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6898 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6896);
// compiled call node returning call6898 (depth = 6)
    gc_frame_newslot(call6898);
    if6892 = call6898;
  } else {
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6899 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call6901 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6900);
// compiled call node returning call6901 (depth = 8)
// compiled member node returning call6901 (depth = 7)
  gc_frame_newslot(call6901);
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6902 = alloc_Boolean(1);
// compiled identifier node returning bool6902 (depth = 7)
  gc_frame_newslot(bool6902);
// starting to compile identifier node (depth = 7)
  Object bool6903 = alloc_Boolean(0);
// compiled identifier node returning bool6903 (depth = 7)
  gc_frame_newslot(bool6903);
// starting to compile string node (depth = 7)
  if (strlit6904 == NULL) {
    strlit6904 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6904);
  }
// compiled string node returning strlit6904 (depth = 7)
  gc_frame_newslot(strlit6904);
// call case 6: other member request
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6901;
  params[2] = bool6902;
  params[3] = bool6903;
  params[4] = strlit6904;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6905 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6899);
// compiled call node returning call6905 (depth = 6)
    gc_frame_newslot(call6905);
    if6892 = call6905;
  }
// compiled if node returning if6892 (depth = 5)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6906 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6907 == NULL) {
    strlit6907 = alloc_String("a definition must have a value after the '='.");
    gc_root(strlit6907);
  }
// compiled string node returning strlit6907 (depth = 6)
  gc_frame_newslot(strlit6907);
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6909 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6908);
// compiled call node returning call6909 (depth = 7)
// compiled member node returning call6909 (depth = 6)
  gc_frame_newslot(call6909);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6912 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6911);
// compiled call node returning call6912 (depth = 8)
// compiled member node returning call6912 (depth = 7)
  int op_slot_right_6910 = gc_frame_newslot(call6912);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6914 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6915 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6914);
// compiled call node returning call6915 (depth = 8)
// compiled member node returning call6915 (depth = 7)
  int op_slot_left_6910 = gc_frame_newslot(call6915);
  params[0] = call6912;
  partcv[0] = 1;
  Object sum6916 = callmethod(call6915, "+", 1, partcv, params);
// compiled op node returning sum6916 (depth = 6)
  gc_frame_newslot(sum6916);
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit6907;
  params[1] = call6909;
  params[2] = sum6916;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6917 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6906);
// compiled call node returning call6917 (depth = 5)
    gc_frame_newslot(call6917);
    if6875 = call6917;
  } else {
  }
// compiled if node returning if6875 (depth = 4)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6919 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6918);
// compiled call node returning call6919 (depth = 6)
// compiled member node returning call6919 (depth = 5)
  *var_val = call6919;
  if (call6919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6860 = done;
  } else {
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6922 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6923 == NULL) {
    strlit6923 = alloc_String("bind");
    gc_root(strlit6923);
  }
// compiled string node returning strlit6923 (depth = 6)
  gc_frame_newslot(strlit6923);
// call case 4: self request
  params[0] = strlit6923;
  partcv[0] = 1;
  Object call6924 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6922);
// compiled call node returning call6924 (depth = 5)
  Object if6921 = done;
  if (istrue(call6924)) {
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6926 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6927 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6926);
// compiled call node returning call6927 (depth = 9)
// compiled member node returning call6927 (depth = 8)
  partcv[0] = 0;
  Object call6928 = callmethod(call6927, "empty",
    1, partcv, params);
  gc_frame_end(callframe6925);
// compiled call node returning call6928 (depth = 7)
// compiled member node returning call6928 (depth = 6)
  *var_suggestions = call6928;
  if (call6928 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6929 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6931 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6930);
// compiled call node returning call6931 (depth = 9)
// compiled member node returning call6931 (depth = 8)
  partcv[0] = 0;
  Object call6932 = callmethod(call6931, "new",
    1, partcv, params);
  gc_frame_end(callframe6929);
// compiled call node returning call6932 (depth = 7)
// compiled member node returning call6932 (depth = 6)
  *var_suggestion = call6932;
  if (call6932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6933 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit6934 == NULL) {
    strlit6934 = alloc_String("=");
    gc_root(strlit6934);
  }
// compiled string node returning strlit6934 (depth = 6)
  gc_frame_newslot(strlit6934);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit6934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6935 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe6933);
// compiled call node returning call6935 (depth = 5)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6936 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6937 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6936);
// compiled call node returning call6937 (depth = 5)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6938 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6940 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6939);
// compiled call node returning call6940 (depth = 9)
// compiled member node returning call6940 (depth = 8)
  partcv[0] = 0;
  Object call6941 = callmethod(call6940, "new",
    1, partcv, params);
  gc_frame_end(callframe6938);
// compiled call node returning call6941 (depth = 7)
// compiled member node returning call6941 (depth = 6)
  *var_suggestion = call6941;
  if (call6941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6943 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit6944 == NULL) {
    strlit6944 = alloc_String("var");
    gc_root(strlit6944);
  }
// compiled string node returning strlit6944 (depth = 6)
  gc_frame_newslot(strlit6944);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit6944;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6945 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe6943);
// compiled call node returning call6945 (depth = 5)
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6946 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6947 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6946);
// compiled call node returning call6947 (depth = 5)
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6948 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6950 == NULL) {
    strlit6950 = alloc_String("A variable declaration uses 'var' and ':='.");
    gc_root(strlit6950);
  }
// compiled string node returning strlit6950 (depth = 7)
  int op_slot_right_6949 = gc_frame_newslot(strlit6950);
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6952 == NULL) {
    strlit6952 = alloc_String("a definition must use '=' instead of ':='. ");
    gc_root(strlit6952);
  }
// compiled string node returning strlit6952 (depth = 7)
  int op_slot_left_6949 = gc_frame_newslot(strlit6952);
  params[0] = strlit6950;
  partcv[0] = 1;
  Object opresult6953 = callmethod(strlit6952, "++", 1, partcv, params);
// compiled op node returning opresult6953 (depth = 6)
  gc_frame_newslot(opresult6953);
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6955 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6954);
// compiled call node returning call6955 (depth = 7)
// compiled member node returning call6955 (depth = 6)
  gc_frame_newslot(call6955);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6957 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6956);
// compiled call node returning call6957 (depth = 7)
// compiled member node returning call6957 (depth = 6)
  gc_frame_newslot(call6957);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6959 = alloc_Float64(1);
// compiled num node returning num6959 (depth = 7)
  int op_slot_right_6958 = gc_frame_newslot(num6959);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6962 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6961);
// compiled call node returning call6962 (depth = 8)
// compiled member node returning call6962 (depth = 7)
  int op_slot_left_6958 = gc_frame_newslot(call6962);
  params[0] = num6959;
  partcv[0] = 1;
  Object sum6963 = callmethod(call6962, "+", 1, partcv, params);
// compiled op node returning sum6963 (depth = 6)
  gc_frame_newslot(sum6963);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6953;
  params[1] = call6955;
  params[2] = call6957;
  params[3] = sum6963;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6964 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6948);
// compiled call node returning call6964 (depth = 5)
    gc_frame_newslot(call6964);
    if6921 = call6964;
  } else {
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6965 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6966 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6967 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6966);
// compiled call node returning call6967 (depth = 9)
// compiled member node returning call6967 (depth = 8)
  partcv[0] = 0;
  Object call6968 = callmethod(call6967, "empty",
    1, partcv, params);
  gc_frame_end(callframe6965);
// compiled call node returning call6968 (depth = 7)
// compiled member node returning call6968 (depth = 6)
  *var_suggestions = call6968;
  if (call6968 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6969 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6971 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6970);
// compiled call node returning call6971 (depth = 9)
// compiled member node returning call6971 (depth = 8)
  partcv[0] = 0;
  Object call6972 = callmethod(call6971, "new",
    1, partcv, params);
  gc_frame_end(callframe6969);
// compiled call node returning call6972 (depth = 7)
// compiled member node returning call6972 (depth = 6)
  *var_suggestion = call6972;
  if (call6972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6973 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6974 == NULL) {
    strlit6974 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6974);
  }
// compiled string node returning strlit6974 (depth = 6)
  gc_frame_newslot(strlit6974);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6974;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6975 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6973);
// compiled call node returning call6975 (depth = 5)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6976 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6977 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6976);
// compiled call node returning call6977 (depth = 5)
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6978 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6980 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6979);
// compiled call node returning call6980 (depth = 9)
// compiled member node returning call6980 (depth = 8)
  partcv[0] = 0;
  Object call6981 = callmethod(call6980, "new",
    1, partcv, params);
  gc_frame_end(callframe6978);
// compiled call node returning call6981 (depth = 7)
// compiled member node returning call6981 (depth = 6)
  *var_suggestion = call6981;
  if (call6981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit6984 == NULL) {
    strlit6984 = alloc_String("var");
    gc_root(strlit6984);
  }
// compiled string node returning strlit6984 (depth = 6)
  gc_frame_newslot(strlit6984);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit6984;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6985 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe6983);
// compiled call node returning call6985 (depth = 5)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6986 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6987 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6986);
// compiled call node returning call6987 (depth = 5)
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6988 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6990 == NULL) {
    strlit6990 = alloc_String("A variable declaration does not require a value but uses 'var', not 'def'.");
    gc_root(strlit6990);
  }
// compiled string node returning strlit6990 (depth = 7)
  int op_slot_right_6989 = gc_frame_newslot(strlit6990);
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6992 == NULL) {
    strlit6992 = alloc_String("a definition must have '=' and a value after the name. ");
    gc_root(strlit6992);
  }
// compiled string node returning strlit6992 (depth = 7)
  int op_slot_left_6989 = gc_frame_newslot(strlit6992);
  params[0] = strlit6990;
  partcv[0] = 1;
  Object opresult6993 = callmethod(strlit6992, "++", 1, partcv, params);
// compiled op node returning opresult6993 (depth = 6)
  gc_frame_newslot(opresult6993);
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6994 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6995 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6994);
// compiled call node returning call6995 (depth = 7)
// compiled member node returning call6995 (depth = 6)
  gc_frame_newslot(call6995);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6997 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6996);
// compiled call node returning call6997 (depth = 7)
// compiled member node returning call6997 (depth = 6)
  gc_frame_newslot(call6997);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6993;
  params[1] = call6995;
  params[2] = call6997;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6998 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6988);
// compiled call node returning call6998 (depth = 5)
    gc_frame_newslot(call6998);
    if6921 = call6998;
  }
// compiled if node returning if6921 (depth = 4)
    gc_frame_newslot(if6921);
    if6860 = if6921;
  }
// compiled if node returning if6860 (depth = 3)
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6999 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7000 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  partcv[0] = 0;
  Object call7001 = callmethod(*var_defTok, "line",
    1, partcv, params);
  gc_frame_end(callframe7000);
// compiled call node returning call7001 (depth = 5)
// compiled member node returning call7001 (depth = 4)
  gc_frame_newslot(call7001);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  partcv[0] = 0;
  Object call7003 = callmethod(*var_defTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7002);
// compiled call node returning call7003 (depth = 5)
// compiled member node returning call7003 (depth = 4)
  gc_frame_newslot(call7003);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7001;
  params[1] = call7003;
  partcv[0] = 2;
  Object call7004 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe6999);
// compiled call node returning call7004 (depth = 3)
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7005 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7007 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe7006);
// compiled call node returning call7007 (depth = 6)
// compiled member node returning call7007 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7008 = callmethod(call7007, "new",
    1, partcv, params);
  gc_frame_end(callframe7005);
// compiled call node returning call7008 (depth = 4)
  *var_o = call7008;
  if (call7008 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7011 = alloc_Boolean(0);
// compiled identifier node returning bool7011 (depth = 5)
  int op_slot_right_7010 = gc_frame_newslot(bool7011);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_7010 = gc_frame_newslot(*var_anns);
  params[0] = bool7011;
  partcv[0] = 1;
  Object opresult7013 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult7013 (depth = 4)
  Object if7009 = done;
  if (istrue(opresult7013)) {
// starting to compile call node (depth = 4)
  int callframe7014 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7015 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7016 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7015);
// compiled call node returning call7016 (depth = 6)
// compiled member node returning call7016 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7017 = callmethod(call7016, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7014);
// compiled call node returning call7017 (depth = 4)
    gc_frame_newslot(call7017);
    if7009 = call7017;
  } else {
  }
// compiled if node returning if7009 (depth = 3)
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7018 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultDefVisibility (depth = 4)
  gc_frame_newslot(*var_defaultDefVisibility);
// starting to compile string node (depth = 4)
  if (strlit7019 == NULL) {
    strlit7019 = alloc_String("confidential");
    gc_root(strlit7019);
  }
// compiled string node returning strlit7019 (depth = 4)
  gc_frame_newslot(strlit7019);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultDefVisibility;
  params[2] = strlit7019;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7020 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7018);
// compiled call node returning call7020 (depth = 3)
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7021 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defTok (depth = 4)
  gc_frame_newslot(*var_defTok);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call7022 = callmethod(*var_o, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe7021);
// compiled call node returning call7022 (depth = 3)
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7023 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7024 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7023);
// compiled call node returning call7024 (depth = 3)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7026 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7025);
// compiled call node returning call7026 (depth = 4)
// compiled member node returning call7026 (depth = 3)
    gc_frame_newslot(call7026);
    if6764 = call7026;
  } else {
  }
// compiled if node returning if6764 (depth = 2)
  gc_frame_end(frame);
  return if6764;
}
Object meth_parser__apply7051(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7054 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7055 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7054);
// compiled call node returning call7055 (depth = 10)
// compiled member node returning call7055 (depth = 9)
  int op_slot_right_7053 = gc_frame_newslot(call7055);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7057 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7058 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7057);
// compiled call node returning call7058 (depth = 10)
// compiled member node returning call7058 (depth = 9)
  int op_slot_left_7053 = gc_frame_newslot(call7058);
  params[0] = call7055;
  partcv[0] = 1;
  Object opresult7059 = callmethod(call7058, "==", 1, partcv, params);
// compiled op node returning opresult7059 (depth = 8)
  int op_slot_right_7052 = gc_frame_newslot(opresult7059);
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7062 == NULL) {
    strlit7062 = alloc_String("bind");
    gc_root(strlit7062);
  }
// compiled string node returning strlit7062 (depth = 9)
  int op_slot_right_7061 = gc_frame_newslot(strlit7062);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7065 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7064);
// compiled call node returning call7065 (depth = 10)
// compiled member node returning call7065 (depth = 9)
  int op_slot_left_7061 = gc_frame_newslot(call7065);
  params[0] = strlit7062;
  partcv[0] = 1;
  Object opresult7066 = callmethod(call7065, "==", 1, partcv, params);
// compiled op node returning opresult7066 (depth = 8)
  int op_slot_left_7052 = gc_frame_newslot(opresult7066);
  params[0] = opresult7059;
  partcv[0] = 1;
  Object opresult7067 = callmethod(opresult7066, "&&", 1, partcv, params);
// compiled op node returning opresult7067 (depth = 7)
  gc_frame_end(frame);
  return opresult7067;
}
Object meth_parser__apply7073(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_7074 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_7074 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7076 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7076 (depth = 7)
  gc_frame_end(frame);
  return opresult7076;
}
Object meth_parser__apply7122(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe7123 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7124 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7123);
// compiled call node returning call7124 (depth = 9)
  gc_frame_end(frame);
  return call7124;
}
Object meth_parser_vardec7027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(16, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_defaultVarVisibility = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for vardec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for vardec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_varTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "varTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_suggestions = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "suggestions");
  Object *var_nextTok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "nextTok");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7029 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7030 == NULL) {
    strlit7030 = alloc_String("var");
    gc_root(strlit7030);
  }
// compiled string node returning strlit7030 (depth = 4)
  gc_frame_newslot(strlit7030);
// call case 4: self request
  params[0] = strlit7030;
  partcv[0] = 1;
  Object call7031 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7029);
// compiled call node returning call7031 (depth = 3)
  Object if7028 = done;
  if (istrue(call7031)) {
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7032 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7033 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7032);
// compiled call node returning call7033 (depth = 5)
// compiled member node returning call7033 (depth = 4)
  *var_line = call7033;
  if (call7033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7034 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7035 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7034);
// compiled call node returning call7035 (depth = 5)
// compiled member node returning call7035 (depth = 4)
  *var_pos = call7035;
  if (call7035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7037 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7036);
// compiled call node returning call7037 (depth = 4)
// compiled member node returning call7037 (depth = 3)
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7040 == NULL) {
    strlit7040 = alloc_String("identifier");
    gc_root(strlit7040);
  }
// compiled string node returning strlit7040 (depth = 5)
  int op_slot_right_7039 = gc_frame_newslot(strlit7040);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7043 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7042);
// compiled call node returning call7043 (depth = 6)
// compiled member node returning call7043 (depth = 5)
  int op_slot_left_7039 = gc_frame_newslot(call7043);
  params[0] = strlit7040;
  partcv[0] = 1;
  Object opresult7044 = callmethod(call7043, "!=", 1, partcv, params);
// compiled op node returning opresult7044 (depth = 4)
  Object if7038 = done;
  if (istrue(opresult7044)) {
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7045 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7047 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7046);
// compiled call node returning call7047 (depth = 8)
// compiled member node returning call7047 (depth = 7)
  partcv[0] = 0;
  Object call7048 = callmethod(call7047, "new",
    1, partcv, params);
  gc_frame_end(callframe7045);
// compiled call node returning call7048 (depth = 6)
// compiled member node returning call7048 (depth = 5)
  *var_suggestion = call7048;
  if (call7048 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7049 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7050 = alloc_Block(NULL, NULL, "parser", 2189);
  gc_frame_newslot(block7050);
// method "_apply"
  block_savedest(block7050);
  Object closure7051 = createclosure(2, "_apply");
  setclosureframe(closure7051, stackframe);
  addtoclosure(closure7051, var_sym);
  addtoclosure(closure7051, selfslot);
  struct UserObject *uo7051 = (struct UserObject*)block7050;
  uo7051->data[0] = (Object)closure7051;
  Method *meth_meth_parser__apply7051 = addmethod2pos(block7050, "_apply", &meth_parser__apply7051, 0);
  int argcv_meth_parser__apply7051[] = {1};
  meth_meth_parser__apply7051->type = alloc_MethodType(1, argcv_meth_parser__apply7051);
  meth_meth_parser__apply7051->definitionModule = modulename;
  meth_meth_parser__apply7051->definitionLine = 2188;
// compiled block node returning block7050 (depth = 6)
  gc_frame_newslot(block7050);
// call case 4: self request
  params[0] = block7050;
  partcv[0] = 1;
  Object call7069 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7049);
// compiled call node returning call7069 (depth = 5)
  *var_nextToken = call7069;
  if (call7069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7071 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7072 = alloc_Block(NULL, NULL, "parser", 2191);
  gc_frame_newslot(block7072);
// method "_apply"
  block_savedest(block7072);
  Object closure7073 = createclosure(3, "_apply");
  setclosureframe(closure7073, stackframe);
  addtoclosure(closure7073, var_sym);
  addtoclosure(closure7073, var_nextToken);
  addtoclosure(closure7073, selfslot);
  struct UserObject *uo7073 = (struct UserObject*)block7072;
  uo7073->data[0] = (Object)closure7073;
  Method *meth_meth_parser__apply7073 = addmethod2pos(block7072, "_apply", &meth_parser__apply7073, 0);
  int argcv_meth_parser__apply7073[] = {0};
  meth_meth_parser__apply7073->type = alloc_MethodType(1, argcv_meth_parser__apply7073);
  meth_meth_parser__apply7073->definitionModule = modulename;
  meth_meth_parser__apply7073->definitionLine = 2189;
// compiled block node returning block7072 (depth = 6)
  gc_frame_newslot(block7072);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7079 = alloc_Boolean(0);
// compiled identifier node returning bool7079 (depth = 7)
  int op_slot_right_7078 = gc_frame_newslot(bool7079);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_7078 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7079;
  partcv[0] = 1;
  Object opresult7081 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7081 (depth = 6)
  params[0] = block7072;
  partcv[0] = 1;
  Object call7082 = callmethod(opresult7081, "orElse",
    1, partcv, params);
  gc_frame_end(callframe7071);
// compiled call node returning call7082 (depth = 5)
  Object if7070 = done;
  if (istrue(call7082)) {
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7083 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7084 == NULL) {
    strlit7084 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7084);
  }
// compiled string node returning strlit7084 (depth = 6)
  gc_frame_newslot(strlit7084);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7084;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7085 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7083);
// compiled call node returning call7085 (depth = 5)
    gc_frame_newslot(call7085);
    if7070 = call7085;
  } else {
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7086 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  partcv[0] = 0;
  Object call7088 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7087);
// compiled call node returning call7088 (depth = 7)
// compiled member node returning call7088 (depth = 6)
  gc_frame_newslot(call7088);
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool7089 = alloc_Boolean(0);
// compiled identifier node returning bool7089 (depth = 6)
  gc_frame_newslot(bool7089);
// starting to compile identifier node (depth = 6)
  Object bool7090 = alloc_Boolean(1);
// compiled identifier node returning bool7090 (depth = 6)
  gc_frame_newslot(bool7090);
// starting to compile string node (depth = 6)
  if (strlit7091 == NULL) {
    strlit7091 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7091);
  }
// compiled string node returning strlit7091 (depth = 6)
  gc_frame_newslot(strlit7091);
// call case 6: other member request
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7088;
  params[2] = bool7089;
  params[3] = bool7090;
  params[4] = strlit7091;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7092 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7086);
// compiled call node returning call7092 (depth = 5)
    gc_frame_newslot(call7092);
    if7070 = call7092;
  }
// compiled if node returning if7070 (depth = 4)
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7093 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7094 == NULL) {
    strlit7094 = alloc_String("a variable declaration must have a name after the 'var'.");
    gc_root(strlit7094);
  }
// compiled string node returning strlit7094 (depth = 5)
  gc_frame_newslot(strlit7094);
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7096 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7095);
// compiled call node returning call7096 (depth = 6)
// compiled member node returning call7096 (depth = 5)
  gc_frame_newslot(call7096);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7098 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7097);
// compiled call node returning call7098 (depth = 6)
// compiled member node returning call7098 (depth = 5)
  gc_frame_newslot(call7098);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7094;
  params[1] = call7096;
  params[2] = call7098;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7099 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7093);
// compiled call node returning call7099 (depth = 4)
    gc_frame_newslot(call7099);
    if7038 = call7099;
  } else {
  }
// compiled if node returning if7038 (depth = 3)
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7101 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7100);
// compiled call node returning call7101 (depth = 4)
// compiled member node returning call7101 (depth = 3)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7102 = alloc_Boolean(0);
// compiled identifier node returning bool7102 (depth = 4)
  *var_val = bool7102;
  if (bool7102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7104 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7103);
// compiled call node returning call7104 (depth = 5)
// compiled member node returning call7104 (depth = 4)
  *var_name = call7104;
  if (call7104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7106 = alloc_Boolean(1);
// compiled identifier node returning bool7106 (depth = 4)
  gc_frame_newslot(bool7106);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool7106;
  partcv[0] = 1;
  Object call7107 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7105);
// compiled call node returning call7107 (depth = 3)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7109 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7108);
// compiled call node returning call7109 (depth = 5)
// compiled member node returning call7109 (depth = 4)
  *var_dtype = call7109;
  if (call7109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7111 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7110);
// compiled call node returning call7111 (depth = 5)
// compiled member node returning call7111 (depth = 4)
  *var_anns = call7111;
  if (call7111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7113 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7114 == NULL) {
    strlit7114 = alloc_String("bind");
    gc_root(strlit7114);
  }
// compiled string node returning strlit7114 (depth = 5)
  gc_frame_newslot(strlit7114);
// call case 4: self request
  params[0] = strlit7114;
  partcv[0] = 1;
  Object call7115 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7113);
// compiled call node returning call7115 (depth = 4)
  Object if7112 = done;
  if (istrue(call7115)) {
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7117 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7116);
// compiled call node returning call7117 (depth = 5)
// compiled member node returning call7117 (depth = 4)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7119 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7120 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7121 = alloc_Block(NULL, NULL, "parser", 2208);
  gc_frame_newslot(block7121);
// method "_apply"
  block_savedest(block7121);
  Object closure7122 = createclosure(2, "_apply");
  setclosureframe(closure7122, stackframe);
  addtoclosure(closure7122, var_blocksOK);
  addtoclosure(closure7122, selfslot);
  struct UserObject *uo7122 = (struct UserObject*)block7121;
  uo7122->data[0] = (Object)closure7122;
  Method *meth_meth_parser__apply7122 = addmethod2pos(block7121, "_apply", &meth_parser__apply7122, 0);
  int argcv_meth_parser__apply7122[] = {0};
  meth_meth_parser__apply7122->type = alloc_MethodType(1, argcv_meth_parser__apply7122);
  meth_meth_parser__apply7122->definitionModule = modulename;
  meth_meth_parser__apply7122->definitionLine = 2208;
// compiled block node returning block7121 (depth = 8)
  gc_frame_newslot(block7121);
// call case 4: self request
  params[0] = block7121;
  partcv[0] = 1;
  Object call7126 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7120);
// compiled call node returning call7126 (depth = 7)
  partcv[0] = 0;
  Object call7127 = callmethod(call7126, "not",
    1, partcv, params);
  gc_frame_end(callframe7119);
// compiled call node returning call7127 (depth = 6)
// compiled member node returning call7127 (depth = 5)
  Object if7118 = done;
  if (istrue(call7127)) {
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7128 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7129 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7130 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7129);
// compiled call node returning call7130 (depth = 9)
// compiled member node returning call7130 (depth = 8)
  partcv[0] = 0;
  Object call7131 = callmethod(call7130, "empty",
    1, partcv, params);
  gc_frame_end(callframe7128);
// compiled call node returning call7131 (depth = 7)
// compiled member node returning call7131 (depth = 6)
  *var_suggestions = call7131;
  if (call7131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7132 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7133 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7134 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7133);
// compiled call node returning call7134 (depth = 9)
// compiled member node returning call7134 (depth = 8)
  partcv[0] = 0;
  Object call7135 = callmethod(call7134, "new",
    1, partcv, params);
  gc_frame_end(callframe7132);
// compiled call node returning call7135 (depth = 7)
// compiled member node returning call7135 (depth = 6)
  *var_suggestion = call7135;
  if (call7135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7136 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array7137 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7137 (depth = 7)
  gc_frame_newslot(array7137);
// call case 4: self request
  params[0] = array7137;
  partcv[0] = 1;
  Object call7138 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7136);
// compiled call node returning call7138 (depth = 6)
  *var_nextTok = call7138;
  if (call7138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7140 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_7140 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7142 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7142 (depth = 6)
  Object if7139 = done;
  if (istrue(opresult7142)) {
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7143 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7144 == NULL) {
    strlit7144 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7144);
  }
// compiled string node returning strlit7144 (depth = 7)
  gc_frame_newslot(strlit7144);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7144;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7145 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7143);
// compiled call node returning call7145 (depth = 6)
    gc_frame_newslot(call7145);
    if7139 = call7145;
  } else {
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7146 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7147 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call7148 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7147);
// compiled call node returning call7148 (depth = 8)
// compiled member node returning call7148 (depth = 7)
  gc_frame_newslot(call7148);
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool7149 = alloc_Boolean(1);
// compiled identifier node returning bool7149 (depth = 7)
  gc_frame_newslot(bool7149);
// starting to compile identifier node (depth = 7)
  Object bool7150 = alloc_Boolean(0);
// compiled identifier node returning bool7150 (depth = 7)
  gc_frame_newslot(bool7150);
// starting to compile string node (depth = 7)
  if (strlit7151 == NULL) {
    strlit7151 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7151);
  }
// compiled string node returning strlit7151 (depth = 7)
  gc_frame_newslot(strlit7151);
// call case 6: other member request
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7148;
  params[2] = bool7149;
  params[3] = bool7150;
  params[4] = strlit7151;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7152 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7146);
// compiled call node returning call7152 (depth = 6)
    gc_frame_newslot(call7152);
    if7139 = call7152;
  }
// compiled if node returning if7139 (depth = 5)
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7153 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7154 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7153);
// compiled call node returning call7154 (depth = 5)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7155 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7157 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7156);
// compiled call node returning call7157 (depth = 9)
// compiled member node returning call7157 (depth = 8)
  partcv[0] = 0;
  Object call7158 = callmethod(call7157, "new",
    1, partcv, params);
  gc_frame_end(callframe7155);
// compiled call node returning call7158 (depth = 7)
// compiled member node returning call7158 (depth = 6)
  *var_suggestion = call7158;
  if (call7158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7160 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7162 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7161);
// compiled call node returning call7162 (depth = 7)
// compiled member node returning call7162 (depth = 6)
  gc_frame_newslot(call7162);
// starting to compile identifier node (depth = 6)
  Object bool7163 = alloc_Boolean(1);
// compiled identifier node returning bool7163 (depth = 6)
  gc_frame_newslot(bool7163);
// starting to compile identifier node (depth = 6)
  Object bool7164 = alloc_Boolean(0);
// compiled identifier node returning bool7164 (depth = 6)
  gc_frame_newslot(bool7164);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call7162;
  params[2] = bool7163;
  params[3] = bool7164;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7165 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7160);
// compiled call node returning call7165 (depth = 5)
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7166 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7167 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7166);
// compiled call node returning call7167 (depth = 5)
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7168 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7170 == NULL) {
    strlit7170 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit7170);
  }
// compiled string node returning strlit7170 (depth = 7)
  int op_slot_right_7169 = gc_frame_newslot(strlit7170);
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7172 == NULL) {
    strlit7172 = alloc_String("a variable declaration must have a value after the ':='. ");
    gc_root(strlit7172);
  }
// compiled string node returning strlit7172 (depth = 7)
  int op_slot_left_7169 = gc_frame_newslot(strlit7172);
  params[0] = strlit7170;
  partcv[0] = 1;
  Object opresult7173 = callmethod(strlit7172, "++", 1, partcv, params);
// compiled op node returning opresult7173 (depth = 6)
  gc_frame_newslot(opresult7173);
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7175 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7174);
// compiled call node returning call7175 (depth = 7)
// compiled member node returning call7175 (depth = 6)
  gc_frame_newslot(call7175);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7178 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7177);
// compiled call node returning call7178 (depth = 8)
// compiled member node returning call7178 (depth = 7)
  int op_slot_right_7176 = gc_frame_newslot(call7178);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7181 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7180);
// compiled call node returning call7181 (depth = 8)
// compiled member node returning call7181 (depth = 7)
  int op_slot_left_7176 = gc_frame_newslot(call7181);
  params[0] = call7178;
  partcv[0] = 1;
  Object sum7182 = callmethod(call7181, "+", 1, partcv, params);
// compiled op node returning sum7182 (depth = 6)
  gc_frame_newslot(sum7182);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7173;
  params[1] = call7175;
  params[2] = sum7182;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7183 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7168);
// compiled call node returning call7183 (depth = 5)
    gc_frame_newslot(call7183);
    if7118 = call7183;
  } else {
  }
// compiled if node returning if7118 (depth = 4)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7185 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7184);
// compiled call node returning call7185 (depth = 6)
// compiled member node returning call7185 (depth = 5)
  *var_val = call7185;
  if (call7185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7112 = done;
  } else {
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7190 == NULL) {
    strlit7190 = alloc_String("=");
    gc_root(strlit7190);
  }
// compiled string node returning strlit7190 (depth = 7)
  int op_slot_right_7189 = gc_frame_newslot(strlit7190);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7193 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7192);
// compiled call node returning call7193 (depth = 8)
// compiled member node returning call7193 (depth = 7)
  int op_slot_left_7189 = gc_frame_newslot(call7193);
  params[0] = strlit7190;
  partcv[0] = 1;
  Object opresult7194 = callmethod(call7193, "==", 1, partcv, params);
// compiled op node returning opresult7194 (depth = 6)
  int op_slot_right_7188 = gc_frame_newslot(opresult7194);
// starting to compile call node (depth = 6)
  int callframe7196 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7197 == NULL) {
    strlit7197 = alloc_String("op");
    gc_root(strlit7197);
  }
// compiled string node returning strlit7197 (depth = 7)
  gc_frame_newslot(strlit7197);
// call case 4: self request
  params[0] = strlit7197;
  partcv[0] = 1;
  Object call7198 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7196);
// compiled call node returning call7198 (depth = 6)
  int op_slot_left_7188 = gc_frame_newslot(call7198);
  params[0] = opresult7194;
  partcv[0] = 1;
  Object opresult7199 = callmethod(call7198, "&&", 1, partcv, params);
// compiled op node returning opresult7199 (depth = 5)
  Object if7187 = done;
  if (istrue(opresult7199)) {
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7200 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7201 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7202 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7201);
// compiled call node returning call7202 (depth = 9)
// compiled member node returning call7202 (depth = 8)
  partcv[0] = 0;
  Object call7203 = callmethod(call7202, "empty",
    1, partcv, params);
  gc_frame_end(callframe7200);
// compiled call node returning call7203 (depth = 7)
// compiled member node returning call7203 (depth = 6)
  *var_suggestions = call7203;
  if (call7203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7204 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7206 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7205);
// compiled call node returning call7206 (depth = 9)
// compiled member node returning call7206 (depth = 8)
  partcv[0] = 0;
  Object call7207 = callmethod(call7206, "new",
    1, partcv, params);
  gc_frame_end(callframe7204);
// compiled call node returning call7207 (depth = 7)
// compiled member node returning call7207 (depth = 6)
  *var_suggestion = call7207;
  if (call7207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7208 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit7209 == NULL) {
    strlit7209 = alloc_String(":=");
    gc_root(strlit7209);
  }
// compiled string node returning strlit7209 (depth = 6)
  gc_frame_newslot(strlit7209);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit7209;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7210 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7208);
// compiled call node returning call7210 (depth = 5)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7211 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7212 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7211);
// compiled call node returning call7212 (depth = 5)
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7213 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7214 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7215 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7214);
// compiled call node returning call7215 (depth = 9)
// compiled member node returning call7215 (depth = 8)
  partcv[0] = 0;
  Object call7216 = callmethod(call7215, "new",
    1, partcv, params);
  gc_frame_end(callframe7213);
// compiled call node returning call7216 (depth = 7)
// compiled member node returning call7216 (depth = 6)
  *var_suggestion = call7216;
  if (call7216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7218 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit7219 == NULL) {
    strlit7219 = alloc_String("def");
    gc_root(strlit7219);
  }
// compiled string node returning strlit7219 (depth = 6)
  gc_frame_newslot(strlit7219);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit7219;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7220 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7218);
// compiled call node returning call7220 (depth = 5)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7221 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7222 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7221);
// compiled call node returning call7222 (depth = 5)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7223 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7224 == NULL) {
    strlit7224 = alloc_String("a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit7224);
  }
// compiled string node returning strlit7224 (depth = 6)
  gc_frame_newslot(strlit7224);
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7226 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7225);
// compiled call node returning call7226 (depth = 7)
// compiled member node returning call7226 (depth = 6)
  gc_frame_newslot(call7226);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7228 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7227);
// compiled call node returning call7228 (depth = 7)
// compiled member node returning call7228 (depth = 6)
  gc_frame_newslot(call7228);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7230 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7229);
// compiled call node returning call7230 (depth = 7)
// compiled member node returning call7230 (depth = 6)
  gc_frame_newslot(call7230);
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7224;
  params[1] = call7226;
  params[2] = call7228;
  params[3] = call7230;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7231 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7223);
// compiled call node returning call7231 (depth = 5)
    gc_frame_newslot(call7231);
    if7187 = call7231;
  } else {
  }
// compiled if node returning if7187 (depth = 4)
    gc_frame_newslot(if7187);
    if7112 = if7187;
  }
// compiled if node returning if7112 (depth = 3)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7232 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call7233 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7232);
// compiled call node returning call7233 (depth = 3)
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7234 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7236 = callmethod(*var_ast, "varDecNode",
    1, partcv, params);
  gc_frame_end(callframe7235);
// compiled call node returning call7236 (depth = 6)
// compiled member node returning call7236 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7237 = callmethod(call7236, "new",
    1, partcv, params);
  gc_frame_end(callframe7234);
// compiled call node returning call7237 (depth = 4)
  *var_o = call7237;
  if (call7237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7240 = alloc_Boolean(0);
// compiled identifier node returning bool7240 (depth = 5)
  int op_slot_right_7239 = gc_frame_newslot(bool7240);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_7239 = gc_frame_newslot(*var_anns);
  params[0] = bool7240;
  partcv[0] = 1;
  Object opresult7242 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult7242 (depth = 4)
  Object if7238 = done;
  if (istrue(opresult7242)) {
// starting to compile call node (depth = 4)
  int callframe7243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7245 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7244);
// compiled call node returning call7245 (depth = 6)
// compiled member node returning call7245 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7246 = callmethod(call7245, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7243);
// compiled call node returning call7246 (depth = 4)
    gc_frame_newslot(call7246);
    if7238 = call7246;
  } else {
  }
// compiled if node returning if7238 (depth = 3)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7247 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultVarVisibility (depth = 4)
  gc_frame_newslot(*var_defaultVarVisibility);
// starting to compile string node (depth = 4)
  if (strlit7248 == NULL) {
    strlit7248 = alloc_String("confidential");
    gc_root(strlit7248);
  }
// compiled string node returning strlit7248 (depth = 4)
  gc_frame_newslot(strlit7248);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultVarVisibility;
  params[2] = strlit7248;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7249 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7247);
// compiled call node returning call7249 (depth = 3)
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7250 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7251 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7250);
// compiled call node returning call7251 (depth = 3)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7253 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7252);
// compiled call node returning call7253 (depth = 4)
// compiled member node returning call7253 (depth = 3)
    gc_frame_newslot(call7253);
    if7028 = call7253;
  } else {
  }
// compiled if node returning if7028 (depth = 2)
  gc_frame_end(frame);
  return if7028;
}
Object meth_parser__apply7264(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7265 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7266 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7265);
// compiled call node returning call7266 (depth = 5)
  gc_frame_end(frame);
  return call7266;
}
Object meth_parser__apply7272(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7273 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7274 == NULL) {
    strlit7274 = alloc_String("comma");
    gc_root(strlit7274);
  }
// compiled string node returning strlit7274 (depth = 8)
  gc_frame_newslot(strlit7274);
// call case 4: self request
  params[0] = strlit7274;
  partcv[0] = 1;
  Object call7275 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7273);
// compiled call node returning call7275 (depth = 7)
  gc_frame_end(frame);
  return call7275;
}
Object meth_parser__apply7290(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe7291 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7292 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7291);
// compiled call node returning call7292 (depth = 12)
  gc_frame_end(frame);
  return call7292;
}
Object meth_parser__apply7278(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7280 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7279);
// compiled call node returning call7280 (depth = 9)
// compiled member node returning call7280 (depth = 8)
  *var_tmp = call7280;
  if (call7280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7282 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7283 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7282);
// compiled call node returning call7283 (depth = 7)
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7284 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7285 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7284);
// compiled call node returning call7285 (depth = 8)
// compiled member node returning call7285 (depth = 7)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7287 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe7288 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block7289 = alloc_Block(NULL, NULL, "parser", 2261);
  gc_frame_newslot(block7289);
// method "_apply"
  block_savedest(block7289);
  Object closure7290 = createclosure(2, "_apply");
  setclosureframe(closure7290, stackframe);
  addtoclosure(closure7290, var_blocksOK);
  addtoclosure(closure7290, selfslot);
  struct UserObject *uo7290 = (struct UserObject*)block7289;
  uo7290->data[0] = (Object)closure7290;
  Method *meth_meth_parser__apply7290 = addmethod2pos(block7289, "_apply", &meth_parser__apply7290, 0);
  int argcv_meth_parser__apply7290[] = {0};
  meth_meth_parser__apply7290->type = alloc_MethodType(1, argcv_meth_parser__apply7290);
  meth_meth_parser__apply7290->definitionModule = modulename;
  meth_meth_parser__apply7290->definitionLine = 2261;
// compiled block node returning block7289 (depth = 11)
  gc_frame_newslot(block7289);
// call case 4: self request
  params[0] = block7289;
  partcv[0] = 1;
  Object call7294 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7288);
// compiled call node returning call7294 (depth = 10)
  partcv[0] = 0;
  Object call7295 = callmethod(call7294, "not",
    1, partcv, params);
  gc_frame_end(callframe7287);
// compiled call node returning call7295 (depth = 9)
// compiled member node returning call7295 (depth = 8)
  Object if7286 = done;
  if (istrue(call7295)) {
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7296 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7297 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7298 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7297);
// compiled call node returning call7298 (depth = 12)
// compiled member node returning call7298 (depth = 11)
  partcv[0] = 0;
  Object call7299 = callmethod(call7298, "empty",
    1, partcv, params);
  gc_frame_end(callframe7296);
// compiled call node returning call7299 (depth = 10)
// compiled member node returning call7299 (depth = 9)
  *var_suggestions = call7299;
  if (call7299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7300 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7301 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7302 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7301);
// compiled call node returning call7302 (depth = 12)
// compiled member node returning call7302 (depth = 11)
  partcv[0] = 0;
  Object call7303 = callmethod(call7302, "new",
    1, partcv, params);
  gc_frame_end(callframe7300);
// compiled call node returning call7303 (depth = 10)
// compiled member node returning call7303 (depth = 9)
  *var_suggestion = call7303;
  if (call7303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7304 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array7305 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit7306 == NULL) {
    strlit7306 = alloc_String("rsquare");
    gc_root(strlit7306);
  }
// compiled string node returning strlit7306 (depth = 11)
  params[0] = strlit7306;
  partcv[0] = 1;
  callmethod(array7305, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array7305 (depth = 10)
  gc_frame_newslot(array7305);
// call case 4: self request
  params[0] = array7305;
  partcv[0] = 1;
  Object call7307 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7304);
// compiled call node returning call7307 (depth = 9)
  *var_nextTok = call7307;
  if (call7307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7309 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7309 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7311 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7311 (depth = 9)
  Object if7308 = done;
  if (istrue(opresult7311)) {
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7312 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7313 == NULL) {
    strlit7313 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7313);
  }
// compiled string node returning strlit7313 (depth = 10)
  gc_frame_newslot(strlit7313);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7313;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7314 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7312);
// compiled call node returning call7314 (depth = 9)
    gc_frame_newslot(call7314);
    if7308 = call7314;
  } else {
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7315 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call7317 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7316);
// compiled call node returning call7317 (depth = 11)
// compiled member node returning call7317 (depth = 10)
  gc_frame_newslot(call7317);
// starting to compile identifier node (depth = 10)
  Object bool7318 = alloc_Boolean(1);
// compiled identifier node returning bool7318 (depth = 10)
  gc_frame_newslot(bool7318);
// starting to compile identifier node (depth = 10)
  Object bool7319 = alloc_Boolean(0);
// compiled identifier node returning bool7319 (depth = 10)
  gc_frame_newslot(bool7319);
// starting to compile string node (depth = 10)
  if (strlit7320 == NULL) {
    strlit7320 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7320);
  }
// compiled string node returning strlit7320 (depth = 10)
  gc_frame_newslot(strlit7320);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7317;
  params[2] = bool7318;
  params[3] = bool7319;
  params[4] = strlit7320;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7321 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7315);
// compiled call node returning call7321 (depth = 9)
    gc_frame_newslot(call7321);
    if7308 = call7321;
  }
// compiled if node returning if7308 (depth = 8)
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7322 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7323 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7322);
// compiled call node returning call7323 (depth = 8)
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7324 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7326 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7325);
// compiled call node returning call7326 (depth = 12)
// compiled member node returning call7326 (depth = 11)
  partcv[0] = 0;
  Object call7327 = callmethod(call7326, "new",
    1, partcv, params);
  gc_frame_end(callframe7324);
// compiled call node returning call7327 (depth = 10)
// compiled member node returning call7327 (depth = 9)
  *var_suggestion = call7327;
  if (call7327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7329 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7330 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7331 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7330);
// compiled call node returning call7331 (depth = 10)
// compiled member node returning call7331 (depth = 9)
  gc_frame_newslot(call7331);
// starting to compile identifier node (depth = 9)
  Object bool7332 = alloc_Boolean(1);
// compiled identifier node returning bool7332 (depth = 9)
  gc_frame_newslot(bool7332);
// starting to compile identifier node (depth = 9)
  Object bool7333 = alloc_Boolean(0);
// compiled identifier node returning bool7333 (depth = 9)
  gc_frame_newslot(bool7333);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7331;
  params[2] = bool7332;
  params[3] = bool7333;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7334 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7329);
// compiled call node returning call7334 (depth = 8)
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7335 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7336 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7335);
// compiled call node returning call7336 (depth = 8)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7337 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7338 == NULL) {
    strlit7338 = alloc_String("a list must contain zero or more valid expressions separated by commas.");
    gc_root(strlit7338);
  }
// compiled string node returning strlit7338 (depth = 9)
  gc_frame_newslot(strlit7338);
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7339 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7340 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7339);
// compiled call node returning call7340 (depth = 10)
// compiled member node returning call7340 (depth = 9)
  gc_frame_newslot(call7340);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7342 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7341);
// compiled call node returning call7342 (depth = 10)
// compiled member node returning call7342 (depth = 9)
  gc_frame_newslot(call7342);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7338;
  params[1] = call7340;
  params[2] = call7342;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7343 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7337);
// compiled call node returning call7343 (depth = 8)
    gc_frame_newslot(call7343);
    if7286 = call7343;
  } else {
  }
// compiled if node returning if7286 (depth = 7)
  gc_frame_end(frame);
  return if7286;
}
Object meth_parser__apply7269(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7270 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7271 = alloc_Block(NULL, NULL, "parser", 2257);
  gc_frame_newslot(block7271);
// method "_apply"
  block_savedest(block7271);
  Object closure7272 = createclosure(1, "_apply");
  setclosureframe(closure7272, stackframe);
  addtoclosure(closure7272, selfslot);
  struct UserObject *uo7272 = (struct UserObject*)block7271;
  uo7272->data[0] = (Object)closure7272;
  Method *meth_meth_parser__apply7272 = addmethod2pos(block7271, "_apply", &meth_parser__apply7272, 0);
  int argcv_meth_parser__apply7272[] = {0};
  meth_meth_parser__apply7272->type = alloc_MethodType(1, argcv_meth_parser__apply7272);
  meth_meth_parser__apply7272->definitionModule = modulename;
  meth_meth_parser__apply7272->definitionLine = 2253;
// compiled block node returning block7271 (depth = 6)
  gc_frame_newslot(block7271);
// starting to compile block node (depth = 6)
  Object block7277 = alloc_Block(NULL, NULL, "parser", 2257);
  gc_frame_newslot(block7277);
// method "_apply"
  block_savedest(block7277);
  Object closure7278 = createclosure(8, "_apply");
  setclosureframe(closure7278, stackframe);
  addtoclosure(closure7278, var_values);
  addtoclosure(closure7278, var_tmp);
  addtoclosure(closure7278, var_params);
  addtoclosure(closure7278, var_blocksOK);
  addtoclosure(closure7278, var_errormessages);
  addtoclosure(closure7278, var_sym);
  addtoclosure(closure7278, var_lastToken);
  addtoclosure(closure7278, selfslot);
  struct UserObject *uo7278 = (struct UserObject*)block7277;
  uo7278->data[0] = (Object)closure7278;
  Method *meth_meth_parser__apply7278 = addmethod2pos(block7277, "_apply", &meth_parser__apply7278, 0);
  int argcv_meth_parser__apply7278[] = {0};
  meth_meth_parser__apply7278->type = alloc_MethodType(1, argcv_meth_parser__apply7278);
  meth_meth_parser__apply7278->definitionModule = modulename;
  meth_meth_parser__apply7278->definitionLine = 2253;
// compiled block node returning block7277 (depth = 6)
  gc_frame_newslot(block7277);
// call case 5: prelude request
  params[0] = block7271;
  params[1] = block7277;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7345 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7270);
// compiled call node returning call7345 (depth = 5)
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7347 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7346);
// compiled call node returning call7347 (depth = 7)
// compiled member node returning call7347 (depth = 6)
  *var_tmp = call7347;
  if (call7347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7349 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7350 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7349);
// compiled call node returning call7350 (depth = 5)
  gc_frame_end(frame);
  return call7350;
}
Object meth_parser_doarray7254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doarray (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doarray");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7256 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7257 == NULL) {
    strlit7257 = alloc_String("lsquare");
    gc_root(strlit7257);
  }
// compiled string node returning strlit7257 (depth = 4)
  gc_frame_newslot(strlit7257);
// call case 4: self request
  params[0] = strlit7257;
  partcv[0] = 1;
  Object call7258 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7256);
// compiled call node returning call7258 (depth = 3)
  Object if7255 = done;
  if (istrue(call7258)) {
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7259 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7260 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7259);
// compiled call node returning call7260 (depth = 4)
// compiled member node returning call7260 (depth = 3)
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7261 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7261 (depth = 4)
  *var_params = array7261;
  if (array7261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7262 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7263 = alloc_Block(NULL, NULL, "parser", 2256);
  gc_frame_newslot(block7263);
// method "_apply"
  block_savedest(block7263);
  Object closure7264 = createclosure(2, "_apply");
  setclosureframe(closure7264, stackframe);
  addtoclosure(closure7264, var_blocksOK);
  addtoclosure(closure7264, selfslot);
  struct UserObject *uo7264 = (struct UserObject*)block7263;
  uo7264->data[0] = (Object)closure7264;
  Method *meth_meth_parser__apply7264 = addmethod2pos(block7263, "_apply", &meth_parser__apply7264, 0);
  int argcv_meth_parser__apply7264[] = {0};
  meth_meth_parser__apply7264->type = alloc_MethodType(1, argcv_meth_parser__apply7264);
  meth_meth_parser__apply7264->definitionModule = modulename;
  meth_meth_parser__apply7264->definitionLine = 2253;
// compiled block node returning block7263 (depth = 4)
  gc_frame_newslot(block7263);
// starting to compile block node (depth = 4)
  Object block7268 = alloc_Block(NULL, NULL, "parser", 2256);
  gc_frame_newslot(block7268);
// method "_apply"
  block_savedest(block7268);
  Object closure7269 = createclosure(8, "_apply");
  setclosureframe(closure7269, stackframe);
  addtoclosure(closure7269, var_values);
  addtoclosure(closure7269, var_tmp);
  addtoclosure(closure7269, var_params);
  addtoclosure(closure7269, var_blocksOK);
  addtoclosure(closure7269, var_errormessages);
  addtoclosure(closure7269, var_sym);
  addtoclosure(closure7269, var_lastToken);
  addtoclosure(closure7269, selfslot);
  struct UserObject *uo7269 = (struct UserObject*)block7268;
  uo7269->data[0] = (Object)closure7269;
  Method *meth_meth_parser__apply7269 = addmethod2pos(block7268, "_apply", &meth_parser__apply7269, 0);
  int argcv_meth_parser__apply7269[] = {0};
  meth_meth_parser__apply7269->type = alloc_MethodType(1, argcv_meth_parser__apply7269);
  meth_meth_parser__apply7269->definitionModule = modulename;
  meth_meth_parser__apply7269->definitionLine = 2253;
// compiled block node returning block7268 (depth = 4)
  gc_frame_newslot(block7268);
// call case 4: self request
  params[0] = block7263;
  params[1] = block7268;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7352 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7262);
// compiled call node returning call7352 (depth = 3)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7355 == NULL) {
    strlit7355 = alloc_String("rsquare");
    gc_root(strlit7355);
  }
// compiled string node returning strlit7355 (depth = 5)
  int op_slot_right_7354 = gc_frame_newslot(strlit7355);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7358 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7357);
// compiled call node returning call7358 (depth = 6)
// compiled member node returning call7358 (depth = 5)
  int op_slot_left_7354 = gc_frame_newslot(call7358);
  params[0] = strlit7355;
  partcv[0] = 1;
  Object opresult7359 = callmethod(call7358, "!=", 1, partcv, params);
// compiled op node returning opresult7359 (depth = 4)
  Object if7353 = done;
  if (istrue(opresult7359)) {
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7360 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7361 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7362 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7361);
// compiled call node returning call7362 (depth = 8)
// compiled member node returning call7362 (depth = 7)
  partcv[0] = 0;
  Object call7363 = callmethod(call7362, "new",
    1, partcv, params);
  gc_frame_end(callframe7360);
// compiled call node returning call7363 (depth = 6)
// compiled member node returning call7363 (depth = 5)
  *var_suggestion = call7363;
  if (call7363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7364 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7365 == NULL) {
    strlit7365 = alloc_String("]");
    gc_root(strlit7365);
  }
// compiled string node returning strlit7365 (depth = 5)
  gc_frame_newslot(strlit7365);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7365;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7366 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7364);
// compiled call node returning call7366 (depth = 4)
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7367 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7368 == NULL) {
    strlit7368 = alloc_String("a list beginning with a '[' must end with a ']'.");
    gc_root(strlit7368);
  }
// compiled string node returning strlit7368 (depth = 5)
  gc_frame_newslot(strlit7368);
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7370 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7369);
// compiled call node returning call7370 (depth = 6)
// compiled member node returning call7370 (depth = 5)
  gc_frame_newslot(call7370);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7372 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7373 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7372);
// compiled call node returning call7373 (depth = 7)
// compiled member node returning call7373 (depth = 6)
  int op_slot_right_7371 = gc_frame_newslot(call7373);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7376 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7375);
// compiled call node returning call7376 (depth = 7)
// compiled member node returning call7376 (depth = 6)
  int op_slot_left_7371 = gc_frame_newslot(call7376);
  params[0] = call7373;
  partcv[0] = 1;
  Object sum7377 = callmethod(call7376, "+", 1, partcv, params);
// compiled op node returning sum7377 (depth = 5)
  gc_frame_newslot(sum7377);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7368;
  params[1] = call7370;
  params[2] = sum7377;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7378 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7367);
// compiled call node returning call7378 (depth = 4)
    gc_frame_newslot(call7378);
    if7353 = call7378;
  } else {
  }
// compiled if node returning if7353 (depth = 3)
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7379 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7381 = callmethod(*var_ast, "arrayNode",
    1, partcv, params);
  gc_frame_end(callframe7380);
// compiled call node returning call7381 (depth = 6)
// compiled member node returning call7381 (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call7382 = callmethod(call7381, "new",
    1, partcv, params);
  gc_frame_end(callframe7379);
// compiled call node returning call7382 (depth = 4)
  *var_o = call7382;
  if (call7382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7383 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7384 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7383);
// compiled call node returning call7384 (depth = 3)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7386 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7385);
// compiled call node returning call7386 (depth = 4)
// compiled member node returning call7386 (depth = 3)
    gc_frame_newslot(call7386);
    if7255 = call7386;
  } else {
  }
// compiled if node returning if7255 (depth = 2)
  gc_frame_end(frame);
  return if7255;
}
Object meth_parser_dodialect7387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dodialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dodialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7389 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7390 == NULL) {
    strlit7390 = alloc_String("dialect");
    gc_root(strlit7390);
  }
// compiled string node returning strlit7390 (depth = 4)
  gc_frame_newslot(strlit7390);
// call case 4: self request
  params[0] = strlit7390;
  partcv[0] = 1;
  Object call7391 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7389);
// compiled call node returning call7391 (depth = 3)
  Object if7388 = done;
  if (istrue(call7391)) {
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7392 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7393 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7392);
// compiled call node returning call7393 (depth = 4)
// compiled member node returning call7393 (depth = 3)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7396 == NULL) {
    strlit7396 = alloc_String("string");
    gc_root(strlit7396);
  }
// compiled string node returning strlit7396 (depth = 5)
  int op_slot_right_7395 = gc_frame_newslot(strlit7396);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7399 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7398);
// compiled call node returning call7399 (depth = 6)
// compiled member node returning call7399 (depth = 5)
  int op_slot_left_7395 = gc_frame_newslot(call7399);
  params[0] = strlit7396;
  partcv[0] = 1;
  Object opresult7400 = callmethod(call7399, "!=", 1, partcv, params);
// compiled op node returning opresult7400 (depth = 4)
  Object if7394 = done;
  if (istrue(opresult7400)) {
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7401 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7403 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7402);
// compiled call node returning call7403 (depth = 8)
// compiled member node returning call7403 (depth = 7)
  partcv[0] = 0;
  Object call7404 = callmethod(call7403, "new",
    1, partcv, params);
  gc_frame_end(callframe7401);
// compiled call node returning call7404 (depth = 6)
// compiled member node returning call7404 (depth = 5)
  *var_suggestion = call7404;
  if (call7404 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7409 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7408);
// compiled call node returning call7409 (depth = 8)
// compiled member node returning call7409 (depth = 7)
  int op_slot_right_7407 = gc_frame_newslot(call7409);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7412 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7411);
// compiled call node returning call7412 (depth = 8)
// compiled member node returning call7412 (depth = 7)
  int op_slot_left_7407 = gc_frame_newslot(call7412);
  params[0] = call7409;
  partcv[0] = 1;
  Object opresult7413 = callmethod(call7412, "==", 1, partcv, params);
// compiled op node returning opresult7413 (depth = 6)
  int op_slot_right_7406 = gc_frame_newslot(opresult7413);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7416 == NULL) {
    strlit7416 = alloc_String("identifier");
    gc_root(strlit7416);
  }
// compiled string node returning strlit7416 (depth = 7)
  int op_slot_right_7415 = gc_frame_newslot(strlit7416);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7419 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7418);
// compiled call node returning call7419 (depth = 8)
// compiled member node returning call7419 (depth = 7)
  int op_slot_left_7415 = gc_frame_newslot(call7419);
  params[0] = strlit7416;
  partcv[0] = 1;
  Object opresult7420 = callmethod(call7419, "==", 1, partcv, params);
// compiled op node returning opresult7420 (depth = 6)
  int op_slot_left_7406 = gc_frame_newslot(opresult7420);
  params[0] = opresult7413;
  partcv[0] = 1;
  Object opresult7421 = callmethod(opresult7420, "&&", 1, partcv, params);
// compiled op node returning opresult7421 (depth = 5)
  Object if7405 = done;
  if (istrue(opresult7421)) {
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7422 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7424 == NULL) {
    strlit7424 = alloc_String("""\x22""");
    gc_root(strlit7424);
  }
// compiled string node returning strlit7424 (depth = 7)
  int op_slot_right_7423 = gc_frame_newslot(strlit7424);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7427 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7428 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7427);
// compiled call node returning call7428 (depth = 9)
// compiled member node returning call7428 (depth = 8)
  int op_slot_right_7426 = gc_frame_newslot(call7428);
// starting to compile string node (depth = 8)
  if (strlit7430 == NULL) {
    strlit7430 = alloc_String("""\x22""");
    gc_root(strlit7430);
  }
// compiled string node returning strlit7430 (depth = 8)
  int op_slot_left_7426 = gc_frame_newslot(strlit7430);
  params[0] = call7428;
  partcv[0] = 1;
  Object opresult7431 = callmethod(strlit7430, "++", 1, partcv, params);
// compiled op node returning opresult7431 (depth = 7)
  int op_slot_left_7423 = gc_frame_newslot(opresult7431);
  params[0] = strlit7424;
  partcv[0] = 1;
  Object opresult7432 = callmethod(opresult7431, "++", 1, partcv, params);
// compiled op node returning opresult7432 (depth = 6)
  gc_frame_newslot(opresult7432);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7432;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7433 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7422);
// compiled call node returning call7433 (depth = 5)
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7435 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7434);
// compiled call node returning call7435 (depth = 7)
// compiled member node returning call7435 (depth = 6)
  *var_errorPos = call7435;
  if (call7435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7405 = done;
  } else {
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7437 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7438 == NULL) {
    strlit7438 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7438);
  }
// compiled string node returning strlit7438 (depth = 6)
  gc_frame_newslot(strlit7438);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7438;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7439 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7437);
// compiled call node returning call7439 (depth = 5)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7441 = alloc_Float64(1);
// compiled num node returning num7441 (depth = 7)
  int op_slot_right_7440 = gc_frame_newslot(num7441);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7445 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7444);
// compiled call node returning call7445 (depth = 9)
// compiled member node returning call7445 (depth = 8)
  int op_slot_right_7443 = gc_frame_newslot(call7445);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7448 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7447);
// compiled call node returning call7448 (depth = 9)
// compiled member node returning call7448 (depth = 8)
  int op_slot_left_7443 = gc_frame_newslot(call7448);
  params[0] = call7445;
  partcv[0] = 1;
  Object sum7449 = callmethod(call7448, "+", 1, partcv, params);
// compiled op node returning sum7449 (depth = 7)
  int op_slot_left_7440 = gc_frame_newslot(sum7449);
  params[0] = num7441;
  partcv[0] = 1;
  Object sum7450 = callmethod(sum7449, "+", 1, partcv, params);
// compiled op node returning sum7450 (depth = 6)
  *var_errorPos = sum7450;
  if (sum7450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7405 = done;
  }
// compiled if node returning if7405 (depth = 4)
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7452 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7453 == NULL) {
    strlit7453 = alloc_String("a dialect statement must have the name of the dialect in quotes after the 'dialect'.");
    gc_root(strlit7453);
  }
// compiled string node returning strlit7453 (depth = 5)
  gc_frame_newslot(strlit7453);
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7454 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7455 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7454);
// compiled call node returning call7455 (depth = 6)
// compiled member node returning call7455 (depth = 5)
  gc_frame_newslot(call7455);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7453;
  params[1] = call7455;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7456 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7452);
// compiled call node returning call7456 (depth = 4)
    gc_frame_newslot(call7456);
    if7394 = call7456;
  } else {
  }
// compiled if node returning if7394 (depth = 3)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7457 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7458 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7460 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7459);
// compiled call node returning call7460 (depth = 6)
// compiled member node returning call7460 (depth = 5)
  gc_frame_newslot(call7460);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7462 = callmethod(*var_ast, "dialectNode",
    1, partcv, params);
  gc_frame_end(callframe7461);
// compiled call node returning call7462 (depth = 6)
// compiled member node returning call7462 (depth = 5)
  params[0] = call7460;
  partcv[0] = 1;
  Object call7463 = callmethod(call7462, "new",
    1, partcv, params);
  gc_frame_end(callframe7458);
// compiled call node returning call7463 (depth = 4)
  gc_frame_newslot(call7463);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call7463;
  partcv[0] = 1;
  Object call7464 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7457);
// compiled call node returning call7464 (depth = 3)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7466 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7465);
// compiled call node returning call7466 (depth = 4)
// compiled member node returning call7466 (depth = 3)
    gc_frame_newslot(call7466);
    if7388 = call7466;
  } else {
  }
// compiled if node returning if7388 (depth = 2)
  gc_frame_end(frame);
  return if7388;
}
Object meth_parser__apply7507(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe7508 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_noBlocks (depth = 9)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call7509 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7508);
// compiled call node returning call7509 (depth = 8)
  gc_frame_end(frame);
  return call7509;
}
Object meth_parser__apply7620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_inhNode = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7621 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inhNode (depth = 6)
  gc_frame_newslot(*var_inhNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 4: self request
  params[0] = *var_inhNode;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7622 = callmethodflags(self, "inheritsModifier()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7621);
// compiled call node returning call7622 (depth = 5)
  gc_frame_end(frame);
  return call7622;
}
Object meth_parser__apply7625(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_parser_inheritsOrUses7467(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsOrUses");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsOrUses (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsOrUses");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_msg = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "msg");
  Object *var_inhNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inhNode");
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7469 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7470 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7471 == NULL) {
    strlit7471 = alloc_String("keyword");
    gc_root(strlit7471);
  }
// compiled string node returning strlit7471 (depth = 5)
  gc_frame_newslot(strlit7471);
// call case 4: self request
  params[0] = strlit7471;
  partcv[0] = 1;
  Object call7472 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7470);
// compiled call node returning call7472 (depth = 4)
  partcv[0] = 0;
  Object call7473 = callmethod(call7472, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7469);
// compiled call node returning call7473 (depth = 3)
  Object if7468 = done;
  if (istrue(call7473)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7468 = undefined;
  } else {
  }
// compiled if node returning if7468 (depth = 2)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7477 == NULL) {
    strlit7477 = alloc_String("use");
    gc_root(strlit7477);
  }
// compiled string node returning strlit7477 (depth = 5)
  int op_slot_right_7476 = gc_frame_newslot(strlit7477);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7480 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7479);
// compiled call node returning call7480 (depth = 6)
// compiled member node returning call7480 (depth = 5)
  int op_slot_left_7476 = gc_frame_newslot(call7480);
  params[0] = strlit7477;
  partcv[0] = 1;
  Object opresult7481 = callmethod(call7480, "==", 1, partcv, params);
// compiled op node returning opresult7481 (depth = 4)
  int op_slot_right_7475 = gc_frame_newslot(opresult7481);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7485 == NULL) {
    strlit7485 = alloc_String("inherit");
    gc_root(strlit7485);
  }
// compiled string node returning strlit7485 (depth = 6)
  int op_slot_right_7484 = gc_frame_newslot(strlit7485);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7487 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7488 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7487);
// compiled call node returning call7488 (depth = 7)
// compiled member node returning call7488 (depth = 6)
  int op_slot_left_7484 = gc_frame_newslot(call7488);
  params[0] = strlit7485;
  partcv[0] = 1;
  Object opresult7489 = callmethod(call7488, "==", 1, partcv, params);
// compiled op node returning opresult7489 (depth = 5)
  int op_slot_right_7483 = gc_frame_newslot(opresult7489);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7492 == NULL) {
    strlit7492 = alloc_String("inherits");
    gc_root(strlit7492);
  }
// compiled string node returning strlit7492 (depth = 6)
  int op_slot_right_7491 = gc_frame_newslot(strlit7492);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7495 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7494);
// compiled call node returning call7495 (depth = 7)
// compiled member node returning call7495 (depth = 6)
  int op_slot_left_7491 = gc_frame_newslot(call7495);
  params[0] = strlit7492;
  partcv[0] = 1;
  Object opresult7496 = callmethod(call7495, "==", 1, partcv, params);
// compiled op node returning opresult7496 (depth = 5)
  int op_slot_left_7483 = gc_frame_newslot(opresult7496);
  params[0] = opresult7489;
  partcv[0] = 1;
  Object opresult7497 = callmethod(opresult7496, "||", 1, partcv, params);
// compiled op node returning opresult7497 (depth = 4)
  int op_slot_left_7475 = gc_frame_newslot(opresult7497);
  params[0] = opresult7481;
  partcv[0] = 1;
  Object opresult7498 = callmethod(opresult7497, "||", 1, partcv, params);
// compiled op node returning opresult7498 (depth = 3)
  Object if7474 = done;
  if (istrue(opresult7498)) {
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7499 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7500 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7499);
// compiled call node returning call7500 (depth = 4)
// compiled member node returning call7500 (depth = 3)
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7501 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7502 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7501);
// compiled call node returning call7502 (depth = 4)
// compiled member node returning call7502 (depth = 3)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7504 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe7505 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7506 = alloc_Block(NULL, NULL, "parser", 2323);
  gc_frame_newslot(block7506);
// method "_apply"
  block_savedest(block7506);
  Object closure7507 = createclosure(2, "_apply");
  setclosureframe(closure7507, stackframe);
  addtoclosure(closure7507, var_noBlocks);
  addtoclosure(closure7507, selfslot);
  struct UserObject *uo7507 = (struct UserObject*)block7506;
  uo7507->data[0] = (Object)closure7507;
  Method *meth_meth_parser__apply7507 = addmethod2pos(block7506, "_apply", &meth_parser__apply7507, 0);
  int argcv_meth_parser__apply7507[] = {0};
  meth_meth_parser__apply7507->type = alloc_MethodType(1, argcv_meth_parser__apply7507);
  meth_meth_parser__apply7507->definitionModule = modulename;
  meth_meth_parser__apply7507->definitionLine = 2323;
// compiled block node returning block7506 (depth = 7)
  gc_frame_newslot(block7506);
// call case 4: self request
  params[0] = block7506;
  partcv[0] = 1;
  Object call7511 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7505);
// compiled call node returning call7511 (depth = 6)
  partcv[0] = 0;
  Object call7512 = callmethod(call7511, "not",
    1, partcv, params);
  gc_frame_end(callframe7504);
// compiled call node returning call7512 (depth = 5)
// compiled member node returning call7512 (depth = 4)
  Object if7503 = done;
  if (istrue(call7512)) {
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7513 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7514 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7515 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7514);
// compiled call node returning call7515 (depth = 8)
// compiled member node returning call7515 (depth = 7)
  partcv[0] = 0;
  Object call7516 = callmethod(call7515, "empty",
    1, partcv, params);
  gc_frame_end(callframe7513);
// compiled call node returning call7516 (depth = 6)
// compiled member node returning call7516 (depth = 5)
  *var_suggestions = call7516;
  if (call7516 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7517 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7519 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7518);
// compiled call node returning call7519 (depth = 8)
// compiled member node returning call7519 (depth = 7)
  partcv[0] = 0;
  Object call7520 = callmethod(call7519, "new",
    1, partcv, params);
  gc_frame_end(callframe7517);
// compiled call node returning call7520 (depth = 6)
// compiled member node returning call7520 (depth = 5)
  *var_suggestion = call7520;
  if (call7520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7521 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array7522 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit7523 == NULL) {
    strlit7523 = alloc_String("rsquare");
    gc_root(strlit7523);
  }
// compiled string node returning strlit7523 (depth = 7)
  params[0] = strlit7523;
  partcv[0] = 1;
  callmethod(array7522, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array7522 (depth = 6)
  gc_frame_newslot(array7522);
// call case 4: self request
  params[0] = array7522;
  partcv[0] = 1;
  Object call7524 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7521);
// compiled call node returning call7524 (depth = 5)
  *var_nextTok = call7524;
  if (call7524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_7526 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_7526 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7528 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7528 (depth = 5)
  Object if7525 = done;
  if (istrue(opresult7528)) {
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7529 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7530 == NULL) {
    strlit7530 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7530);
  }
// compiled string node returning strlit7530 (depth = 6)
  gc_frame_newslot(strlit7530);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7530;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7531 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7529);
// compiled call node returning call7531 (depth = 5)
    gc_frame_newslot(call7531);
    if7525 = call7531;
  } else {
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7532 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7533 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7534 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7533);
// compiled call node returning call7534 (depth = 7)
// compiled member node returning call7534 (depth = 6)
  gc_frame_newslot(call7534);
// starting to compile identifier node (depth = 6)
  Object bool7535 = alloc_Boolean(1);
// compiled identifier node returning bool7535 (depth = 6)
  gc_frame_newslot(bool7535);
// starting to compile identifier node (depth = 6)
  Object bool7536 = alloc_Boolean(0);
// compiled identifier node returning bool7536 (depth = 6)
  gc_frame_newslot(bool7536);
// starting to compile string node (depth = 6)
  if (strlit7537 == NULL) {
    strlit7537 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7537);
  }
// compiled string node returning strlit7537 (depth = 6)
  gc_frame_newslot(strlit7537);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7534;
  params[2] = bool7535;
  params[3] = bool7536;
  params[4] = strlit7537;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7538 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7532);
// compiled call node returning call7538 (depth = 5)
    gc_frame_newslot(call7538);
    if7525 = call7538;
  }
// compiled if node returning if7525 (depth = 4)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7539 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7540 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7539);
// compiled call node returning call7540 (depth = 4)
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7541 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7543 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7542);
// compiled call node returning call7543 (depth = 8)
// compiled member node returning call7543 (depth = 7)
  partcv[0] = 0;
  Object call7544 = callmethod(call7543, "new",
    1, partcv, params);
  gc_frame_end(callframe7541);
// compiled call node returning call7544 (depth = 6)
// compiled member node returning call7544 (depth = 5)
  *var_suggestion = call7544;
  if (call7544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2334
  setline(2334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7546 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call7548 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7547);
// compiled call node returning call7548 (depth = 6)
// compiled member node returning call7548 (depth = 5)
  gc_frame_newslot(call7548);
// starting to compile identifier node (depth = 5)
  Object bool7549 = alloc_Boolean(1);
// compiled identifier node returning bool7549 (depth = 5)
  gc_frame_newslot(bool7549);
// starting to compile identifier node (depth = 5)
  Object bool7550 = alloc_Boolean(0);
// compiled identifier node returning bool7550 (depth = 5)
  gc_frame_newslot(bool7550);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call7548;
  params[2] = bool7549;
  params[3] = bool7550;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7551 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7546);
// compiled call node returning call7551 (depth = 4)
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7552 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7553 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7552);
// compiled call node returning call7553 (depth = 4)
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7555 == NULL) {
    strlit7555 = alloc_String(" keyword must be followed by an expression that creates ");
    gc_root(strlit7555);
  }
// compiled string node returning strlit7555 (depth = 6)
  int op_slot_right_7554 = gc_frame_newslot(strlit7555);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7558 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call7559 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe7558);
// compiled call node returning call7559 (depth = 8)
// compiled member node returning call7559 (depth = 7)
  int op_slot_right_7557 = gc_frame_newslot(call7559);
// starting to compile string node (depth = 7)
  if (strlit7561 == NULL) {
    strlit7561 = alloc_String("The ");
    gc_root(strlit7561);
  }
// compiled string node returning strlit7561 (depth = 7)
  int op_slot_left_7557 = gc_frame_newslot(strlit7561);
  params[0] = call7559;
  partcv[0] = 1;
  Object opresult7562 = callmethod(strlit7561, "++", 1, partcv, params);
// compiled op node returning opresult7562 (depth = 6)
  int op_slot_left_7554 = gc_frame_newslot(opresult7562);
  params[0] = strlit7555;
  partcv[0] = 1;
  Object opresult7563 = callmethod(opresult7562, "++", 1, partcv, params);
// compiled op node returning opresult7563 (depth = 5)
  *var_msg = opresult7563;
  if (opresult7563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7566 == NULL) {
    strlit7566 = alloc_String("use");
    gc_root(strlit7566);
  }
// compiled string node returning strlit7566 (depth = 6)
  int op_slot_right_7565 = gc_frame_newslot(strlit7566);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  partcv[0] = 0;
  Object call7569 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe7568);
// compiled call node returning call7569 (depth = 7)
// compiled member node returning call7569 (depth = 6)
  int op_slot_left_7565 = gc_frame_newslot(call7569);
  params[0] = strlit7566;
  partcv[0] = 1;
  Object opresult7570 = callmethod(call7569, "==", 1, partcv, params);
// compiled op node returning opresult7570 (depth = 5)
  Object if7564 = done;
  if (istrue(opresult7570)) {
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7572 == NULL) {
    strlit7572 = alloc_String("the trait being used.");
    gc_root(strlit7572);
  }
// compiled string node returning strlit7572 (depth = 7)
  int op_slot_right_7571 = gc_frame_newslot(strlit7572);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_7571 = gc_frame_newslot(*var_msg);
  params[0] = strlit7572;
  partcv[0] = 1;
  Object opresult7574 = callmethod(*var_msg, "++", 1, partcv, params);
// compiled op node returning opresult7574 (depth = 6)
  *var_msg = opresult7574;
  if (opresult7574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7564 = done;
  } else {
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7577 == NULL) {
    strlit7577 = alloc_String("the object being inherited.");
    gc_root(strlit7577);
  }
// compiled string node returning strlit7577 (depth = 7)
  int op_slot_right_7576 = gc_frame_newslot(strlit7577);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_7576 = gc_frame_newslot(*var_msg);
  params[0] = strlit7577;
  partcv[0] = 1;
  Object opresult7579 = callmethod(*var_msg, "++", 1, partcv, params);
// compiled op node returning opresult7579 (depth = 6)
  *var_msg = opresult7579;
  if (opresult7579 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7564 = done;
  }
// compiled if node returning if7564 (depth = 4)
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7581 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_msg (depth = 5)
  gc_frame_newslot(*var_msg);
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7582 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7583 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7582);
// compiled call node returning call7583 (depth = 6)
// compiled member node returning call7583 (depth = 5)
  gc_frame_newslot(call7583);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7585 = alloc_Float64(1);
// compiled num node returning num7585 (depth = 6)
  int op_slot_right_7584 = gc_frame_newslot(num7585);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7588 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7589 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7588);
// compiled call node returning call7589 (depth = 8)
// compiled member node returning call7589 (depth = 7)
  int op_slot_right_7587 = gc_frame_newslot(call7589);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7592 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7591);
// compiled call node returning call7592 (depth = 8)
// compiled member node returning call7592 (depth = 7)
  int op_slot_left_7587 = gc_frame_newslot(call7592);
  params[0] = call7589;
  partcv[0] = 1;
  Object sum7593 = callmethod(call7592, "+", 1, partcv, params);
// compiled op node returning sum7593 (depth = 6)
  int op_slot_left_7584 = gc_frame_newslot(sum7593);
  params[0] = num7585;
  partcv[0] = 1;
  Object sum7594 = callmethod(sum7593, "+", 1, partcv, params);
// compiled op node returning sum7594 (depth = 5)
  gc_frame_newslot(sum7594);
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = *var_msg;
  params[1] = call7583;
  params[2] = sum7594;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7595 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7581);
// compiled call node returning call7595 (depth = 4)
    gc_frame_newslot(call7595);
    if7503 = call7595;
  } else {
  }
// compiled if node returning if7503 (depth = 3)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7596 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call7598 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe7597);
// compiled call node returning call7598 (depth = 5)
// compiled member node returning call7598 (depth = 4)
  gc_frame_newslot(call7598);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call7600 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7599);
// compiled call node returning call7600 (depth = 5)
// compiled member node returning call7600 (depth = 4)
  gc_frame_newslot(call7600);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7598;
  params[1] = call7600;
  partcv[0] = 2;
  Object call7601 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7596);
// compiled call node returning call7601 (depth = 3)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7602 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7603 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7604 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7603);
// compiled call node returning call7604 (depth = 6)
// compiled member node returning call7604 (depth = 5)
  gc_frame_newslot(call7604);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7606 = callmethod(*var_ast, "inheritsNode",
    1, partcv, params);
  gc_frame_end(callframe7605);
// compiled call node returning call7606 (depth = 6)
// compiled member node returning call7606 (depth = 5)
  params[0] = call7604;
  partcv[0] = 1;
  Object call7607 = callmethod(call7606, "new",
    1, partcv, params);
  gc_frame_end(callframe7602);
// compiled call node returning call7607 (depth = 4)
  *var_inhNode = call7607;
  if (call7607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7610 == NULL) {
    strlit7610 = alloc_String("use");
    gc_root(strlit7610);
  }
// compiled string node returning strlit7610 (depth = 5)
  int op_slot_right_7609 = gc_frame_newslot(strlit7610);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call7613 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe7612);
// compiled call node returning call7613 (depth = 6)
// compiled member node returning call7613 (depth = 5)
  int op_slot_left_7609 = gc_frame_newslot(call7613);
  params[0] = strlit7610;
  partcv[0] = 1;
  Object opresult7614 = callmethod(call7613, "==", 1, partcv, params);
// compiled op node returning opresult7614 (depth = 4)
  Object if7608 = done;
  if (istrue(opresult7614)) {
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7615 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7616 = alloc_Boolean(1);
// compiled identifier node returning bool7616 (depth = 5)
  gc_frame_newslot(bool7616);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inhNode (depth = 5)
  params[0] = bool7616;
  partcv[0] = 1;
  Object call7617 = callmethod(*var_inhNode, "isUse:=",
    1, partcv, params);
  gc_frame_end(callframe7615);
// compiled call node returning call7617 (depth = 4)
    gc_frame_newslot(call7617);
    if7608 = call7617;
  } else {
  }
// compiled if node returning if7608 (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7618 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7619 = alloc_Block(NULL, NULL, "parser", 2351);
  gc_frame_newslot(block7619);
// method "_apply"
  block_savedest(block7619);
  Object closure7620 = createclosure(3, "_apply");
  setclosureframe(closure7620, stackframe);
  addtoclosure(closure7620, var_inhNode);
  addtoclosure(closure7620, var_btok);
  addtoclosure(closure7620, selfslot);
  struct UserObject *uo7620 = (struct UserObject*)block7619;
  uo7620->data[0] = (Object)closure7620;
  Method *meth_meth_parser__apply7620 = addmethod2pos(block7619, "_apply", &meth_parser__apply7620, 0);
  int argcv_meth_parser__apply7620[] = {0};
  meth_meth_parser__apply7620->type = alloc_MethodType(1, argcv_meth_parser__apply7620);
  meth_meth_parser__apply7620->definitionModule = modulename;
  meth_meth_parser__apply7620->definitionLine = 2348;
// compiled block node returning block7619 (depth = 4)
  gc_frame_newslot(block7619);
// starting to compile block node (depth = 4)
  Object block7624 = alloc_Block(NULL, NULL, "parser", 2351);
  gc_frame_newslot(block7624);
// method "_apply"
  block_savedest(block7624);
  Object closure7625 = createclosure(1, "_apply");
  setclosureframe(closure7625, stackframe);
  addtoclosure(closure7625, selfslot);
  struct UserObject *uo7625 = (struct UserObject*)block7624;
  uo7625->data[0] = (Object)closure7625;
  Method *meth_meth_parser__apply7625 = addmethod2pos(block7624, "_apply", &meth_parser__apply7625, 0);
  int argcv_meth_parser__apply7625[] = {0};
  meth_meth_parser__apply7625->type = alloc_MethodType(1, argcv_meth_parser__apply7625);
  meth_meth_parser__apply7625->definitionModule = modulename;
  meth_meth_parser__apply7625->definitionLine = 2348;
// compiled block node returning block7624 (depth = 4)
  gc_frame_newslot(block7624);
// call case 5: prelude request
  params[0] = block7619;
  params[1] = block7624;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7627 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7618);
// compiled call node returning call7627 (depth = 3)
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7628 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call7629 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7628);
// compiled call node returning call7629 (depth = 3)
    gc_frame_newslot(call7629);
    if7474 = call7629;
  } else {
  }
// compiled if node returning if7474 (depth = 2)
  gc_frame_end(frame);
  return if7474;
}
Object meth_parser_inheritsModifier_40__41_onLineOf7630(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsModifier()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritsModifier()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritsModifier()onLineOf");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for inheritsModifier()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for inheritsModifier");
  Object *var_startToken = &(stackframe->slots[1]);
  *var_startToken = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7632 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7633 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7634 == NULL) {
    strlit7634 = alloc_String("keyword");
    gc_root(strlit7634);
  }
// compiled string node returning strlit7634 (depth = 5)
  gc_frame_newslot(strlit7634);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 4: self request
  params[0] = strlit7634;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7635 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7633);
// compiled call node returning call7635 (depth = 4)
  partcv[0] = 0;
  Object call7636 = callmethod(call7635, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7632);
// compiled call node returning call7636 (depth = 3)
  Object if7631 = done;
  if (istrue(call7636)) {
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7637 = alloc_Boolean(0);
// compiled identifier node returning bool7637 (depth = 4)
  return bool7637;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7631 = undefined;
  } else {
  }
// compiled if node returning if7631 (depth = 2)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7640 == NULL) {
    strlit7640 = alloc_String("alias");
    gc_root(strlit7640);
  }
// compiled string node returning strlit7640 (depth = 4)
  int op_slot_right_7639 = gc_frame_newslot(strlit7640);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7643 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7642);
// compiled call node returning call7643 (depth = 5)
// compiled member node returning call7643 (depth = 4)
  int op_slot_left_7639 = gc_frame_newslot(call7643);
  params[0] = strlit7640;
  partcv[0] = 1;
  Object opresult7644 = callmethod(call7643, "==", 1, partcv, params);
// compiled op node returning opresult7644 (depth = 3)
  Object if7638 = done;
  if (istrue(opresult7644)) {
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7645 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  gc_frame_newslot(*var_node);
// call case 4: self request
  params[0] = *var_node;
  partcv[0] = 1;
  Object call7646 = callmethodflags(self, "parseAlias", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7645);
// compiled call node returning call7646 (depth = 3)
    gc_frame_newslot(call7646);
    if7638 = call7646;
  } else {
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7649 == NULL) {
    strlit7649 = alloc_String("exclude");
    gc_root(strlit7649);
  }
// compiled string node returning strlit7649 (depth = 5)
  int op_slot_right_7648 = gc_frame_newslot(strlit7649);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7652 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7651);
// compiled call node returning call7652 (depth = 6)
// compiled member node returning call7652 (depth = 5)
  int op_slot_left_7648 = gc_frame_newslot(call7652);
  params[0] = strlit7649;
  partcv[0] = 1;
  Object opresult7653 = callmethod(call7652, "==", 1, partcv, params);
// compiled op node returning opresult7653 (depth = 4)
  Object if7647 = done;
  if (istrue(opresult7653)) {
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7654 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  gc_frame_newslot(*var_node);
// call case 4: self request
  params[0] = *var_node;
  partcv[0] = 1;
  Object call7655 = callmethodflags(self, "parseExclude", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7654);
// compiled call node returning call7655 (depth = 4)
    gc_frame_newslot(call7655);
    if7647 = call7655;
  } else {
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7656 = alloc_Boolean(0);
// compiled identifier node returning bool7656 (depth = 4)
    gc_frame_newslot(bool7656);
    if7647 = bool7656;
  }
// compiled if node returning if7647 (depth = 3)
    gc_frame_newslot(if7647);
    if7638 = if7647;
  }
// compiled if node returning if7638 (depth = 2)
  gc_frame_end(frame);
  return if7638;
}
Object meth_parser_parseAlias7657(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseAlias");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseAlias");
  Object params[3];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseAlias (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parseAlias");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newSig = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newSig");
  Object *var_newMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newMeth");
  Object *var_oldSig = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "oldSig");
  Object *var_oldMeth = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "oldMeth");
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7658 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7659 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7658);
// compiled call node returning call7659 (depth = 3)
// compiled member node returning call7659 (depth = 2)
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7660 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7661 = alloc_Boolean(1);
// compiled identifier node returning bool7661 (depth = 4)
  gc_frame_newslot(bool7661);
// call case 4: self request
  params[0] = bool7661;
  partcv[0] = 1;
  Object call7662 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7660);
// compiled call node returning call7662 (depth = 3)
  *var_newSig = call7662;
  if (call7662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newSig (depth = 5)
  partcv[0] = 0;
  Object call7664 = callmethod(*var_newSig, "m",
    1, partcv, params);
  gc_frame_end(callframe7663);
// compiled call node returning call7664 (depth = 4)
// compiled member node returning call7664 (depth = 3)
  *var_newMeth = call7664;
  if (call7664 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7668 == NULL) {
    strlit7668 = alloc_String("=");
    gc_root(strlit7668);
  }
// compiled string node returning strlit7668 (depth = 5)
  int op_slot_right_7667 = gc_frame_newslot(strlit7668);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7670 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7671 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7670);
// compiled call node returning call7671 (depth = 6)
// compiled member node returning call7671 (depth = 5)
  int op_slot_left_7667 = gc_frame_newslot(call7671);
  params[0] = strlit7668;
  partcv[0] = 1;
  Object opresult7672 = callmethod(call7671, "==", 1, partcv, params);
// compiled op node returning opresult7672 (depth = 4)
  int op_slot_right_7666 = gc_frame_newslot(opresult7672);
// starting to compile call node (depth = 4)
  int callframe7674 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7675 == NULL) {
    strlit7675 = alloc_String("op");
    gc_root(strlit7675);
  }
// compiled string node returning strlit7675 (depth = 5)
  gc_frame_newslot(strlit7675);
// call case 4: self request
  params[0] = strlit7675;
  partcv[0] = 1;
  Object call7676 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7674);
// compiled call node returning call7676 (depth = 4)
  int op_slot_left_7666 = gc_frame_newslot(call7676);
  params[0] = opresult7672;
  partcv[0] = 1;
  Object opresult7677 = callmethod(call7676, "&&", 1, partcv, params);
// compiled op node returning opresult7677 (depth = 3)
  Object if7665 = done;
  if (istrue(opresult7677)) {
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7678 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7679 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7678);
// compiled call node returning call7679 (depth = 4)
// compiled member node returning call7679 (depth = 3)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7680 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7681 = alloc_Boolean(1);
// compiled identifier node returning bool7681 (depth = 5)
  gc_frame_newslot(bool7681);
// call case 4: self request
  params[0] = bool7681;
  partcv[0] = 1;
  Object call7682 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7680);
// compiled call node returning call7682 (depth = 4)
  *var_oldSig = call7682;
  if (call7682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7683 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldSig (depth = 6)
  partcv[0] = 0;
  Object call7684 = callmethod(*var_oldSig, "m",
    1, partcv, params);
  gc_frame_end(callframe7683);
// compiled call node returning call7684 (depth = 5)
// compiled member node returning call7684 (depth = 4)
  *var_oldMeth = call7684;
  if (call7684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7685 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7686 = alloc_Boolean(0);
// compiled identifier node returning bool7686 (depth = 4)
  gc_frame_newslot(bool7686);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldMeth (depth = 4)
  params[0] = bool7686;
  partcv[0] = 1;
  Object call7687 = callmethod(*var_oldMeth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7685);
// compiled call node returning call7687 (depth = 3)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7688 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newMeth (depth = 4)
  gc_frame_newslot(*var_newMeth);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldMeth (depth = 4)
  gc_frame_newslot(*var_oldMeth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  params[0] = *var_newMeth;
  params[1] = *var_oldMeth;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7689 = callmethod(*var_node, "addAlias()for",
    2, partcv, params);
  gc_frame_end(callframe7688);
// compiled call node returning call7689 (depth = 3)
    gc_frame_newslot(call7689);
    if7665 = call7689;
  } else {
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7690 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7692 == NULL) {
    strlit7692 = alloc_String("'newMethodName = oldMethodName'");
    gc_root(strlit7692);
  }
// compiled string node returning strlit7692 (depth = 5)
  int op_slot_right_7691 = gc_frame_newslot(strlit7692);
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7694 == NULL) {
    strlit7694 = alloc_String("An alias modifier must take the form ");
    gc_root(strlit7694);
  }
// compiled string node returning strlit7694 (depth = 5)
  int op_slot_left_7691 = gc_frame_newslot(strlit7694);
  params[0] = strlit7692;
  partcv[0] = 1;
  Object opresult7695 = callmethod(strlit7694, "++", 1, partcv, params);
// compiled op node returning opresult7695 (depth = 4)
  gc_frame_newslot(opresult7695);
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7697 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7696);
// compiled call node returning call7697 (depth = 5)
// compiled member node returning call7697 (depth = 4)
  gc_frame_newslot(call7697);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7700 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7699);
// compiled call node returning call7700 (depth = 6)
// compiled member node returning call7700 (depth = 5)
  int op_slot_right_7698 = gc_frame_newslot(call7700);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7703 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7702);
// compiled call node returning call7703 (depth = 6)
// compiled member node returning call7703 (depth = 5)
  int op_slot_left_7698 = gc_frame_newslot(call7703);
  params[0] = call7700;
  partcv[0] = 1;
  Object sum7704 = callmethod(call7703, "+", 1, partcv, params);
// compiled op node returning sum7704 (depth = 4)
  gc_frame_newslot(sum7704);
// call case 6: other member request
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7695;
  params[1] = call7697;
  params[2] = sum7704;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7705 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe7690);
// compiled call node returning call7705 (depth = 3)
    gc_frame_newslot(call7705);
    if7665 = call7705;
  }
// compiled if node returning if7665 (depth = 2)
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7706 = alloc_Boolean(1);
// compiled identifier node returning bool7706 (depth = 3)
  return bool7706;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_parseExclude7707(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parseExclude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseExclude");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseExclude (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parseExclude");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_exSig = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "exSig");
  Object *var_excludedMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "excludedMeth");
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7708 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7709 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7708);
// compiled call node returning call7709 (depth = 3)
// compiled member node returning call7709 (depth = 2)
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7710 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7711 = alloc_Boolean(1);
// compiled identifier node returning bool7711 (depth = 4)
  gc_frame_newslot(bool7711);
// call case 4: self request
  params[0] = bool7711;
  partcv[0] = 1;
  Object call7712 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7710);
// compiled call node returning call7712 (depth = 3)
  *var_exSig = call7712;
  if (call7712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7713 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_exSig (depth = 5)
  partcv[0] = 0;
  Object call7714 = callmethod(*var_exSig, "m",
    1, partcv, params);
  gc_frame_end(callframe7713);
// compiled call node returning call7714 (depth = 4)
// compiled member node returning call7714 (depth = 3)
  *var_excludedMeth = call7714;
  if (call7714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7715 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool7716 = alloc_Boolean(0);
// compiled identifier node returning bool7716 (depth = 3)
  gc_frame_newslot(bool7716);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_excludedMeth (depth = 3)
  params[0] = bool7716;
  partcv[0] = 1;
  Object call7717 = callmethod(*var_excludedMeth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7715);
// compiled call node returning call7717 (depth = 2)
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7718 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_excludedMeth (depth = 3)
  gc_frame_newslot(*var_excludedMeth);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_excludedMeth;
  partcv[0] = 1;
  Object call7719 = callmethod(*var_node, "addExclusion",
    1, partcv, params);
  gc_frame_end(callframe7718);
// compiled call node returning call7719 (depth = 2)
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7720 = alloc_Boolean(1);
// compiled identifier node returning bool7720 (depth = 3)
  return bool7720;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_doobject7721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doobject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doobject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7723 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7724 == NULL) {
    strlit7724 = alloc_String("object");
    gc_root(strlit7724);
  }
// compiled string node returning strlit7724 (depth = 4)
  gc_frame_newslot(strlit7724);
// call case 4: self request
  params[0] = strlit7724;
  partcv[0] = 1;
  Object call7725 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7723);
// compiled call node returning call7725 (depth = 3)
  Object if7722 = done;
  if (istrue(call7725)) {
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7727 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7726);
// compiled call node returning call7727 (depth = 4)
// compiled member node returning call7727 (depth = 3)
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7728 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7729 == NULL) {
    strlit7729 = alloc_String("an object constructor");
    gc_root(strlit7729);
  }
// compiled string node returning strlit7729 (depth = 4)
  gc_frame_newslot(strlit7729);
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 4)
  if (strlit7730 == NULL) {
    strlit7730 = alloc_String("'object'");
    gc_root(strlit7730);
  }
// compiled string node returning strlit7730 (depth = 4)
  gc_frame_newslot(strlit7730);
// call case 4: self request
  params[0] = strlit7729;
  params[1] = *var_lastToken;
  params[2] = strlit7730;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7731 = callmethodflags(self, "parseObjectConstructorBody()startingWith()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7728);
// compiled call node returning call7731 (depth = 3)
    gc_frame_newslot(call7731);
    if7722 = call7731;
  } else {
  }
// compiled if node returning if7722 (depth = 2)
  gc_frame_end(frame);
  return if7722;
}
Object meth_parser__apply7748(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7750 == NULL) {
    strlit7750 = alloc_String("rbrace");
    gc_root(strlit7750);
  }
// compiled string node returning strlit7750 (depth = 7)
  int op_slot_right_7749 = gc_frame_newslot(strlit7750);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7752 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  partcv[0] = 0;
  Object call7753 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7752);
// compiled call node returning call7753 (depth = 8)
// compiled member node returning call7753 (depth = 7)
  int op_slot_left_7749 = gc_frame_newslot(call7753);
  params[0] = strlit7750;
  partcv[0] = 1;
  Object opresult7754 = callmethod(call7753, "==", 1, partcv, params);
// compiled op node returning opresult7754 (depth = 6)
  gc_frame_end(frame);
  return opresult7754;
}
Object meth_parser__apply7827(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7829 == NULL) {
    strlit7829 = alloc_String("eof");
    gc_root(strlit7829);
  }
// compiled string node returning strlit7829 (depth = 7)
  int op_slot_right_7828 = gc_frame_newslot(strlit7829);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7832 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7831);
// compiled call node returning call7832 (depth = 8)
// compiled member node returning call7832 (depth = 7)
  int op_slot_left_7828 = gc_frame_newslot(call7832);
  params[0] = strlit7829;
  partcv[0] = 1;
  Object opresult7833 = callmethod(call7832, "!=", 1, partcv, params);
// compiled op node returning opresult7833 (depth = 6)
  gc_frame_end(frame);
  return opresult7833;
}
Object meth_parser__apply7824(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe7825 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7826 = alloc_Block(NULL, NULL, "parser", 2436);
  gc_frame_newslot(block7826);
// method "_apply"
  block_savedest(block7826);
  Object closure7827 = createclosure(2, "_apply");
  setclosureframe(closure7827, stackframe);
  addtoclosure(closure7827, var_sym);
  addtoclosure(closure7827, selfslot);
  struct UserObject *uo7827 = (struct UserObject*)block7826;
  uo7827->data[0] = (Object)closure7827;
  Method *meth_meth_parser__apply7827 = addmethod2pos(block7826, "_apply", &meth_parser__apply7827, 0);
  int argcv_meth_parser__apply7827[] = {0};
  meth_meth_parser__apply7827->type = alloc_MethodType(1, argcv_meth_parser__apply7827);
  meth_meth_parser__apply7827->definitionModule = modulename;
  meth_meth_parser__apply7827->definitionLine = 2430;
// compiled block node returning block7826 (depth = 5)
  gc_frame_newslot(block7826);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7835 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7836 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7837 == NULL) {
    strlit7837 = alloc_String("rbrace");
    gc_root(strlit7837);
  }
// compiled string node returning strlit7837 (depth = 8)
  gc_frame_newslot(strlit7837);
// call case 4: self request
  params[0] = strlit7837;
  partcv[0] = 1;
  Object call7838 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7836);
// compiled call node returning call7838 (depth = 7)
  partcv[0] = 0;
  Object call7839 = callmethod(call7838, "not",
    1, partcv, params);
  gc_frame_end(callframe7835);
// compiled call node returning call7839 (depth = 6)
// compiled member node returning call7839 (depth = 5)
  params[0] = block7826;
  partcv[0] = 1;
  Object call7840 = callmethod(call7839, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe7825);
// compiled call node returning call7840 (depth = 4)
  gc_frame_end(frame);
  return call7840;
}
Object meth_parser__apply7847(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7849 = callmethodflags(self, "inheritsOrUses", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7848);
// compiled call node returning call7849 (depth = 8)
// compiled member node returning call7849 (depth = 7)
  gc_frame_end(frame);
  return call7849;
}
Object meth_parser__apply7927(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7929 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7928);
// compiled call node returning call7929 (depth = 9)
// compiled member node returning call7929 (depth = 8)
  gc_frame_end(frame);
  return call7929;
}
Object meth_parser__apply7941(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7942 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7943 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7942);
// compiled call node returning call7943 (depth = 10)
// compiled member node returning call7943 (depth = 9)
  gc_frame_end(frame);
  return call7943;
}
Object meth_parser__apply7843(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_inPreamble = getfromclosure(closure, 1);
  Object *var_usedTraits = getfromclosure(closure, 2);
  Object *var_superObject = getfromclosure(closure, 3);
  Object *var_constructName = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7845 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7846 = alloc_Block(NULL, NULL, "parser", 2437);
  gc_frame_newslot(block7846);
// method "_apply"
  block_savedest(block7846);
  Object closure7847 = createclosure(1, "_apply");
  setclosureframe(closure7847, stackframe);
  addtoclosure(closure7847, selfslot);
  struct UserObject *uo7847 = (struct UserObject*)block7846;
  uo7847->data[0] = (Object)closure7847;
  Method *meth_meth_parser__apply7847 = addmethod2pos(block7846, "_apply", &meth_parser__apply7847, 0);
  int argcv_meth_parser__apply7847[] = {0};
  meth_meth_parser__apply7847->type = alloc_MethodType(1, argcv_meth_parser__apply7847);
  meth_meth_parser__apply7847->definitionModule = modulename;
  meth_meth_parser__apply7847->definitionLine = 2436;
// compiled block node returning block7846 (depth = 6)
  gc_frame_newslot(block7846);
// call case 4: self request
  params[0] = block7846;
  partcv[0] = 1;
  Object call7851 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7845);
// compiled call node returning call7851 (depth = 5)
  Object if7844 = done;
  if (istrue(call7851)) {
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7852 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7853 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7852);
// compiled call node returning call7853 (depth = 7)
// compiled member node returning call7853 (depth = 6)
  *var_parentNode = call7853;
  if (call7853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inPreamble (depth = 6)
  Object if7854 = done;
  if (istrue(*var_inPreamble)) {
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call7857 = callmethod(*var_parentNode, "isUse",
    1, partcv, params);
  gc_frame_end(callframe7856);
// compiled call node returning call7857 (depth = 8)
// compiled member node returning call7857 (depth = 7)
  Object if7855 = done;
  if (istrue(call7857)) {
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7858 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_usedTraits (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call7859 = callmethod(*var_usedTraits, "add",
    1, partcv, params);
  gc_frame_end(callframe7858);
// compiled call node returning call7859 (depth = 7)
    gc_frame_newslot(call7859);
    if7855 = call7859;
  } else {
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_usedTraits (depth = 10)
  partcv[0] = 0;
  Object call7862 = callmethod(*var_usedTraits, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe7861);
// compiled call node returning call7862 (depth = 9)
// compiled member node returning call7862 (depth = 8)
  Object if7860 = done;
  if (istrue(call7862)) {
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  *var_superObject = *var_parentNode;
  if (*var_parentNode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if7860 = done;
  } else {
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7864 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7867 == NULL) {
    strlit7867 = alloc_String("");
    gc_root(strlit7867);
  }
// compiled string node returning strlit7867 (depth = 11)
  int op_slot_right_7866 = gc_frame_newslot(strlit7867);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_constructName (depth = 12)
  int op_slot_right_7869 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 12)
  if (strlit7871 == NULL) {
    strlit7871 = alloc_String("before 'use' in ");
    gc_root(strlit7871);
  }
// compiled string node returning strlit7871 (depth = 12)
  int op_slot_left_7869 = gc_frame_newslot(strlit7871);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7872 = callmethod(strlit7871, "++", 1, partcv, params);
// compiled op node returning opresult7872 (depth = 11)
  int op_slot_left_7866 = gc_frame_newslot(opresult7872);
  params[0] = strlit7867;
  partcv[0] = 1;
  Object opresult7873 = callmethod(opresult7872, "++", 1, partcv, params);
// compiled op node returning opresult7873 (depth = 10)
  int op_slot_right_7865 = gc_frame_newslot(opresult7873);
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7875 == NULL) {
    strlit7875 = alloc_String("'inherit' must come ");
    gc_root(strlit7875);
  }
// compiled string node returning strlit7875 (depth = 10)
  int op_slot_left_7865 = gc_frame_newslot(strlit7875);
  params[0] = opresult7873;
  partcv[0] = 1;
  Object opresult7876 = callmethod(strlit7875, "++", 1, partcv, params);
// compiled op node returning opresult7876 (depth = 9)
  gc_frame_newslot(opresult7876);
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call7878 = callmethod(*var_parentNode, "line",
    1, partcv, params);
  gc_frame_end(callframe7877);
// compiled call node returning call7878 (depth = 10)
// compiled member node returning call7878 (depth = 9)
  gc_frame_newslot(call7878);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call7880 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7879);
// compiled call node returning call7880 (depth = 10)
// compiled member node returning call7880 (depth = 9)
  gc_frame_newslot(call7880);
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7882 = alloc_Float64(7);
// compiled num node returning num7882 (depth = 10)
  int op_slot_right_7881 = gc_frame_newslot(num7882);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7884 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call7885 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7884);
// compiled call node returning call7885 (depth = 11)
// compiled member node returning call7885 (depth = 10)
  int op_slot_left_7881 = gc_frame_newslot(call7885);
  params[0] = num7882;
  partcv[0] = 1;
  Object sum7886 = callmethod(call7885, "+", 1, partcv, params);
// compiled op node returning sum7886 (depth = 9)
  gc_frame_newslot(sum7886);
// call case 6: other member request
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult7876;
  params[1] = call7878;
  params[2] = call7880;
  params[3] = sum7886;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7887 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe7864);
// compiled call node returning call7887 (depth = 8)
    gc_frame_newslot(call7887);
    if7860 = call7887;
  }
// compiled if node returning if7860 (depth = 7)
    gc_frame_newslot(if7860);
    if7855 = if7860;
  }
// compiled if node returning if7855 (depth = 6)
    gc_frame_newslot(if7855);
    if7854 = if7855;
  } else {
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7888 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7891 == NULL) {
    strlit7891 = alloc_String("");
    gc_root(strlit7891);
  }
// compiled string node returning strlit7891 (depth = 9)
  int op_slot_right_7890 = gc_frame_newslot(strlit7891);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_constructName (depth = 10)
  int op_slot_right_7893 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 10)
  if (strlit7895 == NULL) {
    strlit7895 = alloc_String("come at the start of ");
    gc_root(strlit7895);
  }
// compiled string node returning strlit7895 (depth = 10)
  int op_slot_left_7893 = gc_frame_newslot(strlit7895);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7896 = callmethod(strlit7895, "++", 1, partcv, params);
// compiled op node returning opresult7896 (depth = 9)
  int op_slot_left_7890 = gc_frame_newslot(opresult7896);
  params[0] = strlit7891;
  partcv[0] = 1;
  Object opresult7897 = callmethod(opresult7896, "++", 1, partcv, params);
// compiled op node returning opresult7897 (depth = 8)
  int op_slot_right_7889 = gc_frame_newslot(opresult7897);
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7900 == NULL) {
    strlit7900 = alloc_String("' must ");
    gc_root(strlit7900);
  }
// compiled string node returning strlit7900 (depth = 9)
  int op_slot_right_7899 = gc_frame_newslot(strlit7900);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7903 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call7904 = callmethod(*var_parentNode, "statementName",
    1, partcv, params);
  gc_frame_end(callframe7903);
// compiled call node returning call7904 (depth = 11)
// compiled member node returning call7904 (depth = 10)
  int op_slot_right_7902 = gc_frame_newslot(call7904);
// starting to compile string node (depth = 10)
  if (strlit7906 == NULL) {
    strlit7906 = alloc_String("'");
    gc_root(strlit7906);
  }
// compiled string node returning strlit7906 (depth = 10)
  int op_slot_left_7902 = gc_frame_newslot(strlit7906);
  params[0] = call7904;
  partcv[0] = 1;
  Object opresult7907 = callmethod(strlit7906, "++", 1, partcv, params);
// compiled op node returning opresult7907 (depth = 9)
  int op_slot_left_7899 = gc_frame_newslot(opresult7907);
  params[0] = strlit7900;
  partcv[0] = 1;
  Object opresult7908 = callmethod(opresult7907, "++", 1, partcv, params);
// compiled op node returning opresult7908 (depth = 8)
  int op_slot_left_7889 = gc_frame_newslot(opresult7908);
  params[0] = opresult7897;
  partcv[0] = 1;
  Object opresult7909 = callmethod(opresult7908, "++", 1, partcv, params);
// compiled op node returning opresult7909 (depth = 7)
  gc_frame_newslot(opresult7909);
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7910 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call7911 = callmethod(*var_parentNode, "line",
    1, partcv, params);
  gc_frame_end(callframe7910);
// compiled call node returning call7911 (depth = 8)
// compiled member node returning call7911 (depth = 7)
  gc_frame_newslot(call7911);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call7913 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7912);
// compiled call node returning call7913 (depth = 8)
// compiled member node returning call7913 (depth = 7)
  gc_frame_newslot(call7913);
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7915 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7916 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call7917 = callmethod(*var_parentNode, "statementName",
    1, partcv, params);
  gc_frame_end(callframe7916);
// compiled call node returning call7917 (depth = 11)
// compiled member node returning call7917 (depth = 10)
  partcv[0] = 0;
  Object call7918 = callmethod(call7917, "size",
    1, partcv, params);
  gc_frame_end(callframe7915);
// compiled call node returning call7918 (depth = 9)
// compiled member node returning call7918 (depth = 8)
  int op_slot_right_7914 = gc_frame_newslot(call7918);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  partcv[0] = 0;
  Object call7921 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7920);
// compiled call node returning call7921 (depth = 9)
// compiled member node returning call7921 (depth = 8)
  int op_slot_left_7914 = gc_frame_newslot(call7921);
  params[0] = call7918;
  partcv[0] = 1;
  Object sum7922 = callmethod(call7921, "+", 1, partcv, params);
// compiled op node returning sum7922 (depth = 7)
  gc_frame_newslot(sum7922);
// call case 6: other member request
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult7909;
  params[1] = call7911;
  params[2] = call7913;
  params[3] = sum7922;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7923 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe7888);
// compiled call node returning call7923 (depth = 6)
    gc_frame_newslot(call7923);
    if7854 = call7923;
  }
// compiled if node returning if7854 (depth = 5)
    gc_frame_newslot(if7854);
    if7844 = if7854;
  } else {
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7925 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7926 = alloc_Block(NULL, NULL, "parser", 2456);
  gc_frame_newslot(block7926);
// method "_apply"
  block_savedest(block7926);
  Object closure7927 = createclosure(1, "_apply");
  setclosureframe(closure7927, stackframe);
  addtoclosure(closure7927, selfslot);
  struct UserObject *uo7927 = (struct UserObject*)block7926;
  uo7927->data[0] = (Object)closure7927;
  Method *meth_meth_parser__apply7927 = addmethod2pos(block7926, "_apply", &meth_parser__apply7927, 0);
  int argcv_meth_parser__apply7927[] = {0};
  meth_meth_parser__apply7927->type = alloc_MethodType(1, argcv_meth_parser__apply7927);
  meth_meth_parser__apply7927->definitionModule = modulename;
  meth_meth_parser__apply7927->definitionLine = 2454;
// compiled block node returning block7926 (depth = 7)
  gc_frame_newslot(block7926);
// call case 4: self request
  params[0] = block7926;
  partcv[0] = 1;
  Object call7931 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7925);
// compiled call node returning call7931 (depth = 6)
  Object if7924 = done;
  if (istrue(call7931)) {
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7932 = alloc_Boolean(0);
// compiled identifier node returning bool7932 (depth = 7)
  *var_inPreamble = bool7932;
  if (bool7932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7934 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call7936 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7935);
// compiled call node returning call7936 (depth = 8)
// compiled member node returning call7936 (depth = 7)
  gc_frame_newslot(call7936);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = call7936;
  partcv[0] = 1;
  Object call7937 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe7934);
// compiled call node returning call7937 (depth = 6)
    gc_frame_newslot(call7937);
    if7924 = call7937;
  } else {
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7939 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7940 = alloc_Block(NULL, NULL, "parser", 2459);
  gc_frame_newslot(block7940);
// method "_apply"
  block_savedest(block7940);
  Object closure7941 = createclosure(1, "_apply");
  setclosureframe(closure7941, stackframe);
  addtoclosure(closure7941, selfslot);
  struct UserObject *uo7941 = (struct UserObject*)block7940;
  uo7941->data[0] = (Object)closure7941;
  Method *meth_meth_parser__apply7941 = addmethod2pos(block7940, "_apply", &meth_parser__apply7941, 0);
  int argcv_meth_parser__apply7941[] = {0};
  meth_meth_parser__apply7941->type = alloc_MethodType(1, argcv_meth_parser__apply7941);
  meth_meth_parser__apply7941->definitionModule = modulename;
  meth_meth_parser__apply7941->definitionLine = 2458;
// compiled block node returning block7940 (depth = 8)
  gc_frame_newslot(block7940);
// call case 4: self request
  params[0] = block7940;
  partcv[0] = 1;
  Object call7945 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7939);
// compiled call node returning call7945 (depth = 7)
  Object if7938 = done;
  if (istrue(call7945)) {
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool7946 = alloc_Boolean(0);
// compiled identifier node returning bool7946 (depth = 8)
  *var_inPreamble = bool7946;
  if (bool7946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7948 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7950 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7949);
// compiled call node returning call7950 (depth = 9)
// compiled member node returning call7950 (depth = 8)
  gc_frame_newslot(call7950);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call7950;
  partcv[0] = 1;
  Object call7951 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe7948);
// compiled call node returning call7951 (depth = 7)
    gc_frame_newslot(call7951);
    if7938 = call7951;
  } else {
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7952 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7955 == NULL) {
    strlit7955 = alloc_String("");
    gc_root(strlit7955);
  }
// compiled string node returning strlit7955 (depth = 10)
  int op_slot_right_7954 = gc_frame_newslot(strlit7955);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_constructName (depth = 11)
  int op_slot_right_7957 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 11)
  if (strlit7959 == NULL) {
    strlit7959 = alloc_String("of of ");
    gc_root(strlit7959);
  }
// compiled string node returning strlit7959 (depth = 11)
  int op_slot_left_7957 = gc_frame_newslot(strlit7959);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7960 = callmethod(strlit7959, "++", 1, partcv, params);
// compiled op node returning opresult7960 (depth = 10)
  int op_slot_left_7954 = gc_frame_newslot(opresult7960);
  params[0] = strlit7955;
  partcv[0] = 1;
  Object opresult7961 = callmethod(opresult7960, "++", 1, partcv, params);
// compiled op node returning opresult7961 (depth = 9)
  int op_slot_right_7953 = gc_frame_newslot(opresult7961);
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7964 == NULL) {
    strlit7964 = alloc_String("' in body ");
    gc_root(strlit7964);
  }
// compiled string node returning strlit7964 (depth = 10)
  int op_slot_right_7963 = gc_frame_newslot(strlit7964);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call7968 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7967);
// compiled call node returning call7968 (depth = 12)
// compiled member node returning call7968 (depth = 11)
  int op_slot_right_7966 = gc_frame_newslot(call7968);
// starting to compile string node (depth = 11)
  if (strlit7970 == NULL) {
    strlit7970 = alloc_String("unexpected symbol '");
    gc_root(strlit7970);
  }
// compiled string node returning strlit7970 (depth = 11)
  int op_slot_left_7966 = gc_frame_newslot(strlit7970);
  params[0] = call7968;
  partcv[0] = 1;
  Object opresult7971 = callmethod(strlit7970, "++", 1, partcv, params);
// compiled op node returning opresult7971 (depth = 10)
  int op_slot_left_7963 = gc_frame_newslot(opresult7971);
  params[0] = strlit7964;
  partcv[0] = 1;
  Object opresult7972 = callmethod(opresult7971, "++", 1, partcv, params);
// compiled op node returning opresult7972 (depth = 9)
  int op_slot_left_7953 = gc_frame_newslot(opresult7972);
  params[0] = opresult7961;
  partcv[0] = 1;
  Object opresult7973 = callmethod(opresult7972, "++", 1, partcv, params);
// compiled op node returning opresult7973 (depth = 8)
  gc_frame_newslot(opresult7973);
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7975 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7974);
// compiled call node returning call7975 (depth = 9)
// compiled member node returning call7975 (depth = 8)
  gc_frame_newslot(call7975);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7977 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7976);
// compiled call node returning call7977 (depth = 9)
// compiled member node returning call7977 (depth = 8)
  gc_frame_newslot(call7977);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7979 = alloc_Float64(1);
// compiled num node returning num7979 (depth = 9)
  int op_slot_right_7978 = gc_frame_newslot(num7979);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7982 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe7983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call7984 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7983);
// compiled call node returning call7984 (depth = 13)
// compiled member node returning call7984 (depth = 12)
  partcv[0] = 0;
  Object call7985 = callmethod(call7984, "size",
    1, partcv, params);
  gc_frame_end(callframe7982);
// compiled call node returning call7985 (depth = 11)
// compiled member node returning call7985 (depth = 10)
  int op_slot_right_7981 = gc_frame_newslot(call7985);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call7988 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7987);
// compiled call node returning call7988 (depth = 11)
// compiled member node returning call7988 (depth = 10)
  int op_slot_left_7981 = gc_frame_newslot(call7988);
  params[0] = call7985;
  partcv[0] = 1;
  Object sum7989 = callmethod(call7988, "+", 1, partcv, params);
// compiled op node returning sum7989 (depth = 9)
  int op_slot_left_7978 = gc_frame_newslot(sum7989);
  params[0] = num7979;
  partcv[0] = 1;
  Object diff7990 = callmethod(sum7989, "-", 1, partcv, params);
// compiled op node returning diff7990 (depth = 8)
  gc_frame_newslot(diff7990);
// call case 6: other member request
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7973;
  params[1] = call7975;
  params[2] = call7977;
  params[3] = diff7990;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7991 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe7952);
// compiled call node returning call7991 (depth = 7)
    gc_frame_newslot(call7991);
    if7938 = call7991;
  }
// compiled if node returning if7938 (depth = 6)
    gc_frame_newslot(if7938);
    if7924 = if7938;
  }
// compiled if node returning if7924 (depth = 5)
    gc_frame_newslot(if7924);
    if7844 = if7924;
  }
// compiled if node returning if7844 (depth = 4)
  gc_frame_end(frame);
  return if7844;
}
Object meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseObjectConstructorBody()startingWith()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody()startingWith()after");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody()startingWith()after");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody()startingWith()after");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseObjectConstructorBody()startingWith()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_constructName = &(stackframe->slots[0]);
  *var_constructName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parseObjectConstructorBody");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for startingWith");
  Object *var_prev = &(stackframe->slots[2]);
  *var_prev = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localMinIndentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "localMinIndentLevel");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_nextTok = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nextTok");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_superObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "superObject");
  Object *var_usedTraits = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "usedTraits");
  Object *var_inPreamble = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "inPreamble");
  Object *var_objNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "objNode");
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7733 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7734 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7733);
// compiled call node returning call7734 (depth = 4)
// compiled member node returning call7734 (depth = 3)
  *var_anns = call7734;
  if (call7734 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7737 == NULL) {
    strlit7737 = alloc_String("lbrace");
    gc_root(strlit7737);
  }
// compiled string node returning strlit7737 (depth = 4)
  int op_slot_right_7736 = gc_frame_newslot(strlit7737);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7740 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7739);
// compiled call node returning call7740 (depth = 5)
// compiled member node returning call7740 (depth = 4)
  int op_slot_left_7736 = gc_frame_newslot(call7740);
  params[0] = strlit7737;
  partcv[0] = 1;
  Object opresult7741 = callmethod(call7740, "!=", 1, partcv, params);
// compiled op node returning opresult7741 (depth = 3)
  Object if7735 = done;
  if (istrue(opresult7741)) {
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7742 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7743 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call7744 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7743);
// compiled call node returning call7744 (depth = 7)
// compiled member node returning call7744 (depth = 6)
  partcv[0] = 0;
  Object call7745 = callmethod(call7744, "new",
    1, partcv, params);
  gc_frame_end(callframe7742);
// compiled call node returning call7745 (depth = 5)
// compiled member node returning call7745 (depth = 4)
  *var_suggestion = call7745;
  if (call7745 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7746 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7747 = alloc_Block(NULL, NULL, "parser", 2416);
  gc_frame_newslot(block7747);
// method "_apply"
  block_savedest(block7747);
  Object closure7748 = createclosure(1, "_apply");
  setclosureframe(closure7748, stackframe);
  addtoclosure(closure7748, selfslot);
  struct UserObject *uo7748 = (struct UserObject*)block7747;
  uo7748->data[0] = (Object)closure7748;
  Method *meth_meth_parser__apply7748 = addmethod2pos(block7747, "_apply", &meth_parser__apply7748, 0);
  int argcv_meth_parser__apply7748[] = {1};
  meth_meth_parser__apply7748->type = alloc_MethodType(1, argcv_meth_parser__apply7748);
  meth_meth_parser__apply7748->definitionModule = modulename;
  meth_meth_parser__apply7748->definitionLine = 2415;
// compiled block node returning block7747 (depth = 5)
  gc_frame_newslot(block7747);
// call case 4: self request
  params[0] = block7747;
  partcv[0] = 1;
  Object call7756 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7746);
// compiled call node returning call7756 (depth = 4)
  *var_nextTok = call7756;
  if (call7756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7759 = alloc_Boolean(0);
// compiled identifier node returning bool7759 (depth = 5)
  int op_slot_right_7758 = gc_frame_newslot(bool7759);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_7758 = gc_frame_newslot(*var_nextTok);
  params[0] = bool7759;
  partcv[0] = 1;
  Object opresult7761 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7761 (depth = 4)
  Object if7757 = done;
  if (istrue(opresult7761)) {
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7762 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7763 == NULL) {
    strlit7763 = alloc_String(" {}");
    gc_root(strlit7763);
  }
// compiled string node returning strlit7763 (depth = 5)
  gc_frame_newslot(strlit7763);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7763;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7764 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7762);
// compiled call node returning call7764 (depth = 4)
    gc_frame_newslot(call7764);
    if7757 = call7764;
  } else {
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7765 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7766 == NULL) {
    strlit7766 = alloc_String(" {");
    gc_root(strlit7766);
  }
// compiled string node returning strlit7766 (depth = 5)
  gc_frame_newslot(strlit7766);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7766;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7767 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7765);
// compiled call node returning call7767 (depth = 4)
    gc_frame_newslot(call7767);
    if7757 = call7767;
  }
// compiled if node returning if7757 (depth = 3)
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7768 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7770 == NULL) {
    strlit7770 = alloc_String(".");
    gc_root(strlit7770);
  }
// compiled string node returning strlit7770 (depth = 5)
  int op_slot_right_7769 = gc_frame_newslot(strlit7770);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_prev (depth = 6)
  int op_slot_right_7772 = gc_frame_newslot(*var_prev);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7775 == NULL) {
    strlit7775 = alloc_String(" must have a '{' after the ");
    gc_root(strlit7775);
  }
// compiled string node returning strlit7775 (depth = 7)
  int op_slot_right_7774 = gc_frame_newslot(strlit7775);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_constructName (depth = 8)
  int op_slot_right_7777 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 8)
  if (strlit7779 == NULL) {
    strlit7779 = alloc_String("");
    gc_root(strlit7779);
  }
// compiled string node returning strlit7779 (depth = 8)
  int op_slot_left_7777 = gc_frame_newslot(strlit7779);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7780 = callmethod(strlit7779, "++", 1, partcv, params);
// compiled op node returning opresult7780 (depth = 7)
  int op_slot_left_7774 = gc_frame_newslot(opresult7780);
  params[0] = strlit7775;
  partcv[0] = 1;
  Object opresult7781 = callmethod(opresult7780, "++", 1, partcv, params);
// compiled op node returning opresult7781 (depth = 6)
  int op_slot_left_7772 = gc_frame_newslot(opresult7781);
  params[0] = *var_prev;
  partcv[0] = 1;
  Object opresult7782 = callmethod(opresult7781, "++", 1, partcv, params);
// compiled op node returning opresult7782 (depth = 5)
  int op_slot_left_7769 = gc_frame_newslot(opresult7782);
  params[0] = strlit7770;
  partcv[0] = 1;
  Object opresult7783 = callmethod(opresult7782, "++", 1, partcv, params);
// compiled op node returning opresult7783 (depth = 4)
  gc_frame_newslot(opresult7783);
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7785 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7784);
// compiled call node returning call7785 (depth = 5)
// compiled member node returning call7785 (depth = 4)
  gc_frame_newslot(call7785);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7788 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7787);
// compiled call node returning call7788 (depth = 6)
// compiled member node returning call7788 (depth = 5)
  int op_slot_right_7786 = gc_frame_newslot(call7788);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7791 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7790);
// compiled call node returning call7791 (depth = 6)
// compiled member node returning call7791 (depth = 5)
  int op_slot_left_7786 = gc_frame_newslot(call7791);
  params[0] = call7788;
  partcv[0] = 1;
  Object sum7792 = callmethod(call7791, "+", 1, partcv, params);
// compiled op node returning sum7792 (depth = 4)
  gc_frame_newslot(sum7792);
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7783;
  params[1] = call7785;
  params[2] = sum7792;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7793 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7768);
// compiled call node returning call7793 (depth = 3)
    gc_frame_newslot(call7793);
    if7735 = call7793;
  } else {
  }
// compiled if node returning if7735 (depth = 2)
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7795 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7794);
// compiled call node returning call7795 (depth = 3)
// compiled member node returning call7795 (depth = 2)
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  partcv[0] = 0;
  Object call7799 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7798);
// compiled call node returning call7799 (depth = 5)
// compiled member node returning call7799 (depth = 4)
  int op_slot_right_7797 = gc_frame_newslot(call7799);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7802 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7801);
// compiled call node returning call7802 (depth = 5)
// compiled member node returning call7802 (depth = 4)
  int op_slot_left_7797 = gc_frame_newslot(call7802);
  params[0] = call7799;
  partcv[0] = 1;
  Object opresult7803 = callmethod(call7802, "==", 1, partcv, params);
// compiled op node returning opresult7803 (depth = 3)
  Object if7796 = done;
  if (istrue(opresult7803)) {
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7805 = alloc_Float64(2);
// compiled num node returning num7805 (depth = 5)
  int op_slot_right_7804 = gc_frame_newslot(num7805);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7808 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7807);
// compiled call node returning call7808 (depth = 6)
// compiled member node returning call7808 (depth = 5)
  int op_slot_left_7804 = gc_frame_newslot(call7808);
  params[0] = num7805;
  partcv[0] = 1;
  Object diff7809 = callmethod(call7808, "-", 1, partcv, params);
// compiled op node returning diff7809 (depth = 4)
  *var_minIndentLevel = diff7809;
  if (diff7809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7796 = done;
  } else {
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7812 = alloc_Float64(2);
// compiled num node returning num7812 (depth = 5)
  int op_slot_right_7811 = gc_frame_newslot(num7812);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call7815 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe7814);
// compiled call node returning call7815 (depth = 6)
// compiled member node returning call7815 (depth = 5)
  int op_slot_left_7811 = gc_frame_newslot(call7815);
  params[0] = num7812;
  partcv[0] = 1;
  Object sum7816 = callmethod(call7815, "+", 1, partcv, params);
// compiled op node returning sum7816 (depth = 4)
  *var_minIndentLevel = sum7816;
  if (sum7816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7796 = done;
  }
// compiled if node returning if7796 (depth = 2)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7818 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7818 (depth = 3)
  *var_body = array7818;
  if (array7818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7819 = alloc_Boolean(0);
// compiled identifier node returning bool7819 (depth = 3)
  *var_superObject = bool7819;
  if (bool7819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7820 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7820 (depth = 3)
  *var_usedTraits = array7820;
  if (array7820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7821 = alloc_Boolean(1);
// compiled identifier node returning bool7821 (depth = 3)
  *var_inPreamble = bool7821;
  if (bool7821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7822 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7823 = alloc_Block(NULL, NULL, "parser", 2436);
  gc_frame_newslot(block7823);
// method "_apply"
  block_savedest(block7823);
  Object closure7824 = createclosure(2, "_apply");
  setclosureframe(closure7824, stackframe);
  addtoclosure(closure7824, var_sym);
  addtoclosure(closure7824, selfslot);
  struct UserObject *uo7824 = (struct UserObject*)block7823;
  uo7824->data[0] = (Object)closure7824;
  Method *meth_meth_parser__apply7824 = addmethod2pos(block7823, "_apply", &meth_parser__apply7824, 0);
  int argcv_meth_parser__apply7824[] = {0};
  meth_meth_parser__apply7824->type = alloc_MethodType(1, argcv_meth_parser__apply7824);
  meth_meth_parser__apply7824->definitionModule = modulename;
  meth_meth_parser__apply7824->definitionLine = 2430;
// compiled block node returning block7823 (depth = 3)
  gc_frame_newslot(block7823);
// starting to compile block node (depth = 3)
  Object block7842 = alloc_Block(NULL, NULL, "parser", 2436);
  gc_frame_newslot(block7842);
// method "_apply"
  block_savedest(block7842);
  Object closure7843 = createclosure(9, "_apply");
  setclosureframe(closure7843, stackframe);
  addtoclosure(closure7843, var_values);
  addtoclosure(closure7843, var_inPreamble);
  addtoclosure(closure7843, var_usedTraits);
  addtoclosure(closure7843, var_superObject);
  addtoclosure(closure7843, var_constructName);
  addtoclosure(closure7843, var_errormessages);
  addtoclosure(closure7843, var_body);
  addtoclosure(closure7843, var_sym);
  addtoclosure(closure7843, selfslot);
  struct UserObject *uo7843 = (struct UserObject*)block7842;
  uo7843->data[0] = (Object)closure7843;
  Method *meth_meth_parser__apply7843 = addmethod2pos(block7842, "_apply", &meth_parser__apply7843, 0);
  int argcv_meth_parser__apply7843[] = {0};
  meth_meth_parser__apply7843->type = alloc_MethodType(1, argcv_meth_parser__apply7843);
  meth_meth_parser__apply7843->definitionModule = modulename;
  meth_meth_parser__apply7843->definitionLine = 2436;
// compiled block node returning block7842 (depth = 3)
  gc_frame_newslot(block7842);
// call case 5: prelude request
  params[0] = block7823;
  params[1] = block7842;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7993 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7822);
// compiled call node returning call7993 (depth = 2)
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7995 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7994);
// compiled call node returning call7995 (depth = 3)
// compiled member node returning call7995 (depth = 2)
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7996 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7998 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe7997);
// compiled call node returning call7998 (depth = 4)
// compiled member node returning call7998 (depth = 3)
  gc_frame_newslot(call7998);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call8000 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7999);
// compiled call node returning call8000 (depth = 4)
// compiled member node returning call8000 (depth = 3)
  gc_frame_newslot(call8000);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call7998;
  params[1] = call8000;
  partcv[0] = 2;
  Object call8001 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7996);
// compiled call node returning call8001 (depth = 2)
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8002 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superObject (depth = 4)
  gc_frame_newslot(*var_superObject);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8004 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8003);
// compiled call node returning call8004 (depth = 5)
// compiled member node returning call8004 (depth = 4)
  params[0] = *var_body;
  params[1] = *var_superObject;
  partcv[0] = 2;
  Object call8005 = callmethod(call8004, "new",
    1, partcv, params);
  gc_frame_end(callframe8002);
// compiled call node returning call8005 (depth = 3)
  *var_objNode = call8005;
  if (call8005 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8008 = alloc_Boolean(0);
// compiled identifier node returning bool8008 (depth = 4)
  int op_slot_right_8007 = gc_frame_newslot(bool8008);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  int op_slot_left_8007 = gc_frame_newslot(*var_anns);
  params[0] = bool8008;
  partcv[0] = 1;
  Object opresult8010 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult8010 (depth = 3)
  Object if8006 = done;
  if (istrue(opresult8010)) {
// starting to compile call node (depth = 3)
  int callframe8011 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  partcv[0] = 0;
  Object call8013 = callmethod(*var_objNode, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8012);
// compiled call node returning call8013 (depth = 5)
// compiled member node returning call8013 (depth = 4)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8014 = callmethod(call8013, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8011);
// compiled call node returning call8014 (depth = 3)
    gc_frame_newslot(call8014);
    if8006 = call8014;
  } else {
  }
// compiled if node returning if8006 (depth = 2)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8015 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_usedTraits (depth = 3)
  gc_frame_newslot(*var_usedTraits);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  params[0] = *var_usedTraits;
  partcv[0] = 1;
  Object call8016 = callmethod(*var_objNode, "usedTraits:=",
    1, partcv, params);
  gc_frame_end(callframe8015);
// compiled call node returning call8016 (depth = 2)
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8017 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  gc_frame_newslot(*var_objNode);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_objNode;
  partcv[0] = 1;
  Object call8018 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8017);
// compiled call node returning call8018 (depth = 2)
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_doclass8020(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doclass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doclass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_objName = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "objName");
  Object *var_s = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "s");
  Object *var_csig = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "csig");
  Object *var_methodName = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "methodName");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_objNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "objNode");
  Object *var_meth = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "meth");
  Object *var_asStringBody = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "asStringBody");
  Object *var_asStringMeth = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "asStringMeth");
  Object *var_metaBody = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "metaBody");
  Object *var_metaObj = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "metaObj");
  Object *var_defDec = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "defDec");
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8022 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8021);
// compiled call node returning call8022 (depth = 3)
// compiled member node returning call8022 (depth = 2)
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8025 == NULL) {
    strlit8025 = alloc_String("identifier");
    gc_root(strlit8025);
  }
// compiled string node returning strlit8025 (depth = 4)
  int op_slot_right_8024 = gc_frame_newslot(strlit8025);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8027 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8028 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8027);
// compiled call node returning call8028 (depth = 5)
// compiled member node returning call8028 (depth = 4)
  int op_slot_left_8024 = gc_frame_newslot(call8028);
  params[0] = strlit8025;
  partcv[0] = 1;
  Object opresult8029 = callmethod(call8028, "!=", 1, partcv, params);
// compiled op node returning opresult8029 (depth = 3)
  Object if8023 = done;
  if (istrue(opresult8029)) {
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8030 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8031 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8032 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8031);
// compiled call node returning call8032 (depth = 7)
// compiled member node returning call8032 (depth = 6)
  partcv[0] = 0;
  Object call8033 = callmethod(call8032, "empty",
    1, partcv, params);
  gc_frame_end(callframe8030);
// compiled call node returning call8033 (depth = 5)
// compiled member node returning call8033 (depth = 4)
  *var_suggestions = call8033;
  if (call8033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8036 == NULL) {
    strlit8036 = alloc_String("lbrace");
    gc_root(strlit8036);
  }
// compiled string node returning strlit8036 (depth = 5)
  int op_slot_right_8035 = gc_frame_newslot(strlit8036);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8039 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8038);
// compiled call node returning call8039 (depth = 6)
// compiled member node returning call8039 (depth = 5)
  int op_slot_left_8035 = gc_frame_newslot(call8039);
  params[0] = strlit8036;
  partcv[0] = 1;
  Object opresult8040 = callmethod(call8039, "==", 1, partcv, params);
// compiled op node returning opresult8040 (depth = 4)
  Object if8034 = done;
  if (istrue(opresult8040)) {
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8041 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8043 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8042);
// compiled call node returning call8043 (depth = 8)
// compiled member node returning call8043 (depth = 7)
  partcv[0] = 0;
  Object call8044 = callmethod(call8043, "new",
    1, partcv, params);
  gc_frame_end(callframe8041);
// compiled call node returning call8044 (depth = 6)
// compiled member node returning call8044 (depth = 5)
  *var_suggestion = call8044;
  if (call8044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8045 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8046 == NULL) {
    strlit8046 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit8046);
  }
// compiled string node returning strlit8046 (depth = 5)
  gc_frame_newslot(strlit8046);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8046;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8047 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8045);
// compiled call node returning call8047 (depth = 4)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8048 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8049 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8048);
// compiled call node returning call8049 (depth = 4)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8050 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8052 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8051);
// compiled call node returning call8052 (depth = 8)
// compiled member node returning call8052 (depth = 7)
  partcv[0] = 0;
  Object call8053 = callmethod(call8052, "new",
    1, partcv, params);
  gc_frame_end(callframe8050);
// compiled call node returning call8053 (depth = 6)
// compiled member node returning call8053 (depth = 5)
  *var_suggestion = call8053;
  if (call8053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8055 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 5)
  if (strlit8056 == NULL) {
    strlit8056 = alloc_String("object");
    gc_root(strlit8056);
  }
// compiled string node returning strlit8056 (depth = 5)
  gc_frame_newslot(strlit8056);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = strlit8056;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8057 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8055);
// compiled call node returning call8057 (depth = 4)
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8058 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8059 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8058);
// compiled call node returning call8059 (depth = 4)
    gc_frame_newslot(call8059);
    if8034 = call8059;
  } else {
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8060 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8061 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8062 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8061);
// compiled call node returning call8062 (depth = 8)
// compiled member node returning call8062 (depth = 7)
  partcv[0] = 0;
  Object call8063 = callmethod(call8062, "new",
    1, partcv, params);
  gc_frame_end(callframe8060);
// compiled call node returning call8063 (depth = 6)
// compiled member node returning call8063 (depth = 5)
  *var_suggestion = call8063;
  if (call8063 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8064 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8065 == NULL) {
    strlit8065 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit8065);
  }
// compiled string node returning strlit8065 (depth = 5)
  gc_frame_newslot(strlit8065);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8065;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8066 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8064);
// compiled call node returning call8066 (depth = 4)
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8067 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8068 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8067);
// compiled call node returning call8068 (depth = 4)
    gc_frame_newslot(call8068);
    if8034 = call8068;
  }
// compiled if node returning if8034 (depth = 3)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8069 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8070 == NULL) {
    strlit8070 = alloc_String("a class must have a name after the 'class'.");
    gc_root(strlit8070);
  }
// compiled string node returning strlit8070 (depth = 4)
  gc_frame_newslot(strlit8070);
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8072 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8071);
// compiled call node returning call8072 (depth = 5)
// compiled member node returning call8072 (depth = 4)
  gc_frame_newslot(call8072);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8074 = alloc_Float64(1);
// compiled num node returning num8074 (depth = 5)
  int op_slot_right_8073 = gc_frame_newslot(num8074);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8077 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8078 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8077);
// compiled call node returning call8078 (depth = 7)
// compiled member node returning call8078 (depth = 6)
  int op_slot_right_8076 = gc_frame_newslot(call8078);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8081 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8080);
// compiled call node returning call8081 (depth = 7)
// compiled member node returning call8081 (depth = 6)
  int op_slot_left_8076 = gc_frame_newslot(call8081);
  params[0] = call8078;
  partcv[0] = 1;
  Object sum8082 = callmethod(call8081, "+", 1, partcv, params);
// compiled op node returning sum8082 (depth = 5)
  int op_slot_left_8073 = gc_frame_newslot(sum8082);
  params[0] = num8074;
  partcv[0] = 1;
  Object sum8083 = callmethod(sum8082, "+", 1, partcv, params);
// compiled op node returning sum8083 (depth = 4)
  gc_frame_newslot(sum8083);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8070;
  params[1] = call8072;
  params[2] = sum8083;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8084 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8069);
// compiled call node returning call8084 (depth = 3)
    gc_frame_newslot(call8084);
    if8023 = call8084;
  } else {
  }
// compiled if node returning if8023 (depth = 2)
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool8085 = alloc_Boolean(0);
// compiled identifier node returning bool8085 (depth = 3)
  *var_objName = bool8085;
  if (bool8085 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8088 == NULL) {
    strlit8088 = alloc_String("dot");
    gc_root(strlit8088);
  }
// compiled string node returning strlit8088 (depth = 4)
  int op_slot_right_8087 = gc_frame_newslot(strlit8088);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8090 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call8092 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8091);
// compiled call node returning call8092 (depth = 7)
// compiled member node returning call8092 (depth = 6)
  partcv[0] = 0;
  Object call8093 = callmethod(call8092, "kind",
    1, partcv, params);
  gc_frame_end(callframe8090);
// compiled call node returning call8093 (depth = 5)
// compiled member node returning call8093 (depth = 4)
  int op_slot_left_8087 = gc_frame_newslot(call8093);
  params[0] = strlit8088;
  partcv[0] = 1;
  Object opresult8094 = callmethod(call8093, "==", 1, partcv, params);
// compiled op node returning opresult8094 (depth = 3)
  Object if8086 = done;
  if (istrue(opresult8094)) {
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8096 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8095);
// compiled call node returning call8096 (depth = 4)
// compiled member node returning call8096 (depth = 3)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8098 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8097);
// compiled call node returning call8098 (depth = 5)
// compiled member node returning call8098 (depth = 4)
  *var_objName = call8098;
  if (call8098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8100 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8101 = alloc_Boolean(1);
// compiled identifier node returning bool8101 (depth = 4)
  gc_frame_newslot(bool8101);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  params[0] = bool8101;
  partcv[0] = 1;
  Object call8102 = callmethod(*var_objName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8100);
// compiled call node returning call8102 (depth = 3)
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8103 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8104 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8103);
// compiled call node returning call8104 (depth = 4)
// compiled member node returning call8104 (depth = 3)
    gc_frame_newslot(call8104);
    if8086 = call8104;
  } else {
  }
// compiled if node returning if8086 (depth = 2)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8106 = alloc_Boolean(0);
// compiled identifier node returning bool8106 (depth = 4)
  gc_frame_newslot(bool8106);
// call case 4: self request
  params[0] = bool8106;
  partcv[0] = 1;
  Object call8107 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8105);
// compiled call node returning call8107 (depth = 3)
  *var_s = call8107;
  if (call8107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call8109 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8108);
// compiled call node returning call8109 (depth = 4)
// compiled member node returning call8109 (depth = 3)
  *var_csig = call8109;
  if (call8109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call8111 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8110);
// compiled call node returning call8111 (depth = 4)
// compiled member node returning call8111 (depth = 3)
  *var_methodName = call8111;
  if (call8111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8112 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8113 = alloc_Boolean(1);
// compiled identifier node returning bool8113 (depth = 3)
  gc_frame_newslot(bool8113);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodName (depth = 3)
  params[0] = bool8113;
  partcv[0] = 1;
  Object call8114 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8112);
// compiled call node returning call8114 (depth = 2)
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call8116 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8115);
// compiled call node returning call8116 (depth = 4)
// compiled member node returning call8116 (depth = 3)
  *var_dtype = call8116;
  if (call8116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8117 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit8118 == NULL) {
    strlit8118 = alloc_String("a class");
    gc_root(strlit8118);
  }
// compiled string node returning strlit8118 (depth = 3)
  gc_frame_newslot(strlit8118);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 3)
  if (strlit8119 == NULL) {
    strlit8119 = alloc_String("method header");
    gc_root(strlit8119);
  }
// compiled string node returning strlit8119 (depth = 3)
  gc_frame_newslot(strlit8119);
// call case 4: self request
  params[0] = strlit8118;
  params[1] = *var_btok;
  params[2] = strlit8119;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8120 = callmethodflags(self, "parseObjectConstructorBody()startingWith()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8117);
// compiled call node returning call8120 (depth = 2)
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8122 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8121);
// compiled call node returning call8122 (depth = 4)
// compiled member node returning call8122 (depth = 3)
  *var_objNode = call8122;
  if (call8122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8123 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call8125 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8124);
// compiled call node returning call8125 (depth = 4)
// compiled member node returning call8125 (depth = 3)
  gc_frame_newslot(call8125);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call8127 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8126);
// compiled call node returning call8127 (depth = 4)
// compiled member node returning call8127 (depth = 3)
  gc_frame_newslot(call8127);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call8125;
  params[1] = call8127;
  partcv[0] = 2;
  Object call8128 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe8123);
// compiled call node returning call8128 (depth = 2)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8129 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodName (depth = 4)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_csig (depth = 4)
  gc_frame_newslot(*var_csig);
// starting to compile array node (depth = 4)
  Object array8130 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethod(array8130, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array8130 (depth = 4)
  gc_frame_newslot(array8130);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8132 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8131);
// compiled call node returning call8132 (depth = 5)
// compiled member node returning call8132 (depth = 4)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = array8130;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8133 = callmethod(call8132, "new",
    1, partcv, params);
  gc_frame_end(callframe8129);
// compiled call node returning call8133 (depth = 3)
  *var_meth = call8133;
  if (call8133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8134 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8135 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call8136 = callmethod(*var_s, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe8135);
// compiled call node returning call8136 (depth = 4)
// compiled member node returning call8136 (depth = 3)
  gc_frame_newslot(call8136);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = call8136;
  partcv[0] = 1;
  Object call8137 = callmethod(*var_meth, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe8134);
// compiled call node returning call8137 (depth = 2)
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8138 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8139 = alloc_Boolean(1);
// compiled identifier node returning bool8139 (depth = 3)
  gc_frame_newslot(bool8139);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool8139;
  partcv[0] = 1;
  Object call8140 = callmethod(*var_meth, "usesClassSyntax:=",
    1, partcv, params);
  gc_frame_end(callframe8138);
// compiled call node returning call8140 (depth = 2)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8141 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  partcv[0] = 0;
  Object call8143 = callmethod(*var_objNode, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8142);
// compiled call node returning call8143 (depth = 4)
// compiled member node returning call8143 (depth = 3)
  gc_frame_newslot(call8143);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8144 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call8145 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8144);
// compiled call node returning call8145 (depth = 4)
// compiled member node returning call8145 (depth = 3)
  params[0] = call8143;
  partcv[0] = 1;
  Object call8146 = callmethod(call8145, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8141);
// compiled call node returning call8146 (depth = 2)
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  int op_slot_right_8148 = gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 4)
  Object bool8150 = alloc_Boolean(0);
// compiled identifier node returning bool8150 (depth = 4)
  int op_slot_left_8148 = gc_frame_newslot(bool8150);
  params[0] = *var_objName;
  partcv[0] = 1;
  Object opresult8151 = callmethod(bool8150, "!=", 1, partcv, params);
// compiled op node returning opresult8151 (depth = 3)
  Object if8147 = done;
  if (istrue(opresult8151)) {
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8152 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_methodName (depth = 7)
  partcv[0] = 0;
  Object call8155 = callmethod(*var_methodName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8154);
// compiled call node returning call8155 (depth = 6)
// compiled member node returning call8155 (depth = 5)
  int op_slot_right_8153 = gc_frame_newslot(call8155);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8158 == NULL) {
    strlit8158 = alloc_String(".");
    gc_root(strlit8158);
  }
// compiled string node returning strlit8158 (depth = 6)
  int op_slot_right_8157 = gc_frame_newslot(strlit8158);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_objName (depth = 8)
  partcv[0] = 0;
  Object call8161 = callmethod(*var_objName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8160);
// compiled call node returning call8161 (depth = 7)
// compiled member node returning call8161 (depth = 6)
  int op_slot_left_8157 = gc_frame_newslot(call8161);
  params[0] = strlit8158;
  partcv[0] = 1;
  Object opresult8162 = callmethod(call8161, "++", 1, partcv, params);
// compiled op node returning opresult8162 (depth = 5)
  int op_slot_left_8153 = gc_frame_newslot(opresult8162);
  params[0] = call8155;
  partcv[0] = 1;
  Object opresult8163 = callmethod(opresult8162, "++", 1, partcv, params);
// compiled op node returning opresult8163 (depth = 4)
  gc_frame_newslot(opresult8163);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = opresult8163;
  partcv[0] = 1;
  Object call8164 = callmethod(*var_objNode, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8152);
// compiled call node returning call8164 (depth = 3)
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8165 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe8166 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8168 == NULL) {
    strlit8168 = alloc_String("");
    gc_root(strlit8168);
  }
// compiled string node returning strlit8168 (depth = 7)
  int op_slot_right_8167 = gc_frame_newslot(strlit8168);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_objName (depth = 10)
  partcv[0] = 0;
  Object call8172 = callmethod(*var_objName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8171);
// compiled call node returning call8172 (depth = 9)
// compiled member node returning call8172 (depth = 8)
  int op_slot_right_8170 = gc_frame_newslot(call8172);
// starting to compile string node (depth = 8)
  if (strlit8174 == NULL) {
    strlit8174 = alloc_String("class ");
    gc_root(strlit8174);
  }
// compiled string node returning strlit8174 (depth = 8)
  int op_slot_left_8170 = gc_frame_newslot(strlit8174);
  params[0] = call8172;
  partcv[0] = 1;
  Object opresult8175 = callmethod(strlit8174, "++", 1, partcv, params);
// compiled op node returning opresult8175 (depth = 7)
  int op_slot_left_8167 = gc_frame_newslot(opresult8175);
  params[0] = strlit8168;
  partcv[0] = 1;
  Object opresult8176 = callmethod(opresult8175, "++", 1, partcv, params);
// compiled op node returning opresult8176 (depth = 6)
  gc_frame_newslot(opresult8176);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8178 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe8177);
// compiled call node returning call8178 (depth = 7)
// compiled member node returning call8178 (depth = 6)
  params[0] = opresult8176;
  partcv[0] = 1;
  Object call8179 = callmethod(call8178, "new",
    1, partcv, params);
  gc_frame_end(callframe8166);
// compiled call node returning call8179 (depth = 5)
  params[0] = call8179;
  partcv[0] = 1;
  callmethod(array8165, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array8165 (depth = 4)
  *var_asStringBody = array8165;
  if (array8165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8180 = gc_frame_new();
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8181 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8182 == NULL) {
    strlit8182 = alloc_String("asString");
    gc_root(strlit8182);
  }
// compiled string node returning strlit8182 (depth = 6)
  gc_frame_newslot(strlit8182);
// starting to compile identifier node (depth = 6)
  Object bool8183 = alloc_Boolean(0);
// compiled identifier node returning bool8183 (depth = 6)
  gc_frame_newslot(bool8183);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8185 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8184);
// compiled call node returning call8185 (depth = 7)
// compiled member node returning call8185 (depth = 6)
  params[0] = strlit8182;
  params[1] = bool8183;
  partcv[0] = 2;
  Object call8186 = callmethod(call8185, "new",
    1, partcv, params);
  gc_frame_end(callframe8181);
// compiled call node returning call8186 (depth = 5)
  gc_frame_newslot(call8186);
// starting to compile array node (depth = 5)
  Object array8187 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8187 (depth = 5)
  gc_frame_newslot(array8187);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringBody (depth = 5)
  gc_frame_newslot(*var_asStringBody);
// starting to compile identifier node (depth = 5)
  Object bool8188 = alloc_Boolean(0);
// compiled identifier node returning bool8188 (depth = 5)
  gc_frame_newslot(bool8188);
// call case 6: other member request
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8189 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8190 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8189);
// compiled call node returning call8190 (depth = 6)
// compiled member node returning call8190 (depth = 5)
  params[0] = call8186;
  params[1] = array8187;
  params[2] = *var_asStringBody;
  params[3] = bool8188;
  partcv[0] = 4;
  Object call8191 = callmethod(call8190, "new",
    1, partcv, params);
  gc_frame_end(callframe8180);
// compiled call node returning call8191 (depth = 4)
  *var_asStringMeth = call8191;
  if (call8191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8192 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  callmethod(array8192, "push", 1, partcv, params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringMeth (depth = 5)
  params[0] = *var_asStringMeth;
  partcv[0] = 1;
  callmethod(array8192, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array8192 (depth = 4)
  *var_metaBody = array8192;
  if (array8192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8193 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaBody (depth = 5)
  gc_frame_newslot(*var_metaBody);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8195 == NULL) {
    strlit8195 = alloc_String("");
    gc_root(strlit8195);
  }
// compiled string node returning strlit8195 (depth = 6)
  int op_slot_right_8194 = gc_frame_newslot(strlit8195);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_objName (depth = 9)
  partcv[0] = 0;
  Object call8199 = callmethod(*var_objName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8198);
// compiled call node returning call8199 (depth = 8)
// compiled member node returning call8199 (depth = 7)
  int op_slot_right_8197 = gc_frame_newslot(call8199);
// starting to compile string node (depth = 7)
  if (strlit8201 == NULL) {
    strlit8201 = alloc_String("class ");
    gc_root(strlit8201);
  }
// compiled string node returning strlit8201 (depth = 7)
  int op_slot_left_8197 = gc_frame_newslot(strlit8201);
  params[0] = call8199;
  partcv[0] = 1;
  Object opresult8202 = callmethod(strlit8201, "++", 1, partcv, params);
// compiled op node returning opresult8202 (depth = 6)
  int op_slot_left_8194 = gc_frame_newslot(opresult8202);
  params[0] = strlit8195;
  partcv[0] = 1;
  Object opresult8203 = callmethod(opresult8202, "++", 1, partcv, params);
// compiled op node returning opresult8203 (depth = 5)
  gc_frame_newslot(opresult8203);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8205 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8204);
// compiled call node returning call8205 (depth = 6)
// compiled member node returning call8205 (depth = 5)
  params[0] = *var_metaBody;
  params[1] = opresult8203;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8206 = callmethod(call8205, "body()named",
    2, partcv, params);
  gc_frame_end(callframe8193);
// compiled call node returning call8206 (depth = 4)
  *var_metaObj = call8206;
  if (call8206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8207 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objName (depth = 5)
  gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaObj (depth = 5)
  gc_frame_newslot(*var_metaObj);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8209 = callmethod(*var_ast, "unknownType",
    1, partcv, params);
  gc_frame_end(callframe8208);
// compiled call node returning call8209 (depth = 6)
// compiled member node returning call8209 (depth = 5)
  gc_frame_newslot(call8209);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8211 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe8210);
// compiled call node returning call8211 (depth = 6)
// compiled member node returning call8211 (depth = 5)
  params[0] = *var_objName;
  params[1] = *var_metaObj;
  params[2] = call8209;
  partcv[0] = 3;
  Object call8212 = callmethod(call8211, "new",
    1, partcv, params);
  gc_frame_end(callframe8207);
// compiled call node returning call8212 (depth = 4)
  *var_defDec = call8212;
  if (call8212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8213 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call8214 = callmethod(*var_defDec, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe8213);
// compiled call node returning call8214 (depth = 3)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8215 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8216 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8217 == NULL) {
    strlit8217 = alloc_String("public");
    gc_root(strlit8217);
  }
// compiled string node returning strlit8217 (depth = 5)
  gc_frame_newslot(strlit8217);
// starting to compile identifier node (depth = 5)
  Object bool8218 = alloc_Boolean(0);
// compiled identifier node returning bool8218 (depth = 5)
  gc_frame_newslot(bool8218);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8220 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8219);
// compiled call node returning call8220 (depth = 6)
// compiled member node returning call8220 (depth = 5)
  params[0] = strlit8217;
  params[1] = bool8218;
  partcv[0] = 2;
  Object call8221 = callmethod(call8220, "new",
    1, partcv, params);
  gc_frame_end(callframe8216);
// compiled call node returning call8221 (depth = 4)
  gc_frame_newslot(call8221);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defDec (depth = 6)
  partcv[0] = 0;
  Object call8223 = callmethod(*var_defDec, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8222);
// compiled call node returning call8223 (depth = 5)
// compiled member node returning call8223 (depth = 4)
  params[0] = call8221;
  partcv[0] = 1;
  Object call8224 = callmethod(call8223, "add",
    1, partcv, params);
  gc_frame_end(callframe8215);
// compiled call node returning call8224 (depth = 3)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8225 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  gc_frame_newslot(*var_defDec);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_defDec;
  partcv[0] = 1;
  Object call8226 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8225);
// compiled call node returning call8226 (depth = 3)
    gc_frame_newslot(call8226);
    if8147 = call8226;
  } else {
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8227 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodName (depth = 6)
  partcv[0] = 0;
  Object call8229 = callmethod(*var_methodName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8228);
// compiled call node returning call8229 (depth = 5)
// compiled member node returning call8229 (depth = 4)
  gc_frame_newslot(call8229);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = call8229;
  partcv[0] = 1;
  Object call8230 = callmethod(*var_objNode, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8227);
// compiled call node returning call8230 (depth = 3)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8233 == NULL) {
    strlit8233 = alloc_String("class");
    gc_root(strlit8233);
  }
// compiled string node returning strlit8233 (depth = 5)
  int op_slot_right_8232 = gc_frame_newslot(strlit8233);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call8236 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe8235);
// compiled call node returning call8236 (depth = 6)
// compiled member node returning call8236 (depth = 5)
  int op_slot_left_8232 = gc_frame_newslot(call8236);
  params[0] = strlit8233;
  partcv[0] = 1;
  Object opresult8237 = callmethod(call8236, "==", 1, partcv, params);
// compiled op node returning opresult8237 (depth = 4)
  Object if8231 = done;
  if (istrue(opresult8237)) {
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8238 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8239 = alloc_Boolean(1);
// compiled identifier node returning bool8239 (depth = 5)
  gc_frame_newslot(bool8239);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = bool8239;
  partcv[0] = 1;
  Object call8240 = callmethod(*var_objNode, "inClass:=",
    1, partcv, params);
  gc_frame_end(callframe8238);
// compiled call node returning call8240 (depth = 4)
    gc_frame_newslot(call8240);
    if8231 = call8240;
  } else {
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8243 == NULL) {
    strlit8243 = alloc_String("trait");
    gc_root(strlit8243);
  }
// compiled string node returning strlit8243 (depth = 6)
  int op_slot_right_8242 = gc_frame_newslot(strlit8243);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  partcv[0] = 0;
  Object call8246 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe8245);
// compiled call node returning call8246 (depth = 7)
// compiled member node returning call8246 (depth = 6)
  int op_slot_left_8242 = gc_frame_newslot(call8246);
  params[0] = strlit8243;
  partcv[0] = 1;
  Object opresult8247 = callmethod(call8246, "==", 1, partcv, params);
// compiled op node returning opresult8247 (depth = 5)
  Object if8241 = done;
  if (istrue(opresult8247)) {
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8248 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool8249 = alloc_Boolean(1);
// compiled identifier node returning bool8249 (depth = 6)
  gc_frame_newslot(bool8249);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  params[0] = bool8249;
  partcv[0] = 1;
  Object call8250 = callmethod(*var_objNode, "inTrait:=",
    1, partcv, params);
  gc_frame_end(callframe8248);
// compiled call node returning call8250 (depth = 5)
    gc_frame_newslot(call8250);
    if8241 = call8250;
  } else {
  }
// compiled if node returning if8241 (depth = 4)
    gc_frame_newslot(if8241);
    if8231 = if8241;
  }
// compiled if node returning if8231 (depth = 3)
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8252 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8251);
// compiled call node returning call8252 (depth = 3)
    gc_frame_newslot(call8252);
    if8147 = call8252;
  }
// compiled if node returning if8147 (depth = 2)
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8253 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8254 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8253);
// compiled call node returning call8254 (depth = 3)
// compiled member node returning call8254 (depth = 2)
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8260(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8262 == NULL) {
    strlit8262 = alloc_String("method");
    gc_root(strlit8262);
  }
// compiled string node returning strlit8262 (depth = 6)
  int op_slot_right_8261 = gc_frame_newslot(strlit8262);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8264 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8265 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call8266 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8265);
// compiled call node returning call8266 (depth = 9)
// compiled member node returning call8266 (depth = 8)
  partcv[0] = 0;
  Object call8267 = callmethod(call8266, "value",
    1, partcv, params);
  gc_frame_end(callframe8264);
// compiled call node returning call8267 (depth = 7)
// compiled member node returning call8267 (depth = 6)
  int op_slot_left_8261 = gc_frame_newslot(call8267);
  params[0] = strlit8262;
  partcv[0] = 1;
  Object opresult8268 = callmethod(call8267, "==", 1, partcv, params);
// compiled op node returning opresult8268 (depth = 5)
  gc_frame_end(frame);
  return opresult8268;
}
Object meth_parser__apply8272(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8274 == NULL) {
    strlit8274 = alloc_String("keyword");
    gc_root(strlit8274);
  }
// compiled string node returning strlit8274 (depth = 7)
  int op_slot_right_8273 = gc_frame_newslot(strlit8274);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8276 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  partcv[0] = 0;
  Object call8278 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8277);
// compiled call node returning call8278 (depth = 10)
// compiled member node returning call8278 (depth = 9)
  partcv[0] = 0;
  Object call8279 = callmethod(call8278, "kind",
    1, partcv, params);
  gc_frame_end(callframe8276);
// compiled call node returning call8279 (depth = 8)
// compiled member node returning call8279 (depth = 7)
  int op_slot_left_8273 = gc_frame_newslot(call8279);
  params[0] = strlit8274;
  partcv[0] = 1;
  Object opresult8280 = callmethod(call8279, "==", 1, partcv, params);
// compiled op node returning opresult8280 (depth = 6)
  gc_frame_end(frame);
  return opresult8280;
}
Object meth_parser_dofactoryMethod8256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dofactoryMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dofactoryMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_csig = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "csig");
  Object *var_methodName = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "methodName");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_objNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "objNode");
  Object *var_meth = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "meth");
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8258 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8259 = alloc_Block(NULL, NULL, "parser", 2573);
  gc_frame_newslot(block8259);
// method "_apply"
  block_savedest(block8259);
  Object closure8260 = createclosure(2, "_apply");
  setclosureframe(closure8260, stackframe);
  addtoclosure(closure8260, var_tokens);
  addtoclosure(closure8260, selfslot);
  struct UserObject *uo8260 = (struct UserObject*)block8259;
  uo8260->data[0] = (Object)closure8260;
  Method *meth_meth_parser__apply8260 = addmethod2pos(block8259, "_apply", &meth_parser__apply8260, 0);
  int argcv_meth_parser__apply8260[] = {0};
  meth_meth_parser__apply8260->type = alloc_MethodType(1, argcv_meth_parser__apply8260);
  meth_meth_parser__apply8260->definitionModule = modulename;
  meth_meth_parser__apply8260->definitionLine = 2566;
// compiled block node returning block8259 (depth = 4)
  gc_frame_newslot(block8259);
// call case 6: other member request
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8270 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8271 = alloc_Block(NULL, NULL, "parser", 2572);
  gc_frame_newslot(block8271);
// method "_apply"
  block_savedest(block8271);
  Object closure8272 = createclosure(2, "_apply");
  setclosureframe(closure8272, stackframe);
  addtoclosure(closure8272, var_tokens);
  addtoclosure(closure8272, selfslot);
  struct UserObject *uo8272 = (struct UserObject*)block8271;
  uo8272->data[0] = (Object)closure8272;
  Method *meth_meth_parser__apply8272 = addmethod2pos(block8271, "_apply", &meth_parser__apply8272, 0);
  int argcv_meth_parser__apply8272[] = {0};
  meth_meth_parser__apply8272->type = alloc_MethodType(1, argcv_meth_parser__apply8272);
  meth_meth_parser__apply8272->definitionModule = modulename;
  meth_meth_parser__apply8272->definitionLine = 2574;
// compiled block node returning block8271 (depth = 5)
  gc_frame_newslot(block8271);
// call case 6: other member request
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8282 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8283 == NULL) {
    strlit8283 = alloc_String("factory");
    gc_root(strlit8283);
  }
// compiled string node returning strlit8283 (depth = 6)
  gc_frame_newslot(strlit8283);
// call case 4: self request
  params[0] = strlit8283;
  partcv[0] = 1;
  Object call8284 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8282);
// compiled call node returning call8284 (depth = 5)
  params[0] = block8271;
  partcv[0] = 1;
  Object call8285 = callmethod(call8284, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8270);
// compiled call node returning call8285 (depth = 4)
  params[0] = block8259;
  partcv[0] = 1;
  Object call8286 = callmethod(call8285, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8258);
// compiled call node returning call8286 (depth = 3)
  Object if8257 = done;
  if (istrue(call8286)) {
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8288 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8287);
// compiled call node returning call8288 (depth = 4)
// compiled member node returning call8288 (depth = 3)
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8290 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8289);
// compiled call node returning call8290 (depth = 4)
// compiled member node returning call8290 (depth = 3)
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8293 == NULL) {
    strlit8293 = alloc_String("identifier");
    gc_root(strlit8293);
  }
// compiled string node returning strlit8293 (depth = 5)
  int op_slot_right_8292 = gc_frame_newslot(strlit8293);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8296 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8295);
// compiled call node returning call8296 (depth = 6)
// compiled member node returning call8296 (depth = 5)
  int op_slot_left_8292 = gc_frame_newslot(call8296);
  params[0] = strlit8293;
  partcv[0] = 1;
  Object opresult8297 = callmethod(call8296, "!=", 1, partcv, params);
// compiled op node returning opresult8297 (depth = 4)
  Object if8291 = done;
  if (istrue(opresult8297)) {
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8298 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8299 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8300 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8299);
// compiled call node returning call8300 (depth = 8)
// compiled member node returning call8300 (depth = 7)
  partcv[0] = 0;
  Object call8301 = callmethod(call8300, "empty",
    1, partcv, params);
  gc_frame_end(callframe8298);
// compiled call node returning call8301 (depth = 6)
// compiled member node returning call8301 (depth = 5)
  *var_suggestions = call8301;
  if (call8301 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8304 == NULL) {
    strlit8304 = alloc_String("lbrace");
    gc_root(strlit8304);
  }
// compiled string node returning strlit8304 (depth = 6)
  int op_slot_right_8303 = gc_frame_newslot(strlit8304);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8307 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8306);
// compiled call node returning call8307 (depth = 7)
// compiled member node returning call8307 (depth = 6)
  int op_slot_left_8303 = gc_frame_newslot(call8307);
  params[0] = strlit8304;
  partcv[0] = 1;
  Object opresult8308 = callmethod(call8307, "==", 1, partcv, params);
// compiled op node returning opresult8308 (depth = 5)
  Object if8302 = done;
  if (istrue(opresult8308)) {
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8309 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8311 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8310);
// compiled call node returning call8311 (depth = 9)
// compiled member node returning call8311 (depth = 8)
  partcv[0] = 0;
  Object call8312 = callmethod(call8311, "new",
    1, partcv, params);
  gc_frame_end(callframe8309);
// compiled call node returning call8312 (depth = 7)
// compiled member node returning call8312 (depth = 6)
  *var_suggestion = call8312;
  if (call8312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8313 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8314 == NULL) {
    strlit8314 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8314);
  }
// compiled string node returning strlit8314 (depth = 6)
  gc_frame_newslot(strlit8314);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8314;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8315 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8313);
// compiled call node returning call8315 (depth = 5)
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8316 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8317 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8316);
// compiled call node returning call8317 (depth = 5)
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8318 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8320 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8319);
// compiled call node returning call8320 (depth = 9)
// compiled member node returning call8320 (depth = 8)
  partcv[0] = 0;
  Object call8321 = callmethod(call8320, "new",
    1, partcv, params);
  gc_frame_end(callframe8318);
// compiled call node returning call8321 (depth = 7)
// compiled member node returning call8321 (depth = 6)
  *var_suggestion = call8321;
  if (call8321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8323 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8324 == NULL) {
    strlit8324 = alloc_String("object");
    gc_root(strlit8324);
  }
// compiled string node returning strlit8324 (depth = 6)
  gc_frame_newslot(strlit8324);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8324;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8325 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8323);
// compiled call node returning call8325 (depth = 5)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8326 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8327 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8326);
// compiled call node returning call8327 (depth = 5)
    gc_frame_newslot(call8327);
    if8302 = call8327;
  } else {
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8328 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8329 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8330 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8329);
// compiled call node returning call8330 (depth = 9)
// compiled member node returning call8330 (depth = 8)
  partcv[0] = 0;
  Object call8331 = callmethod(call8330, "new",
    1, partcv, params);
  gc_frame_end(callframe8328);
// compiled call node returning call8331 (depth = 7)
// compiled member node returning call8331 (depth = 6)
  *var_suggestion = call8331;
  if (call8331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8332 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8333 == NULL) {
    strlit8333 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb"" {}");
    gc_root(strlit8333);
  }
// compiled string node returning strlit8333 (depth = 6)
  gc_frame_newslot(strlit8333);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8333;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8334 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8332);
// compiled call node returning call8334 (depth = 5)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8335 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8336 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8335);
// compiled call node returning call8336 (depth = 5)
    gc_frame_newslot(call8336);
    if8302 = call8336;
  }
// compiled if node returning if8302 (depth = 4)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8337 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8338 == NULL) {
    strlit8338 = alloc_String("a factory method must have a name after the 'method'.");
    gc_root(strlit8338);
  }
// compiled string node returning strlit8338 (depth = 5)
  gc_frame_newslot(strlit8338);
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8339 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8340 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8339);
// compiled call node returning call8340 (depth = 6)
// compiled member node returning call8340 (depth = 5)
  gc_frame_newslot(call8340);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8342 = alloc_Float64(1);
// compiled num node returning num8342 (depth = 6)
  int op_slot_right_8341 = gc_frame_newslot(num8342);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8345 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8346 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8345);
// compiled call node returning call8346 (depth = 8)
// compiled member node returning call8346 (depth = 7)
  int op_slot_right_8344 = gc_frame_newslot(call8346);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8349 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8348);
// compiled call node returning call8349 (depth = 8)
// compiled member node returning call8349 (depth = 7)
  int op_slot_left_8344 = gc_frame_newslot(call8349);
  params[0] = call8346;
  partcv[0] = 1;
  Object sum8350 = callmethod(call8349, "+", 1, partcv, params);
// compiled op node returning sum8350 (depth = 6)
  int op_slot_left_8341 = gc_frame_newslot(sum8350);
  params[0] = num8342;
  partcv[0] = 1;
  Object sum8351 = callmethod(sum8350, "+", 1, partcv, params);
// compiled op node returning sum8351 (depth = 5)
  gc_frame_newslot(sum8351);
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8338;
  params[1] = call8340;
  params[2] = sum8351;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8352 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8337);
// compiled call node returning call8352 (depth = 4)
    gc_frame_newslot(call8352);
    if8291 = call8352;
  } else {
  }
// compiled if node returning if8291 (depth = 3)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8353 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8354 = alloc_Boolean(0);
// compiled identifier node returning bool8354 (depth = 5)
  gc_frame_newslot(bool8354);
// call case 4: self request
  params[0] = bool8354;
  partcv[0] = 1;
  Object call8355 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8353);
// compiled call node returning call8355 (depth = 4)
  *var_s = call8355;
  if (call8355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8356 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8357 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8356);
// compiled call node returning call8357 (depth = 5)
// compiled member node returning call8357 (depth = 4)
  *var_csig = call8357;
  if (call8357 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8358 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8359 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8358);
// compiled call node returning call8359 (depth = 5)
// compiled member node returning call8359 (depth = 4)
  *var_methodName = call8359;
  if (call8359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8360 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8361 = alloc_Boolean(1);
// compiled identifier node returning bool8361 (depth = 4)
  gc_frame_newslot(bool8361);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodName (depth = 4)
  params[0] = bool8361;
  partcv[0] = 1;
  Object call8362 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8360);
// compiled call node returning call8362 (depth = 3)
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8364 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8363);
// compiled call node returning call8364 (depth = 5)
// compiled member node returning call8364 (depth = 4)
  *var_dtype = call8364;
  if (call8364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8365 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8366 == NULL) {
    strlit8366 = alloc_String("a factory method");
    gc_root(strlit8366);
  }
// compiled string node returning strlit8366 (depth = 4)
  gc_frame_newslot(strlit8366);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 4)
  if (strlit8367 == NULL) {
    strlit8367 = alloc_String("method header");
    gc_root(strlit8367);
  }
// compiled string node returning strlit8367 (depth = 4)
  gc_frame_newslot(strlit8367);
// call case 4: self request
  params[0] = strlit8366;
  params[1] = *var_btok;
  params[2] = strlit8367;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8368 = callmethodflags(self, "parseObjectConstructorBody()startingWith()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8365);
// compiled call node returning call8368 (depth = 3)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8370 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8369);
// compiled call node returning call8370 (depth = 5)
// compiled member node returning call8370 (depth = 4)
  *var_objNode = call8370;
  if (call8370 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8371 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodName (depth = 4)
  gc_frame_newslot(*var_methodName);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = *var_methodName;
  partcv[0] = 1;
  Object call8372 = callmethod(*var_objNode, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8371);
// compiled call node returning call8372 (depth = 3)
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8373 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8375 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8374);
// compiled call node returning call8375 (depth = 5)
// compiled member node returning call8375 (depth = 4)
  gc_frame_newslot(call8375);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8377 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8376);
// compiled call node returning call8377 (depth = 5)
// compiled member node returning call8377 (depth = 4)
  gc_frame_newslot(call8377);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8375;
  params[1] = call8377;
  partcv[0] = 2;
  Object call8378 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe8373);
// compiled call node returning call8378 (depth = 3)
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8379 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_csig (depth = 5)
  gc_frame_newslot(*var_csig);
// starting to compile array node (depth = 5)
  Object array8380 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethod(array8380, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array8380 (depth = 5)
  gc_frame_newslot(array8380);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8382 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8381);
// compiled call node returning call8382 (depth = 6)
// compiled member node returning call8382 (depth = 5)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = array8380;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8383 = callmethod(call8382, "new",
    1, partcv, params);
  gc_frame_end(callframe8379);
// compiled call node returning call8383 (depth = 4)
  *var_meth = call8383;
  if (call8383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8384 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8386 = callmethod(*var_s, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe8385);
// compiled call node returning call8386 (depth = 5)
// compiled member node returning call8386 (depth = 4)
  gc_frame_newslot(call8386);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = call8386;
  partcv[0] = 1;
  Object call8387 = callmethod(*var_meth, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe8384);
// compiled call node returning call8387 (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8388 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  partcv[0] = 0;
  Object call8390 = callmethod(*var_objNode, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8389);
// compiled call node returning call8390 (depth = 5)
// compiled member node returning call8390 (depth = 4)
  gc_frame_newslot(call8390);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call8392 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8391);
// compiled call node returning call8392 (depth = 5)
// compiled member node returning call8392 (depth = 4)
  params[0] = call8390;
  partcv[0] = 1;
  Object call8393 = callmethod(call8392, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8388);
// compiled call node returning call8393 (depth = 3)
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8394 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8395 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8394);
// compiled call node returning call8395 (depth = 3)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8397 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8396);
// compiled call node returning call8397 (depth = 4)
// compiled member node returning call8397 (depth = 3)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8257 = done;
  } else {
  }
// compiled if node returning if8257 (depth = 2)
  gc_frame_end(frame);
  return if8257;
}
Object meth_parser__apply8466(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8468 == NULL) {
    strlit8468 = alloc_String("lbrace");
    gc_root(strlit8468);
  }
// compiled string node returning strlit8468 (depth = 7)
  int op_slot_right_8467 = gc_frame_newslot(strlit8468);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call8471 = callmethod(*var_s, "kind",
    1, partcv, params);
  gc_frame_end(callframe8470);
// compiled call node returning call8471 (depth = 8)
// compiled member node returning call8471 (depth = 7)
  int op_slot_left_8467 = gc_frame_newslot(call8471);
  params[0] = strlit8468;
  partcv[0] = 1;
  Object opresult8472 = callmethod(call8471, "!=", 1, partcv, params);
// compiled op node returning opresult8472 (depth = 6)
  gc_frame_end(frame);
  return opresult8472;
}
Object meth_parser__apply8475(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8476 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8477 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8476);
// compiled call node returning call8477 (depth = 6)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8479 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8478);
// compiled call node returning call8479 (depth = 7)
// compiled member node returning call8479 (depth = 6)
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call8481 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8480);
// compiled call node returning call8481 (depth = 8)
// compiled member node returning call8481 (depth = 7)
  *var_s = call8481;
  if (call8481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_methoddec8399(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methoddec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for methoddec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_stok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "stok");
  Object *var_m = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "m");
  Object *var_meth = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "meth");
  Object *var_signature = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "signature");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_varargs = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "varargs");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_localMin = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "localMin");
  Object *var_anns = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "anns");
  Object *var_s = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "s");
  Object *var_suggestion = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "closingBrace");
  Object *var_o = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "o");
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8401 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8402 == NULL) {
    strlit8402 = alloc_String("method");
    gc_root(strlit8402);
  }
// compiled string node returning strlit8402 (depth = 4)
  gc_frame_newslot(strlit8402);
// call case 4: self request
  params[0] = strlit8402;
  partcv[0] = 1;
  Object call8403 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8401);
// compiled call node returning call8403 (depth = 3)
  Object if8400 = done;
  if (istrue(call8403)) {
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8405 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8404);
// compiled call node returning call8405 (depth = 4)
// compiled member node returning call8405 (depth = 3)
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_stok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8407 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8408 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8407);
// compiled call node returning call8408 (depth = 4)
// compiled member node returning call8408 (depth = 3)
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8409 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8410 = alloc_Boolean(0);
// compiled identifier node returning bool8410 (depth = 5)
  gc_frame_newslot(bool8410);
// call case 4: self request
  params[0] = bool8410;
  partcv[0] = 1;
  Object call8411 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8409);
// compiled call node returning call8411 (depth = 4)
  *var_m = call8411;
  if (call8411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8413 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe8412);
// compiled call node returning call8413 (depth = 5)
// compiled member node returning call8413 (depth = 4)
  *var_meth = call8413;
  if (call8413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8415 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe8414);
// compiled call node returning call8415 (depth = 5)
// compiled member node returning call8415 (depth = 4)
  *var_signature = call8415;
  if (call8415 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8417 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8416);
// compiled call node returning call8417 (depth = 5)
// compiled member node returning call8417 (depth = 4)
  *var_dtype = call8417;
  if (call8417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8419 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe8418);
// compiled call node returning call8419 (depth = 5)
// compiled member node returning call8419 (depth = 4)
  *var_varargs = call8419;
  if (call8419 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8420 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8420 (depth = 4)
  *var_body = array8420;
  if (array8420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8422 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8421);
// compiled call node returning call8422 (depth = 5)
// compiled member node returning call8422 (depth = 4)
  *var_anns = call8422;
  if (call8422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8424 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8425 == NULL) {
    strlit8425 = alloc_String("lbrace");
    gc_root(strlit8425);
  }
// compiled string node returning strlit8425 (depth = 5)
  gc_frame_newslot(strlit8425);
// call case 4: self request
  params[0] = strlit8425;
  partcv[0] = 1;
  Object call8426 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8424);
// compiled call node returning call8426 (depth = 4)
  Object if8423 = done;
  if (istrue(call8426)) {
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8427 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8428 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8427);
// compiled call node returning call8428 (depth = 5)
// compiled member node returning call8428 (depth = 4)
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8432 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stok (depth = 8)
  partcv[0] = 0;
  Object call8433 = callmethod(*var_stok, "line",
    1, partcv, params);
  gc_frame_end(callframe8432);
// compiled call node returning call8433 (depth = 7)
// compiled member node returning call8433 (depth = 6)
  int op_slot_right_8431 = gc_frame_newslot(call8433);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8435 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8436 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8435);
// compiled call node returning call8436 (depth = 7)
// compiled member node returning call8436 (depth = 6)
  int op_slot_left_8431 = gc_frame_newslot(call8436);
  params[0] = call8433;
  partcv[0] = 1;
  Object opresult8437 = callmethod(call8436, "==", 1, partcv, params);
// compiled op node returning opresult8437 (depth = 5)
  Object if8430 = done;
  if (istrue(opresult8437)) {
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8439 = alloc_Float64(1);
// compiled num node returning num8439 (depth = 7)
  int op_slot_right_8438 = gc_frame_newslot(num8439);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8441 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8442 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8441);
// compiled call node returning call8442 (depth = 8)
// compiled member node returning call8442 (depth = 7)
  int op_slot_left_8438 = gc_frame_newslot(call8442);
  params[0] = num8439;
  partcv[0] = 1;
  Object diff8443 = callmethod(call8442, "-", 1, partcv, params);
// compiled op node returning diff8443 (depth = 6)
  *var_minIndentLevel = diff8443;
  if (diff8443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8430 = done;
  } else {
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8446 = alloc_Float64(1);
// compiled num node returning num8446 (depth = 7)
  int op_slot_right_8445 = gc_frame_newslot(num8446);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_stok (depth = 9)
  partcv[0] = 0;
  Object call8449 = callmethod(*var_stok, "indent",
    1, partcv, params);
  gc_frame_end(callframe8448);
// compiled call node returning call8449 (depth = 8)
// compiled member node returning call8449 (depth = 7)
  int op_slot_left_8445 = gc_frame_newslot(call8449);
  params[0] = num8446;
  partcv[0] = 1;
  Object sum8450 = callmethod(call8449, "+", 1, partcv, params);
// compiled op node returning sum8450 (depth = 6)
  *var_minIndentLevel = sum8450;
  if (sum8450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8430 = done;
  }
// compiled if node returning if8430 (depth = 4)
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8452 = gc_frame_new();
// starting to compile object node (depth = 5)
  Object inheritingObject8453 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8453 = alloc_userobj2(3,4, objclass8453);
  gc_frame_newslot(obj8453);
// OBJECT OUTER DEC outer
  adddatum2(obj8453, self, 0);
  addmethodreal(obj8453,"outer", &reader_parser_outer_8454);
  Object oldself8453 = self;
  struct StackFrameObject *oldstackframe8453 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8453);
  gc_frame_newslot((Object)stackframe);
  self = obj8453;
  Object *oldselfslot8453 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8453 = (*(struct UserObject *)self).data[0], lowerouter8453 = thisouter8453;
  if (inheritingObject8453) {
    struct UserObject *inho8453 = (struct UserObject *)inheritingObject8453;
    while (inho8453->super != GraceDefaultObject) inho8453 = (struct UserObject *)inho8453->super;
    inho8453->super = obj8453;
    self = inheritingObject8453;
    *selfslot = self;
    lowerouter8453 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8453;
  }
if (objclass8453 == NULL) {
  Method *reader8455 = addmethodrealflags(obj8453, "kind",&reader_parser_kind_8455, MFLAG_DEF);
  reader8455->definitionModule = modulename;
  reader8455->definitionLine = 2644;
}
adddatum2(obj8453, alloc_Undefined(), 1);
if (objclass8453 == NULL) {
  Method *reader8456 = addmethodrealflags(obj8453, "register",&reader_parser_register_8456, 0);
  Method *writer8456 = addmethodrealflags(obj8453, "register:=",&writer_parser_register_8456, 0);
  reader8456->definitionModule = modulename;
  writer8456->definitionModule = modulename;
  reader8456->definitionLine = 2645;
  writer8456->definitionLine = 2645;
}
obj8453->flags |= OFLAG_MUTABLE;
adddatum2(obj8453, alloc_Undefined(), 2);
  sourceObject = obj8453;
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8457 == NULL) {
    strlit8457 = alloc_String("lbrace");
    gc_root(strlit8457);
  }
// compiled string node returning strlit8457 (depth = 6)
  adddatum2(obj8453, strlit8457, 1);
  sourceObject = obj8453;
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8458 == NULL) {
    strlit8458 = alloc_String("");
    gc_root(strlit8458);
  }
// compiled string node returning strlit8458 (depth = 6)
  adddatum2(obj8453, strlit8458, 2);
  objclass8453 = obj8453->class;
  objclass8453->definitionModule = modulename;
  objclass8453->definitionLine = 2643;
  (*(struct UserObject *)self).data[0] = lowerouter8453;
  self = oldself8453;
  selfslot = oldselfslot8453;
  stackframe = oldstackframe8453;
// compiled object node returning obj8453 (depth = 5)
  gc_frame_newslot(obj8453);
// call case 6: other member request
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = obj8453;
  partcv[0] = 1;
  Object call8459 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8452);
// compiled call node returning call8459 (depth = 4)
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8461 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8460);
// compiled call node returning call8461 (depth = 5)
// compiled member node returning call8461 (depth = 4)
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8463 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8462);
// compiled call node returning call8463 (depth = 6)
// compiled member node returning call8463 (depth = 5)
  *var_s = call8463;
  if (call8463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8464 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8465 = alloc_Block(NULL, NULL, "parser", 2649);
  gc_frame_newslot(block8465);
// method "_apply"
  block_savedest(block8465);
  Object closure8466 = createclosure(2, "_apply");
  setclosureframe(closure8466, stackframe);
  addtoclosure(closure8466, var_s);
  addtoclosure(closure8466, selfslot);
  struct UserObject *uo8466 = (struct UserObject*)block8465;
  uo8466->data[0] = (Object)closure8466;
  Method *meth_meth_parser__apply8466 = addmethod2pos(block8465, "_apply", &meth_parser__apply8466, 0);
  int argcv_meth_parser__apply8466[] = {0};
  meth_meth_parser__apply8466->type = alloc_MethodType(1, argcv_meth_parser__apply8466);
  meth_meth_parser__apply8466->definitionModule = modulename;
  meth_meth_parser__apply8466->definitionLine = 2648;
// compiled block node returning block8465 (depth = 5)
  gc_frame_newslot(block8465);
// starting to compile block node (depth = 5)
  Object block8474 = alloc_Block(NULL, NULL, "parser", 2649);
  gc_frame_newslot(block8474);
// method "_apply"
  block_savedest(block8474);
  Object closure8475 = createclosure(4, "_apply");
  setclosureframe(closure8475, stackframe);
  addtoclosure(closure8475, var_s);
  addtoclosure(closure8475, var_body);
  addtoclosure(closure8475, var_values);
  addtoclosure(closure8475, selfslot);
  struct UserObject *uo8475 = (struct UserObject*)block8474;
  uo8475->data[0] = (Object)closure8475;
  Method *meth_meth_parser__apply8475 = addmethod2pos(block8474, "_apply", &meth_parser__apply8475, 0);
  int argcv_meth_parser__apply8475[] = {0};
  meth_meth_parser__apply8475->type = alloc_MethodType(1, argcv_meth_parser__apply8475);
  meth_meth_parser__apply8475->definitionModule = modulename;
  meth_meth_parser__apply8475->definitionLine = 2649;
// compiled block node returning block8474 (depth = 5)
  gc_frame_newslot(block8474);
// call case 5: prelude request
  params[0] = block8465;
  params[1] = block8474;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8484 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8464);
// compiled call node returning call8484 (depth = 4)
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8487 == NULL) {
    strlit8487 = alloc_String("rbrace");
    gc_root(strlit8487);
  }
// compiled string node returning strlit8487 (depth = 6)
  int op_slot_right_8486 = gc_frame_newslot(strlit8487);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8490 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8489);
// compiled call node returning call8490 (depth = 7)
// compiled member node returning call8490 (depth = 6)
  int op_slot_left_8486 = gc_frame_newslot(call8490);
  params[0] = strlit8487;
  partcv[0] = 1;
  Object opresult8491 = callmethod(call8490, "!=", 1, partcv, params);
// compiled op node returning opresult8491 (depth = 5)
  Object if8485 = done;
  if (istrue(opresult8491)) {
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8492 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8493 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8494 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8493);
// compiled call node returning call8494 (depth = 9)
// compiled member node returning call8494 (depth = 8)
  partcv[0] = 0;
  Object call8495 = callmethod(call8494, "new",
    1, partcv, params);
  gc_frame_end(callframe8492);
// compiled call node returning call8495 (depth = 7)
// compiled member node returning call8495 (depth = 6)
  *var_suggestion = call8495;
  if (call8495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8496 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool8497 = alloc_Boolean(0);
// compiled identifier node returning bool8497 (depth = 7)
  gc_frame_newslot(bool8497);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8497;
  partcv[0] = 2;
  Object call8498 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8496);
// compiled call node returning call8498 (depth = 6)
  *var_closingBrace = call8498;
  if (call8498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2660
  setline(2660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool8501 = alloc_Boolean(0);
// compiled identifier node returning bool8501 (depth = 7)
  int op_slot_right_8500 = gc_frame_newslot(bool8501);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8503 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8504 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8503);
// compiled call node returning call8504 (depth = 8)
// compiled member node returning call8504 (depth = 7)
  int op_slot_left_8500 = gc_frame_newslot(call8504);
  params[0] = bool8501;
  partcv[0] = 1;
  Object opresult8505 = callmethod(call8504, "==", 1, partcv, params);
// compiled op node returning opresult8505 (depth = 6)
  Object if8499 = done;
  if (istrue(opresult8505)) {
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8507 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8509 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call8510 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8509);
// compiled call node returning call8510 (depth = 9)
// compiled member node returning call8510 (depth = 8)
  int op_slot_left_8507 = gc_frame_newslot(call8510);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8511 = callmethod(call8510, "==", 1, partcv, params);
// compiled op node returning opresult8511 (depth = 7)
  Object if8506 = done;
  if (istrue(opresult8511)) {
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8512 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8513 == NULL) {
    strlit8513 = alloc_String("}");
    gc_root(strlit8513);
  }
// compiled string node returning strlit8513 (depth = 8)
  gc_frame_newslot(strlit8513);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8513;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8514 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8512);
// compiled call node returning call8514 (depth = 7)
    gc_frame_newslot(call8514);
    if8506 = call8514;
  } else {
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8515 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8517 = alloc_Float64(0.1);
// compiled num node returning num8517 (depth = 9)
  int op_slot_right_8516 = gc_frame_newslot(num8517);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8519 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8520 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call8521 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8520);
// compiled call node returning call8521 (depth = 12)
// compiled member node returning call8521 (depth = 11)
  partcv[0] = 0;
  Object call8522 = callmethod(call8521, "line",
    1, partcv, params);
  gc_frame_end(callframe8519);
// compiled call node returning call8522 (depth = 10)
// compiled member node returning call8522 (depth = 9)
  int op_slot_left_8516 = gc_frame_newslot(call8522);
  params[0] = num8517;
  partcv[0] = 1;
  Object sum8523 = callmethod(call8522, "+", 1, partcv, params);
// compiled op node returning sum8523 (depth = 8)
  gc_frame_newslot(sum8523);
// starting to compile string node (depth = 8)
  if (strlit8524 == NULL) {
    strlit8524 = alloc_String("}");
    gc_root(strlit8524);
  }
// compiled string node returning strlit8524 (depth = 8)
  gc_frame_newslot(strlit8524);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum8523;
  params[1] = strlit8524;
  partcv[0] = 2;
  Object call8525 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8515);
// compiled call node returning call8525 (depth = 7)
    gc_frame_newslot(call8525);
    if8506 = call8525;
  }
// compiled if node returning if8506 (depth = 6)
    gc_frame_newslot(if8506);
    if8499 = if8506;
  } else {
  }
// compiled if node returning if8499 (depth = 5)
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8526 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8527 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8526);
// compiled call node returning call8527 (depth = 5)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8528 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8529 == NULL) {
    strlit8529 = alloc_String("a method must end with a '}'.");
    gc_root(strlit8529);
  }
// compiled string node returning strlit8529 (depth = 6)
  gc_frame_newslot(strlit8529);
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8531 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8530);
// compiled call node returning call8531 (depth = 7)
// compiled member node returning call8531 (depth = 6)
  gc_frame_newslot(call8531);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8533 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8532);
// compiled call node returning call8533 (depth = 7)
// compiled member node returning call8533 (depth = 6)
  gc_frame_newslot(call8533);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8529;
  params[1] = call8531;
  params[2] = call8533;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8534 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8528);
// compiled call node returning call8534 (depth = 5)
    gc_frame_newslot(call8534);
    if8485 = call8534;
  } else {
  }
// compiled if node returning if8485 (depth = 4)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8536 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8535);
// compiled call node returning call8536 (depth = 5)
// compiled member node returning call8536 (depth = 4)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8423 = done;
  } else {
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8538 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8540 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8539);
// compiled call node returning call8540 (depth = 8)
// compiled member node returning call8540 (depth = 7)
  partcv[0] = 0;
  Object call8541 = callmethod(call8540, "new",
    1, partcv, params);
  gc_frame_end(callframe8538);
// compiled call node returning call8541 (depth = 6)
// compiled member node returning call8541 (depth = 5)
  *var_suggestion = call8541;
  if (call8541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8542 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool8543 = alloc_Boolean(1);
// compiled identifier node returning bool8543 (depth = 6)
  gc_frame_newslot(bool8543);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8543;
  partcv[0] = 2;
  Object call8544 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8542);
// compiled call node returning call8544 (depth = 5)
  *var_closingBrace = call8544;
  if (call8544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8547 = alloc_Boolean(0);
// compiled identifier node returning bool8547 (depth = 6)
  int op_slot_right_8546 = gc_frame_newslot(bool8547);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call8550 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8549);
// compiled call node returning call8550 (depth = 7)
// compiled member node returning call8550 (depth = 6)
  int op_slot_left_8546 = gc_frame_newslot(call8550);
  params[0] = bool8547;
  partcv[0] = 1;
  Object opresult8551 = callmethod(call8550, "==", 1, partcv, params);
// compiled op node returning opresult8551 (depth = 5)
  Object if8545 = done;
  if (istrue(opresult8551)) {
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_8553 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8555 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8556 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8555);
// compiled call node returning call8556 (depth = 8)
// compiled member node returning call8556 (depth = 7)
  int op_slot_left_8553 = gc_frame_newslot(call8556);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult8557 = callmethod(call8556, "==", 1, partcv, params);
// compiled op node returning opresult8557 (depth = 6)
  Object if8552 = done;
  if (istrue(opresult8557)) {
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8558 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8559 == NULL) {
    strlit8559 = alloc_String(" {}");
    gc_root(strlit8559);
  }
// compiled string node returning strlit8559 (depth = 7)
  gc_frame_newslot(strlit8559);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8560 = alloc_Boolean(1);
// compiled identifier node returning bool8560 (depth = 7)
  gc_frame_newslot(bool8560);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8559;
  params[1] = *var_lastToken;
  params[2] = bool8560;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8561 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8558);
// compiled call node returning call8561 (depth = 6)
    gc_frame_newslot(call8561);
    if8552 = call8561;
  } else {
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8562 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8564 = alloc_Float64(0.1);
// compiled num node returning num8564 (depth = 8)
  int op_slot_right_8563 = gc_frame_newslot(num8564);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8566 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call8568 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8567);
// compiled call node returning call8568 (depth = 11)
// compiled member node returning call8568 (depth = 10)
  partcv[0] = 0;
  Object call8569 = callmethod(call8568, "line",
    1, partcv, params);
  gc_frame_end(callframe8566);
// compiled call node returning call8569 (depth = 9)
// compiled member node returning call8569 (depth = 8)
  int op_slot_left_8563 = gc_frame_newslot(call8569);
  params[0] = num8564;
  partcv[0] = 1;
  Object sum8570 = callmethod(call8569, "+", 1, partcv, params);
// compiled op node returning sum8570 (depth = 7)
  gc_frame_newslot(sum8570);
// starting to compile string node (depth = 7)
  if (strlit8571 == NULL) {
    strlit8571 = alloc_String("}");
    gc_root(strlit8571);
  }
// compiled string node returning strlit8571 (depth = 7)
  gc_frame_newslot(strlit8571);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum8570;
  params[1] = strlit8571;
  partcv[0] = 2;
  Object call8572 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8562);
// compiled call node returning call8572 (depth = 6)
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8573 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8574 == NULL) {
    strlit8574 = alloc_String(" {");
    gc_root(strlit8574);
  }
// compiled string node returning strlit8574 (depth = 7)
  gc_frame_newslot(strlit8574);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8575 = alloc_Boolean(1);
// compiled identifier node returning bool8575 (depth = 7)
  gc_frame_newslot(bool8575);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8574;
  params[1] = *var_lastToken;
  params[2] = bool8575;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8576 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8573);
// compiled call node returning call8576 (depth = 6)
    gc_frame_newslot(call8576);
    if8552 = call8576;
  }
// compiled if node returning if8552 (depth = 5)
    gc_frame_newslot(if8552);
    if8545 = if8552;
  } else {
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8577 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8578 == NULL) {
    strlit8578 = alloc_String(" {");
    gc_root(strlit8578);
  }
// compiled string node returning strlit8578 (depth = 6)
  gc_frame_newslot(strlit8578);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool8579 = alloc_Boolean(1);
// compiled identifier node returning bool8579 (depth = 6)
  gc_frame_newslot(bool8579);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8578;
  params[1] = *var_lastToken;
  params[2] = bool8579;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8580 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8577);
// compiled call node returning call8580 (depth = 5)
    gc_frame_newslot(call8580);
    if8545 = call8580;
  }
// compiled if node returning if8545 (depth = 4)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8581 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8582 == NULL) {
    strlit8582 = alloc_String("a method must have a '{' after the name.");
    gc_root(strlit8582);
  }
// compiled string node returning strlit8582 (depth = 5)
  gc_frame_newslot(strlit8582);
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8584 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8583);
// compiled call node returning call8584 (depth = 6)
// compiled member node returning call8584 (depth = 5)
  gc_frame_newslot(call8584);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8587 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8586);
// compiled call node returning call8587 (depth = 7)
// compiled member node returning call8587 (depth = 6)
  int op_slot_right_8585 = gc_frame_newslot(call8587);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8589 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8590 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8589);
// compiled call node returning call8590 (depth = 7)
// compiled member node returning call8590 (depth = 6)
  int op_slot_left_8585 = gc_frame_newslot(call8590);
  params[0] = call8587;
  partcv[0] = 1;
  Object sum8591 = callmethod(call8590, "+", 1, partcv, params);
// compiled op node returning sum8591 (depth = 5)
  gc_frame_newslot(sum8591);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8582;
  params[1] = call8584;
  params[2] = sum8591;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8592 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8581);
// compiled call node returning call8592 (depth = 4)
    gc_frame_newslot(call8592);
    if8423 = call8592;
  }
// compiled if node returning if8423 (depth = 3)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8593 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8594 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8595 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8594);
// compiled call node returning call8595 (depth = 5)
// compiled member node returning call8595 (depth = 4)
  gc_frame_newslot(call8595);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8595;
  partcv[0] = 1;
  Object call8596 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8593);
// compiled call node returning call8596 (depth = 3)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8597 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8599 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8598);
// compiled call node returning call8599 (depth = 6)
// compiled member node returning call8599 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8600 = callmethod(call8599, "new",
    1, partcv, params);
  gc_frame_end(callframe8597);
// compiled call node returning call8600 (depth = 4)
  *var_o = call8600;
  if (call8600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_varargs (depth = 4)
  Object if8601 = done;
  if (istrue(*var_varargs)) {
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8602 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8603 = alloc_Boolean(1);
// compiled identifier node returning bool8603 (depth = 5)
  gc_frame_newslot(bool8603);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool8603;
  partcv[0] = 1;
  Object call8604 = callmethod(*var_o, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe8602);
// compiled call node returning call8604 (depth = 4)
    gc_frame_newslot(call8604);
    if8601 = call8604;
  } else {
  }
// compiled if node returning if8601 (depth = 3)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8605 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8607 = callmethod(*var_m, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe8606);
// compiled call node returning call8607 (depth = 5)
// compiled member node returning call8607 (depth = 4)
  gc_frame_newslot(call8607);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = call8607;
  partcv[0] = 1;
  Object call8608 = callmethod(*var_o, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe8605);
// compiled call node returning call8608 (depth = 3)
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8611 = alloc_Boolean(0);
// compiled identifier node returning bool8611 (depth = 5)
  int op_slot_right_8610 = gc_frame_newslot(bool8611);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_8610 = gc_frame_newslot(*var_anns);
  params[0] = bool8611;
  partcv[0] = 1;
  Object opresult8613 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult8613 (depth = 4)
  Object if8609 = done;
  if (istrue(opresult8613)) {
// starting to compile call node (depth = 4)
  int callframe8614 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call8616 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8615);
// compiled call node returning call8616 (depth = 6)
// compiled member node returning call8616 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8617 = callmethod(call8616, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8614);
// compiled call node returning call8617 (depth = 4)
    gc_frame_newslot(call8617);
    if8609 = call8617;
  } else {
  }
// compiled if node returning if8609 (depth = 3)
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8618 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8619 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8618);
// compiled call node returning call8619 (depth = 3)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8620 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8621 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8620);
// compiled call node returning call8621 (depth = 4)
// compiled member node returning call8621 (depth = 3)
    gc_frame_newslot(call8621);
    if8400 = call8621;
  } else {
  }
// compiled if node returning if8400 (depth = 2)
  gc_frame_end(frame);
  return if8400;
}
Object meth_parser__apply8631(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8633 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8634 == NULL) {
    strlit8634 = alloc_String("identifier");
    gc_root(strlit8634);
  }
// compiled string node returning strlit8634 (depth = 6)
  gc_frame_newslot(strlit8634);
// call case 4: self request
  params[0] = strlit8634;
  partcv[0] = 1;
  Object call8635 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8633);
// compiled call node returning call8635 (depth = 5)
  int op_slot_right_8632 = gc_frame_newslot(call8635);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8638 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8639 == NULL) {
    strlit8639 = alloc_String("identifier");
    gc_root(strlit8639);
  }
// compiled string node returning strlit8639 (depth = 7)
  gc_frame_newslot(strlit8639);
// call case 4: self request
  params[0] = strlit8639;
  partcv[0] = 1;
  Object call8640 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8638);
// compiled call node returning call8640 (depth = 6)
  int op_slot_right_8637 = gc_frame_newslot(call8640);
// starting to compile call node (depth = 6)
  int callframe8642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call8643 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8642);
// compiled call node returning call8643 (depth = 6)
  int op_slot_left_8637 = gc_frame_newslot(call8643);
  params[0] = call8640;
  partcv[0] = 1;
  Object opresult8644 = callmethod(call8643, "&&", 1, partcv, params);
// compiled op node returning opresult8644 (depth = 5)
  int op_slot_left_8632 = gc_frame_newslot(opresult8644);
  params[0] = call8635;
  partcv[0] = 1;
  Object opresult8645 = callmethod(opresult8644, "||", 1, partcv, params);
// compiled op node returning opresult8645 (depth = 4)
  gc_frame_end(frame);
  return opresult8645;
}
Object meth_parser__apply8703(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8707 == NULL) {
    strlit8707 = alloc_String("*");
    gc_root(strlit8707);
  }
// compiled string node returning strlit8707 (depth = 9)
  int op_slot_right_8706 = gc_frame_newslot(strlit8707);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8710 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8709);
// compiled call node returning call8710 (depth = 10)
// compiled member node returning call8710 (depth = 9)
  int op_slot_left_8706 = gc_frame_newslot(call8710);
  params[0] = strlit8707;
  partcv[0] = 1;
  Object opresult8711 = callmethod(call8710, "==", 1, partcv, params);
// compiled op node returning opresult8711 (depth = 8)
  int op_slot_right_8705 = gc_frame_newslot(opresult8711);
// starting to compile call node (depth = 8)
  int callframe8713 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8714 == NULL) {
    strlit8714 = alloc_String("op");
    gc_root(strlit8714);
  }
// compiled string node returning strlit8714 (depth = 9)
  gc_frame_newslot(strlit8714);
// call case 4: self request
  params[0] = strlit8714;
  partcv[0] = 1;
  Object call8715 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8713);
// compiled call node returning call8715 (depth = 8)
  int op_slot_left_8705 = gc_frame_newslot(call8715);
  params[0] = opresult8711;
  partcv[0] = 1;
  Object opresult8716 = callmethod(call8715, "&&", 1, partcv, params);
// compiled op node returning opresult8716 (depth = 7)
  int op_slot_right_8704 = gc_frame_newslot(opresult8716);
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8718 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8719 == NULL) {
    strlit8719 = alloc_String("identifier");
    gc_root(strlit8719);
  }
// compiled string node returning strlit8719 (depth = 8)
  gc_frame_newslot(strlit8719);
// call case 4: self request
  params[0] = strlit8719;
  partcv[0] = 1;
  Object call8720 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8718);
// compiled call node returning call8720 (depth = 7)
  int op_slot_left_8704 = gc_frame_newslot(call8720);
  params[0] = opresult8716;
  partcv[0] = 1;
  Object opresult8721 = callmethod(call8720, "||", 1, partcv, params);
// compiled op node returning opresult8721 (depth = 6)
  gc_frame_end(frame);
  return opresult8721;
}
Object meth_parser__apply8724(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_vararg = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_comma = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_nxt = getfromclosure(closure, 6);
  Object *var_part = getfromclosure(closure, 7);
  Object *var_tm = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8726 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8727 == NULL) {
    strlit8727 = alloc_String("op");
    gc_root(strlit8727);
  }
// compiled string node returning strlit8727 (depth = 8)
  gc_frame_newslot(strlit8727);
// call case 4: self request
  params[0] = strlit8727;
  partcv[0] = 1;
  Object call8728 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8726);
// compiled call node returning call8728 (depth = 7)
  Object if8725 = done;
  if (istrue(call8728)) {
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8730 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8729);
// compiled call node returning call8730 (depth = 8)
// compiled member node returning call8730 (depth = 7)
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool8731 = alloc_Boolean(1);
// compiled identifier node returning bool8731 (depth = 8)
  *var_vararg = bool8731;
  if (bool8731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8735 == NULL) {
    strlit8735 = alloc_String("identifier");
    gc_root(strlit8735);
  }
// compiled string node returning strlit8735 (depth = 9)
  int op_slot_right_8734 = gc_frame_newslot(strlit8735);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8738 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8737);
// compiled call node returning call8738 (depth = 10)
// compiled member node returning call8738 (depth = 9)
  int op_slot_left_8734 = gc_frame_newslot(call8738);
  params[0] = strlit8735;
  partcv[0] = 1;
  Object opresult8739 = callmethod(call8738, "!=", 1, partcv, params);
// compiled op node returning opresult8739 (depth = 8)
  Object if8733 = done;
  if (istrue(opresult8739)) {
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8740 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8741 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8742 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8741);
// compiled call node returning call8742 (depth = 12)
// compiled member node returning call8742 (depth = 11)
  partcv[0] = 0;
  Object call8743 = callmethod(call8742, "empty",
    1, partcv, params);
  gc_frame_end(callframe8740);
// compiled call node returning call8743 (depth = 10)
// compiled member node returning call8743 (depth = 9)
  *var_suggestions = call8743;
  if (call8743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8744 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call8746 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8745);
// compiled call node returning call8746 (depth = 12)
// compiled member node returning call8746 (depth = 11)
  partcv[0] = 0;
  Object call8747 = callmethod(call8746, "new",
    1, partcv, params);
  gc_frame_end(callframe8744);
// compiled call node returning call8747 (depth = 10)
// compiled member node returning call8747 (depth = 9)
  *var_suggestion = call8747;
  if (call8747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8748 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8749 == NULL) {
    strlit8749 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit8749);
  }
// compiled string node returning strlit8749 (depth = 9)
  gc_frame_newslot(strlit8749);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit8749;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8750 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8748);
// compiled call node returning call8750 (depth = 8)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8751 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8752 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8751);
// compiled call node returning call8752 (depth = 8)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool8755 = alloc_Boolean(0);
// compiled identifier node returning bool8755 (depth = 10)
  int op_slot_right_8754 = gc_frame_newslot(bool8755);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comma (depth = 10)
  int op_slot_left_8754 = gc_frame_newslot(*var_comma);
  params[0] = bool8755;
  partcv[0] = 1;
  Object opresult8757 = callmethod(*var_comma, "==", 1, partcv, params);
// compiled op node returning opresult8757 (depth = 9)
  Object if8753 = done;
  if (istrue(opresult8757)) {
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8758 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe8759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call8760 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8759);
// compiled call node returning call8760 (depth = 13)
// compiled member node returning call8760 (depth = 12)
  partcv[0] = 0;
  Object call8761 = callmethod(call8760, "new",
    1, partcv, params);
  gc_frame_end(callframe8758);
// compiled call node returning call8761 (depth = 11)
// compiled member node returning call8761 (depth = 10)
  *var_suggestion = call8761;
  if (call8761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe8763 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call8764 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8763);
// compiled call node returning call8764 (depth = 9)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe8765 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8766 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8765);
// compiled call node returning call8766 (depth = 9)
    gc_frame_newslot(call8766);
    if8753 = call8766;
  } else {
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8767 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe8768 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call8769 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8768);
// compiled call node returning call8769 (depth = 13)
// compiled member node returning call8769 (depth = 12)
  partcv[0] = 0;
  Object call8770 = callmethod(call8769, "new",
    1, partcv, params);
  gc_frame_end(callframe8767);
// compiled call node returning call8770 (depth = 11)
// compiled member node returning call8770 (depth = 10)
  *var_suggestion = call8770;
  if (call8770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe8772 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comma (depth = 10)
  gc_frame_newslot(*var_comma);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call8773 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe8772);
// compiled call node returning call8773 (depth = 9)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe8774 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8775 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8774);
// compiled call node returning call8775 (depth = 9)
    gc_frame_newslot(call8775);
    if8753 = call8775;
  }
// compiled if node returning if8753 (depth = 8)
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8776 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8777 == NULL) {
    strlit8777 = alloc_String("a variable length parameter (a parameter beginning with '*') must have a name after the '*'.");
    gc_root(strlit8777);
  }
// compiled string node returning strlit8777 (depth = 9)
  gc_frame_newslot(strlit8777);
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8778 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8779 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8778);
// compiled call node returning call8779 (depth = 10)
// compiled member node returning call8779 (depth = 9)
  gc_frame_newslot(call8779);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call8782 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8781);
// compiled call node returning call8782 (depth = 11)
// compiled member node returning call8782 (depth = 10)
  int op_slot_right_8780 = gc_frame_newslot(call8782);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call8785 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8784);
// compiled call node returning call8785 (depth = 11)
// compiled member node returning call8785 (depth = 10)
  int op_slot_left_8780 = gc_frame_newslot(call8785);
  params[0] = call8782;
  partcv[0] = 1;
  Object sum8786 = callmethod(call8785, "+", 1, partcv, params);
// compiled op node returning sum8786 (depth = 9)
  gc_frame_newslot(sum8786);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit8777;
  params[1] = call8779;
  params[2] = sum8786;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8787 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8776);
// compiled call node returning call8787 (depth = 8)
    gc_frame_newslot(call8787);
    if8733 = call8787;
  } else {
  }
// compiled if node returning if8733 (depth = 7)
    gc_frame_newslot(if8733);
    if8725 = if8733;
  } else {
  }
// compiled if node returning if8725 (depth = 6)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8788 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8789 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8788);
// compiled call node returning call8789 (depth = 7)
// compiled member node returning call8789 (depth = 6)
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call8791 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8790);
// compiled call node returning call8791 (depth = 8)
// compiled member node returning call8791 (depth = 7)
  *var_nxt = call8791;
  if (call8791 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8793 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool8794 = alloc_Boolean(1);
// compiled identifier node returning bool8794 (depth = 7)
  gc_frame_newslot(bool8794);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = bool8794;
  partcv[0] = 1;
  Object call8795 = callmethod(*var_nxt, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8793);
// compiled call node returning call8795 (depth = 6)
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8796 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8798 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8797);
// compiled call node returning call8798 (depth = 8)
// compiled member node returning call8798 (depth = 7)
  gc_frame_newslot(call8798);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = call8798;
  partcv[0] = 1;
  Object call8799 = callmethod(*var_nxt, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8796);
// compiled call node returning call8799 (depth = 6)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vararg (depth = 7)
  Object if8800 = done;
  if (istrue(*var_vararg)) {
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8801 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call8802 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe8801);
// compiled call node returning call8802 (depth = 7)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8803 = gc_frame_new();
// starting to compile identifier node (depth = 8)
  Object bool8804 = alloc_Boolean(1);
// compiled identifier node returning bool8804 (depth = 8)
  gc_frame_newslot(bool8804);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tm (depth = 8)
  params[0] = bool8804;
  partcv[0] = 1;
  Object call8805 = callmethod(*var_tm, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe8803);
// compiled call node returning call8805 (depth = 7)
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8808 == NULL) {
    strlit8808 = alloc_String("rparen");
    gc_root(strlit8808);
  }
// compiled string node returning strlit8808 (depth = 9)
  int op_slot_right_8807 = gc_frame_newslot(strlit8808);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8811 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8810);
// compiled call node returning call8811 (depth = 10)
// compiled member node returning call8811 (depth = 9)
  int op_slot_left_8807 = gc_frame_newslot(call8811);
  params[0] = strlit8808;
  partcv[0] = 1;
  Object opresult8812 = callmethod(call8811, "!=", 1, partcv, params);
// compiled op node returning opresult8812 (depth = 8)
  Object if8806 = done;
  if (istrue(opresult8812)) {
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8813 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call8815 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8814);
// compiled call node returning call8815 (depth = 12)
// compiled member node returning call8815 (depth = 11)
  partcv[0] = 0;
  Object call8816 = callmethod(call8815, "new",
    1, partcv, params);
  gc_frame_end(callframe8813);
// compiled call node returning call8816 (depth = 10)
// compiled member node returning call8816 (depth = 9)
  *var_suggestion = call8816;
  if (call8816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8817 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8818 == NULL) {
    strlit8818 = alloc_String(")");
    gc_root(strlit8818);
  }
// compiled string node returning strlit8818 (depth = 9)
  gc_frame_newslot(strlit8818);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit8818;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8819 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8817);
// compiled call node returning call8819 (depth = 8)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8820 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8821 == NULL) {
    strlit8821 = alloc_String("a part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit8821);
  }
// compiled string node returning strlit8821 (depth = 9)
  gc_frame_newslot(strlit8821);
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8823 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8822);
// compiled call node returning call8823 (depth = 10)
// compiled member node returning call8823 (depth = 9)
  gc_frame_newslot(call8823);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call8826 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8825);
// compiled call node returning call8826 (depth = 11)
// compiled member node returning call8826 (depth = 10)
  int op_slot_right_8824 = gc_frame_newslot(call8826);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8828 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call8829 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8828);
// compiled call node returning call8829 (depth = 11)
// compiled member node returning call8829 (depth = 10)
  int op_slot_left_8824 = gc_frame_newslot(call8829);
  params[0] = call8826;
  partcv[0] = 1;
  Object sum8830 = callmethod(call8829, "+", 1, partcv, params);
// compiled op node returning sum8830 (depth = 9)
  gc_frame_newslot(sum8830);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit8821;
  params[1] = call8823;
  params[2] = sum8830;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8831 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8820);
// compiled call node returning call8831 (depth = 8)
    gc_frame_newslot(call8831);
    if8806 = call8831;
  } else {
  }
// compiled if node returning if8806 (depth = 7)
    gc_frame_newslot(if8806);
    if8800 = if8806;
  } else {
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8832 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8833 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call8834 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe8833);
// compiled call node returning call8834 (depth = 9)
// compiled member node returning call8834 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call8835 = callmethod(call8834, "push",
    1, partcv, params);
  gc_frame_end(callframe8832);
// compiled call node returning call8835 (depth = 7)
    gc_frame_newslot(call8835);
    if8800 = call8835;
  }
// compiled if node returning if8800 (depth = 6)
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8837 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8838 == NULL) {
    strlit8838 = alloc_String("comma");
    gc_root(strlit8838);
  }
// compiled string node returning strlit8838 (depth = 8)
  gc_frame_newslot(strlit8838);
// call case 4: self request
  params[0] = strlit8838;
  partcv[0] = 1;
  Object call8839 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8837);
// compiled call node returning call8839 (depth = 7)
  Object if8836 = done;
  if (istrue(call8839)) {
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8842 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8841);
// compiled call node returning call8842 (depth = 8)
// compiled member node returning call8842 (depth = 7)
    gc_frame_newslot(call8842);
    if8836 = call8842;
  } else {
  }
// compiled if node returning if8836 (depth = 6)
  gc_frame_end(frame);
  return if8836;
}
Object meth_parser__apply8648(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_methname = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_nxt = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_tm = getfromclosure(closure, 7);
  Object *var_signature = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
  Object *var_vararg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "vararg");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_comma = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "comma");
// starting to compile bind node (depth = 4)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8650 == NULL) {
    strlit8650 = alloc_String("()");
    gc_root(strlit8650);
  }
// compiled string node returning strlit8650 (depth = 6)
  int op_slot_right_8649 = gc_frame_newslot(strlit8650);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_8649 = gc_frame_newslot(*var_methname);
  params[0] = strlit8650;
  partcv[0] = 1;
  Object opresult8652 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult8652 (depth = 5)
  *var_methname = opresult8652;
  if (opresult8652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8654 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8655 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call8656 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8655);
// compiled call node returning call8656 (depth = 8)
// compiled member node returning call8656 (depth = 7)
  partcv[0] = 0;
  Object call8657 = callmethod(call8656, "new",
    1, partcv, params);
  gc_frame_end(callframe8654);
// compiled call node returning call8657 (depth = 6)
// compiled member node returning call8657 (depth = 5)
  *var_part = call8657;
  if (call8657 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8658 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8659 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8658);
// compiled call node returning call8659 (depth = 5)
// compiled member node returning call8659 (depth = 4)
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8661 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8660);
// compiled call node returning call8661 (depth = 6)
// compiled member node returning call8661 (depth = 5)
  *var_nxt = call8661;
  if (call8661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8664 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call8665 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe8664);
// compiled call node returning call8665 (depth = 7)
// compiled member node returning call8665 (depth = 6)
  int op_slot_right_8663 = gc_frame_newslot(call8665);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_8663 = gc_frame_newslot(*var_methname);
  params[0] = call8665;
  partcv[0] = 1;
  Object opresult8667 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult8667 (depth = 5)
  *var_methname = opresult8667;
  if (opresult8667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8669 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8670 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  partcv[0] = 0;
  Object call8671 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe8670);
// compiled call node returning call8671 (depth = 6)
// compiled member node returning call8671 (depth = 5)
  gc_frame_newslot(call8671);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call8671;
  partcv[0] = 1;
  Object call8672 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8669);
// compiled call node returning call8672 (depth = 4)
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8673 = alloc_Boolean(0);
// compiled identifier node returning bool8673 (depth = 5)
  *var_vararg = bool8673;
  if (bool8673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8675 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8676 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8677 == NULL) {
    strlit8677 = alloc_String("lparen");
    gc_root(strlit8677);
  }
// compiled string node returning strlit8677 (depth = 8)
  gc_frame_newslot(strlit8677);
// call case 4: self request
  params[0] = strlit8677;
  partcv[0] = 1;
  Object call8678 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8676);
// compiled call node returning call8678 (depth = 7)
  partcv[0] = 0;
  Object call8679 = callmethod(call8678, "not",
    1, partcv, params);
  gc_frame_end(callframe8675);
// compiled call node returning call8679 (depth = 6)
// compiled member node returning call8679 (depth = 5)
  Object if8674 = done;
  if (istrue(call8679)) {
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8681 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8682 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 9)
// compiled member node returning call8682 (depth = 8)
  partcv[0] = 0;
  Object call8683 = callmethod(call8682, "new",
    1, partcv, params);
  gc_frame_end(callframe8680);
// compiled call node returning call8683 (depth = 7)
// compiled member node returning call8683 (depth = 6)
  *var_suggestion = call8683;
  if (call8683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8684 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8685 == NULL) {
    strlit8685 = alloc_String("()");
    gc_root(strlit8685);
  }
// compiled string node returning strlit8685 (depth = 6)
  gc_frame_newslot(strlit8685);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8685;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8686 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8684);
// compiled call node returning call8686 (depth = 5)
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8687 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8689 == NULL) {
    strlit8689 = alloc_String("parameter lists must have parentheses around each parameter list.");
    gc_root(strlit8689);
  }
// compiled string node returning strlit8689 (depth = 7)
  int op_slot_right_8688 = gc_frame_newslot(strlit8689);
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8691 == NULL) {
    strlit8691 = alloc_String("the declaration of a method with multiple ");
    gc_root(strlit8691);
  }
// compiled string node returning strlit8691 (depth = 7)
  int op_slot_left_8688 = gc_frame_newslot(strlit8691);
  params[0] = strlit8689;
  partcv[0] = 1;
  Object opresult8692 = callmethod(strlit8691, "++", 1, partcv, params);
// compiled op node returning opresult8692 (depth = 6)
  gc_frame_newslot(opresult8692);
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8694 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8693);
// compiled call node returning call8694 (depth = 7)
// compiled member node returning call8694 (depth = 6)
  gc_frame_newslot(call8694);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8696 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 7)
// compiled member node returning call8696 (depth = 6)
  gc_frame_newslot(call8696);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult8692;
  params[1] = call8694;
  params[2] = call8696;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8697 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8687);
// compiled call node returning call8697 (depth = 5)
    gc_frame_newslot(call8697);
    if8674 = call8697;
  } else {
  }
// compiled if node returning if8674 (depth = 4)
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8699 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8698);
// compiled call node returning call8699 (depth = 5)
// compiled member node returning call8699 (depth = 4)
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8700 = alloc_Boolean(0);
// compiled identifier node returning bool8700 (depth = 5)
  *var_comma = bool8700;
  if (bool8700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8701 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8702 = alloc_Block(NULL, NULL, "parser", 2730);
  gc_frame_newslot(block8702);
// method "_apply"
  block_savedest(block8702);
  Object closure8703 = createclosure(2, "_apply");
  setclosureframe(closure8703, stackframe);
  addtoclosure(closure8703, var_sym);
  addtoclosure(closure8703, selfslot);
  struct UserObject *uo8703 = (struct UserObject*)block8702;
  uo8703->data[0] = (Object)closure8703;
  Method *meth_meth_parser__apply8703 = addmethod2pos(block8702, "_apply", &meth_parser__apply8703, 0);
  int argcv_meth_parser__apply8703[] = {0};
  meth_meth_parser__apply8703->type = alloc_MethodType(1, argcv_meth_parser__apply8703);
  meth_meth_parser__apply8703->definitionModule = modulename;
  meth_meth_parser__apply8703->definitionLine = 2728;
// compiled block node returning block8702 (depth = 5)
  gc_frame_newslot(block8702);
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block8723 = alloc_Block(NULL, NULL, "parser", 2731);
  gc_frame_newslot(block8723);
// method "_apply"
  block_savedest(block8723);
  Object closure8724 = createclosure(10, "_apply");
  setclosureframe(closure8724, stackframe);
  addtoclosure(closure8724, var_vararg);
  addtoclosure(closure8724, var_sym);
  addtoclosure(closure8724, var_errormessages);
  addtoclosure(closure8724, var_lastToken);
  addtoclosure(closure8724, var_comma);
  addtoclosure(closure8724, var_values);
  addtoclosure(closure8724, var_nxt);
  addtoclosure(closure8724, var_part);
  addtoclosure(closure8724, var_tm);
  addtoclosure(closure8724, selfslot);
  struct UserObject *uo8724 = (struct UserObject*)block8723;
  uo8724->data[0] = (Object)closure8724;
  Method *meth_meth_parser__apply8724 = addmethod2pos(block8723, "_apply", &meth_parser__apply8724, 0);
  int argcv_meth_parser__apply8724[] = {0};
  meth_meth_parser__apply8724->type = alloc_MethodType(1, argcv_meth_parser__apply8724);
  meth_meth_parser__apply8724->definitionModule = modulename;
  meth_meth_parser__apply8724->definitionLine = 2731;
// compiled block node returning block8723 (depth = 5)
  gc_frame_newslot(block8723);
// call case 5: prelude request
  params[0] = block8702;
  params[1] = block8723;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8844 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8701);
// compiled call node returning call8844 (depth = 4)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8847 == NULL) {
    strlit8847 = alloc_String("rparen");
    gc_root(strlit8847);
  }
// compiled string node returning strlit8847 (depth = 6)
  int op_slot_right_8846 = gc_frame_newslot(strlit8847);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8849 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8850 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8849);
// compiled call node returning call8850 (depth = 7)
// compiled member node returning call8850 (depth = 6)
  int op_slot_left_8846 = gc_frame_newslot(call8850);
  params[0] = strlit8847;
  partcv[0] = 1;
  Object opresult8851 = callmethod(call8850, "!=", 1, partcv, params);
// compiled op node returning opresult8851 (depth = 5)
  Object if8845 = done;
  if (istrue(opresult8851)) {
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8852 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8853 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8854 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8853);
// compiled call node returning call8854 (depth = 9)
// compiled member node returning call8854 (depth = 8)
  partcv[0] = 0;
  Object call8855 = callmethod(call8854, "new",
    1, partcv, params);
  gc_frame_end(callframe8852);
// compiled call node returning call8855 (depth = 7)
// compiled member node returning call8855 (depth = 6)
  *var_suggestion = call8855;
  if (call8855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8856 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8857 == NULL) {
    strlit8857 = alloc_String(")");
    gc_root(strlit8857);
  }
// compiled string node returning strlit8857 (depth = 6)
  gc_frame_newslot(strlit8857);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8857;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8858 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8856);
// compiled call node returning call8858 (depth = 5)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8859 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8860 == NULL) {
    strlit8860 = alloc_String("a part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit8860);
  }
// compiled string node returning strlit8860 (depth = 6)
  gc_frame_newslot(strlit8860);
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8862 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8861);
// compiled call node returning call8862 (depth = 7)
// compiled member node returning call8862 (depth = 6)
  gc_frame_newslot(call8862);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8865 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8864);
// compiled call node returning call8865 (depth = 8)
// compiled member node returning call8865 (depth = 7)
  int op_slot_right_8863 = gc_frame_newslot(call8865);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8867 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8868 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8867);
// compiled call node returning call8868 (depth = 8)
// compiled member node returning call8868 (depth = 7)
  int op_slot_left_8863 = gc_frame_newslot(call8868);
  params[0] = call8865;
  partcv[0] = 1;
  Object sum8869 = callmethod(call8868, "+", 1, partcv, params);
// compiled op node returning sum8869 (depth = 6)
  gc_frame_newslot(sum8869);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8860;
  params[1] = call8862;
  params[2] = sum8869;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8870 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8859);
// compiled call node returning call8870 (depth = 5)
    gc_frame_newslot(call8870);
    if8845 = call8870;
  } else {
  }
// compiled if node returning if8845 (depth = 4)
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8871 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8872 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8871);
// compiled call node returning call8872 (depth = 5)
// compiled member node returning call8872 (depth = 4)
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8873 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call8874 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe8873);
// compiled call node returning call8874 (depth = 4)
  gc_frame_end(frame);
  return call8874;
}
Object meth_parser_methodDecRest8622(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodDecRest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method methodDecRest");
  Object params[2];
  int partcv[2];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodDecRest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for methodDecRest");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "methname");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_newName = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newName");
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8623 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8624 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tm (depth = 7)
  partcv[0] = 0;
  Object call8625 = callmethod(*var_tm, "value",
    1, partcv, params);
  gc_frame_end(callframe8624);
// compiled call node returning call8625 (depth = 6)
// compiled member node returning call8625 (depth = 5)
  partcv[0] = 0;
  Object call8626 = callmethod(call8625, "value",
    1, partcv, params);
  gc_frame_end(callframe8623);
// compiled call node returning call8626 (depth = 4)
// compiled member node returning call8626 (depth = 3)
  *var_methname = call8626;
  if (call8626 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tm (depth = 5)
  partcv[0] = 0;
  Object call8628 = callmethod(*var_tm, "signature",
    1, partcv, params);
  gc_frame_end(callframe8627);
// compiled call node returning call8628 (depth = 4)
// compiled member node returning call8628 (depth = 3)
  *var_signature = call8628;
  if (call8628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8629 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8630 = alloc_Block(NULL, NULL, "parser", 2713);
  gc_frame_newslot(block8630);
// method "_apply"
  block_savedest(block8630);
  Object closure8631 = createclosure(2, "_apply");
  setclosureframe(closure8631, stackframe);
  addtoclosure(closure8631, var_sameline);
  addtoclosure(closure8631, selfslot);
  struct UserObject *uo8631 = (struct UserObject*)block8630;
  uo8631->data[0] = (Object)closure8631;
  Method *meth_meth_parser__apply8631 = addmethod2pos(block8630, "_apply", &meth_parser__apply8631, 0);
  int argcv_meth_parser__apply8631[] = {0};
  meth_meth_parser__apply8631->type = alloc_MethodType(1, argcv_meth_parser__apply8631);
  meth_meth_parser__apply8631->definitionModule = modulename;
  meth_meth_parser__apply8631->definitionLine = 2711;
// compiled block node returning block8630 (depth = 3)
  gc_frame_newslot(block8630);
// starting to compile block node (depth = 3)
  Object block8647 = alloc_Block(NULL, NULL, "parser", 2713);
  gc_frame_newslot(block8647);
// method "_apply"
  block_savedest(block8647);
  Object closure8648 = createclosure(10, "_apply");
  setclosureframe(closure8648, stackframe);
  addtoclosure(closure8648, var_methname);
  addtoclosure(closure8648, var_ast);
  addtoclosure(closure8648, var_values);
  addtoclosure(closure8648, var_nxt);
  addtoclosure(closure8648, var_errormessages);
  addtoclosure(closure8648, var_lastToken);
  addtoclosure(closure8648, var_sym);
  addtoclosure(closure8648, var_tm);
  addtoclosure(closure8648, var_signature);
  addtoclosure(closure8648, selfslot);
  struct UserObject *uo8648 = (struct UserObject*)block8647;
  uo8648->data[0] = (Object)closure8648;
  Method *meth_meth_parser__apply8648 = addmethod2pos(block8647, "_apply", &meth_parser__apply8648, 0);
  int argcv_meth_parser__apply8648[] = {0};
  meth_meth_parser__apply8648->type = alloc_MethodType(1, argcv_meth_parser__apply8648);
  meth_meth_parser__apply8648->definitionModule = modulename;
  meth_meth_parser__apply8648->definitionLine = 2711;
// compiled block node returning block8647 (depth = 3)
  gc_frame_newslot(block8647);
// call case 5: prelude request
  params[0] = block8630;
  params[1] = block8647;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8876 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8629);
// compiled call node returning call8876 (depth = 2)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8877 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool8878 = alloc_Boolean(0);
// compiled identifier node returning bool8878 (depth = 4)
  gc_frame_newslot(bool8878);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8880 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8879);
// compiled call node returning call8880 (depth = 5)
// compiled member node returning call8880 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool8878;
  partcv[0] = 2;
  Object call8881 = callmethod(call8880, "new",
    1, partcv, params);
  gc_frame_end(callframe8877);
// compiled call node returning call8881 (depth = 3)
  *var_newName = call8881;
  if (call8881 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8882 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8883 = alloc_Boolean(1);
// compiled identifier node returning bool8883 (depth = 3)
  gc_frame_newslot(bool8883);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newName (depth = 3)
  params[0] = bool8883;
  partcv[0] = 1;
  Object call8884 = callmethod(*var_newName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8882);
// compiled call node returning call8884 (depth = 2)
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newName (depth = 2)
  gc_frame_end(frame);
  return *var_newName;
}
Object meth_parser__apply8895(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8896 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8897 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8896);
// compiled call node returning call8897 (depth = 7)
// compiled member node returning call8897 (depth = 6)
  gc_frame_end(frame);
  return call8897;
}
Object meth_parser_optionalTypeAnnotation8885(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "optionalTypeAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for optionalTypeAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for optionalTypeAnnotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8887 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8888 == NULL) {
    strlit8888 = alloc_String("colon");
    gc_root(strlit8888);
  }
// compiled string node returning strlit8888 (depth = 4)
  gc_frame_newslot(strlit8888);
// call case 4: self request
  params[0] = strlit8888;
  partcv[0] = 1;
  Object call8889 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8887);
// compiled call node returning call8889 (depth = 3)
  Object if8886 = done;
  if (istrue(call8889)) {
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8890 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8891 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8890);
// compiled call node returning call8891 (depth = 4)
// compiled member node returning call8891 (depth = 3)
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8893 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8894 = alloc_Block(NULL, NULL, "parser", 2793);
  gc_frame_newslot(block8894);
// method "_apply"
  block_savedest(block8894);
  Object closure8895 = createclosure(1, "_apply");
  setclosureframe(closure8895, stackframe);
  addtoclosure(closure8895, selfslot);
  struct UserObject *uo8895 = (struct UserObject*)block8894;
  uo8895->data[0] = (Object)closure8895;
  Method *meth_meth_parser__apply8895 = addmethod2pos(block8894, "_apply", &meth_parser__apply8895, 0);
  int argcv_meth_parser__apply8895[] = {0};
  meth_meth_parser__apply8895->type = alloc_MethodType(1, argcv_meth_parser__apply8895);
  meth_meth_parser__apply8895->definitionModule = modulename;
  meth_meth_parser__apply8895->definitionLine = 2792;
// compiled block node returning block8894 (depth = 5)
  gc_frame_newslot(block8894);
// call case 4: self request
  params[0] = block8894;
  partcv[0] = 1;
  Object call8899 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8893);
// compiled call node returning call8899 (depth = 4)
  Object if8892 = done;
  if (istrue(call8899)) {
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8901 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8900);
// compiled call node returning call8901 (depth = 5)
// compiled member node returning call8901 (depth = 4)
    gc_frame_newslot(call8901);
    if8892 = call8901;
  } else {
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8902 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8903 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8902);
// compiled call node returning call8903 (depth = 5)
// compiled member node returning call8903 (depth = 4)
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8904 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8905 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8906 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8905);
// compiled call node returning call8906 (depth = 8)
// compiled member node returning call8906 (depth = 7)
  partcv[0] = 0;
  Object call8907 = callmethod(call8906, "empty",
    1, partcv, params);
  gc_frame_end(callframe8904);
// compiled call node returning call8907 (depth = 6)
// compiled member node returning call8907 (depth = 5)
  *var_suggestions = call8907;
  if (call8907 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8908 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8910 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8909);
// compiled call node returning call8910 (depth = 8)
// compiled member node returning call8910 (depth = 7)
  partcv[0] = 0;
  Object call8911 = callmethod(call8910, "new",
    1, partcv, params);
  gc_frame_end(callframe8908);
// compiled call node returning call8911 (depth = 6)
// compiled member node returning call8911 (depth = 5)
  *var_suggestion = call8911;
  if (call8911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8912 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8913 == NULL) {
    strlit8913 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit8913);
  }
// compiled string node returning strlit8913 (depth = 5)
  gc_frame_newslot(strlit8913);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8913;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8914 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8912);
// compiled call node returning call8914 (depth = 4)
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8915 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8916 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8915);
// compiled call node returning call8916 (depth = 4)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8917 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8919 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8918);
// compiled call node returning call8919 (depth = 8)
// compiled member node returning call8919 (depth = 7)
  partcv[0] = 0;
  Object call8920 = callmethod(call8919, "new",
    1, partcv, params);
  gc_frame_end(callframe8917);
// compiled call node returning call8920 (depth = 6)
// compiled member node returning call8920 (depth = 5)
  *var_suggestion = call8920;
  if (call8920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8922 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 5)
  Object bool8923 = alloc_Boolean(1);
// compiled identifier node returning bool8923 (depth = 5)
  gc_frame_newslot(bool8923);
// starting to compile identifier node (depth = 5)
  Object bool8924 = alloc_Boolean(0);
// compiled identifier node returning bool8924 (depth = 5)
  gc_frame_newslot(bool8924);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = bool8923;
  params[2] = bool8924;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8925 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe8922);
// compiled call node returning call8925 (depth = 4)
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8926 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8927 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8926);
// compiled call node returning call8927 (depth = 4)
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8928 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8929 == NULL) {
    strlit8929 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit8929);
  }
// compiled string node returning strlit8929 (depth = 5)
  gc_frame_newslot(strlit8929);
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8931 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8930);
// compiled call node returning call8931 (depth = 6)
// compiled member node returning call8931 (depth = 5)
  gc_frame_newslot(call8931);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8933 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8932);
// compiled call node returning call8933 (depth = 6)
// compiled member node returning call8933 (depth = 5)
  gc_frame_newslot(call8933);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8929;
  params[1] = call8931;
  params[2] = call8933;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8934 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8928);
// compiled call node returning call8934 (depth = 4)
    gc_frame_newslot(call8934);
    if8892 = call8934;
  }
// compiled if node returning if8892 (depth = 3)
    gc_frame_newslot(if8892);
    if8886 = if8892;
  } else {
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8935 = alloc_Boolean(0);
// compiled identifier node returning bool8935 (depth = 3)
    gc_frame_newslot(bool8935);
    if8886 = bool8935;
  }
// compiled if node returning if8886 (depth = 2)
  gc_frame_end(frame);
  return if8886;
}
Object meth_parser__apply9026(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9028 == NULL) {
    strlit9028 = alloc_String("rsquare");
    gc_root(strlit9028);
  }
// compiled string node returning strlit9028 (depth = 9)
  int op_slot_right_9027 = gc_frame_newslot(strlit9028);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9030 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9031 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call9032 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9031);
// compiled call node returning call9032 (depth = 12)
// compiled member node returning call9032 (depth = 11)
  partcv[0] = 0;
  Object call9033 = callmethod(call9032, "kind",
    1, partcv, params);
  gc_frame_end(callframe9030);
// compiled call node returning call9033 (depth = 10)
// compiled member node returning call9033 (depth = 9)
  int op_slot_left_9027 = gc_frame_newslot(call9033);
  params[0] = strlit9028;
  partcv[0] = 1;
  Object opresult9034 = callmethod(call9033, "==", 1, partcv, params);
// compiled op node returning opresult9034 (depth = 8)
  gc_frame_end(frame);
  return opresult9034;
}
Object meth_parser__apply9221(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9225 == NULL) {
    strlit9225 = alloc_String("*");
    gc_root(strlit9225);
  }
// compiled string node returning strlit9225 (depth = 8)
  int op_slot_right_9224 = gc_frame_newslot(strlit9225);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9228 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9227);
// compiled call node returning call9228 (depth = 9)
// compiled member node returning call9228 (depth = 8)
  int op_slot_left_9224 = gc_frame_newslot(call9228);
  params[0] = strlit9225;
  partcv[0] = 1;
  Object opresult9229 = callmethod(call9228, "==", 1, partcv, params);
// compiled op node returning opresult9229 (depth = 7)
  int op_slot_right_9223 = gc_frame_newslot(opresult9229);
// starting to compile call node (depth = 7)
  int callframe9231 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9232 == NULL) {
    strlit9232 = alloc_String("op");
    gc_root(strlit9232);
  }
// compiled string node returning strlit9232 (depth = 8)
  gc_frame_newslot(strlit9232);
// call case 4: self request
  params[0] = strlit9232;
  partcv[0] = 1;
  Object call9233 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9231);
// compiled call node returning call9233 (depth = 7)
  int op_slot_left_9223 = gc_frame_newslot(call9233);
  params[0] = opresult9229;
  partcv[0] = 1;
  Object opresult9234 = callmethod(call9233, "&&", 1, partcv, params);
// compiled op node returning opresult9234 (depth = 6)
  int op_slot_right_9222 = gc_frame_newslot(opresult9234);
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9236 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9237 == NULL) {
    strlit9237 = alloc_String("identifier");
    gc_root(strlit9237);
  }
// compiled string node returning strlit9237 (depth = 7)
  gc_frame_newslot(strlit9237);
// call case 4: self request
  params[0] = strlit9237;
  partcv[0] = 1;
  Object call9238 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9236);
// compiled call node returning call9238 (depth = 6)
  int op_slot_left_9222 = gc_frame_newslot(call9238);
  params[0] = opresult9234;
  partcv[0] = 1;
  Object opresult9239 = callmethod(call9238, "||", 1, partcv, params);
// compiled op node returning opresult9239 (depth = 5)
  gc_frame_end(frame);
  return opresult9239;
}
Object meth_parser__apply9337(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9340 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call9341 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9340);
// compiled call node returning call9341 (depth = 13)
// compiled member node returning call9341 (depth = 12)
  int op_slot_right_9339 = gc_frame_newslot(call9341);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call9344 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9343);
// compiled call node returning call9344 (depth = 13)
// compiled member node returning call9344 (depth = 12)
  int op_slot_left_9339 = gc_frame_newslot(call9344);
  params[0] = call9341;
  partcv[0] = 1;
  Object opresult9345 = callmethod(call9344, "==", 1, partcv, params);
// compiled op node returning opresult9345 (depth = 11)
  int op_slot_right_9338 = gc_frame_newslot(opresult9345);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9348 == NULL) {
    strlit9348 = alloc_String("rparen");
    gc_root(strlit9348);
  }
// compiled string node returning strlit9348 (depth = 12)
  int op_slot_right_9347 = gc_frame_newslot(strlit9348);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9350 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call9351 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9350);
// compiled call node returning call9351 (depth = 13)
// compiled member node returning call9351 (depth = 12)
  int op_slot_left_9347 = gc_frame_newslot(call9351);
  params[0] = strlit9348;
  partcv[0] = 1;
  Object opresult9352 = callmethod(call9351, "==", 1, partcv, params);
// compiled op node returning opresult9352 (depth = 11)
  int op_slot_left_9338 = gc_frame_newslot(opresult9352);
  params[0] = opresult9345;
  partcv[0] = 1;
  Object opresult9353 = callmethod(opresult9352, "&&", 1, partcv, params);
// compiled op node returning opresult9353 (depth = 10)
  gc_frame_end(frame);
  return opresult9353;
}
Object meth_parser__apply9242(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_comma = getfromclosure(closure, 3);
  Object *var_vararg = getfromclosure(closure, 4);
  Object *var_varargs = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_id = getfromclosure(closure, 7);
  Object *var_dtype = getfromclosure(closure, 8);
  Object *var_part = getfromclosure(closure, 9);
  Object *var_lparen = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_rparen = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "rparen");
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9244 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9245 == NULL) {
    strlit9245 = alloc_String("op");
    gc_root(strlit9245);
  }
// compiled string node returning strlit9245 (depth = 7)
  gc_frame_newslot(strlit9245);
// call case 4: self request
  params[0] = strlit9245;
  partcv[0] = 1;
  Object call9246 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9244);
// compiled call node returning call9246 (depth = 6)
  Object if9243 = done;
  if (istrue(call9246)) {
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9248 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9247);
// compiled call node returning call9248 (depth = 7)
// compiled member node returning call9248 (depth = 6)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9251 == NULL) {
    strlit9251 = alloc_String("identifier");
    gc_root(strlit9251);
  }
// compiled string node returning strlit9251 (depth = 8)
  int op_slot_right_9250 = gc_frame_newslot(strlit9251);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9254 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9253);
// compiled call node returning call9254 (depth = 9)
// compiled member node returning call9254 (depth = 8)
  int op_slot_left_9250 = gc_frame_newslot(call9254);
  params[0] = strlit9251;
  partcv[0] = 1;
  Object opresult9255 = callmethod(call9254, "!=", 1, partcv, params);
// compiled op node returning opresult9255 (depth = 7)
  Object if9249 = done;
  if (istrue(opresult9255)) {
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9256 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9257 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9258 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9257);
// compiled call node returning call9258 (depth = 11)
// compiled member node returning call9258 (depth = 10)
  partcv[0] = 0;
  Object call9259 = callmethod(call9258, "empty",
    1, partcv, params);
  gc_frame_end(callframe9256);
// compiled call node returning call9259 (depth = 9)
// compiled member node returning call9259 (depth = 8)
  *var_suggestions = call9259;
  if (call9259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9260 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9262 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9261);
// compiled call node returning call9262 (depth = 11)
// compiled member node returning call9262 (depth = 10)
  partcv[0] = 0;
  Object call9263 = callmethod(call9262, "new",
    1, partcv, params);
  gc_frame_end(callframe9260);
// compiled call node returning call9263 (depth = 9)
// compiled member node returning call9263 (depth = 8)
  *var_suggestion = call9263;
  if (call9263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9264 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9265 == NULL) {
    strlit9265 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit9265);
  }
// compiled string node returning strlit9265 (depth = 8)
  gc_frame_newslot(strlit9265);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit9265;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9266 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9264);
// compiled call node returning call9266 (depth = 7)
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9267 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9268 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9267);
// compiled call node returning call9268 (depth = 7)
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool9271 = alloc_Boolean(0);
// compiled identifier node returning bool9271 (depth = 9)
  int op_slot_right_9270 = gc_frame_newslot(bool9271);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_comma (depth = 9)
  int op_slot_left_9270 = gc_frame_newslot(*var_comma);
  params[0] = bool9271;
  partcv[0] = 1;
  Object opresult9273 = callmethod(*var_comma, "==", 1, partcv, params);
// compiled op node returning opresult9273 (depth = 8)
  Object if9269 = done;
  if (istrue(opresult9273)) {
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9274 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9276 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9275);
// compiled call node returning call9276 (depth = 12)
// compiled member node returning call9276 (depth = 11)
  partcv[0] = 0;
  Object call9277 = callmethod(call9276, "new",
    1, partcv, params);
  gc_frame_end(callframe9274);
// compiled call node returning call9277 (depth = 10)
// compiled member node returning call9277 (depth = 9)
  *var_suggestion = call9277;
  if (call9277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9279 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call9280 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9279);
// compiled call node returning call9280 (depth = 8)
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9281 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9282 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9281);
// compiled call node returning call9282 (depth = 8)
    gc_frame_newslot(call9282);
    if9269 = call9282;
  } else {
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9283 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9284 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9285 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9284);
// compiled call node returning call9285 (depth = 12)
// compiled member node returning call9285 (depth = 11)
  partcv[0] = 0;
  Object call9286 = callmethod(call9285, "new",
    1, partcv, params);
  gc_frame_end(callframe9283);
// compiled call node returning call9286 (depth = 10)
// compiled member node returning call9286 (depth = 9)
  *var_suggestion = call9286;
  if (call9286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9288 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_comma (depth = 9)
  gc_frame_newslot(*var_comma);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call9289 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe9288);
// compiled call node returning call9289 (depth = 8)
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9290 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9291 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9290);
// compiled call node returning call9291 (depth = 8)
    gc_frame_newslot(call9291);
    if9269 = call9291;
  }
// compiled if node returning if9269 (depth = 7)
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9292 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9293 == NULL) {
    strlit9293 = alloc_String("a variable length parameter (a parameter beginning with a '*') must have a name after the '*'.");
    gc_root(strlit9293);
  }
// compiled string node returning strlit9293 (depth = 8)
  gc_frame_newslot(strlit9293);
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9294 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9295 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9294);
// compiled call node returning call9295 (depth = 9)
// compiled member node returning call9295 (depth = 8)
  gc_frame_newslot(call9295);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9298 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9297);
// compiled call node returning call9298 (depth = 10)
// compiled member node returning call9298 (depth = 9)
  int op_slot_right_9296 = gc_frame_newslot(call9298);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9300 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9301 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9300);
// compiled call node returning call9301 (depth = 10)
// compiled member node returning call9301 (depth = 9)
  int op_slot_left_9296 = gc_frame_newslot(call9301);
  params[0] = call9298;
  partcv[0] = 1;
  Object sum9302 = callmethod(call9301, "+", 1, partcv, params);
// compiled op node returning sum9302 (depth = 8)
  gc_frame_newslot(sum9302);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit9293;
  params[1] = call9295;
  params[2] = sum9302;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9303 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9292);
// compiled call node returning call9303 (depth = 7)
    gc_frame_newslot(call9303);
    if9249 = call9303;
  } else {
  }
// compiled if node returning if9249 (depth = 6)
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9304 = alloc_Boolean(1);
// compiled identifier node returning bool9304 (depth = 7)
  *var_vararg = bool9304;
  if (bool9304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9306 = alloc_Boolean(1);
// compiled identifier node returning bool9306 (depth = 7)
  *var_varargs = bool9306;
  if (bool9306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9243 = done;
  } else {
  }
// compiled if node returning if9243 (depth = 5)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9308 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9309 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9308);
// compiled call node returning call9309 (depth = 6)
// compiled member node returning call9309 (depth = 5)
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9311 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9310);
// compiled call node returning call9311 (depth = 7)
// compiled member node returning call9311 (depth = 6)
  *var_id = call9311;
  if (call9311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9313 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool9314 = alloc_Boolean(1);
// compiled identifier node returning bool9314 (depth = 6)
  gc_frame_newslot(bool9314);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = bool9314;
  partcv[0] = 1;
  Object call9315 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9313);
// compiled call node returning call9315 (depth = 5)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9317 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9316);
// compiled call node returning call9317 (depth = 7)
// compiled member node returning call9317 (depth = 6)
  *var_dtype = call9317;
  if (call9317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9319 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dtype (depth = 6)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = *var_dtype;
  partcv[0] = 1;
  Object call9320 = callmethod(*var_id, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9319);
// compiled call node returning call9320 (depth = 5)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_vararg (depth = 6)
  Object if9321 = done;
  if (istrue(*var_vararg)) {
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9322 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9323 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9322);
// compiled call node returning call9323 (depth = 6)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9326 == NULL) {
    strlit9326 = alloc_String("rparen");
    gc_root(strlit9326);
  }
// compiled string node returning strlit9326 (depth = 8)
  int op_slot_right_9325 = gc_frame_newslot(strlit9326);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9329 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9328);
// compiled call node returning call9329 (depth = 9)
// compiled member node returning call9329 (depth = 8)
  int op_slot_left_9325 = gc_frame_newslot(call9329);
  params[0] = strlit9326;
  partcv[0] = 1;
  Object opresult9330 = callmethod(call9329, "!=", 1, partcv, params);
// compiled op node returning opresult9330 (depth = 7)
  Object if9324 = done;
  if (istrue(opresult9330)) {
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9331 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9333 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9332);
// compiled call node returning call9333 (depth = 11)
// compiled member node returning call9333 (depth = 10)
  partcv[0] = 0;
  Object call9334 = callmethod(call9333, "new",
    1, partcv, params);
  gc_frame_end(callframe9331);
// compiled call node returning call9334 (depth = 9)
// compiled member node returning call9334 (depth = 8)
  *var_suggestion = call9334;
  if (call9334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9335 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block9336 = alloc_Block(NULL, NULL, "parser", 2907);
  gc_frame_newslot(block9336);
// method "_apply"
  block_savedest(block9336);
  Object closure9337 = createclosure(2, "_apply");
  setclosureframe(closure9337, stackframe);
  addtoclosure(closure9337, var_sym);
  addtoclosure(closure9337, selfslot);
  struct UserObject *uo9337 = (struct UserObject*)block9336;
  uo9337->data[0] = (Object)closure9337;
  Method *meth_meth_parser__apply9337 = addmethod2pos(block9336, "_apply", &meth_parser__apply9337, 0);
  int argcv_meth_parser__apply9337[] = {1};
  meth_meth_parser__apply9337->type = alloc_MethodType(1, argcv_meth_parser__apply9337);
  meth_meth_parser__apply9337->definitionModule = modulename;
  meth_meth_parser__apply9337->definitionLine = 2906;
// compiled block node returning block9336 (depth = 9)
  gc_frame_newslot(block9336);
// call case 4: self request
  params[0] = block9336;
  partcv[0] = 1;
  Object call9355 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9335);
// compiled call node returning call9355 (depth = 8)
  *var_rparen = call9355;
  if (call9355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool9359 = alloc_Boolean(0);
// compiled identifier node returning bool9359 (depth = 10)
  int op_slot_right_9358 = gc_frame_newslot(bool9359);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rparen (depth = 10)
  int op_slot_left_9358 = gc_frame_newslot(*var_rparen);
  params[0] = bool9359;
  partcv[0] = 1;
  Object opresult9361 = callmethod(*var_rparen, "!=", 1, partcv, params);
// compiled op node returning opresult9361 (depth = 9)
  int op_slot_right_9357 = gc_frame_newslot(opresult9361);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9364 == NULL) {
    strlit9364 = alloc_String("comma");
    gc_root(strlit9364);
  }
// compiled string node returning strlit9364 (depth = 10)
  int op_slot_right_9363 = gc_frame_newslot(strlit9364);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9367 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9366);
// compiled call node returning call9367 (depth = 11)
// compiled member node returning call9367 (depth = 10)
  int op_slot_left_9363 = gc_frame_newslot(call9367);
  params[0] = strlit9364;
  partcv[0] = 1;
  Object opresult9368 = callmethod(call9367, "==", 1, partcv, params);
// compiled op node returning opresult9368 (depth = 9)
  int op_slot_left_9357 = gc_frame_newslot(opresult9368);
  params[0] = opresult9361;
  partcv[0] = 1;
  Object opresult9369 = callmethod(opresult9368, "&&", 1, partcv, params);
// compiled op node returning opresult9369 (depth = 8)
  Object if9356 = done;
  if (istrue(opresult9369)) {
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9370 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9372 == NULL) {
    strlit9372 = alloc_String("");
    gc_root(strlit9372);
  }
// compiled string node returning strlit9372 (depth = 10)
  int op_slot_right_9371 = gc_frame_newslot(strlit9372);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_id (depth = 13)
  partcv[0] = 0;
  Object call9376 = callmethod(*var_id, "value",
    1, partcv, params);
  gc_frame_end(callframe9375);
// compiled call node returning call9376 (depth = 12)
// compiled member node returning call9376 (depth = 11)
  int op_slot_right_9374 = gc_frame_newslot(call9376);
// starting to compile string node (depth = 11)
  if (strlit9378 == NULL) {
    strlit9378 = alloc_String(",*");
    gc_root(strlit9378);
  }
// compiled string node returning strlit9378 (depth = 11)
  int op_slot_left_9374 = gc_frame_newslot(strlit9378);
  params[0] = call9376;
  partcv[0] = 1;
  Object opresult9379 = callmethod(strlit9378, "++", 1, partcv, params);
// compiled op node returning opresult9379 (depth = 10)
  int op_slot_left_9371 = gc_frame_newslot(opresult9379);
  params[0] = strlit9372;
  partcv[0] = 1;
  Object opresult9380 = callmethod(opresult9379, "++", 1, partcv, params);
// compiled op node returning opresult9380 (depth = 9)
  gc_frame_newslot(opresult9380);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_rparen (depth = 9)
  gc_frame_newslot(*var_rparen);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = opresult9380;
  params[1] = *var_rparen;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9381 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe9370);
// compiled call node returning call9381 (depth = 8)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9382 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lparen (depth = 11)
  partcv[0] = 0;
  Object call9384 = callmethod(*var_lparen, "next",
    1, partcv, params);
  gc_frame_end(callframe9383);
// compiled call node returning call9384 (depth = 10)
// compiled member node returning call9384 (depth = 9)
  gc_frame_newslot(call9384);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
  Object bool9385 = alloc_Boolean(1);
// compiled identifier node returning bool9385 (depth = 9)
  gc_frame_newslot(bool9385);
// starting to compile identifier node (depth = 9)
  Object bool9386 = alloc_Boolean(0);
// compiled identifier node returning bool9386 (depth = 9)
  gc_frame_newslot(bool9386);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = call9384;
  params[1] = *var_sym;
  params[2] = bool9385;
  params[3] = bool9386;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9387 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9382);
// compiled call node returning call9387 (depth = 8)
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9388 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9389 == NULL) {
    strlit9389 = alloc_String("a variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.");
    gc_root(strlit9389);
  }
// compiled string node returning strlit9389 (depth = 9)
  gc_frame_newslot(strlit9389);
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9391 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9390);
// compiled call node returning call9391 (depth = 10)
// compiled member node returning call9391 (depth = 9)
  gc_frame_newslot(call9391);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9392 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9393 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9392);
// compiled call node returning call9393 (depth = 10)
// compiled member node returning call9393 (depth = 9)
  gc_frame_newslot(call9393);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9395 = alloc_Float64(1);
// compiled num node returning num9395 (depth = 10)
  int op_slot_right_9394 = gc_frame_newslot(num9395);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9397 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_rparen (depth = 12)
  partcv[0] = 0;
  Object call9398 = callmethod(*var_rparen, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9397);
// compiled call node returning call9398 (depth = 11)
// compiled member node returning call9398 (depth = 10)
  int op_slot_left_9394 = gc_frame_newslot(call9398);
  params[0] = num9395;
  partcv[0] = 1;
  Object diff9399 = callmethod(call9398, "-", 1, partcv, params);
// compiled op node returning diff9399 (depth = 9)
  gc_frame_newslot(diff9399);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9389;
  params[1] = call9391;
  params[2] = call9393;
  params[3] = diff9399;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9400 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9388);
// compiled call node returning call9400 (depth = 8)
    gc_frame_newslot(call9400);
    if9356 = call9400;
  } else {
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9401 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9402 == NULL) {
    strlit9402 = alloc_String(")");
    gc_root(strlit9402);
  }
// compiled string node returning strlit9402 (depth = 9)
  gc_frame_newslot(strlit9402);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9402;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9403 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9401);
// compiled call node returning call9403 (depth = 8)
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9404 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9405 == NULL) {
    strlit9405 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9405);
  }
// compiled string node returning strlit9405 (depth = 9)
  gc_frame_newslot(strlit9405);
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9406 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9407 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9406);
// compiled call node returning call9407 (depth = 10)
// compiled member node returning call9407 (depth = 9)
  gc_frame_newslot(call9407);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9409 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9410 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9409);
// compiled call node returning call9410 (depth = 11)
// compiled member node returning call9410 (depth = 10)
  int op_slot_right_9408 = gc_frame_newslot(call9410);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9413 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9412);
// compiled call node returning call9413 (depth = 11)
// compiled member node returning call9413 (depth = 10)
  int op_slot_left_9408 = gc_frame_newslot(call9413);
  params[0] = call9410;
  partcv[0] = 1;
  Object sum9414 = callmethod(call9413, "+", 1, partcv, params);
// compiled op node returning sum9414 (depth = 9)
  gc_frame_newslot(sum9414);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9405;
  params[1] = call9407;
  params[2] = sum9414;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9415 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9404);
// compiled call node returning call9415 (depth = 8)
    gc_frame_newslot(call9415);
    if9356 = call9415;
  }
// compiled if node returning if9356 (depth = 7)
    gc_frame_newslot(if9356);
    if9324 = if9356;
  } else {
  }
// compiled if node returning if9324 (depth = 6)
    gc_frame_newslot(if9324);
    if9321 = if9324;
  } else {
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9416 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call9418 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9417);
// compiled call node returning call9418 (depth = 8)
// compiled member node returning call9418 (depth = 7)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9419 = callmethod(call9418, "push",
    1, partcv, params);
  gc_frame_end(callframe9416);
// compiled call node returning call9419 (depth = 6)
    gc_frame_newslot(call9419);
    if9321 = call9419;
  }
// compiled if node returning if9321 (depth = 5)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9421 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9422 == NULL) {
    strlit9422 = alloc_String("comma");
    gc_root(strlit9422);
  }
// compiled string node returning strlit9422 (depth = 7)
  gc_frame_newslot(strlit9422);
// call case 4: self request
  params[0] = strlit9422;
  partcv[0] = 1;
  Object call9423 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9421);
// compiled call node returning call9423 (depth = 6)
  Object if9420 = done;
  if (istrue(call9423)) {
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9425 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9426 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9425);
// compiled call node returning call9426 (depth = 7)
// compiled member node returning call9426 (depth = 6)
    gc_frame_newslot(call9426);
    if9420 = call9426;
  } else {
// Begin line 2933
  setline(2933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9429 == NULL) {
    strlit9429 = alloc_String("rparen");
    gc_root(strlit9429);
  }
// compiled string node returning strlit9429 (depth = 8)
  int op_slot_right_9428 = gc_frame_newslot(strlit9429);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9431 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9432 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9431);
// compiled call node returning call9432 (depth = 9)
// compiled member node returning call9432 (depth = 8)
  int op_slot_left_9428 = gc_frame_newslot(call9432);
  params[0] = strlit9429;
  partcv[0] = 1;
  Object opresult9433 = callmethod(call9432, "!=", 1, partcv, params);
// compiled op node returning opresult9433 (depth = 7)
  Object if9427 = done;
  if (istrue(opresult9433)) {
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9436 == NULL) {
    strlit9436 = alloc_String("rparen");
    gc_root(strlit9436);
  }
// compiled string node returning strlit9436 (depth = 9)
  int op_slot_right_9435 = gc_frame_newslot(strlit9436);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9439 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9438);
// compiled call node returning call9439 (depth = 10)
// compiled member node returning call9439 (depth = 9)
  int op_slot_left_9435 = gc_frame_newslot(call9439);
  params[0] = strlit9436;
  partcv[0] = 1;
  Object opresult9440 = callmethod(call9439, "!=", 1, partcv, params);
// compiled op node returning opresult9440 (depth = 8)
  Object if9434 = done;
  if (istrue(opresult9440)) {
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9441 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9442 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9443 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9442);
// compiled call node returning call9443 (depth = 12)
// compiled member node returning call9443 (depth = 11)
  partcv[0] = 0;
  Object call9444 = callmethod(call9443, "new",
    1, partcv, params);
  gc_frame_end(callframe9441);
// compiled call node returning call9444 (depth = 10)
// compiled member node returning call9444 (depth = 9)
  *var_suggestion = call9444;
  if (call9444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9445 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9446 == NULL) {
    strlit9446 = alloc_String(")");
    gc_root(strlit9446);
  }
// compiled string node returning strlit9446 (depth = 9)
  gc_frame_newslot(strlit9446);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9446;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9447 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9445);
// compiled call node returning call9447 (depth = 8)
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9448 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9449 == NULL) {
    strlit9449 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9449);
  }
// compiled string node returning strlit9449 (depth = 9)
  gc_frame_newslot(strlit9449);
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9451 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9450);
// compiled call node returning call9451 (depth = 10)
// compiled member node returning call9451 (depth = 9)
  gc_frame_newslot(call9451);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9453 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9454 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9453);
// compiled call node returning call9454 (depth = 11)
// compiled member node returning call9454 (depth = 10)
  int op_slot_right_9452 = gc_frame_newslot(call9454);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9457 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9456);
// compiled call node returning call9457 (depth = 11)
// compiled member node returning call9457 (depth = 10)
  int op_slot_left_9452 = gc_frame_newslot(call9457);
  params[0] = call9454;
  partcv[0] = 1;
  Object sum9458 = callmethod(call9457, "+", 1, partcv, params);
// compiled op node returning sum9458 (depth = 9)
  gc_frame_newslot(sum9458);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9449;
  params[1] = call9451;
  params[2] = sum9458;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9459 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9448);
// compiled call node returning call9459 (depth = 8)
    gc_frame_newslot(call9459);
    if9434 = call9459;
  } else {
  }
// compiled if node returning if9434 (depth = 7)
    gc_frame_newslot(if9434);
    if9427 = if9434;
  } else {
  }
// compiled if node returning if9427 (depth = 6)
    gc_frame_newslot(if9427);
    if9420 = if9427;
  }
// compiled if node returning if9420 (depth = 5)
  gc_frame_end(frame);
  return if9420;
}
Object meth_parser__apply9475(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9478 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9479 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9478);
// compiled call node returning call9479 (depth = 10)
// compiled member node returning call9479 (depth = 9)
  int op_slot_right_9477 = gc_frame_newslot(call9479);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call9482 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9481);
// compiled call node returning call9482 (depth = 10)
// compiled member node returning call9482 (depth = 9)
  int op_slot_left_9477 = gc_frame_newslot(call9482);
  params[0] = call9479;
  partcv[0] = 1;
  Object opresult9483 = callmethod(call9482, "==", 1, partcv, params);
// compiled op node returning opresult9483 (depth = 8)
  int op_slot_right_9476 = gc_frame_newslot(opresult9483);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9486 == NULL) {
    strlit9486 = alloc_String("rparen");
    gc_root(strlit9486);
  }
// compiled string node returning strlit9486 (depth = 9)
  int op_slot_right_9485 = gc_frame_newslot(strlit9486);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call9489 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9488);
// compiled call node returning call9489 (depth = 10)
// compiled member node returning call9489 (depth = 9)
  int op_slot_left_9485 = gc_frame_newslot(call9489);
  params[0] = strlit9486;
  partcv[0] = 1;
  Object opresult9490 = callmethod(call9489, "==", 1, partcv, params);
// compiled op node returning opresult9490 (depth = 8)
  int op_slot_left_9476 = gc_frame_newslot(opresult9490);
  params[0] = opresult9483;
  partcv[0] = 1;
  Object opresult9491 = callmethod(opresult9490, "&&", 1, partcv, params);
// compiled op node returning opresult9491 (depth = 7)
  gc_frame_end(frame);
  return opresult9491;
}
Object meth_parser_methodsignature8936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(19, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
  Object *var_myTypeParams = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "myTypeParams");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_varargs = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "varargs");
  Object *var_vararg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "vararg");
  Object *var_lparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "lparen");
  Object *var_id = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "id");
  Object *var_comma = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "comma");
  Object *var_rparen = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "rparen");
  Object *var_tm = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "tm");
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8940 == NULL) {
    strlit8940 = alloc_String("lsquare");
    gc_root(strlit8940);
  }
// compiled string node returning strlit8940 (depth = 5)
  int op_slot_right_8939 = gc_frame_newslot(strlit8940);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8943 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8942);
// compiled call node returning call8943 (depth = 6)
// compiled member node returning call8943 (depth = 5)
  int op_slot_left_8939 = gc_frame_newslot(call8943);
  params[0] = strlit8940;
  partcv[0] = 1;
  Object opresult8944 = callmethod(call8943, "!=", 1, partcv, params);
// compiled op node returning opresult8944 (depth = 4)
  int op_slot_right_8938 = gc_frame_newslot(opresult8944);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8948 == NULL) {
    strlit8948 = alloc_String("op");
    gc_root(strlit8948);
  }
// compiled string node returning strlit8948 (depth = 6)
  int op_slot_right_8947 = gc_frame_newslot(strlit8948);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8951 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8950);
// compiled call node returning call8951 (depth = 7)
// compiled member node returning call8951 (depth = 6)
  int op_slot_left_8947 = gc_frame_newslot(call8951);
  params[0] = strlit8948;
  partcv[0] = 1;
  Object opresult8952 = callmethod(call8951, "!=", 1, partcv, params);
// compiled op node returning opresult8952 (depth = 5)
  int op_slot_right_8946 = gc_frame_newslot(opresult8952);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8955 == NULL) {
    strlit8955 = alloc_String("identifier");
    gc_root(strlit8955);
  }
// compiled string node returning strlit8955 (depth = 6)
  int op_slot_right_8954 = gc_frame_newslot(strlit8955);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8958 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8957);
// compiled call node returning call8958 (depth = 7)
// compiled member node returning call8958 (depth = 6)
  int op_slot_left_8954 = gc_frame_newslot(call8958);
  params[0] = strlit8955;
  partcv[0] = 1;
  Object opresult8959 = callmethod(call8958, "!=", 1, partcv, params);
// compiled op node returning opresult8959 (depth = 5)
  int op_slot_left_8946 = gc_frame_newslot(opresult8959);
  params[0] = opresult8952;
  partcv[0] = 1;
  Object opresult8960 = callmethod(opresult8959, "&&", 1, partcv, params);
// compiled op node returning opresult8960 (depth = 4)
  int op_slot_left_8938 = gc_frame_newslot(opresult8960);
  params[0] = opresult8944;
  partcv[0] = 1;
  Object opresult8961 = callmethod(opresult8960, "&&", 1, partcv, params);
// compiled op node returning opresult8961 (depth = 3)
  Object if8937 = done;
  if (istrue(opresult8961)) {
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8962 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call8964 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8963);
// compiled call node returning call8964 (depth = 7)
// compiled member node returning call8964 (depth = 6)
  partcv[0] = 0;
  Object call8965 = callmethod(call8964, "new",
    1, partcv, params);
  gc_frame_end(callframe8962);
// compiled call node returning call8965 (depth = 5)
// compiled member node returning call8965 (depth = 4)
  *var_suggestion = call8965;
  if (call8965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8966 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8967 == NULL) {
    strlit8967 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8967);
  }
// compiled string node returning strlit8967 (depth = 4)
  gc_frame_newslot(strlit8967);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit8967;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8968 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8966);
// compiled call node returning call8968 (depth = 3)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8969 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8970 == NULL) {
    strlit8970 = alloc_String("a method name must start with an identifier, or be an operator or '[]'.");
    gc_root(strlit8970);
  }
// compiled string node returning strlit8970 (depth = 4)
  gc_frame_newslot(strlit8970);
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8972 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8971);
// compiled call node returning call8972 (depth = 5)
// compiled member node returning call8972 (depth = 4)
  gc_frame_newslot(call8972);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8975 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8974);
// compiled call node returning call8975 (depth = 6)
// compiled member node returning call8975 (depth = 5)
  int op_slot_right_8973 = gc_frame_newslot(call8975);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8977 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8978 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8977);
// compiled call node returning call8978 (depth = 6)
// compiled member node returning call8978 (depth = 5)
  int op_slot_left_8973 = gc_frame_newslot(call8978);
  params[0] = call8975;
  partcv[0] = 1;
  Object sum8979 = callmethod(call8978, "+", 1, partcv, params);
// compiled op node returning sum8979 (depth = 4)
  gc_frame_newslot(sum8979);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8970;
  params[1] = call8972;
  params[2] = sum8979;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8980 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8969);
// compiled call node returning call8980 (depth = 3)
    gc_frame_newslot(call8980);
    if8937 = call8980;
  } else {
  }
// compiled if node returning if8937 (depth = 2)
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8982 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8981);
// compiled call node returning call8982 (depth = 3)
// compiled member node returning call8982 (depth = 2)
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8984 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8983);
// compiled call node returning call8984 (depth = 4)
// compiled member node returning call8984 (depth = 3)
  *var_meth = call8984;
  if (call8984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8985 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8986 = alloc_Boolean(1);
// compiled identifier node returning bool8986 (depth = 3)
  gc_frame_newslot(bool8986);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool8986;
  partcv[0] = 1;
  Object call8987 = callmethod(*var_meth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8985);
// compiled call node returning call8987 (depth = 2)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8988 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8989 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8990 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8989);
// compiled call node returning call8990 (depth = 6)
// compiled member node returning call8990 (depth = 5)
  partcv[0] = 0;
  Object call8991 = callmethod(call8990, "empty",
    1, partcv, params);
  gc_frame_end(callframe8988);
// compiled call node returning call8991 (depth = 4)
// compiled member node returning call8991 (depth = 3)
  *var_signature = call8991;
  if (call8991 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8992 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call8994 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8993);
// compiled call node returning call8994 (depth = 5)
// compiled member node returning call8994 (depth = 4)
  gc_frame_newslot(call8994);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8996 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8995);
// compiled call node returning call8996 (depth = 5)
// compiled member node returning call8996 (depth = 4)
  params[0] = call8994;
  partcv[0] = 1;
  Object call8997 = callmethod(call8996, "partName",
    1, partcv, params);
  gc_frame_end(callframe8992);
// compiled call node returning call8997 (depth = 3)
  *var_part = call8997;
  if (call8997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8998 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call9000 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe8999);
// compiled call node returning call9000 (depth = 4)
// compiled member node returning call9000 (depth = 3)
  gc_frame_newslot(call9000);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call9000;
  partcv[0] = 1;
  Object call9001 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe8998);
// compiled call node returning call9001 (depth = 2)
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9002 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call9004 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9003);
// compiled call node returning call9004 (depth = 4)
// compiled member node returning call9004 (depth = 3)
  gc_frame_newslot(call9004);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call9004;
  partcv[0] = 1;
  Object call9005 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9002);
// compiled call node returning call9005 (depth = 2)
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9006 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9007 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9006);
// compiled call node returning call9007 (depth = 2)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9010 == NULL) {
    strlit9010 = alloc_String("[");
    gc_root(strlit9010);
  }
// compiled string node returning strlit9010 (depth = 4)
  int op_slot_right_9009 = gc_frame_newslot(strlit9010);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9013 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9012);
// compiled call node returning call9013 (depth = 5)
// compiled member node returning call9013 (depth = 4)
  int op_slot_left_9009 = gc_frame_newslot(call9013);
  params[0] = strlit9010;
  partcv[0] = 1;
  Object opresult9014 = callmethod(call9013, "==", 1, partcv, params);
// compiled op node returning opresult9014 (depth = 3)
  Object if9008 = done;
  if (istrue(opresult9014)) {
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9017 == NULL) {
    strlit9017 = alloc_String("rsquare");
    gc_root(strlit9017);
  }
// compiled string node returning strlit9017 (depth = 5)
  int op_slot_right_9016 = gc_frame_newslot(strlit9017);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9020 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9019);
// compiled call node returning call9020 (depth = 6)
// compiled member node returning call9020 (depth = 5)
  int op_slot_left_9016 = gc_frame_newslot(call9020);
  params[0] = strlit9017;
  partcv[0] = 1;
  Object opresult9021 = callmethod(call9020, "!=", 1, partcv, params);
// compiled op node returning opresult9021 (depth = 4)
  Object if9015 = done;
  if (istrue(opresult9021)) {
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9024 = gc_frame_new();
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 7)
  Object block9025 = alloc_Block(NULL, NULL, "parser", 2830);
  gc_frame_newslot(block9025);
// method "_apply"
  block_savedest(block9025);
  Object closure9026 = createclosure(2, "_apply");
  setclosureframe(closure9026, stackframe);
  addtoclosure(closure9026, var_tokens);
  addtoclosure(closure9026, selfslot);
  struct UserObject *uo9026 = (struct UserObject*)block9025;
  uo9026->data[0] = (Object)closure9026;
  Method *meth_meth_parser__apply9026 = addmethod2pos(block9025, "_apply", &meth_parser__apply9026, 0);
  int argcv_meth_parser__apply9026[] = {0};
  meth_meth_parser__apply9026->type = alloc_MethodType(1, argcv_meth_parser__apply9026);
  meth_meth_parser__apply9026->definitionModule = modulename;
  meth_meth_parser__apply9026->definitionLine = 2828;
// compiled block node returning block9025 (depth = 7)
  gc_frame_newslot(block9025);
// call case 6: other member request
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9037 = alloc_Float64(0);
// compiled num node returning num9037 (depth = 8)
  int op_slot_right_9036 = gc_frame_newslot(num9037);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9040 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9039);
// compiled call node returning call9040 (depth = 9)
// compiled member node returning call9040 (depth = 8)
  int op_slot_left_9036 = gc_frame_newslot(call9040);
  params[0] = num9037;
  partcv[0] = 1;
  Object opresult9041 = callmethod(call9040, "==", 1, partcv, params);
// compiled op node returning opresult9041 (depth = 7)
  params[0] = block9025;
  partcv[0] = 1;
  Object call9042 = callmethod(opresult9041, "orElse",
    1, partcv, params);
  gc_frame_end(callframe9024);
// compiled call node returning call9042 (depth = 6)
  int op_slot_right_9023 = gc_frame_newslot(call9042);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String("identifier");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 7)
  int op_slot_right_9044 = gc_frame_newslot(strlit9045);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9047 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9048 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9047);
// compiled call node returning call9048 (depth = 8)
// compiled member node returning call9048 (depth = 7)
  int op_slot_left_9044 = gc_frame_newslot(call9048);
  params[0] = strlit9045;
  partcv[0] = 1;
  Object opresult9049 = callmethod(call9048, "==", 1, partcv, params);
// compiled op node returning opresult9049 (depth = 6)
  int op_slot_left_9023 = gc_frame_newslot(opresult9049);
  params[0] = call9042;
  partcv[0] = 1;
  Object opresult9050 = callmethod(opresult9049, "&&", 1, partcv, params);
// compiled op node returning opresult9050 (depth = 5)
  Object if9022 = done;
  if (istrue(opresult9050)) {
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9051 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9052 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9053 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9052);
// compiled call node returning call9053 (depth = 9)
// compiled member node returning call9053 (depth = 8)
  partcv[0] = 0;
  Object call9054 = callmethod(call9053, "empty",
    1, partcv, params);
  gc_frame_end(callframe9051);
// compiled call node returning call9054 (depth = 7)
// compiled member node returning call9054 (depth = 6)
  *var_suggestions = call9054;
  if (call9054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9055 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9057 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9056);
// compiled call node returning call9057 (depth = 9)
// compiled member node returning call9057 (depth = 8)
  partcv[0] = 0;
  Object call9058 = callmethod(call9057, "new",
    1, partcv, params);
  gc_frame_end(callframe9055);
// compiled call node returning call9058 (depth = 7)
// compiled member node returning call9058 (depth = 6)
  *var_suggestion = call9058;
  if (call9058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9061 = alloc_Float64(0);
// compiled num node returning num9061 (depth = 7)
  int op_slot_right_9060 = gc_frame_newslot(num9061);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9063 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call9064 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9063);
// compiled call node returning call9064 (depth = 8)
// compiled member node returning call9064 (depth = 7)
  int op_slot_left_9060 = gc_frame_newslot(call9064);
  params[0] = num9061;
  partcv[0] = 1;
  Object opresult9065 = callmethod(call9064, "==", 1, partcv, params);
// compiled op node returning opresult9065 (depth = 6)
  Object if9059 = done;
  if (istrue(opresult9065)) {
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9066 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9068 == NULL) {
    strlit9068 = alloc_String(")");
    gc_root(strlit9068);
  }
// compiled string node returning strlit9068 (depth = 8)
  int op_slot_right_9067 = gc_frame_newslot(strlit9068);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9072 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9071);
// compiled call node returning call9072 (depth = 10)
// compiled member node returning call9072 (depth = 9)
  int op_slot_right_9070 = gc_frame_newslot(call9072);
// starting to compile string node (depth = 9)
  if (strlit9074 == NULL) {
    strlit9074 = alloc_String("](");
    gc_root(strlit9074);
  }
// compiled string node returning strlit9074 (depth = 9)
  int op_slot_left_9070 = gc_frame_newslot(strlit9074);
  params[0] = call9072;
  partcv[0] = 1;
  Object opresult9075 = callmethod(strlit9074, "++", 1, partcv, params);
// compiled op node returning opresult9075 (depth = 8)
  int op_slot_left_9067 = gc_frame_newslot(opresult9075);
  params[0] = strlit9068;
  partcv[0] = 1;
  Object opresult9076 = callmethod(opresult9075, "++", 1, partcv, params);
// compiled op node returning opresult9076 (depth = 7)
  gc_frame_newslot(opresult9076);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = opresult9076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9077 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9066);
// compiled call node returning call9077 (depth = 6)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9078 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9079 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9078);
// compiled call node returning call9079 (depth = 6)
    gc_frame_newslot(call9079);
    if9059 = call9079;
  } else {
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9082 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call9083 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9082);
// compiled call node returning call9083 (depth = 9)
// compiled member node returning call9083 (depth = 8)
  int op_slot_right_9081 = gc_frame_newslot(call9083);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9085 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  partcv[0] = 0;
  Object call9087 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9086);
// compiled call node returning call9087 (depth = 11)
// compiled member node returning call9087 (depth = 10)
  partcv[0] = 0;
  Object call9088 = callmethod(call9087, "line",
    1, partcv, params);
  gc_frame_end(callframe9085);
// compiled call node returning call9088 (depth = 9)
// compiled member node returning call9088 (depth = 8)
  int op_slot_left_9081 = gc_frame_newslot(call9088);
  params[0] = call9083;
  partcv[0] = 1;
  Object opresult9089 = callmethod(call9088, "==", 1, partcv, params);
// compiled op node returning opresult9089 (depth = 7)
  Object if9080 = done;
  if (istrue(opresult9089)) {
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9090 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9092 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9091);
// compiled call node returning call9092 (depth = 9)
// compiled member node returning call9092 (depth = 8)
  gc_frame_newslot(call9092);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9094 == NULL) {
    strlit9094 = alloc_String(")");
    gc_root(strlit9094);
  }
// compiled string node returning strlit9094 (depth = 9)
  int op_slot_right_9093 = gc_frame_newslot(strlit9094);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9098 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9097);
// compiled call node returning call9098 (depth = 11)
// compiled member node returning call9098 (depth = 10)
  int op_slot_right_9096 = gc_frame_newslot(call9098);
// starting to compile string node (depth = 10)
  if (strlit9100 == NULL) {
    strlit9100 = alloc_String("](");
    gc_root(strlit9100);
  }
// compiled string node returning strlit9100 (depth = 10)
  int op_slot_left_9096 = gc_frame_newslot(strlit9100);
  params[0] = call9098;
  partcv[0] = 1;
  Object opresult9101 = callmethod(strlit9100, "++", 1, partcv, params);
// compiled op node returning opresult9101 (depth = 9)
  int op_slot_left_9093 = gc_frame_newslot(opresult9101);
  params[0] = strlit9094;
  partcv[0] = 1;
  Object opresult9102 = callmethod(opresult9101, "++", 1, partcv, params);
// compiled op node returning opresult9102 (depth = 8)
  gc_frame_newslot(opresult9102);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call9092;
  params[2] = opresult9102;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9103 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9090);
// compiled call node returning call9103 (depth = 7)
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9104 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9105 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9104);
// compiled call node returning call9105 (depth = 7)
    gc_frame_newslot(call9105);
    if9080 = call9105;
  } else {
  }
// compiled if node returning if9080 (depth = 6)
    gc_frame_newslot(if9080);
    if9059 = if9080;
  }
// compiled if node returning if9059 (depth = 5)
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9106 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9107 == NULL) {
    strlit9107 = alloc_String("a method named '[]' must have a single parameter in parentheses after the '[]'.");
    gc_root(strlit9107);
  }
// compiled string node returning strlit9107 (depth = 6)
  gc_frame_newslot(strlit9107);
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9109 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9108);
// compiled call node returning call9109 (depth = 7)
// compiled member node returning call9109 (depth = 6)
  gc_frame_newslot(call9109);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9112 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9111);
// compiled call node returning call9112 (depth = 8)
// compiled member node returning call9112 (depth = 7)
  int op_slot_right_9110 = gc_frame_newslot(call9112);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9115 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9114);
// compiled call node returning call9115 (depth = 8)
// compiled member node returning call9115 (depth = 7)
  int op_slot_left_9110 = gc_frame_newslot(call9115);
  params[0] = call9112;
  partcv[0] = 1;
  Object sum9116 = callmethod(call9115, "+", 1, partcv, params);
// compiled op node returning sum9116 (depth = 6)
  gc_frame_newslot(sum9116);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9107;
  params[1] = call9109;
  params[2] = sum9116;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9117 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9106);
// compiled call node returning call9117 (depth = 5)
    gc_frame_newslot(call9117);
    if9022 = call9117;
  } else {
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9118 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9120 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9119);
// compiled call node returning call9120 (depth = 9)
// compiled member node returning call9120 (depth = 8)
  partcv[0] = 0;
  Object call9121 = callmethod(call9120, "new",
    1, partcv, params);
  gc_frame_end(callframe9118);
// compiled call node returning call9121 (depth = 7)
// compiled member node returning call9121 (depth = 6)
  *var_suggestion = call9121;
  if (call9121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9122 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9123 == NULL) {
    strlit9123 = alloc_String("]");
    gc_root(strlit9123);
  }
// compiled string node returning strlit9123 (depth = 6)
  gc_frame_newslot(strlit9123);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9123;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9124 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9122);
// compiled call node returning call9124 (depth = 5)
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9125 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9126 == NULL) {
    strlit9126 = alloc_String("a method name must start with either an identifier or '[]'.");
    gc_root(strlit9126);
  }
// compiled string node returning strlit9126 (depth = 6)
  gc_frame_newslot(strlit9126);
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9128 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9127);
// compiled call node returning call9128 (depth = 7)
// compiled member node returning call9128 (depth = 6)
  gc_frame_newslot(call9128);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9131 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9130);
// compiled call node returning call9131 (depth = 8)
// compiled member node returning call9131 (depth = 7)
  int op_slot_right_9129 = gc_frame_newslot(call9131);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9133 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9134 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9133);
// compiled call node returning call9134 (depth = 8)
// compiled member node returning call9134 (depth = 7)
  int op_slot_left_9129 = gc_frame_newslot(call9134);
  params[0] = call9131;
  partcv[0] = 1;
  Object sum9135 = callmethod(call9134, "+", 1, partcv, params);
// compiled op node returning sum9135 (depth = 6)
  gc_frame_newslot(sum9135);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9126;
  params[1] = call9128;
  params[2] = sum9135;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9136 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9125);
// compiled call node returning call9136 (depth = 5)
    gc_frame_newslot(call9136);
    if9022 = call9136;
  }
// compiled if node returning if9022 (depth = 4)
    gc_frame_newslot(if9022);
    if9015 = if9022;
  } else {
  }
// compiled if node returning if9015 (depth = 3)
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9137 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9138 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9137);
// compiled call node returning call9138 (depth = 4)
// compiled member node returning call9138 (depth = 3)
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9139 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9140 == NULL) {
    strlit9140 = alloc_String("[]");
    gc_root(strlit9140);
  }
// compiled string node returning strlit9140 (depth = 4)
  gc_frame_newslot(strlit9140);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = strlit9140;
  partcv[0] = 1;
  Object call9141 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9139);
// compiled call node returning call9141 (depth = 3)
    gc_frame_newslot(call9141);
    if9008 = call9141;
  } else {
  }
// compiled if node returning if9008 (depth = 2)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9142 = alloc_Boolean(0);
// compiled identifier node returning bool9142 (depth = 3)
  *var_myTypeParams = bool9142;
  if (bool9142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9144 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9145 == NULL) {
    strlit9145 = alloc_String("lgeneric");
    gc_root(strlit9145);
  }
// compiled string node returning strlit9145 (depth = 4)
  gc_frame_newslot(strlit9145);
// call case 4: self request
  params[0] = strlit9145;
  partcv[0] = 1;
  Object call9146 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9144);
// compiled call node returning call9146 (depth = 3)
  Object if9143 = done;
  if (istrue(call9146)) {
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9148 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9147);
// compiled call node returning call9148 (depth = 5)
// compiled member node returning call9148 (depth = 4)
  *var_myTypeParams = call9148;
  if (call9148 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9143 = done;
  } else {
  }
// compiled if node returning if9143 (depth = 2)
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9151 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9152 == NULL) {
    strlit9152 = alloc_String("bind");
    gc_root(strlit9152);
  }
// compiled string node returning strlit9152 (depth = 4)
  gc_frame_newslot(strlit9152);
// call case 4: self request
  params[0] = strlit9152;
  partcv[0] = 1;
  Object call9153 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9151);
// compiled call node returning call9153 (depth = 3)
  Object if9150 = done;
  if (istrue(call9153)) {
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9154 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9155 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9154);
// compiled call node returning call9155 (depth = 4)
// compiled member node returning call9155 (depth = 3)
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9156 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9158 == NULL) {
    strlit9158 = alloc_String(":=");
    gc_root(strlit9158);
  }
// compiled string node returning strlit9158 (depth = 5)
  int op_slot_right_9157 = gc_frame_newslot(strlit9158);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call9161 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9160);
// compiled call node returning call9161 (depth = 6)
// compiled member node returning call9161 (depth = 5)
  int op_slot_left_9157 = gc_frame_newslot(call9161);
  params[0] = strlit9158;
  partcv[0] = 1;
  Object opresult9162 = callmethod(call9161, "++", 1, partcv, params);
// compiled op node returning opresult9162 (depth = 4)
  gc_frame_newslot(opresult9162);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = opresult9162;
  partcv[0] = 1;
  Object call9163 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9156);
// compiled call node returning call9163 (depth = 3)
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9164 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9166 == NULL) {
    strlit9166 = alloc_String(":=");
    gc_root(strlit9166);
  }
// compiled string node returning strlit9166 (depth = 5)
  int op_slot_right_9165 = gc_frame_newslot(strlit9166);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9169 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9168);
// compiled call node returning call9169 (depth = 6)
// compiled member node returning call9169 (depth = 5)
  int op_slot_left_9165 = gc_frame_newslot(call9169);
  params[0] = strlit9166;
  partcv[0] = 1;
  Object opresult9170 = callmethod(call9169, "++", 1, partcv, params);
// compiled op node returning opresult9170 (depth = 4)
  gc_frame_newslot(opresult9170);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult9170;
  partcv[0] = 1;
  Object call9171 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9164);
// compiled call node returning call9171 (depth = 3)
    gc_frame_newslot(call9171);
    if9150 = call9171;
  } else {
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9175 == NULL) {
    strlit9175 = alloc_String("prefix");
    gc_root(strlit9175);
  }
// compiled string node returning strlit9175 (depth = 6)
  int op_slot_right_9174 = gc_frame_newslot(strlit9175);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9178 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9177);
// compiled call node returning call9178 (depth = 7)
// compiled member node returning call9178 (depth = 6)
  int op_slot_left_9174 = gc_frame_newslot(call9178);
  params[0] = strlit9175;
  partcv[0] = 1;
  Object opresult9179 = callmethod(call9178, "==", 1, partcv, params);
// compiled op node returning opresult9179 (depth = 5)
  int op_slot_right_9173 = gc_frame_newslot(opresult9179);
// starting to compile call node (depth = 5)
  int callframe9181 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9182 == NULL) {
    strlit9182 = alloc_String("op");
    gc_root(strlit9182);
  }
// compiled string node returning strlit9182 (depth = 6)
  gc_frame_newslot(strlit9182);
// call case 4: self request
  params[0] = strlit9182;
  partcv[0] = 1;
  Object call9183 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9181);
// compiled call node returning call9183 (depth = 5)
  int op_slot_left_9173 = gc_frame_newslot(call9183);
  params[0] = opresult9179;
  partcv[0] = 1;
  Object opresult9184 = callmethod(call9183, "&&", 1, partcv, params);
// compiled op node returning opresult9184 (depth = 4)
  Object if9172 = done;
  if (istrue(opresult9184)) {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9185 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9188 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9187);
// compiled call node returning call9188 (depth = 7)
// compiled member node returning call9188 (depth = 6)
  int op_slot_right_9186 = gc_frame_newslot(call9188);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9190 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9191 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9190);
// compiled call node returning call9191 (depth = 7)
// compiled member node returning call9191 (depth = 6)
  int op_slot_left_9186 = gc_frame_newslot(call9191);
  params[0] = call9188;
  partcv[0] = 1;
  Object opresult9192 = callmethod(call9191, "++", 1, partcv, params);
// compiled op node returning opresult9192 (depth = 5)
  gc_frame_newslot(opresult9192);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = opresult9192;
  partcv[0] = 1;
  Object call9193 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9185);
// compiled call node returning call9193 (depth = 4)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9194 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9197 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9196);
// compiled call node returning call9197 (depth = 7)
// compiled member node returning call9197 (depth = 6)
  int op_slot_right_9195 = gc_frame_newslot(call9197);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9199 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9200 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9199);
// compiled call node returning call9200 (depth = 7)
// compiled member node returning call9200 (depth = 6)
  int op_slot_left_9195 = gc_frame_newslot(call9200);
  params[0] = call9197;
  partcv[0] = 1;
  Object opresult9201 = callmethod(call9200, "++", 1, partcv, params);
// compiled op node returning opresult9201 (depth = 5)
  gc_frame_newslot(opresult9201);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult9201;
  partcv[0] = 1;
  Object call9202 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9194);
// compiled call node returning call9202 (depth = 4)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9203 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9204 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9203);
// compiled call node returning call9204 (depth = 5)
// compiled member node returning call9204 (depth = 4)
    gc_frame_newslot(call9204);
    if9172 = call9204;
  } else {
  }
// compiled if node returning if9172 (depth = 3)
    gc_frame_newslot(if9172);
    if9150 = if9172;
  }
// compiled if node returning if9150 (depth = 2)
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9205 = alloc_Boolean(0);
// compiled identifier node returning bool9205 (depth = 3)
  *var_dtype = bool9205;
  if (bool9205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9206 = alloc_Boolean(0);
// compiled identifier node returning bool9206 (depth = 3)
  *var_varargs = bool9206;
  if (bool9206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9207 = alloc_Boolean(0);
// compiled identifier node returning bool9207 (depth = 3)
  *var_vararg = bool9207;
  if (bool9207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9209 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9210 == NULL) {
    strlit9210 = alloc_String("lparen");
    gc_root(strlit9210);
  }
// compiled string node returning strlit9210 (depth = 4)
  gc_frame_newslot(strlit9210);
// call case 4: self request
  params[0] = strlit9210;
  partcv[0] = 1;
  Object call9211 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9209);
// compiled call node returning call9211 (depth = 3)
  Object if9208 = done;
  if (istrue(call9211)) {
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9212 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9214 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9213);
// compiled call node returning call9214 (depth = 5)
// compiled member node returning call9214 (depth = 4)
  gc_frame_newslot(call9214);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call9214;
  partcv[0] = 1;
  Object call9215 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9212);
// compiled call node returning call9215 (depth = 3)
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9217 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9216);
// compiled call node returning call9217 (depth = 4)
// compiled member node returning call9217 (depth = 3)
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9218 = alloc_Boolean(0);
// compiled identifier node returning bool9218 (depth = 4)
  *var_comma = bool9218;
  if (bool9218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9219 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9220 = alloc_Block(NULL, NULL, "parser", 2872);
  gc_frame_newslot(block9220);
// method "_apply"
  block_savedest(block9220);
  Object closure9221 = createclosure(2, "_apply");
  setclosureframe(closure9221, stackframe);
  addtoclosure(closure9221, var_sym);
  addtoclosure(closure9221, selfslot);
  struct UserObject *uo9221 = (struct UserObject*)block9220;
  uo9221->data[0] = (Object)closure9221;
  Method *meth_meth_parser__apply9221 = addmethod2pos(block9220, "_apply", &meth_parser__apply9221, 0);
  int argcv_meth_parser__apply9221[] = {0};
  meth_meth_parser__apply9221->type = alloc_MethodType(1, argcv_meth_parser__apply9221);
  meth_meth_parser__apply9221->definitionModule = modulename;
  meth_meth_parser__apply9221->definitionLine = 2869;
// compiled block node returning block9220 (depth = 4)
  gc_frame_newslot(block9220);
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block9241 = alloc_Block(NULL, NULL, "parser", 2873);
  gc_frame_newslot(block9241);
// method "_apply"
  block_savedest(block9241);
  Object closure9242 = createclosure(12, "_apply");
  setclosureframe(closure9242, stackframe);
  addtoclosure(closure9242, var_sym);
  addtoclosure(closure9242, var_errormessages);
  addtoclosure(closure9242, var_lastToken);
  addtoclosure(closure9242, var_comma);
  addtoclosure(closure9242, var_vararg);
  addtoclosure(closure9242, var_varargs);
  addtoclosure(closure9242, var_values);
  addtoclosure(closure9242, var_id);
  addtoclosure(closure9242, var_dtype);
  addtoclosure(closure9242, var_part);
  addtoclosure(closure9242, var_lparen);
  addtoclosure(closure9242, selfslot);
  struct UserObject *uo9242 = (struct UserObject*)block9241;
  uo9242->data[0] = (Object)closure9242;
  Method *meth_meth_parser__apply9242 = addmethod2pos(block9241, "_apply", &meth_parser__apply9242, 0);
  int argcv_meth_parser__apply9242[] = {0};
  meth_meth_parser__apply9242->type = alloc_MethodType(1, argcv_meth_parser__apply9242);
  meth_meth_parser__apply9242->definitionModule = modulename;
  meth_meth_parser__apply9242->definitionLine = 2873;
// compiled block node returning block9241 (depth = 4)
  gc_frame_newslot(block9241);
// call case 5: prelude request
  params[0] = block9220;
  params[1] = block9241;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9461 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9219);
// compiled call node returning call9461 (depth = 3)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9464 == NULL) {
    strlit9464 = alloc_String("rparen");
    gc_root(strlit9464);
  }
// compiled string node returning strlit9464 (depth = 5)
  int op_slot_right_9463 = gc_frame_newslot(strlit9464);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9466 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9467 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9466);
// compiled call node returning call9467 (depth = 6)
// compiled member node returning call9467 (depth = 5)
  int op_slot_left_9463 = gc_frame_newslot(call9467);
  params[0] = strlit9464;
  partcv[0] = 1;
  Object opresult9468 = callmethod(call9467, "!=", 1, partcv, params);
// compiled op node returning opresult9468 (depth = 4)
  Object if9462 = done;
  if (istrue(opresult9468)) {
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9469 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9471 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9470);
// compiled call node returning call9471 (depth = 8)
// compiled member node returning call9471 (depth = 7)
  partcv[0] = 0;
  Object call9472 = callmethod(call9471, "new",
    1, partcv, params);
  gc_frame_end(callframe9469);
// compiled call node returning call9472 (depth = 6)
// compiled member node returning call9472 (depth = 5)
  *var_suggestion = call9472;
  if (call9472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9473 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9474 = alloc_Block(NULL, NULL, "parser", 2936);
  gc_frame_newslot(block9474);
// method "_apply"
  block_savedest(block9474);
  Object closure9475 = createclosure(2, "_apply");
  setclosureframe(closure9475, stackframe);
  addtoclosure(closure9475, var_lastToken);
  addtoclosure(closure9475, selfslot);
  struct UserObject *uo9475 = (struct UserObject*)block9474;
  uo9475->data[0] = (Object)closure9475;
  Method *meth_meth_parser__apply9475 = addmethod2pos(block9474, "_apply", &meth_parser__apply9475, 0);
  int argcv_meth_parser__apply9475[] = {1};
  meth_meth_parser__apply9475->type = alloc_MethodType(1, argcv_meth_parser__apply9475);
  meth_meth_parser__apply9475->definitionModule = modulename;
  meth_meth_parser__apply9475->definitionLine = 2935;
// compiled block node returning block9474 (depth = 6)
  gc_frame_newslot(block9474);
// call case 4: self request
  params[0] = block9474;
  partcv[0] = 1;
  Object call9493 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9473);
// compiled call node returning call9493 (depth = 5)
  *var_rparen = call9493;
  if (call9493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9496 = alloc_Boolean(0);
// compiled identifier node returning bool9496 (depth = 6)
  int op_slot_right_9495 = gc_frame_newslot(bool9496);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_left_9495 = gc_frame_newslot(*var_rparen);
  params[0] = bool9496;
  partcv[0] = 1;
  Object opresult9498 = callmethod(*var_rparen, "==", 1, partcv, params);
// compiled op node returning opresult9498 (depth = 5)
  Object if9494 = done;
  if (istrue(opresult9498)) {
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9499 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit9500 == NULL) {
    strlit9500 = alloc_String(")");
    gc_root(strlit9500);
  }
// compiled string node returning strlit9500 (depth = 6)
  gc_frame_newslot(strlit9500);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit9500;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9501 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9499);
// compiled call node returning call9501 (depth = 5)
    gc_frame_newslot(call9501);
    if9494 = call9501;
  } else {
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9502 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9503 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9502);
// compiled call node returning call9503 (depth = 5)
    gc_frame_newslot(call9503);
    if9494 = call9503;
  }
// compiled if node returning if9494 (depth = 4)
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9504 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9505 == NULL) {
    strlit9505 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9505);
  }
// compiled string node returning strlit9505 (depth = 5)
  gc_frame_newslot(strlit9505);
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9507 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9506);
// compiled call node returning call9507 (depth = 6)
// compiled member node returning call9507 (depth = 5)
  gc_frame_newslot(call9507);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9509 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9508);
// compiled call node returning call9509 (depth = 6)
// compiled member node returning call9509 (depth = 5)
  gc_frame_newslot(call9509);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9511 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9510);
// compiled call node returning call9511 (depth = 6)
// compiled member node returning call9511 (depth = 5)
  gc_frame_newslot(call9511);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9505;
  params[1] = call9507;
  params[2] = call9509;
  params[3] = call9511;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9512 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9504);
// compiled call node returning call9512 (depth = 4)
    gc_frame_newslot(call9512);
    if9462 = call9512;
  } else {
  }
// compiled if node returning if9462 (depth = 3)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9516 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9515);
// compiled call node returning call9516 (depth = 6)
// compiled member node returning call9516 (depth = 5)
  int op_slot_right_9514 = gc_frame_newslot(call9516);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9519 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9518);
// compiled call node returning call9519 (depth = 6)
// compiled member node returning call9519 (depth = 5)
  int op_slot_left_9514 = gc_frame_newslot(call9519);
  params[0] = call9516;
  partcv[0] = 1;
  Object opresult9520 = callmethod(call9519, "==", 1, partcv, params);
// compiled op node returning opresult9520 (depth = 4)
  Object if9513 = done;
  if (istrue(opresult9520)) {
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9521 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9524 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9523);
// compiled call node returning call9524 (depth = 7)
// compiled member node returning call9524 (depth = 6)
  int op_slot_right_9522 = gc_frame_newslot(call9524);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9527 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9526);
// compiled call node returning call9527 (depth = 7)
// compiled member node returning call9527 (depth = 6)
  int op_slot_left_9522 = gc_frame_newslot(call9527);
  params[0] = call9524;
  partcv[0] = 1;
  Object diff9528 = callmethod(call9527, "-", 1, partcv, params);
// compiled op node returning diff9528 (depth = 5)
  gc_frame_newslot(diff9528);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff9528;
  partcv[0] = 1;
  Object call9529 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9521);
// compiled call node returning call9529 (depth = 4)
    gc_frame_newslot(call9529);
    if9513 = call9529;
  } else {
  }
// compiled if node returning if9513 (depth = 3)
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9531 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9530);
// compiled call node returning call9531 (depth = 4)
// compiled member node returning call9531 (depth = 3)
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9534 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9535 == NULL) {
    strlit9535 = alloc_String("identifier");
    gc_root(strlit9535);
  }
// compiled string node returning strlit9535 (depth = 6)
  gc_frame_newslot(strlit9535);
// call case 4: self request
  params[0] = strlit9535;
  partcv[0] = 1;
  Object call9536 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9534);
// compiled call node returning call9536 (depth = 5)
  int op_slot_right_9533 = gc_frame_newslot(call9536);
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9539 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9540 == NULL) {
    strlit9540 = alloc_String("identifier");
    gc_root(strlit9540);
  }
// compiled string node returning strlit9540 (depth = 7)
  gc_frame_newslot(strlit9540);
// call case 4: self request
  params[0] = strlit9540;
  partcv[0] = 1;
  Object call9541 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9539);
// compiled call node returning call9541 (depth = 6)
  int op_slot_right_9538 = gc_frame_newslot(call9541);
// starting to compile call node (depth = 6)
  int callframe9543 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9544 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9543);
// compiled call node returning call9544 (depth = 6)
  int op_slot_left_9538 = gc_frame_newslot(call9544);
  params[0] = call9541;
  partcv[0] = 1;
  Object opresult9545 = callmethod(call9544, "&&", 1, partcv, params);
// compiled op node returning opresult9545 (depth = 5)
  int op_slot_left_9533 = gc_frame_newslot(opresult9545);
  params[0] = call9536;
  partcv[0] = 1;
  Object opresult9546 = callmethod(opresult9545, "||", 1, partcv, params);
// compiled op node returning opresult9546 (depth = 4)
  Object if9532 = done;
  if (istrue(opresult9546)) {
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9547 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile array node (depth = 6)
  Object array9548 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9548 (depth = 6)
  gc_frame_newslot(array9548);
// starting to compile identifier node (depth = 6)
  Object bool9549 = alloc_Boolean(0);
// compiled identifier node returning bool9549 (depth = 6)
  gc_frame_newslot(bool9549);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call9551 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9550);
// compiled call node returning call9551 (depth = 7)
// compiled member node returning call9551 (depth = 6)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9548;
  params[3] = bool9549;
  partcv[0] = 4;
  Object call9552 = callmethod(call9551, "new",
    1, partcv, params);
  gc_frame_end(callframe9547);
// compiled call node returning call9552 (depth = 5)
  *var_tm = call9552;
  if (call9552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9553 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tm (depth = 6)
  gc_frame_newslot(*var_tm);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sameline (depth = 6)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9554 = callmethodflags(self, "methodDecRest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9553);
// compiled call node returning call9554 (depth = 5)
  *var_meth = call9554;
  if (call9554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tm (depth = 8)
  partcv[0] = 0;
  Object call9558 = callmethod(*var_tm, "varargs",
    1, partcv, params);
  gc_frame_end(callframe9557);
// compiled call node returning call9558 (depth = 7)
// compiled member node returning call9558 (depth = 6)
  int op_slot_right_9556 = gc_frame_newslot(call9558);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varargs (depth = 6)
  int op_slot_left_9556 = gc_frame_newslot(*var_varargs);
  params[0] = call9558;
  partcv[0] = 1;
  Object opresult9560 = callmethod(*var_varargs, "||", 1, partcv, params);
// compiled op node returning opresult9560 (depth = 5)
  *var_varargs = opresult9560;
  if (opresult9560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9532 = done;
  } else {
  }
// compiled if node returning if9532 (depth = 3)
    gc_frame_newslot(if9532);
    if9208 = if9532;
  } else {
  }
// compiled if node returning if9208 (depth = 2)
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9563 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9564 == NULL) {
    strlit9564 = alloc_String("arrow");
    gc_root(strlit9564);
  }
// compiled string node returning strlit9564 (depth = 4)
  gc_frame_newslot(strlit9564);
// call case 4: self request
  params[0] = strlit9564;
  partcv[0] = 1;
  Object call9565 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9563);
// compiled call node returning call9565 (depth = 3)
  Object if9562 = done;
  if (istrue(call9565)) {
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9567 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9566);
// compiled call node returning call9567 (depth = 4)
// compiled member node returning call9567 (depth = 3)
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9568 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9569 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9568);
// compiled call node returning call9569 (depth = 4)
// compiled member node returning call9569 (depth = 3)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9571 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9570);
// compiled call node returning call9571 (depth = 5)
// compiled member node returning call9571 (depth = 4)
  *var_dtype = call9571;
  if (call9571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9562 = done;
  } else {
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9573 = alloc_Boolean(0);
// compiled identifier node returning bool9573 (depth = 4)
  *var_dtype = bool9573;
  if (bool9573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9562 = done;
  }
// compiled if node returning if9562 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9575 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9575 = alloc_userobj2(5,6, objclass9575);
  gc_frame_newslot(obj9575);
if (objclass9575 == NULL) {
  glfree(obj9575->class->name);
  obj9575->class->name = "self.methodsignature";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9575, self, 0);
  addmethodreal(obj9575,"outer", &reader_parser_outer_9576);
  Object oldself9575 = self;
  struct StackFrameObject *oldstackframe9575 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9575);
  gc_frame_newslot((Object)stackframe);
  self = obj9575;
  Object *oldselfslot9575 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9575 = (*(struct UserObject *)self).data[0], lowerouter9575 = thisouter9575;
  if (inheritingObject9575) {
    struct UserObject *inho9575 = (struct UserObject *)inheritingObject9575;
    while (inho9575->super != GraceDefaultObject) inho9575 = (struct UserObject *)inho9575->super;
    inho9575->super = obj9575;
    self = inheritingObject9575;
    *selfslot = self;
    lowerouter9575 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9575;
  }
if (objclass9575 == NULL) {
  Method *reader9577 = addmethodrealflags(obj9575, "m",&reader_parser_m_9577, MFLAG_DEF);
  reader9577->definitionModule = modulename;
  reader9577->definitionLine = 2967;
}
adddatum2(obj9575, alloc_Undefined(), 1);
if (objclass9575 == NULL) {
  Method *reader9578 = addmethodrealflags(obj9575, "sig",&reader_parser_sig_9578, MFLAG_DEF);
  reader9578->definitionModule = modulename;
  reader9578->definitionLine = 2968;
}
adddatum2(obj9575, alloc_Undefined(), 2);
if (objclass9575 == NULL) {
  Method *reader9579 = addmethodrealflags(obj9575, "rtype",&reader_parser_rtype_9579, MFLAG_DEF);
  reader9579->definitionModule = modulename;
  reader9579->definitionLine = 2969;
}
adddatum2(obj9575, alloc_Undefined(), 3);
if (objclass9575 == NULL) {
  Method *reader9580 = addmethodrealflags(obj9575, "v",&reader_parser_v_9580, MFLAG_DEF);
  reader9580->definitionModule = modulename;
  reader9580->definitionLine = 2970;
}
adddatum2(obj9575, alloc_Undefined(), 4);
if (objclass9575 == NULL) {
  Method *reader9581 = addmethodrealflags(obj9575, "typeParams",&reader_parser_typeParams_9581, MFLAG_DEF);
  reader9581->definitionModule = modulename;
  reader9581->definitionLine = 2971;
}
adddatum2(obj9575, alloc_Undefined(), 5);
  sourceObject = obj9575;
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth (depth = 2)
  adddatum2(obj9575, *var_meth, 1);
  sourceObject = obj9575;
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_signature (depth = 2)
  adddatum2(obj9575, *var_signature, 2);
  sourceObject = obj9575;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_dtype (depth = 2)
  adddatum2(obj9575, *var_dtype, 3);
  sourceObject = obj9575;
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_varargs (depth = 2)
  adddatum2(obj9575, *var_varargs, 4);
  sourceObject = obj9575;
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_myTypeParams (depth = 2)
  adddatum2(obj9575, *var_myTypeParams, 5);
  objclass9575 = obj9575->class;
  objclass9575->definitionModule = modulename;
  objclass9575->definitionLine = 2966;
  (*(struct UserObject *)self).data[0] = lowerouter9575;
  self = oldself9575;
  selfslot = oldselfslot9575;
  stackframe = oldstackframe9575;
  gc_frame_end(frame);
  return obj9575;
}
Object meth_parser_methodsignature8936_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(19, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature()object");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
  Object *var_myTypeParams = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "myTypeParams");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_varargs = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "varargs");
  Object *var_vararg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "vararg");
  Object *var_lparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "lparen");
  Object *var_id = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "id");
  Object *var_comma = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "comma");
  Object *var_rparen = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "rparen");
  Object *var_tm = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "tm");
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8940 == NULL) {
    strlit8940 = alloc_String("lsquare");
    gc_root(strlit8940);
  }
// compiled string node returning strlit8940 (depth = 5)
  int op_slot_right_8939 = gc_frame_newslot(strlit8940);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8943 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8942);
// compiled call node returning call8943 (depth = 6)
// compiled member node returning call8943 (depth = 5)
  int op_slot_left_8939 = gc_frame_newslot(call8943);
  params[0] = strlit8940;
  partcv[0] = 1;
  Object opresult8944 = callmethod(call8943, "!=", 1, partcv, params);
// compiled op node returning opresult8944 (depth = 4)
  int op_slot_right_8938 = gc_frame_newslot(opresult8944);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8948 == NULL) {
    strlit8948 = alloc_String("op");
    gc_root(strlit8948);
  }
// compiled string node returning strlit8948 (depth = 6)
  int op_slot_right_8947 = gc_frame_newslot(strlit8948);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8951 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8950);
// compiled call node returning call8951 (depth = 7)
// compiled member node returning call8951 (depth = 6)
  int op_slot_left_8947 = gc_frame_newslot(call8951);
  params[0] = strlit8948;
  partcv[0] = 1;
  Object opresult8952 = callmethod(call8951, "!=", 1, partcv, params);
// compiled op node returning opresult8952 (depth = 5)
  int op_slot_right_8946 = gc_frame_newslot(opresult8952);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8955 == NULL) {
    strlit8955 = alloc_String("identifier");
    gc_root(strlit8955);
  }
// compiled string node returning strlit8955 (depth = 6)
  int op_slot_right_8954 = gc_frame_newslot(strlit8955);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8958 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8957);
// compiled call node returning call8958 (depth = 7)
// compiled member node returning call8958 (depth = 6)
  int op_slot_left_8954 = gc_frame_newslot(call8958);
  params[0] = strlit8955;
  partcv[0] = 1;
  Object opresult8959 = callmethod(call8958, "!=", 1, partcv, params);
// compiled op node returning opresult8959 (depth = 5)
  int op_slot_left_8946 = gc_frame_newslot(opresult8959);
  params[0] = opresult8952;
  partcv[0] = 1;
  Object opresult8960 = callmethod(opresult8959, "&&", 1, partcv, params);
// compiled op node returning opresult8960 (depth = 4)
  int op_slot_left_8938 = gc_frame_newslot(opresult8960);
  params[0] = opresult8944;
  partcv[0] = 1;
  Object opresult8961 = callmethod(opresult8960, "&&", 1, partcv, params);
// compiled op node returning opresult8961 (depth = 3)
  Object if8937 = done;
  if (istrue(opresult8961)) {
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8962 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call8964 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8963);
// compiled call node returning call8964 (depth = 7)
// compiled member node returning call8964 (depth = 6)
  partcv[0] = 0;
  Object call8965 = callmethod(call8964, "new",
    1, partcv, params);
  gc_frame_end(callframe8962);
// compiled call node returning call8965 (depth = 5)
// compiled member node returning call8965 (depth = 4)
  *var_suggestion = call8965;
  if (call8965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8966 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8967 == NULL) {
    strlit8967 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8967);
  }
// compiled string node returning strlit8967 (depth = 4)
  gc_frame_newslot(strlit8967);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit8967;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8968 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8966);
// compiled call node returning call8968 (depth = 3)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8969 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8970 == NULL) {
    strlit8970 = alloc_String("a method name must start with an identifier, or be an operator or '[]'.");
    gc_root(strlit8970);
  }
// compiled string node returning strlit8970 (depth = 4)
  gc_frame_newslot(strlit8970);
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8972 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8971);
// compiled call node returning call8972 (depth = 5)
// compiled member node returning call8972 (depth = 4)
  gc_frame_newslot(call8972);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8975 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8974);
// compiled call node returning call8975 (depth = 6)
// compiled member node returning call8975 (depth = 5)
  int op_slot_right_8973 = gc_frame_newslot(call8975);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8977 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8978 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8977);
// compiled call node returning call8978 (depth = 6)
// compiled member node returning call8978 (depth = 5)
  int op_slot_left_8973 = gc_frame_newslot(call8978);
  params[0] = call8975;
  partcv[0] = 1;
  Object sum8979 = callmethod(call8978, "+", 1, partcv, params);
// compiled op node returning sum8979 (depth = 4)
  gc_frame_newslot(sum8979);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8970;
  params[1] = call8972;
  params[2] = sum8979;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8980 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8969);
// compiled call node returning call8980 (depth = 3)
    gc_frame_newslot(call8980);
    if8937 = call8980;
  } else {
  }
// compiled if node returning if8937 (depth = 2)
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8982 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8981);
// compiled call node returning call8982 (depth = 3)
// compiled member node returning call8982 (depth = 2)
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8984 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8983);
// compiled call node returning call8984 (depth = 4)
// compiled member node returning call8984 (depth = 3)
  *var_meth = call8984;
  if (call8984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8985 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8986 = alloc_Boolean(1);
// compiled identifier node returning bool8986 (depth = 3)
  gc_frame_newslot(bool8986);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool8986;
  partcv[0] = 1;
  Object call8987 = callmethod(*var_meth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8985);
// compiled call node returning call8987 (depth = 2)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8988 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8989 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8990 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8989);
// compiled call node returning call8990 (depth = 6)
// compiled member node returning call8990 (depth = 5)
  partcv[0] = 0;
  Object call8991 = callmethod(call8990, "empty",
    1, partcv, params);
  gc_frame_end(callframe8988);
// compiled call node returning call8991 (depth = 4)
// compiled member node returning call8991 (depth = 3)
  *var_signature = call8991;
  if (call8991 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8992 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call8994 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8993);
// compiled call node returning call8994 (depth = 5)
// compiled member node returning call8994 (depth = 4)
  gc_frame_newslot(call8994);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8996 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8995);
// compiled call node returning call8996 (depth = 5)
// compiled member node returning call8996 (depth = 4)
  params[0] = call8994;
  partcv[0] = 1;
  Object call8997 = callmethod(call8996, "partName",
    1, partcv, params);
  gc_frame_end(callframe8992);
// compiled call node returning call8997 (depth = 3)
  *var_part = call8997;
  if (call8997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8998 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call9000 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe8999);
// compiled call node returning call9000 (depth = 4)
// compiled member node returning call9000 (depth = 3)
  gc_frame_newslot(call9000);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call9000;
  partcv[0] = 1;
  Object call9001 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe8998);
// compiled call node returning call9001 (depth = 2)
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9002 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call9004 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9003);
// compiled call node returning call9004 (depth = 4)
// compiled member node returning call9004 (depth = 3)
  gc_frame_newslot(call9004);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call9004;
  partcv[0] = 1;
  Object call9005 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9002);
// compiled call node returning call9005 (depth = 2)
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9006 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9007 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9006);
// compiled call node returning call9007 (depth = 2)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9010 == NULL) {
    strlit9010 = alloc_String("[");
    gc_root(strlit9010);
  }
// compiled string node returning strlit9010 (depth = 4)
  int op_slot_right_9009 = gc_frame_newslot(strlit9010);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9013 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9012);
// compiled call node returning call9013 (depth = 5)
// compiled member node returning call9013 (depth = 4)
  int op_slot_left_9009 = gc_frame_newslot(call9013);
  params[0] = strlit9010;
  partcv[0] = 1;
  Object opresult9014 = callmethod(call9013, "==", 1, partcv, params);
// compiled op node returning opresult9014 (depth = 3)
  Object if9008 = done;
  if (istrue(opresult9014)) {
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9017 == NULL) {
    strlit9017 = alloc_String("rsquare");
    gc_root(strlit9017);
  }
// compiled string node returning strlit9017 (depth = 5)
  int op_slot_right_9016 = gc_frame_newslot(strlit9017);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9020 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9019);
// compiled call node returning call9020 (depth = 6)
// compiled member node returning call9020 (depth = 5)
  int op_slot_left_9016 = gc_frame_newslot(call9020);
  params[0] = strlit9017;
  partcv[0] = 1;
  Object opresult9021 = callmethod(call9020, "!=", 1, partcv, params);
// compiled op node returning opresult9021 (depth = 4)
  Object if9015 = done;
  if (istrue(opresult9021)) {
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9024 = gc_frame_new();
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 7)
  Object block9025 = alloc_Block(NULL, NULL, "parser", 2830);
  gc_frame_newslot(block9025);
// method "_apply"
  block_savedest(block9025);
  Object closure9026 = createclosure(2, "_apply");
  setclosureframe(closure9026, stackframe);
  addtoclosure(closure9026, var_tokens);
  addtoclosure(closure9026, selfslot);
  struct UserObject *uo9026 = (struct UserObject*)block9025;
  uo9026->data[0] = (Object)closure9026;
  Method *meth_meth_parser__apply9026 = addmethod2pos(block9025, "_apply", &meth_parser__apply9026, 0);
  int argcv_meth_parser__apply9026[] = {0};
  meth_meth_parser__apply9026->type = alloc_MethodType(1, argcv_meth_parser__apply9026);
  meth_meth_parser__apply9026->definitionModule = modulename;
  meth_meth_parser__apply9026->definitionLine = 2828;
// compiled block node returning block9025 (depth = 7)
  gc_frame_newslot(block9025);
// call case 6: other member request
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9037 = alloc_Float64(0);
// compiled num node returning num9037 (depth = 8)
  int op_slot_right_9036 = gc_frame_newslot(num9037);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9040 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9039);
// compiled call node returning call9040 (depth = 9)
// compiled member node returning call9040 (depth = 8)
  int op_slot_left_9036 = gc_frame_newslot(call9040);
  params[0] = num9037;
  partcv[0] = 1;
  Object opresult9041 = callmethod(call9040, "==", 1, partcv, params);
// compiled op node returning opresult9041 (depth = 7)
  params[0] = block9025;
  partcv[0] = 1;
  Object call9042 = callmethod(opresult9041, "orElse",
    1, partcv, params);
  gc_frame_end(callframe9024);
// compiled call node returning call9042 (depth = 6)
  int op_slot_right_9023 = gc_frame_newslot(call9042);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String("identifier");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 7)
  int op_slot_right_9044 = gc_frame_newslot(strlit9045);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9047 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9048 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9047);
// compiled call node returning call9048 (depth = 8)
// compiled member node returning call9048 (depth = 7)
  int op_slot_left_9044 = gc_frame_newslot(call9048);
  params[0] = strlit9045;
  partcv[0] = 1;
  Object opresult9049 = callmethod(call9048, "==", 1, partcv, params);
// compiled op node returning opresult9049 (depth = 6)
  int op_slot_left_9023 = gc_frame_newslot(opresult9049);
  params[0] = call9042;
  partcv[0] = 1;
  Object opresult9050 = callmethod(opresult9049, "&&", 1, partcv, params);
// compiled op node returning opresult9050 (depth = 5)
  Object if9022 = done;
  if (istrue(opresult9050)) {
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9051 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9052 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9053 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9052);
// compiled call node returning call9053 (depth = 9)
// compiled member node returning call9053 (depth = 8)
  partcv[0] = 0;
  Object call9054 = callmethod(call9053, "empty",
    1, partcv, params);
  gc_frame_end(callframe9051);
// compiled call node returning call9054 (depth = 7)
// compiled member node returning call9054 (depth = 6)
  *var_suggestions = call9054;
  if (call9054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9055 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9057 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9056);
// compiled call node returning call9057 (depth = 9)
// compiled member node returning call9057 (depth = 8)
  partcv[0] = 0;
  Object call9058 = callmethod(call9057, "new",
    1, partcv, params);
  gc_frame_end(callframe9055);
// compiled call node returning call9058 (depth = 7)
// compiled member node returning call9058 (depth = 6)
  *var_suggestion = call9058;
  if (call9058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9061 = alloc_Float64(0);
// compiled num node returning num9061 (depth = 7)
  int op_slot_right_9060 = gc_frame_newslot(num9061);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9063 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call9064 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9063);
// compiled call node returning call9064 (depth = 8)
// compiled member node returning call9064 (depth = 7)
  int op_slot_left_9060 = gc_frame_newslot(call9064);
  params[0] = num9061;
  partcv[0] = 1;
  Object opresult9065 = callmethod(call9064, "==", 1, partcv, params);
// compiled op node returning opresult9065 (depth = 6)
  Object if9059 = done;
  if (istrue(opresult9065)) {
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9066 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9068 == NULL) {
    strlit9068 = alloc_String(")");
    gc_root(strlit9068);
  }
// compiled string node returning strlit9068 (depth = 8)
  int op_slot_right_9067 = gc_frame_newslot(strlit9068);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9072 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9071);
// compiled call node returning call9072 (depth = 10)
// compiled member node returning call9072 (depth = 9)
  int op_slot_right_9070 = gc_frame_newslot(call9072);
// starting to compile string node (depth = 9)
  if (strlit9074 == NULL) {
    strlit9074 = alloc_String("](");
    gc_root(strlit9074);
  }
// compiled string node returning strlit9074 (depth = 9)
  int op_slot_left_9070 = gc_frame_newslot(strlit9074);
  params[0] = call9072;
  partcv[0] = 1;
  Object opresult9075 = callmethod(strlit9074, "++", 1, partcv, params);
// compiled op node returning opresult9075 (depth = 8)
  int op_slot_left_9067 = gc_frame_newslot(opresult9075);
  params[0] = strlit9068;
  partcv[0] = 1;
  Object opresult9076 = callmethod(opresult9075, "++", 1, partcv, params);
// compiled op node returning opresult9076 (depth = 7)
  gc_frame_newslot(opresult9076);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = opresult9076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9077 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9066);
// compiled call node returning call9077 (depth = 6)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9078 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9079 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9078);
// compiled call node returning call9079 (depth = 6)
    gc_frame_newslot(call9079);
    if9059 = call9079;
  } else {
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9082 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call9083 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9082);
// compiled call node returning call9083 (depth = 9)
// compiled member node returning call9083 (depth = 8)
  int op_slot_right_9081 = gc_frame_newslot(call9083);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9085 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  partcv[0] = 0;
  Object call9087 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9086);
// compiled call node returning call9087 (depth = 11)
// compiled member node returning call9087 (depth = 10)
  partcv[0] = 0;
  Object call9088 = callmethod(call9087, "line",
    1, partcv, params);
  gc_frame_end(callframe9085);
// compiled call node returning call9088 (depth = 9)
// compiled member node returning call9088 (depth = 8)
  int op_slot_left_9081 = gc_frame_newslot(call9088);
  params[0] = call9083;
  partcv[0] = 1;
  Object opresult9089 = callmethod(call9088, "==", 1, partcv, params);
// compiled op node returning opresult9089 (depth = 7)
  Object if9080 = done;
  if (istrue(opresult9089)) {
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9090 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9092 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9091);
// compiled call node returning call9092 (depth = 9)
// compiled member node returning call9092 (depth = 8)
  gc_frame_newslot(call9092);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9094 == NULL) {
    strlit9094 = alloc_String(")");
    gc_root(strlit9094);
  }
// compiled string node returning strlit9094 (depth = 9)
  int op_slot_right_9093 = gc_frame_newslot(strlit9094);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9098 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9097);
// compiled call node returning call9098 (depth = 11)
// compiled member node returning call9098 (depth = 10)
  int op_slot_right_9096 = gc_frame_newslot(call9098);
// starting to compile string node (depth = 10)
  if (strlit9100 == NULL) {
    strlit9100 = alloc_String("](");
    gc_root(strlit9100);
  }
// compiled string node returning strlit9100 (depth = 10)
  int op_slot_left_9096 = gc_frame_newslot(strlit9100);
  params[0] = call9098;
  partcv[0] = 1;
  Object opresult9101 = callmethod(strlit9100, "++", 1, partcv, params);
// compiled op node returning opresult9101 (depth = 9)
  int op_slot_left_9093 = gc_frame_newslot(opresult9101);
  params[0] = strlit9094;
  partcv[0] = 1;
  Object opresult9102 = callmethod(opresult9101, "++", 1, partcv, params);
// compiled op node returning opresult9102 (depth = 8)
  gc_frame_newslot(opresult9102);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call9092;
  params[2] = opresult9102;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9103 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9090);
// compiled call node returning call9103 (depth = 7)
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9104 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9105 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9104);
// compiled call node returning call9105 (depth = 7)
    gc_frame_newslot(call9105);
    if9080 = call9105;
  } else {
  }
// compiled if node returning if9080 (depth = 6)
    gc_frame_newslot(if9080);
    if9059 = if9080;
  }
// compiled if node returning if9059 (depth = 5)
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9106 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9107 == NULL) {
    strlit9107 = alloc_String("a method named '[]' must have a single parameter in parentheses after the '[]'.");
    gc_root(strlit9107);
  }
// compiled string node returning strlit9107 (depth = 6)
  gc_frame_newslot(strlit9107);
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9109 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9108);
// compiled call node returning call9109 (depth = 7)
// compiled member node returning call9109 (depth = 6)
  gc_frame_newslot(call9109);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9112 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9111);
// compiled call node returning call9112 (depth = 8)
// compiled member node returning call9112 (depth = 7)
  int op_slot_right_9110 = gc_frame_newslot(call9112);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9115 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9114);
// compiled call node returning call9115 (depth = 8)
// compiled member node returning call9115 (depth = 7)
  int op_slot_left_9110 = gc_frame_newslot(call9115);
  params[0] = call9112;
  partcv[0] = 1;
  Object sum9116 = callmethod(call9115, "+", 1, partcv, params);
// compiled op node returning sum9116 (depth = 6)
  gc_frame_newslot(sum9116);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9107;
  params[1] = call9109;
  params[2] = sum9116;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9117 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9106);
// compiled call node returning call9117 (depth = 5)
    gc_frame_newslot(call9117);
    if9022 = call9117;
  } else {
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9118 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9120 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9119);
// compiled call node returning call9120 (depth = 9)
// compiled member node returning call9120 (depth = 8)
  partcv[0] = 0;
  Object call9121 = callmethod(call9120, "new",
    1, partcv, params);
  gc_frame_end(callframe9118);
// compiled call node returning call9121 (depth = 7)
// compiled member node returning call9121 (depth = 6)
  *var_suggestion = call9121;
  if (call9121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9122 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9123 == NULL) {
    strlit9123 = alloc_String("]");
    gc_root(strlit9123);
  }
// compiled string node returning strlit9123 (depth = 6)
  gc_frame_newslot(strlit9123);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9123;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9124 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9122);
// compiled call node returning call9124 (depth = 5)
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9125 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9126 == NULL) {
    strlit9126 = alloc_String("a method name must start with either an identifier or '[]'.");
    gc_root(strlit9126);
  }
// compiled string node returning strlit9126 (depth = 6)
  gc_frame_newslot(strlit9126);
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9128 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9127);
// compiled call node returning call9128 (depth = 7)
// compiled member node returning call9128 (depth = 6)
  gc_frame_newslot(call9128);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9131 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9130);
// compiled call node returning call9131 (depth = 8)
// compiled member node returning call9131 (depth = 7)
  int op_slot_right_9129 = gc_frame_newslot(call9131);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9133 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9134 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9133);
// compiled call node returning call9134 (depth = 8)
// compiled member node returning call9134 (depth = 7)
  int op_slot_left_9129 = gc_frame_newslot(call9134);
  params[0] = call9131;
  partcv[0] = 1;
  Object sum9135 = callmethod(call9134, "+", 1, partcv, params);
// compiled op node returning sum9135 (depth = 6)
  gc_frame_newslot(sum9135);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9126;
  params[1] = call9128;
  params[2] = sum9135;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9136 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9125);
// compiled call node returning call9136 (depth = 5)
    gc_frame_newslot(call9136);
    if9022 = call9136;
  }
// compiled if node returning if9022 (depth = 4)
    gc_frame_newslot(if9022);
    if9015 = if9022;
  } else {
  }
// compiled if node returning if9015 (depth = 3)
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9137 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9138 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9137);
// compiled call node returning call9138 (depth = 4)
// compiled member node returning call9138 (depth = 3)
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9139 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9140 == NULL) {
    strlit9140 = alloc_String("[]");
    gc_root(strlit9140);
  }
// compiled string node returning strlit9140 (depth = 4)
  gc_frame_newslot(strlit9140);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = strlit9140;
  partcv[0] = 1;
  Object call9141 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9139);
// compiled call node returning call9141 (depth = 3)
    gc_frame_newslot(call9141);
    if9008 = call9141;
  } else {
  }
// compiled if node returning if9008 (depth = 2)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9142 = alloc_Boolean(0);
// compiled identifier node returning bool9142 (depth = 3)
  *var_myTypeParams = bool9142;
  if (bool9142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9144 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9145 == NULL) {
    strlit9145 = alloc_String("lgeneric");
    gc_root(strlit9145);
  }
// compiled string node returning strlit9145 (depth = 4)
  gc_frame_newslot(strlit9145);
// call case 4: self request
  params[0] = strlit9145;
  partcv[0] = 1;
  Object call9146 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9144);
// compiled call node returning call9146 (depth = 3)
  Object if9143 = done;
  if (istrue(call9146)) {
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9148 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9147);
// compiled call node returning call9148 (depth = 5)
// compiled member node returning call9148 (depth = 4)
  *var_myTypeParams = call9148;
  if (call9148 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9143 = done;
  } else {
  }
// compiled if node returning if9143 (depth = 2)
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9151 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9152 == NULL) {
    strlit9152 = alloc_String("bind");
    gc_root(strlit9152);
  }
// compiled string node returning strlit9152 (depth = 4)
  gc_frame_newslot(strlit9152);
// call case 4: self request
  params[0] = strlit9152;
  partcv[0] = 1;
  Object call9153 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9151);
// compiled call node returning call9153 (depth = 3)
  Object if9150 = done;
  if (istrue(call9153)) {
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9154 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9155 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9154);
// compiled call node returning call9155 (depth = 4)
// compiled member node returning call9155 (depth = 3)
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9156 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9158 == NULL) {
    strlit9158 = alloc_String(":=");
    gc_root(strlit9158);
  }
// compiled string node returning strlit9158 (depth = 5)
  int op_slot_right_9157 = gc_frame_newslot(strlit9158);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call9161 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9160);
// compiled call node returning call9161 (depth = 6)
// compiled member node returning call9161 (depth = 5)
  int op_slot_left_9157 = gc_frame_newslot(call9161);
  params[0] = strlit9158;
  partcv[0] = 1;
  Object opresult9162 = callmethod(call9161, "++", 1, partcv, params);
// compiled op node returning opresult9162 (depth = 4)
  gc_frame_newslot(opresult9162);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = opresult9162;
  partcv[0] = 1;
  Object call9163 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9156);
// compiled call node returning call9163 (depth = 3)
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9164 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9166 == NULL) {
    strlit9166 = alloc_String(":=");
    gc_root(strlit9166);
  }
// compiled string node returning strlit9166 (depth = 5)
  int op_slot_right_9165 = gc_frame_newslot(strlit9166);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9169 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9168);
// compiled call node returning call9169 (depth = 6)
// compiled member node returning call9169 (depth = 5)
  int op_slot_left_9165 = gc_frame_newslot(call9169);
  params[0] = strlit9166;
  partcv[0] = 1;
  Object opresult9170 = callmethod(call9169, "++", 1, partcv, params);
// compiled op node returning opresult9170 (depth = 4)
  gc_frame_newslot(opresult9170);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult9170;
  partcv[0] = 1;
  Object call9171 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9164);
// compiled call node returning call9171 (depth = 3)
    gc_frame_newslot(call9171);
    if9150 = call9171;
  } else {
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9175 == NULL) {
    strlit9175 = alloc_String("prefix");
    gc_root(strlit9175);
  }
// compiled string node returning strlit9175 (depth = 6)
  int op_slot_right_9174 = gc_frame_newslot(strlit9175);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9178 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9177);
// compiled call node returning call9178 (depth = 7)
// compiled member node returning call9178 (depth = 6)
  int op_slot_left_9174 = gc_frame_newslot(call9178);
  params[0] = strlit9175;
  partcv[0] = 1;
  Object opresult9179 = callmethod(call9178, "==", 1, partcv, params);
// compiled op node returning opresult9179 (depth = 5)
  int op_slot_right_9173 = gc_frame_newslot(opresult9179);
// starting to compile call node (depth = 5)
  int callframe9181 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9182 == NULL) {
    strlit9182 = alloc_String("op");
    gc_root(strlit9182);
  }
// compiled string node returning strlit9182 (depth = 6)
  gc_frame_newslot(strlit9182);
// call case 4: self request
  params[0] = strlit9182;
  partcv[0] = 1;
  Object call9183 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9181);
// compiled call node returning call9183 (depth = 5)
  int op_slot_left_9173 = gc_frame_newslot(call9183);
  params[0] = opresult9179;
  partcv[0] = 1;
  Object opresult9184 = callmethod(call9183, "&&", 1, partcv, params);
// compiled op node returning opresult9184 (depth = 4)
  Object if9172 = done;
  if (istrue(opresult9184)) {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9185 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9188 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9187);
// compiled call node returning call9188 (depth = 7)
// compiled member node returning call9188 (depth = 6)
  int op_slot_right_9186 = gc_frame_newslot(call9188);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9190 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9191 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9190);
// compiled call node returning call9191 (depth = 7)
// compiled member node returning call9191 (depth = 6)
  int op_slot_left_9186 = gc_frame_newslot(call9191);
  params[0] = call9188;
  partcv[0] = 1;
  Object opresult9192 = callmethod(call9191, "++", 1, partcv, params);
// compiled op node returning opresult9192 (depth = 5)
  gc_frame_newslot(opresult9192);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = opresult9192;
  partcv[0] = 1;
  Object call9193 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9185);
// compiled call node returning call9193 (depth = 4)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9194 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9197 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9196);
// compiled call node returning call9197 (depth = 7)
// compiled member node returning call9197 (depth = 6)
  int op_slot_right_9195 = gc_frame_newslot(call9197);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9199 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9200 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9199);
// compiled call node returning call9200 (depth = 7)
// compiled member node returning call9200 (depth = 6)
  int op_slot_left_9195 = gc_frame_newslot(call9200);
  params[0] = call9197;
  partcv[0] = 1;
  Object opresult9201 = callmethod(call9200, "++", 1, partcv, params);
// compiled op node returning opresult9201 (depth = 5)
  gc_frame_newslot(opresult9201);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult9201;
  partcv[0] = 1;
  Object call9202 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9194);
// compiled call node returning call9202 (depth = 4)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9203 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9204 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9203);
// compiled call node returning call9204 (depth = 5)
// compiled member node returning call9204 (depth = 4)
    gc_frame_newslot(call9204);
    if9172 = call9204;
  } else {
  }
// compiled if node returning if9172 (depth = 3)
    gc_frame_newslot(if9172);
    if9150 = if9172;
  }
// compiled if node returning if9150 (depth = 2)
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9205 = alloc_Boolean(0);
// compiled identifier node returning bool9205 (depth = 3)
  *var_dtype = bool9205;
  if (bool9205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9206 = alloc_Boolean(0);
// compiled identifier node returning bool9206 (depth = 3)
  *var_varargs = bool9206;
  if (bool9206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9207 = alloc_Boolean(0);
// compiled identifier node returning bool9207 (depth = 3)
  *var_vararg = bool9207;
  if (bool9207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9209 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9210 == NULL) {
    strlit9210 = alloc_String("lparen");
    gc_root(strlit9210);
  }
// compiled string node returning strlit9210 (depth = 4)
  gc_frame_newslot(strlit9210);
// call case 4: self request
  params[0] = strlit9210;
  partcv[0] = 1;
  Object call9211 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9209);
// compiled call node returning call9211 (depth = 3)
  Object if9208 = done;
  if (istrue(call9211)) {
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9212 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9214 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9213);
// compiled call node returning call9214 (depth = 5)
// compiled member node returning call9214 (depth = 4)
  gc_frame_newslot(call9214);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call9214;
  partcv[0] = 1;
  Object call9215 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9212);
// compiled call node returning call9215 (depth = 3)
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9217 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9216);
// compiled call node returning call9217 (depth = 4)
// compiled member node returning call9217 (depth = 3)
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9218 = alloc_Boolean(0);
// compiled identifier node returning bool9218 (depth = 4)
  *var_comma = bool9218;
  if (bool9218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9219 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9220 = alloc_Block(NULL, NULL, "parser", 2872);
  gc_frame_newslot(block9220);
// method "_apply"
  block_savedest(block9220);
  Object closure9221 = createclosure(2, "_apply");
  setclosureframe(closure9221, stackframe);
  addtoclosure(closure9221, var_sym);
  addtoclosure(closure9221, selfslot);
  struct UserObject *uo9221 = (struct UserObject*)block9220;
  uo9221->data[0] = (Object)closure9221;
  Method *meth_meth_parser__apply9221 = addmethod2pos(block9220, "_apply", &meth_parser__apply9221, 0);
  int argcv_meth_parser__apply9221[] = {0};
  meth_meth_parser__apply9221->type = alloc_MethodType(1, argcv_meth_parser__apply9221);
  meth_meth_parser__apply9221->definitionModule = modulename;
  meth_meth_parser__apply9221->definitionLine = 2869;
// compiled block node returning block9220 (depth = 4)
  gc_frame_newslot(block9220);
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block9241 = alloc_Block(NULL, NULL, "parser", 2873);
  gc_frame_newslot(block9241);
// method "_apply"
  block_savedest(block9241);
  Object closure9242 = createclosure(12, "_apply");
  setclosureframe(closure9242, stackframe);
  addtoclosure(closure9242, var_sym);
  addtoclosure(closure9242, var_errormessages);
  addtoclosure(closure9242, var_lastToken);
  addtoclosure(closure9242, var_comma);
  addtoclosure(closure9242, var_vararg);
  addtoclosure(closure9242, var_varargs);
  addtoclosure(closure9242, var_values);
  addtoclosure(closure9242, var_id);
  addtoclosure(closure9242, var_dtype);
  addtoclosure(closure9242, var_part);
  addtoclosure(closure9242, var_lparen);
  addtoclosure(closure9242, selfslot);
  struct UserObject *uo9242 = (struct UserObject*)block9241;
  uo9242->data[0] = (Object)closure9242;
  Method *meth_meth_parser__apply9242 = addmethod2pos(block9241, "_apply", &meth_parser__apply9242, 0);
  int argcv_meth_parser__apply9242[] = {0};
  meth_meth_parser__apply9242->type = alloc_MethodType(1, argcv_meth_parser__apply9242);
  meth_meth_parser__apply9242->definitionModule = modulename;
  meth_meth_parser__apply9242->definitionLine = 2873;
// compiled block node returning block9241 (depth = 4)
  gc_frame_newslot(block9241);
// call case 5: prelude request
  params[0] = block9220;
  params[1] = block9241;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9461 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9219);
// compiled call node returning call9461 (depth = 3)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9464 == NULL) {
    strlit9464 = alloc_String("rparen");
    gc_root(strlit9464);
  }
// compiled string node returning strlit9464 (depth = 5)
  int op_slot_right_9463 = gc_frame_newslot(strlit9464);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9466 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9467 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9466);
// compiled call node returning call9467 (depth = 6)
// compiled member node returning call9467 (depth = 5)
  int op_slot_left_9463 = gc_frame_newslot(call9467);
  params[0] = strlit9464;
  partcv[0] = 1;
  Object opresult9468 = callmethod(call9467, "!=", 1, partcv, params);
// compiled op node returning opresult9468 (depth = 4)
  Object if9462 = done;
  if (istrue(opresult9468)) {
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9469 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9471 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9470);
// compiled call node returning call9471 (depth = 8)
// compiled member node returning call9471 (depth = 7)
  partcv[0] = 0;
  Object call9472 = callmethod(call9471, "new",
    1, partcv, params);
  gc_frame_end(callframe9469);
// compiled call node returning call9472 (depth = 6)
// compiled member node returning call9472 (depth = 5)
  *var_suggestion = call9472;
  if (call9472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9473 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9474 = alloc_Block(NULL, NULL, "parser", 2936);
  gc_frame_newslot(block9474);
// method "_apply"
  block_savedest(block9474);
  Object closure9475 = createclosure(2, "_apply");
  setclosureframe(closure9475, stackframe);
  addtoclosure(closure9475, var_lastToken);
  addtoclosure(closure9475, selfslot);
  struct UserObject *uo9475 = (struct UserObject*)block9474;
  uo9475->data[0] = (Object)closure9475;
  Method *meth_meth_parser__apply9475 = addmethod2pos(block9474, "_apply", &meth_parser__apply9475, 0);
  int argcv_meth_parser__apply9475[] = {1};
  meth_meth_parser__apply9475->type = alloc_MethodType(1, argcv_meth_parser__apply9475);
  meth_meth_parser__apply9475->definitionModule = modulename;
  meth_meth_parser__apply9475->definitionLine = 2935;
// compiled block node returning block9474 (depth = 6)
  gc_frame_newslot(block9474);
// call case 4: self request
  params[0] = block9474;
  partcv[0] = 1;
  Object call9493 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9473);
// compiled call node returning call9493 (depth = 5)
  *var_rparen = call9493;
  if (call9493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9496 = alloc_Boolean(0);
// compiled identifier node returning bool9496 (depth = 6)
  int op_slot_right_9495 = gc_frame_newslot(bool9496);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_left_9495 = gc_frame_newslot(*var_rparen);
  params[0] = bool9496;
  partcv[0] = 1;
  Object opresult9498 = callmethod(*var_rparen, "==", 1, partcv, params);
// compiled op node returning opresult9498 (depth = 5)
  Object if9494 = done;
  if (istrue(opresult9498)) {
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9499 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit9500 == NULL) {
    strlit9500 = alloc_String(")");
    gc_root(strlit9500);
  }
// compiled string node returning strlit9500 (depth = 6)
  gc_frame_newslot(strlit9500);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit9500;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9501 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9499);
// compiled call node returning call9501 (depth = 5)
    gc_frame_newslot(call9501);
    if9494 = call9501;
  } else {
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9502 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9503 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9502);
// compiled call node returning call9503 (depth = 5)
    gc_frame_newslot(call9503);
    if9494 = call9503;
  }
// compiled if node returning if9494 (depth = 4)
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9504 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9505 == NULL) {
    strlit9505 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9505);
  }
// compiled string node returning strlit9505 (depth = 5)
  gc_frame_newslot(strlit9505);
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9507 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9506);
// compiled call node returning call9507 (depth = 6)
// compiled member node returning call9507 (depth = 5)
  gc_frame_newslot(call9507);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9509 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9508);
// compiled call node returning call9509 (depth = 6)
// compiled member node returning call9509 (depth = 5)
  gc_frame_newslot(call9509);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9511 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9510);
// compiled call node returning call9511 (depth = 6)
// compiled member node returning call9511 (depth = 5)
  gc_frame_newslot(call9511);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9505;
  params[1] = call9507;
  params[2] = call9509;
  params[3] = call9511;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9512 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9504);
// compiled call node returning call9512 (depth = 4)
    gc_frame_newslot(call9512);
    if9462 = call9512;
  } else {
  }
// compiled if node returning if9462 (depth = 3)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9516 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9515);
// compiled call node returning call9516 (depth = 6)
// compiled member node returning call9516 (depth = 5)
  int op_slot_right_9514 = gc_frame_newslot(call9516);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9519 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9518);
// compiled call node returning call9519 (depth = 6)
// compiled member node returning call9519 (depth = 5)
  int op_slot_left_9514 = gc_frame_newslot(call9519);
  params[0] = call9516;
  partcv[0] = 1;
  Object opresult9520 = callmethod(call9519, "==", 1, partcv, params);
// compiled op node returning opresult9520 (depth = 4)
  Object if9513 = done;
  if (istrue(opresult9520)) {
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9521 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9524 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9523);
// compiled call node returning call9524 (depth = 7)
// compiled member node returning call9524 (depth = 6)
  int op_slot_right_9522 = gc_frame_newslot(call9524);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9527 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9526);
// compiled call node returning call9527 (depth = 7)
// compiled member node returning call9527 (depth = 6)
  int op_slot_left_9522 = gc_frame_newslot(call9527);
  params[0] = call9524;
  partcv[0] = 1;
  Object diff9528 = callmethod(call9527, "-", 1, partcv, params);
// compiled op node returning diff9528 (depth = 5)
  gc_frame_newslot(diff9528);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff9528;
  partcv[0] = 1;
  Object call9529 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9521);
// compiled call node returning call9529 (depth = 4)
    gc_frame_newslot(call9529);
    if9513 = call9529;
  } else {
  }
// compiled if node returning if9513 (depth = 3)
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9531 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9530);
// compiled call node returning call9531 (depth = 4)
// compiled member node returning call9531 (depth = 3)
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9534 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9535 == NULL) {
    strlit9535 = alloc_String("identifier");
    gc_root(strlit9535);
  }
// compiled string node returning strlit9535 (depth = 6)
  gc_frame_newslot(strlit9535);
// call case 4: self request
  params[0] = strlit9535;
  partcv[0] = 1;
  Object call9536 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9534);
// compiled call node returning call9536 (depth = 5)
  int op_slot_right_9533 = gc_frame_newslot(call9536);
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9539 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9540 == NULL) {
    strlit9540 = alloc_String("identifier");
    gc_root(strlit9540);
  }
// compiled string node returning strlit9540 (depth = 7)
  gc_frame_newslot(strlit9540);
// call case 4: self request
  params[0] = strlit9540;
  partcv[0] = 1;
  Object call9541 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9539);
// compiled call node returning call9541 (depth = 6)
  int op_slot_right_9538 = gc_frame_newslot(call9541);
// starting to compile call node (depth = 6)
  int callframe9543 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9544 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9543);
// compiled call node returning call9544 (depth = 6)
  int op_slot_left_9538 = gc_frame_newslot(call9544);
  params[0] = call9541;
  partcv[0] = 1;
  Object opresult9545 = callmethod(call9544, "&&", 1, partcv, params);
// compiled op node returning opresult9545 (depth = 5)
  int op_slot_left_9533 = gc_frame_newslot(opresult9545);
  params[0] = call9536;
  partcv[0] = 1;
  Object opresult9546 = callmethod(opresult9545, "||", 1, partcv, params);
// compiled op node returning opresult9546 (depth = 4)
  Object if9532 = done;
  if (istrue(opresult9546)) {
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9547 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile array node (depth = 6)
  Object array9548 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9548 (depth = 6)
  gc_frame_newslot(array9548);
// starting to compile identifier node (depth = 6)
  Object bool9549 = alloc_Boolean(0);
// compiled identifier node returning bool9549 (depth = 6)
  gc_frame_newslot(bool9549);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call9551 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9550);
// compiled call node returning call9551 (depth = 7)
// compiled member node returning call9551 (depth = 6)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9548;
  params[3] = bool9549;
  partcv[0] = 4;
  Object call9552 = callmethod(call9551, "new",
    1, partcv, params);
  gc_frame_end(callframe9547);
// compiled call node returning call9552 (depth = 5)
  *var_tm = call9552;
  if (call9552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9553 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tm (depth = 6)
  gc_frame_newslot(*var_tm);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sameline (depth = 6)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9554 = callmethodflags(self, "methodDecRest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9553);
// compiled call node returning call9554 (depth = 5)
  *var_meth = call9554;
  if (call9554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tm (depth = 8)
  partcv[0] = 0;
  Object call9558 = callmethod(*var_tm, "varargs",
    1, partcv, params);
  gc_frame_end(callframe9557);
// compiled call node returning call9558 (depth = 7)
// compiled member node returning call9558 (depth = 6)
  int op_slot_right_9556 = gc_frame_newslot(call9558);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varargs (depth = 6)
  int op_slot_left_9556 = gc_frame_newslot(*var_varargs);
  params[0] = call9558;
  partcv[0] = 1;
  Object opresult9560 = callmethod(*var_varargs, "||", 1, partcv, params);
// compiled op node returning opresult9560 (depth = 5)
  *var_varargs = opresult9560;
  if (opresult9560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9532 = done;
  } else {
  }
// compiled if node returning if9532 (depth = 3)
    gc_frame_newslot(if9532);
    if9208 = if9532;
  } else {
  }
// compiled if node returning if9208 (depth = 2)
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9563 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9564 == NULL) {
    strlit9564 = alloc_String("arrow");
    gc_root(strlit9564);
  }
// compiled string node returning strlit9564 (depth = 4)
  gc_frame_newslot(strlit9564);
// call case 4: self request
  params[0] = strlit9564;
  partcv[0] = 1;
  Object call9565 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9563);
// compiled call node returning call9565 (depth = 3)
  Object if9562 = done;
  if (istrue(call9565)) {
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9567 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9566);
// compiled call node returning call9567 (depth = 4)
// compiled member node returning call9567 (depth = 3)
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9568 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9569 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9568);
// compiled call node returning call9569 (depth = 4)
// compiled member node returning call9569 (depth = 3)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9571 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9570);
// compiled call node returning call9571 (depth = 5)
// compiled member node returning call9571 (depth = 4)
  *var_dtype = call9571;
  if (call9571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9562 = done;
  } else {
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9573 = alloc_Boolean(0);
// compiled identifier node returning bool9573 (depth = 4)
  *var_dtype = bool9573;
  if (bool9573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9562 = done;
  }
// compiled if node returning if9562 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9575 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9575 = alloc_userobj2(5,6, objclass9575);
  gc_frame_newslot(obj9575);
if (objclass9575 == NULL) {
  glfree(obj9575->class->name);
  obj9575->class->name = "self.methodsignature";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9575, self, 0);
  addmethodreal(obj9575,"outer", &reader_parser_outer_9576);
  Object oldself9575 = self;
  struct StackFrameObject *oldstackframe9575 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9575);
  gc_frame_newslot((Object)stackframe);
  self = obj9575;
  Object *oldselfslot9575 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9575 = (*(struct UserObject *)self).data[0], lowerouter9575 = thisouter9575;
  if (inheritingObject9575) {
    struct UserObject *inho9575 = (struct UserObject *)inheritingObject9575;
    while (inho9575->super != GraceDefaultObject) inho9575 = (struct UserObject *)inho9575->super;
    inho9575->super = obj9575;
    self = inheritingObject9575;
    *selfslot = self;
    lowerouter9575 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9575;
  }
if (objclass9575 == NULL) {
  Method *reader9577 = addmethodrealflags(obj9575, "m",&reader_parser_m_9577, MFLAG_DEF);
  reader9577->definitionModule = modulename;
  reader9577->definitionLine = 2967;
}
adddatum2(obj9575, alloc_Undefined(), 1);
if (objclass9575 == NULL) {
  Method *reader9578 = addmethodrealflags(obj9575, "sig",&reader_parser_sig_9578, MFLAG_DEF);
  reader9578->definitionModule = modulename;
  reader9578->definitionLine = 2968;
}
adddatum2(obj9575, alloc_Undefined(), 2);
if (objclass9575 == NULL) {
  Method *reader9579 = addmethodrealflags(obj9575, "rtype",&reader_parser_rtype_9579, MFLAG_DEF);
  reader9579->definitionModule = modulename;
  reader9579->definitionLine = 2969;
}
adddatum2(obj9575, alloc_Undefined(), 3);
if (objclass9575 == NULL) {
  Method *reader9580 = addmethodrealflags(obj9575, "v",&reader_parser_v_9580, MFLAG_DEF);
  reader9580->definitionModule = modulename;
  reader9580->definitionLine = 2970;
}
adddatum2(obj9575, alloc_Undefined(), 4);
if (objclass9575 == NULL) {
  Method *reader9581 = addmethodrealflags(obj9575, "typeParams",&reader_parser_typeParams_9581, MFLAG_DEF);
  reader9581->definitionModule = modulename;
  reader9581->definitionLine = 2971;
}
adddatum2(obj9575, alloc_Undefined(), 5);
  sourceObject = obj9575;
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth (depth = 2)
  adddatum2(obj9575, *var_meth, 1);
  sourceObject = obj9575;
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_signature (depth = 2)
  adddatum2(obj9575, *var_signature, 2);
  sourceObject = obj9575;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_dtype (depth = 2)
  adddatum2(obj9575, *var_dtype, 3);
  sourceObject = obj9575;
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_varargs (depth = 2)
  adddatum2(obj9575, *var_varargs, 4);
  sourceObject = obj9575;
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_myTypeParams (depth = 2)
  adddatum2(obj9575, *var_myTypeParams, 5);
  objclass9575 = obj9575->class;
  objclass9575->definitionModule = modulename;
  objclass9575->definitionLine = 2966;
  (*(struct UserObject *)self).data[0] = lowerouter9575;
  self = oldself9575;
  selfslot = oldselfslot9575;
  stackframe = oldstackframe9575;
  gc_frame_end(frame);
  return obj9575;
}
Object meth_parser__apply9592(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe9593 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9594 == NULL) {
    strlit9594 = alloc_String("identifier");
    gc_root(strlit9594);
  }
// compiled string node returning strlit9594 (depth = 5)
  gc_frame_newslot(strlit9594);
// call case 4: self request
  params[0] = strlit9594;
  partcv[0] = 1;
  Object call9595 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9593);
// compiled call node returning call9595 (depth = 4)
  gc_frame_end(frame);
  return call9595;
}
Object meth_parser__apply9598(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_typeIds = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9600 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9599);
// compiled call node returning call9600 (depth = 5)
// compiled member node returning call9600 (depth = 4)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9601 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9602 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9601);
// compiled call node returning call9602 (depth = 6)
// compiled member node returning call9602 (depth = 5)
  *var_id = call9602;
  if (call9602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9603 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool9604 = alloc_Boolean(1);
// compiled identifier node returning bool9604 (depth = 5)
  gc_frame_newslot(bool9604);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  params[0] = bool9604;
  partcv[0] = 1;
  Object call9605 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9603);
// compiled call node returning call9605 (depth = 4)
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9606 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9607 = callmethod(*var_typeIds, "push",
    1, partcv, params);
  gc_frame_end(callframe9606);
// compiled call node returning call9607 (depth = 4)
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9609 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9610 == NULL) {
    strlit9610 = alloc_String("comma");
    gc_root(strlit9610);
  }
// compiled string node returning strlit9610 (depth = 6)
  gc_frame_newslot(strlit9610);
// call case 4: self request
  params[0] = strlit9610;
  partcv[0] = 1;
  Object call9611 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9609);
// compiled call node returning call9611 (depth = 5)
  Object if9608 = done;
  if (istrue(call9611)) {
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9612 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9613 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9612);
// compiled call node returning call9613 (depth = 6)
// compiled member node returning call9613 (depth = 5)
    gc_frame_newslot(call9613);
    if9608 = call9613;
  } else {
  }
// compiled if node returning if9608 (depth = 4)
  gc_frame_end(frame);
  return if9608;
}
Object meth_parser__apply9618(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe9619 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool9620 = alloc_Boolean(1);
// compiled identifier node returning bool9620 (depth = 5)
  gc_frame_newslot(bool9620);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  params[0] = bool9620;
  partcv[0] = 1;
  Object call9621 = callmethod(*var_each, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9619);
// compiled call node returning call9621 (depth = 4)
  gc_frame_end(frame);
  return call9621;
}
Object meth_parser_typeparameters9583(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeparameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeparameters (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeparameters");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeIds = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeIds");
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9585 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9584);
// compiled call node returning call9585 (depth = 3)
// compiled member node returning call9585 (depth = 2)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9586 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9587 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9588 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9587);
// compiled call node returning call9588 (depth = 6)
// compiled member node returning call9588 (depth = 5)
  partcv[0] = 0;
  Object call9589 = callmethod(call9588, "empty",
    1, partcv, params);
  gc_frame_end(callframe9586);
// compiled call node returning call9589 (depth = 4)
// compiled member node returning call9589 (depth = 3)
  *var_typeIds = call9589;
  if (call9589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9590 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9591 = alloc_Block(NULL, NULL, "parser", 2978);
  gc_frame_newslot(block9591);
// method "_apply"
  block_savedest(block9591);
  Object closure9592 = createclosure(1, "_apply");
  setclosureframe(closure9592, stackframe);
  addtoclosure(closure9592, selfslot);
  struct UserObject *uo9592 = (struct UserObject*)block9591;
  uo9592->data[0] = (Object)closure9592;
  Method *meth_meth_parser__apply9592 = addmethod2pos(block9591, "_apply", &meth_parser__apply9592, 0);
  int argcv_meth_parser__apply9592[] = {0};
  meth_meth_parser__apply9592->type = alloc_MethodType(1, argcv_meth_parser__apply9592);
  meth_meth_parser__apply9592->definitionModule = modulename;
  meth_meth_parser__apply9592->definitionLine = 2977;
// compiled block node returning block9591 (depth = 3)
  gc_frame_newslot(block9591);
// starting to compile block node (depth = 3)
  Object block9597 = alloc_Block(NULL, NULL, "parser", 2978);
  gc_frame_newslot(block9597);
// method "_apply"
  block_savedest(block9597);
  Object closure9598 = createclosure(3, "_apply");
  setclosureframe(closure9598, stackframe);
  addtoclosure(closure9598, var_values);
  addtoclosure(closure9598, var_typeIds);
  addtoclosure(closure9598, selfslot);
  struct UserObject *uo9598 = (struct UserObject*)block9597;
  uo9598->data[0] = (Object)closure9598;
  Method *meth_meth_parser__apply9598 = addmethod2pos(block9597, "_apply", &meth_parser__apply9598, 0);
  int argcv_meth_parser__apply9598[] = {0};
  meth_meth_parser__apply9598->type = alloc_MethodType(1, argcv_meth_parser__apply9598);
  meth_meth_parser__apply9598->definitionModule = modulename;
  meth_meth_parser__apply9598->definitionLine = 2977;
// compiled block node returning block9597 (depth = 3)
  gc_frame_newslot(block9597);
// call case 5: prelude request
  params[0] = block9591;
  params[1] = block9597;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9615 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9590);
// compiled call node returning call9615 (depth = 2)
// Begin line 2987
  setline(2987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9616 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9617 = alloc_Block(NULL, NULL, "parser", 2987);
  gc_frame_newslot(block9617);
// method "_apply"
  block_savedest(block9617);
  Object closure9618 = createclosure(1, "_apply");
  setclosureframe(closure9618, stackframe);
  addtoclosure(closure9618, selfslot);
  struct UserObject *uo9618 = (struct UserObject*)block9617;
  uo9618->data[0] = (Object)closure9618;
  Method *meth_meth_parser__apply9618 = addmethod2pos(block9617, "_apply", &meth_parser__apply9618, 0);
  int argcv_meth_parser__apply9618[] = {1};
  meth_meth_parser__apply9618->type = alloc_MethodType(1, argcv_meth_parser__apply9618);
  meth_meth_parser__apply9618->definitionModule = modulename;
  meth_meth_parser__apply9618->definitionLine = 2984;
// compiled block node returning block9617 (depth = 3)
  gc_frame_newslot(block9617);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeIds (depth = 3)
  params[0] = block9617;
  partcv[0] = 1;
  Object call9623 = callmethod(*var_typeIds, "do",
    1, partcv, params);
  gc_frame_end(callframe9616);
// compiled call node returning call9623 (depth = 2)
// Begin line 2988
  setline(2988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9624 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeIds (depth = 4)
  gc_frame_newslot(*var_typeIds);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9625 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9626 = callmethod(*var_ast, "typeParametersNode",
    1, partcv, params);
  gc_frame_end(callframe9625);
// compiled call node returning call9626 (depth = 5)
// compiled member node returning call9626 (depth = 4)
  params[0] = *var_typeIds;
  partcv[0] = 1;
  Object call9627 = callmethod(call9626, "new",
    1, partcv, params);
  gc_frame_end(callframe9624);
// compiled call node returning call9627 (depth = 3)
  *var_result = call9627;
  if (call9627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9630 == NULL) {
    strlit9630 = alloc_String("rgeneric");
    gc_root(strlit9630);
  }
// compiled string node returning strlit9630 (depth = 4)
  int op_slot_right_9629 = gc_frame_newslot(strlit9630);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9633 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9632);
// compiled call node returning call9633 (depth = 5)
// compiled member node returning call9633 (depth = 4)
  int op_slot_left_9629 = gc_frame_newslot(call9633);
  params[0] = strlit9630;
  partcv[0] = 1;
  Object opresult9634 = callmethod(call9633, "!=", 1, partcv, params);
// compiled op node returning opresult9634 (depth = 3)
  Object if9628 = done;
  if (istrue(opresult9634)) {
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9635 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9636 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9637 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9636);
// compiled call node returning call9637 (depth = 7)
// compiled member node returning call9637 (depth = 6)
  partcv[0] = 0;
  Object call9638 = callmethod(call9637, "new",
    1, partcv, params);
  gc_frame_end(callframe9635);
// compiled call node returning call9638 (depth = 5)
// compiled member node returning call9638 (depth = 4)
  *var_suggestion = call9638;
  if (call9638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9639 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9640 == NULL) {
    strlit9640 = alloc_String(">");
    gc_root(strlit9640);
  }
// compiled string node returning strlit9640 (depth = 4)
  gc_frame_newslot(strlit9640);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit9640;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9641 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9639);
// compiled call node returning call9641 (depth = 3)
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9642 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9643 == NULL) {
    strlit9643 = alloc_String("a list of type parameters starting with '<' must end with '>'.");
    gc_root(strlit9643);
  }
// compiled string node returning strlit9643 (depth = 4)
  gc_frame_newslot(strlit9643);
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9645 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9644);
// compiled call node returning call9645 (depth = 5)
// compiled member node returning call9645 (depth = 4)
  gc_frame_newslot(call9645);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9648 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9647);
// compiled call node returning call9648 (depth = 6)
// compiled member node returning call9648 (depth = 5)
  int op_slot_right_9646 = gc_frame_newslot(call9648);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9651 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9650);
// compiled call node returning call9651 (depth = 6)
// compiled member node returning call9651 (depth = 5)
  int op_slot_left_9646 = gc_frame_newslot(call9651);
  params[0] = call9648;
  partcv[0] = 1;
  Object sum9652 = callmethod(call9651, "+", 1, partcv, params);
// compiled op node returning sum9652 (depth = 4)
  gc_frame_newslot(sum9652);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9643;
  params[1] = call9645;
  params[2] = sum9652;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9653 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9642);
// compiled call node returning call9653 (depth = 3)
    gc_frame_newslot(call9653);
    if9628 = call9653;
  } else {
  }
// compiled if node returning if9628 (depth = 2)
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9655 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9654);
// compiled call node returning call9655 (depth = 3)
// compiled member node returning call9655 (depth = 2)
// Begin line 2996
  setline(2996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_doimport9656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_defaultDefVisibility = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doimport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doimport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_importline = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importline");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
  Object *var_name = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "name");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9658 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9659 == NULL) {
    strlit9659 = alloc_String("import");
    gc_root(strlit9659);
  }
// compiled string node returning strlit9659 (depth = 4)
  gc_frame_newslot(strlit9659);
// call case 4: self request
  params[0] = strlit9659;
  partcv[0] = 1;
  Object call9660 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9658);
// compiled call node returning call9660 (depth = 3)
  Object if9657 = done;
  if (istrue(call9660)) {
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9662 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9661);
// compiled call node returning call9662 (depth = 5)
// compiled member node returning call9662 (depth = 4)
  *var_importline = call9662;
  if (call9662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9664 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9663);
// compiled call node returning call9664 (depth = 4)
// compiled member node returning call9664 (depth = 3)
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9667 == NULL) {
    strlit9667 = alloc_String("string");
    gc_root(strlit9667);
  }
// compiled string node returning strlit9667 (depth = 5)
  int op_slot_right_9666 = gc_frame_newslot(strlit9667);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9670 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9669);
// compiled call node returning call9670 (depth = 6)
// compiled member node returning call9670 (depth = 5)
  int op_slot_left_9666 = gc_frame_newslot(call9670);
  params[0] = strlit9667;
  partcv[0] = 1;
  Object opresult9671 = callmethod(call9670, "!=", 1, partcv, params);
// compiled op node returning opresult9671 (depth = 4)
  Object if9665 = done;
  if (istrue(opresult9671)) {
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9672 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9674 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9673);
// compiled call node returning call9674 (depth = 8)
// compiled member node returning call9674 (depth = 7)
  partcv[0] = 0;
  Object call9675 = callmethod(call9674, "new",
    1, partcv, params);
  gc_frame_end(callframe9672);
// compiled call node returning call9675 (depth = 6)
// compiled member node returning call9675 (depth = 5)
  *var_suggestion = call9675;
  if (call9675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3007
  setline(3007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9680 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9679);
// compiled call node returning call9680 (depth = 8)
// compiled member node returning call9680 (depth = 7)
  int op_slot_right_9678 = gc_frame_newslot(call9680);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9683 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9682);
// compiled call node returning call9683 (depth = 8)
// compiled member node returning call9683 (depth = 7)
  int op_slot_left_9678 = gc_frame_newslot(call9683);
  params[0] = call9680;
  partcv[0] = 1;
  Object opresult9684 = callmethod(call9683, "==", 1, partcv, params);
// compiled op node returning opresult9684 (depth = 6)
  int op_slot_right_9677 = gc_frame_newslot(opresult9684);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9687 == NULL) {
    strlit9687 = alloc_String("identifier");
    gc_root(strlit9687);
  }
// compiled string node returning strlit9687 (depth = 7)
  int op_slot_right_9686 = gc_frame_newslot(strlit9687);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9690 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9689);
// compiled call node returning call9690 (depth = 8)
// compiled member node returning call9690 (depth = 7)
  int op_slot_left_9686 = gc_frame_newslot(call9690);
  params[0] = strlit9687;
  partcv[0] = 1;
  Object opresult9691 = callmethod(call9690, "==", 1, partcv, params);
// compiled op node returning opresult9691 (depth = 6)
  int op_slot_left_9677 = gc_frame_newslot(opresult9691);
  params[0] = opresult9684;
  partcv[0] = 1;
  Object opresult9692 = callmethod(opresult9691, "&&", 1, partcv, params);
// compiled op node returning opresult9692 (depth = 5)
  Object if9676 = done;
  if (istrue(opresult9692)) {
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9693 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9695 == NULL) {
    strlit9695 = alloc_String("""\x22""");
    gc_root(strlit9695);
  }
// compiled string node returning strlit9695 (depth = 7)
  int op_slot_right_9694 = gc_frame_newslot(strlit9695);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9699 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9698);
// compiled call node returning call9699 (depth = 9)
// compiled member node returning call9699 (depth = 8)
  int op_slot_right_9697 = gc_frame_newslot(call9699);
// starting to compile string node (depth = 8)
  if (strlit9701 == NULL) {
    strlit9701 = alloc_String("""\x22""");
    gc_root(strlit9701);
  }
// compiled string node returning strlit9701 (depth = 8)
  int op_slot_left_9697 = gc_frame_newslot(strlit9701);
  params[0] = call9699;
  partcv[0] = 1;
  Object opresult9702 = callmethod(strlit9701, "++", 1, partcv, params);
// compiled op node returning opresult9702 (depth = 7)
  int op_slot_left_9694 = gc_frame_newslot(opresult9702);
  params[0] = strlit9695;
  partcv[0] = 1;
  Object opresult9703 = callmethod(opresult9702, "++", 1, partcv, params);
// compiled op node returning opresult9703 (depth = 6)
  gc_frame_newslot(opresult9703);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult9703;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9704 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9693);
// compiled call node returning call9704 (depth = 5)
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9705 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9706 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9705);
// compiled call node returning call9706 (depth = 7)
// compiled member node returning call9706 (depth = 6)
  *var_errorPos = call9706;
  if (call9706 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9676 = done;
  } else {
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9708 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9709 == NULL) {
    strlit9709 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit9709);
  }
// compiled string node returning strlit9709 (depth = 6)
  gc_frame_newslot(strlit9709);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9709;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9710 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9708);
// compiled call node returning call9710 (depth = 5)
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9712 = alloc_Float64(1);
// compiled num node returning num9712 (depth = 7)
  int op_slot_right_9711 = gc_frame_newslot(num9712);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9716 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9715);
// compiled call node returning call9716 (depth = 9)
// compiled member node returning call9716 (depth = 8)
  int op_slot_right_9714 = gc_frame_newslot(call9716);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9719 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9718);
// compiled call node returning call9719 (depth = 9)
// compiled member node returning call9719 (depth = 8)
  int op_slot_left_9714 = gc_frame_newslot(call9719);
  params[0] = call9716;
  partcv[0] = 1;
  Object sum9720 = callmethod(call9719, "+", 1, partcv, params);
// compiled op node returning sum9720 (depth = 7)
  int op_slot_left_9711 = gc_frame_newslot(sum9720);
  params[0] = num9712;
  partcv[0] = 1;
  Object sum9721 = callmethod(sum9720, "+", 1, partcv, params);
// compiled op node returning sum9721 (depth = 6)
  *var_errorPos = sum9721;
  if (sum9721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9676 = done;
  }
// compiled if node returning if9676 (depth = 4)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9723 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9724 == NULL) {
    strlit9724 = alloc_String("an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit9724);
  }
// compiled string node returning strlit9724 (depth = 5)
  gc_frame_newslot(strlit9724);
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9726 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9725);
// compiled call node returning call9726 (depth = 6)
// compiled member node returning call9726 (depth = 5)
  gc_frame_newslot(call9726);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9724;
  params[1] = call9726;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9727 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9723);
// compiled call node returning call9727 (depth = 4)
    gc_frame_newslot(call9727);
    if9665 = call9727;
  } else {
  }
// compiled if node returning if9665 (depth = 3)
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9729 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9728);
// compiled call node returning call9729 (depth = 4)
// compiled member node returning call9729 (depth = 3)
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9731 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9730);
// compiled call node returning call9731 (depth = 5)
// compiled member node returning call9731 (depth = 4)
  *var_p = call9731;
  if (call9731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9735 == NULL) {
    strlit9735 = alloc_String("as");
    gc_root(strlit9735);
  }
// compiled string node returning strlit9735 (depth = 6)
  int op_slot_right_9734 = gc_frame_newslot(strlit9735);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9738 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9737);
// compiled call node returning call9738 (depth = 7)
// compiled member node returning call9738 (depth = 6)
  int op_slot_left_9734 = gc_frame_newslot(call9738);
  params[0] = strlit9735;
  partcv[0] = 1;
  Object opresult9739 = callmethod(call9738, "!=", 1, partcv, params);
// compiled op node returning opresult9739 (depth = 5)
  int op_slot_right_9733 = gc_frame_newslot(opresult9739);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9742 == NULL) {
    strlit9742 = alloc_String("identifier");
    gc_root(strlit9742);
  }
// compiled string node returning strlit9742 (depth = 6)
  int op_slot_right_9741 = gc_frame_newslot(strlit9742);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9745 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9744);
// compiled call node returning call9745 (depth = 7)
// compiled member node returning call9745 (depth = 6)
  int op_slot_left_9741 = gc_frame_newslot(call9745);
  params[0] = strlit9742;
  partcv[0] = 1;
  Object opresult9746 = callmethod(call9745, "!=", 1, partcv, params);
// compiled op node returning opresult9746 (depth = 5)
  int op_slot_left_9733 = gc_frame_newslot(opresult9746);
  params[0] = opresult9739;
  partcv[0] = 1;
  Object opresult9747 = callmethod(opresult9746, "||", 1, partcv, params);
// compiled op node returning opresult9747 (depth = 4)
  Object if9732 = done;
  if (istrue(opresult9747)) {
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9748 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9750 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9749);
// compiled call node returning call9750 (depth = 8)
// compiled member node returning call9750 (depth = 7)
  partcv[0] = 0;
  Object call9751 = callmethod(call9750, "new",
    1, partcv, params);
  gc_frame_end(callframe9748);
// compiled call node returning call9751 (depth = 6)
// compiled member node returning call9751 (depth = 5)
  *var_suggestion = call9751;
  if (call9751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9756 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9755);
// compiled call node returning call9756 (depth = 8)
// compiled member node returning call9756 (depth = 7)
  int op_slot_right_9754 = gc_frame_newslot(call9756);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9759 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9758);
// compiled call node returning call9759 (depth = 8)
// compiled member node returning call9759 (depth = 7)
  int op_slot_left_9754 = gc_frame_newslot(call9759);
  params[0] = call9756;
  partcv[0] = 1;
  Object opresult9760 = callmethod(call9759, "==", 1, partcv, params);
// compiled op node returning opresult9760 (depth = 6)
  int op_slot_right_9753 = gc_frame_newslot(opresult9760);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9763 == NULL) {
    strlit9763 = alloc_String("identifier");
    gc_root(strlit9763);
  }
// compiled string node returning strlit9763 (depth = 7)
  int op_slot_right_9762 = gc_frame_newslot(strlit9763);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9765 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9766 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9765);
// compiled call node returning call9766 (depth = 8)
// compiled member node returning call9766 (depth = 7)
  int op_slot_left_9762 = gc_frame_newslot(call9766);
  params[0] = strlit9763;
  partcv[0] = 1;
  Object opresult9767 = callmethod(call9766, "==", 1, partcv, params);
// compiled op node returning opresult9767 (depth = 6)
  int op_slot_left_9753 = gc_frame_newslot(opresult9767);
  params[0] = opresult9760;
  partcv[0] = 1;
  Object opresult9768 = callmethod(opresult9767, "&&", 1, partcv, params);
// compiled op node returning opresult9768 (depth = 5)
  Object if9752 = done;
  if (istrue(opresult9768)) {
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9769 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9770 == NULL) {
    strlit9770 = alloc_String(" as");
    gc_root(strlit9770);
  }
// compiled string node returning strlit9770 (depth = 6)
  gc_frame_newslot(strlit9770);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9770;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9771 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9769);
// compiled call node returning call9771 (depth = 5)
    gc_frame_newslot(call9771);
    if9752 = call9771;
  } else {
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9772 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9774 == NULL) {
    strlit9774 = alloc_String("");
    gc_root(strlit9774);
  }
// compiled string node returning strlit9774 (depth = 7)
  int op_slot_right_9773 = gc_frame_newslot(strlit9774);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call9778 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9777);
// compiled call node returning call9778 (depth = 9)
// compiled member node returning call9778 (depth = 8)
  int op_slot_right_9776 = gc_frame_newslot(call9778);
// starting to compile string node (depth = 8)
  if (strlit9780 == NULL) {
    strlit9780 = alloc_String(" as ");
    gc_root(strlit9780);
  }
// compiled string node returning strlit9780 (depth = 8)
  int op_slot_left_9776 = gc_frame_newslot(strlit9780);
  params[0] = call9778;
  partcv[0] = 1;
  Object opresult9781 = callmethod(strlit9780, "++", 1, partcv, params);
// compiled op node returning opresult9781 (depth = 7)
  int op_slot_left_9773 = gc_frame_newslot(opresult9781);
  params[0] = strlit9774;
  partcv[0] = 1;
  Object opresult9782 = callmethod(opresult9781, "++", 1, partcv, params);
// compiled op node returning opresult9782 (depth = 6)
  gc_frame_newslot(opresult9782);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult9782;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9783 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9772);
// compiled call node returning call9783 (depth = 5)
    gc_frame_newslot(call9783);
    if9752 = call9783;
  }
// compiled if node returning if9752 (depth = 4)
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9784 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9785 == NULL) {
    strlit9785 = alloc_String("an import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit9785);
  }
// compiled string node returning strlit9785 (depth = 5)
  gc_frame_newslot(strlit9785);
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9787 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9786);
// compiled call node returning call9787 (depth = 6)
// compiled member node returning call9787 (depth = 5)
  gc_frame_newslot(call9787);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9789 = alloc_Float64(1);
// compiled num node returning num9789 (depth = 6)
  int op_slot_right_9788 = gc_frame_newslot(num9789);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9792 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9793 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9792);
// compiled call node returning call9793 (depth = 8)
// compiled member node returning call9793 (depth = 7)
  int op_slot_right_9791 = gc_frame_newslot(call9793);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9796 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9795);
// compiled call node returning call9796 (depth = 8)
// compiled member node returning call9796 (depth = 7)
  int op_slot_left_9791 = gc_frame_newslot(call9796);
  params[0] = call9793;
  partcv[0] = 1;
  Object sum9797 = callmethod(call9796, "+", 1, partcv, params);
// compiled op node returning sum9797 (depth = 6)
  int op_slot_left_9788 = gc_frame_newslot(sum9797);
  params[0] = num9789;
  partcv[0] = 1;
  Object sum9798 = callmethod(sum9797, "+", 1, partcv, params);
// compiled op node returning sum9798 (depth = 5)
  gc_frame_newslot(sum9798);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9785;
  params[1] = call9787;
  params[2] = sum9798;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9799 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9784);
// compiled call node returning call9799 (depth = 4)
    gc_frame_newslot(call9799);
    if9732 = call9799;
  } else {
  }
// compiled if node returning if9732 (depth = 3)
// Begin line 3030
  setline(3030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9801 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9800);
// compiled call node returning call9801 (depth = 4)
// compiled member node returning call9801 (depth = 3)
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9804 == NULL) {
    strlit9804 = alloc_String("identifier");
    gc_root(strlit9804);
  }
// compiled string node returning strlit9804 (depth = 5)
  int op_slot_right_9803 = gc_frame_newslot(strlit9804);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9806 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9807 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9806);
// compiled call node returning call9807 (depth = 6)
// compiled member node returning call9807 (depth = 5)
  int op_slot_left_9803 = gc_frame_newslot(call9807);
  params[0] = strlit9804;
  partcv[0] = 1;
  Object opresult9808 = callmethod(call9807, "!=", 1, partcv, params);
// compiled op node returning opresult9808 (depth = 4)
  Object if9802 = done;
  if (istrue(opresult9808)) {
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9809 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9811 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9810);
// compiled call node returning call9811 (depth = 8)
// compiled member node returning call9811 (depth = 7)
  partcv[0] = 0;
  Object call9812 = callmethod(call9811, "new",
    1, partcv, params);
  gc_frame_end(callframe9809);
// compiled call node returning call9812 (depth = 6)
// compiled member node returning call9812 (depth = 5)
  *var_suggestion = call9812;
  if (call9812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3034
  setline(3034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9816 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9817 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9816);
// compiled call node returning call9817 (depth = 8)
// compiled member node returning call9817 (depth = 7)
  int op_slot_right_9815 = gc_frame_newslot(call9817);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9820 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9819);
// compiled call node returning call9820 (depth = 8)
// compiled member node returning call9820 (depth = 7)
  int op_slot_left_9815 = gc_frame_newslot(call9820);
  params[0] = call9817;
  partcv[0] = 1;
  Object opresult9821 = callmethod(call9820, "==", 1, partcv, params);
// compiled op node returning opresult9821 (depth = 6)
  int op_slot_right_9814 = gc_frame_newslot(opresult9821);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9824 == NULL) {
    strlit9824 = alloc_String("string");
    gc_root(strlit9824);
  }
// compiled string node returning strlit9824 (depth = 7)
  int op_slot_right_9823 = gc_frame_newslot(strlit9824);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9827 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9826);
// compiled call node returning call9827 (depth = 8)
// compiled member node returning call9827 (depth = 7)
  int op_slot_left_9823 = gc_frame_newslot(call9827);
  params[0] = strlit9824;
  partcv[0] = 1;
  Object opresult9828 = callmethod(call9827, "==", 1, partcv, params);
// compiled op node returning opresult9828 (depth = 6)
  int op_slot_left_9814 = gc_frame_newslot(opresult9828);
  params[0] = opresult9821;
  partcv[0] = 1;
  Object opresult9829 = callmethod(opresult9828, "&&", 1, partcv, params);
// compiled op node returning opresult9829 (depth = 5)
  Object if9813 = done;
  if (istrue(opresult9829)) {
// Begin line 3035
  setline(3035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9830 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9832 == NULL) {
    strlit9832 = alloc_String("");
    gc_root(strlit9832);
  }
// compiled string node returning strlit9832 (depth = 7)
  int op_slot_right_9831 = gc_frame_newslot(strlit9832);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9835 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9836 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9835);
// compiled call node returning call9836 (depth = 9)
// compiled member node returning call9836 (depth = 8)
  int op_slot_right_9834 = gc_frame_newslot(call9836);
// starting to compile string node (depth = 8)
  if (strlit9838 == NULL) {
    strlit9838 = alloc_String("");
    gc_root(strlit9838);
  }
// compiled string node returning strlit9838 (depth = 8)
  int op_slot_left_9834 = gc_frame_newslot(strlit9838);
  params[0] = call9836;
  partcv[0] = 1;
  Object opresult9839 = callmethod(strlit9838, "++", 1, partcv, params);
// compiled op node returning opresult9839 (depth = 7)
  int op_slot_left_9831 = gc_frame_newslot(opresult9839);
  params[0] = strlit9832;
  partcv[0] = 1;
  Object opresult9840 = callmethod(opresult9839, "++", 1, partcv, params);
// compiled op node returning opresult9840 (depth = 6)
  gc_frame_newslot(opresult9840);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult9840;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9841 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9830);
// compiled call node returning call9841 (depth = 5)
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9843 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9842);
// compiled call node returning call9843 (depth = 7)
// compiled member node returning call9843 (depth = 6)
  *var_errorPos = call9843;
  if (call9843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9813 = done;
  } else {
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9845 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9847 == NULL) {
    strlit9847 = alloc_String("");
    gc_root(strlit9847);
  }
// compiled string node returning strlit9847 (depth = 7)
  int op_slot_right_9846 = gc_frame_newslot(strlit9847);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call9851 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9850);
// compiled call node returning call9851 (depth = 9)
// compiled member node returning call9851 (depth = 8)
  int op_slot_right_9849 = gc_frame_newslot(call9851);
// starting to compile string node (depth = 8)
  if (strlit9853 == NULL) {
    strlit9853 = alloc_String(" ");
    gc_root(strlit9853);
  }
// compiled string node returning strlit9853 (depth = 8)
  int op_slot_left_9849 = gc_frame_newslot(strlit9853);
  params[0] = call9851;
  partcv[0] = 1;
  Object opresult9854 = callmethod(strlit9853, "++", 1, partcv, params);
// compiled op node returning opresult9854 (depth = 7)
  int op_slot_left_9846 = gc_frame_newslot(opresult9854);
  params[0] = strlit9847;
  partcv[0] = 1;
  Object opresult9855 = callmethod(opresult9854, "++", 1, partcv, params);
// compiled op node returning opresult9855 (depth = 6)
  gc_frame_newslot(opresult9855);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult9855;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9856 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9845);
// compiled call node returning call9856 (depth = 5)
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9858 = alloc_Float64(1);
// compiled num node returning num9858 (depth = 7)
  int op_slot_right_9857 = gc_frame_newslot(num9858);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9862 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9861);
// compiled call node returning call9862 (depth = 9)
// compiled member node returning call9862 (depth = 8)
  int op_slot_right_9860 = gc_frame_newslot(call9862);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9865 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9864);
// compiled call node returning call9865 (depth = 9)
// compiled member node returning call9865 (depth = 8)
  int op_slot_left_9860 = gc_frame_newslot(call9865);
  params[0] = call9862;
  partcv[0] = 1;
  Object sum9866 = callmethod(call9865, "+", 1, partcv, params);
// compiled op node returning sum9866 (depth = 7)
  int op_slot_left_9857 = gc_frame_newslot(sum9866);
  params[0] = num9858;
  partcv[0] = 1;
  Object sum9867 = callmethod(sum9866, "+", 1, partcv, params);
// compiled op node returning sum9867 (depth = 6)
  *var_errorPos = sum9867;
  if (sum9867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9813 = done;
  }
// compiled if node returning if9813 (depth = 4)
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9869 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9870 == NULL) {
    strlit9870 = alloc_String("an import statement must have an identifier after 'as'.");
    gc_root(strlit9870);
  }
// compiled string node returning strlit9870 (depth = 5)
  gc_frame_newslot(strlit9870);
// Begin line 3042
  setline(3042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9872 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9871);
// compiled call node returning call9872 (depth = 6)
// compiled member node returning call9872 (depth = 5)
  gc_frame_newslot(call9872);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9870;
  params[1] = call9872;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9873 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9869);
// compiled call node returning call9873 (depth = 4)
    gc_frame_newslot(call9873);
    if9802 = call9873;
  } else {
  }
// compiled if node returning if9802 (depth = 3)
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9874 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9875 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9874);
// compiled call node returning call9875 (depth = 4)
// compiled member node returning call9875 (depth = 3)
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9876 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9877 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9876);
// compiled call node returning call9877 (depth = 5)
// compiled member node returning call9877 (depth = 4)
  *var_name = call9877;
  if (call9877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9878 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9879 = alloc_Boolean(1);
// compiled identifier node returning bool9879 (depth = 4)
  gc_frame_newslot(bool9879);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool9879;
  partcv[0] = 1;
  Object call9880 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9878);
// compiled call node returning call9880 (depth = 3)
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9881 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9882 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9881);
// compiled call node returning call9882 (depth = 5)
// compiled member node returning call9882 (depth = 4)
  *var_dtype = call9882;
  if (call9882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9883 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_importline (depth = 4)
  gc_frame_newslot(*var_importline);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_importline;
  partcv[0] = 1;
  Object call9884 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe9883);
// compiled call node returning call9884 (depth = 3)
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9885 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call9887 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9886);
// compiled call node returning call9887 (depth = 6)
// compiled member node returning call9887 (depth = 5)
  gc_frame_newslot(call9887);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9889 = callmethod(*var_ast, "importNode",
    1, partcv, params);
  gc_frame_end(callframe9888);
// compiled call node returning call9889 (depth = 6)
// compiled member node returning call9889 (depth = 5)
  params[0] = call9887;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call9890 = callmethod(call9889, "new",
    1, partcv, params);
  gc_frame_end(callframe9885);
// compiled call node returning call9890 (depth = 4)
  *var_o = call9890;
  if (call9890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9891 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9892 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9891);
// compiled call node returning call9892 (depth = 5)
// compiled member node returning call9892 (depth = 4)
  *var_anns = call9892;
  if (call9892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3051
  setline(3051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9895 = alloc_Boolean(0);
// compiled identifier node returning bool9895 (depth = 5)
  int op_slot_right_9894 = gc_frame_newslot(bool9895);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_9894 = gc_frame_newslot(*var_anns);
  params[0] = bool9895;
  partcv[0] = 1;
  Object opresult9897 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult9897 (depth = 4)
  Object if9893 = done;
  if (istrue(opresult9897)) {
// starting to compile call node (depth = 4)
  int callframe9898 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call9900 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe9899);
// compiled call node returning call9900 (depth = 6)
// compiled member node returning call9900 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call9901 = callmethod(call9900, "addAll",
    1, partcv, params);
  gc_frame_end(callframe9898);
// compiled call node returning call9901 (depth = 4)
    gc_frame_newslot(call9901);
    if9893 = call9901;
  } else {
  }
// compiled if node returning if9893 (depth = 3)
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9902 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultDefVisibility (depth = 4)
  gc_frame_newslot(*var_defaultDefVisibility);
// starting to compile string node (depth = 4)
  if (strlit9903 == NULL) {
    strlit9903 = alloc_String("confidential");
    gc_root(strlit9903);
  }
// compiled string node returning strlit9903 (depth = 4)
  gc_frame_newslot(strlit9903);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultDefVisibility;
  params[2] = strlit9903;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9904 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9902);
// compiled call node returning call9904 (depth = 3)
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9905 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9906 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9905);
// compiled call node returning call9906 (depth = 3)
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9908 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9907);
// compiled call node returning call9908 (depth = 4)
// compiled member node returning call9908 (depth = 3)
    gc_frame_newslot(call9908);
    if9657 = call9908;
  } else {
  }
// compiled if node returning if9657 (depth = 2)
  gc_frame_end(frame);
  return if9657;
}
Object meth_parser__apply9919(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9920 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe9921 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9922 == NULL) {
    strlit9922 = alloc_String("rbrace");
    gc_root(strlit9922);
  }
// compiled string node returning strlit9922 (depth = 9)
  gc_frame_newslot(strlit9922);
// call case 4: self request
  params[0] = strlit9922;
  partcv[0] = 1;
  Object call9923 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9921);
// compiled call node returning call9923 (depth = 8)
  partcv[0] = 0;
  Object call9924 = callmethod(call9923, "not",
    1, partcv, params);
  gc_frame_end(callframe9920);
// compiled call node returning call9924 (depth = 7)
// compiled member node returning call9924 (depth = 6)
  gc_frame_end(frame);
  return call9924;
}
Object meth_parser__apply9933(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe9934 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call9935 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9934);
// compiled call node returning call9935 (depth = 9)
  gc_frame_end(frame);
  return call9935;
}
Object meth_parser_doreturn9909(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doreturn (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doreturn");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_retTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retTok");
  Object *var_retval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "retval");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9911 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9912 == NULL) {
    strlit9912 = alloc_String("return");
    gc_root(strlit9912);
  }
// compiled string node returning strlit9912 (depth = 4)
  gc_frame_newslot(strlit9912);
// call case 4: self request
  params[0] = strlit9912;
  partcv[0] = 1;
  Object call9913 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9911);
// compiled call node returning call9913 (depth = 3)
  Object if9910 = done;
  if (istrue(call9913)) {
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_retTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9914 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9915 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9914);
// compiled call node returning call9915 (depth = 4)
// compiled member node returning call9915 (depth = 3)
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9917 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9918 = alloc_Block(NULL, NULL, "parser", 3064);
  gc_frame_newslot(block9918);
// method "_apply"
  block_savedest(block9918);
  Object closure9919 = createclosure(1, "_apply");
  setclosureframe(closure9919, stackframe);
  addtoclosure(closure9919, selfslot);
  struct UserObject *uo9919 = (struct UserObject*)block9918;
  uo9919->data[0] = (Object)closure9919;
  Method *meth_meth_parser__apply9919 = addmethod2pos(block9918, "_apply", &meth_parser__apply9919, 0);
  int argcv_meth_parser__apply9919[] = {0};
  meth_meth_parser__apply9919->type = alloc_MethodType(1, argcv_meth_parser__apply9919);
  meth_meth_parser__apply9919->definitionModule = modulename;
  meth_meth_parser__apply9919->definitionLine = 3062;
// compiled block node returning block9918 (depth = 5)
  gc_frame_newslot(block9918);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9927 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9926);
// compiled call node returning call9927 (depth = 6)
// compiled member node returning call9927 (depth = 5)
  params[0] = block9918;
  partcv[0] = 1;
  Object call9928 = callmethod(call9927, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe9917);
// compiled call node returning call9928 (depth = 4)
  Object if9916 = done;
  if (istrue(call9928)) {
// Begin line 3065
  setline(3065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9930 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe9931 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block9932 = alloc_Block(NULL, NULL, "parser", 3065);
  gc_frame_newslot(block9932);
// method "_apply"
  block_savedest(block9932);
  Object closure9933 = createclosure(2, "_apply");
  setclosureframe(closure9933, stackframe);
  addtoclosure(closure9933, var_blocksOK);
  addtoclosure(closure9933, selfslot);
  struct UserObject *uo9933 = (struct UserObject*)block9932;
  uo9933->data[0] = (Object)closure9933;
  Method *meth_meth_parser__apply9933 = addmethod2pos(block9932, "_apply", &meth_parser__apply9933, 0);
  int argcv_meth_parser__apply9933[] = {0};
  meth_meth_parser__apply9933->type = alloc_MethodType(1, argcv_meth_parser__apply9933);
  meth_meth_parser__apply9933->definitionModule = modulename;
  meth_meth_parser__apply9933->definitionLine = 3065;
// compiled block node returning block9932 (depth = 8)
  gc_frame_newslot(block9932);
// call case 4: self request
  params[0] = block9932;
  partcv[0] = 1;
  Object call9937 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9931);
// compiled call node returning call9937 (depth = 7)
  partcv[0] = 0;
  Object call9938 = callmethod(call9937, "not",
    1, partcv, params);
  gc_frame_end(callframe9930);
// compiled call node returning call9938 (depth = 6)
// compiled member node returning call9938 (depth = 5)
  Object if9929 = done;
  if (istrue(call9938)) {
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9939 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9940 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9941 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9940);
// compiled call node returning call9941 (depth = 9)
// compiled member node returning call9941 (depth = 8)
  partcv[0] = 0;
  Object call9942 = callmethod(call9941, "empty",
    1, partcv, params);
  gc_frame_end(callframe9939);
// compiled call node returning call9942 (depth = 7)
// compiled member node returning call9942 (depth = 6)
  *var_suggestions = call9942;
  if (call9942 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9943 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9945 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9944);
// compiled call node returning call9945 (depth = 9)
// compiled member node returning call9945 (depth = 8)
  partcv[0] = 0;
  Object call9946 = callmethod(call9945, "new",
    1, partcv, params);
  gc_frame_end(callframe9943);
// compiled call node returning call9946 (depth = 7)
// compiled member node returning call9946 (depth = 6)
  *var_suggestion = call9946;
  if (call9946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9947 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array9948 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit9949 == NULL) {
    strlit9949 = alloc_String("rbrace");
    gc_root(strlit9949);
  }
// compiled string node returning strlit9949 (depth = 8)
  params[0] = strlit9949;
  partcv[0] = 1;
  callmethod(array9948, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array9948 (depth = 7)
  gc_frame_newslot(array9948);
// call case 4: self request
  params[0] = array9948;
  partcv[0] = 1;
  Object call9950 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9947);
// compiled call node returning call9950 (depth = 6)
  *var_nextTok = call9950;
  if (call9950 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3069
  setline(3069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_9952 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_9952 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9954 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult9954 (depth = 6)
  Object if9951 = done;
  if (istrue(opresult9954)) {
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9955 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9956 == NULL) {
    strlit9956 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit9956);
  }
// compiled string node returning strlit9956 (depth = 7)
  gc_frame_newslot(strlit9956);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit9956;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9957 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9955);
// compiled call node returning call9957 (depth = 6)
// Begin line 3071
  setline(3071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9958 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9959 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9958);
// compiled call node returning call9959 (depth = 6)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9960 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call9962 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9961);
// compiled call node returning call9962 (depth = 10)
// compiled member node returning call9962 (depth = 9)
  partcv[0] = 0;
  Object call9963 = callmethod(call9962, "new",
    1, partcv, params);
  gc_frame_end(callframe9960);
// compiled call node returning call9963 (depth = 8)
// compiled member node returning call9963 (depth = 7)
  *var_suggestion = call9963;
  if (call9963 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3073
  setline(3073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9965 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool9966 = alloc_Boolean(1);
// compiled identifier node returning bool9966 (depth = 7)
  gc_frame_newslot(bool9966);
// starting to compile identifier node (depth = 7)
  Object bool9967 = alloc_Boolean(0);
// compiled identifier node returning bool9967 (depth = 7)
  gc_frame_newslot(bool9967);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool9966;
  params[2] = bool9967;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9968 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9965);
// compiled call node returning call9968 (depth = 6)
    gc_frame_newslot(call9968);
    if9951 = call9968;
  } else {
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9969 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call9971 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe9970);
// compiled call node returning call9971 (depth = 8)
// compiled member node returning call9971 (depth = 7)
  gc_frame_newslot(call9971);
// starting to compile identifier node (depth = 7)
  Object bool9972 = alloc_Boolean(1);
// compiled identifier node returning bool9972 (depth = 7)
  gc_frame_newslot(bool9972);
// starting to compile identifier node (depth = 7)
  Object bool9973 = alloc_Boolean(0);
// compiled identifier node returning bool9973 (depth = 7)
  gc_frame_newslot(bool9973);
// starting to compile string node (depth = 7)
  if (strlit9974 == NULL) {
    strlit9974 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit9974);
  }
// compiled string node returning strlit9974 (depth = 7)
  gc_frame_newslot(strlit9974);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call9971;
  params[2] = bool9972;
  params[3] = bool9973;
  params[4] = strlit9974;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9975 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe9969);
// compiled call node returning call9975 (depth = 6)
// Begin line 3076
  setline(3076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9976 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9977 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9976);
// compiled call node returning call9977 (depth = 6)
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9978 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call9980 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9979);
// compiled call node returning call9980 (depth = 10)
// compiled member node returning call9980 (depth = 9)
  partcv[0] = 0;
  Object call9981 = callmethod(call9980, "new",
    1, partcv, params);
  gc_frame_end(callframe9978);
// compiled call node returning call9981 (depth = 8)
// compiled member node returning call9981 (depth = 7)
  *var_suggestion = call9981;
  if (call9981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3078
  setline(3078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9983 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9984 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call9985 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe9984);
// compiled call node returning call9985 (depth = 8)
// compiled member node returning call9985 (depth = 7)
  gc_frame_newslot(call9985);
// starting to compile identifier node (depth = 7)
  Object bool9986 = alloc_Boolean(1);
// compiled identifier node returning bool9986 (depth = 7)
  gc_frame_newslot(bool9986);
// starting to compile identifier node (depth = 7)
  Object bool9987 = alloc_Boolean(0);
// compiled identifier node returning bool9987 (depth = 7)
  gc_frame_newslot(bool9987);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call9985;
  params[2] = bool9986;
  params[3] = bool9987;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9988 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9983);
// compiled call node returning call9988 (depth = 6)
    gc_frame_newslot(call9988);
    if9951 = call9988;
  }
// compiled if node returning if9951 (depth = 5)
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9989 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9990 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9989);
// compiled call node returning call9990 (depth = 5)
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9991 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9992 == NULL) {
    strlit9992 = alloc_String("a return statement must have either an expression or a new-line after 'return'.");
    gc_root(strlit9992);
  }
// compiled string node returning strlit9992 (depth = 6)
  gc_frame_newslot(strlit9992);
// Begin line 3082
  setline(3082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9994 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9993);
// compiled call node returning call9994 (depth = 7)
// compiled member node returning call9994 (depth = 6)
  gc_frame_newslot(call9994);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9996 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9995);
// compiled call node returning call9996 (depth = 7)
// compiled member node returning call9996 (depth = 6)
  gc_frame_newslot(call9996);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9998 = alloc_Float64(1);
// compiled num node returning num9998 (depth = 7)
  int op_slot_right_9997 = gc_frame_newslot(num9998);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10001 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10002 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe10001);
// compiled call node returning call10002 (depth = 9)
// compiled member node returning call10002 (depth = 8)
  int op_slot_right_10000 = gc_frame_newslot(call10002);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10005 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10004);
// compiled call node returning call10005 (depth = 9)
// compiled member node returning call10005 (depth = 8)
  int op_slot_left_10000 = gc_frame_newslot(call10005);
  params[0] = call10002;
  partcv[0] = 1;
  Object sum10006 = callmethod(call10005, "+", 1, partcv, params);
// compiled op node returning sum10006 (depth = 7)
  int op_slot_left_9997 = gc_frame_newslot(sum10006);
  params[0] = num9998;
  partcv[0] = 1;
  Object diff10007 = callmethod(sum10006, "-", 1, partcv, params);
// compiled op node returning diff10007 (depth = 6)
  gc_frame_newslot(diff10007);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9992;
  params[1] = call9994;
  params[2] = call9996;
  params[3] = diff10007;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10008 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9991);
// compiled call node returning call10008 (depth = 5)
    gc_frame_newslot(call10008);
    if9929 = call10008;
  } else {
  }
// compiled if node returning if9929 (depth = 4)
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10010 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10009);
// compiled call node returning call10010 (depth = 6)
// compiled member node returning call10010 (depth = 5)
  *var_retval = call10010;
  if (call10010 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9916 = done;
  } else {
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10012 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10013 == NULL) {
    strlit10013 = alloc_String("done");
    gc_root(strlit10013);
  }
// compiled string node returning strlit10013 (depth = 6)
  gc_frame_newslot(strlit10013);
// starting to compile identifier node (depth = 6)
  Object bool10014 = alloc_Boolean(0);
// compiled identifier node returning bool10014 (depth = 6)
  gc_frame_newslot(bool10014);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10015 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call10016 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10015);
// compiled call node returning call10016 (depth = 7)
// compiled member node returning call10016 (depth = 6)
  params[0] = strlit10013;
  params[1] = bool10014;
  partcv[0] = 2;
  Object call10017 = callmethod(call10016, "new",
    1, partcv, params);
  gc_frame_end(callframe10012);
// compiled call node returning call10017 (depth = 5)
  *var_retval = call10017;
  if (call10017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9916 = done;
  }
// compiled if node returning if9916 (depth = 3)
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10019 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_retTok (depth = 6)
  partcv[0] = 0;
  Object call10021 = callmethod(*var_retTok, "line",
    1, partcv, params);
  gc_frame_end(callframe10020);
// compiled call node returning call10021 (depth = 5)
// compiled member node returning call10021 (depth = 4)
  gc_frame_newslot(call10021);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_retTok (depth = 6)
  partcv[0] = 0;
  Object call10023 = callmethod(*var_retTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10022);
// compiled call node returning call10023 (depth = 5)
// compiled member node returning call10023 (depth = 4)
  gc_frame_newslot(call10023);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call10021;
  params[1] = call10023;
  partcv[0] = 2;
  Object call10024 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10019);
// compiled call node returning call10024 (depth = 3)
// Begin line 3089
  setline(3089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10025 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10027 = callmethod(*var_ast, "returnNode",
    1, partcv, params);
  gc_frame_end(callframe10026);
// compiled call node returning call10027 (depth = 6)
// compiled member node returning call10027 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call10028 = callmethod(call10027, "new",
    1, partcv, params);
  gc_frame_end(callframe10025);
// compiled call node returning call10028 (depth = 4)
  *var_o = call10028;
  if (call10028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10029 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10030 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10029);
// compiled call node returning call10030 (depth = 3)
    gc_frame_newslot(call10030);
    if9910 = call10030;
  } else {
  }
// compiled if node returning if9910 (depth = 2)
  gc_frame_end(frame);
  return if9910;
}
Object meth_parser_domethodtype10031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for domethodtype (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for domethodtype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methodTypeTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "methodTypeTok");
  Object *var_m = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "m");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_dtype = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "dtype");
  Object *var_varargs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "varargs");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_suggestion = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestion");
  Object *var_newLine = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "newLine");
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_methodTypeTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10032 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10033 = alloc_Boolean(1);
// compiled identifier node returning bool10033 (depth = 4)
  gc_frame_newslot(bool10033);
// call case 4: self request
  params[0] = bool10033;
  partcv[0] = 1;
  Object call10034 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10032);
// compiled call node returning call10034 (depth = 3)
  *var_m = call10034;
  if (call10034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10036 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe10035);
// compiled call node returning call10036 (depth = 4)
// compiled member node returning call10036 (depth = 3)
  *var_meth = call10036;
  if (call10036 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10037 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10038 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe10037);
// compiled call node returning call10038 (depth = 4)
// compiled member node returning call10038 (depth = 3)
  *var_signature = call10038;
  if (call10038 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10040 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe10039);
// compiled call node returning call10040 (depth = 4)
// compiled member node returning call10040 (depth = 3)
  *var_dtype = call10040;
  if (call10040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10041 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10042 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe10041);
// compiled call node returning call10042 (depth = 4)
// compiled member node returning call10042 (depth = 3)
  *var_varargs = call10042;
  if (call10042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10045 = alloc_Boolean(0);
// compiled identifier node returning bool10045 (depth = 4)
  int op_slot_right_10044 = gc_frame_newslot(bool10045);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  int op_slot_left_10044 = gc_frame_newslot(*var_dtype);
  params[0] = bool10045;
  partcv[0] = 1;
  Object opresult10047 = callmethod(*var_dtype, "==", 1, partcv, params);
// compiled op node returning opresult10047 (depth = 3)
  Object if10043 = done;
  if (istrue(opresult10047)) {
// Begin line 3103
  setline(3103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10048 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10049 == NULL) {
    strlit10049 = alloc_String("Done");
    gc_root(strlit10049);
  }
// compiled string node returning strlit10049 (depth = 5)
  gc_frame_newslot(strlit10049);
// starting to compile identifier node (depth = 5)
  Object bool10050 = alloc_Boolean(0);
// compiled identifier node returning bool10050 (depth = 5)
  gc_frame_newslot(bool10050);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10052 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10051);
// compiled call node returning call10052 (depth = 6)
// compiled member node returning call10052 (depth = 5)
  params[0] = strlit10049;
  params[1] = bool10050;
  partcv[0] = 2;
  Object call10053 = callmethod(call10052, "new",
    1, partcv, params);
  gc_frame_end(callframe10048);
// compiled call node returning call10053 (depth = 4)
  *var_dtype = call10053;
  if (call10053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10043 = done;
  } else {
  }
// compiled if node returning if10043 (depth = 2)
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10055 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeTok (depth = 5)
  partcv[0] = 0;
  Object call10057 = callmethod(*var_methodTypeTok, "line",
    1, partcv, params);
  gc_frame_end(callframe10056);
// compiled call node returning call10057 (depth = 4)
// compiled member node returning call10057 (depth = 3)
  gc_frame_newslot(call10057);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10058 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeTok (depth = 5)
  partcv[0] = 0;
  Object call10059 = callmethod(*var_methodTypeTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10058);
// compiled call node returning call10059 (depth = 4)
// compiled member node returning call10059 (depth = 3)
  gc_frame_newslot(call10059);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call10057;
  params[1] = call10059;
  partcv[0] = 2;
  Object call10060 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10055);
// compiled call node returning call10060 (depth = 2)
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10061 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10062 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call10063 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe10062);
// compiled call node returning call10063 (depth = 5)
// compiled member node returning call10063 (depth = 4)
  gc_frame_newslot(call10063);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature (depth = 4)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call10065 = callmethod(*var_ast, "methodTypeNode",
    1, partcv, params);
  gc_frame_end(callframe10064);
// compiled call node returning call10065 (depth = 5)
// compiled member node returning call10065 (depth = 4)
  params[0] = call10063;
  params[1] = *var_signature;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call10066 = callmethod(call10065, "new",
    1, partcv, params);
  gc_frame_end(callframe10061);
// compiled call node returning call10066 (depth = 3)
  *var_o = call10066;
  if (call10066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10067 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10069 = callmethod(*var_m, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe10068);
// compiled call node returning call10069 (depth = 4)
// compiled member node returning call10069 (depth = 3)
  gc_frame_newslot(call10069);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call10069;
  partcv[0] = 1;
  Object call10070 = callmethod(*var_o, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe10067);
// compiled call node returning call10070 (depth = 2)
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10071 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10072 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10071);
// compiled call node returning call10072 (depth = 2)
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10073 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10074 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10073);
// compiled call node returning call10074 (depth = 3)
// compiled member node returning call10074 (depth = 2)
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10076 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10077 == NULL) {
    strlit10077 = alloc_String("semicolon");
    gc_root(strlit10077);
  }
// compiled string node returning strlit10077 (depth = 4)
  gc_frame_newslot(strlit10077);
// call case 4: self request
  params[0] = strlit10077;
  partcv[0] = 1;
  Object call10078 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10076);
// compiled call node returning call10078 (depth = 3)
  Object if10075 = done;
  if (istrue(call10078)) {
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10080 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10079);
// compiled call node returning call10080 (depth = 4)
// compiled member node returning call10080 (depth = 3)
    gc_frame_newslot(call10080);
    if10075 = call10080;
  } else {
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10082 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe10083 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10084 == NULL) {
    strlit10084 = alloc_String("rbrace");
    gc_root(strlit10084);
  }
// compiled string node returning strlit10084 (depth = 6)
  gc_frame_newslot(strlit10084);
// call case 4: self request
  params[0] = strlit10084;
  partcv[0] = 1;
  Object call10085 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10083);
// compiled call node returning call10085 (depth = 5)
  partcv[0] = 0;
  Object call10086 = callmethod(call10085, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10082);
// compiled call node returning call10086 (depth = 4)
  Object if10081 = done;
  if (istrue(call10086)) {
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10089 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10090 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10089);
// compiled call node returning call10090 (depth = 7)
// compiled member node returning call10090 (depth = 6)
  int op_slot_right_10088 = gc_frame_newslot(call10090);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10092 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call10093 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10092);
// compiled call node returning call10093 (depth = 7)
// compiled member node returning call10093 (depth = 6)
  int op_slot_left_10088 = gc_frame_newslot(call10093);
  params[0] = call10090;
  partcv[0] = 1;
  Object opresult10094 = callmethod(call10093, "==", 1, partcv, params);
// compiled op node returning opresult10094 (depth = 5)
  Object if10087 = done;
  if (istrue(opresult10094)) {
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10095 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10097 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10096);
// compiled call node returning call10097 (depth = 9)
// compiled member node returning call10097 (depth = 8)
  partcv[0] = 0;
  Object call10098 = callmethod(call10097, "new",
    1, partcv, params);
  gc_frame_end(callframe10095);
// compiled call node returning call10098 (depth = 7)
// compiled member node returning call10098 (depth = 6)
  *var_suggestion = call10098;
  if (call10098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10100 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10101 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10100);
// compiled call node returning call10101 (depth = 8)
// compiled member node returning call10101 (depth = 7)
  int op_slot_right_10099 = gc_frame_newslot(call10101);
// starting to compile call node (depth = 7)
  int callframe10103 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num10104 = alloc_Float64(1);
// compiled num node returning num10104 (depth = 8)
  gc_frame_newslot(num10104);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10106 = alloc_Float64(1);
// compiled num node returning num10106 (depth = 9)
  int op_slot_right_10105 = gc_frame_newslot(num10106);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call10109 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10108);
// compiled call node returning call10109 (depth = 10)
// compiled member node returning call10109 (depth = 9)
  int op_slot_left_10105 = gc_frame_newslot(call10109);
  params[0] = num10106;
  partcv[0] = 1;
  Object diff10110 = callmethod(call10109, "-", 1, partcv, params);
// compiled op node returning diff10110 (depth = 8)
  gc_frame_newslot(diff10110);
// call case 6: other member request
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call10112 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10111);
// compiled call node returning call10112 (depth = 10)
// compiled member node returning call10112 (depth = 9)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10114 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10113);
// compiled call node returning call10114 (depth = 10)
// compiled member node returning call10114 (depth = 9)
  params[0] = call10114;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10115 = callmethod(call10112, "[]", 1, partcv, params);
// compiled index node returning idxres10115 (depth = 8)
  params[0] = num10104;
  params[1] = diff10110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10116 = callmethod(idxres10115, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe10103);
// compiled call node returning call10116 (depth = 7)
  int op_slot_left_10099 = gc_frame_newslot(call10116);
  params[0] = call10101;
  partcv[0] = 1;
  Object opresult10117 = callmethod(call10116, "++", 1, partcv, params);
// compiled op node returning opresult10117 (depth = 6)
  *var_newLine = opresult10117;
  if (opresult10117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10118 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10120 = alloc_Float64(0.1);
// compiled num node returning num10120 (depth = 7)
  int op_slot_right_10119 = gc_frame_newslot(num10120);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10123 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10122);
// compiled call node returning call10123 (depth = 8)
// compiled member node returning call10123 (depth = 7)
  int op_slot_left_10119 = gc_frame_newslot(call10123);
  params[0] = num10120;
  partcv[0] = 1;
  Object sum10124 = callmethod(call10123, "+", 1, partcv, params);
// compiled op node returning sum10124 (depth = 6)
  gc_frame_newslot(sum10124);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum10124;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call10125 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10118);
// compiled call node returning call10125 (depth = 5)
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10126 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool10127 = alloc_Boolean(1);
// compiled identifier node returning bool10127 (depth = 6)
  gc_frame_newslot(bool10127);
// starting to compile identifier node (depth = 6)
  Object bool10128 = alloc_Boolean(1);
// compiled identifier node returning bool10128 (depth = 6)
  gc_frame_newslot(bool10128);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool10127;
  params[2] = bool10128;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10129 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10126);
// compiled call node returning call10129 (depth = 5)
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10130 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10131 == NULL) {
    strlit10131 = alloc_String("methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit10131);
  }
// compiled string node returning strlit10131 (depth = 6)
  gc_frame_newslot(strlit10131);
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10132 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10133 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10132);
// compiled call node returning call10133 (depth = 7)
// compiled member node returning call10133 (depth = 6)
  gc_frame_newslot(call10133);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10135 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10134);
// compiled call node returning call10135 (depth = 7)
// compiled member node returning call10135 (depth = 6)
  gc_frame_newslot(call10135);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit10131;
  params[1] = call10133;
  params[2] = call10135;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10136 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10130);
// compiled call node returning call10136 (depth = 5)
    gc_frame_newslot(call10136);
    if10087 = call10136;
  } else {
  }
// compiled if node returning if10087 (depth = 4)
    gc_frame_newslot(if10087);
    if10081 = if10087;
  } else {
  }
// compiled if node returning if10081 (depth = 3)
    gc_frame_newslot(if10081);
    if10075 = if10081;
  }
// compiled if node returning if10075 (depth = 2)
  gc_frame_end(frame);
  return if10075;
}
Object meth_parser__apply10179(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10180 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10181 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10182 == NULL) {
    strlit10182 = alloc_String("rbrace");
    gc_root(strlit10182);
  }
// compiled string node returning strlit10182 (depth = 8)
  gc_frame_newslot(strlit10182);
// call case 4: self request
  params[0] = strlit10182;
  partcv[0] = 1;
  Object call10183 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10181);
// compiled call node returning call10183 (depth = 7)
  partcv[0] = 0;
  Object call10184 = callmethod(call10183, "not",
    1, partcv, params);
  gc_frame_end(callframe10180);
// compiled call node returning call10184 (depth = 6)
// compiled member node returning call10184 (depth = 5)
  gc_frame_end(frame);
  return call10184;
}
Object meth_parser__apply10187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_types = getfromclosure(closure, 1);
  Object *var_meths = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10189 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit10190 == NULL) {
    strlit10190 = alloc_String("type");
    gc_root(strlit10190);
  }
// compiled string node returning strlit10190 (depth = 7)
  gc_frame_newslot(strlit10190);
// call case 4: self request
  params[0] = strlit10190;
  partcv[0] = 1;
  Object call10191 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10189);
// compiled call node returning call10191 (depth = 6)
  Object if10188 = done;
  if (istrue(call10191)) {
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10193 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10192);
// compiled call node returning call10193 (depth = 7)
// compiled member node returning call10193 (depth = 6)
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10194 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10195 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10196 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10195);
// compiled call node returning call10196 (depth = 8)
// compiled member node returning call10196 (depth = 7)
  gc_frame_newslot(call10196);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call10196;
  partcv[0] = 1;
  Object call10197 = callmethod(*var_types, "push",
    1, partcv, params);
  gc_frame_end(callframe10194);
// compiled call node returning call10197 (depth = 6)
    gc_frame_newslot(call10197);
    if10188 = call10197;
  } else {
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10198 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10199 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10198);
// compiled call node returning call10199 (depth = 7)
// compiled member node returning call10199 (depth = 6)
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10200 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10201 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10202 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10201);
// compiled call node returning call10202 (depth = 8)
// compiled member node returning call10202 (depth = 7)
  gc_frame_newslot(call10202);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call10202;
  partcv[0] = 1;
  Object call10203 = callmethod(*var_meths, "push",
    1, partcv, params);
  gc_frame_end(callframe10200);
// compiled call node returning call10203 (depth = 6)
    gc_frame_newslot(call10203);
    if10188 = call10203;
  }
// compiled if node returning if10188 (depth = 5)
  gc_frame_end(frame);
  return if10188;
}
Object meth_parser_dotypeLiteral10137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dotypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeLiteralTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeLiteralTok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meths = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meths");
  Object *var_types = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "types");
  Object *var_mc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mc");
  Object *var_t = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "t");
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_typeLiteralTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10139 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10140 == NULL) {
    strlit10140 = alloc_String("type");
    gc_root(strlit10140);
  }
// compiled string node returning strlit10140 (depth = 4)
  gc_frame_newslot(strlit10140);
// call case 4: self request
  params[0] = strlit10140;
  partcv[0] = 1;
  Object call10141 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10139);
// compiled call node returning call10141 (depth = 3)
  Object if10138 = done;
  if (istrue(call10141)) {
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10142 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10143 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10142);
// compiled call node returning call10143 (depth = 4)
// compiled member node returning call10143 (depth = 3)
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10145 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe10146 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10147 == NULL) {
    strlit10147 = alloc_String("lbrace");
    gc_root(strlit10147);
  }
// compiled string node returning strlit10147 (depth = 6)
  gc_frame_newslot(strlit10147);
// call case 4: self request
  params[0] = strlit10147;
  partcv[0] = 1;
  Object call10148 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10146);
// compiled call node returning call10148 (depth = 5)
  partcv[0] = 0;
  Object call10149 = callmethod(call10148, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10145);
// compiled call node returning call10149 (depth = 4)
  Object if10144 = done;
  if (istrue(call10149)) {
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10150 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10152 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10151);
// compiled call node returning call10152 (depth = 8)
// compiled member node returning call10152 (depth = 7)
  partcv[0] = 0;
  Object call10153 = callmethod(call10152, "new",
    1, partcv, params);
  gc_frame_end(callframe10150);
// compiled call node returning call10153 (depth = 6)
// compiled member node returning call10153 (depth = 5)
  *var_suggestion = call10153;
  if (call10153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10154 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit10155 == NULL) {
    strlit10155 = alloc_String("{");
    gc_root(strlit10155);
  }
// compiled string node returning strlit10155 (depth = 5)
  gc_frame_newslot(strlit10155);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit10155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10156 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10154);
// compiled call node returning call10156 (depth = 4)
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10157 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10158 == NULL) {
    strlit10158 = alloc_String("type literals must open with a brace.");
    gc_root(strlit10158);
  }
// compiled string node returning strlit10158 (depth = 5)
  gc_frame_newslot(strlit10158);
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10160 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10159);
// compiled call node returning call10160 (depth = 6)
// compiled member node returning call10160 (depth = 5)
  gc_frame_newslot(call10160);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10162 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10161);
// compiled call node returning call10162 (depth = 6)
// compiled member node returning call10162 (depth = 5)
  gc_frame_newslot(call10162);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10158;
  params[1] = call10160;
  params[2] = call10162;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10163 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10157);
// compiled call node returning call10163 (depth = 4)
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 3137
  setline(3137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10144 = undefined;
  } else {
  }
// compiled if node returning if10144 (depth = 3)
    gc_frame_newslot(if10144);
    if10138 = if10144;
  } else {
  }
// compiled if node returning if10138 (depth = 2)
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10165 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10166 == NULL) {
    strlit10166 = alloc_String("lbrace");
    gc_root(strlit10166);
  }
// compiled string node returning strlit10166 (depth = 4)
  gc_frame_newslot(strlit10166);
// call case 4: self request
  params[0] = strlit10166;
  partcv[0] = 1;
  Object call10167 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10165);
// compiled call node returning call10167 (depth = 3)
  Object if10164 = done;
  if (istrue(call10167)) {
// Begin line 3140
  setline(3140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array10168 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10168 (depth = 4)
  *var_meths = array10168;
  if (array10168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3141
  setline(3141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array10169 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10169 (depth = 4)
  *var_types = array10169;
  if (array10169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3143
  setline(3143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10171 = alloc_Float64(1);
// compiled num node returning num10171 (depth = 5)
  int op_slot_right_10170 = gc_frame_newslot(num10171);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_10170 = gc_frame_newslot(*var_auto_count);
  params[0] = num10171;
  partcv[0] = 1;
  Object sum10173 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum10173 (depth = 4)
  *var_auto_count = sum10173;
  if (sum10173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10176 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10175);
// compiled call node returning call10176 (depth = 4)
// compiled member node returning call10176 (depth = 3)
// Begin line 3145
  setline(3145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10177 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10178 = alloc_Block(NULL, NULL, "parser", 3145);
  gc_frame_newslot(block10178);
// method "_apply"
  block_savedest(block10178);
  Object closure10179 = createclosure(1, "_apply");
  setclosureframe(closure10179, stackframe);
  addtoclosure(closure10179, selfslot);
  struct UserObject *uo10179 = (struct UserObject*)block10178;
  uo10179->data[0] = (Object)closure10179;
  Method *meth_meth_parser__apply10179 = addmethod2pos(block10178, "_apply", &meth_parser__apply10179, 0);
  int argcv_meth_parser__apply10179[] = {0};
  meth_meth_parser__apply10179->type = alloc_MethodType(1, argcv_meth_parser__apply10179);
  meth_meth_parser__apply10179->definitionModule = modulename;
  meth_meth_parser__apply10179->definitionLine = 3144;
// compiled block node returning block10178 (depth = 4)
  gc_frame_newslot(block10178);
// starting to compile block node (depth = 4)
  Object block10186 = alloc_Block(NULL, NULL, "parser", 3145);
  gc_frame_newslot(block10186);
// method "_apply"
  block_savedest(block10186);
  Object closure10187 = createclosure(4, "_apply");
  setclosureframe(closure10187, stackframe);
  addtoclosure(closure10187, var_values);
  addtoclosure(closure10187, var_types);
  addtoclosure(closure10187, var_meths);
  addtoclosure(closure10187, selfslot);
  struct UserObject *uo10187 = (struct UserObject*)block10186;
  uo10187->data[0] = (Object)closure10187;
  Method *meth_meth_parser__apply10187 = addmethod2pos(block10186, "_apply", &meth_parser__apply10187, 0);
  int argcv_meth_parser__apply10187[] = {0};
  meth_meth_parser__apply10187->type = alloc_MethodType(1, argcv_meth_parser__apply10187);
  meth_meth_parser__apply10187->definitionModule = modulename;
  meth_meth_parser__apply10187->definitionLine = 3145;
// compiled block node returning block10186 (depth = 4)
  gc_frame_newslot(block10186);
// call case 5: prelude request
  params[0] = block10178;
  params[1] = block10186;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10205 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10177);
// compiled call node returning call10205 (depth = 3)
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10206 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10207 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10206);
// compiled call node returning call10207 (depth = 4)
// compiled member node returning call10207 (depth = 3)
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10208 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10209 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralTok (depth = 6)
  partcv[0] = 0;
  Object call10210 = callmethod(*var_typeLiteralTok, "line",
    1, partcv, params);
  gc_frame_end(callframe10209);
// compiled call node returning call10210 (depth = 5)
// compiled member node returning call10210 (depth = 4)
  gc_frame_newslot(call10210);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralTok (depth = 6)
  partcv[0] = 0;
  Object call10212 = callmethod(*var_typeLiteralTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10211);
// compiled call node returning call10212 (depth = 5)
// compiled member node returning call10212 (depth = 4)
  gc_frame_newslot(call10212);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call10210;
  params[1] = call10212;
  partcv[0] = 2;
  Object call10213 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10208);
// compiled call node returning call10213 (depth = 3)
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10214 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10216 = callmethod(*var_ast, "typeLiteralNode",
    1, partcv, params);
  gc_frame_end(callframe10215);
// compiled call node returning call10216 (depth = 6)
// compiled member node returning call10216 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call10217 = callmethod(call10216, "new",
    1, partcv, params);
  gc_frame_end(callframe10214);
// compiled call node returning call10217 (depth = 4)
  *var_t = call10217;
  if (call10217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3157
  setline(3157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10218 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call10219 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10218);
// compiled call node returning call10219 (depth = 3)
    gc_frame_newslot(call10219);
    if10164 = call10219;
  } else {
  }
// compiled if node returning if10164 (depth = 2)
  gc_frame_end(frame);
  return if10164;
}
Object meth_parser__apply10309(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10311 == NULL) {
    strlit10311 = alloc_String("lbrace");
    gc_root(strlit10311);
  }
// compiled string node returning strlit10311 (depth = 8)
  int op_slot_right_10310 = gc_frame_newslot(strlit10311);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call10314 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe10313);
// compiled call node returning call10314 (depth = 9)
// compiled member node returning call10314 (depth = 8)
  int op_slot_left_10310 = gc_frame_newslot(call10314);
  params[0] = strlit10311;
  partcv[0] = 1;
  Object opresult10315 = callmethod(call10314, "==", 1, partcv, params);
// compiled op node returning opresult10315 (depth = 7)
  gc_frame_end(frame);
  return opresult10315;
}
Object meth_parser__apply10321(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_10322 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_10322 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10324 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10324 (depth = 7)
  gc_frame_end(frame);
  return opresult10324;
}
Object meth_parser_typedec10220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_noBlocks = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typedec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typedec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nt");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10222 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10223 == NULL) {
    strlit10223 = alloc_String("type");
    gc_root(strlit10223);
  }
// compiled string node returning strlit10223 (depth = 4)
  gc_frame_newslot(strlit10223);
// call case 4: self request
  params[0] = strlit10223;
  partcv[0] = 1;
  Object call10224 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10222);
// compiled call node returning call10224 (depth = 3)
  Object if10221 = done;
  if (istrue(call10224)) {
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10226 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10225);
// compiled call node returning call10226 (depth = 5)
// compiled member node returning call10226 (depth = 4)
  *var_line = call10226;
  if (call10226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10228 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10227);
// compiled call node returning call10228 (depth = 5)
// compiled member node returning call10228 (depth = 4)
  *var_pos = call10228;
  if (call10228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3166
  setline(3166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10230 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10229);
// compiled call node returning call10230 (depth = 4)
// compiled member node returning call10230 (depth = 3)
// Begin line 3167
  setline(3167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10233 == NULL) {
    strlit10233 = alloc_String("identifier");
    gc_root(strlit10233);
  }
// compiled string node returning strlit10233 (depth = 5)
  int op_slot_right_10232 = gc_frame_newslot(strlit10233);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10236 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10235);
// compiled call node returning call10236 (depth = 6)
// compiled member node returning call10236 (depth = 5)
  int op_slot_left_10232 = gc_frame_newslot(call10236);
  params[0] = strlit10233;
  partcv[0] = 1;
  Object opresult10237 = callmethod(call10236, "!=", 1, partcv, params);
// compiled op node returning opresult10237 (depth = 4)
  Object if10231 = done;
  if (istrue(opresult10237)) {
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10238 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10240 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10239);
// compiled call node returning call10240 (depth = 8)
// compiled member node returning call10240 (depth = 7)
  partcv[0] = 0;
  Object call10241 = callmethod(call10240, "new",
    1, partcv, params);
  gc_frame_end(callframe10238);
// compiled call node returning call10241 (depth = 6)
// compiled member node returning call10241 (depth = 5)
  *var_suggestion = call10241;
  if (call10241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10242 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10243 == NULL) {
    strlit10243 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit10243);
  }
// compiled string node returning strlit10243 (depth = 5)
  gc_frame_newslot(strlit10243);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit10243;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10244 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10242);
// compiled call node returning call10244 (depth = 4)
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10245 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10246 == NULL) {
    strlit10246 = alloc_String("a type declaration must have a name after the 'type'.");
    gc_root(strlit10246);
  }
// compiled string node returning strlit10246 (depth = 5)
  gc_frame_newslot(strlit10246);
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10247 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10248 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10247);
// compiled call node returning call10248 (depth = 6)
// compiled member node returning call10248 (depth = 5)
  gc_frame_newslot(call10248);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10250 = alloc_Float64(1);
// compiled num node returning num10250 (depth = 6)
  int op_slot_right_10249 = gc_frame_newslot(num10250);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10254 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10253);
// compiled call node returning call10254 (depth = 8)
// compiled member node returning call10254 (depth = 7)
  int op_slot_right_10252 = gc_frame_newslot(call10254);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10256 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10257 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10256);
// compiled call node returning call10257 (depth = 8)
// compiled member node returning call10257 (depth = 7)
  int op_slot_left_10252 = gc_frame_newslot(call10257);
  params[0] = call10254;
  partcv[0] = 1;
  Object sum10258 = callmethod(call10257, "+", 1, partcv, params);
// compiled op node returning sum10258 (depth = 6)
  int op_slot_left_10249 = gc_frame_newslot(sum10258);
  params[0] = num10250;
  partcv[0] = 1;
  Object sum10259 = callmethod(sum10258, "+", 1, partcv, params);
// compiled op node returning sum10259 (depth = 5)
  gc_frame_newslot(sum10259);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10246;
  params[1] = call10248;
  params[2] = sum10259;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10260 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10245);
// compiled call node returning call10260 (depth = 4)
    gc_frame_newslot(call10260);
    if10231 = call10260;
  } else {
  }
// compiled if node returning if10231 (depth = 3)
// Begin line 3173
  setline(3173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10262 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10261);
// compiled call node returning call10262 (depth = 4)
// compiled member node returning call10262 (depth = 3)
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10263 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call10264 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10263);
// compiled call node returning call10264 (depth = 3)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10265 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10266 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10267 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10266);
// compiled call node returning call10267 (depth = 6)
// compiled member node returning call10267 (depth = 5)
  gc_frame_newslot(call10267);
// starting to compile identifier node (depth = 5)
  Object bool10268 = alloc_Boolean(0);
// compiled identifier node returning bool10268 (depth = 5)
  gc_frame_newslot(bool10268);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10269 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10270 = callmethod(*var_ast, "typeDecNode",
    1, partcv, params);
  gc_frame_end(callframe10269);
// compiled call node returning call10270 (depth = 6)
// compiled member node returning call10270 (depth = 5)
  params[0] = call10267;
  params[1] = bool10268;
  partcv[0] = 2;
  Object call10271 = callmethod(call10270, "new",
    1, partcv, params);
  gc_frame_end(callframe10265);
// compiled call node returning call10271 (depth = 4)
  *var_nt = call10271;
  if (call10271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3176
  setline(3176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10273 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10274 == NULL) {
    strlit10274 = alloc_String("lgeneric");
    gc_root(strlit10274);
  }
// compiled string node returning strlit10274 (depth = 5)
  gc_frame_newslot(strlit10274);
// call case 4: self request
  params[0] = strlit10274;
  partcv[0] = 1;
  Object call10275 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10273);
// compiled call node returning call10275 (depth = 4)
  Object if10272 = done;
  if (istrue(call10275)) {
// starting to compile call node (depth = 4)
  int callframe10276 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10278 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10277);
// compiled call node returning call10278 (depth = 6)
// compiled member node returning call10278 (depth = 5)
  gc_frame_newslot(call10278);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = call10278;
  partcv[0] = 1;
  Object call10279 = callmethod(*var_nt, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe10276);
// compiled call node returning call10279 (depth = 4)
    gc_frame_newslot(call10279);
    if10272 = call10279;
  } else {
  }
// compiled if node returning if10272 (depth = 3)
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10280 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10281 = alloc_Boolean(1);
// compiled identifier node returning bool10281 (depth = 4)
  gc_frame_newslot(bool10281);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nt (depth = 6)
  partcv[0] = 0;
  Object call10283 = callmethod(*var_nt, "name",
    1, partcv, params);
  gc_frame_end(callframe10282);
// compiled call node returning call10283 (depth = 5)
// compiled member node returning call10283 (depth = 4)
  params[0] = bool10281;
  partcv[0] = 1;
  Object call10284 = callmethod(call10283, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10280);
// compiled call node returning call10284 (depth = 3)
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10285 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10286 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10285);
// compiled call node returning call10286 (depth = 5)
// compiled member node returning call10286 (depth = 4)
  *var_anns = call10286;
  if (call10286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10290 == NULL) {
    strlit10290 = alloc_String("=");
    gc_root(strlit10290);
  }
// compiled string node returning strlit10290 (depth = 6)
  int op_slot_right_10289 = gc_frame_newslot(strlit10290);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10292 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10293 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10292);
// compiled call node returning call10293 (depth = 7)
// compiled member node returning call10293 (depth = 6)
  int op_slot_left_10289 = gc_frame_newslot(call10293);
  params[0] = strlit10290;
  partcv[0] = 1;
  Object opresult10294 = callmethod(call10293, "!=", 1, partcv, params);
// compiled op node returning opresult10294 (depth = 5)
  int op_slot_right_10288 = gc_frame_newslot(opresult10294);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10297 == NULL) {
    strlit10297 = alloc_String("op");
    gc_root(strlit10297);
  }
// compiled string node returning strlit10297 (depth = 6)
  int op_slot_right_10296 = gc_frame_newslot(strlit10297);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10300 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10299);
// compiled call node returning call10300 (depth = 7)
// compiled member node returning call10300 (depth = 6)
  int op_slot_left_10296 = gc_frame_newslot(call10300);
  params[0] = strlit10297;
  partcv[0] = 1;
  Object opresult10301 = callmethod(call10300, "!=", 1, partcv, params);
// compiled op node returning opresult10301 (depth = 5)
  int op_slot_left_10288 = gc_frame_newslot(opresult10301);
  params[0] = opresult10294;
  partcv[0] = 1;
  Object opresult10302 = callmethod(opresult10301, "||", 1, partcv, params);
// compiled op node returning opresult10302 (depth = 4)
  Object if10287 = done;
  if (istrue(opresult10302)) {
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10303 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10304 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10305 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10304);
// compiled call node returning call10305 (depth = 8)
// compiled member node returning call10305 (depth = 7)
  partcv[0] = 0;
  Object call10306 = callmethod(call10305, "new",
    1, partcv, params);
  gc_frame_end(callframe10303);
// compiled call node returning call10306 (depth = 6)
// compiled member node returning call10306 (depth = 5)
  *var_suggestion = call10306;
  if (call10306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10307 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10308 = alloc_Block(NULL, NULL, "parser", 3181);
  gc_frame_newslot(block10308);
// method "_apply"
  block_savedest(block10308);
  Object closure10309 = createclosure(1, "_apply");
  setclosureframe(closure10309, stackframe);
  addtoclosure(closure10309, selfslot);
  struct UserObject *uo10309 = (struct UserObject*)block10308;
  uo10309->data[0] = (Object)closure10309;
  Method *meth_meth_parser__apply10309 = addmethod2pos(block10308, "_apply", &meth_parser__apply10309, 0);
  int argcv_meth_parser__apply10309[] = {1};
  meth_meth_parser__apply10309->type = alloc_MethodType(1, argcv_meth_parser__apply10309);
  meth_meth_parser__apply10309->definitionModule = modulename;
  meth_meth_parser__apply10309->definitionLine = 3180;
// compiled block node returning block10308 (depth = 6)
  gc_frame_newslot(block10308);
// call case 4: self request
  params[0] = block10308;
  partcv[0] = 1;
  Object call10317 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10307);
// compiled call node returning call10317 (depth = 5)
  *var_nextTok = call10317;
  if (call10317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10319 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10320 = alloc_Block(NULL, NULL, "parser", 3182);
  gc_frame_newslot(block10320);
// method "_apply"
  block_savedest(block10320);
  Object closure10321 = createclosure(3, "_apply");
  setclosureframe(closure10321, stackframe);
  addtoclosure(closure10321, var_sym);
  addtoclosure(closure10321, var_nextTok);
  addtoclosure(closure10321, selfslot);
  struct UserObject *uo10321 = (struct UserObject*)block10320;
  uo10321->data[0] = (Object)closure10321;
  Method *meth_meth_parser__apply10321 = addmethod2pos(block10320, "_apply", &meth_parser__apply10321, 0);
  int argcv_meth_parser__apply10321[] = {0};
  meth_meth_parser__apply10321->type = alloc_MethodType(1, argcv_meth_parser__apply10321);
  meth_meth_parser__apply10321->definitionModule = modulename;
  meth_meth_parser__apply10321->definitionLine = 3181;
// compiled block node returning block10320 (depth = 6)
  gc_frame_newslot(block10320);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool10327 = alloc_Boolean(0);
// compiled identifier node returning bool10327 (depth = 7)
  int op_slot_right_10326 = gc_frame_newslot(bool10327);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_10326 = gc_frame_newslot(*var_nextTok);
  params[0] = bool10327;
  partcv[0] = 1;
  Object opresult10329 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10329 (depth = 6)
  params[0] = block10320;
  partcv[0] = 1;
  Object call10330 = callmethod(opresult10329, "orElse",
    1, partcv, params);
  gc_frame_end(callframe10319);
// compiled call node returning call10330 (depth = 5)
  Object if10318 = done;
  if (istrue(call10330)) {
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10331 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10332 == NULL) {
    strlit10332 = alloc_String(" =");
    gc_root(strlit10332);
  }
// compiled string node returning strlit10332 (depth = 6)
  gc_frame_newslot(strlit10332);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10332;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10333 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10331);
// compiled call node returning call10333 (depth = 5)
    gc_frame_newslot(call10333);
    if10318 = call10333;
  } else {
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10334 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call10336 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10335);
// compiled call node returning call10336 (depth = 7)
// compiled member node returning call10336 (depth = 6)
  gc_frame_newslot(call10336);
// starting to compile string node (depth = 6)
  if (strlit10337 == NULL) {
    strlit10337 = alloc_String("=");
    gc_root(strlit10337);
  }
// compiled string node returning strlit10337 (depth = 6)
  gc_frame_newslot(strlit10337);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call10336;
  params[2] = strlit10337;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10338 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe10334);
// compiled call node returning call10338 (depth = 5)
    gc_frame_newslot(call10338);
    if10318 = call10338;
  }
// compiled if node returning if10318 (depth = 4)
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10339 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10340 == NULL) {
    strlit10340 = alloc_String("a type declaration must have an '=' after the type name.");
    gc_root(strlit10340);
  }
// compiled string node returning strlit10340 (depth = 5)
  gc_frame_newslot(strlit10340);
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10342 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10341);
// compiled call node returning call10342 (depth = 6)
// compiled member node returning call10342 (depth = 5)
  gc_frame_newslot(call10342);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10344 = alloc_Float64(1);
// compiled num node returning num10344 (depth = 6)
  int op_slot_right_10343 = gc_frame_newslot(num10344);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10347 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10348 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10347);
// compiled call node returning call10348 (depth = 8)
// compiled member node returning call10348 (depth = 7)
  int op_slot_right_10346 = gc_frame_newslot(call10348);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10350 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10351 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10350);
// compiled call node returning call10351 (depth = 8)
// compiled member node returning call10351 (depth = 7)
  int op_slot_left_10346 = gc_frame_newslot(call10351);
  params[0] = call10348;
  partcv[0] = 1;
  Object sum10352 = callmethod(call10351, "+", 1, partcv, params);
// compiled op node returning sum10352 (depth = 6)
  int op_slot_left_10343 = gc_frame_newslot(sum10352);
  params[0] = num10344;
  partcv[0] = 1;
  Object sum10353 = callmethod(sum10352, "+", 1, partcv, params);
// compiled op node returning sum10353 (depth = 5)
  gc_frame_newslot(sum10353);
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10340;
  params[1] = call10342;
  params[2] = sum10353;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10354 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10339);
// compiled call node returning call10354 (depth = 4)
    gc_frame_newslot(call10354);
    if10287 = call10354;
  } else {
  }
// compiled if node returning if10287 (depth = 3)
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10355 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10356 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10355);
// compiled call node returning call10356 (depth = 4)
// compiled member node returning call10356 (depth = 3)
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10358 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10359 == NULL) {
    strlit10359 = alloc_String("lbrace");
    gc_root(strlit10359);
  }
// compiled string node returning strlit10359 (depth = 5)
  gc_frame_newslot(strlit10359);
// call case 4: self request
  params[0] = strlit10359;
  partcv[0] = 1;
  Object call10360 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10358);
// compiled call node returning call10360 (depth = 4)
  Object if10357 = done;
  if (istrue(call10360)) {
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10361 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10362 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10361);
// compiled call node returning call10362 (depth = 5)
// compiled member node returning call10362 (depth = 4)
    gc_frame_newslot(call10362);
    if10357 = call10362;
  } else {
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10363 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call10364 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10363);
// compiled call node returning call10364 (depth = 4)
    gc_frame_newslot(call10364);
    if10357 = call10364;
  }
// compiled if node returning if10357 (depth = 3)
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10365 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10367 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10366);
// compiled call node returning call10367 (depth = 5)
// compiled member node returning call10367 (depth = 4)
  gc_frame_newslot(call10367);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  params[0] = call10367;
  partcv[0] = 1;
  Object call10368 = callmethod(*var_nt, "value:=",
    1, partcv, params);
  gc_frame_end(callframe10365);
// compiled call node returning call10368 (depth = 3)
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_10370 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool10372 = alloc_Boolean(0);
// compiled identifier node returning bool10372 (depth = 5)
  int op_slot_left_10370 = gc_frame_newslot(bool10372);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult10373 = callmethod(bool10372, "!=", 1, partcv, params);
// compiled op node returning opresult10373 (depth = 4)
  Object if10369 = done;
  if (istrue(opresult10373)) {
// Begin line 3200
  setline(3200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10374 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nt (depth = 7)
  partcv[0] = 0;
  Object call10376 = callmethod(*var_nt, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10375);
// compiled call node returning call10376 (depth = 6)
// compiled member node returning call10376 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10377 = callmethod(call10376, "addAll",
    1, partcv, params);
  gc_frame_end(callframe10374);
// compiled call node returning call10377 (depth = 4)
    gc_frame_newslot(call10377);
    if10369 = call10377;
  } else {
  }
// compiled if node returning if10369 (depth = 3)
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10378 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call10379 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10378);
// compiled call node returning call10379 (depth = 3)
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10381 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10380);
// compiled call node returning call10381 (depth = 4)
// compiled member node returning call10381 (depth = 3)
    gc_frame_newslot(call10381);
    if10221 = call10381;
  } else {
  }
// compiled if node returning if10221 (depth = 2)
  gc_frame_end(frame);
  return if10221;
}
Object meth_parser__apply10464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_suggestion = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3221
  setline(3221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe10465 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit10466 == NULL) {
    strlit10466 = alloc_String(" ");
    gc_root(strlit10466);
  }
// compiled string node returning strlit10466 (depth = 11)
  gc_frame_newslot(strlit10466);
// starting to compile num node (depth = 11)
  Object num10467 = alloc_Float64(1);
// compiled num node returning num10467 (depth = 11)
  gc_frame_newslot(num10467);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call10469 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10468);
// compiled call node returning call10469 (depth = 12)
// compiled member node returning call10469 (depth = 11)
  gc_frame_newslot(call10469);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit10466;
  params[1] = num10467;
  params[2] = call10469;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10470 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe10465);
// compiled call node returning call10470 (depth = 10)
  gc_frame_end(frame);
  return call10470;
}
Object meth_parser__apply10482(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_10484 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call10487 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10486);
// compiled call node returning call10487 (depth = 13)
// compiled member node returning call10487 (depth = 12)
  int op_slot_left_10484 = gc_frame_newslot(call10487);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10488 = callmethod(call10487, ">=", 1, partcv, params);
// compiled op node returning opresult10488 (depth = 11)
  int op_slot_right_10483 = gc_frame_newslot(opresult10488);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num10492 = alloc_Float64(1);
// compiled num node returning num10492 (depth = 13)
  int op_slot_right_10491 = gc_frame_newslot(num10492);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call10495 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10494);
// compiled call node returning call10495 (depth = 14)
// compiled member node returning call10495 (depth = 13)
  int op_slot_left_10491 = gc_frame_newslot(call10495);
  params[0] = num10492;
  partcv[0] = 1;
  Object sum10496 = callmethod(call10495, "+", 1, partcv, params);
// compiled op node returning sum10496 (depth = 12)
  int op_slot_right_10490 = gc_frame_newslot(sum10496);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call10499 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10498);
// compiled call node returning call10499 (depth = 13)
// compiled member node returning call10499 (depth = 12)
  int op_slot_left_10490 = gc_frame_newslot(call10499);
  params[0] = sum10496;
  partcv[0] = 1;
  Object opresult10500 = callmethod(call10499, "!=", 1, partcv, params);
// compiled op node returning opresult10500 (depth = 11)
  int op_slot_left_10483 = gc_frame_newslot(opresult10500);
  params[0] = opresult10488;
  partcv[0] = 1;
  Object opresult10501 = callmethod(opresult10500, "||", 1, partcv, params);
// compiled op node returning opresult10501 (depth = 10)
  gc_frame_end(frame);
  return opresult10501;
}
Object meth_parser__apply10504(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// Begin line 3228
  setline(3228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call10506 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10505);
// compiled call node returning call10506 (depth = 12)
// compiled member node returning call10506 (depth = 11)
  *var_tok = call10506;
  if (call10506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply10519(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10521 == NULL) {
    strlit10521 = alloc_String(" ");
    gc_root(strlit10521);
  }
// compiled string node returning strlit10521 (depth = 12)
  int op_slot_right_10520 = gc_frame_newslot(strlit10521);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_10520 = gc_frame_newslot(*var_line);
  params[0] = strlit10521;
  partcv[0] = 1;
  Object opresult10523 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult10523 (depth = 11)
  *var_line = opresult10523;
  if (opresult10523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_checkIndent10382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_lastIndent = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tok");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_m1 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "m1");
  Object *var_m2 = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "m2");
  Object *var_m3 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "m3");
  Object *var_m4 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "m4");
  Object *var_m5 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "m5");
  Object *var_msg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "msg");
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if10383 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10384 = alloc_Boolean(0);
// compiled identifier node returning bool10384 (depth = 4)
  *var_indentFreePass = bool10384;
  if (bool10384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10383 = done;
  } else {
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10388 == NULL) {
    strlit10388 = alloc_String("semicolon");
    gc_root(strlit10388);
  }
// compiled string node returning strlit10388 (depth = 5)
  int op_slot_right_10387 = gc_frame_newslot(strlit10388);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10391 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10390);
// compiled call node returning call10391 (depth = 6)
// compiled member node returning call10391 (depth = 5)
  int op_slot_left_10387 = gc_frame_newslot(call10391);
  params[0] = strlit10388;
  partcv[0] = 1;
  Object opresult10392 = callmethod(call10391, "==", 1, partcv, params);
// compiled op node returning opresult10392 (depth = 4)
  Object if10386 = done;
  if (istrue(opresult10392)) {
    gc_frame_newslot(done);
    if10386 = done;
  } else {
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 3213
  setline(3213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10396 == NULL) {
    strlit10396 = alloc_String("rsquare");
    gc_root(strlit10396);
  }
// compiled string node returning strlit10396 (depth = 7)
  int op_slot_right_10395 = gc_frame_newslot(strlit10396);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10399 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10398);
// compiled call node returning call10399 (depth = 8)
// compiled member node returning call10399 (depth = 7)
  int op_slot_left_10395 = gc_frame_newslot(call10399);
  params[0] = strlit10396;
  partcv[0] = 1;
  Object opresult10400 = callmethod(call10399, "==", 1, partcv, params);
// compiled op node returning opresult10400 (depth = 6)
  int op_slot_right_10394 = gc_frame_newslot(opresult10400);
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10404 == NULL) {
    strlit10404 = alloc_String("rparen");
    gc_root(strlit10404);
  }
// compiled string node returning strlit10404 (depth = 8)
  int op_slot_right_10403 = gc_frame_newslot(strlit10404);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10406 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10407 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10406);
// compiled call node returning call10407 (depth = 9)
// compiled member node returning call10407 (depth = 8)
  int op_slot_left_10403 = gc_frame_newslot(call10407);
  params[0] = strlit10404;
  partcv[0] = 1;
  Object opresult10408 = callmethod(call10407, "==", 1, partcv, params);
// compiled op node returning opresult10408 (depth = 7)
  int op_slot_right_10402 = gc_frame_newslot(opresult10408);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10411 == NULL) {
    strlit10411 = alloc_String("rbrace");
    gc_root(strlit10411);
  }
// compiled string node returning strlit10411 (depth = 8)
  int op_slot_right_10410 = gc_frame_newslot(strlit10411);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10414 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10413);
// compiled call node returning call10414 (depth = 9)
// compiled member node returning call10414 (depth = 8)
  int op_slot_left_10410 = gc_frame_newslot(call10414);
  params[0] = strlit10411;
  partcv[0] = 1;
  Object opresult10415 = callmethod(call10414, "==", 1, partcv, params);
// compiled op node returning opresult10415 (depth = 7)
  int op_slot_left_10402 = gc_frame_newslot(opresult10415);
  params[0] = opresult10408;
  partcv[0] = 1;
  Object opresult10416 = callmethod(opresult10415, "||", 1, partcv, params);
// compiled op node returning opresult10416 (depth = 6)
  int op_slot_left_10394 = gc_frame_newslot(opresult10416);
  params[0] = opresult10400;
  partcv[0] = 1;
  Object opresult10417 = callmethod(opresult10416, "||", 1, partcv, params);
// compiled op node returning opresult10417 (depth = 5)
  Object if10393 = done;
  if (istrue(opresult10417)) {
    gc_frame_newslot(done);
    if10393 = done;
  } else {
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10420 == NULL) {
    strlit10420 = alloc_String("eof");
    gc_root(strlit10420);
  }
// compiled string node returning strlit10420 (depth = 7)
  int op_slot_right_10419 = gc_frame_newslot(strlit10420);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10422 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10423 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10422);
// compiled call node returning call10423 (depth = 8)
// compiled member node returning call10423 (depth = 7)
  int op_slot_left_10419 = gc_frame_newslot(call10423);
  params[0] = strlit10420;
  partcv[0] = 1;
  Object opresult10424 = callmethod(call10423, "==", 1, partcv, params);
// compiled op node returning opresult10424 (depth = 6)
  Object if10418 = done;
  if (istrue(opresult10424)) {
    gc_frame_newslot(done);
    if10418 = done;
  } else {
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_10426 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10429 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10428);
// compiled call node returning call10429 (depth = 9)
// compiled member node returning call10429 (depth = 8)
  int op_slot_left_10426 = gc_frame_newslot(call10429);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10430 = callmethod(call10429, "<", 1, partcv, params);
// compiled op node returning opresult10430 (depth = 7)
  Object if10425 = done;
  if (istrue(opresult10430)) {
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_10432 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10435 = alloc_Float64(1);
// compiled num node returning num10435 (depth = 10)
  int op_slot_right_10434 = gc_frame_newslot(num10435);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10438 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10437);
// compiled call node returning call10438 (depth = 11)
// compiled member node returning call10438 (depth = 10)
  int op_slot_left_10434 = gc_frame_newslot(call10438);
  params[0] = num10435;
  partcv[0] = 1;
  Object diff10439 = callmethod(call10438, "-", 1, partcv, params);
// compiled op node returning diff10439 (depth = 9)
  int op_slot_left_10432 = gc_frame_newslot(diff10439);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10440 = callmethod(diff10439, "!=", 1, partcv, params);
// compiled op node returning opresult10440 (depth = 8)
  Object if10431 = done;
  if (istrue(opresult10440)) {
// Begin line 3218
  setline(3218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10441 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10442 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10443 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10442);
// compiled call node returning call10443 (depth = 12)
// compiled member node returning call10443 (depth = 11)
  partcv[0] = 0;
  Object call10444 = callmethod(call10443, "empty",
    1, partcv, params);
  gc_frame_end(callframe10441);
// compiled call node returning call10444 (depth = 10)
// compiled member node returning call10444 (depth = 9)
  *var_suggestions = call10444;
  if (call10444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 3219
  setline(3219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10445 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call10447 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10446);
// compiled call node returning call10447 (depth = 12)
// compiled member node returning call10447 (depth = 11)
  partcv[0] = 0;
  Object call10448 = callmethod(call10447, "new",
    1, partcv, params);
  gc_frame_end(callframe10445);
// compiled call node returning call10448 (depth = 10)
// compiled member node returning call10448 (depth = 9)
  *var_suggestion = call10448;
  if (call10448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3220
  setline(3220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10449 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num10453 = alloc_Float64(1);
// compiled num node returning num10453 (depth = 12)
  int op_slot_right_10452 = gc_frame_newslot(num10453);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call10456 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10455);
// compiled call node returning call10456 (depth = 13)
// compiled member node returning call10456 (depth = 12)
  int op_slot_left_10452 = gc_frame_newslot(call10456);
  params[0] = num10453;
  partcv[0] = 1;
  Object diff10457 = callmethod(call10456, "-", 1, partcv, params);
// compiled op node returning diff10457 (depth = 11)
  int op_slot_right_10451 = gc_frame_newslot(diff10457);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_10451 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff10457;
  partcv[0] = 1;
  Object diff10459 = callmethod(*var_minIndentLevel, "-", 1, partcv, params);
// compiled op node returning diff10459 (depth = 10)
  int op_slot_right_10450 = gc_frame_newslot(diff10459);
// starting to compile num node (depth = 10)
  Object num10461 = alloc_Float64(1);
// compiled num node returning num10461 (depth = 10)
  int op_slot_left_10450 = gc_frame_newslot(num10461);
  params[0] = diff10459;
  partcv[0] = 1;
  Object opresult10462 = callmethod(num10461, "..", 1, partcv, params);
// compiled op node returning opresult10462 (depth = 9)
  gc_frame_newslot(opresult10462);
// starting to compile block node (depth = 9)
  Object block10463 = alloc_Block(NULL, NULL, "parser", 3220);
  gc_frame_newslot(block10463);
// method "_apply"
  block_savedest(block10463);
  Object closure10464 = createclosure(3, "_apply");
  setclosureframe(closure10464, stackframe);
  addtoclosure(closure10464, var_sym);
  addtoclosure(closure10464, var_suggestion);
  addtoclosure(closure10464, selfslot);
  struct UserObject *uo10464 = (struct UserObject*)block10463;
  uo10464->data[0] = (Object)closure10464;
  Method *meth_meth_parser__apply10464 = addmethod2pos(block10463, "_apply", &meth_parser__apply10464, 0);
  int argcv_meth_parser__apply10464[] = {1};
  meth_meth_parser__apply10464->type = alloc_MethodType(1, argcv_meth_parser__apply10464);
  meth_meth_parser__apply10464->definitionModule = modulename;
  meth_meth_parser__apply10464->definitionLine = 3220;
// compiled block node returning block10463 (depth = 9)
  gc_frame_newslot(block10463);
// call case 5: prelude request
  params[0] = opresult10462;
  params[1] = block10463;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10472 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10449);
// compiled call node returning call10472 (depth = 8)
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10473 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10474 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10473);
// compiled call node returning call10474 (depth = 8)
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10475 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call10477 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10476);
// compiled call node returning call10477 (depth = 12)
// compiled member node returning call10477 (depth = 11)
  partcv[0] = 0;
  Object call10478 = callmethod(call10477, "new",
    1, partcv, params);
  gc_frame_end(callframe10475);
// compiled call node returning call10478 (depth = 10)
// compiled member node returning call10478 (depth = 9)
  *var_suggestion = call10478;
  if (call10478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10480 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block10481 = alloc_Block(NULL, NULL, "parser", 3227);
  gc_frame_newslot(block10481);
// method "_apply"
  block_savedest(block10481);
  Object closure10482 = createclosure(3, "_apply");
  setclosureframe(closure10482, stackframe);
  addtoclosure(closure10482, var_minIndentLevel);
  addtoclosure(closure10482, var_tok);
  addtoclosure(closure10482, selfslot);
  struct UserObject *uo10482 = (struct UserObject*)block10481;
  uo10482->data[0] = (Object)closure10482;
  Method *meth_meth_parser__apply10482 = addmethod2pos(block10481, "_apply", &meth_parser__apply10482, 0);
  int argcv_meth_parser__apply10482[] = {0};
  meth_meth_parser__apply10482->type = alloc_MethodType(1, argcv_meth_parser__apply10482);
  meth_meth_parser__apply10482->definitionModule = modulename;
  meth_meth_parser__apply10482->definitionLine = 3224;
// compiled block node returning block10481 (depth = 9)
  gc_frame_newslot(block10481);
// starting to compile block node (depth = 9)
  Object block10503 = alloc_Block(NULL, NULL, "parser", 3227);
  gc_frame_newslot(block10503);
// method "_apply"
  block_savedest(block10503);
  Object closure10504 = createclosure(2, "_apply");
  setclosureframe(closure10504, stackframe);
  addtoclosure(closure10504, var_tok);
  addtoclosure(closure10504, selfslot);
  struct UserObject *uo10504 = (struct UserObject*)block10503;
  uo10504->data[0] = (Object)closure10504;
  Method *meth_meth_parser__apply10504 = addmethod2pos(block10503, "_apply", &meth_parser__apply10504, 0);
  int argcv_meth_parser__apply10504[] = {0};
  meth_meth_parser__apply10504->type = alloc_MethodType(1, argcv_meth_parser__apply10504);
  meth_meth_parser__apply10504->definitionModule = modulename;
  meth_meth_parser__apply10504->definitionLine = 3227;
// compiled block node returning block10503 (depth = 9)
  gc_frame_newslot(block10503);
// call case 5: prelude request
  params[0] = block10481;
  params[1] = block10503;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10509 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10480);
// compiled call node returning call10509 (depth = 8)
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10510 == NULL) {
    strlit10510 = alloc_String("");
    gc_root(strlit10510);
  }
// compiled string node returning strlit10510 (depth = 9)
  *var_line = strlit10510;
  if (strlit10510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3231
  setline(3231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10511 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10513 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call10514 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10513);
// compiled call node returning call10514 (depth = 11)
// compiled member node returning call10514 (depth = 10)
  int op_slot_right_10512 = gc_frame_newslot(call10514);
// starting to compile num node (depth = 10)
  Object num10516 = alloc_Float64(1);
// compiled num node returning num10516 (depth = 10)
  int op_slot_left_10512 = gc_frame_newslot(num10516);
  params[0] = call10514;
  partcv[0] = 1;
  Object opresult10517 = callmethod(num10516, "..", 1, partcv, params);
// compiled op node returning opresult10517 (depth = 9)
  gc_frame_newslot(opresult10517);
// starting to compile block node (depth = 9)
  Object block10518 = alloc_Block(NULL, NULL, "parser", 3231);
  gc_frame_newslot(block10518);
// method "_apply"
  block_savedest(block10518);
  Object closure10519 = createclosure(2, "_apply");
  setclosureframe(closure10519, stackframe);
  addtoclosure(closure10519, var_line);
  addtoclosure(closure10519, selfslot);
  struct UserObject *uo10519 = (struct UserObject*)block10518;
  uo10519->data[0] = (Object)closure10519;
  Method *meth_meth_parser__apply10519 = addmethod2pos(block10518, "_apply", &meth_parser__apply10519, 0);
  int argcv_meth_parser__apply10519[] = {1};
  meth_meth_parser__apply10519->type = alloc_MethodType(1, argcv_meth_parser__apply10519);
  meth_meth_parser__apply10519->definitionModule = modulename;
  meth_meth_parser__apply10519->definitionLine = 3231;
// compiled block node returning block10518 (depth = 9)
  gc_frame_newslot(block10518);
// call case 5: prelude request
  params[0] = opresult10517;
  params[1] = block10518;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10526 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10511);
// compiled call node returning call10526 (depth = 8)
// Begin line 3234
  setline(3234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10528 == NULL) {
    strlit10528 = alloc_String("}");
    gc_root(strlit10528);
  }
// compiled string node returning strlit10528 (depth = 10)
  int op_slot_right_10527 = gc_frame_newslot(strlit10528);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_10527 = gc_frame_newslot(*var_line);
  params[0] = strlit10528;
  partcv[0] = 1;
  Object opresult10530 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult10530 (depth = 9)
  *var_line = opresult10530;
  if (opresult10530 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3235
  setline(3235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10532 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10534 = alloc_Float64(0.9);
// compiled num node returning num10534 (depth = 10)
  int op_slot_right_10533 = gc_frame_newslot(num10534);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10537 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10536);
// compiled call node returning call10537 (depth = 11)
// compiled member node returning call10537 (depth = 10)
  int op_slot_left_10533 = gc_frame_newslot(call10537);
  params[0] = num10534;
  partcv[0] = 1;
  Object diff10538 = callmethod(call10537, "-", 1, partcv, params);
// compiled op node returning diff10538 (depth = 9)
  gc_frame_newslot(diff10538);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff10538;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call10539 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10532);
// compiled call node returning call10539 (depth = 8)
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10540 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10541 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10540);
// compiled call node returning call10541 (depth = 8)
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10542 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 3238
  setline(3238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10545 == NULL) {
    strlit10545 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit10545);
  }
// compiled string node returning strlit10545 (depth = 11)
  int op_slot_right_10544 = gc_frame_newslot(strlit10545);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_10547 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 12)
  if (strlit10549 == NULL) {
    strlit10549 = alloc_String("at least ");
    gc_root(strlit10549);
  }
// compiled string node returning strlit10549 (depth = 12)
  int op_slot_left_10547 = gc_frame_newslot(strlit10549);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10550 = callmethod(strlit10549, "++", 1, partcv, params);
// compiled op node returning opresult10550 (depth = 11)
  int op_slot_left_10544 = gc_frame_newslot(opresult10550);
  params[0] = strlit10545;
  partcv[0] = 1;
  Object opresult10551 = callmethod(opresult10550, "++", 1, partcv, params);
// compiled op node returning opresult10551 (depth = 10)
  int op_slot_right_10543 = gc_frame_newslot(opresult10551);
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit10553 == NULL) {
    strlit10553 = alloc_String("the indentation for this line must be ");
    gc_root(strlit10553);
  }
// compiled string node returning strlit10553 (depth = 10)
  int op_slot_left_10543 = gc_frame_newslot(strlit10553);
  params[0] = opresult10551;
  partcv[0] = 1;
  Object opresult10554 = callmethod(strlit10553, "++", 1, partcv, params);
// compiled op node returning opresult10554 (depth = 9)
  gc_frame_newslot(opresult10554);
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10555 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10556 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10555);
// compiled call node returning call10556 (depth = 10)
// compiled member node returning call10556 (depth = 9)
  gc_frame_newslot(call10556);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10558 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10557);
// compiled call node returning call10558 (depth = 10)
// compiled member node returning call10558 (depth = 9)
  gc_frame_newslot(call10558);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult10554;
  params[1] = call10556;
  params[2] = call10558;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10559 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10542);
// compiled call node returning call10559 (depth = 8)
    gc_frame_newslot(call10559);
    if10431 = call10559;
  } else {
  }
// compiled if node returning if10431 (depth = 7)
    gc_frame_newslot(if10431);
    if10425 = if10431;
  } else {
// Begin line 3243
  setline(3243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10563 = alloc_Float64(1);
// compiled num node returning num10563 (depth = 10)
  int op_slot_right_10562 = gc_frame_newslot(num10563);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_minIndentLevel (depth = 10)
  int op_slot_left_10562 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = num10563;
  partcv[0] = 1;
  Object sum10565 = callmethod(*var_minIndentLevel, "+", 1, partcv, params);
// compiled op node returning sum10565 (depth = 9)
  int op_slot_right_10561 = gc_frame_newslot(sum10565);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10568 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10567);
// compiled call node returning call10568 (depth = 10)
// compiled member node returning call10568 (depth = 9)
  int op_slot_left_10561 = gc_frame_newslot(call10568);
  params[0] = sum10565;
  partcv[0] = 1;
  Object opresult10569 = callmethod(call10568, ">", 1, partcv, params);
// compiled op node returning opresult10569 (depth = 8)
  Object if10560 = done;
  if (istrue(opresult10569)) {
// Begin line 3242
  setline(3242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10571 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10570);
// compiled call node returning call10571 (depth = 10)
// compiled member node returning call10571 (depth = 9)
  *var_minIndentLevel = call10571;
  if (call10571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if10560 = done;
  } else {
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3243
  setline(3243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10575 = alloc_Float64(1);
// compiled num node returning num10575 (depth = 10)
  int op_slot_right_10574 = gc_frame_newslot(num10575);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10577 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastIndent (depth = 13)
  int op_slot_right_10578 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_sym (depth = 15)
  partcv[0] = 0;
  Object call10581 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10580);
// compiled call node returning call10581 (depth = 14)
// compiled member node returning call10581 (depth = 13)
  int op_slot_left_10578 = gc_frame_newslot(call10581);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object diff10582 = callmethod(call10581, "-", 1, partcv, params);
// compiled op node returning diff10582 (depth = 12)
  partcv[0] = 0;
  Object call10583 = callmethod(diff10582, "abs",
    1, partcv, params);
  gc_frame_end(callframe10577);
// compiled call node returning call10583 (depth = 11)
// compiled member node returning call10583 (depth = 10)
  int op_slot_left_10574 = gc_frame_newslot(call10583);
  params[0] = num10575;
  partcv[0] = 1;
  Object opresult10584 = callmethod(call10583, "==", 1, partcv, params);
// compiled op node returning opresult10584 (depth = 9)
  Object if10573 = done;
  if (istrue(opresult10584)) {
// Begin line 3244
  setline(3244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10585 == NULL) {
    strlit10585 = alloc_String("the indentation for this line can't differ ");
    gc_root(strlit10585);
  }
// compiled string node returning strlit10585 (depth = 10)
  *var_m1 = strlit10585;
  if (strlit10585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10586 == NULL) {
    strlit10586 = alloc_String("from that of the previous line by 1.""\x0a""  To start a block, or ");
    gc_root(strlit10586);
  }
// compiled string node returning strlit10586 (depth = 10)
  *var_m2 = strlit10586;
  if (strlit10586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10587 == NULL) {
    strlit10587 = alloc_String("to signal a continuation line, increase the indent by 2 or more. ");
    gc_root(strlit10587);
  }
// compiled string node returning strlit10587 (depth = 10)
  *var_m3 = strlit10587;
  if (strlit10587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10588 == NULL) {
    strlit10588 = alloc_String("To end a block, or end the continuation, decrease the indent ");
    gc_root(strlit10588);
  }
// compiled string node returning strlit10588 (depth = 10)
  *var_m4 = strlit10588;
  if (strlit10588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10589 == NULL) {
    strlit10589 = alloc_String("to the prior level. Otherwise, use the same indent as the previous line.");
    gc_root(strlit10589);
  }
// compiled string node returning strlit10589 (depth = 10)
  *var_m5 = strlit10589;
  if (strlit10589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_m5 (depth = 11)
  int op_slot_right_10590 = gc_frame_newslot(*var_m5);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_m4 (depth = 12)
  int op_slot_right_10592 = gc_frame_newslot(*var_m4);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_m3 (depth = 13)
  int op_slot_right_10594 = gc_frame_newslot(*var_m3);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_m2 (depth = 14)
  int op_slot_right_10596 = gc_frame_newslot(*var_m2);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_m1 (depth = 14)
  int op_slot_left_10596 = gc_frame_newslot(*var_m1);
  params[0] = *var_m2;
  partcv[0] = 1;
  Object opresult10598 = callmethod(*var_m1, "++", 1, partcv, params);
// compiled op node returning opresult10598 (depth = 13)
  int op_slot_left_10594 = gc_frame_newslot(opresult10598);
  params[0] = *var_m3;
  partcv[0] = 1;
  Object opresult10599 = callmethod(opresult10598, "++", 1, partcv, params);
// compiled op node returning opresult10599 (depth = 12)
  int op_slot_left_10592 = gc_frame_newslot(opresult10599);
  params[0] = *var_m4;
  partcv[0] = 1;
  Object opresult10600 = callmethod(opresult10599, "++", 1, partcv, params);
// compiled op node returning opresult10600 (depth = 11)
  int op_slot_left_10590 = gc_frame_newslot(opresult10600);
  params[0] = *var_m5;
  partcv[0] = 1;
  Object opresult10601 = callmethod(opresult10600, "++", 1, partcv, params);
// compiled op node returning opresult10601 (depth = 10)
  *var_msg = opresult10601;
  if (opresult10601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3250
  setline(3250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe10602 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_msg (depth = 10)
  gc_frame_newslot(*var_msg);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10603 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10604 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10603);
// compiled call node returning call10604 (depth = 11)
// compiled member node returning call10604 (depth = 10)
  gc_frame_newslot(call10604);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10606 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10605);
// compiled call node returning call10606 (depth = 11)
// compiled member node returning call10606 (depth = 10)
  gc_frame_newslot(call10606);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = *var_msg;
  params[1] = call10604;
  params[2] = call10606;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call10607 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe10602);
// compiled call node returning call10607 (depth = 9)
    gc_frame_newslot(call10607);
    if10573 = call10607;
  } else {
  }
// compiled if node returning if10573 (depth = 8)
    gc_frame_newslot(if10573);
    if10560 = if10573;
  }
// compiled if node returning if10560 (depth = 7)
    gc_frame_newslot(if10560);
    if10425 = if10560;
  }
// compiled if node returning if10425 (depth = 6)
    gc_frame_newslot(if10425);
    if10418 = if10425;
  }
// compiled if node returning if10418 (depth = 5)
    gc_frame_newslot(if10418);
    if10393 = if10418;
  }
// compiled if node returning if10393 (depth = 4)
    gc_frame_newslot(if10393);
    if10386 = if10393;
  }
// compiled if node returning if10386 (depth = 3)
    gc_frame_newslot(if10386);
    if10383 = if10386;
  }
// compiled if node returning if10383 (depth = 2)
  gc_frame_end(frame);
  return if10383;
}
Object meth_parser__apply10704(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe10705 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10706 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10705);
// compiled call node returning call10706 (depth = 5)
  gc_frame_end(frame);
  return call10706;
}
Object meth_parser__apply10785(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe10786 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10787 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10786);
// compiled call node returning call10787 (depth = 11)
  gc_frame_end(frame);
  return call10787;
}
Object meth_parser__apply10709(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_btok = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dest = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "dest");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10712 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10713 == NULL) {
    strlit10713 = alloc_String("bind");
    gc_root(strlit10713);
  }
// compiled string node returning strlit10713 (depth = 8)
  gc_frame_newslot(strlit10713);
// call case 4: self request
  params[0] = strlit10713;
  partcv[0] = 1;
  Object call10714 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10712);
// compiled call node returning call10714 (depth = 7)
  int op_slot_right_10711 = gc_frame_newslot(call10714);
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10718 == NULL) {
    strlit10718 = alloc_String("index");
    gc_root(strlit10718);
  }
// compiled string node returning strlit10718 (depth = 9)
  int op_slot_right_10717 = gc_frame_newslot(strlit10718);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10720 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10721 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  partcv[0] = 0;
  Object call10722 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10721);
// compiled call node returning call10722 (depth = 12)
// compiled member node returning call10722 (depth = 11)
  partcv[0] = 0;
  Object call10723 = callmethod(call10722, "kind",
    1, partcv, params);
  gc_frame_end(callframe10720);
// compiled call node returning call10723 (depth = 10)
// compiled member node returning call10723 (depth = 9)
  int op_slot_left_10717 = gc_frame_newslot(call10723);
  params[0] = strlit10718;
  partcv[0] = 1;
  Object opresult10724 = callmethod(call10723, "==", 1, partcv, params);
// compiled op node returning opresult10724 (depth = 8)
  int op_slot_right_10716 = gc_frame_newslot(opresult10724);
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 3290
  setline(3290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10728 == NULL) {
    strlit10728 = alloc_String("member");
    gc_root(strlit10728);
  }
// compiled string node returning strlit10728 (depth = 10)
  int op_slot_right_10727 = gc_frame_newslot(strlit10728);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10730 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call10732 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10731);
// compiled call node returning call10732 (depth = 13)
// compiled member node returning call10732 (depth = 12)
  partcv[0] = 0;
  Object call10733 = callmethod(call10732, "kind",
    1, partcv, params);
  gc_frame_end(callframe10730);
// compiled call node returning call10733 (depth = 11)
// compiled member node returning call10733 (depth = 10)
  int op_slot_left_10727 = gc_frame_newslot(call10733);
  params[0] = strlit10728;
  partcv[0] = 1;
  Object opresult10734 = callmethod(call10733, "==", 1, partcv, params);
// compiled op node returning opresult10734 (depth = 9)
  int op_slot_right_10726 = gc_frame_newslot(opresult10734);
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10737 == NULL) {
    strlit10737 = alloc_String("identifier");
    gc_root(strlit10737);
  }
// compiled string node returning strlit10737 (depth = 10)
  int op_slot_right_10736 = gc_frame_newslot(strlit10737);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10739 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10740 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call10741 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10740);
// compiled call node returning call10741 (depth = 13)
// compiled member node returning call10741 (depth = 12)
  partcv[0] = 0;
  Object call10742 = callmethod(call10741, "kind",
    1, partcv, params);
  gc_frame_end(callframe10739);
// compiled call node returning call10742 (depth = 11)
// compiled member node returning call10742 (depth = 10)
  int op_slot_left_10736 = gc_frame_newslot(call10742);
  params[0] = strlit10737;
  partcv[0] = 1;
  Object opresult10743 = callmethod(call10742, "==", 1, partcv, params);
// compiled op node returning opresult10743 (depth = 9)
  int op_slot_left_10726 = gc_frame_newslot(opresult10743);
  params[0] = opresult10734;
  partcv[0] = 1;
  Object opresult10744 = callmethod(opresult10743, "||", 1, partcv, params);
// compiled op node returning opresult10744 (depth = 8)
  int op_slot_left_10716 = gc_frame_newslot(opresult10744);
  params[0] = opresult10724;
  partcv[0] = 1;
  Object opresult10745 = callmethod(opresult10744, "||", 1, partcv, params);
// compiled op node returning opresult10745 (depth = 7)
  int op_slot_left_10711 = gc_frame_newslot(opresult10745);
  params[0] = call10714;
  partcv[0] = 1;
  Object opresult10746 = callmethod(opresult10745, "&&", 1, partcv, params);
// compiled op node returning opresult10746 (depth = 6)
  Object if10710 = done;
  if (istrue(opresult10746)) {
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10747 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10748 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10747);
// compiled call node returning call10748 (depth = 8)
// compiled member node returning call10748 (depth = 7)
  *var_dest = call10748;
  if (call10748 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3294
  setline(3294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10751 == NULL) {
    strlit10751 = alloc_String("lbrace");
    gc_root(strlit10751);
  }
// compiled string node returning strlit10751 (depth = 8)
  int op_slot_right_10750 = gc_frame_newslot(strlit10751);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_dest (depth = 10)
  partcv[0] = 0;
  Object call10754 = callmethod(*var_dest, "kind",
    1, partcv, params);
  gc_frame_end(callframe10753);
// compiled call node returning call10754 (depth = 9)
// compiled member node returning call10754 (depth = 8)
  int op_slot_left_10750 = gc_frame_newslot(call10754);
  params[0] = strlit10751;
  partcv[0] = 1;
  Object opresult10755 = callmethod(call10754, "==", 1, partcv, params);
// compiled op node returning opresult10755 (depth = 7)
  Object if10749 = done;
  if (istrue(opresult10755)) {
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10757 == NULL) {
    strlit10757 = alloc_String("");
    gc_root(strlit10757);
  }
// compiled string node returning strlit10757 (depth = 9)
  int op_slot_right_10756 = gc_frame_newslot(strlit10757);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10761 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10760);
// compiled call node returning call10761 (depth = 11)
// compiled member node returning call10761 (depth = 10)
  int op_slot_right_10759 = gc_frame_newslot(call10761);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10764 == NULL) {
    strlit10764 = alloc_String(", sym.line = ");
    gc_root(strlit10764);
  }
// compiled string node returning strlit10764 (depth = 11)
  int op_slot_right_10763 = gc_frame_newslot(strlit10764);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_10766 = gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 12)
  if (strlit10768 == NULL) {
    strlit10768 = alloc_String("sym = ");
    gc_root(strlit10768);
  }
// compiled string node returning strlit10768 (depth = 12)
  int op_slot_left_10766 = gc_frame_newslot(strlit10768);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10769 = callmethod(strlit10768, "++", 1, partcv, params);
// compiled op node returning opresult10769 (depth = 11)
  int op_slot_left_10763 = gc_frame_newslot(opresult10769);
  params[0] = strlit10764;
  partcv[0] = 1;
  Object opresult10770 = callmethod(opresult10769, "++", 1, partcv, params);
// compiled op node returning opresult10770 (depth = 10)
  int op_slot_left_10759 = gc_frame_newslot(opresult10770);
  params[0] = call10761;
  partcv[0] = 1;
  Object opresult10771 = callmethod(opresult10770, "++", 1, partcv, params);
// compiled op node returning opresult10771 (depth = 9)
  int op_slot_left_10756 = gc_frame_newslot(opresult10771);
  params[0] = strlit10757;
  partcv[0] = 1;
  Object opresult10772 = callmethod(opresult10771, "++", 1, partcv, params);
// compiled op node returning opresult10772 (depth = 8)
  params[0] = opresult10772;
  Object call10773 = gracelib_print(NULL, 1,  params);
// compiled call node returning call10773 (depth = 7)
// Begin line 3296
  setline(3296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10774 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10775 == NULL) {
    strlit10775 = alloc_String("popped lbrace token while parsing statement");
    gc_root(strlit10775);
  }
// compiled string node returning strlit10775 (depth = 8)
  gc_frame_newslot(strlit10775);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10776 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10777 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10776);
// compiled call node returning call10777 (depth = 9)
// compiled member node returning call10777 (depth = 8)
  params[0] = strlit10775;
  partcv[0] = 1;
  Object call10778 = callmethod(call10777, "raise",
    1, partcv, params);
  gc_frame_end(callframe10774);
// compiled call node returning call10778 (depth = 7)
    gc_frame_newslot(call10778);
    if10749 = call10778;
  } else {
  }
// compiled if node returning if10749 (depth = 6)
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10780 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10779);
// compiled call node returning call10780 (depth = 7)
// compiled member node returning call10780 (depth = 6)
// Begin line 3299
  setline(3299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10782 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe10783 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block10784 = alloc_Block(NULL, NULL, "parser", 3299);
  gc_frame_newslot(block10784);
// method "_apply"
  block_savedest(block10784);
  Object closure10785 = createclosure(2, "_apply");
  setclosureframe(closure10785, stackframe);
  addtoclosure(closure10785, var_blocksOK);
  addtoclosure(closure10785, selfslot);
  struct UserObject *uo10785 = (struct UserObject*)block10784;
  uo10785->data[0] = (Object)closure10785;
  Method *meth_meth_parser__apply10785 = addmethod2pos(block10784, "_apply", &meth_parser__apply10785, 0);
  int argcv_meth_parser__apply10785[] = {0};
  meth_meth_parser__apply10785->type = alloc_MethodType(1, argcv_meth_parser__apply10785);
  meth_meth_parser__apply10785->definitionModule = modulename;
  meth_meth_parser__apply10785->definitionLine = 3299;
// compiled block node returning block10784 (depth = 10)
  gc_frame_newslot(block10784);
// call case 4: self request
  params[0] = block10784;
  partcv[0] = 1;
  Object call10789 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10783);
// compiled call node returning call10789 (depth = 9)
  partcv[0] = 0;
  Object call10790 = callmethod(call10789, "not",
    1, partcv, params);
  gc_frame_end(callframe10782);
// compiled call node returning call10790 (depth = 8)
// compiled member node returning call10790 (depth = 7)
  Object if10781 = done;
  if (istrue(call10790)) {
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10791 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10792 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10793 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10792);
// compiled call node returning call10793 (depth = 11)
// compiled member node returning call10793 (depth = 10)
  partcv[0] = 0;
  Object call10794 = callmethod(call10793, "empty",
    1, partcv, params);
  gc_frame_end(callframe10791);
// compiled call node returning call10794 (depth = 9)
// compiled member node returning call10794 (depth = 8)
  *var_suggestions = call10794;
  if (call10794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3301
  setline(3301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10795 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10796 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call10797 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10796);
// compiled call node returning call10797 (depth = 11)
// compiled member node returning call10797 (depth = 10)
  partcv[0] = 0;
  Object call10798 = callmethod(call10797, "new",
    1, partcv, params);
  gc_frame_end(callframe10795);
// compiled call node returning call10798 (depth = 9)
// compiled member node returning call10798 (depth = 8)
  *var_suggestion = call10798;
  if (call10798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 3302
  setline(3302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10799 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array10800 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit10801 == NULL) {
    strlit10801 = alloc_String("rbrace");
    gc_root(strlit10801);
  }
// compiled string node returning strlit10801 (depth = 10)
  params[0] = strlit10801;
  partcv[0] = 1;
  callmethod(array10800, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array10800 (depth = 9)
  gc_frame_newslot(array10800);
// call case 4: self request
  params[0] = array10800;
  partcv[0] = 1;
  Object call10802 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10799);
// compiled call node returning call10802 (depth = 8)
  *var_nextTok = call10802;
  if (call10802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3303
  setline(3303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_10804 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_10804 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10806 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10806 (depth = 8)
  Object if10803 = done;
  if (istrue(opresult10806)) {
// Begin line 3304
  setline(3304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10807 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit10808 == NULL) {
    strlit10808 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10808);
  }
// compiled string node returning strlit10808 (depth = 9)
  gc_frame_newslot(strlit10808);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit10808;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10809 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10807);
// compiled call node returning call10809 (depth = 8)
    gc_frame_newslot(call10809);
    if10803 = call10809;
  } else {
// Begin line 3306
  setline(3306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10810 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10811 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call10812 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10811);
// compiled call node returning call10812 (depth = 10)
// compiled member node returning call10812 (depth = 9)
  gc_frame_newslot(call10812);
// starting to compile identifier node (depth = 9)
  Object bool10813 = alloc_Boolean(1);
// compiled identifier node returning bool10813 (depth = 9)
  gc_frame_newslot(bool10813);
// starting to compile identifier node (depth = 9)
  Object bool10814 = alloc_Boolean(0);
// compiled identifier node returning bool10814 (depth = 9)
  gc_frame_newslot(bool10814);
// starting to compile string node (depth = 9)
  if (strlit10815 == NULL) {
    strlit10815 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10815);
  }
// compiled string node returning strlit10815 (depth = 9)
  gc_frame_newslot(strlit10815);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call10812;
  params[2] = bool10813;
  params[3] = bool10814;
  params[4] = strlit10815;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10816 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10810);
// compiled call node returning call10816 (depth = 8)
    gc_frame_newslot(call10816);
    if10803 = call10816;
  }
// compiled if node returning if10803 (depth = 7)
// Begin line 3308
  setline(3308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10817 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10818 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10817);
// compiled call node returning call10818 (depth = 7)
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10819 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call10821 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10820);
// compiled call node returning call10821 (depth = 11)
// compiled member node returning call10821 (depth = 10)
  partcv[0] = 0;
  Object call10822 = callmethod(call10821, "new",
    1, partcv, params);
  gc_frame_end(callframe10819);
// compiled call node returning call10822 (depth = 9)
// compiled member node returning call10822 (depth = 8)
  *var_suggestion = call10822;
  if (call10822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10824 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call10826 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10825);
// compiled call node returning call10826 (depth = 9)
// compiled member node returning call10826 (depth = 8)
  gc_frame_newslot(call10826);
// starting to compile identifier node (depth = 8)
  Object bool10827 = alloc_Boolean(1);
// compiled identifier node returning bool10827 (depth = 8)
  gc_frame_newslot(bool10827);
// starting to compile identifier node (depth = 8)
  Object bool10828 = alloc_Boolean(0);
// compiled identifier node returning bool10828 (depth = 8)
  gc_frame_newslot(bool10828);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call10826;
  params[2] = bool10827;
  params[3] = bool10828;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10829 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10824);
// compiled call node returning call10829 (depth = 7)
// Begin line 3311
  setline(3311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10830 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10831 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10830);
// compiled call node returning call10831 (depth = 7)
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10832 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10833 == NULL) {
    strlit10833 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit10833);
  }
// compiled string node returning strlit10833 (depth = 8)
  gc_frame_newslot(strlit10833);
// Begin line 3313
  setline(3313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10835 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10834);
// compiled call node returning call10835 (depth = 9)
// compiled member node returning call10835 (depth = 8)
  gc_frame_newslot(call10835);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10836 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10837 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10836);
// compiled call node returning call10837 (depth = 9)
// compiled member node returning call10837 (depth = 8)
  gc_frame_newslot(call10837);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit10833;
  params[1] = call10835;
  params[2] = call10837;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10838 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10832);
// compiled call node returning call10838 (depth = 7)
    gc_frame_newslot(call10838);
    if10781 = call10838;
  } else {
  }
// compiled if node returning if10781 (depth = 6)
// Begin line 3315
  setline(3315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10840 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10839);
// compiled call node returning call10840 (depth = 8)
// compiled member node returning call10840 (depth = 7)
  *var_val = call10840;
  if (call10840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3316
  setline(3316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10841 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call10843 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe10842);
// compiled call node returning call10843 (depth = 8)
// compiled member node returning call10843 (depth = 7)
  gc_frame_newslot(call10843);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10844 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call10845 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10844);
// compiled call node returning call10845 (depth = 8)
// compiled member node returning call10845 (depth = 7)
  gc_frame_newslot(call10845);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call10843;
  params[1] = call10845;
  partcv[0] = 2;
  Object call10846 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10841);
// compiled call node returning call10846 (depth = 6)
// Begin line 3317
  setline(3317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10847 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_val (depth = 8)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10848 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call10849 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe10848);
// compiled call node returning call10849 (depth = 9)
// compiled member node returning call10849 (depth = 8)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call10850 = callmethod(call10849, "new",
    1, partcv, params);
  gc_frame_end(callframe10847);
// compiled call node returning call10850 (depth = 7)
  *var_o = call10850;
  if (call10850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3318
  setline(3318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10851 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10852 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10851);
// compiled call node returning call10852 (depth = 6)
    gc_frame_newslot(call10852);
    if10710 = call10852;
  } else {
  }
// compiled if node returning if10710 (depth = 5)
  gc_frame_end(frame);
  return if10710;
}
Object meth_parser_statement10608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_indentFreePass = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_oldLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldLine");
// Begin line 3261
  setline(3261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10610 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10609);
// compiled call node returning call10610 (depth = 4)
// compiled member node returning call10610 (depth = 3)
  *var_statementIndent = call10610;
  if (call10610 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3263
  setline(3263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10613 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10614 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10613);
// compiled call node returning call10614 (depth = 3)
// compiled member node returning call10614 (depth = 2)
// Begin line 3265
  setline(3265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10616 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10617 == NULL) {
    strlit10617 = alloc_String("keyword");
    gc_root(strlit10617);
  }
// compiled string node returning strlit10617 (depth = 4)
  gc_frame_newslot(strlit10617);
// call case 4: self request
  params[0] = strlit10617;
  partcv[0] = 1;
  Object call10618 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10616);
// compiled call node returning call10618 (depth = 3)
  Object if10615 = done;
  if (istrue(call10618)) {
// Begin line 3266
  setline(3266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10621 == NULL) {
    strlit10621 = alloc_String("var");
    gc_root(strlit10621);
  }
// compiled string node returning strlit10621 (depth = 5)
  int op_slot_right_10620 = gc_frame_newslot(strlit10621);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10624 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10623);
// compiled call node returning call10624 (depth = 6)
// compiled member node returning call10624 (depth = 5)
  int op_slot_left_10620 = gc_frame_newslot(call10624);
  params[0] = strlit10621;
  partcv[0] = 1;
  Object opresult10625 = callmethod(call10624, "==", 1, partcv, params);
// compiled op node returning opresult10625 (depth = 4)
  Object if10619 = done;
  if (istrue(opresult10625)) {
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10626 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10627 = callmethodflags(self, "vardec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10626);
// compiled call node returning call10627 (depth = 5)
// compiled member node returning call10627 (depth = 4)
    gc_frame_newslot(call10627);
    if10619 = call10627;
  } else {
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10630 == NULL) {
    strlit10630 = alloc_String("def");
    gc_root(strlit10630);
  }
// compiled string node returning strlit10630 (depth = 6)
  int op_slot_right_10629 = gc_frame_newslot(strlit10630);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10633 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10632);
// compiled call node returning call10633 (depth = 7)
// compiled member node returning call10633 (depth = 6)
  int op_slot_left_10629 = gc_frame_newslot(call10633);
  params[0] = strlit10630;
  partcv[0] = 1;
  Object opresult10634 = callmethod(call10633, "==", 1, partcv, params);
// compiled op node returning opresult10634 (depth = 5)
  Object if10628 = done;
  if (istrue(opresult10634)) {
// Begin line 3269
  setline(3269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10635 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10636 = callmethodflags(self, "defdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10635);
// compiled call node returning call10636 (depth = 6)
// compiled member node returning call10636 (depth = 5)
    gc_frame_newslot(call10636);
    if10628 = call10636;
  } else {
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10639 == NULL) {
    strlit10639 = alloc_String("import");
    gc_root(strlit10639);
  }
// compiled string node returning strlit10639 (depth = 7)
  int op_slot_right_10638 = gc_frame_newslot(strlit10639);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10642 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10641);
// compiled call node returning call10642 (depth = 8)
// compiled member node returning call10642 (depth = 7)
  int op_slot_left_10638 = gc_frame_newslot(call10642);
  params[0] = strlit10639;
  partcv[0] = 1;
  Object opresult10643 = callmethod(call10642, "==", 1, partcv, params);
// compiled op node returning opresult10643 (depth = 6)
  Object if10637 = done;
  if (istrue(opresult10643)) {
// Begin line 3271
  setline(3271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10644 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10645 = callmethodflags(self, "doimport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10644);
// compiled call node returning call10645 (depth = 7)
// compiled member node returning call10645 (depth = 6)
    gc_frame_newslot(call10645);
    if10637 = call10645;
  } else {
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10648 == NULL) {
    strlit10648 = alloc_String("dialect");
    gc_root(strlit10648);
  }
// compiled string node returning strlit10648 (depth = 8)
  int op_slot_right_10647 = gc_frame_newslot(strlit10648);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10651 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10650);
// compiled call node returning call10651 (depth = 9)
// compiled member node returning call10651 (depth = 8)
  int op_slot_left_10647 = gc_frame_newslot(call10651);
  params[0] = strlit10648;
  partcv[0] = 1;
  Object opresult10652 = callmethod(call10651, "==", 1, partcv, params);
// compiled op node returning opresult10652 (depth = 7)
  Object if10646 = done;
  if (istrue(opresult10652)) {
// Begin line 3273
  setline(3273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10653 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10654 = callmethodflags(self, "dodialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10653);
// compiled call node returning call10654 (depth = 8)
// compiled member node returning call10654 (depth = 7)
    gc_frame_newslot(call10654);
    if10646 = call10654;
  } else {
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10657 == NULL) {
    strlit10657 = alloc_String("type");
    gc_root(strlit10657);
  }
// compiled string node returning strlit10657 (depth = 9)
  int op_slot_right_10656 = gc_frame_newslot(strlit10657);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10660 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10659);
// compiled call node returning call10660 (depth = 10)
// compiled member node returning call10660 (depth = 9)
  int op_slot_left_10656 = gc_frame_newslot(call10660);
  params[0] = strlit10657;
  partcv[0] = 1;
  Object opresult10661 = callmethod(call10660, "==", 1, partcv, params);
// compiled op node returning opresult10661 (depth = 8)
  Object if10655 = done;
  if (istrue(opresult10661)) {
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10662 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10663 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10662);
// compiled call node returning call10663 (depth = 9)
// compiled member node returning call10663 (depth = 8)
    gc_frame_newslot(call10663);
    if10655 = call10663;
  } else {
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10666 == NULL) {
    strlit10666 = alloc_String("class");
    gc_root(strlit10666);
  }
// compiled string node returning strlit10666 (depth = 10)
  int op_slot_right_10665 = gc_frame_newslot(strlit10666);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10669 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10668);
// compiled call node returning call10669 (depth = 11)
// compiled member node returning call10669 (depth = 10)
  int op_slot_left_10665 = gc_frame_newslot(call10669);
  params[0] = strlit10666;
  partcv[0] = 1;
  Object opresult10670 = callmethod(call10669, "==", 1, partcv, params);
// compiled op node returning opresult10670 (depth = 9)
  Object if10664 = done;
  if (istrue(opresult10670)) {
// Begin line 3277
  setline(3277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10672 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10671);
// compiled call node returning call10672 (depth = 10)
// compiled member node returning call10672 (depth = 9)
    gc_frame_newslot(call10672);
    if10664 = call10672;
  } else {
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10675 == NULL) {
    strlit10675 = alloc_String("trait");
    gc_root(strlit10675);
  }
// compiled string node returning strlit10675 (depth = 11)
  int op_slot_right_10674 = gc_frame_newslot(strlit10675);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call10678 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10677);
// compiled call node returning call10678 (depth = 12)
// compiled member node returning call10678 (depth = 11)
  int op_slot_left_10674 = gc_frame_newslot(call10678);
  params[0] = strlit10675;
  partcv[0] = 1;
  Object opresult10679 = callmethod(call10678, "==", 1, partcv, params);
// compiled op node returning opresult10679 (depth = 10)
  Object if10673 = done;
  if (istrue(opresult10679)) {
// Begin line 3279
  setline(3279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10680 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10681 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10680);
// compiled call node returning call10681 (depth = 11)
// compiled member node returning call10681 (depth = 10)
    gc_frame_newslot(call10681);
    if10673 = call10681;
  } else {
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10684 == NULL) {
    strlit10684 = alloc_String("factory");
    gc_root(strlit10684);
  }
// compiled string node returning strlit10684 (depth = 12)
  int op_slot_right_10683 = gc_frame_newslot(strlit10684);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10686 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call10687 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10686);
// compiled call node returning call10687 (depth = 13)
// compiled member node returning call10687 (depth = 12)
  int op_slot_left_10683 = gc_frame_newslot(call10687);
  params[0] = strlit10684;
  partcv[0] = 1;
  Object opresult10688 = callmethod(call10687, "==", 1, partcv, params);
// compiled op node returning opresult10688 (depth = 11)
  Object if10682 = done;
  if (istrue(opresult10688)) {
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10689 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10690 = callmethodflags(self, "dofactoryMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10689);
// compiled call node returning call10690 (depth = 12)
// compiled member node returning call10690 (depth = 11)
    gc_frame_newslot(call10690);
    if10682 = call10690;
  } else {
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit10693 == NULL) {
    strlit10693 = alloc_String("return");
    gc_root(strlit10693);
  }
// compiled string node returning strlit10693 (depth = 13)
  int op_slot_right_10692 = gc_frame_newslot(strlit10693);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_sym (depth = 15)
  partcv[0] = 0;
  Object call10696 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10695);
// compiled call node returning call10696 (depth = 14)
// compiled member node returning call10696 (depth = 13)
  int op_slot_left_10692 = gc_frame_newslot(call10696);
  params[0] = strlit10693;
  partcv[0] = 1;
  Object opresult10697 = callmethod(call10696, "==", 1, partcv, params);
// compiled op node returning opresult10697 (depth = 12)
  Object if10691 = done;
  if (istrue(opresult10697)) {
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10699 = callmethodflags(self, "doreturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10698);
// compiled call node returning call10699 (depth = 13)
// compiled member node returning call10699 (depth = 12)
    gc_frame_newslot(call10699);
    if10691 = call10699;
  } else {
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe10700 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10701 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10700);
// compiled call node returning call10701 (depth = 12)
    gc_frame_newslot(call10701);
    if10691 = call10701;
  }
// compiled if node returning if10691 (depth = 11)
    gc_frame_newslot(if10691);
    if10682 = if10691;
  }
// compiled if node returning if10682 (depth = 10)
    gc_frame_newslot(if10682);
    if10673 = if10682;
  }
// compiled if node returning if10673 (depth = 9)
    gc_frame_newslot(if10673);
    if10664 = if10673;
  }
// compiled if node returning if10664 (depth = 8)
    gc_frame_newslot(if10664);
    if10655 = if10664;
  }
// compiled if node returning if10655 (depth = 7)
    gc_frame_newslot(if10655);
    if10646 = if10655;
  }
// compiled if node returning if10646 (depth = 6)
    gc_frame_newslot(if10646);
    if10637 = if10646;
  }
// compiled if node returning if10637 (depth = 5)
    gc_frame_newslot(if10637);
    if10628 = if10637;
  }
// compiled if node returning if10628 (depth = 4)
    gc_frame_newslot(if10628);
    if10619 = if10628;
  }
// compiled if node returning if10619 (depth = 3)
    gc_frame_newslot(if10619);
    if10615 = if10619;
  } else {
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10702 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10703 = alloc_Block(NULL, NULL, "parser", 3288);
  gc_frame_newslot(block10703);
// method "_apply"
  block_savedest(block10703);
  Object closure10704 = createclosure(2, "_apply");
  setclosureframe(closure10704, stackframe);
  addtoclosure(closure10704, var_blocksOK);
  addtoclosure(closure10704, selfslot);
  struct UserObject *uo10704 = (struct UserObject*)block10703;
  uo10704->data[0] = (Object)closure10704;
  Method *meth_meth_parser__apply10704 = addmethod2pos(block10703, "_apply", &meth_parser__apply10704, 0);
  int argcv_meth_parser__apply10704[] = {0};
  meth_meth_parser__apply10704->type = alloc_MethodType(1, argcv_meth_parser__apply10704);
  meth_meth_parser__apply10704->definitionModule = modulename;
  meth_meth_parser__apply10704->definitionLine = 3283;
// compiled block node returning block10703 (depth = 4)
  gc_frame_newslot(block10703);
// starting to compile block node (depth = 4)
  Object block10708 = alloc_Block(NULL, NULL, "parser", 3288);
  gc_frame_newslot(block10708);
// method "_apply"
  block_savedest(block10708);
  Object closure10709 = createclosure(9, "_apply");
  setclosureframe(closure10709, stackframe);
  addtoclosure(closure10709, var_values);
  addtoclosure(closure10709, var_sym);
  addtoclosure(closure10709, var_blocksOK);
  addtoclosure(closure10709, var_errormessages);
  addtoclosure(closure10709, var_lastToken);
  addtoclosure(closure10709, var_btok);
  addtoclosure(closure10709, var_util);
  addtoclosure(closure10709, var_ast);
  addtoclosure(closure10709, selfslot);
  struct UserObject *uo10709 = (struct UserObject*)block10708;
  uo10709->data[0] = (Object)closure10709;
  Method *meth_meth_parser__apply10709 = addmethod2pos(block10708, "_apply", &meth_parser__apply10709, 0);
  int argcv_meth_parser__apply10709[] = {0};
  meth_meth_parser__apply10709->type = alloc_MethodType(1, argcv_meth_parser__apply10709);
  meth_meth_parser__apply10709->definitionModule = modulename;
  meth_meth_parser__apply10709->definitionLine = 3283;
// compiled block node returning block10708 (depth = 4)
  gc_frame_newslot(block10708);
// call case 4: self request
  params[0] = block10703;
  params[1] = block10708;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10854 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10702);
// compiled call node returning call10854 (depth = 3)
    gc_frame_newslot(call10854);
    if10615 = call10854;
  }
// compiled if node returning if10615 (depth = 2)
// Begin line 3322
  setline(3322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10856 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10855);
// compiled call node returning call10856 (depth = 3)
// compiled member node returning call10856 (depth = 2)
// Begin line 3323
  setline(3323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10858 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10859 == NULL) {
    strlit10859 = alloc_String("eof");
    gc_root(strlit10859);
  }
// compiled string node returning strlit10859 (depth = 4)
  gc_frame_newslot(strlit10859);
// call case 4: self request
  params[0] = strlit10859;
  partcv[0] = 1;
  Object call10860 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10858);
// compiled call node returning call10860 (depth = 3)
  Object if10857 = done;
  if (istrue(call10860)) {
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10861 = alloc_Boolean(1);
// compiled identifier node returning bool10861 (depth = 4)
  return bool10861;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10857 = undefined;
  } else {
  }
// compiled if node returning if10857 (depth = 2)
// Begin line 3326
  setline(3326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10863 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10864 == NULL) {
    strlit10864 = alloc_String("semicolon");
    gc_root(strlit10864);
  }
// compiled string node returning strlit10864 (depth = 4)
  gc_frame_newslot(strlit10864);
// call case 4: self request
  params[0] = strlit10864;
  partcv[0] = 1;
  Object call10865 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10863);
// compiled call node returning call10865 (depth = 3)
  Object if10862 = done;
  if (istrue(call10865)) {
// Begin line 3327
  setline(3327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10867 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10866);
// compiled call node returning call10867 (depth = 5)
// compiled member node returning call10867 (depth = 4)
  *var_oldLine = call10867;
  if (call10867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10869 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10868);
// compiled call node returning call10869 (depth = 4)
// compiled member node returning call10869 (depth = 3)
// Begin line 3329
  setline(3329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_10871 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10874 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10873);
// compiled call node returning call10874 (depth = 6)
// compiled member node returning call10874 (depth = 5)
  int op_slot_left_10871 = gc_frame_newslot(call10874);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult10875 = callmethod(call10874, "==", 1, partcv, params);
// compiled op node returning opresult10875 (depth = 4)
  Object if10870 = done;
  if (istrue(opresult10875)) {
// Begin line 3330
  setline(3330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool10876 = alloc_Boolean(1);
// compiled identifier node returning bool10876 (depth = 5)
  *var_indentFreePass = bool10876;
  if (bool10876 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10870 = done;
  } else {
  }
// compiled if node returning if10870 (depth = 3)
    gc_frame_newslot(if10870);
    if10862 = if10870;
  } else {
// Begin line 3333
  setline(3333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10879 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10878);
// compiled call node returning call10879 (depth = 4)
// compiled member node returning call10879 (depth = 3)
    gc_frame_newslot(call10879);
    if10862 = call10879;
  }
// compiled if node returning if10862 (depth = 2)
  gc_frame_end(frame);
  return if10862;
}
Object meth_parser__apply10938(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_previousCommentToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 3353
  setline(3353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  *var_previousCommentToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call10941 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe10940);
// compiled call node returning call10941 (depth = 6)
// compiled member node returning call10941 (depth = 5)
  *var_sym = call10941;
  if (call10941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3355
  setline(3355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10946 = alloc_Float64(1);
// compiled num node returning num10946 (depth = 7)
  int op_slot_right_10945 = gc_frame_newslot(num10946);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10948 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_previousCommentToken (depth = 9)
  partcv[0] = 0;
  Object call10949 = callmethod(*var_previousCommentToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10948);
// compiled call node returning call10949 (depth = 8)
// compiled member node returning call10949 (depth = 7)
  int op_slot_left_10945 = gc_frame_newslot(call10949);
  params[0] = num10946;
  partcv[0] = 1;
  Object sum10950 = callmethod(call10949, "+", 1, partcv, params);
// compiled op node returning sum10950 (depth = 6)
  int op_slot_right_10944 = gc_frame_newslot(sum10950);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10952 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10953 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10952);
// compiled call node returning call10953 (depth = 7)
// compiled member node returning call10953 (depth = 6)
  int op_slot_left_10944 = gc_frame_newslot(call10953);
  params[0] = sum10950;
  partcv[0] = 1;
  Object opresult10954 = callmethod(call10953, ">", 1, partcv, params);
// compiled op node returning opresult10954 (depth = 5)
  Object if10943 = done;
  if (istrue(opresult10954)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10955 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10956 = callmethodflags(self, "noteBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10955);
// compiled call node returning call10956 (depth = 6)
// compiled member node returning call10956 (depth = 5)
    gc_frame_newslot(call10956);
    if10943 = call10956;
  } else {
  }
// compiled if node returning if10943 (depth = 4)
// Begin line 3356
  setline(3356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10957 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10958 == NULL) {
    strlit10958 = alloc_String("comment");
    gc_root(strlit10958);
  }
// compiled string node returning strlit10958 (depth = 5)
  gc_frame_newslot(strlit10958);
// call case 4: self request
  params[0] = strlit10958;
  partcv[0] = 1;
  Object call10959 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10957);
// compiled call node returning call10959 (depth = 4)
  gc_frame_end(frame);
  return call10959;
}
Object meth_parser__apply10962(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_o = getfromclosure(closure, 3);
  Object *var_comments = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3358
  setline(3358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10963 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10965 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10964);
// compiled call node returning call10965 (depth = 6)
// compiled member node returning call10965 (depth = 5)
  gc_frame_newslot(call10965);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10966 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10967 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10966);
// compiled call node returning call10967 (depth = 6)
// compiled member node returning call10967 (depth = 5)
  gc_frame_newslot(call10967);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call10965;
  params[1] = call10967;
  partcv[0] = 2;
  Object call10968 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10963);
// compiled call node returning call10968 (depth = 4)
// Begin line 3359
  setline(3359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10969 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10971 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10970);
// compiled call node returning call10971 (depth = 7)
// compiled member node returning call10971 (depth = 6)
  gc_frame_newslot(call10971);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call10973 = callmethod(*var_ast, "commentNode",
    1, partcv, params);
  gc_frame_end(callframe10972);
// compiled call node returning call10973 (depth = 7)
// compiled member node returning call10973 (depth = 6)
  params[0] = call10971;
  partcv[0] = 1;
  Object call10974 = callmethod(call10973, "new",
    1, partcv, params);
  gc_frame_end(callframe10969);
// compiled call node returning call10974 (depth = 5)
  *var_o = call10974;
  if (call10974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10979 = alloc_Float64(1);
// compiled num node returning num10979 (depth = 7)
  int op_slot_right_10978 = gc_frame_newslot(num10979);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10982 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10981);
// compiled call node returning call10982 (depth = 8)
// compiled member node returning call10982 (depth = 7)
  int op_slot_left_10978 = gc_frame_newslot(call10982);
  params[0] = num10979;
  partcv[0] = 1;
  Object diff10983 = callmethod(call10982, "-", 1, partcv, params);
// compiled op node returning diff10983 (depth = 6)
  int op_slot_right_10977 = gc_frame_newslot(diff10983);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10985 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10986 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comments (depth = 10)
  partcv[0] = 0;
  Object call10987 = callmethod(*var_comments, "last",
    1, partcv, params);
  gc_frame_end(callframe10986);
// compiled call node returning call10987 (depth = 9)
// compiled member node returning call10987 (depth = 8)
  partcv[0] = 0;
  Object call10988 = callmethod(call10987, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10985);
// compiled call node returning call10988 (depth = 7)
// compiled member node returning call10988 (depth = 6)
  int op_slot_left_10977 = gc_frame_newslot(call10988);
  params[0] = diff10983;
  partcv[0] = 1;
  Object opresult10989 = callmethod(call10988, "==", 1, partcv, params);
// compiled op node returning opresult10989 (depth = 5)
  Object if10976 = done;
  if (istrue(opresult10989)) {
// Begin line 3361
  setline(3361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10990 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10991 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  partcv[0] = 0;
  Object call10992 = callmethod(*var_comments, "last",
    1, partcv, params);
  gc_frame_end(callframe10991);
// compiled call node returning call10992 (depth = 7)
// compiled member node returning call10992 (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10993 = callmethod(call10992, "extendCommentUsing",
    1, partcv, params);
  gc_frame_end(callframe10990);
// compiled call node returning call10993 (depth = 5)
    gc_frame_newslot(call10993);
    if10976 = call10993;
  } else {
// Begin line 3363
  setline(3363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10994 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10995 = callmethod(*var_comments, "push",
    1, partcv, params);
  gc_frame_end(callframe10994);
// compiled call node returning call10995 (depth = 5)
// Begin line 3364
  setline(3364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10999 = alloc_Float64(1);
// compiled num node returning num10999 (depth = 8)
  int op_slot_right_10998 = gc_frame_newslot(num10999);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11001 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11002 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11001);
// compiled call node returning call11002 (depth = 9)
// compiled member node returning call11002 (depth = 8)
  int op_slot_left_10998 = gc_frame_newslot(call11002);
  params[0] = num10999;
  partcv[0] = 1;
  Object diff11003 = callmethod(call11002, "-", 1, partcv, params);
// compiled op node returning diff11003 (depth = 7)
  int op_slot_right_10997 = gc_frame_newslot(diff11003);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call11006 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11005);
// compiled call node returning call11006 (depth = 8)
// compiled member node returning call11006 (depth = 7)
  int op_slot_left_10997 = gc_frame_newslot(call11006);
  params[0] = diff11003;
  partcv[0] = 1;
  Object opresult11007 = callmethod(call11006, "<", 1, partcv, params);
// compiled op node returning opresult11007 (depth = 6)
  Object if10996 = done;
  if (istrue(opresult11007)) {
// Begin line 3365
  setline(3365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11008 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool11009 = alloc_Boolean(1);
// compiled identifier node returning bool11009 (depth = 7)
  gc_frame_newslot(bool11009);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = bool11009;
  partcv[0] = 1;
  Object call11010 = callmethod(*var_o, "isPreceededByBlankLine:=",
    1, partcv, params);
  gc_frame_end(callframe11008);
// compiled call node returning call11010 (depth = 6)
    gc_frame_newslot(call11010);
    if10996 = call11010;
  } else {
  }
// compiled if node returning if10996 (depth = 5)
    gc_frame_newslot(if10996);
    if10976 = if10996;
  }
// compiled if node returning if10976 (depth = 4)
  gc_frame_end(frame);
  return if10976;
}
Object meth_parser_pushComments10880(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_comments = getfromclosure(closure, 5);
  Object *var_previousCommentToken = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushComments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushComments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 3343
  setline(3343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10882 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10883 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10884 == NULL) {
    strlit10884 = alloc_String("comment");
    gc_root(strlit10884);
  }
// compiled string node returning strlit10884 (depth = 5)
  gc_frame_newslot(strlit10884);
// call case 4: self request
  params[0] = strlit10884;
  partcv[0] = 1;
  Object call10885 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10883);
// compiled call node returning call10885 (depth = 4)
  partcv[0] = 0;
  Object call10886 = callmethod(call10885, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10882);
// compiled call node returning call10886 (depth = 3)
  Object if10881 = done;
  if (istrue(call10886)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10881 = undefined;
  } else {
  }
// compiled if node returning if10881 (depth = 2)
// Begin line 3344
  setline(3344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10887 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10889 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10888);
// compiled call node returning call10889 (depth = 4)
// compiled member node returning call10889 (depth = 3)
  gc_frame_newslot(call10889);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10891 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10890);
// compiled call node returning call10891 (depth = 4)
// compiled member node returning call10891 (depth = 3)
  gc_frame_newslot(call10891);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call10889;
  params[1] = call10891;
  partcv[0] = 2;
  Object call10892 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10887);
// compiled call node returning call10892 (depth = 2)
// Begin line 3345
  setline(3345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10893 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10895 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10894);
// compiled call node returning call10895 (depth = 5)
// compiled member node returning call10895 (depth = 4)
  gc_frame_newslot(call10895);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10896 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call10897 = callmethod(*var_ast, "commentNode",
    1, partcv, params);
  gc_frame_end(callframe10896);
// compiled call node returning call10897 (depth = 5)
// compiled member node returning call10897 (depth = 4)
  params[0] = call10895;
  partcv[0] = 1;
  Object call10898 = callmethod(call10897, "new",
    1, partcv, params);
  gc_frame_end(callframe10893);
// compiled call node returning call10898 (depth = 3)
  *var_o = call10898;
  if (call10898 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3346
  setline(3346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10902 == NULL) {
    strlit10902 = alloc_String("comment");
    gc_root(strlit10902);
  }
// compiled string node returning strlit10902 (depth = 5)
  int op_slot_right_10901 = gc_frame_newslot(strlit10902);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10905 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe10904);
// compiled call node returning call10905 (depth = 6)
// compiled member node returning call10905 (depth = 5)
  int op_slot_left_10901 = gc_frame_newslot(call10905);
  params[0] = strlit10902;
  partcv[0] = 1;
  Object opresult10906 = callmethod(call10905, "!=", 1, partcv, params);
// compiled op node returning opresult10906 (depth = 4)
  int op_slot_right_10900 = gc_frame_newslot(opresult10906);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10910 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10909);
// compiled call node returning call10910 (depth = 6)
// compiled member node returning call10910 (depth = 5)
  int op_slot_right_10908 = gc_frame_newslot(call10910);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10913 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10912);
// compiled call node returning call10913 (depth = 6)
// compiled member node returning call10913 (depth = 5)
  int op_slot_left_10908 = gc_frame_newslot(call10913);
  params[0] = call10910;
  partcv[0] = 1;
  Object opresult10914 = callmethod(call10913, "==", 1, partcv, params);
// compiled op node returning opresult10914 (depth = 4)
  int op_slot_left_10900 = gc_frame_newslot(opresult10914);
  params[0] = opresult10906;
  partcv[0] = 1;
  Object opresult10915 = callmethod(opresult10914, "&&", 1, partcv, params);
// compiled op node returning opresult10915 (depth = 3)
  Object if10899 = done;
  if (istrue(opresult10915)) {
// Begin line 3347
  setline(3347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10916 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10917 = alloc_Boolean(1);
// compiled identifier node returning bool10917 (depth = 4)
  gc_frame_newslot(bool10917);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool10917;
  partcv[0] = 1;
  Object call10918 = callmethod(*var_o, "isPartialLine:=",
    1, partcv, params);
  gc_frame_end(callframe10916);
// compiled call node returning call10918 (depth = 3)
    gc_frame_newslot(call10918);
    if10899 = call10918;
  } else {
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3348
  setline(3348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10922 = alloc_Float64(1);
// compiled num node returning num10922 (depth = 6)
  int op_slot_right_10921 = gc_frame_newslot(num10922);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10925 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10924);
// compiled call node returning call10925 (depth = 7)
// compiled member node returning call10925 (depth = 6)
  int op_slot_left_10921 = gc_frame_newslot(call10925);
  params[0] = num10922;
  partcv[0] = 1;
  Object diff10926 = callmethod(call10925, "-", 1, partcv, params);
// compiled op node returning diff10926 (depth = 5)
  int op_slot_right_10920 = gc_frame_newslot(diff10926);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10929 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10928);
// compiled call node returning call10929 (depth = 6)
// compiled member node returning call10929 (depth = 5)
  int op_slot_left_10920 = gc_frame_newslot(call10929);
  params[0] = diff10926;
  partcv[0] = 1;
  Object opresult10930 = callmethod(call10929, "<", 1, partcv, params);
// compiled op node returning opresult10930 (depth = 4)
  Object if10919 = done;
  if (istrue(opresult10930)) {
// Begin line 3349
  setline(3349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10931 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool10932 = alloc_Boolean(1);
// compiled identifier node returning bool10932 (depth = 5)
  gc_frame_newslot(bool10932);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool10932;
  partcv[0] = 1;
  Object call10933 = callmethod(*var_o, "isPreceededByBlankLine:=",
    1, partcv, params);
  gc_frame_end(callframe10931);
// compiled call node returning call10933 (depth = 4)
    gc_frame_newslot(call10933);
    if10919 = call10933;
  } else {
  }
// compiled if node returning if10919 (depth = 3)
    gc_frame_newslot(if10919);
    if10899 = if10919;
  }
// compiled if node returning if10899 (depth = 2)
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10934 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10935 = callmethod(*var_comments, "push",
    1, partcv, params);
  gc_frame_end(callframe10934);
// compiled call node returning call10935 (depth = 2)
// Begin line 3352
  setline(3352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10936 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10937 = alloc_Block(NULL, NULL, "parser", 3352);
  gc_frame_newslot(block10937);
// method "_apply"
  block_savedest(block10937);
  Object closure10938 = createclosure(4, "_apply");
  setclosureframe(closure10938, stackframe);
  addtoclosure(closure10938, var_sym);
  addtoclosure(closure10938, var_previousCommentToken);
  addtoclosure(closure10938, var_tokens);
  addtoclosure(closure10938, selfslot);
  struct UserObject *uo10938 = (struct UserObject*)block10937;
  uo10938->data[0] = (Object)closure10938;
  Method *meth_meth_parser__apply10938 = addmethod2pos(block10937, "_apply", &meth_parser__apply10938, 0);
  int argcv_meth_parser__apply10938[] = {0};
  meth_meth_parser__apply10938->type = alloc_MethodType(1, argcv_meth_parser__apply10938);
  meth_meth_parser__apply10938->definitionModule = modulename;
  meth_meth_parser__apply10938->definitionLine = 3348;
// compiled block node returning block10937 (depth = 3)
  gc_frame_newslot(block10937);
// Begin line 3357
  setline(3357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block10961 = alloc_Block(NULL, NULL, "parser", 3357);
  gc_frame_newslot(block10961);
// method "_apply"
  block_savedest(block10961);
  Object closure10962 = createclosure(7, "_apply");
  setclosureframe(closure10962, stackframe);
  addtoclosure(closure10962, var_sym);
  addtoclosure(closure10962, var_util);
  addtoclosure(closure10962, var_ast);
  addtoclosure(closure10962, var_o);
  addtoclosure(closure10962, var_comments);
  addtoclosure(closure10962, var_lastToken);
  addtoclosure(closure10962, selfslot);
  struct UserObject *uo10962 = (struct UserObject*)block10961;
  uo10962->data[0] = (Object)closure10962;
  Method *meth_meth_parser__apply10962 = addmethod2pos(block10961, "_apply", &meth_parser__apply10962, 0);
  int argcv_meth_parser__apply10962[] = {0};
  meth_meth_parser__apply10962->type = alloc_MethodType(1, argcv_meth_parser__apply10962);
  meth_meth_parser__apply10962->definitionModule = modulename;
  meth_meth_parser__apply10962->definitionLine = 3355;
// compiled block node returning block10961 (depth = 3)
  gc_frame_newslot(block10961);
// call case 5: prelude request
  params[0] = block10937;
  params[1] = block10961;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11012 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10936);
// compiled call node returning call11012 (depth = 2)
  gc_frame_end(frame);
  return call11012;
}
Object meth_parser__apply11042(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11044 = alloc_Float64(0);
// compiled num node returning num11044 (depth = 5)
  int op_slot_right_11043 = gc_frame_newslot(num11044);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_11043 = gc_frame_newslot(*var_ix);
  params[0] = num11044;
  partcv[0] = 1;
  Object opresult11046 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult11046 (depth = 4)
  gc_frame_end(frame);
  return opresult11046;
}
Object meth_parser__apply11049(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_comments = getfromclosure(closure, 1);
  Object *var_oLine = getfromclosure(closure, 2);
  Object *var_postComments = getfromclosure(closure, 3);
  Object *var_preComments = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
  Object *var_isPostComment = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isPostComment");
  Object *var_isPreComment = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isPreComment");
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11050 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call11051 = callmethod(*var_comments, "at",
    1, partcv, params);
  gc_frame_end(callframe11050);
// compiled call node returning call11051 (depth = 5)
  *var_each = call11051;
  if (call11051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3395
  setline(3395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11055 = alloc_Float64(1);
// compiled num node returning num11055 (depth = 8)
  int op_slot_right_11054 = gc_frame_newslot(num11055);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_11054 = gc_frame_newslot(*var_oLine);
  params[0] = num11055;
  partcv[0] = 1;
  Object sum11057 = callmethod(*var_oLine, "+", 1, partcv, params);
// compiled op node returning sum11057 (depth = 7)
  int op_slot_right_11053 = gc_frame_newslot(sum11057);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call11060 = callmethod(*var_each, "line",
    1, partcv, params);
  gc_frame_end(callframe11059);
// compiled call node returning call11060 (depth = 8)
// compiled member node returning call11060 (depth = 7)
  int op_slot_left_11053 = gc_frame_newslot(call11060);
  params[0] = sum11057;
  partcv[0] = 1;
  Object opresult11061 = callmethod(call11060, "==", 1, partcv, params);
// compiled op node returning opresult11061 (depth = 6)
  int op_slot_right_11052 = gc_frame_newslot(opresult11061);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oLine (depth = 7)
  int op_slot_right_11063 = gc_frame_newslot(*var_oLine);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call11066 = callmethod(*var_each, "line",
    1, partcv, params);
  gc_frame_end(callframe11065);
// compiled call node returning call11066 (depth = 8)
// compiled member node returning call11066 (depth = 7)
  int op_slot_left_11063 = gc_frame_newslot(call11066);
  params[0] = *var_oLine;
  partcv[0] = 1;
  Object opresult11067 = callmethod(call11066, "==", 1, partcv, params);
// compiled op node returning opresult11067 (depth = 6)
  int op_slot_left_11052 = gc_frame_newslot(opresult11067);
  params[0] = opresult11061;
  partcv[0] = 1;
  Object opresult11068 = callmethod(opresult11067, "||", 1, partcv, params);
// compiled op node returning opresult11068 (depth = 5)
  *var_isPostComment = opresult11068;
  if (opresult11068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3396
  setline(3396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11072 = alloc_Float64(1);
// compiled num node returning num11072 (depth = 8)
  int op_slot_right_11071 = gc_frame_newslot(num11072);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_11071 = gc_frame_newslot(*var_oLine);
  params[0] = num11072;
  partcv[0] = 1;
  Object diff11074 = callmethod(*var_oLine, "-", 1, partcv, params);
// compiled op node returning diff11074 (depth = 7)
  int op_slot_right_11070 = gc_frame_newslot(diff11074);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11076 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call11077 = callmethod(*var_each, "endLine",
    1, partcv, params);
  gc_frame_end(callframe11076);
// compiled call node returning call11077 (depth = 8)
// compiled member node returning call11077 (depth = 7)
  int op_slot_left_11070 = gc_frame_newslot(call11077);
  params[0] = diff11074;
  partcv[0] = 1;
  Object opresult11078 = callmethod(call11077, "==", 1, partcv, params);
// compiled op node returning opresult11078 (depth = 6)
  int op_slot_right_11069 = gc_frame_newslot(opresult11078);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call11081 = callmethod(*var_each, "isPreceededByBlankLine",
    1, partcv, params);
  gc_frame_end(callframe11080);
// compiled call node returning call11081 (depth = 7)
// compiled member node returning call11081 (depth = 6)
  int op_slot_left_11069 = gc_frame_newslot(call11081);
  params[0] = opresult11078;
  partcv[0] = 1;
  Object opresult11082 = callmethod(call11081, "&&", 1, partcv, params);
// compiled op node returning opresult11082 (depth = 5)
  *var_isPreComment = opresult11082;
  if (opresult11082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3397
  setline(3397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isPostComment (depth = 5)
  Object if11083 = done;
  if (istrue(*var_isPostComment)) {
// Begin line 3398
  setline(3398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11084 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe11085 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call11086 = callmethod(*var_comments, "removeAt",
    1, partcv, params);
  gc_frame_end(callframe11085);
// compiled call node returning call11086 (depth = 6)
  gc_frame_newslot(call11086);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_postComments (depth = 6)
  params[0] = call11086;
  partcv[0] = 1;
  Object call11087 = callmethod(*var_postComments, "push",
    1, partcv, params);
  gc_frame_end(callframe11084);
// compiled call node returning call11087 (depth = 5)
    gc_frame_newslot(call11087);
    if11083 = call11087;
  } else {
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isPreComment (depth = 6)
  Object if11088 = done;
  if (istrue(*var_isPreComment)) {
// Begin line 3400
  setline(3400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11089 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe11090 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call11091 = callmethod(*var_comments, "removeAt",
    1, partcv, params);
  gc_frame_end(callframe11090);
// compiled call node returning call11091 (depth = 7)
  gc_frame_newslot(call11091);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  params[0] = call11091;
  partcv[0] = 1;
  Object call11092 = callmethod(*var_preComments, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe11089);
// compiled call node returning call11092 (depth = 6)
    gc_frame_newslot(call11092);
    if11088 = call11092;
  } else {
// Begin line 3404
  setline(3404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num11096 = alloc_Float64(1);
// compiled num node returning num11096 (depth = 9)
  int op_slot_right_11095 = gc_frame_newslot(num11096);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oLine (depth = 9)
  int op_slot_left_11095 = gc_frame_newslot(*var_oLine);
  params[0] = num11096;
  partcv[0] = 1;
  Object diff11098 = callmethod(*var_oLine, "-", 1, partcv, params);
// compiled op node returning diff11098 (depth = 8)
  int op_slot_right_11094 = gc_frame_newslot(diff11098);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11100 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  partcv[0] = 0;
  Object call11101 = callmethod(*var_each, "endLine",
    1, partcv, params);
  gc_frame_end(callframe11100);
// compiled call node returning call11101 (depth = 9)
// compiled member node returning call11101 (depth = 8)
  int op_slot_left_11094 = gc_frame_newslot(call11101);
  params[0] = diff11098;
  partcv[0] = 1;
  Object opresult11102 = callmethod(call11101, "<", 1, partcv, params);
// compiled op node returning opresult11102 (depth = 7)
  Object if11093 = done;
  if (istrue(opresult11102)) {
// Begin line 3402
  setline(3402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11103 = alloc_Float64(0);
// compiled num node returning num11103 (depth = 8)
  *var_ix = num11103;
  if (num11103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if11093 = done;
  } else {
  }
// compiled if node returning if11093 (depth = 6)
    gc_frame_newslot(if11093);
    if11088 = if11093;
  }
// compiled if node returning if11088 (depth = 5)
    gc_frame_newslot(if11088);
    if11083 = if11088;
  }
// compiled if node returning if11083 (depth = 4)
// Begin line 3404
  setline(3404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num11106 = alloc_Float64(1);
// compiled num node returning num11106 (depth = 6)
  int op_slot_right_11105 = gc_frame_newslot(num11106);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_11105 = gc_frame_newslot(*var_ix);
  params[0] = num11106;
  partcv[0] = 1;
  Object diff11108 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff11108 (depth = 5)
  *var_ix = diff11108;
  if (diff11108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_reconcileComments11013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reconcileComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_comments = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reconcileComments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reconcileComments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
  Object *var_oLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oLine");
  Object *var_preComments = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "preComments");
  Object *var_postComments = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "postComments");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_postSz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "postSz");
  Object *var_preSz = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "preSz");
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11014 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11015 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11014);
// compiled call node returning call11015 (depth = 3)
// compiled member node returning call11015 (depth = 2)
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11017 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call11018 = callmethod(*var_values, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe11017);
// compiled call node returning call11018 (depth = 5)
// compiled member node returning call11018 (depth = 4)
  Object if11016 = done;
struct StackFrameObject *iftmpstackframe11016 = stackframe;
  if (istrue(call11018)) {
stackframe = alloc_StackFrame(0, iftmpstackframe11016);
gc_frame_newslot((Object)stackframe);
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
    gc_frame_newslot(*var_moduleObject);
    if11016 = *var_moduleObject;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe11016);
  gc_frame_newslot((Object)stackframe);
// Begin line 3381
  setline(3381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call11020 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11019);
// compiled call node returning call11020 (depth = 5)
// compiled member node returning call11020 (depth = 4)
    gc_frame_newslot(call11020);
    if11016 = call11020;
  }
stackframe = iftmpstackframe11016;
// compiled if node returning if11016 (depth = 3)
  *var_node = if11016;
  if (if11016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11023 == NULL) {
    strlit11023 = alloc_String("lbrace");
    gc_root(strlit11023);
  }
// compiled string node returning strlit11023 (depth = 4)
  int op_slot_right_11022 = gc_frame_newslot(strlit11023);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_node (depth = 6)
  partcv[0] = 0;
  Object call11026 = callmethod(*var_node, "kind",
    1, partcv, params);
  gc_frame_end(callframe11025);
// compiled call node returning call11026 (depth = 5)
// compiled member node returning call11026 (depth = 4)
  int op_slot_left_11022 = gc_frame_newslot(call11026);
  params[0] = strlit11023;
  partcv[0] = 1;
  Object opresult11027 = callmethod(call11026, "==", 1, partcv, params);
// compiled op node returning opresult11027 (depth = 3)
  Object if11021 = done;
  if (istrue(opresult11027)) {
// Begin line 3386
  setline(3386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 3387
  setline(3387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11021 = undefined;
  } else {
  }
// compiled if node returning if11021 (depth = 2)
// Begin line 3388
  setline(3388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call11029 = callmethod(*var_node, "line",
    1, partcv, params);
  gc_frame_end(callframe11028);
// compiled call node returning call11029 (depth = 4)
// compiled member node returning call11029 (depth = 3)
  *var_oLine = call11029;
  if (call11029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11030 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11031 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11032 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11031);
// compiled call node returning call11032 (depth = 6)
// compiled member node returning call11032 (depth = 5)
  partcv[0] = 0;
  Object call11033 = callmethod(call11032, "empty",
    1, partcv, params);
  gc_frame_end(callframe11030);
// compiled call node returning call11033 (depth = 4)
// compiled member node returning call11033 (depth = 3)
  *var_preComments = call11033;
  if (call11033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3390
  setline(3390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11034 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11035 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11036 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11035);
// compiled call node returning call11036 (depth = 6)
// compiled member node returning call11036 (depth = 5)
  partcv[0] = 0;
  Object call11037 = callmethod(call11036, "empty",
    1, partcv, params);
  gc_frame_end(callframe11034);
// compiled call node returning call11037 (depth = 4)
// compiled member node returning call11037 (depth = 3)
  *var_postComments = call11037;
  if (call11037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_comments (depth = 5)
  partcv[0] = 0;
  Object call11039 = callmethod(*var_comments, "size",
    1, partcv, params);
  gc_frame_end(callframe11038);
// compiled call node returning call11039 (depth = 4)
// compiled member node returning call11039 (depth = 3)
  *var_ix = call11039;
  if (call11039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3393
  setline(3393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11040 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block11041 = alloc_Block(NULL, NULL, "parser", 3393);
  gc_frame_newslot(block11041);
// method "_apply"
  block_savedest(block11041);
  Object closure11042 = createclosure(2, "_apply");
  setclosureframe(closure11042, stackframe);
  addtoclosure(closure11042, var_ix);
  addtoclosure(closure11042, selfslot);
  struct UserObject *uo11042 = (struct UserObject*)block11041;
  uo11042->data[0] = (Object)closure11042;
  Method *meth_meth_parser__apply11042 = addmethod2pos(block11041, "_apply", &meth_parser__apply11042, 0);
  int argcv_meth_parser__apply11042[] = {0};
  meth_meth_parser__apply11042->type = alloc_MethodType(1, argcv_meth_parser__apply11042);
  meth_meth_parser__apply11042->definitionModule = modulename;
  meth_meth_parser__apply11042->definitionLine = 3392;
// compiled block node returning block11041 (depth = 3)
  gc_frame_newslot(block11041);
// starting to compile block node (depth = 3)
  Object block11048 = alloc_Block(NULL, NULL, "parser", 3393);
  gc_frame_newslot(block11048);
// method "_apply"
  block_savedest(block11048);
  Object closure11049 = createclosure(6, "_apply");
  setclosureframe(closure11049, stackframe);
  addtoclosure(closure11049, var_ix);
  addtoclosure(closure11049, var_comments);
  addtoclosure(closure11049, var_oLine);
  addtoclosure(closure11049, var_postComments);
  addtoclosure(closure11049, var_preComments);
  addtoclosure(closure11049, selfslot);
  struct UserObject *uo11049 = (struct UserObject*)block11048;
  uo11049->data[0] = (Object)closure11049;
  Method *meth_meth_parser__apply11049 = addmethod2pos(block11048, "_apply", &meth_parser__apply11049, 0);
  int argcv_meth_parser__apply11049[] = {0};
  meth_meth_parser__apply11049->type = alloc_MethodType(1, argcv_meth_parser__apply11049);
  meth_meth_parser__apply11049->definitionModule = modulename;
  meth_meth_parser__apply11049->definitionLine = 3392;
// compiled block node returning block11048 (depth = 3)
  gc_frame_newslot(block11048);
// call case 5: prelude request
  params[0] = block11041;
  params[1] = block11048;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11111 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11040);
// compiled call node returning call11111 (depth = 2)
// Begin line 3407
  setline(3407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11112 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postComments (depth = 5)
  partcv[0] = 0;
  Object call11113 = callmethod(*var_postComments, "size",
    1, partcv, params);
  gc_frame_end(callframe11112);
// compiled call node returning call11113 (depth = 4)
// compiled member node returning call11113 (depth = 3)
  *var_postSz = call11113;
  if (call11113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3408
  setline(3408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preComments (depth = 5)
  partcv[0] = 0;
  Object call11115 = callmethod(*var_preComments, "size",
    1, partcv, params);
  gc_frame_end(callframe11114);
// compiled call node returning call11115 (depth = 4)
// compiled member node returning call11115 (depth = 3)
  *var_preSz = call11115;
  if (call11115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3410
  setline(3410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11119 = alloc_Float64(1);
// compiled num node returning num11119 (depth = 5)
  int op_slot_right_11118 = gc_frame_newslot(num11119);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preSz (depth = 5)
  int op_slot_left_11118 = gc_frame_newslot(*var_preSz);
  params[0] = num11119;
  partcv[0] = 1;
  Object opresult11121 = callmethod(*var_preSz, ">", 1, partcv, params);
// compiled op node returning opresult11121 (depth = 4)
  int op_slot_right_11117 = gc_frame_newslot(opresult11121);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11124 = alloc_Float64(1);
// compiled num node returning num11124 (depth = 5)
  int op_slot_right_11123 = gc_frame_newslot(num11124);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postSz (depth = 5)
  int op_slot_left_11123 = gc_frame_newslot(*var_postSz);
  params[0] = num11124;
  partcv[0] = 1;
  Object opresult11126 = callmethod(*var_postSz, ">", 1, partcv, params);
// compiled op node returning opresult11126 (depth = 4)
  int op_slot_left_11117 = gc_frame_newslot(opresult11126);
  params[0] = opresult11121;
  partcv[0] = 1;
  Object opresult11127 = callmethod(opresult11126, "&&", 1, partcv, params);
// compiled op node returning opresult11127 (depth = 3)
  Object if11116 = done;
  if (istrue(opresult11127)) {
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11128 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11130 == NULL) {
    strlit11130 = alloc_String("""\x0a""");
    gc_root(strlit11130);
  }
// compiled string node returning strlit11130 (depth = 5)
  int op_slot_right_11129 = gc_frame_newslot(strlit11130);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11132 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11133 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_preComments (depth = 9)
  partcv[0] = 0;
  Object call11134 = callmethod(*var_preComments, "last",
    1, partcv, params);
  gc_frame_end(callframe11133);
// compiled call node returning call11134 (depth = 8)
// compiled member node returning call11134 (depth = 7)
  partcv[0] = 0;
  Object call11135 = callmethod(call11134, "value",
    1, partcv, params);
  gc_frame_end(callframe11132);
// compiled call node returning call11135 (depth = 6)
// compiled member node returning call11135 (depth = 5)
  int op_slot_left_11129 = gc_frame_newslot(call11135);
  params[0] = strlit11130;
  partcv[0] = 1;
  Object opresult11136 = callmethod(call11135, "++", 1, partcv, params);
// compiled op node returning opresult11136 (depth = 4)
  gc_frame_newslot(opresult11136);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_preComments (depth = 6)
  partcv[0] = 0;
  Object call11138 = callmethod(*var_preComments, "last",
    1, partcv, params);
  gc_frame_end(callframe11137);
// compiled call node returning call11138 (depth = 5)
// compiled member node returning call11138 (depth = 4)
  params[0] = opresult11136;
  partcv[0] = 1;
  Object call11139 = callmethod(call11138, "value:=",
    1, partcv, params);
  gc_frame_end(callframe11128);
// compiled call node returning call11139 (depth = 3)
    gc_frame_newslot(call11139);
    if11116 = call11139;
  } else {
  }
// compiled if node returning if11116 (depth = 2)
// Begin line 3413
  setline(3413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11140 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_preComments (depth = 3)
  gc_frame_newslot(*var_preComments);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_preComments;
  partcv[0] = 1;
  Object call11141 = callmethod(*var_node, "addComments",
    1, partcv, params);
  gc_frame_end(callframe11140);
// compiled call node returning call11141 (depth = 2)
// Begin line 3414
  setline(3414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11142 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_postComments (depth = 3)
  gc_frame_newslot(*var_postComments);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_postComments;
  partcv[0] = 1;
  Object call11143 = callmethod(*var_node, "addComments",
    1, partcv, params);
  gc_frame_end(callframe11142);
// compiled call node returning call11143 (depth = 2)
  gc_frame_end(frame);
  return call11143;
}
Object meth_parser_checkBadOperators11144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkBadOperators (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkBadOperators");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3418
  setline(3418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11147 == NULL) {
    strlit11147 = alloc_String("=");
    gc_root(strlit11147);
  }
// compiled string node returning strlit11147 (depth = 4)
  int op_slot_right_11146 = gc_frame_newslot(strlit11147);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11150 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11149);
// compiled call node returning call11150 (depth = 5)
// compiled member node returning call11150 (depth = 4)
  int op_slot_left_11146 = gc_frame_newslot(call11150);
  params[0] = strlit11147;
  partcv[0] = 1;
  Object opresult11151 = callmethod(call11150, "==", 1, partcv, params);
// compiled op node returning opresult11151 (depth = 3)
  Object if11145 = done;
  if (istrue(opresult11151)) {
// Begin line 3419
  setline(3419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11152 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11153 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11154 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11153);
// compiled call node returning call11154 (depth = 7)
// compiled member node returning call11154 (depth = 6)
  partcv[0] = 0;
  Object call11155 = callmethod(call11154, "new",
    1, partcv, params);
  gc_frame_end(callframe11152);
// compiled call node returning call11155 (depth = 5)
// compiled member node returning call11155 (depth = 4)
  *var_sugg = call11155;
  if (call11155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3420
  setline(3420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11156 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11157 == NULL) {
    strlit11157 = alloc_String("=");
    gc_root(strlit11157);
  }
// compiled string node returning strlit11157 (depth = 4)
  gc_frame_newslot(strlit11157);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11157;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11158 = callmethod(*var_sugg, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe11156);
// compiled call node returning call11158 (depth = 3)
// Begin line 3421
  setline(3421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11159 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11160 == NULL) {
    strlit11160 = alloc_String("use '==' to test equality, not '='.");
    gc_root(strlit11160);
  }
// compiled string node returning strlit11160 (depth = 4)
  gc_frame_newslot(strlit11160);
// Begin line 3422
  setline(3422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11162 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11161);
// compiled call node returning call11162 (depth = 5)
// compiled member node returning call11162 (depth = 4)
  gc_frame_newslot(call11162);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11163 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11164 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11163);
// compiled call node returning call11164 (depth = 5)
// compiled member node returning call11164 (depth = 4)
  gc_frame_newslot(call11164);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11165 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11166 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11165);
// compiled call node returning call11166 (depth = 5)
// compiled member node returning call11166 (depth = 4)
  gc_frame_newslot(call11166);
// Begin line 3423
  setline(3423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3421
  setline(3421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11160;
  params[1] = call11162;
  params[2] = call11164;
  params[3] = call11166;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11167 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11159);
// compiled call node returning call11167 (depth = 3)
    gc_frame_newslot(call11167);
    if11145 = call11167;
  } else {
  }
// compiled if node returning if11145 (depth = 2)
// Begin line 3425
  setline(3425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11170 == NULL) {
    strlit11170 = alloc_String("rgeneric");
    gc_root(strlit11170);
  }
// compiled string node returning strlit11170 (depth = 4)
  int op_slot_right_11169 = gc_frame_newslot(strlit11170);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11173 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11172);
// compiled call node returning call11173 (depth = 5)
// compiled member node returning call11173 (depth = 4)
  int op_slot_left_11169 = gc_frame_newslot(call11173);
  params[0] = strlit11170;
  partcv[0] = 1;
  Object opresult11174 = callmethod(call11173, "==", 1, partcv, params);
// compiled op node returning opresult11174 (depth = 3)
  Object if11168 = done;
  if (istrue(opresult11174)) {
// Begin line 3426
  setline(3426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11175 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11176 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11177 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11176);
// compiled call node returning call11177 (depth = 7)
// compiled member node returning call11177 (depth = 6)
  partcv[0] = 0;
  Object call11178 = callmethod(call11177, "new",
    1, partcv, params);
  gc_frame_end(callframe11175);
// compiled call node returning call11178 (depth = 5)
// compiled member node returning call11178 (depth = 4)
  *var_sugg = call11178;
  if (call11178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11179 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11180 == NULL) {
    strlit11180 = alloc_String(" ");
    gc_root(strlit11180);
  }
// compiled string node returning strlit11180 (depth = 4)
  gc_frame_newslot(strlit11180);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11180;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11181 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11179);
// compiled call node returning call11181 (depth = 3)
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11182 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11183 == NULL) {
    strlit11183 = alloc_String("the '>' operator must be preceded by a space.");
    gc_root(strlit11183);
  }
// compiled string node returning strlit11183 (depth = 4)
  gc_frame_newslot(strlit11183);
// Begin line 3429
  setline(3429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11185 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11184);
// compiled call node returning call11185 (depth = 5)
// compiled member node returning call11185 (depth = 4)
  gc_frame_newslot(call11185);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11187 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11186);
// compiled call node returning call11187 (depth = 5)
// compiled member node returning call11187 (depth = 4)
  gc_frame_newslot(call11187);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11189 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11188);
// compiled call node returning call11189 (depth = 5)
// compiled member node returning call11189 (depth = 4)
  gc_frame_newslot(call11189);
// Begin line 3430
  setline(3430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11183;
  params[1] = call11185;
  params[2] = call11187;
  params[3] = call11189;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11190 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11182);
// compiled call node returning call11190 (depth = 3)
    gc_frame_newslot(call11190);
    if11168 = call11190;
  } else {
  }
// compiled if node returning if11168 (depth = 2)
  gc_frame_end(frame);
  return if11168;
}
Object meth_parser_checkBadTypeLiteral11191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkBadTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkBadTypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11194 == NULL) {
    strlit11194 = alloc_String("lbrace");
    gc_root(strlit11194);
  }
// compiled string node returning strlit11194 (depth = 4)
  int op_slot_right_11193 = gc_frame_newslot(strlit11194);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11197 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11196);
// compiled call node returning call11197 (depth = 5)
// compiled member node returning call11197 (depth = 4)
  int op_slot_left_11193 = gc_frame_newslot(call11197);
  params[0] = strlit11194;
  partcv[0] = 1;
  Object opresult11198 = callmethod(call11197, "==", 1, partcv, params);
// compiled op node returning opresult11198 (depth = 3)
  Object if11192 = done;
  if (istrue(opresult11198)) {
// Begin line 3436
  setline(3436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11199 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11201 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11200);
// compiled call node returning call11201 (depth = 7)
// compiled member node returning call11201 (depth = 6)
  partcv[0] = 0;
  Object call11202 = callmethod(call11201, "new",
    1, partcv, params);
  gc_frame_end(callframe11199);
// compiled call node returning call11202 (depth = 5)
// compiled member node returning call11202 (depth = 4)
  *var_sugg = call11202;
  if (call11202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3437
  setline(3437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11203 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11204 == NULL) {
    strlit11204 = alloc_String("type ");
    gc_root(strlit11204);
  }
// compiled string node returning strlit11204 (depth = 4)
  gc_frame_newslot(strlit11204);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11204;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11205 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11203);
// compiled call node returning call11205 (depth = 3)
// Begin line 3438
  setline(3438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11206 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11207 == NULL) {
    strlit11207 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit11207);
  }
// compiled string node returning strlit11207 (depth = 4)
  gc_frame_newslot(strlit11207);
// Begin line 3439
  setline(3439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11209 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11208);
// compiled call node returning call11209 (depth = 5)
// compiled member node returning call11209 (depth = 4)
  gc_frame_newslot(call11209);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11211 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11210);
// compiled call node returning call11211 (depth = 5)
// compiled member node returning call11211 (depth = 4)
  gc_frame_newslot(call11211);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11213 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11212);
// compiled call node returning call11213 (depth = 5)
// compiled member node returning call11213 (depth = 4)
  gc_frame_newslot(call11213);
// Begin line 3440
  setline(3440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3438
  setline(3438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11207;
  params[1] = call11209;
  params[2] = call11211;
  params[3] = call11213;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11214 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11206);
// compiled call node returning call11214 (depth = 3)
    gc_frame_newslot(call11214);
    if11192 = call11214;
  } else {
  }
// compiled if node returning if11192 (depth = 2)
  gc_frame_end(frame);
  return if11192;
}
Object meth_parser__apply11328(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3474
  setline(3474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11330 == NULL) {
    strlit11330 = alloc_String("identifier");
    gc_root(strlit11330);
  }
// compiled string node returning strlit11330 (depth = 10)
  int op_slot_right_11329 = gc_frame_newslot(strlit11330);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11333 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11332);
// compiled call node returning call11333 (depth = 11)
// compiled member node returning call11333 (depth = 10)
  int op_slot_left_11329 = gc_frame_newslot(call11333);
  params[0] = strlit11330;
  partcv[0] = 1;
  Object opresult11334 = callmethod(call11333, "==", 1, partcv, params);
// compiled op node returning opresult11334 (depth = 9)
  gc_frame_end(frame);
  return opresult11334;
}
Object meth_parser__apply11338(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3472
  setline(3472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit11340 == NULL) {
    strlit11340 = alloc_String("member");
    gc_root(strlit11340);
  }
// compiled string node returning strlit11340 (depth = 11)
  int op_slot_right_11339 = gc_frame_newslot(strlit11340);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11342 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe11343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call11344 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11343);
// compiled call node returning call11344 (depth = 14)
// compiled member node returning call11344 (depth = 13)
  partcv[0] = 0;
  Object call11345 = callmethod(call11344, "kind",
    1, partcv, params);
  gc_frame_end(callframe11342);
// compiled call node returning call11345 (depth = 12)
// compiled member node returning call11345 (depth = 11)
  int op_slot_left_11339 = gc_frame_newslot(call11345);
  params[0] = strlit11340;
  partcv[0] = 1;
  Object opresult11346 = callmethod(call11345, "==", 1, partcv, params);
// compiled op node returning opresult11346 (depth = 10)
  gc_frame_end(frame);
  return opresult11346;
}
Object meth_parser__apply11325(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3473
  setline(3473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11326 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block11327 = alloc_Block(NULL, NULL, "parser", 3473);
  gc_frame_newslot(block11327);
// method "_apply"
  block_savedest(block11327);
  Object closure11328 = createclosure(2, "_apply");
  setclosureframe(closure11328, stackframe);
  addtoclosure(closure11328, var_sym);
  addtoclosure(closure11328, selfslot);
  struct UserObject *uo11328 = (struct UserObject*)block11327;
  uo11328->data[0] = (Object)closure11328;
  Method *meth_meth_parser__apply11328 = addmethod2pos(block11327, "_apply", &meth_parser__apply11328, 0);
  int argcv_meth_parser__apply11328[] = {0};
  meth_meth_parser__apply11328->type = alloc_MethodType(1, argcv_meth_parser__apply11328);
  meth_meth_parser__apply11328->definitionModule = modulename;
  meth_meth_parser__apply11328->definitionLine = 3468;
// compiled block node returning block11327 (depth = 8)
  gc_frame_newslot(block11327);
// call case 6: other member request
// Begin line 3471
  setline(3471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11336 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block11337 = alloc_Block(NULL, NULL, "parser", 3471);
  gc_frame_newslot(block11337);
// method "_apply"
  block_savedest(block11337);
  Object closure11338 = createclosure(2, "_apply");
  setclosureframe(closure11338, stackframe);
  addtoclosure(closure11338, var_values);
  addtoclosure(closure11338, selfslot);
  struct UserObject *uo11338 = (struct UserObject*)block11337;
  uo11338->data[0] = (Object)closure11338;
  Method *meth_meth_parser__apply11338 = addmethod2pos(block11337, "_apply", &meth_parser__apply11338, 0);
  int argcv_meth_parser__apply11338[] = {0};
  meth_meth_parser__apply11338->type = alloc_MethodType(1, argcv_meth_parser__apply11338);
  meth_meth_parser__apply11338->definitionModule = modulename;
  meth_meth_parser__apply11338->definitionLine = 3474;
// compiled block node returning block11337 (depth = 9)
  gc_frame_newslot(block11337);
// call case 6: other member request
// Begin line 3471
  setline(3471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11349 == NULL) {
    strlit11349 = alloc_String("identifier");
    gc_root(strlit11349);
  }
// compiled string node returning strlit11349 (depth = 10)
  int op_slot_right_11348 = gc_frame_newslot(strlit11349);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11351 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11352 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11353 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11352);
// compiled call node returning call11353 (depth = 13)
// compiled member node returning call11353 (depth = 12)
  partcv[0] = 0;
  Object call11354 = callmethod(call11353, "kind",
    1, partcv, params);
  gc_frame_end(callframe11351);
// compiled call node returning call11354 (depth = 11)
// compiled member node returning call11354 (depth = 10)
  int op_slot_left_11348 = gc_frame_newslot(call11354);
  params[0] = strlit11349;
  partcv[0] = 1;
  Object opresult11355 = callmethod(call11354, "==", 1, partcv, params);
// compiled op node returning opresult11355 (depth = 9)
  params[0] = block11337;
  partcv[0] = 1;
  Object call11356 = callmethod(opresult11355, "orElse",
    1, partcv, params);
  gc_frame_end(callframe11336);
// compiled call node returning call11356 (depth = 8)
  params[0] = block11327;
  partcv[0] = 1;
  Object call11357 = callmethod(call11356, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11326);
// compiled call node returning call11357 (depth = 7)
  gc_frame_end(frame);
  return call11357;
}
Object meth_parser_checkUnexpectedTokenAfterStatement11215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkUnexpectedTokenAfterStatement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkUnexpectedTokenAfterStatement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// Begin line 3445
  setline(3445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11218 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call11219 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11218);
// compiled call node returning call11219 (depth = 5)
// compiled member node returning call11219 (depth = 4)
  int op_slot_right_11217 = gc_frame_newslot(call11219);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11222 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11221);
// compiled call node returning call11222 (depth = 5)
// compiled member node returning call11222 (depth = 4)
  int op_slot_left_11217 = gc_frame_newslot(call11222);
  params[0] = call11219;
  partcv[0] = 1;
  Object opresult11223 = callmethod(call11222, "==", 1, partcv, params);
// compiled op node returning opresult11223 (depth = 3)
  Object if11216 = done;
  if (istrue(opresult11223)) {
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3447
  setline(3447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11227 == NULL) {
    strlit11227 = alloc_String("identifier");
    gc_root(strlit11227);
  }
// compiled string node returning strlit11227 (depth = 6)
  int op_slot_right_11226 = gc_frame_newslot(strlit11227);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call11230 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe11229);
// compiled call node returning call11230 (depth = 7)
// compiled member node returning call11230 (depth = 6)
  int op_slot_left_11226 = gc_frame_newslot(call11230);
  params[0] = strlit11227;
  partcv[0] = 1;
  Object opresult11231 = callmethod(call11230, "==", 1, partcv, params);
// compiled op node returning opresult11231 (depth = 5)
  int op_slot_right_11225 = gc_frame_newslot(opresult11231);
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11235 == NULL) {
    strlit11235 = alloc_String("=");
    gc_root(strlit11235);
  }
// compiled string node returning strlit11235 (depth = 7)
  int op_slot_right_11234 = gc_frame_newslot(strlit11235);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11237 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11238 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11237);
// compiled call node returning call11238 (depth = 8)
// compiled member node returning call11238 (depth = 7)
  int op_slot_left_11234 = gc_frame_newslot(call11238);
  params[0] = strlit11235;
  partcv[0] = 1;
  Object opresult11239 = callmethod(call11238, "==", 1, partcv, params);
// compiled op node returning opresult11239 (depth = 6)
  int op_slot_right_11233 = gc_frame_newslot(opresult11239);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11242 == NULL) {
    strlit11242 = alloc_String("op");
    gc_root(strlit11242);
  }
// compiled string node returning strlit11242 (depth = 7)
  int op_slot_right_11241 = gc_frame_newslot(strlit11242);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11245 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11244);
// compiled call node returning call11245 (depth = 8)
// compiled member node returning call11245 (depth = 7)
  int op_slot_left_11241 = gc_frame_newslot(call11245);
  params[0] = strlit11242;
  partcv[0] = 1;
  Object opresult11246 = callmethod(call11245, "==", 1, partcv, params);
// compiled op node returning opresult11246 (depth = 6)
  int op_slot_left_11233 = gc_frame_newslot(opresult11246);
  params[0] = opresult11239;
  partcv[0] = 1;
  Object opresult11247 = callmethod(opresult11246, "&&", 1, partcv, params);
// compiled op node returning opresult11247 (depth = 5)
  int op_slot_left_11225 = gc_frame_newslot(opresult11247);
  params[0] = opresult11231;
  partcv[0] = 1;
  Object opresult11248 = callmethod(opresult11247, "&&", 1, partcv, params);
// compiled op node returning opresult11248 (depth = 4)
  Object if11224 = done;
  if (istrue(opresult11248)) {
// Begin line 3448
  setline(3448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11249 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11250 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11251 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11250);
// compiled call node returning call11251 (depth = 8)
// compiled member node returning call11251 (depth = 7)
  partcv[0] = 0;
  Object call11252 = callmethod(call11251, "new",
    1, partcv, params);
  gc_frame_end(callframe11249);
// compiled call node returning call11252 (depth = 6)
// compiled member node returning call11252 (depth = 5)
  *var_sugg = call11252;
  if (call11252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3449
  setline(3449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11253 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11254 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11255 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11254);
// compiled call node returning call11255 (depth = 8)
// compiled member node returning call11255 (depth = 7)
  partcv[0] = 0;
  Object call11256 = callmethod(call11255, "empty",
    1, partcv, params);
  gc_frame_end(callframe11253);
// compiled call node returning call11256 (depth = 6)
// compiled member node returning call11256 (depth = 5)
  *var_suggestions = call11256;
  if (call11256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3450
  setline(3450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11257 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool11258 = alloc_Boolean(0);
// compiled identifier node returning bool11258 (depth = 5)
  gc_frame_newslot(bool11258);
// starting to compile identifier node (depth = 5)
  Object bool11259 = alloc_Boolean(0);
// compiled identifier node returning bool11259 (depth = 5)
  gc_frame_newslot(bool11259);
// starting to compile string node (depth = 5)
  if (strlit11260 == NULL) {
    strlit11260 = alloc_String(":=");
    gc_root(strlit11260);
  }
// compiled string node returning strlit11260 (depth = 5)
  gc_frame_newslot(strlit11260);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool11258;
  params[2] = bool11259;
  params[3] = strlit11260;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11261 = callmethod(*var_sugg, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11257);
// compiled call node returning call11261 (depth = 4)
// Begin line 3451
  setline(3451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11262 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call11263 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11262);
// compiled call node returning call11263 (depth = 4)
// Begin line 3452
  setline(3452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11264 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11265 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11266 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11265);
// compiled call node returning call11266 (depth = 8)
// compiled member node returning call11266 (depth = 7)
  partcv[0] = 0;
  Object call11267 = callmethod(call11266, "new",
    1, partcv, params);
  gc_frame_end(callframe11264);
// compiled call node returning call11267 (depth = 6)
// compiled member node returning call11267 (depth = 5)
  *var_sugg2 = call11267;
  if (call11267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3453
  setline(3453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11268 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool11269 = alloc_Boolean(0);
// compiled identifier node returning bool11269 (depth = 5)
  gc_frame_newslot(bool11269);
// starting to compile identifier node (depth = 5)
  Object bool11270 = alloc_Boolean(0);
// compiled identifier node returning bool11270 (depth = 5)
  gc_frame_newslot(bool11270);
// starting to compile string node (depth = 5)
  if (strlit11271 == NULL) {
    strlit11271 = alloc_String("==");
    gc_root(strlit11271);
  }
// compiled string node returning strlit11271 (depth = 5)
  gc_frame_newslot(strlit11271);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool11269;
  params[2] = bool11270;
  params[3] = strlit11271;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11272 = callmethod(*var_sugg2, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11268);
// compiled call node returning call11272 (depth = 4)
// Begin line 3454
  setline(3454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11273 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call11274 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11273);
// compiled call node returning call11274 (depth = 4)
// Begin line 3455
  setline(3455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11275 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11276 == NULL) {
    strlit11276 = alloc_String("assignment uses ':=', not '='.");
    gc_root(strlit11276);
  }
// compiled string node returning strlit11276 (depth = 5)
  gc_frame_newslot(strlit11276);
// Begin line 3456
  setline(3456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11278 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11277);
// compiled call node returning call11278 (depth = 6)
// compiled member node returning call11278 (depth = 5)
  gc_frame_newslot(call11278);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11280 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11279);
// compiled call node returning call11280 (depth = 6)
// compiled member node returning call11280 (depth = 5)
  gc_frame_newslot(call11280);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11282 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11281);
// compiled call node returning call11282 (depth = 6)
// compiled member node returning call11282 (depth = 5)
  gc_frame_newslot(call11282);
// Begin line 3457
  setline(3457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3455
  setline(3455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11276;
  params[1] = call11278;
  params[2] = call11280;
  params[3] = call11282;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11283 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11275);
// compiled call node returning call11283 (depth = 4)
    gc_frame_newslot(call11283);
    if11224 = call11283;
  } else {
  }
// compiled if node returning if11224 (depth = 3)
// Begin line 3459
  setline(3459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11286 == NULL) {
    strlit11286 = alloc_String("rgeneric");
    gc_root(strlit11286);
  }
// compiled string node returning strlit11286 (depth = 5)
  int op_slot_right_11285 = gc_frame_newslot(strlit11286);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11288 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11289 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11288);
// compiled call node returning call11289 (depth = 6)
// compiled member node returning call11289 (depth = 5)
  int op_slot_left_11285 = gc_frame_newslot(call11289);
  params[0] = strlit11286;
  partcv[0] = 1;
  Object opresult11290 = callmethod(call11289, "==", 1, partcv, params);
// compiled op node returning opresult11290 (depth = 4)
  Object if11284 = done;
  if (istrue(opresult11290)) {
// Begin line 3460
  setline(3460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11291 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11292 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11293 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11292);
// compiled call node returning call11293 (depth = 8)
// compiled member node returning call11293 (depth = 7)
  partcv[0] = 0;
  Object call11294 = callmethod(call11293, "new",
    1, partcv, params);
  gc_frame_end(callframe11291);
// compiled call node returning call11294 (depth = 6)
// compiled member node returning call11294 (depth = 5)
  *var_sugg = call11294;
  if (call11294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3461
  setline(3461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11295 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11296 == NULL) {
    strlit11296 = alloc_String(" ");
    gc_root(strlit11296);
  }
// compiled string node returning strlit11296 (depth = 5)
  gc_frame_newslot(strlit11296);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11298 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11297);
// compiled call node returning call11298 (depth = 6)
// compiled member node returning call11298 (depth = 5)
  gc_frame_newslot(call11298);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11300 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11299);
// compiled call node returning call11300 (depth = 6)
// compiled member node returning call11300 (depth = 5)
  gc_frame_newslot(call11300);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = strlit11296;
  params[1] = call11298;
  params[2] = call11300;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11301 = callmethod(*var_sugg, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe11295);
// compiled call node returning call11301 (depth = 4)
// Begin line 3462
  setline(3462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11302 = gc_frame_new();
// Begin line 3463
  setline(3463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit11303 == NULL) {
    strlit11303 = alloc_String("The '>' operator must have a space before it.");
    gc_root(strlit11303);
  }
// compiled string node returning strlit11303 (depth = 5)
  gc_frame_newslot(strlit11303);
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11304 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11305 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11304);
// compiled call node returning call11305 (depth = 6)
// compiled member node returning call11305 (depth = 5)
  gc_frame_newslot(call11305);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11307 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11306);
// compiled call node returning call11307 (depth = 6)
// compiled member node returning call11307 (depth = 5)
  gc_frame_newslot(call11307);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11309 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11308);
// compiled call node returning call11309 (depth = 6)
// compiled member node returning call11309 (depth = 5)
  gc_frame_newslot(call11309);
// Begin line 3465
  setline(3465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3462
  setline(3462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11303;
  params[1] = call11305;
  params[2] = call11307;
  params[3] = call11309;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11310 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11302);
// compiled call node returning call11310 (depth = 4)
    gc_frame_newslot(call11310);
    if11284 = call11310;
  } else {
  }
// compiled if node returning if11284 (depth = 3)
// Begin line 3467
  setline(3467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11313 == NULL) {
    strlit11313 = alloc_String("rbrace");
    gc_root(strlit11313);
  }
// compiled string node returning strlit11313 (depth = 5)
  int op_slot_right_11312 = gc_frame_newslot(strlit11313);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11315 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11316 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11315);
// compiled call node returning call11316 (depth = 6)
// compiled member node returning call11316 (depth = 5)
  int op_slot_left_11312 = gc_frame_newslot(call11316);
  params[0] = strlit11313;
  partcv[0] = 1;
  Object opresult11317 = callmethod(call11316, "!=", 1, partcv, params);
// compiled op node returning opresult11317 (depth = 4)
  Object if11311 = done;
  if (istrue(opresult11317)) {
// Begin line 3468
  setline(3468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11318 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11319 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11320 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11319);
// compiled call node returning call11320 (depth = 8)
// compiled member node returning call11320 (depth = 7)
  partcv[0] = 0;
  Object call11321 = callmethod(call11320, "empty",
    1, partcv, params);
  gc_frame_end(callframe11318);
// compiled call node returning call11321 (depth = 6)
// compiled member node returning call11321 (depth = 5)
  *var_suggestions = call11321;
  if (call11321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3469
  setline(3469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3470
  setline(3470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11323 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block11324 = alloc_Block(NULL, NULL, "parser", 3470);
  gc_frame_newslot(block11324);
// method "_apply"
  block_savedest(block11324);
  Object closure11325 = createclosure(3, "_apply");
  setclosureframe(closure11325, stackframe);
  addtoclosure(closure11325, var_sym);
  addtoclosure(closure11325, var_values);
  addtoclosure(closure11325, selfslot);
  struct UserObject *uo11325 = (struct UserObject*)block11324;
  uo11325->data[0] = (Object)closure11325;
  Method *meth_meth_parser__apply11325 = addmethod2pos(block11324, "_apply", &meth_parser__apply11325, 0);
  int argcv_meth_parser__apply11325[] = {0};
  meth_meth_parser__apply11325->type = alloc_MethodType(1, argcv_meth_parser__apply11325);
  meth_meth_parser__apply11325->definitionModule = modulename;
  meth_meth_parser__apply11325->definitionLine = 3468;
// compiled block node returning block11324 (depth = 6)
  gc_frame_newslot(block11324);
// call case 6: other member request
// Begin line 3470
  setline(3470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11360 = alloc_Float64(0);
// compiled num node returning num11360 (depth = 7)
  int op_slot_right_11359 = gc_frame_newslot(num11360);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11363 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe11362);
// compiled call node returning call11363 (depth = 8)
// compiled member node returning call11363 (depth = 7)
  int op_slot_left_11359 = gc_frame_newslot(call11363);
  params[0] = num11360;
  partcv[0] = 1;
  Object opresult11364 = callmethod(call11363, ">", 1, partcv, params);
// compiled op node returning opresult11364 (depth = 6)
  params[0] = block11324;
  partcv[0] = 1;
  Object call11365 = callmethod(opresult11364, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11323);
// compiled call node returning call11365 (depth = 5)
  Object if11322 = done;
  if (istrue(call11365)) {
// Begin line 3477
  setline(3477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11366 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11367 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11368 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11367);
// compiled call node returning call11368 (depth = 9)
// compiled member node returning call11368 (depth = 8)
  partcv[0] = 0;
  Object call11369 = callmethod(call11368, "new",
    1, partcv, params);
  gc_frame_end(callframe11366);
// compiled call node returning call11369 (depth = 7)
// compiled member node returning call11369 (depth = 6)
  *var_suggestion = call11369;
  if (call11369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11371 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool11372 = alloc_Boolean(1);
// compiled identifier node returning bool11372 (depth = 6)
  gc_frame_newslot(bool11372);
// starting to compile identifier node (depth = 6)
  Object bool11373 = alloc_Boolean(0);
// compiled identifier node returning bool11373 (depth = 6)
  gc_frame_newslot(bool11373);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11375 == NULL) {
    strlit11375 = alloc_String(")");
    gc_root(strlit11375);
  }
// compiled string node returning strlit11375 (depth = 7)
  int op_slot_right_11374 = gc_frame_newslot(strlit11375);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11378 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11379 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11378);
// compiled call node returning call11379 (depth = 9)
// compiled member node returning call11379 (depth = 8)
  int op_slot_right_11377 = gc_frame_newslot(call11379);
// starting to compile string node (depth = 8)
  if (strlit11381 == NULL) {
    strlit11381 = alloc_String("(");
    gc_root(strlit11381);
  }
// compiled string node returning strlit11381 (depth = 8)
  int op_slot_left_11377 = gc_frame_newslot(strlit11381);
  params[0] = call11379;
  partcv[0] = 1;
  Object opresult11382 = callmethod(strlit11381, "++", 1, partcv, params);
// compiled op node returning opresult11382 (depth = 7)
  int op_slot_left_11374 = gc_frame_newslot(opresult11382);
  params[0] = strlit11375;
  partcv[0] = 1;
  Object opresult11383 = callmethod(opresult11382, "++", 1, partcv, params);
// compiled op node returning opresult11383 (depth = 6)
  gc_frame_newslot(opresult11383);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool11372;
  params[2] = bool11373;
  params[3] = opresult11383;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11384 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11371);
// compiled call node returning call11384 (depth = 5)
// Begin line 3479
  setline(3479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11385 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11386 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11385);
// compiled call node returning call11386 (depth = 5)
// Begin line 3480
  setline(3480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11390 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11389);
// compiled call node returning call11390 (depth = 8)
// compiled member node returning call11390 (depth = 7)
  int op_slot_right_11388 = gc_frame_newslot(call11390);
// starting to compile identifier node (depth = 7)
  Object bool11392 = alloc_Boolean(0);
// compiled identifier node returning bool11392 (depth = 7)
  int op_slot_left_11388 = gc_frame_newslot(bool11392);
  params[0] = call11390;
  partcv[0] = 1;
  Object opresult11393 = callmethod(bool11392, "!=", 1, partcv, params);
// compiled op node returning opresult11393 (depth = 6)
  Object if11387 = done;
  if (istrue(opresult11393)) {
// Begin line 3481
  setline(3481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11395 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11394);
// compiled call node returning call11395 (depth = 8)
// compiled member node returning call11395 (depth = 7)
  *var_n = call11395;
  if (call11395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 3482
  setline(3482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11399 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11398);
// compiled call node returning call11399 (depth = 9)
// compiled member node returning call11399 (depth = 8)
  int op_slot_right_11397 = gc_frame_newslot(call11399);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call11402 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe11401);
// compiled call node returning call11402 (depth = 9)
// compiled member node returning call11402 (depth = 8)
  int op_slot_left_11397 = gc_frame_newslot(call11402);
  params[0] = call11399;
  partcv[0] = 1;
  Object opresult11403 = callmethod(call11402, "==", 1, partcv, params);
// compiled op node returning opresult11403 (depth = 7)
  Object if11396 = done;
  if (istrue(opresult11403)) {
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11404 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11406 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11405);
// compiled call node returning call11406 (depth = 11)
// compiled member node returning call11406 (depth = 10)
  partcv[0] = 0;
  Object call11407 = callmethod(call11406, "new",
    1, partcv, params);
  gc_frame_end(callframe11404);
// compiled call node returning call11407 (depth = 9)
// compiled member node returning call11407 (depth = 8)
  *var_suggestion = call11407;
  if (call11407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3484
  setline(3484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11409 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool11410 = alloc_Boolean(1);
// compiled identifier node returning bool11410 (depth = 8)
  gc_frame_newslot(bool11410);
// starting to compile identifier node (depth = 8)
  Object bool11411 = alloc_Boolean(0);
// compiled identifier node returning bool11411 (depth = 8)
  gc_frame_newslot(bool11411);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11413 == NULL) {
    strlit11413 = alloc_String("");
    gc_root(strlit11413);
  }
// compiled string node returning strlit11413 (depth = 9)
  int op_slot_right_11412 = gc_frame_newslot(strlit11413);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11417 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11416);
// compiled call node returning call11417 (depth = 11)
// compiled member node returning call11417 (depth = 10)
  int op_slot_right_11415 = gc_frame_newslot(call11417);
// starting to compile string node (depth = 10)
  if (strlit11419 == NULL) {
    strlit11419 = alloc_String("(");
    gc_root(strlit11419);
  }
// compiled string node returning strlit11419 (depth = 10)
  int op_slot_left_11415 = gc_frame_newslot(strlit11419);
  params[0] = call11417;
  partcv[0] = 1;
  Object opresult11420 = callmethod(strlit11419, "++", 1, partcv, params);
// compiled op node returning opresult11420 (depth = 9)
  int op_slot_left_11412 = gc_frame_newslot(opresult11420);
  params[0] = strlit11413;
  partcv[0] = 1;
  Object opresult11421 = callmethod(opresult11420, "++", 1, partcv, params);
// compiled op node returning opresult11421 (depth = 8)
  gc_frame_newslot(opresult11421);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool11410;
  params[2] = bool11411;
  params[3] = opresult11421;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11422 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11409);
// compiled call node returning call11422 (depth = 7)
// Begin line 3485
  setline(3485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11423 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11424 == NULL) {
    strlit11424 = alloc_String(")");
    gc_root(strlit11424);
  }
// compiled string node returning strlit11424 (depth = 8)
  gc_frame_newslot(strlit11424);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11425 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11426 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11425);
// compiled call node returning call11426 (depth = 9)
// compiled member node returning call11426 (depth = 8)
  gc_frame_newslot(call11426);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit11424;
  params[1] = call11426;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11427 = callmethod(*var_suggestion, "append()onLine",
    2, partcv, params);
  gc_frame_end(callframe11423);
// compiled call node returning call11427 (depth = 7)
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11428 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11429 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11428);
// compiled call node returning call11429 (depth = 7)
    gc_frame_newslot(call11429);
    if11396 = call11429;
  } else {
  }
// compiled if node returning if11396 (depth = 6)
    gc_frame_newslot(if11396);
    if11387 = if11396;
  } else {
  }
// compiled if node returning if11387 (depth = 5)
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11432 == NULL) {
    strlit11432 = alloc_String("identifier");
    gc_root(strlit11432);
  }
// compiled string node returning strlit11432 (depth = 7)
  int op_slot_right_11431 = gc_frame_newslot(strlit11432);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11434 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11435 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call11436 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11435);
// compiled call node returning call11436 (depth = 10)
// compiled member node returning call11436 (depth = 9)
  partcv[0] = 0;
  Object call11437 = callmethod(call11436, "kind",
    1, partcv, params);
  gc_frame_end(callframe11434);
// compiled call node returning call11437 (depth = 8)
// compiled member node returning call11437 (depth = 7)
  int op_slot_left_11431 = gc_frame_newslot(call11437);
  params[0] = strlit11432;
  partcv[0] = 1;
  Object opresult11438 = callmethod(call11437, "==", 1, partcv, params);
// compiled op node returning opresult11438 (depth = 6)
  Object if11430 = done;
  if (istrue(opresult11438)) {
// Begin line 3490
  setline(3490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11439 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call11441 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11440);
// compiled call node returning call11441 (depth = 10)
// compiled member node returning call11441 (depth = 9)
  partcv[0] = 0;
  Object call11442 = callmethod(call11441, "new",
    1, partcv, params);
  gc_frame_end(callframe11439);
// compiled call node returning call11442 (depth = 8)
// compiled member node returning call11442 (depth = 7)
  *var_suggestion = call11442;
  if (call11442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3491
  setline(3491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11444 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool11445 = alloc_Boolean(0);
// compiled identifier node returning bool11445 (depth = 7)
  gc_frame_newslot(bool11445);
// starting to compile identifier node (depth = 7)
  Object bool11446 = alloc_Boolean(0);
// compiled identifier node returning bool11446 (depth = 7)
  gc_frame_newslot(bool11446);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11448 == NULL) {
    strlit11448 = alloc_String("""\x22""");
    gc_root(strlit11448);
  }
// compiled string node returning strlit11448 (depth = 8)
  int op_slot_right_11447 = gc_frame_newslot(strlit11448);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11452 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11451);
// compiled call node returning call11452 (depth = 10)
// compiled member node returning call11452 (depth = 9)
  int op_slot_right_11450 = gc_frame_newslot(call11452);
// starting to compile string node (depth = 9)
  if (strlit11454 == NULL) {
    strlit11454 = alloc_String("""\x22""");
    gc_root(strlit11454);
  }
// compiled string node returning strlit11454 (depth = 9)
  int op_slot_left_11450 = gc_frame_newslot(strlit11454);
  params[0] = call11452;
  partcv[0] = 1;
  Object opresult11455 = callmethod(strlit11454, "++", 1, partcv, params);
// compiled op node returning opresult11455 (depth = 8)
  int op_slot_left_11447 = gc_frame_newslot(opresult11455);
  params[0] = strlit11448;
  partcv[0] = 1;
  Object opresult11456 = callmethod(opresult11455, "++", 1, partcv, params);
// compiled op node returning opresult11456 (depth = 7)
  gc_frame_newslot(opresult11456);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool11445;
  params[2] = bool11446;
  params[3] = opresult11456;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11457 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11444);
// compiled call node returning call11457 (depth = 6)
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11458 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11459 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11458);
// compiled call node returning call11459 (depth = 6)
    gc_frame_newslot(call11459);
    if11430 = call11459;
  } else {
  }
// compiled if node returning if11430 (depth = 5)
    gc_frame_newslot(if11430);
    if11322 = if11430;
  } else {
  }
// compiled if node returning if11322 (depth = 4)
// Begin line 3495
  setline(3495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11460 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array11461 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit11462 == NULL) {
    strlit11462 = alloc_String("rbrace");
    gc_root(strlit11462);
  }
// compiled string node returning strlit11462 (depth = 7)
  params[0] = strlit11462;
  partcv[0] = 1;
  callmethod(array11461, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array11461 (depth = 6)
  gc_frame_newslot(array11461);
// call case 4: self request
  params[0] = array11461;
  partcv[0] = 1;
  Object call11463 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11460);
// compiled call node returning call11463 (depth = 5)
  *var_nextTok = call11463;
  if (call11463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_11465 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_11465 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult11467 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult11467 (depth = 5)
  Object if11464 = done;
  if (istrue(opresult11467)) {
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11468 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11469 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11470 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11469);
// compiled call node returning call11470 (depth = 9)
// compiled member node returning call11470 (depth = 8)
  partcv[0] = 0;
  Object call11471 = callmethod(call11470, "new",
    1, partcv, params);
  gc_frame_end(callframe11468);
// compiled call node returning call11471 (depth = 7)
// compiled member node returning call11471 (depth = 6)
  *var_suggestion = call11471;
  if (call11471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3498
  setline(3498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11473 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call11475 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11474);
// compiled call node returning call11475 (depth = 7)
// compiled member node returning call11475 (depth = 6)
  gc_frame_newslot(call11475);
// starting to compile call node (depth = 6)
  int callframe11476 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num11477 = alloc_Float64(1);
// compiled num node returning num11477 (depth = 7)
  gc_frame_newslot(num11477);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11479 = alloc_Float64(1);
// compiled num node returning num11479 (depth = 8)
  int op_slot_right_11478 = gc_frame_newslot(num11479);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11482 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call11483 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe11482);
// compiled call node returning call11483 (depth = 10)
// compiled member node returning call11483 (depth = 9)
  int op_slot_right_11481 = gc_frame_newslot(call11483);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call11486 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11485);
// compiled call node returning call11486 (depth = 10)
// compiled member node returning call11486 (depth = 9)
  int op_slot_left_11481 = gc_frame_newslot(call11486);
  params[0] = call11483;
  partcv[0] = 1;
  Object sum11487 = callmethod(call11486, "+", 1, partcv, params);
// compiled op node returning sum11487 (depth = 8)
  int op_slot_left_11478 = gc_frame_newslot(sum11487);
  params[0] = num11479;
  partcv[0] = 1;
  Object diff11488 = callmethod(sum11487, "-", 1, partcv, params);
// compiled op node returning diff11488 (depth = 7)
  gc_frame_newslot(diff11488);
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11490 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11489);
// compiled call node returning call11490 (depth = 9)
// compiled member node returning call11490 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call11492 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11491);
// compiled call node returning call11492 (depth = 9)
// compiled member node returning call11492 (depth = 8)
  params[0] = call11492;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11493 = callmethod(call11490, "[]", 1, partcv, params);
// compiled index node returning idxres11493 (depth = 7)
  params[0] = num11477;
  params[1] = diff11488;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11494 = callmethod(idxres11493, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11476);
// compiled call node returning call11494 (depth = 6)
  gc_frame_newslot(call11494);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call11475;
  params[1] = call11494;
  partcv[0] = 2;
  Object call11495 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11473);
// compiled call node returning call11495 (depth = 5)
// Begin line 3499
  setline(3499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11496 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11498 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11497);
// compiled call node returning call11498 (depth = 8)
// compiled member node returning call11498 (depth = 7)
  gc_frame_newslot(call11498);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11499 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call11501 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11500);
// compiled call node returning call11501 (depth = 11)
// compiled member node returning call11501 (depth = 10)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11503 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11502);
// compiled call node returning call11503 (depth = 11)
// compiled member node returning call11503 (depth = 10)
  params[0] = call11503;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11504 = callmethod(call11501, "[]", 1, partcv, params);
// compiled index node returning idxres11504 (depth = 9)
  partcv[0] = 0;
  Object call11505 = callmethod(idxres11504, "size",
    1, partcv, params);
  gc_frame_end(callframe11499);
// compiled call node returning call11505 (depth = 8)
// compiled member node returning call11505 (depth = 7)
  gc_frame_newslot(call11505);
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11507 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11506);
// compiled call node returning call11507 (depth = 9)
// compiled member node returning call11507 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11509 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11508);
// compiled call node returning call11509 (depth = 9)
// compiled member node returning call11509 (depth = 8)
  params[0] = call11509;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11510 = callmethod(call11507, "[]", 1, partcv, params);
// compiled index node returning idxres11510 (depth = 7)
  params[0] = call11498;
  params[1] = call11505;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11511 = callmethod(idxres11510, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11496);
// compiled call node returning call11511 (depth = 6)
  *var_newLine = call11511;
  if (call11511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11512 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11514 = alloc_Float64(0.1);
// compiled num node returning num11514 (depth = 7)
  int op_slot_right_11513 = gc_frame_newslot(num11514);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call11517 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11516);
// compiled call node returning call11517 (depth = 8)
// compiled member node returning call11517 (depth = 7)
  int op_slot_left_11513 = gc_frame_newslot(call11517);
  params[0] = num11514;
  partcv[0] = 1;
  Object sum11518 = callmethod(call11517, "+", 1, partcv, params);
// compiled op node returning sum11518 (depth = 6)
  gc_frame_newslot(sum11518);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum11518;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call11519 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11512);
// compiled call node returning call11519 (depth = 5)
// Begin line 3501
  setline(3501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11520 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11521 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11520);
// compiled call node returning call11521 (depth = 5)
    gc_frame_newslot(call11521);
    if11464 = call11521;
  } else {
// Begin line 3503
  setline(3503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11522 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11524 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11523);
// compiled call node returning call11524 (depth = 9)
// compiled member node returning call11524 (depth = 8)
  partcv[0] = 0;
  Object call11525 = callmethod(call11524, "new",
    1, partcv, params);
  gc_frame_end(callframe11522);
// compiled call node returning call11525 (depth = 7)
// compiled member node returning call11525 (depth = 6)
  *var_suggestion = call11525;
  if (call11525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3504
  setline(3504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11527 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11528 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call11529 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11528);
// compiled call node returning call11529 (depth = 7)
// compiled member node returning call11529 (depth = 6)
  gc_frame_newslot(call11529);
// starting to compile identifier node (depth = 6)
  Object bool11530 = alloc_Boolean(1);
// compiled identifier node returning bool11530 (depth = 6)
  gc_frame_newslot(bool11530);
// starting to compile identifier node (depth = 6)
  Object bool11531 = alloc_Boolean(0);
// compiled identifier node returning bool11531 (depth = 6)
  gc_frame_newslot(bool11531);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call11529;
  params[2] = bool11530;
  params[3] = bool11531;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11532 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe11527);
// compiled call node returning call11532 (depth = 5)
// Begin line 3505
  setline(3505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11533 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11534 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11533);
// compiled call node returning call11534 (depth = 5)
    gc_frame_newslot(call11534);
    if11464 = call11534;
  }
// compiled if node returning if11464 (depth = 4)
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11535 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11536 == NULL) {
    strlit11536 = alloc_String("multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.");
    gc_root(strlit11536);
  }
// compiled string node returning strlit11536 (depth = 5)
  gc_frame_newslot(strlit11536);
// Begin line 3508
  setline(3508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11538 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11537);
// compiled call node returning call11538 (depth = 6)
// compiled member node returning call11538 (depth = 5)
  gc_frame_newslot(call11538);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11540 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11539);
// compiled call node returning call11540 (depth = 6)
// compiled member node returning call11540 (depth = 5)
  gc_frame_newslot(call11540);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11536;
  params[1] = call11538;
  params[2] = call11540;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11541 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11535);
// compiled call node returning call11541 (depth = 4)
    gc_frame_newslot(call11541);
    if11311 = call11541;
  } else {
  }
// compiled if node returning if11311 (depth = 3)
    gc_frame_newslot(if11311);
    if11216 = if11311;
  } else {
  }
// compiled if node returning if11216 (depth = 2)
  gc_frame_end(frame);
  return if11216;
}
Object meth_parser__apply11639(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11641 = alloc_Float64(0);
// compiled num node returning num11641 (depth = 5)
  int op_slot_right_11640 = gc_frame_newslot(num11641);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11644 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11643);
// compiled call node returning call11644 (depth = 6)
// compiled member node returning call11644 (depth = 5)
  int op_slot_left_11640 = gc_frame_newslot(call11644);
  params[0] = num11641;
  partcv[0] = 1;
  Object opresult11645 = callmethod(call11644, ">", 1, partcv, params);
// compiled op node returning opresult11645 (depth = 4)
  gc_frame_end(frame);
  return opresult11645;
}
Object meth_parser__apply11657(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11658 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11659 = callmethodflags(self, "inheritsOrUses", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11658);
// compiled call node returning call11659 (depth = 7)
// compiled member node returning call11659 (depth = 6)
  gc_frame_end(frame);
  return call11659;
}
Object meth_parser__apply11662(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// Begin line 3549
  setline(3549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11664 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe11663);
// compiled call node returning call11664 (depth = 8)
// compiled member node returning call11664 (depth = 7)
  *var_parentNode = call11664;
  if (call11664 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 3550
  setline(3550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call11667 = callmethod(*var_parentNode, "isUse",
    1, partcv, params);
  gc_frame_end(callframe11666);
// compiled call node returning call11667 (depth = 8)
// compiled member node returning call11667 (depth = 7)
  Object if11665 = done;
  if (istrue(call11667)) {
// Begin line 3551
  setline(3551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11668 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_moduleObject (depth = 10)
  partcv[0] = 0;
  Object call11670 = callmethod(*var_moduleObject, "usedTraits",
    1, partcv, params);
  gc_frame_end(callframe11669);
// compiled call node returning call11670 (depth = 9)
// compiled member node returning call11670 (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call11671 = callmethod(call11670, "add",
    1, partcv, params);
  gc_frame_end(callframe11668);
// compiled call node returning call11671 (depth = 7)
    gc_frame_newslot(call11671);
    if11665 = call11671;
  } else {
// Begin line 3554
  setline(3554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3552
  setline(3552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11673 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11674 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_moduleObject (depth = 12)
  partcv[0] = 0;
  Object call11675 = callmethod(*var_moduleObject, "usedTraits",
    1, partcv, params);
  gc_frame_end(callframe11674);
// compiled call node returning call11675 (depth = 11)
// compiled member node returning call11675 (depth = 10)
  partcv[0] = 0;
  Object call11676 = callmethod(call11675, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe11673);
// compiled call node returning call11676 (depth = 9)
// compiled member node returning call11676 (depth = 8)
  Object if11672 = done;
  if (istrue(call11676)) {
// Begin line 3553
  setline(3553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11677 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  gc_frame_newslot(*var_parentNode);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_moduleObject (depth = 9)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call11678 = callmethod(*var_moduleObject, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe11677);
// compiled call node returning call11678 (depth = 8)
    gc_frame_newslot(call11678);
    if11672 = call11678;
  } else {
// Begin line 3555
  setline(3555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11679 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 3556
  setline(3556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit11681 == NULL) {
    strlit11681 = alloc_String("before 'use' in a module.");
    gc_root(strlit11681);
  }
// compiled string node returning strlit11681 (depth = 10)
  int op_slot_right_11680 = gc_frame_newslot(strlit11681);
// Begin line 3555
  setline(3555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit11683 == NULL) {
    strlit11683 = alloc_String("'inherit' must come ");
    gc_root(strlit11683);
  }
// compiled string node returning strlit11683 (depth = 10)
  int op_slot_left_11680 = gc_frame_newslot(strlit11683);
  params[0] = strlit11681;
  partcv[0] = 1;
  Object opresult11684 = callmethod(strlit11683, "++", 1, partcv, params);
// compiled op node returning opresult11684 (depth = 9)
  gc_frame_newslot(opresult11684);
// Begin line 3557
  setline(3557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11685 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call11686 = callmethod(*var_parentNode, "line",
    1, partcv, params);
  gc_frame_end(callframe11685);
// compiled call node returning call11686 (depth = 10)
// compiled member node returning call11686 (depth = 9)
  gc_frame_newslot(call11686);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11687 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call11688 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11687);
// compiled call node returning call11688 (depth = 10)
// compiled member node returning call11688 (depth = 9)
  gc_frame_newslot(call11688);
// Begin line 3558
  setline(3558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num11690 = alloc_Float64(7);
// compiled num node returning num11690 (depth = 10)
  int op_slot_right_11689 = gc_frame_newslot(num11690);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call11693 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11692);
// compiled call node returning call11693 (depth = 11)
// compiled member node returning call11693 (depth = 10)
  int op_slot_left_11689 = gc_frame_newslot(call11693);
  params[0] = num11690;
  partcv[0] = 1;
  Object sum11694 = callmethod(call11693, "+", 1, partcv, params);
// compiled op node returning sum11694 (depth = 9)
  gc_frame_newslot(sum11694);
// call case 6: other member request
// Begin line 3555
  setline(3555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult11684;
  params[1] = call11686;
  params[2] = call11688;
  params[3] = sum11694;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call11695 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe11679);
// compiled call node returning call11695 (depth = 8)
    gc_frame_newslot(call11695);
    if11672 = call11695;
  }
// compiled if node returning if11672 (depth = 7)
    gc_frame_newslot(if11672);
    if11665 = if11672;
  }
// compiled if node returning if11665 (depth = 6)
  gc_frame_end(frame);
  return if11665;
}
Object meth_parser__apply11648(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_oldlength = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 3545
  setline(3545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11649 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11650 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11649);
// compiled call node returning call11650 (depth = 5)
// compiled member node returning call11650 (depth = 4)
// Begin line 3546
  setline(3546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11652 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11651);
// compiled call node returning call11652 (depth = 5)
// compiled member node returning call11652 (depth = 4)
// Begin line 3547
  setline(3547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11653 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11654 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11653);
// compiled call node returning call11654 (depth = 5)
// compiled member node returning call11654 (depth = 4)
// Begin line 3548
  setline(3548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11655 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block11656 = alloc_Block(NULL, NULL, "parser", 3548);
  gc_frame_newslot(block11656);
// method "_apply"
  block_savedest(block11656);
  Object closure11657 = createclosure(1, "_apply");
  setclosureframe(closure11657, stackframe);
  addtoclosure(closure11657, selfslot);
  struct UserObject *uo11657 = (struct UserObject*)block11656;
  uo11657->data[0] = (Object)closure11657;
  Method *meth_meth_parser__apply11657 = addmethod2pos(block11656, "_apply", &meth_parser__apply11657, 0);
  int argcv_meth_parser__apply11657[] = {0};
  meth_meth_parser__apply11657->type = alloc_MethodType(1, argcv_meth_parser__apply11657);
  meth_meth_parser__apply11657->definitionModule = modulename;
  meth_meth_parser__apply11657->definitionLine = 3547;
// compiled block node returning block11656 (depth = 5)
  gc_frame_newslot(block11656);
// starting to compile block node (depth = 5)
  Object block11661 = alloc_Block(NULL, NULL, "parser", 3548);
  gc_frame_newslot(block11661);
// method "_apply"
  block_savedest(block11661);
  Object closure11662 = createclosure(4, "_apply");
  setclosureframe(closure11662, stackframe);
  addtoclosure(closure11662, var_values);
  addtoclosure(closure11662, var_moduleObject);
  addtoclosure(closure11662, var_errormessages);
  addtoclosure(closure11662, selfslot);
  struct UserObject *uo11662 = (struct UserObject*)block11661;
  uo11662->data[0] = (Object)closure11662;
  Method *meth_meth_parser__apply11662 = addmethod2pos(block11661, "_apply", &meth_parser__apply11662, 0);
  int argcv_meth_parser__apply11662[] = {0};
  meth_meth_parser__apply11662->type = alloc_MethodType(1, argcv_meth_parser__apply11662);
  meth_meth_parser__apply11662->definitionModule = modulename;
  meth_meth_parser__apply11662->definitionLine = 3548;
// compiled block node returning block11661 (depth = 5)
  gc_frame_newslot(block11661);
// call case 4: self request
  params[0] = block11656;
  params[1] = block11661;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11697 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11655);
// compiled call node returning call11697 (depth = 4)
// Begin line 3561
  setline(3561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11699 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11698);
// compiled call node returning call11699 (depth = 5)
// compiled member node returning call11699 (depth = 4)
// Begin line 3562
  setline(3562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11701 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11700);
// compiled call node returning call11701 (depth = 5)
// compiled member node returning call11701 (depth = 4)
// Begin line 3563
  setline(3563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11703 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11702);
// compiled call node returning call11703 (depth = 5)
// compiled member node returning call11703 (depth = 4)
// Begin line 3564
  setline(3564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_11705 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call11708 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11707);
// compiled call node returning call11708 (depth = 7)
// compiled member node returning call11708 (depth = 6)
  int op_slot_left_11705 = gc_frame_newslot(call11708);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult11709 = callmethod(call11708, "==", 1, partcv, params);
// compiled op node returning opresult11709 (depth = 5)
  Object if11704 = done;
  if (istrue(opresult11709)) {
// Begin line 3565
  setline(3565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11710 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11711 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11712 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11711);
// compiled call node returning call11712 (depth = 9)
// compiled member node returning call11712 (depth = 8)
  partcv[0] = 0;
  Object call11713 = callmethod(call11712, "new",
    1, partcv, params);
  gc_frame_end(callframe11710);
// compiled call node returning call11713 (depth = 7)
// compiled member node returning call11713 (depth = 6)
  *var_suggestion = call11713;
  if (call11713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3566
  setline(3566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11714 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call11715 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe11714);
// compiled call node returning call11715 (depth = 5)
// Begin line 3567
  setline(3567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11716 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 3568
  setline(3568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit11718 == NULL) {
    strlit11718 = alloc_String("caused by an extra '}', ')', or ']'.");
    gc_root(strlit11718);
  }
// compiled string node returning strlit11718 (depth = 7)
  int op_slot_right_11717 = gc_frame_newslot(strlit11718);
// Begin line 3567
  setline(3567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit11720 == NULL) {
    strlit11720 = alloc_String("invalid statement. This is often ");
    gc_root(strlit11720);
  }
// compiled string node returning strlit11720 (depth = 7)
  int op_slot_left_11717 = gc_frame_newslot(strlit11720);
  params[0] = strlit11718;
  partcv[0] = 1;
  Object opresult11721 = callmethod(strlit11720, "++", 1, partcv, params);
// compiled op node returning opresult11721 (depth = 6)
  gc_frame_newslot(opresult11721);
// Begin line 3569
  setline(3569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11722 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11723 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11722);
// compiled call node returning call11723 (depth = 7)
// compiled member node returning call11723 (depth = 6)
  gc_frame_newslot(call11723);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11725 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11724);
// compiled call node returning call11725 (depth = 7)
// compiled member node returning call11725 (depth = 6)
  gc_frame_newslot(call11725);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11727 = alloc_Float64(1);
// compiled num node returning num11727 (depth = 7)
  int op_slot_right_11726 = gc_frame_newslot(num11727);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11731 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe11730);
// compiled call node returning call11731 (depth = 9)
// compiled member node returning call11731 (depth = 8)
  int op_slot_right_11729 = gc_frame_newslot(call11731);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11734 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11733);
// compiled call node returning call11734 (depth = 9)
// compiled member node returning call11734 (depth = 8)
  int op_slot_left_11729 = gc_frame_newslot(call11734);
  params[0] = call11731;
  partcv[0] = 1;
  Object sum11735 = callmethod(call11734, "+", 1, partcv, params);
// compiled op node returning sum11735 (depth = 7)
  int op_slot_left_11726 = gc_frame_newslot(sum11735);
  params[0] = num11727;
  partcv[0] = 1;
  Object diff11736 = callmethod(sum11735, "-", 1, partcv, params);
// compiled op node returning diff11736 (depth = 6)
  gc_frame_newslot(diff11736);
// Begin line 3570
  setline(3570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3567
  setline(3567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult11721;
  params[1] = call11723;
  params[2] = call11725;
  params[3] = diff11736;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11737 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11716);
// compiled call node returning call11737 (depth = 5)
    gc_frame_newslot(call11737);
    if11704 = call11737;
  } else {
  }
// compiled if node returning if11704 (depth = 4)
// Begin line 3572
  setline(3572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11738 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11739 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11738);
// compiled call node returning call11739 (depth = 6)
// compiled member node returning call11739 (depth = 5)
  *var_oldlength = call11739;
  if (call11739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_parse11542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parse");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_moduleObject = getfromclosure(closure, 3);
  Object *var_defaultDefVisibility = getfromclosure(closure, 4);
  Object *var_defaultVarVisibility = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object *var_errormessages = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parse (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parse");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3518
  setline(3518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11543 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit11544 == NULL) {
    strlit11544 = alloc_String("parsing.");
    gc_root(strlit11544);
  }
// compiled string node returning strlit11544 (depth = 3)
  gc_frame_newslot(strlit11544);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit11544;
  partcv[0] = 1;
  Object call11545 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11543);
// compiled call node returning call11545 (depth = 2)
// Begin line 3519
  setline(3519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11546 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11548 = callmethod(*var_util, "modname",
    1, partcv, params);
  gc_frame_end(callframe11547);
// compiled call node returning call11548 (depth = 5)
// compiled member node returning call11548 (depth = 4)
  gc_frame_newslot(call11548);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call11550 = callmethod(*var_ast, "moduleNode",
    1, partcv, params);
  gc_frame_end(callframe11549);
// compiled call node returning call11550 (depth = 5)
// compiled member node returning call11550 (depth = 4)
  params[0] = *var_values;
  params[1] = call11548;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11551 = callmethod(call11550, "body()named",
    2, partcv, params);
  gc_frame_end(callframe11546);
// compiled call node returning call11551 (depth = 3)
  *var_moduleObject = call11551;
  if (call11551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3521
  setline(3521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11554 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11555 == NULL) {
    strlit11555 = alloc_String("DefaultVisibility");
    gc_root(strlit11555);
  }
// compiled string node returning strlit11555 (depth = 4)
  gc_frame_newslot(strlit11555);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11557 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11556);
// compiled call node returning call11557 (depth = 5)
// compiled member node returning call11557 (depth = 4)
  params[0] = strlit11555;
  partcv[0] = 1;
  Object call11558 = callmethod(call11557, "contains",
    1, partcv, params);
  gc_frame_end(callframe11554);
// compiled call node returning call11558 (depth = 3)
  Object if11553 = done;
  if (istrue(call11558)) {
// Begin line 3522
  setline(3522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11559 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11560 == NULL) {
    strlit11560 = alloc_String("DefaultVisibility");
    gc_root(strlit11560);
  }
// compiled string node returning strlit11560 (depth = 5)
  gc_frame_newslot(strlit11560);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11562 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11561);
// compiled call node returning call11562 (depth = 6)
// compiled member node returning call11562 (depth = 5)
  params[0] = strlit11560;
  partcv[0] = 1;
  Object call11563 = callmethod(call11562, "get",
    1, partcv, params);
  gc_frame_end(callframe11559);
// compiled call node returning call11563 (depth = 4)
  *var_defaultDefVisibility = call11563;
  if (call11563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11565 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11566 == NULL) {
    strlit11566 = alloc_String("DefaultVisibility");
    gc_root(strlit11566);
  }
// compiled string node returning strlit11566 (depth = 5)
  gc_frame_newslot(strlit11566);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11568 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11567);
// compiled call node returning call11568 (depth = 6)
// compiled member node returning call11568 (depth = 5)
  params[0] = strlit11566;
  partcv[0] = 1;
  Object call11569 = callmethod(call11568, "get",
    1, partcv, params);
  gc_frame_end(callframe11565);
// compiled call node returning call11569 (depth = 4)
  *var_defaultVarVisibility = call11569;
  if (call11569 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11553 = done;
  } else {
  }
// compiled if node returning if11553 (depth = 2)
// Begin line 3525
  setline(3525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11572 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11573 == NULL) {
    strlit11573 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11573);
  }
// compiled string node returning strlit11573 (depth = 4)
  gc_frame_newslot(strlit11573);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11575 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11574);
// compiled call node returning call11575 (depth = 5)
// compiled member node returning call11575 (depth = 4)
  params[0] = strlit11573;
  partcv[0] = 1;
  Object call11576 = callmethod(call11575, "contains",
    1, partcv, params);
  gc_frame_end(callframe11572);
// compiled call node returning call11576 (depth = 3)
  Object if11571 = done;
  if (istrue(call11576)) {
// Begin line 3526
  setline(3526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11577 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11578 == NULL) {
    strlit11578 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11578);
  }
// compiled string node returning strlit11578 (depth = 5)
  gc_frame_newslot(strlit11578);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11580 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11579);
// compiled call node returning call11580 (depth = 6)
// compiled member node returning call11580 (depth = 5)
  params[0] = strlit11578;
  partcv[0] = 1;
  Object call11581 = callmethod(call11580, "get",
    1, partcv, params);
  gc_frame_end(callframe11577);
// compiled call node returning call11581 (depth = 4)
  *var_defaultDefVisibility = call11581;
  if (call11581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11571 = done;
  } else {
  }
// compiled if node returning if11571 (depth = 2)
// Begin line 3528
  setline(3528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11584 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11585 == NULL) {
    strlit11585 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11585);
  }
// compiled string node returning strlit11585 (depth = 4)
  gc_frame_newslot(strlit11585);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11587 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11586);
// compiled call node returning call11587 (depth = 5)
// compiled member node returning call11587 (depth = 4)
  params[0] = strlit11585;
  partcv[0] = 1;
  Object call11588 = callmethod(call11587, "contains",
    1, partcv, params);
  gc_frame_end(callframe11584);
// compiled call node returning call11588 (depth = 3)
  Object if11583 = done;
  if (istrue(call11588)) {
// Begin line 3529
  setline(3529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11589 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11590 == NULL) {
    strlit11590 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11590);
  }
// compiled string node returning strlit11590 (depth = 5)
  gc_frame_newslot(strlit11590);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11592 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11591);
// compiled call node returning call11592 (depth = 6)
// compiled member node returning call11592 (depth = 5)
  params[0] = strlit11590;
  partcv[0] = 1;
  Object call11593 = callmethod(call11592, "get",
    1, partcv, params);
  gc_frame_end(callframe11589);
// compiled call node returning call11593 (depth = 4)
  *var_defaultVarVisibility = call11593;
  if (call11593 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11583 = done;
  } else {
  }
// compiled if node returning if11583 (depth = 2)
// Begin line 3531
  setline(3531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11597 = alloc_Float64(0);
// compiled num node returning num11597 (depth = 4)
  int op_slot_right_11596 = gc_frame_newslot(num11597);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_toks (depth = 6)
  partcv[0] = 0;
  Object call11600 = callmethod(*var_toks, "size",
    1, partcv, params);
  gc_frame_end(callframe11599);
// compiled call node returning call11600 (depth = 5)
// compiled member node returning call11600 (depth = 4)
  int op_slot_left_11596 = gc_frame_newslot(call11600);
  params[0] = num11597;
  partcv[0] = 1;
  Object opresult11601 = callmethod(call11600, "==", 1, partcv, params);
// compiled op node returning opresult11601 (depth = 3)
  Object if11595 = done;
  if (istrue(opresult11601)) {
// Begin line 3532
  setline(3532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11602 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11603 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11604 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11603);
// compiled call node returning call11604 (depth = 7)
// compiled member node returning call11604 (depth = 6)
  partcv[0] = 0;
  Object call11605 = callmethod(call11604, "empty",
    1, partcv, params);
  gc_frame_end(callframe11602);
// compiled call node returning call11605 (depth = 5)
// compiled member node returning call11605 (depth = 4)
  return call11605;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11595 = undefined;
  } else {
  }
// compiled if node returning if11595 (depth = 2)
// Begin line 3534
  setline(3534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3535
  setline(3535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11607 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11608 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11607);
// compiled call node returning call11608 (depth = 3)
// compiled member node returning call11608 (depth = 2)
// Begin line 3536
  setline(3536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11611 = alloc_Float64(0);
// compiled num node returning num11611 (depth = 4)
  int op_slot_right_11610 = gc_frame_newslot(num11611);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11614 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11613);
// compiled call node returning call11614 (depth = 5)
// compiled member node returning call11614 (depth = 4)
  int op_slot_left_11610 = gc_frame_newslot(call11614);
  params[0] = num11611;
  partcv[0] = 1;
  Object opresult11615 = callmethod(call11614, ">", 1, partcv, params);
// compiled op node returning opresult11615 (depth = 3)
  Object if11609 = done;
  if (istrue(opresult11615)) {
// Begin line 3537
  setline(3537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11616 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11617 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11618 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11617);
// compiled call node returning call11618 (depth = 7)
// compiled member node returning call11618 (depth = 6)
  partcv[0] = 0;
  Object call11619 = callmethod(call11618, "new",
    1, partcv, params);
  gc_frame_end(callframe11616);
// compiled call node returning call11619 (depth = 5)
// compiled member node returning call11619 (depth = 4)
  *var_sugg = call11619;
  if (call11619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3538
  setline(3538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11620 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num11621 = alloc_Float64(1);
// compiled num node returning num11621 (depth = 4)
  gc_frame_newslot(num11621);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11623 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11622);
// compiled call node returning call11623 (depth = 5)
// compiled member node returning call11623 (depth = 4)
  gc_frame_newslot(call11623);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11624 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11625 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11624);
// compiled call node returning call11625 (depth = 5)
// compiled member node returning call11625 (depth = 4)
  gc_frame_newslot(call11625);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num11621;
  params[1] = call11623;
  params[2] = call11625;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call11626 = callmethod(*var_sugg, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe11620);
// compiled call node returning call11626 (depth = 3)
// Begin line 3539
  setline(3539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11627 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11628 == NULL) {
    strlit11628 = alloc_String("the first line must not be indented.");
    gc_root(strlit11628);
  }
// compiled string node returning strlit11628 (depth = 4)
  gc_frame_newslot(strlit11628);
// Begin line 3540
  setline(3540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11630 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11629);
// compiled call node returning call11630 (depth = 5)
// compiled member node returning call11630 (depth = 4)
  gc_frame_newslot(call11630);
// starting to compile num node (depth = 4)
  Object num11631 = alloc_Float64(1);
// compiled num node returning num11631 (depth = 4)
  gc_frame_newslot(num11631);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11633 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11632);
// compiled call node returning call11633 (depth = 5)
// compiled member node returning call11633 (depth = 4)
  gc_frame_newslot(call11633);
// Begin line 3541
  setline(3541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3539
  setline(3539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11628;
  params[1] = call11630;
  params[2] = num11631;
  params[3] = call11633;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11634 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11627);
// compiled call node returning call11634 (depth = 3)
    gc_frame_newslot(call11634);
    if11609 = call11634;
  } else {
  }
// compiled if node returning if11609 (depth = 2)
// Begin line 3543
  setline(3543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call11636 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11635);
// compiled call node returning call11636 (depth = 4)
// compiled member node returning call11636 (depth = 3)
  *var_oldlength = call11636;
  if (call11636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3544
  setline(3544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11637 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block11638 = alloc_Block(NULL, NULL, "parser", 3544);
  gc_frame_newslot(block11638);
// method "_apply"
  block_savedest(block11638);
  Object closure11639 = createclosure(2, "_apply");
  setclosureframe(closure11639, stackframe);
  addtoclosure(closure11639, var_tokens);
  addtoclosure(closure11639, selfslot);
  struct UserObject *uo11639 = (struct UserObject*)block11638;
  uo11639->data[0] = (Object)closure11639;
  Method *meth_meth_parser__apply11639 = addmethod2pos(block11638, "_apply", &meth_parser__apply11639, 0);
  int argcv_meth_parser__apply11639[] = {0};
  meth_meth_parser__apply11639->type = alloc_MethodType(1, argcv_meth_parser__apply11639);
  meth_meth_parser__apply11639->definitionModule = modulename;
  meth_meth_parser__apply11639->definitionLine = 3543;
// compiled block node returning block11638 (depth = 3)
  gc_frame_newslot(block11638);
// starting to compile block node (depth = 3)
  Object block11647 = alloc_Block(NULL, NULL, "parser", 3544);
  gc_frame_newslot(block11647);
// method "_apply"
  block_savedest(block11647);
  Object closure11648 = createclosure(7, "_apply");
  setclosureframe(closure11648, stackframe);
  addtoclosure(closure11648, var_values);
  addtoclosure(closure11648, var_moduleObject);
  addtoclosure(closure11648, var_errormessages);
  addtoclosure(closure11648, var_oldlength);
  addtoclosure(closure11648, var_tokens);
  addtoclosure(closure11648, var_sym);
  addtoclosure(closure11648, selfslot);
  struct UserObject *uo11648 = (struct UserObject*)block11647;
  uo11648->data[0] = (Object)closure11648;
  Method *meth_meth_parser__apply11648 = addmethod2pos(block11647, "_apply", &meth_parser__apply11648, 0);
  int argcv_meth_parser__apply11648[] = {0};
  meth_meth_parser__apply11648->type = alloc_MethodType(1, argcv_meth_parser__apply11648);
  meth_meth_parser__apply11648->definitionModule = modulename;
  meth_meth_parser__apply11648->definitionLine = 3544;
// compiled block node returning block11647 (depth = 3)
  gc_frame_newslot(block11647);
// call case 5: prelude request
  params[0] = block11638;
  params[1] = block11647;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11742 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11637);
// compiled call node returning call11742 (depth = 2)
// Begin line 3574
  setline(3574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11744 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11743);
// compiled call node returning call11744 (depth = 3)
// compiled member node returning call11744 (depth = 2)
// Begin line 3575
  setline(3575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11745 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11746 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11745);
// compiled call node returning call11746 (depth = 3)
// compiled member node returning call11746 (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11748 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11747);
// compiled call node returning call11748 (depth = 3)
// compiled member node returning call11748 (depth = 2)
// Begin line 3577
  setline(3577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_blankLocation11750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankLocation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blankLocation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankLocation (depth = 3)
  gc_frame_end(frame);
  return *var_blankLocation;
}
Object meth_parser_blankLocation_58__61_11751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blankLocation:=");
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankLocation:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for blankLocation:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_blankLocation = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastLine11754(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lastLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastLine (depth = 3)
  gc_frame_end(frame);
  return *var_lastLine;
}
Object meth_parser_lastLine_58__61_11755(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastLine:=");
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lastLine:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastLine = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastIndent11758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lastIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_lastIndent_58__61_11759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lastIndent:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_indentFreePass11762(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for indentFreePass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_indentFreePass_58__61_11763(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indentFreePass:=");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for indentFreePass:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_minIndentLevel11766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for minIndentLevel");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_minIndentLevel_58__61_11767(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method minIndentLevel:=");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for minIndentLevel:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementIndent11770(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_statementIndent_58__61_11771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for statementIndent:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_tokens11774(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for tokens");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_tokens_58__61_11775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokens:=");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for tokens:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_values11781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_values_58__61_11782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method values:=");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for values:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_moduleObject11784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  gc_frame_end(frame);
  return *var_moduleObject;
}
Object meth_parser_moduleObject_58__61_11785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method moduleObject:=");
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for moduleObject:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_moduleObject = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comments11791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for comments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  gc_frame_end(frame);
  return *var_comments;
}
Object meth_parser_comments_58__61_11792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comments:=");
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for comments:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comments = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_auto_count11795(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for auto_count");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_auto_count_58__61_11796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method auto_count:=");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for auto_count:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_noBlocks11799(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for noBlocks (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for noBlocks");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_blocksOK11801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blocksOK (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blocksOK");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_braceIsType11803(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 105, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for braceIsType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for braceIsType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_braceIsType (depth = 3)
  gc_frame_end(frame);
  return *var_braceIsType;
}
Object meth_parser_braceIsType_58__61_11804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 106, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method braceIsType:=");
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for braceIsType:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for braceIsType:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_braceIsType = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultDefVisibility11807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 107, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defaultDefVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defaultDefVisibility");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultDefVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultDefVisibility;
}
Object meth_parser_defaultDefVisibility_58__61_11808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 108, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method defaultDefVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defaultDefVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for defaultDefVisibility:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultDefVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultVarVisibility11811(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 109, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defaultVarVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defaultVarVisibility");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultVarVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultVarVisibility;
}
Object meth_parser_defaultVarVisibility_58__61_11812(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 110, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method defaultVarVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defaultVarVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for defaultVarVisibility:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultVarVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultMethodVisibility11815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 111, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defaultMethodVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defaultMethodVisibility");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultMethodVisibility;
}
Object meth_parser_defaultMethodVisibility_58__61_11816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 112, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method defaultMethodVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defaultMethodVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for defaultMethodVisibility:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultMethodVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_emptySequence11822(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 113, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for emptySequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for emptySequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_parser_sym11837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 114, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sym");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_sym_58__61_11838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 115, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sym:=");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sym:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastToken11840(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 116, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lastToken");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_lastToken_58__61_11841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 117, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastToken:=");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lastToken:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_previousCommentToken11843(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 118, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for previousCommentToken");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_previousCommentToken (depth = 3)
  gc_frame_end(frame);
  return *var_previousCommentToken;
}
Object meth_parser_previousCommentToken_58__61_11844(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 119, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method previousCommentToken:=");
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for previousCommentToken:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_previousCommentToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementToken11846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 120, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementToken");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_statementToken_58__61_11847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 121, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementToken:=");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for statementToken:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comment11850(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 122, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for comment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_comment_58__61_11851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 123, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comment:=");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for comment:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_firstCallOfNext11854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 124, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for firstCallOfNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for firstCallOfNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_firstCallOfNext (depth = 3)
  gc_frame_end(frame);
  return *var_firstCallOfNext;
}
Object meth_parser_firstCallOfNext_58__61_11855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 125, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method firstCallOfNext:=");
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for firstCallOfNext:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for firstCallOfNext:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_firstCallOfNext = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(128, 128);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(128, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
  Object *var_io = alloc_var();
  Object *var_ast = alloc_var();
  Object *var_util = alloc_var();
  Object *var_errormessages = alloc_var();
  Object *var_blankLocation = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "blankLocation");
  Object *var_lastLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lastLine");
  Object *var_lastIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "statementIndent");
  Object *var_tokens = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "tokens");
  Object *var_values = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "values");
  Object *var_moduleObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "moduleObject");
  Object *var_comments = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "comments");
  Object *var_auto_count = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "blocksOK");
  Object *var_braceIsType = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "braceIsType");
  Object *var_defaultDefVisibility = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "defaultDefVisibility");
  Object *var_defaultVarVisibility = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "defaultVarVisibility");
  Object *var_defaultMethodVisibility = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "defaultMethodVisibility");
  Object *var_emptySequence = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "emptySequence");
  Object *var_sym = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "sym");
  Object *var_lastToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "lastToken");
  Object *var_previousCommentToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "previousCommentToken");
  Object *var_statementToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "statementToken");
  Object *var_comment = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "comment");
  Object *var_firstCallOfNext = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "firstCallOfNext");
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "noteBlank"
  block_savedest(self);
  Object closure1 = createclosure(2, "noteBlank");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_sym);
  addtoclosure(closure1, var_blankLocation);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_parser_noteBlank1 = addmethod2pos(self, "noteBlank", &meth_parser_noteBlank1, 1);
  int argcv_meth_parser_noteBlank1[] = {0};
  meth_meth_parser_noteBlank1->type = alloc_MethodType(1, argcv_meth_parser_noteBlank1);
  meth_meth_parser_noteBlank1->definitionModule = modulename;
  meth_meth_parser_noteBlank1->definitionLine = 40;
// compiled method node returning  (depth = 1)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "next"
  block_savedest(self);
  Object closure9 = createclosure(7, "next");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_tokens);
  addtoclosure(closure9, var_sym);
  addtoclosure(closure9, var_lastToken);
  addtoclosure(closure9, var_lastLine);
  addtoclosure(closure9, var_lastIndent);
  addtoclosure(closure9, var_util);
  addtoclosure(closure9, var_errormessages);
  struct UserObject *uo9 = (struct UserObject*)self;
  uo9->data[2] = (Object)closure9;
  Method *meth_meth_parser_next9 = addmethod2pos(self, "next", &meth_parser_next9, 2);
  int argcv_meth_parser_next9[] = {0};
  meth_meth_parser_next9->type = alloc_MethodType(1, argcv_meth_parser_next9);
  meth_meth_parser_next9->definitionModule = modulename;
  meth_meth_parser_next9->definitionLine = 46;
// compiled method node returning  (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextToken"
  block_savedest(self);
  Object closure60 = createclosure(2, "findNextToken");
  setclosureframe(closure60, stackframe);
  addtoclosure(closure60, var_sym);
  addtoclosure(closure60, var_lastToken);
  struct UserObject *uo60 = (struct UserObject*)self;
  uo60->data[3] = (Object)closure60;
  Method *meth_meth_parser_findNextToken60 = addmethod2pos(self, "findNextToken", &meth_parser_findNextToken60, 3);
  int argcv_meth_parser_findNextToken60[] = {1};
  meth_meth_parser_findNextToken60->type = alloc_MethodType(1, argcv_meth_parser_findNextToken60);
  meth_meth_parser_findNextToken60->definitionModule = modulename;
  meth_meth_parser_findNextToken60->definitionLine = 66;
// compiled method node returning  (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextTokenIndentedAt"
  block_savedest(self);
  Object closure105 = createclosure(1, "findNextTokenIndentedAt");
  setclosureframe(closure105, stackframe);
  addtoclosure(closure105, var_sym);
  struct UserObject *uo105 = (struct UserObject*)self;
  uo105->data[4] = (Object)closure105;
  Method *meth_meth_parser_findNextTokenIndentedAt105 = addmethod2pos(self, "findNextTokenIndentedAt", &meth_parser_findNextTokenIndentedAt105, 4);
  int argcv_meth_parser_findNextTokenIndentedAt105[] = {1};
  meth_meth_parser_findNextTokenIndentedAt105->type = alloc_MethodType(1, argcv_meth_parser_findNextTokenIndentedAt105);
  meth_meth_parser_findNextTokenIndentedAt105->definitionModule = modulename;
  meth_meth_parser_findNextTokenIndentedAt105->definitionLine = 84;
// compiled method node returning  (depth = 1)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextValidToken"
  block_savedest(self);
  Object closure186 = createclosure(1, "findNextValidToken");
  setclosureframe(closure186, stackframe);
  addtoclosure(closure186, var_sym);
  struct UserObject *uo186 = (struct UserObject*)self;
  uo186->data[5] = (Object)closure186;
  Method *meth_meth_parser_findNextValidToken186 = addmethod2pos(self, "findNextValidToken", &meth_parser_findNextValidToken186, 5);
  int argcv_meth_parser_findNextValidToken186[] = {1};
  meth_meth_parser_findNextValidToken186->type = alloc_MethodType(1, argcv_meth_parser_findNextValidToken186);
  meth_meth_parser_findNextValidToken186->definitionModule = modulename;
  meth_meth_parser_findNextValidToken186->definitionLine = 99;
// compiled method node returning  (depth = 1)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findClosingBrace"
  block_savedest(self);
  Object closure228 = createclosure(1, "findClosingBrace");
  setclosureframe(closure228, stackframe);
  addtoclosure(closure228, var_sym);
  struct UserObject *uo228 = (struct UserObject*)self;
  uo228->data[6] = (Object)closure228;
  Method *meth_meth_parser_findClosingBrace228 = addmethod2pos(self, "findClosingBrace", &meth_parser_findClosingBrace228, 6);
  int argcv_meth_parser_findClosingBrace228[] = {2};
  meth_meth_parser_findClosingBrace228->type = alloc_MethodType(1, argcv_meth_parser_findClosingBrace228);
  meth_meth_parser_findClosingBrace228->definitionModule = modulename;
  meth_meth_parser_findClosingBrace228->definitionLine = 124;
// compiled method node returning  (depth = 1)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept"
  block_savedest(self);
  Object closure380 = createclosure(1, "accept");
  setclosureframe(closure380, stackframe);
  addtoclosure(closure380, var_sym);
  struct UserObject *uo380 = (struct UserObject*)self;
  uo380->data[7] = (Object)closure380;
  Method *meth_meth_parser_accept380 = addmethod2pos(self, "accept", &meth_parser_accept380, 7);
  int argcv_meth_parser_accept380[] = {1};
  meth_meth_parser_accept380->type = alloc_MethodType(1, argcv_meth_parser_accept380);
  meth_meth_parser_accept380->definitionModule = modulename;
  meth_meth_parser_accept380->definitionLine = 162;
// compiled method node returning  (depth = 1)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptKeyword"
  block_savedest(self);
  Object closure386 = createclosure(1, "acceptKeyword");
  setclosureframe(closure386, stackframe);
  addtoclosure(closure386, var_sym);
  struct UserObject *uo386 = (struct UserObject*)self;
  uo386->data[8] = (Object)closure386;
  Method *meth_meth_parser_acceptKeyword386 = addmethod2pos(self, "acceptKeyword", &meth_parser_acceptKeyword386, 8);
  int argcv_meth_parser_acceptKeyword386[] = {1};
  meth_meth_parser_acceptKeyword386->type = alloc_MethodType(1, argcv_meth_parser_acceptKeyword386);
  meth_meth_parser_acceptKeyword386->definitionModule = modulename;
  meth_meth_parser_acceptKeyword386->definitionLine = 168;
// compiled method node returning  (depth = 1)
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptSameLine"
  block_savedest(self);
  Object closure400 = createclosure(3, "acceptSameLine");
  setclosureframe(closure400, stackframe);
  addtoclosure(closure400, var_lastIndent);
  addtoclosure(closure400, var_sym);
  addtoclosure(closure400, var_lastLine);
  struct UserObject *uo400 = (struct UserObject*)self;
  uo400->data[9] = (Object)closure400;
  Method *meth_meth_parser_acceptSameLine400 = addmethod2pos(self, "acceptSameLine", &meth_parser_acceptSameLine400, 9);
  int argcv_meth_parser_acceptSameLine400[] = {1};
  meth_meth_parser_acceptSameLine400->type = alloc_MethodType(1, argcv_meth_parser_acceptSameLine400);
  meth_meth_parser_acceptSameLine400->definitionModule = modulename;
  meth_meth_parser_acceptSameLine400->definitionLine = 173;
// compiled method node returning  (depth = 1)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptWithoutSpaces"
  block_savedest(self);
  Object closure422 = createclosure(3, "acceptWithoutSpaces");
  setclosureframe(closure422, stackframe);
  addtoclosure(closure422, var_lastToken);
  addtoclosure(closure422, var_sym);
  addtoclosure(closure422, var_lastLine);
  struct UserObject *uo422 = (struct UserObject*)self;
  uo422->data[10] = (Object)closure422;
  Method *meth_meth_parser_acceptWithoutSpaces422 = addmethod2pos(self, "acceptWithoutSpaces", &meth_parser_acceptWithoutSpaces422, 10);
  int argcv_meth_parser_acceptWithoutSpaces422[] = {1};
  meth_meth_parser_acceptWithoutSpaces422->type = alloc_MethodType(1, argcv_meth_parser_acceptWithoutSpaces422);
  meth_meth_parser_acceptWithoutSpaces422->definitionModule = modulename;
  meth_meth_parser_acceptWithoutSpaces422->definitionLine = 181;
// compiled method node returning  (depth = 1)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptAfterSpaces"
  block_savedest(self);
  Object closure451 = createclosure(3, "acceptAfterSpaces");
  setclosureframe(closure451, stackframe);
  addtoclosure(closure451, var_sym);
  addtoclosure(closure451, var_lastLine);
  addtoclosure(closure451, var_lastToken);
  struct UserObject *uo451 = (struct UserObject*)self;
  uo451->data[11] = (Object)closure451;
  Method *meth_meth_parser_acceptAfterSpaces451 = addmethod2pos(self, "acceptAfterSpaces", &meth_parser_acceptAfterSpaces451, 11);
  int argcv_meth_parser_acceptAfterSpaces451[] = {1};
  meth_meth_parser_acceptAfterSpaces451->type = alloc_MethodType(1, argcv_meth_parser_acceptAfterSpaces451);
  meth_meth_parser_acceptAfterSpaces451->definitionModule = modulename;
  meth_meth_parser_acceptAfterSpaces451->definitionLine = 188;
// compiled method node returning  (depth = 1)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept()onLineOf"
  block_savedest(self);
  Object closure488 = createclosure(1, "accept()onLineOf");
  setclosureframe(closure488, stackframe);
  addtoclosure(closure488, var_sym);
  struct UserObject *uo488 = (struct UserObject*)self;
  uo488->data[12] = (Object)closure488;
  Method *meth_meth_parser_accept_40__41_onLineOf488 = addmethod2pos(self, "accept()onLineOf", &meth_parser_accept_40__41_onLineOf488, 12);
  int argcv_meth_parser_accept_40__41_onLineOf488[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOf488->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOf488);
  meth_meth_parser_accept_40__41_onLineOf488->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOf488->definitionLine = 198;
// compiled method node returning  (depth = 1)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptAfterSpaces()onLineOf"
  block_savedest(self);
  Object closure514 = createclosure(2, "acceptAfterSpaces()onLineOf");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, var_sym);
  addtoclosure(closure514, var_lastToken);
  struct UserObject *uo514 = (struct UserObject*)self;
  uo514->data[13] = (Object)closure514;
  Method *meth_meth_parser_acceptAfterSpaces_40__41_onLineOf514 = addmethod2pos(self, "acceptAfterSpaces()onLineOf", &meth_parser_acceptAfterSpaces_40__41_onLineOf514, 13);
  int argcv_meth_parser_acceptAfterSpaces_40__41_onLineOf514[] = {1, 1};
  meth_meth_parser_acceptAfterSpaces_40__41_onLineOf514->type = alloc_MethodType(2, argcv_meth_parser_acceptAfterSpaces_40__41_onLineOf514);
  meth_meth_parser_acceptAfterSpaces_40__41_onLineOf514->definitionModule = modulename;
  meth_meth_parser_acceptAfterSpaces_40__41_onLineOf514->definitionLine = 205;
// compiled method node returning  (depth = 1)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept()onLineOfLastOr"
  block_savedest(self);
  Object closure553 = createclosure(2, "accept()onLineOfLastOr");
  setclosureframe(closure553, stackframe);
  addtoclosure(closure553, var_sym);
  addtoclosure(closure553, var_lastToken);
  struct UserObject *uo553 = (struct UserObject*)self;
  uo553->data[14] = (Object)closure553;
  Method *meth_meth_parser_accept_40__41_onLineOfLastOr553 = addmethod2pos(self, "accept()onLineOfLastOr", &meth_parser_accept_40__41_onLineOfLastOr553, 14);
  int argcv_meth_parser_accept_40__41_onLineOfLastOr553[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOfLastOr553->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOfLastOr553);
  meth_meth_parser_accept_40__41_onLineOfLastOr553->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOfLastOr553->definitionLine = 217;
// compiled method node returning  (depth = 1)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptArgumentOnLineOf"
  block_savedest(self);
  Object closure589 = createclosure(1, "acceptArgumentOnLineOf");
  setclosureframe(closure589, stackframe);
  addtoclosure(closure589, var_sym);
  struct UserObject *uo589 = (struct UserObject*)self;
  uo589->data[15] = (Object)closure589;
  Method *meth_meth_parser_acceptArgumentOnLineOf589 = addmethod2pos(self, "acceptArgumentOnLineOf", &meth_parser_acceptArgumentOnLineOf589, 15);
  int argcv_meth_parser_acceptArgumentOnLineOf589[] = {1};
  meth_meth_parser_acceptArgumentOnLineOf589->type = alloc_MethodType(1, argcv_meth_parser_acceptArgumentOnLineOf589);
  meth_meth_parser_acceptArgumentOnLineOf589->definitionModule = modulename;
  meth_meth_parser_acceptArgumentOnLineOf589->definitionLine = 223;
// compiled method node returning  (depth = 1)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnSameLine"
  block_savedest(self);
  Object closure630 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure630, stackframe);
  addtoclosure(closure630, var_lastIndent);
  addtoclosure(closure630, var_sym);
  addtoclosure(closure630, var_lastLine);
  struct UserObject *uo630 = (struct UserObject*)self;
  uo630->data[16] = (Object)closure630;
  Method *meth_meth_parser_tokenOnSameLine630 = addmethod2pos(self, "tokenOnSameLine", &meth_parser_tokenOnSameLine630, 16);
  int argcv_meth_parser_tokenOnSameLine630[] = {0};
  meth_meth_parser_tokenOnSameLine630->type = alloc_MethodType(1, argcv_meth_parser_tokenOnSameLine630);
  meth_meth_parser_tokenOnSameLine630->definitionModule = modulename;
  meth_meth_parser_tokenOnSameLine630->definitionLine = 234;
// compiled method node returning  (depth = 1)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didConsume"
  block_savedest(self);
  Object closure644 = createclosure(1, "didConsume");
  setclosureframe(closure644, stackframe);
  addtoclosure(closure644, var_tokens);
  struct UserObject *uo644 = (struct UserObject*)self;
  uo644->data[17] = (Object)closure644;
  Method *meth_meth_parser_didConsume644 = addmethod2pos(self, "didConsume", &meth_parser_didConsume644, 17);
  int argcv_meth_parser_didConsume644[] = {1};
  meth_meth_parser_didConsume644->type = alloc_MethodType(1, argcv_meth_parser_didConsume644);
  meth_meth_parser_didConsume644->definitionModule = modulename;
  meth_meth_parser_didConsume644->definitionLine = 238;
// compiled method node returning  (depth = 1)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "ifConsume()then"
  block_savedest(self);
  Object closure654 = createclosure(1, "ifConsume()then");
  setclosureframe(closure654, stackframe);
  addtoclosure(closure654, var_tokens);
  struct UserObject *uo654 = (struct UserObject*)self;
  uo654->data[18] = (Object)closure654;
  Method *meth_meth_parser_ifConsume_40__41_then654 = addmethod2pos(self, "ifConsume()then", &meth_parser_ifConsume_40__41_then654, 18);
  int argcv_meth_parser_ifConsume_40__41_then654[] = {1, 1};
  meth_meth_parser_ifConsume_40__41_then654->type = alloc_MethodType(2, argcv_meth_parser_ifConsume_40__41_then654);
  meth_meth_parser_ifConsume_40__41_then654->definitionModule = modulename;
  meth_meth_parser_ifConsume_40__41_then654->definitionLine = 244;
// compiled method node returning  (depth = 1)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushnum"
  block_savedest(self);
  Object closure667 = createclosure(3, "pushnum");
  setclosureframe(closure667, stackframe);
  addtoclosure(closure667, var_sym);
  addtoclosure(closure667, var_ast);
  addtoclosure(closure667, var_values);
  struct UserObject *uo667 = (struct UserObject*)self;
  uo667->data[19] = (Object)closure667;
  Method *meth_meth_parser_pushnum667 = addmethod2pos(self, "pushnum", &meth_parser_pushnum667, 19);
  int argcv_meth_parser_pushnum667[] = {0};
  meth_meth_parser_pushnum667->type = alloc_MethodType(1, argcv_meth_parser_pushnum667);
  meth_meth_parser_pushnum667->definitionModule = modulename;
  meth_meth_parser_pushnum667->definitionLine = 254;
// compiled method node returning  (depth = 1)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushoctets"
  block_savedest(self);
  Object closure678 = createclosure(3, "pushoctets");
  setclosureframe(closure678, stackframe);
  addtoclosure(closure678, var_sym);
  addtoclosure(closure678, var_ast);
  addtoclosure(closure678, var_values);
  struct UserObject *uo678 = (struct UserObject*)self;
  uo678->data[20] = (Object)closure678;
  Method *meth_meth_parser_pushoctets678 = addmethod2pos(self, "pushoctets", &meth_parser_pushoctets678, 20);
  int argcv_meth_parser_pushoctets678[] = {0};
  meth_meth_parser_pushoctets678->type = alloc_MethodType(1, argcv_meth_parser_pushoctets678);
  meth_meth_parser_pushoctets678->definitionModule = modulename;
  meth_meth_parser_pushoctets678->definitionLine = 261;
// compiled method node returning  (depth = 1)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushstring"
  block_savedest(self);
  Object closure689 = createclosure(3, "pushstring");
  setclosureframe(closure689, stackframe);
  addtoclosure(closure689, var_sym);
  addtoclosure(closure689, var_ast);
  addtoclosure(closure689, var_values);
  struct UserObject *uo689 = (struct UserObject*)self;
  uo689->data[21] = (Object)closure689;
  Method *meth_meth_parser_pushstring689 = addmethod2pos(self, "pushstring", &meth_parser_pushstring689, 21);
  int argcv_meth_parser_pushstring689[] = {0};
  meth_meth_parser_pushstring689->type = alloc_MethodType(1, argcv_meth_parser_pushstring689);
  meth_meth_parser_pushstring689->definitionModule = modulename;
  meth_meth_parser_pushstring689->definitionLine = 268;
// compiled method node returning  (depth = 1)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushidentifier"
  block_savedest(self);
  Object closure700 = createclosure(5, "pushidentifier");
  setclosureframe(closure700, stackframe);
  addtoclosure(closure700, var_sym);
  addtoclosure(closure700, var_util);
  addtoclosure(closure700, var_ast);
  addtoclosure(closure700, var_auto_count);
  addtoclosure(closure700, var_values);
  struct UserObject *uo700 = (struct UserObject*)self;
  uo700->data[22] = (Object)closure700;
  Method *meth_meth_parser_pushidentifier700 = addmethod2pos(self, "pushidentifier", &meth_parser_pushidentifier700, 22);
  int argcv_meth_parser_pushidentifier700[] = {0};
  meth_meth_parser_pushidentifier700->type = alloc_MethodType(1, argcv_meth_parser_pushidentifier700);
  meth_meth_parser_pushidentifier700->definitionModule = modulename;
  meth_meth_parser_pushidentifier700->definitionLine = 276;
// compiled method node returning  (depth = 1)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "adjustVisibilityOf()withSpecialDefault()overriding"
  block_savedest(self);
  Object closure739 = createclosure(2, "adjustVisibilityOf()withSpecialDefault()overriding");
  setclosureframe(closure739, stackframe);
  addtoclosure(closure739, var_done);
  addtoclosure(closure739, var_ast);
  struct UserObject *uo739 = (struct UserObject*)self;
  uo739->data[23] = (Object)closure739;
  Method *meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739 = addmethod2pos(self, "adjustVisibilityOf()withSpecialDefault()overriding", &meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739, 23);
  int argcv_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739[] = {1, 1, 1};
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739->type = alloc_MethodType(3, argcv_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739);
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739->definitionModule = modulename;
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding739->definitionLine = 288;
// compiled method node returning  (depth = 1)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkAnnotation"
  block_savedest(self);
  Object closure795 = createclosure(2, "checkAnnotation");
  setclosureframe(closure795, stackframe);
  addtoclosure(closure795, var_sym);
  addtoclosure(closure795, var_errormessages);
  struct UserObject *uo795 = (struct UserObject*)self;
  uo795->data[24] = (Object)closure795;
  Method *meth_meth_parser_checkAnnotation795 = addmethod2pos(self, "checkAnnotation", &meth_parser_checkAnnotation795, 24);
  int argcv_meth_parser_checkAnnotation795[] = {1};
  meth_meth_parser_checkAnnotation795->type = alloc_MethodType(1, argcv_meth_parser_checkAnnotation795);
  meth_meth_parser_checkAnnotation795->definitionModule = modulename;
  meth_meth_parser_checkAnnotation795->definitionLine = 304;
// compiled method node returning  (depth = 1)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doannotation"
  block_savedest(self);
  Object closure884 = createclosure(5, "doannotation");
  setclosureframe(closure884, stackframe);
  addtoclosure(closure884, var_noBlocks);
  addtoclosure(closure884, var_errormessages);
  addtoclosure(closure884, var_sym);
  addtoclosure(closure884, var_lastToken);
  addtoclosure(closure884, var_values);
  struct UserObject *uo884 = (struct UserObject*)self;
  uo884->data[25] = (Object)closure884;
  Method *meth_meth_parser_doannotation884 = addmethod2pos(self, "doannotation", &meth_parser_doannotation884, 25);
  int argcv_meth_parser_doannotation884[] = {0};
  meth_meth_parser_doannotation884->type = alloc_MethodType(1, argcv_meth_parser_doannotation884);
  meth_meth_parser_doannotation884->definitionModule = modulename;
  meth_meth_parser_doannotation884->definitionLine = 322;
// compiled method node returning  (depth = 1)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blank"
  block_savedest(self);
  Object closure1057 = createclosure(8, "blank");
  setclosureframe(closure1057, stackframe);
  addtoclosure(closure1057, var_blankLocation);
  addtoclosure(closure1057, var_lastToken);
  addtoclosure(closure1057, var_sym);
  addtoclosure(closure1057, var_done);
  addtoclosure(closure1057, var_previousCommentToken);
  addtoclosure(closure1057, var_values);
  addtoclosure(closure1057, var_util);
  addtoclosure(closure1057, var_ast);
  struct UserObject *uo1057 = (struct UserObject*)self;
  uo1057->data[26] = (Object)closure1057;
  Method *meth_meth_parser_blank1057 = addmethod2pos(self, "blank", &meth_parser_blank1057, 26);
  int argcv_meth_parser_blank1057[] = {0};
  meth_meth_parser_blank1057->type = alloc_MethodType(1, argcv_meth_parser_blank1057);
  meth_meth_parser_blank1057->definitionModule = modulename;
  meth_meth_parser_blank1057->definitionLine = 368;
// compiled method node returning  (depth = 1)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeterm"
  block_savedest(self);
  Object closure1143 = createclosure(1, "dotypeterm");
  setclosureframe(closure1143, stackframe);
  addtoclosure(closure1143, var_noBlocks);
  struct UserObject *uo1143 = (struct UserObject*)self;
  uo1143->data[27] = (Object)closure1143;
  Method *meth_meth_parser_dotypeterm1143 = addmethod2pos(self, "dotypeterm", &meth_parser_dotypeterm1143, 27);
  int argcv_meth_parser_dotypeterm1143[] = {0};
  meth_meth_parser_dotypeterm1143->type = alloc_MethodType(1, argcv_meth_parser_dotypeterm1143);
  meth_meth_parser_dotypeterm1143->definitionModule = modulename;
  meth_meth_parser_dotypeterm1143->definitionLine = 386;
// compiled method node returning  (depth = 1)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpression"
  block_savedest(self);
  Object closure1160 = createclosure(6, "typeexpression");
  setclosureframe(closure1160, stackframe);
  addtoclosure(closure1160, var_values);
  addtoclosure(closure1160, var_statementToken);
  addtoclosure(closure1160, var_sym);
  addtoclosure(closure1160, var_errormessages);
  addtoclosure(closure1160, var_lastToken);
  addtoclosure(closure1160, var_noBlocks);
  struct UserObject *uo1160 = (struct UserObject*)self;
  uo1160->data[28] = (Object)closure1160;
  Method *meth_meth_parser_typeexpression1160 = addmethod2pos(self, "typeexpression", &meth_parser_typeexpression1160, 28);
  int argcv_meth_parser_typeexpression1160[] = {0};
  meth_meth_parser_typeexpression1160->type = alloc_MethodType(1, argcv_meth_parser_typeexpression1160);
  meth_meth_parser_typeexpression1160->definitionModule = modulename;
  meth_meth_parser_typeexpression1160->definitionLine = 398;
// compiled method node returning  (depth = 1)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "newIf"
  block_savedest(self);
  Object closure1252 = createclosure(2, "newIf");
  setclosureframe(closure1252, stackframe);
  addtoclosure(closure1252, var_emptySequence);
  addtoclosure(closure1252, var_ast);
  struct UserObject *uo1252 = (struct UserObject*)self;
  uo1252->data[29] = (Object)closure1252;
  Method *meth_meth_parser_newIf1252 = addmethod2pos(self, "newIf", &meth_parser_newIf1252, 29);
  int argcv_meth_parser_newIf1252[] = {3};
  meth_meth_parser_newIf1252->type = alloc_MethodType(1, argcv_meth_parser_newIf1252);
  meth_meth_parser_newIf1252->definitionModule = modulename;
  meth_meth_parser_newIf1252->definitionLine = 435;
// compiled method node returning  (depth = 1)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "block"
  block_savedest(self);
  Object closure1265 = createclosure(12, "block");
  setclosureframe(closure1265, stackframe);
  addtoclosure(closure1265, var_sym);
  addtoclosure(closure1265, var_statementIndent);
  addtoclosure(closure1265, var_statementToken);
  addtoclosure(closure1265, var_blocksOK);
  addtoclosure(closure1265, var_values);
  addtoclosure(closure1265, var_braceIsType);
  addtoclosure(closure1265, var_errormessages);
  addtoclosure(closure1265, var_lastToken);
  addtoclosure(closure1265, var_indentFreePass);
  addtoclosure(closure1265, var_util);
  addtoclosure(closure1265, var_ast);
  addtoclosure(closure1265, var_minIndentLevel);
  struct UserObject *uo1265 = (struct UserObject*)self;
  uo1265->data[30] = (Object)closure1265;
  Method *meth_meth_parser_block1265 = addmethod2pos(self, "block", &meth_parser_block1265, 30);
  int argcv_meth_parser_block1265[] = {0};
  meth_meth_parser_block1265->type = alloc_MethodType(1, argcv_meth_parser_block1265);
  meth_meth_parser_block1265->definitionModule = modulename;
  meth_meth_parser_block1265->definitionLine = 441;
// compiled method node returning  (depth = 1)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doif"
  block_savedest(self);
  Object closure1802 = createclosure(9, "doif");
  setclosureframe(closure1802, stackframe);
  addtoclosure(closure1802, var_sym);
  addtoclosure(closure1802, var_errormessages);
  addtoclosure(closure1802, var_blocksOK);
  addtoclosure(closure1802, var_lastToken);
  addtoclosure(closure1802, var_values);
  addtoclosure(closure1802, var_minIndentLevel);
  addtoclosure(closure1802, var_statementIndent);
  addtoclosure(closure1802, var_statementToken);
  addtoclosure(closure1802, var_util);
  struct UserObject *uo1802 = (struct UserObject*)self;
  uo1802->data[31] = (Object)closure1802;
  Method *meth_meth_parser_doif1802 = addmethod2pos(self, "doif", &meth_parser_doif1802, 31);
  int argcv_meth_parser_doif1802[] = {0};
  meth_meth_parser_doif1802->type = alloc_MethodType(1, argcv_meth_parser_doif1802);
  meth_meth_parser_doif1802->definitionModule = modulename;
  meth_meth_parser_doif1802->definitionLine = 613;
// compiled method node returning  (depth = 1)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "identifier"
  block_savedest(self);
  Object closure3266 = createclosure(1, "identifier");
  setclosureframe(closure3266, stackframe);
  addtoclosure(closure3266, var_sym);
  struct UserObject *uo3266 = (struct UserObject*)self;
  uo3266->data[32] = (Object)closure3266;
  Method *meth_meth_parser_identifier3266 = addmethod2pos(self, "identifier", &meth_parser_identifier3266, 32);
  int argcv_meth_parser_identifier3266[] = {0};
  meth_meth_parser_identifier3266->type = alloc_MethodType(1, argcv_meth_parser_identifier3266);
  meth_meth_parser_identifier3266->definitionModule = modulename;
  meth_meth_parser_identifier3266->definitionLine = 1015;
// compiled method node returning  (depth = 1)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "prefixop"
  block_savedest(self);
  Object closure3282 = createclosure(6, "prefixop");
  setclosureframe(closure3282, stackframe);
  addtoclosure(closure3282, var_sym);
  addtoclosure(closure3282, var_blocksOK);
  addtoclosure(closure3282, var_errormessages);
  addtoclosure(closure3282, var_lastToken);
  addtoclosure(closure3282, var_values);
  addtoclosure(closure3282, var_ast);
  struct UserObject *uo3282 = (struct UserObject*)self;
  uo3282->data[33] = (Object)closure3282;
  Method *meth_meth_parser_prefixop3282 = addmethod2pos(self, "prefixop", &meth_parser_prefixop3282, 33);
  int argcv_meth_parser_prefixop3282[] = {0};
  meth_meth_parser_prefixop3282->type = alloc_MethodType(1, argcv_meth_parser_prefixop3282);
  meth_meth_parser_prefixop3282->definitionModule = modulename;
  meth_meth_parser_prefixop3282->definitionLine = 1025;
// compiled method node returning  (depth = 1)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "generic"
  block_savedest(self);
  Object closure3475 = createclosure(5, "generic");
  setclosureframe(closure3475, stackframe);
  addtoclosure(closure3475, var_values);
  addtoclosure(closure3475, var_sym);
  addtoclosure(closure3475, var_errormessages);
  addtoclosure(closure3475, var_lastToken);
  addtoclosure(closure3475, var_ast);
  struct UserObject *uo3475 = (struct UserObject*)self;
  uo3475->data[34] = (Object)closure3475;
  Method *meth_meth_parser_generic3475 = addmethod2pos(self, "generic", &meth_parser_generic3475, 34);
  int argcv_meth_parser_generic3475[] = {0};
  meth_meth_parser_generic3475->type = alloc_MethodType(1, argcv_meth_parser_generic3475);
  meth_meth_parser_generic3475->definitionModule = modulename;
  meth_meth_parser_generic3475->definitionLine = 1082;
// compiled method node returning  (depth = 1)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "trycatch"
  block_savedest(self);
  Object closure3664 = createclosure(9, "trycatch");
  setclosureframe(closure3664, stackframe);
  addtoclosure(closure3664, var_sym);
  addtoclosure(closure3664, var_minIndentLevel);
  addtoclosure(closure3664, var_errormessages);
  addtoclosure(closure3664, var_lastToken);
  addtoclosure(closure3664, var_blocksOK);
  addtoclosure(closure3664, var_values);
  addtoclosure(closure3664, var_tokens);
  addtoclosure(closure3664, var_util);
  addtoclosure(closure3664, var_ast);
  struct UserObject *uo3664 = (struct UserObject*)self;
  uo3664->data[35] = (Object)closure3664;
  Method *meth_meth_parser_trycatch3664 = addmethod2pos(self, "trycatch", &meth_parser_trycatch3664, 35);
  int argcv_meth_parser_trycatch3664[] = {0};
  meth_meth_parser_trycatch3664->type = alloc_MethodType(1, argcv_meth_parser_trycatch3664);
  meth_meth_parser_trycatch3664->definitionModule = modulename;
  meth_meth_parser_trycatch3664->definitionLine = 1142;
// compiled method node returning  (depth = 1)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "matchcase"
  block_savedest(self);
  Object closure4271 = createclosure(9, "matchcase");
  setclosureframe(closure4271, stackframe);
  addtoclosure(closure4271, var_sym);
  addtoclosure(closure4271, var_minIndentLevel);
  addtoclosure(closure4271, var_errormessages);
  addtoclosure(closure4271, var_blocksOK);
  addtoclosure(closure4271, var_lastToken);
  addtoclosure(closure4271, var_values);
  addtoclosure(closure4271, var_tokens);
  addtoclosure(closure4271, var_util);
  addtoclosure(closure4271, var_ast);
  struct UserObject *uo4271 = (struct UserObject*)self;
  uo4271->data[36] = (Object)closure4271;
  Method *meth_meth_parser_matchcase4271 = addmethod2pos(self, "matchcase", &meth_parser_matchcase4271, 36);
  int argcv_meth_parser_matchcase4271[] = {0};
  meth_meth_parser_matchcase4271->type = alloc_MethodType(1, argcv_meth_parser_matchcase4271);
  meth_meth_parser_matchcase4271->definitionModule = modulename;
  meth_meth_parser_matchcase4271->definitionLine = 1310;
// compiled method node returning  (depth = 1)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "term"
  block_savedest(self);
  Object closure4649 = createclosure(3, "term");
  setclosureframe(closure4649, stackframe);
  addtoclosure(closure4649, var_sym);
  addtoclosure(closure4649, var_util);
  addtoclosure(closure4649, var_lastToken);
  struct UserObject *uo4649 = (struct UserObject*)self;
  uo4649->data[37] = (Object)closure4649;
  Method *meth_meth_parser_term4649 = addmethod2pos(self, "term", &meth_parser_term4649, 37);
  int argcv_meth_parser_term4649[] = {0};
  meth_meth_parser_term4649->type = alloc_MethodType(1, argcv_meth_parser_term4649);
  meth_meth_parser_term4649->definitionModule = modulename;
  meth_meth_parser_term4649->definitionLine = 1415;
// compiled method node returning  (depth = 1)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expression"
  block_savedest(self);
  Object closure4749 = createclosure(6, "expression");
  setclosureframe(closure4749, stackframe);
  addtoclosure(closure4749, var_values);
  addtoclosure(closure4749, var_sym);
  addtoclosure(closure4749, var_util);
  addtoclosure(closure4749, var_statementToken);
  addtoclosure(closure4749, var_errormessages);
  addtoclosure(closure4749, var_lastToken);
  struct UserObject *uo4749 = (struct UserObject*)self;
  uo4749->data[38] = (Object)closure4749;
  Method *meth_meth_parser_expression4749 = addmethod2pos(self, "expression", &meth_parser_expression4749, 38);
  int argcv_meth_parser_expression4749[] = {1};
  meth_meth_parser_expression4749->type = alloc_MethodType(1, argcv_meth_parser_expression4749);
  meth_meth_parser_expression4749->definitionModule = modulename;
  meth_meth_parser_expression4749->definitionLine = 1447;
// compiled method node returning  (depth = 1)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "postfixsquare"
  block_savedest(self);
  Object closure4857 = createclosure(6, "postfixsquare");
  setclosureframe(closure4857, stackframe);
  addtoclosure(closure4857, var_values);
  addtoclosure(closure4857, var_blocksOK);
  addtoclosure(closure4857, var_errormessages);
  addtoclosure(closure4857, var_sym);
  addtoclosure(closure4857, var_lastToken);
  addtoclosure(closure4857, var_ast);
  struct UserObject *uo4857 = (struct UserObject*)self;
  uo4857->data[39] = (Object)closure4857;
  Method *meth_meth_parser_postfixsquare4857 = addmethod2pos(self, "postfixsquare", &meth_parser_postfixsquare4857, 39);
  int argcv_meth_parser_postfixsquare4857[] = {0};
  meth_meth_parser_postfixsquare4857->type = alloc_MethodType(1, argcv_meth_parser_postfixsquare4857);
  meth_meth_parser_postfixsquare4857->definitionModule = modulename;
  meth_meth_parser_postfixsquare4857->definitionLine = 1490;
// compiled method node returning  (depth = 1)
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "oprec"
  struct UserObject *uo4971 = (struct UserObject*)self;
  uo4971->data[40] = emptyclosure;
  Method *meth_meth_parser_oprec4971 = addmethod2pos(self, "oprec", &meth_parser_oprec4971, 40);
  int argcv_meth_parser_oprec4971[] = {1};
  meth_meth_parser_oprec4971->type = alloc_MethodType(1, argcv_meth_parser_oprec4971);
  meth_meth_parser_oprec4971->definitionModule = modulename;
  meth_meth_parser_oprec4971->definitionLine = 1531;
// compiled method node returning  (depth = 1)
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "toprec"
  struct UserObject *uo4985 = (struct UserObject*)self;
  uo4985->data[41] = emptyclosure;
  Method *meth_meth_parser_toprec4985 = addmethod2pos(self, "toprec", &meth_parser_toprec4985, 41);
  int argcv_meth_parser_toprec4985[] = {1};
  meth_meth_parser_toprec4985->type = alloc_MethodType(1, argcv_meth_parser_toprec4985);
  meth_meth_parser_toprec4985->definitionModule = modulename;
  meth_meth_parser_toprec4985->definitionLine = 1541;
// compiled method node returning  (depth = 1)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpressionrest"
  block_savedest(self);
  Object closure4998 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure4998, stackframe);
  addtoclosure(closure4998, var_noBlocks);
  struct UserObject *uo4998 = (struct UserObject*)self;
  uo4998->data[42] = (Object)closure4998;
  Method *meth_meth_parser_typeexpressionrest4998 = addmethod2pos(self, "typeexpressionrest", &meth_parser_typeexpressionrest4998, 42);
  int argcv_meth_parser_typeexpressionrest4998[] = {0};
  meth_meth_parser_typeexpressionrest4998->type = alloc_MethodType(1, argcv_meth_parser_typeexpressionrest4998);
  meth_meth_parser_typeexpressionrest4998->definitionModule = modulename;
  meth_meth_parser_typeexpressionrest4998->definitionLine = 1550;
// compiled method node returning  (depth = 1)
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "valueexpressionrest"
  block_savedest(self);
  Object closure5011 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure5011, stackframe);
  addtoclosure(closure5011, var_blocksOK);
  struct UserObject *uo5011 = (struct UserObject*)self;
  uo5011->data[43] = (Object)closure5011;
  Method *meth_meth_parser_valueexpressionrest5011 = addmethod2pos(self, "valueexpressionrest", &meth_parser_valueexpressionrest5011, 43);
  int argcv_meth_parser_valueexpressionrest5011[] = {0};
  meth_meth_parser_valueexpressionrest5011->type = alloc_MethodType(1, argcv_meth_parser_valueexpressionrest5011);
  meth_meth_parser_valueexpressionrest5011->definitionModule = modulename;
  meth_meth_parser_valueexpressionrest5011->definitionLine = 1556;
// compiled method node returning  (depth = 1)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expressionrest()recursingWith()blocks"
  block_savedest(self);
  Object closure5024 = createclosure(7, "expressionrest()recursingWith()blocks");
  setclosureframe(closure5024, stackframe);
  addtoclosure(closure5024, var_values);
  addtoclosure(closure5024, var_sym);
  addtoclosure(closure5024, var_statementToken);
  addtoclosure(closure5024, var_errormessages);
  addtoclosure(closure5024, var_lastToken);
  addtoclosure(closure5024, var_util);
  addtoclosure(closure5024, var_ast);
  struct UserObject *uo5024 = (struct UserObject*)self;
  uo5024->data[44] = (Object)closure5024;
  Method *meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024 = addmethod2pos(self, "expressionrest()recursingWith()blocks", &meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024, 44);
  int argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024[] = {1, 1, 1};
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024->type = alloc_MethodType(3, argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024);
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024->definitionModule = modulename;
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5024->definitionLine = 1562;
// compiled method node returning  (depth = 1)
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotrest"
  block_savedest(self);
  Object closure5542 = createclosure(6, "dotrest");
  setclosureframe(closure5542, stackframe);
  addtoclosure(closure5542, var_sym);
  addtoclosure(closure5542, var_util);
  addtoclosure(closure5542, var_values);
  addtoclosure(closure5542, var_ast);
  addtoclosure(closure5542, var_errormessages);
  addtoclosure(closure5542, var_lastToken);
  struct UserObject *uo5542 = (struct UserObject*)self;
  uo5542->data[45] = (Object)closure5542;
  Method *meth_meth_parser_dotrest5542 = addmethod2pos(self, "dotrest", &meth_parser_dotrest5542, 45);
  int argcv_meth_parser_dotrest5542[] = {1};
  meth_meth_parser_dotrest5542->type = alloc_MethodType(1, argcv_meth_parser_dotrest5542);
  meth_meth_parser_dotrest5542->definitionModule = modulename;
  meth_meth_parser_dotrest5542->definitionLine = 1709;
// compiled method node returning  (depth = 1)
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callrest"
  block_savedest(self);
  Object closure5651 = createclosure(6, "callrest");
  setclosureframe(closure5651, stackframe);
  addtoclosure(closure5651, var_values);
  addtoclosure(closure5651, var_sym);
  addtoclosure(closure5651, var_util);
  addtoclosure(closure5651, var_ast);
  addtoclosure(closure5651, var_lastToken);
  addtoclosure(closure5651, var_minIndentLevel);
  struct UserObject *uo5651 = (struct UserObject*)self;
  uo5651->data[46] = (Object)closure5651;
  Method *meth_meth_parser_callrest5651 = addmethod2pos(self, "callrest", &meth_parser_callrest5651, 46);
  int argcv_meth_parser_callrest5651[] = {1};
  meth_meth_parser_callrest5651->type = alloc_MethodType(1, argcv_meth_parser_callrest5651);
  meth_meth_parser_callrest5651->definitionModule = modulename;
  meth_meth_parser_callrest5651->definitionLine = 1743;
// compiled method node returning  (depth = 1)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parenthesizedArg"
  block_savedest(self);
  Object closure5867 = createclosure(5, "parenthesizedArg");
  setclosureframe(closure5867, stackframe);
  addtoclosure(closure5867, var_blocksOK);
  addtoclosure(closure5867, var_values);
  addtoclosure(closure5867, var_errormessages);
  addtoclosure(closure5867, var_sym);
  addtoclosure(closure5867, var_lastToken);
  struct UserObject *uo5867 = (struct UserObject*)self;
  uo5867->data[47] = (Object)closure5867;
  Method *meth_meth_parser_parenthesizedArg5867 = addmethod2pos(self, "parenthesizedArg", &meth_parser_parenthesizedArg5867, 47);
  int argcv_meth_parser_parenthesizedArg5867[] = {1};
  meth_meth_parser_parenthesizedArg5867->type = alloc_MethodType(1, argcv_meth_parser_parenthesizedArg5867);
  meth_meth_parser_parenthesizedArg5867->definitionModule = modulename;
  meth_meth_parser_parenthesizedArg5867->definitionLine = 1830;
// compiled method node returning  (depth = 1)
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArgs"
  block_savedest(self);
  Object closure6278 = createclosure(4, "typeArgs");
  setclosureframe(closure6278, stackframe);
  addtoclosure(closure6278, var_sym);
  addtoclosure(closure6278, var_values);
  addtoclosure(closure6278, var_errormessages);
  addtoclosure(closure6278, var_lastToken);
  struct UserObject *uo6278 = (struct UserObject*)self;
  uo6278->data[48] = (Object)closure6278;
  Method *meth_meth_parser_typeArgs6278 = addmethod2pos(self, "typeArgs", &meth_parser_typeArgs6278, 48);
  int argcv_meth_parser_typeArgs6278[] = {0};
  meth_meth_parser_typeArgs6278->type = alloc_MethodType(1, argcv_meth_parser_typeArgs6278);
  meth_meth_parser_typeArgs6278->definitionModule = modulename;
  meth_meth_parser_typeArgs6278->definitionLine = 1940;
// compiled method node returning  (depth = 1)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArg"
  block_savedest(self);
  Object closure6360 = createclosure(3, "typeArg");
  setclosureframe(closure6360, stackframe);
  addtoclosure(closure6360, var_sym);
  addtoclosure(closure6360, var_values);
  addtoclosure(closure6360, var_ast);
  struct UserObject *uo6360 = (struct UserObject*)self;
  uo6360->data[49] = (Object)closure6360;
  Method *meth_meth_parser_typeArg6360 = addmethod2pos(self, "typeArg", &meth_parser_typeArg6360, 49);
  int argcv_meth_parser_typeArg6360[] = {0};
  meth_meth_parser_typeArg6360->type = alloc_MethodType(1, argcv_meth_parser_typeArg6360);
  meth_meth_parser_typeArg6360->definitionModule = modulename;
  meth_meth_parser_typeArg6360->definitionLine = 1965;
// compiled method node returning  (depth = 1)
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callmprest"
  block_savedest(self);
  Object closure6392 = createclosure(6, "callmprest");
  setclosureframe(closure6392, stackframe);
  addtoclosure(closure6392, var_lastToken);
  addtoclosure(closure6392, var_ast);
  addtoclosure(closure6392, var_values);
  addtoclosure(closure6392, var_errormessages);
  addtoclosure(closure6392, var_sym);
  addtoclosure(closure6392, var_blocksOK);
  struct UserObject *uo6392 = (struct UserObject*)self;
  uo6392->data[50] = (Object)closure6392;
  Method *meth_meth_parser_callmprest6392 = addmethod2pos(self, "callmprest", &meth_parser_callmprest6392, 50);
  int argcv_meth_parser_callmprest6392[] = {3};
  meth_meth_parser_callmprest6392->type = alloc_MethodType(1, argcv_meth_parser_callmprest6392);
  meth_meth_parser_callmprest6392->definitionModule = modulename;
  meth_meth_parser_callmprest6392->definitionLine = 1981;
// compiled method node returning  (depth = 1)
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "defdec"
  block_savedest(self);
  Object closure6763 = createclosure(8, "defdec");
  setclosureframe(closure6763, stackframe);
  addtoclosure(closure6763, var_sym);
  addtoclosure(closure6763, var_errormessages);
  addtoclosure(closure6763, var_lastToken);
  addtoclosure(closure6763, var_values);
  addtoclosure(closure6763, var_blocksOK);
  addtoclosure(closure6763, var_util);
  addtoclosure(closure6763, var_ast);
  addtoclosure(closure6763, var_defaultDefVisibility);
  struct UserObject *uo6763 = (struct UserObject*)self;
  uo6763->data[51] = (Object)closure6763;
  Method *meth_meth_parser_defdec6763 = addmethod2pos(self, "defdec", &meth_parser_defdec6763, 51);
  int argcv_meth_parser_defdec6763[] = {0};
  meth_meth_parser_defdec6763->type = alloc_MethodType(1, argcv_meth_parser_defdec6763);
  meth_meth_parser_defdec6763->definitionModule = modulename;
  meth_meth_parser_defdec6763->definitionLine = 2103;
// compiled method node returning  (depth = 1)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "vardec"
  block_savedest(self);
  Object closure7027 = createclosure(8, "vardec");
  setclosureframe(closure7027, stackframe);
  addtoclosure(closure7027, var_sym);
  addtoclosure(closure7027, var_errormessages);
  addtoclosure(closure7027, var_lastToken);
  addtoclosure(closure7027, var_values);
  addtoclosure(closure7027, var_blocksOK);
  addtoclosure(closure7027, var_util);
  addtoclosure(closure7027, var_ast);
  addtoclosure(closure7027, var_defaultVarVisibility);
  struct UserObject *uo7027 = (struct UserObject*)self;
  uo7027->data[52] = (Object)closure7027;
  Method *meth_meth_parser_vardec7027 = addmethod2pos(self, "vardec", &meth_parser_vardec7027, 52);
  int argcv_meth_parser_vardec7027[] = {0};
  meth_meth_parser_vardec7027->type = alloc_MethodType(1, argcv_meth_parser_vardec7027);
  meth_meth_parser_vardec7027->definitionModule = modulename;
  meth_meth_parser_vardec7027->definitionLine = 2181;
// compiled method node returning  (depth = 1)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doarray"
  block_savedest(self);
  Object closure7254 = createclosure(6, "doarray");
  setclosureframe(closure7254, stackframe);
  addtoclosure(closure7254, var_blocksOK);
  addtoclosure(closure7254, var_values);
  addtoclosure(closure7254, var_errormessages);
  addtoclosure(closure7254, var_sym);
  addtoclosure(closure7254, var_lastToken);
  addtoclosure(closure7254, var_ast);
  struct UserObject *uo7254 = (struct UserObject*)self;
  uo7254->data[53] = (Object)closure7254;
  Method *meth_meth_parser_doarray7254 = addmethod2pos(self, "doarray", &meth_parser_doarray7254, 53);
  int argcv_meth_parser_doarray7254[] = {0};
  meth_meth_parser_doarray7254->type = alloc_MethodType(1, argcv_meth_parser_doarray7254);
  meth_meth_parser_doarray7254->definitionModule = modulename;
  meth_meth_parser_doarray7254->definitionLine = 2251;
// compiled method node returning  (depth = 1)
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dodialect"
  block_savedest(self);
  Object closure7387 = createclosure(5, "dodialect");
  setclosureframe(closure7387, stackframe);
  addtoclosure(closure7387, var_sym);
  addtoclosure(closure7387, var_errormessages);
  addtoclosure(closure7387, var_lastToken);
  addtoclosure(closure7387, var_ast);
  addtoclosure(closure7387, var_values);
  struct UserObject *uo7387 = (struct UserObject*)self;
  uo7387->data[54] = (Object)closure7387;
  Method *meth_meth_parser_dodialect7387 = addmethod2pos(self, "dodialect", &meth_parser_dodialect7387, 54);
  int argcv_meth_parser_dodialect7387[] = {0};
  meth_meth_parser_dodialect7387->type = alloc_MethodType(1, argcv_meth_parser_dodialect7387);
  meth_meth_parser_dodialect7387->definitionModule = modulename;
  meth_meth_parser_dodialect7387->definitionLine = 2294;
// compiled method node returning  (depth = 1)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritsOrUses"
  block_savedest(self);
  Object closure7467 = createclosure(8, "inheritsOrUses");
  setclosureframe(closure7467, stackframe);
  addtoclosure(closure7467, var_done);
  addtoclosure(closure7467, var_sym);
  addtoclosure(closure7467, var_noBlocks);
  addtoclosure(closure7467, var_errormessages);
  addtoclosure(closure7467, var_lastToken);
  addtoclosure(closure7467, var_util);
  addtoclosure(closure7467, var_values);
  addtoclosure(closure7467, var_ast);
  struct UserObject *uo7467 = (struct UserObject*)self;
  uo7467->data[55] = (Object)closure7467;
  Method *meth_meth_parser_inheritsOrUses7467 = addmethod2pos(self, "inheritsOrUses", &meth_parser_inheritsOrUses7467, 55);
  int argcv_meth_parser_inheritsOrUses7467[] = {0};
  meth_meth_parser_inheritsOrUses7467->type = alloc_MethodType(1, argcv_meth_parser_inheritsOrUses7467);
  meth_meth_parser_inheritsOrUses7467->definitionModule = modulename;
  meth_meth_parser_inheritsOrUses7467->definitionLine = 2315;
// compiled method node returning  (depth = 1)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritsModifier()onLineOf"
  block_savedest(self);
  Object closure7630 = createclosure(1, "inheritsModifier()onLineOf");
  setclosureframe(closure7630, stackframe);
  addtoclosure(closure7630, var_sym);
  struct UserObject *uo7630 = (struct UserObject*)self;
  uo7630->data[56] = (Object)closure7630;
  Method *meth_meth_parser_inheritsModifier_40__41_onLineOf7630 = addmethod2pos(self, "inheritsModifier()onLineOf", &meth_parser_inheritsModifier_40__41_onLineOf7630, 56);
  int argcv_meth_parser_inheritsModifier_40__41_onLineOf7630[] = {1, 1};
  meth_meth_parser_inheritsModifier_40__41_onLineOf7630->type = alloc_MethodType(2, argcv_meth_parser_inheritsModifier_40__41_onLineOf7630);
  meth_meth_parser_inheritsModifier_40__41_onLineOf7630->definitionModule = modulename;
  meth_meth_parser_inheritsModifier_40__41_onLineOf7630->definitionLine = 2356;
// compiled method node returning  (depth = 1)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseAlias"
  block_savedest(self);
  Object closure7657 = createclosure(3, "parseAlias");
  setclosureframe(closure7657, stackframe);
  addtoclosure(closure7657, var_sym);
  addtoclosure(closure7657, var_lastToken);
  addtoclosure(closure7657, var_errormessages);
  struct UserObject *uo7657 = (struct UserObject*)self;
  uo7657->data[57] = (Object)closure7657;
  Method *meth_meth_parser_parseAlias7657 = addmethod2pos(self, "parseAlias", &meth_parser_parseAlias7657, 57);
  int argcv_meth_parser_parseAlias7657[] = {1};
  meth_meth_parser_parseAlias7657->type = alloc_MethodType(1, argcv_meth_parser_parseAlias7657);
  meth_meth_parser_parseAlias7657->definitionModule = modulename;
  meth_meth_parser_parseAlias7657->definitionLine = 2370;
// compiled method node returning  (depth = 1)
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseExclude"
  struct UserObject *uo7707 = (struct UserObject*)self;
  uo7707->data[58] = emptyclosure;
  Method *meth_meth_parser_parseExclude7707 = addmethod2pos(self, "parseExclude", &meth_parser_parseExclude7707, 58);
  int argcv_meth_parser_parseExclude7707[] = {1};
  meth_meth_parser_parseExclude7707->type = alloc_MethodType(1, argcv_meth_parser_parseExclude7707);
  meth_meth_parser_parseExclude7707->definitionModule = modulename;
  meth_meth_parser_parseExclude7707->definitionLine = 2387;
// compiled method node returning  (depth = 1)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doobject"
  block_savedest(self);
  Object closure7721 = createclosure(1, "doobject");
  setclosureframe(closure7721, stackframe);
  addtoclosure(closure7721, var_lastToken);
  struct UserObject *uo7721 = (struct UserObject*)self;
  uo7721->data[59] = (Object)closure7721;
  Method *meth_meth_parser_doobject7721 = addmethod2pos(self, "doobject", &meth_parser_doobject7721, 59);
  int argcv_meth_parser_doobject7721[] = {0};
  meth_meth_parser_doobject7721->type = alloc_MethodType(1, argcv_meth_parser_doobject7721);
  meth_meth_parser_doobject7721->definitionModule = modulename;
  meth_meth_parser_doobject7721->definitionLine = 2396;
// compiled method node returning  (depth = 1)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseObjectConstructorBody()startingWith()after"
  block_savedest(self);
  Object closure7732 = createclosure(8, "parseObjectConstructorBody()startingWith()after");
  setclosureframe(closure7732, stackframe);
  addtoclosure(closure7732, var_minIndentLevel);
  addtoclosure(closure7732, var_sym);
  addtoclosure(closure7732, var_errormessages);
  addtoclosure(closure7732, var_lastToken);
  addtoclosure(closure7732, var_statementToken);
  addtoclosure(closure7732, var_values);
  addtoclosure(closure7732, var_util);
  addtoclosure(closure7732, var_ast);
  struct UserObject *uo7732 = (struct UserObject*)self;
  uo7732->data[60] = (Object)closure7732;
  Method *meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732 = addmethod2pos(self, "parseObjectConstructorBody()startingWith()after", &meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732, 60);
  int argcv_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732[] = {1, 1, 1};
  meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732->type = alloc_MethodType(3, argcv_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732);
  meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732->definitionModule = modulename;
  meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7732->definitionLine = 2407;
// compiled method node returning  (depth = 1)
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doclass"
  block_savedest(self);
  Object closure8020 = createclosure(8, "doclass");
  setclosureframe(closure8020, stackframe);
  addtoclosure(closure8020, var_sym);
  addtoclosure(closure8020, var_minIndentLevel);
  addtoclosure(closure8020, var_errormessages);
  addtoclosure(closure8020, var_lastToken);
  addtoclosure(closure8020, var_tokens);
  addtoclosure(closure8020, var_values);
  addtoclosure(closure8020, var_util);
  addtoclosure(closure8020, var_ast);
  struct UserObject *uo8020 = (struct UserObject*)self;
  uo8020->data[61] = (Object)closure8020;
  Method *meth_meth_parser_doclass8020 = addmethod2pos(self, "doclass", &meth_parser_doclass8020, 61);
  int argcv_meth_parser_doclass8020[] = {0};
  meth_meth_parser_doclass8020->type = alloc_MethodType(1, argcv_meth_parser_doclass8020);
  meth_meth_parser_doclass8020->definitionModule = modulename;
  meth_meth_parser_doclass8020->definitionLine = 2477;
// compiled method node returning  (depth = 1)
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dofactoryMethod"
  block_savedest(self);
  Object closure8256 = createclosure(8, "dofactoryMethod");
  setclosureframe(closure8256, stackframe);
  addtoclosure(closure8256, var_tokens);
  addtoclosure(closure8256, var_sym);
  addtoclosure(closure8256, var_minIndentLevel);
  addtoclosure(closure8256, var_errormessages);
  addtoclosure(closure8256, var_lastToken);
  addtoclosure(closure8256, var_values);
  addtoclosure(closure8256, var_util);
  addtoclosure(closure8256, var_ast);
  struct UserObject *uo8256 = (struct UserObject*)self;
  uo8256->data[62] = (Object)closure8256;
  Method *meth_meth_parser_dofactoryMethod8256 = addmethod2pos(self, "dofactoryMethod", &meth_parser_dofactoryMethod8256, 62);
  int argcv_meth_parser_dofactoryMethod8256[] = {0};
  meth_meth_parser_dofactoryMethod8256->type = alloc_MethodType(1, argcv_meth_parser_dofactoryMethod8256);
  meth_meth_parser_dofactoryMethod8256->definitionModule = modulename;
  meth_meth_parser_dofactoryMethod8256->definitionLine = 2570;
// compiled method node returning  (depth = 1)
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methoddec"
  block_savedest(self);
  Object closure8399 = createclosure(8, "methoddec");
  setclosureframe(closure8399, stackframe);
  addtoclosure(closure8399, var_sym);
  addtoclosure(closure8399, var_statementToken);
  addtoclosure(closure8399, var_minIndentLevel);
  addtoclosure(closure8399, var_values);
  addtoclosure(closure8399, var_errormessages);
  addtoclosure(closure8399, var_lastToken);
  addtoclosure(closure8399, var_util);
  addtoclosure(closure8399, var_ast);
  struct UserObject *uo8399 = (struct UserObject*)self;
  uo8399->data[63] = (Object)closure8399;
  Method *meth_meth_parser_methoddec8399 = addmethod2pos(self, "methoddec", &meth_parser_methoddec8399, 63);
  int argcv_meth_parser_methoddec8399[] = {0};
  meth_meth_parser_methoddec8399->type = alloc_MethodType(1, argcv_meth_parser_methoddec8399);
  meth_meth_parser_methoddec8399->definitionModule = modulename;
  meth_meth_parser_methoddec8399->definitionLine = 2618;
// compiled method node returning  (depth = 1)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodDecRest"
  block_savedest(self);
  Object closure8622 = createclosure(5, "methodDecRest");
  setclosureframe(closure8622, stackframe);
  addtoclosure(closure8622, var_ast);
  addtoclosure(closure8622, var_values);
  addtoclosure(closure8622, var_errormessages);
  addtoclosure(closure8622, var_lastToken);
  addtoclosure(closure8622, var_sym);
  struct UserObject *uo8622 = (struct UserObject*)self;
  uo8622->data[64] = (Object)closure8622;
  Method *meth_meth_parser_methodDecRest8622 = addmethod2pos(self, "methodDecRest", &meth_parser_methodDecRest8622, 64);
  int argcv_meth_parser_methodDecRest8622[] = {2};
  meth_meth_parser_methodDecRest8622->type = alloc_MethodType(1, argcv_meth_parser_methodDecRest8622);
  meth_meth_parser_methodDecRest8622->definitionModule = modulename;
  meth_meth_parser_methodDecRest8622->definitionLine = 2702;
// compiled method node returning  (depth = 1)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "optionalTypeAnnotation"
  block_savedest(self);
  Object closure8885 = createclosure(4, "optionalTypeAnnotation");
  setclosureframe(closure8885, stackframe);
  addtoclosure(closure8885, var_values);
  addtoclosure(closure8885, var_errormessages);
  addtoclosure(closure8885, var_lastToken);
  addtoclosure(closure8885, var_sym);
  struct UserObject *uo8885 = (struct UserObject*)self;
  uo8885->data[65] = (Object)closure8885;
  Method *meth_meth_parser_optionalTypeAnnotation8885 = addmethod2pos(self, "optionalTypeAnnotation", &meth_parser_optionalTypeAnnotation8885, 65);
  int argcv_meth_parser_optionalTypeAnnotation8885[] = {0};
  meth_meth_parser_optionalTypeAnnotation8885->type = alloc_MethodType(1, argcv_meth_parser_optionalTypeAnnotation8885);
  meth_meth_parser_optionalTypeAnnotation8885->definitionModule = modulename;
  meth_meth_parser_optionalTypeAnnotation8885->definitionLine = 2788;
// compiled method node returning  (depth = 1)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodsignature"
  block_savedest(self);
  Object closure8936 = createclosure(6, "methodsignature");
  setclosureframe(closure8936, stackframe);
  addtoclosure(closure8936, var_sym);
  addtoclosure(closure8936, var_errormessages);
  addtoclosure(closure8936, var_lastToken);
  addtoclosure(closure8936, var_values);
  addtoclosure(closure8936, var_ast);
  addtoclosure(closure8936, var_tokens);
  struct UserObject *uo8936 = (struct UserObject*)self;
  uo8936->data[66] = (Object)closure8936;
  Method *meth_meth_parser_methodsignature8936 = addmethod2pos(self, "methodsignature", &meth_parser_methodsignature8936, 66);
  int argcv_meth_parser_methodsignature8936[] = {1};
  meth_meth_parser_methodsignature8936->type = alloc_MethodType(1, argcv_meth_parser_methodsignature8936);
  meth_meth_parser_methodsignature8936->definitionModule = modulename;
  meth_meth_parser_methodsignature8936->definitionLine = 2811;
  block_savedest(self);
  Object closure9582 = createclosure(6, "methodsignature()object");
  setclosureframe(closure9582, stackframe);
  addtoclosure(closure9582, var_sym);
  addtoclosure(closure9582, var_errormessages);
  addtoclosure(closure9582, var_lastToken);
  addtoclosure(closure9582, var_values);
  addtoclosure(closure9582, var_ast);
  addtoclosure(closure9582, var_tokens);
  Method *meth_meth_parser_methodsignature8936_object = addmethod2pos(self, "methodsignature()object", &meth_parser_methodsignature8936_object, 66);
  meth_meth_parser_methodsignature8936_object->definitionModule = modulename;
  meth_meth_parser_methodsignature8936_object->definitionLine = 2811;
// compiled method node returning  (depth = 1)
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeparameters"
  block_savedest(self);
  Object closure9583 = createclosure(5, "typeparameters");
  setclosureframe(closure9583, stackframe);
  addtoclosure(closure9583, var_values);
  addtoclosure(closure9583, var_ast);
  addtoclosure(closure9583, var_sym);
  addtoclosure(closure9583, var_errormessages);
  addtoclosure(closure9583, var_lastToken);
  struct UserObject *uo9583 = (struct UserObject*)self;
  uo9583->data[67] = (Object)closure9583;
  Method *meth_meth_parser_typeparameters9583 = addmethod2pos(self, "typeparameters", &meth_parser_typeparameters9583, 67);
  int argcv_meth_parser_typeparameters9583[] = {0};
  meth_meth_parser_typeparameters9583->type = alloc_MethodType(1, argcv_meth_parser_typeparameters9583);
  meth_meth_parser_typeparameters9583->definitionModule = modulename;
  meth_meth_parser_typeparameters9583->definitionLine = 2975;
// compiled method node returning  (depth = 1)
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doimport"
  block_savedest(self);
  Object closure9656 = createclosure(7, "doimport");
  setclosureframe(closure9656, stackframe);
  addtoclosure(closure9656, var_sym);
  addtoclosure(closure9656, var_errormessages);
  addtoclosure(closure9656, var_lastToken);
  addtoclosure(closure9656, var_values);
  addtoclosure(closure9656, var_util);
  addtoclosure(closure9656, var_ast);
  addtoclosure(closure9656, var_defaultDefVisibility);
  struct UserObject *uo9656 = (struct UserObject*)self;
  uo9656->data[68] = (Object)closure9656;
  Method *meth_meth_parser_doimport9656 = addmethod2pos(self, "doimport", &meth_parser_doimport9656, 68);
  int argcv_meth_parser_doimport9656[] = {0};
  meth_meth_parser_doimport9656->type = alloc_MethodType(1, argcv_meth_parser_doimport9656);
  meth_meth_parser_doimport9656->definitionModule = modulename;
  meth_meth_parser_doimport9656->definitionLine = 2999;
// compiled method node returning  (depth = 1)
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doreturn"
  block_savedest(self);
  Object closure9909 = createclosure(7, "doreturn");
  setclosureframe(closure9909, stackframe);
  addtoclosure(closure9909, var_sym);
  addtoclosure(closure9909, var_blocksOK);
  addtoclosure(closure9909, var_errormessages);
  addtoclosure(closure9909, var_lastToken);
  addtoclosure(closure9909, var_values);
  addtoclosure(closure9909, var_ast);
  addtoclosure(closure9909, var_util);
  struct UserObject *uo9909 = (struct UserObject*)self;
  uo9909->data[69] = (Object)closure9909;
  Method *meth_meth_parser_doreturn9909 = addmethod2pos(self, "doreturn", &meth_parser_doreturn9909, 69);
  int argcv_meth_parser_doreturn9909[] = {0};
  meth_meth_parser_doreturn9909->type = alloc_MethodType(1, argcv_meth_parser_doreturn9909);
  meth_meth_parser_doreturn9909->definitionModule = modulename;
  meth_meth_parser_doreturn9909->definitionLine = 3058;
// compiled method node returning  (depth = 1)
// Begin line 3094
  setline(3094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "domethodtype"
  block_savedest(self);
  Object closure10031 = createclosure(6, "domethodtype");
  setclosureframe(closure10031, stackframe);
  addtoclosure(closure10031, var_sym);
  addtoclosure(closure10031, var_ast);
  addtoclosure(closure10031, var_util);
  addtoclosure(closure10031, var_values);
  addtoclosure(closure10031, var_lastToken);
  addtoclosure(closure10031, var_errormessages);
  struct UserObject *uo10031 = (struct UserObject*)self;
  uo10031->data[70] = (Object)closure10031;
  Method *meth_meth_parser_domethodtype10031 = addmethod2pos(self, "domethodtype", &meth_parser_domethodtype10031, 70);
  int argcv_meth_parser_domethodtype10031[] = {0};
  meth_meth_parser_domethodtype10031->type = alloc_MethodType(1, argcv_meth_parser_domethodtype10031);
  meth_meth_parser_domethodtype10031->definitionModule = modulename;
  meth_meth_parser_domethodtype10031->definitionLine = 3094;
// compiled method node returning  (depth = 1)
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeLiteral"
  block_savedest(self);
  Object closure10137 = createclosure(7, "dotypeLiteral");
  setclosureframe(closure10137, stackframe);
  addtoclosure(closure10137, var_sym);
  addtoclosure(closure10137, var_errormessages);
  addtoclosure(closure10137, var_done);
  addtoclosure(closure10137, var_auto_count);
  addtoclosure(closure10137, var_values);
  addtoclosure(closure10137, var_util);
  addtoclosure(closure10137, var_ast);
  struct UserObject *uo10137 = (struct UserObject*)self;
  uo10137->data[71] = (Object)closure10137;
  Method *meth_meth_parser_dotypeLiteral10137 = addmethod2pos(self, "dotypeLiteral", &meth_parser_dotypeLiteral10137, 71);
  int argcv_meth_parser_dotypeLiteral10137[] = {0};
  meth_meth_parser_dotypeLiteral10137->type = alloc_MethodType(1, argcv_meth_parser_dotypeLiteral10137);
  meth_meth_parser_dotypeLiteral10137->definitionModule = modulename;
  meth_meth_parser_dotypeLiteral10137->definitionLine = 3126;
// compiled method node returning  (depth = 1)
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typedec"
  block_savedest(self);
  Object closure10220 = createclosure(7, "typedec");
  setclosureframe(closure10220, stackframe);
  addtoclosure(closure10220, var_sym);
  addtoclosure(closure10220, var_errormessages);
  addtoclosure(closure10220, var_lastToken);
  addtoclosure(closure10220, var_util);
  addtoclosure(closure10220, var_values);
  addtoclosure(closure10220, var_ast);
  addtoclosure(closure10220, var_noBlocks);
  struct UserObject *uo10220 = (struct UserObject*)self;
  uo10220->data[72] = (Object)closure10220;
  Method *meth_meth_parser_typedec10220 = addmethod2pos(self, "typedec", &meth_parser_typedec10220, 72);
  int argcv_meth_parser_typedec10220[] = {0};
  meth_meth_parser_typedec10220->type = alloc_MethodType(1, argcv_meth_parser_typedec10220);
  meth_meth_parser_typedec10220->definitionModule = modulename;
  meth_meth_parser_typedec10220->definitionLine = 3161;
// compiled method node returning  (depth = 1)
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkIndent"
  block_savedest(self);
  Object closure10382 = createclosure(6, "checkIndent");
  setclosureframe(closure10382, stackframe);
  addtoclosure(closure10382, var_indentFreePass);
  addtoclosure(closure10382, var_sym);
  addtoclosure(closure10382, var_minIndentLevel);
  addtoclosure(closure10382, var_errormessages);
  addtoclosure(closure10382, var_lastToken);
  addtoclosure(closure10382, var_lastIndent);
  struct UserObject *uo10382 = (struct UserObject*)self;
  uo10382->data[73] = (Object)closure10382;
  Method *meth_meth_parser_checkIndent10382 = addmethod2pos(self, "checkIndent", &meth_parser_checkIndent10382, 73);
  int argcv_meth_parser_checkIndent10382[] = {0};
  meth_meth_parser_checkIndent10382->type = alloc_MethodType(1, argcv_meth_parser_checkIndent10382);
  meth_meth_parser_checkIndent10382->definitionModule = modulename;
  meth_meth_parser_checkIndent10382->definitionLine = 3207;
// compiled method node returning  (depth = 1)
// Begin line 3254
  setline(3254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "statement"
  block_savedest(self);
  Object closure10608 = createclosure(10, "statement");
  setclosureframe(closure10608, stackframe);
  addtoclosure(closure10608, var_sym);
  addtoclosure(closure10608, var_statementIndent);
  addtoclosure(closure10608, var_statementToken);
  addtoclosure(closure10608, var_blocksOK);
  addtoclosure(closure10608, var_values);
  addtoclosure(closure10608, var_errormessages);
  addtoclosure(closure10608, var_lastToken);
  addtoclosure(closure10608, var_util);
  addtoclosure(closure10608, var_ast);
  addtoclosure(closure10608, var_indentFreePass);
  struct UserObject *uo10608 = (struct UserObject*)self;
  uo10608->data[74] = (Object)closure10608;
  Method *meth_meth_parser_statement10608 = addmethod2pos(self, "statement", &meth_parser_statement10608, 74);
  int argcv_meth_parser_statement10608[] = {0};
  meth_meth_parser_statement10608->type = alloc_MethodType(1, argcv_meth_parser_statement10608);
  meth_meth_parser_statement10608->definitionModule = modulename;
  meth_meth_parser_statement10608->definitionLine = 3254;
// compiled method node returning  (depth = 1)
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushComments"
  block_savedest(self);
  Object closure10880 = createclosure(8, "pushComments");
  setclosureframe(closure10880, stackframe);
  addtoclosure(closure10880, var_done);
  addtoclosure(closure10880, var_sym);
  addtoclosure(closure10880, var_util);
  addtoclosure(closure10880, var_ast);
  addtoclosure(closure10880, var_lastToken);
  addtoclosure(closure10880, var_comments);
  addtoclosure(closure10880, var_previousCommentToken);
  addtoclosure(closure10880, var_tokens);
  struct UserObject *uo10880 = (struct UserObject*)self;
  uo10880->data[75] = (Object)closure10880;
  Method *meth_meth_parser_pushComments10880 = addmethod2pos(self, "pushComments", &meth_parser_pushComments10880, 75);
  int argcv_meth_parser_pushComments10880[] = {0};
  meth_meth_parser_pushComments10880->type = alloc_MethodType(1, argcv_meth_parser_pushComments10880);
  meth_meth_parser_pushComments10880->definitionModule = modulename;
  meth_meth_parser_pushComments10880->definitionLine = 3337;
// compiled method node returning  (depth = 1)
// Begin line 3371
  setline(3371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reconcileComments"
  block_savedest(self);
  Object closure11013 = createclosure(4, "reconcileComments");
  setclosureframe(closure11013, stackframe);
  addtoclosure(closure11013, var_values);
  addtoclosure(closure11013, var_moduleObject);
  addtoclosure(closure11013, var_done);
  addtoclosure(closure11013, var_comments);
  struct UserObject *uo11013 = (struct UserObject*)self;
  uo11013->data[76] = (Object)closure11013;
  Method *meth_meth_parser_reconcileComments11013 = addmethod2pos(self, "reconcileComments", &meth_parser_reconcileComments11013, 76);
  int argcv_meth_parser_reconcileComments11013[] = {0};
  meth_meth_parser_reconcileComments11013->type = alloc_MethodType(1, argcv_meth_parser_reconcileComments11013);
  meth_meth_parser_reconcileComments11013->definitionModule = modulename;
  meth_meth_parser_reconcileComments11013->definitionLine = 3371;
// compiled method node returning  (depth = 1)
// Begin line 3417
  setline(3417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadOperators"
  block_savedest(self);
  Object closure11144 = createclosure(2, "checkBadOperators");
  setclosureframe(closure11144, stackframe);
  addtoclosure(closure11144, var_sym);
  addtoclosure(closure11144, var_errormessages);
  struct UserObject *uo11144 = (struct UserObject*)self;
  uo11144->data[77] = (Object)closure11144;
  Method *meth_meth_parser_checkBadOperators11144 = addmethod2pos(self, "checkBadOperators", &meth_parser_checkBadOperators11144, 77);
  int argcv_meth_parser_checkBadOperators11144[] = {0};
  meth_meth_parser_checkBadOperators11144->type = alloc_MethodType(1, argcv_meth_parser_checkBadOperators11144);
  meth_meth_parser_checkBadOperators11144->definitionModule = modulename;
  meth_meth_parser_checkBadOperators11144->definitionLine = 3417;
// compiled method node returning  (depth = 1)
// Begin line 3434
  setline(3434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadTypeLiteral"
  block_savedest(self);
  Object closure11191 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure11191, stackframe);
  addtoclosure(closure11191, var_sym);
  addtoclosure(closure11191, var_errormessages);
  struct UserObject *uo11191 = (struct UserObject*)self;
  uo11191->data[78] = (Object)closure11191;
  Method *meth_meth_parser_checkBadTypeLiteral11191 = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_checkBadTypeLiteral11191, 78);
  int argcv_meth_parser_checkBadTypeLiteral11191[] = {0};
  meth_meth_parser_checkBadTypeLiteral11191->type = alloc_MethodType(1, argcv_meth_parser_checkBadTypeLiteral11191);
  meth_meth_parser_checkBadTypeLiteral11191->definitionModule = modulename;
  meth_meth_parser_checkBadTypeLiteral11191->definitionLine = 3434;
// compiled method node returning  (depth = 1)
// Begin line 3444
  setline(3444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkUnexpectedTokenAfterStatement"
  block_savedest(self);
  Object closure11215 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure11215, stackframe);
  addtoclosure(closure11215, var_lastToken);
  addtoclosure(closure11215, var_sym);
  addtoclosure(closure11215, var_errormessages);
  addtoclosure(closure11215, var_values);
  addtoclosure(closure11215, var_util);
  struct UserObject *uo11215 = (struct UserObject*)self;
  uo11215->data[79] = (Object)closure11215;
  Method *meth_meth_parser_checkUnexpectedTokenAfterStatement11215 = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_checkUnexpectedTokenAfterStatement11215, 79);
  int argcv_meth_parser_checkUnexpectedTokenAfterStatement11215[] = {0};
  meth_meth_parser_checkUnexpectedTokenAfterStatement11215->type = alloc_MethodType(1, argcv_meth_parser_checkUnexpectedTokenAfterStatement11215);
  meth_meth_parser_checkUnexpectedTokenAfterStatement11215->definitionModule = modulename;
  meth_meth_parser_checkUnexpectedTokenAfterStatement11215->definitionLine = 3444;
// compiled method node returning  (depth = 1)
// Begin line 3514
  setline(3514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parse"
  block_savedest(self);
  Object closure11542 = createclosure(9, "parse");
  setclosureframe(closure11542, stackframe);
  addtoclosure(closure11542, var_util);
  addtoclosure(closure11542, var_values);
  addtoclosure(closure11542, var_ast);
  addtoclosure(closure11542, var_moduleObject);
  addtoclosure(closure11542, var_defaultDefVisibility);
  addtoclosure(closure11542, var_defaultVarVisibility);
  addtoclosure(closure11542, var_tokens);
  addtoclosure(closure11542, var_sym);
  addtoclosure(closure11542, var_errormessages);
  struct UserObject *uo11542 = (struct UserObject*)self;
  uo11542->data[80] = (Object)closure11542;
  Method *meth_meth_parser_parse11542 = addmethod2pos(self, "parse", &meth_parser_parse11542, 80);
  int argcv_meth_parser_parse11542[] = {1};
  meth_meth_parser_parse11542->type = alloc_MethodType(1, argcv_meth_parser_parse11542);
  meth_meth_parser_parse11542->definitionModule = modulename;
  meth_meth_parser_parse11542->definitionLine = 3514;
// compiled method node returning  (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = LOAD_MODULE(ast);
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11749 = alloc_Float64(0);
// compiled num node returning num11749 (depth = 2)
  *var_blankLocation = num11749;
  if (num11749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankLocation"
  block_savedest(self);
  Object closure11750 = createclosure(1, "blankLocation");
  setclosureframe(closure11750, stackframe);
  addtoclosure(closure11750, var_blankLocation);
  struct UserObject *uo11750 = (struct UserObject*)self;
  uo11750->data[81] = (Object)closure11750;
  Method *meth_meth_parser_blankLocation11750 = addmethod2pos(self, "blankLocation", &meth_parser_blankLocation11750, 81);
  int argcv_meth_parser_blankLocation11750[] = {0};
  meth_meth_parser_blankLocation11750->type = alloc_MethodType(1, argcv_meth_parser_blankLocation11750);
  meth_meth_parser_blankLocation11750->definitionModule = modulename;
  meth_meth_parser_blankLocation11750->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankLocation:="
  block_savedest(self);
  Object closure11751 = createclosure(1, "blankLocation:=");
  setclosureframe(closure11751, stackframe);
  addtoclosure(closure11751, var_blankLocation);
  struct UserObject *uo11751 = (struct UserObject*)self;
  uo11751->data[82] = (Object)closure11751;
  Method *meth_meth_parser_blankLocation_58__61_11751 = addmethod2pos(self, "blankLocation:=", &meth_parser_blankLocation_58__61_11751, 82);
  int argcv_meth_parser_blankLocation_58__61_11751[] = {1};
  meth_meth_parser_blankLocation_58__61_11751->type = alloc_MethodType(1, argcv_meth_parser_blankLocation_58__61_11751);
  meth_meth_parser_blankLocation_58__61_11751->definitionModule = modulename;
  meth_meth_parser_blankLocation_58__61_11751->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11753 = alloc_Float64(0);
// compiled num node returning num11753 (depth = 2)
  *var_lastLine = num11753;
  if (num11753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine"
  block_savedest(self);
  Object closure11754 = createclosure(1, "lastLine");
  setclosureframe(closure11754, stackframe);
  addtoclosure(closure11754, var_lastLine);
  struct UserObject *uo11754 = (struct UserObject*)self;
  uo11754->data[83] = (Object)closure11754;
  Method *meth_meth_parser_lastLine11754 = addmethod2pos(self, "lastLine", &meth_parser_lastLine11754, 83);
  int argcv_meth_parser_lastLine11754[] = {0};
  meth_meth_parser_lastLine11754->type = alloc_MethodType(1, argcv_meth_parser_lastLine11754);
  meth_meth_parser_lastLine11754->definitionModule = modulename;
  meth_meth_parser_lastLine11754->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine:="
  block_savedest(self);
  Object closure11755 = createclosure(1, "lastLine:=");
  setclosureframe(closure11755, stackframe);
  addtoclosure(closure11755, var_lastLine);
  struct UserObject *uo11755 = (struct UserObject*)self;
  uo11755->data[84] = (Object)closure11755;
  Method *meth_meth_parser_lastLine_58__61_11755 = addmethod2pos(self, "lastLine:=", &meth_parser_lastLine_58__61_11755, 84);
  int argcv_meth_parser_lastLine_58__61_11755[] = {1};
  meth_meth_parser_lastLine_58__61_11755->type = alloc_MethodType(1, argcv_meth_parser_lastLine_58__61_11755);
  meth_meth_parser_lastLine_58__61_11755->definitionModule = modulename;
  meth_meth_parser_lastLine_58__61_11755->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11757 = alloc_Float64(0);
// compiled num node returning num11757 (depth = 2)
  *var_lastIndent = num11757;
  if (num11757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent"
  block_savedest(self);
  Object closure11758 = createclosure(1, "lastIndent");
  setclosureframe(closure11758, stackframe);
  addtoclosure(closure11758, var_lastIndent);
  struct UserObject *uo11758 = (struct UserObject*)self;
  uo11758->data[85] = (Object)closure11758;
  Method *meth_meth_parser_lastIndent11758 = addmethod2pos(self, "lastIndent", &meth_parser_lastIndent11758, 85);
  int argcv_meth_parser_lastIndent11758[] = {0};
  meth_meth_parser_lastIndent11758->type = alloc_MethodType(1, argcv_meth_parser_lastIndent11758);
  meth_meth_parser_lastIndent11758->definitionModule = modulename;
  meth_meth_parser_lastIndent11758->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent:="
  block_savedest(self);
  Object closure11759 = createclosure(1, "lastIndent:=");
  setclosureframe(closure11759, stackframe);
  addtoclosure(closure11759, var_lastIndent);
  struct UserObject *uo11759 = (struct UserObject*)self;
  uo11759->data[86] = (Object)closure11759;
  Method *meth_meth_parser_lastIndent_58__61_11759 = addmethod2pos(self, "lastIndent:=", &meth_parser_lastIndent_58__61_11759, 86);
  int argcv_meth_parser_lastIndent_58__61_11759[] = {1};
  meth_meth_parser_lastIndent_58__61_11759->type = alloc_MethodType(1, argcv_meth_parser_lastIndent_58__61_11759);
  meth_meth_parser_lastIndent_58__61_11759->definitionModule = modulename;
  meth_meth_parser_lastIndent_58__61_11759->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11761 = alloc_Boolean(0);
// compiled identifier node returning bool11761 (depth = 2)
  *var_indentFreePass = bool11761;
  if (bool11761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass"
  block_savedest(self);
  Object closure11762 = createclosure(1, "indentFreePass");
  setclosureframe(closure11762, stackframe);
  addtoclosure(closure11762, var_indentFreePass);
  struct UserObject *uo11762 = (struct UserObject*)self;
  uo11762->data[87] = (Object)closure11762;
  Method *meth_meth_parser_indentFreePass11762 = addmethod2pos(self, "indentFreePass", &meth_parser_indentFreePass11762, 87);
  int argcv_meth_parser_indentFreePass11762[] = {0};
  meth_meth_parser_indentFreePass11762->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass11762);
  meth_meth_parser_indentFreePass11762->definitionModule = modulename;
  meth_meth_parser_indentFreePass11762->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass:="
  block_savedest(self);
  Object closure11763 = createclosure(1, "indentFreePass:=");
  setclosureframe(closure11763, stackframe);
  addtoclosure(closure11763, var_indentFreePass);
  struct UserObject *uo11763 = (struct UserObject*)self;
  uo11763->data[88] = (Object)closure11763;
  Method *meth_meth_parser_indentFreePass_58__61_11763 = addmethod2pos(self, "indentFreePass:=", &meth_parser_indentFreePass_58__61_11763, 88);
  int argcv_meth_parser_indentFreePass_58__61_11763[] = {1};
  meth_meth_parser_indentFreePass_58__61_11763->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass_58__61_11763);
  meth_meth_parser_indentFreePass_58__61_11763->definitionModule = modulename;
  meth_meth_parser_indentFreePass_58__61_11763->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11765 = alloc_Float64(0);
// compiled num node returning num11765 (depth = 2)
  *var_minIndentLevel = num11765;
  if (num11765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel"
  block_savedest(self);
  Object closure11766 = createclosure(1, "minIndentLevel");
  setclosureframe(closure11766, stackframe);
  addtoclosure(closure11766, var_minIndentLevel);
  struct UserObject *uo11766 = (struct UserObject*)self;
  uo11766->data[89] = (Object)closure11766;
  Method *meth_meth_parser_minIndentLevel11766 = addmethod2pos(self, "minIndentLevel", &meth_parser_minIndentLevel11766, 89);
  int argcv_meth_parser_minIndentLevel11766[] = {0};
  meth_meth_parser_minIndentLevel11766->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel11766);
  meth_meth_parser_minIndentLevel11766->definitionModule = modulename;
  meth_meth_parser_minIndentLevel11766->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel:="
  block_savedest(self);
  Object closure11767 = createclosure(1, "minIndentLevel:=");
  setclosureframe(closure11767, stackframe);
  addtoclosure(closure11767, var_minIndentLevel);
  struct UserObject *uo11767 = (struct UserObject*)self;
  uo11767->data[90] = (Object)closure11767;
  Method *meth_meth_parser_minIndentLevel_58__61_11767 = addmethod2pos(self, "minIndentLevel:=", &meth_parser_minIndentLevel_58__61_11767, 90);
  int argcv_meth_parser_minIndentLevel_58__61_11767[] = {1};
  meth_meth_parser_minIndentLevel_58__61_11767->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel_58__61_11767);
  meth_meth_parser_minIndentLevel_58__61_11767->definitionModule = modulename;
  meth_meth_parser_minIndentLevel_58__61_11767->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11769 = alloc_Float64(0);
// compiled num node returning num11769 (depth = 2)
  *var_statementIndent = num11769;
  if (num11769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent"
  block_savedest(self);
  Object closure11770 = createclosure(1, "statementIndent");
  setclosureframe(closure11770, stackframe);
  addtoclosure(closure11770, var_statementIndent);
  struct UserObject *uo11770 = (struct UserObject*)self;
  uo11770->data[91] = (Object)closure11770;
  Method *meth_meth_parser_statementIndent11770 = addmethod2pos(self, "statementIndent", &meth_parser_statementIndent11770, 91);
  int argcv_meth_parser_statementIndent11770[] = {0};
  meth_meth_parser_statementIndent11770->type = alloc_MethodType(1, argcv_meth_parser_statementIndent11770);
  meth_meth_parser_statementIndent11770->definitionModule = modulename;
  meth_meth_parser_statementIndent11770->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent:="
  block_savedest(self);
  Object closure11771 = createclosure(1, "statementIndent:=");
  setclosureframe(closure11771, stackframe);
  addtoclosure(closure11771, var_statementIndent);
  struct UserObject *uo11771 = (struct UserObject*)self;
  uo11771->data[92] = (Object)closure11771;
  Method *meth_meth_parser_statementIndent_58__61_11771 = addmethod2pos(self, "statementIndent:=", &meth_parser_statementIndent_58__61_11771, 92);
  int argcv_meth_parser_statementIndent_58__61_11771[] = {1};
  meth_meth_parser_statementIndent_58__61_11771->type = alloc_MethodType(1, argcv_meth_parser_statementIndent_58__61_11771);
  meth_meth_parser_statementIndent_58__61_11771->definitionModule = modulename;
  meth_meth_parser_statementIndent_58__61_11771->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11773 = alloc_Boolean(0);
// compiled identifier node returning bool11773 (depth = 2)
  *var_tokens = bool11773;
  if (bool11773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens"
  block_savedest(self);
  Object closure11774 = createclosure(1, "tokens");
  setclosureframe(closure11774, stackframe);
  addtoclosure(closure11774, var_tokens);
  struct UserObject *uo11774 = (struct UserObject*)self;
  uo11774->data[93] = (Object)closure11774;
  Method *meth_meth_parser_tokens11774 = addmethod2pos(self, "tokens", &meth_parser_tokens11774, 93);
  int argcv_meth_parser_tokens11774[] = {0};
  meth_meth_parser_tokens11774->type = alloc_MethodType(1, argcv_meth_parser_tokens11774);
  meth_meth_parser_tokens11774->definitionModule = modulename;
  meth_meth_parser_tokens11774->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens:="
  block_savedest(self);
  Object closure11775 = createclosure(1, "tokens:=");
  setclosureframe(closure11775, stackframe);
  addtoclosure(closure11775, var_tokens);
  struct UserObject *uo11775 = (struct UserObject*)self;
  uo11775->data[94] = (Object)closure11775;
  Method *meth_meth_parser_tokens_58__61_11775 = addmethod2pos(self, "tokens:=", &meth_parser_tokens_58__61_11775, 94);
  int argcv_meth_parser_tokens_58__61_11775[] = {1};
  meth_meth_parser_tokens_58__61_11775->type = alloc_MethodType(1, argcv_meth_parser_tokens_58__61_11775);
  meth_meth_parser_tokens_58__61_11775->definitionModule = modulename;
  meth_meth_parser_tokens_58__61_11775->definitionLine = 3576;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11777 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11778 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11779 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11778);
// compiled call node returning call11779 (depth = 5)
// compiled member node returning call11779 (depth = 4)
  partcv[0] = 0;
  Object call11780 = callmethod(call11779, "empty",
    1, partcv, params);
  gc_frame_end(callframe11777);
// compiled call node returning call11780 (depth = 3)
// compiled member node returning call11780 (depth = 2)
  *var_values = call11780;
  if (call11780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "values"
  block_savedest(self);
  Object closure11781 = createclosure(1, "values");
  setclosureframe(closure11781, stackframe);
  addtoclosure(closure11781, var_values);
  struct UserObject *uo11781 = (struct UserObject*)self;
  uo11781->data[95] = (Object)closure11781;
  Method *meth_meth_parser_values11781 = addmethod2pos(self, "values", &meth_parser_values11781, 95);
  int argcv_meth_parser_values11781[] = {0};
  meth_meth_parser_values11781->type = alloc_MethodType(1, argcv_meth_parser_values11781);
  meth_meth_parser_values11781->definitionModule = modulename;
  meth_meth_parser_values11781->definitionLine = 13;
// compiled method node returning  (depth = 2)
// starting to compile method node (depth = 2)
// method "values:="
  block_savedest(self);
  Object closure11782 = createclosure(1, "values:=");
  setclosureframe(closure11782, stackframe);
  addtoclosure(closure11782, var_values);
  struct UserObject *uo11782 = (struct UserObject*)self;
  uo11782->data[96] = (Object)closure11782;
  Method *meth_meth_parser_values_58__61_11782 = addmethod2pos(self, "values:=", &meth_parser_values_58__61_11782, 96);
  int argcv_meth_parser_values_58__61_11782[] = {1};
  meth_meth_parser_values_58__61_11782->type = alloc_MethodType(1, argcv_meth_parser_values_58__61_11782);
  meth_meth_parser_values_58__61_11782->definitionModule = modulename;
  meth_meth_parser_values_58__61_11782->definitionLine = 13;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
  *var_moduleObject = undefined;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject"
  block_savedest(self);
  Object closure11784 = createclosure(1, "moduleObject");
  setclosureframe(closure11784, stackframe);
  addtoclosure(closure11784, var_moduleObject);
  struct UserObject *uo11784 = (struct UserObject*)self;
  uo11784->data[97] = (Object)closure11784;
  Method *meth_meth_parser_moduleObject11784 = addmethod2pos(self, "moduleObject", &meth_parser_moduleObject11784, 97);
  int argcv_meth_parser_moduleObject11784[] = {0};
  meth_meth_parser_moduleObject11784->type = alloc_MethodType(1, argcv_meth_parser_moduleObject11784);
  meth_meth_parser_moduleObject11784->definitionModule = modulename;
  meth_meth_parser_moduleObject11784->definitionLine = 13;
// compiled method node returning  (depth = 2)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject:="
  block_savedest(self);
  Object closure11785 = createclosure(1, "moduleObject:=");
  setclosureframe(closure11785, stackframe);
  addtoclosure(closure11785, var_moduleObject);
  struct UserObject *uo11785 = (struct UserObject*)self;
  uo11785->data[98] = (Object)closure11785;
  Method *meth_meth_parser_moduleObject_58__61_11785 = addmethod2pos(self, "moduleObject:=", &meth_parser_moduleObject_58__61_11785, 98);
  int argcv_meth_parser_moduleObject_58__61_11785[] = {1};
  meth_meth_parser_moduleObject_58__61_11785->type = alloc_MethodType(1, argcv_meth_parser_moduleObject_58__61_11785);
  meth_meth_parser_moduleObject_58__61_11785->definitionModule = modulename;
  meth_meth_parser_moduleObject_58__61_11785->definitionLine = 13;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11787 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11788 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11789 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11788);
// compiled call node returning call11789 (depth = 5)
// compiled member node returning call11789 (depth = 4)
  partcv[0] = 0;
  Object call11790 = callmethod(call11789, "empty",
    1, partcv, params);
  gc_frame_end(callframe11787);
// compiled call node returning call11790 (depth = 3)
// compiled member node returning call11790 (depth = 2)
  *var_comments = call11790;
  if (call11790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "comments"
  block_savedest(self);
  Object closure11791 = createclosure(1, "comments");
  setclosureframe(closure11791, stackframe);
  addtoclosure(closure11791, var_comments);
  struct UserObject *uo11791 = (struct UserObject*)self;
  uo11791->data[99] = (Object)closure11791;
  Method *meth_meth_parser_comments11791 = addmethod2pos(self, "comments", &meth_parser_comments11791, 99);
  int argcv_meth_parser_comments11791[] = {0};
  meth_meth_parser_comments11791->type = alloc_MethodType(1, argcv_meth_parser_comments11791);
  meth_meth_parser_comments11791->definitionModule = modulename;
  meth_meth_parser_comments11791->definitionLine = 15;
// compiled method node returning  (depth = 2)
// starting to compile method node (depth = 2)
// method "comments:="
  block_savedest(self);
  Object closure11792 = createclosure(1, "comments:=");
  setclosureframe(closure11792, stackframe);
  addtoclosure(closure11792, var_comments);
  struct UserObject *uo11792 = (struct UserObject*)self;
  uo11792->data[100] = (Object)closure11792;
  Method *meth_meth_parser_comments_58__61_11792 = addmethod2pos(self, "comments:=", &meth_parser_comments_58__61_11792, 100);
  int argcv_meth_parser_comments_58__61_11792[] = {1};
  meth_meth_parser_comments_58__61_11792->type = alloc_MethodType(1, argcv_meth_parser_comments_58__61_11792);
  meth_meth_parser_comments_58__61_11792->definitionModule = modulename;
  meth_meth_parser_comments_58__61_11792->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11794 = alloc_Float64(0);
// compiled num node returning num11794 (depth = 2)
  *var_auto_count = num11794;
  if (num11794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count"
  block_savedest(self);
  Object closure11795 = createclosure(1, "auto_count");
  setclosureframe(closure11795, stackframe);
  addtoclosure(closure11795, var_auto_count);
  struct UserObject *uo11795 = (struct UserObject*)self;
  uo11795->data[101] = (Object)closure11795;
  Method *meth_meth_parser_auto_count11795 = addmethod2pos(self, "auto_count", &meth_parser_auto_count11795, 101);
  int argcv_meth_parser_auto_count11795[] = {0};
  meth_meth_parser_auto_count11795->type = alloc_MethodType(1, argcv_meth_parser_auto_count11795);
  meth_meth_parser_auto_count11795->definitionModule = modulename;
  meth_meth_parser_auto_count11795->definitionLine = 15;
// compiled method node returning  (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count:="
  block_savedest(self);
  Object closure11796 = createclosure(1, "auto_count:=");
  setclosureframe(closure11796, stackframe);
  addtoclosure(closure11796, var_auto_count);
  struct UserObject *uo11796 = (struct UserObject*)self;
  uo11796->data[102] = (Object)closure11796;
  Method *meth_meth_parser_auto_count_58__61_11796 = addmethod2pos(self, "auto_count:=", &meth_parser_auto_count_58__61_11796, 102);
  int argcv_meth_parser_auto_count_58__61_11796[] = {1};
  meth_meth_parser_auto_count_58__61_11796->type = alloc_MethodType(1, argcv_meth_parser_auto_count_58__61_11796);
  meth_meth_parser_auto_count_58__61_11796->definitionModule = modulename;
  meth_meth_parser_auto_count_58__61_11796->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11798 = alloc_Boolean(0);
// compiled identifier node returning bool11798 (depth = 2)
  *var_noBlocks = bool11798;
  if (bool11798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "noBlocks"
  block_savedest(self);
  Object closure11799 = createclosure(1, "noBlocks");
  setclosureframe(closure11799, stackframe);
  addtoclosure(closure11799, var_noBlocks);
  struct UserObject *uo11799 = (struct UserObject*)self;
  uo11799->data[103] = (Object)closure11799;
  Method *meth_meth_parser_noBlocks11799 = addmethod2pos(self, "noBlocks", &meth_parser_noBlocks11799, 103);
  int argcv_meth_parser_noBlocks11799[] = {0};
  meth_meth_parser_noBlocks11799->type = alloc_MethodType(1, argcv_meth_parser_noBlocks11799);
  meth_meth_parser_noBlocks11799->definitionModule = modulename;
  meth_meth_parser_noBlocks11799->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11800 = alloc_Boolean(1);
// compiled identifier node returning bool11800 (depth = 2)
  *var_blocksOK = bool11800;
  if (bool11800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blocksOK"
  block_savedest(self);
  Object closure11801 = createclosure(1, "blocksOK");
  setclosureframe(closure11801, stackframe);
  addtoclosure(closure11801, var_blocksOK);
  struct UserObject *uo11801 = (struct UserObject*)self;
  uo11801->data[104] = (Object)closure11801;
  Method *meth_meth_parser_blocksOK11801 = addmethod2pos(self, "blocksOK", &meth_parser_blocksOK11801, 104);
  int argcv_meth_parser_blocksOK11801[] = {0};
  meth_meth_parser_blocksOK11801->type = alloc_MethodType(1, argcv_meth_parser_blocksOK11801);
  meth_meth_parser_blocksOK11801->definitionModule = modulename;
  meth_meth_parser_blocksOK11801->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11802 = alloc_Boolean(0);
// compiled identifier node returning bool11802 (depth = 2)
  *var_braceIsType = bool11802;
  if (bool11802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "braceIsType"
  block_savedest(self);
  Object closure11803 = createclosure(1, "braceIsType");
  setclosureframe(closure11803, stackframe);
  addtoclosure(closure11803, var_braceIsType);
  struct UserObject *uo11803 = (struct UserObject*)self;
  uo11803->data[105] = (Object)closure11803;
  Method *meth_meth_parser_braceIsType11803 = addmethod2pos(self, "braceIsType", &meth_parser_braceIsType11803, 105);
  int argcv_meth_parser_braceIsType11803[] = {0};
  meth_meth_parser_braceIsType11803->type = alloc_MethodType(1, argcv_meth_parser_braceIsType11803);
  meth_meth_parser_braceIsType11803->definitionModule = modulename;
  meth_meth_parser_braceIsType11803->definitionLine = 15;
// compiled method node returning  (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "braceIsType:="
  block_savedest(self);
  Object closure11804 = createclosure(1, "braceIsType:=");
  setclosureframe(closure11804, stackframe);
  addtoclosure(closure11804, var_braceIsType);
  struct UserObject *uo11804 = (struct UserObject*)self;
  uo11804->data[106] = (Object)closure11804;
  Method *meth_meth_parser_braceIsType_58__61_11804 = addmethod2pos(self, "braceIsType:=", &meth_parser_braceIsType_58__61_11804, 106);
  int argcv_meth_parser_braceIsType_58__61_11804[] = {1};
  meth_meth_parser_braceIsType_58__61_11804->type = alloc_MethodType(1, argcv_meth_parser_braceIsType_58__61_11804);
  meth_meth_parser_braceIsType_58__61_11804->definitionModule = modulename;
  meth_meth_parser_braceIsType_58__61_11804->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit11806 == NULL) {
    strlit11806 = alloc_String("confidential");
    gc_root(strlit11806);
  }
// compiled string node returning strlit11806 (depth = 2)
  *var_defaultDefVisibility = strlit11806;
  if (strlit11806 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defaultDefVisibility"
  block_savedest(self);
  Object closure11807 = createclosure(1, "defaultDefVisibility");
  setclosureframe(closure11807, stackframe);
  addtoclosure(closure11807, var_defaultDefVisibility);
  struct UserObject *uo11807 = (struct UserObject*)self;
  uo11807->data[107] = (Object)closure11807;
  Method *meth_meth_parser_defaultDefVisibility11807 = addmethod2pos(self, "defaultDefVisibility", &meth_parser_defaultDefVisibility11807, 107);
  int argcv_meth_parser_defaultDefVisibility11807[] = {0};
  meth_meth_parser_defaultDefVisibility11807->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility11807);
  meth_meth_parser_defaultDefVisibility11807->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility11807->definitionLine = 15;
// compiled method node returning  (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defaultDefVisibility:="
  block_savedest(self);
  Object closure11808 = createclosure(1, "defaultDefVisibility:=");
  setclosureframe(closure11808, stackframe);
  addtoclosure(closure11808, var_defaultDefVisibility);
  struct UserObject *uo11808 = (struct UserObject*)self;
  uo11808->data[108] = (Object)closure11808;
  Method *meth_meth_parser_defaultDefVisibility_58__61_11808 = addmethod2pos(self, "defaultDefVisibility:=", &meth_parser_defaultDefVisibility_58__61_11808, 108);
  int argcv_meth_parser_defaultDefVisibility_58__61_11808[] = {1};
  meth_meth_parser_defaultDefVisibility_58__61_11808->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility_58__61_11808);
  meth_meth_parser_defaultDefVisibility_58__61_11808->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility_58__61_11808->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit11810 == NULL) {
    strlit11810 = alloc_String("confidential");
    gc_root(strlit11810);
  }
// compiled string node returning strlit11810 (depth = 2)
  *var_defaultVarVisibility = strlit11810;
  if (strlit11810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defaultVarVisibility"
  block_savedest(self);
  Object closure11811 = createclosure(1, "defaultVarVisibility");
  setclosureframe(closure11811, stackframe);
  addtoclosure(closure11811, var_defaultVarVisibility);
  struct UserObject *uo11811 = (struct UserObject*)self;
  uo11811->data[109] = (Object)closure11811;
  Method *meth_meth_parser_defaultVarVisibility11811 = addmethod2pos(self, "defaultVarVisibility", &meth_parser_defaultVarVisibility11811, 109);
  int argcv_meth_parser_defaultVarVisibility11811[] = {0};
  meth_meth_parser_defaultVarVisibility11811->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility11811);
  meth_meth_parser_defaultVarVisibility11811->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility11811->definitionLine = 15;
// compiled method node returning  (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defaultVarVisibility:="
  block_savedest(self);
  Object closure11812 = createclosure(1, "defaultVarVisibility:=");
  setclosureframe(closure11812, stackframe);
  addtoclosure(closure11812, var_defaultVarVisibility);
  struct UserObject *uo11812 = (struct UserObject*)self;
  uo11812->data[110] = (Object)closure11812;
  Method *meth_meth_parser_defaultVarVisibility_58__61_11812 = addmethod2pos(self, "defaultVarVisibility:=", &meth_parser_defaultVarVisibility_58__61_11812, 110);
  int argcv_meth_parser_defaultVarVisibility_58__61_11812[] = {1};
  meth_meth_parser_defaultVarVisibility_58__61_11812->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility_58__61_11812);
  meth_meth_parser_defaultVarVisibility_58__61_11812->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility_58__61_11812->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit11814 == NULL) {
    strlit11814 = alloc_String("public");
    gc_root(strlit11814);
  }
// compiled string node returning strlit11814 (depth = 2)
  *var_defaultMethodVisibility = strlit11814;
  if (strlit11814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defaultMethodVisibility"
  block_savedest(self);
  Object closure11815 = createclosure(1, "defaultMethodVisibility");
  setclosureframe(closure11815, stackframe);
  addtoclosure(closure11815, var_defaultMethodVisibility);
  struct UserObject *uo11815 = (struct UserObject*)self;
  uo11815->data[111] = (Object)closure11815;
  Method *meth_meth_parser_defaultMethodVisibility11815 = addmethod2pos(self, "defaultMethodVisibility", &meth_parser_defaultMethodVisibility11815, 111);
  int argcv_meth_parser_defaultMethodVisibility11815[] = {0};
  meth_meth_parser_defaultMethodVisibility11815->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility11815);
  meth_meth_parser_defaultMethodVisibility11815->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility11815->definitionLine = 15;
// compiled method node returning  (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defaultMethodVisibility:="
  block_savedest(self);
  Object closure11816 = createclosure(1, "defaultMethodVisibility:=");
  setclosureframe(closure11816, stackframe);
  addtoclosure(closure11816, var_defaultMethodVisibility);
  struct UserObject *uo11816 = (struct UserObject*)self;
  uo11816->data[112] = (Object)closure11816;
  Method *meth_meth_parser_defaultMethodVisibility_58__61_11816 = addmethod2pos(self, "defaultMethodVisibility:=", &meth_parser_defaultMethodVisibility_58__61_11816, 112);
  int argcv_meth_parser_defaultMethodVisibility_58__61_11816[] = {1};
  meth_meth_parser_defaultMethodVisibility_58__61_11816->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility_58__61_11816);
  meth_meth_parser_defaultMethodVisibility_58__61_11816->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility_58__61_11816->definitionLine = 15;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11818 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11819 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11820 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11819);
// compiled call node returning call11820 (depth = 5)
// compiled member node returning call11820 (depth = 4)
  partcv[0] = 0;
  Object call11821 = callmethod(call11820, "empty",
    1, partcv, params);
  gc_frame_end(callframe11818);
// compiled call node returning call11821 (depth = 3)
// compiled member node returning call11821 (depth = 2)
  *var_emptySequence = call11821;
  if (call11821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "emptySequence"
  block_savedest(self);
  Object closure11822 = createclosure(1, "emptySequence");
  setclosureframe(closure11822, stackframe);
  addtoclosure(closure11822, var_emptySequence);
  struct UserObject *uo11822 = (struct UserObject*)self;
  uo11822->data[113] = (Object)closure11822;
  Method *meth_meth_parser_emptySequence11822 = addmethod2pos(self, "emptySequence", &meth_parser_emptySequence11822, 113);
  int argcv_meth_parser_emptySequence11822[] = {0};
  meth_meth_parser_emptySequence11822->type = alloc_MethodType(1, argcv_meth_parser_emptySequence11822);
  meth_meth_parser_emptySequence11822->definitionModule = modulename;
  meth_meth_parser_emptySequence11822->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject11823 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11823 = alloc_userobj2(6,7, objclass11823);
  gc_frame_newslot(obj11823);
// OBJECT OUTER DEC outer
  adddatum2(obj11823, self, 0);
  addmethodreal(obj11823,"outer", &reader_parser_outer_11824);
  Object oldself11823 = self;
  struct StackFrameObject *oldstackframe11823 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11823);
  gc_frame_newslot((Object)stackframe);
  self = obj11823;
  Object *oldselfslot11823 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11823 = (*(struct UserObject *)self).data[0], lowerouter11823 = thisouter11823;
  if (inheritingObject11823) {
    struct UserObject *inho11823 = (struct UserObject *)inheritingObject11823;
    while (inho11823->super != GraceDefaultObject) inho11823 = (struct UserObject *)inho11823->super;
    inho11823->super = obj11823;
    self = inheritingObject11823;
    *selfslot = self;
    lowerouter11823 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11823;
  }
if (objclass11823 == NULL) {
  Method *reader11825 = addmethodrealflags(obj11823, "kind",&reader_parser_kind_11825, MFLAG_DEF);
  reader11825->definitionModule = modulename;
  reader11825->definitionLine = 27;
}
adddatum2(obj11823, alloc_Undefined(), 1);
if (objclass11823 == NULL) {
  Method *reader11826 = addmethodrealflags(obj11823, "line",&reader_parser_line_11826, MFLAG_DEF);
  reader11826->definitionModule = modulename;
  reader11826->definitionLine = 28;
}
adddatum2(obj11823, alloc_Undefined(), 2);
if (objclass11823 == NULL) {
  Method *reader11827 = addmethodrealflags(obj11823, "linePos",&reader_parser_linePos_11827, MFLAG_DEF);
  reader11827->definitionModule = modulename;
  reader11827->definitionLine = 29;
}
adddatum2(obj11823, alloc_Undefined(), 3);
if (objclass11823 == NULL) {
  Method *reader11828 = addmethodrealflags(obj11823, "indent",&reader_parser_indent_11828, MFLAG_DEF);
  reader11828->definitionModule = modulename;
  reader11828->definitionLine = 30;
}
adddatum2(obj11823, alloc_Undefined(), 4);
if (objclass11823 == NULL) {
  Method *reader11829 = addmethodrealflags(obj11823, "value",&reader_parser_value_11829, MFLAG_DEF);
  reader11829->definitionModule = modulename;
  reader11829->definitionLine = 31;
}
adddatum2(obj11823, alloc_Undefined(), 5);
if (objclass11823 == NULL) {
  Method *reader11830 = addmethodrealflags(obj11823, "size",&reader_parser_size_11830, MFLAG_DEF);
  reader11830->definitionModule = modulename;
  reader11830->definitionLine = 32;
}
adddatum2(obj11823, alloc_Undefined(), 6);
  sourceObject = obj11823;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11831 == NULL) {
    strlit11831 = alloc_String("start");
    gc_root(strlit11831);
  }
// compiled string node returning strlit11831 (depth = 3)
  adddatum2(obj11823, strlit11831, 1);
  sourceObject = obj11823;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11832 = alloc_Float64(0);
// compiled num node returning num11832 (depth = 3)
  adddatum2(obj11823, num11832, 2);
  sourceObject = obj11823;
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11833 = alloc_Float64(0);
// compiled num node returning num11833 (depth = 3)
  adddatum2(obj11823, num11833, 3);
  sourceObject = obj11823;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11834 = alloc_Float64(0);
// compiled num node returning num11834 (depth = 3)
  adddatum2(obj11823, num11834, 4);
  sourceObject = obj11823;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11835 == NULL) {
    strlit11835 = alloc_String("");
    gc_root(strlit11835);
  }
// compiled string node returning strlit11835 (depth = 3)
  adddatum2(obj11823, strlit11835, 5);
  sourceObject = obj11823;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11836 = alloc_Float64(0);
// compiled num node returning num11836 (depth = 3)
  adddatum2(obj11823, num11836, 6);
  objclass11823 = obj11823->class;
  objclass11823->definitionModule = modulename;
  objclass11823->definitionLine = 26;
  (*(struct UserObject *)self).data[0] = lowerouter11823;
  self = oldself11823;
  selfslot = oldselfslot11823;
  stackframe = oldstackframe11823;
// compiled object node returning obj11823 (depth = 2)
  *var_sym = obj11823;
  if (obj11823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym"
  block_savedest(self);
  Object closure11837 = createclosure(1, "sym");
  setclosureframe(closure11837, stackframe);
  addtoclosure(closure11837, var_sym);
  struct UserObject *uo11837 = (struct UserObject*)self;
  uo11837->data[114] = (Object)closure11837;
  Method *meth_meth_parser_sym11837 = addmethod2pos(self, "sym", &meth_parser_sym11837, 114);
  int argcv_meth_parser_sym11837[] = {0};
  meth_meth_parser_sym11837->type = alloc_MethodType(1, argcv_meth_parser_sym11837);
  meth_meth_parser_sym11837->definitionModule = modulename;
  meth_meth_parser_sym11837->definitionLine = 23;
// compiled method node returning  (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym:="
  block_savedest(self);
  Object closure11838 = createclosure(1, "sym:=");
  setclosureframe(closure11838, stackframe);
  addtoclosure(closure11838, var_sym);
  struct UserObject *uo11838 = (struct UserObject*)self;
  uo11838->data[115] = (Object)closure11838;
  Method *meth_meth_parser_sym_58__61_11838 = addmethod2pos(self, "sym:=", &meth_parser_sym_58__61_11838, 115);
  int argcv_meth_parser_sym_58__61_11838[] = {1};
  meth_meth_parser_sym_58__61_11838->type = alloc_MethodType(1, argcv_meth_parser_sym_58__61_11838);
  meth_meth_parser_sym_58__61_11838->definitionModule = modulename;
  meth_meth_parser_sym_58__61_11838->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sym (depth = 2)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken"
  block_savedest(self);
  Object closure11840 = createclosure(1, "lastToken");
  setclosureframe(closure11840, stackframe);
  addtoclosure(closure11840, var_lastToken);
  struct UserObject *uo11840 = (struct UserObject*)self;
  uo11840->data[116] = (Object)closure11840;
  Method *meth_meth_parser_lastToken11840 = addmethod2pos(self, "lastToken", &meth_parser_lastToken11840, 116);
  int argcv_meth_parser_lastToken11840[] = {0};
  meth_meth_parser_lastToken11840->type = alloc_MethodType(1, argcv_meth_parser_lastToken11840);
  meth_meth_parser_lastToken11840->definitionModule = modulename;
  meth_meth_parser_lastToken11840->definitionLine = 23;
// compiled method node returning  (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken:="
  block_savedest(self);
  Object closure11841 = createclosure(1, "lastToken:=");
  setclosureframe(closure11841, stackframe);
  addtoclosure(closure11841, var_lastToken);
  struct UserObject *uo11841 = (struct UserObject*)self;
  uo11841->data[117] = (Object)closure11841;
  Method *meth_meth_parser_lastToken_58__61_11841 = addmethod2pos(self, "lastToken:=", &meth_parser_lastToken_58__61_11841, 117);
  int argcv_meth_parser_lastToken_58__61_11841[] = {1};
  meth_meth_parser_lastToken_58__61_11841->type = alloc_MethodType(1, argcv_meth_parser_lastToken_58__61_11841);
  meth_meth_parser_lastToken_58__61_11841->definitionModule = modulename;
  meth_meth_parser_lastToken_58__61_11841->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_previousCommentToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken"
  block_savedest(self);
  Object closure11843 = createclosure(1, "previousCommentToken");
  setclosureframe(closure11843, stackframe);
  addtoclosure(closure11843, var_previousCommentToken);
  struct UserObject *uo11843 = (struct UserObject*)self;
  uo11843->data[118] = (Object)closure11843;
  Method *meth_meth_parser_previousCommentToken11843 = addmethod2pos(self, "previousCommentToken", &meth_parser_previousCommentToken11843, 118);
  int argcv_meth_parser_previousCommentToken11843[] = {0};
  meth_meth_parser_previousCommentToken11843->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken11843);
  meth_meth_parser_previousCommentToken11843->definitionModule = modulename;
  meth_meth_parser_previousCommentToken11843->definitionLine = 23;
// compiled method node returning  (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken:="
  block_savedest(self);
  Object closure11844 = createclosure(1, "previousCommentToken:=");
  setclosureframe(closure11844, stackframe);
  addtoclosure(closure11844, var_previousCommentToken);
  struct UserObject *uo11844 = (struct UserObject*)self;
  uo11844->data[119] = (Object)closure11844;
  Method *meth_meth_parser_previousCommentToken_58__61_11844 = addmethod2pos(self, "previousCommentToken:=", &meth_parser_previousCommentToken_58__61_11844, 119);
  int argcv_meth_parser_previousCommentToken_58__61_11844[] = {1};
  meth_meth_parser_previousCommentToken_58__61_11844->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken_58__61_11844);
  meth_meth_parser_previousCommentToken_58__61_11844->definitionModule = modulename;
  meth_meth_parser_previousCommentToken_58__61_11844->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken"
  block_savedest(self);
  Object closure11846 = createclosure(1, "statementToken");
  setclosureframe(closure11846, stackframe);
  addtoclosure(closure11846, var_statementToken);
  struct UserObject *uo11846 = (struct UserObject*)self;
  uo11846->data[120] = (Object)closure11846;
  Method *meth_meth_parser_statementToken11846 = addmethod2pos(self, "statementToken", &meth_parser_statementToken11846, 120);
  int argcv_meth_parser_statementToken11846[] = {0};
  meth_meth_parser_statementToken11846->type = alloc_MethodType(1, argcv_meth_parser_statementToken11846);
  meth_meth_parser_statementToken11846->definitionModule = modulename;
  meth_meth_parser_statementToken11846->definitionLine = 23;
// compiled method node returning  (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken:="
  block_savedest(self);
  Object closure11847 = createclosure(1, "statementToken:=");
  setclosureframe(closure11847, stackframe);
  addtoclosure(closure11847, var_statementToken);
  struct UserObject *uo11847 = (struct UserObject*)self;
  uo11847->data[121] = (Object)closure11847;
  Method *meth_meth_parser_statementToken_58__61_11847 = addmethod2pos(self, "statementToken:=", &meth_parser_statementToken_58__61_11847, 121);
  int argcv_meth_parser_statementToken_58__61_11847[] = {1};
  meth_meth_parser_statementToken_58__61_11847->type = alloc_MethodType(1, argcv_meth_parser_statementToken_58__61_11847);
  meth_meth_parser_statementToken_58__61_11847->definitionModule = modulename;
  meth_meth_parser_statementToken_58__61_11847->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11849 = alloc_Boolean(0);
// compiled identifier node returning bool11849 (depth = 2)
  *var_comment = bool11849;
  if (bool11849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment"
  block_savedest(self);
  Object closure11850 = createclosure(1, "comment");
  setclosureframe(closure11850, stackframe);
  addtoclosure(closure11850, var_comment);
  struct UserObject *uo11850 = (struct UserObject*)self;
  uo11850->data[122] = (Object)closure11850;
  Method *meth_meth_parser_comment11850 = addmethod2pos(self, "comment", &meth_parser_comment11850, 122);
  int argcv_meth_parser_comment11850[] = {0};
  meth_meth_parser_comment11850->type = alloc_MethodType(1, argcv_meth_parser_comment11850);
  meth_meth_parser_comment11850->definitionModule = modulename;
  meth_meth_parser_comment11850->definitionLine = 23;
// compiled method node returning  (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment:="
  block_savedest(self);
  Object closure11851 = createclosure(1, "comment:=");
  setclosureframe(closure11851, stackframe);
  addtoclosure(closure11851, var_comment);
  struct UserObject *uo11851 = (struct UserObject*)self;
  uo11851->data[123] = (Object)closure11851;
  Method *meth_meth_parser_comment_58__61_11851 = addmethod2pos(self, "comment:=", &meth_parser_comment_58__61_11851, 123);
  int argcv_meth_parser_comment_58__61_11851[] = {1};
  meth_meth_parser_comment_58__61_11851->type = alloc_MethodType(1, argcv_meth_parser_comment_58__61_11851);
  meth_meth_parser_comment_58__61_11851->definitionModule = modulename;
  meth_meth_parser_comment_58__61_11851->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11853 = alloc_Boolean(1);
// compiled identifier node returning bool11853 (depth = 2)
  *var_firstCallOfNext = bool11853;
  if (bool11853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "firstCallOfNext"
  block_savedest(self);
  Object closure11854 = createclosure(1, "firstCallOfNext");
  setclosureframe(closure11854, stackframe);
  addtoclosure(closure11854, var_firstCallOfNext);
  struct UserObject *uo11854 = (struct UserObject*)self;
  uo11854->data[124] = (Object)closure11854;
  Method *meth_meth_parser_firstCallOfNext11854 = addmethod2pos(self, "firstCallOfNext", &meth_parser_firstCallOfNext11854, 124);
  int argcv_meth_parser_firstCallOfNext11854[] = {0};
  meth_meth_parser_firstCallOfNext11854->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext11854);
  meth_meth_parser_firstCallOfNext11854->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext11854->definitionLine = 23;
// compiled method node returning  (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "firstCallOfNext:="
  block_savedest(self);
  Object closure11855 = createclosure(1, "firstCallOfNext:=");
  setclosureframe(closure11855, stackframe);
  addtoclosure(closure11855, var_firstCallOfNext);
  struct UserObject *uo11855 = (struct UserObject*)self;
  uo11855->data[125] = (Object)closure11855;
  Method *meth_meth_parser_firstCallOfNext_58__61_11855 = addmethod2pos(self, "firstCallOfNext:=", &meth_parser_firstCallOfNext_58__61_11855, 125);
  int argcv_meth_parser_firstCallOfNext_58__61_11855[] = {1};
  meth_meth_parser_firstCallOfNext_58__61_11855->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext_58__61_11855);
  meth_meth_parser_firstCallOfNext_58__61_11855->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext_58__61_11855->definitionLine = 23;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3125
  setline(3125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3253
  setline(3253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3433
  setline(3433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3443
  setline(3443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3513
  setline(3513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3520
  setline(3520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
